diff -pruN 2:15.0.1-1/api-ref/source/v2/parameters.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v2/parameters.yaml
--- 2:15.0.1-1/api-ref/source/v2/parameters.yaml	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v2/parameters.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -665,7 +665,7 @@ has_dependent_backups:
 host:
   description: |
     The OpenStack Block Storage host where the
-    existing volume resides. Host format is ``host@backend``.
+    existing volume resides.
   in: body
   required: true
   type: string
@@ -677,7 +677,8 @@ host_name:
   type: string
 host_name_1:
   description: |
-    The name of the host that hosts the storage backend.
+    The name of the host that hosts the storage backend,
+    may take the format of ``host@backend``.
   in: body
   required: true
   type: string
diff -pruN 2:15.0.1-1/api-ref/source/v3/ext-backups.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/ext-backups.inc
--- 2:15.0.1-1/api-ref/source/v3/ext-backups.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/ext-backups.inc	2020-03-24 18:46:31.000000000 +0000
@@ -313,6 +313,7 @@ Response Parameters
    - id: id_backup
    - links: links_backup
    - name: name_backup
+   - metadata: metadata_backup
 
 Response Example
 ----------------
diff -pruN 2:15.0.1-1/api-ref/source/v3/limits.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/limits.inc
--- 2:15.0.1-1/api-ref/source/v3/limits.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/limits.inc	2020-03-24 18:46:31.000000000 +0000
@@ -59,5 +59,5 @@ Response Parameters
 Response Example
 ----------------
 
-.. literalinclude:: ./samples/limits-show-response.json
+.. literalinclude:: ./samples/limits/limits-show-response.json
    :language: javascript
diff -pruN 2:15.0.1-1/api-ref/source/v3/parameters.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/parameters.yaml
--- 2:15.0.1-1/api-ref/source/v3/parameters.yaml	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/parameters.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -25,12 +25,6 @@ backup_id_required:
   in: path
   required: true
   type: string
-cascade:
-  description: |
-    Remove any snapshots along with the volume. Default=False.
-  in: path
-  required: false
-  type: boolean
 cgsnapshot_id_path:
   description: |
     The ID of the consistency group snapshot.
@@ -49,14 +43,6 @@ encryption_id:
   in: path
   required: true
   type: string
-force_vol_del:
-  description: |
-    Indicates whether to force delete a volume even if
-    the volume is in deleting or error_deleting. Default is ``false``.
-  in: path
-  required: false
-  type: boolean
-  min_version: 3.23
 group_id_path:
   description: |
     The ID of the group.
@@ -208,6 +194,12 @@ bootable_query:
   in: query
   required: false
   type: boolean
+cascade:
+  description: |
+    Remove any snapshots along with the volume. Default=False.
+  in: query
+  required: false
+  type: boolean
 detail:
   description: |
     Indicates whether to show pool details or only
@@ -216,6 +208,26 @@ detail:
   in: query
   required: false
   type: boolean
+filter_created_at:
+  description: |
+    Filters reuslts by a time that resources are created at with time
+    comparison operators: gt/gte/eq/neq/lt/lte.
+    The date and time stamp format is ISO 8601: CCYY-MM-DDThh:mm:ss±hh:mm.
+    The ±hh:mm value, if included, returns the time zone as an offset from UTC.
+  in: query
+  required: false
+  type: string
+  min_version: 3.60
+filter_updated_at:
+  description: |
+    Filters reuslts by a time that resources are updated at with time
+    comaprison operators: gt/gte/eq/neq/lt/lte.
+    The date and time stamp format is ISO 8601: CCYY-MM-DDThh:mm:ss±hh:mm.
+    The ±hh:mm value, if included, returns the time zone as an offset from UTC.
+  in: query
+  required: false
+  type: string
+  min_version: 3.60
 fix_allocated_quotas:
   description: |
     Whether to fix all the non-leaf projects' ``allocation``
@@ -231,6 +243,14 @@ force_del_qos:
   in: query
   required: false
   type: boolean
+force_vol_del:
+  description: |
+    Indicates whether to force delete a volume even if
+    the volume is in deleting or error_deleting. Default is ``false``.
+  in: query
+  required: false
+  type: boolean
+  min_version: 3.23
 host_query:
   description: |
     Filter the service list result by host name of the service.
@@ -549,7 +569,19 @@ attachments:
     is attached to a server instance, the attachments list includes
     the UUID of the attached server, an attachment UUID, the name of
     the attached host, if any, the volume UUID, the device, and the
-    device UUID.  Otherwise, this list is empty.
+    device UUID.  Otherwise, this list is empty. For example::
+
+      [
+        {
+          'server_id': '6c8cf6e0-4c8f-442f-9196-9679737feec6',
+          'attachment_id': '3dafcac4-1cb9-4b60-a227-d729baa10cf6',
+          'attached_at': '2019-09-30T19:30:34.000000',
+          'host_name': null,
+          'volume_id': '5d95d5ee-4bdd-4452-b9d7-d44ca10d3d53',
+          'device': '/dev/vda',
+          'id': '5d95d5ee-4bdd-4452-b9d7-d44ca10d3d53'
+        }
+      ]
   in: body
   required: true
   type: array
@@ -1314,7 +1346,7 @@ has_dependent_backups:
 host:
   description: |
     The OpenStack Block Storage host where the
-    existing volume resides. Host format is ``host@backend``.
+    existing volume resides.
   in: body
   required: true
   type: object
@@ -1333,7 +1365,8 @@ host_name:
   type: string
 host_name_backend:
   description: |
-    The name of the host that hosts the storage backend.
+    The name of the host that hosts the storage backend,
+    may take the format of ``host@backend``.
   in: body
   required: true
   type: string
diff -pruN 2:15.0.1-1/api-ref/source/v3/qos-specs-v3-qos-specs.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/qos-specs-v3-qos-specs.inc
--- 2:15.0.1-1/api-ref/source/v3/qos-specs-v3-qos-specs.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/qos-specs-v3-qos-specs.inc	2020-03-24 18:46:31.000000000 +0000
@@ -61,7 +61,7 @@ Request
 Request Example
 ---------------
 
-.. literalinclude:: ./samples/qos-unset-request.json
+.. literalinclude:: ./samples/qos/qos-unset-request.json
    :language: javascript
 
 
@@ -104,7 +104,7 @@ Response
 Response Example
 ----------------
 
-.. literalinclude:: ./samples/qos_show_response.json
+.. literalinclude:: ./samples/qos/qos_show_response.json
    :language: javascript
 
 
@@ -210,7 +210,7 @@ Response Parameters
 Response Example
 ----------------
 
-.. literalinclude:: ./samples/qos-show-response.json
+.. literalinclude:: ./samples/qos/qos-show-response.json
    :language: javascript
 
 
@@ -241,7 +241,7 @@ Request
 Request Example
 ---------------
 
-.. literalinclude:: ./samples/qos-update-request.json
+.. literalinclude:: ./samples/qos/qos-update-request.json
    :language: javascript
 
 Response
@@ -255,7 +255,7 @@ Response
 Response Example
 ----------------
 
-.. literalinclude:: ./samples/qos-update-response.json
+.. literalinclude:: ./samples/qos/qos-update-response.json
    :language: javascript
 
 
@@ -314,7 +314,7 @@ Request
 Request Example
 ---------------
 
-.. literalinclude:: ./samples/qos-create-request.json
+.. literalinclude:: ./samples/qos/qos-create-request.json
    :language: javascript
 
 
@@ -334,7 +334,7 @@ Response Parameters
 Response Example
 ----------------
 
-.. literalinclude:: ./samples/qos-create-response.json
+.. literalinclude:: ./samples/qos/qos-create-response.json
    :language: javascript
 
 
@@ -384,5 +384,5 @@ Response Parameters
 Response Example
 ----------------
 
-.. literalinclude:: ./samples/qos-list-response.json
+.. literalinclude:: ./samples/qos/qos-list-response.json
    :language: javascript
diff -pruN 2:15.0.1-1/api-ref/source/v3/quota-classes.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/quota-classes.inc
--- 2:15.0.1-1/api-ref/source/v3/quota-classes.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/quota-classes.inc	2020-03-24 18:46:31.000000000 +0000
@@ -60,7 +60,7 @@ Response Parameters
 Response Example
 ----------------
 
-.. literalinclude:: ./samples/quota-classes-show-response.json
+.. literalinclude:: ./samples/quota_classes/quota-classes-show-response.json
    :language: javascript
 
 Update quota classes for a project
@@ -103,7 +103,7 @@ Request
 Request Example
 ---------------
 
-.. literalinclude:: ./samples/quota-classes-update-request.json
+.. literalinclude:: ./samples/quota_classes/quota-classes-update-request.json
    :language: javascript
 
 
@@ -127,5 +127,5 @@ Response Parameters
 Response Example
 ----------------
 
-.. literalinclude:: ./samples/quota-classes-update-response.json
+.. literalinclude:: ./samples/quota_classes/quota-classes-update-response.json
    :language: javascript
diff -pruN 2:15.0.1-1/api-ref/source/v3/quota-sets.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/quota-sets.inc
--- 2:15.0.1-1/api-ref/source/v3/quota-sets.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/quota-sets.inc	2020-03-24 18:46:31.000000000 +0000
@@ -55,7 +55,7 @@ Response Parameters
 Response Example
 ----------------
 
-.. literalinclude:: ./samples/quotas-show-response.json
+.. literalinclude:: ./samples/quota_sets/quotas-show-response.json
    :language: javascript
 
 
@@ -106,7 +106,7 @@ Response Parameters
 Response Example
 ----------------
 
-.. literalinclude:: ./samples/quotas-show-usage-response.json
+.. literalinclude:: ./samples/quota_sets/quotas-show-usage-response.json
    :language: javascript
 
 
@@ -149,7 +149,7 @@ Request
 Request Example
 ---------------
 
-.. literalinclude:: ./samples/quotas-update-request.json
+.. literalinclude:: ./samples/quota_sets/quotas-update-request.json
    :language: javascript
 
 
@@ -173,7 +173,7 @@ Response Parameters
 Response Example
 ----------------
 
-.. literalinclude:: ./samples/quotas-update-response.json
+.. literalinclude:: ./samples/quota_sets/quotas-update-response.json
    :language: javascript
 
 Delete quotas for a project
@@ -248,7 +248,7 @@ Response Parameters
 Response Example
 ----------------
 
-.. literalinclude:: ./samples/quotas-show-defaults-response.json
+.. literalinclude:: ./samples/quota_sets/quotas-show-defaults-response.json
    :language: javascript
 
 
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/limits/limits-show-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/limits/limits-show-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/limits/limits-show-response.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/limits/limits-show-response.json	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,17 @@
+{
+    "limits": {
+        "rate": [],
+        "absolute": {
+            "totalSnapshotsUsed": 0,
+            "maxTotalBackups": 10,
+            "maxTotalVolumeGigabytes": 1000,
+            "maxTotalSnapshots": 10,
+            "maxTotalBackupGigabytes": 1000,
+            "totalBackupGigabytesUsed": 0,
+            "maxTotalVolumes": 10,
+            "totalVolumesUsed": 0,
+            "totalBackupsUsed": 0,
+            "totalGigabytesUsed": 0
+        }
+    }
+}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/limits-show-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/limits-show-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/limits-show-response.json	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/limits-show-response.json	1970-01-01 00:00:00.000000000 +0000
@@ -1,17 +0,0 @@
-{
-    "limits": {
-        "rate": [],
-        "absolute": {
-            "totalSnapshotsUsed": 0,
-            "maxTotalBackups": 10,
-            "maxTotalVolumeGigabytes": 1000,
-            "maxTotalSnapshots": 10,
-            "maxTotalBackupGigabytes": 1000,
-            "totalBackupGigabytesUsed": 0,
-            "maxTotalVolumes": 10,
-            "totalVolumesUsed": 0,
-            "totalBackupsUsed": 0,
-            "totalGigabytesUsed": 0
-        }
-    }
-}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/qos/qos-create-request.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos/qos-create-request.json
--- 2:15.0.1-1/api-ref/source/v3/samples/qos/qos-create-request.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos/qos-create-request.json	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,5 @@
+{
+    "qos_specs": {
+        "name": "reliability-spec"
+    }
+}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/qos/qos-create-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos/qos-create-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/qos/qos-create-response.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos/qos-create-response.json	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,18 @@
+{
+    "qos_specs": {
+        "specs": {},
+        "consumer": "back-end",
+        "name": "reliability-spec",
+        "id": "599ef437-1c99-42ec-9fc6-239d0519fef1"
+    },
+    "links": [
+        {
+            "href": "http://23.253.248.171:8776/v3/89afd400-b646-4bbc-b12b-c0a4d63e5bd3/qos-specs/599ef437-1c99-42ec-9fc6-239d0519fef1",
+            "rel": "self"
+        },
+        {
+            "href": "http://23.253.248.171:8776/89afd400-b646-4bbc-b12b-c0a4d63e5bd3/qos-specs/599ef437-1c99-42ec-9fc6-239d0519fef1",
+            "rel": "bookmark"
+        }
+    ]
+}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/qos/qos-list-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos/qos-list-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/qos/qos-list-response.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos/qos-list-response.json	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,10 @@
+{
+    "qos_specs": [
+        {
+            "consumer": "back-end",
+            "id": "62c17294-2e52-4877-a01f-a30388749d9d",
+            "name": "reliability-spec",
+            "specs": {}
+        }
+    ]
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/qos/qos_show_response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos/qos_show_response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/qos/qos_show_response.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos/qos_show_response.json	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,3 @@
+{
+    "qos_associations": []
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/qos/qos-show-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos/qos-show-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/qos/qos-show-response.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos/qos-show-response.json	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,18 @@
+{
+    "qos_specs": {
+        "specs": {},
+        "consumer": "back-end",
+        "name": "reliability-spec",
+        "id": "0388d6c6-d5d4-42a3-b289-95205c50dd15"
+    },
+    "links": [
+        {
+            "href": "http://23.253.228.211:8776/v3/89afd400-b646-4bbc-b12b-c0a4d63e5bd3/qos-specs/0388d6c6-d5d4-42a3-b289-95205c50dd15",
+            "rel": "self"
+        },
+        {
+            "href": "http://23.253.228.211:8776/89afd400-b646-4bbc-b12b-c0a4d63e5bd3/qos-specs/0388d6c6-d5d4-42a3-b289-95205c50dd15",
+            "rel": "bookmark"
+        }
+    ]
+}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/qos/qos-unset-request.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos/qos-unset-request.json
--- 2:15.0.1-1/api-ref/source/v3/samples/qos/qos-unset-request.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos/qos-unset-request.json	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,5 @@
+{
+    "keys": [
+        "key1"
+    ]
+}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/qos/qos-update-request.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos/qos-update-request.json
--- 2:15.0.1-1/api-ref/source/v3/samples/qos/qos-update-request.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos/qos-update-request.json	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,5 @@
+{
+    "qos_specs": {
+        "delay": "1"
+    }
+}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/qos/qos-update-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos/qos-update-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/qos/qos-update-response.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos/qos-update-response.json	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,5 @@
+{
+    "qos_specs": {
+        "delay": "1"
+    }
+}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/qos-create-request.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos-create-request.json
--- 2:15.0.1-1/api-ref/source/v3/samples/qos-create-request.json	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos-create-request.json	1970-01-01 00:00:00.000000000 +0000
@@ -1,5 +0,0 @@
-{
-    "qos_specs": {
-        "name": "reliability-spec"
-    }
-}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/qos-create-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos-create-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/qos-create-response.json	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos-create-response.json	1970-01-01 00:00:00.000000000 +0000
@@ -1,21 +0,0 @@
-{
-    "qos_specs": {
-        "specs": {
-            "numberOfFailures": "0",
-            "availability": "100"
-        },
-        "consumer": "back-end",
-        "name": "reliability-spec",
-        "id": "599ef437-1c99-42ec-9fc6-239d0519fef1"
-    },
-    "links": [
-        {
-            "href": "http://23.253.248.171:8776/v3/bab7d5c60cd041a0a36f7c4b6e1dd978/qos_specs/599ef437-1c99-42ec-9fc6-239d0519fef1",
-            "rel": "self"
-        },
-        {
-            "href": "http://23.253.248.171:8776/bab7d5c60cd041a0a36f7c4b6e1dd978/qos_specs/599ef437-1c99-42ec-9fc6-239d0519fef1",
-            "rel": "bookmark"
-        }
-    ]
-}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/qos-list-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos-list-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/qos-list-response.json	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos-list-response.json	1970-01-01 00:00:00.000000000 +0000
@@ -1,22 +0,0 @@
-{
-    "qos_specs": [
-        {
-            "specs": {
-                "availability": "100",
-                "numberOfFailures": "0"
-            },
-            "consumer": "back-end",
-            "name": "reliability-spec",
-            "id": "0388d6c6-d5d4-42a3-b289-95205c50dd15"
-        },
-        {
-            "specs": {
-                "delay": "0",
-                "throughput": "100"
-            },
-            "consumer": "back-end",
-            "name": "performance-spec",
-            "id": "ecfc6e2e-7117-44a4-8eec-f84d04f531a8"
-        }
-    ]
-}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/qos_show_response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos_show_response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/qos_show_response.json	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos_show_response.json	1970-01-01 00:00:00.000000000 +0000
@@ -1,9 +0,0 @@
-{
-    "qos_associations": [
-        {
-            "association_type": "volume_type",
-            "name": "reliability-type",
-            "id": "a12983c2-83bd-4afa-be9f-ad796573ead6"
-        }
-    ]
-}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/qos-show-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos-show-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/qos-show-response.json	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos-show-response.json	1970-01-01 00:00:00.000000000 +0000
@@ -1,21 +0,0 @@
-{
-    "qos_specs": {
-        "specs": {
-            "availability": "100",
-            "numberOfFailures": "0"
-        },
-        "consumer": "back-end",
-        "name": "reliability-spec",
-        "id": "0388d6c6-d5d4-42a3-b289-95205c50dd15"
-    },
-    "links": [
-        {
-            "href": "http://23.253.228.211:8776/v3/e1cf63117ae74309a5bcc2002a23be8b/qos_specs/0388d6c6-d5d4-42a3-b289-95205c50dd15",
-            "rel": "self"
-        },
-        {
-            "href": "http://23.253.228.211:8776/e1cf63117ae74309a5bcc2002a23be8b/qos_specs/0388d6c6-d5d4-42a3-b289-95205c50dd15",
-            "rel": "bookmark"
-        }
-    ]
-}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/qos-unset-request.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos-unset-request.json
--- 2:15.0.1-1/api-ref/source/v3/samples/qos-unset-request.json	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos-unset-request.json	1970-01-01 00:00:00.000000000 +0000
@@ -1,5 +0,0 @@
-{
-    "keys": [
-        "key1"
-    ]
-}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/qos-update-request.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos-update-request.json
--- 2:15.0.1-1/api-ref/source/v3/samples/qos-update-request.json	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos-update-request.json	1970-01-01 00:00:00.000000000 +0000
@@ -1,5 +0,0 @@
-{
-    "qos_specs": {
-        "delay": "1"
-    }
-}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/qos-update-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos-update-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/qos-update-response.json	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/qos-update-response.json	1970-01-01 00:00:00.000000000 +0000
@@ -1,5 +0,0 @@
-{
-    "qos_specs": {
-        "delay": "1"
-    }
-}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/quota_classes/quota-classes-show-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quota_classes/quota-classes-show-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/quota_classes/quota-classes-show-response.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quota_classes/quota-classes-show-response.json	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,15 @@
+{
+    "quota_class_set": {
+        "backup_gigabytes": 1000,
+        "backups": 10,
+        "gigabytes": 1000,
+        "gigabytes___DEFAULT__": -1,
+        "groups": 10,
+        "id": "test_class",
+        "per_volume_gigabytes": -1,
+        "snapshots": 10,
+        "snapshots___DEFAULT__": -1,
+        "volumes": 10,
+        "volumes___DEFAULT__": -1
+    }
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/quota_classes/quota-classes-update-request.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quota_classes/quota-classes-update-request.json
--- 2:15.0.1-1/api-ref/source/v3/samples/quota_classes/quota-classes-update-request.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quota_classes/quota-classes-update-request.json	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,7 @@
+{
+    "quota_class_set": {
+        "volumes": 10,
+        "gigabytes": 1000,
+        "snapshots": 10
+    }
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/quota_classes/quota-classes-update-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quota_classes/quota-classes-update-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/quota_classes/quota-classes-update-response.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quota_classes/quota-classes-update-response.json	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,14 @@
+{
+    "quota_class_set": {
+        "backup_gigabytes": 1000,
+        "backups": 10,
+        "gigabytes": 1000,
+        "gigabytes___DEFAULT__": -1,
+        "groups": 10,
+        "per_volume_gigabytes": -1,
+        "snapshots": 10,
+        "snapshots___DEFAULT__": -1,
+        "volumes": 10,
+        "volumes___DEFAULT__": -1
+    }
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/quota_sets/quotas-show-defaults-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quota_sets/quotas-show-defaults-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/quota_sets/quotas-show-defaults-response.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quota_sets/quotas-show-defaults-response.json	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,15 @@
+{
+    "quota_set": {
+        "backup_gigabytes": 1000,
+        "backups": 10,
+        "gigabytes": 1000,
+        "gigabytes___DEFAULT__": -1,
+        "groups": 10,
+        "id": "fake_tenant",
+        "per_volume_gigabytes": -1,
+        "snapshots": 10,
+        "snapshots___DEFAULT__": -1,
+        "volumes": 10,
+        "volumes___DEFAULT__": -1
+    }
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/quota_sets/quotas-show-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quota_sets/quotas-show-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/quota_sets/quotas-show-response.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quota_sets/quotas-show-response.json	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,15 @@
+{
+    "quota_set": {
+        "backup_gigabytes": 1000,
+        "backups": 10,
+        "gigabytes": 1000,
+        "gigabytes___DEFAULT__": -1,
+        "groups": 10,
+        "id": "fake_tenant",
+        "per_volume_gigabytes": -1,
+        "snapshots": 10,
+        "snapshots___DEFAULT__": -1,
+        "volumes": 10,
+        "volumes___DEFAULT__": -1
+    }
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/quota_sets/quotas-show-usage-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quota_sets/quotas-show-usage-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/quota_sets/quotas-show-usage-response.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quota_sets/quotas-show-usage-response.json	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,55 @@
+{
+    "quota_set": {
+        "backup_gigabytes": {
+            "in_use": 0,
+            "limit": 1000,
+            "reserved": 0
+        },
+        "backups": {
+            "in_use": 0,
+            "limit": 10,
+            "reserved": 0
+        },
+        "gigabytes": {
+            "in_use": 0,
+            "limit": 1000,
+            "reserved": 0
+        },
+        "gigabytes___DEFAULT__": {
+            "in_use": 0,
+            "limit": -1,
+            "reserved": 0
+        },
+        "groups": {
+            "in_use": 0,
+            "limit": 10,
+            "reserved": 0
+        },
+        "id": "fake_tenant",
+        "per_volume_gigabytes": {
+            "in_use": 0,
+            "limit": -1,
+            "reserved": 0
+        },
+        "snapshots": {
+            "in_use": 0,
+            "limit": 10,
+            "reserved": 0
+        },
+        "snapshots___DEFAULT__": {
+            "in_use": 0,
+            "limit": -1,
+            "reserved": 0
+        },
+        "volumes": {
+            "in_use": 0,
+            "limit": 10,
+            "reserved": 0
+        },
+        "volumes___DEFAULT__": {
+            "in_use": 0,
+            "limit": -1,
+            "reserved": 0
+        }
+    }
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/quota_sets/quotas-update-request.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quota_sets/quotas-update-request.json
--- 2:15.0.1-1/api-ref/source/v3/samples/quota_sets/quotas-update-request.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quota_sets/quotas-update-request.json	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,7 @@
+{
+    "quota_set":{
+        "groups": 11,
+        "volumes": 5,
+        "backups": 4
+    }
+}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/quota_sets/quotas-update-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quota_sets/quotas-update-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/quota_sets/quotas-update-response.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quota_sets/quotas-update-response.json	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,14 @@
+{
+    "quota_set": {
+        "backup_gigabytes": 1000,
+        "backups": 4,
+        "gigabytes": 1000,
+        "gigabytes___DEFAULT__": -1,
+        "groups": 11,
+        "per_volume_gigabytes": -1,
+        "snapshots": 10,
+        "snapshots___DEFAULT__": -1,
+        "volumes": 5,
+        "volumes___DEFAULT__": -1
+    }
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/quotas-show-defaults-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quotas-show-defaults-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/quotas-show-defaults-response.json	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quotas-show-defaults-response.json	1970-01-01 00:00:00.000000000 +0000
@@ -1,21 +0,0 @@
-{
-    "quota_set": {
-        "id": "a7090a26bc554d93aa845a4d41808251",
-        "volumes": 10,
-        "volumes_ceph": -1,
-        "volumes_lvm-thin": -1,
-        "volumes_lvmdriver-1": -1,
-        "snapshots": 10,
-        "snapshots_ceph": -1,
-        "snapshots_lvm-thin": -1,
-        "snapshots_lvmdriver-1": -1,
-        "backups": 10,
-        "groups": 10,
-        "per_volume_gigabytes": -1,
-        "gigabytes": 1000,
-        "gigabytes_ceph": -1,
-        "gigabytes_lvm-thin": -1,
-        "gigabytes_lvmdriver-1": -1,
-        "backup_gigabytes": 1000
-    }
-}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/quotas-show-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quotas-show-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/quotas-show-response.json	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quotas-show-response.json	1970-01-01 00:00:00.000000000 +0000
@@ -1,21 +0,0 @@
-{
-    "quota_set": {
-        "id": "a7090a26bc554d93aa845a4d41808251",
-        "volumes": 10,
-        "volumes_ceph": -1,
-        "volumes_lvm-thin": -1,
-        "volumes_lvmdriver-1": -1,
-        "snapshots": 10,
-        "snapshots_ceph": -1,
-        "snapshots_lvm-thin": -1,
-        "snapshots_lvmdriver-1": -1,
-        "backups": 10,
-        "groups": 10,
-        "per_volume_gigabytes": -1,
-        "gigabytes": 1000,
-        "gigabytes_ceph": -1,
-        "gigabytes_lvm-thin": -1,
-        "gigabytes_lvmdriver-1": -1,
-        "backup_gigabytes": 1000
-    }
-}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/quotas-show-usage-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quotas-show-usage-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/quotas-show-usage-response.json	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quotas-show-usage-response.json	1970-01-01 00:00:00.000000000 +0000
@@ -1,65 +0,0 @@
-{
-    "quota_set": {
-        "id": "a7090a26bc554d93aa845a4d41808251",
-        "volumes": {
-            "reserved": 0,
-            "allocated": 0,
-            "limit": 10,
-            "in_use": 0
-        },
-        "volumes_lvmdriver-1": {
-            "reserved": 0,
-            "allocated": 0,
-            "limit": -1,
-            "in_use": 0
-        },
-        "snapshots": {
-            "reserved": 0,
-            "allocated": 0,
-            "limit": 10,
-            "in_use": 0
-        },
-        "snapshots_lvmdriver-1": {
-            "reserved": 0,
-            "allocated": 0,
-            "limit": -1,
-            "in_use": 0
-        },
-        "backups": {
-            "reserved": 0,
-            "allocated": 0,
-            "limit": 10,
-            "in_use": 0
-        },
-        "groups": {
-            "reserved": 0,
-            "allocated": 0,
-            "limit": 10,
-            "in_use": 0
-        },
-        "per_volume_gigabytes": {
-            "reserved": 0,
-            "allocated": 0,
-            "limit": -1,
-            "in_use": 0
-        },
-        "gigabytes": {
-            "reserved": 0,
-            "allocated": 0,
-            "limit": 1000,
-            "in_use": 0
-        },
-        "gigabytes_lvmdriver-1": {
-            "reserved": 0,
-            "allocated": 0,
-            "limit": 1000,
-            "in_use": 0
-        },
-        "backup_gigabytes": {
-            "reserved": 0,
-            "allocated": 0,
-            "limit": 1000,
-            "in_use": 0
-        }
-    }
-}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/quotas-update-request.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quotas-update-request.json
--- 2:15.0.1-1/api-ref/source/v3/samples/quotas-update-request.json	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quotas-update-request.json	1970-01-01 00:00:00.000000000 +0000
@@ -1,8 +0,0 @@
-{
-    "quota_set":{
-        "groups": 11,
-        "volumes": 5,
-        "volumes_ceph": 3,
-        "backups": 4
-    }
-}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/quotas-update-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quotas-update-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/quotas-update-response.json	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/quotas-update-response.json	1970-01-01 00:00:00.000000000 +0000
@@ -1,20 +0,0 @@
-{
-    "quota_set": {
-        "volumes": 10,
-        "volumes_ceph": -1,
-        "volumes_lvm-thin": -1,
-        "volumes_lvmdriver-1": -1,
-        "snapshots": 10,
-        "snapshots_ceph": -1,
-        "snapshots_lvm-thin": -1,
-        "snapshots_lvmdriver-1": -1,
-        "backups": 10,
-        "groups": 10,
-        "per_volume_gigabytes": -1,
-        "gigabytes": 1000,
-        "gigabytes_ceph": -1,
-        "gigabytes_lvm-thin": -1,
-        "gigabytes_lvmdriver-1": -1,
-        "backup_gigabytes": 1000
-    }
-}
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/versions/version-show-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/versions/version-show-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/versions/version-show-response.json	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/versions/version-show-response.json	2020-03-24 18:46:31.000000000 +0000
@@ -22,7 +22,7 @@
             "min_version": "3.0",
             "status": "CURRENT",
             "updated": "2018-07-17T00:00:00Z",
-            "version": "3.59"
+            "version": "3.60"
         }
     ]
 }
diff -pruN 2:15.0.1-1/api-ref/source/v3/samples/versions/versions-response.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/versions/versions-response.json
--- 2:15.0.1-1/api-ref/source/v3/samples/versions/versions-response.json	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/samples/versions/versions-response.json	2020-03-24 18:46:31.000000000 +0000
@@ -46,7 +46,7 @@
             "min_version": "3.0",
             "status": "CURRENT",
             "updated": "2018-07-17T00:00:00Z",
-            "version": "3.59"
+            "version": "3.60"
         }
     ]
 }
\ No newline at end of file
diff -pruN 2:15.0.1-1/api-ref/source/v3/volumes-v3-volumes.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/volumes-v3-volumes.inc
--- 2:15.0.1-1/api-ref/source/v3/volumes-v3-volumes.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/api-ref/source/v3/volumes-v3-volumes.inc	2020-03-24 18:46:31.000000000 +0000
@@ -94,6 +94,8 @@ Request
    - offset: offset
    - marker: marker
    - with_count: with_count
+   - created_at: filter_created_at
+   - updated_at: filter_updated_at
 
 
 Response Parameters
@@ -286,6 +288,8 @@ Request
    - offset: offset
    - marker: marker
    - with_count: with_count
+   - created_at: filter_created_at
+   - updated_at: filter_updated_at
 
 
 Response Parameters
diff -pruN 2:15.0.1-1/AUTHORS 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/AUTHORS
--- 2:15.0.1-1/AUTHORS	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/AUTHORS	2020-03-24 18:46:35.000000000 +0000
@@ -0,0 +1,1274 @@
+= <akjayaku@cisco.com>
+Abel Lopez <abelopez@cisco.com>
+Abhijeet Malawade <Abhijeet.Malawade@nttdata.com>
+Abhilash Divakaran <abhilashd@tegile.com>
+Abhinav Srivastava <abhiabhi.sr@gmail.com>
+Abhiram Moturi <abhiram.moturi@oracle.com>
+Abhishek Kekane <abhishek.kekane@nttdata.com>
+Abhishek Kekane <akekane@redhat.com>
+Abhishek Lekshmanan <abhishek.lekshmanan@gmail.com>
+Abhishek Sharma <abmsharm@in.ibm.com>
+Abhishek Shrivastava <abhishek@cloudbyte.com>
+Accela Zhao <accelazh@gmail.com>
+Accela Zhao <bigzhao@cisco.com>
+Adalberto Medeiros <adalbas@linux.vnet.ibm.com>
+Adam Gandelman <adam.gandelman@canonical.com>
+Adam Gandelman <adamg@canonical.com>
+Adam Spiers <aspiers@suse.com>
+Adam Young <ayoung@redhat.com>
+Adelina Tuvenie <atuvenie@cloudbasesolutions.com>
+Adriano Rosso <adriano.rosso@fit-tecnologia.org.br>
+Adrien Vergé <adrien.verge@numergy.com>
+Ajaya Agrawal <ajku.agr@gmail.com>
+Alan <kaihongd@cn.ibm.com>
+Alan Bishop <abishop@redhat.com>
+Alan Jiang <ajiang@us.ibm.com>
+Alan Meadows <alan.meadows@gmail.com>
+Alberto Murillo <alberto.murillo.silva@intel.com>
+Alberto Planas <aplanas@gmail.com>
+Alejandro Emanuel Paredes <alejandro.e.paredes@intel.com>
+Aleksey Ruban <aleksey.ruban@nexenta.com>
+Alessandro Pilotti <ap@pilotti.it>
+Alessandro Pilotti <apilotti@cloudbasesolutions.com>
+Alex Deiter <alex.deiter@nexenta.com>
+Alex Holden <alex@alexjonasholden.com>
+Alex Meade <mr.alex.meade@gmail.com>
+Alex O'Rourke <alex.orourke@hp.com>
+Alex O'Rourke <alex.orourke@hpe.com>
+AlexMuresan <amuresan@cloudbasesolutions.com>
+Alexander Bochkarev <abochkarev@mirantis.com>
+Alexander Gordeev <agordeev@mirantis.com>
+Alexander Gorodnev <agorodnev@mirantis.com>
+Alexander Maretskiy <amaretskiy@mirantis.com>
+Alexandra Settle <a.settle@outlook.com>
+Alexandra Settle <asettle@suse.com>
+Alexandru Muresan <amuresan@cloudbasesolutions.com>
+Alexei Kornienko <akornienko@mirantis.com>
+Alexey Khodos <alexey.khodos@nexenta.com>
+Alexey Yelistratov <ayelistratov@mirantis.com>
+Alexis RIES <ries.alexis@gmail.com>
+Alfredo Moralejo <amoralej@redhat.com>
+Alon Marx <alonma@il.ibm.com>
+Alyson Rosa <alyson.rodrigues.rosa@gmail.com>
+Ameed Ashour <Ameed.Ashour.ext@nokia.com>
+Amit Oren <aoren@infinidat.com>
+Amit Saha <amsaha@gmail.com>
+AmitKumarDas <amit.das@cloudbyte.com>
+Amy Marrich (spotz) <amy@demarco.com>
+Anastasia Karpinska <akarpinska@griddynamics.com>
+Andreas Jaeger <aj@suse.com>
+Andreas Jaeger <aj@suse.de>
+Andreas Karis <akaris@redhat.com>
+Andreas Scheuring <andreas.scheuring@de.ibm.com>
+Andrei V. Ostapenko <aostapenko@mirantis.com>
+Andres Buraschi <andres.buraschi@intel.com>
+Andrew Forrest <forrest@research.att.com>
+Andrew Kerr <andrew.kerr@netapp.com>
+Andrey Kurilin <andr.kurilin@gmail.com>
+Andrey Pavlov <andrey-mp@yandex.ru>
+Andrey Volkov <avolkov@mirantis.com>
+Andy Grover <agrover@redhat.com>
+Angela Smith <aallen@brocade.com>
+Angela Smith <angela.smith@broadcom.com>
+Angus Lees <gus@inodes.org>
+Anh Tran <anhtt@vn.fujitsu.com>
+Anish Bhatt <anish@chelsio.com>
+Ankit Agrawal <ankit11.agrawal@nttdata.com>
+Ann Kamyshnikova <akamyshnikova@mirantis.com>
+Anna Sortland <annasort@us.ibm.com>
+Anthony Lee <anthony.mic.lee@hp.com>
+Anthony Lee <anthony.mic.lee@hpe.com>
+Anthony Young <sleepsonthefloor@gmail.com>
+Anton Arefiev <aarefiev@mirantis.com>
+Anton Frolov <anfrolov@mirantis.com>
+Antony Cleave <antony.cleave@clustervision.com>
+Arata Notsu <notsu@virtualtech.jp>
+Archit Modi <amodi@redhat.com>
+ArkadyKanevsky <arkady_kanevsky@dell.com>
+Armando Migliaccio <armamig@gmail.com>
+Arne Wiebalck <Arne.Wiebalck@cern.ch>
+Arnon Yaari <arnony@infinidat.com>
+Aseel Awwad <aseel.awwad@exalt.ps>
+Aswad Rangnekar <aswad.rangnekar@nttdata.com>
+Atsushi SAKAI <sakaia@jp.fujitsu.com>
+Attila Fazekas <afazekas@redhat.com>
+Aviram Bar-Haim <aviramb@mellanox.com>
+Avishay Traeger <avishay@gmail.com>
+Avishay Traeger <avishay@il.ibm.com>
+Avishay Traeger <avishay@stratoscale.com>
+Bala Gopal Raj <balagopalraj@techpatron.co.in>
+Bardia Keyoumarsi <bardia.keyoumarsi@cohodata.com>
+Bartek Zurawski <bartek.zurawski@ovh.net>
+Bartosz Rabiega <bartosz.rabiega@corp.ovh.com>
+Ben Nemec <bnemec@redhat.com>
+Ben Nemec <openstack@nemebean.com>
+Ben Swartzlander <ben@swartzlander.org>
+Ben Swartzlander <bswartz@netapp.com>
+Bertrand Lallau <bertrand.lallau@gmail.com>
+Bertrand Lallau <bertrand.lallau@thalesgroup.com>
+Bhaa Shakur <bhaa@zadara.com>
+Bharat Kumar Kobagana (BharatK) <bharat.kobagana@redhat.com>
+Bharat Kumar Kobagana <bharat.kobagana@redhat.com>
+Bharat Kumar Kobagana <bkobagan@redhat.com>
+Bhavya Bansal <bbansal@ncsu.edu>
+Bi Shun Ke <aionshun@livemail.tw>
+Bill Owen <billowen@us.ibm.com>
+Bin Zhou <zhou.bin9@zte.com.cn>
+Bob Ball <bob.ball@citrix.com>
+Bob Callaway <bob.callaway@netapp.com>
+Bob-OpenStack <295988511@qq.com>
+Boris Pavlovic <boris@pavlovic.me>
+Brant Knudson <bknudson@us.ibm.com>
+Brent Roskos <roskosb@yahoo.com>
+Brian Rosmaita <romaita.fossdev@gmail.com>
+Brian Rosmaita <rosmaita.fossdev@gmail.com>
+Brian Waldon <bcwaldon@gmail.com>
+Brianna Poulos <Brianna.Poulos@jhuapl.edu>
+Bridget McGinnis <bfmcginnis@gmail.com>
+Bryan D. Payne <bdpayne@acm.org>
+Béla Vancsics <vancsics@inf.u-szeged.hu>
+CY Chiang <cychiang@cht.com.tw>
+Cady_Chen <chenyingnan@inspur.com>
+Cao ShuFeng <caosf.fnst@cn.fujitsu.com>
+Cao Shufeng <caosf.fnst@cn.fujitsu.com>
+Cao Xuan Hoang <hoangcx@vn.fujitsu.com>
+Carl Pecinovsky <csky@us.ibm.com>
+Carlos Goncalves <cgoncalves@av.it.pt>
+Cedric Zhuang <cedric.zhuang@emc.com>
+Cedric Zhuang <cedric.zhuang@gmail.com>
+Chandan Kumar <chkumar246@gmail.com>
+Chandan Kumar <chkumar@redhat.com>
+Chang Bo Guo <guochbo@cn.ibm.com>
+ChangBo Guo(gcb) <eric.guo@easystack.cn>
+Chao Zheng CZ Li <lichaoz@cn.ibm.com>
+Chaozhe.Chen <chaozhe.chen@easystack.cn>
+Charles Short <chucks@redhat.com>
+Chaynika Saikia <csaikia@asu.edu>
+Chet Burgess <cfb@metacloud.com>
+Chhavi Agarwal <chhagarw@in.ibm.com>
+Chi Lo <cl566n@att.com>
+Chiawei Xie <dommgifer@gmail.com>
+Chintha Govardhan <chintha.govardhan@hpe.com>
+Chmouel Boudjnah <chmouel@chmouel.com>
+Chris Buccella <buccella@linux.vnet.ibm.com>
+Chris Friesen <chris.friesen@windriver.com>
+Chris M <cinder@tristero.net>
+Chris Morrell <chris@solidfire.com>
+Chris Morrell <gomeler@gmail.com>
+Chris Suttles <suttles@gmail.com>
+Chris Yang <chrisyang@qnap.com>
+Chris Yeoh <cyeoh@au1.ibm.com>
+Christian Berendt <berendt@b1-systems.de>
+Christian Berendt <berendt@betacloud-solutions.de>
+Christoph Kassen <c.kassen@telekom.de>
+Christopher J Schaefer <cjschaef@us.ibm.com>
+Christopher MacGown <chris@pistoncloud.com>
+Chuck Fouts <fchuck@netapp.com>
+Chuck Short <chuck.short@canonical.com>
+Chuck Short <chucks@redhat.com>
+Cian O'Driscoll <cian@hp.com>
+Ciara Stacke <ciara.stacke@emc.com>
+Cindy Pallares <cindy.pallaresq@gmail.com>
+Clark Boylan <clark.boylan@gmail.com>
+ClaudiuNesa <cnesa@cloudbasesolutions.com>
+Clay Gerrard <clay.gerrard@gmail.com>
+Clenimar Filemon <clenimar.filemon@gmail.com>
+Clinton <cknight@netapp.com>
+Clinton Knight <cknight@netapp.com>
+Colleen Murphy <colleen@gazlene.net>
+Corey Bryant <corey.bryant@canonical.com>
+Corey Wright <corey.wright@rackspace.com>
+Cory Stone <corystone@gmail.com>
+Cory Wright <corywright@gmail.com>
+Craig Vyvial <cp16net@gmail.com>
+Craige McWhirter <craige@mcwhirter.com.au>
+Csaba Henk <chenk@redhat.com>
+Curt Bruns <curt.e.bruns@intel.com>
+Cyril Roelandt <cyril@redhat.com>
+DTadrzak <daniel.tadrzak@intel.com>
+Dai Dang Van <daikk115@gmail.com>
+Daisuke Fujita <fuzita.daisuke@jp.fujitsu.com>
+Dan Prince <dprince@redhat.com>
+Dan Radez <dradez@redhat.com>
+Dan Smith <dansmith@redhat.com>
+Daniel Allegood <daniel.allegood@hp.com>
+Daniel Gollub <d.gollub@telekom.de>
+Daniel Gonzalez <daniel@gonzalez-nothnagel.de>
+Daniel Pawlik <daniel.pawlik@corp.ovh.com>
+Daniel Pawlik <pawlik.dan@gmail.com>
+Daniel Tadrzak <daniel.tadrzak@intel.com>
+Daniel Wilson <daniel.wilson@purestorage.com>
+Danny Al-Gaaf <danny.al-gaaf@bisect.de>
+Dao Cong Tien <tiendc@vn.fujitsu.com>
+Darren Birkett <darren.birkett@gmail.com>
+Davanum Srinivas <davanum@gmail.com>
+Davanum Srinivas <dims@linux.vnet.ibm.com>
+Dave Chen <wei.d.chen@intel.com>
+Dave McCowan <dmccowan@cisco.com>
+David Hill <dhill@redhat.com>
+David Medberry <openstack@medberry.net>
+David Pineau <dav.pineau@gmail.com>
+David Rabel <rabel@b1-systems.de>
+David Ripton <dripton@redhat.com>
+David Rosales <darosale@us.ibm.com>
+David Sariel <dsariel@redhat.com>
+David Vallee Delisle <dvd@redhat.com>
+Deepak C Shetty <deepakcs@redhat.com>
+Deepti Ramakrishna <deepti.ramakrishna@intel.com>
+Deliang Fan <fandeliang@letv.com>
+DennyZhang <denny@unitedstack.com>
+Derek Chiang <derek.chiang@nebula.com>
+Dermot Tynan <tynan@hp.com>
+Derrick J. Wippler <thrawn01@gmail.com>
+Diego Zamboni <dzambonil@gmail.com>
+Diem Tran <diem.tran@oracle.com>
+Dietmar Noll <dnoll@de.ibm.com>
+Digvijay Ukirde <digvijay.ukirde@in.ibm.com>
+Dima Shulyak <dshulyak@mirantis.com>
+Dina Belova <dbelova@mirantis.com>
+Dinesh Bhor <bhordinesh07@gmail.com>
+Dinesh Bhor <dinesh.bhor@nttdata.com>
+Dinesh Subhraveti <dineshs@us.ibm.com>
+Dirk Mueller <dirk@dmllr.de>
+Divya K Konoor <dikonoor@in.ibm.com>
+Dmitriy Rabotjagov <dmitriy.r@sitevalley.com>
+Dmitry Borodaenko <angdraug@gmail.com>
+Dmitry Guryanov <dguryanov@parallels.com>
+Dmitry Guryanov <dguryanov@virtuozzo.com>
+Dmitry Kudyukin <gmorfy@gmail.com>
+Dolph Mathews <dolph.mathews@gmail.com>
+Dominic Schlegel <dominic.schlegel@hostpoint.ch>
+Dongcan Ye <hellochosen@gmail.com>
+Dongsheng Yang <dongsheng.yang@easystack.cn>
+Doug Hellmann <doug.hellmann@dreamhost.com>
+Doug Hellmann <doug@doughellmann.com>
+Doug Schveninger <ds6901@att.com>
+Drew Balfour <andrew.balfour@oracle.com>
+Drew Fisher <drew.fisher@oracle.com>
+Drew Thorstensen <thorst@us.ibm.com>
+Duan Jiong <jduan@fiberhome.com>
+Duncan Thomas <duncan.thomas@gmail.com>
+Duncan Thomas <duncan.thomas@hp.com>
+Dunrong Huang <riegamaths@gmail.com>
+Earle F. Philhower, III <earle.philhower.iii@hgst.com>
+Ed Balduf <ebalduf@fusionio.com>
+Ed Balduf <ed.balduf@solidfire.com>
+Edmund Rhudy <erhudy@bloomberg.net>
+Eduardo Costa <eduardo.costa@tvglobo.com.br>
+Edward Hope-Morley <edward.hope-morley@canonical.com>
+Edwin Wang <edwin.wang@cn.ibm.com>
+Edwin Wang <edwin@oohoo.org>
+Eiichi Aikawa <aikawa@mxk.nes.nec.co.jp>
+Einst Crazy <yu.changcai@99cloud.net>
+Elad Zucker <eladz@hexsys-solutions.com>
+Elena Ezhova <eezhova@mirantis.com>
+Eli Qiao <liyong.qiao@intel.com>
+Emilien Macchi <emilien.macchi@enovance.com>
+Emilien Macchi <emilien@redhat.com>
+Eoghan Glynn <eglynn@redhat.com>
+Eric Brown <browne@vmware.com>
+Eric Guo <eric.guo@easystack.cn>
+Eric Harney <eharney@redhat.com>
+Eric M Gonzalez <eric@awnix.com>
+Eric Windisch <eric@cloudscaling.com>
+Eric Young <eric.young@dell.com>
+Eric Young <eric.young@emc.com>
+Eric Young <eric@aceshome.com>
+Erickson Santos <erickson@lsd.ufcg.edu.br>
+Erik Johannes <erik.johannes@netapp.com>
+Erik Zaadi <erikz@il.ibm.com>
+Erlon Cruz <erlon.cruz@fit-tecnologia.org.br>
+Erlon R. Cruz <erlon.cruz@fit-tecnologia.org.br>
+Erlon R. Cruz <erlon@canonical.com>
+Erlon R. Cruz <erlon@netapp.com>
+Evgeny Antyshev <eantyshev@virtuozzo.com>
+Fabien Boucher <fabien.boucher@enovance.com>
+Falk Reimann <falk.reimann@sap.com>
+Fei Long Wang <flwang@cn.ibm.com>
+Felipe Monteiro <felipe.monteiro@att.com>
+Fengqian Gao <fengqian.gao@intel.com>
+Fergal Mc Carthy <fergal.mccarthy@hpe.com>
+Fernando F. Silva <fernando.silva@netapp.com>
+Flaper Fesp <flaper87@gmail.com>
+Flavio Percoco <flaper87@gmail.com>
+Florent Flament <florent.flament-ext@cloudwatt.com>
+Florian Haas <florian@hastexo.com>
+Forest Romain <romain.forest@thalesgroup.com>
+Francis Moorehead <francis.moorehead@hp.com>
+Francois Deppierraz <francois@ctrlaltdel.ch>
+Frederic Lepied <frederic.lepied@enovance.com>
+Furuta Tomonori <furuta.tomonori@jp.fujitsu.com>
+GaoZqiang <gaozhiqiang2@huawei.com>
+Gaozexu <gaozx.fnst@cn.fujitsu.com>
+Gary Kotton <gkotton@vmware.com>
+Gary W. Smith <gary.w.smith@hp.com>
+Gaurang Tapase <gaurang.tapase@in.ibm.com>
+Gauvain Pocentek <gauvain.pocentek@objectif-libre.com>
+Geraint North <geraint.north@uk.ibm.com>
+Gerald McBrearty <gfm@us.ibm.com>
+Gerard Garcia <nouboh@gmail.com>
+Ghanshyam Mann <gmann@ghanshyammann.com>
+Ghanshyan Mann <gmann@ghanshyammann.com>
+Ghe Rivero <ghe@debian.org>
+Giulio Fidente <gfidente@redhat.com>
+Glenn M. Gobeli <Glenn.Gobeli@netapp.com>
+Gloria Gu <gloria.gu@hp.com>
+Gorka Eguileor <geguileo@redhat.com>
+Goutham Pacha Ravi <gouthampravi@gmail.com>
+Goutham Pacha Ravi <gouthamr@netapp.com>
+Guan Qiang <hzguanqiang@corp.netease.com>
+Guoqiang Ding <dingguoqiang@cloudin.cn>
+Guy Kim <guy.kim088@gmail.com>
+Gyorgy Szombathelyi <gyorgy.szombathelyi@doclerholding.com>
+Gyorgy Szombathelyi <gyurco@freemail.hu>
+Gábor Antal <antal@inf.u-szeged.hu>
+Ha Van Tu <tuhv@vn.fujitsu.com>
+Hagen Finley <hagen@datasundae.com>
+Hahyun <hfamily15@gmail.com>
+Hai-Xu Cheng <chenghxu@cn.ibm.com>
+Haiwei Xu <xu-haiwei@mxw.nes.nec.co.jp>
+Hamdy Khader <hamdyk@mellanox.com>
+Hanxi Liu <hanxi.liu@easystack.cn>
+Hanxi_Liu <hanxi.liu@easystack.cn>
+Haomai Wang <haomai@unitedstack.com>
+Harsh Mishra <harsh.mishra@wipro.com>
+Harshada Mangesh Kakad <harshadak@metsi.co.uk>
+Haruka Tanizawa <h-tanizawa@intellilink.co.jp>
+Hayley Swimelar <hayley@linbit.com>
+He Yongli <yongli.he@intel.com>
+Helen Walsh <helen.walsh@emc.com>
+Hiroyuki Eguchi <h-eguchi@az.jp.nec.com>
+Huangsm <huangsm@awcloud.com>
+Hui Cheng <freedomhui@gmail.com>
+Hyeock Kwon <dev.third9@gmail.com>
+Ian Denhardt <ian@zenhack.net>
+Ian Govett <igovett@gmail.com>
+Ian Wienand <iwienand@redhat.com>
+Ian Y. Choi <ianyrchoi@gmail.com>
+Ibadulla Khan <ik.ibadkhan@gmail.com>
+Igor Pugovkin <ipugovkin@mirantis.com>
+Ihar Hrachyshka <ihrachys@redhat.com>
+Ildiko Vancsa <ildiko.vancsa@gmail.com>
+Ilya Shakhat <shakhat@gmail.com>
+Ilya Tyaptin <ityaptin@mirantis.com>
+Inhye Park <inhye.park@samsung.com>
+Irina Mihai <irina.mihai@windriver.com>
+Isaac Beckman <isaacb@il.ibm.com>
+Ivan Kolodyazhny <e0ne@e0ne.info>
+Ivan Kolodyazhny <ikolodyazhny@mirantis.com>
+Ivan Pchelintsev <Ivan.Pchelintsev@dell.com>
+Ivaylo Mitev <imitev@vmware.com>
+Ivy Zhang <shzyu@cn.ibm.com>
+Jack Lu <renxlu@cisco.com>
+Jacob Gregor <jgregor@us.ibm.com>
+Jacob M. Jacob <jacob_jacob@dell.com>
+James Carey <jecarey@us.ibm.com>
+James E. Blair <jeblair@openstack.org>
+James E. Blair <jeblair@redhat.com>
+James Page <james.page@ubuntu.com>
+Jamie Lennox <jamielennox@gmail.com>
+Jamie Lennox <jamielennox@redhat.com>
+Jan Klare <j.klare@cloudbau.de>
+Jasakov Artem <ayasakov@mirantis.com>
+Jason Ni <jason.ni.py@gmail.com>
+Javeme <zhangmei.li@easystack.cn>
+Jay Conroy <james.conroy@hpe.com>
+Jay Lau <liugya@cn.ibm.com>
+Jay Lee <jaesang50.lee@samsung.com>
+Jay Mehta <jay.mehta@hpe.com>
+Jay Payne <letterj@gmail.com>
+Jay Rubenstein <jay.rubenstein@netapp.com>
+Jay S Bryant <jsbryant@us.ibm.com>
+Jay S. Bryant <jsbryant@electronicjungle.net>
+Jay S. Bryant <jsbryant@us.ibm.com>
+Jay S. Bryant <jungleboyj@electronicjungle.net>
+Jay Wang <jwang@nimblestorage.com>
+Jean-Baptiste RANSY <jean-baptiste.ransy@alyseo.com>
+Jean-Baptiste Ransy <jean-baptiste.ransy@alyseo.com>
+Jean-Marc Saffroy <jean.marc.saffroy@scality.com>
+Jean-Philippe Evrard <jean-philippe@evrard.me>
+Jeegn Chen <jeegn.chen@emc.com>
+Jeff Applewhite <jeff.applewhite@netapp.com>
+Jeffrey Zhang <zhang.lei.fly@gmail.com>
+Jenny Shieh <jenny.shieh@hp.com>
+Jens Harbott <j.harbott@x-ion.de>
+Jeremy Liu <liujiong@gohighsec.com>
+Jeremy Stanley <fungi@yuggoth.org>
+Jess Egler <jess.egler@gmail.com>
+Jesse Keating <jlk@bluebox.net>
+Jesse Pretorius <jesse.pretorius@rackspace.co.uk>
+Ji-Wei <ji.wei3@zte.com.cn>
+Jia Min <shljia@cn.ibm.com>
+Jichao Zhang <jichao.zhang@dell.com>
+Jim Branen <james.branen@hp.com>
+Jimmy McCrory <jimmy.mccrory@gmail.com>
+Jinru Yan <yanjr@cn.ibm.com>
+Jiří Suchomel <jiri.suchomel@suse.com>
+Joe Cropper <jwcroppe@us.ibm.com>
+Joe D'Andrea <jdandrea@research.att.com>
+Joe Gordon <joe.gordon0@gmail.com>
+Joe Gordon <jogo@cloudscaling.com>
+Joel Coffman <joel.coffman@jhuapl.edu>
+Joel Friedly <joelfriedly@gmail.com>
+John Cates <jccates@us.ibm.com>
+John Garbutt <john.garbutt@citrix.com>
+John Griffith <john.griffith8@gmail.com>
+John Griffith <john.griffith@solidfire.com>
+John McDonough <jomcdono@cisco.com>
+Johnny Chou <johnny800503.work@gmail.com>
+JohnnyChou <johnny800503.work@gmail.com>
+Johnson Koil Raj <johnson.raj@hp.com>
+Johnson koil raj <johnson.raj@hp.com>
+Jon Bernard <jbernard@tuxion.com>
+Jon Bernard <jobernar@redhat.com>
+Jordan Pittier <jordan.pittier@scality.com>
+Jordan Tardif <jordan@dreamhost.com>
+JordanP <jordan.pittier@scality.com>
+Jorge Niedbalski <jorge.niedbalski@canonical.com>
+Jose Castro Leon <jose.castro.leon@cern.ch>
+Jose Porrua <jose.porrua@netapp.com>
+Joseph Glanville <joseph@cloudscaling.com>
+Joseph Vokt <joseph.vokt@hp.com>
+Josh Durgin <josh.durgin@inktank.com>
+Joshua Harlow <harlowja@yahoo-inc.com>
+Joshua Huber <jhuber@blockbridge.com>
+JuPing <jup.fnst@cn.fujitsu.com>
+Juan Antonio Osorio Robles <jaosorior@redhat.com>
+Juan Manuel Olle <juan.m.olle@intel.com>
+Juan Zuluaga <juan.c.zuluaga@oracle.com>
+Julia Varlamova <jvarlamova@mirantis.com>
+Julien Danjou <julien@danjou.info>
+Jun Ishizaki <j-ishizaki@jp.fujitsu.com>
+Justin A Wilson <justin.wilson@intel.com>
+KIYOHIRO ADACHI <adachi@mxs.nes.nec.co.jp>
+Kai Zhang <kyle@zelin.io>
+Kaitlin Farr <Kaitlin.Farr@jhuapl.edu>
+Kaitlin Farr <kaitlin.farr@jhuapl.edu>
+Kallebe Monteiro <kallebe.monteiro@lsbd.ufc.br>
+Kamil Rykowski <kamil.rykowski@intel.com>
+Karthik Prabhu Vinod <karthik.prabhu.vinod@intel.com>
+Kartik Bommepally <kbommepally@vmware.com>
+Kazumasa Nomura <kazumasa.nomura.rx@hitachi.com>
+Kedar Vidvans <kedar.vidvans@oracle.com>
+Keisuke Kuroki <ke-kuroki@kddilabs.jp>
+Ken'ichi Ohmichi <ken-oomichi@wx.jp.nec.com>
+Ken'ichi Ohmichi <oomichi@mxs.nes.nec.co.jp>
+Kendall Nelson <kennelson11@gmail.com>
+Kendall Nelson <kjnelson@us.ibm.com>
+Kenji Yasui <k-yasui@ti.jp.nec.com>
+Kevin Carter <kevin@cloudnull.com>
+Kevin Fox <kevin@efox.cc>
+Kien Ha <kienha9922@gmail.com>
+Koert van der Veer <koert@cloudvps.com>
+Kui Shi <skuicloud@gmail.com>
+Kumar Prashant <kumar.prashant@dell.com>
+Kun Huang <academicgareth@gmail.com>
+Kun Huang <gareth@unitedstack.com>
+Kuo-tung Kao <jelly.k@inwinstack.com>
+Kurt Martin <kurt.f.martin@hp.com>
+Kurt Martin <kurt.f.martin@hpe.com>
+Kurt Taylor <krtaylor@us.ibm.com>
+Kushal <kushal.wathore@hpe.com>
+Kushal Wathore <kushal.wathore@hpe.com>
+Lakhinder Walia <lakhinder.walia@hds.com>
+Lakshmi Narayana <Lakshmi.Narayana.ctr@kaminario.com>
+Lance Bragstad <lbragstad@gmail.com>
+Larry Matter <lmatter@coraid.com>
+LarryLiu <liminliu@cn.ibm.com>
+Laura Sofia Enriquez <lsofia.enriquez@gmail.com>
+Lee <jessy1092@gmail.com>
+Lee Yarwood <lyarwood@redhat.com>
+Lena Novokshonova <enovokshonova@mirantis.com>
+Lenny Verkhovsky <lennyb@mellanox.com>
+LeopardMa <mabao@inspur.com>
+Li Min Liu <liminliu@cn.ibm.com>
+Liang Chen <cbjchen@cn.ibm.com>
+Liang Fang <liang.a.fang@intel.com>
+Lin Hua Cheng <lin-hua.cheng@hp.com>
+Lin Yang <lin.a.yang@intel.com>
+Lingxian Kong <anlin.kong@gmail.com>
+Liqin Dong <liqin@cisco.com>
+LisaLi <xiaoyan.li@intel.com>
+Liu Qing <liuqing@chinac.com>
+Liu Xinguo <295988511@qq.com>
+LiuNanke <nanke.liu@easystack.cn>
+LiuSheng <liusheng@huawei.com>
+Liucheng Jiang <jiangliucheng@huawei.com>
+Louie Kwan <louie.kwan@windriver.com>
+Lucas Alvares Gomes <lucasagomes@gmail.com>
+Lucian Petrut <lpetrut@cloudbasesolutions.com>
+Lucian Petrut <petrutlucian94@gmail.com>
+Lucio Seki <luciomitsuru.seki@fit-tecnologia.org.br>
+Lucio Seki <lucioseki@gmail.com>
+Luigi Toscano <ltoscano@redhat.com>
+Luis A. Garcia <luis@linux.vnet.ibm.com>
+Luis Pigueiras <luis.pigueiras@cern.ch>
+Luiz Gavioli <luiz.gavioli@netapp.com>
+Luiz Gavioli <luizbenedito.gavioli@fit-tecnologia.org.br>
+Lujin <luo.lujin@jp.fujitsu.com>
+Luong Anh Tuan <tuanla@vn.fujitsu.com>
+Lynxzh <jmzhang@cn.ibm.com>
+MENJO, Takashi <menjo.takashi@lab.ntt.co.jp>
+MORITA Kazutaka <morita.kazutaka@gmail.com>
+Maciej Szwed <maciej.szwed@intel.com>
+Madhuri Kumari <madhuri.kumari@intel.com>
+Mandell Degerness <mdegerne@gmail.com>
+Manjeet Singh Bhatia <manjeet.s.bhatia@intel.com>
+Manojkiran <manojkiran@localhost.localdomain>
+Manojkiran <manojkiran@manojkiran.(none)>
+MaoyangLiu <liumaoyang@inspur.com>
+Marc Koderer <m.koderer@telekom.de>
+Marc Koderer <marc@koderer.com>
+Marc Methot <mb.methot@gmail.com>
+Marc Methot <mmethot@redhat.com>
+Marga Millet <marga.sfo@gmail.com>
+Margarita Shakhova <shakhova.margarita@gmail.com>
+Marian Horban <mhorban@mirantis.com>
+Mark Giles <mark.giles@oracle.com>
+Mark Goddard <mark@stackhpc.com>
+Mark Korondi <korondi.mark@gmail.com>
+Mark McLoughlin <markmc@redhat.com>
+Mark Sturdevant <mark.sturdevant@hp.com>
+Mark T. Voelker <mvoelker@vmware.com>
+Markus Zoeller <mzoeller@de.ibm.com>
+Martin Kletzander <mkletzan@redhat.com>
+Masaki Kanno <kanno.masaki@jp.fujitsu.com>
+Masayuki Igawa <masayuki.igawa@gmail.com>
+Masayuki Igawa <masayuki@igawa.io>
+Masayuki Igawa <masayuki@igawa.me>
+Matan Sabag <matan.sabag@emc.com>
+Mate Lakat <mate.lakat@citrix.com>
+Mate Lakat <mlakat@suse.com>
+Mathieu Gagné <mgagne@iweb.com>
+Matt Fischer <matt@mattfischer.com>
+Matt Riedemann <mriedem.os@gmail.com>
+Matt Riedemann <mriedem@us.ibm.com>
+Matt Smith <mss@datera.io>
+Matthew Edmonds <edmondsw@us.ibm.com>
+Matthew Thode <mthode@mthode.org>
+Matthew Treinish <mtreinish@kortar.org>
+Matthew Treinish <treinish@linux.vnet.ibm.com>
+Maxim Nestratov <mnestratov@virtuozzo.com>
+Mehdi Abaakouk <mehdi.abaakouk@enovance.com>
+Mehdi Abaakouk <sileht@redhat.com>
+Mehdi Abaakouk <sileht@sileht.net>
+Meir Kriheli <Meir.Kriheli@emc.com>
+Michael Basnight <mbasnight@gmail.com>
+Michael Berlin <mberlin@quobyte.com>
+Michael Dovgal <mdovgal@mirantis.com>
+Michael J Fork <mjfork@us.ibm.com>
+Michael Kerrin <michael.kerrin@hp.com>
+Michael Krotscheck <krotscheck@gmail.com>
+Michael Latchmansingh <mlatchmansingh@datacore.com>
+Michael McAleer <Michael.Mcaleer@dell.com>
+Michael McAleer <michael.mcaleer@dell.com>
+Michael Price <lorenp@netapp.com>
+Michael Price <michael.price@netapp.com>
+Michael Rowden <mrrowden@us.ibm.com>
+Michael Still <mikal@stillhq.com>
+Michal Arbet <michal.arbet@ultimum.io>
+Michal Dulko <michal.dulko@intel.com>
+Michal Jura <mjura@suse.com>
+Michał Dulko <michal.dulko@intel.com>
+Midun Kumar <mneelame@cisco.com>
+Mike Bayer <mike_mp@zzzcomputing.com>
+Mike Mason <mikemason010@gmail.com>
+Mike Perez <thingee@gmail.com>
+Mike Rooney <mrooneyunc@gmail.com>
+Mike Rooney <rooneym@netapp.com>
+Mikhail Khodos <hodosmb@gmail.com>
+Mikhail Khodos <mikhail.khodos@nexenta.com>
+Mingyue Qian <qianmy.fnst@cn.fujitsu.com>
+Minmin Ren <renmm6@chinaunicom.cn>
+Miriam Yumi <miriam.peixoto@fit-tecnologia.org.br>
+Mitsuhiro SHIGEMATSU <shigematsu.mitsuhiro@lab.ntt.co.jp>
+Mitsuhiro Tanino <mitsuhiro.tanino@hds.com>
+Mohammed Naser <mnaser@vexxhost.com>
+Monica Joshi <monjoshi@in.ibm.com>
+MonicaJoshi <monjoshi@in.ibm.com>
+Monty Taylor <mordred@inaugust.com>
+Morgan Fainberg <m@metacloud.com>
+Morgan Fainberg <morgan.fainberg@gmail.com>
+MotoKen <motokentsai@gmail.com>
+Mudassir Latif <mudassir.latif@purestorage.com>
+Mukul Patel <mukul18@gmail.com>
+Mykhailo Dovgal <mdovgal@mirantis.com>
+Nam Nguyen Hoai <namnh@vn.fujitsu.com>
+Naoki Saito <n-saito@vx.jp.nec.com>
+Nashwan Azhari <nmouhammad@cloudbasesolutions.com>
+Nate Potter <nathaniel.potter@intel.com>
+Nathaniel Potter <nathaniel.potter@intel.com>
+Navneet Singh <navsinghnitd@gmail.com>
+Navneet Singh <singn@netapp.com>
+Neha Alhat <neha.alhat@nttdata.com>
+Ngo Quoc Cuong <cuongnq@vn.fujitsu.com>
+Nguyen Hai <nguyentrihai93@gmail.com>
+Nguyen Hai Truong <truongnh@vn.fujitsu.com>
+Nguyen Hung Phuong <phuongnh@vn.fujitsu.com>
+Nicholas Jones <nj762h@att.com>
+Nicolas Trangez <ikke@nicolast.be>
+Nikesh <nikeshmahalka@vedams.com>
+Nikesh Kumar Mahalka <Nikesh.Mahalka.ctr@kaminario.com>
+Nikesh Mahalka <Nikesh.Mahalka.ctr@kaminario.com>
+Nikola Dipanov <ndipanov@redhat.com>
+Nikolaj Starodubtsev <nstarodubtsev@mirantis.com>
+Nikolay Sobolevskiy <nsobolevsky@mirantis.com>
+Nilesh Bhosale <nilesh.bhosale@in.ibm.com>
+Nirmal Ranganathan <rnirmal@gmail.com>
+Nishant Kumar <nishant.e.kumar@ericsson.com>
+Nitin Madhok <nmadhok@g.clemson.edu>
+Nolwenn Cauchois <nolwenn.cauchois@cloudwatt.com>
+Olga Kopylova <olkonami@gmail.com>
+Olivier Pilotte <opilotte@iweb.com>
+Ollie Leahy <oliver.leahy@hp.com>
+Ollie Leahy <oliver.leahy@hpe.com>
+OmarM <omar.muhtaseb@exalt.ps>
+Ondřej Nový <ondrej.novy@firma.seznam.cz>
+OpenStack Release Bot <infra-root@openstack.org>
+Ory Jonay <ojonay@infinidat.com>
+Ovidiu Poncea <ovidiu.poncea@windriver.com>
+Pablo Caruana <pcaruana@redhat.com>
+Pablo Iranzo Gómez <Pablo.Iranzo@gmail.com>
+Pascal Wehrle <p.wehrle@oodrive.com>
+Patrick East <patrick.east@purestorage.com>
+Paul Mathews <pmathews@bluehost.com>
+Paul McMillan <paul.mcmillan@nebula.com>
+Pavel Boldin <pboldin@mirantis.com>
+Pavel Glushchak <pglushchak@virtuozzo.com>
+Pavel Kirpichyov <pavel.kirpichyov@gmail.com>
+Pawel Kaminski <pawelx.kaminski@intel.com>
+Pedro Navarro Perez <pednape@gmail.com>
+Peng Wang <wangpww@cn.ibm.com>
+Pengfei Zhang <lalasjtu@gmail.com>
+Peter Penchev <openstack-dev@storpool.com>
+Peter Pentchev <openstack-dev@storpool.com>
+Peter Wang <peter.wang13@emc.com>
+Philipp Marek <philipp.marek@linbit.com>
+Pierre-André MOREY <kick@mifamofi.net>
+Pony Chou <ponychou@qnap.com>
+Pradeep Sathasivam <psathasi@brocade.com>
+Pranali Deore <pdeore@redhat.com>
+Pranali Deore <pranali.deore@nttdata.com>
+PranaliD <pdeore@redhat.com>
+PranaliDeore <pranali.deore@nttdata.com>
+PranaliDeore <pranali11.deore@nttdata.com>
+Pádraig Brady <pbrady@redhat.com>
+Qian Gao <gaoqian1983@outlook.com>
+Qian Min Chen <chen.qiaomin@99cloud.net>
+Qin Zhao <chaochin@gmail.com>
+Qiu Yu <unicell@gmail.com>
+Rafael Rivero <rafael@cloudscaling.com>
+Rafael Toschi Chiafarelli <rafael.chiafarelli@fit-tecnologia.org.br>
+Rafi Khardalian <rafi@metacloud.com>
+Rahul Verma <rahul.verma@hp.com>
+Raildo Mascena <raildo@lsd.ufcg.edu.br>
+Rajat Dhasmana <rajatdhasmana@gmail.com>
+Rajesh Tailor <rajesh.tailor@nttdata.com>
+Rakesh H S <rh-s@hp.com>
+Rakesh Jain <rakeshj@us.ibm.com>
+Rakesh Mishra <mishra.rakesh510@gmail.com>
+Ralf Haferkamp <rhafer@suse.de>
+Ramy Asselin <ramy.asselin@hp.com>
+Raunak Kumar <rkumar@nimblestorage.com>
+Ravi Edpuganti <ravi.edpuganti@emc.com>
+Ravi Jethani <ravishekar.jethani@nttdata.com>
+Ravi Shekhar Jethani <ravishekar.jethani@nttdata.com>
+Ray Chen <chenrano2002@gmail.com>
+Ray Chen <oldsharp@163.com>
+Rebecca Finn <rebeccax.fihn@intel.com>
+Rich Hagarty <richard.hagarty@hp.com>
+Richard Hedlind <richard.hedlind@x-io.com>
+Rick Bartra <rb560u@att.com>
+Rick Chen <rick.chen@prophetstor.com>
+Rick Harris <rconradharris@gmail.com>
+Rob Crittenden <rcritten@redhat.com>
+Robert Collins <rbtcollins@hp.com>
+Robert Mizielski <robert.mizielski@cloudwatt.com>
+Rodrigo Barbieri <rodrigo.barbieri@fit-tecnologia.org.br>
+Rodrigo Barbieri <rodrigob@netapp.com>
+Rohan Arora <ra271w@att.com>
+Rohan Kanade <rohan.kanade@nttdata.com>
+Rohit Karajgi <rohit.karajgi@nttdata.com>
+Romain Chantereau <romain.chantereau@enovance.com>
+Romain Hardouin <romain.hardouin@cloudwatt.com>
+Roman Bogorodskiy <rbogorodskiy@mirantis.com>
+Roman Podolyaka <rpodolyaka@mirantis.com>
+Ronald Bradford <ronald.bradford@gmail.com>
+Ronen Kat <ronenkat@il.ibm.com>
+Rongze Zhu <rongze@unitedstack.com>
+Rongze Zhu <zrzhit@gmail.com>
+RongzeZhu <zrzhit@gmail.com>
+Rui Yuan Dou <rydou@fiberhome.com>
+Rushi Agrawal <rushi.agr@gmail.com>
+Rushil Chugh <rushil@netapp.com>
+Russell Bryant <rbryant@redhat.com>
+Ryan LIANG <ryan.liang@emc.com>
+Ryan Liang <ryan.liang@dell.com>
+Ryan Liang <ryan.liang@emc.com>
+Ryan Lucio <rlucio@vmem.com>
+Ryan McNair <rdmcnair@us.ibm.com>
+Ryan Rossiter <rlrossit@us.ibm.com>
+Ryan Selden <ryanx.seldon@intel.com>
+Ryosuke Mizuno <r-mizuno@rs.jp.nec.com>
+Sachi King <nakato@nakato.io>
+Sagar Waghmare <sawaghma@redhat.com>
+Sai Kiran <saikiran@techpatron.co.in>
+Sam Morrison <sorrison@gmail.com>
+Samantha Blanco <samantha.blanco@att.com>
+Samuel Matzek <smatzek@us.ibm.com>
+Sandeep Pawar <sandeep.pawar1@veritas.com>
+Sandeep Yadav <sandyada@redhat.com>
+Santhoshkumar Kolathur <skolathu@brocade.com>
+Sascha Peilicke <saschpe@gmx.de>
+Sascha Peilicke <saschpe@mailbox.org>
+Sascha Peilicke <saschpe@suse.de>
+Sasikanth <sasikanth.eda@in.ibm.com>
+Satish Venkatasubramanian <satish.venkatasubramanian@gmail.com>
+Satyajeet Shahane <satyajeet.shahane@intel.com>
+Saverio Proto <saverio.proto@switch.ch>
+Scott DAngelo <scott.dangelo@hp.com>
+Scott Devoid <devoid@anl.gov>
+Sean Chen <schen@tintri.com>
+Sean Chen <xuchenx@gmail.com>
+Sean Dague <sdague@linux.vnet.ibm.com>
+Sean Dague <sean.dague@samsung.com>
+Sean Dague <sean@dague.net>
+Sean McCully <sean_mccully@yahoo.com>
+Sean McGinnis <sean.mcginnis@gmail.com>
+Sean McGinnis <sean.mcginnis@huawei.com>
+Sean McGinnis <sean_mcginnis@dell.com>
+Sean Roberts <seanrob@yahoo-inc.com>
+Sebastian Jeuk <sjeuk001@gmail.com>
+Seif Lotfy <s.lotfy@telekom.de>
+Seiji Aguchi <seiji.aguchi.tr@hitachi.com>
+Sergey Gotliv <sgotliv@redhat.com>
+Sergey Skripnick <sskripnick@mirantis.com>
+Sergey Vilgelm <sergey@vilgelm.info>
+Sergey Vilgelm <svilgelm@mirantis.com>
+Sergio Cazzolato <sergio.j.cazzolato@intel.com>
+Serhii Rusin <serhii_rusin@jabil.com>
+Shane Wang <shane.wang@intel.com>
+ShangXiao <shangxiaobj@inspur.com>
+Shao Kai Li <lshaokai@cn.ibm.com>
+Shatadru Bandyopadhyay <shatadru1@gmail.com>
+Shay Halsband <Shay.Halsband@emc.com>
+Shay Halsband <shay.halsband@emc.com>
+Sheel Rana <ranasheel2000@gmail.com>
+Shilpa Jagannath <smanjara@redhat.com>
+Shlomi Avihou <shlomi@zadarastorage.com>
+Shlomi Sasson <shlomis@mellanox.com>
+Shuangtai Tian <shuangtai.tian@intel.com>
+Shunei Shiono <s-shiono@ti.jp.nec.com>
+ShunliZhou <slzhou@fiberhome.com>
+Shyama Venugopal <shyvenug@in.ibm.com>
+Silvan Kaiser <silvan@quobyte.com>
+Simon Dodsley <simon@purestorage.com>
+Simon Lorenz <simon.lorenz@de.ibm.com>
+Simon O'Donovan <simon.odonovan@dell.com>
+Sivaramakrishna Garimella <sivaramakrishna.garimella@hp.com>
+Skyler Berg <sberg@tintri.com>
+Slade Baumann <baumann@us.ibm.com>
+Slawek Kaplonski <skaplons@redhat.com>
+Sneha Rai <sneha.rai@hpe.com>
+Soffie Huang <Soffie.Huang@falconstor.com>
+Sofia Enriquez <lsofia.enriquez@gmail.com>
+Sonia Ghanekar <sonia.ghanekar@nimblestorage.com>
+Sorin Sbarnea <ssbarnea@redhat.com>
+Sreedhar Varma <sreedhar.varma.ctr@kaminario.com>
+Stack <vijay.ladani@hpe.com>
+Stefan Amann <stefan.amann@de.ibm.com>
+Stefan Nica <snica@suse.com>
+Stephen Mulcahy <stephen.mulcahy@hp.com>
+Steve Kowalik <steven@wedontsleep.org>
+Steve Noyes <steve.noyes@oracle.com>
+Steven Kaufer <kaufer@us.ibm.com>
+Stuart McLaren <stuart.mclaren@hp.com>
+Stuart McLaren<stuart.mclaren@hpe.com>
+Subramanian Neelakantan <subbu@ubuntu.(none)>
+Subramanian Neelakantan <subramanian.neelakantan@gmail.com>
+Sumit Shatwara <sumit.shatwara@hpe.com>
+Surya Ghatty <ghatty@us.ibm.com>
+Sushil Kumar <sushil.kumar2@globallogic.com>
+Sven Anderson <sven@redhat.com>
+Sven Wegener <sven.wegener@inovex.de>
+Svetlana Shturm <sshturm@mirantis.com>
+Swapnil Kulkarni <swapnilkulkarni2608@gmail.com>
+Swapnil Nilangekar <swapnil.sun.nilangekar@hpe.com>
+Swathi Hrishikesh <swathi@hedviginc.com>
+Sylvain Baubeau <sylvain.baubeau@enovance.com>
+Szymon Borkowski <szymon.borkowski@intel.com>
+Szymon Wroblewski <szymon.wroblewski@intel.com>
+Szymon Wróblewski <szymon.wroblewski@intel.com>
+Tadas Ustinavičius <tadas@ring.lt>
+Takahiro Shida <shida@intellilink.co.jp>
+Takashi Menjo <menjo.takashi@lab.ntt.co.jp>
+Takashi NATSUME <natsume.takashi@lab.ntt.co.jp>
+Takashi Natsume <natsume.takashi@lab.ntt.co.jp>
+Takeaki Matsumoto <takeaki.matsumoto@ntt.com>
+Takeshi Nishikawa <takeshi.nishikawa.zf@hitachi.com>
+Tao Bai <baitaosh@cn.ibm.com>
+TaoBai <baitaosh@cn.ibm.com>
+Teruaki Ishizaki <ishizaki.teruaki@lab.ntt.co.jp>
+Thang Pham <thang.g.pham@gmail.com>
+Thelo Gaultier <thelo.gaultier@gmail.com>
+Thiago Correa <thiagoc@netapp.com>
+Thierry Carrez <thierry@openstack.org>
+Thomas Bechtold <tbechtold@suse.com>
+Thomas Bechtold <thomasbechtold@jpberlin.de>
+Thomas Goirand <zigo@debian.org>
+Tiago Pasqualini <tiagop.silva@fit-tecnologia.org.br>
+Tim Clark <timothygclark@gmail.com>
+Timothy Okwii <tokwii@cisco.com>
+Tin Lam <tl3438@att.com>
+Tina <tina.tang@emc.com>
+Tina Tang <tina.tang@emc.com>
+Tingting Zha <zhatt.fnst@cn.fujitsu.com>
+Tobias Urdin <tobias@busybox.se>
+Tom Barron <tbarron@dyncloud.net>
+Tom Barron <tbarron@netapp.com>
+Tom Barron <tpb@dyncloud.net>
+Tom Cammann <tom.cammann@hp.com>
+Tom Fifield <fifieldt@unimelb.edu.au>
+Tom Fifield <tom@openstack.org>
+Tom Hancock <tom.hancock@hp.com>
+Tom Patzig <tom.patzig@sap.com>
+Tom Swanson <tom_swanson@dell.com>
+Tomas Hancock <tom.hancock@hp.com>
+TommyLike <tommylikehu@gmail.com>
+Tomoki Sekiyama <tomoki.sekiyama.qu@hitachi.com>
+Tomoki Sekiyama <tomoki.sekiyama@hds.com>
+Tony Breeds <tony@bakeyournoodle.com>
+Tony Xu <hhktony@gmail.com>
+Tovin Seven <vinhnt@vn.fujitsu.com>
+Tristan Cacqueray <tristan.cacqueray@enovance.com>
+Trung Trinh <trung.t.trinh@dektech.com.au>
+Tzur Eliyahu <tzure@il.ibm.com>
+TzurEliyahu <tzure@il.ibm.com>
+Unana Okpoyo <unana.okpoyo@emc.com>
+Unmesh Gurjar <unmesh.gurjar@hp.com>
+Unmesh Gurjar <unmesh.gurjar@vertex.co.in>
+Vadim Kryvian <vadimk@il.ibm.com>
+Vahid Hashemian <vahidhashemian@us.ibm.com>
+Valeriy Ponomaryov <vponomaryov@mirantis.com>
+Van Hung Pham <hungpv@vn.fujitsu.com>
+Vasanthi Thirumalai <vthirumalai@vmem.com>
+Vasyl Khomenko <vasiliyk@yahoo-inc.com>
+Venkata Krishna <Venkata.Krishna.ctr@kaminario.com>
+VenkataKrishna Reddy <Venkata.Krishna.ctr@kaminario.com>
+Veronica Musso <veronica.a.musso@intel.com>
+Victor A. Ying <victor.ying@purestorage.com>
+Victor Rodionov <vito.ordaz@gmail.com>
+Victor Sergeyev <vsergeyev@mirantis.com>
+Victor Stinner <vstinner@redhat.com>
+Victoria Martinez de la Cruz <victoria@redhat.com>
+Vijay Ladani <vijay.ladani@hpe.com>
+Vilobh Meshram <vilobhmm@yahoo-inc.com>
+Vincent Hou <sbhou@cn.ibm.com>
+Vincent Hou <shou@us.ibm.com>
+Vipin Balachandran <vbala@vmware.com>
+Viraj Hardikar <viraj.hardikar@hp.com>
+Vishakha Agarwal <agarwalvishakha18@gmail.com>
+Vishvananda Ishaya <vishvananda@gmail.com>
+Vivek Agrawal <vivek.agrawal@veritas.com>
+Vivek Dhayaal <vivekdhayaal@gmail.com>
+Vivek Soni <vivek.soni@hpe.com>
+Vivek Soni <viveksoni31390@gmail.com>
+Vlad Gusev <vlad.esten@gmail.com>
+Vladimir Popovski <vladimir@zadarastorage.com>
+Vladislav Kuzmin <vkuzmin@mirantis.com>
+Vu Cong Tuan <tuanvc@vn.fujitsu.com>
+Walter A. Boring IV <waboring@hemna.com>
+Walter A. Boring IV <walter.boring@hp.com>
+Walter A. Boring IV <walter.boring@hpe.com>
+Wenhao Xu <wenhao@zelin.io>
+Wenhao Xu <xuwenhao2008@gmail.com>
+Wenjun Wang <wenjun_dev@163.com>
+WenjunWang1992 <10191230@zte.com.cn>
+William Durairaj <william.dur.sandanaraj@hpe.com>
+Wilson Liu <liuxinguo@huawei.com>
+Woojay Poynter <woojay@linbit.com>
+Wu Wenxiang <wu.wenxiang@99cloud.net>
+Xavier Queralt <xqueralt@redhat.com>
+Xi Yang <xi.yang@emc.com>
+Xi Yang <yang.xi@99cloud.net>
+Xiangfei Zhu <xiangfeiz@vmware.com>
+Xiao Chen <chenxiao@cn.ibm.com>
+Xiaojun Liao <xiaojunliao85@gmail.com>
+Xiaoqin Li <lixqin@cn.ibm.com>
+Xiaoqin Li <xiaoqin.li@hotmail.com>
+XieYingYun <smokony@sina.com>
+XinXiaohui <xiaohui.xin@intel.com>
+Xing Yang <xing.yang@emc.com>
+Xing Yang <xyang@alum.mit.edu>
+Xing Zhang <angeiv.zhang@gmail.com>
+Xingchao Yu <xingchao@unitedstack.com>
+Xinli Guan <xinli@us.ibm.com>
+Xinyuan Huang <xinyuahu@cisco.com>
+Xu Ao <xuao@awcloud.com>
+Xuchu Jiang <xcjiang@cn.ibm.com>
+XueChendi <chendi.xue@intel.com>
+YAMADA Hideki <yamada.hideki@lab.ntt.co.jp>
+Yaguang Tang <heut2008@gmail.com>
+Yaguang Tang <yaguang.tang@canonical.com>
+Yaguang Tang <ytang@mirantis.com>
+Yaguo Zhou <zhouyaguo@gmail.com>
+YanLin Ren <renylin@cn.ibm.com>
+Yang Youseok <ileixe@gmail.com>
+Yang Yu <yuyangbj@cn.ibm.com>
+YangLei <yanglyy@cn.ibm.com>
+Yasuaki Nagata <yasuaki.nagata@intellilink.co.jp>
+YasunoriMaruyama <y-maruyama@tsh-world.co.jp>
+Yejia Xu <yejia@unitedstack.com>
+Yi Chun, Huang <hychuang@cn.ibm.com>
+Yikun Jiang <yikunkero@gmail.com>
+Yingxin <yingxin.cheng@intel.com>
+Yong Huang <yong.huang@emc.com>
+Yosef Berman <yosef@cloudscaling.com>
+Yoshihide Matsumoto <matsumoto333@gmail.com>
+Yu Shengzuo <yu.shengzuo@99cloud.net>
+Yu Zhang <shzyu@cn.ibm.com>
+YuanHui Xu <xuyhuish@cn.ibm.com>
+Yucong Feng <yfeng@us.ibm.com>
+Yug Suo <yugsuo@gmail.com>
+Yuiko Takada <takada-yuiko@mxn.nes.nec.co.jp>
+Yuji Hagiwara <hagiwarayuj@nttdata.co.jp>
+Yuki Kasahara <kasahara.yuki@po.ntts.co.jp>
+Yukihiro KAWADA <warp.kawada@gmail.com>
+Yun Mao <yunmao@gmail.com>
+Yuriy Nesenenko <ynesenenko@mirantis.com>
+Yuriy Taraday <yorik.sar@gmail.com>
+Yuriy Zveryanskyy <yzveryanskyy@mirantis.com>
+Yury Kulazhenkov <yury.kulazhenkov@dell.com>
+Yury Kulazhenkov <yury.kulazhenkov@emc.com>
+Yusuke Hayashi <hayashi-yusuke@jp.fujitsu.com>
+Yuzlikeev Eduard <eyuzlikeev@mirantis.com>
+Zhang Jinnan <zhang.jinnan@99cloud.net>
+ZhangHongtao <zhanghongtao0826@126.com>
+Zhao Liqiang <zhaoliqiang@cmss.chinamobile.com>
+Zhengguang--reset-author <zhengguangou@gmail.com>
+Zhenguo Niu <Niu.ZGlinux@gmail.com>
+Zhi Kun Liu <zhikunli@cn.ibm.com>
+Zhi Yan Liu <zhiyanl@cn.ibm.com>
+ZhiQiang Fan <aji.zqfan@gmail.com>
+Zhihai Song <zhihai.song@easystack.cn>
+Zhiteng Huang <zhiteng.huang@intel.com>
+Zhiteng Huang <zhithuang@ebay.com>
+Zhiteng Huang <zhithuang@ebaysf.com>
+ZhongShengping <chdzsp@163.com>
+Zhongyue Luo <lzyeval@gmail.com>
+Zhongyue Luo <zhongyue.nah@intel.com>
+ZhuRongze <zrzhit@gmail.com>
+Zohar Mamedov <zohar.mamedov@nexenta.com>
+Zoltan Arnold Nagy <nag@zurich.ibm.com>
+abhiram moturi <abhiram.moturi@oracle.com>
+abhiram_moturi <abhiram.moturi@oracle.com>
+abhishekkekane <abhishek.kekane@nttdata.com>
+aimee.ukasick <au7569@att.com>
+albertjone <guanalbertjone@gmail.com>
+alexey-mr <alexey.morlang@gmail.com>
+alonma <alonma@il.ibm.com>
+amoturi <abhiram.moturi@oracle.com>
+anastasia-karpinska <akarpinska@griddynamics.com>
+ankitagrawal <ankit11.agrawal@nttdata.com>
+annegentle <anne@openstack.org>
+anthony.bellino <ab2434@att.com>
+apoorvad <apps.desh@gmail.com>
+appsdesh <apps.desh@gmail.com>
+april <xiaolixu@cn.ibm.com>
+arsenc <arsenc@synology.com>
+ashish.billore <ashish.billore@gmail.com>
+bailinzhang <zhang.bailin@zte.com.cn>
+baiwenteng <baiwenteng@inspur.com>
+bhagyashris <bhagyashri.shewale@nttdata.com>
+binean <ting.wang@easystack.cn>
+caixiaoyu <caixiaoyu@cmss.chinamobile.com>
+caoyuan <cao.yuan@99cloud.net>
+caoyue <yue.cao@easystack.cn>
+chadlung <chad.lung@gmail.com>
+chaochin <chaochin@zhaoqin-RHEL-GPFS1.(none)>
+chenaidong1 <chen.aidong@zte.com.cn>
+cheneydc <dongc@neunn.com>
+chenhb <chen.haibing1@zte.com.cn>
+chenxiangui <chenxiangui@inspur.com>
+chenxing <chen.xing@99cloud.net>
+chenying <ying.chen@huawei.com>
+chenzongliang <chenzongliang@huawei.com>
+chhagarw <chhagarw@in.ibm.com>
+chiehhsuny <chiehhsuny@synology.com>
+clayg <clay.gerrard@gmail.com>
+daisy-ycguo <daisy.ycguo@gmail.com>
+dhinesh <dhinesh@hedviginc.com>
+diem_tran <diem.tran@oracle.com>
+digvijay2016 <digvijay.ukirde@in.ibm.com>
+dineshbhor <dinesh.bhor@nttdata.com>
+dongdongpei <peidongdong121@163.com>
+doubletao <futaotao@huawei.com>
+eduardBM <cubusbacau@yahoo.com>
+enriquetaso <lsofia.enriquez@gmail.com>
+erikzaadi <erik.zaadi@gmail.com>
+felix23ma <felix23ma@gmail.com>
+fpxie <fpxie@fiberhome.com>
+fujioka yuuichi <fujioka-yuuichi@zx.mxh.nes.nec.co.jp>
+futaotao <futaotao@huawei.com>
+fuzk <fuzk@inspur.com>
+galstrom21 <jshepher@rackspace.com>
+gaofei <gao.fei@inspur.com>
+gengchc2 <geng.changcai2@zte.com.cn>
+gfm <gfm@us.ibm.com>
+gh159m <gh159m@att.com>
+ghanshyam <ghanshyammann@gmail.com>
+ghanshyam <gmann@ghanshyammann.com>
+git-harry <git-harry@live.co.uk>
+gtt116 <gtt116@gmail.com>
+guangpei.liu <guangpei.liu@easystack.cn>
+haixin <haixin@inspur.com>
+hallur, parashuram <parashuram.hallur@emc.com>
+hanchl <1922361860@qq.com>
+haobing1 <hao.bing1@zte.com.cn>
+hgangwx <hgangwx@cn.ibm.com>
+honjo-rikimaru-c6 <honjo.rikimaru@po.ntts.co.jp>
+howardlee <lihongweibj@inspur.com>
+huananhuawei <huanan@huawei.com>
+huangtianhua <huangtianhua@huawei.com>
+hussainchachuliya <hussain.chachuliya@nttdata.com>
+huyang <huyang1@huawei.com>
+iain MacDonnell <iain.macdonnell@oracle.com>
+iberezovskiy <iberezovskiy@mirantis.com>
+imacdonn <iain.macdonnell@oracle.com>
+inspurericzhang <zhanglf01@inspur.com>
+int32bit <krystism@gmail.com>
+iswarya_vakati <v.iswarya@nectechnologies.in>
+ivyzhang <shzyu@cn.ibm.com>
+j-griffith <john.griffith8@gmail.com>
+jakedahn <jake@ansolabs.com>
+jarbassaidai <jay.rubenstein@netapp.com>
+jbrogan <jbrogan@ebaysf.com>
+jenny-shieh <jenny.shieh@hp.com>
+jeremy.jia <jiapei2@lenovo.com>
+jeremy.zhang <zhangjun_inspur@163.com>
+jessewu <jessewu@synology.com>
+jiamin <shljia@cn.ibm.com>
+jianghua wang <jianghua.wang@citrix.com>
+jiansong <jian.song@easystack.cn>
+jiaohaolin <jiaohaolin@inspur.com>
+jking-6 <jking@internap.com>
+john-griffith <john.griffith@solidfire.com>
+john.griffith8@gmail.com <john.griffith8@gmail.com>
+jolie <guoshan@awcloud.com>
+jun xie <junxiebj@cn.ibm.com>
+junboli <junbo85.li@gmail.com>
+kan kato <kato.kan@jp.fujitsu.com>
+kedar-vidvans <kedar.vidvans@oracle.com>
+keystone <keystone@ubuntu.(none)>
+keystone <mikhail.khodos@nexenta.com>
+kongwei <kong.wei2@zte.com.cn>
+kongxiangyun <kongxyxian2010@163.com>
+kshimamu <kshimamu@cisco.com>
+kushal <kushal.wathore@hpe.com>
+lakshman <Lakshmi.Narayana.ctr@kaminario.com>
+leiyashuai <leiyashuai@inspur.com>
+leseb <sebastien.han@enovance.com>
+lg.yue <yuelongguang@letv.com>
+liangjingtao <liang.jingtao@zte.com.cn>
+lihaijing <lihaijing@fiberhome.com>
+lijing <lijing@gohighsec.com>
+lijunbo <lijunbo@fiberhome.com>
+lijunjie <lijunjie@cloudin.cn>
+lijunli1 <lijunli@chinac.com>
+limin0801 <limin.lc@inspur.com>
+ling-yun <zengyunling@huawei.com>
+lirenke <lvhancy@163.com>
+lisali <xiaoyan.li@intel.com>
+liu-sheng <liusheng@huawei.com>
+liucheng <liucheng20@huawei.com>
+liudong <liudong78@huawei.com>
+liujiong <liujiong@gohighsec.com>
+liuke2 <liuke2@huawei.com>
+liuqing <jing.liuqing@99cloud.net>
+liusheng <liusheng@huawei.com>
+liushuobj <liushuobj@inspur.com>
+liusu <liusu@chinac.com>
+liuxichao <tangmeiyan77@gmail.com>
+liuxinguo <liuxinguo@huawei.com>
+liuyamin <liuyamin@fiberhome.com>
+lixiaoy1 <xiaoyan.li@intel.com>
+liyingjun <liyingjun1988@gmail.com>
+liyingjun <yingjun.li@kylin-cloud.com>
+liyuanyuan <liyuanyuan.fnst@cn.fujitsu.com>
+lkuchlan <lkuchlan@redhat.com>
+llg8212 <lilinguo@huawei.com>
+lol <821328772@qq.com>
+loooosy <syluo5695@fiberhome.com>
+lrqrun <lrqrun@gmail.com>
+ls1175 <liusheng@huawei.com>
+luqitao <qtlu@fiberhome.com>
+lvdongbing <dongbing.lv@kylin-cloud.com>
+maaoyu <maaoyu@inspur.com>
+malei <ma.lei@99cloud.net>
+manishd <deolalkar.manish@hpe.com>
+mannuray <mannu.ray@gmail.com>
+maoshuai <fwsakura@163.com>
+marcusvrn <marcus.nascimento@fit-tecnologia.org.br>
+masahiro ikeda <ikedamsh@nttdata.co.jp>
+mattanShalev <mattan@reduxio.com>
+mayurindalkar <mayur.indalkar@veritas.com>
+melissaml <ma.lei@99cloud.net>
+michael-mcaleer <Michael.Mcaleer@dell.com>
+michael-mcaleer <michael.mcaleer@dell.com>
+mikhail <mikhail.khodos@nexenta.com>
+mouad benchchaoui <m.benchchaoui@cloudbau.de>
+neochin <jiangliucheng@huawei.com>
+nidhimittalhada <nidhimittal19@gmail.com>
+nikeshm <Nikesh.Mahalaka@dothill.com>
+nikeshmahalka <Nikesh.Mahalka@emulex.com>
+ningwei <jxxiaohou331500@yeah.net>
+nirajsingh <niraj.singh@nttdata.com>
+nuritv <nuritv@mellanox.com>
+odonos12 <simon.odonovan@dell.com>
+oorgeron <octave.orgeron@oracle.com>
+openstack <neha.alhat@nttdata.com>
+pallavi <pallavi.s@nectechnologies.in>
+pangliye <pangliye@inspur.com>
+pawnesh.kumar <pawnesh.kumar@nectechnologies.in>
+pengyuesheng <pengyuesheng@gohighsec.com>
+peter_wang <peter.wang13@emc.com>
+peter_wang <wangxu198709@gmail.com>
+phenom <phenoxim@gmail.com>
+pooja jadhav <pooja.jadhav@nttdata.com>
+poojajadhav <pooja.jadhav@nttdata.com>
+pran1990 <praneshpg@gmail.com>
+prashkre <prashkre@in.ibm.com>
+rackerjoe <breu@breu.org>
+raghavendrat <raghavendra.tilay@hpe.com>
+rajinir <rajini.karthik@dell.com>
+rajinir <rajini_ram@dell.com>
+ramakris <rama.kri.b@hp.com>
+rick.chen <rick.chen@prophetstor.com>
+root <daniel.tadrzak@intel.com>
+root <ranasheel2000@gmail.com>
+root <root@lhx-ceph-1.novalocal>
+root <root@localhost.localdomain>
+ruichen <kiwik.chenrui@huawei.com>
+sanuptpm <sanuptpm@gmail.com>
+sarat inuguri <saratinuguri@gmail.com>
+sarat inuguri <saratkumar_ivn@symantec.com>
+sathish-nagappan <sathish.nagappan@nebula.com>
+saurabh <saurabh.chordiya@nectechnologies.in>
+savihou <shlomi@zadarastorage.com>
+scott-dangelo <scott.dangelo@hp.com>
+scottda <scott.dangelo@hp.com>
+scottda <scott.dangelo@hpe.com>
+scottda <scott.dangelo@ibm.com>
+sdodsley <simon@purestorage.com>
+shangxiaobj <shangxiaobj@inspur.com>
+shanks.yang <yang.hao@inspur.com>
+shaoxj <shaoxj@inspur.com>
+shihanzhang <shihanzhang@huawei.com>
+skudriashev <skudriashev@griddynamics.com>
+smartu3 <zzj123389602@gmail.com>
+sparkliu <spark.liu@cn.ibm.com>
+srushti <srushti.gadadare@nttdata.com>
+stack <kushal.wathore@hpe.com>
+stack <sumit.shatwara@hpe.com>
+stack <vijay.ladani@hpe.com>
+stack <yixuan_z@hotmail.com>
+suguangfeng <suguangfeng@inspur.com>
+sumit7990 <sumit.shatwara@hpe.com>
+sunyandi <sunyd@inspur.com>
+swapnil-nilangekar <swapnil.sun.nilangekar@hpe.com>
+tanlin <lin.tan@intel.com>
+taylorh <taylorh@synology.com>
+tianhui <tianhui@awcloud.com>
+tkauthar <tejdeep.kautharam@intel.com>
+tonybrad <zhangyuan1@chinaunicom.cn>
+tpsilva <tiago.pasqualini@gmail.com>
+tsekiyam <tsekiyam@dhcp47-227.lab.bos.redhat.com>
+tswanson <tswanson@compellent.com>
+ubaumann <openstack@m.ubaumann.ch>
+unicell <unicell@gmail.com>
+ustcdylan <liujunwei@chinamobile.com>
+venkatamahesh <venkatamaheshkotha@gmail.com>
+vinita <Vinita.Deshpande@emc.com>
+vitas.yuzhou <vitas.yuzhou@huawei.com>
+vrushti <vrushtidhola25@gmail.com>
+walmart <yatinkumbhare@gmail.com>
+wang yong <wangyong2017@inspur.com>
+wang yong <yongwc@yeah.net>
+wangfaxin <wangfaxin@inspur.com>
+wanghao <sxmatch1986@gmail.com>
+wanghao <wanghao749@huawei.com>
+wanghong <w.wanghong@huawei.com>
+wanghongtaozz <wanghongtaozz@inspur.com>
+wanghongxu <wang19930902@gmail.com>
+wanghui <wang_hui@inspur.com>
+wangpeng <wangpww@cn.ibm.com>
+wangqi <wang.qi@99cloud.net>
+wangqiangbj <wangqiangbj@inspur.com>
+wangwei <wangwei@navercorp.com>
+wangxiyuan <wangxiyuan1007@gmail.com>
+wangxiyuan <wangxiyuan@huawei.com>
+wangzhenyu <wangzy@fiberhome.com>
+whoami-rajat <rajatdhasmana@gmail.com>
+wingwj <wingwj@gmail.com>
+wuchongyao <wuchongyao@outlook.com>
+wuyuting <wytdahu@gmail.com>
+xgwang5843 <xgwang5843@fiberhome.com>
+xianming mao <xianming.mao@easystack.cn>
+xiaolei hu <xlhu@cn.ibm.com>
+xiaoxi_chen <xiaoxi.chen@intel.com>
+xiexs <xiexs@cn.fujitsu.com>
+xing-yang <xing.yang@emc.com>
+xing-yang <xyang@alum.mit.edu>
+xqli-openstack <xiaoqin.li@hotmail.com>
+xuleibj <xuleibj@inspur.com>
+yanghuichan <yanghc@fiberhome.com>
+yanjun.fu <yanjun.fu@easystack.cn>
+yatin karel <yatin.karel@nectechnologies.in>
+yehia-beyh <yehia.beyh@hp.com>
+yenai <yenai@cmss.chinamobile.com>
+yfzhao <dsware@126.com>
+yfzhao <zhaoyunfeng@fiberhome.com>
+yixuan <yixuan_z@hotmail.com>
+yixuan.zhang <yixuan_z@hotmail.com>
+yixuanzhang <yixuan_z@hotmail.com>
+yoan desbordes <desbor_y@etna-alternance.net>
+yogesh <ykshirsa@netapp.com>
+yogeshprasad <yogesh.prasad@cloudbyte.com>
+yuanyue <yyuanyuee@163.com>
+yuc <yu.shengzuo@99cloud.net>
+yuhui_inspur <yuhui@inspur.com>
+yuriy_n <ynesenenko@mirantis.com>
+yuyafei <yu.yafei@zte.com.cn>
+zejian Zhuang <zzj123389602@gmail.com>
+zeng jia <zengjia@awcloud.com>
+zengyingzhe <zengyingzhe@huawei.com>
+zhang.lei <zhang.lei@99cloud.net>
+zhangbailin <zhangbailin@inspur.com>
+zhangchao010 <zhangchao010@huawei.com>
+zhangchunlong1@huawei.com <zhangchunlong1@huawei.com>
+zhangdaolong <zhangdaolong@fiberhome.com>
+zhangdebo1987 <zhangdebo@inspur.com>
+zhangguoqing <zhang.guoqing@99cloud.net>
+zhangni <zhangni@huawei.com>
+zhangsong <zhangsong@cmss.chinamobile.com>
+zhangxiaohan <zmj1981123@163.com>
+zhangyang <zhangyang1@chinatelecom.cn>
+zhangyanxian <zhang.yanxian@zte.com.cn>
+zhangyanzi <zhangyanzi@huawei.com>
+zhangyi <yi.zhang@easystack.cn>
+zhaochy <zhaochy@cn.ibm.com>
+zhaohua <zhaohua.zhao@huawei.com>
+zhaoleilc <15247232416@163.com>
+zhaoqin <chaochin@gmail.com>
+zheng yin <yin.zheng@easystack.cn>
+zhengyao1 <zheng.yao1@zte.com.cn>
+zhongjun <jun.zhongjun@huawei.com>
+zhouxinyong <zhouxinyong@inspur.com>
+zhu.boxiang <zhu.boxiang@99cloud.net>
+zhu.fanglei <zhu.fanglei@zte.com.cn>
+zhu.rong <zhu.rong@99cloud.net>
+zhubx007 <zhu.boxiang@99cloud.net>
+zhufl <zhu.fanglei@zte.com.cn>
+zhulingjie <easyzlj@gmail.com>
+zhurong <aaronzhu1121@gmail.com>
+zhuzhubj <zhuzhubj@cn.ibm.com>
diff -pruN 2:15.0.1-1/bindep.txt 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/bindep.txt
--- 2:15.0.1-1/bindep.txt	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/bindep.txt	2020-03-24 18:46:31.000000000 +0000
@@ -34,3 +34,5 @@ thin-provisioning-tools [platform:debian
 libxml2-dev [platform:dpkg test]
 libxslt-devel [platform:rpm test]
 libxslt1-dev [platform:dpkg test]
+cryptsetup [platform:rpm]
+cryptsetup-bin [platform:dpkg]
diff -pruN 2:15.0.1-1/ChangeLog 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/ChangeLog
--- 2:15.0.1-1/ChangeLog	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/ChangeLog	2020-03-24 18:46:35.000000000 +0000
@@ -0,0 +1,9533 @@
+CHANGES
+=======
+
+* Update weekly meeting location
+* Imported Translations from Zanata
+* Imported Translations from Zanata
+* PowerMax Driver - SRDF Enhancement
+* [Unity] Fix TypeError for test case test\_delete\_host\_wo\_lock
+* QNAP: Fix login on Python3
+* Update the title of Inspur G2 storage driver
+* PowerMax Driver - Safeguarding retype to some in-use replicated modes
+* RBD: fix volume reference handling in clone logic
+* Tests: Remove Python 2 compat file\_spec code
+* Make cinder-plugin-ceph-tempest job voting
+* Update in-tree Datera Cinder driver
+* Fix DriverFilter string evaluations
+* Ussuri contrib docs community goal
+* PowerMax Driver - Print extend volume info
+* Imported Translations from Zanata
+* Mark Huawei Fusionstorage Driver Supported
+* ChunkedBackupDriver: Freeing memory on restore
+* Revert "Remove Huawei FusionStorage Driver"
+* Support to query volume filter by updated\_at/created\_at
+* Cinder backup export broken
+* PowerMax Driver - Short host name and port group name override
+* Create backups via scheduler
+* Imported Translations from Zanata
+* Run cinder-plugin-ceph-tempest on py3
+* Add new license scheme for Flashsystem9000 series
+
+16.0.0.0b1
+----------
+
+* Tell reno to ignore the kilo branch
+* Install all requirements in docs builds
+* Change path to query in cinderAPI V3-volume delete
+* 3PAR: Revert flag for Active/Active High Availability Support
+* Fix stestr command error in doc
+* Seagate driver: Add Basic auth header when logging in via HTTPS
+* Support volume transfer \`name\` filters
+* PowerMax Driver - Get Manageable Volumes Fix
+* Fix volume unit test
+* NEC driver: fix migrate/retype an in-use volume
+* Update driver removal policy
+* Update reviewing doc with py3 usage guidelines
+* Add cryptsetup to bindep.txt
+* Skip cryptsetup password quality checking
+* Remove Dell EMC PS Series Driver
+* Configurable timeout of the QEMU img conversion
+* Handle retries in PowerMax unit tests
+* Add migration to make volume\_type\_id non nullable
+* Refactor README links
+* Support multiple stores of Glance
+* Add upgrade check for removed Veritas Access driver
+* RBD: catch argument exceptions when configuring multiattach
+* Bump paramiko requirement
+* Tests: hacking check tweaks
+* Hacking: Remove C304 check for LOG.audit
+* Update oslo.vmware version
+* Fix an issue in storwize unit test case
+* Mark MacroSAN Driver Unsupported
+* PowerMax Driver - Unisphere storage group/array tagging support
+* Add upgrade check for removed VZStorage driver
+* PowerMax Driver - RDF clean snapvx target fix
+* Remove the Veritas Access Driver
+* Mark Veritas CNFS Driver Unsupported
+* Remove the Virtuozzo Storage Driver
+* Make volume soft delete more thorough
+* Remove hacking check N325
+* Add note that block-box is not supported
+* Enable flake8-logging-format extension
+* Clean up test requirements
+* Mark IET target driver deprecated
+* Imported Translations from Zanata
+* Fujitsu Driver: Change the calculation of TPP's capacity
+* Pure Storage - remove six due to Py2 support dropped
+* Fix: Create new cache entry when xtremio reaches snap limit
+* Update release notes for ibm storage
+* Introduce flake8-import-order extension
+* Huawei Cinder Driver Support Dorado V6 Storage.(iSCSI, FC)
+* Fix duplicated words issue like " should should "
+* Add missing parameters in log messages
+* Drop requirements for unsupported python versions
+* Raise hacking version to 2.0.0
+* api-ref: give an example of volume['attachments']
+* Fix trivial typo in comment
+* Fix KeyError exception when volume filter file does not exist
+* Correct typos
+* Doc: update storwize cinder driver configuration guide
+* Remove unused exception catch in revert
+* Add upgrade check for removed Sheepdog driver
+* Add upgrade check for removed Nimble driver
+* Add upgrade check for removed ProphetStor driver
+* Add upgrade check for removed Huawei driver
+* Remove Sheepdog Driver
+* Remove Nimble Storage Driver
+* Remove ProphetStor Flexvisor Driver
+* PowerMax Docs -  corrections and improvements
+* doc: clarify usage of use\_multipath\_for\_image\_xfer parameter
+* Remove Huawei FusionStorage Driver
+* doc: fixes typo in multi backend configration doc
+* Update the community page
+* Fix: failed to create snapshot with DriverFilter
+* Fixed open tempfile.NamedTemporaryFile as text in Python3
+* StorPool: move the config to the shared group
+* Move cinder grenade job to py3 and in cinder repo
+* Mark Brocade FC ZM driver unsupported
+* DS8k Cinder Driver support Python3
+* Elaborate on terminate\_connection documentation
+* Publish backup capabilities to a scheduler
+* Readd reno to test-requirements
+* Removed unnecessary lines
+* Mark storwize driver supported
+* Fix pylint E1101 and E1135 issue
+* Remove Python 2 support from testing and gate jobs
+* PowerMax Driver - retype attached replication fix
+* PowerMax Driver - Volume group delete failure
+* PowerMax Driver - Unmanage Snapshot Delete Fix
+* Tests: Isolate rbd deferred deletion tests
+* Tests: Remove unused rbd mock\_driver\_configuration
+* Start README.rst with a better title
+* PowerMax Driver - Setting minimum Unisphere version to 9.1.0.5
+* Imported Translations from Zanata
+* Modify help for update host command
+* Drop old neutron-grenade job
+* Fix tox 'bindep' environment
+* Convert PrettyTable usage to tabulate
+* remotefs: remove invalid "external" arg on lock method
+* RemoteFS: Use dest vol id instead of source id in snapshot temp name
+* Fix remotefs clone volume locking
+* Remove unnecessary saving of host and availability\_zone
+* Remove py2 mentions from contributor docs
+* SPDK drivers: Update RPC calls to match latest SPDK changes
+* NEC driver: fix a non-disruptive backup error
+* Use volume utils to clone encryption
+* Change the RPC parameter
+* Pure Storage - bump version numbers for Ussuri
+* iSCSI driver initialization should fail for Primera backend
+* Fix "is"/"is not" with a literal usage
+* update review site link
+* Deprecate rbd\_keyring\_conf option
+* NEC driver: fix an undefined variable
+* Pure Storage - Fix disconnect error in clustered environments
+* Increase cpu limit for image conversion
+* Fujitsu Driver: Multiple pools support
+* Reserve migrations for DB backports
+* PowerMax Driver - QoS calculation failure
+* NEC driver: replace deprecated xml library
+* Fix VxFlexOS documentation
+* Remove Oracle ZFSSA drivers
+* 3PAR: Add HPE Primera related information
+* [Trivial] Adjust log message and add missing ws between words
+* Fix source link
+* docs: update cinder system architecture page
+* Switch to opensuse-15 nodeset
+* Add volume type name and description check when update volume type
+* Switch to official Ussuri jobs
+* Remove unreferenced document table and image files
+* Remove warning that docs are auto generated
+* Add reference to LP bug in configuration doc readme
+* Remove duplicate lines in netapp driver documentation
+* Imported Translations from Zanata
+* NetApp SolidFire: Add options for replication mode
+* PowerMax Driver - ODE Capabilities Fix
+* LINSTOR driver update for LINSTOR v0.9.12 with REST API
+* Pure: Ensure generated volume name does not exceed 63 characters
+* NEC Driver : Code Refactoring
+* Tests: Fix retype unit test InvalidUUID warning
+* Fix: Online migrations for untyped volumes/snapshots
+* Automate generation of quotas api-ref samples
+* 3PAR: For Peer Persistence, add policy options in RCG
+* Automate generation of qos specs api-ref samples
+* Update master for stable/train
+
+15.0.0.0rc1
+-----------
+
+* NetApp SolidFire: Fix replication
+* PowerMax Docs -  Short host and port group name changes
+* Port check\_exec.py to Python 3
+* PowerMax Docs -  New features and supported software
+* Add "service token" documentation
+* Releasenote followup: Untyped to default volume type
+* PowerMax Driver - Volume Retype Replication fix
+* PowerMax Driver - Metro Volume Metadata change
+* Add "deletion policy" property to uploaded images
+* NEC Driver: Storage assist retype and a bugfix
+* Add doc page for accelerate image compression
+* Fix missing print format in log messages
+* HPE 3PAR: Updated supported operations for multiattach feature
+* Make sure stale image metadata is not used
+* PowerMax Driver - Unisphere version check
+* PowerMax Driver - Debug Metadata Fix
+* Untyped to Default Volume Type
+* NEC Driver: Support revert to snapshot
+* Move the constants to constants.py (for Fujitsu driver)
+* Unity: Add replication support
+* Delete unused key when rekeying volume
+* Leverage hw accelerator in image compression
+* Move hacking checks to tests dir
+* Fix pylint env for ancient versions of git
+* Tests: Fix test\_volume.py import ordering
+* Rekey volume on clone
+* 3PAR: Add Peer Persistence support
+* Denote max microversion for Train
+* Bump pylint to 2.3.0
+* Pylint: use -j 0 arg
+* target/spdknvmf: Add max\_queue\_depth configuration parameter
+* NEC Driver: allow more than 4 iSCSI portals
+* Zadara VPSA: Move to API access key authentication
+* Fix up test\_snapshot notify tests
+* Continue renaming of volume\_utils (drivers)
+* Continue renaming volume\_utils (core)
+* Rename volume/utils.py to volume/volume\_utils.py
+* NEC Driver: Support multi-attach
+* Address reno nit for ZFSSA deprecation
+* StorPool: update the driver requirements
+* Mark the StorPool driver as supported again
+* Advertise some of the StorPool driver's capabilities
+* Mark HPE LeftHand driver as unsupported
+* Mark Virtuozzo Driver Unsupported
+* Fix online data migrations
+* Blacklist eventlet 0.25.0
+* PowerMax Driver - Revert to Snapshot Fix
+* Fix potential NameError of rc\_id
+* Google backup: correct string encoding between py 2 and 3
+* Mark Huawei Fusionstorage Driver Unsupported
+* Change PDF file name
+* [api-ref]Host name is not necessary to contain '@'
+* Mark IBM GPFS Driver Unsupported
+* Unsupport IBM DS8k and XIV Drivers
+* Mark Oracle ZFSSA Drivers Unsupported
+* nova: use EndpointNotFound from keystoneauth1
+* Synology: Fix driver to be compatible with python3
+* Added information how to use JsonFilter
+* PowerMax Driver - Volume & Snapshot Metadata
+* PowerMax driver - check cylinder count of source and target volumes
+* PowerMax Driver - SnapVX NoCopy Mode
+* PowerMax Driver - Miscellaneous improvements to delete
+* PowerMax Driver - Fix for CI on replication\_device config
+* Add cinder-specs link to readme.rst
+* Fix fujitsu's wrong call to pywbem
+* Dell EMC SC: Handle the mappings of multiattached volume
+* Mark IBM Flashsystem Drivers Unsupported
+* Mark the IBM Storwize driver unsupported
+* Add pdf documentation build in tox
+* docs: update new driver review page
+* Don't allow retype to encrypted+multiattach type
+* Infortrend: Mock sleep in tests
+* NEC Driver: Python3 compatibility
+* Log exception info when objects fail to init
+* Move some code out of utils.py
+* Support Incremental Backup Completion In RBD
+* Fix NFS volume retype with migrate
+* [api-ref]Fix response example file of update\_type
+* Fix tox docs failure
+* [api-ref]Fix values of service-status in list-hosts
+* Ignore hacking rule H101
+* Fix LVM IPv6 target portals
+* PowerMax Driver - feedback on tag removal
+* Address review comments for MacroSAN driver
+* 3PAR: Add config for NSP single path attach
+* Revert "3PAR: Provide new option to specify NSP for single path attachments"
+* Enable mutate for cinder scheduler
+* Create Seagate driver from dothill driver
+* Hedvig: Migration to py37
+* Fix "Fix upload volume to glance"
+* Tests: Combine similar encrypted volume tests w/ ddt
+* api-ref: add metadata parameter in the response of create-backup
+* Rollback the quota\_usages table when failed to create a incremental backup
+* Docs: Jenkins is dead, long live Zuul
+* Cisco FC Zone Manager Driver - Python3.x support
+* Update docs building
+* Docs: Make links more robust
+* PowerMax Driver - Train San REST Port Removal
+* PowerMax Driver - QoS Utils Move
+* Add contributor notes on cinder-status checks
+* Fixing 404's and broken links
+* Update drivers documentation
+* Tighten unit test dict assertions
+* Fix upload volume to glance
+* Refactor API utilities into api\_utils.py
+* SF remove deprecated sf\_allow\_template\_caching
+* Update Veritas Access in Support Matrix
+* Mark Storpool Driver Unsupported
+* Fix ceph: only close rbd image after snapshot iteration is finished
+* Fix issue of getting detail backups list info
+* Rsdlib changed providing\_pools interface
+* NetApp ONTAP: Fix JSON serialization error on EMS logs
+* Fix DetachedInstanceError for VolumeAttachment
+* Fix get\_driver\_options
+* Create extras for pypi install
+* Correcting typo in environment spelling
+* PowerMax Driver - Create Volume from SG Payload Change
+* Prevent double-attachment race in attachment\_reserve
+* Run 'tempest-ipv6-only' job in gate
+* 3PAR: Provide new option to specify NSP for single path attachments
+* Imported Translations from Zanata
+* Add MacroSAN cinder driver
+* Fix dothill multiattach support
+* QNAP: Avoid unnecessary sleeps
+* Update api-ref location
+* Never skip jobs when .zuul.yaml is changed
+* Remove outdated scripts from tools/
+* [DOCFIX] Correct Cinder Backup Driver Option Value
+* Bump Pure Storage FC driver version number for Train
+* Re-add Infortrend Cinder volume driver
+* Replace "integrated-gate-py3" template with new "integrated-gate-storage"
+* Update NexentaStor5 driver
+* Compress images uploaded to Glance
+* HPE 3PAR - Fix detach of multiattach volumes
+* doc: Fix rbd driver marked support multiattach
+* Update support matrix entries for MSA and Lenovo arrays
+* Add policy sample file to gitignore
+* Add release note ignore for backport note
+* Move DotHill release note to correct location
+* Refactor use of encryption/image volume utils
+* Add context to cloning snapshots in remotefs driver
+* Cleanup api-ref sample files
+* Zadara VPSA: Fix driver force detach operation
+* Unity: force delete lun by default
+* Launch driver list generation with the same python interpreter
+* Blacklist sphinx 2.1.0 (autodoc bug)
+* Add support for VxFlex OS 3.0 to VxFlex OS driver
+* Add Active/Active HA to Support Matrix
+* Mark Datera driver unsupported
+* RBD: save and restore multiattach features
+* Add case: force delete snapshot
+* Add case: volume can't be reverted in in-use status
+* Fix assertion methods in a unit test
+* Replace deprecated with\_lockmode with with\_for\_update
+* Fix kwargs passed to exception to get better format of error message
+* SF: Handle qos values on extend volume
+* Fix volume type quota defaults in quotas tests
+* Fix :param: in docstring
+* Run cinderlib functional tests on Ceph job
+* Remove the Nexenta Edge Driver
+* Remove the Veritas HyperScale Driver
+* Remove the Tintri Driver
+* remove support for deprecated options in VxFlex OS driver
+* rename ScaleIO driver to VxFlex OS
+* NetApp SolidFire: Adding new fields to scheduler data
+* Add key-manager to sevice catalog
+* NFS: Retry on intermittent mount failure
+* Add Contributor Docs for Upgrade Checks
+* Rename RSD doc file to match title for sorting
+* Update QoS and add Accuracy Note
+* Remove the DRBDManage Driver
+* Add OS-SCH-HNT in extensions list
+* Cinder RSD Driver
+* Replace assert to raise AssertionError
+* VMware: Enable thin volume from image on VVol
+* PowerMax Driver - Metro ODE Support
+* PowerMax Driver - PowerMax Formatted Vols Fix
+* PowerMax driver - Rapid TDEV Deallocation
+* Remove unused CG volume manager constants
+* Enable osprofiler for rally job
+* Small doc updates: canonical URLs, rally doc, etc
+* Re-enable new pycodestyle errors
+* Mark Veritas Access Driver Unsupported
+* Mark Prophetstor Driver Unsupported
+* Mark the Nimble Driver Unsupported
+* PowerMax driver - locking improvements
+* PowerMax driver - clone improvements
+* PowerMax driver - add 'target\_array\_model' to metadata
+* VMware: Implement clone\_image
+* Docs: Add new driver review checklist
+* Revert "Implement volume capacity stats for VMware"
+* PowerMax driver -  changing from 9.0 to 9.1 REST endpoints
+* Add rbd secret\_uuid in secondary config
+* Bump hacking version to 1.1.x
+* Update Python 3 test runtimes for Train
+* Fix formatting issues in PowerMax docs
+* PowerMax docs - known issues with metro
+* Make py37 unit tests voting
+* move Dell EMC SC driver exceptions
+* Add Upgrade Check for Drivers Removed in Stein
+* Add upgrade check for Windows iSCSI driver
+* move kaminario driver exceptions
+* Deprecate NestedDbQuotaDriver for nested quotas
+* move dothill exceptions
+* Mark the Sheepdog driver unsupported
+* move purestorage driver exceptions
+* move Hyperscale exceptions to driver
+* move storpool exception
+* Remove Sheepdog tests from zuul config
+* Drop use git.openstack.org for tox deps
+* Fix "connector=None" issue in Kaminario drivers
+* move cisco zonemanager exception
+* move vzstorage exceptions
+* move zadara exceptions
+* Bump bandit version
+* Move RBD driver exception to driver
+* LOG \_init\_vendor\_properites
+* HPE 3PAR-Added support for multiattach feature in hpe3par cinder driver
+* Pure Storage FlashArray iSCSI driver target CIDR support
+* [VNX] Fix test case issue
+* Remove BackupDriverWithVerify class
+* Cap sphinx for py2 to match global reqs
+* Handle collections.abc deprecations
+* move zfssa exception
+* Update NEC driver manual and support matrix
+* Correct typo in api-ref
+* Glob volume driver docs to auto sort
+* move netapp exception
+* move Nexenta exception
+* move NVMEOF exception to target file
+* move brocade zone manager exceptions
+* move 3par exception
+* move xtremio exceptions
+* Update doc for missed quotation marks
+* Remove driver requirements of removed drivers
+* Remove the repeated calls
+* Remove confusing annotation
+* VMware: Filter out datastore with 0 capacity
+* move solidfire driver exceptions
+* move smbfs exceptions
+* api-ref: mark migration\_status parameter as optional
+* Add python37 job
+* Removes python-linstor as a requirement for LINSTOR driver
+* Make sure we install cinder requirements during the correct tox phase
+* remove unused exceptions
+* move datera exception
+* move sheepdog exception
+* Use assertNotIn to check dict item
+* move Google backup exceptions
+* Removes drbdmanage as a requirement for drbdmanage driver
+* move synology driver exceptions
+* Remove unused exception
+* Move NVMET driver exceptions to driver file
+* [Trivial fix]Remove unnecessary slash
+* Do not use 'self' in classmethod
+* [Unity] Update doc for compressed volume support
+* Allow filtering on size for volume list
+* move GPFS driver exception to driver file
+* Compact DB migrations to Queens
+* Remove unneeded comment
+* Update Brocade FCZM driver's driver options
+* Fix invalid function name
+* Add user messages for some volume snapshot actions
+* Remove obsolete get\_backup\_driver functions
+* Fix swift backup driver crashing during service startup
+* Correct and optimize hpe3par tests
+* lvm: Only use initiators when comparing connector dicts
+* Update unit test debugging instructions for stestr
+* OpenDev Migration Patch
+* Start release cycle checklist documentation
+* Remove docs for --allow-multiattach
+* Add missing ws seperator between words
+* PowerMax docs - add information on new and existing functionality
+* 3PAR: Provide an option duing creation of volume from snapshot
+* NFS: Log exception when update\_migrated\_volume fails
+* Drop use of git.openstack.org
+* Fix missing print format error
+* Rollback the volume\_types table when failed to update quota\_usages
+* Uncap jsonschema
+* Fix cinder-manage args --max\_count in docs
+* Use proper casing in backup\_compression\_algorithm doc
+* Remove DataCore volume drivers
+* Introduce config to supplement periodic\_interval
+* VNX: add option vnx\_async\_migrate
+* add libpq-dev to build psycopg2
+* Tests: Fix up test\_volume notify tests
+* Make backup\_compression\_algorithm case insensitive
+* Update the min version of tox
+* Update gate-irrelevant-files
+* Add upgrade check for presence of policy.json file
+* Allow reset-state to detach volume as per policy
+* Fix deprecation escape sequence errors under 3.6
+* Document behavior of message.create
+* Reserve migrations for DB backports
+* VNX: delete the LUN from VNX backend
+* Add upgrade checker for backup driver path
+* Remove non-exception from EXCEPTION\_DETAIL\_MAPPINGS
+* Remove scanning upgrade checker from opts generation
+* Fix code-block JSON format issues
+* Replace HTTP numeric codes with constants
+* Remove doc for Nova option that doesn't exist
+* Unity: Add consistent group support
+* Add NetApp E-Series Driver to Removal List
+* Doc: Mark last Stein API microversion
+* Raise eventlet lower-constraint to 0.22.0
+* Replace openstack.org git:// URLs with https://
+* PowerMax Driver - In-Use Retype Path Fix
+* Run cinderlib functional tests on LVM-LIO job
+* Imported Translations from Zanata
+* Fix service\_uuid migration for volumes with no host
+* Update master for stable/stein
+* Synology: Add support for UC-Series model
+
+14.0.0.0rc1
+-----------
+
+* Handling filters in Generalized Filtering API
+* Automate generation of volume transfer api-ref samples
+* [NetApp] Casting block\_count to int before calling ONTAP API
+* Fix Support Matrix - Pure does support Multiattach
+* Gate Fix: Bumping versions in lower-constraints.txt
+* Fix VolumeAttachment is not bound to a Session
+* Modify the configuration mode of FusionStorage Cinder Driver
+* Automate generation of snapshots api-ref samples
+* Refactored NexentaStor5 driver
+* Adds revert to snapshot feature to support matrix
+* PowerMax docs -  changing cinder tags to powermax
+* Use excutils.save\_and\_reraise\_exception instead of reraise
+* PowerMax driver -  test fixes for \_sanity\_port\_group\_check
+* NetApp SolidFire: Fix misbehavior on account creation
+* Add get\_driver\_options method
+* docs: mark rbd driver support for extending an in-use volume
+* Revert "Remove truncate from rootwrap filters"
+* Revert "Use native python truncate for privsep"
+* NetApp SolidFire: Fix multi-attach volume deletion
+* Update required version of taskflow
+* Update minimal acceptable glanceclient
+* Create volume attachments status check
+* Allow setting Pure host personality
+* Add project\_id in group snapshots list and show API
+* Use 'target\_helper' config opt in linstor driver
+* Update oslo.privsep minimum requirement
+* Use new target\_\* options in documentation
+* Remove py35 from setup.cfg
+* Add oslo.privsep to config-generator list
+* Fix typo in the comment
+* Use config-table for dynamic config documentation
+* Drop py35 jobs
+* VNX: update sg in cache
+* Disable etcd3 for lio-barbican job
+* Enable service capabilities update at less than 60 seconds
+* Extend timeout for database migration tests
+* Improve documentation of goodness/filter function
+* api-ref: add qos\_specs\_id to show default volume type response
+* Update support matrix of Huawei driver
+* Define single place for irrelevant-files
+* Fix Snapshot object metadata loading
+* Use native python truncate for privsep
+* Fix python3 compatibility of rbd get\_fsid
+* Remove truncate from rootwrap filters
+* Trim test list for lio-barbican job
+* Tests: Fix up migrate notify tests
+* Extend remove\_version\_from\_href support
+* Pylint: Filter out cinder.objects and requests E1101
+* Fix version return incorrect when endpoint url end without /
+* Update section 'When do i need a new Microversion?'
+* docs: Add os-migrate\_volume\_completion api-ref
+* Doc8: Stop skipping D001: Line too long
+* Include .inc files in doc8 linting
+* NetApp SolidFire: Thin provisioning scheduler support
+* REST connector for Brocade zone driver
+* Fix for auth version change in Brcd HTTP
+* Remove drbdadm from filters
+* Replace 'lvconvert' from rootwrap
+* PowerMax Driver - Unmanage Snapshot Improvements
+* PowerMax driver - performance improvements
+* PowerMax Driver - Unit Test Refactoring
+* PowerMax driver - do an rdf\_group check earlier
+* Limit RBD discard to 32 bit chunks
+* Fix incorrect replication info for RBD
+* Remove LOCI publishing from the post pipeline
+* Add empty check before using zone driver
+* VNX Driver: delete\_hba() instead of remove\_hba()
+* PowerMax driver - handle special case where IG exists
+* PowerMax driver -  move pagination code to request
+* PowerMax driver - do the portgroup check earlier
+* PowerMax driver - solve issue of concurrent snapvx operations
+* Compact DB migrations to Ocata
+* Automate generation of volume actions api-ref samples
+* Fix some miscapitalizations of VMware
+* RBD: add support for multiattach
+* PowerMax Driver - Storage-assisted in-use retype support
+* Use oslo.privsep for 'lvcreate'
+* Add Python 3.6 version in setup.cfg
+* Update install docs to match default NFS config
+* Update rbd thin-provisioning in support-matrix
+* Remove legacy-tempest-dsvm-full-drbd-devstack job
+* Drop nova-multiattach job
+* Declare multiattach support for HPE MSA
+* Remove 'tgtadm' from rootwrap
+* Huawei driver refactor(2/10)
+* Adding microversion in releasenote "project\_id response in groups"
+* Support transfer pagination
+* Switch tempest-slow to be run on python 3
+* Remove LIO multiattach release note
+* Fix HPE3PAR not returning cached stats
+* Add project\_id in group list and show API
+* Return WWN for validation in Pure Storage drivers
+* PowerMax Driver - Replication Settings Fix
+* PowerMax driver -  code cleanup and minor improvements
+* QNAP: Add support for QTS 4.4.0
+* api-ref: Add cipher to update an encryption type interface
+* VMAX driver doc - clarify PowerMax rebrand release note
+* Fix keystone auth config in install doc
+* Fix the misspelling of "volumes"
+* Fix "import xxx as xxx" grammar
+* Add missing ws seperator between words
+* Add check\_encryption\_provider to volume utils
+* fast8 improvements
+* Huawei driver refactor(1/10)
+* Cleanup rootwrap filters
+* Fix gigabytes usage error when deleting snapshot group
+* Report msg error when cannot revert to snapshot
+* Fix for HPE MSA 2050 login failures
+* Pass image\_id to ImageDownloadFailed
+* Update FusionStorage Cinder Driver by using REST API
+* Move Fujitsu ETERNUS DX related file
+* Refresh the Service.service\_id after re-spawning children
+* Correct default policy\_file in the sample config
+* Remove 'lvrename' from rootwrap
+* LinstorDrv : Fix wrong key using when getting device path
+* Create new image volume cache entry when cloning fails
+* Refactor on policy in code
+* Add policy test for volume extend/retype/update\_ro policy
+* Add policy test for volume metadata policy
+* Add policy test for volume action policy
+* Add policy test for volume update/del policy
+* VMware: Implement retype
+* VMware: Release notes for vmware\_storage\_profile
+* Temporary solution for fixing gate test\_tpool\_size
+* Improve volume transfer records
+* PowerMax driver -  changing from 8.4 to 9.0 REST endpoints
+* Handle 'is\_public' filter in volume-type list
+* Automate generation of volumes api-ref samples
+* Imported Translations from Zanata
+* Implement volume capacity stats for VMware
+* Switch ietadm to use olso.privsep
+* Enable some tests in the cinder.tests.unit.test\_cmd module for MacOS
+* Initiating Cinder Volume Manager with large number of volumes
+* Avoid using 'truncate' on Windows
+* PowerMax driver - rebranding VMAX to PowerMax
+* [Doc] Fix typos
+* Fix for CI information in SPDK volume driver
+* Add test case: extend non-exist volume
+* Reset snapshot status available
+* Add test case: retype volume when driver not initialized
+* Add test case: delete snapshot when driver not initialized
+* NetApp: Return all iSCSI targets-portals
+* Automate generation of API versions api-ref samples
+* NetApp Doc: Enhance 'netapp\_storage\_protocol' description
+* SPDK drivers documentation
+* Fixup some issues of Inspur AS13000 cinder driver
+* add resource filters to the included data\_files
+* LINBIT DRBDManage driver moves to maintenance mode
+* Fix Xtremio driver configuration ordering
+* Support deferred deletion in RBD
+* Remove those copy words occured twice times in dell-emc-vmax-driver.rst
+* Add new LINSTOR volume driver
+* Hedvig Cinder driver implementation
+* cinder-volume: Stop masking IOError different than ENOSPC
+* Add missing backup status in API doc
+* Using wrong parameter in test\_backup\_ceph
+* Move 'attach.end' notify to attachment\_complete
+* Mask passwords in utils.trace for func params
+* Fix CI failed: test\_get\_volume\_filter\_options\_using\_config
+* QNAP: Support QES FW on TDS series NAS
+* ScaleIO: Fix Extra Spec parameter name in driver doc
+* Remove support for NetApp E-Series systems
+* Adding SPDK volume driver
+* Delete related encryption provider when a volume type is deleting
+* Fix retype notifier test case (BackupNFSTestCase)
+* [api-ref] Fix the parameter of image metadata
+* Handle string status codes in logging
+* VMAX Driver - Failover Unisphere Support
+* Remove vgc-cluster
+* Remove 'ln' command from rootwrap filter
+* Add policy configuration howto
+* Remove umount from volume.filters
+* Refactor for Veritas iSCSI driver
+* Add x\_project\_id, accepted to transfers
+* Add policy test for volume create policy
+* Ignore migration 127 error on MariaDB
+* [Unity] Storage-assisted migration support
+* Use renamed template 'integrated-gate-py3'
+* Allow to use \_max qos option together with per\_gb
+* Driver reinitialization after failure
+* Correct the use of assertTrue
+* Revert "Synchronize all LVM operations"
+* Update IBM storwise svc driver doc
+* api-ref: volume\_type\_access should be array instead of object
+* Fix \_per\_gb\_min usage with \_per\_gb
+* Set message property in ImageDownloadFailed
+* Fix A/A 'resource\_backend' when scheduling volumes
+* Add irrelevant-files for integrated test jobs
+* Handle image download and conversion errors
+* Synchronize all LVM operations
+* Rename BackupNFSSwiftBasedTestCase
+* Cinder volume driver for Inspur AS13000 series
+* Add user\_id in backup list and show API
+* Fix permissions with NFS-backed snapshots and backups
+* VMware: Storage policy support
+* VMware: Add support for vStorageObject snapshots
+* Make policy config docs consistent
+* Revert "Ceph driver should respect the \`--incremental\` option for backups"
+* api-ref: add response body for set-image-metadata-for-a-volume
+* Revert "Move check\_encryption\_provider to volume utils"
+* VMAX Driver - VMAX OS Upgrade Bug
+* PowerMax driver doc - clarifying SE and Unisphere support
+* Doc: Remove unnecessary note
+* Extract copy\_image\_to\_volume into volume utils
+* Ensure image utils don't block greenthreads
+* Adding missing Volume states to VolumeStatus enum
+* Automate generation of api-ref samples
+* Add policy test for TENANT\_ATTRIBUTE\_POLICY
+* Imported Translations from Zanata
+* Add missing ws seperator between words
+* Change a function name of swift backup
+* Tests : notifier problem with backup
+* Change openstack-dev to openstack-discuss
+* Add secret=true to fixed\_key configuration parameter
+* Cleanup code duplication in cinder.cmd.backup module
+* Fix the problem of the scheduler status
+* Check Volume Status on attahcment create/update
+* Stop cleaning images to be deleted in remotefs driver
+* Retry on DBDeadLock affecting worker updates
+* Add test case: clone volume with bad size
+* Remove deprecated query\_volume\_filters config option
+* Correct default policy file
+* VMAX Driver - Place volume in SG as part of unmanage volume
+* PowerMax driver doc - removing support for VMAX2
+* Ceph driver should respect the \`--incremental\` option for backups
+* api-ref: fix some issues in volumes interfaces
+* VMware: Check empty provider location
+* Ignore updated stable release note
+* [Doc] Fix status and parameters of vol connection api
+* Imported Translations from Zanata
+* sqlalchemy: GroupTypeProjects.deleted is boolean
+* An alternate way to fix retype notifier test case
+* api-ref: document encryption type provider choices
+* Imported Translations from Zanata
+* api-ref: volume summary is available from v3.12
+* Revert "Remove mount from volume.filters"
+* Adding SPDK NVMe-oF target driver
+* doc: Change variable name DEFAULT\_API\_VERSION to \_MIN\_API\_VERSION
+* Block broken requests 2.20.0
+* [api-ref] Fix the value of project\_id
+* NetApp SolidFire: Revert volume to snapshot
+* lvm: Avoid premature calls to terminate\_connection for muiltiattach vols
+* api-ref: fix succeed code and add field for update-backup
+* api-ref: add missing volumes\_links in list-volume interfaces
+* api-ref: Adding backup create response example
+* Add policy test for volume GET\_ALL\_POLICY
+* Imported Translations from Zanata
+* Set right attach mode after migration
+* api-ref: fix response example of list-backups
+* Make lower constraints CI works well
+* api-ref: fix response code and data type for volume interfaces
+* Imported Translations from Zanata
+* Improve/Clean api-ref parameters
+* [Trivial Fix] Correct spelling error of "bandwidth"
+* Add test coverage to manage existing flow
+* VMAX driver - allow for a clean system with no initiator groups
+* Drop simplejson usage
+* Remove Babel from requirements
+* Update docs landing page to follow guideline
+* api-ref: Correct response body type for show host details
+* Increase the length of resource property in quota\_usages
+* Remove DeprecationWarning of "decodestring()"
+* VMAX Driver - Fix for invalid device id length
+* Remove out-of-date configurations in setup.cfg
+* Add policy test for volume:force\_delete
+* add missing comma
+* Simplify the policy test case
+* Fix a typo in multiattach doc
+* Remove setup.py check from pep8 job
+* [Trivial] Fix typo in comment in delete\_volume
+* Update backup flow for CephBackupDriver
+* Imported Translations from Zanata
+* Handle rbd.OSError on broken RBD image
+* Fix non iSCSI attach serialization
+* Set user message on volume create failure
+* Imported Translations from Zanata
+* Raise the ImageTooBig exception when found it
+* Move tgt targets to privsep
+* Fix and Optimize : retype tests
+* hpe 3par driver initialization failure
+* api-ref: cleanup status conditions for backup/restore APIs
+* PY3: Ensure rados.Object.read/write use byte data
+* Forbidden to revert volume to a different size snapshot
+* Fix debug message for \_copy\_volume\_data
+* Remove scstadmin from rootwrap
+* [Trivial] Replace 'action' with 'command' in cinder-status doc
+* Allow using forward slashes in metadata
+* Fix unexpected behavior in \_clone\_image\_volume
+* Remove scsi\_id from rootwrap filter
+* Remove mount from volume.filters
+* Drop drv\_cfg from rootwrap filters
+* Remove touch command from volume.filters
+* Imported Translations from Zanata
+* cinder-manage online\_data\_migrations fixes
+* Handling unexpected python error "NoneType object is not iterable"
+* Base framework for cinder-status upgrade check
+* api-ref: add missing fields in volume group types
+* Huawei: Simplify wait\_for\_condition calls
+* Update sphinx extension logging
+* Restructure Huawei driver
+* VMAX: set faked max\_oversubscription\_ratio
+* Move cinder-manage page to cli doc subtree
+* api-ref: fix some inconsistencies in snapshot API
+* Add test-requirements to pylint reqs
+* Rename cinder.privsep.utils to cinder.privsep.path
+* Adding regression test for update\_group
+* DS8K: correct the usage for ssl method(SSLContext.wrap\_socket)
+* Fix: storage\_pools key in Huawei Driver
+* Imported Translations from Zanata
+* Fix for field type error
+* fix misspelling of available
+* Imported Translations from Zanata
+* Increment versioning with pbr instruction
+* Mark Veritas HyperScale Driver Unsupported
+* Cinder Backup: object\_count value incorrect
+* Extract volume image metadata into volume utils
+* Extract \_get\_image\_metadata into volume utils
+* Use tempest-pg-full
+* Remove the ITRI DISCO driver
+* NFS Backup: Avoid TypeError in os-brick when not configured
+* [minifix] Update reno formatting on Quobyte driver defaults change
+* api-ref: totalSnapshotsUsed in limits response should be integer
+* Add column only when it doesn't exist
+* VNX: Add constraints for async migration
+* Remove volume:get policy from test policy file
+* Replace openSUSE experimental check with newer version
+* Fix for cinder-manage db purge
+* Follow Up: Generalizing is\_replicated\_str to is\_boolean\_str
+* api-ref: Add response fields and response example for snapshot manage
+* api-ref: remove created\_at from response example of list-transfer
+* Handle drivers that do not support list manageable
+* Fix doc output examples
+* Fix: UnboundLocalError variable referenced before assignment
+* api-ref: Add response fields and response example for volume manage
+* api\_ref: total\_capacity and free\_capacity can be float
+* Stop using deprecated rpc\_backend option
+* Don't quote {posargs} in tox.ini
+* Imported Translations from Zanata
+* api-ref: qos and extra\_spec are optional in types view
+* Fix wrong uuid recognized when create group
+* api-ref: Fix namespace parameter for backend capabilities
+* Imported Translations from Zanata
+* SF ensure the correct volume is deleted
+* Mark the Nexenta Edge driver unsupported
+* Mark the Tintri driver unsupported
+* Remove source\_replica info from api-ref
+* Remove sg\_scan
+* Update unit test debug instructions
+* API-REF:os-quota-sets v2 API reference has the wrong parameters
+* VMAX docs - Replace serial\_number
+* Remove the HGST Flash Storage Driver
+* Add missing 'is\_public' volume type parameter
+* nimble storage: support for force detach
+* nimble storage: retype support
+* Use Tempest slow job to run all slow tests
+* api-ref: Change extensions updated type to updated\_at
+* api-ref: remove encryption from Show-an-encryption-type
+* hosts api ref: all fields should be of type string
+* Remove systool from rootwrap
+* Add tests for multiattach check in cinder.objects
+* Clean up the deprecated description in doc
+* Fix wrong NotFound in get\_by\_name\_or\_id
+* api-ref: add missing response body for groups
+* Fix CLI output examples
+* Fix multiattach set to false after retype
+* Update Dell EMC Driver's multi-attach Support
+* Fix backup driver configuration examples in the documetation
+* api-ref: add missing fields in volume types
+* api-ref: total/free\_capacity should be with postfix \_gb
+* api-ref: namespace in extensions is optional
+* Fix pylint warning
+* Exclude disabled API versions from listing
+* Enable split logging for cinder-keystoneclient interaction
+* Remove unecessary pass
+* VMAX Driver - Fix for manage volume if volume is part of SG
+* api-ref: clarify volume\_type param in volume create API
+* api-ref: fix req/resp params for v3 os-quota-class-sets
+* api-ref: mark name as optional in volume create API
+* Fix DRBD volume driver creating a 2-volume resource
+* ZFSSA iSCSI implement get\_manageable\_volumes()
+* Get rid of keys() usage
+* Imported Translations from Zanata
+* Fix bug of renaming volume with same name
+* Fix some inconsistencies in qos-specs api ref
+* Propose example volume protection tests
+* services api ref: fix field enum value and add missing field
+* ZFSSA iSCSI driver doc fix - allow\_rename auth/o
+* ZFSSA handle manage nonexistent volume
+* Adding variable for total gigabytes used by snapshot param
+* [Optimize] Use OVO when retrieve volume object
+* Add microversion history to api-ref
+* Dell PS Driver moves to maintenance mode
+* Remove udevadm from rootwrap
+* VMAX Rocky doc - version information
+* Fix some inconsistencies in messages api ref
+* Fix typos in volume api ref doc
+* Remove aoe-revalidate, aoe-discover, aoe-flush
+* VMAX Driver - Rollback for manage existing volume
+* ZFSSA volume driver REST client python3 fixes
+* Fix image volume cache max size and max count limits
+* Move hscli to privsep
+* Imported Translations from Zanata
+* 3PAR: Update Storage Driver docs
+* Imported Translations from Zanata
+* EMC ScaleIO driver does not honor create from snapshot volume size
+* Link to the in-tree driver support matrix from multiattach docs
+* Imported Translations from Zanata
+* api-ref: document no\_snapshots default for volume transfer API
+* api-ref: add preconditions for volume transfer APIs
+* Add comment to online data migration command
+* Rename devstack-plugin-ceph jobs
+* Fix wrong filter of backups in db api
+* Fix indentation in docs
+* Remove resolve\_hostname
+* Imported Translations from Zanata
+* Clean up bare raised pylint warning
+* Fix pylint warnings for "unnecessary not"
+* Update Zuul configuration
+* add python 3.6 unit test job
+* switch documentation job to new PTI
+* import zuul job settings from project-config
+* Ds8k: Mock evenlet.sleep calls
+* Fujitsu DX: Add retries for busy error
+* Ensure VNX unit tests don't sleep
+* Simplify running pylint
+* Tintri: Inherit tests from BaseDriverTestCase
+* NetApp SolidFire: Fix CG snapshot deletion
+* Imported Translations from Zanata
+* Modify Pure driver to configure PG/Pod names
+* Move check\_encryption\_provider to volume utils
+* Imported Translations from Zanata
+* Move release note to the releasenotes/notes dir
+* NetApp SolidFire: Fix force\_detach
+* fix misspelling of 'configuration'
+* Remove deprecated HPE Lefthand config opts
+* VMware: Fix revert-to-snapshot
+* VMware: Remove member initialization in properties
+* Move sphinx-feature-classification to docs reqs
+* Simplify hostname lookup
+* Imported Translations from Zanata
+* tintri: Remove \_resolve\_hostname
+* trival: Fix some spacing issues
+* Fix typo
+* Update doc for get-pools API
+* Avoid using dict.get() in assertions
+* Imported Translations from Zanata
+* Remove auth\_uri usage
+* 3PAR: Added retries on volume deletion
+* VMAX Driver - Initiator retrieval short hostname fix
+* SIO: Clean up padded volume comments
+* Add test case: create volume from source volume
+* Fix IPv6 for Cinder NetApp ONTAP drivers
+* Remove cinder-tox-compliance job
+* Correct the link of 'OpenStack Documentation Contributor Guide'
+* Fixed invalid number of arguments bug in ScaleIO driver
+* LVM: Disable multiattach for LIO iSCSI target
+* Replace assertRaisesRegexp with assertRaisesRegex
+* Fix deprecation warnings
+* VMAX doc - important known issue
+* Drop legacy backup service support
+* Changed default behaviour of nas\_secure\_file\_\* for Quobyte driver
+* Imported Translations from Zanata
+* api-ref: add docs for os-migrate\_volume API
+* Remove deprecated sio\_allow\_non\_padded\_thick\_volumes
+* Remove flashsystem\_multipath\_enabled opt
+* Dell EMC: Added excluded\_domain\_ips ListOpt to SC driver
+* Remove WindowsDriver mapping
+* Remove deprecated iSCSI target config opts
+* Imported Translations from Zanata
+* Remove os-image-create API extension
+* Make divisibility py3 compatible in DRBD driver
+* Xtremio: Remove unused constant
+* Raise HTTPUnsupportedMediaType when content type is unsupported
+* Add 'volume\_attachment' to volume expected attributes
+* ScaleIO: Deprecate sio\_allow\_non\_padded\_thick\_volumes
+* Make solidfire code py3-compatible
+* Imported Translations from Zanata
+* Add api-ref for mv 3.55 volume transfer
+* Fix support indicator for rbd extend attached
+* ScaleIO: Disable volume creation without padding
+* Add policy granularity to the encryption API
+* Fix api-ref title levels and index
+* Fix XTREMIO driver name
+* Add False check when do \_retype\_error
+* Add retry to LVM deactivation
+* [Docs] Update some links for Gerrit of Code Reviews
+* Optimizing code (wrap\_socket())
+* Save the backup.service just before \_run\_backup
+* Make code py3-compatible (global callable())
+* Update document for metadata show API
+* Reserve 3 migrations for DB backports
+* Imported Translations from Zanata
+* Imported Translations from Zanata
+* NetApp SolidFire: Fix NetApp SolidFire SSL option
+* Imported Translations from Zanata
+* Remove the CoprHD driver
+* Update reno for stable/rocky
+
+13.0.0.0rc1
+-----------
+
+* Imported Translations from Zanata
+* Fix \_attachment\_reserve to not allow attaching an invalid status volume
+* Allow extra parameters in volume\_type\_encryption
+* Default functional tests to use v3 API
+* Add retries to delete a volume in the Nimble Driver
+* Add volume create schema enforcement unit tests
+* Fix one help description of rbd driver
+* Fix typo on Storwize release note
+* Note max API version for Rocky
+* Add sphinx-feature-classification based support matrix
+* VMAX driver - releasenote fix
+* Solidfire: Avoid UnboundLocalError
+* 3PAR: Update Storage Driver docs for Rocky release
+* VMAX Docs - SSL Support Revision
+* VMAX docs - Rocky features
+* VMAX docs - Restructure of content
+* VMAX Driver - Fix for get-pools and returned Service Levels
+* VMAX driver - minor metadata additions
+* VMAX driver - replace 'data=' with 'message='
+* VMAX driver - pagination on get vols from SG list
+* Correct volume-transfers API endpoint
+* Improve messages api-ref description
+* Add ability to specify minimum value when using capacity based QoS
+* IBM XIV: fix issues for replication
+* Fix none-ascii char in doc
+
+13.0.0.0b3
+----------
+
+* solidfire: Enable SSL with requests
+* VMAX Driver - Fix for multiple clones failure
+* Fix indentation in docs
+* VSA: Concurrent request handling in attachment
+* NetApp ONTAP: Fix driver force detach operations
+* docs: Write high availability devref
+* Consume quota when importing backup resource
+* Update volume create schema to allow 'null'
+* nimble: Fix missing ssl support
+* INFINIDAT: add host.created\_by metadata key
+* Set bootable when creating volume from snapshot
+* Handle multiattach attribute when managing volumes
+* Update delete group snapshot API exception handling
+* tintri: Enable SSL with requests
+* Fix remotefs driver report wrong value
+* IBM XIV and DS8K: Update document for Rocky release:
+* Revert "Use Tempest scenario job to run all scenario tests"
+* Add release note for force delete MV fix
+* ActiveCluster support for Pure Storage drivers
+* Remove mox3
+* XtremIO: support multiattach
+* NEC driver: Return non-random iscsi portal in initialize
+* Update microversion number with constants
+* [Unity] Compressed volume support
+* Don't require size when creating volume from snap
+* Fix some nits in transfer volume with snapshots
+* Add keystoneauth options to list\_opts
+* Update microversion for force delete volume parameter
+* VMware: set 'shared\_targets' as False
+* INFINIDAT: validate\_connector should validate by protocol
+* DS8K: correct the behavior for retype method
+* Non Windows per service lock for Backup service
+* QNAP: Add support for QES 2.1.0
+* [doc] Use openstack client commands to replace cinder client
+* [doc] Use openstack client commands to replace cinder client
+* Use Tempest scenario job to run all scenario tests
+* Transfer snapshots with volumes
+* Update attachment create API document
+* NEC driver: loss of access after live-migration
+* Pure Storage FlashArray driver - enable multiattach support
+* VMAX driver - Block revert to snapshot for replicated volumes
+* VMAX driver - Add VMAX specific volume metadata to logs
+* Add ability to specify mode to attachment-create
+* use restore\_file instead of open volume when restoring
+* Unity: add multiattach support
+* Update api-ref and release notes for schema validation
+* Prepare Google Backup driver for latest libraries
+* Fix Port nvmet driver to use privsep
+* NetApp ONTAP iSCSI/FCP: Enable multiattach capability
+* Remove note about mox
+* Unity: add thick volume support
+* LVM: Enhance option descriptions
+* api-ref: Update notes on encryption key size
+* Ceph backup: set close\_fds on Popen
+* Use ensure\_tree instead of mkdir when creating paths
+* RemoteFS: Use summarize option for "du"
+* Remove hus-cmd from rootwrap volume.filters
+* Avoid os.getpgrp, breaking Windows c-backup support
+* Enable split logging for cinder-glanceclient interaction
+* Remove tee from volume.filters
+* Revert "Use os.mkdir instead of mkdir"
+* Change blockbox to block-box
+* Remove unused commands from volume.filters
+* Remove ssc command from volume.filters
+* NetApp: Deprecate E-Series drivers
+* Use os.mkdir instead of mkdir
+* Remove blockdev from volume.filters
+* Drop dmsetup from rootwrap
+* Remove mkdir from volume.filters
+* NetApp ONTAP: Remove NFS driver online volume extending support
+* Add policy in code documentation for os-set\_bootable API
+* Port nvmet driver to use privsep
+* DS8K: correct behavior and return value for terminate\_connection method
+* DS8K: correct the behavior for get\_pools method
+* Correct Pure Storage configuration documentation
+* INFINIDAT: change create\_child to create\_snapshot
+* Adds Overlay Volumes Created from Snapshots to Quobyte
+* Fix RBD incremental backup
+* Add blueprints and releasenotes link to README
+* Fix parameter description in volume and snapshot manage extension
+* Keep volume's status in 'creating' when creating from backup
+* RBD: support to get manageable snapshots
+* [NetApp ONTAP] Add filtering to API trace logging
+* [Logging] Enable filtering of trace\_api logs
+* Fix 'availability\_zones' attribute not recognized when creating volume
+* V3 jsonschema validation: Volumes
+* Enable running py36 unit tests
+* Handling type's multiattach extra specs in API task flow
+* NEC driver: Fix iscsi multipath initialize\_connection tests
+* NetApp ONTAP: Remove iSCSI/FC driver online volume extend support
+* Multipath: Update docs for backend drivers
+* Fix time convert error in testcases
+* NEC driver: Reuse iSCSI LUNs of detached volumes
+* Fix quota error when deleting temporary volume
+* Make scheduler check online\_extend\_support capability
+* Clean up unnecessary test params in test\_rbd
+* NetApp ONTAP NFS: Enable multiattach capability
+* Adds more validations in create\_snapshot
+* Add policy check for type show and type list
+* Fix vmware disk type changed when volume type is eagerZeroedThick
+* Remove report of allocated\_capacity\_gb from Inspur driver
+* Fix v3 sample files
+* Dell EMC: SC FC Driver wwns api response in lower
+* Add v3 api-ref for force delete snapshot
+* api-ref: Adds os-update\_readonly\_flag API
+* Fix prophetstor drivers report value
+* Fix invalid escape sequence warnings
+* Get rid of conditional rtslib\_fb imports
+* DataCore: get rid of pylint errors due to contextlib
+* Nimble: Fix tuple being passed for exception init
+* Solidfire: Fix pylint errors for class decorators
+* Infinidat: Get rid of pylint errors due to private lib
+* NetApp: Remove duplicate volume\_type kwarg
+* Increase pylint processes
+* Add v3 api-ref for updating snapshot status
+* Reject any filter whose key contains non ascii character
+* HPE3PAR: Fix pointing to backend in group failover
+* Remove 'message' from format argument from exception
+* Fix the usage of RBDVolumeProxy in getting manageable volumes
+* Storwize: get list of all volumes for ensure\_export
+* Keep ORM names matching their VO counterparts
+* Storwize:clone volume with iogrp value as expected
+* [XtremIO] Remove provisioning factor when reporting
+* DS8K: Enable multiattach support
+* Move blockbox DB volume to home directory
+* VMAX Driver - Incorrect SSL cert verification
+* VMAX docs - use config-table directive
+* VMAX driver - remove deprecated XML option
+* VMAX driver - Deleting snapshot that is source of multiple volumes fails
+* VMAX driver - Incorrect service level reporting
+* VMAX driver and docs - change san\_rest\_port to san\_api\_port
+* Imported Translations from Zanata
+* api-ref: Rephrase delete volume precondition
+* policy docs: Add volume summary under GET\_ALL\_POLICY entry
+* Storwize: add data reduction pool support
+* Allow running unit tests on macOS
+* Update macOS devref info
+* Fix tox -e docs failure
+* Add ansible helper to Linux dev environment info
+* Remove 'message' from format argument from exception
+* Remove 'message' from format argument from exception
+* Be explicit about tox python version
+* DS8K: correct the return value for initialize\_connection method
+* Add debug logs for weigher filters
+* Add documentation page for basic volume quality of service
+* VMAX: Address nits in list manageable code
+* Mark Dell EMC CoprHD Drivers unsupported
+* Add doc about backend\_default config
+* [doc]Modify failed hyperlinks
+* [api-ref] Fix the parameter metadata in v3
+* Empty option value maybe cause Unity driver failed to initialize
+* Support image signature verification
+* Imported Translations from Zanata
+* trivial: Add min\_version: 3.1 to api\_ref for upload volume
+* Fix cinder-volume uses latest req-id for all log calls
+
+13.0.0.0b2
+----------
+
+* Mock log output from DataCore drivers
+* Add NexentaEdge drivers
+* VMware: Add file open mode to support python3
+* Tests: Remove some ovo FutureWarnings about UUIDs
+* Add check to the flake8 job
+* Cloning image fails results duplicate cache entry
+* api-ref: Fix some params in volume types
+* Switch to oslo\_messaging.ConfFixture.transport\_url
+* Run pylint job under py3
+* Disable failing backup tests in LIO/Barbican job
+* Remove kwargs 'message' when exception is created
+* Api-ref: Fix the incorrect parameter description
+* Replace os.makedirs to avoid process race
+* Implement privsep boilerplate in cinder
+* Default tox jobs to python3
+* Fix group availability zone-backend host mismatch
+* Mark Disco driver unsupported
+* Mark the HGST Driver unsupported
+* Move driver config opts out of catchall page
+* RBD: support to report backend state
+* IBM XIV: Report backend state in service list
+* IBM DS8K: Report backend state
+* Add note about multiattach not supporting encryption to docs
+* Fix Dell EMC Xtremeio drivers report wrong value
+* Fix documentation error
+* Correct S-Series to DS-Series systems
+* Remove the deprecated config option
+* Fix GCS backup driver docs
+* Doc: Fix broken link (Nimble)
+* Imported Translations from Zanata
+* Add user messages for extend volume operation
+* Mark DataCore Drivers unsupported
+* V3 jsonschema validation: volume\_type\_encryption
+* ZFSSA handle non-existent snapshot
+* Update storage backends supported for Lenovo
+* Fix handling of 'cinder\_encryption\_key\_id' image metadata
+* Remove \_static folder in doc directory
+* Update "auth\_url"
+* Fix api-ref for backup export and import
+* Missing request parameters in update quotas
+* Trivial: Update pypi url to new url
+* V3 jsonschema validation: admin\_actions
+* [Api-ref] fix the type of service\_id in worker cleanup api
+* api-ref: Fix v3 API version details error
+* [Unity] Return logged-out initiators
+* Add cinder v2 experimental job
+* Fix cannot add a column with non-constant default
+* Update author in latex sphinx doc builds
+* Update the volume-encryption doc
+* Additional fix for hostname validation regex
+* doc: correct indentation from a note block
+* V3 jsonschema validation: scheduler\_hints
+* INFINIDAT: fixing extend mechanism
+* Storwize: update the function is\_volume\_hyperswap
+* Fix the argument for cinder-manage command
+* NEC driver: Faster clone status check
+* Fix cinder-volume setup in block-box
+* [Docs] Fixes documentation warning
+* Remove duplicate sample files
+* Fix option description in DRBD driver
+* Remove Ocata config option changes doc
+* VMAX driver - VMAX list manageable volumes and snapshots
+* VMAX driver - Enable multiattach support
+* Fix wrong usage of fields.BackupStatus.AVAILABLE
+* ScaleIO: Rebranding of product to VxFlex OS
+* Disable test\_volume\_backup\_restore for lio-barbican job
+* Support availability-zone type
+* Fix rbd driver json loading
+* Fix create backup API document
+* Add missing volume APIs
+* Imported Translations from Zanata
+* [Api-ref] fix incorrect host value in worker cleanup api
+* Fix NVMET minor log message issues
+* Fix google backup driver
+* V3 jsonschema validation: os-services
+* Update auth\_uri option to www\_authenticate\_uri
+* Huawei driver supports create\_group\_from\_src
+* Disallow multiattach for encrypted volumes
+* NetApp ONTAP iSCSI: Force exception on online extend
+* Fix hostname validation regex
+* Add snapshots to minimum driver interface
+* Add descriptions for auth\_strategy choices
+* RBD: remove redundant exception log to reduce noise
+* Log backup\_service.restore() exception
+* Add support for promoting a failed over backend
+* [Unity] Add support of removing empty host
+* V3 json schema validation: generic volume groups
+* Fix i18n issue in volume\_action and admin\_action
+* Support filter backend based on operation type
+* Remove stale pip-missing-reqs tox test
+* NEC driver: Delete max volumes per pool limit
+* [ci][rally] make the job inherit the right parent
+* Make config-table display list defaults in list format
+* api-ref: modify 'keys' description
+* QNAP: driver fails to detach while uploading volume to image
+* Remove static config option table for Infinidat
+* Remove zonemanager static config option tables
+* [VNX] Fix property set in configuration doc
+* Fix os-detach attachment\_id schema
+* Adding NVMET target for NVMeOF
+* DRBD: Remove cast to int in size calculation
+* Remove backup driver static config option tables
+* Add missing 'transfer' parameter in API document
+* Update HPE docs to use config-table directive
+* Skip running py36 tests on irrelevant files
+* Remove ZFSSA static config option tables
+* Remove Zadara static config option table
+* Remove Virtuozzo static config option table
+* Remove Tintri static config option table
+* Remove Synology static config option table
+* Remove SolidFire static config option table
+* Remove Quobyte static config option table
+* Replace Chinese punctuation with English punctuation
+* Replace cluster object's host with service\_topic\_queue
+* IBM XIV: enable FC zoning to all the ports
+* [doc] Add the possible status for attachment
+* Remove Nimble static config option table
+* Remove NEC static config option table
+* Remove static config option table for Lenovo
+* Remove Kaminario static config option table
+* Remove static config option table for DISCO driver
+* Add skip filter to config-table directive
+* Imported Translations from Zanata
+* Update auth\_url value in install docs
+* Fix doc warnings causing local failures
+* Updates overprovisioning dev-ref
+* Add reno to test-requirements
+* api-ref: modify 'has\_dependent\_backups' param's description
+* V3 jsonschema validation: Quota classes
+* V3 jsonschema validation: Quotas
+* Remove Fujitsu static config table
+* Update Dell EMC docs to use config-table directive
+* Update Datera docs to use config-table directive
+* Update Sheepdog docs to use config-table directive
+* Remove remaining block device driver config info
+* Update CoprHD docs to use config-table directive
+* GoodnessWeigher schedules non-type volumes
+* Add config table sphinx directive
+* Fix doc errors in nimble driver documentation
+* api-ref: Correct the cgsnapshot\_id parameter
+* Test running jobs under py36/bionic
+* Imported Translations from Zanata
+* Clean output of driver list generation
+* Fix QNap docstring format
+* Fix driver docstring RST formatting
+* Add VERSION and WIKI\_NAME to NEC driver
+* Remove deprecated lvm\_max\_over\_subscription\_ratio
+* Add Keystone v3 domain information to context
+* RBD: Handle ImageNotFound exception in \_get\_usage\_info correctly
+* QNAP: driver fails to create volume and snapshot in some case
+* RBD: add support for active/active replication
+* Dell EMC SC: Removed space from debug statement
+* Collect resource id from RequestSpec parameter
+* Add missing VolumeAttachStatus enum field
+* Clearup duplicate req\_version variable
+* Parent of RBD cloned volume marked as deleted should not be manageable
+* Fix backup/restore error for ceph rbd backend
+* Trivial: Update pypi url to new url
+* WinSMB volume driver doc: Add Volume backup support
+
+13.0.0.0b1
+----------
+
+* Dell EMC SC: Enabled multiattach in Storage Center Driver
+* Clarify sizing when creating vol from source
+* Improve API method logging
+* NetApp ONTAP: Set new sub-lun clone limit for ONTAP driver
+* Adding abstract class NVMeOF
+* V3 jsonschema validation: volume\_transfer
+* Imported Translations from Zanata
+* FC: refactor fczm utils decorators to functions
+* VMAX driver - Attaches/detaches after host assisted retype failing
+* V3 json schema validation: volume manage
+* V3 json schema validation: workers
+* RBD snapshot needs to be protected/unprotected after being managed/unmanaged
+* VMware: Extend volume after clone
+* Set sample\_default for 'host' option
+* Uncap eventlet
+* ZFSSA implement "Enhance iSCSI multipath support"
+* Rephrase for multiattach support
+* NetApp ONTAP: Fix export path used as volume name
+* Use InvalidConfigurationValue instead of InvalidInput
+* NEC docs: add new features and improve description
+* Update the HP MSA and Lenovo driver documentation
+* ZFSSA accept pool stats when cluster node stripped
+* Refresh volume when checking for conflicting attachments
+* nimble: update documentation for supportability
+* Doc: Add driver security notes to contributor doc
+* Move MV history under API Microversion contrib docs
+* V3 jsonschema validation: snapshot\_actions
+* Fix mocks for ZFS Storage Appliance unit tests
+* Storwize: Report backend state in service list
+* Add doc to pep8 check\_exec
+* VMAX docs - miscellaneous clarifications
+* [Optimise] Use ThreadGroup to manage periodic tasks
+* Update auth\_uri option to www\_authenticate\_uri
+* add lower-constraints job
+* Unignore .stestr.conf
+* VNX: fix performance in create/delete\_volume
+* Default pep8/fast8 to run under python 3
+* Move testing info higher in contrib docs
+* Clean up doc configuration
+* Use sphinxcontrib.apidoc for module docs
+* Remove exec flag from doc files
+* V3 jsonschema validation: volume actions
+* fixs grammar problems and unify format in api-ref
+* Clarify volume migration CLI reference
+* Add delete snapshot preconditions
+* Handle migrating encryption key IDs in Backup table
+* Dell EMC SC: dell-storagecenter-driver docs updated
+* Doc: Add inspur driver doc to toctree
+* VMware: Adding NFS41 datastore as supported
+* Avoid second restart on offline upgrades
+* [Optimize] Validate configured scheduler filters when initialize
+* Remove extended attribute 'os-volume-replication' in Doc
+* Cleanup volume management CLI reference
+* Use check\_virtual\_size to do the size check
+* Unity: fail to detach lun when auto zone enabled
+* Implementation of Cinder driver over FC for Inspur InStorage
+* Dell EMC SC: volume model update return missing vol id
+* Adding image membership check to \_is\_image\_available
+* OVO: support query for disabled services
+* Imported Translations from Zanata
+* Fix doc format errors in module docstrings
+* Remove unused doc extensions
+* Allow extension of volumes with snapshots for VZstorage driver
+* 3PAR: Report backend state in service list
+* Storwize: self assign the SCSI lun id for volume attaching
+* ScaleIO: Prevent usage of unsafe volumes
+* Skip masking of command output over ssh
+* Move openstackdocstheme to extensions in api-ref
+* Unity: Enable ssl verification
+* Storwize: check flashcopy\_rate before mkfcmap
+* Reduce scope of the lock for image volume cache
+* Don't use custom password generating code
+* api-ref: Fix microversion for volume.backup\_id
+* Remove driver-specific notes from extend api-ref
+* Document more review processes
+* fix a typo: s/clent/client/
+* Updated from global requirements
+* [sytle] use http code constant instead of int
+* V3 jsonschema validation: Clusters
+* VNX: fix options incorrect behavior
+* Storwize: modify hyperswap host\_site configuration
+* Support Qemu >= 2.10.0 in Quobyte driver
+* fix a typo in remotefs.py
+* Fix get\_max\_over\_subscription\_ratio docstring
+* Fix: Incorrect replication status on clusters
+* Fix: Including resources in None cluster
+* Follow the new PTI for document build [Updated]
+* Imported Translations from Zanata
+* NEC driver: Disallow access from the source node after live-migration
+* Fix parameter error in image\_utils
+* Remove inappropriate directory space check
+* Add max MV for Queens and fix formatting
+* INFINIDAT: set REST API client parameters
+* Mock local directory testing for image conversion
+* Imported Translations from Zanata
+* Fix vhd image conversion regression
+* Sync snapshot's encryption\_key\_id with volume's value
+* V3 jsonschema validation: types\_extra\_specs
+* DS8K: correct in-use replication vol status
+* Dell EMC SC: ISCSI initialize\_connection fixes
+* nimble: update documentation for supportability
+* Fix incorrect usage of assertEqual() method in RBD unit tests
+* Add missing 'target\_obj' when perform policy check
+* Fix policy in code docs for extended\_snapshot\_attributes
+* Updated from global requirements
+* Imported Translations from Zanata
+* Revert "Stop unnecessarily querying storage for stats"
+* Storwize: filter active wwpns for NPIV
+* Use soft authorize for 'extended\_snapshot\_attributes' policy
+* Add ISCSI driver for Veritas Access
+* Adding Glance method for listing image members and unit test
+* Updated from global requirements
+* QNAP Drivers - Move from httplib to requests
+* Support multiple processes on Cinder Backup
+* V3 jsonschema validation: volume\_image\_metadata
+* Updated from global requirements
+* Fix missing print format error
+* Fix api-ref response code title levels
+* Clean out config deprecation information
+* Fix API reference attach\_mode parameter default for attachments API
+* VMAX docs - prefix emc-vmax-driver.rst with 'dell-'
+* Enable slow tests for lvm-barbican job
+* VMAX driver - Replication failover performance improvement
+* V3 jsonschema validation: qos-specs
+* Updated from global requirements
+* fix spelling error with  errormessage
+* [sytle] use http code constant instead of int
+* Remove ExceptionInParsingArguments
+* Avoid build system IP going into sample config
+* VMAX driver - Retype replicated volumes
+* use defusedxml to avoid XML attack
+* [VNX] Restore snapshot to volume
+* Update links in README
+* Updated from global requirements
+* Add documentation for capacity based quality of service
+* Make the LVM Barbican job vote
+* Fix typo errors
+* INFINIDAT: add support for multi-attach
+* Update doc name and path for dell emc vnx driver
+* Use rest\_status\_code for api-ref response codes
+* Add support for unmanaging snapshot of rbd driver
+* Stop unnecessarily querying storage for stats
+* Allow configuring tpool size
+* Add backup restoration cancellation support
+* Imported Translations from Zanata
+* NetApp: Add use-exact-size parameter when creating a LUN on ONTAP iSCSI
+* Storwize: update flashcopy\_rate range and add it to volume type
+* Add 'list\_volume' in Group show&list API Doc
+* Dell EMC SC: Added timeout options for SC driver
+* VMware: Option to specify datastore name regex
+* [api-ref] Fix 'volume\_id' for in the v3/volumes-v3-volumes-actions.inc
+* Updated from global requirements
+* Imported Translations from Zanata
+* Dell EMC SC: Error Deleting Consistency Group
+* Remove utils.read\_file\_as\_root()
+* 3PAR: Add \`force detach\` support
+* ScaleIO Driver: Document support for ScaleIO 2.5
+* Move release note put in wrong location
+* Fix the testcase of test\_cmd
+* RBD: Add comment about multiattach support
+* Imported Translations from Zanata
+* RBD: Improve connection debug statement
+* Delete redundant code
+* Parse endpoint arguments in SolidFire
+* Api-ref:Add target volume preconditions for backup restore
+* Add functional-py35 gate job
+* Support cross AZ backups
+* Reserve 5 migrations for DB backports
+* Improve ChunkedBackupDriver hashlib calls
+* Fix allocated\_capacity\_gb race on create volume
+* Fix reporting old stats
+* Change order of installation to match previous
+* Log config options with oslo.config
+* RBD: Don't query Ceph on stats for exclusive pools
+* Imported Translations from Zanata
+* Enable hash randomization in unit tests
+* Tests: Fix backup validation with hash randomization
+* Add multiattach reporting to SolidFire
+* Tests: Fix 3par tests with hash randomization
+* Tests: Disable 2 netapp unit tests
+* Tests: Fix NetApp tests with hash randomization
+* Tests: Fix VMAX tests with hash randomization
+* Tests: Fix inspur tests with hash randomization
+* Fix find -delete race in tox
+* Use oslo\_db.sqlalchemy.test\_fixtures
+* Adds a Cache for Volumes Created from Snapshots with Quobyte
+* Add unit test coverage for backup chunkeddriver class
+* Add throughput limits that scale per-GB
+* Change 'hpe3par\_snap\_cpg' to 'hpe3par\_cpg\_snap'
+* Imported Translations from Zanata
+* Updated from global requirements
+* Imported Translations from Zanata
+* Cinder logs rabbitmq password on connection log
+* docs: Fix volume encryption link
+* Tests: Fix python version check
+* QNAP: Pass unit tests with hash randomization enabled
+* Provide a hint when performing a volume action can't find the method
+* Expand on mv 3.50 description
+* Only enforce multiattach policy for retype target
+* 3PAR: Monitor task of promoting a virtual copy
+* Correct attachment create success response code
+* api-ref: note that force detach is admin-only by default
+* Imported Translations from Zanata
+* Stop a connections leak when freeing an SSHPool
+* Remove deprecated fatal\_exception\_format\_errors option
+* VMAX driver - Concurrency issues involving replicated volumes
+* Remove legacy driver name mappings
+* Modify broken link
+* Admin guide documentation for volume multiattach
+* Remove deprecated service-to-driver mapping for backups
+* ScaleIO: Add documentation for containerized overcloud
+* Solving permission errors due to directory ownership on NFS
+* Imported Translations from Zanata
+* Improve logs on scheduler
+* Fix the note of API version in admin doc
+* Fix grammar error
+* Remove "cinder-manage logs" commands
+* Remove some unused parameters in parameters.yaml
+* Fix typos
+* Fix link error in 'Boot from volume' doc
+* Imported Translations from Zanata
+* fix misspelling of 'return'
+* Fix spelling mistakes
+* Fix typos in cinder
+* Enable multiattach capability for the zfssa driver
+* Update reno for stable/queens
+* Fix AZ not matching backend after migration
+
+12.0.0.0rc1
+-----------
+
+* Use provider\_id for SolidFire Volume lookups
+* Deprecate Cinder Hosts API/Extension
+* Add Windows volume backup support
+* Fix json data format
+* Fix UnicodeDecodeError when decode API input
+* Api-ref: add 'all\_tenants' API query option
+* Make CinderException format errors fatal for tests
+* VMAX doc - Queens feature documentation
+* Revert consumed quota when failed to create group from source group
+* Imported Translations from Zanata
+* Zuul: Remove project name
+* Add python 3.5 in classifier
+* Correct lvm\_type default value in config doc
+* modify the http link to the https link
+* Add missing MV history for 3.50
+* Move doc of report backend state to cli
+* Imported Translations from Zanata
+* Fix pylint error in DotHill drivers
+* Imported Translations from Zanata
+* Storwize: avoid ascii code error for ssh response stderr
+* Fix DuplicateOptError in fixed\_key migration code
+* Storwize: modify the self.\_helpers to backend\_helper
+* Update document for worker cleanup API
+* Add backup cancellation admin doc
+* 3PAR: fix cloning issue in create group from source
+* Fix link in boot from volume docs
+* docs: Use the encryption provider format constants
+* Remove unused parameters in v2/v3 parameters.yaml
+* Fix leftovers after backup abort
+* Updated from global requirements
+* Add policy check for create volume with multiattach
+* Dell EMC SC: Find volume folder API call fails on root folders
+* SMBFS: allow snapshot ro attach
+* SMBFS: fix creating volume from snapshot
+* Fix the typo in api\_conditional\_updates.rst
+* Fix wrong grammar
+* [VNX] \`initiator\_target\_map\` is None
+* Schedule request to scheduler when manage existing snapshot
+* Fix how backups handle encryption key IDs
+* Rename lio job to lio-barbican
+* Update Windows docs
+* 3PAR: Fixed sync period updation in rcg
+* Add 'metadata' in backup detail&show API document
+* Handle TZ change in iso8601 >=0.1.12
+* Storwize: correct return value for update\_group
+* Fix cinder quota-usage error
+* Remove consistencygroups/api.py
+* Fix: request-id missing in volume action's response header
+* [Trivial] SMBFS: fix provisioning type usage
+
+12.0.0.0b3
+----------
+
+* Support fabric specific Cisco FC Zone Name
+* DS8K: Correct create volume behavior for CG
+* backup: set default swiftclient log level to WARN
+* Tests: Fix RBD invalid UUID warnings
+* api-ref: add multiattach considerations to retype docs
+* api-ref: update migration\_policy retype note about encrypted volumes
+* fix misspelling of 'password'
+* Netapp Ontap: Adds support for auto-max-over-subscription
+* Overprovisioning Improvements
+* HPE 3PAR: Update Storage Driver docs for Queens release
+* Update the description of quota's project id
+* Fix mis-named context object
+* Add debug logging around multiattach status changes
+* Fix multiattach policy names in release note
+* Add back support for the multiattach flag for volume create
+* Remove logging on Swift backup obj writer
+* Simplify keystone password assertions
+* Add policy check for complete attachment API action
+* [1/2] Fix mock for sleep mocks in volume drivers tests
+* fix wrong url link
+* Fix typo in test\_qnap
+* Add contributor notes on how to use pdb with tests
+* Run doc8 first
+* RBD: Support encrypted volumes
+* INFINIDAT: support force detach
+* Replace Chinese punctuation with English punctuation
+* nimble: update config doc to add missing extra-specs support
+* Add the nova-multiattach job to the check/gate queues
+* Remove extra spaces of the volume creation request body
+* V3 jsonschema validation: volume\_type\_access
+* Move disk space check to run when needed
+* Update Volume Encryption Documentation
+* Avoid use of deprecated commands in lenovo driver
+* Rename 'WindowsDriver' to 'WindowsISCSIDriver'
+* Fix readonly mode for new attachment API calls
+* Enable multiattach capability for lvm driver
+* 3PAR: fix volume migration for "in-use" volume
+* modify volume spelling errors
+* modify http to https
+* Fix api-ref for v3 volume group types
+* Fix combination of parameters for update APIs
+* Add enough notification for QoS
+* Unity: Add revert\_to\_snapshot support
+* Adapt cinder backup swift help test
+* Enable multiattach capability
+* Add multiattach policy
+* Updated from global requirements
+* Fix api-ref for v3 volume types
+* [VNX]Add \`force detach\` support
+* [Unity] Add \`force detach\` support
+* Storwize: fix an incorrect temporary parameter name
+* Update nfs driver doc for snapshot support
+* Storwize: use DLM locks
+* Fix BadRequest for 'ref' as string value
+* Remove leading and trailing spaces from parameters
+* Adds documentation for DataCore volume driver
+* Storwize: Use passed volume names in migrate
+* Fix glance create client unit tests
+* Updated from global requirements
+* Run backup-restore operations on native thread
+* Fix compression related tests
+* INFINIDAT: add missing connection\_info params
+* Update volume's 'updated\_at' when accept transfer
+* Tests: Fix Storpool tests hash randomization failure
+* Fix: Propagate OS global request ID
+* Fix Backup uses latest req-id for all log calls
+* Fix BadRequest for 'null' metadata and group\_specs
+* Fix api-ref for v3 Services
+* Delete duplicated save operation when do backup creating
+* Fix dictionary mistakes in docstring
+* Fix 'volume\_type' for in the api-ref
+* Remove the deprecated "giturl" option
+* Remove unused lib in test-rquirements.txt
+* VMAX driver - retype fix where workload is None
+* VMAX driver - QOS settings incorrectly applied on Default storage group
+* VMAX doc - Queens feature documentation
+* DS8K: block in-use volume to be added to consistency group
+* [Doc] Add replication group support in doc for Storwize
+* Fix version details API does not return 200 OK
+* Dell EMC SC: On None connector terminate\_connection unmaps all
+* Deprecate the allow-multiattach option to create
+* Improve multiattach error message
+* ScaleIO: Enable multiattach for volumes
+* Windows: allow multiple c-vol backends per service
+* Check create from image policy when image not none
+* Validate metadata before reserve quota
+* api-ref: fix the response parameter for multiattach
+* Docs: ibm\_storage\_driver: Fix volume\_driver path in documentation
+* Synology: Rename iSCSI target config option
+* Revert volume consumed capacity when rescheduling
+* 3PAR: fix create group from source functionality
+* Initialize osprofiler in WSGI application
+* VMAX driver - Multiple storage group creation attempts
+* Fix: validation error if the optional parameter's value is None
+* Storwize: correct in-use replication vol status
+* Unity: Attach Unity volume via IPv6
+* Fix v3 api-ref for showing API details url error
+* VMware:Config option to disable lazy volume create
+* VMware: Support volume adapter type change
+* Tests: Fix XIV test failure with hash randomization
+* Block attempts to transfer encrypted volumes
+* Mock FixedIntervalLoopingCall for Huawei unit tests
+* [api-ref] Add missing fields to the API Reference
+* V3 jsonschema validation: Backups
+* Storwize: add hyperswap volume support
+* Handle InvalidVolume when creating a volume attachment
+* RBD: get manageable volumes
+* Fix reserve volume enforcing the wrong policy action
+* Fix api-ref for v3 volume types
+* Add descriptions of base policies
+* Do not explicitly list thin provisioning tools for RPM
+* Add driver-requirements entry for storpool
+* DS8K: correct LSS behavior for CG snapshots
+* V2/V3 json schema validation: snapshot manage
+* V2/V3 jsonschema validation: snapshots
+* VMAX driver - Fix AttributeError of dell emc driver
+* VMAX driver - Errors extending replicated volumes
+* VMAX driver - Fix error handling and checks for generic volume groups
+* VMAX driver - revert a volume to last snapshot
+* VMAX driver - Incorrect stats reporting
+* VMAX driver - support for manage/unmanage snapshot
+* VMAX driver - retypes failing when workload is missing
+* VMAX driver - Implement SRDF Metro feature
+* VMAX driver - Cannot extend volumes in a replication relationship
+* VMAX driver - Enable CHAP authentication for vmax backend
+* VMAX driver - Add async replication support
+* Validate volume status again when snapshot created
+* Use constants for cinder-volume
+* Reintroduce the StorPool driver
+* Report backend state in service list
+* Remove some no-use code about failover
+* Add instructions for the Error response codes
+* Fix incorrect description in api ref
+* V3 jsonschema validation: Volume-types
+* Update 'force' parameter for volume delete API
+* NEC driver: implement manage/unmanage functions
+* Adding all docs into index.rst of administration docs
+* Missing generalized\_filters in cinder administration doc
+* Updated from global requirements
+* Deprecate CG APIs
+* Bump up the API microversion in cinder.rc
+* Add microversion and volume status limit to revert api ref doc
+* HPE 3PAR - Implement Tiramisu feature on 3PAR
+* Enable fail back in SolidFire driver
+* StorageCenter: Fix volume mapping for API v3.1
+* Update tgt iSCSI target on volume extend
+* Follow the new PTI for document build
+* NEC driver: add automatic configuration of SAN access control
+* Remove unused sf\_enable\_volume\_mapping conf option
+* Add admin ctxt to request qos\_specs in SolidFire
+* Remove In-repo cinder tempest plugin
+* V3 jsonschema validation: Group Snapshots
+* VNX: Fix cloning failure when system is busy
+* InStorage: fix problem when doing instance live migration
+* NFS: Fix nas\_secure auto mode permissions failure
+* Add online data migration routine for attachment\_specs
+* NetApp: Fix to support SVM scoped permissions
+* Dell EMC SC: API 4.0 incompatibilities
+* Trivialfix -- Fix spacing in docstring
+* VMAX doc - Queens feature documentation
+* Create group from snapshot-group failure leaves behind the volume
+* SMBFS: fix detecting if a volume is in-use
+* Raise PolicyNotAuthorized exception on consistency Group snapshot
+* Fix some typos in cinder doc
+* Updated from global requirements
+* Fix volume image metadata endpoints returning None
+* NetApp E-Series: Fix broken generic volume groups
+* Fix migration Invalid volume message
+* [api-ref] Fix http method for updating encryption type
+* Fix create encrypted volume from image
+* Storwize: disable creating volume with non cg\_snapshot group\_id
+* Rename iSCSI target config options to more general
+* 3PAR: Update CHAP on host record when volume is migrated to new compute host
+* Use method validate\_integer from oslo.utils
+* Add 'shared\_targets' only when it doesn't exist
+* Use defusedxml for XML parsing
+* Remove deprecated 'pybasedir' config option
+* Remove deprecated 'netapp\_eseries\_host\_type' config option
+* Remove deprecated HP 3PAR config options
+* Remove deprecated 'nas\_ip' config option
+* Fix indentation in docs
+* Fixes creation of mirrored volumes due to wrong type
+* Check for migrated UUID in SolidFire delete
+* Add thin provisioning package to install guide
+* Correct documented service upgrade order
+* VMAX doc - Queens feature documentation
+* Add service\_token for cinder-glance interaction
+* Add service\_token for cinder-nova interaction
+* Switch to oslo\_db retry decorator
+* Don't call driver.terminate\_connection if there is no connector
+* Store host connector in volume\_attachment.connector column
+* qemu-img info --force-share for NFS driver
+* NetApp ONTAP: Copy offload bugfix
+* Cleanup XtremIO IG cleanup note
+* SMBFS: remove deprecated config options
+* Storwize: fix group creation restrict rules
+* Restore\_backup: set error when volume status not matched
+* Keep v3 api-ref error response code 404 for reverting
+* Speed up DataCore unit tests
+* API ref: add host format to description
+* Fix discrepancy in api-ref for volume\_types APIs
+* Fix json formatting eror
+* V3 jsonschema validation: Group type specs
+* Don't raise 'NotAuthorized' inside when soft authorization
+* Change ssh\_utils parameter to correctly sends keepalive packets
+* Modify v3 api-ref error response codes for reverting
+* Removed gb quota decrement in grp snapshot delete
+* Add output of slowest tests to UT runs
+* Fix available space checking for image conversion
+* Deprecate cinder-manage logs commands
+* QNAP: Add support for QES 2.0.0
+* Fix test case in test\_volume\_unicode.py
+* VMAX Doc - clarification and typo fixes
+* Updates Help Text on Quobyte Volume URL Option
+* V3 jsonschema validation: Volume metadata
+* Fix create from snapshot and source volume
+* VMware: Bump driver version
+* Check snapshot flag for test\_snapshot\_create\_volume\_description\_non\_ascii\_code
+* Updated from global requirements
+* Fix discrepancy in api-ref for create volume manage api
+
+12.0.0.0b2
+----------
+
+* Remove skip\_validation\_flag to False by default
+* XtremIO: optional clean IG with no mappings
+* Fix api-ref for v3 group type specs
+* TrivialFix: Delete word ‘I’ in admin/blockstorage-backup-disks.rst
+* Fix TypeError for workers cleanup api incase of invalid resource\_type value
+* DS8K: don't swap role after failover group
+* Updated from global requirements
+* DS8K: lss\_range\_for\_cg should take csv as well as range
+* Fix for volume from image snapshot free space issue
+* NEC driver: delete an unused configuration parameter
+* INFINIDAT: change CI\_WIKI\_NAME
+* V3 jsonschema validation: Group types
+* Add test for volume create with non-ascii characters
+* Add cg policies and clean up old policy handling
+* Migrate fixed\_key encryption keys to Barbican
+* Add shared\_targets and service\_uuid to volumes
+* Pass in the parameters multipath when migrating volume
+* Discrepancy in api-ref and code for create group type API
+* Imported Translations from Zanata
+* Remove extra test variable assignment
+* Tests: Cleanup utils.create\_volume fields
+* Imported Translations from Zanata
+* Discrepancy in api-ref and code for create group snapshot API
+* Tests: Fix Storwize hash randomization failure
+* added clarification in docs for usage of "volume\_clear\*" options
+* Disallow unmanaging encrypted volumes
+* Disallow managed volume to be managed again
+* Fix project\_domain\_name and user\_domain\_name in doc
+* Add support for enhanced features to the QNAP Cinder driver
+* Mock out CLI execution in NEC driver tests
+* handle no default\_cgsnapshot\_type
+* Add shared\_targets flag to Volumes
+* Allow purging of records less than 1 day old
+* Update the documentation links
+* Support create volume from backup
+* Fix 'KeyError' when 'with\_count' is not specified
+* Consolidate code that manages encryption keys
+* Use new oslo.db test cases
+* Move legacy-cinder-tox-\* jobs in-tree
+* Add cleanup to TestCase.flags()
+* HPE3PAR: Create FC vlun as host sees
+* Support create a volume from image snapshot
+* Filter valid FC initiator while FC attaching
+* Remove invalid parameters in the file testing.rst
+* SMBFS: manageable volumes
+* Fix retype migrating volume with rep\_status 'not-capable'
+* Adds DataCore Volume Drivers
+* Handle quota in 2 phases when managing resource
+* RBD: support driver-assisted volume migration
+* Update unity tests to use our test base
+* Update access control of show under hostAPI
+* Modify the wrong link in document
+* V3 jsonschema validation: Attachments
+* Add fixture to only emit DeprecationWarning once
+* Remove DB authorisation checking with quota API operations
+* Update oslo.context RequestContext args
+* Update bindep.txt for doc builds
+* nimble: handle unicode strings in volume create
+* Handle deprecation of inspect.getargspec
+* Add service\_uuid FK to volumes
+* Fix policy documentation for os-show\_image\_metadata endpoint
+* Fix group\_type\_id in api-ref
+* Imported Translations from Zanata
+* VMware: Backend driver for VStorageObject
+* NetApp ONTAP: Fix delayed snapshot deletion call
+* Suppress UT log messages
+* Try Fetching value from 'cluster' when raise exception
+* Fix v3 api-ref for restoring backup are wrongly described
+* Fix qos-spec-v2-qos-specs error
+* Add v3 api-ref for showing encryption specs item
+* Explicitly set expected log level for tests
+* Update api-ref to include volume\_image\_metadata
+* Remove ExceptionTestCase
+* V3 jsonschema validation: base schema framework
+* Check available capacity before creating resources
+* Remove setting of version/release from releasenotes
+* Test os-brick master in LIO gate job
+* Storwize: revert to snapshot support
+* Fix cinder-manage volume delete
+* api-ref: fix 203 error response codes to be 403
+* Inspur Cinder iSCSI driver
+* [Trivial] set min max\_over\_subscription\_ratio to 1
+* Add doc/source/\_static/cinder.policy.yaml.sample to .gitignore
+* Fix 'D005 No newline at end of file' Error
+* Fix controller install document indentation
+* Fix earlier backup records can't be restored
+* Fix several instances of chap secret being output to logs
+* NetApp cDot: Fix manage volumes
+* Fix resource count for os-host show
+* Correct gb,snapshot quota update in group snapshot
+* HPE 3PAR: Handle single path in FC configuration
+* Remove v1 API reference
+* NetApp ONTAP: Remove orphaned 7mode file
+* Prevent leaking encryption key when deleting volume
+* Schedule request to scheduler when create group from resource
+* Re-add QNAP Cinder volume driver
+* Add missing 'obj\_make\_compatible' in RequestSpec object
+* Tests: Rework volume deletion w/ invalid status test
+* set vg\_thin\_pool\_size to float type
+* Added mount fstype based validation of Quobyte mounts
+* HPE3PAR: Modify host & clear zone after detach
+* Use oslo\_db.sqlalchemy.enginefacade
+* Add .zuul.yaml with LIO job
+* Updated from global requirements
+* Unity: Remove redundant debug logging
+* Change default test log level
+* Handle assertRaisesRegexp Python 3 deprecation
+* Switch kaminario to use standard trace decorator
+* NetApp E-series: Fix provisioned\_capacity\_gb
+* Fix VolumeAttachment OVO Volume lazy loading
+* Use oslo\_log instead of logging
+* Remove deprecated keymgr code
+* VMAX doc - add manage and unmanage section
+* HPE 3PAR: Adding driver capability
+* Improve cinder revert-to-snapshot notifications
+* create\_volume: cleanup consistencygroup when driver exception
+* Improve deleting-missing-backup exception handling
+* SMBFS: add fixed image support
+* ScaleIO - Cleanup and enhance configuration doc
+* Remove unused print\_function imports
+* Schedule the request to scheduler when creating from snapshot/volume
+* Optimizes volume creation in the Quobyte Driver
+* ScaleIO: Update CI Wiki name
+* ScaleIO: adapt to moved connector constants
+* imageutils: allow passing subformat when converting
+* Unity: Fix duplicate hosts created with same name
+* Update setup instructions
+* Make test logging setup fixture disable future setup
+* XtremIO: extending volume in create\_volume\_from\_snapshot
+* Use total reserved quota value instead of partial
+* Tintri - Updated driver docs with new nfs option
+* Fix imageutils tests on windows
+* Fix api-ref for group snapshots API
+* HPE 3PAR: ISCSI/FC drivers – code refactoring
+* Storwize: Fix typo in log message
+* SMBFS: Enable reverting snapshots
+* DS8K: update replication\_status in generic group APIs
+* Disco driver: Fix the location to get the disco connector constant
+* Storwize: add backup snapshots support
+* Fix migate\_volume API with replication\_status ‘not-capable’
+* Make service object UUID not nullable
+* Don't fail when deleting missing backup
+* ibm-storage: Fix create\_volume\_from\_snapshot
+* Fix incorrect use of assertFalse causing CI failed
+* [TrivialFix] Remove errant comma in capabilities policies
+* Tests: Fix coverage unit test failure
+* Dell EMC: Update PS and SC CI wiki names
+* Dell EMC PS: Fix Duplicate ACL records Issue
+* Completely remove mox from Cinder unittest
+* Support count info in List&Detail APIs
+* Remove doc/build before running docs job
+* VMware: Add profile ID to connection info
+* VMware: Revert to snapshot
+* VMware: Improve scalability of querying volumes
+* Fix manage\_existing API behaving wrongly with storage pools
+* NetApp ONTAP: Remove support for 7mode systems
+* Fix key\_manager API call
+* Revert "Tests: Fail if oslo.versionedobjects issues Invalid UUID warnings"
+* Imported Translations from Zanata
+* INFINIDAT: add support for overprovisioning
+* Clean up driver configuration reference
+* Fix migration 112 to use live\_data\_migration API
+* Enable using extra-specs for SF attributes
+* Add policy documentation and sample file
+* ScaleIO Driver - include snap usage in provisioned capacity
+* VMAX driver - Deprecate backend xml configuration
+* VMAX driver - Remove workload for next gen arrays
+* VMAX driver - Implement Tiramisu feature on VMAX
+
+12.0.0.0b1
+----------
+
+* Revert "Move vol\_db\_empty to NFS driver"
+* Change Install 'Tutorials' to 'Guides'
+* Add index for reservations on (deleted, uuid)
+* Redundant alias in import statement
+* RemoteFS: revert snapshot support
+* DS8K: support clone volume asynchronously
+* Move 'zoning\_mode' back to DEFAULT section
+* Add display\_name to solidfire volume attributes
+* FlashSystem: Add CMMVC6045E CLI error for multi-host mapping
+* Add v3 api-ref for updating specific extra specs for a volume type
+* Fix "import xx as xx" grammer
+* NEC driver: Never use target info in migration\_status
+* VMAX driver - detach volume shouldn't remove from volume groups
+* VMAX driver - Volume identifier issues
+* VMAX driver - concurrently deleting volumes can fail
+* Replace http with https for doc links in cinder
+* [policy in code] Add support for volume, volume type resources
+* DS8000 ConsistencyGroup failed to update group with volumes
+* ScaleIO Driver: Backup volume via snapshot
+* Run backup compression on native thread
+* Fix backup compression unit tests
+* Make stringify header work under python2
+* Api-ref: Add missing api response for volume transfer
+* Switch from ostestr to stestr
+* Add v3 api-ref for showing all/specific extra specs for a volume type
+* Remove deprecated nova config options
+* Switch Rally Task To format V2
+* Update configuration names in ITRI DISCO volume driver
+* Kaminario K2: Add non discovery iSCSI multipath
+* Fix backup-import error when the deleted record in the same db
+* Updated from global requirements
+* FlashSystems: permit snapshot/clone volumes larger than source
+* Deprecate SolidFire Image Caching feature
+* [policy in code] Add support for service, limits
+* [policy in code] Add support for qos and quota resources
+* Vzstorage: improvement of create\_cloned\_volume
+* [policy in code] Add support for group, g-snapshot resources
+* Add ability to specify backup driver via class name
+* Add documentation for API 'validate\_setup\_for\_nested\_quota\_use'
+* [policy in code] Add support for backup resource
+* VMAX driver - documentation updates around versions
+* Add Storwize replication group support
+* VNX: Fix issue when creating without type
+* Remove deprecated VD base classes which are not used now
+* Kaminario K2: Support duplicated FQDN in network
+* NEC driver: Fix exception in terminate\_connection with no connector
+* [policy in code] Add support for snapshot resource
+* Add v3 api-ref for deleting extra spec for a volume type
+* Switch base to the latest in doc link address
+* Replace the usage of some aliases in tempest
+* Update tenant to project in cli quota doc
+* ScaleIO Driver - adding cache and refactoring tests
+* Remove API check is\_valid\_body
+* Add .stestr.conf configuration
+* Do not load extendable routes for the Versions router
+* Remove newton-compat upgrade code on service startup
+* Remove Hitachi volume drivers
+* Remove Tegile volume driver
+* Remove ZTE volume driver
+* Remove X-IO volume driver
+* Remove Violin volume drivers
+* Add retries to LVM logical volume activation
+* Remove Reduxio volume driver
+* Remove QNAP volume driver
+* Cleanup some todo's for refresh()
+* Update BlockBox
+* Brocade: Add HTTP connection cleanup
+* Remove Infortrend drivers
+* VMAX driver - remove WLP stats
+* Remove deprecated heartbeat options
+* Dell EMC PS: Fix extend volume creating unmanaged snapsots
+* Remove deprecated osapi\_volume\_base\_URL
+* Clean up docs landing page
+* Dell EMC PS: Optimize parsing of capacity info from backend
+* Dell EMC PS: Fix over-subscription ratio stats
+* Doc: Move generalized\_filters to admin
+* Doc: Configuration: Remove some outdated Ceph info
+* Add ploop to parallels naming conversion
+* Generate create\_at date in usage in isoformat for backups/snapshots
+* Add uuid to services entries
+* Fix tempest test revet\_client typo
+* Fix Tempest Volume Revert test
+* Fix Reset a snapshot's status API Request Example
+* Replace DbMigrationError with DBMigrationError
+* Fix description for volume\_type object in API Ref
+* Mark Cisco FC ZM driver as unsupported
+* Fix v3 api-ref for updating extra specs of volume type
+* Add backups v3 views
+* Storwize: add NPIV support
+* Address importing directory issue
+* Stop overriding LVM overprovisioning ratio and deprecate
+* Clean up api-ref index page
+* Update provider parameter in sample json files
+* NetApp ONTAP: Fix reporting of provisioned\_capacity\_gb
+* Fix api-ref for reset group snapshot
+* Remove legacy driver name mappings
+* Api-ref: change 'tenant' to 'project' in v2 doc
+* [policy in code] Add support for message, worker, cluster resources
+* 3PAR: Cinder volume revert to snapshot support
+* Compact Newton database migrations
+* Add indexes to SQLAlchemy models
+* Updated from global requirements
+* [policy in code] Add support for attachment resource
+* Api-ref: fix v2/v3 hosts extension api doc
+* nimble: fix for parent volume delete
+* Check for outstanding attachments during reserve
+* Remove SCREEN\_LOGDIR from devstack install setting
+* nimble: update config doc for unicode unsupported
+* Use constants for microversion values
+* Add default configuration files to data\_files
+* HPE 3PAR: fix delete operation of replicated volume
+* Revert status to previous state on extend failure
+* Clear cached autogenerated docs before docs build
+* Switch to use key\_manager.backend
+* LVM: Activate thin snapshot before clone activation
+* [DOC] Update index page for Install tutorial
+* docs: Fix typo error in blockstorage-driver-filter-weighing.rst
+* Remove leftover API v1 cruft
+* Fix a migration issue of Huawei driver
+* DRBD: Remove unneeded list length checks
+* Add another hack from NOVA\_GROUP to generate\_cinder\_opts.py
+* Remove FalconStor volume drivers
+* RBD: get provisioned capacity using same connection
+* Add missing snapshot action in index.rst
+* [DOC] Remove duplicate build of module index
+* docs: link to the api-ref for 3.27/3.44 for the version history
+* api-ref: document microversions for the attachments API
+* Updated from global requirements
+* Update generate\_cinder\_opts path
+* Link to API version history from main index
+* Create custom assertTrue and assertFalse
+* Signal the max v3 microversion for mitaka
+* Adding project id check
+* Remove Glance v1 API support
+* Add tempest configuration for the LIO CI job
+* IBM XIV: Fix ordered use of a dict
+* Use newer location for iso8601 UTC
+* Remove Blockbridge volume driver
+* Remove Coho volume driver
+* Use conditional update for group update and delete
+* Implement keymgr list() method
+* Synology: Driver unable to be initialized
+* ibm\_storage - fix enable replication after disable
+* Fix wrong links in Cinder
+* Support az filter for snapshot
+* NetApp: Remove redundant QoS cleanup task
+* Fix test\_rpc\_consumer\_isolation for oslo.messaging 5.31.0
+* Tests: Don't write files to /tmp/nec/
+* vzstorage: return from \_create\_cloned\_volume
+* NetApp: Adds logging of ONTAP API version
+* Fix attachments on volume show when volume is attaching
+* Remove API v1
+* Deprecate service-to-driver mapping for backups
+* VMware: Use vSphere template as snapshot format
+* Fix an compatibility issue after Huawei driver upgrade
+* VMware: Add 'managedBy' info
+* VMware: Remove unused variables
+* Remove glusterfs documentation
+* Fix use of outdated ternary operator
+* Remove unsupported BlockDeviceDriver
+* [Api-ref]: Add missing key/values in the json files
+* Update HPE 3PAR Storage Driver docs for Pike release
+* api-ref: Normalize response codes
+* api-ref: Remove unused parameter defs
+* Fix 'fix\_allocated\_quotas' doesn't work when validate setup
+* Updated from global requirements
+* Remove vestigate HUDSON\_PUBLISH\_DOCS reference
+* Dell EMC PS: Report total volumes on the backend
+* api-ref: Make v3 enclosing objects consistent
+* HPE Lefthand: fix volume manage operation
+* api-ref: Clarify os-host GET behavior
+* Fix python 3.6 escape char warnings in strings
+* Fix InvalidUUID warnings in unit tests
+* Fix installation instructions format
+* cleanup cg field when create image cache volume
+* Don't collect snapshots again when sync provider info
+* Fix python 3.6 escape char warnings in strings
+* Add contributor doc on assertEqual vs assertFalse
+* [Api-ref] Add api doc for attachment complete
+* Unhide errors from check\_uptodate.sh
+* Make sure that versions are applied as relative URLs
+* Don't lock whole project's resource when reserve/commit
+* VMAX driver - Pike documentation amendments
+* Correct contributor doc information
+* [Doc] Handle Sphinx warnings as errors
+* Making reservations before group creation
+* [DOC BLD FIX] Fix remote-code-block warnings
+* [DOC BLD FIX] Make opts sections lowercase
+* Reserve 5 migrations for DB backports
+* Hpe: reduce duplicate validation
+* Storwize: reduce duplicate validation
+* Use backup\_use\_temp\_snapshot setting for default
+* api-ref: Add group replication APIs
+* Update the documentation link
+* Fix allocated capacity report on non pool drivers
+* Modify some spelling mistakes in cinder
+* Correct module path in doc
+* TrivialFix for the docstring and json format
+* Remove duplicate variables in v3
+* api-ref: Add backup import and export
+* Stop using internal \`oslo\_log.log.\_loggers\` dict
+* Removed unnecessary tearDown() methods
+* Updated from global requirements
+* HPE Lefthand: fix volume retype operation
+* Update HPE Lefthand/StoreVirtual Storage Driver doc for Pike release
+* Add missing PrettyTable requirement
+* Make cinder-manage service list to print full host
+* [DOC BLD FIX] Fix duplicate content warnings
+* Fix IntOpt type of VMAX config options
+* RBD: Fix stats reporting
+* NEC driver reads default\_backends
+* Cisco zonemanager: fix create multi-fabric zones
+* Update the documentation link
+* Api-ref: add 'os-services' v3 api doc
+* VStorage: make logging path configurable
+* Allow v3.0 volume metadata API calls
+* [Doc Bld Fix] Add links to man page contents
+* Ibm\_storage - fix create volume into group
+* Revert "Mark Virtuozzo driver as unsupported"
+* Updated from global requirements
+* Add input format check for qos\_spec update
+* IBM Storage: add QoS documentation
+* 3PAR driver-requirements name
+* Move config-generator to tools
+* Add releasenotes to check\_exec list
+* Ibm\_storage - fix delete group with replication
+* Ibm\_storage - fix failover\_replication
+* IBM storage: check pyxcli version on initialize
+* [Docs] Storwize:Update document for Pike release
+* [Api-ref] Add worker cleanup for service docs api
+* VMware: Add support for cloning attached volumes
+* Write maximum version of Pike
+* Do not fail if RBD image is broken
+* Save object after updating for attachment\_complete
+* RBD - volume create failed when volume need flatten
+* Change pure drivers default replication interval
+* ibm-storage: enable FC zonning to all ports
+* Make attachment\_update set status to attaching
+* 3PAR: Fixed image cache enabled capability
+* Get correct hypermetro remote lun ID while mapping
+* cinder incremental backup with ceph fails if last one deleted
+* SMBFS: enable thin provisioning support flag
+* Fix wrong links
+* Update reno for stable/pike
+
+11.0.0.0rc1
+-----------
+
+* [Docs] Pull over Cinder service overview for install
+* [Docs] Add documentation contribution docs
+* [DOC FIX] Create missing index pages
+* Revert "Mark ETERNUS drivers as unsupported"
+* Fix bug of detaching failed while concurrently attach/detach
+* NetApp: block drivers fail when volume missing
+* Eliminate randomness in encode\_name&encode\_host\_name methods
+* Fix missing print format error
+* NetApp: Fix override of scheduler decision
+* INFINIDAT: add documentation for volume compression
+* INFINIDAT: add driver changelog
+* [api-ref] Add api-ref for os-quota-class-sets APIs
+* Pike release note cleanup
+* Replace dict.iteritems/iterkeys with dict.items/keys
+* [Api-ref] Add metatdata parameters to backup create/update
+* Load resource filter config file in testcase
+* Fix wrong param transfer in scheduler flows
+* [DOC BLD FIX] Fix user messages documentation
+* [DOC BLD FIX] Fix missing references in documentation
+* Make Cinder's Landing Page look like Keystone's
+* Fix message format for VolumeAttachmentNotFound exception
+* Clean up repl v1 volume creation from replication
+* Modify a little desc to satisfy the code
+* [Api-ref] Add force parameter to volume delete
+* Updated from global requirements
+* [DOC BLD FIX] Name files for inclusion properly
+* Revert "NetApp: Deprecate E-Series drivers"
+* VMAX driver - Error attaching failed over volumes
+* VMAX driver - None connector object in a terminate\_connection in Pike
+* VMAX driver - performance improvements in retype
+* VMAX driver - volume delete can fail
+* Remove duplicate variables
+* Fujitsu Driver: Fix exception in terminate\_connection with no connector
+* Infortrend mask password logging
+* VMAX driver - seamless upgrade from SMI-S to REST
+* VMAX driver - performance improvements
+* Fix host and cluster\_name filter for snapshot list
+* Refresh az cache if target az is not found in cache
+* Remove redundant mock rpc statement
+* Fix grammatical mistake, Changed character from "a" to "an"
+* VMware: Bump driver version
+* Make VolumeTypeExtraSpecsController policy more granular
+* Updated from global requirements
+* [DOC] VMware: Add doc for vmware:adapter\_type
+* [DOC] VMware: Update config table
+* Update resource\_filter to keep backward compatibility
+* Switch to using bool for filtering non-deleted volume attributes
+* Correct 'os-show\_image\_metadata' API document
+* Sort cinder-manage commands
+* VMAX driver - Pike documentation
+* Catch Castellan errors in create volume
+* Removed unnecessary setUp() call in unit test
+* Add API document for quota usage
+* Cloning a volume from a snapshot in thin lv
+* [DOC BLD FIX] Fix the numerous docstring probs in coprhd
+* NetApp: Fix SVM scoped user startup exception
+* Missing snapshot statuses
+* [DOC BLD FIX] Correct docstring errors in dell\_emc VMAX
+* Fix image download to volume for iso images
+* [DOC BLD FIX] Add missing files under configuration
+* VMAX driver - align VMAX QOS settings with front end
+* Fix layout of api-ref for group type specs
+* Fix failure for failing back the primary
+* Updated from global requirements
+* Revert "Handle concurrent volume creation request"
+* NetApp cDOT: Support generic groups for block
+
+11.0.0.0b3
+----------
+
+* Fix typo in message for volume creation failure
+* Update and replace http with https for doc links in Cinder
+* Add the backup metadata support releasenote
+* Update backend state when extending volume
+* Handle concurrent volume creation request
+* [DOC BLD FIX] Correct json code block in attachments
+* [DOC BLD FIX] Fix docstring error in fakes.rst
+* cinder backup sets incorrect parent\_id
+* Update URL home-page in documents according to document migration
+* Mock execute in unit test
+* Revert MySQL Cluster Support until an approach is worked out
+* [DOC BLD FIX] Add code:: blocks to manager.py
+* [DOC BLD FIX] Fix docstring problems in vzstorage driver
+* [DOC BLD FIX] Fix dosctring errors in veritas driver
+* [DOC BLD FIX] Correct docstring issues in Soldfire driver
+* Fix no feature to enable 'exclusive-lock' of image in ceph
+* [DOC BLD FIX] Fix docstring issues in hpmsa driver
+* Mark Tegile driver as unsupported
+* [DOC BLD FIX] Fix docstring errors in reduxio
+* Updated from global requirements
+* Add choices to backup\_swift\_auth
+* Support metadata for backup resource
+* VMware: Cache storage profile ID
+* Use OVO for test\_backup
+* Fix release notes link
+* VMware: Add volume adapter type extra-spec option
+* [DOC BLD FIX] Fix docstring errors in nexenta driver
+* Remove references to dothill driver options
+* [DOC BLD FIX] Fix netapp docstring issues
+* [DOC BLD FIX] Fix docstring issues in Lenovo driver
+* [DOC BLD FIX] Fix docstring errors in VNX driver
+* Add cinder backup service initialize check
+* Volume type with encryption comparison
+* [DOC BLD FIX] Fix docstring issues in ibm\_storage
+* NetApp cDOT: Support generic groups for file
+* [DOC BLD FIX] Fix docstring issues for Hitachi HNAS driver
+* Updated from global requirements
+* [DOC BLD FIX] Correct docstring errors in falconstor driver
+* [DOC BLD FIX] Fix docstring issues in dothill driver
+* [DOC BLD FIX] Correct dosctring errors in disco driver
+* Fix test\_scheduler\_stats error module calls
+* Add a check warning for quota update
+* Add VNX replication group support
+* [DOC BLD FIX] Fix docstring errors for VMAX driver
+* ibm\_storage - fix disable/delete replication
+* Updated from global requirements
+* Update group status
+* VMware: Optimize volume creation from image
+* [DOC BLD FIX] Fix formatting error in driver.py
+* LVM: Activate LV before creating exports
+* Disable merge snapshot to volume for thin LVM
+* Replace six.itervalues with dict.values() in cinder
+* Convert lenovo driver to use distributed lock manager
+* Do not delete group if group snapshot exists
+* ProphetStor: Support generic group
+* Updated from global requirements
+* VMAX driver - bootable volume errors
+* [DOC BLD FIX] Fix formatting errors in Dell/EMC PS
+* VMAX driver - Implement Generic Volume Group feature
+* [DOC BLD FIX] Fix docstring errors in Dell/EMC Unity
+* [DOC BLD FIX] correct formatting errors in datera driver
+* 3PAR: Get host from os-brick
+* Change Huawei driver's private data storing place
+* 3PAR: Modify update\_migrated\_volume code to driver
+* ZFSSA iSCSI delete volume with non-existent LUN
+* Make doc/source directory compliant with design in spec
+* Remove key\_manager.api\_class hack
+* Don't verify format with autodetect after image conversion
+* Add support for OS-Brick force disconnect
+* [api-ref] Update volume metadata for a specific key (v2)
+* [api-ref] Backups: change parameter 'backup\_id' to be mandatory
+* Fix 'connector' parameter in update attachments API
+* Enables MySQL Cluster Support for Cinder
+* Added CG capability to volume group in CoprHD
+* coordination: use tooz builtin heartbeat feature
+* HPE Lefthand: Fixed cloning operation
+* [DOC BLD FIX] Add missing glossaries
+* Updated from global requirements
+* VMware: Use temporary image
+* ScaleIO Driver: Updating config reference
+* Mark Falconstor drivers as unsupported
+* Mark Coho driver as unsupported
+* ZFSSA iSCSI volume driver multi-connect
+* Move config-reference to configuration
+* XIV\A9000: Added replication group support
+* [DOC BLD FIX] Fix code block issues
+* Kamiario: Fix over subscription reporting
+* VNX: ignore cg creation if group is not cg enabled
+* Updated from global requirements
+* Add missing api-ref documents for group type specs
+* [DOC BLD FIX] Remove todo:: directive from volume\_driver
+* [DOC BLD FIX] Fix docstring formatting in message\_field
+* ZFSSA: apply LUN specs when cloning snapshots
+* [DOC BLD FIX] Fix formatting in cinder.compute.nova
+* Migrate configuration-reference to Cinder repo
+* enabling nimble driver again
+* coordination: remove custom Lock object
+* SMBFS: deprecate provisioning ratio config options
+* [api-ref]Fix API Doc error in creating backup
+* ScaleIO Driver: Fix transposing of PD and SP in list of pools
+* Updated from global requirements
+* [DOC BLD FIX] Fix indentation in attachments.py
+* [DOC BLD FIX] Correct :returns: in db/api.py
+* Pop "consistencygroup" from volume object
+* Fix typo
+* NEC driver: Optimal path for non-disruptive backup
+* Ignore all .egg-info directories in doc8 check
+* INFINIDAT: support for volume compression
+* Update Documentation link
+* 3PAR: Add volume to consistency/generic group
+* DS8K: add replication consistency group support
+* DS8K driver: specify pool and lss in extra-specs
+* Update contents of attach\_detach\_conventions\_v2.rst
+* VMAX - Live Migration, replacing SMI-S with REST
+* VMAX driver - Replication, replacing SMI-S with REST
+* Dell EMC SC: Terminate\_connection chokes on None
+* Revert "Correct RBD Provision stats&fix a perf problem"
+* zfssaiscsi driver initiator group option processing
+* Make VolumeTypeExtraSpecsController policy more granular
+* Add ability to extend 'in-use' volume
+* ScaleIo Driver: refactor config options
+* Remove dothill driver options
+* Add insufficient space async error in create vol
+* Globalize regex objects
+* Add group to cluster when init host
+* Dell SC: Fix python 3.6 'async' keyword warning
+* Fix python 3.6 escape char warnings in strings
+* Add support for shared "backend\_defaults" config
+* Tintri: Fix config option access
+* INFINIDAT: Add QoS support
+* Fix SSHPool current\_size not work correctly
+* Tiramisu: Add groups param to failover\_host
+* Api-ref: Reorganize volumes versions
+* Keep consistent of naming convention
+* Migrate Cinder Scheduling CLI documentation
+* Migrate Cinder CLI Quota docs
+* Migrate volume management CLI documentation
+* Migrate the blockstorage admin-guide to Cinder
+* Restore ability to disable API versions
+* Fix errors preventing doc builds
+* VMAX driver - Compression, replacing SMI-S with REST
+* VMAX driver - QoS, replacing SMI-S with REST
+* Remove the unnecessary pv\_list assign during LVM object init
+* Fix some reST field lists in docstrings
+* VNX: wrong size of volume from image cache
+* Update attachment\_delete for multiple attachments
+* Fix v1 API api-ref link
+* Fix Log parameter
+* Add snapshot clean worker decorator
+* Remove periodic\_tasks method from base manager
+* Add params for API v3 snapshot-create
+* Modify the length of project\_id for Messages
+* Fix volume migration error with NEC driver
+* Fix the inappropriate parameter name
+* Switch to openstackdocstheme
+* VMware: Config option for default adapter type
+* Enable H904 check
+* LVM: Don't initialize VG with lvm\_type='auto'
+* Fix attachment\_delete for reserved case
+* Fix wrong usage of rbd.list\_snaps return value
+* XtremIO: fix fetching FC targets from X2 array
+* Revert "Don't use ignoreskipactivation for thin LVM"
+* Api-ref: Update doc for show backups
+* api-ref: Add parameter "offset" to list apis
+* Use GroupSnapshotStatus enum field
+* Add 'reserved' status to api-ref
+* Rename method 'delete' to 'delete\_backup' in backup drivers
+* Optimize: Replace 'fields.Enum' with 'object'
+* Unify host naming in readme file
+* Move driver options to "backend\_defaults" section
+* Use SnapshotStatus enum field
+* Fix scheduler\_host\_manager limitation
+* Improve Capacity filter logging
+* IBM Storage: fix create volume with --group-id
+* Add 'LUNType' configuration verification for Dorado array
+* Unity: temp snapshot for backup deleted twice
+* Use GroupStatus enum field
+* XtremIO: Detach all IGs for null connector
+* Remove dothill driver
+* Datera 2.4.0 driver update
+* Fix image cache db query when limits are enabled
+* Don't use ignoreskipactivation for thin LVM
+* Fix exception in dothill iSCSI driver's terminate\_connection
+* Updated from global requirements
+* Allow extension of volumes with snapshots for SMBfs driver
+* Windows iSCSI: use configured iSCSI portals
+* Add gmcv support in SVC driver
+* VMware: Fix volume cascade delete
+* Fix wording in warning message
+* Remove extra space in release note
+* Fix rally "volume\_type" parameter
+* Add custom keyring when initializing RBD connection
+* Avoid register extensions on the versions router
+* Use 'min\_version' to mark newly added parameters in DOC
+* Update log translation hacking rule
+* VNX: Add QoS support
+* remove extra characters "/"
+* Fix some doc issue
+* Add driver interface documentation for list manageable
+* [Api-ref] Update quota-set APIs ref
+* Api-ref: Add upload-to-image api-ref
+* Fix driver exception when cascade deleting volume after transferring
+* Rename DB Driver param for backup drivers to 'db'
+* IBM Storage: Fix for misidentification of QoS type
+* Unity: Use thin clone when cloning volume
+* Show user\_id when cinder snapshot-show
+* Tempest for revert-to-snapshot
+* Fix the default port value
+* SMBFS: enhance volume cloning
+* import installation guide pages from openstack-manuals
+* ScaleIO Driver: Fix for using scheduler specified pool
+* IBM Storage - Fix vol create from snapshot in CG
+* Replace OS\_AUTH\_TYPE with OS\_AUTH\_SYSTEM in rc
+* Windows: case insensitive path comparisons
+* Api-ref: add documentation for v2/v3 backup 'os-reset\_status' action
+* Add note about stop supporting of log translation
+* VNX: failed to create from image cache
+* Add policy granularity to the qos-specs API
+* Fix i18n issues
+* Allow extension of volumes with snapshots for Quobyte driver
+* Add params for v3 API volume-type-create
+* Use exception.CinderException instead of Exception
+* Performance: Remove useless snapshot object get
+* Remove redundant notification
+* Provide user friendly messages for db sync
+* [XIV] Fix exception message format issue
+* Enable some off-by-default checks
+* ScaleIO: Logging cleanup
+* Fix assertTrue in functional tests
+* Cinder volume revert to snapshot
+* Fix connection\_info field in VolumeAttachment object
+* Add v2 v3 response example in API doc
+* Fix bugs while integrated with Huawei Dorado array
+* Remove the redundant volume/snapshot check
+* Updated from global requirements
+* VNX: cg and generic group cleanup
+* Add IBM-Storage replication group support
+* VMAX driver - Retype, replacing SMI-S with REST
+* Storwize Support iSCSI host when FC volume is there
+* Add enable\_lazy in api/openstack/wsgi.py
+* [api-ref] Add snapshot metadata key api
+* [api-ref] Update volume metadata key api
+* Move vol\_db\_empty to NFS driver
+* Add project\_id admin filter to limits API
+* Add thin-provisioning-tools to bindep
+* Set default lvm\_type to auto
+* Fix migration completion for New Attach API's
+* Explicit user messages
+* api-ref: clarify retype docs around default policy permissions
+* Updated from global requirements
+* Tests: Disallow use of assertTrue(str)
+* [api-ref]Fix the incorrect description in volume API
+* Add the missing brace in api/v3/attachment
+* Remove duplicated line from \_do\_attachment\_delete
+* [api-ref]Fix the wrong description in volume API
+* ScaleIO - Make compatible with next SIO version
+* Add backup to cinder architecture page
+* Fix response code for update and delete API in volume attachments
+* IBM-Storage: group-create-from-src fail with error
+* Add rel note for create volume from enc. image
+* ignore error when remove non-exist vol from cg
+* Mock time.sleep for VMAXRestTest.test\_remove\_vol\_from\_sg\_failed
+* Remove deprecated oslo\_messaging.get\_transport
+* ScaleIO Driver: get manageable volumes
+* Mark ZTE driver as unsupported
+* Add CG capability to generic groups in GPFS driver
+* FusionStorage: use versioned objects
+* Clarify some details related blockbox deployment
+* IBM Storage- revert vol size capacity optimization
+* Send global\_request\_id to nova/glance when calls are made
+* Remove usage of CONF from DISCO driver
+* Add Metadata format check
+* Fix boolean opts defined as strings
+
+11.0.0.0b2
+----------
+
+* Allow Pure drivers to handle detach with no host
+* RemoteFS: enable image volume cache
+* Ibm storage: added new option for qos type
+* Fix api-ref for v3 volume and snapshot manage
+* Fix NoneType has no attribute get error
+* Api-ref: fix parameter 'volume\_id' info
+* Refactor update attachment's testcases
+* Api-ref: Add doc for update backup
+* Replace deprecated BaseException.message with six.text\_type
+* Use requests lib for Huawei array connection
+* Add libssl to bindep
+* Revert "Using assertFalse(A) instead of assertEqual(False, A)"
+* VMAX driver - Base functionality, replacing SMI-S with REST
+* Clarify create\_volume size debug message
+* INFINIDAT: add metadata to InfiniBox objects
+* Using assertFalse(A) instead of assertEqual(False, A)
+* Correct cinder dev doc typo
+* Mark Virtuozzo driver as unsupported
+* Dell EMC SC: Updated Created by Message
+* Add warning header to opts.py file
+* API/DB: Fix hash randomization test issues
+* cleanup: remove DEVSTACK\_CINDER\_SECURE\_DELETE
+* Mapping parallel and ploop
+* Replace assertTrue(isinstance()) with assertIsInstance()
+* Using wrong connector parameter in V3 attach
+* Support sort backup with name
+* [api-ref]Adds API documentation for 'os-set\_bootable' action
+* Updated from global requirements
+* Updated from global requirements
+* Fix support for AMI image conversion
+* Remove service filter for service list
+* Remove some unnecessary spaces
+* Minor fixes to microversion devref
+* VNX: fix issue when backing-up in-use volume
+* Introduce managing existing snapshot to rbd driver
+* Fix example code about api\_version in api\_m\_dev.rst
+* Add description about tox in dev\_env.rst
+* Return metadata in volume summary
+* Ceph: Fix delete backup with non-existent pool
+* Allow logging in tempest tests
+* Storwize:  add mirrored volume support
+* Trivial fix typos
+* Refactor NEC volume driver
+* Remove unused \_detach\_snapshot method
+* Do proper cleanup if connect volume fails
+* Add an instance-uuid check on attachment\_reserve
+* GPFS: Fix forceful delete for consistency group
+* Periodic task to clean expired reservation
+* Update OVO devref
+* Add is\_replicated() to Volume and VolumeType OVOs
+* Make failover DB changes consistent
+* Revert "Use HostAddressOpt for opts that accept IP and hostnames"
+* Fix api-ref for POST backup for optional name
+* Fix typos in README.md
+* change consistencygroup\_id to group\_id
+* Fix typo
+* Add the missing "vol\_type\_id" param for qos association api-ref
+* Fix like filter related issues
+* Updated from global requirements
+* Extracted HTTP response codes to constants
+* Make "connector" param to be optional in force-detach api
+* LVM: update max\_over\_subscription\_ratio help message
+* Add Generic Volume Group Into Quota Management
+* Update SolidFire CI Wiki
+* Add a local bindep.txt override
+* NetApp DOT: Fix hash randomization test failures
+* Updated from global requirements
+* Update replication v2.1 devref
+* INFINIDAT: add support for generic volume groups
+* INFINIDAT: add support for iSCSI
+* Rolling Upgrades: Fix Volume OVO
+* Rolling Upgrades: Fix Group OVO
+* OVO: Remove child\_versions from list classes
+* SMBFS: remove redundant check
+* SMBFS: switch to distributed locks
+* SMBFS: drop JSON file storing allocation data
+* SMBFS: report each share as a pool
+* Add RemoteFSPoolMixin
+* RemoteFS: pass volume object to '\_find\_share'
+* Add volume type filter to API Get-Pools
+* Updated from global requirements
+* SolidFire Generic Groups Support
+* OVO: Fix VolumeType create not bound to a Session
+* VMAX driver - Detaching volumes if part of two or more MVs
+* XtremIO: reduce number of backend calls
+* Extend Falconstor driver to utilize multiple FSS storage pools
+* Remove empty line in api\_version\_request
+* Updated from global requirements
+* Use the deprecated os\_privileged\_xxx settings
+* Add blockbox to Cinder project
+* Create volume from VHD format image always failed
+* api-ref cleanup: required flag for tenants
+* Updated from global requirements
+* Python3: Don't use Exception.message
+* GPFS: Handle unsupported operations with an exception
+* api-ref: add list manageable resource API
+* Check the volume metadata value is a string or not
+* Mark X-IO driver as unsupported
+* Mark Synology driver as unsupported
+* Mark Reduxio driver as unsupported
+* Mark Nimble driver as unsupported
+* Mark Infortrend drivers as unsupported
+* Mark ETERNUS drivers as unsupported
+* Remove BRCD primary\_switch\_wwn config option
+* Mock qemu calls in sheepdog tests
+* Add time.sleep mock for test\_lv\_deactivate\_timeout
+* Fix typo errors
+* ZFSSA: Allow clones to differ in size from parent
+* Convert marker format for listing manageable resources
+* vzstorage: use remotefs.VZStorageRemoteFSClient
+* OVO: Add reminder to add backporting code
+* vstorage: added vz:volume\_format vendor property
+* Fix bugs of GPFSNFS & GPFSRemote Driver initialization failure
+* Support 'LIKE' operator to filter resource
+* Add the missing parameters in the api-ref of ext-backups.inc
+* Updated from global requirements
+* INFINIDAT: add locking around initialize/terminate connection
+* Implementation of Cinder driver for Veritas Access
+* Add 'resource\_filters' API to support generalized filtering
+* Deprecate osapi\_volume\_base\_url duplicate option
+* Updated from global requirements
+* Tests: Fix Blockbridge hash randomization failure
+* Tests: Fix VMAX hash randomization failure
+* Tests: Fix Datera hash randomization failure
+* Tests: Fix XIV unit hash randomization failure
+* backup: handle device path represented by dir
+* Rolling Upgrades: Fix VolumeAttachment
+* Add API documentation for force-delete volume in v2 and v3
+* coordination: remove un-used method is\_active()
+* Fix py27 gate - Remove Tooz usage for tests
+* Remove unused volume\_types field when creating group
+* INFINIDAT: delete host objects when detaching the last LUN
+* INFINIDAT: Use infinisdk for communication with storage array
+* Add information in notification of type's extra\_spec
+* NFS Backup: Fix overwritting backups
+* Add missing retype API documentation
+* ibm-storage: update version number and history
+* Fix async mirroring on XIV limited range backends
+* Rollback snapshot's status when backup failed
+* Correct sphinx source code syntax
+* Clean codes around backup APIs
+* Fix all\_tenants doesn't work for volume summary
+* Fix incorrect volume\_id request description in api-ref
+* Trivial fix typos
+* 3PAR: Added volume to vvset in online copy
+* Add documentation for invalid filter keys
+* Add service dynamic log change/query
+* Dell EMC: Moved SC driver under dell\_emc
+* [Trivial] SMBFS: fix passing image format using volume types
+* Fix typo
+* Correct typo of cinder doc
+* Fix swift auth\_url/url check
+* Fix typo in docstring
+* SMBFS: avoid unnecessary conversion when uploading volumes
+* Fix forceful deletion of Consistency Group for GPFS Driver
+* Refactor internal context testcases with ddt
+* Enable mutable config in Cinder
+* VMAX driver - Close ecom connections
+* Read XtremIO options from self.configuration
+* Read rbd options from self.configuration, not CONF
+* Fix backup\_api\_class doesn't work
+* Add support for generalized filtering on list APIs
+* Modernize the nova client in cinder
+* ScaleIO 1.32 deprecation notice
+* SMBFS: Use share mountpoint when fetching capacity info
+* Fix permission error in VNX driver
+* VMware: Stop setting dynamicType
+* VMware: Apply policy at vmdk level during retype
+* genopts: Fix python 3 compat, sort options
+* Remove snapshot['size'] references
+* Remove backup-restore methods in driver code
+* Fix change API volume create message
+* VMAX driver - Manage/Unmanage performance fix
+* Updated from global requirements
+* VMAX driver - Rollback error on Live Migration
+* Remove usage of parameter enforce\_type
+* Trivial fix typos while reading code
+* Re-arrange v3 API reference
+* Re-order api-ref home page index
+* Trivial fix PEP 8 coding style violation and typo
+* Move the releasenote to the right folder
+* Add missing testcases for migration scripts
+* 3PAR: Added Replication Feature In Retype Flow
+* Functional tests for group replication
+* Update attachment's status when attaching a readonly volume
+* ds8k: should verify REST version separately
+* Remove dependecy testrepository
+* Move the releasenote to the right folder
+* Remove non-scheduler volume extend support
+* Eternus driver: Move soft dependency check out of \_\_init\_\_
+* Use cryptography instead of pycrypto
+* Tiramisu: replication group support
+* xiv: enable get fc targets by host
+* NFS: run qemu-img info as root
+* Give more time for LVM deactivation
+* Remove unused fallocate method/filter
+* Fix quota reserve for manage snapshot
+* Updated from global requirements
+* Delete limited\_by\_marker from api/common.py
+* LIO: Fix terminate\_connection AttributeError
+* Spelling error "paramenter"
+* validate\_integer doesn't check non int properly
+* Fix host check in is\_backend\_frozen
+* Refactor 'update\_group' method
+* Use cg object when invoking update cg method
+* Volume Type Encryption added to v2 api-ref
+* Fix accessing uninitialized variable bug
+* Don't return empty volume\_image\_metadata when list volume
+* GPFS: Enhance GPFS driver to work in container
+* Create indexes for foreign keys
+* NetApp: Refresh directory before waiting
+* Fix NoneType has no attribute get
+* Updated from global requirements
+* HPE 3PAR: Adds CG capability in generic volume groups(GVG)
+* Fix typo in comments
+* Check groups before deleting group type
+* Fix backup temp snapshot path on remote node
+* Changing releasenotes file present in review change 409128
+* ProphetStor failed to create volume size larger than the snapshot
+* Add attachment API doc
+* Remove obsolete Liberty code
+* VMAX driver - Pre-zoned port group fix
+* Updated from global requirements
+* Improve help for periodic message\_reap\_interval
+* fix typo
+* Add 'connection\_info' to attachment object
+* Fix the filter when list volume with group
+* Filtering attachment doesn't support 'instance\_id'
+* Don't check thin provisioning when manage volumes
+* Clean up expired user messages
+* Dell EMC SC: Support generic groups
+* NetApp: Deprecate E-Series drivers
+* ScaleIO: Adding CG support to groups
+* attach\_volume first check for existing attachment
+* Eliminate deprecation warning in db
+* Add a release note for groups
+* Revert "Huawei: disable certificate verification"
+* Fix for Group API update to include check policy
+* Create volumes from encrypted images
+* Glance: attach volume encryption key id to image
+* Dell EMC SC: Raise on \_init\_volume create\_snapshot failure
+* qemu\_img\_info: Don't autodetect source format
+* Check "kernel\_id", "ramdisk\_id" for Glance v2 only
+* XIV: switch to generic volume group
+* Updated from global requirements
+* Reverts quobyte\_volume\_url option back to type StrOpt
+* Disables xattrs on Quobyte driver mounts
+* [BugFix] Add method policy in attachment APIs
+* Adds a bugfix release note regarding backing up with the Quobytedriver
+* HPE Lefthand: add CG capability to generic groups
+* qemu\_img\_info: report 'luks' images as 'raw'
+* Fix encryption key deletion error handling on volume delete
+* Fix rally job gate-rally-dsvm-cinder-ubuntu-xenial-nv
+* 3PAR: Enable HPE-3PAR Compression Feature
+* ProphstStor driver 'SSL' communication fails to check certificates
+* RemoteFS: fix volume cascade delete
+* Tests: Remove the redundant methods
+* Storwize: correct unreplicated vol status
+* recover image-volume size if extend volume failed
+* Fix config option volume\_backend\_name's invalid overridden value
+* VNX: add missing group snapshot pool stats
+* Optimize the link address
+
+11.0.0.0b1
+----------
+
+* Updated from global requirements
+* Remove unused references from config-generator
+* Synology: fix snapshot metadata loss
+* Missing volume status on block storage v2 API
+* Validate uuid parameters strictly for create volume API
+* ds8k: check lun exist or not when clone volume
+* DS8K driver should use DLM
+* DS8K driver: remove code for fake connector
+* [api-ref] Add backing-up to snapshot statuses
+* Use HostAddressOpt for opts that accept IP and hostnames
+* DS8K driver: change the design of CG
+* Add sem-ver flag so pbr generates correct version
+* Fixed wrongly catched multiple exception types
+* Storwize: add CG capability to generic groups
+* Fix attach issue for failed-over volume
+* Fix migrate api giving incorrect exception message
+* Reduce code duplication
+* Separate out routine for getting qemu\_img\_info
+* NEC driver doesn't provide link down portal info
+* Fix metadata api's raises TypeError
+* Remove 'verbose' config option initialization
+* Remove sha256file value from logs for incremental backups
+* [api-ref] Add cascade to volume delete
+* Add CG capability to generic groups in Huawei driver
+* Huawei: disable certificate verification
+* Hitachi: Mark HBSD and VSP as unsupported
+* HNAS: Mark NFS driver as unsupported
+* Support for HostAddress opt
+* Add an optional db session argument to cinder.db.sqlalchemy.api. quota\_allocated\_get\_all\_by\_project(). Then in quota\_reserve() pass the session that is fetched for that method so that a new session does not have to be made. This can avoid DB timeouts and retries when a lot of concurrent operations are hitting quota\_reserve()
+* HPE 3PAR: Handle manage and unmanage hosts present
+* VNX: allow specify pool name for replication
+* VMAX driver - Live Migration is dropping connection
+* [Trivial]Fix some incorrect annotations
+* Fix some format error in docstrings
+* Add bandit-baseline to tox.ini
+* Backup: Add choices to compression algorithm option
+* ScaleIO: Fixing support for SIO 1.3x
+* Updated from global requirements
+* Fix error status check when create backup
+* Remove mirror policy parameter from Huawei driver
+* Updated from global requirements
+* Implementation of cinder driver for Veritas HyperScale
+* Tolerate new SQLAlchemy==1.1.7
+* [BugFix][Devref] Refactor attach/detach v2 devref
+* [BugFix]Cinder forgets to update 'deleted\_at' when deleting
+* Add more specific error message
+* Tests: mock psutil usage in quobyte tests
+* New test case for InfroTrend driver
+* Add unit test for brick/local\_dev/lvm.py: create\_volume
+* [api-ref] Update snapshot/volume's metadata api-ref
+* api-ref: fix rest method error in reset group and group-snapshot status
+* Fix the missing args bug while lvm creates volume failed
+* [BugFix] Add 'all\_tenants', 'project\_id' in attachment-list
+* Huawei driver supports front-end qos
+* Use the list iterator instead of six iterator
+* Add two response parameters in the api-ref of getting capabilities
+* NetApp E-Series CI name update
+* Don't use tempest special\_fields
+* Add \_\_init\_\_ for cinder.config module
+* Clean up index links to removed content
+* Make cinder-manage online migrations more verbose
+* SMBFS: enable Nova assisted volume snapshots
+* Remove deprecated 'host' option for cinder-volume
+* Sheepdog: fix conflict of temporary snapshot name
+* api-ref: Fix volume\_id parameter for the path
+* Fix 500 error when 'mountpoint' is not provided to os-attach
+* RemoteFS: prevent creation of encrypted volumes
+* HPE LeftHand: extend volume if larger than snapshot
+* Mark the Violin volume drivers as unsupported
+* Mark QNAP volume driver as unsupported
+* [Doc] Add documentation for messages API
+* Mark Blockbridge volume driver as unsupported
+* Delete the duplicate interface about the api version
+* Fix some reST field lists in docstrings
+* Remove XML description from media-types
+* Fix version numbers on media-types
+* Fix status\_code of "list versions" API
+* Adding new test case for InforTrend driver
+* Fixed inconsistent naming conventions
+* Extracted HTTP response codes to constants
+* Extracted HTTP response codes to constants
+* Extracted HTTP response codes to constants
+* Extracted HTTP response codes to constants
+* Extracted HTTP response codes to constants
+* replace references to cinder.openstack.org
+* [doc] Update doc index
+* Consistency groups API is not returning project\_id filter groups
+* Adding tests for api/v3/group\_specs.py
+* Fix docs failures caused by latest eventlet
+* VMware: Enforce min vCenter server version 5.5
+* Fix cinder functional tests job
+* Adds missing return value to create\_cloned\_volume of Quobyte driver
+* Don't change volume's status when create backups from snapshots
+* Add missing and incorrect response and error codes in cinder api-ref
+* ZFSSA can avoid fetching img when creating vol from cache
+* Fix more invalid UUID warnings in test\_vmax file
+* ZFSSA cache luns are too small when images are precisely X Gi
+* Support sort snapshots with name
+* [Doc] Add missing parameter in v3 resource documentation
+* Remove log translations
+* Remove old oslo.messaging transport aliases
+* Remove unused CG code
+* Delete consistency group fails on xtremio driver
+* Remove hacking check for log translation
+* Add IOPS limits that scale per-GB
+* Update db from drivers in default groups methods
+* ScaleIO: Fixing warnings spotted by PyCharm and tox
+* Added gigabyte unit to values in exception message
+* Set access\_policy for messaging's dispatcher
+* Dell EMC SC: Return dict from delete\_consisgroup
+* Prevent duplicate entries in the image cache
+* Updated from global requirements
+* Fix ut error of volume deletion
+* IBM storage: switch to generic volume group
+* Fix lock contention in SolidFire driver
+* Revert "Remove v1 API reference"
+* VMAX driver - volumes part of CG not managed correctly
+* VMAX driver - consistency group remove empty values
+* Datera: extend volume if larger than snapshot
+* Tests: Fix InvalidUUID warning for 'qosId'
+* Add filter, sorter and pagination for group snapshot
+* Correct Extend lvm Volume
+* Fix create\_consistencygroup when using CG objects
+* Fix: SnapshotStatus missing in Cinder
+* Replace yaml.load() with yaml.safe\_load()
+* [Optimise] Refactor group snapshot testcases
+* Add API documentation for volume detach in v3
+* Dell EMC SC: Added retry to \_init\_volume
+* Make QnapISCSIDriver unit tests faster
+* Adds API documentation for list and show hosts
+* Updated from global requirements
+* Fix 500 HTTP API error caused by rpcapi RemoteError exception
+* Update devref for OVO version bumping
+* Improve devref for API errors
+* Add a README in tests dir linked to devref html
+* Remove HNAS iSCSI driver
+* Replace yaml.load() with yaml.safe\_load()
+* [Optimise] Refactor ExtraSpecsOpsTestCase with ddt
+* ProphetStor driver create vol from snap with wrong size
+* Add driver-requirements.txt
+* Bump prlimit cpu time for qemu-img from 2 to 8
+* Remove "list\_volume" from filter
+* Remove unreachable code
+* Remove duplicate key from dictionary
+* Fix 500 error if boolean is\_public is passed as string
+* Fix a typo
+* api-ref: v2 API does not mention GET volume metadata by key
+* Update guru doc to support file modification events
+* rbd: resize volume not cloned but full copy
+* Coho: resize volume if cloned image is larger
+* XtremIO: allow a cloned volume with larger size
+* Replace obsolete vanity openstack.org URLs
+* Fix column types in models.py
+* cors: update default configuration
+* Tests: Use six.moves.urllib urlencode
+* Switch to use stable data\_utils
+* VMAX driver - Change vendor\_name from EMC to Dell EMC
+* VMware: Refactor vmdk unit tests
+* api-ref cleanup: remove quotas user related calls
+* Fix generic group's unit testcase
+* Switch to decorators.idempotent\_id
+* Change the default value of used Glance API
+* Disallow modification of in use Volume Types
+* Hash password displays in debug log
+* Add debug log of retryable response on SolidFire
+* Filter on Active status in SolidFire List
+* Remove TODO related to Nova API version
+* Add per-backend availability zones
+* cinder-backup - coordination not initialized
+* Reuse API v2 for v1 calls
+* VMware: Remove redundant sanity check
+* api-ref: v2 update volume metadata description is wrong
+* Fix action on services raises TypeError
+* api-ref: v2 API does not mention DELETE for volume metadata
+* Set backup available after verify
+* Updated from global requirements
+* Fix size update error for snapshot-manage operation
+* Remove domains \*-log-\* from compile\_catalog
+* Fix typo error
+* Updated from global requirements
+* Validate display\_name/description attributes in API layer
+* Purge immediately on Delete in SolidFire Driver
+* Deprecate API v2
+* Huawei driver supports specifying copy speed
+* Fix internal tempest tests
+* Reuse identical API v2 code for v1
+* Remove v1 API reference
+* NEC: Fix format string in debug message
+* Fix ATTACH\_READONLY\_VOLUME message generation
+* Remove an outdated comment
+* Remove reserving quotas in c-vol's retype method
+* Enforce \_usage\_from\_snapshot to fetch info from deleted volume
+* VMAX driver - replace pickle with jsonutils
+* Switch NFS driver to use DLM locks
+* Zadara driver - move from httplib to requests
+* Remove Linux SMBFS driver
+* Unity driver: fail to disconnect volume
+* Remove unused logging import
+* create snapshot with generic group fail with XtremIO Driver
+* Fix attachments after attached migration
+* Fix volume retype with migration as non-admin
+* Fix multibackend-matrix confs
+* Adds attached migration to multibackend-matrix
+* VMAX driver - superfluous debug messages causing error
+* Fix SolidFire cgsnap clone bug
+* Compact Mitaka database migrations
+* Remove Ocata's data migrations
+* Add the backup variable structure in backup\_driver interface
+* Dell EMC SC: Return dict in delete\_cgsnapshot
+* ceph backup support for EXCLUSIVE\_LOCK and JOURNALING features
+* SolidFire: Handle connect\_volume() failure when create vol from image
+* Change nova\_catalog\_admin\_info to default to publicURL
+* Adds db\_online\_data\_migrations to cinder-manage manpage
+* VMware: Delete temporary snapshot after clone
+* doc: verify all rst files
+* Updated from global requirements
+* 3PAR: rally test create-volume-from-snapshot fails
+* VMAX Driver - disable initiator check by default
+* NetApp: Track SVM and Cluster scoped credentials
+* Fix Pep8 Failures for Python3
+* Tests: Remove mocks of nonexistent methods (NetApp)
+* Cinder tox updates for Python3
+* [4/4]Reset generic volume group and group snapshot statuses
+* Removes getfattr from Quobyte Cinder driver
+* Use ovo instead of dict
+* Fix duplicate lvs2 entry in rootwrap volume filter
+* Updated from global requirements
+* fix create\_consistencygroup in xiv
+* Output the driver info as json
+* Add maximum microversion for Ocata
+* Dell EMC Ps: Report discard support
+* Switch and/or to ternary operator
+* Fix "No documentation found in" errors in docs
+* VNX: Handle error during volume deletion
+* Unity driver: check array OE version
+* Dell EMC: Create independent volume on clone
+* Add quota limit check and enhance roll back for cg create
+* Storwize: correct the product key for replication
+* Fix Block Storage API reference nesting
+* VMAX driver - snapshot creation and immediate deletion fix
+* Drop version validation
+* Add filters support to get\_pools
+* [11/11] Refactor test\_volume file
+* [10/11] Refactor test\_volume file
+* [9/11] Refactor test\_volume file
+* [8/11] Refactor test\_volume file
+* [7/11] Refactor test\_volume file
+* [6/11] Refactor test\_volume file
+* [5/11] Refactor test\_volume file
+* [4/11] Refactor test\_volume file
+* [3/11] Refactor test\_volume file
+* [2/11] Refactor test\_volume file
+* [1/11] Refactor test\_volume file
+* Disable multiattach for all drivers
+* Remove support for py34
+* Autoselection of IBM SVC/Storwize IO group
+* Remove unsupported NexentaEdge driver
+* Remove unsupported HPE XP driver
+* Remove unsupported CloudByte driver
+* VMAX driver - allow for multi volume types in Consistency Group
+* Minor cleanup on tools/test-setup.sh
+* Add Ocata sanity check migration
+* Use https instead of http for git.openstack.org
+* Update reno for stable/ocata
+
+10.0.0.0rc1
+-----------
+
+* VMAX driver - widen locking around storage groups
+* Reserve 5 migrations for DB backports
+* Tests: Fix NetApp unit test failure w/ hash randomization
+* xiv create vol from replicated source fails
+* Don't use None value for sql query
+* Remove promote and reenable from policy
+* VMAX driver - copy state fix
+* VMAX driver - ignore service level and workload in xml
+* VMAX driver - Convert eval to ast.literal\_eval
+* VMAX driver - failover error fix
+* 3PAR: Remove un-necessary snapshot in online copy operation
+* Add SUPPORTED flag to Lenovo FC driver
+* Image utils: fix fetching available space on Windows
+* NetApp cDOT: Add check if copyoffload tool is available
+* Fix max\_age calculation for quota usage refresh
+* Fix 500 error while listing manageable volumes and snapshots
+* Add usage and limit info on quota limit errors
+* Prepare for using standard python tests
+* Convert ignoreskippedcluster check to be static
+* Nosec audit url open issue from Bandit
+* Clean up release notes for Ocata
+* xiv delete cg fails if removed on backend
+* VMware: Set vSphere opID prefix
+* Make get\_capabilities look for clusters
+* Resolve Brocade HTTPS connection error
+* Add SUPPORTED flag to Lenovo iSCSI driver
+* Add SUPPORTED flag to HP MSA driver
+* Hitachi VSP: Specify compute nodes and copy ports
+* ZTE: Added CI\_WIKI\_NAME
+* Fix notification short-circuit
+* Fix CopyVolumeToImageTestCase max recursion depth
+* HNAS: Cloned volume with different volume type
+* VMware: Use full clone if extend needed
+* Extracted HTTP response codes to constants
+* VMware: Use storage profile name in extra-spec
+* RBD:Move RBDVolume calls to a separate threads
+* Move release notes to correct location
+* Add cluster\_name to temporary volumes
+* Fix host assignment when clustered
+* 3PAR: Inconsistency in copied and source CG
+* Remove redundant log during initialize connection
+* VMAX driver - sync sv issue
+* Reduced the complexity of the main() method
+* Add descriptions to Pure drivers
+* Adds API documentation for update snapshot status
+* clean up replication volume on an xiv backend
+* Add create volume from image policy
+* Short-circuit notifications when not enabled
+* Stop get\_notifier mock in tests cleanup
+* VMAX driver - removed incorrect six.text\_type
+* Updated from global requirements
+* Rebrand and move EQLX driver to dell\_emc folder
+* Fix Live Migration for Nimble Storage Driver
+* create consistency group mishandles types
+* Infortrend: Stable generation of strings from dicts
+* VMAX driver - QoS key fix
+* VMAX driver - remove global mock of volume\_types
+* Switch to decorators.idempotent\_id
+* Set image\_owner before adding location to glance
+* Dell EMC SC: Delete doesn't account for migration
+* Zero out SolidFire capacity when unreachable
+* IBM driver update CI\_WIKI\_NAME
+
+10.0.0.0b3
+----------
+
+* Fix Qos for clone for Nimble Storage Driver
+* Add lock acquire/release debug messages
+* [api-ref]Fix the volume metadata description error
+* [api-ref]Add volumes/summary API doc
+* [api-ref]Change tenant to project
+* Fix double call to "qemu-img create"
+* Fix api-ref status parameter
+* Refactor volumes summary
+* Small change to microversion header on devref
+* Check if volume node has enough space for image operations
+* Revert "Mark the sheepdog driver as unsupported"
+* backup of active 3par ISCSI bootable volume fails
+* Open the source code of ibm\_storage driver
+* NFS snapshots
+* Tests: Fix hash unstable dict comparison
+* Tests: Fix mock for vzstorage remotefs
+* Fix the api-ref CI failure
+* Eager load projects when getting types by group
+* VMAX driver - rename and restructure driver
+* Updated from global requirements
+* Switch ManageableSnaphots & ManageableVolumes list to OVO
+* VMAX driver - storage group cleanup on error
+* Add assert\_min\_rpc\_version decorator
+* NetApp cDOT: Add NetApp Volume Encryption support
+* Add volume backup tempest tests
+* Make CappedVersionUnknown exception more useful
+* vzstorage: use resize instead of grow for ploop images
+* Add driver supported status to dict output format
+* Break migrate\_add\_message\_prefix into two queries
+* Remove useless FIXME
+* Fix some problem for attachment list
+* Don't drop the volume type's extra spec at DB layer
+* Switch to using generic groups with Pure driver
+* VMAX driver - Implement volume replication for VMAX
+* Brcd zonemanager: Fix unstable command generation
+* Dell SC: Logging asyncTask if XML returned
+* Test: Fix assert\_has\_calls dict order bug (QoS)
+* FalconStor: Drop the copy\_image\_to\_volume feature
+* Refactor backup RPC API test cases
+* Refactor scheduler RPC API test cases
+* Update the parameter check when create attachment
+* FalconStor: Restore option "san\_secondary\_ip"
+* Extracted HTTP response codes to constants
+* XtremIO: Add CG capability to generic groups
+* VMAX driver - Consistency Group automerge fix
+* VMAX driver - Support for compression on All Flash
+* Add new attachment APIS
+* Add lock around SolidFire clone-image
+* VMAX driver - Storage assisted volume migration
+* Dell SC: Retype fixes
+* Revert "Mark Huawei volume driver as unsupported"
+* Fix typos
+* Adds getfattr and mount to Cinder rootwrap volume.filters
+* Refactor volume RPC API test cases
+* Make notify\_service\_capabilities cluster aware
+* VNX: Add async migration support
+* VNX: Update sg cache if it already existed
+* Allow snapshots and volumes to have Null group values
+* Fix for FC Initiator API in Nimble Storage Driver
+* Revert "Mark Quobyte volume driver as unsupported"
+* Fix retype with migrate
+* VMware: Allow deletion of snapshot in error state
+* Move driver tests to tests/unit/volume/drivers
+* Prevent claiming and updating races on worker
+* Fix replication freeze mechanism
+* Move service and cluster creation in test to utils
+* Make Image Volume Cache cluster aware
+* Make Replication support Active-Active
+* Fix for live migration for Nimble Storage
+* NexentaStor5: Added extend method to NFS driver
+* Sync \`\`services\`\` SQLA model with what's in the DB
+* Make BackupManager not a SchedulerDependentManager
+* Optimise: Use sqlalchemy to build table sequence
+* Fix volume manage
+* Revert "Mark Tintri volume driver as unsupported"
+* Nosec subprocess with shell equal True from Bandit
+* Modify the spelling mistakes
+* Add volume to fake snapshot object
+* Clean up image tmp file if c-vol gets restarted
+* Modify the spelling mistakes
+* Prevent driver load failures from objects
+* Nosec Paramiko exec\_command() warning from Bandit
+* Replace deprecated pylint disable-msg with disable
+* DB: Optimize update methods
+* Updated from global requirements
+* Save model\_update as admin in create\_volume
+* Improvement to get group detail(Part 2)
+* Add api version history for 3.23
+* Deprecate the Linux SMBFS driver
+* Storwize: do the correct update after failover
+* Unity Driver: Backup volume via snapshot
+* RBD: Fix RBD replication on volumes from image source
+* Dell SC: Change DRP search to reference type
+* vzstorage: fixed snapshot deletion in error state
+* Dell SC: Missing version history
+* Remove deprecated RequestBodySizeLimiter class
+* Allow triggering cleanup from API
+* [py35] image file should be open in binary mode
+* HNAS: Change snapshot names
+* Add prefix to user message event ids
+* Improve compatibility with novaclient 7.0.0
+* Updated from global requirements
+* Unity: Add support to set IO ports in option
+* Fixes hpelefthandclient AttributeError
+* Mark the sheepdog driver as unsupported
+* Add volume type access operations notification
+* Remove inheritance from deprecated classes
+* FusionStorage: rename the CI\_WIKI\_NAME
+* Dell SC: Failback timeout extended
+* Tests: Remove more InvalidUUID warnings
+* Don't translate exceptions w/ no message
+* Add command information to cinder-manage.rst
+* Add CG capability to generic groups in VNX driver
+* RBD: Remove volume\_tmp\_dir option
+* Fix devref create\_volume doc formatting
+* VMware: Use versionutils in oslo.utils
+* Delete volume when rescheduling
+* VMware: Set backend UUID to volume UUID
+* Rename AddFCZone and RemoveFCZone according to PEP 8
+* Cleanup limit view name processing
+* Datera 2.3 driver update
+* Skip CI link in list for infra supported drivers
+* Add manage/unmanage to DISCO driver
+* Updated from global requirements
+* Fix a few typos in storwize\_svc\_common.py
+* Doc: Fix build warnings for missing code-block lang
+* CoprHD: Handle ScaleIO CI failing with version-3.5
+* Python3 common patterns
+* Enable DeprecationWarning in test environments
+* Add orm type check for paginate\_query
+* [api-ref]Add api ref for "volume type encryption"
+* Fix sphinx errors related to missing paths/modules
+* Cascade + force volume delete parameters
+* Adds metadata in search option for snapshot
+* Fix python integer interpretation in Py2 and Py3
+* Fix Cisco Initiator zoning updates
+* Add QoS and Dedupe Support for Nimble Storage
+* Remove unused PasteAppNotFound exception
+* tgt: Remove existence check before delete
+* Only log insecure key manager warning once
+* Refactoring ITRI DISCO cinder volume driver
+* Convert 'parallels' format name to 'ploop'
+* Add psycopg2 and PyMySQL to test-requirements
+* Attach/Delete volume for tgt driver race condition fix
+* Correct RBD Provision stats&fix a perf problem
+* Avoid Forcing the Translation of Translatable Variables
+* Updated from global requirements
+* Deprecate the block\_device driver
+* [1/4]Reset generic volume group status
+* HNAS: Deprecate HNAS iSCSI driver
+* VMAX driver - PortGroup rollback error path scenario
+* Report multiattach capability for Hitachi VSP drivers
+* Tests: Split up NFS backup notification test
+* Set replication\_status automatically on retype
+* Set replication\_status on volume creation
+* Update replication property in capabilities
+* Cisco: can't add new zone when no zone is created before
+* VMware: Fix inventory folder after volume transfer
+* Use oslo.messaging topics for multibackend
+* Backup project attribute support
+* Cinder consistency group returning generic error message
+* Move VNX driver to dell\_emc folder
+* NexentaStor5: sessions and HTTPS support
+* Add more operations to cluster
+* Make workers ORM compatible with SQLAlchemy 1.1.4
+* VMAX driver - MVs and SGs not reflecting correct protocol
+* Delete space to pass the check of pep8
+* Fix logging traceback in service logs
+* Remove "service" from required\_import\_options
+* Add Rest API Support for Nimble Storage
+* Adds release note for 'Route extend\_volume' bugfix
+* Add 'unmanaging' state to volumes and snapshots
+* Fix service\_get mock method
+* Mark Nexenta Edge volume drivers as unsupported
+* Mark DotHill volume drivers as unsupported
+* leave the unreleased branch unspecified for release notes
+* Fix VMAX clone CG release note
+* Mark Tintri volume driver as unsupported
+* Mark Quobyte volume driver as unsupported
+* Mark Huawei volume driver as unsupported
+* Mark CloudByte volume driver as unsupported
+* Mark HPE XP volume driver as unsupported
+* RBD: Implement v2.1 replication
+* Updated from global requirements
+* Storwize: create vol fails near licensed limit
+* Add get\_all capability to volume\_attachments
+* Cluster volume group fix in lvm
+* Drop the judgement condition for FakeConnector
+* Rolling upgrade procedure documentation
+* Remove Scality backend driver
+* Use method is\_valid\_boolstr from oslo\_utils
+
+10.0.0.0b2
+----------
+
+* Updated from global requirements
+* Support new osprofiler API
+* [api-ref] Show more specific parameter of capabilities
+* Cosmetic changes to scheduler
+* Support A/A on Scheduler operations
+* Fix detach twice of snapshot
+* Add cinder volume drivers for NEC Storage M series
+* Remove authorisation checks at the DB level for quota operations
+* Fix condition parameter bug in routes
+* Add Apache 2.0 license to source file
+* VMAX driver - Attach and detach snapshot
+* Improve DB method naming consistency
+* Simplify calls to mock\_object
+* Make APIVersionRequest's null check more pythonic
+* Nexenta: Added ZFS cleanup in NexentaStor4 iSCSI driver
+* Move windows drivers to versioned objects
+* Correct reraising of exception
+* Fix warning when running \`tox -e docs\`
+* ibm\_storage driver: Added fczm decorators
+* Dell SC: Added Logging to \_swap\_credentials
+* Unreserve volume: fix log message for completion
+* Dell SC: Missing volume creation options
+* Hacking: Remove N333 oslo namespace import check
+* Adds Unity Cinder Driver
+* Added initial backend ISCSI driver for Reduxio
+* Switch default py3x to py35
+* Remove run\_tests.sh wrapper
+* Do not manage VG with > 1 volume in Kaminario driver
+* HNAS: Add list manageable volume/snapshots
+* Move to hacking 0.12
+* Modify variable's usage in Log Messages
+* Prohibit creating volume from source with dif encryptions
+* Route extend\_volume calls to scheduler
+* Remove deprecated volume\_clear shred option
+* Fix dos-style endlines
+* Add QNAP ES Storage Driver
+* Fix TypeError when execute cinder-volume-usage-audit
+* Log detailed attach/detach volumes info
+* Remove anyjson test dependency
+* EMC VMAX: Remove unused is\_in\_range() method
+* Non-WAN port filter issue in Kaminario iSCSI driver
+* Updated from global requirements
+* Introduce Hitachi VSP iSCSI driver
+* Remove Kaminario deprecated option
+* Introduce Hitachi VSP driver
+* Support A/A in delete actions and get\_capabilities
+* Change volume\_type dict to ovo
+* Dell SC: Incorrect exceptions being returned
+* Tests: Fix invalid UUID warnings
+* Block 3.1 message with c-sch RPCAPI pinned to 3.0
+* Huawei: Mask unnecessary log print
+* Fix status after a VolumeDriverException
+* Fix replication\_status on InvalidReplicationTarget
+* Add host check on replication actions
+* Updated from global requirements
+* Revert "Swap volume type for migration started by retype"
+* LVM: collect more debug data when VG creation fails
+* SolidFire QoS scaled by volume size
+* Refactor api test\_common to use ddt library
+* New cinder driver to support INFINIDAT InfiniBox
+* Remove cgsnapshot\_id before snapshot.save
+* Add missing consistencygroup\_id in volume
+* Remove support for single backend config
+* Removed unused constant in v3/views/clusters.py
+* Add back policy check for CG
+* Fix secondary lvm cmds rootwrap filters
+* Update detach\_volume() with versionedobjects
+* Update attach\_volume() with versionedobjects
+* Calculate virtual free capacity and notify
+* NetApp cDOT driver fails to clone from NFS cache
+* Admin API policy enforcement contingent on is\_admin\_project
+* test: fix wrong usage of config option in test\_window
+* Fix wrong usage of config option gpfs\_images\_share\_mode
+* Refactor test\_volume\_actions to use ddt library
+* Correct the attributes of volume which created by clone a CG
+* Swap volume type for migration started by retype
+* Replace functions 'Dict.get' and 'del' with 'Dict.pop'
+* Reuse already existing groups in tempest plugin
+* Huawei: Mark password option as secret
+* Remove Unicode byte order mark
+* Add driver interface for groups
+* Remove emc folder
+* Always allow to create snapshot db record with snapshot-manage
+* [api-ref] Correct status code of backup delete
+* Add cg constraint when deleting a volume type
+* Fix response bootable parameter type in api document
+* Skip more parameters when import backup record
+* Dell SC: Reject thaw call when backend is failed over
+* Dell SC: Unable to locate LV primary after LV-AFO
+* Remove nosetests i18n fix
+* Remove temporary directory creation for BaseBackupTest
+* Add logging to FakeLoggingVolumeDriver
+* Remove empty debug\_opts
+* Add unsupported status to driver listing
+* Add is\_up property to service and cluster objects
+* HNAS: Rename hnas\_svcX\_volume\_type
+* Fix UnBoundLocalError in update\_consistencygroup
+* Support A/A in attach/detach operations
+* Remove 2 unnecessary assignments
+* Show team and repo badges on README
+* HPE3PAR: handle conflict in iscsi host create
+* Add dev doc for generic volume groups
+* Remove unused constant in hbsd\_horcm.py
+* Fix create\_group with group type name
+* Show provider\_id for admin
+* Fix online data migrations cmd in release notes
+* Fix UnableToFailOver exception message
+* Gate migration tests: Add Cinder tempest hook
+* Updated from global requirements
+* Create a dell\_emc folder for Dell EMC drivers
+* CG API changes for migrating CGs
+* [2/4]Reset group snapshot status
+* Update is\_up from Service OVO class to match ORM
+* Replace assertDictMatch with assertDictEqual method in tests
+* Move XtremIO driver to dell\_emc folder
+* Replace six.iteritems with dict.items()
+* Fix VMAX unit test timeout issue
+* Migrate consistency groups to groups
+* Move ScaleIO driver to dell\_emc folder
+* Modify the position of try-except
+* Fix names in online-data-migrations release note
+* Windows SMB: use os-brick remotefs client
+* Fix typo in test\_quotas.py
+* Skip test\_storwize\_get\_host\_from\_connector\_with\_lshost\_failure
+* Update v2 and v3 Volume actions documentation
+* Handle NotImplementedError for image cache cloning
+* Fix v2 volume create api-reference request parameters
+* VMware: VMDK driver performance improvements
+* VMAX driver - Create a CG from a source CG
+* Deprecate Hitachi Block Storage Driver
+* Add host check while create snapshot
+* Prevent Active-Active on drivers by default
+* Log traceback for validate\_connector exception
+* Fix "wrap functions with 2 blank lines" pep8 check
+* RBD: improve readability in over provisioning tests
+* Delete the redundant expression expected\_attrs
+
+10.0.0.0b1
+----------
+
+* Remove use of timeutils.set\_time\_override
+* Add generic code for online data migrations
+* VMAX driver - Ensure VMAX volume matches cinder db volume
+* Updated from global requirements
+* Pass OVO instance to copy\_volume\_to\_image
+* Drop unused parameter in class EntryCreateTask
+* Set EVENTLET\_NO\_GREENDNS for IPv6 and dnspython compat
+* Fix doc comments
+* Add multipath enhancement to Storwize iSCSI driver
+* Update replication doc
+* Add VolumeAttachStatus Enum
+* Dell SC: Live Volumes not cleaned up
+* Remove race conditions from transfer API
+* Convert backup\_device to OVO
+* Clean \_get\_cctxt method signatures
+* DB: Optimize volume\_update method
+* Fix typo error
+* Fix compatibility with decorator < 4.0.x
+* Fix config generator issue with OVO decorators
+* Dell SC: Minor cleanup
+* NetApp ONTAP: Deprecate 7-mode driver
+* Fix unit tests for LVM migration with os-brick 1.7.0
+* Fix releasenotes job
+* Make c-vol use workers table for cleanup
+* Updated from global requirements
+* Dell SC: Log FO state more clearly
+* Add API unit tests for snapshot creation force values
+* Use VolumeDriverException for driver exceptions
+* Dell SC: Error creating snapshots with live volume
+* Remove GlusterFS volume driver
+* VMAX driver - Useful name convention for CG names
+* VMAX driver - Duplicate initiator group name error
+* To fix miscellaneous bugs in OVOs
+* Dell SC: Add init\_volume check and logging
+* RBD: prevent creation of encrypted volumes
+* Make divisible py3 compatible in vmware driver
+* Remove mox3 in test-requirement.txt
+* Fix typos in comment
+* VMAX driver - No support for creating CG from CG source
+* Updated from global requirements
+* NetApp Data ONTAP driver enhanced support logging
+* FalconStor: Fix creating snapshot failed
+* Dell SC: AsyncTask could return incomplete
+* VNX:Add more check on replication\_device keys
+* Skip unit-tests which use os.fdatasync on MacOS
+* Missing parameter for storage pools in Pure Storage driver
+* NetApp: Report shared blocks exhaustion
+* Allow entry created in VolumeAttachment table for 2nd and later volumes
+* storwize: get\_host\_from\_connector optimization
+* Huawei: Fix the rest query timeout problem
+* Updated from global requirements
+* Remove logging import unused
+* Add current status to error msg in reserve\_volume
+* Return HTTPBadRequest instead of HTTPNotFound
+* Removed extra xml api-ref files
+* Fix return values of consistencygroup actions in Pure storage driver
+* Update .coveragerc after the removal of openstack directory
+* Fixes ZFSSANFS driver on Solaris platform
+* VMware:Config option for http connection pool size
+* Updated from global requirements
+* Add generic reset-status method in admin actions' testcases
+* Updated from global requirements
+* Imported Translations from Zanata
+* Mark backup\_swift\_key option as secret
+* make Liberty incompatibility error more helpful
+* Add Fibre Channel support for Nimble Storage
+* Updated from global requirements
+* Adjust doc about threading
+* RemoteFS: Remove deprecated config options
+* Fix HNAS Driver KeyError exception in volume manage
+* NetApp NFS: Look for new file for >60s
+* Cleanup RCP API versioning
+* VMware: Fix deprecation warning
+* VMware:Remove redundant check for usable ESX hosts
+* Updated from global requirements
+* NetApp Data ONTAP headroom calculation error
+* Update synchronized decorator
+* VNX: use delete instead of remove
+* Stop using mox in unit/api/v2/ tests
+* Fix the issue that osprofiler opts not in cinder.conf.sample
+* Remove volid from attachments\_get\_by\_host|instance
+* Coho Data: New socket connections per request
+* Imported Translations from Zanata
+* Log message cleanup for volume-usage-audit
+* Imported Translations from Zanata
+* Make divisible py3 compatible in remotefs driver
+* Add 'cinder' to the 'allowed\_direct\_url\_schemes'
+* Imported Translations from Zanata
+* Add backup notification to cinder-volume-usage-audit
+* VMAX driver - Create initiator group in single call
+* Fix log translation marker in volume/utils.py
+* Fix policy file used for testing
+* Imported Translations from Zanata
+* Dell SC: Can incorrectly identify if it is failed over
+* Enable release notes translation
+* Remove deprecated cinder.middleware.sizelimit
+* Add VERSION to ZTE driver class
+* Imported Translations from Zanata
+* Switch from tempest-lib to tempest
+* VMAX driver - Misleading logging on portgroups
+* VMAX driver - Heat detach issue
+* Sort options in cinder.conf by module name
+* Fix typos in documentation
+* Move volume drivers unit tests to tests.unit.volume.driver module
+* Add version to ibm\_storage driver
+* Remove support for 2.x volume RPC API
+* Remove support for 2.x scheduler RPC API
+* Imported Translations from Zanata
+* Error message for image conversion failure
+* Add cleanable base object and cleanup request VO
+* Imported Translations from Zanata
+* Fix for Tegile driver failing to establish volume connection
+* Removing deprecated Dell EqualLogic config options
+* Hacking: Remove C305 contextlib.nested check
+* Fix typo: remove redundant 'that'
+* Removing cinder-all binary
+* Updated from global requirements
+* Remove old deprecated driver mappings
+* Imported Translations from Zanata
+* Nexenta: Use base VolumeDriver migrate\_volume
+* Add the note of maximum microversion
+* VNX: raise exception if no storops
+* Speed up kaminario's drivers tests
+* VMware: Skip setting vmdk UUID
+* Imported Translations from Zanata
+* Fix typo in emc\_vmax\_fast.py
+* Disable API v1 by default
+* RBD Thin Provisioning stats
+* Drop unused parameter in class ExtractSchedulerSpecTask
+* Add interface decorator to ibm\_storage driver
+* Imported Translations from Zanata
+* VMware: Remove FakeObject
+* Updated from global requirements
+* Fix typo in devref/api\_conditional\_updates.rst
+* Fix a typo in manager.py,test\_common.py and emc\_vmax\_utils.py
+* Re-use RBDImageMetadata and RBDVolumeIOWrapper from os-brick
+* Fix IndexError in volume manager
+* Remove ovo[fixtures] dependency from tox.ini
+* extract\_host: Handle empty host string input
+* Updated from global requirements
+* Hacking checks for H105
+* Remove dead code - replication RPC APIs
+* Speed up ibm storwize svc driver's tests
+* Files with no code must be left completely empty
+* Add support for Infortrend GS Series products
+* Add 'replication\_targets' and 'display\_name' in API docs
+* Imported Translations from Zanata
+* OVO: OPTIONAL\_FIELDS should be moved inside the OVO
+* OPTIONAL\_FIELDS should be inside OVO object group\_snapshot
+* Moving the OPTIONAL\_FIELDS inside the OVO object group
+* Updated from global requirements
+* Cleanup lintstack exceptions related to objects
+* Imported Translations from Zanata
+* Remove placeholder tempest test
+* Hacking: remove check for "tests/unit/integrated"
+* Allow attribute lazy loading in VolumeType OVO
+* Provide cfg to ignore lvm descriptor leak warnings
+* Imported Translations from Zanata
+* Imported Translations from Zanata
+* Imported Translations from Zanata
+* Volume get: Check policy before fetching metadata
+* Fix a typo in scheduler manager "filter\_propterties"
+* Fix test case note
+* Fix project assignment in VolumeType OVO
+* Imported Translations from Zanata
+* Fix pep8 E501 line too long
+* Using assertIsNone() instead of assertIs(None)
+* Fix formatting in generate\_config\_opts
+* Reduce redundant call of image show
+* Limit memory & CPU when running qemu-img info
+* Updated from global requirements
+* Allow getting qos\_specs in db.volume\_type\_get
+* Fix missing string format specifiers
+* Deprecate LocalVD, SnapshotVD, CGVD, ExtendVD, TransferVD
+* Use keystoneauth1 for creating the keystone session
+* Add test\_get\_all\_by\_volume in objects/test\_backup
+* replace filter() to meet python3
+* Add snapshot id validation during volume creation
+* Imported Translations from Zanata
+* Refactor of getting qemu-img version
+* Remove extra param in list\_manageable\_snapshots
+* Stop using mox in cinder/tests/unit
+* Modifies override logic for key\_manager
+* Remove unnecessary setUp
+* Imported Translations from Zanata
+* Sheepdog: fix clone failure
+* Read domain info from context when contacting nova
+* Compact Liberty database migrations
+* XtremIO: fix migration bug
+* Remove unnecessary setUp and tearDown
+* Imported Translations from Zanata
+* Don't attempt to escalate cinder-manage privileges
+* Remove duplicate keys from dictionary
+* Remove unnecessary setUp and tearDown
+* Add missing %s in print message
+* Create v3 API Reference
+* Reserve 5 migrations for Newton backports
+* Add os-detach to api-ref
+* Fix request\_spec conversion from o.vo to dict
+* Storwize: remove SCSI LUN ID for volume attaching
+* Stop using mox in unit/\*.py (2/2)
+* Imported Translations from Zanata
+* Huawei: Backend capabilies report optimization
+* Imported Translations from Zanata
+* Imported Translations from Zanata
+* Update reno for stable/newton
+* NetApp cDOT: Fix model update for cheesecake volumes
+
+9.0.0.0rc1
+----------
+
+* Fixed request/response parameters in doc
+* Add volume RPC API v3.0
+* Add scheduler RPC API v3.0
+* XtremIO: bump driver version to 1.0.8
+* Imported Translations from Zanata
+* netapp image cache cleaning start thresholds does not work
+* Fix missing JSON response in API reference
+* Mark v1 as DEPRECATED in devref
+* Add xUnknownSliceID to retry list
+* Dell SC: ISCSI initialize\_connection fixes
+* Use IP in Kaminario locks and add/delete loggers
+* Add combined function get\_vol\_type\_by\_name\_or\_id
+* Imported Translations from Zanata
+* Remove unreachable return statement
+* Dell SC: Disable connectivity failures for new servers
+* Fix release notes formatting
+* Fix coerce good values in test\_fields.py
+* VMAX driver - Does not honor clone volume size
+* Updated from global requirements
+* Fix glance v2 image update
+* Unit test to use vol obj instead of dictionary
+* Imported Translations from Zanata
+* Remove few Kaminario release notes
+* Newton release notes cleanup
+* Use to\_policy\_values for enforcing policy
+* Fix logic in retype check for encryption changes
+* Added default for ScaleIO driver max\_over\_subscription
+* Save volume\_type/group\_type uuid into db when creating group
+* Imported Translations from Zanata
+* DRBD: Don't put clients everywhere
+* VMAX driver - Cleanup of Initiator group fails
+* Imported Translations from Zanata
+* fix the %{} when string formating
+* Fixed illegal syntax error code in ScaleIO rename volume
+* VMware: Send additional connection info
+* Imported Translations from Zanata
+* Have a default OPTIONAL\_FIELDS for persistent OVOs
+* Include OPTIONAL\_FIELDS in VolumeType OVO class
+* Remove sleep mocks in RBD unit tests
+* Fix RBD timeout
+* Fix creating typeless volumes with Mitaka's c-sch
+* Add missing release notes
+* Make sure get\_backup\_device result is an o.vo
+* [api-ref] Correct response code in Cinder API v2
+* VMAX driver - failed rollback on VMAX3 when MV issue
+* Fix order of arguments in assertIs
+* Remove driver interface changes from reno devref
+* Imported Translations from Zanata
+* Doc: qos-specs is always and only "Administrators only"
+* Cleanup Newton release notes
+* Clean create\_snapshots\_in\_db method
+* standardize release note page ordering
+* Dell SC: Error attaching after LV-AFO
+* VMAX driver - Removal of iscsiadm from vmax cinder
+* VMAX Plugin - Target WWN change for redundancy
+* Orphan view and multipath issue in Kaminario driver
+* Imported Translations from Zanata
+* [api-ref] Correct response code in Cinder API v1
+* Eqlx: Ignore missing snapshot on delete
+* NetApp cDOT: Fix reporting of replication capabilities
+* Mark Scality volume driver as unsupported
+* Trivial: Fix a trivial flake8 error
+* VMAX driver - Replace "SLO" tag with "ServiceLevel" tag
+* Register state\_path opts and add it to sample conf
+* Imported Translations from Zanata
+* Refactor volume status in managing vol
+* Updated from global requirements
+* VMAX driver - Won't delete pre-existing initiator groups
+* NetApp: Fix issue with busy snapshot deletion
+* Provide volume size for tempest volume creation
+* Nexenta: Added use of sessions for NexentaEdge drivers
+* Imported Translations from Zanata
+* RBD: Error when managing a nonexistent volume
+* Fixed indentation
+* XtremIO: fix bug deleting cgsnapshot
+* Raise NotImplementedError instead of NotImplemented
+* Imported Translations from Zanata
+* Support create group with group type name
+* Rename specific driver option with synology prefix
+* Remove doc for promote/reenable replica
+* Imported Translations from Zanata
+* Imported Translations from Zanata
+* LeftHand add entry point tracing
+* Remove host assignment in Snapshot OVO
+* Fix lazy loading cluster field from Service OVO
+* Fix manage existing MissingDependencies error
+* Do not pass unicode to str.isspace()  when disabling a service
+* Correction in log massage format syntax
+* EMC VMAX - multi-attach failure to VMAX3 when SLO is omitted
+* add more credentials information to check\_is\_admin
+* VMAX driver - Retrieve volume from snapshot
+* Fix CapacityWeiger to accept None volume type
+* Imported Translations from Zanata
+* check quota per\_volume\_gigabytes for transfer-accept
+
+9.0.0.0b3
+---------
+
+* Dell SC: Add dell\_server\_os configuration option
+* Add supported driver checks to Zone Manager
+* Fix backup unit tests imports for os-brick
+* Fix backup unit test with new os-brick
+* Stop using mox in unit/api/contrib/ tests (1/2)
+* Stop using mox in unit/volume/drivers/\*.py
+* ScaleIO over subscription support
+* Fix exceed of dd action when copying with path
+* Fix CapacityFilter to accept None volume type
+* Fix HNAS stats reporting
+* Imported Translations from Zanata
+* Stop using mox in unit/api/v3/ tests
+* Deleting volume metadata keys with a single request
+* Switch StrOpt to URIOpt for URL config options
+* Add Castellan release note
+* Add ability for ceph driver to report discard
+* Changes stats report for ScaleIO driver
+* Remove cinder/tests/unit/test\_misc.py
+* Imported Translations from Zanata
+* CoprHD: Handle create volume from CG snapshot error
+* Performance issue for VNX attache LUN
+* Config logABug feature for Cinder api-ref
+* Stop using mox in test\_wsgi, test\_nexenta, test\_netapp
+* Remove unused source file tests/unit/db/fakes.py
+* Fix an invalid function call in test\_consistencygroups.py
+* zfssaiscsi driver log messges need cleaned up
+* Fix typo in enable\_unsupported\_driver description
+* Mark GlusterFS driver as deprecated
+* Retype encrypted volumes
+* Fix DellStorageCenter docstrings
+* Fix driver interface checks for ZTE driver
+* Add CI\_WIKI\_NAME to ZTE Driver
+* Add CI\_WIKI\_NAME to X-IO Driver
+* Add CI\_WIKI\_NAME to Synology iSCSI Driver
+* Create encrypted volumes from images
+* Add encryptor attach/detach in utils
+* XtremIO: fix the returned value of CG actions
+* Stop using mox in unit/api/contrib/ tests (2/2)
+* Change assertTrue(isinstance()) with optimal assert
+* Stop using mox in unit/\*.py tests (1/2)
+* Use assertIn instead of assertTrue(A in B)
+* Remove unused function from unit/fake\_utils.py
+* Imported Translations from Zanata
+* Clean import in code
+* Remove unused config.CONF
+* Add tempest tests for Consistency Groups
+* HNAS: Add support for manage/unmanage snapshots in NFS driver
+* Reduce the runtime of drivers/ibm/test\_storwize\_svc
+* Improve TestCase.mock\_object method
+* Fix the password print in cinder-volume.log issue
+* VMAX Driver - Live Migration for VMAX3
+* Remove self.\_\_dict\_\_ for formatting strings
+* Imported Translations from Zanata
+* CoprHD: Add missing key in ScaleIO driver
+* Avoid patch loopingcall in VNX
+* Add validation for the metadata properties
+* Removed RPC topic config options
+* Clean imports in code
+* Replace key manager with Castellan
+* Cleanup api-ref
+* Update api-ref path
+* Nexenta: NexentaStor4 NFS driver cache capacity and use sessions
+* Stop using /etc/cinder/cinder.conf for cmd tests
+* Use utils.validate\_dictionary\_string\_length
+* Stop using mox from unit/image/\*.py
+* Fix some typos in comments
+* Separate create and update rules for volume metadata
+* Updated from global requirements
+* TrivialFix: remove unnecessary VERSION\_COMPATIBILITY
+* When only .pyc left, the extended API can not be used
+* Recover volume status after remove\_export
+* Pure - warn when deleting destroyed snapshot
+* Fix quota rollback on retype failure
+* Pin RPC server's serializer to min obj version
+* Driver documentation cleanup
+* Host selection when creating backup
+* TrivialFix: Remove cfg import unused
+* Fix password masking result
+* Let setup.py compile\_catalog process all language files
+* Dell SC: Add exclude\_domain\_ip option
+* Add support for force backup for Nimble Storage
+* Retype issue in Kaminario Cinder drivers
+* TrivialFix: Remove logging import unused
+* Stop using mox in unit/volume/drivers/emc/\*.py tests
+* Stop using mox in unit/consistencygroup/\*.py tests
+* Stop using mox in unit/scheduler/\*.py tests
+* Stop using mox in unit/zonemanager/\*.py tests
+* Stop using mox in unit/backup/drivers/\*.py
+* Fix incorrect parameter in create\_key
+* Use constraints for api-ref environment
+* Dell SC: Live Volume Autofailover
+* Add new supported driver checks
+* Tests: Fix racy volume unit test
+* [Trivial] Refactor the using of dict.get() in the test assertion
+* vzstorage: fix create/delete snapshots
+* Sending ScaleIO volume id in attach and detach volume
+* Cleanup upgrade-related FIXME's
+* Using oslo\_config's min attribute
+* Add replication failback in Kaminario K2 drivers
+* Added config option to enable SSL
+* Group specs: Fix exception name
+* Dell SC: Failback replications limited to 5 at a time
+* VMware: Add volume name in vCenter to conn info
+* NetApp: Report multiattach as enabled
+* Attachment lost after migrating in-use volume
+* Fix typo in the huawei\_driver.py
+* Fix invalid services caused by enabled\_backends
+* Updated from global requirements
+* Change NFS driver to not throw exception without nfs shares file
+* Datera driver 2.2 update
+* Reduce the runtime of drivers/dell/test\_dellsc
+* Add release note to warn about os-brick lock dir
+* Updated from global requirements
+* Use min attribute from oslo\_config
+* Imported Translations from Zanata
+* Fix the interface to call update\_server\_volume
+* Dell SC: Break\_replication unhandled NoneType error
+* Volume Manage/Unmanage Support for IBM FlashSystem
+* Imported Translations from Zanata
+* Change a typo error in the releasenote
+* Fix reported driver's versions
+* Use OVOs to set errors in manage volume/snapshot
+* Use original volume OVO instance in create flow
+* Fix mysql binary comparison
+* VMware: Allow images in ova container
+* Add CI\_WIKI\_NAME to driver's devref
+* Improve Hitachi HNAS volume drivers log messages
+* Updated from global requirements
+* EMC VMAX - iSCSI Multipath support
+* Fix typo in cinder/tests/unit/image/test\_glance.py
+* Clean imports in code
+* Imported Translations from Zanata
+* Enhance api\_microversion doc
+* Add CI\_WIKI\_NAME to Tegile volume driver
+* Add get\_manageable\_\* methods to Pure drivers
+* Use constraints for all tox environments
+* Imported Translations from Zanata
+* Remove the using of dict.get() in assertIsNone
+* Revise Synology DSM storage driver
+* Refactor the usage of save\_and\_reraise\_exception
+* Add volumes/summary API support
+* Imported Translations from Zanata
+* Ignore case when comparing wwns in Pure FC driver
+* NetApp: Add Consistency Group Support for NFS
+* Replication, hard-coding and dict.name issues in K2
+* Update homepage with developer document page
+* Add CI wiki page to driver listing
+* Imported Translations from Zanata
+* Refactor cinder.utils.\_copy\_volume\_with\_path
+* HNAS: Deprecating XML config file
+* Add functional-py35 to tox
+* Remove code duplication in enums
+* Concurrency issue in K2 iSCSI and FC Cinder drivers
+* VMAX Driver - QoS support for the VMAX3
+* Mask out passwords when tracing
+* Remove debug logger translations
+* Imported Translations from Zanata
+* Fix volume creation with no volume type
+* Dell SC: delete\_live\_volume payload incorrect
+* Dell SC: Requests async header is invalid
+* Imported Translations from Zanata
+* Use object instead of string when reset backup
+* Prevent doc generation failure on OVO decorators
+* CI: Add CI\_WIKI\_NAME to all drivers
+* Imported Translations from Zanata
+* Make the volume-manage doc be more general
+* Add missing dependency on keystoneauth1
+* Fix tox pip-missing-reqs
+* Revert "Remove Tegile volume driver"
+* HPE XP add entry point debug tracing
+* Remove resource\_common\_manage load warning
+* Updated from global requirements
+* Huawei: Check before add initiator
+* Huawei: Modify array LUNs naming rules
+* Added update-host for CGs in cinder-manage
+* Imported Translations from Zanata
+* Remove unused context parameter
+* Imported Translations from Zanata
+* QoS support for the Coho Data Cinder driver
+* Fix backup NFS share mount with default backup\_mount\_options
+* Add tracing to remotefs entry points
+* NetApp cDOT: Add cheesecake replication support
+* Don't use config option sqlite\_db
+* Improve snapshot handling in K2
+* Fix volume retype from SolidFire
+* EMC VMAX - Oversubscription support
+* Ceph doesn't save a container name for volume backup
+* Updated from global requirements
+* Fix volume upload-to-image for vhd disk-format
+* Imported Translations from Zanata
+* Remove context object in oslo.log method
+* 3PAR add entry point debug tracing
+* Fail manage operations if service is down
+* Support retype in K2 cinder driver
+* Remove comma from end of policy.json
+* Prevent adding same OVO version twice to history
+* Removed a dead db function register\_models()
+* Handle snapshot delete conflict in 3par driver
+* Imported Translations from Zanata
+* Specify key algorithm and size for create\_key
+* Add functional-py34 to tox
+* Fix size exceed of dd action when clearing a volume
+* HNAS drivers refactoring
+* Use volume o.vo in get\_backup\_volume\_temp\_snapshot
+* Imported Translations from Zanata
+* Fix ImportError of fake\_driver
+* Add proxy config option to google backup driver
+* Add API Reference for groups
+* Add stochastic weight handler to scheduler
+* Fix Scheduler manager masking retype fail details
+* fixed misspelling in synology\_common.py
+* Updated from global requirements
+* Don't puke when exiting driver list
+* corrected the help string in coho.driver
+* Fix ImportError of fake\_driver
+* Storwize:create\_volume\_from\_snapshot with different size
+* Imported Translations from Zanata
+* Fixing pending comments for CoprHD Drivers
+* Huawei: Fixed problems caused by password expiration
+* Add metadata length check to volume-manage
+* Added unit test coverage to test\_limits.py for api v2
+* Dell SC: Use Live Volume for replication
+* Remove race condition from lvextend
+* Switch request\_spec in create volume calls to ovo
+* Support replication in K2
+* Support manage/unmanage and extra-specs in K2
+* Update xiv\_ds8k driver name and description
+* Imported Translations from Zanata
+* Set VERSION in VNX cinder driver
+* ScaleIO ignore rename of external volumes
+* Managed snapshot should return ceiling of size in Huawei driver
+* Size in tintri driver should be converted to integer
+* Improvement to query cg detail(Part 1)
+* Fix documentation and remove dead code
+* VMware: Fix retype when storage policy is enabled
+* Validate name in qos-spec
+* Replace functions 'Dict.get' and 'del' with 'Dict.pop'
+* Updated from global requirements
+* NetApp: Report hybrid aggregates in volume stats
+* Storwize: Quote vdisk names to handle spaces
+* Add group\_type\_id in create\_group\_snapshot
+* Fixes ZFSSANFS driver
+* DRBD: Disk-options for new resources
+* Fix mistakes introduced with QoSSpecs object
+* Add backup update function (microversion)
+* VMware: Fix upload to image with glance v2
+* Remove Tegile volume driver
+* Quobyte volume driver should use DLM
+* Add functional tests for nested quotas
+* XtremIO: Implement update\_migrated\_volume
+* NetApp: Refactor unit tests
+* Add driver list to doc build
+* Move fake\_driver to tests root dir
+* Map volume/snapshot manage extensions to v3
+* Replace OpenStack LLC with OpenStack Foundation
+* VMAX Driver - SnapVX licensing checks for VMAX3
+* LVM driver: list manageable volumes and snapshots
+* Sheepdog:fix the bug of failed to clone image
+* Move drivers unit tests to unit.volume.drivers directory
+* Docs: Correct i18n information
+* Fix db purge for quality\_of\_service\_specs FK constraint
+* Fix log message when service is disabled
+* Add interface documentation to driver devref
+* Remove duplicate code in functional tests
+* Docs: cleanup doc8 errors
+* Docs: remove todo list generation
+* Update doc README and remove old Makefile
+* Imported Translations from Zanata
+* Handle API NotFound exceptions at WSGI level
+* Add worker's DB operations
+* Add workers table
+* Modify API to include cluster related operations
+* Update manage with cluster related commands
+* Improve cinder-manage arg parsing
+* Add cluster job distribution
+* Update Versioned Objects with Cluster object
+* Add cluster table and related methods
+* Update OVO instance on destroy method call
+* Fix wrong declaration in Scheduler's base driver
+* Refactor sqlalchemy service methods
+* Improve api\_version decorator to avoid noqa
+* Imported Translations from Zanata
+* Add functional tests for groups
+* Tests: mock notifier in CG tests
+* Remove duplicated code in manage\_existing\_snapshot
+* Initialise oslo.privsep early in main
+* Imported Translations from Zanata
+* Add lock decorator to SolidFire clone\_image method
+* Dell: Fix docstring cut/paste error
+* NetApp: Support new parameter to cDOT clone API
+* Auto sync manager's RPC\_API\_VERSION
+* Fix CinderPersistentObject.refresh
+* Replace locks in remotefs and glusterfs backend drivers
+* Block Device Driver: report pools in volume stats
+* Add missing test case
+* Updated from global requirements
+* Invalid volume state when manage operation fails
+* Add group snapshots - APIs
+* Dell SC: Add secondary DSM support
+* Fix some typos
+* Remove generate\_driver\_list dependency on cur dir
+* Huawei: Support reporting disk type of pool
+* Fix 500 for 'qos-create' key or value > 255 characters
+* Add group snapshots - manager
+* Add group snapshots - db and objects
+* XtremIO: support of snapshot manage commands
+* Fix the group type filter
+* Fix policy check for group types
+* Differentiate thick and thin provisioning
+* Remove force option from create\_snapshots\_in\_db()
+* Set sleep time to 0 in Datera driver
+* Add generic volume groups
+* Huawei: Support backup snapshot
+* Fix assertEqual usage in test\_volume\_manage
+* Fix chunked backup driver interface name
+* Removed unused code from cinder.utils
+* 3par driver handles concurrent host create conflict
+* Fix typo in delete snapshot in Synology driver
+* Removed unused code from cinder.utils
+
+9.0.0.0b2
+---------
+
+* Fixes consistency snapshot creation
+* [doc] Fix a non-alphabetical order bug
+* Trivial: Use fake.VOLUME\_ID instead of id
+* Violin Memory iSCSI storage for 7000 series AFA
+* update min tox version to 2.0
+* Updated from global requirements
+* Switch \_create\_temp\_cloned\_volume in driver to VO
+* NetApp: Add aggregate capacity info to scheduler
+* Add strict Boolean checking for storage pools
+* Add Synology DSM storage driver
+* Use from\_environ to load context
+* Use context.from\_dict to determine available arguments
+* Add ZTE Block Storage Driver
+* iSCSI Target: remove confusing comment/log
+* Storwize: Fix exception ProcessExecutionError
+* Changing method \_from\_db\_object to classmethod
+* Allow admin project to operate on all quotas
+* Use default provisioning type from config
+* Delete \*.pyc files before running tox tests
+* Implementation for CoprHD Cinder Drivers
+* Image virtual size doesn't fit to volume size
+* Don't apply config fixture to auth\_token.CONF
+* Check flashcopy mapping before deleting volume
+* Send scaleio id to os-brick
+* Nexenta: Added HA support and enhance get\_volume\_stats()
+* Fix failure with "None" volume type in Pure drivers
+* Add backend driver for Zadara Storage VPSA
+* Add group type and group specs
+* Don't use shred for volume clearing
+* Add cinder backend driver for Huawei FusionStorage
+* Do not conjecture volume-id from iscsi\_name
+* VNX: New Cinder driver in Newton
+* Return vaild reason when unknown error occur
+* Moving the OPTIONAL\_FIELDS inside the OVO  object
+* Support microversions on inherited Controllers
+* Replace use of mox with mock in test\_base\_filter
+* Replace 10 \*\* 9 with a constant units.G
+* Reduce logging level of API validation messages
+* Fix manage existing volume fails after object merged
+* Add strict Boolean checking for volume manage
+* Adds unit test coverage for consistencygroups.py
+* FalconStor: New Cinder driver in Newton
+* Move QualityOfServiceSpecs to use VersionedObject
+* Snapshot object has no attribute about size
+* Add return parameter info for manage\_existing\_get\_size
+* cinder-manage db purge has issues with foreign keys
+* Huawei: Use versionedObject
+* Resolve unittest hang issue
+* Fix some typos
+* Add logging when filtering returns nothing
+* Validate extra\_specs type
+* Just a few spelling modification. "occurred"
+* Remove white space between print and ()
+* Log traceback for initialize connection failure
+* Remove unused LOG
+* Use assertEqual/Less/Greater/In/IsNone
+* Updated from global requirements
+* Add \_\_ne\_\_ built-in function
+* Fix consisgroup V3 interfaces
+* Add proper scheduler\_hint key to dev-ref
+* check the validity of metadata when update volume
+* Remove unused \_\_init\_\_
+* EQLX: Extend of snapshot or clone failure
+* Log terminate\_connection exception with traceback
+* Replace use of mox with mock in test\_api\_urlmap
+* Add README in release notes directory
+* Fix broken link in HACKING.rst
+* Replace int with float to bring math.ceil into effect
+* EMC ScaleIO should return ceiling of volume size
+* Deprecate defining c-vol backends in DEFAULT
+* Dell SC: Do not set High Availability in async mode
+* Replace use of mox with mock in test\_ibm\_xiv\_ds8k
+* Remove translation from config options
+* Correct reraising of exception
+* EMC VMAX - locking SG for concurrent threads
+* Use elevated context to query DB in VolumeNumberWeigher
+* Huawei: Support huawei consistency group
+* Make divisible py3 compatible in nfs driver
+* Updated unit tests to use official unittest methods
+* Fix raise UnableToFailover call in SolidFire
+* Provide Kaminario K2 all-flash array FC driver
+* RBD: uppercase rbd\_opts for consistency
+* Add strict Boolean checking for volume create
+* Replace use of mox with mock in test\_brick\_lvm
+* Replace use of mox with mock in test\_lvm\_driver
+* Remove six.iter\*
+* Updated from global requirements
+* Add validation for container name
+* VMware: Fix create vol from streamOptimized image
+* Use True instead of 1 in while loop
+* Remove mock.patch.stopall call in test\_smbfs
+* XtremIO: fix test suite
+* Add strict Boolean checking for quota show
+* Correct unavailabe to unavailable
+* Huawei: Support iSCSI configuration in replication feature
+* Dell SC: Specify High Availability for create replication
+* Increment Pure Storage Driver Versions
+* Refactoring Kaminario iSCSI driver
+* Don't reuse pep8 env in compliance tox runs
+* Trivial Fix
+* NetApp: Finish SSC refactor by removing dead code
+* Implement unit test for HPE Lefthand driver
+* Added coverage report to tox.ini
+* Add strict Boolean checking for qos delete
+* Add validation for type extra\_specs
+* Replace mock with self.override\_config
+* fix cinder ceph backup driver padding error
+* Replace 1024\*1024\*1024 with units.Gi to express more accurately
+* Unexpected function is called in \_migrate\_volume\_generic
+* Violin: resize volume if cloned lun is larger
+* Make dict.keys() PY3 compatible
+* Move \_validate\_extra\_specs to cinder/utils
+* VMware: Refactor vmdk unit tests
+* Updated from global requirements
+* Move \_check\_metadata\_properties to cinder/utils
+* Remove deprecaterd mapping in manager.py
+* Capability lists in Cinder scheduler
+* Updated from global requirements
+* Nexenta: Add NBD driver for NexentaEdge
+* Add missing coordination=True on service start
+* tempest: Add Unicode volume name test
+* Adding Scaling QoS for ScaleIO driver
+* Updated from global requirements
+* Implement match-set type 3PAR FC VLUN creation
+* Fix pylint error in K2 iSCSI driver
+* Fix lock files littering working dir during tests
+* Fix TSM backup driver test mocks
+* Improve DB volume check in LVM manage volume
+* VMware: Honor vmware\_cluster\_name during retype
+* Revert "Revert "use utf8 as default charset for all tables in mysql db""
+* Fix snapshot stuck in 'deleting' after reboot c-v
+* Update initialize\_connection to use versionedobjects
+* Updated from global requirements
+* NetApp: Replace SSC for cDOT block & file drivers
+* Revert "use utf8 as default charset for all tables in mysql db"
+* huawei-iscsi-multipath-support
+* use utf8 as default charset for all tables in mysql db
+* Implemented unit test cases for HPE LeftHand driver
+* add FIXME tag for extra argument 'topic' in scheduler rpc api
+* update coordination.Lock.release's docstring
+* Fix permissions error when configuring nfs backend
+* Use cinders test class in cloudbyte unit tests
+* Correct DB modifications from compaction
+* Add unit tests in cinder for HPE Lefthand driver
+* Provide Kaminario K2 all-flash array iSCSI driver
+* VMware:Persist storage policy ID in vmdk meta-data
+* Allow setting CG name or description to empty value
+* Support None value of extra\_specs in cinder-scheduler filter
+* Fix db purge for volume\_types FK constraint
+* ABC Metaclass for IBM FlashSystem
+* IBM FlashSystem: Add host check for iSCSI driver
+* vzstorage: add ploop volume format support
+* Use versionedobjects in remotefs.py
+* Move test from test\_glusterfs and test\_quobyte to test\_remotefs
+* Netmask needs corersion to string
+* image\_size\_m should get ceiling of image
+* Add unit tests in cinder component for 3PAR driver
+* Handle quota exceed exception
+* Replace locks in volume manager
+* Updated from global requirements
+* Start/Stop coordinator with Volume service
+* Tests: Remove notification\_driver config
+* Tests: Use mock for notifier tests
+* 3PAR: Fix delete volume when online clone
+* Add driver interface checks
+* Add test type clarification to devref
+* Backup and restore broken in zfssaiscsi driver
+* Windows SMBFS: fix VHD/x resize
+* Remove duplicated fake drivers
+* Cleanup volume\_type\_projects
+* Implement OVO class init mechanism
+* Add debug level logs on OVO backports
+* Stop assuming persistent OVOs are also DictCompat
+* Move OVO methods from CinderObject to Persistent
+* Remove remotable from OVOs
+* Use manifest to backport OVOs during upgrades
+* Nimble: Don't query all vols from DB in do\_setup()
+* Fix wrong usage of exception's attribute message
+* Add parameter info for manageable snapshots
+* Adds ACL, IP Pool, Multipath to Datera Driver
+* Dell SC: Retry unhandled exception REST Gets
+* Fixed \_create\_3par\_iscsi\_host(), added unit test for 3PAR
+* Set QoS on cloned volumes
+* VMware: Deprecate vCenter version 5.1
+* Update manage\_existing to use volume object
+* VMware: Fix constants in unit tests
+* Updated from global requirements
+* EMC driver should return ceiling of volume size
+* Use oslo\_middleware sizelimit
+* migrate to os-api-ref
+* volume upload-to-image fails for iso disk-format
+* Huawei driver should return ceiling of volume size
+* Volume manage/unmanage support for Eqlx driver
+* NetApp: Log unexpected errors from backend
+* Add Auth Version 3 support in Swift Backup Driver
+* Add error messages to conditional updates devref
+* Add docstrings to CG and CG Snapshot filters
+* Virtual size should get ceiling of image
+* DRBD: Allow to set options for new resources
+* SolidFire driver should return ceiling of volume size
+* Clean up man page and remove version/date
+* 3PAR: Fix terminate\_connection when failed over
+* VMware: Remove unused methods
+* Fix MySQL DB error in Delete CG
+* Nimble driver should return ceiling of volume size
+* Updated from global requirements
+* Remove locks from Pure volume drivers
+* Give more fine grained access to DriverInitiatorData
+* Remove IN\_USE from ConsistencyGroupStatus enum
+* Compact Kilo database migrations
+* Bump to Nova v2.1
+* Switch to using correct TaskFlow Failure class
+* Optimize service find in migration
+* NetApp NFS Cmode: Fix NotFound exception
+* Add check to limit maximum value of age\_in\_days
+* GPFS: Fix consistency group ERROR\_CREATE status
+* Remove the duplicated definition of \_add\_to\_threadpool
+* Imported Translations from Zanata
+* Coho data sanity fix in the driver unittest
+
+9.0.0.0b1
+---------
+
+* Dell SC: Added support for failover\_host failback
+* Remove API races from consistency groups
+* Minimize cost of DB exists decorator checks
+* Pass volume\_type\_id in when deleting snapshot
+* Add unit test case in Nimble Driver
+* Fix attachment\_get\_by\_\* to return entire list
+* Remove API races from migrate and retype
+* SwiftBackupDriver: Dont add project\_id to authurl
+* Updated from global requirements
+* Catch GlanceMetadataNotFound in creating cgsnp
+* Updated from global requirements
+* List manageable volumes and snapshots
+* Updated from global requirements
+* Add pagination support to messages
+* gpfs: Add changed options for 'find' command in rootwrap filters
+* Huawei replication should use auto recovery policy
+* Dell SC: Switched REST calls to async where available
+* Move all backups related unit tests to backup directory
+* Move consistency groups tests to consistencygroup directory
+* Volume manage should parse volume size as float
+* Return BadRequest for invalid 4byte unicode character
+* NetApp: Add iterator handling to client library
+* Make IBM drivers return snapshot object for cg ops
+* Coho Data: Reconnect to cluster on broken pipe
+* Remove mox usage from test\_nexenta
+* Manage/unmanage snapshot in ScaleIO driver
+* 'display-name' is not used in snapshot\_manage
+* LeftHand Fix terminate\_connection when failed over
+* Storwize: terminate\_connetion NPIV perf improvement
+* Revert "Add hacking check to prevent assert\_called\_once"
+* Fix 3PAR cg display name issues
+* DRBD: ensure\_export() might not have 'provider\_location'
+* Fix image-volume cache to use volume object when evicting
+* Fix retype from non-repl to repl type in Pure drivers
+* Remove test\_conf.py
+* Dell SC: Changed rename volume REST API call
+* Add hacking check to prevent assert\_called\_once
+* Updated from global requirements
+* Huawei: Raise if no FC port found
+* VMware: Increase default task poll interval
+* VMware: Update volume config during unmanage
+* Drop use of invalid assert\_called\_once call
+* Fix AttributeError when obtaining 'name' attribute from 'snap'
+* Handle SSL termination proxies for version list
+* Call \_init\_volume\_driver in backup manager
+* Updated from global requirements
+* model\_update for temp volume or snapshot in backup
+* Add debug messages and comments for ceph backup
+* Avoid ascii code error for request body strings
+* Fail on disabled\_reasons with more than 255 chars
+* Windows iSCSI: properly handle config option
+* Remove unused logging import and LOG global var
+* Fix Brcd zone driver initiator zone update
+* Add SnapshotStatus enum field
+* Tests: Fix mock imports
+* NetApp: Remove type checks from manage workflow
+* ScaleIO actual volume size model update
+* Capacity weigher: Pass correct arg to super()
+* IBM Flashsystem: Add missing items to common
+* Prevent Multitable conditional updates
+* Remove support for 1.x volume RPC API
+* Remove inappropriate Copyright
+* RBD: include cluster name in connection info
+* Tests: Don't attempt connection for Coho driver init
+* 3PAR Clean up VLUN deletion on detach
+* Remove object to dictionary translation logic
+* Refactored the update method in api.py for vol obj
+* Tests: Use unique volume IDs in backup tests
+* Move LVM tests to test\_lvm\_driver.py
+* Move CG unit tests to test\_cg.py
+* Fix an error in CG object
+* Fix backup using temp snapshot code path
+* IBM FlashSystem: Cleanup host resource leaking
+* Updated from global requirements
+* Add sample config file to cinder docs
+* Make api\_microversion\_dev more explicit
+* Use check\_string\_length from oslo\_utils
+* Fix up RPC cleanup process
+* Add unit tests in cinder component for HPE drivers
+* Whitelist 'rm' in api-ref tox environment
+* gpfs: remove a race in deleting volumes
+* Fix taskflow parameters for manage\_existing
+* Correct misspelt words in msg in cinder
+* Implement CHAP Authentication for E-Series Driver
+* WADL to RST migration in cinder tree
+* Properly mock out image\_utils operations for tests
+* Dell Eqlx: Volume from snapshot now honors resize
+* Use example.com in unit tests
+* Extend remove\_version\_from\_href support
+* Fix return value of \_clone\_image\_volume
+* image: don't use is\_public with glance V2 API
+* Change provider\_id to StringField
+* Add missing SnapshotUnavailable to cinder/exception.py
+* NetApp: Rewrite user API discovery logic
+* Remove unnecessary v3 VolumeController.\_\_init\_\_
+* Fix v3/volumes.py VolumeController super(...) parameters
+* DB: Optimize volume existence check
+* Reorder DB API require\_context decorators
+* Remove API races on extend and volume\_upload\_image
+* Manage existing volume with invalid host
+* Remove CG db access in Storwize driver
+* Specify a user-agent in Pure volume drivers
+* Dell SC: find\_volume failure in manage and retype
+* 3PAR driver failure SR License missing in array
+* Remove unnecessary created\_at from ORM Message
+* Fix uncaught NotFound exceptions
+* Remove support for 1.x Backup RPC API
+* Provide consistency to "Openstack-Api-Version" header
+* Change OVOs project\_id and user\_id to StringField
+* Use to\_utf8() instead of safe\_encode() in convert\_str()
+* Replace manually changing CONF options
+* remove extra quota commit of manage snapshot
+* Add replication v2.1 test cases
+* Move initiator\_data access to helper methods
+* Add ability to filter by volume\_glance\_metadata
+* Add Cheesecake APIs to policy.json file
+* Add upload\_image API role-based access policy
+* Add snapshot\_metadata operations to policy.json
+* Mark the v1 API as deprecated
+* Fix Lun ID 0 in HPE 3PAR driver
+* Added 'volume:get\_transfer' to policy.json file
+* NetApp: Decouple capacity volume stats collection
+* NetApp: Managing cDOT LUN by UUID fails
+* VMware: Use \_in\_use() to check for in-use volumes
+* Add devref for conditional updates
+* Fix gate-cinder-tox-db-functional job
+* Add ordering possibilities to conditional update
+* Add unmanage volume for RBD driver
+* Updated from global requirements
+* VMware: Support for paraVirtual image adapter type
+* Pass default executor to os-brick
+* NetApp: E-Series driver using invalid host-types
+* NetApp: Use Local Cache to Copy an Available Image
+* Add provider\_location to cloned volume
+* Failback will enable the host that has been frozen
+* Move and rename tempest\_tests to cinder/tests/tempest
+* Tests: lower case all fake uuid constants
+* Tests: Fail if oslo.versionedobjects issues Invalid UUID warnings
+* Removed extra line of code
+* Fix uuid warnings in various api contrib unit tests
+*  Fix snapshot test uuid warnings in api.contrib
+* Fix volume test uuid warnings in api.contrib
+* Fix vol type/spec uuid warnings in api.contrib
+* Fix qos\_manage uuid warnings in api.contrib tests
+* Fix CG uuid warnings in api.contrib unit tests
+* Fix admin\_actions uuid warnings in api.contrib
+* Fix uuid warnings from api.contrib backup tests
+* Fix uuid warnings from test\_db\_api unit tests
+* User messages API for error cases
+* Imported Translations from Zanata
+* Imported Translations from Zanata
+* Assisted snapshot:  use Keystone Session with Nova Client
+* Imported Translations from Zanata
+* fix invalid uuid in emc extremio unit tests
+* fix invalid uuid warnings from test\_cmd
+* Fix invalid uuids in tintri unit tests
+* Fix uuid warnings from db unit tests
+* Fix invalid uuids in EMC scaleio unit tests
+* Tests: Fix invalid UUIDs in EMC VNX tests
+* ibm flashsystem: Fixing hardcoded attribute
+* Fix 20 typos on devref
+* VMware: Remove TODO for port config option
+* Remove XML API
+* Microversion of Bootable filter in cinder list
+* init\_host offload to default to true
+* Imported Translations from Zanata
+* Updated from global requirements
+* 3PAR: Remove metadata that tracks the instance id
+* Updated from global requirements
+* Handle TFlow short comings in SF driver
+* Add failed\_over detection to SolidFire driver
+* Implement replicate\_volume & failover on SolidFire
+* Deprecate nas\_ip and change this to nas\_host
+* Imported Translations from Zanata
+* Implement Cluster Pairing for SolidFire Driver
+* Fix minor typos in the migration devref
+* Cleanup volume\_attachment in case of reset-state attach\_status
+* Updated from global requirements
+* Use messaging notifications transport instead of default
+* Fix doc and source documentation errors and warning
+* RBD: delete snapshots if missing in the backend
+* Coding style issue
+* Remove support for 1.x scheduler RPC API
+* Launchpad Answers no longer used
+* Fix RPC and Object version pinning on API
+* Fix service version pinning on start
+* Fix doc build if git is absent
+* Updated from global requirements
+* Tests: Define fake\_constants as constants
+* Doc: Remove incorrect run\_tests.sh documentation
+* fix invalid uuid warnings from test\_quota
+* Fix fake uuids in NetApp ESeries unit tests
+* Fix invalid uuids in sheepdog unit tests
+* Use utils.convert\_str to convert HTTP header values
+* Remove deprecated ISERTgtAdm
+* Set backup import volume id to real uuid
+* fix ConsistencyGroup volume\_type\_id field
+* Updated from global requirements
+* Storwize: Multiple management IP not raising exceptions
+* Fix ExtraSpecsOpsTestCase sub unit tests
+* check per\_volume\_gigabytes quota for cinder extend
+* Imported Translations from Zanata
+* Updated from global requirements
+* Make cinder-all binary deprecated
+* Add in-tree tempest tests
+* Update SolidFire driver to store cluster info
+* VMware: Reduce volume creation time
+* Fix typos in Cinder files
+* Fix driver.failover\_host call in manager.py
+* Remove "patch mock to raise for invalid assert calls"
+* Add test for checking object compatibilities
+* Update the Administrator guide links
+* Update \_usage\_from\_backup() method with versionedobjects
+* Dell SC: Updated to utilize provider\_id
+* Updated from global requirements
+* Sheepdog:make full use of all sheepdog nodes
+* Enable str2size() to handle long int for i386
+* Imported Translations from Zanata
+* Hacking: Ignore tools/ for C303
+* Pylint: refactor ignored message lists
+* Brocade FCZM: Fix LOGOUT\_PAGE reference
+* Fix volume retype failure with on-demand policy
+* Define context.roles with base class
+* Fix invalid error message of volume create
+* Stop using tpool with oslo\_db
+* Huawei: Do not do split if replication pair abnormal
+* Storwize: fix unmapped multi-attached volume failure
+* Cleanup DB schema after Mitaka
+* Fix uuid warnings from api.v2 unit tests
+* Dell SC: Checking volume size in create\_volume\_from\_snapshot
+* Fix uuid warnings from api.v1 unit tests
+* Fix api/v1 unit test inconsistencies
+* Add fake\_cgsnapshot for unittest use
+* Fix typos in Cinder files
+* http header value must be a string
+* python34 tests don't run without python3-dev
+* Re-enable image to volume with failure test
+* Dell Eqlx: Cloning volume does not honor new size
+* Storwize: fix deadlock and major lock granularity issue
+* Fix for NexentaEdge jsonrpc url formatting
+* Support oversubscription for IBM Storwize/SVC
+
+8.0.0
+-----
+
+* Huawei: Fix getting admin\_metadata
+* Imported Translations from Zanata
+* NexentaStor4 iSCSI: convert blocksize to str
+* Conditionally restore display\_name
+* NexentaStor drivers: resize volume if cloned image is larger
+* rtstool surrounds IPv6 addresses by brackets
+* Imported Translations from Zanata
+* NexentaStor: Remove extra format string specifier
+* Fix typos in Cinder files
+* Imported Translations from Zanata
+* XtremIO handle errors in terminate\_connection:
+* Imported Translations from Zanata
+* Check hasattr before calling get in SolidFire
+* Huawei: Fix getting admin\_metadata
+* Remove unused utils.find\_config function
+* Sheepdog:optimization of connection error handling
+* DRBD: extend volume if larger than snapshot
+* Imported Translations from Zanata
+* Fix invalid uuids in rbd unit tests
+* Dont query image metadata for empty volume list
+* Remove entry\_points from setup.cfg
+* Don't suppress the path part of glance url
+* Fix meaningless quota exceeded exception info
+* Imported Translations from Zanata
+* Don't disallow quota deletion if allocated < 0
+* Added more options while uploading volume as image
+* VMware: Support for non-default port
+* Remove PyMySQL and psycopg2 from test-requirements.txt
+* Imported Translations from Zanata
+* Provide user friendly message for FK failure
+* Fix misspelled word in help text
+* Datera: resize volume if cloned image is larger
+* Fix Brcd lookup service to use defined southbound protocol
+* Docs: Add genconfig to devref toc
+* Updated doc string
+* Imported Translations from Zanata
+* Report 2.0 as supported version of RPC APIs
+* Fix volume RPC API methods related to backups
+* Report 2.0 as supported version of RPC APIs
+* NexentaStor5 iscsi: resize volume if cloned image is larger
+* Imported Translations from Zanata
+* EMC VMAX - Operations and timeout issues
+* Imported Translations from Zanata
+* Imported Translations from Zanata
+* Fix the format problem of LOG in failover\_host
+* Dell SC: Error results moved to json
+* Dell SC: create\_cgsnapshot returning wrong structure
+* Re-add policy check for get\_snapshot
+* Enable functional test for volume creation
+* Remove bandit.yaml in favor of defaults
+* NexentaEdge: resize volume if cloned image is larger
+* Storwize: Set multiattach property per pool
+* Fix volume RPC API methods related to backups
+* Imported Translations from Zanata
+* Imported Translations from Zanata
+* Fix race condition when toggling SP
+* Dell SC: create\_cgsnapshot returning wrong structure
+* Hitachi drivers: resize volume if cloned image is larger
+* Huawei: Record and check LUN wwn
+* Mark deprecated options correctly
+* SMBFS: fix parsing volume type extra specs and metadata
+* Update reno for stable/mitaka
+* VMware: Bump driver version
+* VMware: Bump driver version
+* Imported Translations from Zanata
+* VMware: Refactor unit tests
+* Update .gitreview for stable/mitaka
+* Huawei: Record and check LUN wwn
+
+8.0.0.0rc1
+----------
+
+* Reserve 5 migrations for Mitaka backports
+* Add update\_host for backup in cinder-manager
+* Fix formatting in vol/snap delete API messages
+* Cleaned duplicate dictionary values
+* Fix compatibility mode of backup jobs scheduling
+* Add devref on rolling upgrades
+* 3PAR fix create\_cloned\_volume for larger size
+* VNX: Enhance migration start verification
+* Check volume\_id consistent when creating backup
+* Fix race condition when toggling SP
+* Huawei: Check when attach hypermetro volume
+* Huawei: Check the QoS status before we use
+* LeftHand: Add default SSH timeout and key values
+* Pass correct source\_id to \_handle\_bootable\_volume\_glance\_meta()
+* Alter wrong comment about param filters
+* Use get\_by\_args instead of get\_by\_host\_and\_topic
+* Fix format in cinder/volume/drivers/netapp/dataontap/block\_base.py
+* XIO: refactor \_send\_cmd to reduce the redundant
+* Revert "VNX: Set timeout for naviseccli"
+* NetApp E-Series: Volumes not added to consisgroup
+* Fix volume migration VolumeType exception
+* Fix retype failure when original has no volume type
+* Add backup RPC API v2.0
+* IBM XIV/DS8K: Implement Replication v2.1
+* Huawei: Implement v2.1 replication
+* Remove circular import to fix config generation
+* Wrong comment line in quotas.py
+* XtremIO handle errors in terminate\_connection:
+* Imported Translations from Zanata
+* VNX: Set timeout for naviseccli
+* VNX: Allow set migrate rate when migrating volumes
+* Fix ScaleIO driver does not honor clone size
+* Fix py34 error of indexing 'dict\_keys' object
+* Imported Translations from Zanata
+* Fix error message when running genconfig
+* Huawei: Creating hypermetro failed in the remote pool
+* Delete deprecated configuration in NFS tests
+* Imported Translations from Zanata
+* Emit notifications for volume retype
+* Fixup stats key for replication in init\_host\_with\_pc
+* EMC VMAX - SSl connection is not picking up values
+* Add the key 'replication' and set the correct 'replication\_status'
+* register the config generator default hook with the right name
+* Fix for Pure drivers not checking full client version
+* Fixup for Pure drivers cheesecake replication setup
+* Remove empty directories and unused files from unit tests
+* Cleanup 3PAR/LeftHand failover\_host exceptions
+* Use googleapiclient import instead of apiclient
+* Enable api.view.test\_versions unit tests
+* Allow clone volume with different size
+* DRBD driver: resize volume if cloned image is larger
+* Fix 500 error if 'offset' is out of range
+* Add volume RPC API v2.0
+* Imported Translations from Zanata
+* typo: add a missing '}' in comment
+* Fix up failover\_host exceptions to preserve states
+* Add release note for delete volume with snaps
+* RBD: remove duplicate clone test
+* Disallow quota deletes if default under usage
+* EMC VMAX - SnapVX and other snapshot improvements
+* Move replication\_status update to init\_with\_rpc
+* Lazy load a project quotas's default values
+* Permit volume type operations for policy authorized users
+* SMBFS: fix parsing volume type extra specs and metadata
+* Host selection in backup service
+* Add volume\_type to volume object expected\_attrs
+* VNX: Update replication for v2.1
+* Imported Translations from Zanata
+* Pass new volume size when cloning (blockbridge)
+* Storwize: Update replication to v2.1
+* LeftHand: Create cloned volume didn't honor size
+* Switch failover-host from rpc call to cast
+* Dell SC: Active\_backend\_id wrong type
+* Show qos\_specs\_id based on policy
+* Remove remaining oslo-incubator code from Cinder
+* Updated from global requirements
+* Pass RBD order to clone call
+* Remove "sqlite\_clean\_db" option
+* Exclude test.py from sample conf
+* Fix invalid UUID warnings for test\_volume\_\*
+* Huawei: Check before delete host
+* rbd: Change capacity calculation from integer to float
+* Fix failure with rbd on slow ceph clusters
+* Remove those unnecessary statements "return True"
+* Imported Translations from Zanata
+* Run py34 tests with plain 'tox' command
+* Report versions in cinder-manager service list
+* Dell SC: create\_cloned\_volume didn't honor size
+* Cleanup Mitaka release notes
+* Dell SC: Incorrect values in REST API Login call
+* Moved CORS middleware configuration into oslo-config-generator
+* Add get\_volume\_stats for LoggingVolumeDriver
+* Correcting thin provisioning behavior
+* SMBFS: Fix initialize connection issues caused by in-use images
+* NetApp: volume resize using clone fails with QoS
+* VMware: Unit test refactoring
+* Fixes creating volume issue for multiple management IPs
+* Imported Translations from Zanata
+* Add volumes table definition when migrating to 67
+* Trim 5s+ from storwize unit tests
+* Allow api\_version\_request.matches to accept a string
+* microversion header for legacy endpoints removed
+* Update quotas to handle domain acting as project
+* Continue volume delete on encryption key delete errors
+* Fix backup import
+* Unset executable bit in release note
+* DRBD: Policy-based waiting for completion
+* Block subtractive operations in DB migrations
+* Handle exceptions about snapshot in backup create
+* Replace logging with oslo\_log
+* Support https keystone CA checking in volume quotas
+* Imported Translations from Zanata
+* Fixup release notes for v2 -> v2.1 replication impls
+* support new HTTP microversion header
+* Fix for glance\_metadata during volume migration
+* Readd iscsi\_target table
+* Imported Translations from Zanata
+* Fix issue with Pure drivers delete\_snapshot exception handling
+* Add backend id to Pure Volume Driver trace logs
+* Don't fail on clearing 3PAR object volume key
+* Fix invalid uuid warnings in backup unit tests
+* Update quota\_utils with import for keystone\_auth
+* Fix invalid uuid warnings in test\_volume.py
+* Tintri image direct clone
+* Use get\_by\_args instead of host\_and\_topic
+* Remove a vol in error state from a CG
+* Fix call to Barbican Secrets create()
+* 3PAR use same LUN id for each export path
+* Fix oslo.service config generation
+* Update unittest for Storwize pool-aware-cinder-scheduler
+* Huawei: Check the real size before extend volume
+* Revert "Remove Cisco FC Zone Manager Driver"
+* Make query to quota usage table order preserved
+* Allow for Pure drivers to verify HTTPS requests
+* Fix volume filtering for quoted display name
+
+8.0.0.0b3
+---------
+
+* Use openstack.org URLs in README
+* Add attach/detach doc to index
+* Don't run test\_volume.VolumeTestCase twice
+* Fixes running error for storwize \_run\_ssh
+* Dell SC: Support Replication V2.1
+* Use OSprofiler options consolidated in lib itself
+* Fix test\_create\_volume\_flow test issue
+* Fix test isolation issues related to versions
+* Add missing requirements
+* Convert huawei ISCSIDriver unit tests to RFC5737 addrs
+* Changes in ScaleIO configurations options
+* Storwize/SVC: Clone between different size volumes
+* Huawei: Manage volume fails due to lower array version
+* Fix exception during service update
+* Huawei: Create snapshot have a log error
+* EMC VMAX - Limit SG and MV to 64 characters
+* Fix spelling mistake in docstring
+* EMC VMAX - Recreating SG when it has been deleted
+* VMAX-Replacing deprecated API EMCGetTargetEndpoints
+* 3PAR: Update replication to v2.1
+* LeftHand: Update replication to v2.1
+* Update Pure replication to cheesecake
+* Fixed logging for oslo versioned objects
+* Move replication volume manager warnings to info
+* Trim 50s from huawei ISCSIDriver unit tests
+* Copy unit tests for StandardLogging fixture from Nova
+* Add 'conf' param for TextGuruMeditation autorun setup
+* Use is\_int\_like method from oslo\_utils
+* Fix sshpool.remove code
+* Remove an useless and wrong call
+* Copy StandardLogging fixture from Nova
+* Add ability to failback for replication V2.1
+* Storwize SVC multiple management IPs
+* Updating Datera DataFabric Driver to v2 of Datera DataFabric API
+* Capture warnings into logs
+* Return BadRequest for invalid unicode names (continued)
+* IBM Storwize with pool-aware-cinder-scheduler
+* Fix HTTP sessions left open in Brocade zone driver
+* Fix invalid uuid warnings in block device unit tests
+* Fix invalid uuid warnings in scheduler unit tests
+* Add necessary fields to volume creation
+* Add scheduler RPC API v2.0
+* Clean up replication v2.1 (Cheesecake) RPC API
+* always use pip constraints
+* Remove unused columns from Service ORM model
+* CONF add suppress\_requests\_ssl\_warnings
+* Make nullable of fields in db model and object match
+* Remove unused pngmath sphinx extension
+* Delete volumes with snapshots
+* Clarify glance\_api\_insecure help text
+* NetApp: Fix SSH Client File Creation in Unit Test
+* Trim 12s from disco unit tests
+* Remove QoS settings from SolidFire attributes
+* EMC VMAX - get iscsi ip from port in existing MV
+* Misprint in policy.json
+* Re-enable -1 child limits for nested quotas
+* Support IP lookup of target portal DNS name
+* Updated from global requirements
+* Huawei: delete\_snapshot need not return any value
+* Match the ip more accurately in Huawei driver
+* Huawei: Consider bandwidth when selecting port
+* Add description when rename LUN in Huawei driver
+* Huawei: Code cleanup
+* Modify the number of params of hypermetro in HuaweiDriver
+* EMC VMAX - Changing PercentSynced to CopyState in isSynched
+* Add basic workflow of attach/detach to devref
+* Change frozen error messages from \_LE to \_
+* Replication v2.1 (Cheesecake)
+* Change Fail to Failed in error messages
+* NetApp: Add Consistency Group support for E-Series
+* Return BadRequest for invalid Unicode names
+* Check for service existance in capabilities API
+* Enable all unit tests on Python 3.4
+* Adding general notes about rolling upgrades
+* Move deprecation release notes to correct section
+* Tests: Don't assert on LOG.warn
+* Return all target\_wwpns for FC storwize
+* Fix error message in cinder type-update
+* Fix NoneType error in service\_get\_all
+* Add os-brick rootwrap filter for privsep
+* LeftHand: Updating minimum client version
+* NetApp: Implement CGs for ONTAP Drivers
+* Fix HNAS iSCSI driver attachment
+* NetApp: Support iSCSI CHAP Uni-directional Auth
+* Avoid hardcoding value from oslo library
+* cinder-api-microversions code
+* Port netapp dataontap driver to Python 3
+* Scalable backup service - Liberty compatibility
+* Huawei: Log the IP when login fails
+* Huawei: Fix create volume with prefetch value error
+* Huawei: Don't fail when port group does not exist
+* Force target\_lun to be int type to make os-brick happy
+* Changed Nexenta default chunksize from 16k to 32k
+* Volume manage/unmanage support to ZFSSA drivers
+* Removed unreachable code
+* Disable multi-attach for RBD
+* Correct iscsi lun type
+* Fix invalid uuid warnings in object unit tests
+* Imported Translations from Zanata
+* Fixed help message for AllocatedCapacityWeigher
+* EMC VMAX - not cleaning up HW Resource WWPN initiators
+* Huawei: Fixed url range
+* Updated from global requirements
+* Test: use assert\_has\_calls() instead
+* Move anyjson to test-requirements
+* Huawei: Judgement failure when creating hypermetro
+* Remove useless get\_replication\_updates driver call
+* [LVM] Restore target config during ensure\_export
+* 3PAR get host by WWN now handles mixed cases
+* NetApp: E-Series remove snapshot limitations
+* Fix race condition in RemoteFS create\_snapshot\_online
+* Add SIGHUP handlers to reset RPC version pins
+* Handle OverQuota exception during volume transfer
+* Remove extra get\_active\_zoneset query from Brocade CLI
+* Tintri image cache cleanup
+* Huawei: Ensure the port is online
+* Rtstool sets wrong exception message on save
+* Test middleware test\_faults to Python 3
+* Split out NestedQuotas into a separate driver
+* Revert changes to use ostestr
+* doc: Fix wrong description about adding RESTful API
+* Propoerly call oslo's Service stop and wait
+* Remove unused kill method from Service
+* Wait for periodic tasks to stop on exit
+* Dell: Failed vol create could leave dead volumes
+* Roll back reservations quota in RPC if necessary
+* Scaling backup service
+* EMC ScaleIO - fix bug in extend volume
+* VMware: manage\_existing for VMDK driver
+* VMware: manage\_existing\_get\_size for VMDK driver
+* Delete unuseful code in Huawei driver
+* Cleanup unused conf variables
+* Port infortrend driver to Python 3
+* Disable Rally backup-related scenarios
+* Fix last Python 3 issues in zonemanager
+* Port hgst driver to Python 3
+* Port API v1 and v2 to Python 3
+* Port API contribs to Python 3
+* Port test\_emc\_vnx to Python 3
+* Fix service-list filter
+* Coho volume stats update
+* Sheepdog: Fix malformed image url format
+* Update quota when volume type renames
+* Add restore\_volume\_id in backup
+* Updated from global requirements
+* Support for consistency groups in ScaleIO driver
+* Use of metadata id instead of metadata name
+* Fix 'asert' typo in unit test
+* Fix dynamic import of CONF.volume\_api\_class
+* Filter & goodness functions in NetApp drivers
+* Manage/unmanage volume in ScaleIO driver
+* HNAS driver: Fix SSH and cluster\_admin\_ip0 bug
+* Remove duplicated code in volume manager and base driver
+* Don't use Mock.called\_once\_with that does not exist
+* EMC VMAX - necessary updates for CG changes
+* RBD: use versioned objects
+* Tests: Fix calls to non-existent assert methods
+* Updated from global requirements
+* Profiler: make it possible to run without loading osprofiler
+* Profiler: don't call trace\_cls if profiler is not enabled
+* Tests: Set volume listen port to test\_service\_listen\_port
+* Remove Cisco FC Zone Manager Driver
+* Add variable QoS to NetApp cDOT drivers
+* Move integrated tests to 'functional' directory
+* py3: Fix usage of JSON in API contrib
+* Port utils.safe\_minidom\_parse\_string() to Python 3
+* Include allocated quota value in the quota reserve
+* Log stack trace for middleware faults
+* hacking: Fix false positive in C302 check
+* Port backup drivers to Python 3
+* Storwize: Implement v2 replication
+* Volume create fails with FakeISCSIDriver
+* Adds support for configuring zoning in a virtual fabric
+* ScaleIO QoS Support
+* Zfssaiscsi driver should not use 'default' initiator group
+* Update db in CGSnapshot create
+* 3PAR: Create consistency group from source CG
+* Remove old client version checks from 3PAR driver
+* Improve logging to debug invalid "extra\_specs" entries
+* Huawei: Implement v2 replication (managed)
+* DRBD: Fix arguments for resize\_volume DBus API call
+* Port objects unit tests to Python 3
+* Updated from global requirements
+* VNX: Add 'None' check in parsing provider location
+* NexentaStor5 iSCSI driver unit tests
+* LeftHand: Implement un/manage snapshot support
+* Updated from global requirements
+* EMC VMAX - Method not being called for V3
+* Allow for eradicating Pure volumes on Cinder delete
+* HNAS driver: retry on Connection reset fix
+* Fix issue in hacking with underscore imports
+* DRBD: Compat for current DRBDmanage versions
+* Fix variable scope issue in try-except
+* Imported Translations from Zanata
+* Bootable filter for listening volumes from CLI
+* Clean uploading volume when c-vol restarts
+* mock time.sleep in Broadcom unit test
+* Don't create cgsnapshot if cg is empty
+* Added osprofiler headers to cors middleware
+* Imported Translations from Zanata
+* Fix the replication spelling in message
+* 3PAR fix driver to work with image cache
+* Updated from global requirements
+* Improve logging for volume detach
+* Remove useless unit tests mock in Huawei driver
+* Return updated volume type after updating
+* Remove 'external=True' in Huawei driver
+* Fix XtremIO multi cluster support
+* EMC VMAX - Fix for last volume in VMAX3 storage group
+* Filtering type extra-spec support to ZFSSA drivers
+* Zfssaiscsi driver should return target\_lun as int
+* Pin RPC and object version to lowest running
+* Report RPC and objects versions
+* Add missing RPC calls versions to rpcapi modules
+* Huawei: Balanced FC port selection when zoning
+* VNX: Replication V2 support(managed)
+* Adds HTTPS southbound connector for Brocade FC Zone Driver
+* Replication V2 for Pure Storage
+* Support ZeroMQ messaging driver in cinder
+* Remove redundant definition of 'deleted'
+* Fix update\_consistencygroup log info
+* Correct opt type for nexenta\_chunksize/blocksize
+* Huawei: Add manage/unmanage snapshot support
+* Remove deprecated options from NFS driver
+* Fixing HNAS XML parser
+* Replace exit() by sys.exit()
+* IBM XIV/DS8K: Implements Replication V2
+* Support cinder\_img\_volume\_type in image metadata
+* Adds friendly zone name support
+* LeftHand: Implement v2 replication (unmanaged)
+* EMC VMAX - VMAX driver failing to remove zones
+* Remove access\_mode 'rw' setting in drivers
+* Tests: Strengthen assertFalse assertions
+* Fix laggard cisco FC zone client unit tests
+* Fix xtremio slow unit tests
+* Fix sluggish rbd unit tests
+* Fix torpid coordinator unit tests
+* Rework Storwize/SVC protocol to fix add\_vdisk\_copy
+* NetApp ONTAP - Reapply API tracing
+* Run flake8 also on cinder/common
+* Replace assertEqual(\*, None) with assertIsNone in tests
+* Wrap the method to calculate virtual free capacity
+* Add pagination support to consistency group
+
+8.0.0.0b2
+---------
+
+* Fix NFS driver unit test docstring
+* Adding action to policy.json
+* fix NFS driver max\_over\_subscription\_ratio typo
+* Add pip-missing-reqs tox env
+* Add missing requirements
+* Added 'bootable volume' filter for non-admin user
+* Move wsgi to oslo\_service.wsgi
+* Set LVM driver default overprovisioning ratio to 1.0
+* Tegile tests: Change volume size to int
+* VMware: Fix release notes
+* FlashSystem reports error in \_find\_host\_exhaustive()
+* Huawei: Refactor driver for the second time
+* Add cinder backup driver for Google Cloud Storage
+* NexentaStor 5 iSCSI backend driver
+* NexentaStor 5 NFS backend driver
+* DRBD: Rename "dres" to avoid confusion with "res"
+* EMC VMAX - Incorrect SG selected on an VMAX3 attach
+* Activate sparse copy for Netapp
+* Add Fujitsu ETERNUS DX Volume Driver (FC part)
+* Imported Translations from Zanata
+* XtremIO: FC initialize connection failed
+* Updated from global requirements
+* Disallow transferring volume in consistency group
+* Reduce use of eval()
+* Remote unused iscsi\_targets table
+* ITRI DISCO cinder driver
+* NetApp eseries: report max\_over\_subscription\_ratio correctly
+* Python 3: Replace reduce and xrange with six.moves
+* Infrastructure to use the DRBD transport for NOVA
+* NetApp ONTAP: Fix extending volume beyond lun geometry
+* Refactor Windows drivers using os-win
+* Base iSCSI initiator validation
+* Fix ChunkedBackupDriver \_create\_container
+* XtremIO: Set the location of a CA certificate
+* Huawei: Add manage/unmanage volume support
+* Remove DB calls from Pure Volume Driver CG methods
+* Dell SC: Adding logging to httpclient
+* LeftHand: Implement v2 replication (managed)
+* Enable trim/discard in SolidFire's driver
+* API Middleware fault: Log exception type
+* Re-add Nexenta drivers
+* Remove invalid NetApp QoS keys
+* Fix thin provisioning flags in NetApp drivers
+* Return BadRequest for invalid Unicode names
+* Handling Invalid argument iflag=direct in dd
+* Execute mount.nfs check as root
+* Report discard support for Dell SC connections
+* Add ConsistencyGroupStatus enum field
+* 3PAR: Adding volume checks to manage snapshot API
+* Added Keystone and RequestID headers to CORS middleware
+* Allow host and instance\_uuid at attach
+* Trival: Remove 'MANIFEST.in'
+* Imported Translations from Zanata
+* Add finish\_volume\_migration to volume object
+* Fix tox -e fast8
+* Updated from global requirements
+* Removes the Violin 6000 FC and iSCSI drivers
+* Dell SC: Implements Replication V2
+* Storwize: Add force flag on vdisk mapping call
+* Storwize/SVC: Volume manage using source-name
+* Enable consisgroups in SolidFire driver
+* Replace deprecated library function os.popen() with subprocess
+* Constant defined for sqlAlchemy VARCHAR & INTEGER
+* Fix image volume creation error
+* Cleanup in backup reset status
+* NetApp FC drivers should not set 'rw' access mode
+* Change minimum 3PAR API version for replication
+* Optimize 3PAR array ID retrieval
+* Add metadata aliases to Volume object
+* Add pagination support to volume type
+* Re-enabled hacking checks for H105
+* Don’t log warnings for image cache when disabled
+* Fix grammatical mistake in defining articles
+* Scality SOFS: don't always read /proc/mounts twice
+* Add BackupStatus enum field
+* Updated from global requirements
+* Fix issue with flake8 check and full paths
+* Fix race conditions in migration 061
+* Replace use of mox with mock in test\_nfs
+* Updated "deleted" column of volume\_type\_access
+* Add Fujitsu ETERNUS DX Volume Driver (again)
+* Add backref relationships to ConsistencyGroup obj
+* Misspelling in message
+* Fix some warnings about 'unused variable' for XIO
+* Updates consistency group for ibm svc driver
+* Add volume driver for Tegile IntelliFlash array
+* Fix to allow RBD delete an unprotected snapshot
+* Remove the deprecated ibmnas driver
+* Wrong usage of "a"
+* VMware: optimize in get\_cluster\_refs
+* Rebrand HP XP driver to now be HPE
+* Fix creating volume by snapshot for GPFS driver
+* Rename Huawei drivers
+* Check min config requirements for rbd driver
+* Remove API races from delete methods
+* Remove API races from attach and detach methods
+* Quota API is now compatible with keystone API v2
+* Add pagination support to Qos specs
+* Remove name\_id when creating volume with cache enabled
+* Imported Translations from Zanata
+* Updated from global requirements
+* Enhance the stats reported from the Pure Volume Drivers
+* Allow replicated volumes to be recoverable
+* Imported Translations from Zanata
+* Retyping volume got error under max vol limit
+* Add config option to enable reporting discard
+* Storwize: Split up \_\_init\_\_ into separate files
+* Fix volume upload failure with glance\_api\_version=2
+* EMC VMAX - Extend Volume for VMAX3
+* XtremIO add support for create CG from CG src
+* Fix bugs caused by porting to python3
+* Imported Translations from Zanata
+* Disable capabilities based on 3PAR licenses
+* Add empty initialize\_connection method to PureBaseVolumeDriver
+* Fix python 3.x import issues with pure.py
+* Override osapi\_volume\_listen\_port for test\_workers
+* Updated from global requirements
+* replace deprecated oslo\_messaging \_impl\_messaging
+* Remove downgrade migrations
+* Fix delete\_snapshot error case in Pure driver
+* 3PAR: Implement un/manage snapshot support
+* Error handling for invalid SLO/Workload combo
+* 3PAR: Implement v2 replication (unmanaged)
+* Add serial number to eseries ASUP payload
+* XtremIO: fix generic glance cache with XtremIO
+* VMware: Add support for VVOL datastores
+* Tooz locks
+* Small refactoring in test\_admin\_actions.py
+* Imported Translations from Zanata
+* Making NFS \_find\_share efficient
+* Change the format of some inconsistent docstring
+* Preserve request id in Cinder logs
+* Add volume\_extensions:quotas:delete to policy.json
+* Pass volume\_id in request\_spec for manage\_existing
+* VMware: Fix volume copy across vCenter datacenters
+* Imported Translations from Zanata
+* Modify VO so that obj.get always defaults to None
+* Replace use of mox with mock in test\_quotas
+* Replace use of mox with mock in test\_rbd
+* Skip check whether volume is local if it's None
+* Imported Translations from Zanata
+* Implement refresh() for cinder objects
+* EMC VMAX - get\_short\_host\_name not called in find\_device\_number
+* Move retype quota checks to API
+* Implement snapshots-related features for Block Device Driver
+* Refactor cinder.utils.is\_valid\_boolstr
+* Add synchronization in Block Device driver
+* Recalculate allocated value of parent project
+* Updated from global requirements
+* Volume migration: add 'name\_id' as valid skippable field
+* Fix invalid cache image-volume creation
+* Imported Translations from Zanata
+* Remove eventlet WSGI functionality
+* Deprecated tox -downloadcache option removed
+* Fix for showing default quotas to non-admin user
+* VNX: Fix failure in SnapCopy feature
+* Use wild card for passing env variable
+* Recognize extra fields in CinderObjectDictCompat
+* Imported Translations from Zanata
+* VNX: Fix issue in deleting cg/cgsnapshot
+* Add validation for volume\_type of volume object
+* Update Pure REST API supported version numbers in Pure driver
+* Updated from global requirements
+* Retype functionality in Tintri driver
+* Fix non-migration swap with error
+* Replace use of mox with mock in test\_solidfire
+* Check context before returning cached value
+* 3PAR: Implement v2 replication (managed)
+* Use Cinder API v2 for Rally scenarios
+* Check backup service before backup delete
+* Python 3: fix a lot of tests
+* EMC VMAX - Fix for randomly selecting a portgroup
+* Volume driver for Coho Data storage solutions
+* XtremIO: fix iscsi chap discovery bug
+* XtremIO: fix missing multiattach flag
+* Fix StrOpts with integer defaults
+* Dynamically Pull Out Option Sections
+* Use the catalog to retrieve glance\_api\_servers
+* Address potential races in SolidFire VAG
+* Update migrate\_volume API to use versionedobjects
+* Storwize: add config option to control flash copy rate
+* Remove version per M-1 release instructions
+* Use proper config option to connect to keystone
+* Robustify writing iscsi target persistence file
+
+8.0.0.0b1
+---------
+
+* Adding devref about genconfig
+* LIO: Handle initiator IQNs as case insensitive
+* Fix dictionary key error
+* VMware: Replace mox with mock
+* VMware: Unit test refactoring (image to vol - 2/2)
+* VMware: Unit test refactoring (image to vol - 1/2)
+* Imported Translations from Zanata
+* Remove deprecated LVM ISCSI and ISER Drivers
+* Delete unused codes in rbd.retype
+* NetApp: E-Series fix JSONDecodeError on first add
+* Add Mitaka-1 release notes
+* NetApp: Refactor E-Series tests
+* xio: fix regression in authentication
+* Add some missing fields to Volume object
+* Imported Translations from Zanata
+* Add retype in lvm driver
+* Updated violin driver check for volume objects
+* Take into consideration races in XtremIOClient3
+* Optimize "open" method with context manager
+* Updated from global requirements
+* Sheepdog: Optimization of error handling
+* Fix the bug of can't get the desired image info
+* Cleanup orphaned code in sqlalchemy API
+* Cleanup orphaned code from image and manager
+* Cleanup orphaned code from brick LVM
+* Cleanup orphaned code from ceph backup driver
+* Force releasenotes warnings to be treated as errors
+* Remove db access in VNX driver
+* Fix quotas issue during volume transfer
+* Declare multiattach is True in Dell Eqlx driver
+* Nexenta Edge iSCSI backend driver
+* RBD: Make snapshot\_delete more robust
+* Hacking Checks for assertTrue/IsNone()
+* Remove netaddr useless requirement
+* Improve metadata update operations
+* Add atomic conditional updates to objects
+* Revert "Add Scality SRB driver"
+* VMware: Validate extra spec opt vmware:clone\_type
+* Update list\_replication\_targets
+* Port zonemanager to Python 3
+* Port key manager to Python 3
+* Move oslo-incubator's scheduler module to cinder
+* Remove stubs and add resource cleanup
+* VMware: Skip unsupported datastore types
+* Port IBM storewize\_svc driver to Python 3
+* Declare multiattach is True in RBD driver
+* XtremIO fix attach readonly bug
+* CG API should return volume type IDs
+* EMC VMAX - Change naming convention for MV and SG for FAST
+* Fix the bug of OSError when convert image
+* Don't build two tox envs for pep8(-constraints)
+* Add guidelines for release notes to devref
+* Imported Translations from Zanata
+* Imported Translations from Zanata
+* Updated from global requirements
+* Eager load columns in volume\_get\_active\_by\_window
+* Backup snapshots
+* LeftHand: Remove self.db assignment
+* Deprecate \*\_multipath\_enabled flag for IBM drivers
+* Fix debug output for cinder-volume-usage-audit
+* Add check\_uptodate.sh --checkopts to "pep8"
+* Move get\_by\_id to CinderObject
+* Imported Translations from Zanata
+* fast8: Skip git rm'd files
+* Manage existing: fix volume object saving
+* Fix swap\_volume for case without migration
+* Remove .mailmap file
+* Remove db access from 3PAR and LH cg functions
+* Additional VAG support for SolidFire
+* Fix InstanceLocalityFilter scheduler filter
+* Add a FakeGateDriver
+* Fix metadata retrieval in GPFS driver
+* Imported Translations from Zanata
+* VNX: Fix metadata get overriden issue
+* Added VAG support to SolidFire
+* Refactor HP LeftHand driver to now be HPE
+* Remove db access from XIV/DS8K CG functions
+* Do not use api-paste.ini osprofiler options
+* Remove duplicate keys from dictionary
+* Bad exception clauses order
+* Imported Translations from Zanata
+* Check specific driver enabled in create\_backup
+* get\_all\_snapshots: Fix log message typo
+* Updated from global requirements
+* ScaleIO extend volume round up capacity
+* Port HP 3PAR driver to Python 3
+* Modify test\_hpe3par to support random hash
+* Imported Translations from Zanata
+* Fix ScaleIO driver provisioning key
+* Imported Translations from Zanata
+* Remove the HP CLIQ proxy driver
+* Retry on database deadlock on service\_update method
+* Downstream Fix for Genconfig
+* Correct assertDictMatch argument order
+* 3PAR Fix find\_existing\_vluns
+* Port xio driver to Python 3
+* Remove kombu as a dependency for Cinder
+* Port EMC VMAX to Python 3
+* Port EMC VNX CLI to Python 3
+* Sheepdog: Fix a problem about multi backend
+* Imported Translations from Zanata
+* Update compression license check
+* py3: Fix error handling in prophetstor driver
+* Updated from global requirements
+* Refactor HP 3PAR drivers to now be HPE
+* add "unreleased" release notes page
+* Add os-win to requirements.txt
+* Update extend\_volume API to use versionedobjects
+* Update retype API to use versionedobjects
+* Update get/delete\_volume API to use versionedobjects
+* Update create\_volume API to use versionedobjects
+* Test for object version hash changes
+* Fix cinder objects unit test registration
+* CG driver function should not access db
+* Add test for snapshot filtering by project id
+* Imported Translations from Zanata
+* Use oslo\_config new type PortOpt for port options
+* Update CONTRIBUTING.md to CONTRIBUTING.rst
+* CG creation should be scheduled on backend level
+* Removal of deprecated NPIV option in Storwize
+* Fix ZFSSA drivers' local cache bugs
+* OpenStack typo
+* Change nfs to NFS in the help strings of nfs.py
+* Port zfssa driver to Python 3
+* Port vzstorage to Python 3
+* Port cinder.utils.monkey\_patch() to Python 3
+* XtremIO fix create CG from src flow
+* Don't use default=None for config options
+* Imported Translations from Zanata
+* 3PAR drivers volume size conversion is incorrect
+* Port vmware datastore to Python 3
+* Use Service object instead of DB API directly
+* Docstring fix in scheduler-stats
+* Add LC\_ALL=C to lvcreate, lvextend and pvresize
+* Port cinder.hacking to Python 3
+* Port test\_tintri to Python 3
+* Add reno for release notes management
+* Imported Translations from Zanata
+* Fix failure of unit test TestCinderAllCmd
+* Execute mount.nfs check with absolute path
+* Imported Translations from Zanata
+* Update minimum tox version to 1.8
+* Update cinder-manage man to match current options
+* Replace warnings.warn in sqlalchemy-api
+* Replace warnings.warn in glusterfs
+* Using extra-specs in cloned vols for Nimble driver
+* SheepdogDriver: Improve get\_volume\_stats operation
+* Add retype logic in manage\_existing for VNX
+* Adds CORS support to Cinder
+* Fix calling delete\_zones method with a wrong argument
+* Return volume\_type extra specs based on policy
+* Revert "Handle correct exception raised by python-novaclient"
+* NetApp: Fix issue with updating E-Series password
+* NetApp: Fix issue with E-Series volume expand
+* Update register\_opts hacking check to allow tuples
+* Updated from global requirements
+* optimize the copy\_image\_to\_volume method of sheepdogdriver
+* Fix UsedLimitsController's authorizer to soft
+* Imported Translations from Zanata
+* Handle correct exception raised by python-novaclient
+* lvconvert missing from cinder volume.filters
+* Support insecure NAS security options in Quobyte
+* Brocade driver add\_zone optimization
+* Imported Translations from Zanata
+* Add missing cgsnapshot field to Snapshot object
+* Eager load snapshot\_metadata in \*snapshot\_get\_all
+* Case sensitivity problem in cinder scheduler
+* Add protocol to help of glance\_api\_servers option
+* SMBFS: Fix retrieving total allocated size
+* Make relationships in objects consistent
+* Imported Translations from Zanata
+* Remove the jointly loaded model in finish\_volume\_migration
+* Update docs to generate Guru Meditation Report
+* Add qos\_specs\_id to volume type show
+* Fix NoneType Attribute error
+* Support initialization state in Backup Manager
+* Imported Translations from Zanata
+* Add -constraints for CI jobs
+* Fix typos about 'target\_discovered'
+* NetApp: Cleanup if E-Series volume create fails
+* VMware: Unit test refactoring
+* Cleanup for cinder tests with CGSnapshot
+* Imported Translations from Zanata
+* VMware: Enforce min vCenter version
+* Add hypermetro support for Huawei driver
+* Updated from global requirements
+* devref doc: assorted fixes in "Unit Tests"
+* LIO: Let delete\_initiator succeed if iqn not found
+* CGSnapshot Object
+* Updates in consistency\_group in xiv/ds8k driver
+* Retype support for CloudByte iSCSI cinder driver
+* Add retries for Cisco FCZM client CLI \_cfg\_save
+* Updated from global requirements
+* Remove unused gettextutils from oslo-incubator
+* Wrong usage of "an" in the mesages:
+* NetApp: E-Series fix deletion of missing volume
+* Wrong usage of "an" in the mesages: an service
+* VMware: Relocate volume only during no disk space
+* Port Windows drivers to Python 3
+* Use project id from volume when retyping volumes
+* Fix typo in LIO terminate\_connection error msg
+* Update the devref for volume migration
+* Implement update\_migrated\_volume for NFS driver
+* Only use LOG.exception in exception handler
+* Port API admin action tests to Python 3
+* Port API types extra specs to Python 3
+* Port API to Python 3
+* Mark XML API as deprecated in Mitaka
+* windows: don't use LOG.exception if not logging an exception
+* Improve performance listing detail for volumes
+* Move CloneableVD to common functions
+* Fix updating only volume type is\_public
+* encryption\_api\_url requires a version
+* Cleanup/move code in Storwize Driver
+* Port WSGI tests to Python 3
+* Fix method VolumeTypeList.get\_all
+* Use lvm\_conf\_file directory for LVM\_SYSTEM\_DIR value
+
+7.0.0
+-----
+
+* Squashed commit of WebOb 1.5 and oslo.db fixes
+* Change default Exception code to 500
+* Dell SC: Disable REST verify warnings
+* Update config format for replication\_devices
+* Fix log formatting for rbd driver
+* Fix Status-Line in HTTP response
+* Huawei driver handle volume exists error
+* Updated from global requirements
+* Tox fast8: use pep8 env dir
+* Move ssh\_utils tests to test\_ssh\_utils
+* Volume extend error does not catch exception
+* Fix test\_misc for WebOb 1.5
+* ScaleIO driver: update\_migrated\_volume
+* Fix error string format for replication API calls
+* Port IBM flashsystem to Python 3
+* Port ceph driver to Python 3
+* Provide better debug log when 'cinder manage' fails
+* Remove references to Swift in chunked driver
+* Add insecure option for swift backup
+* ScaleIO: Fix protection\_domain\_id log message at init
+* Port test\_srb to Python 3
+* Add fast format option for thick volume creation
+* Imported Translations from Zanata
+* Retype enhancement for EMC VNX cinder driver
+* Updated from global requirements
+* Verify volume is replication capable
+* Add device identifier to replication device
+* Port violin driver to Python 3
+* Port EMC scaleio to Python 3
+* Remove extra register\_opts() calls in netapp eseries
+* Add multi-initiator extra-spec for Nimble driver
+* Fix SolidFire target composition
+* Port targets test\_iet\_driver to Python 3
+* Port image cache to Python 3
+* py3: Run unit tests with ostestr on Python 3.4
+* Add testresources and testscenarios used by oslo.db fixture
+* Clone cg support in VNX driver
+* Test\_backup\_swift: Don't leak notifications
+* test\_backup\_nfs: Set volume id per test
+* test\_backup\_swift: Set volume id per test
+* Add backup\_swift\_auth\_url to swift backup driver
+* Dell Eqlx: Support over subscription in thin provisioning
+* Hacking check for opt name registration
+* Add ability to set prefix in SolidFire Volume name
+* Updated from global requirements
+* Fix broken format string in vol mgr log
+* Detach volume on device validation failure
+* Convert  Retry-After header parameter value to string
+* Fix capacity report error in Huawei driver
+* emc vmax driver: use integer division for Python 3
+* VMAX Target iSCSI IP Address
+* Updated from global requirements
+* Delete a temporary volume in DB with admin context
+* Fix update quota of subprojects
+* Port test\_quobyte to Python 3
+* Remove unused 'deprecated' option from auth\_strategy opt
+
+7.0.0.0rc2
+----------
+
+* Fix VMAX live migration problem
+* Imported Translations from Zanata
+* Port netapp SSC Cmode to Python 3
+* Port test\_netapp to Python 3
+* VMAX Truncate Storage Group Name
+* HNAS iSCSI manage does not work with spaces
+* Port scheduler host manager to Python 3
+* Fix various Python 3 issues
+* Fix volume throttling to Python 3
+* Ensure replication functions check driver status
+* Fix enable/disable\_replication raise InvalidVolume
+* Tests: print fake\_notifier queue upon mismatch
+* Cleanup orphaned code from cinder root directory
+* Image cache tests: use fake\_notifier
+* Implement extend\_volume method to Block Device driver
+* Small optimization in Block Device driver
+* DRBD: new option "drbdmanage\_devs\_on\_controller"
+* Obtain target authentication from database same as LIO target
+* Dell SC: cgsnapshot-delete doesn't actually delete
+* LVM: Make sparse\_copy\_volume private, use for capabilities
+* Dell SC: cgsnapshot-delete doesn't actually delete
+* Fix typo in cinder-config-generator.conf
+* Port test\_volume to Python 3
+* Fix unreachable code pylint issues
+* Huawei driver add check before use a QoS
+* Report \*real\* free capacity in Huawei driver
+* Fix update Huawei driver issue
+* Fix Python 3 issues in wsgi
+* py3: Port pure driver test to Python 3
+* GlusterFS: extend volume to the right path
+* Use pbr wsgi\_scripts to install Cinder WSGI entry point
+* Report \*real\* free capacity in Huawei driver
+* Imported Translations from Zanata
+* Fix Bad indentation pylint issues
+* Show image metadata
+* XtremIO fix remapping bug
+* Revert use of netapp\_lib from NetApp Drivers
+* Fix volume related operation in CloudByte driver
+* Add placholder for migration backports in Liberty
+* Add placholder for migration backports in Liberty
+* Revert use of netapp\_lib from NetApp Drivers
+* Remove the destination volume check in delete\_volume
+* Huawei driver add check before use a QoS
+* Fix VMAX live migration problem
+* Cleanup of Translations
+* Missing configuration opts from cinder.sample.conf
+* Use function capsulation in Huawei driver
+
+7.0.0.0rc1
+----------
+
+* Open Mitaka development
+* Create volume in cg enhancement in VNX driver
+* Remove duplicate keys from dictionary
+* Fix URL format in Huawei driver
+* Setup LVM\_SYSTEM\_DIR earlier in LVM.\_\_init()
+* Add "fast8" tox env
+* Allow c-vol backends to start when some backends fail to load
+* Fix use of wrong storage pools for NetApp Drivers
+* VMware: Remove VMDK driver for ESX server
+* Use of ast for integers doesn't changes type
+* Make rpc\_client method private for VolumeCommands
+* Ignore Forbidden error on quotas-get for nested projects
+* Change ignore-errors to ignore\_errors
+* NetApp volume/snapshot delete performance fix
+* Replace soft\_delete in volume\_type\_access\_remove
+* Fix way of getting LUN id in Huawei driver
+* Fixing create CG from Cgsnapshot bug in VNX driver
+* Fix delete quota of subprojects
+* Dynamically create cinder.conf.sample
+* Updated from global requirements
+* Fix MITM vulnerability for Brocade FC SAN lookup
+* Imported Translations from Zanata
+* Fix cinder-all binary
+* NetApp: Fix volume extend with E-Series
+* Fix netapp\_enable\_multiattach default for E-Series
+* Check for None on service's updated\_at
+* Fix issue of volume after host-assisted migration
+* Attaching enhancement for EMC VNX driver
+* Tests: Split VolumeTestCase into separate classes
+* Local img-cache files ignored for image transfers
+* Snapmirror targets should not be reported as pools
+* Change check method for 'all\_tenants'
+* Create a page of drivers with stevedore.sphinxext
+* Enable certificate verification during image copy
+* Fix NetApp clone from glance failure
+* Storwize: Fix format string
+* Fix usage of novaclient
+* Check for empty attributes on SF volume
+* Fix volume lookups in SolidFire template caching
+* Don't rely on provider\_id for resource deletion
+* Fix Pure get pgroup volume snapshot name
+* Dothill fix options access
+* HPMSA fix access to common options
+* Lenovo driver fix access to common opts
+* Fixed missing log variable types
+* VMware: Fix invalid product name
+* Retrieve volume in update\_migrated\_volume
+* Swap the decorator order for PureFCDriver methods
+* Add ScaleIO Cinder driver commands
+* SolidFire provider\_id for snapshots on init
+* LeftHand Add update\_migrated\_volume to drivers
+* Huawei: fix multi REST-URLs bug
+* Improve coverage for snapshot\_get\_by\_host
+* LVM: add the exception handling to volume copy
+* Fix NetApp loop in clone of NFS backed images
+* Hacking log format arg check
+* backup init\_host cleanup exception handling
+* Making opt names consistent
+* Fix QoS keys not being available to scheduler
+* Add ConsistencyGroup object entries to linstack.py
+* Pass in snapshot refs for host on provider\_update
+* Filter hosts with pool in snapshot\_get\_by\_host
+* Fix typos in comments
+* Filter scheduler: Fix KeyError on invalid create request
+* Updated from global requirements
+* Return a tuple from SolidFire update\_provider\_info
+* Add unmanage default implementation to VolumeDriver
+* Correctly report multiattach in Pure drivers
+* Add manage\_existing and unmanage to BaseVD
+* Add migrate\_volume to BaseVD
+* Update update\_migrated\_volume in VNX driver
+* 3PAR Disable generic image volume cache
+* Add updated\_at into response of listing detail
+* Add os-brick's scsi\_id command to Cinder rootwrap
+* Fix order of arguments in assertEqual
+* Updated from global requirements
+* Error message in update\_migrated\_volume was incorrect
+* Remove empty rules from policies for API access
+* Fix HDS HNAS driver logging password as plain text
+* Add mechanism to update snapshot provider\_id
+* VMware: Remove global patching of open
+* VMware: Skip ESX hosts in maintenance mode
+* 3PAR Add update\_migrated\_volume to drivers
+* Updated from global requirements
+* Switch SVC driver to use lsportfc to determine FC target WWPNS
+* Use consolidated update for failover\_replication
+* VMware: Fix exception messages
+* Adds allow\_availability\_zone\_fallback option to Cinder
+* NetApp E-Series over-subscription support
+* ZFSSA driver to return project 'available' space
+
+7.0.0.0b3
+---------
+
+* Get full volume model in Replication manager API’s
+* Fix problem of efficient volume copy for migration
+* Generic image-volume cache
+* Implement thin provisioning support for E-Series
+* Remove useless response checks in SolidFire driver
+* Sheepdog: Improve snapshot and clone operation
+* Fix the virtual port support in VNX driver
+* DotHill driver fix create\_cloned\_volume parent id
+* 3PAR Fix create\_cloned\_volume source volume id
+* Cloudbyte fix create\_cloned\_volume parent id
+* Scheduler-based over-subscription for NFS drivers
+* ScaleIO driver should use os-brick connector
+* Add instructions on how to deploy API under Apache
+* Sync volume versionedobject to ORM
+* Check before add lun to QoS in Huawei driver
+* Fix backup metadata import missing fields
+* Remove the unnecassary volume\_api.get(context, volume\_id)
+* Port image\_utils to Python 3
+* Port volume transfer to Python 3
+* Service object
+* Allow specified backend capabilities to be retrieved
+* Remove deprecated options
+* Add cinder.conf.sample to gitignore
+* Add delete\_snapshot and update\_snapshot rules
+* Handle KeyManager exception when deleting a volume
+* Fix a merge problem in VMAX driver
+* Don't require OpenSSL for unit tests
+* Add pagination to backups
+* Enhance FC zone support for Huawei driver
+* Add support for file I/O volume migration
+* Add debug logging before attaching volume in driver
+* Detect addition of executable files
+* Remove executable bits on files
+* NetApp DOT block driver over-subscription support
+* Cleanup for SnapshotObject
+* Add additional SSC extra specs to E-Series driver
+* Minor optimization
+* Adding delete-wait-loop for CloudByte Volumes
+* get\_replication\_updates call to driver is wrong
+* Earlier authority check for create volume API
+* Fix url in API response to get original
+* Efficient volume copy for generic volume migration
+* Volume status management during migration
+* Clean up line continuation in Storwize driver
+* LeftHand: Adding Consistency Group Support
+* 3PAR update driver to store stats
+* Remove driver.set\_execute()
+* Skip intermittent VMDK tests
+* Rework Scality SOFS driver to use RemoteFS class
+* Adds framework for get\_capabilities() feature
+* Implement AutoSupport for NetApp E-Series driver
+* Add retries to delete a volume in the RBD driver
+* Add support for volume groups and netapp\_raid\_type
+* Dell SC: init\_volume stale volume info fix
+* Validate filters in snapshot\*, backup\* in db.api
+* Fix volume copy for 'virtual' volumes in DotHill
+* Imported Translations from Transifex
+* Use version convert methods from oslo.utils
+* Implement manage/unmanage snapshot in Pure drivers
+* Reduce runtime of E-Series iSCSI tests
+* Cinder Nested Quota Driver
+* Add manage/unmanage volume support for Nimble
+* Python 3 incompatible expression fix
+* Local cache feature of Oracle ZFSSA drivers
+* Replace urllib.unquote with urllib.parse.unquote
+* Remove unused dependency discover
+* Update volume status AFTER terminate\_connection is done
+* Add unit test for backup get\_all
+* Incremental backup improvements for L
+* Sheepdog: improve create and delete operation
+* Implement function to manage/unmanage snapshots
+* Sheepdog: Add class for dog command executor
+* Dont eager load volume type specs on volume list
+* Filter out extra-specs from type get for non-admin
+* Prevent that all backup objects are deleted
+* Add pagination to snapshots
+* Parameter osapi\_max\_limit is always used by default
+* Update NetApp Drivers to use netapp\_lib
+* Extend unit tests for backup get\_all
+* Fix nimble storage volume stats reporting
+* TemporaryImages to inspect image before conversion
+* Efficient image transfer for Glance cinder store
+* adds user\_id to check\_is\_admin
+* Fix backup list all\_tenants=0 filtering for admin
+* Add Cinder API wsgi application
+* Add consistency group tests to test\_volume\_rpcapi
+* Cinder replication V2
+* force\_detach terminate\_connection needs connector
+* Assisted volume migration for Oracle ZFSSA drivers
+* Add https options and minor code changes
+* Fix bad except clauses order
+* Add volume retype support for Huawei driver
+* Fix URLs to admin-guide-cloud
+* Nested Quota Driver: Get Project Hierarchy
+* Check sio\_storage\_pools in check\_for\_setup\_error
+* Fix description for "Barbarism of editting a file"
+* Dell SC: Added logging for the find\_wwns functions
+* Add missing space to logged error in create volume
+* Cleaning up CONF.register\_opts() in compute/\_\_init\_\_.py
+* Update provider\_id column on SolidFire init
+* Add ability to update provider\_id during init
+* Fix \_LI() to \_LW() in LOG.warning message
+* Remove the method delete\_volume\_admin\_metadata
+* Support efficient non-disruptive volume backup in VNX
+* Validate value when user update quota
+* Add SolidFire svip to config options
+* Return multiple iSCSI portals in VNX Cinder driver
+* Avoid returning volume metadata in DotHill driver
+* Small cleanups in BaseVD/VolumeDriver
+* Port 3PAR drivers to use ABCMeta driver model
+* Updated from global requirements
+* Switch to the oslo\_utils.fileutils
+* Parse out SolidFire account from api response
+* Dell SC: Better exception handling in init\_conn
+* Port test\_nfs to Python 3
+* Corrects the order of AssertEquals params in Quobyte tests
+* Adds the random option to cinder retry function
+* Extra specs may not be in volume types
+* VMware: Fix re-attach volume error for VC 5.1
+* Remove duplicate keys from dictionary
+* LeftHand driver is ignoring reserved\_percentage
+* Update devref unit tests doc
+* Tests: Fix zfssa TestRestClientURL.test\_request
+* Test whether sample config generation works
+* Revert "mark oslo.vmware as optional dependency"
+* Register the volume\_opts config options in remotefs.py
+* Create CG needs extra specs
+* Configure space reservation on NetApp Data ONTAP
+* Dell SC: Fix error causing missed log message
+* Rename free\_virtual in capacity filter
+* Make migration's volume source deletion async
+* Add the ability to update type public status
+* Adds manage/unmanage methods for HNAS drivers
+* Update deprecated version of novaclient
+* Add version columns to services table
+* 3PAR: Adding Consistency Group Support
+* Remove unused function volume\_type\_encryption\_get
+* Refactor to remove duplicate code
+* Correct comment to be consistent with code
+* Allow 0 length name
+* Add volume migration support for Huawei driver
+* Cleanup for cinder tests with ConsistencyGroups
+* VMware: Change inventory folder hierarchy
+* Adapt SnapshotController to view builder
+* Add backup/restore methods to Sheepdog driver
+* Use min and max on IntOpt option types
+* Over subscription for HP 3PAR drivers
+* Allow CG without snapshot to be deleted
+* Tintri snapshot id
+* Add volume type support to Datera
+* Fix Pure create volume from cgsnapshot
+* Implement Clone CG in Pure Volume Drivers
+* Dell Eqlx: Use generic option ssh\_timeout
+* Make X-IO volume driver wait for delete volume to complete
+* Reduced file size to prevent timeout
+* Update SolidFire driver to pass newer flake8
+* 3PAR: Adding performance metrics to volume status
+* Don't use context.elevated to get volume
+* Enable cinder-manage to remove services
+* VMware: Bump driver version
+* Fix backup init\_host volume cleanup
+* VMware: Deprecate vCenter version less than 5.1
+* Updated from global requirements
+* Small clean up in volume object
+* Move import and export backup metadata to object
+* On Volume list only retrieve needed data from DB
+* Return volume name from backup\_restore
+* Switch Pure volume drivers to use Snapshot Objects
+* Don't return Exception when volume is detached
+* Use Requests HTTP library and URL safe names
+* Remove RetypeVD class, fix NFS driver retype
+* Fix Python 3 issues in Windows tests
+* Add objects.register\_all() to cinder-all command
+* GPFS volume encryption-at-rest support
+* VMware: Set virtual disk UUID to volume ID
+* Add oslo.vmware into test-requirements
+* Add multipath support to 3PAR iSCSI driver
+* Prevent volume already in CG to be added to another
+* LVM Thin Provisioning auto-detect
+* Fix HNAS iSCSI 32 targets limitation error
+* Remove unused fake objects in vmdk test module
+* VMware: Add volume ID in vCenter's volume config
+* Enhance PureISCSIDriver multipath support
+* Add unit test cases for the capacity scheduler
+* Fix argument order for assertEqual in tests
+* Fix order of parms in assertEqual for scheduler ut
+* VNX driver needs extra params for create cg from src
+* Prevent creating encrypted volume with image
+* EMC VMAX Create CG from CG Snapshot
+* mark oslo.vmware as optional dependency
+* ConsistencyGroup Object
+* Validate string, integer limit for input parameter
+* Validate name and description string
+* Handle missing temp volume and snapshot during cleanup
+* Updated from global requirements
+* Validate 'is\_public' when creating volume type
+* Remove StorPool Driver
+* Ignore InsecureReq warning in SolidFire Driver
+* Attach snapshot - driver only
+* Remove bad tests for the VMAX driver
+* Update authorization actions for services API
+* Fix missing parameters in driver CG interface
+* Remove incorrect URLs from jenkins.rst
+* Fix list comparison for empty list
+* Snap copy feature for EMC VNX Cinder driver
+* Tests: Fix os.path.exists mock (emc\_vnxdirect)
+* Add connector object to create\_export
+* Correct usage of assertEqual for boolean values
+* Remove unit test migration logging
+* Add support '--all-tenants' for cinder backup-list
+* Corrected order of parameters in docstring
+* Fix wrong exception usage in cinder exception classes
+* Fix RestURL to storage backend in Huawei driver
+* Sync scheduler module from oslo-incubator
+* VNX driver needs to return snapshot objects
+* Revert "Revert First version of Cinder driver for Quobyte"
+* Enhance unit tests for zfssa drivers
+* VMware: Remove unused constants
+* Fix volume limit exceeded exception
+* Refactor api.v2.volumes unit tests
+* Dell SC: Add check of current value on retype
+* Update snap-quota to unlimited in Nimble driver
+* Add more Rally scenarios to run
+* Updated from global requirements
+* Fix PEP476 & format message of Oracle ZFSSA drivers
+* Add SmartX support for Huawei driver
+* Enhance deletion efficiency when backup init host
+* Fix order of arguments in assertEqual
+* Add multiple pools support to VMAX driver
+* Fix status comparison for attached volume backup
+* Updated from global requirements
+* NetApp SSC job will be run periodically
+* RBD: use user-configured value for chunk size
+* Over subscription for HP LeftHand iSCSI driver
+* Use prefix for SolidFire template account
+* Fix multi-line docstrings to meet hacking rules
+* sqlalchemy exception kills FixedIntervalLoopingCall thread
+* VMware: Fix protocol in backend stats
+* Fix error message in cinder/api/v2/volumes.py
+* Fix concurrent attaches on HNAS iSCSI driver
+* GlusterFS: Using 'fallocate' instead of 'dd'
+* Fixing notify message of manage\_existing flow
+* Clone CG
+* Fix get default quota values for subprojects
+* Add deactivate step to extend\_lv
+* Fix exception on uploading a volume to image with glance v2 API
+* Set VERSION on the Nimble driver
+
+7.0.0.0b2
+---------
+
+* Log which service is down
+* Move update\_migrated\_volume() to BaseVD
+* GlusterFS backup driver
+* Posix backup driver
+* Add mock cases for IBM FlashSystem
+* Add discard to connection properties
+* Remove deprecated config options for Liberty
+* RBD: use user-configured value for max\_clone\_depth
+* Updated from global requirements
+* Fix lvm manage existing volume
+* Add entry create and cast tasks to manage workflow
+* Fix cleanup\_temp\_volume\_snapshots for missing vol
+* Remove unused context parameter
+* Adding NFS support to the GPFS Driver
+* Remove deprecated SimpleScheduler
+* Fix doc string definitions
+* Port StorwizeSVCDriver to use ABCMeta driver model
+* Add extra spec capability for Nimble Cinder Driver
+* XtremIO support for iscsi discovery auth
+* Add bandit for security static analysis testing
+* typos(?) in create\_snapshots\_in\_db
+* Add multiple pools support for Huawei driver
+* Port XIVDS8K Driver to use ABCMeta driver model
+* Fix Python 3 issues in Hitachi HNAS tests
+* Port remotefs driver to Python 3
+* Port IBM driver to Python 3
+* Clean up volume\_types logging
+* NetApp ESeries: fix delete of non-existent volume
+* Refactoring of manager's create\_volume flow
+* Remove unused arguments from c-vol's create\_volume
+* Updated from global requirements
+* Add I/T mapping check for IBM FlashSystem
+* Remove simple scheduler which is deprecated since Juno
+* LVM: Support efficient data copy for LVM driver
+* Implement retype for Pure drivers
+* Dell SC: Add support for driver retype
+* EMC VMAX Modify CG
+* XtremIO volume driver consistency group support
+* Add Cinder internal tenant support
+* VMware:Replace vCenter calls with oslo.vmware calls
+* Rename filename from il8n.rst to i18n.rst
+* Non-disruptive backup
+* DRBD: Rename a constant to a better name
+* Remove resource lock operation for HBSD
+* Dell SC: Fix legacy bug, init\_conn bug and REST API bug
+* Dell SC: Fix Consistency Group issues
+* Add drivers list generator
+* Fix 033 add encryption unique key migration
+* Add CHAP support for Huawei driver
+* Move volume.api test to correct location
+* Remove logging statements from migrations
+* DRBD: Define a separate prefix for snapshots
+* Prevent missing Purity hosts from raising errors
+* Revert "Remove X-IO volume driver"
+* Filter cgsnapshots data on the DB side
+* Refactor Huawei Volume driver
+* Add volume\_attachment to volume usage notifications
+* Graceful shutdown WSGI/RPC server
+* Backups: allow name to be specified during restore
+* Set default policy for "volume:get"
+* Add iSCSI multipath support for Huawei driver
+* Fix 3PAR driver handling of existing VLUNs
+* Don’t log warnings in Pure initialize\_connection
+* scality: add export and name keys to os-initialize\_connection info
+* Add delete/update\_volume\_metadata policy rules
+* Remove "volume:services" rule from policy.json
+* Report capability of multiattach for FlashSystem
+* Handle volume not found on zfssa volume delete
+* Raise BadRequest for invalid replication status
+* Add unit tests for cinder.api.v2.volumes
+* Raise HTTP exception for backup not found
+* Port NetApp NFS drivers to use ABC driver model
+* Removing OpenvStorage for no CI
+* Remove unused serialize\_args method
+* Remove obsolete API from documentation
+* Tests: test\_volume mock conversion
+* Fix restore point if backup base is diff-format in ceph
+* Add white list support for target ports in VNX driver
+* Preserve mock side\_effect’s in test\_pure
+* StorPool: clean up the last uses of str.format()
+* Removing archaic references
+* Remove useless logging from unit tests
+* cinder list fails with 'name' sort key
+* Storwize\_svc\_npiv\_compatibility\_mode default value change
+* Remove unused parameter in PureFCDriver \_connect
+* Cleanup unused method fake\_get\_target
+* Set driver version in Sheepdog driver
+* Updated from global requirements
+* Fix saving tz aware datetimes in Versioned Objects
+* set/unset volume image metadata
+* Fix not implemented wording in update\_migrated\_volume
+* Add support for force-delete backups
+* Improve 3PAR driver VLUN creation and deletion
+* Remove hacking check N327
+* Fix tests failing in gate
+* Fix properties extracting from image with glance api v2
+* Support SMI-S provider v8.0.3 in VMAX driver
+* Add ability to override OpenStack privileged user auth url
+* VMEM v6000: Fix export verify routines
+* Port Tintri driver to ABC driver model
+* Fix block\_device driver to behave as documented
+* NetApp E-Series: Add debug tracing
+* Set encrypted key in connection\_info during initialize
+* Nested Quota: Set default values to subproject
+* Dell SC: Add support for ManageableVD
+* Fix NetApp cDOT driver use of Glance locations
+* Fix missing pool name in consistency group
+* NetApp ONTAP: Add debug tracing
+* Add tracing facility for drivers
+* Fix error message in Pure driver with correct text
+* Notify the transfer volume action in cinder
+* Storwize Driver zone removing
+* Dell SC: Add support for consistency groups
+* Remove duplicate volume.filters entry
+* Port NetApp E-Series iSCSI driver to ABC model
+* Fix getting out-of-date volume operation state issue for VNX
+* Separate FlashSystem FC and iSCSI common code
+* Update expected error message from lvs
+* Fix HBSD horcm driver with oslo.concurrency 2.1.0
+* Remove X-IO volume driver
+* RemoteFS: Fix the offline snapshot delete operation
+* Implement the update\_migrated\_volume for the drivers
+* Avoid race condition at snapshot deletion stage
+* Fix Python 3 issues in cmd
+* Port image/glance.py to Python 3
+* Switch to oslo.reports
+* Validate maximum limit for quota
+* Updated from global requirements
+* Fix block eventlet threads on rbd calls
+* RemoteFS: Reporting configured reserved\_percentage in \_update\_volume\_stats
+* GlusterFS: support extending a volume that has snapshots
+* Port dothill to Python 3
+* Fix backup.rpcapi to pass object backup
+* Fix typo in solidfire driver option
+* Mock socket.gethostbyaddr in test\_v7000\_fcp
+* Replace missed basestring by six for python3 compatability
+* Return 404 if volume type encryption is not found
+* Updated from global requirements
+* smbfs: fix invalid check for smbfs\_used\_ratio correctness
+* Remove lio\_initiator\_iqns config option
+* Move HDS drivers to Hitachi folder
+* Fix Python 3 issues in targets unit tests
+* Port drbdmanagedrv driver to Python 3
+* Port test\_db\_api to Python 3
+* Port hitachi driver to Python 3
+* Fix getting wwpn information in infortrend driver for DS4000
+* Do not allow to modify access for public volume type
+* Add dependency check in RBD delete\_snapshot
+* Port huawei driver to Python 3
+* XtremIO driver fix array snapshot problem
+* Fix cinder.conf.sample generation
+* Handle attachment of second volume
+* VMware: Create volume backing in specific clusters
+* Use versionutils from oslo.log
+* Correct overquota error message
+* Updated from global requirements
+* Fix timeout issue in EMC VNX driver unit test
+* Remove oslo logging from backup unit tests
+* Add notifications about snapshot.update.\*
+* Sync the latest fileutils module from oslo-incubator
+* Port NetApp DATAONTAP blocks drivers to ABC model
+* Fix 'no actual-pathname' NetApp API error
+* Use right oslo.service entry points
+* Use symbol for error code in VNX cinder driver
+* Storwize driver report capability for multiattach
+* Filter snapshots data on the DB side
+* Change generic NotFound to specific exception
+* Storwize: add the missing stops in the end of the messages
+* Ensure 'WSGIService' derives from oslo\_service base class
+* Switch to oslo.service
+* Fix library includes for config generator
+* Revert First version of Cinder driver for Quobyte
+* Fix cinder-manage volume delete cmd
+* Fix Python 3 issues in the blockbridge driver
+* Fix Python 3 issues in the swift backup driver
+* Fix Python 3 issues in ceph and rbd drivers
+* Fix Python 3 issues in backup
+* Remove generate\_glance\_url
+* Fix manage\_existing function in infortrend driver
+* Add unit tests for the capacity filter
+* Modify template account creation in SolidFire drvr
+* Tests: Fix assertRaisesRegexp deprecation warnings
+
+7.0.0.0b1
+---------
+
+* Harden scheduler.rpcapi unit tests
+* Fix backups.rpcapi to pass objects over RPC
+* Fix weird change of volume status in re-scheduling
+* Fix tox -e py34
+* Add exception catch in report\_state for DBError
+* Updated from global requirements
+* Dell SC: Enable use of Storage Profiles
+* Use elevated context for backup destroy
+* Fix Cinder Objects unit tests
+* rbd: add volume\_id to connection\_info in initialize\_connection
+* Fix Datera driver export call
+* Add iscsi\_target\_flags configuration option
+* Adds the Violin Memory V7000 series FC driver
+* Remove the hardcoded concurrency limit for ostestr
+* Revert "Disable backup progress notifications for unit tests"
+* Nested Quota : Create allocated column in cinder.quotas
+* Handle incorrect '--config-dir' param
+* Get updated volume status in begin\_detaching
+* Tests: Make fake\_notifier per-instance
+* Validate outermost request body element name consistently
+* Add missing argument to delete\_keys method
+* Port LeftHand driver to use ABCMeta driver model
+* Add Virtuozzo Storage Volume Driver
+* Disable profiler for unit tests
+* Use a hard-coded project\_id in racy cinder.tests.unit.test\_volume tests
+* Validate bool value using strutils.bool\_from\_string method
+* Incorrect exception caught in qos-specs create api
+* VMware: Remove unused methods
+* Scality SOFS: enhance how the remoteFS mount is detected
+* Backup object
+* Add missing Jinja2 to requirements.txt
+* Storwize: remove the useless method check\_copy\_ok
+* Update version for Liberty
+
+7.0.0a0
+-------
+
+* ScaleIO: Fix broken format string
+* Sync 'report' from oslo-incubator
+* Ceph driver support retries on rados\_connect\_timeout
+* Dell SC Removed \_find\_domain and associated tests
+* LVM add multiattach flag capability
+* Add volume drivers for Infortrend Storage
+* XtremIO Volume driver requests, multipath
+* Updated from global requirements
+* Adds FC and ISCSI Cinder drivers for Lenovo Storage Arrays
+* Adds FC and ISCSI Cinder drivers for HPMSA Storage Arrays
+* Replace basestring with six.string\_types
+* Fix broken export commands on block\_device driver
+* Switch to oslo.policy 0.3.0
+* Add config option to set max\_volume\_size\_limit
+* Fix LIO target helper when missing targetcli
+* Move DRBD tests into tests/unit
+* Volume driver for HP XP storage
+* Replace xrange() with six.moves.range()
+* Drop L suffix from long integers
+* Pass proxy environment variables to tox
+* Re-add DRBD driver
+* Refactor API create\_volume flow
+* Introduce Guru Meditation Reports into Cinder
+* Adds FC and ISCSI Cinder drivers for DotHill Storage Arrays
+* Get rid of oslo-incubator copy of middleware
+* SQL scripts should not manage transactions
+* Targets tests: Clean up long lines
+* Update 3PAR user config help strings
+* Disallow backing files when uploading volumes to image
+* Remove WritableLogger wrapper
+* Get StringIO from six for Python 3 compatibility
+* Fix Python 3 issues in utils
+* Update SolidFire to use target driver model
+* Wait until service thread is done on service stop
+* Add cinder volume driver for Blockbridge EPS
+* 3PAR enable multiattach capability reporting
+* Replace dit.itervalues() with dict.values()
+* Rewrite code merging two dictionaries
+* Replace dict(obj.iteritems() with dict(obj)
+* Replace dict.iteritems() with dict.items()
+* san driver: don't use relative Python import
+* Implement Cinder Volume driver for HGST Solutions
+* Volume manager should set filter\_function and goodness\_function
+* Tintri driver to manage existing backend storage objects
+* Replace it.next() with next(it) for py3 compat
+* Use six to fix imports on Python 3
+* NetApp E-Series: Add Fibre Channel Support
+* NetApp E-Series: Refactor class structure for FC
+* NetApp E-Series driver: Remove caching logic
+* Use six.reraise() for Python 3 compatibility
+* Updated from global requirements
+* Add secondary account capability to SolidFire
+* Replace urllib and urllib2 with six.moves.urllib
+* Replace unicode with six.text\_type
+* Use correct rtslib namespace for newer versions
+* Dispose DB connections between backend proc starts
+* EMC ScaleIO Cinder Driver
+* RemoteFS: Fix doc for locked\_volume\_id\_operation
+* Re-integrate Oracle iSCSI Cinder driver
+* Dell SC: Expanded comments and update var names
+* Re-add the StorPool distributed storage driver
+* Add iSCSI protocol support for IBM FlashSystem
+* Fixes 3PAR snapshot failure with optional params
+* ConsistencyGroup: Return 400 instead of 500 for invalid body
+* Port remote\_fs driver to use new driver model
+* Make VNX Cinder Driver aware of VNX Pool Full Threshold
+* Add 'source-id' and 'source-name' support in VNX driver
+* Revert "Adds drivers for DotHill Storage Arrays."
+* Dell SC: Added support for alternate iscsi portals
+* Dell: Added verify cert option for REST calls
+* Handle ineffective backup compression
+* Prophetstor driver needs to return snapshot objects
+* Complete switch to snapshot objects
+* DriverFilter: don't check volume\_backend\_name
+* Add Pure Storage FibreChannel driver
+* Fix exception parameter name
+* Move Dothill tests out of root test directory
+* Fix remaining memory issues with nfs backup unit tests
+* Don't send heartbeats if Manager reports a problem
+* Changes in rally-jobs/README.rst
+* Removed explicit return from \_\_init\_\_ method
+* Return provider\_id in SolidFire model update
+* Deprecate the HPLeftHandISCSIDriver CLIQ driver
+* Allow provisioning to reach max oversubscription
+* Port ProphetStor driver to use ABCMeta driver model
+* Clean up unused exceptions
+* Refactor scheduler's create\_volume flow
+* Adds FC and ISCSI Cinder drivers for DotHill Storage Arrays
+* Bump SolidFire version number
+* Dell SC: update\_volume\_stats could use uninitialized vars
+* Disable backup progress notifications for unit tests
+* Tintri Cinder Volume driver
+* Fix assertRaisesRegexp deprecation warnings in UT
+* Refactor PureISCSIDriver into base and iSCSI classes
+* Add missing unit test for goodness weigher
+* Non-admin user to query volume filter by az
+* Fix cinder concurrency issues on rtstool
+* Use SolidFire snapshots for Cinder snapshots
+* Switch get\_all\_snapshots to use objects
+* rbd driver in cinder does not manage glance images multi-location
+* Notification with volume and snapshot metadata
+* Remove pretty\_tox and use ostestr
+* Add volume ID to fake volumes in Gluster tests
+* Fix capacity filter to allow oversubscription
+* EMC VMAX Manage/Unmanage Volume
+* Add chap support to CloudByte cinder driver
+* Multiple pools support enhancement in VNX cinder driver
+* Remove un-used import at test\_volume\_transfer.py
+* NetApp FC driver shims missing manage/unmanage
+* Updating cmd/manage.py get\_arg\_string() argument parser and adding unit test
+* Fix expression-not-assigned pylint issues
+* Add standard QoS spec support to cDOT drivers
+* Avoid LUN ID collisions in NetApp iSCSI drivers
+* VMware: insecure option should be exposed
+* Create iSCSI lio portals with right IPs and port
+* Create consistgroup from cgsnapshot support in VNX driver
+* Stop using deprecated timeutils.isotime()
+* Fix response when querying host detail by host name
+* Fix wrong response with version details
+* Display NOTIFICATIONS on assert failure
+* Brocade driver not parsing zone data correctly
+* Fix issues with extra specs in VMAX driver
+* Don't use dict.iterkeys()
+* Address 0x712d8e0e error in VNX Cinder Driver
+* Leverage dict comprehension in PEP-0274
+* Add missing '-o' CLI option to VNX Cinder Driver
+* Validate name and description for volume type
+* Leave sqlalchemy convert to boolean to the DB SQL type to use
+* Switch from MySQL-python to PyMySQL
+* Add ability for drivers to copy data preserving sparseness
+* Remove HDS HUS iSCSI driver
+* Updated from global requirements
+* Use nfs\_oversub\_ratio when reporting pool capacity
+* LVM: Pass volume size in MiB to copy\_volume() during volume migration
+* LVM: Support efficient data copy using "dd" for create\_cloned\_volume
+* Fix a problem with FAST support in VMAX driver
+* Remove use of deprecated LOG.warn
+* Fix incorrect reraising of exceptions
+* Switch to oslo\_versionedobjects
+* Cinder os-force\_detach api returns 500
+* Check volume\_backend in retype
+* Fix overwrite of params in SF image cache update
+* Dell SC driver honoring folder name after volume creation
+* Check type match on create from source/snap
+* Add patch for consistency group update in ProphetStor driver
+* Logging not using oslo.i18n guidelines (openstack)
+* Remove unused context parameter
+* Replace suds test dependency with suds-jurko
+* Fix missing translations for log messages
+* Remove Brick from cinder codebase
+* Follow i18n guidelines in LIO target
+* Windows SMBFS: Fix image resize errors during volume creation
+* Windows iSCSI: Add CHAP authentication support
+* NFS Backup: Correcting backup\_sha\_block\_size\_bytes help message
+* Fix common misspellings
+* GlusterFS: Renaming test case to test\_mount\_glusterfs
+* Add new exception to retryables in SolidFire driver
+* Convert mox to mock: tests/compute/test\_service.py
+* FlashSystem reports error while running tests with multi-thread
+* Dell: Added support for update\_migrated\_volume
+* Fix FakeISCSIDriver and FakeISERDriver
+* Add volume status to error messages in backup create flow
+* Bad link in API version details response
+* Fix xxx=\n pep8 errors in volume\_utils.py
+* Log command failure details before raising ISCSITargetDetachFailed
+* Eqlx: Fixes the retries on Network Connection Error
+* Rename Datera test to test\_datera for discovery
+* Allow rexports for targets with Datera
+* Add os-brick to cinder requirements.txt
+* Fix the KeyError in CloudByte iSCSI cinder driver
+* LIO: Enable iSER for IPv6
+* LIO: Use rtslib property instead of private method
+* Fix missing translations for log messages
+* Cinder os-attach api returns 500
+* cinder os-detach api returns 500
+* HDS HNAS Driver fails when FS unhealthy
+* Logging not using oslo.i18n guidelines (zonemgr)
+* Fix broken add\_iscsi\_conn log message
+* Fix unit tests spam output
+* Preserve usage and reservations on quota deletion
+* Fix 'driver is uninitialize' typo
+* Removing sleep between when a command is sent and 'YES' is sent
+* Windows iSCSI: remove ensure\_export
+* tests: replace mox by mox3, clean out mox usage
+* Catch additional type conversion errors
+* Tests: Remove sleep from NFS tests
+* Port block\_device driver to use new driver model
+* VMware: Enable vCenter certificate verification
+* Fix typo in log messages and comments
+* Clean up failed clones in VMAX driver
+* Correct directories check for N327 hacking check
+* Fake out sleeps in unit tests
+* Fix range check for NFS used ratio
+* Move logging sample to use oslo\_log
+* Targets test refactoring
+* Revert state if attachment already exists
+* Add retry to lvm delete
+* Admin extends tenant's volume but change admin's quota
+* Drop use of 'oslo' namespace package
+* Add Multi-connection support to XIV
+* VNX Cinder driver Over Subscription Support
+* Fix namespace issue in generate\_sample.sh
+* Add hacking check for str and unicode in exceptions
+* Fix volume creation from image with allowed\_direct\_url\_schemes
+* Change default of option volume\_driver to LVMVolumeDriver
+* GlusterFS: Support over subscription in thin provisioning
+* Remove unnecessary checks for encrypted types
+* Add test case for volume\_encryption\_metadata\_get
+* Updated from global requirements
+* Port rbd driver to use new driver model
+* Don't truncate osapi\_volume\_link prefixes
+* Fixed issue with mismatched config in VMAX driver
+
+2015.1.0
+--------
+
+* Add external genconfig calls
+* Create initiator id for VMAX iSCSI driver
+* Remove deprecated methods in VNX driver
+* Remove unused find\_attribute\_or\_element()
+* 3PAR don't log version numbers every stats update
+* Sync oslo service module
+* Add external genconfig calls
+* Enable use of filter\_function in PureISCIDriver
+* NetApp E-Series: Fix instance live-migration with attached volumes
+* Add resource tag to logging in volume.manager.py
+* VMware: Handle concurrent inventory folder create
+* Leverage timeutils, drop strtime() usage
+* GlusterFS: Using mount method in RemoteFsClient
+* Remove redundant code from VNX Cinder Driver
+* Remove force check from copy\_volume\_to\_image
+* Logging not using oslo.i18n guidelines (scheduler)
+* service child process normal SIGTERM exit
+* service child process normal SIGTERM exit
+* Move unit tests into dedicated directory
+* Dell SC driver calls out the wrong REST API version
+* Move RBD calls to a separate threads
+* Windows SMBFS: fix volume extend
+* Fix a wrong argument of create method
+* Fix tiny typo: compatability => compatibility
+* Reserve 5 migrations for Kilo backports
+* RBD: Add missing Ceph customized cluster name support
+* Standardize logging in volume.api.py
+* Release Import of Translations from Transifex
+* Fix fetch\_to\_volume\_format if vhd is requested
+* Windows: Improve vhdutils error messages
+* SMBFS: Add minimum qemu-img version requirement
+* VolMgr: reschedule only when filter\_properties has retry
+* Storwize driver should only report active wwpn port
+* update .gitreview for stable/kilo
+* Mask passwords with iscsiadm commands
+* Add support for customized cluster name
+* Updated from global requirements
+* SMBFS: Lock on a per-volume basis
+* Windows SMBFS: fix volume extend
+* Complete the doc/README.rst instructions to build docs
+* Verify all quotas before updating the database
+* Add locking to PureISCSIDriver around creating Purity Host objects
+* Include boot properties from glance v2 images
+* Add CA cert option to backups swift driver
+* Fix a wrong argument of create method
+* Add locking to PureISCSIDriver around creating Purity Host objects
+* Reworked Dell SC iSCSI target portal return
+* Fix LUN misalignment issue with NetApp iSCSI drivers
+* Remove the export creation during volume creation for migration
+* Fix assertEqual in test\_volume.py in correct order of params
+* VNX Cinder Driver should report 0 free\_capacity\_gb in some scenarios
+* Include boot properties from glance v2 images
+* Logging not using oslo.i18n guidelines (brick)
+* set default auth\_strategy to keystone
+
+2015.1.0rc1
+-----------
+
+* Open Liberty development
+* Removed sleep before 'YES' is sent to confim an operation
+* Update openstack-common reference in openstack/common/README
+* GlusterFS: Returning provider location of volume from snapshot
+* Fixes snapshot creation failure in CloudByte driver
+* Delete the temporary volume if migration fails
+* Revert "Removing Windows drivers"
+* Correct cinder hacking check numbering
+* Add hacking check for print() statements
+* Rbd update volume stats in wrong way
+* Add missing copy\_volume\_to\_image method to Sheepdog driver
+* Partial Revert "Removing Huawei drivers"
+* Create initiator id if not exist in VMAX driver
+* Fixed encrypted property for 3PAR FC and iSCSI drivers
+* Partial Revert "Removing ZFSSA driver"
+* Mock wait\_for\_volume\_removal in test\_brick\_connector
+* Dell SC driver has insufficient iscsi logging
+* VMware: Skip vSAN for preallocated image download
+* Enable H238 hacking rule
+* Use six.text\_type instead of unicode
+* Fix ISCSIDriver initialized connection volume type
+* Fix multipath device discovery when UFN is enabled
+* Fix missing clone\_image API support for sheepdog driver
+* More error handling on EMC VNX migration failure
+* Set volume\_attachment to [] for the temporary volume creation
+* Add volume:update rule to policy.json
+* Fix always false condition in glance wrapper
+* Only use operational LIFs for iscsi target details
+* Revert "Removing Netapp FC drivers for no reported CI"
+* Get volume from db again before updating it's status
+* Catch more general exception in manager's create\_volume
+* Fix broken fetch\_to\_volume\_format log message
+* Tests: Fix v6000 test failure with random hash seed
+* Check volume status in detach db api
+* Fix wrong command for \_rescan\_multipath
+* Storwize: Replication status still active when primary copy is offline
+* VMware: Fix instance\_uuid access in volume retype
+* Logging not using oslo.i18n guidelines
+* Remove LP bug ref in remove\_iscsi\_device
+* Fix potential access to missing key
+* Brick: Fix race in removing iSCSI device
+* VMware: Improve invalid container error message
+* Fix the format of the system name in VMAX driver
+* Hitachi: Fix access to volume instance\_uuid
+* VMware: Fix ImageNotAuthorized during copy volume
+* Fix: Boot from image with HNAS iSCSI
+* SMBFS: Fix missing volume provider location
+* Enhance VNX Cinder volume creation logic
+* Properly use obj\_extra\_fields in objects
+* Create unit tests for volume objects
+* Fix incorrect invocation of \_add\_to\_threadpool
+* VMware: Fixed usage of volume instance\_uuid
+* Change volume and snapshot stuck creating to error
+* Imported Translations from Transifex
+* Fixed access to instance\_uuid in retype
+* Ensure initialize\_connection in targets pass multipath parameter
+* Eager load volume extra specs
+* Be safe with getting attachment
+* Added the missing attachment to detach\_volume
+* Make lio iSCSI changes persistent to avoid lost
+* Sort list of cinder\_object.changes
+* Move to hacking 0.10
+* Syncing versionutils from oslo-incubator
+* Properly remove host object from ISE
+* Dell Storage Center API change fails init\_conn
+* Windows iSCSI: fix volume clone
+* Enable request-id in cinder API logs
+* Use cached values for stats on query failures for vmem drivers
+* The value of netapp\_storage\_protocol should default to none
+* Change leftover oslo.\* to oslo\_\*
+* Updated from global requirements
+* Fix: Synchronise Quobyte Share mounting
+* Fix typo in cinder/cinder/volume/drivers/emc\_vmax
+* Update file doc string for pure.py
+* update oslo policy to remove policy.d log spam
+* Fix QoSSpecManageApiTest to work in parallel
+
+2015.1.0b3
+----------
+
+* Remove chap secret DEBUG logging in PureISCSIDriver
+* Removing Windows drivers for no reported CI
+* Fix logging mistake in swift backup driver
+* Removing Zadara driver for no reported CI
+* Removing Huawei drivers for no reported CI
+* Removing Netapp FC drivers for no reported CI
+* Removing Fujitsu driver for no reported CI
+* Removing DRBD driver for no reported CI
+* Removing FusionIO driver for no reported CI
+* Removing Nexenta driver for no reported CI
+* Removing Symantec NFS driver for no reported CI
+* Removing StorPool driver for no reported CI
+* Removing ZFSSA driver for no reported CI
+* Make the 3PAR drivers honor the pool in create
+* Removing HP MSA driver for no reported CI
+* Removing Coraid driver for no reported CI
+* Add retry to create resource in Datera driver
+* Logging not using oslo.i18n guidelines
+* Tests: Fix az test failure when PYTHONHASHSEED != 0
+* Change datetime.now() to timeutils.utcnow() from oslo\_utils
+* Fixes nits in check\_no\_contextlib\_nested
+* Fix logging to catch original exceptions and tracebacks
+* Remove error messages from multipath command output before parsing
+* Return updated volume object to the caller of \_attach\_volume()
+* Fix SAN generic driver ssh whitespaced commands
+* EMC: Fix use of "\_" as variable name
+* Reduce configured file size for nfs backup unit tests
+* tests: remove useless variable
+* Revert "Datera's export to avoid deprecated keys"
+* Don't override extra specs with config in VMAX
+* Check license before clone in VMAX driver
+* Fixing mount when state\_path is configured with a final '/'
+* Verify all quotas before updating the database
+* Update Violin REST client library name
+* Remove the reference of volume['instance\_uuid']in VNX driver
+* Increase LeftHand driver minimum client version
+* Decrement remaining retries after failed REST call
+* VMware: Fail immediately for images in a container
+* Make unused iscsi\_num\_targets, iser\_num\_targets configs as deprecated
+* Raise exception for invalid mock assert calls
+* Mocked utils.execute for broken tests
+* Huawei driver check before associating LUN to a LUN group
+* Windows: Fixes wintypes import issue in vhdutils
+* Fix typos in LVMVolumeDriver
+* Add minimum qemu-img version check functions
+* Implement IET target driver
+* Fix unit tests for multiattach patch
+* Fixed a concurrency issue in VMAX driver
+* Fix LVM thin pool creation race
+* Added provider\_id to volume and snapshot object
+* Fix ArgsAlreadyParsedError in emc\_vnx\_cli.py
+* Fix typo in log message
+* remotefs: Fix doc string for \_create\_snapshot
+* Fix a typo in sf\_template\_account\_name help
+* Move to the oslo.middleware library
+* Remove use of contextlib.nested
+* Remove strutils from oslo-incubator
+* Add waiting for the driver to SchedulerManager
+* Fix retype return value in volume driver base class
+* Fix retype arguments in volume driver base class
+* Fix sqlalchemy reuse in multi-backend children
+* Fix Cinder logs to show authentication error in RBD driver
+* Update hacking check for oslo\_log
+* Add is\_ready method to scheduler driver
+* Fix for  inconsistent cinder-services state change
+* Fix HNAS iSCSI driver error on LUN creation
+* Datera driver looks for lun-0 instead lun-1 now
+* Use oslo.log instead of oslo-incubator
+* Remove the useless next link for volumes, transfers and backups
+* Unset auth token before trying to login to Datera
+* NFS backup driver
+* Sort snapshots in create CG from CG snapshot
+* Add multiattach capabilities injection
+* Tests: Harden fake\_notifier asserts
+* Error trying to delete snapshots on Hitachi driver
+* Remove global mocking from test\_pure.py
+* Allow scheduler to receive volume stats when starting service
+* VMware: Fix exception logging
+* Adjust Cinder to support FCP on System z systems
+* Refactor Swift backup driver and introduce chunking driver
+* Namespace updates for \_i18n and imageutils & fileutils
+* Dell FC driver inheritance order causing failures
+* Add volume multi attach support
+* Add project\_id to barbican keymgr wrapper
+* Fixes VNX NotImplementedError of unmanage
+* Replace assertEqual(True, \*) -> assertTrue(\*)
+* Update Datera's export to avoid deprecated keys
+* Improve error handling in refactored Tgt driver
+* Adds pool aware scheduling for HNAS drivers
+* PureISCSIDriver consistency group updates
+* HP lefthand driver filter and evalautor function
+* Fix the unicode encode error when create volume
+* Add consistency group support for XIV/DS8K cinder driver proxy
+* Don't fail target\_delete if ACL's don't exist
+* Change log level for no object attribute found
+* Add Manage/Unmanage support to NetApp NFS drivers
+* Use snapshot object in create\_volume flow
+* Fix "rtsllib" -> "rtslib" typos
+* Fix some issues with pool name sent to SVC
+* Fix allocated\_capacity tracking when rescheduling
+* HP 3par driver filter and evaluator function
+* Add support to incremental backups in cinder
+* Convert all eqlx tests from mox to mock
+* Fixed the order of mock decorators in VMAX driver
+* Adds SSH communication to HNAS drivers
+* Add CHAP support to PureISCSIDriver
+* Make objects behave more like our old dictionaries
+* Two choices for iscsi\_helper is missing
+* Update Datera's Authentication method
+* Simplify cxt test\_create\_export() unit test
+* CG Modification Support in EMC VNX Cinder Driver
+* Dell SC API change fails snapshot creation
+* Adding manage/unmanage support for LeftHand driver
+* More validation logic for VNX CG creation
+* Change default value of gpfs\_images\_share\_mode to None
+* Add DB table for driver specific data
+* Move oslo.messaging to the oslo\_messaging namespace
+* Create Consistency Group from CG Snapshot API
+* Modify Consistency Group API
+* Remove useless storage\_availability\_zone import
+* Failover to alternative iSCSI portals on login failure
+* Update volume type name for volume type API
+* Add config option to override url for versions
+* Snapshot and volume objects
+* Cinder objects base
+* Dell Storage Center Driver API bug
+* Password config options should be marked secret
+* Clear migration\_status from a destination volume if migration fails
+* RBD: Query volume features from ceph.conf
+* i18n Compatibility in VMAX driver
+* Correct a few changes in the VMAX driver
+* Fix HNAS driver parsing errors
+* RBD: remove non-layering support for antiquated versions
+* Fixed errors in docstrings in the VMAX driver
+* SMBFS: Fix retrieving the volume path and format
+* More validation logic for VNX CG creation
+* Add flash cache policy to 3PAR driver
+* Update v1 deprecation warnings
+* Fixes the import for Lefthand driver
+* NetApp eseries implementation for manage/unmanage
+* Replication status periodic task optimization
+* XtreamIO version 4.0 support
+* Change max\_over\_subscription\_ratio default value
+* Use Unique SCST Group names in SCST cinder helper driver
+* Add CHAP persistence to SCST target helper
+* Fix for infinity capacity reporting in EQL driver
+* Use iscsi\_helper instead of target\_helper on logs
+* Import only modules: H302
+* Revert "Remove retry\_deactivation directive on lvremove"
+* Over subscription for Pure Storage iSCSI driver
+* Use oslo\_config choices support
+* Custom zone name prefix not being used by brcd driver
+* cinder-manage man update
+* GET volumes API sorting REST/volume/DB updates
+* GET volumes API sorting enhancements common utilities
+* FCZM fix reading of cinder config entries
+* Sync scheduler.filters module from oslo-incubator
+* Limit volume copy bandwidth per backend
+* Generic filter support for volume queries
+* Remove warnings for long vgs and lvs calls
+* Use subunit-trace to enable output during unit test runs
+* VMware: Relocate volume to compliant datastore
+* VMware:Use datastore selection logic in new module
+* VMware: Refactor initialize\_connection unit tests
+* Fix exceptions logging in TgtAdm
+* Sync 'versionutils' module from oslo-incubator
+* Sync 'threadgroup' from oslo-incubator
+* Update 'systemd' module from oslo-incubator
+* Sync 'service' module from oslo-incubator
+* Sync 'loopingcall' module from oslo-incubator
+* Sync the 'fileutils' module from oslo-incubator
+* Sync 'eventlet\_backdoor' module from oslo-incubator
+* Remove unused 'test' module from oslo-incubator
+* IBM GPFS Consistency Group Implementation
+* Fixed 3PAR driver load balancing during migration
+* NetApp E-series: Allow scheduling by disk
+* Make Interval and Retries Configurable for VMAX
+* Pass region name to Nova client
+* Remove retry\_deactivation directive on lvremove
+* Manage/unmanage impl for NetApp ONTAP iscsi driver
+* Fix argument order in assertEqual: tests/test\_service.py
+* Fix some message nits in the ZoneManager
+* Implement refresh as kwargs in get\_volume\_stats
+* Dell sc driver iscsi multipath enhancement
+* Tests: Fix cxt target tests opening files
+* LVM: Fix thin provisioning and mirrors stats reporting
+* Fix exception error on HNAS drivers
+* Fix comments style according to the Hacking Rules
+* Passing privileged user to create nova assisted snapshots
+* Fix return value inconsistency in VNX Driver
+* Fixed typo
+* Pool-aware scheduler support in EMC VNX Cinder driver
+* Fix extraneous comma that breaks docbook generation
+* Sync policy module from oslo-incubator
+* Dell Storage Center: Add retries to API calls
+* EQLX: Consolidate CHAP config options
+* Add support for chiscsi iscsi helper
+* Fix logging guideline violations in volume/api.py
+* Remove useless requirement on wsgiref
+* Snapshot of bootable volume goes in error state
+* Sync periodic\_task module from oslo-incubator
+* Tests: Don't require binding to port 4444
+* Tests: Remove TestWSGIService.test\_reset\_pool\_size\_to\_default
+* Tests: Remove randomness from NFS mount tests
+* Change exception message in volume api
+* Refactoring for export functions in Target object
+* Add iSCSI SCST Target support to cinder
+* EMC VMAX driver Kilo update
+* Fix Scality SRB driver security concerns
+* Fixes total\_capacity\_gb value in CloudByte driver
+* EMC VNX Cinder Driver iSCSI multipath enhancement
+* Add dedup provisioning to 3PAR drivers
+* Provided requirements are meant to be immutable
+* Remove optional parameter from lun mapping call
+* quobyte: remove dependency to xattr
+* Don't fail target\_delete if target doesn't exist
+* Remove custom lazy loading
+* DRBD: Use correct function object after DBus disconnect
+* Split volume driver into ABC classes
+* Mock out the wait routine in the VMAX driver
+* Limit ram and disk used by ceph backup tests
+* Fix detach volume from host problem in VMAX driver
+* fix typo in config.py
+* Update hacking ignore list
+* VMware: Delay string interpolation in log messages
+* VMware: Integrate VMDK driver with oslo.vmware
+* Enhance iSCSI multipath support
+* Dell Storage Center Unit Test Updates for Kilo
+* Updated from global requirements
+* Update eqlx driver help text
+* Add extra library oslo.concurrency to oslo.config.generator.rc
+
+2015.1.0b2
+----------
+
+* Support over subscription in thin provisioning
+* Change oslo.\* to oslo\_\*
+* Lefthand driver fails to attach a cloned volume
+* Purge deleted rows
+* Make PureISCSIDriver iSCSI port discovery more flexible
+* EMC VNX Cinder Driver Update
+* Make storwize debug log more readable
+* Fixes the EQL driver CI tests AttributeError
+* Add manage/unmanage methods for Hitachi Block Storage Driver
+* RemoteFS: Use nas\_ip and nas\_share\_path options
+* Scality SOFS : Use ensure\_tree from fileutils
+* Tests: Don't sleep for looping calls (eqlx)
+* Enable use of an /etc/cinder/lvm.conf file
+* Roll back if VMAX masking view not created
+* Tests: Don't sleep for looping calls
+* Windows iSCSI driver: Fixes copy disk method exception handling
+* VMware: Fix missing target resource pool
+* Revert "Implement Huawei SDSHypervisor driver"
+* Remove the solaris volume driver
+* Fix SSHPoolTestCase to work in parallel
+* Drop deprecated namespace for oslo.rootwrap
+* Fixes attribute content checking
+* Imported Translations from Transifex
+* Support iSER driver within the ISCSITarget flow
+* HP3Par: Set snapCPG when managing existing volumes
+* Fixed misspelling in solidfire.py
+* Adds unit tests for HNAS backend
+* Failed to discovery when iscsi multipath and CHAP both enabled
+* Add retry for tgtadm update when tgt exists
+* Add completion logging for snapshots and volumes
+* Fix configratuion of rally jobs
+* Create SolidFire Template account on init
+* Updated from global requirements
+* Add debug message for lvremove after udev settle
+* IBM Storwize driver Consistency Group Implementation
+* Use get\_my\_ipv4 from oslo.utils
+* TgtAdm: Fix \_recreate\_backing\_lun logging
+* Revert "Create SolidFire Template account on init"
+* HP 3PAR modules have bad log messages
+* Remove useless and unused request\_utils
+* Create SolidFire Template account on init
+* Fetch\_to\_volume\_format calls copy\_volume using wrong parameter
+* Changed pvs separator from ':' to '|' to support names with ':'
+* Raise correct exception when validate\_connector failed
+* Add provisioned\_capacity
+* Move 3 Fujitsu ETERNUS DX related file
+* Add retry to lvm snapshot create
+* Add a generic retry decorator to cinder/utils
+* Use uuidutils from oslo.utils
+* Remove unnecessary method: \_ensure\_iscsi\_targets() in tgt.py
+* Raise correct exception if deleting of LIO iSCSI target is failed
+* Cleanup unused DB APIs, part I
+* Remove argparse from requirements
+* Update tests for Quobyte Cinder drv from mox->mock
+* Fixes a small issue in find\_autodoc\_modules.sh
+* Fix the eqlx driver to retry on ssh timeout
+* Add retrying lib from global requirements
+* Remove usage of taskflow 'utils.misc' module
+* Move oslo.serialization to oslo\_serialization namespace
+* HP 3PAR modules do not follow coding guidelines
+* Improve debug logging of Dell Storage Center driver
+* Fix \_usage\_from\_snapshot in volume.utils
+* VMware:Fix error creating vCenter inventory folder
+* New Cinder volume driver for openvstorage
+* Fix cinder-manage shell ipython
+* Shrink down customized logging listener
+* Prevent deleting volumes in a consistency group
+* Fix bug in rbd driver: the cloned volume size is wrong
+* Fix HNAS driver confusing error message (iSCSI driver)
+* Updated from global requirements
+* Ensure lazy translation is disabled properly
+* DRBD: remove a wrong comma, it creates a tuple
+* Move oslo.utils to oslo\_utils namespace
+* Make test\_create\_delete\_snapshot more robust
+* Add policy\_dirs conf fixture
+* DRBD: Log an error if libraries can't be loaded
+* Fix the iSER legacy usage in the new targets flow
+* Move oslo.config to oslo\_config namespace
+* Add support for manage/unmanage volume commands to PureISCSIDriver
+* Scality: Lock around SOFS mount to avoid a race
+* Set 'driver\_volume\_type' to 'gpfs'
+* Verify the instance's existance in the VMAX driver
+* Updated from global requirements
+* Switch the PureISCSIDriver over to using the purestorage pypi module
+* Fix zfssa driver volume attach to work with latest zfssa software
+* Updated from global requirements
+* Move oslo.db to oslo\_db namespace
+* Fix eqlx endless loop when server closes the connection
+* Increase unit test coverage in hacking test
+* Fixed server name being retained after detach in LeftHand
+* Fixes misspelled words in Cinder
+* Imported Translations from Transifex
+* Add mock for cinder-rtstool call in tests.targets.test\_lio\_driver
+* Skip LIO target unit tests until mocked
+* Fix LOG formatting in api initialize\_connection
+* TgtAdm: Don't change CHAP username/password on live migration
+* Deal with PEP-0476 certificate chaining checking
+* Add hacking check for oslo namespace usage
+* Remove locks from LeftHand driver
+* Fix bug in tgt conf for volume
+* Use is\_valid\_ipv6 from oslo.utils
+* Use lockutils.set\_defaults to set lock\_path in test
+* Fix bug in sheepdog driver: the wrong volume size
+* Add loopingcalls for Huawei storage system driver
+* Implement clone\_image caching on SolidFire
+* Add migration tests for PostgreSQL
+* Garbage Remains when Attached Volume is Migrated with NFS Driver
+* Update README.rst to current state
+* Remove unused variables from ensure\_export()
+* Fix incorrect usage of get\_flow in volume.manager
+* Fix iscsi\_write\_cache setting for iscsi targets
+* Add debug messaging for tgt already exists
+* Clean up QoSSpecManageApiTest setup
+* Add more rally benchmarks related to Cinder
+* Use cinder.utils.execute directly
+* Deal with tgt already exists errors
+* Fix drbd driver to load without 3'rd party libs
+* i18n fixes for PureISCSIDriver
+* cinder-rtstool: should use acl.node\_wwn
+* LVM: Add terminate\_connection call for Target Objects
+* Add an instance-locality filter
+* Adds cinder iscsi driver for CloudByte storage
+* Add driver filter and evaluator for scheduler
+* Remove import of private \_lazy module
+* Fix argument order in assertEqual: tests/test\_nfs.py
+* Fix the continuation line indent to pass flake8
+* Capitalize the first letter in log messages
+* Fix argument order in assertEqual: tests/test\_glusterfs.py
+* Use assertRaisesRegexp() in test\_srb.py
+* The DRBD(manage) Cinder volume driver
+* Make ProphetStor drivers compliant with logging standards
+* Transition LVM Driver to use Target Objects
+* Replace oslo-incubator with oslo\_context
+* Create proxy volume driver
+* Fix handling of serialized data in filtering of volumes
+* Convert mox to mock: tests/test\_glusterfs.py
+* Remove check on db\_exc.DBError
+* Add specific docs build option to tox
+* Imported Translations from Transifex
+* Add a privileged user for OpenStack services
+* Add support to PureISCSIDriver for Consistency Groups
+* Expand the description of extra\_capabilities
+* Fix broken StorPool driver
+* Brick LVM: Remove self.lv\_list
+* Revert "Outputs the message about failing to bind
+* Replace the NetApp driver proxy layer with a proper factory
+* Quobyte Driver Exception Cleanup
+* Handle the volume not found case in the VMAX driver
+* Fix format errors in brick/iscsi LOG messages
+* Add unit tests for NetApp do\_setup methods
+* Outputs the message about failing to bind to IPv6
+* NetApp E-series: Do not log passwords in requests
+* Set iet\_conf to nonexistent file in unit test
+* Fix issue with passing lists in filters
+* Rename oslo.concurrency to oslo\_concurrency
+* Add a provider\_id column to Volumes and Snapshots
+* Mock leaked \_execute() calls in driver tests
+* Sync request\_utils module from oslo-incubator
+* Sync periodic\_task module from oslo-incubator
+* Persist volume uuid on VMAX array
+* Fixed a problem in terminate\_connection in VMAX driver
+* Sync the latest middleware module from oslo-incubator
+* LVM: Volume is deleted unexpectedly during volume migration
+* RBD: use image\_conversion\_dir for image operations
+* Sync the latest loopingcall module from oslo-incubator
+* Sync install\_venv\_common from oslo-incubator
+* Sync latest imageutils from oslo-incubator
+* rtstool on Ubuntu installs in /usr/local/bin
+* encryption\_id needs to be non-nullable
+* Mock calls to rpm and dpkg from NetApp unit tests
+* Fix files in Cinder with execute bit set
+* Add error handling to \_connect function in PureISCSIDriver
+* Fix typo that escaped review in connector.py
+* Fix 3PAR host persona mapping to match WSAPI
+* Punctuation and Copyright changes
+* Make 3PAR drivers compliant with logging standards
+* Fixing 3PAR connection name cache error
+* Remove redundant args for clone\_image method
+* Add Oracle ZFSSA NFS Cinder Driver Support
+* Fix HNAS driver initialization
+
+2015.1.0b1
+----------
+
+* Make GPFS driver compliant with logging standards
+* Updated from global requirements
+* Fixed wait for job completion in VMAX driver
+* Logging updates to properly use ',' instead of '%'
+* Add support for Purity Protection Groups to PureISCSIDriver
+* Catch ImageNotFound exception when deleting rbd volume
+* Isolate Cinder Attach and Connect in Base Driver
+* Uncouple scheduler stats from volume creation
+* Fibrechannel and iSCSI for Violin Memory 6000 Series Arrays
+* Add Scality SRB driver
+* Update volume driver for Huawei storage system
+* Implement Huawei SDSHypervisor driver
+* Implement Huawei SDSHypervisor connector
+* Added volume type description for volume type API
+* Added UUID as primary key for Encryption model
+* Fix 3PAR driver hang on SSH calls
+* Delete default volume size 100M in drivers
+* Send the notifications to the Ceilometer for backup service
+* Add the StorPool block storage driver
+* Update global requirements
+* Remove commented out code from cinder/test.py
+* Fix HNAS driver confusing error message
+* Remove iscsi\_helper calls from base iscsi driver
+* Add unit test for commit 22abe9081
+* Add Support for Dell Storage Center
+* Ensure that lun\_id is an int for NetApp Drivers
+* Symantec NFS cinder driver
+* DB migration tests
+* Convert mox to mock: tests/compute/test\_nova.py
+* Correct default service\_name for nova\_catalog\*\_info config option
+* FlashSystem Code Cleanup
+* FibreChannel drivers for NetApp Data ONTAP storage controllers
+* First version of Cinder driver for Quobyte USP
+* Fix use of invalid variable in tgt exists check
+* Remove an unused variable in volume/manager.py
+* Brick: fix bug in tgt conf for volume
+* Convert test\_image\_utils tests to mock
+* Report better capacity info for a limitless 3par cpg
+* VMware: Fix datastore selection with single host
+* Add support for backup encryption metadata
+* Improve use of temporary\_file and temporary\_dir
+* RemoteFS: Move Nova snapshot code into RemoteFSSnapDriver
+* Implementing the use of \_L’x’/i18n markers
+* Fixes intermittent NFS driver mount failure
+* Updated from global requirements
+* Use pbr entry\_points to setup the cinder scripts
+* ZFSSA iSCSI driver should support extra specs
+* Remove the cinder.conf.sample file
+* Fix for typo in Purity Host create/delete methods in PureISCSIDriver
+* Fix a clone volume problem in VMAX driver
+* Updated from global requirements
+* Fix 3PAR driver attach error when host name missing
+* NetApp fix vol migration unusability
+* Updated from global requirements
+* Allow HostState to handle empty capabilities
+* Inherit RequestContext from oslo
+* Imported Translations from Transifex
+* Workflow documentation is now in infra-manual
+* Remove the check\_uptodate conf checks
+* Improve unit tests for cinder/volume/utils.py
+* Remove lio\_initiator\_iqns
+* Bring cinder up-to-date with new oslo libraries
+* VMware: Add missing storage profile requirement
+* Use object.property instead of object.dump()['property']
+* NetApp 7mode NFS driver doesn't honor netapp\_vfiler option
+* Revert "Fix Brocade FC SAN lookup MITM vulnerability"
+* Add ability to zfssa driver to create multiple initiator groups
+* Improve testing of cinder/utils.py
+* Fix rpc initialization of cinder-manager volume
+* Fix 3PAR drivers attempt to locate existing host
+* Volume type access extension
+* Remove driver compatibility in volume manager
+* Don't use \_execute directly in brick/iscsi
+* Deal with tgt already exists errors
+* Fix find\_autodoc\_modules.sh to support OSX
+* Raise exception if invalid IP is specified
+* Fix check\_ssh\_injection in cinder/utils
+* Fix \_get\_disk\_of\_partition edgecase in utils
+* Adding volume driver for X-IO ISE
+* Remove Python 2.6 backwards compatibility code
+* Imported Translations from Transifex
+* Get the 'consumer' in a correct way for retyping with qos-specs
+* PureISCSIDriver:Handle delete called on already deleted volume
+* Add limited retype support for rbd
+* Add iSCSI Target objects as independent objects
+* Remove Python 2.6 classifier
+* Implementing the use of \_L’x’/i18n markers
+* Match mock.patch decorator with appropriate param
+* Correct misspelled words
+* Brick LVM: LV not found logging and error handling
+* etc: replace NullHandler by Python one
+* Don't use module importutils from oslo-incubator
+* Removing locks from 3PAR FC and iSCSI drivers
+* Update rally job files
+* Fix calls to assert\_called\_once in unit tests
+* Refactoring to allow addition of NetApp FibreChannel drivers
+* Add ability to create volume from image by image name
+* Fix exception message formatting
+* VMware: Set target ESX host for backing VM clone
+* Create "image\_conversion\_dir" before creating temporary file
+* Convert the DateTime into ISO8601 format for Ceilometer
+* Imported Translations from Transifex
+* Remove module timeutils
+* NetApp NFS and iSCSI: move zapi client logic into modules
+* Context cleanup
+* ProphetStor with pool aware cinder scheduler
+* Updated from global requirements
+* Imported Translations from Transifex
+* Fix messages in EMC VMAX driver with no translation
+* Scality SOFS: implement volume backup and restore
+* Fixup regressions in PureISCSIDriver log statements
+* Implementing the use of \_L’x’/i18n markers
+* Remove module jsonutils
+* Sync policy from oslo-incubator
+* Don't use module excutils from oslo-incubator
+* Sync latest versionutils from oslo-incubator
+* GlusterFS: Lock on a per-volume basis
+* Defining the variable "tmp" before try block
+* PureISCSIDriver needs to disconnect hosts before deleting volumes
+* context.elevated() should use copy.deepcopy()
+* Added missing rules in policy.json
+* Fix message translations for MSA common class
+* Switch Cinder to use oslo.concurrency
+* Use oslo.utils
+* Remove code for deprecated extension path
+* Imported Translations from Transifex
+* Update prerequisite packages in development docs
+* Change CHAP secret default length
+* Implementing the use of \_L’x’/i18n markers
+* Switch to oslo.serialization
+* Fix typo in SolidFire xDBVersionMismatch label
+* Fix a problem in creating consistency group in ProphetStor driver
+* Updated from global requirements
+* Disable Cgsnapshot APIs by default
+* Invalid GlusterFS share format error
+* allow image\_id for imageRef in create volume API v2
+* Changing PureISCSIDriver to use % string formatting instead of .format
+* Update cinder.conf.sample to fix max db conn retries
+* CiscoFCSanLookupService passing command as string
+* Documentation Bug fix committed
+* Add i18n \_LX tags for relevant log levels in EQLX driver
+* Bump Req timeout to 30 seconds in SolidFire Driver
+* Remove cinder/compute/aggregate\_states.py
+* Remove deprecation warnings relating to api-paste
+* Mock isfile in test\_ssh\_missing\_hosts\_key\_file
+* Implementing the use of \_L’x’/i18n markers
+* Scality driver:use self.configuration instead of CONF
+* Mock cinder.wsgi.Server in TestWSGIService
+* Explicitly close requests obj in SolidFire Driver
+* Remove Mock class monkey patching
+* Add volume attribute support to volume created using clone, snapshot
+* Stop stacktracing on QuotaErrors
+* Stop stacktracing on InvalidInput exceptions
+* Add automatic creation and deletion of Purity hosts for PureISCSIDriver
+* Mox -> Mock for test\_block\_device.py
+* Fix Brocade FC SAN lookup MITM vulnerability
+* Implementing the use of \_L’x’/i18n markers
+* Imported Translations from Transifex
+* Updated from global requirements
+* Fix the LV NotFound situation for thin-type LVM
+* Fix wrapper to work with barbicanclient 3.0.1
+* Retry remove iscsi target
+* Adding support for 'source-id' in 3PAR manage
+* Remove test\_barbican from keymgr tests
+* Implementing the use of \_L’x’/i18n markers
+* Capture exception when delete a volume detached
+* Add cinder support for IBM FlashSystem
+* Use urllib.urlencode instead of dict\_to\_query\_str
+* Disable python-barbicanclient 3.0.0 version
+* Activate pep8 check that \_ is imported
+* LIO: Fix UnboundLocalError in ensure\_export
+* Amend unused variables to assist pylint testing
+* Brick LVM: Rename get\_all\_volumes, further optimize
+* Fix wrong arg number for \_fix\_id\_migration issue
+* Cleanly override config in tests
+* Add debug output indicating provider\_location
+* Use look up service for auto zoning
+* Fix for debugging c-vol in PyCharm
+* CiscoFCSanLookupSerive uses extra argument in init
+* Fix SolidFire inaccurate model on migrated vols
+* Eventlet green threads not released back to pool
+* Add ability to update migration info on backend
+* Reserve 5 migrations for backports
+* Verify the full interface of the context object
+* IBM Storwize: Improve error message
+* Imported Translations from Transifex
+* LioAdm: Delete initiator from targets on terminate\_connection
+* NFS Security Enhancements: allows secure NFS environment setup
+* Brick LVM: Optimize get\_volume
+* TgtAdm: Don't change CHAP username/password on live migration
+* Update volume-type's quota when extending volume
+* Cinder api service doesn't handle SIGHUP properly
+* Handle DBConnectionError instead of Exception
+* Remove outdated \_ as a builting from pylintrc
+* ProphetStor driver consistency group support
+* Turn on Flake-8 Complexity Checking
+* Log a warning when getting lvs and vgs takes longer than 60 seconds
+* Add client\_socket\_timeout option
+* IBM Storwize driver: Add local variable assignment to "ctxt"
+* Updated from global requirements
+* Multipath commands with error messages in stdout fail to parse
+* NetApp fix to set non default server port in api
+* Correct the message string
+
+2014.2
+------
+
+* Fix LVM iSCSI driver tgtadm CHAP authentication
+* Export cinder volumes only if the status is 'in-use'
+* Fix LVM iSCSI driver tgtadm CHAP authentication
+* Export cinder volumes only if the status is 'in-use'
+* Revert "Relocate volume to compliant datastore"
+* Remove vol\_type\_id cast to str
+* Move SolidFire driver from httplib to requests
+* check the configuration item glance\_num\_retries
+* VMware: Fix initialization of datastore selector
+* Imported Translations from Transifex
+* Fix exception handling on test\_delete\_nonexistent\_volume
+* check the configuration eqlx\_cli\_max\_retries
+* Revert "Relocate volume to compliant datastore"
+* Remove deprecated use of gettextutils import \_
+* Fix NetApp AutoSupport Shortcomings
+* HP 3PAR: Don't ignore extra-specs snap\_cpg when missing cpg
+* 3PAR migrate without losing type settings
+* 3PAR with pool-aware-cinder-scheduler
+* Fix display name change during backup restore
+* gitignore /.\*
+* Fixes docstring typos (Cinder)
+
+2014.2.rc2
+----------
+
+* Remove useless sslutils from openstack.common
+* Truncate fail\_reason to column length
+* Fix eqlx CLI output parsing on bad input
+* Eqlx fix NoSuchOptError for volume\_name\_template on clone
+* VMware: Bump driver version
+* Updated translations
+* NetApp fix eseries unit test mock clean
+* Make sure device support Direct before setting
+* Make sure device support Direct before setting
+* Eseries warn if multipath is not set for img xfer
+* GlusterFS: Remove unneeded conf import
+* ZFSSA iSCSI vol create fails with vol type option
+* Handle eqlx SSH connection close on abort
+* ZFSSA iSCSI driver cannot add multple initiators to a group
+* Fix race condition in ISCSIConnector \_disconnect\_volume\_multipath\_iscsi
+* Deprecate / obsolete NetApp volume extra specs
+* IBM Storwize driver: Retype the volume with correct empty QoS
+* Fixed Typo from modfied to modified
+* Updated from global requirements
+* Sync latest processutils from oslo-incubator
+* Imported Translations from Transifex
+* Updated from global requirements
+* coraid: allow setting default repository
+* Sync latest processutils from oslo-incubator
+* Windows SMBFS: Handle volume\_name in \_qemu\_img\_info
+* Refuse invalid qcow2 backing files
+* Windows SMBFS: Handle volume\_name in \_qemu\_img\_info
+* Refuse invalid qcow2 backing files
+* Clarify InvalidInput exception when the size is missing
+* Handle eqlx SSH connection close on abort
+* Deprecate / obsolete NetApp volume extra specs
+* Fix race condition in ISCSIConnector \_disconnect\_volume\_multipath\_iscsi
+* ZFSSA iSCSI driver cannot add multple initiators to a group
+* ZFSSA iSCSI vol create fails with vol type option
+* Open Kilo development
+
+2014.2.rc1
+----------
+
+* Fix race condition in ISCSIConnector disconnect\_volume
+* Adds openSUSE support for developer documentation
+* IBM Storwize driver: Retype the volume with correct empty QoS
+* VMware:Unquote folder name for folder exists check
+* VMware: cinder-volume create\_session fail at retry
+* Fixing format for log messages
+* Update /etc/cinder/cinder.conf.sample for memcache
+* VMware: Relocate volume to compliant datastore
+* Fix parameter miss in test\_snapshot\_metadata test case
+* Failed to re-detach volume when volume detached
+* Imported Translations from Transifex
+* IBM Storwize:Failed to retype from non-type to replication enable
+* Fix unnecessary WSGI worker warning at API startup
+* Remove XenAPI driver
+* Add required spaces in log messages
+* Fix ssh\_host\_key\_file default in help and config.sample.conf
+* Downgrade 'infinite' and 'unknown' capacity in weigher
+* Remove unused py33 tox env
+* Add unit test to cinder cgsnapshot api
+* DB migration 25->24 failed when dropping column
+* Allow scheduler pool information to be retrieved
+* Increase the 3PAR hostname length
+* Timeout triggers failures running tempest for ZFSSA driver
+* NetApp fix for default host type in eseries
+* HP 3PAR drivers should not claim to have 'infinite' space
+* Add tests for consistency groups DB migration
+* Verify requested size in volume.api create
+* Typo "asscoiated" should be "associated"
+* NetApp fix eseries unit test mock clean
+* Updated from global requirements
+* Set socket options in correct way
+* HP 3PAR: Allow retype when the old snapshot CPG (3PAR pool) is None
+* NetApp fix for controller preferred path
+* VMware: Add storage profile related unit tests
+* Check replication status failed for non-replication
+* VMware: Implement retype for VMDK driver
+* VMware: Improve datastore selection logic
+* Sync latest strutils from oslo-incubator for mask\_password fix
+* Remove executable bits on various files
+* Fix a problem with 'volume list' when 'all\_tenants=0'
+* IBMNAS: Remove call to set r/w permissions to all
+* Updated from global requirements
+* Getting iscsi\_ip\_address from cinder.conf
+* Handle config file with newlines and whitespaces
+* Volume types need to be specified when creating CG
+* Stop using intersphinx
+* Netapp drivers support for pool-aware scheduling
+* coraid: fix snapshot deletion
+* SQL scripts should not manage transactions
+* Add reset-state function for backups
+* Add test case for volume\_types.py
+* Block sqlalchemy-migrate 0.9.2
+* Destroy Datera export target after detach
+* EMC VNX Direct Driver Consistency Group support
+* Update oslo.config and oslo.messaging requirements
+* Fixes Windows Volume Driver upload volume fails
+* Log an error on nfs mount failure
+* Sync service.py and its dependencies to Cinder
+* HP 3PAR configurable ssh-host-key-policy
+* Fix confusing exception message in NetApp iscsi driver
+* Delete consistency group failed
+* Fixing leaking sessions in 3PAR on attach/detach
+* Add Windows SMB Volume Driver
+* Netapp: fix multiple copies of cinder-volume
+* Add SMB Volume Driver
+* Fix possible race condition for accept transfer
+* Imported Translations from Transifex
+* Mock glance client object in version unit tests
+* Revert iSCSI Target objects as independent objects
+* Use right body for test\_create\_missing\_specs\_name
+* remove object in wsgi LOG.info
+* Don't clear \_mounted\_shares list in remoteFS while updating
+* Some tcp configuration paramters are ignored
+* Add filter to volume transfer REST api
+* Fix help for running specified unit tests
+* Deprecate the V1 API
+* Set default pool value to system in gpfs driver
+* Fixes Cinder fails to upload volume to vhd image
+* Unit test for restore with different hosts
+
+2014.2.b3
+---------
+
+* During a restore send the restore request to the right host
+* Add Datera driver for Cinder
+* warn against sorting requirements
+* VMware: Remove redundant extend disk API call
+* VMware: Implement backup/restore for VMDK driver
+* Update the HP 3PAR default persona
+* Fixed Typo - from hypens to hyphens
+* Fixed typo from 'the the' to 'the'
+* Fix running unit tests with coverage
+* Support Volume Backup Quota
+* Volume Replication implementation for IBM Storwize/SVC
+* Add Fujitsu ETERNUS DX support
+* Pool-aware Scheduler Support
+* Small typos
+* Add QoS support to IBM Storwize driver
+* Fix unnecessary snap of glance image, with non-raw images
+* Driver for Fusion-io ioControl Hybrid array
+* Make ssh-host-key-policy configurable
+* Add Cisco FC Zoning plugin to the FC ZoneManager
+* Typo
+* Ignore pylint error 'hashlib' has no shaxxx member
+* Update oslo policy and its dependencies
+* Avoid using the disk cache on volume initialisation
+* Introduce Hitachi storage volume driver
+* XtremIO cinder iSCSI & FC volume drivers for Juno
+* Consistency Groups
+* Add retype method to xiv/ds8k driver interface
+* Fixes terminate\_connection live migration issue
+* Fixing 3PAR excessive FC port usage
+* Sync latest processutils from oslo-incubator
+* Sync latest strutils from oslo-incubator
+* Mock processutils.execute properly in test\_ibmnas
+* VMware: Disable suds caching
+* Adds volume replication methods to xiv/ds8k driver interface
+* Pass an empty context to the notifier
+* Add Oracle ZFS Storage Appliance ISCSI Driver
+* Add support in Cinder for volume replication - driver approach
+* EMC VMAX Driver Juno Update
+* Fix duplicate teardown to allow tox upgrade
+* Revert test\_rootwrap\_filter to avoid python2.6 test failure
+* Improve Cinder API internal cache interface
+* Allow backup-to-swift to take swift URL from service catalogue
+* Integrate OSprofiler and Cinder
+* Fix variable name in api/v<n>/snapshot.py
+* Honor volume:get policy
+* Extending IBMNAS driver to support NFS based GPFS storage system
+* GlusterFS: Use image\_utils for tempfile creation
+* Modify error code compatible with Mac OS
+* Cache snapshots in request for extension
+* Remove redundant temporary\_chown from IetAdm
+* Failed to initialize connection
+* Mock out image source file in image\_utils tests
+* Provide a quick way to run flake8
+* Ignore No value passed for parameter 'dml' message
+* Create RemoteFSSnapDriver class
+* VMware: Handle exceptions raised by image update
+* Adds barbican keymgr wrapper
+* Imported Translations from Transifex
+* Catch vol not found in SolidFire transfer
+* Fix LOG string formatting in image\_utils
+* Change the froce delete volume flage to True
+* Update ref used for notifications
+* HP 3PAR manage\_existing with volume-type support
+* Add iSCSI Target objects as independent objects
+* Rewrite ionice command filter using ChainingRegExpFilter
+* Use abstract class for the backup driver interface
+* Put result in quotes
+* Fix exception handling in PureISCSIDriver
+* Catch DBDuplicateEntry instead of IntegrityError
+* Enable import group hacking rule
+* Actually encode the SolidFire json dump result
+* Sync latest oslo-incubator log for debug fixes
+* Enable F402 checks and fix violations
+* Prevent tenant viewing volumes owed by another
+* VMware: Check snapshot and rename backing
+* Fix bad indentation in netapp and san.hp volume drivers
+* Ignore HTTP\_PROXY during test requests
+* Issue one SQL statement per execute() call
+* Add ProphetStor DPL Storage server volume driver for Cinder
+* Add timer info for copy operations
+* Make manage.py usable
+* Enable H104, F841 hacking rule and fix violations
+* Adds CA cert file path option for glance connections
+* Enable Swift backup driver for auth 2.0
+* Updated HACKING.rst so that it is accurate
+* Update help strings
+* Add hacking check for use of LOG.audit
+* Imported Translations from Transifex
+* Use oslo.i18n
+* Add CHAP support for 3PAR ISCSI
+* EMC: Fix minor issue in VNX driver and unit tests
+* fix a small typo in development.environment.rst
+* Do not translate debug messages
+* Fixing LeftHand live migration error
+* Improve regex for \_ import hacking check
+* General cleanup of unused objects
+* RPC client lazy initialization
+* Fix snapshot id for snapshot\_destroy
+* Use auth\_token from keystonemiddleware
+* Fixes wrong usage of mock.assert\_not\_called()
+* Fix error log level in restore-backup routine
+* Add retry\_on\_deadlock to db update methods
+* Fix unit test test\_import\_record\_with\_verify
+* Change the exception type for Storwize/SVC driver
+* VMware: Update default task\_poll\_interval value
+* Change logging level AUDIT to INFO
+* Fix solidfire accept\_transfer
+* VMware: Volume from non-streamOptimized image
+* Enable checks for E711, E712 and E713
+* Add note that some checks are disabled on purpose
+* VMware:Disk type conversion during clone backing
+* VMware:Support for attaching disk to backing
+* Change 3PAR delete message when volume is busy
+* Move generate\_password into volume utils
+* Move SSHPool into ssh\_utils.py
+* Fixes migrate\_volume\_completion
+* Change corrupted spelling mistakes
+* EMC VNX Direct Driver Update for Juno
+* Storwize/SVC can not get the right host
+* Skip incompatible test on OSX
+* Have task/flow logging go to a separate log file
+* fix atom link in XML Version API
+* Update ref used for notifications
+* Fix glance metadata SQL query performance
+* Add return of updated object on update from DB
+* fixing the iSER transport protocol when using LVMISERDriver
+* Add hacking check for vim headers
+* Get updated model info on volume transfer
+* Introduce iSCSI driver for Pure Storage FlashArray
+* Further cleanup of reservations index
+* Sync log from oslo-incubator for isEnabledFor fix
+* Modify the index migration slightly for backport
+* Remove cinder-clear-rabbit-queues
+* Remove cinder-rpc-zmq-receiver
+* Remove reattach function in cinder-manage
+* Set python hash seed to 0 in tox.ini
+* HP 3PAR retype implementation
+* Add index for reservations on (deleted, expire)
+* Remove Hyper-V dependency in the Windows Cinder Volume Driver
+* Fix no handlers could be found issue
+* Add storageHost content to volume messages
+* Add hacking check for explicit import of \_
+* Make manage/unmanage admin only
+* Avoid OSError in get\_blkdev\_major\_minor with network filesystems
+* VMware:Support for create disk and disk descriptor
+* Implement import/export for SolidFire Driver
+
+2014.2.b2
+---------
+
+* Implements new 'bootable' option for manage existing volume
+* Add hacking test
+* Fixes Cinder volume upload to image on windows
+* Add explicit import of \_ to hp\_3par\_fc and iscsi
+* Adds storwize\_svc\_npiv\_compatibility\_mode flag to Storwize/SVC driver
+* Switch to use oslo.db
+* Add additional explicit imports of \_ where needed
+* Fix failure of source volume deletion in migrate\_volume\_completion
+* Remove hard coded reference from gettextutils.py
+* Enable lazy translation for Cinder
+* Explicitly import \_() in Cinder code
+* Fix performance issues with brocade zone driver
+* Don't leave snapshots on the floor
+* Add some log info for NoValidHost
+* Use immutable default values for args
+* Update cinder generate\_sample script
+* XIV volume manage/unmanage support
+* Add affinity/anti-affinity filters
+* Bump oslo.rootwrap to 1.3.0.0a1 for Cinder
+* Mock out time.sleep in storwize unit tests
+* Fix the section name in CONTRIBUTING.rst
+* Cinder-api service throws error on SIGHUP signal
+* Clean up base Volume Driver
+* Fixes EqualLogic volume live migration
+* Correct misspelled word
+* Remove definition of Python Source Code Encodings
+* Fixed some typos in the cinder codebase
+* Sync gettextutils.py from oslo-incubator
+* Use PyCrypto to generate randomness passwords
+* Remove $sqlite\_db from default database connection
+* Sync processutils and log from oslo
+* Configure write cache option of tgtd iscsi driver
+* Enhance docstring for iscsi\_helper
+* Updated from global requirements
+* Ensure FC ZoneManager is called
+* Remove cinder.context warning logging
+* sync periodic\_task fix from incubator
+* Slow down Storwize driver initialization
+* Updated from global requirements
+* Imported Translations from Transifex
+* Imported Translations from Transifex
+* volume\_image\_metadata missing from volume list
+* Correct lvm\_mirrors help message
+* Ceph rbd volume manage/unmanage support
+* Enable E121,E122,E123,E126,E128 hacking rules
+* Replace tearDown with addCleanup - Part 3
+* Fix begin\_detach logic
+* Use (# of CPUs) osapi\_volume\_workers by default
+* Restore osapi\_volume\_workers config option
+* Fix host option isn't set when using multiple backend
+* Add optional\_args to fix Volume Import failure
+* 3PAR Only remove FC Zone on last volume detach
+* Ensure rbd connect exception is properly caught
+* Add cinder-manage cmd to update host column
+* Add cinder volume driver support for Nimble Storage
+* Sync processutils from oslo with deps
+* Synced jsonutils from oslo-incubator
+* Enable hacking rule E111,E112,E113
+* Bump minimum hacking version to 0.9.2
+* Only warn about deprecation warnings once
+* Fix dropped exception for create\_export in vol manager
+* Misuse of i18n log translation to output error message
+* Support Volume Num Weighter
+* Fix docstring for snapshots API
+* Don't use ModelBase.save() inside of transaction
+* Fix unsaved exception in backup/drivers
+* 3PAR volume manage/unmanage support
+* Add cgroups related commands to rootwrap filters
+* Use a task subclass instead of a functor + task wrapper
+* Fix BrcdFCSANlookupService to iterate multiple switches
+* GlusterFS: Handle deletion of snapshot with no backing file
+* Fixed data copy issue of volume/driver.py
+* Make rbd driver string encoding checks consistent
+* Remove check\_volume\_az\_zone functor and associated passing
+* Minor cleanups in test\_volume
+* Fix retyping attached volumes requiring migration
+* Update \_resize\_volume\_file() to support appropriate permissions
+* test\_storwize\_vdisk\_copy\_ops fails if green thread context switch
+* VMware:Fix params for copy-image-to-volume
+* VMware: Optional create backing parameters
+* Fixes cinder volume from snapshot on Windows
+* Fixes cinder volume create on Windows Server 2012 R2
+* Fixes cinder volume from image on Windows
+* Use oslo-incubator module units
+* Attach log listeners to other engines
+* Adding filter options to backup list
+* Remove global conf settings from iscsi helper
+* Add genconfig tox job for sample config file generation
+* Fix nfs\_shares config file parsing of spaces
+* GlusterFS: Various unit test improvements
+* vmware: Force chunked transfer for upload-to-image
+* Sync the latest common db code from oslo
+* Fix order dependency of admin metadata
+* GlusterFS tests: Mock out compute, don't load novaclient
+* Updated from global requirements
+* debug level logs should not be translated
+* Implement extend volume in NFS driver
+* Fixes an issue with 'dd' bug from Illumos repo
+* Handle the case where az is disabled/removed
+* I/O rate limit for volume copy with qemu-img convert
+* I/O rate limit for volume copy with dd
+* glusterfs: Honor mount options when restarting cinder service
+* Add keyword argument missing at some exc.HTTPError subclass
+* Made provision for providing optional arguments
+* Removes unecessary call to rbd.Image
+* Add task/flow listener support around the volume api flow
+* Retry lvremove with ignore\_suspended\_devices
+* Allow reset-state on attach and migration fields
+* Implements HDS-Cinder HNAS Drivers
+* vmware: Fixes VMDK volume incompatibility issue
+* Remove unused oslo module and adjust opentstack-common.conf
+
+2014.2.b1
+---------
+
+* Copy custom properties to image from volume
+* Add strip size support to rbd driver
+* Fix log capturing fixture
+* Fix Brocade FC driver's use of the fc\_fabric\_names
+* LIO: Don't add ACL for local initiator name
+* Delete image on upload-to-image failure
+* Ensure flushing of IO prior to removing FC device
+* Fixed the comment spelling error - voumes to volumes
+* Remove Quota Exception Stack Traces from Cinder Logs
+* Use os.urandom in volume transfer
+* Remove check\_{attach,detach} from volumes API
+* Make begin\_detaching fail if volume not "in-use"
+* hp\_lefthand\_rest\_proxy no handler for logger during tests
+* 3PAR volume detach with host in a host set
+* Update cinder.conf
+* Sync periodic\_task from oslo-incubator
+* Remove second get call to list/show volumes
+* Fix a message format error in migration cleanup
+* Add support for z/VM driver
+* Handle volumes no longer existing in resume delete
+* Fix ISER scan retry option
+* Only create volume with an active image
+* Updated from global requirements
+* Ensure metadata is saved before updating volume status
+* Add XML deserializer for qos\_manage delete\_keys API
+* Use error instead of warning to log mount exc
+* Allow host config to be overriden in backend
+* Remove all mostly untranslated PO files
+* Updated from global requirements
+* Remove create\_from\* functor jump table
+* SSHPool in utils should allow customized host key missing policy
+* Check whether O\_DIRECT is supported to iflag and oflag separately
+* Set volume usage audit period to not NoneType
+* BrcdFCSanLookupService should allow customize host key and policy
+* NetApp fix eseries concurrent vol map failure
+* NetApp fix attach fail for already mapped volume
+* Imported Translations from Transifex
+* Convert SolidFire Capacity response to GiB
+* eliminate the need for hplefthandclient in tests
+* Fix solaris\_execute in SolarisISCSIDriver
+* Fix for solidfire driver to use reserved\_percentage
+* Fix retyping volume that has volume type None
+* eliminate the need for hp3parclient in tests
+* Add missing methods to FakeISCSIDriver
+* Add mailmap entry
+* Fix wrong exception reference
+* Limit formatting routes when adding resources
+* Use oslo network utils function to set tcp\_keepalive
+* Properly initialize rpc in cinder-volume-usage-audit
+* Add exception handling for copy\_volume\_to\_image()
+* NetApp NFS: Do not reference dst\_img\_local before assignment
+* Remove explicit dependency on amqplib
+* Fixes an issue with 3PAR attach
+* Ensure that lun\_id is an int
+* Implement validate\_connector in FibreChannelDriver
+* Fix broken version responses
+* Fix double "the" in Cinder quota warning
+* CinderException args to strings when exceptions
+* Fixed 3PAR driver issue finding correct vlun
+* Storwize/SVC driver detach volume failed
+* Add disabled kwarg to service\_get\_all\_by\_topic
+* Add rally job
+* Improve consistency of help strings
+* Remove unused volume instance\_uuid methods
+* Cinder list does not filter admin metadata
+* Specify lld in tgt config backends
+* Replace tearDown with addCleanup - Part 2
+* Keep volume available if retype fails due to quota
+* Remove unused 3PAR driver method
+* Fix bad indentation in tests
+* Add set-bootable command
+* Fix handling multiple WWPNs on preferred FC node
+* Fallback to None on missing Glance image attrs
+* Remove old driver mappings from Havana
+* Adjust sample config for keystoneclient 0.8.0 release
+* Remove unused reservation methods from db.api
+* Re-raise exceptions in upload-to-image
+* Update Cinder dev doc
+* vmware: Fix problems with VIM API retry logic
+* Create volume fail when image id is ""
+* Use cached db object in volume\_mig\_status ext
+* Add exception catch if Storwize/SVC driver failed when retyping
+* Replace tearDown with addCleanup - Part 5
+* Replace tearDown with addCleanup - Part 4
+* Enable flake8 H303,H304 checking
+* Storwize/SVC driver crashes when check volume copy status
+* Switch over to FixedIntervalLoopingCall
+* Correct metadata ordering issue in tests
+* driver.create/remove\_export() require elevated context
+* Inform about instance\_uuid in volume usage notification
+* Check for silent failure of tgtadm remove
+* GlusterFS: Delete active snapshot file on volume delete
+* Fixes HP LeftHand driver with Paramiko 1.13.0
+* Fixes cinder error state volume delete on Windows
+* Added unit test cases for \_is\_share\_eligible in NFS driver
+* Log initialize\_connection error before remove\_export
+* Force detach should only be an admin api
+* Updated from global requirements
+* Change iogrp property when retyping for Storwize/SVC
+* Check that all po/pot files are valid
+* Allow deprecated volume update keys in v2
+* \_translate\_from\_glance() can cause an unnecessary HTTP request
+* Adds ionice command permutations to rootwrap filters
+* Append nas\_opts to IBMNAS\_NFSDriver configuration
+* Enable flake8 F841 checking
+* GET details REST API next link missing 'details'
+* GlusterFS: Delete volume-<uuid>.info file when volume is deleted
+* Fix Jenkins translation jobs
+* Fixes HostTestCase failures due to slow test run
+* Imported Translations from Transifex
+* Updated from global requirements
+* Fixes cinder volume delete on Windows
+* Fixes cinder volume attach on Windows
+* Open Juno development
+
+2014.1.rc1
+----------
+
+* Imported Translations from Transifex
+* Changes to correct name of missing NetApp license
+* NetApp cmode nfs: Fix QOS extra spec
+* NetApp cmode iscsi: Fix QOS extra spec
+* Fixes a problem in attach volume in EMC driver
+* Update config generator from OSLO
+* Pass the mirrorlog option as two arguments
+* Import request\_id middleware bug fix from oslo
+* Netapp iscsi: allow snapshots with unspecified block range
+* Serialize the notification payload
+* Disable oslo.messaging debug logs
+* Updated from global requirements
+* Update tests to use CONF.set\_override
+* Adds xiv\_chap to xiv/ds8k driver configuration
+* vmware: Use SessionIsActive to find stale session
+* init\_host should be called before RPC consumer is created
+* Add RequestContextSerializer for rpc notifications
+* Allow NetApp iSCSI driver to sub-clone large volumes
+* Can't force-create snapshot by an non-exist error volume
+* Remove rootwrap module
+* Simplify test force delete snapshot unit test
+* ceph backup driver: improve log messages
+* resolve KeyError for IBM Storwize/SVC driver
+* vmware: Remove deprecation warning from VC driver
+* Remove unused method from NetApp iscsi driver
+* vmware: Remove pbm\_default\_policy config option
+* VMware: Implement vmdk extend\_volume
+* Fix create\_export/remove\_export in driver.py
+* Imported Translations from Transifex
+* vmware:Ignore inaccessible/inMaintenance datastore
+* Ensure name is utf-8 when deleting rbd vol or snap
+* Use six.moves.urllib.parse instead of urlparse
+* Use the error\_out\_volume from flow common instead
+* Revert "Re-enable lazy translation"
+* Sync latest Oslo code for imageutils
+* Don't send untextified exc to webob
+* Imported Translations from Transifex
+* Updated from global requirements
+* Use debug level logging during unit tests
+* Sync log.py from oslo-incubator
+* Fixed some FCZM unit tests hacking issues
+* Add missing config values for vmwware\_vmdk test
+* cinder-rtstool imports a not existing module
+* get volumes with limit and filters does not work
+* Fixes cinder-volume service startup on Windows
+* Fixed nova VM live migration issue with 3PAR
+* Adding domain to context
+* Switch over to oslosphinx
+* Add libffi-dev to list of packages to install in dev env
+* VMware: Take the volume size from the user input
+* Fix exception message of CoraidESMConfigureError
+* vmware: Mark VMware ESX vmdk driver as deprecated
+* Fixes ssh-injection error while using chap authentication
+* Generate config samples for oslo.messaging
+* Add conversion types in some strings
+* Port to oslo.messaging
+* Updated from global requirements
+* get volumes API does not handle limit=0
+* EMC SMI-S delete snapshot unit test takes too long
+* 3PAR: Support extend volume based on snapshot
+* Fixed spelling error - accomodate to accommodate
+* GPFS unit tests: increased coverage, uses mock
+* Clean Up EMC VNX Direct Driver in Cinder
+* gpfs driver: fix logging problems
+* Convert cinder utils tests to use mock
+* Include next link when default limit is reached
+* Re-enable lazy translation
+* Sync latest Oslo config code for i18n
+* Fix HP LeftHand Performance issue with AO
+* NetApp implementation for copy offload in clustered nfs driver
+
+2014.1.b3
+---------
+
+* Remove str() from LOG.\* and exceptions
+* Storwize volume manage/unmanage support
+* Volume manage/unmanage support
+* Add user defined extra capabilities
+* remove \_check\_container\_exists from Swift backup driver
+* Add initiator\_target\_map for IBM Storwize/SVC
+* Fix HP LeftHand migration with snapshots
+* Updated from global requirements
+* Fix docstring ordering
+* Typo corrections for test files in cinder
+* vmware: PBM wsdl file configuration
+* vmware: default global pbm policy configuration
+* vmware: check datastore availability during create
+* vmware: Storage policy based volume placement
+* Add EMC VNX Direct Driver in Cinder
+* gpfs volume driver backup file access fixes
+* Check if snapshot is deleted cleanly
+* Restrict rootwrap find filter for IBM NAS and GPFS
+* Add initiator target map in EMC SMI-S FC driver
+* GlusterFS: Set permissions on qcow2 snapshot files
+* Make EMC SMI-S driver unit tests faster
+* change time.sleep to use loopingcall
+* Change RBD delete failure log level to warn
+* Updated from global requirements
+* Update Oslo wiki link in README
+* Add versioning output for the FC Zone Manager
+* Fix volume stats with multiple LeftHand clusters
+* Export and import backup service metadata
+* Don't clear host\_state\_map when scheduling
+* Add volume metadata backup suport to swift driver
+* Add optional ionice to volume clearing process
+* Quota delete operation in cinder
+* Restrict rootwrap find filter for NetAppNFS driver
+* GlusterFS: Increase snapshot delete job timeout to two hours
+* Segment LUN clones in NetApp iSCSI
+* updating testing readme with more current information
+* Remove unused variable
+* Python 3: replace "im\_self" by "\_\_self\_\_"
+* Update FibreChannel Zone Manager config
+* Change warning message in NetApp driver for vsadmin creds
+* 3PAR: Fix extend volume GiB to MiB
+* TSM backup driver changes to support file backup
+* Fix silly error in comment
+* 3PAR: Create volume from snapshot with larger size
+* Fix free\_capacity reporting in SolidFire driver
+* Fix test\_delete\_should\_not\_.. to assert something
+* Replace assertEqual(None, \*) with assertIsNone in tests
+* Replace tearDown with addCleanup
+* Use six.StringIO instead of StringIO.StringIO
+* Implement retype in IBM GPFS Driver and refactor
+* 3PAR: Delete missing snapshot stuck in error\_del
+* Added 3par initiator target map for FCZM
+* Fix race in test\_delete\_backup
+* Driver for IBM SONAS and Storwize V7000 Unified
+* Fix webob.exc.HTTPForbidden parameter miss
+* Add snapshot related data to limits api
+* Storwize/SVC: Change volume copy task to async
+* Fix FC connection handling in the storwize driver
+* Sync log.py from oslo
+* Replace httplib.HTTPSConnection in unittests
+* Add support for FC zone lifecycle management
+* Give a way to save why a service has been disabled
+* Remove old driver mapping deprecation
+* 3PAR: Backend assisted volume migrate
+* Add HP MSA Fiber Channel driver
+* Ensure return for db api functions
+* HP LeftHand Backend assisted volume migrate
+* Add support for qos\_specs feature to 3PAR drivers
+* Add x-openstack-request-id to cinder responses
+* Update 3PAR drivers to pass cert test
+* Remove unused function
+* Use len instead of for-loop to get the end index
+* Ensures NetApp iSCSI driver correctly compares int values for size
+* Sync request\_id, request\_utils for cinder
+* IBM XIV and DS8000 Driver reorganizing (IBM dir)
+* Sync oslo imageutils, strutils to cinder
+* GPFS:  Implement volume backup and restore
+* Fix missing package dependency for requests
+* test\_volume unittest fails if ran only this module
+* Fix invalid facilities documented in rootwrap.conf
+* Use six.moves cStringIO instead of cStringIO
+* NetApp api fix structure conversion methods
+* Add support for backing up volume metadata
+* Imported Translations from Transifex
+* Replace assertEqual(None, \*) with assertIsNone in tests
+* Add encrypted flag to volumes
+* Implement retype in HP LeftHand driver
+* Cast the quota set values to integer before checking their validity
+* Remove rabbit\_notifier (Sync notifier with oslo d6e1ba7)
+* Remove dependent module py3kcompat
+* Add EMC SMI-S FC Driver in Cinder
+* Fix wrong example of "nova\_endpoint\_template"
+* NetApp eseries iscsi driver implementation
+* Update gpfs driver volume creation process
+* Deactivate LV before removing
+* VMware: changing volumeops tests from mox to mock
+* Remove unused exception
+* Add searchDepth when getClusterInfo called
+* Check type argument on create from source and snap
+* Rename Openstack to OpenStack
+* Removes use of timeutils.set\_time\_override
+* Removed unused context in \_extend\_snapshot method
+* Remove unused methods
+* Storwize/SVC: Check wwpn not None
+* Changes to cast variable as integer as XML API fails
+* Ceph backup driver tidyup
+* Move create\_, remove\_ and ensure\_export from drivers
+* New HP LeftHand array iSCSI driver
+* GlusterFS: Fix create/restore backup
+* Allow operators to customize max header size
+* Fixup persistence file not found on tgt remove
+* Remove tox locale overrides
+* Add method for unit tests to set logging level
+* Brick support for pNFS
+* Storwize/SVC: Fix races in host-related functions
+* Fix cinder-backup volume restore with ceph driver
+* Dont set error\_extending status on API extend call
+* Fix misspellings in cinder
+* Fixes cinder failed to create/restore a backup with NFS driver
+* Brick fix BrickException message formatting
+* lvm: unhandled exception when migrating volume
+* Implement retype in SolidFire driver
+* Validate the quota in the API layer for volume extend
+* Rename self.tgtadm to self.target\_helper
+* Fix LVM migrate\_volume tests
+* Brick connector fix for GlusterFS
+* Updated from global requirements
+* vmware: intermittent failure in test\_vmware\_vmdk
+* RBD unit test improvements
+* Move clear\_volume back to it's own method
+* Don't use shred for volume\_clear=zero
+* Nexenta iSCSI driver: fixed volume\_migration
+* Move clear\_volume method to volume.utils
+* Add update support to volume type encryption
+* LVM: log thin pool name and size upon creation
+* Remove create\_export from volume create
+* vmdk: To add missing time unit in driver option
+* Update SolidFire Driver to use cinder's units
+* Update cinder.conf.sample for new keystone client
+* LVM: remove redundant casts to float
+* On create\_volume flow get rid of host parameter
+* Imported Translations from Transifex
+* Allow spaces in host names in the storwize driver
+* Remove a catching exception during delete\_volume
+* Remove SSH code from 3PAR drivers
+* Remove unused task from manager create\_volume flow
+* Add support for special char in volume metadata
+* Brick LVM: Handle space info as numeric types
+* Set a sane default for state\_path
+* Fixes incorrect key in dictionary
+* Stop volume\_type\_encryption creation when in use
+* Revert initialize\_connection changes
+* Convert ceph backup unit tests from mox to mock
+* VolumeManager: initialize even if a volume can't be found
+* Add create\_iscsi\_target stub to TargetAdmin
+* 3PAR iSCSI volumes attach to single nsp
+* Extra\_spec containing '/' can't be deleted
+* LVM: Robustify skipactivation detection
+* Make sure report\_interval is less than service\_down\_time
+* Redundant check in os-migrate\_volume\_completion
+* Updated error messages for volume clone
+* Imported Translations from Transifex
+* Updated from global requirements
+* Fix up the way we do iqn variable in unit test
+* Catch new iscsi exception
+* Delete volume transfer in volume\_destroy function
+* Create structure of flows' packages
+* Fix docstring and remove unused variable
+* GlusterFS: Fix deadlock in volume clone
+* Enable multi-process for API service
+* Sync RPC module from Oslo
+* Sync common modules from Oslo
+* Sync py3kcompat, sslutils, versionutils from Oslo
+* Sync gettextutils from Oslo
+* Storwize driver cleanup
+* Add support for retype in Storwize/SVC driver
+* Add notifier events to cinder volume rename, reset-state
+
+2014.1.b2
+---------
+
+* Convert RBD unit tests to use mock instead of mox
+* Fixed inconsistency in iqn
+* Update HACKING.rst with regard to mock usage
+* Remove unused method 'is\_key\_value\_present()'
+* Remove unused config options
+* Remove unused exceptions
+* Do not show quota of removed volume types in Default Quotas panel
+* Fix up calculating space info for mirrored volumes
+* Rename \_\_init\_\_.py to create\_volume.py
+* Use oslo.rootwrap library instead of local copy
+* Fix UnboundLocalError in TgtAdm.update\_iscsi\_target
+* Update host on driver retype
+* Remove unused variable in restore\_backup method
+* Ensure hostnames are converted to IP for comparison
+* Add Backup Service to 'cinder-all' script
+* Remove env from rootwrap filter
+* Allow user to specify audit period
+* Fix exception log msg in attach volume method
+* Fix import log\_handler error with publish\_errors set
+* Use a mirrored mirror log
+* Added missing accept\_transfer to FC
+* Register EMC config options globally
+* Fix os.getlogin() problem with no tty
+* Updates for version list to show correct references
+* Fix cross-import bug in cinder.db.sqlalchemy.api
+* Pull Bug #1263122 fix for service module from Oslo
+* Pull latest scheduler change from Oslo
+* Use loopingcall from openstack-common
+* Use a \*args pass-in instead of a list one
+* Remove unused variable in os-extend api
+* GlusterFS: Synchronize additional operations
+* Move driver initialization check into the method
+* Update cinder.conf.sample for keystoneclient change
+* Transfer creation doesn't support 'name' via xml
+* Change default policy for volume\_extension:volume\_tenant\_attribute
+* Print driver exception on retype
+* Drop Chance/SimpleScheduler Implementation
+* Fix sqlalchemy bug in transfer\_get\_all\_by\_project
+* Fix sheepdog copy\_image\_to\_volume method
+* NFS/GlusterFS: Skip incorrectly formatted shares
+* Remove unused message from iogrp\_data setup
+* Remove legacy config option 'connection\_type'
+* Modify default prefix for solidfire account
+* Add time\_type dictionary to test\_migrations
+* 3PAR: Raise Ex when del snapshot with depend vol
+* Add bool\_type dictionary to test\_migrations
+* Hiding postgresql password in connection string
+* Fixed a problem in iSCSI multipath
+* Fix the invalid argument of webob.exc.HTTPBadRequest
+* Add ability to modify volume type
+* Fix downgrade in 002\_quota\_class.py for MySQL
+* Removed deprecated config option hp3par\_domain
+* Fix Brick LVM test command parsing
+* Update V2 API to return detailed volume information on create
+* LVM: Fix "intialized" typo in warning msg
+* Imported Translations from Transifex
+* removed unused context in check\_\*\*\* methods
+* add 'force' verification in \_volume\_upload\_image
+* Raise max header size to accommodate large tokens
+* LVM: update iscsi target on volume attach
+* LVM: Activate Thin Pool LV upon initialization
+* GlusterFS: Use correct base argument when deleting attached snaps
+* Switch to Oslo's config generator
+* Removed copyright from empty files
+* Remove unused fake\_flags
+* Replace Simple/Chance Scheduler with FilterScheduler
+* Reduce the redundant variable declarations
+* Imported Translations from Transifex
+* Remove vim header
+* Redundant size check in volume restore api
+* Add AllocatedCapacityWeigher
+* Imported Translations from Transifex
+* Adding helpful URL links to README.rst and HACKING.rst
+* Handle terminate\_connection() exception in volume manager
+* Empty files shouldn't contain copyright nor license
+* Bugfix missing foreign key removal for mysql
+* Fix spelling errors
+* Imported Translations from Transifex
+* Add additional metadata as key-value pairs in 3PAR
+* Handle initialize\_connection() exception in volume manager
+* Output Strings of bin/\*.py should support i18n
+* Add qos\_specs support to solidfire driver
+* Service launcher method docstring corrected
+* Fix QoS information in initialize\_connection() result
+* Fix and enable gating on F401
+* Only reverify backing lun when create backing lun
+* Set volume\_dd\_blocksize configurable on per-driver basis
+* Add exception logging if flow creation fails
+* Remove dynamic default on sf\_account\_prefix
+* make delete recovery messages debug level
+* Remove unused code from volume manager (reset\_stats)
+* Pylint fixes for GlusterFS driver
+* Pylint fixes for Brick iSCSI/LVM
+* 3PAR FC: add ability to add WWNs to host
+* Imported Translations from Transifex
+* Adjust import order according to PEP8 imports rule
+* Do not clone non-raw images in rbd backend
+* Adds unit tests for drivers.rbd.RBDImageIOWrapper
+* [Netapp/Nexenta] Move registration of config options
+* Fix and enable gating on H402
+* LVM: Activate source snap LV when cloning from volume
+* Remove test that was no longer used for long
+* make help text more meaningful for cinder docs
+* Switch create volume commands to Taskflow 0.1.1
+* Use mock for scheduler tests
+* Remove LANG=C from rootwrap invocations
+* Add the driver name to get stats log output
+* Remove hashbang (#!) at beginning of python modules
+* Fix KeyError while generating a WSGI response
+* Updated from global requirements
+* Lazy log the fixed\_key warnings
+* Add disabled\_reason field to services table
+* Catch TypeError when new\_size is None on extend
+* Sync matchmaker\_ring.py from oslo-incubator
+* Add RBD test for volume not existing during delete
+* Sync rpc fix from oslo-incubator
+* Returns thin pool free space calculated from actual usage
+* Brick LVM: Set C locale when gathering PV info
+* LVM migration: Check if name is equal to dest\_vg
+* Convert lvm\_mirrors to int
+* LVM migrate: Use keywords for the brick instance
+* LVM: Create thin pools of adequate size
+* GlusterFS: Remove glusterfs\_disk\_util option
+* Catch ImageBusy exception when deleting rbd volume
+* Adds lock for create from vol/snap to avoid race conditions
+* Fix docstring for snapshot\_metadata controller
+* Fixes case insensitive for resp body
+* VMDK:Using host mount info for datastore selection
+* Fixes case insensitive for resp body
+
+2014.1.b1
+---------
+
+* All API controllers inherit from wsgi.Controller
+* delete.start/delete.end notification for hostless
+* Fix typo/misspelled words
+* Update hacking to hacking>=0.8.0,<0.9
+* Add more logging to migrate\_volume\_completion
+* Use model\_query() in db.\*\*\*\*\*\_destroy
+* Change method name to test\_get\_volume\_stats
+* Adjust RBD delete log level
+* Bump to sqlalchemy-migrate 0.8.2
+* Add unit tests for volume reserve and unreserve
+* Don't stop volume service for failed re-export operations
+* GlusterFS: Complete snapshot\_delete when info doesn't exist
+* Fix typo in cinder
+* Imported Translations from Transifex
+* Add attach/detach notifications
+* Removes dublicated assert from test\_migrations.py
+* Use assertAlmostEqual instead of failUnlessAlmostEqual in unit tests
+* Fixing check order for empty body in get\_body()
+* Updates .gitignore
+* Remove unused import and CinderNode sqlalchemy model
+* Fix suppressed exceptions for migration downgrade
+* Fix the wrong verification for 'readonly'
+* Parse out '@' in volume['host'] to do discovery
+* Add volume migration code to Nexenta iSCSI volume driver
+* Handle NotFound exception in snapshots API code
+* Add chance weigher to scheduler
+* Redundant body validation for volume\_upload\_image
+* Imported Translations from Transifex
+* Fix Storwize terminate\_connection with no host
+* Fix \_update\_volume\_stats typos
+* Remove the redundant judgment for 'restore'
+* Make volume\_glance\_metadata\_create compat with DB2
+* GlusterFS: Set correct permissions for volume file created via clone
+* GlusterFS: Ensure Cinder can write to shares
+* The param 'readonly' is incorrect checked
+* Fix docstring for Snapshot model
+* Make sure report\_interval is less than service\_down\_time
+* Ensure 'status' in update\_snapshot\_status
+* Update openstack/common/periodic\_task
+* Initialize and terminate connection raise 500 err
+* Fix docstring for \_migrate\_volume\_completion
+* Migrate volume should check para "host" in request
+* Continue to delete volumes that DNE in rbd backend
+* Pull latest service module from Oslo
+* Add greenthread.sleep() to parent wait()
+* Fix ./run\_tests.sh -V --virtual-env-name
+* Pass the size when fetching image in xenapi driver
+* Remove unused code in test\_admin\_actions.py
+* Add support for extend volume in GPFS vol driver
+* Remove dead code from test\_get\_volume\_stats()
+* Remove suffixes from LVM brick test vgs output
+* Subclass vendor specific exceptions
+* Don't do glance v2 calls when config is set to v1
+* LVM: Activate source LV before cloning from it
+* Add default quota class into DB during migration
+* To fix test\_get\_dss\_rp in test\_vmware\_vmdk.py
+* Fix typo in cinder.volume.API
+* NetApp fix for vsadmin role failure for ssc
+* Create snapshot throws 500 Internal Error
+* Fixes inappropriate error message
+* NetApp fix free space as zero during 1st vol stats update
+* Add valid check and unit tests on quota class
+* GlusterFS: Synchronize operations that manipulate qcow2 data
+* Check only our VG name when testing if VG exists
+* Update quota-set throw 500 error
+* Using HttpNfcLease to transfer vmdk files
+* Adds extend volume to Dell EqualLogic Driver
+* Remove the use of common.uuidutils.gen\_uuid
+* Imported Translations from Transifex
+* Do not allow bad keys while updating quota
+* Use cached volumes in REST API extensions
+* Enable object caching in cinder REST API requests
+* Nexenta iSCSI driver: extend volume stats of \_update\_volume\_stats
+* Fail when image is bigger than the volume
+* Update URL for global HACKING document and remove duplicate section
+* Retrieve volume image metadata using single query
+* Add call to retrieve image metadata for volumes in bulk
+* Do not remove volume silently if GPFS is unmounted
+* Report zero capacity if GPFS is unmounted
+* Nexenta NFS driver refactoring
+* RequestContext initialization failed in cinder
+* Nexenta: Remove snapshot after volume-clone deletion
+* Don't use deprecated module commands
+* Remove dup of LVMISCSIDriver in LVMISERDriver
+* Remove duplication of ISCSIDriver in ISERDriver
+* Support volume\_readonly\_update using XML format
+* Fix typo in test\_check\_ssh\_injection\_on error test
+* Remove lvm-thin pool\_size config option
+* Examine if GPFS is mounted before writing data
+* Imported Translations from Transifex
+* Remove unused db calls to fetch original metadata
+* replace u\2013 char with dash
+* Sync log from oslo
+* Add tests for LVM -cow clearing
+* clean up numeric expressions in test
+* Fixes typo in method name \_notify\_voloume\_type\_error
+* Allow spaces in quoted SSH command arguments
+* Use pipe between ceph backup diff export/import
+* Imported Translations from Transifex
+* Add missing space to num\_iser\_scan\_tries text
+* Add cinder.db.migration.db\_initial\_version()
+* remove rundundant lockfile requirement
+* Imported Translations from Transifex
+* Revert "Brick connector fix for NFS drivers"
+* Update my mailmap
+* GlusterFS: set correct filename when cloning volume
+* Handle NotFound exceptions in API
+* Unit test fails in pbuilder environment
+* Updated from global requirements
+* Check if dir exists before calling listdir
+* Rename "rtstool" to "cinder-rtstool", add dep
+* Downgrade target create failure mesg to warning
+* Nexenta iSCSI driver: Refactor create\_cloned\_volume
+* VMware: Registering vmdk opts in global space
+* Brick connector revised fix for NFS drivers
+* Nexenta drivers ignore "does not exist" exception
+* Add openstack/common/crypto from OSLO
+* Fix volume transfer href issue
+* Remove duplication of brick.iscsi in brick.iser
+* Drop auth\_token configs for api-paste.ini
+* NetApp unit test fail fix for http\_proxy
+* Revert "remove cinder-rtstool because of rtslib dep"
+* Let GPFS driver to rename snapshot with root permission
+* Imported Translations from Transifex
+* NetApp fix for 7mode iscsi volume stats
+* Brick connector fix for NFS drivers
+* NetApp fix ssc volume filtering inconsistency
+* Updated from global requirements
+* NetApp fix mirrored stats
+* NetApp fix for compression and dedup stats
+* Fix generate conf script can't handle multistropt
+* Add auth\_token settings to cinder.conf.sample
+* Add extend\_volume for Huawei drivers
+* Update openstack/common/notifier
+* Imported Translations from Transifex
+* Apply six for metaclass
+* Provide gettext \_ in missing locations
+* Nexenta NFS driver: caching for appliance volroot
+* Cinder extension to add used resources in absolute limits
+* Fix Huawei HVS driver AttributeError
+* Storwize: Fix iogrp availability check
+* Imported Translations from Transifex
+* Uses oslo.imageutils
+* Don't zero out thin provisioned LV's on delete
+* Fix lvm.extend\_volume to pass Gig suffix
+* Nexenta NFS volume driver folder auto sharing
+* FK lookup failures during migration
+* Initialize shares variables for RemoteFsDriver(s)
+* Fix indentation errors in drivers
+* Imported Translations from Transifex
+* Fix Huawei drivers to support other host OSs
+* Fix all occurences of H404 Hacking warning
+* Imported Translations from Transifex
+* VMware: Fixed upload-to-image for available volume
+* Refactor Nexenta iSCSI driver
+* Remove unused 'initiator' imports
+* Fix tests to work in debug mode
+* Updated from global requirements
+* Remove whitespace from cfg options
+* Remove option count from sample configuration
+* improves lvm version parsing for customised builds
+* Fix typo in cinder.volume.drivers.nexenta.\_\_init\_\_
+* Remove obsolete redhat-eventlet.patch
+* long flashcopy operation may block volume service
+* Support Huawei driver upgrade from grizzly to havana
+* Imported Translations from Transifex
+* VMware: Disallow snapshot of attached volume
+* Clean up comparison assertions
+* Utilizes assertIsNone and assertIsNotNone
+* Nexenta volume drivers: refactor NexentaJSONProxy
+* remove unused methods in driver.Scheduler
+* Imported Translations from Transifex
+* Nexenta iSCSI driver fix \_lu\_exists
+* Ignore H803 from Hacking
+* Drop conf\_key\_mgr warning message!
+* VMware: Re-create session for RetrievePropertiesEx
+* use cinder utils.get\_root\_helper
+* Provide user with more information on quota fail
+* Cleanup and more tests for db.api methods
+* Fix broken solidfire create-snapshot
+* Clean CONF out of brick iser
+* Open Icehouse development
+* Imported Translations from Transifex
+* Add key manager implementation with static key
+* Remove need for CONF acces in brick iscsi
+* Quotas roll back failure of create volume task
+* Remove incorrect class in cinder.conf.sample
+* Fixes incorrect class path in logging\_sample.conf
+* Storwize SVC driver hostname can't start with number
+* After commiting quota we should avoid certain reverts
+* Remove CONF from brick remotefs
+* Pass through args and kwargs in brick connectors
+* Clean CONF out of brick initiator
+* Update Babel from Openstack Requirements
+* Disable lazy translation
+* Improve gpfs config flag help text readability
+* Check for backing lun on iscsi target create
+* usedevelop in tox
+* Fixes ceph backup import errors
+* Add XML response tests for qos specs manage ext
+* v2 api - return bootable attr value on volume list
+* Fixes backup with multiple volume backend
+* Dont retry if target creation succeeds
+* VMware ESX: Fixes vol clone & clone from snapshot
+* Create volume revert fails for non admin user
+* VMware: Usng RetrvProprtisEx & does multi ESX scan
+* Fix XML serializer for QoS Specs extension
+* Fix Huawei HVS driver attaching volume error
+* Add debug logging for targets
+* Add support for querying the quotas usage
+* Validate force\_host\_copy API param for migration
+* Imported Translations from Transifex
+* Update OpenStack Style Commandments link
+* Set vol driver initialized before deleting volumes
+* Add error logs for Huawei driver
+* Clean CONF out of brick exception
+* Fix translation of CinderExceptions in REST API
+* Allow upgrade from Grizzly with ThinLVMVolumeDriver
+* Use module units for some drivers
+* Get host group id when Huawei driver initializing
+* Fix mandatory and optional args for create\_volume
+* Pass correct args to vol\_rpc create\_volume calls
+* Fix processutils.execute errors on windows
+* Sync gettextutils from oslo
+* LVM volume\_clear: error on unexpected inputs
+* Revert "Fix volume\_rpcapi calls for chance/simple scheds"
+* Fix finish\_volume\_migration() on SQLAlchemy 0.8.x
+* VMware: Handles no datastores case
+* Fixes some typos in cinder
+* Update rootwrap with code from oslo
+* Specific /usr/local/bin/hus-cmd rootwrap filter
+* Allow v2 Volume API to create volume with type name
+* Imported Translations from Transifex
+* Fix volume\_rpcapi calls for chance/simple scheds
+* Require assisted\_volume\_snapshots from novaclient
+* Fix over-indent in compute/nova
+* Add sg\_scan filter to rootwrap
+* Add extend to reference LVM driver
+* Fix issues with failed lvremove
+* GlusterFS: Copy snap from correct source file
+* GlusterFS: Use image\_utils for qemu-img calls
+* Remove default root\_helper of sudo for remotefs
+* Add a retry to create\_iscsi\_target for LVM
+* Fix HP3PAR iSCSI path connection
+* Added mapper for update\_all on snapshot\_metadata
+* Add volume metadata to v2
+* Enforce driver is initialized
+* Added mapper for snapshot\_metadata
+* Fix type change in bootable setting of volume view
+* Add logging to prior to raising exceptions
+* GPFS Driver missing clone depth limit for snapshots
+* remove VolumeNotFoundForInstance class
+* Sync gettextutils from oslo
+* Use built-in print() instead of print statement
+* Fixes vol restore discard final bytes unzeroed
+* Fixes call GlanceConnectionFailed in invalid ARG
+* Fixes call VolumeNotFound in the invalid argument
+* Soft delete tmp migration volume
+* Fix \_\_init\_\_ methods of brick initiator connectors
+* Fix secure delete for thick LVM snapshots
+* assertEquals is deprecated, use assertEqual
+* Storwize/SVC: Optional CHAP authentication
+* Fix huawei driver test issues
+* fix wrong desciption of monkey\_patch config
+* Allow display\_name for v2 snapshot-update
+* Pass down root\_helper in more cases
+* Set rootwrap\_config path to rootwrap.conf
+* Do not use qemu-img --backing-chain or --output=json
+* VMware driver: Fix for invalid datastore selection
+* Fixes ceph volume restore to larger image than source
+* Imported Translations from Transifex
+* nms.folder.create\_with\_opts not supported on Nexenta 3.1.4.2
+* Use $state\_path/conversion for image\_conversion\_dir default
+* Improves the parsing way of ssh returns
+* Fixes the use of exception.InvalidInput with the wrong arguments
+* Remove unused exceptions
+* Fix client connection leaks in HP3PAR drivers
+* Add default\_availability\_zone configuration option to cinder
+* Imported Translations from Transifex
+* Turn db model object into a primitive object to avoid error
+* Catch generic exceptions
+* Add delete support for volume type encryption
+* Adds Dell EqualLogic volume driver for Cinder
+* Fixing UnicodeEncodeError against volume creating function
+* Fix deleting qos specs key
+* Move novaclient to requirements.txt
+* fix missing unit in log message
+* Add check for qemu-img to image\_utils fetch\_to\_raw
+* Changed header from LLC to Foundation based on trademark policies
+* Fixed erroneous force full copy in ceph backup driver
+* Call to\_primitive on volumes.rpcapi.create\_volume
+* Fix typo in cinder.tests.test\_create\_volume\_flow
+* Fix Qos Specs association corner case
+* Fixes pep8 violation in nova
+* Fix bug in Nexenta NFS driver \_do\_create\_volume
+* Restrict Volume type deletion with volumes assoc
+* Replace assertEquals with assertEqual - 2/2
+* Check cinder-backup service before "backing-up"
+* Do not attempt vg.update on uninitialized vg
+* Replace assertEquals with assertEqual - 1/2
+* Add support for LocalConnector type in brick
+* Remove unused/redundant methods in cinder/test.py
+* Fix error casting value to float in lvm.py
+* Fixes misuse of assertTrue in test scripts
+* Utilizes assertIsNotNone
+* Utilize assertIsInstance
+* Remove deprecated assert\_() usage
+* Fix brick remotefs dependency on cinder
+* Remove quota fetch race condition
+* Synchronize extend\_volume methods in 3PAR drivers
+* Added copy-on-write support for all RBD cloning
+
+2013.2.b3
+---------
+
+* fix log string in conversion type
+* VMDK copy\_image\_to\_volume and copy\_volume\_to\_image
+* Validate VV Set exists in 3PAR drivers
+* This adds a README to brick
+* Fix tuple usage error
+* Fixes brick Nova pep8 violation for lvm.py
+* fix inconsistent i18n log message
+* QEMU-assisted-snapshots for GlusterFS volumes
+* Add view builder to QoS specs API extension
+* Add features to Zadara Storage Cinder driver
+* Use tempfile and cleanup in windows unit test
+* Adds Nexenta NFS driver
+* Set vg\_thin\_pool to pool name instead of pool\_path
+* Fixes cinder-volume service startup on Windows
+* extract 'limits.' to constant for ratelimiting logic
+* Send notifications when extending volume
+* Fix errors in volume usage audit script
+* New update\_snapshot\_status API
+* Add volume driver for Huawei HVS storage system
+* Increase test coverage for cinder.utils
+* Add Fibre Channel drivers for Huawei storage systems
+* Refactor huawei Dorado array iSCSI driver
+* Refactor Huawei iSCSI driver
+* Enable gating on F811
+* Add support for Havana missing features in Windows driver
+* Add venv wrapper for check\_uptodate.sh
+* Clone volume with right size with SolidFire
+* Fixes bug to allow for encrypted volume deletion
+* Sync rpc fix from oslo-incubator
+* Move comment back to right place
+* copy\_image\_to\_volume for Nexenta volume driver
+* Fix pep8 violation in backup
+* Utilizes assertIn and assertNotIn
+* Implements APIs for VMDK driver
+* Remove \_create\_volume function from several tests
+* Don't need to init testr explicitly
+* Add missing LH SAN driver features for Havana
+* Multi storage backend support for Nexenta driver
+* Fix typo in bin/cinder-volume-usage-audit
+* Remove unused methods from cinder.utils
+* Increase test coverage for cinder.image.image\_utils
+* Add kwargs to create\_volume in tests/utils.py
+* Update the version for the FC and iSCSI driver
+* Pass MB size on copy\_volume\_data call copy\_volume
+* Adding Read-Only volume attaching support to Cinder
+* Add NFS/GlusterFS support to brick library
+* Pass db into driver as constructor's parameter
+* Modified 3PAR drives to support 3parclient 2.0.0
+* Move create\_volume flow to a subfolder
+* Import order cleanup
+* Migrate manage script needs import of db session module
+* Migration for attached volumes
+* Add optimized volume migration to Storwize/SVC
+* Fix quota update validation for non-int types
+* Imported Translations from Transifex
+* Removes exception instance creation on execute()
+* Fix except in lvm.py
+* Add automated check of conf sample
+* Remove deprecated code from Nexenta Exception class
+* Sync up with global requirements
+* Extend volume for GlusterFS
+* Offline snapshots for GlusterFS volumes
+* Ensure that qpid connection is closed (from oslo)
+* Imported Translations from Transifex
+* Test WWNs with basestring
+* Imported Translations from Transifex
+* Remove print statement in db api test
+* Ignore stmf target must be offline exception
+* Sync execute() related exceptions with oslo
+* The DB migration shouldn't populate types table
+* Use a new rest client for every Coraid ESM command
+* Remove unused methods from LVM driver
+* Storwize/SVC: allow setting of I/O group
+* Implement QoS support for volumes
+* Move the frequently injection task to the base folder
+* Move root task class to base file
+* Backup driver for IBM Tivoli Storage manager (TSM)
+* Dont crash service if sf cluster isnt available
+* 3PAR driver add missing domain check on QOS cmd
+* Remove unused methods from cinder.utils
+* Refactor cinder/tests/test\_volume.py
+* Unified Volume Driver for IBM XIV and IBM DS8K
+* Adds brick helpers to cinder utils
+* Fix python 3 pep8 errors for print
+* Fix incorrect msgstr's to avoid translation errors
+* GPFS use clone\_image for creating volumes
+* 3PAR driver terminate connection host validation
+* Re-enable a lot of cinder scheduler tests
+* emit warning while running flake8 without virtual env
+* Set bootable flag for volume cloned from image
+* Remove unused methods from cinder.utils
+* Clean up the sqlalchemy migrate manage.py script
+* Allow to delete a volume in error\_extending status
+* Update Brick to use executor
+* flake8 H202 error in test\_image\_utils.py
+* Removes ssh\_execute in utils.py
+* Fix volume\_glance\_metadata deletion
+* Use system locale when Accept-Language header is not provided
+* Generic backup\_volume and restore\_backup functions
+* Relax policy so owner can access encryption info
+* Fix Fibre Channel attach for single WWN
+* Make the SolidFire driver api port configurable
+* Add accept\_transfer to solidfire driver
+* Added need info to accept\_transfer
+* Allow volume create from source unless in error status
+* Avoid serializing CinderExceptions before they are translated
+* Add root\_helper param to get\_connector\_properties
+* Standardize on ID for log messages
+* Reduce hidden effects of sqlalchemy objects
+* Removed need for domain in 3PAR drivers
+* Allow Cinder to call Nova client
+* Use FakeLoopingCall instead of the real one
+* Fix some pylint error in Coraid Driver
+* Storwize/SVC: More error logging
+* Remove strcmp\_const\_time
+* Refactor LVM driver to use Brick VG utility
+* Added missing import
+* Fixes SSH injection threat in 3PAR driver
+* Implement missing Coraid Driver functionality for Havana
+* Increase test coverage brick/initiator/connector
+* Fix SSH injection threat in 3PAR driver
+* refactor/unify driver version strings
+* Refactor Nexenta driver
+* Update Nexenta ISCSI volume driver authors
+* Extract ISCSI tries option into connector module
+* Externalize error messages in the v2 API
+* Add more asserts to the limiter unit tests to test the RateLimit
+* Replace os.unlink with delete\_if\_exists
+* No need to declare the exception conf
+* Add support for encrypted volumes
+* Add tests for cinder/brick/initiator/connector
+* Tidy up the SSH call to avoid injection attacks for HP's driver
+* Raise exception when Glance metadata not found
+* Interprete scoped key as nested tags
+* Adding the -online option to the 3PAR clone
+* Fixes some unseen flake8 violations
+* Fixes volume clone from volume
+* Fixes docstring formats in connector.py
+* Fixes files with wrong bitmode
+* Add unit tests for cinder/api/contrib/quotas
+* remove Brick deps on cinder.exception
+* Remove Brick iser dependency on cinder
+* Fix handling ImageUnacceptable in create\_volume
+* Use native methods for list manipulation
+* Fix signature of \_create\_volume() in ThinLVMVolumeDriver
+* Add H233 to ignores in tox.ini
+* Imported Translations from Transifex
+* Add support for volume cloning to Nexenta driver
+* Fix ratelimiting
+* GPFS support for various volume attributes
+* Upgrade Scality driver to match minimum features
+* Ignore purge\_props for v2 Glance api and fix upload
+* Add support for API message localization
+* 3PAR drivers creating incorrect comment data
+* Imported Translations from Transifex
+* Use utils.safe\_minidom\_parse\_string in extensions
+* Move resource usage sync functions to db backend
+* Imported Translations from Transifex
+* Refactoring of create\_volume to use taskflow
+* Add minimum features in HDS driver (for Havana & Icehouse)
+* Ignore stmf target must be offline exception
+* Added glance\_request\_timeout config option
+* Set lock\_path in tests
+* 3PAR volumes created from snaps failed to attach
+* Add test for brick.local\_dev.lvm
+* Imported Translations from Transifex
+* Remove Brick's iscsi dependency on cinder
+* Remove locals() from iser
+* Move volume\_clear and clear\_size opts up to driver
+* Imported Translations from Transifex
+* Set the concurrent connections on the 3PAR array
+* Create key manager interface
+* Remove usage of obsolete oslo.exception
+* Fixes create rbd volume from image v1 glance api
+* Imported Translations from Transifex
+* Remove Storage Manager from cinder-manage
+* Remove cinder.exception from Brick
+* Add bin directory to flake8 when not in venv
+* Add support for volume extension to Nexenta Systems volume driver
+* GPFS Verify min release level for mmclone command
+* Sync gettextutils from oslo
+* Add eclipse project files to .gitignore
+* Remove unnecessary metadata from the 3PAR drivers
+* Adding support for iSER transport protocol
+* NetApp fix clone image compatibility issue with ssc
+* Set bootable flag for volume serializer
+* Fix chown fail for nfs file without necessary permission
+* Add new persona value in the 3PAR driver
+* Update driver version to 1.1
+* Fix NetApp iscsi drivers for cinder backup
+* Fix pep8 and pylint violation in Nexenta volume driver
+* Test tools barfs on reusage of 'id' attribute
+* Ignore "volume does not exist error"
+* Call get\_session() only when necessary
+* Fix volume\_create()/snapshot\_create() DB methods
+* Execute DB API methods in a single transaction
+* Improve DB API test coverage
+* Fix check for mount.nfs helper installation
+* Imported Translations from Transifex
+* Remove xen storage manager tables
+* Remove unused migration\_\* methods from db api
+* Factorize code between nfs.py and glusterfs.py
+* NetApp fix create vol different size than snapshot
+* LVM / Block Device Drivers: Fix duplicated flags
+* tox.ini: Change sitepackages to False
+* Tidy up the SSH call to avoid injection attacks in storwize\_svc
+* NetApp check for 7 mode controller version
+* Storwize/SVC: Use reserved percentage from conf
+* Imported Translations from Transifex
+* Pop out 'offset' and 'limit' before use for filter
+* Imported Translations from Transifex
+* Fix running of migrations tests by Jenkins gate
+* Update to latest oslo rootwrap
+* Make unicode-to-utf8 conversion universal in ceph backup driver
+* Add more info to delete error message
+* Update references with new Mailing List location
+* Allow connect by FC-only or iSCSI-only systems
+* NetApp NFS efficient clone\_image impl
+* Removed the dep on cinder.utils
+* Fix the multi-backend storge issue for ZMQ
+* NetApp storage service feature support
+* Imported Translations from Transifex
+* Create volume from snapshot must be in the same AZ as snapshot
+* Using volume name property instead of using template and id
+* Fix unit suffix and add no\_suffix option
+* GPFS stub calls to truncate and dd in unit tests
+* Storwize/SVC: Use VolumeDriver's copy vol<->image
+* Implements extend volume feature in HP 3PAR driver
+* use encode('utf8') instead of str()
+* Imported Translations from Transifex
+* Migration for detached volumes with no snaps
+* Fix cinder error for deprecated Netapp drivers
+* get\_snapshot should populate the snapshot metadata
+* Adding driver minimum features and volume stats to dev doc
+* Update RBD driver to be compliant with HACKING
+* GPFS convert glance image to raw only when needed
+* Fix oslo.config.cfg.NoSuchOptError when running individual tests
+* Fixes RBD driver docstring format issues
+* fix name 'update\_volume\_status' to 'update\_volume\_stats'
+* use 'exc\_info=1' instead of import traceback
+* Fix further Hacking 0.6.x warnings
+* Add create & attach times to SolidFire attributes
+* Implement extend volume for Storwize/SVC
+* Cleanup README.rst
+* Fix volumes search by metadata
+* Add test for volume status check when extending
+* 3PAR Driver modifications to support QOS
+* Make Storwize/SVC tests work without simulator
+* Revert hardening of Storwize/SVC SSH commands
+* Clone\_image method added image\_id as parameter
+* Added incremental backup support to Ceph backup driver
+* Sync gettextutils from oslo
+* Imported Translations from Transifex
+* Fix duplicate config options
+* Move copy\_volume function to volume/utils.py
+* Fixes default value of use\_default\_quota\_class
+* Imported Translations from Transifex
+* Delete snapshot metadata when snapshot is deleted
+* Tidy up the SSH call to avoid injection attacks in storwize\_svc
+* Fix extend\_volume error handling
+* Fixes race condition in LVMVolumeDriver create\_cloned\_volume method
+* Checks the volume\_clear flag and just return if it is none
+
+2013.2.b2
+---------
+
+* Fixes Opt type of use\_multipath\_for\_image\_xfer
+* Fixes Opt types in cinder/backup/drivers/ceph.py
+* Fix indent in cincer/volume/configuration.py
+* Implement validate\_connector for Storwize/SVC
+* Fix error when QuotaUsage.updated\_at is NULL
+* Rename SolidFire driver for consistency
+* Add Brick Fibre Channel attach/detach support
+* Increase timeout period for clone volume
+* Be sure to check deleted types on quota update
+* CoraidDriver: Allow volumes in error state to be deleted
+* Adds multiple iSCSI port support to 3PAR
+* Implement extend volume functionality in Sheepdog
+* Mark methods used in class only with prefix "\_"
+* Add te field user\_id into the volume detailed information
+* Catch additional connect fail cases
+* Clean up Huawei tmp files from tests
+* Add flag argument to 'cinder-manage config list'
+* Imported Translations from Transifex
+* Add generic block device driver
+* Use base ISCSI driver to fulfill some driver requirements
+* Cleanup and make HACKING.rst DRYer
+* Clone\_image should return dict of vol properties, clone status
+* Update requirements from openstack/requirements
+* Refactor SSHPool.get() to use Pool.get()
+* Enable zero the snapshot when delete snapshot in LVMVolumeDriver
+* Fixes ceph-backup failure if original volume deleted
+* Implement extend volume functionality in Rbd
+* Handle errors raised by extend\_volume
+* Minor reorg for (array resource usage and backend options naming)
+* Check enabled backup service before rpc request
+* Fixed Ceph backup librbd segfault
+* Add support to import images into sheepdog volumes
+* Add tests for cinder/api/urlmap.py
+* remove improper assert usage
+* Enable setting blocksize on volumes
+*     cinder.api: Replace 'locals()' with explicit values
+* Update upper bound of keystoneclient version
+* Fix missing volume\_name\_template flag
+* Change check-detach to reject more states
+* Implement extend volume functionality in SolidFire
+* Add unit tests for cinder/api/versions
+* Make String column creation compatible with SQLAlchemy 0.8
+* Remove suds requirement
+* Add support for storing volumes on GPFS
+* Consist terminate\_connection function signature
+* SolidFire API RequestID is useless
+* Add ability to specify SolidFire API version
+* Refactor reschedule in exception handling of volume manager
+* Don't pass 'session' arg to public DB API methods
+* Add interface class for backup drivers
+* Prevent wrongly privilege escalation of a context
+* Move brick initiator tests to brick subdirectory
+* Fix extent size issue when creating thin pool
+* Sync install\_venv\_common from oslo
+* Fix a few Sphinx warnings
+* Ignore files created by Sphinx build
+* Use oslo.sphinx and remove local copy of doc theme
+* Add unit tests for cinder/api/contrib/volume\_actions
+* Scheduler should not select down volume managers
+* Add check for snapshot to Brick LVM
+* Fix typo 'Flase' -> 'False'
+* Rename cinder.flags to cinder.common.config
+* Add execute wrapper to brick LVM code
+* Imported Translations from Transifex
+* CoraidDriver: Create\_volume\_from\_snapshot of a different size
+* Make os-services API extension consistent
+* Imported Translations from Transifex
+* Removes 3PAR domain option from cinder config file
+* Skip brick\_initiator test in virtual environments
+* Added Cinder volume backup to Ceph support
+* Handle ECONNREFUSED exception in SolidFire driver
+* Add os-availability-zone extension
+* Run flake8 also on cinder/\*/openstack
+* Imported Translations from Transifex
+* Quotas by Volume Type
+* xenapi: implement xenserver image to volume
+* Save some more image attributes to volume\_glance\_metadata
+* Fix check\_for\_setup\_error for sheepdog driver
+* Add Brick iSCSI attach/detach
+* Added volume backup and restore to Ceph RBD driver
+* Fix service alive information in os-services extension
+* Calculate count for customized dd blocksize
+* Content-length missing in put\_object
+* Replace glance\_metadata check with bootable column
+* Imported Translations from Transifex
+* Avoid winning the useless use of cat award
+* Fix up trivial H103 license check mismatches
+* Register used CONF entries in cinder.api.common.py
+* Fix and enable gating on H401
+* Do not raise NEW exceptions
+*         cinder.[brick,db,image] Replace 'locals()'
+* Update kombu requirement
+* Remove usage of locals() for formatting from cinder.tests.\*
+* Adds create\_from\_volume test cases
+* Use list comprehensions when possible
+* NetApp:iSCSI drivers reserved percent need to change to 0
+* Add support for swift user/key authentication
+* Refactor the backup method of SwiftBackupService
+* Imported Translations from Transifex
+* NetApp unified driver implementation
+* Add \_create\_volume to ThinLVMVolumeDriver
+* Add the project name into CinderKeystoneContext
+* Add build directory to flake8 ignore dirs
+* Add missing extend volume test (rpcapi)
+* fix error class path in logging sample
+* Modify check for volume-type-id to a get w/default
+* Don't perform retry\_execute in certain cases
+* Adding host attaching support to Cinder
+* Update attach status when instance id invalid
+* Fix and enable gating on H403
+* Use Python 3.x compatible except construct
+* cinder.backup: Replace 'locals()' with explicit values
+* cinder/.: replace 'locals()' with explicit values
+* Editable default quota support for cinder
+* Imported Translations from Transifex
+* Use common.processutils.execute
+* Remove usage of locals() for formatting from cinder.volume.\*
+* cinder.schedule: Replace 'locals()' with explicit values
+* Imported Translations from Transifex
+* Remove the 'migrate' option from cinder-manage
+* Use Python 3.x compatible octal numbers
+* Use Python 3.x compatible except: construct
+* Update and add notifiers in create volume
+* Imported Translations from Transifex
+* Fix up the test framework
+* Raise an error if iSCSI is not supported
+* Remove usage of locals() for formatting from cinder.api.\*
+* Implement capability to extend existing volume
+* Replace utils.to\_bytes() with strutils.to\_bytes()
+* Flatten Volume from Snapshot
+* Imported Translations from Transifex
+* Replace FLAGS with cfg.CONF in volume
+* Replace FLAGS with cfg.CONF in other modules, unless tests
+* Elevate volume/snap "is busy" log message for volume/snap\_delete
+* Imported Translations from Transifex
+* Fixes 3PAR drivers terminate\_connection issue
+* Added policy check for backup operations
+* Update to the latest stevedore
+* Fix various Sphinx warnings
+* Fix some unittest cases failed on osx
+* Fix the after subscription size checks
+* Re-set default sql\_connection and sqlite\_db
+* Remove explicit distribute depend
+* Add missing exception from volume/api.py
+* Allow disabling ssl compression for glance client
+* Add availability zone checking in the api service
+* Add missing attributes to xml deserializer for volume request
+* Integrate oslo's periodic tasks
+* Fix LVM logging error
+* Remove direct call to utils.execute
+* Add policy checking for transfer create/accept
+* Replace FLAGS with cfg.CONF in tests
+* Replace FLAGS with cfg.CONF in api
+* Start using Pyflakes
+* Add the iscsi device check and exception processing
+* Minor Logic bug in NFS Driver
+* Imported Translations from Transifex
+* Fix 'undefined symbol conn' error
+* NFS drivers don't honor vm size with volume from an image
+* Add missing tests for backup\_\* methods
+* Replace functions in utils with oslo.fileutils
+* Remove E12 errors from tox.ini Flake ignores
+* Unset all stubs before running other cleanups
+* Fix config registration in cinder volume drivers
+* Elevate acceptors context on accept reserve udpate
+* Removing service\_\* options from authtoken
+* Add call to vol driver when accepting a transfer
+* Imported Translations from Transifex
+* Implement DB migration for volume transfer BP
+* Replace FLAGS with cfg.CONF in db
+* Add missing tests for iscsi\_\* methods
+* Log iSCSI target output on error
+* Re-write of the cinder-manage man page
+* Replace FLAGS with cfg.CONF in scheduler
+* python3: Introduce py33 to tox.ini
+* Fix AttributeError typo
+* Fix path for pylint Gate
+* Fixed method db.api.reservation\_expire
+* Handle IPv6 specifid glance servers gracefully
+* HDS Cinder Driver. Rev #1
+* Imported Translations from Transifex
+* Add error reporting to generate\_sample.sh on import failure
+* Updating HACKING to disallow the use of locals()
+* Prevent force delete if the volume is attached
+* InvalidUUID can not be raised
+* Fix incorrect authorization rule in quota contrib api
+* Rename requires files to standard names
+* rbd: simplify configuration and use librbd and librados
+* Update 3PAR driver session management
+* Fix typos
+* Add testrepository to git ignores
+* Fix incorrect copyright
+* Add missing tests for cinder.db.api.quota\_
+* Return 404 from delete of extra spec if not found
+* Fix incorrect status for volume clone from image
+* Imported Translations from Transifex
+* Support for NFS shares with spaces in path
+* Fixes 3PAR Host already exists error
+* Ensure that pbr>=0.5.10 is installed
+* Add missing tests for cinder.db.api
+* Remove execute permissions from test files
+* Migrate to Oslo DB code
+
+2013.2.b1
+---------
+
+* Catch and report errors from copy image to volume
+* test\_glance.py: Stub out \_get\_member\_model as well
+* rbd: send ceph monitor addresses with connection info
+* Don't set signing\_dir by default
+* Remove cinder\_emc\_config.xml.sample
+* Update cloned volumes QoS settings
+* Fix 'Inheritance-based rule deprecated' log warning
+* Added '%' before snapshot variable
+* Hack run\_tests.sh to work with single tests again
+* Imported Translations from Transifex
+* Don't throw ValueError for invalid volume id
+* ModifyVolume attributes on Clone
+* Improve "service is down or disabled" warning message
+* Add "\_" builtin method for config generation
+* Replace custom skip\_ methods
+* Migrate base test class to testtools
+* Fix ownership transfer when cloning with SolidFire
+* Make NFS share selection more intelligent
+* Add common Oslo DB code to the source tree
+* Add the service\_state into test\_schedule\_happy\_day
+* Implement scheduler hints for API v2
+* Update log.py and jsonutils.py from oslo-incubator
+* Added a test for bad limit param
+* Added test for nonnumerical limit param
+* Raise VolumeNotFound with correct volume\_id
+* Removes a broken link from the sidebar of Sphinx built pages
+* Imported Translations from Transifex
+* Support mount options for NFS/GlusterFS volumes
+* Hide v1/v2 version entities in API when disabled
+* Allow flake8 to run in venv
+* Imported Translations from Transifex
+* Imported Translations from Transifex
+* Convert to oslo strutils.bool\_from\_string
+* Update import of strutils from oslo
+* Add thin provisioning support checks
+* Update/Publish volume service updates on delete
+* RemoteFsDriver: copy\_image\_to\_volume and copy\_volume\_to\_image
+* Imported Translations from Transifex
+* solidfire: Make sure src\_uuid is passed correctly
+* Implement cloned volume for the RBD driver
+* Add .coveragerc to show proper coverage statistics. As in other openstack projects
+* NetApp server tunneling fix
+* Move iscsi helpers to brick directory
+* Fix up hacking ignores a bit
+* Hide lock\_prefix argument using synchronized\_with\_prefix()
+* Storwize/SVC: fix attach bug for live migration
+* Deprecating old dot path locations for Folsom configs
+* solidfire: Add ability to override account prefix
+* Fixes an get\_volume\_stats reporting issue
+* Increased unit test code coverage
+* Create an LVM utility to use for local storage
+* Add CINDER\_LOCALEDIR env variable
+* Remove gettext.install() from cinder/\_\_init\_\_.py
+* Use flake8 and hacking
+* Use pbr instead of openstack.common.setup
+* Change the type of "free\_capacity\_gb" to be float
+* Set default values for NFS/GlusterFS share\_config files
+* Add missing spaces to iscsi\_iotype help
+* Adds notifiers to both volumeTypes and volumeTypeExtraSpecs
+* Fix missing spaces in Huawei Logging
+* Add pylint-based lintstack test to tox environment
+* Remove outdated cinder test doc
+* Implement copy\_image\_to\_volume and copy\_volume\_to\_image on nfs backends
+* Update import of oslo's processutils
+* Fix ability to add custom volume\_backend\_name
+* Add db client packages to dev env setup doc
+* Check that volume is at least minDisk size
+* Remove old\_name from kwargs when using IET helper
+* Copy the RHEL6 eventlet workaround from Oslo
+* Remove setuptools-git as run time dependency
+* Fix LHN driver to allow backend name configuration
+* Deleting a backup removed the backup record from database
+* Remove \_path\_exists method
+* Encode username and password in config file
+* Clear volumes stuck in 'downloading'
+* Fixes 3PAR FC driver synchronization
+* Avoid using whitespace in test\_safe\_parse\_xml
+* Add stats reporting to Nexenta Driver
+* Remove duplicate method definition
+* iscsi: Add ability to specify or autodetect block vs fileio
+* Rename duplicate test method
+* Update to latest copy of OSLO incubator
+* Cinder wasn't filtering the backups returned to backup list API
+* cinder volume service keeps retrying even code exception
+* Add missing space to "volumes already consumed" message
+* Add capabilities reporting to ThinLVM driver
+* NetApp: Fix failing NetApp tests
+* Use VERSION var for volume\_stats version (Gluster/NFS)
+* Add parsing to extra-specs key check
+* Use a SSH pool to manage SSH connection
+* Remove Flags usage from cinder.volume.driver
+* new cinder.conf.sample and fix extract\_opts.py
+* fix default config option types
+* Fix incompatible Storwize/SVC commands
+* Fix backup manager formatting error
+* Add service list functionality cinder-manage
+* Clean up attach/detach tests
+* Reformat openstack-common.conf
+* Sync with oslo-incubator copy of setup.py
+* Don't hard code AUTH\_ into the swift backup url
+* Remove update\_volume\_status log message from NFS driver
+* Implement get\_volume\_stats for GlusterFS driver
+* Fixed a volume creation re-schedule error
+* Allow deletion of backups where the service is None
+* Fix cinder-manage backup list to work with uuids
+* leave re-scheduled volume status to creating
+* Prevent create volume from snapshot with bad size
+* Add du to rootwrap filters
+* Change format of some judgments
+* Remove InvalidPortRange exception
+* Add availability\_zone to the volume and snapshot notifications
+* Throw InvalidSnapshot for failed snap delete
+* remove deprecated assert\_unicode sqlalchemy attribute
+* Fix IBM copyright strings
+* REST session validity not checked in get\_volume\_info
+* Enforce exclusive options snapshot-id, source-volid and image-id
+* Add snapshot events to the cinder notification
+* getLogger should be called after logging is configured
+* Mark sql\_connection with secret flag
+* Sync lockutils from oslo-incubator stable/grizzly
+* Remove unused tools/rfc.sh
+* Add the volume and snapshot gigabytes together
+* Force deletes using tgt to workaround bug 1159948
+* Fixed shared gigabytes quota resource
+* CoraidDriver: support users that are not admin
+* Fix quota updating when admin deletes common user's volume
+* Last driver sync for Folsom and Grizzly
+* Fix bug with 3PAR host entry in wrong domain
+* Snapshot reservation sync calls wrong resource
+* Fetch volume\_types by uuid and not by name in v2
+* Use the local configuration in the nfs drivers
+* Fixed attach volume for EMC SMI-S iSCSI driver
+* Extend param2id() to work with uuids
+* Clean up started volume services in tests
+* CoraidDriver: do not call login from \_\_init\_\_
+* CoraidDriver: typo in \_login exception handler
+* Fixes Cinder REST API /volumes issue
+* Add missing processutils for impl\_zmq in oslo rpc
+* Update Cinder's latest copy of OSLO grizzly stable
+* Remove the log spam generated by the NetApp driver unit tests
+* Speedup solidfire unit tests
+* Updates to OSAPI sizelimit middleware
+* Use OpenStack common project requires
+* Rename cinder-rtstool to rtstool
+* Make dd block size user configurable
+* remove cinder-rtstool because of rtslib dep
+* Add snapshots to the volume usage audit report
+* CoraidDriver: retrive volume info (improvement)
+* Remove AGPL rtslib pkg from pip-requires
+* Fix Storwize/SVC LUN allocation with holes
+* Remove references to FLAGS from volume/manager.py
+* Allow snapshot\_delete for NFS/GlusterFS drivers
+* Pull Oslo log fix to enable root logger initialization
+* Clean up exec\_dirs prefix from rootwrap conf
+* Fix typo in persona valid values
+* Use self.configuration to support the multi-backend case
+
+2013.1.rc1
+----------
+
+* Bump version for Grizzly RC1 cut
+* Count Snapshots towards volume/gigabyte quotas
+* Fix 3PAR driver hiding existing host error
+* Switch all uses of 422 response code to 400
+* Implement get\_volume\_stats in NFS driver
+* cinder-manage does not print any version information
+* Fix ISCSIDriver rescan
+* Compression/tier capabilities for Storwize/SVC
+* Fixes dettach volumes in Windows cinder plugin
+* Fix \_migrate\_up in test\_migrations
+* Switch to final 1.1.0 oslo.config release
+* Adds a flag to set glance api version to call
+* Storwize/SVC driver fix for multibackend scenario
+* Fix bad request response code on extra\_specs create
+* Fix bugs for Huawei driver
+* Do not use prefix to lookup host in Storwize/SVC
+* update error log arguements in filter scheduler
+* Update oslo rpc libraries
+* Remove/update unused log arguements in manager
+* Removing flags in RBD in favor of configuration
+* LIO iSCSI initiator ACL auto-config
+* Fix a few bugs for LeftHand Grizzly
+* Update tox.ini to support RHEL 6.x
+* Fix volume capacity reporting
+* Pull newly merged Olso update for 'is' operator
+* Use nose and openstack nose plugin
+* Exit run\_tests with the result code of the test runner
+* Mark configuration option netapp\_password secret
+* Add get\_volume\_stats in the sheepdog driver
+* Switch to oslo.config
+* Fix calling setUp() method of superclass from tearDown method
+* Fix 3PAR drivers to work in multi-backend mode
+* Fixed copy image to volume and clone volume
+* Fixes issues found in /os-hosts API
+* Fix Storwize/SVC storage\_protocol reporting
+* sync oslo changes for setup / version
+* swift backup service checks version during restore
+* Add some useful log to filter scheduler
+* Elevate context for delete volume with no host
+* Improved fail\_reason for cinder-backup swift connection errors
+* Convert from using FLAGS directly in SF driver
+* Improve logging for volume operations via manager
+* Only use iscsi\_helper config option if using LVMISCSIDriver
+* Fix query filter in volume\_get\_active\_by\_window()
+* Changed to INFO level logging for main cinder-backup operations
+* NetApp: Clean up lock file left behind by unit tests
+* NetApp: Fix race condition in 7-mode iSCSI driver with DFM
+* update install\_venv\_common to handle bootstrapping
+* allow run\_tests.sh to report why it failed
+* Remove compat cfg wrapper
+* XenAPINFS: Fix Volume always uploaded as vhd/ovf
+* Fixed cinder-backup start errors seen with devstack
+* Cinder devref doc cleanups
+* Fix various exception paths
+* Implement metadata options for snapshots
+* Skip timestamp check if 'capabilities' is none
+* Fix stale volume list for NetApp 7-mode ISCSI driver
+* Implement a basic backup-volume-to-swift service
+* Better error handling around volume delete
+* Moved cinder\_emc\_config.xml.sample to emc folder
+* Uses tempdir module to create/delete xml file
+* Add HUAWEI volume driver in Cinder
+* XenAPINFS: Create volume from image (generic)
+* Bump the oslo-config version to address issues
+* Ensure volume exists before deleting
+* Add LIO configuration for iSCSI initiators
+* rbd: implement get\_volume\_stats()
+* Handle maxclonepervolume/node limits in SF driver
+* Use oslo-config-2013.1b3
+* Fix syntax error in  cinder-volume-usage-audit
+* HP 3PAR Fibre Channel Driver and iSCSI Updates
+* Fibre Channel base class for Cinder drivers
+* Update cinder-manage to use FLAGS.log\_dir
+* Add a safe\_minidom\_parse\_string function
+* Add a volume driver in Cinder for Scality SOFS
+* Fix create volume from image
+* XenAPINFS: fix capacity reporting
+* Update Storwize/SVC driver for Grizzly
+* Set rootwrap\_config in cinder.conf sample
+* Skip tests if cinder is not installed
+* Fix undef function call in test\_migrations for py26
+* Fix PEP8 violation (again)
+* Update cinder-volume to enable multi volume support
+* Install rtslib when installing cinder
+* Sync latest cfg and log from oslo-incubator
+* Handle 'infinite' and 'unknown' capacity in CapacityWeigher
+* Add get\_cluster\_stats to SolidFire driver
+* NetApp: Fix for snapshot not deleted in error state
+* NetApp bug fix for multibackend scenario
+* Adding support for Coraid AoE SANs Appliances
+* Add an update option to run\_tests.sh
+* Update EMC SMI-S Driver
+* Add LIO iSCSI backend support using python-rtslib
+* Add GlusterFS volume driver
+* Create a RemoteFsDriver class
+* Fix ordering of function args
+* Add an ID to temporary volume snapshot object
+* Allow create\_volume() to retry when exception happened
+* Fixes the provisioning on selected volumes for NetApp 7 mode
+* rbd: update volume<->image copying
+* Fix PEP8 violation
+* Update snapshot rest api to be consistent with volumes
+* change display\_description to description in volumes
+* v2 volume/snapshot create will correctly give a 202 response
+* add postgresql opportunistic testing
+* make test\_databases instance variable
+* Move create\_cloned\_volume() to LVMVolumeDriver
+* Update to latest oslo-version code
+* Allow disabling of long-lived SSH connections
+* Don't require importing paramiko for error
+* Allow for specifying nfs mount options
+* rework migration 004 testing with real data
+* Allow tools/install\_venv\_common.py to be run from within the source directory
+* add data injection on migrations
+* sync database connect changes from nova
+* XenAPINFS: Copy volume to glance
+* XenAPINFS: Copy image from glance
+* Fix inability to delete volumes in error state for NetApp driver
+* Copy glance\_image\_metadata when cloning volumes
+* Add volume\_glance\_metadata to volume.api.get
+* Import Oslo's common rootwrap to Cinder
+* Mark password config options with secret
+* Fixes 'not in' operator usage
+* Skip tests if cinder is not installed
+* Fix provider\_location column add for PSQL
+* Update 3PAR driver
+* Fix the generalized copy\_image\_to\_volume operation
+* import tools/flakes from oslo
+* Add unit tests for ISCSIDriver.\_do\_iscsi\_discovery and ISCSIDriver.\_get\_iscsi\_properties
+* Fixes "is not" usage
+* Pull cfg module from Oslo and update cinder-manage accordingly
+* Set source volume to "in use" during clone
+* Update some Oslo Packages
+* Fix typo in cinder/db/api.py
+* Replace CRLF with unix-style "LF"
+* Allow volume back-end to report 'infinite' or 'unknown' as capacity
+* Wrap SolidFire size parameter in int
+* Use install\_venv\_common.py from oslo
+* Update osapi\_volume\_extension default
+* Generic iSCSI copy volume<->image
+* Implement LVM thin provisioning support
+* Check for installed cinder in filter tests
+* Fix hosts extension and enable its tests
+* Check for non-default volume name template
+* Get updated vol status in volume.api.reserve
+* Update EMC SMI-S iSCSI Driver
+* Clean up QTree when deleting volume on NetApp storage box
+* Fix NFS volume creation
+* Improve error message for missing NFS share config
+* ensure zeros are written out when clearing volumes
+* Fix error for extra specs update with empty body
+* Clean up IPV6 config checks in test\_wsgi
+* Add capability to update volume metadata
+* Fix sheepdog volume creation
+* Add LUN# to provider\_location in Nexenta driver
+* Check for configured IPV6 before running tests
+* New cinder.conf.sample format
+* Move iscsi flags back to driver.py
+* Snapshot support for XenAPINFS
+* support a configurable volume wiping method
+* Relax various version constraints
+* Support for SSL in wsgi.Server
+* Enhance wsgi to listen on ipv6 address
+* Factor out LVM code
+* Implement filter scheduler
+* Revert "Implement filter scheduler"
+* Update SolidFire Volume driver
+* Provide HP 3PAR array iSCSI driver
+* Fix CinderClient exception name in EMCISCSIDriver
+* Enable cinder exception format checking in tests
+* Update exceptions to pass correct kwargs
+* Add option to make exception format errors fatal
+* Implement filter scheduler
+* Use tempdir for lock\_path in tests
+* Upgrade WebOb to 1.2.3
+* Make WebOb version specification more flexible
+* Fix cmds clearing in TargetAdminTestCase
+* Add missing library
+* use deleted = False, not 0 for update
+* Implement ability to Clone volumes in Cinder
+* Add pyflakes
+* Adds synchronization to attach volume
+* Add EMC Volume Driver in Cinder
+* Added extra-spec key scoping to the 3PAR drivers
+* Adding marker, pagination, sort key and sort direction to v2 api
+* Fix typo in image\_utils tempfile handling
+* Make the NetAppISCSIDriver.\_is\_clone\_done() method able to handle empty responses. Add unit tests to exercise this case
+* Make sure we don't double remove tmp on exception
+* Add service mgmt extension
+* Added the lockutils, fileutils, gettextutils
+* Fixes a Windows volume driver bug on disk export
+* Moving host admin extension with other extensions
+* Allow the lvm backed drivers to use mirrrors
+* CHAP support for IBM Storwize/SVC driver
+* Remove instance quota re-sync code
+* Add image metadata API extension
+* Raise NotImplemented for drivers that don't support images
+* Add \*.swp to gitignore
+* Support glance servers over https
+* Add commands used by NFS volume driver to rootwrap
+* Changing display\_name to name in v2 api
+* Make summary and detail view consistent with other projects
+* creating separate v1 and v2 stubs and general fakes
+* Make copy\_to\_volume a bit more useful
+* Delete type call in api needs update to use ID
+* Convert volume\_type id from int to uuid
+* Fixes the 3PAR drivers CPG validation
+* Rename Config osapi\_compute\_link\_prefix to osapi\_volume\_base\_URL
+* Fix exception when size is None
+* Ensure request\_spec can be serialized
+* attaching volumes will set instance\_uuid instantly
+* Revert changes to monkey\_patch
+* Improve provider\_location cleanup code for RBD
+* Fix import order to make it alphabetical
+* Fix None being passed into as\_int()
+* Use auth\_token middleware from keystoneclient
+* Provide i18n to those messages without \_()
+* Revert "use O\_DIRECT when copying from /dev/zero too"
+* Make pep8 checks a bit stricter
+* Unpin lxml requirements
+* use O\_DIRECT when copying from /dev/zero too
+* Add CONTRIBUTING file
+* Add the persistency to the volume created by iscsi IET
+* adding copy of v1 as v2
+* Moving contrib to cinder.api
+* Moving api v1 implementation into v1 directory
+* Switching api to use base extension manager
+* moving all middleware code in cinder.api.middleware
+* Moving common api code into cinder.api
+* Cleaning up volume driver paths
+* Add volume bootable information to api response
+* Add XenAPINFSDriver
+* Add db table for Glance Metadata
+* Remove redundant db.volume\_update() in volume manager create\_volume()
+* Pin pep8 1.3.3
+* Removes the xensm driver
+* Pass in correct volume\_ref to create\_from\_snapshot
+* NetApp direct to filer drivers for iscsi and nfs
+* Add hosts extension to Cinder
+* Remove unused python-daemon dependency
+* Make tox.ini run pep8/hacking checks on bin
+* Various pep8/HACKING fixes for Cinder
+* Volume RPC API Versioning
+* Remove gen\_uuid()
+* Remove obsolete use\_local\_volumes
+* Import order cleanup per HACKING
+* Remove unused volume API method - remove\_from\_compute()
+* Scheduler API clean up and refactor
+* Remove dm\_setup(remove) call in volume\_delete
+* Add ability to disable secure volume delete
+* Remove the zeroing out of the volume altogether
+* Add 'create\_volume' to scheduler RPC API
+* Fix run\_tests.sh ambiguous usage msg and behaviour for -x option
+* Add admin only action for force detach
+* Changes bit mode of zadara.py to 644
+* Port openstack-common/uuidutils to Cinder
+* Fix 401 from auth\_token middleware
+* Splitting out volume drivers in driver.py
+* Minor optimization in create\_volume in HpSanISCSIDriver
+* Adding a SSH Connection Pool
+* Fixes 3par driver methods that were double locking
+* Return volume type name on volume create
+* pin sqlalchemy to the 0.7 series
+* Add VolumeTenantAttribute API extension
+* Log the body of an /action
+* Detect and fix issues caused by vol ID migration
+* Split out drivers in san.py
+* Add VolumeHostAttribute API extension
+* Add default volume type flag
+* Fix typo so setting volume\_tmp\_dir works
+* Rollback for resources during volume creation failure
+* Allow the user to update a volume's metadata
+* Add the generation of the username and password for iSCSI target
+* Update HACKING.rst and related changes from Nova/PEP8
+* Add trove classifiers for PyPI
+* Ensure device node exists before wiping during volume deletion
+* Update volume and snapshot status on delete
+* Drop unused quota\_usage db methods
+* Drop duplicate sqlalchemy db api methods
+* Change output strings to i18ned
+* Adds support for Windows 2012 Storage Server blueprint windows2012driver https://blueprints.launchpad.net/cinder/+spec/windows2012driver
+* Update common
+* Fix incorrect class path for legacycinder formatter in logging\_sample.conf
+* Error message references incorrect variable
+* Loosen anyjson dependency to avoid clash with ceilometer
+* Configuration Options clean up
+* Fix typo in policy documentation
+* Add snapshot force delete admin action
+* Mock out sleep in some retry tests
+* Use policy based rule to define context.is\_admin
+* Sync openstack common and add policy
+* Fix typo in sample configuration file
+* Update distribute version in test requires
+* Revert explicit usage of tgt-adm --conf option
+* Fixes remove\_export for IetAdm
+* Add missing entries in setup, fix up pip-requires
+* Fix NetAppCmodeISCSIDriver.\_get\_lun\_handle() method
+* Remove unused code: check\_for\_export
+* Return 400 if create volume snapshot force parameter is invalid
+* Fix cinder-volume-usage-audit
+* Sync with nova change I135ed85a
+* Remove cinder gating hack
+* Set the default availability zone back to nova
+* Add lun number (0) to model\_update in HpSanDriver
+* Fixes to the SolarisISCSI Driver
+* Stop double logging to the console
+* Restore SIGPIPE default action for subprocesses
+* Replace builtin hash with MD5 to solve 32/64-bit issues
+* Correct IetAdm remove\_iscsi\_target
+* Add nova migrate\_version check to cinder import
+* Bump version to 2013.1
+* Clean up db.volume\_create()
+* Fix volume deletion when device mapper is used
+* Update quota when deleting volume that failed to be scheduled
+* Sync a change to rpc from openstack-common
+* Add a resume delete on volume manager startup
+* Improve entity validation in volumes APIs
+* Add entity body validation helper
+* Should've added super().tearDown() in test\_iscsi
+* Fixes bug 1050135
+* Fix FLAGS.volumes\_dir help message
+* Use tmpdir and avoid leaving test files behind
+* Sync log format changes from openstack-common
+* Update rpc from openstack-common
+* Add volume quota in volume/api.py and olume/manager.py
+* Fixes bug 1049446
+* Revert "Don't zero out snapshot volume on snapshot\_delete"
+* Add update to volume and snapshot controllers
+* Nail the pip requirement at 1.1
+* Clean up .gitignore
+* Prevent from bug #1008866 is reverted
+* rename nova.pot => cinder.pot, nova.po => cinder.po
+* Don't zero out snapshot volume on snapshot\_delete
+* Recent changes to SolidFire API changed iqn format
+* Remove unused utils.wrap\_exception
+* Sync notifier changes from openstack-common
+* Clean up some codes about compute in VolumeTestCase
+* Remove unused db api
+* Typo nova => cinder
+* Remove vpn\_ping function in cinder/utils.py
+* Update SolidFire driver to reflect IQN changes
+* Rename test\_nova\_rootwrap.py to test\_cinder\_rootwrap.py
+* Fixes potential bugs found by pylint
+* Handle missing 'provider\_location' in rm\_export
+* Specify the conf file when creating a volume
+* avoid the buffer cache when copying volumes
+* Fix Typo in LOG.error
+* Remove dependencies for netaddr
+* Filter volumes and snapshots by query string
+* Remove null\_kernel option
+* Remove default\_schedule\_zone
+* Remove memcached\_servers config option
+* Regenerate cinder.conf.sample
+* Sync improvements to config file generator tools
+* Sync misc changes from openstack-common
+* Sync zmq changes from openstack-common
+* Sync cfg changes from openstack-common
+* Fix xml metadata for volumes api in cinder
+* Fix bug where image size is incorrectly rejected
+* Several hacking compliance fixes
+* Remove Cheetah from pip-requires
+* Update dev docs   \* Quick pass at implementing the basics for cinder dev docs   \* Remove the N/A compute related stuff   \* Clean up the architecture a bit to only show cinder related   \* Remove various modules form TOC's that aren't applicable
+* Typo fix: nova => cinder
+* Move newly created NFS exceptions to standard location in exception.py Addresses bug 1037619
+* Add admin actions extension
+* Removed unnecessary call to ensure\_export
+* Add cinder- prefix to all binaries
+* Make size optional when creating a volume from a snap
+* Fix creation of iscsi targets
+* Spelling: Persistant=>Persistent
+* Implement volume quota support in Cinder
+* Remove unused return values and commented out code from NFS driver
+* Remove unused flags
+* Fix PEP8 issues
+* Fix incorrect tgt-admin call in create\_iscsi\_target
+* Add 'detaching' to volume status
+* Typo fix in cinder: existant => existent
+* Make glance image service check base exception classes
+* Fix PEP8 issues
+* Remove unused exceptions from cinder/exception.py
+* Add nosehtmloutput as a test dependency
+* Migrate volume related quota info in db migration
+* Use event.listen() instead of deprecated listeners kwarg
+* Add declare for xiv driver in fake\_flags
+* Remove logging in volume tests
+* Call driver for attach/detach\_volume
+* Fix spelling typos
+* Remove unused function
+* blueprint zadara-volume-driver
+* Adding the volume notifications to cinder
+* add ability to clone images
+* Update SolidFire volume driver
+* Add proper support for deprecation messages
+* Remove utils.deprecated functions
+* Move volume size validation to api layer
+* Map internal exceptions in the nova style
+* Add driver for using files on a generic NFS server as virtual block devices Add NetApp-specific NFS virtual block driver
+* Implements bp migrate-nova-volumes-to-cinder
+* add get\_location method for images
+* rbd: implement create\_volume\_from\_snapshot
+* Replace deprecated client with python-glanceclient
+* Remove unused imports
+* Fix check\_for\_export() in non-exporting drivers
+* Adds new volume API extensions
+* Driver for IBM XIV storage
+* Fake requests in tests should be to v1
+* Add C-mode driver for NetApp
+* storwize-svc: improved test coverage and fixes
+* Use setuptools-git
+* Add iscsiadm path for qauntal
+* Create unique volumes\_dir for testing
+* Remove redundant 'availability\_zone' config options
+* Straight port of the NetApp driver updates from nova-volume to cinder
+* Use volume driver specific execeptions
+* Admin users should be restricted from seeing all snapshots by default
+* Use openstack.common.notifier
+* Admin users should be restricted from seeing all volumes by default
+* Deprecate root\_helper in favor of rootwrap\_config
+* Send 'create volume from snapshot' to the proper host
+* Add persistent volumes for tgtd
+* Scheduler-clean-up
+* Include AUTHORS file in MANIFEST.in
+* Add authors for IBM Storwize and SVC driver
+* Driver for IBM Storwize and SVC storage
+* Remove unused instance\_name\_template flag
+* Allow XML payload for volume creation
+* Include volume\_metadata with object on vol create
+* Trim volume type representation
+* Port nova-rootwrap changes to cinder-rootwrap
+* Don't do PEP8 test for openstack-common code
+* Cleanup unused code in servce.py
+* Use openstack.common.setup
+* utils module is still being used by cinder-volume service
+* Remove unused fake memcache client
+* Remove unused check\_snapshots\_enabled
+* Use openstack.common.log for logging
+* Don't create volumes if an incorrect size was given
+* Use rpc from openstack-common
+* Add missing gettextutils from openstack-common
+* Use save\_and\_reraise\_exception() from common
+* Use openstack.common.cfg.CONF
+* Remove cinder.log usage from cinder.rpc
+* Remove cinder.context dependency from cinder.rpc
+* Localize rpc options to rpc code
+* Add version to scheduler rpc API
+* Sync cfg and iniparser from openstack-common
+* Use cfg's new global CONF object
+* Make use of openstack.common.jsonutils
+* Sync with latest version of openstack.common.cfg
+* Convert Cinder to use openstack-common jsonutils
+* Add missing ack to impl\_qpid
+* Move queue\_get\_for() from db to rpc
+* Add base support for rpc API versioning
+* Make kombu support optional for running unit tests
+* Stop using cinder.exception from cinder.rpc
+* Remove unused synchronization decorator
+* Remove 'cinder-manage config convert'
+* Use cfg's new behavior of reset() clearing overrides
+* Remove unused enabled\_apis flag
+* Remove some unused helper scripts
+* Remove unused wrap\_errors decorator
+* Remove unused get\_{id,version}\_from\_href()
+* Remove unused metadata serialization
+* Remove unused raise\_http\_conflict\_for\_instance\_invalid\_state()
+* Remove unused OverLimitFault
+* Remove old flagfile support
+* Misused and not used config options
+* Pass 'cinder' project into ConfigOpts
+* Sync to newer openstack.common.cfg
+* Convert Cinder to use openstack-common timeutils
+* Do not duplicate nova docs in cinder
+* Remove unused db api methods
+* Create single initial Cinder DB migration file
+* Updated HpSanISCSIDriver to use initialize/terminate methods
+* Pruned Authors file to active contributors (from nova-volumes)
+* Move nova-manage.rst to cinder-manage.rst
+* Add action extensions to support nova integration
+* Revert "Add action extensions to support nova integration."
+* Fix volume['id'] from integer to string
+* Add action extensions to support nova integration
+* Set pep8 version to 1.1 in test\_requires
+* Fix topics so that the do not collide with nova
+* Fix up coverage and jenkins test running
+* Remove instance Foreign Key in volumes table, replace with instance\_uuid
+* Align the tox.ini file
+* Removed cinder/api/openstack/compute and moved the relevant pieces under cinder/api/openstack/volume. Fixes bug 994177
+* Initial fork out of Nova
diff -pruN 2:15.0.1-1/cinder/api/common.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/common.py
--- 2:15.0.1-1/cinder/api/common.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/common.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,12 +13,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-
+import enum
 import json
 import os
 import re
 
-import enum
 from oslo_config import cfg
 from oslo_log import log as logging
 from six.moves import urllib
@@ -203,7 +202,7 @@ def remove_version_from_href(href):
 
     """
     parsed_url = urllib.parse.urlsplit(href)
-    url_parts = parsed_url.path.split('/', 2)
+    url_parts = parsed_url.path.split('/')
 
     # NOTE: this should match vX.X or vX
     expression = re.compile(r'^v([0-9]+|[0-9]+\.[0-9]+)(/.*|$)')
@@ -386,6 +385,14 @@ def get_enabled_resource_filters(resourc
         return {}
 
 
+def get_time_comparsion_operators():
+    """Get list of time comparsion operators.
+
+    This method returns list which contains the allowed comparsion operators.
+    """
+    return ["gt", "gte", "eq", "neq", "lt", "lte"]
+
+
 def convert_filter_attributes(filters, resource):
     for key in filters.copy().keys():
         if resource in ['volume', 'backup',
diff -pruN 2:15.0.1-1/cinder/api/contrib/admin_actions.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/contrib/admin_actions.py
--- 2:15.0.1-1/cinder/api/contrib/admin_actions.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/contrib/admin_actions.py	2020-03-24 18:46:31.000000000 +0000
@@ -174,7 +174,7 @@ class VolumeAdminController(AdminControl
 
         try:
             self.volume_api.terminate_connection(context, volume, connector)
-        except exception.VolumeBackendAPIException as error:
+        except exception.VolumeBackendAPIException:
             msg = _("Unable to terminate volume connection from backend.")
             raise webob.exc.HTTPInternalServerError(explanation=msg)
 
diff -pruN 2:15.0.1-1/cinder/api/contrib/cgsnapshots.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/contrib/cgsnapshots.py
--- 2:15.0.1-1/cinder/api/contrib/cgsnapshots.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/contrib/cgsnapshots.py	2020-03-24 18:46:31.000000000 +0000
@@ -68,7 +68,7 @@ class CgsnapshotsController(wsgi.Control
         except exception.InvalidGroupSnapshot as e:
             raise exc.HTTPBadRequest(explanation=six.text_type(e))
         except (exception.GroupSnapshotNotFound,
-                exception.PolicyNotAuthorized) as e:
+                exception.PolicyNotAuthorized):
             # Exceptions will be handled at the wsgi level
             raise
         except Exception:
diff -pruN 2:15.0.1-1/cinder/api/contrib/quotas.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/contrib/quotas.py
--- 2:15.0.1-1/cinder/api/contrib/quotas.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/contrib/quotas.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,10 +13,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import webob
-
 from oslo_log import log as logging
 from oslo_utils import strutils
+import webob
 
 from cinder.api import extensions
 from cinder.api.openstack import wsgi
diff -pruN 2:15.0.1-1/cinder/api/contrib/types_extra_specs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/contrib/types_extra_specs.py
--- 2:15.0.1-1/cinder/api/contrib/types_extra_specs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/contrib/types_extra_specs.py	2020-03-24 18:46:31.000000000 +0000
@@ -26,6 +26,7 @@ from cinder import context as ctxt
 from cinder import db
 from cinder import exception
 from cinder.i18n import _
+from cinder.image import image_utils
 from cinder.policies import type_extra_specs as policy
 from cinder import rpc
 from cinder.volume import volume_types
@@ -71,6 +72,10 @@ class VolumeTypeExtraSpecsController(wsg
         self._check_type(context, type_id)
         specs = body['extra_specs']
 
+        if 'image_service:store_id' in specs:
+            image_service_store_id = specs['image_service:store_id']
+            image_utils.validate_stores_id(context, image_service_store_id)
+
         db.volume_type_extra_specs_update_or_create(context,
                                                     type_id,
                                                     specs)
@@ -95,6 +100,10 @@ class VolumeTypeExtraSpecsController(wsg
             expl = _('Request body and URI mismatch')
             raise webob.exc.HTTPBadRequest(explanation=expl)
 
+        if 'image_service:store_id' in body:
+            image_service_store_id = body['image_service:store_id']
+            image_utils.validate_stores_id(context, image_service_store_id)
+
         db.volume_type_extra_specs_update_or_create(context,
                                                     type_id,
                                                     body)
diff -pruN 2:15.0.1-1/cinder/api/contrib/volume_actions.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/contrib/volume_actions.py
--- 2:15.0.1-1/cinder/api/contrib/volume_actions.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/contrib/volume_actions.py	2020-03-24 18:46:31.000000000 +0000
@@ -30,6 +30,7 @@ from cinder import exception
 from cinder.i18n import _
 from cinder.policies import volume_actions as policy
 from cinder import volume
+from cinder.volume import volume_utils
 
 
 CONF = cfg.CONF
@@ -221,9 +222,8 @@ class VolumeActionsController(wsgi.Contr
             # Clone volume encryption key: the current key cannot
             # be reused because it will be deleted when the volume is
             # deleted.
-            encryption_key_id = self._key_manager.store(
-                context,
-                self._key_manager.get(context, volume.encryption_key_id))
+            encryption_key_id = volume_utils.clone_encryption_key(
+                context, self._key_manager, volume.encryption_key_id)
 
             image_metadata['cinder_encryption_key_id'] = encryption_key_id
             image_metadata['cinder_encryption_key_deletion_policy'] = \
diff -pruN 2:15.0.1-1/cinder/api/contrib/volume_image_metadata.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/contrib/volume_image_metadata.py
--- 2:15.0.1-1/cinder/api/contrib/volume_image_metadata.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/contrib/volume_image_metadata.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,11 +13,10 @@
 #   under the License.
 
 """The Volume Image Metadata API extension."""
+from oslo_log import log as logging
 from six.moves import http_client
 import webob
 
-from oslo_log import log as logging
-
 from cinder.api import common
 from cinder.api import extensions
 from cinder.api.openstack import wsgi
@@ -29,7 +28,6 @@ from cinder import objects
 from cinder.policies import volume_metadata as policy
 from cinder import volume
 
-
 LOG = logging.getLogger(__name__)
 
 
diff -pruN 2:15.0.1-1/cinder/api/contrib/volume_transfer.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/contrib/volume_transfer.py
--- 2:15.0.1-1/cinder/api/contrib/volume_transfer.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/contrib/volume_transfer.py	2020-03-24 18:46:31.000000000 +0000
@@ -61,6 +61,8 @@ class VolumeTransferController(wsgi.Cont
         context = req.environ['cinder.context']
         filters = req.params.copy()
         LOG.debug('Listing volume transfers')
+        if 'name' in filters:
+            filters['display_name'] = filters.pop('name')
         transfers = self.transfer_api.get_all(context, filters=filters,
                                               sort_keys=['created_at', 'id'],
                                               sort_dirs=['asc', 'asc'])
diff -pruN 2:15.0.1-1/cinder/api/extensions.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/extensions.py
--- 2:15.0.1-1/cinder/api/extensions.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/extensions.py	2020-03-24 18:46:31.000000000 +0000
@@ -281,7 +281,7 @@ def load_standard_extensions(ext_mgr, lo
                          (package, relpkg, root, classname))
 
             if ext_list is not None and classname not in ext_list:
-                logger.debug("Skipping extension: %s" % classpath)
+                logger.debug("Skipping extension: %s", classpath)
                 continue
 
             try:
diff -pruN 2:15.0.1-1/cinder/api/microversions.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/microversions.py
--- 2:15.0.1-1/cinder/api/microversions.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/microversions.py	2020-03-24 18:46:31.000000000 +0000
@@ -159,6 +159,8 @@ GROUP_GROUPSNAPSHOT_PROJECT_ID = '3.58'
 
 SUPPORT_TRANSFER_PAGINATION = '3.59'
 
+VOLUME_TIME_COMPARISON_FILTER = '3.60'
+
 
 def get_mv_header(version):
     """Gets a formatted HTTP microversion header.
diff -pruN 2:15.0.1-1/cinder/api/openstack/api_version_request.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/openstack/api_version_request.py
--- 2:15.0.1-1/cinder/api/openstack/api_version_request.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/openstack/api_version_request.py	2020-03-24 18:46:31.000000000 +0000
@@ -135,6 +135,10 @@ REST_API_VERSION_HISTORY = """
              detail, list group snapshots with detail, show group detail and
              show group snapshot detail APIs.
     * 3.59 - Support volume transfer pagination.
+    * 3.60 - Support filtering on the "updated_at" and "created_at" fields with
+             time comparison operators for the volume summary list
+             ("GET /v3/{project_id}/volumes") and volume detail list
+             ("GET /v3/{project_id}/volumes/detail") requests.
 """
 
 # The minimum and maximum versions of the API supported
@@ -142,7 +146,7 @@ REST_API_VERSION_HISTORY = """
 # minimum version of the API supported.
 # Explicitly using /v2 endpoints will still work
 _MIN_API_VERSION = "3.0"
-_MAX_API_VERSION = "3.59"
+_MAX_API_VERSION = "3.60"
 _LEGACY_API_VERSION2 = "2.0"
 UPDATED = "2018-07-17T00:00:00Z"
 
diff -pruN 2:15.0.1-1/cinder/api/openstack/__init__.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/openstack/__init__.py
--- 2:15.0.1-1/cinder/api/openstack/__init__.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/openstack/__init__.py	2020-03-24 18:46:31.000000000 +0000
@@ -31,7 +31,7 @@ LOG = logging.getLogger(__name__)
 
 class APIMapper(routes.Mapper):
     def routematch(self, url=None, environ=None):
-        if url is "":
+        if url == "":
             result = self._match("", environ)
             return result[0], result[1]
         return routes.Mapper.routematch(self, url, environ)
diff -pruN 2:15.0.1-1/cinder/api/openstack/rest_api_version_history.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/openstack/rest_api_version_history.rst
--- 2:15.0.1-1/cinder/api/openstack/rest_api_version_history.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/openstack/rest_api_version_history.rst	2020-03-24 18:46:31.000000000 +0000
@@ -463,3 +463,7 @@ detail APIs.
 ---------------------------------
 Support volume transfer pagination.
 
+3.60
+----
+Add 'created_at' and 'updated_at' to support users can list/detail volumes by
+specifying the time comparison operators along with created_at or updated_at.
diff -pruN 2:15.0.1-1/cinder/api/openstack/wsgi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/openstack/wsgi.py
--- 2:15.0.1-1/cinder/api/openstack/wsgi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/openstack/wsgi.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,13 +14,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-# TODO(smcginnis) update this once six has support for collections.abc
-# (https://github.com/benjaminp/six/pull/241) or clean up once we drop py2.7.
-try:
-    from collections.abc import Callable
-except ImportError:
-    from collections import Callable
-
+from collections import abc
 import functools
 import inspect
 import math
@@ -39,15 +33,12 @@ import webob.exc
 from cinder.api.openstack import api_version_request as api_version
 from cinder.api.openstack import versioned_method
 from cinder import exception
-
 from cinder import i18n
 i18n.enable_lazy()
-
 from cinder.i18n import _
 from cinder import utils
 from cinder.wsgi import common as wsgi
 
-
 LOG = logging.getLogger(__name__)
 
 SUPPORTED_CONTENT_TYPES = (
@@ -609,13 +600,11 @@ class ResourceExceptionHandler(object):
             raise Fault(exception.ConvertedException(
                 code=ex_value.code, explanation=six.text_type(ex_value)))
         elif isinstance(ex_value, TypeError):
-            exc_info = (ex_type, ex_value, ex_traceback)
-            LOG.error('Exception handling resource: %s',
-                      ex_value, exc_info=exc_info)
+            LOG.exception('Exception handling resource:')
             raise Fault(webob.exc.HTTPBadRequest())
         elif isinstance(ex_value, Fault):
             LOG.info("Fault thrown: %s", ex_value)
-            raise ex_value
+            raise
         elif isinstance(ex_value, webob.exc.HTTPException):
             LOG.info("HTTP exception thrown: %s", ex_value)
             raise Fault(ex_value)
@@ -1095,7 +1084,7 @@ class ControllerMetaclass(type):
                 versioned_methods.append(getattr(base, VER_METHOD_ATTR))
 
         for key, value in cls_dict.items():
-            if not isinstance(value, Callable):
+            if not isinstance(value, abc.Callable):
                 continue
             if getattr(value, 'wsgi_action', None):
                 actions[value.wsgi_action] = key
diff -pruN 2:15.0.1-1/cinder/api/schemas/volume_types.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/schemas/volume_types.py
--- 2:15.0.1-1/cinder/api/schemas/volume_types.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/schemas/volume_types.py	2020-03-24 18:46:31.000000000 +0000
@@ -44,7 +44,7 @@ update = {
         'volume_type': {
             'type': 'object',
             'properties': {
-                'name': parameter_types.name_allow_zero_min_length,
+                'name': parameter_types.update_name,
                 'description': parameter_types.description,
                 'is_public': parameter_types.boolean,
             },
diff -pruN 2:15.0.1-1/cinder/api/v2/volumes.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/v2/volumes.py
--- 2:15.0.1-1/cinder/api/v2/volumes.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/v2/volumes.py	2020-03-24 18:46:31.000000000 +0000
@@ -282,7 +282,7 @@ class VolumeController(wsgi.Controller):
 
     def _get_volume_filter_options(self):
         """Return volume search options allowed by non-admin."""
-        return common.get_enabled_resource_filters('volume')['volume']
+        return common.get_enabled_resource_filters('volume').get('volume', [])
 
     @validation.schema(volumes.update, mv.V2_BASE_VERSION,
                        mv.get_prior_version(mv.SUPPORT_VOLUME_SCHEMA_CHANGES))
diff -pruN 2:15.0.1-1/cinder/api/v3/attachments.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/v3/attachments.py
--- 2:15.0.1-1/cinder/api/v3/attachments.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/v3/attachments.py	2020-03-24 18:46:31.000000000 +0000
@@ -190,7 +190,7 @@ class AttachmentsController(wsgi.Control
             err_msg = _(
                 "Unable to create attachment for volume (%s).") % ex.msg
             LOG.exception(err_msg)
-        except Exception as ex:
+        except Exception:
             err_msg = _("Unable to create attachment for volume.")
             LOG.exception(err_msg)
         finally:
diff -pruN 2:15.0.1-1/cinder/api/v3/volumes.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/v3/volumes.py
--- 2:15.0.1-1/cinder/api/v3/volumes.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/v3/volumes.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,6 +15,7 @@
 
 from oslo_log import log as logging
 from oslo_log import versionutils
+from oslo_utils import timeutils
 import six
 from six.moves import http_client
 import webob
@@ -90,10 +91,44 @@ class VolumeController(volumes_v2.Volume
         if req_version.matches(None, mv.BACKUP_UPDATE):
             filters.pop('group_id', None)
 
+        if req_version.matches(None, mv.SUPPORT_TRANSFER_PAGINATION):
+            filters.pop('created_at', None)
+            filters.pop('updated_at', None)
+
         api_utils.remove_invalid_filter_options(
             context, filters,
             self._get_volume_filter_options())
 
+    def _handle_time_comparison_filters(self, filters):
+        for time_comparison_filter in ['created_at', 'updated_at']:
+            if time_comparison_filter in filters:
+                time_filter_dict = {}
+                comparison_units = filters[time_comparison_filter].split(',')
+                operators = common.get_time_comparsion_operators()
+                for comparison_unit in comparison_units:
+                    try:
+                        operator_and_time = comparison_unit.split(":")
+                        comparison_operator = operator_and_time[0]
+                        time = ''
+                        for time_str in operator_and_time[1:-1]:
+                            time += time_str + ":"
+                        time += operator_and_time[-1]
+                        if comparison_operator not in operators:
+                            msg = _(
+                                'Invalid %s operator') % comparison_operator
+                            raise exc.HTTPBadRequest(explanation=msg)
+                    except IndexError:
+                        msg = _('Invalid %s value') % time_comparison_filter
+                        raise exc.HTTPBadRequest(explanation=msg)
+                    try:
+                        parsed_time = timeutils.parse_isotime(time)
+                    except ValueError:
+                        msg = _('Invalid %s value') % time
+                        raise exc.HTTPBadRequest(explanation=msg)
+                    time_filter_dict[comparison_operator] = parsed_time
+
+                filters[time_comparison_filter] = time_filter_dict
+
     def _get_volumes(self, req, is_detail):
         """Returns a list of volumes, transformed through view builder."""
 
@@ -121,6 +156,8 @@ class VolumeController(volumes_v2.Volume
         if 'name' in filters:
             filters['display_name'] = filters.pop('name')
 
+        self._handle_time_comparison_filters(filters)
+
         strict = req.api_version_request.matches(
             mv.VOLUME_LIST_BOOTABLE, None)
         self.volume_api.check_volume_filters(filters, strict)
@@ -207,8 +244,6 @@ class VolumeController(volumes_v2.Volume
             self.volume_api.revert_to_snapshot(context, volume, l_snap)
         except (exception.InvalidVolume, exception.InvalidSnapshot) as e:
             raise exc.HTTPConflict(explanation=six.text_type(e))
-        except exception.VolumeSizeExceedsAvailableQuota as e:
-            raise exc.HTTPForbidden(explanation=six.text_type(e))
 
     def _get_image_snapshot(self, context, image_uuid):
         image_snapshot = None
diff -pruN 2:15.0.1-1/cinder/api/v3/volume_transfer.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/v3/volume_transfer.py
--- 2:15.0.1-1/cinder/api/v3/volume_transfer.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/v3/volume_transfer.py	2020-03-24 18:46:31.000000000 +0000
@@ -46,6 +46,8 @@ class VolumeTransferController(volume_tr
             # as default order, but we should keep the compatible in here.
             sort_keys, sort_dirs = ['created_at', 'id'], ['asc', 'asc']
         filters = params
+        if 'name' in filters:
+            filters['display_name'] = filters.pop('name')
         LOG.debug('Listing volume transfers')
 
         transfers = self.transfer_api.get_all(context, marker=marker,
diff -pruN 2:15.0.1-1/cinder/api/validation/parameter_types.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/validation/parameter_types.py
--- 2:15.0.1-1/cinder/api/validation/parameter_types.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/validation/parameter_types.py	2020-03-24 18:46:31.000000000 +0000
@@ -67,7 +67,7 @@ def _build_regex_range(ws=True, invert=F
 
     The inversion is useful when we want to generate a set of ranges
     which is everything that's not a certain class. For instance,
-    produce all all the non printable characters as a set of ranges.
+    produce all the non printable characters as a set of ranges.
     """
     if exclude is None:
         exclude = []
@@ -125,6 +125,11 @@ name = {
 }
 
 
+update_name = {
+    'type': ['string', 'null'], 'minLength': 1, 'maxLength': 255
+}
+
+
 description = {
     'type': ['string', 'null'], 'minLength': 0, 'maxLength': 255,
     'pattern': valid_description_regex,
diff -pruN 2:15.0.1-1/cinder/api/views/backups.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/views/backups.py
--- 2:15.0.1-1/cinder/api/views/backups.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/api/views/backups.py	2020-03-24 18:46:31.000000000 +0000
@@ -31,7 +31,8 @@ class ViewBuilder(common.ViewBuilder):
 
     def detail_list(self, request, backups, backup_count=None):
         """Detailed view of a list of backups ."""
-        return self._list_view(self.detail, request, backups, backup_count)
+        return self._list_view(self.detail, request, backups, backup_count,
+                               self._collection_name + '/detail')
 
     def summary(self, request, backup):
         """Generic, non-detailed view of a backup."""
@@ -80,12 +81,13 @@ class ViewBuilder(common.ViewBuilder):
 
         return backup_dict
 
-    def _list_view(self, func, request, backups, backup_count):
+    def _list_view(self, func, request, backups, backup_count,
+                   coll_name=_collection_name):
         """Provide a view for a list of backups."""
         backups_list = [func(request, backup)['backup'] for backup in backups]
         backups_links = self._get_collection_links(request,
                                                    backups,
-                                                   self._collection_name,
+                                                   coll_name,
                                                    backup_count)
         backups_dict = dict(backups=backups_list)
 
diff -pruN 2:15.0.1-1/cinder/backup/api.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/backup/api.py
--- 2:15.0.1-1/cinder/backup/api.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/backup/api.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,18 +15,17 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Handles all requests relating to the volume backups service.
-"""
+"""Handles all requests relating to the volume backups service."""
 
 from datetime import datetime
+import random
+
 from eventlet import greenthread
 from oslo_config import cfg
 from oslo_log import log as logging
 from oslo_utils import excutils
 from oslo_utils import strutils
 from pytz import timezone
-import random
 
 from cinder.backup import rpcapi as backup_rpcapi
 from cinder.common import constants
@@ -41,8 +40,8 @@ from cinder.policies import backups as p
 import cinder.policy
 from cinder import quota
 from cinder import quota_utils
+from cinder.scheduler import rpcapi as scheduler_rpcapi
 import cinder.volume
-from cinder.volume import volume_utils
 
 backup_opts = [
     cfg.BoolOpt('backup_use_same_host',
@@ -62,6 +61,7 @@ class API(base.Base):
 
     def __init__(self, db=None):
         self.backup_rpcapi = backup_rpcapi.BackupAPI()
+        self.scheduler_rpcapi = scheduler_rpcapi.SchedulerAPI()
         self.volume_api = cinder.volume.API()
         super(API, self).__init__(db)
 
@@ -228,10 +228,6 @@ class API(base.Base):
             raise exception.InvalidVolume(reason=msg)
 
         previous_status = volume['status']
-        volume_host = volume_utils.extract_host(volume.host, 'host')
-        availability_zone = availability_zone or volume.availability_zone
-        host = self._get_available_backup_service_host(volume_host,
-                                                       availability_zone)
 
         # Reserve a quota before setting volume status and backup status
         try:
@@ -314,8 +310,6 @@ class API(base.Base):
                 'container': container,
                 'parent_id': parent_id,
                 'size': volume['size'],
-                'host': host,
-                'availability_zone': availability_zone,
                 'snapshot_id': snapshot_id,
                 'data_timestamp': data_timestamp,
                 'parent': parent,
@@ -335,10 +329,7 @@ class API(base.Base):
                 finally:
                     QUOTAS.rollback(context, reservations)
 
-        # TODO(DuncanT): In future, when we have a generic local attach,
-        #                this can go via the scheduler, which enables
-        #                better load balancing and isolation of services
-        self.backup_rpcapi.create_backup(context, backup)
+        self.scheduler_rpcapi.create_backup(context, backup)
 
         return backup
 
diff -pruN 2:15.0.1-1/cinder/backup/chunkeddriver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/backup/chunkeddriver.py
--- 2:15.0.1-1/cinder/backup/chunkeddriver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/backup/chunkeddriver.py	2020-03-24 18:46:31.000000000 +0000
@@ -717,9 +717,12 @@ class ChunkedBackupDriver(driver.BackupD
                 LOG.debug('decompressing data using %s algorithm',
                           compression_algorithm)
                 decompressed = decompressor.decompress(body)
+                body = None  # Allow Python to free it
                 volume_file.write(decompressed)
+                decompressed = None  # Allow Python to free it
             else:
                 volume_file.write(body)
+                body = None  # Allow Python to free it
 
             # force flush every write to avoid long blocking write on close
             volume_file.flush()
diff -pruN 2:15.0.1-1/cinder/backup/drivers/ceph.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/backup/drivers/ceph.py
--- 2:15.0.1-1/cinder/backup/drivers/ceph.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/backup/drivers/ceph.py	2020-03-24 18:46:31.000000000 +0000
@@ -976,7 +976,7 @@ class CephBackupDriver(driver.BackupDriv
                     self.delete_backup(backup)
         else:
             if backup.parent_id:
-                LOG.debug("Volume file is NOT RBD: can't perform"
+                LOG.debug("Volume file is NOT RBD: can't perform "
                           "incremental backup.")
                 raise exception.BackupRBDOperationFailed
             LOG.debug("Volume file is NOT RBD: will do full backup.")
diff -pruN 2:15.0.1-1/cinder/backup/manager.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/backup/manager.py
--- 2:15.0.1-1/cinder/backup/manager.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/backup/manager.py	2020-03-24 18:46:31.000000000 +0000
@@ -71,9 +71,10 @@ backup_manager_opts = [
                help='Time in seconds between checks to see if the backup '
                     'driver has been successfully initialized, any time '
                     'the driver is restarted.'),
-    cfg.IntOpt('backup_driver_status_check_interval',
+    cfg.IntOpt('backup_driver_stats_polling_interval',
                default=60,
                min=10,
+               deprecated_name='backup_driver_status_check_interval',
                help='Time in seconds between checks of the backup driver '
                     'status.  If does not report as working, it is '
                     'restarted.'),
@@ -111,7 +112,7 @@ SERVICE_PGRP = '' if os.name == 'nt' els
 # writes/reads and the compression/decompression calls.
 # (https://github.com/eventlet/eventlet/issues/432)
 
-class BackupManager(manager.ThreadPoolManager):
+class BackupManager(manager.SchedulerDependentManager):
     """Manages backup of block storage devices."""
 
     RPC_API_VERSION = backup_rpcapi.BackupAPI.RPC_API_VERSION
@@ -135,12 +136,6 @@ class BackupManager(manager.ThreadPoolMa
             self.driver_name = new_name
         self.service = importutils.import_class(self.driver_name)
 
-    def _update_backup_error(self, backup, err,
-                             status=fields.BackupStatus.ERROR):
-        backup.status = status
-        backup.fail_reason = err
-        backup.save()
-
     def init_host(self, **kwargs):
         """Run initialization needed for a standalone service."""
         ctxt = context.get_admin_context()
@@ -157,6 +152,7 @@ class BackupManager(manager.ThreadPoolMa
         backups = objects.BackupList.get_all_by_host(ctxt, self.host)
         self._add_to_threadpool(key_migration.migrate_fixed_key,
                                 backups=backups)
+        self.publish_service_capabilities(ctxt)
 
     def _setup_backup_driver(self, ctxt):
         backup_service = self.service(context=ctxt, db=self.db)
@@ -237,7 +233,7 @@ class BackupManager(manager.ThreadPoolMa
             self._cleanup_one_volume(ctxt, volume)
 
             err = 'incomplete backup reset on manager restart'
-            self._update_backup_error(backup, err)
+            volume_utils.update_backup_error(backup, err)
         elif backup['status'] == fields.BackupStatus.RESTORING:
             LOG.info('Resetting backup %s to '
                      'available (was restoring).',
@@ -358,10 +354,6 @@ class BackupManager(manager.ThreadPoolMa
 
         self._notify_about_backup_usage(context, backup, "create.start")
 
-        backup.host = self.host
-        backup.availability_zone = self.az
-        backup.save()
-
         expected_status = "backing-up"
         if snapshot_id:
             actual_status = snapshot['status']
@@ -371,7 +363,7 @@ class BackupManager(manager.ThreadPoolMa
                     'expected_status': expected_status,
                     'actual_status': actual_status,
                 }
-                self._update_backup_error(backup, err)
+                volume_utils.update_backup_error(backup, err)
                 raise exception.InvalidSnapshot(reason=err)
         else:
             actual_status = volume['status']
@@ -381,7 +373,7 @@ class BackupManager(manager.ThreadPoolMa
                     'expected_status': expected_status,
                     'actual_status': actual_status,
                 }
-                self._update_backup_error(backup, err)
+                volume_utils.update_backup_error(backup, err)
                 raise exception.InvalidVolume(reason=err)
 
         expected_status = fields.BackupStatus.CREATING
@@ -392,13 +384,13 @@ class BackupManager(manager.ThreadPoolMa
                 'expected_status': expected_status,
                 'actual_status': actual_status,
             }
-            self._update_backup_error(backup, err)
+            volume_utils.update_backup_error(backup, err)
             raise exception.InvalidBackup(reason=err)
 
         try:
             if not self.is_working():
                 err = _('Create backup aborted due to backup service is down.')
-                self._update_backup_error(backup, err)
+                volume_utils.update_backup_error(backup, err)
                 raise exception.InvalidBackup(reason=err)
 
             backup.service = self.driver_name
@@ -414,7 +406,7 @@ class BackupManager(manager.ThreadPoolMa
                         context, volume_id,
                         {'status': previous_status,
                          'previous_status': 'error_backing-up'})
-                self._update_backup_error(backup, six.text_type(err))
+                volume_utils.update_backup_error(backup, six.text_type(err))
 
         # Restore the original status.
         if snapshot_id:
@@ -536,9 +528,6 @@ class BackupManager(manager.ThreadPoolMa
         volume = objects.Volume.get_by_id(context, volume_id)
         self._notify_about_backup_usage(context, backup, "restore.start")
 
-        backup.host = self.host
-        backup.save()
-
         expected_status = [fields.VolumeStatus.RESTORING_BACKUP,
                            fields.VolumeStatus.CREATING]
         volume_previous_status = volume['status']
@@ -564,7 +553,7 @@ class BackupManager(manager.ThreadPoolMa
                      '%(expected_status)s but got %(actual_status)s.') %
                    {'expected_status': expected_status,
                     'actual_status': actual_status})
-            self._update_backup_error(backup, err)
+            volume_utils.update_backup_error(backup, err)
             self.db.volume_update(context, volume_id,
                                   {'status': fields.VolumeStatus.ERROR})
             raise exception.InvalidBackup(reason=err)
@@ -715,8 +704,6 @@ class BackupManager(manager.ThreadPoolMa
         LOG.info('Delete backup started, backup: %s.', backup.id)
 
         self._notify_about_backup_usage(context, backup, "delete.start")
-        backup.host = self.host
-        backup.save()
 
         expected_status = fields.BackupStatus.DELETING
         actual_status = backup.status
@@ -725,13 +712,13 @@ class BackupManager(manager.ThreadPoolMa
                     '%(expected_status)s but got %(actual_status)s.') \
                 % {'expected_status': expected_status,
                    'actual_status': actual_status}
-            self._update_backup_error(backup, err)
+            volume_utils.update_backup_error(backup, err)
             raise exception.InvalidBackup(reason=err)
 
         if backup.service and not self.is_working():
             err = _('Delete backup is aborted due to backup service is down.')
             status = fields.BackupStatus.ERROR_DELETING
-            self._update_backup_error(backup, err, status)
+            volume_utils.update_backup_error(backup, err, status)
             raise exception.InvalidBackup(reason=err)
 
         if not self._is_our_backup(backup):
@@ -741,7 +728,7 @@ class BackupManager(manager.ThreadPoolMa
                     ' backup [%(backup_service)s].')\
                 % {'configured_service': self.driver_name,
                    'backup_service': backup.service}
-            self._update_backup_error(backup, err)
+            volume_utils.update_backup_error(backup, err)
             raise exception.InvalidBackup(reason=err)
 
         if backup.service:
@@ -750,7 +737,8 @@ class BackupManager(manager.ThreadPoolMa
                 backup_service.delete_backup(backup)
             except Exception as err:
                 with excutils.save_and_reraise_exception():
-                    self._update_backup_error(backup, six.text_type(err))
+                    volume_utils.update_backup_error(backup,
+                                                     six.text_type(err))
 
         # Get reservations
         try:
@@ -881,7 +869,7 @@ class BackupManager(manager.ThreadPoolMa
                 err = _('Import record failed, cannot find backup '
                         'service to perform the import. Request service '
                         '%(service)s.') % {'service': backup_service}
-                self._update_backup_error(backup, err)
+                volume_utils.update_backup_error(backup, err)
                 raise exception.ServiceNotFound(service_id=backup_service)
         else:
             # Yes...
@@ -895,7 +883,7 @@ class BackupManager(manager.ThreadPoolMa
                 backup_service.import_record(backup, driver_options)
             except Exception as err:
                 msg = six.text_type(err)
-                self._update_backup_error(backup, msg)
+                volume_utils.update_backup_error(backup, msg)
                 raise exception.InvalidBackup(reason=msg)
 
             required_import_options = {
@@ -914,7 +902,7 @@ class BackupManager(manager.ThreadPoolMa
                 msg = (_('Driver successfully decoded imported backup data, '
                          'but there are missing fields (%s).') %
                        ', '.join(missing_opts))
-                self._update_backup_error(backup, msg)
+                volume_utils.update_backup_error(backup, msg)
                 raise exception.InvalidBackup(reason=msg)
 
             # Confirm the ID from the record in the DB is the right one
@@ -923,7 +911,7 @@ class BackupManager(manager.ThreadPoolMa
                 msg = (_('Trying to import backup metadata from id %(meta_id)s'
                          ' into backup %(id)s.') %
                        {'meta_id': backup_id, 'id': backup.id})
-                self._update_backup_error(backup, msg)
+                volume_utils.update_backup_error(backup, msg)
                 raise exception.InvalidBackup(reason=msg)
 
             # Overwrite some fields
@@ -1082,7 +1070,18 @@ class BackupManager(manager.ThreadPoolMa
         return self.is_initialized
 
     @periodic_task.periodic_task(
-        spacing=CONF.backup_driver_status_check_interval)
+        spacing=CONF.backup_driver_stats_polling_interval)
+    def publish_service_capabilities(self, context):
+        """Collect driver status and then publish."""
+        self._report_driver_status(context)
+        self._publish_service_capabilities(context)
+
     def _report_driver_status(self, context):
         if not self.is_working():
             self.setup_backup_backend(context)
+        backup_stats = {
+            'backend_state': self.is_working(),
+            'driver_name': self.driver_name,
+            'availability_zone': self.az
+        }
+        self.update_service_capabilities(backup_stats)
diff -pruN 2:15.0.1-1/cinder/backup/rpcapi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/backup/rpcapi.py
--- 2:15.0.1-1/cinder/backup/rpcapi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/backup/rpcapi.py	2020-03-24 18:46:31.000000000 +0000
@@ -46,9 +46,10 @@ class BackupAPI(rpc.RPCAPI):
 
         2.0 - Remove 1.x compatibility
         2.1 - Adds set_log_levels and get_log_levels
+        2.2 - Adds publish_service_capabilities
     """
 
-    RPC_API_VERSION = '2.1'
+    RPC_API_VERSION = '2.2'
     RPC_DEFAULT_VERSION = '2.0'
     TOPIC = constants.BACKUP_TOPIC
     BINARY = 'cinder-backup'
@@ -58,9 +59,9 @@ class BackupAPI(rpc.RPCAPI):
         cctxt = self._get_cctxt(server=backup.host)
         cctxt.cast(ctxt, 'create_backup', backup=backup)
 
-    def restore_backup(self, ctxt, volume_host, backup, volume_id):
+    def restore_backup(self, ctxt, backup_host, backup, volume_id):
         LOG.debug("restore_backup in rpcapi backup_id %s", backup.id)
-        cctxt = self._get_cctxt(server=volume_host)
+        cctxt = self._get_cctxt(server=backup_host)
         cctxt.cast(ctxt, 'restore_backup', backup=backup,
                    volume_id=volume_id)
 
@@ -111,3 +112,8 @@ class BackupAPI(rpc.RPCAPI):
     def get_log_levels(self, context, service, log_request):
         cctxt = self._get_cctxt(server=service.host, version='2.1')
         return cctxt.call(context, 'get_log_levels', log_request=log_request)
+
+    @rpc.assert_min_rpc_version('2.2')
+    def publish_service_capabilities(self, ctxt):
+        cctxt = self._get_cctxt(version='2.2', fanout=True)
+        cctxt.cast(ctxt, 'publish_service_capabilities')
diff -pruN 2:15.0.1-1/cinder/brick/local_dev/lvm.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/brick/local_dev/lvm.py
--- 2:15.0.1-1/cinder/brick/local_dev/lvm.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/brick/local_dev/lvm.py	2020-03-24 18:46:31.000000000 +0000
@@ -179,7 +179,10 @@ class LVM(executor.Executor):
                 consumed_space = pool_size / 100 * data_percent
                 free_space = pool_size - consumed_space
                 free_space = round(free_space, 2)
-        except putils.ProcessExecutionError as err:
+        # Need noqa due to a false error about the 'err' variable being unused
+        # even though it is used in the logging. Possibly related to
+        # https://github.com/PyCQA/pyflakes/issues/378.
+        except putils.ProcessExecutionError as err:  # noqa
             LOG.exception('Error querying thin pool about data_percent')
             LOG.error('Cmd     :%s', err.cmd)
             LOG.error('StdOut  :%s', err.stdout)
diff -pruN 2:15.0.1-1/cinder/cmd/api.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/cmd/api.py
--- 2:15.0.1-1/cinder/cmd/api.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/cmd/api.py	2020-03-24 18:46:31.000000000 +0000
@@ -17,31 +17,27 @@
 
 """Starter script for Cinder OS API."""
 
-import eventlet
-eventlet.monkey_patch()
-
 import logging as python_logging
 import sys
 
-from cinder import objects
-
+import eventlet  # noqa
+eventlet.monkey_patch()
 from oslo_config import cfg
 from oslo_log import log as logging
 from oslo_reports import guru_meditation_report as gmr
 from oslo_reports import opts as gmr_opts
 
-from cinder import i18n
+from cinder import i18n  # noqa
 i18n.enable_lazy()
-
 # Need to register global_opts
 from cinder.common import config
 from cinder import coordination
+from cinder import objects
 from cinder import rpc
 from cinder import service
 from cinder import utils
 from cinder import version
 
-
 CONF = cfg.CONF
 
 
diff -pruN 2:15.0.1-1/cinder/cmd/backup.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/cmd/backup.py
--- 2:15.0.1-1/cinder/cmd/backup.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/cmd/backup.py	2020-03-24 18:46:31.000000000 +0000
@@ -26,7 +26,6 @@ import sys
 # share the same context.
 import eventlet
 eventlet.monkey_patch()
-
 from oslo_concurrency import processutils
 from oslo_config import cfg
 from oslo_log import log as logging
@@ -34,13 +33,11 @@ from oslo_privsep import priv_context
 from oslo_reports import guru_meditation_report as gmr
 from oslo_reports import opts as gmr_opts
 
-
-from cinder import i18n
-i18n.enable_lazy()
-
 # Need to register global_opts
 from cinder.common import config  # noqa
 from cinder.db import api as session
+from cinder import i18n
+i18n.enable_lazy()
 from cinder import objects
 from cinder import service
 from cinder import utils
@@ -69,6 +66,7 @@ def _launch_backup_process(launcher, num
     try:
         server = service.Service.create(binary='cinder-backup',
                                         coordination=True,
+                                        service_name='backup',
                                         process_number=num_process)
     except Exception:
         LOG.exception('Backup service %s failed to start.', CONF.host)
diff -pruN 2:15.0.1-1/cinder/cmd/manage.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/cmd/manage.py
--- 2:15.0.1-1/cinder/cmd/manage.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/cmd/manage.py	2020-03-24 18:46:31.000000000 +0000
@@ -58,7 +58,6 @@ except ImportError:
     import collections
 
 import logging as python_logging
-import prettytable
 import sys
 import time
 
@@ -67,6 +66,7 @@ from oslo_db import exception as db_exc
 from oslo_db.sqlalchemy import migration
 from oslo_log import log as logging
 from oslo_utils import timeutils
+import tabulate
 
 # Need to register global_opts
 from cinder.backup import rpcapi as backup_rpcapi
@@ -384,11 +384,11 @@ class DbCommands(object):
         headers = ["{}".format(_('Migration')),
                    "{}".format(_('Total Needed')),
                    "{}".format(_('Completed')), ]
-        t = prettytable.PrettyTable(headers)
+        rows = []
         for name in sorted(migration_info.keys()):
             info = migration_info[name]
-            t.add_row([name, info[0], info[1]])
-        print(t)
+            rows.append([name, info[0], info[1]])
+        print(tabulate.tabulate(rows, headers=headers, tablefmt='psql'))
 
         # NOTE(imacdonn): In the "unlimited" case, the loop above will only
         # terminate when all possible migrations have been effected. If we're
@@ -465,8 +465,10 @@ class VolumeCommands(object):
         rpcapi = volume_rpcapi.VolumeAPI()
         rpcapi.delete_volume(ctxt, volume)
 
-    @args('--currenthost', required=True, help='Existing volume host name')
-    @args('--newhost', required=True, help='New volume host name')
+    @args('--currenthost', required=True, help='Existing volume host name in '
+                                               'the format host@backend#pool')
+    @args('--newhost', required=True, help='New volume host name in the '
+                                           'format host@backend#pool')
     def update_host(self, currenthost, newhost):
         """Modify the host name associated with a volume.
 
diff -pruN 2:15.0.1-1/cinder/cmd/scheduler.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/cmd/scheduler.py
--- 2:15.0.1-1/cinder/cmd/scheduler.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/cmd/scheduler.py	2020-03-24 18:46:31.000000000 +0000
@@ -17,22 +17,20 @@
 
 """Starter script for Cinder Scheduler."""
 
-import eventlet
-eventlet.monkey_patch()
-
 import logging as python_logging
 import sys
 
+import eventlet
+eventlet.monkey_patch()
 from oslo_config import cfg
 from oslo_log import log as logging
 from oslo_reports import guru_meditation_report as gmr
 from oslo_reports import opts as gmr_opts
 
-from cinder import i18n
-i18n.enable_lazy()
-
 # Need to register global_opts
 from cinder.common import config  # noqa
+from cinder import i18n
+i18n.enable_lazy()
 from cinder import objects
 from cinder import service
 from cinder import utils
diff -pruN 2:15.0.1-1/cinder/cmd/status.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/cmd/status.py
--- 2:15.0.1-1/cinder/cmd/status.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/cmd/status.py	2020-03-24 18:46:31.000000000 +0000
@@ -18,21 +18,19 @@
 import os
 import sys
 
+from oslo_config import cfg
+from oslo_upgradecheck import upgradecheck as uc
+
 from cinder import context
 from cinder import db
 from cinder import exception
 from cinder import objects
-from cinder import service  # noqa
-from oslo_config import cfg
-from oslo_upgradecheck import upgradecheck as uc
-
 from cinder.policy import DEFAULT_POLICY_FILENAME
-import cinder.service  # noqa
-
+# Need to import service to load config
+from cinder import service  # noqa
 # We must first register Cinder's objects. Otherwise
 # we cannot import the volume manager.
 objects.register_all()
-
 import cinder.volume.manager as volume_manager
 
 CONF = cfg.CONF
@@ -40,10 +38,18 @@ CONF = cfg.CONF
 SUCCESS = uc.Code.SUCCESS
 FAILURE = uc.Code.FAILURE
 WARNING = uc.Code.WARNING
-REMOVED_DRVRS = ["coprhd",
-                 "drbdmanage",
-                 "disco",
-                 "hgst", ]
+REMOVED_DRVRS = [
+    "coprhd",
+    "drbdmanage",
+    "disco",
+    "hgst",
+    "fusionstorage",
+    "prophetstor",
+    "nimble",
+    "sheepdog",
+    "vzstorage",
+    "veritas_access",
+]
 
 
 def _get_enabled_drivers():
diff -pruN 2:15.0.1-1/cinder/cmd/volume.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/cmd/volume.py
--- 2:15.0.1-1/cinder/cmd/volume.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/cmd/volume.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,11 +16,14 @@
 #    under the License.
 
 """Starter script for Cinder Volume."""
+import logging as python_logging
+import os
+import re
+import shlex
+import sys
 
 import eventlet
 import eventlet.tpool
-import os
-
 # Monkey patching must go before the oslo.log import, otherwise
 # oslo.context will not use greenthread thread local and all greenthreads
 # will share the same context.
@@ -30,36 +33,25 @@ if os.name == 'nt':
     eventlet.monkey_patch(os=False)
 else:
     eventlet.monkey_patch()
-
-import logging as python_logging
-import re
-
-from cinder import exception
-from cinder import objects
-
-
-import shlex
-import sys
-
 from oslo_config import cfg
 from oslo_log import log as logging
 from oslo_privsep import priv_context
 from oslo_reports import guru_meditation_report as gmr
 from oslo_reports import opts as gmr_opts
 
-from cinder import i18n
-i18n.enable_lazy()
-
 # Need to register global_opts
 from cinder.common import config  # noqa
 from cinder.common import constants
 from cinder.db import api as session
+from cinder import exception
+from cinder import i18n
+i18n.enable_lazy()
 from cinder.i18n import _
+from cinder import objects
 from cinder import service
 from cinder import utils
 from cinder import version
 
-
 CONF = cfg.CONF
 
 host_opt = cfg.StrOpt('backend_host', help='Backend override of host value.')
diff -pruN 2:15.0.1-1/cinder/cmd/volume_usage_audit.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/cmd/volume_usage_audit.py
--- 2:15.0.1-1/cinder/cmd/volume_usage_audit.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/cmd/volume_usage_audit.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,35 +15,35 @@
 #    under the License.
 
 """
-    Cron script to generate usage notifications for volumes existing during
-    the audit period.
+Cron script to generate usage notifications for volumes existing during
+the audit period.
 
-    Together with the notifications generated by volumes
-    create/delete/resize, over that time period, this allows an external
-    system consuming usage notification feeds to calculate volume usage
-    for each tenant.
-
-    Time periods are specified as 'hour', 'month', 'day' or 'year'
-
-    - `hour` - previous hour. If run at 9:07am, will generate usage for
-      8-9am.
-    - `month` - previous month. If the script is run April 1, it will
-      generate usages for March 1 through March 31.
-    - `day` -  previous day. if run on July 4th, it generates usages for
-      July 3rd.
-    - `year` - previous year. If run on Jan 1, it generates usages for
-      Jan 1 through Dec 31 of the previous year.
+Together with the notifications generated by volumes
+create/delete/resize, over that time period, this allows an external
+system consuming usage notification feeds to calculate volume usage
+for each tenant.
+
+Time periods are specified as 'hour', 'month', 'day' or 'year'
+
+- `hour` - previous hour. If run at 9:07am, will generate usage for
+  8-9am.
+- `month` - previous month. If the script is run April 1, it will
+  generate usages for March 1 through March 31.
+- `day` -  previous day. if run on July 4th, it generates usages for
+  July 3rd.
+- `year` - previous year. If run on Jan 1, it generates usages for
+  Jan 1 through Dec 31 of the previous year.
 
 """
 
 import datetime
-import iso8601
 import sys
 
+import iso8601
 from oslo_config import cfg
 from oslo_log import log as logging
 
-from cinder import i18n
+from cinder import i18n  # noqa
 i18n.enable_lazy()
 from cinder import context
 from cinder.i18n import _
diff -pruN 2:15.0.1-1/cinder/db/sqlalchemy/api.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/db/sqlalchemy/api.py
--- 2:15.0.1-1/cinder/db/sqlalchemy/api.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/db/sqlalchemy/api.py	2020-03-24 18:46:31.000000000 +0000
@@ -18,14 +18,8 @@
 
 """Implementation of SQLAlchemy backend."""
 
-
 import collections
-
-try:
-    from collections.abc import Iterable
-except ImportError:
-    from collections import Iterable
-
+from collections import abc
 import datetime as dt
 import functools
 import itertools
@@ -419,6 +413,27 @@ def _filter_host(field, value, match_lev
     return or_(*conditions)
 
 
+def _filter_time_comparison(field, time_filter_dict):
+    """Generate a filter condition for time comparison operators"""
+
+    conditions = []
+    for operator in time_filter_dict:
+        filter_time = timeutils.normalize_time(time_filter_dict[operator])
+        if operator == 'gt':
+            conditions.append(field.op('>')(filter_time))
+        elif operator == 'gte':
+            conditions.append(field.op('>=')(filter_time))
+        if operator == 'eq':
+            conditions.append(field.op('=')(filter_time))
+        elif operator == 'neq':
+            conditions.append(field.op('!=')(filter_time))
+        if operator == 'lt':
+            conditions.append(field.op('<')(filter_time))
+        elif operator == 'lte':
+            conditions.append(field.op('<=')(filter_time))
+    return or_(*conditions)
+
+
 def _clustered_bool_field_filter(query, field_name, filter_value):
     # Now that we have clusters, a service is disabled/frozen if the service
     # doesn't belong to a cluster or if it belongs to a cluster and the cluster
@@ -1658,35 +1673,33 @@ def volume_data_get_for_project(context,
                                         volume_type_id, host=host)
 
 
+VOLUME_DEPENDENT_MODELS = frozenset([models.VolumeMetadata,
+                                     models.VolumeAdminMetadata,
+                                     models.Transfer,
+                                     models.VolumeGlanceMetadata,
+                                     models.VolumeAttachment])
+
+
 @require_admin_context
 @oslo_db_api.wrap_db_retry(max_retries=5, retry_on_deadlock=True)
 def volume_destroy(context, volume_id):
     session = get_session()
     now = timeutils.utcnow()
+    updated_values = {'status': 'deleted',
+                      'deleted': True,
+                      'deleted_at': now,
+                      'updated_at': literal_column('updated_at'),
+                      'migration_status': None}
     with session.begin():
-        updated_values = {'status': 'deleted',
-                          'deleted': True,
-                          'deleted_at': now,
-                          'updated_at': literal_column('updated_at'),
-                          'migration_status': None}
         model_query(context, models.Volume, session=session).\
             filter_by(id=volume_id).\
             update(updated_values)
-        model_query(context, models.VolumeMetadata, session=session).\
-            filter_by(volume_id=volume_id).\
-            update({'deleted': True,
-                    'deleted_at': now,
-                    'updated_at': literal_column('updated_at')})
-        model_query(context, models.VolumeAdminMetadata, session=session).\
-            filter_by(volume_id=volume_id).\
-            update({'deleted': True,
-                    'deleted_at': now,
-                    'updated_at': literal_column('updated_at')})
-        model_query(context, models.Transfer, session=session).\
-            filter_by(volume_id=volume_id).\
-            update({'deleted': True,
-                    'deleted_at': now,
-                    'updated_at': literal_column('updated_at')})
+        for model in VOLUME_DEPENDENT_MODELS:
+            model_query(context, model, session=session).\
+                filter_by(volume_id=volume_id).\
+                update({'deleted': True,
+                        'deleted_at': now,
+                        'updated_at': literal_column('updated_at')})
     del updated_values['updated_at']
     return updated_values
 
@@ -1720,7 +1733,7 @@ def _include_in_cluster(context, cluster
         value = filters.pop(field)
         # We do a special backend filter
         query = query.filter(_filter_host(getattr(model, field), value))
-        # If we want do do a partial rename and we haven't set the cluster
+        # If we want to do a partial rename and we haven't set the cluster
         # already, the value we want to set is a SQL replace of existing field
         # value.
         if partial_rename and isinstance(cluster, six.string_types):
@@ -2441,6 +2454,19 @@ def _process_volume_filters(query, filte
         query = query.filter(_filter_host(models.Volume.cluster_name,
                                           cluster_name))
 
+    for time_comparison_filter in ['created_at', 'updated_at']:
+        if filters.get(time_comparison_filter, None):
+            time_filter_dict = filters.pop(time_comparison_filter)
+            try:
+                time_filter_attr = getattr(models.Volume,
+                                           time_comparison_filter)
+                query = query.filter(_filter_time_comparison(time_filter_attr,
+                                                             time_filter_dict))
+            except AttributeError:
+                LOG.debug("%s column could not be found.",
+                          time_comparison_filter)
+                return None
+
     # Apply exact match filters for everything else, ensure that the
     # filter value exists on the model
     for key in filters.keys():
@@ -5083,7 +5109,7 @@ def volume_glance_metadata_copy_from_vol
                                                       volume_id):
     """Update the Glance metadata for a volume.
 
-    This copies all all of the key:value pairs from the originating volume,
+    This copies all of the key:value pairs from the originating volume,
     to ensure that a volume created from the volume (clone) will
     retain the original metadata.
     """
@@ -7135,7 +7161,7 @@ def condition_db_filter(model, field, va
     """
     orm_field = getattr(model, field)
     # For values that must match and are iterables we use IN
-    if (isinstance(value, Iterable) and
+    if (isinstance(value, abc.Iterable) and
             not isinstance(value, six.string_types)):
         # We cannot use in_ when one of the values is None
         if None not in value:
@@ -7161,7 +7187,7 @@ def condition_not_db_filter(model, field
     result = ~condition_db_filter(model, field, value)
 
     if (auto_none
-            and ((isinstance(value, Iterable) and
+            and ((isinstance(value, abc.Iterable) and
                   not isinstance(value, six.string_types)
                   and None not in value)
                  or (value is not None))):
diff -pruN 2:15.0.1-1/cinder/db/sqlalchemy/migrate_repo/manage.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/db/sqlalchemy/migrate_repo/manage.py
--- 2:15.0.1-1/cinder/db/sqlalchemy/migrate_repo/manage.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/db/sqlalchemy/migrate_repo/manage.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,10 +15,10 @@
 
 import os
 
-from cinder.db.sqlalchemy import migrate_repo
-
 from migrate.versioning.shell import main
 
+from cinder.db.sqlalchemy import migrate_repo
+
 
 if __name__ == '__main__':
     main(debug='False',
diff -pruN 2:15.0.1-1/cinder/db/sqlalchemy/migrate_repo/versions/133_placeholder.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/db/sqlalchemy/migrate_repo/versions/133_placeholder.py
--- 2:15.0.1-1/cinder/db/sqlalchemy/migrate_repo/versions/133_placeholder.py	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/db/sqlalchemy/migrate_repo/versions/133_placeholder.py	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,22 @@
+#    Licensed under the Apache License, Version 2.0 (the "License"); you may
+#    not use this file except in compliance with the License. You may obtain
+#    a copy of the License at
+#
+#         http://www.apache.org/licenses/LICENSE-2.0
+#
+#    Unless required by applicable law or agreed to in writing, software
+#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+#    License for the specific language governing permissions and limitations
+#    under the License.
+
+# This is a placeholder for Train backports.
+# Do not use this number for new Ussuri work. New work starts after all the
+# placeholders.
+#
+# See this for more information:
+# http://lists.openstack.org/pipermail/openstack-dev/2013-March/006827.html
+
+
+def upgrade(migrate_engine):
+    pass
diff -pruN 2:15.0.1-1/cinder/db/sqlalchemy/migrate_repo/versions/134_placeholder.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/db/sqlalchemy/migrate_repo/versions/134_placeholder.py
--- 2:15.0.1-1/cinder/db/sqlalchemy/migrate_repo/versions/134_placeholder.py	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/db/sqlalchemy/migrate_repo/versions/134_placeholder.py	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,22 @@
+#    Licensed under the Apache License, Version 2.0 (the "License"); you may
+#    not use this file except in compliance with the License. You may obtain
+#    a copy of the License at
+#
+#         http://www.apache.org/licenses/LICENSE-2.0
+#
+#    Unless required by applicable law or agreed to in writing, software
+#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+#    License for the specific language governing permissions and limitations
+#    under the License.
+
+# This is a placeholder for Train backports.
+# Do not use this number for new Ussuri work. New work starts after all the
+# placeholders.
+#
+# See this for more information:
+# http://lists.openstack.org/pipermail/openstack-dev/2013-March/006827.html
+
+
+def upgrade(migrate_engine):
+    pass
diff -pruN 2:15.0.1-1/cinder/db/sqlalchemy/migrate_repo/versions/135_placeholder.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/db/sqlalchemy/migrate_repo/versions/135_placeholder.py
--- 2:15.0.1-1/cinder/db/sqlalchemy/migrate_repo/versions/135_placeholder.py	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/db/sqlalchemy/migrate_repo/versions/135_placeholder.py	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,22 @@
+#    Licensed under the Apache License, Version 2.0 (the "License"); you may
+#    not use this file except in compliance with the License. You may obtain
+#    a copy of the License at
+#
+#         http://www.apache.org/licenses/LICENSE-2.0
+#
+#    Unless required by applicable law or agreed to in writing, software
+#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+#    License for the specific language governing permissions and limitations
+#    under the License.
+
+# This is a placeholder for Train backports.
+# Do not use this number for new Ussuri work. New work starts after all the
+# placeholders.
+#
+# See this for more information:
+# http://lists.openstack.org/pipermail/openstack-dev/2013-March/006827.html
+
+
+def upgrade(migrate_engine):
+    pass
diff -pruN 2:15.0.1-1/cinder/db/sqlalchemy/migrate_repo/versions/136_make_vol_type_col_non_nullable.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/db/sqlalchemy/migrate_repo/versions/136_make_vol_type_col_non_nullable.py
--- 2:15.0.1-1/cinder/db/sqlalchemy/migrate_repo/versions/136_make_vol_type_col_non_nullable.py	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/db/sqlalchemy/migrate_repo/versions/136_make_vol_type_col_non_nullable.py	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,52 @@
+#    Licensed under the Apache License, Version 2.0 (the "License"); you may
+#    not use this file except in compliance with the License. You may obtain
+#    a copy of the License at
+#
+#         http://www.apache.org/licenses/LICENSE-2.0
+#
+#    Unless required by applicable law or agreed to in writing, software
+#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+#    License for the specific language governing permissions and limitations
+#    under the License.
+
+from sqlalchemy import MetaData, Table
+
+from cinder import exception
+from cinder.i18n import _
+
+
+def upgrade(migrate_engine):
+    """Make volume_type columns non-nullable"""
+
+    meta = MetaData(bind=migrate_engine)
+
+    # Update volume_type columns in tables to not allow null value
+
+    volumes = Table('volumes', meta, autoload=True)
+
+    try:
+        volumes.c.volume_type_id.alter(nullable=False)
+    except Exception:
+        msg = (_('Migration cannot continue until all volumes have '
+                 'been migrated to the `__DEFAULT__` volume type. Please '
+                 'run `cinder-manage db online_data_migrations`. '
+                 'There are still untyped volumes unmigrated.'))
+        raise exception.ValidationError(msg)
+
+    snapshots = Table('snapshots', meta, autoload=True)
+
+    try:
+        snapshots.c.volume_type_id.alter(nullable=False)
+    except Exception:
+        msg = (_('Migration cannot continue until all snapshots have '
+                 'been migrated to the `__DEFAULT__` volume type. Please '
+                 'run `cinder-manage db online_data_migrations`.'
+                 'There are still %(count)i untyped snapshots unmigrated.'))
+        raise exception.ValidationError(msg)
+
+    encryption = Table('encryption', meta, autoload=True)
+    # since volume_type is a mandatory arg when creating encryption
+    # volume_type_id column won't contain any null values so we can directly
+    # alter it
+    encryption.c.volume_type_id.alter(nullable=False)
diff -pruN 2:15.0.1-1/cinder/exception.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/exception.py
--- 2:15.0.1-1/cinder/exception.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/exception.py	2020-03-24 18:46:31.000000000 +0000
@@ -331,6 +331,14 @@ class NotFound(CinderException):
     safe = True
 
 
+class GlanceStoreNotFound(NotFound):
+    message = _("Store %(store_id)s not enabled in glance.")
+
+
+class GlanceStoreReadOnly(Invalid):
+    message = _("Store %(store_id)s is read-only in glance.")
+
+
 class VolumeNotFound(NotFound):
     message = _("Volume %(volume_id)s could not be found.")
 
@@ -1117,3 +1125,8 @@ class CinderAcceleratorError(CinderExcep
                 "Command %(cmd)s execution failed.\n"
                 "%(description)s\n"
                 "Reason: %(reason)s")
+
+
+class SnapshotLimitReached(CinderException):
+    message = _("Exceeded the configured limit of "
+                "%(set_limit)s snapshots per volume.")
diff -pruN 2:15.0.1-1/cinder/image/cache.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/image/cache.py
--- 2:15.0.1-1/cinder/image/cache.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/image/cache.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,12 +12,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-from pytz import timezone
-import six
-
 from oslo_config import cfg
 from oslo_log import log as logging
 from oslo_utils import timeutils
+from pytz import timezone
+import six
 
 from cinder import objects
 from cinder import rpc
diff -pruN 2:15.0.1-1/cinder/image/glance.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/image/glance.py
--- 2:15.0.1-1/cinder/image/glance.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/image/glance.py	2020-03-24 18:46:31.000000000 +0000
@@ -216,9 +216,15 @@ class GlanceClientWrapper(object):
                       glanceclient.exc.InvalidEndpoint,
                       glanceclient.exc.CommunicationError)
         num_attempts = 1 + CONF.glance_num_retries
+        store_id = kwargs.pop('store_id', None)
 
         for attempt in range(1, num_attempts + 1):
             client = self.client or self._create_onetime_client(context)
+            if store_id:
+                client.http_client.additional_headers = {
+                    'x-image-meta-store': store_id
+                }
+
             try:
                 controller = getattr(client,
                                      kwargs.pop('controller', 'images'))
@@ -287,6 +293,14 @@ class GlanceImageService(object):
         except Exception:
             _reraise_translated_image_exception(image_id)
 
+    def get_stores(self, context):
+        """Returns a list of dicts with stores information."""
+        try:
+            return self._client.call(context,
+                                     'get_stores_info')
+        except Exception:
+            _reraise_translated_exception()
+
     def show(self, context, image_id):
         """Returns a dict with image data for the given opaque image id."""
         try:
@@ -380,7 +394,8 @@ class GlanceImageService(object):
         return self._translate_from_glance(context, recv_service_image_meta)
 
     def update(self, context, image_id,
-               image_meta, data=None, purge_props=True):
+               image_meta, data=None, purge_props=True,
+               store_id=None):
         """Modify the given image with the new data."""
         # For v2, _translate_to_glance stores custom properties in image meta
         # directly. We need the custom properties to identify properties to
@@ -394,9 +409,13 @@ class GlanceImageService(object):
         # NOTE(bcwaldon): id is not an editable field, but it is likely to be
         # passed in by calling code. Let's be nice and ignore it.
         image_meta.pop('id', None)
+        kwargs = {}
+        if store_id:
+            kwargs['store_id'] = store_id
+
         try:
             if data:
-                self._client.call(context, 'upload', image_id, data)
+                self._client.call(context, 'upload', image_id, data, **kwargs)
             if image_meta:
                 if purge_props:
                     # Properties to remove are those not specified in
diff -pruN 2:15.0.1-1/cinder/image/image_utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/image/image_utils.py
--- 2:15.0.1-1/cinder/image/image_utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/image/image_utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -48,6 +48,7 @@ import six
 from cinder import exception
 from cinder.i18n import _
 from cinder.image import accelerator
+from cinder.image import glance
 from cinder import utils
 from cinder.volume import throttling
 from cinder.volume import volume_utils
@@ -63,14 +64,20 @@ image_opts = [
                 default=True,
                 help='When possible, compress images uploaded '
                 'to the image service'),
+    cfg.IntOpt('image_conversion_cpu_limit',
+               default=60,
+               help='CPU time limit in seconds to convert the image'),
+    cfg.IntOpt('image_conversion_address_space_limit',
+               default=1,
+               help='Address space limit in gigabytes to convert the image'),
 ]
 
 CONF = cfg.CONF
 CONF.register_opts(image_opts)
 
 QEMU_IMG_LIMITS = processutils.ProcessLimits(
-    cpu_time=30,
-    address_space=1 * units.Gi)
+    cpu_time=CONF.image_conversion_cpu_limit,
+    address_space=CONF.image_conversion_address_space_limit * units.Gi)
 
 
 QEMU_IMG_FORMAT_MAP = {
@@ -88,6 +95,19 @@ QEMU_IMG_MIN_CONVERT_LUKS_VERSION = '2.1
 COMPRESSIBLE_IMAGE_FORMATS = ('qcow2',)
 
 
+def validate_stores_id(context, image_service_store_id):
+    image_service = glance.get_default_image_service()
+    stores_info = image_service.get_stores(context)['stores']
+    for info in stores_info:
+        if image_service_store_id == info['id']:
+            if info.get('read-only') == "true":
+                raise exception.GlanceStoreReadOnly(
+                    store_id=image_service_store_id)
+            return
+
+    raise exception.GlanceStoreNotFound(store_id=image_service_store_id)
+
+
 def fixup_disk_format(disk_format):
     """Return the format to be provided to qemu-img convert."""
 
@@ -660,7 +680,8 @@ def _validate_file_format(image_data, ex
 
 
 def upload_volume(context, image_service, image_meta, volume_path,
-                  volume_format='raw', run_as_root=True, compress=True):
+                  volume_format='raw', run_as_root=True, compress=True,
+                  store_id=None):
     image_id = image_meta['id']
     if image_meta.get('container_format') != 'compressed':
         if (image_meta['disk_format'] == volume_format):
@@ -669,12 +690,14 @@ def upload_volume(context, image_service
             if os.name == 'nt' or os.access(volume_path, os.R_OK):
                 with open(volume_path, 'rb') as image_file:
                     image_service.update(context, image_id, {},
-                                         tpool.Proxy(image_file))
+                                         tpool.Proxy(image_file),
+                                         store_id=store_id)
             else:
                 with utils.temporary_chown(volume_path):
                     with open(volume_path, 'rb') as image_file:
                         image_service.update(context, image_id, {},
-                                             tpool.Proxy(image_file))
+                                             tpool.Proxy(image_file),
+                                             store_id=store_id)
             return
 
     with temporary_file() as tmp:
@@ -716,7 +739,8 @@ def upload_volume(context, image_service
             accel.compress_img(run_as_root=run_as_root)
         with open(tmp, 'rb') as image_file:
             image_service.update(context, image_id, {},
-                                 tpool.Proxy(image_file))
+                                 tpool.Proxy(image_file),
+                                 store_id=store_id)
 
 
 def check_virtual_size(virtual_size, volume_size, image_id):
diff -pruN 2:15.0.1-1/cinder/interface/volume_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/interface/volume_driver.py
--- 2:15.0.1-1/cinder/interface/volume_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/interface/volume_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -207,6 +207,9 @@ class VolumeDriverCore(base.CinderInterf
     def terminate_connection(self, volume, connector):
         """Remove access to a volume.
 
+        Note: If ``connector`` is ``None``, then all connections to the volume
+        should be terminated.
+
         :param volume: The volume to remove.
         :param connector: The Dictionary containing information about the
                           connection. This is optional when doing a
diff -pruN 2:15.0.1-1/cinder/keymgr/migration.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/keymgr/migration.py
--- 2:15.0.1-1/cinder/keymgr/migration.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/keymgr/migration.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,13 +16,12 @@
 import binascii
 import itertools
 
-from oslo_config import cfg
-from oslo_log import log as logging
-
 from barbicanclient import client as barbican_client
 from castellan import options as castellan_options
 from keystoneauth1 import loading as ks_loading
 from keystoneauth1 import session as ks_session
+from oslo_config import cfg
+from oslo_log import log as logging
 
 from cinder import context
 from cinder import coordination
diff -pruN 2:15.0.1-1/cinder/locale/de/LC_MESSAGES/cinder.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/de/LC_MESSAGES/cinder.po
--- 2:15.0.1-1/cinder/locale/de/LC_MESSAGES/cinder.po	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/de/LC_MESSAGES/cinder.po	2020-03-24 18:46:31.000000000 +0000
@@ -14,11 +14,11 @@ msgid ""
 msgstr ""
 "Project-Id-Version: cinder VERSION\n"
 "Report-Msgid-Bugs-To: https://bugs.launchpad.net/openstack-i18n/\n"
-"POT-Creation-Date: 2019-10-04 05:27+0000\n"
+"POT-Creation-Date: 2020-03-18 14:40+0000\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"PO-Revision-Date: 2019-10-03 06:57+0000\n"
+"PO-Revision-Date: 2019-10-03 07:02+0000\n"
 "Last-Translator: Andreas Jaeger <jaegerandi@gmail.com>\n"
 "Language: de\n"
 "Plural-Forms: nplurals=2; plural=(n != 1);\n"
@@ -121,12 +121,6 @@ msgstr ""
 "werden unterstützt, tatsächlicher Modus ist %(vol_mode)s."
 
 #, python-format
-msgid "%(service)s Service is not %(status)s on storage appliance: %(host)s"
-msgstr ""
-"%(service)s-Dienst befindet sich nicht %(status)s auf der Speicher-"
-"Appliance: %(host)s"
-
-#, python-format
 msgid ""
 "%(worker_name)s value of %(workers)d is invalid, must be greater than 0."
 msgstr ""
@@ -175,10 +169,6 @@ msgid "%s is not installed"
 msgstr "%s ist nicht installiert."
 
 #, python-format
-msgid "%s is not installed."
-msgstr "%s ist nicht installiert."
-
-#, python-format
 msgid "%s is not set"
 msgstr "%s ist nicht festgelegt"
 
@@ -201,10 +191,6 @@ msgid "%s must be an absolute path."
 msgstr "%s muss ein absoluter Pfad sein."
 
 #, python-format
-msgid "%s not set in cinder.conf"
-msgstr "%s in cinder.conf nicht festgelegt."
-
-#, python-format
 msgid "%s not set."
 msgstr "%s nicht festgelegt."
 
@@ -229,14 +215,6 @@ msgstr "'consistencygroup_id' muss angeg
 msgid "'qemu-img info' parsing failed."
 msgstr "Auswertung von 'qemu-img info' fehlgeschlagen."
 
-#, python-format
-msgid ""
-"(Command: %(cmd)s) (Return Code: %(exit_code)s) (Stdout: %(stdout)s) "
-"(Stderr: %(stderr)s)"
-msgstr ""
-"(Befehl: %(cmd)s) (Rückgabecode: %(exit_code)s) (Standardausgabe: "
-"%(stdout)s) (Standard-Fehlerausgabe: %(stderr)s)"
-
 msgid "A concurrent, possibly contradictory, request has been made."
 msgstr ""
 "Es wurde eine gleichzeitige, möglicherweise widersprüchliche, Anforderung "
@@ -326,14 +304,6 @@ msgstr ""
 "Fehler während der LUNcopy-Operation. LUNcopy-Name: %(luncopyname)s. LUNcopy-"
 "Status: %(luncopystatus)s. LUNcopy-Zustand: %(luncopystate)s."
 
-#, python-format
-msgid "An error occurred while reading volume \"%s\"."
-msgstr "Beim Lesen von Datenträger \"%s\" ist ein Fehler aufgetreten."
-
-#, python-format
-msgid "An error occurred while writing to volume \"%s\"."
-msgstr "Beim Schreiben auf Datenträger \"%s\" ist ein Fehler aufgetreten."
-
 msgid "An unknown error occurred."
 msgstr "Ein unbekannter Fehler ist aufgetreten."
 
@@ -417,9 +387,6 @@ msgstr "Verfügbare Kategorien:"
 msgid "Backend doesn't exist (%(backend)s)"
 msgstr "Backend ist nicht vorhanden (%(backend)s)."
 
-msgid "Backend storage did not configure fiber channel target."
-msgstr "Backend-Speicher hat Fibre Channel-Ziel nicht konfiguriert. "
-
 msgid "Backing up an in-use volume must use the force flag."
 msgstr ""
 "Für die Sicherung eines Datenträgers mit dem Status 'in-use' muss das force-"
@@ -538,12 +505,6 @@ msgstr ""
 msgid "CPG (%s) doesn't exist on array"
 msgstr "CPG (%s) ist im Array nicht vorhanden."
 
-#, python-format
-msgid "Cache volume %s does not have required properties"
-msgstr ""
-"Der Zwischenspeicherdatenträger %s hat nicht die erforderlichen "
-"Eigenschaften."
-
 msgid "Can not add FC port to host."
 msgstr "FC-Port kann nicht zu Host hinzugefügt werden."
 
@@ -683,10 +644,6 @@ msgstr ""
 "VF-Kontext kann nicht geändert werden. Die angegebene VF ist nicht in der "
 "Liste der verwaltbaren VFs %(vf_list)s enthalten."
 
-#, python-format
-msgid "Cannot create directory %s."
-msgstr "Verzeichnis %s kann nicht erstellt werden."
-
 msgid "Cannot create encryption specs. Volume type in use."
 msgstr ""
 "Verschlüsselungsspezifikationen können nicht erstellt werden. Datenträgertyp "
@@ -711,24 +668,6 @@ msgstr ""
 "volume_type mit dem Namen %(name)s und der Spezifikation %(extra_specs)s "
 "kann nicht erstellt werden."
 
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)d volume instances."
-msgstr ""
-"Zwischenspeicherdatenträger %(cachevol_name)s kann nicht gelöscht werden. Er "
-"wurde am %(updated_at)s aktualisiert und enthält zurzeit %(numclones)d "
-"Datenträgerinstanzen."
-
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)s volume instances."
-msgstr ""
-"Der Zwischenspeicherdatenträger %(cachevol_name)s kann nicht gelöscht "
-"werden. Er wurde am %(updated_at)s aktualisiert und enthält zurzeit "
-"%(numclones)s Datenträgerinstanzen."
-
 msgid "Cannot delete encryption specs. Volume type in use."
 msgstr ""
 "Verschlüsselungsspezifikationen können nicht gelöscht werden. Datenträgertyp "
@@ -801,11 +740,6 @@ msgstr ""
 "Durch die Änderung wäre die Nutzung kleiner als 0 für die folgenden "
 "Ressourcen: %(unders)s"
 
-msgid "Check access permissions for the ZFS share assigned to this driver."
-msgstr ""
-"Prüfen Sie die Zugriffsberechtigungen für die diesem Treiber zugeordneten "
-"freigegebenen ZFS-Verzeichnisse."
-
 msgid "Check hostgroup associate error."
 msgstr "Fehler beim Prüfen der Hostgruppenzuordnung."
 
@@ -821,13 +755,6 @@ msgstr "Fehler beim Prüfen der LUN-Grup
 msgid "Check portgroup associate error."
 msgstr "Fehler beim Prüfen der Portgruppenzuordnung."
 
-msgid ""
-"Check the state of the http service. Also ensure that the https port number "
-"is the same as the one specified in cinder.conf."
-msgstr ""
-"Prüfen Sie den Zustand des http-Diensts. Stellen Sie auch sicher, dass die "
-"https-Portnummer der in cinder.conf angegebenen Portnummer entspricht."
-
 msgid "Chunk size is not multiple of block size for creating hash."
 msgstr ""
 "Chunkgröße ist kein Vielfaches der Blockgröße zur Bildung des Hashwerts."
@@ -847,12 +774,6 @@ msgstr ""
 msgid "Cluster"
 msgstr "Cluster"
 
-msgid ""
-"Cluster is not formatted. You should probably perform \"dog cluster format\"."
-msgstr ""
-"Cluster ist nicht formatiert. Sie müssen möglicherweise \"dog cluster format"
-"\" ausführen."
-
 #, python-format
 msgid "CommandLineHelper._wait_for_condition: %s timeout."
 msgstr "CommandLineHelper._wait_for_condition: %s Zeitlimit."
@@ -872,12 +793,6 @@ msgstr "Compute-Cluster: %(cluster)s nic
 msgid "Condition has no field."
 msgstr "Die Bedingung hat kein Feld."
 
-#, python-format
-msgid "Config 'max_over_subscription_ratio' invalid. Must be > 0: %s"
-msgstr ""
-"Die Konfiguration von 'max_over_subscription_ratio' ist ungültig. Muss > 0 "
-"sein: %s"
-
 msgid "Configuration error: dell_sc_ssn not set."
 msgstr "Konfigurationsfehler: dell_sc_ssn ist nicht festgelegt."
 
@@ -930,6 +845,10 @@ msgid "Converted to %(f1)s, but format i
 msgstr "In %(f1)s konvertiert, Format ist nun jedoch %(f2)s."
 
 #, python-format
+msgid "Converted to %(vol_format)s, but format is now %(file_format)s"
+msgstr "In %(vol_format)s konvertiert, Format ist nun jedoch %(file_format)s."
+
+#, python-format
 msgid "Converted to raw, but format is now %s"
 msgstr "In unformatierten Zustand konvertiert, Format ist nun jedoch %s"
 
@@ -1323,203 +1242,6 @@ msgstr ""
 "Stellen Sie sicher, dass configfs an /sys/kernel/config eingehängt ist."
 
 #, python-format
-msgid ""
-"Error Cloning Snapshot: %(snapshot)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Clone project: %(clone_proj)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Fehler beim Klonen von Schattenkopie %(snapshot)s für Datenträger %(lun)s "
-"von Pool %(pool)s Projekt: %(project)s Klonprojekt: %(clone_proj)s. "
-"Rückgabecode: %(ret.status)d Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Initiator: %(initiator)s on Alias: %(alias)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Fehler beim Erstellen von Initiator %(initiator)s für Alias: %(alias)s "
-"Rückgabecode: %(ret.status)d Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Fehler beim Erstellen von Projekt %(project)s für Pool %(pool)s "
-"Rückgabecode: %(ret.status)d Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Property: %(property)s Type: %(type)s Description: "
-"%(description)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Fehler beim Erstellen der Eigenschaft: %(property)s Typ: %(type)s "
-"Beschreibung: %(description)s Rückgabecode: %(ret.status)d Nachricht: "
-"%(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Share: %(name)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Fehler beim Erstellen von freigegebenem Verzeichnis %(name)s. Rückgabecode: "
-"%(ret.status)d Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Volume: %(lun)s Size: %(size)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"Fehler beim Erstellen von Datenträger %(lun)s Größe: %(size)s Rückgabecode: "
-"%(ret.status)d Nachricht: %(ret.data)s. "
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Share: %(share)s to Pool: %(pool)s "
-"Project: %(project)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Fehler beim Löschen von Schattenkopie %(snapshot)s für freigegebenes "
-"Verzeichnis %(share)s aus Pool %(pool)s Projekt: %(project)s  Rückgabecode: "
-"%(ret.status)d Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Volume: %(lun)s to Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Fehler beim Löschen von Schattenkopie %(snapshot)s für Datenträger %(lun)s "
-"aus Pool: %(pool)s Projekt: %(project)s.  Rückgabecode: %(ret.status)d "
-"Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Volume: %(lun)s from Pool: %(pool)s, Project: %(project)s. "
-"Return code: %(ret.status)d, Message: %(ret.data)s."
-msgstr ""
-"Fehler beim Löschen des Datenträgers %(lun)s aus Pool %(pool)s, Projekt: "
-"%(project)s. Rückgabecode: %(ret.status)d, Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting project: %(project)s on pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Fehler beim Löschen des Projekts: %(project)s auf Pool: %(pool)s. "
-"Rückgabecode: %(ret.status)d Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting replication action: %(id)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"Fehler beim Löschen der Replikationsaktion: %(id)s. Rückgabecode: "
-"%(ret.status)d Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Initiators: InitiatorGroup: %(initiatorgroup)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Fehler beim Abrufen von Initiatoren: InitiatorGroup: %(initiatorgroup)s "
-"Rückgabecode: %(ret.status)d Nachricht: %(ret.data)s ."
-
-#, python-format
-msgid ""
-"Error Getting Pool Stats: Pool: %(pool)s Return code: %(status)d Message: "
-"%(data)s."
-msgstr ""
-"Fehler beim Abrufen der Poolstatistikdaten: Pool: %(pool)s Rückgabecode: "
-"%(status)d Nachricht: %(data)s."
-
-#, python-format
-msgid ""
-"Error Getting Project Stats: Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Fehler beim Abrufen der Projektstatistiken: Pool: %(pool)s Projekt: "
-"%(project)s Rückgabecode: %(ret.status)d Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Share: %(share)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Fehler beim Abrufen von freigegebenem Verzeichnis %(share)s für Pool "
-"%(pool)s Projekt: %(project)s. Rückgabecode: %(ret.status)d Nachricht: "
-"%(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Volume: %(lun)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Fehler beim Abrufen von Datenträger %(lun)s für Pool: %(pool)s Projekt: "
-"%(project)s. Rückgabecode: %(ret.status)d Nachricht: %(ret.data)s."
-
-#, python-format
-msgid "Error Pool ownership: Pool %(pool)s is not owned by %(host)s."
-msgstr ""
-"Fehler bei Pooleigentümer: Eigner des Pools %(pool)s ist nicht %(host)s."
-
-#, python-format
-msgid ""
-"Error Setting props Props: %(props)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Fehler beim Festlegen der Eigenschaften %(props)s für Datenträger %(lun)s "
-"von Pool %(pool)s Projekt: %(project)s. Rückgabecode: %(ret.status)d "
-"Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Initiator: %(iqn)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Fehler beim Überprüfen von Initiator %(iqn)s Rückgabecode: %(ret.status)d "
-"Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Pool: %(pool)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Fehler beim Überprüfen von Pool %(pool)s Rückgabecode: %(ret.status)d "
-"Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Fehler beim Überprüfen von Projekt %(project)s für Pool %(pool)s "
-"Rückgabecode: %(ret.status)d Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Fehler beim Überprüfen des %(service)s-Diensts. Rückgabecode: %(ret.status)d "
-"Nachricht:  %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Target: %(alias)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Fehler beim Überprüfen von Ziel %(alias)s Rückgabecode: %(ret.status)d "
-"Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying share: %(share)s on Project: %(project)s and Pool: %(pool)s "
-"Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Fehler beim Überprüfen von freigegebenem Verzeichnis %(share)s für Projekt "
-"%(project)s und Pool %(pool)s Rückgabecode: %(ret.status)d Nachricht: "
-"%(ret.data)s."
-
-#, python-format
 msgid "Error attempting to run %(method)s"
 msgstr "Fehler bei dem Versuch, %(method)s auszuführen."
 
@@ -1559,14 +1281,6 @@ msgstr "Fehler während Bewerteranalyse:
 
 #, python-format
 msgid ""
-"Error editing share: %(share)s on Pool: %(pool)s Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Fehler beim Bearbeiten von freigegebenem Verzeichnis %(share)s für Pool "
-"%(pool)s. Rückgabecode: %(ret.status)d Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
 "Error enabling iSER for NetworkPortal: please ensure that RDMA is supported "
 "on your iSCSI port %(port)d on ip %(ip)s."
 msgstr ""
@@ -1595,55 +1309,15 @@ msgstr "Fehler beim Erweitern des Datent
 msgid "Error finding %(name)s."
 msgstr "Fehler bei der Suche nach %(name)s."
 
-msgid ""
-"Error getting appliance version details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Fehler beim Abrufen der Details der Appliance-Version. Rückgabecode: %(ret."
-"status)d Nachricht: %(ret.data)s."
-
 #, python-format
 msgid "Error getting domain id from name %(name)s: %(id)s."
 msgstr "Fehler beim Abrufen der Domänen-ID von Name %(name)s: %(id)s."
 
-msgid "Error getting initiator groups."
-msgstr "Fehler beim Abrufen von Initiatorgruppen."
-
 #, python-format
 msgid "Error getting pool id from name %(pool_name)s: %(err_msg)s."
 msgstr "Fehler beim Abrufen der Pool-ID von Name %(pool_name)s: %(err_msg)s."
 
 #, python-format
-msgid ""
-"Error getting replication action: %(id)s. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Fehler beim Abrufen der Replikationsaktion: %(id)s. Rückgabecode: "
-"%(ret.status)d Nachricht: %(ret.data)s."
-
-msgid ""
-"Error getting replication source details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Fehler beim Abrufen der Details der Replikationsquelle. Rückgabecode: %(ret."
-"status)d Nachricht: %(ret.data)s."
-
-msgid ""
-"Error getting replication target details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Fehler beim Abrufen der Details des Replikationsziels. Rückgabecode: %(ret."
-"status)d Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error getting version: svc: %(svc)s.Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Fehler beim Abrufen der Version: SVC: %(svc)s. Rückgabecode: %(ret.status)d "
-"Nachricht: %(ret.data)s."
-
-#, python-format
 msgid "Error in SolidFire API response: data=%(data)s"
 msgstr "Fehler in Antwort von SolidFire-API: Daten=%(data)s"
 
@@ -1651,23 +1325,6 @@ msgstr "Fehler in Antwort von SolidFire-
 msgid "Error managing volume: %s."
 msgstr "Fehler beim Verwalten des Datenträgers: %s"
 
-#, python-format
-msgid ""
-"Error modifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Fehler beim Ändern von %(service)s-Dienst. Rückgabecode: %(ret.status)d "
-"Nachricht: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error moving volume: %(vol)s from source project: %(src)s to target project: "
-"%(tgt)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Fehler beim Verschieben des Datenträgers: %(vol)s von Quellenprojekt: "
-"%(src)s zu Zielprojekt: %(tgt)s Rückgabecode: %(ret.status)d Nachricht: "
-"%(ret.data)s."
-
 msgid "Error not a KeyError."
 msgstr "Fehler ist nicht vom Typ 'KeyError'."
 
@@ -1682,38 +1339,6 @@ msgid "Error retrieving volume size"
 msgstr "Fehler beim Abrufen der Datenträgergröße"
 
 #, python-format
-msgid ""
-"Error sending replication update for action id: %(id)s . Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Fehler beim Senden der Replikationsaktualisierung für Aktions-ID: %(id)s. "
-"Rückgabecode: %(ret.status)d Nachricht: %(ret.data)s ."
-
-#, python-format
-msgid ""
-"Error sending replication update. Returned error: %(err)s. Action: %(id)s."
-msgstr ""
-"Fehler beim Senden der Replikationsaktualisierung. Zurückgegebener Fehler: "
-"%(err)s. Aktion: %(id)s."
-
-#, python-format
-msgid ""
-"Error setting replication inheritance to %(set)s for volume: %(vol)s project "
-"%(project)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Fehler beim Festlegen der Replikationsvererbung auf %(set)s für Datenträger: "
-"%(vol)s Projekt %(project)s Rückgabecode: %(ret.status)d Nachricht: "
-"%(ret.data)s."
-
-#, python-format
-msgid ""
-"Error severing the package: %(package)s from source: %(src)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Fehler beim Abtrennen des Pakets: %(package)s von Quelle: %(src)s "
-"Rückgabecode: %(ret.status)d Nachricht: %(ret.data)s ."
-
-#, python-format
 msgid "Error while authenticating with switch: %s."
 msgstr "Fehler beim Authentifizieren am Switch: %s."
 
@@ -1864,16 +1489,6 @@ msgstr ""
 "FC ist das Protokoll, aber WWPNs werden von OpenStack nicht bereitgestellt."
 
 #, python-format
-msgid "Faield to unassign %(volume)s"
-msgstr "Zuordnung für %(volume)s konnte nicht aufgehoben werden."
-
-#, python-format
-msgid "Fail to create cache volume %(volume)s. Error: %(err)s"
-msgstr ""
-"Fehler beim Erstellen des Zwischenspeicherdatenträgers %(volume)s. Fehler: "
-"%(err)s"
-
-#, python-format
 msgid "Failed adding connection for fabric=%(fabric)s: Error: %(err)s"
 msgstr ""
 "Fehler beim Hinzufügen einer Verbindung für Fabric=%(fabric)s: Fehler:%(err)s"
@@ -1948,12 +1563,6 @@ msgid "Failed to connect to Dell REST AP
 msgstr "Fehler beim Herstellen einer Verbindung zur Dell-REST-API. "
 
 #, python-format
-msgid "Failed to connect to sheep daemon. addr: %(addr)s, port: %(port)s"
-msgstr ""
-"Fehler beim Herstellen einer Verbindung zu sheep-Dämon. Adresse: %(addr)s, "
-"Port: %(port)s"
-
-#, python-format
 msgid "Failed to copy image to volume: %(reason)s"
 msgstr "Kopieren des Abbilds auf Datenträger fehlgeschlagen: %(reason)s"
 
@@ -1979,21 +1588,6 @@ msgid "Failed to create api volume flow.
 msgstr "Der API-Ablauf für die Erstellung des Datenträgers ist fehlgeschlagen."
 
 #, python-format
-msgid "Failed to create cg snapshot %(id)s due to %(reason)s."
-msgstr ""
-"Fehler beim Erstellen der Schattenkopie der Konsistenzgruppe (Cgsnapshot) "
-"%(id)s. Ursache: %(reason)s."
-
-#, python-format
-msgid "Failed to create consistency group %(id)s due to %(reason)s."
-msgstr ""
-"Fehler beim Erstellen der Konsistenzgruppe %(id)s. Ursache: %(reason)s."
-
-#, python-format
-msgid "Failed to create consistency group %(id)s:%(ret)s."
-msgstr "Fehler beim Erstellen der Konsistenzgruppe %(id)s:%(ret)s."
-
-#, python-format
 msgid "Failed to create consistency group: %(cgid)s. Error: %(excmsg)s."
 msgstr ""
 "Fehler beim Erstellen der Konsistenzgruppe: %(cgid)s. Fehler: %(excmsg)s."
@@ -2068,16 +1662,6 @@ msgid "Failed to create volume %s"
 msgstr "Erstellen von Datenträger %s fehlgeschlagen"
 
 #, python-format
-msgid "Failed to delete cgsnapshot %(id)s due to %(reason)s."
-msgstr ""
-"Fehler beim Löschen der Schattenkopie der Konsistenzgruppe (Cgsnapshot) "
-"%(id)s. Ursache: %(reason)s."
-
-#, python-format
-msgid "Failed to delete consistency group %(id)s due to %(reason)s."
-msgstr "Fehler beim Löschen der Konsistenzgruppe %(id)s. Ursache: %(reason)s."
-
-#, python-format
 msgid ""
 "Failed to delete fileset for consistency group %(cgname)s. Error: %(excmsg)s."
 msgstr ""
@@ -2161,10 +1745,6 @@ msgid "Failed to find host %s."
 msgstr "Host %s nicht gefunden."
 
 #, python-format
-msgid "Failed to find iSCSI initiator group containing %(initiator)s."
-msgstr "Die iSCSI-Initiatorgruppe mit %(initiator)s wurde nicht gefunden."
-
-#, python-format
 msgid "Failed to get LUN target details for the LUN %s"
 msgstr "Fehler beim Abrufen von LUN-Zieldetails für LUN %s"
 
@@ -2277,14 +1857,6 @@ msgstr "Anmeldung bei %s-Array fehlgesch
 msgid "Failed to login with all rest URLs."
 msgstr "Anmeldung mit allen REST-URLs fehlgeschlagen."
 
-#, python-format
-msgid ""
-"Failed to make a request to Datera cluster endpoint due to the following "
-"reason: %s"
-msgstr ""
-"Fehler beim Stellen einer Anforderung an den Datera-Cluster-Endpunkt. "
-"Ursache: %s"
-
 msgid "Failed to manage api volume flow."
 msgstr "Der API-Ablauf für die Verwaltung des Datenträgers ist fehlgeschlagen."
 
@@ -2502,32 +2074,6 @@ msgid "Failure staging LUN %s to tmp."
 msgstr "Fehler beim Zwischenspeichern von LUN %s in temporärem Bereich."
 
 #, python-format
-msgid "Fexvisor failed to add volume %(id)s due to %(reason)s."
-msgstr ""
-"Flexvisor konnte Datenträger %(id)s nicht hinzufügen. Ursache: %(reason)s."
-
-#, python-format
-msgid ""
-"Fexvisor failed to join the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr ""
-"Fexvisor konnte den Datenträger %(vol)s in der Gruppe %(group)s nicht "
-"verknüpfen. Ursache: %(ret)s."
-
-#, python-format
-msgid ""
-"Fexvisor failed to remove the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr ""
-"Fexvisor konnte den Datenträger %(vol)s in der Gruppe %(group)s nicht "
-"entfernen. Ursache: %(ret)s."
-
-#, python-format
-msgid "Fexvisor failed to remove volume %(id)s due to %(reason)s."
-msgstr ""
-"Flexvisor konnte den Datenträger %(id)s nicht entfernen. Ursache: %(reason)s."
-
-#, python-format
 msgid "Fibre Channel SAN Lookup failure: %(reason)s"
 msgstr "Fehler bei der Fibre Channel-SAN-Suche: %(reason)s"
 
@@ -2544,10 +2090,6 @@ msgid "File %(file_path)s could not be f
 msgstr "Datei %(file_path)s wurde nicht gefunden."
 
 #, python-format
-msgid "File already exists at %s."
-msgstr "Datei bereits vorhanden bei %s."
-
-#, python-format
 msgid "File already exists at: %s"
 msgstr "Datei bereits vorhanden in: %s"
 
@@ -2578,198 +2120,6 @@ msgstr ""
 "'%(version)s' ist installiert."
 
 #, python-format
-msgid "Flexvisor assign volume failed.:%(id)s:%(status)s."
-msgstr "Flexvisor konnte Datenträger %(id)s nicht zuordnen: %(status)s."
-
-#, python-format
-msgid "Flexvisor assign volume failed:%(id)s:%(status)s."
-msgstr "Flexvisor konnte Datenträger %(id)s nicht zuordnen: %(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor could not find volume %(id)s snapshot in the group %(vgid)s "
-"snapshot %(vgsid)s."
-msgstr ""
-"Flexvisor konnte die Schattenkopie des Datenträgers %(id)s in der Gruppe "
-"%(vgid)s Schattenkopie %(vgsid)s nicht finden."
-
-#, python-format
-msgid "Flexvisor create volume failed.:%(volumeid)s:%(status)s."
-msgstr "Flexvisor konnte Datenträger %(volumeid)s nicht erstellen: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed deleting volume %(id)s: %(status)s."
-msgstr "Flexvisor konnte Datenträger %(id)s nicht löschen: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to add volume %(id)s to group %(cgid)s."
-msgstr ""
-"Flexvisor konnte den Datenträger %(id)s nicht der Gruppe %(cgid)s hinzufügen."
-
-#, python-format
-msgid ""
-"Flexvisor failed to assign volume %(id)s due to unable to query status by "
-"event id."
-msgstr ""
-"Flexvisor konnte Datenträger %(id)s nicht zuordnen, da der Status nicht "
-"anhand der Ereignis-ID abgerufen werden konnte. "
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(id)s: %(status)s."
-msgstr "Flexvisor konnte Datenträger %(id)s nicht zuordnen: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(volume)s iqn %(iqn)s."
-msgstr "Flexvisor konnte Datenträger %(volume)s IQN %(iqn)s nicht zuordnen."
-
-#, python-format
-msgid "Flexvisor failed to clone volume %(id)s: %(status)s."
-msgstr "Flexvisor konnte Datenträger %(id)s nicht klonen: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to clone volume (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor konnte Datenträger %(id)s nicht klonen (Ereignis konnte nicht "
-"abgerufen werden)."
-
-#, python-format
-msgid "Flexvisor failed to create snapshot for volume %(id)s: %(status)s."
-msgstr ""
-"Flexvisor konnte Schattenkopie für Datenträger %(id)s nicht erstellen: "
-"%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to create snapshot for volume (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor konnte Schattenkopie für Datenträger %(id)s nicht erstellen "
-"(Ereignis konnte nicht abgerufen werden)."
-
-#, python-format
-msgid "Flexvisor failed to create volume %(id)s in the group %(vgid)s."
-msgstr ""
-"Flexvisor konnte Datenträger %(id)s nicht in der Gruppe %(vgid)s erstellen."
-
-#, python-format
-msgid "Flexvisor failed to create volume %(volume)s: %(status)s."
-msgstr "Flexvisor konnte Datenträger %(volume)s nicht erstellen: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume (get event) %s."
-msgstr "Flexvisor konnte Datenträger %s nicht erstellen (Ereignis abrufen)."
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s: %(status)s."
-msgstr ""
-"Flexvisor konnte Datenträger nicht aus der Schattenkopie %(id)s erstellen: "
-"%(status)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s:%(status)s."
-msgstr ""
-"Flexvisor konnte Datenträger nicht aus Schattenkopie %(id)s erstellen: "
-"%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to create volume from snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor konnte Datenträger nicht aus der Schattenkopie %(id)s erstellen "
-"(Ereignis konnte nicht abgerufen werden)."
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot %(id)s: %(status)s."
-msgstr "Flexvisor konnte Schattenkopie %(id)s nicht löschen: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor konnte Schattenkopie %(id)s nicht löschen (Ereignis konnte nicht "
-"abgerufen werden)."
-
-#, python-format
-msgid "Flexvisor failed to delete volume %(id)s: %(status)s."
-msgstr "Flexvisor konnte Datenträger %(id)s nicht löschen: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s: %(status)s."
-msgstr "Flexvisor konnte Datenträger %(id)s nicht erweitern: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s:%(status)s."
-msgstr "Flexvisor konnte Datenträger %(id)s nicht erweitern: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor konnte Datenträger %(id)s nicht erweitern (Ereignis konnte nicht "
-"abgerufen werden)."
-
-#, python-format
-msgid "Flexvisor failed to get pool info %(id)s: %(status)s."
-msgstr ""
-"Flexvisor konnte Poolinformationen zu %(id)s nicht abrufen: %(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to get snapshot id of volume %(id)s from group %(vgid)s."
-msgstr ""
-"Flexvisor konnnte die Schattenkopie-ID des Datenträgers %(id)s nicht aus der "
-"Gruppe %(vgid)s abrufen."
-
-#, python-format
-msgid "Flexvisor failed to remove volume %(id)s from group %(cgid)s."
-msgstr ""
-"Flexvisor konnte den Datenträger %(id)s nicht aus der Gruppe %(cgid)s "
-"entfernen."
-
-#, python-format
-msgid "Flexvisor failed to spawn volume from snapshot %(id)s:%(status)s."
-msgstr ""
-"Flexvisor konnte Datenträger nicht aus der Schattenkopie %(id)s generieren: "
-"%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to spawn volume from snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor konnte Datenträger nicht aus der Schattenkopie %(id)s erstellen "
-"(Ereignis konnte nicht abgerufen werden)."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume %(id)s: %(status)s."
-msgstr ""
-"Flexvisor konnte Zuordnung für Datenträger %(id)s nicht aufheben: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume (get event) %(id)s."
-msgstr ""
-"Flexvisor konnte Zuordnung für Datenträger %(id)s nicht aufheben (Ereignis "
-"abrufen)."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume:%(id)s:%(status)s."
-msgstr ""
-"Flexvisor konnte Zuordnung für Datenträger %(id)s nicht aufheben: %(status)s."
-
-#, python-format
-msgid "Flexvisor unable to find the source volume %(id)s info."
-msgstr ""
-"Flexvisor konnte die Informationen zum Quellendatenträger %(id)s nicht "
-"finden."
-
-#, python-format
-msgid "Flexvisor unassign volume failed:%(id)s:%(status)s."
-msgstr ""
-"Flexvisor konnte Zuordnung für Datenträger %(id)s nicht aufheben: %(status)s."
-
-#, python-format
-msgid "Flexvisor volume %(id)s failed to join group %(vgid)s."
-msgstr ""
-"Flexvisor-Datenträger %(id)s konnte nicht mit der Gruppe %(vgid)s verknüpft "
-"werden."
-
-#, python-format
 msgid "Folder %s does not exist in Nexenta Store appliance"
 msgstr "Der Ordner %s ist nicht in der Nexenta Store-Appliance vorhanden."
 
@@ -3142,14 +2492,6 @@ msgid "Invalid Replication Target: %(rea
 msgstr "Ungültiges Replikationsziel: %(reason)s"
 
 #, python-format
-msgid ""
-"Invalid Virtuozzo Storage share specification: %r. Must be: [MDS1[,"
-"MDS2],...:/]<CLUSTER NAME>[:PASSWORD]."
-msgstr ""
-"Ungültige Spezifikation einer Virtuozzo-Speicherfreigabe: %r. Erforderlich: "
-"[MDS1[,MDS2],...:/]<CLUSTERNAME>[:KENNWORT]."
-
-#, python-format
 msgid "Invalid XtremIO version %(cur)s, version %(min)s or up is required"
 msgstr ""
 "Ungültige XtremIO-Version %(cur)s, Version ab %(min)s ist erforderlich."
@@ -3160,13 +2502,6 @@ msgstr ""
 "Es wurden ungültige Kontingentzuordnungen für die folgenden "
 "Projektkontingente definiert: %s"
 
-msgid "Invalid argument - negative seek offset."
-msgstr "Ungültiges Argument - negativer Suchoffset."
-
-#, python-format
-msgid "Invalid argument - whence=%s not supported."
-msgstr "Ungültiges Argument: whence=%s wird nicht unterstützt."
-
 #, python-format
 msgid "Invalid attaching mode '%(mode)s' for volume %(volume_id)s."
 msgstr "Ungültiger Anhangmodus '%(mode)s' für Datenträger %(volume_id)s."
@@ -3180,18 +2515,6 @@ msgid "Invalid backup: %(reason)s"
 msgstr "Ungültige Sicherung: %(reason)s"
 
 #, python-format
-msgid "Invalid connection initialization response of volume %(name)s"
-msgstr ""
-"Ungültige Antwort für Initialisierung der Verbindung von Datenträger %(name)s"
-
-#, python-format
-msgid ""
-"Invalid connection initialization response of volume %(name)s: %(output)s"
-msgstr ""
-"Ungültige Antwort für Initialisierung der Verbindung von Datenträger "
-"%(name)s: %(output)s"
-
-#, python-format
 msgid "Invalid content type %(content_type)s."
 msgstr "Ungültiger Inhaltstyp %(content_type)s."
 
@@ -3260,6 +2583,12 @@ msgid "Invalid input"
 msgstr "Ungültige Eingabe"
 
 #, python-format
+msgid ""
+"Invalid input for field/attribute %(path)s. Value: %(value)s. %(message)s"
+msgstr ""
+"Ungültige Eingabe für Feld/Attribut %(path)s. Wert: %(value)s. %(message)s"
+
+#, python-format
 msgid "Invalid input received: %(reason)s"
 msgstr "Ungültige Eingabe erhalten: %(reason)s"
 
@@ -3284,10 +2613,6 @@ msgid "Invalid mount point base: %s"
 msgstr "Ungültige Mountpunktbasis: %s"
 
 #, python-format
-msgid "Invalid mount point base: %s."
-msgstr "Ungültige Mountpunktbasis: %s."
-
-#, python-format
 msgid "Invalid new snapCPG name for retype.  new_snap_cpg='%s'."
 msgstr "Ungültiger neuer snapCPG-Name für Typänderung. new_snap_cpg='%s'."
 
@@ -3306,9 +2631,6 @@ msgstr "Ungültige sekundäre ID %s."
 msgid "Invalid service catalog json."
 msgstr "Ungültige Servicekatalog-JSON."
 
-msgid "Invalid sheepdog cluster status."
-msgstr "Ungültiger Status des sheepdog-Clusters."
-
 #, python-format
 msgid "Invalid snapshot: %(reason)s"
 msgstr "Ungültige Schattenkopie: %(reason)s"
@@ -3392,10 +2714,6 @@ msgstr ""
 "Ungültiger volume_type angegeben: %s (der angeforderte Typ muss von dieser "
 "Konsistenzgruppe unterstützt werden)."
 
-#, python-format
-msgid "Invalid wwpns format %(wwpns)s"
-msgstr "Ungültiges wwpns-Format %(wwpns)s"
-
 msgid "Issue encountered waiting for job."
 msgstr "Beim Warten auf die Aufgabe ist ein Problem aufgetreten. "
 
@@ -3408,10 +2726,6 @@ msgstr ""
 "Ausgabe eines Failovers fehlgeschlagen, weil die Replikation nicht "
 "ordnungsgemäß konfiguriert wurde. "
 
-#, python-format
-msgid "KeyError: %s"
-msgstr "KeyError: %s"
-
 msgid "Keystone version 3 or greater must be used to get nested quota support."
 msgstr ""
 "Für die Unterstützung von verschachtelten Kontingenten muss Keystone ab "
@@ -3743,9 +3057,6 @@ msgstr ""
 msgid "New volume type not specified in request_spec."
 msgstr "Der neue Datenträgertyp wurde nicht in request_spec angegeben."
 
-msgid "Nimble Cinder Driver exception"
-msgstr "Nimble-Cinder-Treiberausnahme"
-
 msgid "No FC initiator can be added to host."
 msgstr "Es kann kein FC-Initiator zum Host hinzugefügt werden. "
 
@@ -3785,10 +3096,6 @@ msgid "No initiator connected to fabric.
 msgstr "Kein Initiator mit Fabric verbunden."
 
 #, python-format
-msgid "No initiator group found for initiator %s"
-msgstr "Keine Initiatorgruppe gefunden für Initiator %s"
-
-#, python-format
 msgid "No interface found on cluster for ip %s"
 msgstr "Keine Schnittstelle im Cluster für IP %s gefunden."
 
@@ -3801,9 +3108,6 @@ msgstr "Keine eingehängten gemeinsam ge
 msgid "No mounted SMBFS shares found."
 msgstr "Keine eingehängten gemeinsam genutzten SMBFS-Laufwerke gefunden."
 
-msgid "No mounted Virtuozzo Storage shares found"
-msgstr "Keine eingehängten gemeinsam genutzten Virtuozzo-Laufwerke gefunden."
-
 msgid "No mounted shares found"
 msgstr "Keine eingehängten gemeinsam genutzten Laufwerke gefunden."
 
@@ -3831,9 +3135,6 @@ msgstr "Keine Schattenkopie gefunden fü
 msgid "No such QoS spec %(specs_id)s."
 msgstr "Keine solche QoS-Spezifikation %(specs_id)s vorhanden."
 
-msgid "No suitable discovery ip found"
-msgstr "Keine geeignete Erkennungs-IP-Adresse gefunden."
-
 #, python-format
 msgid "No support to restore backup version %s"
 msgstr "Keine Unterstützung für die Wiederherstellung der Sicherungsversion %s"
@@ -3876,11 +3177,6 @@ msgstr "Nicht berechtigt."
 msgid "Not enough space on backend (%(backend)s)"
 msgstr "Nicht genug Speicherplatz im Backend (%(backend)s) vorhanden."
 
-msgid "Not enough storage space in the ZFS share to perform this operation."
-msgstr ""
-"Es ist nicht genügend Speicherplatz im freigegebenen ZFS-Verzeichnis zum "
-"Ausführen dieser Operation vorhanden."
-
 msgid "Not stored in rbd"
 msgstr "Nicht in RBD gespeichert."
 
@@ -3915,11 +3211,6 @@ msgstr ""
 "Stammprojekte festgelegt wurden, dürfen die Kontingente der zugehörigen "
 "untergeordneten Elemente anzeigen."
 
-msgid "Only volumes managed by OpenStack can be unmanaged."
-msgstr ""
-"Aufheben der Verwaltung von Datenträgern ist nur für Datenträger möglich, "
-"die von OpenStack verwaltet werden."
-
 #, python-format
 msgid "Operation failed with status=%(status)s. Full dump: %(data)s"
 msgstr ""
@@ -3968,9 +3259,6 @@ msgstr "Richtlinie lässt Ausführung vo
 msgid "Pool is not available in the volume host field."
 msgstr "Pool ist im Hostfeld für Datenträger nicht verfügbar."
 
-msgid "Pool is not available in the volume host fields."
-msgstr "Pool ist in den Hostfeldern für Datenträger nicht verfügbar."
-
 #, python-format
 msgid "Pool with name %(pool_name)s wasn't found in domain %(domain_id)s."
 msgstr ""
@@ -4131,17 +3419,6 @@ msgstr "Referenz muss 'source-name' oder
 msgid "Reference must contain source-name."
 msgstr "Referenz muss Element 'source-name' enthalten."
 
-msgid "Reference to volume to be managed must contain source-name."
-msgstr ""
-"Die Referenz auf den zu verwaltenden Datenträger muss 'source-name' "
-"enthalten."
-
-#, python-format
-msgid "Reference to volume: %s to be managed must contain source-name."
-msgstr ""
-"Die Referenz auf den zu verwaltenden Datenträger %s muss 'source-name' "
-"enthalten."
-
 #, python-format
 msgid ""
 "Refusing to migrate volume ID: %(id)s. Please check your configuration "
@@ -4203,12 +3480,6 @@ msgid "Request body contains too many it
 msgstr "Anforderungshauptteil enthält zu viele Elemente"
 
 #, python-format
-msgid "Request to Datera cluster returned bad status: %(status)s | %(reason)s"
-msgstr ""
-"Anforderung an Datera-Cluster gibt unzulässigen Status zurück: %(status)s | "
-"%(reason)s"
-
-#, python-format
 msgid ""
 "Requested backup exceeds allowed Backup gigabytes quota. Requested "
 "%(requested)sG, quota is %(quota)sG and %(consumed)sG has been consumed."
@@ -4339,11 +3610,6 @@ msgid "SMBFS config file not set (smbfs_
 msgstr "SMBFS-Konfigurationsdatei nicht definiert (smbfs_shares_config)."
 
 #, python-format
-msgid "SSH Command failed after '%(total_attempts)r' attempts : '%(command)s'"
-msgstr ""
-"SSH-Befehl fehlgeschlagen nach '%(total_attempts)r' Versuchen : '%(command)s'"
-
-#, python-format
 msgid "SSH command injection detected: %(command)s"
 msgstr "SSH-Befehlsinjektion erkannt: %(command)s"
 
@@ -4396,10 +3662,6 @@ msgstr ""
 "Format Adresse:/Export haben. Prüfen Sie die Einstellungen 'nas_host' und "
 "'nas_share_path'."
 
-#, python-format
-msgid "Sheepdog I/O Error, command was: \"%s\"."
-msgstr "Sheepdog-E/A-Fehler. Befehl war: \"%s\"."
-
 msgid ""
 "Show operations can only be made to projects in the same hierarchy of the "
 "project in which users are scoped to."
@@ -4597,15 +3859,6 @@ msgstr ""
 "Das GPFS-Dateisystem %(fs)s ist nicht auf dem erforderlichen Releasestand. "
 "Aktueller Stand ist %(cur)s, er muss aber mindestens %(min)s sein."
 
-#, python-format
-msgid ""
-"The WebDAV request failed. Reason: %(msg)s, Return code/reason: %(code)s, "
-"Source Volume: %(src)s, Destination Volume: %(dst)s, Method: %(method)s."
-msgstr ""
-"Die WebDAV-Anforderung ist fehlgeschlagen. Ursache: %(msg)s, Rückgabecode/"
-"Ursache: %(code)s, Quellendatenträger: %(src)s, Zieldatenträger: %(dst)s, "
-"Methode: %(method)s."
-
 msgid ""
 "The above error may show that the database has not been created.\n"
 "Please create a database using 'cinder-manage db sync' before running this "
@@ -4702,10 +3955,6 @@ msgstr ""
 msgid "The snapshot is unavailable: %(data)s"
 msgstr "Die Schattenkopie ist nicht verfügbar: %(data)s"
 
-msgid "The source volume for this WebDAV operation not found."
-msgstr ""
-"Der Quellendatenträger für diese WebDAV-Operation wurde nicht gefunden."
-
 #, python-format
 msgid ""
 "The source volume type '%(src)s' is different than the destination volume "
@@ -4919,10 +4168,6 @@ msgid "Type cannot be converted into NaE
 msgstr "Typ kann nicht in NaElement konvertiert werden."
 
 #, python-format
-msgid "TypeError: %s"
-msgstr "TypeError: %s"
-
-#, python-format
 msgid "UUIDs %s are in both add and remove volume list."
 msgstr ""
 "UUIDs %s befinden sich sowohl in der Liste zum Hinzufügen als auch in der "
@@ -5188,9 +4433,6 @@ msgstr ""
 "Nicht erwartete Ausgabe. Erwartet wurde [%(expected)s], empfangen wurde "
 "[%(output)s]"
 
-msgid "Unexpected response from Nimble API"
-msgstr "Unerwartete Antwort von Nimble-API"
-
 msgid "Unexpected status code"
 msgstr "Unerwarteter Statuscode"
 
@@ -5211,43 +4453,10 @@ msgstr "Unbekannte RemoteFS-Ausnahme"
 msgid "Unknown SMBFS exception."
 msgstr "Unbekannte SMBFS-Ausnahme"
 
-msgid "Unknown Virtuozzo Storage exception"
-msgstr "Unbekannte Virtuozzo-Speicherausnahmebedingung"
-
 msgid "Unknown action"
 msgstr "Unbekannte Aktion"
 
 #, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, Set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"Es ist nicht bekannt, ob der zu verwaltende Datenträger %s bereits von "
-"Cinder verwaltet wird. Verwalten des Datenträgers wird abgebrochen. Fügen "
-"Sie dem Datenträger die angepasste Schemaeigenschaft 'cinder_managed' hinzu "
-"und setzen Sie den zugehörigen Wert auf 'False'. Alternativ können Sie den "
-"Wert der Cinder-Konfigurationsrichtlinie 'zfssa_manage_policy' auf 'loose' "
-"setzen, um diese Einschränkung zu entfernen."
-
-#, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"Es ist nicht bekannt, ob der zu verwaltende Datenträger %s bereits von "
-"Cinder verwaltet wird. Verwalten des Datenträgers wird abgebrochen. Fügen "
-"Sie dem Datenträger die angepasste Schemaeigenschaft 'cinder_managed' hinzu "
-"und setzen Sie den zugehörigen Wert auf 'False'. Alternativ können Sie den "
-"Wert der Cinder-Konfigurationsrichtlinie 'zfssa_manage_policy' auf 'loose' "
-"setzen, um diese Einschränkung zu entfernen."
-
-#, python-format
 msgid "Unknown or unsupported command %(cmd)s"
 msgstr "Unbekannter oder nicht unterstützter Befehl %(cmd)s"
 
@@ -5361,10 +4570,6 @@ msgstr "Benutzer-ID"
 msgid "User does not have admin privileges"
 msgstr "Benutzer hat keine Admin-Berechtigungen."
 
-msgid "User not authorized to perform WebDAV operations."
-msgstr ""
-"Der Benutzer ist zum Ausführen von WebDAV-Operationen nicht berechtigt."
-
 msgid "UserName is not configured."
 msgstr "UserName ist nicht konfiguriert."
 
@@ -5398,10 +4603,6 @@ msgid "Value '%(param)s' for '%(param_st
 msgstr "Wert '%(param)s' für '%(param_string)s' ist kein boolescher Wert."
 
 #, python-format
-msgid "ValueError: %s"
-msgstr "ValueError: %s"
-
-#, python-format
 msgid "Vdisk %(name)s not involved in mapping %(src)s -> %(tgt)s."
 msgstr ""
 "Virtuelle Platte %(name)s nicht in Zuordnung %(src)s -> %(tgt)s enthalten."
@@ -5512,26 +4713,10 @@ msgid "Volume %s does not exist on the a
 msgstr "Der Datenträger %s ist im Array nicht vorhanden. "
 
 #, python-format
-msgid "Volume %s does not have provider_location specified, skipping."
-msgstr ""
-"Für Datenträger %s ist provider_location nicht angegeben, wird übersprungen."
-
-#, python-format
 msgid "Volume %s doesn't exist on array."
 msgstr "Der Datenträger %s ist im Array nicht vorhanden. "
 
 #, python-format
-msgid "Volume %s doesn't exist on the ZFSSA backend."
-msgstr "Der Datenträger %s ist nicht im ZFSSA-Backend vorhanden."
-
-#, python-format
-msgid ""
-"Volume %s is online. Set volume to offline for managing using OpenStack."
-msgstr ""
-"Der Datenträger %s ist 'online'. Setzen Sie den Datenträger für die "
-"Verwaltung mit OpenStack auf 'offline'."
-
-#, python-format
 msgid "Volume %s must not be part of a consistency group."
 msgstr "Datenträger %s darf nicht Teil einer Konsistenzgruppe sein."
 
@@ -5683,9 +4868,6 @@ msgstr "Datenträger noch nicht dem Host
 msgid "Volume replication for %(volume_id)s could not be found."
 msgstr "Die Datenträgerreplizierung für %(volume_id)s wurde nicht gefunden."
 
-msgid "Volume should have agent-type set as None."
-msgstr "Für Datenträger sollte Agententyp auf None festgelegt werden."
-
 #, python-format
 msgid ""
 "Volume size %(volume_size)sGB cannot be smaller than the image minDisk size "
@@ -5727,9 +4909,6 @@ msgstr "Datenträgergröße muss Vielfac
 msgid "Volume size must multiple of 1 GB."
 msgstr "Datenträgergröße muss Vielfaches von 1 GB sein."
 
-msgid "Volume status must be 'available'."
-msgstr "Datenträgerstatus muss 'available' sein."
-
 msgid "Volume to Initiator Group mapping already exists"
 msgstr ""
 "Die Zuordnung von Datenträger zu Initiatorgruppe ist bereits vorhanden."
@@ -5786,10 +4965,6 @@ msgid "Volume type with name %(volume_ty
 msgstr ""
 "Datenträgertyp mit dem Namen %(volume_type_name)s wurde nicht gefunden."
 
-#, python-format
-msgid "Volume: %s is already being managed by Cinder."
-msgstr "Der Datenträger %s wird bereits von Cinder verwaltet."
-
 msgid ""
 "Volumes/account exceeded on both primary and secondary SolidFire accounts."
 msgstr ""
@@ -5797,26 +4972,9 @@ msgstr ""
 "SolidFire-Konten überschritten."
 
 #, python-format
-msgid ""
-"VzStorage config 'vzstorage_used_ratio' invalid. Must be > 0 and <= 1.0: %s."
-msgstr ""
-"VzStorage-Konfiguration 'vzstorage_used_ratio' ist ungültig. Muss > 0 und <= "
-"1,0 sein: %s."
-
-#, python-format
-msgid "VzStorage config file at %(config)s doesn't exist."
-msgstr "VzStorage-Konfigurationsdatei ist nicht in %(config)s vorhanden."
-
-#, python-format
 msgid "Wait synchronize failed. Running status: %s."
 msgstr "Warten auf Synchronisierung fehlgeschlagen. Ausführungsstatus: %s."
 
-msgid ""
-"Waiting for all nodes to join cluster. Ensure all sheep daemons are running."
-msgstr ""
-"Es wird gewartet, bis alle Knoten mit dem Cluster verknüpft sind. Stellen "
-"Sie sicher, dass alle sheep-Dämonprozesse aktiv sind."
-
 msgid "We should not do switch over on primary array."
 msgstr "Wechsel in primären Array nicht empfohlen."
 
@@ -6574,9 +5732,6 @@ msgstr ""
 msgid "fake"
 msgstr "fake"
 
-msgid "fileno is not supported by SheepdogIOWrapper"
-msgstr "Fileno wird von SheepdogIOWrapper nicht unterstützt."
-
 #, python-format
 msgid "fmt=%(fmt)s backed by: %(backing_file)s"
 msgstr "fmt=%(fmt)s gesichert durch: %(backing_file)s"
@@ -6625,13 +5780,6 @@ msgstr ""
 "gpfs_images_share_mode wurde als copy_on_write festgelegt, aber %(vol)s und "
 "%(img)s gehören zu anderen Dateigruppen."
 
-msgid ""
-"http service may have been abruptly disabled or put to maintenance state in "
-"the middle of this operation."
-msgstr ""
-"Der http-Dienst wurde möglicherweise mitten in dieser Operation unerwartet "
-"inaktiviert oder in den Wartungsmodus versetzt."
-
 msgid "id cannot be None"
 msgstr "ID darf nicht 'None' sein."
 
@@ -6929,11 +6077,3 @@ msgstr "Datenträger zugeordnet"
 
 msgid "volumes changed"
 msgstr "Datenträger geändert"
-
-#, python-format
-msgid ""
-"zfssa_manage_policy property needs to be set to 'strict' or 'loose'. Current "
-"value is: %s."
-msgstr ""
-"Die Eigenschaft 'zfssa_manage_policy' muss auf 'strict' oder 'loose' gesetzt "
-"sein. Aktueller Wert: %s."
diff -pruN 2:15.0.1-1/cinder/locale/es/LC_MESSAGES/cinder.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/es/LC_MESSAGES/cinder.po
--- 2:15.0.1-1/cinder/locale/es/LC_MESSAGES/cinder.po	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/es/LC_MESSAGES/cinder.po	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: cinder VERSION\n"
 "Report-Msgid-Bugs-To: https://bugs.launchpad.net/openstack-i18n/\n"
-"POT-Creation-Date: 2019-10-04 05:27+0000\n"
+"POT-Creation-Date: 2020-03-18 14:40+0000\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
@@ -117,12 +117,6 @@ msgstr ""
 "copias de seguridad de imagen o archivo, la modalidad real es %(vol_mode)s."
 
 #, python-format
-msgid "%(service)s Service is not %(status)s on storage appliance: %(host)s"
-msgstr ""
-"El servicio %(service)s no está %(status)s en el dispositivo de "
-"almacenamiento: %(host)s"
-
-#, python-format
 msgid ""
 "%(worker_name)s value of %(workers)d is invalid, must be greater than 0."
 msgstr ""
@@ -170,10 +164,6 @@ msgid "%s is not installed"
 msgstr "%s no está instalado"
 
 #, python-format
-msgid "%s is not installed."
-msgstr "%s no está instalado."
-
-#, python-format
 msgid "%s is not set"
 msgstr "%s no está establecido"
 
@@ -196,10 +186,6 @@ msgid "%s must be an absolute path."
 msgstr "%s debe ser una ruta absoluta."
 
 #, python-format
-msgid "%s not set in cinder.conf"
-msgstr "%s no está definido en cinder.conf"
-
-#, python-format
 msgid "%s not set."
 msgstr "%s no establecido."
 
@@ -224,14 +210,6 @@ msgstr "Es necesario especificar el 'con
 msgid "'qemu-img info' parsing failed."
 msgstr "Se ha encontrado un error en el análisis de 'qemu-img info'."
 
-#, python-format
-msgid ""
-"(Command: %(cmd)s) (Return Code: %(exit_code)s) (Stdout: %(stdout)s) "
-"(Stderr: %(stderr)s)"
-msgstr ""
-"(Mandato: %(cmd)s) (Código de retorno: %(exit_code)s) (Salida estándar: "
-"%(stdout)s) (Error estándar: %(stderr)s)"
-
 msgid "A concurrent, possibly contradictory, request has been made."
 msgstr "Se ha realizado una solicitud simultánea, posiblemente contradictoria."
 
@@ -322,14 +300,6 @@ msgstr ""
 "%(luncopyname)s. Situación de LUNcopy: %(luncopystatus)s. Estado de LUNcopy: "
 "%(luncopystate)s."
 
-#, python-format
-msgid "An error occurred while reading volume \"%s\"."
-msgstr "Se ha producido un error al leer el volumen \"%s\"."
-
-#, python-format
-msgid "An error occurred while writing to volume \"%s\"."
-msgstr "Se ha producido un error al escribir en el volumen \"%s\"."
-
 msgid "An unknown error occurred."
 msgstr "Se ha producido un error desconocido."
 
@@ -405,11 +375,6 @@ msgstr "Categorías disponibles:"
 msgid "Backend doesn't exist (%(backend)s)"
 msgstr "El programa de fondo no existe %(backend)s)"
 
-msgid "Backend storage did not configure fiber channel target."
-msgstr ""
-"El almacenamiento del programa de fondo no ha configurado el destino de "
-"canal de fibra."
-
 msgid "Backing up an in-use volume must use the force flag."
 msgstr ""
 "La copia de seguridad de un volumen en uso debe utilizar el distintivo force."
@@ -527,10 +492,6 @@ msgstr ""
 msgid "CPG (%s) doesn't exist on array"
 msgstr "CPG (%s) no existe en la matriz"
 
-#, python-format
-msgid "Cache volume %s does not have required properties"
-msgstr "El volumen de la memoria caché  %s no tiene las propiedades necesarias"
-
 msgid "Can not add FC port to host."
 msgstr "No se puede añadir el puerto FC al host."
 
@@ -667,10 +628,6 @@ msgstr ""
 "No se puede cambiar el contexto de la VF, la VF especificada no está "
 "disponible en la lista de VF gestionables %(vf_list)s."
 
-#, python-format
-msgid "Cannot create directory %s."
-msgstr "No se puede crear el directorio %s."
-
 msgid "Cannot create encryption specs. Volume type in use."
 msgstr ""
 "No se pueden crear especificaciones de cifrado. El tipo de volumen se está "
@@ -693,24 +650,6 @@ msgstr ""
 "No se puede crear el tipo de volumen con el nombre %(name)s y las "
 "especificaciones %(extra_specs)s"
 
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)d volume instances."
-msgstr ""
-"No se puede suprimir el volumen de la memoria caché: %(cachevol_name)s. Se "
-"ha actualizado a %(updated_at)s y actualmente tiene %(numclones)d instancias "
-"de volumen."
-
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)s volume instances."
-msgstr ""
-"No se puede suprimir el volumen de la memoria caché: %(cachevol_name)s. Se "
-"ha actualizado a %(updated_at)s y actualmente tiene %(numclones)s instancias "
-"de volumen."
-
 msgid "Cannot delete encryption specs. Volume type in use."
 msgstr ""
 "No se pueden suprimir especificaciones de cifrado. El tipo de volumen se "
@@ -781,11 +720,6 @@ msgstr ""
 "El cambio produciría un uso inferior a 0 para los recursos siguientes: "
 "%(unders)s."
 
-msgid "Check access permissions for the ZFS share assigned to this driver."
-msgstr ""
-"Compruebe los permisos de acceso para la unidad compartida ZFS asignada a "
-"este controlador."
-
 msgid "Check hostgroup associate error."
 msgstr "Error al comprobar la asociación del grupo de host."
 
@@ -801,13 +735,6 @@ msgstr "Error al comprobar la asociació
 msgid "Check portgroup associate error."
 msgstr "Error al comprobar la asociación del grupo de puertos."
 
-msgid ""
-"Check the state of the http service. Also ensure that the https port number "
-"is the same as the one specified in cinder.conf."
-msgstr ""
-"Compruebe el estado del servicio HTTP. Asegúrese también de que el número de "
-"puerto HTTPS es el mismo que el que se ha especificado en cinder.conf."
-
 msgid "Chunk size is not multiple of block size for creating hash."
 msgstr ""
 "El tamaño de trozo no es múltiplo del tamaño de bloque para la creación de "
@@ -826,12 +753,6 @@ msgstr ""
 "El tipo de clon '%(clone_type)s' no es válido; los valores válidos son: "
 "'%(full_clone)s' y '%(linked_clone)s'."
 
-msgid ""
-"Cluster is not formatted. You should probably perform \"dog cluster format\"."
-msgstr ""
-"El clúster no se ha formateado. Debe realizar probablemente \"dog cluster "
-"format\"."
-
 #, python-format
 msgid "CommandLineHelper._wait_for_condition: %s timeout."
 msgstr ""
@@ -849,11 +770,6 @@ msgstr "Clúster de cálculo: no se ha e
 msgid "Condition has no field."
 msgstr "La condición no tiene ningún campo."
 
-#, python-format
-msgid "Config 'max_over_subscription_ratio' invalid. Must be > 0: %s"
-msgstr ""
-"La configuración 'max_over_subscription_ratio' no es válida. Debe ser > 0: %s"
-
 msgid "Configuration error: dell_sc_ssn not set."
 msgstr "Error de configuración: dell_sc_ssn no está establecido."
 
@@ -906,6 +822,11 @@ msgid "Converted to %(f1)s, but format i
 msgstr "Se ha convertido a %(f1)s, pero ahora el formato es %(f2)s"
 
 #, python-format
+msgid "Converted to %(vol_format)s, but format is now %(file_format)s"
+msgstr ""
+"Se ha convertido a %(vol_format)s, pero ahora el formato es %(file_format)s"
+
+#, python-format
 msgid "Converted to raw, but format is now %s"
 msgstr "Convertido a sin formato, pero el formato es ahora %s"
 
@@ -1292,203 +1213,6 @@ msgstr "Habilita la réplica."
 msgid "Ensure that configfs is mounted at /sys/kernel/config."
 msgstr "Asegúrese de que configfs está montado en /sys/kernel/config."
 
-#, python-format
-msgid ""
-"Error Cloning Snapshot: %(snapshot)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Clone project: %(clone_proj)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Error al clonar la instantánea: %(snapshot)s en el volumen: %(lun)s de la "
-"agrupación: %(pool)s Proyecto: %(project)s  Clonar proyecto: %(clone_proj)s "
-"Código de retorno: %(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Initiator: %(initiator)s on Alias: %(alias)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Error al crear el iniciador: %(initiator)s en el Alias: %(alias)s Código de "
-"retorno: %(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Error al crear el proyecto: %(project)s en la agrupación: %(pool)s Código de "
-"retorno: %(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Property: %(property)s Type: %(type)s Description: "
-"%(description)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Error al crear la propiedad: %(property)s Tipo: %(type)s Descripción: "
-"%(description)s Código de retorno: %(ret.status)d Mensaje: %(ret.data)s ."
-
-#, python-format
-msgid ""
-"Error Creating Share: %(name)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Error al crear la unidad compartida: %(name)s Código de retorno: "
-"%(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Volume: %(lun)s Size: %(size)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"Error al crear el volumen: %(lun)s Tamaño: %(size)s Código de retorno: "
-"%(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Share: %(share)s to Pool: %(pool)s "
-"Project: %(project)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Error al suprimir la instantánea: %(snapshot)s en la unidad compartida: "
-"%(share)s en la agrupación: %(pool)s Proyecto: %(project)s  Código de "
-"retorno: %(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Volume: %(lun)s to Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Error al suprimir la instantánea: %(snapshot)s en el volumen: %(lun)s en la "
-"agrupación: %(pool)s Proyecto: %(project)s  Código de retorno: "
-"%(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Volume: %(lun)s from Pool: %(pool)s, Project: %(project)s. "
-"Return code: %(ret.status)d, Message: %(ret.data)s."
-msgstr ""
-"Error al suprimir el volumen: %(lun)s de la agrupación: %(pool)s, Proyecto: "
-"%(project)s. Código de retorno: %(ret.status)d, Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting project: %(project)s on pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Error al suprimir el proyecto: %(project)s enla agrupación: %(pool)s Código "
-"de retorno: %(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting replication action: %(id)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"Error al suprimir la acción de réplica: %(id)s Código de retorno: "
-"%(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Initiators: InitiatorGroup: %(initiatorgroup)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Error al obtener los iniciadores: InitiatorGroup: %(initiatorgroup)s Código "
-"de retorno: %(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Pool Stats: Pool: %(pool)s Return code: %(status)d Message: "
-"%(data)s."
-msgstr ""
-"Error al obtener las estadísticas de la agrupación: Agrupación: %(pool)s "
-"Código de retorno: %(status)d Mensaje: %(data)s."
-
-#, python-format
-msgid ""
-"Error Getting Project Stats: Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Error al obtener el estado del proyecto: agrupación: %(pool)s Proyecto: "
-"%(project)s Código de retorno: %(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Share: %(share)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Error al obtener la unidad compartida: %(share)s en la agrupación: %(pool)s "
-"Proyecto: %(project)s Código de retorno: %(ret.status)d Mensaje: "
-"%(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Volume: %(lun)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Error al obtener el volumen: %(lun)s en la agrupación: %(pool)s Proyecto: "
-"%(project)s Código de retorno: %(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid "Error Pool ownership: Pool %(pool)s is not owned by %(host)s."
-msgstr ""
-"Error en la propiedad de la agrupación: La agrupación %(pool)s no es "
-"propiedad de %(host)s."
-
-#, python-format
-msgid ""
-"Error Setting props Props: %(props)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Error al establecer las propiedades. Propiedades: %(props)s en el volumen: "
-"%(lun)s de la agrupación: %(pool)s Proyecto: %(project)s Código de retorno: "
-"%(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Initiator: %(iqn)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Error al verificar el iniciador: %(iqn)s Código de retorno: %(ret.status)d "
-"Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Pool: %(pool)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Error al verificar la agrupación: %(pool)s Código de retorno: %(ret.status)d "
-"Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Error al verificar el proyecto: %(project)s en la agrupación: %(pool)s "
-"Código de retorno: %(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Error al verificar el servicio: %(service)s Código de retorno: "
-"%(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Target: %(alias)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Error al verificar el destino: %(alias)s Código de retorno: %(ret.status)d "
-"Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying share: %(share)s on Project: %(project)s and Pool: %(pool)s "
-"Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Error al verificar la unidad compartida: %(share)s en el Proyecto: "
-"%(project)s y la Agrupación: %(pool)s Código de retorno: %(ret.status)d "
-"Mensaje: %(ret.data)s ."
-
 msgid "Error connecting to ceph cluster."
 msgstr "Error al conectarse con un clúster ceph."
 
@@ -1517,14 +1241,6 @@ msgstr "Error durante el análisis de ev
 
 #, python-format
 msgid ""
-"Error editing share: %(share)s on Pool: %(pool)s Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Error al editar la unidad compartida: %(share)s en la agrupación: %(pool)s "
-"Código de retorno: %(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
 "Error enabling iSER for NetworkPortal: please ensure that RDMA is supported "
 "on your iSCSI port %(port)d on ip %(ip)s."
 msgstr ""
@@ -1552,21 +1268,11 @@ msgstr "Error al extender volumen: %(rea
 msgid "Error finding %(name)s."
 msgstr "Error al buscar %(name)s"
 
-msgid ""
-"Error getting appliance version details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Error al obtener los detalles de la versión de dispositivo. Código de "
-"retorno: %(ret.status)d Mensaje: %(ret.data)s."
-
 #, python-format
 msgid "Error getting domain id from name %(name)s: %(id)s."
 msgstr ""
 "Error al obtener el ID de dominio a partir del nombre %(name)s: %(id)s."
 
-msgid "Error getting initiator groups."
-msgstr "Error al obtener los grupos de iniciador."
-
 #, python-format
 msgid "Error getting pool id from name %(pool_name)s: %(err_msg)s."
 msgstr ""
@@ -1574,36 +1280,6 @@ msgstr ""
 "%(err_msg)s."
 
 #, python-format
-msgid ""
-"Error getting replication action: %(id)s. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Error al obtener la acción de réplica: %(id)s. Código de retorno: "
-"%(ret.status)d Mensaje: %(ret.data)s."
-
-msgid ""
-"Error getting replication source details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Error al obtener los detalles de origen de réplica. Código de retorno: %(ret."
-"status)d Mensaje: %(ret.data)s."
-
-msgid ""
-"Error getting replication target details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Error al obtener los detalles de destino de réplica. Código de retorno: "
-"%(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error getting version: svc: %(svc)s.Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Error al obtener la versión: svc: %(svc)s. Código de retorno: %(ret.status)d "
-"Mensaje: %(ret.data)s."
-
-#, python-format
 msgid "Error in SolidFire API response: data=%(data)s"
 msgstr "Error en respuesta de API SolidFire: data=%(data)s"
 
@@ -1611,23 +1287,6 @@ msgstr "Error en respuesta de API SolidF
 msgid "Error managing volume: %s."
 msgstr "Error al gestionar el volumen: %s."
 
-#, python-format
-msgid ""
-"Error modifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Error al modificar el servicio: %(service)s Código de retorno: "
-"%(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error moving volume: %(vol)s from source project: %(src)s to target project: "
-"%(tgt)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Error al mover el volumen: %(vol)s del proyecto de origen: %(src)s al "
-"proyecto de destino: %(tgt)s Código de retorno: %(ret.status)d Mensaje: "
-"%(ret.data)s ."
-
 msgid "Error not a KeyError."
 msgstr "El error no es un KeyError."
 
@@ -1642,38 +1301,6 @@ msgid "Error retrieving volume size"
 msgstr "Error al recuperar el tamaño de volumen"
 
 #, python-format
-msgid ""
-"Error sending replication update for action id: %(id)s . Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Error al enviar una actualización de réplica para el ID de acción: %(id)s. "
-"Código de retorno: %(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error sending replication update. Returned error: %(err)s. Action: %(id)s."
-msgstr ""
-"Error al enviar la actualización de réplica. Error devuelto: %(err)s. "
-"Acción: %(id)s."
-
-#, python-format
-msgid ""
-"Error setting replication inheritance to %(set)s for volume: %(vol)s project "
-"%(project)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Error al establecer la herencia de réplica en %(set)s para el volumen: "
-"%(vol)s del proyecto %(project)s Código de retorno: %(ret.status)d Mensaje: "
-"%(ret.data)s ."
-
-#, python-format
-msgid ""
-"Error severing the package: %(package)s from source: %(src)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Error al cortar el paquete: %(package)s del origen: %(src)s Código de "
-"retorno: %(ret.status)d Mensaje: %(ret.data)s."
-
-#, python-format
 msgid "Error while authenticating with switch: %s."
 msgstr "Error durante la autenticación con el conmutador: %s."
 
@@ -1821,16 +1448,6 @@ msgid "FC is the protocol but wwpns are
 msgstr "FC es el protocolo pero OpenStack no proporciona wwpns."
 
 #, python-format
-msgid "Faield to unassign %(volume)s"
-msgstr "No se ha podido desasignar %(volume)s"
-
-#, python-format
-msgid "Fail to create cache volume %(volume)s. Error: %(err)s"
-msgstr ""
-"No se ha podido crear el volumen de la memoria caché %(volume)s. Error: "
-"%(err)s"
-
-#, python-format
 msgid "Failed adding connection for fabric=%(fabric)s: Error: %(err)s"
 msgstr "No se ha podido añadir conexión para tejido=%(fabric)s: Error:%(err)s"
 
@@ -1907,12 +1524,6 @@ msgid "Failed to connect to Dell REST AP
 msgstr "No se ha podido conectar con la API REST de Dell"
 
 #, python-format
-msgid "Failed to connect to sheep daemon. addr: %(addr)s, port: %(port)s"
-msgstr ""
-"No se ha podido conectar al daemon sheep. Dirección: %(addr)s, puerto: "
-"%(port)s"
-
-#, python-format
 msgid "Failed to copy image to volume: %(reason)s"
 msgstr "Copiar la imagen al volumen ha fallado: %(reason)s"
 
@@ -1938,19 +1549,6 @@ msgid "Failed to create api volume flow.
 msgstr "No se ha podido crear flujo de volumen de la API."
 
 #, python-format
-msgid "Failed to create cg snapshot %(id)s due to %(reason)s."
-msgstr "No se ha podido crear el cgsnapshot %(id)s debido a %(reason)s."
-
-#, python-format
-msgid "Failed to create consistency group %(id)s due to %(reason)s."
-msgstr ""
-"No se ha podido crear el grupo de consistencia %(id)s debido a %(reason)s."
-
-#, python-format
-msgid "Failed to create consistency group %(id)s:%(ret)s."
-msgstr "No se ha podido crear el grupo de consistencia %(id)s:%(ret)s."
-
-#, python-format
 msgid "Failed to create consistency group: %(cgid)s. Error: %(excmsg)s."
 msgstr ""
 "No se ha podido crear el grupo de consistencia: %(cgid)s. Error: %(excmsg)s."
@@ -2023,15 +1621,6 @@ msgid "Failed to create volume %s"
 msgstr "Error al crear volumen %s"
 
 #, python-format
-msgid "Failed to delete cgsnapshot %(id)s due to %(reason)s."
-msgstr "No se ha podido suprimir el cgsnapshot %(id)s debido a %(reason)s."
-
-#, python-format
-msgid "Failed to delete consistency group %(id)s due to %(reason)s."
-msgstr ""
-"No se ha podido suprimir el grupo de consistencia %(id)s debido a %(reason)s."
-
-#, python-format
 msgid ""
 "Failed to delete fileset for consistency group %(cgname)s. Error: %(excmsg)s."
 msgstr ""
@@ -2111,12 +1700,6 @@ msgid "Failed to find host %s."
 msgstr "No se ha podido encontrar el host %s."
 
 #, python-format
-msgid "Failed to find iSCSI initiator group containing %(initiator)s."
-msgstr ""
-"No se ha podido encontrar el grupo de iniciadores iSCSI que contiene "
-"%(initiator)s."
-
-#, python-format
 msgid "Failed to get LUN target details for the LUN %s"
 msgstr ""
 "Se ha encontrado un error en la obtención de los detalles de destino de LUN "
@@ -2238,14 +1821,6 @@ msgstr ""
 msgid "Failed to login with all rest URLs."
 msgstr "No se ha podido iniciar sesión con todos los URL rest."
 
-#, python-format
-msgid ""
-"Failed to make a request to Datera cluster endpoint due to the following "
-"reason: %s"
-msgstr ""
-"No se ha podido hacer una solicitud al punto final del clúster de Datera "
-"debido al siguiente motivo: %s"
-
 msgid "Failed to manage api volume flow."
 msgstr "No se ha podido gestionar el flujo de volumen de la API."
 
@@ -2460,30 +2035,6 @@ msgid "Failure staging LUN %s to tmp."
 msgstr "Error de transferencia de LUN %s a tmp."
 
 #, python-format
-msgid "Fexvisor failed to add volume %(id)s due to %(reason)s."
-msgstr "Fexvisor no ha podido añadir el volumen %(id)s debido a %(reason)s."
-
-#, python-format
-msgid ""
-"Fexvisor failed to join the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr ""
-"Fexvisor no ha podido unir el volumen %(vol)s en el grupo %(group)s debido a "
-"%(ret)s."
-
-#, python-format
-msgid ""
-"Fexvisor failed to remove the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr ""
-"Fexvisor no ha podido eliminar el volumen %(vol)s en el grupo %(group)s "
-"debido a %(ret)s."
-
-#, python-format
-msgid "Fexvisor failed to remove volume %(id)s due to %(reason)s."
-msgstr "Fexvisor no ha podido eliminar el volumen %(id)s debido a %(reason)s."
-
-#, python-format
 msgid "Fibre Channel SAN Lookup failure: %(reason)s"
 msgstr "Anomalía de búsqueda de SAN de canal de fibra: %(reason)s"
 
@@ -2500,10 +2051,6 @@ msgid "File %(file_path)s could not be f
 msgstr "No se ha podido encontrar el archivo %(file_path)s."
 
 #, python-format
-msgid "File already exists at %s."
-msgstr "Ya existe el archivo en %s."
-
-#, python-format
 msgid "File already exists at: %s"
 msgstr "El archivo ya existe en: %s"
 
@@ -2534,191 +2081,6 @@ msgstr ""
 "'%(fcache_version)s' versión '%(version)s' esté instalada."
 
 #, python-format
-msgid "Flexvisor assign volume failed.:%(id)s:%(status)s."
-msgstr ""
-"La desasignación de volumen de Flexvisor ha fallado: %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor assign volume failed:%(id)s:%(status)s."
-msgstr "La asignación de volumen de Flexvisor ha fallado: %(id)s:%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor could not find volume %(id)s snapshot in the group %(vgid)s "
-"snapshot %(vgsid)s."
-msgstr ""
-"Flexvisor no ha podido encontrar la instantánea del volumen %(id)s en la "
-"instantánea %(vgid)s del grupo %(vgsid)s."
-
-#, python-format
-msgid "Flexvisor create volume failed.:%(volumeid)s:%(status)s."
-msgstr ""
-"La creación de volumen de Flexvisor ha fallado: %(volumeid)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor failed deleting volume %(id)s: %(status)s."
-msgstr "Flexvisor no ha podido suprimir el volumen %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to add volume %(id)s to group %(cgid)s."
-msgstr "Flexvisor no ha podido añadir el volumen %(id)s al grupo %(cgid)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to assign volume %(id)s due to unable to query status by "
-"event id."
-msgstr ""
-"Flexvisor no ha podido asignar el volumen %(id)s porque no ha podido "
-"consultar el estado por id de suceso."
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(id)s: %(status)s."
-msgstr "Flexvisor no ha podido asignar el volumen %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(volume)s iqn %(iqn)s."
-msgstr "Flexvisor no ha podido asignar al volumen %(volume)s el iqn %(iqn)s."
-
-#, python-format
-msgid "Flexvisor failed to clone volume %(id)s: %(status)s."
-msgstr "Flexvisor no ha podido clonar el volumen %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to clone volume (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor no ha podido clonar el volumen (no ha podido obtener el suceso) "
-"%(id)s."
-
-#, python-format
-msgid "Flexvisor failed to create snapshot for volume %(id)s: %(status)s."
-msgstr ""
-"Flexvisor no ha podido crear la instantánea para el volumen %(id)s: "
-"%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to create snapshot for volume (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor no ha podido crear la instantánea para el volumen (no ha podido "
-"obtener el suceso) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume %(id)s in the group %(vgid)s."
-msgstr "Flexvisor no ha podido crear el volumen %(id)s en el grupo %(vgid)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume %(volume)s: %(status)s."
-msgstr "Flexvisor no ha podido crear el volumen %(volume)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume (get event) %s."
-msgstr "Flexvisor no ha podido crear el volumen (obtener el suceso) %s."
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s: %(status)s."
-msgstr ""
-"Flexvisor no ha podido crear el volumen a partir de la instantánea %(id)s: "
-"%(status)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s:%(status)s."
-msgstr ""
-"Flexvisor no ha podido crear el volumen a partir de la instantánea %(id)s: "
-"%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to create volume from snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor no ha podido crear el volumen a partir de la instantánea (no ha "
-"podido obtener el suceso) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot %(id)s: %(status)s."
-msgstr "Flexvisor no ha podido suprimir la instantánea %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor no ha podido suprimir la instantánea (no ha podido obtener el "
-"suceso) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to delete volume %(id)s: %(status)s."
-msgstr "Flexvisor no ha podido suprimir el volumen %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s: %(status)s."
-msgstr "Flexvisor no ha podido ampliar el volumen %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s:%(status)s."
-msgstr "Flexvisor no ha podido ampliar el volumen %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor no ha podido ampliar el volumen (no ha podido obtener el suceso) "
-"%(id)s."
-
-#, python-format
-msgid "Flexvisor failed to get pool info %(id)s: %(status)s."
-msgstr ""
-"Flexvisor no ha podido obtener la información de agrupación %(id)s: "
-"%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to get snapshot id of volume %(id)s from group %(vgid)s."
-msgstr ""
-"Flexvisor no ha podido obtener el ID de instantánea del volumen %(id)s del "
-"grupo %(vgid)s."
-
-#, python-format
-msgid "Flexvisor failed to remove volume %(id)s from group %(cgid)s."
-msgstr "Flexvisor no ha podido eliminar el volumen %(id)s del grupo %(cgid)s."
-
-#, python-format
-msgid "Flexvisor failed to spawn volume from snapshot %(id)s:%(status)s."
-msgstr ""
-"Flexvisor no ha podido generar el volumen a partir de la instantánea %(id)s:"
-"%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to spawn volume from snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor no ha podido generar el volumen a partir de la instantánea (no ha "
-"podido obtener el suceso) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume %(id)s: %(status)s."
-msgstr "Flexvisor no ha podido desasignar el volumen %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume (get event) %(id)s."
-msgstr ""
-"Flexvisor no ha podido desasignar el volumen (obtener el suceso) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume:%(id)s:%(status)s."
-msgstr "Flexvisor no ha podido desasignar el volumen: %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor unable to find the source volume %(id)s info."
-msgstr ""
-"Flexvisor no ha podido encontrar la información del volumen de origen %(id)s."
-
-#, python-format
-msgid "Flexvisor unassign volume failed:%(id)s:%(status)s."
-msgstr ""
-"La desasignación de volumen de Flexvisor ha fallado: %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor volume %(id)s failed to join group %(vgid)s."
-msgstr "El volumen de Flexvisor %(id)s no se ha podido unir al grupo %(vgid)s."
-
-#, python-format
 msgid "Folder %s does not exist in Nexenta Store appliance"
 msgstr "La carpeta %s no existe en la aplicación Nexenta Store"
 
@@ -3051,14 +2413,6 @@ msgid "Invalid Replication Target: %(rea
 msgstr "Destino de replicación no válido: %(reason)s"
 
 #, python-format
-msgid ""
-"Invalid Virtuozzo Storage share specification: %r. Must be: [MDS1[,"
-"MDS2],...:/]<CLUSTER NAME>[:PASSWORD]."
-msgstr ""
-"Especificación de compartición de Virtuozzo Storage no válida: %r. Debe ser: "
-"[MDS1[,MDS2],...:/]<CLUSTER NAME>[:PASSWORD]."
-
-#, python-format
 msgid "Invalid XtremIO version %(cur)s, version %(min)s or up is required"
 msgstr ""
 "Versión de XtremIO no válida %(cur)s, se requiere la versión %(min)s o "
@@ -3070,13 +2424,6 @@ msgstr ""
 "Se han definido unas cuotas asignadas no válidas en las siguientes cuotas de "
 "proyecto: %s"
 
-msgid "Invalid argument - negative seek offset."
-msgstr "Argumento no válido - desplazamiento de búsqueda negativo."
-
-#, python-format
-msgid "Invalid argument - whence=%s not supported."
-msgstr "Argumento no válido -  whence=%s no admitido."
-
 #, python-format
 msgid "Invalid attaching mode '%(mode)s' for volume %(volume_id)s."
 msgstr "Método de conexión '%(mode)s' inválido para el volumen %(volume_id)s."
@@ -3090,17 +2437,6 @@ msgid "Invalid backup: %(reason)s"
 msgstr "Copia de seguridad no válida: %(reason)s"
 
 #, python-format
-msgid "Invalid connection initialization response of volume %(name)s"
-msgstr "Respuesta de inicialización de conexión no válida del volumen %(name)s"
-
-#, python-format
-msgid ""
-"Invalid connection initialization response of volume %(name)s: %(output)s"
-msgstr ""
-"Respuesta de inicialización de conexión no válida del volumen %(name)s: "
-"%(output)s"
-
-#, python-format
 msgid "Invalid content type %(content_type)s."
 msgstr "Tipo de contenido invalido %(content_type)s."
 
@@ -3188,10 +2524,6 @@ msgid "Invalid mount point base: %s"
 msgstr "Base de punto de montaje no válida: %s"
 
 #, python-format
-msgid "Invalid mount point base: %s."
-msgstr "Base de punto de montaje no válida: %s."
-
-#, python-format
 msgid "Invalid new snapCPG name for retype.  new_snap_cpg='%s'."
 msgstr ""
 "Nuevo nombre de snapCPG no válido para la reescritura. new_snap_cpg='%s'."
@@ -3211,9 +2543,6 @@ msgstr "ID secundarios no válidos %s."
 msgid "Invalid service catalog json."
 msgstr "JSON de catálogo de servicios no válido."
 
-msgid "Invalid sheepdog cluster status."
-msgstr "Estado de clúster sheepdog no válido."
-
 #, python-format
 msgid "Invalid snapshot: %(reason)s"
 msgstr "Instantánea no válida: %(reason)s"
@@ -3301,10 +2630,6 @@ msgstr ""
 "volume_type proporcionado no válido: %s (este grupo de consistencia debe "
 "soportar el tipo solicitado)."
 
-#, python-format
-msgid "Invalid wwpns format %(wwpns)s"
-msgstr "Formato de wwpns no válido %(wwpns)s"
-
 msgid "Issue encountered waiting for job."
 msgstr "Se ha detectado un problema al esperar el trabajo."
 
@@ -3317,10 +2642,6 @@ msgstr ""
 "Se está emitiendo un mensaje de migración tras error fallida porque la "
 "replicación no está configurada correctamente."
 
-#, python-format
-msgid "KeyError: %s"
-msgstr "KeyError: %s"
-
 msgid "Keystone version 3 or greater must be used to get nested quota support."
 msgstr ""
 "Se debe utilizar la versión 3 o superior de Keystone para tener soporte para "
@@ -3648,9 +2969,6 @@ msgstr ""
 msgid "New volume type not specified in request_spec."
 msgstr "No se ha especificado el tipo de volumen nuevo en request_spec."
 
-msgid "Nimble Cinder Driver exception"
-msgstr "Excepción de controlador Nimble Cinder"
-
 msgid "No FC initiator can be added to host."
 msgstr "No se puede añadir ningún iniciador FC al host."
 
@@ -3691,10 +3009,6 @@ msgid "No initiator connected to fabric.
 msgstr "No hay ningún iniciador conectado al tejido."
 
 #, python-format
-msgid "No initiator group found for initiator %s"
-msgstr "No se ha encontrado ningún grupo de iniciadores para el iniciador %s"
-
-#, python-format
 msgid "No interface found on cluster for ip %s"
 msgstr "No se ha encontrado ninguna interfaz en el clúster para la IP %s"
 
@@ -3707,9 +3021,6 @@ msgstr "No se han encontrado unidades co
 msgid "No mounted SMBFS shares found."
 msgstr "No se han encontrado unidades compartidas SMBFS montadas"
 
-msgid "No mounted Virtuozzo Storage shares found"
-msgstr "No se han encontrado unidades compartidas de Virtuozzo Storage"
-
 msgid "No mounted shares found"
 msgstr "No se han encontrado unidades compartidas montadas"
 
@@ -3735,9 +3046,6 @@ msgstr "No se ha encontrado archivo con
 msgid "No such QoS spec %(specs_id)s."
 msgstr "No hay especificaciones de QoS %(specs_id)s."
 
-msgid "No suitable discovery ip found"
-msgstr "No se ha encontrado ningún IP de descubrimiento adecuado"
-
 #, python-format
 msgid "No support to restore backup version %s"
 msgstr "No hay soporte para restaurar la versión de copia de seguridad %s"
@@ -3778,11 +3086,6 @@ msgstr "No Autorizado"
 msgid "Not enough space on backend (%(backend)s)"
 msgstr "No hay espacio suficiente en el el programa de fondo (%(backend)s)"
 
-msgid "Not enough storage space in the ZFS share to perform this operation."
-msgstr ""
-"No hay espacio de almacenamiento suficiente en la unidad compartida ZFS para "
-"realizar esta operación."
-
 msgid "Not stored in rbd"
 msgstr "No está almacenado en rbd"
 
@@ -3816,10 +3119,6 @@ msgstr ""
 "Sólo los usuarios con ámbito de señal para padres inmediatos o proyectos "
 "root pueden ver las cuotas hijo."
 
-msgid "Only volumes managed by OpenStack can be unmanaged."
-msgstr ""
-"Solo los volúmenes gestionados por OpenStack pueden dejarse de gestionar."
-
 #, python-format
 msgid "Operation failed with status=%(status)s. Full dump: %(data)s"
 msgstr ""
@@ -3871,9 +3170,6 @@ msgstr "La política no permite realizar
 msgid "Pool is not available in the volume host field."
 msgstr "La agrupación no está disponible en el campo del host del volumen."
 
-msgid "Pool is not available in the volume host fields."
-msgstr "La agrupación no está disponibles en los campos de host del volumen."
-
 #, python-format
 msgid "Pool with name %(pool_name)s wasn't found in domain %(domain_id)s."
 msgstr ""
@@ -4024,16 +3320,6 @@ msgstr "La referencia debe contener sour
 msgid "Reference must contain source-name."
 msgstr "La referencia debe contener el elemento source-name."
 
-msgid "Reference to volume to be managed must contain source-name."
-msgstr ""
-"La referencia al volumen a gestionar debe contener el elemento source-name."
-
-#, python-format
-msgid "Reference to volume: %s to be managed must contain source-name."
-msgstr ""
-"La referencia al volumen: %s a gestionar debe contener el elemento source-"
-"name."
-
 #, python-format
 msgid ""
 "Refusing to migrate volume ID: %(id)s. Please check your configuration "
@@ -4096,12 +3382,6 @@ msgid "Request body contains too many it
 msgstr "El cuerpo de solicitud contiene demasiados elementos"
 
 #, python-format
-msgid "Request to Datera cluster returned bad status: %(status)s | %(reason)s"
-msgstr ""
-"La solicitud al clúster de Datera ha devuelto un estado incorrecto: "
-"%(status)s | %(reason)s"
-
-#, python-format
 msgid ""
 "Requested backup exceeds allowed Backup gigabytes quota. Requested "
 "%(requested)sG, quota is %(quota)sG and %(consumed)sG has been consumed."
@@ -4229,12 +3509,6 @@ msgstr ""
 "El archivo de configuración SMBFS no se ha configurado (smbfs_shares_config)."
 
 #, python-format
-msgid "SSH Command failed after '%(total_attempts)r' attempts : '%(command)s'"
-msgstr ""
-"Se ha encontrado un error en el mandato SSH tras '%(total_attempts)r' "
-"intentos: '%(command)s'"
-
-#, python-format
 msgid "SSH command injection detected: %(command)s"
 msgstr "Se ha detectado inyección de mandato SSH: %(command)s"
 
@@ -4283,10 +3557,6 @@ msgstr "Error al definir el acceso secun
 msgid "Sets thin provisioning."
 msgstr "Establece suministro ligero."
 
-#, python-format
-msgid "Sheepdog I/O Error, command was: \"%s\"."
-msgstr "Error de E/S Sheepdog, el mandato era: \"%s\"."
-
 msgid ""
 "Show operations can only be made to projects in the same hierarchy of the "
 "project in which users are scoped to."
@@ -4478,15 +3748,6 @@ msgstr ""
 "El GPFS filesystem %(fs)s no está en el nivel de release requerido.  El "
 "nivel actual es %(cur)s, debe ser al menos %(min)s."
 
-#, python-format
-msgid ""
-"The WebDAV request failed. Reason: %(msg)s, Return code/reason: %(code)s, "
-"Source Volume: %(src)s, Destination Volume: %(dst)s, Method: %(method)s."
-msgstr ""
-"La solicitud WebDAV ha fallado. Motivo: %(msg)s, Código de retorno/motivo: "
-"%(code)s, Volumen de origen: %(src)s, Volumen de destino: %(dst)s, Método: "
-"%(method)s."
-
 msgid ""
 "The above error may show that the database has not been created.\n"
 "Please create a database using 'cinder-manage db sync' before running this "
@@ -4580,9 +3841,6 @@ msgstr ""
 msgid "The snapshot is unavailable: %(data)s"
 msgstr "La instantánea no está disponible: %(data)s"
 
-msgid "The source volume for this WebDAV operation not found."
-msgstr "No se ha encontrado el volumen de origen para esta operación WebDAV."
-
 #, python-format
 msgid ""
 "The source volume type '%(src)s' is different than the destination volume "
@@ -4791,10 +4049,6 @@ msgid "Type cannot be converted into NaE
 msgstr "El tipo no se puede convertir a NaElement."
 
 #, python-format
-msgid "TypeError: %s"
-msgstr "TypeError: %s"
-
-#, python-format
 msgid "UUIDs %s are in both add and remove volume list."
 msgstr ""
 "Los UUID %s están tanto en la lista de volumen de añadir como de eliminar."
@@ -5063,9 +4317,6 @@ msgid "Unexpected output. Expected [%(ex
 msgstr ""
 "Salida inesperada. Se esperaba[%(expected)s] pero se ha recibido [%(output)s]"
 
-msgid "Unexpected response from Nimble API"
-msgstr "Respuesta inesperada de la API Nimble"
-
 msgid "Unexpected status code"
 msgstr "Código de estado inesperado"
 
@@ -5086,41 +4337,10 @@ msgstr "Excepción de RemoteFS desconoci
 msgid "Unknown SMBFS exception."
 msgstr "Excepción de SMBFS desconocida"
 
-msgid "Unknown Virtuozzo Storage exception"
-msgstr "Excepción desconocida de Virtuozzo Storage"
-
 msgid "Unknown action"
 msgstr "Acción desconocida"
 
 #, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, Set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"No se sabe si el volumen: %s que se tiene que gestionar ya está siendo "
-"gestionado por Cinder. Abortando Gestionar volumen. Añada la propiedad de "
-"esquema personalizada 'cinder_managed' al volumen y establezca su valor en "
-"False. Como alternativa, establezca el valor de la política de configuración "
-"de Cinder 'zfssa_manage_policy' en 'loose' para eliminar esta restricción."
-
-#, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"No se sabe si el volumen: %s que se tiene que gestionar ya está siendo "
-"gestionado por Cinder. Abortando Gestionar volumen. Añada la propiedad de "
-"esquema personalizada 'cinder_managed' al volumen y establezca su valor en "
-"False. Como alternativa, establezca el valor de la política de configuración "
-"de Cinder 'zfssa_manage_policy' en 'loose' para eliminar esta restricción."
-
-#, python-format
 msgid "Unknown or unsupported command %(cmd)s"
 msgstr "Mandato desconocido o no soportado %(cmd)s"
 
@@ -5231,9 +4451,6 @@ msgstr "ID de usuario"
 msgid "User does not have admin privileges"
 msgstr "El usuario no tiene privilegios de administrador"
 
-msgid "User not authorized to perform WebDAV operations."
-msgstr "El usuario no tiene autorización para realizar operaciones WebDAV."
-
 msgid "UserName is not configured."
 msgstr "Nombre de usuario no está configurado."
 
@@ -5263,10 +4480,6 @@ msgstr ""
 "\"%(option)s\""
 
 #, python-format
-msgid "ValueError: %s"
-msgstr "ValueError: %s"
-
-#, python-format
 msgid "Vdisk %(name)s not involved in mapping %(src)s -> %(tgt)s."
 msgstr ""
 "El disco virtual %(name)s no está implicado en la correlación %(src)s -> "
@@ -5369,25 +4582,10 @@ msgid "Volume %s does not exist on the a
 msgstr "El volumen %s no existe en la matriz."
 
 #, python-format
-msgid "Volume %s does not have provider_location specified, skipping."
-msgstr "El volumen %s no tiene especificado provider_location, se salta."
-
-#, python-format
 msgid "Volume %s doesn't exist on array."
 msgstr "El volumen %s no existe en la matriz."
 
 #, python-format
-msgid "Volume %s doesn't exist on the ZFSSA backend."
-msgstr "El volumen %s no existe en el programa de fondo ZFSSA."
-
-#, python-format
-msgid ""
-"Volume %s is online. Set volume to offline for managing using OpenStack."
-msgstr ""
-"El volumen %s está en línea. Defina el volumen como fuera de línea para "
-"gestionarlo con  OpenStack."
-
-#, python-format
 msgid "Volume %s must not be part of a consistency group."
 msgstr "El volumen %s no debe formar parte de un grupo de consistencia."
 
@@ -5450,10 +4648,6 @@ msgid "Volume device not found at %(devi
 msgstr "Dispositivo de volumen no encontrado en: %(device)s"
 
 #, python-format
-msgid "Volume does not exists %s."
-msgstr "El volumen %s no existe."
-
-#, python-format
 msgid "Volume driver %s not initialized."
 msgstr "Controlador de volumen %s no inicializado."
 
@@ -5535,9 +4729,6 @@ msgstr "Aún no se ha asignado el volume
 msgid "Volume replication for %(volume_id)s could not be found."
 msgstr "La réplica de volumen de %(volume_id)s no se ha encontrado."
 
-msgid "Volume should have agent-type set as None."
-msgstr "El volumen debe tener agent-type establecido como None."
-
 #, python-format
 msgid ""
 "Volume size %(volume_size)sGB cannot be smaller than the image minDisk size "
@@ -5577,9 +4768,6 @@ msgstr "El tamaño del volumen debe ser
 msgid "Volume size must multiple of 1 GB."
 msgstr "El tamaño de volumen debe ser múltiplo de 1 GB."
 
-msgid "Volume status must be 'available'."
-msgstr "El estado de volumen debe ser 'disponible'."
-
 msgid "Volume to Initiator Group mapping already exists"
 msgstr "El volumen para la correlación del grupo de iniciadores ya existe"
 
@@ -5635,10 +4823,6 @@ msgstr ""
 "No se ha podido encontrar el tipo de volumen con el nombre "
 "%(volume_type_name)s."
 
-#, python-format
-msgid "Volume: %s is already being managed by Cinder."
-msgstr "El volumen %s ya se gestiona en Cinder."
-
 msgid ""
 "Volumes/account exceeded on both primary and secondary SolidFire accounts."
 msgstr ""
@@ -5646,25 +4830,9 @@ msgstr ""
 "SolidFire, tanto primarias como secundarias."
 
 #, python-format
-msgid ""
-"VzStorage config 'vzstorage_used_ratio' invalid. Must be > 0 and <= 1.0: %s."
-msgstr ""
-"VzStorage config 'vzstorage_used_ratio' no válido. Debe ser > 0 y <= 1.0: %s."
-
-#, python-format
-msgid "VzStorage config file at %(config)s doesn't exist."
-msgstr "El archivo de config VzStorage en %(config)s no existe."
-
-#, python-format
 msgid "Wait synchronize failed. Running status: %s."
 msgstr "Esperar sincronización ha fallado. Estado de ejecución: %s."
 
-msgid ""
-"Waiting for all nodes to join cluster. Ensure all sheep daemons are running."
-msgstr ""
-"Esperando a que todos los nodos se unan al clúster. Asegúrese de que los "
-"daemons sheep se estén ejecutando."
-
 msgid "We should not do switch over on primary array."
 msgstr "No deberíamos hace conmutación en la matriz principal."
 
@@ -6423,9 +5591,6 @@ msgstr ""
 msgid "fake"
 msgstr "ficticio"
 
-msgid "fileno is not supported by SheepdogIOWrapper"
-msgstr "fileno no admitido por SheepdogIOWrapper"
-
 #, python-format
 msgid "fmt=%(fmt)s backed by: %(backing_file)s"
 msgstr "fmt=%(fmt)s respaldado por: %(backing_file)s"
@@ -6474,13 +5639,6 @@ msgstr ""
 "gpfs_images_share_mode está establecido en copy_on_write, pero %(vol)s y "
 "%(img)s pertenecen a conjuntos de archivos diferentes."
 
-msgid ""
-"http service may have been abruptly disabled or put to maintenance state in "
-"the middle of this operation."
-msgstr ""
-"Es posible que el servicio HTTP se haya inhabilitado de forma abrupta o que "
-"se haya puesto en estado de mantenimiento en el transcurso de esta operación."
-
 msgid "id cannot be None"
 msgstr "el ID no puede ser None"
 
@@ -6790,11 +5948,3 @@ msgstr "volúmenes asignados"
 
 msgid "volumes changed"
 msgstr "volúmenes modificados"
-
-#, python-format
-msgid ""
-"zfssa_manage_policy property needs to be set to 'strict' or 'loose'. Current "
-"value is: %s."
-msgstr ""
-"La propiedad zfssa_manage_policy se debe establecer a 'strict' o 'loose'. El "
-"valor actual es: %s."
diff -pruN 2:15.0.1-1/cinder/locale/fr/LC_MESSAGES/cinder.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/fr/LC_MESSAGES/cinder.po
--- 2:15.0.1-1/cinder/locale/fr/LC_MESSAGES/cinder.po	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/fr/LC_MESSAGES/cinder.po	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: cinder VERSION\n"
 "Report-Msgid-Bugs-To: https://bugs.launchpad.net/openstack-i18n/\n"
-"POT-Creation-Date: 2019-10-04 05:27+0000\n"
+"POT-Creation-Date: 2020-03-18 14:40+0000\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
@@ -113,12 +113,6 @@ msgstr ""
 "prises en charge, mode réel : %(vol_mode)s."
 
 #, python-format
-msgid "%(service)s Service is not %(status)s on storage appliance: %(host)s"
-msgstr ""
-"Le service %(service)s n'a pas le statut %(status)s sur le dispositif de "
-"stockage %(host)s"
-
-#, python-format
 msgid ""
 "%(worker_name)s value of %(workers)d is invalid, must be greater than 0."
 msgstr ""
@@ -167,10 +161,6 @@ msgid "%s is not installed"
 msgstr "%s n'est pas installé"
 
 #, python-format
-msgid "%s is not installed."
-msgstr "%s n'est pas installé."
-
-#, python-format
 msgid "%s is not set"
 msgstr "%s n'est pas défini"
 
@@ -193,10 +183,6 @@ msgid "%s must be an absolute path."
 msgstr "%s doit être un chemin d'accès absolu."
 
 #, python-format
-msgid "%s not set in cinder.conf"
-msgstr "%s non défini dans cinder.conf"
-
-#, python-format
 msgid "%s not set."
 msgstr "%s non défini."
 
@@ -217,14 +203,6 @@ msgstr "'consistencygroup_id' doit être
 msgid "'qemu-img info' parsing failed."
 msgstr "Echec de l'analyse syntaxique de 'qemu-img info'."
 
-#, python-format
-msgid ""
-"(Command: %(cmd)s) (Return Code: %(exit_code)s) (Stdout: %(stdout)s) "
-"(Stderr: %(stderr)s)"
-msgstr ""
-"(Commande : %(cmd)s) (Code retour : %(exit_code)s) (Sortie standard : "
-"%(stdout)s) (Erreur standard : %(stderr)s)"
-
 msgid "A concurrent, possibly contradictory, request has been made."
 msgstr "Une demande simultanée, et peut-être contradictoire, a été effectuée."
 
@@ -315,14 +293,6 @@ msgstr ""
 "%(luncopyname)s. Statut LUNcopy : %(luncopystatus)s. Etat LUNcopy : "
 "%(luncopystate)s."
 
-#, python-format
-msgid "An error occurred while reading volume \"%s\"."
-msgstr "Une erreur s'est produite lors de la lecture du volume \"%s\"."
-
-#, python-format
-msgid "An error occurred while writing to volume \"%s\"."
-msgstr "Une erreur s'est produite lors de l'écriture dans le volume \"%s\"."
-
 msgid "An unknown exception occurred."
 msgstr "Une exception inconnue s'est produite."
 
@@ -398,9 +368,6 @@ msgstr "Catégories disponibles :"
 msgid "Backend doesn't exist (%(backend)s)"
 msgstr "Le système dorsal n'existe pas (%(backend)s)"
 
-msgid "Backend storage did not configure fiber channel target."
-msgstr "Le stockage de back-end n'a pas configuré la cible de canal optique."
-
 msgid "Backing up an in-use volume must use the force flag."
 msgstr ""
 "La sauvegarde d'un volume en cours d'utilisation doit utiliser l'indicateur "
@@ -513,10 +480,6 @@ msgstr ""
 msgid "CPG (%s) doesn't exist on array"
 msgstr "CPG (%s) n'existe pas dans la matrice"
 
-#, python-format
-msgid "Cache volume %s does not have required properties"
-msgstr "Le volume de cache %s n'a pas les propriétés requises"
-
 msgid "Can not add FC port to host."
 msgstr "Impossible d'ajouter le port FC à l'hôte."
 
@@ -655,10 +618,6 @@ msgstr ""
 "Impossible de modifier le contexte VF, VF indiqué non disponible dans la "
 "liste VF gérable %(vf_list)s."
 
-#, python-format
-msgid "Cannot create directory %s."
-msgstr "Impossible de créer le répertoire %s."
-
 msgid "Cannot create encryption specs. Volume type in use."
 msgstr ""
 "Impossible de créer des spécifications de chiffrement. Type de volume en "
@@ -683,24 +642,6 @@ msgstr ""
 "Impossible de créer volume_type avec le nom %(name)s et les spécifications "
 "%(extra_specs)s"
 
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)d volume instances."
-msgstr ""
-"Impossible de supprimer le volume cache %(cachevol_name)s. Il a été mis à "
-"jour le %(updated_at)s et contient actuellement %(numclones)d instances de "
-"volume."
-
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)s volume instances."
-msgstr ""
-"Impossible de supprimer le volume cache : %(cachevol_name)s. Ila été mis à "
-"jour le %(updated_at)s et contient actuellement %(numclones)s instances de "
-"volume."
-
 msgid "Cannot delete encryption specs. Volume type in use."
 msgstr ""
 "Impossible de supprimer des spécifications de chiffrement. Type de volume en "
@@ -773,11 +714,6 @@ msgstr ""
 "La modification définira une utilisation inférieure à 0 pour les ressources "
 "suivantes : %(unders)s"
 
-msgid "Check access permissions for the ZFS share assigned to this driver."
-msgstr ""
-"Vérifiez les autorisations d'accès accordées pour le partage ZFS affecté à "
-"ce pilote."
-
 msgid "Check hostgroup associate error."
 msgstr "Erreur lors de la vérification de l'associé hostgroup."
 
@@ -795,13 +731,6 @@ msgstr "Erreur lors de la vérification
 msgid "Check portgroup associate error."
 msgstr "Erreur lors de la vérification de l'associé portgroup."
 
-msgid ""
-"Check the state of the http service. Also ensure that the https port number "
-"is the same as the one specified in cinder.conf."
-msgstr ""
-"Vérifiez l'état du service HTTP. Assurez-vous également que le numéro de "
-"port HTTPS est identique à celui indiqué dans cinder.conf."
-
 msgid "Chunk size is not multiple of block size for creating hash."
 msgstr ""
 "La taille de bloc n'est pas un multiple de la taille de bloc pour la "
@@ -820,12 +749,6 @@ msgstr ""
 "Type de clone '%(clone_type)s' non valide, les valeurs admises sont : "
 "'%(full_clone)s' et '%(linked_clone)s'."
 
-msgid ""
-"Cluster is not formatted. You should probably perform \"dog cluster format\"."
-msgstr ""
-"Le cluster n'est pas formaté. Vous devriez probablement effectuer \"dog "
-"cluster format\"."
-
 #, python-format
 msgid "CommandLineHelper._wait_for_condition: %s timeout."
 msgstr ""
@@ -843,11 +766,6 @@ msgstr "Cluster de calcul %(cluster)s in
 msgid "Condition has no field."
 msgstr "La condition n'a aucun champ correspondant."
 
-#, python-format
-msgid "Config 'max_over_subscription_ratio' invalid. Must be > 0: %s"
-msgstr ""
-"Configuration  'max_over_subscription_ratio' non valide. Doit être > 0 : %s"
-
 msgid "Configuration error: dell_sc_ssn not set."
 msgstr "Erreur de configuration : dell_sc_ssn non défini."
 
@@ -900,6 +818,12 @@ msgid "Converted to %(f1)s, but format i
 msgstr "Converti au format %(f1)s, mais le format est maintenant %(f2)s"
 
 #, python-format
+msgid "Converted to %(vol_format)s, but format is now %(file_format)s"
+msgstr ""
+"Converti au format %(vol_format)s, mais le format est maintenant "
+"%(file_format)s"
+
+#, python-format
 msgid "Converted to raw, but format is now %s"
 msgstr "Converti au format brut, mais le format est maintenant %s"
 
@@ -1287,202 +1211,6 @@ msgstr "Active la réplication. "
 msgid "Ensure that configfs is mounted at /sys/kernel/config."
 msgstr "Assurez-vous que configfs est monté sur /sys/kernel/config."
 
-#, python-format
-msgid ""
-"Error Cloning Snapshot: %(snapshot)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Clone project: %(clone_proj)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erreur de clonage de l'instantané : %(snapshot)s sur le volume : %(lun)s du "
-"pool : %(pool)s Projet : %(project)s  Projet clone : %(clone_proj)s Code "
-"retour : %(ret.status)d Message : %(ret.data)s ."
-
-#, python-format
-msgid ""
-"Error Creating Initiator: %(initiator)s on Alias: %(alias)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Erreur de création de l'initiateur %(initiator)s sur l'alias %(alias)s. Code "
-"retour : %(ret.status)d Message : %(ret.data)s ."
-
-#, python-format
-msgid ""
-"Error Creating Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Erreur de création du projet : %(project)s sur le pool : %(pool)s Code "
-"retour : %(ret.status)d Message : %(ret.data)s ."
-
-#, python-format
-msgid ""
-"Error Creating Property: %(property)s Type: %(type)s Description: "
-"%(description)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erreur lors de la création de la propriété : %(property)s. Type : %(type)s. "
-"Description : %(description)s. Code retour : %(ret.status)d Message : "
-"%(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Share: %(name)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Erreur lors de la création du partage %(name)s. Code retour : %(ret.status)d "
-"Message : %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Volume: %(lun)s Size: %(size)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"Erreur de création du volume : %(lun)s Taille : %(size)s Code retour : "
-"%(ret.status)d Message : %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Share: %(share)s to Pool: %(pool)s "
-"Project: %(project)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erreur lors de la suppression de l'instantané %(snapshot)s sur le partage "
-"%(share)s vers le pool %(pool)s Projet : %(project)s  Code retour : "
-"%(ret.status)d Message : %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Volume: %(lun)s to Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erreur de suppression de l'instantané : %(snapshot)s sur le volume %(lun)s "
-"vers le pool %(pool)s Projet : %(project)s  Code retour : %(ret.status)d "
-"Message : %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Volume: %(lun)s from Pool: %(pool)s, Project: %(project)s. "
-"Return code: %(ret.status)d, Message: %(ret.data)s."
-msgstr ""
-"Erreur lors de la suppression du volume %(lun)s du pool : %(pool)s, projet : "
-"%(project)s. Code retour : %(ret.status)d, Message : %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting project: %(project)s on pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erreur lors de la suppression du projet %(project)s sur le pool : %(pool)s. "
-"Code retour : %(ret.status)d Message : %(ret.data)s ."
-
-#, python-format
-msgid ""
-"Error Deleting replication action: %(id)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"Erreur lors de la suppression de l'action de réplication : %(id)s. Code "
-"retour : %(ret.status)d Message : %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Initiators: InitiatorGroup: %(initiatorgroup)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Erreur d'obtention des initiateurs. InitiatorGroup : %(initiatorgroup)s. "
-"Code retour : %(ret.status)d Message : %(ret.data)s ."
-
-#, python-format
-msgid ""
-"Error Getting Pool Stats: Pool: %(pool)s Return code: %(status)d Message: "
-"%(data)s."
-msgstr ""
-"Erreur lors de l'obtention des statistiques du pool : pool : %(pool)s, code "
-"retour : %(status)d, message : %(data)s."
-
-#, python-format
-msgid ""
-"Error Getting Project Stats: Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erreur lors de l'obtention des statistiques du projet : Pool : %(pool)s "
-"Projet: %(project)s Code retour : %(ret.status)d Message : %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Share: %(share)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erreur d'obtention du partage %(share)s sur le pool %(pool)s. Projet: "
-"%(project)s Code retour : %(ret.status)d Message : %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Volume: %(lun)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erreur d'obtention du volume : %(lun)s sur le pool %(pool)s Projet : "
-"%(project)s Code retour : %(ret.status)d Message : %(ret.data)s."
-
-#, python-format
-msgid "Error Pool ownership: Pool %(pool)s is not owned by %(host)s."
-msgstr ""
-"Erreur de propriété du pool : le pool %(pool)s n'est pas détenu par %(host)s."
-
-#, python-format
-msgid ""
-"Error Setting props Props: %(props)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erreur de définition des propriétés : %(props)s sur le volume : %(lun)s du "
-"pool : %(pool)s Projet : %(project)s  Code retour : %(ret.status)d Message : "
-"%(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Initiator: %(iqn)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Erreur de vérification du demandeur : %(iqn)s Code retour : %(ret.status)d "
-"Message : %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Pool: %(pool)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Erreur de vérification du pool : %(pool)s Code retour : %(ret.status)d "
-"Message : %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erreur de vérification du projet : %(project)s sur le pool : %(pool)s Code "
-"retour : %(ret.status)d Message : %(ret.data)s ."
-
-#, python-format
-msgid ""
-"Error Verifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Erreur lors de la vérification du service %(service)s. Code retour : "
-"%(ret.status)d Message : %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Target: %(alias)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Erreur de vérification de la cible : %(alias)s Code retour : %(ret.status)d "
-"Message : %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying share: %(share)s on Project: %(project)s and Pool: %(pool)s "
-"Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erreur lors de la vérification du partage %(share)s sur le projet "
-"%(project)s et le pool %(pool)s. Code retour : %(ret.status)d Message : "
-"%(ret.data)s."
-
 msgid "Error connecting to ceph cluster."
 msgstr "Erreur lors de la connexion au cluster ceph."
 
@@ -1511,14 +1239,6 @@ msgstr "Erreur lors de l'analyse syntaxi
 
 #, python-format
 msgid ""
-"Error editing share: %(share)s on Pool: %(pool)s Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Erreur lors de l'édition du partage %(share)s sur le pool %(pool)s. Code "
-"retour : %(ret.status)d Message : %(ret.data)s ."
-
-#, python-format
-msgid ""
 "Error enabling iSER for NetworkPortal: please ensure that RDMA is supported "
 "on your iSCSI port %(port)d on ip %(ip)s."
 msgstr ""
@@ -1546,21 +1266,11 @@ msgstr "Erreur lors de l'extension du vo
 msgid "Error finding %(name)s."
 msgstr "Erreur lors de la recherche de %(name)s."
 
-msgid ""
-"Error getting appliance version details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Erreur lors de l'obtention des détails de version du dispositif. Code "
-"retour : %(ret.status)d Message : %(ret.data)s."
-
 #, python-format
 msgid "Error getting domain id from name %(name)s: %(id)s."
 msgstr ""
 "Erreur d'obtention de l'ID de domaine à partir du nom %(name)s : %(id)s."
 
-msgid "Error getting initiator groups."
-msgstr "Erreur d'obtention des groupes d'initiateurs."
-
 #, python-format
 msgid "Error getting pool id from name %(pool_name)s: %(err_msg)s."
 msgstr ""
@@ -1568,36 +1278,6 @@ msgstr ""
 "%(err_msg)s."
 
 #, python-format
-msgid ""
-"Error getting replication action: %(id)s. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Erreur lors de l'obtention de l'action de réplication : %(id)s. Code "
-"retour : %(ret.status)d Message : %(ret.data)s."
-
-msgid ""
-"Error getting replication source details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Erreur lors de l'obtention des détails de la source de réplication. Code "
-"retour : %(ret.status)d Message : %(ret.data)s."
-
-msgid ""
-"Error getting replication target details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Erreur lors de l'obtention des détails de la cible de réplication. Code "
-"retour : %(ret.status)d Message : %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error getting version: svc: %(svc)s.Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Erreur lors de l'obtention de la version : service : %(svc)s. Code retour : "
-"%(ret.status)d Message : %(ret.data)s."
-
-#, python-format
 msgid "Error in SolidFire API response: data=%(data)s"
 msgstr "Erreur dans la réponse de l'API SolidFire : data = %(data)s"
 
@@ -1605,23 +1285,6 @@ msgstr "Erreur dans la réponse de l'API
 msgid "Error managing volume: %s."
 msgstr "Erreur lors de la gestion du volume : %s."
 
-#, python-format
-msgid ""
-"Error modifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Erreur lors de la modification du service %(service)s. Code retour : "
-"%(ret.status)d Message : %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error moving volume: %(vol)s from source project: %(src)s to target project: "
-"%(tgt)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Erreur lors du déplacement du volume %(vol)s du projet source %(src)s vers "
-"le projet cible  %(tgt)s. Code retour : %(ret.status)d Message : "
-"%(ret.data)s."
-
 msgid "Error not a KeyError."
 msgstr "Erreur autre qu'une erreur KeyError."
 
@@ -1637,38 +1300,6 @@ msgid "Error retrieving volume size"
 msgstr "Erreur lors de l'obtention de la taille du volume"
 
 #, python-format
-msgid ""
-"Error sending replication update for action id: %(id)s . Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Erreur lors de l'envoi de la mise à jour de la réplication pour l'ID "
-"d'action : %(id)s. Code retour : %(ret.status)d Message : %(ret.data)s ."
-
-#, python-format
-msgid ""
-"Error sending replication update. Returned error: %(err)s. Action: %(id)s."
-msgstr ""
-"Erreur lors de l'envoi de la mise à jour de la réplication. Erreur "
-"renvoyée : %(err)s. Action : %(id)s."
-
-#, python-format
-msgid ""
-"Error setting replication inheritance to %(set)s for volume: %(vol)s project "
-"%(project)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Erreur lors de la définition de l'héritage de réplication à %(set)s pour le "
-"volume : %(vol)s Projet %(project)s. Code retour : %(ret.status)d Message : "
-"%(ret.data)s."
-
-#, python-format
-msgid ""
-"Error severing the package: %(package)s from source: %(src)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Erreur lors de la scission du package %(package)s de la source : %(src)s. "
-"Code retour : %(ret.status)d Message : %(ret.data)s ."
-
-#, python-format
 msgid "Error while authenticating with switch: %s."
 msgstr "Erreur lors de l'authentification avec le commutateur : %s."
 
@@ -1820,14 +1451,6 @@ msgstr ""
 "FC est le protocole mais les noms WWPN ne sont pas fournis par OpenStack."
 
 #, python-format
-msgid "Faield to unassign %(volume)s"
-msgstr "Echec de la libération de %(volume)s"
-
-#, python-format
-msgid "Fail to create cache volume %(volume)s. Error: %(err)s"
-msgstr "Echec de la création du volume cache %(volume)s. Erreur : %(err)s"
-
-#, python-format
 msgid "Failed adding connection for fabric=%(fabric)s: Error: %(err)s"
 msgstr ""
 "Echec de l'ajout de la connexion pour fabric=%(fabric)s : Erreur : %(err)s"
@@ -1904,11 +1527,6 @@ msgid "Failed to connect to Dell REST AP
 msgstr "Echec de connexion à l'API REST Dell "
 
 #, python-format
-msgid "Failed to connect to sheep daemon. addr: %(addr)s, port: %(port)s"
-msgstr ""
-"Echec de la connexion au démon sheep. Adresse : %(addr)s, port : %(port)s"
-
-#, python-format
 msgid "Failed to copy image to volume: %(reason)s"
 msgstr "Échec de la copie de l'image vers le volume : %(reason)s"
 
@@ -1934,21 +1552,6 @@ msgid "Failed to create api volume flow.
 msgstr "Echec de la création du flux de volume d'API."
 
 #, python-format
-msgid "Failed to create cg snapshot %(id)s due to %(reason)s."
-msgstr ""
-"Echec de la création de l'instantané du groupe de cohérence %(id)s. Cause : "
-"%(reason)s."
-
-#, python-format
-msgid "Failed to create consistency group %(id)s due to %(reason)s."
-msgstr ""
-"Echec de la création du groupe de cohérence %(id)s. Cause : %(reason)s."
-
-#, python-format
-msgid "Failed to create consistency group %(id)s:%(ret)s."
-msgstr "Echec de la création du groupe de cohérence %(id)s : %(ret)s."
-
-#, python-format
 msgid "Failed to create consistency group: %(cgid)s. Error: %(excmsg)s."
 msgstr ""
 "Echec de la création du groupe de cohérence : %(cgid)s. Erreur : %(excmsg)s."
@@ -2020,17 +1623,6 @@ msgid "Failed to create volume %s"
 msgstr "Echec de création du volume %s"
 
 #, python-format
-msgid "Failed to delete cgsnapshot %(id)s due to %(reason)s."
-msgstr ""
-"Echec de la suppression de l'instantané du groupe de cohérence %(id)s. "
-"Cause : %(reason)s."
-
-#, python-format
-msgid "Failed to delete consistency group %(id)s due to %(reason)s."
-msgstr ""
-"Echec de la suppression du groupe de cohérence %(id)s. Cause : %(reason)s."
-
-#, python-format
 msgid ""
 "Failed to delete fileset for consistency group %(cgname)s. Error: %(excmsg)s."
 msgstr ""
@@ -2106,11 +1698,6 @@ msgid "Failed to find host %s."
 msgstr "L'hôte %s est introuvable."
 
 #, python-format
-msgid "Failed to find iSCSI initiator group containing %(initiator)s."
-msgstr ""
-"Impossible de trouver le groupe d'initiateurs iSCSI contenant %(initiator)s."
-
-#, python-format
 msgid "Failed to get LUN target details for the LUN %s"
 msgstr "Echec d'obtention des détails cible du numéro d'unité logique %s"
 
@@ -2227,14 +1814,6 @@ msgstr "Echec de connexion à la matrice
 msgid "Failed to login with all rest URLs."
 msgstr "Echec de connexion à toutes les URL Rest."
 
-#, python-format
-msgid ""
-"Failed to make a request to Datera cluster endpoint due to the following "
-"reason: %s"
-msgstr ""
-"Echec de la demande au noeud final du cluster Datera pour la raison "
-"suivante : %s"
-
 msgid "Failed to manage api volume flow."
 msgstr "Echec de la gestion du flux de volume d'API."
 
@@ -2446,32 +2025,6 @@ msgid "Failure staging LUN %s to tmp."
 msgstr "Echec du transfert du numéro d'unité logique %s vers tmp."
 
 #, python-format
-msgid "Fexvisor failed to add volume %(id)s due to %(reason)s."
-msgstr ""
-"Echec de Fexvisor lors de l'ajout du volume %(id)s. Cause : %(reason)s."
-
-#, python-format
-msgid ""
-"Fexvisor failed to join the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr ""
-"Fexvisor n'est pas parvenu à joindre le volume %(vol)s au groupe %(group)s. "
-"Motif : %(ret)s."
-
-#, python-format
-msgid ""
-"Fexvisor failed to remove the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr ""
-"Fexvisor n'est pas parvenu à retirer le volume %(vol)s du groupe %(group)s. "
-"Motif : %(ret)s."
-
-#, python-format
-msgid "Fexvisor failed to remove volume %(id)s due to %(reason)s."
-msgstr ""
-"Fexvisor n'est pas parvenu à supprimer le volume %(id)s. Motif : %(reason)s."
-
-#, python-format
 msgid "Fibre Channel SAN Lookup failure: %(reason)s"
 msgstr "Echec de recherche de réseau SAN Fibre Channel : %(reason)s"
 
@@ -2488,10 +2041,6 @@ msgid "File %(file_path)s could not be f
 msgstr "Fichier %(file_path)s introuvable."
 
 #, python-format
-msgid "File already exists at %s."
-msgstr "Le fichier existe déjà dans %s."
-
-#, python-format
 msgid "File already exists at: %s"
 msgstr "Le fichier existe déjà dans : %s"
 
@@ -2524,210 +2073,6 @@ msgstr ""
 "'%(version)s' soit installé."
 
 #, python-format
-msgid "Flexvisor assign volume failed.:%(id)s:%(status)s."
-msgstr ""
-"Echec de Flexvisor lors de l'affectation de volume : %(id)s : %(status)s."
-
-#, python-format
-msgid "Flexvisor assign volume failed:%(id)s:%(status)s."
-msgstr ""
-"Echec de Flexvisor lors de l'affectation de volume : %(id)s : %(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor could not find volume %(id)s snapshot in the group %(vgid)s "
-"snapshot %(vgsid)s."
-msgstr ""
-"Flexvisor n'a pas trouvé l'instantané %(id)s du volume dans l'instantané "
-"%(vgsid)s du groupe %(vgid)s."
-
-#, python-format
-msgid "Flexvisor create volume failed.:%(volumeid)s:%(status)s."
-msgstr ""
-"Echec de Flexvisor lors de la création de volume : %(volumeid)s : %(status)s."
-
-#, python-format
-msgid "Flexvisor failed deleting volume %(id)s: %(status)s."
-msgstr ""
-"Echec de Flexvisor lors de la suppression du volume %(id)s : %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to add volume %(id)s to group %(cgid)s."
-msgstr ""
-"Echec de Flexvisor lors de l'ajout du volume %(id)s au groupe %(cgid)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to assign volume %(id)s due to unable to query status by "
-"event id."
-msgstr ""
-"Flexvisor n'a pas affecté le volume %(id)s car il ne peut demander l'état de "
-"la requête par ID d'événement."
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(id)s: %(status)s."
-msgstr ""
-"Echec de Flexvisor lors de l'affectation du volume %(id)s : %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(volume)s iqn %(iqn)s."
-msgstr ""
-"Echec de Flexvisor lors de l'affectation du volume %(volume)s IQN %(iqn)s."
-
-#, python-format
-msgid "Flexvisor failed to clone volume %(id)s: %(status)s."
-msgstr "Echec de Flexvisor lors du clonage du volume %(id)s : %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to clone volume (failed to get event) %(id)s."
-msgstr ""
-"Echec de Flexvisor lors du clonage du volume (échec de l'obtention de "
-"l'événement) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to create snapshot for volume %(id)s: %(status)s."
-msgstr ""
-"Echec de Flexvisor lors de la création de l'instantané pour le volume "
-"%(id)s : %(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to create snapshot for volume (failed to get event) %(id)s."
-msgstr ""
-"Echec de Flexvisor lors de la création de l'instantané pour le volume (échec "
-"de l'obtention de l'événement) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume %(id)s in the group %(vgid)s."
-msgstr ""
-"Echec de Flexvisor lors de la création du volume %(id)s dans le groupe "
-"%(vgid)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume %(volume)s: %(status)s."
-msgstr ""
-"Echec de Flexvisor lors de la création du volume %(volume)s : %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume (get event) %s."
-msgstr ""
-"Echec de Flexvisor lors de la création du volume (obtention de l'événement) "
-"%s."
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s: %(status)s."
-msgstr ""
-"Echec de Flexvisor lors de la création du volume à partir de l'instantané "
-"%(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s:%(status)s."
-msgstr ""
-"Echec de Flexvisor lors de la création du volume à partir de l'instantané "
-"%(id)s:%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to create volume from snapshot (failed to get event) %(id)s."
-msgstr ""
-"Echec de Flexvisor lors de la création du volume à partir de l'instantané "
-"(échec de l'obtention de l'événement) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot %(id)s: %(status)s."
-msgstr ""
-"Echec de Flexvisor lors de la suppression de l'instantané %(id)s : "
-"%(status)s."
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot (failed to get event) %(id)s."
-msgstr ""
-"Echec de Flexvisor lors de la suppression de l'instantané (échec de "
-"l'obtention de l'événement) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to delete volume %(id)s: %(status)s."
-msgstr ""
-"Echec de Flexvisor lors de la suppression du volume %(id)s : %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s: %(status)s."
-msgstr ""
-"Echec de Flexvisor lors de l'exportation du volume %(id)s : %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s:%(status)s."
-msgstr ""
-"Echec de Flexvisor lors de l'exportation du volume %(id)s : %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume (failed to get event) %(id)s."
-msgstr ""
-"Echec de Flexvisor lors de l'extension du volume (échec de l'obtention de "
-"l'événement) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to get pool info %(id)s: %(status)s."
-msgstr ""
-"Echec de Flexvisor lors de l'obtention des informations de pool %(id)s : "
-"%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to get snapshot id of volume %(id)s from group %(vgid)s."
-msgstr ""
-"Echec de Flexvisor lors de l'obtention de l'ID instantané du volume %(id)s à "
-"partir du groupe %(vgid)s."
-
-#, python-format
-msgid "Flexvisor failed to remove volume %(id)s from group %(cgid)s."
-msgstr ""
-"Flexvisor n'est pas parvenu à supprimer le volume %(id)s du groupe %(cgid)s."
-
-#, python-format
-msgid "Flexvisor failed to spawn volume from snapshot %(id)s:%(status)s."
-msgstr ""
-"Echec de Flexvisor lors de la génération du volume à partir de l'instantané "
-"%(id)s:%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to spawn volume from snapshot (failed to get event) %(id)s."
-msgstr ""
-"Echec de Flexvisor lors de la génération du volume à partir de l'instantané "
-"(échec de l'obtention de l'événement) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume %(id)s: %(status)s."
-msgstr ""
-"Echec de Flexvisor lors de la libération du volume %(id)s : %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume (get event) %(id)s."
-msgstr ""
-"Echec de Flexvisor lors de la libération du volume (obtention de "
-"l'événement) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume:%(id)s:%(status)s."
-msgstr ""
-"Echec de Flexvisor lors de la libération du volume %(id)s : %(status)s."
-
-#, python-format
-msgid "Flexvisor unable to find the source volume %(id)s info."
-msgstr "Flexvisor n'a pas trouvé les infos du volume source %(id)s."
-
-#, python-format
-msgid "Flexvisor unassign volume failed:%(id)s:%(status)s."
-msgstr ""
-"Echec de Flexvisor lors de la libération de volume : %(id)s : %(status)s."
-
-#, python-format
-msgid "Flexvisor volume %(id)s failed to join group %(vgid)s."
-msgstr ""
-"Le volume Flexvisor %(id)s n'a pas réussi à joindre le groupe %(vgid)s."
-
-#, python-format
 msgid "Folder %s does not exist in Nexenta Store appliance"
 msgstr "Le dossier %s n'existe pas dans Nexenta Store Appliance"
 
@@ -3058,14 +2403,6 @@ msgid "Invalid Replication Target: %(rea
 msgstr "Cible de réplication non valide : %(reason)s"
 
 #, python-format
-msgid ""
-"Invalid Virtuozzo Storage share specification: %r. Must be: [MDS1[,"
-"MDS2],...:/]<CLUSTER NAME>[:PASSWORD]."
-msgstr ""
-"Spécification de partage Virtuozzo Storage non valide : %r. Doit être : "
-"[MDS1[,MDS2],...:/]<NOM CLUSTER>[:MOT DE PASSE]."
-
-#, python-format
 msgid "Invalid XtremIO version %(cur)s, version %(min)s or up is required"
 msgstr ""
 "Version XtremIO non valide %(cur)s, version %(min)s ou ultérieure est requise"
@@ -3075,13 +2412,6 @@ msgid "Invalid allocated quotas defined
 msgstr ""
 "Quotas alloués non valides définis pour les quotas de projet suivants : %s"
 
-msgid "Invalid argument - negative seek offset."
-msgstr "Argument non valide - décalage seek négatif."
-
-#, python-format
-msgid "Invalid argument - whence=%s not supported."
-msgstr "Argument non valide - whence=%s n'est pas pris en charge."
-
 #, python-format
 msgid "Invalid attaching mode '%(mode)s' for volume %(volume_id)s."
 msgstr "Mode de connexion '%(mode)s' non valide pour le volume %(volume_id)s."
@@ -3095,18 +2425,6 @@ msgid "Invalid backup: %(reason)s"
 msgstr "Sauvegarde non valide : %(reason)s"
 
 #, python-format
-msgid "Invalid connection initialization response of volume %(name)s"
-msgstr ""
-"Réponse d'initialisation de connexion non valide pour le volume %(name)s"
-
-#, python-format
-msgid ""
-"Invalid connection initialization response of volume %(name)s: %(output)s"
-msgstr ""
-"Réponse d'initialisation de connexion non valide pour le volume %(name)s : "
-"%(output)s"
-
-#, python-format
 msgid "Invalid content type %(content_type)s."
 msgstr "Le type de contenu %(content_type)s est invalide"
 
@@ -3197,10 +2515,6 @@ msgid "Invalid mount point base: %s"
 msgstr "Base du point de montage non valide : %s"
 
 #, python-format
-msgid "Invalid mount point base: %s."
-msgstr "Base de point de montage non valide : %s."
-
-#, python-format
 msgid "Invalid new snapCPG name for retype.  new_snap_cpg='%s'."
 msgstr "Nouveau nom snapCPG non valide pour confirmation. new_snap_cpg='%s'."
 
@@ -3219,9 +2533,6 @@ msgstr "ID secondaire non valide %s."
 msgid "Invalid service catalog json."
 msgstr "json de catalogue de service non valide."
 
-msgid "Invalid sheepdog cluster status."
-msgstr "Statut de cluster Sheepdog non valide."
-
 #, python-format
 msgid "Invalid snapshot: %(reason)s"
 msgstr "snapshot invalide : %(reason)s"
@@ -3307,10 +2618,6 @@ msgstr ""
 "volume_type non valide fourni : %s (le type demandé doit être pris en charge "
 "par ce groupe de cohérence)."
 
-#, python-format
-msgid "Invalid wwpns format %(wwpns)s"
-msgstr "Format de wwpn %(wwpns)s non valide"
-
 msgid "Issue encountered waiting for job."
 msgstr "Erreur rencontrée durant l'attente du travail."
 
@@ -3323,10 +2630,6 @@ msgstr ""
 "Le lancement d'un basculement a échoué car la réplication n'a pas été "
 "configurée correctement."
 
-#, python-format
-msgid "KeyError: %s"
-msgstr "KeyError : %s"
-
 msgid "Keystone version 3 or greater must be used to get nested quota support."
 msgstr ""
 "Keystone version 3 ou ultérieure doit être utilisé pour la prise en charge "
@@ -3634,9 +2937,6 @@ msgstr ""
 msgid "New volume type not specified in request_spec."
 msgstr "Nouveau type de volume non indiqué dans request_spec."
 
-msgid "Nimble Cinder Driver exception"
-msgstr "Exception du pilote Nimble Cinder"
-
 msgid "No FC initiator can be added to host."
 msgstr "Aucun initiateur FC ne peut être ajouté à l'hôte."
 
@@ -3674,10 +2974,6 @@ msgid "No initiator connected to fabric.
 msgstr "Aucun initiateur n'est connecté à l'ensemble de noeuds (fabric)."
 
 #, python-format
-msgid "No initiator group found for initiator %s"
-msgstr "Aucun groupe demandeur trouvé pour le demandeur %s"
-
-#, python-format
 msgid "No interface found on cluster for ip %s"
 msgstr "Aucune interface trouvée dans le cluster pour l'IP %s"
 
@@ -3690,9 +2986,6 @@ msgstr "Aucun partage NFS monté trouvé
 msgid "No mounted SMBFS shares found."
 msgstr "Aucun partage SMBFS monté trouvé."
 
-msgid "No mounted Virtuozzo Storage shares found"
-msgstr "Aucun partage de stockage Virtuozzo monté n'a été trouvé"
-
 msgid "No mounted shares found"
 msgstr "Aucun partage monté trouvé"
 
@@ -3718,9 +3011,6 @@ msgstr "Aucun instantané trouvé avec %
 msgid "No such QoS spec %(specs_id)s."
 msgstr "Aucune spécif. QoS du type %(specs_id)s."
 
-msgid "No suitable discovery ip found"
-msgstr "Aucune adresse IP correcte trouvée"
-
 #, python-format
 msgid "No support to restore backup version %s"
 msgstr ""
@@ -3758,11 +3048,6 @@ msgstr "Non autorisé."
 msgid "Not enough space on backend (%(backend)s)"
 msgstr "Espace insuffisant sur le système dorsal (%(backend)s)"
 
-msgid "Not enough storage space in the ZFS share to perform this operation."
-msgstr ""
-"Espace de stockage insuffisant dans le partage ZFS pour exécuter cette "
-"opération."
-
 msgid "Not stored in rbd"
 msgstr "Non stocké dans rbd"
 
@@ -3796,9 +3081,6 @@ msgstr ""
 "Seuls les utilisateurs avec portée de jeton sur les parents immédiats ou les "
 "projets racine sont autoriser à visualiser ses quotas enfants."
 
-msgid "Only volumes managed by OpenStack can be unmanaged."
-msgstr "Seuls les volumes gérés par OpenStack peuvent être non gérés."
-
 #, python-format
 msgid "Operation failed with status=%(status)s. Full dump: %(data)s"
 msgstr ""
@@ -3844,9 +3126,6 @@ msgstr "Le réglage des droits n'autoris
 msgid "Pool is not available in the volume host field."
 msgstr "Le pool n'est pas disponible dans la zone d'hôte du volume."
 
-msgid "Pool is not available in the volume host fields."
-msgstr "Le pool n'est pas disponible dans les zones d'hôte du volume."
-
 #, python-format
 msgid "Pool with name %(pool_name)s wasn't found in domain %(domain_id)s."
 msgstr ""
@@ -3988,13 +3267,6 @@ msgstr "La référence doit contenir l'
 msgid "Reference must contain source-name."
 msgstr "La référence doit contenir source-name."
 
-msgid "Reference to volume to be managed must contain source-name."
-msgstr "La référence au volume à gérer doit contenir l'élément source-name."
-
-#, python-format
-msgid "Reference to volume: %s to be managed must contain source-name."
-msgstr "La référence au volume %s à gérer doit contenir l'élément source-name."
-
 #, python-format
 msgid ""
 "Refusing to migrate volume ID: %(id)s. Please check your configuration "
@@ -4059,12 +3331,6 @@ msgid "Request body contains too many it
 msgstr "Le corps de la demande contient un trop grand nombre d'éléments"
 
 #, python-format
-msgid "Request to Datera cluster returned bad status: %(status)s | %(reason)s"
-msgstr ""
-"La demande au cluster Datera a renvoyé un statut incorrect : %(status)s | "
-"%(reason)s"
-
-#, python-format
 msgid ""
 "Requested backup exceeds allowed Backup gigabytes quota. Requested "
 "%(requested)sG, quota is %(quota)sG and %(consumed)sG has been consumed."
@@ -4182,12 +3448,6 @@ msgid "SMBFS config file not set (smbfs_
 msgstr "Fichier de configuration SMBFS non défini (smbfs_shares_config)."
 
 #, python-format
-msgid "SSH Command failed after '%(total_attempts)r' attempts : '%(command)s'"
-msgstr ""
-"Echec de la commande SSH après '%(total_attempts)r' tentatives : "
-"'%(command)s'"
-
-#, python-format
 msgid "SSH command injection detected: %(command)s"
 msgstr "Injection de commande SSH détectée : %(command)s"
 
@@ -4231,10 +3491,6 @@ msgstr "Erreur lors de la définition d'
 msgid "Sets thin provisioning."
 msgstr "Active l'allocation de ressources à la demande."
 
-#, python-format
-msgid "Sheepdog I/O Error, command was: \"%s\"."
-msgstr "Erreur d'E-S Sheepdog I/O, commande concernée : \"%s\"."
-
 msgid ""
 "Show operations can only be made to projects in the same hierarchy of the "
 "project in which users are scoped to."
@@ -4425,15 +3681,6 @@ msgstr ""
 "Le système de fichiers GPFS %(fs)s ne se trouve pas au niveau d'édition "
 "requis. Niveau actuel : %(cur)s, niveau minimal requis : %(min)s."
 
-#, python-format
-msgid ""
-"The WebDAV request failed. Reason: %(msg)s, Return code/reason: %(code)s, "
-"Source Volume: %(src)s, Destination Volume: %(dst)s, Method: %(method)s."
-msgstr ""
-"Echec de la demande WebDAV. Cause : %(msg)s. Code retour/cause : %(code)s, "
-"volume source : %(src)s, volume de destination : %(dst)s, méthode : "
-"%(method)s."
-
 msgid ""
 "The above error may show that the database has not been created.\n"
 "Please create a database using 'cinder-manage db sync' before running this "
@@ -4522,9 +3769,6 @@ msgstr ""
 "L'instantané ne peut pas être créé alors que le volume est en mode "
 "maintenance."
 
-msgid "The source volume for this WebDAV operation not found."
-msgstr "Volume source introuvable pour cette opération WebDAV."
-
 #, python-format
 msgid ""
 "The source volume type '%(src)s' is different than the destination volume "
@@ -4743,10 +3987,6 @@ msgid "Type cannot be converted into NaE
 msgstr "Impossible de convertir le type en NaElement."
 
 #, python-format
-msgid "TypeError: %s"
-msgstr "TypeError : %s"
-
-#, python-format
 msgid "UUIDs %s are in both add and remove volume list."
 msgstr ""
 "Les UUID %s sont tous les deux dans la liste de volumes à ajouter et à "
@@ -5008,9 +4248,6 @@ msgstr ""
 msgid "Unexpected output. Expected [%(expected)s] but received [%(output)s]"
 msgstr "Sortie inattendue. [%(expected)s] attendu mais  [%(output)s] reçu"
 
-msgid "Unexpected response from Nimble API"
-msgstr "Code de réponse inattendu de l'API Nimble"
-
 msgid "Unexpected status code"
 msgstr "Code de statut inattendu"
 
@@ -5031,41 +4268,10 @@ msgstr "Exception RemoteFS inconnue"
 msgid "Unknown SMBFS exception."
 msgstr "Exception SMBFS inconnue."
 
-msgid "Unknown Virtuozzo Storage exception"
-msgstr "Exception Virtuozzo Storage inconnue"
-
 msgid "Unknown action"
 msgstr "Action inconnu"
 
 #, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, Set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"Inconnu si le volume : %s à gérer est déjà géré par Cinder. Abandon de "
-"l'opération gérer le volume. Ajoutez la propriété de schéma personnalisé "
-"'cinder_managed' au volume et définissez sa valeur sur False. Autrement, "
-"définissez la valeur de la stratégie de configuration cinder "
-"'zfssa_manage_policy' sur 'loose' pour supprimer cette restriction."
-
-#, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"Inconnu si le volume : %s à gérer est déjà géré par Cinder. Abandon de "
-"l'opération gérer le volume. Ajoutez la propriété de schéma personnalisé "
-"'cinder_managed' au volume et définissez sa valeur sur False. Autrement, "
-"définissez la valeur de la stratégie de configuration cinder "
-"'zfssa_manage_policy' sur 'loose' pour supprimer cette restriction."
-
-#, python-format
 msgid "Unknown or unsupported command %(cmd)s"
 msgstr "Commande inconnue ou non prise en charge %(cmd)s"
 
@@ -5178,9 +4384,6 @@ msgstr "ID Utilisateur"
 msgid "User does not have admin privileges"
 msgstr "L’utilisateur n'a pas les privilèges administrateur"
 
-msgid "User not authorized to perform WebDAV operations."
-msgstr "Utilisateur non autorisé à exécuter des opérations WebDAV."
-
 msgid "UserName is not configured."
 msgstr "UserName n'est pas configuré."
 
@@ -5210,10 +4413,6 @@ msgstr ""
 "\"%(option)s\""
 
 #, python-format
-msgid "ValueError: %s"
-msgstr "ValueError : %s"
-
-#, python-format
 msgid "Vdisk %(name)s not involved in mapping %(src)s -> %(tgt)s."
 msgstr ""
 "Le disque virtuel %(name)s n'est pas impliqué dans le mappage %(src)s -> "
@@ -5316,26 +4515,10 @@ msgid "Volume %s does not exist on the a
 msgstr "Le volume %s n'existe pas sur la matrice."
 
 #, python-format
-msgid "Volume %s does not have provider_location specified, skipping."
-msgstr ""
-"provider_location n'a pas été spécifié pour le volume %s. Il sera ignoré."
-
-#, python-format
 msgid "Volume %s doesn't exist on array."
 msgstr "Le volume %s n'existe pas sur la matrice."
 
 #, python-format
-msgid "Volume %s doesn't exist on the ZFSSA backend."
-msgstr "Le volume %s n'existe pas sur le back-end ZFSSA."
-
-#, python-format
-msgid ""
-"Volume %s is online. Set volume to offline for managing using OpenStack."
-msgstr ""
-"Le volume %s est en ligne (online). Définissez le volume comme étant hors "
-"ligne (offline) pour le gérer avec OpenStack."
-
-#, python-format
 msgid "Volume %s must not be part of a consistency group."
 msgstr "Le volume %s ne doit pas faire partie d'un groupe de cohérence."
 
@@ -5479,9 +4662,6 @@ msgstr "Volume non encore affecté à l'
 msgid "Volume replication for %(volume_id)s could not be found."
 msgstr "Réplication du volume pour %(volume_id)s introuvable."
 
-msgid "Volume should have agent-type set as None."
-msgstr "Le volume doit avoir la valeur agent-type définie à None."
-
 #, python-format
 msgid ""
 "Volume size %(volume_size)sGB cannot be smaller than the image minDisk size "
@@ -5523,9 +4703,6 @@ msgstr "La taille du volume doit être u
 msgid "Volume size must multiple of 1 GB."
 msgstr "La taille du volume doit être un multiple de 1 Go."
 
-msgid "Volume status must be 'available'."
-msgstr "L'état du volume doit être 'disponible'."
-
 msgid "Volume to Initiator Group mapping already exists"
 msgstr "Le volume pour le mappage du groupe initiateur existe déjà"
 
@@ -5580,10 +4757,6 @@ msgstr "Le nom de type de volume ne peut
 msgid "Volume type with name %(volume_type_name)s could not be found."
 msgstr "Le type de volume portant le nom %(volume_type_name)s est introuvable."
 
-#, python-format
-msgid "Volume: %s is already being managed by Cinder."
-msgstr "Volume %s déjà géré par Cinder."
-
 msgid ""
 "Volumes/account exceeded on both primary and secondary SolidFire accounts."
 msgstr ""
@@ -5591,26 +4764,9 @@ msgstr ""
 "secondaires."
 
 #, python-format
-msgid ""
-"VzStorage config 'vzstorage_used_ratio' invalid. Must be > 0 and <= 1.0: %s."
-msgstr ""
-"La configuration VzStorage 'vzstorage_used_ratio' n'est pas valide. Doit "
-"être > 0 et <= 1.0: %s."
-
-#, python-format
-msgid "VzStorage config file at %(config)s doesn't exist."
-msgstr "Le fichier de configuration VzStorage %(config)s n'existe pas."
-
-#, python-format
 msgid "Wait synchronize failed. Running status: %s."
 msgstr "Echec de l'attente de synchronisation. Statut d'exécution : %s."
 
-msgid ""
-"Waiting for all nodes to join cluster. Ensure all sheep daemons are running."
-msgstr ""
-"En attente que tous les noeuds aient rejoint le cluster. Vérifiez que tous "
-"les démons sheep sont en exécution."
-
 msgid "We should not do switch over on primary array."
 msgstr ""
 "Il est déconseillé d'effectuer un basculement sur la matrice principale."
@@ -6357,9 +5513,6 @@ msgstr "extend_volume, nom du volume : %
 msgid "fake"
 msgstr "factice"
 
-msgid "fileno is not supported by SheepdogIOWrapper"
-msgstr "fileno n'est pas pris en charge par SheepdogIOWrapper"
-
 #, python-format
 msgid "fmt=%(fmt)s backed by: %(backing_file)s"
 msgstr "fmt=%(fmt)s sauvegardé par : %(backing_file)s"
@@ -6408,13 +5561,6 @@ msgstr ""
 "gpfs_images_share_mode est défini sur copy_on_write mais %(vol)s et %(img)s "
 "appartiennent à des ensembles de fichiers différents."
 
-msgid ""
-"http service may have been abruptly disabled or put to maintenance state in "
-"the middle of this operation."
-msgstr ""
-"Le service HTTP a pu être subitement désactivé ou mis à l'état de "
-"maintenance au milieu de cette opération."
-
 msgid "id cannot be None"
 msgstr "l'ID ne peut pas être None"
 
@@ -6707,11 +5853,3 @@ msgstr "volumes affectés"
 
 msgid "volumes changed"
 msgstr "volumes modifiés"
-
-#, python-format
-msgid ""
-"zfssa_manage_policy property needs to be set to 'strict' or 'loose'. Current "
-"value is: %s."
-msgstr ""
-"La propriété zfssa_manage_policy doit être définie avec la valeur 'strict' "
-"ou 'loose'. Valeur actuelle : %s."
diff -pruN 2:15.0.1-1/cinder/locale/it/LC_MESSAGES/cinder.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/it/LC_MESSAGES/cinder.po
--- 2:15.0.1-1/cinder/locale/it/LC_MESSAGES/cinder.po	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/it/LC_MESSAGES/cinder.po	2020-03-24 18:46:31.000000000 +0000
@@ -9,7 +9,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: cinder VERSION\n"
 "Report-Msgid-Bugs-To: https://bugs.launchpad.net/openstack-i18n/\n"
-"POT-Creation-Date: 2019-10-04 05:27+0000\n"
+"POT-Creation-Date: 2020-03-18 14:40+0000\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
@@ -109,12 +109,6 @@ msgstr ""
 "sono supportati; la modalità corrente è %(vol_mode)s."
 
 #, python-format
-msgid "%(service)s Service is not %(status)s on storage appliance: %(host)s"
-msgstr ""
-"Il servizio %(service)s non è %(status)s sull'applicazione di archiviazione: "
-"%(host)s"
-
-#, python-format
 msgid ""
 "%(worker_name)s value of %(workers)d is invalid, must be greater than 0."
 msgstr ""
@@ -163,10 +157,6 @@ msgid "%s is not installed"
 msgstr "%s non installato"
 
 #, python-format
-msgid "%s is not installed."
-msgstr "%s non installato."
-
-#, python-format
 msgid "%s is not set"
 msgstr "%s non è impostato"
 
@@ -189,10 +179,6 @@ msgid "%s must be an absolute path."
 msgstr "%s deve essere un percorso assoluto."
 
 #, python-format
-msgid "%s not set in cinder.conf"
-msgstr "%s non impostato in cinder.conf"
-
-#, python-format
 msgid "%s not set."
 msgstr "%s non impostato."
 
@@ -213,14 +199,6 @@ msgstr "è necessario specificare 'consi
 msgid "'qemu-img info' parsing failed."
 msgstr "analisi di 'qemu-img info' non riuscita."
 
-#, python-format
-msgid ""
-"(Command: %(cmd)s) (Return Code: %(exit_code)s) (Stdout: %(stdout)s) "
-"(Stderr: %(stderr)s)"
-msgstr ""
-"(Comando: %(cmd)s) (Codice di ritorno: %(exit_code)s) (Stdout: %(stdout)s) "
-"(Stderr: %(stderr)s)"
-
 msgid "A concurrent, possibly contradictory, request has been made."
 msgstr ""
 "È stata effettuata una richiesta contemporanea, probabilmente "
@@ -313,14 +291,6 @@ msgstr ""
 "%(luncopyname)s. Stato LUNcopy: %(luncopystatus)s. Stato LUNcopy: "
 "%(luncopystate)s."
 
-#, python-format
-msgid "An error occurred while reading volume \"%s\"."
-msgstr "Si è verificato un errore durante la lettura del volume \"%s\". "
-
-#, python-format
-msgid "An error occurred while writing to volume \"%s\"."
-msgstr "Si è verificato un errore durante la scrittura del volume \"%s\". "
-
 msgid "An unknown exception occurred."
 msgstr "E' stato riscontrato un errore sconosciuto"
 
@@ -392,11 +362,6 @@ msgstr "Categorie disponibili:"
 msgid "Backend doesn't exist (%(backend)s)"
 msgstr "Il backend non esiste (%(backend)s)"
 
-msgid "Backend storage did not configure fiber channel target."
-msgstr ""
-"L'archivio di backend non ha configurato la destinazione del canale a fibre "
-"ottiche"
-
 msgid "Backing up an in-use volume must use the force flag."
 msgstr ""
 "Il backup di un volume in uso deve utilizzare l'indicatore di forzatura. "
@@ -507,10 +472,6 @@ msgstr ""
 msgid "CPG (%s) doesn't exist on array"
 msgstr "CPG (%s) non esiste nell'array"
 
-#, python-format
-msgid "Cache volume %s does not have required properties"
-msgstr "Il volume della cache %s non presenta le proprietà richieste"
-
 msgid "Can not add FC port to host."
 msgstr "Impossibile aggiungere la porta FC all'host."
 
@@ -642,10 +603,6 @@ msgstr ""
 "Impossibile modificare il contesto VF, il contesto VF specificato non è "
 "disponibile nell'elenco di VF gestibili %(vf_list)s."
 
-#, python-format
-msgid "Cannot create directory %s."
-msgstr "Impossibile creare la directory %s. "
-
 msgid "Cannot create encryption specs. Volume type in use."
 msgstr "Impossibile creare le specifiche di codifica. Tipo di volume in uso."
 
@@ -665,22 +622,6 @@ msgid "Cannot create volume_type with na
 msgstr ""
 "Impossibile creare volume_type con nome %(name)s e specifiche %(extra_specs)s"
 
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)d volume instances."
-msgstr ""
-"Impossibile eliminare il volume cache: %(cachevol_name)s. È stato aggiornato "
-"alle%(updated_at)s e attualmente ha %(numclones)d istanze volume."
-
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)s volume instances."
-msgstr ""
-"Impossibile eliminare il volume cache: %(cachevol_name)s. È stato aggiornato "
-"alle%(updated_at)s e attualmente ha %(numclones)s istanze volume."
-
 msgid "Cannot delete encryption specs. Volume type in use."
 msgstr ""
 "Impossibile eliminare le specifiche di codifica. Tipo di volume in uso."
@@ -747,11 +688,6 @@ msgstr ""
 "La modifica renderebbe l'utilizzo inferiore a 0 per le seguenti risorse: "
 "%(unders)s"
 
-msgid "Check access permissions for the ZFS share assigned to this driver."
-msgstr ""
-"Controllare le autorizzazioni di accesso per la condivisione ZFS assegnata a "
-"questo driver."
-
 msgid "Check hostgroup associate error."
 msgstr "Errore di controllo associazione gruppo host. "
 
@@ -767,13 +703,6 @@ msgstr "Errore di controllo associazione
 msgid "Check portgroup associate error."
 msgstr "Errore di controllo associazione gruppo porte. "
 
-msgid ""
-"Check the state of the http service. Also ensure that the https port number "
-"is the same as the one specified in cinder.conf."
-msgstr ""
-"Controllare lo stato del servizio http. Assicurarsi che il numero della "
-"porta https sia uguale a quello specificato in cinder.conf."
-
 msgid "Chunk size is not multiple of block size for creating hash."
 msgstr ""
 "La dimensione della porzione non è un multiplo della dimensione del blocco "
@@ -791,12 +720,6 @@ msgstr ""
 "Il tipo di clone '%(clone_type)s' non è valido; i valori validi sono: "
 "'%(full_clone)s' e '%(linked_clone)s'."
 
-msgid ""
-"Cluster is not formatted. You should probably perform \"dog cluster format\"."
-msgstr ""
-"Il cluster non è formattato. È probabilmente necessario eseguire \"dog "
-"cluster format\"."
-
 #, python-format
 msgid "CommandLineHelper._wait_for_condition: %s timeout."
 msgstr "CommandLineHelper._wait_for_condition: %s timeout."
@@ -812,11 +735,6 @@ msgstr "Cluster di calcolo: %(cluster)s
 msgid "Condition has no field."
 msgstr "La condizione non ha campi."
 
-#, python-format
-msgid "Config 'max_over_subscription_ratio' invalid. Must be > 0: %s"
-msgstr ""
-"Configurazione 'max_over_subscription_ratio' non valida. Deve essere > 0: %s"
-
 msgid "Configuration error: dell_sc_ssn not set."
 msgstr "Errore di configurazione: dell_sc_ssn non impostato."
 
@@ -869,6 +787,10 @@ msgid "Converted to %(f1)s, but format i
 msgstr "Convertito in %(f1)s, ma il formato ora è %(f2)s"
 
 #, python-format
+msgid "Converted to %(vol_format)s, but format is now %(file_format)s"
+msgstr "Convertito in %(vol_format)s, ma il formato ora è %(file_format)s"
+
+#, python-format
 msgid "Converted to raw, but format is now %s"
 msgstr "Convertito in non elaborato, ma il formato ora è %s"
 
@@ -1252,207 +1174,6 @@ msgstr "Abilita la replica. "
 msgid "Ensure that configfs is mounted at /sys/kernel/config."
 msgstr "Verificare che configfs sia montato in /sys/kernel/config."
 
-#, python-format
-msgid ""
-"Error Cloning Snapshot: %(snapshot)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Clone project: %(clone_proj)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Errore durante la clonazione dell'istantanea: %(snapshot)s sul volume: "
-"%(lun)s del pool: %(pool)s Progetto: %(project)s Progetto clone: "
-"%(clone_proj)s Codice di ritorno: %(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Initiator: %(initiator)s on Alias: %(alias)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Errore durante la creazione dell'iniziatore: %(initiator)s sull'alias: "
-"%(alias)s Codice di ritorno: %(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Errore durante la creazione del progetto: %(project)s sul pool: %(pool)s "
-"Codice di ritorno: %(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Property: %(property)s Type: %(type)s Description: "
-"%(description)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Errore durante la creazione delle proprietà: %(property)s Tipo: %(type)s "
-"Descrizione: %(description)s Codice di ritorno: %(ret.status)d Messaggio: "
-"%(ret.data)s ."
-
-#, python-format
-msgid ""
-"Error Creating Share: %(name)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Errore durante la creazione della condivisione: %(name)s Codice di ritorno: "
-"%(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Volume: %(lun)s Size: %(size)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"Errore durante la creazione del volume: %(lun)s Dimensione: %(size)s Codice "
-"di ritorno: %(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Share: %(share)s to Pool: %(pool)s "
-"Project: %(project)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Errore durante l'eliminazione dell'istantanea: %(snapshot)s sulla "
-"condivisione: %(share)s nel pool: %(pool)s Progetto: %(project)s  Codice di "
-"ritorno: %(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Volume: %(lun)s to Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Errore durante l'eliminazione dell'istantanea: %(snapshot)s sul volume: "
-"%(lun)s nel pool: %(pool)s Progetto: %(project)s  Codice di ritorno: "
-"%(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Volume: %(lun)s from Pool: %(pool)s, Project: %(project)s. "
-"Return code: %(ret.status)d, Message: %(ret.data)s."
-msgstr ""
-"Errore durante l'eliminazione del volume: %(lun)s dal pool: %(pool)s, "
-"Progetto: %(project)s. Codice di ritorno: %(ret.status)d, Messaggio: "
-"%(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting project: %(project)s on pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Errore durante l'eliminazione del progetto: %(project)s sul pool: %(pool)s "
-"Codice di ritorno: %(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting replication action: %(id)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"Errore durante l'eliminazione dell'azione di replica: %(id)s Codice di "
-"ritorno: %(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Initiators: InitiatorGroup: %(initiatorgroup)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Errore durante l'acquisizione degli iniziatori: InitiatorGroup:"
-"%(initiatorgroup)s Codice di ritorno: %(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Pool Stats: Pool: %(pool)s Return code: %(status)d Message: "
-"%(data)s."
-msgstr ""
-"Errore durante il richiamo delle statistiche del pool: Pool: %(pool)s Codice "
-"di ritorno: %(status)d Messaggio: %(data)s."
-
-#, python-format
-msgid ""
-"Error Getting Project Stats: Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Errore durante l'acquisizione delle statistiche del progetto: Pool: %(pool)s "
-"Progetto: %(project)s Codice di ritorno: %(ret.status)d Messaggio: "
-"%(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Share: %(share)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Errore durante l'acquisizione della condivisione: %(share)s nel pool: "
-"%(pool)s Progetto: %(project)s Codice di ritorno: %(ret.status)d Messaggio: "
-"%(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Volume: %(lun)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Errore durante l'acquisizione del volume: %(lun)s nel pool: %(pool)s "
-"Progetto: %(project)s Codice di ritorno: %(ret.status)d Messaggio: "
-"%(ret.data)s."
-
-#, python-format
-msgid "Error Pool ownership: Pool %(pool)s is not owned by %(host)s."
-msgstr ""
-"Proprietà del pool degli errori: Il pool %(pool)s non è di proprietà di "
-"%(host)s."
-
-#, python-format
-msgid ""
-"Error Setting props Props: %(props)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Errore durante l'impostazione props Props: %(props)s sul volume: %(lun)s del "
-"pool: %(pool)s Progetto: %(project)s  Codice di ritorno: %(ret.status)d "
-"Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Initiator: %(iqn)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Errore durante la verifica dell'iniziatore: %(iqn)s Codice di ritorno: "
-"%(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Pool: %(pool)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Errore durante la verifica del pool: %(pool)s Codice di ritorno: "
-"%(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"errore durante la verifica del progetto: %(project)s nel pool: %(pool)s "
-"Codice di ritorno: %(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Errore durante la verifica del servizio: %(service)s Codice di ritorno: "
-"%(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Target: %(alias)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Errore durante la verifica della destinazione: %(alias)s Codice di ritorno: "
-"%(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying share: %(share)s on Project: %(project)s and Pool: %(pool)s "
-"Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Errore durante la verifica della condivisione: %(share)s sul Progetto:"
-"%(project)s e Pool: %(pool)s Codice di ritorno: %(ret.status)d Messaggio: "
-"%(ret.data)s ."
-
 msgid "Error connecting to ceph cluster."
 msgstr "Errore durante la connessione al cluster ceph."
 
@@ -1481,14 +1202,6 @@ msgstr "Errore durante l'analisi del pro
 
 #, python-format
 msgid ""
-"Error editing share: %(share)s on Pool: %(pool)s Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Errore durante la modifica della condivisione: %(share)s nel pool: %(pool)s "
-"Codice di ritorno: %(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
 "Error enabling iSER for NetworkPortal: please ensure that RDMA is supported "
 "on your iSCSI port %(port)d on ip %(ip)s."
 msgstr ""
@@ -1517,55 +1230,15 @@ msgstr "Errore durante l'estensione del
 msgid "Error finding %(name)s."
 msgstr "Errore nella ricerca di %(name)s."
 
-msgid ""
-"Error getting appliance version details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Errore nel richiamo dei dettagli della versione del dispositivo. Codice di "
-"ritorno: %(ret.status)d Messaggio: %(ret.data)s."
-
 #, python-format
 msgid "Error getting domain id from name %(name)s: %(id)s."
 msgstr "Errore nel recupero dell'id dominio dal nome %(name)s: %(id)s."
 
-msgid "Error getting initiator groups."
-msgstr "Errore durante l'acquisizione dei gruppi iniziatori."
-
 #, python-format
 msgid "Error getting pool id from name %(pool_name)s: %(err_msg)s."
 msgstr "Errore nel recupero dell'id pool dal nome %(pool_name)s: %(err_msg)s."
 
 #, python-format
-msgid ""
-"Error getting replication action: %(id)s. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Errore nel richiamo dell'azione di replica: %(id)s. Codice di ritorno: "
-"%(ret.status)d Messaggio: %(ret.data)s."
-
-msgid ""
-"Error getting replication source details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Errore nel richiamo dei dettagli dell'origine di replica. Codice di ritorno: "
-"%(ret.status)d Messaggio: %(ret.data)s."
-
-msgid ""
-"Error getting replication target details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Errore nel richiamo dei dettagli della destinazione di replica. Codice di "
-"ritorno: %(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error getting version: svc: %(svc)s.Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Errore durante l'acquisizione della versione: svc: %(svc)s.Codice di "
-"ritorno: %(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
 msgid "Error in SolidFire API response: data=%(data)s"
 msgstr "Errore nella risposta dell'API SolidFire: data=%(data)s"
 
@@ -1573,23 +1246,6 @@ msgstr "Errore nella risposta dell'API S
 msgid "Error managing volume: %s."
 msgstr "Errore durante la gestione del volume: %s. "
 
-#, python-format
-msgid ""
-"Error modifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Errore durante la modifica del servizio: %(service)s Codice di ritorno: "
-"%(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error moving volume: %(vol)s from source project: %(src)s to target project: "
-"%(tgt)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Errore durante lo spostamento del volume: %(vol)s dal progetto di origine: "
-"%(src)s al progetto di destinazione: %(tgt)s Codice di ritorno: "
-"%(ret.status)d Messaggio: %(ret.data)s ."
-
 msgid "Error not a KeyError."
 msgstr "L'errore non è un KeyError."
 
@@ -1604,38 +1260,6 @@ msgid "Error retrieving volume size"
 msgstr "Errore durante il richiamo della dimensione del volume "
 
 #, python-format
-msgid ""
-"Error sending replication update for action id: %(id)s . Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Errore durante l'invio dell'aggiornamento di replica per l'id azione: "
-"%(id)s. Codice di ritorno: %(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error sending replication update. Returned error: %(err)s. Action: %(id)s."
-msgstr ""
-"Errore durante l'invio dell'aggiornamento di replica. Errore restituito: "
-"%(err)s. Azione: %(id)s. "
-
-#, python-format
-msgid ""
-"Error setting replication inheritance to %(set)s for volume: %(vol)s project "
-"%(project)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Errore durante l'impostazione dell'eredità di di replica su %(set)s per il "
-"volume: %(vol)s progetto %(project)s Codice di ritorno: %(ret.status)d "
-"Messaggio: %(ret.data)s ."
-
-#, python-format
-msgid ""
-"Error severing the package: %(package)s from source: %(src)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Errore staccando il pacchetto: %(package)s dall'origine: %(src)s Codice di "
-"ritorno: %(ret.status)d Messaggio: %(ret.data)s."
-
-#, python-format
 msgid "Error while authenticating with switch: %s."
 msgstr "Errore durante l'autenticazione con lo switch: %s."
 
@@ -1785,14 +1409,6 @@ msgid "FC is the protocol but wwpns are
 msgstr "FC è il protocollo ma i wwpn non sono forniti da OpenStack."
 
 #, python-format
-msgid "Faield to unassign %(volume)s"
-msgstr "Impossibile annullare l'assegnazione %(volume)s"
-
-#, python-format
-msgid "Fail to create cache volume %(volume)s. Error: %(err)s"
-msgstr "Impossibile creare il volume cache %(volume)s. Errore: %(err)s"
-
-#, python-format
 msgid "Failed adding connection for fabric=%(fabric)s: Error: %(err)s"
 msgstr ""
 "Impossibile aggiungere la connessione per fabric=%(fabric)s: Errore:%(err)s"
@@ -1865,11 +1481,6 @@ msgid "Failed to connect to Dell REST AP
 msgstr "Impossibile collegarsi all'API Dell REST"
 
 #, python-format
-msgid "Failed to connect to sheep daemon. addr: %(addr)s, port: %(port)s"
-msgstr ""
-"Impossibile connettersi al daemon sheep, indirizzo: %(addr)s, porta: %(port)s"
-
-#, python-format
 msgid "Failed to copy image to volume: %(reason)s"
 msgstr "Impossibile copiare l'immagine nel volume: %(reason)s"
 
@@ -1897,20 +1508,6 @@ msgid "Failed to create api volume flow.
 msgstr "Impossibile creare il flusso del volume api."
 
 #, python-format
-msgid "Failed to create cg snapshot %(id)s due to %(reason)s."
-msgstr ""
-"Impossibile creare l'istantanea del gruppo di coerenza %(id)s a causa di "
-"%(reason)s."
-
-#, python-format
-msgid "Failed to create consistency group %(id)s due to %(reason)s."
-msgstr "Impossibile creare il gruppo di coerenza %(id)s a causa di %(reason)s."
-
-#, python-format
-msgid "Failed to create consistency group %(id)s:%(ret)s."
-msgstr "Impossibile creare il gruppo di coerenza %(id)s:%(ret)s."
-
-#, python-format
 msgid "Failed to create consistency group: %(cgid)s. Error: %(excmsg)s."
 msgstr ""
 "Impossibile creare il gruppo di coerenza: %(cgid)s. Errore: %(excmsg)s."
@@ -1981,17 +1578,6 @@ msgid "Failed to create volume %s"
 msgstr "Impossibile creare il volume %s"
 
 #, python-format
-msgid "Failed to delete cgsnapshot %(id)s due to %(reason)s."
-msgstr ""
-"Impossibile eliminare l'istantanea del gruppo di coerenza %(id)s a causa di "
-"%(reason)s."
-
-#, python-format
-msgid "Failed to delete consistency group %(id)s due to %(reason)s."
-msgstr ""
-"Impossibile eliminare il gruppo di coerenza %(id)s a causa di %(reason)s."
-
-#, python-format
 msgid ""
 "Failed to delete fileset for consistency group %(cgname)s. Error: %(excmsg)s."
 msgstr ""
@@ -2069,11 +1655,6 @@ msgid "Failed to find host %s."
 msgstr "Impossibile trovare l'host %s."
 
 #, python-format
-msgid "Failed to find iSCSI initiator group containing %(initiator)s."
-msgstr ""
-"Impossibile trovare il gruppo di iniziatori iSCSI contenente %(initiator)s."
-
-#, python-format
 msgid "Failed to get LUN target details for the LUN %s"
 msgstr "Impossibile ottenere i dettagli della destinazione LUN per LUN %s"
 
@@ -2185,14 +1766,6 @@ msgstr "Impossibile accedere a %s Array
 msgid "Failed to login with all rest URLs."
 msgstr "Impossibile accedere con tutti gli URL rest. "
 
-#, python-format
-msgid ""
-"Failed to make a request to Datera cluster endpoint due to the following "
-"reason: %s"
-msgstr ""
-"Impossibile effettuare la richiesta all'endpoint del cluster Datera a causa "
-"del seguente motivo: %s"
-
 msgid "Failed to manage api volume flow."
 msgstr "Impossibile gestire il flusso del volume api."
 
@@ -2401,32 +1974,6 @@ msgid "Failure staging LUN %s to tmp."
 msgstr "Errore di trasferimento della LUN %s in tmp."
 
 #, python-format
-msgid "Fexvisor failed to add volume %(id)s due to %(reason)s."
-msgstr ""
-"Fexvisor non è riuscito ad aggiungere il volume %(id)s a causa di %(reason)s."
-
-#, python-format
-msgid ""
-"Fexvisor failed to join the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr ""
-"Fexvisor non è riuscito ad unirsi al volume %(vol)s nel gruppo %(group)s a "
-"causa di %(ret)s."
-
-#, python-format
-msgid ""
-"Fexvisor failed to remove the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr ""
-"Fexvisor non è riuscito a rimuovere il volume %(vol)s nel gruppo %(group)s a "
-"causa di %(ret)s."
-
-#, python-format
-msgid "Fexvisor failed to remove volume %(id)s due to %(reason)s."
-msgstr ""
-"Fexvisor non è riuscito a rimuovere il volume %(id)s a causa di %(reason)s."
-
-#, python-format
 msgid "Fibre Channel SAN Lookup failure: %(reason)s"
 msgstr "Errore di controllo SAN di Fibre Channel: %(reason)s"
 
@@ -2443,10 +1990,6 @@ msgid "File %(file_path)s could not be f
 msgstr "Impossibile trovare il file %(file_path)s."
 
 #, python-format
-msgid "File already exists at %s."
-msgstr "Il file già esiste in %s."
-
-#, python-format
 msgid "File already exists at: %s"
 msgstr "Il file già esiste in: %s"
 
@@ -2477,198 +2020,6 @@ msgstr ""
 "è installata la versione '%(version)s'."
 
 #, python-format
-msgid "Flexvisor assign volume failed.:%(id)s:%(status)s."
-msgstr "Flexvisor assegnazione volume non riuscita: %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor assign volume failed:%(id)s:%(status)s."
-msgstr "Flexvisor errore di assegnazione volume:%(id)s:%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor could not find volume %(id)s snapshot in the group %(vgid)s "
-"snapshot %(vgsid)s."
-msgstr ""
-"Flexvisor non è riuscito a trovare l'istantanea del volume %(id)s nel gruppo "
-"%(vgid)s istantanea %(vgsid)s."
-
-#, python-format
-msgid "Flexvisor create volume failed.:%(volumeid)s:%(status)s."
-msgstr "Flexvisor non è riuscito a creare il volume.:%(volumeid)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor failed deleting volume %(id)s: %(status)s."
-msgstr "Flexvisor non è riuscito ad eliminare il volume %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to add volume %(id)s to group %(cgid)s."
-msgstr ""
-"Flexvisor non è riuscito ad aggiungere il volume %(id)s al gruppo %(cgid)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to assign volume %(id)s due to unable to query status by "
-"event id."
-msgstr ""
-"Flexvisor non è riuscito ad assegnare il volume %(id)s perché non riesce ad "
-"eseguire la query dello stato utilizzando l'id evento."
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(id)s: %(status)s."
-msgstr "Flexvisor non è riuscito ad assegnare il volume %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(volume)s iqn %(iqn)s."
-msgstr ""
-"Flexvisor non è riuscito ad assegnare il volume %(volume)s iqn %(iqn)s."
-
-#, python-format
-msgid "Flexvisor failed to clone volume %(id)s: %(status)s."
-msgstr "Flexvisor non è riuscito a clonare il volume %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to clone volume (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor non è riuscito a clonare il volume (evento get non riuscito) "
-"%(id)s."
-
-#, python-format
-msgid "Flexvisor failed to create snapshot for volume %(id)s: %(status)s."
-msgstr ""
-"Flexvisor non è riuscito a creare l'istantanea per il volume %(id)s: "
-"%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to create snapshot for volume (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor non è riuscito a creare l'istantanea per il (evento get non "
-"riuscito) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume %(id)s in the group %(vgid)s."
-msgstr ""
-"Flexvisor non è riuscito a creare il volume %(id)s nel gruppo %(vgid)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume %(volume)s: %(status)s."
-msgstr "Flexvisor non è riuscito a creare il volume %(volume)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume (get event) %s."
-msgstr "Flexvisor non è riuscito a creare il volume (evento get) %s."
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s: %(status)s."
-msgstr ""
-"Flexvisor non è riuscito a creare il volume da un'istantanea %(id)s: "
-"%(status)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s:%(status)s."
-msgstr ""
-"Flexvisor non è riuscito a creare il volume da un'istantanea %(id)s: "
-"%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to create volume from snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor non è riuscito a creare il volume da un'istantanea (evento get non "
-"riuscito) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot %(id)s: %(status)s."
-msgstr "Flexvisor non è riuscito ad eliminare l'istantanea %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor non è riuscito ad eliminare l'istantanea  (evento get non "
-"riuscito) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to delete volume %(id)s: %(status)s."
-msgstr "Flexvisor non è riuscito ad eliminare il volume %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s: %(status)s."
-msgstr "Flexvisor non è riuscito ad estendere il volume %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s:%(status)s."
-msgstr "Flexvisor non è riuscito ad estendere il volume %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor non è riuscito ad estendere il volume (evento get non riuscito) "
-"%(id)s."
-
-#, python-format
-msgid "Flexvisor failed to get pool info %(id)s: %(status)s."
-msgstr ""
-"Flexvisor non è riuscito ad acquisire le informazioni sul pool %(id)s: "
-"%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to get snapshot id of volume %(id)s from group %(vgid)s."
-msgstr ""
-"Flexvisor non è riuscito ad ottenere l'ID istantanea del volume %(id)s dal "
-"gruppo %(vgid)s."
-
-#, python-format
-msgid "Flexvisor failed to remove volume %(id)s from group %(cgid)s."
-msgstr ""
-"Flexvisor non è riuscito a rimuovere il volume %(id)s dal gruppo %(cgid)s."
-
-#, python-format
-msgid "Flexvisor failed to spawn volume from snapshot %(id)s:%(status)s."
-msgstr ""
-"Flexvisor non è riuscito a generare il volume da un'istantanea %(id)s:"
-"%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to spawn volume from snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor non è riuscito a generare il volume da un'istantanea (evento get "
-"non riuscito) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume %(id)s: %(status)s."
-msgstr ""
-"Flexvisor non è riuscito ad annullare l'assegnazione del volume %(id)s: "
-"%(status)s."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume (get event) %(id)s."
-msgstr ""
-"Flexvisor non è riuscito ad annullare l'assegnazione del volume (evento get) "
-"%(id)s."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume:%(id)s:%(status)s."
-msgstr ""
-"Flexvisor non è riuscito ad annullare l'assegnazione del volume: %(id)s: "
-"%(status)s."
-
-#, python-format
-msgid "Flexvisor unable to find the source volume %(id)s info."
-msgstr "Flexvisor è riuscito a trovare l'origine del volume %(id)s."
-
-#, python-format
-msgid "Flexvisor unassign volume failed:%(id)s:%(status)s."
-msgstr ""
-"Flexvisor errore annullando l'assegnazione del volume:%(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor volume %(id)s failed to join group %(vgid)s."
-msgstr ""
-"Il volume Flexvisor %(id)s non è riuscito ad unirsi al gruppo %(vgid)s."
-
-#, python-format
 msgid "Folder %s does not exist in Nexenta Store appliance"
 msgstr "La cartella %s non esiste nell'applicazione Nexenta Store"
 
@@ -2994,14 +2345,6 @@ msgid "Invalid Replication Target: %(rea
 msgstr "Destinazione di replica non valida: %(reason)s"
 
 #, python-format
-msgid ""
-"Invalid Virtuozzo Storage share specification: %r. Must be: [MDS1[,"
-"MDS2],...:/]<CLUSTER NAME>[:PASSWORD]."
-msgstr ""
-"Specifica di condivisione Virtuozzo Storage non valida: %r. Deve essere: "
-"[MDS1[,MDS2],...:/]<CLUSTER NAME>[:PASSWORD]."
-
-#, python-format
 msgid "Invalid XtremIO version %(cur)s, version %(min)s or up is required"
 msgstr ""
 "Versione XtremIO non valida %(cur)s, è richiesta la versione %(min)s o "
@@ -3012,13 +2355,6 @@ msgid "Invalid allocated quotas defined
 msgstr ""
 "Quote allocate non valide definite per le seguenti quote del progetto: %s"
 
-msgid "Invalid argument - negative seek offset."
-msgstr "Argomento non valido - offset di ricerca negativo."
-
-#, python-format
-msgid "Invalid argument - whence=%s not supported."
-msgstr "Argomento non valido - whence=%s non supportato."
-
 #, python-format
 msgid "Invalid attaching mode '%(mode)s' for volume %(volume_id)s."
 msgstr ""
@@ -3033,18 +2369,6 @@ msgid "Invalid backup: %(reason)s"
 msgstr "Backup non valido: %(reason)s"
 
 #, python-format
-msgid "Invalid connection initialization response of volume %(name)s"
-msgstr ""
-"Risposta di inizializzazione di connessione del volume non valida %(name)s"
-
-#, python-format
-msgid ""
-"Invalid connection initialization response of volume %(name)s: %(output)s"
-msgstr ""
-"Risposta di inizializzazione di connessione del volume non valida %(name)s: "
-"%(output)s"
-
-#, python-format
 msgid "Invalid content type %(content_type)s."
 msgstr "Tipo di contenuto non valido%(content_type)s."
 
@@ -3132,10 +2456,6 @@ msgid "Invalid mount point base: %s"
 msgstr "Base del punto di montaggio non valida: %s"
 
 #, python-format
-msgid "Invalid mount point base: %s."
-msgstr "Base del punto di montaggio non valida: %s"
-
-#, python-format
 msgid "Invalid new snapCPG name for retype.  new_snap_cpg='%s'."
 msgstr "Nuovo nome snapCPG non valido per la riscrittura  new_snap_cpg='%s'."
 
@@ -3154,9 +2474,6 @@ msgstr "L'id secondario %s  e' invalido.
 msgid "Invalid service catalog json."
 msgstr "json del catalogo del servizio non è valido."
 
-msgid "Invalid sheepdog cluster status."
-msgstr "Stato del cluster sheepdog non valido. "
-
 #, python-format
 msgid "Invalid snapshot: %(reason)s"
 msgstr "Istantanea non valida: %(reason)s"
@@ -3242,10 +2559,6 @@ msgstr ""
 "volume_type fornito non valido: %s (il tipo richiesto deve essere supportato "
 "da questo gruppo di coerenza)."
 
-#, python-format
-msgid "Invalid wwpns format %(wwpns)s"
-msgstr "Formato wwpn non valido %(wwpns)s"
-
 msgid "Issue encountered waiting for job."
 msgstr "Si è verificato un problema in attesa del job."
 
@@ -3258,10 +2571,6 @@ msgstr ""
 "Esecuzione del failover non riuscita perché la replica non è configurata "
 "correttamente."
 
-#, python-format
-msgid "KeyError: %s"
-msgstr "KeyError: %s"
-
 msgid "Keystone version 3 or greater must be used to get nested quota support."
 msgstr ""
 "Keystone versione 3 o successiva deve essere utilizzato per ottenere il "
@@ -3566,9 +2875,6 @@ msgstr ""
 msgid "New volume type not specified in request_spec."
 msgstr "Nuovo tipo di volume non specificato in request_spec."
 
-msgid "Nimble Cinder Driver exception"
-msgstr "Eccezione driver Nimble Cinder"
-
 msgid "No FC initiator can be added to host."
 msgstr "Nessun iniziatore FC può essere aggiunto all'host."
 
@@ -3606,10 +2912,6 @@ msgid "No initiator connected to fabric.
 msgstr "Nessun iniziatore collegato a fabric."
 
 #, python-format
-msgid "No initiator group found for initiator %s"
-msgstr "Nessun gruppo iniziatore trovato per l'iniziatore %s"
-
-#, python-format
 msgid "No interface found on cluster for ip %s"
 msgstr "Nessuna interfaccia trovata nel cluster per l'ip %s"
 
@@ -3622,9 +2924,6 @@ msgstr "Non è stata trovata nessuna con
 msgid "No mounted SMBFS shares found."
 msgstr "Non è stata trovata nessuna condivisione SMBFS montata."
 
-msgid "No mounted Virtuozzo Storage shares found"
-msgstr "Non è stata trovata alcuna condivisione Virtuozzo Storage montata"
-
 msgid "No mounted shares found"
 msgstr "Non è stata trovata nessuna condivisione montata"
 
@@ -3648,9 +2947,6 @@ msgstr "Nessuna istantanea (snap) trovat
 msgid "No such QoS spec %(specs_id)s."
 msgstr "Non esiste alcuna specifica QoS %(specs_id)s."
 
-msgid "No suitable discovery ip found"
-msgstr "Non è stato trovato nessun IP di rilevamento adatto"
-
 #, python-format
 msgid "No support to restore backup version %s"
 msgstr "Nessun supporto per il ripristino della versione di backup %s"
@@ -3687,11 +2983,6 @@ msgstr "Non autorizzato."
 msgid "Not enough space on backend (%(backend)s)"
 msgstr "Spazio insufficiente sul backend (%(backend)s)"
 
-msgid "Not enough storage space in the ZFS share to perform this operation."
-msgstr ""
-"Spazio di archiviazione insufficiente nella condivisione ZFS per eseguire "
-"questa operazione."
-
 msgid "Not stored in rbd"
 msgstr "Non memorizzato in rbd"
 
@@ -3726,10 +3017,6 @@ msgstr ""
 "Solo agli utenti con token nell'ambito dei parent immediati o progetti root "
 "è consentito visualizzare le quote child."
 
-msgid "Only volumes managed by OpenStack can be unmanaged."
-msgstr ""
-"È possibile annullare la gestione solo dei volumi gestiti da OpenStack."
-
 #, python-format
 msgid "Operation failed with status=%(status)s. Full dump: %(data)s"
 msgstr "Operazione non riuscita con status=%(status)s. Dump completo: %(data)s"
@@ -3773,9 +3060,6 @@ msgstr "La politica non consente di eseg
 msgid "Pool is not available in the volume host field."
 msgstr "Il pool non è disponibile nel campo dell'host del volume."
 
-msgid "Pool is not available in the volume host fields."
-msgstr "Il pool non è disponibile nei campi dell'host del volume."
-
 #, python-format
 msgid "Pool with name %(pool_name)s wasn't found in domain %(domain_id)s."
 msgstr ""
@@ -3920,13 +3204,6 @@ msgstr "Il riferimento deve contenere il
 msgid "Reference must contain source-name."
 msgstr "Il riferimento deve contenere source-name."
 
-msgid "Reference to volume to be managed must contain source-name."
-msgstr "Il riferimento al volume da gestire deve contenere source-name."
-
-#, python-format
-msgid "Reference to volume: %s to be managed must contain source-name."
-msgstr "Il riferimento al volume: %s da gestire deve contenere source-name."
-
 #, python-format
 msgid ""
 "Refusing to migrate volume ID: %(id)s. Please check your configuration "
@@ -3988,12 +3265,6 @@ msgid "Request body contains too many it
 msgstr "Il corpo della richiesta contiene troppi elementi"
 
 #, python-format
-msgid "Request to Datera cluster returned bad status: %(status)s | %(reason)s"
-msgstr ""
-"La richiesta a Datera ha restituito uno stato non corretto: %(status)s | "
-"%(reason)s"
-
-#, python-format
 msgid ""
 "Requested backup exceeds allowed Backup gigabytes quota. Requested "
 "%(requested)sG, quota is %(quota)sG and %(consumed)sG has been consumed."
@@ -4111,11 +3382,6 @@ msgid "SMBFS config file not set (smbfs_
 msgstr "Il file di configurazione SMBFS non è impostato (smbfs_shares_config)."
 
 #, python-format
-msgid "SSH Command failed after '%(total_attempts)r' attempts : '%(command)s'"
-msgstr ""
-"Comando SSH non riuscito dopo '%(total_attempts)r' tentativi: '%(command)s'"
-
-#, python-format
 msgid "SSH command injection detected: %(command)s"
 msgstr "Rilevato inserimento comando SSH: %(command)s"
 
@@ -4159,10 +3425,6 @@ msgstr "Errore di impostazione dell'acce
 msgid "Sets thin provisioning."
 msgstr "Imposta il thin provisioning."
 
-#, python-format
-msgid "Sheepdog I/O Error, command was: \"%s\"."
-msgstr "Errore I/O Sheepdog, il comando era: \"%s\". "
-
 msgid ""
 "Show operations can only be made to projects in the same hierarchy of the "
 "project in which users are scoped to."
@@ -4355,15 +3617,6 @@ msgstr ""
 "Il filesystem %(fs)s GPFS non è del livello di release richiesto.  Il "
 "livello corrente è %(cur)s, deve essere almeno %(min)s."
 
-#, python-format
-msgid ""
-"The WebDAV request failed. Reason: %(msg)s, Return code/reason: %(code)s, "
-"Source Volume: %(src)s, Destination Volume: %(dst)s, Method: %(method)s."
-msgstr ""
-"La richiesta WebDAV non è riuscita. Motivo: %(msg)s, Codice di ritorno/"
-"motivo:%(code)s, Volume di origine: %(src)s, Volume di destinazione:%(dst)s, "
-"Metodo:%(method)s."
-
 msgid ""
 "The above error may show that the database has not been created.\n"
 "Please create a database using 'cinder-manage db sync' before running this "
@@ -4447,9 +3700,6 @@ msgstr ""
 "L'istantanea non può essere creata quando il volume è in modalità di "
 "manutenzione. "
 
-msgid "The source volume for this WebDAV operation not found."
-msgstr "Volume di origine per questa operazione WebDAV non trovato."
-
 #, python-format
 msgid ""
 "The source volume type '%(src)s' is different than the destination volume "
@@ -4661,10 +3911,6 @@ msgid "Type cannot be converted into NaE
 msgstr "Il tipo non può essere convertito in NaElement."
 
 #, python-format
-msgid "TypeError: %s"
-msgstr "TypeError: %s"
-
-#, python-format
 msgid "UUIDs %s are in both add and remove volume list."
 msgstr ""
 "Gli UUID %s sono presenti nell'elenco dei volumi di aggiunta e rimozione."
@@ -4921,9 +4167,6 @@ msgstr ""
 msgid "Unexpected output. Expected [%(expected)s] but received [%(output)s]"
 msgstr "Output imprevisto. Previsto [%(expected)s] ma ricevuto [%(output)s]"
 
-msgid "Unexpected response from Nimble API"
-msgstr "Risposta imprevista dall'API Nimble"
-
 msgid "Unexpected status code"
 msgstr "Codice di stato imprevisto"
 
@@ -4944,41 +4187,10 @@ msgstr "Eccezione RemoteFS sconosciuta"
 msgid "Unknown SMBFS exception."
 msgstr "Eccezione SMBFS sconosciuta."
 
-msgid "Unknown Virtuozzo Storage exception"
-msgstr "Eccezione Virtuozzo Storage sconosciuta "
-
 msgid "Unknown action"
 msgstr "Azione sconosciuta"
 
 #, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, Set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"Si ignora se il volume: %s da gestire è già gestito da Cinder. Interruzione "
-"della gestione del volume. Aggiungere la proprietà dello schema "
-"personalizzato 'cinder_managed' al volume e impostare il relativo valore su "
-"False. In alternativa, impostare il valore della politica di configurazione "
-"di cinder 'zfssa_manage_policy' su 'loose' per rimuovere questa restrizione."
-
-#, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"Si ignora se il volume: %s da gestire è già gestito da Cinder. Interruzione "
-"della gestione del volume. Aggiungere la proprietà dello schema "
-"personalizzato 'cinder_managed' al volume e impostare il relativo valore su "
-"False. In alternativa, impostare il valore della politica di configurazione "
-"di cinder 'zfssa_manage_policy' su 'loose' per rimuovere questa restrizione."
-
-#, python-format
 msgid "Unknown or unsupported command %(cmd)s"
 msgstr "Comando %(cmd)s sconosciuto o non supportato"
 
@@ -5088,9 +4300,6 @@ msgstr "Identificativo Utente"
 msgid "User does not have admin privileges"
 msgstr "L'utente non ha i privilegi dell'amministratore"
 
-msgid "User not authorized to perform WebDAV operations."
-msgstr "L'utente non è autorizzato ad eseguire le operazioni WebDAV."
-
 msgid "UserName is not configured."
 msgstr "UserName non configurato."
 
@@ -5120,10 +4329,6 @@ msgstr ""
 "\"%(option)s\""
 
 #, python-format
-msgid "ValueError: %s"
-msgstr "ValueError: %s"
-
-#, python-format
 msgid "Vdisk %(name)s not involved in mapping %(src)s -> %(tgt)s."
 msgstr "Vdisk %(name)s non coinvolto nell'associazione %(src)s -> %(tgt)s."
 
@@ -5221,25 +4426,10 @@ msgid "Volume %s does not exist on the a
 msgstr "Il volume %s non esiste su questo array. "
 
 #, python-format
-msgid "Volume %s does not have provider_location specified, skipping."
-msgstr "Sul volume %s non è specificato provider_location; ignorato."
-
-#, python-format
 msgid "Volume %s doesn't exist on array."
 msgstr "Il volume %s non esiste nell'array."
 
 #, python-format
-msgid "Volume %s doesn't exist on the ZFSSA backend."
-msgstr "Il volume %s non esiste nel backend ZFSSA."
-
-#, python-format
-msgid ""
-"Volume %s is online. Set volume to offline for managing using OpenStack."
-msgstr ""
-"Il volume %s è online. Impostare il volume su offline per la gestione "
-"tramite OpenStack."
-
-#, python-format
 msgid "Volume %s must not be part of a consistency group."
 msgstr "Il volume %s non deve fare parte di un gruppo di coerenza."
 
@@ -5383,9 +4573,6 @@ msgstr "Il volume non è stato ancora as
 msgid "Volume replication for %(volume_id)s could not be found."
 msgstr "Impossibile trovare la replica del volume per %(volume_id)s."
 
-msgid "Volume should have agent-type set as None."
-msgstr "Il volume deve avere agent-type impostato su Nessuno. "
-
 #, python-format
 msgid ""
 "Volume size %(volume_size)sGB cannot be smaller than the image minDisk size "
@@ -5429,9 +4616,6 @@ msgstr "La dimensione del volume deve es
 msgid "Volume size must multiple of 1 GB."
 msgstr "La dimensione del volume deve essere un multiplo di 1 GB. "
 
-msgid "Volume status must be 'available'."
-msgstr "Lo stato del volume deve essere 'available'."
-
 msgid "Volume to Initiator Group mapping already exists"
 msgstr "L'associazione del volume al gruppo iniziatori già esiste"
 
@@ -5486,35 +4670,14 @@ msgid "Volume type with name %(volume_ty
 msgstr ""
 "Impossibile trovare il tipo di volume con il nome %(volume_type_name)s."
 
-#, python-format
-msgid "Volume: %s is already being managed by Cinder."
-msgstr "Il volume: %s è già in fase di importazione da Cinder."
-
 msgid ""
 "Volumes/account exceeded on both primary and secondary SolidFire accounts."
 msgstr "Volumi/account superati sugli account SolidFire primario e secondario."
 
 #, python-format
-msgid ""
-"VzStorage config 'vzstorage_used_ratio' invalid. Must be > 0 and <= 1.0: %s."
-msgstr ""
-"Config VzStorage 'vzstorage_used_ratio' non valida, deve essere > 0 e <= "
-"1.0: %s."
-
-#, python-format
-msgid "VzStorage config file at %(config)s doesn't exist."
-msgstr "File config VzStorage in %(config)s non esiste."
-
-#, python-format
 msgid "Wait synchronize failed. Running status: %s."
 msgstr "Sincronizzazione attesa non riuscita. Stato esecuzione: %s."
 
-msgid ""
-"Waiting for all nodes to join cluster. Ensure all sheep daemons are running."
-msgstr ""
-"In attesa che tutti i nodi partecipino al cluster. Verificare che tutti i "
-"daemon sheep siano in esecuzione. "
-
 msgid "We should not do switch over on primary array."
 msgstr "Non è consigliabile passare all'array primario."
 
@@ -6249,9 +5412,6 @@ msgstr "extend_volume, volumename: %(vol
 msgid "fake"
 msgstr "fake"
 
-msgid "fileno is not supported by SheepdogIOWrapper"
-msgstr "fileno non è supportato da SheepdogIOWrapper "
-
 #, python-format
 msgid "fmt=%(fmt)s backed by: %(backing_file)s"
 msgstr "fmt=%(fmt)s sottoposto a backup da: %(backing_file)s"
@@ -6300,13 +5460,6 @@ msgstr ""
 "gpfs_images_share_mode è impostato su copy_on_write, ma %(vol)s e %(img)s "
 "appartengono a fileset differenti."
 
-msgid ""
-"http service may have been abruptly disabled or put to maintenance state in "
-"the middle of this operation."
-msgstr ""
-"Il servizio http potrebbe essere stato bruscamente disabilitato o inserito "
-"in stato di manutenzione durante questa operazione."
-
 msgid "id cannot be None"
 msgstr "l'id non può essere None"
 
@@ -6597,11 +5750,3 @@ msgstr "volumi assegnati"
 
 msgid "volumes changed"
 msgstr "volumi modificati"
-
-#, python-format
-msgid ""
-"zfssa_manage_policy property needs to be set to 'strict' or 'loose'. Current "
-"value is: %s."
-msgstr ""
-"La proprietà zfssa_manage_policy deve essere impostata su 'strict' o "
-"'loose'. Il valore corrente è : %s."
diff -pruN 2:15.0.1-1/cinder/locale/ja/LC_MESSAGES/cinder.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/ja/LC_MESSAGES/cinder.po
--- 2:15.0.1-1/cinder/locale/ja/LC_MESSAGES/cinder.po	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/ja/LC_MESSAGES/cinder.po	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: cinder VERSION\n"
 "Report-Msgid-Bugs-To: https://bugs.launchpad.net/openstack-i18n/\n"
-"POT-Creation-Date: 2019-10-04 05:27+0000\n"
+"POT-Creation-Date: 2020-03-18 14:40+0000\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
@@ -125,12 +125,6 @@ msgstr ""
 "プがサポートされています。実際のモードは %(vol_mode)s です。"
 
 #, python-format
-msgid "%(service)s Service is not %(status)s on storage appliance: %(host)s"
-msgstr ""
-"%(service)s サービスはストレージアプライアンス %(host)s で %(status)s になっ"
-"ていません"
-
-#, python-format
 msgid ""
 "%(type)s with id %(id)s is already being cleaned up or another host has "
 "taken over it."
@@ -194,10 +188,6 @@ msgid "%s is not installed"
 msgstr "%s がインストールされていません。"
 
 #, python-format
-msgid "%s is not installed."
-msgstr "%s がインストールされていません。"
-
-#, python-format
 msgid "%s is not set"
 msgstr "%s が設定されていません"
 
@@ -220,10 +210,6 @@ msgid "%s must be an absolute path."
 msgstr "%s は絶対パスである必要があります。"
 
 #, python-format
-msgid "%s not set in cinder.conf"
-msgstr "%s が cinder.conf に設定されていません"
-
-#, python-format
 msgid "%s not set."
 msgstr "%s が設定されていません。"
 
@@ -251,14 +237,6 @@ msgstr "'qemu-img info' の解析に失
 msgid "'success' not found"
 msgstr "'success' が見つかりません。"
 
-#, python-format
-msgid ""
-"(Command: %(cmd)s) (Return Code: %(exit_code)s) (Stdout: %(stdout)s) "
-"(Stderr: %(stderr)s)"
-msgstr ""
-"(Command: %(cmd)s) (Return Code: %(exit_code)s) (Stdout: %(stdout)s) "
-"(Stderr: %(stderr)s)"
-
 msgid "400 Bad Request"
 msgstr "413 Request entity too large"
 
@@ -358,10 +336,6 @@ msgid "An error has occurred during back
 msgstr "バックアップ操作中にエラーが発生しました。"
 
 #, python-format
-msgid "An error has occurred in SheepdogDriver. (Reason: %(reason)s)"
-msgstr "SheepdogDriver でエラーが発生しました。(理由: %(reason)s)"
-
-#, python-format
 msgid ""
 "An error occurred during the LUNcopy operation. LUNcopy name: "
 "%(luncopyname)s. LUNcopy status: %(luncopystatus)s. LUNcopy state: "
@@ -374,18 +348,6 @@ msgstr ""
 msgid "An error occurred while attempting to modify Snapshot '%s'."
 msgstr "スナップショット '%s' を変更しようとした際にエラーが発生しました。"
 
-#, python-format
-msgid "An error occurred while reading volume \"%s\"."
-msgstr "ボリューム \"%s\" の読み取り中にエラーが発生しました。"
-
-#, python-format
-msgid "An error occurred while seeking for volume \"%s\"."
-msgstr "ボリューム \"%s\" のシーク中にエラーが発生しました。"
-
-#, python-format
-msgid "An error occurred while writing to volume \"%s\"."
-msgstr "ボリューム \"%s\" への書き込み中にエラーが発生しました。"
-
 msgid "An unknown error occurred."
 msgstr "不明なエラーが発生しました。"
 
@@ -470,11 +432,6 @@ msgstr "使用可能カテゴリー:"
 msgid "Backend doesn't exist (%(backend)s)"
 msgstr "バックエンドが存在しません(%(backend)s)"
 
-msgid "Backend storage did not configure fiber channel target."
-msgstr ""
-"バックエンドストレージによってファイバーチャネルターゲットは設定されませんで"
-"した。"
-
 msgid "Backing up an in-use volume must use the force flag."
 msgstr ""
 "使用中のボリュームのバックアップを行う際は、force フラグを使用する必要があり"
@@ -591,10 +548,6 @@ msgstr ""
 msgid "CPG (%s) doesn't exist on array"
 msgstr "CPG (%s) がアレイ上に存在しません"
 
-#, python-format
-msgid "Cache volume %s does not have required properties"
-msgstr "キャッシュボリューム %s に必須のプロパティーがありません"
-
 msgid "Can not add FC port to host."
 msgstr "ホストに FC ポートを追加できません。"
 
@@ -808,10 +761,6 @@ msgstr ""
 "VF コンテキストを変更できません。指定された VF は管理可能な VF リスト "
 "%(vf_list)s で使用可能ではありません。"
 
-#, python-format
-msgid "Cannot create directory %s."
-msgstr "ディレクトリー %s を作成できません。"
-
 msgid "Cannot create encryption specs. Volume type in use."
 msgstr "暗号化仕様を作成できません。ボリュームタイプは使用中です。"
 
@@ -854,24 +803,6 @@ msgstr ""
 "名前 %(name)s および仕様 %(extra_specs)s を使用して volume_type を作成できま"
 "せん。"
 
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)d volume instances."
-msgstr ""
-"キャッシュボリューム: %(cachevol_name)s を削除できません。%(updated_at)s に更"
-"新されたこのキャッシュボリュームには現在 %(numclones)d のボリュームインスタン"
-"スがあります。"
-
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)s volume instances."
-msgstr ""
-"キャッシュボリューム: %(cachevol_name)s を削除できません。%(updated_at)s に更"
-"新されたこのキャッシュボリュームには 現在 %(numclones)s のボリュームインスタ"
-"ンスがあります。"
-
 msgid "Cannot delete encryption specs. Volume type in use."
 msgstr "暗号化仕様を削除できません。ボリュームタイプは使用中です。"
 
@@ -972,10 +903,6 @@ msgid ""
 "Change would make usage less than 0 for the following resources: %(unders)s"
 msgstr "変更によって、次のリソースの使用量が 0 未満になります: %(unders)s"
 
-msgid "Check access permissions for the ZFS share assigned to this driver."
-msgstr ""
-"このドライバーに割り当てられている ZFS 共有のアクセス権を確認してください。"
-
 msgid "Check hostgroup associate error."
 msgstr "ホストグループ関連付けの確認のエラー。"
 
@@ -991,13 +918,6 @@ msgstr "LUN グループ関連付けの
 msgid "Check portgroup associate error."
 msgstr "ポートグループ関連付けの確認のエラー。"
 
-msgid ""
-"Check the state of the http service. Also ensure that the https port number "
-"is the same as the one specified in cinder.conf."
-msgstr ""
-"HTTP サービスの状態を確認してください。また、HTTPS ポート番号が cinder.conf "
-"に指定されている番号と同じであることも確認してください。"
-
 msgid "Chunk size is not multiple of block size for creating hash."
 msgstr ""
 "チャンクサイズが、ハッシュを作成するためのブロックサイズの倍数ではありませ"
@@ -1034,12 +954,6 @@ msgstr "クラスター %(name)s は既
 msgid "Cluster %s successfully removed."
 msgstr "クラスター %s は正常に削除されました。"
 
-msgid ""
-"Cluster is not formatted. You should probably perform \"dog cluster format\"."
-msgstr ""
-"クラスターの形式が正しく設定されていません。ドッグクラスター形式を実行する必"
-"要があるかもしれません。"
-
 #, python-format
 msgid "CommandLineHelper._wait_for_condition: %s timeout."
 msgstr "CommandLineHelper._wait_for_condition: %s タイムアウト。"
@@ -1056,12 +970,6 @@ msgstr "コンピュートクラスタ
 msgid "Condition has no field."
 msgstr "条件にフィールドがありません。"
 
-#, python-format
-msgid "Config 'max_over_subscription_ratio' invalid. Must be > 0: %s"
-msgstr ""
-"設定 'max_over_subscription_ratio' は無効です。0 より大きくなければなりませ"
-"ん: %s"
-
 msgid "Configuration error: dell_sc_ssn not set."
 msgstr "設定エラー: dell_sc_ssn not が設定されていません。"
 
@@ -1113,6 +1021,10 @@ msgid "Converted to %(f1)s, but format i
 msgstr "%(f1)s に変換されましたが、現在の形式は %(f2)s です"
 
 #, python-format
+msgid "Converted to %(vol_format)s, but format is now %(file_format)s"
+msgstr "%(vol_format)s に変換されましたが、現在の形式は %(file_format)s です"
+
+#, python-format
 msgid "Converted to raw, but format is now %s"
 msgstr "ローに変換されましたが、現在の形式は %s です"
 
@@ -1548,202 +1460,6 @@ msgid "Ensure that configfs is mounted a
 msgstr ""
 "configfs が /sys/kernel/config でマウントされていることを確認してください。"
 
-#, python-format
-msgid ""
-"Error Cloning Snapshot: %(snapshot)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Clone project: %(clone_proj)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"プール: %(pool)s プロジェクト: %(project)s 複製プロジェクト: %(clone_proj)s "
-"のボリューム: %(lun)s でのスナップショット: %(snapshot)s の複製中にエラーが発"
-"生しました。戻りコード: %(ret.status)d メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Creating Initiator: %(initiator)s on Alias: %(alias)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"エイリアス %(alias)s でのイニシエーター %(initiator)s の作成中にエラーが発生"
-"しました。戻りコード: %(ret.status)d、メッセージ: %(ret.data)s"
-
-#, python-format
-msgid ""
-"Error Creating Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"プール %(pool)s でのプロジェクト %(project)s の作成中にエラーが発生しました。"
-"戻りコード: %(ret.status)d、メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Creating Property: %(property)s Type: %(type)s Description: "
-"%(description)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"プロパティー: %(property)s タイプ: %(type)s 説明: %(description)s の作成中に"
-"エラーが発生しました。戻りコード: %(ret.status)d メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Creating Share: %(name)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"共有 %(name)s の作成中にエラーが発生しました。戻りコード: %(ret.status)d、"
-"メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Creating Volume: %(lun)s Size: %(size)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"ボリュームの作成中にエラーが発生しました: %(lun)s。サイズ: %(size)s、戻りコー"
-"ド: %(ret.status)d、メッセージ: %(ret.data)s。 "
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Share: %(share)s to Pool: %(pool)s "
-"Project: %(project)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"共有 %(share)s でスナップショット %(snapshot)s をプール %(pool)s から削除中に"
-"エラーが発生しました。プロジェクト: %(project)s、戻りコード: %(ret.status)d、"
-"メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Volume: %(lun)s to Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"ボリューム %(lun)s でスナップショット %(snapshot)s をプール %(pool)s から削除"
-"しているときにエラーが発生しました。プロジェクト: %(project)s、戻りコード: "
-"%(ret.status)d、メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Deleting Volume: %(lun)s from Pool: %(pool)s, Project: %(project)s. "
-"Return code: %(ret.status)d, Message: %(ret.data)s."
-msgstr ""
-"プール: %(pool)s、プロジェクト: %(project)s からのボリューム: %(lun)s の削除"
-"中にエラーが発生しました。戻りコード: %(ret.status)d、メッセージ: "
-"%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Deleting project: %(project)s on pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"プール: %(pool)s のプロジェクト: %(project)s の削除中にエラーが発生しました。"
-"戻りコード: %(ret.status)d メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Deleting replication action: %(id)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"レプリケーションアクション: %(id)s の削除中にエラーが発生しました。戻りコー"
-"ド: %(ret.status)d メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Getting Initiators: InitiatorGroup: %(initiatorgroup)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"イニシエーターの取得中にエラーが発生しました。InitiatorGroup: "
-"%(initiatorgroup)s 戻りコード: %(ret.status)d メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Getting Pool Stats: Pool: %(pool)s Return code: %(status)d Message: "
-"%(data)s."
-msgstr ""
-"プール統計: プール: %(pool)sの取得中にエラーが発生しました 戻りコード: "
-"%(status)d メッセージ: %(data)s。"
-
-#, python-format
-msgid ""
-"Error Getting Project Stats: Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"プロジェクト統計: プール: %(pool)s プロジェクト: %(project)s の取得中にエラー"
-"が発生しました。戻りコード: %(ret.status)d メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Getting Share: %(share)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"プール %(pool)s での共有 %(share)s の取得中にエラーが発生しました。プロジェク"
-"ト: %(project)s 戻りコード: %(ret.status)d メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Getting Volume: %(lun)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"プール %(pool)s でのボリューム %(lun)s の取得中にエラーが発生しました。プロ"
-"ジェクト: %(project)s、戻りコード: %(ret.status)d、メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid "Error Pool ownership: Pool %(pool)s is not owned by %(host)s."
-msgstr ""
-"プール所有権のエラーが発生しました: %(host)s はプール %(pool)s を所有していま"
-"せん。"
-
-#, python-format
-msgid ""
-"Error Setting props Props: %(props)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"プール %(pool)s のボリューム %(lun)s でのプロパティー %(props)s の設定中にエ"
-"ラーが発生しました。プロジェクト: %(project)s、戻りコード: %(ret.status)d、"
-"メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying Initiator: %(iqn)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"イニシエーターの検査中にエラーが発生しました: %(iqn)s。戻りコード: "
-"%(ret.status)d、メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying Pool: %(pool)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"プールの検査中にエラーが発生しました: %(pool)s。戻りコード: %(ret.status)d、"
-"メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"プール %(pool)s でのプロジェクト %(project)s の検査中にエラーが発生しました。"
-"戻りコード: %(ret.status)d、メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"サービス %(service)s の検査中にエラーが発生しました。戻りコード: "
-"%(ret.status)d、メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying Target: %(alias)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"ターゲットの検査中にエラーが発生しました: %(alias)s。戻りコード: "
-"%(ret.status)d、メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying share: %(share)s on Project: %(project)s and Pool: %(pool)s "
-"Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"プロジェクト %(project)s およびプール %(pool)s で共有 %(share)s を検証中にエ"
-"ラーが発生しました。戻りコード: %(ret.status)d メッセージ: %(ret.data)s。"
-
 msgid "Error connecting to ceph cluster."
 msgstr "ceph クラスターへの接続エラーです。"
 
@@ -1772,14 +1488,6 @@ msgstr "エバリュエーター構文
 
 #, python-format
 msgid ""
-"Error editing share: %(share)s on Pool: %(pool)s Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"プール %(pool)s での共有 %(share)s の編集中にエラーが発生しました。戻りコー"
-"ド: %(ret.status)d メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
 "Error enabling iSER for NetworkPortal: please ensure that RDMA is supported "
 "on your iSCSI port %(port)d on ip %(ip)s."
 msgstr ""
@@ -1806,20 +1514,10 @@ msgstr "ボリュームの拡張エラ
 msgid "Error finding %(name)s."
 msgstr "%(name)s の検索中にエラーが発生しました。"
 
-msgid ""
-"Error getting appliance version details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"アプライアンスバージョンの詳細の取得中にエラーが発生しました。戻りコード: "
-"%(ret.status)d メッセージ: %(ret.data)s。"
-
 #, python-format
 msgid "Error getting domain id from name %(name)s: %(id)s."
 msgstr "名前 %(name)s からドメイン ID を取得中にエラーが発生しました: %(id)s。"
 
-msgid "Error getting initiator groups."
-msgstr "イニシエーターグループの取得エラー。"
-
 #, python-format
 msgid "Error getting pool id from name %(pool_name)s: %(err_msg)s."
 msgstr ""
@@ -1827,36 +1525,6 @@ msgstr ""
 "%(err_msg)s。"
 
 #, python-format
-msgid ""
-"Error getting replication action: %(id)s. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"レプリケーションアクション: %(id)s の取得中にエラーが発生しました。戻りコー"
-"ド: %(ret.status)d メッセージ: %(ret.data)s。"
-
-msgid ""
-"Error getting replication source details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"レプリケーションソースの詳細の取得中にエラーが発生しました。戻りコード: "
-"%(ret.status)d メッセージ: %(ret.data)s。"
-
-msgid ""
-"Error getting replication target details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"レプリケーションターゲットの詳細の取得中にエラーが発生しました。戻りコード: "
-"%(ret.status)d メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error getting version: svc: %(svc)s.Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"バージョンの取得中にエラーが発生しました: svc: %(svc)s。戻りコード: "
-"%(ret.status)d、メッセージ: %(ret.data)s。"
-
-#, python-format
 msgid "Error in SolidFire API response: data=%(data)s"
 msgstr "SolidFire API 応答にエラーがあります: data=%(data)s"
 
@@ -1864,23 +1532,6 @@ msgstr "SolidFire API 応答にエラー
 msgid "Error managing volume: %s."
 msgstr "ボリュームの管理中にエラーが発生しました: %s。"
 
-#, python-format
-msgid ""
-"Error modifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"サービス %(service)s の変更中にエラーが発生しました。戻りコード: "
-"%(ret.status)d、メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error moving volume: %(vol)s from source project: %(src)s to target project: "
-"%(tgt)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"ソースプロジェクト: %(src)s からターゲットプロジェクト: %(tgt)s へのボリュー"
-"ム: %(vol)s の移動中にエラーが発生しました。戻りコード: %(ret.status)d メッ"
-"セージ: %(ret.data)s。 "
-
 msgid "Error not a KeyError."
 msgstr "KeyError ではなくエラーです。"
 
@@ -1911,38 +1562,6 @@ msgid "Error retrieving volume size"
 msgstr "ボリュームサイズの抽出でエラーが発生しました"
 
 #, python-format
-msgid ""
-"Error sending replication update for action id: %(id)s . Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"アクション ID: %(id)s のレプリケーション更新の送信中にエラーが発生しました。"
-"戻りコード: %(ret.status)d メッセージ: %(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error sending replication update. Returned error: %(err)s. Action: %(id)s."
-msgstr ""
-"レプリケーション更新の送信中にエラーが発生しました。戻されたエラー: %(err)s。"
-"アクション: %(id)s。"
-
-#, python-format
-msgid ""
-"Error setting replication inheritance to %(set)s for volume: %(vol)s project "
-"%(project)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"ボリューム: %(vol)s プロジェクト %(project)s の %(set)s へのレプリケーション"
-"継承の設定中にエラーが発生しました。戻りコード: %(ret.status)d メッセージ: "
-"%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error severing the package: %(package)s from source: %(src)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"ソース: %(src)s からのパッケージ: %(package)s の提供中にエラーが発生しまし"
-"た。戻りコード: %(ret.status)d メッセージ: %(ret.data)s。"
-
-#, python-format
 msgid "Error while authenticating with switch: %s."
 msgstr "スイッチによる認証中にエラーが発生しました: %s。"
 
@@ -2041,11 +1660,6 @@ msgid "Exception: %s"
 msgstr "例外: %s"
 
 #, python-format
-msgid "Expected higher file exists for snapshot %s"
-msgstr ""
-"スナップショット %s には、上位のファイルが存在することが期待されています。"
-
-#, python-format
 msgid "Expected integer for node_count, svcinfo lsiogrp returned: %(node)s."
 msgstr ""
 "node_count に対して整数が予期され、svcinfo lsiogrp が返されました: %(node)s。"
@@ -2102,14 +1716,6 @@ msgid "FC is the protocol but wwpns are
 msgstr "FC がプロトコルですが、wwpns が OpenStack によって提供されていません。"
 
 #, python-format
-msgid "Faield to unassign %(volume)s"
-msgstr "%(volume)s の割り当て解除に失敗しました"
-
-#, python-format
-msgid "Fail to create cache volume %(volume)s. Error: %(err)s"
-msgstr "キャッシュボリューム %(volume)s の作成に失敗しました。エラー: %(err)s"
-
-#, python-format
 msgid "Failed adding connection for fabric=%(fabric)s: Error: %(err)s"
 msgstr "ファブリック %(fabric)s の接続の追加に失敗しました。エラー: %(err)s"
 
@@ -2188,11 +1794,6 @@ msgid "Failed to connect to Dell REST AP
 msgstr "Dell REST API への接続に失敗しました"
 
 #, python-format
-msgid "Failed to connect to sheep daemon. addr: %(addr)s, port: %(port)s"
-msgstr ""
-"シープデーモンへの接続に失敗しました。アドレス: %(addr)s、 ポート: %(port)s"
-
-#, python-format
 msgid "Failed to copy image to volume: %(reason)s"
 msgstr "イメージをボリュームにコピーできませんでした: %(reason)s"
 
@@ -2225,18 +1826,6 @@ msgid "Failed to create api volume flow.
 msgstr "API ボリュームフローの作成に失敗しました。"
 
 #, python-format
-msgid "Failed to create cg snapshot %(id)s due to %(reason)s."
-msgstr "%(reason)s が原因で cg スナップショット %(id)s の作成に失敗しました。"
-
-#, python-format
-msgid "Failed to create consistency group %(id)s due to %(reason)s."
-msgstr "%(reason)s が原因で整合性グループ %(id)s の作成に失敗しました。"
-
-#, python-format
-msgid "Failed to create consistency group %(id)s:%(ret)s."
-msgstr "整合性グループ %(id)s の作成に失敗しました: %(ret)s。"
-
-#, python-format
 msgid "Failed to create consistency group: %(cgid)s. Error: %(excmsg)s."
 msgstr "整合性グループ %(cgid)s の作成に失敗しました。エラー: %(excmsg)s。"
 
@@ -2308,14 +1897,6 @@ msgid "Failed to create volume %s"
 msgstr "ボリューム %s の作成に失敗しました。"
 
 #, python-format
-msgid "Failed to delete cgsnapshot %(id)s due to %(reason)s."
-msgstr "%(reason)s が原因で cgsnapshot %(id)s の削除に失敗しました。"
-
-#, python-format
-msgid "Failed to delete consistency group %(id)s due to %(reason)s."
-msgstr "%(reason)s が原因で整合性グループ %(id)s の削除に失敗しました。"
-
-#, python-format
 msgid ""
 "Failed to delete fileset for consistency group %(cgname)s. Error: %(excmsg)s."
 msgstr ""
@@ -2400,12 +1981,6 @@ msgid "Failed to find host %s."
 msgstr "ホスト %s を見つけることに失敗しました。"
 
 #, python-format
-msgid "Failed to find iSCSI initiator group containing %(initiator)s."
-msgstr ""
-"%(initiator)s を含む  iSCSI イニシエーターグループを見つけることに失敗しまし"
-"た。"
-
-#, python-format
 msgid "Failed to get LUN target details for the LUN %s"
 msgstr "LUN %s の LUN ターゲット詳細の取得に失敗しました"
 
@@ -2521,13 +2096,6 @@ msgstr "%s 配列へのログインに
 msgid "Failed to login with all rest URLs."
 msgstr "すべての rest URL のログインに失敗しました。"
 
-#, python-format
-msgid ""
-"Failed to make a request to Datera cluster endpoint due to the following "
-"reason: %s"
-msgstr ""
-"次の理由で、Datera クラスターエンドポイントへの要求を実行できませんでした: %s"
-
 msgid "Failed to manage api volume flow."
 msgstr "API ボリュームフローの管理に失敗しました。"
 
@@ -2759,32 +2327,6 @@ msgid "Failure staging LUN %s to tmp."
 msgstr "LUN %s を一時 lun へステージング中に障害が発生しました。"
 
 #, python-format
-msgid "Fexvisor failed to add volume %(id)s due to %(reason)s."
-msgstr ""
-"Fexvisor は %(reason)s が原因でボリューム %(id)s の追加に失敗しました。"
-
-#, python-format
-msgid ""
-"Fexvisor failed to join the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr ""
-"Fexvisor は %(ret)s が原因でグループ %(group)s でのボリューム %(vol)s の結合"
-"に失敗しました。"
-
-#, python-format
-msgid ""
-"Fexvisor failed to remove the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr ""
-"Fexvisor は %(ret)s が原因で グループ  %(group)s でのボリューム %(vol)s の削"
-"除に失敗しました。"
-
-#, python-format
-msgid "Fexvisor failed to remove volume %(id)s due to %(reason)s."
-msgstr ""
-"Fexvisor は %(reason)s が原因でボリューム %(id)s の削除に失敗しました。"
-
-#, python-format
 msgid "Fibre Channel SAN Lookup failure: %(reason)s"
 msgstr "ファイバーチャネル SAN ルックアップ障害: %(reason)s"
 
@@ -2804,10 +2346,6 @@ msgid "File %(file_path)s could not be f
 msgstr "ファイル %(file_path)s が見つかりませんでした。"
 
 #, python-format
-msgid "File already exists at %s."
-msgstr "ファイルは %s に既に存在します。"
-
-#, python-format
 msgid "File already exists at: %s"
 msgstr "ファイルは既に存在します: %s"
 
@@ -2841,195 +2379,6 @@ msgstr ""
 "「%(version)s」がインストールされていることを必要としています。"
 
 #, python-format
-msgid "Flexvisor assign volume failed.:%(id)s:%(status)s."
-msgstr ""
-"Flexvisor によるボリュームの割り当てが失敗しました: %(id)s:%(status)s。"
-
-#, python-format
-msgid "Flexvisor assign volume failed:%(id)s:%(status)s."
-msgstr ""
-"Flexvisor によるボリュームの割り当てが失敗しました: %(id)s:%(status)s。"
-
-#, python-format
-msgid ""
-"Flexvisor could not find volume %(id)s snapshot in the group %(vgid)s "
-"snapshot %(vgsid)s."
-msgstr ""
-"Flexvisor はグループ %(vgid)s スナップショット %(vgsid)s でボリューム %(id)s "
-"スナップショットを見つけられませんでした。"
-
-#, python-format
-msgid "Flexvisor create volume failed.:%(volumeid)s:%(status)s."
-msgstr ""
-"Flexvisor によるボリュームの作成が失敗しました: %(volumeid)s:%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed deleting volume %(id)s: %(status)s."
-msgstr "Flexvisor はボリューム %(id)s の削除に失敗しました: %(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to add volume %(id)s to group %(cgid)s."
-msgstr ""
-"Flexvisor はボリューム %(id)s をグループ %(cgid)s に追加できませんでした。"
-
-#, python-format
-msgid ""
-"Flexvisor failed to assign volume %(id)s due to unable to query status by "
-"event id."
-msgstr ""
-"Flexvisor は、イベント ID でステータスを照会できないことが原因でボリューム "
-"%(id)s を割り当てることに失敗しました。"
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(id)s: %(status)s."
-msgstr "Flexvisor はボリューム %(id)s の割り当てに失敗しました: %(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(volume)s iqn %(iqn)s."
-msgstr ""
-"Flexvisor はボリューム %(volume)s iqn %(iqn)s の割り当てに失敗しました。"
-
-#, python-format
-msgid "Flexvisor failed to clone volume %(id)s: %(status)s."
-msgstr "Flexvisor はボリューム %(id)s の複製に失敗しました: %(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to clone volume (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor はボリューム %(id)s の複製に失敗しました (イベントの取得に失敗しま"
-"した)。"
-
-#, python-format
-msgid "Flexvisor failed to create snapshot for volume %(id)s: %(status)s."
-msgstr ""
-"Flexvisor はボリューム %(id)s のスナップショットを作成することに失敗しまし"
-"た: %(status)s。"
-
-#, python-format
-msgid ""
-"Flexvisor failed to create snapshot for volume (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor はボリューム %(id)s のスナップショットを作成することに失敗しました "
-"(イベントの取得に失敗しました)。"
-
-#, python-format
-msgid "Flexvisor failed to create volume %(id)s in the group %(vgid)s."
-msgstr ""
-"Flexvisor はグループ %(vgid)s 内でボリューム %(id)s を作成できませんでした。"
-
-#, python-format
-msgid "Flexvisor failed to create volume %(volume)s: %(status)s."
-msgstr "Flexvisor はボリューム %(volume)s の作成に失敗しました: %(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to create volume (get event) %s."
-msgstr "Flexvisor はボリューム %s の作成 (イベントの取得) に失敗しました。"
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s: %(status)s."
-msgstr ""
-"Flexvisor はスナップショット %(id)s からのボリュームの作成に失敗しました: "
-"%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s:%(status)s."
-msgstr ""
-"Flexvisor はスナップショット %(id)s からのボリュームの作成に失敗しました: "
-"%(status)s。"
-
-#, python-format
-msgid ""
-"Flexvisor failed to create volume from snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor はスナップショット %(id)s からのボリュームの作成に失敗しました (イ"
-"ベントの取得に失敗しました)。"
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot %(id)s: %(status)s."
-msgstr "Flexvisor はスナップショット %(id)s の削除に失敗しました: %(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor はスナップショット %(id)s の削除に失敗しました (イベントの取得に失"
-"敗しました)。"
-
-#, python-format
-msgid "Flexvisor failed to delete volume %(id)s: %(status)s."
-msgstr "Flexvisor はボリューム %(id)s の削除に失敗しました: %(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s: %(status)s."
-msgstr "Flexvisor はボリューム %(id)s の拡張に失敗しました: %(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s:%(status)s."
-msgstr "Flexvisor はボリューム %(id)s の拡張に失敗しました: %(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to extend volume (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor はボリューム %(id)s の拡張に失敗しました (イベントの取得に失敗しま"
-"した)。"
-
-#, python-format
-msgid "Flexvisor failed to get pool info %(id)s: %(status)s."
-msgstr "Flexvisor はプール情報 %(id)s の取得に失敗しました: %(status)s。"
-
-#, python-format
-msgid ""
-"Flexvisor failed to get snapshot id of volume %(id)s from group %(vgid)s."
-msgstr ""
-"Flexvisor はグループ %(vgid)s からボリューム %(id)s のスナップショット ID を"
-"取得できませんでした。"
-
-#, python-format
-msgid "Flexvisor failed to remove volume %(id)s from group %(cgid)s."
-msgstr ""
-"Flexvisor はグループ %(cgid)s からのボリューム %(id)s の削除に失敗しました。"
-
-#, python-format
-msgid "Flexvisor failed to spawn volume from snapshot %(id)s:%(status)s."
-msgstr ""
-"Flexvisor はスナップショット %(id)s からのボリュームの作成に失敗しました: "
-"%(status)s。"
-
-#, python-format
-msgid ""
-"Flexvisor failed to spawn volume from snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor はスナップショット %(id)s からのボリュームの作成に失敗しました (イ"
-"ベントの取得に失敗しました)。"
-
-#, python-format
-msgid "Flexvisor failed to unassign volume %(id)s: %(status)s."
-msgstr ""
-"Flexvisor はボリューム %(id)s の割り当て解除に失敗しました: %(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to unassign volume (get event) %(id)s."
-msgstr ""
-"Flexvisor はボリューム %(id)s の割り当て解除 (イベントの取得) に失敗しまし"
-"た。"
-
-#, python-format
-msgid "Flexvisor failed to unassign volume:%(id)s:%(status)s."
-msgstr "Flexvisor はボリューム %(id)s の割り当て解除に失敗しました: %(status)s"
-
-#, python-format
-msgid "Flexvisor unable to find the source volume %(id)s info."
-msgstr "Flexvisor はソースボリューム %(id)s 情報を検出できません。"
-
-#, python-format
-msgid "Flexvisor unassign volume failed:%(id)s:%(status)s."
-msgstr ""
-"Flexvisor によるボリュームの割り当て解除が失敗しました: %(id)s:%(status)s。"
-
-#, python-format
-msgid "Flexvisor volume %(id)s failed to join group %(vgid)s."
-msgstr "Flexvisor ボリューム %(id)s はグループ %(vgid)s の結合に失敗しました。"
-
-#, python-format
 msgid "Folder %s does not exist in Nexenta Store appliance"
 msgstr "フォルダー %s は Nexenta Store アプライアンスに存在しません"
 
@@ -3490,14 +2839,6 @@ msgid "Invalid Replication Target: %(rea
 msgstr "無効なレプリケーションターゲット: %(reason)s"
 
 #, python-format
-msgid ""
-"Invalid Virtuozzo Storage share specification: %r. Must be: [MDS1[,"
-"MDS2],...:/]<CLUSTER NAME>[:PASSWORD]."
-msgstr ""
-"Virtuozzo Storage のシェアの指定が無効です: %r。[MDS1[,MDS2],...:/]<CLUSTER "
-"NAME>[:PASSWORD] である必要があります。"
-
-#, python-format
 msgid "Invalid XtremIO version %(cur)s, version %(min)s or up is required"
 msgstr ""
 "XtremIO バージョン %(cur)s は無効です。バージョン %(min)s 以上が必要です"
@@ -3507,13 +2848,6 @@ msgid "Invalid allocated quotas defined
 msgstr ""
 "以下のプロジェクトのクォータに定義した割り当て済みのクォータが無効です: %s"
 
-msgid "Invalid argument - negative seek offset."
-msgstr "引数が無効です。シークオフセットが負の値です。"
-
-#, python-format
-msgid "Invalid argument - whence=%s not supported."
-msgstr "引数が無効です。whence=%s はサポートされません。"
-
 #, python-format
 msgid "Invalid attaching mode '%(mode)s' for volume %(volume_id)s."
 msgstr "接続モード '%(mode)s' はボリューム %(volume_id)s には無効です。"
@@ -3531,15 +2865,6 @@ msgid "Invalid backup: %(reason)s"
 msgstr "無効なバックアップ: %(reason)s"
 
 #, python-format
-msgid "Invalid connection initialization response of volume %(name)s"
-msgstr "ボリューム %(name)s の接続初期化応答が無効です"
-
-#, python-format
-msgid ""
-"Invalid connection initialization response of volume %(name)s: %(output)s"
-msgstr "ボリューム %(name)s の接続初期化応答が無効です: %(output)s"
-
-#, python-format
 msgid "Invalid content type %(content_type)s."
 msgstr "無効なコンテンツタイプ %(content_type)s。"
 
@@ -3633,10 +2958,6 @@ msgid "Invalid mount point base: %s"
 msgstr "無効なマウントポイントベース: %s"
 
 #, python-format
-msgid "Invalid mount point base: %s."
-msgstr "無効なマウントポイントベース: %s"
-
-#, python-format
 msgid "Invalid new snapCPG name for retype.  new_snap_cpg='%s'."
 msgstr "新規 snapCPG 名がタイプ変更には無効です。new_snap_cpg='%s'。"
 
@@ -3655,9 +2976,6 @@ msgstr "無効なセカンダリー ID %
 msgid "Invalid service catalog json."
 msgstr "無効なサービスカタログ JSON。"
 
-msgid "Invalid sheepdog cluster status."
-msgstr "シープドッグクラスターの状態が無効です。"
-
 #, python-format
 msgid "Invalid snapshot: %(reason)s"
 msgstr "無効なスナップショット: %(reason)s"
@@ -3756,10 +3074,6 @@ msgstr ""
 "無効な volume_type %s が指定されました (要求するタイプは、このグループでサ"
 "ポートされていなければなりません)。"
 
-#, python-format
-msgid "Invalid wwpns format %(wwpns)s"
-msgstr "wwpn 形式 %(wwpns)s は無効です"
-
 msgid "Issue encountered waiting for job."
 msgstr "ジョブの待機中に問題が発生しました。"
 
@@ -3780,10 +3094,6 @@ msgstr "再試行可能な Kaminario 例
 msgid "KaminarioCinderDriver failure: %(reason)s"
 msgstr "Kaminario Cinder ドライバー障害です: %(reason)s"
 
-#, python-format
-msgid "KeyError: %s"
-msgstr "KeyError: %s"
-
 msgid "Keystone version 3 or greater must be used to get nested quota support."
 msgstr ""
 "ネストされたクォータを使用するには、Keystone のバージョン 3 以降を使用する必"
@@ -4155,9 +3465,6 @@ msgstr ""
 msgid "New volume type not specified in request_spec."
 msgstr "新規のボリュームタイプが要求仕様に指定されていません。"
 
-msgid "Nimble Cinder Driver exception"
-msgstr "Nimble Cinder ドライバー例外"
-
 msgid "No FC initiator can be added to host."
 msgstr "ホストには FC イニシエーターを追加できません。"
 
@@ -4203,10 +3510,6 @@ msgid "No initiator connected to fabric.
 msgstr "ファブリックに接続されたイニシエーターはありません。"
 
 #, python-format
-msgid "No initiator group found for initiator %s"
-msgstr "イニシエーター %s のイニシエーターグループが見つかりません。"
-
-#, python-format
 msgid "No interface found on cluster for ip %s"
 msgstr "ip %s のクラスター上にインターフェースが見つかりませんでした"
 
@@ -4219,9 +3522,6 @@ msgstr "マウントされた NFS 共有
 msgid "No mounted SMBFS shares found."
 msgstr "マウントされた SMBFS 共有が見つかりません。"
 
-msgid "No mounted Virtuozzo Storage shares found"
-msgstr "マウントされた Virtuozzo Storage 共有が見つかりません"
-
 msgid "No mounted shares found"
 msgstr "マウントされた共有が見つかりません"
 
@@ -4252,9 +3552,6 @@ msgstr ""
 msgid "No such QoS spec %(specs_id)s."
 msgstr "そのような QoS 仕様 %(specs_id)s は存在しません。"
 
-msgid "No suitable discovery ip found"
-msgstr "適切なディスカバリー ip が見つかりません。"
-
 msgid "No suitable host was found to failover."
 msgstr "フェイルオーバーに適したホストが見つかりませんでした。"
 
@@ -4317,10 +3614,6 @@ msgstr "許可されていません。"
 msgid "Not enough space on backend (%(backend)s)"
 msgstr "バックエンド容量が不十分です (%(backend)s)"
 
-msgid "Not enough storage space in the ZFS share to perform this operation."
-msgstr ""
-"この操作を実行するために十分なストレージスペースが ZFS 共有にありません。"
-
 msgid "Not stored in rbd"
 msgstr "rbd 内に保管されていません。"
 
@@ -4355,9 +3648,6 @@ msgstr ""
 "直近の親またはルートプロジェクトに割り当てられたトークンを持つユーザーのみ"
 "が、子のクォータを参照することができます。"
 
-msgid "Only volumes managed by OpenStack can be unmanaged."
-msgstr "非管理に設定できるのは、OpenStack が管理するボリュームのみです。"
-
 #, python-format
 msgid "Operation failed with status=%(status)s. Full dump: %(data)s"
 msgstr "状態=%(status)s で操作が失敗しました。フルダンプ: %(data)s"
@@ -4416,9 +3706,6 @@ msgstr "ポリシーは %(action)s の
 msgid "Pool is not available in the volume host field."
 msgstr "プールがボリュームホストフィールドにありません。"
 
-msgid "Pool is not available in the volume host fields."
-msgstr "プールがボリュームホストフィールドにありません。"
-
 #, python-format
 msgid "Pool with name %(pool_name)s wasn't found in domain %(domain_id)s."
 msgstr ""
@@ -4573,16 +3860,6 @@ msgstr "参照には source-name また
 msgid "Reference must contain source-name."
 msgstr "参照には source-name が含まれていなければなりません。"
 
-msgid "Reference to volume to be managed must contain source-name."
-msgstr ""
-"管理対象のボリュームへの参照には source-name が含まれていなければなりません。"
-
-#, python-format
-msgid "Reference to volume: %s to be managed must contain source-name."
-msgstr ""
-"管理対象のボリューム: %s への参照には source-name が含まれていなければなりま"
-"せん。"
-
 #, python-format
 msgid ""
 "Refusing to migrate volume ID: %(id)s. Please check your configuration "
@@ -4664,12 +3941,6 @@ msgid "Request body contains too many it
 msgstr "要求本体に含まれる項目が多すぎます"
 
 #, python-format
-msgid "Request to Datera cluster returned bad status: %(status)s | %(reason)s"
-msgstr ""
-"Datera クラスターに対する要求から、正しくない状態が返されました: %(status)s "
-"| %(reason)s"
-
-#, python-format
 msgid ""
 "Requested backup exceeds allowed Backup gigabytes quota. Requested "
 "%(requested)sG, quota is %(quota)sG and %(consumed)sG has been consumed."
@@ -4802,11 +4073,6 @@ msgid "SMBFS config file not set (smbfs_
 msgstr "SMBFS 構成ファイルが設定されていません (smbfs_shares_config)。"
 
 #, python-format
-msgid "SSH Command failed after '%(total_attempts)r' attempts : '%(command)s'"
-msgstr ""
-"'%(total_attempts)r' 回の試行後に SSH コマンドが失敗しました: '%(command)s'"
-
-#, python-format
 msgid "SSH command injection detected: %(command)s"
 msgstr "SSH コマンド注入が検出されました: %(command)s"
 
@@ -4862,10 +4128,6 @@ msgstr ""
 "形式が無効であるため、共有 %s は無視されました。address:/export 形式でなけれ"
 "ばなりません。nas_host および nas_share_path の設定を確認してください。"
 
-#, python-format
-msgid "Sheepdog I/O Error, command was: \"%s\"."
-msgstr "シープドッグの I/O エラー。実行されたコマンド: \"%s\"."
-
 msgid ""
 "Show operations can only be made to projects in the same hierarchy of the "
 "project in which users are scoped to."
@@ -5001,9 +4263,6 @@ msgstr "ソースボリュームはマ
 msgid "Specified logical volume does not exist."
 msgstr "指定された論理ボリュームは存在しません。"
 
-msgid "Specifies IP pool to use for volume"
-msgstr "ボリュームに用いる IP プールを指定します。"
-
 msgid ""
 "Specifies number of replicas for each volume. Can only be increased once "
 "volume is created"
@@ -5127,14 +4386,6 @@ msgstr ""
 "GPFS ファイルシステム %(fs)s は必要なリリースレベルに達していません。現在のレ"
 "ベルは %(cur)s です。%(min)s 以上は必要です。"
 
-#, python-format
-msgid ""
-"The WebDAV request failed. Reason: %(msg)s, Return code/reason: %(code)s, "
-"Source Volume: %(src)s, Destination Volume: %(dst)s, Method: %(method)s."
-msgstr ""
-"WebDAV 要求が失敗しました。理由: %(msg)s、戻りコード/理由: %(code)s、ソースボ"
-"リューム: %(src)s、宛先ボリューム: %(dst)s、メソッド: %(method)s。"
-
 msgid ""
 "The above error may show that the database has not been created.\n"
 "Please create a database using 'cinder-manage db sync' before running this "
@@ -5196,12 +4447,6 @@ msgstr ""
 msgid "The method update_migrated_volume is not implemented."
 msgstr "update_migrated_volume メソッドが実装されていません。"
 
-msgid "The name to use for storage instances created"
-msgstr "作成したストレージインスタンスにも用いる名前"
-
-msgid "The name to use for volumes created"
-msgstr "作成したボリュームに用いる名前"
-
 msgid "The parent backup must be available for incremental backup."
 msgstr "増分バックアップでは親バックアップが使用可能でなければなりません。"
 
@@ -5254,9 +4499,6 @@ msgstr ""
 "このスナップショットの親は、削除中やアクションの取り消し中などの理由で、オリ"
 "ジナルのものではありません。このため、このスナップショットは管理できません。"
 
-msgid "The source volume for this WebDAV operation not found."
-msgstr "この WebDAV 操作のソースボリュームが見つかりません。"
-
 #, python-format
 msgid ""
 "The source volume type '%(src)s' is different than the destination volume "
@@ -5452,13 +4694,6 @@ msgstr ""
 msgid "Transfer %(transfer_id)s could not be found."
 msgstr "転送 %(transfer_id)s が見つかりませんでした。"
 
-msgid ""
-"True to set acl 'allow_all' on volumes created.  Cannot be changed on volume "
-"once set"
-msgstr ""
-"ボリューム作成時に acl 'allow_all'  を True に設定します。一度ボリュームに設"
-"定すると変更することはできません。"
-
 #, python-format
 msgid ""
 "Trying to import backup metadata from id %(meta_id)s into backup %(id)s."
@@ -5495,10 +4730,6 @@ msgid "Type cannot be converted into NaE
 msgstr "タイプは NaElement に変換できません。"
 
 #, python-format
-msgid "TypeError: %s"
-msgstr "TypeError: %s"
-
-#, python-format
 msgid "UUIDs %s are in both add and remove volume list."
 msgstr "UUID %s が、ボリュームの追加リストと削除リストの両方に存在します。"
 
@@ -5791,9 +5022,6 @@ msgstr ""
 msgid "Unexpected over quota on %(name)s."
 msgstr "%(name)s で、予期せずクォータを超過しました。"
 
-msgid "Unexpected response from Nimble API"
-msgstr "Nimble API からの予期しない応答"
-
 msgid "Unexpected status code"
 msgstr "予期しないステータスコード"
 
@@ -5814,41 +5042,10 @@ msgstr "不明な RemoteFS 例外"
 msgid "Unknown SMBFS exception."
 msgstr "不明な SMBFS 例外。"
 
-msgid "Unknown Virtuozzo Storage exception"
-msgstr "Virtuozzo Storage で不明な例外が発生しました"
-
 msgid "Unknown action"
 msgstr "不明なアクション"
 
 #, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, Set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"管理対象のボリューム: %s がすでに Cinder によって管理されている場合は不明で"
-"す。ボリュームの管理を中止します。 'cinder_managed' カスタムスキーマプロパ"
-"ティーをそのボリュームに追加し、その値を False に設定してください。あるいは、"
-"Cinder の設定ポリシーの値 'zfssa_manage_policy' を 'loose' に変更してこの制限"
-"を取り除きます。"
-
-#, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"管理対象のボリューム: %s がすでに Cinder によって管理されている場合は不明で"
-"す。ボリュームの管理を中止します。 'cinder_managed' カスタムスキーマプロパ"
-"ティーをそのボリュームに追加し、その値を False に設定してください。あるいは、"
-"Cinder の設定ポリシーの値 'zfssa_manage_policy' を 'loose' に変更してこの制限"
-"を取り除きます。"
-
-#, python-format
 msgid "Unknown or unsupported command %(cmd)s"
 msgstr "不明またはサポートされないコマンド (%(cmd)s) です。"
 
@@ -5913,10 +5110,6 @@ msgstr ""
 "v6.4 以上が実行されていることを確認してください"
 
 #, python-format
-msgid "Unsupported volume format %s"
-msgstr "ボリューム形式はサポートされていません: %s "
-
-#, python-format
 msgid "Unsupported volume format: %s "
 msgstr "ボリューム形式はサポートされていません: %s "
 
@@ -5966,9 +5159,6 @@ msgstr "ユーザー ID"
 msgid "User does not have admin privileges"
 msgstr "ユーザーに管理者特権がありません。"
 
-msgid "User not authorized to perform WebDAV operations."
-msgstr "ユーザーは WebDAV 操作の実行が許可されていません。"
-
 msgid "User not permitted to query Data ONTAP volumes."
 msgstr "ユーザーには Data ONTAP ボリュームの照会が許可されていません。"
 
@@ -6004,10 +5194,6 @@ msgid ""
 msgstr "構成オプション \"%(option)s\" の値 \"%(value)s\" は無効です。"
 
 #, python-format
-msgid "ValueError: %s"
-msgstr "ValueError: %s"
-
-#, python-format
 msgid "Vdisk %(name)s not involved in mapping %(src)s -> %(tgt)s."
 msgstr "%(src)s から %(tgt)s へのマッピングに関連しない Vdisk %(name)s。"
 
@@ -6126,26 +5312,10 @@ msgid "Volume %s does not exist on the a
 msgstr "ボリューム %s does はアレイに存在しません。"
 
 #, python-format
-msgid "Volume %s does not have provider_location specified, skipping."
-msgstr ""
-"ボリューム %s で provider_location が指定されていません。スキップします。"
-
-#, python-format
 msgid "Volume %s doesn't exist on array."
 msgstr "ボリューム %s がアレイに存在しません。"
 
 #, python-format
-msgid "Volume %s doesn't exist on the ZFSSA backend."
-msgstr "ボリューム %s が ZFSSA バックエンドに存在しません。"
-
-#, python-format
-msgid ""
-"Volume %s is online. Set volume to offline for managing using OpenStack."
-msgstr ""
-"ボリューム %s がオンラインです。OpenStack を使用して管理するために、ボリュー"
-"ムをオフラインに設定してください。"
-
-#, python-format
 msgid "Volume %s must not be part of a consistency group."
 msgstr "ボリューム %s は整合性グループの一部であってはなりません。"
 
@@ -6210,10 +5380,6 @@ msgid "Volume device not found at %(devi
 msgstr "%(device)s でボリュームデバイスが見つかりません。"
 
 #, python-format
-msgid "Volume does not exists %s."
-msgstr "ボリュームが存在しません: %s"
-
-#, python-format
 msgid "Volume driver %s not initialized."
 msgstr "ボリュームドライバー %s が初期化されていません。"
 
@@ -6314,9 +5480,6 @@ msgstr "ボリュームがまだホス
 msgid "Volume replication for %(volume_id)s could not be found."
 msgstr "%(volume_id)s のボリューム複製が見つかりませんでした。"
 
-msgid "Volume should have agent-type set as None."
-msgstr "ボリュームには agent-type として None を設定する必要があります。"
-
 #, python-format
 msgid ""
 "Volume size %(volume_size)sGB cannot be smaller than the image minDisk size "
@@ -6360,15 +5523,6 @@ msgstr "ボリュームサイズは 1 GB
 msgid "Volume size must multiple of 1 GB."
 msgstr "ボリュームサイズは 1 GB の倍数である必要があります"
 
-msgid "Volume status must be 'available'."
-msgstr "ボリュームの状態は「使用可能」でなければなりません。"
-
-#, python-format
-msgid "Volume status must be available for snapshot %(id)s. (is %(status)s)"
-msgstr ""
-"スナップショット %(id)s に関しては、ボリュームの状態が「利用可能」でなければ"
-"いけません。  (現在は %(status)s です)"
-
 msgid "Volume to Initiator Group mapping already exists"
 msgstr "ボリュームからイニシエーターグループへのマッピングは既に存在します。"
 
@@ -6422,10 +5576,6 @@ msgstr "ボリューム種別名を空
 msgid "Volume type with name %(volume_type_name)s could not be found."
 msgstr "名前 %(volume_type_name)s を持つボリューム種別が見つかりませんでした。"
 
-#, python-format
-msgid "Volume: %s is already being managed by Cinder."
-msgstr "ボリューム: %s はすでに Cinder によって管理されています。"
-
 msgid ""
 "Volumes/account exceeded on both primary and secondary SolidFire accounts."
 msgstr ""
@@ -6433,26 +5583,9 @@ msgstr ""
 "トの数量が超過しました。"
 
 #, python-format
-msgid ""
-"VzStorage config 'vzstorage_used_ratio' invalid. Must be > 0 and <= 1.0: %s."
-msgstr ""
-"VzStorage の設定の 'vzstorage_used_ratio' が無効です。0 より大きく 1.0 以下で"
-"ある必要があります: %s。"
-
-#, python-format
-msgid "VzStorage config file at %(config)s doesn't exist."
-msgstr "%(config)s の VzStorage のコンフィグファイルが存在しません"
-
-#, python-format
 msgid "Wait synchronize failed. Running status: %s."
 msgstr "同期の待機が失敗しました。実行状態: %s。"
 
-msgid ""
-"Waiting for all nodes to join cluster. Ensure all sheep daemons are running."
-msgstr ""
-"すべてのノードがクラスターに接続するのを待機しています。すべてのシープデーモ"
-"ンが稼働中であることを確認してください。"
-
 msgid "We should not do switch over on primary array."
 msgstr "プライマリーアレイで切り替えを行ってはなりません。"
 
@@ -7218,13 +6351,6 @@ msgstr ""
 "クトの MD5 %(etag)s が Swift に送信されたオブジェクトの MD5 %(md5)s と同じで"
 "はありません"
 
-msgid ""
-"existing_ref argument must be of this format:app_inst_name:storage_inst_name:"
-"vol_name"
-msgstr ""
-"引数 existing_ref は 次の形式でなければいけません: app_inst_name:"
-"storage_inst_name:vol_name"
-
 #, python-format
 msgid "extend_volume, eternus_pool: %(eternus_pool)s, pool not found."
 msgstr ""
@@ -7254,9 +6380,6 @@ msgstr ""
 msgid "fake"
 msgstr "偽"
 
-msgid "fileno is not supported by SheepdogIOWrapper"
-msgstr "SheepdogIOWrapper は fileno をサポートしません。"
-
 #, python-format
 msgid "fmt=%(fmt)s backed by: %(backing_file)s"
 msgstr "fmt=%(fmt)s の基盤: %(backing_file)s"
@@ -7342,13 +6465,6 @@ msgstr "割り当てられたグルー
 msgid "group_type_id cannot be None"
 msgstr "group_type_id を None に設定することはできません。"
 
-msgid ""
-"http service may have been abruptly disabled or put to maintenance state in "
-"the middle of this operation."
-msgstr ""
-"この操作の途中で HTTP サービスが急に無効または保守状態になった可能性がありま"
-"す。"
-
 msgid "id cannot be None"
 msgstr "ID を None にすることはできません。"
 
@@ -7732,11 +6848,3 @@ msgstr "割り当てられたボリュ
 
 msgid "volumes changed"
 msgstr "変更されたボリューム"
-
-#, python-format
-msgid ""
-"zfssa_manage_policy property needs to be set to 'strict' or 'loose'. Current "
-"value is: %s."
-msgstr ""
-"zfssa_manage_policy プロパティーは 'strict' または 'loose' に設定する必要があ"
-"ります。現在の値は %s です。"
diff -pruN 2:15.0.1-1/cinder/locale/ko_KR/LC_MESSAGES/cinder.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/ko_KR/LC_MESSAGES/cinder.po
--- 2:15.0.1-1/cinder/locale/ko_KR/LC_MESSAGES/cinder.po	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/ko_KR/LC_MESSAGES/cinder.po	2020-03-24 18:46:31.000000000 +0000
@@ -15,7 +15,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: cinder VERSION\n"
 "Report-Msgid-Bugs-To: https://bugs.launchpad.net/openstack-i18n/\n"
-"POT-Creation-Date: 2019-10-04 05:27+0000\n"
+"POT-Creation-Date: 2020-03-18 14:40+0000\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
@@ -119,11 +119,6 @@ msgstr ""
 "%(vol_mode)s입니다."
 
 #, python-format
-msgid "%(service)s Service is not %(status)s on storage appliance: %(host)s"
-msgstr ""
-"%(service)s 서비스가 스토리지 어플라이언스 %(host)s에서 %(status)s이(가) 아님"
-
-#, python-format
 msgid ""
 "%(worker_name)s value of %(workers)d is invalid, must be greater than 0."
 msgstr ""
@@ -176,10 +171,6 @@ msgid "%s is not installed"
 msgstr "%s이(가) 설치되지 않음"
 
 #, python-format
-msgid "%s is not installed."
-msgstr "%s이(가) 설치되어 있지 않습니다. "
-
-#, python-format
 msgid "%s is not set"
 msgstr "%s이(가) 설정되지 않았음"
 
@@ -201,10 +192,6 @@ msgid "%s must be an absolute path."
 msgstr "%s은(는) 절대 경로여야 합니다. "
 
 #, python-format
-msgid "%s not set in cinder.conf"
-msgstr "cinder.conf에 %s이(가) 설정되지 않음"
-
-#, python-format
 msgid "%s not set."
 msgstr "%s이(가) 설정되지 않음. "
 
@@ -225,14 +212,6 @@ msgstr "'consistencygroup_id'를 지정
 msgid "'qemu-img info' parsing failed."
 msgstr "'qemu-img info' 구문 분석에 실패했습니다. "
 
-#, python-format
-msgid ""
-"(Command: %(cmd)s) (Return Code: %(exit_code)s) (Stdout: %(stdout)s) "
-"(Stderr: %(stderr)s)"
-msgstr ""
-"(명령: %(cmd)s) (리턴 코드: %(exit_code)s) (Stdout: %(stdout)s) (Stderr: "
-"%(stderr)s)"
-
 msgid "A concurrent, possibly contradictory, request has been made."
 msgstr "동시에 모순된 요청이 수행되었습니다."
 
@@ -319,14 +298,6 @@ msgstr ""
 "상태: %(luncopystatus)s. LUNcopy 상태: %(luncopystate)s."
 
 #, python-format
-msgid "An error occurred while reading volume \"%s\"."
-msgstr "볼륨 \"%s\"을(를) 읽는 중에 오류가 발생했습니다. "
-
-#, python-format
-msgid "An error occurred while writing to volume \"%s\"."
-msgstr "볼륨 \"%s\"에 쓰는 중에 오류가 발생했습니다. "
-
-#, python-format
 msgid "An invalid 'name' value was provided. %(reason)s"
 msgstr "유효하지 않은 'name' 값이 제공되었습니다. %(reason)s"
 
@@ -407,9 +378,6 @@ msgstr "사용 가능한 카테고리:"
 msgid "Backend doesn't exist (%(backend)s)"
 msgstr "백엔드가 존재하지 않음(%(backend)s)"
 
-msgid "Backend storage did not configure fiber channel target."
-msgstr "백엔드 스토리지가 파이버 채널 대상을 구성하지 않았습니다."
-
 msgid "Backing up an in-use volume must use the force flag."
 msgstr "사용 중인 볼륨을 백업하려면 강제 실행 플래그를 사용해야 합니다. "
 
@@ -528,10 +496,6 @@ msgstr ""
 msgid "CPG (%s) doesn't exist on array"
 msgstr "배열에 CPG(%s)가 없음"
 
-#, python-format
-msgid "Cache volume %s does not have required properties"
-msgstr "캐시 볼륨 %s에 필수 특성이 없음"
-
 msgid "Can not add FC port to host."
 msgstr "호스트에 FC 포트를 추가할 수 없습니다."
 
@@ -660,10 +624,6 @@ msgstr ""
 "VF 컨텍스트를 변경할 수 없음, 관리할 수 있는 VF 목록 %(vf_list)s에서 지정된 "
 "VF를 사용할 수 없습니다."
 
-#, python-format
-msgid "Cannot create directory %s."
-msgstr "디렉토리 %s을(를) 작성할 수 없습니다. "
-
 msgid "Cannot create encryption specs. Volume type in use."
 msgstr "암호화 스펙을 작성할 수 없습니다. 볼륨 유형이 사용 중입니다."
 
@@ -682,22 +642,6 @@ msgid "Cannot create volume_type with na
 msgstr ""
 "이름이 %(name)s이고 스펙이 %(extra_specs)s인 volume_type을 작성할 수 없음"
 
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)d volume instances."
-msgstr ""
-"캐시 볼륨: %(cachevol_name)s을(를) 삭제할 수 없습니다. %(updated_at)s에 업데"
-"이트되었으며 현재 %(numclones)d개 볼륨 인스턴스를 가지고 있습니다. "
-
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)s volume instances."
-msgstr ""
-"캐시 볼륨: %(cachevol_name)s을(를) 삭제할 수 없습니다. %(updated_at)s에 업데"
-"이트되었으며 현재 %(numclones)s개 볼륨 인스턴스를 가지고 있습니다. "
-
 msgid "Cannot delete encryption specs. Volume type in use."
 msgstr "암호화 스펙을 삭제할 수 없습니다. 볼륨 유형이 사용 중입니다."
 
@@ -768,9 +712,6 @@ msgid ""
 "Change would make usage less than 0 for the following resources: %(unders)s"
 msgstr "이 변경으로 인해 %(unders)s 자원의 사용량이 0보다 적게 됩니다. "
 
-msgid "Check access permissions for the ZFS share assigned to this driver."
-msgstr "이 드라이버에 지정된 ZFS 공유에 대한 액세스 권한을 확인하십시오."
-
 msgid "Check hostgroup associate error."
 msgstr "호스트 그룹 연관 확인 오류입니다. "
 
@@ -786,13 +727,6 @@ msgstr "Lun 그룹 연관 확인 오류
 msgid "Check portgroup associate error."
 msgstr "포트 그룹 연관 확인 오류입니다. "
 
-msgid ""
-"Check the state of the http service. Also ensure that the https port number "
-"is the same as the one specified in cinder.conf."
-msgstr ""
-"http 서비스 상태를 확인하십시오. 또한 https 포트 번호가 cinder.conf에 지정된 "
-"번호 중 하나인지도 확인하십시오."
-
 msgid "Chunk size is not multiple of block size for creating hash."
 msgstr "청크 크기가 해시 작성을 위한 블록 크기의 배수가 아닙니다. "
 
@@ -820,12 +754,6 @@ msgstr "%(id)s 클러스터가 아직 
 msgid "Cluster %(name)s already exists."
 msgstr "%(name)s(이)라는 이름을 가진 클라스터가 이미 존재합니다."
 
-msgid ""
-"Cluster is not formatted. You should probably perform \"dog cluster format\"."
-msgstr ""
-"클러스터가 형식화되지 않았습니다. \"dog 클러스터 형식화\"를 수행해야 할 수 있"
-"습니다. "
-
 #, python-format
 msgid "CommandLineHelper._wait_for_condition: %s timeout."
 msgstr "CommandLineHelper._wait_for_condition: %s 제한시간"
@@ -841,11 +769,6 @@ msgstr "계산 클러스터: %(cluster)s
 msgid "Condition has no field."
 msgstr "조건에 필드가 없습니다."
 
-#, python-format
-msgid "Config 'max_over_subscription_ratio' invalid. Must be > 0: %s"
-msgstr ""
-"구성 'max_over_subscription_ratio'가 올바르지 않습니다. 0보다 커야 함: %s"
-
 msgid "Configuration error: dell_sc_ssn not set."
 msgstr "구성 오류: dell_sc_ssn이 설정되지 않았습니다."
 
@@ -896,6 +819,10 @@ msgid "Converted to %(f1)s, but format i
 msgstr "%(f1)s(으)로 변환되었지만 이제 형식이 %(f2)s임"
 
 #, python-format
+msgid "Converted to %(vol_format)s, but format is now %(file_format)s"
+msgstr "%(vol_format)s(으)로 변환되었지만 이제 형식이 %(file_format)s임"
+
+#, python-format
 msgid "Converted to raw, but format is now %s"
 msgstr "원시로 변환되었지만 형식은 지금 %s임"
 
@@ -1262,195 +1189,6 @@ msgstr "복제를 사용으로 설정합
 msgid "Ensure that configfs is mounted at /sys/kernel/config."
 msgstr "configfs가 /sys/kernel/config에 마운트되는지 확인하십시오."
 
-#, python-format
-msgid ""
-"Error Cloning Snapshot: %(snapshot)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Clone project: %(clone_proj)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"풀: %(pool)s의 볼륨: %(lun)s에서 스냅샷: %(snapshot)s 복제 중 오류 발생 프로"
-"젝트: %(project)s 복제 프로젝트: %(clone_proj)s 리턴 코드: %(ret.status)d 메"
-"시지: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Initiator: %(initiator)s on Alias: %(alias)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"%(alias)s 별명에 %(initiator)s 개시자를 작성하는 중 오류 발생. 리턴 코드: "
-"%(ret.status)d 메시지: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"%(pool)s 풀에 %(project)s 프로젝트를 작성하는 중 오류 발생. 리턴 코드: "
-"%(ret.status)d 메시지: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Property: %(property)s Type: %(type)s Description: "
-"%(description)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"특성: %(property)s 유형: %(type)s 설명: %(description)s 작성 중 오류 발생, 리"
-"턴 코드: %(ret.status)d 메시지: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Share: %(name)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"공유 작성 중 오류 발생: %(name)s 리턴 코드: %(ret.status)d 메시지:  "
-"%(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Volume: %(lun)s Size: %(size)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"%(lun)s 볼륨(크기: %(size)s)을 작성하는 중 오류 발생. 리턴 코드: "
-"%(ret.status)d 메시지: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Share: %(share)s to Pool: %(pool)s "
-"Project: %(project)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"스냅샷: %(snapshot)s 삭제 오류, 공유: %(share)s, 대상 풀: %(pool)s 프로젝트: "
-"%(project)s 리턴 코드: %(ret.status)d 메시지:  %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Volume: %(lun)s to Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"%(pool)s 풀 %(project)s 프로젝트의 %(lun)s 볼륨에서 %(snapshot)s 스냅샷을 삭"
-"제하는 중 오류 발생. 리턴 코드: %(ret.status)d 메시지: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Volume: %(lun)s from Pool: %(pool)s, Project: %(project)s. "
-"Return code: %(ret.status)d, Message: %(ret.data)s."
-msgstr ""
-"풀: %(pool)s에서 볼륨: %(lun)s 삭제 중 오류 발생, 프로젝트: %(project)s. 리"
-"턴 코드: %(ret.status)d, 메시지: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting project: %(project)s on pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"풀: %(pool)s에서 프로젝트: %(project)s을(를) 삭제하는 중 오류 발생, 리턴 코"
-"드: %(ret.status)d 메시지: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting replication action: %(id)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"복제 조치: %(id)s 삭제 중 오류 발생, 리턴 코드: %(ret.status)d 메시지: "
-"%(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Initiators: InitiatorGroup: %(initiatorgroup)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"개시자를 가져오는 중 오류 발생: 개시자 그룹: %(initiatorgroup)s 리턴 코드:"
-"%(ret.status)d 메시지: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Pool Stats: Pool: %(pool)s Return code: %(status)d Message: "
-"%(data)s."
-msgstr ""
-"풀 통계 가져오기 오류: 풀: %(pool)s 리턴 코드: %(status)d 메시지: %(data)s."
-
-#, python-format
-msgid ""
-"Error Getting Project Stats: Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"프로젝트 통계를 가져오는 중 오류 발생: 풀: %(pool)s 프로젝트: %(project)s 리"
-"턴 코드: %(ret.status)d 메시지: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Share: %(share)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"공유 가져오기 중 오류 발생: %(share)s 풀: %(pool)s 프로젝트: %(project)s 리"
-"턴 코드: %(ret.status)d 메시지: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Volume: %(lun)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"%(pool)s 풀 %(project)s 프로젝트에서 %(lun)s 볼륨을 가져오는 중 오류 발생. 리"
-"턴 코드: %(ret.status)d 메시지: %(ret.data)s."
-
-#, python-format
-msgid "Error Pool ownership: Pool %(pool)s is not owned by %(host)s."
-msgstr "풀 소유권 오류: %(host)s에서 풀 %(pool)s을(를) 소유하지 않습니다."
-
-#, python-format
-msgid ""
-"Error Setting props Props: %(props)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"%(pool)s 풀 %(project)s 프로젝트의 %(lun)s 볼륨에서 %(props)s 특성을 가져오"
-"는 중 오류 발생. 리턴 코드: %(ret.status)d 메시지: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Initiator: %(iqn)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"%(iqn)s 개시자를 확인하는 중 오류 발생. 리턴 코드: %(ret.status)d 메시지:  "
-"%(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Pool: %(pool)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"%(pool)s 풀을 확인하는 중 오류 발생. 리턴 코드: %(ret.status)d 메시지:  "
-"%(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"%(pool)s 풀에서 %(project)s 프로젝트를 확인하는 중 오류 발생. 리턴 코드: "
-"%(ret.status)d 메시지: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"서비스 %(service)s 확인 중 오류 발생. 리턴 코드: %(ret.status)d 메시지:"
-"%(ret.data)s인 동안에는 인스턴스 연관을 변경할 수 없습니다."
-
-#, python-format
-msgid ""
-"Error Verifying Target: %(alias)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"%(alias)s 대상을 확인하는 중 오류 발생. 리턴 코드: %(ret.status)d 메시지:  "
-"%(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying share: %(share)s on Project: %(project)s and Pool: %(pool)s "
-"Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"공유 확인 중 오류 발생: %(share)s, 프로젝트: %(project)s, 풀: %(pool)s, 리턴 "
-"코드: %(ret.status)d 메시지: %(ret.data)s."
-
 msgid "Error connecting to ceph cluster."
 msgstr "ceph 클러스터 연결 중에 오류가 발생했습니다. "
 
@@ -1479,14 +1217,6 @@ msgstr "평가자 구문 분석 중 오
 
 #, python-format
 msgid ""
-"Error editing share: %(share)s on Pool: %(pool)s Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"공유 편집 중 오류 발생: %(share)s 풀: %(pool)s 리턴 코드: %(ret.status)d 메시"
-"지: %(ret.data)s."
-
-#, python-format
-msgid ""
 "Error enabling iSER for NetworkPortal: please ensure that RDMA is supported "
 "on your iSCSI port %(port)d on ip %(ip)s."
 msgstr ""
@@ -1513,55 +1243,15 @@ msgstr "볼륨 확장 중 오류 발생:
 msgid "Error finding %(name)s."
 msgstr "%(name)s을(를) 찾는 중에 오류가 발생했습니다. "
 
-msgid ""
-"Error getting appliance version details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"어플라이언스 버전 세부사항을 가져오는 중에 오류가 발생했습니다. 리턴 코드: "
-"%(ret.status)d 메시지: %(ret.data)s."
-
 #, python-format
 msgid "Error getting domain id from name %(name)s: %(id)s."
 msgstr "이름 %(name)s에서 도메인 ID를 가져오는 중에 오류 발생: %(id)s."
 
-msgid "Error getting initiator groups."
-msgstr "개시자 그룹을 가져오는 중 오류가 발생했습니다."
-
 #, python-format
 msgid "Error getting pool id from name %(pool_name)s: %(err_msg)s."
 msgstr "이름 %(pool_name)s에서 풀 ID를 가져오는 중에 오류 발생: %(err_msg)s."
 
 #, python-format
-msgid ""
-"Error getting replication action: %(id)s. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"복제 조치: %(id)s을(를) 가져오는 중에 오류가 발생했습니다. 리턴 코드: "
-"%(ret.status)d 메시지: %(ret.data)s."
-
-msgid ""
-"Error getting replication source details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"복제 소스 세부사항을 가져오는 중에 오류가 발생했습니다. 리턴 코드: %(ret."
-"status)d 메시지: %(ret.data)s."
-
-msgid ""
-"Error getting replication target details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"복제 대상 세부사항을 가져오는 중에 오류가 발생했습니다. 리턴 코드: %(ret."
-"status)d 메시지: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error getting version: svc: %(svc)s.Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"버전을 가져오는 중 오류 발생: svc: %(svc)s. 리턴 코드: %(ret.status)d 메시"
-"지:  %(ret.data)s."
-
-#, python-format
 msgid "Error in SolidFire API response: data=%(data)s"
 msgstr "SolidFire API 응답의 오류: 데이터=%(data)s"
 
@@ -1569,23 +1259,6 @@ msgstr "SolidFire API 응답의 오류:
 msgid "Error managing volume: %s."
 msgstr "볼륨 관리 중 오류 발생: %s."
 
-#, python-format
-msgid ""
-"Error modifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"서비스 수정 중 오류 발생: %(service)s 리턴 코드: %(ret.status)d 메시지:"
-"%(ret.data)s인 동안에는 인스턴스 연관을 변경할 수 없습니다."
-
-#, python-format
-msgid ""
-"Error moving volume: %(vol)s from source project: %(src)s to target project: "
-"%(tgt)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"볼륨: %(vol)s을(를) 소스 프로젝트: %(src)s에서 대상 프로젝트: %(tgt)s(으)로 "
-"이동하는 중에 오류가 발생했습니다. 리턴 코드: %(ret.status)d 메시지: "
-"%(ret.data)s."
-
 msgid "Error not a KeyError."
 msgstr "KeyError가 아닌 오류입니다."
 
@@ -1600,37 +1273,6 @@ msgid "Error retrieving volume size"
 msgstr "볼륨 크기 검색 시 오류 발생"
 
 #, python-format
-msgid ""
-"Error sending replication update for action id: %(id)s . Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"조치 id: %(id)s에 대한 복제 업데이트를 전송하는 중에 오류가 발생했습니다. 리"
-"턴 코드: %(ret.status)d 메시지: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error sending replication update. Returned error: %(err)s. Action: %(id)s."
-msgstr ""
-"복제 업데이트를 전송하는 중에 오류가 발생했습니다. 리턴된 오류: %(err)s. 조"
-"치: %(id)s."
-
-#, python-format
-msgid ""
-"Error setting replication inheritance to %(set)s for volume: %(vol)s project "
-"%(project)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"볼륨: %(vol)s 프로젝트 %(project)s에 대해 복제 상속을 %(set)s(으)로 설정하는 "
-"중에 오류 발생, 리턴 코드: %(ret.status)d 메시지: %(ret.data)s ."
-
-#, python-format
-msgid ""
-"Error severing the package: %(package)s from source: %(src)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"소스: %(src)s에서 패키지: %(package)s을(를) 제공하는 중 오류 발생, 리턴 코"
-"드: %(ret.status)d 메시지: %(ret.data)s."
-
-#, python-format
 msgid "Error while authenticating with switch: %s."
 msgstr "스위치로 인증하는 동안 오류 발생: %s."
 
@@ -1778,14 +1420,6 @@ msgid "FC is the protocol but wwpns are
 msgstr "FC는 프로토콜이지만 OpenStack에서 wwpns를 제공하지 않습니다. "
 
 #, python-format
-msgid "Faield to unassign %(volume)s"
-msgstr "%(volume)s을(를) 지정 취소하지 못함"
-
-#, python-format
-msgid "Fail to create cache volume %(volume)s. Error: %(err)s"
-msgstr "캐시 볼륨 %(volume)s을(를) 작성하지 못했습니다. 오류: %(err)s"
-
-#, python-format
 msgid "Failed adding connection for fabric=%(fabric)s: Error: %(err)s"
 msgstr "패브릭=%(fabric)s에 대한 연결 추가 실패: 오류:%(err)s"
 
@@ -1855,10 +1489,6 @@ msgid "Failed to connect to Dell REST AP
 msgstr "Dell REST API에 연결하는 데 실패"
 
 #, python-format
-msgid "Failed to connect to sheep daemon. addr: %(addr)s, port: %(port)s"
-msgstr "sheep 디먼에 연결하지 못했습니다. 주소: %(addr)s, 포트: %(port)s"
-
-#, python-format
 msgid "Failed to copy image to volume: %(reason)s"
 msgstr "볼륨에 이미지를 복사할 수 없음: %(reason)s"
 
@@ -1884,18 +1514,6 @@ msgid "Failed to create api volume flow.
 msgstr "api 볼륨 플로우 작성에 실패했습니다. "
 
 #, python-format
-msgid "Failed to create cg snapshot %(id)s due to %(reason)s."
-msgstr "%(reason)s(으)로 인해 cg 스냅샷 %(id)s을(를) 작성할 수 없습니다."
-
-#, python-format
-msgid "Failed to create consistency group %(id)s due to %(reason)s."
-msgstr "%(reason)s(으)로 인해 일관성 그룹 %(id)s을(를) 작성할 수 없습니다."
-
-#, python-format
-msgid "Failed to create consistency group %(id)s:%(ret)s."
-msgstr "일관성 그룹 %(id)s 작성 실패: %(ret)s."
-
-#, python-format
 msgid "Failed to create consistency group: %(cgid)s. Error: %(excmsg)s."
 msgstr "일관성 그룹 작성 실패: %(cgid)s. 오류: %(excmsg)s."
 
@@ -1962,14 +1580,6 @@ msgid "Failed to create volume %s"
 msgstr "%s 볼륨을 작성하지 못함 "
 
 #, python-format
-msgid "Failed to delete cgsnapshot %(id)s due to %(reason)s."
-msgstr "%(reason)s(으)로 인해 cg 스냅샷 %(id)s을(를) 삭제할 수 없습니다."
-
-#, python-format
-msgid "Failed to delete consistency group %(id)s due to %(reason)s."
-msgstr "%(reason)s(으)로 인해 일관성 그룹 %(id)s을(를) 삭제할 수 없습니다."
-
-#, python-format
 msgid ""
 "Failed to delete fileset for consistency group %(cgname)s. Error: %(excmsg)s."
 msgstr "일관성 그룹 %(cgname)s에 대한 파일 세트 삭제 실패. 오류: %(excmsg)s."
@@ -2041,10 +1651,6 @@ msgid "Failed to find host %s."
 msgstr "호스트 %s을(를) 찾지 못했습니다. "
 
 #, python-format
-msgid "Failed to find iSCSI initiator group containing %(initiator)s."
-msgstr "%(initiator)s을(를) 포함하는 iSCSI 개시자 그룹을 찾지 못했습니다."
-
-#, python-format
 msgid "Failed to get LUN target details for the LUN %s"
 msgstr "LUN %s에 대한 LUN 대상 세부사항을 가져오지 못함"
 
@@ -2152,12 +1758,6 @@ msgstr "%s 배열에 로그온하지 못
 msgid "Failed to login with all rest URLs."
 msgstr "모든 나머지 URL로 로그인하지 못했습니다. "
 
-#, python-format
-msgid ""
-"Failed to make a request to Datera cluster endpoint due to the following "
-"reason: %s"
-msgstr "다음 이유로 Datera 클러스터 엔드포인트에 요청을 작성하지 못함: %s"
-
 msgid "Failed to manage api volume flow."
 msgstr "API 볼륨 플로우를 관리하지 못했습니다. "
 
@@ -2356,32 +1956,6 @@ msgid "Failure staging LUN %s to tmp."
 msgstr "LUN %s을(를) tmp로 스테이징하지 못했습니다."
 
 #, python-format
-msgid "Fexvisor failed to add volume %(id)s due to %(reason)s."
-msgstr ""
-"%(reason)s(으)로 인해 Fexvisor에서 볼륨 %(id)s을(를) 추가하지 못했습니다."
-
-#, python-format
-msgid ""
-"Fexvisor failed to join the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr ""
-"%(ret)s(으)로 인해 Fexvisor가 그룹 %(group)s에서 볼륨 %(vol)s을(를) 결합하지 "
-"못했습니다. "
-
-#, python-format
-msgid ""
-"Fexvisor failed to remove the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr ""
-"%(ret)s(으)로 인해 Fexvisor가 그룹 %(group)s에서 볼륨 %(vol)s을(를) 제거하지 "
-"못했습니다. "
-
-#, python-format
-msgid "Fexvisor failed to remove volume %(id)s due to %(reason)s."
-msgstr ""
-"%(reason)s(으)로 인해 Fexvisor가 볼륨 %(id)s을(를) 제거하지 못했습니다. "
-
-#, python-format
 msgid "Fibre Channel SAN Lookup failure: %(reason)s"
 msgstr "파이버 채널 SAN 검색 실패: %(reason)s"
 
@@ -2398,10 +1972,6 @@ msgid "File %(file_path)s could not be f
 msgstr "%(file_path)s 파일을 찾을 수 없습니다. "
 
 #, python-format
-msgid "File already exists at %s."
-msgstr "%s에 파일이 이미 있습니다. "
-
-#, python-format
 msgid "File already exists at: %s"
 msgstr "%s에 파일이 이미 있음"
 
@@ -2435,166 +2005,6 @@ msgstr ""
 "(가) 설치되어 있어야 합니다. "
 
 #, python-format
-msgid "Flexvisor assign volume failed.:%(id)s:%(status)s."
-msgstr "Flexvisor 볼륨 지정 실패:%(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor assign volume failed:%(id)s:%(status)s."
-msgstr "Flexvisor 볼륨 지정 실패:%(id)s:%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor could not find volume %(id)s snapshot in the group %(vgid)s "
-"snapshot %(vgsid)s."
-msgstr ""
-"Flexvisor에서 볼륨 %(id)s 스냅샷을 그룹 %(vgid)s 스냅샷 %(vgsid)s에서 찾을 "
-"수 없습니다."
-
-#, python-format
-msgid "Flexvisor create volume failed.:%(volumeid)s:%(status)s."
-msgstr "Flexvisor 볼륨 작성 실패:%(volumeid)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor failed deleting volume %(id)s: %(status)s."
-msgstr "Flexvisor가 %(id)s 볼륨을 삭제하지 못함: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to add volume %(id)s to group %(cgid)s."
-msgstr "Flexvisor에서 볼륨 %(id)s을(를) 그룹 %(cgid)s에 추가하지 못했습니다."
-
-#, python-format
-msgid ""
-"Flexvisor failed to assign volume %(id)s due to unable to query status by "
-"event id."
-msgstr ""
-"이벤트 ID로 상태를 조회할 수 없어 Flexvisor가 %(id)s 볼륨을 지정하지 못했습니"
-"다."
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(id)s: %(status)s."
-msgstr "Flexvisor가 %(id)s 볼륨을 지정하지 못함: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(volume)s iqn %(iqn)s."
-msgstr "Flexvisor에서 볼륨 %(volume)s에 iqn %(iqn)s을(를) 지정하지 못했습니다."
-
-#, python-format
-msgid "Flexvisor failed to clone volume %(id)s: %(status)s."
-msgstr "Flexvisor가 %(id)s 볼륨을 복제하지 못함: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to clone volume (failed to get event) %(id)s."
-msgstr "Flexvisor가 %(id)s 볼륨을 복제하지(이벤트를 가져오지) 못했습니다."
-
-#, python-format
-msgid "Flexvisor failed to create snapshot for volume %(id)s: %(status)s."
-msgstr "Flexvisor가 %(id)s 볼륨의 스냅샷을 작성하지 못함: %(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to create snapshot for volume (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor가 %(id)s 볼륨의 스냅샷을 작성하지(이벤트를 가져오지) 못했습니다."
-
-#, python-format
-msgid "Flexvisor failed to create volume %(id)s in the group %(vgid)s."
-msgstr "Flexvisor에서 볼륨 %(id)s을(를) 그룹 %(vgid)s에 작성하지 못했습니다."
-
-#, python-format
-msgid "Flexvisor failed to create volume %(volume)s: %(status)s."
-msgstr "Flexvisor가 %(volume)s 볼륨을 작성하지 못함: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume (get event) %s."
-msgstr "Flexvisor가 %s 볼륨을 작성하지(이벤트를 가져오지) 못했습니다."
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s: %(status)s."
-msgstr "Flexvisor가 %(id)s 스냅샷에서 볼륨을 작성하지 못함: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s:%(status)s."
-msgstr "Flexvisor가 %(id)s 스냅샷에서 볼륨을 작성하지 못함: %(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to create volume from snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor가 %(id)s 스냅샷에서 볼륨을 작성하지(이벤트를 가져오지) 못했습니다."
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot %(id)s: %(status)s."
-msgstr "Flexvisor가 %(id)s 스냅샷을 삭제하지 못함: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot (failed to get event) %(id)s."
-msgstr "Flexvisor가 %(id)s 스냅샷을 삭제하지(이벤트를 가져오지) 못했습니다."
-
-#, python-format
-msgid "Flexvisor failed to delete volume %(id)s: %(status)s."
-msgstr "Flexvisor가 %(id)s 볼륨을 삭제하지 못함: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s: %(status)s."
-msgstr "Flexvisor가 %(id)s 볼륨을 확장하지 못함: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s:%(status)s."
-msgstr "Flexvisor가 %(id)s 볼륨을 확장하지 못함: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume (failed to get event) %(id)s."
-msgstr "Flexvisor가 %(id)s 볼륨을 확장하지(이벤트를 가져오지) 못했습니다."
-
-#, python-format
-msgid "Flexvisor failed to get pool info %(id)s: %(status)s."
-msgstr "Flexvisor가 풀 정보 %(id)s을(를) 가져오지 못함: %(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to get snapshot id of volume %(id)s from group %(vgid)s."
-msgstr ""
-"Flexvisor가 그룹 %(vgid)s에서 볼륨 %(id)s의 스냅샷 ID를 가져오지 못했습니다."
-
-#, python-format
-msgid "Flexvisor failed to remove volume %(id)s from group %(cgid)s."
-msgstr "Flexvisor가 그룹 %(cgid)s에서 볼륨 %(id)s을(를) 제거하지 못했습니다. "
-
-#, python-format
-msgid "Flexvisor failed to spawn volume from snapshot %(id)s:%(status)s."
-msgstr "Flexvisor가 %(id)s 스냅샷에서 볼륨을 파생하지 못함: %(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to spawn volume from snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor가 %(id)s 스냅샷에서 볼륨을 파생하지(이벤트를 가져오지) 못했습니다."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume %(id)s: %(status)s."
-msgstr "Flexvisor가 %(id)s 볼륨을 지정 취소하지 못함: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume (get event) %(id)s."
-msgstr "Flexvisor가 %(id)s 볼륨을 지정 취소하지(이벤트를 가져오지) 못했습니다."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume:%(id)s:%(status)s."
-msgstr "Flexvisor에서 볼륨 %(id)s을(를) 지정 취소하지 못함: %(status)s."
-
-#, python-format
-msgid "Flexvisor unable to find the source volume %(id)s info."
-msgstr "Flexvisor에서 소스 볼륨 %(id)s 정보를 찾을 수 없습니다."
-
-#, python-format
-msgid "Flexvisor unassign volume failed:%(id)s:%(status)s."
-msgstr "Flexvisor 볼륨 지정 취소 실패:%(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor volume %(id)s failed to join group %(vgid)s."
-msgstr "Flexvisor 볼륨 %(id)s에서 그룹 %(vgid)s을(를) 결합하지 못했습니다."
-
-#, python-format
 msgid "Folder %s does not exist in Nexenta Store appliance"
 msgstr "폴더 %s이(가) Nexenta Store 어플라이언스에 없음"
 
@@ -2959,14 +2369,6 @@ msgid "Invalid Replication Target: %(rea
 msgstr "올바르지 않은 복제 대상: %(reason)s"
 
 #, python-format
-msgid ""
-"Invalid Virtuozzo Storage share specification: %r. Must be: [MDS1[,"
-"MDS2],...:/]<CLUSTER NAME>[:PASSWORD]."
-msgstr ""
-"올바르지 않은 Virtuozzo 스토리지 공유 스펙: %r. 다음이어야 함: [MDS1[,"
-"MDS2],...:/]<CLUSTER NAME>[:PASSWORD]."
-
-#, python-format
 msgid "Invalid XtremIO version %(cur)s, version %(min)s or up is required"
 msgstr "올바르지 않은 XtremIO 버전 %(cur)s, %(min)s 이상의 버전이 필요함"
 
@@ -2974,13 +2376,6 @@ msgstr "올바르지 않은 XtremIO 버
 msgid "Invalid allocated quotas defined for the following project quotas: %s"
 msgstr "다음 프로젝트 할당량에 잘못 할당된 할당량이 정의됨 : %s"
 
-msgid "Invalid argument - negative seek offset."
-msgstr "올바르지 않은 인수 - 음수 찾기 오프셋. "
-
-#, python-format
-msgid "Invalid argument - whence=%s not supported."
-msgstr "올바르지 않은 인수 - whence=%s은(는) 지원되지 않습니다. "
-
 #, python-format
 msgid "Invalid attaching mode '%(mode)s' for volume %(volume_id)s."
 msgstr "볼륨 %(volume_id)s의  연결 모드 '%(mode)s'가 잘못 되었습니다."
@@ -2994,15 +2389,6 @@ msgid "Invalid backup: %(reason)s"
 msgstr "올바르지 않은 백업: %(reason)s"
 
 #, python-format
-msgid "Invalid connection initialization response of volume %(name)s"
-msgstr "볼륨 %(name)s의 올바르지 않은 연결 초기화 응답"
-
-#, python-format
-msgid ""
-"Invalid connection initialization response of volume %(name)s: %(output)s"
-msgstr "볼륨 %(name)s의 올바르지 않은 연결 초기화 응답: %(output)s"
-
-#, python-format
 msgid "Invalid content type %(content_type)s."
 msgstr "올바르지 않은 컨텐츠 유형 %(content_type)s."
 
@@ -3100,10 +2486,6 @@ msgid "Invalid mount point base: %s"
 msgstr "올바르지 않은 마운트 지점 기반: %s"
 
 #, python-format
-msgid "Invalid mount point base: %s."
-msgstr "올바르지 않은 마운트 지점 기반: %s."
-
-#, python-format
 msgid "Invalid new snapCPG name for retype.  new_snap_cpg='%s'."
 msgstr ""
 "새 snapCPG 이름이 재입력을 수행하기에 올바르지 않습니다. new_snap_cpg='%s'."
@@ -3123,9 +2505,6 @@ msgstr "올바르지 않은 보조 id %s
 msgid "Invalid service catalog json."
 msgstr "올바르지 않은 서비스 카탈로그 json입니다. "
 
-msgid "Invalid sheepdog cluster status."
-msgstr "Sheepdog 클러스터 상태가 올바르지 않습니다. "
-
 #, python-format
 msgid "Invalid snapshot: %(reason)s"
 msgstr "잘못된 스냅샷: %(reason)s"
@@ -3208,10 +2587,6 @@ msgstr ""
 "올바르지 않은 volume_type이 제공됨: %s(이 일관성 그룹이 요청된 유형을지원해"
 "야 함)."
 
-#, python-format
-msgid "Invalid wwpns format %(wwpns)s"
-msgstr "올바르지 않은 wwpn 형식 %(wwpns)s"
-
 msgid "Issue encountered waiting for job."
 msgstr "작업 대기 중에 문제가 발생했습니다."
 
@@ -3222,10 +2597,6 @@ msgid ""
 "Issuing a fail-over failed because replication is not properly configured."
 msgstr "복제가 적절하게 구성되지 않았으므로 장애 복구 실행에 실패했습니다."
 
-#, python-format
-msgid "KeyError: %s"
-msgstr "KeyError: %s"
-
 msgid "Keystone version 3 or greater must be used to get nested quota support."
 msgstr "중첩 할당량 지원을 받기 위해 Keystone 버전 3 이상을 사용해야 합니다."
 
@@ -3523,9 +2894,6 @@ msgstr ""
 msgid "New volume type not specified in request_spec."
 msgstr "새 볼륨 유형이 request_spec에서 지정되지 않았습니다."
 
-msgid "Nimble Cinder Driver exception"
-msgstr "Nimble Cinder 드라이버 예외"
-
 msgid "No FC initiator can be added to host."
 msgstr "FC 개시자를 호스트에 추가할 수 없습니다."
 
@@ -3563,10 +2931,6 @@ msgid "No initiator connected to fabric.
 msgstr "개시자가 패브릭에 연결되지 않았습니다."
 
 #, python-format
-msgid "No initiator group found for initiator %s"
-msgstr "%s 개시자의 개시자 그룹을 찾을 수 없음"
-
-#, python-format
 msgid "No interface found on cluster for ip %s"
 msgstr "ip %s에 대한 클러스터에서 인터페이스를 찾을 수 없음"
 
@@ -3579,9 +2943,6 @@ msgstr "마운트된 NFS 공유를 찾
 msgid "No mounted SMBFS shares found."
 msgstr "마운트된 SMBFS 공유를 찾을 수 없습니다."
 
-msgid "No mounted Virtuozzo Storage shares found"
-msgstr "마운트된 Virtuozzo 스토리지 공유를 찾을 수 없습니다. "
-
 msgid "No mounted shares found"
 msgstr "마운트된 공유를 찾을 수 없음"
 
@@ -3608,9 +2969,6 @@ msgstr "%(volume_id)s 볼륨에 대한 
 msgid "No such QoS spec %(specs_id)s."
 msgstr "해당하는 QoS 스펙 %(specs_id)s이(가) 없습니다. "
 
-msgid "No suitable discovery ip found"
-msgstr "적합한 발견 ip를 찾을 수 없음"
-
 #, python-format
 msgid "No support to restore backup version %s"
 msgstr "백업 버전 %s 복원을 지원하지 않음"
@@ -3650,9 +3008,6 @@ msgstr "권한이 없습니다. "
 msgid "Not enough space on backend (%(backend)s)"
 msgstr "백엔드(%(backend)s)에 공간이 충분하지 않음"
 
-msgid "Not enough storage space in the ZFS share to perform this operation."
-msgstr "ZFS 공유에서 이 조작을 수행하는 데 필요한 스토리지 공간이 부족합니다."
-
 msgid "Not stored in rbd"
 msgstr "rbd에 저장되지 않음"
 
@@ -3686,9 +3041,6 @@ msgstr ""
 "직속 상위 또는 루트 프로젝트로 범위가 지정된 토큰을 가진 사용자만 하위 할당량"
 "을 볼 수 있습니다. "
 
-msgid "Only volumes managed by OpenStack can be unmanaged."
-msgstr "OpenStack에서 관리하는 볼류만 관리를 취소할 수 있습니다."
-
 #, python-format
 msgid "Operation failed with status=%(status)s. Full dump: %(data)s"
 msgstr "조작이 상태=%(status)s과(와) 함께 실패했습니다. 전체 덤프: %(data)s"
@@ -3732,9 +3084,6 @@ msgstr "정책이 %(action)s이(가) 수
 msgid "Pool is not available in the volume host field."
 msgstr "볼륨 호스트 필드에서 풀을 사용할 수 없습니다."
 
-msgid "Pool is not available in the volume host fields."
-msgstr "볼륨 호스트 필드에서 풀을 사용할 수 없습니다."
-
 #, python-format
 msgid "Pool with name %(pool_name)s wasn't found in domain %(domain_id)s."
 msgstr ""
@@ -3876,13 +3225,6 @@ msgstr "참조에는 source-name 또는
 msgid "Reference must contain source-name."
 msgstr "참조에는 source-name이 포함되어야 합니다. "
 
-msgid "Reference to volume to be managed must contain source-name."
-msgstr "관리할 볼륨에 대한 참조에 source-name이 포함되어야 합니다."
-
-#, python-format
-msgid "Reference to volume: %s to be managed must contain source-name."
-msgstr "관리할 볼륨: %s에 대한 참조에 source-name이 포함되어야 합니다."
-
 #, python-format
 msgid ""
 "Refusing to migrate volume ID: %(id)s. Please check your configuration "
@@ -3944,11 +3286,6 @@ msgid "Request body contains too many it
 msgstr "요청 본문에 너무 많은 항목이 들어있음"
 
 #, python-format
-msgid "Request to Datera cluster returned bad status: %(status)s | %(reason)s"
-msgstr ""
-"Datera 클러스터에 대한 요청이 잘못된 상태를 리턴함: %(status)s | %(reason)s"
-
-#, python-format
 msgid ""
 "Requested backup exceeds allowed Backup gigabytes quota. Requested "
 "%(requested)sG, quota is %(quota)sG and %(consumed)sG has been consumed."
@@ -4068,12 +3405,6 @@ msgid "SMBFS config file not set (smbfs_
 msgstr "SMBFS 구성 파일이 설정되지 않았습니다(smbfs_shares_config)."
 
 #, python-format
-msgid "SSH Command failed after '%(total_attempts)r' attempts : '%(command)s'"
-msgstr ""
-"'%(command)s' 명령을 '%(total_attempts)r'번 시도한 후에 SSH 명령이 실패했습니"
-"다. "
-
-#, python-format
 msgid "SSH command injection detected: %(command)s"
 msgstr "SSH 명령 인젝션 발견됨: %(command)s"
 
@@ -4115,10 +3446,6 @@ msgstr "쌍 보조 액세스 설정 오
 msgid "Sets thin provisioning."
 msgstr "씬 프로비저닝을 설정합니다. "
 
-#, python-format
-msgid "Sheepdog I/O Error, command was: \"%s\"."
-msgstr "Sheepdog I/O 오류, 명령: \"%s\"."
-
 msgid ""
 "Show operations can only be made to projects in the same hierarchy of the "
 "project in which users are scoped to."
@@ -4309,14 +3636,6 @@ msgstr ""
 "GPFS 파일 시스템 %(fs)s이(가) 필수 릴리스 레벨이 아닙니다. 현재 레벨은 "
 "%(cur)s이고, 최소 %(min)s이어야 합니다. "
 
-#, python-format
-msgid ""
-"The WebDAV request failed. Reason: %(msg)s, Return code/reason: %(code)s, "
-"Source Volume: %(src)s, Destination Volume: %(dst)s, Method: %(method)s."
-msgstr ""
-"WebDAV 요청 실패. 이유: %(msg)s, 리턴 코드/이유: %(code)s,소스 볼륨: "
-"%(src)s, 대상 볼륨: %(dst)s, 메소드: %(method)s."
-
 msgid ""
 "The above error may show that the database has not been created.\n"
 "Please create a database using 'cinder-manage db sync' before running this "
@@ -4399,9 +3718,6 @@ msgstr "볼륨이 유지보수 모드에
 msgid "The snapshot is unavailable: %(data)s"
 msgstr "스냅샷 사용 불가: %(data)s"
 
-msgid "The source volume for this WebDAV operation not found."
-msgstr "이 WebDAV 조작의 소스 볼륨을 찾을 수 없습니다."
-
 #, python-format
 msgid ""
 "The source volume type '%(src)s' is different than the destination volume "
@@ -4594,10 +3910,6 @@ msgid "Type cannot be converted into NaE
 msgstr "유형을 NaElement로 변환할 수 없습니다."
 
 #, python-format
-msgid "TypeError: %s"
-msgstr "TypeError: %s"
-
-#, python-format
 msgid "UUIDs %s are in both add and remove volume list."
 msgstr "UUID %s이(가) 추가 및 제거 볼륨 목록에 있습니다. "
 
@@ -4845,9 +4157,6 @@ msgstr ""
 "예상치 못한 결과입니다. [%(expected)s]을(를) 예상했지만 [%(output)s]을(를) 수"
 "신했습니다."
 
-msgid "Unexpected response from Nimble API"
-msgstr "Nimble API로부터의 예기치 않은 응답"
-
 msgid "Unexpected status code"
 msgstr "예기치 않은 상태 코드"
 
@@ -4868,39 +4177,10 @@ msgstr "알 수 없는 RemoteFS 예외"
 msgid "Unknown SMBFS exception."
 msgstr "알 수 없는 SMBFS 예외입니다."
 
-msgid "Unknown Virtuozzo Storage exception"
-msgstr "알 수 없는 Virtuozzo 스토리지 예외"
-
 msgid "Unknown action"
 msgstr "알 수 없는 조치"
 
 #, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, Set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"관리할 볼륨: %s이(가) 이미 Cinder에서 관리 중인지 알 수 없습니다. 볼륨 관리"
-"를 중단합니다. 'cinder_managed' 사용자 지정 스키마 특성을 볼륨에 추가하고 값"
-"을 False로 설정합니다. 또는 cinder 구성 정책 'zfssa_manage_policy'의 값을 "
-"'loose'로 설정하여 이 제한을 제거하십시오."
-
-#, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"관리할 볼륨: %s이(가) 이미 Cinder에서 관리 중인지 알 수 없습니다. 볼륨 관리"
-"를 중단합니다. 'cinder_managed' 사용자 지정 스키마 특성을 볼륨에 추가하고 값"
-"을 False로 설정합니다. 또는 cinder 구성 정책 'zfssa_manage_policy'의 값을 "
-"'loose'로 설정하여 이 제한을 제거하십시오."
-
-#, python-format
 msgid "Unknown or unsupported command %(cmd)s"
 msgstr "알 수 없거나 지원되지 않는 명령 %(cmd)s"
 
@@ -5005,9 +4285,6 @@ msgstr "사용자 ID"
 msgid "User does not have admin privileges"
 msgstr "사용자에게 관리자 권한이 없습니다"
 
-msgid "User not authorized to perform WebDAV operations."
-msgstr "사용자에게 WebDAV 조작을 수행할 권한이 없습니다."
-
 msgid "UserName is not configured."
 msgstr "UserName이 구성되지 않았습니다."
 
@@ -5035,10 +4312,6 @@ msgid ""
 msgstr "값 \"%(value)s\"이(가) 구성 옵션 \"%(option)s\"에 대해 올바르지 않음"
 
 #, python-format
-msgid "ValueError: %s"
-msgstr "ValueError: %s"
-
-#, python-format
 msgid "Vdisk %(name)s not involved in mapping %(src)s -> %(tgt)s."
 msgstr "Vdisk %(name)s이(가) 맵핑 %(src)s -> %(tgt)s에 포함되지 않았습니다. "
 
@@ -5136,25 +4409,10 @@ msgid "Volume %s does not exist on the a
 msgstr "배열에 %s 볼륨이 없습니다."
 
 #, python-format
-msgid "Volume %s does not have provider_location specified, skipping."
-msgstr "%s 볼륨에 지정된 provider_location이 없습니다. 건너뜁니다."
-
-#, python-format
 msgid "Volume %s doesn't exist on array."
 msgstr "배열에 %s 볼륨이 없습니다."
 
 #, python-format
-msgid "Volume %s doesn't exist on the ZFSSA backend."
-msgstr "ZFSSA 백엔드에 %s 볼륨이 없습니다."
-
-#, python-format
-msgid ""
-"Volume %s is online. Set volume to offline for managing using OpenStack."
-msgstr ""
-"볼륨 %s이(가) 온라인입니다. OpenStack을 사용하여 관리할 볼륨을 오프라인으로 "
-"설정합니다."
-
-#, python-format
 msgid "Volume %s must not be part of a consistency group."
 msgstr "볼륨 %s이(가) 일관성 그룹의 일부가 아니어야 합니다. "
 
@@ -5297,9 +4555,6 @@ msgstr "볼륨을 아직 호스트에 
 msgid "Volume replication for %(volume_id)s could not be found."
 msgstr "%(volume_id)s의 볼륨 복제를 찾을 수 없습니다. "
 
-msgid "Volume should have agent-type set as None."
-msgstr "볼륨의 에이전트 유형은 None으로 설정되어야 합니다. "
-
 #, python-format
 msgid ""
 "Volume size %(volume_size)sGB cannot be smaller than the image minDisk size "
@@ -5338,9 +4593,6 @@ msgstr "볼륨 크기는 1GB의 배수
 msgid "Volume size must multiple of 1 GB."
 msgstr "볼륨 크기는 1GB의 배수여야 합니다. "
 
-msgid "Volume status must be 'available'."
-msgstr "볼륨 상태가 '사용 가능'이어야 합니다. "
-
 msgid "Volume to Initiator Group mapping already exists"
 msgstr "개시자 그룹에 대한 볼륨 맵핑이 이미 있음"
 
@@ -5397,35 +4649,14 @@ msgstr "이름이 %(volume_type_name)s
 msgid "Volume type's availability zones are invalid %(az)s."
 msgstr "볼륨 타입의 가용 영역들이 올바르지 않은 %(az)s입니다. "
 
-#, python-format
-msgid "Volume: %s is already being managed by Cinder."
-msgstr "Cinder에서 이미 볼륨: %s을(를) 관리 중입니다."
-
 msgid ""
 "Volumes/account exceeded on both primary and secondary SolidFire accounts."
 msgstr "기본 및 보조 SolidFire 계정 모두에서 볼륨/계정이 초과되었습니다."
 
 #, python-format
-msgid ""
-"VzStorage config 'vzstorage_used_ratio' invalid. Must be > 0 and <= 1.0: %s."
-msgstr ""
-"VzStorage 구성 'vzstorage_used_ratio'가 올바르지 않습니다. 0보다 크고 1.0 이"
-"하여야 함: %s."
-
-#, python-format
-msgid "VzStorage config file at %(config)s doesn't exist."
-msgstr "%(config)s의 VzStorage 구성 파일이 존재하지 않습니다. "
-
-#, python-format
 msgid "Wait synchronize failed. Running status: %s."
 msgstr "동기화 대기 실패. 실행 상태: %s."
 
-msgid ""
-"Waiting for all nodes to join cluster. Ensure all sheep daemons are running."
-msgstr ""
-"모든 노드가 클러스터를 결합할 때까지 기다리는 중입니다. 모든 sheep 디먼이 실"
-"행 중인지 확인하십시오. "
-
 msgid "We should not do switch over on primary array."
 msgstr "기본 배열로 전환할 수 없습니다."
 
@@ -6141,9 +5372,6 @@ msgstr "extend_volume, volumename: %(vol
 msgid "fake"
 msgstr "fake"
 
-msgid "fileno is not supported by SheepdogIOWrapper"
-msgstr "SheepdogIOWrapper는 fileno를 지원하지 않음"
-
 #, python-format
 msgid "fmt=%(fmt)s backed by: %(backing_file)s"
 msgstr "fmt=%(fmt)s 백업: %(backing_file)s"
@@ -6192,13 +5420,6 @@ msgstr ""
 "gpfs_images_share_mode가 copy_on_write로 설정되었지만 %(vol)s과(와) %(img)s은"
 "(는)다른 파일 세트에 속합니다."
 
-msgid ""
-"http service may have been abruptly disabled or put to maintenance state in "
-"the middle of this operation."
-msgstr ""
-"http 서비스가 갑자기 사용 안함으로 설정되었거나 이 조작을 수행하는 중에 유지"
-"보수 상태로 변경된 경우일 수 있습니다."
-
 msgid "id cannot be None"
 msgstr "id는 None일 수 없음"
 
@@ -6484,11 +5705,3 @@ msgstr "볼륨이 지정됨"
 
 msgid "volumes changed"
 msgstr "볼륨이 변경됨"
-
-#, python-format
-msgid ""
-"zfssa_manage_policy property needs to be set to 'strict' or 'loose'. Current "
-"value is: %s."
-msgstr ""
-"zfssa_manage_policy 특성을 'strict' 또는 'loose'로 설정해야 합니다. 현재 값: "
-"%s."
diff -pruN 2:15.0.1-1/cinder/locale/pt_BR/LC_MESSAGES/cinder.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/pt_BR/LC_MESSAGES/cinder.po
--- 2:15.0.1-1/cinder/locale/pt_BR/LC_MESSAGES/cinder.po	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/pt_BR/LC_MESSAGES/cinder.po	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: cinder VERSION\n"
 "Report-Msgid-Bugs-To: https://bugs.launchpad.net/openstack-i18n/\n"
-"POT-Creation-Date: 2019-10-04 05:27+0000\n"
+"POT-Creation-Date: 2020-03-18 14:40+0000\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
@@ -112,12 +112,6 @@ msgstr ""
 "%(vol_mode)s."
 
 #, python-format
-msgid "%(service)s Service is not %(status)s on storage appliance: %(host)s"
-msgstr ""
-"O Serviço %(service)s não é %(status)s no dispositivo de armazenamento: "
-"%(host)s"
-
-#, python-format
 msgid ""
 "%(worker_name)s value of %(workers)d is invalid, must be greater than 0."
 msgstr "Valor %(worker_name)s de %(workers)d é inválido, deve ser maior que 0."
@@ -164,10 +158,6 @@ msgid "%s is not installed"
 msgstr "%s não está instalado"
 
 #, python-format
-msgid "%s is not installed."
-msgstr "%s não está instalado."
-
-#, python-format
 msgid "%s is not set"
 msgstr "%s não está configurado"
 
@@ -190,10 +180,6 @@ msgid "%s must be an absolute path."
 msgstr "%s deve ser um caminho absoluto."
 
 #, python-format
-msgid "%s not set in cinder.conf"
-msgstr "%s não configurado em cinder.conf"
-
-#, python-format
 msgid "%s not set."
 msgstr "%s não definido."
 
@@ -214,14 +200,6 @@ msgstr "'consistencygroup_id' deve ser e
 msgid "'qemu-img info' parsing failed."
 msgstr "Falha na análise de 'qemu-img info'."
 
-#, python-format
-msgid ""
-"(Command: %(cmd)s) (Return Code: %(exit_code)s) (Stdout: %(stdout)s) "
-"(Stderr: %(stderr)s)"
-msgstr ""
-"(Comando: %(cmd)s) (Código de Retorno: %(exit_code)s) (Saída padrão: "
-"%(stdout)s) (Erro padrão: %(stderr)s)"
-
 msgid "A concurrent, possibly contradictory, request has been made."
 msgstr "Foi feita uma solicitação atual possivelmente contraditória."
 
@@ -311,14 +289,6 @@ msgstr ""
 "%(luncopyname)s. O status de LUNcopy: %(luncopystatus)s. Estado de LUNcopy: "
 "%(luncopystate)s."
 
-#, python-format
-msgid "An error occurred while reading volume \"%s\"."
-msgstr "Ocorreu um erro ao ler o volume \"%s\"."
-
-#, python-format
-msgid "An error occurred while writing to volume \"%s\"."
-msgstr "Ocorreu um erro ao gravar no volume \"%s\"."
-
 msgid "An unknown exception occurred."
 msgstr "Ocorreu uma exceção desconhecida."
 
@@ -389,9 +359,6 @@ msgstr "Categorias disponíveis:"
 msgid "Backend doesn't exist (%(backend)s)"
 msgstr "Backend não existe (%(backend)s)"
 
-msgid "Backend storage did not configure fiber channel target."
-msgstr "Armazenamento de backend não configurou o destino do Fiber Channel."
-
 msgid "Backing up an in-use volume must use the force flag."
 msgstr "O backup de um volume em uso deve usar a sinalização de força."
 
@@ -500,10 +467,6 @@ msgstr ""
 msgid "CPG (%s) doesn't exist on array"
 msgstr "CPG (%s) não existe na matriz"
 
-#, python-format
-msgid "Cache volume %s does not have required properties"
-msgstr "O volume de cache %s não possui as propriedades necessárias. "
-
 msgid "Can not add FC port to host."
 msgstr "Não é possível incluir a porta FC no host."
 
@@ -639,10 +602,6 @@ msgstr ""
 "Não é possível alterar o contexto do VF porque o VF especificado não está "
 "disponível na lista de VFs gerenciáveis %(vf_list)s."
 
-#, python-format
-msgid "Cannot create directory %s."
-msgstr "Não é possível criar o diretório %s."
-
 msgid "Cannot create encryption specs. Volume type in use."
 msgstr ""
 "Não foi possível criar especificações de criptografia. Tipo de volume em uso."
@@ -664,24 +623,6 @@ msgstr ""
 "Não é possível criar o volume_type com o nome %(name)s e as especificações "
 "%(extra_specs)s"
 
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)d volume instances."
-msgstr ""
-"Não é possível excluir o volume de cache: %(cachevol_name)s. Ele foi "
-"atualizado em %(updated_at)s e atualmente tem %(numclones)d instâncias de "
-"volume."
-
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)s volume instances."
-msgstr ""
-"Não é possível excluir o volume de cache: %(cachevol_name)s. Ele foi "
-"atualizado em %(updated_at)s e atualmente tem %(numclones)s instâncias de "
-"volume."
-
 msgid "Cannot delete encryption specs. Volume type in use."
 msgstr ""
 "Não é possível excluir especificações de criptografia. Tipo de volume em uso."
@@ -748,11 +689,6 @@ msgid ""
 "Change would make usage less than 0 for the following resources: %(unders)s"
 msgstr "A mudança usaria menos de 0 para os recursos a seguir: %(unders)s"
 
-msgid "Check access permissions for the ZFS share assigned to this driver."
-msgstr ""
-"Verifique as permissões de acesso para o compartilhamento do ZFS designado a "
-"este driver."
-
 msgid "Check hostgroup associate error."
 msgstr "Verifique o erro de associação ao grupo de hosts."
 
@@ -768,13 +704,6 @@ msgstr "Verifique o erro de associação
 msgid "Check portgroup associate error."
 msgstr "Verifique o erro de associação ao grupo de portas."
 
-msgid ""
-"Check the state of the http service. Also ensure that the https port number "
-"is the same as the one specified in cinder.conf."
-msgstr ""
-"Verifique o estado do serviço http. Além disso, assegure-se de que o número "
-"da porta https seja o mesmo que o especificado em cinder.conf."
-
 msgid "Chunk size is not multiple of block size for creating hash."
 msgstr ""
 "O tamanho do chunk não é múltiplo do tamanho de bloco para criar o hash."
@@ -791,12 +720,6 @@ msgstr ""
 "O tipo de clone '%(clone_type)s' é inválido; os valores válidos são: "
 "'%(full_clone)s' e '%(linked_clone)s'."
 
-msgid ""
-"Cluster is not formatted. You should probably perform \"dog cluster format\"."
-msgstr ""
-"O cluster não está formatado. É provável que seja necessário executar \"dog "
-"cluster format\"."
-
 #, python-format
 msgid "CommandLineHelper._wait_for_condition: %s timeout."
 msgstr "CommandLineHelper._wait_for_condition: tempo limite de %s."
@@ -813,11 +736,6 @@ msgstr "Cluster de cálculo: %(cluster)s
 msgid "Condition has no field."
 msgstr "A condição não possui campo."
 
-#, python-format
-msgid "Config 'max_over_subscription_ratio' invalid. Must be > 0: %s"
-msgstr ""
-"Configuração de 'max_over_subscription_ratio' inválida. Deve ser > 0: %s"
-
 msgid "Configuration error: dell_sc_ssn not set."
 msgstr "Erro de configuração: dell_sc_ssn não configurado."
 
@@ -869,6 +787,10 @@ msgid "Converted to %(f1)s, but format i
 msgstr "Convertido em %(f1)s, mas o formato agora é %(f2)s"
 
 #, python-format
+msgid "Converted to %(vol_format)s, but format is now %(file_format)s"
+msgstr "Convertido em %(vol_format)s, mas o formato agora é %(file_format)s"
+
+#, python-format
 msgid "Converted to raw, but format is now %s"
 msgstr "Convertido em bruto, mas o formato é agora %s"
 
@@ -1256,201 +1178,6 @@ msgstr "Permite replicação."
 msgid "Ensure that configfs is mounted at /sys/kernel/config."
 msgstr "Assegure-se de que configfs esteja montado em /sys/kernel/config."
 
-#, python-format
-msgid ""
-"Error Cloning Snapshot: %(snapshot)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Clone project: %(clone_proj)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erro Clonando Captura Instantânea: %(snapshot)s no Volume: %(lun)s de "
-"Conjunto: %(pool)s Projeto: %(project)s Projeto clone: %(clone_proj)s Código "
-"de retorno: %(ret.status)d Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Initiator: %(initiator)s on Alias: %(alias)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Erro ao Criar Inicializador: %(initiator)s em Alias: %(alias)s Código de "
-"retorno: %(ret.status)d Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Erro ao Criar Projeto: %(project)s no Conjunto: %(pool)s Código de retorno: "
-"%(ret.status)d Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Property: %(property)s Type: %(type)s Description: "
-"%(description)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erro ao criar propriedade: %(property)s Tipo: %(type)s Descrição: "
-"%(description)s Código de retorno: %(ret.status)d Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Share: %(name)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Erro ao Criar Compartilhamento: %(name)s Código de retorno: %(ret.status)d "
-"Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Volume: %(lun)s Size: %(size)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"Erro ao Criar Volume: %(lun)s Tamanho: %(size)s Código de retorno: "
-"%(ret.status)d Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Share: %(share)s to Pool: %(pool)s "
-"Project: %(project)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erro ao Excluir Captura Instantânea: %(snapshot)s no Compartilhamento: "
-"%(share)s para Conjunto: %(pool)s Projeto: %(project)s  Código de retorno: "
-"%(ret.status)d Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Volume: %(lun)s to Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erro ao Excluir Captura Instantânea: %(snapshot)s no Volume: %(lun)s para "
-"Conjunto: %(pool)s Projeto: %(project)s  Código de retorno: %(ret.status)d "
-"Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Volume: %(lun)s from Pool: %(pool)s, Project: %(project)s. "
-"Return code: %(ret.status)d, Message: %(ret.data)s."
-msgstr ""
-"Erro ao excluir volume: %(lun)s do Conjunto: %(pool)s, Projeto: %(project)s. "
-"Código de retorno: %(ret.status)d, Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting project: %(project)s on pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erro ao excluir projeto: %(project)s no pool: %(pool)s Código de retorno: "
-"%(ret.status)d Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting replication action: %(id)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"Erro ao excluir ação de replicação: %(id)s Código de retorno: %(ret.status)d "
-"Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Initiators: InitiatorGroup: %(initiatorgroup)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Erro ao Obter Inicializadores: InitiatorGroup: %(initiatorgroup)s Código de "
-"retorno: %(ret.status)d Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Pool Stats: Pool: %(pool)s Return code: %(status)d Message: "
-"%(data)s."
-msgstr ""
-"Erro ao Obter Estatísticas do Conjunto: Conjunto %(pool)s, Código de "
-"Retorno: %(status)d, Mensagem: %(data)s."
-
-#, python-format
-msgid ""
-"Error Getting Project Stats: Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erro ao obter estatísticas do projeto: Conjunto: %(pool)s Projeto: "
-"%(project)s Código de retorno: %(ret.status)d Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Share: %(share)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erro ao Obter Compartilhamento: %(share)s no Conjunto: %(pool)s Projeto: "
-"%(project)s Código de retorno: %(ret.status)d Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Volume: %(lun)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erro ao Obter Volume: %(lun)s em Conjunto: %(pool)s Projeto: %(project)s "
-"Código de retorno: %(ret.status)d Mensagem: %(ret.data)s."
-
-#, python-format
-msgid "Error Pool ownership: Pool %(pool)s is not owned by %(host)s."
-msgstr ""
-"Erro de propriedade do Conjunto: O conjunto %(pool)s não é de propriedade do "
-"%(host)s."
-
-#, python-format
-msgid ""
-"Error Setting props Props: %(props)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erro ao Definir instalações do operador programável: %(props)s no Volume: "
-"%(lun)s de Conjunto: %(pool)s Projeto: %(project)s  Código de retorno: "
-"%(ret.status)d Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Initiator: %(iqn)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Erro ao Verificar Inicializador: %(iqn)s Código de retorno: %(ret.status)d "
-"Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Pool: %(pool)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Erro ao Verificar o Conjunto: %(pool)s Código de retorno: %(ret.status)d "
-"Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erro ao Verificar Projeto: %(project)s no Conjunto: %(pool)s Código de "
-"retorno: %(ret.status)d Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Erro ao Verificar o Serviço: %(service)s Código de retorno: %(ret.status)d "
-"Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Target: %(alias)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Erro ao Verificar Destino: %(alias)s Código de retorno: %(ret.status)d "
-"Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying share: %(share)s on Project: %(project)s and Pool: %(pool)s "
-"Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Erro ao verificar compartilhamento: %(share)s no Projeto: %(project)s e no "
-"Conjunto: %(pool)s Código de retorno: %(ret.status)d Mensagem: %(ret.data)s."
-
 msgid "Error connecting to ceph cluster."
 msgstr "Erro ao se conectar ao cluster ceph."
 
@@ -1479,14 +1206,6 @@ msgstr "Erro durante a análise do avali
 
 #, python-format
 msgid ""
-"Error editing share: %(share)s on Pool: %(pool)s Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Erro ao editar compartilhamento: %(share)s no Conjunto: %(pool)s Código de "
-"retorno: %(ret.status)d Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
 "Error enabling iSER for NetworkPortal: please ensure that RDMA is supported "
 "on your iSCSI port %(port)d on ip %(ip)s."
 msgstr ""
@@ -1513,55 +1232,15 @@ msgstr "Erro ao estender volume:%(reason
 msgid "Error finding %(name)s."
 msgstr "Erro ao localizar %(name)s."
 
-msgid ""
-"Error getting appliance version details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Erro ao obter detalhes da versão do dispositivo. Código de retorno: %(ret."
-"status)d Mensagem: %(ret.data)s."
-
 #, python-format
 msgid "Error getting domain id from name %(name)s: %(id)s."
 msgstr "Erro ao obter ID do domínio do nome %(name)s: %(id)s."
 
-msgid "Error getting initiator groups."
-msgstr "Erro ao obter grupos do inicializador."
-
 #, python-format
 msgid "Error getting pool id from name %(pool_name)s: %(err_msg)s."
 msgstr "Erro ao obter o ID do conjunto do nome %(pool_name)s: %(err_msg)s."
 
 #, python-format
-msgid ""
-"Error getting replication action: %(id)s. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Erro ao obter ação de replicação: %(id)s. Código de retorno: %(ret.status)d "
-"Mensagem: %(ret.data)s."
-
-msgid ""
-"Error getting replication source details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Erro ao obter detalhes da origem de replicação. Código de retorno: %(ret."
-"status)d Mensagem: %(ret.data)s."
-
-msgid ""
-"Error getting replication target details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Erro ao obter detalhes do destino de replicação. Código de retorno: %(ret."
-"status)d Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error getting version: svc: %(svc)s.Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Erro ao obter a versão: svc: %(svc)s. Código de retorno: %(ret.status)d "
-"Mensagem: %(ret.data)s."
-
-#, python-format
 msgid "Error in SolidFire API response: data=%(data)s"
 msgstr "Erro na resposta da API SolidFire: data=%(data)s"
 
@@ -1569,22 +1248,6 @@ msgstr "Erro na resposta da API SolidFir
 msgid "Error managing volume: %s."
 msgstr "Erro ao gerenciar o volume: %s."
 
-#, python-format
-msgid ""
-"Error modifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Erro ao modificar o Serviço: %(service)s Código de retorno: %(ret.status)d "
-"Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error moving volume: %(vol)s from source project: %(src)s to target project: "
-"%(tgt)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Erro ao mover o volume: %(vol)s do projeto de origem: %(src)s para o projeto "
-"de destino: %(tgt)s Código de retorno: %(ret.status)d Mensagem: %(ret.data)s."
-
 msgid "Error not a KeyError."
 msgstr "O erro não é um KeyError."
 
@@ -1599,37 +1262,6 @@ msgid "Error retrieving volume size"
 msgstr "Erro ao recuperar o tamanho do volume"
 
 #, python-format
-msgid ""
-"Error sending replication update for action id: %(id)s . Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Erro ao enviar atualização de replicação para o ID de ação: %(id)s. Código "
-"de retorno: %(ret.status)d Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error sending replication update. Returned error: %(err)s. Action: %(id)s."
-msgstr ""
-"Erro ao enviar atualização de replicação. Erro retornado: %(err)s. Ação: "
-"%(id)s."
-
-#, python-format
-msgid ""
-"Error setting replication inheritance to %(set)s for volume: %(vol)s project "
-"%(project)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Erro ao configurar herança de replicação para %(set)s para o volume: %(vol)s "
-"projeto %(project)s Código de retorno: %(ret.status)d Mensagem: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error severing the package: %(package)s from source: %(src)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Erro ao separar o pacote: %(package)s da origem: %(src)s Código de retorno: "
-"%(ret.status)d Mensagem: %(ret.data)s."
-
-#, python-format
 msgid "Error while authenticating with switch: %s."
 msgstr "Erro ao autenticar-se com o comutador: %s"
 
@@ -1770,14 +1402,6 @@ msgid "FC is the protocol but wwpns are
 msgstr "FC é o protocolo, mas wwpns não são fornecidos pelo OpenStack."
 
 #, python-format
-msgid "Faield to unassign %(volume)s"
-msgstr "Falha ao remover designação de %(volume)s"
-
-#, python-format
-msgid "Fail to create cache volume %(volume)s. Error: %(err)s"
-msgstr "Falha ao criar volume de cache %(volume)s. Erro: %(err)s"
-
-#, python-format
 msgid "Failed adding connection for fabric=%(fabric)s: Error: %(err)s"
 msgstr "Falha ao incluir conexão para a malha=%(fabric)s: Erro:%(err)s"
 
@@ -1848,11 +1472,6 @@ msgid "Failed to connect to Dell REST AP
 msgstr "Falha ao conectar-se com a API REST Dell"
 
 #, python-format
-msgid "Failed to connect to sheep daemon. addr: %(addr)s, port: %(port)s"
-msgstr ""
-"Falha ao conectar-se ao daemon sheep. Endereço: %(addr)s, porta: %(port)s"
-
-#, python-format
 msgid "Failed to copy image to volume: %(reason)s"
 msgstr "Falha ao copiar imagem para o volume: %(reason)s"
 
@@ -1878,18 +1497,6 @@ msgid "Failed to create api volume flow.
 msgstr "Falha ao criar o fluxo de volume da API."
 
 #, python-format
-msgid "Failed to create cg snapshot %(id)s due to %(reason)s."
-msgstr "Falha ao criar a captura instantânea cg %(id)s devido a %(reason)s."
-
-#, python-format
-msgid "Failed to create consistency group %(id)s due to %(reason)s."
-msgstr "Falha ao criar grupo de consistências %(id)s devido a %(reason)s."
-
-#, python-format
-msgid "Failed to create consistency group %(id)s:%(ret)s."
-msgstr "Falha ao criar grupo de consistências %(id)s:%(ret)s."
-
-#, python-format
 msgid "Failed to create consistency group: %(cgid)s. Error: %(excmsg)s."
 msgstr "Falha ao criar grupo de consistências: %(cgid)s. Erro: %(excmsg)s."
 
@@ -1956,14 +1563,6 @@ msgid "Failed to create volume %s"
 msgstr "Falha ao criar o volume %s"
 
 #, python-format
-msgid "Failed to delete cgsnapshot %(id)s due to %(reason)s."
-msgstr "Falha ao excluir cgsnapshot %(id)s devido a %(reason)s."
-
-#, python-format
-msgid "Failed to delete consistency group %(id)s due to %(reason)s."
-msgstr "Falha ao excluir o grupo de consistências %(id)s devido a %(reason)s."
-
-#, python-format
 msgid ""
 "Failed to delete fileset for consistency group %(cgname)s. Error: %(excmsg)s."
 msgstr ""
@@ -2038,11 +1637,6 @@ msgid "Failed to find host %s."
 msgstr "Falha ao localizar host %s."
 
 #, python-format
-msgid "Failed to find iSCSI initiator group containing %(initiator)s."
-msgstr ""
-"Falha ao localizar o grupo de iniciadores iSCSI contendo %(initiator)s."
-
-#, python-format
 msgid "Failed to get LUN target details for the LUN %s"
 msgstr "Falha ao obter detalhes do destino de LUN para o LUN %s"
 
@@ -2154,14 +1748,6 @@ msgstr "Falha ao efetuar logon na Matriz
 msgid "Failed to login with all rest URLs."
 msgstr "Falha ao efetuar login com todas as URLs REST."
 
-#, python-format
-msgid ""
-"Failed to make a request to Datera cluster endpoint due to the following "
-"reason: %s"
-msgstr ""
-"Falha ao realizar uma solicitação ao terminal do cluster Datera devido ao "
-"seguinte motivo: %s"
-
 msgid "Failed to manage api volume flow."
 msgstr "Falha ao gerenciar fluxo de volume da API."
 
@@ -2362,30 +1948,6 @@ msgid "Failure staging LUN %s to tmp."
 msgstr "Falha na preparação do LUN %s para tmp."
 
 #, python-format
-msgid "Fexvisor failed to add volume %(id)s due to %(reason)s."
-msgstr "O Fexvisor falhou ao incluir o volume %(id)s devido a %(reason)s."
-
-#, python-format
-msgid ""
-"Fexvisor failed to join the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr ""
-"Fexvisor falhou ao associar o volume %(vol)s no grupo %(group)s devido a "
-"%(ret)s."
-
-#, python-format
-msgid ""
-"Fexvisor failed to remove the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr ""
-"Fexvisor falhou ao remover o volume %(vol)s no grupo %(group)s devido a "
-"%(ret)s."
-
-#, python-format
-msgid "Fexvisor failed to remove volume %(id)s due to %(reason)s."
-msgstr "Fexvisor falhou ao remover o volume %(id)s devido a %(reason)s."
-
-#, python-format
 msgid "Fibre Channel SAN Lookup failure: %(reason)s"
 msgstr "Falha no Fibre Channel SAN Lookup: %(reason)s"
 
@@ -2402,10 +1964,6 @@ msgid "File %(file_path)s could not be f
 msgstr "O arquivo %(file_path)s não pôde ser localizado."
 
 #, python-format
-msgid "File already exists at %s."
-msgstr "O arquivo já existe em %s."
-
-#, python-format
 msgid "File already exists at: %s"
 msgstr "O arquivo já existe em: %s"
 
@@ -2436,185 +1994,6 @@ msgstr ""
 "'%(fcache_version)s' versão '%(version)s' está instalada."
 
 #, python-format
-msgid "Flexvisor assign volume failed.:%(id)s:%(status)s."
-msgstr "Volume de designação do Flexvisor com falha: %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor assign volume failed:%(id)s:%(status)s."
-msgstr "Volume de designação do Flexvisor falhou:%(id)s:%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor could not find volume %(id)s snapshot in the group %(vgid)s "
-"snapshot %(vgsid)s."
-msgstr ""
-"O Flexvisor não pôde localizar a captura instantânea do volume %(id)s no "
-"grupo %(vgid)s da captura instantânea %(vgsid)s."
-
-#, python-format
-msgid "Flexvisor create volume failed.:%(volumeid)s:%(status)s."
-msgstr "Flexvisor cria volume com falha.:%(volumeid)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor failed deleting volume %(id)s: %(status)s."
-msgstr "O Flexvisor falhou ao excluir o volume %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor failed to add volume %(id)s to group %(cgid)s."
-msgstr "O Flexvisor falhou ao incluir o volume %(id)s ao grupo %(cgid)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to assign volume %(id)s due to unable to query status by "
-"event id."
-msgstr ""
-"Flexvisor falhou ao designar o volume %(id)s devido a não poder consultar o "
-"status pelo id de evento."
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(id)s: %(status)s."
-msgstr "Flexvisor falhou ao designar volume %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(volume)s iqn %(iqn)s."
-msgstr "O Flexvisor falhou ao designar o volume %(volume)s iqn %(iqn)s."
-
-#, python-format
-msgid "Flexvisor failed to clone volume %(id)s: %(status)s."
-msgstr "O Flexvisor falhou ao clonar o volume %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor failed to clone volume (failed to get event) %(id)s."
-msgstr "O Flexvisor falhou ao clonar o volume (falha ao obter evento) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to create snapshot for volume %(id)s: %(status)s."
-msgstr ""
-"O Flexvisor falhou ao criar a captura instantânea para o volume %(id)s:"
-"%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to create snapshot for volume (failed to get event) %(id)s."
-msgstr ""
-"O Flexvisor falhou ao criar a captura instantânea para o volume (falha ao "
-"obter evento) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume %(id)s in the group %(vgid)s."
-msgstr "O Flexvisor falhou ao criar o volume %(id)s no grupo %(vgid)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume %(volume)s: %(status)s."
-msgstr "Flexvisor falhou ao criar volume %(volume)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume (get event) %s."
-msgstr "Flexvisor falhou ao criar volume (get event) %s."
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s: %(status)s."
-msgstr ""
-"O Flexvisor falhou ao criar volume da captura instantânea %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s:%(status)s."
-msgstr ""
-"O Flexvisor falhou ao criar volume da captura instantânea %(id)s:%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to create volume from snapshot (failed to get event) %(id)s."
-msgstr ""
-"O Flexvisor falhou ao criar volume da captura instantânea (falha ao obter "
-"evento) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot %(id)s: %(status)s."
-msgstr "O Flexvisor falhou ao excluir a captura instantânea %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot (failed to get event) %(id)s."
-msgstr ""
-"O Flexvisor falhou ao excluir a captura instantânea (falha ao obter "
-"evento)%(id)s."
-
-#, python-format
-msgid "Flexvisor failed to delete volume %(id)s: %(status)s."
-msgstr "O Flexvisor falhou ao excluir o volume %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s: %(status)s."
-msgstr "O Flexvisor falhou ao estender o volume %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s:%(status)s."
-msgstr "O Flexvisor falhou ao estender o volume %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume (failed to get event) %(id)s."
-msgstr ""
-"O Flexvisor falhou ao estender o volume (falha ao obter evento) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to get pool info %(id)s: %(status)s."
-msgstr ""
-"O Flexvisor falhou ao obter informações do conjunto %(id)s: %(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to get snapshot id of volume %(id)s from group %(vgid)s."
-msgstr ""
-"O Flexvisor falhou ao obter o id de captura instantânea do volume %(id)s do "
-"grupo %(vgid)s."
-
-#, python-format
-msgid "Flexvisor failed to remove volume %(id)s from group %(cgid)s."
-msgstr "Flexvisor falhou ao remover o volume %(id)s do grupo %(cgid)s."
-
-#, python-format
-msgid "Flexvisor failed to spawn volume from snapshot %(id)s:%(status)s."
-msgstr ""
-"O Flexvisor falhou ao efetuar spawn do volume de captura instantânea %(id)s:"
-"%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to spawn volume from snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor falhou ao efetuar spawn do volume de captura instantânea (falha ao "
-"obter evento) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume %(id)s: %(status)s."
-msgstr "Flexvisor falhou ao remover a designação do volume %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume (get event) %(id)s."
-msgstr ""
-"Flexvisor falhou ao remover designação do volume (obter evento) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume:%(id)s:%(status)s."
-msgstr ""
-"O Flexvisor falhou ao remover a designação do volume: %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor unable to find the source volume %(id)s info."
-msgstr ""
-"O Flexvisor não conseguiu localizar as informações do volume de origem "
-"%(id)s."
-
-#, python-format
-msgid "Flexvisor unassign volume failed:%(id)s:%(status)s."
-msgstr ""
-"Falha na remoção de designação de volume pelo Flexvisor %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor volume %(id)s failed to join group %(vgid)s."
-msgstr "O volume do Flexvisor %(id)s falhou ao unir o grupo %(vgid)s."
-
-#, python-format
 msgid "Folder %s does not exist in Nexenta Store appliance"
 msgstr "O volume %s não existe no dispositivo Nexenta Store."
 
@@ -2936,14 +2315,6 @@ msgid "Invalid Replication Target: %(rea
 msgstr "Destino de Replicação Inválido: %(reason)s"
 
 #, python-format
-msgid ""
-"Invalid Virtuozzo Storage share specification: %r. Must be: [MDS1[,"
-"MDS2],...:/]<CLUSTER NAME>[:PASSWORD]."
-msgstr ""
-"Especificação de compartilhamento de armazenamento Virtuozzo inválido: %r. "
-"Deve ser: [MDS1[,MDS2],...:/]<CLUSTER NAME>[:PASSWORD]."
-
-#, python-format
 msgid "Invalid XtremIO version %(cur)s, version %(min)s or up is required"
 msgstr ""
 "Versão XtremIO %(cur)s inválida, versão %(min)s ou posterior é necessária"
@@ -2953,13 +2324,6 @@ msgid "Invalid allocated quotas defined
 msgstr ""
 "Cotas alocadas inválidas definidas para as cotas de projeto a seguir: %s"
 
-msgid "Invalid argument - negative seek offset."
-msgstr "Argumento inválido – deslocamento de busca negativo."
-
-#, python-format
-msgid "Invalid argument - whence=%s not supported."
-msgstr "Argumento inválido – whence=%s não suportado."
-
 #, python-format
 msgid "Invalid attaching mode '%(mode)s' for volume %(volume_id)s."
 msgstr "Modo de anexamento inválido '%(mode)s' para o volume %(volume_id)s."
@@ -2973,16 +2337,6 @@ msgid "Invalid backup: %(reason)s"
 msgstr "Backup inválido: %(reason)s"
 
 #, python-format
-msgid "Invalid connection initialization response of volume %(name)s"
-msgstr "Resposta de inicialização de conexão inválida %(name)s"
-
-#, python-format
-msgid ""
-"Invalid connection initialization response of volume %(name)s: %(output)s"
-msgstr ""
-"Resposta de inicialização de conexão inválida de volume %(name)s: %(output)s"
-
-#, python-format
 msgid "Invalid content type %(content_type)s."
 msgstr "Tipo de conteúdo inválido %(content_type)s."
 
@@ -3069,10 +2423,6 @@ msgid "Invalid mount point base: %s"
 msgstr "Base de ponto de montagem inválido: %s"
 
 #, python-format
-msgid "Invalid mount point base: %s."
-msgstr "Base de ponto de montagem inválida: %s."
-
-#, python-format
 msgid "Invalid new snapCPG name for retype.  new_snap_cpg='%s'."
 msgstr "Novo nome do snapCPG inválido para nova digitação.  new_snap_cpg='%s'."
 
@@ -3091,9 +2441,6 @@ msgstr "ID secundário inválido %s"
 msgid "Invalid service catalog json."
 msgstr "Catálogo de serviço json inválido."
 
-msgid "Invalid sheepdog cluster status."
-msgstr "Status do cluster sheepdog inválido."
-
 #, python-format
 msgid "Invalid snapshot: %(reason)s"
 msgstr "Snapshot inválido: %(reason)s"
@@ -3180,10 +2527,6 @@ msgstr ""
 "volume_type inválido fornecido: %s (o tipo solicitado deve ser suportado por "
 "este grupo de consistências)."
 
-#, python-format
-msgid "Invalid wwpns format %(wwpns)s"
-msgstr "Formato inválido de wwpns %(wwpns)s"
-
 msgid "Issue encountered waiting for job."
 msgstr "Emita espera encontrada para a tarefa."
 
@@ -3196,10 +2539,6 @@ msgstr ""
 "Falha ao emitir um failover porque a replicação não está configurada "
 "corretamente."
 
-#, python-format
-msgid "KeyError: %s"
-msgstr "KeyError: %s"
-
 msgid "Keystone version 3 or greater must be used to get nested quota support."
 msgstr ""
 "O Keystone versão 3 ou maior deve ser usado para obter o suporte de cota "
@@ -3504,9 +2843,6 @@ msgstr ""
 msgid "New volume type not specified in request_spec."
 msgstr "Tipo de volume novo não especificado em request_spec."
 
-msgid "Nimble Cinder Driver exception"
-msgstr "Exceção Nimble Cinder Driver"
-
 msgid "No FC initiator can be added to host."
 msgstr "Nenhum iniciador de FC pode ser incluído no host. "
 
@@ -3544,10 +2880,6 @@ msgid "No initiator connected to fabric.
 msgstr "Nenhum iniciador conectado à malha."
 
 #, python-format
-msgid "No initiator group found for initiator %s"
-msgstr "Nenhum grupo de inicializador localizado para o inicializador %s"
-
-#, python-format
 msgid "No interface found on cluster for ip %s"
 msgstr "Nenhuma interface localizada no cluster para o IP %s"
 
@@ -3560,10 +2892,6 @@ msgstr "Nenhum compartilhamento NFS mont
 msgid "No mounted SMBFS shares found."
 msgstr "Nenhum compartilhamento SMBFS montado foi localizado."
 
-msgid "No mounted Virtuozzo Storage shares found"
-msgstr ""
-"Nenhum compartilhamento de armazenamento Virtuozzo montado foi localizado"
-
 msgid "No mounted shares found"
 msgstr "Nenhum compartilhamento montado foi localizado"
 
@@ -3588,9 +2916,6 @@ msgstr "Nenhum snap localizado com %s co
 msgid "No such QoS spec %(specs_id)s."
 msgstr "Sem spec QoS %(specs_id)s."
 
-msgid "No suitable discovery ip found"
-msgstr "Nenhum IP de descoberta adequado foi localizado"
-
 #, python-format
 msgid "No support to restore backup version %s"
 msgstr "Não há suporte para restaurar a versão de backup %s"
@@ -3627,11 +2952,6 @@ msgstr "Não autorizado."
 msgid "Not enough space on backend (%(backend)s)"
 msgstr "Não há espaço suficiente no backend (%(backend)s)"
 
-msgid "Not enough storage space in the ZFS share to perform this operation."
-msgstr ""
-"Não há espaço de armazenamento suficiente no compartilhamento do ZFS para "
-"executar essa operação."
-
 msgid "Not stored in rbd"
 msgstr "Não armazenado em rbd"
 
@@ -3665,9 +2985,6 @@ msgstr ""
 "Somente usuários com escopo do token definido para pais imediatos ou "
 "projetos raiz têm permissão para ver suas cotas filhas."
 
-msgid "Only volumes managed by OpenStack can be unmanaged."
-msgstr "Somente volumes gerenciados pelo OpenStack podem ser não gerenciados."
-
 #, python-format
 msgid "Operation failed with status=%(status)s. Full dump: %(data)s"
 msgstr "A operação falhou com o status=%(status)s. Dump completo: %(data)s"
@@ -3711,9 +3028,6 @@ msgstr "A política não permite que %(a
 msgid "Pool is not available in the volume host field."
 msgstr "O conjunto não está disponível no campo do host de volume."
 
-msgid "Pool is not available in the volume host fields."
-msgstr "O conjunto não está disponível nos campos do host de volume."
-
 #, python-format
 msgid "Pool with name %(pool_name)s wasn't found in domain %(domain_id)s."
 msgstr ""
@@ -3856,13 +3170,6 @@ msgstr "A referência deve conter source
 msgid "Reference must contain source-name."
 msgstr "A referência deve conter o nome de origem."
 
-msgid "Reference to volume to be managed must contain source-name."
-msgstr "A referência ao volume a ser gerenciado deve conter o source-name."
-
-#, python-format
-msgid "Reference to volume: %s to be managed must contain source-name."
-msgstr "A referência ao volume: %s a ser gerenciado deve conter o source-name."
-
 #, python-format
 msgid ""
 "Refusing to migrate volume ID: %(id)s. Please check your configuration "
@@ -3924,12 +3231,6 @@ msgid "Request body contains too many it
 msgstr "O corpo da solicitação contém excesso de itens"
 
 #, python-format
-msgid "Request to Datera cluster returned bad status: %(status)s | %(reason)s"
-msgstr ""
-"A solicitação ao cluster Datera retornou o status inválido: %(status)s | "
-"%(reason)s"
-
-#, python-format
 msgid ""
 "Requested backup exceeds allowed Backup gigabytes quota. Requested "
 "%(requested)sG, quota is %(quota)sG and %(consumed)sG has been consumed."
@@ -4046,10 +3347,6 @@ msgid "SMBFS config file not set (smbfs_
 msgstr "Arquivo de configuração SMBFS não definido (smbfs_shares_config)."
 
 #, python-format
-msgid "SSH Command failed after '%(total_attempts)r' attempts : '%(command)s'"
-msgstr "Comando SSH falhou após '%(total_attempts)r' tentativas: '%(command)s'"
-
-#, python-format
 msgid "SSH command injection detected: %(command)s"
 msgstr "Injeção de comando SSH detectada: %(command)s"
 
@@ -4095,10 +3392,6 @@ msgstr "Erro de configuração de acesso
 msgid "Sets thin provisioning."
 msgstr "Configura thin provisioning."
 
-#, python-format
-msgid "Sheepdog I/O Error, command was: \"%s\"."
-msgstr "Erro de E/S de sheepdog, o comando foi: \"%s\"."
-
 msgid ""
 "Show operations can only be made to projects in the same hierarchy of the "
 "project in which users are scoped to."
@@ -4291,15 +3584,6 @@ msgstr ""
 "O sistema de arquivos GPFS %(fs)s não está no nível da liberação necessário. "
 "O nível atual é %(cur)s, deve ser pelo menos %(min)s."
 
-#, python-format
-msgid ""
-"The WebDAV request failed. Reason: %(msg)s, Return code/reason: %(code)s, "
-"Source Volume: %(src)s, Destination Volume: %(dst)s, Method: %(method)s."
-msgstr ""
-"A solicitação WebDAV falhou. Motivo: %(msg)s, Código de retorno/razão: "
-"%(code)s, Volume de Origem: %(src)s, Volume de Destino: %(dst)s, Método: "
-"%(method)s."
-
 msgid ""
 "The above error may show that the database has not been created.\n"
 "Please create a database using 'cinder-manage db sync' before running this "
@@ -4386,9 +3670,6 @@ msgstr ""
 "A captura instantânea não pode ser criada quando o volume está no modo de "
 "manutenção."
 
-msgid "The source volume for this WebDAV operation not found."
-msgstr "O volume de origem para esta operação WebDAV não foi localizado."
-
 #, python-format
 msgid ""
 "The source volume type '%(src)s' is different than the destination volume "
@@ -4589,10 +3870,6 @@ msgid "Type cannot be converted into NaE
 msgstr "O tipo não pode ser convertido em  NaElement."
 
 #, python-format
-msgid "TypeError: %s"
-msgstr "TypeError: %s"
-
-#, python-format
 msgid "UUIDs %s are in both add and remove volume list."
 msgstr "UUIDs %s estão na lista de inclusão e remoção de volume."
 
@@ -4852,9 +4129,6 @@ msgstr ""
 msgid "Unexpected output. Expected [%(expected)s] but received [%(output)s]"
 msgstr "Saída inesperada. Esperada [%(expected)s], mas recebida [%(output)s]"
 
-msgid "Unexpected response from Nimble API"
-msgstr "Resposta inesperada da API do Nimble"
-
 msgid "Unexpected status code"
 msgstr "Código de status inesperado"
 
@@ -4875,41 +4149,10 @@ msgstr "Exceção RemoteFS desconhecida"
 msgid "Unknown SMBFS exception."
 msgstr "Exceção SMBFS desconhecida."
 
-msgid "Unknown Virtuozzo Storage exception"
-msgstr "Exceção de armazenamento Virtuozzo desconhecido"
-
 msgid "Unknown action"
 msgstr "Ação desconhecida"
 
 #, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, Set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"Desconhecido se o volume: %s a ser gerenciado estiver sendo gerenciado pelo "
-"Cinder. Interrompendo gerenciamento de volume. Inclua a propriedade de "
-"esquema customizado 'cinder_managed' no volume e configure seu valor para "
-"False. Como alternativa, defina o valor da política de configuração do "
-"Cinder 'zfssa_manage_policy' para 'loose' para remover essa restrição."
-
-#, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"Desconhecido se o volume: %s a ser gerenciado estiver sendo gerenciado pelo "
-"Cinder. Interrompendo gerenciamento de volume. Inclua a propriedade de "
-"esquema customizado 'cinder_managed' no volume e configure seu valor para "
-"False. Como alternativa, defina o valor da política de configuração do "
-"Cinder 'zfssa_manage_policy' para 'loose' para remover essa restrição."
-
-#, python-format
 msgid "Unknown or unsupported command %(cmd)s"
 msgstr "Comando desconhecido ou não suportado %(cmd)s"
 
@@ -5018,9 +4261,6 @@ msgstr "ID de Usuário"
 msgid "User does not have admin privileges"
 msgstr "O usuário não tem privilégios de administrador"
 
-msgid "User not authorized to perform WebDAV operations."
-msgstr "O usuário não está autorizado a executar operações do WebDAV."
-
 msgid "UserName is not configured."
 msgstr "UserName não está configurado."
 
@@ -5050,10 +4290,6 @@ msgstr ""
 "\""
 
 #, python-format
-msgid "ValueError: %s"
-msgstr "ValueError: %s"
-
-#, python-format
 msgid "Vdisk %(name)s not involved in mapping %(src)s -> %(tgt)s."
 msgstr "Vdisk %(name)s não envolvido no mapeamento %(src)s -> %(tgt)s."
 
@@ -5151,25 +4387,10 @@ msgid "Volume %s does not exist on the a
 msgstr "O volume %s não existe na matriz."
 
 #, python-format
-msgid "Volume %s does not have provider_location specified, skipping."
-msgstr "O volume %s não possui provider_location especificado, ignorando."
-
-#, python-format
 msgid "Volume %s doesn't exist on array."
 msgstr "O volume %s não existe na matriz."
 
 #, python-format
-msgid "Volume %s doesn't exist on the ZFSSA backend."
-msgstr "O volume %s não existe no backend ZFSSA."
-
-#, python-format
-msgid ""
-"Volume %s is online. Set volume to offline for managing using OpenStack."
-msgstr ""
-"O volume %s está on-line. Configure o volume para off-line gerenciar o uso "
-"do  OpenStack."
-
-#, python-format
 msgid "Volume %s must not be part of a consistency group."
 msgstr "O volume %s não deve ser parte de um grupo de consistências."
 
@@ -5311,9 +4532,6 @@ msgstr "Volume ainda não designado para
 msgid "Volume replication for %(volume_id)s could not be found."
 msgstr "Replicação de volume %(volume_id)s não pôde ser encontrada."
 
-msgid "Volume should have agent-type set as None."
-msgstr "O volume deve ter agent-type configurado como Nenhum."
-
 #, python-format
 msgid ""
 "Volume size %(volume_size)sGB cannot be smaller than the image minDisk size "
@@ -5355,9 +4573,6 @@ msgstr "O tamanho do volume deve ser mú
 msgid "Volume size must multiple of 1 GB."
 msgstr "O tamanho do volume deve ser múltiplo de 1 GB."
 
-msgid "Volume status must be 'available'."
-msgstr "O status do volume deve ser 'disponível'."
-
 msgid "Volume to Initiator Group mapping already exists"
 msgstr "Já existe um mapeamento de grupos de volume para inicializador"
 
@@ -5412,36 +4627,15 @@ msgid "Volume type with name %(volume_ty
 msgstr ""
 "O tipo de volume com o nome %(volume_type_name)s não pôde ser localizado."
 
-#, python-format
-msgid "Volume: %s is already being managed by Cinder."
-msgstr "O volume %s já está sendo gerenciado pelo Cinder."
-
 msgid ""
 "Volumes/account exceeded on both primary and secondary SolidFire accounts."
 msgstr ""
 "Os volumes/contas excederam nas contas SolidFire primárias e secundárias."
 
 #, python-format
-msgid ""
-"VzStorage config 'vzstorage_used_ratio' invalid. Must be > 0 and <= 1.0: %s."
-msgstr ""
-"Configuração VzStorage 'vzstorage_used_ratio' inválida. Deve ser > 0 e <= "
-"1.0: %s."
-
-#, python-format
-msgid "VzStorage config file at %(config)s doesn't exist."
-msgstr "Arquivo de configuração VzStorage em %(config)s não existe."
-
-#, python-format
 msgid "Wait synchronize failed. Running status: %s."
 msgstr "Falha ao aguardar sincronização. Status de execução: %s."
 
-msgid ""
-"Waiting for all nodes to join cluster. Ensure all sheep daemons are running."
-msgstr ""
-"Aguardando que todos os nós se associem ao cluster. Assegure-se de que todos "
-"os daemons sheep estejam em execução."
-
 msgid "We should not do switch over on primary array."
 msgstr "Não é recomendável executar switch over na matriz primária."
 
@@ -6177,9 +5371,6 @@ msgstr "extend_volume, volumename: %(vol
 msgid "fake"
 msgstr "falso"
 
-msgid "fileno is not supported by SheepdogIOWrapper"
-msgstr "fileno não é suportado pelo SheepdogIOWrapper"
-
 #, python-format
 msgid "fmt=%(fmt)s backed by: %(backing_file)s"
 msgstr "fmt=%(fmt)s retornado por: %(backing_file)s"
@@ -6228,13 +5419,6 @@ msgstr ""
 "gpfs_images_share_mode está configurada para copy_on_write, mas %(vol)s e "
 "%(img)s pertencem a diferentes conjuntos."
 
-msgid ""
-"http service may have been abruptly disabled or put to maintenance state in "
-"the middle of this operation."
-msgstr ""
-"O serviço http foi desativado abruptamente ou pode ter sido colocado em "
-"estado de manutenção no meio dessa operação."
-
 msgid "id cannot be None"
 msgstr "id não pode ser Nenhum"
 
@@ -6523,11 +5707,3 @@ msgstr "volumes designados"
 
 msgid "volumes changed"
 msgstr "volumes alterados"
-
-#, python-format
-msgid ""
-"zfssa_manage_policy property needs to be set to 'strict' or 'loose'. Current "
-"value is: %s."
-msgstr ""
-"A propriedade zfssa_manage_policy precisa ser configurada para 'strict' ou "
-"'loose'. O valor atual é: %s."
diff -pruN 2:15.0.1-1/cinder/locale/ru/LC_MESSAGES/cinder.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/ru/LC_MESSAGES/cinder.po
--- 2:15.0.1-1/cinder/locale/ru/LC_MESSAGES/cinder.po	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/ru/LC_MESSAGES/cinder.po	2020-03-24 18:46:31.000000000 +0000
@@ -11,7 +11,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: cinder VERSION\n"
 "Report-Msgid-Bugs-To: https://bugs.launchpad.net/openstack-i18n/\n"
-"POT-Creation-Date: 2019-10-04 05:27+0000\n"
+"POT-Creation-Date: 2020-03-18 14:40+0000\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
@@ -113,12 +113,6 @@ msgstr ""
 "резервные копии файлов и образов. Фактический режим: %(vol_mode)s."
 
 #, python-format
-msgid "%(service)s Service is not %(status)s on storage appliance: %(host)s"
-msgstr ""
-"Служба %(service)s не находится в состоянии %(status)s в устройстве хранения "
-"%(host)s"
-
-#, python-format
 msgid ""
 "%(worker_name)s value of %(workers)d is invalid, must be greater than 0."
 msgstr ""
@@ -166,10 +160,6 @@ msgid "%s is not installed"
 msgstr "%s не установлен"
 
 #, python-format
-msgid "%s is not installed."
-msgstr "%s не установлен."
-
-#, python-format
 msgid "%s is not set"
 msgstr "%s - не множество"
 
@@ -192,10 +182,6 @@ msgid "%s must be an absolute path."
 msgstr "%s должен быть абсолютным путем."
 
 #, python-format
-msgid "%s not set in cinder.conf"
-msgstr "%s не задан в cinder.conf"
-
-#, python-format
 msgid "%s not set."
 msgstr "%s не задан."
 
@@ -216,14 +202,6 @@ msgstr "Необходимо указа
 msgid "'qemu-img info' parsing failed."
 msgstr "Ошибка анализа 'qemu-img info'."
 
-#, python-format
-msgid ""
-"(Command: %(cmd)s) (Return Code: %(exit_code)s) (Stdout: %(stdout)s) "
-"(Stderr: %(stderr)s)"
-msgstr ""
-"(Команда: %(cmd)s) (Код возврата: %(exit_code)s) (stdout: %(stdout)s) "
-"(stderr: %(stderr)s)"
-
 msgid "A concurrent, possibly contradictory, request has been made."
 msgstr "Параллельно выполняется другой, вероятно, конфликтующий запрос."
 
@@ -310,14 +288,6 @@ msgstr ""
 "Ошибка во время операции LUNcopy. Имя LUNcopy: %(luncopyname)s. Статус "
 "LUNcopy: %(luncopystatus)s. Состояние LUNcopy: %(luncopystate)s."
 
-#, python-format
-msgid "An error occurred while reading volume \"%s\"."
-msgstr "Возникла ошибка при чтении тома \"%s\"."
-
-#, python-format
-msgid "An error occurred while writing to volume \"%s\"."
-msgstr "Возникла ошибка при записи на том \"%s\"."
-
 msgid "An unknown exception occurred."
 msgstr "Обнаружено неизвестное исключение."
 
@@ -391,9 +361,6 @@ msgstr "Доступные катего
 msgid "Backend doesn't exist (%(backend)s)"
 msgstr "Базовый сервер не существует (%(backend)s)"
 
-msgid "Backend storage did not configure fiber channel target."
-msgstr "Память базовой системы не настроила цель оптоволоконного канала."
-
 msgid "Backing up an in-use volume must use the force flag."
 msgstr ""
 "Для резервного копирования используемого тома требуется флаг принудительного "
@@ -509,10 +476,6 @@ msgstr ""
 msgid "CPG (%s) doesn't exist on array"
 msgstr "CPG (%s) не существует в массиве"
 
-#, python-format
-msgid "Cache volume %s does not have required properties"
-msgstr "Для тома кэша %s не заданы обязательные свойства"
-
 msgid "Can not add FC port to host."
 msgstr "Не удалось добавить порт Fibre Channel в хост."
 
@@ -643,10 +606,6 @@ msgstr ""
 "Не удаётся изменить контекст VF, данный VF недоступен в списке управляемых "
 "VF %(vf_list)s."
 
-#, python-format
-msgid "Cannot create directory %s."
-msgstr "Не удалось создать каталог %s."
-
 msgid "Cannot create encryption specs. Volume type in use."
 msgstr "Невозможно создать спецификацию шифрования. Тип тома используется."
 
@@ -667,22 +626,6 @@ msgstr ""
 "Невозможно создать volume_type с именем %(name)s и спецификациями "
 "%(extra_specs)s"
 
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)d volume instances."
-msgstr ""
-"Не удалось удалить том кэша %(cachevol_name)s. Он обновлен в%(updated_at)s и "
-"сейчас содержит %(numclones)d экземпляры тома."
-
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)s volume instances."
-msgstr ""
-"Не удалось удалить том кэша %(cachevol_name)s. Он обновлен в %(updated_at)s "
-"и сейчас содержит %(numclones)s экземпляры тома."
-
 msgid "Cannot delete encryption specs. Volume type in use."
 msgstr "Невозможно удалить спецификацию шифрования. Тип тома используется."
 
@@ -746,10 +689,6 @@ msgid ""
 msgstr ""
 "Изменение будет использовать менее 0 для следующих ресурсов: %(unders)s"
 
-msgid "Check access permissions for the ZFS share assigned to this driver."
-msgstr ""
-"Проверьте права доступа для общего раздела ZFS, присвоенного этому драйверу."
-
 msgid "Check hostgroup associate error."
 msgstr "Ошибка проверки связывания группы хостов."
 
@@ -765,13 +704,6 @@ msgstr "Ошибка проверки с
 msgid "Check portgroup associate error."
 msgstr "Ошибка проверки связывания группы портов."
 
-msgid ""
-"Check the state of the http service. Also ensure that the https port number "
-"is the same as the one specified in cinder.conf."
-msgstr ""
-"Проверьте состояние службы http. Убедитесь также, что номер порта https "
-"number совпадает с указанным в cinder.conf."
-
 msgid "Chunk size is not multiple of block size for creating hash."
 msgstr "Размер фрагмента не кратен размеру блока для создания хэша."
 
@@ -787,12 +719,6 @@ msgstr ""
 "Недопустимый тип дубликата '%(clone_type)s'. Допустимые типы: "
 "'%(full_clone)s' и '%(linked_clone)s'."
 
-msgid ""
-"Cluster is not formatted. You should probably perform \"dog cluster format\"."
-msgstr ""
-"Кластер не отформатирован. Необходимо выполнить команду \"dog cluster format"
-"\"."
-
 #, python-format
 msgid "CommandLineHelper._wait_for_condition: %s timeout."
 msgstr "CommandLineHelper._wait_for_condition: тайм-аут %s."
@@ -808,11 +734,6 @@ msgstr "Вычислительный к
 msgid "Condition has no field."
 msgstr "В условии нет поля."
 
-#, python-format
-msgid "Config 'max_over_subscription_ratio' invalid. Must be > 0: %s"
-msgstr ""
-"Недопустимое значение 'max_over_subscription_ratio'. Должно быть > 0: %s"
-
 msgid "Configuration error: dell_sc_ssn not set."
 msgstr "Ошибка конфигурации: dell_sc_ssn не задан."
 
@@ -864,6 +785,12 @@ msgid "Converted to %(f1)s, but format i
 msgstr "Выполнено преобразование в %(f1)s, но в данный момент формат - %(f2)s"
 
 #, python-format
+msgid "Converted to %(vol_format)s, but format is now %(file_format)s"
+msgstr ""
+"Выполнено преобразование в %(vol_format)s, но в данный момент формат - "
+"%(file_format)s"
+
+#, python-format
 msgid "Converted to raw, but format is now %s"
 msgstr "Преобразование в необработанный, но текущий формат %s"
 
@@ -1241,198 +1168,6 @@ msgstr "Включает реплика
 msgid "Ensure that configfs is mounted at /sys/kernel/config."
 msgstr "Убедитесь, что configfs смонтирована в /sys/kernel/config."
 
-#, python-format
-msgid ""
-"Error Cloning Snapshot: %(snapshot)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Clone project: %(clone_proj)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Ошибка при дублировании моментальной копии %(snapshot)s, том: %(lun)s, пул: "
-"%(pool)s, проект: %(project)s, дубликат проекта: %(clone_proj)s, код "
-"возврата: %(ret.status)d, сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Initiator: %(initiator)s on Alias: %(alias)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Ошибка при создании инициатора %(initiator)s для псевдонима %(alias)s. Код "
-"возврата: %(ret.status)d, сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Ошибка при создании проекта %(project)s в пуле %(pool)s, код возврата: "
-"%(ret.status)d, сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Property: %(property)s Type: %(type)s Description: "
-"%(description)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Ошибка создания свойства %(property)s, тип: %(type)s, описание: "
-"%(description)s, код возврата: %(ret.status)d, сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Share: %(name)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Ошибка при создании общего ресурса: %(name)s, код возврата: %(ret.status)d, "
-"сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Creating Volume: %(lun)s Size: %(size)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"Ошибка при создании тома %(lun)s, размер %(size)s, код возврата "
-"%(ret.status)d Сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Share: %(share)s to Pool: %(pool)s "
-"Project: %(project)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Ошибка при удалении моментальной копии %(snapshot)s, общий ресурс: "
-"%(share)s, пул: %(pool)s, проект: %(project)s, код возврата: %(ret.status)d, "
-"сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Volume: %(lun)s to Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Ошибка при удалении моментальной копии %(snapshot)s, том: %(lun)s, пул: "
-"%(pool)s, проект: %(project)s, код возврата: %(ret.status)d, сообщение: "
-"%(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting Volume: %(lun)s from Pool: %(pool)s, Project: %(project)s. "
-"Return code: %(ret.status)d, Message: %(ret.data)s."
-msgstr ""
-"Ошибка удаления тома %(lun)s из пула %(pool)s, проект: %(project)s. Код "
-"возврата: %(ret.status)d, сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting project: %(project)s on pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Ошибка удаления проекта %(project)s в пуле %(pool)s. Код возврата: "
-"%(ret.status)d, сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Deleting replication action: %(id)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"Ошибка действия удаления репликации %(id)s. Код возврата: %(ret.status)d "
-"Сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Initiators: InitiatorGroup: %(initiatorgroup)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Ошибка при получении инициаторов: InitiatorGroup: %(initiatorgroup)s, Код "
-"возврата: %(ret.status)d, сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Pool Stats: Pool: %(pool)s Return code: %(status)d Message: "
-"%(data)s."
-msgstr ""
-"Ошибка при получении статистики пула: пул: %(pool)s код возврата: %(status)d "
-"сообщение: %(data)s."
-
-#, python-format
-msgid ""
-"Error Getting Project Stats: Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Ошибка получения статистики проекта: Пул: %(pool)s Проект: %(project)s Код "
-"возврата: %(ret.status)d Сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Share: %(share)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Ошибка получения общего ресурса: %(share)s, пул: %(pool)s, проект: "
-"%(project)s код возврата: %(ret.status)d, сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Getting Volume: %(lun)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Ошибка при получении тома %(lun)s в пуле %(pool)s, проект: %(project)s, код "
-"возврата: %(ret.status)d, сообщение: %(ret.data)s."
-
-#, python-format
-msgid "Error Pool ownership: Pool %(pool)s is not owned by %(host)s."
-msgstr "Ошибка принадлежности пула: пул %(pool)s не принадлежит %(host)s."
-
-#, python-format
-msgid ""
-"Error Setting props Props: %(props)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Ошибка при задании свойств %(props)s, том: %(lun)s, пул: %(pool)s, проект: "
-"%(project)s, код возврата: %(ret.status)d, сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Initiator: %(iqn)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Ошибка при проверке инициатора: %(iqn)s, код возврата: %(ret.status)d, "
-"сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Pool: %(pool)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Ошибка при проверке пула: %(pool)s, код возврата: %(ret.status)d, сообщение: "
-"%(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Ошибка при проверке проекта %(project)s в пуле %(pool)s, код возврата: "
-"%(ret.status)d, сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Ошибка при проверке службы: %(service)s, код возврата: %(ret.status)d, "
-"сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying Target: %(alias)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Ошибка при проверке цели: %(alias)s, код возврата: %(ret.status)d, "
-"сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error Verifying share: %(share)s on Project: %(project)s and Pool: %(pool)s "
-"Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"Ошибка при проверке общего ресурса %(share)s в проекте %(project)s и пуле "
-"%(pool)s, код возврата: %(ret.status)d, сообщение: %(ret.data)s."
-
 msgid "Error connecting to ceph cluster."
 msgstr "Ошибка подключения к кластеру ceph."
 
@@ -1461,14 +1196,6 @@ msgstr "Ошибка во время а
 
 #, python-format
 msgid ""
-"Error editing share: %(share)s on Pool: %(pool)s Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Ошибка при изменении общего ресурса: %(share)s, пул: %(pool)s, код возврата: "
-"%(ret.status)d, сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
 "Error enabling iSER for NetworkPortal: please ensure that RDMA is supported "
 "on your iSCSI port %(port)d on ip %(ip)s."
 msgstr ""
@@ -1495,55 +1222,15 @@ msgstr "Ошибка расширени
 msgid "Error finding %(name)s."
 msgstr "Ошибка при поиске %(name)s."
 
-msgid ""
-"Error getting appliance version details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Ошибка получения сведений о версии устройства. Код возврата: %(ret.status)d "
-"Сообщение: %(ret.data)s."
-
 #, python-format
 msgid "Error getting domain id from name %(name)s: %(id)s."
 msgstr "Ошибка получения ИД домена из имени %(name)s: %(id)s."
 
-msgid "Error getting initiator groups."
-msgstr "Ошибка при получении групп инициаторов."
-
 #, python-format
 msgid "Error getting pool id from name %(pool_name)s: %(err_msg)s."
 msgstr "Ошибка получения ИД пула из имени %(pool_name)s: %(err_msg)s."
 
 #, python-format
-msgid ""
-"Error getting replication action: %(id)s. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Ошибка действия получения репликации %(id)s. Код возврата: %(ret.status)d "
-"Сообщение: %(ret.data)s."
-
-msgid ""
-"Error getting replication source details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Ошибка получения сведений об источнике репликации. Код возврата: %(ret."
-"status)d Сообщение: %(ret.data)s."
-
-msgid ""
-"Error getting replication target details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"Ошибка получения сведений о цели репликации. Код возврата: %(ret.status)d "
-"Сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error getting version: svc: %(svc)s.Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Ошибка при получении версии svc %(svc)s. Код возврата: %(ret.status)d "
-"Сообщение: %(ret.data)s."
-
-#, python-format
 msgid "Error in SolidFire API response: data=%(data)s"
 msgstr "Ошибка в ответе API SolidFire: data=%(data)s"
 
@@ -1551,22 +1238,6 @@ msgstr "Ошибка в ответе API
 msgid "Error managing volume: %s."
 msgstr "Ошибка управления томом: %s."
 
-#, python-format
-msgid ""
-"Error modifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"Ошибка изменения службы: %(service)s, код возврата: %(ret.status)d, "
-"сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error moving volume: %(vol)s from source project: %(src)s to target project: "
-"%(tgt)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Ошибка перемещения тома %(vol)s из исходного проекта %(src)s в целевой "
-"проект %(tgt)s, код возврата: %(ret.status)d, сообщение: %(ret.data)s."
-
 msgid "Error not a KeyError."
 msgstr "Тип ошибки отличается от KeyError."
 
@@ -1581,37 +1252,6 @@ msgid "Error retrieving volume size"
 msgstr "Ошибка получения размера тома"
 
 #, python-format
-msgid ""
-"Error sending replication update for action id: %(id)s . Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Ошибка передачи обновления репликации для ИД действия %(id)s. Код возврата: "
-"%(ret.status)d, сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error sending replication update. Returned error: %(err)s. Action: %(id)s."
-msgstr ""
-"Ошибка отправки обновления репликации. Возвращенная ошибка: %(err)s. "
-"Действие: %(id)s."
-
-#, python-format
-msgid ""
-"Error setting replication inheritance to %(set)s for volume: %(vol)s project "
-"%(project)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Ошибка установки значения наследования репликации %(set)s для тома %(vol)s. "
-"Проект %(project)s, код возврата: %(ret.status)d, сообщение: %(ret.data)s."
-
-#, python-format
-msgid ""
-"Error severing the package: %(package)s from source: %(src)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"Ошибка преобразования пакета %(package)s из источника %(src)s в локальный "
-"пакет. Код возврата: %(ret.status)d, сообщение: %(ret.data)s."
-
-#, python-format
 msgid "Error while authenticating with switch: %s."
 msgstr "Ошибка при идентификации на коммутаторе: %s."
 
@@ -1758,14 +1398,6 @@ msgid "FC is the protocol but wwpns are
 msgstr "Протокол - FC, но не получены WWPN от OpenStack."
 
 #, python-format
-msgid "Faield to unassign %(volume)s"
-msgstr "Отменить назначение %(volume)s не удалось"
-
-#, python-format
-msgid "Fail to create cache volume %(volume)s. Error: %(err)s"
-msgstr "Не удалось создать том кэша %(volume)s. Ошибка: %(err)s"
-
-#, python-format
 msgid "Failed adding connection for fabric=%(fabric)s: Error: %(err)s"
 msgstr ""
 "Не удалось добавить соединение для коммутируемой сети=%(fabric)s. Ошибка:"
@@ -1840,11 +1472,6 @@ msgid "Failed to connect to Dell REST AP
 msgstr "Не удается подключиться к API REST Dell"
 
 #, python-format
-msgid "Failed to connect to sheep daemon. addr: %(addr)s, port: %(port)s"
-msgstr ""
-"Не удалось подключиться к демону sheep. Адрес: %(addr)s, порт: %(port)s"
-
-#, python-format
 msgid "Failed to copy image to volume: %(reason)s"
 msgstr "Не удалось скопировать образ на том: %(reason)s"
 
@@ -1870,18 +1497,6 @@ msgid "Failed to create api volume flow.
 msgstr "Не удалось создать поток тома api."
 
 #, python-format
-msgid "Failed to create cg snapshot %(id)s due to %(reason)s."
-msgstr "Не удалось создать моментальную копию cg %(id)s, причина: %(reason)s."
-
-#, python-format
-msgid "Failed to create consistency group %(id)s due to %(reason)s."
-msgstr "Не удалось создать группу согласования %(id)s, причина: %(reason)s."
-
-#, python-format
-msgid "Failed to create consistency group %(id)s:%(ret)s."
-msgstr "Не удалось создать группу согласования %(id)s:%(ret)s."
-
-#, python-format
 msgid "Failed to create consistency group: %(cgid)s. Error: %(excmsg)s."
 msgstr "Не удалось создать группу согласования %(cgid)s. Ошибка: %(excmsg)s."
 
@@ -1944,15 +1559,6 @@ msgid "Failed to create volume %s"
 msgstr "Не удалось создать том %s"
 
 #, python-format
-msgid "Failed to delete cgsnapshot %(id)s due to %(reason)s."
-msgstr ""
-"Не удалось удалить моментальную копию cgsnapshot %(id)s, причина: %(reason)s."
-
-#, python-format
-msgid "Failed to delete consistency group %(id)s due to %(reason)s."
-msgstr "Не удалось удалить группу согласования %(id)s, причина: %(reason)s."
-
-#, python-format
 msgid ""
 "Failed to delete fileset for consistency group %(cgname)s. Error: %(excmsg)s."
 msgstr ""
@@ -2025,10 +1631,6 @@ msgid "Failed to find host %s."
 msgstr "Не найден хост %s."
 
 #, python-format
-msgid "Failed to find iSCSI initiator group containing %(initiator)s."
-msgstr "Не найдена группа инициаторов iSCSI, содержащая %(initiator)s."
-
-#, python-format
 msgid "Failed to get LUN target details for the LUN %s"
 msgstr "Не удалось получить целевые сведения LUN для LUN %s"
 
@@ -2140,14 +1742,6 @@ msgstr "Не удалось войти 
 msgid "Failed to login with all rest URLs."
 msgstr "Не удалось войти через все URL REST."
 
-#, python-format
-msgid ""
-"Failed to make a request to Datera cluster endpoint due to the following "
-"reason: %s"
-msgstr ""
-"Не удалось создать запрос к конечной точке кластера Datera по следующей "
-"причине: %s"
-
 msgid "Failed to manage api volume flow."
 msgstr "Сбой управления потоком тома api."
 
@@ -2352,30 +1946,6 @@ msgid "Failure staging LUN %s to tmp."
 msgstr "Сбой промежуточного копирования LUN %s в tmp."
 
 #, python-format
-msgid "Fexvisor failed to add volume %(id)s due to %(reason)s."
-msgstr "Fexvisor не удалось добавить том %(id)s, причина: %(reason)s."
-
-#, python-format
-msgid ""
-"Fexvisor failed to join the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr ""
-"Fexvisor не удалось добавить том %(vol)s в группу %(group)s. Причина: "
-"%(ret)s."
-
-#, python-format
-msgid ""
-"Fexvisor failed to remove the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr ""
-"Fexvisor не удалось удалить том %(vol)s из группы %(group)s. Причина: "
-"%(ret)s."
-
-#, python-format
-msgid "Fexvisor failed to remove volume %(id)s due to %(reason)s."
-msgstr "Fexvisor не удалось удалить том %(id)s. Причина: %(reason)s."
-
-#, python-format
 msgid "Fibre Channel SAN Lookup failure: %(reason)s"
 msgstr "Сбой поиска в SAN Fibre Channel: %(reason)s"
 
@@ -2392,10 +1962,6 @@ msgid "File %(file_path)s could not be f
 msgstr "Файл %(file_path)s не может быть найден."
 
 #, python-format
-msgid "File already exists at %s."
-msgstr "Файл уже существует в %s."
-
-#, python-format
 msgid "File already exists at: %s"
 msgstr "Файл уже существует в %s"
 
@@ -2426,179 +1992,6 @@ msgstr ""
 "%(fcache_version)s %(version)s была установлена."
 
 #, python-format
-msgid "Flexvisor assign volume failed.:%(id)s:%(status)s."
-msgstr "Flexvisor не удалось назначить том: %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor assign volume failed:%(id)s:%(status)s."
-msgstr "Flexvisor не удалось назначить том: %(id)s:%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor could not find volume %(id)s snapshot in the group %(vgid)s "
-"snapshot %(vgsid)s."
-msgstr ""
-"Flexvisor не удалось найти моментальную копию тома %(id)s в группе %(vgid)s. "
-"Моментальная копия: %(vgsid)s."
-
-#, python-format
-msgid "Flexvisor create volume failed.:%(volumeid)s:%(status)s."
-msgstr "Flexvisor не удалось создать том: %(volumeid)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor failed deleting volume %(id)s: %(status)s."
-msgstr "Flexvisor не удалось удалить том %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to add volume %(id)s to group %(cgid)s."
-msgstr "Flexvisor не удалось добавить том %(id)s в группу %(cgid)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to assign volume %(id)s due to unable to query status by "
-"event id."
-msgstr ""
-"Flexvisor не удалось назначить том %(id)s из-за невозможности запросить "
-"состояние по ИД события."
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(id)s: %(status)s."
-msgstr "Flexvisor не удалось назначить том %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(volume)s iqn %(iqn)s."
-msgstr "Flexvisor не удалось назначить том %(volume)s: %(iqn)s."
-
-#, python-format
-msgid "Flexvisor failed to clone volume %(id)s: %(status)s."
-msgstr "Flexvisor не удалось скопировать том %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to clone volume (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor не удалось скопировать том (не удалось получить событие) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to create snapshot for volume %(id)s: %(status)s."
-msgstr ""
-"Flexvisor не удалось создать моментальную копию тома %(id)s: %(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to create snapshot for volume (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor не удалось создать моментальную копию тома (не удалось получить "
-"событие) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume %(id)s in the group %(vgid)s."
-msgstr "Flexvisor не удалось создать том %(id)s в группе %(vgid)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume %(volume)s: %(status)s."
-msgstr "Flexvisor не удалось создать том %(volume)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume (get event) %s."
-msgstr "Flexvisor не удалось создать том (получить событие) %s."
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s: %(status)s."
-msgstr ""
-"Flexvisor не удалось создать том из моментальной копии %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s:%(status)s."
-msgstr ""
-"Flexvisor не удалось создать том из моментальной копии %(id)s:%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to create volume from snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor не удалось создать том из моментальной копии (не удалось получить "
-"событие) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot %(id)s: %(status)s."
-msgstr "Flexvisor не удалось удалить моментальную копию %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor не удалось удалить моментальную копию (не удалось получить "
-"событие) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to delete volume %(id)s: %(status)s."
-msgstr "Flexvisor не удалось удалить том %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s: %(status)s."
-msgstr "Flexvisor не удалось расширить том %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s:%(status)s."
-msgstr "Flexvisor не удалось расширить том %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to extend volume (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor не удалось расширить том (не удалось получить событие) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to get pool info %(id)s: %(status)s."
-msgstr "Flexvisor не удалось получить информацию о пуле %(id)s: %(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to get snapshot id of volume %(id)s from group %(vgid)s."
-msgstr ""
-"Flexvisor не удалось получить ИД моментальной копии тома %(id)s из группы "
-"%(vgid)s."
-
-#, python-format
-msgid "Flexvisor failed to remove volume %(id)s from group %(cgid)s."
-msgstr "Flexvisor не удалось удалить том %(id)s из группы %(cgid)s."
-
-#, python-format
-msgid "Flexvisor failed to spawn volume from snapshot %(id)s:%(status)s."
-msgstr ""
-"Flexvisor не удалось породить том из моментальной копии %(id)s:%(status)s."
-
-#, python-format
-msgid ""
-"Flexvisor failed to spawn volume from snapshot (failed to get event) %(id)s."
-msgstr ""
-"Flexvisor не удалось породить том из моментальной копии (не удалось получить "
-"событие) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume %(id)s: %(status)s."
-msgstr "Flexvisor не удалось отменить назначение тома %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume (get event) %(id)s."
-msgstr ""
-"Flexvisor не удалось отменить назначение тома (получить событие) %(id)s."
-
-#, python-format
-msgid "Flexvisor failed to unassign volume:%(id)s:%(status)s."
-msgstr "Flexvisor не удалось отменить назначение тома %(id)s: %(status)s."
-
-#, python-format
-msgid "Flexvisor unable to find the source volume %(id)s info."
-msgstr "Flexvisor не удалось найти информацию об исходном томе %(id)s."
-
-#, python-format
-msgid "Flexvisor unassign volume failed:%(id)s:%(status)s."
-msgstr "Flexvisor не удалось отменить назначение тома: %(id)s:%(status)s."
-
-#, python-format
-msgid "Flexvisor volume %(id)s failed to join group %(vgid)s."
-msgstr "Тому Flexvisor %(id)s не удалось присоединить группу %(vgid)s."
-
-#, python-format
 msgid "Folder %s does not exist in Nexenta Store appliance"
 msgstr "Папка %s не существует в устройстве Nexenta Store"
 
@@ -2919,14 +2312,6 @@ msgid "Invalid Replication Target: %(rea
 msgstr "Недопустимый целевой объект репликации: %(reason)s"
 
 #, python-format
-msgid ""
-"Invalid Virtuozzo Storage share specification: %r. Must be: [MDS1[,"
-"MDS2],...:/]<CLUSTER NAME>[:PASSWORD]."
-msgstr ""
-"Недопустимая спецификация общего ресурса Virtuozzo Storage: %r. Должно быть: "
-"[MDS1[,MDS2],...:/]<ИМЯ-КЛАСТЕРА>[:ПАРОЛЬ]."
-
-#, python-format
 msgid "Invalid XtremIO version %(cur)s, version %(min)s or up is required"
 msgstr "Недопустимая версия XtremIO %(cur)s, требуется версия не ниже %(min)s"
 
@@ -2934,13 +2319,6 @@ msgstr "Недопустимая вер
 msgid "Invalid allocated quotas defined for the following project quotas: %s"
 msgstr "Неправильно определены квоты для следующего проекта: %s"
 
-msgid "Invalid argument - negative seek offset."
-msgstr "Недопустимый аргумент - отрицательное смещение функции seek."
-
-#, python-format
-msgid "Invalid argument - whence=%s not supported."
-msgstr "Недопустимый аргумент - whence=%s не поддерживается."
-
 #, python-format
 msgid "Invalid attaching mode '%(mode)s' for volume %(volume_id)s."
 msgstr "Недопустимый режим подключения %(mode)s для тома %(volume_id)s."
@@ -2954,16 +2332,6 @@ msgid "Invalid backup: %(reason)s"
 msgstr "Недопустимая резервная копия: %(reason)s"
 
 #, python-format
-msgid "Invalid connection initialization response of volume %(name)s"
-msgstr "Недопустимый ответ об инициализации соединения от тома %(name)s:"
-
-#, python-format
-msgid ""
-"Invalid connection initialization response of volume %(name)s: %(output)s"
-msgstr ""
-"Недопустимый ответ об инициализации соединения от тома %(name)s: %(output)s"
-
-#, python-format
 msgid "Invalid content type %(content_type)s."
 msgstr "Недопустимый тип содержимого %(content_type)s."
 
@@ -3051,10 +2419,6 @@ msgid "Invalid mount point base: %s"
 msgstr "Недопустимая база точки монтирования: %s"
 
 #, python-format
-msgid "Invalid mount point base: %s."
-msgstr "Недопустимая база точки монтирования: %s."
-
-#, python-format
 msgid "Invalid new snapCPG name for retype.  new_snap_cpg='%s'."
 msgstr "Недопустимое новое имя snapCPG для изменения типа. new_snap_cpg='%s'."
 
@@ -3073,9 +2437,6 @@ msgstr "Недопустимый вто
 msgid "Invalid service catalog json."
 msgstr "Недопустимый json каталога службы."
 
-msgid "Invalid sheepdog cluster status."
-msgstr "Недопустимое состояние кластера sheepdog."
-
 #, python-format
 msgid "Invalid snapshot: %(reason)s"
 msgstr "Недопустимая моментальная копия: %(reason)s"
@@ -3159,10 +2520,6 @@ msgstr ""
 "Указано недопустимое значение volume_type: %s (запрошенный тип должен "
 "поддерживаться данной группой согласования)."
 
-#, python-format
-msgid "Invalid wwpns format %(wwpns)s"
-msgstr "Недопустимый формат wwpns %(wwpns)s"
-
 msgid "Issue encountered waiting for job."
 msgstr "Во время ожидания задания обнаружена неполадка."
 
@@ -3174,10 +2531,6 @@ msgid ""
 msgstr ""
 "Переключение после сбоя невозможно, так как репликация настроена неверно."
 
-#, python-format
-msgid "KeyError: %s"
-msgstr "KeyError: %s"
-
 msgid "Keystone version 3 or greater must be used to get nested quota support."
 msgstr "Поддержка вложенных квот доступна в keystone версии не ниже 3."
 
@@ -3475,9 +2828,6 @@ msgstr ""
 msgid "New volume type not specified in request_spec."
 msgstr "Новый тип тома не указан в request_spec."
 
-msgid "Nimble Cinder Driver exception"
-msgstr "Исключительная ситуация драйвера Nimble Cinder"
-
 msgid "No FC initiator can be added to host."
 msgstr "Инициатор Fibre Channel не добавлен в хост."
 
@@ -3516,10 +2866,6 @@ msgid "No initiator connected to fabric.
 msgstr "Никакой инициатор не подключен к фабрике."
 
 #, python-format
-msgid "No initiator group found for initiator %s"
-msgstr "Группа инициатора не найдена для инициатора %s"
-
-#, python-format
 msgid "No interface found on cluster for ip %s"
 msgstr "В кластере не найден интерфейс для ip-адреса %s"
 
@@ -3532,9 +2878,6 @@ msgstr "Не обнаружено смо
 msgid "No mounted SMBFS shares found."
 msgstr "Не обнаружено смонтированных общих ресурсов SMBFS."
 
-msgid "No mounted Virtuozzo Storage shares found"
-msgstr "Не найдены смонтированные общие ресурсы Virtuozzo Storage"
-
 msgid "No mounted shares found"
 msgstr "Не обнаружено смонтированных общих ресурсов"
 
@@ -3557,9 +2900,6 @@ msgstr "Не найдена момент
 msgid "No such QoS spec %(specs_id)s."
 msgstr "Нет такой спецификации QoS: %(specs_id)s."
 
-msgid "No suitable discovery ip found"
-msgstr "Подходящий поисковый IP не найден"
-
 #, python-format
 msgid "No support to restore backup version %s"
 msgstr "Нет поддержки восстановления резервной версии %s"
@@ -3596,11 +2936,6 @@ msgstr "Не авторизирован
 msgid "Not enough space on backend (%(backend)s)"
 msgstr "Недостаточно места на базовом сервере (%(backend)s)"
 
-msgid "Not enough storage space in the ZFS share to perform this operation."
-msgstr ""
-"В общем ресурсе ZFS отсутствует свободное пространство для выполнения этой "
-"операции."
-
 msgid "Not stored in rbd"
 msgstr "Не сохранено в rbd"
 
@@ -3635,11 +2970,6 @@ msgstr ""
 "Только пользователи с маркером, связанным с непосредственными родительскими "
 "объектами и корневыми проектами могут просматривать квоты дочерних элементов."
 
-msgid "Only volumes managed by OpenStack can be unmanaged."
-msgstr ""
-"Вывести из-под управления можно только тома, находящиеся под управлением "
-"OpenStack."
-
 #, python-format
 msgid "Operation failed with status=%(status)s. Full dump: %(data)s"
 msgstr "Операция не выполнена, состояние=%(status)s. Полный дамп: %(data)s"
@@ -3683,9 +3013,6 @@ msgstr "Политика не допус
 msgid "Pool is not available in the volume host field."
 msgstr "Не указан пул в поле хоста тома."
 
-msgid "Pool is not available in the volume host fields."
-msgstr "Пул недоступен в полях хоста тома."
-
 #, python-format
 msgid "Pool with name %(pool_name)s wasn't found in domain %(domain_id)s."
 msgstr "Не найден пул с именем %(pool_name)s в домене %(domain_id)s."
@@ -3824,17 +3151,6 @@ msgstr "Указатель должен
 msgid "Reference must contain source-name."
 msgstr "Ссылка должна содержать элемент source-name."
 
-msgid "Reference to volume to be managed must contain source-name."
-msgstr ""
-"Ссылка на том, передаваемый под управление, должна содержать элемент source-"
-"name."
-
-#, python-format
-msgid "Reference to volume: %s to be managed must contain source-name."
-msgstr ""
-"Ссылка на том %s, передаваемый под управление, должна содержать элемент "
-"source-name."
-
 #, python-format
 msgid ""
 "Refusing to migrate volume ID: %(id)s. Please check your configuration "
@@ -3896,11 +3212,6 @@ msgid "Request body contains too many it
 msgstr "Тело запроса содержит избыточное количество объектов"
 
 #, python-format
-msgid "Request to Datera cluster returned bad status: %(status)s | %(reason)s"
-msgstr ""
-"Запрос к кластеру Datera вернул неверное состояние: %(status)s | %(reason)s"
-
-#, python-format
 msgid ""
 "Requested backup exceeds allowed Backup gigabytes quota. Requested "
 "%(requested)sG, quota is %(quota)sG and %(consumed)sG has been consumed."
@@ -4016,11 +3327,6 @@ msgid "SMBFS config file not set (smbfs_
 msgstr "Файл конфигурации SMBFS не указан (smbfs_shares_config)."
 
 #, python-format
-msgid "SSH Command failed after '%(total_attempts)r' attempts : '%(command)s'"
-msgstr ""
-"После '%(total_attempts)r' попыток не выполнена команда SSH: '%(command)s'"
-
-#, python-format
 msgid "SSH command injection detected: %(command)s"
 msgstr "Обнаружено внедрение команды SSH: %(command)s"
 
@@ -4066,10 +3372,6 @@ msgstr "Ошибка настройки
 msgid "Sets thin provisioning."
 msgstr "Задает тонкое резервирование."
 
-#, python-format
-msgid "Sheepdog I/O Error, command was: \"%s\"."
-msgstr "Ошибка ввода-вывода Sheepdog, команда: \"%s\"."
-
 msgid ""
 "Show operations can only be made to projects in the same hierarchy of the "
 "project in which users are scoped to."
@@ -4259,14 +3561,6 @@ msgstr ""
 "Уровень выпуска файловой системы GPFS %(fs)s не соответствует требуемому. "
 "Текущий уровень - %(cur)s, должен быть %(min)s."
 
-#, python-format
-msgid ""
-"The WebDAV request failed. Reason: %(msg)s, Return code/reason: %(code)s, "
-"Source Volume: %(src)s, Destination Volume: %(dst)s, Method: %(method)s."
-msgstr ""
-"Запрос WebDAV не выполнен. Причина: %(msg)s, Код возврата/причина: %(code)s, "
-"Исходный том: %(src)s, Целевой том: %(dst)s, Метод: %(method)s."
-
 msgid ""
 "The above error may show that the database has not been created.\n"
 "Please create a database using 'cinder-manage db sync' before running this "
@@ -4343,9 +3637,6 @@ msgid "The snapshot cannot be created wh
 msgstr ""
 "Моментальную копию нельзя создать, когда том находится в режиме обслуживания."
 
-msgid "The source volume for this WebDAV operation not found."
-msgstr "Не найден исходный том для этой операции WebDAV."
-
 #, python-format
 msgid ""
 "The source volume type '%(src)s' is different than the destination volume "
@@ -4542,10 +3833,6 @@ msgid "Type cannot be converted into NaE
 msgstr "Тип невозможно преобразовать в NaElement."
 
 #, python-format
-msgid "TypeError: %s"
-msgstr "TypeError: %s"
-
-#, python-format
 msgid "UUIDs %s are in both add and remove volume list."
 msgstr ""
 "UUID %s находятся и в списке добавления томов, и в списке удаления томов."
@@ -4803,9 +4090,6 @@ msgid "Unexpected output. Expected [%(ex
 msgstr ""
 "Непредвиденный вывод. Вместо ожидаемого [%(expected)s] получен [%(output)s]"
 
-msgid "Unexpected response from Nimble API"
-msgstr "Непредвиденный ответ от API Nimble"
-
 msgid "Unexpected status code"
 msgstr "Непредвиденный код состояния"
 
@@ -4826,41 +4110,10 @@ msgstr "Неизвестная искл
 msgid "Unknown SMBFS exception."
 msgstr "Неизвестная исключительная ситуация в SMBFS."
 
-msgid "Unknown Virtuozzo Storage exception"
-msgstr "Неизвестная исключительная ситуация Virtuozzo Storage"
-
 msgid "Unknown action"
 msgstr "Неизвестное действие"
 
 #, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, Set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"Не удаётся установить, передан ли уже том %s под управление Cinder. Передача "
-"под управление прервана. Добавьте пользовательское свойство схемы "
-"'cinder_managed' для тома и присвойте ему значение False. Для устранения "
-"этого ограничения также можно присвоить свойству 'zfssa_manage_policy' "
-"значение 'loose'."
-
-#, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"Не удаётся установить, передан ли уже том %s под управление Cinder. Передача "
-"под управление прервана. Добавьте пользовательское свойство схемы "
-"'cinder_managed' для тома и присвойте ему значение False. Для устранения "
-"этого ограничения также можно присвоить свойству 'zfssa_manage_policy' "
-"значение 'loose'."
-
-#, python-format
 msgid "Unknown or unsupported command %(cmd)s"
 msgstr "Неизвестная или неподдерживаемая команда %(cmd)s"
 
@@ -4967,9 +4220,6 @@ msgstr "ID пользователя"
 msgid "User does not have admin privileges"
 msgstr "Пользователь не имеет административных привилегий"
 
-msgid "User not authorized to perform WebDAV operations."
-msgstr "У пользователя нет прав доступа для выполнения операций WebDAV."
-
 msgid "UserName is not configured."
 msgstr "UserName не настроен."
 
@@ -4998,10 +4248,6 @@ msgstr ""
 "Значение \"%(value)s\" недопустимо для параметра конфигурации \"%(option)s\""
 
 #, python-format
-msgid "ValueError: %s"
-msgstr "ValueError: %s"
-
-#, python-format
 msgid "Vdisk %(name)s not involved in mapping %(src)s -> %(tgt)s."
 msgstr "Vdisk %(name)s не участвует в связи %(src)s -> %(tgt)s."
 
@@ -5098,24 +4344,10 @@ msgid "Volume %s does not exist on the a
 msgstr "Том %s не существует в массиве."
 
 #, python-format
-msgid "Volume %s does not have provider_location specified, skipping."
-msgstr "Для тома %s не указан параметр provider_location - пропущено."
-
-#, python-format
 msgid "Volume %s doesn't exist on array."
 msgstr "Том %s не существует в массиве."
 
 #, python-format
-msgid "Volume %s doesn't exist on the ZFSSA backend."
-msgstr "Том %s не существует в базовой системе ZFSSA."
-
-#, python-format
-msgid ""
-"Volume %s is online. Set volume to offline for managing using OpenStack."
-msgstr ""
-"Том %s включен. Выключите его, чтобы передать под управление OpenStack."
-
-#, python-format
 msgid "Volume %s must not be part of a consistency group."
 msgstr "Том %s не должен быть частью группы согласования."
 
@@ -5254,9 +4486,6 @@ msgstr "Том не связан с хо
 msgid "Volume replication for %(volume_id)s could not be found."
 msgstr "Копия тома %(volume_id)s не найдена."
 
-msgid "Volume should have agent-type set as None."
-msgstr "В параметре agent-type тома должно быть указано значение None."
-
 #, python-format
 msgid ""
 "Volume size %(volume_size)sGB cannot be smaller than the image minDisk size "
@@ -5298,9 +4527,6 @@ msgstr "Размер тома долже
 msgid "Volume size must multiple of 1 GB."
 msgstr "Размер тома должен быть кратен 1 ГБ."
 
-msgid "Volume status must be 'available'."
-msgstr "Состояние тома должно быть available."
-
 msgid "Volume to Initiator Group mapping already exists"
 msgstr "Связь тома с группой инициаторов уже существует"
 
@@ -5354,10 +4580,6 @@ msgstr "Имя типа тома не д
 msgid "Volume type with name %(volume_type_name)s could not be found."
 msgstr "Тип тома под названием %(volume_type_name)s не может быть найден."
 
-#, python-format
-msgid "Volume: %s is already being managed by Cinder."
-msgstr "Том %s уже находится под управлением Cinder."
-
 msgid ""
 "Volumes/account exceeded on both primary and secondary SolidFire accounts."
 msgstr ""
@@ -5365,26 +4587,9 @@ msgstr ""
 "SolidFire."
 
 #, python-format
-msgid ""
-"VzStorage config 'vzstorage_used_ratio' invalid. Must be > 0 and <= 1.0: %s."
-msgstr ""
-"Конфигурация VzStorage 'vzstorage_used_ratio' недопустима. Значение должно "
-"быть больше 0 и не больше 1,0: %s."
-
-#, python-format
-msgid "VzStorage config file at %(config)s doesn't exist."
-msgstr "Файл конфигурации VzStorage в %(config)s не существует."
-
-#, python-format
 msgid "Wait synchronize failed. Running status: %s."
 msgstr "Ошибка ожидания синхронизации. Состояние выполнения: %s."
 
-msgid ""
-"Waiting for all nodes to join cluster. Ensure all sheep daemons are running."
-msgstr ""
-"Ожидание добавления всех узлов в кластер. Убедитесь, что работают все демоны "
-"sheep."
-
 msgid "We should not do switch over on primary array."
 msgstr "Переключение для основного массива не разрешено."
 
@@ -6109,9 +5314,6 @@ msgstr "extend_volume, имя тома:
 msgid "fake"
 msgstr "поддельный"
 
-msgid "fileno is not supported by SheepdogIOWrapper"
-msgstr "fileno не поддерживается SheepdogIOWrapper"
-
 #, python-format
 msgid "fmt=%(fmt)s backed by: %(backing_file)s"
 msgstr "fmt=%(fmt)s backed by: %(backing_file)s"
@@ -6160,13 +5362,6 @@ msgstr ""
 "Параметру gpfs_images_share_mode присвоено значение copy_on_write, но "
 "%(vol)s и %(img)s относятся к разным наборам файлов."
 
-msgid ""
-"http service may have been abruptly disabled or put to maintenance state in "
-"the middle of this operation."
-msgstr ""
-"Служба http может быть неожиданно отключена или переведена в режим "
-"обслуживания посреди выполнения операции."
-
 msgid "id cannot be None"
 msgstr "Недопустимое значение для ИД: None"
 
@@ -6458,11 +5653,3 @@ msgstr "тома присвоены"
 
 msgid "volumes changed"
 msgstr "тома изменены"
-
-#, python-format
-msgid ""
-"zfssa_manage_policy property needs to be set to 'strict' or 'loose'. Current "
-"value is: %s."
-msgstr ""
-"Свойству zfssa_manage_policy должно быть присвоено значение 'strict' или "
-"'loose'. Текущее значение: %s."
diff -pruN 2:15.0.1-1/cinder/locale/zh_CN/LC_MESSAGES/cinder.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/zh_CN/LC_MESSAGES/cinder.po
--- 2:15.0.1-1/cinder/locale/zh_CN/LC_MESSAGES/cinder.po	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/zh_CN/LC_MESSAGES/cinder.po	2020-03-24 18:46:31.000000000 +0000
@@ -19,7 +19,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: cinder VERSION\n"
 "Report-Msgid-Bugs-To: https://bugs.launchpad.net/openstack-i18n/\n"
-"POT-Creation-Date: 2019-10-04 05:27+0000\n"
+"POT-Creation-Date: 2020-03-18 14:40+0000\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
@@ -130,10 +130,6 @@ msgstr ""
 "映像或文件备份，实际方式为 %(vol_mode)s。"
 
 #, python-format
-msgid "%(service)s Service is not %(status)s on storage appliance: %(host)s"
-msgstr "在以下存储设备上，%(service)s 服务并非处于 %(status)s 状态：%(host)s"
-
-#, python-format
 msgid ""
 "%(worker_name)s value of %(workers)d is invalid, must be greater than 0."
 msgstr "%(workers)d 的 %(worker_name)s 值无效，必须大于 0。"
@@ -182,10 +178,6 @@ msgid "%s is not installed"
 msgstr "未安装 %s"
 
 #, python-format
-msgid "%s is not installed."
-msgstr "未安装 %s。"
-
-#, python-format
 msgid "%s is not set"
 msgstr "未设置 %s "
 
@@ -206,10 +198,6 @@ msgid "%s must be an absolute path."
 msgstr "%s 必须为绝对路径。"
 
 #, python-format
-msgid "%s not set in cinder.conf"
-msgstr "cinder.conf 中未设置 %s"
-
-#, python-format
 msgid "%s not set."
 msgstr "未设置 %s。"
 
@@ -234,14 +222,6 @@ msgstr "必须指定“consistencygroup_
 msgid "'qemu-img info' parsing failed."
 msgstr "'qemu-img info'解析失败"
 
-#, python-format
-msgid ""
-"(Command: %(cmd)s) (Return Code: %(exit_code)s) (Stdout: %(stdout)s) "
-"(Stderr: %(stderr)s)"
-msgstr ""
-"（命令：%(cmd)s）（返回码：%(exit_code)s）（标准输出：%(stdout)s）（标准错"
-"误：%(stderr)s）"
-
 msgid "400 Bad Request"
 msgstr "400 错误请求"
 
@@ -333,10 +313,6 @@ msgid "An error has occurred during back
 msgstr "在备份过程中出现一个错误"
 
 #, python-format
-msgid "An error has occurred in SheepdogDriver. (Reason: %(reason)s)"
-msgstr "SheepdogDriver中发生了错误。（原因:%(reason)s）"
-
-#, python-format
 msgid ""
 "An error occurred during the LUNcopy operation. LUNcopy name: "
 "%(luncopyname)s. LUNcopy status: %(luncopystatus)s. LUNcopy state: "
@@ -345,18 +321,6 @@ msgstr ""
 "在 LUNcopy 操作期间发生错误。LUNcopy 名称为 %(luncopyname)s。LUNcopy 状态为 "
 "%(luncopystatus)s。LUNcopy 状态为 %(luncopystate)s。"
 
-#, python-format
-msgid "An error occurred while reading volume \"%s\"."
-msgstr "读取卷“%s”时发生错误。"
-
-#, python-format
-msgid "An error occurred while seeking for volume \"%s\"."
-msgstr "查找卷“%s”时发生错误。"
-
-#, python-format
-msgid "An error occurred while writing to volume \"%s\"."
-msgstr "写入卷“%s”时发生错误。"
-
 msgid "An unknown error occurred."
 msgstr "发生未知错误。"
 
@@ -430,9 +394,6 @@ msgstr "可用的类别："
 msgid "Backend doesn't exist (%(backend)s)"
 msgstr "后端不存在 (%(backend)s)"
 
-msgid "Backend storage did not configure fiber channel target."
-msgstr "后端存储器未配置光纤通道目标。"
-
 msgid "Backing up an in-use volume must use the force flag."
 msgstr "备份一个正在使用的卷时必须使用强制标志。"
 
@@ -542,10 +503,6 @@ msgstr ""
 msgid "CPG (%s) doesn't exist on array"
 msgstr "数组中不存在 CPG (%s)"
 
-#, python-format
-msgid "Cache volume %s does not have required properties"
-msgstr "高速缓存卷 %s 没有必需属性。"
-
 msgid "Can not add FC port to host."
 msgstr "无法将 FC 端口添加至主机。"
 
@@ -695,10 +652,6 @@ msgid ""
 "list %(vf_list)s."
 msgstr "无法更改 VF 上下文，指定的 VF 在管理 VF 列表 %(vf_list)s 中不可用。"
 
-#, python-format
-msgid "Cannot create directory %s."
-msgstr "无法创建目录 %s。"
-
 msgid "Cannot create encryption specs. Volume type in use."
 msgstr "无法创建加密规范。卷类型在使用中。"
 
@@ -735,22 +688,6 @@ msgstr "无法创建大小为 %s 的卷
 msgid "Cannot create volume_type with name %(name)s and specs %(extra_specs)s"
 msgstr "无法创建名称为 %(name)s 规格为 %(extra_specs)s 的卷类型。"
 
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)d volume instances."
-msgstr ""
-"无法删除高速缓存卷：%(cachevol_name)s。在 %(updated_at)s 对其进行了更新，它当"
-"前具有 %(numclones)d 卷实例。"
-
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)s volume instances."
-msgstr ""
-"无法删除高速缓存卷：%(cachevol_name)s。在 %(updated_at)s 对其进行了更新，它当"
-"前具有 %(numclones)s 卷实例。"
-
 msgid "Cannot delete encryption specs. Volume type in use."
 msgstr "无法删除加密规范。卷类型在使用中。"
 
@@ -847,9 +784,6 @@ msgid ""
 "Change would make usage less than 0 for the following resources: %(unders)s"
 msgstr "对于下列资源，更改将导致使用量小于 0：%(unders)s"
 
-msgid "Check access permissions for the ZFS share assigned to this driver."
-msgstr "请检查分配给此驱动程序的 ZFS 共享项的访问许可权。"
-
 msgid "Check hostgroup associate error."
 msgstr "检查主机组关联时发生错误。"
 
@@ -865,13 +799,6 @@ msgstr "检查 LUN 组关联时发生错
 msgid "Check portgroup associate error."
 msgstr "检查端口组关联时发生错误。"
 
-msgid ""
-"Check the state of the http service. Also ensure that the https port number "
-"is the same as the one specified in cinder.conf."
-msgstr ""
-"请检查 HTTP 服务的状态。另外，请确保 HTTPS 端口号与 cinder.conf 中指定的 "
-"HTTPS 端口号相同。"
-
 msgid "Chunk size is not multiple of block size for creating hash."
 msgstr "区块大小不是用于创建散列的块大小的倍数。"
 
@@ -905,10 +832,6 @@ msgstr "集群 %(name)s 已存在。"
 msgid "Cluster %s successfully removed."
 msgstr "成功删除集群 %s。"
 
-msgid ""
-"Cluster is not formatted. You should probably perform \"dog cluster format\"."
-msgstr "集群未格式化。您可能应该执行“dog cluster format”。"
-
 #, python-format
 msgid "CommandLineHelper._wait_for_condition: %s timeout."
 msgstr "CommandLineHelper._wait_for_condition：%s 超时。"
@@ -923,10 +846,6 @@ msgstr "找不到计算集群 %(cluster)
 msgid "Condition has no field."
 msgstr "条件没有任何字段。"
 
-#, python-format
-msgid "Config 'max_over_subscription_ratio' invalid. Must be > 0: %s"
-msgstr "配置“max_over_subscription_ratio”无效。必须大于 0：%s"
-
 msgid "Configuration error: dell_sc_ssn not set."
 msgstr "配置错误：未设置 dell_sc_ssn。"
 
@@ -977,6 +896,10 @@ msgid "Converted to %(f1)s, but format i
 msgstr "已转换为 %(f1)s，但现在格式为 %(f2)s"
 
 #, python-format
+msgid "Converted to %(vol_format)s, but format is now %(file_format)s"
+msgstr "已转换为 %(vol_format)s，但现在格式为 %(file_format)s"
+
+#, python-format
 msgid "Converted to raw, but format is now %s"
 msgstr "转化为裸格式，但目前格式是 %s"
 
@@ -1357,185 +1280,6 @@ msgstr "启用复制。"
 msgid "Ensure that configfs is mounted at /sys/kernel/config."
 msgstr "请确保 configfs 安装在 /sys/kernel/config 处。"
 
-#, python-format
-msgid ""
-"Error Cloning Snapshot: %(snapshot)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Clone project: %(clone_proj)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"在池 %(pool)s 的卷 %(lun)s 上克隆快照 %(snapshot)s 时出错。项目：%(project)s "
-"克隆项目：%(clone_proj)s返回码：%(ret.status)d 消息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Creating Initiator: %(initiator)s on Alias: %(alias)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"对别名 %(alias)s 创建发起方 %(initiator)s 时出错。返回码：%(ret.status)d 消"
-"息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Creating Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"在池 %(pool)s 上创建项目 %(project)s 时出错。返回码：%(ret.status)d 消息："
-"%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Creating Property: %(property)s Type: %(type)s Description: "
-"%(description)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"创建属性 %(property)s、类型 %(type)s 和描述 %(description)s 时出错。返回码："
-"%(ret.status)d 消息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Creating Share: %(name)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"创建共享项 %(name)s 时出错。返回码：%(ret.status)d 消息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Creating Volume: %(lun)s Size: %(size)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"创建大小为 %(size)s 的卷 %(lun)s 时出错。返回码：%(ret.status)d消息："
-"%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Share: %(share)s to Pool: %(pool)s "
-"Project: %(project)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"在共享项 %(share)s 上对池 %(pool)s 删除快照 %(snapshot)s 时出错。项目："
-"%(project)s 返回码：%(ret.status)d 消息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Volume: %(lun)s to Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"在卷 %(lun)s 上对池 %(pool)s 删除快照 %(snapshot)s 时出错。项目：%(project)s "
-"返回码：%(ret.status)d 消息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Deleting Volume: %(lun)s from Pool: %(pool)s, Project: %(project)s. "
-"Return code: %(ret.status)d, Message: %(ret.data)s."
-msgstr ""
-"从池 %(pool)s 中删除卷 %(lun)s 时出错，项目：%(project)s。返回码："
-"%(ret.status)d，消息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Deleting project: %(project)s on pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"删除池 %(pool)s 上的项目 %(project)s 时出错。返回码：%(ret.status)d 消息："
-"%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Deleting replication action: %(id)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"删除复制操作 %(id)s 时出错。返回码：%(ret.status)d 消息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Getting Initiators: InitiatorGroup: %(initiatorgroup)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"获取发起方时出错：发起方组为 %(initiatorgroup)s，返回码为 %(ret.status)d 消"
-"息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Getting Pool Stats: Pool: %(pool)s Return code: %(status)d Message: "
-"%(data)s."
-msgstr "获取池统计信息时出错：池：%(pool)s 返回码：%(status)d 消息：%(data)s。"
-
-#, python-format
-msgid ""
-"Error Getting Project Stats: Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"获取项目状态时出错：池：%(pool)s 项目：%(project)s返回码：%(ret.status)d 消"
-"息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Getting Share: %(share)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"在池 %(pool)s 上获取共享项 %(share)s 时出错。项目：%(project)s 返回码："
-"%(ret.status)d 消息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Getting Volume: %(lun)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"在池 %(pool)s 上获取卷 %(lun)s 时出错。项目：%(project)s 返回码："
-"%(ret.status)d 消息：%(ret.data)s。"
-
-#, python-format
-msgid "Error Pool ownership: Pool %(pool)s is not owned by %(host)s."
-msgstr "池所有权出错：池 %(pool)s 并非归 %(host)s 所有。"
-
-#, python-format
-msgid ""
-"Error Setting props Props: %(props)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"在池 %(pool)s 的卷 %(lun)s 上设置属性 Props %(props)s 时出错。项目："
-"%(project)s 返回码：%(ret.status)d 消息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying Initiator: %(iqn)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"验证启动程序 %(iqn)s 时出错。返回码：%(ret.status)d 消息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying Pool: %(pool)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr "验证池 %(pool)s 时出错。返回码：%(ret.status)d 消息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"在池 %(pool)s 上验证项目 %(project)s 时出错。返回码：%(ret.status)d，消息："
-"%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"验证服务 %(service)s 时出错。返回码：%(ret.status)d 消息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying Target: %(alias)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr "验证目标 %(alias)s 时出错。返回码：%(ret.status)d 消息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying share: %(share)s on Project: %(project)s and Pool: %(pool)s "
-"Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"在项目 %(project)s 和池 %(pool)s 上验证共享项 %(share)s 时出错。返回码为 "
-"%(ret.status)d，消息为 %(ret.data)s。"
-
 msgid "Error connecting to ceph cluster."
 msgstr "连接至 ceph 集群时出错。"
 
@@ -1564,14 +1308,6 @@ msgstr "在评估程序解析期间，
 
 #, python-format
 msgid ""
-"Error editing share: %(share)s on Pool: %(pool)s Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"在池 %(pool)s 上编辑共享项 %(share)s 时出错。返回码：%(ret.status)d，消息："
-"%(ret.data)s。"
-
-#, python-format
-msgid ""
 "Error enabling iSER for NetworkPortal: please ensure that RDMA is supported "
 "on your iSCSI port %(port)d on ip %(ip)s."
 msgstr ""
@@ -1598,49 +1334,15 @@ msgstr "扩展卷时出错：%(reason)s"
 msgid "Error finding %(name)s."
 msgstr "查找 %(name)s 时出错。"
 
-msgid ""
-"Error getting appliance version details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"获取设备版本详细信息时出错。返回码：%(ret.status)d 消息：%(ret.data)s。"
-
 #, python-format
 msgid "Error getting domain id from name %(name)s: %(id)s."
 msgstr "从名称 %(name)s 中获取域标识 %(id)s 时出错。"
 
-msgid "Error getting initiator groups."
-msgstr "获取发起方组时，发生错误。"
-
 #, python-format
 msgid "Error getting pool id from name %(pool_name)s: %(err_msg)s."
 msgstr "从名称 %(pool_name)s 中获取池标识时出错：%(err_msg)s。"
 
 #, python-format
-msgid ""
-"Error getting replication action: %(id)s. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"获取复制操作 %(id)s 时出错。返回码：%(ret.status)d 消息：%(ret.data)s。"
-
-msgid ""
-"Error getting replication source details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr "获取复制源详细信息时出错。返回码：%(ret.status)d 消息：%(ret.data)s。"
-
-msgid ""
-"Error getting replication target details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"获取复制目标详细信息时出错。返回码：%(ret.status)d 消息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error getting version: svc: %(svc)s.Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"获取版本时出错：svc：%(svc)s。返回码：%(ret.status)d 消息：%(ret.data)s。"
-
-#, python-format
 msgid "Error in SolidFire API response: data=%(data)s"
 msgstr "SolidFire API响应里发生错误：data=%(data)s"
 
@@ -1648,21 +1350,6 @@ msgstr "SolidFire API响应里发生错
 msgid "Error managing volume: %s."
 msgstr "管理卷 %s 时出错。"
 
-#, python-format
-msgid ""
-"Error modifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"修改服务 %(service)s 时出错。返回码：%(ret.status)d 消息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error moving volume: %(vol)s from source project: %(src)s to target project: "
-"%(tgt)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"将卷 %(vol)s 从源项目 %(src)s 移至目标项目 %(tgt)s 时出错。返回码："
-"%(ret.status)d 消息：%(ret.data)s。"
-
 msgid "Error not a KeyError."
 msgstr "错误并非 KeyError。"
 
@@ -1693,35 +1380,6 @@ msgid "Error retrieving volume size"
 msgstr "检索卷大小时出错"
 
 #, python-format
-msgid ""
-"Error sending replication update for action id: %(id)s . Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"为操作标识 %(id)s 发送复制更新时出错。返回码：%(ret.status)d 消息："
-"%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error sending replication update. Returned error: %(err)s. Action: %(id)s."
-msgstr "发送复制更新时出错。所返回的错误：%(err)s。操作：%(id)s。"
-
-#, python-format
-msgid ""
-"Error setting replication inheritance to %(set)s for volume: %(vol)s project "
-"%(project)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"对于卷 %(vol)s，将复制继承设置为 %(set)s 时出错。项目：%(project)s 返回码："
-"%(ret.status)d 消息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error severing the package: %(package)s from source: %(src)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"从源 %(src)s 分割软件包 %(package)s 时出错。返回码：%(ret.status)d 消息："
-"%(ret.data)s。"
-
-#, python-format
 msgid "Error while authenticating with switch: %s."
 msgstr "向交换机认证时出错：%s。"
 
@@ -1862,14 +1520,6 @@ msgid "FC is the protocol but wwpns are
 msgstr "FC 为协议，但 OpenStack 未提供 wwpns。"
 
 #, python-format
-msgid "Faield to unassign %(volume)s"
-msgstr "无法取消分配 %(volume)s"
-
-#, python-format
-msgid "Fail to create cache volume %(volume)s. Error: %(err)s"
-msgstr "未能创建高速缓存卷 %(volume)s。错误：%(err)s"
-
-#, python-format
 msgid "Failed adding connection for fabric=%(fabric)s: Error: %(err)s"
 msgstr "对于光纤网 %(fabric)s，未能添加连接：发生错误：%(err)s"
 
@@ -1940,10 +1590,6 @@ msgid "Failed to connect to Dell REST AP
 msgstr "无法连接至 Dell REST API"
 
 #, python-format
-msgid "Failed to connect to sheep daemon. addr: %(addr)s, port: %(port)s"
-msgstr "未能连接至 sheep 守护程序。地址：%(addr)s，端口：%(port)s"
-
-#, python-format
 msgid "Failed to copy image to volume: %(reason)s"
 msgstr "未能将映像复制到卷：%(reason)s"
 
@@ -1976,18 +1622,6 @@ msgid "Failed to create api volume flow.
 msgstr "未能创建 api 卷流。"
 
 #, python-format
-msgid "Failed to create cg snapshot %(id)s due to %(reason)s."
-msgstr "由于 %(reason)s，未能创建 cg 快照 %(id)s。"
-
-#, python-format
-msgid "Failed to create consistency group %(id)s due to %(reason)s."
-msgstr "由于 %(reason)s，未能创建一致性组 %(id)s。"
-
-#, python-format
-msgid "Failed to create consistency group %(id)s:%(ret)s."
-msgstr "未能创建一致性组 %(id)s：%(ret)s。"
-
-#, python-format
 msgid "Failed to create consistency group: %(cgid)s. Error: %(excmsg)s."
 msgstr "未能创建一致性组：%(cgid)s。错误为 %(excmsg)s。"
 
@@ -2053,14 +1687,6 @@ msgid "Failed to create volume %s"
 msgstr "未能创建卷 %s"
 
 #, python-format
-msgid "Failed to delete cgsnapshot %(id)s due to %(reason)s."
-msgstr "由于 %(reason)s，未能删除 cg 快照 %(id)s。"
-
-#, python-format
-msgid "Failed to delete consistency group %(id)s due to %(reason)s."
-msgstr "由于 %(reason)s，未能删除一致性组 %(id)s。"
-
-#, python-format
 msgid ""
 "Failed to delete fileset for consistency group %(cgname)s. Error: %(excmsg)s."
 msgstr "未能针对一致性组 %(cgname)s 删除文件集。错误为 %(excmsg)s。"
@@ -2131,10 +1757,6 @@ msgid "Failed to find host %s."
 msgstr "未能找到主机 %s。"
 
 #, python-format
-msgid "Failed to find iSCSI initiator group containing %(initiator)s."
-msgstr "找不到包含 %(initiator)s 的 iSCSI 启动程序组。"
-
-#, python-format
 msgid "Failed to get LUN target details for the LUN %s"
 msgstr "未能获取 LUN %s 的 LUN 目标详细信息"
 
@@ -2242,12 +1864,6 @@ msgstr "未能登录到 %s 阵列（无
 msgid "Failed to login with all rest URLs."
 msgstr "未能使用所有 REST URL 进行登录。"
 
-#, python-format
-msgid ""
-"Failed to make a request to Datera cluster endpoint due to the following "
-"reason: %s"
-msgstr "由于以下原因，未能对 Datera 集群端点进行请求：%s"
-
 msgid "Failed to manage api volume flow."
 msgstr "未能管理 API 卷流。"
 
@@ -2428,26 +2044,6 @@ msgid "Failure staging LUN %s to tmp."
 msgstr "将 LUN %s 登台至临时文件夹时发生故障。"
 
 #, python-format
-msgid "Fexvisor failed to add volume %(id)s due to %(reason)s."
-msgstr "由于 %(reason)s，Fexvisor 未能添加卷 %(id)s。"
-
-#, python-format
-msgid ""
-"Fexvisor failed to join the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr "由于 %(ret)s，Fexvisor 未能将卷 %(vol)s加入组 %(group)s。"
-
-#, python-format
-msgid ""
-"Fexvisor failed to remove the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr "由于 %(ret)s，Fexvisor 未能移除组 %(group)s中的卷 %(vol)s。"
-
-#, python-format
-msgid "Fexvisor failed to remove volume %(id)s due to %(reason)s."
-msgstr "由于 %(reason)s，Fexvisor 未能移除卷 %(id)s。"
-
-#, python-format
 msgid "Fibre Channel SAN Lookup failure: %(reason)s"
 msgstr "光纤通道 SAN 查找失败：%(reason)s"
 
@@ -2467,10 +2063,6 @@ msgid "File %(file_path)s could not be f
 msgstr "找不到文件 %(file_path)s。"
 
 #, python-format
-msgid "File already exists at %s."
-msgstr "%s 处已存在文件。"
-
-#, python-format
 msgid "File already exists at: %s"
 msgstr "在以下位置处，已存在文件：%s"
 
@@ -2500,158 +2092,6 @@ msgstr ""
 "闪存高速缓存策略要求安装了 WSAPI 版本“%(fcache_version)s”版本“%(version)s”。"
 
 #, python-format
-msgid "Flexvisor assign volume failed.:%(id)s:%(status)s."
-msgstr "Flexvisor 分配卷失败：%(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor assign volume failed:%(id)s:%(status)s."
-msgstr "Flexvisor 分配卷失败：%(id)s：%(status)s。"
-
-#, python-format
-msgid ""
-"Flexvisor could not find volume %(id)s snapshot in the group %(vgid)s "
-"snapshot %(vgsid)s."
-msgstr "Flexvisor 在组 %(vgid)s 快照 %(vgsid)s 中找不到卷 %(id)s 快照。"
-
-#, python-format
-msgid "Flexvisor create volume failed.:%(volumeid)s:%(status)s."
-msgstr "Flexvisor 创建卷失败：%(volumeid)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed deleting volume %(id)s: %(status)s."
-msgstr "Flexvisor 无法删除卷 %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to add volume %(id)s to group %(cgid)s."
-msgstr "Flexvisor 未能将卷 %(id)s 添加至组 %(cgid)s。"
-
-#, python-format
-msgid ""
-"Flexvisor failed to assign volume %(id)s due to unable to query status by "
-"event id."
-msgstr "Flexvisor 无法分配卷 %(id)s，因为无法按事件标识查询状态。 "
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(id)s: %(status)s."
-msgstr "Flexvisor 无法分配卷 %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(volume)s iqn %(iqn)s."
-msgstr "Flexvisor 未能分配卷 %(volume)s iqn %(iqn)s。"
-
-#, python-format
-msgid "Flexvisor failed to clone volume %(id)s: %(status)s."
-msgstr "Flexvisor 无法克隆卷 %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to clone volume (failed to get event) %(id)s."
-msgstr "Flexvisor 无法克隆卷（无法获取事件）%(id)s。"
-
-#, python-format
-msgid "Flexvisor failed to create snapshot for volume %(id)s: %(status)s."
-msgstr "Flexvisor 无法对卷 %(id)s 创建快照：%(status)s。"
-
-#, python-format
-msgid ""
-"Flexvisor failed to create snapshot for volume (failed to get event) %(id)s."
-msgstr "Flexvisor 无法对卷 %(id)s 创建快照（无法获取事件）。  "
-
-#, python-format
-msgid "Flexvisor failed to create volume %(id)s in the group %(vgid)s."
-msgstr "Flexvisor 未能在组 %(vgid)s 中创建卷 %(id)s。"
-
-#, python-format
-msgid "Flexvisor failed to create volume %(volume)s: %(status)s."
-msgstr "Flexvisor 无法创建卷 %(volume)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to create volume (get event) %s."
-msgstr "Flexvisor 无法创建卷（获取事件）%s。"
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s: %(status)s."
-msgstr "Flexvisor 未能从快照 %(id)s 创建卷：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s:%(status)s."
-msgstr "Flexvisor 无法从快照 %(id)s 创建卷：%(status)s。"
-
-#, python-format
-msgid ""
-"Flexvisor failed to create volume from snapshot (failed to get event) %(id)s."
-msgstr "Flexvisor 无法从快照创建卷（无法获取事件）%(id)s。  "
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot %(id)s: %(status)s."
-msgstr "Flexvisor 无法删除快照 %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot (failed to get event) %(id)s."
-msgstr "Flexvisor 无法删除快照（无法获取事件）%(id)s。"
-
-#, python-format
-msgid "Flexvisor failed to delete volume %(id)s: %(status)s."
-msgstr "Flexvisor 无法删除卷 %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s: %(status)s."
-msgstr "Flexvisor 未能扩展卷 %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s:%(status)s."
-msgstr "Flexvisor 无法扩展卷 %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to extend volume (failed to get event) %(id)s."
-msgstr "Flexvisor 无法扩展卷（无法获取事件）%(id)s。"
-
-#, python-format
-msgid "Flexvisor failed to get pool info %(id)s: %(status)s."
-msgstr "Flexvisor 无法获取池信息 %(id)s：%(status)s。"
-
-#, python-format
-msgid ""
-"Flexvisor failed to get snapshot id of volume %(id)s from group %(vgid)s."
-msgstr "Flexvisor 未能从组 %(vgid)s 获取卷 %(id)s 的快照标识。"
-
-#, python-format
-msgid "Flexvisor failed to remove volume %(id)s from group %(cgid)s."
-msgstr "Flexvisor 未能从组 %(cgid)s 中移除卷 %(id)s。"
-
-#, python-format
-msgid "Flexvisor failed to spawn volume from snapshot %(id)s:%(status)s."
-msgstr "Flexvisor 无法从快照 %(id)s 衍生卷：%(status)s。"
-
-#, python-format
-msgid ""
-"Flexvisor failed to spawn volume from snapshot (failed to get event) %(id)s."
-msgstr "Flexvisor 无法从快照衍生卷（无法获取事件）%(id)s。  "
-
-#, python-format
-msgid "Flexvisor failed to unassign volume %(id)s: %(status)s."
-msgstr "Flexvisor 无法取消分配卷 %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to unassign volume (get event) %(id)s."
-msgstr "Flexvisor 无法取消分配卷（获取事件）%(id)s。"
-
-#, python-format
-msgid "Flexvisor failed to unassign volume:%(id)s:%(status)s."
-msgstr "Flexvisor 未能取消分配卷 %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor unable to find the source volume %(id)s info."
-msgstr "Flexvisor 找不到源卷 %(id)s 信息。"
-
-#, python-format
-msgid "Flexvisor unassign volume failed:%(id)s:%(status)s."
-msgstr "Flexvisor 取消分配卷失败：%(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor volume %(id)s failed to join group %(vgid)s."
-msgstr "Flexvisor 卷 %(id)s 未能加入组 %(vgid)s。"
-
-#, python-format
 msgid "Folder %s does not exist in Nexenta Store appliance"
 msgstr "文件夹 %s 在 Nexenta 存储设备中不存在"
 
@@ -3069,14 +2509,6 @@ msgid "Invalid Replication Target: %(rea
 msgstr "无效复制目标：%(reason)s"
 
 #, python-format
-msgid ""
-"Invalid Virtuozzo Storage share specification: %r. Must be: [MDS1[,"
-"MDS2],...:/]<CLUSTER NAME>[:PASSWORD]."
-msgstr ""
-"无效 Virtuozzo 存储器共享规范：%r。必须为 [MDS1[,MDS2],...:/]<CLUSTER NAME>[:"
-"PASSWORD]。"
-
-#, python-format
 msgid "Invalid XtremIO version %(cur)s, version %(min)s or up is required"
 msgstr "XtremIO V%(cur)s 无效，需要 V%(min)s 或更高版本"
 
@@ -3084,13 +2516,6 @@ msgstr "XtremIO V%(cur)s 无效，需要
 msgid "Invalid allocated quotas defined for the following project quotas: %s"
 msgstr "对以下项目配额定义的已分配配额无效：%s"
 
-msgid "Invalid argument - negative seek offset."
-msgstr "无效参数 - 查找偏移量为负数。"
-
-#, python-format
-msgid "Invalid argument - whence=%s not supported."
-msgstr "无效参数 - whence=%s 不受支持。"
-
 #, python-format
 msgid "Invalid attaching mode '%(mode)s' for volume %(volume_id)s."
 msgstr "加载模式 '%(mode)s' 对于卷 %(volume_id)s 无效。"
@@ -3108,15 +2533,6 @@ msgid "Invalid backup: %(reason)s"
 msgstr "备份无效：%(reason)s"
 
 #, python-format
-msgid "Invalid connection initialization response of volume %(name)s"
-msgstr "卷 %(name)s 的连接初始化响应无效"
-
-#, python-format
-msgid ""
-"Invalid connection initialization response of volume %(name)s: %(output)s"
-msgstr "卷 %(name)s 的连接初始化响应无效：%(output)s"
-
-#, python-format
 msgid "Invalid content type %(content_type)s."
 msgstr "无效的内容类型 %(content_type)s。"
 
@@ -3209,10 +2625,6 @@ msgid "Invalid mount point base: %s"
 msgstr "安装点基准无效：%s"
 
 #, python-format
-msgid "Invalid mount point base: %s."
-msgstr "安装点基准无效：%s。"
-
-#, python-format
 msgid "Invalid new snapCPG name for retype.  new_snap_cpg='%s'."
 msgstr "新 snapCPG 名称对执行 retype 操作无效。new_snap_cpg='%s'。"
 
@@ -3231,9 +2643,6 @@ msgstr "无效辅助标识 %s。"
 msgid "Invalid service catalog json."
 msgstr "服务目录 json 无效。"
 
-msgid "Invalid sheepdog cluster status."
-msgstr "sheepdog 集群状态无效。"
-
 #, python-format
 msgid "Invalid snapshot: %(reason)s"
 msgstr "快照无效: %(reason)s"
@@ -3325,10 +2734,6 @@ msgid ""
 "group)."
 msgstr "提供的以下 volume_type 无效：%s（所请求类型必须被该组支持）。"
 
-#, python-format
-msgid "Invalid wwpns format %(wwpns)s"
-msgstr "无效 WWPN 格式 %(wwpns)s"
-
 msgid "Issue encountered waiting for job."
 msgstr "等待作业时遇到问题。"
 
@@ -3347,10 +2752,6 @@ msgstr "Kaminario可重试异常:%(reaso
 msgid "KaminarioCinderDriver failure: %(reason)s"
 msgstr "Kaminario Cinder 驱动程序故障:%(reason)s"
 
-#, python-format
-msgid "KeyError: %s"
-msgstr "KeyError：%s"
-
 msgid "Keystone version 3 or greater must be used to get nested quota support."
 msgstr "必须使用 Keystone 版本 3 或更高版本来获取嵌套配额支持。"
 
@@ -3663,9 +3064,6 @@ msgstr ""
 msgid "New volume type not specified in request_spec."
 msgstr "在 request_spec 中，未指定新的卷类型。"
 
-msgid "Nimble Cinder Driver exception"
-msgstr "Nimble Cinder 驱动程序异常"
-
 msgid "No FC initiator can be added to host."
 msgstr "无法将任何 FC 启动程序添加至主机。"
 
@@ -3707,10 +3105,6 @@ msgid "No initiator connected to fabric.
 msgstr "没有任何启动程序连接至光纤网络。"
 
 #, python-format
-msgid "No initiator group found for initiator %s"
-msgstr "找不到对应启动程序 %s 的启动程序组"
-
-#, python-format
 msgid "No interface found on cluster for ip %s"
 msgstr "集群中找不到 IP %s 的接口"
 
@@ -3723,9 +3117,6 @@ msgstr "找不到任何已安装的 NFS
 msgid "No mounted SMBFS shares found."
 msgstr "找不到任何已安装的 SMBFS 共享项。"
 
-msgid "No mounted Virtuozzo Storage shares found"
-msgstr "找不到任何已安装的 Virtuozzo 存储器共享项"
-
 msgid "No mounted shares found"
 msgstr "找不到任何已安装的共享项"
 
@@ -3753,9 +3144,6 @@ msgstr "无法为该卷请求分配存
 msgid "No such QoS spec %(specs_id)s."
 msgstr "不存在任何此类 QoS 规范 %(specs_id)s。"
 
-msgid "No suitable discovery ip found"
-msgstr "找不到合适的发现 IP"
-
 #, python-format
 msgid "No support to restore backup version %s"
 msgstr "不支持复原备份版本 %s"
@@ -3794,9 +3182,6 @@ msgstr "未授权。"
 msgid "Not enough space on backend (%(backend)s)"
 msgstr "后端 (%(backend)s) 上没有足够的空间"
 
-msgid "Not enough storage space in the ZFS share to perform this operation."
-msgstr "ZFS 共享项中的存储空间不足，无法执行此操作。"
-
 msgid "Not stored in rbd"
 msgstr "未存储在 rbd 中"
 
@@ -3828,9 +3213,6 @@ msgid ""
 "allowed to see its children quotas."
 msgstr "只允许令牌作用域仅限于直系父代或者根项目的用户查看其子代配额。"
 
-msgid "Only volumes managed by OpenStack can be unmanaged."
-msgstr "只有 OpenStack 管理的卷才能为非受管卷。"
-
 #, python-format
 msgid "Operation failed with status=%(status)s. Full dump: %(data)s"
 msgstr "操作失败，并且 status=%(status)s。完全转储：%(data)s"
@@ -3874,9 +3256,6 @@ msgstr "政策不允许 %(action)s 被
 msgid "Pool is not available in the volume host field."
 msgstr "在卷主机字段中，未提供池。"
 
-msgid "Pool is not available in the volume host fields."
-msgstr "在卷主机字段中，未提供池。"
-
 #, python-format
 msgid "Pool with name %(pool_name)s wasn't found in domain %(domain_id)s."
 msgstr "在域 %(domain_id)s 中找不到名称为 %(pool_name)s 的池。"
@@ -4017,13 +3396,6 @@ msgstr "引用必须包含 source-name 
 msgid "Reference must contain source-name."
 msgstr "引用必须包含源名称。"
 
-msgid "Reference to volume to be managed must contain source-name."
-msgstr "对要管理的卷的引用必须包含 source-name。"
-
-#, python-format
-msgid "Reference to volume: %s to be managed must contain source-name."
-msgstr "对要管理的卷 %s 的引用必须包含 source-name。"
-
 #, python-format
 msgid ""
 "Refusing to migrate volume ID: %(id)s. Please check your configuration "
@@ -4084,10 +3456,6 @@ msgid "Request body contains too many it
 msgstr "请求主体包含太多items"
 
 #, python-format
-msgid "Request to Datera cluster returned bad status: %(status)s | %(reason)s"
-msgstr "针对 Datera 集群的请求返回了不正确的状态：%(status)s | %(reason)s"
-
-#, python-format
 msgid ""
 "Requested backup exceeds allowed Backup gigabytes quota. Requested "
 "%(requested)sG, quota is %(quota)sG and %(consumed)sG has been consumed."
@@ -4203,10 +3571,6 @@ msgid "SMBFS config file not set (smbfs_
 msgstr "SMBFS 配置文件未设置 (smbfs_shares_config)。"
 
 #, python-format
-msgid "SSH Command failed after '%(total_attempts)r' attempts : '%(command)s'"
-msgstr "SSH 命令在“%(total_attempts)r”之后失败，尝试次数：“%(command)s”"
-
-#, python-format
 msgid "SSH command injection detected: %(command)s"
 msgstr "检测到 SSH 命令注入：%(command)s"
 
@@ -4256,10 +3620,6 @@ msgstr ""
 "由于格式无效，已忽略共享项 %s。格式必须为 address:/export。请检查 nas_host "
 "和 nas_share_path 设置。"
 
-#, python-format
-msgid "Sheepdog I/O Error, command was: \"%s\"."
-msgstr "Sheepdog I/O 错误，命令为：\"%s\"。"
-
 msgid ""
 "Show operations can only be made to projects in the same hierarchy of the "
 "project in which users are scoped to."
@@ -4361,9 +3721,6 @@ msgstr "源卷未在迁移中。"
 msgid "Specified logical volume does not exist."
 msgstr "所指定的逻辑卷不存在。"
 
-msgid "Specifies IP pool to use for volume"
-msgstr "为使用卷指定IP池。"
-
 msgid ""
 "Specifies number of replicas for each volume. Can only be increased once "
 "volume is created"
@@ -4477,14 +3834,6 @@ msgstr ""
 "GPFS 文件系统 %(fs)s 未处于所要求的发行版级别。当前级别为 %(cur)s，而要求的级"
 "别必须至少为 %(min)s。"
 
-#, python-format
-msgid ""
-"The WebDAV request failed. Reason: %(msg)s, Return code/reason: %(code)s, "
-"Source Volume: %(src)s, Destination Volume: %(dst)s, Method: %(method)s."
-msgstr ""
-"WebDAV 请求失败。原因为 %(msg)s，返回码/原因码为 %(code)s，源卷为 %(src)s，目"
-"标卷为 %(dst)s，方法为 %(method)s。"
-
 msgid ""
 "The above error may show that the database has not been created.\n"
 "Please create a database using 'cinder-manage db sync' before running this "
@@ -4527,12 +3876,6 @@ msgstr "主机未准备好故障返回
 msgid "The method update_migrated_volume is not implemented."
 msgstr "未实现方法 update_migrated_volume。"
 
-msgid "The name to use for storage instances created"
-msgstr "存储实例使用的名称已创建。"
-
-msgid "The name to use for volumes created"
-msgstr "卷使用的名称已创建。"
-
 msgid "The parent backup must be available for incremental backup."
 msgstr "父备份必须可用于增量备份。"
 
@@ -4574,9 +3917,6 @@ msgstr "当卷处于维护方式时，
 msgid "The snapshot is unavailable: %(data)s"
 msgstr "快照不可用:%(data)s"
 
-msgid "The source volume for this WebDAV operation not found."
-msgstr "找不到此 WebDAV 操作的源卷。"
-
 #, python-format
 msgid ""
 "The source volume type '%(src)s' is different than the destination volume "
@@ -4759,10 +4099,6 @@ msgid "Type cannot be converted into NaE
 msgstr "此类型不能转换为 NaElement。"
 
 #, python-format
-msgid "TypeError: %s"
-msgstr "TypeError：%s"
-
-#, python-format
 msgid "UUIDs %s are in both add and remove volume list."
 msgstr "UUID %s 同时位于“添加卷”和“移除卷”列表中。"
 
@@ -5005,9 +4341,6 @@ msgstr "意外输出。需要 [%(expecte
 msgid "Unexpected over quota on %(name)s."
 msgstr "%(name)s 超过预期配额。"
 
-msgid "Unexpected response from Nimble API"
-msgstr "来自 Nimble API 的意外响应"
-
 msgid "Unexpected status code"
 msgstr "意外的状态码"
 
@@ -5028,37 +4361,10 @@ msgstr "RemoteFS 异常未知"
 msgid "Unknown SMBFS exception."
 msgstr "SMBFS 异常未知。"
 
-msgid "Unknown Virtuozzo Storage exception"
-msgstr "未知 Virtuozzo 存储器异常"
-
 msgid "Unknown action"
 msgstr "操作未知"
 
 #, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, Set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"不知道要管理的卷 %s 是否已由 Cinder 管理。正在异常中止管理卷。请"
-"将“cinder_managed”定制模式属性添加至该卷，并将其值设置为 False。或者，将 "
-"Cinder 配置策略“zfssa_manage_policy”的值设置为“loose”以移除此限制。"
-
-#, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"不知道要管理的卷 %s 是否已由 Cinder 管理。正在异常中止管理卷。请"
-"将“cinder_managed”定制模式属性添加至该卷，并将其值设置为 False。或者，将 "
-"Cinder 配置策略“zfssa_manage_policy”的值设置为“loose”以移除此限制。"
-
-#, python-format
 msgid "Unknown or unsupported command %(cmd)s"
 msgstr "命令 %(cmd)s 未知或不受支持"
 
@@ -5118,10 +4424,6 @@ msgstr ""
 "在交换机 %s 上存在不受支持的固件。请确保交换机正在运行固件 V6.4 或更高版本"
 
 #, python-format
-msgid "Unsupported volume format %s"
-msgstr "不支持的卷格式：%s"
-
-#, python-format
 msgid "Unsupported volume format: %s "
 msgstr "以下卷格式不受支持：%s "
 
@@ -5164,9 +4466,6 @@ msgstr "用户ID"
 msgid "User does not have admin privileges"
 msgstr "用户没有管理员权限"
 
-msgid "User not authorized to perform WebDAV operations."
-msgstr "用户无权执行 WebDAV 操作。"
-
 msgid "UserName is not configured."
 msgstr "未配置 UserName。"
 
@@ -5194,10 +4493,6 @@ msgid ""
 msgstr "值“%(value)s”对于配置选项“%(option)s”无效"
 
 #, python-format
-msgid "ValueError: %s"
-msgstr "ValueError：%s"
-
-#, python-format
 msgid "Vdisk %(name)s not involved in mapping %(src)s -> %(tgt)s."
 msgstr "从 %(src)s 到 %(tgt)s 的映射中未涉及到 Vdisk %(name)s。"
 
@@ -5308,23 +4603,10 @@ msgid "Volume %s does not exist on the a
 msgstr "卷 %s 在阵列上不存在。"
 
 #, python-format
-msgid "Volume %s does not have provider_location specified, skipping."
-msgstr "卷 %s 没有指定 provider_location，正在跳过。"
-
-#, python-format
 msgid "Volume %s doesn't exist on array."
 msgstr "卷 %s 在阵列上不存在。"
 
 #, python-format
-msgid "Volume %s doesn't exist on the ZFSSA backend."
-msgstr "卷 %s 在 ZFSSA 后端上不存在。"
-
-#, python-format
-msgid ""
-"Volume %s is online. Set volume to offline for managing using OpenStack."
-msgstr "卷 %s 已联机。将该卷设置为脱机以便使用 OpenStack 进行管理。"
-
-#, python-format
 msgid "Volume %s must not be part of a consistency group."
 msgstr "卷 %s 不得是一致性组的一部分。"
 
@@ -5468,9 +4750,6 @@ msgstr "卷尚未分配给主机。"
 msgid "Volume replication for %(volume_id)s could not be found."
 msgstr "找不到 %(volume_id)s 的卷复制。"
 
-msgid "Volume should have agent-type set as None."
-msgstr "卷应该将 agent-type 设置为“无”。"
-
 #, python-format
 msgid ""
 "Volume size %(volume_size)sGB cannot be smaller than the image minDisk size "
@@ -5506,13 +4785,6 @@ msgstr "卷大小必须为 1 GB 的倍
 msgid "Volume size must multiple of 1 GB."
 msgstr "卷大小必须是 1 GB 的倍数。"
 
-msgid "Volume status must be 'available'."
-msgstr "卷状态必须为“可用”。"
-
-#, python-format
-msgid "Volume status must be available for snapshot %(id)s. (is %(status)s)"
-msgstr "对于快照 %(id)s，卷状态必须为“available”。（卷状态现在为 %(status)s）"
-
 msgid "Volume to Initiator Group mapping already exists"
 msgstr "卷至发起方组的映射已存在"
 
@@ -5560,32 +4832,14 @@ msgstr "卷类型名称不能为 空."
 msgid "Volume type with name %(volume_type_name)s could not be found."
 msgstr "名为 %(volume_type_name)s 的卷类型没有找到。"
 
-#, python-format
-msgid "Volume: %s is already being managed by Cinder."
-msgstr "卷 %s 已由 Cinder 管理。"
-
 msgid ""
 "Volumes/account exceeded on both primary and secondary SolidFire accounts."
 msgstr "卷/帐户同时超出主 SolidFire 帐户和辅助 SolidFire 帐户的限制。"
 
 #, python-format
-msgid ""
-"VzStorage config 'vzstorage_used_ratio' invalid. Must be > 0 and <= 1.0: %s."
-msgstr ""
-"VzStorage 配置“vzstorage_used_ratio”无效。必须大于 0 并且小于或等于 1.0：%s。"
-
-#, python-format
-msgid "VzStorage config file at %(config)s doesn't exist."
-msgstr "%(config)s 处不存在 VzStorage 配置文件。"
-
-#, python-format
 msgid "Wait synchronize failed. Running status: %s."
 msgstr "等待同步失败。运行状态：%s。"
 
-msgid ""
-"Waiting for all nodes to join cluster. Ensure all sheep daemons are running."
-msgstr "正在等待所有节点加入集群。请确保所有 sheep 守护程序都在运行。"
-
 msgid "We should not do switch over on primary array."
 msgstr "不应在主阵列上切换。"
 
@@ -6278,12 +5532,6 @@ msgstr ""
 "将对象写入 swift 时出错，swift %(etag)s 中对象的 MD5 与发送至 swift %(md5)s "
 "的对象的 MD5 不同"
 
-msgid ""
-"existing_ref argument must be of this format:app_inst_name:storage_inst_name:"
-"vol_name"
-msgstr ""
-"参数 existing_ref 的格式必须为：app_inst_name:storage_inst_name:vol_name。"
-
 #, python-format
 msgid "extend_volume, eternus_pool: %(eternus_pool)s, pool not found."
 msgstr "extend_volume，eternus_pool：%(eternus_pool)s，找不到池。"
@@ -6311,9 +5559,6 @@ msgstr "extend_volume，volumename：%(v
 msgid "fake"
 msgstr "fake"
 
-msgid "fileno is not supported by SheepdogIOWrapper"
-msgstr "SheepdogIOWrapper 不支持 fileno"
-
 #, python-format
 msgid "fmt=%(fmt)s backed by: %(backing_file)s"
 msgstr "fmt=%(fmt)s 由 %(backing_file)s 支持"
@@ -6388,11 +5633,6 @@ msgstr "已分配组快照"
 msgid "group_type_id cannot be None"
 msgstr "group_type_id 不能为None"
 
-msgid ""
-"http service may have been abruptly disabled or put to maintenance state in "
-"the middle of this operation."
-msgstr "HTTP 服务可能已突然禁用，或在此操作的中途进入维护状态。"
-
 msgid "id cannot be None"
 msgstr "id不能是None"
 
@@ -6684,9 +5924,3 @@ msgstr "已分配卷"
 
 msgid "volumes changed"
 msgstr "已更改卷"
-
-#, python-format
-msgid ""
-"zfssa_manage_policy property needs to be set to 'strict' or 'loose'. Current "
-"value is: %s."
-msgstr "zfssa_manage_policy 属性需要设置为“strict”或“loose”。当前值为：%s。"
diff -pruN 2:15.0.1-1/cinder/locale/zh_TW/LC_MESSAGES/cinder.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/zh_TW/LC_MESSAGES/cinder.po
--- 2:15.0.1-1/cinder/locale/zh_TW/LC_MESSAGES/cinder.po	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/locale/zh_TW/LC_MESSAGES/cinder.po	2020-03-24 18:46:31.000000000 +0000
@@ -9,7 +9,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: cinder VERSION\n"
 "Report-Msgid-Bugs-To: https://bugs.launchpad.net/openstack-i18n/\n"
-"POT-Creation-Date: 2019-10-04 05:27+0000\n"
+"POT-Creation-Date: 2020-03-18 14:40+0000\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
@@ -108,10 +108,6 @@ msgstr ""
 "映像檔或檔案備份，實際模式為%(vol_mode)s。"
 
 #, python-format
-msgid "%(service)s Service is not %(status)s on storage appliance: %(host)s"
-msgstr "%(service)s 服務在儲存體軟體驅動裝置 %(host)s 上不是處於 %(status)s"
-
-#, python-format
 msgid ""
 "%(worker_name)s value of %(workers)d is invalid, must be greater than 0."
 msgstr "%(workers)d 的 %(worker_name)s 值無效，必須大於 0。"
@@ -152,10 +148,6 @@ msgid "%s is not installed"
 msgstr "%s 未安裝"
 
 #, python-format
-msgid "%s is not installed."
-msgstr "未安裝 %s。"
-
-#, python-format
 msgid "%s is not set"
 msgstr "未設定 %s"
 
@@ -176,10 +168,6 @@ msgid "%s must be an absolute path."
 msgstr "%s 必須是絕對路徑。"
 
 #, python-format
-msgid "%s not set in cinder.conf"
-msgstr "%s 未在 cinder.conf 中設定"
-
-#, python-format
 msgid "%s not set."
 msgstr "未設定 %s。"
 
@@ -200,14 +188,6 @@ msgstr "必須指定 'consistencygroup_i
 msgid "'qemu-img info' parsing failed."
 msgstr "'qemu-img info' 剖析失敗。"
 
-#, python-format
-msgid ""
-"(Command: %(cmd)s) (Return Code: %(exit_code)s) (Stdout: %(stdout)s) "
-"(Stderr: %(stderr)s)"
-msgstr ""
-"（指令：%(cmd)s）（回覆碼：%(exit_code)s）（標準輸出：%(stdout)s）（標準錯"
-"誤：%(stderr)s）"
-
 msgid "A concurrent, possibly contradictory, request has been made."
 msgstr "已發出並行（可能矛盾）的要求。"
 
@@ -287,14 +267,6 @@ msgstr ""
 "LUNcopy 作業期間發生錯誤。LUNcopy 名稱：%(luncopyname)s。LUNcopy 狀態 "
 "(status)：%(luncopystatus)s。LUNcopy 狀態 (state)：%(luncopystate)s。"
 
-#, python-format
-msgid "An error occurred while reading volume \"%s\"."
-msgstr "讀取磁區 \"%s\" 時發生錯誤。"
-
-#, python-format
-msgid "An error occurred while writing to volume \"%s\"."
-msgstr "寫入磁區 \"%s\" 時發生錯誤。"
-
 msgid "An unknown exception occurred."
 msgstr "發生一個未知例外"
 
@@ -361,9 +333,6 @@ msgstr "可用的種類："
 msgid "Backend doesn't exist (%(backend)s)"
 msgstr "後端不存在 (%(backend)s)"
 
-msgid "Backend storage did not configure fiber channel target."
-msgstr "後端儲存體未配置光纖通道目標。"
-
 msgid "Backing up an in-use volume must use the force flag."
 msgstr "備份使用中的磁區必須使用強制旗標。"
 
@@ -469,10 +438,6 @@ msgstr ""
 msgid "CPG (%s) doesn't exist on array"
 msgstr "陣列上不存在 CPG (%s)"
 
-#, python-format
-msgid "Cache volume %s does not have required properties"
-msgstr "快取磁區 %s 沒有必需的內容"
-
 msgid "Can not add FC port to host."
 msgstr "無法將 FC 埠新增至主機。"
 
@@ -583,10 +548,6 @@ msgid ""
 msgstr ""
 "無法變更 VF 環境定義，在可管理的 VF 清單 %(vf_list)s 中無法使用指定的 VF。"
 
-#, python-format
-msgid "Cannot create directory %s."
-msgstr "無法建立目錄 %s。"
-
 msgid "Cannot create encryption specs. Volume type in use."
 msgstr "無法建立加密規格。磁區類型在使用中。"
 
@@ -603,22 +564,6 @@ msgstr "無法建立大小為 %s 的磁
 msgid "Cannot create volume_type with name %(name)s and specs %(extra_specs)s"
 msgstr "無法使用名稱 %(name)s 及規格 %(extra_specs)s 來建立 volume_type"
 
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)d volume instances."
-msgstr ""
-"無法刪除快取磁區：%(cachevol_name)s。該快取磁區已在 %(updated_at)s 得到更新，"
-"且目前具有 %(numclones)d 個磁區實例。"
-
-#, python-format
-msgid ""
-"Cannot delete cache volume: %(cachevol_name)s. It was updated at "
-"%(updated_at)s and currently has %(numclones)s volume instances."
-msgstr ""
-"無法刪除快取磁區：%(cachevol_name)s。該快取磁區已在 %(updated_at)s 得到更新，"
-"且目前具有 %(numclones)s 個磁區實例。"
-
 msgid "Cannot delete encryption specs. Volume type in use."
 msgstr "無法刪除加密規格。磁區類型在使用中。"
 
@@ -681,9 +626,6 @@ msgid ""
 "Change would make usage less than 0 for the following resources: %(unders)s"
 msgstr "變更會使下列資源的用量小於 0：%(unders)s"
 
-msgid "Check access permissions for the ZFS share assigned to this driver."
-msgstr "請檢查指派給此驅動程式之 ZFS 共用的存取權限。"
-
 msgid "Check hostgroup associate error."
 msgstr "檢查主機群組關聯時發生錯誤。"
 
@@ -699,12 +641,6 @@ msgstr "檢查 LUN 群組關聯時發生
 msgid "Check portgroup associate error."
 msgstr "檢查埠群組關聯時發生錯誤。"
 
-msgid ""
-"Check the state of the http service. Also ensure that the https port number "
-"is the same as the one specified in cinder.conf."
-msgstr ""
-"請檢查 HTTP 服務的狀態。同時確保 HTTPS 埠號與 cinder.conf 中指定的埠號相同。"
-
 msgid "Chunk size is not multiple of block size for creating hash."
 msgstr "片段大小不是用於建立雜湊之區塊大小的倍數。"
 
@@ -720,10 +656,6 @@ msgstr ""
 "複製類型 '%(clone_type)s' 無效；有效值為：'%(full_clone)s' 和 "
 "'%(linked_clone)s'。"
 
-msgid ""
-"Cluster is not formatted. You should probably perform \"dog cluster format\"."
-msgstr "叢集未格式化。您可能應該執行 \"dog cluster format\"。"
-
 #, python-format
 msgid "CommandLineHelper._wait_for_condition: %s timeout."
 msgstr "CommandLineHelper._wait_for_condition：%s 逾時。"
@@ -738,10 +670,6 @@ msgstr "找不到計算叢集：%(cluste
 msgid "Condition has no field."
 msgstr "條件不含任何欄位。"
 
-#, python-format
-msgid "Config 'max_over_subscription_ratio' invalid. Must be > 0: %s"
-msgstr "配置 'max_over_subscription_ratio' 無效。必需大於 0：%s"
-
 msgid "Configuration error: dell_sc_ssn not set."
 msgstr "配置錯誤：未設定 dell_sc_ssn。"
 
@@ -792,6 +720,10 @@ msgid "Converted to %(f1)s, but format i
 msgstr "已轉換為 %(f1)s，但格式現在為 %(f2)s"
 
 #, python-format
+msgid "Converted to %(vol_format)s, but format is now %(file_format)s"
+msgstr "已轉換為 %(vol_format)s，但格式現在為 %(file_format)s"
+
+#, python-format
 msgid "Converted to raw, but format is now %s"
 msgstr "已轉換為原始，但格式現在為 %s"
 
@@ -1145,190 +1077,6 @@ msgstr "啟用抄寫。"
 msgid "Ensure that configfs is mounted at /sys/kernel/config."
 msgstr "請確保 configfs 已裝載於 /sys/kernel/config 中。"
 
-#, python-format
-msgid ""
-"Error Cloning Snapshot: %(snapshot)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Clone project: %(clone_proj)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"在儲存區 %(pool)s 的磁區 %(lun)s 上複製 Snapshot：%(snapshot)s 時發生錯誤專"
-"案：%(project)s，副本專案：%(clone_proj)s，回覆碼：%(ret.status)d。訊息："
-"%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Creating Initiator: %(initiator)s on Alias: %(alias)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"在別名 %(alias)s 上建立起始器 %(initiator)s 時發生錯誤。回覆碼："
-"%(ret.status)d。訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Creating Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"在儲存區 %(pool)s 上建立專案 %(project)s 時發生錯誤。回覆碼：%(ret.status)d。"
-"訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Creating Property: %(property)s Type: %(type)s Description: "
-"%(description)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"建立內容 %(property)s 類型 %(type)s 說明%(description)s 時發生錯誤。回覆碼："
-"%(ret.status)d。訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Creating Share: %(name)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"建立共用 %(name)s 時發生錯誤。回覆碼：%(ret.status)d。訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Creating Volume: %(lun)s Size: %(size)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"建立磁區 %(lun)s 時發生錯誤。大小：%(size)s。回覆碼：%(ret.status)d。訊息："
-"%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Share: %(share)s to Pool: %(pool)s "
-"Project: %(project)s Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"在下列儲存區的共用 %(share)s 上刪除 Snapshot %(snapshot)s 時發生錯誤："
-"%(pool)s 專案：%(project)s 回覆碼：%(ret.status)d。訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Deleting Snapshot: %(snapshot)s on Volume: %(lun)s to Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"在下列儲存區的磁區 %(lun)s 上刪除 Snapshot：%(snapshot)s 時發生錯誤："
-"%(pool)s 專案：%(project)s  回覆碼：%(ret.status)d 訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Deleting Volume: %(lun)s from Pool: %(pool)s, Project: %(project)s. "
-"Return code: %(ret.status)d, Message: %(ret.data)s."
-msgstr ""
-"從儲存區 %(pool)s 刪除磁區 %(lun)s 時發生錯誤，專案 %(project)s。回覆碼："
-"%(ret.status)d，訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Deleting project: %(project)s on pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"刪除儲存區 %(pool)s 上的專案 %(project)s 時發生錯誤。回覆碼：%(ret.status)d。"
-"訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Deleting replication action: %(id)s Return code: %(ret.status)d "
-"Message: %(ret.data)s."
-msgstr ""
-"刪除抄寫動作 %(id)s 時發生錯誤。回覆碼：%(ret.status)d。訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Getting Initiators: InitiatorGroup: %(initiatorgroup)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"取得起始器時發生錯誤：InitiatorGroup：%(initiatorgroup)s 回覆碼："
-"%(ret.status)d。訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Getting Pool Stats: Pool: %(pool)s Return code: %(status)d Message: "
-"%(data)s."
-msgstr ""
-"取得儲存區統計資料時發生錯誤：儲存區：%(pool)s，回覆碼：%(status)d，訊息："
-"%(data)s。"
-
-#, python-format
-msgid ""
-"Error Getting Project Stats: Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"取得專案統計資料時發生錯誤：儲存區：%(pool)s，專案：%(project)s，回覆碼："
-"%(ret.status)d，訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Getting Share: %(share)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"取得儲存區 %(pool)s 上的共用 %(share)s 時發生錯誤。專案：%(project)s回覆碼："
-"%(ret.status)d。訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Getting Volume: %(lun)s on Pool: %(pool)s Project: %(project)s Return "
-"code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"取得儲存區 %(pool)s 上的磁區 %(lun)s 時發生錯誤。專案：%(project)s。回覆碼："
-"%(ret.status)d。訊息：%(ret.data)s。"
-
-#, python-format
-msgid "Error Pool ownership: Pool %(pool)s is not owned by %(host)s."
-msgstr "錯誤的儲存區所有權：儲存區 %(pool)s 不歸 %(host)s 擁有。"
-
-#, python-format
-msgid ""
-"Error Setting props Props: %(props)s on Volume: %(lun)s of Pool: %(pool)s "
-"Project: %(project)s  Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"在儲存區 %(pool)s 的磁區 %(lun)s 上設定內容 Props：%(props)s 時發生錯誤專案："
-"%(project)s。回覆碼：%(ret.status)d。訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying Initiator: %(iqn)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"驗證起始器 %(iqn)s 時發生錯誤。回覆碼：%(ret.status)d。訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying Pool: %(pool)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"驗證儲存區 %(pool)s 時發生錯誤。回覆碼：%(ret.status)d。訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying Project: %(project)s on Pool: %(pool)s Return code: "
-"%(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"在儲存區 %(pool)s 上驗證專案 %(project)s 時發生錯誤。回覆碼：%(ret.status)d。"
-"訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"驗證服務 %(service)s 時發生錯誤。回覆碼：%(ret.status)d。訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying Target: %(alias)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"驗證目標 %(alias)s 時發生錯誤。回覆碼：%(ret.status)d。訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error Verifying share: %(share)s on Project: %(project)s and Pool: %(pool)s "
-"Return code: %(ret.status)d Message: %(ret.data)s."
-msgstr ""
-"在專案 %(project)s 及儲存區 %(pool)s 上驗證共用 %(share)s 時發生錯誤。回覆"
-"碼：%(ret.status)d，訊息：%(ret.data)s。"
-
 msgid "Error connecting to ceph cluster."
 msgstr "連接至 ceph 叢集時發生錯誤。"
 
@@ -1357,14 +1105,6 @@ msgstr "評估器剖析期間發生錯
 
 #, python-format
 msgid ""
-"Error editing share: %(share)s on Pool: %(pool)s Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"編輯儲存區 %(pool)s 上的共用 %(share)s 時發生錯誤。回覆碼：%(ret.status)d。訊"
-"息：%(ret.data)s。"
-
-#, python-format
-msgid ""
 "Error enabling iSER for NetworkPortal: please ensure that RDMA is supported "
 "on your iSCSI port %(port)d on ip %(ip)s."
 msgstr ""
@@ -1391,51 +1131,15 @@ msgstr "延伸磁區時發生錯誤：%(
 msgid "Error finding %(name)s."
 msgstr "尋找 %(name)s 時發生錯誤。"
 
-msgid ""
-"Error getting appliance version details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"取得軟體驅動裝置版本詳細資料時發生錯誤。回覆碼：%(ret.status)d。訊息：%(ret."
-"data)s。"
-
 #, python-format
 msgid "Error getting domain id from name %(name)s: %(id)s."
 msgstr "從名稱 %(name)s 取得網域 ID 時發生錯誤：%(id)s。"
 
-msgid "Error getting initiator groups."
-msgstr "取得起始器群組時發生錯誤。"
-
 #, python-format
 msgid "Error getting pool id from name %(pool_name)s: %(err_msg)s."
 msgstr "從名稱 %(pool_name)s 取得儲存區 ID 時發生錯誤：%(err_msg)s。"
 
 #, python-format
-msgid ""
-"Error getting replication action: %(id)s. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"取得抄寫動作 %(id)s 時發生錯誤。回覆碼：%(ret.status)d。訊息：%(ret.data)s。"
-
-msgid ""
-"Error getting replication source details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"取得抄寫來源詳細資料時發生錯誤。回覆碼：%(ret.status)d。訊息：%(ret.data)s。"
-
-msgid ""
-"Error getting replication target details. Return code: %(ret.status)d "
-"Message: %(ret.data)s ."
-msgstr ""
-"取得抄寫目標詳細資料時發生錯誤。回覆碼：%(ret.status)d。訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error getting version: svc: %(svc)s.Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"取得版本時發生錯誤：SVC：%(svc)s。回覆碼：%(ret.status)d 訊息：%(ret.data)s。"
-
-#, python-format
 msgid "Error in SolidFire API response: data=%(data)s"
 msgstr "SolidFire API 回應發生錯誤：資料 = %(data)s"
 
@@ -1443,21 +1147,6 @@ msgstr "SolidFire API 回應發生錯誤
 msgid "Error managing volume: %s."
 msgstr "管理磁區時發生錯誤：%s。"
 
-#, python-format
-msgid ""
-"Error modifying Service: %(service)s Return code: %(ret.status)d Message: "
-"%(ret.data)s."
-msgstr ""
-"修改服務 %(service)s 時發生錯誤。回覆碼：%(ret.status)d。訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error moving volume: %(vol)s from source project: %(src)s to target project: "
-"%(tgt)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"將磁區 %(vol)s 從來源專案 %(src)s 移至下列目標專案時發生錯誤：%(tgt)s。回覆"
-"碼：%(ret.status)d。訊息：%(ret.data)s。"
-
 msgid "Error not a KeyError."
 msgstr "此錯誤不是 KeyError。"
 
@@ -1472,35 +1161,6 @@ msgid "Error retrieving volume size"
 msgstr "擷取磁區大小時發生錯誤"
 
 #, python-format
-msgid ""
-"Error sending replication update for action id: %(id)s . Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"傳送動作識別碼 %(id)s 的抄寫更新時發生錯誤。回覆碼：%(ret.status)d。訊息："
-"%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error sending replication update. Returned error: %(err)s. Action: %(id)s."
-msgstr "傳送抄寫更新時發生錯誤。傳回的錯誤：%(err)s。動作：%(id)s。"
-
-#, python-format
-msgid ""
-"Error setting replication inheritance to %(set)s for volume: %(vol)s project "
-"%(project)s Return code: %(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"針對磁區 %(vol)s，將抄寫繼承設定為 %(set)s 時發生錯誤，專案：%(project)s。回"
-"覆碼：%(ret.status)d。訊息：%(ret.data)s。"
-
-#, python-format
-msgid ""
-"Error severing the package: %(package)s from source: %(src)s Return code: "
-"%(ret.status)d Message: %(ret.data)s ."
-msgstr ""
-"將套件 %(package)s 從來源 %(src)s 分離時發生錯誤。回覆碼：%(ret.status)d。訊"
-"息：%(ret.data)s。"
-
-#, python-format
 msgid "Error while authenticating with switch: %s."
 msgstr "對交換器進行鑑別時發生錯誤：%s。"
 
@@ -1634,14 +1294,6 @@ msgid "FC is the protocol but wwpns are
 msgstr "FC 是通訊協定，但 OpenStack 未提供 WWPN。"
 
 #, python-format
-msgid "Faield to unassign %(volume)s"
-msgstr "無法取消指派 %(volume)s"
-
-#, python-format
-msgid "Fail to create cache volume %(volume)s. Error: %(err)s"
-msgstr "無法建立快取磁區 %(volume)s。錯誤：%(err)s"
-
-#, python-format
 msgid "Failed adding connection for fabric=%(fabric)s: Error: %(err)s"
 msgstr "無法給架構 %(fabric)s 新增連線：錯誤：%(err)s"
 
@@ -1709,10 +1361,6 @@ msgid "Failed to connect to Dell REST AP
 msgstr "無法連接至 Dell REST API"
 
 #, python-format
-msgid "Failed to connect to sheep daemon. addr: %(addr)s, port: %(port)s"
-msgstr "無法連接 sheep 常駐程式。位址：%(addr)s，埠：%(port)s"
-
-#, python-format
 msgid "Failed to copy image to volume: %(reason)s"
 msgstr "無法將映像檔複製到磁區：%(reason)s"
 
@@ -1738,18 +1386,6 @@ msgid "Failed to create api volume flow.
 msgstr "無法建立 API 磁區流程。"
 
 #, python-format
-msgid "Failed to create cg snapshot %(id)s due to %(reason)s."
-msgstr "由於 %(reason)s，無法建立 cg Snapshot %(id)s。"
-
-#, python-format
-msgid "Failed to create consistency group %(id)s due to %(reason)s."
-msgstr "由於 %(reason)s，無法建立一致性群組 %(id)s。"
-
-#, python-format
-msgid "Failed to create consistency group %(id)s:%(ret)s."
-msgstr "無法建立一致性群組 %(id)s：%(ret)s。"
-
-#, python-format
 msgid "Failed to create consistency group: %(cgid)s. Error: %(excmsg)s."
 msgstr "無法建立一致性群組 %(cgid)s。錯誤：%(excmsg)s。"
 
@@ -1815,14 +1451,6 @@ msgid "Failed to create volume %s"
 msgstr "無法建立磁區 %s"
 
 #, python-format
-msgid "Failed to delete cgsnapshot %(id)s due to %(reason)s."
-msgstr "由於 %(reason)s，無法刪除 cg Snapshot %(id)s。"
-
-#, python-format
-msgid "Failed to delete consistency group %(id)s due to %(reason)s."
-msgstr "由於 %(reason)s，無法刪除一致性群組 %(id)s。"
-
-#, python-format
 msgid ""
 "Failed to delete fileset for consistency group %(cgname)s. Error: %(excmsg)s."
 msgstr "無法刪除一致性群組 %(cgname)s 的檔案集。錯誤：%(excmsg)s。"
@@ -1893,10 +1521,6 @@ msgid "Failed to find host %s."
 msgstr "找不到主機 %s。"
 
 #, python-format
-msgid "Failed to find iSCSI initiator group containing %(initiator)s."
-msgstr "找不到包含 %(initiator)s 的 iSCSI 起始器群組。"
-
-#, python-format
 msgid "Failed to get LUN target details for the LUN %s"
 msgstr "無法取得 LUN %s 的 LUN 目標詳細資料"
 
@@ -2004,12 +1628,6 @@ msgstr "無法登入 %s 陣列（無效
 msgid "Failed to login with all rest URLs."
 msgstr "無法使用所有其餘 URL 進行登入。"
 
-#, python-format
-msgid ""
-"Failed to make a request to Datera cluster endpoint due to the following "
-"reason: %s"
-msgstr "無法對 Datera 叢集端點發出要求，原因如下：%s"
-
 msgid "Failed to manage api volume flow."
 msgstr "無法管理 API 磁區流程。"
 
@@ -2189,26 +1807,6 @@ msgid "Failure staging LUN %s to tmp."
 msgstr "將 LUN %s 暫置到 tmp 時失敗。"
 
 #, python-format
-msgid "Fexvisor failed to add volume %(id)s due to %(reason)s."
-msgstr "由於 %(reason)s，Fexvisor 無法新增磁區 %(id)s。"
-
-#, python-format
-msgid ""
-"Fexvisor failed to join the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr "Fexvisor 無法結合群組 %(group)s 中的磁區 %(vol)s，原因：%(ret)s。"
-
-#, python-format
-msgid ""
-"Fexvisor failed to remove the volume %(vol)s in the group %(group)s due to "
-"%(ret)s."
-msgstr "Fexvisor 無法移除群組 %(group)s 中的磁區 %(vol)s，原因：%(ret)s。"
-
-#, python-format
-msgid "Fexvisor failed to remove volume %(id)s due to %(reason)s."
-msgstr "Fexvisor 無法移除磁區 %(id)s，原因：%(reason)s。"
-
-#, python-format
 msgid "Fibre Channel SAN Lookup failure: %(reason)s"
 msgstr "「光纖通道」SAN 查閱失敗：%(reason)s"
 
@@ -2225,10 +1823,6 @@ msgid "File %(file_path)s could not be f
 msgstr "找不到檔案 %(file_path)s。"
 
 #, python-format
-msgid "File already exists at %s."
-msgstr "%s 處已存在檔案。"
-
-#, python-format
 msgid "File already exists at: %s"
 msgstr "%s 處已存在檔案"
 
@@ -2259,159 +1853,6 @@ msgstr ""
 "'%(version)s' 版。"
 
 #, python-format
-msgid "Flexvisor assign volume failed.:%(id)s:%(status)s."
-msgstr "Flexvisor 指派磁區失敗：%(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor assign volume failed:%(id)s:%(status)s."
-msgstr "Flexvisor 指派磁區失敗：%(id)s：%(status)s。"
-
-#, python-format
-msgid ""
-"Flexvisor could not find volume %(id)s snapshot in the group %(vgid)s "
-"snapshot %(vgsid)s."
-msgstr ""
-"Flexvisor 在群組 %(vgid)s Snapshot %(vgsid)s 中找不到磁區 %(id)s Snapshot。"
-
-#, python-format
-msgid "Flexvisor create volume failed.:%(volumeid)s:%(status)s."
-msgstr "Flexvisor 建立磁區失敗：%(volumeid)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed deleting volume %(id)s: %(status)s."
-msgstr "Flexvisor 無法刪除磁區 %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to add volume %(id)s to group %(cgid)s."
-msgstr "Flexvisor 無法將磁區 %(id)s 新增至群組 %(cgid)s。"
-
-#, python-format
-msgid ""
-"Flexvisor failed to assign volume %(id)s due to unable to query status by "
-"event id."
-msgstr "Flexvisor 無法指派磁區 %(id)s，原因是無法依事件 ID 來查詢狀態。"
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(id)s: %(status)s."
-msgstr "Flexvisor 無法指派磁區 %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to assign volume %(volume)s iqn %(iqn)s."
-msgstr "Flexvisor 無法指派磁區 %(volume)s iqn %(iqn)s。"
-
-#, python-format
-msgid "Flexvisor failed to clone volume %(id)s: %(status)s."
-msgstr "Flexvisor 無法複製磁區 %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to clone volume (failed to get event) %(id)s."
-msgstr "Flexvisor 無法複製磁區（無法取得事件）%(id)s。"
-
-#, python-format
-msgid "Flexvisor failed to create snapshot for volume %(id)s: %(status)s."
-msgstr "Flexvisor 無法建立磁區 %(id)s 的 Snapshot：%(status)s。"
-
-#, python-format
-msgid ""
-"Flexvisor failed to create snapshot for volume (failed to get event) %(id)s."
-msgstr "Flexvisor 無法建立下列磁區的 Snapshot（無法取得事件）：%(id)s。"
-
-#, python-format
-msgid "Flexvisor failed to create volume %(id)s in the group %(vgid)s."
-msgstr "Flexvisor 無法在群組 %(vgid)s 中建立磁區 %(id)s。"
-
-#, python-format
-msgid "Flexvisor failed to create volume %(volume)s: %(status)s."
-msgstr "Flexvisor 無法建立磁區 %(volume)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to create volume (get event) %s."
-msgstr "Flexvisor 無法建立磁區（取得事件）%s。"
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s: %(status)s."
-msgstr "Flexvisor 無法從 Snapshot %(id)s 建立磁區：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to create volume from snapshot %(id)s:%(status)s."
-msgstr "Flexvisor 無法從 Snapshot %(id)s 建立磁區：%(status)s。"
-
-#, python-format
-msgid ""
-"Flexvisor failed to create volume from snapshot (failed to get event) %(id)s."
-msgstr "Flexvisor 無法從下列 Snapshot 建立磁區（無法取得事件）：%(id)s。"
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot %(id)s: %(status)s."
-msgstr "Flexvisor 無法刪除 Snapshot %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to delete snapshot (failed to get event) %(id)s."
-msgstr "Flexvisor 無法刪除 Snapshot（無法取得事件）%(id)s。"
-
-#, python-format
-msgid "Flexvisor failed to delete volume %(id)s: %(status)s."
-msgstr "Flexvisor 無法刪除磁區 %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s: %(status)s."
-msgstr "Flexvisor 無法延伸磁區 %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to extend volume %(id)s:%(status)s."
-msgstr "Flexvisor 無法延伸磁區 %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to extend volume (failed to get event) %(id)s."
-msgstr "Flexvisor 無法延伸磁區（無法取得事件）%(id)s。"
-
-#, python-format
-msgid "Flexvisor failed to get pool info %(id)s: %(status)s."
-msgstr "Flexvisor 無法取得儲存區資訊 %(id)s：%(status)s。"
-
-#, python-format
-msgid ""
-"Flexvisor failed to get snapshot id of volume %(id)s from group %(vgid)s."
-msgstr "Flexvisor 無法從群組 %(vgid)s 取得磁區 %(id)s 的 Snapshot ID。"
-
-#, python-format
-msgid "Flexvisor failed to remove volume %(id)s from group %(cgid)s."
-msgstr "Flexvisor 無法從群組 %(cgid)s 中移除磁區 %(id)s。"
-
-#, python-format
-msgid "Flexvisor failed to spawn volume from snapshot %(id)s:%(status)s."
-msgstr "Flexvisor 無法從 Snapshot %(id)s 大量產生磁區：%(status)s。"
-
-#, python-format
-msgid ""
-"Flexvisor failed to spawn volume from snapshot (failed to get event) %(id)s."
-msgstr "Flexvisor 無法從下列 Snapshot 大量產生磁區（無法取得事件）：%(id)s。"
-
-#, python-format
-msgid "Flexvisor failed to unassign volume %(id)s: %(status)s."
-msgstr "Flexvisor 無法取消指派磁區 %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor failed to unassign volume (get event) %(id)s."
-msgstr "Flexvisor 無法取消指派磁區（取得事件）%(id)s。"
-
-#, python-format
-msgid "Flexvisor failed to unassign volume:%(id)s:%(status)s."
-msgstr "Flexvisor 無法取消指派磁區 %(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor unable to find the source volume %(id)s info."
-msgstr "Flexvisor 找不到來源磁區 %(id)s 資訊。"
-
-#, python-format
-msgid "Flexvisor unassign volume failed:%(id)s:%(status)s."
-msgstr "Flexvisor 取消指派磁區失敗：%(id)s：%(status)s。"
-
-#, python-format
-msgid "Flexvisor volume %(id)s failed to join group %(vgid)s."
-msgstr "Flexvisor 磁區 %(id)s 無法加入群組 %(vgid)s 中。"
-
-#, python-format
 msgid "Folder %s does not exist in Nexenta Store appliance"
 msgstr "資料夾 %s 不存在於「Nexenta 儲存庫」軟體驅動裝置中"
 
@@ -2717,14 +2158,6 @@ msgid "Invalid Replication Target: %(rea
 msgstr "無效的抄寫目標：%(reason)s"
 
 #, python-format
-msgid ""
-"Invalid Virtuozzo Storage share specification: %r. Must be: [MDS1[,"
-"MDS2],...:/]<CLUSTER NAME>[:PASSWORD]."
-msgstr ""
-"Virtuozzo 儲存體共用項目規格無效：%r。必須是：[MDS1[,MDS2],...:/]<CLUSTER "
-"NAME>[:PASSWORD]。"
-
-#, python-format
 msgid "Invalid XtremIO version %(cur)s, version %(min)s or up is required"
 msgstr "XtremIO %(cur)s 版無效，需要 %(min)s 版或更高版本"
 
@@ -2732,13 +2165,6 @@ msgstr "XtremIO %(cur)s 版無效，需
 msgid "Invalid allocated quotas defined for the following project quotas: %s"
 msgstr "為下列專案配額定義的已配置配額無效：%s"
 
-msgid "Invalid argument - negative seek offset."
-msgstr "無效的引數 - 負數探查偏移。"
-
-#, python-format
-msgid "Invalid argument - whence=%s not supported."
-msgstr "無效的引數 - 不支援 whence=%s。"
-
 #, python-format
 msgid "Invalid attaching mode '%(mode)s' for volume %(volume_id)s."
 msgstr "連接模式 '%(mode)s' 不適用於磁區 %(volume_id)s。"
@@ -2752,15 +2178,6 @@ msgid "Invalid backup: %(reason)s"
 msgstr "無效的備份：%(reason)s"
 
 #, python-format
-msgid "Invalid connection initialization response of volume %(name)s"
-msgstr "磁區 %(name)s 的連線起始設定回應無效"
-
-#, python-format
-msgid ""
-"Invalid connection initialization response of volume %(name)s: %(output)s"
-msgstr "磁區 %(name)s 的連線起始設定回應無效：%(output)s"
-
-#, python-format
 msgid "Invalid content type %(content_type)s."
 msgstr "無效的內容類型 %(content_type)s。"
 
@@ -2845,10 +2262,6 @@ msgid "Invalid mount point base: %s"
 msgstr "無效的裝載點基本程式：%s"
 
 #, python-format
-msgid "Invalid mount point base: %s."
-msgstr "無效的裝載點基本程式：%s。"
-
-#, python-format
 msgid "Invalid new snapCPG name for retype.  new_snap_cpg='%s'."
 msgstr "新 snapCPG 名稱無效，無法執行 Retype 動作。new_snap_cpg='%s'。"
 
@@ -2867,9 +2280,6 @@ msgstr "次要 ID %s 無效。"
 msgid "Invalid service catalog json."
 msgstr "無效的服務型錄 JSON。"
 
-msgid "Invalid sheepdog cluster status."
-msgstr "sheepdog 叢集狀態無效。"
-
 #, python-format
 msgid "Invalid snapshot: %(reason)s"
 msgstr "無效的 Snapshot：%(reason)s"
@@ -2948,10 +2358,6 @@ msgid ""
 "consistency group)."
 msgstr "提供的 volume_type 無效：%s（所要求的類型必須受此一致性群組支援）。"
 
-#, python-format
-msgid "Invalid wwpns format %(wwpns)s"
-msgstr "無效的 WWPN 格式 %(wwpns)s"
-
 msgid "Issue encountered waiting for job."
 msgstr "等待工作時遇到問題。"
 
@@ -2962,10 +2368,6 @@ msgid ""
 "Issuing a fail-over failed because replication is not properly configured."
 msgstr "發出失效接手失敗，因為未正確配置抄寫。"
 
-#, python-format
-msgid "KeyError: %s"
-msgstr "KeyError：%s"
-
 msgid "Keystone version 3 or greater must be used to get nested quota support."
 msgstr "Keystone 第 3 版或更高版本必須用於取得巢狀配額支援。"
 
@@ -3234,9 +2636,6 @@ msgstr ""
 msgid "New volume type not specified in request_spec."
 msgstr "request_spec 中沒有指定新的磁區類型。"
 
-msgid "Nimble Cinder Driver exception"
-msgstr "Nimble Cinder 驅動程式異常狀況"
-
 msgid "No FC initiator can be added to host."
 msgstr "任何 FC 起始器均無法新增至主機。"
 
@@ -3274,10 +2673,6 @@ msgid "No initiator connected to fabric.
 msgstr "沒有起始器已連接至光纖。"
 
 #, python-format
-msgid "No initiator group found for initiator %s"
-msgstr "找不到起始器 %s 的起始器群組"
-
-#, python-format
 msgid "No interface found on cluster for ip %s"
 msgstr "在叢集上找不到 IP %s 的介面"
 
@@ -3290,9 +2685,6 @@ msgstr "找不到已裝載的 NFS 共用
 msgid "No mounted SMBFS shares found."
 msgstr "找不到已裝載的 SMBFS 共用項目。"
 
-msgid "No mounted Virtuozzo Storage shares found"
-msgstr "找不到已裝載的 Virtuozzo 儲存體共用項目"
-
 msgid "No mounted shares found"
 msgstr "找不到已裝載的共用項目"
 
@@ -3315,9 +2707,6 @@ msgstr "找不到含有 %s 的 Snapshot
 msgid "No such QoS spec %(specs_id)s."
 msgstr "沒有這類服務品質規格 %(specs_id)s。"
 
-msgid "No suitable discovery ip found"
-msgstr "找不到適當的探索 IP"
-
 #, python-format
 msgid "No support to restore backup version %s"
 msgstr "不支援還原備份版本 %s"
@@ -3352,9 +2741,6 @@ msgstr "未被授權"
 msgid "Not enough space on backend (%(backend)s)"
 msgstr "後端 (%(backend)s) 上空間不足"
 
-msgid "Not enough storage space in the ZFS share to perform this operation."
-msgstr "ZFS 共用中的儲存體空間不足，無法執行此作業。"
-
 msgid "Not stored in rbd"
 msgstr "未儲存在 rbd 中"
 
@@ -3385,9 +2771,6 @@ msgid ""
 msgstr ""
 "只容許具備已限定為原生母項或 root 專案範圍之記號的使用者來查看其子項配額。"
 
-msgid "Only volumes managed by OpenStack can be unmanaged."
-msgstr "只能取消管理由 OpenStack 進行管理的磁區。"
-
 #, python-format
 msgid "Operation failed with status=%(status)s. Full dump: %(data)s"
 msgstr "作業失敗，狀態 = %(status)s。完整傾出：%(data)s"
@@ -3430,9 +2813,6 @@ msgstr "原則不容許執行 %(action)s
 msgid "Pool is not available in the volume host field."
 msgstr "在磁區主機欄位中無法使用儲存區。"
 
-msgid "Pool is not available in the volume host fields."
-msgstr "在磁區主機欄位中無法使用儲存區。"
-
 #, python-format
 msgid "Pool with name %(pool_name)s wasn't found in domain %(domain_id)s."
 msgstr "在網域 %(domain_id)s 中找不到名稱為 %(pool_name)s 的儲存區。"
@@ -3568,13 +2948,6 @@ msgstr "參照必須包含 source-name 
 msgid "Reference must contain source-name."
 msgstr "參照必須包含 source-name。"
 
-msgid "Reference to volume to be managed must contain source-name."
-msgstr "對要管理之磁區的參照必需包含 source-name。"
-
-#, python-format
-msgid "Reference to volume: %s to be managed must contain source-name."
-msgstr "對要管理之磁區 %s 的參照必需包含 source-name。"
-
 #, python-format
 msgid ""
 "Refusing to migrate volume ID: %(id)s. Please check your configuration "
@@ -3636,10 +3009,6 @@ msgid "Request body contains too many it
 msgstr "要求內文包含太多項目"
 
 #, python-format
-msgid "Request to Datera cluster returned bad status: %(status)s | %(reason)s"
-msgstr "傳送至 Datera 叢集的要求，傳回了不正確的狀態：%(status)s | %(reason)s"
-
-#, python-format
 msgid ""
 "Requested backup exceeds allowed Backup gigabytes quota. Requested "
 "%(requested)sG, quota is %(quota)sG and %(consumed)sG has been consumed."
@@ -3748,10 +3117,6 @@ msgid "SMBFS config file not set (smbfs_
 msgstr "未設定 SMBFS 配置檔 (smbfs_shares_config)。"
 
 #, python-format
-msgid "SSH Command failed after '%(total_attempts)r' attempts : '%(command)s'"
-msgstr "嘗試 '%(total_attempts)r' 次之後 SSH 指令仍失敗：'%(command)s'"
-
-#, python-format
 msgid "SSH command injection detected: %(command)s"
 msgstr "偵測到 SSH 指令注入：%(command)s"
 
@@ -3793,10 +3158,6 @@ msgstr "設定配對次要存取時發
 msgid "Sets thin provisioning."
 msgstr "設定精簡供應。"
 
-#, python-format
-msgid "Sheepdog I/O Error, command was: \"%s\"."
-msgstr "Sheepdog I/O 錯誤，指令為：\"%s\"。"
-
 msgid ""
 "Show operations can only be made to projects in the same hierarchy of the "
 "project in which users are scoped to."
@@ -3969,14 +3330,6 @@ msgid ""
 msgstr ""
 "GPFS 檔案系統 %(fs)s 不是必要的版次。現行層次是 %(cur)s，必須至少是 %(min)s。"
 
-#, python-format
-msgid ""
-"The WebDAV request failed. Reason: %(msg)s, Return code/reason: %(code)s, "
-"Source Volume: %(src)s, Destination Volume: %(dst)s, Method: %(method)s."
-msgstr ""
-"WebDAV 要求失敗。原因：%(msg)s，回覆碼/原因：%(code)s，來源磁區：%(src)s，目"
-"的地磁區：%(dst)s，方法：%(method)s。"
-
 msgid ""
 "The above error may show that the database has not been created.\n"
 "Please create a database using 'cinder-manage db sync' before running this "
@@ -4050,9 +3403,6 @@ msgstr "保留計數必須小於或等
 msgid "The snapshot cannot be created when the volume is in maintenance mode."
 msgstr "當磁區處於維護模式時，無法建立 Snapshot。"
 
-msgid "The source volume for this WebDAV operation not found."
-msgstr "找不到此 WebDAV 作業的來源磁區。"
-
 #, python-format
 msgid ""
 "The source volume type '%(src)s' is different than the destination volume "
@@ -4234,10 +3584,6 @@ msgid "Type cannot be converted into NaE
 msgstr "無法將類型轉換為 NaElement。"
 
 #, python-format
-msgid "TypeError: %s"
-msgstr "TypeError：%s"
-
-#, python-format
 msgid "UUIDs %s are in both add and remove volume list."
 msgstr "UUID %s 同時位於新增和移除磁區清單中。"
 
@@ -4468,9 +3814,6 @@ msgstr "非預期的 CLI 回應：標頭
 msgid "Unexpected output. Expected [%(expected)s] but received [%(output)s]"
 msgstr "非預期的輸出。預期 [%(expected)s]，但卻接收到 [%(output)s]"
 
-msgid "Unexpected response from Nimble API"
-msgstr "來自 Nimble API 的非預期回應"
-
 msgid "Unexpected status code"
 msgstr "非預期的狀態碼"
 
@@ -4491,37 +3834,10 @@ msgstr "不明的 RemoteFS 異常狀況"
 msgid "Unknown SMBFS exception."
 msgstr "不明的 SMBFS 異常狀況。"
 
-msgid "Unknown Virtuozzo Storage exception"
-msgstr "「不明 Virtuozzo 儲存體」異常狀況"
-
 msgid "Unknown action"
 msgstr "不明動作"
 
 #, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, Set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"如果要管理的磁區 %s 已經由 Cinder 進行管理，則是不明情況。正在終止管理磁區。"
-"請將 'cinder_managed' 自訂綱目內容新增至該磁區，並將它的值設為 False。或者，"
-"將 Cinder 配置原則 'zfssa_manage_policy' 的值設為 'loose'，以移除此限制。"
-
-#, python-format
-msgid ""
-"Unknown if the volume: %s to be managed is already being managed by Cinder. "
-"Aborting manage volume. Please add 'cinder_managed' custom schema property "
-"to the volume and set its value to False. Alternatively, set the value of "
-"cinder config policy 'zfssa_manage_policy' to 'loose' to remove this "
-"restriction."
-msgstr ""
-"如果要管理的磁區 %s 已經由 Cinder 進行管理，則是不明情況。正在終止管理磁區。"
-"請將 'cinder_managed' 自訂綱目內容新增至該磁區，並將它的值設為 False。或者，"
-"將 Cinder 配置原則 'zfssa_manage_policy' 的值設為 'loose'，以移除此限制。"
-
-#, python-format
 msgid "Unknown or unsupported command %(cmd)s"
 msgstr "不明或不支援的指令 %(cmd)s"
 
@@ -4616,9 +3932,6 @@ msgstr "使用者識別號"
 msgid "User does not have admin privileges"
 msgstr "使用者並沒有管理者權力"
 
-msgid "User not authorized to perform WebDAV operations."
-msgstr "使用者未獲授權來執行 WebDAV 作業。"
-
 msgid "UserName is not configured."
 msgstr "未配置 UserName。"
 
@@ -4646,10 +3959,6 @@ msgid ""
 msgstr "值 \"%(value)s\" 不適用於配置選項 \"%(option)s\""
 
 #, python-format
-msgid "ValueError: %s"
-msgstr "ValueError：%s"
-
-#, python-format
 msgid "Vdisk %(name)s not involved in mapping %(src)s -> %(tgt)s."
 msgstr "從 %(src)s 到 %(tgt)s 的對映未涉及到 vdisk %(name)s。"
 
@@ -4742,23 +4051,10 @@ msgid "Volume %s does not exist on the a
 msgstr "磁區 %s 不在陣列上。"
 
 #, python-format
-msgid "Volume %s does not have provider_location specified, skipping."
-msgstr "沒有為磁區 %s 指定 provider_location，正在跳過。"
-
-#, python-format
 msgid "Volume %s doesn't exist on array."
 msgstr "磁區 %s 不在陣列上。"
 
 #, python-format
-msgid "Volume %s doesn't exist on the ZFSSA backend."
-msgstr "磁區 %s 不存在於 ZFSSA 後端上。"
-
-#, python-format
-msgid ""
-"Volume %s is online. Set volume to offline for managing using OpenStack."
-msgstr "磁區 %s 在線上。請將磁區設為離線，以使用 OpenStack 進行管理。"
-
-#, python-format
 msgid "Volume %s must not be part of a consistency group."
 msgstr "磁區 %s 不得為一致性群組的一部分。"
 
@@ -4890,9 +4186,6 @@ msgstr "尚未將磁區指派給主機
 msgid "Volume replication for %(volume_id)s could not be found."
 msgstr "找不到 %(volume_id)s 的磁區抄寫。"
 
-msgid "Volume should have agent-type set as None."
-msgstr "磁區應該將代理程式類型設定為「無」。"
-
 #, python-format
 msgid ""
 "Volume size %(volume_size)sGB cannot be smaller than the image minDisk size "
@@ -4929,9 +4222,6 @@ msgstr "磁區大小必須是 1 GB 的
 msgid "Volume size must multiple of 1 GB."
 msgstr "磁區大小必須是 1 GB 的倍數。"
 
-msgid "Volume status must be 'available'."
-msgstr "磁區狀態必須為「可用」。"
-
 msgid "Volume to Initiator Group mapping already exists"
 msgstr "磁區至起始器群組的對映已存在"
 
@@ -4979,32 +4269,14 @@ msgstr "磁區類型名稱不能為空
 msgid "Volume type with name %(volume_type_name)s could not be found."
 msgstr "找不到名稱為 %(volume_type_name)s 的磁區類型。"
 
-#, python-format
-msgid "Volume: %s is already being managed by Cinder."
-msgstr "磁區 %s 已經由 Cinder 進行管理。"
-
 msgid ""
 "Volumes/account exceeded on both primary and secondary SolidFire accounts."
 msgstr "超過了主要及次要 SolidFire 帳戶上的磁區/帳戶。"
 
 #, python-format
-msgid ""
-"VzStorage config 'vzstorage_used_ratio' invalid. Must be > 0 and <= 1.0: %s."
-msgstr ""
-"VzStorage 配置 'vzstorage_used_ratio' 無效。必須大於 0 且小於或等於 1.0：%s。"
-
-#, python-format
-msgid "VzStorage config file at %(config)s doesn't exist."
-msgstr "%(config)s 處的 VzStorage 配置檔不存在。"
-
-#, python-format
 msgid "Wait synchronize failed. Running status: %s."
 msgstr "等待同步失敗。執行中狀態：%s。"
 
-msgid ""
-"Waiting for all nodes to join cluster. Ensure all sheep daemons are running."
-msgstr "正在等待所有節點結合叢集。請確保所有 sheep 常駐程式都在執行中。"
-
 msgid "We should not do switch over on primary array."
 msgstr "我們不應切換到主要陣列上。"
 
@@ -5698,9 +4970,6 @@ msgstr "extend_volume，磁區名稱：%
 msgid "fake"
 msgstr "偽造"
 
-msgid "fileno is not supported by SheepdogIOWrapper"
-msgstr "SheepdogIOWrapper 不支援 fileno"
-
 #, python-format
 msgid "fmt=%(fmt)s backed by: %(backing_file)s"
 msgstr "fmt = %(fmt)s 受 %(backing_file)s 支援"
@@ -5747,11 +5016,6 @@ msgstr ""
 "gpfs_images_share_mode 已設為 copy_on_write，但 %(vol)s 及 %(img)s 屬於不同的"
 "檔案集。"
 
-msgid ""
-"http service may have been abruptly disabled or put to maintenance state in "
-"the middle of this operation."
-msgstr "HTTP 服務可能已在執行此作業的中途意外停用或置於維護狀態。"
-
 msgid "id cannot be None"
 msgstr "ID 不能為 None"
 
@@ -6020,9 +5284,3 @@ msgstr "已指派磁區"
 
 msgid "volumes changed"
 msgstr "已變更磁區"
-
-#, python-format
-msgid ""
-"zfssa_manage_policy property needs to be set to 'strict' or 'loose'. Current "
-"value is: %s."
-msgstr "zfssa_manage_policy 內容需要設為 'strict' 或 'loose'。現行值為：%s。"
diff -pruN 2:15.0.1-1/cinder/manager.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/manager.py
--- 2:15.0.1-1/cinder/manager.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/manager.py	2020-03-24 18:46:31.000000000 +0000
@@ -51,7 +51,8 @@ This module provides Manager, a base cla
 
 """
 
-
+from eventlet import greenpool
+from eventlet import tpool
 from oslo_config import cfg
 from oslo_log import log as logging
 import oslo_messaging as messaging
@@ -67,10 +68,6 @@ from cinder import rpc
 from cinder.scheduler import rpcapi as scheduler_rpcapi
 from cinder import utils
 
-from eventlet import greenpool
-from eventlet import tpool
-
-
 CONF = cfg.CONF
 LOG = logging.getLogger(__name__)
 
@@ -177,12 +174,13 @@ class SchedulerDependentManager(ThreadPo
     """
 
     def __init__(self, host=None, db_driver=None, service_name='undefined',
-                 cluster=None):
+                 cluster=None, *args, **kwargs):
         self.last_capabilities = None
         self.service_name = service_name
         self.scheduler_rpcapi = scheduler_rpcapi.SchedulerAPI()
         super(SchedulerDependentManager, self).__init__(host, db_driver,
-                                                        cluster=cluster)
+                                                        cluster=cluster,
+                                                        *args, **kwargs)
 
     def update_service_capabilities(self, capabilities):
         """Remember these capabilities to send on next periodic update."""
diff -pruN 2:15.0.1-1/cinder/objects/backup.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/objects/backup.py
--- 2:15.0.1-1/cinder/objects/backup.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/objects/backup.py	2020-03-24 18:46:31.000000000 +0000
@@ -43,7 +43,7 @@ class Backup(base.CinderPersistentObject
     # Version 1.7: Add parent
     VERSION = '1.7'
 
-    OPTIONAL_FIELDS = ('metadata',)
+    OPTIONAL_FIELDS = ('metadata', 'parent')
 
     fields = {
         'id': fields.UUIDField(),
@@ -156,6 +156,11 @@ class Backup(base.CinderPersistentObject
         if not self._context:
             raise exception.OrphanedObjectError(method='obj_load_attr',
                                                 objtype=self.obj_name())
+        if attrname == 'parent':
+            if self.parent_id:
+                self.parent = self.get_by_id(self._context, self.parent_id)
+            else:
+                self.parent = None
         self.obj_reset_changes(fields=[attrname])
 
     def obj_what_changed(self):
@@ -212,7 +217,7 @@ class Backup(base.CinderPersistentObject
         # We don't want to export extra fields and we want to force lazy
         # loading, so we can't use dict(self) or self.obj_to_primitive
         record = {name: field.to_primitive(self, name, getattr(self, name))
-                  for name, field in self.fields.items()}
+                  for name, field in self.fields.items() if name != 'parent'}
         # We must update kwargs instead of record to ensure we don't overwrite
         # "real" data from the backup
         kwargs.update(record)
diff -pruN 2:15.0.1-1/cinder/objects/base.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/objects/base.py
--- 2:15.0.1-1/cinder/objects/base.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/objects/base.py	2020-03-24 18:46:31.000000000 +0000
@@ -280,7 +280,7 @@ class CinderPersistentObject(object):
         # registration.
         try:
             cls.model = db.get_model_for_versioned_object(cls)
-        except (ImportError, AttributeError) as e:
+        except (ImportError, AttributeError):
             msg = _("Couldn't find ORM model for Persistent Versioned "
                     "Object %s.") % cls.obj_name()
             LOG.exception("Failed to initialize object.")
diff -pruN 2:15.0.1-1/cinder/objects/cgsnapshot.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/objects/cgsnapshot.py
--- 2:15.0.1-1/cinder/objects/cgsnapshot.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/objects/cgsnapshot.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,12 +12,13 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from oslo_versionedobjects import fields
+
 from cinder import db
 from cinder import exception
 from cinder.i18n import _
 from cinder import objects
 from cinder.objects import base
-from oslo_versionedobjects import fields
 
 
 @base.CinderObjectRegistry.register
diff -pruN 2:15.0.1-1/cinder/objects/consistencygroup.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/objects/consistencygroup.py
--- 2:15.0.1-1/cinder/objects/consistencygroup.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/objects/consistencygroup.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,6 +13,7 @@
 #    under the License.
 
 from oslo_utils import versionutils
+from oslo_versionedobjects import fields
 
 from cinder import db
 from cinder import exception
@@ -20,7 +21,6 @@ from cinder.i18n import _
 from cinder import objects
 from cinder.objects import base
 from cinder.objects import fields as c_fields
-from oslo_versionedobjects import fields
 
 
 @base.CinderObjectRegistry.register
diff -pruN 2:15.0.1-1/cinder/objects/group_snapshot.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/objects/group_snapshot.py
--- 2:15.0.1-1/cinder/objects/group_snapshot.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/objects/group_snapshot.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,12 +12,13 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from oslo_versionedobjects import fields
+
 from cinder import db
 from cinder import exception
 from cinder.i18n import _
 from cinder import objects
 from cinder.objects import base
-from oslo_versionedobjects import fields
 
 
 @base.CinderObjectRegistry.register
diff -pruN 2:15.0.1-1/cinder/objects/qos_specs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/objects/qos_specs.py
--- 2:15.0.1-1/cinder/objects/qos_specs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/objects/qos_specs.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,6 +12,7 @@
 
 from oslo_db import exception as db_exc
 from oslo_log import log as logging
+from oslo_versionedobjects import fields
 
 from cinder import db
 from cinder import exception
@@ -19,7 +20,6 @@ from cinder.i18n import _
 from cinder import objects
 from cinder.objects import base
 from cinder.objects import fields as c_fields
-from oslo_versionedobjects import fields
 
 LOG = logging.getLogger(__name__)
 
diff -pruN 2:15.0.1-1/cinder/objects/volume.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/objects/volume.py
--- 2:15.0.1-1/cinder/objects/volume.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/objects/volume.py	2020-03-24 18:46:31.000000000 +0000
@@ -192,9 +192,6 @@ class Volume(cleanable.CinderCleanableOb
 
     def __init__(self, *args, **kwargs):
         super(Volume, self).__init__(*args, **kwargs)
-        self._orig_metadata = {}
-        self._orig_admin_metadata = {}
-        self._orig_glance_metadata = {}
 
         self._reset_metadata_tracking()
 
diff -pruN 2:15.0.1-1/cinder/opts.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/opts.py
--- 2:15.0.1-1/cinder/opts.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/opts.py	2020-03-24 18:46:31.000000000 +0000
@@ -25,9 +25,8 @@ import itertools
 
 from keystoneauth1 import loading
 
-from cinder import objects
+from cinder import objects  # noqa
 objects.register_all()
-
 from cinder.api import common as cinder_api_common
 from cinder.api.middleware import auth as cinder_api_middleware_auth
 from cinder.api.views import versions as cinder_api_views_versions
@@ -75,8 +74,6 @@ from cinder.volume.drivers.datera import
     cinder_volume_drivers_datera_dateraiscsi
 from cinder.volume.drivers.dell_emc.powermax import common as \
     cinder_volume_drivers_dell_emc_powermax_common
-from cinder.volume.drivers.dell_emc import ps as \
-    cinder_volume_drivers_dell_emc_ps
 from cinder.volume.drivers.dell_emc.sc import storagecenter_common as \
     cinder_volume_drivers_dell_emc_sc_storagecentercommon
 from cinder.volume.drivers.dell_emc.unity import driver as \
@@ -135,9 +132,6 @@ from cinder.volume.drivers.netapp import
 from cinder.volume.drivers.nexenta import options as \
     cinder_volume_drivers_nexenta_options
 from cinder.volume.drivers import nfs as cinder_volume_drivers_nfs
-from cinder.volume.drivers import nimble as cinder_volume_drivers_nimble
-from cinder.volume.drivers.prophetstor import options as \
-    cinder_volume_drivers_prophetstor_options
 from cinder.volume.drivers import pure as cinder_volume_drivers_pure
 from cinder.volume.drivers import qnap as cinder_volume_drivers_qnap
 from cinder.volume.drivers import quobyte as cinder_volume_drivers_quobyte
@@ -146,27 +140,19 @@ from cinder.volume.drivers import remote
 from cinder.volume.drivers.san.hp import hpmsa_common as \
     cinder_volume_drivers_san_hp_hpmsacommon
 from cinder.volume.drivers.san import san as cinder_volume_drivers_san_san
-from cinder.volume.drivers import sheepdog as cinder_volume_drivers_sheepdog
 from cinder.volume.drivers import solidfire as cinder_volume_drivers_solidfire
 from cinder.volume.drivers import storpool as cinder_volume_drivers_storpool
 from cinder.volume.drivers.stx import common as \
     cinder_volume_drivers_stx_common
 from cinder.volume.drivers.synology import synology_common as \
     cinder_volume_drivers_synology_synologycommon
-from cinder.volume.drivers.veritas_access import veritas_iscsi as \
-    cinder_volume_drivers_veritas_access_veritasiscsi
 from cinder.volume.drivers.vmware import vmdk as \
     cinder_volume_drivers_vmware_vmdk
-from cinder.volume.drivers import vzstorage as cinder_volume_drivers_vzstorage
 from cinder.volume.drivers.windows import iscsi as \
     cinder_volume_drivers_windows_iscsi
 from cinder.volume.drivers.windows import smbfs as \
     cinder_volume_drivers_windows_smbfs
 from cinder.volume.drivers import zadara as cinder_volume_drivers_zadara
-from cinder.volume.drivers.zfssa import zfssaiscsi as \
-    cinder_volume_drivers_zfssa_zfssaiscsi
-from cinder.volume.drivers.zfssa import zfssanfs as \
-    cinder_volume_drivers_zfssa_zfssanfs
 from cinder.volume import manager as cinder_volume_manager
 from cinder.volume.targets import spdknvmf as cinder_volume_targets_spdknvmf
 from cinder.wsgi import eventlet_server as cinder_wsgi_eventletserver
@@ -258,6 +244,7 @@ def list_opts():
                 cinder_volume_driver.scst_opts,
                 cinder_volume_driver.backup_opts,
                 cinder_volume_driver.image_opts,
+                cinder_volume_drivers_datera_dateraiscsi.d_opts,
                 cinder_volume_drivers_fusionstorage_dsware.volume_opts,
                 cinder_volume_drivers_infortrend_raidcmd_cli_commoncli.
                 infortrend_opts,
@@ -267,8 +254,6 @@ def list_opts():
                 instorage_mcs_opts,
                 cinder_volume_drivers_inspur_instorage_instorageiscsi.
                 instorage_mcs_iscsi_opts,
-                cinder_volume_drivers_storpool.storpool_opts,
-                cinder_volume_drivers_veritas_access_veritasiscsi.VA_VOL_OPTS,
                 cinder_volume_manager.volume_manager_opts,
                 cinder_wsgi_eventletserver.socket_opts,
             )),
@@ -295,9 +280,7 @@ def list_opts():
                 cinder_volume_driver.nvmet_opts,
                 cinder_volume_driver.scst_opts,
                 cinder_volume_driver.image_opts,
-                cinder_volume_drivers_datera_dateraiscsi.d_opts,
                 cinder_volume_drivers_dell_emc_powermax_common.powermax_opts,
-                cinder_volume_drivers_dell_emc_ps.eqlx_opts,
                 cinder_volume_drivers_dell_emc_sc_storagecentercommon.
                 common_opts,
                 cinder_volume_drivers_dell_emc_unity_driver.UNITY_OPTS,
@@ -348,8 +331,6 @@ def list_opts():
                 cinder_volume_drivers_nexenta_options.NEXENTA_RRMGR_OPTS,
                 cinder_volume_drivers_nexenta_options.NEXENTA_EDGE_OPTS,
                 cinder_volume_drivers_nfs.nfs_opts,
-                cinder_volume_drivers_nimble.nimble_opts,
-                cinder_volume_drivers_prophetstor_options.DPL_OPTS,
                 cinder_volume_drivers_pure.PURE_OPTS,
                 cinder_volume_drivers_qnap.qnap_opts,
                 cinder_volume_drivers_quobyte.volume_opts,
@@ -359,18 +340,15 @@ def list_opts():
                 cinder_volume_drivers_san_hp_hpmsacommon.common_opts,
                 cinder_volume_drivers_san_hp_hpmsacommon.iscsi_opts,
                 cinder_volume_drivers_san_san.san_opts,
-                cinder_volume_drivers_sheepdog.sheepdog_opts,
                 cinder_volume_drivers_solidfire.sf_opts,
+                cinder_volume_drivers_storpool.storpool_opts,
                 cinder_volume_drivers_stx_common.common_opts,
                 cinder_volume_drivers_stx_common.iscsi_opts,
                 cinder_volume_drivers_synology_synologycommon.cinder_opts,
                 cinder_volume_drivers_vmware_vmdk.vmdk_opts,
-                cinder_volume_drivers_vzstorage.vzstorage_opts,
                 cinder_volume_drivers_windows_iscsi.windows_opts,
                 cinder_volume_drivers_windows_smbfs.volume_opts,
                 cinder_volume_drivers_zadara.zadara_opts,
-                cinder_volume_drivers_zfssa_zfssaiscsi.ZFSSA_OPTS,
-                cinder_volume_drivers_zfssa_zfssanfs.ZFSSA_OPTS,
                 cinder_volume_manager.volume_backend_opts,
                 cinder_volume_targets_spdknvmf.spdk_opts,
             )),
diff -pruN 2:15.0.1-1/cinder/privsep/hscli.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/privsep/hscli.py
--- 2:15.0.1-1/cinder/privsep/hscli.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/privsep/hscli.py	2020-03-24 18:46:31.000000000 +0000
@@ -37,9 +37,8 @@ def hsexecute(cmdarg_json):
         (cmd_out, cmd_err) = putils.execute("hscli", cmdarg_json)
     except (putils.UnknownArgumentError, putils.ProcessExecutionError,
             OSError):
-        LOG.error("Exception in running the command for %s",
-                  cmdarg_json,
-                  exc_info=True)
+        LOG.exception("Exception in running the command for %s",
+                      cmdarg_json)
         raise exception.UnableToExecuteHyperScaleCmd(command=cmdarg_json)
 
     return (cmd_out, cmd_err)
diff -pruN 2:15.0.1-1/cinder/quota_utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/quota_utils.py
--- 2:15.0.1-1/cinder/quota_utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/quota_utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,13 +12,12 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-from oslo_config import cfg
-from oslo_log import log as logging
-
 from keystoneauth1 import identity
 from keystoneauth1 import loading as ka_loading
 from keystoneclient import client
 from keystoneclient import exceptions
+from oslo_config import cfg
+from oslo_log import log as logging
 
 from cinder import db
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/scheduler/driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/scheduler/driver.py
--- 2:15.0.1-1/cinder/scheduler/driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/scheduler/driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -154,3 +154,8 @@ class Scheduler(object):
         """Must override schedule method for scheduler to work."""
         raise NotImplementedError(_(
             "Must implement schedule_get_pools"))
+
+    def get_backup_host(self, volume, driver=None):
+        """Must override schedule method for scheduler to work."""
+        raise NotImplementedError(_(
+            "Must implement get_backup_host"))
diff -pruN 2:15.0.1-1/cinder/scheduler/evaluator/evaluator.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/scheduler/evaluator/evaluator.py
--- 2:15.0.1-1/cinder/scheduler/evaluator/evaluator.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/scheduler/evaluator/evaluator.py	2020-03-24 18:46:31.000000000 +0000
@@ -45,21 +45,21 @@ class EvalConstant(object):
             (which_dict, entry) = result.split('.')
             try:
                 result = _vars[which_dict][entry]
-            except KeyError as e:
+            except KeyError:
                 raise exception.EvaluatorParseException(
-                    _("KeyError: %s") % e)
-            except TypeError as e:
+                    _("KeyError evaluating string"))
+            except TypeError:
                 raise exception.EvaluatorParseException(
-                    _("TypeError: %s") % e)
+                    _("TypeError evaluating string"))
 
         try:
             result = int(result)
         except ValueError:
             try:
                 result = float(result)
-            except ValueError as e:
-                raise exception.EvaluatorParseException(
-                    _("ValueError: %s") % e)
+            except ValueError:
+                if isinstance(result, str):
+                    result = result.replace('"', '').replace('\'', '')
 
         return result
 
@@ -232,8 +232,9 @@ def _def_parser():
 
     alphas = pyparsing.alphas
     Combine = pyparsing.Combine
-    Forward = pyparsing.Forward
     nums = pyparsing.nums
+    quoted_string = pyparsing.quotedString
+
     oneOf = pyparsing.oneOf
     opAssoc = pyparsing.opAssoc
     operatorPrecedence = pyparsing.operatorPrecedence
@@ -243,9 +244,8 @@ def _def_parser():
     real = Combine(Word(nums) + '.' + Word(nums))
     variable = Word(alphas + '_' + '.')
     number = real | integer
-    expr = Forward()
     fn = Word(alphas + '_' + '.')
-    operand = number | variable | fn
+    operand = number | variable | fn | quoted_string
 
     signop = oneOf('+ -')
     addop = oneOf('+ -')
diff -pruN 2:15.0.1-1/cinder/scheduler/filter_scheduler.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/scheduler/filter_scheduler.py
--- 2:15.0.1-1/cinder/scheduler/filter_scheduler.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/scheduler/filter_scheduler.py	2020-03-24 18:46:31.000000000 +0000
@@ -287,7 +287,12 @@ class FilterScheduler(driver.Scheduler):
         # takes 'resource_XX' and 'volume_XX' as input respectively, copying
         # 'volume_XX' to 'resource_XX' will make both filters happy.
         volume_type = request_spec.get("volume_type")
-        resource_type = volume_type if volume_type is not None else {}
+        # When creating snapshots, the value of volume_type is None here
+        # which causes issues in filters (Eg: Bug #1856126).
+        # To prevent that, we set it as an empty dictionary here.
+        if volume_type is None:
+            volume_type = {}
+        resource_type = volume_type
 
         config_options = self._get_configuration_options()
 
@@ -571,3 +576,6 @@ class FilterScheduler(driver.Scheduler):
         backend_state = top_backend.obj
         LOG.debug("Choosing %s", backend_state.backend_id)
         return top_backend
+
+    def get_backup_host(self, volume, driver=None):
+        return self.host_manager.get_backup_host(volume, driver)
diff -pruN 2:15.0.1-1/cinder/scheduler/host_manager.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/scheduler/host_manager.py
--- 2:15.0.1-1/cinder/scheduler/host_manager.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/scheduler/host_manager.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,12 +15,8 @@
 
 """Manage backends in the current zone."""
 
-# TODO(smcginnis) update this once six has support for collections.abc
-# (https://github.com/benjaminp/six/pull/241) or clean up once we drop py2.7.
-try:
-    from collections.abc import Mapping
-except ImportError:
-    from collections import Mapping
+import collections
+import random
 
 from oslo_config import cfg
 from oslo_log import log as logging
@@ -71,7 +67,7 @@ CONF.import_opt('max_over_subscription_r
 LOG = logging.getLogger(__name__)
 
 
-class ReadOnlyDict(Mapping):
+class ReadOnlyDict(collections.Mapping):
     """A read-only dict."""
     def __init__(self, source=None):
         if source is not None:
@@ -400,6 +396,8 @@ class HostManager(object):
 
     backend_state_cls = BackendState
 
+    ALLOWED_SERVICE_NAMES = ('volume', 'backup')
+
     REQUIRED_KEYS = frozenset([
         'pool_name',
         'total_capacity_gb',
@@ -414,6 +412,7 @@ class HostManager(object):
     def __init__(self):
         self.service_states = {}  # { <host|cluster>: {<service>: {cap k : v}}}
         self.backend_state_map = {}
+        self.backup_service_states = {}
         self.filter_handler = filters.BackendFilterHandler('cinder.scheduler.'
                                                            'filters')
         self.filter_classes = self.filter_handler.get_all_classes()
@@ -506,7 +505,7 @@ class HostManager(object):
     def update_service_capabilities(self, service_name, host, capabilities,
                                     cluster_name, timestamp):
         """Update the per-service capabilities based on this notification."""
-        if service_name != 'volume':
+        if service_name not in HostManager.ALLOWED_SERVICE_NAMES:
             LOG.debug('Ignoring %(service_name)s service update '
                       'from %(host)s',
                       {'service_name': service_name, 'host': host})
@@ -525,6 +524,15 @@ class HostManager(object):
 
         # Set the default capabilities in case None is set.
         backend = cluster_name or host
+
+        if service_name == 'backup':
+            self.backup_service_states[backend] = capabilities
+            LOG.debug("Received %(service_name)s service update from "
+                      "%(host)s: %(cap)s",
+                      {'service_name': service_name, 'host': host,
+                       'cap': capabilities})
+            return
+
         capab_old = self.service_states.get(backend, {"timestamp": 0})
         capab_last_update = self.service_states_last_update.get(
             backend, {"timestamp": 0})
@@ -889,3 +897,74 @@ class HostManager(object):
         # If the capability and value are not in the same type,
         # we just convert them into string to compare them.
         return str(value) == str(capability)
+
+    def get_backup_host(self, volume, driver=None):
+        if volume:
+            volume_host = volume_utils.extract_host(volume.host, 'host')
+        else:
+            volume_host = None
+        az = volume.availability_zone if volume else None
+        return self._get_available_backup_service_host(volume_host, az, driver)
+
+    def _get_any_available_backup_service(self, availability_zone,
+                                          driver=None):
+        """Get an available backup service host.
+
+        Get an available backup service host in the specified
+        availability zone.
+        """
+        services = [srv for srv in self._list_backup_services(
+            availability_zone, driver)]
+        random.shuffle(services)
+        return services[0] if services else None
+
+    def _get_available_backup_service_host(self, host, az, driver=None):
+        """Return an appropriate backup service host."""
+        backup_host = None
+        if not host or not CONF.backup_use_same_host:
+            backup_host = self._get_any_available_backup_service(az, driver)
+        elif self._is_backup_service_enabled(az, host):
+            backup_host = host
+        if not backup_host:
+            raise exception.ServiceNotFound(service_id='cinder-backup')
+        return backup_host
+
+    def _list_backup_services(self, availability_zone, driver=None):
+        """List all enabled backup services.
+
+        :returns: list -- hosts for services that are enabled for backup.
+        """
+        services = []
+
+        def _is_good_service(cap, driver, az):
+            if driver is None and az is None:
+                return True
+            match_driver = cap['driver_name'] == driver if driver else True
+            if match_driver:
+                if not az:
+                    return True
+                return cap['availability_zone'] == az
+            return False
+
+        for backend, capabilities in self.backup_service_states.items():
+            if capabilities['backend_state']:
+                if _is_good_service(capabilities, driver, availability_zone):
+                    services.append(backend)
+
+        return services
+
+    def _az_matched(self, service, availability_zone):
+        return ((not availability_zone) or
+                service.availability_zone == availability_zone)
+
+    def _is_backup_service_enabled(self, availability_zone, host):
+        """Check if there is a backup service available."""
+        topic = constants.BACKUP_TOPIC
+        ctxt = cinder_context.get_admin_context()
+        services = objects.ServiceList.get_all_by_topic(
+            ctxt, topic, disabled=False)
+        for srv in services:
+            if (self._az_matched(srv, availability_zone) and
+                    srv.host == host and srv.is_up):
+                return True
+        return False
diff -pruN 2:15.0.1-1/cinder/scheduler/manager.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/scheduler/manager.py
--- 2:15.0.1-1/cinder/scheduler/manager.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/scheduler/manager.py	2020-03-24 18:46:31.000000000 +0000
@@ -33,6 +33,7 @@ from oslo_utils import timeutils
 from oslo_utils import versionutils
 import six
 
+from cinder.backup import rpcapi as backup_rpcapi
 from cinder import context
 from cinder import db
 from cinder import exception
@@ -48,6 +49,7 @@ from cinder import rpc
 from cinder.scheduler.flows import create_volume
 from cinder.scheduler import rpcapi as scheduler_rpcapi
 from cinder.volume import rpcapi as volume_rpcapi
+from cinder.volume import volume_utils as vol_utils
 
 
 scheduler_manager_opts = [
@@ -101,6 +103,7 @@ class SchedulerManager(manager.Cleanable
         self.driver = importutils.import_object(scheduler_driver)
         super(SchedulerManager, self).__init__(*args, **kwargs)
         self._startup_delay = True
+        self.backup_api = backup_rpcapi.BackupAPI()
         self.volume_api = volume_rpcapi.VolumeAPI()
         self.sch_api = scheduler_rpcapi.SchedulerAPI()
         self.message_api = mess_api.API()
@@ -261,6 +264,15 @@ class SchedulerManager(manager.Cleanable
 
     def request_service_capabilities(self, context):
         volume_rpcapi.VolumeAPI().publish_service_capabilities(context)
+        try:
+            self.backup_api.publish_service_capabilities(context)
+        except exception.ServiceTooOld as e:
+            # cinder-backup has publish_service_capabilities starting Stein
+            # release only.
+            msg = ("Failed to notify about cinder-backup service "
+                   "capabilities for host %(host)s. This is normal "
+                   "during a live upgrade. Error: %(e)s")
+            LOG.warning(msg, {'host': self.host, 'e': e})
 
     @append_operation_type()
     def migrate_volume(self, context, volume, backend, force_copy,
@@ -615,3 +627,15 @@ class SchedulerManager(manager.Cleanable
 
         LOG.info('Cleanup requests completed.')
         return requested, not_requested
+
+    def create_backup(self, context, backup):
+        volume = self.db.volume_get(context, backup.volume_id)
+        try:
+            host = self.driver.get_backup_host(volume)
+            backup.host = host
+            backup.save()
+            self.backup_api.create_backup(context, backup)
+        except exception.ServiceNotFound:
+            msg = "Service not found for creating backup."
+            LOG.error(msg)
+            vol_utils.update_backup_error(backup, msg)
diff -pruN 2:15.0.1-1/cinder/scheduler/rpcapi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/scheduler/rpcapi.py
--- 2:15.0.1-1/cinder/scheduler/rpcapi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/scheduler/rpcapi.py	2020-03-24 18:46:31.000000000 +0000
@@ -72,9 +72,10 @@ class SchedulerAPI(rpc.RPCAPI):
         3.9 - Adds create_snapshot method
         3.10 - Adds backup_id to create_volume method.
         3.11 - Adds manage_existing_snapshot method.
+        3.12 - Adds create_backup method.
     """
 
-    RPC_API_VERSION = '3.11'
+    RPC_API_VERSION = '3.12'
     RPC_DEFAULT_VERSION = '3.0'
     TOPIC = constants.SCHEDULER_TOPIC
     BINARY = 'cinder-scheduler'
@@ -260,3 +261,9 @@ class SchedulerAPI(rpc.RPCAPI):
     def get_log_levels(self, context, service, log_request):
         cctxt = self._get_cctxt(server=service.host, version='3.7')
         return cctxt.call(context, 'get_log_levels', log_request=log_request)
+
+    @rpc.assert_min_rpc_version('3.12')
+    def create_backup(self, ctxt, backup):
+        cctxt = self._get_cctxt()
+        msg_args = {'backup': backup}
+        return cctxt.cast(ctxt, 'create_backup', **msg_args)
diff -pruN 2:15.0.1-1/cinder/service.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/service.py
--- 2:15.0.1-1/cinder/service.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/service.py	2020-03-24 18:46:31.000000000 +0000
@@ -602,7 +602,8 @@ def serve(server, workers=None):
     if _launcher:
         raise RuntimeError(_('serve() can only be called once'))
 
-    _launcher = service.launch(CONF, server, workers=workers)
+    _launcher = service.launch(CONF, server, workers=workers,
+                               restart_method='mutate')
 
 
 def wait():
diff -pruN 2:15.0.1-1/cinder/test.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/test.py
--- 2:15.0.1-1/cinder/test.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/test.py	2020-03-24 18:46:31.000000000 +0000
@@ -24,12 +24,12 @@ import copy
 import logging
 import os
 import sys
+from unittest import mock
 import uuid
 
 from eventlet import tpool
 import fixtures
 from keystonemiddleware import auth_token
-import mock
 from oslo_concurrency import lockutils
 from oslo_config import fixture as config_fixture
 from oslo_log.fixture import logging_error as log_fixture
@@ -58,7 +58,6 @@ from cinder.tests.unit import fake_notif
 from cinder.volume import volume_types
 from cinder.volume import volume_utils
 
-
 CONF = config.CONF
 
 _DB_CACHE = None
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/limits/limits-show-response.json.tpl 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/limits/limits-show-response.json.tpl
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/limits/limits-show-response.json.tpl	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/limits/limits-show-response.json.tpl	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,17 @@
+{
+    "limits": {
+        "rate": [],
+        "absolute": {
+            "totalSnapshotsUsed": 0,
+            "maxTotalBackups": 10,
+            "maxTotalVolumeGigabytes": 1000,
+            "maxTotalSnapshots": 10,
+            "maxTotalBackupGigabytes": 1000,
+            "totalBackupGigabytesUsed": 0,
+            "maxTotalVolumes": 10,
+            "totalVolumesUsed": 0,
+            "totalBackupsUsed": 0,
+            "totalGigabytesUsed": 0
+        }
+    }
+}
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/qos/qos-create-request.json.tpl 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/qos/qos-create-request.json.tpl
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/qos/qos-create-request.json.tpl	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/qos/qos-create-request.json.tpl	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,5 @@
+{
+    "qos_specs": {
+        "name": "reliability-spec"
+    }
+}
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/qos/qos-create-response.json.tpl 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/qos/qos-create-response.json.tpl
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/qos/qos-create-response.json.tpl	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/qos/qos-create-response.json.tpl	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,18 @@
+{
+    "links": [
+        {
+            "href": "%(host)s/v3/89afd400-b646-4bbc-b12b-c0a4d63e5bd3/qos-specs/%(uuid)s",
+            "rel": "self"
+        },
+        {
+            "href": "%(host)s/89afd400-b646-4bbc-b12b-c0a4d63e5bd3/qos-specs/%(uuid)s",
+            "rel": "bookmark"
+        }
+    ],
+    "qos_specs": {
+        "consumer": "back-end",
+        "id": "%(uuid)s",
+        "name": "reliability-spec",
+        "specs": {}
+    }
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/qos/qos-list-response.json.tpl 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/qos/qos-list-response.json.tpl
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/qos/qos-list-response.json.tpl	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/qos/qos-list-response.json.tpl	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,10 @@
+{
+    "qos_specs": [
+        {
+            "consumer": "back-end",
+            "id": "%(uuid)s",
+            "name": "reliability-spec",
+            "specs": {}
+        }
+    ]
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/qos/qos_show_response.json.tpl 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/qos/qos_show_response.json.tpl
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/qos/qos_show_response.json.tpl	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/qos/qos_show_response.json.tpl	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,3 @@
+{
+    "qos_associations": []
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/qos/qos-show-response.json.tpl 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/qos/qos-show-response.json.tpl
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/qos/qos-show-response.json.tpl	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/qos/qos-show-response.json.tpl	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,18 @@
+{
+    "links": [
+        {
+            "href": "%(host)s/v3/89afd400-b646-4bbc-b12b-c0a4d63e5bd3/qos-specs/%(uuid)s",
+            "rel": "self"
+        },
+        {
+            "href": "%(host)s/89afd400-b646-4bbc-b12b-c0a4d63e5bd3/qos-specs/%(uuid)s",
+            "rel": "bookmark"
+        }
+    ],
+    "qos_specs": {
+        "consumer": "back-end",
+        "id": "%(uuid)s",
+        "name": "reliability-spec",
+        "specs": {}
+    }
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/qos/qos-update-request.json.tpl 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/qos/qos-update-request.json.tpl
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/qos/qos-update-request.json.tpl	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/qos/qos-update-request.json.tpl	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,5 @@
+{
+    "qos_specs": {
+        "delay": "1"
+    }
+}
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/qos/qos-update-response.json.tpl 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/qos/qos-update-response.json.tpl
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/qos/qos-update-response.json.tpl	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/qos/qos-update-response.json.tpl	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,5 @@
+{
+    "qos_specs": {
+        "delay": "1"
+    }
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/quota_classes/quota-classes-show-response.json.tpl 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/quota_classes/quota-classes-show-response.json.tpl
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/quota_classes/quota-classes-show-response.json.tpl	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/quota_classes/quota-classes-show-response.json.tpl	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,15 @@
+{
+    "quota_class_set": {
+        "backup_gigabytes": 1000,
+        "backups": 10,
+        "gigabytes": 1000,
+        "gigabytes___DEFAULT__": -1,
+        "groups": 10,
+        "id": "test_class",
+        "per_volume_gigabytes": -1,
+        "snapshots": 10,
+        "snapshots___DEFAULT__": -1,
+        "volumes": 10,
+        "volumes___DEFAULT__": -1
+    }
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/quota_classes/quota-classes-update-request.json.tpl 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/quota_classes/quota-classes-update-request.json.tpl
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/quota_classes/quota-classes-update-request.json.tpl	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/quota_classes/quota-classes-update-request.json.tpl	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,7 @@
+{
+    "quota_class_set": {
+        "volumes": 10,
+        "gigabytes": 1000,
+        "snapshots": 10
+    }
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/quota_classes/quota-classes-update-response.json.tpl 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/quota_classes/quota-classes-update-response.json.tpl
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/quota_classes/quota-classes-update-response.json.tpl	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/quota_classes/quota-classes-update-response.json.tpl	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,14 @@
+{
+    "quota_class_set": {
+        "backup_gigabytes": 1000,
+        "backups": 10,
+        "gigabytes": 1000,
+        "gigabytes___DEFAULT__": -1,
+        "groups": 10,
+        "per_volume_gigabytes": -1,
+        "snapshots": 10,
+        "snapshots___DEFAULT__": -1,
+        "volumes": 10,
+        "volumes___DEFAULT__": -1
+    }
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-show-defaults-response.json.tpl 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-show-defaults-response.json.tpl
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-show-defaults-response.json.tpl	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-show-defaults-response.json.tpl	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,15 @@
+{
+    "quota_set": {
+        "backup_gigabytes": 1000,
+        "backups": 10,
+        "gigabytes": 1000,
+        "gigabytes___DEFAULT__": -1,
+        "groups": 10,
+        "id": "fake_tenant",
+        "per_volume_gigabytes": -1,
+        "snapshots": 10,
+        "snapshots___DEFAULT__": -1,
+        "volumes": 10,
+        "volumes___DEFAULT__": -1
+    }
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-show-response.json.tpl 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-show-response.json.tpl
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-show-response.json.tpl	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-show-response.json.tpl	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,15 @@
+{
+    "quota_set": {
+        "backup_gigabytes": 1000,
+        "backups": 10,
+        "gigabytes": 1000,
+        "gigabytes___DEFAULT__": -1,
+        "groups": 10,
+        "id": "fake_tenant",
+        "per_volume_gigabytes": -1,
+        "snapshots": 10,
+        "snapshots___DEFAULT__": -1,
+        "volumes": 10,
+        "volumes___DEFAULT__": -1
+    }
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-show-usage-response.json.tpl 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-show-usage-response.json.tpl
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-show-usage-response.json.tpl	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-show-usage-response.json.tpl	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,55 @@
+{
+    "quota_set": {
+        "backup_gigabytes": {
+            "in_use": 0,
+            "limit": 1000,
+            "reserved": 0
+        },
+        "backups": {
+            "in_use": 0,
+            "limit": 10,
+            "reserved": 0
+        },
+        "gigabytes": {
+            "in_use": 0,
+            "limit": 1000,
+            "reserved": 0
+        },
+        "gigabytes___DEFAULT__": {
+            "in_use": 0,
+            "limit": -1,
+            "reserved": 0
+        },
+        "groups": {
+            "in_use": 0,
+            "limit": 10,
+            "reserved": 0
+        },
+        "id": "fake_tenant",
+        "per_volume_gigabytes": {
+            "in_use": 0,
+            "limit": -1,
+            "reserved": 0
+        },
+        "snapshots": {
+            "in_use": 0,
+            "limit": 10,
+            "reserved": 0
+        },
+        "snapshots___DEFAULT__": {
+            "in_use": 0,
+            "limit": -1,
+            "reserved": 0
+        },
+        "volumes": {
+            "in_use": 0,
+            "limit": 10,
+            "reserved": 0
+        },
+        "volumes___DEFAULT__": {
+            "in_use": 0,
+            "limit": -1,
+            "reserved": 0
+        }
+    }
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-update-request.json.tpl 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-update-request.json.tpl
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-update-request.json.tpl	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-update-request.json.tpl	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,7 @@
+{
+    "quota_set":{
+        "groups": 11,
+        "volumes": 5,
+        "backups": 4
+    }
+}
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-update-response.json.tpl 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-update-response.json.tpl
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-update-response.json.tpl	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-update-response.json.tpl	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,14 @@
+{
+    "quota_set": {
+        "backup_gigabytes": 1000,
+        "backups": 4,
+        "gigabytes": 1000,
+        "gigabytes___DEFAULT__": -1,
+        "groups": 11,
+        "per_volume_gigabytes": -1,
+        "snapshots": 10,
+        "snapshots___DEFAULT__": -1,
+        "volumes": 5,
+        "volumes___DEFAULT__": -1
+    }
+}
\ No newline at end of file
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/test_limits.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/test_limits.py
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/test_limits.py	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/test_limits.py	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,24 @@
+#    Licensed under the Apache License, Version 2.0 (the "License"); you may
+#    not use this file except in compliance with the License. You may obtain
+#    a copy of the License at
+#
+#         http://www.apache.org/licenses/LICENSE-2.0
+#
+#    Unless required by applicable law or agreed to in writing, software
+#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+#    License for the specific language governing permissions and limitations
+#    under the License.
+
+from cinder.tests.functional.api_sample_tests import test_volumes
+
+
+class LimitsSampleJsonTest(test_volumes.VolumesSampleBase):
+    sample_dir = "limits"
+
+    def setUp(self):
+        super(LimitsSampleJsonTest, self).setUp()
+
+    def test_limits_get(self):
+        response = self._do_get('limits')
+        self._verify_response('limits-show-response', {}, response, 200)
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/test_qos.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/test_qos.py
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/test_qos.py	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/test_qos.py	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,46 @@
+#    Licensed under the Apache License, Version 2.0 (the "License"); you may
+#    not use this file except in compliance with the License. You may obtain
+#    a copy of the License at
+#
+#         http://www.apache.org/licenses/LICENSE-2.0
+#
+#    Unless required by applicable law or agreed to in writing, software
+#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+#    License for the specific language governing permissions and limitations
+#    under the License.
+
+from oslo_serialization import jsonutils
+
+from cinder.tests.functional.api_sample_tests import test_volumes
+
+
+class QOSSampleJsonTest(test_volumes.VolumesSampleBase):
+    sample_dir = "qos"
+
+    def setUp(self):
+        super(QOSSampleJsonTest, self).setUp()
+        self.response = self._do_post('qos-specs', 'qos-create-request')
+
+    def test_qos_create(self):
+        self._verify_response('qos-create-response', {}, self.response, 200)
+
+    def test_qos_list(self):
+        response = self._do_get('qos-specs')
+        self._verify_response('qos-list-response', {}, response, 200)
+
+    def test_qos_show(self):
+        res = jsonutils.loads(self.response.content)['qos_specs']
+        response = self._do_get('qos-specs/%s' % res['id'])
+        self._verify_response('qos-show-response', {}, response, 200)
+
+    def test_qos_update(self):
+        res = jsonutils.loads(self.response.content)['qos_specs']
+        response = self._do_put('qos-specs/%s' % res['id'],
+                                'qos-update-request')
+        self._verify_response('qos-update-response', {}, response, 200)
+
+    def test_qos_show_associations(self):
+        res = jsonutils.loads(self.response.content)['qos_specs']
+        response = self._do_get('qos-specs/%s/associations' % res['id'])
+        self._verify_response('qos_show_response', {}, response, 200)
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/test_quota_classes.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/test_quota_classes.py
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/test_quota_classes.py	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/test_quota_classes.py	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,31 @@
+#    Licensed under the Apache License, Version 2.0 (the "License"); you may
+#    not use this file except in compliance with the License. You may obtain
+#    a copy of the License at
+#
+#         http://www.apache.org/licenses/LICENSE-2.0
+#
+#    Unless required by applicable law or agreed to in writing, software
+#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+#    License for the specific language governing permissions and limitations
+#    under the License.
+
+from cinder.tests.functional.api_sample_tests import test_volumes
+
+
+class QuotaClassesSampleJsonTest(test_volumes.VolumesSampleBase):
+    sample_dir = "quota_classes"
+
+    def setUp(self):
+        super(QuotaClassesSampleJsonTest, self).setUp()
+
+    def test_quota_classes_show(self):
+        response = self._do_get('os-quota-class-sets/test_class')
+        self._verify_response('quota-classes-show-response', {},
+                              response, 200)
+
+    def test_quotas_update(self):
+        response = self._do_put('os-quota-class-sets/test_class',
+                                'quota-classes-update-request')
+        self._verify_response('quota-classes-update-response', {},
+                              response, 200)
diff -pruN 2:15.0.1-1/cinder/tests/functional/api_sample_tests/test_quota_sets.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/test_quota_sets.py
--- 2:15.0.1-1/cinder/tests/functional/api_sample_tests/test_quota_sets.py	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/api_sample_tests/test_quota_sets.py	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,38 @@
+#    Licensed under the Apache License, Version 2.0 (the "License"); you may
+#    not use this file except in compliance with the License. You may obtain
+#    a copy of the License at
+#
+#         http://www.apache.org/licenses/LICENSE-2.0
+#
+#    Unless required by applicable law or agreed to in writing, software
+#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+#    License for the specific language governing permissions and limitations
+#    under the License.
+
+from cinder.tests.functional.api_sample_tests import test_volumes
+
+
+class QuotaSetsSampleJsonTest(test_volumes.VolumesSampleBase):
+    sample_dir = "quota_sets"
+
+    def setUp(self):
+        super(QuotaSetsSampleJsonTest, self).setUp()
+
+    def test_quotas_show(self):
+        response = self._do_get('os-quota-sets/fake_tenant')
+        self._verify_response('quotas-show-response', {}, response, 200)
+
+    def test_quotas_show_usage(self):
+        response = self._do_get('os-quota-sets/fake_tenant?usage=True')
+        self._verify_response('quotas-show-usage-response', {}, response, 200)
+
+    def test_quotas_update(self):
+        response = self._do_put('os-quota-sets/fake_tenant',
+                                'quotas-update-request')
+        self._verify_response('quotas-update-response', {}, response, 200)
+
+    def test_quotas_defaults(self):
+        response = self._do_get('os-quota-sets/fake_tenant/defaults')
+        self._verify_response('quotas-show-defaults-response',
+                              {}, response, 200)
diff -pruN 2:15.0.1-1/cinder/tests/functional/functional_helpers.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/functional_helpers.py
--- 2:15.0.1-1/cinder/tests/functional/functional_helpers.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/functional_helpers.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,17 +13,15 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Provides common functionality for functional tests
-"""
+"""Provides common functionality for functional tests."""
 import os.path
 import random
 import string
 import time
+from unittest import mock
 import uuid
 
 import fixtures
-import mock
 from oslo_config import cfg
 
 from cinder import service
diff -pruN 2:15.0.1-1/cinder/tests/functional/test_quotas.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/test_quotas.py
--- 2:15.0.1-1/cinder/tests/functional/test_quotas.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/functional/test_quotas.py	2020-03-24 18:46:31.000000000 +0000
@@ -11,7 +11,7 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-import mock
+from unittest import mock
 import uuid
 
 from cinder import quota
diff -pruN 2:15.0.1-1/cinder/tests/hacking/checks.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/hacking/checks.py
--- 2:15.0.1-1/cinder/tests/hacking/checks.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/hacking/checks.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,6 +14,7 @@
 
 import ast
 import re
+
 import six
 
 """
@@ -45,16 +46,9 @@ underscore_import_check = re.compile(r"(
 underscore_import_check_multi = re.compile(r"(.)*i18n\s+import(.)* _, (.)*")
 # We need this for cases where they have created their own _ function.
 custom_underscore_check = re.compile(r"(.)*_\s*=\s*(.)*")
-no_audit_log = re.compile(r"(.)*LOG\.audit(.)*")
 no_print_statements = re.compile(r"\s*print\s*\(.+\).*")
 dict_constructor_with_list_copy_re = re.compile(r".*\bdict\((\[)?(\(|\[)")
 
-# NOTE(jsbryant): When other oslo libraries switch over non-namespaced
-# imports, we will need to add them to the regex below.
-oslo_namespace_imports = re.compile(r"from[\s]*oslo[.](concurrency|db"
-                                    "|config|utils|serialization|log)")
-no_contextlib_nested = re.compile(r"\s*with (contextlib\.)?nested\(")
-
 logging_instance = re.compile(
     r"(.)*LOG\.(warning|info|debug|error|exception)\(")
 
@@ -166,53 +160,6 @@ def check_explicit_underscore_import(log
         yield(0, "N323: Found use of _() without explicit import of _ !")
 
 
-class CheckForStrUnicodeExc(BaseASTChecker):
-    """Checks for the use of str() or unicode() on an exception.
-
-    This currently only handles the case where str() or unicode()
-    is used in the scope of an exception handler.  If the exception
-    is passed into a function, returned from an assertRaises, or
-    used on an exception created in the same scope, this does not
-    catch it.
-    """
-
-    CHECK_DESC = ('N325 str() and unicode() cannot be used on an '
-                  'exception.  Remove or use six.text_type()')
-
-    def __init__(self, tree, filename):
-        super(CheckForStrUnicodeExc, self).__init__(tree, filename)
-        self.name = []
-        self.already_checked = []
-
-    # Python 2
-    def visit_TryExcept(self, node):
-        for handler in node.handlers:
-            if handler.name:
-                self.name.append(handler.name.id)
-                super(CheckForStrUnicodeExc, self).generic_visit(node)
-                self.name = self.name[:-1]
-            else:
-                super(CheckForStrUnicodeExc, self).generic_visit(node)
-
-    # Python 3
-    def visit_ExceptHandler(self, node):
-        if node.name:
-            self.name.append(node.name)
-            super(CheckForStrUnicodeExc, self).generic_visit(node)
-            self.name = self.name[:-1]
-        else:
-            super(CheckForStrUnicodeExc, self).generic_visit(node)
-
-    def visit_Call(self, node):
-        if self._check_call_names(node, ['str', 'unicode']):
-            if node not in self.already_checked:
-                self.already_checked.append(node)
-                if isinstance(node.args[0], ast.Name):
-                    if node.args[0].id in self.name:
-                        self.add_error(node.args[0])
-        super(CheckForStrUnicodeExc, self).generic_visit(node)
-
-
 class CheckLoggingFormatArgs(BaseASTChecker):
     """Check for improper use of logging format arguments.
 
@@ -395,19 +342,6 @@ def check_no_print_statements(logical_li
         yield(0, msg)
 
 
-def check_no_log_audit(logical_line):
-    """Ensure that we are not using LOG.audit messages
-
-    Plans are in place going forward as discussed in the following
-    spec (https://review.openstack.org/#/c/91446/) to take out
-    LOG.audit messages.  Given that audit was a concept invented
-    for OpenStack we can enforce not using it.
-    """
-
-    if no_audit_log.match(logical_line):
-        yield(0, "C304: Found LOG.audit.  Use LOG.info instead.")
-
-
 def check_timeutils_strtime(logical_line):
     msg = ("C306: Found timeutils.strtime(). "
            "Please use datetime.datetime.isoformat() or datetime.strftime()")
@@ -415,12 +349,6 @@ def check_timeutils_strtime(logical_line
         yield(0, msg)
 
 
-def no_log_warn(logical_line):
-    msg = "C307: LOG.warn is deprecated, please use LOG.warning!"
-    if "LOG.warn(" in logical_line:
-        yield (0, msg)
-
-
 def dict_constructor_with_list_copy(logical_line):
     msg = ("N336: Must use a dict comprehension instead of a dict constructor "
            "with a sequence of key-value pairs.")
@@ -436,19 +364,21 @@ def check_timeutils_isotime(logical_line
 
 
 def no_test_log(logical_line, filename, noqa):
-    if ('cinder/tests/tempest' in filename or
-            'cinder/tests' not in filename or noqa):
+    if ('cinder/tests' not in filename or noqa):
         return
     msg = "C309: Unit tests should not perform logging."
     if logging_instance.match(logical_line):
         yield (0, msg)
 
 
-def validate_assertTrue(logical_line):
+def validate_assertTrue(logical_line, filename):
     # Note: a comparable check cannot be implemented for
     # assertFalse(), because assertFalse(None) passes.
     # Therefore, assertEqual(False, value) is required to
     # have the strongest test.
+    if 'cinder/tests/unit' not in filename:
+        return
+
     if re.match(assert_True, logical_line):
         msg = ("C313: Unit tests should use assertTrue(value) instead"
                " of using assertEqual(True, value).")
@@ -460,7 +390,6 @@ def factory(register):
     register(no_translate_logs)
     register(no_mutable_default_args)
     register(check_explicit_underscore_import)
-    register(CheckForStrUnicodeExc)
     register(CheckLoggingFormatArgs)
     register(CheckOptRegistrationArgs)
     register(check_datetime_now)
@@ -468,8 +397,6 @@ def factory(register):
     register(check_timeutils_isotime)
     register(check_unicode_usage)
     register(check_no_print_statements)
-    register(check_no_log_audit)
-    register(no_log_warn)
     register(dict_constructor_with_list_copy)
     register(no_test_log)
     register(validate_assertTrue)
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_admin_actions.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_admin_actions.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_admin_actions.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_admin_actions.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,9 +10,10 @@
 # License for the specific language governing permissions and limitations
 # under the License.
 
+from unittest import mock
+
 import ddt
 import fixtures
-import mock
 from oslo_concurrency import lockutils
 from oslo_config import fixture as config_fixture
 import oslo_messaging as messaging
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_backup_project_attribute.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_backup_project_attribute.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_backup_project_attribute.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_backup_project_attribute.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,6 @@
 #   under the License.
 
 import ddt
-
 from oslo_serialization import jsonutils
 import webob
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_backups.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_backups.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_backups.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_backups.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,12 +13,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Tests for Backup code.
-"""
+"""Tests for Backup code."""
+
+from unittest import mock
 
 import ddt
-import mock
 from oslo_serialization import jsonutils
 from oslo_utils import timeutils
 import six
@@ -257,6 +256,45 @@ class BackupsAPITestCase(test.TestCase):
         backup2.destroy()
         backup1.destroy()
 
+    def test_list_all_backups_detail_json_over_limit(self):
+        self.override_config('osapi_max_limit', 2)
+        backup1 = utils.create_backup(self.context, availability_zone='az1',
+                                      container='volumebackups', size=1)
+        backup2 = utils.create_backup(self.context, availability_zone='az1',
+                                      container='volumebackups', size=1)
+        backup3 = utils.create_backup(self.context, availability_zone='az1',
+                                      container='volumebackups', size=1)
+
+        req = webob.Request.blank('/v2/%s/backups/detail' % fake.PROJECT_ID)
+        req.method = 'GET'
+        req.headers['Content-Type'] = 'application/json'
+        req.headers['Accept'] = 'application/json'
+        res = req.get_response(fakes.wsgi_app(
+            fake_auth_context=self.user_context))
+        res_dict = jsonutils.loads(res.body)
+
+        self.assertEqual(http_client.OK, res.status_int)
+        self.assertEqual(NUM_ELEMENTS_IN_BACKUP, len(res_dict['backups'][0]))
+        self.assertEqual(NUM_ELEMENTS_IN_BACKUP, len(res_dict['backups'][1]))
+        self.assertEqual(2, len(res_dict['backups']))
+
+        self.assertIn('backups_links', res_dict)
+        links = res_dict['backups_links']
+        next_url = links[0]['href']
+        req = webob.Request.blank(next_url)
+        req.method = 'GET'
+        req.headers['Content-Type'] = 'application/json'
+        req.headers['Accept'] = 'application/json'
+        res = req.get_response(fakes.wsgi_app(
+            fake_auth_context=self.user_context))
+        res_dict = jsonutils.loads(res.body)
+
+        self.assertEqual(NUM_ELEMENTS_IN_BACKUP, len(res_dict['backups'][0]))
+
+        backup3.destroy()
+        backup2.destroy()
+        backup1.destroy()
+
     def test_list_backups_detail_json(self):
         backup1 = utils.create_backup(self.context, availability_zone='az1',
                                       container='volumebackups', size=1)
@@ -483,13 +521,7 @@ class BackupsAPITestCase(test.TestCase):
             fake_auth_context=self.user_context))
         self.assertEqual(http_client.BAD_REQUEST, res.status_int)
 
-    @mock.patch('cinder.db.service_get_all')
-    def test_create_backup_json(self, _mock_service_get_all):
-        _mock_service_get_all.return_value = [
-            {'availability_zone': 'fake_az', 'host': 'testhost',
-             'disabled': 0, 'updated_at': timeutils.utcnow(),
-             'uuid': 'a3a593da-7f8d-4bb7-8b4c-f2bc1e0b4824'}]
-
+    def test_create_backup_json(self):
         volume = utils.create_volume(self.context, size=5)
 
         body = {"backup": {"name": "nightly001",
@@ -510,9 +542,6 @@ class BackupsAPITestCase(test.TestCase):
 
         self.assertEqual(http_client.ACCEPTED, res.status_int)
         self.assertIn('id', res_dict['backup'])
-        _mock_service_get_all.assert_called_once_with(mock.ANY,
-                                                      disabled=False,
-                                                      topic='cinder-backup')
 
         volume.destroy()
 
@@ -623,11 +652,6 @@ class BackupsAPITestCase(test.TestCase):
 
         self.assertEqual(202, res.status_code)
 
-        res_dict = jsonutils.loads(res.body)
-        backup = objects.Backup.get_by_id(self.context,
-                                          res_dict['backup']['id'])
-        self.assertEqual(backup_svc_az, backup.availability_zone)
-
     @mock.patch('cinder.db.service_get_all')
     def test_create_backup_inuse_no_force(self,
                                           _mock_service_get_all):
@@ -661,13 +685,7 @@ class BackupsAPITestCase(test.TestCase):
 
         volume.destroy()
 
-    @mock.patch('cinder.db.service_get_all')
-    def test_create_backup_inuse_force(self, _mock_service_get_all):
-        _mock_service_get_all.return_value = [
-            {'availability_zone': 'fake_az', 'host': 'testhost',
-             'disabled': 0, 'updated_at': timeutils.utcnow(),
-             'uuid': 'a3a593da-7f8d-4bb7-8b4c-f2bc1e0b4824'}]
-
+    def test_create_backup_inuse_force(self):
         volume = utils.create_volume(self.context, size=5, status='in-use')
         backup = utils.create_backup(self.context, volume.id,
                                      status=fields.BackupStatus.AVAILABLE,
@@ -692,20 +710,11 @@ class BackupsAPITestCase(test.TestCase):
 
         self.assertEqual(http_client.ACCEPTED, res.status_int)
         self.assertIn('id', res_dict['backup'])
-        _mock_service_get_all.assert_called_once_with(mock.ANY,
-                                                      disabled=False,
-                                                      topic='cinder-backup')
 
         backup.destroy()
         volume.destroy()
 
-    @mock.patch('cinder.db.service_get_all')
-    def test_create_backup_snapshot_json(self, _mock_service_get_all):
-        _mock_service_get_all.return_value = [
-            {'availability_zone': 'fake_az', 'host': 'testhost',
-             'disabled': 0, 'updated_at': timeutils.utcnow(),
-             'uuid': 'a3a593da-7f8d-4bb7-8b4c-f2bc1e0b4824'}]
-
+    def test_create_backup_snapshot_json(self):
         volume = utils.create_volume(self.context, size=5, status='available')
 
         body = {"backup": {"name": "nightly001",
@@ -725,9 +734,6 @@ class BackupsAPITestCase(test.TestCase):
         res_dict = jsonutils.loads(res.body)
         self.assertEqual(http_client.ACCEPTED, res.status_int)
         self.assertIn('id', res_dict['backup'])
-        _mock_service_get_all.assert_called_once_with(mock.ANY,
-                                                      disabled=False,
-                                                      topic='cinder-backup')
 
         volume.destroy()
 
@@ -830,15 +836,8 @@ class BackupsAPITestCase(test.TestCase):
                           req,
                           body=body)
 
-    @mock.patch('cinder.db.service_get_all')
     @ddt.data(False, True)
-    def test_create_backup_delta(self, backup_from_snapshot,
-                                 _mock_service_get_all):
-        _mock_service_get_all.return_value = [
-            {'availability_zone': 'fake_az', 'host': 'testhost',
-             'disabled': 0, 'updated_at': timeutils.utcnow(),
-             'uuid': 'a3a593da-7f8d-4bb7-8b4c-f2bc1e0b4824'}]
-
+    def test_create_backup_delta(self, backup_from_snapshot):
         volume = utils.create_volume(self.context, size=5)
         snapshot = None
         if backup_from_snapshot:
@@ -880,9 +879,6 @@ class BackupsAPITestCase(test.TestCase):
 
         self.assertEqual(http_client.ACCEPTED, res.status_int)
         self.assertIn('id', res_dict['backup'])
-        _mock_service_get_all.assert_called_once_with(mock.ANY,
-                                                      disabled=False,
-                                                      topic='cinder-backup')
 
         backup.destroy()
         if snapshot:
@@ -1053,14 +1049,7 @@ class BackupsAPITestCase(test.TestCase):
 
         res = req.get_response(fakes.wsgi_app(
             fake_auth_context=self.user_context))
-        res_dict = jsonutils.loads(res.body)
-        self.assertEqual(http_client.SERVICE_UNAVAILABLE, res.status_int)
-        self.assertEqual(http_client.SERVICE_UNAVAILABLE,
-                         res_dict['serviceUnavailable']['code'])
-        self.assertEqual('Service cinder-backup could not be found.',
-                         res_dict['serviceUnavailable']['message'])
-
-        volume.refresh()
+        self.assertEqual(http_client.ACCEPTED, res.status_int)
         self.assertEqual('available', volume.status)
 
     @mock.patch('cinder.db.service_get_all')
@@ -1097,13 +1086,7 @@ class BackupsAPITestCase(test.TestCase):
 
         volume.destroy()
 
-    @mock.patch('cinder.db.service_get_all')
-    def test_create_backup_with_null_validate(self, _mock_service_get_all):
-        _mock_service_get_all.return_value = [
-            {'availability_zone': 'fake_az', 'host': 'testhost',
-             'disabled': 0, 'updated_at': timeutils.utcnow(),
-             'uuid': 'a3a593da-7f8d-4bb7-8b4c-f2bc1e0b4824'}]
-
+    def test_create_backup_with_null_validate(self):
         volume = utils.create_volume(self.context, size=5)
 
         body = {"backup": {"name": None,
@@ -1124,9 +1107,7 @@ class BackupsAPITestCase(test.TestCase):
 
         self.assertEqual(http_client.ACCEPTED, res.status_int)
         self.assertIn('id', res_dict['backup'])
-        _mock_service_get_all.assert_called_once_with(mock.ANY,
-                                                      disabled=False,
-                                                      topic='cinder-backup')
+
         volume.destroy()
 
     @mock.patch('cinder.db.service_get_all')
@@ -1156,9 +1137,6 @@ class BackupsAPITestCase(test.TestCase):
 
         self.assertEqual(http_client.ACCEPTED, res.status_int)
         self.assertIn('id', res_dict['backup'])
-        _mock_service_get_all.assert_called_once_with(mock.ANY,
-                                                      disabled=False,
-                                                      topic='cinder-backup')
         volume.destroy()
 
     @mock.patch('cinder.db.service_get_all')
@@ -1433,6 +1411,7 @@ class BackupsAPITestCase(test.TestCase):
         req = webob.Request.blank('/v2/%s/backups/%s' % (
                                   fake.PROJECT_ID, backup.id))
         req.method = 'DELETE'
+
         req.headers['Content-Type'] = 'application/json'
         res = req.get_response(fakes.wsgi_app(
             fake_auth_context=self.user_context))
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_capabilities.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_capabilities.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_capabilities.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_capabilities.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 import oslo_messaging
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_cgsnapshots.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_cgsnapshots.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_cgsnapshots.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_cgsnapshots.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,11 +13,10 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Tests for cgsnapshot code.
-"""
+"""Tests for cgsnapshot code."""
+
+from unittest import mock
 
-import mock
 from oslo_serialization import jsonutils
 from six.moves import http_client
 import webob
@@ -30,7 +29,6 @@ from cinder import objects
 from cinder import test
 from cinder.tests.unit.api import fakes
 from cinder.tests.unit import fake_constants as fake
-
 from cinder.tests.unit import utils
 import cinder.volume
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_consistencygroups.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_consistencygroups.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_consistencygroups.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_consistencygroups.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,12 +13,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Tests for consistency group code.
-"""
+"""Tests for consistency group code."""
+
+from unittest import mock
 
 import ddt
-import mock
 from oslo_serialization import jsonutils
 from six.moves import http_client
 import webob
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_extended_snapshot_attributes.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_extended_snapshot_attributes.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_extended_snapshot_attributes.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_extended_snapshot_attributes.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
 
-import mock
 from oslo_serialization import jsonutils
 from six.moves import http_client
 import webob
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_hosts.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_hosts.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_hosts.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_hosts.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,7 +14,7 @@
 #    under the License.
 
 import datetime
-import mock
+from unittest import mock
 
 import iso8601
 from oslo_utils import timeutils
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_qos_specs_manage.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_qos_specs_manage.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_qos_specs_manage.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_qos_specs_manage.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,8 +14,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 from six.moves import http_client
 import webob
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_quotas_classes.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_quotas_classes.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_quotas_classes.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_quotas_classes.py	2020-03-24 18:46:31.000000000 +0000
@@ -18,7 +18,7 @@ Tests for cinder.api.contrib.quota_class
 """
 
 
-import mock
+from unittest import mock
 
 from cinder.api.contrib import quota_classes
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_quotas.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_quotas.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_quotas.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_quotas.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,14 +14,14 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Tests for cinder.api.contrib.quotas.py
-"""
+"""Tests for cinder.api.contrib.quotas.py"""
 
+from unittest import mock
+import uuid
 
 import ddt
-import mock
-import uuid
+from oslo_config import cfg
+from oslo_config import fixture as config_fixture
 import webob.exc
 
 from cinder.api.contrib import quotas
@@ -34,10 +34,6 @@ from cinder.tests.unit import fake_const
 from cinder.tests.unit import test_db_api
 
 
-from oslo_config import cfg
-from oslo_config import fixture as config_fixture
-
-
 CONF = cfg.CONF
 
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_scheduler_stats.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_scheduler_stats.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_scheduler_stats.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_scheduler_stats.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,8 +14,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 import webob
 
 from cinder.api.contrib import scheduler_stats
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_services.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_services.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_services.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_services.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,12 +13,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-
 import datetime
+from unittest import mock
 
 import ddt
 import iso8601
-import mock
 from oslo_config import cfg
 from six.moves import http_client
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_snapshot_actions.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_snapshot_actions.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_snapshot_actions.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_snapshot_actions.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,8 +12,9 @@
 #   License for the specific language governing permissions and limitations
 #   under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 from oslo_serialization import jsonutils
 from six.moves import http_client
 import webob
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_snapshot_manage.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_snapshot_manage.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_snapshot_manage.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_snapshot_manage.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,8 @@
 #   License for the specific language governing permissions and limitations
 #   under the License.
 
-import mock
+from unittest import mock
+
 from oslo_config import cfg
 import oslo_messaging as messaging
 from oslo_serialization import jsonutils
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_snapshot_unmanage.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_snapshot_unmanage.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_snapshot_unmanage.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_snapshot_unmanage.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,8 @@
 #   License for the specific language governing permissions and limitations
 #   under the License.
 
-import mock
+from unittest import mock
+
 from oslo_serialization import jsonutils
 from six.moves import http_client
 import webob
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_types_extra_specs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_types_extra_specs.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_types_extra_specs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_types_extra_specs.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,14 +15,16 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 from oslo_config import cfg
 from oslo_utils import timeutils
 import webob
 
 from cinder.api.contrib import types_extra_specs
 from cinder import exception
+from cinder.image import glance as image_store
 from cinder import test
 from cinder.tests.unit.api import fakes
 from cinder.tests.unit import fake_constants as fake
@@ -146,6 +148,65 @@ class VolumeTypesExtraSpecsTest(test.Tes
         self.assertIn('updated_at', self.notifier.notifications[0]['payload'])
         self.assertEqual('value1', res_dict['extra_specs']['key1'])
 
+    @mock.patch.object(image_store.GlanceImageService, 'get_stores')
+    def test_create_valid_image_store(self, mock_get_stores):
+        mock_get_stores.return_value = {
+            'stores': [{
+                'default': 'true',
+                'id': 'cheap'
+            }, {
+                'id': 'read_only_store',
+                'read-only': 'true'
+            }]
+        }
+        self.mock_object(cinder.db,
+                         'volume_type_extra_specs_update_or_create',
+                         return_create_volume_type_extra_specs)
+        body = {"extra_specs": {"image_service:store_id": "cheap"}}
+
+        self.assertEqual(0, len(self.notifier.notifications))
+        req = fakes.HTTPRequest.blank(self.api_path)
+        res_dict = self.controller.create(req, fake.VOLUME_ID, body=body)
+        self.assertEqual(1, len(self.notifier.notifications))
+        self.assertIn('created_at', self.notifier.notifications[0]['payload'])
+        self.assertIn('updated_at', self.notifier.notifications[0]['payload'])
+        self.assertEqual(
+            'cheap', res_dict['extra_specs']['image_service:store_id'])
+
+    @mock.patch.object(image_store.GlanceImageService, 'get_stores')
+    def test_create_invalid_image_store(self, mock_get_stores):
+        mock_get_stores.return_value = {
+            'stores': [{
+                'default': 'true',
+                'id': 'cheap'
+            }, {
+                'id': 'read_only_store',
+                'read-only': 'true'
+            }]
+        }
+        body = {"extra_specs": {"image_service:store_id": "fast"}}
+        req = fakes.HTTPRequest.blank(self.api_path)
+        self.assertRaises(cinder.exception.GlanceStoreNotFound,
+                          self.controller.create,
+                          req, fake.VOLUME_ID, body=body)
+
+    @mock.patch.object(image_store.GlanceImageService, 'get_stores')
+    def test_create_read_only_image_store(self, mock_get_stores):
+        mock_get_stores.return_value = {
+            'stores': [{
+                'default': 'true',
+                'id': 'cheap'
+            }, {
+                'id': 'read_only_store',
+                'read-only': 'true'
+            }]
+        }
+        body = {"extra_specs": {"image_service:store_id": "read_only_store"}}
+        req = fakes.HTTPRequest.blank(self.api_path)
+        self.assertRaises(cinder.exception.GlanceStoreReadOnly,
+                          self.controller.create,
+                          req, fake.VOLUME_ID, body=body)
+
     @mock.patch.object(cinder.db, 'volume_type_extra_specs_update_or_create')
     def test_create_key_allowed_chars(
             self, volume_type_extra_specs_update_or_create):
@@ -194,6 +255,93 @@ class VolumeTypesExtraSpecsTest(test.Tes
         self.assertEqual('value3',
                          res_dict['extra_specs']['other3_alphanum.-_:'])
 
+    @mock.patch.object(image_store.GlanceImageService, 'get_stores')
+    def test_update_valid_image_store(self, mock_get_stores):
+        mock_get_stores.return_value = {
+            'stores': [{
+                'default': 'true',
+                'id': 'cheap'
+            }, {
+                'id': 'fast',
+            },
+                {
+                'id': 'read_only_store',
+                'read-only': 'true'
+            }]
+        }
+        self.mock_object(cinder.db,
+                         'volume_type_extra_specs_update_or_create',
+                         return_create_volume_type_extra_specs)
+        body = {"image_service:store_id": "fast"}
+
+        self.assertEqual(0, len(self.notifier.notifications))
+        req = fakes.HTTPRequest.blank(
+            self.api_path + "/image_service:store_id")
+        res_dict = self.controller.update(req, fake.VOLUME_ID,
+                                          "image_service:store_id",
+                                          body=body)
+        self.assertEqual(1, len(self.notifier.notifications))
+        self.assertIn('created_at', self.notifier.notifications[0]['payload'])
+        self.assertIn('updated_at', self.notifier.notifications[0]['payload'])
+        self.assertEqual(
+            'fast', res_dict['image_service:store_id'])
+
+    @mock.patch.object(image_store.GlanceImageService, 'get_stores')
+    def test_update_invalid_image_store(self, mock_get_stores):
+        mock_get_stores.return_value = {
+            'stores': [{
+                'default': 'true',
+                'id': 'cheap'
+            }, {
+                'id': 'fast',
+            },
+                {
+                'id': 'read_only_store',
+                'read-only': 'true'
+            }]
+        }
+        self.mock_object(cinder.db,
+                         'volume_type_extra_specs_update_or_create',
+                         return_create_volume_type_extra_specs)
+        body = {"image_service:store_id": "very_fast"}
+
+        self.assertEqual(0, len(self.notifier.notifications))
+        req = fakes.HTTPRequest.blank(
+            self.api_path + "/image_service:store_id")
+        self.assertRaises(cinder.exception.GlanceStoreNotFound,
+                          self.controller.update,
+                          req, fake.VOLUME_ID,
+                          "image_service:store_id",
+                          body=body)
+
+    @mock.patch.object(image_store.GlanceImageService, 'get_stores')
+    def test_update_read_only_image_store(self, mock_get_stores):
+        mock_get_stores.return_value = {
+            'stores': [{
+                'default': 'true',
+                'id': 'cheap'
+            }, {
+                'id': 'fast',
+            },
+                {
+                'id': 'read_only_store',
+                'read-only': 'true'
+            }]
+        }
+        self.mock_object(cinder.db,
+                         'volume_type_extra_specs_update_or_create',
+                         return_create_volume_type_extra_specs)
+        body = {"image_service:store_id": "read_only_store"}
+
+        self.assertEqual(0, len(self.notifier.notifications))
+        req = fakes.HTTPRequest.blank(
+            self.api_path + "/image_service:store_id")
+        self.assertRaises(cinder.exception.GlanceStoreReadOnly,
+                          self.controller.update,
+                          req, fake.VOLUME_ID,
+                          "image_service:store_id",
+                          body=body)
+
     def test_update_item(self):
         self.mock_object(cinder.db,
                          'volume_type_extra_specs_update_or_create',
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_types_manage.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_types_manage.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_types_manage.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_types_manage.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,12 +13,12 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
-import six
-import webob
+from unittest import mock
 
 import ddt
 from oslo_utils import strutils
+import six
+import webob
 
 from cinder.api.contrib import types_manage
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_used_limits.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_used_limits.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_used_limits.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_used_limits.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 
 from cinder.api.contrib import used_limits
 from cinder.api import microversions as mv
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_volume_actions.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_volume_actions.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_volume_actions.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_volume_actions.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,10 +13,10 @@
 #   under the License.
 
 import datetime
+from unittest import mock
 import uuid
 
 import ddt
-import mock
 from oslo_config import cfg
 import oslo_messaging as messaging
 from oslo_serialization import jsonutils
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_volume_image_metadata.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_volume_image_metadata.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_volume_image_metadata.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_volume_image_metadata.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,7 @@
 #   License for the specific language governing permissions and limitations
 #   under the License.
 
-import mock
+from unittest import mock
 import uuid
 
 from oslo_policy import policy as oslo_policy
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_volume_manage.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_volume_manage.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_volume_manage.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_volume_manage.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,9 @@
 #   License for the specific language governing permissions and limitations
 #   under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 from oslo_config import cfg
 import oslo_messaging as messaging
 from oslo_serialization import jsonutils
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_volume_transfer.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_volume_transfer.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_volume_transfer.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_volume_transfer.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,11 +13,10 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Tests for volume transfer code.
-"""
+"""Tests for volume transfer code."""
+
+from unittest import mock
 
-import mock
 from oslo_serialization import jsonutils
 from six.moves import http_client
 import webob
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_volume_type_access.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_volume_type_access.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_volume_type_access.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_volume_type_access.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,7 @@
 #    under the License.
 
 import datetime
-import mock
+from unittest import mock
 
 from six.moves import http_client
 import webob
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/contrib/test_volume_unmanage.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_volume_unmanage.py
--- 2:15.0.1-1/cinder/tests/unit/api/contrib/test_volume_unmanage.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/contrib/test_volume_unmanage.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,8 @@
 #   License for the specific language governing permissions and limitations
 #   under the License.
 
-import mock
+from unittest import mock
+
 from oslo_serialization import jsonutils
 from six.moves import http_client
 import webob
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/openstack/test_wsgi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/openstack/test_wsgi.py
--- 2:15.0.1-1/cinder/tests/unit/api/openstack/test_wsgi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/openstack/test_wsgi.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,10 +10,10 @@
 # License for the specific language governing permissions and limitations
 # under the License.
 
-import ddt
 import inspect
+from unittest import mock
 
-import mock
+import ddt
 from oslo_utils import encodeutils
 from six.moves import http_client
 import webob
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/test_common.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/test_common.py
--- 2:15.0.1-1/cinder/tests/unit/api/test_common.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/test_common.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,18 +14,16 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Test suites for 'common' code used throughout the OpenStack HTTP API.
-"""
+"""Test suites for 'common' code used throughout the OpenStack HTTP API."""
+
+from unittest import mock
 
 import ddt
-import mock
+from oslo_config import cfg
 from testtools import matchers
 import webob
 import webob.exc
 
-from oslo_config import cfg
-
 from cinder.api import common
 from cinder import test
 
@@ -263,7 +261,9 @@ class MiscFunctionsTest(test.TestCase):
               ('http://cinder.example.com/v1.1/images/v10.5',
                'http://cinder.example.com/images/v10.5'),
               ('http://cinder.example.com/cinder/v2',
-               'http://cinder.example.com/cinder'))
+               'http://cinder.example.com/cinder'),
+              ('http://cinder.example.com/volume/v2/123',
+               'http://cinder.example.com/volume/123'))
     @ddt.unpack
     def test_remove_version_from_href(self, fixture, expected):
         """Test for removing version from href
@@ -479,7 +479,7 @@ class GeneralFiltersTest(test.TestCase):
                'expected': ["name", "status", "metadata",
                             "bootable", "migration_status",
                             "availability_zone", "group_id",
-                            "size"]},
+                            "size", "created_at", "updated_at"]},
               {'resource': 'backup',
                'expected': ["name", "status", "volume_id"]},
               {'resource': 'snapshot',
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v2/fakes.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v2/fakes.py
--- 2:15.0.1-1/cinder/tests/unit/api/v2/fakes.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v2/fakes.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,6 +14,7 @@
 #    under the License.
 
 import datetime
+
 import iso8601
 
 from cinder import exception as exc
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v2/test_snapshot_metadata.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v2/test_snapshot_metadata.py
--- 2:15.0.1-1/cinder/tests/unit/api/v2/test_snapshot_metadata.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v2/test_snapshot_metadata.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,10 +13,10 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
 import uuid
 
 import ddt
-import mock
 from oslo_serialization import jsonutils
 from six.moves import http_client
 import webob
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v2/test_snapshots.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v2/test_snapshots.py
--- 2:15.0.1-1/cinder/tests/unit/api/v2/test_snapshots.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v2/test_snapshots.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,8 +14,9 @@
 #    under the License.
 
 import datetime
+from unittest import mock
+
 import ddt
-import mock
 from oslo_config import cfg
 import pytz
 from six.moves import http_client
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v2/test_types.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v2/test_types.py
--- 2:15.0.1-1/cinder/tests/unit/api/v2/test_types.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v2/test_types.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,9 +13,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
 import uuid
 
-import mock
 from oslo_utils import timeutils
 import six
 import webob
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v2/test_volume_metadata.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v2/test_volume_metadata.py
--- 2:15.0.1-1/cinder/tests/unit/api/v2/test_volume_metadata.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v2/test_volume_metadata.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,9 +13,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
 import uuid
 
-import mock
 from oslo_config import cfg
 from oslo_serialization import jsonutils
 from six.moves import http_client
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v2/test_volumes.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v2/test_volumes.py
--- 2:15.0.1-1/cinder/tests/unit/api/v2/test_volumes.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v2/test_volumes.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,12 +15,12 @@
 
 
 import datetime
-import iso8601
 import json
+from unittest import mock
 
 import ddt
 import fixtures
-import mock
+import iso8601
 from oslo_config import cfg
 import six
 from six.moves import http_client
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/fakes.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/fakes.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/fakes.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/fakes.py	2020-03-24 18:46:31.000000000 +0000
@@ -11,6 +11,7 @@
 #    under the License.
 
 import datetime
+
 import iso8601
 
 from cinder.tests.unit import fake_constants as fake
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/stubs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/stubs.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/stubs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/stubs.py	2020-03-24 18:46:31.000000000 +0000
@@ -11,6 +11,7 @@
 #    under the License.
 
 import datetime
+
 import iso8601
 
 from cinder.tests.unit import fake_constants as fake
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/test_attachments.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_attachments.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/test_attachments.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_attachments.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,12 +13,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Tests for attachments Api.
-"""
+"""Tests for attachments Api."""
+
+from unittest import mock
 
 import ddt
-import mock
 from oslo_policy import policy as oslo_policy
 
 from cinder.api import microversions as mv
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/test_backups.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_backups.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/test_backups.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_backups.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,8 +16,9 @@
 """The backups V3 api."""
 
 import copy
+from unittest import mock
+
 import ddt
-import mock
 from oslo_serialization import jsonutils
 from oslo_utils import strutils
 import webob
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/test_cluster.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_cluster.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/test_cluster.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_cluster.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,10 +14,10 @@
 #    under the License.
 
 import datetime
+from unittest import mock
 
 import ddt
 import iso8601
-import mock
 from oslo_utils import versionutils
 
 from cinder.api import extensions
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/test_group_snapshots.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_group_snapshots.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/test_group_snapshots.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_group_snapshots.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,12 +13,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Tests for group_snapshot code.
-"""
+"""Tests for group_snapshot code."""
+
+from unittest import mock
 
 import ddt
-import mock
 from oslo_policy import policy as oslo_policy
 from six.moves import http_client
 import webob
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/test_group_specs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_group_specs.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/test_group_specs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_group_specs.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,17 +13,17 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
+
 import webob
 
+from cinder.api import microversions as mv
+from cinder.api.v3 import group_specs as v3_group_specs
 from cinder import context
 from cinder import db
 from cinder import exception
 from cinder import rpc
 from cinder import test
-
-from cinder.api import microversions as mv
-from cinder.api.v3 import group_specs as v3_group_specs
 from cinder.tests.unit.api import fakes
 from cinder.tests.unit import fake_constants as fake
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/test_groups.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_groups.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/test_groups.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_groups.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,12 +13,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Tests for group code.
-"""
+"""Tests for group code."""
+
+from unittest import mock
 
 import ddt
-import mock
 from six.moves import http_client
 import webob
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/test_group_types.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_group_types.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/test_group_types.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_group_types.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,10 +13,10 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
 import uuid
 
 import ddt
-import mock
 from oslo_utils import strutils
 from oslo_utils import timeutils
 import six
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/test_limits.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_limits.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/test_limits.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_limits.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 
 from cinder.api import microversions as mv
 from cinder.api.openstack import api_version_request as api_version
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/test_messages.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_messages.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/test_messages.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_messages.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,8 +10,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 from six.moves import http_client
 
 from cinder.api import extensions
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/test_resource_filters.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_resource_filters.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/test_resource_filters.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_resource_filters.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,12 +10,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Tests for resource filters API.
-"""
+"""Tests for resource filters API."""
+
+from unittest import mock
 
 import ddt
-import mock
 import six
 
 from cinder.api import microversions as mv
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/test_snapshot_manage.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_snapshot_manage.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/test_snapshot_manage.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_snapshot_manage.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,8 +12,9 @@
 #   License for the specific language governing permissions and limitations
 #   under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 from oslo_config import cfg
 from oslo_serialization import jsonutils
 from six.moves import http_client
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/test_snapshots.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_snapshots.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/test_snapshots.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_snapshots.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 from oslo_utils import strutils
 
 from cinder.api import microversions as mv
@@ -44,7 +45,6 @@ def fake_get(self, context, *args, **kwa
            'host': 'fake-host',
            'status': 'available',
            'encryption_key_id': None,
-           'volume_type_id': None,
            'migration_status': None,
            'availability_zone': 'fake-zone',
            'attach_status': 'detached',
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/test_volume_manage.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_volume_manage.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/test_volume_manage.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_volume_manage.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,8 +12,9 @@
 #   License for the specific language governing permissions and limitations
 #   under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 from oslo_config import cfg
 from oslo_serialization import jsonutils
 from six.moves import http_client
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/test_volume_metadata.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_volume_metadata.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/test_volume_metadata.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_volume_metadata.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,9 +10,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
 import uuid
 
-import mock
 from oslo_config import cfg
 from oslo_serialization import jsonutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/test_volumes.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_volumes.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/test_volumes.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_volumes.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,14 +12,15 @@
 #    under the License.
 
 import datetime
-import ddt
-import iso8601
 import json
+from unittest import mock
 
+import ddt
 import fixtures
-import mock
+import iso8601
 from oslo_serialization import jsonutils
 from oslo_utils import strutils
+from oslo_utils import timeutils
 from six.moves import http_client
 import webob
 
@@ -120,18 +121,27 @@ class VolumeApiTest(test.TestCase):
         self._reset_filter_file()
 
     def _create_volume_with_glance_metadata(self):
+        basetime = timeutils.utcnow()
+        td = datetime.timedelta(minutes=1)
+
         vol1 = db.volume_create(self.ctxt, {'display_name': 'test1',
+                                            'created_at': basetime - 3 * td,
+                                            'updated_at': basetime - 2 * td,
                                             'project_id':
                                             self.ctxt.project_id,
                                             'volume_type_id':
-                                                fake.VOLUME_TYPE_ID})
+                                                fake.VOLUME_TYPE_ID,
+                                            'id': fake.VOLUME_ID})
         db.volume_glance_metadata_create(self.ctxt, vol1.id, 'image_name',
                                          'imageTestOne')
         vol2 = db.volume_create(self.ctxt, {'display_name': 'test2',
+                                            'created_at': basetime - td,
+                                            'updated_at': basetime,
                                             'project_id':
                                             self.ctxt.project_id,
                                             'volume_type_id':
-                                                fake.VOLUME_TYPE_ID})
+                                                fake.VOLUME_TYPE_ID,
+                                            'id': fake.VOLUME2_ID})
         db.volume_glance_metadata_create(self.ctxt, vol2.id, 'image_name',
                                          'imageTestTwo')
         db.volume_glance_metadata_create(self.ctxt, vol2.id, 'disk_format',
@@ -984,3 +994,80 @@ class VolumeApiTest(test.TestCase):
         self.assertEqual('host1', attachments[0]['host_name'])
         self.assertEqual('na', attachments[0]['device'])
         self.assertEqual(att_time, attachments[0]['attached_at'])
+
+    @ddt.data(('created_at=gt:', 0), ('created_at=lt:', 2))
+    @ddt.unpack
+    def test_volume_index_filter_by_created_at_with_gt_and_lt(self, change,
+                                                              expect_result):
+        self._create_volume_with_glance_metadata()
+        change_time = timeutils.utcnow() + datetime.timedelta(minutes=1)
+        req = fakes.HTTPRequest.blank(("/v3/volumes?%s%s") %
+                                      (change, change_time))
+        req.environ['cinder.context'] = self.ctxt
+        req.headers = mv.get_mv_header(mv.VOLUME_TIME_COMPARISON_FILTER)
+        req.api_version_request = mv.get_api_version(
+            mv.VOLUME_TIME_COMPARISON_FILTER)
+        res_dict = self.controller.index(req)
+        volumes = res_dict['volumes']
+        self.assertEqual(expect_result, len(volumes))
+
+    @ddt.data(('updated_at=gt:', 0), ('updated_at=lt:', 1))
+    @ddt.unpack
+    def test_vol_filter_by_updated_at_with_gt_and_lt(self, change, result):
+        vols = self._create_volume_with_glance_metadata()
+        change_time = vols[1].updated_at
+        req = fakes.HTTPRequest.blank(("/v3/volumes?%s%s") %
+                                      (change, change_time))
+        req.environ['cinder.context'] = self.ctxt
+        req.headers = mv.get_mv_header(mv.VOLUME_TIME_COMPARISON_FILTER)
+        req.api_version_request = mv.get_api_version(
+            mv.VOLUME_TIME_COMPARISON_FILTER)
+        res_dict = self.controller.index(req)
+        volumes = res_dict['volumes']
+        self.assertEqual(result, len(volumes))
+
+    @ddt.data(('updated_at=eq:', 1, fake.VOLUME2_ID),
+              ('updated_at=neq:', 1, fake.VOLUME_ID))
+    @ddt.unpack
+    def test_vol_filter_by_updated_at_with_eq_and_neq(self, change, result,
+                                                      expected_volume_id):
+        vols = self._create_volume_with_glance_metadata()
+        change_time = vols[1].updated_at
+        req = fakes.HTTPRequest.blank(("/v3/volumes?%s%s") %
+                                      (change, change_time))
+        req.environ['cinder.context'] = self.ctxt
+        req.headers = mv.get_mv_header(mv.VOLUME_TIME_COMPARISON_FILTER)
+        req.api_version_request = mv.get_api_version(
+            mv.VOLUME_TIME_COMPARISON_FILTER)
+        res_dict = self.controller.index(req)
+        volumes = res_dict['volumes']
+        self.assertEqual(result, len(volumes))
+        self.assertEqual(expected_volume_id, volumes[0]['id'])
+
+    @ddt.data('created_at', 'updated_at')
+    def test_volume_filter_by_time_with_invaild_time(self, change):
+        self._create_volume_with_glance_metadata()
+        change_time = '123'
+        req = fakes.HTTPRequest.blank(("/v3/volumes?%s=%s") %
+                                      (change, change_time))
+        req.environ['cinder.context'] = self.ctxt
+        req.headers = mv.get_mv_header(mv.VOLUME_TIME_COMPARISON_FILTER)
+        req.api_version_request = mv.get_api_version(
+            mv.VOLUME_TIME_COMPARISON_FILTER)
+        self.assertRaises(webob.exc.HTTPBadRequest, self.controller.index, req)
+
+    def test_volume_index_filter_by_time_with_lte_and_gte(self):
+        vols = self._create_volume_with_glance_metadata()
+        change_since = vols[1].updated_at
+        change_before = timeutils.utcnow() + datetime.timedelta(minutes=1)
+        req = fakes.HTTPRequest.blank(("/v3/volumes?updated_at=lte:%s&"
+                                       "updated_at=gte:%s") %
+                                      (change_before, change_since))
+        req.environ['cinder.context'] = self.ctxt
+        req.headers = mv.get_mv_header(mv.VOLUME_TIME_COMPARISON_FILTER)
+        req.api_version_request = mv.get_api_version(
+            mv.VOLUME_TIME_COMPARISON_FILTER)
+        res_dict = self.controller.index(req)
+        volumes = res_dict['volumes']
+        self.assertEqual(1, len(volumes))
+        self.assertEqual(vols[1].id, volumes[0]['id'])
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/test_volume_transfer.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_volume_transfer.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/test_volume_transfer.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_volume_transfer.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,12 +13,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Tests for volume transfer code.
-"""
-import ddt
+"""Tests for volume transfer code."""
+
+from unittest import mock
 
-import mock
+import ddt
 from oslo_serialization import jsonutils
 from six.moves import http_client
 import webob
diff -pruN 2:15.0.1-1/cinder/tests/unit/api/v3/test_workers.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_workers.py
--- 2:15.0.1-1/cinder/tests/unit/api/v3/test_workers.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/api/v3/test_workers.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 from oslo_serialization import jsonutils
 from six.moves import http_client
 import webob
diff -pruN 2:15.0.1-1/cinder/tests/unit/attachments/test_attachments_api.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/attachments/test_attachments_api.py
--- 2:15.0.1-1/cinder/tests/unit/attachments/test_attachments_api.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/attachments/test_attachments_api.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,7 +10,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
+
 from oslo_config import cfg
 from oslo_policy import policy as oslo_policy
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/attachments/test_attachments_manager.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/attachments/test_attachments_manager.py
--- 2:15.0.1-1/cinder/tests/unit/attachments/test_attachments_manager.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/attachments/test_attachments_manager.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,7 +10,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
+
 from oslo_config import cfg
 from oslo_utils import importutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/backup/drivers/test_backup_ceph.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/drivers/test_backup_ceph.py
--- 2:15.0.1-1/cinder/tests/unit/backup/drivers/test_backup_ceph.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/drivers/test_backup_ceph.py	2020-03-24 18:46:31.000000000 +0000
@@ -19,10 +19,10 @@ import json
 import os
 import tempfile
 import threading
+from unittest import mock
 import uuid
 
 import ddt
-import mock
 from os_brick.initiator import linuxrbd
 from oslo_concurrency import processutils
 from oslo_config import cfg
diff -pruN 2:15.0.1-1/cinder/tests/unit/backup/drivers/test_backup_driver_base.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/drivers/test_backup_driver_base.py
--- 2:15.0.1-1/cinder/tests/unit/backup/drivers/test_backup_driver_base.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/drivers/test_backup_driver_base.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,9 +14,9 @@
 #    under the License.
 """ Tests for the backup service base driver. """
 
+from unittest import mock
 import uuid
 
-import mock
 from oslo_serialization import jsonutils
 
 from cinder.backup import driver
diff -pruN 2:15.0.1-1/cinder/tests/unit/backup/drivers/test_backup_glusterfs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/drivers/test_backup_glusterfs.py
--- 2:15.0.1-1/cinder/tests/unit/backup/drivers/test_backup_glusterfs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/drivers/test_backup_glusterfs.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,13 +12,10 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Tests for GlusterFS backup driver.
-
-"""
+"""Tests for GlusterFS backup driver."""
 import os
+from unittest import mock
 
-import mock
 from os_brick.remotefs import remotefs as remotefs_brick
 
 from cinder.backup.drivers import glusterfs
diff -pruN 2:15.0.1-1/cinder/tests/unit/backup/drivers/test_backup_google.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/drivers/test_backup_google.py
--- 2:15.0.1-1/cinder/tests/unit/backup/drivers/test_backup_google.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/drivers/test_backup_google.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,10 +14,7 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Tests for Google Backup code.
-
-"""
+"""Tests for Google Backup code."""
 
 import bz2
 import filecmp
@@ -26,10 +23,10 @@ import os
 import shutil
 import tempfile
 import threading
+from unittest import mock
 import zlib
 
 from eventlet import tpool
-import mock
 from oslo_utils import units
 
 from cinder.backup.drivers import gcs as google_dr
diff -pruN 2:15.0.1-1/cinder/tests/unit/backup/drivers/test_backup_nfs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/drivers/test_backup_nfs.py
--- 2:15.0.1-1/cinder/tests/unit/backup/drivers/test_backup_nfs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/drivers/test_backup_nfs.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,12 +12,9 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Tests for Backup NFS driver.
+"""Tests for Backup NFS driver."""
 
-"""
 import bz2
-import ddt
 import filecmp
 import hashlib
 import os
@@ -25,10 +22,11 @@ import shutil
 import stat
 import tempfile
 import threading
+from unittest import mock
 import zlib
 
+import ddt
 from eventlet import tpool
-import mock
 from os_brick import exception as brick_exception
 from os_brick.remotefs import remotefs as remotefs_brick
 from oslo_config import cfg
diff -pruN 2:15.0.1-1/cinder/tests/unit/backup/drivers/test_backup_posix.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/drivers/test_backup_posix.py
--- 2:15.0.1-1/cinder/tests/unit/backup/drivers/test_backup_posix.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/drivers/test_backup_posix.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,14 +12,11 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Tests for Posix backup driver.
-
-"""
+"""Tests for Posix backup driver."""
 
 import os
+from unittest import mock
 
-import mock
 from six.moves import builtins
 
 from cinder.backup.drivers import posix
diff -pruN 2:15.0.1-1/cinder/tests/unit/backup/drivers/test_backup_swift.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/drivers/test_backup_swift.py
--- 2:15.0.1-1/cinder/tests/unit/backup/drivers/test_backup_swift.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/drivers/test_backup_swift.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,23 +12,20 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Tests for Backup swift code.
-
-"""
+"""Tests for Backup swift code."""
 
 import bz2
-import ddt
 import filecmp
 import hashlib
 import os
 import shutil
 import tempfile
 import threading
+from unittest import mock
 import zlib
 
+import ddt
 from eventlet import tpool
-import mock
 from oslo_config import cfg
 from swiftclient import client as swift
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/backup/drivers/test_backup_tsm.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/drivers/test_backup_tsm.py
--- 2:15.0.1-1/cinder/tests/unit/backup/drivers/test_backup_tsm.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/drivers/test_backup_tsm.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,13 +13,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 #
-"""
-Tests for volume backup to IBM Tivoli Storage Manager (TSM).
-"""
+"""Tests for volume backup to IBM Tivoli Storage Manager (TSM)."""
 
 import json
-import mock
 import posix
+from unittest import mock
 
 from oslo_concurrency import processutils as putils
 from oslo_utils import timeutils
diff -pruN 2:15.0.1-1/cinder/tests/unit/backup/fake_swift_client2.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/fake_swift_client2.py
--- 2:15.0.1-1/cinder/tests/unit/backup/fake_swift_client2.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/fake_swift_client2.py	2020-03-24 18:46:31.000000000 +0000
@@ -20,7 +20,6 @@ import socket
 import tempfile
 
 from six.moves import http_client
-
 from swiftclient import client as swift
 
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/backup/fake_swift_client.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/fake_swift_client.py
--- 2:15.0.1-1/cinder/tests/unit/backup/fake_swift_client.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/fake_swift_client.py	2020-03-24 18:46:31.000000000 +0000
@@ -20,7 +20,6 @@ import zlib
 
 import six
 from six.moves import http_client
-
 from swiftclient import client as swift
 
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/backup/test_backup.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/test_backup.py
--- 2:15.0.1-1/cinder/tests/unit/backup/test_backup.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/test_backup.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,12 +15,12 @@
 """Tests for Backup code."""
 
 import copy
-import ddt
 import os
+from unittest import mock
 import uuid
 
+import ddt
 from eventlet import tpool
-import mock
 from os_brick.initiator.connectors import fake as fake_connectors
 from oslo_config import cfg
 from oslo_db import exception as db_exc
@@ -1905,20 +1905,6 @@ class BackupAPITestCase(BaseBackupTest):
                           volume_id=volume_id,
                           container='volumebackups')
 
-    @mock.patch('cinder.backup.rpcapi.BackupAPI.create_backup')
-    @mock.patch('cinder.backup.api.API._is_backup_service_enabled')
-    def test_create_backup_in_same_host(self, mock_is_enable,
-                                        mock_create):
-        self.override_config('backup_use_same_host', True)
-        mock_is_enable.return_value = True
-        self.ctxt.user_id = 'fake_user'
-        self.ctxt.project_id = 'fake_project'
-        volume_id = self._create_volume_db_entry(status='available',
-                                                 host='testhost#lvm',
-                                                 size=1)
-        backup = self.api.create(self.ctxt, None, None, volume_id, None)
-        self.assertEqual('testhost', backup.host)
-
     @mock.patch.object(api.API, '_get_available_backup_service_host',
                        return_value='fake_host')
     @mock.patch('cinder.backup.rpcapi.BackupAPI.create_backup')
diff -pruN 2:15.0.1-1/cinder/tests/unit/backup/test_chunkeddriver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/test_chunkeddriver.py
--- 2:15.0.1-1/cinder/tests/unit/backup/test_chunkeddriver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/test_chunkeddriver.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,9 +14,9 @@
 """Tests for the base chunkedbackupdriver class."""
 
 import json
+from unittest import mock
 import uuid
 
-import mock
 from oslo_config import cfg
 from oslo_utils import units
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/backup/test_rpcapi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/test_rpcapi.py
--- 2:15.0.1-1/cinder/tests/unit/backup/test_rpcapi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/backup/test_rpcapi.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,7 +16,7 @@
 Unit Tests for cinder.backup.rpcapi
 """
 
-import mock
+from unittest import mock
 
 from cinder.backup import rpcapi as backup_rpcapi
 from cinder import objects
@@ -41,7 +41,7 @@ class BackupRPCAPITestCase(test.RPCAPITe
         self._test_rpc_api('restore_backup',
                            rpc_method='cast',
                            server='fake_volume_host',
-                           volume_host='fake_volume_host',
+                           backup_host='fake_volume_host',
                            backup=self.fake_backup_obj,
                            volume_id=fake.VOLUME_ID)
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/brick/test_brick_lvm.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/brick/test_brick_lvm.py
--- 2:15.0.1-1/cinder/tests/unit/brick/test_brick_lvm.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/brick/test_brick_lvm.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,8 +12,10 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
+
+from unittest import mock
+
 import ddt
-import mock
 from oslo_concurrency import processutils
 
 from cinder.brick.local_dev import lvm as brick
diff -pruN 2:15.0.1-1/cinder/tests/unit/cast_as_call.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/cast_as_call.py
--- 2:15.0.1-1/cinder/tests/unit/cast_as_call.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/cast_as_call.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 
 def mock_cast_as_call(obj=None):
diff -pruN 2:15.0.1-1/cinder/tests/unit/cmd/test_status.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/cmd/test_status.py
--- 2:15.0.1-1/cinder/tests/unit/cmd/test_status.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/cmd/test_status.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,10 +12,10 @@
 
 """Unit tests for the cinder-status CLI interfaces."""
 
-import ddt
-import mock
+from unittest import mock
 import uuid
 
+import ddt
 from oslo_config import cfg
 from oslo_upgradecheck import upgradecheck as uc
 import testtools
@@ -27,6 +27,7 @@ from cinder import db
 from cinder.db.sqlalchemy import api as sqla_api
 from cinder import exception
 from cinder import test
+from cinder.tests.unit import fake_constants as fakes
 import cinder.volume.manager as volume_manager
 
 
@@ -194,7 +195,16 @@ class TestCinderStatus(testtools.TestCas
               'cinder.volume.drivers.coprhd.iscsi.EMCCoprHDISCSIDriver',
               'cinder.volume.drivers.coprhd.scaleio.EMCCoprHDScaleIODriver',
               'cinder.volume.drivers.disco.disco.DiscoDriver',
-              'cinder.volume.drivers.hgst.HGSTDriver')
+              'cinder.volume.drivers.hgst.HGSTDriver',
+              'cinder.volume.drivers.fusionstorage.dsware.DSWAREDriver',
+              'cinder.volume.drivers.prophetstor.dpl_fc.DPLFCDriver',
+              'cinder.volume.drivers.prophetstor.dpl_iscsi.DPLISCSIDriver',
+              'cinder.volume.drivers.nimble.NimbleFCDriver',
+              'cinder.volume.drivers.nimble.NimbleISCSIDriver',
+              'cinder.volume.drivers.sheepdog.SheepdogDriver',
+              'cinder.volume.drivers.vzstorage.VZStorageDriver',
+              'cinder.volume.drivers.veritas_access.veritas_iscsi.'
+              'ACCESSIscsiDriver')
     def test_check_removed_drivers_fail(self, volume_driver):
         self._set_volume_driver(
             volume_driver,
@@ -253,22 +263,24 @@ class TestCinderStatus(testtools.TestCas
     def test__check_service_uuid_ok(self):
         self._create_service()
         self._create_service()
-        self._create_volume()
+        self._create_volume(volume_type_id=fakes.VOLUME_TYPE_ID)
         # Confirm that we ignored deleted entries
-        self._create_volume(service_uuid=None, deleted=True)
+        self._create_volume(service_uuid=None, deleted=True,
+                            volume_type_id=fakes.VOLUME_TYPE_ID)
         result = self.checks._check_service_uuid()
         self.assertEqual(uc.Code.SUCCESS, result.code)
 
     def test__check_service_uuid_fail_service(self):
         self._create_service()
         self._create_service(uuid=None)
-        self._create_volume()
+        self._create_volume(volume_type_id=fakes.VOLUME_TYPE_ID)
         result = self.checks._check_service_uuid()
         self.assertEqual(uc.Code.FAILURE, result.code)
 
     def test__check_service_uuid_fail_volume(self):
         self._create_service()
-        self._create_volume(service_uuid=None)
+        self._create_volume(service_uuid=None,
+                            volume_type_id=fakes.VOLUME_TYPE_ID)
         result = self.checks._check_service_uuid()
         self.assertEqual(uc.Code.FAILURE, result.code)
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/compute/test_nova.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/compute/test_nova.py
--- 2:15.0.1-1/cinder/tests/unit/compute/test_nova.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/compute/test_nova.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,17 +12,18 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
 from keystoneauth1 import exceptions as ks_exc
-import mock
+from keystoneauth1 import loading as ks_loading
+from novaclient import exceptions as nova_exceptions
+from oslo_config import cfg
 
 from cinder.compute import nova
 from cinder import context
 from cinder.message import message_field
 from cinder import test
-from keystoneauth1 import loading as ks_loading
-from novaclient import exceptions as nova_exceptions
-from oslo_config import cfg
 
 CONF = cfg.CONF
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/db/test_cluster.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/db/test_cluster.py
--- 2:15.0.1-1/cinder/tests/unit/db/test_cluster.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/db/test_cluster.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,7 +15,8 @@
 
 """Tests for cluster table related operations."""
 
-import mock
+from unittest import mock
+
 from oslo_config import cfg
 from sqlalchemy.orm import exc
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/db/test_migrations.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/db/test_migrations.py
--- 2:15.0.1-1/cinder/tests/unit/db/test_migrations.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/db/test_migrations.py	2020-03-24 18:46:31.000000000 +0000
@@ -114,6 +114,9 @@ class MigrationsMixin(test_migrations.Wa
             # it should be add the additional prefix before volume_type_name,
             # which we of course allow *this* size to 300.
             127,
+            # 136 modifies the the tables having volume_type_id field to set
+            # as non nullable
+            136,
         ]
 
         if version not in exceptions:
@@ -188,6 +191,15 @@ class MigrationsMixin(test_migrations.Wa
                  .execute().first())
         self.assertIsNotNone(vtype)
 
+    def _check_136(self, engine, data):
+        """Test alter volume_type_id columns."""
+        vol_table = db_utils.get_table(engine, 'volumes')
+        snap_table = db_utils.get_table(engine, 'snapshots')
+        encrypt_table = db_utils.get_table(engine, 'encryption')
+        self.assertFalse(vol_table.c.volume_type_id.nullable)
+        self.assertFalse(snap_table.c.volume_type_id.nullable)
+        self.assertFalse(encrypt_table.c.volume_type_id.nullable)
+
     # NOTE: this test becomes slower with each addition of new DB migration.
     # 'pymysql' works much slower on slow nodes than 'psycopg2'. And such
     # timeout mostly required for testing of 'mysql' backend.
diff -pruN 2:15.0.1-1/cinder/tests/unit/db/test_orm_relationships.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/db/test_orm_relationships.py
--- 2:15.0.1-1/cinder/tests/unit/db/test_orm_relationships.py	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/db/test_orm_relationships.py	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,46 @@
+# Copyright 2020 Red Hat, Inc.
+#
+#    Licensed under the Apache License, Version 2.0 (the "License"); you may
+#    not use this file except in compliance with the License. You may obtain
+#    a copy of the License at
+#
+#         http://www.apache.org/licenses/LICENSE-2.0
+#
+#    Unless required by applicable law or agreed to in writing, software
+#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+#    License for the specific language governing permissions and limitations
+#    under the License.
+
+"""Tests for code that makes assumptions about ORM relationships."""
+
+from sqlalchemy_utils import functions as saf
+
+from cinder.db.sqlalchemy import api as db_api
+from cinder.db.sqlalchemy import models
+from cinder import test
+
+
+class VolumeRelationshipsTestCase(test.TestCase):
+    """Test cases for Volume ORM model relationshps."""
+
+    def test_volume_dependent_models_list(self):
+        """Make sure the volume dependent tables list is accurate."""
+        # Addresses LP Bug #1542169
+
+        volume_declarative_base = saf.get_declarative_base(models.Volume)
+        volume_fks = saf.get_referencing_foreign_keys(models.Volume)
+
+        dependent_tables = []
+        for table, fks in saf.group_foreign_keys(volume_fks):
+            dependent_tables.append(table)
+
+        found_dependent_models = []
+        for table in dependent_tables:
+            found_dependent_models.append(saf.get_class_by_table(
+                volume_declarative_base, table))
+
+        self.assertEqual(len(found_dependent_models),
+                         len(db_api.VOLUME_DEPENDENT_MODELS))
+        for model in found_dependent_models:
+            self.assertIn(model, db_api.VOLUME_DEPENDENT_MODELS)
diff -pruN 2:15.0.1-1/cinder/tests/unit/db/test_purge.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/db/test_purge.py
--- 2:15.0.1-1/cinder/tests/unit/db/test_purge.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/db/test_purge.py	2020-03-24 18:46:31.000000000 +0000
@@ -19,6 +19,7 @@ import datetime
 import uuid
 
 from oslo_db import exception as db_exc
+from oslo_db.sqlalchemy import utils as sqlalchemyutils
 from oslo_utils import timeutils
 from sqlalchemy.dialects import sqlite
 
@@ -28,8 +29,6 @@ from cinder.db.sqlalchemy import api as
 from cinder import exception
 from cinder import test
 
-from oslo_db.sqlalchemy import utils as sqlalchemyutils
-
 
 class PurgeDeletedTest(test.TestCase):
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/fake_notifier.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/fake_notifier.py
--- 2:15.0.1-1/cinder/tests/unit/fake_notifier.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/fake_notifier.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,8 +14,8 @@
 
 import collections
 import functools
-
 import json
+
 import oslo_messaging as messaging
 
 from cinder import rpc
diff -pruN 2:15.0.1-1/cinder/tests/unit/group/test_groups_api.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/group/test_groups_api.py
--- 2:15.0.1-1/cinder/tests/unit/group/test_groups_api.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/group/test_groups_api.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,9 +16,9 @@
 """
 Tests for group API.
 """
+from unittest import mock
 
 import ddt
-import mock
 
 from cinder import context
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/group/test_groups_manager.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/group/test_groups_manager.py
--- 2:15.0.1-1/cinder/tests/unit/group/test_groups_manager.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/group/test_groups_manager.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,9 +12,9 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
+from unittest import mock
 
 import ddt
-import mock
 from oslo_config import cfg
 from oslo_utils import importutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/group/test_groups_manager_replication.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/group/test_groups_manager_replication.py
--- 2:15.0.1-1/cinder/tests/unit/group/test_groups_manager_replication.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/group/test_groups_manager_replication.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,9 +12,9 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
+from unittest import mock
 
 import ddt
-import mock
 from oslo_config import cfg
 from oslo_utils import importutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/image/accelerators/test_qat_gzip.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/image/accelerators/test_qat_gzip.py
--- 2:15.0.1-1/cinder/tests/unit/image/accelerators/test_qat_gzip.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/image/accelerators/test_qat_gzip.py	2020-03-24 18:46:31.000000000 +0000
@@ -11,7 +11,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 from cinder import exception
 from cinder.image import accelerator
diff -pruN 2:15.0.1-1/cinder/tests/unit/image/fake.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/image/fake.py
--- 2:15.0.1-1/cinder/tests/unit/image/fake.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/image/fake.py	2020-03-24 18:46:31.000000000 +0000
@@ -18,7 +18,7 @@
 
 import copy
 import datetime
-import mock
+from unittest import mock
 import uuid
 
 from cinder import exception
@@ -102,7 +102,6 @@ class _FakeImageService(object):
                   'updated_at': timestamp,
                   'deleted_at': None,
                   'deleted': False,
-                  'size': 1024,
                   'status': 'active',
                   'visibility': 'public',
                   'protected': True,
@@ -213,7 +212,7 @@ class _FakeImageService(object):
         return self.images[image_id]
 
     def update(self, context, image_id, metadata, data=None,
-               purge_props=False):
+               purge_props=False, store_id=None):
         """Replace the contents of the given image with the new data.
 
         :raises ImageNotFound: if the image does not exist.
diff -pruN 2:15.0.1-1/cinder/tests/unit/image/test_accelerator.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/image/test_accelerator.py
--- 2:15.0.1-1/cinder/tests/unit/image/test_accelerator.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/image/test_accelerator.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,7 @@
 #    under the License.
 
 
-import mock
+from unittest import mock
 
 from cinder.image import accelerator
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/image/test_cache.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/image/test_cache.py
--- 2:15.0.1-1/cinder/tests/unit/image/test_cache.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/image/test_cache.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,9 +13,9 @@
 #    under the License.
 
 from datetime import timedelta
-import ddt
-import mock
+from unittest import mock
 
+import ddt
 from oslo_utils import timeutils
 
 from cinder import context as ctxt
diff -pruN 2:15.0.1-1/cinder/tests/unit/image/test_glance.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/image/test_glance.py
--- 2:15.0.1-1/cinder/tests/unit/image/test_glance.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/image/test_glance.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,14 +16,14 @@
 
 import datetime
 import itertools
-import six
+from unittest import mock
 
 import ddt
 import glanceclient.exc
 from keystoneauth1.loading import session as ks_session
 from keystoneauth1 import session
-import mock
 from oslo_config import cfg
+import six
 
 from cinder import context
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/keymgr/test_migration.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/keymgr/test_migration.py
--- 2:15.0.1-1/cinder/tests/unit/keymgr/test_migration.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/keymgr/test_migration.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,7 +14,8 @@
 # under the License.
 """Tests for encryption key migration."""
 
-import mock
+from unittest import mock
+
 from oslo_config import cfg
 
 from cinder import db
diff -pruN 2:15.0.1-1/cinder/tests/unit/message/test_api.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/message/test_api.py
--- 2:15.0.1-1/cinder/tests/unit/message/test_api.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/message/test_api.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,8 +10,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 import datetime
+from unittest import mock
 
-import mock
 from oslo_config import cfg
 from oslo_utils import timeutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/message/test_message_field.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/message/test_message_field.py
--- 2:15.0.1-1/cinder/tests/unit/message/test_message_field.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/message/test_message_field.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,10 +10,10 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import ddt
 import inspect
 from itertools import chain
 
+import ddt
 from oslo_config import cfg
 
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/objects/test_backup.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_backup.py
--- 2:15.0.1-1/cinder/tests/unit/objects/test_backup.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_backup.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
+
 from oslo_utils import timeutils
 import pytz
 import six
@@ -143,6 +144,19 @@ class TestBackup(test_objects.BaseObject
                                 metadata={'test_key': 'test_value'})
         self.assertEqual({'test_key': 'test_value'}, backup.metadata)
 
+    @mock.patch('cinder.objects.backup.Backup.get_by_id',
+                return_value=None)
+    def test_obj_field_parent(self, mock_lzy_ld):
+        backup = objects.Backup(context=self.context,
+                                parent_id=None)
+        self.assertIsNone(backup.parent)
+
+        # Bug #1862635: should trigger a lazy load
+        backup = objects.Backup(context=self.context,
+                                parent_id=fake.UUID5)
+        _ = backup.parent
+        mock_lzy_ld.assert_called_once()
+
     def test_import_record(self):
         utils.replace_obj_loader(self, objects.Backup)
         backup = objects.Backup(context=self.context, id=fake.BACKUP_ID,
@@ -154,6 +168,24 @@ class TestBackup(test_objects.BaseObject
         # Make sure we don't lose data when converting from string
         self.assertDictEqual(self._expected_backup(backup), imported_backup)
 
+    @mock.patch('cinder.db.get_by_id', return_value=fake_backup)
+    def test_import_record_w_parent(self, backup_get):
+        full_backup = objects.Backup.get_by_id(self.context, fake.USER_ID)
+        self._compare(self, fake_backup, full_backup)
+
+        utils.replace_obj_loader(self, objects.Backup)
+        incr_backup = objects.Backup(context=self.context,
+                                     id=fake.BACKUP2_ID,
+                                     parent=full_backup,
+                                     parent_id=full_backup['id'],
+                                     num_dependent_backups=0)
+        export_string = incr_backup.encode_record()
+        imported_backup = objects.Backup.decode_record(export_string)
+
+        # Make sure we don't lose data when converting from string
+        self.assertDictEqual(self._expected_backup(incr_backup),
+                             imported_backup)
+
     def test_import_record_additional_info(self):
         utils.replace_obj_loader(self, objects.Backup)
         backup = objects.Backup(context=self.context, id=fake.BACKUP_ID,
@@ -175,7 +207,7 @@ class TestBackup(test_objects.BaseObject
 
     def _expected_backup(self, backup):
         record = {name: field.to_primitive(backup, name, getattr(backup, name))
-                  for name, field in backup.fields.items()}
+                  for name, field in backup.fields.items() if name != 'parent'}
         return record
 
     def test_import_record_additional_info_cant_overwrite(self):
diff -pruN 2:15.0.1-1/cinder/tests/unit/objects/test_base.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_base.py
--- 2:15.0.1-1/cinder/tests/unit/objects/test_base.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_base.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,11 +13,11 @@
 #    under the License.
 
 import datetime
-import ddt
+from unittest import mock
 import uuid
 
+import ddt
 from iso8601 import iso8601
-import mock
 from oslo_versionedobjects import fields
 from sqlalchemy import sql
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/objects/test_cgsnapshot.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_cgsnapshot.py
--- 2:15.0.1-1/cinder/tests/unit/objects/test_cgsnapshot.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_cgsnapshot.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
+
 from oslo_utils import timeutils
 import pytz
 import six
diff -pruN 2:15.0.1-1/cinder/tests/unit/objects/test_cleanable.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_cleanable.py
--- 2:15.0.1-1/cinder/tests/unit/objects/test_cleanable.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_cleanable.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,8 +14,7 @@
 #    under the License.
 
 import inspect
-
-import mock
+from unittest import mock
 
 from cinder import context
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/objects/test_cleanup_request.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_cleanup_request.py
--- 2:15.0.1-1/cinder/tests/unit/objects/test_cleanup_request.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_cleanup_request.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 from oslo_utils import timeutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/objects/test_cluster.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_cluster.py
--- 2:15.0.1-1/cinder/tests/unit/objects/test_cluster.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_cluster.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 from oslo_utils import timeutils
 
 import cinder.db
diff -pruN 2:15.0.1-1/cinder/tests/unit/objects/test_consistencygroup.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_consistencygroup.py
--- 2:15.0.1-1/cinder/tests/unit/objects/test_consistencygroup.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_consistencygroup.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,8 @@
 # License for the specific language governing permissions and limitations
 # under the License.
 
-import mock
+from unittest import mock
+
 from oslo_utils import timeutils
 import pytz
 import six
diff -pruN 2:15.0.1-1/cinder/tests/unit/objects/test_group.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_group.py
--- 2:15.0.1-1/cinder/tests/unit/objects/test_group.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_group.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,8 +12,9 @@
 # License for the specific language governing permissions and limitations
 # under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 import six
 
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/objects/test_group_snapshot.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_group_snapshot.py
--- 2:15.0.1-1/cinder/tests/unit/objects/test_group_snapshot.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_group_snapshot.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
+
 from oslo_utils import timeutils
 import pytz
 import six
diff -pruN 2:15.0.1-1/cinder/tests/unit/objects/test_group_type.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_group_type.py
--- 2:15.0.1-1/cinder/tests/unit/objects/test_group_type.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_group_type.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
+
 import six
 
 from cinder import objects
diff -pruN 2:15.0.1-1/cinder/tests/unit/objects/test_qos.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_qos.py
--- 2:15.0.1-1/cinder/tests/unit/objects/test_qos.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_qos.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,7 +10,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
+
 from oslo_utils import timeutils
 import pytz
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/objects/test_service.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_service.py
--- 2:15.0.1-1/cinder/tests/unit/objects/test_service.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_service.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,9 @@
 #    under the License.
 
 import datetime
+from unittest import mock
+
 import ddt
-import mock
 from oslo_utils import timeutils
 import pytz
 import six
diff -pruN 2:15.0.1-1/cinder/tests/unit/objects/test_snapshot.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_snapshot.py
--- 2:15.0.1-1/cinder/tests/unit/objects/test_snapshot.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_snapshot.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,9 +13,9 @@
 #    under the License.
 
 import copy
+from unittest import mock
 
 import ddt
-import mock
 from oslo_utils import timeutils
 import pytz
 import six
diff -pruN 2:15.0.1-1/cinder/tests/unit/objects/test_volume_attachment.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_volume_attachment.py
--- 2:15.0.1-1/cinder/tests/unit/objects/test_volume_attachment.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_volume_attachment.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,8 +12,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 import six
 from sqlalchemy.orm import attributes
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/objects/test_volume.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_volume.py
--- 2:15.0.1-1/cinder/tests/unit/objects/test_volume.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_volume.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,8 +12,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 from oslo_utils import timeutils
 import pytz
 import six
diff -pruN 2:15.0.1-1/cinder/tests/unit/objects/test_volume_type.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_volume_type.py
--- 2:15.0.1-1/cinder/tests/unit/objects/test_volume_type.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/objects/test_volume_type.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,8 +12,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 from oslo_utils import timeutils
 import pytz
 import six
diff -pruN 2:15.0.1-1/cinder/tests/unit/policies/test_base.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/policies/test_base.py
--- 2:15.0.1-1/cinder/tests/unit/policies/test_base.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/policies/test_base.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,9 +12,9 @@
 #    under the License.
 
 import uuid
-import webob
 
 from oslo_serialization import jsonutils
+import webob
 
 from cinder.api import microversions as mv
 from cinder import context as cinder_context
diff -pruN 2:15.0.1-1/cinder/tests/unit/policies/test_volume_actions.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/policies/test_volume_actions.py
--- 2:15.0.1-1/cinder/tests/unit/policies/test_volume_actions.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/policies/test_volume_actions.py	2020-03-24 18:46:31.000000000 +0000
@@ -11,7 +11,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
+
 from six.moves import http_client
 
 from cinder.api import microversions as mv
diff -pruN 2:15.0.1-1/cinder/tests/unit/policies/test_volume_metadata.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/policies/test_volume_metadata.py
--- 2:15.0.1-1/cinder/tests/unit/policies/test_volume_metadata.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/policies/test_volume_metadata.py	2020-03-24 18:46:31.000000000 +0000
@@ -11,7 +11,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
+
 from six.moves import http_client
 
 from cinder.tests.unit.policies import test_base
diff -pruN 2:15.0.1-1/cinder/tests/unit/policies/test_volume.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/policies/test_volume.py
--- 2:15.0.1-1/cinder/tests/unit/policies/test_volume.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/policies/test_volume.py	2020-03-24 18:46:31.000000000 +0000
@@ -11,7 +11,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
+
 from six.moves import http_client
 
 from cinder.tests.unit import fake_constants
diff -pruN 2:15.0.1-1/cinder/tests/unit/scheduler/test_allocated_capacity_weigher.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_allocated_capacity_weigher.py
--- 2:15.0.1-1/cinder/tests/unit/scheduler/test_allocated_capacity_weigher.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_allocated_capacity_weigher.py	2020-03-24 18:46:31.000000000 +0000
@@ -17,7 +17,7 @@
 Tests For Allocated Capacity Weigher.
 """
 
-import mock
+from unittest import mock
 
 from cinder.common import constants
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/scheduler/test_base_filter.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_base_filter.py
--- 2:15.0.1-1/cinder/tests/unit/scheduler/test_base_filter.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_base_filter.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,7 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-import mock
+from unittest import mock
 
 from cinder.scheduler import base_filter
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/scheduler/test_capacity_weigher.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_capacity_weigher.py
--- 2:15.0.1-1/cinder/tests/unit/scheduler/test_capacity_weigher.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_capacity_weigher.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,13 +12,11 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Tests For Capacity Weigher.
-"""
+"""Tests For Capacity Weigher."""
 from datetime import datetime
+from unittest import mock
 
 import ddt
-import mock
 
 from cinder.common import constants
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/scheduler/test_chance_weigher.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_chance_weigher.py
--- 2:15.0.1-1/cinder/tests/unit/scheduler/test_chance_weigher.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_chance_weigher.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,7 +15,7 @@
 Tests For Chance Weigher.
 """
 
-import mock
+from unittest import mock
 
 from cinder.scheduler import host_manager
 from cinder.scheduler.weights import chance
diff -pruN 2:15.0.1-1/cinder/tests/unit/scheduler/test_filter_scheduler.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_filter_scheduler.py
--- 2:15.0.1-1/cinder/tests/unit/scheduler/test_filter_scheduler.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_filter_scheduler.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,12 +12,11 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Tests For Filter Scheduler.
-"""
+"""Tests For Filter Scheduler."""
+
+from unittest import mock
 
 import ddt
-import mock
 
 from cinder import context
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/scheduler/test_host_filters.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_host_filters.py
--- 2:15.0.1-1/cinder/tests/unit/scheduler/test_host_filters.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_host_filters.py	2020-03-24 18:46:31.000000000 +0000
@@ -11,12 +11,11 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Tests For Scheduler Host Filters.
-"""
+"""Tests For Scheduler Host Filters."""
+
+from unittest import mock
 
 import ddt
-import mock
 from oslo_serialization import jsonutils
 from requests import exceptions as request_exceptions
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/scheduler/test_host_manager.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_host_manager.py
--- 2:15.0.1-1/cinder/tests/unit/scheduler/test_host_manager.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_host_manager.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,15 +12,13 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Tests For HostManager
-"""
+"""Tests For HostManager."""
 
 from datetime import datetime
 from datetime import timedelta
-import ddt
+from unittest import mock
 
-import mock
+import ddt
 from oslo_serialization import jsonutils
 from oslo_utils import timeutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/scheduler/test_rpcapi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_rpcapi.py
--- 2:15.0.1-1/cinder/tests/unit/scheduler/test_rpcapi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_rpcapi.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,19 +13,18 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Unit Tests for cinder.scheduler.rpcapi
-"""
+"""Unit Tests for cinder.scheduler.rpcapi."""
 
 from datetime import datetime
+from unittest import mock
 
 import ddt
-import mock
 
 from cinder import exception
 from cinder import objects
 from cinder.scheduler import rpcapi as scheduler_rpcapi
 from cinder import test
+from cinder.tests.unit.backup import fake_backup
 from cinder.tests.unit import fake_constants
 from cinder.tests.unit import fake_snapshot
 from cinder.tests.unit import fake_volume
@@ -46,6 +45,7 @@ class SchedulerRPCAPITestCase(test.RPCAP
         self.fake_rs_obj = objects.RequestSpec.from_primitives({})
         self.fake_rs_dict = {'volume_id': self.volume_id}
         self.fake_fp_dict = {'availability_zone': 'fake_az'}
+        self.fake_backup_dict = fake_backup.fake_backup_obj(self.context)
 
     @ddt.data('3.0', '3.3')
     @mock.patch('oslo_messaging.RPCClient.can_send_version')
@@ -301,3 +301,11 @@ class SchedulerRPCAPITestCase(test.RPCAP
                            service=service,
                            log_request='log_request',
                            version='3.7')
+
+    @mock.patch('oslo_messaging.RPCClient.can_send_version')
+    def test_create_backup(self, can_send_version):
+        self._test_rpc_api('create_backup',
+                           rpc_method='cast',
+                           backup=self.fake_backup_dict)
+
+        can_send_version.assert_called_once_with('3.12')
diff -pruN 2:15.0.1-1/cinder/tests/unit/scheduler/test_scheduler.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_scheduler.py
--- 2:15.0.1-1/cinder/tests/unit/scheduler/test_scheduler.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_scheduler.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,15 +13,14 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Tests For Scheduler
-"""
+"""Tests For Scheduler."""
 
 import collections
 import copy
 from datetime import datetime
+from unittest import mock
+
 import ddt
-import mock
 from oslo_config import cfg
 
 from cinder.common import constants
@@ -32,6 +31,7 @@ from cinder import objects
 from cinder.scheduler import driver
 from cinder.scheduler import manager
 from cinder import test
+from cinder.tests.unit.backup import fake_backup
 from cinder.tests.unit import fake_constants as fake
 from cinder.tests.unit import fake_volume
 from cinder.tests.unit.scheduler import fakes as fake_scheduler
@@ -121,7 +121,8 @@ class SchedulerManagerTestCase(test.Test
     @mock.patch('cinder.objects.service.Service.get_minimum_obj_version')
     @mock.patch('cinder.rpc.LAST_RPC_VERSIONS', {'cinder-volume': '1.3'})
     @mock.patch('cinder.rpc.LAST_OBJ_VERSIONS', {'cinder-volume': '1.4',
-                                                 'cinder-scheduler': '1.4'})
+                                                 'cinder-scheduler': '1.4',
+                                                 'cinder-backup': '1.5'})
     def test_reset(self, get_min_obj, get_min_rpc):
         mgr = self.manager_cls()
 
@@ -583,6 +584,42 @@ class SchedulerManagerTestCase(test.Test
         self.assertEqual(1, vol_clean_mock.call_count)
         self.assertEqual(1, sch_clean_mock.call_count)
 
+    @mock.patch('cinder.backup.rpcapi.BackupAPI.create_backup')
+    @mock.patch('cinder.objects.backup.Backup.save')
+    @mock.patch('cinder.scheduler.driver.Scheduler.get_backup_host')
+    @mock.patch('cinder.db.volume_get')
+    def test_create_backup(self, mock_volume_get, mock_host, mock_save,
+                           mock_create):
+        volume = fake_volume.fake_db_volume()
+        mock_volume_get.return_value = volume
+        mock_host.return_value = 'cinder-backup'
+        backup = fake_backup.fake_backup_obj(self.context)
+
+        self.manager.create_backup(self.context, backup=backup)
+
+        mock_save.assert_called_once()
+        mock_host.assert_called_once_with(volume)
+        mock_volume_get.assert_called_once_with(self.context, backup.volume_id)
+        mock_create.assert_called_once_with(self.context, backup)
+
+    @mock.patch('cinder.volume.volume_utils.update_backup_error')
+    @mock.patch('cinder.scheduler.driver.Scheduler.get_backup_host')
+    @mock.patch('cinder.db.volume_get')
+    def test_create_backup_no_service(self, mock_volume_get, mock_host,
+                                      mock_error):
+        volume = fake_volume.fake_db_volume()
+        mock_volume_get.return_value = volume
+        mock_host.side_effect = exception.ServiceNotFound(
+            service_id='cinder-volume')
+        backup = fake_backup.fake_backup_obj(self.context)
+
+        self.manager.create_backup(self.context, backup=backup)
+
+        mock_host.assert_called_once_with(volume)
+        mock_volume_get.assert_called_once_with(self.context, backup.volume_id)
+        mock_error.assert_called_once_with(
+            backup, 'Service not found for creating backup.')
+
 
 class SchedulerTestCase(test.TestCase):
     """Test case for base scheduler driver class."""
diff -pruN 2:15.0.1-1/cinder/tests/unit/scheduler/test_stochastic_weight_handler.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_stochastic_weight_handler.py
--- 2:15.0.1-1/cinder/tests/unit/scheduler/test_stochastic_weight_handler.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_stochastic_weight_handler.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,13 +10,12 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Tests for stochastic weight handler
-"""
+"""Tests for stochastic weight handler."""
 
-import ddt
 import random
 
+import ddt
+
 from cinder.scheduler import base_weight
 from cinder.scheduler.weights.stochastic import StochasticHostWeightHandler
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/scheduler/test_volume_number_weigher.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_volume_number_weigher.py
--- 2:15.0.1-1/cinder/tests/unit/scheduler/test_volume_number_weigher.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/scheduler/test_volume_number_weigher.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,7 +16,7 @@
 Tests For Volume Number Weigher.
 """
 
-import mock
+from unittest import mock
 
 from cinder.common import constants
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/targets/targets_fixture.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/targets_fixture.py
--- 2:15.0.1-1/cinder/tests/unit/targets/targets_fixture.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/targets_fixture.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,8 +14,8 @@ import copy
 import os
 import shutil
 import tempfile
+from unittest import mock
 
-import mock
 from oslo_utils import fileutils
 from oslo_utils import timeutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/targets/test_base_iscsi_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_base_iscsi_driver.py
--- 2:15.0.1-1/cinder/tests/unit/targets/test_base_iscsi_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_base_iscsi_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,7 +10,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
+
 from oslo_config import cfg
 
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/targets/test_cxt_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_cxt_driver.py
--- 2:15.0.1-1/cinder/tests/unit/targets/test_cxt_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_cxt_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,8 +15,7 @@
 
 import os
 import sys
-
-import mock
+from unittest import mock
 
 from cinder import context
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/targets/test_iet_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_iet_driver.py
--- 2:15.0.1-1/cinder/tests/unit/targets/test_iet_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_iet_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -11,14 +11,13 @@
 #    under the License.
 
 import contextlib
+from unittest import mock
 
-import mock
 from oslo_concurrency import processutils as putils
 import six
 
 from cinder import context
 from cinder import exception
-
 from cinder.tests.unit.targets import targets_fixture as tf
 from cinder import utils
 from cinder.volume.targets import iet
diff -pruN 2:15.0.1-1/cinder/tests/unit/targets/test_iser_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_iser_driver.py
--- 2:15.0.1-1/cinder/tests/unit/targets/test_iser_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_iser_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,7 +10,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 from cinder.tests.unit.targets import targets_fixture as tf
 from cinder import utils
diff -pruN 2:15.0.1-1/cinder/tests/unit/targets/test_lio_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_lio_driver.py
--- 2:15.0.1-1/cinder/tests/unit/targets/test_lio_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_lio_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,7 +10,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
+
 from oslo_concurrency import processutils as putils
 
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/targets/test_nvmeof_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_nvmeof_driver.py
--- 2:15.0.1-1/cinder/tests/unit/targets/test_nvmeof_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_nvmeof_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,7 +10,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 from oslo_utils import timeutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/targets/test_nvmet_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_nvmet_driver.py
--- 2:15.0.1-1/cinder/tests/unit/targets/test_nvmet_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_nvmet_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,7 +10,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 from oslo_utils import timeutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/targets/test_scst_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_scst_driver.py
--- 2:15.0.1-1/cinder/tests/unit/targets/test_scst_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_scst_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,7 +10,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 from cinder import context
 from cinder.tests.unit.targets import targets_fixture as tf
diff -pruN 2:15.0.1-1/cinder/tests/unit/targets/test_spdknvmf.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_spdknvmf.py
--- 2:15.0.1-1/cinder/tests/unit/targets/test_spdknvmf.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_spdknvmf.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,7 @@
 
 import copy
 import json
-import mock
+from unittest import mock
 
 from cinder import test
 from cinder.volume import configuration as conf
@@ -220,16 +220,16 @@ class JSONRPCException(Exception):
 
 class JSONRPCClient(object):
     def __init__(self, addr=None, port=None):
-        self.methods = {"get_bdevs": self.get_bdevs,
+        self.methods = {"bdev_get_bdevs": self.get_bdevs,
                         "construct_nvmf_subsystem":
                             self.construct_nvmf_subsystem,
-                        "delete_nvmf_subsystem": self.delete_nvmf_subsystem,
-                        "nvmf_subsystem_create": self.nvmf_subsystem_create,
+                        "nvmf_delete_subsystem": self.delete_nvmf_subsystem,
+                        "nvmf_create_subsystem": self.nvmf_subsystem_create,
                         "nvmf_subsystem_add_listener":
                             self.nvmf_subsystem_add_listener,
                         "nvmf_subsystem_add_ns":
                             self.nvmf_subsystem_add_ns,
-                        "get_nvmf_subsystems": self.get_nvmf_subsystems}
+                        "nvmf_get_subsystems": self.get_nvmf_subsystems}
         self.bdevs = copy.deepcopy(BDEVS)
         self.nvmf_subsystems = copy.deepcopy(NVMF_SUBSYSTEMS)
 
@@ -362,7 +362,7 @@ class SpdkNvmfDriverTestCase(test.TestCa
     def test__get_spdk_volume_name(self):
         with mock.patch.object(self.driver, "_rpc_call",
                                self.jsonrpcclient.call):
-            bdevs = self.driver._rpc_call("get_bdevs")
+            bdevs = self.driver._rpc_call("bdev_get_bdevs")
             bdev_name = bdevs[0]['name']
             volume_name = self.driver._get_spdk_volume_name(bdev_name)
             self.assertEqual(bdev_name, volume_name)
@@ -373,7 +373,7 @@ class SpdkNvmfDriverTestCase(test.TestCa
         with mock.patch.object(self.driver, "_rpc_call",
                                self.jsonrpcclient.call):
             nqn = self.driver._get_nqn_with_volume_name("Nvme0n1p0")
-            nqn_tmp = self.driver._rpc_call("get_nvmf_subsystems")[1]['nqn']
+            nqn_tmp = self.driver._rpc_call("nvmf_get_subsystems")[1]['nqn']
             self.assertEqual(nqn, nqn_tmp)
             nqn = self.driver._get_nqn_with_volume_name("fake")
             self.assertIsNone(nqn)
@@ -387,21 +387,21 @@ class SpdkNvmfDriverTestCase(test.TestCa
     def test_create_nvmeof_target(self):
         with mock.patch.object(self.driver, "_rpc_call",
                                self.jsonrpcclient.call):
-            subsystems_first = self.driver._rpc_call("get_nvmf_subsystems")
+            subsystems_first = self.driver._rpc_call("nvmf_get_subsystems")
             self.driver.create_nvmeof_target("Nvme0n1p1",
                                              "nqn.2016-06.io.spdk",
                                              "192.168.0.1",
                                              4420, "rdma", -1, -1, "")
-            subsystems_last = self.driver._rpc_call("get_nvmf_subsystems")
+            subsystems_last = self.driver._rpc_call("nvmf_get_subsystems")
             self.assertEqual(len(subsystems_first) + 1, len(subsystems_last))
 
     def test_delete_nvmeof_target(self):
         with mock.patch.object(self.driver, "_rpc_call",
                                self.jsonrpcclient.call):
-            subsystems_first = self.driver._rpc_call("get_nvmf_subsystems")
+            subsystems_first = self.driver._rpc_call("nvmf_get_subsystems")
             target = Target()
             self.driver.delete_nvmeof_target(target)
-            subsystems_last = self.driver._rpc_call("get_nvmf_subsystems")
+            subsystems_last = self.driver._rpc_call("nvmf_get_subsystems")
             self.assertEqual(len(subsystems_first) - 1, len(subsystems_last))
             target.name = "fake"
             self.driver.delete_nvmeof_target(target)
diff -pruN 2:15.0.1-1/cinder/tests/unit/targets/test_tgt_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_tgt_driver.py
--- 2:15.0.1-1/cinder/tests/unit/targets/test_tgt_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/targets/test_tgt_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,8 @@
 import os
 import sys
 import time
+from unittest import mock
 
-import mock
 from oslo_concurrency import processutils as putils
 
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_api_urlmap.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_api_urlmap.py
--- 2:15.0.1-1/cinder/tests/unit/test_api_urlmap.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_api_urlmap.py	2020-03-24 18:46:31.000000000 +0000
@@ -17,7 +17,7 @@
 Tests for cinder.api.urlmap.py
 """
 
-import mock
+from unittest import mock
 
 from cinder.api import urlmap
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_cleanable_manager.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_cleanable_manager.py
--- 2:15.0.1-1/cinder/tests/unit/test_cleanable_manager.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_cleanable_manager.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 from oslo_utils import timeutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_cmd.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_cmd.py
--- 2:15.0.1-1/cinder/tests/unit/test_cmd.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_cmd.py	2020-03-24 18:46:31.000000000 +0000
@@ -11,13 +11,14 @@
 #    under the License.
 
 import datetime
-import iso8601
+import re
 import sys
 import time
+from unittest import mock
 
 import ddt
 import fixtures
-import mock
+import iso8601
 from oslo_config import cfg
 from oslo_db import exception as oslo_exception
 from oslo_utils import timeutils
@@ -109,10 +110,12 @@ class TestCinderBackupCmd(test.TestCase)
 
         c1 = mock.call(binary=constants.BACKUP_BINARY,
                        coordination=True,
-                       process_number=1)
+                       process_number=1,
+                       service_name='backup')
         c2 = mock.call(binary=constants.BACKUP_BINARY,
                        coordination=True,
-                       process_number=2)
+                       process_number=2,
+                       service_name='backup')
         service_create.assert_has_calls([c1, c2])
 
         launcher = get_launcher.return_value
@@ -421,22 +424,28 @@ class TestCinderManageCmd(test.TestCase)
         exit = self.assertRaises(SystemExit,
                                  command.online_data_migrations, 10)
         self.assertEqual(1, exit.code)
-        expected = """\
-5 rows matched query mock_mig_1, 4 migrated
-6 rows matched query mock_mig_2, 6 migrated
-+------------+--------------+-----------+
-| Migration  | Total Needed | Completed |
-+------------+--------------+-----------+
-| mock_mig_1 |      5       |     4     |
-| mock_mig_2 |      6       |     6     |
-+------------+--------------+-----------+
-"""
         command.online_migrations[0].assert_has_calls([mock.call(ctxt,
                                                                  10)])
         command.online_migrations[1].assert_has_calls([mock.call(ctxt,
                                                                  6)])
 
-        self.assertEqual(expected, sys.stdout.getvalue())
+        output = sys.stdout.getvalue()
+        matches = re.findall(
+            '5 rows matched query mock_mig_1, 4 migrated',
+            output, re.MULTILINE)
+        self.assertEqual(len(matches), 1)
+        matches = re.findall(
+            '6 rows matched query mock_mig_2, 6 migrated',
+            output, re.MULTILINE)
+        self.assertEqual(len(matches), 1)
+        matches = re.findall(
+            'mock_mig_1 .* 5 .* 4',
+            output, re.MULTILINE)
+        self.assertEqual(len(matches), 1)
+        matches = re.findall(
+            'mock_mig_2 .* 6 .* 6',
+            output, re.MULTILINE)
+        self.assertEqual(len(matches), 1)
 
     @mock.patch('cinder.context.get_admin_context')
     def test_online_migrations_no_max_count(self, mock_get_context):
@@ -456,19 +465,24 @@ class TestCinderManageCmd(test.TestCase)
         exit = self.assertRaises(SystemExit,
                                  command.online_data_migrations, None)
         self.assertEqual(0, exit.code)
-        expected = """\
-Running batches of 50 until complete.
-120 rows matched query fake_migration, 50 migrated
-120 rows matched query fake_migration, 50 migrated
-120 rows matched query fake_migration, 20 migrated
-120 rows matched query fake_migration, 0 migrated
-+----------------+--------------+-----------+
-|   Migration    | Total Needed | Completed |
-+----------------+--------------+-----------+
-| fake_migration |     120      |    120    |
-+----------------+--------------+-----------+
-"""
-        self.assertEqual(expected, sys.stdout.getvalue())
+        output = sys.stdout.getvalue()
+        self.assertIn('Running batches of 50 until complete.', output)
+        matches = re.findall(
+            '120 rows matched query fake_migration, 50 migrated',
+            output, re.MULTILINE)
+        self.assertEqual(len(matches), 2)
+        matches = re.findall(
+            '120 rows matched query fake_migration, 20 migrated',
+            output, re.MULTILINE)
+        self.assertEqual(len(matches), 1)
+        matches = re.findall(
+            '120 rows matched query fake_migration, 0 migrated',
+            output, re.MULTILINE)
+        self.assertEqual(len(matches), 1)
+        matches = re.findall(
+            'fake_migration .* 120 .* 120',
+            output, re.MULTILINE)
+        self.assertEqual(len(matches), 1)
 
     @mock.patch('cinder.context.get_admin_context')
     def test_online_migrations_error(self, mock_get_context):
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_context.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_context.py
--- 2:15.0.1-1/cinder/tests/unit/test_context.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_context.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 
 from cinder import context
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_coordination.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_coordination.py
--- 2:15.0.1-1/cinder/tests/unit/test_coordination.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_coordination.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,8 +14,8 @@
 #    under the License.
 
 import inspect
+from unittest import mock
 
-import mock
 import tooz.coordination
 import tooz.locking
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_db_api.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_db_api.py
--- 2:15.0.1-1/cinder/tests/unit/test_db_api.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_db_api.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,13 +13,12 @@
 
 """Unit tests for cinder.db.api."""
 
-
 import datetime
+import enum
+from unittest import mock
+from unittest.mock import call
 
 import ddt
-import enum
-import mock
-from mock import call
 from oslo_config import cfg
 from oslo_utils import timeutils
 from oslo_utils import uuidutils
@@ -658,6 +657,13 @@ class DBAPIVolumeTestCase(BaseTest):
         self.assertRaises(exception.VolumeNotFound, db.volume_get,
                           self.ctxt, volume['id'])
 
+    @mock.patch('cinder.db.sqlalchemy.api.model_query')
+    def test_volume_destroy_deletes_dependent_data(self, mock_model_query):
+        """Addresses LP Bug #1542169."""
+        db.volume_destroy(self.ctxt, fake.VOLUME_ID)
+        expected_call_count = 1 + len(sqlalchemy_api.VOLUME_DEPENDENT_MODELS)
+        self.assertEqual(expected_call_count, mock_model_query.call_count)
+
     def test_volume_get_all(self):
         volumes = [db.volume_create(self.ctxt,
                    {'host': 'h%d' % i, 'size': i,
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_db_worker_api.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_db_worker_api.py
--- 2:15.0.1-1/cinder/tests/unit/test_db_worker_api.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_db_worker_api.py	2020-03-24 18:46:31.000000000 +0000
@@ -17,9 +17,9 @@
 
 from datetime import datetime
 import time
+from unittest import mock
 import uuid
 
-import mock
 from oslo_db import exception as db_exception
 import six
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_evaluator.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_evaluator.py
--- 2:15.0.1-1/cinder/tests/unit/test_evaluator.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_evaluator.py	2020-03-24 18:46:31.000000000 +0000
@@ -127,11 +127,12 @@ class EvaluatorTestCase(test.TestCase):
     def test_nonnumber_comparison(self):
         nonnumber = {'test': 'foo'}
         request = {'test': 'bar'}
-        self.assertRaises(
-            exception.EvaluatorParseException,
-            evaluator.evaluate,
-            "nonnumber.test != request.test",
-            nonnumber=nonnumber, request=request)
+        self.assertTrue(
+            evaluator.evaluate("nonnumber.test != request.test",
+                               nonnumber=nonnumber, request=request))
+        self.assertFalse(
+            evaluator.evaluate("nonnumber.test == request.test",
+                               nonnumber=nonnumber, request=request))
 
     def test_div_zero(self):
         self.assertRaises(exception.EvaluatorParseException,
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_exception.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_exception.py
--- 2:15.0.1-1/cinder/tests/unit/test_exception.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_exception.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,8 +15,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import fixtures
-import mock
 import six
 from six.moves import http_client
 import webob.util
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_hacking.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_hacking.py
--- 2:15.0.1-1/cinder/tests/unit/test_hacking.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_hacking.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,10 +12,10 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import ddt
 import textwrap
+from unittest import mock
 
-import mock
+import ddt
 import pycodestyle
 
 from cinder import test
@@ -80,8 +80,6 @@ class HackingTestCase(test.TestCase):
 
     def test_no_translate_logs(self):
         self.assertEqual(1, len(list(checks.no_translate_logs(
-            "LOG.audit(_('foo'))", "cinder/scheduler/foo.py"))))
-        self.assertEqual(1, len(list(checks.no_translate_logs(
             "LOG.debug(_('foo'))", "cinder/scheduler/foo.py"))))
         self.assertEqual(1, len(list(checks.no_translate_logs(
             "LOG.error(_('foo'))", "cinder/scheduler/foo.py"))))
@@ -219,77 +217,6 @@ class HackingTestCase(test.TestCase):
                                 expected_errors=[(2, 19, 'C311'),
                                                  (3, 18, 'C311')])
 
-    def test_str_unicode_exception(self):
-
-        checker = checks.CheckForStrUnicodeExc
-        code = """
-               def f(a, b):
-                   try:
-                       p = str(a) + str(b)
-                   except ValueError as e:
-                       p = str(e)
-                   return p
-               """
-        errors = [(5, 16, 'N325')]
-        self._assert_has_errors(code, checker, expected_errors=errors)
-
-        code = """
-               def f(a, b):
-                   try:
-                       p = unicode(a) + str(b)
-                   except ValueError as e:
-                       p = e
-                   return p
-               """
-        self._assert_has_no_errors(code, checker)
-
-        code = """
-               def f(a, b):
-                   try:
-                       p = str(a) + str(b)
-                   except ValueError as e:
-                       p = unicode(e)
-                   return p
-               """
-        errors = [(5, 20, 'N325')]
-        self._assert_has_errors(code, checker, expected_errors=errors)
-
-        code = """
-               def f(a, b):
-                   try:
-                       p = str(a) + str(b)
-                   except ValueError as e:
-                       try:
-                           p  = unicode(a) + unicode(b)
-                       except ValueError as ve:
-                           p = str(e) + str(ve)
-                       p = e
-                   return p
-               """
-        errors = [(8, 20, 'N325'), (8, 29, 'N325')]
-        self._assert_has_errors(code, checker, expected_errors=errors)
-
-        code = """
-               def f(a, b):
-                   try:
-                       p = str(a) + str(b)
-                   except ValueError as e:
-                       try:
-                           p  = unicode(a) + unicode(b)
-                       except ValueError as ve:
-                           p = str(e) + unicode(ve)
-                       p = str(e)
-                   return p
-               """
-        errors = [(8, 20, 'N325'), (8, 33, 'N325'), (9, 16, 'N325')]
-        self._assert_has_errors(code, checker, expected_errors=errors)
-
-    def test_check_no_log_audit(self):
-        self.assertEqual(1, len(list(checks.check_no_log_audit(
-            "LOG.audit('My test audit log')"))))
-        self.assertEqual(0, len(list(checks.check_no_log_audit(
-            "LOG.info('My info test log.')"))))
-
     def test_no_mutable_default_args(self):
         self.assertEqual(0, len(list(checks.no_mutable_default_args(
             "def foo (bar):"))))
@@ -371,9 +298,15 @@ class HackingTestCase(test.TestCase):
     def test_validate_assertTrue(self):
         test_value = True
         self.assertEqual(0, len(list(checks.validate_assertTrue(
-            "assertTrue(True)"))))
+            "assertTrue(True)", 'cinder/volume/stuff/a_file.py'))))
+        self.assertEqual(0, len(list(checks.validate_assertTrue(
+            "assertTrue(True)", 'cinder/tests/unit/test_file.py'))))
+        self.assertEqual(0, len(list(checks.validate_assertTrue(
+            "assertEqual(True, %s)" % test_value,
+            'cinder/volume/stuff/a_file.py'))))
         self.assertEqual(1, len(list(checks.validate_assertTrue(
-            "assertEqual(True, %s)" % test_value))))
+            "assertEqual(True, %s)" % test_value,
+            'cinder/tests/unit/test_file.py'))))
 
     @ddt.unpack
     @ddt.data(
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_image_utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_image_utils.py
--- 2:15.0.1-1/cinder/tests/unit/test_image_utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_image_utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,10 +14,10 @@
 
 import errno
 import math
+from unittest import mock
 
 import cryptography
 import ddt
-import mock
 from oslo_concurrency import processutils
 from oslo_utils import units
 from six.moves import builtins
@@ -762,7 +762,8 @@ class TestUploadVolume(test.TestCase):
         mock_proxy.assert_called_once_with(
             mock_open.return_value.__enter__.return_value)
         image_service.update.assert_called_once_with(
-            ctxt, image_meta['id'], {}, mock_proxy.return_value)
+            ctxt, image_meta['id'], {}, mock_proxy.return_value,
+            store_id=None)
 
     @mock.patch('eventlet.tpool.Proxy')
     @mock.patch('cinder.image.image_utils.utils.temporary_chown')
@@ -794,7 +795,8 @@ class TestUploadVolume(test.TestCase):
         mock_proxy.assert_called_once_with(
             mock_open.return_value.__enter__.return_value)
         image_service.update.assert_called_once_with(
-            ctxt, image_meta['id'], {}, mock_proxy.return_value)
+            ctxt, image_meta['id'], {}, mock_proxy.return_value,
+            store_id=None)
 
     @mock.patch('cinder.image.accelerator.ImageAccel._get_engine')
     @mock.patch('cinder.image.accelerator.ImageAccel.is_engine_ready',
@@ -849,7 +851,8 @@ class TestUploadVolume(test.TestCase):
         mock_proxy.assert_called_once_with(
             mock_open.return_value.__enter__.return_value)
         image_service.update.assert_called_once_with(
-            ctxt, image_meta['id'], {}, mock_proxy.return_value)
+            ctxt, image_meta['id'], {}, mock_proxy.return_value,
+            store_id=None)
         mock_engine.compress_img.assert_called()
 
     @mock.patch('eventlet.tpool.Proxy')
@@ -882,7 +885,8 @@ class TestUploadVolume(test.TestCase):
         mock_proxy.assert_called_once_with(
             mock_open.return_value.__enter__.return_value)
         image_service.update.assert_called_once_with(
-            ctxt, image_meta['id'], {}, mock_proxy.return_value)
+            ctxt, image_meta['id'], {}, mock_proxy.return_value,
+            store_id=None)
 
     @mock.patch('cinder.image.accelerator.ImageAccel._get_engine')
     @mock.patch('cinder.image.accelerator.ImageAccel.is_engine_ready',
@@ -938,7 +942,8 @@ class TestUploadVolume(test.TestCase):
         mock_proxy.assert_called_once_with(
             mock_open.return_value.__enter__.return_value)
         image_service.update.assert_called_once_with(
-            ctxt, image_meta['id'], {}, mock_proxy.return_value)
+            ctxt, image_meta['id'], {}, mock_proxy.return_value,
+            store_id=None)
         mock_engine.compress_img.assert_called()
 
     @mock.patch('cinder.image.image_utils.CONF')
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_interface.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_interface.py
--- 2:15.0.1-1/cinder/tests/unit/test_interface.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_interface.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 from cinder.interface import util
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_macrosan_drivers.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_macrosan_drivers.py
--- 2:15.0.1-1/cinder/tests/unit/test_macrosan_drivers.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_macrosan_drivers.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,9 +13,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 """Tests for macrosan drivers."""
-import mock
 import os
 import socket
+from unittest import mock
 
 from six.moves import UserDict
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_manager.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_manager.py
--- 2:15.0.1-1/cinder/tests/unit/test_manager.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_manager.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
+
 import six
 
 from cinder import manager
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_policy.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_policy.py
--- 2:15.0.1-1/cinder/tests/unit/test_policy.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_policy.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,19 +13,18 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 import os.path
+from unittest import mock
 
-import mock
 from oslo_config import cfg
 from oslo_config import fixture as config_fixture
 from oslo_policy import policy as oslo_policy
 
 from cinder import context
 from cinder import exception
+from cinder import policy
 from cinder import test
 from cinder import utils
 
-from cinder import policy
-
 CONF = cfg.CONF
 
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_qos_specs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_qos_specs.py
--- 2:15.0.1-1/cinder/tests/unit/test_qos_specs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_qos_specs.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,16 +13,14 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Unit Tests for qos specs internal API
-"""
+"""Unit Tests for qos specs internal API."""
 
-import mock
-import six
 import time
+from unittest import mock
 
 from oslo_db import exception as db_exc
 from oslo_utils import timeutils
+import six
 
 from cinder import context
 from cinder import db
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_quota.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_quota.py
--- 2:15.0.1-1/cinder/tests/unit/test_quota.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_quota.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,8 +16,8 @@
 #    under the License.
 
 import datetime
+from unittest import mock
 
-import mock
 from oslo_config import cfg
 from oslo_config import fixture as config_fixture
 from oslo_utils import timeutils
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_quota_utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_quota_utils.py
--- 2:15.0.1-1/cinder/tests/unit/test_quota_utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_quota_utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,17 +13,17 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
+
+from keystoneclient import exceptions
+from oslo_config import cfg
+from oslo_config import fixture as config_fixture
 
 from cinder import context
 from cinder import exception
 from cinder import quota_utils
 from cinder import test
 
-from keystoneclient import exceptions
-
-from oslo_config import cfg
-from oslo_config import fixture as config_fixture
 
 CONF = cfg.CONF
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_rpc.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_rpc.py
--- 2:15.0.1-1/cinder/tests/unit/test_rpc.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_rpc.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,8 +12,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 
 from cinder.objects import base
 from cinder import rpc
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_service_auth.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_service_auth.py
--- 2:15.0.1-1/cinder/tests/unit/test_service_auth.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_service_auth.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,18 +10,18 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 from keystoneauth1.identity.generic import password
 from keystoneauth1 import loading as ks_loading
 from keystoneauth1 import service_token
-import mock
+from oslo_config import cfg
 
 from cinder import context
 from cinder import exception
 from cinder import service_auth
 from cinder import test
 
-from oslo_config import cfg
-
 CONF = cfg.CONF
 
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_service.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_service.py
--- 2:15.0.1-1/cinder/tests/unit/test_service.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_service.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,12 +15,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Unit Tests for remote procedure calls using queue
-"""
+"""Unit Tests for remote procedure calls using queue."""
+
+from unittest import mock
 
 import ddt
-import mock
 from oslo_concurrency import processutils
 from oslo_config import cfg
 from oslo_db import exception as db_exc
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_setup_profiler.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_setup_profiler.py
--- 2:15.0.1-1/cinder/tests/unit/test_setup_profiler.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_setup_profiler.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 from cinder.common import constants
 from cinder import service
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_ssh_utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_ssh_utils.py
--- 2:15.0.1-1/cinder/tests/unit/test_ssh_utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_ssh_utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,10 +10,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
-import paramiko
+from unittest import mock
 import uuid
 
+import paramiko
+
 from cinder import exception
 from cinder import ssh_utils
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_test.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_test.py
--- 2:15.0.1-1/cinder/tests/unit/test_test.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_test.py	2020-03-24 18:46:31.000000000 +0000
@@ -17,7 +17,8 @@
 
 """Tests for the testing base code."""
 
-import mock
+from unittest import mock
+
 from oslo_config import cfg
 import oslo_messaging as messaging
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_utils.py
--- 2:15.0.1-1/cinder/tests/unit/test_utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,16 +12,15 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-
 import datetime
 import functools
 import json
 import os
 import sys
 import time
+from unittest import mock
 
 import ddt
-import mock
 from oslo_utils import timeutils
 import six
 from six.moves import range
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_volume_cleanup.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_volume_cleanup.py
--- 2:15.0.1-1/cinder/tests/unit/test_volume_cleanup.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_volume_cleanup.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,8 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-import mock
+from unittest import mock
+
 from oslo_config import cfg
 
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_volume_throttling.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_volume_throttling.py
--- 2:15.0.1-1/cinder/tests/unit/test_volume_throttling.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_volume_throttling.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,7 +15,7 @@
 
 """Tests for volume copy throttling helpers."""
 
-import mock
+from unittest import mock
 
 from cinder import test
 from cinder import utils
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_volume_transfer.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_volume_transfer.py
--- 2:15.0.1-1/cinder/tests/unit/test_volume_transfer.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_volume_transfer.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,8 +12,8 @@
 #    under the License.
 """Unit Tests for volume transfers."""
 
+from unittest import mock
 
-import mock
 from oslo_utils import timeutils
 
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_volume_types.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_volume_types.py
--- 2:15.0.1-1/cinder/tests/unit/test_volume_types.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_volume_types.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,10 +13,9 @@
 #    under the License.
 """Unit Tests for volume types code."""
 
-
 import datetime
-import mock
 import time
+from unittest import mock
 
 from oslo_db import exception as db_exc
 from oslo_utils import uuidutils
diff -pruN 2:15.0.1-1/cinder/tests/unit/test_volume_utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_volume_utils.py
--- 2:15.0.1-1/cinder/tests/unit/test_volume_utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/test_volume_utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -18,14 +18,14 @@
 
 import datetime
 import io
-import mock
-import six
+from unittest import mock
 
 from castellan import key_manager
 import ddt
 from oslo_concurrency import processutils
 from oslo_config import cfg
 from oslo_utils import units
+import six
 
 from cinder import context
 from cinder import db
diff -pruN 2:15.0.1-1/cinder/tests/unit/utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/utils.py
--- 2:15.0.1-1/cinder/tests/unit/utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,12 +14,11 @@
 #
 
 import datetime
-import fixtures
 import socket
-import sys
+from unittest import mock
 import uuid
 
-import mock
+import fixtures
 from oslo_config import cfg
 from oslo_service import loopingcall
 from oslo_utils import timeutils
@@ -443,7 +442,7 @@ file_spec = None
 
 
 def get_file_spec():
-    """Return a Python 2 and 3 compatible version of a 'file' spec.
+    """Return a 'file' spec.
 
     This is to be used anywhere that you need to do something such as
     mock.MagicMock(spec=file) to mock out something with the file attributes.
@@ -454,14 +453,9 @@ def get_file_spec():
     global file_spec
     # set on first use
     if file_spec is None:
-        if sys.version_info[0] == 3:
-            import _io
-            file_spec = list(set(dir(_io.TextIOWrapper)).union(
-                set(dir(_io.BytesIO))))
-        else:
-            # NOTE(jsbryant): Pep8 on py3 based systems will fail because
-            # 'file' has been removed.  Using noqa here to avoid the failure.
-            file_spec = file  # noqa
+        import _io
+        file_spec = list(set(dir(_io.TextIOWrapper)).union(
+            set(dir(_io.BytesIO))))
 
 
 def generate_timeout_series(timeout):
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/powermax_data.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/powermax_data.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/powermax_data.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/powermax_data.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,6 +14,7 @@
 #    under the License.
 
 from copy import deepcopy
+
 import six
 
 from cinder import context
@@ -39,10 +40,13 @@ class PowerMaxData(object):
     srp = 'SRP_1'
     srp2 = 'SRP_2'
     slo = 'Diamond'
+    slo_diamond = 'Diamond'
+    slo_silver = 'Silver'
     workload = 'DSS'
     port_group_name_f = 'OS-fibre-PG'
     port_group_name_i = 'OS-iscsi-PG'
     masking_view_name_f = 'OS-HostX-F-OS-fibre-PG-MV'
+    masking_view_name_Y_f = 'OS-HostY-F-OS-fibre-PG-MV'
     masking_view_name_i = 'OS-HostX-SRP_1-I-OS-iscsi-PG-MV'
     initiatorgroup_name_f = 'OS-HostX-F-IG'
     initiatorgroup_name_i = 'OS-HostX-I-IG'
@@ -55,6 +59,7 @@ class PowerMaxData(object):
     default_sg_no_slo = 'OS-no_SLO-SG'
     default_sg_compr_disabled = 'OS-SRP_1-Diamond-DSS-CD-SG'
     default_sg_re_enabled = 'OS-SRP_1-Diamond-DSS-RE-SG'
+    default_sg_no_slo_re_enabled = 'OS-SRP_1-Diamond-NONE-RE-SG'
     failed_resource = 'OS-failed-resource'
     fake_host = 'HostX@Backend#Diamond+DSS+SRP_1+000197800123'
     new_host = 'HostX@Backend#Silver+OLTP+SRP_1+000197800123'
@@ -80,6 +85,7 @@ class PowerMaxData(object):
     temp_snapvx = 'temp-00001-snapshot_for_clone'
     next_gen_ucode = 5978
     gvg_group_id = 'test-gvg'
+    sg_tags = 'production,test'
 
     # connector info
     wwpn1 = '123456789012345'
@@ -170,6 +176,11 @@ class PowerMaxData(object):
     provider_location5 = {'array': remote_array,
                           'device_id': device_id}
 
+    replication_update = (
+        {'replication_status': 'enabled',
+         'replication_driver_data': six.text_type(
+             {'array': remote_array, 'device_id': device_id2})})
+
     legacy_provider_location = {
         'classname': 'Symm_StorageVolume',
         'keybindings': {'CreationClassName': u'Symm_StorageVolume',
@@ -248,7 +259,7 @@ class PowerMaxData(object):
 
     test_volume_attachment = volume_attachment.VolumeAttachment(
         id='2b06255d-f5f0-4520-a953-b029196add6b', volume_id=test_volume.id,
-        connector=connector)
+        connector=connector, attached_host='HostX')
 
     location_info = {'location_info': '000197800123#SRP_1#Diamond#DSS',
                      'storage_protocol': 'FC'}
@@ -271,6 +282,12 @@ class PowerMaxData(object):
                    'interval': 3,
                    'retries': 120}
 
+    vol_type_extra_specs_tags = {
+        'storagetype:storagegrouptags': u'good, comma,  separated,list'}
+    vol_type_extra_specs_tags_bad = {
+        'storagetype:storagegrouptags': u'B&d, [list]'}
+    extra_specs_port_group_template = deepcopy(extra_specs)
+    extra_specs_port_group_template['port_group_template'] = 'portGroupName'
     extra_specs_migrate = deepcopy(extra_specs)
     extra_specs_migrate[utils.PORTGROUPNAME] = port_group_name_f
 
@@ -287,6 +304,10 @@ class PowerMaxData(object):
     rep_extra_specs['retries'] = 1
     rep_extra_specs['srp'] = srp2
     rep_extra_specs['rep_mode'] = 'Synchronous'
+    rep_extra_specs['sync_interval'] = 3
+    rep_extra_specs['sync_retries'] = 200
+    rep_extra_specs['rdf_group_label'] = rdf_group_name
+    rep_extra_specs['rdf_group_no'] = rdf_group_no
     rep_extra_specs2 = deepcopy(rep_extra_specs)
     rep_extra_specs2[utils.PORTGROUPNAME] = port_group_name_f
     rep_extra_specs3 = deepcopy(rep_extra_specs)
@@ -296,6 +317,8 @@ class PowerMaxData(object):
     rep_extra_specs4['rdf_group_label'] = rdf_group_name
     rep_extra_specs5 = deepcopy(rep_extra_specs2)
     rep_extra_specs5['target_array_model'] = 'VMAX250F'
+    rep_extra_specs6 = deepcopy(rep_extra_specs3)
+    rep_extra_specs6['target_array_model'] = 'PMAX2000'
 
     rep_extra_specs_ode = deepcopy(rep_extra_specs2)
     rep_extra_specs_ode['array'] = array
@@ -305,6 +328,39 @@ class PowerMaxData(object):
     rep_extra_specs_legacy = deepcopy(rep_extra_specs_ode)
     rep_extra_specs_legacy['mode'] = 'Synchronous'
 
+    extra_specs_tags = deepcopy(extra_specs)
+    extra_specs_tags.update({utils.STORAGE_GROUP_TAGS: sg_tags})
+
+    rep_extra_specs_mgmt = deepcopy(rep_extra_specs)
+    rep_extra_specs_mgmt['srp'] = srp
+    rep_extra_specs_mgmt['mgmt_sg_name'] = rdf_managed_async_grp
+    rep_extra_specs_mgmt['sg_name'] = default_sg_no_slo_re_enabled
+    rep_extra_specs_mgmt['rdf_group_no'] = rdf_group_no
+    rep_extra_specs_mgmt['rdf_group_label'] = rdf_group_name
+    rep_extra_specs_mgmt['target_array_model'] = array_model
+    rep_extra_specs_mgmt['slo'] = 'Diamond'
+    rep_extra_specs_mgmt['workload'] = 'NONE'
+    rep_extra_specs_mgmt['sync_interval'] = 2
+    rep_extra_specs_mgmt['sync_retries'] = 200
+
+    rep_extra_specs_metro = deepcopy(rep_extra_specs)
+    rep_extra_specs_metro[utils.REP_MODE] = utils.REP_METRO
+    rep_extra_specs_metro[utils.METROBIAS] = True
+    rep_extra_specs_metro['replication_enabled'] = '<is> True'
+
+    rep_config = {
+        'array': remote_array, 'srp': srp, 'portgroup': port_group_name_i,
+        'rdf_group_no': rdf_group_no, 'sync_retries': 200,
+        'sync_interval': 1, 'rdf_group_label': rdf_group_name,
+        'allow_extend': True, 'mode': utils.REP_METRO}
+
+    ex_specs_rep_config = deepcopy(rep_extra_specs_metro)
+    ex_specs_rep_config['array'] = array
+    ex_specs_rep_config['rep_config'] = rep_config
+
+    ex_specs_rep_config_no_extend = deepcopy(ex_specs_rep_config)
+    ex_specs_rep_config_no_extend['rep_config']['allow_extend'] = False
+
     test_volume_type_1 = volume_type.VolumeType(
         id='2b06255d-f5f0-4520-a953-b029196add6a', name='abc',
         extra_specs=extra_specs)
@@ -389,7 +445,9 @@ class PowerMaxData(object):
         'storagegroup_name': storagegroup_name_f,
         'volume_name': test_volume.name,
         'workload': workload,
-        'replication_enabled': False}
+        'replication_enabled': False,
+        'used_host_name': 'HostX',
+        'port_group_label': port_group_name_f}
 
     masking_view_dict_no_slo = deepcopy(masking_view_dict)
     masking_view_dict_no_slo.update(
@@ -412,6 +470,10 @@ class PowerMaxData(object):
          utils.OTHER_PARENT_SG: parent_sg_i, utils.FAST_SG:
              storagegroup_name_i, utils.NO_SLO_SG: no_slo_sg_name})
 
+    masking_view_dict_tags = deepcopy(masking_view_dict)
+    masking_view_dict_tags.update(
+        {'tag_list': sg_tags})
+
     # vmax data
     # sloprovisioning
     compression_info = {'symmetrixId': ['000197800128']}
@@ -539,6 +601,16 @@ class PowerMaxData(object):
                        'rdfGroupNumber': rdf_group_no,
                        'states': ['Failed Over']}]
 
+    sg_rdf_group_details = {
+        "storageGroupName": test_vol_grp_name,
+        "symmetrixId": array,
+        "volumeRdfTypes": ["R1"],
+        "modes": ["Asynchronous"],
+        "totalTracks": 8205,
+        "largerRdfSides": ["Equal"],
+        "rdfGroupNumber": 1,
+        "states": ["suspended"]}
+
     sg_list = {'storageGroupId': [storagegroup_name_f,
                                   defaultstoragegroup_name]}
 
@@ -617,6 +689,17 @@ class PowerMaxData(object):
                             'snapvx_source': 'false',
                             'storageGroupId': []}
 
+    volume_details_attached_async = (
+        {'cap_gb': 2,
+         'num_of_storage_groups': 1,
+         'volumeId': device_id,
+         'volume_identifier': 'OS-%s' % test_volume.id,
+         'wwn': volume_wwn,
+         'snapvx_target': 'false',
+         'snapvx_source': 'false',
+         'storageGroupId': [
+             rdf_managed_async_grp, storagegroup_name_f + '-RA']})
+
     volume_list = [
         {'id': '6b70de13-98c5-46b2-8f24-e4e96a8988fa',
          'count': 2,
@@ -750,6 +833,14 @@ class PowerMaxData(object):
                              'remoteVolumeState': 'Write Disabled',
                              'remoteSymmetrixId': remote_array}
 
+    rdf_group_vol_details_not_synced = {
+        'remoteRdfGroupNumber': rdf_group_no, 'localSymmetrixId': array,
+        'volumeConfig': 'RDF1+TDEV', 'localRdfGroupNumber': rdf_group_no,
+        'localVolumeName': device_id, 'rdfpairState': 'syncinprog',
+        'remoteVolumeName': device_id2, 'localVolumeState': 'Ready',
+        'rdfMode': 'Synchronous', 'remoteVolumeState': 'Write Disabled',
+        'remoteSymmetrixId': remote_array}
+
     # system
     job_list = [{'status': 'SUCCEEDED',
                  'jobId': '12345',
@@ -812,7 +903,8 @@ class PowerMaxData(object):
             'numStorageGroups': 0, 'reservationInfo': {'reserved': False},
             'encapsulated': False, 'formattedName': '00001',
             'system_resource': False, 'numSymDevMaskingViews': 0,
-            'nameModifier': "", 'configuration': 'TDEV'},
+            'nameModifier': "", "userDefinedIdentifier": "N/A",
+            'configuration': 'TDEV'},
             'maskingInfo': {'masked': False},
             'rdfInfo': {
                 'dynamicRDF': False, 'RDF': False,
@@ -837,7 +929,8 @@ class PowerMaxData(object):
             'reservationInfo': {'reserved': False}, 'mapped': False,
             'encapsulated': False, 'formattedName': '00001',
             'system_resource': False, 'numSymDevMaskingViews': 0,
-            'nameModifier': "", 'configuration': 'TDEV'},
+            'nameModifier': "", "userDefinedIdentifier": "N/A",
+            'configuration': 'TDEV'},
             'rdfInfo': {
                 'dynamicRDF': False, 'RDF': False,
                 'concurrentRDF': False,
@@ -860,7 +953,8 @@ class PowerMaxData(object):
             'reservationInfo': {'reserved': False}, 'mapped': False,
             'encapsulated': False, 'formattedName': '00002',
             'system_resource': False, 'numSymDevMaskingViews': 0,
-            'nameModifier': "", 'configuration': 'TDEV'},
+            'nameModifier': "", "userDefinedIdentifier": "N/A",
+            'configuration': 'TDEV'},
             'rdfInfo': {
                 'dynamicRDF': False, 'RDF': False,
                 'concurrentRDF': False,
@@ -883,7 +977,8 @@ class PowerMaxData(object):
             'reservationInfo': {'reserved': False}, 'mapped': False,
             'encapsulated': False, 'formattedName': '00003',
             'system_resource': False, 'numSymDevMaskingViews': 0,
-            'nameModifier': "", 'configuration': 'TDEV'},
+            'nameModifier': "", "userDefinedIdentifier": "N/A",
+            'configuration': 'TDEV'},
             'rdfInfo': {
                 'dynamicRDF': False, 'RDF': False,
                 'concurrentRDF': False,
@@ -906,7 +1001,8 @@ class PowerMaxData(object):
             'reservationInfo': {'reserved': False}, 'mapped': False,
             'encapsulated': False, 'formattedName': '00004',
             'system_resource': False, 'numSymDevMaskingViews': 0,
-            'nameModifier': "", 'configuration': 'TDEV'},
+            'nameModifier': "", "userDefinedIdentifier": "N/A",
+            'configuration': 'TDEV'},
             'rdfInfo': {
                 'dynamicRDF': False, 'RDF': False,
                 'concurrentRDF': False,
@@ -931,7 +1027,8 @@ class PowerMaxData(object):
             'numStorageGroups': 0, 'reservationInfo': {'reserved': False},
             'encapsulated': False, 'formattedName': '00001',
             'system_resource': False, 'numSymDevMaskingViews': 0,
-            'nameModifier': "", 'configuration': 'TDEV'},
+            'nameModifier': "", "userDefinedIdentifier": "N/A",
+            'configuration': 'TDEV'},
             'maskingInfo': {'masked': False},
             'rdfInfo': {
                 'dynamicRDF': False, 'RDF': False,
@@ -945,7 +1042,8 @@ class PowerMaxData(object):
             'numStorageGroups': 0, 'reservationInfo': {'reserved': False},
             'encapsulated': False, 'formattedName': '00002',
             'system_resource': False, 'numSymDevMaskingViews': 1,
-            'nameModifier': "", 'configuration': 'TDEV'},
+            'nameModifier': "", "userDefinedIdentifier": "N/A",
+            'configuration': 'TDEV'},
             'maskingInfo': {'masked': False},
             'rdfInfo': {
                 'dynamicRDF': False, 'RDF': False,
@@ -959,7 +1057,8 @@ class PowerMaxData(object):
             'numStorageGroups': 0, 'reservationInfo': {'reserved': False},
             'encapsulated': False, 'formattedName': '00003',
             'system_resource': False, 'numSymDevMaskingViews': 0,
-            'nameModifier': "", 'configuration': 'TDEV'},
+            'nameModifier': "", "userDefinedIdentifier": "N/A",
+            'configuration': 'TDEV'},
             'maskingInfo': {'masked': False},
             'rdfInfo': {
                 'dynamicRDF': False, 'RDF': False,
@@ -973,7 +1072,8 @@ class PowerMaxData(object):
             'numStorageGroups': 0, 'reservationInfo': {'reserved': False},
             'encapsulated': False, 'formattedName': '00004',
             'system_resource': False, 'numSymDevMaskingViews': 0,
-            'nameModifier': "", 'configuration': 'TDEV'},
+            'nameModifier': "", "userDefinedIdentifier": "N/A",
+            'configuration': 'TDEV'},
             'maskingInfo': {'masked': False},
             'rdfInfo': {
                 'dynamicRDF': False, 'RDF': False,
@@ -987,7 +1087,8 @@ class PowerMaxData(object):
             'numStorageGroups': 0, 'reservationInfo': {'reserved': False},
             'encapsulated': False, 'formattedName': '00005',
             'system_resource': False, 'numSymDevMaskingViews': 0,
-            'nameModifier': 'OS-vol', 'configuration': 'TDEV'},
+            'nameModifier': 'OS-vol', "userDefinedIdentifier": "OS-vol",
+            'configuration': 'TDEV'},
             'maskingInfo': {'masked': False},
             'rdfInfo': {
                 'dynamicRDF': False, 'RDF': False,
@@ -1032,9 +1133,12 @@ class PowerMaxData(object):
         "vp_saved_percent": 99.9
     }
 
+    storage_group_with_tags = deepcopy(add_volume_sg_info_dict)
+    storage_group_with_tags.update({"tags": sg_tags})
+
     data_dict = {volume_id: volume_info_dict}
     platform = 'Linux-4.4.0-104-generic-x86_64-with-Ubuntu-16.04-xenial'
-    unisphere_version = u'V9.1.0.1054'
+    unisphere_version = u'V9.1.0.5'
     unisphere_version_90 = "V9.0.0.1"
     openstack_release = '12.0.0.0b3.dev401'
     openstack_version = '12.0.0'
@@ -1203,3 +1307,48 @@ class PowerMaxData(object):
 
     volume_metadata = {
         'DeviceID': device_id, 'ArrayID': array, 'ArrayModel': array_model}
+
+    # retype metadata dict
+    retype_metadata_dict = {
+        'device_id': device_id,
+        'rdf_group_no': '10',
+        'remote_array': remote_array,
+        'target_device_id': device_id,
+        'rep_mode': 'Asynchronous',
+        'replication_status': 'enabled',
+        'target_array_model': array_model}
+
+    retype_metadata_dict2 = {
+        'default_sg_name': 'default-sg',
+        'service_level': 'Diamond'
+    }
+
+    rep_info_dict = {
+        'device_id': device_id,
+        'local_array': array, 'remote_array': remote_array,
+        'target_device_id': device_id2, 'target_name': 'test_vol',
+        'rdf_group_no': rdf_group_no, 'rep_mode': 'Metro',
+        'replication_status': 'Enabled', 'rdf_group_label': rdf_group_name,
+        'target_array_model': array_model,
+        'rdf_mgmt_grp': rdf_managed_async_grp}
+
+    create_vol_with_replication_payload = {
+        'executionOption': 'ASYNCHRONOUS',
+        'editStorageGroupActionParam': {
+            'expandStorageGroupParam': {
+                'addVolumeParam': {
+                    'emulation': 'FBA',
+                    'create_new_volumes': 'False',
+                    'volumeAttributes': [
+                        {'num_of_vols': 1,
+                         'volumeIdentifier': {
+                             'identifier_name': (
+                                 volume_details[0]['volume_identifier']),
+                             'volumeIdentifierChoice': 'identifier_name'},
+                         'volume_size': test_volume.size,
+                         'capacityUnit': 'GB'}],
+                    'remoteSymmSGInfoParam': {
+                        'force': 'true',
+                        'remote_symmetrix_1_id': remote_array,
+                        'remote_symmetrix_1_sgs': [
+                            defaultstoragegroup_name]}}}}}
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/powermax_fake_objects.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/powermax_fake_objects.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/powermax_fake_objects.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/powermax_fake_objects.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,6 +14,7 @@
 #    under the License.
 
 import ast
+
 import requests
 
 from cinder import exception
@@ -231,6 +232,8 @@ class FakeRequestsSession(object):
                     break
         elif 'info' in url:
             return_object = self.data.version_details
+        elif 'tag' in url:
+            return_object = []
         else:
             for symm in self.data.symmetrix:
                 if symm['symmetrixId'] in url:
@@ -320,6 +323,10 @@ class FakeConfiguration(object):
                 self.u4p_failover_timeout = value
             elif key == 'u4p_primary':
                 self.u4p_primary = value
+            elif key == 'powermax_short_host_name_template':
+                self.powermax_short_host_name_template = value
+            elif key == 'powermax_port_group_name_template':
+                self.powermax_port_group_name_template = value
 
     def safe_get(self, key):
         try:
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_common.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_common.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_common.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_common.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,7 +15,9 @@
 
 import ast
 from copy import deepcopy
-import mock
+import time
+from unittest import mock
+
 import six
 
 from cinder import exception
@@ -43,9 +45,11 @@ class PowerMaxCommonTest(test.TestCase):
         self.mock_object(volume_utils, 'get_max_over_subscription_ratio',
                          return_value=1.0)
         configuration = tpfo.FakeConfiguration(
-            None, 'CommonTests', 1, 1, san_ip='1.1.1.1', san_login='smc',
+            emc_file=None, volume_backend_name='CommonTests', interval=1,
+            retries=1, san_ip='1.1.1.1', san_login='smc',
             vmax_array=self.data.array, vmax_srp='SRP_1', san_password='smc',
-            san_api_port=8443, vmax_port_groups=[self.data.port_group_name_f])
+            san_api_port=8443, vmax_port_groups=[self.data.port_group_name_f],
+            powermax_port_group_name_template='portGroupName')
         rest.PowerMaxRest._establish_rest_session = mock.Mock(
             return_value=tpfo.FakeRequestsSession())
         driver = fc.PowerMaxFCDriver(configuration=configuration)
@@ -70,7 +74,6 @@ class PowerMaxCommonTest(test.TestCase):
                        side_effect=[[], tpd.PowerMaxData.array_info_wl])
     def test_gather_info_tests(self, mck_parse, mck_combo, mck_rest,
                                mck_nextgen, mck_ucode):
-
         # Use-Case 1: Gather info no-opts
         configuration = tpfo.FakeConfiguration(
             None, 'config_group', None, None)
@@ -81,6 +84,54 @@ class PowerMaxCommonTest(test.TestCase):
         self.assertTrue(self.common.next_gen)
         self.assertEqual(self.common.ucode_level, self.data.next_gen_ucode)
 
+    @mock.patch.object(common.PowerMaxCommon,
+                       '_gather_info')
+    def test_get_attributes_from_config_short_host_template(
+            self, mock_gather):
+        configuration = tpfo.FakeConfiguration(
+            emc_file=None, volume_backend_name='config_group', interval='10',
+            retries='10', replication_device=None,
+            powermax_short_host_name_template='shortHostName')
+        driver = fc.PowerMaxFCDriver(configuration=configuration)
+        driver.common._get_attributes_from_config()
+        self.assertEqual(
+            'shortHostName', driver.common.powermax_short_host_name_template)
+
+    @mock.patch.object(common.PowerMaxCommon,
+                       '_gather_info')
+    def test_get_attributes_from_config_no_short_host_template(
+            self, mock_gather):
+        configuration = tpfo.FakeConfiguration(
+            emc_file=None, volume_backend_name='config_group', interval='10',
+            retries='10', replication_device=None)
+        driver = fc.PowerMaxFCDriver(configuration=configuration)
+        driver.common._get_attributes_from_config()
+        self.assertIsNone(driver.common.powermax_short_host_name_template)
+
+    @mock.patch.object(common.PowerMaxCommon,
+                       '_gather_info')
+    def test_get_attributes_from_config_port_group_template(
+            self, mock_gather):
+        configuration = tpfo.FakeConfiguration(
+            emc_file=None, volume_backend_name='config_group', interval='10',
+            retries='10', replication_device=None,
+            powermax_port_group_name_template='portGroupName')
+        driver = fc.PowerMaxFCDriver(configuration=configuration)
+        driver.common._get_attributes_from_config()
+        self.assertEqual(
+            'portGroupName', driver.common.powermax_port_group_name_template)
+
+    @mock.patch.object(common.PowerMaxCommon,
+                       '_gather_info')
+    def test_get_attributes_from_config_no_port_group_template(
+            self, mock_gather):
+        configuration = tpfo.FakeConfiguration(
+            emc_file=None, volume_backend_name='config_group', interval='10',
+            retries='10', replication_device=None)
+        driver = fc.PowerMaxFCDriver(configuration=configuration)
+        driver.common._get_attributes_from_config()
+        self.assertIsNone(driver.common.powermax_port_group_name_template)
+
     def test_get_slo_workload_combinations_powermax(self):
         array_info = self.common.get_attributes_from_cinder_config()
         finalarrayinfolist = self.common._get_slo_workload_combinations(
@@ -265,7 +316,8 @@ class PowerMaxCommonTest(test.TestCase):
             array, volume, device_id, extra_specs, self.data.connector, False)
         mock_rm.assert_called_once_with(
             array, volume, device_id, volume_name,
-            extra_specs, True, self.data.connector, async_grp=None)
+            extra_specs, True, self.data.connector, async_grp=None,
+            host_template=None)
 
     @mock.patch.object(masking.PowerMaxMasking,
                        'return_volume_to_fast_managed_group')
@@ -280,7 +332,8 @@ class PowerMaxCommonTest(test.TestCase):
             array, volume, device_id, extra_specs, self.data.connector, True)
         mock_rm.assert_called_once_with(
             array, volume, device_id, volume_name,
-            extra_specs, False, self.data.connector, async_grp=None)
+            extra_specs, False, self.data.connector, async_grp=None,
+            host_template=None)
         mock_return.assert_called_once()
 
     def test_unmap_lun(self):
@@ -294,7 +347,18 @@ class PowerMaxCommonTest(test.TestCase):
             self.common._unmap_lun(volume, connector)
             mock_remove.assert_called_once_with(
                 array, volume, device_id, extra_specs,
-                connector, False, async_grp=None)
+                connector, False, async_grp=None, host_template=None)
+
+    def test_unmap_lun_force(self):
+        volume = self.data.test_volume
+        extra_specs = deepcopy(self.data.extra_specs_intervals_set)
+        extra_specs[utils.PORTGROUPNAME] = self.data.port_group_name_f
+        connector = deepcopy(self.data.connector)
+        del connector['host']
+        with mock.patch.object(
+                self.common.utils, 'get_host_short_name') as mock_host:
+            self.common._unmap_lun(volume, connector)
+            mock_host.assert_not_called()
 
     @mock.patch.object(common.PowerMaxCommon, '_remove_members')
     def test_unmap_lun_attachments(self, mock_rm):
@@ -325,7 +389,7 @@ class PowerMaxCommonTest(test.TestCase):
                 self.common._unmap_lun(volume, connector)
                 mock_remove.assert_called_once_with(
                     array, volume, device_id, extra_specs,
-                    connector, False, async_grp=None)
+                    connector, False, async_grp=None, host_template=None)
 
     def test_unmap_lun_not_mapped(self):
         volume = self.data.test_volume
@@ -348,7 +412,7 @@ class PowerMaxCommonTest(test.TestCase):
             self.common._unmap_lun(volume, None)
             mock_remove.assert_called_once_with(
                 array, volume, device_id, extra_specs, None,
-                False, async_grp=None)
+                False, async_grp=None, host_template=None)
 
     def test_initialize_connection_already_mapped(self):
         volume = self.data.test_volume
@@ -477,11 +541,8 @@ class PowerMaxCommonTest(test.TestCase):
                 volume, connector)
 
     @mock.patch.object(provision.PowerMaxProvision, 'extend_volume')
-    @mock.patch.object(common.PowerMaxCommon, '_array_ode_capabilities_check',
-                       return_value=[True] * 4)
     @mock.patch.object(common.PowerMaxCommon, '_extend_vol_validation_checks')
-    def test_extend_vol_no_rep_success(self, mck_val_chk, mck_ode_chk,
-                                       mck_extend):
+    def test_extend_vol_no_rep_success(self, mck_val_chk, mck_extend):
         volume = self.data.test_volume
         array = self.data.array
         device_id = self.data.device_id
@@ -493,47 +554,95 @@ class PowerMaxCommonTest(test.TestCase):
             array, device_id, new_size, ref_extra_specs, None)
 
     @mock.patch.object(provision.PowerMaxProvision, 'extend_volume')
-    @mock.patch.object(common.PowerMaxCommon, 'get_rdf_details',
-                       return_value=(10, None))
     @mock.patch.object(common.PowerMaxCommon, '_array_ode_capabilities_check',
                        return_value=[True] * 4)
+    @mock.patch.object(common.PowerMaxCommon, 'get_rdf_details',
+                       return_value=('1', None))
     @mock.patch.object(common.PowerMaxCommon, '_extend_vol_validation_checks')
-    def test_extend_vol_rep_success(self, mck_val_chk, mck_ode_chk,
-                                    mck_get_rdf, mck_extend):
+    @mock.patch.object(common.PowerMaxCommon, '_initial_setup',
+                       return_value=tpd.PowerMaxData.ex_specs_rep_config)
+    def test_extend_vol_rep_success_next_gen(
+            self, mck_setup, mck_val_chk, mck_get_rdf, mck_ode, mck_extend):
+        self.common.next_gen = True
         volume = self.data.test_volume
         array = self.data.array
         device_id = self.data.device_id
         new_size = self.data.test_volume.size
-        ref_extra_specs = deepcopy(self.data.rep_extra_specs_ode)
-        with mock.patch.object(self.common, '_initial_setup',
-                               return_value=self.data.rep_extra_specs_ode):
-            self.common.next_gen = True
-            self.common.rep_config = deepcopy(ref_extra_specs)
-            self.common.extend_volume(volume, new_size)
-            mck_extend.assert_called_with(
-                array, device_id, new_size, ref_extra_specs, 10)
+        ref_extra_specs = deepcopy(self.data.ex_specs_rep_config)
+        ref_extra_specs['array'] = self.data.array
 
-    @mock.patch.object(common.PowerMaxCommon, '_sync_check')
-    def test_extend_volume_failed_snap_src(self, mck_sync):
+        self.common.extend_volume(volume, new_size)
+        mck_extend.assert_called_once_with(
+            array, device_id, new_size, ref_extra_specs, '1')
+
+    @mock.patch.object(provision.PowerMaxProvision, 'extend_volume')
+    @mock.patch.object(common.PowerMaxCommon, '_extend_legacy_replicated_vol')
+    @mock.patch.object(common.PowerMaxCommon, '_array_ode_capabilities_check',
+                       return_value=[True, True, False, False])
+    @mock.patch.object(common.PowerMaxCommon, 'get_rdf_details',
+                       return_value=('1', None))
+    @mock.patch.object(common.PowerMaxCommon, '_extend_vol_validation_checks')
+    @mock.patch.object(common.PowerMaxCommon, '_initial_setup',
+                       return_value=tpd.PowerMaxData.ex_specs_rep_config)
+    def test_extend_vol_rep_success_next_gen_legacy_r2(
+            self, mck_setup, mck_val_chk, mck_get_rdf, mck_ode, mck_leg_extend,
+            mck_extend):
+        self.common.next_gen = True
+        self.common.rep_config = self.data.rep_config
         volume = self.data.test_volume
+        array = self.data.array
+        device_id = self.data.device_id
         new_size = self.data.test_volume.size
-        with mock.patch.object(self.rest, 'is_vol_in_rep_session',
-                               return_value=(False, True, None)):
-            self.assertRaises(exception.VolumeBackendAPIException,
-                              self.common.extend_volume, volume, new_size)
+        ref_extra_specs = deepcopy(self.data.ex_specs_rep_config)
+        ref_extra_specs['array'] = self.data.array
+
+        self.common.extend_volume(volume, new_size)
+        mck_leg_extend.assert_called_once_with(
+            array, volume, device_id, volume.name, new_size,
+            ref_extra_specs, '1')
+        mck_extend.assert_not_called()
 
-    def test_extend_volume_failed_no_device_id(self):
+    @mock.patch.object(provision.PowerMaxProvision, 'extend_volume')
+    @mock.patch.object(common.PowerMaxCommon, '_extend_legacy_replicated_vol')
+    @mock.patch.object(common.PowerMaxCommon, '_array_ode_capabilities_check',
+                       return_value=[False, False, False, False])
+    @mock.patch.object(common.PowerMaxCommon, 'get_rdf_details',
+                       return_value=('1', None))
+    @mock.patch.object(common.PowerMaxCommon, '_extend_vol_validation_checks')
+    @mock.patch.object(common.PowerMaxCommon, '_initial_setup',
+                       return_value=tpd.PowerMaxData.ex_specs_rep_config)
+    def test_extend_vol_rep_success_legacy(
+            self, mck_setup, mck_val_chk, mck_get_rdf, mck_ode, mck_leg_extend,
+            mck_extend):
+        self.common.rep_config = self.data.rep_config
+        self.common.next_gen = False
         volume = self.data.test_volume
+        array = self.data.array
+        device_id = self.data.device_id
         new_size = self.data.test_volume.size
-        with mock.patch.object(self.common, '_find_device_on_array',
-                               return_value=None):
-            self.assertRaises(exception.VolumeBackendAPIException,
-                              self.common.extend_volume, volume, new_size)
+        ref_extra_specs = deepcopy(self.data.ex_specs_rep_config)
+        ref_extra_specs['array'] = self.data.array
 
-    @mock.patch.object(common.PowerMaxCommon, '_sync_check')
-    def test_extend_volume_failed_wrong_size(self, mck_sync):
+        self.common.extend_volume(volume, new_size)
+        mck_leg_extend.assert_called_once_with(
+            array, volume, device_id, volume.name, new_size,
+            ref_extra_specs, '1')
+        mck_extend.assert_not_called()
+
+    @mock.patch.object(common.PowerMaxCommon, '_array_ode_capabilities_check',
+                       return_value=[False, False, False, False])
+    @mock.patch.object(common.PowerMaxCommon, 'get_rdf_details',
+                       return_value=('1', None))
+    @mock.patch.object(common.PowerMaxCommon, '_extend_vol_validation_checks')
+    @mock.patch.object(
+        common.PowerMaxCommon, '_initial_setup',
+        return_value=tpd.PowerMaxData.ex_specs_rep_config_no_extend)
+    def test_extend_vol_rep_success_legacy_allow_extend_false(
+            self, mck_setup, mck_val_chk, mck_get_rdf, mck_ode):
+        self.common.rep_config = self.data.rep_config
+        self.common.next_gen = False
         volume = self.data.test_volume
-        new_size = 1
+        new_size = self.data.test_volume.size
         self.assertRaises(exception.VolumeBackendAPIException,
                           self.common.extend_volume, volume, new_size)
 
@@ -611,7 +720,9 @@ class PowerMaxCommonTest(test.TestCase):
 
     @mock.patch.object(
         common.PowerMaxCommon, '_get_masking_views_from_volume',
-        return_value=([], [tpd.PowerMaxData.masking_view_name_f]))
+        return_value=([tpd.PowerMaxData.masking_view_name_f],
+                      [tpd.PowerMaxData.masking_view_name_f,
+                       tpd.PowerMaxData.masking_view_name_Y_f]))
     def test_find_host_lun_id_multiattach(self, mock_mask):
         volume = self.data.test_volume
         extra_specs = self.data.extra_specs
@@ -619,8 +730,8 @@ class PowerMaxCommonTest(test.TestCase):
             volume, 'HostX', extra_specs)
         self.assertTrue(is_multiattach)
 
-    @mock.patch.object(common.PowerMaxCommon, 'get_remote_target_device',
-                       return_value=tpd.PowerMaxData.device_id2)
+    @mock.patch.object(rest.PowerMaxRest, 'get_rdf_pair_volume',
+                       return_value=tpd.PowerMaxData.rdf_group_vol_details)
     @mock.patch.object(rest.PowerMaxRest, 'get_volume',
                        return_value=tpd.PowerMaxData.volume_details[0])
     def test_find_host_lun_id_rep_extra_specs(self, mock_vol, mock_tgt):
@@ -629,6 +740,27 @@ class PowerMaxCommonTest(test.TestCase):
             self.data.extra_specs, self.data.rep_extra_specs)
         mock_tgt.assert_called_once()
 
+    @mock.patch.object(rest.PowerMaxRest, 'find_mv_connections_for_vol',
+                       return_value='1')
+    @mock.patch.object(common.PowerMaxCommon, '_get_masking_views_from_volume',
+                       side_effect=[([], ['OS-HostX-I-PG-MV']),
+                                    (['OS-HostX-I-PG-MV'],
+                                     ['OS-HostX-I-PG-MV'])])
+    @mock.patch.object(rest.PowerMaxRest, 'get_volume',
+                       return_value=tpd.PowerMaxData.volume_details[0])
+    def test_find_host_lun_id_backward_compatible(
+            self, mock_vol, mock_mvs, mock_mv_conns):
+        expected_dict = {'hostlunid': '1', 'maskingview': 'OS-HostX-I-PG-MV',
+                         'array': '000197800123', 'device_id': '00001'}
+        self.common.powermax_short_host_name_template = (
+            'shortHostName[:7]finance')
+        masked_vols, is_multiattach = self.common.find_host_lun_id(
+            self.data.test_volume, 'HostX',
+            self.data.extra_specs)
+        self.assertEqual(expected_dict, masked_vols)
+        self.assertFalse(is_multiattach)
+        mock_mv_conns.assert_called_once()
+
     def test_get_masking_views_from_volume(self):
         array = self.data.array
         device_id = self.data.device_id
@@ -680,8 +812,8 @@ class PowerMaxCommonTest(test.TestCase):
             self.assertRaises(exception.VolumeBackendAPIException,
                               self.common._initial_setup, volume)
 
-    @mock.patch.object(common.PowerMaxCommon, 'get_remote_target_device',
-                       return_value=tpd.PowerMaxData.device_id2)
+    @mock.patch.object(rest.PowerMaxRest, 'get_rdf_pair_volume',
+                       return_value=tpd.PowerMaxData.rdf_group_vol_details)
     def test_populate_masking_dict(self, mock_tgt):
         volume = self.data.test_volume
         connector = self.data.connector
@@ -690,6 +822,7 @@ class PowerMaxCommonTest(test.TestCase):
         extra_specs[utils.WORKLOAD] = self.data.workload
         ref_mv_dict = self.data.masking_view_dict
         self.common.next_gen = False
+        self.common.powermax_port_group_name_template = 'portGroupName'
         masking_view_dict = self.common._populate_masking_dict(
             volume, connector, extra_specs)
         self.assertEqual(ref_mv_dict, masking_view_dict)
@@ -744,30 +877,33 @@ class PowerMaxCommonTest(test.TestCase):
         volume = self.data.test_clone_volume
         source_volume = self.data.test_volume
         extra_specs = self.data.extra_specs
-        ref_dict = self.data.provider_location_clone
-        clone_dict = self.common._create_cloned_volume(
-            volume, source_volume, extra_specs)
-        self.assertEqual(ref_dict, clone_dict)
+        ref_response = (self.data.provider_location_clone, dict(), dict())
+        clone_dict, rep_update, rep_info_dict = (
+            self.common._create_cloned_volume(
+                volume, source_volume, extra_specs))
+        self.assertEqual(ref_response, (clone_dict, rep_update, rep_info_dict))
 
     @mock.patch.object(common.PowerMaxCommon, '_clone_check')
     def test_create_cloned_volume_is_snapshot(self, mck_clone_chk):
         volume = self.data.test_snapshot
         source_volume = self.data.test_volume
         extra_specs = self.data.extra_specs
-        ref_dict = self.data.snap_location
-        clone_dict = self.common._create_cloned_volume(
-            volume, source_volume, extra_specs, True, False)
-        self.assertEqual(ref_dict, clone_dict)
+        ref_response = (self.data.snap_location, dict(), dict())
+        clone_dict, rep_update, rep_info_dict = (
+            self.common._create_cloned_volume(
+                volume, source_volume, extra_specs, True, False))
+        self.assertEqual(ref_response, (clone_dict, rep_update, rep_info_dict))
 
     @mock.patch.object(common.PowerMaxCommon, '_clone_check')
     def test_create_cloned_volume_from_snapshot(self, mck_clone_chk):
         volume = self.data.test_clone_volume
         source_volume = self.data.test_snapshot
         extra_specs = self.data.extra_specs
-        ref_dict = self.data.provider_location_snapshot
-        clone_dict = self.common._create_cloned_volume(
-            volume, source_volume, extra_specs, False, True)
-        self.assertEqual(ref_dict, clone_dict)
+        ref_response = (self.data.provider_location_snapshot, dict(), dict())
+        clone_dict, rep_update, rep_info_dict = (
+            self.common._create_cloned_volume(
+                volume, source_volume, extra_specs, False, True))
+        self.assertEqual(ref_response, (clone_dict, rep_update, rep_info_dict))
 
     def test_create_cloned_volume_not_licenced(self):
         volume = self.data.test_clone_volume
@@ -871,7 +1007,7 @@ class PowerMaxCommonTest(test.TestCase):
         array = self.data.array
         device_id = self.data.device_id
         volume_name = self.data.test_volume.name
-        ref_extra_specs = self.data.extra_specs_intervals_set
+        ref_extra_specs = deepcopy(self.data.extra_specs_intervals_set)
         ref_extra_specs[utils.PORTGROUPNAME] = self.data.port_group_name_f
         volume = self.data.test_volume
         with mock.patch.object(self.common, '_sync_check'):
@@ -894,12 +1030,14 @@ class PowerMaxCommonTest(test.TestCase):
         volume_name = '1'
         volume_size = self.data.test_volume.size
         extra_specs = self.data.extra_specs
-        ref_dict = self.data.provider_location
+        ref_response = (self.data.provider_location, dict(), dict())
         with mock.patch.object(self.rest, 'get_volume',
                                return_value=self.data.volume_details[0]):
-            volume_dict = self.common._create_volume(
-                volume_name, volume_size, extra_specs)
-        self.assertEqual(ref_dict, volume_dict)
+            volume_dict, rep_update, rep_info_dict = (
+                self.common._create_volume(
+                    volume_name, volume_size, extra_specs))
+        self.assertEqual(ref_response,
+                         (volume_dict, rep_update, rep_info_dict))
 
     def test_create_volume_success_next_gen(self):
         volume_name = '1'
@@ -958,27 +1096,6 @@ class PowerMaxCommonTest(test.TestCase):
             self.common._create_volume,
             volume_name, volume_size, extra_specs)
 
-    @mock.patch.object(rest.PowerMaxRest, 'is_next_gen_array',
-                       return_value=False)
-    @mock.patch.object(provision.PowerMaxProvision, 'verify_slo_workload',
-                       return_value=(True, True))
-    @mock.patch.object(provision.PowerMaxProvision, 'create_volume_from_sg')
-    def test_create_volume_in_use_replication_enabled(self, mock_create,
-                                                      mock_verify,
-                                                      mock_nextgen):
-        volume_name = '1'
-        volume_size = self.data.test_volume.size
-        rep_extra_specs = self.data.rep_extra_specs3
-        with mock.patch.object(
-                self.masking,
-                'get_or_create_default_storage_group') as mck_sg:
-            self.common._create_volume(
-                volume_name, volume_size, rep_extra_specs, in_use=True)
-            mck_sg.assert_called_once_with(
-                rep_extra_specs['array'], rep_extra_specs['srp'],
-                rep_extra_specs['slo'], rep_extra_specs['workload'],
-                rep_extra_specs, False, True, rep_extra_specs['rep_mode'])
-
     def test_set_vmax_extra_specs(self):
         srp_record = self.common.get_attributes_from_cinder_config()
         extra_specs = self.common._set_vmax_extra_specs(
@@ -1038,6 +1155,26 @@ class PowerMaxCommonTest(test.TestCase):
         ref_extra_specs[utils.PORTGROUPNAME] = self.data.port_group_name_f
         self.assertEqual('NONE', extra_specs[utils.WORKLOAD])
 
+    def test_set_vmax_extra_specs_tags_not_set(self):
+        srp_record = self.common.get_attributes_from_cinder_config()
+        extra_specs = self.common._set_vmax_extra_specs(
+            self.data.vol_type_extra_specs, srp_record)
+        self.assertTrue('storagetype:storagegrouptags' not in extra_specs)
+
+    def test_set_vmax_extra_specs_tags_set_correctly(self):
+        srp_record = self.common.get_attributes_from_cinder_config()
+        extra_specs = self.common._set_vmax_extra_specs(
+            self.data.vol_type_extra_specs_tags, srp_record)
+        self.assertEqual(
+            self.data.vol_type_extra_specs_tags[utils.STORAGE_GROUP_TAGS],
+            extra_specs[utils.STORAGE_GROUP_TAGS])
+
+    def test_set_vmax_extra_specs_tags_set_incorrectly(self):
+        srp_record = self.common.get_attributes_from_cinder_config()
+        self.assertRaises(exception.VolumeBackendAPIException,
+                          self.common._set_vmax_extra_specs,
+                          self.data.vol_type_extra_specs_tags_bad, srp_record)
+
     def test_delete_volume_from_srp_success(self):
         array = self.data.array
         device_id = self.data.device_id
@@ -1050,6 +1187,7 @@ class PowerMaxCommonTest(test.TestCase):
             mock_del.assert_called_once_with(array, device_id, volume_name)
 
     def test_delete_volume_from_srp_failed(self):
+        self.mock_object(time, 'sleep')
         array = self.data.array
         device_id = self.data.failed_resource
         volume_name = self.data.test_volume.name
@@ -1062,28 +1200,6 @@ class PowerMaxCommonTest(test.TestCase):
                               device_id, volume_name, extra_specs)
             mock_add.assert_not_called()
 
-    @mock.patch.object(utils.PowerMaxUtils, 'is_replication_enabled',
-                       side_effect=[False, True])
-    def test_remove_vol_and_cleanup_replication(self, mock_rep_enabled):
-        array = self.data.array
-        device_id = self.data.device_id
-        volume = self.data.test_volume
-        volume_name = self.data.test_volume.name
-        extra_specs = self.data.extra_specs
-        with mock.patch.object(
-                self.masking, 'remove_and_reset_members') as mock_rm:
-            with mock.patch.object(
-                    self.common, 'cleanup_lun_replication') as mock_clean:
-                self.common._remove_vol_and_cleanup_replication(
-                    array, device_id, volume_name, extra_specs, volume)
-                mock_rm.assert_called_once_with(
-                    array, volume, device_id, volume_name, extra_specs, False)
-                mock_clean.assert_not_called()
-                self.common._remove_vol_and_cleanup_replication(
-                    array, device_id, volume_name, extra_specs, volume)
-                mock_clean.assert_called_once_with(
-                    volume, volume_name, device_id, extra_specs)
-
     @mock.patch.object(utils.PowerMaxUtils, 'is_volume_failed_over',
                        side_effect=[True, False])
     @mock.patch.object(common.PowerMaxCommon, '_get_replication_extra_specs',
@@ -1106,18 +1222,50 @@ class PowerMaxCommonTest(test.TestCase):
 
     @mock.patch.object(common.PowerMaxCommon, '_get_replication_extra_specs',
                        return_value=tpd.PowerMaxData.rep_extra_specs)
-    @mock.patch.object(common.PowerMaxCommon, 'get_remote_target_device',
-                       return_value=(tpd.PowerMaxData.device_id2,))
-    @mock.patch.object(utils.PowerMaxUtils, 'is_metro_device',
-                       side_effect=[False, True])
-    def test_get_target_wwns(self, mock_metro, mock_tgt, mock_specs):
+    @mock.patch.object(common.PowerMaxCommon, 'get_rdf_details',
+                       return_value=('1', tpd.PowerMaxData.remote_array))
+    @mock.patch.object(rest.PowerMaxRest, 'get_rdf_pair_volume',
+                       return_value=tpd.PowerMaxData.rdf_group_vol_details)
+    @mock.patch.object(
+        common.PowerMaxCommon, '_get_target_wwns_from_masking_view',
+        return_value=[tpd.PowerMaxData.wwnn1])
+    def test_get_target_wwns(
+            self, mck_wwns, mock_tgt, mock_rdf_grp, mock_specs):
         __, metro_wwns = self.common.get_target_wwns_from_masking_view(
             self.data.test_volume, self.data.connector)
         self.assertEqual([], metro_wwns)
         # Is metro volume
-        __, metro_wwns = self.common.get_target_wwns_from_masking_view(
-            self.data.test_volume, self.data.connector)
-        self.assertEqual([self.data.wwnn1], metro_wwns)
+        with mock.patch.object(common.PowerMaxCommon, '_initial_setup',
+                               return_value=self.data.rep_extra_specs_ode):
+            self.common.rep_config = self.data.rep_config
+            __, metro_wwns = self.common.get_target_wwns_from_masking_view(
+                self.data.test_volume, self.data.connector)
+            self.assertEqual([self.data.wwnn1], metro_wwns)
+
+    @mock.patch.object(common.PowerMaxCommon,
+                       '_get_target_wwns_from_masking_view')
+    @mock.patch.object(utils.PowerMaxUtils, 'get_host_name_label',
+                       return_value = 'my_short_h94485')
+    @mock.patch.object(utils.PowerMaxUtils, 'is_replication_enabled',
+                       return_value=False)
+    def test_get_target_wwns_host_override(
+            self, mock_rep_check, mock_label, mock_mv):
+        host_record = {'host': 'my_short_host_name'}
+        connector = deepcopy(self.data.connector)
+        connector.update(host_record)
+        extra_specs = {'pool_name': 'Diamond+DSS+SRP_1+000197800123',
+                       'srp': 'SRP_1', 'array': '000197800123',
+                       'storagetype:portgroupname': 'OS-fibre-PG',
+                       'interval': 1, 'retries': 1, 'slo': 'Diamond',
+                       'workload': 'DSS'}
+        host_template = 'shortHostName[:10]uuid[:5]'
+        self.common.powermax_short_host_name_template = host_template
+        self.common.get_target_wwns_from_masking_view(
+            self.data.test_volume, connector)
+        mock_label.assert_called_once_with(
+            connector['host'], host_template)
+        mock_mv.assert_called_once_with(
+            self.data.device_id, 'my_short_h94485', extra_specs)
 
     def test_get_port_group_from_masking_view(self):
         array = self.data.array
@@ -1172,25 +1320,27 @@ class PowerMaxCommonTest(test.TestCase):
         clone_volume = self.data.test_clone_volume
         source_device_id = self.data.device_id
         snap_name = self.data.snap_location['snap_name']
-        ref_dict = self.data.provider_location_snapshot
-        clone_dict = self.common._create_replica(
+        ref_response = (self.data.provider_location_snapshot, dict(), dict())
+        clone_dict, rep_update, rep_info_dict = self.common._create_replica(
             array, clone_volume, source_device_id,
             self.data.extra_specs, snap_name)
-        self.assertEqual(ref_dict, clone_dict)
+        self.assertEqual(ref_response, (clone_dict, rep_update, rep_info_dict))
 
     def test_create_replica_no_snap_name(self):
         array = self.data.array
         clone_volume = self.data.test_clone_volume
         source_device_id = self.data.device_id
         snap_name = "temp-" + source_device_id + "-snapshot_for_clone"
-        ref_dict = self.data.provider_location_clone
+        ref_response = (self.data.provider_location_clone, dict(), dict())
         with mock.patch.object(
                 self.utils, 'get_temp_snap_name',
                 return_value=snap_name) as mock_get_snap:
-            clone_dict = self.common._create_replica(
-                array, clone_volume, source_device_id,
-                self.data.extra_specs)
-            self.assertEqual(ref_dict, clone_dict)
+            clone_dict, rep_update, rep_info_dict = (
+                self.common._create_replica(
+                    array, clone_volume, source_device_id,
+                    self.data.extra_specs))
+            self.assertEqual(ref_response,
+                             (clone_dict, rep_update, rep_info_dict))
             mock_get_snap.assert_called_once_with(source_device_id)
 
     def test_create_replica_failed_cleanup_target(self):
@@ -1216,7 +1366,7 @@ class PowerMaxCommonTest(test.TestCase):
         source_device_id = self.data.device_id
         snap_name = self.data.failed_resource
         with mock.patch.object(self.common, '_create_volume',
-                               return_value={'device_id': None}):
+                               return_value=({'device_id': None}, {}, {})):
             with mock.patch.object(
                     self.common, '_cleanup_target') as mock_cleanup:
                 self.assertRaises(
@@ -1261,8 +1411,7 @@ class PowerMaxCommonTest(test.TestCase):
         with mock.patch.object(self.rest, 'get_sync_session',
                                return_value='session'):
             with mock.patch.object(
-                    self.provision,
-                    'break_replication_relationship') as mock_break:
+                    self.provision, 'unlink_snapvx_tgt_volume') as mock_break:
                 self.common._cleanup_target(
                     array, target_device_id, source_device_id,
                     clone_name, snap_name, extra_specs)
@@ -1382,8 +1531,8 @@ class PowerMaxCommonTest(test.TestCase):
 
     @mock.patch.object(common.PowerMaxCommon,
                        '_remove_vol_and_cleanup_replication')
-    @mock.patch.object(common.PowerMaxCommon, '_sync_check')
-    def test_unmanage_success(self, mck_sync, mock_rm):
+    @mock.patch.object(common.PowerMaxCommon, '_clone_check')
+    def test_unmanage_success(self, mck_clone, mock_rm):
         volume = self.data.test_volume
         with mock.patch.object(self.rest, 'rename_volume') as mock_rename:
             self.common.unmanage(volume)
@@ -1412,7 +1561,7 @@ class PowerMaxCommonTest(test.TestCase):
     def test_retype(self, mock_migrate):
         device_id = self.data.device_id
         volume_name = self.data.test_volume.name
-        extra_specs = self.data.extra_specs_intervals_set
+        extra_specs = deepcopy(self.data.extra_specs_intervals_set)
         extra_specs[utils.PORTGROUPNAME] = self.data.port_group_name_f
         volume = self.data.test_volume
         new_type = {'extra_specs': {}}
@@ -1435,150 +1584,13 @@ class PowerMaxCommonTest(test.TestCase):
                                    new_type, host)
                 mock_retype.assert_called_once()
 
-    @mock.patch.object(
-        rest.PowerMaxRest, 'get_volume',
-        return_value=tpd.PowerMaxData.volume_details_attached)
-    @mock.patch.object(rest.PowerMaxRest, 'get_storage_group',
-                       return_value=tpd.PowerMaxData.sg_details[1])
-    @mock.patch.object(utils.PowerMaxUtils, 'get_child_sg_name',
-                       return_value=('OS-Test-SG', '', '', ''))
-    @mock.patch.object(rest.PowerMaxRest, 'is_child_sg_in_parent_sg',
-                       return_value=True)
-    @mock.patch.object(masking.PowerMaxMasking,
-                       'move_volume_between_storage_groups')
-    @mock.patch.object(rest.PowerMaxRest, 'is_volume_in_storagegroup',
-                       return_value=True)
-    def test_retype_inuse_volume_tgt_sg_exist(self, mck_vol_in_sg, mck_sg_move,
-                                              mck_child_sg_in_sg,
-                                              mck_get_sg_name,
-                                              mck_get_sg, mck_get_vol):
-        array = self.data.array
-        srp = self.data.srp
-        slo = self.data.slo
-        workload = self.data.workload
-        device_id = self.data.device_id
-        volume = self.data.test_attached_volume
-        rep_mode = 'Synchronous'
-        src_extra_specs = self.data.extra_specs_migrate
-        interval = src_extra_specs['interval']
-        retries = src_extra_specs['retries']
-        tgt_extra_specs = {
-            'srp': srp, 'array': array, 'slo': slo, 'workload': workload,
-            'interval': interval, 'retries': retries, 'rep_mode': rep_mode}
-
-        success = self.common._retype_inuse_volume(
-            array, srp, volume, device_id, src_extra_specs, slo, workload,
-            tgt_extra_specs, False)[0]
-        self.assertTrue(success)
-        mck_sg_move.assert_called()
-        mck_vol_in_sg.assert_called()
-
-    @mock.patch.object(
-        rest.PowerMaxRest, 'get_volume',
-        return_value=tpd.PowerMaxData.volume_details_attached)
-    @mock.patch.object(utils.PowerMaxUtils, 'get_child_sg_name',
-                       return_value=('OS-Test-SG', '', '', ''))
-    @mock.patch.object(provision.PowerMaxProvision, 'create_storage_group')
-    @mock.patch.object(masking.PowerMaxMasking, 'add_child_sg_to_parent_sg')
-    @mock.patch.object(rest.PowerMaxRest, 'is_child_sg_in_parent_sg',
-                       return_value=True)
-    @mock.patch.object(masking.PowerMaxMasking,
-                       'move_volume_between_storage_groups')
-    @mock.patch.object(rest.PowerMaxRest, 'is_volume_in_storagegroup',
-                       return_value=True)
-    def test_retype_inuse_volume_no_tgt_sg(self, mck_vol_in_sg, mck_move_vol,
-                                           mck_sg_in_sg, mck_add_sg_to_sg,
-                                           mck_create_sg, mck_get_csg_name,
-                                           mck_get_vol):
-        array = self.data.array
-        srp = self.data.srp
-        slo = self.data.slo
-        workload = self.data.workload
-        device_id = self.data.device_id
-        volume = self.data.test_attached_volume
-        rep_mode = 'Synchronous'
-        src_extra_specs = self.data.extra_specs_migrate
-        interval = src_extra_specs['interval']
-        retries = src_extra_specs['retries']
-        tgt_extra_specs = {
-            'srp': srp, 'array': array, 'slo': slo, 'workload': workload,
-            'interval': interval, 'retries': retries, 'rep_mode': rep_mode}
-
-        with mock.patch.object(self.rest, 'get_storage_group',
-                               side_effect=[self.data.sg_details[1], None,
-                                            self.data.sg_details[1]]):
-            success = self.common._retype_inuse_volume(
-                array, srp, volume, device_id, src_extra_specs, slo, workload,
-                tgt_extra_specs, False)[0]
-            mck_create_sg.assert_called()
-            mck_add_sg_to_sg.assert_called()
-            self.assertTrue(success)
-
-    @mock.patch.object(
-        rest.PowerMaxRest, 'get_volume',
-        return_value=tpd.PowerMaxData.volume_details_attached)
-    @mock.patch.object(rest.PowerMaxRest, 'get_storage_group',
-                       return_value=tpd.PowerMaxData.sg_details[1])
-    @mock.patch.object(utils.PowerMaxUtils, 'get_child_sg_name',
-                       return_value=('OS-Test-SG', '', '', ''))
-    @mock.patch.object(rest.PowerMaxRest, 'is_child_sg_in_parent_sg',
-                       return_value=False)
-    @mock.patch.object(masking.PowerMaxMasking,
-                       'move_volume_between_storage_groups')
-    @mock.patch.object(rest.PowerMaxRest, 'is_volume_in_storagegroup',
+    @mock.patch.object(utils.PowerMaxUtils, 'is_retype_supported',
                        return_value=False)
-    def test_retype_inuse_volume_fail(self, mck_vol_in_sg, mck_sg_move,
-                                      mck_child_sg_in_sg, mck_get_sg_name,
-                                      mck_get_sg, mck_get_vol):
-        array = self.data.array
-        srp = self.data.srp
-        slo = self.data.slo
-        workload = self.data.workload
-        device_id = self.data.device_id
-        volume = self.data.test_attached_volume
-        rep_mode = 'Synchronous'
-        src_extra_specs = self.data.extra_specs_migrate
-        interval = src_extra_specs['interval']
-        retries = src_extra_specs['retries']
-        tgt_extra_specs = {
-            'srp': srp, 'array': array, 'slo': slo, 'workload': workload,
-            'interval': interval, 'retries': retries, 'rep_mode': rep_mode}
-
-        success = self.common._retype_inuse_volume(
-            array, srp, volume, device_id, src_extra_specs, slo, workload,
-            tgt_extra_specs, False)[0]
-        self.assertFalse(success)
-        mck_vol_in_sg.assert_not_called()
-        mck_sg_move.assert_not_called()
-
-    @mock.patch.object(
-        rest.PowerMaxRest, 'get_volume',
-        return_value=tpd.PowerMaxData.volume_details_attached)
-    @mock.patch.object(rest.PowerMaxRest, 'get_storage_group',
-                       return_value=tpd.PowerMaxData.sg_details[1])
-    @mock.patch.object(utils.PowerMaxUtils, 'get_volume_attached_hostname',
-                       return_value=None)
-    def test_retype_inuse_volume_fail_no_attached_host(self, mck_get_hostname,
-                                                       mck_get_sg,
-                                                       mck_get_vol):
-        array = self.data.array
-        srp = self.data.srp
-        slo = self.data.slo
-        workload = self.data.workload
-        device_id = self.data.device_id
-        volume = self.data.test_attached_volume
-        rep_mode = 'Synchronous'
-        src_extra_specs = self.data.extra_specs_migrate
-        interval = src_extra_specs['interval']
-        retries = src_extra_specs['retries']
-        tgt_extra_specs = {
-            'srp': srp, 'array': array, 'slo': slo, 'workload': workload,
-            'interval': interval, 'retries': retries, 'rep_mode': rep_mode}
-
-        success = self.common._retype_inuse_volume(
-            array, srp, volume, device_id, src_extra_specs, slo, workload,
-            tgt_extra_specs, False)[0]
-        self.assertFalse(success)
+    def test_retype_not_supported(self, mck_retype):
+        volume = self.data.test_volume
+        new_type = {'extra_specs': self.data.rep_extra_specs}
+        host = self.data.new_host
+        self.assertFalse(self.common.retype(volume, new_type, host))
 
     def test_slo_workload_migration_valid(self):
         device_id = self.data.device_id
@@ -1642,247 +1654,36 @@ class PowerMaxCommonTest(test.TestCase):
                     extra_specs[utils.SRP], self.data.slo,
                     self.data.workload, volume_name, new_type, extra_specs)
 
-    @mock.patch.object(masking.PowerMaxMasking, 'remove_and_reset_members')
-    @mock.patch.object(common.PowerMaxCommon, 'get_volume_metadata',
-                       return_value='')
-    def test_migrate_volume_success(self, mck_meta, mock_remove):
-        with mock.patch.object(self.rest, 'is_volume_in_storagegroup',
-                               return_value=True):
-            device_id = self.data.device_id
-            volume_name = self.data.test_volume.name
-            extra_specs = self.data.extra_specs
-            volume = self.data.test_volume
-            new_type = {'extra_specs': {}}
-            migrate_status = self.common._migrate_volume(
-                self.data.array, volume, device_id, self.data.srp,
-                self.data.slo, self.data.workload, volume_name,
-                new_type, extra_specs)[0]
-            self.assertTrue(migrate_status)
-
-            target_extra_specs = {
-                'array': self.data.array, 'interval': 3,
-                'retries': 120, 'slo': self.data.slo,
-                'srp': self.data.srp, 'workload': self.data.workload}
-            mock_remove.assert_called_once_with(
-                self.data.array, volume, device_id, volume_name,
-                target_extra_specs, reset=True)
-            mock_remove.reset_mock()
-
-            with mock.patch.object(
-                    self.rest, 'get_storage_groups_from_volume',
-                    return_value=[]):
-                migrate_status = self.common._migrate_volume(
-                    self.data.array, volume, device_id, self.data.srp,
-                    self.data.slo, self.data.workload, volume_name,
-                    new_type, extra_specs)[0]
-                self.assertTrue(migrate_status)
-                mock_remove.assert_not_called()
-
-    @mock.patch.object(common.PowerMaxCommon, 'cleanup_lun_replication')
-    @mock.patch.object(common.PowerMaxCommon, '_retype_inuse_volume',
-                       return_value=(True, 'Test'))
-    @mock.patch.object(common.PowerMaxCommon,
-                       'setup_inuse_volume_replication',
-                       return_value=('Status', 'Data', 'Info'))
-    @mock.patch.object(common.PowerMaxCommon, '_retype_remote_volume',
-                       return_value=True)
-    @mock.patch.object(common.PowerMaxCommon, 'get_volume_metadata',
-                       return_value='')
-    def test_migrate_in_use_volume(self, mck_meta, mck_remote_retype,
-                                   mck_setup, mck_retype, mck_cleanup):
-        # Array/Volume info
-        array = self.data.array
-        srp = self.data.srp
-        slo = self.data.slo
-        workload = self.data.workload
+    @mock.patch.object(
+        common.PowerMaxCommon, 'get_volume_metadata', return_value='')
+    @mock.patch.object(
+        common.PowerMaxCommon, '_retype_volume',
+        return_value=(True, tpd.PowerMaxData.defaultstoragegroup_name))
+    def test_migrate_volume_success_no_rep(self, mck_retype, mck_get):
+        array_id = self.data.array
+        volume = self.data.test_volume
         device_id = self.data.device_id
-        volume = self.data.test_attached_volume
-        volume_name = self.data.test_attached_volume.name
-        # Rep Config
-        rep_mode = 'Synchronous'
-        self.common.rep_config = {'mode': rep_mode, 'metro_use_bias': True}
-        # Extra Specs
-        new_type = {'extra_specs': {}}
-        src_extra_specs = self.data.extra_specs_migrate
-        interval = src_extra_specs['interval']
-        retries = src_extra_specs['retries']
-        tgt_extra_specs = {
-            'srp': srp, 'array': array, 'slo': slo, 'workload': workload,
-            'interval': interval, 'retries': retries, 'rep_mode': rep_mode}
-
-        def _reset_mocks():
-            mck_cleanup.reset_mock()
-            mck_setup.reset_mock()
-            mck_retype.reset_mock()
-            mck_remote_retype.reset_mock()
-
-        # Scenario 1: no_rep => no_rep
-        with mock.patch.object(self.utils, 'is_replication_enabled',
-                               side_effect=[False, False]):
-            success = self.common._migrate_volume(
-                array, volume, device_id, srp, slo, workload, volume_name,
-                new_type, src_extra_specs)[0]
-            mck_retype.assert_called_once_with(
-                array, srp, volume, device_id, src_extra_specs, slo, workload,
-                tgt_extra_specs, False)
-            mck_cleanup.assert_not_called()
-            mck_setup.assert_not_called()
-            mck_remote_retype.assert_not_called()
-            self.assertTrue(success)
-            _reset_mocks()
-
-        # Scenario 2: rep => no_rep
-        with mock.patch.object(self.utils, 'is_replication_enabled',
-                               side_effect=[True, False]):
-            success = self.common._migrate_volume(
-                array, volume, device_id, srp, slo, workload, volume_name,
-                new_type, src_extra_specs)[0]
-            cleanup_specs = src_extra_specs
-            cleanup_specs['force_vol_add'] = True
-            mck_cleanup.assert_called_once_with(
-                volume, volume_name, device_id, cleanup_specs)
-            mck_retype.assert_called_once_with(
-                array, srp, volume, device_id, src_extra_specs, slo, workload,
-                tgt_extra_specs, False)
-            mck_setup.assert_not_called()
-            mck_remote_retype.assert_not_called()
-            self.assertTrue(success)
-            _reset_mocks()
-
-        # Scenario 3: no_rep => rep
-        with mock.patch.object(self.utils, 'is_replication_enabled',
-                               side_effect=[False, True]):
-            success = self.common._migrate_volume(
-                array, volume, device_id, srp, slo, workload, volume_name,
-                new_type, src_extra_specs)[0]
-            mck_setup_specs = src_extra_specs
-            mck_setup_specs[utils.METROBIAS] = self.common.rep_config[
-                'metro_use_bias']
-            mck_setup.assert_called_once_with(
-                self.data.array, volume, device_id, mck_setup_specs)
-            mck_retype.assert_called_once_with(
-                array, srp, volume, device_id, src_extra_specs, slo,
-                workload, tgt_extra_specs, False)
-            mck_cleanup.assert_not_called()
-            mck_remote_retype.assert_not_called()
-            self.assertTrue(success)
-            _reset_mocks()
-
-        # Scenario 4: rep => rep
-        with mock.patch.object(self.utils, 'is_replication_enabled',
-                               side_effect=[True, True]):
-            success = self.common._migrate_volume(
-                array, volume, device_id, srp, slo, workload, volume_name,
-                new_type, src_extra_specs)[0]
-            mck_retype.assert_called_once_with(
-                array, srp, volume, device_id, src_extra_specs, slo, workload,
-                tgt_extra_specs, False)
-            mck_remote_retype.assert_called_once_with(
-                array, volume, device_id, volume_name, rep_mode, True,
-                tgt_extra_specs)
-            mck_cleanup.assert_not_called()
-            mck_setup.assert_not_called()
-            self.assertTrue(success)
-
-    @mock.patch.object(common.PowerMaxCommon, 'setup_volume_replication',
-                       return_value=('Status', 'Data', 'Info'))
-    @mock.patch.object(common.PowerMaxCommon, '_retype_volume',
-                       return_value=True)
-    @mock.patch.object(common.PowerMaxCommon, 'cleanup_lun_replication')
-    @mock.patch.object(common.PowerMaxCommon, '_retype_inuse_volume',
-                       return_value=(True, 'test'))
-    @mock.patch.object(common.PowerMaxCommon,
-                       'setup_inuse_volume_replication',
-                       return_value=('Status', 'Data', 'Info'))
-    @mock.patch.object(common.PowerMaxCommon, '_retype_remote_volume',
-                       return_value=True)
-    @mock.patch.object(common.PowerMaxCommon, 'get_volume_metadata',
-                       return_value='')
-    def test_migrate_volume_attachment_path(
-            self, mck_meta, mck_remote_retype, mck_setup_use, mck_inuse_retype,
-            mck_cleanup, mck_retype, mck_setup):
-        # Array/Volume info
-        array = self.data.array
         srp = self.data.srp
-        slo = self.data.slo
-        workload = self.data.workload
-        device_id = self.data.device_id
-        volume_attached = self.data.test_attached_volume
-        volume_attached_name = self.data.test_attached_volume.name
-        volume_not_attached = self.data.test_volume
-        volume_not_attached_name = self.data.test_volume.name
-
-        # Extra Specs
+        target_slo = self.data.slo_silver
+        target_workload = self.data.workload
+        volume_name = volume.name
         new_type = {'extra_specs': {}}
-        self.common.rep_config = {'mode': None}
-        src_extra_specs = self.data.extra_specs_migrate
-
-        # Scenario 1: Volume attached
-        with mock.patch.object(self.utils, 'is_replication_enabled',
-                               side_effect=[False, False]):
-            success = self.common._migrate_volume(
-                array, volume_attached, device_id, srp, slo, workload,
-                volume_attached_name, new_type, src_extra_specs)[0]
-            mck_inuse_retype.assert_called_once()
-            self.assertTrue(success)
-
-        mck_cleanup.reset_mock()
-        mck_setup_use.reset_mock()
-
-        # Scenario 2: Volume not attached
-        with mock.patch.object(self.utils, 'is_replication_enabled',
-                               side_effect=[False, False]):
-            success = self.common._migrate_volume(
-                array, volume_not_attached, device_id, srp, slo, workload,
-                volume_not_attached_name, new_type, src_extra_specs)[0]
-            mck_retype.assert_called_once()
-            self.assertTrue(success)
-
-        # Scenario 3: Volume not attached, enable RDF
-        tgt_extra_specs = {
-            'srp': srp, 'array': array, 'slo': slo, 'workload': workload,
-            'interval': src_extra_specs['interval'],
-            'retries': src_extra_specs['retries'],
-            utils.METROBIAS: True}
-        self.common.rep_config[utils.METROBIAS] = True
-        with mock.patch.object(self.utils, 'is_replication_enabled',
-                               side_effect=[False, True]):
-            success = self.common._migrate_volume(
-                array, volume_not_attached, device_id, srp, slo, workload,
-                volume_not_attached_name, new_type, src_extra_specs)[0]
-            mck_setup.assert_called_once_with(array, volume_not_attached,
-                                              device_id, tgt_extra_specs)
-            mck_retype.assert_called_once()
-            self.assertTrue(success)
-
-    @mock.patch.object(masking.PowerMaxMasking, 'remove_and_reset_members')
-    def test_migrate_volume_failed_get_new_sg_failed(self, mock_remove):
-        device_id = self.data.device_id
-        volume_name = self.data.test_volume.name
         extra_specs = self.data.extra_specs
-        new_type = {'extra_specs': {}}
-        with mock.patch.object(
-                self.masking, 'get_or_create_default_storage_group',
-                side_effect=exception.VolumeBackendAPIException):
-            migrate_status = self.common._migrate_volume(
-                self.data.array, self.data.test_volume, device_id,
-                self.data.srp, self.data.slo,
-                self.data.workload, volume_name, new_type, extra_specs)
-            self.assertFalse(migrate_status)
 
-    def test_migrate_volume_failed_vol_not_added(self):
-        device_id = self.data.device_id
-        volume_name = self.data.test_volume.name
-        extra_specs = self.data.extra_specs
-        new_type = {'extra_specs': {}}
-        with mock.patch.object(
-                self.rest, 'is_volume_in_storagegroup',
-                return_value=False):
-            migrate_status = self.common._migrate_volume(
-                self.data.array, self.data.test_volume, device_id,
-                self.data.srp, self.data.slo,
-                self.data.workload, volume_name, new_type, extra_specs)[0]
-            self.assertFalse(migrate_status)
+        target_extra_specs = {
+            utils.SRP: srp, utils.ARRAY: array_id, utils.SLO: target_slo,
+            utils.WORKLOAD: target_workload,
+            utils.INTERVAL: extra_specs[utils.INTERVAL],
+            utils.RETRIES: extra_specs[utils.RETRIES],
+            utils.DISABLECOMPRESSION: False}
+
+        success, model_update = self.common._migrate_volume(
+            array_id, volume, device_id, srp, target_slo, target_workload,
+            volume_name, new_type, extra_specs)
+        mck_retype.assert_called_once_with(
+            array_id, srp, device_id, volume, volume_name, extra_specs,
+            target_slo, target_workload, target_extra_specs)
+        self.assertTrue(success)
 
     def test_is_valid_for_storage_assisted_migration_true(self):
         device_id = self.data.device_id
@@ -2170,24 +1971,25 @@ class PowerMaxCommonTest(test.TestCase):
                 group, volumes)
         self.assertEqual(ref_model_update, model_update)
 
-    @mock.patch.object(
-        common.PowerMaxCommon, '_get_clone_vol_info',
-        return_value=(tpd.PowerMaxData.device_id,
-                      tpd.PowerMaxData.extra_specs, 1, 'tgt_vol'))
-    @mock.patch.object(volume_utils, 'is_group_a_cg_snapshot_type',
-                       return_value=True)
-    @mock.patch.object(volume_utils, 'is_group_a_type',
-                       return_value=False)
-    @mock.patch.object(common.PowerMaxCommon, 'get_volume_metadata',
-                       return_value='')
-    def test_create_group_from_src_success(self, mck_meta, mock_type,
-                                           mock_cg_type, mock_info):
-        ref_model_update = {'status': fields.GroupStatus.AVAILABLE}
-        model_update, volumes_model_update = (
-            self.common.create_group_from_src(
-                None, self.data.test_group_1, [self.data.test_volume],
-                self.data.test_group_snapshot_1, [], None, []))
-        self.assertEqual(ref_model_update, model_update)
+    # TODO: FIX THIS
+    # @mock.patch.object(
+    #     common.PowerMaxCommon, '_get_clone_vol_info',
+    #     return_value=(tpd.PowerMaxData.device_id,
+    #                   tpd.PowerMaxData.extra_specs, 1, 'tgt_vol'))
+    # @mock.patch.object(volume_utils, 'is_group_a_cg_snapshot_type',
+    #                    return_value=True)
+    # @mock.patch.object(volume_utils, 'is_group_a_type',
+    #                    return_value=False)
+    # @mock.patch.object(common.PowerMaxCommon, 'get_volume_metadata',
+    #                    return_value='')
+    # def test_create_group_from_src_success(self, mck_meta, mock_type,
+    #                                        mock_cg_type, mock_info):
+    #     ref_model_update = {'status': fields.GroupStatus.AVAILABLE}
+    #     model_update, volumes_model_update = (
+    #         self.common.create_group_from_src(
+    #             None, self.data.test_group_1, [self.data.test_volume],
+    #             self.data.test_group_snapshot_1, [], None, []))
+    #     self.assertEqual(ref_model_update, model_update)
 
     @mock.patch.object(
         common.PowerMaxCommon, '_remove_vol_and_cleanup_replication')
@@ -2745,52 +2547,43 @@ class PowerMaxCommonTest(test.TestCase):
         self.assertTrue(r2_ode)
         self.assertTrue(r2_ode_metro)
 
-    @mock.patch.object(common.PowerMaxCommon,
-                       '_add_new_volume_to_volume_group')
-    @mock.patch.object(common.PowerMaxCommon, 'setup_volume_replication')
-    @mock.patch.object(provision.PowerMaxProvision, 'extend_volume')
-    @mock.patch.object(rest.PowerMaxRest, 'get_size_of_device_on_array',
-                       return_value=tpd.PowerMaxData.test_volume.size)
-    @mock.patch.object(provision.PowerMaxProvision, 'break_rdf_relationship')
-    @mock.patch.object(masking.PowerMaxMasking, 'remove_and_reset_members')
+    @mock.patch.object(rest.PowerMaxRest, 'srdf_resume_replication')
+    @mock.patch.object(common.PowerMaxCommon, '_protect_storage_group')
     @mock.patch.object(
-        common.PowerMaxCommon, '_get_replication_extra_specs',
-        return_value=tpd.PowerMaxData.rep_extra_specs)
-    @mock.patch.object(
-        common.PowerMaxCommon, 'get_remote_target_device',
-        return_value=(
-            tpd.PowerMaxData.device_id2, tpd.PowerMaxData.remote_array,
-            tpd.PowerMaxData.rdf_group_vol_details['localRdfGroupNumber'],
-            tpd.PowerMaxData.rdf_group_vol_details['localVolumeState'],
-            tpd.PowerMaxData.rdf_group_vol_details['rdfpairState']))
-    def test_extend_legacy_replicated_vol(self, mck_get_tgt, mck_rdf_specs,
-                                          mck_reset, mck_break_rdf, mck_size,
-                                          mck_extend, mck_set_rep, mck_add):
-
+        common.PowerMaxCommon, 'configure_volume_replication',
+        return_value=('first_vol_in_rdf_group', None, None,
+                      tpd.PowerMaxData.rep_extra_specs_mgmt, True))
+    @mock.patch.object(provision.PowerMaxProvision, 'extend_volume')
+    @mock.patch.object(common.PowerMaxCommon, 'break_rdf_device_pair_session')
+    def test_extend_legacy_replicated_vol(
+            self, mck_break, mck_extend, mck_configure, mck_protect, mck_res):
         volume = self.data.test_volume_group_member
         array = self.data.array
         device_id = self.data.device_id
         new_size = volume.size + 1
-        extra_specs = deepcopy(self.data.extra_specs)
-
+        extra_specs = self.data.extra_specs
+        rdf_group_no = self.data.rdf_group_no
         self.common._extend_legacy_replicated_vol(
-            array, volume, device_id, volume.name, new_size, extra_specs)
+            array, volume, device_id, volume.name, new_size, extra_specs,
+            rdf_group_no)
+        mck_protect.assert_called_once()
+        mck_res.assert_called_once()
 
     @mock.patch.object(
-        common.PowerMaxCommon, 'get_remote_target_device',
-        return_value=(None, None, None, None, None))
-    @mock.patch.object(common.PowerMaxCommon, '_sync_check')
-    def test_extend_legacy_replicated_vol_fail(self, mck_sync, mck_get_tgt):
-
+        common.PowerMaxCommon, 'break_rdf_device_pair_session',
+        side_effect=exception.VolumeBackendAPIException)
+    def test_extend_legacy_replicated_vol_fail(self, mck_resume):
         volume = self.data.test_volume_group_member
         array = self.data.array
         device_id = self.data.device_id
         new_size = volume.size + 1
-        extra_specs = deepcopy(self.data.extra_specs)
+        extra_specs = self.data.extra_specs
+        rdf_group_no = self.data.rdf_group_no
         self.assertRaises(
             exception.VolumeBackendAPIException,
-            self.common._extend_vol_validation_checks,
-            array, device_id, volume.name, extra_specs, volume.size, new_size)
+            self.common._extend_legacy_replicated_vol,
+            array, device_id, volume.name, extra_specs, volume.size, new_size,
+            rdf_group_no)
 
     def test_get_unisphere_port(self):
         # Test user set port ID
@@ -2867,8 +2660,7 @@ class PowerMaxCommonTest(test.TestCase):
         self.assertEqual(3, mck_unlink.call_count)
 
     @mock.patch.object(provision.PowerMaxProvision, 'delete_temp_volume_snap')
-    @mock.patch.object(provision.PowerMaxProvision,
-                       'break_replication_relationship')
+    @mock.patch.object(provision.PowerMaxProvision, 'unlink_snapvx_tgt_volume')
     def test_unlink_targets_and_delete_temp_snapvx(self, mck_break, mck_del):
         array = self.data.array
         extra_specs = self.data.extra_specs
@@ -3101,3 +2893,289 @@ class PowerMaxCommonTest(test.TestCase):
         model_update = self.common.update_metadata(
             model_update, existing_metadata, object_metadata)
         self.assertEqual(ref_model_update, model_update)
+
+    def test_update_metadata_model_list_exception(self):
+        model_update = [{'provider_location': six.text_type(
+            self.data.provider_location)}]
+
+        existing_metadata = None
+
+        object_metadata = {'device-meta-key-1': 'device-meta-value-1',
+                           'device-meta-key-2': 'device-meta-value-2'}
+
+        self.assertRaises(
+            exception.VolumeBackendAPIException,
+            self.common.update_metadata, model_update, existing_metadata,
+            object_metadata)
+
+    @mock.patch.object(rest.PowerMaxRest, 'get_storage_group',
+                       return_value=tpd.PowerMaxData.add_volume_sg_info_dict)
+    def test_get_tags_of_storage_group_none(self, mock_sg):
+        self.assertIsNone(self.common.get_tags_of_storage_group(
+            self.data.array, self.data.defaultstoragegroup_name))
+
+    @mock.patch.object(rest.PowerMaxRest, 'get_storage_group',
+                       return_value=tpd.PowerMaxData.storage_group_with_tags)
+    def test_get_tags_of_storage_group_exists(self, mock_sg):
+        tag_list = self.common.get_tags_of_storage_group(
+            self.data.array, self.data.defaultstoragegroup_name)
+        self.assertEqual(tpd.PowerMaxData.sg_tags, tag_list)
+
+    @mock.patch.object(rest.PowerMaxRest, 'get_storage_group',
+                       side_effect=exception.APIException)
+    def test_get_tags_of_storage_group_exception(self, mock_sg):
+        self.assertIsNone(self.common.get_tags_of_storage_group(
+            self.data.array, self.data.storagegroup_name_f))
+
+    @mock.patch.object(rest.PowerMaxRest, 'add_storage_array_tags')
+    @mock.patch.object(rest.PowerMaxRest, 'get_array_tags',
+                       return_value=[])
+    def test_check_and_add_tags_to_storage_array(
+            self, mock_get_tags, mock_add_tags):
+        array_tag_list = ['OpenStack']
+        self.common._check_and_add_tags_to_storage_array(
+            self.data.array, array_tag_list, self.data.extra_specs)
+        mock_add_tags.assert_called_with(
+            self.data.array, array_tag_list, self.data.extra_specs)
+
+    @mock.patch.object(rest.PowerMaxRest, 'add_storage_array_tags')
+    @mock.patch.object(rest.PowerMaxRest, 'get_array_tags',
+                       return_value=[])
+    def test_check_and_add_tags_to_storage_array_add_2_tags(
+            self, mock_get_tags, mock_add_tags):
+        array_tag_list = ['OpenStack', 'Production']
+        self.common._check_and_add_tags_to_storage_array(
+            self.data.array, array_tag_list, self.data.extra_specs)
+        mock_add_tags.assert_called_with(
+            self.data.array, array_tag_list, self.data.extra_specs)
+
+    @mock.patch.object(rest.PowerMaxRest, 'add_storage_array_tags')
+    @mock.patch.object(rest.PowerMaxRest, 'get_array_tags',
+                       return_value=['Production'])
+    def test_check_and_add_tags_to_storage_array_add_1_tags(
+            self, mock_get_tags, mock_add_tags):
+        array_tag_list = ['OpenStack', 'Production']
+        add_tag_list = ['OpenStack']
+        self.common._check_and_add_tags_to_storage_array(
+            self.data.array, array_tag_list, self.data.extra_specs)
+        mock_add_tags.assert_called_with(
+            self.data.array, add_tag_list, self.data.extra_specs)
+
+    @mock.patch.object(rest.PowerMaxRest, 'add_storage_array_tags')
+    @mock.patch.object(rest.PowerMaxRest, 'get_array_tags',
+                       return_value=['openstack'])
+    def test_check_and_add_tags_to_storage_array_already_tagged(
+            self, mock_get_tags, mock_add_tags):
+        array_tag_list = ['OpenStack']
+        self.common._check_and_add_tags_to_storage_array(
+            self.data.array, array_tag_list, self.data.extra_specs)
+        mock_add_tags.assert_not_called()
+
+    @mock.patch.object(rest.PowerMaxRest, 'get_array_tags',
+                       return_value=[])
+    def test_check_and_add_tags_to_storage_array_invalid_tag(
+            self, mock_get_tags):
+        array_tag_list = ['Open$tack']
+        self.assertRaises(
+            exception.VolumeBackendAPIException,
+            self.common._check_and_add_tags_to_storage_array,
+            self.data.array, array_tag_list, self.data.extra_specs)
+
+    def test_validate_storage_group_tag_list_good_tag_list(self):
+        self.common._validate_storage_group_tag_list(
+            self.data.vol_type_extra_specs_tags)
+
+    @mock.patch.object(utils.PowerMaxUtils, 'verify_tag_list')
+    def test_validate_storage_group_tag_list_no_tag_list(
+            self, mock_verify):
+        self.common._validate_storage_group_tag_list(
+            self.data.extra_specs)
+        mock_verify.assert_not_called()
+
+    def test_set_config_file_and_get_extra_specs(self):
+        self.common.rep_config = {
+            'mode': utils.REP_METRO, utils.METROBIAS: True}
+        with mock.patch.object(self.utils, 'get_volumetype_extra_specs',
+                               return_value=self.data.rep_extra_specs_metro):
+            extra_specs, __ = self.common._set_config_file_and_get_extra_specs(
+                self.data.test_volume, None)
+            self.assertEqual(self.data.rep_extra_specs_metro, extra_specs)
+
+    @mock.patch.object(rest.PowerMaxRest, 'is_volume_in_storagegroup',
+                       return_value=True)
+    @mock.patch.object(masking.PowerMaxMasking,
+                       'return_volume_to_volume_group')
+    @mock.patch.object(masking.PowerMaxMasking,
+                       'move_volume_between_storage_groups')
+    @mock.patch.object(
+        masking.PowerMaxMasking, 'get_or_create_default_storage_group',
+        return_value=tpd.PowerMaxData.rdf_managed_async_grp)
+    @mock.patch.object(rest.PowerMaxRest, 'get_volume',
+                       return_value=tpd.PowerMaxData.volume_details[0])
+    @mock.patch.object(utils.PowerMaxUtils, 'get_rdf_management_group_name',
+                       return_value=tpd.PowerMaxData.rdf_managed_async_grp)
+    def test_retype_volume_detached(
+            self, mck_get_rdf, mck_get_vol, mck_get_sg, mck_move_vol,
+            mck_return_vol, mck_is_vol):
+
+        array = self.data.array
+        srp = self.data.srp
+        device_id = self.data.device_id
+        volume = self.data.test_volume
+        volume_name = self.data.volume_id
+        extra_specs = self.data.rep_extra_specs
+        target_slo = self.data.slo_silver
+        target_workload = self.data.workload
+        target_extra_specs = deepcopy(self.data.rep_extra_specs)
+        target_extra_specs[utils.DISABLECOMPRESSION] = False
+        group_name = self.data.rdf_managed_async_grp
+
+        success, target_sg_name = self.common._retype_volume(
+            array, srp, device_id, volume, volume_name, extra_specs,
+            target_slo, target_workload, target_extra_specs, remote=True)
+
+        mck_get_rdf.assert_called_once_with(self.common.rep_config)
+        mck_get_vol.assert_called_once_with(array, device_id)
+        mck_get_sg.assert_called_once_with(
+            array, srp, target_slo, target_workload, extra_specs,
+            False, True, target_extra_specs['rep_mode'])
+        mck_move_vol.assert_called_once_with(
+            array, device_id, self.data.volume_details[0]['storageGroupId'][0],
+            group_name, extra_specs, force=True)
+        mck_return_vol.assert_called_once_with(
+            array, volume, device_id, volume_name, extra_specs)
+        mck_is_vol.assert_called_once_with(array, device_id, group_name)
+        self.assertTrue(success)
+        self.assertEqual(group_name, target_sg_name)
+
+    @mock.patch.object(
+        utils.PowerMaxUtils, 'get_port_name_label',
+        return_value='my_pg')
+    @mock.patch.object(
+        utils.PowerMaxUtils, 'get_volume_attached_hostname',
+        return_value='HostX')
+    @mock.patch.object(
+        rest.PowerMaxRest, 'is_volume_in_storagegroup', return_value=True)
+    @mock.patch.object(
+        masking.PowerMaxMasking, 'return_volume_to_volume_group')
+    @mock.patch.object(
+        masking.PowerMaxMasking, 'move_volume_between_storage_groups')
+    @mock.patch.object(
+        masking.PowerMaxMasking, 'add_child_sg_to_parent_sg')
+    @mock.patch.object(
+        provision.PowerMaxProvision, 'create_storage_group')
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_storage_group',
+        side_effect=[None, tpd.PowerMaxData.volume_info_dict])
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_volume',
+        return_value=tpd.PowerMaxData.volume_details[0])
+    @mock.patch.object(
+        utils.PowerMaxUtils, 'get_rdf_management_group_name',
+        return_value=tpd.PowerMaxData.rdf_managed_async_grp)
+    def test_retype_volume_attached(
+            self, mck_get_rdf, mck_get_vol, mck_get_sg, mck_create, mck_add,
+            mck_move_vol, mck_return_vol, mck_is_vol, mck_host, mck_pg):
+
+        array = self.data.array
+        srp = self.data.srp
+        device_id = self.data.device_id
+        volume = self.data.test_attached_volume
+        volume_name = self.data.volume_id
+        extra_specs = self.data.rep_extra_specs
+        target_slo = self.data.slo_silver
+        target_workload = deepcopy(self.data.workload)
+        target_extra_specs = self.data.rep_extra_specs
+        target_extra_specs[utils.DISABLECOMPRESSION] = False
+
+        success, target_sg_name = self.common._retype_volume(
+            array, srp, device_id, volume, volume_name, extra_specs,
+            target_slo, target_workload, target_extra_specs)
+        mck_get_rdf.assert_called_once()
+        mck_get_vol.assert_called_once()
+        mck_create.assert_called_once()
+        mck_add.assert_called_once()
+        mck_move_vol.assert_called_once()
+        mck_return_vol.assert_called_once()
+        mck_is_vol.assert_called_once()
+        self.assertEqual(2, mck_get_sg.call_count)
+        self.assertTrue(success)
+
+    @mock.patch.object(
+        utils.PowerMaxUtils, 'get_volume_attached_hostname', return_value=None)
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_volume',
+        return_value=tpd.PowerMaxData.volume_details[0])
+    @mock.patch.object(
+        utils.PowerMaxUtils, 'get_rdf_management_group_name',
+        return_value=tpd.PowerMaxData.rdf_managed_async_grp)
+    def test_retype_volume_attached_no_host_fail(
+            self, mck_get_rdf, mck_get_vol, mck_get_host):
+
+        array = self.data.array
+        srp = self.data.srp
+        device_id = self.data.device_id
+        volume = self.data.test_attached_volume
+        volume_name = self.data.volume_id
+        extra_specs = self.data.rep_extra_specs
+        target_slo = self.data.slo_silver
+        target_workload = self.data.workload
+        target_extra_specs = deepcopy(self.data.rep_extra_specs)
+        target_extra_specs[utils.DISABLECOMPRESSION] = False
+
+        success, target_sg_name = self.common._retype_volume(
+            array, srp, device_id, volume, volume_name, extra_specs,
+            target_slo, target_workload, target_extra_specs)
+        mck_get_rdf.assert_called_once()
+        mck_get_vol.assert_called_once()
+        self.assertFalse(success)
+        self.assertIsNone(target_sg_name)
+
+    @mock.patch.object(rest.PowerMaxRest, 'is_volume_in_storagegroup',
+                       return_value=False)
+    @mock.patch.object(masking.PowerMaxMasking,
+                       'return_volume_to_volume_group')
+    @mock.patch.object(masking.PowerMaxMasking,
+                       'move_volume_between_storage_groups')
+    @mock.patch.object(
+        masking.PowerMaxMasking, 'get_or_create_default_storage_group',
+        return_value=tpd.PowerMaxData.rdf_managed_async_grp)
+    @mock.patch.object(rest.PowerMaxRest, 'get_volume',
+                       return_value=tpd.PowerMaxData.volume_details[0])
+    @mock.patch.object(utils.PowerMaxUtils, 'get_rdf_management_group_name',
+                       return_value=tpd.PowerMaxData.rdf_managed_async_grp)
+    def test_retype_volume_detached_vol_not_in_sg_fail(
+            self, mck_get_rdf, mck_get_vol, mck_get_sg, mck_move_vol,
+            mck_return_vol, mck_is_vol):
+
+        array = self.data.array
+        srp = self.data.srp
+        device_id = self.data.device_id
+        volume = self.data.test_volume
+        volume_name = self.data.volume_id
+        extra_specs = self.data.rep_extra_specs
+        target_slo = self.data.slo_silver
+        target_workload = self.data.workload
+        target_extra_specs = deepcopy(self.data.rep_extra_specs)
+        target_extra_specs[utils.DISABLECOMPRESSION] = False
+
+        success, target_sg_name = self.common._retype_volume(
+            array, srp, device_id, volume, volume_name, extra_specs,
+            target_slo, target_workload, target_extra_specs, remote=True)
+        self.assertFalse(success)
+        self.assertIsNone(target_sg_name)
+
+    @mock.patch.object(
+        rest.PowerMaxRest, 'rename_volume')
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_rdf_pair_volume',
+        return_value=tpd.PowerMaxData.rdf_group_vol_details)
+    def test_get_and_set_remote_device_uuid(self, mck_get_pair, mck_rename):
+        extra_specs = self.data.rep_extra_specs
+        rep_extra_specs = self.data.rep_extra_specs_mgmt
+        volume_dict = {'device_id': self.data.device_id,
+                       'device_uuid': self.data.volume_id}
+
+        remote_vol = self.common.get_and_set_remote_device_uuid(
+            extra_specs, rep_extra_specs, volume_dict)
+        self.assertEqual(remote_vol, self.data.device_id2)
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_fc.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_fc.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_fc.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_fc.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 from cinder import test
 from cinder.tests.unit.volume.drivers.dell_emc.powermax import (
@@ -150,6 +150,19 @@ class PowerMaxFCTest(test.TestCase):
 
     @mock.patch.object(
         common.PowerMaxCommon, 'get_masking_views_from_volume',
+        side_effect = ([(None, False),
+                        ([tpd.PowerMaxData.masking_view_name_f], False)]))
+    def test_get_zoning_mappings_retry_backward_compatibility(
+            self, mock_views):
+        with mock.patch.object(self.common.utils, 'get_host_name_label',
+                               return_value=None) as mock_label:
+            self.driver._get_zoning_mappings(
+                self.data.test_volume, self.data.connector)
+            self.assertEqual(2, mock_label.call_count)
+            self.assertEqual(2, mock_views.call_count)
+
+    @mock.patch.object(
+        common.PowerMaxCommon, 'get_masking_views_from_volume',
         return_value=([tpd.PowerMaxData.masking_view_name_f], True))
     def test_get_zoning_mappings_metro(self, mock_mv):
         ref_mappings = self.data.zoning_mappings_metro
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_iscsi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_iscsi.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_iscsi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_iscsi.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,8 +14,7 @@
 #    under the License.
 
 from copy import deepcopy
-
-import mock
+from unittest import mock
 
 from cinder import exception
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_masking.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_masking.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_masking.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_masking.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,7 +14,7 @@
 #    under the License.
 
 from copy import deepcopy
-import mock
+from unittest import mock
 
 from cinder import exception
 from cinder import test
@@ -162,6 +162,25 @@ class PowerMaxMaskingTest(test.TestCase)
                 self.data.extra_specs)
         mock_rm.assert_called_once()
 
+    @mock.patch.object(rest.PowerMaxRest, 'remove_child_sg_from_parent_sg')
+    @mock.patch.object(masking.PowerMaxMasking, 'get_parent_sg_from_child',
+                       side_effect=[None, tpd.PowerMaxData.parent_sg_f])
+    @mock.patch.object(rest.PowerMaxRest, 'move_volume_between_storage_groups')
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_num_vols_in_sg', return_value=1)
+    def test_force_move_volume_between_storage_groups(
+            self, mock_num, mock_move, mock_parent, mock_rm):
+
+        self.driver.masking.move_volume_between_storage_groups(
+            self.data.array, self.data.device_id,
+            self.data.storagegroup_name_i, self.data.storagegroup_name_f,
+            self.data.extra_specs, force=True)
+
+        mock_move.assert_called_once_with(
+            self.data.array, self.data.device_id,
+            self.data.storagegroup_name_i, self.data.storagegroup_name_f,
+            self.data.extra_specs, True)
+
     @mock.patch.object(rest.PowerMaxRest, 'get_masking_view',
                        side_effect=[tpd.PowerMaxData.maskingview,
                                     tpd.PowerMaxData.maskingview, None])
@@ -234,7 +253,8 @@ class PowerMaxMaskingTest(test.TestCase)
 
     @mock.patch.object(
         rest.PowerMaxRest, 'get_storage_group',
-        side_effect=[tpd.PowerMaxData.storagegroup_name_i, None, None])
+        side_effect=[tpd.PowerMaxData.storagegroup_name_i, None,
+                     tpd.PowerMaxData.storagegroup_name_i])
     @mock.patch.object(
         provision.PowerMaxProvision, 'create_storage_group',
         side_effect=[tpd.PowerMaxData.storagegroup_name_i, None])
@@ -243,11 +263,21 @@ class PowerMaxMaskingTest(test.TestCase)
             self.driver.masking._get_or_create_storage_group(
                 self.data.array, self.maskingviewdict,
                 self.data.storagegroup_name_i, self.extra_specs)
+        self.assertEqual(3, mock_get_sg.call_count)
+        self.assertEqual(1, mock_sg.call_count)
+
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_storage_group',
+        side_effect=[None, tpd.PowerMaxData.storagegroup_name_i])
+    @mock.patch.object(
+        provision.PowerMaxProvision, 'create_storage_group',
+        side_effect=[tpd.PowerMaxData.storagegroup_name_i])
+    def test_get_or_create_storage_group_is_parent(self, mock_sg, mock_get_sg):
         self.driver.masking._get_or_create_storage_group(
             self.data.array, self.maskingviewdict,
             self.data.storagegroup_name_i, self.extra_specs, True)
-        self.assertEqual(3, mock_get_sg.call_count)
-        self.assertEqual(2, mock_sg.call_count)
+        self.assertEqual(2, mock_get_sg.call_count)
+        self.assertEqual(1, mock_sg.call_count)
 
     @mock.patch.object(masking.PowerMaxMasking, '_move_vol_from_default_sg',
                        return_value=None)
@@ -271,7 +301,8 @@ class PowerMaxMaskingTest(test.TestCase)
                              tpd.PowerMaxData.storagegroup_name_i]):
             _, msg = (self.driver.masking._check_existing_storage_group(
                 self.data.array, self.maskingviewdict['maskingview_name'],
-                self.data.defaultstoragegroup_name, masking_view_dict))
+                self.data.defaultstoragegroup_name, masking_view_dict,
+                self.data.extra_specs))
             self.assertIsNone(msg)
             mock_create_sg.assert_not_called()
 
@@ -280,7 +311,8 @@ class PowerMaxMaskingTest(test.TestCase)
                                    tpd.PowerMaxData.parent_sg_i, None]):
             _, msg = (self.driver.masking._check_existing_storage_group(
                 self.data.array, self.maskingviewdict['maskingview_name'],
-                self.data.defaultstoragegroup_name, masking_view_dict))
+                self.data.defaultstoragegroup_name, masking_view_dict,
+                self.data.extra_specs))
             self.assertIsNone(msg)
             mock_create_sg.assert_called_once_with(
                 self.data.array, masking_view_dict,
@@ -305,7 +337,8 @@ class PowerMaxMaskingTest(test.TestCase)
         for x in range(0, 4):
             _, msg = (self.driver.masking._check_existing_storage_group(
                 self.data.array, self.maskingviewdict['maskingview_name'],
-                self.data.defaultstoragegroup_name, masking_view_dict))
+                self.data.defaultstoragegroup_name, masking_view_dict,
+                self.data.extra_specs))
             self.assertIsNotNone(msg)
         self.assertEqual(7, mock_get_sg.call_count)
         self.assertEqual(1, mock_move.call_count)
@@ -819,7 +852,7 @@ class PowerMaxMaskingTest(test.TestCase)
                    self.data.masking_view_name_f]
         with mock.patch.object(
                 rest.PowerMaxRest, 'get_masking_views_by_initiator_group',
-                side_effect=[mv_list, []]):
+                side_effect=[mv_list, mv_list, [], []]):
             self.mask._last_volume_delete_initiator_group(
                 self.data.array, self.data.initiatorgroup_name_i,
                 self.data.connector['host'])
@@ -960,7 +993,8 @@ class PowerMaxMaskingTest(test.TestCase)
     def test_pre_multiattach(self, mock_return):
         mv_dict = self.mask.pre_multiattach(
             self.data.array, self.data.device_id,
-            self.data.masking_view_dict_multiattach, self.data.extra_specs)
+            self.data.masking_view_dict_multiattach,
+            self.data.extra_specs)
         mock_return.assert_not_called()
         self.assertEqual(self.data.storagegroup_name_f,
                          mv_dict[utils.FAST_SG])
@@ -979,7 +1013,8 @@ class PowerMaxMaskingTest(test.TestCase)
                                return_value='DiamondDSS'):
             self.mask.pre_multiattach(
                 self.data.array, self.data.device_id,
-                self.data.masking_view_dict_multiattach, self.data.extra_specs)
+                self.data.masking_view_dict_multiattach,
+                self.data.extra_specs)
             utils.PowerMaxUtils.truncate_string.assert_called_once_with(
                 'DiamondDSS', 10)
 
@@ -993,7 +1028,8 @@ class PowerMaxMaskingTest(test.TestCase)
             self, mock_return, mock_sg):
         for x in range(0, 2):
             self.mask.return_volume_to_fast_managed_group(
-                self.data.array, self.data.device_id, self.data.extra_specs)
+                self.data.array, self.data.device_id,
+                self.data.extra_specs)
         no_slo_specs = deepcopy(self.data.extra_specs)
         no_slo_specs[utils.SLO] = None
         self.mask.return_volume_to_fast_managed_group(
@@ -1050,3 +1086,73 @@ class PowerMaxMaskingTest(test.TestCase)
             self.data.parent_sg_f, self.data.extra_specs)
         mock_rm.assert_called_once()
         self.assertEqual(2, mock_del.call_count)
+
+    @mock.patch.object(utils.PowerMaxUtils, 'verify_tag_list')
+    def test_add_tags_to_storage_group_disabled(self, mock_verify):
+        self.mask._add_tags_to_storage_group(
+            self.data.array, self.data.add_volume_sg_info_dict,
+            self.data.extra_specs)
+        mock_verify.assert_not_called()
+
+    @mock.patch.object(utils.PowerMaxUtils, 'verify_tag_list')
+    def test_add_tags_to_storage_group_enabled(self, mock_verify):
+        self.mask._add_tags_to_storage_group(
+            self.data.array, self.data.add_volume_sg_info_dict,
+            self.data.extra_specs_tags)
+        mock_verify.assert_called()
+
+    @mock.patch.object(utils.PowerMaxUtils, 'get_new_tags')
+    def test_add_tags_to_storage_group_existing_tags(self, mock_inter):
+        self.mask._add_tags_to_storage_group(
+            self.data.array, self.data.storage_group_with_tags,
+            self.data.extra_specs_tags)
+        mock_inter.assert_called()
+
+    @mock.patch.object(rest.PowerMaxRest, 'add_storage_group_tag',
+                       side_effect=[exception.VolumeBackendAPIException])
+    def test_add_tags_to_storage_group_exception(self, mock_except):
+        self.mask._add_tags_to_storage_group(
+            self.data.array, self.data.add_volume_sg_info_dict,
+            self.data.extra_specs_tags)
+        mock_except.assert_called()
+
+    @mock.patch.object(rest.PowerMaxRest,
+                       'get_masking_views_from_storage_group',
+                       return_value=[tpd.PowerMaxData.masking_view_name_f])
+    def test_get_host_and_port_group_labels(self, mock_mv):
+        host_label, port_group_label = (
+            self.mask._get_host_and_port_group_labels(
+                self.data.array, self.data.parent_sg_f))
+        self.assertEqual('HostX', host_label)
+        self.assertEqual('OS-fibre-PG', port_group_label)
+
+    @mock.patch.object(rest.PowerMaxRest,
+                       'get_masking_views_from_storage_group',
+                       return_value=['OS-HostX699ea-I-p-name3b02c-MV'])
+    def test_get_host_and_port_group_labels_complex(self, mock_mv):
+        host_label, port_group_label = (
+            self.mask._get_host_and_port_group_labels(
+                self.data.array, self.data.parent_sg_f))
+        self.assertEqual('HostX699ea', host_label)
+        self.assertEqual('p-name3b02c', port_group_label)
+
+    @mock.patch.object(rest.PowerMaxRest,
+                       'get_masking_views_from_storage_group',
+                       return_value=['OS-myhost-I-myportgroup-MV'])
+    def test_get_host_and_port_group_labels_plain(self, mock_mv):
+        host_label, port_group_label = (
+            self.mask._get_host_and_port_group_labels(
+                self.data.array, self.data.parent_sg_f))
+        self.assertEqual('myhost', host_label)
+        self.assertEqual('myportgroup', port_group_label)
+
+    @mock.patch.object(rest.PowerMaxRest,
+                       'get_masking_views_from_storage_group',
+                       return_value=[
+                           'OS-host-with-dash-I-portgroup-with-dashes-MV'])
+    def test_get_host_and_port_group_labels_dashes(self, mock_mv):
+        host_label, port_group_label = (
+            self.mask._get_host_and_port_group_labels(
+                self.data.array, self.data.parent_sg_f))
+        self.assertEqual('host-with-dash', host_label)
+        self.assertEqual('portgroup-with-dashes', port_group_label)
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_metadata.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_metadata.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_metadata.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_metadata.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
 import platform
+from unittest import mock
 
 from cinder.objects import fields
 from cinder import test
@@ -74,6 +74,16 @@ class PowerMaxVolumeMetadataDebugTest(te
     @mock.patch.object(
         metadata.PowerMaxVolumeMetadata, 'update_volume_info_metadata',
         return_value={})
+    def test_capture_attach_info_tags(self, mock_uvim):
+        self.volume_metadata.capture_attach_info(
+            self.data.test_volume, self.data.extra_specs,
+            self.data.masking_view_dict_tags, self.data.fake_host,
+            False, False)
+        mock_uvim.assert_called_once()
+
+    @mock.patch.object(
+        metadata.PowerMaxVolumeMetadata, 'update_volume_info_metadata',
+        return_value={})
     def test_capture_create_volume(self, mock_uvim):
         self.volume_metadata.capture_create_volume(
             self.data.device_id, self.data.test_volume, 'test_group',
@@ -193,6 +203,20 @@ class PowerMaxVolumeMetadataDebugTest(te
             sg_list=sg_list)
         self.assertEqual(result_dict, volume_metadata)
 
+    def test_fill_volume_trace_dict_array_tags(self):
+        datadict = {}
+        volume_trace_dict = {}
+        volume_key_value = {}
+        result_dict = {'successful_operation': 'create',
+                       'volume_id': self.data.test_volume.id,
+                       'array_tag_list': ['one', 'two']}
+        volume_metadata = self.volume_metadata._fill_volume_trace_dict(
+            self.data.test_volume.id, 'create', False, target_name=None,
+            datadict=datadict, volume_key_value=volume_key_value,
+            volume_trace_dict=volume_trace_dict,
+            array_tag_list=['one', 'two'])
+        self.assertEqual(result_dict, volume_metadata)
+
     @mock.patch.object(utils.PowerMaxUtils, 'merge_dicts',
                        return_value={})
     def test_consolidate_volume_trace_list(self, mock_m2d):
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_provision.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_provision.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_provision.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_provision.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,9 +13,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-from copy import deepcopy
-
-import mock
+from unittest import mock
 
 from cinder import exception
 from cinder import test
@@ -27,7 +25,6 @@ from cinder.tests.unit.volume.drivers.de
 from cinder.volume.drivers.dell_emc.powermax import iscsi
 from cinder.volume.drivers.dell_emc.powermax import provision
 from cinder.volume.drivers.dell_emc.powermax import rest
-from cinder.volume.drivers.dell_emc.powermax import utils
 from cinder.volume import volume_utils
 
 
@@ -79,6 +76,23 @@ class PowerMaxProvisionTest(test.TestCas
             array, volume_name, storagegroup_name, volume_size, extra_specs)
         self.assertEqual(ref_dict, volume_dict)
 
+    @mock.patch.object(rest.PowerMaxRest, 'create_volume_from_sg')
+    def test_create_volume_from_sg_with_rep_info(self, mck_create):
+        array = self.data.array
+        storagegroup_name = self.data.storagegroup_name_f
+        volume_id = self.data.test_volume.id
+        volume_name = self.utils.get_volume_element_name(volume_id)
+        volume_size = self.data.test_volume.size
+        extra_specs = self.data.extra_specs
+        rep_info_dict = self.data.rep_info_dict
+
+        self.provision.create_volume_from_sg(
+            array, volume_name, storagegroup_name, volume_size, extra_specs,
+            rep_info=rep_info_dict)
+        mck_create.assert_called_once_with(
+            array, volume_name, storagegroup_name, volume_size, extra_specs,
+            rep_info_dict)
+
     def test_delete_volume_from_srp(self):
         array = self.data.array
         device_id = self.data.device_id
@@ -118,7 +132,7 @@ class PowerMaxProvisionTest(test.TestCas
                     snap_name, extra_specs, create_snap=True)
                 mock_modify.assert_called_once_with(
                     array, source_device_id, target_device_id, snap_name,
-                    extra_specs, link=True)
+                    extra_specs, link=True, copy=False)
                 mock_create_snapvx.assert_called_once_with(
                     array, source_device_id, snap_name, extra_specs, ttl=ttl)
 
@@ -134,13 +148,13 @@ class PowerMaxProvisionTest(test.TestCas
                     self.provision.rest, 'modify_volume_snap') as mock_modify:
                 self.provision.create_volume_replica(
                     array, source_device_id, target_device_id,
-                    snap_name, extra_specs, create_snap=False)
+                    snap_name, extra_specs, create_snap=False, copy_mode=True)
                 mock_modify.assert_called_once_with(
                     array, source_device_id, target_device_id, snap_name,
-                    extra_specs, link=True)
+                    extra_specs, link=True, copy=True)
                 mock_create_snapvx.assert_not_called()
 
-    def test_break_replication_relationship(self):
+    def test_unlink_snapvx_tgt_volume(self):
         array = self.data.array
         source_device_id = self.data.device_id
         target_device_id = self.data.device_id2
@@ -149,7 +163,7 @@ class PowerMaxProvisionTest(test.TestCas
 
         with mock.patch.object(
                 self.provision, '_unlink_volume') as mock_unlink:
-            self.provision.break_replication_relationship(
+            self.provision.unlink_snapvx_tgt_volume(
                 array, target_device_id, source_device_id, snap_name,
                 extra_specs, generation=6, loop=True)
             mock_unlink.assert_called_once_with(
@@ -375,56 +389,38 @@ class PowerMaxProvisionTest(test.TestCas
                     self.data.array, self.data.defaultstoragegroup_name))
             self.assertEqual(ref_settings3, sg_slo_settings3)
 
-    @mock.patch.object(rest.PowerMaxRest, 'wait_for_rdf_consistent_state')
-    @mock.patch.object(rest.PowerMaxRest, 'delete_rdf_pair')
-    @mock.patch.object(rest.PowerMaxRest, 'modify_rdf_device_pair')
-    def test_break_rdf_relationship(self, mock_mod, mock_del, mock_wait):
+    @mock.patch.object(rest.PowerMaxRest, 'srdf_delete_device_pair')
+    @mock.patch.object(rest.PowerMaxRest, 'srdf_suspend_replication')
+    @mock.patch.object(rest.PowerMaxRest, 'wait_for_rdf_pair_sync')
+    def test_break_rdf_relationship(self, mock_wait, mock_suspend, mock_del):
         array = self.data.array
         device_id = self.data.device_id
-        target_device = self.data.device_id2
-        rdf_group_name = self.data.rdf_group_name
-        rep_extra_specs = self.data.rep_extra_specs
-        # State is suspended
+        sg_name = self.data.storagegroup_name_f
+        rdf_group = self.data.rdf_group_no
+        extra_specs = self.data.rep_extra_specs
+
+        # sync still in progress
         self.provision.break_rdf_relationship(
-            array, device_id, target_device,
-            rdf_group_name, rep_extra_specs, 'Suspended')
-        mock_mod.assert_not_called()
-        mock_del.assert_called_once_with(
-            array, device_id, rdf_group_name)
+            array, device_id, sg_name, rdf_group, extra_specs, 'SyncInProg')
+        mock_wait.assert_called_once_with(array, rdf_group, device_id,
+                                          extra_specs)
+        mock_del.assert_called_once_with(array, rdf_group, device_id)
+        mock_wait.reset_mock()
+        mock_suspend.reset_mock()
         mock_del.reset_mock()
-        # State is synchronized
+
+        # State is Consistent, need to suspend
         self.provision.break_rdf_relationship(
-            array, device_id, target_device,
-            rdf_group_name, rep_extra_specs, 'Synchronized')
-        mock_mod.assert_called_once_with(
-            array, device_id, rdf_group_name, rep_extra_specs,
-            suspend=True)
-        mock_del.assert_called_once_with(
-            array, device_id, rdf_group_name)
-        # sync still in progress
+            array, device_id, sg_name, rdf_group, extra_specs, 'Consistent')
+        mock_suspend.assert_called_once_with(array, sg_name, rdf_group,
+                                             extra_specs)
+        mock_del.assert_called_once_with(array, rdf_group, device_id)
+        mock_del.reset_mock()
+
+        # State is synchronized
         self.provision.break_rdf_relationship(
-            array, device_id, target_device,
-            rdf_group_name, rep_extra_specs, 'SyncInProg')
-        mock_wait.assert_called_once()
-
-    @mock.patch.object(provision.PowerMaxProvision,
-                       'disable_group_replication')
-    @mock.patch.object(provision.PowerMaxProvision, 'delete_rdf_pair')
-    def test_break_metro_rdf_pair(self, mock_del, mock_disable):
-        self.provision.break_metro_rdf_pair(
-            self.data.array, self.data.device_id, self.data.device_id2,
-            self.data.rdf_group_no, self.data.rep_extra_specs, 'metro_grp')
-        mock_del.assert_called_once()
-
-    def test_delete_rdf_pair_async(self):
-        with mock.patch.object(
-                self.provision.rest, 'delete_rdf_pair') as mock_del_rdf:
-            extra_specs = deepcopy(self.data.extra_specs)
-            extra_specs[utils.REP_MODE] = utils.REP_ASYNC
-            self.provision.delete_rdf_pair(
-                self.data.array, self.data.device_id,
-                self.data.rdf_group_no, self.data.device_id2, extra_specs)
-            mock_del_rdf.assert_called_once()
+            array, device_id, sg_name, rdf_group, extra_specs, 'Synchronized')
+        mock_del.assert_called_once_with(array, rdf_group, device_id)
 
     @mock.patch.object(rest.PowerMaxRest, 'get_storage_group',
                        return_value=None)
@@ -454,15 +450,39 @@ class PowerMaxProvisionTest(test.TestCas
         array = self.data.array
         snap_name = self.data.group_snapshot_name
         source_group_name = self.data.storagegroup_name_source
-        extra_specs = self.data.extra_specs
-        src_dev_ids = [self.data.device_id]
         with mock.patch.object(
                 self.provision,
                 'delete_group_replica') as mock_delete_replica:
             self.provision.delete_group_replica(
-                array, snap_name, source_group_name, src_dev_ids, extra_specs)
+                array, snap_name, source_group_name)
             mock_delete_replica.assert_called_once_with(
-                array, snap_name, source_group_name, src_dev_ids, extra_specs)
+                array, snap_name, source_group_name)
+
+    @mock.patch.object(rest.PowerMaxRest,
+                       'get_storagegroup_snap_generation_list',
+                       side_effect=[['0', '3', '1', '2'],
+                                    ['0', '1'], ['0'], list()])
+    def test_delete_group_replica_side_effect(self, mock_list):
+        array = self.data.array
+        snap_name = self.data.group_snapshot_name
+        source_group_name = self.data.storagegroup_name_source
+        with mock.patch.object(
+                self.rest, 'delete_storagegroup_snap') as mock_del:
+            self.provision.delete_group_replica(
+                array, snap_name, source_group_name)
+            self.assertEqual(4, mock_del.call_count)
+            mock_del.reset_mock()
+            self.provision.delete_group_replica(
+                array, snap_name, source_group_name)
+            self.assertEqual(2, mock_del.call_count)
+            mock_del.reset_mock()
+            self.provision.delete_group_replica(
+                array, snap_name, source_group_name)
+            self.assertEqual(1, mock_del.call_count)
+            mock_del.reset_mock()
+            self.provision.delete_group_replica(
+                array, snap_name, source_group_name)
+            mock_del.assert_not_called()
 
     def test_link_and_break_replica(self):
         array = self.data.array
@@ -503,50 +523,6 @@ class PowerMaxProvisionTest(test.TestCas
             self.data.extra_specs)
         mock_create.assert_called_once()
 
-    def test_enable_group_replication(self):
-        with mock.patch.object(self.rest,
-                               'modify_storagegroup_rdf') as mock_mod:
-            self.provision.enable_group_replication(
-                self.data.array, self.data.test_vol_grp_name,
-                self.data.rdf_group_no, self.data.extra_specs)
-            mock_mod.assert_called_once()
-
-    def test_disable_group_replication(self):
-        with mock.patch.object(self.rest,
-                               'modify_storagegroup_rdf') as mock_mod:
-            self.provision.disable_group_replication(
-                self.data.array, self.data.test_vol_grp_name,
-                self.data.rdf_group_no, self.data.extra_specs)
-            mock_mod.assert_called_once()
-
-    def test_failover_group(self):
-        with mock.patch.object(self.rest,
-                               'modify_storagegroup_rdf') as mock_fo:
-            # Failover
-            self.provision.failover_group(
-                self.data.array, self.data.test_vol_grp_name,
-                self.data.rdf_group_no, self.data.extra_specs)
-            mock_fo.assert_called_once_with(
-                self.data.array, self.data.test_vol_grp_name,
-                self.data.rdf_group_no, 'Failover', self.data.extra_specs)
-            mock_fo.reset_mock()
-            # Failback
-            self.provision.failover_group(
-                self.data.array, self.data.test_vol_grp_name,
-                self.data.rdf_group_no, self.data.extra_specs, False)
-            mock_fo.assert_called_once_with(
-                self.data.array, self.data.test_vol_grp_name,
-                self.data.rdf_group_no, 'Failback', self.data.extra_specs)
-
-    @mock.patch.object(rest.PowerMaxRest, 'modify_storagegroup_rdf')
-    @mock.patch.object(rest.PowerMaxRest, 'delete_storagegroup_rdf')
-    def test_delete_group_replication(self, mock_mod, mock_del):
-        self.provision.delete_group_replication(
-            self.data.array, self.data.test_vol_grp_name,
-            self.data.rdf_group_no, self.data.extra_specs)
-        mock_mod.assert_called_once()
-        mock_del.assert_called_once()
-
     @mock.patch.object(
         rest.PowerMaxRest, 'get_snap_linked_device_list',
         side_effect=[[{'targetDevice': tpd.PowerMaxData.device_id2}],
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_replication.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_replication.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_replication.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_replication.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,14 +15,13 @@
 
 import ast
 from copy import deepcopy
+from unittest import mock
+from unittest.mock import call
 
-import mock
 import six
 
 from cinder import exception
-from cinder import objects
 from cinder.objects import fields
-from cinder.objects import group
 from cinder import test
 from cinder.tests.unit.volume.drivers.dell_emc.powermax import (
     powermax_data as tpd)
@@ -50,18 +49,18 @@ class PowerMaxReplicationTest(test.TestC
             'allow_extend': 'True'}
         volume_utils.get_max_over_subscription_ratio = mock.Mock()
         configuration = tpfo.FakeConfiguration(
-            None, 'CommonReplicationTests', 1, 1, san_ip='1.1.1.1',
-            san_login='smc', vmax_array=self.data.array, vmax_srp='SRP_1',
-            san_password='smc', san_api_port=8443,
+            None, 'CommonReplicationTests', interval=1, retries=1,
+            san_ip='1.1.1.1', san_login='smc', vmax_array=self.data.array,
+            vmax_srp='SRP_1', san_password='smc', san_api_port=8443,
             vmax_port_groups=[self.data.port_group_name_f],
             replication_device=self.replication_device)
         rest.PowerMaxRest._establish_rest_session = mock.Mock(
             return_value=tpfo.FakeRequestsSession())
         driver = fc.PowerMaxFCDriver(configuration=configuration)
         iscsi_config = tpfo.FakeConfiguration(
-            None, 'CommonReplicationTests', 1, 1, san_ip='1.1.1.1',
-            san_login='smc', vmax_array=self.data.array, vmax_srp='SRP_1',
-            san_password='smc', san_api_port=8443,
+            None, 'CommonReplicationTests', interval=1, retries=1,
+            san_ip='1.1.1.1', san_login='smc', vmax_array=self.data.array,
+            vmax_srp='SRP_1', san_password='smc', san_api_port=8443,
             vmax_port_groups=[self.data.port_group_name_i],
             replication_device=self.replication_device)
         iscsi_driver = iscsi.PowerMaxISCSIDriver(configuration=iscsi_config)
@@ -86,9 +85,9 @@ class PowerMaxReplicationTest(test.TestC
             'rdf_group_label': self.data.rdf_group_name,
             'allow_extend': 'True', 'mode': 'async'}
         async_configuration = tpfo.FakeConfiguration(
-            None, 'CommonReplicationTests', 1, 1, san_ip='1.1.1.1',
-            san_login='smc', vmax_array=self.data.array, vmax_srp='SRP_1',
-            san_password='smc', san_api_port=8443,
+            None, 'CommonReplicationTests', interval=1, retries=1,
+            san_ip='1.1.1.1', san_login='smc', vmax_array=self.data.array,
+            vmax_srp='SRP_1', san_password='smc', san_api_port=8443,
             vmax_port_groups=[self.data.port_group_name_f],
             replication_device=self.async_rep_device)
         self.async_driver = fc.PowerMaxFCDriver(
@@ -100,9 +99,9 @@ class PowerMaxReplicationTest(test.TestC
             'rdf_group_label': self.data.rdf_group_name,
             'allow_extend': 'True', 'mode': 'metro'}
         metro_configuration = tpfo.FakeConfiguration(
-            None, 'CommonReplicationTests', 1, 1, san_ip='1.1.1.1',
-            san_login='smc', vmax_array=self.data.array, vmax_srp='SRP_1',
-            san_password='smc', san_api_port=8443,
+            None, 'CommonReplicationTests', interval=1, retries=1,
+            san_ip='1.1.1.1', san_login='smc', vmax_array=self.data.array,
+            vmax_srp='SRP_1', san_password='smc', san_api_port=8443,
             vmax_port_groups=[self.data.port_group_name_f],
             replication_device=self.metro_rep_device)
         self.metro_driver = fc.PowerMaxFCDriver(
@@ -112,123 +111,6 @@ class PowerMaxReplicationTest(test.TestC
         self.common._get_replication_info()
         self.assertTrue(self.common.replication_enabled)
 
-    @mock.patch.object(volume_utils, 'is_group_a_cg_snapshot_type',
-                       return_value=False)
-    @mock.patch.object(objects.group.Group, 'get_by_id',
-                       return_value=tpd.PowerMaxData.test_rep_group)
-    @mock.patch.object(volume_utils, 'is_group_a_type', return_value=True)
-    @mock.patch.object(utils.PowerMaxUtils, 'check_replication_matched',
-                       return_value=True)
-    @mock.patch.object(masking.PowerMaxMasking, 'add_volume_to_storage_group')
-    @mock.patch.object(
-        common.PowerMaxCommon, '_replicate_volume',
-        return_value=({
-            'replication_driver_data':
-                tpd.PowerMaxData.test_volume.replication_driver_data}, {}))
-    @mock.patch.object(common.PowerMaxCommon, 'get_volume_metadata',
-                       return_value='')
-    def test_create_replicated_volume(
-            self, mck_meta, mock_rep, mock_add, mock_match, mock_check,
-            mock_get, mock_cg):
-        extra_specs = deepcopy(self.extra_specs)
-        extra_specs[utils.PORTGROUPNAME] = self.data.port_group_name_f
-        vol_identifier = self.utils.get_volume_element_name(
-            self.data.test_volume.id)
-        self.common.create_volume(self.data.test_volume)
-        volume_dict = self.data.provider_location
-        mock_rep.assert_called_once_with(
-            self.data.test_volume, vol_identifier, volume_dict,
-            extra_specs)
-        # Add volume to replication group
-        self.common.create_volume(self.data.test_volume_group_member)
-        mock_add.assert_called_once()
-
-    @mock.patch.object(
-        common.PowerMaxCommon, '_replicate_volume',
-        return_value=({
-            'replication_driver_data':
-                tpd.PowerMaxData.test_volume.replication_driver_data}, {}))
-    @mock.patch.object(utils.PowerMaxUtils, 'is_replication_enabled',
-                       return_value=True)
-    @mock.patch.object(rest.PowerMaxRest, 'get_rdf_group_number',
-                       side_effect=['4', None])
-    @mock.patch.object(common.PowerMaxCommon, 'get_volume_metadata',
-                       return_value='')
-    def test_create_replicated_vol_side_effect(
-            self, mck_meta, mock_rdf_no, mock_rep_enabled, mock_rep_vol):
-        self.common.rep_config = self.utils.get_replication_config(
-            [self.replication_device])
-        ref_rep_data = {'array': six.text_type(self.data.remote_array),
-                        'device_id': self.data.device_id2}
-        ref_model_update = {
-            'provider_location': six.text_type(
-                self.data.test_volume.provider_location),
-            'replication_driver_data': six.text_type(ref_rep_data),
-            'metadata': ''}
-        model_update = self.common.create_volume(self.data.test_volume)
-        self.assertEqual(ref_model_update, model_update)
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.common.create_volume,
-                          self.data.test_volume)
-
-    @mock.patch.object(common.PowerMaxCommon, '_clone_check')
-    @mock.patch.object(common.PowerMaxCommon, 'get_volume_metadata',
-                       return_value='')
-    def test_create_cloned_replicated_volume(self, mck_meta, mck_clone):
-        extra_specs = deepcopy(self.extra_specs)
-        extra_specs[utils.PORTGROUPNAME] = self.data.port_group_name_f
-        with mock.patch.object(self.common, '_replicate_volume',
-                               return_value=({}, {})) as mock_rep:
-            self.common.create_cloned_volume(
-                self.data.test_clone_volume, self.data.test_volume)
-            volume_dict = self.data.provider_location_clone
-            mock_rep.assert_called_once_with(
-                self.data.test_clone_volume,
-                self.data.test_clone_volume.name, volume_dict, extra_specs)
-
-    @mock.patch.object(common.PowerMaxCommon, '_clone_check')
-    @mock.patch.object(common.PowerMaxCommon, 'get_volume_metadata',
-                       return_value='')
-    def test_create_replicated_volume_from_snap(self, mck_meta, mck_clone):
-        extra_specs = deepcopy(self.extra_specs)
-        extra_specs[utils.PORTGROUPNAME] = self.data.port_group_name_f
-        with mock.patch.object(self.common, '_replicate_volume',
-                               return_value=({}, {})) as mock_rep:
-            self.common.create_volume_from_snapshot(
-                self.data.test_clone_volume, self.data.test_snapshot)
-            volume_dict = self.data.provider_location_snapshot
-            mock_rep.assert_called_once_with(
-                self.data.test_clone_volume,
-                'snapshot-%s' % self.data.snapshot_id, volume_dict,
-                extra_specs)
-
-    def test_replicate_volume(self):
-        volume_dict = self.data.provider_location
-        rs_enabled = fields.ReplicationStatus.ENABLED
-        with mock.patch.object(
-                self.common, 'setup_volume_replication',
-                return_value=(rs_enabled, {}, {})) as mock_setup:
-            self.common._replicate_volume(
-                self.data.test_volume, '1', volume_dict, self.extra_specs)
-            mock_setup.assert_called_once_with(
-                self.data.array, self.data.test_volume,
-                self.data.device_id, self.extra_specs)
-
-    def test_replicate_volume_exception(self):
-        volume_dict = self.data.provider_location
-        with mock.patch.object(
-                self.common, 'setup_volume_replication',
-                side_effect=exception.VolumeBackendAPIException(data='')):
-            with mock.patch.object(
-                    self.common, '_cleanup_replication_source') as mock_clean:
-                self.assertRaises(
-                    exception.VolumeBackendAPIException,
-                    self.common._replicate_volume, self.data.test_volume,
-                    '1', volume_dict, self.extra_specs)
-                mock_clean.assert_called_once_with(
-                    self.data.array, self.data.test_volume, '1',
-                    volume_dict, self.extra_specs)
-
     @mock.patch.object(common.PowerMaxCommon, '_remove_members')
     @mock.patch.object(
         common.PowerMaxCommon, '_get_replication_extra_specs',
@@ -238,8 +120,10 @@ class PowerMaxReplicationTest(test.TestC
     def test_unmap_lun_volume_failed_over(self, mock_fo, mock_es, mock_rm):
         extra_specs = deepcopy(self.extra_specs)
         extra_specs[utils.PORTGROUPNAME] = self.data.port_group_name_f
+        extra_specs[utils.IS_RE] = True
         rep_config = self.utils.get_replication_config(
             [self.replication_device])
+        rep_config[utils.RDF_CONS_EXEMPT] = False
         self.common._unmap_lun(self.data.test_volume, self.data.connector)
         mock_es.assert_called_once_with(extra_specs, rep_config)
 
@@ -260,10 +144,14 @@ class PowerMaxReplicationTest(test.TestC
     def test_initialize_connection_vol_failed_over(self, mock_fo):
         extra_specs = deepcopy(self.extra_specs)
         extra_specs[utils.PORTGROUPNAME] = self.data.port_group_name_f
+
         rep_extra_specs = deepcopy(tpd.PowerMaxData.rep_extra_specs)
         rep_extra_specs[utils.PORTGROUPNAME] = self.data.port_group_name_f
+
         rep_config = self.utils.get_replication_config(
             [self.replication_device])
+        rep_config[utils.RDF_CONS_EXEMPT] = False
+
         with mock.patch.object(self.common, '_get_replication_extra_specs',
                                return_value=rep_extra_specs) as mock_es:
             self.common.initialize_connection(
@@ -349,202 +237,6 @@ class PowerMaxReplicationTest(test.TestC
                          masking_dict[utils.SG_NAME])
 
     @mock.patch.object(common.PowerMaxCommon,
-                       '_replicate_volume',
-                       return_value=({}, {}))
-    @mock.patch.object(rest.PowerMaxRest, 'get_array_model_info',
-                       return_value=('VMAX250F', False))
-    @mock.patch.object(common.PowerMaxCommon, 'get_volume_metadata',
-                       return_value='')
-    def test_manage_existing_is_replicated(self, mck_meta, mock_model,
-                                           mock_rep):
-        extra_specs = deepcopy(self.extra_specs)
-        extra_specs[utils.PORTGROUPNAME] = self.data.port_group_name_f
-        external_ref = {u'source-name': u'00002'}
-        volume_name = self.utils.get_volume_element_name(
-            self.data.test_volume.id)
-        provider_location = {'device_id': u'00002', 'array': self.data.array}
-        with mock.patch.object(
-                self.common, '_check_lun_valid_for_cinder_management',
-                return_value=(volume_name, 'test_sg')):
-            self.common.manage_existing(
-                self.data.test_volume, external_ref)
-            mock_rep.assert_called_once_with(
-                self.data.test_volume, volume_name, provider_location,
-                extra_specs, delete_src=False)
-
-    @mock.patch.object(common.PowerMaxCommon, '_sync_check')
-    @mock.patch.object(masking.PowerMaxMasking, 'remove_and_reset_members')
-    @mock.patch.object(rest.PowerMaxRest, 'get_array_model_info',
-                       return_value=('VMAX250F', False))
-    def test_setup_volume_replication(self, mock_model, mock_rm, mck_sync):
-        rep_status, rep_data, __ = self.common.setup_volume_replication(
-            self.data.array, self.data.test_volume, self.data.device_id,
-            self.extra_specs)
-        self.assertEqual(fields.ReplicationStatus.ENABLED, rep_status)
-        self.assertEqual({'array': self.data.remote_array,
-                          'device_id': self.data.device_id}, rep_data)
-
-    @mock.patch.object(common.PowerMaxCommon, '_sync_check')
-    @mock.patch.object(masking.PowerMaxMasking, 'remove_and_reset_members')
-    @mock.patch.object(common.PowerMaxCommon, '_create_volume')
-    @mock.patch.object(rest.PowerMaxRest, 'get_array_model_info',
-                       return_value=('VMAX250F', False))
-    def test_setup_volume_replication_target(
-            self, mock_model, mock_create, mock_rm, mck_sync):
-        rep_status, rep_data, __ = self.common.setup_volume_replication(
-            self.data.array, self.data.test_volume, self.data.device_id,
-            self.extra_specs, self.data.device_id2)
-        self.assertEqual(fields.ReplicationStatus.ENABLED, rep_status)
-        self.assertEqual({'array': self.data.remote_array,
-                          'device_id': self.data.device_id2}, rep_data)
-        mock_create.assert_not_called()
-
-    @mock.patch.object(common.PowerMaxCommon, 'get_rdf_details',
-                       return_value=(tpd.PowerMaxData.rdf_group_no,
-                                     tpd.PowerMaxData.remote_array))
-    @mock.patch.object(rest.PowerMaxRest, 'get_size_of_device_on_array',
-                       return_value=2)
-    @mock.patch.object(common.PowerMaxCommon, '_get_replication_extra_specs',
-                       return_value=tpd.PowerMaxData.rep_extra_specs5)
-    @mock.patch.object(common.PowerMaxCommon, '_create_volume',
-                       return_value=tpd.PowerMaxData.provider_location)
-    @mock.patch.object(common.PowerMaxCommon, '_sync_check')
-    @mock.patch.object(rest.PowerMaxRest, 'create_rdf_device_pair',
-                       return_value=tpd.PowerMaxData.rdf_group_details)
-    def test_setup_inuse_volume_replication(self, mck_create_rdf_pair,
-                                            mck_sync_chk, mck_create_vol,
-                                            mck_rep_specs, mck_get_vol_size,
-                                            mck_get_rdf_info):
-        array = self.data.array
-        device_id = self.data.device_id
-        volume = self.data.test_attached_volume
-        extra_specs = self.data.extra_specs_migrate
-        self.rep_config = self.data.rep_extra_specs4
-        rep_status, rep_data, __ = (
-            self.common.setup_inuse_volume_replication(
-                array, volume, device_id, extra_specs))
-        self.assertEqual('enabled', rep_status)
-        self.assertEqual(self.data.rdf_group_details, rep_data)
-
-    @mock.patch.object(rest.PowerMaxRest, 'get_array_model_info',
-                       return_value=('VMAX250F', False))
-    @mock.patch.object(common.PowerMaxCommon, '_cleanup_remote_target')
-    def test_cleanup_lun_replication_success(self, mock_clean, mock_model):
-        rep_extra_specs = deepcopy(self.data.rep_extra_specs)
-        rep_extra_specs[utils.PORTGROUPNAME] = self.data.port_group_name_f
-        rep_extra_specs['target_array_model'] = 'VMAX250F'
-        self.common.cleanup_lun_replication(
-            self.data.test_volume, '1', self.data.device_id,
-            self.extra_specs)
-        mock_clean.assert_called_once_with(
-            self.data.array, self.data.test_volume,
-            self.data.remote_array, self.data.device_id,
-            self.data.device_id2, self.data.rdf_group_no, '1',
-            rep_extra_specs)
-        # Cleanup legacy replication
-        self.common.cleanup_lun_replication(
-            self.data.test_legacy_vol, '1', self.data.device_id,
-            self.extra_specs)
-        mock_clean.assert_called_once_with(
-            self.data.array, self.data.test_volume,
-            self.data.remote_array, self.data.device_id,
-            self.data.device_id2, self.data.rdf_group_no, '1',
-            rep_extra_specs)
-
-    @mock.patch.object(rest.PowerMaxRest, 'get_array_model_info',
-                       return_value=('VMAX250F', False))
-    @mock.patch.object(common.PowerMaxCommon, '_cleanup_remote_target')
-    def test_cleanup_lun_replication_no_target(self, mock_clean, mock_model):
-        with mock.patch.object(self.common, 'get_remote_target_device',
-                               return_value=(None, '', '', '', '')):
-            self.common.cleanup_lun_replication(
-                self.data.test_volume, '1', self.data.device_id,
-                self.extra_specs)
-            mock_clean.assert_not_called()
-
-    @mock.patch.object(
-        common.PowerMaxCommon, 'get_remote_target_device',
-        return_value=(tpd.PowerMaxData.device_id2, '', '', '', ''))
-    @mock.patch.object(common.PowerMaxCommon,
-                       '_add_volume_to_async_rdf_managed_grp')
-    def test_cleanup_lun_replication_exception(self, mock_add, mock_tgt):
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.common.cleanup_lun_replication,
-                          self.data.test_volume, '1', self.data.device_id,
-                          self.extra_specs)
-        # is metro or async volume
-        extra_specs = deepcopy(self.extra_specs)
-        extra_specs[utils.REP_MODE] = utils.REP_METRO
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.common.cleanup_lun_replication,
-                          self.data.test_volume, '1', self.data.device_id,
-                          extra_specs)
-        mock_add.assert_called_once()
-
-    @mock.patch.object(common.PowerMaxCommon, '_cleanup_metro_target')
-    @mock.patch.object(masking.PowerMaxMasking,
-                       'remove_vol_from_storage_group')
-    @mock.patch.object(common.PowerMaxCommon, '_delete_from_srp')
-    @mock.patch.object(provision.PowerMaxProvision, 'break_rdf_relationship')
-    def test_cleanup_remote_target(self, mock_break, mock_del,
-                                   mock_rm, mock_clean_metro):
-        with mock.patch.object(self.rest, 'are_vols_rdf_paired',
-                               return_value=(False, '', '')):
-            self.common._cleanup_remote_target(
-                self.data.array, self.data.test_volume,
-                self.data.remote_array, self.data.device_id,
-                self.data.device_id2, self.data.rdf_group_name,
-                'vol1', self.data.rep_extra_specs)
-            mock_break.assert_not_called()
-        self.common._cleanup_remote_target(
-            self.data.array, self.data.test_volume,
-            self.data.remote_array, self.data.device_id,
-            self.data.device_id2, self.data.rdf_group_name,
-            'vol1', self.data.rep_extra_specs)
-        mock_break.assert_called_once_with(
-            self.data.array, self.data.device_id,
-            self.data.device_id2, self.data.rdf_group_name,
-            self.data.rep_extra_specs, 'Synchronized')
-        # is metro volume
-        with mock.patch.object(self.utils, 'is_metro_device',
-                               return_value=True):
-            self.common._cleanup_remote_target(
-                self.data.array, self.data.test_volume,
-                self.data.remote_array, self.data.device_id,
-                self.data.device_id2, self.data.rdf_group_name,
-                'vol1', self.data.rep_extra_specs)
-            mock_clean_metro.assert_called_once()
-
-    def test_cleanup_remote_target_exception(self):
-        extra_specs = deepcopy(self.data.rep_extra_specs)
-        extra_specs['mode'] = utils.REP_METRO
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.metro_driver.common._cleanup_remote_target,
-                          self.data.array, self.data.test_volume,
-                          self.data.remote_array,
-                          self.data.device_id, self.data.device_id2,
-                          self.data.rdf_group_name, 'vol1', extra_specs)
-
-    @mock.patch.object(provision.PowerMaxProvision, 'enable_group_replication')
-    @mock.patch.object(rest.PowerMaxRest, 'get_num_vols_in_sg',
-                       side_effect=[2, 0])
-    def test_cleanup_metro_target(self, mock_vols, mock_enable):
-        # allow delete is True
-        specs = {'allow_del_metro': True}
-        for x in range(0, 2):
-            self.common._cleanup_metro_target(
-                self.data.array, self.data.device_id, self.data.device_id2,
-                self.data.rdf_group_no, specs)
-            mock_enable.assert_called_once()
-        # allow delete is False
-        specs['allow_del_metro'] = False
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.common._cleanup_metro_target,
-                          self.data.array, self.data.device_id,
-                          self.data.device_id2,
-                          self.data.rdf_group_no, specs)
-
-    @mock.patch.object(common.PowerMaxCommon,
                        '_remove_vol_and_cleanup_replication')
     @mock.patch.object(masking.PowerMaxMasking,
                        'remove_vol_from_storage_group')
@@ -586,78 +278,6 @@ class PowerMaxReplicationTest(test.TestC
         self.common.failover_host(volumes, None, [group1])
         mock_fg.assert_called_once()
 
-    def test_get_remote_target_device(self):
-        target_device1, _, _, _, _ = (
-            self.common.get_remote_target_device(
-                self.data.array, self.data.test_volume, self.data.device_id))
-        self.assertEqual(self.data.device_id2, target_device1)
-        target_device2, _, _, _, _ = (
-            self.common.get_remote_target_device(
-                self.data.array, self.data.test_clone_volume,
-                self.data.device_id))
-        self.assertIsNone(target_device2)
-        with mock.patch.object(self.rest, 'are_vols_rdf_paired',
-                               return_value=(False, '')):
-            target_device3, _, _, _, _ = (
-                self.common.get_remote_target_device(
-                    self.data.array, self.data.test_volume,
-                    self.data.device_id))
-            self.assertIsNone(target_device3)
-        with mock.patch.object(self.rest, 'get_volume',
-                               return_value=None):
-            target_device4, _, _, _, _ = (
-                self.common.get_remote_target_device(
-                    self.data.array, self.data.test_volume,
-                    self.data.device_id))
-            self.assertIsNone(target_device4)
-
-    @mock.patch.object(rest.PowerMaxRest, 'get_array_model_info',
-                       return_value=('VMAX250F', False))
-    @mock.patch.object(common.PowerMaxCommon,
-                       'add_volume_to_replication_group')
-    @mock.patch.object(common.PowerMaxCommon, '_sync_check')
-    @mock.patch.object(masking.PowerMaxMasking, 'remove_and_reset_members')
-    def test_enable_rdf(self, mock_remove, mck_sync, mock_add, mock_model):
-        rep_config = self.utils.get_replication_config(
-            [self.replication_device])
-        self.common.enable_rdf(
-            self.data.array, self.data.test_volume, self.data.device_id,
-            self.data.rdf_group_no, rep_config, 'OS-1',
-            self.data.remote_array, self.data.device_id2, self.extra_specs)
-        self.assertEqual(2, mock_remove.call_count)
-        self.assertEqual(2, mock_add.call_count)
-
-    @mock.patch.object(rest.PowerMaxRest, 'get_array_model_info',
-                       return_value=('VMAX250F', False))
-    @mock.patch.object(masking.PowerMaxMasking,
-                       'remove_vol_from_storage_group')
-    @mock.patch.object(common.PowerMaxCommon, '_cleanup_remote_target')
-    def test_enable_rdf_exception(self, mock_cleanup, mock_rm, mock_model):
-        rep_config = self.utils.get_replication_config(
-            [self.replication_device])
-        self.assertRaises(
-            exception.VolumeBackendAPIException, self.common.enable_rdf,
-            self.data.array, self.data.test_volume, self.data.device_id,
-            self.data.failed_resource, rep_config, 'OS-1',
-            self.data.remote_array, self.data.device_id2, self.extra_specs)
-        self.assertEqual(1, mock_cleanup.call_count)
-
-    def test_add_volume_to_replication_group(self):
-        sg_name = self.common.add_volume_to_replication_group(
-            self.data.array, self.data.device_id, 'vol1',
-            self.extra_specs)
-        self.assertEqual(self.data.default_sg_re_enabled, sg_name)
-
-    @mock.patch.object(masking.PowerMaxMasking,
-                       'get_or_create_default_storage_group',
-                       side_effect=exception.VolumeBackendAPIException)
-    def test_add_volume_to_replication_group_exception(self, mock_get):
-        self.assertRaises(
-            exception.VolumeBackendAPIException,
-            self.common.add_volume_to_replication_group,
-            self.data.array, self.data.device_id, 'vol1',
-            self.extra_specs)
-
     @mock.patch.object(rest.PowerMaxRest,
                        'get_array_model_info',
                        return_value=('VMAX250F', False))
@@ -811,36 +431,62 @@ class PowerMaxReplicationTest(test.TestC
             self.assertEqual(fields.ReplicationStatus.ERROR,
                              model_update['replication_status'])
 
-    def test_failover_replication(self):
+    def test_failover_replication_empty_group(self):
         with mock.patch.object(volume_utils, 'is_group_a_type',
                                return_value=True):
-            # Case 1: Empty group
             model_update, __ = self.common.failover_replication(
                 None, self.data.test_group, [])
             self.assertEqual({}, model_update)
-            # Case 2: Successfully failed over
-            model_update, __ = self.common.failover_replication(
-                None, self.data.test_group, [self.data.test_volume])
-            self.assertEqual(fields.ReplicationStatus.FAILED_OVER,
-                             model_update['replication_status'])
-            # Case 3: Successfully failed back
-            model_update, __ = self.common.failover_replication(
-                None, self.data.test_group, [self.data.test_volume],
-                secondary_backend_id='default')
-            self.assertEqual(fields.ReplicationStatus.ENABLED,
-                             model_update['replication_status'])
-            # Case 4: Exception
-            model_update, __ = self.common.failover_replication(
-                None, self.data.test_group_failed, [self.data.test_volume])
-            self.assertEqual(fields.ReplicationStatus.ERROR,
-                             model_update['replication_status'])
 
-    @mock.patch.object(provision.PowerMaxProvision, 'failover_group')
-    def test_failover_replication_metro(self, mock_fo):
-        volumes = [self.data.test_volume]
-        _, vol_model_updates = self.common._failover_replication(
-            volumes, group, None, host=True, is_metro=True)
-        mock_fo.assert_not_called()
+    @mock.patch.object(rest.PowerMaxRest, 'srdf_failover_group',
+                       return_value=tpd.PowerMaxData.rdf_group_no)
+    @mock.patch.object(common.PowerMaxCommon, 'get_rdf_details',
+                       return_value=tpd.PowerMaxData.rdf_group_no)
+    @mock.patch.object(common.PowerMaxCommon, '_find_volume_group',
+                       return_value=tpd.PowerMaxData.test_group)
+    def test_failover_replication_failover(self, mck_find_vol_grp,
+                                           mck_get_rdf_grp, mck_failover):
+        volumes = [self.data.test_volume_group_member]
+        vol_group = self.data.test_group
+        vol_grp_name = self.data.test_group.name
+
+        model_update, __ = self.common._failover_replication(
+            volumes, vol_group, vol_grp_name, host=True)
+        self.assertEqual(fields.ReplicationStatus.FAILED_OVER,
+                         model_update['replication_status'])
+
+    @mock.patch.object(rest.PowerMaxRest, 'srdf_failover_group',
+                       return_value=tpd.PowerMaxData.rdf_group_no)
+    @mock.patch.object(common.PowerMaxCommon, 'get_rdf_details',
+                       return_value=tpd.PowerMaxData.rdf_group_no)
+    @mock.patch.object(common.PowerMaxCommon, '_find_volume_group',
+                       return_value=tpd.PowerMaxData.test_group)
+    def test_failover_replication_failback(self, mck_find_vol_grp,
+                                           mck_get_rdf_grp, mck_failover):
+        volumes = [self.data.test_volume_group_member]
+        vol_group = self.data.test_group
+        vol_grp_name = self.data.test_group.name
+
+        model_update, __ = self.common._failover_replication(
+            volumes, vol_group, vol_grp_name, host=True,
+            secondary_backend_id='default')
+        self.assertEqual(fields.ReplicationStatus.ENABLED,
+                         model_update['replication_status'])
+
+    @mock.patch.object(common.PowerMaxCommon, 'get_rdf_details',
+                       return_value=None)
+    @mock.patch.object(common.PowerMaxCommon, '_find_volume_group',
+                       return_value=tpd.PowerMaxData.test_group)
+    def test_failover_replication_exception(self, mck_find_vol_grp,
+                                            mck_get_rdf_grp):
+        volumes = [self.data.test_volume_group_member]
+        vol_group = self.data.test_group
+        vol_grp_name = self.data.test_group.name
+
+        model_update, __ = self.common._failover_replication(
+            volumes, vol_group, vol_grp_name)
+        self.assertEqual(fields.ReplicationStatus.ERROR,
+                         model_update['replication_status'])
 
     @mock.patch.object(utils.PowerMaxUtils, 'get_volume_group_utils',
                        return_value=(tpd.PowerMaxData.array, {}))
@@ -888,43 +534,6 @@ class PowerMaxReplicationTest(test.TestC
             [self.data.device_id], self.extra_specs)
         mock_rm.assert_called_once()
 
-    @mock.patch.object(masking.PowerMaxMasking, 'add_volume_to_storage_group')
-    def test_add_volume_to_async_group(self, mock_add):
-        extra_specs = deepcopy(self.extra_specs)
-        extra_specs['rep_mode'] = utils.REP_ASYNC
-        self.async_driver.common._add_volume_to_async_rdf_managed_grp(
-            self.data.array, self.data.device_id, 'name',
-            self.data.remote_array, self.data.device_id2, extra_specs)
-        self.assertEqual(2, mock_add.call_count)
-
-    def test_add_volume_to_async_group_exception(self):
-        extra_specs = deepcopy(self.extra_specs)
-        extra_specs['rep_mode'] = utils.REP_ASYNC
-        self.assertRaises(
-            exception.VolumeBackendAPIException,
-            self.async_driver.common._add_volume_to_async_rdf_managed_grp,
-            self.data.failed_resource, self.data.device_id, 'name',
-            self.data.remote_array, self.data.device_id2, extra_specs)
-
-    @mock.patch.object(common.PowerMaxCommon, '_sync_check')
-    @mock.patch.object(rest.PowerMaxRest, 'get_array_model_info',
-                       return_value=('VMAX250F', False))
-    @mock.patch.object(common.PowerMaxCommon,
-                       '_add_volume_to_async_rdf_managed_grp')
-    @mock.patch.object(masking.PowerMaxMasking, 'remove_and_reset_members')
-    def test_setup_volume_replication_async(
-            self, mock_rm, mock_add, mock_model, mck_sync):
-        extra_specs = deepcopy(self.extra_specs)
-        extra_specs['rep_mode'] = utils.REP_ASYNC
-        rep_status, rep_data, __ = (
-            self.async_driver.common.setup_volume_replication(
-                self.data.array, self.data.test_volume,
-                self.data.device_id, extra_specs))
-        self.assertEqual(fields.ReplicationStatus.ENABLED, rep_status)
-        self.assertEqual({'array': self.data.remote_array,
-                          'device_id': self.data.device_id}, rep_data)
-        mock_add.assert_called_once()
-
     @mock.patch.object(common.PowerMaxCommon, '_failover_replication',
                        return_value=({}, {}))
     @mock.patch.object(common.PowerMaxCommon, '_sync_check')
@@ -937,119 +546,609 @@ class PowerMaxReplicationTest(test.TestC
             self.async_driver.common.failover_host(volumes, None, [])
         mock_fg.assert_called_once()
 
-    @mock.patch.object(common.PowerMaxCommon, '_retype_volume',
-                       return_value=True)
-    @mock.patch.object(masking.PowerMaxMasking,
-                       'remove_vol_from_storage_group')
-    @mock.patch.object(common.PowerMaxCommon, '_retype_remote_volume',
-                       return_value=True)
     @mock.patch.object(
-        common.PowerMaxCommon, 'setup_volume_replication',
-        return_value=('', tpd.PowerMaxData.provider_location2, ''))
-    @mock.patch.object(common.PowerMaxCommon,
-                       '_remove_vol_and_cleanup_replication')
-    @mock.patch.object(utils.PowerMaxUtils, 'is_replication_enabled',
-                       side_effect=[False, True, True, False, True, True])
+        common.PowerMaxCommon, 'get_volume_metadata', return_value={})
+    @mock.patch.object(
+        rest.PowerMaxRest, 'srdf_resume_replication')
+    @mock.patch.object(
+        common.PowerMaxCommon, '_protect_storage_group',
+        return_value=(fields.ReplicationStatus.ENABLED,
+                      tpd.PowerMaxData.replication_update,
+                      tpd.PowerMaxData.rep_info_dict))
+    @mock.patch.object(
+        masking.PowerMaxMasking, 'add_volume_to_default_storage_group')
+    @mock.patch.object(
+        common.PowerMaxCommon, 'configure_volume_replication',
+        return_value=(
+            'first_vol_in_rdf_group', tpd.PowerMaxData.replication_update,
+            tpd.PowerMaxData.rep_info_dict,
+            tpd.PowerMaxData.rep_extra_specs_mgmt, True))
+    @mock.patch.object(
+        rest.PowerMaxRest, 'rename_volume')
+    @mock.patch.object(
+        common.PowerMaxCommon, '_check_lun_valid_for_cinder_management',
+        return_value=(tpd.PowerMaxData.test_volume.name,
+                      tpd.PowerMaxData.storagegroup_name_source))
+    @mock.patch.object(
+        utils.PowerMaxUtils, 'get_array_and_device_id',
+        return_value=(tpd.PowerMaxData.array, tpd.PowerMaxData.device_id))
+    @mock.patch.object(
+        common.PowerMaxCommon, '_initial_setup',
+        return_value=tpd.PowerMaxData.rep_extra_specs)
+    def test_manage_existing_enable_replication(
+            self, mck_setup, mck_get_array, mck_check_lun, mck_rename,
+            mck_configure, mck_add, mck_post, mck_resume, mck_meta):
+
+        external_ref = {u'source-name': u'00002'}
+        volume = self.data.test_volume
+        ref_model_update = {
+            'metadata': {},
+            'provider_location': six.text_type({
+                'device_id': self.data.device_id,
+                'array': self.data.array}),
+            'replication_driver_data': six.text_type({
+                'device_id': self.data.device_id2,
+                'array': self.data.remote_array}),
+            'replication_status': fields.ReplicationStatus.ENABLED}
+
+        model_update = self.common.manage_existing(volume, external_ref)
+        mck_configure.assert_called_once()
+        mck_add.assert_called_once()
+        mck_post.assert_called_once()
+        mck_resume.assert_called_once()
+        self.assertEqual(ref_model_update, model_update)
+
+    @mock.patch.object(
+        masking.PowerMaxMasking, 'add_volume_to_default_storage_group',
+        side_effect=exception.VolumeBackendAPIException)
+    @mock.patch.object(
+        common.PowerMaxCommon, 'configure_volume_replication',
+        return_value=(
+            'first_vol_in_rdf_group', tpd.PowerMaxData.replication_update,
+            tpd.PowerMaxData.rep_info_dict,
+            tpd.PowerMaxData.rep_extra_specs, True))
+    @mock.patch.object(
+        rest.PowerMaxRest, 'rename_volume')
+    @mock.patch.object(
+        common.PowerMaxCommon, '_check_lun_valid_for_cinder_management',
+        return_value=(tpd.PowerMaxData.test_volume.name,
+                      tpd.PowerMaxData.storagegroup_name_source))
+    @mock.patch.object(
+        utils.PowerMaxUtils, 'get_array_and_device_id',
+        return_value=(tpd.PowerMaxData.array, tpd.PowerMaxData.device_id))
+    @mock.patch.object(
+        common.PowerMaxCommon, '_initial_setup',
+        return_value=tpd.PowerMaxData.rep_extra_specs)
+    def test_manage_existing_enable_replication_exception(
+            self, mck_setup, mck_get_array, mck_check_lun, mck_rename,
+            mck_configure, mck_add):
+        external_ref = {u'source-name': u'00002'}
+        volume = self.data.test_volume
+        self.assertRaises(exception.VolumeBackendAPIException,
+                          self.common.manage_existing, volume, external_ref)
+        self.assertEqual(2, mck_rename.call_count)
+
+    @mock.patch.object(
+        common.PowerMaxCommon, 'get_volume_metadata',
+        return_value={'device-meta-key-1': 'device-meta-value-1',
+                      'device-meta-key-2': 'device-meta-value-2'})
+    @mock.patch.object(
+        common.PowerMaxCommon, '_create_volume',
+        return_value=(
+            tpd.PowerMaxData.provider_location,
+            {'replication_driver_data': tpd.PowerMaxData.provider_location2},
+            {}))
+    @mock.patch.object(
+        common.PowerMaxCommon, '_initial_setup',
+        return_value=tpd.PowerMaxData.rep_extra_specs)
+    def test_create_rep_volume(self, mck_initial, mck_create, mck_meta):
+        ref_model_update = (
+            {'provider_location': six.text_type(self.data.provider_location),
+             'replication_driver_data': (
+                 tpd.PowerMaxData.provider_location2),
+             'metadata': {'device-meta-key-1': 'device-meta-value-1',
+                          'device-meta-key-2': 'device-meta-value-2',
+                          'user-meta-key-1': 'user-meta-value-1',
+                          'user-meta-key-2': 'user-meta-value-2'}})
+        volume = deepcopy(self.data.test_volume)
+        volume.metadata = {'user-meta-key-1': 'user-meta-value-1',
+                           'user-meta-key-2': 'user-meta-value-2'}
+        model_update = self.common.create_volume(volume)
+        self.assertEqual(ref_model_update, model_update)
+
     @mock.patch.object(common.PowerMaxCommon, 'get_volume_metadata',
                        return_value='')
-    def test_migrate_volume_replication(
-            self, mck_meta, mock_re, mock_rm_rep, mock_setup, mock_retype,
-            mock_rm, mock_rt):
+    @mock.patch.object(
+        common.PowerMaxCommon, '_create_cloned_volume',
+        return_value=(
+            tpd.PowerMaxData.provider_location,
+            tpd.PowerMaxData.replication_update, {}))
+    def test_create_rep_volume_from_snapshot(self, mck_meta, mck_clone_chk):
+        ref_model_update = (
+            {'provider_location': six.text_type(self.data.provider_location),
+             'metadata': ''})
+        ref_model_update.update(self.data.replication_update)
+        model_update = self.common.create_volume_from_snapshot(
+            self.data.test_clone_volume, self.data.test_snapshot)
+        self.assertEqual(ref_model_update, model_update)
+
+    @mock.patch.object(
+        common.PowerMaxCommon, 'get_volume_metadata', return_value='')
+    @mock.patch.object(
+        common.PowerMaxCommon, '_create_cloned_volume',
+        return_value=(
+            tpd.PowerMaxData.provider_location_clone,
+            tpd.PowerMaxData.replication_update, {}))
+    @mock.patch.object(common.PowerMaxCommon, '_clone_check')
+    def test_cloned_rep_volume(self, mck_clone, mck_meta, mck_clone_chk):
+        ref_model_update = {
+            'provider_location': six.text_type(
+                self.data.provider_location_clone), 'metadata': ''}
+        ref_model_update.update(self.data.replication_update)
+        model_update = self.common.create_cloned_volume(
+            self.data.test_clone_volume, self.data.test_volume)
+        self.assertEqual(ref_model_update, model_update)
+
+    @mock.patch.object(
+        common.PowerMaxCommon, '_add_volume_to_rdf_management_group')
+    @mock.patch.object(
+        common.PowerMaxCommon, 'get_and_set_remote_device_uuid',
+        return_value=tpd.PowerMaxData.device_id2)
+    @mock.patch.object(common.PowerMaxCommon, 'srdf_protect_storage_group')
+    @mock.patch.object(
+        provision.PowerMaxProvision, 'create_volume_from_sg',
+        return_value=tpd.PowerMaxData.provider_location)
+    @mock.patch.object(
+        masking.PowerMaxMasking, 'get_or_create_default_storage_group',
+        return_value=tpd.PowerMaxData.default_sg_re_enabled)
+    @mock.patch.object(
+        common.PowerMaxCommon, 'prepare_replication_details',
+        return_value=(True, tpd.PowerMaxData.rep_extra_specs_mgmt, {}))
+    @mock.patch.object(
+        provision.PowerMaxProvision, 'verify_slo_workload',
+        return_value=(True, True))
+    def test_create_volume_rep_enabled(
+            self, mck_slo, mck_prep, mck_get, mck_create, mck_protect, mck_set,
+            mck_add):
+        volume_name = self.data.volume_id
+        volume_size = 1
+        extra_specs = deepcopy(self.data.rep_extra_specs)
+        extra_specs[utils.SLO] = utils.REP_ASYNC
+        self.common.rep_config = {'rdf_group_label': self.data.rdf_group_name}
+
+        volume_dict, rep_update, rep_info_dict = self.common._create_volume(
+            volume_name, volume_size, extra_specs)
+        self.assertEqual(self.data.provider_location, volume_dict)
+        self.assertEqual(self.data.replication_update, rep_update)
+        self.assertIsNone(rep_info_dict)
+
+    @mock.patch.object(common.PowerMaxCommon, 'get_rdf_details',
+                       return_value=(tpd.PowerMaxData.rdf_group_no, None))
+    @mock.patch.object(utils.PowerMaxUtils, 'is_replication_enabled',
+                       side_effect=[False, True])
+    def test_remove_vol_and_cleanup_replication(self, mck_rep, mck_get):
+        array = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        device_id = self.data.device_id
+        volume = self.data.test_volume
+        volume_name = self.data.test_volume.name
+        extra_specs = self.data.extra_specs
+
+        with mock.patch.object(
+                self.masking, 'remove_and_reset_members') as mock_rm:
+            self.common._remove_vol_and_cleanup_replication(
+                array, device_id, volume_name, extra_specs, volume)
+            mock_rm.assert_called_once_with(
+                array, volume, device_id, volume_name, extra_specs, False)
+        with mock.patch.object(
+                self.common, 'cleanup_rdf_device_pair') as mock_clean:
+            self.common._remove_vol_and_cleanup_replication(
+                array, device_id, volume_name, extra_specs, volume)
+            mock_clean.assert_called_once_with(
+                array, rdf_group_no, device_id, extra_specs)
+
+    @mock.patch.object(
+        common.PowerMaxCommon, 'get_volume_metadata', return_value='')
+    @mock.patch.object(rest.PowerMaxRest, 'srdf_resume_replication')
+    @mock.patch.object(
+        common.PowerMaxCommon, '_retype_volume',
+        return_value=(True, tpd.PowerMaxData.defaultstoragegroup_name))
+    @mock.patch.object(
+        common.PowerMaxCommon, 'break_rdf_device_pair_session',
+        return_value=({'mgmt_sg_name': tpd.PowerMaxData.rdf_managed_async_grp,
+                       'rdf_group_no': tpd.PowerMaxData.rdf_group_no}, True))
+    def test_migrate_volume_success_rep_to_no_rep(
+            self, mck_break, mck_retype, mck_resume, mck_get):
+        array_id = self.data.array
+        volume = self.data.test_volume
+        device_id = self.data.device_id
+        srp = self.data.srp
+        target_slo = self.data.slo_silver
+        target_workload = self.data.workload
+        volume_name = volume.name
         new_type = {'extra_specs': {}}
-        for x in range(0, 3):
-            success, model_update = self.common._migrate_volume(
-                self.data.array, self.data.test_volume, self.data.device_id,
-                self.data.srp, 'OLTP', 'Silver', self.data.test_volume.name,
-                new_type, self.data.extra_specs)
-            self.assertTrue(success)
-        mock_rm_rep.assert_called_once()
-        mock_setup.assert_called_once()
-        mock_retype.assert_called_once()
+        extra_specs = self.data.rep_extra_specs
+
+        target_extra_specs = {
+            utils.SRP: srp, utils.ARRAY: array_id, utils.SLO: target_slo,
+            utils.WORKLOAD: target_workload,
+            utils.INTERVAL: extra_specs[utils.INTERVAL],
+            utils.RETRIES: extra_specs[utils.RETRIES],
+            utils.DISABLECOMPRESSION: False}
+
+        success, model_update = self.common._migrate_volume(
+            array_id, volume, device_id, srp, target_slo, target_workload,
+            volume_name, new_type, extra_specs)
+        mck_break.assert_called_once_with(
+            array_id, device_id, volume_name, extra_specs)
+        mck_retype.assert_called_once_with(
+            array_id, srp, device_id, volume, volume_name, extra_specs,
+            target_slo, target_workload, target_extra_specs)
+        self.assertTrue(success)
 
     @mock.patch.object(
+        common.PowerMaxCommon, 'get_volume_metadata', return_value='')
+    @mock.patch.object(
+        common.PowerMaxCommon, '_post_retype_srdf_protect_storage_group',
+        return_value=('Enabled', tpd.PowerMaxData.rdf_group_vol_details,
+                      tpd.PowerMaxData.device_id2))
+    @mock.patch.object(
+        common.PowerMaxCommon, '_retype_volume',
+        return_value=(True, tpd.PowerMaxData.defaultstoragegroup_name))
+    @mock.patch.object(
+        common.PowerMaxCommon, 'configure_volume_replication',
+        return_value=('first_vol_in_rdf_group', {},
+                      {'target_device_id': tpd.PowerMaxData.device_id2,
+                       'remote_array': tpd.PowerMaxData.remote_array},
+                      tpd.PowerMaxData.rep_extra_specs, False))
+    def test_migrate_volume_success_no_rep_to_rep(
+            self, mck_configure, mck_retype, mck_protect, mck_get):
+        self.common.rep_config = {'mode': utils.REP_SYNC,
+                                  'array': self.data.array}
+        array_id = self.data.array
+        volume = self.data.test_volume
+        device_id = self.data.device_id
+        srp = self.data.srp
+        target_slo = self.data.slo_silver
+        target_workload = self.data.workload
+        volume_name = volume.name
+        extra_specs = self.data.extra_specs
+        new_type = {'extra_specs': self.data.rep_extra_specs}
+
+        target_extra_specs = deepcopy(new_type['extra_specs'])
+        target_extra_specs.update({
+            utils.SRP: srp, utils.ARRAY: array_id, utils.SLO: target_slo,
+            utils.WORKLOAD: target_workload,
+            utils.INTERVAL: extra_specs[utils.INTERVAL],
+            utils.RETRIES: extra_specs[utils.RETRIES],
+            utils.DISABLECOMPRESSION: False, utils.REP_MODE: utils.REP_SYNC})
+
+        success, model_update = self.common._migrate_volume(
+            array_id, volume, device_id, srp, target_slo, target_workload,
+            volume_name, new_type, extra_specs)
+        mck_configure.assert_called_once_with(
+            array_id, volume, device_id, target_extra_specs)
+        mck_retype.assert_called_once_with(
+            array_id, srp, device_id, volume, volume_name, extra_specs,
+            target_slo, target_workload, target_extra_specs)
+        self.assertTrue(success)
+
+    @mock.patch.object(
+        common.PowerMaxCommon, 'get_volume_metadata', return_value='')
+    @mock.patch.object(
+        common.PowerMaxCommon, '_retype_remote_volume', return_value=True)
+    @mock.patch.object(
+        common.PowerMaxCommon, '_retype_volume',
+        return_value=(True, tpd.PowerMaxData.defaultstoragegroup_name))
+    def test_migrate_volume_success_rep_to_rep(self, mck_retype, mck_remote,
+                                               mck_get):
+        self.common.rep_config = {'mode': utils.REP_SYNC,
+                                  'array': self.data.array}
+        array_id = self.data.array
+        volume = self.data.test_volume
+        device_id = self.data.device_id
+        srp = self.data.srp
+        target_slo = self.data.slo_silver
+        target_workload = self.data.workload
+        volume_name = volume.name
+        extra_specs = deepcopy(self.data.rep_extra_specs)
+        extra_specs[utils.SLO] = self.data.slo_diamond
+        new_type = {'extra_specs': self.data.rep_extra_specs}
+
+        target_extra_specs = deepcopy(new_type['extra_specs'])
+        target_extra_specs.update({
+            utils.SRP: srp, utils.ARRAY: array_id, utils.SLO: target_slo,
+            utils.WORKLOAD: target_workload,
+            utils.INTERVAL: extra_specs[utils.INTERVAL],
+            utils.RETRIES: extra_specs[utils.RETRIES],
+            utils.DISABLECOMPRESSION: False, utils.REP_MODE: utils.REP_SYNC})
+
+        success, model_update = self.common._migrate_volume(
+            array_id, volume, device_id, srp, target_slo, target_workload,
+            volume_name, new_type, extra_specs)
+        mck_retype.assert_called_once_with(
+            array_id, srp, device_id, volume, volume_name, extra_specs,
+            target_slo, target_workload, target_extra_specs)
+        mck_remote.assert_called_once_with(
+            array_id, volume, device_id, volume_name, utils.REP_SYNC,
+            True, target_extra_specs)
+        self.assertTrue(success)
+
+    @mock.patch.object(masking.PowerMaxMasking, 'add_volume_to_storage_group')
+    @mock.patch.object(provision.PowerMaxProvision, 'get_or_create_group')
+    @mock.patch.object(utils.PowerMaxUtils, 'get_rdf_management_group_name',
+                       return_value=tpd.PowerMaxData.rdf_managed_async_grp)
+    def test_add_volume_to_rdf_management_group(self, mck_get_rdf, mck_get_grp,
+                                                mck_add):
+        array = self.data.array
+        device_id = self.data.device_id
+        volume_name = self.data.volume_id
+        remote_array = self.data.remote_array
+        target_device_id = self.data.device_id2
+        extra_specs = self.data.rep_extra_specs
+        group_name = self.data.rdf_managed_async_grp
+
+        get_create_grp_calls = [
+            call(array, group_name, extra_specs),
+            call(remote_array, group_name, extra_specs)]
+        add_vol_calls = [
+            call(array, device_id, group_name, volume_name, extra_specs,
+                 force=True),
+            call(remote_array, target_device_id, group_name, volume_name,
+                 extra_specs, force=True)]
+
+        self.common._add_volume_to_rdf_management_group(
+            array, device_id, volume_name, remote_array, target_device_id,
+            extra_specs)
+        mck_get_grp.assert_has_calls(get_create_grp_calls)
+        mck_add.assert_has_calls(add_vol_calls)
+
+    @mock.patch.object(
+        common.PowerMaxCommon, '_delete_from_srp')
+    @mock.patch.object(
+        rest.PowerMaxRest, 'srdf_resume_replication')
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_rdf_group',
+        return_value=tpd.PowerMaxData.rdf_group_details)
+    @mock.patch.object(
+        masking.PowerMaxMasking, 'remove_and_reset_members')
+    @mock.patch.object(
+        provision.PowerMaxProvision, 'break_rdf_relationship')
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_storage_groups_from_volume',
+        return_value=tpd.PowerMaxData.default_sg_re_enabled)
+    @mock.patch.object(
+        utils.PowerMaxUtils, 'get_rdf_management_group_name',
+        return_value=tpd.PowerMaxData.rdf_managed_async_grp)
+    @mock.patch.object(
+        rest.PowerMaxRest, 'are_vols_rdf_paired',
+        return_value=(True, None, utils.RDF_SYNC_STATE))
+    def test_cleanup_remote_target_async_metro(
+            self, mck_paired, mck_get_rdf, mck_get_sg, mck_break, mck_reset,
+            mck_get_rdf_grp, mck_resume, mck_delete):
+        array = self.data.array
+        volume = self.data.test_volume
+        remote_array = self.data.remote_array
+        device_id = self.data.device_id
+        target_device_id = self.data.device_id2
+        rdf_group_no = self.data.rdf_group_no
+        volume_name = self.data.volume_id
+        rep_extra_specs = deepcopy(self.data.rep_extra_specs)
+        rep_extra_specs[utils.REP_MODE] = utils.REP_METRO
+        sg_name = self.data.default_sg_re_enabled
+        async_grp = self.data.rdf_managed_async_grp
+        pair_state = utils.RDF_SYNC_STATE
+        reset_calls = [
+            call(remote_array, volume, target_device_id, volume_name,
+                 rep_extra_specs, sg_name),
+            call(remote_array, volume, target_device_id, volume_name,
+                 rep_extra_specs, async_grp)]
+
+        self.common._cleanup_remote_target(
+            array, volume, remote_array, device_id, target_device_id,
+            rdf_group_no, volume_name, rep_extra_specs)
+        mck_paired.assert_called_once_with(
+            array, remote_array, device_id, target_device_id)
+        mck_get_rdf.assert_called_once_with(self.common.rep_config)
+        mck_get_sg.assert_called_once_with(array, device_id)
+        mck_break.assert_called_once_with(
+            array, device_id, sg_name, rdf_group_no, rep_extra_specs,
+            pair_state)
+        mck_reset.assert_has_calls(reset_calls)
+        mck_get_rdf_grp.assert_called_once_with(array, rdf_group_no)
+        mck_resume.assert_called_once_with(
+            array, sg_name, rdf_group_no, rep_extra_specs)
+        mck_delete.assert_called_once_with(
+            remote_array, target_device_id, volume_name, rep_extra_specs)
+
+    @mock.patch.object(
+        common.PowerMaxCommon, '_delete_from_srp')
+    @mock.patch.object(
+        rest.PowerMaxRest, 'srdf_resume_replication')
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_rdf_group',
+        return_value=tpd.PowerMaxData.rdf_group_details)
+    @mock.patch.object(
+        masking.PowerMaxMasking, 'remove_and_reset_members')
+    @mock.patch.object(
+        provision.PowerMaxProvision, 'break_rdf_relationship')
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_storage_groups_from_volume',
+        return_value=tpd.PowerMaxData.default_sg_re_enabled)
+    @mock.patch.object(
+        rest.PowerMaxRest, 'are_vols_rdf_paired',
+        return_value=(True, None, utils.RDF_SYNC_STATE))
+    def test_cleanup_remote_target_sync(
+            self, mck_paired, mck_get_sg, mck_break, mck_reset,
+            mck_get_rdf_grp, mck_resume, mck_delete):
+        array = self.data.array
+        volume = self.data.test_volume
+        remote_array = self.data.remote_array
+        device_id = self.data.device_id
+        target_device_id = self.data.device_id2
+        rdf_group_no = self.data.rdf_group_no
+        volume_name = self.data.volume_id
+        rep_extra_specs = deepcopy(self.data.rep_extra_specs)
+        rep_extra_specs[utils.REP_MODE] = utils.REP_SYNC
+        sg_name = self.data.default_sg_re_enabled
+        pair_state = utils.RDF_SYNC_STATE
+
+        self.common._cleanup_remote_target(
+            array, volume, remote_array, device_id, target_device_id,
+            rdf_group_no, volume_name, rep_extra_specs)
+        mck_paired.assert_called_once_with(
+            array, remote_array, device_id, target_device_id)
+        mck_get_sg.assert_called_once_with(array, device_id)
+        mck_break.assert_called_once_with(
+            array, device_id, sg_name, rdf_group_no, rep_extra_specs,
+            pair_state)
+        mck_reset.assert_called_once_with(
+            remote_array, volume, target_device_id, volume_name,
+            rep_extra_specs, sg_name)
+        mck_get_rdf_grp.assert_called_once_with(array, rdf_group_no)
+        mck_resume.assert_called_once_with(
+            array, sg_name, rdf_group_no, rep_extra_specs)
+        mck_delete.assert_called_once_with(
+            remote_array, target_device_id, volume_name, rep_extra_specs)
+
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_storage_groups_from_volume',
+        return_value=tpd.PowerMaxData.sg_list['storageGroupId'])
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_rdf_pair_volume',
+        return_value=tpd.PowerMaxData.rdf_group_vol_details)
+    @mock.patch.object(
         common.PowerMaxCommon, '_get_replication_extra_specs',
-        return_value=tpd.PowerMaxData.extra_specs_rep_enabled)
-    @mock.patch.object(rest.PowerMaxRest, 'get_storage_groups_from_volume',
-                       side_effect=[tpd.PowerMaxData.storagegroup_list,
-                                    ['OS-SRP_1-Diamond-DSS-RE-SG']])
-    @mock.patch.object(common.PowerMaxCommon, '_retype_volume',
-                       return_value=True)
-    def test_retype_volume_replication(self, mock_retype, mock_sg, mock_es):
-        for x in range(0, 2):
-            self.common._retype_remote_volume(
-                self.data.array, self.data.test_volume, self.data.device_id,
-                self.data.test_volume.name, utils.REP_SYNC,
-                True, self.data.extra_specs)
-        mock_retype.assert_called_once()
+        return_value=tpd.PowerMaxData.rep_extra_specs)
+    @mock.patch.object(
+        common.PowerMaxCommon, 'get_rdf_details',
+        return_value=(tpd.PowerMaxData.rdf_group_no,
+                      tpd.PowerMaxData.remote_array))
+    def test_cleanup_rdf_device_pair_vol_cnt_exception(
+            self, mck_get_rdf, mck_get_rep, mck_get_rdf_pair, mck_get_sg_list):
+        array = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        device_id = self.data.device_id
+        extra_specs = deepcopy(self.data.rep_extra_specs)
+        extra_specs[utils.REP_MODE] = utils.REP_SYNC
+        self.assertRaises(
+            exception.VolumeBackendAPIException,
+            self.common.cleanup_rdf_device_pair, array, rdf_group_no,
+            device_id, extra_specs)
+
+    @mock.patch.object(
+        rest.PowerMaxRest, 'srdf_resume_replication')
+    @mock.patch.object(
+        common.PowerMaxCommon, '_cleanup_rdf_storage_groups_post_r2_delete')
+    @mock.patch.object(
+        rest.PowerMaxRest, 'delete_volume')
+    @mock.patch.object(
+        rest.PowerMaxRest, 'remove_vol_from_sg')
+    @mock.patch.object(
+        rest.PowerMaxRest, 'srdf_remove_device_pair_from_storage_group')
+    @mock.patch.object(
+        rest.PowerMaxRest, 'srdf_suspend_replication')
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_num_vols_in_sg', return_value=2)
+    @mock.patch.object(
+        utils.PowerMaxUtils, 'get_rdf_management_group_name',
+        return_value=tpd.PowerMaxData.rdf_managed_async_grp)
+    @mock.patch.object(
+        rest.PowerMaxRest, 'wait_for_rdf_pair_sync')
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_storage_groups_from_volume',
+        return_value=tpd.PowerMaxData.sg_list_rep)
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_rdf_pair_volume',
+        return_value=tpd.PowerMaxData.rdf_group_vol_details)
+    @mock.patch.object(
+        common.PowerMaxCommon, '_get_replication_extra_specs',
+        return_value=tpd.PowerMaxData.rep_extra_specs_mgmt)
+    @mock.patch.object(
+        common.PowerMaxCommon, 'get_rdf_details',
+        return_value=(tpd.PowerMaxData.rdf_group_no,
+                      tpd.PowerMaxData.remote_array))
+    def test_cleanup_rdf_device_pair(
+            self, mck_get_rdf, mck_get_rep, mck_get_rdf_pair, mck_get_sg_list,
+            mck_wait, mck_get_mgmt_grp, mck_get_num_vols, mck_suspend,
+            mck_srdf_remove, mck_remove, mck_delete, mck_cleanup, mck_resume):
+        array = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        device_id = self.data.device_id
+        target_device_id = self.data.device_id2
+        extra_specs = deepcopy(self.data.rep_extra_specs)
+        extra_specs[utils.REP_MODE] = utils.REP_METRO
+        rep_extra_specs = self.data.rep_extra_specs_mgmt
+        rdf_mgmt_grp = self.data.rdf_managed_async_grp
 
+        self.common.cleanup_rdf_device_pair(
+            array, rdf_group_no, device_id, extra_specs)
 
-class PowerMaxReplicationDebugTest(test.TestCase):
-    def setUp(self):
-        self.data = tpd.PowerMaxData()
-        super(PowerMaxReplicationDebugTest, self).setUp()
-        mock_logging = self.mock_object(common, 'LOG')
-        mock_log = mock.Mock()
-        mock_log.isEnabledFor = True
-        mock_logging.getLogger = mock.Mock(return_value=mock_log)
-        self.replication_device = {
-            'target_device_id': self.data.remote_array,
-            'remote_port_group': self.data.port_group_name_f,
-            'remote_pool': self.data.srp2,
-            'rdf_group_label': self.data.rdf_group_name,
-            'allow_extend': 'True'}
-        volume_utils.get_max_over_subscription_ratio = mock.Mock()
-        configuration = tpfo.FakeConfiguration(
-            None, 'CommonReplicationDebugTests', 1, 1, san_ip='1.1.1.1',
-            san_login='smc', vmax_array=self.data.array, vmax_srp='SRP_1',
-            san_password='smc', san_api_port=8443,
-            vmax_port_groups=[self.data.port_group_name_f],
-            replication_device=self.replication_device,
-            debug=True)
-        rest.PowerMaxRest._establish_rest_session = mock.Mock(
-            return_value=tpfo.FakeRequestsSession())
-        driver = fc.PowerMaxFCDriver(configuration=configuration)
-        self.driver = driver
-        self.common = self.driver.common
-        self.masking = self.common.masking
-        self.provision = self.common.provision
-        self.rest = self.common.rest
-        self.utils = self.common.utils
-        self.utils.get_volumetype_extra_specs = (
-            mock.Mock(
-                return_value=self.data.vol_type_extra_specs_rep_enabled))
-        self.extra_specs = deepcopy(self.data.extra_specs_rep_enabled)
-        self.extra_specs['retries'] = 1
-        self.extra_specs['interval'] = 1
-        self.extra_specs['rep_mode'] = 'Synchronous'
+        remove_calls = [
+            call(array, rdf_mgmt_grp, device_id, extra_specs),
+            call(self.data.remote_array, rdf_mgmt_grp, target_device_id,
+                 rep_extra_specs)]
+        mck_suspend.assert_called_once_with(
+            array, rdf_mgmt_grp, rdf_group_no, rep_extra_specs)
+        mck_remove.assert_has_calls(remove_calls)
+        mck_resume.assert_called_once_with(
+            array, rdf_mgmt_grp, rdf_group_no, rep_extra_specs)
 
-    @mock.patch.object(common.PowerMaxCommon, '_sync_check')
-    @mock.patch.object(masking.PowerMaxMasking, 'remove_and_reset_members')
-    @mock.patch.object(common.PowerMaxCommon, '_create_volume')
-    @mock.patch.object(rest.PowerMaxRest, 'get_array_model_info',
-                       return_value=('VMAX250F', False))
-    def test_setup_volume_replication_target_debug(
-            self, mock_model, mock_create, mock_rm, mck_sync):
-        rep_status, rep_data, rep_info_dict = (
-            self.common.setup_volume_replication(
-                self.data.array, self.data.test_volume, self.data.device_id,
-                self.extra_specs, self.data.device_id2))
-        self.assertEqual(fields.ReplicationStatus.ENABLED, rep_status)
-        self.assertEqual({'array': self.data.remote_array,
-                          'device_id': self.data.device_id2}, rep_data)
-        self.assertEqual('VMAX250F', rep_info_dict['target_array_model'])
-        mock_create.assert_not_called()
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_num_vols_in_sg', return_value=1)
+    @mock.patch.object(
+        common.PowerMaxCommon, '_get_replication_extra_specs',
+        return_value=tpd.PowerMaxData.rep_extra_specs_mgmt)
+    def test_prepare_replication_details(self, mck_get_rep, mck_get_vols):
+        extra_specs = deepcopy(self.data.extra_specs_rep_enabled)
+        extra_specs['rep_mode'] = 'Synchronous'
+        extra_specs['workload'] = 'NONE'
+
+        rep_extra_specs = self.data.rep_extra_specs_mgmt
+        ref_info_dict = {
+            'initial_device_list': ['00001', '00002'],
+            'local_array': self.data.array,
+            'rdf_group_no': self.data.rdf_group_no,
+            'remote_array': self.data.remote_array,
+            'rep_mode': utils.REP_SYNC, 'service_level': self.data.slo_diamond,
+            'sg_name': self.data.default_sg_no_slo_re_enabled,
+            'sync_interval': 2, 'sync_retries': 200}
+
+        rep_first_vol, resp_extra_specs, rep_info_dict = (
+            self.common.prepare_replication_details(extra_specs))
+        self.assertFalse(rep_first_vol)
+        self.assertEqual(rep_extra_specs, resp_extra_specs)
+        self.assertEqual(ref_info_dict, rep_info_dict)
 
-    @mock.patch.object(common.PowerMaxCommon, '_sync_check')
-    @mock.patch.object(masking.PowerMaxMasking, 'remove_and_reset_members')
-    @mock.patch.object(rest.PowerMaxRest, 'get_array_model_info',
-                       return_value=('VMAX250F', False))
-    def test_setup_volume_replication_no_target_debug(
-            self, mock_model, mock_rm, mck_sync):
-        rep_status, rep_data, rep_info_dict = (
-            self.common.setup_volume_replication(
-                self.data.array, self.data.test_volume, self.data.device_id,
-                self.extra_specs))
-        self.assertEqual(fields.ReplicationStatus.ENABLED, rep_status)
-        self.assertEqual({'array': self.data.remote_array,
-                          'device_id': self.data.device_id}, rep_data)
-        self.assertEqual('VMAX250F', rep_info_dict['target_array_model'])
+    @mock.patch.object(
+        rest.PowerMaxRest, 'srdf_protect_storage_group')
+    def test_srdf_protect_storage_group(self, mck_protect):
+        extra_specs = self.data.rep_extra_specs
+        rep_extra_specs = self.data.rep_extra_specs_mgmt
+        volume_dict = {'storage_group': self.data.rdf_managed_async_grp}
+
+        self.common.srdf_protect_storage_group(extra_specs, rep_extra_specs,
+                                               volume_dict)
+        mck_protect.assert_called_once_with(
+            extra_specs['array'], rep_extra_specs['array'],
+            rep_extra_specs['rdf_group_no'], extra_specs['rep_mode'],
+            volume_dict['storage_group'], rep_extra_specs['slo'], extra_specs)
+
+    def test_gather_replication_updates(self):
+        self.common.rep_config = {'rdf_group_label': self.data.rdf_group_name}
+        extra_specs = self.data.rep_extra_specs
+        rep_extra_specs = self.data.rep_extra_specs_mgmt
+        volume_dict = {'storage_group': self.data.rdf_managed_async_grp,
+                       'remote_device_id': self.data.device_id2,
+                       'device_uuid': self.data.volume_id}
+        ref_replication_update = (
+            {'replication_status': common.REPLICATION_ENABLED,
+             'replication_driver_data': six.text_type(
+                 {'array': self.data.remote_array,
+                  'device_id': self.data.device_id2})})
+
+        replication_update, rep_info_dict = (
+            self.common.gather_replication_updates(
+                extra_specs, rep_extra_specs, volume_dict))
+
+        self.assertEqual(ref_replication_update, replication_update)
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_rest.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_rest.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_rest.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_rest.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,13 +15,13 @@
 
 from copy import deepcopy
 import time
+from unittest import mock
+from unittest.mock import call
 
-import mock
 import requests
 
 from cinder import exception
 from cinder import test
-from cinder.tests.unit import utils as test_utils
 from cinder.tests.unit.volume.drivers.dell_emc.powermax import (
     powermax_data as tpd)
 from cinder.tests.unit.volume.drivers.dell_emc.powermax import (
@@ -428,6 +428,45 @@ class PowerMaxRestTest(test.TestCase):
                 volume_name, self.data.failed_resource,
                 self.data.test_volume.size, self.data.extra_specs)
 
+    @mock.patch.object(rest.PowerMaxRest, 'rename_volume')
+    @mock.patch.object(rest.PowerMaxRest, 'get_volume_list',
+                       return_value=['00001', '00002', '00003', '00004'])
+    @mock.patch.object(rest.PowerMaxRest, 'wait_for_job')
+    @mock.patch.object(rest.PowerMaxRest, 'modify_storage_group',
+                       return_value=(200, 'job'))
+    def test_create_volume_from_sg_rep_info(
+            self, mck_modify, mck_wait, mck_get_vol, mck_rename):
+        volume_name = self.data.volume_details[0]['volume_identifier']
+        sg_name = self.data.defaultstoragegroup_name
+        rep_info = self.data.rep_info_dict
+        rep_info['initial_device_list'] = ['00001', '00002', '00003']
+        ref_payload = self.data.create_vol_with_replication_payload
+        ref_volume_dict = {utils.ARRAY: self.data.array,
+                           utils.DEVICE_ID: '00004'}
+
+        volume_dict = self.rest.create_volume_from_sg(
+            self.data.array, volume_name, sg_name,
+            self.data.test_volume.size, self.data.extra_specs, rep_info)
+        mck_modify.assert_called_once_with(
+            self.data.array, self.data.defaultstoragegroup_name, ref_payload)
+        self.assertEqual(ref_volume_dict, volume_dict)
+
+    @mock.patch.object(rest.PowerMaxRest, 'get_volume_list',
+                       return_value=['00001', '00002', '00003', '00004'])
+    @mock.patch.object(rest.PowerMaxRest, 'wait_for_job')
+    @mock.patch.object(rest.PowerMaxRest, 'modify_storage_group',
+                       return_value=(200, 'job'))
+    def test_create_volume_from_sg_rep_info_vol_cnt_exception(
+            self, mck_modify, mck_wait, mck_get_vol):
+        volume_name = self.data.volume_details[0]['volume_identifier']
+        sg_name = self.data.defaultstoragegroup_name
+        rep_info = self.data.rep_info_dict
+        rep_info['initial_device_list'] = ['00001', '00002']
+        self.assertRaises(exception.VolumeBackendAPIException,
+                          self.rest.create_volume_from_sg, self.data.array,
+                          volume_name, sg_name, self.data.test_volume.size,
+                          self.data.extra_specs, rep_info)
+
     def test_add_vol_to_sg_success(self):
         operation = 'Add volume to sg'
         status_code = 202
@@ -1151,6 +1190,14 @@ class PowerMaxRestTest(test.TestCase):
             self.rest.modify_volume_snap(array, source_id, target_id,
                                          snap_name, extra_specs)
             mock_modify.assert_not_called()
+            # copy mode is True
+            payload['copy'] = 'true'
+            self.rest.modify_volume_snap(
+                array, source_id, target_id, snap_name, extra_specs, link=True,
+                copy=True)
+            mock_modify.assert_called_once_with(
+                array, 'replication', 'snapshot', payload,
+                resource_name=snap_name, private='/private')
 
     def test_delete_volume_snap(self):
         array = self.data.array
@@ -1283,7 +1330,7 @@ class PowerMaxRestTest(test.TestCase):
                                   'host_io_limit_mb_sec': '4000'}}
         self.data.sg_details.append(sg_qos)
         array = self.data.array
-        extra_specs = self.data.extra_specs
+        extra_specs = deepcopy(self.data.extra_specs)
         extra_specs['qos'] = {'total_iops_sec': '4000',
                               'DistributionType': 'Always'}
         return_value = self.rest.update_storagegroup_qos(
@@ -1298,7 +1345,7 @@ class PowerMaxRestTest(test.TestCase):
     def test_update_storagegroup_qos_exception(self):
         array = self.data.array
         storage_group = self.data.defaultstoragegroup_name
-        extra_specs = self.data.extra_specs
+        extra_specs = deepcopy(self.data.extra_specs)
         extra_specs['qos'] = {'total_iops_sec': '4000',
                               'DistributionType': 'Wrong',
                               'total_bytes_sec': '4194304000'}
@@ -1371,152 +1418,40 @@ class PowerMaxRestTest(test.TestCase):
                 self.data.array, self.data.rdf_group_name)
             self.assertIsNone(rdfg_num3)
 
-    def test_create_rdf_device_pair(self):
-        ref_dict = {'array': self.data.remote_array,
-                    'device_id': self.data.device_id2}
-        extra_specs = deepcopy(self.data.extra_specs)
-        extra_specs[utils.REP_MODE] = utils.REP_SYNC
-        rdf_dict = self.rest.create_rdf_device_pair(
-            self.data.array, self.data.device_id, self.data.rdf_group_no,
-            self.data.device_id2, self.data.remote_array, extra_specs)
-        self.assertEqual(ref_dict, rdf_dict)
-
-    def test_create_rdf_device_pair_async(self):
-        ref_dict = {'array': self.data.remote_array,
-                    'device_id': self.data.device_id2}
-        extra_specs = deepcopy(self.data.extra_specs)
-        extra_specs[utils.REP_MODE] = utils.REP_ASYNC
-        rdf_dict = self.rest.create_rdf_device_pair(
-            self.data.array, self.data.device_id, self.data.rdf_group_no,
-            self.data.device_id2, self.data.remote_array, extra_specs)
-        self.assertEqual(ref_dict, rdf_dict)
-
-    def test_create_rdf_device_pair_metro(self):
-        ref_dict = {'array': self.data.remote_array,
-                    'device_id': self.data.device_id2}
-        extra_specs = deepcopy(self.data.extra_specs)
-        extra_specs[utils.REP_MODE] = utils.REP_METRO
-        extra_specs[utils.METROBIAS] = True
-        rdf_dict = self.rest.create_rdf_device_pair(
-            self.data.array, self.data.device_id, self.data.rdf_group_no,
-            self.data.device_id2, self.data.remote_array, extra_specs)
-        self.assertEqual(ref_dict, rdf_dict)
-
-    @mock.patch.object(rest.PowerMaxRest, 'wait_for_job')
-    @mock.patch.object(rest.PowerMaxRest, 'create_resource',
-                       return_value=(200, 'job'))
-    @mock.patch.object(rest.PowerMaxRest, 'is_next_gen_array',
-                       side_effect=[True, True, False, False])
-    def test_test_create_rdf_device_pair_metro_cons_exempt(
-            self, mck_nxt_gen, mck_create, mck_wait):
-        extra_specs = deepcopy(self.data.extra_specs)
-        extra_specs[utils.REP_MODE] = utils.REP_METRO
-        extra_specs[utils.METROBIAS] = True
-
-        ref_payload = ({
-            "deviceNameListSource": [{"name": self.data.device_id}],
-            "deviceNameListTarget": [{"name": self.data.device_id2}],
-            "replicationMode": 'Active',
-            "establish": 'true',
-            "rdfType": 'RDF1'})
-
-        get_payload_true = {'rdfType': 'RDF1', 'consExempt': 'true'}
-        get_payload_false = {'rdfType': 'RDF1', 'consExempt': 'false'}
-
-        with mock.patch.object(
-                self.rest, 'get_metro_payload_info',
-                side_effect=[get_payload_true,
-                             get_payload_false]) as mock_payload:
-            ref_extra_specs = deepcopy(extra_specs)
-
-            ref_extra_specs[utils.RDF_CONS_EXEMPT] = True
-            self.rest.create_rdf_device_pair(
-                self.data.array, self.data.device_id, self.data.rdf_group_no,
-                self.data.device_id2, self.data.remote_array, extra_specs)
-            mock_payload.assert_called_once_with(
-                self.data.array, ref_payload, self.data.rdf_group_no,
-                ref_extra_specs)
-
-            mock_payload.reset_mock()
-
-            ref_extra_specs[utils.RDF_CONS_EXEMPT] = False
-            self.rest.create_rdf_device_pair(
-                self.data.array, self.data.device_id, self.data.rdf_group_no,
-                self.data.device_id2, self.data.remote_array, extra_specs)
-            mock_payload.assert_called_once_with(
-                self.data.array, ref_payload, self.data.rdf_group_no,
-                ref_extra_specs)
-
     @mock.patch.object(rest.PowerMaxRest, 'get_rdf_group',
                        side_effect=[{'numDevices': 0}, {'numDevices': 0},
                                     {'numDevices': 1}, {'numDevices': 1}])
     def test_get_metro_payload_info(self, mock_rdfg):
-        payload_in = {'establish': 'true', 'rdfType': 'RDF1'}
+        payload_in = {'establish': 'true', 'rdfMode': 'Active',
+                      'rdfType': 'RDF1'}
 
         # First volume out, Metro use bias not set
         act_payload_1 = self.rest.get_metro_payload_info(
-            self.data.array, payload_in.copy(), self.data.rdf_group_no, {})
+            self.data.array, payload_in.copy(), self.data.rdf_group_no, {},
+            True)
         self.assertEqual(payload_in, act_payload_1)
 
         # First volume out, Metro use bias set
         act_payload_2 = self.rest.get_metro_payload_info(
             self.data.array, payload_in.copy(), self.data.rdf_group_no,
-            {'metro_bias': True})
+            {'metro_bias': True}, True)
         self.assertEqual('true', act_payload_2['metroBias'])
 
         # Not first vol in RDFG, consistency exempt not set
         act_payload_3 = self.rest.get_metro_payload_info(
             self.data.array, payload_in.copy(), self.data.rdf_group_no,
-            {'consExempt': False})
-        ref_payload_3 = {'rdfType': 'NA', 'format': 'true'}
+            {'exempt': False}, False)
+        ref_payload_3 = {'rdfMode': 'Active', 'rdfType': 'RDF1'}
         self.assertEqual(ref_payload_3, act_payload_3)
 
         # Not first vol in RDFG, consistency exempt set
         act_payload_4 = self.rest.get_metro_payload_info(
             self.data.array, payload_in.copy(), self.data.rdf_group_no,
-            {'consExempt': True})
-        ref_payload_4 = {'rdfType': 'RDF1', 'consExempt': 'true'}
+            {'exempt': True}, True)
+        ref_payload_4 = {'rdfType': 'RDF1', 'exempt': 'true',
+                         'rdfMode': 'Active'}
         self.assertEqual(ref_payload_4, act_payload_4)
 
-    def test_modify_rdf_device_pair(self):
-        resource_name = '70/volume/00001'
-        common_opts = {'force': 'false', 'symForce': 'false', 'star': 'false',
-                       'hop2': 'false', 'bypass': 'false'}
-        suspend_payload = {'action': 'SUSPEND',
-                           'executionOption': 'ASYNCHRONOUS',
-                           'suspend': common_opts}
-
-        failover_opts = deepcopy(common_opts)
-        failover_opts.update({'establish': 'true', 'restore': 'false',
-                              'remote': 'false', 'immediate': 'false'})
-        failover_payload = {'action': 'Failover',
-                            'executionOption': 'ASYNCHRONOUS',
-                            'failover': failover_opts}
-        with mock.patch.object(
-                self.rest, 'modify_resource', return_value=(
-                    200, self.data.job_list[0])) as mock_mod:
-            self.rest.modify_rdf_device_pair(
-                self.data.array, self.data.device_id, self.data.rdf_group_no,
-                self.data.extra_specs, suspend=True)
-            mock_mod.assert_called_once_with(
-                self.data.array, 'replication', 'rdf_group',
-                suspend_payload, resource_name=resource_name,
-                private='/private')
-            mock_mod.reset_mock()
-            self.rest.modify_rdf_device_pair(
-                self.data.array, self.data.device_id, self.data.rdf_group_no,
-                self.data.extra_specs, suspend=False)
-            mock_mod.assert_called_once_with(
-                self.data.array, 'replication', 'rdf_group',
-                failover_payload, resource_name=resource_name,
-                private='/private')
-
-    @mock.patch.object(rest.PowerMaxRest, 'delete_resource')
-    def test_delete_rdf_pair(self, mock_del):
-        self.rest.delete_rdf_pair(
-            self.data.array, self.data.device_id, self.data.rdf_group_no)
-        mock_del.assert_called_once()
-
     def test_get_storage_group_rep(self):
         array = self.data.array
         source_group_name = self.data.storagegroup_name_source
@@ -1545,6 +1480,27 @@ class PowerMaxRestTest(test.TestCase):
             mock_create.assert_called_once_with(
                 array, source_group, snap_name, extra_specs)
 
+    def test_delete_storagegroup_snap(self):
+        array = self.data.array
+        source_group = self.data.storagegroup_name_source
+        snap_name = self.data.group_snapshot_name
+        with mock.patch.object(
+                self.rest, 'delete_storagegroup_snap') as mock_delete:
+            self.rest.delete_storagegroup_snap(
+                array, source_group, snap_name, '0')
+            mock_delete.assert_called_once_with(
+                array, source_group, snap_name, '0')
+
+    @mock.patch.object(rest.PowerMaxRest, 'get_resource',
+                       return_value={'generations': ['0', '1']})
+    def test_get_storagegroup_snap_generation_list(self, mock_list):
+        array = self.data.array
+        source_group = self.data.storagegroup_name_source
+        snap_name = self.data.group_snapshot_name
+        ret_list = self.rest.get_storagegroup_snap_generation_list(
+            array, source_group, snap_name)
+        self.assertEqual(['0', '1'], ret_list)
+
     def test_get_storagegroup_rdf_details(self):
         details = self.rest.get_storagegroup_rdf_details(
             self.data.array, self.data.test_vol_grp_name,
@@ -1561,16 +1517,6 @@ class PowerMaxRestTest(test.TestCase):
             self.data.rdf_group_no, 'Establish')
         self.assertTrue(verify2)
 
-    def test_modify_storagegroup_rdf(self):
-        with mock.patch.object(
-                self.rest, 'modify_resource',
-                return_value=(202, self.data.job_list[0])) as mock_mod:
-            self.rest.modify_storagegroup_rdf(
-                self.data.array, self.data.test_vol_grp_name,
-                self.data.rdf_group_no, 'Failover',
-                self.data.extra_specs)
-            mock_mod.assert_called_once()
-
     def test_delete_storagegroup_rdf(self):
         with mock.patch.object(
                 self.rest, 'delete_resource') as mock_del:
@@ -1595,24 +1541,6 @@ class PowerMaxRestTest(test.TestCase):
         self.assertTrue(is_next_gen2)
         self.assertEqual('PowerMax 2000', array_model_powermax)
 
-    @mock.patch('oslo_service.loopingcall.FixedIntervalLoopingCall',
-                new=test_utils.ZeroIntervalLoopingCall)
-    @mock.patch.object(rest.PowerMaxRest, 'are_vols_rdf_paired',
-                       side_effect=[('', '', 'syncinprog'),
-                                    ('', '', 'consistent'),
-                                    exception.CinderException])
-    def test_wait_for_rdf_consistent_state(self, mock_paired):
-        self.rest.wait_for_rdf_consistent_state(
-            self.data.array, self.data.remote_array,
-            self.data.device_id, self.data.device_id2,
-            self.data.extra_specs)
-        self.assertEqual(2, mock_paired.call_count)
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.rest.wait_for_rdf_consistent_state,
-                          self.data.array, self.data.remote_array,
-                          self.data.device_id, self.data.device_id2,
-                          self.data.extra_specs)
-
     @mock.patch.object(rest.PowerMaxRest, 'modify_resource',
                        return_value=('200', 'JobComplete'))
     def test_modify_volume_snap_rename(self, mock_modify):
@@ -1798,3 +1726,372 @@ class PowerMaxRestTest(test.TestCase):
             self.assertFalse(valid_version)
         request_count = mock_req.call_count
         self.assertEqual(2, request_count)
+
+    @mock.patch.object(rest.PowerMaxRest, 'get_resource',
+                       return_value=tpd.PowerMaxData.sg_rdf_group_details)
+    def test_get_storage_group_rdf_group_state(self, mck_get):
+        ref_get_resource = ('storagegroup/%(sg)s/rdf_group/%(rdfg)s' % {
+            'sg': self.data.test_vol_grp_name, 'rdfg': self.data.rdf_group_no})
+        states = self.rest.get_storage_group_rdf_group_state(
+            self.data.array, self.data.test_vol_grp_name,
+            self.data.rdf_group_no)
+        mck_get.assert_called_once_with(
+            self.data.array, 'replication', ref_get_resource)
+        self.assertEqual(states, [utils.RDF_SUSPENDED_STATE])
+
+    @mock.patch.object(rest.PowerMaxRest, 'get_resource')
+    def test_get_rdf_pair_volume(self, mck_get):
+        rdf_grp_no = self.data.rdf_group_no
+        device_id = self.data.device_id
+        array = self.data.array
+        ref_get_resource = ('rdf_group/%(rdf_group)s/volume/%(device)s' % {
+            'rdf_group': rdf_grp_no, 'device': device_id})
+        self.rest.get_rdf_pair_volume(array, rdf_grp_no, device_id)
+        mck_get.assert_called_once_with(array, 'replication', ref_get_resource)
+
+    @mock.patch.object(rest.PowerMaxRest, 'wait_for_job')
+    @mock.patch.object(rest.PowerMaxRest, 'create_resource',
+                       return_value=(200, 'job'))
+    def test_srdf_protect_storage_group(self, mck_create, mck_wait):
+        array_id = self.data.array
+        remote_array_id = self.data.remote_array
+        rdf_group_no = self.data.rdf_group_no
+        replication_mode = utils.REP_METRO
+        sg_name = self.data.default_sg_re_enabled
+        service_level = 'Diamond'
+        extra_specs = self.data.rep_extra_specs_metro
+        remote_sg = self.data.rdf_managed_async_grp
+
+        ref_payload = {
+            'executionOption': 'ASYNCHRONOUS', 'metroBias': 'true',
+            'replicationMode': 'Active', 'remoteSLO': service_level,
+            'remoteSymmId': remote_array_id, 'rdfgNumber': rdf_group_no,
+            'remoteStorageGroupName': remote_sg, 'establish': 'true'}
+        ref_resource = ('storagegroup/%(sg_name)s/rdf_group' % {
+            'sg_name': sg_name})
+
+        self.rest.srdf_protect_storage_group(
+            array_id, remote_array_id, rdf_group_no, replication_mode,
+            sg_name, service_level, extra_specs, target_sg=remote_sg)
+        mck_create.assert_called_once_with(
+            array_id, 'replication', ref_resource, ref_payload)
+
+    @mock.patch.object(rest.PowerMaxRest, 'wait_for_job')
+    @mock.patch.object(rest.PowerMaxRest, 'modify_resource',
+                       return_value=(200, 'job'))
+    def test_srdf_modify_group(self, mck_modify, mck_wait):
+        array_id = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        sg_name = self.data.default_sg_re_enabled
+        payload = {'executionOption': 'ASYNCHRONOUS', 'action': 'Suspend'}
+        extra_specs = self.data.rep_extra_specs
+        msg = 'test'
+        resource = ('storagegroup/%(sg_name)s/rdf_group/%(rdf_group_no)s' % {
+            'sg_name': sg_name, 'rdf_group_no': rdf_group_no})
+
+        self.rest.srdf_modify_group(
+            array_id, rdf_group_no, sg_name, payload, extra_specs, msg)
+        mck_modify.assert_called_once_with(
+            array_id, 'replication', resource, payload)
+        mck_wait.assert_called_once_with(msg, 200, 'job', extra_specs)
+
+    @mock.patch.object(rest.PowerMaxRest, 'wait_for_job')
+    @mock.patch.object(rest.PowerMaxRest, 'modify_resource',
+                       return_value=(200, 'job'))
+    def test_srdf_modify_group_async_call_false(self, mck_modify, mck_wait):
+        array_id = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        sg_name = self.data.default_sg_re_enabled
+        payload = {'action': 'Suspend'}
+        extra_specs = self.data.rep_extra_specs
+        msg = 'test'
+        resource = ('storagegroup/%(sg_name)s/rdf_group/%(rdf_group_no)s' % {
+            'sg_name': sg_name, 'rdf_group_no': rdf_group_no})
+
+        self.rest.srdf_modify_group(
+            array_id, rdf_group_no, sg_name, payload, extra_specs, msg, False)
+        mck_modify.assert_called_once_with(
+            array_id, 'replication', resource, payload)
+        mck_wait.assert_not_called()
+
+    @mock.patch.object(rest.PowerMaxRest, 'srdf_modify_group')
+    @mock.patch.object(rest.PowerMaxRest, 'get_storage_group_rdf_group_state',
+                       return_value=[utils.RDF_CONSISTENT_STATE])
+    def test_srdf_suspend_replication(self, mck_get, mck_modify):
+        array_id = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        sg_name = self.data.default_sg_re_enabled
+        rep_extra_specs = self.data.rep_extra_specs
+
+        self.rest.srdf_suspend_replication(
+            array_id, sg_name, rdf_group_no, rep_extra_specs)
+        mck_modify.assert_called_once_with(
+            array_id, rdf_group_no, sg_name,
+            {'suspend': {'force': 'true'}, 'action': 'Suspend'},
+            rep_extra_specs, 'Suspend SRDF Group Replication')
+
+    @mock.patch.object(rest.PowerMaxRest, 'srdf_modify_group')
+    @mock.patch.object(rest.PowerMaxRest, 'get_storage_group_rdf_group_state',
+                       return_value=[utils.RDF_SUSPENDED_STATE])
+    def test_srdf_suspend_replication_already_suspended(self, mck_get,
+                                                        mck_modify):
+        array_id = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        sg_name = self.data.default_sg_re_enabled
+        rep_extra_specs = self.data.rep_extra_specs
+
+        self.rest.srdf_suspend_replication(
+            array_id, sg_name, rdf_group_no, rep_extra_specs)
+        mck_modify.assert_not_called()
+
+    @mock.patch.object(rest.PowerMaxRest, 'srdf_modify_group')
+    @mock.patch.object(rest.PowerMaxRest, 'get_storage_group_rdf_group_state',
+                       return_value=[utils.RDF_SUSPENDED_STATE])
+    def test_srdf_resume_replication(self, mck_get, mck_modify):
+        array_id = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        sg_name = self.data.default_sg_re_enabled
+        rep_extra_specs = self.data.rep_extra_specs
+
+        self.rest.srdf_resume_replication(
+            array_id, sg_name, rdf_group_no, rep_extra_specs)
+        mck_modify.assert_called_once_with(
+            array_id, rdf_group_no, sg_name, {'action': 'Resume'},
+            rep_extra_specs, 'Resume SRDF Group Replication', True)
+
+    @mock.patch.object(rest.PowerMaxRest, 'srdf_modify_group')
+    @mock.patch.object(rest.PowerMaxRest, 'get_storage_group_rdf_group_state',
+                       return_value=[utils.RDF_SUSPENDED_STATE])
+    def test_srdf_resume_replication_metro(self, mck_get, mck_modify):
+        array_id = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        sg_name = self.data.default_sg_re_enabled
+        rep_extra_specs = self.data.rep_extra_specs_metro
+
+        self.rest.srdf_resume_replication(
+            array_id, sg_name, rdf_group_no, rep_extra_specs)
+        mck_modify.assert_called_once_with(
+            array_id, rdf_group_no, sg_name,
+            {"action": "Establish", "establish": {"metroBias": "true"}},
+            rep_extra_specs, 'Resume SRDF Group Replication', True)
+
+    @mock.patch.object(rest.PowerMaxRest, 'srdf_modify_group')
+    @mock.patch.object(rest.PowerMaxRest, 'get_storage_group_rdf_group_state',
+                       return_value=[utils.RDF_CONSISTENT_STATE])
+    def test_srdf_resume_replication_already_resumed(self, mck_get,
+                                                     mck_modify):
+        array_id = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        sg_name = self.data.default_sg_re_enabled
+        rep_extra_specs = self.data.rep_extra_specs
+
+        self.rest.srdf_resume_replication(
+            array_id, sg_name, rdf_group_no, rep_extra_specs)
+        mck_modify.assert_not_called()
+
+    @mock.patch.object(rest.PowerMaxRest, 'srdf_modify_group')
+    @mock.patch.object(rest.PowerMaxRest, 'get_storage_group_rdf_group_state',
+                       return_value=[utils.RDF_CONSISTENT_STATE])
+    def test_srdf_establish_replication(self, mck_get, mck_modify):
+        array_id = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        sg_name = self.data.default_sg_re_enabled
+        rep_extra_specs = self.data.rep_extra_specs
+
+        first_call = call(array_id, rdf_group_no, sg_name,
+                          {'action': 'Suspend'}, rep_extra_specs,
+                          'Suspend SRDF Group Replication')
+        second_call = call(array_id, rdf_group_no, sg_name,
+                           {'action': 'Establish'}, rep_extra_specs,
+                           'Incremental Establish SRDF Group Replication')
+
+        self.rest.srdf_establish_replication(
+            array_id, sg_name, rdf_group_no, rep_extra_specs)
+        mck_modify.assert_has_calls([first_call, second_call], any_order=False)
+
+    @mock.patch.object(rest.PowerMaxRest, 'srdf_modify_group')
+    def test_srdf_failover_group(self, mck_modify):
+        array_id = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        sg_name = self.data.default_sg_re_enabled
+        rep_extra_specs = self.data.rep_extra_specs
+
+        self.rest.srdf_failover_group(
+            array_id, sg_name, rdf_group_no, rep_extra_specs)
+        mck_modify.assert_called_once_with(
+            array_id, rdf_group_no, sg_name, {'action': 'Failover'},
+            rep_extra_specs, 'Failing over SRDF group replication')
+
+    @mock.patch.object(rest.PowerMaxRest, 'srdf_modify_group')
+    def test_srdf_failback_group(self, mck_modify):
+        array_id = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        sg_name = self.data.default_sg_re_enabled
+        rep_extra_specs = self.data.rep_extra_specs
+
+        self.rest.srdf_failback_group(
+            array_id, sg_name, rdf_group_no, rep_extra_specs)
+        mck_modify.assert_called_once_with(
+            array_id, rdf_group_no, sg_name, {'action': 'Failback'},
+            rep_extra_specs, 'Failing back SRDF group replication')
+
+    @mock.patch.object(rest.PowerMaxRest, 'wait_for_job')
+    @mock.patch.object(rest.PowerMaxRest, 'modify_storage_group',
+                       return_value=(200, 'job'))
+    def test_srdf_remove_device_pair_from_storage_group(self, mck_modify,
+                                                        mck_wait):
+        array_id = self.data.array
+        sg_name = self.data.default_sg_re_enabled
+        remote_array_id = self.data.remote_array
+        device_id = self.data.device_id
+        rep_extra_specs = self.data.rep_extra_specs
+        ref_payload = {
+            'editStorageGroupActionParam': {
+                'removeVolumeParam': {
+                    'volumeId': [device_id],
+                    'remoteSymmSGInfoParam': {
+                        'remote_symmetrix_1_id': remote_array_id,
+                        'remote_symmetrix_1_sgs': [sg_name]}}}}
+
+        self.rest.srdf_remove_device_pair_from_storage_group(
+            array_id, sg_name, remote_array_id, device_id, rep_extra_specs)
+        mck_modify.assert_called_once_with(
+            array_id, sg_name, ref_payload)
+
+    @mock.patch.object(rest.PowerMaxRest, 'delete_resource')
+    def test_srdf_delete_device_pair(self, mck_del):
+        array_id = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        device_id = self.data.device_id
+        ref_resource = ('%(rdfg)s/volume/%(dev)s' % {
+            'rdfg': rdf_group_no, 'dev': device_id})
+
+        self.rest.srdf_delete_device_pair(
+            array_id, rdf_group_no, device_id)
+        mck_del.assert_called_once_with(
+            array_id, 'replication', 'rdf_group', ref_resource)
+
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_rdf_pair_volume',
+        return_value=tpd.PowerMaxData.rdf_group_vol_details)
+    @mock.patch.object(rest.PowerMaxRest, 'wait_for_job')
+    @mock.patch.object(rest.PowerMaxRest, 'create_resource',
+                       return_value=(200, 'job'))
+    def test_srdf_create_device_pair_async(
+            self, mck_create, mck_wait, mck_get):
+        array_id = self.data.array
+        remote_array = self.data.remote_array
+        rdf_group_no = self.data.rdf_group_no
+        mode = utils.REP_ASYNC
+        device_id = self.data.device_id
+        tgt_device_id = self.data.device_id2
+        rep_extra_specs = self.data.rep_extra_specs
+
+        ref_payload = {
+            'executionOption': 'ASYNCHRONOUS', 'rdfMode': mode,
+            'localDeviceListCriteriaParam': {'localDeviceList': [device_id]},
+            'rdfType': 'RDF1', 'invalidateR2': 'true', 'exempt': 'true'}
+        ref_resource = 'rdf_group/%(rdfg)s/volume' % {'rdfg': rdf_group_no}
+        ref_response = {
+            'array': array_id, 'remote_array': remote_array,
+            'src_device': device_id, 'tgt_device': tgt_device_id,
+            'session_info': self.data.rdf_group_vol_details}
+
+        create_response = self.rest.srdf_create_device_pair(
+            array_id, rdf_group_no, mode, device_id, rep_extra_specs, True)
+        mck_create.assert_called_once_with(
+            array_id, 'replication', ref_resource, ref_payload)
+        mck_get.assert_called_once_with(
+            array_id, rdf_group_no, device_id)
+        self.assertEqual(ref_response, create_response)
+
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_rdf_pair_volume',
+        return_value=tpd.PowerMaxData.rdf_group_vol_details)
+    @mock.patch.object(rest.PowerMaxRest, 'wait_for_job')
+    @mock.patch.object(rest.PowerMaxRest, 'create_resource',
+                       return_value=(200, 'job'))
+    def test_srdf_create_device_pair_sync(
+            self, mck_create, mck_wait, mck_get):
+        array_id = self.data.array
+        remote_array = self.data.remote_array
+        rdf_group_no = self.data.rdf_group_no
+        mode = utils.REP_SYNC
+        device_id = self.data.device_id
+        tgt_device_id = self.data.device_id2
+        rep_extra_specs = self.data.rep_extra_specs
+
+        ref_payload = {
+            'executionOption': 'ASYNCHRONOUS', 'rdfMode': mode,
+            'localDeviceListCriteriaParam': {'localDeviceList': [device_id]},
+            'rdfType': 'RDF1', 'establish': 'true'}
+        ref_resource = 'rdf_group/%(rdfg)s/volume' % {'rdfg': rdf_group_no}
+        ref_response = {
+            'array': array_id, 'remote_array': remote_array,
+            'src_device': device_id, 'tgt_device': tgt_device_id,
+            'session_info': self.data.rdf_group_vol_details}
+
+        create_response = self.rest.srdf_create_device_pair(
+            array_id, rdf_group_no, mode, device_id, rep_extra_specs, True)
+        mck_create.assert_called_once_with(
+            array_id, 'replication', ref_resource, ref_payload)
+        mck_get.assert_called_once_with(
+            array_id, rdf_group_no, device_id)
+        self.assertEqual(ref_response, create_response)
+
+    @mock.patch.object(rest.PowerMaxRest, 'get_storage_group_rdf_group_state',
+                       return_value=[utils.RDF_CONSISTENT_STATE])
+    def test_wait_for_rdf_group_sync(self, mck_get):
+        array_id = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        sg_name = self.data.default_sg_re_enabled
+        rep_extra_specs = deepcopy(self.data.rep_extra_specs)
+        rep_extra_specs['sync_retries'] = 2
+        rep_extra_specs['sync_interval'] = 1
+
+        self.rest.wait_for_rdf_group_sync(
+            array_id, sg_name, rdf_group_no, rep_extra_specs)
+        mck_get.assert_called_once_with(array_id, sg_name, rdf_group_no)
+
+    @mock.patch.object(rest.PowerMaxRest, 'get_storage_group_rdf_group_state',
+                       return_value=[utils.RDF_SYNCINPROG_STATE])
+    def test_wait_for_rdf_group_sync_fail(self, mck_get):
+        array_id = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        sg_name = self.data.default_sg_re_enabled
+        rep_extra_specs = deepcopy(self.data.rep_extra_specs)
+        rep_extra_specs['sync_retries'] = 1
+        rep_extra_specs['sync_interval'] = 1
+
+        self.assertRaises(exception.VolumeBackendAPIException,
+                          self.rest.wait_for_rdf_group_sync,
+                          array_id, sg_name, rdf_group_no, rep_extra_specs)
+
+    @mock.patch.object(rest.PowerMaxRest, 'get_rdf_pair_volume',
+                       return_value=tpd.PowerMaxData.rdf_group_vol_details)
+    def test_wait_for_rdf_pair_sync(self, mck_get):
+        array_id = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        sg_name = self.data.default_sg_re_enabled
+        rep_extra_specs = deepcopy(self.data.rep_extra_specs)
+        rep_extra_specs['sync_retries'] = 2
+        rep_extra_specs['sync_interval'] = 1
+
+        self.rest.wait_for_rdf_pair_sync(
+            array_id, sg_name, rdf_group_no, rep_extra_specs)
+        mck_get.assert_called_once_with(array_id, sg_name, rdf_group_no)
+
+    @mock.patch.object(
+        rest.PowerMaxRest, 'get_rdf_pair_volume',
+        return_value=tpd.PowerMaxData.rdf_group_vol_details_not_synced)
+    def test_wait_for_rdf_pair_sync_fail(self, mck_get):
+        array_id = self.data.array
+        rdf_group_no = self.data.rdf_group_no
+        sg_name = self.data.default_sg_re_enabled
+        rep_extra_specs = deepcopy(self.data.rep_extra_specs)
+        rep_extra_specs['sync_retries'] = 1
+        rep_extra_specs['sync_interval'] = 1
+
+        self.assertRaises(exception.VolumeBackendAPIException,
+                          self.rest.wait_for_rdf_pair_sync,
+                          array_id, sg_name, rdf_group_no, rep_extra_specs)
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_utils.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,10 +15,10 @@
 
 from copy import deepcopy
 import datetime
+from unittest import mock
 
 from ddt import data
 from ddt import ddt
-import mock
 import six
 
 from cinder import exception
@@ -221,7 +221,7 @@ class PowerMaxUtilsTest(test.TestCase):
             extra_specs)
         self.assertTrue(do_disable_compression)
         # Compression disabled by no SL/WL combination
-        extra_specs2 = self.data.extra_specs
+        extra_specs2 = deepcopy(self.data.extra_specs)
         extra_specs2[utils.SLO] = None
         do_disable_compression2 = self.utils.is_compression_disabled(
             extra_specs2)
@@ -295,14 +295,29 @@ class PowerMaxUtilsTest(test.TestCase):
         rep_device_list6[0]['mode'] = 'metro'
         rep_config6 = self.utils.get_replication_config(rep_device_list6)
         self.assertFalse(rep_config6['metro_bias'])
-        self.assertFalse(rep_config6['allow_delete_metro'])
         # Success, mode is metro - metro options true
         rep_device_list7 = rep_device_list6
-        rep_device_list6[0].update(
-            {'allow_delete_metro': 'true', 'metro_use_bias': 'true'})
+        rep_device_list6[0].update({'metro_use_bias': 'true'})
         rep_config7 = self.utils.get_replication_config(rep_device_list7)
         self.assertTrue(rep_config7['metro_bias'])
-        self.assertTrue(rep_config7['allow_delete_metro'])
+
+    def test_get_replication_config_sync_retries_intervals(self):
+        # Default sync interval & retry values
+        rep_device_list1 = [{'target_device_id': self.data.remote_array,
+                             'remote_pool': self.data.srp,
+                             'remote_port_group': self.data.port_group_name_f,
+                             'rdf_group_label': self.data.rdf_group_name}]
+
+        rep_config1 = self.utils.get_replication_config(rep_device_list1)
+        self.assertEqual(200, rep_config1['sync_retries'])
+        self.assertEqual(3, rep_config1['sync_interval'])
+
+        # User set interval & retry values
+        rep_device_list2 = deepcopy(rep_device_list1)
+        rep_device_list2[0].update({'sync_retries': 300, 'sync_interval': 1})
+        rep_config2 = self.utils.get_replication_config(rep_device_list2)
+        self.assertEqual(300, rep_config2['sync_retries'])
+        self.assertEqual(1, rep_config2['sync_interval'])
 
     def test_is_volume_failed_over(self):
         vol = deepcopy(self.data.test_volume)
@@ -405,10 +420,10 @@ class PowerMaxUtilsTest(test.TestCase):
         metro_prefix = self.utils.get_replication_prefix(utils.REP_METRO)
         self.assertEqual('-RM', metro_prefix)
 
-    def test_get_async_rdf_managed_grp_name(self):
+    def test_get_rdf_management_group_name(self):
         rep_config = {'rdf_group_label': self.data.rdf_group_name,
                       'mode': utils.REP_ASYNC}
-        grp_name = self.utils.get_async_rdf_managed_grp_name(rep_config)
+        grp_name = self.utils.get_rdf_management_group_name(rep_config)
         self.assertEqual(self.data.rdf_managed_async_grp, grp_name)
 
     def test_is_metro_device(self):
@@ -422,9 +437,9 @@ class PowerMaxUtilsTest(test.TestCase):
         self.assertFalse(is_metro2)
 
     def test_does_vol_need_rdf_management_group(self):
-        self.assertFalse(self.utils.does_vol_need_rdf_management_group(
-            self.data.rep_extra_specs))
         extra_specs = deepcopy(self.data.rep_extra_specs)
+        self.assertFalse(self.utils.does_vol_need_rdf_management_group(
+            extra_specs))
         extra_specs[utils.REP_MODE] = utils.REP_ASYNC
         self.assertTrue(self.utils.does_vol_need_rdf_management_group(
             extra_specs))
@@ -450,26 +465,38 @@ class PowerMaxUtilsTest(test.TestCase):
 
     def test_get_child_sg_name(self):
         host_name = 'HostX'
+        port_group_label = self.data.port_group_name_f
         # Slo and rep enabled
-        extra_specs1 = self.data.extra_specs_rep_enabled
-        extra_specs1[utils.PORTGROUPNAME] = self.data.port_group_name_f
-        child_sg_name, do_disable_compression, rep_enabled, pg_name = (
-            self.utils.get_child_sg_name(host_name, extra_specs1))
+        extra_specs1 = {
+            'pool_name': u'Diamond+DSS+SRP_1+000197800123',
+            'slo': 'Diamond',
+            'workload': 'DSS',
+            'srp': 'SRP_1',
+            'array': self.data.array,
+            'interval': 3,
+            'retries': 120,
+            'replication_enabled': True,
+            'rep_mode': 'Synchronous',
+            utils.PORTGROUPNAME: self.data.port_group_name_f}
+
+        child_sg_name, do_disable_compression, rep_enabled = (
+            self.utils.get_child_sg_name(
+                host_name, extra_specs1, port_group_label))
         re_name = self.data.storagegroup_name_f + '-RE'
         self.assertEqual(re_name, child_sg_name)
         # Disable compression
-        extra_specs2 = self.data.extra_specs_disable_compression
-        extra_specs2[utils.PORTGROUPNAME] = self.data.port_group_name_f
-        child_sg_name, do_disable_compression, rep_enabled, pg_name = (
-            self.utils.get_child_sg_name(host_name, extra_specs2))
+        extra_specs2 = deepcopy(self.data.extra_specs_disable_compression)
+        child_sg_name, do_disable_compression, rep_enabled = (
+            self.utils.get_child_sg_name(
+                host_name, extra_specs2, port_group_label))
         cd_name = self.data.storagegroup_name_f + '-CD'
         self.assertEqual(cd_name, child_sg_name)
         # No slo
         extra_specs3 = deepcopy(self.data.extra_specs)
         extra_specs3[utils.SLO] = None
-        extra_specs3[utils.PORTGROUPNAME] = self.data.port_group_name_f
-        child_sg_name, do_disable_compression, rep_enabled, pg_name = (
-            self.utils.get_child_sg_name(host_name, extra_specs3))
+        child_sg_name, do_disable_compression, rep_enabled = (
+            self.utils.get_child_sg_name(
+                host_name, extra_specs3, port_group_label))
         self.assertEqual(self.data.no_slo_sg_name, child_sg_name)
 
     def test_change_multiattach(self):
@@ -499,14 +526,13 @@ class PowerMaxUtilsTest(test.TestCase):
                 self.utils.is_snapshot_manageable(volume))
 
     def test_get_volume_attached_hostname(self):
-        device_info_pass = self.data.volume_details_attached
+
+        attached_volume = deepcopy(self.data.test_volume)
+        attached_volume.volume_attachment.objects = [
+            self.data.test_volume_attachment]
         # Success
-        hostname = self.utils.get_volume_attached_hostname(device_info_pass)
+        hostname = self.utils.get_volume_attached_hostname(attached_volume)
         self.assertEqual('HostX', hostname)
-        # Fail
-        device_info_fail = self.data.volume_details_no_sg
-        hostname = self.utils.get_volume_attached_hostname(device_info_fail)
-        self.assertIsNone(hostname)
 
     def test_validate_qos_input_exception(self):
         qos_extra_spec = {'total_iops_sec': 90, 'DistributionType': 'Wrong',
@@ -610,3 +636,582 @@ class PowerMaxUtilsTest(test.TestCase):
         sl_3, wl_3 = self.utils.get_service_level_workload(extra_specs)
         self.assertEqual('Diamond', sl_3)
         self.assertEqual('DSS', wl_3)
+
+    def test_get_new_tags_none(self):
+        list_str1 = 'finance, production,   test'
+        list_str2 = 'production,test,finance'
+
+        self.assertEqual(
+            [], self.utils.get_new_tags(list_str1, list_str2))
+
+    def test_get_new_tags_one(self):
+        list_str1 = 'finance, production,   test'
+        list_str2 = 'production,test'
+
+        self.assertEqual(
+            ['finance'], self.utils.get_new_tags(list_str1, list_str2))
+
+    def test_get_new_tags_two(self):
+        list_str1 = 'finance, production,   test, test2'
+        list_str2 = 'production,test'
+
+        self.assertEqual(
+            ['finance', 'test2'], self.utils.get_new_tags(
+                list_str1, list_str2))
+
+    def test_get_new_tags_case(self):
+        list_str1 = 'Finance, Production,   test, tEst2'
+        list_str2 = 'production,test'
+
+        self.assertEqual(
+            ['Finance', 'tEst2'], self.utils.get_new_tags(
+                list_str1, list_str2))
+
+    def test_get_new_tags_empty_string_first(self):
+        list_str1 = ''
+        list_str2 = 'production,test'
+
+        self.assertEqual(
+            [], self.utils.get_new_tags(
+                list_str1, list_str2))
+
+    def test_get_new_tags_empty_string_second(self):
+        list_str1 = 'production,test'
+        list_str2 = '  '
+
+        self.assertEqual(
+            ['production', 'test'], self.utils.get_new_tags(
+                list_str1, list_str2))
+
+    def test_get_intersection(self):
+        list_str1 = 'finance,production'
+        list_str2 = 'production'
+
+        common_list = self.utils._get_intersection(
+            list_str1, list_str2)
+
+        self.assertEqual(['production'], common_list)
+
+    def test_get_intersection_unordered_list(self):
+        list_str1 = 'finance,production'
+        list_str2 = 'production, finance'
+
+        common_list = (
+            self.utils._get_intersection(list_str1, list_str2))
+
+        self.assertEqual(['finance', 'production'], common_list)
+
+    def test_verify_tag_list_good(self):
+        tag_list = ['no', 'InValid', 'characters', 'dash-allowed',
+                    '123', 'underscore_allowed',
+                    ' leading_space', 'trailing-space ']
+        self.assertTrue(self.utils.verify_tag_list(tag_list))
+
+    def test_verify_tag_list_space(self):
+        tag_list = ['bad space']
+        self.assertFalse(self.utils.verify_tag_list(tag_list))
+
+    def test_verify_tag_list_forward_slash(self):
+        tag_list = ['\\forward\\slash']
+        self.assertFalse(self.utils.verify_tag_list(tag_list))
+
+    def test_verify_tag_list_square_bracket(self):
+        tag_list = ['[squareBrackets]']
+        self.assertFalse(self.utils.verify_tag_list(tag_list))
+
+    def test_verify_tag_list_backward_slash(self):
+        tag_list = ['/backward/slash']
+        self.assertFalse(self.utils.verify_tag_list(tag_list))
+
+    def test_verify_tag_list_curly_bracket(self):
+        tag_list = ['{curlyBrackets}']
+        self.assertFalse(self.utils.verify_tag_list(tag_list))
+
+    def test_verify_tag_list_empty_list(self):
+        tag_list = []
+        self.assertFalse(self.utils.verify_tag_list(tag_list))
+
+    def test_verify_tag_list_not_a_list(self):
+        tag_list = '1,2,3,4'
+        self.assertFalse(self.utils.verify_tag_list(tag_list))
+
+    def test_verify_tag_list_exceeds_8(self):
+        tag_list = ['1', '2', '3', '4', '5', '6', '7', '8', '9']
+        self.assertFalse(self.utils.verify_tag_list(tag_list))
+
+    def test_convert_list_to_string(self):
+        input_list = ['one', 'two', 'three']
+        output_string = self.utils.convert_list_to_string(input_list)
+        self.assertEqual('one,two,three', output_string)
+
+    def test_convert_list_to_string_input_string(self):
+        input_list = 'one,two,three'
+        output_string = self.utils.convert_list_to_string(input_list)
+        self.assertEqual('one,two,three', output_string)
+
+    def test_regex_check_case_2(self):
+        test_template = 'shortHostName[:10]uuid[:5]'
+        is_ok, case = self.utils.regex_check(test_template, True)
+        self.assertTrue(is_ok)
+        self.assertEqual('2', case)
+
+    def test_regex_check_case_3(self):
+        test_template = 'shortHostName[-10:]uuid[:5]'
+        is_ok, case = self.utils.regex_check(test_template, True)
+        self.assertTrue(is_ok)
+        self.assertEqual('3', case)
+
+    def test_regex_check_case_4(self):
+        test_template = 'shortHostName[:7]finance'
+        is_ok, case = self.utils.regex_check(test_template, True)
+        self.assertTrue(is_ok)
+        self.assertEqual('4', case)
+
+    def test_regex_check_case_5(self):
+        test_template = 'shortHostName[-6:]production'
+        is_ok, case = self.utils.regex_check(test_template, True)
+        self.assertTrue(is_ok)
+        self.assertEqual('5', case)
+
+    def test_regex_check_case_2_misspelt(self):
+        test_template = 'shortHstName[:10]uuid[:5]'
+        is_ok, case = self.utils.regex_check(test_template, True)
+        self.assertFalse(is_ok)
+        self.assertEqual('0', case)
+
+    def test_regex_check_case_3_misspelt(self):
+        test_template = 'shortHostName[-10:]uud[:5]'
+        is_ok, case = self.utils.regex_check(test_template, True)
+        self.assertFalse(is_ok)
+        self.assertEqual('0', case)
+
+    def test_regex_check_case_4_misspelt(self):
+        test_template = 'shortHotName[:7]finance'
+        is_ok, case = self.utils.regex_check(test_template, True)
+        self.assertFalse(is_ok)
+        self.assertEqual('0', case)
+
+    def test_regex_check_case_5_misspelt(self):
+        test_template = 'shortHstName[-6:]production'
+        is_ok, case = self.utils.regex_check(test_template, True)
+        self.assertFalse(is_ok)
+        self.assertEqual('0', case)
+
+    def test_regex_check_case_4_invalid_chars(self):
+        test_template = 'shortHostName[:7]f*n&nce'
+        is_ok, case = self.utils.regex_check(test_template, True)
+        self.assertFalse(is_ok)
+        self.assertEqual('0', case)
+
+    def test_regex_check_case_5_invalid_chars(self):
+        test_template = 'shortHostName[-6:]pr*ducti*n'
+        is_ok, case = self.utils.regex_check(test_template, True)
+        self.assertFalse(is_ok)
+        self.assertEqual('0', case)
+
+    def test_regex_check_case_2_missing_square_bracket(self):
+        test_template = 'shortHostName[:10uuid[:5]'
+        is_ok, case = self.utils.regex_check(test_template, True)
+        self.assertFalse(is_ok)
+        self.assertEqual('0', case)
+
+    def test_regex_check_case_4_missing_square_bracket(self):
+        test_template = 'shortHostName[:10finance'
+        is_ok, case = self.utils.regex_check(test_template, True)
+        self.assertFalse(is_ok)
+        self.assertEqual('0', case)
+
+    def test_prepare_string_entity_case_2(self):
+        test_template = 'shortHostName[:10]uuid[:5]'
+        altered_string = self.utils.prepare_string_entity(
+            test_template, 'my_short_host_name', True)
+        self.assertEqual(
+            'my_short_host_name[:10]uuid[:5]',
+            altered_string)
+
+    def test_prepare_string_entity_case_3(self):
+        test_template = 'shortHostName[-10:]uuid[:5]'
+        altered_string = self.utils.prepare_string_entity(
+            test_template, 'my_short_host_name', True)
+        self.assertEqual(
+            'my_short_host_name[-10:]uuid[:5]',
+            altered_string)
+
+    def test_prepare_string_entity_case_4(self):
+        test_template = 'shortHostName[:7]finance'
+        altered_string = self.utils.prepare_string_entity(
+            test_template, 'my_short_host_name', True)
+        self.assertEqual(
+            'my_short_host_name[:7]finance',
+            altered_string)
+
+    def test_prepare_string_entity_case_5(self):
+        test_template = 'shortHostName[-6:]production'
+        altered_string = self.utils.prepare_string_entity(
+            test_template, 'my_short_host_name', True)
+        self.assertEqual(
+            'my_short_host_name[-6:]production',
+            altered_string)
+
+    def test_prepare_string_with_uuid_case_2(self):
+        test_template = 'shortHostName[:10]uuid[:5]'
+        pass_two, uuid = self.utils.prepare_string_with_uuid(
+            test_template, 'my_short_host_name', True)
+        self.assertEqual(
+            'my_short_host_name[:10]944854dce45898b544a1cb9071d3cc35[:5]',
+            pass_two)
+        self.assertEqual('944854dce45898b544a1cb9071d3cc35', uuid)
+
+    def test_prepare_string_with_uuid_case_3(self):
+        test_template = 'shortHostName[-10:]uuid[:5]'
+        pass_two, uuid = self.utils.prepare_string_with_uuid(
+            test_template, 'my_short_host_name', True)
+        self.assertEqual(
+            'my_short_host_name[-10:]944854dce45898b544a1cb9071d3cc35[:5]',
+            pass_two)
+        self.assertEqual('944854dce45898b544a1cb9071d3cc35', uuid)
+
+    def test_check_upper_limit_short_host(self):
+        self.assertRaises(exception.VolumeBackendAPIException,
+                          self.utils.check_upper_limit,
+                          12, 12, True)
+
+    def test_check_upper_limit_short_host_case_4(self):
+        user_define_name = 'Little_too_long'
+        self.assertRaises(exception.VolumeBackendAPIException,
+                          self.utils.check_upper_limit,
+                          12, len(user_define_name), True)
+
+    def test_validate_short_host_name_from_template_case_1(self):
+        test_template = 'shortHostName'
+        short_host_name = 'my_short_host'
+        result_string = self.utils.validate_short_host_name_from_template(
+            test_template, short_host_name)
+        self.assertEqual('my_short_host', result_string)
+
+    def test_validate_short_host_name_from_template_case_1_exceeds_16char(
+            self):
+        test_template = 'shortHostName'
+        short_host_name = 'my_short_host_greater_than_16chars'
+        result_string = self.utils.validate_short_host_name_from_template(
+            test_template, short_host_name)
+        self.assertEqual('6chars0bc43f914e', result_string)
+
+    def test_validate_short_host_name_from_template_case_1_template_misspelt(
+            self):
+        test_template = 'shortHstName'
+        short_host_name = 'my_short_host'
+        self.assertRaises(exception.VolumeBackendAPIException,
+                          self.utils.validate_short_host_name_from_template,
+                          test_template, short_host_name)
+
+    def test_validate_short_host_name_from_template_case_2(self):
+        test_template = 'shortHostName[:10]uuid[:5]'
+        short_host_name = 'my_short_host_name'
+        result_string = self.utils.validate_short_host_name_from_template(
+            test_template, short_host_name)
+        self.assertEqual('my_short_h94485', result_string)
+
+    def test_validate_short_host_name_from_template_case_2_shorter_than(self):
+        test_template = 'shortHostName[:10]uuid[:5]'
+        short_host_name = 'HostX'
+        result_string = self.utils.validate_short_host_name_from_template(
+            test_template, short_host_name)
+        self.assertEqual('HostX699ea', result_string)
+
+    def test_validate_short_host_name_from_template_case_3(self):
+        test_template = 'shortHostName[-10:]uuid[:5]'
+        short_host_name = 'my_short_host_name'
+        result_string = self.utils.validate_short_host_name_from_template(
+            test_template, short_host_name)
+        self.assertEqual('_host_name94485', result_string)
+
+    def test_validate_short_host_name_from_template_case_3_shorter_than(self):
+        test_template = 'shortHostName[-10:]uuid[:5]'
+        short_host_name = 'HostX'
+        result_string = self.utils.validate_short_host_name_from_template(
+            test_template, short_host_name)
+        self.assertEqual('HostX699ea', result_string)
+
+    def test_validate_short_host_name_from_template_case_4(self):
+        test_template = 'shortHostName[:7]finance'
+        short_host_name = 'my_short_host_name'
+        result_string = self.utils.validate_short_host_name_from_template(
+            test_template, short_host_name)
+        self.assertEqual('my_shorfinance', result_string)
+
+    def test_validate_short_host_name_from_template_case_5(self):
+        test_template = 'shortHostName[-6:]production'
+        short_host_name = 'my_short_host_name'
+        result_string = self.utils.validate_short_host_name_from_template(
+            test_template, short_host_name)
+        self.assertEqual('t_nameproduction', result_string)
+
+    def test_validate_short_host_name_exception_missing_minus(self):
+        test_template = 'shortHostName[6:]production'
+        short_host_name = 'my_short_host_name'
+        self.assertRaises(exception.VolumeBackendAPIException,
+                          self.utils.validate_short_host_name_from_template,
+                          test_template, short_host_name)
+
+    def test_validate_port_group_from_template_case_1(self):
+        test_template = 'portGroupName'
+        port_group_name = 'my_pg'
+        result_string = self.utils.validate_port_group_name_from_template(
+            test_template, port_group_name)
+        self.assertEqual('my_pg', result_string)
+
+    def test_validate_port_group_from_template_case_1_long(self):
+        test_template = 'portGroupName'
+        port_group_name = 'my_port_group_name'
+        result_string = self.utils.validate_port_group_name_from_template(
+            test_template, port_group_name)
+        self.assertEqual('p_name5ba163', result_string)
+
+    def test_validate_port_group_from_template_case_1_misspelt(self):
+        test_template = 'portGr*upName'
+        port_group_name = 'my_port_group_name'
+        self.assertRaises(exception.VolumeBackendAPIException,
+                          self.utils.validate_port_group_name_from_template,
+                          test_template, port_group_name)
+
+    def test_validate_port_group_from_template_case_2(self):
+        test_template = 'portGroupName[:6]uuid[:5]'
+        port_group_name = 'my_port_group_name'
+        result_string = self.utils.validate_port_group_name_from_template(
+            test_template, port_group_name)
+        self.assertEqual('my_por3b02c', result_string)
+
+    def test_validate_port_group_from_template_case_3(self):
+        test_template = 'portGroupName[-6:]uuid[:5]'
+        port_group_name = 'my_port_group_name'
+        result_string = self.utils.validate_port_group_name_from_template(
+            test_template, port_group_name)
+        self.assertEqual('p_name3b02c', result_string)
+
+    def test_validate_port_group_from_template_case_4(self):
+        test_template = 'portGroupName[:6]test'
+        port_group_name = 'my_port_group_name'
+        result_string = self.utils.validate_port_group_name_from_template(
+            test_template, port_group_name)
+        self.assertEqual('my_portest', result_string)
+
+    def test_validate_port_group_from_template_case_5(self):
+        test_template = 'portGroupName[-7:]test'
+        port_group_name = 'my_port_group_name'
+        result_string = self.utils.validate_port_group_name_from_template(
+            test_template, port_group_name)
+        self.assertEqual('up_nametest', result_string)
+
+    def test_validate_port_group_name_exception_missing_minus(self):
+        test_template = 'portGroupName[6:]test'
+        port_group_name = 'my_port_group_name'
+        self.assertRaises(exception.VolumeBackendAPIException,
+                          self.utils.validate_port_group_name_from_template,
+                          test_template, port_group_name)
+
+    def test_validate_port_group_name_exception_chars_exceeded(self):
+        test_template = 'portGroupName[:10]test'
+        port_group_name = 'my_port_group_name'
+        self.assertRaises(exception.VolumeBackendAPIException,
+                          self.utils.validate_port_group_name_from_template,
+                          test_template, port_group_name)
+
+    def test_get_port_name_label_default(self):
+        port_name_in = 'my_port_group_name'
+        port_group_template = 'portGroupName'
+        port_name_out = self.utils.get_port_name_label(
+            port_name_in, port_group_template)
+        self.assertEqual('p_name5ba163', port_name_out)
+
+    def test_get_port_name_label_template(self):
+        port_name_in = 'my_port_group_name'
+        port_group_template = 'portGroupName[-6:]uuid[:5]'
+        port_name_out = self.utils.get_port_name_label(
+            port_name_in, port_group_template)
+        self.assertEqual('p_name3b02c', port_name_out)
+
+    def test_get_rdf_managed_storage_group(self):
+        rdf_component_dict = ('OS-23_24_007-Asynchronous-rdf-sg',
+                              {'prefix': 'OS',
+                               'rdf_label': '23_24_007',
+                               'sync_mode': 'Asynchronous',
+                               'after_mode': 'rdf-sg'})
+
+        async_rdf_details = (
+            self.utils.get_rdf_managed_storage_group(
+                self.data.volume_details_attached_async))
+        self.assertEqual(rdf_component_dict, async_rdf_details)
+
+    def test_get_storage_group_component_dict_no_slo(self):
+        """Test for get_storage_group_component_dict.
+
+        REST and no SLO.
+        """
+        sg_no_slo = 'OS-myhost-No_SLO-os-iscsi-pg'
+        component_dict = self.utils.get_storage_group_component_dict(
+            sg_no_slo)
+        self.assertEqual('myhost', component_dict['host'])
+        self.assertEqual('OS', component_dict['prefix'])
+        self.assertEqual('No_SLO', component_dict['no_slo'])
+        self.assertEqual('os-iscsi-pg', component_dict['portgroup'])
+        self.assertIsNone(component_dict['sloworkload'])
+        self.assertIsNone(component_dict['srp'])
+
+    def test_get_storage_group_component_dict_slo_workload_2(self):
+        """Test for get_storage_group_component_dict.
+
+        SLO, workload and test 2.
+        """
+        sg_slo_workload = 'OS-myhost-SRP_1-DiamodOLTP-os-iscsi-pg-RE'
+        component_dict = self.utils.get_storage_group_component_dict(
+            sg_slo_workload)
+        self.assertEqual('OS', component_dict['prefix'])
+        self.assertEqual('myhost', component_dict['host'])
+        self.assertEqual('SRP_1', component_dict['srp'])
+        self.assertEqual('os-iscsi-pg', component_dict['portgroup'])
+        self.assertEqual('DiamodOLTP', component_dict['sloworkload'])
+        self.assertIsNone(component_dict['no_slo'])
+
+    def test_get_storage_group_component_dict_compression_disabled(self):
+        """Test for get_storage_group_component_dict.
+
+        Compression disabled.
+        """
+        sg_compression_disabled = 'OS-myhost-SRP_1-DiamodNONE-os-iscsi-pg-CD'
+        component_dict = self.utils.get_storage_group_component_dict(
+            sg_compression_disabled)
+        self.assertEqual('OS', component_dict['prefix'])
+        self.assertEqual('myhost', component_dict['host'])
+        self.assertEqual('SRP_1', component_dict['srp'])
+        self.assertEqual('os-iscsi-pg', component_dict['portgroup'])
+        self.assertEqual('DiamodNONE', component_dict['sloworkload'])
+        self.assertEqual('-CD', component_dict['after_pg'])
+        self.assertIsNone(component_dict['no_slo'])
+
+    def test_get_storage_group_component_dict_replication_enabled(self):
+        """Test for get_storage_group_component_dict.
+
+        Replication enabled.
+        """
+        sg_slo_workload_rep = 'OS-myhost-SRP_1-DiamodOLTP-os-iscsi-pg-RE'
+        component_dict = self.utils.get_storage_group_component_dict(
+            sg_slo_workload_rep)
+        self.assertEqual('OS', component_dict['prefix'])
+        self.assertEqual('myhost', component_dict['host'])
+        self.assertEqual('SRP_1', component_dict['srp'])
+        self.assertEqual('os-iscsi-pg', component_dict['portgroup'])
+        self.assertEqual('DiamodOLTP', component_dict['sloworkload'])
+        self.assertEqual('-RE', component_dict['after_pg'])
+        self.assertIsNone(component_dict['no_slo'])
+
+    def test_get_storage_group_component_dict_slo_no_workload(self):
+        """Test for get_storage_group_component_dict.
+
+        SLO and no workload.
+        """
+        sg_slo_no_workload = 'OS-myhost-SRP_1-DiamodNONE-os-iscsi-pg'
+        component_dict = self.utils.get_storage_group_component_dict(
+            sg_slo_no_workload)
+        self.assertEqual('OS', component_dict['prefix'])
+        self.assertEqual('myhost', component_dict['host'])
+        self.assertEqual('SRP_1', component_dict['srp'])
+        self.assertEqual('os-iscsi-pg', component_dict['portgroup'])
+        self.assertEqual('DiamodNONE', component_dict['sloworkload'])
+        self.assertIsNone(component_dict['no_slo'])
+
+    def test_get_storage_group_component_dict_dashes(self):
+        """Test for get_storage_group_component_dict, dashes."""
+        sg_host_with_dashes = (
+            'OS-host-with-dashes-SRP_1-DiamodOLTP-myportgroup-RE')
+        component_dict = self.utils.get_storage_group_component_dict(
+            sg_host_with_dashes)
+        self.assertEqual('host-with-dashes', component_dict['host'])
+        self.assertEqual('OS', component_dict['prefix'])
+        self.assertEqual('SRP_1', component_dict['srp'])
+        self.assertEqual('DiamodOLTP', component_dict['sloworkload'])
+        self.assertEqual('myportgroup', component_dict['portgroup'])
+        self.assertEqual('-RE', component_dict['after_pg'])
+
+    def test_delete_values_from_dict(self):
+        """Test delete_values_from_dict"""
+        delete_list = ['rdf_group_no', 'rep_mode', 'target_array_model',
+                       'service_level', 'remote_array', 'target_device_id',
+                       'replication_status', 'rdf_group_label']
+        data_dict = self.utils.delete_values_from_dict(
+            self.data.retype_metadata_dict, delete_list)
+        self.assertEqual({'device_id': self.data.device_id}, data_dict)
+
+    def test_update_values_in_dict(self):
+        """Test delete_values_from_dict"""
+        update_list = [('default_sg_name', 'source_sg_name'),
+                       ('service_level', 'source_service_level')]
+
+        update_dict = {'default_sg_name': 'default-sg',
+                       'service_level': 'Diamond'}
+        ret_dict = {'source_sg_name': 'default-sg',
+                    'source_service_level': 'Diamond'}
+        data_dict = self.utils.update_values_in_dict(
+            update_dict, update_list)
+        self.assertEqual(ret_dict, data_dict)
+
+    def test_get_unique_device_ids_from_lists(self):
+        list_a = ['00001', '00002', '00003']
+        list_b = ['00002', '00003', '00004']
+        unique_ids = self.utils.get_unique_device_ids_from_lists(list_a,
+                                                                 list_b)
+        self.assertEqual(['00004'], unique_ids)
+
+    def test_update_payload_for_rdf_vol_create(self):
+        payload = {
+            'array': self.data.array,
+            'editStorageGroupActionParam': {
+                'expandStorageGroupParam': {
+                    'addVolumeParam': {}}}}
+
+        updated_payload = self.utils.update_payload_for_rdf_vol_create(
+            payload, self.data.remote_array, self.data.storagegroup_name_f)
+        expected_payload = {
+            'array': self.data.array,
+            'editStorageGroupActionParam': {
+                'expandStorageGroupParam': {
+                    'addVolumeParam': {
+                        'remoteSymmSGInfoParam': {
+                            'force': 'true',
+                            'remote_symmetrix_1_id': self.data.remote_array,
+                            'remote_symmetrix_1_sgs': [
+                                self.data.storagegroup_name_f]}}}}}
+        self.assertEqual(expected_payload, updated_payload)
+
+    def test_is_retype_supported(self):
+        # Volume source type not replicated, target type Metro replicated,
+        # volume is detached, host-assisted retype supported
+        volume = self.data.test_volume
+        volume.attach_status = 'detached'
+
+        src_extra_specs = deepcopy(self.data.extra_specs)
+        src_extra_specs['rep_mode'] = None
+
+        tgt_extra_specs = deepcopy(self.data.rep_extra_specs)
+        tgt_extra_specs['rep_mode'] = utils.REP_METRO
+
+        self.assertTrue(self.utils.is_retype_supported(volume, src_extra_specs,
+                                                       tgt_extra_specs))
+
+        # Volume source type not replicated, target type Metro replicated,
+        # volume is attached, host-assisted retype not supported
+        volume.attach_status = 'attached'
+        self.assertFalse(self.utils.is_retype_supported(
+            volume, src_extra_specs, tgt_extra_specs))
+
+        # Volume source type Async replicated, target type Metro replicated,
+        # volume is attached, host-assisted retype not supported
+        src_extra_specs['rep_mode'] = utils.REP_ASYNC
+        self.assertFalse(self.utils.is_retype_supported(
+            volume, src_extra_specs, tgt_extra_specs))
+
+        # Volume source type Metro replicated, target type Metro replicated,
+        # volume is attached, host-assisted retype supported
+        src_extra_specs['rep_mode'] = utils.REP_METRO
+        self.assertTrue(self.utils.is_retype_supported(
+            volume, src_extra_specs, tgt_extra_specs))
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/sc/test_fc.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/sc/test_fc.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/sc/test_fc.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/sc/test_fc.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 from cinder import context
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/sc/test_scapi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/sc/test_scapi.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/sc/test_scapi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/sc/test_scapi.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,13 +12,14 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+import json
+from unittest import mock
+import uuid
+
 import ddt
 import eventlet
-import json
-import mock
 import requests
 from requests import models
-import uuid
 
 from cinder import context
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/sc/test_sc.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/sc/test_sc.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/sc/test_sc.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/sc/test_sc.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,10 +12,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import eventlet
-import mock
+from unittest import mock
 import uuid
 
+import eventlet
+
 from cinder import context
 from cinder import exception
 from cinder.objects import fields
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/test_ps.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/test_ps.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/test_ps.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/test_ps.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,606 +0,0 @@
-#    Copyright (c) 2013-2017 Dell Inc, or its subsidiaries.
-#    Copyright 2013 OpenStack Foundation
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-
-import time
-import unittest
-
-from eventlet import greenthread
-import mock
-from oslo_concurrency import processutils
-import paramiko
-import six
-
-from cinder import context
-from cinder import exception
-from cinder import ssh_utils
-from cinder import test
-from cinder import utils
-from cinder.volume import configuration as conf
-from cinder.volume.drivers.dell_emc import ps
-
-
-class PSSeriesISCSIDriverTestCase(test.TestCase):
-
-    def setUp(self):
-        super(PSSeriesISCSIDriverTestCase, self).setUp()
-        self.configuration = mock.Mock(conf.Configuration)
-        self.configuration.san_is_local = False
-        self.configuration.san_ip = "10.0.0.1"
-        self.configuration.san_login = "foo"
-        self.configuration.san_password = "bar"
-        self.configuration.san_ssh_port = 16022
-        self.configuration.san_thin_provision = True
-        self.configuration.san_private_key = 'foo'
-        self.configuration.ssh_min_pool_conn = 1
-        self.configuration.ssh_max_pool_conn = 5
-        self.configuration.ssh_conn_timeout = 30
-        self.configuration.eqlx_pool = 'non-default'
-        self.configuration.eqlx_group_name = 'group-0'
-        self.configuration.eqlx_cli_max_retries = 5
-
-        self.configuration.use_chap_auth = True
-        self.configuration.chap_username = 'admin'
-        self.configuration.chap_password = 'password'
-
-        self.configuration.max_over_subscription_ratio = 1.0
-
-        self.driver_stats_output = ['TotalCapacity: 111GB',
-                                    'FreeSpace: 11GB',
-                                    'VolumeReportedSpace: 80GB',
-                                    'TotalVolumes: 100']
-        self.cmd = 'this is dummy command'
-        self._context = context.get_admin_context()
-        self.driver = ps.PSSeriesISCSIDriver(
-            configuration=self.configuration)
-        self.volume_name = "fakevolume"
-        self.volid = "fakeid"
-        self.volume = {'name': self.volume_name,
-                       'display_name': 'fake_display_name'}
-        self.connector = {
-            'ip': '10.0.0.2',
-            'initiator': 'iqn.1993-08.org.debian:01:2227dab76162',
-            'host': 'fakehost'}
-        self.access_record_output = [
-            "ID  Initiator       Ipaddress     AuthMethod UserName   Apply-To",
-            "--- --------------- ------------- ---------- ---------- --------",
-            "1   iqn.1993-08.org.debian:01:222 *.*.*.*       none        both",
-            "       7dab76162"]
-        self.fake_access_id = '1'
-        self.fake_iqn = 'iqn.2003-10.com.equallogic:group01:25366:fakev'
-        self.fake_iqn_return = ['iSCSI target name is %s.' % self.fake_iqn]
-        self.fake_volume_output = ["Size: 5GB",
-                                   "iSCSI Name: %s" % self.fake_iqn,
-                                   "Description: "]
-        self.fake_volume_info = {'size': 5.0,
-                                 'iSCSI_Name': self.fake_iqn}
-        self.driver._group_ip = '10.0.1.6'
-        self.properties = {
-            'target_discovered': True,
-            'target_portal': '%s:3260' % self.driver._group_ip,
-            'target_iqn': self.fake_iqn,
-            'volume_id': 1,
-            'discard': True}
-        self._model_update = {
-            'provider_location': "%s:3260,1 %s 0" % (self.driver._group_ip,
-                                                     self.fake_iqn),
-            'provider_auth': 'CHAP %s %s' % (
-                self.configuration.chap_username,
-                self.configuration.chap_password)
-        }
-
-    def _fake_get_iscsi_properties(self, volume):
-        return self.properties
-
-    def test_create_volume(self):
-        volume = {'name': self.volume_name, 'size': 1}
-        mock_attrs = {'args': ['volume', 'create', volume['name'],
-                               "%sG" % (volume['size']), 'pool',
-                               self.configuration.eqlx_pool,
-                               'thin-provision']}
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.configure_mock(**mock_attrs)
-            mock_eql_execute.return_value = self.fake_iqn_return
-            model_update = self.driver.create_volume(volume)
-            self.assertEqual(self._model_update, model_update)
-
-    def test_delete_volume(self):
-        volume = {'name': self.volume_name, 'size': 1}
-        show_attrs = {'args': ['volume', 'select', volume['name'], 'show']}
-        off_attrs = {'args': ['volume', 'select', volume['name'], 'offline']}
-        delete_attrs = {'args': ['volume', 'delete', volume['name']]}
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.configure_mock(**show_attrs)
-            mock_eql_execute.configure_mock(**off_attrs)
-            mock_eql_execute.configure_mock(**delete_attrs)
-            self.driver.delete_volume(volume)
-
-    def test_delete_absent_volume(self):
-        volume = {'name': self.volume_name, 'size': 1, 'id': self.volid}
-        mock_attrs = {'args': ['volume', 'select', volume['name'], 'show']}
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.configure_mock(**mock_attrs)
-            mock_eql_execute.side_effect = processutils.ProcessExecutionError(
-                stdout='% Error ..... does not exist.\n')
-            self.driver.delete_volume(volume)
-
-    def test_ensure_export(self):
-        volume = {'name': self.volume_name, 'size': 1}
-        mock_attrs = {'args': ['volume', 'select', volume['name'], 'show']}
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.configure_mock(**mock_attrs)
-            self.driver.ensure_export({}, volume)
-
-    def test_create_snapshot(self):
-        snapshot = {'name': 'fakesnap', 'volume_name': 'fakevolume_name'}
-        snap_name = 'fake_snap_name'
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.return_value = ['Snapshot name is %s' % snap_name]
-            self.driver.create_snapshot(snapshot)
-
-    def test_create_volume_from_snapshot(self):
-        snapshot = {'name': 'fakesnap', 'volume_name': 'fakevolume_name',
-                    'volume_size': '1'}
-        volume = {'name': self.volume_name, 'size': '1'}
-        mock_attrs = {'args': ['volume', 'select', snapshot['volume_name'],
-                               'snapshot', 'select', snapshot['name'],
-                               'clone', volume['name']]}
-
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            with mock.patch.object(self.driver,
-                                   'extend_volume') as mock_extend_volume:
-                mock_eql_execute.configure_mock(**mock_attrs)
-                mock_eql_execute.return_value = self.fake_iqn_return
-                mock_extend_volume.return_value = self.fake_iqn_return
-                model_update = self.driver.create_volume_from_snapshot(
-                    volume, snapshot)
-                self.assertEqual(self._model_update, model_update)
-                self.assertFalse(self.driver.extend_volume.called)
-
-    def test_create_volume_from_snapshot_extend(self):
-        snapshot = {'name': 'fakesnap', 'volume_name': 'fakevolume_name',
-                    'volume_size': '100'}
-        volume = {'name': self.volume_name, 'size': '200'}
-        mock_attrs = {'args': ['volume', 'select', snapshot['volume_name'],
-                               'snapshot', 'select', snapshot['name'],
-                               'clone', volume['name']]}
-
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            with mock.patch.object(self.driver,
-                                   'extend_volume') as mock_extend_volume:
-                mock_eql_execute.configure_mock(**mock_attrs)
-                mock_eql_execute.return_value = self.fake_iqn_return
-                mock_extend_volume.return_value = self.fake_iqn_return
-                model_update = self.driver.create_volume_from_snapshot(
-                    volume, snapshot)
-                self.assertEqual(self._model_update, model_update)
-                self.assertTrue(self.driver.extend_volume.called)
-                self.driver.extend_volume.assert_called_once_with(
-                    volume, volume['size'])
-
-    def test_create_cloned_volume(self):
-        src_vref = {'name': 'fake_uuid', 'size': '1'}
-        volume = {'name': self.volume_name, 'size': '1'}
-        mock_attrs = {'args': ['volume', 'select', volume['name'],
-                               'multihost-access', 'enable']}
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            with mock.patch.object(self.driver,
-                                   'extend_volume') as mock_extend_volume:
-                mock_eql_execute.configure_mock(**mock_attrs)
-                mock_eql_execute.return_value = self.fake_iqn_return
-                mock_extend_volume.return_value = self.fake_iqn_return
-                model_update = self.driver.create_cloned_volume(
-                    volume, src_vref)
-                self.assertEqual(self._model_update, model_update)
-                self.assertFalse(self.driver.extend_volume.called)
-
-    def test_create_cloned_volume_extend(self):
-        src_vref = {'name': 'fake_uuid', 'size': '100'}
-        volume = {'name': self.volume_name, 'size': '200'}
-        mock_attrs = {'args': ['volume', 'select', volume['name'],
-                               'multihost-access', 'enable']}
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            with mock.patch.object(self.driver,
-                                   'extend_volume') as mock_extend_volume:
-                mock_eql_execute.configure_mock(**mock_attrs)
-                mock_eql_execute.return_value = self.fake_iqn_return
-                mock_extend_volume.return_value = self.fake_iqn_return
-                cloned_vol = self.driver.create_cloned_volume(volume, src_vref)
-                self.assertEqual(self._model_update, cloned_vol)
-                self.assertTrue(self.driver.extend_volume.called)
-
-    def test_delete_snapshot(self):
-        snapshot = {'name': 'fakesnap', 'volume_name': 'fakevolume_name'}
-        mock_attrs = {'args': ['volume', 'select', snapshot['volume_name'],
-                               'snapshot', 'delete', snapshot['name']]}
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.configure_mock(**mock_attrs)
-            self.driver.delete_snapshot(snapshot)
-
-    def test_delete_absent_snapshot(self):
-        snapshot = {'name': 'fakesnap', 'volume_name': 'fakevolume_name'}
-        mock_attrs = {'args': ['volume', 'select', snapshot['volume_name'],
-                               'snapshot', 'delete', snapshot['name']]}
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.configure_mock(**mock_attrs)
-            mock_eql_execute.side_effect = processutils.ProcessExecutionError(
-                stdout='% Error ..... does not exist.\n')
-            self.driver.delete_snapshot(snapshot)
-
-    def test_extend_volume(self):
-        new_size = '200'
-        volume = {'name': self.volume_name, 'size': 100}
-        mock_attrs = {'args': ['volume', 'select', volume['name'],
-                               'size', "%sG" % new_size]}
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.configure_mock(**mock_attrs)
-            self.driver.extend_volume(volume, new_size)
-
-    def test_get_volume_info(self):
-        attrs = ('volume', 'select', self.volume, 'show')
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.return_value = self.fake_volume_output
-            data = self.driver._get_volume_info(self.volume)
-            mock_eql_execute.assert_called_with(*attrs)
-            self.assertEqual(self.fake_volume_info, data)
-
-    def test_get_volume_info_negative(self):
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.side_effect = processutils.ProcessExecutionError(
-                stdout='% Error ..... does not exist.\n')
-            self.assertRaises(exception.ManageExistingInvalidReference,
-                              self.driver._get_volume_info, self.volume_name)
-
-    def test_manage_existing(self):
-        ref = {'source-name': self.volume_name}
-        attrs = ('volume', 'select', self.volume_name,
-                 'multihost-access', 'enable')
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            with mock.patch.object(self.driver,
-                                   '_get_volume_info') as mock_volume_info:
-                mock_volume_info.return_value = self.fake_volume_info
-                mock_eql_execute.return_value = self.fake_iqn_return
-                model_update = self.driver.manage_existing(self.volume, ref)
-                mock_eql_execute.assert_called_with(*attrs)
-                self.assertEqual(self._model_update, model_update)
-
-    def test_manage_existing_invalid_ref(self):
-        ref = {}
-        self.assertRaises(exception.InvalidInput,
-                          self.driver.manage_existing, self.volume, ref)
-
-    def test_manage_existing_get_size(self):
-        ref = {'source-name': self.volume_name}
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.return_value = self.fake_volume_output
-            size = self.driver.manage_existing_get_size(self.volume, ref)
-            self.assertEqual(float('5.0'), size)
-
-    def test_manage_existing_get_size_invalid_ref(self):
-        """Error on manage with invalid reference."""
-        ref = {}
-        self.assertRaises(exception.InvalidInput,
-                          self.driver.manage_existing_get_size,
-                          self.volume, ref)
-
-    def test_unmanage(self):
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.return_value = None
-            self.driver.unmanage(self.volume)
-
-    def test_initialize_connection(self):
-        volume = {'name': self.volume_name}
-        mock_attrs = {'args': ['volume', 'select', volume['name'], 'access',
-                               'create', 'initiator',
-                               self.connector['initiator'],
-                               'authmethod', 'chap',
-                               'username',
-                               self.configuration.chap_username]}
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            with mock.patch.object(self.driver,
-                                   '_get_iscsi_properties') as mock_iscsi:
-                mock_eql_execute.configure_mock(**mock_attrs)
-                mock_iscsi.return_value = self.properties
-                iscsi_properties = self.driver.initialize_connection(
-                    volume, self.connector)
-                self.assertEqual(self._fake_get_iscsi_properties(volume),
-                                 iscsi_properties['data'])
-                self.assertTrue(iscsi_properties['data']['discard'])
-
-    def test_terminate_connection(self):
-        def my_side_effect(*args, **kwargs):
-            if args[4] == 'show':
-                return self.access_record_output
-            else:
-                return ''
-        volume = {'name': self.volume_name}
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.side_effect = my_side_effect
-            self.driver.terminate_connection(volume, self.connector)
-
-    def test_get_access_record(self):
-        attrs = ('volume', 'select', self.volume['name'], 'access', 'show')
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.return_value = self.access_record_output
-            data = self.driver._get_access_record(self.volume, self.connector)
-            mock_eql_execute.assert_called_with(*attrs)
-            self.assertEqual(self.fake_access_id, data)
-
-    def test_get_access_record_negative(self):
-        attrs = ('volume', 'select', self.volume['name'], 'access', 'show')
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.return_value = []
-            data = self.driver._get_access_record(self.volume, self.connector)
-            mock_eql_execute.assert_called_with(*attrs)
-            self.assertIsNone(data)
-
-    def test_do_setup(self):
-        fake_group_ip = '10.1.2.3'
-
-        def my_side_effect(*args, **kwargs):
-            if args[0] == 'grpparams':
-                return ['Group-Ipaddress: %s' % fake_group_ip]
-            else:
-                return ''
-
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.side_effect = my_side_effect
-            self.driver.do_setup(self._context)
-            self.assertEqual(fake_group_ip, self.driver._group_ip)
-
-    def test_update_volume_stats_thin(self):
-        mock_attrs = {'args': ['pool', 'select',
-                               self.configuration.eqlx_pool, 'show']}
-        self.configuration.san_thin_provision = True
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.configure_mock(**mock_attrs)
-            mock_eql_execute.return_value = self.driver_stats_output
-            self.driver._update_volume_stats()
-            self.assert_volume_stats(self.driver._stats)
-
-    def test_update_volume_stats_thick(self):
-        mock_attrs = {'args': ['pool', 'select',
-                               self.configuration.eqlx_pool, 'show']}
-        self.configuration.san_thin_provision = False
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.configure_mock(**mock_attrs)
-            mock_eql_execute.return_value = self.driver_stats_output
-            self.driver._update_volume_stats()
-            self.assert_volume_stats(self.driver._stats)
-
-    def test_get_volume_stats_thin(self):
-        mock_attrs = {'args': ['pool', 'select',
-                               self.configuration.eqlx_pool, 'show']}
-        self.configuration.san_thin_provision = True
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.configure_mock(**mock_attrs)
-            mock_eql_execute.return_value = self.driver_stats_output
-            stats = self.driver.get_volume_stats(refresh=True)
-            self.assert_volume_stats(stats)
-
-    def test_get_volume_stats_thick(self):
-        mock_attrs = {'args': ['pool', 'select',
-                               self.configuration.eqlx_pool, 'show']}
-        self.configuration.san_thin_provision = False
-        with mock.patch.object(self.driver,
-                               '_eql_execute') as mock_eql_execute:
-            mock_eql_execute.configure_mock(**mock_attrs)
-            mock_eql_execute.return_value = self.driver_stats_output
-            stats = self.driver.get_volume_stats(refresh=True)
-            self.assert_volume_stats(stats)
-
-    def assert_volume_stats(self, stats):
-        thin_enabled = self.configuration.san_thin_provision
-        self.assertEqual(float('111.0'), stats['total_capacity_gb'])
-        self.assertEqual(float('11.0'), stats['free_capacity_gb'])
-        self.assertEqual(100, stats['total_volumes'])
-
-        if thin_enabled:
-            self.assertEqual(80.0, stats['provisioned_capacity_gb'])
-        else:
-            space = stats['total_capacity_gb'] - stats['free_capacity_gb']
-            self.assertEqual(space, stats['provisioned_capacity_gb'])
-
-        self.assertEqual(thin_enabled, stats['thin_provisioning_support'])
-        self.assertEqual(not thin_enabled,
-                         stats['thick_provisioning_support'])
-        self.assertEqual('Dell EMC', stats['vendor_name'])
-        self.assertFalse(stats['multiattach'])
-
-    def test_get_space_in_gb(self):
-        self.assertEqual(123.0, self.driver._get_space_in_gb('123.0GB'))
-        self.assertEqual(124.0, self.driver._get_space_in_gb('123.5GB'))
-        self.assertEqual(123.0 * 1024, self.driver._get_space_in_gb('123.0TB'))
-        self.assertEqual(1.0, self.driver._get_space_in_gb('1024.0MB'))
-        self.assertEqual(2.0, self.driver._get_space_in_gb('1536.0MB'))
-
-    def test_get_output(self):
-
-        def _fake_recv(ignore_arg):
-            return '%s> ' % self.configuration.eqlx_group_name
-
-        chan = mock.Mock(paramiko.Channel)
-        mock_recv = self.mock_object(chan, 'recv')
-        mock_recv.return_value = '%s> ' % self.configuration.eqlx_group_name
-        self.assertEqual([_fake_recv(None)], self.driver._get_output(chan))
-
-    def test_get_prefixed_value(self):
-        lines = ['Line1 passed', 'Line1 failed']
-        prefix = ['Line1', 'Line2']
-        expected_output = [' passed', None]
-        self.assertEqual(expected_output[0],
-                         self.driver._get_prefixed_value(lines, prefix[0]))
-        self.assertEqual(expected_output[1],
-                         self.driver._get_prefixed_value(lines, prefix[1]))
-
-    def test_ssh_execute(self):
-        ssh = mock.Mock(paramiko.SSHClient)
-        chan = mock.Mock(paramiko.Channel)
-        transport = mock.Mock(paramiko.Transport)
-        mock_get_output = self.mock_object(self.driver, '_get_output')
-        self.mock_object(chan, 'invoke_shell')
-        expected_output = ['NoError: test run']
-        mock_get_output.return_value = expected_output
-        ssh.get_transport.return_value = transport
-        transport.open_session.return_value = chan
-        chan.invoke_shell()
-        chan.send('stty columns 255' + '\r')
-        chan.send(self.cmd + '\r')
-        chan.close()
-        self.assertEqual(expected_output,
-                         self.driver._ssh_execute(ssh, self.cmd))
-
-    def test_ssh_execute_error(self):
-        self.mock_object(self.driver, '_ssh_execute',
-                         side_effect=processutils.ProcessExecutionError)
-        ssh = mock.Mock(paramiko.SSHClient)
-        chan = mock.Mock(paramiko.Channel)
-        transport = mock.Mock(paramiko.Transport)
-        mock_get_output = self.mock_object(self.driver, '_get_output')
-        self.mock_object(ssh, 'get_transport')
-        self.mock_object(chan, 'invoke_shell')
-        expected_output = ['Error: test run', '% Error']
-        mock_get_output.return_value = expected_output
-        ssh.get_transport().return_value = transport
-        transport.open_session.return_value = chan
-        chan.invoke_shell()
-        chan.send('stty columns 255' + '\r')
-        chan.send(self.cmd + '\r')
-        chan.close()
-        self.assertRaises(processutils.ProcessExecutionError,
-                          self.driver._ssh_execute, ssh, self.cmd)
-
-    @mock.patch.object(greenthread, 'sleep')
-    def test_ensure_retries(self, _gt_sleep):
-        num_attempts = 3
-        self.driver.configuration.eqlx_cli_max_retries = num_attempts
-        self.mock_object(self.driver, '_ssh_execute',
-                         side_effect=exception.VolumeBackendAPIException(
-                             "some error"))
-        # mocks for calls in _run_ssh
-        self.mock_object(utils, 'check_ssh_injection')
-        self.mock_object(ssh_utils, 'SSHPool')
-
-        sshpool = ssh_utils.SSHPool("127.0.0.1", 22, 10,
-                                    "test",
-                                    password="test",
-                                    min_size=1,
-                                    max_size=1)
-        self.driver.sshpool = mock.Mock(return_value=sshpool)
-        ssh = mock.Mock(paramiko.SSHClient)
-        self.driver.sshpool.item().__enter__ = mock.Mock(return_value=ssh)
-        self.driver.sshpool.item().__exit__ = mock.Mock(return_value=False)
-        # now call the execute
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.driver._eql_execute, "fake command")
-        self.assertEqual(num_attempts + 1,
-                         self.driver._ssh_execute.call_count)
-
-    @mock.patch.object(greenthread, 'sleep')
-    def test_ensure_connection_retries(self, _gt_sleep):
-        num_attempts = 3
-        self.driver.configuration.eqlx_cli_max_retries = num_attempts
-        self.mock_object(self.driver, '_ssh_execute',
-                         side_effect=processutils.ProcessExecutionError(
-                             stdout='% Error ... some error.\n'))
-        # mocks for calls in _run_ssh
-        self.mock_object(utils, 'check_ssh_injection')
-        self.mock_object(ssh_utils, 'SSHPool')
-
-        sshpool = ssh_utils.SSHPool("127.0.0.1", 22, 10,
-                                    "test",
-                                    password="test",
-                                    min_size=1,
-                                    max_size=1)
-        self.driver.sshpool = mock.Mock(return_value=sshpool)
-        ssh = mock.Mock(paramiko.SSHClient)
-        self.driver.sshpool.item().__enter__ = mock.Mock(return_value=ssh)
-        self.driver.sshpool.item().__exit__ = mock.Mock(return_value=False)
-        # now call the execute
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.driver._eql_execute, "fake command")
-        self.assertEqual(num_attempts + 1,
-                         self.driver._ssh_execute.call_count)
-
-    @unittest.skip("Skip until bug #1578986 is fixed")
-    @mock.patch.object(greenthread, 'sleep')
-    def test_ensure_retries_on_channel_timeout(self, _gt_sleep):
-        num_attempts = 3
-        self.driver.configuration.eqlx_cli_max_retries = num_attempts
-
-        # mocks for calls and objects in _run_ssh
-        self.mock_object(utils, 'check_ssh_injection')
-        self.mock_object(ssh_utils, 'SSHPool')
-
-        sshpool = ssh_utils.SSHPool("127.0.0.1", 22, 10,
-                                    "test",
-                                    password="test",
-                                    min_size=1,
-                                    max_size=1)
-        self.driver.sshpool = mock.Mock(return_value=sshpool)
-        ssh = mock.Mock(paramiko.SSHClient)
-        self.driver.sshpool.item().__enter__ = mock.Mock(return_value=ssh)
-        self.driver.sshpool.item().__exit__ = mock.Mock(return_value=False)
-        # mocks for _ssh_execute and _get_output
-        self.mock_object(self.driver, '_get_output',
-                         side_effect=exception.VolumeBackendAPIException(
-                             "some error"))
-        # now call the execute
-        with mock.patch('sys.stderr', new=six.StringIO()):
-            self.assertRaises(exception.VolumeBackendAPIException,
-                              self.driver._eql_execute, "fake command")
-
-        self.assertEqual(num_attempts + 1, self.driver._get_output.call_count)
-
-    @unittest.skip("Skip until bug #1578986 is fixed")
-    def test_with_timeout(self):
-        @ps.with_timeout
-        def no_timeout(cmd, *args, **kwargs):
-            return 'no timeout'
-
-        @ps.with_timeout
-        def w_timeout(cmd, *args, **kwargs):
-            time.sleep(1)
-
-        self.assertEqual('no timeout', no_timeout('fake cmd'))
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          w_timeout, 'fake cmd', timeout=0.1)
-
-    def test_local_path(self):
-        self.assertRaises(NotImplementedError, self.driver.local_path, '')
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/test_xtremio.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/test_xtremio.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/test_xtremio.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/test_xtremio.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,8 +16,8 @@
 import copy
 import re
 import time
+from unittest import mock
 
-import mock
 import six
 
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_adapter.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_adapter.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_adapter.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_adapter.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,9 +15,9 @@
 
 import contextlib
 import functools
+from unittest import mock
 
 import ddt
-import mock
 from oslo_utils import units
 
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_client.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_client.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_client.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_client.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,9 +13,9 @@
 # License for the specific language governing permissions and limitations
 # under the License.
 import unittest
+from unittest import mock
 
 import ddt
-from mock import mock
 from oslo_utils import units
 
 from cinder import coordination
@@ -70,7 +70,7 @@ class MockResource(object):
             raise ex.UnityResourceNotFoundError()
         elif self.get_id() == 'snap_in_use':
             raise ex.UnityDeleteAttachedSnapError()
-        elif self.name == 'empty_host':
+        elif self.name == 'empty-host':
             raise ex.HostDeleteIsCalled()
         elif self.get_id() == 'lun_in_replication':
             if not force_snap_delete:
@@ -649,7 +649,8 @@ class ClientTest(unittest.TestCase):
         host = MockResource(name='empty-host')
         self.client.host_cache['empty-host'] = host
         self.assertRaises(ex.HostDeleteIsCalled,
-                          self.client.delete_host_wo_lock(host))
+                          self.client.delete_host_wo_lock,
+                          host)
 
     def test_delete_host_wo_lock_remove_from_cache(self):
         host = MockResource(name='empty-host-in-cache')
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_driver.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,8 +15,7 @@
 
 import functools
 import unittest
-
-import mock
+from unittest import mock
 
 from cinder.tests.unit.volume.drivers.dell_emc.unity \
     import fake_exception as ex
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_replication.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_replication.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_replication.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_replication.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,9 +14,9 @@
 # under the License.
 
 import unittest
+from unittest import mock
 
 import ddt
-from mock import mock
 
 from cinder import exception
 from cinder.volume import configuration as conf
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_utils.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/unity/test_utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,8 +15,8 @@
 
 import functools
 import unittest
+from unittest import mock
 
-import mock
 from oslo_utils import units
 
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/fake_enum.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/fake_enum.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/fake_enum.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/fake_enum.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,6 +14,7 @@
 #    under the License.
 
 import enum
+
 import six
 
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/__init__.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/__init__.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/__init__.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/__init__.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,8 +14,7 @@
 # under the License.
 
 import sys
-
-import mock
+from unittest import mock
 
 from cinder.tests.unit.volume.drivers.dell_emc.vnx import fake_exception
 from cinder.tests.unit.volume.drivers.dell_emc.vnx import fake_storops
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/res_mock.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/res_mock.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/res_mock.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/res_mock.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,8 @@
 # License for the specific language governing permissions and limitations
 # under the License.
 
-import mock
+from unittest import mock
+
 import six
 
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_adapter.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_adapter.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_adapter.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_adapter.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,9 +12,9 @@
 # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 # License for the specific language governing permissions and limitations
 # under the License.
-import mock
 import os
 import re
+from unittest import mock
 
 from oslo_config import cfg
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_common.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_common.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_common.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_common.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,7 @@
 # License for the specific language governing permissions and limitations
 # under the License.
 
-import mock
+from unittest import mock
 
 from cinder import exception
 from cinder.tests.unit.volume.drivers.dell_emc.vnx import fake_storops \
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_driver.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,7 @@
 # License for the specific language governing permissions and limitations
 # under the License.
 
-import mock
+from unittest import mock
 
 from cinder.tests.unit.volume.drivers.dell_emc.vnx import test_base
 from cinder.volume.drivers.dell_emc.vnx import driver
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_replication.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_replication.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_replication.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_replication.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,7 @@
 # License for the specific language governing permissions and limitations
 # under the License.
 
-import mock
+from unittest import mock
 
 from cinder.objects import fields
 from cinder.tests.unit.volume.drivers.dell_emc.vnx import res_mock
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_utils.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/test_utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,7 @@
 # License for the specific language governing permissions and limitations
 # under the License.
 
-import mock
+from unittest import mock
 
 from cinder import exception
 from cinder.tests.unit.volume.drivers.dell_emc.vnx import fake_exception \
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/utils.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vnx/utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vnx/utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,8 +15,8 @@
 
 
 from os import path
+from unittest import mock
 
-import mock
 import six
 import yaml
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/__init__.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/__init__.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/__init__.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/__init__.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,6 +13,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 import copy
+
 import requests
 import six
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/mocks.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/mocks.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/mocks.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/mocks.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,10 +13,10 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 import json
-import requests
-import six
 
 from oslo_config import cfg
+import requests
+import six
 
 from cinder.volume.drivers.dell_emc.vxflexos import driver
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_create_volume.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_create_volume.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_create_volume.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_create_volume.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 
 from cinder import context
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_get_manageable.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_get_manageable.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_get_manageable.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_get_manageable.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,9 +14,9 @@
 #    under the License.
 
 from copy import deepcopy
+from unittest import mock
 
 import ddt
-import mock
 
 from cinder.tests.unit import fake_volume
 from cinder.tests.unit.volume.drivers.dell_emc import vxflexos
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_groups.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_groups.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_groups.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_groups.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,11 +14,10 @@
 #    under the License.
 
 import json
-import mock
+from unittest import mock
 
 from cinder import context
 from cinder.objects import fields
-
 from cinder.tests.unit import fake_constants as fake
 from cinder.tests.unit import fake_group
 from cinder.tests.unit import fake_snapshot
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_initialize_connection.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_initialize_connection.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_initialize_connection.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_initialize_connection.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,7 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-import mock
+from unittest import mock
 
 from cinder import context
 from cinder.tests.unit import fake_constants as fake
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_initialize_connection_snapshot.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_initialize_connection_snapshot.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_initialize_connection_snapshot.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_initialize_connection_snapshot.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 from cinder import context
 from cinder.tests.unit import fake_constants as fake
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_manage_existing.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_manage_existing.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_manage_existing.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_manage_existing.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,6 +13,10 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest.mock import patch
+
+from six.moves import urllib
+
 from cinder import context
 from cinder import exception
 from cinder.tests.unit import fake_constants as fake
@@ -20,8 +24,6 @@ from cinder.tests.unit import fake_volum
 from cinder.tests.unit.volume.drivers.dell_emc import vxflexos
 from cinder.tests.unit.volume.drivers.dell_emc.vxflexos import mocks
 from cinder.volume import volume_types
-from mock import patch
-from six.moves import urllib
 
 
 class TestManageExisting(vxflexos.TestVxFlexOSDriver):
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_misc.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_misc.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_misc.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_misc.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,9 +13,10 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import ddt
 import json
-import mock
+from unittest import mock
+
+import ddt
 
 from cinder import context
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/fusionstorage/test_dsware.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/fusionstorage/test_dsware.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/fusionstorage/test_dsware.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/fusionstorage/test_dsware.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,12 +12,12 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-import ddt
 import json
-
-import mock
+from unittest import mock
 import uuid
 
+import ddt
+
 from cinder import exception
 from cinder import objects
 from cinder import test
@@ -98,9 +98,10 @@ class TestDSWAREDriver(test.TestCase):
              "QoS_support": False,
              "thin_provisioning_support": False,
              "vendor_name": "Huawei",
+             "storage_protocol": "SCSI",
              "pools":
-                 [{"pool_name": 'fake_pool_name', "total_capacity_gb": 2,
-                   "free_capacity_gb": 1}]}, retval)
+                 [{"pool_name": 'fake_pool_name', "total_capacity_gb": 2.0,
+                   "free_capacity_gb": 1.0}]}, retval)
         mock_query_pool_info.assert_called_once_with()
 
     @mock.patch.object(fs_client.RestCommon, 'keep_alive')
@@ -380,7 +381,7 @@ class TestDSWAREDriver(test.TestCase):
         retval, vol = self.fake_driver._attach_volume(
             "context", volume, "properties")
         self.assertEqual(
-            ({'device': {'path': b'fake_path'}}, volume), (retval, vol))
+            ({'device': {'path': 'fake_path'}}, volume), (retval, vol))
         mock__get_manager_ip.assert_called_once_with("properties")
         mock__check_volume_exist.assert_called_once_with(volume)
         mock_attach_volume.assert_called_once_with(volume.name, 'fake_ip')
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/fusionstorage/test_fs_client.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/fusionstorage/test_fs_client.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/fusionstorage/test_fs_client.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/fusionstorage/test_fs_client.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,7 +14,8 @@
 #    under the License.
 
 import json
-import mock
+from unittest import mock
+
 import requests
 
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/fusionstorage/test_fs_conf.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/fusionstorage/test_fs_conf.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/fusionstorage/test_fs_conf.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/fusionstorage/test_fs_conf.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,13 +12,12 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-import ddt
-
-import mock
 import os
 import shutil
 import tempfile
+from unittest import mock
 
+import ddt
 from six.moves import configparser
 
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/fusionstorage/test_utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/fusionstorage/test_utils.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/fusionstorage/test_utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/fusionstorage/test_utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 import json
-
 import re
+
 import requests
 
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/hpe/fake_hpe_3par_client.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/hpe/fake_hpe_3par_client.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/hpe/fake_hpe_3par_client.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/hpe/fake_hpe_3par_client.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,8 +16,7 @@
 """Fake HPE client for testing 3PAR without installing the client."""
 
 import sys
-
-import mock
+from unittest import mock
 
 from cinder.tests.unit.volume.drivers.hpe \
     import fake_hpe_client_exceptions as hpeexceptions
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/hpe/fake_hpe_lefthand_client.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/hpe/fake_hpe_lefthand_client.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/hpe/fake_hpe_lefthand_client.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/hpe/fake_hpe_lefthand_client.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,8 +16,7 @@
 """Fake HPE client for testing LeftHand without installing the client."""
 
 import sys
-
-import mock
+from unittest import mock
 
 from cinder.tests.unit.volume.drivers.hpe \
     import fake_hpe_client_exceptions as hpeexceptions
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/hpe/test_hpe3par.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/hpe/test_hpe3par.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/hpe/test_hpe3par.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/hpe/test_hpe3par.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,7 +16,7 @@
 
 import ast
 import copy
-import mock
+from unittest import mock
 
 from oslo_utils import units
 from oslo_utils import uuidutils
@@ -2017,7 +2017,6 @@ class TestHPE3PARDriverBase(HPE3PARBaseD
 
         mock_client.getVolume.return_value = {
             'name': mock.ANY,
-            'snapCPG': mock.ANY,
             'comment': "{'display_name': 'Foo Volume'}",
             'provisioningType': mock.ANY,
             'userCPG': 'OpenStackCPG',
@@ -2124,7 +2123,6 @@ class TestHPE3PARDriverBase(HPE3PARBaseD
 
         mock_client.getVolume.return_value = {
             'name': mock.ANY,
-            'snapCPG': mock.ANY,
             'comment': "{'display_name': 'Foo Volume'}",
             'provisioningType': mock.ANY,
             'userCPG': 'OpenStackCPG',
@@ -2224,7 +2222,6 @@ class TestHPE3PARDriverBase(HPE3PARBaseD
 
         mock_client.getVolume.return_value = {
             'name': mock.ANY,
-            'snapCPG': mock.ANY,
             'comment': "{'display_name': 'Foo Volume'}",
             'provisioningType': mock.ANY,
             'userCPG': 'OpenStackCPG',
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/hpe/test_hpelefthand.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/hpe/test_hpelefthand.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/hpe/test_hpelefthand.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/hpe/test_hpelefthand.py	2020-03-24 18:46:31.000000000 +0000
@@ -17,7 +17,8 @@
 
 import copy
 import json
-import mock
+from unittest import mock
+
 from oslo_utils import units
 
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/huawei/test_huawei_drivers.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/huawei/test_huawei_drivers.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/huawei/test_huawei_drivers.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/huawei/test_huawei_drivers.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,16 +15,17 @@
 """Tests for huawei drivers."""
 import collections
 import copy
-import ddt
 import json
-import mock
 import re
-import requests
-import retrying
 import tempfile
+from unittest import mock
 from xml.dom import minidom
 from xml.etree import ElementTree
 
+import ddt
+import requests
+import retrying
+
 from cinder import context
 from cinder import exception
 from cinder import objects
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/ibm/fake_pyxcli.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/ibm/fake_pyxcli.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/ibm/fake_pyxcli.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/ibm/fake_pyxcli.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,8 +14,8 @@
 #    under the License.
 #
 """ Fake pyxcli-client for testing the driver without installing pyxcli"""
-import mock
 import sys
+from unittest import mock
 
 from cinder.tests.unit.volume.drivers.ibm import fake_pyxcli_exceptions
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/ibm/test_ds8k_proxy.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/ibm/test_ds8k_proxy.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/ibm/test_ds8k_proxy.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/ibm/test_ds8k_proxy.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,10 +16,11 @@
 """Tests for the IBM DS8K family driver."""
 import ast
 import copy
+import json
+from unittest import mock
+
 import ddt
 import eventlet
-import json
-import mock
 import six
 
 from cinder import context
@@ -32,7 +33,6 @@ import cinder.volume.drivers.ibm.ibm_sto
 from cinder.volume.drivers.ibm.ibm_storage import proxy
 from cinder.volume import group_types
 from cinder.volume import volume_types
-
 # mock decorator logger for all unit test cases.
 mock_logger = mock.patch.object(proxy, 'logger', lambda x: x)
 mock_logger.start()
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/ibm/test_ibm_flashsystem_iscsi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/ibm/test_ibm_flashsystem_iscsi.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/ibm/test_ibm_flashsystem_iscsi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/ibm/test_ibm_flashsystem_iscsi.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,14 +14,12 @@
 #    under the License.
 #
 
-"""
-Tests for the IBM FlashSystem iSCSI volume driver.
-"""
-
-import mock
-import six
+"""Tests for the IBM FlashSystem iSCSI volume driver."""
 
 import random
+from unittest import mock
+
+import six
 
 from cinder import context
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/ibm/test_ibm_flashsystem.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/ibm/test_ibm_flashsystem.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/ibm/test_ibm_flashsystem.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/ibm/test_ibm_flashsystem.py	2020-03-24 18:46:31.000000000 +0000
@@ -17,14 +17,14 @@
 
 """Tests for the IBM FlashSystem volume driver."""
 
-import mock
+import random
+import re
+from unittest import mock
+
 from oslo_concurrency import processutils
 from oslo_utils import units
 import six
 
-import random
-import re
-
 from cinder import context
 from cinder import exception
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/ibm/test_ibm_storage.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/ibm/test_ibm_storage.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/ibm/test_ibm_storage.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/ibm/test_ibm_storage.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,8 +16,7 @@
 
 
 import copy
-
-import mock
+from unittest import mock
 
 from cinder import context
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/ibm/test_storwize_svc.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/ibm/test_storwize_svc.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/ibm/test_storwize_svc.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/ibm/test_storwize_svc.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,22 +14,20 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 #
-"""
-Tests for the IBM Storwize family and SVC volume driver.
-"""
+"""Tests for the IBM Storwize family and SVC volume driver."""
 
-import ddt
 import json
-import mock
-import paramiko
 import random
 import re
 import time
+from unittest import mock
 
+import ddt
 from oslo_concurrency import processutils
 from oslo_config import cfg
 from oslo_utils import importutils
 from oslo_utils import units
+import paramiko
 import six
 
 from cinder import context
@@ -4070,7 +4068,7 @@ class StorwizeSVCFcDriverTestCase(test.T
                           connector)
         # All the wwpns of this host are not configured.
         host_site_2 = {'site1': 'ff00000000000000',
-                       'site1': 'ff00000000000001'}
+                       'site2': 'ff00000000000001'}
         self.fc_driver.configuration.set_override(
             'storwize_preferred_host_site', host_site_2)
         self.assertRaises(exception.VolumeDriverException,
@@ -4078,8 +4076,8 @@ class StorwizeSVCFcDriverTestCase(test.T
                           volume_fc,
                           connector)
 
-        host_site_3 = {'site1': 'ffff000000000000',
-                       'site1': 'ffff000000000001'}
+        # All the wwpns of this host are configured
+        host_site_3 = {'site1': 'ffff000000000000&ffff000000000001'}
         self.fc_driver.configuration.set_override(
             'storwize_preferred_host_site', host_site_3)
         self.fc_driver.initialize_connection(volume_fc, connector)
@@ -4088,7 +4086,8 @@ class StorwizeSVCFcDriverTestCase(test.T
         host_info = self.fc_driver._helpers.ssh.lshost(host=host_name)
         self.assertEqual('site1', host_info[0]['site_name'])
 
-        host_site_4 = {'site2': 'ffff000000000000',
+        # Partial wwpns of this host are configured
+        host_site_4 = {'site1': 'ff00000000000000',
                        'site2': 'ffff000000000001'}
         self.fc_driver.configuration.set_override(
             'storwize_preferred_host_site', host_site_4)
@@ -8139,17 +8138,20 @@ class StorwizeHelpersTestCase(test.TestC
         fake_license_scheme = {
             'license_scheme': '9846'
         }
+        fake_9100_license_scheme = {
+            'license_scheme': 'flex'
+        }
         fake_license_invalid_scheme = {
             'license_scheme': '0000'
         }
-
         lslicense.side_effect = [fake_license_without_keys,
                                  fake_license_without_keys,
                                  fake_license,
                                  fake_license_without_keys]
         lsguicapabilities.side_effect = [fake_license_without_keys,
                                          fake_license_invalid_scheme,
-                                         fake_license_scheme]
+                                         fake_license_scheme,
+                                         fake_9100_license_scheme]
         self.assertFalse(self.storwize_svc_common.compression_enabled())
 
         self.assertFalse(self.storwize_svc_common.compression_enabled())
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/ibm/test_xiv_proxy.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/ibm/test_xiv_proxy.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/ibm/test_xiv_proxy.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/ibm/test_xiv_proxy.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,10 +13,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 #
-import mock
-import six
+from unittest import mock
 from xml.etree import ElementTree
 
+import six
+
 from cinder import context
 from cinder import exception
 from cinder import objects
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/infortrend/test_infortrend_cli.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/infortrend/test_infortrend_cli.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/infortrend/test_infortrend_cli.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/infortrend/test_infortrend_cli.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 from cinder import test
 from cinder.volume.drivers.infortrend.raidcmd_cli import cli_factory as cli
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/infortrend/test_infortrend_common.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/infortrend/test_infortrend_common.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/infortrend/test_infortrend_common.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/infortrend/test_infortrend_common.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,8 +14,7 @@
 #    under the License.
 
 import copy
-
-import mock
+from unittest import mock
 
 from cinder import exception
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/inspur/as13000/test_as13000_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/inspur/as13000/test_as13000_driver.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/inspur/as13000/test_as13000_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/inspur/as13000/test_as13000_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,14 +13,12 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Volume driver test for Inspur AS13000
-"""
+"""Volume driver test for Inspur AS13000."""
 
 import json
-import mock
 import random
 import time
+from unittest import mock
 
 import ddt
 import eventlet
@@ -997,7 +995,7 @@ class AS13000DriverTestCase(test.TestCas
         host_exist, target_name, node = (
             self.as13000_san._get_target_from_conn(host_ip))
 
-        if host_ip is 'fake_ip3':
+        if host_ip == 'fake_ip3':
             self.assertEqual((True, 'fake_target_2',
                               ['fake_node4', 'fake_node3']),
                              (host_exist, target_name, node))
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/inspur/instorage/fakes.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/inspur/instorage/fakes.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/inspur/instorage/fakes.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/inspur/instorage/fakes.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,9 +13,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 #
-"""
-Tests for the Inspur InStorage volume driver.
-"""
+"""Tests for the Inspur InStorage volume driver."""
 
 import re
 
@@ -25,7 +23,6 @@ import six
 
 from cinder import exception
 from cinder import utils
-
 from cinder.volume.drivers.inspur.instorage import instorage_const
 from cinder.volume.drivers.inspur.instorage import instorage_fc
 from cinder.volume.drivers.inspur.instorage import instorage_iscsi
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/inspur/instorage/test_common.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/inspur/instorage/test_common.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/inspur/instorage/test_common.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/inspur/instorage/test_common.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,13 +13,12 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 #
-"""
-Tests for the Inspur InStorage volume driver.
-"""
+"""Tests for the Inspur InStorage volume driver."""
+
+from unittest import mock
 
 import ddt
 from eventlet import greenthread
-import mock
 from oslo_concurrency import processutils
 from oslo_config import cfg
 from oslo_utils import importutils
@@ -33,6 +32,7 @@ from cinder.objects import fields
 from cinder import ssh_utils
 from cinder import test
 from cinder.tests.unit import utils as testutils
+from cinder.tests.unit.volume.drivers.inspur.instorage import fakes
 from cinder.volume import configuration as conf
 from cinder.volume.drivers.inspur.instorage import (
     replication as instorage_rep)
@@ -42,8 +42,6 @@ from cinder.volume import qos_specs
 from cinder.volume import volume_types
 from cinder.volume import volume_utils
 
-from cinder.tests.unit.volume.drivers.inspur.instorage import fakes
-
 
 CONF = cfg.CONF
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/inspur/instorage/test_fc_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/inspur/instorage/test_fc_driver.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/inspur/instorage/test_fc_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/inspur/instorage/test_fc_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,12 +13,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 #
-"""
-Tests for the Inspur InStorage volume driver.
-"""
+"""Tests for the Inspur InStorage volume driver."""
+
+from unittest import mock
 
 from eventlet import greenthread
-import mock
 from oslo_utils import importutils
 
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/inspur/instorage/test_helper_routines.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/inspur/instorage/test_helper_routines.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/inspur/instorage/test_helper_routines.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/inspur/instorage/test_helper_routines.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,20 +13,18 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 #
-"""
-Tests for the Inspur InStorage volume driver.
-"""
+"""Tests for the Inspur InStorage volume driver."""
+
+from unittest import mock
 
 import ddt
-import mock
 
 from cinder import exception
 from cinder import test
+from cinder.tests.unit.volume.drivers.inspur.instorage import fakes
 from cinder.volume import configuration as conf
 from cinder.volume.drivers.inspur.instorage import instorage_common
 
-from cinder.tests.unit.volume.drivers.inspur.instorage import fakes
-
 
 class CLIParserTestCase(test.TestCase):
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/inspur/instorage/test_iscsi_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/inspur/instorage/test_iscsi_driver.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/inspur/instorage/test_iscsi_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/inspur/instorage/test_iscsi_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,12 +13,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 #
-"""
-Tests for the Inspur InStorage volume driver.
-"""
+"""Tests for the Inspur InStorage volume driver."""
+
+from unittest import mock
 
 from eventlet import greenthread
-import mock
 from oslo_utils import importutils
 import six
 
@@ -26,12 +25,11 @@ from cinder import context
 from cinder import exception
 from cinder import test
 from cinder.tests.unit import utils as testutils
+from cinder.tests.unit.volume.drivers.inspur.instorage import fakes
 from cinder.volume import configuration as conf
 from cinder.volume.drivers.inspur.instorage import instorage_iscsi
 from cinder.volume import volume_types
 
-from cinder.tests.unit.volume.drivers.inspur.instorage import fakes
-
 
 class InStorageMCSISCSIDriverTestCase(test.TestCase):
     def setUp(self):
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/inspur/instorage/test_replication.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/inspur/instorage/test_replication.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/inspur/instorage/test_replication.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/inspur/instorage/test_replication.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,14 +13,12 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 #
-"""
-Tests for the Inspur InStorage volume driver.
-"""
+"""Tests for the Inspur InStorage volume driver."""
 
 import json
+from unittest import mock
 
 from eventlet import greenthread
-import mock
 from oslo_utils import importutils
 from oslo_utils import units
 
@@ -30,6 +28,7 @@ from cinder.objects import fields
 from cinder import test
 from cinder.tests.unit import fake_constants as fake
 from cinder.tests.unit import utils as testutils
+from cinder.tests.unit.volume.drivers.inspur.instorage import fakes
 from cinder import utils
 from cinder.volume import configuration as conf
 from cinder.volume.drivers.inspur.instorage import (
@@ -38,8 +37,6 @@ from cinder.volume.drivers.inspur.instor
 from cinder.volume.drivers.inspur.instorage import instorage_const
 from cinder.volume import volume_types
 
-from cinder.tests.unit.volume.drivers.inspur.instorage import fakes
-
 
 class InStorageMCSReplicationTestCase(test.TestCase):
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/nec/test_volume.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/nec/test_volume.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/nec/test_volume.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/nec/test_volume.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,9 +14,10 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import ddt
-import mock
 import time
+from unittest import mock
+
+import ddt
 
 from cinder import context
 from cinder import exception
@@ -558,7 +559,7 @@ class NominatePoolLDTest(volume_helper.M
         # config:pool_backup_pools=[2]
         self.pools[1]['free'] = savePool1
 
-        if len(self.pools[0]['ld_list']) is 1024:
+        if len(self.pools[0]['ld_list']) == 1024:
             savePool2 = self.pools[2]['free']
             savePool3 = self.pools[3]['free']
             self.pools[2]['free'] = 0
@@ -681,13 +682,6 @@ class VolumeCreateTest(volume_helper.MSt
         vol.status = 'available'
         self._validate_migrate_volume(vol, self.xml)
 
-        vol.status = 'creating'
-        with self.assertRaisesRegex(exception.VolumeBackendAPIException,
-                                    'Specified Logical Disk'
-                                    ' LX:287RbQoP7VdwR1WsPC2fZT'
-                                    ' is not available.'):
-            self._validate_migrate_volume(vol, self.xml)
-
         vol.id = "AAAAAAAA"
         vol.status = 'available'
         with self.assertRaisesRegex(exception.NotFound,
@@ -1404,10 +1398,17 @@ class Migrate_test(volume_helper.MStorag
 
     def test_migrate_volume(self):
         vol = DummyVolume(constants.VOLUME2_ID)
-        moved, model_update = self.migrate_volume(None, vol,
-                                                  self.host)
+        vol.status = 'available'
+        moved, __ = self.migrate_volume(None, vol,
+                                        self.host)
         self.assertTrue(moved)
 
+        vol = DummyVolume(constants.VOLUME2_ID)
+        vol.status = 'in-use'
+        moved, __ = self.migrate_volume(None, vol,
+                                        self.host)
+        self.assertFalse(moved)
+
         vol.id = "87d8d42f-7550-4f43-9a2b-fe722bf86941"
         with self.assertRaisesRegex(exception.NotFound,
                                     'Logical Disk `LX:48L3QCi4npuqxPX0Lyeu8H`'
@@ -1416,11 +1417,9 @@ class Migrate_test(volume_helper.MStorag
 
         vol.id = '46045673-41e7-44a7-9333-02f07feab04b'
         vol.status = 'creating'
-        with self.assertRaisesRegex(exception.VolumeBackendAPIException,
-                                    'Specified Logical Disk '
-                                    'LX:287RbQoP7VdwR1WsPC2fZT is '
-                                    'not available.'):
-            self._validate_migrate_volume(vol, xml_out)
+        moved, __ = self.migrate_volume(None, vol,
+                                        self.host)
+        self.assertFalse(moved)
 
         vol.id = "92dbc7f4-dbc3-4a87-aef4-d5a2ada3a9af"
         vol.status = 'available'
@@ -1468,6 +1467,14 @@ class Migrate_test(volume_helper.MStorag
         retyped = self.retype(None, vol, new_type, diff, self.host)
         self.assertTrue(retyped)
 
+        vol.attach_status = 'attached'
+        diff = {'encryption': {},
+                'qos_specs': {},
+                'extra_specs': {u'volume_backend_name': (u'Storage1',
+                                                         u'Storage2')}}
+        retyped = self.retype(None, vol, new_type, diff, self.host)
+        self.assertFalse(retyped)
+
     def test_validate_retype_volume(self):
         vol = DummyVolume("87d8d42f-7550-4f43-9a2b-fe722bf86941")
         with self.assertRaisesRegex(exception.NotFound,
@@ -1755,3 +1762,64 @@ class SetQosSpec_test(volume_helper.MSto
         volume_type_id = '33cd6136-0465-4ee0-82fa-b5f3a9138249'
         ret = self._set_qos_spec(ldname, volume_type_id)
         self.assertIsNone(ret)
+
+    def test_get_qos_parameters(self):
+        specs = {}
+        qos_params = self.get_qos_parameters(specs, True)
+        self.assertEqual(0, qos_params['upperlimit'])
+        self.assertEqual(0, qos_params['lowerlimit'])
+        self.assertEqual('off', qos_params['upperreport'])
+
+        specs = {}
+        qos_params = self.get_qos_parameters(specs, False)
+        self.assertIsNone(qos_params['upperlimit'])
+        self.assertIsNone(qos_params['lowerlimit'])
+        self.assertIsNone(qos_params['upperreport'])
+
+        specs = {u'upperlimit': u'1000',
+                 u'lowerlimit': u'500',
+                 u'upperreport': u'off'}
+        qos_params = self.get_qos_parameters(specs, False)
+        self.assertEqual(1000, qos_params['upperlimit'])
+        self.assertEqual(500, qos_params['lowerlimit'])
+        self.assertEqual('off', qos_params['upperreport'])
+
+        specs = {u'upperreport': u'on'}
+        qos_params = self.get_qos_parameters(specs, False)
+        self.assertIsNone(qos_params['upperlimit'])
+        self.assertIsNone(qos_params['lowerlimit'])
+        self.assertEqual('on', qos_params['upperreport'])
+
+        specs = {u'upperreport': u'aaa'}
+        qos_params = self.get_qos_parameters(specs, False)
+        self.assertIsNone(qos_params['upperlimit'])
+        self.assertIsNone(qos_params['lowerlimit'])
+        self.assertIsNone(qos_params['upperreport'])
+
+        specs = {u'upperlimit': u'1000001',
+                 u'lowerlimit': u'500'}
+        with self.assertRaisesRegex(exception.InvalidConfigurationValue,
+                                    'Value "1000001" is not valid for '
+                                    'configuration option "upperlimit"'):
+            self.get_qos_parameters(specs, False)
+
+        specs = {u'upperlimit': u'aaa',
+                 u'lowerlimit': u'500'}
+        with self.assertRaisesRegex(exception.InvalidConfigurationValue,
+                                    'Value "aaa" is not valid for '
+                                    'configuration option "upperlimit"'):
+            self.get_qos_parameters(specs, False)
+
+        specs = {u'upperlimit': u'1000',
+                 u'lowerlimit': u'aaa'}
+        with self.assertRaisesRegex(exception.InvalidConfigurationValue,
+                                    'Value "aaa" is not valid for '
+                                    'configuration option "lowerlimit"'):
+            self.get_qos_parameters(specs, False)
+
+        specs = {u'upperlimit': u'1000',
+                 u'lowerlimit': u'1'}
+        with self.assertRaisesRegex(exception.InvalidConfigurationValue,
+                                    'Value "1" is not valid for '
+                                    'configuration option "lowerlimit"'):
+            self.get_qos_parameters(specs, False)
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/client/fakes.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/client/fakes.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/client/fakes.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/client/fakes.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,9 +13,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
 
 from lxml import etree
-import mock
 from six.moves import urllib
 
 from cinder.tests.unit.volume.drivers.netapp.dataontap import fakes as fake
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/client/test_api.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/client/test_api.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/client/test_api.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/client/test_api.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,12 +15,12 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Tests for NetApp API layer
-"""
+"""Tests for NetApp API layer"""
+
+from unittest import mock
+
 import ddt
 from lxml import etree
-import mock
 from oslo_utils import netutils
 import paramiko
 import six
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/client/test_client_base.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/client/test_client_base.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/client/test_client_base.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/client/test_client_base.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,12 +14,12 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+import time
+from unittest import mock
 import uuid
 
 from lxml import etree
-import mock
 import six
-import time
 
 from cinder import exception
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/client/test_client_cmode.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/client/test_client_cmode.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/client/test_client_cmode.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/client/test_client_cmode.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,14 +16,14 @@
 #    under the License.
 
 import copy
+import time
+from unittest import mock
 import uuid
 
 import ddt
 from lxml import etree
-import mock
 import paramiko
 import six
-import time
 
 from cinder import exception
 from cinder import ssh_utils
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/performance/test_perf_base.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/performance/test_perf_base.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/performance/test_perf_base.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/performance/test_perf_base.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 
 from cinder import exception
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/performance/test_perf_cmode.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/performance/test_perf_cmode.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/performance/test_perf_cmode.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/performance/test_perf_cmode.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
+
 import ddt
-import mock
 
 from cinder import test
 from cinder.tests.unit.volume.drivers.netapp.dataontap.performance \
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/test_block_base.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/test_block_base.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/test_block_base.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/test_block_base.py	2020-03-24 18:46:31.000000000 +0000
@@ -18,15 +18,13 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Mock unit tests for the NetApp block storage library
-"""
+"""Mock unit tests for the NetApp block storage library"""
 
 import copy
+from unittest import mock
 import uuid
 
 import ddt
-import mock
 from oslo_log import versionutils
 from oslo_utils import units
 import six
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/test_block_cmode.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/test_block_cmode.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/test_block_cmode.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/test_block_cmode.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,12 +14,11 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Mock unit tests for the NetApp block storage C-mode library
-"""
+"""Mock unit tests for the NetApp block storage C-mode library."""
+
+from unittest import mock
 
 import ddt
-import mock
 
 from cinder import exception
 from cinder.objects import fields
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/test_nfs_base.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/test_nfs_base.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/test_nfs_base.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/test_nfs_base.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,16 +13,14 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Unit tests for the NetApp NFS storage driver
-"""
+"""Unit tests for the NetApp NFS storage driver."""
 import copy
 import os
 import threading
 import time
+from unittest import mock
 
 import ddt
-import mock
 from os_brick.remotefs import remotefs as remotefs_brick
 from oslo_concurrency import processutils
 from oslo_utils import units
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/test_nfs_cmode.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/test_nfs_cmode.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/test_nfs_cmode.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/test_nfs_cmode.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,15 +12,13 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Mock unit tests for the NetApp cmode nfs storage driver
-"""
+"""Mock unit tests for the NetApp cmode nfs storage driver."""
 
 import hashlib
+from unittest import mock
 import uuid
 
 import ddt
-import mock
 from os_brick.remotefs import remotefs as remotefs_brick
 from oslo_utils import units
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_capabilities.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_capabilities.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_capabilities.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_capabilities.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,9 +15,9 @@
 
 import collections
 import copy
+from unittest import mock
 
 import ddt
-import mock
 import six
 
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_data_motion.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_data_motion.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_data_motion.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_data_motion.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,11 +10,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+import copy
 import time
+from unittest import mock
 
-import copy
 import ddt
-import mock
 from oslo_config import cfg
 
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_loopingcalls.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_loopingcalls.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_loopingcalls.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_loopingcalls.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,8 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
+
 from oslo_service import loopingcall
 
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_utils.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,9 +12,9 @@
 
 import json
 import socket
+from unittest import mock
 
 import ddt
-import mock
 from oslo_config import cfg
 
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/test_utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/test_utils.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/netapp/test_utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/netapp/test_utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -19,10 +19,10 @@ Mock unit tests for the NetApp driver ut
 """
 
 import copy
-import ddt
 import platform
+from unittest import mock
 
-import mock
+import ddt
 from oslo_concurrency import processutils as putils
 
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/nexenta/test_nexenta5_iscsi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/nexenta/test_nexenta5_iscsi.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/nexenta/test_nexenta5_iscsi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/nexenta/test_nexenta5_iscsi.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,12 +12,10 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Unit tests for OpenStack Cinder volume driver
-"""
+"""Unit tests for OpenStack Cinder volume driver."""
+from unittest import mock
 import uuid
 
-import mock
 from oslo_utils import units
 
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/nexenta/test_nexenta5_jsonrpc.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/nexenta/test_nexenta5_jsonrpc.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/nexenta/test_nexenta5_jsonrpc.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/nexenta/test_nexenta5_jsonrpc.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,17 +12,15 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Unit tests for NexentaStor 5 REST API helper
-"""
+"""Unit tests for NexentaStor 5 REST API helper."""
 
 import copy
 import hashlib
 import json
 import posixpath
+from unittest import mock
 import uuid
 
-import mock
 import requests
 import six
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/nexenta/test_nexenta5_nfs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/nexenta/test_nexenta5_nfs.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/nexenta/test_nexenta5_nfs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/nexenta/test_nexenta5_nfs.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,13 +12,11 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Unit tests for OpenStack Cinder volume driver
-"""
+"""Unit tests for OpenStack Cinder volume driver."""
 import hashlib
 import os
+from unittest import mock
 
-import mock
 from oslo_utils import units
 
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/nexenta/test_nexenta.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/nexenta/test_nexenta.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/nexenta/test_nexenta.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/nexenta/test_nexenta.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,12 +12,11 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Unit tests for OpenStack Cinder volume driver
-"""
+"""Unit tests for OpenStack Cinder volume driver."""
+
+from unittest import mock
+from unittest.mock import patch
 
-import mock
-from mock import patch
 from oslo_utils import units
 
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/solidfire/test_solidfire.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/solidfire/test_solidfire.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/solidfire/test_solidfire.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/solidfire/test_solidfire.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,15 +16,15 @@
 
 import datetime
 import re
-import six
+from unittest import mock
 
 from ddt import data
 from ddt import ddt
 from ddt import file_data
 from ddt import unpack
-import mock
 from oslo_utils import timeutils
 from oslo_utils import units
+import six
 
 from cinder import context
 from cinder import exception
@@ -183,7 +183,7 @@ class SolidFireVolumeTestCase(test.TestC
 
     def fake_issue_api_request(obj, method, params, version='1.0',
                                endpoint=None):
-        if method is 'GetClusterCapacity':
+        if method == 'GetClusterCapacity':
             data = {}
             if version == '1.0':
                 data = {'result': {'clusterCapacity': {
@@ -220,7 +220,7 @@ class SolidFireVolumeTestCase(test.TestC
                         'clusterRecentIOSize': 0}}}
             return data
 
-        elif method is 'GetClusterInfo':
+        elif method == 'GetClusterInfo':
             results = {
                 'result':
                     {'clusterInfo':
@@ -233,7 +233,7 @@ class SolidFireVolumeTestCase(test.TestC
                          'attributes': {}}}}
             return results
 
-        elif method is 'GetClusterVersionInfo':
+        elif method == 'GetClusterVersionInfo':
             return {'id': None, 'result': {'softwareVersionInfo':
                                            {'pendingVersion': '8.2.1.4',
                                             'packageName': '',
@@ -242,10 +242,10 @@ class SolidFireVolumeTestCase(test.TestC
                                            'clusterVersion': '8.2.1.4',
                                            'clusterAPIVersion': '8.2'}}
 
-        elif method is 'AddAccount' and version == '1.0':
+        elif method == 'AddAccount' and version == '1.0':
             return {'result': {'accountID': 25}, 'id': 1}
 
-        elif method is 'GetAccountByName' and version == '1.0':
+        elif method == 'GetAccountByName' and version == '1.0':
             results = {'result': {'account':
                                   {'accountID': 25,
                                    'username': params['username'],
@@ -257,25 +257,25 @@ class SolidFireVolumeTestCase(test.TestC
                        "id": 1}
             return results
 
-        elif method is 'CreateVolume' and version == '1.0':
+        elif method == 'CreateVolume' and version == '1.0':
             return {'result': {'volumeID': 5}, 'id': 1}
 
-        elif method is 'CreateSnapshot' and version == '6.0':
+        elif method == 'CreateSnapshot' and version == '6.0':
             return {'result': {'snapshotID': 5}, 'id': 1}
 
-        elif method is 'DeleteVolume' and version == '1.0':
+        elif method == 'DeleteVolume' and version == '1.0':
             return {'result': {}, 'id': 1}
 
-        elif method is 'ModifyVolume' and version == '5.0':
+        elif method == 'ModifyVolume' and version == '5.0':
             return {'result': {}, 'id': 1}
 
-        elif method is 'CloneVolume':
+        elif method == 'CloneVolume':
             return {'result': {'volumeID': 6}, 'id': 2}
 
-        elif method is 'ModifyVolume':
+        elif method == 'ModifyVolume':
             return {'result': {}, 'id': 1}
 
-        elif method is 'ListVolumesForAccount' and version == '1.0':
+        elif method == 'ListVolumesForAccount' and version == '1.0':
             test_name = 'OS-VOLID-a720b3c0-d1f0-11e1-9b23-0800200c9a66'
             result = {'result': {
                 'volumes': [{'volumeID': 5,
@@ -291,7 +291,7 @@ class SolidFireVolumeTestCase(test.TestC
                              'iqn': test_name}]}}
             return result
 
-        elif method is 'ListActiveVolumes':
+        elif method == 'ListActiveVolumes':
             test_name = "existing_volume"
             result = {'result': {
                 'volumes': [{'volumeID': 5,
@@ -306,7 +306,7 @@ class SolidFireVolumeTestCase(test.TestC
                              'qos': None,
                              'iqn': test_name}]}}
             return result
-        elif method is 'ListVolumes':
+        elif method == 'ListVolumes':
             test_name = "get_sfvol_by_cinder"
             result = {'result': {
                 'volumes': [{'volumeID': 5,
@@ -337,13 +337,13 @@ class SolidFireVolumeTestCase(test.TestC
                                     != params['startVolumeID']]
                 result['result']['volumes'] = selected_volumes
             return result
-        elif method is 'DeleteSnapshot':
+        elif method == 'DeleteSnapshot':
             return {'result': {}}
-        elif method is 'GetClusterVersionInfo':
+        elif method == 'GetClusterVersionInfo':
             return {'result': {'clusterAPIVersion': '8.0'}}
-        elif method is 'StartVolumePairing':
+        elif method == 'StartVolumePairing':
             return {'result': {'volumePairingKey': 'fake-pairing-key'}}
-        elif method is 'RollbackToSnapshot':
+        elif method == 'RollbackToSnapshot':
             return {
                 "id": 1,
                 "result": {
@@ -368,7 +368,7 @@ class SolidFireVolumeTestCase(test.TestC
                     "snapshotID": 1
                 }
             }
-        elif method is 'ListAccounts':
+        elif method == 'ListAccounts':
             return {
                 'result': {
                     'accounts': [{
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/synology/test_synology_common.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/synology/test_synology_common.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/synology/test_synology_common.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/synology/test_synology_common.py	2020-03-24 18:46:31.000000000 +0000
@@ -18,11 +18,11 @@
 import copy
 import json
 import math
+from unittest import mock
 
 from cryptography.hazmat.backends import default_backend
 from cryptography.hazmat.primitives.asymmetric import padding
 from cryptography.hazmat.primitives.asymmetric import rsa
-import mock
 from oslo_utils import units
 import requests
 from six.moves import http_client
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/synology/test_synology_iscsi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/synology/test_synology_iscsi.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/synology/test_synology_iscsi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/synology/test_synology_iscsi.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,7 +15,7 @@
 
 """Tests for the Synology iSCSI volume driver."""
 
-import mock
+from unittest import mock
 
 from cinder import exception
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_datera.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_datera.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_datera.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_datera.py	2020-03-24 18:46:31.000000000 +0000
@@ -1,4 +1,4 @@
-# Copyright 2017 Datera
+# Copyright 2020 Datera
 # All Rights Reserved.
 #
 #    Licensed under the Apache License, Version 2.0 (the "License"); you may
@@ -13,97 +13,85 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
-import six
+import sys
+from unittest import mock
+import uuid
 
 from cinder import context
 from cinder import exception
 from cinder import test
+from cinder import version
 from cinder.volume import configuration as conf
-from cinder.volume.drivers.datera import datera_common as datc
-from cinder.volume.drivers.datera import datera_iscsi as datera
 from cinder.volume import volume_types
 
+sys.modules['dfs_sdk'] = mock.MagicMock()
 
-datc.DEFAULT_SI_SLEEP = 0
-datc.DEFAULT_SI_SLEEP_API_2 = 0
-datc.DEFAULT_SNAP_SLEEP = 0
-URL_TEMPLATES = datera.datc.URL_TEMPLATES
+from cinder.volume.drivers.datera import datera_iscsi as datera  # noqa
+
+datera.datc.DEFAULT_SI_SLEEP = 0
+datera.datc.DEFAULT_SNAP_SLEEP = 0
 OS_PREFIX = datera.datc.OS_PREFIX
 UNMANAGE_PREFIX = datera.datc.UNMANAGE_PREFIX
+DateraAPIException = datera.datc.DateraAPIException
 
 
-class DateraVolumeTestCasev2(test.TestCase):
+class DateraVolumeTestCasev22(test.TestCase):
 
     def setUp(self):
-        super(DateraVolumeTestCasev2, self).setUp()
-
         self.cfg = mock.Mock(spec=conf.Configuration)
         self.cfg.san_ip = '127.0.0.1'
-        self.cfg.san_is_local = True
-        self.cfg.datera_api_token = 'secret'
         self.cfg.datera_api_port = '7717'
-        self.cfg.datera_num_replicas = '2'
+        self.cfg.san_is_local = True
+        self.cfg.datera_num_replicas = 1
         self.cfg.datera_503_timeout = 0.01
         self.cfg.datera_503_interval = 0.001
-        self.cfg.datera_acl_allow_all = False
         self.cfg.datera_debug = False
         self.cfg.san_login = 'user'
         self.cfg.san_password = 'pass'
-        self.cfg.datera_tenant_id = 'test-tenant'
+        self.cfg.datera_tenant_id = '/root/test-tenant'
         self.cfg.driver_client_cert = None
         self.cfg.driver_client_cert_key = None
         self.cfg.datera_disable_profiler = False
-        self.cfg.driver_use_ssl = False
+        self.cfg.datera_ldap_server = ""
+        self.cfg.datera_volume_type_defaults = {}
+        self.cfg.datera_disable_template_override = False
+        self.cfg.datera_disable_extended_metadata = False
+        self.cfg.datera_enable_image_cache = False
+        self.cfg.datera_image_cache_volume_type_id = ""
+        self.cfg.filter_function = lambda: None
+        self.cfg.goodness_function = lambda: None
+        self.cfg.use_chap_auth = False
+        self.cfg.chap_username = ""
+        self.cfg.chap_password = ""
 
+        super(DateraVolumeTestCasev22, self).setUp()
         mock_exec = mock.Mock()
         mock_exec.return_value = ('', '')
 
         self.driver = datera.DateraDriver(execute=mock_exec,
                                           configuration=self.cfg)
-        self.driver.set_initialized()
-        self.driver.configuration.get = _config_getter
-        self.volume = _stub_volume()
-        self.driver._request = mock.Mock()
-        m = mock.Mock()
-        m.json.return_value = {'api_versions': ['v2']}
-        self.driver._request.return_value = m
-        self.mock_api = mock.Mock()
-        self.driver._issue_api_request = self.mock_api
-        self._apiv = "2"
-        self._tenant = None
+        self.driver.api = mock.MagicMock()
+        self.driver.apiv = "2.2"
 
+        self.driver.set_initialized()
+        # No-op config getter
+        self.driver.configuration.get = lambda *args, **kwargs: {}
         # self.addCleanup(self.api_patcher.stop)
+        self.driver.datera_version = "3.3.3"
 
     def test_volume_create_success(self):
-        self.mock_api.return_value = stub_single_ai
-        self.assertIsNone(self.driver.create_volume(self.volume))
+        testvol = _stub_volume()
+        self.assertIsNone(self.driver.create_volume(testvol))
 
     def test_volume_create_fails(self):
-        self.mock_api.side_effect = datc.DateraAPIException
-        self.assertRaises(datc.DateraAPIException,
-                          self.driver.create_volume, self.volume)
-
-    def test_volume_create_delay(self):
-        """Verify after 1st retry volume becoming available is a success."""
-
-        def _progress_api_return(mock_api):
-            if mock_api.retry_count == 1:
-                _bad_vol_ai = stub_single_ai.copy()
-                _bad_vol_ai['storage_instances']['storage-1'][
-                    'volumes']['volume-1']['op_status'] = 'unavailable'
-                return _bad_vol_ai
-            else:
-                self.mock_api.retry_count += 1
-                return stub_single_ai
-        self.mock_api.retry_count = 0
-        self.mock_api.return_value = _progress_api_return(self.mock_api)
-        self.assertEqual(1, self.mock_api.retry_count)
-        self.assertIsNone(self.driver.create_volume(self.volume))
+        testvol = _stub_volume()
+        self.driver.api.app_instances.create.side_effect = DateraAPIException
+        self.assertRaises(DateraAPIException,
+                          self.driver.create_volume,
+                          testvol)
 
     @mock.patch.object(volume_types, 'get_volume_type')
     def test_create_volume_with_extra_specs(self, mock_get_type):
-        self.mock_api.return_value = stub_single_ai
         mock_get_type.return_value = {
             'name': u'The Best',
             'qos_specs_id': None,
@@ -130,1089 +118,354 @@ class DateraVolumeTestCasev2(test.TestCa
         self.assertTrue(mock_get_type.called)
 
     def test_create_cloned_volume_success(self):
-        source_volume = _stub_volume(
-            id='7f91abfa-7964-41ed-88fc-207c3a290b4f',
-            display_name='foo'
-        )
-        self.assertIsNone(self.driver.create_cloned_volume(self.volume,
-                                                           source_volume))
+        testvol = _stub_volume()
+        ref = _stub_volume(id=str(uuid.uuid4()))
+        self.assertIsNone(self.driver.create_cloned_volume(testvol, ref))
 
     def test_create_cloned_volume_success_larger(self):
-        cloned_volume = _stub_volume(
-            id='7f91abfa-7964-41ed-88fc-207c3a290b4f',
-            display_name='foo',
-            size=2
-        )
-
-        mock_extend = mock.Mock()
-        if self._apiv == '2':
-            self.driver._extend_volume_2 = mock_extend
-            self.driver.create_cloned_volume(cloned_volume, self.volume)
-            mock_extend.assert_called_with(
-                cloned_volume, cloned_volume['size'])
-        else:
-            self.driver._extend_volume_2_1 = mock_extend
-            self.driver.create_cloned_volume(cloned_volume, self.volume)
-            mock_extend.assert_called_with(
-                cloned_volume, cloned_volume['size'])
+        newsize = 2
+        testvol = _stub_volume(size=newsize)
+        ref = _stub_volume(id=str(uuid.uuid4()))
+        mock_extend = mock.MagicMock()
+        self.driver._extend_volume_2_2 = mock_extend
+        self.driver._extend_volume_2_1 = mock_extend
+        self.driver.create_cloned_volume(testvol, ref)
+        mock_extend.assert_called_once_with(testvol, newsize)
 
     def test_create_cloned_volume_fails(self):
-        self.mock_api.side_effect = datc.DateraAPIException
-        source_volume = _stub_volume(
-            id='7f91abfa-7964-41ed-88fc-207c3a290b4f',
-            display_name='foo'
-        )
-        self.assertRaises(datc.DateraAPIException,
-                          self.driver.create_cloned_volume, self.volume,
-                          source_volume)
+        testvol = _stub_volume()
+        ref = _stub_volume(id=str(uuid.uuid4()))
+        self.driver.api.app_instances.create.side_effect = DateraAPIException
+        self.assertRaises(DateraAPIException,
+                          self.driver.create_cloned_volume,
+                          testvol,
+                          ref)
 
     def test_delete_volume_success(self):
-        if self._apiv == '2':
-            self.mock_api.side_effect = [
-                {},
-                self._generate_fake_api_request()(
-                    "acl_policy", api_version=self._apiv, tenant=self._tenant),
-                self._generate_fake_api_request()(
-                    "ig_group", api_version=self._apiv, tenant=self._tenant),
-                {},
-                {},
-                {},
-                {},
-                {}]
-        else:
-            self.mock_api.side_effect = [
-                {},
-                {},
-                self._generate_fake_api_request()(
-                    "acl_policy", api_version=self._apiv, tenant=self._tenant),
-                self._generate_fake_api_request()(
-                    "ig_group", api_version=self._apiv, tenant=self._tenant),
-                {},
-                {},
-                {},
-                {},
-                {}]
-        self.assertIsNone(self.driver.delete_volume(self.volume))
+        testvol = _stub_volume()
+        self.driver.api.app_instances.delete.return_value = {}
+        self.assertIsNone(self.driver.delete_volume(testvol))
 
     def test_delete_volume_not_found(self):
-        if self._apiv == '2':
-            self.mock_api.side_effect = exception.NotFound
-        else:
-            self.mock_api.side_effect = [
-                self._generate_fake_api_request("tenant"),
-                {},
-                exception.NotFound,
-                self._generate_fake_api_request()(
-                    "acl_policy", api_version=self._apiv, tenant=self._tenant),
-                self._generate_fake_api_request()(
-                    "ig_group", api_version=self._apiv, tenant=self._tenant),
-                {},
-                {},
-                {},
-                {},
-            ]
-        self.assertIsNone(self.driver.delete_volume(self.volume))
+        testvol = _stub_volume()
+        self.driver.api.app_instances.list.side_effect = exception.NotFound
+        self.assertIsNone(self.driver.delete_volume(testvol))
 
     def test_delete_volume_fails(self):
-        self.mock_api.side_effect = datc.DateraAPIException
-        self.assertRaises(datc.DateraAPIException,
-                          self.driver.delete_volume, self.volume)
+        testvol = _stub_volume()
+        self.driver.api.app_instances.list.side_effect = DateraAPIException
+        self.assertRaises(DateraAPIException,
+                          self.driver.delete_volume, testvol)
 
     def test_ensure_export_success(self):
-        self.mock_api.side_effect = self._generate_fake_api_request()
+        testvol = _stub_volume()
         ctxt = context.get_admin_context()
-        self.assertIsNone(self.driver.ensure_export(ctxt,
-                                                    self.volume,
-                                                    None))
+        self.assertIsNone(self.driver.ensure_export(ctxt, testvol, None))
 
     def test_ensure_export_fails(self):
-        self.mock_api.side_effect = datc.DateraAPIException
+        # This can't fail because it's a no-op
+        testvol = _stub_volume()
         ctxt = context.get_admin_context()
-        self.assertRaises(datc.DateraAPIException,
-                          self.driver.ensure_export, ctxt, self.volume, None)
+        self.assertIsNone(self.driver.ensure_export(ctxt, testvol, None))
 
     def test_create_export_target_does_not_exist_success(self):
-        self.mock_api.side_effect = self._generate_fake_api_request(
-            targets_exist=False)
-        ctxt = context.get_admin_context()
-        self.assertIsNone(self.driver.create_export(ctxt,
-                                                    self.volume,
-                                                    None))
+        testvol = _stub_volume()
+        aimock = mock.MagicMock()
+        simock = mock.MagicMock()
+        simock.reload.return_value = simock
+        aimock.storage_instances.list.return_value = [simock]
+        simock.op_state = "available"
+        self.driver.cvol_to_ai = mock.Mock()
+        self.driver.cvol_to_ai.return_value = aimock
+        self.assertIsNone(self.driver.create_export(None, testvol, None))
 
     def test_create_export_fails(self):
-        self.mock_api.side_effect = datc.DateraAPIException
-        ctxt = context.get_admin_context()
-        self.assertRaises(datc.DateraAPIException,
+        testvol = _stub_volume()
+        aimock = mock.MagicMock()
+        simock = mock.MagicMock()
+        simock.reload.return_value = simock
+        aimock.storage_instances.list.side_effect = DateraAPIException
+        simock.op_state = "available"
+        self.driver.cvol_to_ai = mock.Mock()
+        self.driver.cvol_to_ai.return_value = aimock
+        self.assertRaises(DateraAPIException,
                           self.driver.create_export,
-                          ctxt,
-                          self.volume,
+                          None,
+                          testvol,
                           None)
 
     def test_initialize_connection_success(self):
-        self.mock_api.side_effect = self._generate_fake_api_request()
-        connector = {}
-
-        expected = {
-            'driver_volume_type': 'iscsi',
-            'data': {
-                'target_discovered': False,
-                'volume_id': self.volume['id'],
-                'target_iqn': ('iqn.2013-05.com.daterainc:tc:01:sn:'
-                               '3bbb080aab7d9abc'),
-                'target_portal': '172.28.41.63:3260',
-                'target_lun': 0,
-                'discard': False}}
-        self.assertEqual(expected,
-                         self.driver.initialize_connection(self.volume,
-                                                           connector))
+        testvol = _stub_volume()
+        aimock = mock.MagicMock()
+        simock = mock.MagicMock()
+        simock.access = {"ips": ["test-ip"], "iqn": "test-iqn"}
+        simock.reload.return_value = simock
+        aimock.storage_instances.list.return_value = [simock]
+        self.driver.cvol_to_ai = mock.Mock()
+        self.driver.cvol_to_ai.return_value = aimock
+        self.assertEqual(self.driver.initialize_connection(testvol, {}),
+                         {'data': {'discard': False,
+                                   'target_discovered': False,
+                                   'target_iqn': 'test-iqn',
+                                   'target_lun': 0,
+                                   'target_portal': 'test-ip:3260',
+                                   'volume_id': testvol['id']},
+                          'driver_volume_type': 'iscsi'})
 
     def test_initialize_connection_fails(self):
-        self.mock_api.side_effect = datc.DateraAPIException
-        connector = {}
-        self.assertRaises(datc.DateraAPIException,
+        testvol = _stub_volume()
+        aimock = mock.MagicMock()
+        simock = mock.MagicMock()
+        simock.access = {"ips": ["test-ip"], "iqn": "test-iqn"}
+        simock.reload.return_value = simock
+        aimock.storage_instances.list.side_effect = DateraAPIException
+        self.driver.cvol_to_ai = mock.Mock()
+        self.driver.cvol_to_ai.return_value = aimock
+        self.assertRaises(DateraAPIException,
                           self.driver.initialize_connection,
-                          self.volume,
-                          connector)
+                          testvol,
+                          {})
 
     def test_detach_volume_success(self):
-        if self._apiv == '2':
-            self.mock_api.side_effect = [
-                {},
-                self._generate_fake_api_request()(
-                    "acl_policy", api_version=self._apiv, tenant=self._tenant),
-                self._generate_fake_api_request()(
-                    "ig_group", api_version=self._apiv, tenant=self._tenant),
-                {},
-                {},
-                {},
-                {}]
-        else:
-            self.mock_api.side_effect = [
-                {},
-                {},
-                self._generate_fake_api_request()(
-                    "acl_policy", api_version=self._apiv, tenant=self._tenant),
-                self._generate_fake_api_request()(
-                    "ig_group", api_version=self._apiv, tenant=self._tenant),
-                {},
-                {},
-                {},
-                {}]
+        testvol = _stub_volume()
+        self.driver.cvol_to_ai = mock.MagicMock()
+        aimock = mock.MagicMock()
+        aimock.set.return_value = {}
+        self.driver.cvol_to_ai.return_value = aimock
         ctxt = context.get_admin_context()
-        volume = _stub_volume(status='in-use')
-        self.assertIsNone(self.driver.detach_volume(ctxt, volume))
+        self.assertIsNone(self.driver.detach_volume(ctxt, testvol))
 
     def test_detach_volume_fails(self):
-        self.mock_api.side_effect = datc.DateraAPIException
+        testvol = _stub_volume()
+        self.driver.cvol_to_ai = mock.MagicMock()
+        aimock = mock.MagicMock()
+        aimock.set.side_effect = DateraAPIException
+        self.driver.cvol_to_ai.return_value = aimock
         ctxt = context.get_admin_context()
-        volume = _stub_volume(status='in-use')
-        self.assertRaises(datc.DateraAPIException,
-                          self.driver.detach_volume, ctxt, volume)
+        self.assertRaises(DateraAPIException,
+                          self.driver.detach_volume,
+                          ctxt, testvol)
 
     def test_detach_volume_not_found(self):
-        if self._apiv == '2':
-            self.mock_api.side_effect = exception.NotFound
-        else:
-            self.mock_api.side_effect = [
-                self._generate_fake_api_request("tenant"),
-                exception.NotFound,
-                self._generate_fake_api_request()(
-                    "acl_policy", api_version=self._apiv, tenant=self._tenant),
-                self._generate_fake_api_request()(
-                    "ig_group", api_version=self._apiv, tenant=self._tenant),
-                {},
-                {},
-                {},
-                {}]
+        testvol = _stub_volume()
+        self.driver.cvol_to_ai = mock.MagicMock()
+        aimock = mock.MagicMock()
+        aimock.set.side_effect = exception.NotFound
+        self.driver.cvol_to_ai.return_value = aimock
         ctxt = context.get_admin_context()
-        volume = _stub_volume(status='in-use')
-        self.assertIsNone(self.driver.detach_volume(ctxt, volume))
+        self.assertIsNone(self.driver.detach_volume(ctxt, testvol))
 
     def test_create_snapshot_success(self):
-        snapshot = _stub_snapshot(volume_id=self.volume['id'])
-        self.mock_api.side_effect = self._generate_fake_api_request()
-        self.assertIsNone(self.driver.create_snapshot(snapshot))
+        testsnap = _stub_snapshot(volume_id=str(uuid.uuid4()))
+        volmock = mock.MagicMock()
+        snapmock = mock.MagicMock()
+        snapmock.reload.return_value = snapmock
+        snapmock.uuid = testsnap['id']
+        snapmock.op_state = "available"
+        volmock.snapshots.create.return_value = snapmock
+        self.driver.cvol_to_dvol = mock.MagicMock()
+        self.driver.cvol_to_dvol.return_value = volmock
+        self.assertIsNone(self.driver.create_snapshot(testsnap))
 
     def test_create_snapshot_fails(self):
-        self.mock_api.side_effect = datc.DateraAPIException
-        snapshot = _stub_snapshot(volume_id=self.volume['id'])
-        self.assertRaises(datc.DateraAPIException,
-                          self.driver.create_snapshot, snapshot)
+        testsnap = _stub_snapshot(volume_id=str(uuid.uuid4()))
+        self.driver.api.app_instances.list.side_effect = DateraAPIException
+        self.assertRaises(DateraAPIException,
+                          self.driver.create_snapshot,
+                          testsnap)
 
     def test_delete_snapshot_success(self):
-        if self._apiv == '2':
-            self.mock_api.return_value = stub_return_snapshots
-        else:
-            self.mock_api.return_value = stub_return_snapshots_21
-        snapshot = _stub_snapshot(volume_id=self.volume['id'])
-        self.assertIsNone(self.driver.delete_snapshot(snapshot))
+        testsnap = _stub_snapshot(volume_id=str(uuid.uuid4()))
+        self.assertIsNone(self.driver.delete_snapshot(testsnap))
 
     def test_delete_snapshot_not_found(self):
-        if self._apiv == '2':
-            self.mock_api.side_effect = [
-                stub_return_snapshots,
-                exception.NotFound]
-        else:
-            self.mock_api.side_effect = [
-                self._generate_fake_api_request("tenant"),
-                stub_return_snapshots_21,
-                exception.NotFound]
-        snapshot = _stub_snapshot(self.volume['id'], volume_id="test")
-        self.assertIsNone(self.driver.delete_snapshot(snapshot))
+        testsnap = _stub_snapshot(volume_id=str(uuid.uuid4()))
+        self.driver.cvol_to_dvol = mock.MagicMock()
+        aimock = mock.MagicMock()
+        aimock.snapshots.list.side_effect = exception.NotFound
+        self.driver.cvol_to_dvol.return_value = aimock
+        self.assertIsNone(self.driver.delete_snapshot(testsnap))
 
     def test_delete_snapshot_fails(self):
-        self.mock_api.side_effect = datc.DateraAPIException
-        snapshot = _stub_snapshot(volume_id=self.volume['id'])
-        self.assertRaises(datc.DateraAPIException,
-                          self.driver.delete_snapshot, snapshot)
+        testsnap = _stub_snapshot(volume_id=str(uuid.uuid4()))
+        self.driver.cvol_to_dvol = mock.MagicMock()
+        aimock = mock.MagicMock()
+        aimock.snapshots.list.side_effect = DateraAPIException
+        self.driver.cvol_to_dvol.return_value = aimock
+        self.assertRaises(DateraAPIException,
+                          self.driver.delete_snapshot,
+                          testsnap)
 
     def test_create_volume_from_snapshot_success(self):
-        snapshot = _stub_snapshot(volume_id=self.volume['id'])
-        if self._apiv == '2':
-            self.mock_api.side_effect = [
-                stub_return_snapshots,
-                list(stub_return_snapshots.values())[0],
-                None]
-        else:
-            self.mock_api.side_effect = [
-                self._generate_fake_api_request("tenant"),
-                stub_return_snapshots_21,
-                {'data': stub_return_snapshots_21['data'][0]},
-                None]
-        self.assertIsNone(
-            self.driver.create_volume_from_snapshot(self.volume, snapshot))
-
-    @mock.patch.object(datera.DateraDriver, 'extend_volume')
-    def test_create_volume_from_snapshot_success_larger(self, mock_extend):
-        snapshot = _stub_snapshot(volume_id=self.volume['id'])
-        extend_volume = _stub_volume(size=2)
-
-        mock_extend = mock.Mock()
-        if self._apiv == '2':
-            self.driver._extend_volume_2 = mock_extend
-            self.mock_api.side_effect = [
-                stub_return_snapshots,
-                list(stub_return_snapshots.values())[0],
-                None]
-            self.driver.create_volume_from_snapshot(extend_volume, snapshot)
-            mock_extend.assert_called_once_with(extend_volume,
-                                                extend_volume['size'])
-        else:
-            self.driver._extend_volume_2_1 = mock_extend
-            self.mock_api.side_effect = [
-                self._generate_fake_api_request("tenant"),
-                stub_return_snapshots_21,
-                {'data': stub_return_snapshots_21['data'][0]},
-                None]
-            self.driver.create_volume_from_snapshot(extend_volume, snapshot)
-            mock_extend.assert_called_once_with(extend_volume,
-                                                extend_volume['size'])
+        testsnap = _stub_snapshot(volume_id=str(uuid.uuid4()))
+        testvol = _stub_volume()
+        volmock = mock.MagicMock()
+        snapmock = mock.MagicMock()
+        snapmock.reload.return_value = snapmock
+        snapmock.uuid = testsnap['id']
+        snapmock.op_state = "available"
+        self.driver.cvol_to_dvol = mock.MagicMock()
+        self.driver.cvol_to_dvol.return_value = volmock
+        volmock.snapshots.list.return_value = [snapmock]
+        self.assertIsNone(self.driver.create_volume_from_snapshot(
+            testvol, testsnap))
 
     def test_create_volume_from_snapshot_fails(self):
-        self.mock_api.side_effect = datc.DateraAPIException
-        snapshot = _stub_snapshot(volume_id=self.volume['id'])
-        self.assertRaises(datc.DateraAPIException,
-                          self.driver.create_volume_from_snapshot, self.volume,
-                          snapshot)
+        testsnap = _stub_snapshot(volume_id=str(uuid.uuid4()))
+        testvol = _stub_volume()
+        self.driver.cvol_to_dvol = mock.MagicMock()
+        aimock = mock.MagicMock()
+        aimock.snapshots.list.side_effect = DateraAPIException
+        self.driver.cvol_to_dvol.return_value = aimock
+        self.assertRaises(DateraAPIException,
+                          self.driver.create_volume_from_snapshot,
+                          testvol,
+                          testsnap)
 
     def test_extend_volume_success(self):
-        volume = _stub_volume(size=1)
-        self.mock_api.side_effect = [
-            stub_get_export,
-            {'data': stub_get_export},
-            self._generate_fake_api_request()(
-                "acl_policy", api_version=self._apiv, tenant=self._tenant),
-            self._generate_fake_api_request()(
-                "ig_group", api_version=self._apiv, tenant=self._tenant),
-            self._generate_fake_api_request()(
-                "acl_policy", api_version=self._apiv, tenant=self._tenant),
-            {}, {}, {}, {}, {}, {}, stub_get_export,
-            {'data': stub_get_export}]
-        self.assertIsNone(self.driver.extend_volume(volume, 2))
+        newsize = 2
+        testvol = _stub_volume()
+        mockvol = mock.MagicMock()
+        mockvol.size = newsize
+        self.driver.cvol_to_dvol = mock.MagicMock()
+        self.driver.cvol_to_dvol.return_value = mockvol
+        self.driver._offline_flip_2_2 = mock.MagicMock()
+        self.driver._offline_flip_2_1 = mock.MagicMock()
+        self.assertIsNone(self.driver.extend_volume(testvol, newsize))
 
     def test_extend_volume_fails(self):
-        self.mock_api.side_effect = datc.DateraAPIException
-        volume = _stub_volume(size=1)
-        self.assertRaises(datc.DateraAPIException,
-                          self.driver.extend_volume, volume, 2)
-
-    def test_login_successful(self):
-        self.mock_api.return_value = {
-            'key': 'dd2469de081346c28ac100e071709403'
-        }
-        self.assertIsNone(self.driver.login())
-        self.assertEqual(1, self.mock_api.call_count)
-
-    def test_login_unsuccessful(self):
-        self.mock_api.side_effect = exception.NotAuthorized
-        self.assertRaises(exception.NotAuthorized, self.driver.login)
-        self.assertEqual(1, self.mock_api.call_count)
+        newsize = 2
+        testvol = _stub_volume()
+        mockvol = mock.MagicMock()
+        mockvol.size = newsize
+        mockvol.set.side_effect = DateraAPIException
+        self.driver.cvol_to_dvol = mock.MagicMock()
+        self.driver.cvol_to_dvol.return_value = mockvol
+        self.driver._offline_flip_2_2 = mock.MagicMock()
+        self.driver._offline_flip_2_1 = mock.MagicMock()
+        self.assertRaises(DateraAPIException,
+                          self.driver.extend_volume,
+                          testvol,
+                          newsize)
 
     def test_manage_existing(self):
-        self.mock_api.return_value = {}
-        if self._apiv == '2':
-            test_name = {"source-name": "test-app:test-si:test-vol"}
-            self.assertIsNone(
-                self.driver.manage_existing(
-                    _stub_volume(),
-                    test_name))
-            self.mock_api.assert_called_with(
-                URL_TEMPLATES['ai_inst']().format(
-                    test_name["source-name"].split(":")[0]),
-                method='put',
-                body={'name': OS_PREFIX + _stub_volume()['id']},
-                api_version=self._apiv)
-        else:
-            tenant = 'tenant'
-            test_name = {"source-name": "{}:test-app:test-si:test-vol".format(
-                tenant)}
-            self.assertIsNone(
-                self.driver.manage_existing(
-                    _stub_volume(),
-                    test_name))
-            self.mock_api.assert_called_with(
-                URL_TEMPLATES['ai_inst']().format(
-                    test_name["source-name"].split(":")[1]),
-                method='put',
-                body={'name': OS_PREFIX + _stub_volume()['id']},
-                api_version=self._apiv,
-                tenant='tenant')
+        existing_ref = {'source-name': "A:B:C:D"}
+        testvol = _stub_volume()
+        self.driver.cvol_to_ai = mock.MagicMock()
+        self.assertIsNone(self.driver.manage_existing(testvol, existing_ref))
 
     def test_manage_existing_wrong_ref(self):
-        TEST_NAME = {"source-name": "incorrect-reference"}
-        self.assertRaises(
-            exception.ManageExistingInvalidReference,
-            self.driver.manage_existing,
-            _stub_volume(),
-            TEST_NAME)
+        existing_ref = {'source-name': "ABCD"}
+        testvol = _stub_volume()
+        self.driver.cvol_to_ai = mock.MagicMock()
+        self.assertRaises(exception.ManageExistingInvalidReference,
+                          self.driver.manage_existing,
+                          testvol,
+                          existing_ref)
 
     def test_manage_existing_get_size(self):
-        TEST_NAME = {"source-name": "test-app:storage-1:volume-1"}
-        self.mock_api.side_effect = self._generate_fake_api_request()
-        self.assertEqual(
-            self.driver.manage_existing_get_size(
-                _stub_volume(),
-                TEST_NAME), 500)
-        if self._apiv == '2':
-            self.mock_api.assert_called_with(
-                URL_TEMPLATES['ai_inst']().format(
-                    TEST_NAME["source-name"].split(":")[0]),
-                api_version=self._apiv)
-        else:
-            self.mock_api.assert_called_with(
-                URL_TEMPLATES['ai_inst']().format(
-                    TEST_NAME["source-name"].split(":")[0]),
-                api_version=self._apiv,
-                tenant=self._tenant)
+        existing_ref = {'source-name': "A:B:C:D"}
+        testvol = _stub_volume()
+        volmock = mock.MagicMock()
+        volmock.size = testvol['size']
+        self.driver.cvol_to_dvol = mock.MagicMock()
+        self.driver.cvol_to_dvol.return_value = volmock
+        self.assertEqual(self.driver.manage_existing_get_size(
+            testvol, existing_ref), testvol['size'])
 
     def test_manage_existing_get_size_wrong_ref(self):
-        TEST_NAME = {"source-name": "incorrect-reference"}
-        self.assertRaises(
-            exception.ManageExistingInvalidReference,
-            self.driver.manage_existing_get_size,
-            _stub_volume(),
-            TEST_NAME)
+        existing_ref = {'source-name': "ABCD"}
+        testvol = _stub_volume()
+        self.driver.cvol_to_ai = mock.MagicMock()
+        self.assertRaises(exception.ManageExistingInvalidReference,
+                          self.driver.manage_existing_get_size,
+                          testvol,
+                          existing_ref)
 
     def test_get_manageable_volumes(self):
-        if self._apiv == '2':
-            self.mock_api.return_value = non_cinder_ais
-            six.assertCountEqual(
-                self,
+        testvol = _stub_volume()
+        v1 = {'reference': {'source-name': 'some-ai:storage-1:volume-1'},
+              'size': 1,
+              'safe_to_manage': True,
+              'reason_not_safe': '',
+              'cinder_id': None,
+              'extra_info': {'snapshots': '[]'}}
+        v2 = {'reference': {'source-name': 'some-other-ai:storage-1:volume-1'},
+              'size': 2,
+              'safe_to_manage': True,
+              'reason_not_safe': '',
+              'cinder_id': None,
+              'extra_info': {'snapshots': '[]'}}
+
+        mock1 = mock.MagicMock()
+        mock1.__getitem__.side_effect = ['some-ai']
+        mock1.name = 'some-ai'
+        mocksi1 = mock.MagicMock()
+        mocksi1.name = "storage-1"
+        mocksi1.__getitem__.side_effect = [[mock.MagicMock()]]
+        mock1.storage_instances.list.return_value = [mocksi1]
+        mockvol1 = mock.MagicMock()
+        mockvol1.name = "volume-1"
+        mockvol1.size = v1['size']
+        mocksi1.volumes.list.return_value = [mockvol1]
+
+        mock2 = mock.MagicMock()
+        mock2.__getitem__.side_effect = ['some-other-ai']
+        mock2.name = 'some-other-ai'
+        mocksi2 = mock.MagicMock()
+        mocksi2.name = "storage-1"
+        mocksi2.__getitem__.side_effect = [[mock.MagicMock()]]
+        mock2.storage_instances.list.return_value = [mocksi2]
+        mockvol2 = mock.MagicMock()
+        mockvol2.name = "volume-1"
+        mockvol2.size = v2['size']
+        mocksi2.volumes.list.return_value = [mockvol2]
+
+        listmock = mock.MagicMock()
+        listmock.return_value = [mock1, mock2]
+        self.driver.api.app_instances.list = listmock
+
+        marker = mock.MagicMock()
+        limit = mock.MagicMock()
+        offset = mock.MagicMock()
+        sort_keys = mock.MagicMock()
+        sort_dirs = mock.MagicMock()
+        if (version.version_string() >= '15.0.0'):
+            with mock.patch(
+                    'cinder.volume.volume_utils.paginate_entries_list') \
+                    as mpage:
                 self.driver.get_manageable_volumes(
-                    {}, "", 10, 0, "", ""),
-                [{'cinder_id': None,
-                  'extra_info': None,
-                  'reason_not_safe': None,
-                  'reference': {
-                      "source-name": 'test-app-inst:storage-1:volume-1'},
-                  'safe_to_manage': True,
-                  'size': 50},
-                 {'cinder_id': 'c20aba21-6ef6-446b-b374-45733b4883ba',
-                  'extra_info': None,
-                  'reason_not_safe': None,
-                  'reference': None,
-                  'safe_to_manage': False,
-                  'size': None}])
+                    [testvol], marker, limit, offset, sort_keys, sort_dirs)
+                mpage.assert_called_once_with(
+                    [v1, v2], marker, limit, offset, sort_keys, sort_dirs)
         else:
-            self.mock_api.return_value = non_cinder_ais_21
-            self.assertEqual(
+            with mock.patch(
+                    'cinder.volume.utils.paginate_entries_list') as mpage:
                 self.driver.get_manageable_volumes(
-                    {}, "", 10, 0, "", ""),
-                [{'cinder_id': None,
-                  'extra_info': None,
-                  'reason_not_safe': '',
-                  'reference': {
-                      "source-name": 'test-app-inst:storage-1:volume-1'},
-                  'safe_to_manage': True,
-                  'size': 50},
-                 {'cinder_id': 'c20aba21-6ef6-446b-b374-45733b4883ba',
-                  'extra_info': None,
-                  'reason_not_safe': '',
-                  'reference': None,
-                  'safe_to_manage': False,
-                  'size': None}])
+                    [testvol], marker, limit, offset, sort_keys, sort_dirs)
+                mpage.assert_called_once_with(
+                    [v1, v2], marker, limit, offset, sort_keys, sort_dirs)
 
     def test_unmanage(self):
-        self.mock_api.return_value = {}
-        self.assertIsNone(self.driver.unmanage(_stub_volume()))
-        if self._apiv == '2':
-            self.mock_api.assert_called_with(
-                URL_TEMPLATES['ai_inst']().format(
-                    OS_PREFIX + _stub_volume()['id']),
-                method='put',
-                body={'name': UNMANAGE_PREFIX + _stub_volume()['id']},
-                api_version=self._apiv)
-        else:
-            self.mock_api.assert_called_with(
-                URL_TEMPLATES['ai_inst']().format(
-                    OS_PREFIX + _stub_volume()['id']),
-                method='put',
-                body={'name': UNMANAGE_PREFIX + _stub_volume()['id']},
-                api_version=self._apiv,
-                tenant=self._tenant)
-
-    def _generate_fake_api_request(self, targets_exist=True):
-        def _fake_api_request(resource_type, *args, **kwargs):
-            if 'api_version' not in kwargs:
-                raise ValueError("Fix me dummy")
-            result = None
-            if resource_type.split('/')[-1] == 'storage-1':
-                result = stub_get_export
-            elif (resource_type.split('/')[-1] ==
-                    'c20aba21-6ef6-446b-b374-45733b4883ba'):
-                result = stub_app_instance[
-                    'c20aba21-6ef6-446b-b374-45733b4883ba']
-            elif resource_type == 'acl_policy':
-                result = stub_acl if self._apiv == '2' else stub_acl_21
-            elif resource_type == 'ig_group':
-                result = stub_ig if self._apiv == '2' else stub_ig_21
-            elif resource_type.split('/')[-1] == 'snapshots':
-                result = {'timestamp': 'test_ts'}
-            elif resource_type.split('/')[-1] == 'test_ts':
-                result = {'op_state': 'available'}
-            elif resource_type == 'tenant':
-                return {}
-            else:
-                if kwargs.get('api_version') == '2':
-                    result = list(stub_app_instance.values())[0]
-                else:
-                    result = stub_app_instance_21['data']
-
-            if kwargs.get('api_version') == '2':
-                return result
-            else:
-                return {'data': result}
-        return _fake_api_request
+        testvol = _stub_volume()
+        self.assertIsNone(self.driver.unmanage(testvol))
 
 
-class DateraVolumeTestCasev21(DateraVolumeTestCasev2):
+class DateraVolumeTestCasev21(DateraVolumeTestCasev22):
 
     def setUp(self):
         super(DateraVolumeTestCasev21, self).setUp()
-
-        m = mock.Mock()
-        m.json.return_value = {'api_versions': ['v2.1']}
-        self.driver._request.return_value = m
-        self.driver._store_metadata = mock.Mock()
-        self._apiv = '2.1'
-        self._tenant = self.cfg.datera_tenant_id
-
-
-stub_acl = {
-    'initiator_groups': [
-        '/initiator_groups/IG-8739f309-dae9-4534-aa02-5b8e9e96eefd'],
-    'initiators': [],
-    'path': ('/app_instances/8739f309-dae9-4534-aa02-5b8e9e96eefd/'
-             'storage_instances/storage-1/acl_policy')}
-
-stub_acl_21 = {
-    'initiator_groups': [
-        {'path': '/initiator_groups/IG-8739f309-dae9-4534-aa02-5b8e9e96eefd'}],
-    'initiators': [],
-    'path': ('/app_instances/8739f309-dae9-4534-aa02-5b8e9e96eefd/'
-             'storage_instances/storage-1/acl_policy')}
-
-stub_ig = {
-    'members': ['/initiators/iqn.1993-08.org.debian:01:ed22de8d75c0'],
-    'name': 'IG-21e08155-8b95-4108-b148-089f64623963',
-    'path': '/initiator_groups/IG-21e08155-8b95-4108-b148-089f64623963'}
-
-stub_ig_21 = {
-    'members': [
-        {'path': '/initiators/iqn.1993-08.org.debian:01:ed22de8d75c0'}],
-    'name': 'IG-21e08155-8b95-4108-b148-089f64623963',
-    'path': '/initiator_groups/IG-21e08155-8b95-4108-b148-089f64623963'}
-
-stub_create_export = {
-    "_ipColl": ["172.28.121.10", "172.28.120.10"],
-    "acls": {},
-    "activeServers": {"4594953e-f97f-e111-ad85-001e6738c0f0": "1"},
-    "ctype": "TC_BLOCK_ISCSI",
-    "endpointsExt1": {
-        "4594953e-f97f-e111-ad85-001e6738c0f0": {
-            "ipHigh": 0,
-            "ipLow": "192421036",
-            "ipStr": "172.28.120.11",
-            "ipV": 4,
-            "name": "",
-            "network": 24
-        }
-    },
-    "endpointsExt2": {
-        "4594953e-f97f-e111-ad85-001e6738c0f0": {
-            "ipHigh": 0,
-            "ipLow": "192486572",
-            "ipStr": "172.28.121.11",
-            "ipV": 4,
-            "name": "",
-            "network": 24
-        }
-    },
-    "inodes": {"c20aba21-6ef6-446b-b374-45733b4883ba": "1"},
-    "name": "",
-    "networkPort": 0,
-    "serverAllocation": "TS_ALLOC_COMPLETED",
-    "servers": {"4594953e-f97f-e111-ad85-001e6738c0f0": "1"},
-    "targetAllocation": "TS_ALLOC_COMPLETED",
-    "targetIds": {
-        "4594953e-f97f-e111-ad85-001e6738c0f0": {
-            "ids": [{
-                "dev": None,
-                "id": "iqn.2013-05.com.daterainc::01:sn:fc372bc0490b2dbe"
-            }]
-        }
-    },
-    "typeName": "TargetIscsiConfig",
-    "uuid": "7071efd7-9f22-4996-8f68-47e9ab19d0fd"
-}
-
-
-stub_app_instance = {
-    "c20aba21-6ef6-446b-b374-45733b4883ba": {
-        "admin_state": "online",
-        "clone_src": {},
-        "create_mode": "openstack",
-        "descr": "",
-        "health": "ok",
-        "name": "c20aba21-6ef6-446b-b374-45733b4883ba",
-        "path": "/app_instances/c20aba21-6ef6-446b-b374-45733b4883ba",
-        "storage_instances": {
-            "storage-1": {
-                "access": {
-                    "ips": [
-                        "172.28.41.63"
-                    ],
-                    "iqn": "iqn.2013-05.com.daterainc:tc:01:sn:"
-                           "3bbb080aab7d9abc",
-                    "path": "/app_instances/c20aba21-6ef6-446b-b374"
-                            "-45733b4883ba/storage_instances/storage-1/access"
-                },
-                "access_control": {
-                    "initiator_groups": [],
-                    "initiators": [],
-                    "path": "/app_instances/c20aba21-6ef6-446b-b374-"
-                            "45733b4883ba/storage_instances/storage-1"
-                            "/access_control"
-                },
-                "access_control_mode": "allow_all",
-                "active_initiators": [],
-                "active_storage_nodes": [
-                    "/storage_nodes/1c4feac4-17c7-478b-8928-c76e8ec80b72"
-                ],
-                "admin_state": "online",
-                "auth": {
-                    "initiator_pswd": "",
-                    "initiator_user_name": "",
-                    "path": "/app_instances/c20aba21-6ef6-446b-b374-"
-                            "45733b4883ba/storage_instances/storage-1/auth",
-                    "target_pswd": "",
-                    "target_user_name": "",
-                    "type": "none"
-                },
-                "creation_type": "user",
-                "descr": "c20aba21-6ef6-446b-b374-45733b4883ba__ST__storage-1",
-                "op_state": "available",
-                "name": "storage-1",
-                "path": "/app_instances/c20aba21-6ef6-446b-b374-"
-                        "45733b4883ba/storage_instances/storage-1",
-                "uuid": "b9897b84-149f-43c7-b19c-27d6af8fa815",
-                "volumes": {
-                    "volume-1": {
-                        "capacity_in_use": 0,
-                        "name": "volume-1",
-                        "op_state": "available",
-                        "path": "/app_instances/c20aba21-6ef6-446b-b374-"
-                                "45733b4883ba/storage_instances/storage-1"
-                                "/volumes/volume-1",
-                        "replica_count": 3,
-                        "size": 500,
-                        "snapshot_policies": {},
-                        "snapshots": {
-                            "1445384931.322468627": {
-                                "op_state": "available",
-                                "path": "/app_instances/c20aba21-6ef6-446b"
-                                        "-b374-45733b4883ba/storage_instances"
-                                        "/storage-1/volumes/volume-1/snapshots"
-                                        "/1445384931.322468627",
-                                "uuid": "0bb34f0c-fea4-48e0-bf96-591120ac7e3c"
-                            }
-                        },
-                        "uuid": "c20aba21-6ef6-446b-b374-45733b4883ba"
-                    }
-                }
-            }
-        },
-        "uuid": "c20aba21-6ef6-446b-b374-45733b4883ba"
-    }
-}
-stub_app_instance_21 = {
-    "tenant": "/root",
-    "path": "/app_instances/1e52946a-5c77-45ed-8b4e-b46e7236a8eb",
-    "version": "v2.1",
-    "data": {
-        "tenant": "/root",
-        "path": "/app_instances/1e52946a-5c77-45ed-8b4e-b46e7236a8eb",
-        "name": "OS-9b0216bc-8aab-47f2-b746-843f497cb7a6",
-        "id": "1e52946a-5c77-45ed-8b4e-b46e7236a8eb",
-        "health": "ok",
-        "app_template": {
-            "path": "",
-            "resolved_path": "",
-            "resolved_tenant": ""
-        },
-        "descr": "",
-        "admin_state": "online",
-        "storage_instances": [
-            {
-                "health": "ok",
-                "path": "/app_instances/1e52946a-5c77-45ed-8b4e-b46e7236a8eb/"
-                "storage_instances/storage-1",
-                "name": "storage-1",
-                "admin_state": "online",
-                "op_state": "available",
-                "volumes": [
-                    {
-                        "path": "/app_instances/1e52946a-5c77-45ed-8b4e-"
-                                "b46e7236a8eb/"
-                        "storage_instances/storage-1/volumes/volume-1",
-                        "name": "volume-1",
-                        "replica_count": 1,
-                        "uuid": "9b0216bc-8aab-47f2-b746-843f497cb7a6",
-                        "size": 500,
-                        "capacity_in_use": 0,
-                        "snapshot_policies": [],
-                        "snapshots": [],
-                        "placement_mode": "hybrid",
-                        "op_state": "available",
-                        "active_storage_nodes": [
-                            {
-                                "path": "/storage_nodes/75f2cae4-68fb-4236-"
-                                        "a90c-b6c480b68816"
-                            }
-                        ],
-                        "health": "ok"
-                    }
-                ],
-                "access_control_mode": "deny_all",
-                "acl_policy": {
-                    "path": "/app_instances/1e52946a-5c77-45ed-8b4e-"
-                            "b46e7236a8eb/"
-                    "storage_instances/storage-1/acl_policy",
-                    "initiators": [],
-                    "initiator_groups": []
-                },
-                "ip_pool": {
-                    "path": "/access_network_ip_pools/default",
-                    "resolved_path": "/access_network_ip_pools/default",
-                    "resolved_tenant": "/root"
-                },
-                "access": {
-                    "path": "/app_instances/1e52946a-5c77-45ed-8b4e-"
-                            "b46e7236a8eb/"
-                    "storage_instances/storage-1/access",
-                    "ips": [
-                        "172.28.41.63",
-                        "172.29.41.29"
-                    ],
-                    "iqn": "iqn.2013-05.com.daterainc:tc:01:sn:"
-                           "3bbb080aab7d9abc"
-                },
-                "auth": {
-                    "path": "/app_instances/1e52946a-5c77-45ed-8b4e-"
-                            "b46e7236a8eb/"
-                    "storage_instances/storage-1/auth",
-                    "type": "none",
-                    "initiator_user_name": "",
-                    "initiator_pswd": "(hidden)",
-                    "target_user_name": "",
-                    "target_pswd": "(hidden)"
-                },
-                "active_initiators": [],
-                "active_storage_nodes": [
-                    {
-                        "path": "/storage_nodes/75f2cae4-68fb-4236-a90c-"
-                                "b6c480b68816"
-                    }
-                ],
-                "uuid": "eb3d7b07-b520-4cc2-b365-90135b84c356"
-            }
-        ],
-        "create_mode": "openstack",
-        "uuid": "9b0216bc-8aab-47f2-b746-843f497cb7a6",
-        "snapshots": [],
-        "snapshot_policies": []
-    }
-}
-
-stub_get_export = stub_app_instance[
-    'c20aba21-6ef6-446b-b374-45733b4883ba']['storage_instances']['storage-1']
-
-stub_single_ai = stub_app_instance['c20aba21-6ef6-446b-b374-45733b4883ba']
-
-stub_return_snapshots = \
-    {
-        "1446076293.118600738": {
-            "op_state": "available",
-            "path": "/app_instances/c20aba21-6ef6-446b-b374-45733b4883ba"
-            "/storage_instances/storage-1/volumes/volume-1/snapshots/"
-            "1446076293.118600738",
-            "uuid": "0bb34f0c-fea4-48e0-bf96-591120ac7e3c"
-        },
-        "1446076384.00607846": {
-            "op_state": "available",
-            "path": "/app_instances/c20aba21-6ef6-446b-b374-45733b4883ba"
-            "/storage_instances/storage-1/volumes/volume-1/snapshots/"
-            "1446076384.00607846",
-            "uuid": "25b4b959-c30a-45f2-a90c-84a40f34f0a1"
-        }
-    }
-
-stub_return_snapshots_21 = {
-    'data': [
-        {
-            "op_state": "available",
-            "path": "/app_instances/c20aba21-6ef6-446b-b374-45733b4883ba"
-            "/storage_instances/storage-1/volumes/volume-1/snapshots/",
-            "timestamp": "1446076293.118600738",
-            "utc_ts": "1446076293.118600738",
-            "uuid": "0bb34f0c-fea4-48e0-bf96-591120ac7e3c"
-        },
-        {
-            "op_state": "available",
-            "path": "/app_instances/c20aba21-6ef6-446b-b374-45733b4883ba"
-            "/storage_instances/storage-1/volumes/volume-1/snapshots/",
-            "timestamp": "1446076384.00607846",
-            "utc_ts": "1446076384.00607846",
-            "uuid": "25b4b959-c30a-45f2-a90c-84a40f34f0a1"
-        }]
-}
-
-non_cinder_ais = {
-    "75bc1c69-a399-4acb-aade-3514caf13c5e": {
-        "admin_state": "online",
-        "create_mode": "normal",
-        "descr": "",
-        "health": "ok",
-        "id": "75bc1c69-a399-4acb-aade-3514caf13c5e",
-        "name": "test-app-inst",
-        "path": "/app_instances/75bc1c69-a399-4acb-aade-3514caf13c5e",
-        "snapshot_policies": {},
-        "snapshots": {},
-        "storage_instances": {
-            "storage-1": {
-                "access": {
-                    "ips": [
-                        "172.28.41.93"
-                    ],
-                    "iqn": "iqn.2013-05.com.daterainc:tc:01:sn:"
-                           "29036682e2d37b98",
-                    "path": "/app_instances/75bc1c69-a399-4acb-aade-"
-                            "3514caf13c5e/storage_instances/storage-1/access"
-                },
-                "access_control_mode": "deny_all",
-                "acl_policy": {
-                    "initiator_groups": [],
-                    "initiators": [],
-                    "path": "/app_instances/75bc1c69-a399-4acb-aade-"
-                            "3514caf13c5e/storage_instances/storage-"
-                            "1/acl_policy"
-                },
-                "active_initiators": [],
-                "active_storage_nodes": [
-                    "/storage_nodes/78b350a8-43f2-453f-a257-8df76d7406b9"
-                ],
-                "admin_state": "online",
-                "auth": {
-                    "initiator_pswd": "(hidden)",
-                    "initiator_user_name": "",
-                    "path": "/app_instances/75bc1c69-a399-4acb-aade-"
-                            "3514caf13c5e/storage_instances/storage-1/auth",
-                    "target_pswd": "(hidden)",
-                    "target_user_name": "",
-                    "type": "none"
-                },
-                "creation_type": "user",
-                "ip_pool": "/access_network_ip_pools/default",
-                "name": "storage-1",
-                "op_state": "available",
-                "path": "/app_instances/75bc1c69-a399-4acb-aade-"
-                        "3514caf13c5e/storage_instances/storage-1",
-                "uuid": "6421237d-e4fc-433a-b535-148d5b6d8586",
-                "volumes": {
-                    "volume-1": {
-                        "capacity_in_use": 0,
-                        "name": "volume-1",
-                        "op_state": "available",
-                        "path": "/app_instances/75bc1c69-a399-4acb-aade-"
-                                "3514caf13c5e/storage_instances/storage-"
-                                "1/volumes/volume-1",
-                        "replica_count": 1,
-                        "size": 50,
-                        "snapshot_policies": {},
-                        "snapshots": {},
-                        "uuid": "e674d29c-a672-40d1-9577-abe3a504ffe9"
-                    }
-                }
-            }
-        },
-        "uuid": "00000000-0000-0000-0000-000000000000"
-    },
-    "dfdaf8d1-8976-4c13-a829-3345e03cf810": {
-        "admin_state": "offline",
-        "create_mode": "openstack",
-        "descr": "",
-        "health": "ok",
-        "id": "dfdaf8d1-8976-4c13-a829-3345e03cf810",
-        "name": "OS-c20aba21-6ef6-446b-b374-45733b4883ba",
-        "path": "/app_instances/dfdaf8d1-8976-4c13-a829-3345e03cf810",
-        "snapshot_policies": {},
-        "snapshots": {},
-        "storage_instances": {
-            "storage-1": {
-                "access": {
-                    "ips": [
-                        "172.28.41.57"
-                    ],
-                    "iqn": "iqn.2013-05.com.daterainc:tc:01:sn:"
-                           "56cd59e754ad02b6",
-                    "path": "/app_instances/dfdaf8d1-8976-4c13-a829-"
-                            "3345e03cf810/storage_instances/storage-1/access"
-                },
-                "access_control_mode": "deny_all",
-                "acl_policy": {
-                    "initiator_groups": [],
-                    "initiators": [],
-                    "path": "/app_instances/dfdaf8d1-8976-4c13-a829-"
-                            "3345e03cf810/storage_instances/storage-"
-                            "1/acl_policy"
-                },
-                "active_initiators": [],
-                "active_storage_nodes": [
-                    "/storage_nodes/78b350a8-43f2-453f-a257-8df76d7406b9"
-                ],
-                "admin_state": "offline",
-                "auth": {
-                    "initiator_pswd": "(hidden)",
-                    "initiator_user_name": "",
-                    "path": "/app_instances/dfdaf8d1-8976-4c13-a829-"
-                            "3345e03cf810/storage_instances/storage-1/auth",
-                    "target_pswd": "(hidden)",
-                    "target_user_name": "",
-                    "type": "none"
-                },
-                "creation_type": "user",
-                "ip_pool": "/access_network_ip_pools/default",
-                "name": "storage-1",
-                "op_state": "unavailable",
-                "path": "/app_instances/dfdaf8d1-8976-4c13-a829-3345e03cf810"
-                        "/storage_instances/storage-1",
-                "uuid": "5620a673-9985-464e-9616-e325a50eac60",
-                "volumes": {
-                    "volume-1": {
-                        "capacity_in_use": 0,
-                        "name": "volume-1",
-                        "op_state": "available",
-                        "path": "/app_instances/dfdaf8d1-8976-4c13-a829-"
-                                "3345e03cf810/storage_instances/storage-"
-                                "1/volumes/volume-1",
-                        "replica_count": 1,
-                        "size": 5,
-                        "snapshot_policies": {},
-                        "snapshots": {},
-                        "uuid": "c20aba21-6ef6-446b-b374-45733b4883ba"
-                    }
-                }
-            }
-        },
-        "uuid": "c20aba21-6ef6-446b-b374-45733b4883ba"
-    }
-}
-
-non_cinder_ais_21 = {
-    'data': [{
-        "admin_state": "online",
-        "create_mode": "normal",
-        "descr": "",
-        "health": "ok",
-        "id": "75bc1c69-a399-4acb-aade-3514caf13c5e",
-        "name": "test-app-inst",
-        "path": "/app_instances/75bc1c69-a399-4acb-aade-3514caf13c5e",
-        "snapshot_policies": {},
-        "snapshots": {},
-        "storage_instances": {
-            "storage-1": {
-                "access": {
-                    "ips": [
-                        "172.28.41.93"
-                    ],
-                    "iqn": "iqn.2013-05.com.daterainc:tc:01:sn:"
-                           "29036682e2d37b98",
-                    "path": "/app_instances/75bc1c69-a399-4acb-aade-"
-                            "3514caf13c5e/storage_instances/storage-1/access"
-                },
-                "access_control_mode": "deny_all",
-                "acl_policy": {
-                    "initiator_groups": [],
-                    "initiators": [],
-                    "path": "/app_instances/75bc1c69-a399-4acb-aade-"
-                            "3514caf13c5e/storage_instances/storage-"
-                            "1/acl_policy"
-                },
-                "active_initiators": [],
-                "active_storage_nodes": [
-                    "/storage_nodes/78b350a8-43f2-453f-a257-8df76d7406b9"
-                ],
-                "admin_state": "online",
-                "auth": {
-                    "initiator_pswd": "(hidden)",
-                    "initiator_user_name": "",
-                    "path": "/app_instances/75bc1c69-a399-4acb-aade-"
-                            "3514caf13c5e/storage_instances/storage-1/auth",
-                    "target_pswd": "(hidden)",
-                    "target_user_name": "",
-                    "type": "none"
-                },
-                "creation_type": "user",
-                "ip_pool": "/access_network_ip_pools/default",
-                "name": "storage-1",
-                "op_state": "available",
-                "path": "/app_instances/75bc1c69-a399-4acb-aade-"
-                        "3514caf13c5e/storage_instances/storage-1",
-                "uuid": "6421237d-e4fc-433a-b535-148d5b6d8586",
-                "volumes": {
-                    "volume-1": {
-                        "capacity_in_use": 0,
-                        "name": "volume-1",
-                        "op_state": "available",
-                        "path": "/app_instances/75bc1c69-a399-4acb-aade-"
-                                "3514caf13c5e/storage_instances/storage-"
-                                "1/volumes/volume-1",
-                        "replica_count": 1,
-                        "size": 50,
-                        "snapshot_policies": {},
-                        "snapshots": {},
-                        "uuid": "e674d29c-a672-40d1-9577-abe3a504ffe9"
-                    }
-                }
-            }
-        },
-        "uuid": "00000000-0000-0000-0000-000000000000"
-    },
-        {
-        "admin_state": "offline",
-        "create_mode": "openstack",
-        "descr": "",
-        "health": "ok",
-        "id": "dfdaf8d1-8976-4c13-a829-3345e03cf810",
-        "name": "OS-c20aba21-6ef6-446b-b374-45733b4883ba",
-        "path": "/app_instances/dfdaf8d1-8976-4c13-a829-3345e03cf810",
-        "snapshot_policies": {},
-        "snapshots": {},
-        "storage_instances": {
-            "storage-1": {
-                "access": {
-                    "ips": [
-                        "172.28.41.57"
-                    ],
-                    "iqn": "iqn.2013-05.com.daterainc:tc:01:sn:"
-                           "56cd59e754ad02b6",
-                    "path": "/app_instances/dfdaf8d1-8976-4c13-a829-"
-                            "3345e03cf810/storage_instances/storage-1/access"
-                },
-                "access_control_mode": "deny_all",
-                "acl_policy": {
-                    "initiator_groups": [],
-                    "initiators": [],
-                    "path": "/app_instances/dfdaf8d1-8976-4c13-a829-"
-                            "3345e03cf810/storage_instances/storage-"
-                            "1/acl_policy"
-                },
-                "active_initiators": [],
-                "active_storage_nodes": [
-                    "/storage_nodes/78b350a8-43f2-453f-a257-8df76d7406b9"
-                ],
-                "admin_state": "offline",
-                "auth": {
-                    "initiator_pswd": "(hidden)",
-                    "initiator_user_name": "",
-                    "path": "/app_instances/dfdaf8d1-8976-4c13-a829-"
-                            "3345e03cf810/storage_instances/storage-1/auth",
-                    "target_pswd": "(hidden)",
-                    "target_user_name": "",
-                    "type": "none"
-                },
-                "creation_type": "user",
-                "ip_pool": "/access_network_ip_pools/default",
-                "name": "storage-1",
-                "op_state": "unavailable",
-                "path": "/app_instances/dfdaf8d1-8976-4c13-a829-3345e03cf810"
-                        "/storage_instances/storage-1",
-                "uuid": "5620a673-9985-464e-9616-e325a50eac60",
-                "volumes": {
-                    "volume-1": {
-                        "capacity_in_use": 0,
-                        "name": "volume-1",
-                        "op_state": "available",
-                        "path": "/app_instances/dfdaf8d1-8976-4c13-a829-"
-                                "3345e03cf810/storage_instances/storage-"
-                                "1/volumes/volume-1",
-                        "replica_count": 1,
-                        "size": 5,
-                        "snapshot_policies": {},
-                        "snapshots": {},
-                        "uuid": "c20aba21-6ef6-446b-b374-45733b4883ba"
-                    }
-                }
-            }
-        },
-        "uuid": "c20aba21-6ef6-446b-b374-45733b4883ba"
-    }]
-}
-
-
-def _stub_datera_volume(*args, **kwargs):
-    return {
-        "status": "available",
-        "name": "test",
-        "num_replicas": "2",
-        "parent": "00000000-0000-0000-0000-000000000000",
-        "size": "1024",
-        "sub_type": "IS_ORIGINAL",
-        "uuid": "10305aa4-1343-4363-86fe-f49eb421a48c",
-        "snapshots": [],
-        "snapshot_configs": [],
-        "targets": [
-            kwargs.get('targets', "744e1bd8-d741-4919-86cd-806037d98c8a"),
-        ]
-    }
+        self.driver.api = mock.MagicMock()
+        self.driver.apiv = '2.1'
 
 
 def _stub_volume(*args, **kwargs):
-    uuid = u'c20aba21-6ef6-446b-b374-45733b4883ba'
-    name = u'volume-00000001'
+    uuid = 'c20aba21-6ef6-446b-b374-45733b4883ba'
+    name = 'volume-00000001'
     size = 1
     volume = {}
     volume['id'] = kwargs.get('id', uuid)
+    volume['project_id'] = "test-project"
     volume['display_name'] = kwargs.get('display_name', name)
     volume['size'] = kwargs.get('size', size)
     volume['provider_location'] = kwargs.get('provider_location', None)
@@ -1221,16 +474,13 @@ def _stub_volume(*args, **kwargs):
 
 
 def _stub_snapshot(*args, **kwargs):
-    uuid = u'0bb34f0c-fea4-48e0-bf96-591120ac7e3c'
-    name = u'snapshot-00000001'
-    size = 1
-    volume = {}
-    volume['id'] = kwargs.get('id', uuid)
-    volume['display_name'] = kwargs.get('display_name', name)
-    volume['volume_size'] = kwargs.get('size', size)
-    volume['volume_id'] = kwargs.get('volume_id', None)
-    return volume
-
-
-def _config_getter(*args, **kwargs):
-    return {}
+    uuid = '0bb34f0c-fea4-48e0-bf96-591120ac7e3c'
+    name = 'snapshot-00000001'
+    volume_size = 1
+    snap = {}
+    snap['id'] = kwargs.get('id', uuid)
+    snap['project_id'] = "test-project"
+    snap['display_name'] = kwargs.get('display_name', name)
+    snap['volume_id'] = kwargs.get('volume_id', None)
+    snap['volume_size'] = kwargs.get('volume_size', volume_size)
+    return snap
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_fujitsu_dx.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_fujitsu_dx.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_fujitsu_dx.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_fujitsu_dx.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,11 +14,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
-import six
 import tempfile
+from unittest import mock
 
 from oslo_utils import units
+import six
 
 from cinder import exception
 from cinder import test
@@ -26,6 +26,8 @@ from cinder.volume import configuration
 
 with mock.patch.dict('sys.modules', pywbem=mock.Mock()):
     from cinder.volume.drivers.fujitsu.eternus_dx \
+        import eternus_dx_cli
+    from cinder.volume.drivers.fujitsu.eternus_dx \
         import eternus_dx_common as dx_common
     from cinder.volume.drivers.fujitsu.eternus_dx \
         import eternus_dx_fc as dx_fc
@@ -43,6 +45,7 @@ CONF = """<?xml version='1.0' encoding='
 <EternusPassword>testpass</EternusPassword>
 <EternusISCSIIP>10.0.0.3</EternusISCSIIP>
 <EternusPool>abcd1234_TPP</EternusPool>
+<EternusPool>abcd1234_RG</EternusPool>
 <EternusSnapPool>abcd1234_OSVD</EternusSnapPool>
 </FUJITSU>"""
 
@@ -51,8 +54,19 @@ TEST_VOLUME = {
     'name': 'volume1',
     'display_name': 'volume1',
     'provider_location': None,
-    'volume_metadata': [],
+    'metadata': {},
+    'size': 1,
+    'host': 'controller@113#abcd1234_TPP'
+}
+
+TEST_VOLUME2 = {
+    'id': '98179912-2495-42e9-97f0-6a0d3511700a',
+    'name': 'volume2',
+    'display_name': 'volume2',
+    'provider_location': None,
+    'metadata': {},
     'size': 1,
+    'host': 'controller@113#abcd1234_RG'
 }
 
 TEST_SNAP = {
@@ -72,7 +86,8 @@ TEST_CLONE = {
     'project_id': 'project',
     'display_name': 'clone1',
     'display_description': 'volume created from snapshot',
-    'volume_metadata': [],
+    'metadata': {},
+    'host': 'controller@113#abcd1234_TPP'
 }
 
 ISCSI_INITIATOR = 'iqn.1993-08.org.debian:01:8261afe17e4c'
@@ -96,24 +111,76 @@ AUTH_PRIV = 'FUJITSU_AuthorizedPrivilege
 STOR_SYNC = 'FUJITSU_StorageSynchronized'
 PROT_CTRL_UNIT = 'CIM_ProtocolControllerForUnit'
 STORAGE_TYPE = 'abcd1234_TPP'
+STORAGE_TYPE2 = 'abcd1234_RG'
 LUNMASKCTRL_IDS = ['AFG0010_CM00CA00P00', 'AFG0011_CM01CA00P00']
 
 MAP_STAT = '0'
 VOL_STAT = '0'
 
 FAKE_CAPACITY = 1170368102400
+# Volume1 in pool abcd1234_TPP
 FAKE_LUN_ID1 = '600000E00D2A0000002A011500140000'
 FAKE_LUN_NO1 = '0x0014'
+# Snapshot1 in pool abcd1234_OSVD
 FAKE_LUN_ID2 = '600000E00D2A0000002A0115001E0000'
 FAKE_LUN_NO2 = '0x001E'
+# Volume2 in pool abcd1234_RG
+FAKE_LUN_ID3 = '600000E00D2800000028075301140000'
+FAKE_LUN_NO3 = '0x0114'
 FAKE_SYSTEM_NAME = 'ET603SA4621302115'
+# abcd1234_TPP pool
+FAKE_USEGB = 2.0
+# abcd1234_RG pool
+FAKE_USEGB2 = 1.0
+FAKE_POOLS = [{
+    'path': {'InstanceID': 'FUJITSU:TPP0004'},
+    'pool_name': 'abcd1234_TPP',
+    'useable_capacity_gb': (FAKE_CAPACITY / units.Gi) * 20 - FAKE_USEGB,
+    'multiattach': False,
+    'thick_provisioning_support': False,
+    'provisioned_capacity_gb': FAKE_USEGB,
+    'total_volumes': 2,
+    'thin_provisioning_support': True,
+    'free_capacity_gb': FAKE_CAPACITY / units.Gi - FAKE_USEGB,
+    'total_capacity_gb': FAKE_CAPACITY / units.Gi,
+    'max_over_subscription_ratio': '20.0',
+}, {
+    'path': {'InstanceID': 'FUJITSU:RSP0005'},
+    'pool_name': 'abcd1234_RG',
+    'useable_capacity_gb': FAKE_CAPACITY / units.Gi - FAKE_USEGB2,
+    'multiattach': False,
+    'thick_provisioning_support': True,
+    'provisioned_capacity_gb': FAKE_USEGB2,
+    'total_volumes': 1,
+    'thin_provisioning_support': False,
+    'free_capacity_gb': FAKE_CAPACITY / units.Gi - FAKE_USEGB2,
+    'total_capacity_gb': FAKE_CAPACITY / units.Gi,
+    'max_over_subscription_ratio': 1,
+}]
 
 FAKE_STATS = {
+    'driver_version': '1.3.0',
+    'storage_protocol': 'iSCSI',
     'vendor_name': 'FUJITSU',
-    'total_capacity_gb': FAKE_CAPACITY / units.Gi,
-    'free_capacity_gb': FAKE_CAPACITY / units.Gi,
+    'QoS_support': False,
+    'volume_backend_name': 'volume_backend_name',
+    'shared_targets': True,
+    'backend_state': 'up',
+    'pools': FAKE_POOLS,
+}
+FAKE_STATS2 = {
+    'driver_version': '1.3.0',
+    'storage_protocol': 'FC',
+    'vendor_name': 'FUJITSU',
+    'QoS_support': False,
+    'volume_backend_name': 'volume_backend_name',
+    'shared_targets': True,
+    'backend_state': 'up',
+    'pools': FAKE_POOLS,
 }
 
+
+# Volume1 in pool abcd1234_TPP
 FAKE_KEYBIND1 = {
     'CreationClassName': 'FUJITSU_StorageVolume',
     'SystemName': STORAGE_SYSTEM,
@@ -121,11 +188,27 @@ FAKE_KEYBIND1 = {
     'SystemCreationClassName': 'FUJITSU_StorageComputerSystem',
 }
 
+# Volume2 in pool abcd1234_RG
+FAKE_KEYBIND3 = {
+    'CreationClassName': 'FUJITSU_StorageVolume',
+    'SystemName': STORAGE_SYSTEM,
+    'DeviceID': FAKE_LUN_ID3,
+    'SystemCreationClassName': 'FUJITSU_StorageComputerSystem',
+}
+
+# Volume1
 FAKE_LOCATION1 = {
     'classname': 'FUJITSU_StorageVolume',
     'keybindings': FAKE_KEYBIND1,
 }
 
+# Volume2
+FAKE_LOCATION3 = {
+    'classname': 'FUJITSU_StorageVolume',
+    'keybindings': FAKE_KEYBIND3,
+}
+
+# Volume1 metadata info.
 FAKE_LUN_META1 = {
     'FJ_Pool_Type': 'Thinporvisioning_POOL',
     'FJ_Volume_No': FAKE_LUN_NO1,
@@ -134,10 +217,24 @@ FAKE_LUN_META1 = {
     'FJ_Backend': FAKE_SYSTEM_NAME,
 }
 
+# Volume2 metadata info.
+FAKE_LUN_META3 = {
+    'FJ_Pool_Type': 'RAID_GROUP',
+    'FJ_Volume_No': FAKE_LUN_NO3,
+    'FJ_Volume_Name': u'FJosv_4whcadwDac7ANKHA2O719A==',
+    'FJ_Pool_Name': STORAGE_TYPE2,
+    'FJ_Backend': FAKE_SYSTEM_NAME,
+}
+# Volume1
 FAKE_MODEL_INFO1 = {
     'provider_location': six.text_type(FAKE_LOCATION1),
     'metadata': FAKE_LUN_META1,
 }
+# Volume2
+FAKE_MODEL_INFO3 = {
+    'provider_location': six.text_type(FAKE_LOCATION3),
+    'metadata': FAKE_LUN_META3,
+}
 
 FAKE_KEYBIND2 = {
     'CreationClassName': 'FUJITSU_StorageVolume',
@@ -151,7 +248,9 @@ FAKE_LOCATION2 = {
     'keybindings': FAKE_KEYBIND2,
 }
 
-FAKE_SNAP_INFO = {'provider_location': six.text_type(FAKE_LOCATION2)}
+FAKE_SNAP_INFO = {
+    'provider_location': six.text_type(FAKE_LOCATION2)
+}
 
 FAKE_LUN_META2 = {
     'FJ_Pool_Type': 'Thinporvisioning_POOL',
@@ -205,7 +304,10 @@ class FakeEternusConnection(object):
             VOL_STAT = '1'
             rc = 0
             vol = self._enum_volumes()
-            job = {'TheElement': vol[0].path}
+            if InPool.get('InstanceID') == 'FUJITSU:RSP0005':
+                job = {'TheElement': vol[1].path}
+            else:
+                job = {'TheElement': vol[0].path}
         elif MethodName == 'ReturnToStoragePool':
             VOL_STAT = '0'
             rc = 0
@@ -262,7 +364,7 @@ class FakeEternusConnection(object):
 
         return result
 
-    def EnumerateInstances(self, name):
+    def EnumerateInstances(self, name, **param_dict):
         result = None
         if name == 'FUJITSU_StorageProduct':
             result = self._enum_sysnames()
@@ -315,6 +417,8 @@ class FakeEternusConnection(object):
             result = self._assoc_storagevolume(objectpath)
         elif ResultClass == 'FUJITSU_AuthorizedPrivilege':
             result = self._assoc_authpriv()
+        elif AssocClass == 'FUJITSU_AllocatedFromStoragePool':
+            result = self._assocnames_pool(objectpath)
         else:
             result = self._default_assoc(objectpath)
 
@@ -329,6 +433,9 @@ class FakeEternusConnection(object):
             result = self._assocnames_tcp_endpoint()
         elif ResultClass == 'FUJITSU_AffinityGroupController':
             result = self._assocnames_afngroup()
+        elif (ResultClass == 'FUJITSU_StorageVolume' and
+              AssocClass == 'FUJITSU_AllocatedFromStoragePool'):
+            result = self._assocnames_volumelist(objectpath)
         else:
             result = self._default_assocnames(objectpath)
 
@@ -407,6 +514,26 @@ class FakeEternusConnection(object):
     def _assocnames_afngroup(self):
         return self._enum_afntyservice()
 
+    def _assocnames_volumelist(self, poolpath):
+        volumelist = self._enum_volumes(force=True)
+        inpool = []
+        for vol in volumelist:
+            vol_pool = vol.get('poolpath')
+            if poolpath['InstanceID'] == vol_pool:
+                inpool.append(vol)
+
+        return inpool
+
+    def _assocnames_pool(self, volumepath):
+        poollist = self._enum_pool_details('RAID')
+        poollist += self._enum_pool_details('TPP')
+        volpool = []
+        for pool in poollist:
+            if volumepath['poolpath'] == pool['InstanceID']:
+                volpool.append(pool)
+
+        return volpool
+
     def _default_assocnames(self, objectpath):
         return objectpath
 
@@ -520,34 +647,48 @@ class FakeEternusConnection(object):
     def _enum_pool_details(self, pooltype):
         pools = []
         pool = FJ_StoragePool()
+        pool2 = FJ_StoragePool()
 
         if pooltype == 'RAID':
             pool['InstanceID'] = 'FUJITSU:RSP0004'
             pool['CreationClassName'] = 'FUJITSU_RAIDStoragePool'
             pool['ElementName'] = 'abcd1234_OSVD'
             pool['TotalManagedSpace'] = 1170368102400
-            pool['RemainingManagedSpace'] = 1170368102400
-            pool.path = pool
+            pool['RemainingManagedSpace'] = 1170368102400 - 1 * units.Gi
+            pool.path = FJ_StoragePool()
+            pool.path['InstanceID'] = 'FUJITSU:RSP0004'
             pool.path.classname = 'FUJITSU_RAIDStoragePool'
+            pools.append(pool)
+
+            pool2['InstanceID'] = 'FUJITSU:RSP0005'
+            pool2['CreationClassName'] = 'FUJITSU_RAIDStoragePool'
+            pool2['ElementName'] = 'abcd1234_RG'
+            pool2['TotalManagedSpace'] = 1170368102400
+            pool2['RemainingManagedSpace'] = 1170368102400 - 1 * units.Gi
+            pool2.path = FJ_StoragePool()
+            pool2.path['InstanceID'] = 'FUJITSU:RSP0005'
+            pool2.path.classname = 'FUJITSU_RAIDStoragePool'
+            pools.append(pool2)
         else:
-            pool = FJ_StoragePool()
             pool['InstanceID'] = 'FUJITSU:TPP0004'
             pool['CreationClassName'] = 'FUJITSU_ThinProvisioningPool'
             pool['ElementName'] = 'abcd1234_TPP'
             pool['TotalManagedSpace'] = 1170368102400
-            pool['RemainingManagedSpace'] = 1170368102400
-            pool.path = pool
+            pool['RemainingManagedSpace'] = 1170368102400 - 2 * units.Gi
+            pool.path = FJ_StoragePool()
+            pool.path['InstanceID'] = 'FUJITSU:TPP0004'
             pool.path.classname = 'FUJITSU_ThinProvisioningPool'
+            pools.append(pool)
 
-        pools.append(pool)
         return pools
 
-    def _enum_volumes(self):
+    def _enum_volumes(self, force=False):
         volumes = []
-        if VOL_STAT == '0':
+        if VOL_STAT == '0' and not force:
             return volumes
         volume = FJ_StorageVolume()
         volume['name'] = TEST_VOLUME['name']
+        volume['poolpath'] = 'FUJITSU:TPP0004'
         volume['CreationClassName'] = 'FUJITSU_StorageVolume'
         volume['Name'] = FAKE_LUN_ID1
         volume['DeviceID'] = FAKE_LUN_ID1
@@ -558,20 +699,46 @@ class FakeEternusConnection(object):
         volume.path = volume
         volume.path.classname = volume['CreationClassName']
 
-        name = {}
-        name['classname'] = 'FUJITSU_StorageVolume'
-        keys = {}
-        keys['CreationClassName'] = 'FUJITSU_StorageVolume'
-        keys['SystemName'] = STORAGE_SYSTEM
-        keys['DeviceID'] = volume['DeviceID']
-        keys['SystemCreationClassName'] = 'FUJITSU_StorageComputerSystem'
-        name['keybindings'] = keys
+        name = {
+            'classname': 'FUJITSU_StorageVolume',
+            'keybindings': {
+                'CreationClassName': 'FUJITSU_StorageVolume',
+                'SystemName': STORAGE_SYSTEM,
+                'DeviceID': volume['DeviceID'],
+                'SystemCreationClassName': 'FUJITSU_StorageComputerSystem',
+            },
+        }
         volume['provider_location'] = str(name)
-
         volumes.append(volume)
 
+        volume3 = FJ_StorageVolume()
+        volume3['name'] = TEST_VOLUME2['name']
+        volume3['poolpath'] = 'FUJITSU:RSP0005'
+        volume3['CreationClassName'] = 'FUJITSU_StorageVolume'
+        volume3['Name'] = FAKE_LUN_ID3
+        volume3['DeviceID'] = FAKE_LUN_ID3
+        volume3['SystemCreationClassName'] = 'FUJITSU_StorageComputerSystem'
+        volume3['SystemName'] = STORAGE_SYSTEM
+        volume3['ElementName'] = 'FJosv_4whcadwDac7ANKHA2O719A=='
+        volume3['volume_type_id'] = None
+        volume3.path = volume3
+        volume3.path.classname = volume3['CreationClassName']
+
+        name3 = {
+            'classname': 'FUJITSU_StorageVolume',
+            'keybindings': {
+                'CreationClassName': 'FUJITSU_StorageVolume',
+                'SystemName': STORAGE_SYSTEM,
+                'DeviceID': volume3['DeviceID'],
+                'SystemCreationClassName': 'FUJITSU_StorageComputerSystem',
+            },
+        }
+        volume3['provider_location'] = str(name3)
+        volumes.append(volume3)
+
         snap_vol = FJ_StorageVolume()
         snap_vol['name'] = TEST_SNAP['name']
+        snap_vol['poolpath'] = 'FUJITSU:RSP0004'
         snap_vol['CreationClassName'] = 'FUJITSU_StorageVolume'
         snap_vol['Name'] = FAKE_LUN_ID2
         snap_vol['DeviceID'] = FAKE_LUN_ID2
@@ -581,20 +748,21 @@ class FakeEternusConnection(object):
         snap_vol.path = snap_vol
         snap_vol.path.classname = snap_vol['CreationClassName']
 
-        name2 = {}
-        name2['classname'] = 'FUJITSU_StorageVolume'
-        keys2 = {}
-        keys2['CreationClassName'] = 'FUJITSU_StorageVolume'
-        keys2['SystemName'] = STORAGE_SYSTEM
-        keys2['DeviceID'] = snap_vol['DeviceID']
-        keys2['SystemCreationClassName'] = 'FUJITSU_StorageComputerSystem'
-        name2['keybindings'] = keys2
+        name2 = {
+            'classname': 'FUJITSU_StorageVolume',
+            'keybindings': {
+                'CreationClassName': 'FUJITSU_StorageVolume',
+                'SystemName': STORAGE_SYSTEM,
+                'DeviceID': snap_vol['DeviceID'],
+                'SystemCreationClassName': 'FUJITSU_StorageComputerSystem',
+            },
+        }
         snap_vol['provider_location'] = str(name2)
-
         volumes.append(snap_vol)
 
         clone_vol = FJ_StorageVolume()
         clone_vol['name'] = TEST_CLONE['name']
+        clone_vol['poolpath'] = 'FUJITSU:TPP0004'
         clone_vol['CreationClassName'] = 'FUJITSU_StorageVolume'
         clone_vol['ElementName'] = TEST_CLONE['name']
         clone_vol['DeviceID'] = FAKE_LUN_ID2
@@ -678,7 +846,6 @@ class FakeEternusConnection(object):
         return targetlist
 
     def _getinstance_storagevolume(self, objpath):
-        foundinstance = None
         instance = FJ_StorageVolume()
         volumes = self._enum_volumes()
         for volume in volumes:
@@ -713,6 +880,8 @@ class FJFCDriverTestCase(test.TestCase):
         # Make fake Object by using mock as configuration object.
         self.configuration = mock.Mock(spec=conf.Configuration)
         self.configuration.cinder_eternus_config_file = self.config_file.name
+        self.configuration.safe_get = self.fake_safe_get
+        self.configuration.max_over_subscription_ratio = '20.0'
 
         self.mock_object(dx_common.FJDXCommon, '_get_eternus_connection',
                          self.fake_eternus_connection)
@@ -721,26 +890,58 @@ class FJFCDriverTestCase(test.TestCase):
         self.mock_object(dx_common.FJDXCommon, '_create_eternus_instance_name',
                          instancename.fake_create_eternus_instance_name)
 
+        self.mock_object(eternus_dx_cli.FJDXCLI, '_exec_cli_with_eternus',
+                         self.fake_exec_cli_with_eternus)
         # Set iscsi driver to self.driver.
         driver = dx_fc.FJDXFCDriver(configuration=self.configuration)
         self.driver = driver
 
+    def fake_exec_cli_with_eternus(self, exec_cmdline):
+        if exec_cmdline == "show users":
+            ret = ('\r\nCLI> show users\r\n00\r\n'
+                   '3B\r\nf.ce\tMaintainer\t01\t00'
+                   '\t00\t00\r\ntestuser\tSoftware'
+                   '\t01\t01\t00\t00\r\nCLI> ')
+            return ret
+        elif exec_cmdline.startswith('show volumes'):
+            ret = ('\r\nCLI> %s\r\n00\r\n0560\r\n0000'
+                   '\tFJosv_0qJ4rpOHgFE8ipcJOMfBmg=='
+                   '\tA001\t0B\t00\t0000\tabcd1234_TPP'
+                   '\t0000000000200000\t00\t00'
+                   '\t00000000\t0050\tFF\t00\tFF'
+                   '\tFF\t20\tFF\tFFFF\t00'
+                   '\t600000E00D2A0000002A011500140000'
+                   '\t00\t00\tFF\tFF\tFFFFFFFF\t00'
+                   '\t00\tFF\r\n0001\tFJosv_UkCZqMFZW3SU_JzxjHiKfg=='
+                   '\tA001\t0B\t00\t0000\tabcd1234_OSVD'
+                   '\t0000000000200000\t00\t00\t00000000'
+                   '\t0050\tFF\t00\tFF\tFF\t20\tFF\tFFFF'
+                   '\t00\t600000E00D2A0000002A0115001E0000'
+                   '\t00\t00\tFF\tFF\tFFFFFFFF\t00'
+                   '\t00\tFF' % exec_cmdline)
+            return ret
+
+    def fake_safe_get(self, str=None):
+        return str
+
     def fake_eternus_connection(self):
         conn = FakeEternusConnection()
         return conn
 
     def test_get_volume_stats(self):
         ret = self.driver.get_volume_stats(True)
-        stats = {'vendor_name': ret['vendor_name'],
-                 'total_capacity_gb': ret['total_capacity_gb'],
-                 'free_capacity_gb': ret['free_capacity_gb']}
-        self.assertEqual(FAKE_STATS, stats)
+
+        self.assertEqual(FAKE_STATS2, ret)
 
     def test_create_and_delete_volume(self):
         model_info = self.driver.create_volume(TEST_VOLUME)
         self.assertEqual(FAKE_MODEL_INFO1, model_info)
 
+        model_info = self.driver.create_volume(TEST_VOLUME2)
+        self.assertEqual(FAKE_MODEL_INFO3, model_info)
+
         self.driver.delete_volume(TEST_VOLUME)
+        self.driver.delete_volume(TEST_VOLUME2)
 
     @mock.patch.object(dx_common.FJDXCommon, '_get_mapdata')
     def test_map_unmap(self, mock_mapdata):
@@ -816,7 +1017,16 @@ class FJFCDriverTestCase(test.TestCase):
         model_info = self.driver.create_volume(TEST_VOLUME)
         self.assertEqual(FAKE_MODEL_INFO1, model_info)
 
-        self.driver.extend_volume(TEST_VOLUME, 10)
+        volume_info = {}
+        for key in TEST_VOLUME:
+            if key == 'provider_location':
+                volume_info[key] = model_info[key]
+            elif key == 'metadata':
+                volume_info[key] = model_info[key]
+            else:
+                volume_info[key] = TEST_VOLUME[key]
+
+        self.driver.extend_volume(volume_info, 10)
 
 
 class FJISCSIDriverTestCase(test.TestCase):
@@ -835,6 +1045,8 @@ class FJISCSIDriverTestCase(test.TestCas
         # Make fake Object by using mock as configuration object.
         self.configuration = mock.Mock(spec=conf.Configuration)
         self.configuration.cinder_eternus_config_file = self.config_file.name
+        self.configuration.safe_get = self.fake_safe_get
+        self.configuration.max_over_subscription_ratio = '20.0'
 
         self.mock_object(dx_common.FJDXCommon, '_get_eternus_connection',
                          self.fake_eternus_connection)
@@ -846,10 +1058,40 @@ class FJISCSIDriverTestCase(test.TestCas
         self.mock_object(dx_common.FJDXCommon, '_get_mapdata_iscsi',
                          self.fake_get_mapdata)
 
+        self.mock_object(eternus_dx_cli.FJDXCLI, '_exec_cli_with_eternus',
+                         self.fake_exec_cli_with_eternus)
         # Set iscsi driver to self.driver.
         driver = dx_iscsi.FJDXISCSIDriver(configuration=self.configuration)
         self.driver = driver
 
+    def fake_exec_cli_with_eternus(self, exec_cmdline):
+        if exec_cmdline == "show users":
+            ret = ('\r\nCLI> show users\r\n00\r\n'
+                   '3B\r\nf.ce\tMaintainer\t01\t00'
+                   '\t00\t00\r\ntestuser\tSoftware'
+                   '\t01\t01\t00\t00\r\nCLI> ')
+            return ret
+        elif exec_cmdline.startswith('show volumes'):
+            ret = ('\r\nCLI> %s\r\n00\r\n0560\r\n0000'
+                   '\tFJosv_0qJ4rpOHgFE8ipcJOMfBmg=='
+                   '\tA001\t0B\t00\t0000\tabcd1234_TPP'
+                   '\t0000000000200000\t00\t00'
+                   '\t00000000\t0050\tFF\t00\tFF'
+                   '\tFF\t20\tFF\tFFFF\t00'
+                   '\t600000E00D2A0000002A011500140000'
+                   '\t00\t00\tFF\tFF\tFFFFFFFF\t00'
+                   '\t00\tFF\r\n0001\tFJosv_UkCZqMFZW3SU_JzxjHiKfg=='
+                   '\tA001\t0B\t00\t0000\tabcd1234_OSVD'
+                   '\t0000000000200000\t00\t00\t00000000'
+                   '\t0050\tFF\t00\tFF\tFF\t20\tFF\tFFFF'
+                   '\t00\t600000E00D2A0000002A0115001E0000'
+                   '\t00\t00\tFF\tFF\tFFFFFFFF\t00'
+                   '\t00\tFF' % exec_cmdline)
+            return ret
+
+    def fake_safe_get(self, str=None):
+        return str
+
     def fake_eternus_connection(self):
         conn = FakeEternusConnection()
         return conn
@@ -867,16 +1109,18 @@ class FJISCSIDriverTestCase(test.TestCas
 
     def test_get_volume_stats(self):
         ret = self.driver.get_volume_stats(True)
-        stats = {'vendor_name': ret['vendor_name'],
-                 'total_capacity_gb': ret['total_capacity_gb'],
-                 'free_capacity_gb': ret['free_capacity_gb']}
-        self.assertEqual(FAKE_STATS, stats)
+
+        self.assertEqual(FAKE_STATS, ret)
 
     def test_create_and_delete_volume(self):
         model_info = self.driver.create_volume(TEST_VOLUME)
         self.assertEqual(FAKE_MODEL_INFO1, model_info)
 
+        model_info = self.driver.create_volume(TEST_VOLUME2)
+        self.assertEqual(FAKE_MODEL_INFO3, model_info)
+
         self.driver.delete_volume(TEST_VOLUME)
+        self.driver.delete_volume(TEST_VOLUME2)
 
     def test_map_unmap(self):
         fake_mapdata = self.fake_get_mapdata(None, {}, None)
@@ -942,4 +1186,13 @@ class FJISCSIDriverTestCase(test.TestCas
         model_info = self.driver.create_volume(TEST_VOLUME)
         self.assertEqual(FAKE_MODEL_INFO1, model_info)
 
-        self.driver.extend_volume(TEST_VOLUME, 10)
+        volume_info = {}
+        for key in TEST_VOLUME:
+            if key == 'provider_location':
+                volume_info[key] = model_info[key]
+            elif key == 'metadata':
+                volume_info[key] = model_info[key]
+            else:
+                volume_info[key] = TEST_VOLUME[key]
+
+        self.driver.extend_volume(volume_info, 10)
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_gpfs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_gpfs.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_gpfs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_gpfs.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,10 +15,11 @@
 
 import os
 import tempfile
+from unittest import mock
 
-import mock
 from oslo_concurrency import processutils
 from oslo_config import cfg
+from oslo_utils import timeutils
 from oslo_utils import units
 
 from cinder import context
@@ -27,6 +28,7 @@ from cinder import objects
 from cinder.objects import fields
 from cinder import test
 from cinder.tests.unit import fake_constants as fake
+from cinder.tests.unit import utils as test_utils
 from cinder import utils
 from cinder.volume import configuration as conf
 from cinder.volume.drivers.ibm import gpfs
@@ -86,6 +88,7 @@ class GPFSDriverTestCase(test.TestCase):
         self.context = context.get_admin_context()
         self.context.user_id = 'fake'
         self.context.project_id = 'fake'
+        self.updated_at = timeutils.utcnow()
         CONF.gpfs_images_dir = self.images_dir
 
     def _cleanup(self, images_dir, volumes_path):
@@ -1384,7 +1387,16 @@ class GPFSDriverTestCase(test.TestCase):
     @mock.patch('cinder.volume.drivers.ibm.gpfs.GPFSDriver.local_path')
     @mock.patch('cinder.image.image_utils.upload_volume')
     def test_copy_volume_to_image(self, mock_upload_volume, mock_local_path):
-        volume = self._fake_volume()
+        volume = test_utils.create_volume(
+            self.context, volume_type_id=fake.VOLUME_TYPE_ID,
+            updated_at=self.updated_at)
+        extra_specs = {
+            'image_service:store_id': 'fake-store'
+        }
+        test_utils.create_volume_type(
+            self.context.elevated(), id=fake.VOLUME_TYPE_ID,
+            name="test_type", extra_specs=extra_specs)
+
         self.driver.copy_volume_to_image('', volume, '', '')
 
     @mock.patch('cinder.utils.execute')
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_hedvig.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_hedvig.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_hedvig.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_hedvig.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,7 +14,7 @@
 #    under the License.
 #
 
-import mock
+from unittest import mock
 
 from cinder import context
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_infinidat.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_infinidat.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_infinidat.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_infinidat.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,10 +15,11 @@
 """Unit tests for INFINIDAT InfiniBox volume driver."""
 
 import functools
-import mock
-from oslo_utils import units
 import platform
 import socket
+from unittest import mock
+
+from oslo_utils import units
 
 from cinder import exception
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_kaminario.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_kaminario.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_kaminario.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_kaminario.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,11 +14,11 @@
 #    under the License.
 """Unit tests for kaminario driver."""
 import re
+import time
+from unittest import mock
 
 import ddt
-import mock
 from oslo_utils import units
-import time
 
 from cinder import context
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_linstordrv.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_linstordrv.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_linstordrv.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_linstordrv.py	2020-03-24 18:46:31.000000000 +0000
@@ -1,4 +1,4 @@
-# Copyright (c) 2018 LINBIT HA Solutions GmbH
+# Copyright (c) 2018-2019 LINBIT HA Solutions GmbH
 # All Rights Reserved.
 #
 #    Licensed under the Apache License, Version 2.0 (the "License"); you may
@@ -13,7 +13,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 from oslo_config import cfg
 from oslo_utils import timeutils
@@ -26,442 +26,303 @@ from cinder.volume.drivers import linsto
 CONF = cfg.CONF
 
 CINDER_UNKNOWN = 'unknown'
-LVM = 'Lvm'
-LVMTHIN = 'LvmThin'
+DISKLESS = 'DISKLESS'
+LVM = 'LVM'
+LVM_THIN = 'LVM_THIN'
+ZFS = 'ZFS'
+ZFS_THIN = 'ZFS_THIN'
 DRIVER = 'cinder.volume.drivers.linstordrv.'
 
 RESOURCE = {
-    'name': 'CV_bc3015e6-695f-4688-91f2-1deb4321e4f0',
+    'name': 'CV_0348a7d3-3bb9-452d-9f40-2cf5ebfe9131',
     'volume': {
-        'device_path': '/dev/drbd1000',
-    },
+        'device_path': '/dev/drbd1000'
+    }
 }
 
-RESOURCE_LIST = {
-    'resourceStates': [
-        {
-            'rscName': 'CV_bc3015e6-695f-4688-91f2-1deb4321e4f0',
-            'nodeName': 'node_one',
-            'inUse': False,
-            'vlmStates': [
-                {
-                    'vlmNr': 0,
-                    'diskState': 'Diskless',
-                }
-            ],
-        },
-        {
-            'rscName': 'CV_bc3015e6-695f-4688-91f2-1deb4321e4f0',
-            'nodeName': 'node_two',
-            'inUse': False,
-            'vlmStates': [
-                {
-                    'vlmNr': 0,
-                    'diskState': 'UpToDate',
-                }
-            ],
-        },
-    ],
-    'resources': [
-        {
-            'name': 'CV_bc3015e6-695f-4688-91f2-1deb4321e4f0',
-            'nodeId': 0,
-            'nodeName': 'node_one',
-            'nodeUuid': '67939f68-2b26-41b7-b32e-a20b77664aef',
-            'props': [{'key': 'PeerSlots', 'value': '7'}],
-            'rscDfnUuid': '03623665-35a3-4caa-aa92-0c8badbda84a',
-            'uuid': '559a229e-2b97-4d20-8f6d-87778bbe2f9e',
-            'vlms': [
-                {
-                    'backingDisk': '/dev/vg-35/f1_00000',
-                    'devicePath': '/dev/drbd1000',
-                    'metaDisk': 'internal',
-                    'storPoolName': 'DfltStorPool',
-                    'storPoolUuid': 'd2f293f5-5d73-4447-a14b-70efe01302be',
-                    'vlmDfnUuid': '0eedabe4-3c20-4eff-af74-b2ec2304ab0c',
-                    'vlmMinorNr': 1000,
-                    'vlmNr': 0,
-                    'vlmUuid': '38e48fb8-e0af-4317-8aab-aabb46db4cf8'
-                }
-            ]
+RESOURCE_LIST = [{
+    'layer_object': {
+        'children': [{
+            'storage': {
+                'storage_volumes': [{
+                    'allocated_size_kib': 1048576,
+                    'device_path':
+                    '/dev/vol/CV_0348a7d3-3bb9-452d-9f40-2cf5ebfe9131_00000',
+                    'disk_state': '[]',
+                    'usable_size_kib': 1048576,
+                    'volume_number': 0}]},
+            'type': 'STORAGE'}],
+        'drbd': {
+            'al_size': 32,
+            'al_stripes': 1,
+            'drbd_resource_definition': {
+                'al_stripe_size_kib': 32,
+                'al_stripes': 1,
+                'down': False,
+                'peer_slots': 7,
+                'port': 7005,
+                'secret': 'poQZ0Ad/Bq8DT9fA7ydB',
+                'transport_type': 'IP'},
+            'drbd_volumes': [{
+                'allocated_size_kib': 1044740,
+                'backing_device':
+                    '/dev/vol/CV_0348a7d3-3bb9-452d-9f40-2cf5ebfe9131_00000',
+                'device_path': '/dev/drbd1005',
+                'drbd_volume_definition': {
+                    'minor_number': 1005,
+                    'volume_number': 0},
+                'usable_size_kib': 1044480}],
+            'node_id': 0,
+            'peer_slots': 7},
+        'type': 'DRBD'},
+    'name': 'CV_0348a7d3-3bb9-452d-9f40-2cf5ebfe9131',
+    'node_name': 'node-2',
+    'state': {'in_use': False},
+    'uuid': 'a4ab4670-c5fc-4590-a3a2-39c4685c8c32',
+    'volumes': [{
+        'allocated_size_kib': 45403,
+        'device_path': '/dev/drbd1005',
+        'layer_data_list': [{
+            'data': {
+                'allocated_size_kib': 1044740,
+                'backing_device':
+                '/dev/vol/CV_0348a7d3-3bb9-452d-9f40-2cf5ebfe9131_00000',
+                'device_path': '/dev/drbd1005',
+                'drbd_volume_definition': {
+                    'minor_number': 1005,
+                    'volume_number': 0},
+                'usable_size_kib': 1044480},
+            'type': 'DRBD'}, {
+            'data': {
+                'allocated_size_kib': 1048576,
+                'device_path':
+                '/dev/vol/CV_0348a7d3-3bb9-452d-9f40-2cf5ebfe9131_00000',
+                'disk_state': '[]',
+                'usable_size_kib': 1048576,
+                'volume_number': 0},
+            'type': 'STORAGE'}
+        ],
+        'props': {
+            'RestoreFromResource': 'CV_123a2fdc-365f-472e-bb8e-484788712abc',
+            'RestoreFromSnapshot': 'SN_68edb708-48de-4da1-9953-b9de9da9f1b8'
         },
-        {
-            'name': 'CV_bc3015e6-695f-4688-91f2-1deb4321e4f0',
-            'nodeId': 1,
-            'nodeName': 'node_two',
-            'nodeUuid': '82c4c5a5-8290-481e-9e35-1c71094b0cab',
-            'props': [{'key': 'PeerSlots', 'value': '7'}],
-            'rscDfnUuid': '03623665-35a3-4caa-aa92-0c8badbda84a',
-            'rscFlags': ['DISKLESS'],
-            'uuid': '23d3d331-ad0c-43f3-975b-d1048e09dc23',
-            'vlms': [
-                {
-                    'backingDisk': 'none',
-                    'devicePath': '/dev/drbd1000',
-                    'metaDisk': 'internal',
-                    'storPoolName': 'DfltStorPool',
-                    'storPoolUuid': '85ef7894-0682-4019-b95a-1b25e81c0cb5',
-                    'vlmDfnUuid': '0eedabe4-3c20-4eff-af74-b2ec2304ab0c',
-                    'vlmMinorNr': 1000,
-                    'vlmNr': 0,
-                    'vlmUuid': 'd25b6c91-680f-4aa6-97c3-533e4bf4e659'
-                }
-            ]
-        }
-    ]
-}
-
-RESOURCE_LIST_RESP = ['node_two', 'node_one']
+        'provider_kind': 'LVM_THIN',
+        'state': {'disk_state': 'UpToDate'},
+        'storage_pool_name': 'DfltStorPool',
+        'uuid': 'e270ba0c-b284-4f21-85cc-602f132a2251',
+        'volume_number': 0}]}, {
+    'flags': ['DISKLESS'],
+    'layer_object': {
+        'children': [{
+            'storage': {
+                'storage_volumes': [{
+                    'allocated_size_kib': 0,
+                    'usable_size_kib': 1044480,
+                    'volume_number': 0}]},
+            'type': 'STORAGE'}],
+        'drbd': {
+            'al_size': 32,
+            'al_stripes': 1,
+            'drbd_resource_definition': {
+                'al_stripe_size_kib': 32,
+                'al_stripes': 1,
+                'down': False,
+                'peer_slots': 7,
+                'port': 7005,
+                'secret': 'poQZ0Ad/Bq8DT9fA7ydB',
+                'transport_type': 'IP'},
+            'drbd_volumes': [{
+                'allocated_size_kib': 1044740,
+                'device_path': '/dev/drbd1005',
+                'drbd_volume_definition': {
+                    'minor_number': 1005,
+                    'volume_number': 0},
+                'usable_size_kib': 1044480}],
+            'flags': ['DISKLESS'],
+            'node_id': 1,
+            'peer_slots': 7},
+        'type': 'DRBD'},
+    'name': 'CV_0348a7d3-3bb9-452d-9f40-2cf5ebfe9131',
+    'node_name': 'node-1',
+    'state': {'in_use': False},
+    'uuid': '11e853df-6f66-4cd9-9fbc-f3f7cc98d5cf',
+    'volumes': [{
+        'allocated_size_kib': 45403,
+        'device_path': '/dev/drbd1005',
+        'layer_data_list': [
+            {
+                'data': {
+                    'allocated_size_kib': 1044740,
+                    'device_path': '/dev/drbd1005',
+                    'drbd_volume_definition': {
+                        'minor_number': 1005,
+                        'volume_number': 0},
+                    'usable_size_kib': 1044480},
+                'type': 'DRBD'
+            },
+            {
+                'data': {
+                    'allocated_size_kib': 0,
+                    'usable_size_kib': 1044480,
+                    'volume_number': 0
+                },
+                'type': 'STORAGE'
+            }
+        ],
+        'provider_kind': 'DISKLESS',
+        'state': {'disk_state': 'Diskless'},
+        'storage_pool_name': 'DfltStorPool',
+        'uuid': '27b4aeec-2b42-41c9-b186-86afc8778046',
+        'volume_number': 0
+    }]}]
 
-SNAPSHOT_LIST_RESP = ['node_two']
+RESOURCE_LIST_RESP = ['node-1', 'node-2']
 
-RESOURCE_DFN_LIST = {
-    'rscDfns': [
-        {
-            'rscDfnPort': 7002,
-            'rscDfnProps': [{'key': u'DrbdPrimarySetOn',
-                             'value': u'NODE_TWO'}],
-            'rscDfnSecret': u'syxflfoMqj84cUUcsqta',
-            'rscDfnUuid': u'f55f0c28-455b-458f-a05d-b5f7f16b5c22',
-            'rscName': u'CV_bc3015e6-695f-4688-91f2-1deb4321e4f0',
-            'vlmDfns': [
-                {
-                    'vlmDfnUuid': u'89f6eff2-c4cd-4586-9ab8-8e850568b93b',
-                    'vlmMinor': 1001,
-                    'vlmNr': 0,
-                    'vlmProps': [{'key': u'DrbdCurrentGi',
-                                  'value': u'2286D24524D26AA'}],
-                    'vlmSize': '1044480'}
-            ]
-        },
-    ]
-}
+SNAPSHOT_LIST_RESP = ['node-1']
 
-RESOURCE_DFN_LIST_RESP = [
-    {
-        'rd_name': u'CV_bc3015e6-695f-4688-91f2-1deb4321e4f0',
-        'rd_port': 7002,
-        'rd_size': 1.0,
-        'rd_uuid': u'f55f0c28-455b-458f-a05d-b5f7f16b5c22',
-        'vlm_dfn_uuid': u'89f6eff2-c4cd-4586-9ab8-8e850568b93b'
-    }
-]
+DISKLESS_LIST_RESP = ['node-1']
 
-NODES_LIST = {
-    'nodes': [
+RESOURCE_DFN_LIST = [{
+    'layer_data': [
         {
-            'connectionStatus': 2,
-            'name': u'node_two',
-            'netInterfaces': [
-                {
-                    'address': u'192.168.66.113',
-                    'name': u'default',
-                    'stltEncryptionType': u'PLAIN',
-                    'stltPort': 3366,
-                    'uuid': u'224e50c3-09a8-4cf8-b701-13663a66aecd'
-                }
-            ],
-            'props': [{'key': u'CurStltConnName', 'value': u'default'}],
-            'type': u'COMBINED',
-            'uuid': u'67939f68-2b26-41b7-b32e-a20b77664aef'
+            'data': {
+                'al_stripe_size_kib': 32,
+                'al_stripes': 1,
+                'down': False,
+                'peer_slots': 7,
+                'port': 7005,
+                'secret': 'poQZ0Ad/Bq8DT9fA7ydB',
+                'transport_type': 'IP'
+            },
+            'type': 'DRBD'
         },
         {
-            'connectionStatus': 2,
-            'name': u'node_one',
-            'netInterfaces': [
-                {
-                    'address': u'192.168.66.115',
-                    'name': u'default',
-                    'stltEncryptionType': u'PLAIN',
-                    'stltPort': 3366,
-                    'uuid': u'36f42ec9-9999-4ad7-a889-8d7dbb498163'
-                }
-            ],
-            'props': [{'key': u'CurStltConnName', 'value': u'default'}],
-            'type': u'COMBINED',
-            'uuid': u'82c4c5a5-8290-481e-9e35-1c71094b0cab'
+            'type': 'STORAGE'
         }
-    ]
-}
+    ],
+    'name': 'CV_0348a7d3-3bb9-452d-9f40-2cf5ebfe9131',
+    'props': {'DrbdPrimarySetOn': 'node-1'},
+    'uuid': '9a684294-6db4-40c8-bfeb-e5351200b9db'
+}]
+
+RESOURCE_DFN_LIST_RESP = [{
+    'rd_name': u'CV_0348a7d3-3bb9-452d-9f40-2cf5ebfe9131',
+    'rd_uuid': u'9a684294-6db4-40c8-bfeb-e5351200b9db',
+}]
 
-NODES_RESP = [
+NODES_LIST = [
     {
-        'node_address': u'192.168.66.113',
-        'node_name': u'node_two',
-        'node_uuid': u'67939f68-2b26-41b7-b32e-a20b77664aef'
+        'connection_status': 'ONLINE',
+        'name': 'node-1',
+        'net_interfaces': [{
+            'address': '192.168.8.63',
+            'name': 'default',
+            'satellite_encryption_type': 'PLAIN',
+            'satellite_port': 3366,
+            'uuid': '9c5b727f-0c62-4040-9a33-96a4fd4aaac3'}],
+        'props': {'CurStltConnName': 'default'},
+        'type': 'COMBINED',
+        'uuid': '69b88ffb-50d9-4576-9843-d7bf4724d043'
     },
     {
-        'node_address': u'192.168.66.115',
-        'node_name': u'node_one',
-        'node_uuid': u'82c4c5a5-8290-481e-9e35-1c71094b0cab'
+        'connection_status': 'ONLINE',
+        'name': 'node-2',
+        'net_interfaces': [{
+            'address': '192.168.8.102',
+            'name': 'default',
+            'satellite_encryption_type': 'PLAIN',
+            'satellite_port': 3366,
+            'uuid': '3f911fc9-4f9b-4155-b9da-047d5242484c'}],
+        'props': {'CurStltConnName': 'default'},
+        'type': 'SATELLITE',
+        'uuid': '26bde754-0f05-499c-a63c-9f4e5f30556e'
     }
 ]
 
-STORAGE_POOL_DEF = {
-    'storPoolDfns': [
-        {
-            'storPoolName': u'DfltStorPool',
-            'uuid': u'f51611c6-528f-4793-a87a-866d09e6733a'
-        }
-    ]
-}
-
-STORAGE_POOL_DEF_RESP = [
-    {
-        'spd_name': u'DfltStorPool',
-        'spd_uuid': u'f51611c6-528f-4793-a87a-866d09e6733a'
-    }
+NODES_RESP = [
+    {'node_address': '192.168.8.63', 'node_name': 'node-1'},
+    {'node_address': '192.168.8.102', 'node_name': 'node-2'}
 ]
 
-STORAGE_POOL_LIST = {
-    'storPools': [
-        {
-            'driver': u'LvmThinDriver',
-            'freeSpace': {
-                'freeCapacity': '36700160',
-                'storPoolName': u'DfltStorPool',
-                'storPoolUuid': u'd2f293f5-5d73-4447-a14b-70efe01302be',
-                'totalCapacity': '36700160'
-            },
-            'nodeName': u'node_two',
-            'nodeUuid': u'67939f68-2b26-41b7-b32e-a20b77664aef',
-            'props': [{'key': u'StorDriver/LvmVg', 'value': u'vg-35'},
-                      {'key': u'StorDriver/ThinPool',
-                       'value': u'thinpool'}],
-            'staticTraits': [{'key': u'Provisioning', 'value': u'Thin'},
-                             {'key': u'SupportsSnapshots',
-                              'value': u'true'}],
-            'storPoolDfnUuid': u'f51611c6-528f-4793-a87a-866d09e6733a',
-            'storPoolName': u'DfltStorPool',
-            'storPoolUuid': u'd2f293f5-5d73-4447-a14b-70efe01302be',
-            'vlms': [
-                {
-                    'backingDisk':
-                        u'/dev/vg-35/CV_bc3015e6-695f-4688-91f2-1deb4321e4f0',
-                    'devicePath': u'/dev/drbd1001',
-                    'metaDisk': u'internal',
-                    'storPoolName': u'DfltStorPool',
-                    'storPoolUuid': u'd2f293f5-5d73-4447-a14b-70efe01302be',
-                    'vlmDfnUuid': u'89f6eff2-c4cd-4586-9ab8-8e850568b93b',
-                    'vlmMinorNr': 1001,
-                    'vlmNr': 0,
-                    'vlmUuid': u'b91392ae-904a-4bc6-862f-9c7aca629b35'
-                },
-                {
-                    'backingDisk': u'/dev/vg-35/f1_00000',
-                    'devicePath': u'/dev/drbd1000',
-                    'metaDisk': u'internal',
-                    'storPoolName': u'DfltStorPool',
-                    'storPoolUuid': u'd2f293f5-5d73-4447-a14b-70efe01302be',
-                    'vlmDfnUuid': u'0eedabe4-3c20-4eff-af74-b2ec2304ab0c',
-                    'vlmMinorNr': 1000,
-                    'vlmNr': 0,
-                    'vlmUuid': u'38e48fb8-e0af-4317-8aab-aabb46db4cf8'
-                }
-            ]
-        },
-        {
-            'driver': u'DisklessDriver',
-            'freeSpace': {
-                'freeCapacity': '9223372036854775807',
-                'storPoolName': u'DfltStorPool',
-                'storPoolUuid': u'85ef7894-0682-4019-b95a-1b25e81c0cb5',
-                'totalCapacity': '9223372036854775807'
-            },
-            'nodeName': u'node_one',
-            'nodeUuid': u'82c4c5a5-8290-481e-9e35-1c71094b0cab',
-            'staticTraits': [{'key': u'SupportsSnapshots',
-                              'value': u'false'}],
-            'storPoolDfnUuid': u'f51611c6-528f-4793-a87a-866d09e6733a',
-            'storPoolName': u'DfltStorPool',
-            'storPoolUuid': u'85ef7894-0682-4019-b95a-1b25e81c0cb5',
-            'vlms': [
-                {
-                    'backingDisk': u'none',
-                    'devicePath': u'/dev/drbd1001',
-                    'metaDisk': u'internal',
-                    'storPoolName': u'DfltStorPool',
-                    'storPoolUuid': u'85ef7894-0682-4019-b95a-1b25e81c0cb5',
-                    'vlmDfnUuid': u'89f6eff2-c4cd-4586-9ab8-8e850568b93b',
-                    'vlmMinorNr': 1001,
-                    'vlmNr': 0,
-                    'vlmUuid': u'4c63ee46-acb0-4aa5-8758-8fa8f65fdd5a'
-                },
-                {
-                    'backingDisk': u'none',
-                    'devicePath': u'/dev/drbd1000',
-                    'metaDisk': u'internal',
-                    'storPoolName': u'DfltStorPool',
-                    'storPoolUuid': u'85ef7894-0682-4019-b95a-1b25e81c0cb5',
-                    'vlmDfnUuid': u'0eedabe4-3c20-4eff-af74-b2ec2304ab0c',
-                    'vlmMinorNr': 1000,
-                    'vlmNr': 0,
-                    'vlmUuid': u'd25b6c91-680f-4aa6-97c3-533e4bf4e659'
-                }
-            ]
-        }
-    ]
-}
+STORAGE_POOL_DEF = [{'storage_pool_name': 'DfltStorPool'}]
 
-STORAGE_POOL_LIST_RESP = [
+STORAGE_POOL_DEF_RESP = ['DfltStorPool']
+
+STORAGE_POOL_LIST = [
     {
-        'driver_name': 'LvmThin',
-        'node_name': u'node_two',
-        'node_uuid': u'67939f68-2b26-41b7-b32e-a20b77664aef',
-        'sp_cap': 35.0,
-        'sp_free': 35.0,
-        'sp_name': u'DfltStorPool',
-        'sp_uuid': u'd2f293f5-5d73-4447-a14b-70efe01302be',
-        'sp_vlms_uuid': [u'89f6eff2-c4cd-4586-9ab8-8e850568b93b',
-                         u'0eedabe4-3c20-4eff-af74-b2ec2304ab0c']
+        'free_capacity': 104815656,
+        'free_space_mgr_name': 'node-2:DfltStorPool',
+        'node_name': 'node-2',
+        'props': {
+            'StorDriver/LvmVg': 'vol',
+            'StorDriver/ThinPool': 'thin_pool'
+        },
+        'provider_kind': 'LVM_THIN',
+        'static_traits': {
+            'Provisioning': 'Thin',
+            'SupportsSnapshots': 'true'
+        },
+        'storage_pool_name': 'DfltStorPool',
+        'total_capacity': 104857600,
+        'uuid': '004faf29-be1a-4d74-9470-038bcee2c611'
     },
     {
-        'driver_name': u'DisklessDriver',
-        'node_name': u'node_one',
-        'node_uuid': u'82c4c5a5-8290-481e-9e35-1c71094b0cab',
-        'sp_cap': 0.0,
-        'sp_free': -1.0,
-        'sp_name': u'DfltStorPool',
-        'sp_uuid': u'85ef7894-0682-4019-b95a-1b25e81c0cb5',
-        'sp_vlms_uuid': [u'89f6eff2-c4cd-4586-9ab8-8e850568b93b',
-                         u'0eedabe4-3c20-4eff-af74-b2ec2304ab0c']
+        'free_capacity': 9223372036854775807,
+        'free_space_mgr_name': 'node-1:DfltStorPool',
+        'node_name': 'node-1',
+        'provider_kind': 'DISKLESS',
+        'static_traits': {'SupportsSnapshots': 'false'},
+        'storage_pool_name': 'DfltStorPool',
+        'total_capacity': 9223372036854775807,
+        'uuid': '897da09e-1316-45c0-a308-c07008af42df'
     }
 ]
 
-VOLUME_LIST = {
-    'resourceStates': [
-        {
-            'inUse': False,
-            'nodeName': u'wp-u16-cinder-dev-lg',
-            'rscName': u'CV_bc3015e6-695f-4688-91f2-1deb4321e4f0',
-            'vlmStates': [{'diskState': u'Diskless', 'vlmNr': 0}]
-        },
-        {
-            'nodeName': u'wp-u16-cinder-dev-1', 'rscName': u'foo'
-        },
-        {
-            'inUse': False,
-            'nodeName': u'wp-u16-cinder-dev-1',
-            'rscName': u'CV_bc3015e6-695f-4688-91f2-1deb4321e4f0',
-            'vlmStates': [{'diskState': u'UpToDate', 'vlmNr': 0}]
-        }
-    ],
-    'resources': [
-        {
-            'name': u'CV_bc3015e6-695f-4688-91f2-1deb4321e4f0',
-            'nodeId': 0,
-            'nodeName': u'wp-u16-cinder-dev-1',
-            'nodeUuid': u'67939f68-2b26-41b7-b32e-a20b77664aef',
-            'props': [{'key': u'PeerSlots', 'value': u'7'}],
-            'rscDfnUuid': u'f55f0c28-455b-458f-a05d-b5f7f16b5c22',
-            'uuid': u'2da61a7a-83b7-41d1-8a96-3a1a118dfba2',
-            'vlms': [
-                {
-                    'backingDisk':
-                        u'/dev/vg-35/CV_bc3015e6-695f-4688-91f2-' +
-                        u'1deb4321e4f0_00000',
-                    'devicePath': u'/dev/drbd1001',
-                    'metaDisk': u'internal',
-                    'storPoolName': u'DfltStorPool',
-                    'storPoolUuid': u'd2f293f5-5d73-4447-a14b-70efe01302be',
-                    'vlmDfnUuid': u'89f6eff2-c4cd-4586-9ab8-8e850568b93b',
-                    'vlmMinorNr': 1001,
-                    'vlmNr': 0,
-                    'vlmUuid': u'b91392ae-904a-4bc6-862f-9c7aca629b35'
-                }
-            ]
-        },
-        {
-            'name': u'CV_bc3015e6-695f-4688-91f2-1deb4321e4f0',
-            'nodeId': 1,
-            'nodeName': u'wp-u16-cinder-dev-lg',
-            'nodeUuid': u'82c4c5a5-8290-481e-9e35-1c71094b0cab',
-            'props': [{'key': u'PeerSlots', 'value': u'7'}],
-            'rscDfnUuid': u'f55f0c28-455b-458f-a05d-b5f7f16b5c22',
-            'rscFlags': [u'DISKLESS'],
-            'uuid': u'bd6472d1-dc3c-4d41-a5f0-f44271c05680',
-            'vlms': [
-                {
-                    'backingDisk': u'none',
-                    'devicePath': u'/dev/drbd1001',
-                    'metaDisk': u'internal',
-                    'storPoolName': u'DfltStorPool',
-                    'storPoolUuid': u'85ef7894-0682-4019-b95a-1b25e81c0cb5',
-                    'vlmDfnUuid': u'89f6eff2-c4cd-4586-9ab8-8e850568b93b',
-                    'vlmMinorNr': 1001,
-                    'vlmNr': 0,
-                    'vlmUuid': u'4c63ee46-acb0-4aa5-8758-8fa8f65fdd5a'
-                }
-            ]
-        }
-    ]
-}
-
-VOLUME_LIST_RESP = [
+STORAGE_POOL_LIST_RESP = [
     {
-        'node_name': u'wp-u16-cinder-dev-1',
-        'rd_name': u'CV_bc3015e6-695f-4688-91f2-1deb4321e4f0',
-        'volume': [
-            {
-                'backingDisk': u'/dev/vg-35/CV_bc3015e6-695f-4688-91f2-' +
-                               u'1deb4321e4f0_00000',
-                'devicePath': u'/dev/drbd1001',
-                'metaDisk': u'internal',
-                'storPoolName': u'DfltStorPool',
-                'storPoolUuid': u'd2f293f5-5d73-4447-a14b-70efe01302be',
-                'vlmDfnUuid': u'89f6eff2-c4cd-4586-9ab8-8e850568b93b',
-                'vlmMinorNr': 1001,
-                'vlmNr': 0,
-                'vlmUuid': u'b91392ae-904a-4bc6-862f-9c7aca629b35'
-            }
-        ]
+        'driver_name': 'LVM_THIN',
+        'node_name': 'node-2',
+        'sp_uuid': '004faf29-be1a-4d74-9470-038bcee2c611',
+        'sp_cap': 100.0,
+        'sp_free': 100,
+        'sp_name': u'DfltStorPool'
     },
     {
-        'node_name': u'wp-u16-cinder-dev-lg',
-        'rd_name': u'CV_bc3015e6-695f-4688-91f2-1deb4321e4f0',
-        'volume': [
-            {
-                'backingDisk': u'none',
-                'devicePath': u'/dev/drbd1001',
-                'metaDisk': u'internal',
-                'storPoolName': u'DfltStorPool',
-                'storPoolUuid': u'85ef7894-0682-4019-b95a-1b25e81c0cb5',
-                'vlmDfnUuid': u'89f6eff2-c4cd-4586-9ab8-8e850568b93b',
-                'vlmMinorNr': 1001,
-                'vlmNr': 0,
-                'vlmUuid': u'4c63ee46-acb0-4aa5-8758-8fa8f65fdd5a'
-            }
-        ]
+        'driver_name': 'DISKLESS',
+        'node_name': 'node-1',
+        'sp_uuid': '897da09e-1316-45c0-a308-c07008af42df',
+        'sp_allocated': 0.0,
+        'sp_cap': -1.0,
+        'sp_free': -1.0,
+        'sp_name': 'DfltStorPool'
     }
 ]
 
 VOLUME_STATS_RESP = {
     'driver_version': '0.0.7',
-    'pools': [
-        {
-            'QoS_support': False,
-            'backend_state': 'up',
-            'filter_function': None,
-            'free_capacity_gb': 35.0,
-            'goodness_function': None,
-            'location_info': 'linstor://localhost',
-            'max_over_subscription_ratio': 0,
-            'multiattach': False,
-            'pool_name': 'lin-test-driver',
-            'provisioned_capacity_gb': 1.0,
-            'reserved_percentage': 0,
-            'thick_provisioning_support': False,
-            'thin_provisioning_support': True,
-            'total_capacity_gb': 35.0,
-            'total_volumes': 1,
-        }
-    ],
+    'pools': [{
+        'QoS_support': False,
+        'backend_state': 'up',
+        'filter_function': None,
+        'free_capacity_gb': 100,
+        'goodness_function': None,
+        'location_info': 'linstor://localhost',
+        'max_over_subscription_ratio': 0,
+        'multiattach': False,
+        'pool_name': 'lin-test-driver',
+        'provisioned_capacity_gb': 0.0,
+        'reserved_percentage': 0,
+        'thick_provisioning_support': False,
+        'thin_provisioning_support': True,
+        'total_capacity_gb': 100.0,
+        'total_volumes': 1,
+    }],
     'vendor_name': 'LINBIT',
     'volume_backend_name': 'lin-test-driver'
 }
 
 CINDER_VOLUME = {
-    'id': 'bc3015e6-695f-4688-91f2-1deb4321e4f0',
+    'id': '0348a7d3-3bb9-452d-9f40-2cf5ebfe9131',
     'name': 'test-lin-vol',
     'size': 1,
     'volume_type_id': 'linstor',
@@ -469,15 +330,15 @@ CINDER_VOLUME = {
 }
 
 SNAPSHOT = {
-    'id': 'bc3015e6-695f-4688-91f2-1deb4321e4f0',
-    'volume_id': 'bc3015e6-695f-4688-91f2-1deb4321e4f0',
+    'id': '0348a7d3-3bb9-452d-9f40-2cf5ebfe9131',
+    'volume_id': '0348a7d3-3bb9-452d-9f40-2cf5ebfe9131',
     'volume_size': 1
 }
 
 VOLUME_NAMES = {
-    'linstor': 'CV_bc3015e6-695f-4688-91f2-1deb4321e4f0',
-    'cinder': 'bc3015e6-695f-4688-91f2-1deb4321e4f0',
-    'snap': 'SN_bc3015e6-695f-4688-91f2-1deb4321e4f0',
+    'linstor': 'CV_0348a7d3-3bb9-452d-9f40-2cf5ebfe9131',
+    'cinder': '0348a7d3-3bb9-452d-9f40-2cf5ebfe9131',
+    'snap': 'SN_0348a7d3-3bb9-452d-9f40-2cf5ebfe9131',
 }
 
 
@@ -498,9 +359,6 @@ class LinstorAPIFakeDriver(object):
     def fake_api_storage_pool_list(self):
         return STORAGE_POOL_LIST
 
-    def fake_api_volume_list(self):
-        return VOLUME_LIST
-
     def fake_api_resource_dfn_list(self):
         return RESOURCE_DFN_LIST
 
@@ -508,6 +366,22 @@ class LinstorAPIFakeDriver(object):
         return SNAPSHOT_LIST_RESP
 
 
+class LinstorFakeResource(object):
+
+    def __init__(self):
+        self.volumes = [{'size': 1069547520}]
+        self.id = 0
+
+    def delete(self):
+        return True
+
+    def is_diskless(self, host):
+        if host in DISKLESS_LIST_RESP:
+            return True
+        else:
+            return False
+
+
 class LinstorBaseDriverTestCase(test.TestCase):
 
     def __init__(self, *args, **kwargs):
@@ -530,13 +404,14 @@ class LinstorBaseDriverTestCase(test.Tes
         self.driver.default_rsc_size = 1
         self.driver.default_vg_name = 'vg-1'
         self.driver.default_downsize_factor = int('4096')
-        self.driver.default_pool = STORAGE_POOL_DEF_RESP[0]['spd_name']
-        self.driver.host_name = 'node_one'
+        self.driver.default_pool = STORAGE_POOL_DEF_RESP[0]
+        self.driver.host_name = 'node-1'
         self.driver.diskless = True
         self.driver.default_uri = 'linstor://localhost'
         self.driver.default_backend_name = 'lin-test-driver'
         self.driver.configuration.reserved_percentage = 0
         self.driver.configuration.max_over_subscription_ratio = 0
+        self.driver.ap_count = 0
 
     @mock.patch(DRIVER + 'LinstorBaseDriver._ping')
     def test_ping(self, m_ping):
@@ -554,23 +429,50 @@ class LinstorBaseDriverTestCase(test.Tes
         expected = u'bd6472d1-dc3c-4d41-a5f0-f44271c05680'
         self.assertEqual(expected, val)
 
+    @mock.patch('uuid.uuid4')
+    def test_clean_uuid_with_braces(self, m_uuid):
+        m_uuid.return_value = u'{bd6472d1-dc3c-4d41-a5f0-f44271c05680}'
+
+        val = self.driver._clean_uuid()
+        expected = u'bd6472d1-dc3c-4d41-a5f0-f44271c05680'
+
+        m_uuid.assert_called_once()
+        self.assertEqual(expected, val)
+
     # Test volume size conversions
-    def test_unit_conversions_to_linstor(self):
+    def test_unit_conversions_to_linstor_1GiB(self):
         val = self.driver._vol_size_to_linstor(1)
         expected = 1044480   # 1048575 - 4096
         self.assertEqual(expected, val)
 
+    def test_unit_conversions_to_linstor_2GiB(self):
+        val = self.driver._vol_size_to_linstor(2)
+        expected = 2093056   # 2097152 - 4096
+        self.assertEqual(expected, val)
+
     def test_unit_conversions_to_cinder(self):
         val = self.driver._vol_size_to_cinder(1048576)
         expected = 1
         self.assertEqual(expected, val)
 
+    def test_unit_conversions_to_cinder_2GiB(self):
+        val = self.driver._vol_size_to_cinder(2097152)
+        expected = 2
+        self.assertEqual(expected, val)
+
     def test_is_clean_volume_name(self):
         val = self.driver._is_clean_volume_name(VOLUME_NAMES['cinder'],
                                                 drv.DM_VN_PREFIX)
         expected = VOLUME_NAMES['linstor']
         self.assertEqual(expected, val)
 
+    def test_is_clean_volume_name_invalid(self):
+        wrong_uuid = 'bc3015e6-695f-4688-91f2-invaliduuid1'
+        val = self.driver._is_clean_volume_name(wrong_uuid,
+                                                drv.DM_VN_PREFIX)
+        expected = None
+        self.assertEqual(expected, val)
+
     def test_snapshot_name_from_cinder_snapshot(self):
         val = self.driver._snapshot_name_from_cinder_snapshot(
             SNAPSHOT)
@@ -600,7 +502,9 @@ class LinstorBaseDriverTestCase(test.Tes
         m_rsc_list.return_value = self._fake_driver.fake_api_resource_list()
 
         val = self.driver._get_rsc_path(VOLUME_NAMES['linstor'])
-        expected = '/dev/drbd1000'
+        expected = '/dev/drbd1005'
+
+        m_rsc_list.assert_called_once()
         self.assertEqual(expected, val)
 
     @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_resource_list')
@@ -608,7 +512,9 @@ class LinstorBaseDriverTestCase(test.Tes
         m_rsc_list.return_value = self._fake_driver.fake_api_resource_list()
 
         val = self.driver._get_local_path(CINDER_VOLUME)
-        expected = '/dev/drbd1000'
+        expected = '/dev/drbd1005'
+
+        m_rsc_list.assert_called_once()
         self.assertEqual(expected, val)
 
     @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_storage_pool_dfn_list')
@@ -618,6 +524,8 @@ class LinstorBaseDriverTestCase(test.Tes
 
         val = self.driver._get_spd()
         expected = STORAGE_POOL_DEF_RESP
+
+        m_spd_list.assert_called_once()
         self.assertEqual(expected, val)
 
     @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_storage_pool_list')
@@ -627,6 +535,8 @@ class LinstorBaseDriverTestCase(test.Tes
 
         val = self.driver._get_storage_pool()
         expected = STORAGE_POOL_LIST_RESP
+
+        m_sp_list.assert_called_once()
         self.assertEqual(expected, val)
 
     @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_resource_dfn_list')
@@ -636,6 +546,8 @@ class LinstorBaseDriverTestCase(test.Tes
 
         val = self.driver._get_resource_definitions()
         expected = RESOURCE_DFN_LIST_RESP
+
+        m_rscd_list.assert_called_once()
         self.assertEqual(expected, val)
 
     @mock.patch(DRIVER + 'LinstorBaseDriver._get_snapshot_nodes')
@@ -644,24 +556,43 @@ class LinstorBaseDriverTestCase(test.Tes
 
         val = self.driver._get_snapshot_nodes(VOLUME_NAMES['linstor'])
         expected = SNAPSHOT_LIST_RESP
+
+        m_rsc_list.assert_called_once()
+        self.assertEqual(expected, val)
+
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_resource_list')
+    def test_get_diskless_nodes(self, m_rsc_list):
+        m_rsc_list.return_value = self._fake_driver.fake_api_resource_list()
+
+        val = self.driver._get_diskless_nodes(RESOURCE['name'])
+        expected = DISKLESS_LIST_RESP
+
+        m_rsc_list.assert_called_once()
         self.assertEqual(expected, val)
 
-    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_nodes_list')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_node_list')
     def test_get_linstor_nodes(self, m_node_list):
         m_node_list.return_value = self._fake_driver.fake_api_node_list()
 
         val = self.driver._get_linstor_nodes()
         expected = RESOURCE_LIST_RESP
+
+        m_node_list.assert_called_once()
         self.assertEqual(expected, val)
 
-    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_nodes_list')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_node_list')
     def test_get_nodes(self, m_node_list):
         m_node_list.return_value = self._fake_driver.fake_api_node_list()
 
         val = self.driver._get_nodes()
         expected = NODES_RESP
+
+        m_node_list.assert_called_once()
         self.assertEqual(expected, val)
 
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_size')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_is_diskless')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_resource_list')
     @mock.patch(DRIVER + 'LinstorBaseDriver.get_goodness_function')
     @mock.patch(DRIVER + 'LinstorBaseDriver.get_filter_function')
     @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_resource_dfn_list')
@@ -670,81 +601,79 @@ class LinstorBaseDriverTestCase(test.Tes
                               m_sp_list,
                               m_rscd_list,
                               m_filter,
-                              m_goodness):
+                              m_goodness,
+                              m_rsc_list,
+                              m_diskless,
+                              m_rsc_size):
         m_sp_list.return_value = (
             self._fake_driver.fake_api_storage_pool_list())
         m_rscd_list.return_value = (
             self._fake_driver.fake_api_resource_dfn_list())
         m_filter.return_value = None
         m_goodness.return_value = None
+        m_rsc_list.return_value = RESOURCE_LIST
+        m_diskless.return_value = True
+        m_rsc_size.return_value = 1069547520
 
         val = self.driver._get_volume_stats()
         expected = VOLUME_STATS_RESP
+
+        m_sp_list.assert_called_once()
+        m_rscd_list.assert_called_once()
         self.assertEqual(expected, val)
 
-    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_resource_list')
-    @mock.patch(DRIVER + 'LinstorBaseDriver._check_api_reply')
     @mock.patch(DRIVER + 'LinstorBaseDriver._api_snapshot_create')
     def test_create_snapshot_fail(self,
-                                  m_snap_create,
-                                  m_api_reply,
-                                  m_rsc_list):
-        m_snap_create.return_value = None
-        m_rsc_list.return_value = self._fake_driver.fake_api_resource_list()
-        m_api_reply.return_value = False
+                                  m_snap_create):
+        m_snap_create.return_value = False
 
         self.assertRaises(cinder_exception.VolumeBackendAPIException,
                           self.driver.create_snapshot, SNAPSHOT)
 
-    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_resource_list')
-    @mock.patch(DRIVER + 'LinstorBaseDriver._check_api_reply')
     @mock.patch(DRIVER + 'LinstorBaseDriver._api_snapshot_create')
     def test_create_snapshot_success(self,
-                                     m_snap_create,
-                                     m_api_reply,
-                                     m_rsc_list):
-        m_snap_create.return_value = None
-        m_rsc_list.return_value = self._fake_driver.fake_api_resource_list()
-        m_api_reply.return_value = True
+                                     m_snap_create):
+        m_snap_create.return_value = True
 
         # No exception should be raised
         self.assertIsNone(self.driver.create_snapshot(SNAPSHOT))
 
-    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_resource_dfn_list')
-    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_resource_list')
-    @mock.patch(DRIVER + 'LinstorBaseDriver._check_api_reply')
     @mock.patch(DRIVER + 'LinstorBaseDriver._api_snapshot_delete')
     def test_delete_snapshot_fail(self,
-                                  m_snap_delete,
-                                  m_api_reply,
-                                  m_rsc_list,
-                                  m_rsc_dfn_list):
-        m_snap_delete.return_value = None
-        m_api_reply.return_value = False
-        m_rsc_list.return_value = self._fake_driver.fake_api_resource_list()
-        m_rsc_dfn_list.return_value = (
-            self._fake_driver.fake_api_resource_dfn_list())
+                                  m_snap_delete):
+        m_snap_delete.return_value = False
 
         self.assertRaises(cinder_exception.VolumeBackendAPIException,
                           self.driver.delete_snapshot, SNAPSHOT)
 
-    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_dfn_delete')
-    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_resource_list')
-    @mock.patch(DRIVER + 'LinstorBaseDriver._check_api_reply')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_snapshot_nodes')
     @mock.patch(DRIVER + 'LinstorBaseDriver._api_snapshot_delete')
     def test_delete_snapshot_success(self,
                                      m_snap_delete,
-                                     m_api_reply,
-                                     m_rsc_list,
-                                     m_rsc_dfn_delete):
-        m_snap_delete.return_value = None
-        m_api_reply.return_value = True
-        m_rsc_list.return_value = self._fake_driver.fake_api_resource_list()
-        m_rsc_dfn_delete.return_value = True
+                                     m_snap_nodes):
+        m_snap_delete.return_value = True
+        m_snap_nodes.return_value = self._fake_driver.fake_api_snapshot_list()
+
+        # No exception should be raised
+        self.driver.delete_snapshot(SNAPSHOT)
+
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_dfn_delete')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_snapshot_nodes')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_snapshot_delete')
+    def test_delete_snapshot_success_cleanup_rd(self,
+                                                m_snap_delete,
+                                                m_snap_nodes,
+                                                m_rd_delete):
+        m_snap_delete.return_value = True
+        m_snap_nodes.return_value = []
+        m_rd_delete.return_value = None
 
         # No exception should be raised
         self.driver.delete_snapshot(SNAPSHOT)
 
+        # Resource Definition Delete should run once
+        m_rd_delete.assert_called_once()
+
     @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_storage_pool_list')
     @mock.patch(DRIVER + 'LinstorBaseDriver._api_volume_dfn_set_sp')
     @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_volume_extend')
@@ -768,8 +697,6 @@ class LinstorBaseDriverTestCase(test.Tes
         m_api_reply.return_value = True
         m_snap_vd_restore.return_value = True
         m_nodes = []
-        m_nodes.append('for test')
-        m_nodes.remove('for test')
         m_lin_nodes.return_value = m_nodes
         m_snap_rsc_restore.return_value = True
         m_rsc_create.return_value = True
@@ -778,16 +705,95 @@ class LinstorBaseDriverTestCase(test.Tes
         m_sp_list.return_value = (
             self._fake_driver.fake_api_storage_pool_list())
 
+        # No exception should be raised
         self.assertIsNone(self.driver.create_volume_from_snapshot(
             CINDER_VOLUME, SNAPSHOT))
 
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_storage_pool_list')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_volume_dfn_set_sp')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_volume_extend')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_create')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_snapshot_resource_restore')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_linstor_nodes')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_snapshot_volume_dfn_restore')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._check_api_reply')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_dfn_create')
+    def test_create_volume_from_snapshot_fail_restore(self,
+                                                      m_rsc_dfn_create,
+                                                      m_api_reply,
+                                                      m_snap_vd_restore,
+                                                      m_lin_nodes,
+                                                      m_snap_rsc_restore,
+                                                      m_rsc_create,
+                                                      m_vol_extend,
+                                                      m_vol_dfn,
+                                                      m_sp_list):
+        m_rsc_dfn_create.return_value = True
+        m_api_reply.return_value = True
+        m_snap_vd_restore.return_value = True
+        m_nodes = []
+        m_lin_nodes.return_value = m_nodes
+        m_snap_rsc_restore.return_value = False
+        m_rsc_create.return_value = True
+        m_vol_extend.return_value = True
+        m_vol_dfn.return_value = True
+        m_sp_list.return_value = (
+            self._fake_driver.fake_api_storage_pool_list())
+
+        # Failing to restore a snapshot should raise an exception
+        self.assertRaises(cinder_exception.VolumeBackendAPIException,
+                          self.driver.create_volume_from_snapshot,
+                          CINDER_VOLUME, SNAPSHOT)
+
+    @mock.patch(DRIVER + 'LinstorBaseDriver.delete_volume')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_storage_pool_list')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_volume_dfn_set_sp')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_volume_extend')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_create')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_snapshot_resource_restore')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_linstor_nodes')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_snapshot_volume_dfn_restore')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._check_api_reply')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_dfn_create')
+    def test_create_volume_from_snapshot_fail_extend(self,
+                                                     m_rsc_dfn_create,
+                                                     m_api_reply,
+                                                     m_snap_vd_restore,
+                                                     m_lin_nodes,
+                                                     m_snap_rsc_restore,
+                                                     m_rsc_create,
+                                                     m_vol_extend,
+                                                     m_vol_dfn,
+                                                     m_sp_list,
+                                                     m_delete_volume):
+        m_rsc_dfn_create.return_value = True
+        m_api_reply.return_value = False
+        m_snap_vd_restore.return_value = True
+        m_nodes = []
+        m_lin_nodes.return_value = m_nodes
+        m_snap_rsc_restore.return_value = True
+        m_rsc_create.return_value = True
+        m_vol_extend.return_value = True
+        m_vol_dfn.return_value = True
+        m_sp_list.return_value = (
+            self._fake_driver.fake_api_storage_pool_list())
+        m_delete_volume.return_value = True
+
+        # Failing to extend the volume after a snapshot restoration should
+        # raise an exception
+        new_volume = CINDER_VOLUME
+        new_volume['size'] = 2
+        self.assertRaises(cinder_exception.VolumeBackendAPIException,
+                          self.driver.create_volume_from_snapshot,
+                          new_volume, SNAPSHOT)
+
     @mock.patch(DRIVER + 'LinstorBaseDriver._check_api_reply')
     @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_create')
     @mock.patch(DRIVER + 'LinstorBaseDriver._api_volume_dfn_create')
     @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_dfn_create')
     @mock.patch(DRIVER + 'LinstorBaseDriver._api_storage_pool_create')
     @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_storage_pool_dfn_list')
-    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_nodes_list')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_node_list')
     @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_storage_pool_list')
     def test_create_volume_fail_no_linstor_nodes(self,
                                                  m_sp_list,
@@ -824,7 +830,7 @@ class LinstorBaseDriverTestCase(test.Tes
     @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_dfn_create')
     @mock.patch(DRIVER + 'LinstorBaseDriver._api_storage_pool_create')
     @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_storage_pool_dfn_list')
-    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_nodes_list')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_node_list')
     @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_storage_pool_list')
     def test_create_volume_fail_rsc_create(self,
                                            m_sp_list,
@@ -862,7 +868,7 @@ class LinstorBaseDriverTestCase(test.Tes
     @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_dfn_create')
     @mock.patch(DRIVER + 'LinstorBaseDriver._api_storage_pool_create')
     @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_storage_pool_dfn_list')
-    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_nodes_list')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_node_list')
     @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_storage_pool_list')
     def test_create_volume(self,
                            m_sp_list,
@@ -893,8 +899,9 @@ class LinstorBaseDriverTestCase(test.Tes
 
         val = self.driver.create_volume(test_volume)
         expected = {}
-        self.assertEqual(val, expected)
+        self.assertEqual(expected, val)
 
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_auto_delete')
     @mock.patch(DRIVER + 'LinstorBaseDriver._check_api_reply')
     @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_dfn_delete')
     @mock.patch(DRIVER + 'LinstorBaseDriver._api_volume_dfn_delete')
@@ -905,21 +912,126 @@ class LinstorBaseDriverTestCase(test.Tes
                                            m_rsc_delete,
                                            m_vol_dfn_delete,
                                            m_rsc_dfn_delete,
-                                           m_api_reply):
+                                           m_api_reply,
+                                           m_rsc_auto_delete):
         m_rsc_list.return_value = self._fake_driver.fake_api_resource_list()
         m_rsc_delete.return_value = True
         m_vol_dfn_delete.return_value = True
         m_rsc_dfn_delete.return_value = True
         m_api_reply.return_value = False
+        m_rsc_auto_delete.return_value = True
+
+        test_volume = CINDER_VOLUME
+        test_volume['display_name'] = 'linstor_test'
+        test_volume['host'] = 'node_one'
+        test_volume['size'] = 1
+
+        self.assertRaises(cinder_exception.VolumeBackendAPIException,
+                          self.driver.delete_volume, test_volume)
+
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_auto_delete')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_diskless_nodes')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._check_api_reply')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_dfn_delete')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_volume_dfn_delete')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_delete')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_resource_list')
+    def test_delete_volume_fail_diskless_remove(self,
+                                                m_rsc_list,
+                                                m_rsc_delete,
+                                                m_vol_dfn_delete,
+                                                m_rsc_dfn_delete,
+                                                m_api_reply,
+                                                m_diskless,
+                                                m_rsc_auto_delete):
+        m_rsc_list.return_value = self._fake_driver.fake_api_resource_list()
+        m_rsc_delete.return_value = False
+        m_vol_dfn_delete.return_value = True
+        m_rsc_dfn_delete.return_value = True
+        m_api_reply.return_value = False
+        m_diskless.return_value = ['foo']
+        m_rsc_auto_delete.return_value = True
+
+        test_volume = CINDER_VOLUME
+        test_volume['display_name'] = 'linstor_test'
+        test_volume['host'] = 'node_one'
+        test_volume['size'] = 1
+
+        # Raises exception for failing to delete a diskless resource
+        self.assertRaises(cinder_exception.VolumeBackendAPIException,
+                          self.driver.delete_volume, test_volume)
+
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_auto_delete')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_snapshot_nodes')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_diskless_nodes')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._check_api_reply')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_dfn_delete')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_volume_dfn_delete')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_delete')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_resource_list')
+    def test_delete_volume_fail_diskful_remove(self,
+                                               m_rsc_list,
+                                               m_rsc_delete,
+                                               m_vol_dfn_delete,
+                                               m_rsc_dfn_delete,
+                                               m_api_reply,
+                                               m_diskless,
+                                               m_snap_nodes,
+                                               m_rsc_auto_delete):
+        m_rsc_list.return_value = self._fake_driver.fake_api_resource_list()
+        m_rsc_delete.return_value = False
+        m_vol_dfn_delete.return_value = True
+        m_rsc_dfn_delete.return_value = True
+        m_api_reply.return_value = False
+        m_diskless.return_value = []
+        m_snap_nodes.return_value = ['foo']
+        m_rsc_auto_delete.return_value = True
 
         test_volume = CINDER_VOLUME
         test_volume['display_name'] = 'linstor_test'
         test_volume['host'] = 'node_one'
         test_volume['size'] = 1
 
+        # Raises exception for failing to delete a diskful resource
         self.assertRaises(cinder_exception.VolumeBackendAPIException,
                           self.driver.delete_volume, test_volume)
 
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_auto_delete')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_snapshot_nodes')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_diskless_nodes')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._check_api_reply')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_dfn_delete')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_volume_dfn_delete')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_delete')
+    @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_resource_list')
+    def test_delete_volume_fail_volume_definition(self,
+                                                  m_rsc_list,
+                                                  m_rsc_delete,
+                                                  m_vol_dfn_delete,
+                                                  m_rsc_dfn_delete,
+                                                  m_api_reply,
+                                                  m_diskless,
+                                                  m_snap_nodes,
+                                                  m_rsc_auto_delete):
+        m_rsc_list.return_value = self._fake_driver.fake_api_resource_list()
+        m_rsc_delete.return_value = True
+        m_vol_dfn_delete.return_value = False
+        m_rsc_dfn_delete.return_value = True
+        m_api_reply.return_value = False
+        m_diskless.return_value = []
+        m_snap_nodes.return_value = []
+        m_rsc_auto_delete.return_value = True
+
+        test_volume = CINDER_VOLUME
+        test_volume['display_name'] = 'linstor_test'
+        test_volume['host'] = 'node_one'
+        test_volume['size'] = 1
+
+        # Raises exception for failing to delete a volume definition
+        self.assertRaises(cinder_exception.VolumeBackendAPIException,
+                          self.driver.delete_volume, test_volume)
+
+    @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_auto_delete')
     @mock.patch(DRIVER + 'LinstorBaseDriver._check_api_reply')
     @mock.patch(DRIVER + 'LinstorBaseDriver._api_rsc_dfn_delete')
     @mock.patch(DRIVER + 'LinstorBaseDriver._api_volume_dfn_delete')
@@ -930,12 +1042,14 @@ class LinstorBaseDriverTestCase(test.Tes
                            m_rsc_delete,
                            m_vol_dfn_delete,
                            m_rsc_dfn_delete,
-                           m_api_reply):
+                           m_api_reply,
+                           m_rsc_auto_delete):
         m_rsc_list.return_value = self._fake_driver.fake_api_resource_list()
         m_rsc_delete.return_value = True
         m_vol_dfn_delete.return_value = True
         m_rsc_dfn_delete.return_value = True
         m_api_reply.return_value = True
+        m_rsc_auto_delete.return_value = True
 
         test_volume = CINDER_VOLUME
         test_volume['display_name'] = 'linstor_test'
@@ -944,7 +1058,7 @@ class LinstorBaseDriverTestCase(test.Tes
 
         val = self.driver.delete_volume(test_volume)
         expected = True
-        self.assertEqual(val, expected)
+        self.assertEqual(expected, val)
 
     @mock.patch(DRIVER + 'LinstorBaseDriver._check_api_reply')
     @mock.patch(DRIVER + 'LinstorBaseDriver._get_api_volume_extend')
@@ -973,7 +1087,7 @@ class LinstorBaseDriverTestCase(test.Tes
 
         val = self.driver.migrate_volume(m_ctxt, m_volume, m_host)
         expected = (False, None)
-        self.assertEqual(val, expected)
+        self.assertEqual(expected, val)
 
 
 class LinstorIscsiDriverTestCase(test.TestCase):
@@ -996,7 +1110,7 @@ class LinstorIscsiDriverTestCase(test.Te
         self.driver.default_rsc_size = 1
         self.driver.default_vg_name = 'vg-1'
         self.driver.default_downsize_factor = int('4096')
-        self.driver.default_pool = STORAGE_POOL_DEF_RESP[0]['spd_name']
+        self.driver.default_pool = STORAGE_POOL_DEF_RESP[0]
         self.driver.host_name = 'node_one'
         self.driver.diskless = True
         self.driver.location_info = 'LinstorIscsi:linstor://localhost'
@@ -1004,22 +1118,22 @@ class LinstorIscsiDriverTestCase(test.Te
         self.driver.configuration.reserved_percentage = int('0')
         self.driver.configuration.max_over_subscription_ratio = int('0')
 
+    @mock.patch(DRIVER + 'LinstorIscsiDriver._get_api_resource_list')
     @mock.patch(DRIVER + 'LinstorIscsiDriver._get_volume_stats')
-    def test_iscsi_get_volume_stats(self, m_vol_stats):
+    def test_iscsi_get_volume_stats(self, m_vol_stats, m_rsc_list):
 
         m_vol_stats.return_value = VOLUME_STATS_RESP
+        m_rsc_list.return_value = RESOURCE_LIST
 
         val = self.driver.get_volume_stats()
 
         expected = VOLUME_STATS_RESP
         expected["storage_protocol"] = 'iSCSI'
-        self.assertEqual(val, expected)
+        self.assertEqual(expected, val)
 
-    @mock.patch(DRIVER + 'proto')
     @mock.patch(DRIVER + 'linstor')
-    def test_iscsi_check_for_setup_error_pass(self, m_linstor, m_proto):
+    def test_iscsi_check_for_setup_error_pass(self, m_linstor):
         m_linstor.return_value = True
-        m_proto.return_value = True
 
         # No exception should be raised
         self.driver.check_for_setup_error()
@@ -1044,7 +1158,7 @@ class LinstorDrbdDriverTestCase(test.Tes
         self.driver.default_rsc_size = 1
         self.driver.default_vg_name = 'vg-1'
         self.driver.default_downsize_factor = int('4096')
-        self.driver.default_pool = STORAGE_POOL_DEF_RESP[0]['spd_name']
+        self.driver.default_pool = STORAGE_POOL_DEF_RESP[0]
         self.driver.host_name = 'node_one'
         self.driver.diskless = True
         self.driver.location_info = 'LinstorDrbd:linstor://localhost'
@@ -1054,7 +1168,7 @@ class LinstorDrbdDriverTestCase(test.Tes
 
     @mock.patch(DRIVER + 'LinstorDrbdDriver._get_rsc_path')
     def test_drbd_return_drbd_config(self, m_rsc_path):
-        m_rsc_path.return_value = '/dev/drbd1000'
+        m_rsc_path.return_value = '/dev/drbd1005'
 
         val = self.driver._return_drbd_config(CINDER_VOLUME)
 
@@ -1064,14 +1178,14 @@ class LinstorDrbdDriverTestCase(test.Tes
                 "device_path": str(m_rsc_path.return_value)
             }
         }
-        self.assertEqual(val, expected)
+        self.assertEqual(expected, val)
 
     @mock.patch(DRIVER + 'LinstorDrbdDriver._get_api_storage_pool_list')
     def test_drbd_node_in_sp(self, m_sp_list):
         m_sp_list.return_value = (
             self._fake_driver.fake_api_storage_pool_list())
 
-        val = self.driver._node_in_sp('node_two')
+        val = self.driver._node_in_sp('node-1')
         self.assertTrue(val)
 
     @mock.patch(DRIVER + 'LinstorDrbdDriver._get_volume_stats')
@@ -1081,13 +1195,11 @@ class LinstorDrbdDriverTestCase(test.Tes
         val = self.driver.get_volume_stats()
         expected = VOLUME_STATS_RESP
         expected["storage_protocol"] = 'DRBD'
-        self.assertEqual(val, expected)
+        self.assertEqual(expected, val)
 
-    @mock.patch(DRIVER + 'proto')
     @mock.patch(DRIVER + 'linstor')
-    def test_drbd_check_for_setup_error_pass(self, m_linstor, m_proto):
+    def test_drbd_check_for_setup_error_pass(self, m_linstor):
         m_linstor.return_value = True
-        m_proto.return_value = True
 
         # No exception should be raised
         self.driver.check_for_setup_error()
@@ -1117,7 +1229,7 @@ class LinstorDrbdDriverTestCase(test.Tes
                 "device_path": str(m_rsc_path.return_value)
             }
         }
-        self.assertEqual(val, expected)
+        self.assertEqual(expected, val)
 
     @mock.patch(DRIVER + 'LinstorDrbdDriver._check_api_reply')
     @mock.patch(DRIVER + 'LinstorDrbdDriver._api_rsc_delete')
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_lvm_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_lvm_driver.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_lvm_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_lvm_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,11 +10,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import ddt
 import os
 import socket
+from unittest import mock
 
-import mock
+import ddt
 from oslo_concurrency import processutils
 from oslo_config import cfg
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_nfs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_nfs.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_nfs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_nfs.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,15 +14,15 @@
 #    under the License.
 """Unit tests for the NFS driver module."""
 
-import ddt
 import errno
 import os
-import six
+from unittest import mock
 import uuid
 
-import mock
+import ddt
 from oslo_utils import imageutils
 from oslo_utils import units
+import six
 
 from cinder import context
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_nimble.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_nimble.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_nimble.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_nimble.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,1431 +0,0 @@
-# Nimble Storage, Inc. (c) 2013-2014
-# All Rights Reserved.
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-
-
-import mock
-from six.moves import http_client
-import sys
-
-from cinder import context
-from cinder import exception
-from cinder.objects import volume as obj_volume
-from cinder import test
-from cinder.tests.unit import fake_constants as fake
-from cinder.volume.drivers import nimble
-from cinder.volume import volume_types
-
-NIMBLE_CLIENT = 'cinder.volume.drivers.nimble.NimbleRestAPIExecutor'
-NIMBLE_URLLIB2 = 'cinder.volume.drivers.nimble.requests'
-NIMBLE_RANDOM = 'cinder.volume.drivers.nimble.random'
-NIMBLE_ISCSI_DRIVER = 'cinder.volume.drivers.nimble.NimbleISCSIDriver'
-NIMBLE_FC_DRIVER = 'cinder.volume.drivers.nimble.NimbleFCDriver'
-DRIVER_VERSION = '4.0.1'
-nimble.DEFAULT_SLEEP = 0
-
-FAKE_POSITIVE_LOGIN_RESPONSE_1 = '2c20aad78a220ed1dae21dcd6f9446f5'
-
-FAKE_POSITIVE_LOGIN_RESPONSE_2 = '2c20aad78a220ed1dae21dcd6f9446ff'
-
-FAKE_POSITIVE_HEADERS = {'X-Auth-Token': FAKE_POSITIVE_LOGIN_RESPONSE_1}
-
-FAKE_POSITIVE_NETCONFIG_RESPONSE = {
-    'role': 'active',
-    'subnet_list': [{'network': '172.18.212.0',
-                     'discovery_ip': '172.18.108.21',
-                     'type': 'data',
-                     'allow_iscsi': True,
-                     'label': 'data1',
-                     'allow_group': True,
-                     'vlan_id': 0}],
-    'array_list': [{'nic_list': [{'subnet_label': 'data1',
-                                  'tagged': False,
-                                  'data_ip': '172.18.212.82',
-                                  'name': 'eth3'}]}],
-    'name': 'test-array'}
-
-FAKE_NEGATIVE_NETCONFIG_RESPONSE = exception.VolumeDriverException(
-    "Session expired")
-
-FAKE_CREATE_VOLUME_POSITIVE_RESPONSE = {
-    'clone': False,
-    'name': "testvolume"}
-
-FAKE_CREATE_VOLUME_POSITIVE_RESPONSE_ENCRYPTION = {
-    'clone': False,
-    'name': "testvolume-encryption"}
-
-FAKE_CREATE_VOLUME_POSITIVE_RESPONSE_PERF_POLICY = {
-    'clone': False,
-    'name': "testvolume-perf-policy"}
-
-FAKE_CREATE_VOLUME_POSITIVE_RESPONSE_MULTI_INITIATOR = {
-    'clone': False,
-    'name': "testvolume-multi-initiator"}
-
-FAKE_CREATE_VOLUME_POSITIVE_RESPONSE_DEDUPE = {
-    'clone': False,
-    'name': "testvolume-dedupe"}
-
-FAKE_CREATE_VOLUME_POSITIVE_RESPONSE_QOS = {
-    'clone': False,
-    'name': "testvolume-qos"}
-
-FAKE_GET_VOL_INFO_RESPONSE = {'name': 'testvolume',
-                              'clone': False,
-                              'target_name': 'iqn.test',
-                              'online': True,
-                              'agent_type': 'openstack'}
-
-FAKE_GET_VOL_INFO_RESPONSE_MANAGE = {'name': 'testvolume',
-                                     'agent_type': 'none',
-                                     'online': False,
-                                     'target_name': 'iqn.test'}
-
-FAKE_GET_VOL_INFO_ONLINE = {'name': 'testvolume',
-                            'size': 2048,
-                            'online': True,
-                            'agent_type': 'none'}
-
-FAKE_GET_VOL_INFO_BACKUP_RESPONSE = {'name': 'testvolume',
-                                     'clone': True,
-                                     'target_name': 'iqn.test',
-                                     'online': False,
-                                     'agent_type': 'openstack',
-                                     'parent_vol_id': 'volume-' +
-                                                      fake.VOLUME2_ID,
-                                     'base_snap_id': 'test-backup-snap'}
-
-FAKE_GET_SNAP_INFO_BACKUP_RESPONSE = {
-    'description': "backup-vol-" + fake.VOLUME2_ID,
-    'name': 'test-backup-snap',
-    'id': fake.SNAPSHOT_ID,
-    'vol_id': fake.VOLUME_ID,
-    'volume_name': 'volume-' + fake.VOLUME_ID}
-
-FAKE_POSITIVE_GROUP_CONFIG_RESPONSE = {
-    'name': 'group-test',
-    'version_current': '0.0.0.0',
-    'access_protocol_list': ['iscsi']}
-
-FAKE_LOGIN_POST_RESPONSE = {
-    'data': {'session_token': FAKE_POSITIVE_LOGIN_RESPONSE_1}}
-
-FAKE_EXTEND_VOLUME_PARAMS = {'data': {'size': 5120,
-                                      'reserve': 0,
-                                      'warn_level': 80,
-                                      'limit': 100,
-                                      'snap_limit': sys.maxsize}}
-
-FAKE_IGROUP_LIST_RESPONSE = [
-    {'iscsi_initiators': [{'iqn': 'test-initiator1'}],
-     'name': 'test-igrp1'},
-    {'iscsi_initiators': [{'iqn': 'test-initiator2'}],
-     'name': 'test-igrp2'}]
-
-FAKE_IGROUP_LIST_RESPONSE_FC = [
-    {'fc_initiators': [{'wwpn': '10:00:00:00:00:00:00:00'}],
-     'name': 'test-igrp1'},
-    {'fc_initiators': [{'wwpn': '10:00:00:00:00:00:00:00'},
-                       {'wwpn': '10:00:00:00:00:00:00:01'}],
-     'name': 'test-igrp2'}]
-
-
-FAKE_CREATE_VOLUME_NEGATIVE_RESPONSE = exception.VolumeBackendAPIException(
-    "Volume testvolume not found")
-
-FAKE_VOLUME_INFO_NEGATIVE_RESPONSE = exception.VolumeBackendAPIException(
-    "Volume testvolume not found")
-
-FAKE_CREATE_VOLUME_NEGATIVE_ENCRYPTION = exception.VolumeBackendAPIException(
-    "Volume testvolume-encryption not found")
-
-FAKE_CREATE_VOLUME_NEGATIVE_PERFPOLICY = exception.VolumeBackendAPIException(
-    "Volume testvolume-perfpolicy not found")
-
-FAKE_CREATE_VOLUME_NEGATIVE_DEDUPE = exception.VolumeBackendAPIException(
-    "The specified pool is not capable of hosting deduplicated volumes")
-
-FAKE_CREATE_VOLUME_NEGATIVE_QOS = exception.VolumeBackendAPIException(
-    "Please set valid IOPS limitin the range [256, 4294967294]")
-
-FAKE_POSITIVE_GROUP_INFO_RESPONSE = {
-    'version_current': '3.0.0.0',
-    'group_target_enabled': False,
-    'name': 'group-nimble',
-    'usage_valid': True,
-    'usable_capacity_bytes': 8016883089408,
-    'compressed_vol_usage_bytes': 2938311843,
-    'compressed_snap_usage_bytes': 36189,
-    'unused_reserve_bytes': 0}
-
-FAKE_GENERIC_POSITIVE_RESPONSE = ""
-FAKE_VOLUME_DELETE_HAS_CLONE_RESPONSE = "Object has a clone"
-
-FAKE_TYPE_ID = fake.VOLUME_TYPE_ID
-FAKE_TYPE_ID_NEW = fake.VOLUME_TYPE2_ID
-FAKE_POOL_ID = fake.GROUP_ID
-FAKE_PERFORMANCE_POLICY_ID = fake.OBJECT_ID
-NIMBLE_MANAGEMENT_IP = "10.18.108.55"
-NIMBLE_SAN_LOGIN = "nimble"
-NIMBLE_SAN_PASS = "nimble_pass"
-
-
-def create_configuration(username, password, ip_address,
-                         pool_name=None, subnet_label=None,
-                         thin_provision=True):
-    configuration = mock.Mock()
-    configuration.san_login = username
-    configuration.san_password = password
-    configuration.san_ip = ip_address
-    configuration.san_thin_provision = thin_provision
-    configuration.nimble_pool_name = pool_name
-    configuration.nimble_subnet_label = subnet_label
-    configuration.safe_get.return_value = 'NIMBLE'
-    return configuration
-
-
-class NimbleDriverBaseTestCase(test.TestCase):
-
-    """Base Class for the NimbleDriver Tests."""
-
-    def setUp(self):
-        super(NimbleDriverBaseTestCase, self).setUp()
-        self.mock_client_service = None
-        self.mock_client_class = None
-        self.driver = None
-
-    @staticmethod
-    def client_mock_decorator(configuration):
-        def client_mock_wrapper(func):
-            def inner_client_mock(
-                    self, mock_client_class, mock_urllib2, *args, **kwargs):
-                self.mock_client_class = mock_client_class
-                self.mock_client_service = mock.MagicMock(name='Client')
-                self.mock_client_class.return_value = self.mock_client_service
-                self.driver = nimble.NimbleISCSIDriver(
-                    configuration=configuration)
-                mock_login_response = mock_urllib2.post.return_value
-                mock_login_response = mock.MagicMock()
-                mock_login_response.status_code.return_value = http_client.OK
-                mock_login_response.json.return_value = (
-                    FAKE_LOGIN_POST_RESPONSE)
-                self.driver.do_setup(context.get_admin_context())
-                self.driver.APIExecutor.login()
-                func(self, *args, **kwargs)
-            return inner_client_mock
-        return client_mock_wrapper
-
-    @staticmethod
-    def client_mock_decorator_fc(configuration):
-        def client_mock_wrapper(func):
-            def inner_client_mock(
-                    self, mock_client_class, mock_urllib2, *args, **kwargs):
-                self.mock_client_class = mock_client_class
-                self.mock_client_service = mock.MagicMock(name='Client')
-                self.mock_client_class.return_value = (
-                    self.mock_client_service)
-                self.driver = nimble.NimbleFCDriver(
-                    configuration=configuration)
-                mock_login_response = mock_urllib2.post.return_value
-                mock_login_response = mock.MagicMock()
-                mock_login_response.status_code.return_value = http_client.OK
-                mock_login_response.json.return_value = (
-                    FAKE_LOGIN_POST_RESPONSE)
-                self.driver.do_setup(context.get_admin_context())
-                self.driver.APIExecutor.login()
-                func(self, *args, **kwargs)
-            return inner_client_mock
-        return client_mock_wrapper
-
-
-class NimbleDriverLoginTestCase(NimbleDriverBaseTestCase):
-
-    """Tests do_setup api."""
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        "nimble", "nimble_pass", "10.18.108.55", 'default', '*'))
-    def test_do_setup_positive(self):
-        expected_call_list = [mock.call.login()]
-        self.mock_client_service.assert_has_calls(expected_call_list)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_expire_session_id(self):
-        expected_call_list = [mock.call.login()]
-        self.mock_client_service.assert_has_calls(expected_call_list)
-
-        self.driver.APIExecutor.get("groups")
-        expected_call_list = [mock.call.get_group_info(),
-                              mock.call.login(),
-                              mock.call.get("groups")]
-
-        self.assertEqual(
-            self.mock_client_service.method_calls,
-            expected_call_list)
-
-
-class NimbleDriverVolumeTestCase(NimbleDriverBaseTestCase):
-
-    """Tests volume related api's."""
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @mock.patch.object(volume_types, 'get_volume_type_extra_specs',
-                       mock.Mock(type_id=FAKE_TYPE_ID, return_value={
-                                 'nimble:perfpol-name': 'default',
-                                 'nimble:encryption': 'yes'}))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        NIMBLE_SAN_LOGIN, NIMBLE_SAN_PASS, NIMBLE_MANAGEMENT_IP,
-        'default', '*'))
-    def test_create_volume_positive(self):
-        self.mock_client_service.get_vol_info.return_value = (
-            FAKE_GET_VOL_INFO_RESPONSE)
-        self.mock_client_service.get_netconfig.return_value = (
-            FAKE_POSITIVE_NETCONFIG_RESPONSE)
-
-        self.assertEqual({
-            'provider_location': '172.18.108.21:3260 iqn.test',
-            'provider_auth': None},
-            self.driver.create_volume({'name': 'testvolume',
-                                       'size': 1,
-                                       'volume_type_id': None,
-                                       'display_name': '',
-                                       'display_description': ''}))
-
-        self.mock_client_service.create_vol.assert_called_once_with(
-            {'name': 'testvolume',
-             'size': 1,
-             'volume_type_id': None,
-             'display_name': '',
-             'display_description': ''},
-            'default',
-            False,
-            'iSCSI',
-            False)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @mock.patch.object(volume_types, 'get_volume_type_extra_specs',
-                       mock.Mock(type_id=FAKE_TYPE_ID, return_value={
-                                 'nimble:perfpol-name': 'default',
-                                 'nimble:encryption': 'yes'}))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        NIMBLE_SAN_LOGIN, NIMBLE_SAN_PASS, NIMBLE_MANAGEMENT_IP,
-        'default', '*'))
-    def test_create_volume_with_unicode(self):
-        self.mock_client_service.get_vol_info.return_value = (
-            FAKE_GET_VOL_INFO_RESPONSE)
-        self.mock_client_service.get_netconfig.return_value = (
-            FAKE_POSITIVE_NETCONFIG_RESPONSE)
-
-        self.assertEqual({
-            'provider_location': '172.18.108.21:3260 iqn.test',
-            'provider_auth': None},
-            self.driver.create_volume({'name': 'testvolume',
-                                       'size': 1,
-                                       'volume_type_id': None,
-                                       'display_name': u'unicode_name',
-                                       'display_description': ''}))
-
-        self.mock_client_service.create_vol.assert_called_once_with(
-            {'name': 'testvolume',
-             'size': 1,
-             'volume_type_id': None,
-             'display_name': u'unicode_name',
-             'display_description': ''},
-            'default',
-            False,
-            'iSCSI',
-            False)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @mock.patch.object(volume_types, 'get_volume_type_extra_specs',
-                       mock.Mock(type_id=FAKE_TYPE_ID, return_value={
-                           'nimble:perfpol-name': 'default',
-                           'nimble:encryption': 'yes',
-                           'nimble:multi-initiator': 'false'}))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_create_volume_encryption_positive(self):
-        self.mock_client_service._execute_create_vol.return_value = (
-            FAKE_CREATE_VOLUME_POSITIVE_RESPONSE_ENCRYPTION)
-        self.mock_client_service.get_vol_info.return_value = (
-            FAKE_GET_VOL_INFO_RESPONSE)
-        self.mock_client_service.get_netconfig.return_value = (
-            FAKE_POSITIVE_NETCONFIG_RESPONSE)
-
-        volume = {'name': 'testvolume-encryption',
-                  'size': 1,
-                  'volume_type_id': FAKE_TYPE_ID,
-                  'display_name': '',
-                  'display_description': ''}
-        self.assertEqual({
-            'provider_location': '172.18.108.21:3260 iqn.test',
-            'provider_auth': None},
-            self.driver.create_volume(volume))
-
-        self.mock_client_service.create_vol.assert_called_once_with(
-            {'name': 'testvolume-encryption',
-             'size': 1,
-             'volume_type_id': FAKE_TYPE_ID,
-             'display_name': '',
-             'display_description': '',
-             },
-            'default',
-            False,
-            'iSCSI',
-            False)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @mock.patch.object(volume_types, 'get_volume_type_extra_specs',
-                       mock.Mock(type_id=FAKE_TYPE_ID, return_value={
-                           'nimble:perfpol-name': 'VMware ESX',
-                           'nimble:encryption': 'no',
-                           'nimble:multi-initiator': 'false'}))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_create_volume_perfpolicy_positive(self):
-        self.mock_client_service._execute_create_vol.return_value = (
-            FAKE_CREATE_VOLUME_POSITIVE_RESPONSE_PERF_POLICY)
-        self.mock_client_service.get_vol_info.return_value = (
-            FAKE_GET_VOL_INFO_RESPONSE)
-        self.mock_client_service.get_netconfig.return_value = (
-            FAKE_POSITIVE_NETCONFIG_RESPONSE)
-
-        self.assertEqual(
-            {'provider_location': '172.18.108.21:3260 iqn.test',
-             'provider_auth': None},
-            self.driver.create_volume({'name': 'testvolume-perfpolicy',
-                                       'size': 1,
-                                       'volume_type_id': FAKE_TYPE_ID,
-                                       'display_name': '',
-                                       'display_description': ''}))
-
-        self.mock_client_service.create_vol.assert_called_once_with(
-            {'name': 'testvolume-perfpolicy',
-             'size': 1,
-             'volume_type_id': FAKE_TYPE_ID,
-             'display_name': '',
-             'display_description': '',
-             },
-            'default',
-            False,
-            'iSCSI',
-            False)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @mock.patch.object(volume_types, 'get_volume_type_extra_specs',
-                       mock.Mock(type_id=FAKE_TYPE_ID, return_value={
-                           'nimble:perfpol-name': 'default',
-                           'nimble:encryption': 'no',
-                           'nimble:multi-initiator': 'true'}))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_create_volume_multi_initiator_positive(self):
-        self.mock_client_service._execute_create_vol.return_value = (
-            FAKE_CREATE_VOLUME_POSITIVE_RESPONSE_MULTI_INITIATOR)
-        self.mock_client_service.get_vol_info.return_value = (
-            FAKE_GET_VOL_INFO_RESPONSE)
-        self.mock_client_service.get_netconfig.return_value = (
-            FAKE_POSITIVE_NETCONFIG_RESPONSE)
-
-        self.assertEqual(
-            {'provider_location': '172.18.108.21:3260 iqn.test',
-             'provider_auth': None},
-            self.driver.create_volume({'name': 'testvolume-multi-initiator',
-                                       'size': 1,
-                                       'volume_type_id': FAKE_TYPE_ID,
-                                       'display_name': '',
-                                       'display_description': ''}))
-
-        self.mock_client_service.create_vol.assert_called_once_with(
-            {'name': 'testvolume-multi-initiator',
-             'size': 1,
-             'volume_type_id': FAKE_TYPE_ID,
-             'display_name': '',
-             'display_description': '',
-             },
-            'default',
-            False,
-            'iSCSI',
-            False)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @mock.patch.object(volume_types, 'get_volume_type_extra_specs',
-                       mock.Mock(type_id=FAKE_TYPE_ID, return_value={
-                           'nimble:perfpol-name': 'default',
-                           'nimble:encryption': 'no',
-                           'nimble:dedupe': 'true'}))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_create_volume_dedupe_positive(self):
-        self.mock_client_service._execute_create_vol.return_value = (
-            FAKE_CREATE_VOLUME_POSITIVE_RESPONSE_DEDUPE)
-        self.mock_client_service.get_vol_info.return_value = (
-            FAKE_GET_VOL_INFO_RESPONSE)
-        self.mock_client_service.get_netconfig.return_value = (
-            FAKE_POSITIVE_NETCONFIG_RESPONSE)
-
-        self.assertEqual(
-            {'provider_location': '172.18.108.21:3260 iqn.test',
-             'provider_auth': None},
-            self.driver.create_volume({'name': 'testvolume-dedupe',
-                                       'size': 1,
-                                       'volume_type_id': FAKE_TYPE_ID,
-                                       'display_name': '',
-                                       'display_description': ''}))
-
-        self.mock_client_service.create_vol.assert_called_once_with(
-            {'name': 'testvolume-dedupe',
-             'size': 1,
-             'volume_type_id': FAKE_TYPE_ID,
-             'display_name': '',
-             'display_description': '',
-             },
-            'default',
-            False,
-            'iSCSI',
-            False)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @mock.patch.object(volume_types, 'get_volume_type_extra_specs',
-                       mock.Mock(type_id=FAKE_TYPE_ID, return_value={
-                           'nimble:perfpol-name': 'default',
-                           'nimble:iops-limit': '1024'}))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_create_volume_qos_positive(self):
-        self.mock_client_service._execute_create_vol.return_value = (
-            FAKE_CREATE_VOLUME_POSITIVE_RESPONSE_QOS)
-        self.mock_client_service.get_vol_info.return_value = (
-            FAKE_GET_VOL_INFO_RESPONSE)
-        self.mock_client_service.get_netconfig.return_value = (
-            FAKE_POSITIVE_NETCONFIG_RESPONSE)
-
-        self.assertEqual(
-            {'provider_location': '172.18.108.21:3260 iqn.test',
-             'provider_auth': None},
-            self.driver.create_volume({'name': 'testvolume-qos',
-                                       'size': 1,
-                                       'volume_type_id': FAKE_TYPE_ID,
-                                       'display_name': '',
-                                       'display_description': ''}))
-
-        self.mock_client_service.create_vol.assert_called_once_with(
-            {'name': 'testvolume-qos',
-             'size': 1,
-             'volume_type_id': FAKE_TYPE_ID,
-             'display_name': '',
-             'display_description': '',
-             },
-            'default',
-            False,
-            'iSCSI',
-            False)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    @mock.patch.object(volume_types, 'get_volume_type_extra_specs',
-                       mock.Mock(type_id=FAKE_TYPE_ID, return_value={
-                           'nimble:perfpol-name': 'default',
-                           'nimble:encryption': 'no',
-                           'nimble:multi-initiator': 'true'}))
-    def test_create_volume_negative(self):
-        self.mock_client_service.get_vol_info.side_effect = (
-            FAKE_CREATE_VOLUME_NEGATIVE_RESPONSE)
-
-        self.assertRaises(
-            exception.VolumeBackendAPIException,
-            self.driver.create_volume,
-            {'name': 'testvolume',
-             'size': 1,
-             'volume_type_id': FAKE_TYPE_ID,
-             'display_name': '',
-             'display_description': ''})
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_create_volume_encryption_negative(self):
-        self.mock_client_service.get_vol_info.side_effect = (
-            FAKE_CREATE_VOLUME_NEGATIVE_ENCRYPTION)
-        self.assertRaises(
-            exception.VolumeBackendAPIException,
-            self.driver.create_volume,
-            {'name': 'testvolume-encryption',
-             'size': 1,
-             'volume_type_id': None,
-             'display_name': '',
-             'display_description': ''})
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_create_volume_perfpolicy_negative(self):
-        self.mock_client_service.get_vol_info.side_effect = (
-            FAKE_CREATE_VOLUME_NEGATIVE_PERFPOLICY)
-        self.assertRaises(
-            exception.VolumeBackendAPIException,
-            self.driver.create_volume,
-            {'name': 'testvolume-perfpolicy',
-             'size': 1,
-             'volume_type_id': None,
-             'display_name': '',
-             'display_description': ''})
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_create_volume_dedupe_negative(self):
-        self.mock_client_service.get_vol_info.side_effect = (
-            FAKE_CREATE_VOLUME_NEGATIVE_DEDUPE)
-        self.assertRaises(
-            exception.VolumeBackendAPIException,
-            self.driver.create_volume,
-            {'name': 'testvolume-dedupe',
-             'size': 1,
-             'volume_type_id': None,
-             'display_name': '',
-             'display_description': ''})
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    @mock.patch.object(volume_types, 'get_volume_type_extra_specs',
-                       mock.Mock(type_id=FAKE_TYPE_ID, return_value={
-                           'nimble:perfpol-name': 'default',
-                           'nimble:iops-limit': '200'}))
-    def test_create_volume_qos_negative(self):
-        self.mock_client_service.get_vol_info.side_effect = (
-            FAKE_CREATE_VOLUME_NEGATIVE_QOS)
-        self.assertRaises(
-            exception.VolumeBackendAPIException,
-            self.driver.create_volume,
-            {'name': 'testvolume-qos',
-             'size': 1,
-             'volume_type_id': None,
-             'display_name': '',
-             'display_description': ''})
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    @mock.patch(NIMBLE_ISCSI_DRIVER + ".is_volume_backup_clone", mock.Mock(
-        return_value=['', '']))
-    def test_delete_volume(self):
-        self.mock_client_service.online_vol.return_value = (
-            FAKE_GENERIC_POSITIVE_RESPONSE)
-        self.mock_client_service.delete_vol.return_value = (
-            FAKE_GENERIC_POSITIVE_RESPONSE)
-        self.driver.delete_volume({'name': 'testvolume'})
-        expected_calls = [mock.call.online_vol(
-            'testvolume', False),
-            mock.call.delete_vol('testvolume')]
-
-        self.mock_client_service.assert_has_calls(expected_calls)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    @mock.patch(NIMBLE_ISCSI_DRIVER + ".is_volume_backup_clone", mock.Mock(
-        return_value=['', '']))
-    def test_delete_volume_with_clone(self):
-        self.mock_client_service.delete_vol.side_effect = \
-            nimble.NimbleAPIException(FAKE_VOLUME_DELETE_HAS_CLONE_RESPONSE)
-
-        self.assertRaises(
-            exception.VolumeIsBusy,
-            self.driver.delete_volume,
-            {'name': 'testvolume'})
-
-        expected_calls = [
-            mock.call.login(),
-            mock.call.online_vol('testvolume', False),
-            mock.call.delete_vol('testvolume'),
-            mock.call.delete_vol('testvolume'),
-            mock.call.delete_vol('testvolume'),
-            mock.call.online_vol('testvolume', True)]
-
-        self.mock_client_service.assert_has_calls(expected_calls)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    @mock.patch(NIMBLE_ISCSI_DRIVER + ".is_volume_backup_clone", mock.Mock(
-        return_value=['test-backup-snap', 'volume-' + fake.VOLUME_ID]))
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host')
-    def test_delete_volume_with_backup(self, mock_volume_list):
-        mock_volume_list.return_value = []
-        self.mock_client_service.online_vol.return_value = (
-            FAKE_GENERIC_POSITIVE_RESPONSE)
-        self.mock_client_service.delete_vol.return_value = (
-            FAKE_GENERIC_POSITIVE_RESPONSE)
-        self.mock_client_service.online_snap.return_value = (
-            FAKE_GENERIC_POSITIVE_RESPONSE)
-        self.mock_client_service.delete_snap.return_value = (
-            FAKE_GENERIC_POSITIVE_RESPONSE)
-
-        self.driver.delete_volume({'name': 'testvolume'})
-        expected_calls = [mock.call.online_vol(
-            'testvolume', False),
-            mock.call.delete_vol('testvolume'),
-            mock.call.online_snap('volume-' + fake.VOLUME_ID,
-                                  False,
-                                  'test-backup-snap'),
-            mock.call.delete_snap('volume-' + fake.VOLUME_ID,
-                                  'test-backup-snap')]
-
-        self.mock_client_service.assert_has_calls(expected_calls)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_extend_volume(self):
-        self.mock_client_service.edit_vol.return_value = (
-            FAKE_CREATE_VOLUME_POSITIVE_RESPONSE)
-        self.driver.extend_volume({'name': 'testvolume'}, 5)
-
-        self.mock_client_service.edit_vol.assert_called_once_with(
-            'testvolume', FAKE_EXTEND_VOLUME_PARAMS)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(volume_types, 'get_volume_type_extra_specs',
-                       mock.Mock(type_id=FAKE_TYPE_ID,
-                                 return_value={
-                                     'nimble:perfpol-name': 'default',
-                                     'nimble:encryption': 'yes',
-                                     'nimble:multi-initiator': 'false',
-                                     'nimble:iops-limit': '1024'}))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*', False))
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host')
-    @mock.patch(NIMBLE_RANDOM)
-    def test_create_cloned_volume(self, mock_random, mock_volume_list):
-        mock_random.sample.return_value = fake.VOLUME_ID
-        mock_volume_list.return_value = []
-        self.mock_client_service.snap_vol.return_value = (
-            FAKE_GENERIC_POSITIVE_RESPONSE)
-        self.mock_client_service.clone_vol.return_value = (
-            FAKE_GENERIC_POSITIVE_RESPONSE)
-        self.mock_client_service.get_vol_info.return_value = (
-            FAKE_GET_VOL_INFO_RESPONSE)
-        self.mock_client_service.get_netconfig.return_value = (
-            FAKE_POSITIVE_NETCONFIG_RESPONSE)
-
-        volume = obj_volume.Volume(context.get_admin_context(),
-                                   id=fake.VOLUME_ID,
-                                   size=5.0,
-                                   _name_id=None,
-                                   display_name='',
-                                   volume_type_id=FAKE_TYPE_ID
-                                   )
-        src_volume = obj_volume.Volume(context.get_admin_context(),
-                                       id=fake.VOLUME2_ID,
-                                       _name_id=None,
-                                       size=5.0)
-        self.assertEqual({
-            'provider_location': '172.18.108.21:3260 iqn.test',
-            'provider_auth': None},
-            self.driver.create_cloned_volume(volume, src_volume))
-
-        expected_calls = [mock.call.snap_vol(
-            {'volume_name': "volume-" + fake.VOLUME2_ID,
-                'name': 'openstack-clone-volume-' + fake.VOLUME_ID + "-" +
-                        fake.VOLUME_ID,
-                'volume_size': src_volume['size'],
-                'display_name': volume['display_name'],
-                'display_description': ''}),
-            mock.call.clone_vol(volume,
-                                {'volume_name': "volume-" + fake.VOLUME2_ID,
-                                 'name': 'openstack-clone-volume-' +
-                                         fake.VOLUME_ID + "-" +
-                                         fake.VOLUME_ID,
-                                 'volume_size': src_volume['size'],
-                                 'display_name': volume['display_name'],
-                                 'display_description': ''},
-                                True, False, 'iSCSI', 'default')]
-
-        self.mock_client_service.assert_has_calls(expected_calls)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_manage_volume_positive(self):
-        self.mock_client_service.get_netconfig.return_value = (
-            FAKE_POSITIVE_NETCONFIG_RESPONSE)
-        self.mock_client_service.get_vol_info.return_value = (
-            FAKE_GET_VOL_INFO_RESPONSE_MANAGE)
-        self.mock_client_service.online_vol.return_value = (
-            FAKE_GENERIC_POSITIVE_RESPONSE)
-        self.mock_client_service.edit_vol.return_value = (
-            FAKE_CREATE_VOLUME_POSITIVE_RESPONSE)
-        self.assertEqual({
-            'provider_location': '172.18.108.21:3260 iqn.test',
-            'provider_auth': None},
-            self.driver.manage_existing({'name': 'volume-abcdef',
-                                         'id': fake.VOLUME_ID,
-                                         'agent_type': None},
-                                        {'source-name': 'test-vol'}))
-        expected_calls = [mock.call.edit_vol(
-            'test-vol', {'data': {'agent_type': 'openstack',
-                                  'name': 'volume-abcdef'}}),
-            mock.call.online_vol('volume-abcdef', True)]
-        self.mock_client_service.assert_has_calls(expected_calls)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_manage_volume_which_is_online(self):
-        self.mock_client_service.get_netconfig.return_value = (
-            FAKE_POSITIVE_NETCONFIG_RESPONSE)
-        self.mock_client_service.get_vol_info.return_value = (
-            FAKE_GET_VOL_INFO_ONLINE)
-        self.assertRaises(
-            exception.InvalidVolume,
-            self.driver.manage_existing,
-            {'name': 'volume-abcdef'},
-            {'source-name': 'test-vol'})
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_manage_volume_get_size(self):
-        self.mock_client_service.get_netconfig.return_value = (
-            FAKE_POSITIVE_NETCONFIG_RESPONSE)
-        self.mock_client_service.get_vol_info.return_value = (
-            FAKE_GET_VOL_INFO_ONLINE)
-        size = self.driver.manage_existing_get_size(
-            {'name': 'volume-abcdef'}, {'source-name': 'test-vol'})
-        self.assertEqual(2, size)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_manage_volume_with_improper_ref(self):
-        self.assertRaises(
-            exception.ManageExistingInvalidReference,
-            self.driver.manage_existing,
-            {'name': 'volume-abcdef'},
-            {'source-id': 'test-vol'})
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_manage_volume_with_nonexistant_volume(self):
-        self.mock_client_service.get_vol_info.side_effect = (
-            FAKE_VOLUME_INFO_NEGATIVE_RESPONSE)
-        self.assertRaises(
-            exception.VolumeBackendAPIException,
-            self.driver.manage_existing,
-            {'name': 'volume-abcdef'},
-            {'source-name': 'test-vol'})
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_manage_volume_with_wrong_agent_type(self):
-        self.mock_client_service.get_vol_info.return_value = (
-            FAKE_GET_VOL_INFO_RESPONSE)
-        self.assertRaises(
-            exception.ManageExistingAlreadyManaged,
-            self.driver.manage_existing,
-            {'id': 'abcdef', 'name': 'volume-abcdef'},
-            {'source-name': 'test-vol'})
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_unmanage_volume_positive(self):
-        self.mock_client_service.get_vol_info.return_value = (
-            FAKE_GET_VOL_INFO_RESPONSE)
-        self.mock_client_service.edit_vol.return_value = (
-            FAKE_CREATE_VOLUME_POSITIVE_RESPONSE)
-        self.driver.unmanage({'name': 'volume-abcdef'})
-        expected_calls = [
-            mock.call.edit_vol(
-                'volume-abcdef',
-                {'data': {'agent_type': 'none'}}),
-
-            mock.call.online_vol('volume-abcdef', False)]
-
-        self.mock_client_service.assert_has_calls(expected_calls)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_unmanage_with_invalid_volume(self):
-        self.mock_client_service.get_vol_info.side_effect = (
-            FAKE_VOLUME_INFO_NEGATIVE_RESPONSE)
-        self.assertRaises(
-            exception.VolumeBackendAPIException,
-            self.driver.unmanage,
-            {'name': 'volume-abcdef'}
-        )
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_unmanage_with_invalid_agent_type(self):
-        self.mock_client_service.get_vol_info.return_value = (
-            FAKE_GET_VOL_INFO_ONLINE)
-        self.assertRaises(
-            exception.InvalidVolume,
-            self.driver.unmanage,
-            {'name': 'volume-abcdef'}
-        )
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @mock.patch.object(volume_types, 'get_volume_type',
-                       mock.Mock(type_id=FAKE_TYPE_ID_NEW,
-                                 return_value={
-                                     'id': FAKE_TYPE_ID_NEW,
-                                     'extra_specs':
-                                     {'nimble:perfpol-name': 'default',
-                                      'nimble:encryption': 'yes',
-                                      'nimble:multi-initiator': 'false',
-                                      'nimble:iops-limit': '1024'}}))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_retype(self):
-        self.mock_client_service.get_vol_info.return_value = (
-            FAKE_GET_VOL_INFO_ONLINE)
-        retype, update = self.driver.retype(None, FAKE_GET_VOL_INFO_ONLINE,
-                                            volume_types.get_volume_type(
-                                                None,
-                                                FAKE_TYPE_ID_NEW),
-                                            None, None)
-        self.assertTrue(retype)
-        self.assertIsNone(update)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_get_volume_stats(self):
-        self.mock_client_service.get_group_info.return_value = (
-            FAKE_POSITIVE_GROUP_INFO_RESPONSE)
-        expected_res = {'driver_version': DRIVER_VERSION,
-                        'vendor_name': 'Nimble',
-                        'volume_backend_name': 'NIMBLE',
-                        'storage_protocol': 'iSCSI',
-                        'pools': [{'pool_name': 'NIMBLE',
-                                   'total_capacity_gb': 7466.30419921875,
-                                   'free_capacity_gb': 7463.567649364471,
-                                   'reserved_percentage': 0,
-                                   'QoS_support': False}]}
-        self.assertEqual(
-            expected_res,
-            self.driver.get_volume_stats(refresh=True))
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_is_volume_backup_clone(self):
-        self.mock_client_service.get_vol_info.return_value = (
-            FAKE_GET_VOL_INFO_BACKUP_RESPONSE)
-        self.mock_client_service.get_snap_info_by_id.return_value = (
-            FAKE_GET_SNAP_INFO_BACKUP_RESPONSE)
-        self.mock_client_service.get_snap_info_detail.return_value = (
-            FAKE_GET_SNAP_INFO_BACKUP_RESPONSE)
-        self.mock_client_service.get_volume_name.return_value = (
-            'volume-' + fake.VOLUME2_ID)
-
-        volume = obj_volume.Volume(context.get_admin_context(),
-                                   id=fake.VOLUME_ID,
-                                   _name_id=None)
-        self.assertEqual(("test-backup-snap", "volume-" + fake.VOLUME2_ID),
-                         self.driver.is_volume_backup_clone(volume))
-        expected_calls = [
-            mock.call.get_vol_info('volume-' + fake.VOLUME_ID),
-            mock.call.get_snap_info_by_id('test-backup-snap',
-                                          'volume-' + fake.VOLUME2_ID)
-        ]
-        self.mock_client_service.assert_has_calls(expected_calls)
-
-
-class NimbleDriverSnapshotTestCase(NimbleDriverBaseTestCase):
-
-    """Tests snapshot related api's."""
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_create_snapshot(self):
-        self.mock_client_service.snap_vol.return_value = (
-            FAKE_GENERIC_POSITIVE_RESPONSE)
-        self.driver.create_snapshot(
-            {'volume_name': 'testvolume',
-             'name': 'testvolume-snap1',
-             'display_name': ''})
-        self.mock_client_service.snap_vol.assert_called_once_with(
-            {'volume_name': 'testvolume',
-             'name': 'testvolume-snap1',
-             'display_name': ''})
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_delete_snapshot(self):
-        self.mock_client_service.online_snap.return_value = (
-            FAKE_GENERIC_POSITIVE_RESPONSE)
-        self.mock_client_service.delete_snap.return_value = (
-            FAKE_GENERIC_POSITIVE_RESPONSE)
-        self.driver.delete_snapshot(
-            {'volume_name': 'testvolume',
-             'name': 'testvolume-snap1'})
-        expected_calls = [mock.call.online_snap(
-            'testvolume', False, 'testvolume-snap1'),
-            mock.call.delete_snap('testvolume',
-                                  'testvolume-snap1')]
-        self.mock_client_service.assert_has_calls(expected_calls)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @mock.patch.object(volume_types, 'get_volume_type_extra_specs',
-                       mock.Mock(type_id=FAKE_TYPE_ID, return_value={
-                                 'nimble:perfpol-name': 'default',
-                                 'nimble:encryption': 'yes',
-                                 'nimble:multi-initiator': 'false'}))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_create_volume_from_snapshot(self):
-        self.mock_client_service.clone_vol.return_value = (
-            FAKE_GENERIC_POSITIVE_RESPONSE)
-        self.mock_client_service.get_vol_info.return_value = (
-            FAKE_GET_VOL_INFO_RESPONSE)
-        self.mock_client_service.get_netconfig.return_value = (
-            FAKE_POSITIVE_NETCONFIG_RESPONSE)
-        self.assertEqual({
-            'provider_location': '172.18.108.21:3260 iqn.test',
-            'provider_auth': None},
-            self.driver.create_volume_from_snapshot(
-                {'name': 'clone-testvolume',
-                 'size': 2,
-                 'volume_type_id': FAKE_TYPE_ID},
-                {'volume_name': 'testvolume',
-                 'name': 'testvolume-snap1',
-                 'volume_size': 1}))
-        expected_calls = [
-            mock.call.clone_vol(
-                {'name': 'clone-testvolume',
-                 'volume_type_id': FAKE_TYPE_ID,
-                 'size': 2},
-                {'volume_name': 'testvolume',
-                 'name': 'testvolume-snap1',
-                 'volume_size': 1},
-                False,
-                False,
-                'iSCSI',
-                'default'),
-            mock.call.edit_vol('clone-testvolume',
-                               {'data': {'size': 2048,
-                                         'snap_limit': sys.maxsize,
-                                         'warn_level': 80,
-                                         'reserve': 0,
-                                         'limit': 100}})]
-        self.mock_client_service.assert_has_calls(expected_calls)
-
-
-class NimbleDriverConnectionTestCase(NimbleDriverBaseTestCase):
-
-    """Tests Connection related api's."""
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_initialize_connection_igroup_exist(self):
-        self.mock_client_service.get_initiator_grp_list.return_value = (
-            FAKE_IGROUP_LIST_RESPONSE)
-        expected_res = {
-            'driver_volume_type': 'iscsi',
-            'data': {
-                'target_discovered': False,
-                'volume_id': 12,
-                'target_iqn': '13',
-                'target_lun': 0,
-                'target_portal': '12'}}
-        self.assertEqual(
-            expected_res,
-            self.driver.initialize_connection(
-                {'name': 'test-volume',
-                 'provider_location': '12 13',
-                 'id': 12},
-                {'initiator': 'test-initiator1'}))
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    @mock.patch(NIMBLE_ISCSI_DRIVER + '._get_data_ips')
-    @mock.patch(NIMBLE_ISCSI_DRIVER + ".get_lun_number")
-    @mock.patch(NIMBLE_ISCSI_DRIVER + '._get_gst_for_group')
-    def test_initialize_connection_group_scoped_target(self, mock_gst_name,
-                                                       mock_lun_number,
-                                                       mock_data_ips):
-        mock_data_ips.return_value = ['12', '13']
-        mock_lun_number.return_value = 0
-        mock_gst_name.return_value = "group_target_name"
-        self.mock_client_service.get_initiator_grp_list.return_value = (
-            FAKE_IGROUP_LIST_RESPONSE)
-        expected_res = {
-            'driver_volume_type': 'iscsi',
-            'data': {
-                'target_discovered': False,
-                'volume_id': 12,
-                'target_iqns': ['group_target_name', 'group_target_name'],
-                'target_luns': [0, 0],
-                'target_portals': ['12', '13']}}
-        self.assertEqual(
-            expected_res,
-            self.driver.initialize_connection(
-                {'name': 'test-volume',
-                 'provider_location': '12 group_target_name',
-                 'id': 12},
-                {'initiator': 'test-initiator1'}))
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_initialize_connection_live_migration(self):
-        self.mock_client_service.get_initiator_grp_list.return_value = (
-            FAKE_IGROUP_LIST_RESPONSE)
-        expected_res = {
-            'driver_volume_type': 'iscsi',
-            'data': {
-                'target_discovered': False,
-                'volume_id': 12,
-                'target_iqn': '13',
-                'target_lun': 0,
-                'target_portal': '12'}}
-
-        self.assertEqual(
-            expected_res,
-            self.driver.initialize_connection(
-                {'name': 'test-volume',
-                 'provider_location': '12 13',
-                 'id': 12},
-                {'initiator': 'test-initiator1'}))
-
-        self.driver.initialize_connection(
-            {'name': 'test-volume',
-             'provider_location': '12 13',
-             'id': 12},
-            {'initiator': 'test-initiator1'})
-
-        # 2 or more calls to initialize connection and add_acl for live
-        # migration to work
-        expected_calls = [
-            mock.call.get_initiator_grp_list(),
-            mock.call.add_acl({'name': 'test-volume',
-                               'provider_location': '12 13',
-                               'id': 12},
-                              'test-igrp1'),
-            mock.call.get_initiator_grp_list(),
-            mock.call.add_acl({'name': 'test-volume',
-                               'provider_location': '12 13',
-                               'id': 12},
-                              'test-igrp1')]
-        self.mock_client_service.assert_has_calls(expected_calls)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator_fc(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    @mock.patch(NIMBLE_FC_DRIVER + ".get_lun_number")
-    @mock.patch(NIMBLE_FC_DRIVER + ".get_wwpns_from_array")
-    def test_initialize_connection_fc_igroup_exist(self, mock_wwpns,
-                                                   mock_lun_number):
-        mock_lun_number.return_value = 13
-        mock_wwpns.return_value = ["1111111111111101"]
-        self.mock_client_service.get_initiator_grp_list.return_value = (
-            FAKE_IGROUP_LIST_RESPONSE_FC)
-        expected_res = {
-            'driver_volume_type': 'fibre_channel',
-            'data': {
-                'target_lun': 13,
-                'target_discovered': True,
-                'target_wwn': ["1111111111111101"],
-                'initiator_target_map': {'1000000000000000':
-                                         ['1111111111111101']}}}
-        self.assertEqual(
-            expected_res,
-            self.driver.initialize_connection(
-                {'name': 'test-volume',
-                 'provider_location': 'array1',
-                 'id': 12},
-                {'initiator': 'test-initiator1',
-                 'wwpns': ['1000000000000000']}))
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    @mock.patch(NIMBLE_RANDOM)
-    def test_initialize_connection_igroup_not_exist(self, mock_random):
-        mock_random.sample.return_value = 'abcdefghijkl'
-        self.mock_client_service.get_initiator_grp_list.return_value = (
-            FAKE_IGROUP_LIST_RESPONSE)
-        expected_res = {
-            'driver_volume_type': 'iscsi',
-            'data': {
-                'target_discovered': False,
-                'target_lun': 0,
-                'volume_id': 12,
-                'target_iqn': '13',
-                'target_portal': '12'}}
-        self.assertEqual(
-            expected_res,
-            self.driver.initialize_connection(
-                {'name': 'test-volume',
-                 'provider_location': '12 13',
-                 'id': 12},
-                {'initiator': 'test-initiator3'}))
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator_fc(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    @mock.patch(NIMBLE_FC_DRIVER + ".get_wwpns_from_array")
-    @mock.patch(NIMBLE_FC_DRIVER + ".get_lun_number")
-    @mock.patch(NIMBLE_RANDOM)
-    def test_initialize_connection_fc_igroup_not_exist(self, mock_random,
-                                                       mock_lun_number,
-                                                       mock_wwpns):
-        mock_random.sample.return_value = 'abcdefghijkl'
-        mock_lun_number.return_value = 13
-        mock_wwpns.return_value = ["1111111111111101"]
-        self.mock_client_service.get_initiator_grp_list.return_value = (
-            FAKE_IGROUP_LIST_RESPONSE_FC)
-        expected_res = {
-            'driver_volume_type': 'fibre_channel',
-            'data': {
-                'target_lun': 13,
-                'target_discovered': True,
-                'target_wwn': ["1111111111111101"],
-                'initiator_target_map': {'1000000000000000':
-                                         ['1111111111111101']}}}
-
-        self.driver._create_igroup_for_initiator("test-initiator3",
-                                                 [1111111111111101])
-        self.assertEqual(
-            expected_res,
-            self.driver.initialize_connection(
-                {'name': 'test-volume',
-                 'provider_location': 'array1',
-                 'id': 12},
-                {'initiator': 'test-initiator3',
-                 'wwpns': ['1000000000000000']}))
-
-        expected_calls = [mock.call.create_initiator_group_fc(
-            'openstack-abcdefghijkl'),
-            mock.call.add_initiator_to_igroup_fc('openstack-abcdefghijkl',
-                                                 1111111111111101)]
-        self.mock_client_service.assert_has_calls(expected_calls)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_terminate_connection_positive(self):
-        self.mock_client_service.get_initiator_grp_list.return_value = (
-            FAKE_IGROUP_LIST_RESPONSE)
-        self.driver.terminate_connection(
-            {'name': 'test-volume',
-             'provider_location': '12 13',
-             'id': 12},
-            {'initiator': 'test-initiator1'})
-        expected_calls = [mock.call._get_igroupname_for_initiator(
-            'test-initiator1'),
-            mock.call.remove_acl({'name': 'test-volume'},
-                                 'test-igrp1')]
-        self.mock_client_service.assert_has_calls(
-            self.mock_client_service.method_calls,
-            expected_calls)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_terminate_connection_without_connector(self):
-        self.mock_client_service.get_initiator_grp_list.return_value = (
-            FAKE_IGROUP_LIST_RESPONSE)
-        self.driver.terminate_connection(
-            {'name': 'test-volume',
-             'provider_location': '12 13',
-             'id': 12},
-            None)
-        expected_calls = [mock.call._get_igroupname_for_initiator(
-            'test-initiator1'),
-            mock.call.remove_all_acls({'name': 'test-volume'})]
-        self.mock_client_service.assert_has_calls(
-            self.mock_client_service.method_calls,
-            expected_calls)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator_fc(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    @mock.patch(NIMBLE_FC_DRIVER + ".get_wwpns_from_array")
-    def test_terminate_connection_positive_fc(self, mock_wwpns):
-        mock_wwpns.return_value = ["1111111111111101"]
-        self.mock_client_service.get_initiator_grp_list.return_value = (
-            FAKE_IGROUP_LIST_RESPONSE_FC)
-        self.driver.terminate_connection(
-            {'name': 'test-volume',
-             'provider_location': 'array1',
-             'id': 12},
-            {'initiator': 'test-initiator1',
-             'wwpns': ['1000000000000000']})
-        expected_calls = [
-            mock.call.get_igroupname_for_initiator_fc(
-                "10:00:00:00:00:00:00:00"),
-            mock.call.remove_acl({'name': 'test-volume'},
-                                 'test-igrp1')]
-        self.mock_client_service.assert_has_calls(
-            self.mock_client_service.method_calls,
-            expected_calls)
-
-    @mock.patch(NIMBLE_URLLIB2)
-    @mock.patch(NIMBLE_CLIENT)
-    @mock.patch.object(obj_volume.VolumeList, 'get_all_by_host',
-                       mock.Mock(return_value=[]))
-    @NimbleDriverBaseTestCase.client_mock_decorator(create_configuration(
-        'nimble', 'nimble_pass', '10.18.108.55', 'default', '*'))
-    def test_terminate_connection_negative(self):
-        self.mock_client_service.get_initiator_grp_list.return_value = (
-            FAKE_IGROUP_LIST_RESPONSE)
-        self.assertRaises(
-            exception.VolumeDriverException,
-            self.driver.terminate_connection,
-            {'name': 'test-volume',
-             'provider_location': '12 13', 'id': 12},
-            {'initiator': 'test-initiator3'})
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_prophetstor_dpl.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_prophetstor_dpl.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_prophetstor_dpl.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_prophetstor_dpl.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,931 +0,0 @@
-# Copyright (c) 2014 ProphetStor, Inc.
-# All Rights Reserved.
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-
-import errno
-import re
-
-import mock
-from oslo_utils import units
-from six.moves import http_client
-
-from cinder import context
-from cinder import exception
-from cinder.objects import fields
-from cinder import test
-from cinder.tests.unit import fake_constants
-from cinder.tests.unit import fake_snapshot
-from cinder.tests.unit import utils as test_utils
-from cinder.volume import configuration as conf
-from cinder.volume.drivers.prophetstor import dpl_iscsi as DPLDRIVER
-from cinder.volume.drivers.prophetstor import dplcommon as DPLCOMMON
-from cinder.volume import group_types
-
-POOLUUID = 'ac33fc6e417440d5a1ef27d7231e1cc4'
-VOLUMEUUID = 'a000000000000000000000000000001'
-INITIATOR = 'iqn.2013-08.org.debian:01:aaaaaaaa'
-DATA_IN_CONNECTOR = {'initiator': INITIATOR}
-DATA_SERVER_INFO = 0, {
-    'metadata': {'vendor': 'ProphetStor',
-                 'version': '1.5'}}
-
-DATA_POOLS = 0, {
-    'children': [POOLUUID]
-}
-
-DATA_POOLINFO = 0, {
-    'capabilitiesURI': '',
-    'children': [],
-    'childrenrange': '',
-    'completionStatus': 'Complete',
-    'metadata': {'available_capacity': 4294967296,
-                 'ctime': 1390551362349,
-                 'vendor': 'prophetstor',
-                 'version': '1.5',
-                 'display_description': 'Default Pool',
-                 'display_name': 'default_pool',
-                 'event_uuid': '4f7c4d679a664857afa4d51f282a516a',
-                 'physical_device': {'cache': [],
-                                     'data': ['disk_uuid_0',
-                                              'disk_uuid_1',
-                                              'disk_uuid_2'],
-                                     'log': [],
-                                     'spare': []},
-                 'pool_uuid': POOLUUID,
-                 'properties': {'raid_level': 'raid0'},
-                 'state': 'Online',
-                 'used_capacity': 0,
-                 'total_capacity': 4294967296,
-                 'zpool_guid': '8173612007304181810'},
-    'objectType': 'application/cdmi-container',
-    'percentComplete': 100}
-
-DATA_ASSIGNVDEV = 0, {
-    'children': [],
-    'childrenrange': '',
-    'completionStatus': 'Complete',
-    'domainURI': '',
-    'exports': {'Network/iSCSI': [
-                {'logical_unit_name': '',
-                 'logical_unit_number': '101',
-                 'permissions': [INITIATOR],
-                 'portals': ['172.31.1.210:3260'],
-                 'target_identifier':
-                 'iqn.2013-09.com.prophetstor:hypervisor.886423051816'
-                 }]},
-    'metadata': {'ctime': 0,
-                 'event_uuid': 'c11e90287e9348d0b4889695f1ec4be5',
-                 'type': 'volume'},
-    'objectID': '',
-    'objectName': 'd827e23d403f4f12bb208a6fec208fd8',
-    'objectType': 'application/cdmi-container',
-    'parentID': '8daa374670af447e8efea27e16bf84cd',
-    'parentURI': '/dpl_volume',
-    'snapshots': []
-}
-
-DATA_OUTPUT = 0, None
-
-MOD_OUTPUT = {'status': 'available'}
-
-DATA_IN_GROUP = {'id': 'fe2dbc51-5810-451d-ab2f-8c8a48d15bee',
-                 'name': 'group123',
-                 'description': 'des123',
-                 'status': ''}
-
-DATA_IN_VOLUME = {'id': 'c11e902-87e9-348d-0b48-89695f1ec4be5',
-                  'display_name': 'abc123',
-                  'display_description': '',
-                  'size': 10,
-                  'host': "hostname@backend#%s" % POOLUUID}
-
-DATA_IN_VOLUME_VG = {'id': 'fe2dbc5-1581-0451-dab2-f8c8a48d15bee',
-                     'display_name': 'abc123',
-                     'display_description': '',
-                     'size': 10,
-                     'group_id':
-                         'fe2dbc51-5810-451d-ab2f-8c8a48d15bee',
-                     'status': 'available',
-                     'host': "hostname@backend#%s" % POOLUUID}
-
-DATA_IN_REMOVE_VOLUME_VG = {
-    'id': 'fe2dbc515810451dab2f8c8a48d15bee',
-    'display_name': 'fe2dbc515810451dab2f8c8a48d15bee',
-    'display_description': '',
-    'size': 10,
-    'group_id': 'fe2dbc51-5810-451d-ab2f-8c8a48d15bee',
-    'status': 'available',
-    'host': "hostname@backend#%s" % POOLUUID}
-
-DATA_IN_VOLUME1 = {'id': 'c11e902-87e9-348d-0b48-89695f1ec4bef',
-                   'display_name': 'abc456',
-                   'display_description': '',
-                   'size': 10,
-                   'host': "hostname@backend#%s" % POOLUUID}
-
-DATA_IN_CG_SNAPSHOT = {
-    'group_id': 'fe2dbc51-5810-451d-ab2f-8c8a48d15bee',
-    'id': 'cgsnapshot1',
-    'name': 'cgsnapshot1',
-    'description': 'cgsnapshot1',
-    'status': ''}
-
-DATA_IN_SNAPSHOT = {'id': 'fe2dbc5-1581-0451-dab2-f8c8a48d15bee',
-                    'volume_id': 'c11e902-87e9-348d-0b48-89695f1ec4be5',
-                    'display_name': 'snapshot1',
-                    'display_description': '',
-                    'volume_size': 5}
-
-DATA_OUT_SNAPSHOT_CG = {
-    'id': 'snapshot1',
-    'volume_id': 'c11e902-87e9-348d-0b48-89695f1ec4be5',
-    'display_name': 'snapshot1',
-    'display_description': '',
-    'group_snapshot_id': 'fe2dbc51-5810-451d-ab2f-8c8a48d15bee'}
-
-DATA_OUT_CG = {
-    "objectType": "application/cdmi-container",
-    "objectID": "fe2dbc515810451dab2f8c8a48d15bee",
-    "objectName": "<new_volume_group_uuid>",
-    "parentURI": "/dpl_volgroup",
-    "parentID": "fe2dbc515810451dab2f8c8a48d15bee",
-    "domainURI": "",
-    "capabilitiesURI": "",
-    "completionStatus": "Complete",
-    "percentComplete": 100,
-    "metadata":
-    {
-        "type": "volume|snapshot|replica",
-        "volume_group_uuid": "<volume_group_uuid>",
-        "origin_uuid": "<origin_uuid>",
-        "snapshot_uuid": "<snapshot_uuid>",
-        "display_name": "<display name>",
-        "display_description": "<display description>",
-        "ctime": 12345678,
-        "total_capacity": 1024,
-        "snapshot_used_capacity": 0,
-        "maximum_snapshot": 1024,
-        "snapshot_quota": 0,
-        "state": "<state>",
-        "properties":
-        {
-            "snapshot_rotation": True,
-        }
-    },
-    "childrenrange": "<range>",
-    "children":
-    [
-        'fe2dbc515810451dab2f8c8a48d15bee',
-    ],
-}
-
-
-class TestProphetStorDPLVolume(test.TestCase):
-
-    def _gen_snapshot_url(self, vdevid, snapshotid):
-        snapshot_url = '/%s/%s/%s' % (vdevid, DPLCOMMON.DPL_OBJ_SNAPSHOT,
-                                      snapshotid)
-        return snapshot_url
-
-    def setUp(self):
-        super(TestProphetStorDPLVolume, self).setUp()
-        self.dplcmd = DPLCOMMON.DPLVolume('1.1.1.1', 8356, 'admin', 'password')
-        self.DPL_MOCK = mock.MagicMock()
-        self.dplcmd.objCmd = self.DPL_MOCK
-        self.DPL_MOCK.send_cmd.return_value = DATA_OUTPUT
-
-    def test_getserverinfo(self):
-        self.dplcmd.get_server_info()
-        self.DPL_MOCK.send_cmd.assert_called_once_with(
-            'GET',
-            '/%s/%s/' % (DPLCOMMON.DPL_VER_V1, DPLCOMMON.DPL_OBJ_SYSTEM),
-            None,
-            [http_client.OK, http_client.ACCEPTED])
-
-    def test_createvdev(self):
-        self.dplcmd.create_vdev(DATA_IN_VOLUME['id'],
-                                DATA_IN_VOLUME['display_name'],
-                                DATA_IN_VOLUME['display_description'],
-                                POOLUUID,
-                                int(DATA_IN_VOLUME['size']) * units.Gi)
-
-        metadata = {}
-        metadata['display_name'] = DATA_IN_VOLUME['display_name']
-        metadata['display_description'] = DATA_IN_VOLUME['display_description']
-        metadata['pool_uuid'] = POOLUUID
-        metadata['total_capacity'] = int(DATA_IN_VOLUME['size']) * units.Gi
-        metadata['maximum_snapshot'] = 1024
-        metadata['properties'] = dict(thin_provision=True)
-        params = {}
-        params['metadata'] = metadata
-        self.DPL_MOCK.send_cmd.assert_called_once_with(
-            'PUT',
-            '/%s/%s/%s/' % (DPLCOMMON.DPL_VER_V1, DPLCOMMON.DPL_OBJ_VOLUME,
-                            DATA_IN_VOLUME['id']),
-            params,
-            [http_client.OK, http_client.ACCEPTED, http_client.CREATED])
-
-    def test_extendvdev(self):
-        self.dplcmd.extend_vdev(DATA_IN_VOLUME['id'],
-                                DATA_IN_VOLUME['display_name'],
-                                DATA_IN_VOLUME['display_description'],
-                                int(DATA_IN_VOLUME['size']) * units.Gi)
-        metadata = {}
-        metadata['display_name'] = DATA_IN_VOLUME['display_name']
-        metadata['display_description'] = DATA_IN_VOLUME['display_description']
-        metadata['total_capacity'] = int(DATA_IN_VOLUME['size']) * units.Gi
-        metadata['maximum_snapshot'] = 1024
-        params = {}
-        params['metadata'] = metadata
-        self.DPL_MOCK.send_cmd.assert_called_once_with(
-            'PUT',
-            '/%s/%s/%s/' % (DPLCOMMON.DPL_VER_V1, DPLCOMMON.DPL_OBJ_VOLUME,
-                            DATA_IN_VOLUME['id']),
-            params,
-            [http_client.OK, http_client.ACCEPTED, http_client.CREATED])
-
-    def test_deletevdev(self):
-        self.dplcmd.delete_vdev(DATA_IN_VOLUME['id'], True)
-        metadata = {}
-        params = {}
-        metadata['force'] = True
-        params['metadata'] = metadata
-        self.DPL_MOCK.send_cmd.assert_called_once_with(
-            'DELETE',
-            '/%s/%s/%s/' % (DPLCOMMON.DPL_VER_V1, DPLCOMMON.DPL_OBJ_VOLUME,
-                            DATA_IN_VOLUME['id']),
-            params,
-            [http_client.OK, http_client.ACCEPTED, http_client.NOT_FOUND,
-             http_client.NO_CONTENT])
-
-    def test_createvdevfromsnapshot(self):
-        self.dplcmd.create_vdev_from_snapshot(
-            DATA_IN_VOLUME['id'],
-            DATA_IN_VOLUME['display_name'],
-            DATA_IN_VOLUME['display_description'],
-            DATA_IN_SNAPSHOT['id'],
-            POOLUUID)
-        metadata = {}
-        params = {}
-        metadata['snapshot_operation'] = 'copy'
-        metadata['display_name'] = DATA_IN_VOLUME['display_name']
-        metadata['display_description'] = DATA_IN_VOLUME['display_description']
-        metadata['pool_uuid'] = POOLUUID
-        metadata['maximum_snapshot'] = 1024
-        metadata['properties'] = dict(thin_provision=True)
-        params['metadata'] = metadata
-        params['copy'] = self._gen_snapshot_url(DATA_IN_VOLUME['id'],
-                                                DATA_IN_SNAPSHOT['id'])
-        self.DPL_MOCK.send_cmd.assert_called_once_with(
-            'PUT',
-            '/%s/%s/%s/' % (DPLCOMMON.DPL_VER_V1, DPLCOMMON.DPL_OBJ_VOLUME,
-                            DATA_IN_VOLUME['id']),
-            params,
-            [http_client.OK, http_client.ACCEPTED, http_client.CREATED])
-
-    def test_getpool(self):
-        self.dplcmd.get_pool(POOLUUID)
-        self.DPL_MOCK.send_cmd.assert_called_once_with(
-            'GET',
-            '/%s/%s/%s/' % (DPLCOMMON.DPL_VER_V1, DPLCOMMON.DPL_OBJ_POOL,
-                            POOLUUID),
-            None,
-            [http_client.OK, http_client.ACCEPTED])
-
-    def test_clonevdev(self):
-        self.dplcmd.clone_vdev(
-            DATA_IN_VOLUME['id'],
-            DATA_IN_VOLUME1['id'],
-            POOLUUID,
-            DATA_IN_VOLUME['display_name'],
-            DATA_IN_VOLUME['display_description'],
-            int(DATA_IN_VOLUME['size']) * units.Gi
-        )
-        metadata = {}
-        params = {}
-        metadata["snapshot_operation"] = "clone"
-        metadata["display_name"] = DATA_IN_VOLUME['display_name']
-        metadata["display_description"] = DATA_IN_VOLUME['display_description']
-        metadata["pool_uuid"] = POOLUUID
-        metadata["total_capacity"] = int(DATA_IN_VOLUME['size']) * units.Gi
-        metadata['maximum_snapshot'] = 1024
-        metadata['properties'] = dict(thin_provision=True)
-        params["metadata"] = metadata
-        params["copy"] = DATA_IN_VOLUME['id']
-
-        self.DPL_MOCK.send_cmd.assert_called_once_with(
-            'PUT',
-            '/%s/%s/%s/' % (DPLCOMMON.DPL_VER_V1, DPLCOMMON.DPL_OBJ_VOLUME,
-                            DATA_IN_VOLUME1['id']),
-            params,
-            [http_client.OK, http_client.CREATED, http_client.ACCEPTED])
-
-    def test_createvdevsnapshot(self):
-        self.dplcmd.create_vdev_snapshot(
-            DATA_IN_VOLUME['id'],
-            DATA_IN_SNAPSHOT['id'],
-            DATA_IN_SNAPSHOT['display_name'],
-            DATA_IN_SNAPSHOT['display_description']
-        )
-        metadata = {}
-        params = {}
-        metadata['display_name'] = DATA_IN_SNAPSHOT['display_name']
-        metadata['display_description'] = (
-            DATA_IN_SNAPSHOT['display_description'])
-        params['metadata'] = metadata
-        params['snapshot'] = DATA_IN_SNAPSHOT['id']
-
-        self.DPL_MOCK.send_cmd.assert_called_once_with(
-            'PUT',
-            '/%s/%s/%s/' % (DPLCOMMON.DPL_VER_V1, DPLCOMMON.DPL_OBJ_VOLUME,
-                            DATA_IN_VOLUME['id']),
-            params,
-            [http_client.OK, http_client.CREATED, http_client.ACCEPTED])
-
-    def test_getvdev(self):
-        self.dplcmd.get_vdev(DATA_IN_VOLUME['id'])
-        self.DPL_MOCK.send_cmd.assert_called_once_with(
-            'GET',
-            '/%s/%s/%s/' % (DPLCOMMON.DPL_VER_V1, DPLCOMMON.DPL_OBJ_VOLUME,
-                            DATA_IN_VOLUME['id']),
-            None,
-            [http_client.OK, http_client.ACCEPTED, http_client.NOT_FOUND])
-
-    def test_getvdevstatus(self):
-        self.dplcmd.get_vdev_status(DATA_IN_VOLUME['id'], '123456')
-        self.DPL_MOCK.send_cmd.assert_called_once_with(
-            'GET',
-            '/%s/%s/%s/?event_uuid=%s' % (DPLCOMMON.DPL_VER_V1,
-                                          DPLCOMMON.DPL_OBJ_VOLUME,
-                                          DATA_IN_VOLUME['id'],
-                                          '123456'),
-            None,
-            [http_client.OK, http_client.NOT_FOUND])
-
-    def test_getpoolstatus(self):
-        self.dplcmd.get_pool_status(POOLUUID, '123456')
-        self.DPL_MOCK.send_cmd.assert_called_once_with(
-            'GET',
-            '/%s/%s/%s/?event_uuid=%s' % (DPLCOMMON.DPL_VER_V1,
-                                          DPLCOMMON.DPL_OBJ_POOL,
-                                          POOLUUID,
-                                          '123456'),
-            None,
-            [http_client.OK, http_client.NOT_FOUND])
-
-    def test_assignvdev(self):
-        self.dplcmd.assign_vdev(
-            DATA_IN_VOLUME['id'],
-            'iqn.1993-08.org.debian:01:test1',
-            '',
-            '1.1.1.1:3260',
-            0
-        )
-        params = {}
-        metadata = {}
-        exports = {}
-        metadata['export_operation'] = 'assign'
-        exports['Network/iSCSI'] = {}
-        target_info = {}
-        target_info['logical_unit_number'] = 0
-        target_info['logical_unit_name'] = ''
-        permissions = []
-        portals = []
-        portals.append('1.1.1.1:3260')
-        permissions.append('iqn.1993-08.org.debian:01:test1')
-        target_info['permissions'] = permissions
-        target_info['portals'] = portals
-        exports['Network/iSCSI'] = target_info
-
-        params['metadata'] = metadata
-        params['exports'] = exports
-        self.DPL_MOCK.send_cmd.assert_called_once_with(
-            'PUT',
-            '/%s/%s/%s/' % (DPLCOMMON.DPL_VER_V1,
-                            DPLCOMMON.DPL_OBJ_VOLUME,
-                            DATA_IN_VOLUME['id']),
-            params,
-            [http_client.OK, http_client.ACCEPTED, http_client.CREATED])
-
-    def test_unassignvdev(self):
-        self.dplcmd.unassign_vdev(DATA_IN_VOLUME['id'],
-                                  'iqn.1993-08.org.debian:01:test1',
-                                  '')
-        params = {}
-        metadata = {}
-        exports = {}
-        metadata['export_operation'] = 'unassign'
-        params['metadata'] = metadata
-
-        exports['Network/iSCSI'] = {}
-        exports['Network/iSCSI']['target_identifier'] = ''
-        permissions = []
-        permissions.append('iqn.1993-08.org.debian:01:test1')
-        exports['Network/iSCSI']['permissions'] = permissions
-
-        params['exports'] = exports
-        self.DPL_MOCK.send_cmd.assert_called_once_with(
-            'PUT',
-            '/%s/%s/%s/' % (DPLCOMMON.DPL_VER_V1,
-                            DPLCOMMON.DPL_OBJ_VOLUME,
-                            DATA_IN_VOLUME['id']),
-            params,
-            [http_client.OK, http_client.ACCEPTED,
-             http_client.NO_CONTENT, http_client.NOT_FOUND])
-
-    def test_deletevdevsnapshot(self):
-        self.dplcmd.delete_vdev_snapshot(DATA_IN_VOLUME['id'],
-                                         DATA_IN_SNAPSHOT['id'])
-        params = {}
-        params['copy'] = self._gen_snapshot_url(DATA_IN_VOLUME['id'],
-                                                DATA_IN_SNAPSHOT['id'])
-        self.DPL_MOCK.send_cmd.assert_called_once_with(
-            'DELETE',
-            '/%s/%s/%s/%s/%s/' % (DPLCOMMON.DPL_VER_V1,
-                                  DPLCOMMON.DPL_OBJ_VOLUME,
-                                  DATA_IN_VOLUME['id'],
-                                  DPLCOMMON.DPL_OBJ_SNAPSHOT,
-                                  DATA_IN_SNAPSHOT['id']),
-            None,
-            [http_client.OK, http_client.ACCEPTED, http_client.NO_CONTENT,
-             http_client.NOT_FOUND])
-
-    def test_listvdevsnapshots(self):
-        self.dplcmd.list_vdev_snapshots(DATA_IN_VOLUME['id'])
-        self.DPL_MOCK.send_cmd.assert_called_once_with(
-            'GET',
-            '/%s/%s/%s/%s/' % (DPLCOMMON.DPL_VER_V1,
-                               DPLCOMMON.DPL_OBJ_VOLUME,
-                               DATA_IN_VOLUME['id'],
-                               DPLCOMMON.DPL_OBJ_SNAPSHOT),
-            None,
-            [http_client.OK])
-
-
-class TestProphetStorDPLDriver(test.TestCase):
-
-    def __init__(self, method):
-        super(TestProphetStorDPLDriver, self).__init__(method)
-
-    def _conver_uuid2hex(self, strID):
-        return strID.replace('-', '')
-
-    def setUp(self):
-        super(TestProphetStorDPLDriver, self).setUp()
-        self.configuration = mock.Mock(conf.Configuration)
-        self.configuration.san_ip = '1.1.1.1'
-        self.configuration.dpl_port = 8356
-        self.configuration.san_login = 'admin'
-        self.configuration.san_password = 'password'
-        self.configuration.dpl_pool = POOLUUID
-        self.configuration.target_port = 3260
-        self.configuration.san_is_local = False
-        self.configuration.san_thin_provision = True
-        self.configuration.driver_ssl_cert_verify = False
-        self.configuration.driver_ssl_cert_path = None
-        self.context = context.get_admin_context()
-        self.DPL_MOCK = mock.MagicMock()
-        self.DB_MOCK = mock.MagicMock()
-        self.dpldriver = DPLDRIVER.DPLISCSIDriver(
-            configuration=self.configuration)
-        self.dpldriver.dpl = self.DPL_MOCK
-        self.dpldriver.db = self.DB_MOCK
-        self.dpldriver.do_setup(self.context)
-
-    def test_get_volume_stats(self):
-        self.DPL_MOCK.get_pool.return_value = DATA_POOLINFO
-        self.DPL_MOCK.get_server_info.return_value = DATA_SERVER_INFO
-        res = self.dpldriver.get_volume_stats(True)
-        self.assertEqual('ProphetStor', res['vendor_name'])
-        self.assertEqual('1.5', res['driver_version'])
-        pool = res["pools"][0]
-        self.assertEqual(4, pool['total_capacity_gb'])
-        self.assertEqual(4, pool['free_capacity_gb'])
-        self.assertEqual(0, pool['reserved_percentage'])
-        self.assertFalse(pool['QoS_support'])
-
-    def test_create_volume(self):
-        volume = test_utils.create_volume(
-            self.context,
-            id=DATA_IN_VOLUME['id'],
-            display_name=DATA_IN_VOLUME['display_name'],
-            size=DATA_IN_VOLUME['size'],
-            host=DATA_IN_VOLUME['host'])
-        self.DPL_MOCK.create_vdev.return_value = DATA_OUTPUT
-        self.dpldriver.create_volume(volume)
-        self.DPL_MOCK.create_vdev.assert_called_once_with(
-            self._conver_uuid2hex(volume.id),
-            volume.display_name,
-            volume.display_description,
-            self.configuration.dpl_pool,
-            int(volume.size) * units.Gi,
-            True)
-
-    def test_create_volume_without_pool(self):
-        volume = test_utils.create_volume(
-            self.context,
-            id=DATA_IN_VOLUME['id'],
-            display_name=DATA_IN_VOLUME['display_name'],
-            size=DATA_IN_VOLUME['size'],
-            host=DATA_IN_VOLUME['host'])
-        self.DPL_MOCK.create_vdev.return_value = DATA_OUTPUT
-        self.configuration.dpl_pool = ""
-        volume.host = "host@backend"  # missing pool
-        self.assertRaises(exception.InvalidHost, self.dpldriver.create_volume,
-                          volume=volume)
-
-    def test_create_volume_with_configuration_pool(self):
-        volume = test_utils.create_volume(
-            self.context,
-            id=DATA_IN_VOLUME['id'],
-            display_name=DATA_IN_VOLUME['display_name'],
-            size=DATA_IN_VOLUME['size'],
-            host="host@backend")
-        self.DPL_MOCK.create_vdev.return_value = DATA_OUTPUT
-        self.dpldriver.create_volume(volume)
-        self.DPL_MOCK.create_vdev.assert_called_once_with(
-            self._conver_uuid2hex(volume.id),
-            volume.display_name, volume.display_description,
-            self.configuration.dpl_pool, int(volume.size) * units.Gi, True)
-
-    def test_create_volume_of_group(self):
-        group_type = group_types.create(
-            self.context,
-            'group',
-            {'consistent_group_snapshot_enabled': '<is> True'}
-        )
-        group = test_utils.create_group(
-            self.context,
-            id=fake_constants.CONSISTENCY_GROUP_ID,
-            host='host@backend#unit_test_pool',
-            group_type_id=group_type.id)
-        self.DPL_MOCK.create_vdev.return_value = DATA_OUTPUT
-        self.DPL_MOCK.join_vg.return_value = DATA_OUTPUT
-        volume = test_utils.create_volume(
-            self.context,
-            id=DATA_IN_VOLUME_VG['id'],
-            display_name=DATA_IN_VOLUME_VG['display_name'],
-            size=DATA_IN_VOLUME_VG['size'],
-            group_id=group.id,
-            host=DATA_IN_VOLUME_VG['host'])
-        self.dpldriver.create_volume(volume)
-        self.DPL_MOCK.create_vdev.assert_called_once_with(
-            self._conver_uuid2hex(volume.id),
-            volume.display_name,
-            volume.display_description,
-            self.configuration.dpl_pool,
-            int(volume.size) * units.Gi,
-            True)
-        self.DPL_MOCK.join_vg.assert_called_once_with(
-            self._conver_uuid2hex(volume.id),
-            self._conver_uuid2hex(volume.group_id))
-
-    def test_delete_volume(self):
-        volume = test_utils.create_volume(
-            self.context,
-            id=DATA_IN_VOLUME['id'],
-            display_name=DATA_IN_VOLUME['display_name'],
-            size=DATA_IN_VOLUME['size'],
-            host=DATA_IN_VOLUME['host'])
-        self.DPL_MOCK.delete_vdev.return_value = DATA_OUTPUT
-        self.dpldriver.delete_volume(volume)
-        self.DPL_MOCK.delete_vdev.assert_called_once_with(
-            self._conver_uuid2hex(volume.id))
-
-    def test_delete_volume_of_group(self):
-        group_type = group_types.create(
-            self.context,
-            'group',
-            {'consistent_group_snapshot_enabled': '<is> True'}
-        )
-        group = test_utils.create_group(
-            self.context,
-            id=fake_constants.CONSISTENCY_GROUP_ID,
-            host='host@backend#unit_test_pool',
-            group_type_id=group_type.id)
-        volume = test_utils.create_volume(
-            self.context,
-            id=DATA_IN_VOLUME_VG['id'],
-            display_name=DATA_IN_VOLUME_VG['display_name'],
-            size=DATA_IN_VOLUME_VG['size'],
-            group_id=group.id,
-            host=DATA_IN_VOLUME_VG['host'])
-        self.DPL_MOCK.delete_vdev.return_value = DATA_OUTPUT
-        self.DPL_MOCK.leave_vg.return_volume = DATA_OUTPUT
-        self.dpldriver.delete_volume(volume)
-        self.DPL_MOCK.leave_vg.assert_called_once_with(
-            self._conver_uuid2hex(volume.id),
-            self._conver_uuid2hex(volume.group_id)
-        )
-        self.DPL_MOCK.delete_vdev.assert_called_once_with(
-            self._conver_uuid2hex(volume.id))
-
-    def test_create_volume_from_snapshot(self):
-        self.DPL_MOCK.create_vdev_from_snapshot.return_value = DATA_OUTPUT
-        self.DPL_MOCK.extend_vdev.return_value = DATA_OUTPUT
-        volume = test_utils.create_volume(
-            self.context,
-            id=DATA_IN_VOLUME_VG['id'],
-            display_name=DATA_IN_VOLUME_VG['display_name'],
-            size=DATA_IN_VOLUME_VG['size'],
-            host=DATA_IN_VOLUME_VG['host'])
-        self.dpldriver.create_volume_from_snapshot(
-            volume, DATA_IN_SNAPSHOT)
-        self.DPL_MOCK.create_vdev_from_snapshot.assert_called_once_with(
-            self._conver_uuid2hex(volume.id),
-            volume.display_name,
-            volume.display_description,
-            self._conver_uuid2hex(volume.id),
-            self.configuration.dpl_pool,
-            True)
-        self.DPL_MOCK.extend_vdev.assert_called_once_with(
-            self._conver_uuid2hex(volume.id),
-            volume.display_name,
-            volume.display_description,
-            volume.size * units.Gi)
-
-    def test_create_cloned_volume(self):
-        new_volume = test_utils.create_volume(
-            self.context,
-            id=DATA_IN_VOLUME1['id'],
-            display_name=DATA_IN_VOLUME1['display_name'],
-            size=DATA_IN_VOLUME1['size'],
-            host=DATA_IN_VOLUME1['host'])
-        src_volume = test_utils.create_volume(
-            self.context,
-            id=DATA_IN_VOLUME['id'])
-        self.DPL_MOCK.clone_vdev.return_value = DATA_OUTPUT
-        self.dpldriver.create_cloned_volume(new_volume, src_volume)
-        self.DPL_MOCK.clone_vdev.assert_called_once_with(
-            self._conver_uuid2hex(src_volume.id),
-            self._conver_uuid2hex(new_volume.id),
-            self.configuration.dpl_pool,
-            new_volume.display_name,
-            new_volume.display_description,
-            int(new_volume.size) *
-            units.Gi,
-            True)
-
-    def test_create_snapshot(self):
-        self.DPL_MOCK.create_vdev_snapshot.return_value = DATA_OUTPUT
-        self.dpldriver.create_snapshot(DATA_IN_SNAPSHOT)
-        self.DPL_MOCK.create_vdev_snapshot.assert_called_once_with(
-            self._conver_uuid2hex(DATA_IN_SNAPSHOT['volume_id']),
-            self._conver_uuid2hex(DATA_IN_SNAPSHOT['id']),
-            DATA_IN_SNAPSHOT['display_name'],
-            DATA_IN_SNAPSHOT['display_description'])
-
-    def test_delete_snapshot(self):
-        self.DPL_MOCK.delete_vdev_snapshot.return_value = DATA_OUTPUT
-        self.dpldriver.delete_snapshot(DATA_IN_SNAPSHOT)
-        self.DPL_MOCK.delete_vdev_snapshot.assert_called_once_with(
-            self._conver_uuid2hex(DATA_IN_SNAPSHOT['volume_id']),
-            self._conver_uuid2hex(DATA_IN_SNAPSHOT['id']))
-
-    def test_initialize_connection(self):
-        self.DPL_MOCK.assign_vdev.return_value = DATA_ASSIGNVDEV
-        self.DPL_MOCK.get_vdev.return_value = DATA_ASSIGNVDEV
-        res = self.dpldriver.initialize_connection(DATA_IN_VOLUME,
-                                                   DATA_IN_CONNECTOR)
-        self.assertEqual('iscsi', res['driver_volume_type'])
-        self.assertEqual(101, res['data']['target_lun'])
-        self.assertTrue(res['data']['target_discovered'])
-        self.assertEqual('172.31.1.210:3260', res['data']['target_portal'])
-        self.assertEqual(
-            'iqn.2013-09.com.prophetstor:hypervisor.886423051816',
-            res['data']['target_iqn'])
-
-    def test_terminate_connection(self):
-        self.DPL_MOCK.unassign_vdev.return_value = DATA_OUTPUT
-        self.dpldriver.terminate_connection(DATA_IN_VOLUME, DATA_IN_CONNECTOR)
-        self.DPL_MOCK.unassign_vdev.assert_called_once_with(
-            self._conver_uuid2hex(DATA_IN_VOLUME['id']),
-            DATA_IN_CONNECTOR['initiator'])
-
-    def test_terminate_connection_volume_detached(self):
-        self.DPL_MOCK.unassign_vdev.return_value = errno.ENODATA, None
-        self.dpldriver.terminate_connection(DATA_IN_VOLUME, DATA_IN_CONNECTOR)
-        self.DPL_MOCK.unassign_vdev.assert_called_once_with(
-            self._conver_uuid2hex(DATA_IN_VOLUME['id']),
-            DATA_IN_CONNECTOR['initiator'])
-
-    def test_terminate_connection_failed(self):
-        self.DPL_MOCK.unassign_vdev.return_value = errno.EFAULT, None
-        ex = self.assertRaises(
-            exception.VolumeBackendAPIException,
-            self.dpldriver.terminate_connection,
-            volume=DATA_IN_VOLUME, connector=DATA_IN_CONNECTOR)
-        self.assertIsNotNone(
-            re.match(r".*Flexvisor failed", ex.msg))
-
-    def test_get_pool_info(self):
-        self.DPL_MOCK.get_pool.return_value = DATA_POOLINFO
-        _, res = self.dpldriver._get_pool_info(POOLUUID)
-        self.assertEqual(4294967296, res['metadata']['available_capacity'])
-        self.assertEqual(1390551362349, res['metadata']['ctime'])
-        self.assertEqual('Default Pool',
-                         res['metadata']['display_description'])
-        self.assertEqual('default_pool',
-                         res['metadata']['display_name'])
-        self.assertEqual('4f7c4d679a664857afa4d51f282a516a',
-                         res['metadata']['event_uuid'])
-        self.assertEqual(
-            {'cache': [],
-             'data': ['disk_uuid_0', 'disk_uuid_1', 'disk_uuid_2'],
-             'log': [],
-             'spare': []},
-            res['metadata']['physical_device'])
-        self.assertEqual(POOLUUID, res['metadata']['pool_uuid'])
-        self.assertEqual(
-            {'raid_level': 'raid0'},
-            res['metadata']['properties'])
-        self.assertEqual('Online', res['metadata']['state'])
-        self.assertEqual(4294967296, res['metadata']['total_capacity'])
-        self.assertEqual('8173612007304181810', res['metadata']['zpool_guid'])
-
-    def test_create_group(self):
-        group_type = group_types.create(
-            self.context,
-            'group',
-            {'consistent_group_snapshot_enabled': '<is> True'}
-        )
-        group = test_utils.create_group(
-            self.context,
-            id=fake_constants.CONSISTENCY_GROUP_ID,
-            host='host@backend#unit_test_pool',
-            group_type_id=group_type.id)
-        self.DPL_MOCK.create_vg.return_value = DATA_OUTPUT
-        model_update = self.dpldriver.create_group(self.context, group)
-        self.DPL_MOCK.create_vg.assert_called_once_with(
-            self._conver_uuid2hex(fake_constants.CONSISTENCY_GROUP_ID),
-            'test_group',
-            'this is a test group')
-        self.assertDictEqual({'status': (
-            fields.ConsistencyGroupStatus.AVAILABLE)}, model_update)
-
-    def test_delete_group(self):
-        group_type = group_types.create(
-            self.context,
-            'group',
-            {'consistent_group_snapshot_enabled': '<is> True'}
-        )
-        group = test_utils.create_group(
-            self.context,
-            id=fake_constants.CONSISTENCY_GROUP_ID,
-            host='host@backend#unit_test_pool',
-            group_type_id=group_type.id)
-        self.DB_MOCK.volume_get_all_by_group.return_value = (
-            [DATA_IN_VOLUME_VG])
-        self.DPL_MOCK.delete_vdev.return_value = DATA_OUTPUT
-        self.DPL_MOCK.delete_cg.return_value = DATA_OUTPUT
-        model_update, volumes = self.dpldriver.delete_group(
-            self.context, group, [])
-        self.DPL_MOCK.delete_vg.assert_called_once_with(
-            self._conver_uuid2hex(fake_constants.CONSISTENCY_GROUP_ID))
-        self.DPL_MOCK.delete_vdev.assert_called_once_with(
-            self._conver_uuid2hex((DATA_IN_VOLUME_VG['id'])))
-        self.assertDictEqual({'status': (
-            fields.ConsistencyGroupStatus.DELETED)}, model_update)
-
-    def test_update_group(self):
-        group_type = group_types.create(
-            self.context,
-            'group',
-            {'consistent_group_snapshot_enabled': '<is> True'}
-        )
-        self.DPL_MOCK.get_vg.return_value = (0, DATA_OUT_CG)
-        self.DPL_MOCK.join_vg.return_value = DATA_OUTPUT
-        self.DPL_MOCK.leave_vg.return_value = DATA_OUTPUT
-        group = test_utils.create_group(
-            self.context,
-            id='fe2dbc51-5810-451d-ab2f-8c8a48d15bee',
-            host='host@backend#unit_test_pool',
-            group_type_id=group_type.id)
-        vol_add = test_utils.create_volume(
-            self.context,
-            id=fake_constants.VOLUME2_ID,
-            display_name=DATA_IN_VOLUME_VG['display_name'],
-            size=DATA_IN_VOLUME_VG['size'],
-            group_id='fe2dbc51-5810-451d-ab2f-8c8a48d15bee',
-            host=DATA_IN_VOLUME_VG['host'])
-        vol_del = test_utils.create_volume(
-            self.context,
-            id=DATA_IN_REMOVE_VOLUME_VG['id'],
-            display_name=DATA_IN_REMOVE_VOLUME_VG['display_name'],
-            size=DATA_IN_REMOVE_VOLUME_VG['size'],
-            group_id='fe2dbc51-5810-451d-ab2f-8c8a48d15bee',
-            host=DATA_IN_REMOVE_VOLUME_VG['host'])
-        (model_update, add_vols, remove_vols) = (
-            self.dpldriver.update_group(
-                self.context, group, [vol_add], [vol_del]))
-        self.DPL_MOCK.join_vg.assert_called_once_with(
-            self._conver_uuid2hex(vol_add.id),
-            self._conver_uuid2hex(group.id))
-        self.DPL_MOCK.leave_vg.assert_called_once_with(
-            self._conver_uuid2hex(vol_del.id),
-            self._conver_uuid2hex(group.id))
-        self.assertDictEqual({'status': (
-            fields.ConsistencyGroupStatus.AVAILABLE)}, model_update)
-
-    def test_update_group_exception_join(self):
-        group_type = group_types.create(
-            self.context,
-            'group',
-            {'consistent_group_snapshot_enabled': '<is> True'}
-        )
-        self.DPL_MOCK.get_vg.return_value = (0, DATA_OUT_CG)
-        self.DPL_MOCK.join_vg.return_value = -1, None
-        self.DPL_MOCK.leave_vg.return_value = DATA_OUTPUT
-        volume = test_utils.create_volume(
-            self.context,
-            id=fake_constants.VOLUME2_ID,
-            display_name=DATA_IN_VOLUME_VG['display_name'],
-            size=DATA_IN_VOLUME_VG['size'],
-            host=DATA_IN_VOLUME_VG['host'])
-        group = test_utils.create_group(
-            self.context,
-            id=fake_constants.CONSISTENCY_GROUP_ID,
-            host='host@backend#unit_test_pool',
-            group_type_id=group_type.id)
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.dpldriver.update_group,
-                          context=None,
-                          group=group,
-                          add_volumes=[volume],
-                          remove_volumes=None)
-
-    def test_update_group_exception_leave(self):
-        group_type = group_types.create(
-            self.context,
-            'group',
-            {'consistent_group_snapshot_enabled': '<is> True'}
-        )
-        self.DPL_MOCK.get_vg.return_value = (0, DATA_OUT_CG)
-        self.DPL_MOCK.leave_vg.return_value = -1, None
-        volume = test_utils.create_volume(
-            self.context,
-            id='fe2dbc51-5810-451d-ab2f-8c8a48d15bee',
-            display_name=DATA_IN_VOLUME_VG['display_name'],
-            size=DATA_IN_VOLUME_VG['size'],
-            host=DATA_IN_VOLUME_VG['host'])
-        group = test_utils.create_group(
-            self.context,
-            id=fake_constants.CONSISTENCY_GROUP_ID,
-            host='host@backend#unit_test_pool',
-            group_type_id=group_type.id)
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.dpldriver.update_group,
-                          context=None,
-                          group=group,
-                          add_volumes=None,
-                          remove_volumes=[volume])
-
-    @mock.patch(
-        'cinder.objects.snapshot.SnapshotList.get_all_for_group_snapshot')
-    def test_create_group_snapshot(self, get_all_for_group_snapshot):
-        group_type = group_types.create(
-            self.context,
-            'group',
-            {'consistent_group_snapshot_enabled': '<is> True'}
-        )
-        snapshot_obj = fake_snapshot.fake_snapshot_obj(self.context)
-        snapshot_obj.group_id = \
-            DATA_IN_CG_SNAPSHOT['group_id']
-        snapshot_obj.group_type_id = group_type.id
-        get_all_for_group_snapshot.return_value = [snapshot_obj]
-        self.DPL_MOCK.create_vdev_snapshot.return_value = DATA_OUTPUT
-        model_update, snapshots = self.dpldriver.create_group_snapshot(
-            self.context, snapshot_obj, [])
-        self.assertDictEqual({'status': 'available'}, model_update)
-
-    @mock.patch(
-        'cinder.objects.snapshot.SnapshotList.get_all_for_group_snapshot')
-    def test_delete_group_snapshot(self, get_all_for_group_snapshot):
-        group_type = group_types.create(
-            self.context,
-            'group',
-            {'consistent_group_snapshot_enabled': '<is> True'}
-        )
-        snapshot_obj = fake_snapshot.fake_snapshot_obj(self.context)
-        snapshot_obj.group_id = \
-            DATA_IN_CG_SNAPSHOT['group_id']
-        snapshot_obj.group_type_id = group_type.id
-        get_all_for_group_snapshot.return_value = [snapshot_obj]
-        self.DPL_MOCK.delete_group_snapshot.return_value = DATA_OUTPUT
-        model_update, snapshots = self.dpldriver.delete_group_snapshot(
-            self.context, snapshot_obj, [])
-        self.DPL_MOCK.delete_vdev_snapshot.assert_called_once_with(
-            self._conver_uuid2hex(snapshot_obj.group_id),
-            self._conver_uuid2hex(snapshot_obj.id),
-            True)
-        self.assertDictEqual({'status': 'deleted'}, model_update)
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_pure.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_pure.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_pure.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_pure.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,12 +14,12 @@
 #    under the License.
 
 from copy import deepcopy
+import http
 import sys
+from unittest import mock
 
 import ddt
-import mock
 from oslo_utils import units
-from six.moves import http_client
 
 from cinder import exception
 from cinder.objects import fields
@@ -42,7 +42,7 @@ def fake_retry(exceptions, interval=1, r
 patch_retry = mock.patch('cinder.utils.retry', fake_retry)
 patch_retry.start()
 sys.modules['purestorage'] = mock.Mock()
-from cinder.volume.drivers import pure
+from cinder.volume.drivers import pure  # noqa
 
 # Only mock utils.retry for cinder.volume.drivers.pure import
 patch_retry.stop()
@@ -506,7 +506,7 @@ class PureDriverTestCase(test.TestCase):
         self.purestorage_module.PureHTTPError = FakePureStorageHTTPError
 
     def fake_get_array(*args, **kwargs):
-        if 'action' in kwargs and kwargs['action'] is 'monitor':
+        if 'action' in kwargs and kwargs['action'] == 'monitor':
             return PERF_INFO_RAW
 
         if 'space' in kwargs and kwargs['space'] is True:
@@ -1063,7 +1063,7 @@ class PureBaseVolumeDriverTestCase(PureB
         self.array.list_volume_private_connections.return_value = {}
         self.array.destroy_volume.side_effect = \
             self.purestorage_module.PureHTTPError(
-                code=http_client.BAD_REQUEST,
+                code=http.client.BAD_REQUEST,
                 text="Volume does not exist"
             )
         self.driver.delete_volume(vol)
@@ -1078,7 +1078,7 @@ class PureBaseVolumeDriverTestCase(PureB
         self.array.assert_has_calls(expected)
         self.assertFalse(self.array.eradicate_volume.called)
         self.array.destroy_volume.side_effect = (
-            self.purestorage_module.PureHTTPError(code=http_client.BAD_REQUEST,
+            self.purestorage_module.PureHTTPError(code=http.client.BAD_REQUEST,
                                                   text="does not exist"))
         self.driver.delete_volume(vol)
         self.array.destroy_volume.side_effect = None
@@ -1203,7 +1203,7 @@ class PureBaseVolumeDriverTestCase(PureB
         self.array.assert_has_calls(expected)
         self.assertFalse(self.array.eradicate_volume.called)
         self.array.destroy_volume.side_effect = (
-            self.purestorage_module.PureHTTPError(code=http_client.BAD_REQUEST,
+            self.purestorage_module.PureHTTPError(code=http.client.BAD_REQUEST,
                                                   text=error_text))
         self.driver.delete_snapshot(snap)
         self.array.destroy_volume.side_effect = None
@@ -1259,7 +1259,7 @@ class PureBaseVolumeDriverTestCase(PureB
         # Branch where connection is missing and the host is still deleted
         self.array.reset_mock()
         self.array.disconnect_host.side_effect = \
-            self.purestorage_module.PureHTTPError(code=http_client.BAD_REQUEST,
+            self.purestorage_module.PureHTTPError(code=http.client.BAD_REQUEST,
                                                   text="is not connected")
         self.driver.terminate_connection(vol, ISCSI_CONNECTOR)
         self.array.disconnect_host.assert_called_with(PURE_HOST_NAME, vol_name)
@@ -1270,7 +1270,7 @@ class PureBaseVolumeDriverTestCase(PureB
         self.array.reset_mock()
         self.array.disconnect_host.side_effect = \
             self.purestorage_module.PureHTTPError(
-                code=http_client.INTERNAL_SERVER_ERROR,
+                code=http.client.INTERNAL_SERVER_ERROR,
                 text="Some other error"
             )
         self.assertRaises(self.purestorage_module.PureHTTPError,
@@ -1333,7 +1333,7 @@ class PureBaseVolumeDriverTestCase(PureB
         self.array.reset_mock()
         self.array.list_host_connections.return_value = []
         self.array.delete_host.side_effect = \
-            self.purestorage_module.PureHTTPError(code=http_client.BAD_REQUEST,
+            self.purestorage_module.PureHTTPError(code=http.client.BAD_REQUEST,
                                                   text=error)
         self.driver.terminate_connection(vol, ISCSI_CONNECTOR)
         self.array.disconnect_host.assert_called_with(PURE_HOST_NAME, vol_name)
@@ -1609,7 +1609,7 @@ class PureBaseVolumeDriverTestCase(PureB
 
         self.array.destroy_pgroup.side_effect = \
             self.purestorage_module.PureHTTPError(
-                code=http_client.BAD_REQUEST,
+                code=http.client.BAD_REQUEST,
                 text="Protection group has been destroyed."
             )
         self.driver.delete_consistencygroup(mock_context,
@@ -1621,7 +1621,7 @@ class PureBaseVolumeDriverTestCase(PureB
 
         self.array.destroy_pgroup.side_effect = \
             self.purestorage_module.PureHTTPError(
-                code=http_client.BAD_REQUEST,
+                code=http.client.BAD_REQUEST,
                 text="Protection group does not exist"
             )
         self.driver.delete_consistencygroup(mock_context,
@@ -1633,7 +1633,7 @@ class PureBaseVolumeDriverTestCase(PureB
 
         self.array.destroy_pgroup.side_effect = \
             self.purestorage_module.PureHTTPError(
-                code=http_client.BAD_REQUEST,
+                code=http.client.BAD_REQUEST,
                 text="Some other error"
             )
         self.assertRaises(self.purestorage_module.PureHTTPError,
@@ -1644,7 +1644,7 @@ class PureBaseVolumeDriverTestCase(PureB
 
         self.array.destroy_pgroup.side_effect = \
             self.purestorage_module.PureHTTPError(
-                code=http_client.INTERNAL_SERVER_ERROR,
+                code=http.client.INTERNAL_SERVER_ERROR,
                 text="Another different error"
             )
         self.assertRaises(self.purestorage_module.PureHTTPError,
@@ -1792,7 +1792,7 @@ class PureBaseVolumeDriverTestCase(PureB
 
         self.array.destroy_pgroup.side_effect = \
             self.purestorage_module.PureHTTPError(
-                code=http_client.BAD_REQUEST,
+                code=http.client.BAD_REQUEST,
                 text="Protection group snapshot has been destroyed."
             )
         self.driver.delete_cgsnapshot(mock_context, mock_cgsnap, [mock_snap])
@@ -1801,7 +1801,7 @@ class PureBaseVolumeDriverTestCase(PureB
 
         self.array.destroy_pgroup.side_effect = \
             self.purestorage_module.PureHTTPError(
-                code=http_client.BAD_REQUEST,
+                code=http.client.BAD_REQUEST,
                 text="Protection group snapshot does not exist"
             )
         self.driver.delete_cgsnapshot(mock_context, mock_cgsnap, [mock_snap])
@@ -1810,7 +1810,7 @@ class PureBaseVolumeDriverTestCase(PureB
 
         self.array.destroy_pgroup.side_effect = \
             self.purestorage_module.PureHTTPError(
-                code=http_client.BAD_REQUEST,
+                code=http.client.BAD_REQUEST,
                 text="Some other error"
             )
         self.assertRaises(self.purestorage_module.PureHTTPError,
@@ -1821,7 +1821,7 @@ class PureBaseVolumeDriverTestCase(PureB
 
         self.array.destroy_pgroup.side_effect = \
             self.purestorage_module.PureHTTPError(
-                code=http_client.INTERNAL_SERVER_ERROR,
+                code=http.client.INTERNAL_SERVER_ERROR,
                 text="Another different error"
             )
         self.assertRaises(self.purestorage_module.PureHTTPError,
@@ -1890,7 +1890,7 @@ class PureBaseVolumeDriverTestCase(PureB
         self.array.get_volume.side_effect = \
             self.purestorage_module.PureHTTPError(
                 text="Volume does not exist.",
-                code=http_client.BAD_REQUEST
+                code=http.client.BAD_REQUEST
             )
         self.assertRaises(exception.ManageExistingInvalidReference,
                           self.driver.manage_existing,
@@ -1987,7 +1987,7 @@ class PureBaseVolumeDriverTestCase(PureB
         self.array.rename_volume.side_effect = \
             self.purestorage_module.PureHTTPError(
                 text="Volume does not exist.",
-                code=http_client.BAD_REQUEST
+                code=http.client.BAD_REQUEST
             )
 
         self.driver.unmanage(vol)
@@ -2052,7 +2052,7 @@ class PureBaseVolumeDriverTestCase(PureB
         self.array.get_volume.side_effect = \
             self.purestorage_module.PureHTTPError(
                 text="Volume does not exist.",
-                code=http_client.BAD_REQUEST
+                code=http.client.BAD_REQUEST
             )
         self.assertRaises(exception.ManageExistingInvalidReference,
                           self.driver.manage_existing_snapshot,
@@ -2119,7 +2119,7 @@ class PureBaseVolumeDriverTestCase(PureB
         self.array.get_volume.side_effect = \
             self.purestorage_module.PureHTTPError(
                 text="Volume does not exist.",
-                code=http_client.BAD_REQUEST
+                code=http.client.BAD_REQUEST
             )
         self.assertRaises(exception.ManageExistingInvalidReference,
                           self.driver.manage_existing_snapshot_get_size,
@@ -2151,7 +2151,7 @@ class PureBaseVolumeDriverTestCase(PureB
         self.array.rename_volume.side_effect = \
             self.purestorage_module.PureHTTPError(
                 text="Snapshot does not exist.",
-                code=http_client.BAD_REQUEST
+                code=http.client.BAD_REQUEST
             )
 
         self.driver.unmanage_snapshot(snap)
@@ -2535,7 +2535,7 @@ class PureBaseVolumeDriverTestCase(PureB
 
     def test_does_pgroup_exist_not_exists(self):
         self.array.get_pgroup.side_effect = (
-            self.purestorage_module.PureHTTPError(code=http_client.BAD_REQUEST,
+            self.purestorage_module.PureHTTPError(code=http.client.BAD_REQUEST,
                                                   text="does not exist"))
         exists = self.driver._does_pgroup_exist(self.array, "some_pgroup")
         self.assertFalse(exists)
@@ -2736,7 +2736,7 @@ class PureBaseVolumeDriverTestCase(PureB
         }
         vol, vol_name = self.new_fake_vol(type_extra_specs=repl_extra_specs)
         self.array.set_pgroup.side_effect = FakePureStorageHTTPError(
-            code=http_client.BAD_REQUEST, text='already belongs to')
+            code=http.client.BAD_REQUEST, text='already belongs to')
         self.driver._enable_async_replication_if_needed(self.array, vol)
         self.array.set_pgroup.assert_called_with(
             self.driver._replication_pg_name,
@@ -2945,7 +2945,7 @@ class PureBaseVolumeDriverTestCase(PureB
 
     def test_disable_replication_already_disabled(self):
         self.array.set_pgroup.side_effect = FakePureStorageHTTPError(
-            code=http_client.BAD_REQUEST, text='could not be found')
+            code=http.client.BAD_REQUEST, text='could not be found')
         vol, vol_name = self.new_fake_vol()
         self.driver._disable_async_replication(vol)
         self.array.set_pgroup.assert_called_with(
@@ -3283,7 +3283,7 @@ class PureISCSIDriverTestCase(PureBaseSh
             [expected, {"host": "extra", "lun": 2}]
         self.array.connect_host.side_effect = \
             self.purestorage_module.PureHTTPError(
-                code=http_client.BAD_REQUEST,
+                code=http.client.BAD_REQUEST,
                 text="Connection already exists"
             )
         actual = self.driver._connect(self.array, vol_name, ISCSI_CONNECTOR,
@@ -3299,7 +3299,7 @@ class PureISCSIDriverTestCase(PureBaseSh
         self.array.list_volume_private_connections.return_value = {}
         self.array.connect_host.side_effect = \
             self.purestorage_module.PureHTTPError(
-                code=http_client.BAD_REQUEST,
+                code=http.client.BAD_REQUEST,
                 text="Connection already exists"
             )
         self.assertRaises(pure.PureDriverException, self.driver._connect,
@@ -3312,11 +3312,11 @@ class PureISCSIDriverTestCase(PureBaseSh
         vol, vol_name = self.new_fake_vol()
         mock_host.return_value = [PURE_HOST]
         self.array.list_volume_private_connections.side_effect = \
-            self.purestorage_module.PureHTTPError(code=http_client.BAD_REQUEST,
+            self.purestorage_module.PureHTTPError(code=http.client.BAD_REQUEST,
                                                   text="")
         self.array.connect_host.side_effect = \
             self.purestorage_module.PureHTTPError(
-                code=http_client.BAD_REQUEST,
+                code=http.client.BAD_REQUEST,
                 text="Connection already exists"
             )
         self.assertRaises(self.purestorage_module.PureHTTPError,
@@ -3335,7 +3335,7 @@ class PureISCSIDriverTestCase(PureBaseSh
 
         self.array.set_host.side_effect = (
             self.purestorage_module.PureHTTPError(
-                code=http_client.BAD_REQUEST, text='Host does not exist.'))
+                code=http.client.BAD_REQUEST, text='Host does not exist.'))
 
         # Because we mocked out retry make sure we are raising the right
         # exception to allow for retries to happen.
@@ -3350,7 +3350,7 @@ class PureISCSIDriverTestCase(PureBaseSh
 
         self.array.create_host.side_effect = (
             self.purestorage_module.PureHTTPError(
-                code=http_client.BAD_REQUEST,
+                code=http.client.BAD_REQUEST,
                 text='The specified IQN is already in use.'))
 
         # Because we mocked out retry make sure we are raising the right
@@ -3366,7 +3366,7 @@ class PureISCSIDriverTestCase(PureBaseSh
 
         self.array.create_host.side_effect = (
             self.purestorage_module.PureHTTPError(
-                code=http_client.BAD_REQUEST, text='Host already exists.'))
+                code=http.client.BAD_REQUEST, text='Host already exists.'))
 
         # Because we mocked out retry make sure we are raising the right
         # exception to allow for retries to happen.
@@ -3531,7 +3531,7 @@ class PureFCDriverTestCase(PureBaseShare
             [expected, {"host": "extra", "lun": 2}]
         self.array.connect_host.side_effect = \
             self.purestorage_module.PureHTTPError(
-                code=http_client.BAD_REQUEST,
+                code=http.client.BAD_REQUEST,
                 text="Connection already exists"
             )
         actual = self.driver._connect(self.array, vol_name, FC_CONNECTOR)
@@ -3546,7 +3546,7 @@ class PureFCDriverTestCase(PureBaseShare
         self.array.list_volume_private_connections.return_value = {}
         self.array.connect_host.side_effect = \
             self.purestorage_module.PureHTTPError(
-                code=http_client.BAD_REQUEST,
+                code=http.client.BAD_REQUEST,
                 text="Connection already exists"
             )
         self.assertRaises(pure.PureDriverException, self.driver._connect,
@@ -3559,11 +3559,11 @@ class PureFCDriverTestCase(PureBaseShare
         vol, vol_name = self.new_fake_vol()
         mock_host.return_value = [PURE_HOST]
         self.array.list_volume_private_connections.side_effect = \
-            self.purestorage_module.PureHTTPError(code=http_client.BAD_REQUEST,
+            self.purestorage_module.PureHTTPError(code=http.client.BAD_REQUEST,
                                                   text="")
         self.array.connect_host.side_effect = \
             self.purestorage_module.PureHTTPError(
-                code=http_client.BAD_REQUEST,
+                code=http.client.BAD_REQUEST,
                 text="Connection already exists"
             )
         self.assertRaises(self.purestorage_module.PureHTTPError,
@@ -3579,7 +3579,7 @@ class PureFCDriverTestCase(PureBaseShare
 
         self.array.create_host.side_effect = (
             self.purestorage_module.PureHTTPError(
-                code=http_client.BAD_REQUEST,
+                code=http.client.BAD_REQUEST,
                 text='The specified WWN is already in use.'))
 
         # Because we mocked out retry make sure we are raising the right
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_qnap.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_qnap.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_qnap.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_qnap.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,15 +13,14 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import base64
-from collections import OrderedDict
+import collections
+from unittest import mock
 
 from ddt import data
 from ddt import ddt
 from ddt import unpack
 from defusedxml import cElementTree as ET
 import eventlet
-import mock
 from oslo_config import cfg
 from oslo_utils import units
 import requests
@@ -39,19 +38,13 @@ CONF = cfg.CONF
 FAKE_LUNNAA = {'LUNNAA': 'fakeLunNaa'}
 FAKE_SNAPSHOT = {'snapshot_id': 'fakeSnapshotId'}
 
+FAKE_USER = 'admin'
 FAKE_PASSWORD = 'qnapadmin'
-FAKE_PARMS = OrderedDict()
-FAKE_PARMS['pwd'] = base64.b64encode(FAKE_PASSWORD.encode("utf-8"))
-FAKE_PARMS['serviceKey'] = 1
-FAKE_PARMS['user'] = 'admin'
-sanitized_params = OrderedDict()
-
-for key in FAKE_PARMS:
-    value = FAKE_PARMS[key]
-    if value is not None:
-        sanitized_params[key] = six.text_type(value)
-sanitized_params = utils.create_ordereddict(sanitized_params)
-global_sanitized_params = urllib.parse.urlencode(sanitized_params)
+FAKE_PASSWORD_ENCODED = 'cW5hcGFkbWlu'  # Base64 encoding of FAKE_PASSWORD
+FAKE_PARMS = collections.OrderedDict(pwd=FAKE_PASSWORD_ENCODED,
+                                     serviceKey='1',
+                                     user=FAKE_USER)
+global_sanitized_params = urllib.parse.urlencode(FAKE_PARMS)
 
 header = {
     'charset': 'utf-8',
@@ -1179,13 +1172,13 @@ class QnapDriverLoginTestCase(QnapDriver
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin', 'qnapadmin', mng_url,
+                FAKE_USER, FAKE_PASSWORD, mng_url,
                 '1.2.3.4', 'Storage Pool 1', True, verify_ssl=ssl))
         self.driver.do_setup('context')
 
         self.assertEqual('fakeSid', self.driver.api_executor.sid)
-        self.assertEqual('admin', self.driver.api_executor.username)
-        self.assertEqual('qnapadmin', self.driver.api_executor.password)
+        self.assertEqual(FAKE_USER, self.driver.api_executor.username)
+        self.assertEqual(FAKE_PASSWORD, self.driver.api_executor.password)
         self.assertEqual('1.2.3.4', self.driver.api_executor.ip)
         self.assertEqual(port, self.driver.api_executor.port)
         self.assertEqual(ssl, self.driver.api_executor.ssl)
@@ -1206,7 +1199,7 @@ class QnapDriverLoginTestCase(QnapDriver
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin', 'qnapadmin', mng_url,
+                FAKE_USER, FAKE_PASSWORD, mng_url,
                 '1.2.3.4', 'Storage Pool 1', True, verify_ssl=ssl))
 
         del self.driver.configuration.qnap_management_url
@@ -1231,7 +1224,7 @@ class QnapDriverLoginTestCase(QnapDriver
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin', 'qnapadmin', mng_url,
+                FAKE_USER, FAKE_PASSWORD, mng_url,
                 '1.2.3.4', 'Storage Pool 1', True, verify_ssl=ssl))
         self.assertRaises(exception.VolumeDriverException,
                           self.driver.do_setup, 'context')
@@ -1251,14 +1244,14 @@ class QnapDriverLoginTestCase(QnapDriver
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin', 'qnapadmin', mng_url,
+                FAKE_USER, FAKE_PASSWORD, mng_url,
                 '1.2.3.4', 'Storage Pool 1', True, verify_ssl=ssl))
         self.driver.do_setup('context')
         self.driver.check_for_setup_error()
 
         self.assertEqual('fakeSid', self.driver.api_executor.sid)
-        self.assertEqual('admin', self.driver.api_executor.username)
-        self.assertEqual('qnapadmin', self.driver.api_executor.password)
+        self.assertEqual(FAKE_USER, self.driver.api_executor.username)
+        self.assertEqual(FAKE_PASSWORD, self.driver.api_executor.password)
         self.assertEqual('1.2.3.4', self.driver.api_executor.ip)
         self.assertEqual(port, self.driver.api_executor.port)
         self.assertEqual(ssl, self.driver.api_executor.ssl)
@@ -1342,8 +1335,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -1386,8 +1379,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -1419,8 +1412,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -1452,8 +1445,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -1498,8 +1491,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 'Pool1',
                 True))
@@ -1562,8 +1555,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -1597,8 +1590,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -1635,8 +1628,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -1663,8 +1656,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -1703,8 +1696,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -1754,8 +1747,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -1787,8 +1780,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -1834,8 +1827,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -1866,8 +1859,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -1917,8 +1910,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -1972,8 +1965,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2028,8 +2021,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2086,8 +2079,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -2129,8 +2122,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2170,8 +2163,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2208,8 +2201,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2235,8 +2228,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2267,8 +2260,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2304,8 +2297,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2335,8 +2328,8 @@ class QnapDriverVolumeTestCase(QnapDrive
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2360,8 +2353,8 @@ class QnapDriverVolumeTestCase(QnapDrive
             'ES1640dc ', 'ES1640dc ', '1.1.3')
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2405,8 +2398,8 @@ class QnapDriverVolumeTestCase(QnapDrive
             'ES1640dc ', 'ES1640dc ', '1.1.3')
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2431,8 +2424,8 @@ class QnapDriverVolumeTestCase(QnapDrive
             'ES1640dc ', 'ES1640dc ', '1.1.3')
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2462,8 +2455,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2522,8 +2515,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2584,8 +2577,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2613,8 +2606,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2639,8 +2632,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2685,8 +2678,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2709,8 +2702,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2733,8 +2726,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2779,8 +2772,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2827,8 +2820,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2851,8 +2844,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2875,8 +2868,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2924,8 +2917,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2948,8 +2941,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -2970,8 +2963,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3026,8 +3019,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3050,8 +3043,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3073,8 +3066,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3105,8 +3098,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3152,8 +3145,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3176,8 +3169,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3200,8 +3193,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3246,8 +3239,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3270,8 +3263,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3294,8 +3287,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3341,8 +3334,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3365,8 +3358,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3389,8 +3382,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3434,8 +3427,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3455,8 +3448,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3498,8 +3491,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3542,8 +3535,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3586,8 +3579,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3632,8 +3625,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3655,8 +3648,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3702,8 +3695,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3726,8 +3719,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3774,8 +3767,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3799,8 +3792,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3824,8 +3817,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3873,8 +3866,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3897,8 +3890,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3921,8 +3914,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -3963,8 +3956,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4005,8 +3998,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4049,8 +4042,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4073,8 +4066,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4097,8 +4090,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4144,8 +4137,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4168,8 +4161,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4192,8 +4185,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4248,8 +4241,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4278,8 +4271,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4308,8 +4301,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4349,8 +4342,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4391,8 +4384,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4430,8 +4423,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4473,8 +4466,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4497,8 +4490,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4543,8 +4536,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4567,8 +4560,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4591,8 +4584,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4637,8 +4630,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4662,8 +4655,8 @@ class QnapAPIExecutorEsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -4713,8 +4706,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -4771,8 +4764,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -4831,8 +4824,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -4860,8 +4853,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -4886,8 +4879,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -4933,8 +4926,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -4957,8 +4950,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -4981,8 +4974,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5026,8 +5019,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5073,8 +5066,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5097,8 +5090,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5121,8 +5114,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5169,8 +5162,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5193,8 +5186,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5217,8 +5210,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5264,8 +5257,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5288,8 +5281,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5312,8 +5305,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5360,8 +5353,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5383,8 +5376,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5406,8 +5399,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5454,8 +5447,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5478,8 +5471,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5502,8 +5495,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5540,8 +5533,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5564,8 +5557,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5612,8 +5605,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5637,8 +5630,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5662,8 +5655,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5710,8 +5703,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5734,8 +5727,8 @@ class QnapAPIExecutorTsTestCase(QnapDriv
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Storage Pool 1',
@@ -5765,8 +5758,8 @@ class QnapAPIExecutorTesTestCase(QnapDri
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -5825,8 +5818,8 @@ class QnapAPIExecutorTesTestCase(QnapDri
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -5887,8 +5880,8 @@ class QnapAPIExecutorTesTestCase(QnapDri
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -5916,8 +5909,8 @@ class QnapAPIExecutorTesTestCase(QnapDri
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -5942,8 +5935,8 @@ class QnapAPIExecutorTesTestCase(QnapDri
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
@@ -5981,8 +5974,8 @@ class QnapAPIExecutorTesTestCase(QnapDri
 
         self.driver = qnap.QnapISCSIDriver(
             configuration=create_configuration(
-                'admin',
-                'qnapadmin',
+                FAKE_USER,
+                FAKE_PASSWORD,
                 'http://1.2.3.4:8080',
                 '1.2.3.4',
                 'Pool1',
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_quobyte.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_quobyte.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_quobyte.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_quobyte.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,21 +15,22 @@
 #    under the License.
 """Unit tests for the Quobyte driver module."""
 
-import ddt
 import errno
 import os
-import psutil
 import shutil
-import six
 import traceback
+from unittest import mock
 
-import mock
+import ddt
 from oslo_concurrency import processutils as putils
 from oslo_utils import fileutils
 from oslo_utils import imageutils
 from oslo_utils import units
+import psutil
+import six
 
 from cinder import context
+from cinder import db
 from cinder import exception
 from cinder.image import image_utils
 from cinder import test
@@ -1273,7 +1274,9 @@ class QuobyteDriverTestCase(test.TestCas
     def test_copy_volume_to_image_raw_image(self):
         drv = self._driver
 
-        volume = self._simple_volume()
+        volume_type_id = db.volume_type_create(
+            self.context, {'name': 'quo_type', 'extra_specs': {}}).get('id')
+        volume = self._simple_volume(volume_type_id=volume_type_id)
         volume_path = '%s/%s' % (self.TEST_MNT_POINT, volume['name'])
         image_meta = {'id': '10958016-e196-42e3-9e7f-5d8927ae3099'}
 
@@ -1311,14 +1314,17 @@ class QuobyteDriverTestCase(test.TestCas
                                                        force_share=True,
                                                        run_as_root=False)
             mock_upload_volume.assert_called_once_with(
-                mock.ANY, mock.ANY, mock.ANY, upload_path, run_as_root=False)
+                mock.ANY, mock.ANY, mock.ANY, upload_path, run_as_root=False,
+                store_id=None)
             self.assertTrue(mock_create_temporary_file.called)
 
     def test_copy_volume_to_image_qcow2_image(self):
         """Upload a qcow2 image file which has to be converted to raw first."""
         drv = self._driver
 
-        volume = self._simple_volume()
+        volume_type_id = db.volume_type_create(
+            self.context, {'name': 'quo_type', 'extra_specs': {}}).get('id')
+        volume = self._simple_volume(volume_type_id=volume_type_id)
         volume_path = '%s/%s' % (self.TEST_MNT_POINT, volume['name'])
         image_meta = {'id': '10958016-e196-42e3-9e7f-5d8927ae3099'}
 
@@ -1360,14 +1366,17 @@ class QuobyteDriverTestCase(test.TestCas
             mock_convert_image.assert_called_once_with(
                 volume_path, upload_path, 'raw', run_as_root=False)
             mock_upload_volume.assert_called_once_with(
-                mock.ANY, mock.ANY, mock.ANY, upload_path, run_as_root=False)
+                mock.ANY, mock.ANY, mock.ANY, upload_path, run_as_root=False,
+                store_id=None)
             self.assertTrue(mock_create_temporary_file.called)
 
     def test_copy_volume_to_image_snapshot_exists(self):
         """Upload an active snapshot which has to be converted to raw first."""
         drv = self._driver
 
-        volume = self._simple_volume()
+        volume_type_id = db.volume_type_create(
+            self.context, {'name': 'quo_type', 'extra_specs': {}}).get('id')
+        volume = self._simple_volume(volume_type_id=volume_type_id)
         volume_path = '%s/volume-%s' % (self.TEST_MNT_POINT, self.VOLUME_UUID)
         volume_filename = 'volume-%s' % self.VOLUME_UUID
         image_meta = {'id': '10958016-e196-42e3-9e7f-5d8927ae3099'}
@@ -1411,7 +1420,8 @@ class QuobyteDriverTestCase(test.TestCas
             mock_convert_image.assert_called_once_with(
                 volume_path, upload_path, 'raw', run_as_root=False)
             mock_upload_volume.assert_called_once_with(
-                mock.ANY, mock.ANY, mock.ANY, upload_path, run_as_root=False)
+                mock.ANY, mock.ANY, mock.ANY, upload_path, run_as_root=False,
+                store_id=None)
             self.assertTrue(mock_create_temporary_file.called)
 
     def test_set_nas_security_options_default(self):
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_rbd.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_rbd.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_rbd.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_rbd.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,19 +14,19 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+import errno
 import math
 import os
 import tempfile
+import time
+from unittest import mock
+from unittest.mock import call
 import uuid
 
 import castellan
 import ddt
-import errno
-import mock
-from mock import call
 from oslo_utils import imageutils
 from oslo_utils import units
-import time
 
 from cinder import context
 from cinder import db
@@ -168,14 +168,6 @@ class MockDriverConfig(object):
         return getattr(self, value, self._default)
 
 
-def mock_driver_configuration(value):
-    if value == 'max_over_subscription_ratio':
-        return 1.0
-    if value == 'reserved_percentage':
-        return 0
-    return 'RBD'
-
-
 @ddt.ddt
 class RBDTestCase(test.TestCase):
 
@@ -423,18 +415,19 @@ class RBDTestCase(test.TestCase):
         'image.features()'will be both called for 'exclusive-lock' and
         'journaling' in this order.
         """
-        journaling_feat = 1
-        exclusive_lock_feat = 2
-        self.driver.rbd.RBD_FEATURE_JOURNALING = journaling_feat
-        self.driver.rbd.RBD_FEATURE_EXCLUSIVE_LOCK = exclusive_lock_feat
         image = self.mock_proxy.return_value.__enter__.return_value
-        image.features.return_value = 0
+
+        image_features = 0
         if exclusive_lock_enabled:
-            image.features.return_value += exclusive_lock_feat
+            image_features |= self.driver.RBD_FEATURE_EXCLUSIVE_LOCK
         if journaling_enabled:
-            image.features.return_value += journaling_feat
+            image_features |= self.driver.RBD_FEATURE_JOURNALING
+
+        image.features.return_value = image_features
+
         journaling_status = str(journaling_enabled).lower()
         exclusive_lock_status = str(exclusive_lock_enabled).lower()
+
         expected = {
             'replication_driver_data': ('{"had_exclusive_lock":%s,'
                                         '"had_journaling":%s}' %
@@ -444,14 +437,15 @@ class RBDTestCase(test.TestCase):
         }
         res = self.driver._enable_replication(self.volume_a)
         self.assertEqual(expected, res)
+
         if exclusive_lock_enabled and journaling_enabled:
             image.update_features.assert_not_called()
         elif exclusive_lock_enabled and not journaling_enabled:
-            image.update_features.assert_called_once_with(journaling_feat,
-                                                          True)
+            image.update_features.assert_called_once_with(
+                self.driver.RBD_FEATURE_JOURNALING, True)
         else:
-            calls = [call(exclusive_lock_feat, True),
-                     call(journaling_feat, True)]
+            calls = [call(self.driver.RBD_FEATURE_EXCLUSIVE_LOCK, True),
+                     call(self.driver.RBD_FEATURE_JOURNALING, True)]
             image.update_features.assert_has_calls(calls, any_order=False)
         image.mirror_image_enable.assert_called_once_with()
 
@@ -474,10 +468,10 @@ class RBDTestCase(test.TestCase):
             image.update_features.assert_not_called()
         elif had_journaling == 'false' and had_exclusive_lock == 'true':
             image.update_features.assert_called_once_with(
-                self.driver.rbd.RBD_FEATURE_JOURNALING, False)
+                self.driver.RBD_FEATURE_JOURNALING, False)
         else:
-            calls = [call(self.driver.rbd.RBD_FEATURE_JOURNALING, False),
-                     call(self.driver.rbd.RBD_FEATURE_EXCLUSIVE_LOCK,
+            calls = [call(self.driver.RBD_FEATURE_JOURNALING, False),
+                     call(self.driver.RBD_FEATURE_EXCLUSIVE_LOCK,
                           False)]
             image.update_features.assert_has_calls(calls, any_order=False)
 
@@ -1068,10 +1062,13 @@ class RBDTestCase(test.TestCase):
                 (self.mock_rbd.Image.return_value.protect_snap
                     .assert_called_once_with('.'.join(
                         (self.volume_b.name, 'clone_snap'))))
+                # We expect clone() to be called exactly once.
                 self.assertEqual(
                     1, self.mock_rbd.RBD.return_value.clone.call_count)
+                # Without flattening, only the source volume is opened,
+                # so only one call to close() should occur.
                 self.assertEqual(
-                    2, self.mock_rbd.Image.return_value.close.call_count)
+                    1, self.mock_rbd.Image.return_value.close.call_count)
                 self.assertTrue(mock_get_clone_depth.called)
                 mock_resize.assert_not_called()
                 mock_enable_repl.assert_not_called()
@@ -1107,7 +1104,7 @@ class RBDTestCase(test.TestCase):
         image.protect_snap.assert_called_once_with(name + '.clone_snap')
         self.assertEqual(1, self.mock_rbd.RBD.return_value.clone.call_count)
         self.assertEqual(
-            2, self.mock_rbd.Image.return_value.close.call_count)
+            1, self.mock_rbd.Image.return_value.close.call_count)
         mock_get_clone_depth.assert_called_once_with(
             self.mock_client().__enter__(), self.volume_a.name)
         mock_resize.assert_not_called()
@@ -1137,7 +1134,7 @@ class RBDTestCase(test.TestCase):
                 self.assertEqual(
                     1, self.mock_rbd.RBD.return_value.clone.call_count)
                 self.assertEqual(
-                    2, self.mock_rbd.Image.return_value.close.call_count)
+                    1, self.mock_rbd.Image.return_value.close.call_count)
                 self.assertTrue(mock_get_clone_depth.called)
                 self.assertEqual(
                     1, mock_resize.call_count)
@@ -1194,7 +1191,7 @@ class RBDTestCase(test.TestCase):
 
                 # We expect the driver to close both volumes, so 2 is expected
                 self.assertEqual(
-                    3, self.mock_rbd.Image.return_value.close.call_count)
+                    2, self.mock_rbd.Image.return_value.close.call_count)
                 self.assertTrue(mock_get_clone_depth.called)
                 mock_enable_repl.assert_not_called()
 
@@ -2459,6 +2456,55 @@ class RBDTestCase(test.TestCase):
         ret = driver.get_backup_device(self.context, backup)
         self.assertEqual(ret, (self.volume_b, False))
 
+    @common_mocks
+    def test_multiattach_exclusions(self):
+        self.assertEqual(
+            self.driver.RBD_FEATURE_JOURNALING |
+            self.driver.RBD_FEATURE_FAST_DIFF |
+            self.driver.RBD_FEATURE_OBJECT_MAP |
+            self.driver.RBD_FEATURE_EXCLUSIVE_LOCK,
+            self.driver.MULTIATTACH_EXCLUSIONS)
+
+    MULTIATTACH_FULL_FEATURES = (
+        driver.RBDDriver.RBD_FEATURE_LAYERING |
+        driver.RBDDriver.RBD_FEATURE_EXCLUSIVE_LOCK |
+        driver.RBDDriver.RBD_FEATURE_OBJECT_MAP |
+        driver.RBDDriver.RBD_FEATURE_FAST_DIFF |
+        driver.RBDDriver.RBD_FEATURE_JOURNALING)
+
+    MULTIATTACH_REDUCED_FEATURES = (
+        driver.RBDDriver.RBD_FEATURE_LAYERING |
+        driver.RBDDriver.RBD_FEATURE_EXCLUSIVE_LOCK)
+
+    @ddt.data(MULTIATTACH_FULL_FEATURES, MULTIATTACH_REDUCED_FEATURES)
+    @common_mocks
+    def test_enable_multiattach(self, features):
+        image = self.mock_proxy.return_value.__enter__.return_value
+        image_features = features
+        image.features.return_value = image_features
+
+        ret = self.driver._enable_multiattach(self.volume_a)
+
+        image.update_features.assert_called_once_with(
+            self.driver.MULTIATTACH_EXCLUSIONS & image_features, False)
+
+        self.assertEqual(
+            {'provider_location':
+             "{\"saved_features\":%s}" % image_features}, ret)
+
+    @ddt.data(MULTIATTACH_FULL_FEATURES, MULTIATTACH_REDUCED_FEATURES)
+    @common_mocks
+    def test_disable_multiattach(self, features):
+        image = self.mock_proxy.return_value.__enter__.return_value
+        self.volume_a.provider_location = '{"saved_features": %s}' % features
+
+        ret = self.driver._disable_multiattach(self.volume_a)
+
+        image.update_features.assert_called_once_with(
+            self.driver.MULTIATTACH_EXCLUSIONS & features, True)
+
+        self.assertEqual({'provider_location': None}, ret)
+
 
 class ManagedRBDTestCase(test_driver.BaseDriverTestCase):
     driver_name = "cinder.volume.drivers.rbd.RBDDriver"
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_remotefs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_remotefs.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_remotefs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_remotefs.py	2020-03-24 18:46:31.000000000 +0000
@@ -17,9 +17,9 @@ import copy
 import os
 import re
 import sys
+from unittest import mock
 
 import ddt
-import mock
 
 from cinder import context
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_rsd.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_rsd.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_rsd.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_rsd.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,9 +10,10 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import fixtures
-import mock
 import sys
+from unittest import mock
+
+import fixtures
 
 from cinder import exception
 from cinder.i18n import _
@@ -70,7 +71,7 @@ fake_sushy.exceptions.InvalidParameterVa
 sys.modules['rsd_lib'] = fake_rsd_lib
 sys.modules['sushy'] = fake_sushy
 
-from cinder.volume.drivers import rsd as rsd_driver
+from cinder.volume.drivers import rsd as rsd_driver  # noqa
 
 
 class RSDClientTestCase(test.TestCase):
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_san.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_san.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_san.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_san.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,7 @@
 #    under the License.
 #
 
-import mock
+from unittest import mock
 
 from cinder import test
 from cinder.volume import configuration
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_seagate.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_seagate.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_seagate.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_seagate.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,24 +16,21 @@
 #
 """Unit tests for OpenStack Cinder Seagate driver."""
 
-from cinder import exception
-from cinder import test
+from unittest import mock
 
-from cinder.objects import fields
+from defusedxml import lxml as etree
+import requests
 
+from cinder import exception
+from cinder.objects import fields
+from cinder import test
 import cinder.volume.drivers.stx.client
 import cinder.volume.drivers.stx.common
 import cinder.volume.drivers.stx.exception as stx_exception
 import cinder.volume.drivers.stx.fc
 import cinder.volume.drivers.stx.iscsi
-
 from cinder.zonemanager import utils as fczm_utils
 
-from defusedxml import lxml as etree
-
-import mock
-
-import requests
 
 STXClient = cinder.volume.drivers.stx.client.STXClient
 STXCommon = cinder.volume.drivers.stx.common.STXCommon
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_sheepdog.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_sheepdog.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_sheepdog.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_sheepdog.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,1396 +0,0 @@
-
-# Copyright (c) 2013 Zelin.io
-# Copyright (C) 2015 Nippon Telegraph and Telephone Corporation.
-# All Rights Reserved.
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-
-
-import contextlib
-import errno
-
-import mock
-from oslo_concurrency import processutils
-from oslo_utils import importutils
-from oslo_utils import units
-
-from cinder import context
-from cinder import exception
-from cinder.i18n import _
-from cinder.image import image_utils
-from cinder import test
-from cinder.tests.unit import fake_constants as fake
-from cinder.tests.unit import fake_snapshot
-from cinder.tests.unit import fake_volume
-from cinder import utils
-from cinder.volume import configuration as conf
-from cinder.volume.drivers import sheepdog
-
-SHEEP_ADDR = '127.0.0.1'
-SHEEP_PORT = 7000
-
-
-class SheepdogDriverTestDataGenerator(object):
-    def __init__(self):
-        self.TEST_VOLUME = self._make_fake_volume(self.TEST_VOL_DATA)
-        self.TEST_CLONED_VOLUME = self._make_fake_volume(
-            self.TEST_CLONED_VOL_DATA)
-        self.TEST_SNAPSHOT = self._make_fake_snapshot(
-            self.TEST_SNAPSHOT_DATA, self.TEST_VOLUME)
-
-    def sheepdog_cmd_error(self, cmd, exit_code, stdout, stderr):
-        return (('(Command: %(cmd)s) '
-                 '(Return Code: %(exit_code)s) '
-                 '(Stdout: %(stdout)s) '
-                 '(Stderr: %(stderr)s)') %
-                {'cmd': cmd,
-                 'exit_code': exit_code,
-                 'stdout': stdout.replace('\n', '\\n'),
-                 'stderr': stderr.replace('\n', '\\n')})
-
-    def _make_fake_volume(self, volume_data):
-        return fake_volume.fake_volume_obj(context.get_admin_context(),
-                                           **volume_data)
-
-    def _make_fake_snapshot(self, snapshot_data, src_volume):
-        snapshot_obj = fake_snapshot.fake_snapshot_obj(
-            context.get_admin_context(), **snapshot_data)
-        snapshot_obj.volume = src_volume
-        return snapshot_obj
-
-    def cmd_dog_vdi_create(self, name, size):
-        return ('env', 'LC_ALL=C', 'LANG=C', 'dog', 'vdi', 'create', name,
-                '%sG' % size, '-a', SHEEP_ADDR, '-p', SHEEP_PORT)
-
-    def cmd_dog_vdi_delete(self, name):
-        return ('env', 'LC_ALL=C', 'LANG=C', 'dog', 'vdi', 'delete', name,
-                '-a', SHEEP_ADDR, '-p', SHEEP_PORT)
-
-    def cmd_dog_vdi_create_snapshot(self, vdiname, snapname):
-        return ('env', 'LC_ALL=C', 'LANG=C', 'dog', 'vdi', 'snapshot', '-s',
-                snapname, '-a', SHEEP_ADDR, '-p', SHEEP_PORT, vdiname)
-
-    def cmd_dog_vdi_delete_snapshot(self, vdiname, snapname):
-        return ('env', 'LC_ALL=C', 'LANG=C', 'dog', 'vdi', 'delete', '-s',
-                snapname, '-a', SHEEP_ADDR, '-p', SHEEP_PORT, vdiname)
-
-    def cmd_qemuimg_vdi_clone(self, src_vdiname, src_snapname, dst_vdiname,
-                              size):
-        return ('env', 'LC_ALL=C', 'LANG=C', 'qemu-img', 'create', '-b',
-                'sheepdog:%(addr)s:%(port)s:%(src_vdiname)s:%(src_snapname)s' %
-                {'addr': SHEEP_ADDR, 'port': SHEEP_PORT,
-                 'src_vdiname': src_vdiname, 'src_snapname': src_snapname},
-                'sheepdog:%(addr)s:%(port)s:%(dst_vdiname)s' %
-                {'addr': SHEEP_ADDR, 'port': SHEEP_PORT,
-                 'dst_vdiname': dst_vdiname}, '%sG' % size)
-
-    def cmd_dog_vdi_resize(self, name, size):
-        return ('env', 'LC_ALL=C', 'LANG=C', 'dog', 'vdi', 'resize', name,
-                size, '-a', SHEEP_ADDR, '-p', SHEEP_PORT)
-
-    def cmd_dog_vdi_list(self, name):
-        return ('env', 'LC_ALL=C', 'LANG=C', 'dog', 'vdi', 'list', name,
-                '-r', '-a', SHEEP_ADDR, '-p', SHEEP_PORT)
-
-    def cmd_dog_node_info(self):
-        return ('env', 'LC_ALL=C', 'LANG=C', 'dog', 'node', 'info',
-                '-a', SHEEP_ADDR, '-p', SHEEP_PORT, '-r')
-
-    def cmd_dog_node_list(self):
-        return ('env', 'LC_ALL=C', 'LANG=C', 'dog', 'node', 'list',
-                '-a', SHEEP_ADDR, '-p', SHEEP_PORT, '-r')
-
-    CMD_DOG_CLUSTER_INFO = ('env', 'LC_ALL=C', 'LANG=C', 'dog', 'cluster',
-                            'info', '-a', SHEEP_ADDR, '-p', SHEEP_PORT)
-
-    TEST_VOL_DATA = {
-        'size': 1,
-        'id': fake.VOLUME_ID,
-        'provider_auth': None,
-        'host': 'host@backendsec#unit_test_pool',
-        'project_id': fake.PROJECT_ID,
-        'provider_location': 'location',
-        'display_name': 'vol1',
-        'display_description': 'unit test volume',
-        'volume_type_id': None,
-        'consistencygroup_id': None,
-    }
-
-    TEST_CLONED_VOL_DATA = {
-        'size': 2,
-        'id': fake.VOLUME2_ID,
-        'provider_auth': None,
-        'host': 'host@backendsec#unit_test_pool',
-        'project_id': fake.PROJECT_ID,
-        'provider_location': 'location',
-        'display_name': 'vol3',
-        'display_description': 'unit test cloned volume',
-        'volume_type_id': None,
-        'consistencygroup_id': None,
-    }
-
-    TEST_SNAPSHOT_DATA = {
-        'id': fake.SNAPSHOT_ID,
-    }
-
-    COLLIE_NODE_INFO = """
-0 107287605248 3623897354 3%
-Total 107287605248 3623897354 3% 54760833024
-"""
-
-    COLLIE_NODE_LIST = """
-0 127.0.0.1:7000 128 1
-"""
-
-    COLLIE_VDI_LIST = """
-= testvolume 0 0 0 0 1467037106 fd32fc 3
-"""
-
-    COLLIE_CLUSTER_INFO_0_5 = """\
-Cluster status: running
-
-Cluster created at Tue Jun 25 19:51:41 2013
-
-Epoch Time           Version
-2013-06-25 19:51:41      1 [127.0.0.1:7000, 127.0.0.1:7001, 127.0.0.1:7002]
-"""
-
-    COLLIE_CLUSTER_INFO_0_6 = """\
-Cluster status: running, auto-recovery enabled
-
-Cluster created at Tue Jun 25 19:51:41 2013
-
-Epoch Time           Version
-2013-06-25 19:51:41      1 [127.0.0.1:7000, 127.0.0.1:7001, 127.0.0.1:7002]
-"""
-
-    DOG_CLUSTER_RUNNING = """\
-Cluster status: running, auto-recovery enabled
-
-Cluster created at Thu Jun 18 17:24:56 2015
-
-Epoch Time           Version [Host:Port:V-Nodes,,,]
-2015-06-18 17:24:56      1 [127.0.0.1:7000:128, 127.0.0.1:7001:128,\
- 127.0.0.1:7002:128]
-"""
-
-    DOG_CLUSTER_INFO_TO_BE_FORMATTED = """\
-Cluster status: Waiting for cluster to be formatted
-"""
-
-    DOG_CLUSTER_INFO_WAITING_OTHER_NODES = """\
-Cluster status: Waiting for other nodes to join cluster
-
-Cluster created at Thu Jun 18 17:24:56 2015
-
-Epoch Time           Version [Host:Port:V-Nodes,,,]
-2015-06-18 17:24:56      1 [127.0.0.1:7000:128, 127.0.0.1:7001:128]
-"""
-
-    DOG_CLUSTER_INFO_SHUTTING_DOWN = """\
-Cluster status: System is shutting down
-"""
-
-    DOG_VDI_CREATE_VDI_ALREADY_EXISTS = """\
-Failed to create VDI %(vdiname)s: VDI exists already
-"""
-
-    DOG_VDI_SNAPSHOT_VDI_NOT_FOUND = """\
-Failed to create snapshot for volume-00000000-0000-0000-0000-000000000001: \
-No VDI found
-"""
-
-    DOG_VDI_SNAPSHOT_ALREADY_EXISTED = """\
-Failed to create snapshot for volume-00000000-0000-0000-0000-000000000001, \
-maybe snapshot id (0) or tag (snapshot-00000000-0000-0000-0000-000000000002) \
-is existed
-"""
-
-    DOG_VDI_SNAPSHOT_TAG_NOT_FOUND = """\
-Failed to open VDI volume-00000000-0000-0000-0000-000000000001 \
-(snapshot id: 0 snapshot tag: snapshot-00000000-0000-0000-0000-000000000002): \
-Failed to find requested tag
-"""
-
-    DOG_VDI_SNAPSHOT_VOLUME_NOT_FOUND = """\
-Failed to open VDI volume-00000000-0000-0000-0000-000000000001 \
-(snapshot id: 0 snapshot tag: snapshot-00000000-0000-0000-0000-000000000002): \
-No VDI found
-"""
-
-    DOG_VDI_RESIZE_SIZE_SHRINK = """\
-Shrinking VDIs is not implemented
-"""
-
-    DOG_VDI_RESIZE_TOO_LARGE = """\
-New VDI size is too large. This volume's max size is 4398046511104
-"""
-
-    DOG_COMMAND_ERROR_VDI_NOT_EXISTS = """\
-Failed to open VDI %(vdiname)s (snapshot id: 0 snapshot tag: ): No VDI found
-"""
-
-    DOG_COMMAND_ERROR_FAIL_TO_CONNECT = """\
-failed to connect to 127.0.0.1:7000: Connection refused
-failed to connect to 127.0.0.1:7000: Connection refused
-Failed to get node list
-"""
-
-    QEMU_IMG_VDI_ALREADY_EXISTS = """\
-qemu-img: sheepdog:volume-00000000-0000-0000-0000-000000000001: \
-VDI exists already,
-"""
-
-    QEMU_IMG_VDI_NOT_FOUND = """\
-qemu-img: sheepdog:volume-00000000-0000-0000-0000-000000000003: \
-cannot get vdi info, No vdi found, \
-volume-00000000-0000-0000-0000-000000000001 \
-snapshot-00000000-0000-0000-0000-000000000002
-"""
-
-    QEMU_IMG_SNAPSHOT_NOT_FOUND = """\
-qemu-img: sheepdog:volume-00000000-0000-0000-0000-000000000003: \
-cannot get vdi info, Failed to find the requested tag, \
-volume-00000000-0000-0000-0000-000000000001 \
-snapshot-00000000-0000-0000-0000-000000000002
-"""
-
-    QEMU_IMG_SIZE_TOO_LARGE = """\
-qemu-img: sheepdog:volume-00000000-0000-0000-0000-000000000001: \
-An image is too large. The maximum image size is 4096GB
-"""
-
-    QEMU_IMG_FAILED_TO_CONNECT = """\
-qemu-img: sheepdog::volume-00000000-0000-0000-0000-000000000001: \
-Failed to connect socket: Connection refused
-"""
-
-
-class FakeImageService(object):
-    def download(self, context, image_id, path):
-        pass
-
-
-class SheepdogIOWrapperTestCase(test.TestCase):
-    def setUp(self):
-        super(SheepdogIOWrapperTestCase, self).setUp()
-        self.volume = {'name': 'volume-2f9b2ff5-987b-4412-a91c-23caaf0d5aff'}
-        self.snapshot_name = 'snapshot-bf452d80-068a-43d7-ba9f-196cf47bd0be'
-
-        self.vdi_wrapper = sheepdog.SheepdogIOWrapper(
-            SHEEP_ADDR, SHEEP_PORT, self.volume)
-        self.snapshot_wrapper = sheepdog.SheepdogIOWrapper(
-            SHEEP_ADDR, SHEEP_PORT, self.volume, self.snapshot_name)
-
-        self.execute = mock.MagicMock()
-        self.mock_object(processutils, 'execute', self.execute)
-
-    def test_init(self):
-        self.assertEqual(self.volume['name'], self.vdi_wrapper._vdiname)
-        self.assertIsNone(self.vdi_wrapper._snapshot_name)
-        self.assertEqual(0, self.vdi_wrapper._offset)
-
-        self.assertEqual(self.snapshot_name,
-                         self.snapshot_wrapper._snapshot_name)
-
-    def test_execute(self):
-        cmd = ('cmd1', 'arg1')
-        data = 'data1'
-
-        self.vdi_wrapper._execute(cmd, data)
-
-        self.execute.assert_called_once_with(*cmd, process_input=data)
-
-    def test_execute_error(self):
-        cmd = ('cmd1', 'arg1')
-        data = 'data1'
-        self.mock_object(processutils, 'execute',
-                         mock.MagicMock(side_effect=OSError))
-
-        args = (cmd, data)
-        self.assertRaises(exception.VolumeDriverException,
-                          self.vdi_wrapper._execute,
-                          *args)
-
-    def test_read_vdi(self):
-        self.vdi_wrapper.read()
-        self.execute.assert_called_once_with(
-            'dog', 'vdi', 'read', '-a', SHEEP_ADDR, '-p', SHEEP_PORT,
-            self.volume['name'], 0, process_input=None)
-
-    def test_read_vdi_invalid(self):
-        self.vdi_wrapper._valid = False
-        self.assertRaises(exception.VolumeDriverException,
-                          self.vdi_wrapper.read)
-
-    def test_write_vdi(self):
-        data = 'data1'
-
-        self.vdi_wrapper.write(data)
-
-        self.execute.assert_called_once_with(
-            'dog', 'vdi', 'write', '-a', SHEEP_ADDR, '-p', SHEEP_PORT,
-            self.volume['name'], 0, len(data),
-            process_input=data)
-        self.assertEqual(len(data), self.vdi_wrapper.tell())
-
-    def test_write_vdi_invalid(self):
-        self.vdi_wrapper._valid = False
-        self.assertRaises(exception.VolumeDriverException,
-                          self.vdi_wrapper.write, 'dummy_data')
-
-    def test_read_snapshot(self):
-        self.snapshot_wrapper.read()
-        self.execute.assert_called_once_with(
-            'dog', 'vdi', 'read', '-a', SHEEP_ADDR, '-p', SHEEP_PORT,
-            '-s', self.snapshot_name, self.volume['name'], 0,
-            process_input=None)
-
-    def test_seek(self):
-        self.vdi_wrapper.seek(12345)
-        self.assertEqual(12345, self.vdi_wrapper.tell())
-
-        self.vdi_wrapper.seek(-2345, whence=1)
-        self.assertEqual(10000, self.vdi_wrapper.tell())
-
-        # This results in negative offset.
-        self.assertRaises(IOError, self.vdi_wrapper.seek, -20000, whence=1)
-
-    def test_seek_invalid(self):
-        seek_num = 12345
-        self.vdi_wrapper._valid = False
-        self.assertRaises(exception.VolumeDriverException,
-                          self.vdi_wrapper.seek, seek_num)
-
-    def test_flush(self):
-        # flush does nothing.
-        self.vdi_wrapper.flush()
-        self.assertFalse(self.execute.called)
-
-    def test_fileno(self):
-        self.assertRaises(IOError, self.vdi_wrapper.fileno)
-
-
-class SheepdogClientTestCase(test.TestCase):
-    def setUp(self):
-        super(SheepdogClientTestCase, self).setUp()
-        self._cfg = conf.Configuration(None)
-        self._cfg.sheepdog_store_address = SHEEP_ADDR
-        self._cfg.sheepdog_store_port = SHEEP_PORT
-        self.driver = sheepdog.SheepdogDriver(configuration=self._cfg)
-        db_driver = self.driver.configuration.db_driver
-        self.db = importutils.import_module(db_driver)
-        self.driver.db = self.db
-        self.driver.do_setup(None)
-        self.test_data = SheepdogDriverTestDataGenerator()
-        node_list = [SHEEP_ADDR]
-        self.client = sheepdog.SheepdogClient(node_list, SHEEP_PORT)
-        self._addr = SHEEP_ADDR
-        self._port = SHEEP_PORT
-        self._vdiname = self.test_data.TEST_VOLUME.name
-        self._vdisize = self.test_data.TEST_VOLUME.size
-        self._src_vdiname = self.test_data.TEST_SNAPSHOT.volume_name
-        self._snapname = self.test_data.TEST_SNAPSHOT.name
-        self._dst_vdiname = self.test_data.TEST_CLONED_VOLUME.name
-        self._dst_vdisize = self.test_data.TEST_CLONED_VOLUME.size
-
-    @mock.patch.object(utils, 'execute')
-    def test_run_dog_success(self, fake_execute):
-        args = ('cluster', 'info')
-        expected_cmd = self.test_data.CMD_DOG_CLUSTER_INFO
-        fake_execute.return_value = ('', '')
-        self.client._run_dog(*args)
-        fake_execute.assert_called_once_with(*expected_cmd)
-
-    @mock.patch.object(utils, 'execute')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_run_dog_command_not_found(self, fake_logger, fake_execute):
-        args = ('cluster', 'info')
-        expected_msg = 'No such file or directory'
-        expected_errno = errno.ENOENT
-        fake_execute.side_effect = OSError(expected_errno, expected_msg)
-        self.assertRaises(OSError, self.client._run_dog, *args)
-        self.assertTrue(fake_logger.error.called)
-
-    @mock.patch.object(utils, 'execute')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_run_dog_operation_not_permitted(self, fake_logger, fake_execute):
-        args = ('cluster', 'info')
-        expected_msg = 'Operation not permitted'
-        expected_errno = errno.EPERM
-        fake_execute.side_effect = OSError(expected_errno, expected_msg)
-        self.assertRaises(OSError, self.client._run_dog, *args)
-        self.assertTrue(fake_logger.error.called)
-
-    @mock.patch.object(utils, 'execute')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_run_dog_fail_to_connect(self, fake_logger, fake_execute):
-        args = ('cluster', 'info')
-        cmd = self.test_data.CMD_DOG_CLUSTER_INFO
-        exit_code = 2
-        stdout = 'stdout dummy'
-        stderr = self.test_data.DOG_COMMAND_ERROR_FAIL_TO_CONNECT
-        expected_reason = (_('Failed to connect to sheep daemon. '
-                             'addr: %(addr)s, port: %(port)s'),
-                           {'addr': SHEEP_ADDR, 'port': SHEEP_PORT})
-        fake_execute.side_effect = processutils.ProcessExecutionError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout, stderr=stderr)
-        ex = self.assertRaises(sheepdog.SheepdogError,
-                               self.client._run_dog, *args)
-        self.assertEqual(expected_reason, ex.kwargs['reason'])
-
-    @mock.patch.object(utils, 'execute')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_run_dog_fail_to_connect_bugcase(self, fake_logger, fake_execute):
-        # NOTE(zhangsong): Sheepdog's bug case.
-        # details are written to Sheepdog driver code.
-        args = ('node', 'list')
-        stdout = ''
-        stderr = self.test_data.DOG_COMMAND_ERROR_FAIL_TO_CONNECT
-        expected_reason = (_('Failed to connect to sheep daemon. '
-                           'addr: %(addr)s, port: %(port)s'),
-                           {'addr': SHEEP_ADDR, 'port': SHEEP_PORT})
-        fake_execute.return_value = (stdout, stderr)
-        ex = self.assertRaises(sheepdog.SheepdogError,
-                               self.client._run_dog, *args)
-        self.assertEqual(expected_reason, ex.kwargs['reason'])
-
-    @mock.patch.object(utils, 'execute')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_run_dog_unknown_error(self, fake_logger, fake_execute):
-        args = ('cluster', 'info')
-        cmd = self.test_data.CMD_DOG_CLUSTER_INFO
-        exit_code = 1
-        stdout = 'stdout dummy'
-        stderr = 'stderr dummy'
-        expected_msg = self.test_data.sheepdog_cmd_error(
-            cmd=cmd, exit_code=exit_code, stdout=stdout, stderr=stderr)
-        fake_execute.side_effect = processutils.ProcessExecutionError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout, stderr=stderr)
-        ex = self.assertRaises(sheepdog.SheepdogCmdError,
-                               self.client._run_dog, *args)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(utils, 'execute')
-    def test_run_qemu_img_success(self, fake_execute):
-        # multiple part of args match the prefix and
-        # volume name is matched the prefix unfortunately
-        expected_cmd = ('env', 'LC_ALL=C', 'LANG=C',
-                        'qemu-img', 'create', '-b',
-                        'sheepdog:%(addr)s:%(port)s:sheepdog:snap' %
-                        {'addr': SHEEP_ADDR, 'port': SHEEP_PORT},
-                        'sheepdog:%(addr)s:%(port)s:clone' %
-                        {'addr': SHEEP_ADDR, 'port': SHEEP_PORT}, '10G')
-        fake_execute.return_value = ('', '')
-        self.client._run_qemu_img('create', '-b', 'sheepdog:sheepdog:snap',
-                                  'sheepdog:clone', '10G')
-        fake_execute.assert_called_once_with(*expected_cmd)
-
-    @mock.patch.object(utils, 'execute')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_run_qemu_img_command_not_found(self, fake_logger, fake_execute):
-        args = ('create', 'dummy')
-        expected_msg = 'No such file or directory'
-        expected_errno = errno.ENOENT
-        fake_execute.side_effect = OSError(expected_errno, expected_msg)
-        self.assertRaises(OSError, self.client._run_qemu_img, *args)
-        self.assertTrue(fake_logger.error.called)
-
-    @mock.patch.object(utils, 'execute')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_run_qemu_img_unknown_os_error(self, fake_logger, fake_execute):
-        args = ('create', 'dummy')
-        expected_msg = 'unknown'
-        expected_errno = errno.EPERM
-        fake_execute.side_effect = OSError(expected_errno, expected_msg)
-        self.assertRaises(OSError, self.client._run_qemu_img, *args)
-        self.assertTrue(fake_logger.error.called)
-
-    @mock.patch.object(utils, 'execute')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_run_qemu_img_fail_to_connect(self, fake_logger, fake_execute):
-        args = ('create', 'dummy')
-        cmd = ('qemu-img', 'create', 'dummy')
-        exit_code = 1
-        stdout = 'stdout dummy'
-        stderr = self.test_data.QEMU_IMG_FAILED_TO_CONNECT
-        expected_reason = (_('Failed to connect to sheep daemon. '
-                             'addr: %(addr)s, port: %(port)s'),
-                           {'addr': SHEEP_ADDR, 'port': SHEEP_PORT})
-        fake_execute.side_effect = processutils.ProcessExecutionError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout, stderr=stderr)
-        ex = self.assertRaises(sheepdog.SheepdogError,
-                               self.client._run_qemu_img, *args)
-        self.assertEqual(expected_reason, ex.kwargs['reason'])
-
-    @mock.patch.object(utils, 'execute')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_run_qemu_img_unknown_execution_error(self, fake_logger,
-                                                  fake_execute):
-        args = ('create', 'dummy')
-        cmd = ('qemu-img', 'create', 'dummy')
-        exit_code = 1
-        stdout = 'stdout dummy'
-        stderr = 'stderr dummy'
-        expected_msg = self.test_data.sheepdog_cmd_error(
-            cmd=cmd, exit_code=exit_code, stdout=stdout, stderr=stderr)
-        fake_execute.side_effect = processutils.ProcessExecutionError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout, stderr=stderr)
-        ex = self.assertRaises(sheepdog.SheepdogCmdError,
-                               self.client._run_qemu_img, *args)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_check_cluster_status_success(self, fake_logger, fake_execute):
-        stdout = self.test_data.DOG_CLUSTER_RUNNING
-        stderr = ''
-        expected_cmd = ('cluster', 'info')
-        fake_execute.return_value = (stdout, stderr)
-        self.client.check_cluster_status()
-        fake_execute.assert_called_once_with(*expected_cmd)
-        self.assertTrue(fake_logger.debug.called)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    def test_check_cluster_status_v0_5(self, fake_execute):
-        stdout = self.test_data.COLLIE_CLUSTER_INFO_0_5
-        stderr = ''
-        fake_execute.return_value = (stdout, stderr)
-        self.client.check_cluster_status()
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    def test_check_cluster_status_v0_6(self, fake_execute):
-        stdout = self.test_data.COLLIE_CLUSTER_INFO_0_6
-        stderr = ''
-        fake_execute.return_value = (stdout, stderr)
-        self.client.check_cluster_status()
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_check_cluster_status_not_formatted(self, fake_logger,
-                                                fake_execute):
-        stdout = self.test_data.DOG_CLUSTER_INFO_TO_BE_FORMATTED
-        stderr = ''
-        expected_reason = _('Cluster is not formatted. '
-                            'You should probably perform '
-                            '"dog cluster format".')
-        fake_execute.return_value = (stdout, stderr)
-        ex = self.assertRaises(sheepdog.SheepdogError,
-                               self.client.check_cluster_status)
-        self.assertEqual(expected_reason, ex.kwargs['reason'])
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_check_cluster_status_waiting_to_join_cluster(self, fake_logger,
-                                                          fake_execute):
-        stdout = self.test_data.DOG_CLUSTER_INFO_WAITING_OTHER_NODES
-        stderr = ''
-        expected_reason = _('Waiting for all nodes to join cluster. '
-                            'Ensure all sheep daemons are running.')
-        fake_execute.return_value = (stdout, stderr)
-        ex = self.assertRaises(sheepdog.SheepdogError,
-                               self.client.check_cluster_status)
-        self.assertEqual(expected_reason, ex.kwargs['reason'])
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_check_cluster_status_shutting_down(self, fake_logger,
-                                                fake_execute):
-        stdout = self.test_data.DOG_CLUSTER_INFO_SHUTTING_DOWN
-        stderr = ''
-        expected_reason = _('Invalid sheepdog cluster status.')
-        fake_execute.return_value = (stdout, stderr)
-        ex = self.assertRaises(sheepdog.SheepdogError,
-                               self.client.check_cluster_status)
-        self.assertEqual(expected_reason, ex.kwargs['reason'])
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_check_cluster_status_unknown_error(self, fake_logger,
-                                                fake_execute):
-        cmd = self.test_data.CMD_DOG_CLUSTER_INFO
-        exit_code = 2
-        stdout = 'stdout_dummy'
-        stderr = 'stdout_dummy'
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout, stderr=stderr)
-        ex = self.assertRaises(sheepdog.SheepdogCmdError,
-                               self.client.check_cluster_status)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    def test_create_success(self, fake_execute):
-        expected_cmd = ('vdi', 'create', self._vdiname, '%sG' % self._vdisize)
-        fake_execute.return_value = ('', '')
-        self.client.create(self._vdiname, self._vdisize)
-        fake_execute.assert_called_once_with(*expected_cmd)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_create_vdi_already_exists(self, fake_logger, fake_execute):
-        cmd = self.test_data.cmd_dog_vdi_create(self._vdiname, self._vdisize)
-        exit_code = 1
-        stdout = ''
-        stderr = (self.test_data.DOG_VDI_CREATE_VDI_ALREADY_EXISTS %
-                  {'vdiname': self._vdiname})
-        expected_msg = self.test_data.sheepdog_cmd_error(
-            cmd=cmd, exit_code=exit_code, stdout=stdout, stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError, self.client.create,
-                               self._vdiname, self._vdisize)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_create_unknown_error(self, fake_logger, fake_execute):
-        cmd = self.test_data.cmd_dog_vdi_create(self._vdiname, self._vdisize)
-        exit_code = 1
-        stdout = 'stdout_dummy'
-        stderr = 'stderr_dummy'
-        expected_msg = self.test_data.sheepdog_cmd_error(
-            cmd=cmd, exit_code=exit_code, stdout=stdout, stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError, self.client.create,
-                               self._vdiname, self._vdisize)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    def test_delete_success(self, fake_execute):
-        expected_cmd = ('vdi', 'delete', self._vdiname)
-        fake_execute.return_value = ('', '')
-        self.client.delete(self._vdiname)
-        fake_execute.assert_called_once_with(*expected_cmd)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_delete_vdi_not_found(self, fake_logger, fake_execute):
-        stdout = ''
-        stderr = (self.test_data.DOG_COMMAND_ERROR_VDI_NOT_EXISTS %
-                  {'vdiname': self._vdiname})
-        fake_execute.return_value = (stdout, stderr)
-        self.client.delete(self._vdiname)
-        self.assertTrue(fake_logger.warning.called)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_delete_unknown_error(self, fake_logger, fake_execute):
-        cmd = self.test_data.cmd_dog_vdi_delete(self._vdiname)
-        exit_code = 2
-        stdout = 'stdout_dummy'
-        stderr = 'stderr_dummy'
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError,
-                               self.client.delete, self._vdiname)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    def test_create_snapshot_success(self, fake_execute):
-        args = (self._src_vdiname, self._snapname)
-        expected_cmd = ('vdi', 'snapshot', '-s', self._snapname,
-                        self._src_vdiname)
-        fake_execute.return_value = ('', '')
-        self.client.create_snapshot(*args)
-        fake_execute.assert_called_once_with(*expected_cmd)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_create_snapshot_vdi_not_found(self, fake_logger, fake_execute):
-        args = (self._src_vdiname, self._snapname)
-        cmd = self.test_data.cmd_dog_vdi_create_snapshot(*args)
-        exit_code = 1
-        stdout = ''
-        stderr = self.test_data.DOG_VDI_SNAPSHOT_VDI_NOT_FOUND
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError,
-                               self.client.create_snapshot, *args)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_create_snapshot_snap_name_already_used(self, fake_logger,
-                                                    fake_execute):
-        args = (self._src_vdiname, self._snapname)
-        cmd = self.test_data.cmd_dog_vdi_create_snapshot(*args)
-        exit_code = 1
-        stdout = 'stdout_dummy'
-        stderr = self.test_data.DOG_VDI_SNAPSHOT_ALREADY_EXISTED
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError,
-                               self.client.create_snapshot, *args)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_create_snapshot_unknown_error(self, fake_logger, fake_execute):
-        args = (self._src_vdiname, self._snapname)
-        cmd = self.test_data.cmd_dog_vdi_create_snapshot(*args)
-        exit_code = 1
-        stdout = 'stdout_dummy'
-        stderr = 'unknown_error'
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError,
-                               self.client.create_snapshot, *args)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_delete_snapshot_success(self, fake_logger, fake_execute):
-        args = (self._src_vdiname, self._snapname)
-        expected_cmd = ('vdi', 'delete', '-s', self._snapname,
-                        self._src_vdiname)
-        fake_execute.return_value = ('', '')
-        self.client.delete_snapshot(*args)
-        fake_execute.assert_called_once_with(*expected_cmd)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_delete_snapshot_not_found(self, fake_logger, fake_execute):
-        args = (self._src_vdiname, self._snapname)
-        stdout = ''
-        stderr = self.test_data.DOG_VDI_SNAPSHOT_TAG_NOT_FOUND
-        fake_execute.return_value = (stdout, stderr)
-        self.client.delete_snapshot(*args)
-        self.assertTrue(fake_logger.warning.called)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_delete_snapshot_vdi_not_found(self, fake_logger, fake_execute):
-        args = (self._src_vdiname, self._snapname)
-        stdout = ''
-        stderr = self.test_data.DOG_VDI_SNAPSHOT_VOLUME_NOT_FOUND
-        fake_execute.return_value = (stdout, stderr)
-        self.client.delete_snapshot(*args)
-        self.assertTrue(fake_logger.warning.called)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_delete_snapshot_unknown_error(self, fake_logger, fake_execute):
-        args = (self._src_vdiname, self._snapname)
-        cmd = self.test_data.cmd_dog_vdi_delete_snapshot(*args)
-        exit_code = 2
-        stdout = 'stdout_dummy'
-        stderr = 'unknown_error'
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError,
-                               self.client.delete_snapshot, *args)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_qemu_img')
-    def test_clone_success(self, fake_execute):
-        args = (self._src_vdiname, self._snapname,
-                self._dst_vdiname, self._dst_vdisize)
-        src_volume = 'sheepdog:%(src_vdiname)s:%(snapname)s' % {
-            'src_vdiname': self._src_vdiname, 'snapname': self._snapname}
-        dst_volume = 'sheepdog:%s' % self._dst_vdiname
-        expected_cmd = ('create', '-b', src_volume, dst_volume,
-                        '%sG' % self._dst_vdisize)
-        fake_execute.return_code = ("", "")
-        self.client.clone(*args)
-        fake_execute.assert_called_once_with(*expected_cmd)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_qemu_img')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_clone_dst_vdi_already_exists(self, fake_logger, fake_execute):
-        args = (self._src_vdiname, self._snapname,
-                self._dst_vdiname, self._dst_vdisize)
-        cmd = self.test_data.cmd_qemuimg_vdi_clone(*args)
-        exit_code = 2
-        stdout = 'stdout_dummy'
-        stderr = self.test_data.QEMU_IMG_VDI_ALREADY_EXISTS
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError, self.client.clone,
-                               *args)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_qemu_img')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_clone_src_vdi_not_found(self, fake_logger, fake_execute):
-        args = (self._src_vdiname, self._snapname,
-                self._dst_vdiname, self._dst_vdisize)
-        cmd = self.test_data.cmd_qemuimg_vdi_clone(*args)
-        exit_code = 2
-        stdout = 'stdout_dummy'
-        stderr = self.test_data.QEMU_IMG_VDI_NOT_FOUND
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError, self.client.clone,
-                               *args)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_qemu_img')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_clone_src_snapshot_not_found(self, fake_logger, fake_execute):
-        args = (self._src_vdiname, self._snapname,
-                self._dst_vdiname, self._dst_vdisize)
-        cmd = self.test_data.cmd_qemuimg_vdi_clone(*args)
-        exit_code = 2
-        stdout = 'stdout_dummy'
-        stderr = self.test_data.QEMU_IMG_SNAPSHOT_NOT_FOUND
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError, self.client.clone,
-                               *args)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_qemu_img')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_clone_too_large_volume_size(self, fake_logger, fake_execute):
-        args = (self._src_vdiname, self._snapname,
-                self._dst_vdiname, self._dst_vdisize)
-        cmd = self.test_data.cmd_qemuimg_vdi_clone(*args)
-        exit_code = 2
-        stdout = 'stdout_dummy'
-        stderr = self.test_data.QEMU_IMG_SIZE_TOO_LARGE
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError, self.client.clone,
-                               *args)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_qemu_img')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_clone_unknown_error(self, fake_logger, fake_execute):
-        args = (self._src_vdiname, self._snapname,
-                self._dst_vdiname, self._dst_vdisize)
-        cmd = self.test_data.cmd_qemuimg_vdi_clone(*args)
-        exit_code = 2
-        stdout = 'stdout_dummy'
-        stderr = 'stderr_dummy'
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError, self.client.clone,
-                               *args)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    def test_resize_success(self, fake_execute):
-        expected_cmd = ('vdi', 'resize', self._vdiname, 10 * 1024 ** 3)
-        fake_execute.return_value = ('', '')
-        self.client.resize(self._vdiname, 10)
-        fake_execute.assert_called_once_with(*expected_cmd)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_resize_vdi_not_found(self, fake_logger, fake_execute):
-        cmd = self.test_data.cmd_dog_vdi_resize(self._vdiname, 10 * 1024 ** 3)
-        exit_code = 1
-        stdout = 'stdout_dummy'
-        stderr = (self.test_data.DOG_COMMAND_ERROR_VDI_NOT_EXISTS %
-                  {'vdiname': self._vdiname})
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError,
-                               self.client.resize, self._vdiname, 1)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_resize_shrinking_not_supported(self, fake_logger, fake_execute):
-        cmd = self.test_data.cmd_dog_vdi_resize(self._vdiname, 1 * 1024 ** 3)
-        exit_code = 1
-        stdout = 'stdout_dummy'
-        stderr = self.test_data.DOG_VDI_RESIZE_SIZE_SHRINK
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError,
-                               self.client.resize, self._vdiname, 1)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_resize_too_large_size(self, fake_logger, fake_execute):
-        cmd = self.test_data.cmd_dog_vdi_resize(self._vdiname, 5 * 1024 ** 4)
-        exit_code = 64
-        stdout = 'stdout_dummy'
-        stderr = self.test_data.DOG_VDI_RESIZE_TOO_LARGE
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError,
-                               self.client.resize, self._vdiname, 5120)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_resize_unknown_error(self, fake_logger, fake_execute):
-        cmd = self.test_data.cmd_dog_vdi_resize(self._vdiname, 10 * 1024 ** 3)
-        exit_code = 2
-        stdout = 'stdout_dummy'
-        stderr = 'stderr_dummy'
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError,
-                               self.client.resize, self._vdiname, 10)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    def test_get_volume_stats_success(self, fake_execute):
-        expected_cmd = ('node', 'info', '-r')
-        fake_execute.return_value = (self.test_data.COLLIE_NODE_INFO, '')
-        self.client.get_volume_stats()
-        fake_execute.assert_called_once_with(*expected_cmd)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_get_volume_stats_unknown_error(self, fake_logger, fake_execute):
-        cmd = self.test_data.cmd_dog_node_info()
-        exit_code = 2
-        stdout = 'stdout_dummy'
-        stderr = 'stderr_dummy'
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError,
-                               self.client.get_volume_stats)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    def test_get_vdi_info_success(self, fake_execute):
-
-        expected_cmd = ('vdi', 'list', self._vdiname, '-r')
-        fake_execute.return_value = (self.test_data.COLLIE_VDI_LIST, '')
-        self.client.get_vdi_info(self._vdiname)
-        fake_execute.assert_called_once_with(*expected_cmd)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_get_vdi_info_unknown_error(self, fake_logger, fake_execute):
-        cmd = self.test_data.cmd_dog_vdi_list(self._vdiname)
-        exit_code = 2
-        stdout = 'stdout_dummy'
-        stderr = 'stderr_dummy'
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError,
-                               self.client.get_vdi_info, self._vdiname)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    def test_update_node_list_success(self, fake_execute):
-        expected_cmd = ('node', 'list', '-r')
-        fake_execute.return_value = (self.test_data.COLLIE_NODE_LIST, '')
-        self.client.update_node_list()
-        fake_execute.assert_called_once_with(*expected_cmd)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_update_node_list_unknown_error(self, fake_logger, fake_execute):
-        cmd = self.test_data.cmd_dog_node_list()
-        exit_code = 2
-        stdout = 'stdout_dummy'
-        stderr = 'stderr_dummy'
-        expected_msg = self.test_data.sheepdog_cmd_error(cmd=cmd,
-                                                         exit_code=exit_code,
-                                                         stdout=stdout,
-                                                         stderr=stderr)
-        fake_execute.side_effect = sheepdog.SheepdogCmdError(
-            cmd=cmd, exit_code=exit_code, stdout=stdout.replace('\n', '\\n'),
-            stderr=stderr.replace('\n', '\\n'))
-        ex = self.assertRaises(sheepdog.SheepdogCmdError,
-                               self.client.update_node_list)
-        self.assertTrue(fake_logger.error.called)
-        self.assertEqual(expected_msg, ex.msg)
-
-
-class SheepdogDriverTestCase(test.TestCase):
-    def setUp(self):
-        super(SheepdogDriverTestCase, self).setUp()
-        self._cfg = conf.Configuration(None)
-        self._cfg.sheepdog_store_address = SHEEP_ADDR
-        self._cfg.sheepdog_store_port = SHEEP_PORT
-        self.driver = sheepdog.SheepdogDriver(configuration=self._cfg)
-        db_driver = self.driver.configuration.db_driver
-        self.db = importutils.import_module(db_driver)
-        self.driver.db = self.db
-        self.driver.do_setup(None)
-        self.test_data = SheepdogDriverTestDataGenerator()
-        self.client = self.driver.client
-        self._addr = SHEEP_ADDR
-        self._port = SHEEP_PORT
-        self._vdiname = self.test_data.TEST_VOLUME.name
-        self._vdisize = self.test_data.TEST_VOLUME.size
-        self._src_vdiname = self.test_data.TEST_SNAPSHOT.volume_name
-        self._snapname = self.test_data.TEST_SNAPSHOT.name
-        self._dst_vdiname = self.test_data.TEST_CLONED_VOLUME.name
-        self._dst_vdisize = self.test_data.TEST_CLONED_VOLUME.size
-
-    @mock.patch.object(sheepdog.SheepdogClient, 'update_node_list')
-    @mock.patch.object(sheepdog.SheepdogClient, 'check_cluster_status')
-    def test_check_for_setup_error(self, fake_check, fake_update):
-        self.driver.check_for_setup_error()
-        fake_check.assert_called_once_with()
-        fake_update.assert_called_once_with()
-
-    @mock.patch.object(sheepdog.SheepdogClient, 'create')
-    def test_create_volume(self, fake_execute):
-        self.driver.create_volume(self.test_data.TEST_VOLUME)
-        fake_execute.assert_called_once_with(self._vdiname, self._vdisize)
-
-    @mock.patch.object(sheepdog.SheepdogClient, 'delete')
-    def test_delete_volume(self, fake_execute):
-        self.driver.delete_volume(self.test_data.TEST_VOLUME)
-        fake_execute.assert_called_once_with(self._vdiname)
-
-    @mock.patch.object(sheepdog.SheepdogClient, 'get_volume_stats')
-    def test_update_volume_stats(self, fake_execute):
-        fake_execute.return_value = self.test_data.COLLIE_NODE_INFO
-        expected = dict(
-            volume_backend_name='sheepdog',
-            vendor_name='Open Source',
-            driver_version=self.driver.VERSION,
-            storage_protocol='sheepdog',
-            total_capacity_gb=float(107287605248) / units.Gi,
-            free_capacity_gb=float(107287605248 - 3623897354) / units.Gi,
-            reserved_percentage=0,
-            QoS_support=False)
-        actual = self.driver.get_volume_stats(True)
-        self.assertDictEqual(expected, actual)
-
-    @mock.patch.object(sheepdog.SheepdogClient, '_run_dog')
-    def test_copy_image_to_volume(self, fake_run_dog):
-        @contextlib.contextmanager
-        def fake_temp_file():
-            class FakeTmp(object):
-                def __init__(self, name):
-                    self.name = name
-            yield FakeTmp('test').name
-
-        def fake_try_execute(obj, *command, **kwargs):
-            return True
-
-        self.mock_object(image_utils, 'temporary_file', fake_temp_file)
-        self.mock_object(image_utils, 'fetch_verify_image',
-                         return_value=None)
-        self.mock_object(image_utils, 'convert_image',
-                         return_value=None)
-        self.mock_object(sheepdog.SheepdogDriver, '_try_execute',
-                         fake_try_execute)
-        fake_run_dog.return_value = ('fake_stdout', 'fake_stderr')
-        self.driver.copy_image_to_volume(None, self.test_data.TEST_VOLUME,
-                                         FakeImageService(), None)
-
-    @mock.patch('six.moves.builtins.open')
-    @mock.patch('cinder.image.image_utils.temporary_file')
-    def test_copy_volume_to_image(self, mock_temp, mock_open):
-        fake_context = {}
-        fake_volume = {'name': 'volume-00000001'}
-        fake_image_service = mock.Mock()
-        fake_image_meta = {'id': '10958016-e196-42e3-9e7f-5d8927ae3099'}
-        temp_file = mock_temp.return_value.__enter__.return_value
-
-        patch = mock.patch.object
-        with patch(self.driver, '_try_execute') as fake_try_execute:
-            self.driver.copy_volume_to_image(fake_context,
-                                             fake_volume,
-                                             fake_image_service,
-                                             fake_image_meta)
-
-            expected_cmd = ('qemu-img',
-                            'convert',
-                            '-f', 'raw',
-                            '-t', 'none',
-                            '-O', 'raw',
-                            'sheepdog:%s:%s:%s' % (
-                                self._addr,
-                                self._port,
-                                fake_volume['name']),
-                            mock.ANY)
-            mock_open.assert_called_once_with(temp_file, 'rb')
-            fake_try_execute.assert_called_once_with(*expected_cmd)
-            fake_image_service.update.assert_called_once_with(
-                fake_context, fake_image_meta['id'], mock.ANY, mock.ANY)
-
-    @mock.patch('six.moves.builtins.open')
-    @mock.patch('cinder.image.image_utils.temporary_file')
-    def test_copy_volume_to_image_nonexistent_volume(self, mock_temp,
-                                                     mock_open):
-        fake_context = {}
-        fake_volume = {
-            'name': 'nonexistent-volume-82c4539e-c2a5-11e4-a293-0aa186c60fe0'}
-        fake_image_service = mock.Mock()
-        fake_image_meta = {'id': '10958016-e196-42e3-9e7f-5d8927ae3099'}
-
-        patch = mock.patch.object
-        with patch(self.driver, '_try_execute') as fake_try_execute:
-            fake_try_execute.side_effect = (
-                processutils.ProcessExecutionError)
-            args = (fake_context, fake_volume, fake_image_service,
-                    fake_image_meta)
-            expected_cmd = ('qemu-img',
-                            'convert',
-                            '-f', 'raw',
-                            '-t', 'none',
-                            '-O', 'raw',
-                            'sheepdog:%s:%s:%s' % (
-                                self._addr,
-                                self._port,
-                                fake_volume['name']),
-                            mock.ANY)
-
-            self.assertRaises(processutils.ProcessExecutionError,
-                              self.driver.copy_volume_to_image,
-                              *args)
-
-            fake_try_execute.assert_called_once_with(*expected_cmd)
-            mock_open.assert_not_called()
-            fake_image_service.update.assert_not_called()
-
-    @mock.patch.object(sheepdog.SheepdogClient, 'create_snapshot')
-    @mock.patch.object(sheepdog.SheepdogClient, 'clone')
-    @mock.patch.object(sheepdog.SheepdogClient, 'delete_snapshot')
-    def test_create_cloned_volume(self, fake_delete_snapshot,
-                                  fake_clone, fake_create_snapshot):
-        src_vol = self.test_data.TEST_VOLUME
-        cloned_vol = self.test_data.TEST_CLONED_VOLUME
-
-        self.driver.create_cloned_volume(cloned_vol, src_vol)
-        snapshot_name = 'tmp-snap-%s-%s' % (src_vol.name, cloned_vol.id)
-        fake_create_snapshot.assert_called_once_with(src_vol.name,
-                                                     snapshot_name)
-        fake_clone.assert_called_once_with(src_vol.name, snapshot_name,
-                                           cloned_vol.name, cloned_vol.size)
-        fake_delete_snapshot.assert_called_once_with(src_vol.name,
-                                                     snapshot_name)
-
-    @mock.patch.object(sheepdog.SheepdogClient, 'create_snapshot')
-    @mock.patch.object(sheepdog.SheepdogClient, 'clone')
-    @mock.patch.object(sheepdog.SheepdogClient, 'delete_snapshot')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_create_cloned_volume_failure(self, fake_logger,
-                                          fake_delete_snapshot,
-                                          fake_clone, fake_create_snapshot):
-        src_vol = self.test_data.TEST_VOLUME
-        cloned_vol = self.test_data.TEST_CLONED_VOLUME
-        snapshot_name = 'tmp-snap-%s-%s' % (src_vol.name, cloned_vol.id)
-
-        fake_clone.side_effect = sheepdog.SheepdogCmdError(
-            cmd='dummy', exit_code=1, stdout='dummy', stderr='dummy')
-        self.assertRaises(sheepdog.SheepdogCmdError,
-                          self.driver.create_cloned_volume,
-                          cloned_vol, src_vol)
-        fake_delete_snapshot.assert_called_once_with(src_vol.name,
-                                                     snapshot_name)
-        self.assertTrue(fake_logger.error.called)
-
-    @mock.patch.object(sheepdog.SheepdogClient, 'create_snapshot')
-    def test_create_snapshot(self, fake_create_snapshot):
-        snapshot = self.test_data.TEST_SNAPSHOT
-        self.driver.create_snapshot(snapshot)
-        fake_create_snapshot.assert_called_once_with(snapshot.volume_name,
-                                                     snapshot.name)
-
-    @mock.patch.object(sheepdog.SheepdogClient, 'delete_snapshot')
-    def test_delete_snapshot(self, fake_delete_snapshot):
-        snapshot = self.test_data.TEST_SNAPSHOT
-        self.driver.delete_snapshot(snapshot)
-        fake_delete_snapshot.assert_called_once_with(snapshot.volume_name,
-                                                     snapshot.name)
-
-    def test_clone_image_success(self):
-        context = {}
-        image_id = "caa4ffd0-fake-fake-fake-f8631a807f5a"
-        image_location = ('sheepdog://192.168.1.111:7000:%s' % image_id, None)
-        image_meta = {'id': image_id, 'size': 1, 'disk_format': 'raw'}
-        image_service = ''
-
-        patch = mock.patch.object
-        with patch(self.driver, '_is_cloneable', return_value=True):
-            with patch(self.driver, 'create_cloned_volume'):
-                with patch(self.client, 'resize'):
-                    model_updated, cloned = self.driver.clone_image(
-                        context, self.test_data.TEST_CLONED_VOLUME,
-                        image_location, image_meta, image_service)
-
-        self.assertTrue(cloned)
-        self.assertEqual("sheepdog:%s:%s:%s" % (
-                         self._addr,
-                         self._port,
-                         self.test_data.TEST_CLONED_VOLUME.name),
-                         model_updated['provider_location'])
-
-    def test_clone_image_failure(self):
-        context = {}
-        fake_vol = {}
-        image_location = ('image_location', None)
-        image_meta = {}
-        image_service = ''
-
-        with mock.patch.object(self.driver, '_is_cloneable',
-                               lambda *args: False):
-            result = self.driver.clone_image(
-                context, fake_vol, image_location, image_meta, image_service)
-            self.assertEqual(({}, False), result)
-
-    def test_is_cloneable(self):
-        uuid = '87f1b01c-f46c-4537-bd5d-23962f5f4316'
-        location = 'sheepdog://127.0.0.1:7000:%s' % uuid
-        image_meta = {'id': uuid, 'size': 1, 'disk_format': 'raw'}
-        invalid_image_meta = {'id': uuid, 'size': 1, 'disk_format': 'iso'}
-
-        with mock.patch.object(self.client, 'get_vdi_info') as fake_execute:
-            fake_execute.return_value = self.test_data.COLLIE_VDI_LIST
-            self.assertTrue(
-                self.driver._is_cloneable(location, image_meta))
-
-            # Test for invalid location
-            self.assertFalse(
-                self.driver._is_cloneable('invalid-location', image_meta))
-
-            # Test for image not exist in sheepdog cluster
-            fake_execute.return_value = ''
-            self.assertFalse(
-                self.driver._is_cloneable(location, image_meta))
-
-            # Test for invalid image meta
-            self.assertFalse(
-                self.driver._is_cloneable(location, invalid_image_meta))
-
-    def test_create_volume_from_snapshot(self):
-        dst_volume = self.test_data.TEST_CLONED_VOLUME
-        snapshot = self.test_data.TEST_SNAPSHOT
-        with mock.patch.object(self.client, 'clone') as fake_execute:
-            self.driver.create_volume_from_snapshot(dst_volume, snapshot)
-            fake_execute.assert_called_once_with(self._src_vdiname,
-                                                 self._snapname,
-                                                 self._dst_vdiname,
-                                                 self._dst_vdisize)
-
-    def test_initialize_connection(self):
-        fake_volume = self.test_data.TEST_VOLUME
-        expected = {
-            'driver_volume_type': 'sheepdog',
-            'data': {
-                'name': fake_volume.name,
-                'hosts': ["127.0.0.1"],
-                'ports': ["7000"],
-            }
-        }
-        actual = self.driver.initialize_connection(fake_volume, None)
-        self.assertDictEqual(expected, actual)
-
-    @mock.patch.object(sheepdog.SheepdogClient, 'resize')
-    @mock.patch.object(sheepdog, 'LOG')
-    def test_extend_volume(self, fake_logger, fake_execute):
-        self.driver.extend_volume(self.test_data.TEST_VOLUME, 10)
-        fake_execute.assert_called_once_with(self._vdiname, 10)
-        self.assertTrue(fake_logger.debug.called)
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_spdk.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_spdk.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_spdk.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_spdk.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,16 +12,19 @@
 
 import copy
 import json
-import mock
+from unittest import mock
 
 from os_brick import initiator
 from os_brick.initiator import connector
+from oslo_utils import timeutils
 from oslo_utils import units
 
 from cinder import context
 from cinder import objects
 from cinder import test
+from cinder.tests.unit import fake_constants as fake
 from cinder.tests.unit import fake_volume
+from cinder.tests.unit import utils as test_utils
 from cinder import utils
 from cinder.volume import configuration as conf
 from cinder.volume.drivers import spdk as spdk_driver
@@ -250,23 +253,23 @@ class JSONRPCException(Exception):
 
 class JSONRPCClient(object):
     def __init__(self, addr=None, port=None):
-        self.methods = {"get_bdevs": self.get_bdevs,
-                        "get_lvol_stores": self.get_lvol_stores,
-                        "destroy_lvol_bdev": self.destroy_lvol_bdev,
-                        "snapshot_lvol_bdev": self.snapshot_lvol_bdev,
-                        "clone_lvol_bdev": self.clone_lvol_bdev,
-                        "construct_lvol_bdev": self.construct_lvol_bdev,
-                        "resize_lvol_bdev": self.resize_lvol_bdev,
-                        "get_nvmf_subsystems": self.get_nvmf_subsystems,
+        self.methods = {"bdev_get_bdevs": self.get_bdevs,
+                        "bdev_lvol_get_lvstores": self.get_lvol_stores,
+                        "bdev_lvol_delete": self.destroy_lvol_bdev,
+                        "bdev_lvol_snapshot": self.snapshot_lvol_bdev,
+                        "bdev_lvol_clone": self.clone_lvol_bdev,
+                        "bdev_lvol_create": self.construct_lvol_bdev,
+                        "bdev_lvol_resize": self.resize_lvol_bdev,
+                        "nvmf_get_subsystems": self.get_nvmf_subsystems,
                         "construct_nvmf_subsystem":
                             self.construct_nvmf_subsystem,
-                        "nvmf_subsystem_create":
+                        "nvmf_create_subsystem":
                             self.nvmf_subsystem_create,
                         "nvmf_subsystem_add_listener":
                             self.nvmf_subsystem_add_listener,
                         "nvmf_subsystem_add_ns":
                             self.nvmf_subsystem_add_ns,
-                        "inflate_lvol_bdev": self.inflate_lvol_bdev}
+                        "bdev_lvol_inflate": self.inflate_lvol_bdev}
         self.bdevs = copy.deepcopy(BDEVS)
         self.nvmf_subsystems = copy.deepcopy(NVMF_SUBSYSTEMS)
         self.lvol_stores = copy.deepcopy(LVOL_STORES)
@@ -513,6 +516,8 @@ class SpdkDriverTestCase(test.TestCase):
         self.jsonrpcclient = JSONRPCClient()
         self.driver = spdk_driver.SPDKDriver(configuration=
                                              self.configuration)
+        self._context = context.get_admin_context()
+        self.updated_at = timeutils.utcnow()
 
     def test__update_volume_stats(self):
         with mock.patch.object(self.driver, "_rpc_call",
@@ -536,7 +541,7 @@ class SpdkDriverTestCase(test.TestCase):
         with mock.patch.object(self.driver, "_rpc_call",
                                self.jsonrpcclient.call):
             bdev = self.driver._rpc_call(
-                "get_bdevs", params={"name": "lvs_test/lvol0"})
+                "bdev_get_bdevs", params={"name": "lvs_test/lvol0"})
             self.assertEqual(
                 bdev[0]['driver_specific']['lvol']['lvol_store_uuid'],
                 self.driver._get_spdk_lvs_uuid(
@@ -547,7 +552,7 @@ class SpdkDriverTestCase(test.TestCase):
     def test__get_spdk_lvs_free_space(self):
         with mock.patch.object(self.driver, "_rpc_call",
                                self.jsonrpcclient.call):
-            lvs = self.driver._rpc_call("get_lvol_stores")
+            lvs = self.driver._rpc_call("bdev_lvol_get_lvstores")
             lvol_store = None
             for lvol in lvs:
                 if lvol['name'] == "lvs_test":
@@ -583,7 +588,7 @@ class SpdkDriverTestCase(test.TestCase):
                              bdev)
             volume_clone = Volume()
             volume_clone.name = "clone0"
-            self.driver._rpc_call("snapshot_lvol_bdev",
+            self.driver._rpc_call("bdev_lvol_snapshot",
                                   params={'snapshot_name': "snapshot0",
                                           'lvol_name': "lvs_test/lvol2"})
             bdev = self.driver._get_spdk_volume_name("lvs_test/snapshot0")
@@ -628,19 +633,19 @@ class SpdkDriverTestCase(test.TestCase):
             db_volume = objects.Volume._from_db_object(ctxt, objects.Volume(),
                                                        db_volume)
             volume_get.return_value = db_volume
-            start_bdevs_len = len(self.driver._rpc_call('get_bdevs'))
+            start_bdevs_len = len(self.driver._rpc_call('bdev_get_bdevs'))
             self.driver.create_volume(db_volume)
-            tmp_bdevs = self.driver._rpc_call('get_bdevs')
+            tmp_bdevs = self.driver._rpc_call('bdev_get_bdevs')
             self.assertEqual(start_bdevs_len + 1, len(tmp_bdevs))
             volume = Volume()
             volume.name = "lvs_test/%s" % db_volume.name
             volume_name = self.driver._get_spdk_volume_name(volume.name)
-            self.driver._rpc_call('destroy_lvol_bdev', {"name": volume_name})
+            self.driver._rpc_call('bdev_lvol_delete', {"name": volume_name})
             self.driver.delete_volume(volume)
             bdev = self.driver._get_spdk_volume_name("lvs_test/%s"
                                                      % db_volume.name)
             self.assertIsNone(bdev)
-            tmp_bdevs = self.driver._rpc_call('get_bdevs')
+            tmp_bdevs = self.driver._rpc_call('bdev_get_bdevs')
             self.assertEqual(start_bdevs_len, len(tmp_bdevs))
 
     def get_volume_stats(self):
@@ -654,7 +659,7 @@ class SpdkDriverTestCase(test.TestCase):
                                self.jsonrpcclient.call):
             volume_clone = Volume()
             volume_clone.name = "clone0"
-            self.driver._rpc_call("snapshot_lvol_bdev",
+            self.driver._rpc_call("bdev_lvol_snapshot",
                                   params={'snapshot_name': "snapshot0",
                                           'lvol_name': "lvs_test/lvol2"})
             snapshot = Snapshot()
@@ -688,7 +693,7 @@ class SpdkDriverTestCase(test.TestCase):
                                self.jsonrpcclient.call):
             snapshot = Snapshot()
             snapshot.name = "snapshot0"
-            self.driver._rpc_call("snapshot_lvol_bdev",
+            self.driver._rpc_call("bdev_lvol_snapshot",
                                   params = {'snapshot_name': snapshot.name})
             self.driver.delete_snapshot(snapshot)
             snapshot = self.driver._get_spdk_volume_name("lvs_test/" +
@@ -733,16 +738,24 @@ class SpdkDriverTestCase(test.TestCase):
     def test_copy_volume_to_image(self, volume_get):
         with mock.patch.object(self.driver, "_rpc_call",
                                self.jsonrpcclient.call):
-            db_volume = fake_volume.fake_db_volume()
-            db_volume['provider_location'] = "127.0.0.1:3262 RDMA " \
-                                             "2016-06.io.spdk:cnode2"
+            provider_location = "127.0.0.1:3262 RDMA 2016-06.io.spdk:cnode2"
+            volume = test_utils.create_volume(
+                self._context, volume_type_id=fake.VOLUME_TYPE_ID,
+                updated_at=self.updated_at,
+                provider_location=provider_location)
+            extra_specs = {
+                'image_service:store_id': 'fake-store'
+            }
+            test_utils.create_volume_type(self._context.elevated(),
+                                          id=fake.VOLUME_TYPE_ID,
+                                          name="test_type",
+                                          extra_specs=extra_specs)
+
             ctxt = context.get_admin_context()
-            db_volume = objects.Volume._from_db_object(ctxt, objects.Volume(),
-                                                       db_volume)
-            volume_get.return_value = db_volume
+            volume_get.return_value = volume
             with mock.patch.object(self.driver.target_driver, "_rpc_call",
                                    self.jsonrpcclient.call):
-                self.driver.copy_volume_to_image(ctxt, db_volume, None, None)
+                self.driver.copy_volume_to_image(ctxt, volume, None, None)
 
     def test_extend_volume(self):
         with mock.patch.object(self.driver, "_rpc_call",
@@ -750,7 +763,7 @@ class SpdkDriverTestCase(test.TestCase):
             volume = Volume()
             volume.name = "lvs_test/lvol0"
             self.driver.extend_volume(volume, 2)
-            bdev = self.driver._rpc_call("get_bdevs",
+            bdev = self.driver._rpc_call("bdev_get_bdevs",
                                          params={"name": "lvs_test/lvol0"})
             self.assertEqual(2 * units.Gi,
                              bdev[0]['num_blocks'] * bdev[0]['block_size'])
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_storpool.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_storpool.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_storpool.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_storpool.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,9 +16,9 @@
 
 import re
 import sys
+from unittest import mock
 
 import ddt
-import mock
 from oslo_utils import units
 import six
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_veritas_cnfs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_veritas_cnfs.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_veritas_cnfs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_veritas_cnfs.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,8 +15,7 @@
 
 
 import os
-
-import mock
+from unittest import mock
 
 from cinder import context
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_vzstorage.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_vzstorage.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_vzstorage.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_vzstorage.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,477 +0,0 @@
-#  Copyright 2015 Odin
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-
-import collections
-import copy
-import ddt
-import errno
-import os
-
-import mock
-
-from os_brick.remotefs import remotefs
-from oslo_utils import units
-
-from cinder import context
-from cinder import exception
-from cinder.image import image_utils
-from cinder import test
-from cinder.tests.unit import fake_snapshot
-from cinder.tests.unit import fake_volume
-from cinder.volume.drivers import vzstorage
-
-
-_orig_path_exists = os.path.exists
-
-
-@ddt.ddt
-class VZStorageTestCase(test.TestCase):
-
-    _FAKE_SHARE = "10.0.0.1,10.0.0.2:/cluster123:123123"
-    _FAKE_MNT_BASE = '/mnt'
-    _FAKE_MNT_POINT = os.path.join(_FAKE_MNT_BASE, 'fake_hash')
-    _FAKE_VOLUME_NAME = 'volume-4f711859-4928-4cb7-801a-a50c37ceaccc'
-    _FAKE_VOLUME_PATH = os.path.join(_FAKE_MNT_POINT, _FAKE_VOLUME_NAME)
-    _FAKE_SNAPSHOT_ID = '50811859-4928-4cb7-801a-a50c37ceacba'
-    _FAKE_SNAPSHOT_PATH = (
-        _FAKE_VOLUME_PATH + '-snapshot' + _FAKE_SNAPSHOT_ID)
-
-    def setUp(self):
-        super(VZStorageTestCase, self).setUp()
-
-        self._cfg = mock.MagicMock()
-        self._cfg.vzstorage_shares_config = '/fake/config/path'
-        self._cfg.vzstorage_sparsed_volumes = False
-        self._cfg.vzstorage_used_ratio = 0.7
-        self._cfg.vzstorage_mount_point_base = self._FAKE_MNT_BASE
-        self._cfg.vzstorage_default_volume_format = 'raw'
-        self._cfg.nas_secure_file_operations = 'auto'
-        self._cfg.nas_secure_file_permissions = 'auto'
-
-        self._vz_driver = vzstorage.VZStorageDriver(configuration=self._cfg)
-        self._vz_driver._local_volume_dir = mock.Mock(
-            return_value=self._FAKE_MNT_POINT)
-        self._vz_driver._execute = mock.Mock()
-        self._vz_driver.base = self._FAKE_MNT_BASE
-
-        self.context = context.get_admin_context()
-        vol_type = fake_volume.fake_volume_type_obj(self.context)
-        vol_type.extra_specs = {}
-        _FAKE_VOLUME = {'id': '4f711859-4928-4cb7-801a-a50c37ceaccc',
-                        'size': 1,
-                        'provider_location': self._FAKE_SHARE,
-                        'name': self._FAKE_VOLUME_NAME,
-                        'status': 'available'}
-        self.vol = fake_volume.fake_volume_obj(self.context,
-                                               volume_type_id=vol_type.id,
-                                               **_FAKE_VOLUME)
-        self.vol.volume_type = vol_type
-
-        _FAKE_SNAPSHOT = {'id': self._FAKE_SNAPSHOT_ID,
-                          'status': 'available',
-                          'volume_size': 1}
-        self.snap = fake_snapshot.fake_snapshot_obj(self.context,
-                                                    **_FAKE_SNAPSHOT)
-        self.snap.volume = self.vol
-
-    def _path_exists(self, path):
-        if path.startswith(self._cfg.vzstorage_shares_config):
-            return True
-        return _orig_path_exists(path)
-
-    def _path_dont_exists(self, path):
-        if path.startswith('/fake'):
-            return False
-        return _orig_path_exists(path)
-
-    @mock.patch('os.path.exists')
-    def test_setup_ok(self, mock_exists):
-        mock_exists.side_effect = self._path_exists
-        self._vz_driver.do_setup(mock.sentinel.context)
-
-    @mock.patch('os.path.exists')
-    def test_setup_missing_shares_conf(self, mock_exists):
-        mock_exists.side_effect = self._path_dont_exists
-        self.assertRaises(vzstorage.VzStorageException,
-                          self._vz_driver.do_setup,
-                          mock.sentinel.context)
-
-    @mock.patch('os.path.exists')
-    def test_setup_invalid_usage_ratio(self, mock_exists):
-        mock_exists.side_effect = self._path_exists
-        self._vz_driver.configuration.vzstorage_used_ratio = 1.2
-        self.assertRaises(vzstorage.VzStorageException,
-                          self._vz_driver.do_setup,
-                          mock.sentinel.context)
-
-    @mock.patch('os.path.exists')
-    def test_setup_invalid_usage_ratio2(self, mock_exists):
-        mock_exists.side_effect = self._path_exists
-        self._vz_driver.configuration.vzstorage_used_ratio = 0
-        self.assertRaises(vzstorage.VzStorageException,
-                          self._vz_driver.do_setup,
-                          mock.sentinel.context)
-
-    @mock.patch('os.path.exists')
-    def test_setup_invalid_mount_point_base(self, mock_exists):
-        mock_exists.side_effect = self._path_exists
-        self._cfg.vzstorage_mount_point_base = './tmp'
-        vz_driver = vzstorage.VZStorageDriver(configuration=self._cfg)
-        self.assertRaises(vzstorage.VzStorageException,
-                          vz_driver.do_setup,
-                          mock.sentinel.context)
-
-    @mock.patch('os.path.exists')
-    def test_setup_no_vzstorage(self, mock_exists):
-        mock_exists.side_effect = self._path_exists
-        exc = OSError()
-        exc.errno = errno.ENOENT
-        self._vz_driver._execute.side_effect = exc
-        self.assertRaises(vzstorage.VzStorageException,
-                          self._vz_driver.do_setup,
-                          mock.sentinel.context)
-
-    @ddt.data({'qemu_fmt': 'parallels', 'glance_fmt': 'ploop'},
-              {'qemu_fmt': 'qcow2', 'glance_fmt': 'qcow2'})
-    @ddt.unpack
-    def test_initialize_connection(self, qemu_fmt, glance_fmt):
-        drv = self._vz_driver
-        info = mock.Mock()
-        info.file_format = qemu_fmt
-        snap_info = """{"volume_format": "%s",
-                        "active": "%s"}""" % (qemu_fmt, self.vol.id)
-        with mock.patch.object(drv, '_qemu_img_info', return_value=info):
-            with mock.patch.object(drv, '_read_file',
-                                   return_value=snap_info):
-                ret = drv.initialize_connection(self.vol, None)
-        name = drv.get_active_image_from_info(self.vol)
-        expected = {'driver_volume_type': 'vzstorage',
-                    'data': {'export': self._FAKE_SHARE,
-                             'format': glance_fmt,
-                             'name': name},
-                    'mount_point_base': self._FAKE_MNT_BASE}
-        self.assertEqual(expected, ret)
-
-    def test_ensure_share_mounted_invalid_share(self):
-        self.assertRaises(vzstorage.VzStorageException,
-                          self._vz_driver._ensure_share_mounted, ':')
-
-    @mock.patch.object(remotefs.RemoteFsClient, 'mount')
-    def test_ensure_share_mounted(self, mock_mount):
-        drv = self._vz_driver
-        share = 'test'
-        expected_calls = [
-            mock.call(share, ['-u', 'cinder', '-g', 'root', '-l',
-                              '/var/log/vstorage/%s/cinder.log.gz' % share]),
-            mock.call(share, ['-l', '/var/log/dummy.log'])
-        ]
-
-        share_flags = '["-u", "cinder", "-g", "root"]'
-        drv.shares[share] = share_flags
-        drv._ensure_share_mounted(share)
-
-        share_flags = '["-l", "/var/log/dummy.log"]'
-        drv.shares[share] = share_flags
-        drv._ensure_share_mounted(share)
-
-        mock_mount.assert_has_calls(expected_calls)
-
-    def test_find_share(self):
-        drv = self._vz_driver
-        drv._mounted_shares = [self._FAKE_SHARE]
-        with mock.patch.object(drv, '_is_share_eligible', return_value=True):
-            ret = drv._find_share(self.vol)
-            self.assertEqual(self._FAKE_SHARE, ret)
-
-    def test_find_share_no_shares_mounted(self):
-        drv = self._vz_driver
-        with mock.patch.object(drv, '_is_share_eligible', return_value=True):
-            self.assertRaises(vzstorage.VzStorageNoSharesMounted,
-                              drv._find_share, self.vol)
-
-    def test_find_share_no_shares_suitable(self):
-        drv = self._vz_driver
-        drv._mounted_shares = [self._FAKE_SHARE]
-        with mock.patch.object(drv, '_is_share_eligible', return_value=False):
-            self.assertRaises(vzstorage.VzStorageNoSuitableShareFound,
-                              drv._find_share, self.vol)
-
-    def test_is_share_eligible_false(self):
-        drv = self._vz_driver
-        cap_info = (100 * units.Gi, 40 * units.Gi, 60 * units.Gi)
-        with mock.patch.object(drv, '_get_capacity_info',
-                               return_value=cap_info):
-            ret = drv._is_share_eligible(self._FAKE_SHARE, 50)
-            self.assertFalse(ret)
-
-    def test_is_share_eligible_true(self):
-        drv = self._vz_driver
-        cap_info = (100 * units.Gi, 40 * units.Gi, 60 * units.Gi)
-        with mock.patch.object(drv, '_get_capacity_info',
-                               return_value=cap_info):
-            ret = drv._is_share_eligible(self._FAKE_SHARE, 30)
-            self.assertTrue(ret)
-
-    @mock.patch.object(image_utils, 'resize_image')
-    def test_extend_volume(self, mock_resize_image):
-        drv = self._vz_driver
-        drv._check_extend_volume_support = mock.Mock(return_value=True)
-        drv._is_file_size_equal = mock.Mock(return_value=True)
-
-        snap_info = '{"active": "%s"}' % self.vol.id
-        with mock.patch.object(drv, 'get_volume_format',
-                               return_value="raw"):
-            with mock.patch.object(drv, 'get_active_image_from_info',
-                                   return_value=self._FAKE_VOLUME_PATH):
-                with mock.patch.object(drv, '_read_file',
-                                       return_value=snap_info):
-                    drv.extend_volume(self.vol, 10)
-
-        mock_resize_image.assert_called_once_with(self._FAKE_VOLUME_PATH, 10)
-
-    def _test_check_extend_support(self, is_eligible=True):
-        drv = self._vz_driver
-        drv.local_path = mock.Mock(return_value=self._FAKE_VOLUME_PATH)
-        drv._is_share_eligible = mock.Mock(return_value=is_eligible)
-
-        active = self._FAKE_VOLUME_PATH
-
-        drv.get_active_image_from_info = mock.Mock(return_value=active)
-        if not is_eligible:
-            self.assertRaises(exception.ExtendVolumeError,
-                              drv._check_extend_volume_support,
-                              self.vol, 2)
-        else:
-            drv._check_extend_volume_support(self.vol, 2)
-            drv._is_share_eligible.assert_called_once_with(self._FAKE_SHARE, 1)
-
-    def test_check_extend_support(self):
-        self._test_check_extend_support()
-
-    def test_check_extend_volume_uneligible_share(self):
-        self._test_check_extend_support(is_eligible=False)
-
-    @mock.patch.object(image_utils, 'convert_image')
-    def test_copy_volume_from_snapshot(self, mock_convert_image):
-        drv = self._vz_driver
-
-        fake_volume_info = {self._FAKE_SNAPSHOT_ID: 'fake_snapshot_file_name',
-                            'backing-files':
-                            {self._FAKE_SNAPSHOT_ID:
-                             self._FAKE_VOLUME_NAME}}
-        fake_img_info = mock.MagicMock()
-        fake_img_info.backing_file = self._FAKE_VOLUME_NAME
-
-        drv.get_volume_format = mock.Mock(return_value='raw')
-        drv._local_path_volume_info = mock.Mock(
-            return_value=self._FAKE_VOLUME_PATH + '.info')
-        drv._local_volume_dir = mock.Mock(
-            return_value=self._FAKE_MNT_POINT)
-        drv._read_info_file = mock.Mock(
-            return_value=fake_volume_info)
-        drv._qemu_img_info = mock.Mock(
-            return_value=fake_img_info)
-        drv.local_path = mock.Mock(
-            return_value=self._FAKE_VOLUME_PATH[:-1])
-        drv._extend_volume = mock.Mock()
-
-        drv._copy_volume_from_snapshot(
-            self.snap, self.vol,
-            self.vol['size'])
-        drv._extend_volume.assert_called_once_with(
-            self.vol, self.vol['size'], 'raw')
-        mock_convert_image.assert_called_once_with(
-            self._FAKE_VOLUME_PATH, self._FAKE_VOLUME_PATH[:-1], 'raw')
-
-    def test_delete_volume(self):
-        drv = self._vz_driver
-        fake_vol_info = self._FAKE_VOLUME_PATH + '.info'
-
-        drv._ensure_share_mounted = mock.MagicMock()
-        fake_ensure_mounted = drv._ensure_share_mounted
-
-        drv._local_volume_dir = mock.Mock(
-            return_value=self._FAKE_MNT_POINT)
-        drv.get_active_image_from_info = mock.Mock(
-            return_value=self._FAKE_VOLUME_NAME)
-        drv._delete = mock.Mock()
-        drv._local_path_volume_info = mock.Mock(
-            return_value=fake_vol_info)
-
-        with mock.patch('os.path.exists', lambda x: True):
-            drv.delete_volume(self.vol)
-
-            fake_ensure_mounted.assert_called_once_with(self._FAKE_SHARE)
-            drv._delete.assert_any_call(
-                self._FAKE_VOLUME_PATH)
-            drv._delete.assert_any_call(fake_vol_info)
-
-    @mock.patch('cinder.volume.drivers.remotefs.RemoteFSSnapDriverBase.'
-                '_write_info_file')
-    def test_delete_snapshot_ploop(self, _mock_write_info_file):
-        fake_snap_info = {
-            'active': self._FAKE_VOLUME_NAME,
-            self._FAKE_SNAPSHOT_ID: self._FAKE_SNAPSHOT_PATH,
-        }
-        self._vz_driver.get_volume_format = mock.Mock(
-            return_value=vzstorage.DISK_FORMAT_PLOOP)
-        self._vz_driver._read_info_file = mock.Mock(
-            return_value=fake_snap_info
-        )
-        self._vz_driver._get_desc_path = mock.Mock(
-            return_value='%s/DiskDescriptor.xml' % self._FAKE_VOLUME_PATH
-        )
-        self._vz_driver.delete_snapshot(self.snap)
-        self._vz_driver._execute.assert_called_once_with(
-            'ploop', 'snapshot-delete', '-u',
-            '{%s}' % self._FAKE_SNAPSHOT_ID,
-            '%s/DiskDescriptor.xml' % self._FAKE_VOLUME_PATH,
-            run_as_root=True
-        )
-
-    @mock.patch('cinder.volume.drivers.remotefs.RemoteFSSnapDriverBase.'
-                '_delete_snapshot')
-    def test_delete_snapshot_qcow2_invalid_snap_info(self,
-                                                     mock_delete_snapshot):
-        fake_snap_info = {
-            'active': self._FAKE_VOLUME_NAME,
-        }
-        self._vz_driver.get_volume_format = mock.Mock(
-            return_value=vzstorage.DISK_FORMAT_QCOW2)
-        self._vz_driver._read_info_file = mock.Mock(
-            return_value=fake_snap_info
-        )
-        self._vz_driver.delete_snapshot(self.snap)
-        self.assertFalse(mock_delete_snapshot.called)
-
-    def test_extend_volume_ploop(self):
-        drv = self._vz_driver
-        drv.get_active_image_from_info = mock.Mock(
-            return_value=self._FAKE_VOLUME_PATH)
-        drv.get_volume_format = mock.Mock(
-            return_value=vzstorage.DISK_FORMAT_PLOOP)
-        drv._is_share_eligible = mock.Mock(
-            return_value=True)
-        drv.extend_volume(self.vol, 100)
-        drv._execute.assert_called_once_with(
-            'ploop', 'resize', '-s', '100G',
-            '%s/DiskDescriptor.xml' % self._FAKE_VOLUME_PATH,
-            run_as_root=True)
-
-    @mock.patch.object(os.path, 'exists', return_value=False)
-    def test_do_create_volume_with_volume_type(self, mock_exists):
-        drv = self._vz_driver
-        drv.local_path = mock.Mock(
-            return_value=self._FAKE_VOLUME_PATH)
-        drv._write_info_file = mock.Mock()
-        drv._qemu_img_info = mock.Mock()
-        drv._create_qcow2_file = mock.Mock()
-        drv._create_ploop = mock.Mock()
-
-        volume_type = fake_volume.fake_volume_type_obj(self.context)
-        volume_type.extra_specs = {
-            'vz:volume_format': 'qcow2'
-        }
-        volume1 = fake_volume.fake_volume_obj(self.context)
-        volume1.size = 1024
-        volume1.volume_type = volume_type
-        volume2 = copy.deepcopy(volume1)
-        volume2.metadata = {
-            'volume_format': 'ploop'
-        }
-
-        drv._do_create_volume(volume1)
-        drv._create_qcow2_file.assert_called_once_with(
-            self._FAKE_VOLUME_PATH, 1024)
-
-        drv._do_create_volume(volume2)
-        drv._create_ploop.assert_called_once_with(
-            self._FAKE_VOLUME_PATH, 1024)
-
-    @mock.patch('cinder.volume.drivers.remotefs.RemoteFSSnapDriver.'
-                '_create_cloned_volume')
-    @mock.patch.object(vzstorage.VZStorageDriver, 'get_volume_format',
-                       return_value='qcow2')
-    def test_create_cloned_volume_qcow2(self,
-                                        mock_get_volume_format,
-                                        mock_remotefs_create_cloned_volume,
-                                        ):
-        drv = self._vz_driver
-        volume = fake_volume.fake_volume_obj(self.context)
-        src_vref_id = '375e32b2-804a-49f2-b282-85d1d5a5b9e1'
-        src_vref = fake_volume.fake_volume_obj(
-            self.context,
-            id=src_vref_id,
-            name='volume-%s' % src_vref_id,
-            provider_location=self._FAKE_SHARE)
-        src_vref.context = self.context
-
-        mock_remotefs_create_cloned_volume.return_value = {
-            'provider_location': self._FAKE_SHARE}
-        ret = drv.create_cloned_volume(volume, src_vref)
-        mock_remotefs_create_cloned_volume.assert_called_once_with(
-            volume, src_vref)
-        self.assertEqual(ret, {'provider_location': self._FAKE_SHARE})
-
-    @mock.patch.object(vzstorage.VZStorageDriver, '_local_path_volume_info')
-    @mock.patch.object(vzstorage.VZStorageDriver, '_create_snapshot_ploop')
-    @mock.patch.object(vzstorage.VZStorageDriver, 'delete_snapshot')
-    @mock.patch.object(vzstorage.VZStorageDriver, '_write_info_file')
-    @mock.patch.object(vzstorage.VZStorageDriver, '_copy_volume_from_snapshot')
-    @mock.patch.object(vzstorage.VZStorageDriver, 'get_volume_format',
-                       return_value='ploop')
-    def test_create_cloned_volume_ploop(self,
-                                        mock_get_volume_format,
-                                        mock_copy_volume_from_snapshot,
-                                        mock_write_info_file,
-                                        mock_delete_snapshot,
-                                        mock_create_snapshot_ploop,
-                                        mock_local_path_volume_info,
-                                        ):
-        drv = self._vz_driver
-        volume = fake_volume.fake_volume_obj(self.context)
-        src_vref_id = '375e32b2-804a-49f2-b282-85d1d5a5b9e1'
-        src_vref = fake_volume.fake_volume_obj(
-            self.context,
-            id=src_vref_id,
-            name='volume-%s' % src_vref_id,
-            provider_location=self._FAKE_SHARE)
-        src_vref.context = self.context
-
-        snap_attrs = ['volume_name', 'size', 'volume_size', 'name',
-                      'volume_id', 'id', 'volume']
-        Snapshot = collections.namedtuple('Snapshot', snap_attrs)
-
-        snap_ref = Snapshot(volume_name=volume.name,
-                            name='clone-snap-%s' % src_vref.id,
-                            size=src_vref.size,
-                            volume_size=src_vref.size,
-                            volume_id=src_vref.id,
-                            id=src_vref.id,
-                            volume=src_vref)
-
-        def _check_provider_location(volume):
-            self.assertEqual(volume.provider_location, self._FAKE_SHARE)
-            return mock.sentinel.fake_info_path
-        mock_local_path_volume_info.side_effect = _check_provider_location
-
-        ret = drv.create_cloned_volume(volume, src_vref)
-        self.assertEqual(ret, {'provider_location': self._FAKE_SHARE})
-
-        mock_write_info_file.assert_called_once_with(
-            mock.sentinel.fake_info_path, {'active': 'volume-%s' % volume.id})
-        mock_create_snapshot_ploop.assert_called_once_with(snap_ref)
-        mock_copy_volume_from_snapshot.assert_called_once_with(
-            snap_ref, volume, volume.size)
-        mock_delete_snapshot.assert_called_once_with(snap_ref)
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_zadara.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_zadara.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_zadara.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_zadara.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,7 +16,8 @@
 Tests for Zadara VPSA volume driver
 """
 import copy
-import mock
+from unittest import mock
+
 import requests
 from six.moves.urllib import parse
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_zfssa.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_zfssa.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/test_zfssa.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/test_zfssa.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,2074 +0,0 @@
-# Copyright (c) 2014, 2016, Oracle and/or its affiliates. All rights reserved.
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-"""Unit tests for Oracle's ZFSSA Cinder volume driver."""
-
-from datetime import date
-import errno
-import json
-import math
-
-import mock
-from oslo_utils import units
-import six
-import textwrap
-
-from cinder import context
-from cinder import exception
-from cinder.image import image_utils
-from cinder import test
-from cinder.tests.unit import fake_utils
-from cinder.tests.unit import utils
-from cinder.volume import configuration as conf
-from cinder.volume import driver
-from cinder.volume.drivers import nfs as nfsdriver
-from cinder.volume.drivers import remotefs
-from cinder.volume.drivers.zfssa import restclient as client
-from cinder.volume.drivers.zfssa import webdavclient
-from cinder.volume.drivers.zfssa import zfssaiscsi as iscsi
-from cinder.volume.drivers.zfssa import zfssanfs
-from cinder.volume.drivers.zfssa import zfssarest as rest
-from cinder.volume import volume_utils
-
-
-nfs_logbias = 'latency'
-nfs_compression = 'off'
-zfssa_cache_dir = 'os-cinder-cache'
-
-no_virtsize_img = {
-    'id': 'no_virtsize_img_id1234',
-    'size': 654321,
-    'updated_at': date(2015, 1, 1),
-}
-
-small_img = {
-    'id': '1e5177e7-95e5-4a0f-b170-e45f4b469f6a',
-    'size': 654321,
-    'virtual_size': 2361393152,
-    'updated_at': date(2015, 1, 1),
-}
-
-large_img = {
-    'id': 'large_id5678',
-    'size': 50000000,
-    'virtual_size': 11806965760,
-    'updated_at': date(2015, 2, 2),
-}
-
-fakespecs = {
-    'prop1': 'prop1_val',
-    'prop2': 'prop2_val',
-}
-
-small_img_props = {
-    'size': 3,
-}
-
-img_props_nfs = {
-    'image_id': small_img['id'],
-    'updated_at': small_img['updated_at'].isoformat(),
-    'size': 3,
-    'name': '%(dir)s/os-cache-vol-%(name)s' % ({'dir': zfssa_cache_dir,
-                                                'name': small_img['id']}),
-    'id': small_img['id']
-}
-
-fakecontext = 'fakecontext'
-img_service = 'fakeimgservice'
-img_location = 'fakeimglocation'
-
-
-class ImgInfo(object):
-    def __init__(self, vsize):
-        self.virtual_size = vsize
-
-
-class FakeResponse(object):
-    def __init__(self, statuscode, data='data'):
-        self.status = statuscode
-        self.data = data
-
-
-class FakeSSL(object):
-    def _create_unverified_context(self):
-        return 'fakecontext'
-
-
-class TestZFSSAISCSIDriver(test.TestCase):
-
-    test_vol = {
-        'name': 'cindervol',
-        'size': 3,
-        'id': 1,
-        'provider_location': 'fake_location 1 2',
-        'provider_auth': 'fake_auth user pass',
-    }
-
-    test_vol2 = {
-        'name': 'cindervol2',
-        'size': 5,
-        'id': 2,
-        'provider_location': 'fake_location 3 4',
-        'provider_auth': 'fake_auth user pass',
-    }
-
-    test_snap = {
-        'name': 'cindersnap',
-        'volume_name': test_vol['name']
-    }
-
-    test_vol_snap = {
-        'name': 'cindersnapvol',
-        'size': test_vol['size']
-    }
-
-    def setUp(self):
-        super(TestZFSSAISCSIDriver, self).setUp()
-        self._create_fake_config()
-        self.mock_object(iscsi, 'factory_zfssa', spec=rest.ZFSSAApi)
-        self.mock_object(volume_utils, 'get_max_over_subscription_ratio',
-                         return_value=1.0)
-        iscsi.ZFSSAISCSIDriver._execute = fake_utils.fake_execute
-        self.drv = iscsi.ZFSSAISCSIDriver(configuration=self.configuration)
-        self.drv.do_setup({})
-
-    def _create_fake_config(self):
-        self.configuration = mock.Mock(spec=conf.Configuration)
-        self.configuration.san_ip = '1.1.1.1'
-        self.configuration.san_login = 'user'
-        self.configuration.san_password = 'passwd'
-        self.configuration.zfssa_pool = 'pool'
-        self.configuration.zfssa_project = 'project'
-        self.configuration.zfssa_lun_volblocksize = '8k'
-        self.configuration.zfssa_lun_sparse = 'false'
-        self.configuration.zfssa_lun_logbias = 'latency'
-        self.configuration.zfssa_lun_compression = 'off'
-        self.configuration.zfssa_initiator_group = 'test-init-grp1'
-        self.configuration.zfssa_initiator = \
-            'iqn.1-0.org.deb:01:d7, iqn.1-0.org.deb:01:d9'
-        self.configuration.zfssa_initiator_user = ''
-        self.configuration.zfssa_initiator_password = ''
-        self.configuration.zfssa_initiator_config = textwrap.dedent('''
-            {'test-init-grp1':
-              [{'iqn': 'iqn.1-0.org.deb:01:d7',
-                'user': '',
-                'password': ''}],
-             'test-init-grp2':
-              [{'iqn': 'iqn.1.0.org.deb:01:d9',
-                'user': '',
-                'password': ''}]
-            }
-            ''')
-        self.configuration.zfssa_target_group = 'test-target-grp1'
-        self.configuration.zfssa_target_user = ''
-        self.configuration.zfssa_target_password = ''
-        self.configuration.zfssa_target_portal = '1.1.1.1:3260'
-        self.configuration.zfssa_target_interfaces = 'e1000g0'
-        self.configuration.zfssa_rest_timeout = 60
-        self.configuration.volume_backend_name = 'fake_zfssa'
-        self.configuration.zfssa_enable_local_cache = True
-        self.configuration.zfssa_cache_project = zfssa_cache_dir
-        self.configuration.safe_get = self.fake_safe_get
-        self.configuration.zfssa_replication_ip = '1.1.1.1'
-        self.configuration.zfssa_manage_policy = 'loose'
-
-    def _util_migrate_volume_exceptions(self):
-        self.drv.zfssa.get_lun.return_value = (
-            {'targetgroup': 'test-target-grp1'})
-        self.drv.zfssa.get_asn.return_value = (
-            '9a2b5a0f-e3af-6d14-9578-8825f229dc89')
-        self.drv.tgt_zfssa.get_asn.return_value = (
-            '9a2b5a0f-e3af-6d14-9578-8825f229dc89')
-        targets = {'targets': [{'hostname': '2.2.2.2',
-                                'address': '2.2.2.2:216',
-                                'label': '2.2.2.2',
-                                'asn':
-                                '9a2b5a0f-e3af-6d14-9578-8825f229dc89'}]}
-
-        self.drv.zfssa.get_replication_targets.return_value = targets
-        self.drv.zfssa.edit_inherit_replication_flag.return_value = {}
-        self.drv.zfssa.create_replication_action.return_value = 'action-123'
-        self.drv.zfssa.send_repl_update.return_value = True
-
-    @mock.patch.object(iscsi.LOG, 'warning')
-    @mock.patch.object(iscsi.LOG, 'error')
-    @mock.patch.object(iscsi, 'factory_zfssa')
-    def test_parse_initiator_config(self, _factory_zfssa, elog, wlog):
-        """Test the parsing of the old style initator config variables. """
-        lcfg = self.configuration
-
-        with mock.patch.object(lcfg, 'zfssa_initiator_config', ''):
-            # Test empty zfssa_initiator_group
-            with mock.patch.object(lcfg, 'zfssa_initiator_group', ''):
-                self.assertRaises(exception.InvalidConfigurationValue,
-                                  self.drv.do_setup, {})
-
-            # Test empty zfssa_initiator with zfssa_initiator_group set to
-            # a value other than "default"
-            with mock.patch.object(lcfg, 'zfssa_initiator', ''):
-                self.assertRaises(exception.InvalidConfigurationValue,
-                                  self.drv.do_setup, {})
-
-            # Test zfssa_initiator_group set to 'default' with non-empty
-            # zfssa_initiator.
-            with mock.patch.object(lcfg, 'zfssa_initiator_group', 'default'):
-                self.drv.do_setup({})
-                wlog.assert_called_with(mock.ANY,
-                                        {'inigrp': lcfg.zfssa_initiator_group,
-                                         'ini': lcfg.zfssa_initiator})
-
-    def test_migrate_volume(self):
-        self._util_migrate_volume_exceptions()
-
-        volume = self.test_vol
-        volume.update({'host': 'fake_host',
-                       'status': 'available',
-                       'name': 'vol-1',
-                       'source_volid': self.test_vol['id']})
-
-        loc_info = '2.2.2.2:fake_auth:pool2:project2:test-target-grp1:2.2.2.2'
-
-        host = {'host': 'stack@zfssa_iscsi#fake_zfssa',
-                'capabilities': {'vendor_name': 'Oracle',
-                                 'storage_protocol': 'iSCSI',
-                                 'location_info': loc_info}}
-        ctxt = context.get_admin_context()
-
-        # Test the normal case
-        result = self.drv.migrate_volume(ctxt, volume, host)
-        self.assertEqual((True, None), result)
-
-        # Test when volume status is not available
-        volume['status'] = 'in-use'
-        result = self.drv.migrate_volume(ctxt, volume, host)
-        self.assertEqual((False, None), result)
-        volume['status'] = 'available'
-
-        # Test when vendor is not Oracle
-        host['capabilities']['vendor_name'] = 'elcarO'
-        result = self.drv.migrate_volume(ctxt, volume, host)
-        self.assertEqual((False, None), result)
-        host['capabilities']['vendor_name'] = 'Oracle'
-
-        # Test when storage protocol is not iSCSI
-        host['capabilities']['storage_protocol'] = 'not_iSCSI'
-        result = self.drv.migrate_volume(ctxt, volume, host)
-        self.assertEqual((False, None), result)
-        host['capabilities']['storage_protocol'] = 'iSCSI'
-
-        # Test when location_info is incorrect
-        host['capabilities']['location_info'] = ''
-        self.assertEqual((False, None), result)
-        host['capabilities']['location_info'] = loc_info
-
-        # Test if replication ip and replication target's address dont match
-        invalid_loc_info = (
-            '2.2.2.2:fake_auth:pool2:project2:test-target-grp1:9.9.9.9')
-        host['capabilities']['location_info'] = invalid_loc_info
-        result = self.drv.migrate_volume(ctxt, volume, host)
-        self.assertEqual((False, None), result)
-        host['capabilities']['location_info'] = loc_info
-
-        # Test if no targets are returned
-        self.drv.zfssa.get_replication_targets.return_value = {'targets': []}
-        result = self.drv.migrate_volume(ctxt, volume, host)
-        self.assertEqual((False, None), result)
-
-    def test_migrate_volume_uninherit_exception(self):
-        self._util_migrate_volume_exceptions()
-
-        volume = self.test_vol
-        volume.update({'host': 'fake_host',
-                       'status': 'available',
-                       'name': 'vol-1',
-                       'source_volid': self.test_vol['id']})
-
-        loc_info = '2.2.2.2:fake_auth:pool2:project2:test-target-grp1:2.2.2.2'
-
-        host = {'host': 'stack@zfssa_iscsi#fake_zfssa',
-                'capabilities': {'vendor_name': 'Oracle',
-                                 'storage_protocol': 'iSCSI',
-                                 'location_info': loc_info}}
-        ctxt = context.get_admin_context()
-
-        self.drv.zfssa.edit_inherit_replication_flag.side_effect = (
-            exception.VolumeBackendAPIException(data='uniherit ex'))
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv.migrate_volume, ctxt, volume, host)
-
-    def test_migrate_volume_create_action_exception(self):
-        self._util_migrate_volume_exceptions()
-
-        volume = self.test_vol
-        volume.update({'host': 'fake_host',
-                       'status': 'available',
-                       'name': 'vol-1',
-                       'source_volid': self.test_vol['id']})
-
-        loc_info = '2.2.2.2:fake_auth:pool2:project2:test-target-grp1:2.2.2.2'
-
-        host = {'host': 'stack@zfssa_iscsi#fake_zfssa',
-                'capabilities': {'vendor_name': 'Oracle',
-                                 'storage_protocol': 'iSCSI',
-                                 'location_info': loc_info}}
-        ctxt = context.get_admin_context()
-
-        self.drv.zfssa.create_replication_action.side_effect = (
-            exception.VolumeBackendAPIException(data=
-                                                'failed to create action'))
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv.migrate_volume, ctxt, volume, host)
-
-    def test_migrate_volume_send_update_exception(self):
-        self._util_migrate_volume_exceptions()
-
-        volume = self.test_vol
-        volume.update({'host': 'fake_host',
-                       'status': 'available',
-                       'name': 'vol-1',
-                       'source_volid': self.test_vol['id']})
-
-        loc_info = '2.2.2.2:fake_auth:pool2:project2:test-target-grp1:2.2.2.2'
-
-        host = {'host': 'stack@zfssa_iscsi#fake_zfssa',
-                'capabilities': {'vendor_name': 'Oracle',
-                                 'storage_protocol': 'iSCSI',
-                                 'location_info': loc_info}}
-        ctxt = context.get_admin_context()
-
-        self.drv.zfssa.send_repl_update.side_effect = (
-            exception.VolumeBackendAPIException(data='failed to send update'))
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv.migrate_volume, ctxt, volume, host)
-
-    def test_migrate_volume_sever_repl_exception(self):
-        self._util_migrate_volume_exceptions()
-
-        volume = self.test_vol
-        volume.update({'host': 'fake_host',
-                       'status': 'available',
-                       'name': 'vol-1',
-                       'source_volid': self.test_vol['id']})
-
-        loc_info = '2.2.2.2:fake_auth:pool2:project2:test-target-grp1:2.2.2.2'
-
-        host = {'host': 'stack@zfssa_iscsi#fake_zfssa',
-                'capabilities': {'vendor_name': 'Oracle',
-                                 'storage_protocol': 'iSCSI',
-                                 'location_info': loc_info}}
-        ctxt = context.get_admin_context()
-        self.drv.tgt_zfssa.sever_replication.side_effect = (
-            exception.VolumeBackendAPIException(data=
-                                                'failed to sever replication'))
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv.migrate_volume, ctxt, volume, host)
-
-    def test_create_delete_volume(self):
-        self.drv.zfssa.get_lun.return_value = {'guid':
-                                               '00000000000000000000000000000',
-                                               'number': 0,
-                                               'initiatorgroup': 'default',
-                                               'size': 1,
-                                               'nodestroy': False}
-        lcfg = self.configuration
-        self.drv.create_volume(self.test_vol)
-        self.drv.zfssa.create_lun.assert_called_once_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_project,
-            self.test_vol['name'],
-            six.text_type(self.test_vol['size']) + 'g',
-            lcfg.zfssa_target_group,
-            mock.ANY)
-        self.drv.delete_volume(self.test_vol)
-        self.drv.zfssa.get_lun.assert_called_once_with(lcfg.zfssa_pool,
-                                                       lcfg.zfssa_project,
-                                                       self.test_vol['name'])
-        self.drv.zfssa.delete_lun.assert_called_once_with(
-            pool=lcfg.zfssa_pool,
-            project=lcfg.zfssa_project,
-            lun=self.test_vol['name'])
-
-    def test_delete_volume_with_missing_lun(self):
-        self.drv.zfssa.get_lun.side_effect = exception.VolumeNotFound(
-            volume_id=self.test_vol['name'])
-        self.drv.delete_volume(self.test_vol)
-        self.drv.zfssa.delete_lun.assert_not_called()
-
-    def test_delete_volume_backend_fail(self):
-        self.drv.zfssa.get_lun.side_effect = \
-            exception.VolumeBackendAPIException(data='fakemsg')
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv.delete_volume,
-                          self.test_vol)
-
-    @mock.patch.object(iscsi.ZFSSAISCSIDriver, '_check_origin')
-    def test_delete_cache_volume(self, _check_origin):
-        lcfg = self.configuration
-        lun2del = {
-            'guid': '00000000000000000000000000000',
-            'number': 0,
-            'initiatorgroup': 'default',
-            'size': 1,
-            'nodestroy': False,
-            'origin': {
-                'project': lcfg.zfssa_cache_project,
-                'snapshot': 'image-%s' % small_img['id'],
-                'share': 'os-cache-vol-%s' % small_img['id'],
-            }
-        }
-        self.drv.zfssa.get_lun.return_value = lun2del
-        self.drv.delete_volume(self.test_vol)
-        self.drv._check_origin.assert_called_once_with(lun2del,
-                                                       self.test_vol['name'])
-
-    def test_check_origin(self):
-        lcfg = self.configuration
-        lun2del = {
-            'guid': '00000000000000000000000000000',
-            'number': 0,
-            'initiatorgroup': 'default',
-            'size': 1,
-            'nodestroy': False,
-            'origin': {
-                'project': lcfg.zfssa_cache_project,
-                'snapshot': 'image-%s' % small_img['id'],
-                'share': 'os-cache-vol-%s' % small_img['id'],
-            }
-        }
-        cache = lun2del['origin']
-        self.drv.zfssa.get_lun_snapshot.return_value = {
-            'name': self.test_snap['name'],
-            'numclones': 0
-        }
-        self.drv._check_origin(lun2del, 'volname')
-        self.drv.zfssa.delete_lun.assert_called_once_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_cache_project,
-            cache['share'])
-
-    def test_create_delete_snapshot(self):
-        self.drv.zfssa.get_lun_snapshot.return_value = {
-            'name': self.test_snap['name'],
-            'numclones': 0
-        }
-        lcfg = self.configuration
-        self.drv.create_snapshot(self.test_snap)
-        self.drv.zfssa.create_snapshot.assert_called_once_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_project,
-            self.test_snap['volume_name'],
-            self.test_snap['name'])
-        self.drv.delete_snapshot(self.test_snap)
-        self.drv.zfssa.delete_snapshot.assert_called_once_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_project,
-            self.test_snap['volume_name'],
-            self.test_snap['name'])
-
-    def test_delete_nonexistent_snapshot(self):
-        self.drv.zfssa.get_lun_snapshot.side_effect = \
-            exception.SnapshotNotFound(snapshot_id=self.test_snap['name'])
-        self.drv.delete_snapshot(self.test_snap)
-        self.drv.zfssa.delete_snapshot.assert_not_called()
-
-    def test_delete_snapshot_backend_fail(self):
-        self.drv.zfssa.get_lun_snapshot.side_effect = \
-            exception.VolumeBackendAPIException(data='fakemsg')
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv.delete_snapshot,
-                          self.test_snap)
-
-    def test_create_volume_from_snapshot(self):
-        lcfg = self.configuration
-        self.drv.zfssa.get_lun.return_value = self.test_vol
-        self.drv.create_snapshot(self.test_snap)
-        self.drv.zfssa.create_snapshot.assert_called_once_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_project,
-            self.test_snap['volume_name'],
-            self.test_snap['name'])
-        self.drv.create_volume_from_snapshot(self.test_vol_snap,
-                                             self.test_snap)
-        specs = self.drv._get_voltype_specs(self.test_vol)
-        specs.update({'custom:cinder_managed': True})
-        self.drv.zfssa.clone_snapshot.assert_called_once_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_project,
-            self.test_snap['volume_name'],
-            self.test_snap['name'],
-            lcfg.zfssa_project,
-            self.test_vol_snap['name'],
-            specs)
-
-    def test_create_larger_volume_from_snapshot(self):
-        lcfg = self.configuration
-        self.drv.zfssa.get_lun.return_value = self.test_vol
-        self.drv.create_snapshot(self.test_snap)
-        self.drv.zfssa.create_snapshot.assert_called_once_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_project,
-            self.test_snap['volume_name'],
-            self.test_snap['name'])
-
-        # use the larger test volume
-        self.drv.create_volume_from_snapshot(self.test_vol2,
-                                             self.test_snap)
-        specs = self.drv._get_voltype_specs(self.test_vol)
-        specs.update({'custom:cinder_managed': True})
-        self.drv.zfssa.clone_snapshot.assert_called_once_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_project,
-            self.test_snap['volume_name'],
-            self.test_snap['name'],
-            lcfg.zfssa_project,
-            self.test_vol2['name'],
-            specs)
-
-    @mock.patch.object(iscsi.ZFSSAISCSIDriver, '_get_provider_info')
-    def test_volume_attach_detach(self, _get_provider_info):
-        lcfg = self.configuration
-        test_target_iqn = 'iqn.1986-03.com.sun:02:00000-aaaa-bbbb-cccc-ddddd'
-        self.drv._get_provider_info.return_value = {
-            'provider_location': '%s %s' % (lcfg.zfssa_target_portal,
-                                            test_target_iqn)
-        }
-
-        def side_effect_get_initiator_initiatorgroup(arg):
-            return [{
-                'iqn.1-0.org.deb:01:d7': 'test-init-grp1',
-                'iqn.1-0.org.deb:01:d9': 'test-init-grp2',
-            }[arg]]
-
-        self.drv.zfssa.get_initiator_initiatorgroup.side_effect = (
-            side_effect_get_initiator_initiatorgroup)
-
-        initiator = 'iqn.1-0.org.deb:01:d7'
-        initiator_group = 'test-init-grp1'
-        lu_number = '246'
-
-        self.drv.zfssa.get_lun.side_effect = iter([
-            {'initiatorgroup': [], 'number': []},
-            {'initiatorgroup': [initiator_group], 'number': [lu_number]},
-            {'initiatorgroup': [initiator_group], 'number': [lu_number]},
-        ])
-
-        connector = dict(initiator=initiator)
-        props = self.drv.initialize_connection(self.test_vol, connector)
-        self.drv._get_provider_info.assert_called_once_with()
-        self.assertEqual('iscsi', props['driver_volume_type'])
-        self.assertEqual(self.test_vol['id'], props['data']['volume_id'])
-        self.assertEqual(lcfg.zfssa_target_portal,
-                         props['data']['target_portal'])
-        self.assertEqual(test_target_iqn, props['data']['target_iqn'])
-        self.assertEqual(int(lu_number), props['data']['target_lun'])
-        self.assertFalse(props['data']['target_discovered'])
-        self.drv.zfssa.set_lun_initiatorgroup.assert_called_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_project,
-            self.test_vol['name'],
-            [initiator_group])
-
-        self.drv.terminate_connection(self.test_vol, connector)
-        self.drv.zfssa.set_lun_initiatorgroup.assert_called_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_project,
-            self.test_vol['name'],
-            [])
-
-    @mock.patch.object(iscsi.ZFSSAISCSIDriver, '_get_provider_info')
-    def test_volume_attach_detach_multipath(self, _get_provider_info):
-        lcfg = self.configuration
-        test_target_iqn = 'iqn.1986-03.com.sun:02:00000-aaaa-bbbb-cccc-ddddd'
-        self.drv._get_provider_info.return_value = {
-            'provider_location': '%s %s' % (lcfg.zfssa_target_portal,
-                                            test_target_iqn)
-        }
-
-        def side_effect_get_initiator_initiatorgroup(arg):
-            return [{
-                'iqn.1-0.org.deb:01:d7': 'test-init-grp1',
-                'iqn.1-0.org.deb:01:d9': 'test-init-grp2',
-            }[arg]]
-
-        self.drv.zfssa.get_initiator_initiatorgroup.side_effect = (
-            side_effect_get_initiator_initiatorgroup)
-
-        initiator = 'iqn.1-0.org.deb:01:d7'
-        initiator_group = 'test-init-grp1'
-        lu_number = '246'
-
-        self.drv.zfssa.get_lun.side_effect = iter([
-            {'initiatorgroup': [], 'number': []},
-            {'initiatorgroup': [initiator_group], 'number': [lu_number]},
-            {'initiatorgroup': [initiator_group], 'number': [lu_number]},
-        ])
-
-        connector = {
-            'initiator': initiator,
-            'multipath': True
-        }
-        props = self.drv.initialize_connection(self.test_vol, connector)
-        self.drv._get_provider_info.assert_called_once_with()
-        self.assertEqual('iscsi', props['driver_volume_type'])
-        self.assertEqual(self.test_vol['id'], props['data']['volume_id'])
-        self.assertEqual([lcfg.zfssa_target_portal],
-                         props['data']['target_portals'])
-        self.assertEqual([test_target_iqn], props['data']['target_iqns'])
-        self.assertEqual([int(lu_number)], props['data']['target_luns'])
-        self.assertFalse(props['data']['target_discovered'])
-        self.drv.zfssa.set_lun_initiatorgroup.assert_called_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_project,
-            self.test_vol['name'],
-            [initiator_group])
-
-        self.drv.terminate_connection(self.test_vol, connector)
-        self.drv.zfssa.set_lun_initiatorgroup.assert_called_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_project,
-            self.test_vol['name'],
-            [])
-
-    @mock.patch.object(iscsi.ZFSSAISCSIDriver, '_get_provider_info')
-    def test_volume_attach_detach_live_migration(self, _get_provider_info):
-        lcfg = self.configuration
-        test_target_iqn = 'iqn.1986-03.com.sun:02:00000-aaaa-bbbb-cccc-ddddd'
-        self.drv._get_provider_info.return_value = {
-            'provider_location': '%s %s' % (lcfg.zfssa_target_portal,
-                                            test_target_iqn)
-        }
-
-        def side_effect_get_initiator_initiatorgroup(arg):
-            return [{
-                'iqn.1-0.org.deb:01:d7': 'test-init-grp1',
-                'iqn.1-0.org.deb:01:d9': 'test-init-grp2',
-            }[arg]]
-
-        self.drv.zfssa.get_initiator_initiatorgroup.side_effect = (
-            side_effect_get_initiator_initiatorgroup)
-
-        src_initiator = 'iqn.1-0.org.deb:01:d7'
-        src_initiator_group = 'test-init-grp1'
-        src_connector = dict(initiator=src_initiator)
-        src_lu_number = '123'
-
-        dst_initiator = 'iqn.1-0.org.deb:01:d9'
-        dst_initiator_group = 'test-init-grp2'
-        dst_connector = dict(initiator=dst_initiator)
-        dst_lu_number = '456'
-
-        # In the beginning, the LUN is already presented to the source
-        # node. During initialize_connection(), and at the beginning of
-        # terminate_connection(), it's presented to both nodes.
-        self.drv.zfssa.get_lun.side_effect = iter([
-            {'initiatorgroup': [src_initiator_group],
-             'number': [src_lu_number]},
-            {'initiatorgroup': [dst_initiator_group, src_initiator_group],
-             'number': [dst_lu_number, src_lu_number]},
-            {'initiatorgroup': [dst_initiator_group, src_initiator_group],
-             'number': [dst_lu_number, src_lu_number]},
-        ])
-
-        # Before migration, the volume gets connected to the destination
-        # node (whilst still connected to the source node), so it should
-        # be presented to the initiator groups for both
-        props = self.drv.initialize_connection(self.test_vol, dst_connector)
-        self.drv.zfssa.set_lun_initiatorgroup.assert_called_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_project,
-            self.test_vol['name'],
-            [src_initiator_group, dst_initiator_group])
-
-        # LU number must be an int -
-        # https://bugs.launchpad.net/cinder/+bug/1538582
-        # and must be the LU number for the destination node's
-        # initiatorgroup (where the connection was just initialized)
-        self.assertEqual(int(dst_lu_number), props['data']['target_lun'])
-
-        # After migration, the volume gets detached from the source node
-        # so it should be present to only the destination node
-        self.drv.terminate_connection(self.test_vol, src_connector)
-        self.drv.zfssa.set_lun_initiatorgroup.assert_called_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_project,
-            self.test_vol['name'],
-            [dst_initiator_group])
-
-    def test_volume_attach_detach_negative(self):
-        self.drv.zfssa.get_initiator_initiatorgroup.return_value = []
-
-        connector = dict(initiator='iqn.1-0.org.deb:01:d7')
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv.initialize_connection,
-                          self.test_vol,
-                          connector)
-
-    def test_get_volume_stats(self):
-        self.drv.zfssa.get_project_stats.return_value = 2 * units.Gi,\
-            3 * units.Gi
-        self.drv.zfssa.get_pool_details.return_value = \
-            {"profile": "mirror:log_stripe"}
-        lcfg = self.configuration
-        stats = self.drv.get_volume_stats(refresh=True)
-        self.drv.zfssa.get_project_stats.assert_called_once_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_project)
-        self.drv.zfssa.get_pool_details.assert_called_once_with(
-            lcfg.zfssa_pool)
-        self.assertEqual('Oracle', stats['vendor_name'])
-        self.assertEqual(self.configuration.volume_backend_name,
-                         stats['volume_backend_name'])
-        self.assertEqual(self.drv.VERSION, stats['driver_version'])
-        self.assertEqual(self.drv.protocol, stats['storage_protocol'])
-        self.assertEqual(0, stats['reserved_percentage'])
-        self.assertFalse(stats['QoS_support'])
-        self.assertEqual(3, stats['total_capacity_gb'])
-        self.assertEqual(2, stats['free_capacity_gb'])
-        self.assertEqual('mirror:log_stripe', stats['zfssa_poolprofile'])
-        self.assertEqual('8k', stats['zfssa_volblocksize'])
-        self.assertEqual('false', stats['zfssa_sparse'])
-        self.assertEqual('off', stats['zfssa_compression'])
-        self.assertEqual('latency', stats['zfssa_logbias'])
-
-        self.drv.zfssa.get_pool_details.return_value = {"profile": "raidz2"}
-        stats = self.drv.get_volume_stats(refresh=True)
-        self.assertEqual('raidz2', stats['zfssa_poolprofile'])
-
-    def test_extend_volume(self):
-        lcfg = self.configuration
-        self.drv.extend_volume(self.test_vol, 3)
-        self.drv.zfssa.set_lun_props.assert_called_once_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_project,
-            self.test_vol['name'],
-            volsize= 3 * units.Gi)
-
-    @mock.patch('cinder.volume.volume_types.get_volume_type_extra_specs')
-    def test_get_voltype_specs(self, get_volume_type_extra_specs):
-        volume_type_id = mock.sentinel.volume_type_id
-        volume = {'volume_type_id': volume_type_id}
-        get_volume_type_extra_specs.return_value = {
-            'zfssa:volblocksize': '128k',
-            'zfssa:compression': 'gzip'
-        }
-        ret = self.drv._get_voltype_specs(volume)
-        self.assertEqual('128k', ret.get('volblocksize'))
-        self.assertEqual(self.configuration.zfssa_lun_sparse,
-                         ret.get('sparse'))
-        self.assertEqual('gzip', ret.get('compression'))
-        self.assertEqual(self.configuration.zfssa_lun_logbias,
-                         ret.get('logbias'))
-
-    def fake_safe_get(self, value):
-        try:
-            val = getattr(self.configuration, value)
-        except AttributeError:
-            val = None
-        return val
-
-    @mock.patch.object(iscsi.ZFSSAISCSIDriver, '_verify_cache_volume')
-    def test_clone_image_negative(self, _verify_cache_volume):
-        # Disabling local cache feature:
-        self.configuration.zfssa_enable_local_cache = False
-
-        self.assertEqual((None, False),
-                         self.drv.clone_image(fakecontext, self.test_vol,
-                                              img_location,
-                                              small_img,
-                                              img_service))
-
-        self.configuration.zfssa_enable_local_cache = True
-        # Creating a volume smaller than image:
-        self.assertEqual((None, False),
-                         self.drv.clone_image(fakecontext, self.test_vol,
-                                              img_location,
-                                              large_img,
-                                              img_service))
-
-        # Creating a volume equal as image:
-        eq_img = large_img.copy()
-        eq_img['virtual_size'] = self.test_vol['size'] * units.Gi
-        self.assertEqual((None, False),
-                         self.drv.clone_image(fakecontext, self.test_vol,
-                                              img_location,
-                                              eq_img,
-                                              img_service))
-
-        # Exception raised in _verify_cache_image
-        self.drv._verify_cache_volume.side_effect = (
-            exception.VolumeBackendAPIException('fakeerror'))
-        self.assertEqual((None, False),
-                         self.drv.clone_image(fakecontext, self.test_vol,
-                                              img_location,
-                                              small_img,
-                                              img_service))
-
-    @mock.patch.object(iscsi.ZFSSAISCSIDriver, '_get_voltype_specs')
-    @mock.patch.object(iscsi.ZFSSAISCSIDriver, '_verify_cache_volume')
-    @mock.patch.object(iscsi.ZFSSAISCSIDriver, 'extend_volume')
-    def test_clone_image(self, _extend_vol, _verify_cache, _get_specs):
-        lcfg = self.configuration
-        cache_vol = 'volume-os-cache-vol-%s' % small_img['id']
-        cache_snap = 'image-%s' % small_img['id']
-        self.drv._get_voltype_specs.return_value = fakespecs.copy()
-        self.drv._verify_cache_volume.return_value = cache_vol, cache_snap
-
-        model, cloned = self.drv.clone_image(fakecontext, self.test_vol2,
-                                             img_location,
-                                             small_img,
-                                             img_service)
-        specs = fakespecs
-        specs.update({'custom:cinder_managed': True})
-        self.drv._verify_cache_volume.assert_called_once_with(fakecontext,
-                                                              small_img,
-                                                              img_service,
-                                                              fakespecs,
-                                                              small_img_props)
-        self.drv.zfssa.clone_snapshot.assert_called_once_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_cache_project,
-            cache_vol,
-            cache_snap,
-            lcfg.zfssa_project,
-            self.test_vol2['name'],
-            specs)
-
-        self.drv.extend_volume.assert_called_once_with(self.test_vol2,
-                                                       self.test_vol2['size'])
-
-    @mock.patch.object(iscsi.ZFSSAISCSIDriver, '_create_cache_volume')
-    def test_verify_cache_vol_no_cache_vol(self, _create_cache_vol):
-        vol_name = 'os-cache-vol-%s' % small_img['id']
-        self.drv.zfssa.get_lun.side_effect = exception.VolumeNotFound(
-            volume_id=vol_name)
-        self.drv._verify_cache_volume(fakecontext, small_img,
-                                      img_service, fakespecs, small_img_props)
-        self.drv._create_cache_volume.assert_called_once_with(fakecontext,
-                                                              small_img,
-                                                              img_service,
-                                                              fakespecs,
-                                                              small_img_props)
-
-    def test_verify_cache_vol_no_cache_snap(self):
-        snap_name = 'image-%s' % small_img['id']
-        self.drv.zfssa.get_lun_snapshot.side_effect = (
-            exception.SnapshotNotFound(snapshot_id=snap_name))
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv._verify_cache_volume,
-                          fakecontext,
-                          small_img,
-                          img_service,
-                          fakespecs,
-                          small_img_props)
-
-    def test_verify_cache_vol_stale_vol(self):
-        self.drv.zfssa.get_lun_snapshot.return_value = {'numclones': 5}
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv._verify_cache_volume,
-                          fakecontext,
-                          small_img,
-                          img_service,
-                          fakespecs,
-                          small_img_props)
-
-    @mock.patch.object(iscsi.ZFSSAISCSIDriver, '_create_cache_volume')
-    def test_verify_cache_vol_updated_vol(self, _create_cache_vol):
-        lcfg = self.configuration
-        updated_vol = {
-            'updated_at': date(3000, 12, 12),
-            'image_id': 'updated_id',
-        }
-        cachevol_name = 'os-cache-vol-%s' % small_img['id']
-        self.drv.zfssa.get_lun.return_value = updated_vol
-        self.drv.zfssa.get_lun_snapshot.return_value = {'numclones': 0}
-        self.drv._verify_cache_volume(fakecontext, small_img,
-                                      img_service, fakespecs, small_img_props)
-        self.drv.zfssa.delete_lun.assert_called_once_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_cache_project,
-            cachevol_name)
-        self.drv._create_cache_volume.assert_called_once_with(fakecontext,
-                                                              small_img,
-                                                              img_service,
-                                                              fakespecs,
-                                                              small_img_props)
-
-    @mock.patch.object(driver.BaseVD, 'copy_image_to_volume')
-    def test_create_cache_volume(self, _copy_image):
-        lcfg = self.configuration
-        virtual_size = int(small_img['virtual_size'])
-        volsize = math.ceil(float(virtual_size) / units.Gi)
-        lunsize = "%sg" % six.text_type(int(volsize))
-        volname = 'os-cache-vol-%s' % small_img['id']
-        snapname = 'image-%s' % small_img['id']
-        cachevol_props = {
-            'cache_name': volname,
-            'snap_name': snapname,
-        }
-        cachevol_props.update(small_img_props)
-        cache_vol = {
-            'name': volname,
-            'id': small_img['id'],
-            'size': volsize,
-        }
-        lun_props = {
-            'custom:image_id': small_img['id'],
-            'custom:updated_at': (
-                six.text_type(small_img['updated_at'].isoformat())),
-        }
-        lun_props.update(fakespecs)
-
-        self.drv._create_cache_volume(fakecontext,
-                                      small_img,
-                                      img_service,
-                                      fakespecs,
-                                      cachevol_props)
-
-        self.drv.zfssa.create_lun.assert_called_once_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_cache_project,
-            cache_vol['name'],
-            lunsize,
-            lcfg.zfssa_target_group,
-            lun_props)
-        _copy_image.assert_called_once_with(fakecontext,
-                                            cache_vol,
-                                            img_service,
-                                            small_img['id'])
-        self.drv.zfssa.create_snapshot.assert_called_once_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_cache_project,
-            cache_vol['name'],
-            snapname)
-
-    def test_create_cache_vol_negative(self):
-        lcfg = self.configuration
-        volname = 'os-cache-vol-%s' % small_img['id']
-        snapname = 'image-%s' % small_img['id']
-        cachevol_props = {
-            'cache_name': volname,
-            'snap_name': snapname,
-        }
-        cachevol_props.update(small_img)
-
-        self.drv.zfssa.get_lun.side_effect = exception.VolumeNotFound(
-            volume_id=volname)
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv._create_cache_volume,
-                          fakecontext,
-                          small_img,
-                          img_service,
-                          fakespecs,
-                          cachevol_props)
-        self.drv.zfssa.delete_lun.assert_called_once_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_cache_project,
-            volname)
-
-    def test_get_manageable_volumes(self):
-        lcfg = self.configuration
-
-        self.drv.zfssa.get_all_luns.return_value = [
-            {'name': 'volume-11111111-1111-1111-1111-111111111111',
-             'size': 111 * units.Gi,
-             'cinder_managed': True},
-            {'name': 'volume2',
-             'size': 222 * units.Gi,
-             'cinder_managed': False},
-            {'name': 'volume-33333333-3333-3333-3333-333333333333',
-             'size': 333 * units.Gi,
-             'cinder_managed': True},
-            {'name': 'volume4',
-             'size': 444 * units.Gi}
-        ]
-
-        cinder_vols = [{'id': '11111111-1111-1111-1111-111111111111'}]
-        args = (cinder_vols, None, 1000, 0, ['size'], ['asc'])
-
-        lcfg.zfssa_manage_policy = 'strict'
-        expected = [
-            {'reference': {'source-name':
-                           'volume-11111111-1111-1111-1111-111111111111'},
-             'size': 111,
-             'safe_to_manage': False,
-             'reason_not_safe': 'already managed',
-             'cinder_id': '11111111-1111-1111-1111-111111111111',
-             'extra_info': None},
-            {'reference': {'source-name': 'volume2'},
-             'size': 222,
-             'safe_to_manage': True,
-             'reason_not_safe': None,
-             'cinder_id': None,
-             'extra_info': None},
-            {'reference': {'source-name':
-                           'volume-33333333-3333-3333-3333-333333333333'},
-             'size': 333,
-             'safe_to_manage': False,
-             'reason_not_safe': 'managed by another cinder instance?',
-             'cinder_id': None,
-             'extra_info': None},
-            {'reference': {'source-name': 'volume4'},
-             'size': 444,
-             'safe_to_manage': False,
-             'reason_not_safe': 'cinder_managed schema not present',
-             'cinder_id': None,
-             'extra_info': None},
-        ]
-
-        result = self.drv.get_manageable_volumes(*args)
-        self.assertEqual(expected, result)
-
-        lcfg.zfssa_manage_policy = 'loose'
-        expected[3]['safe_to_manage'] = True
-        expected[3]['reason_not_safe'] = None
-
-        result = self.drv.get_manageable_volumes(*args)
-        self.assertEqual(expected, result)
-
-    @mock.patch.object(iscsi.ZFSSAISCSIDriver, '_get_existing_vol')
-    @mock.patch.object(iscsi.ZFSSAISCSIDriver, '_verify_volume_to_manage')
-    def test_volume_manage(self, _get_existing_vol, _verify_volume_to_manage):
-        lcfg = self.configuration
-        lcfg.zfssa_manage_policy = 'loose'
-        test_vol = self.test_vol
-        self.drv._get_existing_vol.return_value = test_vol
-        self.drv._verify_volume_to_manage.return_value = None
-        self.drv.zfssa.set_lun_props.return_value = True
-        self.assertIsNone(self.drv.manage_existing({'name': 'volume-123'},
-                                                   {'source-name':
-                                                       'volume-567'}))
-        self.drv._get_existing_vol.assert_called_once_with({'source-name':
-                                                            'volume-567'})
-        self.drv._verify_volume_to_manage.assert_called_once_with(test_vol)
-        self.drv.zfssa.set_lun_props.assert_called_once_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_project,
-            test_vol['name'],
-            name='volume-123',
-            schema={"custom:cinder_managed": True})
-
-        # Case when zfssa_manage_policy is 'loose' and 'cinder_managed' is
-        # set to true.
-        test_vol.update({'cinder_managed': False})
-        self.assertIsNone(self.drv.manage_existing({'name': 'volume-123'},
-                                                   {'source-name':
-                                                       'volume-567'}))
-
-        # Another case is when the zfssa_manage_policy is set to 'strict'
-        lcfg.zfssa_manage_policy = 'strict'
-        test_vol.update({'cinder_managed': False})
-        self.assertIsNone(self.drv.manage_existing({'name': 'volume-123'},
-                                                   {'source-name':
-                                                       'volume-567'}))
-
-    def test_volume_manage_negative(self):
-        lcfg = self.configuration
-        lcfg.zfssa_manage_policy = 'strict'
-        test_vol = self.test_vol
-
-        if 'cinder_managed' in test_vol:
-            del test_vol['cinder_managed']
-
-        self.drv.zfssa.get_lun.return_value = test_vol
-        self.assertRaises(exception.InvalidInput,
-                          self.drv.manage_existing, {'name': 'cindervol'},
-                          {'source-name': 'volume-567'})
-
-        test_vol.update({'cinder_managed': True})
-        self.drv.zfssa.get_lun.return_value = test_vol
-        self.assertRaises(exception.ManageExistingAlreadyManaged,
-                          self.drv.manage_existing, {'name': 'cindervol'},
-                          {'source-name': 'volume-567'})
-
-        test_vol.update({'cinder_managed': False})
-        self.drv.zfssa.get_lun.return_value = test_vol
-        self.assertRaises(exception.ManageExistingInvalidReference,
-                          self.drv.manage_existing, {'name': 'cindervol'},
-                          {'source-id': 'volume-567'})
-
-        lcfg.zfssa_manage_policy = 'loose'
-        self.assertRaises(exception.ManageExistingInvalidReference,
-                          self.drv.manage_existing, {'name': 'cindervol'},
-                          {'source-id': 'volume-567'})
-
-    def test_volume_manage_nonexistent(self):
-        self.drv.zfssa.get_lun.side_effect = \
-            exception.VolumeNotFound(volume_id='bogus_lun')
-        self.assertRaises(exception.ManageExistingInvalidReference,
-                          self.drv.manage_existing, {'name': 'cindervol'},
-                          {'source-name': 'bogus_lun'})
-
-    @mock.patch.object(iscsi.ZFSSAISCSIDriver, '_verify_volume_to_manage')
-    def test_volume_manage_negative_api_exception(self,
-                                                  _verify_volume_to_manage):
-        lcfg = self.configuration
-        lcfg.zfssa_manage_policy = 'loose'
-        self.drv.zfssa.get_lun.return_value = self.test_vol
-        self.drv._verify_volume_to_manage.return_value = None
-        self.drv.zfssa.set_lun_props.side_effect = \
-            exception.VolumeBackendAPIException(data='fake exception')
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv.manage_existing, {'name': 'volume-123'},
-                          {'source-name': 'volume-567'})
-
-    def test_volume_unmanage(self):
-        lcfg = self.configuration
-        self.drv.zfssa.set_lun_props.return_value = True
-        self.assertIsNone(self.drv.unmanage({'name': 'volume-123'}))
-        self.drv.zfssa.set_lun_props.assert_called_once_with(
-            lcfg.zfssa_pool,
-            lcfg.zfssa_project,
-            'volume-123',
-            name='unmanaged-volume-123',
-            schema={"custom:cinder_managed": False})
-
-    def test_volume_unmanage_negative(self):
-        self.drv.zfssa.set_lun_props.side_effect = \
-            exception.VolumeBackendAPIException(data='fake exception')
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv.unmanage, {'name': 'volume-123'})
-
-    @mock.patch.object(iscsi.ZFSSAISCSIDriver, '_get_existing_vol')
-    def test_manage_existing_get_size(self, _get_existing_vol):
-        test_vol = self.test_vol
-        test_vol['size'] = 3 * units.Gi
-        self.drv._get_existing_vol.return_value = test_vol
-        self.assertEqual(3, self.drv.manage_existing_get_size(
-                         {'name': 'volume-123'},
-                         {'source-name': 'volume-567'}))
-
-    @mock.patch.object(iscsi.ZFSSAISCSIDriver, '_get_existing_vol')
-    def test_manage_existing_get_size_negative(self, _get_existing_vol):
-        self.drv._get_existing_vol.side_effect = \
-            exception.VolumeNotFound(volume_id='123')
-        self.assertRaises(exception.VolumeNotFound,
-                          self.drv.manage_existing_get_size,
-                          {'name': 'volume-123'},
-                          {'source-name': 'volume-567'})
-
-
-class TestZFSSANFSDriver(test.TestCase):
-
-    test_vol = {
-        'name': 'test-vol',
-        'id': '1',
-        'size': 3,
-        'provider_location':
-        'fakelocation',
-    }
-
-    test_snap = {
-        'name': 'cindersnap',
-        'volume_name': test_vol['name'],
-        'volume_size': test_vol['size']
-    }
-
-    test_vol_snap = {
-        'name': 'cindersnapvol',
-        'size': test_vol['size']
-    }
-
-    def setUp(self):
-        super(TestZFSSANFSDriver, self).setUp()
-        self._create_fake_config()
-        self.mock_object(zfssanfs, 'factory_zfssa', spec=rest.ZFSSAApi)
-        self.mock_object(volume_utils, 'get_max_over_subscription_ratio',
-                         return_value=1.0)
-        self.drv = zfssanfs.ZFSSANFSDriver(configuration=self.configuration)
-        self.drv._execute = fake_utils.fake_execute
-        self.drv.do_setup({})
-        self.drv.mount_path = 'fake_mount_path'
-        self.context = context.get_admin_context()
-
-    def _create_fake_config(self):
-        self.configuration = mock.Mock(spec=conf.Configuration)
-        self.configuration.reserved_percentage = 0
-        self.configuration.max_over_subscription_ratio = 20.0
-        self.configuration.san_ip = '1.1.1.1'
-        self.configuration.san_login = 'user'
-        self.configuration.san_password = 'passwd'
-        self.configuration.zfssa_data_ip = '2.2.2.2'
-        self.configuration.zfssa_https_port = '443'
-        self.configuration.zfssa_nfs_pool = 'pool'
-        self.configuration.zfssa_nfs_project = 'nfs_project'
-        self.configuration.zfssa_nfs_share = 'nfs_share'
-        self.configuration.zfssa_nfs_share_logbias = nfs_logbias
-        self.configuration.zfssa_nfs_share_compression = nfs_compression
-        self.configuration.zfssa_nfs_mount_options = ''
-        self.configuration.zfssa_rest_timeout = '30'
-        self.configuration.zfssa_enable_local_cache = True
-        self.configuration.zfssa_cache_directory = zfssa_cache_dir
-        self.configuration.nfs_sparsed_volumes = 'true'
-        self.configuration.nfs_mount_point_base = '$state_path/mnt'
-        self.configuration.nfs_mount_options = None
-        self.configuration.zfssa_manage_policy = 'strict'
-
-    def test_setup_nfs_client(self):
-        mock_execute = self.mock_object(self.drv, '_execute',
-                                        side_effect= OSError(errno.ENOENT,
-                                                             'No such file or '
-                                                             'directory.'))
-
-        self.assertRaises(exception.NfsException, self.drv.do_setup,
-                          self.context)
-        mock_execute.assert_has_calls(
-            [mock.call('mount.nfs',
-                       check_exit_code=False,
-                       run_as_root=True),
-             mock.call('/usr/sbin/mount',
-                       check_exit_code=False,
-                       run_as_root=True)])
-
-    def test_migrate_volume(self):
-        self.drv.zfssa.get_asn.return_value = (
-            '9a2b5a0f-e3af-6d14-9578-8825f229dc89')
-        volume = self.test_vol
-        volume.update({'host': 'fake_host',
-                       'status': 'available',
-                       'name': 'vol-1',
-                       'source_volid': self.test_vol['id']})
-
-        loc_info = '9a2b5a0f-e3af-6d14-9578-8825f229dc89:nfs_share'
-
-        host = {'host': 'stack@zfssa_nfs#fake_zfssa',
-                'capabilities': {'vendor_name': 'Oracle',
-                                 'storage_protocol': 'nfs',
-                                 'location_info': loc_info}}
-        ctxt = context.get_admin_context()
-
-        # Test Normal case
-        result = self.drv.migrate_volume(ctxt, volume, host)
-        self.assertEqual((True, None), result)
-
-        # Test when volume status is not available
-        volume['status'] = 'in-use'
-        result = self.drv.migrate_volume(ctxt, volume, host)
-        self.assertEqual((False, None), result)
-        volume['status'] = 'available'
-
-        # Test when Vendor is not Oracle
-        host['capabilities']['vendor_name'] = 'elcarO'
-        result = self.drv.migrate_volume(ctxt, volume, host)
-        self.assertEqual((False, None), result)
-        host['capabilities']['vendor_name'] = 'Oracle'
-
-        # Test when storage protocol is not iSCSI
-        host['capabilities']['storage_protocol'] = 'not_nfs'
-        result = self.drv.migrate_volume(ctxt, volume, host)
-        self.assertEqual((False, None), result)
-        host['capabilities']['storage_protocol'] = 'nfs'
-
-        # Test for exceptions
-        host['capabilities']['location_info'] = ''
-        result = self.drv.migrate_volume(ctxt, volume, host)
-        self.assertEqual((False, None), result)
-        host['capabilities']['location_info'] = loc_info
-
-        # Test case when source and target asn dont match
-        invalid_loc_info = (
-            'fake_asn*https://2.2.2.2:/shares/export/nfs_share*nfs_share')
-        host['capabilities']['location_info'] = invalid_loc_info
-        result = self.drv.migrate_volume(ctxt, volume, host)
-        self.assertEqual((False, None), result)
-
-        # Test case when source and target shares names are different
-        invalid_loc_info = (
-            '9a2b5a0f-e3af-6d14-9578-8825f229dc89*' +
-            'https://tgt:/shares/export/nfs_share*nfs_share_1')
-        host['capabilities']['location_info'] = invalid_loc_info
-        result = self.drv.migrate_volume(ctxt, volume, host)
-        self.assertEqual((False, None), result)
-
-    def test_create_delete_snapshot(self):
-        lcfg = self.configuration
-        self.drv.create_snapshot(self.test_snap)
-        self.drv.zfssa.create_snapshot.assert_called_once_with(
-            lcfg.zfssa_nfs_pool,
-            lcfg.zfssa_nfs_project,
-            lcfg.zfssa_nfs_share,
-            mock.ANY)
-        self.drv.zfssa.create_snapshot_of_volume_file.assert_called_once_with(
-            src_file=mock.ANY,
-            dst_file=self.test_snap['name'])
-        self.drv.delete_snapshot(self.test_snap)
-        self.drv.zfssa.delete_snapshot_of_volume_file.assert_called_with(
-            src_file=self.test_snap['name'])
-
-    def test_create_volume_from_snapshot(self):
-        self.drv.create_snapshot(self.test_snap)
-        with mock.patch.object(self.drv, '_ensure_shares_mounted'):
-            self.drv.create_volume_from_snapshot(self.test_vol_snap,
-                                                 self.test_snap,
-                                                 method='COPY')
-
-        self.drv.zfssa.create_volume_from_snapshot_file.\
-            assert_called_once_with(src_file=self.test_snap['name'],
-                                    dst_file=self.test_vol_snap['name'],
-                                    method='COPY')
-
-    def test_get_volume_stats(self):
-        lcfg = self.configuration
-        self.drv._mounted_shares = ['nfs_share']
-        with mock.patch.object(self.drv, '_ensure_shares_mounted'):
-            with mock.patch.object(self.drv, '_get_share_capacity_info') as \
-                    mock_get_share_capacity_info:
-                mock_get_share_capacity_info.return_value = (1073741824,
-                                                             9663676416)
-                self.drv.zfssa.get_pool_details.return_value = \
-                    {"profile": "mirror:log_stripe"}
-                self.drv.zfssa.get_share.return_value = {"compression": "lzjb",
-                                                         "encryption": "off",
-                                                         "logbias": "latency"}
-                stats = self.drv.get_volume_stats(refresh=True)
-                self.drv.zfssa.get_pool_details.assert_called_once_with(
-                    lcfg.zfssa_nfs_pool)
-                self.drv.zfssa.get_share.assert_called_with(
-                    lcfg.zfssa_nfs_pool, lcfg.zfssa_nfs_project,
-                    lcfg.zfssa_nfs_share)
-
-                self.assertEqual(1, stats['free_capacity_gb'])
-                self.assertEqual(10, stats['total_capacity_gb'])
-                self.assertEqual('mirror:log_stripe',
-                                 stats['zfssa_poolprofile'])
-                self.assertEqual('lzjb', stats['zfssa_compression'])
-                self.assertEqual('true', stats['zfssa_sparse'])
-                self.assertEqual('off', stats['zfssa_encryption'])
-                self.assertEqual('latency', stats['zfssa_logbias'])
-
-                self.drv.zfssa.get_pool_details.return_value = \
-                    {"profile": "mirror3"}
-                stats = self.drv.get_volume_stats(refresh=True)
-                self.assertEqual('mirror3', stats['zfssa_poolprofile'])
-
-    @mock.patch.object(nfsdriver.NfsDriver, 'delete_volume')
-    @mock.patch.object(zfssanfs.ZFSSANFSDriver, '_check_origin')
-    def test_delete_volume(self, _check_origin, _delete_vol):
-        self.drv.zfssa.get_volume.side_effect = self._get_volume_side_effect
-        test_vol = zfssanfs.Volume()
-        test_vol._name_id = small_img['id']
-        test_vol.size = 3
-        test_vol.provider_location = 'fakelocation'
-
-        self.drv.delete_volume(test_vol)
-        _delete_vol.assert_called_once_with(test_vol)
-        self.drv._check_origin.assert_called_once_with(img_props_nfs['name'])
-
-    def _get_volume_side_effect(self, *args, **kwargs):
-        lcfg = self.configuration
-        volname = six.text_type(args[0])
-        if volname.startswith(lcfg.zfssa_cache_directory):
-            return {'numclones': 0}
-        else:
-            return {'origin': img_props_nfs['name']}
-
-    def test_check_origin(self):
-        self.drv.zfssa.get_volume.side_effect = self._get_volume_side_effect
-        self.drv._check_origin(img_props_nfs['name'])
-        self.drv.zfssa.delete_file.assert_called_once_with(
-            img_props_nfs['name'])
-
-    @mock.patch.object(image_utils, 'qemu_img_info')
-    @mock.patch.object(image_utils.TemporaryImages, 'fetch')
-    @mock.patch.object(zfssanfs.ZFSSANFSDriver, '_verify_cache_volume')
-    @mock.patch.object(zfssanfs.ZFSSANFSDriver, 'create_cloned_volume')
-    def test_clone_image_negative(self, _create_clone, _verify_cache_volume,
-                                  _fetch, _info):
-        _fetch.return_value = mock.MagicMock(spec=utils.get_file_spec())
-        _info.return_value = ImgInfo(small_img['virtual_size'])
-
-        # Disabling local cache feature:
-        self.configuration.zfssa_enable_local_cache = False
-        self.assertEqual((None, False),
-                         self.drv.clone_image(fakecontext, self.test_vol,
-                                              img_location,
-                                              small_img,
-                                              img_service))
-
-        self.configuration.zfssa_enable_local_cache = True
-
-        # Creating a volume smaller than image:
-        _info.return_value = ImgInfo(large_img['virtual_size'])
-        self.assertEqual((None, False),
-                         self.drv.clone_image(fakecontext, self.test_vol,
-                                              img_location,
-                                              large_img,
-                                              img_service))
-
-        # Exception raised in _verify_cache_image
-        _info.return_value = ImgInfo(small_img['virtual_size'])
-        self.drv._verify_cache_volume.side_effect = (
-            exception.VolumeBackendAPIException('fakeerror'))
-        self.assertEqual((None, False),
-                         self.drv.clone_image(fakecontext, self.test_vol,
-                                              img_location,
-                                              small_img,
-                                              img_service))
-
-    @mock.patch.object(image_utils, 'qemu_img_info')
-    @mock.patch.object(image_utils.TemporaryImages, 'fetch')
-    @mock.patch.object(zfssanfs.ZFSSANFSDriver, 'create_cloned_volume')
-    @mock.patch.object(zfssanfs.ZFSSANFSDriver, '_verify_cache_volume')
-    @mock.patch.object(zfssanfs.ZFSSANFSDriver, 'extend_volume')
-    def test_clone_image(self, _extend_vol, _verify_cache, _create_clone,
-                         _fetch, _info):
-        _fetch.return_value = mock.MagicMock(spec=utils.get_file_spec())
-        _info.return_value = ImgInfo(small_img['virtual_size'])
-        self.drv._verify_cache_volume.return_value = \
-            'volume-' + img_props_nfs['id']
-        prov_loc = {'provider_location': self.test_vol['provider_location']}
-        self.drv.create_cloned_volume.return_value = prov_loc
-        self.assertEqual((prov_loc, True),
-                         self.drv.clone_image(fakecontext, self.test_vol,
-                                              img_location,
-                                              small_img,
-                                              img_service))
-        img_props = {}
-        img_props['id'] = img_props_nfs['image_id']
-        img_props['image_id'] = img_props_nfs['image_id']
-        img_props['updated_at'] = img_props_nfs['updated_at']
-        img_props['size'] = img_props_nfs['size']
-
-        self.drv._verify_cache_volume.assert_called_once_with(fakecontext,
-                                                              small_img,
-                                                              img_service,
-                                                              img_props)
-        cache_vol = {
-            'name': self.drv._verify_cache_volume.return_value,
-            'size': 3,
-            'id': small_img['id'],
-        }
-        self.drv.create_cloned_volume.assert_called_once_with(self.test_vol,
-                                                              cache_vol)
-
-    @mock.patch.object(zfssanfs.ZFSSANFSDriver, '_create_cache_volume')
-    def test_verify_cache_vol_no_cache_vol(self, _create_cache_vol):
-        self.drv.zfssa.get_volume.side_effect = exception.VolumeNotFound(
-            volume_id=img_props_nfs['name'])
-        self.drv._verify_cache_volume(fakecontext, small_img,
-                                      img_service, img_props_nfs)
-        self.drv._create_cache_volume.assert_called_once_with(fakecontext,
-                                                              small_img,
-                                                              img_service,
-                                                              img_props_nfs)
-
-    def test_verify_cache_vol_stale_vol(self):
-        self.drv.zfssa.get_volume.return_value = {
-            'numclones': 5,
-            'updated_at': small_img['updated_at'].isoformat(),
-            'image_id': 'wrong_id',
-        }
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv._verify_cache_volume,
-                          fakecontext,
-                          small_img,
-                          img_service,
-                          img_props_nfs)
-
-    @mock.patch.object(zfssanfs.ZFSSANFSDriver, '_create_cache_volume')
-    @mock.patch.object(nfsdriver.NfsDriver, 'delete_volume')
-    def test_verify_cache_vol_updated_vol(self, _del_vol, _create_cache_vol):
-        updated_vol = {
-            'updated_at': date(3000, 12, 12),
-            'image_id': 'updated_id',
-            'numclones': 0,
-        }
-        self.drv.zfssa.get_volume.return_value = updated_vol
-        self.drv._verify_cache_volume(fakecontext, small_img,
-                                      img_service, img_props_nfs)
-
-        self.drv._create_cache_volume.assert_called_once_with(fakecontext,
-                                                              small_img,
-                                                              img_service,
-                                                              img_props_nfs)
-
-    @mock.patch.object(remotefs.RemoteFSDriver, 'copy_image_to_volume')
-    @mock.patch.object(nfsdriver.NfsDriver, 'create_volume')
-    def test_create_cache_volume(self, _create_vol, _copy_image):
-        self.drv.zfssa.webdavclient = mock.Mock()
-        self.drv._create_cache_volume(fakecontext,
-                                      small_img,
-                                      img_service,
-                                      img_props_nfs)
-
-        self.assertEqual(1, _create_vol.call_count)
-        self.assertEqual(1, _copy_image.call_count)
-
-    def test_create_cache_vol_negative(self):
-        self.drv.zfssa.get_lun.side_effect = (
-            exception.VolumeBackendAPIException)
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv._create_cache_volume,
-                          fakecontext,
-                          small_img,
-                          img_service,
-                          img_props_nfs)
-        self.drv.zfssa.delete_file.assert_called_once_with(
-            'os-cinder-cache/volume-' + img_props_nfs['id'])
-
-    def test_volume_manage(self):
-        lcfg = self.configuration
-        lcfg.zfssa_manage_policy = 'loose'
-        test_vol = self.test_vol
-
-        self.drv.zfssa.get_volume.return_value = test_vol
-        self.drv.zfssa.rename_volume.return_value = None
-        self.drv.zfssa.set_file_props.return_value = None
-        self.drv.mount_path = lcfg.zfssa_data_ip + ':' + 'fake_mountpoint'
-        self.assertEqual({'provider_location': self.drv.mount_path},
-                         self.drv.manage_existing({'name': 'volume-123'},
-                                                  {'source-name':
-                                                      'volume-567'}))
-
-        self.drv.zfssa.get_volume.assert_called_once_with('volume-567')
-        self.drv.zfssa.rename_volume.assert_called_once_with('volume-567',
-                                                             'volume-123')
-        self.drv.zfssa.set_file_props.assert_called_once_with(
-            'volume-123', {'cinder_managed': 'True'})
-        # Test when 'zfssa_manage_policy' is set to 'strict'.
-        lcfg.zfssa_manage_policy = 'strict'
-        test_vol.update({'cinder_managed': 'False'})
-        self.drv.zfssa.get_volume.return_value = test_vol
-        self.assertEqual({'provider_location': self.drv.mount_path},
-                         self.drv.manage_existing({'name': 'volume-123'},
-                                                  {'source-name':
-                                                      'volume-567'}))
-
-    def test_volume_manage_negative_no_source_name(self):
-        self.assertRaises(exception.ManageExistingInvalidReference,
-                          self.drv.manage_existing,
-                          {'name': 'volume-123'},
-                          {'source-id': 'volume-567'})
-
-    def test_volume_manage_negative_backend_exception(self):
-        self.drv.zfssa.get_volume.side_effect = \
-            exception.VolumeNotFound(volume_id='volume-567')
-        self.assertRaises(exception.InvalidInput,
-                          self.drv.manage_existing,
-                          {'name': 'volume-123'},
-                          {'source-name': 'volume-567'})
-
-    def test_volume_manage_negative_verify_fail(self):
-        lcfg = self.configuration
-        lcfg.zfssa_manage_policy = 'strict'
-        test_vol = self.test_vol
-        test_vol['cinder_managed'] = ''
-
-        self.drv.zfssa.get_volume.return_value = test_vol
-        self.assertRaises(exception.InvalidInput,
-                          self.drv.manage_existing,
-                          {'name': 'volume-123'},
-                          {'source-name': 'volume-567'})
-
-        test_vol.update({'cinder_managed': 'True'})
-        self.drv.zfssa.get_volume.return_value = test_vol
-        self.assertRaises(exception.ManageExistingAlreadyManaged,
-                          self.drv.manage_existing,
-                          {'name': 'volume-123'},
-                          {'source-name': 'volume-567'})
-
-    @mock.patch.object(zfssanfs.ZFSSANFSDriver, '_verify_volume_to_manage')
-    def test_volume_manage_negative_rename_fail(self,
-                                                _verify_volume_to_manage):
-        test_vol = self.test_vol
-        test_vol.update({'cinder_managed': 'False'})
-        self.drv.zfssa.get_volume.return_value = test_vol
-        self.drv._verify_volume_to_manage.return_value = None
-        self.drv.zfssa.rename_volume.side_effect = \
-            exception.VolumeBackendAPIException(data="fake exception")
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv.manage_existing, {'name': 'volume-123'},
-                          {'source-name': 'volume-567'})
-
-    @mock.patch.object(zfssanfs.ZFSSANFSDriver, '_verify_volume_to_manage')
-    def test_volume_manage_negative_set_prop_fail(self,
-                                                  _verify_volume_to_manage):
-        test_vol = self.test_vol
-        test_vol.update({'cinder_managed': 'False'})
-        self.drv.zfssa.get_volume.return_value = test_vol
-        self.drv._verify_volume_to_manage.return_value = None
-        self.drv.zfssa.rename_volume.return_value = None
-        self.drv.zfssa.set_file_props.side_effect = \
-            exception.VolumeBackendAPIException(data="fake exception")
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv.manage_existing, {'name': 'volume-123'},
-                          {'source-name': 'volume-567'})
-
-    def test_volume_unmanage(self):
-        test_vol = self.test_vol
-        test_vol.update({'cinder_managed': 'True'})
-        self.drv.zfssa.rename_volume.return_value = None
-        self.drv.zfssa.set_file_props.return_value = None
-        self.assertIsNone(self.drv.unmanage(test_vol))
-        new_vol_name = 'unmanaged-' + test_vol['name']
-        self.drv.zfssa.rename_volume.assert_called_once_with(test_vol['name'],
-                                                             new_vol_name)
-        self.drv.zfssa.set_file_props.assert_called_once_with(
-            new_vol_name, {'cinder_managed': 'False'})
-
-    def test_volume_unmanage_negative_rename_fail(self):
-        test_vol = self.test_vol
-        test_vol.update({'cinder_managed': 'True'})
-        self.drv.zfssa.rename_volume.side_effect = \
-            exception.VolumeBackendAPIException(data="fake exception")
-        self.drv.zfssa.set_file_props.return_value = None
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv.unmanage, test_vol)
-
-    def test_volume_unmanage_negative_set_prop_fail(self):
-        test_vol = self.test_vol
-        test_vol.update({'cinder_managed': 'True'})
-        self.drv.zfssa.rename_volume.return_value = None
-        self.drv.zfssa.set_file_props.side_effect = \
-            exception.VolumeBackendAPIException(data="fake exception")
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.drv.unmanage, test_vol)
-
-    @mock.patch.object(zfssanfs.ZFSSANFSDriver, '_get_mount_point_for_share')
-    def test_manage_existing_get_size(self, _get_mount_point_for_share):
-        self.drv._get_mount_point_for_share.return_value = \
-            '/fake/mnt/fake_share/'
-        self.drv._mounted_shares = []
-        self.drv._mounted_shares.append('fake_share')
-        file = mock.Mock(st_size=123 * units.Gi)
-        with mock.patch('os.path.isfile', return_value=True):
-            with mock.patch('os.stat', return_value=file):
-                self.assertEqual(float(file.st_size / units.Gi),
-                                 self.drv.manage_existing_get_size(
-                                     {'name': 'volume-123'},
-                                     {'source-name': 'volume-567'}))
-
-    @mock.patch.object(zfssanfs.ZFSSANFSDriver, '_get_mount_point_for_share')
-    def test_manage_existing_get_size_negative(self,
-                                               _get_mount_point_for_share):
-        self.drv._get_mount_point_for_share.return_value = \
-            '/fake/mnt/fake_share/'
-        self.drv._mounted_shares = []
-        self.drv._mounted_shares.append('fake_share')
-        with mock.patch('os.path.isfile', return_value=True):
-            with mock.patch('os.stat', side_effect=OSError):
-                self.assertRaises(exception.VolumeBackendAPIException,
-                                  self.drv.manage_existing_get_size,
-                                  {'name': 'volume-123'},
-                                  {'source-name': 'volume-567'})
-
-
-class TestZFSSAApi(test.TestCase):
-    def setUp(self):
-        super(TestZFSSAApi, self).setUp()
-        self.host = 'fakehost'
-        self.user = 'fakeuser'
-        self.url = None
-        self.pool = 'fakepool'
-        self.project = 'fakeproject'
-        self.vol = 'fakevol'
-        self.snap = 'fakesnapshot'
-        self.clone = 'fakeclone'
-        self.targetalias = 'fakealias'
-        self.mock_object(rest, 'factory_restclient', spec=rest.ZFSSAApi)
-        self.zfssa = rest.ZFSSAApi()
-        self.zfssa.set_host('fakehost')
-        self.pool_url = '/api/storage/v1/pools/'
-
-    def _create_response(self, status, data='data'):
-        response = FakeResponse(status, data)
-        return response
-
-    def test_create_project(self):
-        self.zfssa.rclient.get.return_value = self._create_response(
-            client.Status.OK)
-        self.zfssa.create_project(self.pool, self.project)
-        expected_svc = self.pool_url + self.pool + '/projects/' + self.project
-        self.zfssa.rclient.get.assert_called_with(expected_svc)
-
-    def test_create_initiator(self):
-        self.zfssa.rclient.get.return_value = self._create_response(
-            client.Status.OK)
-        initiator = 'iqn.1986-03.com.sun:02:00000-aaaa-bbbb-cccc-ddddd'
-        alias = 'init-group'
-        self.zfssa.create_initiator(initiator, alias)
-        self.zfssa.rclient.get.assert_called_with(
-            '/api/san/v1/iscsi/initiators/alias=' + alias)
-
-    def test_create_target(self):
-        self.zfssa.rclient.get.return_value = self._create_response(
-            client.Status.NOT_FOUND)
-        ret_val = json.dumps(
-            {'target': {'iqn':
-                        'iqn.1986-03.com.sun:02:00000-aaaa-bbbb-cccc-ddddd'}})
-        self.zfssa.rclient.post.return_value = self._create_response(
-            client.Status.CREATED, ret_val)
-        alias = 'tgt-group'
-        self.zfssa.create_target(alias)
-        self.zfssa.rclient.post.assert_called_with('/api/san/v1/iscsi/targets',
-                                                   {'alias': alias})
-
-    def test_get_target(self):
-        ret_val = json.dumps(
-            {'target': {'href': 'fake_href',
-                        'alias': 'tgt-group',
-                        'iqn':
-                        'iqn.1986-03.com.sun:02:00000-aaaa-bbbb-cccc-ddddd',
-                        'targetchapuser': '',
-                        'targetchapsecret': '',
-                        'interfaces': ['nge0']}})
-        self.zfssa.rclient.get.return_value = self._create_response(
-            client.Status.OK, ret_val)
-        ret = self.zfssa.get_target('tgt-group')
-        self.zfssa.rclient.get.assert_called_once_with(
-            '/api/san/v1/iscsi/targets/alias=tgt-group')
-        self.assertEqual('iqn.1986-03.com.sun:02:00000-aaaa-bbbb-cccc-ddddd',
-                         ret)
-
-    def test_verify_pool(self):
-        self.zfssa.rclient.get.return_value = self._create_response(
-            client.Status.OK)
-        self.zfssa.verify_pool(self.pool)
-        self.zfssa.rclient.get.assert_called_with(self.pool_url + self.pool)
-
-    def test_verify_project(self):
-        self.zfssa.rclient.get.return_value = self._create_response(
-            client.Status.NOT_FOUND)
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.zfssa.verify_project,
-                          self.pool,
-                          self.project)
-
-    def test_verify_initiator(self):
-        self.zfssa.rclient.get.return_value = self._create_response(
-            client.Status.OK)
-        self.zfssa.verify_initiator('iqn.1-0.org.deb:01:d7')
-        self.zfssa.rclient.get.assert_called_with(
-            '/api/san/v1/iscsi/initiators/iqn.1-0.org.deb:01:d7')
-
-    def test_verify_target(self):
-        self.zfssa.rclient.get.return_value = self._create_response(
-            client.Status.BAD_REQUEST)
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.zfssa.verify_target,
-                          self.targetalias)
-
-    def test_create_delete_lun(self):
-        arg = json.dumps({'name': self.vol,
-                          'initiatorgroup': 'com.sun.ms.vss.hg.maskAll'})
-        self.zfssa.rclient.post.return_value = self._create_response(
-            client.Status.CREATED, data=arg)
-        self.zfssa.create_lun(self.pool, self.project, self.vol, 1, 'tgt-grp',
-                              None)
-        expected_arg = {'name': self.vol,
-                        'volsize': 1,
-                        'targetgroup': 'tgt-grp',
-                        'initiatorgroup': 'com.sun.ms.vss.hg.maskAll'}
-        self.zfssa.rclient.post.assert_called_with(
-            self.pool_url + self.pool + '/projects/' + self.project + '/luns',
-            expected_arg)
-
-        self.zfssa.rclient.delete.return_value = self._create_response(
-            client.Status.NO_CONTENT)
-        self.zfssa.delete_lun(self.pool, self.project, self.vol)
-        self.zfssa.rclient.delete.assert_called_with(
-            self.pool_url + self.pool + '/projects/' + self.project +
-            '/luns/' + self.vol)
-
-    def test_create_delete_snapshot(self):
-        self.zfssa.rclient.post.return_value = self._create_response(
-            client.Status.CREATED)
-        self.zfssa.create_snapshot(self.pool,
-                                   self.project,
-                                   self.vol,
-                                   self.snap)
-        expected_arg = {'name': self.snap}
-        self.zfssa.rclient.post.assert_called_with(
-            self.pool_url + self.pool + '/projects/' + self.project +
-            '/luns/' + self.vol + '/snapshots', expected_arg)
-
-        self.zfssa.rclient.delete.return_value = self._create_response(
-            client.Status.NO_CONTENT)
-        self.zfssa.delete_snapshot(self.pool,
-                                   self.project,
-                                   self.vol,
-                                   self.snap)
-        self.zfssa.rclient.delete.assert_called_with(
-            self.pool_url + self.pool + '/projects/' + self.project +
-            '/luns/' + self.vol + '/snapshots/' + self.snap)
-
-    def test_clone_snapshot(self):
-        self.zfssa.rclient.put.return_value = self._create_response(
-            client.Status.CREATED)
-        self.zfssa.clone_snapshot(self.pool,
-                                  self.project,
-                                  self.vol,
-                                  self.snap,
-                                  self.project,
-                                  self.clone,
-                                  None)
-        expected_svc = '/api/storage/v1/pools/' + self.pool + '/projects/' + \
-            self.project + '/luns/' + self.vol + '/snapshots/' + self.snap + \
-            '/clone'
-        expected_arg = {'project': self.project,
-                        'share': self.clone,
-                        'nodestroy': True}
-        self.zfssa.rclient.put.assert_called_with(expected_svc, expected_arg)
-
-    def test_get_project_stats(self):
-        ret_val = json.dumps({"project": {"name": self.project,
-                                          "space_available": 15754895360,
-                                          "space_total": 25754895360,
-                                          "dedup": False,
-                                          "logbias": "latency",
-                                          "encryption": "off"}})
-        self.zfssa.rclient.get.return_value = self._create_response(
-            client.Status.OK, ret_val)
-        self.zfssa.get_project_stats(self.pool, self.project)
-        expected_svc = '/api/storage/v1/pools/' + self.pool + '/projects/' + \
-            self.project
-        self.zfssa.rclient.get.assert_called_with(expected_svc)
-
-        self.zfssa.rclient.get.return_value = self._create_response(
-            client.Status.NOT_FOUND)
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.zfssa.get_project_stats,
-                          self.pool,
-                          self.project)
-
-    def test_get_pool_stats_not_owned(self):
-        # Case where the pool is owned by the cluster peer when cluster
-        # is active. In this case, we should fail, because the driver is
-        # configured to talk to the wrong control head.
-        pool_data = {'pool': {'asn': 'fake-asn-b',
-                     'owner': 'fakepeer'}}
-        version_data = {'version': {'asn': 'fake-asn-a',
-                        'nodename': 'fakehost'}}
-        cluster_data = {'cluster': {'peer_hostname': 'fakepeer',
-                                    'peer_asn': 'fake-asn-b',
-                                    'peer_state': 'AKCS_CLUSTERED'}}
-        self.zfssa.rclient.get.side_effect = [
-            self._create_response(client.Status.OK,
-                                  json.dumps(pool_data)),
-            self._create_response(client.Status.OK,
-                                  json.dumps(version_data)),
-            self._create_response(client.Status.OK,
-                                  json.dumps(cluster_data))]
-        self.assertRaises(exception.InvalidInput,
-                          self.zfssa.get_pool_details,
-                          self.pool)
-
-    def test_get_pool_stats_stripped(self):
-        # Case where the pool is owned by the cluster peer when it is in a
-        # stripped state. In this case, so long as the owner and ASN for the
-        # pool match the peer, we should not fail.
-        pool_data = {'pool': {'asn': 'fake-asn-a',
-                     'owner': 'fakehost'}}
-        version_data = {'version': {'asn': 'fake-asn-b',
-                        'nodename': 'fakepeer'}}
-        cluster_data = {'cluster': {'peer_hostname': 'fakehost',
-                                    'peer_asn': 'fake-asn-a',
-                                    'peer_state': 'AKCS_STRIPPED'}}
-        self.zfssa.rclient.get.side_effect = [
-            self._create_response(client.Status.OK,
-                                  json.dumps(pool_data)),
-            self._create_response(client.Status.OK,
-                                  json.dumps(version_data)),
-            self._create_response(client.Status.OK,
-                                  json.dumps(cluster_data))]
-        self.zfssa.get_pool_details(self.pool)
-
-
-class TestZFSSANfsApi(test.TestCase):
-    def setUp(self):
-        super(TestZFSSANfsApi, self).setUp()
-        self.host = 'fakehost'
-        self.user = 'fakeuser'
-        self.url = None
-        self.pool = 'fakepool'
-        self.project = 'fakeproject'
-        self.share = 'fakeshare'
-        self.snap = 'fakesnapshot'
-        self.targetalias = 'fakealias'
-        self.mock_object(rest, 'factory_restclient', spec=rest.ZFSSAApi)
-        self.webdavclient = mock.MagicMock(spec=webdavclient.ZFSSAWebDAVClient)
-        self.zfssa = rest.ZFSSANfsApi()
-        self.zfssa.set_host('fakehost')
-        self.pool_url = '/api/storage/v1/pools/'
-
-    def _create_response(self, status, data='data'):
-        response = FakeResponse(status, data)
-        return response
-
-    def test_verify_share(self):
-        self.zfssa.rclient.get.return_value = self._create_response(
-            client.Status.OK)
-        self.zfssa.verify_share(self.pool, self.project, self.share)
-        self.zfssa.rclient.get.assert_called_with(self.pool_url + self.pool +
-                                                  '/projects/' + self.project +
-                                                  '/filesystems/' + self.share)
-
-    def test_create_delete_snapshot(self):
-        self.zfssa.rclient.post.return_value = self._create_response(
-            client.Status.CREATED)
-        self.zfssa.create_snapshot(self.pool,
-                                   self.project,
-                                   self.share,
-                                   self.snap)
-        expected_arg = {'name': self.snap}
-        self.zfssa.rclient.post.assert_called_with(
-            self.pool_url + self.pool + '/projects/' + self.project +
-            '/filesystems/' + self.share + '/snapshots', expected_arg)
-
-        self.zfssa.rclient.delete.return_value = self._create_response(
-            client.Status.NO_CONTENT)
-        self.zfssa.delete_snapshot(self.pool,
-                                   self.project,
-                                   self.share,
-                                   self.snap)
-        self.zfssa.rclient.delete.assert_called_with(
-            self.pool_url + self.pool + '/projects/' + self.project +
-            '/filesystems/' + self.share + '/snapshots/' + self.snap)
-
-    def create_delete_snapshot_of_volume_file(self):
-        src_file = "fake_src_file"
-        dst_file = "fake_dst_file"
-        self.zfssa.create_snapshot_of_volume_file(src_file=src_file,
-                                                  dst_file=dst_file)
-        self.zfssa.webdavclient.request.assert_called_once_with(
-            src_file=src_file,
-            dst_file=dst_file,
-            method='COPY')
-        self.zfssa.delete_snapshot_of_volume_file(src_file=src_file)
-        self.zfssa.webdavclient.request.assert_called_once_with(
-            src_file=src_file, method='DELETE')
-
-    def test_get_share(self):
-        ret_val = json.dumps({'filesystem': 'test_fs'})
-        self.zfssa.rclient.get.return_value = self._create_response(
-            client.Status.OK, ret_val)
-        ret = self.zfssa.get_share(self.pool, self.project, self.share)
-        self.zfssa.rclient.get.assert_called_with(self.pool_url + self.pool +
-                                                  '/projects/' + self.project +
-                                                  '/filesystems/' + self.share)
-        self.assertEqual('test_fs', ret)
-
-    def test_create_share(self):
-        self.zfssa.rclient.get.return_value = self._create_response(
-            client.Status.NOT_FOUND)
-        self.zfssa.rclient.post.return_value = self._create_response(
-            client.Status.BAD_REQUEST)
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self.zfssa.create_share,
-                          self.pool,
-                          self.project,
-                          self.share,
-                          {})
-
-    @mock.patch.object(rest.ZFSSANfsApi, '_change_service_state')
-    @mock.patch.object(rest.ZFSSANfsApi, 'verify_service')
-    def test_enable_disable_modify_service(self,
-                                           verify_service,
-                                           _change_service_state):
-        self.zfssa.enable_service('http')
-        self.zfssa._change_service_state.assert_called_with(
-            'http', state='enable')
-        self.zfssa.verify_service.assert_called_with('http')
-
-        self.zfssa.disable_service('http')
-        self.zfssa._change_service_state.assert_called_with(
-            'http', state='disable')
-        self.zfssa.verify_service.assert_called_with('http', status='offline')
-
-        ret_val = json.dumps({'service': {
-            "href": "/api/service/v1/services/http",
-            "<status>": "online",
-            "require_login": False,
-            "protocols": "http/https",
-            "listen_port": 81,
-            "https_port": 443}})
-        self.zfssa.rclient.put.return_value = self._create_response(
-            client.Status.ACCEPTED, ret_val)
-        args = {'listen_port': 81}
-        self.zfssa.modify_service('http', args)
-        self.zfssa.rclient.put.called_with('/api/service/v1/services/http',
-                                           args)
-
-
-class TestRestClientURL(test.TestCase):
-    def setUp(self):
-        super(TestRestClientURL, self).setUp()
-        self.timeout = 60
-        self.url = '1.1.1.1'
-        self.client = client.RestClientURL(self.url, timeout=self.timeout)
-
-    @mock.patch.object(client.RestClientURL, 'request')
-    def test_post(self, _request):
-        path = '/api/storage/v1/pools'
-        body = {'name': 'fakepool'}
-        self.client.post(path, body=body)
-        self.client.request.assert_called_with(path, 'POST', body)
-
-    @mock.patch.object(client.RestClientURL, 'request')
-    def test_get(self, _request):
-        path = '/api/storage/v1/pools'
-        self.client.get(path)
-        self.client.request.assert_called_with(path, 'GET')
-
-    @mock.patch.object(client.RestClientURL, 'request')
-    def test_put(self, _request):
-        path = '/api/storage/v1/pools'
-        body = {'name': 'fakepool'}
-        self.client.put(path, body=body)
-        self.client.request.assert_called_with(path, 'PUT', body)
-
-    @mock.patch.object(client.RestClientURL, 'request')
-    def test_delete(self, _request):
-        path = '/api/storage/v1/pools'
-        self.client.delete(path)
-        self.client.request.assert_called_with(path, 'DELETE')
-
-    @mock.patch.object(client.RestClientURL, 'request')
-    def test_head(self, _request):
-        path = '/api/storage/v1/pools'
-        self.client.head(path)
-        self.client.request.assert_called_with(path, 'HEAD')
-
-    @mock.patch.object(client, 'RestResult')
-    @mock.patch.object(client.urllib.request, 'Request')
-    @mock.patch.object(client.urllib.request, 'urlopen')
-    def test_request(self, _urlopen, _Request, _RestResult):
-        path = '/api/storage/v1/pools'
-        _urlopen.return_value = mock.Mock()
-        self.client.request(path, mock.ANY)
-        _Request.assert_called_with(self.url + path, None, self.client.headers)
-        self.assertEqual(1, _urlopen.call_count)
-        _RestResult.assert_called_with(response=mock.ANY)
-
-    @mock.patch.object(client, 'RestResult')
-    @mock.patch.object(client.urllib.request, 'Request')
-    @mock.patch.object(client.urllib.request, 'urlopen')
-    @mock.patch.object(client, 'ssl', new_callable=FakeSSL)
-    def test_ssl_with_context(self, _ssl, _urlopen, _Request, _RestResult):
-        """Test PEP476 certificate opt_out fix. """
-        path = '/api/storage/v1/pools'
-        _urlopen.return_value = mock.Mock()
-        self.client.request(path, mock.ANY)
-        _urlopen.assert_called_once_with(mock.ANY,
-                                         timeout=self.timeout,
-                                         context='fakecontext')
-
-    @mock.patch.object(client, 'RestResult')
-    @mock.patch.object(client.urllib.request, 'Request')
-    @mock.patch.object(client.urllib.request, 'urlopen')
-    @mock.patch.object(client, 'ssl', new_callable=object)
-    def test_ssl_no_context(self, _ssl, _urlopen, _Request, _RestResult):
-        """Verify the PEP476 fix backward compatibility. """
-        path = '/api/storage/v1/pools'
-        _urlopen.return_value = mock.Mock()
-        self.client.request(path, mock.ANY)
-        _urlopen.assert_called_once_with(mock.ANY, timeout=self.timeout)
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/veritas_access/test_veritas_iscsi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/veritas_access/test_veritas_iscsi.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/veritas_access/test_veritas_iscsi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/veritas_access/test_veritas_iscsi.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,659 +0,0 @@
-# Copyright 2017 Veritas Technologies LLC.
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-"""
-Unit tests for Veritas Access cinder driver.
-"""
-import hashlib
-import json
-import tempfile
-from xml.dom.minidom import Document
-
-import mock
-from oslo_config import cfg
-import requests
-
-from cinder import context
-from cinder import exception
-from cinder import test
-from cinder.volume import configuration as conf
-from cinder.volume.drivers.veritas_access import veritas_iscsi
-
-CONF = cfg.CONF
-FAKE_BACKEND = 'fake_backend'
-
-
-class MockResponse(object):
-    def __init__(self):
-        self.status_code = 200
-
-    def json(self):
-        data = {'fake_key': 'fake_val'}
-        return json.dumps(data)
-
-
-class FakeXML(object):
-
-    def __init__(self):
-        self.tempdir = tempfile.mkdtemp()
-
-    def create_vrts_fake_config_file(self):
-
-        target = 'iqn.2017-02.com.veritas:faketarget'
-        portal = '1.1.1.1'
-        auth_detail = '0'
-        doc = Document()
-
-        vrts_node = doc.createElement("VRTS")
-        doc.appendChild(vrts_node)
-
-        vrts_target_node = doc.createElement("VrtsTargets")
-        vrts_node.appendChild(vrts_target_node)
-
-        target_node = doc.createElement("Target")
-
-        vrts_target_node.appendChild(target_node)
-
-        name_ele = doc.createElement("Name")
-        portal_ele = doc.createElement("PortalIP")
-        auth_ele = doc.createElement("Authentication")
-
-        name_ele.appendChild(doc.createTextNode(target))
-        portal_ele.appendChild(doc.createTextNode(portal))
-        auth_ele.appendChild(doc.createTextNode(auth_detail))
-
-        target_node.appendChild(name_ele)
-        target_node.appendChild(portal_ele)
-        target_node.appendChild(auth_ele)
-
-        filename = 'vrts_config.xml'
-        config_file_path = self.tempdir + '/' + filename
-
-        f = open(config_file_path, 'w')
-        doc.writexml(f)
-        f.close()
-        return config_file_path
-
-
-class fake_volume(object):
-    def __init__(self):
-        self.id = 'fakeid'
-        self.name = 'fakename'
-        self.size = 1
-        self.snapshot_id = False
-        self.metadata = {'dense': True}
-
-
-class fake_volume2(object):
-    def __init__(self):
-        self.id = 'fakeid2'
-        self.name = 'fakename2'
-        self.size = 2
-        self.snapshot_id = False
-        self.metadata = {'dense': True}
-
-
-class fake_clone_volume(object):
-    def __init__(self):
-        self.id = 'fakecloneid'
-        self.name = 'fakeclonename'
-        self.size = 1
-        self.snapshot_id = False
-
-
-class fake_clone_volume2(object):
-    def __init__(self):
-        self.id = 'fakecloneid2'
-        self.name = 'fakeclonename'
-        self.size = 2
-        self.snapshot_id = False
-
-
-class fake_snapshot(object):
-    def __init__(self):
-        self.id = 'fakeid'
-        self.volume_id = 'fakevolumeid'
-        self.volume_size = 1
-
-
-class ACCESSIscsiDriverTestCase(test.TestCase):
-    """Tests ACCESSShareDriver."""
-
-    volume = fake_volume()
-    volume2 = fake_volume2()
-    snapshot = fake_snapshot()
-    clone_volume = fake_clone_volume()
-    clone_volume2 = fake_clone_volume2()
-    connector = {
-        'initiator': 'iqn.1994-05.com.fakeinitiator'
-    }
-
-    def setUp(self):
-        super(ACCESSIscsiDriverTestCase, self).setUp()
-        self._create_fake_config()
-        lcfg = self.configuration
-        self._context = context.get_admin_context()
-        self._driver = veritas_iscsi.ACCESSIscsiDriver(configuration=lcfg)
-        self._driver.do_setup(self._context)
-
-    def _create_fake_config(self):
-        self.mock_object(veritas_iscsi.ACCESSIscsiDriver,
-                         '_authenticate_access')
-        self.configuration = mock.Mock(spec=conf.Configuration)
-        self.configuration.safe_get = self.fake_safe_get
-        self.configuration.san_ip = '1.1.1.1'
-        self.configuration.san_login = 'user'
-        self.configuration.san_password = 'passwd'
-        self.configuration.san_api_port = 14161
-        self.configuration.vrts_lun_sparse = True
-        self.configuration.vrts_target_config = (
-            FakeXML().create_vrts_fake_config_file())
-        self.configuration.target_port = 3260
-        self.configuration.volume_backend_name = FAKE_BACKEND
-
-    def fake_safe_get(self, value):
-        try:
-            val = getattr(self.configuration, value)
-        except AttributeError:
-            val = None
-        return val
-
-    def test_create_volume(self):
-        self.mock_object(self._driver, '_vrts_get_suitable_target')
-        self.mock_object(self._driver, '_vrts_get_targets_store')
-        self.mock_object(self._driver, '_access_api')
-
-        mylist = []
-        target = {}
-        target['name'] = 'iqn.2017-02.com.veritas:faketarget'
-        target['portal_ip'] = '1.1.1.1'
-        target['auth'] = '0'
-        mylist.append(target)
-
-        self._driver._vrts_get_suitable_target.return_value = (
-            'iqn.2017-02.com.veritas:faketarget')
-        self._driver._access_api.return_value = True
-        return_list = self._driver._vrts_parse_xml_file(
-            self.configuration.vrts_target_config)
-
-        self._driver.create_volume(self.volume)
-
-        self.assertEqual(mylist, return_list)
-        self.assertEqual(1, self._driver._access_api.call_count)
-
-    def test_create_volume_negative(self):
-        self.mock_object(self._driver, '_vrts_get_suitable_target')
-        self.mock_object(self._driver, '_vrts_get_targets_store')
-        self.mock_object(self._driver, '_access_api')
-
-        self._driver._vrts_get_suitable_target.return_value = (
-            'iqn.2017-02.com.veritas:faketarget')
-        self._driver._access_api.return_value = False
-
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self._driver.create_volume,
-                          self.volume)
-
-    def test_create_volume_negative_no_suitable_target_found(self):
-        self.mock_object(self._driver, '_vrts_get_suitable_target')
-        self.mock_object(self._driver, '_access_api')
-
-        self._driver._vrts_get_suitable_target.return_value = False
-
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self._driver.create_volume,
-                          self.volume)
-        self.assertEqual(0, self._driver._access_api.call_count)
-
-    def test_delete_volume(self):
-        self.mock_object(self._driver, '_get_vrts_lun_list')
-        self.mock_object(self._driver, '_access_api')
-
-        va_lun_name = self._driver._get_va_lun_name(self.volume.id)
-
-        length = len(self.volume.id)
-        index = int(length / 2)
-        name1 = self.volume.id[:index]
-        name2 = self.volume.id[index:]
-        crc1 = hashlib.md5(name1.encode('utf-8')).hexdigest()[:5]
-        crc2 = hashlib.md5(name2.encode('utf-8')).hexdigest()[:5]
-
-        volume_name_to_ret = 'cinder' + '-' + crc1 + '-' + crc2
-
-        lun = {}
-        lun['lun_name'] = va_lun_name
-        lun['target_name'] = 'iqn.2017-02.com.veritas:faketarget'
-        lun_list = {'output': {'output': {'luns': [lun]}}}
-        self._driver._get_vrts_lun_list.return_value = lun_list
-
-        self._driver._access_api.return_value = True
-
-        self._driver.delete_volume(self.volume)
-        self.assertEqual(volume_name_to_ret, va_lun_name)
-        self.assertEqual(1, self._driver._access_api.call_count)
-
-    def test_delete_volume_negative(self):
-        self.mock_object(self._driver, '_get_vrts_lun_list')
-        self.mock_object(self._driver, '_access_api')
-
-        self._driver._access_api.return_value = False
-
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self._driver.delete_volume,
-                          self.volume)
-
-    def test_create_snapshot(self):
-        self.mock_object(self._driver, '_access_api')
-
-        self._driver._access_api.return_value = True
-
-        self._driver.create_snapshot(self.snapshot)
-        self.assertEqual(1, self._driver._access_api.call_count)
-
-    def test_create_snapshot_negative(self):
-        self.mock_object(self._driver, '_access_api')
-
-        self._driver._access_api.return_value = False
-
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self._driver.create_snapshot,
-                          self.snapshot)
-
-        self.assertEqual(1, self._driver._access_api.call_count)
-
-    def test_delete_snapshot(self):
-        self.mock_object(self._driver, '_access_api')
-
-        self._driver._access_api.return_value = True
-
-        self._driver.delete_snapshot(self.snapshot)
-        self.assertEqual(1, self._driver._access_api.call_count)
-
-    def test_delete_snapshot_negative(self):
-        self.mock_object(self._driver, '_access_api')
-
-        self._driver._access_api.return_value = False
-
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self._driver.delete_snapshot,
-                          self.snapshot)
-
-        self.assertEqual(1, self._driver._access_api.call_count)
-
-    def test_create_cloned_volume(self):
-        self.mock_object(self._driver, '_access_api')
-        self.mock_object(self._driver, '_vrts_extend_lun')
-        self.mock_object(self._driver, '_get_vrts_lun_list')
-        self.mock_object(self._driver, '_vrts_get_fs_list')
-        self.mock_object(self._driver, '_vrts_is_space_available_in_store')
-
-        va_lun_name = self._driver._get_va_lun_name(self.volume.id)
-
-        lun = {}
-        lun['lun_name'] = va_lun_name
-        lun['fs_name'] = 'fake_fs'
-        lun['target_name'] = 'iqn.2017-02.com.veritas:faketarget'
-        lun_list = {'output': {'output': {'luns': [lun]}}}
-
-        self._driver._get_vrts_lun_list.return_value = lun_list
-
-        self._driver._vrts_is_space_available_in_store.return_value = True
-
-        self._driver._access_api.return_value = True
-
-        self._driver.create_cloned_volume(self.clone_volume, self.volume)
-        self.assertEqual(1, self._driver._access_api.call_count)
-        self.assertEqual(0, self._driver._vrts_extend_lun.call_count)
-
-    def test_create_cloned_volume_of_greater_size(self):
-        self.mock_object(self._driver, '_access_api')
-        self.mock_object(self._driver, '_vrts_extend_lun')
-        self.mock_object(self._driver, '_get_vrts_lun_list')
-        self.mock_object(self._driver, '_vrts_get_fs_list')
-        self.mock_object(self._driver, '_vrts_is_space_available_in_store')
-
-        va_lun_name = self._driver._get_va_lun_name(self.volume.id)
-
-        lun = {}
-        lun['lun_name'] = va_lun_name
-        lun['fs_name'] = 'fake_fs'
-        lun['target_name'] = 'iqn.2017-02.com.veritas:faketarget'
-        lun_list = {'output': {'output': {'luns': [lun]}}}
-
-        self._driver._get_vrts_lun_list.return_value = lun_list
-
-        self._driver._vrts_is_space_available_in_store.return_value = True
-
-        self._driver._access_api.return_value = True
-
-        self._driver.create_cloned_volume(self.clone_volume2, self.volume)
-        self.assertEqual(1, self._driver._access_api.call_count)
-        self.assertEqual(1, self._driver._vrts_extend_lun.call_count)
-
-    def test_create_cloned_volume_negative(self):
-        self.mock_object(self._driver, '_access_api')
-        self.mock_object(self._driver, '_get_vrts_lun_list')
-        self.mock_object(self._driver, '_vrts_get_fs_list')
-        self.mock_object(self._driver, '_vrts_is_space_available_in_store')
-
-        va_lun_name = self._driver._get_va_lun_name(self.volume.id)
-
-        lun = {}
-        lun['lun_name'] = va_lun_name
-        lun['fs_name'] = 'fake_fs'
-        lun['target_name'] = 'iqn.2017-02.com.veritas:faketarget'
-        lun_list = {'output': {'output': {'luns': [lun]}}}
-
-        self._driver._get_vrts_lun_list.return_value = lun_list
-
-        self._driver._vrts_is_space_available_in_store.return_value = True
-
-        self._driver._access_api.return_value = False
-
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self._driver.create_cloned_volume,
-                          self.clone_volume, self.volume)
-
-        self.assertEqual(1, self._driver._access_api.call_count)
-
-    def test_create_volume_from_snapshot(self):
-        self.mock_object(self._driver, '_access_api')
-        self.mock_object(self._driver, '_vrts_extend_lun')
-        self.mock_object(self._driver, '_vrts_get_targets_store')
-        self.mock_object(self._driver, '_vrts_get_assigned_store')
-        self.mock_object(self._driver, '_vrts_get_fs_list')
-        self.mock_object(self._driver, '_vrts_is_space_available_in_store')
-
-        snap_name = self._driver._get_va_lun_name(self.snapshot.id)
-
-        snap = {}
-        snap['snapshot_name'] = snap_name
-        snap['target_name'] = 'fake_target'
-
-        snapshots = []
-        snapshots.append(snap)
-
-        snap_info = {}
-        snap_info['output'] = {'output': {'snapshots': snapshots}}
-
-        self._driver._access_api.return_value = snap_info
-
-        self._driver._vrts_is_space_available_in_store.return_value = True
-
-        self._driver.create_volume_from_snapshot(self.volume, self.snapshot)
-        self.assertEqual(2, self._driver._access_api.call_count)
-        self.assertEqual(0, self._driver._vrts_extend_lun.call_count)
-
-    def test_create_volume_from_snapshot_of_greater_size(self):
-        self.mock_object(self._driver, '_access_api')
-        self.mock_object(self._driver, '_vrts_extend_lun')
-        self.mock_object(self._driver, '_vrts_get_targets_store')
-        self.mock_object(self._driver, '_vrts_get_assigned_store')
-        self.mock_object(self._driver, '_vrts_get_fs_list')
-        self.mock_object(self._driver, '_vrts_is_space_available_in_store')
-
-        snap_name = self._driver._get_va_lun_name(self.snapshot.id)
-
-        snap = {}
-        snap['snapshot_name'] = snap_name
-        snap['target_name'] = 'fake_target'
-
-        snapshots = []
-        snapshots.append(snap)
-
-        snap_info = {}
-        snap_info['output'] = {'output': {'snapshots': snapshots}}
-
-        self._driver._access_api.return_value = snap_info
-
-        self._driver._vrts_is_space_available_in_store.return_value = True
-
-        self._driver.create_volume_from_snapshot(self.volume2, self.snapshot)
-        self.assertEqual(2, self._driver._access_api.call_count)
-        self.assertEqual(1, self._driver._vrts_extend_lun.call_count)
-
-    def test_create_volume_from_snapshot_negative(self):
-        self.mock_object(self._driver, '_access_api')
-        self.mock_object(self._driver, '_vrts_get_targets_store')
-
-        snap = {}
-        snap['snapshot_name'] = 'fake_snap_name'
-        snap['target_name'] = 'fake_target'
-
-        snapshots = []
-        snapshots.append(snap)
-
-        snap_info = {}
-        snap_info['output'] = {'output': {'snapshots': snapshots}}
-
-        self._driver._access_api.return_value = snap_info
-
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self._driver.create_volume_from_snapshot,
-                          self.volume, self.snapshot)
-
-        self.assertEqual(1, self._driver._access_api.call_count)
-        self.assertEqual(0, self._driver._vrts_get_targets_store.call_count)
-
-    def test_extend_volume(self):
-        self.mock_object(self._driver, '_access_api')
-        self.mock_object(self._driver, '_get_vrts_lun_list')
-        self.mock_object(self._driver, '_vrts_get_fs_list')
-        self.mock_object(self._driver, '_vrts_is_space_available_in_store')
-
-        va_lun_name = self._driver._get_va_lun_name(self.volume.id)
-
-        lun = {}
-        lun['lun_name'] = va_lun_name
-        lun['fs_name'] = 'fake_fs'
-        lun['target_name'] = 'iqn.2017-02.com.veritas:faketarget'
-        lun_list = {'output': {'output': {'luns': [lun]}}}
-
-        self._driver._get_vrts_lun_list.return_value = lun_list
-        self._driver._vrts_is_space_available_in_store.return_value = True
-
-        self._driver._access_api.return_value = True
-
-        self._driver.extend_volume(self.volume, 2)
-        self.assertEqual(1, self._driver._access_api.call_count)
-
-    def test_extend_volume_negative(self):
-        self.mock_object(self._driver, '_access_api')
-        self.mock_object(self._driver, '_get_vrts_lun_list')
-        self.mock_object(self._driver, '_vrts_get_fs_list')
-        self.mock_object(self._driver, '_vrts_is_space_available_in_store')
-
-        va_lun_name = self._driver._get_va_lun_name(self.volume.id)
-
-        lun = {}
-        lun['lun_name'] = va_lun_name
-        lun['fs_name'] = 'fake_fs'
-        lun['target_name'] = 'iqn.2017-02.com.veritas:faketarget'
-        lun_list = {'output': {'output': {'luns': [lun]}}}
-
-        self._driver._get_vrts_lun_list.return_value = lun_list
-        self._driver._vrts_is_space_available_in_store.return_value = True
-
-        self._driver._access_api.return_value = False
-
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self._driver.extend_volume, self.volume, 2)
-        self.assertEqual(1, self._driver._vrts_get_fs_list.call_count)
-        self.assertEqual(1, self._driver._access_api.call_count)
-
-    def test_extend_volume_negative_not_volume_found(self):
-        self.mock_object(self._driver, '_access_api')
-        self.mock_object(self._driver, '_get_vrts_lun_list')
-        self.mock_object(self._driver, '_vrts_get_fs_list')
-
-        lun = {}
-        lun['lun_name'] = 'fake_lun'
-        lun['fs_name'] = 'fake_fs'
-        lun['target_name'] = 'iqn.2017-02.com.veritas:faketarget'
-        lun_list = {'output': {'output': {'luns': [lun]}}}
-
-        self._driver._get_vrts_lun_list.return_value = lun_list
-
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self._driver.extend_volume, self.volume, 2)
-
-        self.assertEqual(0, self._driver._vrts_get_fs_list.call_count)
-        self.assertEqual(0, self._driver._access_api.call_count)
-
-    def test_initialize_connection(self):
-        self.mock_object(self._driver, '_access_api')
-        self.mock_object(self._driver, '_get_vrts_lun_list')
-        self.mock_object(self._driver, '_vrts_target_initiator_mapping')
-        self.mock_object(self._driver, '_vrts_get_iscsi_properties')
-
-        va_lun_name = self._driver._get_va_lun_name(self.volume.id)
-
-        lun = {}
-        lun['lun_name'] = va_lun_name
-        lun['target_name'] = 'iqn.2017-02.com.veritas:faketarget'
-        lun_list = {'output': {'output': {'luns': [lun]}}}
-
-        self._driver._get_vrts_lun_list.return_value = lun_list
-        self._driver._access_api.return_value = True
-        self._driver.initialize_connection(self.volume, self.connector)
-        self.assertEqual(1, self._driver._vrts_get_iscsi_properties.call_count)
-
-    def test_initialize_connection_negative(self):
-        self.mock_object(self._driver, '_access_api')
-        self.mock_object(self._driver, '_get_vrts_lun_list')
-        self.mock_object(self._driver, '_vrts_target_initiator_mapping')
-        self.mock_object(self._driver, '_vrts_get_iscsi_properties')
-
-        lun = {}
-        lun['lun_name'] = 'fakelun'
-        lun['target_name'] = 'iqn.2017-02.com.veritas:faketarget'
-        lun_list = {'output': {'output': {'luns': [lun]}}}
-        self._driver.LUN_FOUND_INTERVAL = 5
-
-        self._driver._get_vrts_lun_list.return_value = lun_list
-        self._driver._access_api.return_value = True
-
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self._driver.initialize_connection, self.volume,
-                          self.connector)
-
-        self.assertEqual(
-            0, self._driver._vrts_target_initiator_mapping.call_count)
-        self.assertEqual(0, self._driver._vrts_get_iscsi_properties.call_count)
-
-    def test___vrts_get_iscsi_properties(self):
-        self.mock_object(self._driver, '_access_api')
-
-        va_lun_name = self._driver._get_va_lun_name(self.volume.id)
-        storage_object = "'/fakestores/fakeio/" + va_lun_name + "'"
-
-        lun_id_list = {}
-        lun_id_list['output'] = ("[{'storage_object': " +
-                                 storage_object + ", 'index': '1'}]")
-
-        target_name = 'iqn.2017-02.com.veritas:faketarget'
-
-        self._driver._access_api.return_value = lun_id_list
-
-        iscsi_properties_ret_value = {}
-        iscsi_properties_ret_value['target_discovered'] = True
-        iscsi_properties_ret_value['target_iqn'] = target_name
-        iscsi_properties_ret_value['target_portal'] = '1.1.1.1:3260'
-        iscsi_properties_ret_value['target_lun'] = 1
-        iscsi_properties_ret_value['volume_id'] = 'fakeid'
-        iscsi_properties = self._driver._vrts_get_iscsi_properties(self.volume,
-                                                                   target_name)
-
-        self.assertEqual(iscsi_properties_ret_value, iscsi_properties)
-
-    def test__access_api(self):
-        self.mock_object(requests, 'session')
-
-        provider = '%s:%s' % (self._driver._va_ip, self._driver._port)
-        path = '/fake/path'
-        input_data = {}
-        mock_response = MockResponse()
-        session = requests.session
-
-        data = {'fake_key': 'fake_val'}
-        json_data = json.dumps(data)
-
-        session.request.return_value = mock_response
-        ret_value = self._driver._access_api(session, provider, path,
-                                             json.dumps(input_data), 'GET')
-
-        self.assertEqual(json_data, ret_value)
-
-    def test__access_api_negative(self):
-        session = self._driver.session
-        provider = '%s:%s' % (self._driver._va_ip, self._driver._port)
-        path = '/fake/path'
-        input_data = {}
-        ret_value = self._driver._access_api(session, provider, path,
-                                             json.dumps(input_data), 'GET')
-        self.assertEqual(False, ret_value)
-
-    def test__get_api(self):
-        provider = '%s:%s' % (self._driver._va_ip, self._driver._port)
-        tail = '/fake/path'
-        ret = self._driver._get_api(provider, tail)
-
-        api_root = 'https://%s/api/access' % (provider)
-        to_be_ret = api_root + tail
-        self.assertEqual(to_be_ret, ret)
-
-    def test__vrts_target_initiator_mapping_negative(self):
-        self.mock_object(self._driver, '_access_api')
-        target_name = 'fake_target'
-        initiator_name = 'fake_initiator'
-
-        self._driver._access_api.return_value = False
-        self.assertRaises(exception.VolumeBackendAPIException,
-                          self._driver._vrts_target_initiator_mapping,
-                          target_name, initiator_name)
-
-    def test_get_volume_stats(self):
-        self.mock_object(self._driver, '_authenticate_access')
-        self.mock_object(self._driver, '_vrts_get_targets_store')
-        self.mock_object(self._driver, '_vrts_get_fs_list')
-
-        target_list = []
-        target_details = {}
-        target_details['fs_list'] = ['fs1']
-        target_details['wwn'] = 'iqn.2017-02.com.veritas:faketarget'
-        target_list.append(target_details)
-
-        self._driver._vrts_get_targets_store.return_value = target_list
-
-        fs_list = []
-        fs_dict = {}
-        fs_dict['name'] = 'fs1'
-        fs_dict['file_storage_capacity'] = 10737418240
-        fs_dict['file_storage_used'] = 1073741824
-        fs_list.append(fs_dict)
-
-        self._driver._vrts_get_fs_list.return_value = fs_list
-
-        self._driver.get_volume_stats()
-        data = {
-            'volume_backend_name': FAKE_BACKEND,
-            'vendor_name': 'Veritas',
-            'driver_version': '1.0',
-            'storage_protocol': 'iSCSI',
-            'total_capacity_gb': 10,
-            'free_capacity_gb': 9,
-            'reserved_percentage': 0,
-            'thin_provisioning_support': True
-        }
-
-        self.assertEqual(data, self._driver._stats)
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/vmware/test_fcd.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/vmware/test_fcd.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/vmware/test_fcd.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/vmware/test_fcd.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,12 +13,12 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Test suite for VMware vCenter FCD driver.
-"""
+"""Test suite for VMware vCenter FCD driver."""
+
+from unittest import mock
 
 import ddt
-import mock
+from oslo_utils import timeutils
 from oslo_utils import units
 from oslo_vmware import image_transfer
 from oslo_vmware.objects import datastore
@@ -27,8 +27,10 @@ from oslo_vmware import vim_util
 from cinder import context
 from cinder import exception as cinder_exceptions
 from cinder import test
+from cinder.tests.unit import fake_constants as fake
 from cinder.tests.unit import fake_snapshot
 from cinder.tests.unit import fake_volume
+from cinder.tests.unit import utils as test_utils
 from cinder.volume import configuration
 from cinder.volume.drivers.vmware import datastore as hub
 from cinder.volume.drivers.vmware import fcd
@@ -67,6 +69,7 @@ class VMwareVStorageObjectDriverTestCase
         self._driver._vc_version = self.VC_VERSION
         self._driver._storage_policy_enabled = True
         self._context = context.get_admin_context()
+        self.updated_at = timeutils.utcnow()
 
     @mock.patch.object(VMDK_DRIVER, 'do_setup')
     @mock.patch.object(FCD_DRIVER, 'volumeops')
@@ -387,7 +390,16 @@ class VMwareVStorageObjectDriverTestCase
         vops.get_vmdk_path.return_value = vmdk_file_path
         vops.get_backing_by_uuid.return_value = backing
 
-        volume = self._create_volume_obj()
+        volume = test_utils.create_volume(
+            self._context, volume_type_id=fake.VOLUME_TYPE_ID,
+            updated_at=self.updated_at)
+        extra_specs = {
+            'image_service:store_id': 'fake-store'
+        }
+        test_utils.create_volume_type(
+            self._context.elevated(), id=fake.VOLUME_TYPE_ID,
+            name="test_type", extra_specs=extra_specs)
+
         image_service = mock.sentinel.image_service
         image_meta = self._create_image_meta()
         self._driver.copy_volume_to_image(
@@ -412,7 +424,8 @@ class VMwareVStorageObjectDriverTestCase
             vm=backing,
             vmdk_file_path=vmdk_file_path,
             vmdk_size=volume.size * units.Gi,
-            image_name=image_meta['name'])
+            image_name=image_meta['name'],
+            store_id='fake-store')
         vops.detach_fcd.assert_called_once_with(backing, fcd_loc)
         delete_temp_backing.assert_called_once_with(backing)
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/vmware/test_vmware_datastore.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/vmware/test_vmware_datastore.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/vmware/test_vmware_datastore.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/vmware/test_vmware_datastore.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,13 +13,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Unit tests for datastore module.
-"""
+"""Unit tests for datastore module."""
 
 import re
+from unittest import mock
 
-import mock
 from oslo_utils import units
 
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/vmware/test_vmware_vmdk.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/vmware/test_vmware_vmdk.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/vmware/test_vmware_vmdk.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/vmware/test_vmware_vmdk.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,14 +13,13 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Test suite for VMware vCenter VMDK driver.
-"""
+"""Test suite for VMware vCenter VMDK driver."""
 
 import re
+from unittest import mock
 
 import ddt
-import mock
+from oslo_utils import timeutils
 from oslo_utils import units
 from oslo_utils import versionutils
 from oslo_vmware import exceptions
@@ -34,6 +33,7 @@ from cinder import test
 from cinder.tests.unit import fake_constants
 from cinder.tests.unit import fake_snapshot
 from cinder.tests.unit import fake_volume
+from cinder.tests.unit import utils as test_utils
 from cinder.volume import configuration
 from cinder.volume.drivers.vmware import datastore as hub
 from cinder.volume.drivers.vmware import exceptions as vmdk_exceptions
@@ -107,6 +107,7 @@ class VMwareVcVmdkDriverTestCase(test.Te
                                                db=self._db)
 
         self._context = context.get_admin_context()
+        self.updated_at = timeutils.utcnow()
 
     def test_get_volume_stats(self):
         stats = self._driver.get_volume_stats()
@@ -564,6 +565,23 @@ class VMwareVcVmdkDriverTestCase(test.Te
                 'is_public': is_public,
                 }
 
+    @mock.patch.object(VMDK_DRIVER, 'copy_image_to_volume')
+    def test_clone_image(self, copy_image_to_volume):
+        model_update = mock.sentinel.model_update
+        copy_image_to_volume.return_value = model_update
+
+        context = mock.sentinel.context
+        volume = mock.sentinel.volume
+        image_meta = self._create_image_meta()
+        image_service = mock.sentinel.image_service
+
+        ret = self._driver.clone_image(
+            context, volume, mock.sentinel.image_location, image_meta,
+            image_service)
+        self.assertEqual((model_update, True), ret)
+        copy_image_to_volume.assert_called_once_with(
+            context, volume, image_service, image_meta['id'])
+
     @mock.patch('cinder.volume.drivers.vmware.vmdk.VMwareVcVmdkDriver.'
                 '_validate_disk_format')
     def test_copy_image_to_volume_with_invalid_container(self,
@@ -1184,7 +1202,17 @@ class VMwareVcVmdkDriverTestCase(test.Te
         vops.get_vmdk_path.return_value = vmdk_file_path
 
         context = mock.sentinel.context
-        volume = self._create_volume_dict()
+        volume = test_utils.create_volume(
+            self._context, volume_type_id = fake_constants.VOLUME_TYPE_ID,
+            updated_at = self.updated_at)
+        extra_specs = {
+            'image_service:store_id': 'fake-store'
+        }
+        test_utils.create_volume_type(self._context.elevated(),
+                                      id=fake_constants.VOLUME_TYPE_ID,
+                                      name="test_type",
+                                      extra_specs=extra_specs)
+
         image_service = mock.sentinel.image_service
         image_meta = self._create_image_meta()
         self._driver.copy_volume_to_image(
@@ -1204,6 +1232,7 @@ class VMwareVcVmdkDriverTestCase(test.Te
             session=session,
             host=self._config.vmware_host_ip,
             port=self._config.vmware_host_port,
+            store_id='fake-store',
             vm=backing,
             vmdk_file_path=vmdk_file_path,
             vmdk_size=volume['size'] * units.Gi,
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/drivers/vmware/test_vmware_volumeops.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/vmware/test_vmware_volumeops.py
--- 2:15.0.1-1/cinder/tests/unit/volume/drivers/vmware/test_vmware_volumeops.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/drivers/vmware/test_vmware_volumeops.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,12 +13,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Test suite for VMware VMDK driver volumeops module.
-"""
+"""Test suite for VMware VMDK driver volumeops module."""
+
+from unittest import mock
 
 import ddt
-import mock
 from oslo_utils import units
 from oslo_vmware import exceptions
 from oslo_vmware import vim_util
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/flows/test_create_volume_flow.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/flows/test_create_volume_flow.py
--- 2:15.0.1-1/cinder/tests/unit/volume/flows/test_create_volume_flow.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/flows/test_create_volume_flow.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,16 +14,15 @@
 #    under the License.
 """ Tests for create_volume TaskFlow """
 
-import six
 import sys
+from unittest import mock
 import uuid
 
-import ddt
-import mock
-
 from castellan.common import exception as castellan_exc
 from castellan.tests.unit.key_manager import mock_key_manager
+import ddt
 from oslo_utils import imageutils
+import six
 
 from cinder import context
 from cinder import exception
@@ -1319,7 +1318,7 @@ class CreateVolumeFlowManagerGlanceCinde
                                         image_id,
                                         image_meta,
                                         fake_image_service)
-        if format is 'raw' and not owner and location:
+        if format == 'raw' and not owner and location:
             fake_driver.create_cloned_volume.assert_called_once_with(
                 volume, image_volume)
             handle_bootable.assert_called_once_with(self.ctxt, volume,
@@ -1384,7 +1383,7 @@ class CreateVolumeFlowManagerGlanceCinde
                                         image_id,
                                         image_meta,
                                         fake_image_service)
-        if format is 'raw' and not owner and location:
+        if format == 'raw' and not owner and location:
             fake_driver.create_cloned_volume.assert_called_once_with(
                 volume, image_volume)
             handle_bootable.assert_called_once_with(self.ctxt, volume,
@@ -1559,53 +1558,52 @@ class CreateVolumeFlowManagerImageCacheT
         image_location = 'someImageLocationStr'
         image_id = fakes.IMAGE_ID
         image_meta = mock.MagicMock()
-        image_info = imageutils.QemuImgInfo()
-        image_info.virtual_size = '1073741824'
-        mock_qemu_info.return_value = image_info
-
         volume = fake_volume.fake_volume_obj(self.ctxt, size=1,
                                              host='foo@bar#pool')
-        image_volume = fake_volume.fake_db_volume(size=2)
-        self.mock_db.volume_create.return_value = image_volume
-
+        self.mock_driver.clone_image.return_value = (None, False)
         self.flags(verify_glance_signatures='disabled')
 
-        if cloning_supported:
-            mock_create_from_src.side_effect = exception.CinderException(
-                'Error during cloning')
-        else:
-            mock_create_from_src.side_effect = NotImplementedError(
-                'Driver does not support clone')
-
         manager = create_volume_manager.CreateVolumeFromSpecTask(
             self.mock_volume_manager,
             self.mock_db,
             self.mock_driver,
             image_volume_cache=self.mock_cache
         )
-
-        model_update = manager._create_from_image_cache_or_download(
-            self.ctxt,
-            volume,
-            image_location,
-            image_id,
-            image_meta,
-            self.mock_image_service,
-            update_cache=False)
+        if cloning_supported:
+            mock_create_from_src.side_effect = exception.SnapshotLimitReached(
+                'Error during cloning')
+            self.assertRaises(
+                exception.SnapshotLimitReached,
+                manager._create_from_image,
+                self.ctxt,
+                volume,
+                image_location,
+                image_id,
+                image_meta,
+                self.mock_image_service)
+        else:
+            mock_create_from_src.side_effect = NotImplementedError(
+                'Driver does not support clone')
+            model_update = manager._create_from_image(
+                self.ctxt,
+                volume,
+                image_location,
+                image_id,
+                image_meta,
+                self.mock_image_service)
+            mock_create_from_img_dl.assert_called_once()
+            self.assertEqual(mock_create_from_img_dl.return_value,
+                             model_update)
 
         # Ensure cloning was attempted and that it failed
         mock_create_from_src.assert_called_once()
-        mock_create_from_img_dl.assert_called_once()
-        self.assertEqual(mock_create_from_img_dl.return_value, model_update)
-
-        # Ensure a new cache entry is created when cloning fails, but
-        # only when the driver supports cloning.
-        if cloning_supported:
-            (self.mock_volume_manager.
-             _create_image_cache_volume_entry.assert_called_once())
-        else:
-            (self.mock_volume_manager.
-             _create_image_cache_volume_entry.assert_not_called())
+        with mock.patch(
+                'cinder.volume.flows.manager.create_volume.'
+                'CreateVolumeFromSpecTask') as volume_manager:
+            (volume_manager.CreateVolumeFromSpecTask.
+             _create_from_image_cache_or_download.called_once())
+            (volume_manager.CreateVolumeFromSpecTask.
+             _create_from_image_cache.called_once())
 
     @mock.patch('cinder.volume.flows.manager.create_volume.'
                 'CreateVolumeFromSpecTask.'
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/flows/test_manage_snapshot_flow.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/flows/test_manage_snapshot_flow.py
--- 2:15.0.1-1/cinder/tests/unit/volume/flows/test_manage_snapshot_flow.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/flows/test_manage_snapshot_flow.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,8 +16,9 @@
 
 # TODO(mdovgal): add tests for other TaskFlow cases
 
+from unittest import mock
+
 import ddt
-import mock
 
 from cinder import context
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/flows/test_manage_volume_flow.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/flows/test_manage_volume_flow.py
--- 2:15.0.1-1/cinder/tests/unit/volume/flows/test_manage_volume_flow.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/flows/test_manage_volume_flow.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,8 @@
 """ Tests for manage_existing TaskFlow """
 
 import inspect
-import mock
+from unittest import mock
+
 import taskflow.engines
 
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/__init__.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/__init__.py
--- 2:15.0.1-1/cinder/tests/unit/volume/__init__.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/__init__.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,8 +16,8 @@
 import os
 import shutil
 import tempfile
+from unittest import mock
 
-import mock
 from oslo_config import cfg
 from oslo_utils import importutils
 from stevedore import extension
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/test_availability_zone.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_availability_zone.py
--- 2:15.0.1-1/cinder/tests/unit/volume/test_availability_zone.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_availability_zone.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,7 +16,7 @@
 """Test for volume availability zone."""
 
 import datetime
-import mock
+from unittest import mock
 
 from oslo_utils import timeutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/test_capabilities.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_capabilities.py
--- 2:15.0.1-1/cinder/tests/unit/volume/test_capabilities.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_capabilities.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,7 +14,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 from oslo_serialization import jsonutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/test_connection.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_connection.py
--- 2:15.0.1-1/cinder/tests/unit/volume/test_connection.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_connection.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,8 +15,9 @@
 #    under the License.
 """Tests for Volume connection test cases."""
 
+from unittest import mock
+
 import ddt
-import mock
 
 from cinder import context
 from cinder import db
@@ -88,7 +89,7 @@ class DiscardFlagTestCase(base.BaseVolum
         self.volume.driver.initialize_connection.return_value = conn_info
 
         def _safe_get(key):
-            if key is 'report_discard_supported':
+            if key == 'report_discard_supported':
                 return config_discard_flag
             else:
                 return None
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/test_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_driver.py
--- 2:15.0.1-1/cinder/tests/unit/volume/test_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,11 +14,11 @@
 #    under the License.
 """Tests for Volume Code."""
 
-import ddt
-import mock
 import shutil
 import tempfile
+from unittest import mock
 
+import ddt
 import os_brick
 from oslo_config import cfg
 from oslo_utils import importutils
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/test_image.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_image.py
--- 2:15.0.1-1/cinder/tests/unit/volume/test_image.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_image.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,9 +16,9 @@
 """Tests for volume and images."""
 
 import datetime
-import mock
 import os
 import tempfile
+from unittest import mock
 
 from oslo_utils import imageutils
 from oslo_utils import units
@@ -89,6 +89,11 @@ class CopyVolumeToImageTestCase(base.Bas
     def test_copy_volume_to_image_status_available(self):
         # creating volume testdata
         self.volume_attrs['instance_uuid'] = None
+        volume_type_id = db.volume_type_create(
+            self.context, {'name': 'test', 'extra_specs': {
+                'image_service:store_id': 'fake_store'
+            }}).get('id')
+        self.volume_attrs['volume_type_id'] = volume_type_id
         db.volume_create(self.context, self.volume_attrs)
 
         # start test
@@ -129,6 +134,11 @@ class CopyVolumeToImageTestCase(base.Bas
         # Creating volume testdata
         self.volume_attrs['instance_uuid'] = 'b21f957d-a72f-4b93-b5a5-' \
                                              '45b1161abb02'
+        volume_type_id = db.volume_type_create(
+            self.context, {'name': 'test', 'extra_specs': {
+                'image_service:store_id': 'fake_store'
+            }}).get('id')
+        self.volume_attrs['volume_type_id'] = volume_type_id
         db.volume_create(self.context, self.volume_attrs)
 
         method = 'volume_update_status_based_on_attachment'
@@ -150,6 +160,11 @@ class CopyVolumeToImageTestCase(base.Bas
     def test_copy_volume_to_image_status_use(self):
         self.image_meta['id'] = 'a440c04b-79fa-479c-bed1-0b816eaec379'
         # creating volume testdata
+        volume_type_id = db.volume_type_create(
+            self.context, {'name': 'test', 'extra_specs': {
+                'image_service:store_id': 'fake_store'
+            }}).get('id')
+        self.volume_attrs['volume_type_id'] = volume_type_id
         db.volume_create(self.context, self.volume_attrs)
 
         # start test
@@ -163,6 +178,11 @@ class CopyVolumeToImageTestCase(base.Bas
     def test_copy_volume_to_image_exception(self):
         self.image_meta['id'] = NON_EXISTENT_IMAGE_ID
         # creating volume testdata
+        volume_type_id = db.volume_type_create(
+            self.context, {'name': 'test', 'extra_specs': {
+                'image_service:store_id': 'fake_store'
+            }}).get('id')
+        self.volume_attrs['volume_type_id'] = volume_type_id
         self.volume_attrs['status'] = 'in-use'
         db.volume_create(self.context, self.volume_attrs)
 
@@ -296,6 +316,11 @@ class CopyVolumeToImageTestCase(base.Bas
         # creating volume testdata
         self.volume_attrs['instance_uuid'] = None
         self.volume_attrs['snapshot_id'] = fake.SNAPSHOT_ID
+        volume_type_id = db.volume_type_create(
+            self.context, {'name': 'test', 'extra_specs': {
+                'image_service:store_id': 'fake_store'
+            }}).get('id')
+        self.volume_attrs['volume_type_id'] = volume_type_id
         db.volume_create(self.context, self.volume_attrs)
 
         def fake_create(context, volume, **kwargs):
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/test_init_host.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_init_host.py
--- 2:15.0.1-1/cinder/tests/unit/volume/test_init_host.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_init_host.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,7 +15,8 @@
 #    under the License.
 """Tests for volume init host method cases."""
 
-import mock
+from unittest import mock
+
 from oslo_config import cfg
 from oslo_utils import importutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/test_manage_volume.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_manage_volume.py
--- 2:15.0.1-1/cinder/tests/unit/volume/test_manage_volume.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_manage_volume.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,7 +12,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import mock
+from unittest import mock
 
 from cinder import context
 from cinder import db
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/test_replication_manager.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_replication_manager.py
--- 2:15.0.1-1/cinder/tests/unit/volume/test_replication_manager.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_replication_manager.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,12 +13,10 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+from unittest import mock
 import uuid
 
 import ddt
-
-import mock
-
 from oslo_config import cfg
 from oslo_utils import timeutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/test_rpcapi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_rpcapi.py
--- 2:15.0.1-1/cinder/tests/unit/volume/test_rpcapi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_rpcapi.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,12 +12,11 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Unit Tests for cinder.volume.rpcapi
-"""
-import ddt
-import mock
+"""Unit Tests for cinder.volume.rpcapi."""
+
+from unittest import mock
 
+import ddt
 from oslo_config import cfg
 from oslo_serialization import jsonutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/test_snapshot.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_snapshot.py
--- 2:15.0.1-1/cinder/tests/unit/volume/test_snapshot.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_snapshot.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,11 +15,11 @@
 #    under the License.
 """Tests for global snapshot cases."""
 
-import ddt
 import os
 import sys
+from unittest import mock
 
-import mock
+import ddt
 from oslo_config import cfg
 from oslo_utils import imageutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/test_volume_manager.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_volume_manager.py
--- 2:15.0.1-1/cinder/tests/unit/volume/test_volume_manager.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_volume_manager.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,7 +14,7 @@
 #    under the License.
 """Tests for Volume Manager Code."""
 
-import mock
+from unittest import mock
 
 from cinder import exception
 from cinder.message import message_field
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/test_volume_migration.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_volume_migration.py
--- 2:15.0.1-1/cinder/tests/unit/volume/test_volume_migration.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_volume_migration.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,10 +15,10 @@
 #    under the License.
 """Tests for Volume Code."""
 
-import ddt
 import time
+from unittest import mock
 
-import mock
+import ddt
 import os_brick
 from oslo_concurrency import processutils
 from oslo_config import cfg
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/test_volume.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_volume.py
--- 2:15.0.1-1/cinder/tests/unit/volume/test_volume.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_volume.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,15 +16,15 @@
 """Tests for Volume Code."""
 
 import datetime
-import ddt
+import enum
 import time
+from unittest import mock
 import uuid
 
 from castellan.common import exception as castellan_exception
 from castellan import key_manager
-import enum
+import ddt
 import eventlet
-import mock
 import os_brick.initiator.connectors.iscsi
 from oslo_concurrency import processutils
 from oslo_config import cfg
@@ -1679,6 +1679,7 @@ class VolumeTestCase(base.BaseVolumeTest
                 mock_execute.assert_called_once_with(
                     'cryptsetup', 'luksChangeKey',
                     '/some/device/thing',
+                    '--force-password',
                     log_errors=processutils.LOG_ALL_ERRORS,
                     process_input='qwert\nasdfg\n',
                     run_as_root=True)
@@ -2781,10 +2782,17 @@ class VolumeTestCase(base.BaseVolumeTest
         self.assertEqual('available',
                          db.volume_get(context.get_admin_context(),
                                        volume_dst['id']).status)
-        src_glancemeta = db.volume_get(context.get_admin_context(),
-                                       volume_src['id']).volume_glance_metadata
-        dst_glancemeta = db.volume_get(context.get_admin_context(),
-                                       volume_dst['id']).volume_glance_metadata
+
+        # TODO: review all tests in this file to make sure they are
+        # using the defined db.api to access stuff rather than taking
+        # shortcuts like the following (see LP Bug #1860817):
+        # src_glancemeta = db.volume_get(context.get_admin_context(),
+        #     volume_src['id']).volume_glance_metadata
+
+        src_glancemeta = db.volume_glance_metadata_get(
+            context.get_admin_context(), volume_src['id'])
+        dst_glancemeta = db.volume_glance_metadata_get(
+            context.get_admin_context(), volume_dst['id'])
         for meta_src in src_glancemeta:
             for meta_dst in dst_glancemeta:
                 if meta_dst.key == meta_src.key:
diff -pruN 2:15.0.1-1/cinder/tests/unit/volume/test_volume_retype.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_volume_retype.py
--- 2:15.0.1-1/cinder/tests/unit/volume/test_volume_retype.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/volume/test_volume_retype.py	2020-03-24 18:46:31.000000000 +0000
@@ -11,7 +11,8 @@
 #    under the License.
 """Tests for Volume retype Code."""
 
-import mock
+from unittest import mock
+
 from oslo_config import cfg
 
 from cinder import context
diff -pruN 2:15.0.1-1/cinder/tests/unit/windows/test_iscsi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/windows/test_iscsi.py
--- 2:15.0.1-1/cinder/tests/unit/windows/test_iscsi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/windows/test_iscsi.py	2020-03-24 18:46:31.000000000 +0000
@@ -19,18 +19,21 @@ Unit tests for Windows Server 2012 OpenS
 """
 
 import os
+from unittest import mock
 
 import ddt
-import mock
 from oslo_utils import fileutils
+from oslo_utils import timeutils
 from oslo_utils import units
 
 from cinder import context
 from cinder import exception
 from cinder.image import image_utils
 from cinder import test
+from cinder.tests.unit import fake_constants as fake
 from cinder.tests.unit import fake_snapshot
 from cinder.tests.unit import fake_volume
+from cinder.tests.unit import utils as test_utils
 from cinder.tests.unit.windows import db_fakes
 from cinder.volume import configuration as conf
 from cinder.volume.drivers.windows import iscsi as windows_iscsi
@@ -49,6 +52,9 @@ class TestWindowsISCSIDriver(test.TestCa
         self._driver = windows_iscsi.WindowsISCSIDriver(
             configuration=self.configuration)
 
+        self._context = context.get_admin_context()
+        self.updated_at = timeutils.utcnow()
+
     @mock.patch.object(fileutils, 'ensure_tree')
     def test_do_setup(self, mock_ensure_tree):
         self._driver.do_setup(mock.sentinel.context)
@@ -375,7 +381,18 @@ class TestWindowsISCSIDriver(test.TestCa
 
         disk_format = 'vhd'
         fake_image_meta = db_fakes.get_fake_image_meta()
-        volume = fake_volume.fake_volume_obj(mock.sentinel.fake_context)
+
+        fake_volume = test_utils.create_volume(
+            self._context, volume_type_id=fake.VOLUME_TYPE_ID,
+            updated_at=self.updated_at)
+
+        extra_specs = {
+            'image_service:store_id': 'fake-store'
+        }
+        test_utils.create_volume_type(self._context.elevated(),
+                                      id=fake.VOLUME_TYPE_ID, name="test_type",
+                                      extra_specs=extra_specs)
+
         fake_img_conv_dir = 'fake_img_conv_dir'
         self.flags(image_conversion_dir=fake_img_conv_dir)
 
@@ -388,17 +405,18 @@ class TestWindowsISCSIDriver(test.TestCa
             fake_image_meta['id'] + '.' + disk_format)
 
         self._driver.copy_volume_to_image(
-            mock.sentinel.context, volume,
+            mock.sentinel.context, fake_volume,
             mock.sentinel.image_service,
             fake_image_meta)
 
-        mock_tmp_snap.assert_called_once_with(volume.name)
+        mock_tmp_snap.assert_called_once_with(fake_volume.name)
         tgt_utils.export_snapshot.assert_called_once_with(
             mock.sentinel.tmp_snap_name,
             expected_tmp_vhd_path)
         mock_upload_volume.assert_called_once_with(
             mock.sentinel.context, mock.sentinel.image_service,
-            fake_image_meta, expected_tmp_vhd_path, 'vhd')
+            fake_image_meta, expected_tmp_vhd_path, 'vhd',
+            store_id='fake-store')
         mock_delete_if_exists.assert_called_once_with(
             expected_tmp_vhd_path)
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/windows/test_smbfs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/windows/test_smbfs.py
--- 2:15.0.1-1/cinder/tests/unit/windows/test_smbfs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/windows/test_smbfs.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,9 +14,10 @@
 
 import copy
 import os
+from unittest import mock
 
 import ddt
-import mock
+from oslo_utils import timeutils
 from oslo_utils import units
 
 from cinder import context
@@ -24,6 +25,7 @@ from cinder import exception
 from cinder.image import image_utils
 from cinder.objects import fields
 from cinder import test
+from cinder.tests.unit import fake_constants as fake
 from cinder.tests.unit import fake_volume
 from cinder.tests.unit import utils as test_utils
 from cinder.volume.drivers import remotefs
@@ -78,6 +80,9 @@ class WindowsSmbFsTestCase(test.TestCase
         self.volume = self._simple_volume()
         self.snapshot = self._simple_snapshot(volume=self.volume)
 
+        self._context = context.get_admin_context()
+        self.updated_at = timeutils.utcnow()
+
     def _simple_volume(self, **kwargs):
         updates = {'id': self._FAKE_VOLUME_ID,
                    'size': self._FAKE_VOLUME_SIZE,
@@ -722,6 +727,17 @@ class WindowsSmbFsTestCase(test.TestCase
     def test_copy_volume_to_image(self, has_parent=False):
         drv = self._smbfs_driver
 
+        volume = test_utils.create_volume(
+            self._context, volume_type_id=fake.VOLUME_TYPE_ID,
+            updated_at=self.updated_at)
+
+        extra_specs = {
+            'image_service:store_id': 'fake-store'
+        }
+        test_utils.create_volume_type(self._context.elevated(),
+                                      id=fake.VOLUME_TYPE_ID, name="test_type",
+                                      extra_specs=extra_specs)
+
         fake_image_meta = {'id': 'fake-image-id'}
         fake_img_format = self._smbfs_driver._DISK_FORMAT_VHDX
 
@@ -746,12 +762,12 @@ class WindowsSmbFsTestCase(test.TestCase
         with mock.patch.object(image_utils, 'upload_volume') as (
                 fake_upload_volume):
             drv.copy_volume_to_image(
-                mock.sentinel.context, self.volume,
+                mock.sentinel.context, volume,
                 mock.sentinel.image_service, fake_image_meta)
 
             if has_parent:
                 fake_temp_image_name = '%s.temp_image.%s.%s' % (
-                    self.volume.id,
+                    volume.id,
                     fake_image_meta['id'],
                     fake_img_format)
                 fake_temp_image_path = os.path.join(
@@ -772,7 +788,8 @@ class WindowsSmbFsTestCase(test.TestCase
 
             fake_upload_volume.assert_called_once_with(
                 mock.sentinel.context, mock.sentinel.image_service,
-                fake_image_meta, upload_path, fake_img_format)
+                fake_image_meta, upload_path, fake_img_format,
+                store_id='fake-store')
 
     @mock.patch.object(smbfs.WindowsSmbfsDriver, '_get_vhd_type')
     def test_copy_image_to_volume(self, mock_get_vhd_type):
diff -pruN 2:15.0.1-1/cinder/tests/unit/zonemanager/test_brcd_fc_san_lookup_service.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_brcd_fc_san_lookup_service.py
--- 2:15.0.1-1/cinder/tests/unit/zonemanager/test_brcd_fc_san_lookup_service.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_brcd_fc_san_lookup_service.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,8 +16,8 @@
 
 
 """Unit tests for brcd fc san lookup service."""
+from unittest import mock
 
-import mock
 from oslo_config import cfg
 from oslo_utils import importutils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/zonemanager/test_brcd_fc_zone_client_cli.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_brcd_fc_zone_client_cli.py
--- 2:15.0.1-1/cinder/tests/unit/zonemanager/test_brcd_fc_zone_client_cli.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_brcd_fc_zone_client_cli.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,8 +16,8 @@
 
 
 """Unit tests for brcd fc zone client cli."""
+from unittest import mock
 
-import mock
 from oslo_concurrency import processutils
 
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/zonemanager/test_brcd_fc_zone_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_brcd_fc_zone_driver.py
--- 2:15.0.1-1/cinder/tests/unit/zonemanager/test_brcd_fc_zone_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_brcd_fc_zone_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,8 +16,8 @@
 
 
 """Unit tests for Brocade fc zone driver."""
+from unittest import mock
 
-import mock
 from oslo_config import cfg
 from oslo_utils import importutils
 import paramiko
diff -pruN 2:15.0.1-1/cinder/tests/unit/zonemanager/test_brcd_http_fc_zone_client.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_brcd_http_fc_zone_client.py
--- 2:15.0.1-1/cinder/tests/unit/zonemanager/test_brcd_http_fc_zone_client.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_brcd_http_fc_zone_client.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,11 +16,10 @@
 
 """Unit tests for brcd fc zone client http(s)."""
 import time
+from unittest import mock
+from unittest.mock import patch
 
 from oslo_utils import encodeutils
-
-import mock
-from mock import patch
 import six
 
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/zonemanager/test_cisco_fc_san_lookup_service.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_cisco_fc_san_lookup_service.py
--- 2:15.0.1-1/cinder/tests/unit/zonemanager/test_cisco_fc_san_lookup_service.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_cisco_fc_san_lookup_service.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,8 +16,8 @@
 
 
 """Unit tests for Cisco fc san lookup service."""
+from unittest import mock
 
-import mock
 from oslo_config import cfg
 
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/tests/unit/zonemanager/test_cisco_fc_zone_client_cli.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_cisco_fc_zone_client_cli.py
--- 2:15.0.1-1/cinder/tests/unit/zonemanager/test_cisco_fc_zone_client_cli.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_cisco_fc_zone_client_cli.py	2020-03-24 18:46:31.000000000 +0000
@@ -18,8 +18,8 @@
 """Unit tests for Cisco fc zone client cli."""
 
 import time
+from unittest import mock
 
-import mock
 from oslo_concurrency import processutils
 from six.moves import range
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/zonemanager/test_cisco_fc_zone_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_cisco_fc_zone_driver.py
--- 2:15.0.1-1/cinder/tests/unit/zonemanager/test_cisco_fc_zone_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_cisco_fc_zone_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,8 +16,8 @@
 
 
 """Unit tests for Cisco FC zone driver."""
+from unittest import mock
 
-import mock
 from oslo_concurrency import processutils
 from oslo_config import cfg
 from oslo_utils import importutils
diff -pruN 2:15.0.1-1/cinder/tests/unit/zonemanager/test_driverutils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_driverutils.py
--- 2:15.0.1-1/cinder/tests/unit/zonemanager/test_driverutils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_driverutils.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,11 +14,11 @@
 #    under the License.
 #
 
-
 """Unit tests for friendly zone name."""
-import ddt
 import string
 
+import ddt
+
 from cinder import test
 from cinder.zonemanager.drivers import driver_utils
 
diff -pruN 2:15.0.1-1/cinder/tests/unit/zonemanager/test_fc_zone_manager.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_fc_zone_manager.py
--- 2:15.0.1-1/cinder/tests/unit/zonemanager/test_fc_zone_manager.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_fc_zone_manager.py	2020-03-24 18:46:31.000000000 +0000
@@ -19,7 +19,7 @@
 
 """Unit tests for FC Zone Manager."""
 
-import mock
+from unittest import mock
 
 from cinder import exception
 from cinder import test
diff -pruN 2:15.0.1-1/cinder/tests/unit/zonemanager/test_volume_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_volume_driver.py
--- 2:15.0.1-1/cinder/tests/unit/zonemanager/test_volume_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/tests/unit/zonemanager/test_volume_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -19,7 +19,7 @@
 
 """Unit tests for Volume Manager."""
 
-import mock
+from unittest import mock
 
 from cinder import test
 from cinder.tests import fake_driver
diff -pruN 2:15.0.1-1/cinder/transfer/api.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/transfer/api.py
--- 2:15.0.1-1/cinder/transfer/api.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/transfer/api.py	2020-03-24 18:46:31.000000000 +0000
@@ -209,7 +209,7 @@ class API(base.Base):
             donor_reservations = QUOTAS.reserve(context,
                                                 project_id=donor_id,
                                                 **reserve_opts)
-        except exception.OverQuota as e:
+        except exception.OverQuota:
             donor_reservations = None
             LOG.exception("Failed to update volume providing snapshots quota:"
                           " Over quota.")
diff -pruN 2:15.0.1-1/cinder/utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/utils.py
--- 2:15.0.1-1/cinder/utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -587,7 +587,7 @@ def get_blkdev_major_minor(path, lookup_
         # lookup the mounted disk which the file lies on
         out, _err = execute('df', path)
         devpath = out.split("\n")[1].split()[0]
-        if devpath[0] is not '/':
+        if devpath[0] != '/':
             # the file is on a network file system
             return None
         return get_blkdev_major_minor(devpath, False)
diff -pruN 2:15.0.1-1/cinder/volume/driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/driver.py
--- 2:15.0.1-1/cinder/volume/driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -88,14 +88,17 @@ volume_opts = [
                     'target support, ietadm for iSCSI Enterprise Target, '
                     'iscsictl for Chelsio iSCSI Target, nvmet for NVMEoF '
                     'support, spdk-nvmeof for SPDK NVMe-oF, '
-                    'or fake for testing.'),
+                    'or fake for testing. Note: The IET driver is deprecated '
+                    'and will be removed in the V release.'),
     cfg.StrOpt('volumes_dir',
                default='$state_path/volumes',
                help='Volume configuration file storage '
                'directory'),
     cfg.StrOpt('iet_conf',
                default='/etc/iet/ietd.conf',
-               help='IET configuration file'),
+               deprecated_for_removal=True,
+               deprecated_reason='IET target driver is no longer supported.',
+               help='DEPRECATED: IET configuration file'),
     cfg.StrOpt('chiscsi_conf',
                default='/etc/chelsio-iscsi/chiscsi.conf',
                help='Chiscsi (CXT) global defaults configuration file'),
@@ -312,12 +315,18 @@ image_opts = [
     cfg.BoolOpt('use_multipath_for_image_xfer',
                 default=False,
                 help='Do we attach/detach volumes in cinder using multipath '
-                     'for volume to image and image to volume transfers?'),
+                     'for volume to image and image to volume transfers? '
+                     'This parameter needs to be configured for each backend '
+                     'section or in [backend_defaults] section as a common '
+                     'configuration for all backends.'),
     cfg.BoolOpt('enforce_multipath_for_image_xfer',
                 default=False,
                 help='If this is set to True, attachment of volumes for '
                      'image transfer will be aborted when multipathd is not '
-                     'running. Otherwise, it will fallback to single path.'),
+                     'running. Otherwise, it will fallback to single path. '
+                     'This parameter needs to be configured for each backend '
+                     'section or in [backend_defaults] section as a common '
+                     'configuration for all backends.'),
 ]
 
 
@@ -340,26 +349,26 @@ CONF.import_opt('backup_use_same_host',
 class BaseVD(object):
     """Executes commands relating to Volumes.
 
-       Base Driver for Cinder Volume Control Path,
-       This includes supported/required implementation
-       for API calls.  Also provides *generic* implementation
-       of core features like cloning, copy_image_to_volume etc,
-       this way drivers that inherit from this base class and
-       don't offer their own impl can fall back on a general
-       solution here.
-
-       Key thing to keep in mind with this driver is that it's
-       intended that these drivers ONLY implement Control Path
-       details (create, delete, extend...), while transport or
-       data path related implementation should be a *member object*
-       that we call a connector.  The point here is that for example
-       don't allow the LVM driver to implement iSCSI methods, instead
-       call whatever connector it has configured via conf file
-       (iSCSI{LIO, TGT, IET}, FC, etc).
-
-       In the base class and for example the LVM driver we do this via a has-a
-       relationship and just provide an interface to the specific connector
-       methods.  How you do this in your own driver is of course up to you.
+    Base Driver for Cinder Volume Control Path,
+    This includes supported/required implementation
+    for API calls.  Also provides *generic* implementation
+    of core features like cloning, copy_image_to_volume etc,
+    this way drivers that inherit from this base class and
+    don't offer their own impl can fall back on a general
+    solution here.
+
+    Key thing to keep in mind with this driver is that it's
+    intended that these drivers ONLY implement Control Path
+    details (create, delete, extend...), while transport or
+    data path related implementation should be a *member object*
+    that we call a connector.  The point here is that for example
+    don't allow the LVM driver to implement iSCSI methods, instead
+    call whatever connector it has configured via conf file
+    (iSCSI{LIO, TGT, ET}, FC, etc).
+
+    In the base class and for example the LVM driver we do this via a has-a
+    relationship and just provide an interface to the specific connector
+    methods.  How you do this in your own driver is of course up to you.
     """
     VERSION = "N/A"
 
@@ -418,7 +427,7 @@ class BaseVD(object):
 
         # We set these mappings up in the base driver so they
         # can be used by children
-        # (intended for LVM and BlockDevice, but others could use as well)
+        # (intended for LVM, but others could use as well)
         self.target_mapping = {
             'fake': 'cinder.volume.targets.fake.FakeTarget',
             'ietadm': 'cinder.volume.targets.iet.IetAdm',
@@ -893,12 +902,16 @@ class BaseVD(object):
                                                           enforce_multipath)
         attach_info, volume = self._attach_volume(context, volume, properties)
 
+        # retrieve store information from extra-specs
+        store_id = volume.volume_type.extra_specs.get('image_service:store_id')
+
         try:
             image_utils.upload_volume(context,
                                       image_service,
                                       image_meta,
                                       attach_info['device']['path'],
-                                      compress=True)
+                                      compress=True,
+                                      store_id=store_id)
         finally:
             # Since attached volume was not used for writing we can force
             # detach it
@@ -2510,9 +2523,9 @@ class VolumeDriver(ManageableVD, Cloneab
 class ProxyVD(object):
     """Proxy Volume Driver to mark proxy drivers
 
-        If a driver uses a proxy class (e.g. by using __setattr__ and
-        __getattr__) without directly inheriting from base volume driver this
-        class can help marking them and retrieve the actual used driver object.
+    If a driver uses a proxy class (e.g. by using __setattr__ and
+    __getattr__) without directly inheriting from base volume driver this
+    class can help marking them and retrieve the actual used driver object.
     """
     def _get_driver(self):
         """Returns the actual driver object.
diff -pruN 2:15.0.1-1/cinder/volume/drivers/datera/datera_api21.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/datera/datera_api21.py
--- 2:15.0.1-1/cinder/volume/drivers/datera/datera_api21.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/datera/datera_api21.py	2020-03-24 18:46:31.000000000 +0000
@@ -1,4 +1,4 @@
-# Copyright 2017 Datera
+# Copyright 2020 Datera
 # All Rights Reserved.
 #
 #    Licensed under the Apache License, Version 2.0 (the "License"); you may
@@ -13,27 +13,39 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
+import contextlib
+import ipaddress
+import math
 import random
-import re
+import time
 import uuid
 
 import eventlet
-import ipaddress
-import six
-
+from os_brick import exception as brick_exception
 from oslo_log import log as logging
-from oslo_utils import excutils
+from oslo_serialization import jsonutils as json
+from oslo_utils import importutils
 from oslo_utils import units
+import six
 
 from cinder import exception
 from cinder.i18n import _
-from cinder.volume import volume_utils
-
+from cinder.image import image_utils
+from cinder import utils
 import cinder.volume.drivers.datera.datera_common as datc
+from cinder.volume import volume_types
+from cinder.volume import volume_utils as volutils
 
 LOG = logging.getLogger(__name__)
 
+dexceptions = importutils.try_import('dfs_sdk.exceptions')
 
+API_VERSION = "2.1"
+
+
+# The DateraAPI classes (2.1, 2.2) are enhanced by datera_common's lookup()
+# decorator which generates members run-time. Therefore on the class we disable
+# pylint's no-member check pylint: disable=no-member
 class DateraApi(object):
 
     # =================
@@ -41,34 +53,38 @@ class DateraApi(object):
     # =================
 
     def _create_volume_2_1(self, volume):
-        tenant = self._create_tenant(volume)
         policies = self._get_policies_for_resource(volume)
         num_replicas = int(policies['replica_count'])
-        storage_name = policies['default_storage_name']
-        volume_name = policies['default_volume_name']
+        storage_name = 'storage-1'
+        volume_name = 'volume-1'
         template = policies['template']
         placement = policies['placement_mode']
+        ip_pool = policies['ip_pool']
+
+        name = datc.get_name(volume)
 
         if template:
             app_params = (
                 {
-                    'create_mode': "openstack",
+                    'create_mode': 'openstack',
                     # 'uuid': str(volume['id']),
-                    'name': datc._get_name(volume['id']),
-                    'app_template': '/app_templates/{}'.format(template)
+                    'name': name,
+                    'app_template': {'path': '/app_templates/{}'.format(
+                        template)}
                 })
-
         else:
 
             app_params = (
                 {
-                    'create_mode': "openstack",
+                    'create_mode': 'openstack',
                     'uuid': str(volume['id']),
-                    'name': datc._get_name(volume['id']),
+                    'name': name,
                     'access_control_mode': 'deny_all',
                     'storage_instances': [
                         {
                             'name': storage_name,
+                            'ip_pool': {'path': ('/access_network_ip_pools/'
+                                                 '{}'.format(ip_pool))},
                             'volumes': [
                                 {
                                     'name': volume_name,
@@ -82,103 +98,92 @@ class DateraApi(object):
                         }
                     ]
                 })
-        self._issue_api_request(
-            datc.URL_TEMPLATES['ai'](),
-            'post',
-            body=app_params,
-            api_version='2.1',
-            tenant=tenant)
-        self._update_qos_2_1(volume, policies, tenant)
+
+        tenant = self.create_tenant(volume['project_id'])
+        self.api.app_instances.create(tenant=tenant, **app_params)
+        self._update_qos_2_1(volume, policies)
+        self._add_vol_meta_2_1(volume)
 
     # =================
     # = Extend Volume =
     # =================
 
     def _extend_volume_2_1(self, volume, new_size):
-        tenant = self._create_tenant(volume)
+        if volume['size'] >= new_size:
+            LOG.warning("Volume size not extended due to original size being "
+                        "greater or equal to new size.  Originial: "
+                        "%(original)s, New: %(new)s", {
+                            'original': volume['size'],
+                            'new': new_size})
+            return
         policies = self._get_policies_for_resource(volume)
         template = policies['template']
         if template:
-            LOG.warning("Volume size not extended due to template binding:"
+            LOG.warning("Volume size not extended due to template binding."
                         " volume: %(volume)s, template: %(template)s",
-                        volume=volume, template=template)
+                        {'volume': volume, 'template': template})
             return
 
-        # Offline App Instance, if necessary
-        reonline = False
-        app_inst = self._issue_api_request(
-            datc.URL_TEMPLATES['ai_inst']().format(
-                datc._get_name(volume['id'])),
-            api_version='2.1', tenant=tenant)
-        if app_inst['data']['admin_state'] == 'online':
-            reonline = True
-            self._detach_volume_2_1(None, volume)
-        # Change Volume Size
-        app_inst = datc._get_name(volume['id'])
-        data = {
-            'size': new_size
-        }
-        store_name, vol_name = self._scrape_template(policies)
-        self._issue_api_request(
-            datc.URL_TEMPLATES['vol_inst'](
-                store_name, vol_name).format(app_inst),
-            method='put',
-            body=data,
-            api_version='2.1',
-            tenant=tenant)
-        # Online Volume, if it was online before
-        if reonline:
-            self._create_export_2_1(None, volume, None)
+        with self._offline_flip_2_1(volume):
+            # Change Volume Size
+            tenant = self.get_tenant(volume['project_id'])
+            dvol = self.cvol_to_dvol(volume, tenant=tenant)
+            dvol.set(tenant=tenant, size=new_size)
 
     # =================
     # = Cloned Volume =
     # =================
 
     def _create_cloned_volume_2_1(self, volume, src_vref):
-        policies = self._get_policies_for_resource(volume)
-        tenant = self._create_tenant(volume)
-        store_name, vol_name = self._scrape_template(policies)
-
-        src = "/" + datc.URL_TEMPLATES['vol_inst'](
-            store_name, vol_name).format(datc._get_name(src_vref['id']))
+        tenant = self.get_tenant(volume['project_id'])
+        sdvol = self.cvol_to_dvol(src_vref, tenant=tenant)
+        src = sdvol.path
         data = {
             'create_mode': 'openstack',
-            'name': datc._get_name(volume['id']),
+            'name': datc.get_name(volume),
             'uuid': str(volume['id']),
             'clone_volume_src': {'path': src},
         }
-        self._issue_api_request(
-            datc.URL_TEMPLATES['ai'](), 'post', body=data, api_version='2.1',
-            tenant=tenant)
+        tenant = self.get_tenant(volume['project_id'])
+        self.api.app_instances.create(tenant=tenant, **data)
 
         if volume['size'] > src_vref['size']:
             self._extend_volume_2_1(volume, volume['size'])
+        self._add_vol_meta_2_1(volume)
 
     # =================
     # = Delete Volume =
     # =================
 
     def _delete_volume_2_1(self, volume):
-        self._detach_volume_2_1(None, volume)
-        tenant = self._create_tenant(volume)
-        app_inst = datc._get_name(volume['id'])
         try:
-            self._issue_api_request(
-                datc.URL_TEMPLATES['ai_inst']().format(app_inst),
-                method='delete',
-                api_version='2.1',
-                tenant=tenant)
+            tenant = self.get_tenant(volume['project_id'])
+            ai = self.cvol_to_ai(volume, tenant=tenant)
+            si = ai.storage_instances.list(tenant=tenant)[0]
+
+            # Clear out ACL
+            acl = si.acl_policy.get(tenant=tenant)
+            acl.set(tenant=tenant, initiators=[])
+
+            # Bring volume offline
+            data = {
+                'admin_state': 'offline',
+                'force': True
+            }
+            ai.set(tenant=tenant, **data)
+
+            ai.delete(tenant=tenant, force=True)
         except exception.NotFound:
             msg = ("Tried to delete volume %s, but it was not found in the "
                    "Datera cluster. Continuing with delete.")
-            LOG.info(msg, datc._get_name(volume['id']))
+            LOG.info(msg, datc.get_name(volume))
 
     # =================
     # = Ensure Export =
     # =================
 
     def _ensure_export_2_1(self, context, volume, connector=None):
-        self.create_export(context, volume, connector)
+        pass
 
     # =========================
     # = Initialize Connection =
@@ -187,29 +192,25 @@ class DateraApi(object):
     def _initialize_connection_2_1(self, volume, connector):
         # Now online the app_instance (which will online all storage_instances)
         multipath = connector.get('multipath', False)
-        tenant = self._create_tenant(volume)
-        url = datc.URL_TEMPLATES['ai_inst']().format(
-            datc._get_name(volume['id']))
+        tenant = self.get_tenant(volume['project_id'])
+        ai = self.cvol_to_ai(volume, tenant=tenant)
         data = {
             'admin_state': 'online'
         }
-        app_inst = self._issue_api_request(
-            url, method='put', body=data, api_version='2.1', tenant=tenant)[
-            'data']
-        storage_instances = app_inst["storage_instances"]
-        si = storage_instances[0]
+        ai.set(tenant=tenant, **data)
+        si = ai.storage_instances.list(tenant=tenant)[0]
 
         # randomize portal chosen
         choice = 0
         policies = self._get_policies_for_resource(volume)
         if policies["round_robin"]:
             choice = random.randint(0, 1)
-        portal = si['access']['ips'][choice] + ':3260'
-        iqn = si['access']['iqn']
+        portal = si.access['ips'][choice] + ':3260'
+        iqn = si.access['iqn']
         if multipath:
-            portals = [p + ':3260' for p in si['access']['ips']]
-            iqns = [iqn for _ in si['access']['ips']]
-            lunids = [self._get_lunid() for _ in si['access']['ips']]
+            portals = [p + ':3260' for p in si.access['ips']]
+            iqns = [iqn for _ in si.access['ips']]
+            lunids = [self._get_lunid() for _ in si.access['ips']]
 
             result = {
                 'driver_volume_type': 'iscsi',
@@ -234,6 +235,12 @@ class DateraApi(object):
                     'volume_id': volume['id'],
                     'discard': False}}
 
+        if self.use_chap_auth:
+            result['data'].update(
+                auth_method="CHAP",
+                auth_username=self.chap_username,
+                auth_password=self.chap_password)
+
         return result
 
     # =================
@@ -241,291 +248,224 @@ class DateraApi(object):
     # =================
 
     def _create_export_2_1(self, context, volume, connector):
-        tenant = self._create_tenant(volume)
-        url = datc.URL_TEMPLATES['ai_inst']().format(
-            datc._get_name(volume['id']))
+        tenant = self.get_tenant(volume['project_id'])
+        ai = self.cvol_to_ai(volume, tenant=tenant)
         data = {
             'admin_state': 'offline',
             'force': True
         }
-        self._issue_api_request(
-            url, method='put', body=data, api_version='2.1', tenant=tenant)
+        ai.set(tenant=tenant, **data)
+        si = ai.storage_instances.list(tenant=tenant)[0]
         policies = self._get_policies_for_resource(volume)
-        store_name, _ = self._scrape_template(policies)
         if connector and connector.get('ip'):
             # Case where volume_type has non default IP Pool info
             if policies['ip_pool'] != 'default':
-                initiator_ip_pool_path = self._issue_api_request(
-                    "access_network_ip_pools/{}".format(
-                        policies['ip_pool']),
-                    api_version='2.1',
-                    tenant=tenant)['path']
+                initiator_ip_pool_path = self.api.access_network_ip_pools.get(
+                    policies['ip_pool']).path
             # Fallback to trying reasonable IP based guess
             else:
                 initiator_ip_pool_path = self._get_ip_pool_for_string_ip_2_1(
-                    connector['ip'])
+                    connector['ip'], tenant)
 
-            ip_pool_url = datc.URL_TEMPLATES['si_inst'](
-                store_name).format(datc._get_name(volume['id']))
             ip_pool_data = {'ip_pool': {'path': initiator_ip_pool_path}}
-            self._issue_api_request(ip_pool_url,
-                                    method="put",
-                                    body=ip_pool_data,
-                                    api_version='2.1',
-                                    tenant=tenant)
-        url = datc.URL_TEMPLATES['ai_inst']().format(
-            datc._get_name(volume['id']))
+            si.set(tenant=tenant, **ip_pool_data)
         data = {
             'admin_state': 'online'
         }
-        self._issue_api_request(
-            url, method='put', body=data, api_version='2.1', tenant=tenant)
+        ai.set(tenant=tenant, **data)
         # Check if we've already setup everything for this volume
-        url = (datc.URL_TEMPLATES['si']().format(datc._get_name(volume['id'])))
-        storage_instances = self._issue_api_request(
-            url, api_version='2.1', tenant=tenant)
+        storage_instances = ai.storage_instances.list(tenant=tenant)
         # Handle adding initiator to product if necessary
         # Then add initiator to ACL
-        if (connector and
-                connector.get('initiator') and
-                not policies['acl_allow_all']):
-            initiator_name = "OpenStack_{}_{}".format(
-                self.driver_prefix, str(uuid.uuid4())[:4])
-            initiator_group = datc.INITIATOR_GROUP_PREFIX + str(uuid.uuid4())
-            found = False
+        if connector and connector.get('initiator'):
+            initiator_name = "OpenStack-{}".format(str(uuid.uuid4())[:8])
             initiator = connector['initiator']
-            if not found:
-                data = {'id': initiator, 'name': initiator_name}
-                # Try and create the initiator
-                # If we get a conflict, ignore it
-                self._issue_api_request("initiators",
-                                        method="post",
-                                        body=data,
-                                        conflict_ok=True,
-                                        api_version='2.1',
-                                        tenant=tenant)
-            # Create initiator group with initiator in it
-            initiator_path = "/initiators/{}".format(initiator)
-            initiator_group_path = "/initiator_groups/{}".format(
-                initiator_group)
-            ig_data = {'name': initiator_group,
-                       'members': [{'path': initiator_path}]}
-            self._issue_api_request("initiator_groups",
-                                    method="post",
-                                    body=ig_data,
-                                    conflict_ok=True,
-                                    api_version='2.1',
-                                    tenant=tenant)
+            dinit = None
+            data = {'id': initiator, 'name': initiator_name}
+            # Try and create the initiator
+            # If we get a conflict, ignore it
+            try:
+                dinit = self.api.initiators.create(tenant=tenant, **data)
+            except dexceptions.ApiConflictError:
+                dinit = self.api.initiators.get(initiator, tenant=tenant)
+            initiator_path = dinit['path']
             # Create ACL with initiator group as reference for each
             # storage_instance in app_instance
             # TODO(_alastor_): We need to avoid changing the ACLs if the
             # template already specifies an ACL policy.
-            for si in storage_instances['data']:
-                acl_url = (datc.URL_TEMPLATES['si']() +
-                           "/{}/acl_policy").format(
-                    datc._get_name(volume['id']), si['name'])
-                existing_acl = self._issue_api_request(acl_url,
-                                                       method="get",
-                                                       api_version='2.1',
-                                                       tenant=tenant)['data']
+            for si in storage_instances:
+                existing_acl = si.acl_policy.get(tenant=tenant)
                 data = {}
-                data['initiators'] = existing_acl['initiators']
-                data['initiator_groups'] = existing_acl['initiator_groups']
-                data['initiator_groups'].append({"path": initiator_group_path})
-                self._issue_api_request(acl_url,
-                                        method="put",
-                                        body=data,
-                                        api_version='2.1',
-                                        tenant=tenant)
+                # Grabbing only the 'path' key from each existing initiator
+                # within the existing acl. eacli --> existing acl initiator
+                eacli = []
+                for acl in existing_acl['initiators']:
+                    nacl = {}
+                    nacl['path'] = acl['path']
+                    eacli.append(nacl)
+                data['initiators'] = eacli
+                data['initiators'].append({"path": initiator_path})
+                # Grabbing only the 'path' key from each existing initiator
+                # group within the existing acl. eaclig --> existing
+                # acl initiator group
+                eaclig = []
+                for acl in existing_acl['initiator_groups']:
+                    nacl = {}
+                    nacl['path'] = acl['path']
+                    eaclig.append(nacl)
+                data['initiator_groups'] = eaclig
+                si.acl_policy.set(tenant=tenant, **data)
+        if self.use_chap_auth:
+            for si in storage_instances:
+                data = {'type': 'chap',
+                        'target_user_name': self.chap_username,
+                        'target_pswd': self.chap_password}
+                si.auth.set(tenant=tenant, **data)
         # Check to ensure we're ready for go-time
-        self._si_poll_2_1(volume, policies, tenant)
+        self._si_poll_2_1(volume, si, tenant)
+        self._add_vol_meta_2_1(volume, connector=connector)
 
     # =================
     # = Detach Volume =
     # =================
 
     def _detach_volume_2_1(self, context, volume, attachment=None):
-        tenant = self._create_tenant(volume)
-        url = datc.URL_TEMPLATES['ai_inst']().format(
-            datc._get_name(volume['id']))
-        data = {
-            'admin_state': 'offline',
-            'force': True
-        }
         try:
-            self._issue_api_request(url, method='put', body=data,
-                                    api_version='2.1', tenant=tenant)
+            tenant = self.get_tenant(volume['project_id'])
+            ai = self.cvol_to_ai(volume, tenant=tenant)
+            # Clear out ACL for this specific attachment
+            si = ai.storage_instances.list(tenant=tenant)[0]
+            existing_acl = si.acl_policy.get(tenant=tenant)
+            data = {}
+            # Grabbing only the 'path' key from each existing initiator
+            # within the existing acl. eacli --> existing acl initiator
+            eacli = []
+            for acl in existing_acl['initiators']:
+                if (
+                    attachment is not None
+                    and attachment.connector is not None
+                    and acl['path'].split('/')[-1]
+                    == attachment.connector['initiator']
+                ):
+                    continue
+                nacl = {}
+                nacl['path'] = acl['path']
+                eacli.append(nacl)
+            data['initiators'] = eacli
+            data['initiator_groups'] = existing_acl['initiator_groups']
+            si.acl_policy.set(tenant=tenant, **data)
+
+            if not eacli:
+                # bring the application instance offline if there
+                # are no initiators left.
+                data = {
+                    'admin_state': 'offline',
+                    'force': True
+                }
+                ai.set(tenant=tenant, **data)
+
         except exception.NotFound:
             msg = ("Tried to detach volume %s, but it was not found in the "
                    "Datera cluster. Continuing with detach.")
             LOG.info(msg, volume['id'])
-        # TODO(_alastor_): Make acl cleaning multi-attach aware
-        self._clean_acl_2_1(volume, tenant)
-
-    def _check_for_acl_2_1(self, initiator_path):
-        """Returns True if an acl is found for initiator_path """
-        # TODO(_alastor_) when we get a /initiators/:initiator/acl_policies
-        # endpoint use that instead of this monstrosity
-        initiator_groups = self._issue_api_request("initiator_groups",
-                                                   api_version='2.1')
-        for ig, igdata in initiator_groups.items():
-            if initiator_path in igdata['members']:
-                LOG.debug("Found initiator_group: %s for initiator: %s",
-                          ig, initiator_path)
-                return True
-        LOG.debug("No initiator_group found for initiator: %s", initiator_path)
-        return False
-
-    def _clean_acl_2_1(self, volume, tenant):
-        policies = self._get_policies_for_resource(volume)
-
-        store_name, _ = self._scrape_template(policies)
-
-        acl_url = (datc.URL_TEMPLATES["si_inst"](
-            store_name) + "/acl_policy").format(datc._get_name(volume['id']))
-        try:
-            initiator_group = self._issue_api_request(
-                acl_url, api_version='2.1', tenant=tenant)['data'][
-                    'initiator_groups'][0]['path']
-            # TODO(_alastor_): Re-enable this when we get a force-delete
-            # option on the /initiators endpoint
-            # initiator_iqn_path = self._issue_api_request(
-            #     initiator_group.lstrip("/"), api_version='2.1',
-            #     tenant=tenant)[
-            #         "data"]["members"][0]["path"]
-            # Clear out ACL and delete initiator group
-            self._issue_api_request(acl_url,
-                                    method="put",
-                                    body={'initiator_groups': []},
-                                    api_version='2.1',
-                                    tenant=tenant)
-            self._issue_api_request(initiator_group.lstrip("/"),
-                                    method="delete",
-                                    api_version='2.1',
-                                    tenant=tenant)
-            # TODO(_alastor_): Re-enable this when we get a force-delete
-            # option on the /initiators endpoint
-            # if not self._check_for_acl_2_1(initiator_iqn_path):
-            #     self._issue_api_request(initiator_iqn_path.lstrip("/"),
-            #                             method="delete",
-            #                             api_version='2.1',
-            #                             tenant=tenant)
-        except (IndexError, exception.NotFound):
-            LOG.debug("Did not find any initiator groups for volume: %s",
-                      volume)
 
     # ===================
     # = Create Snapshot =
     # ===================
 
     def _create_snapshot_2_1(self, snapshot):
-        tenant = self._create_tenant(snapshot)
-        policies = self._get_policies_for_resource(snapshot)
-
-        store_name, vol_name = self._scrape_template(policies)
-
-        url_template = datc.URL_TEMPLATES['vol_inst'](
-            store_name, vol_name) + '/snapshots'
-        url = url_template.format(datc._get_name(snapshot['volume_id']))
 
+        dummy_vol = {'id': snapshot['volume_id'],
+                     'project_id': snapshot['project_id']}
+        tenant = self.get_tenant(dummy_vol['project_id'])
+        dvol = self.cvol_to_dvol(dummy_vol, tenant=tenant)
         snap_params = {
             'uuid': snapshot['id'],
         }
-        snap = self._issue_api_request(url, method='post', body=snap_params,
-                                       api_version='2.1', tenant=tenant)
-        snapu = "/".join((url, snap['data']['timestamp']))
-        self._snap_poll_2_1(snapu, tenant)
+        snap = dvol.snapshots.create(tenant=tenant, **snap_params)
+        self._snap_poll_2_1(snap, tenant)
 
     # ===================
     # = Delete Snapshot =
     # ===================
 
     def _delete_snapshot_2_1(self, snapshot):
-        tenant = self._create_tenant(snapshot)
-        policies = self._get_policies_for_resource(snapshot)
-
-        store_name, vol_name = self._scrape_template(policies)
+        # Handle case where snapshot is "managed"
+        dummy_vol = {'id': snapshot['volume_id'],
+                     'project_id': snapshot['project_id']}
+        tenant = self.get_tenant(dummy_vol['project_id'])
+        dvol = self.cvol_to_dvol(dummy_vol, tenant=tenant)
+
+        snapshots = None
+
+        # Shortcut if this is a managed snapshot
+        provider_location = snapshot.get('provider_location')
+        if provider_location:
+            snap = dvol.snapshots.get(provider_location, tenant=tenant)
+            snap.delete(tenant=tenant)
+            return
 
-        snap_temp = datc.URL_TEMPLATES['vol_inst'](
-            store_name, vol_name) + '/snapshots'
-        snapu = snap_temp.format(datc._get_name(snapshot['volume_id']))
-        snapshots = []
+        # Long-way.  UUID identification
         try:
-            snapshots = self._issue_api_request(snapu,
-                                                method='get',
-                                                api_version='2.1',
-                                                tenant=tenant)
+            snapshots = dvol.snapshots.list(tenant=tenant)
         except exception.NotFound:
             msg = ("Tried to delete snapshot %s, but parent volume %s was "
                    "not found in Datera cluster. Continuing with delete.")
             LOG.info(msg,
-                     datc._get_name(snapshot['id']),
-                     datc._get_name(snapshot['volume_id']))
+                     datc.get_name(snapshot),
+                     datc.get_name({'id': snapshot['volume_id']}))
             return
 
         try:
-            for snap in snapshots['data']:
-                if snap['uuid'] == snapshot['id']:
-                    url_template = snapu + '/{}'
-                    url = url_template.format(snap['timestamp'])
-                    self._issue_api_request(
-                        url,
-                        method='delete',
-                        api_version='2.1',
-                        tenant=tenant)
+            for snap in snapshots:
+                if snap.uuid == snapshot['id']:
+                    snap.delete(tenant=tenant)
                     break
             else:
                 raise exception.NotFound
         except exception.NotFound:
             msg = ("Tried to delete snapshot %s, but was not found in "
                    "Datera cluster. Continuing with delete.")
-            LOG.info(msg, datc._get_name(snapshot['id']))
+            LOG.info(msg, datc.get_name(snapshot))
 
     # ========================
     # = Volume From Snapshot =
     # ========================
 
     def _create_volume_from_snapshot_2_1(self, volume, snapshot):
-        tenant = self._create_tenant(volume)
-        policies = self._get_policies_for_resource(snapshot)
-
-        store_name, vol_name = self._scrape_template(policies)
-
-        snap_temp = datc.URL_TEMPLATES['vol_inst'](
-            store_name, vol_name) + '/snapshots'
-        snapu = snap_temp.format(datc._get_name(snapshot['volume_id']))
-        snapshots = self._issue_api_request(
-            snapu, method='get', api_version='2.1', tenant=tenant)
-
-        for snap in snapshots['data']:
-            if snap['uuid'] == snapshot['id']:
-                found_ts = snap['utc_ts']
-                break
+        # Handle case where snapshot is "managed"
+        dummy_vol = {'id': snapshot['volume_id'],
+                     'project_id': snapshot['project_id']}
+        tenant = self.get_tenant(dummy_vol['project_id'])
+        dvol = self.cvol_to_dvol(dummy_vol, tenant=tenant)
+        found_snap = None
+        provider_location = snapshot.get('provider_location')
+        if provider_location:
+            found_snap = dvol.snapshots.get(provider_location, tenant=tenant)
         else:
-            raise exception.NotFound
-
-        snap_url = (snap_temp + '/{}').format(
-            datc._get_name(snapshot['volume_id']), found_ts)
+            snapshots = dvol.snapshots.list(tenant=tenant)
+            for snap in snapshots:
+                if snap.uuid == snapshot['id']:
+                    found_snap = snap
+                    break
+            else:
+                raise exception.SnapshotNotFound(snapshot_id=snapshot['id'])
 
-        self._snap_poll_2_1(snap_url, tenant)
+        self._snap_poll_2_1(found_snap, tenant)
 
-        src = "/" + snap_url
+        src = found_snap.path
         app_params = (
             {
                 'create_mode': 'openstack',
                 'uuid': str(volume['id']),
-                'name': datc._get_name(volume['id']),
+                'name': datc.get_name(volume),
                 'clone_snapshot_src': {'path': src},
             })
-        self._issue_api_request(
-            datc.URL_TEMPLATES['ai'](),
-            method='post',
-            body=app_params,
-            api_version='2.1',
-            tenant=tenant)
 
+        self.api.app_instances.create(tenant=tenant, **app_params)
         if (volume['size'] > snapshot['volume_size']):
             self._extend_volume_2_1(volume, volume['size'])
+        self._add_vol_meta_2_1(volume)
 
     # ==========
     # = Retype =
@@ -542,7 +482,7 @@ class DateraApi(object):
         # And that backend matches this driver
         old_pol = self._get_policies_for_resource(volume)
         new_pol = self._get_policies_for_volume_type(new_type)
-        if (host['capabilities']['vendor_name'].lower() ==
+        if (host['capabilities']['volume_backend_name'].lower() ==
                 self.backend_name.lower()):
             LOG.debug("Starting fast volume retype")
 
@@ -552,19 +492,26 @@ class DateraApi(object):
                     "unsupported.  Type1: %s, Type2: %s",
                     volume['volume_type_id'], new_type)
 
-            tenant = self._create_tenant(volume)
-            self._update_qos_2_1(volume, new_pol, tenant)
-            vol_params = (
-                {
-                    'placement_mode': new_pol['placement_mode'],
-                    'replica_count': new_pol['replica_count'],
-                })
-            url = datc.URL_TEMPLATES['vol_inst'](
-                old_pol['default_storage_name'],
-                old_pol['default_volume_name']).format(
-                    datc._get_name(volume['id']))
-            self._issue_api_request(url, method='put', body=vol_params,
-                                    api_version='2.1', tenant=tenant)
+            self._update_qos_2_1(volume, new_pol, clear_old=True)
+            tenant = self.get_tenant(volume['project_id'])
+            dvol = self.cvol_to_dvol(volume, tenant=tenant)
+            # Only replica_count ip_pool requires offlining the app_instance
+            if (new_pol['replica_count'] != old_pol['replica_count'] or
+                    new_pol['ip_pool'] != old_pol['ip_pool']):
+                with self._offline_flip_2_1(volume):
+                    vol_params = (
+                        {
+                            'placement_mode': new_pol['placement_mode'],
+                            'replica_count': new_pol['replica_count'],
+                        })
+                    dvol.set(tenant=tenant, **vol_params)
+            elif new_pol['placement_mode'] != old_pol['placement_mode']:
+                vol_params = (
+                    {
+                        'placement_mode': new_pol['placement_mode'],
+                    })
+                dvol.set(tenant=tenant, **vol_params)
+            self._add_vol_meta_2_1(volume)
             return True
 
         else:
@@ -577,99 +524,54 @@ class DateraApi(object):
 
     def _manage_existing_2_1(self, volume, existing_ref):
         # Only volumes created under the requesting tenant can be managed in
-        # the v2.1 API.  Eg.  If tenant A is the tenant for the volume to be
+        # the v2.1+ API.  Eg.  If tenant A is the tenant for the volume to be
         # managed, it must also be tenant A that makes this request.
         # This will be fixed in a later API update
-        tenant = self._create_tenant(volume)
         existing_ref = existing_ref['source-name']
-        if existing_ref.count(":") not in (2, 3):
-            raise exception.ManageExistingInvalidReference(
-                _("existing_ref argument must be of this format: "
-                  "tenant:app_inst_name:storage_inst_name:vol_name or "
-                  "app_inst_name:storage_inst_name:vol_name"))
-        app_inst_name = existing_ref.split(":")[0]
-        try:
-            (tenant, app_inst_name, storage_inst_name,
-                vol_name) = existing_ref.split(":")
-        except TypeError:
-            app_inst_name, storage_inst_name, vol_name = existing_ref.split(
-                ":")
-            tenant = None
+        app_inst_name, __, __, __ = datc._parse_vol_ref(existing_ref)
         LOG.debug("Managing existing Datera volume %s  "
                   "Changing name to %s",
-                  datc._get_name(volume['id']), existing_ref)
-        data = {'name': datc._get_name(volume['id'])}
-        self._issue_api_request(datc.URL_TEMPLATES['ai_inst']().format(
-            app_inst_name), method='put', body=data, api_version='2.1',
-            tenant=tenant)
+                  datc.get_name(volume), existing_ref)
+        # Rename AppInstance
+        dummy_vol = {'id': app_inst_name,
+                     'project_id': volume['project_id']}
+        tenant = self.get_tenant(volume['project_id'])
+        ai = self.cvol_to_ai(dummy_vol, tenant=tenant)
+        data = {'name': datc.get_name(volume)}
+        ai.set(tenant=tenant, **data)
+        self._add_vol_meta_2_1(volume)
 
     # ===================
     # = Manage Get Size =
     # ===================
 
     def _manage_existing_get_size_2_1(self, volume, existing_ref):
-        tenant = self._create_tenant(volume)
         existing_ref = existing_ref['source-name']
-        if existing_ref.count(":") != 2:
-            raise exception.ManageExistingInvalidReference(
-                _("existing_ref argument must be of this format:"
-                  "app_inst_name:storage_inst_name:vol_name"))
-        app_inst_name, si_name, vol_name = existing_ref.split(":")
-        app_inst = self._issue_api_request(
-            datc.URL_TEMPLATES['ai_inst']().format(app_inst_name),
-            api_version='2.1', tenant=tenant)
-        return self._get_size_2_1(
-            volume, tenant, app_inst, si_name, vol_name)
-
-    def _get_size_2_1(self, volume, tenant=None, app_inst=None, si_name=None,
-                      vol_name=None):
-        """Helper method for getting the size of a backend object
-
-        If app_inst is provided, we'll just parse the dict to get
-        the size instead of making a separate http request
-        """
-        policies = self._get_policies_for_resource(volume)
-        si_name = si_name if si_name else policies['default_storage_name']
-        vol_name = vol_name if vol_name else policies['default_volume_name']
-        if not app_inst:
-            vol_url = datc.URL_TEMPLATES['ai_inst']().format(
-                datc._get_name(volume['id']))
-            app_inst = self._issue_api_request(
-                vol_url, api_version='2.1', tenant=tenant)['data']
-        if 'data' in app_inst:
-            app_inst = app_inst['data']
-        sis = app_inst['storage_instances']
-        found_si = None
-        for si in sis:
-            if si['name'] == si_name:
-                found_si = si
-                break
-        found_vol = None
-        for vol in found_si['volumes']:
-            if vol['name'] == vol_name:
-                found_vol = vol
-        size = found_vol['size']
-        return size
+        app_inst_name, storage_inst_name, vol_name, __ = datc._parse_vol_ref(
+            existing_ref)
+        dummy_vol = {'id': app_inst_name,
+                     'project_id': volume['project_id']}
+        dvol = self.cvol_to_dvol(dummy_vol)
+        return dvol.size
 
     # =========================
     # = Get Manageable Volume =
     # =========================
 
-    def _get_manageable_volumes_2_1(self, cinder_volumes, marker, limit,
-                                    offset, sort_keys, sort_dirs):
+    def _list_manageable_2_1(self, cinder_volumes):
         # Use the first volume to determine the tenant we're working under
         if cinder_volumes:
-            tenant = self._create_tenant(cinder_volumes[0])
+            tenant = self.get_tenant(cinder_volumes[0]['project_id'])
         else:
             tenant = None
-        LOG.debug("Listing manageable Datera volumes")
-        app_instances = self._issue_api_request(
-            datc.URL_TEMPLATES['ai'](), api_version='2.1',
-            tenant=tenant)['data']
+        app_instances = self.api.app_instances.list(tenant=tenant)
 
         results = []
 
-        cinder_volume_ids = [vol['id'] for vol in cinder_volumes]
+        if cinder_volumes and 'volume_id' in cinder_volumes[0]:
+            cinder_volume_ids = [vol['volume_id'] for vol in cinder_volumes]
+        else:
+            cinder_volume_ids = [vol['id'] for vol in cinder_volumes]
 
         for ai in app_instances:
             ai_name = ai['name']
@@ -678,20 +580,20 @@ class DateraApi(object):
             safe_to_manage = False
             reason_not_safe = ""
             cinder_id = None
-            extra_info = None
-            if re.match(datc.UUID4_RE, ai_name):
-                cinder_id = ai_name.lstrip(datc.OS_PREFIX)
-            if (not cinder_id and
-                    ai_name.lstrip(datc.OS_PREFIX) not in cinder_volume_ids):
-                safe_to_manage, reason_not_safe = self._is_manageable_2_1(ai)
-            if safe_to_manage:
-                si = list(ai['storage_instances'].values())[0]
-                si_name = si['name']
-                vol = list(si['volumes'].values())[0]
-                vol_name = vol['name']
-                size = vol['size']
-                reference = {"source-name": "{}:{}:{}".format(
-                    ai_name, si_name, vol_name)}
+            extra_info = {}
+            (safe_to_manage, reason_not_safe,
+                cinder_id) = self._is_manageable_2_1(
+                    ai, cinder_volume_ids, tenant)
+            si = ai.storage_instances.list(tenant=tenant)[0]
+            si_name = si.name
+            vol = si.volumes.list(tenant=tenant)[0]
+            vol_name = vol.name
+            size = vol.size
+            snaps = [(snap.utc_ts, snap.uuid)
+                     for snap in vol.snapshots.list(tenant=tenant)]
+            extra_info["snapshots"] = json.dumps(snaps)
+            reference = {"source-name": "{}:{}:{}".format(
+                ai_name, si_name, vol_name)}
 
             results.append({
                 'reference': reference,
@@ -700,112 +602,335 @@ class DateraApi(object):
                 'reason_not_safe': reason_not_safe,
                 'cinder_id': cinder_id,
                 'extra_info': extra_info})
+        return results
 
-        page_results = volume_utils.paginate_entries_list(
+    def _get_manageable_volumes_2_1(self, cinder_volumes, marker, limit,
+                                    offset, sort_keys, sort_dirs):
+        LOG.debug("Listing manageable Datera volumes")
+        results = self._list_manageable_2_1(cinder_volumes)
+        page_results = volutils.paginate_entries_list(
             results, marker, limit, offset, sort_keys, sort_dirs)
 
         return page_results
 
-    def _is_manageable_2_1(self, app_inst):
-        if len(app_inst['storage_instances']) == 1:
-            si = list(app_inst['storage_instances'].values())[0]
+    def _is_manageable_2_1(self, ai, cinder_volume_ids, tenant):
+        cinder_id = None
+        ai_name = ai.name
+        match = datc.UUID4_RE.match(ai_name)
+        if match:
+            cinder_id = match.group(1)
+        if cinder_id and cinder_id in cinder_volume_ids:
+            return (False,
+                    "App Instance already managed by Cinder",
+                    cinder_id)
+        if len(ai.storage_instances.list(tenant=tenant)) == 1:
+            si = ai.storage_instances.list(tenant=tenant)[0]
             if len(si['volumes']) == 1:
-                return (True, "")
+                return (True, "", cinder_id)
         return (False,
-                "App Instance has more than one storage instance or volume")
+                "App Instance has more than one storage instance or volume",
+                cinder_id)
     # ============
     # = Unmanage =
     # ============
 
     def _unmanage_2_1(self, volume):
-        tenant = self._create_tenant(volume)
         LOG.debug("Unmanaging Cinder volume %s.  Changing name to %s",
-                  volume['id'], datc._get_unmanaged(volume['id']))
-        data = {'name': datc._get_unmanaged(volume['id'])}
-        self._issue_api_request(datc.URL_TEMPLATES['ai_inst']().format(
-            datc._get_name(volume['id'])),
-            method='put',
-            body=data,
-            api_version='2.1',
-            tenant=tenant)
+                  volume['id'], datc.get_unmanaged(volume['id']))
+        data = {'name': datc.get_unmanaged(volume['id'])}
+        tenant = self.get_tenant(volume['project_id'])
+        ai = self.cvol_to_ai(volume, tenant=tenant)
+        ai.set(tenant=tenant, **data)
 
-    # ================
-    # = Volume Stats =
-    # ================
+    # ===================
+    # = Manage Snapshot =
+    # ===================
 
-    # =========
-    # = Login =
-    # =========
+    def _manage_existing_snapshot_2_1(self, snapshot, existing_ref):
+        existing_ref = existing_ref['source-name']
+        datc._check_snap_ref(existing_ref)
+        LOG.debug("Managing existing Datera volume snapshot %s for volume %s",
+                  existing_ref, datc.get_name({'id': snapshot['volume_id']}))
+        return {'provider_location': existing_ref}
 
-    # ===========
-    # = Tenancy =
-    # ===========
+    def _manage_existing_snapshot_get_size_2_1(self, snapshot, existing_ref):
+        existing_ref = existing_ref['source-name']
+        datc._check_snap_ref(existing_ref)
+        dummy_vol = {'id': snapshot['volume_id'],
+                     'project_id': snapshot['project_id']}
+        dvol = self.cvol_to_dvol(dummy_vol)
+        return dvol.size
+
+    def _get_manageable_snapshots_2_1(self, cinder_snapshots, marker, limit,
+                                      offset, sort_keys, sort_dirs):
+        LOG.debug("Listing manageable Datera snapshots")
+        results = self._list_manageable_2_1(cinder_snapshots)
+        snap_results = []
+        snapids = set((snap['id'] for snap in cinder_snapshots))
+        snaprefs = set((snap.get('provider_location')
+                        for snap in cinder_snapshots))
+        for volume in results:
+            snaps = json.loads(volume["extra_info"]["snapshots"])
+            for snapshot in snaps:
+                reference = snapshot[0]
+                uuid = snapshot[1]
+                size = volume["size"]
+                safe_to_manage = True
+                reason_not_safe = ""
+                cinder_id = ""
+                extra_info = {}
+                source_reference = volume["reference"]
+                if uuid in snapids or reference in snaprefs:
+                    safe_to_manage = False
+                    reason_not_safe = _("already managed by Cinder")
+                elif not volume['safe_to_manage'] and not volume['cinder_id']:
+                    safe_to_manage = False
+                    reason_not_safe = _("parent volume not safe to manage")
+                snap_results.append({
+                    'reference': {'source-name': reference},
+                    'size': size,
+                    'safe_to_manage': safe_to_manage,
+                    'reason_not_safe': reason_not_safe,
+                    'cinder_id': cinder_id,
+                    'extra_info': extra_info,
+                    'source_reference': source_reference})
+        page_results = volutils.paginate_entries_list(
+            snap_results, marker, limit, offset, sort_keys, sort_dirs)
 
-    def _create_tenant(self, volume=None):
-        # Create the Datera tenant if specified in the config
-        # Otherwise use the tenant provided
-        if self.tenant_id is None:
-            tenant = None
-        elif self.tenant_id.lower() == "map" and volume:
-            # Convert dashless uuid to uuid with dashes
-            # Eg: 0e33e95a9b154d348c675a1d8ea5b651 -->
-            #       0e33e95a-9b15-4d34-8c67-5a1d8ea5b651
-            tenant = datc._get_name(str(uuid.UUID(volume["project_id"])))
-        elif self.tenant_id.lower() == "map" and not volume:
-            tenant = None
-        else:
-            tenant = self.tenant_id
+        return page_results
 
-        if tenant:
-            params = {'name': tenant}
-            self._issue_api_request(
-                'tenants', method='post', body=params, conflict_ok=True,
-                api_version='2.1')
-        return tenant
-
-    # =========
-    # = Login =
-    # =========
-
-    def _login_2_1(self):
-        """Use the san_login and san_password to set token."""
-        body = {
-            'name': self.username,
-            'password': self.password
-        }
+    def _unmanage_snapshot_2_1(self, snapshot):
+        return {'provider_location': None}
 
-        # Unset token now, otherwise potential expired token will be sent
-        # along to be used for authorization when trying to login.
-        self.datera_api_token = None
+    # ====================
+    # = Fast Image Clone =
+    # ====================
+
+    def _clone_image_2_1(self, context, volume, image_location, image_meta,
+                         image_service):
+        # We're not going to fast image clone if the feature is not enabled
+        # and/or we can't reach the image being requested
+        if (not self.image_cache or
+                not self._image_accessible(context, volume, image_meta)):
+            return None, False
+        # Check to make sure we're working with a valid volume type
+        try:
+            found = volume_types.get_volume_type(context, self.image_type)
+        except (exception.VolumeTypeNotFound, exception.InvalidVolumeType):
+            found = None
+        if not found:
+            msg = "Invalid volume type: %s"
+            LOG.error(msg, self.image_type)
+            raise ValueError(_("Option datera_image_cache_volume_type_id must"
+                               " be set to a valid volume_type id"))
+        # Check image format
+        fmt = image_meta.get('disk_format', '')
+        if fmt.lower() != 'raw':
+            LOG.debug("Image format is not RAW, image requires conversion "
+                      "before clone.  Image format: [%s]", fmt)
+            return None, False
+
+        LOG.debug("Starting fast image clone")
+        # TODO(_alastor_): determine if Datera is already an image backend
+        # for this request and direct clone instead of caching
+
+        # Dummy volume, untracked by Cinder
+        src_vol = {'id': image_meta['id'],
+                   'volume_type_id': self.image_type,
+                   'size': volume['size'],
+                   'project_id': volume['project_id']}
+
+        # Determine if we have a cached version of the image
+        cached = self._vol_exists_2_1(src_vol)
+
+        if cached:
+            tenant = self.get_tenant(src_vol['project_id'])
+            ai = self.cvol_to_ai(src_vol, tenant=tenant)
+            metadata = ai.metadata.get(tenant=tenant)
+            # Check to see if the master image has changed since we created
+            # The cached version
+            ts = self._get_vol_timestamp_2_1(src_vol)
+            mts = time.mktime(image_meta['updated_at'].timetuple())
+            LOG.debug("Original image timestamp: %s, cache timestamp %s",
+                      mts, ts)
+            # If the image is created by Glance, we'll trust that even if the
+            # timestamps don't match up, the data is ok to clone as it's not
+            # managed by this driver
+            if metadata.get('type') == 'image':
+                LOG.debug("Found Glance volume-backed image for %s",
+                          src_vol['id'])
+            # If the master image time is greater than the volume creation
+            # time, we invalidate the cache and delete the volume.  The
+            # exception is if the cached volume was created by Glance.  We
+            # NEVER want to delete this volume.  It's annotated with
+            # 'type': 'image' in the metadata, so we'll check for that
+            elif mts > ts and metadata.get('type') != 'image':
+                LOG.debug("Cache is older than original image, deleting cache")
+                cached = False
+                self._delete_volume_2_1(src_vol)
+
+        # If we don't have the image, we'll cache it
+        if not cached:
+            LOG.debug("No image cache found for: %s, caching image",
+                      image_meta['id'])
+            self._cache_vol_2_1(context, src_vol, image_meta, image_service)
+
+        # Now perform the clone of the found image or newly cached image
+        self._create_cloned_volume_2_1(volume, src_vol)
+        # Force volume resize
+        vol_size = volume['size']
+        volume['size'] = 0
+        self._extend_volume_2_1(volume, vol_size)
+        volume['size'] = vol_size
+        # Determine if we need to retype the newly created volume
+        vtype_id = volume.get('volume_type_id')
+        if vtype_id and self.image_type and vtype_id != self.image_type:
+            vtype = volume_types.get_volume_type(context, vtype_id)
+            LOG.debug("Retyping newly cloned volume from type: %s to type: %s",
+                      self.image_type, vtype_id)
+            diff, discard = volume_types.volume_types_diff(
+                context, self.image_type, vtype_id)
+            host = {'capabilities': {'vendor_name': self.backend_name}}
+            self._retype_2_1(context, volume, vtype, diff, host)
+        return None, True
+
+    def _cache_vol_2_1(self, context, vol, image_meta, image_service):
+        image_id = image_meta['id']
+        # Pull down image and determine if valid
+        with image_utils.TemporaryImages.fetch(image_service,
+                                               context,
+                                               image_id) as tmp_image:
+            data = image_utils.qemu_img_info(tmp_image)
+            fmt = data.file_format
+            if fmt is None:
+                raise exception.ImageUnacceptable(
+                    reason=_("'qemu-img info' parsing failed."),
+                    image_id=image_id)
+
+            backing_file = data.backing_file
+            if backing_file is not None:
+                raise exception.ImageUnacceptable(
+                    image_id=image_id,
+                    reason=_("fmt=%(fmt)s backed by:%(backing_file)s")
+                    % {'fmt': fmt, 'backing_file': backing_file, })
+
+            vsize = int(
+                math.ceil(float(data.virtual_size) / units.Gi))
+            vol['size'] = vsize
+            vtype = vol['volume_type_id']
+            LOG.info("Creating cached image with volume type: %(vtype)s and "
+                     "size %(size)s", {'vtype': vtype, 'size': vsize})
+            self._create_volume_2_1(vol)
+            with self._connect_vol(context, vol) as device:
+                LOG.debug("Moving image %s to volume %s",
+                          image_meta['id'], datc.get_name(vol))
+                image_utils.convert_image(tmp_image,
+                                          device,
+                                          'raw',
+                                          run_as_root=True)
+                LOG.debug("Finished moving image %s to volume %s",
+                          image_meta['id'], datc.get_name(vol))
+                data = image_utils.qemu_img_info(device, run_as_root=True)
+                if data.file_format != 'raw':
+                    raise exception.ImageUnacceptable(
+                        image_id=image_id,
+                        reason=_(
+                            "Converted to %(vol_format)s, but format is "
+                            "now %(file_format)s") % {
+                                'vol_format': 'raw',
+                                'file_format': data.file_format})
+        # TODO(_alastor_): Remove this snapshot creation when we fix
+        # "created_at" attribute in the frontend
+        # We don't actually care about the snapshot uuid, we just want
+        # a single snapshot
+        snapshot = {'id': str(uuid.uuid4()),
+                    'volume_id': vol['id'],
+                    'project_id': vol['project_id']}
+        self._create_snapshot_2_1(snapshot)
+        metadata = {'type': 'cached_image'}
+        tenant = self.get_tenant(vol['project_id'])
+        ai = self.cvol_to_ai(vol, tenant=tenant)
+        ai.metadata.set(tenant=tenant, **metadata)
+        # Cloning offline AI is ~4 seconds faster than cloning online AI
+        self._detach_volume_2_1(None, vol)
+
+    def _get_vol_timestamp_2_1(self, volume):
+        tenant = self.get_tenant(volume['project_id'])
+        dvol = self.cvol_to_dvol(volume, tenant=tenant)
+        snapshots = dvol.snapshots.list(tenant=tenant)
+        if len(snapshots) == 1:
+            return float(snapshots[0].utc_ts)
+        else:
+            # We'll return 0 if we find no snapshots (or the incorrect number)
+            # to ensure the timestamp comparison with the master copy fails
+            # since the master copy will always have a timestamp > 0.
+            LOG.debug("Number of snapshots found: %s", len(snapshots))
+            return 0
+
+    def _vol_exists_2_1(self, volume):
+        LOG.debug("Checking if volume %s exists", volume['id'])
+        try:
+            ai = self.cvol_to_ai(volume)
+            LOG.debug("Volume %s exists", volume['id'])
+            return ai
+        except exception.NotFound:
+            LOG.debug("Volume %s not found", volume['id'])
+            return None
 
+    @contextlib.contextmanager
+    def _connect_vol(self, context, vol):
+        connector = None
         try:
-            LOG.debug('Getting Datera auth token.')
-            results = self._issue_api_request(
-                'login', 'put', body=body, sensitive=True, api_version='2.1',
-                tenant=None)
-            self.datera_api_token = results['key']
-        except exception.NotAuthorized:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Logging into the Datera cluster failed. Please '
-                          'check your username and password set in the '
-                          'cinder.conf and start the cinder-volume '
-                          'service again.')
+            # Start connection, get the connector object and create the
+            # export (ACL, IP-Pools, etc)
+            conn = self._initialize_connection_2_1(
+                vol, {'multipath': False})
+            connector = utils.brick_get_connector(
+                conn['driver_volume_type'],
+                use_multipath=False,
+                device_scan_attempts=10,
+                conn=conn)
+            connector_info = {'initiator': connector.get_initiator()}
+            self._create_export_2_1(None, vol, connector_info)
+            retries = 10
+            attach_info = conn['data']
+            while True:
+                try:
+                    attach_info.update(
+                        connector.connect_volume(conn['data']))
+                    break
+                except brick_exception.FailedISCSITargetPortalLogin:
+                    retries -= 1
+                    if not retries:
+                        LOG.error("Could not log into portal before end of "
+                                  "polling period")
+                        raise
+                    LOG.debug("Failed to login to portal, retrying")
+                    eventlet.sleep(2)
+            device_path = attach_info['path']
+            yield device_path
+        finally:
+            # Close target connection
+            if connector:
+                # Best effort disconnection
+                try:
+                    connector.disconnect_volume(attach_info, attach_info)
+                except Exception:
+                    pass
 
     # ===========
     # = Polling =
     # ===========
 
-    def _snap_poll_2_1(self, url, tenant):
+    def _snap_poll_2_1(self, snap, tenant):
         eventlet.sleep(datc.DEFAULT_SNAP_SLEEP)
         TIMEOUT = 20
         retry = 0
         poll = True
-        while poll and retry < TIMEOUT:
+        while poll and not retry >= TIMEOUT:
             retry += 1
-            snap = self._issue_api_request(url,
-                                           api_version='2.1',
-                                           tenant=tenant)['data']
-            if snap['op_state'] == 'available':
+            snap = snap.reload(tenant=tenant)
+            if snap.op_state == 'available':
                 poll = False
             else:
                 eventlet.sleep(1)
@@ -813,21 +938,16 @@ class DateraApi(object):
             raise exception.VolumeDriverException(
                 message=_('Snapshot not ready.'))
 
-    def _si_poll_2_1(self, volume, policies, tenant):
+    def _si_poll_2_1(self, volume, si, tenant):
         # Initial 4 second sleep required for some Datera versions
         eventlet.sleep(datc.DEFAULT_SI_SLEEP)
         TIMEOUT = 10
         retry = 0
-        check_url = datc.URL_TEMPLATES['si_inst'](
-            policies['default_storage_name']).format(
-                datc._get_name(volume['id']))
         poll = True
-        while poll and retry < TIMEOUT:
+        while poll and not retry >= TIMEOUT:
             retry += 1
-            si = self._issue_api_request(check_url,
-                                         api_version='2.1',
-                                         tenant=tenant)['data']
-            if si['op_state'] == 'available':
+            si = si.reload(tenant=tenant)
+            if si.op_state == 'available':
                 poll = False
             else:
                 eventlet.sleep(1)
@@ -840,12 +960,13 @@ class DateraApi(object):
     # ================
 
     def _get_volume_stats_2_1(self, refresh=False):
+        # cluster_stats is defined by datera_iscsi
+        # pylint: disable=access-member-before-definition
         if refresh or not self.cluster_stats:
             try:
                 LOG.debug("Updating cluster stats info.")
 
-                results = self._issue_api_request(
-                    'system', api_version='2.1')['data']
+                results = self.api.system.get()
 
                 if 'uuid' not in results:
                     LOG.error(
@@ -857,9 +978,9 @@ class DateraApi(object):
                     'driver_version': self.VERSION,
                     'storage_protocol': 'iSCSI',
                     'total_capacity_gb': (
-                        int(results['total_capacity']) / units.Gi),
+                        int(results.total_capacity) / units.Gi),
                     'free_capacity_gb': (
-                        int(results['available_capacity']) / units.Gi),
+                        int(results.available_capacity) / units.Gi),
                     'reserved_percentage': 0,
                     'QoS_support': True,
                 }
@@ -873,43 +994,105 @@ class DateraApi(object):
     # = QoS =
     # =======
 
-    def _update_qos_2_1(self, resource, policies, tenant):
-        url = datc.URL_TEMPLATES['vol_inst'](
-            policies['default_storage_name'],
-            policies['default_volume_name']) + '/performance_policy'
-        url = url.format(datc._get_name(resource['id']))
-        type_id = resource.get('volume_type_id', None)
+    def _update_qos_2_1(self, volume, policies, clear_old=False):
+        tenant = self.get_tenant(volume['project_id'])
+        dvol = self.cvol_to_dvol(volume, tenant=tenant)
+        type_id = volume.get('volume_type_id', None)
         if type_id is not None:
+            iops_per_gb = int(policies.get('iops_per_gb', 0))
+            bandwidth_per_gb = int(policies.get('bandwidth_per_gb', 0))
             # Filter for just QOS policies in result. All of their keys
             # should end with "max"
             fpolicies = {k: int(v) for k, v in
                          policies.items() if k.endswith("max")}
             # Filter all 0 values from being passed
-            fpolicies = dict(filter(lambda _v: _v[1] > 0, fpolicies.items()))
+            fpolicies = {k: int(v) for k, v in
+                         fpolicies.items() if v > 0}
+            # Calculate and set iops/gb and bw/gb, but only if they don't
+            # exceed total_iops_max and total_bw_max aren't set since they take
+            # priority
+            if iops_per_gb:
+                ipg = iops_per_gb * volume['size']
+                # Not using zero, because zero means unlimited
+                im = fpolicies.get('total_iops_max', 1)
+                r = ipg
+                if ipg > im:
+                    r = im
+                fpolicies['total_iops_max'] = r
+            if bandwidth_per_gb:
+                bpg = bandwidth_per_gb * volume['size']
+                # Not using zero, because zero means unlimited
+                bm = fpolicies.get('total_bandwidth_max', 1)
+                r = bpg
+                if bpg > bm:
+                    r = bm
+                fpolicies['total_bandwidth_max'] = r
+            if fpolicies or clear_old:
+                try:
+                    pp = dvol.performance_policy.get(tenant=tenant)
+                    pp.delete(tenant=tenant)
+                except dexceptions.ApiNotFoundError:
+                    LOG.debug("No existing performance policy found")
             if fpolicies:
-                self._issue_api_request(url, 'delete', api_version='2.1',
-                                        tenant=tenant)
-                self._issue_api_request(url, 'post', body=fpolicies,
-                                        api_version='2.1', tenant=tenant)
+                dvol.performance_policy.create(tenant=tenant, **fpolicies)
 
     # ============
     # = IP Pools =
     # ============
 
-    def _get_ip_pool_for_string_ip_2_1(self, ip):
+    def _get_ip_pool_for_string_ip_2_1(self, ip, tenant):
         """Takes a string ipaddress and return the ip_pool API object dict """
         pool = 'default'
         ip_obj = ipaddress.ip_address(six.text_type(ip))
-        ip_pools = self._issue_api_request('access_network_ip_pools',
-                                           api_version='2.1')
-        for ipdata in ip_pools['data']:
+        ip_pools = self.api.access_network_ip_pools.list(tenant=tenant)
+        for ipdata in ip_pools:
             for adata in ipdata['network_paths']:
                 if not adata.get('start_ip'):
                     continue
                 pool_if = ipaddress.ip_interface(
                     "/".join((adata['start_ip'], str(adata['netmask']))))
                 if ip_obj in pool_if.network:
-                    pool = ipdata['name']
-        return self._issue_api_request(
-            "access_network_ip_pools/{}".format(pool),
-            api_version='2.1')['path']
+                    pool = ipdata.name
+        return self.api.access_network_ip_pools.get(pool, tenant=tenant).path
+    # ====================
+    # = Volume Migration =
+    # ====================
+
+    def _update_migrated_volume_2_1(self, context, volume, new_volume,
+                                    volume_status):
+        """Rename the newly created volume to the original volume.
+
+        So we can find it correctly.
+        """
+        tenant = self.get_tenant(new_volume['project_id'])
+        ai = self.cvol_to_ai(new_volume, tenant=tenant)
+        data = {'name': datc.get_name(volume)}
+        ai.set(tenant=tenant, **data)
+        return {'_name_id': None}
+
+    @contextlib.contextmanager
+    def _offline_flip_2_1(self, volume):
+        reonline = False
+        tenant = self.get_tenant(volume['project_id'])
+        ai = self.cvol_to_ai(volume, tenant=tenant)
+        if ai.admin_state == 'online':
+            reonline = True
+        ai.set(tenant=tenant, admin_state='offline')
+        yield
+        if reonline:
+            ai.set(tenant=tenant, admin_state='online')
+
+    def _add_vol_meta_2_1(self, volume, connector=None):
+        if not self.do_metadata:
+            return
+        metadata = {'host': volume.get('host', ''),
+                    'display_name': datc.filter_chars(
+                        volume.get('display_name', '')),
+                    'bootable': str(volume.get('bootable', False)),
+                    'availability_zone': volume.get('availability_zone', '')}
+        if connector:
+            metadata.update(connector)
+        LOG.debug("Adding volume metadata: %s", metadata)
+        tenant = self.get_tenant(volume['project_id'])
+        ai = self.cvol_to_ai(volume, tenant=tenant)
+        ai.metadata.set(tenant=tenant, **metadata)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/datera/datera_api22.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/datera/datera_api22.py
--- 2:15.0.1-1/cinder/volume/drivers/datera/datera_api22.py	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/datera/datera_api22.py	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,1175 @@
+# Copyright 2020 Datera
+# All Rights Reserved.
+#
+#    Licensed under the Apache License, Version 2.0 (the "License"); you may
+#    not use this file except in compliance with the License. You may obtain
+#    a copy of the License at
+#
+#         http://www.apache.org/licenses/LICENSE-2.0
+#
+#    Unless required by applicable law or agreed to in writing, software
+#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+#    License for the specific language governing permissions and limitations
+#    under the License.
+
+import contextlib
+import ipaddress
+import math
+import random
+import time
+import uuid
+
+import eventlet
+from os_brick import exception as brick_exception
+from oslo_log import log as logging
+from oslo_serialization import jsonutils as json
+from oslo_utils import importutils
+from oslo_utils import units
+import six
+
+from cinder import exception
+from cinder.i18n import _
+from cinder.image import image_utils
+from cinder import utils
+import cinder.volume.drivers.datera.datera_common as datc
+from cinder.volume import volume_types
+from cinder.volume import volume_utils as volutils
+
+LOG = logging.getLogger(__name__)
+
+dexceptions = importutils.try_import('dfs_sdk.exceptions')
+
+API_VERSION = "2.2"
+
+
+# The DateraAPI classes (2.1, 2.2) are enhanced by datera_common's lookup()
+# decorator which generates members run-time. Therefore on the class we disable
+# pylint's no-member check pylint: disable=no-member
+class DateraApi(object):
+
+    # =================
+    # = Create Volume =
+    # =================
+
+    def _create_volume_2_2(self, volume):
+        policies = self._get_policies_for_resource(volume)
+        num_replicas = int(policies['replica_count'])
+        storage_name = 'storage-1'
+        volume_name = 'volume-1'
+        template = policies['template']
+        placement = policies['placement_mode']
+        ppolicy = policies['placement_policy']
+        ip_pool = datc.get_ip_pool(policies)
+
+        name = datc.get_name(volume)
+
+        if template:
+            app_params = (
+                {
+                    'create_mode': 'openstack',
+                    # 'uuid': str(volume['id']),
+                    'name': name,
+                    'app_template': {'path': '/app_templates/{}'.format(
+                        template)}
+                })
+            if self._support_template_override_2_2():
+                app_params['template_override'] = {
+                    'storage_instances': {
+                        storage_name: {
+                            'volumes': {
+                                volume_name: {
+                                    'size': str(volume['size'])}}}}}
+
+        else:
+
+            app_params = (
+                {
+                    'create_mode': 'openstack',
+                    'uuid': str(volume['id']),
+                    'name': name,
+                    'access_control_mode': 'deny_all',
+                    'storage_instances': [
+                        {
+                            'name': storage_name,
+                            'ip_pool': {'path': ('/access_network_ip_pools/'
+                                                 '{}'.format(ip_pool))},
+                            'volumes': [
+                                {
+                                    'name': volume_name,
+                                    'size': volume['size'],
+                                    'replica_count': num_replicas,
+                                    'snapshot_policies': [
+                                    ]
+                                }
+                            ]
+                        }
+                    ]
+                })
+            create_vol = app_params['storage_instances'][0]['volumes'][0]
+            if datc.dat_version_gte(self.datera_version, '3.3.0.0'):
+                create_vol['placement_policy'] = {
+                    'path': '/placement_policies/{}'.format(ppolicy)}
+            else:
+                create_vol['placement_mode'] = placement
+
+        tenant = self.create_tenant(volume['project_id'])
+        self.api.app_instances.create(tenant=tenant, **app_params)
+        self._update_qos_2_2(volume, policies)
+        self._add_vol_meta_2_2(volume)
+
+    # =================
+    # = Extend Volume =
+    # =================
+
+    def _extend_volume_2_2(self, volume, new_size):
+        if volume['size'] >= new_size:
+            LOG.warning("Volume size not extended due to original size being "
+                        "greater or equal to new size. Original: "
+                        "%(original)s, New: %(new)s",
+                        {'original': volume['size'],
+                         'new': new_size})
+            return
+        policies = self._get_policies_for_resource(volume)
+        template = policies['template']
+        if template and not self._support_template_override_2_2():
+            LOG.warning("Volume size not extended due to template binding.  "
+                        "Template override is supported in product versions "
+                        "3.3.X+: volume: %(volume)s, template: %(template)s",
+                        {'volume': volume, 'template': template})
+            return
+
+        with self._offline_flip_2_2(volume):
+            # Change Volume Size
+            tenant = self.get_tenant(volume['project_id'])
+            dvol = self.cvol_to_dvol(volume, tenant)
+            dvol.set(tenant=tenant, size=new_size)
+
+    # =================
+    # = Cloned Volume =
+    # =================
+
+    def _create_cloned_volume_2_2(self, volume, src_vref):
+        tenant = self.get_tenant(volume['project_id'])
+        sdvol = self.cvol_to_dvol(src_vref, tenant=tenant)
+        src = sdvol.path
+        data = {
+            'create_mode': 'openstack',
+            'name': datc.get_name(volume),
+            'uuid': str(volume['id']),
+            'clone_volume_src': {'path': src},
+        }
+        tenant = self.get_tenant(volume['project_id'])
+        self.api.app_instances.create(tenant=tenant, **data)
+
+        if volume['size'] > src_vref['size']:
+            self._extend_volume_2_2(volume, volume['size'])
+        self._add_vol_meta_2_2(volume)
+
+    # =================
+    # = Delete Volume =
+    # =================
+
+    def _delete_volume_2_2(self, volume):
+        try:
+            tenant = self.get_tenant(volume['project_id'])
+            ai = self.cvol_to_ai(volume, tenant=tenant)
+            si = ai.storage_instances.list(tenant=tenant)[0]
+
+            # Clear out ACL
+            acl = si.acl_policy.get(tenant=tenant)
+            acl.set(tenant=tenant, initiators=[])
+
+            # Bring volume offline
+            data = {
+                'admin_state': 'offline',
+                'force': True
+            }
+            ai.set(tenant=tenant, **data)
+
+            ai.delete(tenant=tenant, force=True)
+        except exception.NotFound:
+            msg = ("Tried to delete volume %s, but it was not found in the "
+                   "Datera cluster. Continuing with delete.")
+            LOG.info(msg, datc.get_name(volume))
+
+    # =================
+    # = Ensure Export =
+    # =================
+
+    def _ensure_export_2_2(self, context, volume, connector=None):
+        pass
+
+    # =========================
+    # = Initialize Connection =
+    # =========================
+
+    def _initialize_connection_2_2(self, volume, connector):
+        # Now online the app_instance (which will online all storage_instances)
+        multipath = connector.get('multipath', False)
+        tenant = self.get_tenant(volume['project_id'])
+        ai = self.cvol_to_ai(volume, tenant=tenant)
+        data = {
+            'admin_state': 'online'
+        }
+        ai.set(tenant=tenant, **data)
+        si = ai.storage_instances.list(tenant=tenant)[0]
+
+        # randomize portal chosen
+        choice = 0
+        policies = self._get_policies_for_resource(volume)
+        if policies["round_robin"]:
+            choice = random.randint(0, 1)
+        portal = si.access['ips'][choice] + ':3260'
+        iqn = si.access['iqn']
+        if multipath:
+            portals = [p + ':3260' for p in si.access['ips']]
+            iqns = [iqn for _ in si.access['ips']]
+            lunids = [self._get_lunid() for _ in si.access['ips']]
+
+            result = {
+                'driver_volume_type': 'iscsi',
+                'data': {
+                    'target_discovered': False,
+                    'target_iqn': iqn,
+                    'target_iqns': iqns,
+                    'target_portal': portal,
+                    'target_portals': portals,
+                    'target_lun': self._get_lunid(),
+                    'target_luns': lunids,
+                    'volume_id': volume['id'],
+                    'discard': False}}
+        else:
+            result = {
+                'driver_volume_type': 'iscsi',
+                'data': {
+                    'target_discovered': False,
+                    'target_iqn': iqn,
+                    'target_portal': portal,
+                    'target_lun': self._get_lunid(),
+                    'volume_id': volume['id'],
+                    'discard': False}}
+
+        if self.use_chap_auth:
+            result['data'].update(
+                auth_method="CHAP",
+                auth_username=self.chap_username,
+                auth_password=self.chap_password)
+
+        return result
+
+    # =================
+    # = Create Export =
+    # =================
+
+    def _create_export_2_2(self, context, volume, connector):
+        tenant = self.get_tenant(volume['project_id'])
+        ai = self.cvol_to_ai(volume, tenant=tenant)
+        data = {
+            'admin_state': 'offline',
+            'force': True
+        }
+        ai.set(tenant=tenant, **data)
+        si = ai.storage_instances.list(tenant=tenant)[0]
+        policies = self._get_policies_for_resource(volume)
+        if connector and connector.get('ip'):
+            # Case where volume_type has non default IP Pool info
+            ip_pool = datc.get_ip_pool(policies)
+            if ip_pool != 'default':
+                initiator_ip_pool_path = self.api.access_network_ip_pools.get(
+                    ip_pool).path
+            # Fallback to trying reasonable IP based guess
+            else:
+                initiator_ip_pool_path = self._get_ip_pool_for_string_ip_2_2(
+                    connector['ip'], tenant)
+
+            ip_pool_data = {'ip_pool': {'path': initiator_ip_pool_path}}
+            if not ai.app_template["path"]:
+                si.set(tenant=tenant, **ip_pool_data)
+        data = {
+            'admin_state': 'online'
+        }
+        ai.set(tenant=tenant, **data)
+        # Check if we've already setup everything for this volume
+        storage_instances = ai.storage_instances.list(tenant=tenant)
+        # Handle adding initiator to product if necessary
+        # Then add initiator to ACL
+        if connector and connector.get('initiator'):
+            initiator_name = "OpenStack-{}".format(str(uuid.uuid4())[:8])
+            initiator = connector['initiator']
+            dinit = None
+            try:
+                # We want to make sure the initiator is created under the
+                # current tenant rather than using the /root one
+                dinit = self.api.initiators.get(initiator, tenant=tenant)
+                if dinit.tenant != tenant:
+                    raise dexceptions.ApiNotFoundError(
+                        "Initiator {} was not found under tenant {} "
+                        "[{} != {}]".format(
+                            initiator, tenant, dinit.tenant, tenant))
+            except dexceptions.ApiNotFoundError:
+                # TODO(_alastor_): Take out the 'force' flag when we fix
+                # DAT-15931
+                data = {'id': initiator, 'name': initiator_name, 'force': True}
+                # Try and create the initiator
+                # If we get a conflict, ignore it
+                try:
+                    dinit = self.api.initiators.create(tenant=tenant, **data)
+                except dexceptions.ApiConflictError:
+                    pass
+            initiator_path = dinit['path']
+            # Create ACL with initiator group as reference for each
+            # storage_instance in app_instance
+            # TODO(_alastor_): We need to avoid changing the ACLs if the
+            # template already specifies an ACL policy.
+            for si in storage_instances:
+                existing_acl = si.acl_policy.get(tenant=tenant)
+                data = {}
+                # Grabbing only the 'path' key from each existing initiator
+                # within the existing acl. eacli --> existing acl initiator
+                eacli = []
+                for acl in existing_acl['initiators']:
+                    nacl = {}
+                    nacl['path'] = acl['path']
+                    eacli.append(nacl)
+                data['initiators'] = eacli
+                data['initiators'].append({"path": initiator_path})
+                # Grabbing only the 'path' key from each existing initiator
+                # group within the existing acl. eaclig --> existing
+                # acl initiator group
+                eaclig = []
+                for acl in existing_acl['initiator_groups']:
+                    nacl = {}
+                    nacl['path'] = acl['path']
+                    eaclig.append(nacl)
+                data['initiator_groups'] = eaclig
+                si.acl_policy.set(tenant=tenant, **data)
+        if self.use_chap_auth:
+            for si in storage_instances:
+                data = {'type': 'chap',
+                        'target_user_name': self.chap_username,
+                        'target_pswd': self.chap_password}
+                si.auth.set(tenant=tenant, **data)
+        # Check to ensure we're ready for go-time
+        self._si_poll_2_2(volume, si, tenant)
+        self._add_vol_meta_2_2(volume, connector=connector)
+
+    # =================
+    # = Detach Volume =
+    # =================
+
+    def _detach_volume_2_2(self, context, volume, attachment=None):
+        try:
+            tenant = self.get_tenant(volume['project_id'])
+            ai = self.cvol_to_ai(volume, tenant=tenant)
+            # Clear out ACL for this specific attachment
+            si = ai.storage_instances.list(tenant=tenant)[0]
+            existing_acl = si.acl_policy.get(tenant=tenant)
+            data = {}
+            # Grabbing only the 'path' key from each existing initiator
+            # within the existing acl. eacli --> existing acl initiator
+            eacli = []
+            for acl in existing_acl['initiators']:
+                if (
+                    attachment is not None
+                    and attachment.connector is not None
+                    and acl['path'].split('/')[-1]
+                    == attachment.connector['initiator']
+                ):
+                    continue
+                nacl = {}
+                nacl['path'] = acl['path']
+                eacli.append(nacl)
+            data['initiators'] = eacli
+            data['initiator_groups'] = existing_acl['initiator_groups']
+            si.acl_policy.set(tenant=tenant, **data)
+
+            if not eacli:
+                # bring the application instance offline if there
+                # are no initiators left.
+                data = {
+                    'admin_state': 'offline',
+                    'force': True
+                }
+                ai.set(tenant=tenant, **data)
+
+        except exception.NotFound:
+            msg = ("Tried to detach volume %s, but it was not found in the "
+                   "Datera cluster. Continuing with detach.")
+            LOG.info(msg, volume['id'])
+
+    # ===================
+    # = Create Snapshot =
+    # ===================
+
+    def _create_snapshot_2_2(self, snapshot):
+
+        dummy_vol = {'id': snapshot['volume_id'],
+                     'project_id': snapshot['project_id']}
+        tenant = self.get_tenant(dummy_vol['project_id'])
+        dvol = self.cvol_to_dvol(dummy_vol, tenant=tenant)
+        snap_params = {
+            'uuid': snapshot['id'],
+        }
+        snap = dvol.snapshots.create(tenant=tenant, **snap_params)
+        self._snap_poll_2_2(snap, tenant)
+
+    # ===================
+    # = Delete Snapshot =
+    # ===================
+
+    def _delete_snapshot_2_2(self, snapshot):
+        # Handle case where snapshot is "managed"
+        dummy_vol = {'id': snapshot['volume_id'],
+                     'project_id': snapshot['project_id']}
+        tenant = self.get_tenant(dummy_vol['project_id'])
+        dvol = self.cvol_to_dvol(dummy_vol, tenant=tenant)
+
+        snapshots = None
+
+        # Shortcut if this is a managed snapshot
+        provider_location = snapshot.get('provider_location')
+        if provider_location:
+            snap = dvol.snapshots.get(provider_location, tenant=tenant)
+            snap.delete(tenant=tenant)
+            return
+
+        # Long-way.  UUID identification
+        try:
+            snapshots = dvol.snapshots.list(tenant=tenant)
+        except exception.NotFound:
+            msg = ("Tried to delete snapshot %s, but parent volume %s was "
+                   "not found in Datera cluster. Continuing with delete.")
+            LOG.info(msg,
+                     datc.get_name(snapshot),
+                     datc.get_name({'id': snapshot['volume_id']}))
+            return
+
+        try:
+            for snap in snapshots:
+                if snap.uuid == snapshot['id']:
+                    snap.delete(tenant=tenant)
+                    break
+            else:
+                raise exception.NotFound
+        except exception.NotFound:
+            msg = ("Tried to delete snapshot %s, but was not found in "
+                   "Datera cluster. Continuing with delete.")
+            LOG.info(msg, datc.get_name(snapshot))
+
+    # ========================
+    # = Volume From Snapshot =
+    # ========================
+
+    def _create_volume_from_snapshot_2_2(self, volume, snapshot):
+        # Handle case where snapshot is "managed"
+        dummy_vol = {'id': snapshot['volume_id'],
+                     'project_id': snapshot['project_id']}
+        tenant = self.get_tenant(dummy_vol['project_id'])
+        dvol = self.cvol_to_dvol(dummy_vol, tenant=tenant)
+        found_snap = None
+        provider_location = snapshot.get('provider_location')
+        if provider_location:
+            found_snap = dvol.snapshots.get(provider_location, tenant=tenant)
+        else:
+            snapshots = dvol.snapshots.list(tenant=tenant)
+            for snap in snapshots:
+                if snap.uuid == snapshot['id']:
+                    found_snap = snap
+                    break
+            else:
+                raise exception.SnapshotNotFound(snapshot_id=snapshot['id'])
+
+        self._snap_poll_2_2(found_snap, tenant)
+
+        src = found_snap.path
+        app_params = (
+            {
+                'create_mode': 'openstack',
+                'uuid': str(volume['id']),
+                'name': datc.get_name(volume),
+                'clone_snapshot_src': {'path': src},
+            })
+
+        self.api.app_instances.create(tenant=tenant, **app_params)
+        if (volume['size'] > snapshot['volume_size']):
+            self._extend_volume_2_2(volume, volume['size'])
+        self._add_vol_meta_2_2(volume)
+
+    # ==========
+    # = Retype =
+    # ==========
+
+    def _retype_2_2(self, ctxt, volume, new_type, diff, host):
+        LOG.debug("Retype called\n"
+                  "Volume: %(volume)s\n"
+                  "NewType: %(new_type)s\n"
+                  "Diff: %(diff)s\n"
+                  "Host: %(host)s\n", {'volume': volume, 'new_type': new_type,
+                                       'diff': diff, 'host': host})
+        # We'll take the fast route only if the types share the same backend
+        # And that backend matches this driver
+        old_pol = self._get_policies_for_resource(volume)
+        new_pol = self._get_policies_for_volume_type(new_type)
+        if (host['capabilities']['volume_backend_name'].lower() ==
+                self.backend_name.lower()):
+            LOG.debug("Starting fast volume retype")
+
+            if old_pol.get('template') or new_pol.get('template'):
+                LOG.warning(
+                    "Fast retyping between template-backed volume-types "
+                    "unsupported.  Type1: %s, Type2: %s",
+                    volume['volume_type_id'], new_type)
+
+            self._update_qos_2_2(volume, new_pol, clear_old=True)
+            tenant = self.get_tenant(volume['project_id'])
+            dvol = self.cvol_to_dvol(volume, tenant=tenant)
+            # Only replica_count ip_pool requires offlining the app_instance
+            if (new_pol['replica_count'] != old_pol['replica_count'] or
+                    new_pol['ip_pool'] != old_pol['ip_pool']):
+                with self._offline_flip_2_2(volume):
+                    # ip_pool is Storage Instance level
+                    ai = self.cvol_to_ai(volume, tenant=tenant)
+                    si = ai.storage_instances.list(tenant=tenant)[0]
+                    ip_pool = datc.get_ip_pool(new_pol)
+                    si_params = (
+                        {
+                            'ip_pool': {'path': ('/access_network_ip_pools/'
+                                                 '{}'.format(ip_pool))},
+                        })
+                    si.set(tenant=tenant, **si_params)
+                    # placement_mode and replica_count are Volume level
+                    vol_params = (
+                        {
+                            'placement_mode': new_pol['placement_mode'],
+                            'replica_count': new_pol['replica_count'],
+                        })
+                    if datc.dat_version_gte(self.datera_version, '3.3.0.0'):
+                        ppolicy = {'path': '/placement_policies/{}'.format(
+                            new_pol.get('placement_policy'))}
+                        vol_params['placement_policy'] = ppolicy
+                    dvol.set(tenant=tenant, **vol_params)
+            elif (new_pol['placement_mode'] != old_pol[
+                    'placement_mode'] or new_pol[
+                        'placement_policy'] != old_pol['placement_policy']):
+                vol_params = (
+                    {
+                        'placement_mode': new_pol['placement_mode'],
+                    })
+                if datc.dat_version_gte(self.datera_version, '3.3.0.0'):
+                    ppolicy = {'path': '/placement_policies/{}'.format(
+                        new_pol.get('placement_policy'))}
+                    vol_params['placement_policy'] = ppolicy
+                dvol.set(tenant=tenant, **vol_params)
+            self._add_vol_meta_2_2(volume)
+            return True
+
+        else:
+            LOG.debug("Couldn't fast-retype volume between specified types")
+            return False
+
+    # ==========
+    # = Manage =
+    # ==========
+
+    def _manage_existing_2_2(self, volume, existing_ref):
+        # Only volumes created under the requesting tenant can be managed in
+        # the v2.1+ API.  Eg.  If tenant A is the tenant for the volume to be
+        # managed, it must also be tenant A that makes this request.
+        # This will be fixed in a later API update
+        existing_ref = existing_ref['source-name']
+        app_inst_name, __, __, __ = datc._parse_vol_ref(existing_ref)
+        LOG.debug("Managing existing Datera volume %s  "
+                  "Changing name to %s",
+                  datc.get_name(volume), existing_ref)
+        # Rename AppInstance
+        dummy_vol = {'id': app_inst_name,
+                     'project_id': volume['project_id']}
+        tenant = self.get_tenant(volume['project_id'])
+        ai = self.cvol_to_ai(dummy_vol, tenant=tenant)
+        data = {'name': datc.get_name(volume)}
+        ai.set(tenant=tenant, **data)
+        self._add_vol_meta_2_2(volume)
+
+    # ===================
+    # = Manage Get Size =
+    # ===================
+
+    def _manage_existing_get_size_2_2(self, volume, existing_ref):
+        existing_ref = existing_ref['source-name']
+        app_inst_name, storage_inst_name, vol_name, __ = datc._parse_vol_ref(
+            existing_ref)
+        dummy_vol = {'id': app_inst_name,
+                     'project_id': volume['project_id']}
+        dvol = self.cvol_to_dvol(dummy_vol)
+        return dvol.size
+
+    # =========================
+    # = Get Manageable Volume =
+    # =========================
+
+    def _list_manageable_2_2(self, cinder_volumes):
+        # Use the first volume to determine the tenant we're working under
+        if cinder_volumes:
+            tenant = self.get_tenant(cinder_volumes[0]['project_id'])
+        else:
+            tenant = None
+        app_instances = self.api.app_instances.list(tenant=tenant)
+
+        results = []
+
+        if cinder_volumes and 'volume_id' in cinder_volumes[0]:
+            cinder_volume_ids = [vol['volume_id'] for vol in cinder_volumes]
+        else:
+            cinder_volume_ids = [vol['id'] for vol in cinder_volumes]
+
+        for ai in app_instances:
+            ai_name = ai['name']
+            reference = None
+            size = None
+            safe_to_manage = False
+            reason_not_safe = ""
+            cinder_id = None
+            extra_info = {}
+            (safe_to_manage, reason_not_safe,
+                cinder_id) = self._is_manageable_2_2(
+                    ai, cinder_volume_ids, tenant)
+            si = ai.storage_instances.list(tenant=tenant)[0]
+            si_name = si.name
+            vol = si.volumes.list(tenant=tenant)[0]
+            vol_name = vol.name
+            size = vol.size
+            snaps = [(snap.utc_ts, snap.uuid)
+                     for snap in vol.snapshots.list(tenant=tenant)]
+            extra_info["snapshots"] = json.dumps(snaps)
+            reference = {"source-name": "{}:{}:{}".format(
+                ai_name, si_name, vol_name)}
+
+            results.append({
+                'reference': reference,
+                'size': size,
+                'safe_to_manage': safe_to_manage,
+                'reason_not_safe': reason_not_safe,
+                'cinder_id': cinder_id,
+                'extra_info': extra_info})
+        return results
+
+    def _get_manageable_volumes_2_2(self, cinder_volumes, marker, limit,
+                                    offset, sort_keys, sort_dirs):
+        LOG.debug("Listing manageable Datera volumes")
+        results = self._list_manageable_2_2(cinder_volumes)
+        page_results = volutils.paginate_entries_list(
+            results, marker, limit, offset, sort_keys, sort_dirs)
+
+        return page_results
+
+    def _is_manageable_2_2(self, ai, cinder_volume_ids, tenant):
+        cinder_id = None
+        ai_name = ai.name
+        match = datc.UUID4_RE.match(ai_name)
+        if match:
+            cinder_id = match.group(1)
+        if cinder_id and cinder_id in cinder_volume_ids:
+            return (False,
+                    "App Instance already managed by Cinder",
+                    cinder_id)
+        if len(ai.storage_instances.list(tenant=tenant)) == 1:
+            si = ai.storage_instances.list(tenant=tenant)[0]
+            if len(si['volumes']) == 1:
+                return (True, "", cinder_id)
+        return (False,
+                "App Instance has more than one storage instance or volume",
+                cinder_id)
+    # ============
+    # = Unmanage =
+    # ============
+
+    def _unmanage_2_2(self, volume):
+        LOG.debug("Unmanaging Cinder volume %s.  Changing name to %s",
+                  volume['id'], datc.get_unmanaged(volume['id']))
+        data = {'name': datc.get_unmanaged(volume['id'])}
+        tenant = self.get_tenant(volume['project_id'])
+        ai = self.cvol_to_ai(volume, tenant=tenant)
+        ai.set(tenant=tenant, **data)
+
+    # ===================
+    # = Manage Snapshot =
+    # ===================
+
+    def _manage_existing_snapshot_2_2(self, snapshot, existing_ref):
+        existing_ref = existing_ref['source-name']
+        datc._check_snap_ref(existing_ref)
+        LOG.debug("Managing existing Datera volume snapshot %s for volume %s",
+                  existing_ref, datc.get_name({'id': snapshot['volume_id']}))
+        return {'provider_location': existing_ref}
+
+    def _manage_existing_snapshot_get_size_2_2(self, snapshot, existing_ref):
+        existing_ref = existing_ref['source-name']
+        datc._check_snap_ref(existing_ref)
+        dummy_vol = {'id': snapshot['volume_id'],
+                     'project_id': snapshot['project_id']}
+        dvol = self.cvol_to_dvol(dummy_vol)
+        return dvol.size
+
+    def _get_manageable_snapshots_2_2(self, cinder_snapshots, marker, limit,
+                                      offset, sort_keys, sort_dirs):
+        LOG.debug("Listing manageable Datera snapshots")
+        results = self._list_manageable_2_2(cinder_snapshots)
+        snap_results = []
+        snapids = set((snap['id'] for snap in cinder_snapshots))
+        snaprefs = set((snap.get('provider_location')
+                        for snap in cinder_snapshots))
+        for volume in results:
+            snaps = json.loads(volume["extra_info"]["snapshots"])
+            for snapshot in snaps:
+                reference = snapshot[0]
+                uuid = snapshot[1]
+                size = volume["size"]
+                safe_to_manage = True
+                reason_not_safe = ""
+                cinder_id = ""
+                extra_info = {}
+                source_reference = volume["reference"]
+                if uuid in snapids or reference in snaprefs:
+                    safe_to_manage = False
+                    reason_not_safe = _("already managed by Cinder")
+                elif not volume['safe_to_manage'] and not volume['cinder_id']:
+                    safe_to_manage = False
+                    reason_not_safe = _("parent volume not safe to manage")
+                snap_results.append({
+                    'reference': {'source-name': reference},
+                    'size': size,
+                    'safe_to_manage': safe_to_manage,
+                    'reason_not_safe': reason_not_safe,
+                    'cinder_id': cinder_id,
+                    'extra_info': extra_info,
+                    'source_reference': source_reference})
+        page_results = volutils.paginate_entries_list(
+            snap_results, marker, limit, offset, sort_keys, sort_dirs)
+
+        return page_results
+
+    def _unmanage_snapshot_2_2(self, snapshot):
+        return {'provider_location': None}
+
+    # ====================
+    # = Fast Image Clone =
+    # ====================
+
+    def _clone_image_2_2(self, context, volume, image_location, image_meta,
+                         image_service):
+        # We're not going to fast image clone if the feature is not enabled
+        # and/or we can't reach the image being requested
+        if (not self.image_cache or
+                not self._image_accessible(context, volume, image_meta)):
+            return None, False
+        # Check to make sure we're working with a valid volume type
+        try:
+            found = volume_types.get_volume_type(context, self.image_type)
+        except (exception.VolumeTypeNotFound, exception.InvalidVolumeType):
+            found = None
+        if not found:
+            msg = "Invalid volume type: %s"
+            LOG.error(msg, self.image_type)
+            raise ValueError(_("Option datera_image_cache_volume_type_id must"
+                               " be set to a valid volume_type id"))
+        # Check image format
+        fmt = image_meta.get('disk_format', '')
+        if fmt.lower() != 'raw':
+            LOG.debug("Image format is not RAW, image requires conversion "
+                      "before clone.  Image format: [%s]", fmt)
+            return None, False
+
+        LOG.debug("Starting fast image clone")
+        # TODO(_alastor_): determine if Datera is already an image backend
+        # for this request and direct clone instead of caching
+
+        # Dummy volume, untracked by Cinder
+        src_vol = {'id': image_meta['id'],
+                   'volume_type_id': self.image_type,
+                   'size': volume['size'],
+                   'project_id': volume['project_id']}
+
+        # Determine if we have a cached version of the image
+        cached = self._vol_exists_2_2(src_vol)
+
+        if cached:
+            tenant = self.get_tenant(src_vol['project_id'])
+            ai = self.cvol_to_ai(src_vol, tenant=tenant)
+            metadata = ai.metadata.get(tenant=tenant)
+            # Check to see if the master image has changed since we created
+            # The cached version
+            ts = self._get_vol_timestamp_2_2(src_vol)
+            mts = time.mktime(image_meta['updated_at'].timetuple())
+            LOG.debug("Original image timestamp: %s, cache timestamp %s",
+                      mts, ts)
+            # If the image is created by Glance, we'll trust that even if the
+            # timestamps don't match up, the data is ok to clone as it's not
+            # managed by this driver
+            if metadata.get('type') == 'image':
+                LOG.debug("Found Glance volume-backed image for %s",
+                          src_vol['id'])
+            # If the master image time is greater than the volume creation
+            # time, we invalidate the cache and delete the volume.  The
+            # exception is if the cached volume was created by Glance.  We
+            # NEVER want to delete this volume.  It's annotated with
+            # 'type': 'image' in the metadata, so we'll check for that
+            elif mts > ts and metadata.get('type') != 'image':
+                LOG.debug("Cache is older than original image, deleting cache")
+                cached = False
+                self._delete_volume_2_2(src_vol)
+
+        # If we don't have the image, we'll cache it
+        if not cached:
+            LOG.debug("No image cache found for: %s, caching image",
+                      image_meta['id'])
+            self._cache_vol_2_2(context, src_vol, image_meta, image_service)
+
+        # Now perform the clone of the found image or newly cached image
+        self._create_cloned_volume_2_2(volume, src_vol)
+        # Force volume resize
+        vol_size = volume['size']
+        volume['size'] = 0
+        self._extend_volume_2_2(volume, vol_size)
+        volume['size'] = vol_size
+        # Determine if we need to retype the newly created volume
+        vtype_id = volume.get('volume_type_id')
+        if vtype_id and self.image_type and vtype_id != self.image_type:
+            vtype = volume_types.get_volume_type(context, vtype_id)
+            LOG.debug("Retyping newly cloned volume from type: %s to type: %s",
+                      self.image_type, vtype_id)
+            diff, discard = volume_types.volume_types_diff(
+                context, self.image_type, vtype_id)
+            host = {'capabilities': {'vendor_name': self.backend_name}}
+            self._retype_2_2(context, volume, vtype, diff, host)
+        return None, True
+
+    def _cache_vol_2_2(self, context, vol, image_meta, image_service):
+        image_id = image_meta['id']
+        # Pull down image and determine if valid
+        with image_utils.TemporaryImages.fetch(image_service,
+                                               context,
+                                               image_id) as tmp_image:
+            data = image_utils.qemu_img_info(tmp_image)
+            fmt = data.file_format
+            if fmt is None:
+                raise exception.ImageUnacceptable(
+                    reason=_("'qemu-img info' parsing failed."),
+                    image_id=image_id)
+
+            backing_file = data.backing_file
+            if backing_file is not None:
+                raise exception.ImageUnacceptable(
+                    image_id=image_id,
+                    reason=_("fmt=%(fmt)s backed by:%(backing_file)s")
+                    % {'fmt': fmt, 'backing_file': backing_file, })
+
+            vsize = int(
+                math.ceil(float(data.virtual_size) / units.Gi))
+            vol['size'] = vsize
+            vtype = vol['volume_type_id']
+            LOG.info("Creating cached image with volume type: %(vtype)s and "
+                     "size %(size)s", {'vtype': vtype, 'size': vsize})
+            self._create_volume_2_2(vol)
+            with self._connect_vol(context, vol) as device:
+                LOG.debug("Moving image %s to volume %s",
+                          image_meta['id'], datc.get_name(vol))
+                image_utils.convert_image(tmp_image,
+                                          device,
+                                          'raw',
+                                          run_as_root=True)
+                LOG.debug("Finished moving image %s to volume %s",
+                          image_meta['id'], datc.get_name(vol))
+                data = image_utils.qemu_img_info(device, run_as_root=True)
+                if data.file_format != 'raw':
+                    raise exception.ImageUnacceptable(
+                        image_id=image_id,
+                        reason=_(
+                            "Converted to %(vol_format)s, but format is "
+                            "now %(file_format)s") % {
+                                'vol_format': 'raw',
+                                'file_format': data.file_format})
+        # TODO(_alastor_): Remove this snapshot creation when we fix
+        # "created_at" attribute in the frontend
+        # We don't actually care about the snapshot uuid, we just want
+        # a single snapshot
+        snapshot = {'id': str(uuid.uuid4()),
+                    'volume_id': vol['id'],
+                    'project_id': vol['project_id']}
+        self._create_snapshot_2_2(snapshot)
+        metadata = {'type': 'cached_image'}
+        tenant = self.get_tenant(vol['project_id'])
+        ai = self.cvol_to_ai(vol, tenant=tenant)
+        ai.metadata.set(tenant=tenant, **metadata)
+        # Cloning offline AI is ~4 seconds faster than cloning online AI
+        self._detach_volume_2_2(None, vol)
+
+    def _get_vol_timestamp_2_2(self, volume):
+        tenant = self.get_tenant(volume['project_id'])
+        dvol = self.cvol_to_dvol(volume, tenant=tenant)
+        snapshots = dvol.snapshots.list(tenant=tenant)
+        if len(snapshots) == 1:
+            return float(snapshots[0].utc_ts)
+        else:
+            # We'll return 0 if we find no snapshots (or the incorrect number)
+            # to ensure the timestamp comparison with the master copy fails
+            # since the master copy will always have a timestamp > 0.
+            LOG.debug("Number of snapshots found: %s", len(snapshots))
+            return 0
+
+    def _vol_exists_2_2(self, volume):
+        LOG.debug("Checking if volume %s exists", volume['id'])
+        try:
+            ai = self.cvol_to_ai(volume)
+            LOG.debug("Volume %s exists", volume['id'])
+            return ai
+        except exception.NotFound:
+            LOG.debug("Volume %s not found", volume['id'])
+            return None
+
+    @contextlib.contextmanager
+    def _connect_vol(self, context, vol):
+        connector = None
+        try:
+            # Start connection, get the connector object and create the
+            # export (ACL, IP-Pools, etc)
+            conn = self._initialize_connection_2_2(
+                vol, {'multipath': False})
+            connector = utils.brick_get_connector(
+                conn['driver_volume_type'],
+                use_multipath=False,
+                device_scan_attempts=10,
+                conn=conn)
+            connector_info = {'initiator': connector.get_initiator()}
+            self._create_export_2_2(None, vol, connector_info)
+            retries = 10
+            attach_info = conn['data']
+            while True:
+                try:
+                    attach_info.update(
+                        connector.connect_volume(conn['data']))
+                    break
+                except brick_exception.FailedISCSITargetPortalLogin:
+                    retries -= 1
+                    if not retries:
+                        LOG.error("Could not log into portal before end of "
+                                  "polling period")
+                        raise
+                    LOG.debug("Failed to login to portal, retrying")
+                    eventlet.sleep(2)
+            device_path = attach_info['path']
+            yield device_path
+        finally:
+            # Close target connection
+            if connector:
+                # Best effort disconnection
+                try:
+                    connector.disconnect_volume(attach_info, attach_info)
+                except Exception:
+                    pass
+
+    # ===========
+    # = Polling =
+    # ===========
+
+    def _snap_poll_2_2(self, snap, tenant):
+        eventlet.sleep(datc.DEFAULT_SNAP_SLEEP)
+        TIMEOUT = 20
+        retry = 0
+        poll = True
+        while poll and not retry >= TIMEOUT:
+            retry += 1
+            snap = snap.reload(tenant=tenant)
+            if snap.op_state == 'available':
+                poll = False
+            else:
+                eventlet.sleep(1)
+        if retry >= TIMEOUT:
+            raise exception.VolumeDriverException(
+                message=_('Snapshot not ready.'))
+
+    def _si_poll_2_2(self, volume, si, tenant):
+        # Initial 4 second sleep required for some Datera versions
+        eventlet.sleep(datc.DEFAULT_SI_SLEEP)
+        TIMEOUT = 10
+        retry = 0
+        poll = True
+        while poll and not retry >= TIMEOUT:
+            retry += 1
+            si = si.reload(tenant=tenant)
+            if si.op_state == 'available':
+                poll = False
+            else:
+                eventlet.sleep(1)
+        if retry >= TIMEOUT:
+            raise exception.VolumeDriverException(
+                message=_('Resource not ready.'))
+
+    # ================
+    # = Volume Stats =
+    # ================
+
+    def _get_volume_stats_2_2(self, refresh=False):
+        # cluster_stats is defined by datera_iscsi
+        # pylint: disable=access-member-before-definition
+        if refresh or not self.cluster_stats:
+            try:
+                LOG.debug("Updating cluster stats info.")
+
+                results = self.api.system.get()
+                self.datera_version = results.sw_version
+
+                if 'uuid' not in results:
+                    LOG.error(
+                        'Failed to get updated stats from Datera Cluster.')
+
+                stats = {
+                    'volume_backend_name': self.backend_name,
+                    'vendor_name': 'Datera',
+                    'driver_version': self.VERSION,
+                    'storage_protocol': 'iSCSI',
+                    'total_capacity_gb': (
+                        int(results.total_capacity) / units.Gi),
+                    'free_capacity_gb': (
+                        int(results.available_capacity) / units.Gi),
+                    'total_flash_capacity_gb': (
+                        int(results.all_flash_total_capacity) / units.Gi),
+                    'total_hybrid_capacity_gb': (
+                        int(results.hybrid_total_capacity) / units.Gi),
+                    'free_flash_capacity_gb': (
+                        int(results.all_flash_available_capacity) / units.Gi),
+                    'free_hybrid_capacity_gb': (
+                        int(results.hybrid_available_capacity) / units.Gi),
+                    'reserved_percentage': 0,
+                    'QoS_support': True,
+                    'compression': results.get('compression_enabled', False),
+                    'compression_ratio': results.get('compression_ratio', '0'),
+                    'l3_enabled': results.get('l3_enabled', False),
+                    'filter_function': self.filterf,
+                    'goodness_function': self.goodnessf
+                }
+
+                self.cluster_stats = stats
+            except exception.DateraAPIException:
+                LOG.error('Failed to get updated stats from Datera cluster.')
+        return self.cluster_stats
+
+    # =======
+    # = QoS =
+    # =======
+
+    def _update_qos_2_2(self, volume, policies, clear_old=False):
+        tenant = self.get_tenant(volume['project_id'])
+        dvol = self.cvol_to_dvol(volume, tenant=tenant)
+        type_id = volume.get('volume_type_id', None)
+        if type_id is not None:
+            iops_per_gb = int(policies.get('iops_per_gb', 0))
+            bandwidth_per_gb = int(policies.get('bandwidth_per_gb', 0))
+            # Filter for just QOS policies in result. All of their keys
+            # should end with "max"
+            fpolicies = {k: int(v) for k, v in
+                         policies.items() if k.endswith("max")}
+            # Filter all 0 values from being passed
+            fpolicies = {k: int(v) for k, v in
+                         fpolicies.items() if v > 0}
+            # Calculate and set iops/gb and bw/gb, but only if they don't
+            # exceed total_iops_max and total_bw_max aren't set since they take
+            # priority
+            if iops_per_gb:
+                ipg = iops_per_gb * volume['size']
+                # Not using zero, because zero means unlimited
+                im = fpolicies.get('total_iops_max', 1)
+                r = ipg
+                if ipg > im:
+                    r = im
+                fpolicies['total_iops_max'] = r
+            if bandwidth_per_gb:
+                bpg = bandwidth_per_gb * volume['size']
+                # Not using zero, because zero means unlimited
+                bm = fpolicies.get('total_bandwidth_max', 1)
+                r = bpg
+                if bpg > bm:
+                    r = bm
+                fpolicies['total_bandwidth_max'] = r
+            if fpolicies or clear_old:
+                try:
+                    pp = dvol.performance_policy.get(tenant=tenant)
+                    pp.delete(tenant=tenant)
+                except dexceptions.ApiNotFoundError:
+                    LOG.debug("No existing performance policy found")
+            if fpolicies:
+                dvol.performance_policy.create(tenant=tenant, **fpolicies)
+
+    # ============
+    # = IP Pools =
+    # ============
+
+    def _get_ip_pool_for_string_ip_2_2(self, ip, tenant):
+        """Takes a string ipaddress and return the ip_pool API object dict """
+        pool = 'default'
+        ip_obj = ipaddress.ip_address(six.text_type(ip))
+        ip_pools = self.api.access_network_ip_pools.list(tenant=tenant)
+        for ipdata in ip_pools:
+            for adata in ipdata['network_paths']:
+                if not adata.get('start_ip'):
+                    continue
+                pool_if = ipaddress.ip_interface(
+                    "/".join((adata['start_ip'], str(adata['netmask']))))
+                if ip_obj in pool_if.network:
+                    pool = ipdata.name
+        return self.api.access_network_ip_pools.get(pool, tenant=tenant).path
+    # ====================
+    # = Volume Migration =
+    # ====================
+
+    def _update_migrated_volume_2_2(self, context, volume, new_volume,
+                                    volume_status):
+        """Rename the newly created volume to the original volume.
+
+        So we can find it correctly.
+        """
+        tenant = self.get_tenant(new_volume['project_id'])
+        ai = self.cvol_to_ai(new_volume, tenant=tenant)
+        data = {'name': datc.get_name(volume)}
+        ai.set(tenant=tenant, **data)
+        return {'_name_id': None}
+
+    @contextlib.contextmanager
+    def _offline_flip_2_2(self, volume):
+        reonline = False
+        tenant = self.get_tenant(volume['project_id'])
+        ai = self.cvol_to_ai(volume, tenant=tenant)
+        if ai.admin_state == 'online':
+            reonline = True
+        ai.set(tenant=tenant, admin_state='offline')
+        yield
+        if reonline:
+            ai.set(tenant=tenant, admin_state='online')
+
+    def _add_vol_meta_2_2(self, volume, connector=None):
+        if not self.do_metadata:
+            return
+        metadata = {'host': volume.get('host', ''),
+                    'display_name': datc.filter_chars(
+                        volume.get('display_name', '')),
+                    'bootable': str(volume.get('bootable', False)),
+                    'availability_zone': volume.get('availability_zone', '')}
+        if connector:
+            metadata.update(connector)
+        LOG.debug("Adding volume metadata: %s", metadata)
+        tenant = self.get_tenant(volume['project_id'])
+        ai = self.cvol_to_ai(volume, tenant=tenant)
+        ai.metadata.set(tenant=tenant, **metadata)
+
+    def _support_template_override_2_2(self):
+        # Getting the whole api schema is expensive
+        # so we only want to do this once per driver
+        # instantiation.
+        if not self.template_override:
+            return False
+        if not hasattr(self, '_to_22'):
+            api = self.api.api.get()
+            prop = api['/app_instances']['create']['bodyParamSchema'][
+                'properties']
+            self._to_22 = 'template_override' in prop
+        return self._to_22
diff -pruN 2:15.0.1-1/cinder/volume/drivers/datera/datera_api2.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/datera/datera_api2.py
--- 2:15.0.1-1/cinder/volume/drivers/datera/datera_api2.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/datera/datera_api2.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,765 +0,0 @@
-# Copyright 2017 Datera
-# All Rights Reserved.
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-
-import re
-import uuid
-
-import eventlet
-import ipaddress
-import six
-
-from oslo_log import log as logging
-from oslo_utils import excutils
-from oslo_utils import units
-
-from cinder import exception
-from cinder.i18n import _
-from cinder.volume import volume_utils
-
-import cinder.volume.drivers.datera.datera_common as datc
-
-LOG = logging.getLogger(__name__)
-
-
-class DateraApi(object):
-
-    # =================
-    # = Create Volume =
-    # =================
-
-    def _create_volume_2(self, volume):
-        # Generate App Instance, Storage Instance and Volume
-        # Volume ID will be used as the App Instance Name
-        # Storage Instance and Volumes will have standard names
-        policies = self._get_policies_for_resource(volume)
-        num_replicas = int(policies['replica_count'])
-        storage_name = policies['default_storage_name']
-        volume_name = policies['default_volume_name']
-        template = policies['template']
-
-        if template:
-            app_params = (
-                {
-                    'create_mode': "openstack",
-                    # 'uuid': str(volume['id']),
-                    'name': datc._get_name(volume['id']),
-                    'app_template': '/app_templates/{}'.format(template)
-                })
-        else:
-
-            app_params = (
-                {
-                    'create_mode': "openstack",
-                    'uuid': str(volume['id']),
-                    'name': datc._get_name(volume['id']),
-                    'access_control_mode': 'deny_all',
-                    'storage_instances': {
-                        storage_name: {
-                            'name': storage_name,
-                            'volumes': {
-                                volume_name: {
-                                    'name': volume_name,
-                                    'size': volume['size'],
-                                    'replica_count': num_replicas,
-                                    'snapshot_policies': {
-                                    }
-                                }
-                            }
-                        }
-                    }
-                })
-        self._issue_api_request(
-            datc.URL_TEMPLATES['ai'](),
-            'post',
-            body=app_params,
-            api_version='2')
-        self._update_qos(volume, policies)
-
-    # =================
-    # = Extend Volume =
-    # =================
-
-    def _extend_volume_2(self, volume, new_size):
-        # Current product limitation:
-        # If app_instance is bound to template resizing is not possible
-        # Once policies are implemented in the product this can go away
-        policies = self._get_policies_for_resource(volume)
-        template = policies['template']
-        if template:
-            LOG.warning("Volume size not extended due to template binding:"
-                        " volume: %(volume)s, template: %(template)s",
-                        volume=volume, template=template)
-            return
-
-        # Offline App Instance, if necessary
-        reonline = False
-        app_inst = self._issue_api_request(
-            datc.URL_TEMPLATES['ai_inst']().format(
-                datc._get_name(volume['id'])),
-            api_version='2')
-        if app_inst['admin_state'] == 'online':
-            reonline = True
-            self._detach_volume_2(None, volume)
-        # Change Volume Size
-        app_inst = datc._get_name(volume['id'])
-        data = {
-            'size': new_size
-        }
-        store_name, vol_name = self._scrape_template(policies)
-        self._issue_api_request(
-            datc.URL_TEMPLATES['vol_inst'](
-                store_name, vol_name).format(app_inst),
-            method='put',
-            body=data,
-            api_version='2')
-        # Online Volume, if it was online before
-        if reonline:
-            self._create_export_2(None, volume, None)
-
-    # =================
-    # = Cloned Volume =
-    # =================
-
-    def _create_cloned_volume_2(self, volume, src_vref):
-        policies = self._get_policies_for_resource(volume)
-
-        store_name, vol_name = self._scrape_template(policies)
-
-        src = "/" + datc.URL_TEMPLATES['vol_inst'](
-            store_name, vol_name).format(datc._get_name(src_vref['id']))
-        data = {
-            'create_mode': 'openstack',
-            'name': datc._get_name(volume['id']),
-            'uuid': str(volume['id']),
-            'clone_src': src,
-        }
-        self._issue_api_request(
-            datc.URL_TEMPLATES['ai'](), 'post', body=data, api_version='2')
-
-        if volume['size'] > src_vref['size']:
-            self._extend_volume_2(volume, volume['size'])
-
-    # =================
-    # = Delete Volume =
-    # =================
-
-    def _delete_volume_2(self, volume):
-        self.detach_volume(None, volume)
-        app_inst = datc._get_name(volume['id'])
-        try:
-            self._issue_api_request(datc.URL_TEMPLATES['ai_inst']().format(
-                app_inst),
-                method='delete',
-                api_version='2')
-        except exception.NotFound:
-            LOG.info("Tried to delete volume %s, but it was not found in the "
-                     "Datera cluster. Continuing with delete.",
-                     datc._get_name(volume['id']))
-
-    # =================
-    # = Ensure Export =
-    # =================
-
-    def _ensure_export_2(self, context, volume, connector):
-        return self._create_export_2(context, volume, connector)
-
-    # =========================
-    # = Initialize Connection =
-    # =========================
-
-    def _initialize_connection_2(self, volume, connector):
-        # Now online the app_instance (which will online all storage_instances)
-        multipath = connector.get('multipath', False)
-        url = datc.URL_TEMPLATES['ai_inst']().format(
-            datc._get_name(volume['id']))
-        data = {
-            'admin_state': 'online'
-        }
-        app_inst = self._issue_api_request(
-            url, method='put', body=data, api_version='2')
-        storage_instances = app_inst["storage_instances"]
-        si_names = list(storage_instances.keys())
-
-        portal = storage_instances[si_names[0]]['access']['ips'][0] + ':3260'
-        iqn = storage_instances[si_names[0]]['access']['iqn']
-        if multipath:
-            portals = [p + ':3260' for p in
-                       storage_instances[si_names[0]]['access']['ips']]
-            iqns = [iqn for _ in
-                    storage_instances[si_names[0]]['access']['ips']]
-            lunids = [self._get_lunid() for _ in
-                      storage_instances[si_names[0]]['access']['ips']]
-
-            return {
-                'driver_volume_type': 'iscsi',
-                'data': {
-                    'target_discovered': False,
-                    'target_iqn': iqn,
-                    'target_iqns': iqns,
-                    'target_portal': portal,
-                    'target_portals': portals,
-                    'target_lun': self._get_lunid(),
-                    'target_luns': lunids,
-                    'volume_id': volume['id'],
-                    'discard': False}}
-        else:
-            return {
-                'driver_volume_type': 'iscsi',
-                'data': {
-                    'target_discovered': False,
-                    'target_iqn': iqn,
-                    'target_portal': portal,
-                    'target_lun': self._get_lunid(),
-                    'volume_id': volume['id'],
-                    'discard': False}}
-
-    # =================
-    # = Create Export =
-    # =================
-
-    def _create_export_2(self, context, volume, connector):
-        # Online volume in case it hasn't been already
-        url = datc.URL_TEMPLATES['ai_inst']().format(
-            datc._get_name(volume['id']))
-        data = {
-            'admin_state': 'online'
-        }
-        self._issue_api_request(url, method='put', body=data, api_version='2')
-        # Check if we've already setup everything for this volume
-        url = (datc.URL_TEMPLATES['si']().format(datc._get_name(volume['id'])))
-        storage_instances = self._issue_api_request(url, api_version='2')
-        # Handle adding initiator to product if necessary
-        # Then add initiator to ACL
-        policies = self._get_policies_for_resource(volume)
-
-        store_name, _ = self._scrape_template(policies)
-
-        if (connector and
-                connector.get('initiator') and
-                not policies['acl_allow_all']):
-            initiator_name = "OpenStack_{}_{}".format(
-                self.driver_prefix, str(uuid.uuid4())[:4])
-            initiator_group = datc.INITIATOR_GROUP_PREFIX + volume['id']
-            found = False
-            initiator = connector['initiator']
-            current_initiators = self._issue_api_request(
-                'initiators', api_version='2')
-            for iqn, values in current_initiators.items():
-                if initiator == iqn:
-                    found = True
-                    break
-            # If we didn't find a matching initiator, create one
-            if not found:
-                data = {'id': initiator, 'name': initiator_name}
-                # Try and create the initiator
-                # If we get a conflict, ignore it because race conditions
-                self._issue_api_request("initiators",
-                                        method="post",
-                                        body=data,
-                                        conflict_ok=True,
-                                        api_version='2')
-            # Create initiator group with initiator in it
-            initiator_path = "/initiators/{}".format(initiator)
-            initiator_group_path = "/initiator_groups/{}".format(
-                initiator_group)
-            ig_data = {'name': initiator_group, 'members': [initiator_path]}
-            self._issue_api_request("initiator_groups",
-                                    method="post",
-                                    body=ig_data,
-                                    conflict_ok=True,
-                                    api_version='2')
-            # Create ACL with initiator group as reference for each
-            # storage_instance in app_instance
-            # TODO(_alastor_): We need to avoid changing the ACLs if the
-            # template already specifies an ACL policy.
-            for si_name in storage_instances.keys():
-                acl_url = (datc.URL_TEMPLATES['si']() +
-                           "/{}/acl_policy").format(
-                    datc._get_name(volume['id']), si_name)
-                existing_acl = self._issue_api_request(acl_url,
-                                                       method="get",
-                                                       api_version='2')
-                data = {}
-                data['initiators'] = existing_acl['initiators']
-                data['initiator_groups'] = existing_acl['initiator_groups']
-                data['initiator_groups'].append(initiator_group_path)
-                self._issue_api_request(acl_url,
-                                        method="put",
-                                        body=data,
-                                        api_version='2')
-
-        if connector and connector.get('ip'):
-            try:
-                # Case where volume_type has non default IP Pool info
-                if policies['ip_pool'] != 'default':
-                    initiator_ip_pool_path = self._issue_api_request(
-                        "access_network_ip_pools/{}".format(
-                            policies['ip_pool']), api_version='2')['path']
-                # Fallback to trying reasonable IP based guess
-                else:
-                    initiator_ip_pool_path = self._get_ip_pool_for_string_ip(
-                        connector['ip'])
-
-                ip_pool_url = datc.URL_TEMPLATES['si_inst'](
-                    store_name).format(datc._get_name(volume['id']))
-                ip_pool_data = {'ip_pool': initiator_ip_pool_path}
-                self._issue_api_request(ip_pool_url,
-                                        method="put",
-                                        body=ip_pool_data,
-                                        api_version='2')
-            except exception.DateraAPIException:
-                # Datera product 1.0 support
-                pass
-
-        # Check to ensure we're ready for go-time
-        self._si_poll(volume, policies)
-
-    # =================
-    # = Detach Volume =
-    # =================
-
-    def _detach_volume_2(self, context, volume, attachment=None):
-        url = datc.URL_TEMPLATES['ai_inst']().format(
-            datc._get_name(volume['id']))
-        data = {
-            'admin_state': 'offline',
-            'force': True
-        }
-        try:
-            self._issue_api_request(url, method='put', body=data,
-                                    api_version='2')
-        except exception.NotFound:
-            msg = ("Tried to detach volume %s, but it was not found in the "
-                   "Datera cluster. Continuing with detach.")
-            LOG.info(msg, volume['id'])
-        # TODO(_alastor_): Make acl cleaning multi-attach aware
-        self._clean_acl_2(volume)
-
-    def _check_for_acl_2(self, initiator_path):
-        """Returns True if an acl is found for initiator_path """
-        # TODO(_alastor_) when we get a /initiators/:initiator/acl_policies
-        # endpoint use that instead of this monstrosity
-        initiator_groups = self._issue_api_request("initiator_groups",
-                                                   api_version='2')
-        for ig, igdata in initiator_groups.items():
-            if initiator_path in igdata['members']:
-                LOG.debug("Found initiator_group: %s for initiator: %s",
-                          ig, initiator_path)
-                return True
-        LOG.debug("No initiator_group found for initiator: %s", initiator_path)
-        return False
-
-    def _clean_acl_2(self, volume):
-        policies = self._get_policies_for_resource(volume)
-
-        store_name, _ = self._scrape_template(policies)
-
-        acl_url = (datc.URL_TEMPLATES["si_inst"](
-            store_name) + "/acl_policy").format(datc._get_name(volume['id']))
-        try:
-            initiator_group = self._issue_api_request(
-                acl_url, api_version='2')['initiator_groups'][0]
-            initiator_iqn_path = self._issue_api_request(
-                initiator_group.lstrip("/"))["members"][0]
-            # Clear out ACL and delete initiator group
-            self._issue_api_request(acl_url,
-                                    method="put",
-                                    body={'initiator_groups': []},
-                                    api_version='2')
-            self._issue_api_request(initiator_group.lstrip("/"),
-                                    method="delete",
-                                    api_version='2')
-            if not self._check_for_acl_2(initiator_iqn_path):
-                self._issue_api_request(initiator_iqn_path.lstrip("/"),
-                                        method="delete",
-                                        api_version='2')
-        except (IndexError, exception.NotFound):
-            LOG.debug("Did not find any initiator groups for volume: %s",
-                      volume)
-
-    # ===================
-    # = Create Snapshot =
-    # ===================
-
-    def _create_snapshot_2(self, snapshot):
-        policies = self._get_policies_for_resource(snapshot)
-
-        store_name, vol_name = self._scrape_template(policies)
-
-        url_template = datc.URL_TEMPLATES['vol_inst'](
-            store_name, vol_name) + '/snapshots'
-        url = url_template.format(datc._get_name(snapshot['volume_id']))
-
-        snap_params = {
-            'uuid': snapshot['id'],
-        }
-        snap = self._issue_api_request(url, method='post', body=snap_params,
-                                       api_version='2')
-        snapu = "/".join((url, snap['timestamp']))
-        self._snap_poll(snapu)
-
-    # ===================
-    # = Delete Snapshot =
-    # ===================
-
-    def _delete_snapshot_2(self, snapshot):
-        policies = self._get_policies_for_resource(snapshot)
-
-        store_name, vol_name = self._scrape_template(policies)
-
-        snap_temp = datc.URL_TEMPLATES['vol_inst'](
-            store_name, vol_name) + '/snapshots'
-        snapu = snap_temp.format(datc._get_name(snapshot['volume_id']))
-        snapshots = self._issue_api_request(snapu, method='get',
-                                            api_version='2')
-
-        try:
-            for ts, snap in snapshots.items():
-                if snap['uuid'] == snapshot['id']:
-                    url_template = snapu + '/{}'
-                    url = url_template.format(ts)
-                    self._issue_api_request(url, method='delete',
-                                            api_version='2')
-                    break
-            else:
-                raise exception.NotFound
-        except exception.NotFound:
-            msg = ("Tried to delete snapshot %s, but was not found in "
-                   "Datera cluster. Continuing with delete.")
-            LOG.info(msg, datc._get_name(snapshot['id']))
-
-    # ========================
-    # = Volume From Snapshot =
-    # ========================
-
-    def _create_volume_from_snapshot_2(self, volume, snapshot):
-        policies = self._get_policies_for_resource(snapshot)
-
-        store_name, vol_name = self._scrape_template(policies)
-
-        snap_temp = datc.URL_TEMPLATES['vol_inst'](
-            store_name, vol_name) + '/snapshots'
-        snapu = snap_temp.format(datc._get_name(snapshot['volume_id']))
-        snapshots = self._issue_api_request(snapu, method='get',
-                                            api_version='2')
-        for ts, snap in snapshots.items():
-            if snap['uuid'] == snapshot['id']:
-                found_ts = ts
-                break
-        else:
-            raise exception.NotFound
-
-        snap_url = (snap_temp + '/{}').format(
-            datc._get_name(snapshot['volume_id']), found_ts)
-
-        self._snap_poll(snap_url)
-
-        src = "/" + snap_url
-        app_params = (
-            {
-                'create_mode': 'openstack',
-                'uuid': str(volume['id']),
-                'name': datc._get_name(volume['id']),
-                'clone_src': src,
-            })
-        self._issue_api_request(
-            datc.URL_TEMPLATES['ai'](),
-            method='post',
-            body=app_params,
-            api_version='2')
-
-        if (volume['size'] > snapshot['volume_size']):
-            self._extend_volume_2(volume, volume['size'])
-
-    # ==========
-    # = Manage =
-    # ==========
-
-    def _manage_existing_2(self, volume, existing_ref):
-        existing_ref = existing_ref['source-name']
-        if existing_ref.count(":") != 2:
-            raise exception.ManageExistingInvalidReference(
-                _("existing_ref argument must be of this format:"
-                  "app_inst_name:storage_inst_name:vol_name"))
-        app_inst_name = existing_ref.split(":")[0]
-        LOG.debug("Managing existing Datera volume %s.  "
-                  "Changing name to %s",
-                  datc._get_name(volume['id']),
-                  existing_ref)
-        data = {'name': datc._get_name(volume['id'])}
-        self._issue_api_request(datc.URL_TEMPLATES['ai_inst']().format(
-            app_inst_name), method='put', body=data, api_version='2')
-
-    # ===================
-    # = Manage Get Size =
-    # ===================
-
-    def _manage_existing_get_size_2(self, volume, existing_ref):
-        existing_ref = existing_ref['source-name']
-        if existing_ref.count(":") != 2:
-            raise exception.ManageExistingInvalidReference(
-                _("existing_ref argument must be of this format:"
-                  "app_inst_name:storage_inst_name:vol_name"))
-        app_inst_name, si_name, vol_name = existing_ref.split(":")
-        app_inst = self._issue_api_request(
-            datc.URL_TEMPLATES['ai_inst']().format(app_inst_name),
-            api_version='2')
-        return self._get_size_2(volume, app_inst, si_name, vol_name)
-
-    def _get_size_2(self, volume, app_inst=None, si_name=None, vol_name=None):
-        """Helper method for getting the size of a backend object
-
-        If app_inst is provided, we'll just parse the dict to get
-        the size instead of making a separate http request
-        """
-        policies = self._get_policies_for_resource(volume)
-        si_name = si_name if si_name else policies['default_storage_name']
-        vol_name = vol_name if vol_name else policies['default_volume_name']
-        if not app_inst:
-            vol_url = datc.URL_TEMPLATES['ai_inst']().format(
-                datc._get_name(volume['id']))
-            app_inst = self._issue_api_request(vol_url)
-        size = app_inst[
-            'storage_instances'][si_name]['volumes'][vol_name]['size']
-        return size
-
-    # =========================
-    # = Get Manageable Volume =
-    # =========================
-
-    def _get_manageable_volumes_2(self, cinder_volumes, marker, limit, offset,
-                                  sort_keys, sort_dirs):
-        LOG.debug("Listing manageable Datera volumes")
-        app_instances = self._issue_api_request(
-            datc.URL_TEMPLATES['ai'](), api_version='2').values()
-
-        results = []
-
-        cinder_volume_ids = [vol['id'] for vol in cinder_volumes]
-
-        for ai in app_instances:
-            ai_name = ai['name']
-            reference = None
-            size = None
-            safe_to_manage = False
-            reason_not_safe = None
-            cinder_id = None
-            extra_info = None
-            if re.match(datc.UUID4_RE, ai_name):
-                cinder_id = ai_name.lstrip(datc.OS_PREFIX)
-            if (not cinder_id and
-                    ai_name.lstrip(datc.OS_PREFIX) not in cinder_volume_ids):
-                safe_to_manage = self._is_manageable(ai)
-            if safe_to_manage:
-                si = list(ai['storage_instances'].values())[0]
-                si_name = si['name']
-                vol = list(si['volumes'].values())[0]
-                vol_name = vol['name']
-                size = vol['size']
-                reference = {"source-name": "{}:{}:{}".format(
-                    ai_name, si_name, vol_name)}
-
-            results.append({
-                'reference': reference,
-                'size': size,
-                'safe_to_manage': safe_to_manage,
-                'reason_not_safe': reason_not_safe,
-                'cinder_id': cinder_id,
-                'extra_info': extra_info})
-
-        page_results = volume_utils.paginate_entries_list(
-            results, marker, limit, offset, sort_keys, sort_dirs)
-
-        return page_results
-
-    # ============
-    # = Unmanage =
-    # ============
-
-    def _unmanage_2(self, volume):
-        LOG.debug("Unmanaging Cinder volume %s.  Changing name to %s",
-                  volume['id'], datc._get_unmanaged(volume['id']))
-        data = {'name': datc._get_unmanaged(volume['id'])}
-        self._issue_api_request(datc.URL_TEMPLATES['ai_inst']().format(
-            datc._get_name(volume['id'])),
-            method='put',
-            body=data,
-            api_version='2')
-
-    # ================
-    # = Volume Stats =
-    # ================
-
-    def _get_volume_stats_2(self, refresh=False):
-        if refresh or not self.cluster_stats:
-            try:
-                LOG.debug("Updating cluster stats info.")
-
-                results = self._issue_api_request('system', api_version='2')
-
-                if 'uuid' not in results:
-                    LOG.error(
-                        'Failed to get updated stats from Datera Cluster.')
-
-                backend_name = self.configuration.safe_get(
-                    'volume_backend_name')
-                stats = {
-                    'volume_backend_name': backend_name or 'Datera',
-                    'vendor_name': 'Datera',
-                    'driver_version': self.VERSION,
-                    'storage_protocol': 'iSCSI',
-                    'total_capacity_gb': (
-                        int(results['total_capacity']) / units.Gi),
-                    'free_capacity_gb': (
-                        int(results['available_capacity']) / units.Gi),
-                    'reserved_percentage': 0,
-                }
-
-                self.cluster_stats = stats
-            except exception.DateraAPIException:
-                LOG.error('Failed to get updated stats from Datera cluster.')
-        return self.cluster_stats
-
-    def _is_manageable(self, app_inst):
-        if len(app_inst['storage_instances']) == 1:
-            si = list(app_inst['storage_instances'].values())[0]
-            if len(si['volumes']) == 1:
-                return True
-        return False
-
-    # =========
-    # = Login =
-    # =========
-
-    def _login_2(self):
-        """Use the san_login and san_password to set token."""
-        body = {
-            'name': self.username,
-            'password': self.password
-        }
-
-        # Unset token now, otherwise potential expired token will be sent
-        # along to be used for authorization when trying to login.
-        self.datera_api_token = None
-
-        try:
-            LOG.debug('Getting Datera auth token.')
-            results = self._issue_api_request('login', 'put', body=body,
-                                              sensitive=True, api_version='2')
-            self.datera_api_token = results['key']
-        except exception.NotAuthorized:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Logging into the Datera cluster failed. Please '
-                          'check your username and password set in the '
-                          'cinder.conf and start the cinder-volume '
-                          'service again.')
-
-    # ===========
-    # = Polling =
-    # ===========
-
-    def _snap_poll(self, url):
-        eventlet.sleep(datc.DEFAULT_SNAP_SLEEP)
-        TIMEOUT = 10
-        retry = 0
-        poll = True
-        while poll and retry < TIMEOUT:
-            retry += 1
-            snap = self._issue_api_request(url, api_version='2')
-            if snap['op_state'] == 'available':
-                poll = False
-            else:
-                eventlet.sleep(1)
-        if retry >= TIMEOUT:
-            raise exception.VolumeDriverException(
-                message=_('Snapshot not ready.'))
-
-    def _si_poll(self, volume, policies):
-        # Initial 4 second sleep required for some Datera versions
-        eventlet.sleep(datc.DEFAULT_SI_SLEEP_API_2)
-        TIMEOUT = 10
-        retry = 0
-        check_url = datc.URL_TEMPLATES['si_inst'](
-            policies['default_storage_name']).format(
-                datc._get_name(volume['id']))
-        poll = True
-        while poll and retry < TIMEOUT:
-            retry += 1
-            si = self._issue_api_request(check_url, api_version='2')
-            if si['op_state'] == 'available':
-                poll = False
-            else:
-                eventlet.sleep(1)
-        if retry >= TIMEOUT:
-            raise exception.VolumeDriverException(
-                message=_('Resource not ready.'))
-
-    # ============
-    # = IP Pools =
-    # ============
-
-    def _get_ip_pool_for_string_ip(self, ip):
-        """Takes a string ipaddress and return the ip_pool API object dict """
-        pool = 'default'
-        ip_obj = ipaddress.ip_address(six.text_type(ip))
-        ip_pools = self._issue_api_request('access_network_ip_pools',
-                                           api_version='2')
-        for ip_pool, ipdata in ip_pools.items():
-            for access, adata in ipdata['network_paths'].items():
-                if not adata.get('start_ip'):
-                    continue
-                pool_if = ipaddress.ip_interface(
-                    "/".join((adata['start_ip'], str(adata['netmask']))))
-                if ip_obj in pool_if.network:
-                    pool = ip_pool
-        return self._issue_api_request(
-            "access_network_ip_pools/{}".format(pool), api_version='2')['path']
-
-    # =============
-    # = Templates =
-    # =============
-
-    def _scrape_template(self, policies):
-        sname = policies['default_storage_name']
-        vname = policies['default_volume_name']
-
-        template = policies['template']
-        if template:
-            result = self._issue_api_request(
-                datc.URL_TEMPLATES['at']().format(template), api_version='2')
-            sname, st = list(result['storage_templates'].items())[0]
-            vname = list(st['volume_templates'].keys())[0]
-        return sname, vname
-
-    # =======
-    # = QoS =
-    # =======
-
-    def _update_qos(self, resource, policies):
-        url = datc.URL_TEMPLATES['vol_inst'](
-            policies['default_storage_name'],
-            policies['default_volume_name']) + '/performance_policy'
-        url = url.format(datc._get_name(resource['id']))
-        type_id = resource.get('volume_type_id', None)
-        if type_id is not None:
-            # Filter for just QOS policies in result. All of their keys
-            # should end with "max"
-            fpolicies = {k: int(v) for k, v in
-                         policies.items() if k.endswith("max")}
-            # Filter all 0 values from being passed
-            fpolicies = dict(filter(lambda _v: _v[1] > 0, fpolicies.items()))
-            if fpolicies:
-                self._issue_api_request(url, 'post', body=fpolicies,
-                                        api_version='2')
diff -pruN 2:15.0.1-1/cinder/volume/drivers/datera/datera_common.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/datera/datera_common.py
--- 2:15.0.1-1/cinder/volume/drivers/datera/datera_common.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/datera/datera_common.py	2020-03-24 18:46:31.000000000 +0000
@@ -1,4 +1,4 @@
-# Copyright 2017 Datera
+# Copyright 2020 Datera
 # All Rights Reserved.
 #
 #    Licensed under the Apache License, Version 2.0 (the "License"); you may
@@ -14,229 +14,138 @@
 #    under the License.
 
 import functools
-import json
+import random
 import re
-import six
+import string
 import time
 import types
 import uuid
 
-import eventlet
-import requests
-
+from glanceclient import exc as glance_exc
 from oslo_log import log as logging
-from six.moves import http_client
+from oslo_utils import importutils
 
 from cinder import context
 from cinder import exception
 from cinder.i18n import _
+from cinder.image import glance
 from cinder.volume import qos_specs
 from cinder.volume import volume_types
 
-
 LOG = logging.getLogger(__name__)
-OS_PREFIX = "OS-"
-UNMANAGE_PREFIX = "UNMANAGED-"
+
+dfs_sdk = importutils.try_import('dfs_sdk')
+
+OS_PREFIX = "OS"
+UNMANAGE_PREFIX = "UNMANAGED"
 
 # Taken from this SO post :
 # http://stackoverflow.com/a/18516125
 # Using old-style string formatting because of the nature of the regex
 # conflicting with new-style curly braces
-UUID4_STR_RE = ("%s[a-f0-9]{8}-?[a-f0-9]{4}-?4[a-f0-9]{3}-?[89ab]"
-                "[a-f0-9]{3}-?[a-f0-9]{12}")
+UUID4_STR_RE = ("%s.*([a-f0-9]{8}-?[a-f0-9]{4}-?4[a-f0-9]{3}-?[89ab]"
+                "[a-f0-9]{3}-?[a-f0-9]{12})")
 UUID4_RE = re.compile(UUID4_STR_RE % OS_PREFIX)
+SNAP_RE = re.compile(r"\d{10,}\.\d+")
 
 # Recursive dict to assemble basic url structure for the most common
 # API URL endpoints. Most others are constructed from these
-URL_TEMPLATES = {
-    'ai': lambda: 'app_instances',
-    'ai_inst': lambda: (URL_TEMPLATES['ai']() + '/{}'),
-    'si': lambda: (URL_TEMPLATES['ai_inst']() + '/storage_instances'),
-    'si_inst': lambda storage_name: (
-        (URL_TEMPLATES['si']() + '/{}').format(
-            '{}', storage_name)),
-    'vol': lambda storage_name: (
-        (URL_TEMPLATES['si_inst'](storage_name) + '/volumes')),
-    'vol_inst': lambda storage_name, volume_name: (
-        (URL_TEMPLATES['vol'](storage_name) + '/{}').format(
-            '{}', volume_name)),
-    'at': lambda: 'app_templates/{}'}
-
 DEFAULT_SI_SLEEP = 1
 DEFAULT_SI_SLEEP_API_2 = 5
 DEFAULT_SNAP_SLEEP = 1
-INITIATOR_GROUP_PREFIX = "IG-"
-API_VERSIONS = ["2", "2.1"]
+API_VERSIONS = ["2.1", "2.2"]
 API_TIMEOUT = 20
 
-###############
-# METADATA KEYS
-###############
-
-M_TYPE = 'cinder_volume_type'
-M_CALL = 'cinder_calls'
-M_CLONE = 'cinder_clone_from'
-M_MANAGED = 'cinder_managed'
-
-M_KEYS = [M_TYPE, M_CALL, M_CLONE, M_MANAGED]
+VALID_CHARS = set(string.ascii_letters + string.digits + "-_.")
 
 
 class DateraAPIException(exception.VolumeBackendAPIException):
     message = _("Bad response from Datera API")
 
 
-def _get_name(name):
-    return "".join((OS_PREFIX, name))
-
+def get_name(resource):
+    dn = resource.get('display_name')
+    cid = resource.get('id')
+    if dn:
+        dn = filter_chars(dn)
+        # Check to ensure the name is short enough to fit.  Prioritize
+        # the prefix and Cinder ID, strip all invalid characters
+        nl = len(OS_PREFIX) + len(dn) + len(cid) + 2
+        if nl >= 64:
+            dn = dn[:-(nl - 63)]
+        return "-".join((OS_PREFIX, dn, cid))
+    return "-".join((OS_PREFIX, cid))
+
+
+def get_unmanaged(name):
+    return "-".join((UNMANAGE_PREFIX, name))
+
+
+def filter_chars(s):
+    if s:
+        return ''.join([c for c in s if c in VALID_CHARS])
+    return s
 
-def _get_unmanaged(name):
-    return "".join((UNMANAGE_PREFIX, name))
 
-
-def _authenticated(func):
-    """Ensure the driver is authenticated to make a request.
-
-    In do_setup() we fetch an auth token and store it. If that expires when
-    we do API request, we'll fetch a new one.
-    """
-    @functools.wraps(func)
-    def func_wrapper(driver, *args, **kwargs):
-        try:
-            return func(driver, *args, **kwargs)
-        except exception.NotAuthorized:
-            # Prevent recursion loop. After the driver arg is the
-            # resource_type arg from _issue_api_request(). If attempt to
-            # login failed, we should just give up.
-            if args[0] == 'login':
-                raise
-
-            # Token might've expired, get a new one, try again.
-            driver.login()
-            return func(driver, *args, **kwargs)
-    return func_wrapper
-
-
-def _api_lookup(func):
-    """Perform a dynamic API implementation lookup for a call
-
-    Naming convention follows this pattern:
-
-        # original_func(args) --> _original_func_X_?Y?(args)
-        # where X and Y are the major and minor versions of the latest
-        # supported API version
-
-        # From the Datera box we've determined that it supports API
-        # versions ['2', '2.1']
-        # This is the original function call
-        @_api_lookup
-        def original_func(arg1, arg2):
-            print("I'm a shim, this won't get executed!")
-            pass
-
-        # This is the function that is actually called after determining
-        # the correct API version to use
-        def _original_func_2_1(arg1, arg2):
-            some_version_2_1_implementation_here()
-
-        # This is the function that would be called if the previous function
-        # did not exist:
-        def _original_func_2(arg1, arg2):
-            some_version_2_implementation_here()
-
-        # This function would NOT be called, because the connected Datera box
-        # does not support the 1.5 version of the API
-        def _original_func_1_5(arg1, arg2):
-            some_version_1_5_implementation_here()
-    """
+def lookup(func):
     @functools.wraps(func)
     def wrapper(*args, **kwargs):
         obj = args[0]
-        api_versions = _get_supported_api_versions(obj)
-        api_version = None
-        index = -1
-        while True:
-            try:
-                api_version = api_versions[index]
-            except (IndexError, KeyError):
-                msg = _("No compatible API version found for this product: "
-                        "api_versions -> %(api_version)s, %(func)s")
-                LOG.error(msg, api_version=api_version, func=func)
-                raise DateraAPIException(msg % {
-                    'api_version': api_version, 'func': func})
-            # Py27
-            try:
-                name = "_" + "_".join(
-                    (func.func_name, api_version.replace(".", "_")))
-            # Py3+
-            except AttributeError:
-                name = "_" + "_".join(
-                    (func.__name__, api_version.replace(".", "_")))
-            try:
-                if obj.do_profile:
-                    LOG.info("Trying method: %s", name)
-                    call_id = uuid.uuid4()
-                    LOG.debug("Profiling method: %s, id %s", name, call_id)
-                    t1 = time.time()
-                    obj.thread_local.trace_id = call_id
-                result = getattr(obj, name)(*args[1:], **kwargs)
-                if obj.do_profile:
-                    t2 = time.time()
-                    timedelta = round(t2 - t1, 3)
-                    LOG.debug("Profile for method %s, id %s: %ss",
-                              name, call_id, timedelta)
-                return result
-            except AttributeError as e:
-                # If we find the attribute name in the error message
-                # then we continue otherwise, raise to prevent masking
-                # errors
-                if name not in six.text_type(e):
-                    raise
-                else:
-                    LOG.info(e)
-                    index -= 1
-            except DateraAPIException as e:
-                if "UnsupportedVersionError" in six.text_type(e):
-                    index -= 1
-                else:
-                    raise
-
+        name = "_" + func.__name__ + "_" + obj.apiv.replace(".", "_")
+        LOG.debug("Trying method: %s", name)
+        call_id = uuid.uuid4()
+        if obj.do_profile:
+            LOG.debug("Profiling method: %s, id %s", name, call_id)
+            t1 = time.time()
+        obj.thread_local.trace_id = call_id
+        result = getattr(obj, name)(*args[1:], **kwargs)
+        if obj.do_profile:
+            t2 = time.time()
+            timedelta = round(t2 - t1, 3)
+            LOG.debug("Profile for method %s, id %s: %ss",
+                      name, call_id, timedelta)
+        return result
     return wrapper
 
 
-def _get_supported_api_versions(driver):
-    t = time.time()
-    if driver.api_cache and driver.api_timeout - t < API_TIMEOUT:
-        return driver.api_cache
-    driver.api_timeout = t + API_TIMEOUT
-    results = []
-    host = driver.configuration.san_ip
-    port = driver.configuration.datera_api_port
-    client_cert = driver.configuration.driver_client_cert
-    client_cert_key = driver.configuration.driver_client_cert_key
-    cert_data = None
-    header = {'Content-Type': 'application/json; charset=utf-8',
-              'Datera-Driver': 'OpenStack-Cinder-{}'.format(driver.VERSION)}
-    protocol = 'http'
-    if client_cert:
-        protocol = 'https'
-        cert_data = (client_cert, client_cert_key)
+def _parse_vol_ref(ref):
+    if ref.count(":") not in (2, 3):
+        raise exception.ManageExistingInvalidReference(
+            _("existing_ref argument must be of this format: "
+              "tenant:app_inst_name:storage_inst_name:vol_name or "
+              "app_inst_name:storage_inst_name:vol_name"))
     try:
-        url = '%s://%s:%s/api_versions' % (protocol, host, port)
-        resp = driver._request(url, "get", None, header, cert_data)
-        data = resp.json()
-        results = [elem.strip("v") for elem in data['api_versions']]
-    except (DateraAPIException, KeyError):
-        # Fallback to pre-endpoint logic
-        for version in API_VERSIONS[0:-1]:
-            url = '%s://%s:%s/v%s' % (protocol, host, port, version)
-            resp = driver._request(url, "get", None, header, cert_data)
-            if ("api_req" in resp.json() or
-                    str(resp.json().get("code")) == "99"):
-                results.append(version)
-            else:
-                LOG.error("No supported API versions available, "
-                          "Please upgrade your Datera EDF software")
-    return results
+        (tenant, app_inst_name, storage_inst_name,
+            vol_name) = ref.split(":")
+        if tenant == "root":
+            tenant = None
+    except (TypeError, ValueError):
+        app_inst_name, storage_inst_name, vol_name = ref.split(
+            ":")
+        tenant = None
+    return app_inst_name, storage_inst_name, vol_name, tenant
+
+
+def _check_snap_ref(ref):
+    if not SNAP_RE.match(ref):
+        raise exception.ManageExistingInvalidReference(
+            _("existing_ref argument must be of this format: "
+              "1234567890.12345678"))
+    return True
+
+
+def _get_size(app_inst):
+    """Helper method for getting the size of a backend object
+
+    If app_inst is provided, we'll just parse the dict to get
+    the size instead of making a separate http request
+    """
+    if 'data' in app_inst:
+        app_inst = app_inst['data']
+    sis = app_inst['storage_instances']
+    found_si = sis[0]
+    found_vol = found_si['volumes'][0]
+    return found_vol['size']
 
 
 def _get_volume_type_obj(driver, resource):
@@ -252,16 +161,20 @@ def _get_volume_type_obj(driver, resourc
 
 
 def _get_policies_for_resource(driver, resource):
+    volume_type = driver._get_volume_type_obj(resource)
+    return driver._get_policies_for_volume_type(volume_type)
+
+
+def _get_policies_for_volume_type(driver, volume_type):
     """Get extra_specs and qos_specs of a volume_type.
 
     This fetches the scoped keys from the volume type. Anything set from
      qos_specs will override key/values set from extra_specs.
     """
-    volume_type = driver._get_volume_type_obj(resource)
     # Handle case of volume with no type.  We still want the
     # specified defaults from above
     if volume_type:
-        specs = volume_type.get('extra_specs')
+        specs = volume_type.get('extra_specs', {})
     else:
         specs = {}
 
@@ -270,19 +183,19 @@ def _get_policies_for_resource(driver, r
                 in driver._init_vendor_properties()[0].items()}
 
     if volume_type:
-        # Populate updated value
-        for key, value in specs.items():
-            if ':' in key:
-                fields = key.split(':')
-                key = fields[1]
-                policies[key] = value
 
         qos_specs_id = volume_type.get('qos_specs_id')
         if qos_specs_id is not None:
             ctxt = context.get_admin_context()
             qos_kvs = qos_specs.get_qos_specs(ctxt, qos_specs_id)['specs']
             if qos_kvs:
-                policies.update(qos_kvs)
+                specs.update(qos_kvs)
+        # Populate updated value
+        for key, value in specs.items():
+            if ':' in key:
+                fields = key.split(':')
+                key = fields[1]
+                policies[key] = value
     # Cast everything except booleans int that can be cast
     for k, v in policies.items():
         # Handle String Boolean case
@@ -297,199 +210,152 @@ def _get_policies_for_resource(driver, r
     return policies
 
 
-# ================
-# = API Requests =
-# ================
-
-def _request(driver, connection_string, method, payload, header, cert_data):
-    LOG.debug("Endpoint for Datera API call: %s", connection_string)
-    LOG.debug("Payload for Datera API call: %s", payload)
-    try:
-        response = getattr(requests, method)(connection_string,
-                                             data=payload, headers=header,
-                                             verify=False, cert=cert_data)
-        return response
-    except requests.exceptions.RequestException as ex:
-        msg = _(
-            'Failed to make a request to Datera cluster endpoint due '
-            'to the following reason: %s') % six.text_type(
-            ex.message)
-        LOG.error(msg)
-        raise DateraAPIException(msg)
-
-
-def _raise_response(driver, response):
-    msg = _('Request to Datera cluster returned bad status:'
-            ' %(status)s | %(reason)s') % {
-                'status': response.status_code,
-                'reason': response.reason}
-    LOG.error(msg)
-    raise DateraAPIException(msg)
-
-
-def _handle_bad_status(driver,
-                       response,
-                       connection_string,
-                       method,
-                       payload,
-                       header,
-                       cert_data,
-                       sensitive=False,
-                       conflict_ok=False):
-    if (response.status_code == http_client.BAD_REQUEST and
-            connection_string.endswith("api_versions")):
-        # Raise the exception, but don't log any error.  We'll just fall
-        # back to the old style of determining API version.  We make this
-        # request a lot, so logging it is just noise
-        raise DateraAPIException
-    if response.status_code == http_client.NOT_FOUND:
-        raise exception.NotFound(response.json()['message'])
-    elif response.status_code in [http_client.FORBIDDEN,
-                                  http_client.UNAUTHORIZED]:
-        raise exception.NotAuthorized()
-    elif response.status_code == http_client.CONFLICT and conflict_ok:
-        # Don't raise, because we're expecting a conflict
-        pass
-    elif response.status_code == http_client.SERVICE_UNAVAILABLE:
-        current_retry = 0
-        while current_retry <= driver.retry_attempts:
-            LOG.debug("Datera 503 response, trying request again")
-            eventlet.sleep(driver.interval)
-            resp = driver._request(connection_string,
-                                   method,
-                                   payload,
-                                   header,
-                                   cert_data)
-            if resp.ok:
-                return response.json()
-            elif resp.status_code != http_client.SERVICE_UNAVAILABLE:
-                driver._raise_response(resp)
+def _image_accessible(driver, context, volume, image_meta):
+    # Determine if image is accessible by current project
+    pid = volume.get('project_id', '')
+    public = False
+    visibility = image_meta.get('visibility', None)
+    LOG.debug("Image %(image)s visibility: %(vis)s",
+              {"image": image_meta['id'], "vis": visibility})
+    if visibility and visibility in ['public', 'community']:
+        public = True
+    elif visibility and visibility in ['shared', 'private']:
+        # Do membership check.  Newton and before didn't have a 'shared'
+        # visibility option, so we have to do this check for 'private'
+        # as well
+        gclient = glance.get_default_image_service()
+        members = []
+        # list_members is only available in Rocky+
+        try:
+            members = gclient.list_members(context, image_meta['id'])
+        except AttributeError:
+            # This is the fallback method for the same query
+            try:
+                members = gclient._client.call(context,
+                                               'list',
+                                               controller='image_members',
+                                               image_id=image_meta['id'])
+            except glance_exc.HTTPForbidden as e:
+                LOG.warning(e)
+        except glance_exc.HTTPForbidden as e:
+            LOG.warning(e)
+        members = list(members)
+        LOG.debug("Shared image %(image)s members: %(members)s",
+                  {"image": image_meta['id'], "members": members})
+        for member in members:
+            if (member['member_id'] == pid and
+                    member['status'] == 'accepted'):
+                public = True
+                break
+        if image_meta.get('is_public', False):
+            public = True
+        else:
+            if image_meta.get('owner', '') == pid:
+                public = True
+    if not public:
+        LOG.warning("Requested image is not "
+                    "accessible by current Project.")
+    return public
+
+
+def _format_tenant(tenant):
+    if tenant == "all" or (tenant and ('/root' in tenant or 'root' in tenant)):
+        return '/root'
+    elif tenant and ('/root' not in tenant and 'root' not in tenant):
+        return "/" + "/".join(('root', tenant)).strip('/')
+    return tenant
+
+
+def get_ip_pool(policies):
+    ip_pool = policies['ip_pool']
+    if ',' in ip_pool:
+        ip_pools = ip_pool.split(',')
+        ip_pool = random.choice(ip_pools)
+    return ip_pool
+
+
+def create_tenant(driver, project_id):
+    if driver.tenant_id.lower() == 'map':
+        name = get_name({'id': project_id})
+    elif driver.tenant_id:
+        name = driver.tenant_id.replace('root', '').strip('/')
     else:
-        driver._raise_response(response)
-
+        name = 'root'
+    if name:
+        try:
+            driver.api.tenants.create(name=name)
+        except dfs_sdk.exceptions.ApiConflictError:
+            LOG.debug("Tenant {} already exists".format(name))
+    return _format_tenant(name)
+
+
+def get_tenant(driver, project_id):
+    if driver.tenant_id.lower() == 'map':
+        return _format_tenant(get_name({'id': project_id}))
+    elif not driver.tenant_id:
+        return _format_tenant('root')
+    return _format_tenant(driver.tenant_id)
+
+
+def cvol_to_ai(driver, resource, tenant=None):
+    if not tenant:
+        tenant = get_tenant(driver, resource['project_id'])
+        try:
+            # api.tenants.get needs a non '/'-prefixed tenant id
+            driver.api.tenants.get(tenant.strip('/'))
+        except dfs_sdk.exceptions.ApiNotFoundError:
+            create_tenant(driver, resource['project_id'])
+    cid = resource.get('id', None)
+    if not cid:
+        raise ValueError('Unsure what id key to use for object', resource)
+    ais = driver.api.app_instances.list(
+        filter='match(name,.*{}.*)'.format(cid),
+        tenant=tenant)
+    if not ais:
+        raise exception.VolumeNotFound(volume_id=cid)
+    return ais[0]
+
+
+def cvol_to_dvol(driver, resource, tenant=None):
+    if not tenant:
+        tenant = get_tenant(driver, resource['project_id'])
+    ai = cvol_to_ai(driver, resource, tenant=tenant)
+    si = ai.storage_instances.list(tenant=tenant)[0]
+    vol = si.volumes.list(tenant=tenant)[0]
+    return vol
+
+
+def _version_to_int(ver):
+    # Using a factor of 100 per digit so up to 100 versions are supported
+    # per major/minor/patch/subpatch digit in this calculation
+    # Example:
+    # In [2]: _version_to_int("3.3.0.0")
+    # Out[2]: 303000000
+    # In [3]: _version_to_int("2.2.7.1")
+    # Out[3]: 202070100
+    VERSION_DIGITS = 4
+    factor = pow(10, VERSION_DIGITS * 2)
+    div = pow(10, 2)
+    val = 0
+    for c in ver.split("."):
+        val += int(int(c) * factor)
+        factor /= div
+    return val
 
-@_authenticated
-def _issue_api_request(driver, resource_url, method='get', body=None,
-                       sensitive=False, conflict_ok=False,
-                       api_version='2', tenant=None):
-    """All API requests to Datera cluster go through this method.
-
-    :param resource_url: the url of the resource
-    :param method: the request verb
-    :param body: a dict with options for the action_type
-    :param sensitive: Bool, whether request should be obscured from logs
-    :param conflict_ok: Bool, True to suppress ConflictError exceptions
-    during this request
-    :param api_version: The Datera api version for the request
-    :param tenant: The tenant header value for the request (only applicable
-    to 2.1 product versions and later)
-    :returns: a dict of the response from the Datera cluster
-    """
-    host = driver.configuration.san_ip
-    port = driver.configuration.datera_api_port
-    api_token = driver.datera_api_token
-
-    payload = json.dumps(body, ensure_ascii=False)
-    payload.encode('utf-8')
-
-    header = {'Content-Type': 'application/json; charset=utf-8'}
-    header.update(driver.HEADER_DATA)
-
-    protocol = 'http'
-    if driver.configuration.driver_use_ssl:
-        protocol = 'https'
-
-    if api_token:
-        header['Auth-Token'] = api_token
-
-    if tenant == "all":
-        header['tenant'] = tenant
-    elif tenant and '/root' not in tenant:
-        header['tenant'] = "".join(("/root/", tenant))
-    elif tenant and '/root' in tenant:
-        header['tenant'] = tenant
-    elif driver.tenant_id and driver.tenant_id.lower() != "map":
-        header['tenant'] = driver.tenant_id
-
-    client_cert = driver.configuration.driver_client_cert
-    client_cert_key = driver.configuration.driver_client_cert_key
-    cert_data = None
-
-    if client_cert:
-        protocol = 'https'
-        cert_data = (client_cert, client_cert_key)
-
-    connection_string = '%s://%s:%s/v%s/%s' % (protocol, host, port,
-                                               api_version, resource_url)
-
-    request_id = uuid.uuid4()
-
-    if driver.do_profile:
-        t1 = time.time()
-    if not sensitive:
-        LOG.debug("\nDatera Trace ID: %(tid)s\n"
-                  "Datera Request ID: %(rid)s\n"
-                  "Datera Request URL: /v%(api)s/%(url)s\n"
-                  "Datera Request Method: %(method)s\n"
-                  "Datera Request Payload: %(payload)s\n"
-                  "Datera Request Headers: %(header)s\n",
-                  {'tid': driver.thread_local.trace_id,
-                   'rid': request_id,
-                   'api': api_version,
-                   'url': resource_url,
-                   'method': method,
-                   'payload': payload,
-                   'header': header})
-    response = driver._request(connection_string,
-                               method,
-                               payload,
-                               header,
-                               cert_data)
-
-    data = response.json()
-
-    timedelta = "Profiling disabled"
-    if driver.do_profile:
-        t2 = time.time()
-        timedelta = round(t2 - t1, 3)
-    if not sensitive:
-        LOG.debug("\nDatera Trace ID: %(tid)s\n"
-                  "Datera Response ID: %(rid)s\n"
-                  "Datera Response TimeDelta: %(delta)ss\n"
-                  "Datera Response URL: %(url)s\n"
-                  "Datera Response Payload: %(payload)s\n"
-                  "Datera Response Object: %(obj)s\n",
-                  {'tid': driver.thread_local.trace_id,
-                   'rid': request_id,
-                   'delta': timedelta,
-                   'url': response.url,
-                   'payload': payload,
-                   'obj': vars(response)})
-    if not response.ok:
-        driver._handle_bad_status(response,
-                                  connection_string,
-                                  method,
-                                  payload,
-                                  header,
-                                  cert_data,
-                                  conflict_ok=conflict_ok)
 
-    return data
+def dat_version_gte(version_a, version_b):
+    return _version_to_int(version_a) >= _version_to_int(version_b)
 
 
 def register_driver(driver):
-    for func in [_get_supported_api_versions,
-                 _get_volume_type_obj,
+    for func in [_get_volume_type_obj,
                  _get_policies_for_resource,
-                 _request,
-                 _raise_response,
-                 _handle_bad_status,
-                 _issue_api_request]:
-        # PY27
+                 _get_policies_for_volume_type,
+                 _image_accessible,
+                 get_tenant,
+                 create_tenant,
+                 cvol_to_ai,
+                 cvol_to_dvol]:
 
         f = types.MethodType(func, driver)
-        try:
-            setattr(driver, func.func_name, f)
-        # PY3+
-        except AttributeError:
-            setattr(driver, func.__name__, f)
+        setattr(driver, func.__name__, f)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/datera/datera_iscsi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/datera/datera_iscsi.py
--- 2:15.0.1-1/cinder/volume/drivers/datera/datera_iscsi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/datera/datera_iscsi.py	2020-03-24 18:46:31.000000000 +0000
@@ -1,4 +1,4 @@
-# Copyright 2017 Datera
+# Copyright 2020 Datera
 # All Rights Reserved.
 #
 #    Licensed under the Apache License, Version 2.0 (the "License"); you may
@@ -19,29 +19,34 @@ import uuid
 from eventlet.green import threading
 from oslo_config import cfg
 from oslo_log import log as logging
+from oslo_utils import importutils
 import six
 
 from cinder import exception
 from cinder.i18n import _
+from cinder import interface
 from cinder import utils
-from cinder.volume import configuration
-from cinder.volume.drivers.san import san
-
-import cinder.volume.drivers.datera.datera_api2 as api2
 import cinder.volume.drivers.datera.datera_api21 as api21
+import cinder.volume.drivers.datera.datera_api22 as api22
 import cinder.volume.drivers.datera.datera_common as datc
-
+from cinder.volume.drivers.san import san
 
 LOG = logging.getLogger(__name__)
 
+dfs_sdk = importutils.try_import('dfs_sdk')
+
 d_opts = [
     cfg.StrOpt('datera_api_port',
                default='7717',
+               deprecated_for_removal=True,
                help='Datera API port.'),
     cfg.StrOpt('datera_api_version',
-               default='2',
+               default='2.2',
                deprecated_for_removal=True,
                help='Datera API version.'),
+    cfg.StrOpt('datera_ldap_server',
+               default=None,
+               help='LDAP authentication server'),
     cfg.IntOpt('datera_503_timeout',
                default='120',
                help='Timeout for HTTP 503 retry messages'),
@@ -59,25 +64,51 @@ d_opts = [
                default=None,
                help="If set to 'Map' --> OpenStack project ID will be mapped "
                     "implicitly to Datera tenant ID\n"
-                    "If set to 'None' --> Datera tenant ID will not be used "
+                    "If set to None --> Datera tenant ID will not be used "
                     "during volume provisioning\n"
                     "If set to anything else --> Datera tenant ID will be the "
                     "provided value"),
+    cfg.BoolOpt('datera_enable_image_cache',
+                default=False,
+                help="Set to True to enable Datera backend image caching"),
+    cfg.StrOpt('datera_image_cache_volume_type_id',
+               default=None,
+               help="Cinder volume type id to use for cached volumes"),
     cfg.BoolOpt('datera_disable_profiler',
                 default=False,
                 help="Set to True to disable profiling in the Datera driver"),
+    cfg.BoolOpt('datera_disable_extended_metadata',
+                default=False,
+                help="Set to True to disable sending additional metadata to "
+                     "the Datera backend"),
+    cfg.BoolOpt('datera_disable_template_override',
+                default=False,
+                help="Set to True to disable automatic template override of "
+                     "the size attribute when creating from a template"),
+    cfg.DictOpt('datera_volume_type_defaults',
+                default={},
+                help="Settings here will be used as volume-type defaults if "
+                     "the volume-type setting is not provided.  This can be "
+                     "used, for example, to set a very low total_iops_max "
+                     "value if none is specified in the volume-type to "
+                     "prevent accidental overusage.  Options are specified "
+                     "via the following format, WITHOUT ANY 'DF:' PREFIX: "
+                     "'datera_volume_type_defaults="
+                     "iops_per_gb:100,bandwidth_per_gb:200...etc'."),
 ]
 
 
 CONF = cfg.CONF
 CONF.import_opt('driver_use_ssl', 'cinder.volume.driver')
-CONF.register_opts(d_opts, group=configuration.SHARED_CONF_GROUP)
+CONF.register_opts(d_opts)
 
 
 @six.add_metaclass(utils.TraceWrapperWithABCMetaclass)
-class DateraDriver(san.SanISCSIDriver, api2.DateraApi, api21.DateraApi):
+@interface.volumedriver
+class DateraDriver(san.SanISCSIDriver, api21.DateraApi, api22.DateraApi):
+    """The OpenStack Datera iSCSI volume driver.
 
-    """The OpenStack Datera Driver
+    .. code-block:: none
 
     Version history:
         * 1.0 - Initial driver
@@ -92,21 +123,85 @@ class DateraDriver(san.SanISCSIDriver, a
         * 2.3.1 - Scalability bugfixes
         * 2.3.2 - Volume Placement, ACL multi-attach bugfix
         * 2.4.0 - Fast Retype Support
+        * 2.5.0 - Glance Image Caching, retyping/QoS bugfixes
+        * 2.6.0 - Api 2.2 support
+        * 2.6.1 - Glance interoperability fix
+        * 2.7.0 - IOPS/GB and BW/GB settings, driver level overrides
+                  (API 2.1+ only)
+        * 2.7.2 - Allowing DF: QoS Spec prefix, QoS type leak bugfix
+        * 2.7.3 - Fixed bug in clone_image where size was not set correctly
+        * 2.7.4 - Fix for create_tenant incorrect API call
+                  Temporary fix for DAT-15931
+        * 2.7.5 - Removed "force" parameter from /initiators v2.1 API requests
+        * 2.8.0 - iops_per_gb and bandwidth_per_gb are now limited by
+                  total_iops_max and total_bandwidth_max (API 2.1+ only)
+                  Bugfix for cinder retype with online volume
+        * 2.8.1 - Bugfix for missing default dict during retype
+        * 2.8.2 - Updated most retype operations to not detach volume
+        * 2.8.3 - Bugfix for not allowing fast clones for shared/community
+                  volumes
+        * 2.8.4 - Fixed missing API version pinning in _offline_flip
+        * 2.8.5 - Membership check for fast image cloning. Metadata API pinning
+        * 2.8.6 - Added LDAP support and CHAP support
+        * 2.8.7 - Bugfix for missing tenancy calls in offline_flip
+        * 2.9.0 - Volumes now correctly renamed during backend migration.
+                  Implemented update_migrated_volume (API 2.1+ only),
+                  Prevent non-raw image cloning
+        * 2.9.1 - Added extended metadata attributes during volume creation
+                  and attachment.  Added datera_disable_extended_metadata
+                  option to disable it.
+        * 2.9.2 - Made ensure_export a no-op.  Removed usage of
+                  initiator-groups
+        * 2018.4.5.0 - Switch to new date-based versioning scheme.  Removed v2
+                       API support
+        * 2018.4.17.1 - Bugfixes to IP Pools, Templates and Initiators
+        * 2018.4.25.0 - Snapshot Manage.  List Manageable Snapshots support
+        * 2018.4.27.0 - Major driver revamp/restructure, no functionality
+                        change
+        * 2018.5.1.0 - Bugfix for Map tenant auto-creation
+        * 2018.5.18.0 - Bugfix for None tenant handling
+        * 2018.6.7.0 - Bugfix for missing project_id during image clone
+        * 2018.7.13.0 - Massive update porting to use the Datera Python-SDK
+        * 2018.7.20.0 - Driver now includes display_name in created backend
+                        app_instances.
+        * 2018.9.17.0 - Requirements and doc changes
+        * 2018.10.8.0 - Added extra_headers to Python-SDK constructor call.
+                        This allows for the SDK to send the type of driver
+                        performing each request along with the request. This
+                        functionality existed before the Python-SDK revamp, so
+                        this change adds the functionality back in.
+        * 2018.10.8.1 - Adding thread_local to Python-SDK constructor call.
+                        This preserves trace_id in the logs
+        * 2018.10.30.0 - Adding template_override support.  Added
+                         datera_disable_template_override cfgOpt to disable
+                         this feature. Updated required requests version to
+                         >=2.20.0 because of a security vulnerability in
+                         <=2.19.X. Added support for filter_function and
+                         goodness_function.
+        * 2018.11.1.0 - Adding flash and hybrid capacity info to
+                        get_volume_stats
+        * 2018.11.8.0 - Fixing bug that broke 2.2.X support
+        * 2018.11.14.0 - Bugfixes for v2.1 API support and unicode character
+                         support
+        * 2019.1.24.0 - Python-SDK requirements update, README updates
+        * 2019.2.25.0 - Scalability fixes and utility script updates
+        * 2019.6.4.1 - Added Pypi packaging installation support
+        * 2019.12.10.0 - Python 3.x support, tox tests, CI ready, live
+                         migration support, image cache, bugfixes.
     """
-    VERSION = '2.4.0'
+
+    VERSION = '2019.12.10.0'
 
     CI_WIKI_NAME = "datera-ci"
 
     HEADER_DATA = {'Datera-Driver': 'OpenStack-Cinder-{}'.format(VERSION)}
 
-    # TODO(jsbryant) Remove driver in the 'U' release if CI is not fixed.
-    SUPPORTED = False
-
     def __init__(self, *args, **kwargs):
         super(DateraDriver, self).__init__(*args, **kwargs)
         self.configuration.append_config_values(d_opts)
         self.username = self.configuration.san_login
         self.password = self.configuration.san_password
+        self.ldap = self.configuration.datera_ldap_server
         self.cluster_stats = {}
         self.datera_api_token = None
         self.interval = self.configuration.datera_503_interval
@@ -114,23 +209,39 @@ class DateraDriver(san.SanISCSIDriver, a
                                self.interval)
         self.driver_prefix = str(uuid.uuid4())[:4]
         self.datera_debug = self.configuration.datera_debug
-        self.datera_api_versions = []
 
         if self.datera_debug:
             utils.setup_tracing(['method'])
         self.tenant_id = self.configuration.datera_tenant_id
+        if self.tenant_id is None:
+            self.tenant_id = ''
+        self.defaults = self.configuration.datera_volume_type_defaults
         if self.tenant_id and self.tenant_id.lower() == 'none':
             self.tenant_id = None
+        self.template_override = (
+            not self.configuration.datera_disable_template_override)
         self.api_check = time.time()
         self.api_cache = []
         self.api_timeout = 0
         self.do_profile = not self.configuration.datera_disable_profiler
-        self.thread_local = threading.local()
+        self.do_metadata = (
+            not self.configuration.datera_disable_extended_metadata)
+        self.image_cache = self.configuration.datera_enable_image_cache
+        self.image_type = self.configuration.datera_image_cache_volume_type_id
+        self.thread_local = threading.local()  # pylint: disable=no-member
+        self.datera_version = None
+        self.apiv = None
+        self.api = None
+        self.filterf = self.get_filter_function()
+        self.goodnessf = self.get_goodness_function()
+
+        self.use_chap_auth = self.configuration.use_chap_auth
+        self.chap_username = self.configuration.chap_username
+        self.chap_password = self.configuration.chap_password
 
         backend_name = self.configuration.safe_get(
             'volume_backend_name')
         self.backend_name = backend_name or 'Datera'
-
         datc.register_driver(self)
 
     def do_setup(self, context):
@@ -143,8 +254,25 @@ class DateraDriver(san.SanISCSIDriver, a
             LOG.error(msg)
             raise exception.InvalidInput(msg)
 
-        self.login()
-        self._create_tenant()
+        # Try each valid api version starting with the latest until we find
+        # one that works
+        for apiv in reversed(datc.API_VERSIONS):
+            try:
+                api = dfs_sdk.get_api(self.configuration.san_ip,
+                                      self.username,
+                                      self.password,
+                                      'v{}'.format(apiv),
+                                      disable_log=True,
+                                      extra_headers=self.HEADER_DATA,
+                                      thread_local=self.thread_local,
+                                      ldap_server=self.ldap)
+                system = api.system.get()
+                LOG.debug('Connected successfully to cluster: %s', system.name)
+                self.api = api
+                self.apiv = apiv
+                break
+            except Exception as e:
+                LOG.warning(e)
 
     # =================
 
@@ -152,7 +280,7 @@ class DateraDriver(san.SanISCSIDriver, a
     # = Create Volume =
     # =================
 
-    @datc._api_lookup
+    @datc.lookup
     def create_volume(self, volume):
         """Create a logical volume."""
         pass
@@ -161,7 +289,7 @@ class DateraDriver(san.SanISCSIDriver, a
     # = Extend Volume =
     # =================
 
-    @datc._api_lookup
+    @datc.lookup
     def extend_volume(self, volume, new_size):
         pass
 
@@ -171,7 +299,7 @@ class DateraDriver(san.SanISCSIDriver, a
     # = Cloned Volume =
     # =================
 
-    @datc._api_lookup
+    @datc.lookup
     def create_cloned_volume(self, volume, src_vref):
         pass
 
@@ -179,7 +307,7 @@ class DateraDriver(san.SanISCSIDriver, a
     # = Delete Volume =
     # =================
 
-    @datc._api_lookup
+    @datc.lookup
     def delete_volume(self, volume):
         pass
 
@@ -187,7 +315,7 @@ class DateraDriver(san.SanISCSIDriver, a
     # = Ensure Export =
     # =================
 
-    @datc._api_lookup
+    @datc.lookup
     def ensure_export(self, context, volume, connector=None):
         """Gets the associated account, retrieves CHAP info and updates."""
 
@@ -195,7 +323,7 @@ class DateraDriver(san.SanISCSIDriver, a
     # = Initialize Connection =
     # =========================
 
-    @datc._api_lookup
+    @datc.lookup
     def initialize_connection(self, volume, connector):
         pass
 
@@ -203,7 +331,7 @@ class DateraDriver(san.SanISCSIDriver, a
     # = Create Export =
     # =================
 
-    @datc._api_lookup
+    @datc.lookup
     def create_export(self, context, volume, connector):
         pass
 
@@ -211,7 +339,7 @@ class DateraDriver(san.SanISCSIDriver, a
     # = Detach Volume =
     # =================
 
-    @datc._api_lookup
+    @datc.lookup
     def detach_volume(self, context, volume, attachment=None):
         pass
 
@@ -219,7 +347,7 @@ class DateraDriver(san.SanISCSIDriver, a
     # = Create Snapshot =
     # ===================
 
-    @datc._api_lookup
+    @datc.lookup
     def create_snapshot(self, snapshot):
         pass
 
@@ -227,7 +355,7 @@ class DateraDriver(san.SanISCSIDriver, a
     # = Delete Snapshot =
     # ===================
 
-    @datc._api_lookup
+    @datc.lookup
     def delete_snapshot(self, snapshot):
         pass
 
@@ -235,7 +363,7 @@ class DateraDriver(san.SanISCSIDriver, a
     # = Volume From Snapshot =
     # ========================
 
-    @datc._api_lookup
+    @datc.lookup
     def create_volume_from_snapshot(self, volume, snapshot):
         pass
 
@@ -243,12 +371,11 @@ class DateraDriver(san.SanISCSIDriver, a
     # = Retype =
     # ==========
 
-    @datc._api_lookup
+    @datc.lookup
     def retype(self, ctxt, volume, new_type, diff, host):
         """Convert the volume to be of the new type.
 
         Returns a boolean indicating whether the retype occurred.
-
         :param ctxt: Context
         :param volume: A dictionary describing the volume to migrate
         :param new_type: A dictionary describing the volume type to convert to
@@ -263,7 +390,7 @@ class DateraDriver(san.SanISCSIDriver, a
     # = Manage =
     # ==========
 
-    @datc._api_lookup
+    @datc.lookup
     def manage_existing(self, volume, existing_ref):
         """Manage an existing volume on the Datera backend
 
@@ -277,7 +404,6 @@ class DateraDriver(san.SanISCSIDriver, a
 
         (existing_ref['source-name'] ==
              tenant:app_inst_name:storage_inst_name:vol_name)
-
         if using Datera 2.1 API
 
         or
@@ -293,11 +419,41 @@ class DateraDriver(san.SanISCSIDriver, a
         """
         pass
 
+    @datc.lookup
+    def manage_existing_snapshot(self, snapshot, existing_ref):
+        """Brings an existing backend storage object under Cinder management.
+
+        existing_ref is passed straight through from the API request's
+        manage_existing_ref value, and it is up to the driver how this should
+        be interpreted.  It should be sufficient to identify a storage object
+        that the driver should somehow associate with the newly-created cinder
+        snapshot structure.
+
+        There are two ways to do this:
+
+        1. Rename the backend storage object so that it matches the
+           snapshot['name'] which is how drivers traditionally map between a
+           cinder snapshot and the associated backend storage object.
+
+        2. Place some metadata on the snapshot, or somewhere in the backend,
+           that allows other driver requests (e.g. delete) to locate the
+           backend storage object when required.
+
+        If the existing_ref doesn't make sense, or doesn't refer to an existing
+        backend storage object, raise a ManageExistingInvalidReference
+        exception.
+
+        :param snapshot:     Cinder volume snapshot to manage
+        :param existing_ref: Driver-specific information used to identify a
+                             volume snapshot
+        """
+        pass
+
     # ===================
     # = Manage Get Size =
     # ===================
 
-    @datc._api_lookup
+    @datc.lookup
     def manage_existing_get_size(self, volume, existing_ref):
         """Get the size of an unmanaged volume on the Datera backend
 
@@ -317,20 +473,32 @@ class DateraDriver(san.SanISCSIDriver, a
         """
         pass
 
+    @datc.lookup
+    def manage_existing_snapshot_get_size(self, snapshot, existing_ref):
+        """Return size of snapshot to be managed by manage_existing.
+
+        When calculating the size, round up to the next GB.
+
+        :param snapshot:     Cinder volume snapshot to manage
+        :param existing_ref: Driver-specific information used to identify a
+                             volume snapshot
+        :returns size:       Volume snapshot size in GiB (integer)
+        """
+        pass
+
     # =========================
     # = Get Manageable Volume =
     # =========================
 
-    @datc._api_lookup
+    @datc.lookup
     def get_manageable_volumes(self, cinder_volumes, marker, limit, offset,
                                sort_keys, sort_dirs):
         """List volumes on the backend available for management by Cinder.
 
         Returns a list of dictionaries, each specifying a volume in the host,
         with the following keys:
-
         - reference (dictionary): The reference for a volume, which can be
-          passed to 'manage_existing'.
+          passed to "manage_existing".
         - size (int): The size of the volume according to the storage
           backend, rounded up to the nearest GB.
         - safe_to_manage (boolean): Whether or not this volume is safe to
@@ -354,11 +522,50 @@ class DateraDriver(san.SanISCSIDriver, a
         """
         pass
 
+    # ============================
+    # = Get Manageable Snapshots =
+    # ============================
+
+    @datc.lookup
+    def get_manageable_snapshots(self, cinder_snapshots, marker, limit,
+                                 offset, sort_keys, sort_dirs):
+        """List snapshots on the backend available for management by Cinder.
+
+        Returns a list of dictionaries, each specifying a snapshot in the host,
+        with the following keys:
+        - reference (dictionary): The reference for a snapshot, which can be
+        passed to "manage_existing_snapshot".
+        - size (int): The size of the snapshot according to the storage
+        backend, rounded up to the nearest GB.
+        - safe_to_manage (boolean): Whether or not this snapshot is safe to
+        manage according to the storage backend. For example, is the snapshot
+        in use or invalid for any reason.
+        - reason_not_safe (string): If safe_to_manage is False, the reason why.
+        - cinder_id (string): If already managed, provide the Cinder ID.
+        - extra_info (string): Any extra information to return to the user
+        - source_reference (string): Similar to "reference", but for the
+        snapshot's source volume.
+
+        :param cinder_snapshots: A list of snapshots in this host that Cinder
+                                 currently manages, used to determine if
+                                 a snapshot is manageable or not.
+        :param marker:    The last item of the previous page; we return the
+                          next results after this value (after sorting)
+        :param limit:     Maximum number of items to return
+        :param offset:    Number of items to skip after marker
+        :param sort_keys: List of keys to sort results by (valid keys are
+                          'identifier' and 'size')
+        :param sort_dirs: List of directions to sort by, corresponding to
+                          sort_keys (valid directions are 'asc' and 'desc')
+
+        """
+        pass
+
     # ============
     # = Unmanage =
     # ============
 
-    @datc._api_lookup
+    @datc.lookup
     def unmanage(self, volume):
         """Unmanage a currently managed volume in Cinder
 
@@ -366,11 +573,43 @@ class DateraDriver(san.SanISCSIDriver, a
         """
         pass
 
+    # ====================
+    # = Fast Image Clone =
+    # ====================
+
+    @datc.lookup
+    def clone_image(self, context, volume, image_location, image_meta,
+                    image_service):
+        """Clone an existing image volume."""
+        pass
+
+    # ====================
+    # = Volume Migration =
+    # ====================
+
+    @datc.lookup
+    def update_migrated_volume(self, context, volume, new_volume,
+                               volume_status):
+        """Return model update for migrated volume.
+
+        Each driver implementing this method needs to be responsible for the
+        values of _name_id and provider_location. If None is returned or either
+        key is not set, it means the volume table does not need to change the
+        value(s) for the key(s).
+        The return format is {"_name_id": value, "provider_location": value}.
+        :param volume: The original volume that was migrated to this backend
+        :param new_volume: The migration volume object that was created on
+                           this backend as part of the migration process
+        :param original_volume_status: The status of the original volume
+        :returns: model_update to update DB with any needed changes
+        """
+        pass
+
     # ================
     # = Volume Stats =
     # ================
 
-    @datc._api_lookup
+    @datc.lookup
     def get_volume_stats(self, refresh=False):
         """Get volume stats.
 
@@ -385,31 +624,10 @@ class DateraDriver(san.SanISCSIDriver, a
     # = Login =
     # =========
 
-    @datc._api_lookup
+    @datc.lookup
     def login(self):
         pass
 
-    # =======
-    # = QoS =
-    # =======
-
-    def _update_qos(self, resource, policies):
-        url = datc.URL_TEMPLATES['vol_inst'](
-            policies['default_storage_name'],
-            policies['default_volume_name']) + '/performance_policy'
-        url = url.format(datc._get_name(resource['id']))
-        type_id = resource.get('volume_type_id', None)
-        if type_id is not None:
-            # Filter for just QOS policies in result. All of their keys
-            # should end with "max"
-            fpolicies = {k: int(v) for k, v in
-                         policies.items() if k.endswith("max")}
-            # Filter all 0 values from being passed
-            fpolicies = dict(filter(lambda _v: _v[1] > 0, fpolicies.items()))
-            if fpolicies:
-                self._issue_api_request(url, 'post', body=fpolicies,
-                                        api_version='2')
-
     def _get_lunid(self):
         return 0
 
@@ -448,18 +666,62 @@ class DateraDriver(san.SanISCSIDriver, a
 
         prefix: DF --> Datera Fabric
         """
+        LOG.debug("Using the following volume-type defaults: %s",
+                  self.defaults)
 
         properties = {}
 
         self._set_property(
             properties,
+            "DF:iops_per_gb",
+            "Datera IOPS Per GB Setting",
+            _("Setting this value will calculate IOPS for each volume of "
+              "this type based on their size.  Eg. A setting of 100 will "
+              "give a 1 GB volume 100 IOPS, but a 10 GB volume 1000 IOPS. "
+              "A setting of '0' is unlimited.  This value is applied to "
+              "total_iops_max and will be overridden by total_iops_max if "
+              "iops_per_gb is set and a large enough volume is provisioned "
+              "which would exceed total_iops_max"),
+            "integer",
+            minimum=0,
+            default=int(self.defaults.get('iops_per_gb', 0)))
+
+        self._set_property(
+            properties,
+            "DF:bandwidth_per_gb",
+            "Datera Bandwidth Per GB Setting",
+            _("Setting this value will calculate bandwidth for each volume of "
+              "this type based on their size in KiB/s.  Eg. A setting of 100 "
+              "will give a 1 GB volume 100 KiB/s bandwidth, but a 10 GB "
+              "volume 1000 KiB/s bandwidth. A setting of '0' is unlimited. "
+              "This value is applied to total_bandwidth_max and will be "
+              "overridden by total_bandwidth_max if set and a large enough "
+              "volume is provisioned which woudl exceed total_bandwidth_max"),
+            "integer",
+            minimum=0,
+            default=int(self.defaults.get('bandwidth_per_gb', 0)))
+
+        self._set_property(
+            properties,
             "DF:placement_mode",
-            "Datera Volume Placement",
-            _("'single_flash' for single-flash-replica placement, "
+            "Datera Volume Placement Mode (deprecated)",
+            _("'DEPRECATED: PLEASE USE 'placement_policy' on 3.3.X+ versions "
+              " of the Datera product.  'single_flash' for "
+              "single-flash-replica placement, "
               "'all_flash' for all-flash-replica placement, "
               "'hybrid' for hybrid placement"),
             "string",
-            default="hybrid")
+            default=self.defaults.get('placement_mode', 'hybrid'))
+
+        self._set_property(
+            properties,
+            "DF:placement_policy",
+            "Datera Volume Placement Policy",
+            _("Valid path to a media placement policy.  Example: "
+              "/placement_policies/all-flash"),
+            "string",
+            default=self.defaults.get('placement_policy',
+                                      'default'))
 
         self._set_property(
             properties,
@@ -467,7 +729,7 @@ class DateraDriver(san.SanISCSIDriver, a
             "Datera Round Robin Portals",
             _("True to round robin the provided portals for a target"),
             "boolean",
-            default=False)
+            default="True" == self.defaults.get('round_robin', "False"))
 
         if self.configuration.get('datera_debug_replica_count_override'):
             replica_count = 1
@@ -481,24 +743,20 @@ class DateraDriver(san.SanISCSIDriver, a
               "increased once volume is created"),
             "integer",
             minimum=1,
-            default=replica_count)
-
-        self._set_property(
-            properties,
-            "DF:acl_allow_all",
-            "Datera ACL Allow All",
-            _("True to set acl 'allow_all' on volumes created.  Cannot be "
-              "changed on volume once set"),
-            "boolean",
-            default=False)
+            default=int(self.defaults.get('replica_count', replica_count)))
 
         self._set_property(
             properties,
             "DF:ip_pool",
             "Datera IP Pool",
-            _("Specifies IP pool to use for volume"),
+            _("Specifies IP pool to use for volume.  If provided string "
+              "contains commas, it will be split on the commas and each "
+              "substring will be uses as a separate IP pool and the volume's "
+              "IP pool will be chosen randomly from the list.  Example: "
+              "'my-ip-pool1,my-ip-pool2,my-ip-pool3', next attach "
+              "my-ip-pool2 was chosen randomly as the volume IP pool"),
             "string",
-            default="default")
+            default=self.defaults.get('ip_pool', 'default'))
 
         self._set_property(
             properties,
@@ -506,7 +764,7 @@ class DateraDriver(san.SanISCSIDriver, a
             "Datera Template",
             _("Specifies Template to use for volume provisioning"),
             "string",
-            default="")
+            default=self.defaults.get('template', ''))
 
         # ###### QoS Settings ###### #
         self._set_property(
@@ -517,23 +775,7 @@ class DateraDriver(san.SanISCSIDriver, a
               "use 0 for unlimited"),
             "integer",
             minimum=0,
-            default=0)
-
-        self._set_property(
-            properties,
-            "DF:default_storage_name",
-            "Datera Default Storage Instance Name",
-            _("The name to use for storage instances created"),
-            "string",
-            default="storage-1")
-
-        self._set_property(
-            properties,
-            "DF:default_volume_name",
-            "Datera Default Volume Name",
-            _("The name to use for volumes created"),
-            "string",
-            default="volume-1")
+            default=int(self.defaults.get('read_bandwidth_max', 0)))
 
         self._set_property(
             properties,
@@ -543,7 +785,7 @@ class DateraDriver(san.SanISCSIDriver, a
               "use 0 for unlimited"),
             "integer",
             minimum=0,
-            default=0)
+            default=int(self.defaults.get('write_bandwidth_max', 0)))
 
         self._set_property(
             properties,
@@ -553,7 +795,7 @@ class DateraDriver(san.SanISCSIDriver, a
               "use 0 for unlimited"),
             "integer",
             minimum=0,
-            default=0)
+            default=int(self.defaults.get('total_bandwidth_max', 0)))
 
         self._set_property(
             properties,
@@ -563,7 +805,7 @@ class DateraDriver(san.SanISCSIDriver, a
               "use 0 for unlimited"),
             "integer",
             minimum=0,
-            default=0)
+            default=int(self.defaults.get('read_iops_max', 0)))
 
         self._set_property(
             properties,
@@ -573,7 +815,7 @@ class DateraDriver(san.SanISCSIDriver, a
               "use 0 for unlimited"),
             "integer",
             minimum=0,
-            default=0)
+            default=int(self.defaults.get('write_iops_max', 0)))
 
         self._set_property(
             properties,
@@ -583,7 +825,7 @@ class DateraDriver(san.SanISCSIDriver, a
               "use 0 for unlimited"),
             "integer",
             minimum=0,
-            default=0)
+            default=int(self.defaults.get('total_iops_max', 0)))
         # ###### End QoS Settings ###### #
 
         return properties, 'DF'
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/powermax/common.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/powermax/common.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/powermax/common.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/powermax/common.py	2020-03-24 18:46:31.000000000 +0000
@@ -137,7 +137,16 @@ powermax_opts = [
     cfg.ListOpt(utils.POWERMAX_PORT_GROUPS,
                 bounds=True,
                 help='List of port groups containing frontend ports '
-                     'configured prior for server connection.')]
+                     'configured prior for server connection.'),
+    cfg.ListOpt(utils.POWERMAX_ARRAY_TAG_LIST,
+                bounds=True,
+                help='List of user assigned name for storage array.'),
+    cfg.StrOpt(utils.POWERMAX_SHORT_HOST_NAME_TEMPLATE,
+               default='shortHostName',
+               help='User defined override for short host name.'),
+    cfg.StrOpt(utils.POWERMAX_PORT_GROUP_NAME_TEMPLATE,
+               default='portGroupName',
+               help='User defined override for port group name.')]
 
 
 CONF.register_opts(powermax_opts, group=configuration.SHARED_CONF_GROUP)
@@ -181,6 +190,9 @@ class PowerMaxCommon(object):
         self.extend_replicated_vol = False
         self.rep_devices = []
         self.failover = False
+        self.powermax_array_tag_list = None
+        self.powermax_short_host_name_template = None
+        self.powermax_port_group_name_template = None
 
         # Gather environment info
         self._get_replication_info()
@@ -214,6 +226,12 @@ class PowerMaxCommon(object):
         self.snapvx_unlink_limit = self._get_unlink_configuration_value(
             utils.VMAX_SNAPVX_UNLINK_LIMIT,
             utils.POWERMAX_SNAPVX_UNLINK_LIMIT)
+        self.powermax_array_tag_list = self.configuration.safe_get(
+            utils.POWERMAX_ARRAY_TAG_LIST)
+        self.powermax_short_host_name_template = self.configuration.safe_get(
+            utils.POWERMAX_SHORT_HOST_NAME_TEMPLATE)
+        self.powermax_port_group_name_template = self.configuration.safe_get(
+            utils.POWERMAX_PORT_GROUP_NAME_TEMPLATE)
         self.pool_info['backend_name'] = (
             self.configuration.safe_get('volume_backend_name'))
         mosr = volume_utils.get_max_over_subscription_ratio(
@@ -325,13 +343,15 @@ class PowerMaxCommon(object):
                 if self.active_backend_id == self.rep_config['array']:
                     self.failover = True
                 self.extend_replicated_vol = self.rep_config['allow_extend']
-                self.allow_delete_metro = (
-                    self.rep_config['allow_delete_metro']
-                    if self.rep_config.get('allow_delete_metro') else False)
-                # use self.replication_enabled for update_volume_stats
                 self.replication_enabled = True
                 LOG.debug("The replication configuration is %(rep_config)s.",
                           {'rep_config': self.rep_config})
+
+            if self.next_gen:
+                self.rep_config[utils.RDF_CONS_EXEMPT] = True
+            else:
+                self.rep_config[utils.RDF_CONS_EXEMPT] = False
+
         elif self.rep_devices and len(self.rep_devices) > 1:
             LOG.error("More than one replication target is configured. "
                       "Dell EMC PowerMax/VMAX only suppports a single "
@@ -414,16 +434,11 @@ class PowerMaxCommon(object):
         :param volume: volume object
         :returns:  model_update - dict
         """
-        model_update = {}
-        rep_info_dict = {}
-        rep_driver_data = {}
+        model_update, rep_driver_data = dict(), dict()
+        group_name, group_id = None, None
+
         volume_id = volume.id
-        group_name = None
-        group_id = None
         extra_specs = self._initial_setup(volume)
-        # Check if the RDF group is valid
-        if self.utils.is_replication_enabled(extra_specs):
-            self.get_rdf_details(extra_specs[utils.ARRAY])
 
         if 'qos' in extra_specs:
             del extra_specs['qos']
@@ -432,13 +447,10 @@ class PowerMaxCommon(object):
         volume_name = self.utils.get_volume_element_name(volume_id)
         volume_size = volume.size
 
-        volume_dict = (self._create_volume(
-            volume_name, volume_size, extra_specs))
+        volume_dict, rep_update, rep_info_dict = self._create_volume(
+            volume_name, volume_size, extra_specs)
 
-        # Set-up volume replication, if enabled
-        if self.utils.is_replication_enabled(extra_specs):
-            rep_update, rep_info_dict = self._replicate_volume(
-                volume, volume_name, volume_dict, extra_specs)
+        if rep_update:
             rep_driver_data = rep_update['replication_driver_data']
             model_update.update(rep_update)
 
@@ -451,15 +463,20 @@ class PowerMaxCommon(object):
                     volume, volume_dict['device_id'], volume_name,
                     extra_specs, rep_driver_data)
 
+        # Gather Metadata
         model_update.update(
             {'provider_location': six.text_type(volume_dict)})
         model_update = self.update_metadata(
             model_update, volume.metadata, self.get_volume_metadata(
                 volume_dict['array'], volume_dict['device_id']))
 
+        array_tag_list = self.get_tags_of_storage_array(
+            extra_specs[utils.ARRAY])
+
         self.volume_metadata.capture_create_volume(
             volume_dict['device_id'], volume, group_name, group_id,
-            extra_specs, rep_info_dict, 'create')
+            extra_specs, rep_info_dict, 'create',
+            array_tag_list=array_tag_list)
 
         LOG.info("Leaving create_volume: %(name)s. Volume dict: %(dict)s.",
                  {'name': volume_name, 'dict': volume_dict})
@@ -507,15 +524,10 @@ class PowerMaxCommon(object):
             snapshot, extra_specs)
         from_snapvx = False if sourcedevice_id else True
 
-        clone_dict = self._create_cloned_volume(
-            volume, snapshot, extra_specs, is_snapshot=False,
-            from_snapvx=from_snapvx)
-
-        # Set-up volume replication, if enabled
-        if self.utils.is_replication_enabled(extra_specs):
-            rep_update, rep_info_dict = (
-                self._replicate_volume(
-                    volume, snapshot['name'], clone_dict, extra_specs))
+        clone_dict, rep_update, rep_info_dict = self._create_cloned_volume(
+            volume, snapshot, extra_specs, from_snapvx=from_snapvx)
+        # Update model with replication session info if applicable
+        if rep_update:
             model_update.update(rep_update)
 
         model_update.update(
@@ -523,10 +535,12 @@ class PowerMaxCommon(object):
         model_update = self.update_metadata(
             model_update, volume.metadata, self.get_volume_metadata(
                 clone_dict['array'], clone_dict['device_id']))
+        array_tag_list = self.get_tags_of_storage_array(
+            extra_specs[utils.ARRAY])
         self.volume_metadata.capture_create_volume(
             clone_dict['device_id'], volume, None, None,
             extra_specs, rep_info_dict, 'createFromSnapshot',
-            source_snapshot_id=snapshot.id)
+            source_snapshot_id=snapshot.id, array_tag_list=array_tag_list)
 
         return model_update
 
@@ -539,13 +553,20 @@ class PowerMaxCommon(object):
         """
         model_update, rep_info_dict = {}, {}
         extra_specs = self._initial_setup(clone_volume)
-        clone_dict = self._create_cloned_volume(clone_volume, source_volume,
-                                                extra_specs)
+        array = extra_specs[utils.ARRAY]
+        source_device_id = self._find_device_on_array(
+            source_volume, extra_specs)
 
-        # Set-up volume replication, if enabled
-        if self.utils.is_replication_enabled(extra_specs):
-            rep_update, rep_info_dict = self._replicate_volume(
-                clone_volume, clone_volume.name, clone_dict, extra_specs)
+        if not self.next_gen and (
+                extra_specs.get('rep_mode', None) == utils.REP_METRO):
+            self._sync_check(array, source_device_id, extra_specs)
+        else:
+            self._clone_check(array, source_device_id, extra_specs)
+
+        clone_dict, rep_update, rep_info_dict = self._create_cloned_volume(
+            clone_volume, source_volume, extra_specs)
+        # Update model with replication session info if applicable
+        if rep_update:
             model_update.update(rep_update)
 
         model_update.update(
@@ -553,40 +574,16 @@ class PowerMaxCommon(object):
         model_update = self.update_metadata(
             model_update, clone_volume.metadata, self.get_volume_metadata(
                 clone_dict['array'], clone_dict['device_id']))
+        array_tag_list = self.get_tags_of_storage_array(
+            extra_specs[utils.ARRAY])
         self.volume_metadata.capture_create_volume(
             clone_dict['device_id'], clone_volume, None, None,
             extra_specs, rep_info_dict, 'createFromVolume',
             temporary_snapvx=clone_dict.get('snap_name'),
-            source_device_id=clone_dict.get('source_device_id'))
+            source_device_id=clone_dict.get('source_device_id'),
+            array_tag_list=array_tag_list)
         return model_update
 
-    def _replicate_volume(self, volume, volume_name, volume_dict, extra_specs,
-                          delete_src=True):
-        """Setup up remote replication for a volume.
-
-        :param volume: the volume object
-        :param volume_name: the volume name
-        :param volume_dict: the volume dict
-        :param extra_specs: the extra specifications
-        :param delete_src: flag to indicate if source should be deleted on
-                           if replication fails
-        :returns: replication model_update, rep_info_dict
-        """
-        array = volume_dict['array']
-        try:
-            device_id = volume_dict['device_id']
-            replication_status, replication_driver_data, rep_info_dict = (
-                self.setup_volume_replication(
-                    array, volume, device_id, extra_specs))
-        except Exception:
-            if delete_src:
-                self._cleanup_replication_source(
-                    array, volume, volume_name, volume_dict, extra_specs)
-            raise
-        return ({'replication_status': replication_status,
-                 'replication_driver_data': six.text_type(
-                     replication_driver_data)}, rep_info_dict)
-
     def delete_volume(self, volume):
         """Deletes a EMC(PowerMax/VMAX) volume.
 
@@ -607,7 +604,7 @@ class PowerMaxCommon(object):
         :returns: dict -- the cloned volume dictionary
         """
         extra_specs = self._initial_setup(volume)
-        snapshot_dict = self._create_cloned_volume(
+        snapshot_dict, __, __ = self._create_cloned_volume(
             snapshot, volume, extra_specs, is_snapshot=True)
 
         model_update = {
@@ -658,7 +655,7 @@ class PowerMaxCommon(object):
 
     def _remove_members(self, array, volume, device_id,
                         extra_specs, connector, is_multiattach,
-                        async_grp=None):
+                        async_grp=None, host_template=None):
         """This method unmaps a volume from a host.
 
         Removes volume from the storage group that belongs to a masking view.
@@ -675,7 +672,8 @@ class PowerMaxCommon(object):
         reset = False if is_multiattach else True
         self.masking.remove_and_reset_members(
             array, volume, device_id, volume_name,
-            extra_specs, reset, connector, async_grp=async_grp)
+            extra_specs, reset, connector, async_grp=async_grp,
+            host_template=host_template)
         if is_multiattach:
             self.masking.return_volume_to_fast_managed_group(
                 array, device_id, extra_specs)
@@ -695,10 +693,10 @@ class PowerMaxCommon(object):
         if self.utils.is_volume_failed_over(volume):
             extra_specs = rep_extra_specs
         volume_name = volume.name
-        async_grp = None
+        mgmt_sg_name = None
         LOG.info("Unmap volume: %(volume)s.", {'volume': volume})
         if connector is not None:
-            host = self.utils.get_host_short_name(connector['host'])
+            host_name = connector.get('host')
             attachment_list = volume.volume_attachment
             LOG.debug("Volume attachment list: %(atl)s. "
                       "Attachment type: %(at)s",
@@ -710,7 +708,7 @@ class PowerMaxCommon(object):
             if att_list is not None:
                 host_list = [att.connector['host'] for att in att_list if
                              att is not None and att.connector is not None]
-                current_host_occurances = host_list.count(host)
+                current_host_occurances = host_list.count(host_name)
                 if current_host_occurances > 1:
                     LOG.info("Volume is attached to multiple instances on "
                              "this host. Not removing the volume from the "
@@ -719,35 +717,37 @@ class PowerMaxCommon(object):
         else:
             LOG.warning("Cannot get host name from connector object - "
                         "assuming force-detach.")
-            host = None
+            host_name = None
 
         device_info, is_multiattach = (
-            self.find_host_lun_id(volume, host, extra_specs))
+            self.find_host_lun_id(volume, host_name, extra_specs))
         if 'hostlunid' not in device_info:
             LOG.info("Volume %s is not mapped. No volume to unmap.",
                      volume_name)
             return
         array = extra_specs[utils.ARRAY]
         if self.utils.does_vol_need_rdf_management_group(extra_specs):
-            async_grp = self.utils.get_async_rdf_managed_grp_name(
+            mgmt_sg_name = self.utils.get_rdf_management_group_name(
                 self.rep_config)
-        self._remove_members(array, volume, device_info['device_id'],
-                             extra_specs, connector, is_multiattach,
-                             async_grp=async_grp)
+        self._remove_members(
+            array, volume, device_info['device_id'], extra_specs, connector,
+            is_multiattach, async_grp=mgmt_sg_name,
+            host_template=self.powermax_short_host_name_template)
         if self.utils.is_metro_device(self.rep_config, extra_specs):
             # Need to remove from remote masking view
             device_info, __ = (self.find_host_lun_id(
-                volume, host, extra_specs, rep_extra_specs))
+                volume, host_name, extra_specs, rep_extra_specs))
             if 'hostlunid' in device_info:
                 self._remove_members(
                     rep_extra_specs[utils.ARRAY], volume,
                     device_info['device_id'], rep_extra_specs, connector,
-                    is_multiattach, async_grp=async_grp)
+                    is_multiattach, async_grp=mgmt_sg_name,
+                    host_template=self.powermax_short_host_name_template)
             else:
                 # Make an attempt to clean up initiator group
                 self.masking.attempt_ig_cleanup(
                     connector, self.protocol, rep_extra_specs[utils.ARRAY],
-                    True)
+                    True, host_template=self.powermax_short_host_name_template)
         if is_multiattach and LOG.isEnabledFor(logging.DEBUG):
             mv_list, sg_list = (
                 self._get_mvs_and_sgs_from_volume(
@@ -802,7 +802,7 @@ class PowerMaxCommon(object):
         if self.utils.is_volume_failed_over(volume):
             extra_specs = rep_extra_specs
         device_info_dict, is_multiattach = (
-            self.find_host_lun_id(volume, connector['host'], extra_specs))
+            self.find_host_lun_id(volume, connector.get('host'), extra_specs))
         masking_view_dict = self._populate_masking_dict(
             volume, connector, extra_specs)
         masking_view_dict[utils.IS_MULTIATTACH] = is_multiattach
@@ -828,7 +828,7 @@ class PowerMaxCommon(object):
                     device_info_dict['maskingview']))
             if self.utils.is_metro_device(self.rep_config, extra_specs):
                 remote_info_dict, is_multiattach = (
-                    self.find_host_lun_id(volume, connector['host'],
+                    self.find_host_lun_id(volume, connector.get('host'),
                                           extra_specs, rep_extra_specs))
                 if remote_info_dict.get('hostlunid') is None:
                     # Need to attach on remote side
@@ -870,11 +870,19 @@ class PowerMaxCommon(object):
                         rep_extra_specs[utils.ARRAY], remote_port_group))
             device_info_dict['is_multipath'] = is_multipath
 
+        array_tag_list = self.get_tags_of_storage_array(
+            extra_specs[utils.ARRAY])
+        if array_tag_list:
+            masking_view_dict['array_tag_list'] = array_tag_list
+
         if is_multiattach and LOG.isEnabledFor(logging.DEBUG):
             masking_view_dict['mv_list'], masking_view_dict['sg_list'] = (
                 self._get_mvs_and_sgs_from_volume(
                     extra_specs[utils.ARRAY],
                     masking_view_dict[utils.DEVICE_ID]))
+        elif not is_multiattach and LOG.isEnabledFor(logging.DEBUG):
+            masking_view_dict['tag_list'] = self.get_tags_of_storage_group(
+                extra_specs[utils.ARRAY], masking_view_dict[utils.SG_NAME])
 
         self.volume_metadata.capture_attach_info(
             volume, extra_specs, masking_view_dict, connector['host'],
@@ -882,6 +890,35 @@ class PowerMaxCommon(object):
 
         return device_info_dict
 
+    def get_tags_of_storage_group(self, array, storage_group_name):
+        """Get the tag information from a storage group
+
+        :param array: serial number of array
+        :param storage_group_name: storage group name
+
+        :returns: tag list
+        """
+        try:
+            storage_group = self.rest.get_storage_group(
+                array, storage_group_name)
+        except Exception:
+            return None
+        return storage_group.get('tags')
+
+    def get_tags_of_storage_array(self, array):
+        """Get the tag information from an array
+
+        :param array: serial number of array
+
+        :returns: tag list
+        """
+        tag_name_list = None
+        try:
+            tag_name_list = self.rest.get_array_tags(array)
+        except Exception:
+            pass
+        return tag_name_list
+
     def _attach_metro_volume(self, volume, connector, is_multiattach,
                              extra_specs, rep_extra_specs):
         """Helper method to attach a metro volume.
@@ -894,7 +931,7 @@ class PowerMaxCommon(object):
         :param is_multiattach: flag to indicate if this a multiattach case
         :param extra_specs: the extra specifications
         :param rep_extra_specs: replication extra specifications
-        :return: hostlunid, remote_port_group
+        :returns: hostlunid, remote_port_group
         """
         remote_mv_dict = self._populate_masking_dict(
             volume, connector, extra_specs, rep_extra_specs)
@@ -935,7 +972,7 @@ class PowerMaxCommon(object):
         # Find host lun id again after the volume is exported to the host.
 
         device_info_dict, __ = self.find_host_lun_id(
-            volume, connector['host'], extra_specs, rep_extra_specs)
+            volume, connector.get('host'), extra_specs, rep_extra_specs)
         if 'hostlunid' not in device_info_dict:
             # Did not successfully attach to host, so a rollback is required.
             error_message = (_("Error Attaching volume %(vol)s. Cannot "
@@ -976,47 +1013,39 @@ class PowerMaxCommon(object):
         rep_enabled = self.utils.is_replication_enabled(ex_specs)
         rdf_grp_no = None
         legacy_extend = False
-        metro_exception = False
 
         # Run validation and capabilities checks
         self._extend_vol_validation_checks(
             array, device_id, vol_name, ex_specs, orig_vol_size, new_size)
-        r1_ode, r1_ode_metro, r2_ode, r2_ode_metro = (
-            self._array_ode_capabilities_check(array, rep_enabled))
 
         # Get extend workflow dependent on array gen and replication status
-        if self.next_gen:
-            if rep_enabled:
-                (rdf_grp_no, __) = self.get_rdf_details(array)
+        if rep_enabled:
+            rdf_grp_no, _ = self.get_rdf_details(array)
+            r1_ode, r1_ode_metro, r2_ode, r2_ode_metro = (
+                self._array_ode_capabilities_check(array, True))
+            if self.next_gen:
                 if self.utils.is_metro_device(self.rep_config, ex_specs):
-                    if not r1_ode_metro or not r2_ode_metro:
-                        metro_exception = True
-
-        elif not self.next_gen and rep_enabled:
-            if self.utils.is_metro_device(self.rep_config, ex_specs):
-                metro_exception = True
+                    if not r1_ode_metro or not r2_ode or not r2_ode_metro:
+                        legacy_extend = True
             else:
                 legacy_extend = True
 
-        # If volume to be extended is SRDF Metro enabled and not FoxTail uCode
-        if metro_exception:
-            metro_exception_message = (_(
-                "Extending a replicated volume with SRDF/Metro enabled is not "
-                "permitted on this backend. Please contact your storage "
-                "administrator. Note that you cannot extend SRDF/Metro "
-                "protected volumes unless running FoxTail PowerMax OS uCode "
-                "level."))
-            LOG.error(metro_exception_message)
-            raise exception.VolumeBackendAPIException(
-                message=metro_exception_message)
-
         # Handle the extend process using workflow info from previous steps
         if legacy_extend:
-            LOG.info("Legacy extend volume %(volume)s to %(new_size)d GBs",
-                     {'volume': vol_name,
-                      'new_size': int(new_size)})
-            self._extend_legacy_replicated_vol(
-                array, volume, device_id, vol_name, new_size, ex_specs)
+            if self.rep_config.get('allow_extend', False):
+                LOG.info("Legacy extend volume %(volume)s to %(new_size)d GBs",
+                         {'volume': vol_name, 'new_size': int(new_size)})
+                self._extend_legacy_replicated_vol(
+                    array, volume, device_id, vol_name, new_size, ex_specs,
+                    rdf_grp_no)
+            else:
+                exception_message = (
+                    "Extending a replicated volume on this backend is not "
+                    "permitted. Please set 'allow_extend:True' in your "
+                    "PowerMax replication target_backend configuration.")
+                LOG.error(exception_message)
+                raise exception.VolumeBackendAPIException(
+                    message=exception_message)
         else:
             LOG.info("ODE extend volume %(volume)s to %(new_size)d GBs",
                      {'volume': vol_name,
@@ -1024,6 +1053,9 @@ class PowerMaxCommon(object):
             self.provision.extend_volume(
                 array, device_id, new_size, ex_specs, rdf_grp_no)
 
+        self.volume_metadata.capture_extend_info(
+            volume, new_size, device_id, ex_specs, array)
+
         LOG.debug("Leaving extend_volume: %(volume_name)s. ",
                   {'volume_name': vol_name})
 
@@ -1103,8 +1135,10 @@ class PowerMaxCommon(object):
 
         return r1_ode, r1_ode_metro, r2_ode, r2_ode_metro
 
-    def _extend_legacy_replicated_vol(self, array, volume, device_id,
-                                      volume_name, new_size, extra_specs):
+    @coordination.synchronized('emc-{rdf_group_no}-rdf')
+    def _extend_legacy_replicated_vol(
+            self, array, volume, device_id, volume_name, new_size, extra_specs,
+            rdf_group_no):
         """Extend a legacy OS volume without Online Device Expansion
 
         :param array: the array serial number
@@ -1113,48 +1147,35 @@ class PowerMaxCommon(object):
         :param volume_name: the volume name
         :param new_size: the new size the volume should be
         :param extra_specs: extra specifications
+        :param rdf_group_no: the RDF group number
         """
         try:
-            (target_device, remote_array, rdf_group, local_vol_state,
-             pair_state) = self.get_remote_target_device(
-                array, volume, device_id)
-            rep_extra_specs = self._get_replication_extra_specs(
-                extra_specs, self.rep_config)
-
-            # Volume must be removed from replication (storage) group before
-            # the replication relationship can be ended (cannot have a mix of
-            # replicated and non-replicated volumes as the SRDF groups become
-            # unmanageable)
-            self.masking.remove_and_reset_members(
-                array, volume, device_id, volume_name, extra_specs, False)
-            # Repeat on target side
-            self.masking.remove_and_reset_members(
-                remote_array, volume, target_device, volume_name,
-                rep_extra_specs, False)
+            # Break the RDF device pair relationship and cleanup R2
             LOG.info("Breaking replication relationship...")
-            self.provision.break_rdf_relationship(array, device_id,
-                                                  target_device, rdf_group,
-                                                  rep_extra_specs, pair_state)
-            # Extend the target volume
-            LOG.info("Extending target volume...")
-            # Check to make sure the R2 device requires extending first...
-            r2_size = self.rest.get_size_of_device_on_array(remote_array,
-                                                            target_device)
-            if int(r2_size) < int(new_size):
-                self.provision.extend_volume(remote_array, target_device,
-                                             new_size, rep_extra_specs)
-            # Extend the source volume
+            self.break_rdf_device_pair_session(
+                array, device_id, volume_name, extra_specs)
+
+            # Extend the R1 volume
             LOG.info("Extending source volume...")
-            self.provision.extend_volume(array, device_id, new_size,
-                                         extra_specs)
-            # Re-create replication relationship
+            self.provision.extend_volume(
+                array, device_id, new_size, extra_specs)
+
+            # Setup volume replication again for source volume
             LOG.info("Recreating replication relationship...")
-            self.setup_volume_replication(array, volume, device_id,
-                                          extra_specs, target_device)
-            # Check if volume needs to be returned to volume group
-            if volume.group_id:
-                self._add_new_volume_to_volume_group(
-                    volume, device_id, volume_name, extra_specs)
+            rep_status, __, __, rep_extra_specs, resume_rdf = (
+                self.configure_volume_replication(
+                    array, volume, device_id, extra_specs))
+
+            # If first/only volume in SG then RDF protect SG
+            if rep_status == 'first_vol_in_rdf_group':
+                self._protect_storage_group(
+                    array, device_id, volume, volume_name, rep_extra_specs)
+
+            # If more than one volume in SG then resume replication
+            if resume_rdf:
+                self.rest.srdf_resume_replication(
+                    array, rep_extra_specs['mgmt_sg_name'],
+                    rep_extra_specs['rdf_group_no'], extra_specs)
 
         except Exception as e:
             exception_message = (_("Error extending volume. Error received "
@@ -1381,11 +1402,13 @@ class PowerMaxCommon(object):
         if extra_specs:
             if extra_specs.get('replication_enabled') == '<is> True':
                 extra_specs[utils.IS_RE] = True
-                if self.rep_config and self.rep_config.get('mode'):
-                    extra_specs[utils.REP_MODE] = self.rep_config['mode']
-                if self.rep_config and self.rep_config.get(utils.METROBIAS):
-                    extra_specs[utils.METROBIAS] = self.rep_config[
-                        utils.METROBIAS]
+                if self.rep_config:
+                    if self.rep_config.get('mode'):
+                        extra_specs[utils.REP_MODE] = self.rep_config['mode']
+                    if self.rep_config.get(utils.METROBIAS):
+                        extra_specs[utils.METROBIAS] = self.rep_config[
+                            utils.METROBIAS]
+
         return extra_specs, qos_specs
 
     def _find_device_on_array(self, volume, extra_specs):
@@ -1443,17 +1466,29 @@ class PowerMaxCommon(object):
         is_multiattach = False
         volume_name = volume.name
         device_id = self._find_device_on_array(volume, extra_specs)
-        if rep_extra_specs is not None:
-            device_id = self.get_remote_target_device(
-                extra_specs[utils.ARRAY], volume, device_id)[0]
+        if rep_extra_specs:
+            rdf_pair_info = self.rest.get_rdf_pair_volume(
+                extra_specs[utils.ARRAY], rep_extra_specs['rdf_group_no'],
+                device_id)
+            device_id = rdf_pair_info.get('remoteVolumeName', None)
             extra_specs = rep_extra_specs
-        host_name = self.utils.get_host_short_name(host) if host else None
+
+        host_name = self.utils.get_host_name_label(
+            host, self.powermax_short_host_name_template) if host else None
         if device_id:
             array = extra_specs[utils.ARRAY]
             # Return only masking views for this host
             host_maskingviews, all_masking_view_list = (
                 self._get_masking_views_from_volume(
                     array, device_id, host_name))
+            if not host_maskingviews:
+                # Backward compatibility if a new template was added to
+                # an existing backend.
+                host_name = self.utils.get_host_short_name(
+                    host) if host else None
+                host_maskingviews, all_masking_view_list = (
+                    self._get_masking_views_from_volume_for_host(
+                        all_masking_view_list, host_name))
 
             for maskingview in host_maskingviews:
                 host_lun_id = self.rest.find_mv_connections_for_vol(
@@ -1464,6 +1499,7 @@ class PowerMaxCommon(object):
                                   'array': array,
                                   'device_id': device_id}
                     maskedvols = devicedict
+
             if not maskedvols:
                 LOG.debug(
                     "Host lun id not found for volume: %(volume_name)s "
@@ -1502,7 +1538,7 @@ class PowerMaxCommon(object):
         :param volume: the volume object
         :param device_id: the volume device id
         :param host: the host
-        :return: masking view list, is metro
+        :returns: masking view list, is metro
         """
         is_metro = False
         extra_specs = self._initial_setup(volume)
@@ -1521,17 +1557,28 @@ class PowerMaxCommon(object):
         :returns: masking view list, all masking view list
         """
         LOG.debug("Getting masking views from volume")
-        host_maskingview_list, all_masking_view_list = [], []
-        host_compare = True if host else False
         mvs, __ = self._get_mvs_and_sgs_from_volume(array, device_id)
-        for mv in mvs:
-            all_masking_view_list.append(mv)
-            if host_compare:
-                if host.lower() in mv.lower():
-                    host_maskingview_list.append(mv)
-        maskingview_list = (host_maskingview_list if host_compare else
-                            all_masking_view_list)
-        return maskingview_list, all_masking_view_list
+        return self._get_masking_views_from_volume_for_host(mvs, host)
+
+    def _get_masking_views_from_volume_for_host(
+            self, masking_views, host_name):
+        """Check all masking views for host_name
+
+        :param masking_views: list of masking view
+        :param host_name: the host name for comparision
+        :returns: masking view list, all masking view list
+        """
+        LOG.debug("Getting masking views from volume for host %(host)s ",
+                  {'host': host_name})
+        host_masking_view_list, all_masking_view_list = [], []
+        for masking_view in masking_views:
+            all_masking_view_list.append(masking_view)
+            if host_name:
+                if host_name.lower() in masking_view.lower():
+                    host_masking_view_list.append(masking_view)
+        host_masking_view_list = (host_masking_view_list if host_name else
+                                  all_masking_view_list)
+        return host_masking_view_list, all_masking_view_list
 
     def _get_mvs_and_sgs_from_volume(self, array, device_id):
         """Helper function to retrieve masking views and storage groups.
@@ -1602,8 +1649,10 @@ class PowerMaxCommon(object):
         volume_name = volume.name
         device_id = self._find_device_on_array(volume, extra_specs)
         if rep_extra_specs is not None:
-            device_id = self.get_remote_target_device(
-                extra_specs[utils.ARRAY], volume, device_id)[0]
+            rdf_pair_info = self.rest.get_rdf_pair_volume(
+                extra_specs[utils.ARRAY], rep_extra_specs['rdf_group_no'],
+                device_id)
+            device_id = rdf_pair_info.get('remoteVolumeName', None)
             extra_specs = rep_extra_specs
         if not device_id:
             exception_message = (_("Cannot retrieve volume %(vol)s "
@@ -1612,7 +1661,10 @@ class PowerMaxCommon(object):
             raise exception.VolumeBackendAPIException(exception_message)
 
         protocol = self.utils.get_short_protocol_type(self.protocol)
-        short_host_name = self.utils.get_host_short_name(connector['host'])
+        short_host_name = self.utils.get_host_name_label(
+            connector['host'], self.powermax_short_host_name_template)
+        masking_view_dict[utils.USED_HOST_NAME] = short_host_name
+
         masking_view_dict[utils.SLO] = extra_specs[utils.SLO]
         masking_view_dict[utils.WORKLOAD] = 'NONE' if self.next_gen else (
             extra_specs[utils.WORKLOAD])
@@ -1623,19 +1675,27 @@ class PowerMaxCommon(object):
                         "in cinder.conf or as an extra spec. Port group "
                         "cannot be left empty as creating a new masking "
                         "view will fail.")
+        masking_view_dict[utils.PORT_GROUP_LABEL] = (
+            self.utils.get_port_name_label(
+                extra_specs[utils.PORTGROUPNAME],
+                self.powermax_port_group_name_template))
+
         masking_view_dict[utils.PORTGROUPNAME] = (
             extra_specs[utils.PORTGROUPNAME])
         masking_view_dict[utils.INITIATOR_CHECK] = (
             self._get_initiator_check_flag())
 
-        child_sg_name, do_disable_compression, rep_enabled, short_pg_name = (
-            self.utils.get_child_sg_name(short_host_name, extra_specs))
+        child_sg_name, do_disable_compression, rep_enabled = (
+            self.utils.get_child_sg_name(
+                short_host_name, extra_specs,
+                masking_view_dict[utils.PORT_GROUP_LABEL]))
         masking_view_dict[utils.DISABLECOMPRESSION] = do_disable_compression
         masking_view_dict[utils.IS_RE] = rep_enabled
         mv_prefix = (
             "OS-%(shortHostName)s-%(protocol)s-%(pg)s"
             % {'shortHostName': short_host_name,
-               'protocol': protocol, 'pg': short_pg_name})
+               'protocol': protocol,
+               'pg': masking_view_dict[utils.PORT_GROUP_LABEL]})
 
         masking_view_dict[utils.SG_NAME] = child_sg_name
 
@@ -1670,6 +1730,7 @@ class PowerMaxCommon(object):
         """
         clone_name = volume.name
         snap_name = None
+        rep_update, rep_info_dict = dict(), dict()
         LOG.info("Create a replica from Volume: Clone Volume: %(clone_name)s "
                  "from Source Volume: %(source_name)s.",
                  {'clone_name': clone_name,
@@ -1700,10 +1761,11 @@ class PowerMaxCommon(object):
                 message=exception_message)
 
         # Perform any snapvx cleanup if required before creating the clone
-        self._clone_check(array, source_device_id, extra_specs)
+        if is_snapshot or from_snapvx:
+            self._clone_check(array, source_device_id, extra_specs)
 
         if not is_snapshot:
-            clone_dict = self._create_replica(
+            clone_dict, rep_update, rep_info_dict = self._create_replica(
                 array, volume, source_device_id, extra_specs,
                 snap_name=snap_name)
         else:
@@ -1715,7 +1777,7 @@ class PowerMaxCommon(object):
                   {'clone_name': clone_name,
                    'source_name': source_device_id})
 
-        return clone_dict
+        return clone_dict, rep_update, rep_info_dict
 
     def _parse_snap_info(self, array, snapshot):
         """Given a snapshot object, parse the provider_location.
@@ -1830,20 +1892,25 @@ class PowerMaxCommon(object):
         return volume_name
 
     def _create_volume(
-            self, volume_name, volume_size, extra_specs, in_use=False):
+            self, volume_name, volume_size, extra_specs):
         """Create a volume.
 
         :param volume_name: the volume name
         :param volume_size: the volume size
         :param extra_specs: extra specifications
         :param in_use: if the volume is in 'in-use' state
-        :return: volume_dict --dict
+        :returns: volume_dict --dict
         :raises: VolumeBackendAPIException:
         """
+        # Set Create Volume options
+        is_re, rep_mode, rep_first_vol = False, None, False
+        rep_extra_specs, rep_info_dict, rep_update = dict(), dict(), dict()
+        # Get Array details
         array = extra_specs[utils.ARRAY]
         array_model, next_gen = self.rest.get_array_model_info(array)
         if next_gen:
             extra_specs[utils.WORKLOAD] = 'NONE'
+        # Verify valid SL/WL combination
         is_valid_slo, is_valid_workload = self.provision.verify_slo_workload(
             array, extra_specs[utils.SLO],
             extra_specs[utils.WORKLOAD], next_gen, array_model)
@@ -1868,21 +1935,42 @@ class PowerMaxCommon(object):
         do_disable_compression = self.utils.is_compression_disabled(
             extra_specs)
 
-        # If the volume is in-use, set replication config for correct SG
-        # creation
-        if in_use and self.utils.is_replication_enabled(extra_specs):
+        if self.utils.is_replication_enabled(extra_specs):
             is_re, rep_mode = True, extra_specs['rep_mode']
-        else:
-            is_re, rep_mode = False, None
+            rep_first_vol, rep_extra_specs, rep_info_dict = (
+                self.prepare_replication_details(extra_specs))
 
         storagegroup_name = self.masking.get_or_create_default_storage_group(
             array, extra_specs[utils.SRP], extra_specs[utils.SLO],
             extra_specs[utils.WORKLOAD], extra_specs,
             do_disable_compression, is_re, rep_mode)
+
         try:
             volume_dict = self.provision.create_volume_from_sg(
                 array, volume_name, storagegroup_name,
-                volume_size, extra_specs)
+                volume_size, extra_specs, rep_info_dict)
+            if is_re:
+                rep_vol_dict = deepcopy(volume_dict)
+                rep_vol_dict.update({'device_uuid': volume_name,
+                                     'storage_group': rep_extra_specs[
+                                         'sg_name'],
+                                     'size': volume_size})
+                if rep_first_vol:
+                    self.srdf_protect_storage_group(
+                        extra_specs, rep_extra_specs, rep_vol_dict)
+
+                remote_device_id = self.get_and_set_remote_device_uuid(
+                    extra_specs, rep_extra_specs, rep_vol_dict)
+                rep_vol_dict.update({'remote_device_id': remote_device_id})
+                rep_update, rep_info_dict = self.gather_replication_updates(
+                    extra_specs, rep_extra_specs, rep_vol_dict)
+
+                if rep_mode in [utils.REP_ASYNC, utils.REP_METRO]:
+                    self._add_volume_to_rdf_management_group(
+                        array, volume_dict['device_id'], volume_name,
+                        rep_extra_specs['array'], remote_device_id,
+                        extra_specs)
+
         except Exception:
             # if the volume create fails, check if the
             # storage group needs to be cleaned up
@@ -1899,7 +1987,7 @@ class PowerMaxCommon(object):
                     array, storagegroup_name)
             raise
 
-        return volume_dict
+        return volume_dict, rep_update, rep_info_dict
 
     def _set_vmax_extra_specs(self, extra_specs, pool_record):
         """Set the PowerMax/VMAX extra specs.
@@ -1929,6 +2017,8 @@ class PowerMaxCommon(object):
             LOG.error(error_message)
             raise exception.VolumeBackendAPIException(message=error_message)
 
+        self._validate_storage_group_tag_list(extra_specs)
+
         extra_specs[utils.INTERVAL] = self.interval
         LOG.debug("The interval is set at: %(intervalInSecs)s.",
                   {'intervalInSecs': self.interval})
@@ -1990,6 +2080,10 @@ class PowerMaxCommon(object):
         else:
             extra_specs.pop(utils.DISABLECOMPRESSION, None)
 
+        self._check_and_add_tags_to_storage_array(
+            extra_specs[utils.ARRAY], self.powermax_array_tag_list,
+            extra_specs)
+
         LOG.debug("SRP is: %(srp)s, Array is: %(array)s "
                   "SLO is: %(slo)s, Workload is: %(workload)s.",
                   {'srp': extra_specs[utils.SRP],
@@ -2005,6 +2099,47 @@ class PowerMaxCommon(object):
 
         return extra_specs
 
+    def _validate_storage_group_tag_list(self, extra_specs):
+        """Validate the storagetype:storagegrouptags list
+
+        :param extra_specs: the extra specifications
+        :raises: VolumeBackendAPIException:
+        """
+        tag_list = extra_specs.get(utils.STORAGE_GROUP_TAGS)
+        if tag_list:
+            if not self.utils.verify_tag_list(tag_list.split(',')):
+                exception_message = (_(
+                    "Unable to get verify "
+                    "storagetype:storagegrouptags in the Volume Type. "
+                    "Only alpha-numeric, dashes and underscores "
+                    "allowed. List values must be separated by commas. "
+                    "The number of values must not exceed 8"))
+                raise exception.VolumeBackendAPIException(
+                    message=exception_message)
+            else:
+                LOG.info("The tag list %(tag_list)s has been verified.",
+                         {'tag_list': tag_list})
+
+    def _validate_array_tag_list(self, array_tag_list):
+        """Validate the array tag list
+
+        :param array_tag_list: the array tag list
+        :raises: VolumeBackendAPIException:
+        """
+        if array_tag_list:
+            if not self.utils.verify_tag_list(array_tag_list):
+                exception_message = (_(
+                    "Unable to get verify "
+                    "config option powermax_array_tag_list. "
+                    "Only alpha-numeric, dashes and underscores "
+                    "allowed. List values must be separated by commas. "
+                    "The number of values must not exceed 8"))
+                raise exception.VolumeBackendAPIException(
+                    message=exception_message)
+            else:
+                LOG.info("The tag list %(tag_list)s has been verified.",
+                         {'tag_list': array_tag_list})
+
     def _delete_from_srp(self, array, device_id, volume_name,
                          extra_specs):
         """Delete from srp.
@@ -2038,17 +2173,134 @@ class PowerMaxCommon(object):
         :param extra_specs: the extra specifications
         :param volume: the volume object
         """
-        # Cleanup remote replication
+        # Cleanup replication
         if self.utils.is_replication_enabled(extra_specs):
-            # Add force to allow volume removal from RDF enabled storage groups
+            rdf_group_no, __ = self.get_rdf_details(array)
+            self.cleanup_rdf_device_pair(array, rdf_group_no, device_id,
+                                         extra_specs)
+        else:
+            self.masking.remove_and_reset_members(
+                array, volume, device_id, volume_name, extra_specs, False)
+
+    @coordination.synchronized('emc-{rdf_group_no}-rdf')
+    def cleanup_rdf_device_pair(self, array, rdf_group_no, device_id,
+                                extra_specs):
+        """Cleanup replication on a RDF device pair, leave only source volume.
+
+        :param array: the array serial number
+        :param rdf_group_no: the rdf group number
+        :param device_id: the device id
+        :param extra_specs: the extra specifications
+        :raises: exception.VolumeBackendAPIException
+        """
+        resume_replication, rdf_mgmt_cleanup = False, False
+        rdf_mgmt_sg, vols_in_mgmt_sg = None, None
+        rep_mode = extra_specs['rep_mode']
+        if rep_mode in [utils.REP_METRO, utils.REP_ASYNC]:
             extra_specs['force_vol_remove'] = True
+        rdf_group_no, remote_array = self.get_rdf_details(array)
+        rep_extra_specs = self._get_replication_extra_specs(
+            extra_specs, self.rep_config)
 
-            self.cleanup_lun_replication(volume, volume_name,
-                                         device_id, extra_specs)
+        # 1. Get the remote device ID so it can be deleted later
+        remote_device = self.rest.get_rdf_pair_volume(
+            array, rdf_group_no, device_id)
+        remote_device_id = remote_device['remoteVolumeName']
+        vol_sg_list = self.rest.get_storage_groups_from_volume(
+            array, device_id)
 
-        # Remove from any storage groups
-        self.masking.remove_and_reset_members(
-            array, volume, device_id, volume_name, extra_specs, False)
+        # 2. If replication mode is async or metro, get RDF mgmt group info and
+        # suspend RDFG before proceeding to delete operation
+        if rep_mode in [utils.REP_METRO, utils.REP_ASYNC]:
+            # Make sure devices are in a valid state before continuing
+            self.rest.wait_for_rdf_pair_sync(
+                array, rdf_group_no, device_id, rep_extra_specs)
+            rdf_mgmt_sg = self.utils.get_rdf_management_group_name(
+                self.rep_config)
+
+            vols_in_mgmt_sg = self.rest.get_num_vols_in_sg(array, rdf_mgmt_sg)
+            if vols_in_mgmt_sg > 1:
+                resume_replication = True
+            else:
+                rdf_mgmt_cleanup = True
+
+            self.rest.srdf_suspend_replication(
+                array, rdf_mgmt_sg, rdf_group_no, rep_extra_specs)
+
+        # 3. Check vol does not live in any SGs outside OpenStack managed SGs
+        if rdf_mgmt_sg and rdf_mgmt_sg in vol_sg_list:
+            vol_sg_list.remove(rdf_mgmt_sg)
+        if len(vol_sg_list) > 1:
+            exception_message = (_(
+                "There is more than one storage group associated with device "
+                "%(dev)s not including RDF management groups. Please check "
+                "device is not member of non-OpenStack managed storage "
+                "groups" % {'dev': device_id}))
+            LOG.error(exception_message)
+            raise exception.VolumeBackendAPIException(exception_message)
+        else:
+            vol_src_sg = vol_sg_list[0]
+
+        # 4. Remove device from SG and delete RDFG device pair
+        self.rest.srdf_remove_device_pair_from_storage_group(
+            array, vol_src_sg, rep_extra_specs['array'], device_id,
+            rep_extra_specs)
+
+        # 5. Remove the volume from any additional SGs
+        if rdf_mgmt_sg:
+            self.rest.remove_vol_from_sg(
+                array, rdf_mgmt_sg, device_id, extra_specs)
+            self.rest.remove_vol_from_sg(
+                remote_array, rdf_mgmt_sg, remote_device_id, rep_extra_specs)
+
+        # 6. Delete the r2 volume
+        self.rest.delete_volume(remote_array, remote_device_id)
+
+        # 7. Delete the SGs if there are no volumes remaining
+        self._cleanup_rdf_storage_groups_post_r2_delete(
+            array, remote_array, vol_src_sg, rdf_mgmt_sg, rdf_mgmt_cleanup)
+
+        # 8. Resume replication if RDFG still contains volumes
+        if resume_replication:
+            self.rest.srdf_resume_replication(
+                array, rdf_mgmt_sg, rep_extra_specs['rdf_group_no'],
+                rep_extra_specs)
+
+        LOG.info('Remote device %(dev)s deleted from RDF Group %(grp)s',
+                 {'dev': remote_device_id,
+                  'grp': rep_extra_specs['rdf_group_label']})
+
+    def _cleanup_rdf_storage_groups_post_r2_delete(
+            self, array, remote_array, sg_name, rdf_mgmt_sg, rdf_mgmt_cleanup):
+        """Cleanup storage groups after a RDF device pair has been deleted.
+
+        :param array: the array serial number
+        :param remote_array: the remote array serial number
+        :param sg_name: the storage group name
+        :param rdf_mgmt_sg: the RDF managment group name
+        :param rdf_mgmt_cleanup: is RDF management group cleanup required
+        """
+        vols_in_sg = self.rest.get_num_vols_in_sg(array, sg_name)
+        if not vols_in_sg:
+            parent_sg = self.masking.get_parent_sg_from_child(
+                array, sg_name)
+            self.rest.delete_storage_group(array, sg_name)
+            self.rest.delete_storage_group(remote_array, sg_name)
+            if parent_sg:
+                vols_in_parent = self.rest.get_num_vols_in_sg(
+                    array, parent_sg)
+                if not vols_in_parent:
+                    mv_name = self.rest.get_masking_views_from_storage_group(
+                        array, parent_sg)
+                    if mv_name:
+                        self.rest.delete_masking_view(array, mv_name)
+                    if sg_name != parent_sg:
+                        self.rest.delete_storage_group(array, parent_sg)
+                        self.rest.delete_storage_group(remote_array,
+                                                       parent_sg)
+        if rdf_mgmt_cleanup:
+            self.rest.delete_storage_group(array, rdf_mgmt_sg)
+            self.rest.delete_storage_group(remote_array, rdf_mgmt_sg)
 
     def get_target_wwns_from_masking_view(
             self, volume, connector):
@@ -2060,18 +2312,28 @@ class PowerMaxCommon(object):
         """
         metro_wwns = []
         host = connector['host']
-        short_host_name = self.utils.get_host_short_name(host)
+        short_host_name = self.utils.get_host_name_label(
+            host, self.powermax_short_host_name_template) if host else None
         extra_specs = self._initial_setup(volume)
         rep_extra_specs = self._get_replication_extra_specs(
             extra_specs, self.rep_config)
+
         if self.utils.is_volume_failed_over(volume):
             extra_specs = rep_extra_specs
         device_id = self._find_device_on_array(volume, extra_specs)
         target_wwns = self._get_target_wwns_from_masking_view(
             device_id, short_host_name, extra_specs)
+
         if self.utils.is_metro_device(self.rep_config, extra_specs):
-            remote_device_id = self.get_remote_target_device(
-                extra_specs[utils.ARRAY], volume, device_id)[0]
+            rdf_group_no, __ = self.get_rdf_details(
+                extra_specs[utils.ARRAY])
+
+            rdf_pair_info = self.rest.get_rdf_pair_volume(
+                extra_specs[utils.ARRAY], rdf_group_no, device_id)
+            remote_device_id = rdf_pair_info.get('remoteVolumeName', None)
+
+            rep_extra_specs = self._get_replication_extra_specs(
+                extra_specs, self.rep_config)
             metro_wwns = self._get_target_wwns_from_masking_view(
                 remote_device_id, short_host_name, rep_extra_specs)
         return target_wwns, metro_wwns
@@ -2083,7 +2345,7 @@ class PowerMaxCommon(object):
         :param device_id: the device id
         :param short_host_name: the short host name
         :param extra_specs: the extra specs
-        :return: target wwns -- list
+        :returns: target wwns -- list
         """
         target_wwns = []
         array = extra_specs[utils.ARRAY]
@@ -2178,17 +2440,21 @@ class PowerMaxCommon(object):
         :returns: int -- return code
         :returns: dict -- cloneDict
         """
-        target_device_id = None
-        clone_id = clone_volume.id
+        clone_id, target_device_id = clone_volume.id, None
         clone_name = self.utils.get_volume_element_name(clone_id)
-        create_snap = False
-
+        create_snap, copy_mode, rep_extra_specs = False, False, dict()
         volume_dict = self.rest.get_volume(array, source_device_id)
+        replication_enabled = self.utils.is_replication_enabled(extra_specs)
+        if replication_enabled:
+            copy_mode = True
+            __, rep_extra_specs, __ = (
+                self.prepare_replication_details(extra_specs))
+
         # PowerMax/VMAX supports using a target volume that is bigger than
         # the source volume, so we create the target volume the desired
         # size at this point to avoid having to extend later
         try:
-            clone_dict = self._create_volume(
+            clone_dict, rep_update, rep_info_dict = self._create_volume(
                 clone_name, clone_volume.size, extra_specs)
 
             target_device_id = clone_dict['device_id']
@@ -2202,9 +2468,16 @@ class PowerMaxCommon(object):
             if not snap_name:
                 snap_name = self.utils.get_temp_snap_name(source_device_id)
                 create_snap = True
+            if replication_enabled:
+                self.rest.srdf_suspend_replication(
+                    array, rep_extra_specs['sg_name'],
+                    rep_extra_specs['rdf_group_no'], rep_extra_specs)
             self.provision.create_volume_replica(
                 array, source_device_id, target_device_id,
-                snap_name, extra_specs, create_snap)
+                snap_name, extra_specs, create_snap, copy_mode)
+            if replication_enabled:
+                self.rest.rdf_resume_with_retries(array, rep_extra_specs)
+
         except Exception as e:
             if target_device_id:
                 LOG.warning("Create replica failed. Cleaning up the target "
@@ -2220,7 +2493,7 @@ class PowerMaxCommon(object):
         # add source id and snap_name to the clone dict
         clone_dict['source_device_id'] = source_device_id
         clone_dict['snap_name'] = snap_name
-        return clone_dict
+        return clone_dict, rep_update, rep_info_dict
 
     def _cleanup_target(
             self, array, target_device_id, source_device_id,
@@ -2239,7 +2512,7 @@ class PowerMaxCommon(object):
         snap_session = self.rest.get_sync_session(
             array, source_device_id, snap_name, target_device_id, generation)
         if snap_session:
-            self.provision.break_replication_relationship(
+            self.provision.unlink_snapvx_tgt_volume(
                 array, target_device_id, source_device_id,
                 snap_name, extra_specs, generation)
         self._remove_vol_and_cleanup_replication(
@@ -2331,7 +2604,7 @@ class PowerMaxCommon(object):
                 "Unlinking source from target. Source: %(vol)s, Target: "
                 "%(tgt)s, Generation: %(gen)s.", {'vol': source, 'tgt': target,
                                                   'gen': generation})
-            self.provision.break_replication_relationship(
+            self.provision.unlink_snapvx_tgt_volume(
                 array, target, source, snap_name, extra_specs, generation,
                 loop)
 
@@ -2365,7 +2638,7 @@ class PowerMaxCommon(object):
                 array, device_id, tgt_only=True)
             source_device_id = tgt_session['source_vol_id']
             LOG.debug("Target %(tgt)s source device %(src)s",
-                      {'target': device_id, 'src': source_device_id})
+                      {'tgt': device_id, 'src': source_device_id})
 
         return source_device_id
 
@@ -2434,10 +2707,14 @@ class PowerMaxCommon(object):
         :returns: dict -- model_update
         """
         LOG.info("Beginning manage existing volume process")
-        rep_info_dict = {}
+        rep_info_dict, resume_rdf, rep_status = dict(), False, None
+        rep_model_update, rep_driver_data = dict(), dict()
+        rep_extra_specs = dict()
+        extra_specs = self._initial_setup(volume)
         array, device_id = self.utils.get_array_and_device_id(
             volume, external_ref)
         volume_id = volume.id
+
         # Check if the existing volume is valid for cinder management
         orig_vol_name, src_sg = self._check_lun_valid_for_cinder_management(
             array, device_id, volume_id, external_ref)
@@ -2445,12 +2722,10 @@ class PowerMaxCommon(object):
         if not orig_vol_name:
             orig_vol_name = device_id
         LOG.debug("Original volume name %(vol)s and source sg: %(sg_name)s.",
-                  {'vol': orig_vol_name,
-                   'sg_name': src_sg})
-        extra_specs = self._initial_setup(volume)
+                  {'vol': orig_vol_name, 'sg_name': src_sg})
 
-        volume_name = self.utils.get_volume_element_name(volume_id)
         # Rename the volume
+        volume_name = self.utils.get_volume_element_name(volume_id)
         LOG.debug("Rename volume %(vol)s to %(element_name)s.",
                   {'vol': orig_vol_name,
                    'element_name': volume_name})
@@ -2460,38 +2735,108 @@ class PowerMaxCommon(object):
 
         # Set-up volume replication, if enabled
         if self.utils.is_replication_enabled(extra_specs):
-            rep_update, rep_info_dict = self._replicate_volume(
-                volume, volume_name, provider_location,
-                extra_specs, delete_src=False)
-            model_update.update(rep_update)
+            (rep_status, rep_driver_data, rep_info_dict,
+             rep_extra_specs, resume_rdf) = (
+                self.configure_volume_replication(
+                    array, volume, device_id, extra_specs))
+            if rep_driver_data:
+                rep_model_update = {
+                    'replication_status': rep_status,
+                    'replication_driver_data': six.text_type(
+                        {'device_id': rep_info_dict['target_device_id'],
+                         'array': rep_info_dict['remote_array']})}
 
-        else:
-            try:
-                # Add/move volume to default storage group
-                self.masking.add_volume_to_default_storage_group(
-                    array, device_id, volume_name, extra_specs, src_sg=src_sg)
-            except Exception as e:
-                exception_message = (_(
-                    "Unable to move the volume to the default SG. "
-                    "Exception received was %(e)s") % {'e': six.text_type(e)})
-                LOG.error(exception_message)
-                # Try to rename the volume back to the original name
-                LOG.debug("Rename volume %(vol)s back to %(element_name)s.",
-                          {'vol': volume_id,
-                           'element_name': orig_vol_name})
-                self.rest.rename_volume(array, device_id, orig_vol_name)
-                raise exception.VolumeBackendAPIException(
-                    message=exception_message)
+        try:
+            # Add/move volume to default storage group
+            self.masking.add_volume_to_default_storage_group(
+                array, device_id, volume_name, extra_specs, src_sg=src_sg)
+            if rep_status == 'first_vol_in_rdf_group':
+                rep_status, rep_driver_data, rep_info_dict = (
+                    self._protect_storage_group(
+                        array, device_id, volume, volume_name,
+                        rep_extra_specs))
+
+        except Exception as e:
+            exception_message = (_(
+                "Unable to move the volume to the default SG. "
+                "Exception received was %(e)s") % {'e': six.text_type(e)})
+            LOG.error(exception_message)
+            LOG.debug("Rename volume %(vol)s back to %(element_name)s.",
+                      {'vol': volume_id, 'element_name': orig_vol_name})
+            self.rest.rename_volume(array, device_id, orig_vol_name)
+            raise exception.VolumeBackendAPIException(
+                message=exception_message)
 
+        if resume_rdf:
+            self.rest.srdf_resume_replication(
+                array, rep_extra_specs['mgmt_sg_name'],
+                rep_extra_specs['rdf_group_no'], extra_specs)
+
+        if rep_driver_data:
+            rep_model_update = {
+                'replication_status': rep_status,
+                'replication_driver_data': six.text_type(
+                    {'device_id': rep_info_dict['target_device_id'],
+                     'array': rep_info_dict['remote_array']})}
+
+        model_update.update(rep_model_update)
         model_update = self.update_metadata(
             model_update, volume.metadata, self.get_volume_metadata(
                 array, device_id))
-
         self.volume_metadata.capture_manage_existing(
             volume, rep_info_dict, device_id, extra_specs)
 
         return model_update
 
+    def _protect_storage_group(
+            self, array, device_id, volume, volume_name, rep_extra_specs):
+        """Enable RDF on a volume after it has been managed into OpenStack.
+
+        :param array: the array serial number
+        :param device_id: the device id
+        :param volume: the volume object
+        :param volume_name: the volume name
+        :param rep_info_dict: replication information dictionary
+        :returns: replication status, device pair info, replication info --
+                  str, dict, dict
+        """
+        rdf_group_no = rep_extra_specs['rdf_group_no']
+        remote_array = rep_extra_specs['array']
+        rep_mode = rep_extra_specs['rep_mode']
+
+        if rep_mode in [utils.REP_ASYNC, utils.REP_METRO]:
+            rep_extra_specs['mgmt_sg_name'] = (
+                self.utils.get_rdf_management_group_name(self.rep_config))
+        else:
+            rep_extra_specs['mgmt_sg_name'] = None
+
+        sg_list = self.rest.get_storage_groups_from_volume(array, device_id)
+        if len(sg_list) == 1:
+            sg_name = sg_list[0]
+        elif len(sg_list) > 1:
+            exception_message = (_(
+                "Unable to RDF protect device %(dev)s in OpenStack managed "
+                "storage group because it currently exists in one or more "
+                "user managed storage groups." % {'dev': device_id}))
+            LOG.error(exception_message)
+            raise exception.VolumeBackendAPIException(exception_message)
+
+        rep_status, pair_info, r2_device_id = (
+            self._post_retype_srdf_protect_storage_group(
+                array, sg_name, device_id, volume_name, rep_extra_specs))
+
+        target_name = self.utils.get_volume_element_name(volume.id)
+        rep_info_dict = self.volume_metadata.gather_replication_info(
+            volume.id, 'replication', False,
+            rdf_group_no=rdf_group_no, target_name=target_name,
+            remote_array=remote_array, target_device_id=r2_device_id,
+            replication_status=rep_status, rep_mode=rep_mode,
+            rdf_group_label=self.rep_config['rdf_group_label'],
+            target_array_model=rep_extra_specs['target_array_model'],
+            mgmt_sg_name=rep_extra_specs['mgmt_sg_name'])
+
+        return rep_status, pair_info, rep_info_dict
+
     def _check_lun_valid_for_cinder_management(
             self, array, device_id, volume_id, external_ref):
         """Check if a volume is valid for cinder management.
@@ -2607,7 +2952,7 @@ class PowerMaxCommon(object):
                       {'id': volume_id})
         else:
             # Check if volume is snap source
-            self._sync_check(extra_specs['array'], device_id, extra_specs)
+            self._clone_check(extra_specs['array'], device_id, extra_specs)
             # Remove volume from any openstack storage groups
             # and remove any replication
             self._remove_vol_and_cleanup_replication(
@@ -2797,7 +3142,7 @@ class PowerMaxCommon(object):
                           keys: size, reference. Default=None.
         :param sort_dirs: Direction to sort by. Valid dirs: asc, desc.
                           Default=None.
-        :return: List of dicts containing all volumes valid for management
+        :returns: List of dicts containing all volumes valid for management
         """
         valid_vols = []
         manageable_vols = []
@@ -2853,7 +3198,7 @@ class PowerMaxCommon(object):
                           keys: size, reference. Default=None.
         :param sort_dirs: Direction to sort by. Valid dirs: asc, desc.
                           Default=None.
-        :return: manageable_vols -Sorted list of dicts
+        :returns: manageable_vols -Sorted list of dicts
         """
         # If sort keys selected, determine if by size or reference, and
         # direction of sort
@@ -2905,7 +3250,7 @@ class PowerMaxCommon(object):
                           Valid keys: size, reference. Default=None.
         :param sort_dirs: Direction to sort by. Valid dirs: asc, desc.
                           Default=None.
-        :return: List of dicts containing all snapshots valid for management
+        :returns: List of dicts containing all snapshots valid for management
         """
         manageable_snaps = []
         array = self.pool_info['arrays_info'][0]["SerialNumber"]
@@ -2948,7 +3293,7 @@ class PowerMaxCommon(object):
                           Valid keys: size, reference. Default=None.
         :param sort_dirs: Direction to sort by. Valid dirs: asc, desc.
                           Default=None.
-        :return: List of dicts containing all snapshots valid for management
+        :returns: List of dicts containing all snapshots valid for management
         """
         manageable_snaps = sorted(
             manageable_snaps,
@@ -2998,7 +3343,7 @@ class PowerMaxCommon(object):
         :param manageable_snaps: list of manageable snapshots
         :param device: the source device
 
-        :return: List of dicts containing all snapshots valid for management
+        :returns: List of dicts containing all snapshots valid for management
         """
         if self.utils.is_snapshot_manageable(device):
             # Snapshot valid, extract relevant snap info
@@ -3050,6 +3395,16 @@ class PowerMaxCommon(object):
                  {'volume': volume_name})
 
         extra_specs = self._initial_setup(volume)
+        if not self.utils.is_retype_supported(volume, extra_specs,
+                                              new_type['extra_specs']):
+            src_mode = extra_specs.get('rep_mode', 'non-replicated')
+            LOG.error("It is not possible to perform host-assisted retype "
+                      "from %(src_mode)s to Metro replication type whilst the "
+                      "volume is attached to a host. To perform this "
+                      "operation please first detach the volume.",
+                      {'src_mode': src_mode})
+            return False
+
         device_id = self._find_device_on_array(volume, extra_specs)
         if device_id is None:
             LOG.error("Volume %(name)s not found on the array. "
@@ -3133,110 +3488,78 @@ class PowerMaxCommon(object):
         :param extra_specs: the extra specifications
         :returns: bool
         """
-        model_update, rep_mode, move_target, success = None, None, False, False
+        model_update, success = None, False
+        rep_info_dict, rep_extra_specs, rep_mode, rep_status, resume_rdf = (
+            None, None, None, False, False)
+
         target_extra_specs = new_type['extra_specs']
-        target_extra_specs[utils.SRP] = srp
-        target_extra_specs[utils.ARRAY] = array
-        target_extra_specs[utils.SLO] = target_slo
-        target_extra_specs[utils.WORKLOAD] = target_workload
-        target_extra_specs[utils.INTERVAL] = extra_specs[utils.INTERVAL]
-        target_extra_specs[utils.RETRIES] = extra_specs[utils.RETRIES]
-        is_compression_disabled = self.utils.is_compression_disabled(
+        target_extra_specs.update({
+            utils.SRP: srp, utils.ARRAY: array, utils.SLO: target_slo,
+            utils.WORKLOAD: target_workload,
+            utils.INTERVAL: extra_specs[utils.INTERVAL],
+            utils.RETRIES: extra_specs[utils.RETRIES]})
+
+        compression_disabled = self.utils.is_compression_disabled(
             target_extra_specs)
+        target_extra_specs.update(
+            {utils.DISABLECOMPRESSION: compression_disabled})
 
-        if self.rep_config and self.rep_config.get('mode'):
+        was_rep_enabled = self.utils.is_replication_enabled(extra_specs)
+        if self.utils.is_replication_enabled(target_extra_specs):
             rep_mode = self.rep_config['mode']
             target_extra_specs[utils.REP_MODE] = rep_mode
-        was_rep_enabled = self.utils.is_replication_enabled(extra_specs)
-        is_rep_enabled = self.utils.is_replication_enabled(target_extra_specs)
-
-        if volume.attach_status == 'attached':
-            # Scenario: Rep was enabled, target VT has rep disabled, need to
-            # disable replication
-            if was_rep_enabled and not is_rep_enabled:
-                # Add force to allow volume removal from RDF enabled
-                # storage groups
-                extra_specs['force_vol_remove'] = True
-                self.cleanup_lun_replication(volume, volume_name,
-                                             device_id, extra_specs)
-                model_update = {
-                    'replication_status': REPLICATION_DISABLED,
-                    'replication_driver_data': None}
-
-            # Scenario: Rep was not enabled, target VT has rep enabled, need to
-            # enable replication
-            elif not was_rep_enabled and is_rep_enabled:
-                metro_bias = utils.METROBIAS
-                if metro_bias in self.rep_config:
-                    extra_specs[metro_bias] = self.rep_config[metro_bias]
-                rep_status, rep_driver_data, rep_info_dict = (
-                    self.setup_inuse_volume_replication(
-                        array, volume, device_id, extra_specs))
-                model_update = {
-                    'replication_status': rep_status,
-                    'replication_driver_data': six.text_type(rep_driver_data)}
-
-            # Retype the device on the source array
-            success, target_sg_name = self._retype_inuse_volume(
-                array, srp, volume, device_id, extra_specs,
-                target_slo, target_workload, target_extra_specs,
-                is_compression_disabled)
-
-            # If the volume was replication enabled both before and after
-            # retype, the volume needs to be retyped on the remote array also
-            if was_rep_enabled and is_rep_enabled:
-                success = self._retype_remote_volume(
-                    array, volume, device_id, volume_name,
-                    rep_mode, is_rep_enabled, target_extra_specs)
-
-        # Volume is not attached, retype as normal
+            is_rep_enabled = True
         else:
-            if was_rep_enabled:
-                if not is_rep_enabled:
-                    # Disable replication is True
-                    self._remove_vol_and_cleanup_replication(
-                        array, device_id, volume_name, extra_specs, volume)
-                    model_update = {'replication_status': REPLICATION_DISABLED,
-                                    'replication_driver_data': None}
-                else:
-                    # Ensure both source and target volumes are retyped
-                    move_target = True
-            else:
-                if is_rep_enabled:
-                    metro_bias = utils.METROBIAS
-                    if metro_bias in self.rep_config:
-                        target_extra_specs[
-                            metro_bias] = self.rep_config[metro_bias]
-                    # Setup_volume_replication will put volume in correct sg
-                    rep_status, rdf_dict, __ = self.setup_volume_replication(
-                        array, volume, device_id, target_extra_specs)
-                    model_update = {
-                        'replication_status': rep_status,
-                        'replication_driver_data': six.text_type(rdf_dict)}
-                    model_update = self.update_metadata(
-                        model_update, volume.metadata,
-                        self.get_volume_metadata(array, device_id))
+            is_rep_enabled = False
 
-                    return True, model_update
-
-            try:
-                target_sg_name = (
-                    self.masking.get_or_create_default_storage_group(
-                        array, srp, target_slo, target_workload, extra_specs,
-                        is_compression_disabled, is_rep_enabled, rep_mode))
-            except Exception as e:
-                LOG.error("Failed to get or create storage group. "
-                          "Exception received was %(e)s.", {'e': e})
-                return False
+        # Scenario: Rep -> Non-Rep
+        if was_rep_enabled and not is_rep_enabled:
+            rep_extra_specs, resume_rdf = (
+                self.break_rdf_device_pair_session(
+                    array, device_id, volume_name, extra_specs))
+            model_update = {
+                'replication_status': REPLICATION_DISABLED,
+                'replication_driver_data': None}
 
-            success = self._retype_volume(
-                array, device_id, volume_name, target_sg_name,
-                volume, target_extra_specs)
+        # Scenario: Non-Rep -> Rep
+        elif not was_rep_enabled and is_rep_enabled:
+            (rep_status, rep_driver_data, rep_info_dict,
+             rep_extra_specs, resume_rdf) = (
+                self.configure_volume_replication(
+                    array, volume, device_id, target_extra_specs))
+            model_update = {
+                'replication_status': rep_status,
+                'replication_driver_data': six.text_type(
+                    {'device_id': rep_info_dict['target_device_id'],
+                     'array': rep_info_dict['remote_array']})}
+
+        # Retype Volume
+        success, target_sg_name = self._retype_volume(
+            array, srp, device_id, volume, volume_name, extra_specs,
+            target_slo, target_workload, target_extra_specs)
+
+        # Volume is first volume in RDFG, SG needs to be protected
+        if rep_status == 'first_vol_in_rdf_group':
+            rep_status, rdf_pair_info, tgt_device_id = (
+                self._post_retype_srdf_protect_storage_group(
+                    array, target_sg_name, device_id, volume_name,
+                    rep_extra_specs))
+            model_update = {
+                'replication_status': rep_status,
+                'replication_driver_data': six.text_type(
+                    {'device_id': tgt_device_id,
+                     'array': rdf_pair_info['remoteSymmetrixId']})}
+
+        # Scenario: Rep -> Rep
+        if was_rep_enabled and is_rep_enabled:
+            success = self._retype_remote_volume(
+                array, volume, device_id, volume_name,
+                rep_mode, is_rep_enabled, target_extra_specs)
 
-            if move_target:
-                success = self._retype_remote_volume(
-                    array, volume, device_id, volume_name,
-                    rep_mode, is_rep_enabled, target_extra_specs)
+        if resume_rdf:
+            self.rest.srdf_resume_replication(
+                array, rep_extra_specs['mgmt_sg_name'],
+                rep_extra_specs['rdf_group_no'], rep_extra_specs)
 
         if success:
             model_update = self.update_metadata(
@@ -3246,124 +3569,145 @@ class PowerMaxCommon(object):
             self.volume_metadata.capture_retype_info(
                 volume, device_id, array, srp, target_slo,
                 target_workload, target_sg_name, is_rep_enabled, rep_mode,
-                is_compression_disabled)
+                target_extra_specs[utils.DISABLECOMPRESSION])
 
         return success, model_update
 
-    def _retype_volume(self, array, device_id, volume_name, target_sg_name,
-                       volume, extra_specs):
-        """Move the volume to the correct storagegroup.
+    def _retype_volume(
+            self, array, srp, device_id, volume, volume_name, extra_specs,
+            target_slo, target_workload, target_extra_specs, remote=False):
+        """Retype a volume from one volume type to another.
 
-        Add the volume to the target storage group, or to the correct default
-        storage group, and check if it is there.
-        :param array: the array serial
-        :param device_id: the device id
-        :param volume_name: the volume name
-        :param target_sg_name: the target sg name
+        The target storage group ID is returned so the next phase in the
+        calling function can SRDF protect it if required.
+
+        :param array: the array serial number
+        :param srp: the storage resource pool name
+        :param device_id: the device ID to be retyped
         :param volume: the volume object
-        :param extra_specs: the target extra specifications
-        :returns bool
+        :param volume_name: the volume name
+        :param extra_specs: source extra specs
+        :param target_slo: target service level id
+        :param target_workload: target workload id
+        :param target_extra_specs: target extra specs
+        :param remote: if the volume being retyped is on a remote replication
+                       target
+        :returns: retype success, target storage group -- bool, str
         """
-        storagegroups = self.rest.get_storage_groups_from_volume(
-            array, device_id)
-        if not storagegroups:
-            LOG.warning("Volume : %(volume_name)s does not currently "
-                        "belong to any storage groups.",
-                        {'volume_name': volume_name})
-            # Add the volume to the target storage group
-            self.masking.add_volume_to_storage_group(
-                array, device_id, target_sg_name, volume_name, extra_specs)
-            # Check if volume should be member of GVG
-            self.masking.return_volume_to_volume_group(
-                array, volume, device_id, volume_name, extra_specs)
-        else:
-            # Move the volume to the correct default storage group for
-            # its volume type
-            self.masking.remove_and_reset_members(
-                array, volume, device_id, volume_name,
-                extra_specs, reset=True)
 
-        # Check that it has been added.
-        vol_check = self.rest.is_volume_in_storagegroup(
-            array, device_id, target_sg_name)
-        if not vol_check:
-            LOG.error(
-                "Volume: %(volume_name)s has not been "
-                "added to target storage group %(storageGroup)s.",
-                {'volume_name': volume_name,
-                 'storageGroup': target_sg_name})
-            return False
-
-        return True
-
-    def _retype_inuse_volume(self, array, srp, volume, device_id, extra_specs,
-                             target_slo, target_workload, target_extra_specs,
-                             is_compression_disabled):
-        """Retype an in-use volume using storage assisted migration.
+        is_re, rep_mode, mgmt_sg_name = False, None, None
+        if self.utils.is_replication_enabled(target_extra_specs):
+            is_re, rep_mode = True, target_extra_specs['rep_mode']
+            mgmt_sg_name = self.utils.get_rdf_management_group_name(
+                self.rep_config)
 
-        :param array: the array serial
-        :param srp: the SRP ID
-        :param volume: the volume object
-        :param device_id: the device id
-        :param extra_specs: the source volume type extra specs
-        :param target_slo: the service level of the target volume type
-        :param target_workload: the workload of the target volume type
-        :param target_extra_specs: the target extra specs
-        :param is_compression_disabled: if compression is disabled in the
-        target volume type
-        :return: if the retype was successful -- bool,
-                 the storage group the volume has moved to --str
-        """
-        success = False
         device_info = self.rest.get_volume(array, device_id)
-        source_sg_name = device_info['storageGroupId'][0]
-        source_sg = self.rest.get_storage_group(array, source_sg_name)
-        target_extra_specs[utils.PORTGROUPNAME] = extra_specs[
-            utils.PORTGROUPNAME]
 
-        attached_host = self.utils.get_volume_attached_hostname(device_info)
-        if not attached_host:
-            LOG.error(
-                "There was an issue retrieving attached host from volume "
-                "%(volume_name)s, aborting storage-assisted migration.",
-                {'volume_name': device_id})
-            return False, None
+        target_extra_specs[utils.PORTGROUPNAME] = (
+            extra_specs.get(utils.PORTGROUPNAME, None))
+        disable_compression = target_extra_specs[utils.DISABLECOMPRESSION]
+        source_sg_list = device_info['storageGroupId']
+        if mgmt_sg_name in source_sg_list:
+            source_sg_list.remove(mgmt_sg_name)
+        source_sg_name = source_sg_list[0]
+
+        # If volume is attached set up the parent/child SGs if not already
+        # present on array
+        if volume.attach_status == 'attached' and not remote:
+            attached_host = self.utils.get_volume_attached_hostname(
+                volume)
+            if not attached_host:
+                LOG.error(
+                    "There was an issue retrieving attached host from volume "
+                    "%(volume_name)s, aborting storage-assisted migration.",
+                    {'volume_name': device_id})
+                return False, None
+
+            port_group_label = self.utils.get_port_name_label(
+                target_extra_specs[utils.PORTGROUPNAME],
+                self.powermax_port_group_name_template)
 
-        target_sg_name, __, __, __ = self.utils.get_child_sg_name(
-            attached_host, target_extra_specs)
-        target_sg = self.rest.get_storage_group(array, target_sg_name)
-
-        if not target_sg:
-            self.provision.create_storage_group(array, target_sg_name, srp,
-                                                target_slo,
-                                                target_workload,
-                                                target_extra_specs,
-                                                is_compression_disabled)
-            parent_sg = source_sg['parent_storage_group'][0]
-            self.masking.add_child_sg_to_parent_sg(
-                array, target_sg_name, parent_sg, target_extra_specs)
+            target_sg_name, __, __ = self.utils.get_child_sg_name(
+                attached_host, target_extra_specs, port_group_label)
             target_sg = self.rest.get_storage_group(array, target_sg_name)
 
-        target_in_parent = self.rest.is_child_sg_in_parent_sg(
-            array, target_sg_name, target_sg['parent_storage_group'][0])
+            if not target_sg:
+                self.provision.create_storage_group(
+                    array, target_sg_name, srp, target_slo, target_workload,
+                    target_extra_specs, disable_compression)
+                source_sg = self.rest.get_storage_group(array, source_sg_name)
+                parent_sg = source_sg.get('parent_storage_group', None)
+
+                if parent_sg:
+                    parent_sg = parent_sg[0]
+                    self.masking.add_child_sg_to_parent_sg(
+                        array, target_sg_name, parent_sg, target_extra_specs)
 
-        if target_sg and target_in_parent:
-            self.masking.move_volume_between_storage_groups(
-                array, device_id, source_sg_name, target_sg_name,
-                target_extra_specs)
-            success = self.rest.is_volume_in_storagegroup(
-                array, device_id, target_sg_name)
+        # Else volume is not attached or is remote volume, default SGs are used
+        else:
+            target_sg_name = (
+                self.masking.get_or_create_default_storage_group(
+                    array, srp, target_slo, target_workload, extra_specs,
+                    disable_compression, is_re, rep_mode))
+
+        # Move the volume from the source to target storage group
+        self.masking.move_volume_between_storage_groups(
+            array, device_id, source_sg_name, target_sg_name, extra_specs,
+            force=True)
 
+        # Check if volume should be member of GVG
+        self.masking.return_volume_to_volume_group(
+            array, volume, device_id, volume_name, extra_specs)
+
+        # Check the move was successful
+        success = self.rest.is_volume_in_storagegroup(
+            array, device_id, target_sg_name)
         if not success:
             LOG.error(
                 "Volume: %(volume_name)s has not been "
                 "added to target storage group %(storageGroup)s.",
                 {'volume_name': device_id,
                  'storageGroup': target_sg_name})
+            return False, None
         else:
             LOG.info("Move successful: %(success)s", {'success': success})
+            return success, target_sg_name
 
-        return success, target_sg_name
+    def _post_retype_srdf_protect_storage_group(
+            self, array, local_sg_name, device_id, volume_name,
+            rep_extra_specs):
+        """SRDF protect SG if first volume in SG after retype operation.
+
+        :param array: the array serial number
+        :param local_sg_name: the local storage group name
+        :param device_id: the local device ID
+        :param volume_name: the volume name
+        :param rep_extra_specs: replication info dictionary
+        :returns: replication enables status, device pair info,
+                  remote device id -- str, dict, str
+        """
+        rep_mode = rep_extra_specs['rep_mode']
+        remote_array = rep_extra_specs['array']
+        rdf_group_no = rep_extra_specs['rdf_group_no']
+        service_level = rep_extra_specs['slo']
+
+        remote_sg_name = self.utils.derive_default_sg_from_extra_specs(
+            rep_extra_specs, rep_mode)
+        self.rest.srdf_protect_storage_group(
+            array, remote_array, rdf_group_no, rep_mode, local_sg_name,
+            service_level, rep_extra_specs, target_sg=remote_sg_name)
+
+        pair_info = self.rest.get_rdf_pair_volume(
+            array, rdf_group_no, device_id)
+        r2_device_id = pair_info['remoteVolumeName']
+        self.rest.rename_volume(remote_array, r2_device_id, volume_name)
+
+        if rep_mode in [utils.REP_ASYNC, utils.REP_METRO]:
+            self._add_volume_to_rdf_management_group(
+                array, device_id, volume_name, remote_array,
+                r2_device_id, rep_extra_specs)
+
+        return REPLICATION_ENABLED, pair_info, r2_device_id
 
     def _retype_remote_volume(self, array, volume, device_id,
                               volume_name, rep_mode, is_re, extra_specs):
@@ -3379,19 +3723,23 @@ class PowerMaxCommon(object):
         :returns: bool
         """
         success = True
-        (target_device, remote_array, _, _, _) = (
-            self.get_remote_target_device(array, volume, device_id))
         rep_extra_specs = self._get_replication_extra_specs(
             extra_specs, self.rep_config)
+        target_device = self.rest.get_rdf_pair_volume(
+            array, rep_extra_specs['rdf_group_no'], device_id)
+        target_device_id = target_device['remoteVolumeName']
+        remote_array = rep_extra_specs['array']
         rep_compr_disabled = self.utils.is_compression_disabled(
             rep_extra_specs)
+
         remote_sg_name = self.masking.get_or_create_default_storage_group(
             remote_array, rep_extra_specs[utils.SRP],
             rep_extra_specs[utils.SLO], rep_extra_specs[utils.WORKLOAD],
             rep_extra_specs, rep_compr_disabled,
             is_re=is_re, rep_mode=rep_mode)
+
         found_storage_group_list = self.rest.get_storage_groups_from_volume(
-            remote_array, target_device)
+            remote_array, target_device_id)
         move_rqd = True
         for found_storage_group_name in found_storage_group_list:
             # Check if remote volume is already in the correct sg
@@ -3400,8 +3748,10 @@ class PowerMaxCommon(object):
                 break
         if move_rqd:
             success = self._retype_volume(
-                remote_array, target_device, volume_name, remote_sg_name,
-                volume, rep_extra_specs)
+                remote_array, rep_extra_specs[utils.SRP],
+                target_device_id, volume, volume_name, rep_extra_specs,
+                extra_specs[utils.SLO], extra_specs[utils.WORKLOAD],
+                extra_specs, remote=True)
         return success
 
     def _is_valid_for_storage_assisted_migration(
@@ -3501,139 +3851,85 @@ class PowerMaxCommon(object):
 
         return True, target_slo, target_workload
 
-    def setup_volume_replication(self, array, volume, device_id,
-                                 extra_specs, target_device_id=None):
-        """Setup replication for volume, if enabled.
-
-        Called on create volume, create cloned volume, create volume from
-        snapshot, manage_existing, and re-establishing a replication
-        relationship after extending.
-        :param array: the array serial number
-        :param volume: the volume object
-        :param device_id: the device id
-        :param extra_specs: the extra specifications
-        :param target_device_id: the target device id
-        :returns: replication_status -- str, replication_driver_data -- dict
-                  rep_info_dict -- dict
-        """
-        source_name = volume.name
-        LOG.debug('Starting replication setup '
-                  'for volume: %s.', source_name)
-        # Get rdf details
-        rdf_group_no, remote_array = self.get_rdf_details(array)
-        rdf_vol_size = volume.size
-        if rdf_vol_size == 0:
-            rdf_vol_size = self.rest.get_size_of_device_on_array(
-                array, device_id)
-
-        # Give the target volume the same Volume Element Name as the
-        # source volume
-        target_name = self.utils.get_volume_element_name(volume.id)
-
-        rep_extra_specs = self._get_replication_extra_specs(
-            extra_specs, self.rep_config)
-        if not target_device_id:
-            # Create a target volume on the target array
-            volume_dict = self._create_volume(
-                target_name, rdf_vol_size, rep_extra_specs)
-            target_device_id = volume_dict['device_id']
-
-        LOG.debug("Create volume replica: Target device: %(target)s "
-                  "Source Device: %(source)s "
-                  "Volume identifier: %(name)s.",
-                  {'target': target_device_id,
-                   'source': device_id,
-                   'name': target_name})
-
-        # Enable rdf replication and establish the link
-        rdf_dict = self.enable_rdf(
-            array, volume, device_id, rdf_group_no, self.rep_config,
-            target_name, remote_array, target_device_id, extra_specs)
-
-        if self.utils.does_vol_need_rdf_management_group(extra_specs):
-            self._add_volume_to_async_rdf_managed_grp(
-                array, device_id, source_name, remote_array,
-                target_device_id, extra_specs)
-
-        LOG.info('Successfully setup replication for %s.',
-                 target_name)
-        replication_status = REPLICATION_ENABLED
-        replication_driver_data = rdf_dict
-        rep_info_dict = self.volume_metadata.gather_replication_info(
-            volume.id, 'replication', False,
-            rdf_group_no=rdf_group_no,
-            target_name=target_name, remote_array=remote_array,
-            target_device_id=target_device_id,
-            replication_status=replication_status,
-            rep_mode=rep_extra_specs['rep_mode'],
-            rdf_group_label=self.rep_config['rdf_group_label'],
-            target_array_model=rep_extra_specs['target_array_model'])
-
-        return replication_status, replication_driver_data, rep_info_dict
-
-    def setup_inuse_volume_replication(self, array, volume, device_id,
-                                       extra_specs):
-        """Setup replication for in-use volume.
+    def configure_volume_replication(self, array, volume, device_id,
+                                     extra_specs):
+        """Configure volume replication for a source device.
 
         :param array: the array serial number
         :param volume: the volume object
         :param device_id: the device id
-        :param extra_specs: the extra specifications
-        :return: replication_status -- str, replication_driver_data -- dict
-                 rep_info_dict -- dict
-        """
-        source_name = volume.name
-        LOG.debug('Starting replication setup '
-                  'for volume: %s.', source_name)
+        :param extra_specs: volume extra specifications
+        :returns: replication status, device pair info, replication info,
+                  resume rdf -- str, dict, dict, bool
+        """
+        # Set session attributes
+        LOG.debug('Starting replication setup for volume %(vol)s',
+                  {'vol': volume.name})
+        resume_rdf, mgmt_sg_name = False, None
+        disable_compression = self.utils.is_compression_disabled(
+            extra_specs)
         rdf_group_no, remote_array = self.get_rdf_details(array)
-        extra_specs['replication_enabled'] = '<is> True'
-        extra_specs['rep_mode'] = self.rep_config['mode']
-
-        rdf_vol_size = volume.size
-        if rdf_vol_size == 0:
-            rdf_vol_size = self.rest.get_size_of_device_on_array(
-                array, device_id)
-
-        target_name = self.utils.get_volume_element_name(volume.id)
-
         rep_extra_specs = self._get_replication_extra_specs(
             extra_specs, self.rep_config)
-        volume_dict = self._create_volume(
-            target_name, rdf_vol_size, rep_extra_specs, in_use=True)
-        target_device_id = volume_dict['device_id']
-
-        LOG.debug("Create volume replica: Target device: %(target)s "
-                  "Source Device: %(source)s "
-                  "Volume identifier: %(name)s.",
-                  {'target': target_device_id,
-                   'source': device_id,
-                   'name': target_name})
-
-        self._sync_check(array, device_id, extra_specs, tgt_only=True)
-        rdf_dict = self.rest.create_rdf_device_pair(
-            array, device_id, rdf_group_no, target_device_id, remote_array,
-            extra_specs)
+        rep_mode = rep_extra_specs['rep_mode']
+        rep_extra_specs['mgmt_sg_name'] = None
+        group_details = self.rest.get_rdf_group(array, rdf_group_no)
+
+        if group_details['numDevices'] == 0:
+            rep_info = {
+                'remote_array': remote_array, 'rdf_group_no': rdf_group_no,
+                'rep_mode': rep_mode, 'slo': rep_extra_specs['slo'],
+                'extra_specs': rep_extra_specs, 'target_device_id': None}
+            return ('first_vol_in_rdf_group', None, rep_info,
+                    rep_extra_specs, False)
+
+        if group_details['numDevices'] > 0 and (
+                rep_mode in [utils.REP_ASYNC, utils.REP_METRO]):
+            mgmt_sg_name = self.utils.get_rdf_management_group_name(
+                self.rep_config)
+            self.rest.srdf_suspend_replication(
+                array, mgmt_sg_name, rdf_group_no, rep_extra_specs)
+            rep_extra_specs['mgmt_sg_name'] = mgmt_sg_name
+            resume_rdf = True
+
+        pair_info = self.rest.srdf_create_device_pair(
+            array, rdf_group_no, rep_mode, device_id, rep_extra_specs,
+            self.next_gen)
+
+        r2_device_id = pair_info['tgt_device']
+        device_uuid = self.utils.get_volume_element_name(volume.id)
+        self.rest.rename_volume(remote_array, r2_device_id, device_uuid)
+
+        tgt_sg_name = self.masking.get_or_create_default_storage_group(
+            remote_array, rep_extra_specs['srp'], rep_extra_specs['slo'],
+            rep_extra_specs['workload'], rep_extra_specs, disable_compression,
+            is_re=True, rep_mode=rep_mode)
+        self.rest.add_vol_to_sg(remote_array, tgt_sg_name, r2_device_id,
+                                rep_extra_specs, force=True)
+
+        if rep_mode in [utils.REP_ASYNC, utils.REP_METRO]:
+            self._add_volume_to_rdf_management_group(
+                array, device_id, device_uuid, remote_array, r2_device_id,
+                extra_specs)
 
-        LOG.info('Successfully setup replication for %s.',
-                 target_name)
-        replication_status = REPLICATION_ENABLED
-        replication_driver_data = rdf_dict
+        rep_status = REPLICATION_ENABLED
+        target_name = self.utils.get_volume_element_name(volume.id)
         rep_info_dict = self.volume_metadata.gather_replication_info(
             volume.id, 'replication', False,
-            rdf_group_no=rdf_group_no,
-            target_name=target_name, remote_array=remote_array,
-            target_device_id=target_device_id,
-            replication_status=replication_status,
-            rep_mode=rep_extra_specs['rep_mode'],
+            rdf_group_no=rdf_group_no, target_name=target_name,
+            remote_array=remote_array, target_device_id=r2_device_id,
+            replication_status=rep_status, rep_mode=rep_mode,
             rdf_group_label=self.rep_config['rdf_group_label'],
-            target_array_model=rep_extra_specs['target_array_model'])
+            target_array_model=rep_extra_specs['target_array_model'],
+            mgmt_sg_name=rep_extra_specs['mgmt_sg_name'])
 
-        return replication_status, replication_driver_data, rep_info_dict
+        return (rep_status, pair_info, rep_info_dict, rep_extra_specs,
+                resume_rdf)
 
-    def _add_volume_to_async_rdf_managed_grp(
+    def _add_volume_to_rdf_management_group(
             self, array, device_id, volume_name, remote_array,
             target_device_id, extra_specs):
-        """Add an async volume to its rdf management group.
+        """Add an volume to its rdf management group.
 
         :param array: the array serial number
         :param device_id: the device id
@@ -3643,7 +3939,7 @@ class PowerMaxCommon(object):
         :param extra_specs: the extra specifications
         :raises: VolumeBackendAPIException
         """
-        group_name = self.utils.get_async_rdf_managed_grp_name(
+        group_name = self.utils.get_rdf_management_group_name(
             self.rep_config)
         try:
             self.provision.get_or_create_group(array, group_name, extra_specs)
@@ -3665,72 +3961,86 @@ class PowerMaxCommon(object):
             raise exception.VolumeBackendAPIException(
                 message=exception_message)
 
-    def cleanup_lun_replication(self, volume, volume_name,
-                                device_id, extra_specs):
-        """Cleanup target volume on delete.
+    def break_rdf_device_pair_session(self, array, device_id, volume_name,
+                                      extra_specs):
+        """Delete RDF device pair deleting R2 volume but leaving R1 in place.
 
-        Extra logic if target is last in group, or is a metro volume.
-        :param volume: the volume object
-        :param volume_name: the volume name
+        :param array: the array serial number
         :param device_id: the device id
-        :param extra_specs: extra specifications
-        :raises: VolumeBackendAPIException
+        :param volume_name: the volume name
+        :param extra_specs: the volume extra specifications
+        :returns: replication extra specs, resume rdf -- dict, bool
         """
-        LOG.debug('Starting cleanup replication from volume: '
-                  '%s.', volume_name)
-        try:
-            loc = volume.provider_location
-            rep_data = volume.replication_driver_data
+        LOG.debug('Starting replication cleanup for RDF pair source device: '
+                  '%(d_id)s.', {'d_id': device_id})
 
-            if (isinstance(loc, six.string_types)
-                    and isinstance(rep_data, six.string_types)):
-                name = ast.literal_eval(loc)
-                try:
-                    array = name['array']
-                except KeyError:
-                    array = (name['keybindings']
-                             ['SystemName'].split('+')[1].strip('-'))
-                rep_extra_specs = self._get_replication_extra_specs(
-                    extra_specs, self.rep_config)
-                (target_device, remote_array, rdf_group_no,
-                 local_vol_state, pair_state) = (
-                    self.get_remote_target_device(array, volume, device_id))
-
-                if target_device is not None:
-                    # Clean-up target
-                    self._cleanup_remote_target(
-                        array, volume, remote_array, device_id, target_device,
-                        rdf_group_no, volume_name, rep_extra_specs)
-                    LOG.info('Successfully destroyed replication for '
-                             'volume: %(volume)s',
-                             {'volume': volume_name})
-                else:
-                    LOG.warning('Replication target not found for '
-                                'replication-enabled volume: %(volume)s',
-                                {'volume': volume_name})
-        except Exception as e:
-            if extra_specs.get(utils.REP_MODE, None) in [
-                    utils.REP_ASYNC, utils.REP_METRO]:
-                (target_device, remote_array, rdf_group_no,
-                 local_vol_state, pair_state) = (
-                    self.get_remote_target_device(
-                        extra_specs[utils.ARRAY], volume, device_id))
-                if target_device is not None:
-                    # Return devices to their async rdf management groups
-                    self._add_volume_to_async_rdf_managed_grp(
-                        extra_specs[utils.ARRAY], device_id, volume_name,
-                        remote_array, target_device, extra_specs)
-            exception_message = (
-                _('Cannot get necessary information to cleanup '
-                  'replication target for volume: %(volume)s. '
-                  'The exception received was: %(e)s. Manual '
-                  'clean-up may be required. Please contact '
-                  'your administrator.')
-                % {'volume': volume_name, 'e': six.text_type(e)})
-            LOG.error(exception_message)
-            raise exception.VolumeBackendAPIException(
-                message=exception_message)
+        # Set session attributes
+        resume_rdf, mgmt_sg_name = True, None
+        rep_extra_specs = self._get_replication_extra_specs(
+            extra_specs, self.rep_config)
+        extra_specs['force_vol_remove'] = True
+        rep_extra_specs['force_vol_remove'] = True
+        remote_array = rep_extra_specs['array']
+        rdfg_no = rep_extra_specs['rdf_group_no']
+        remote_device = self.rest.get_rdf_pair_volume(
+            array, rdfg_no, device_id)
+        remote_device_id = remote_device['remoteVolumeName']
+
+        # Get the names of the SGs associated with the volume on the R2 array
+        # before any operations are carried out - this will be used later for
+        # remove vol operations
+        r1_sg_names = self.rest.get_storage_groups_from_volume(
+            remote_array, remote_device_id)
+        r2_sg_names = self.rest.get_storage_groups_from_volume(
+            remote_array, remote_device_id)
+
+        if rep_extra_specs['rep_mode'] in [utils.REP_ASYNC, utils.REP_METRO]:
+            mgmt_sg_name = self.utils.get_rdf_management_group_name(
+                self.rep_config)
+            sg_name = mgmt_sg_name
+        else:
+            sg_name = r1_sg_names[0]
 
+        rep_extra_specs['mgmt_sg_name'] = sg_name
+
+        rdf_group_state = self.rest.get_storage_group_rdf_group_state(
+            array, sg_name, rdfg_no)
+        # We need to wait for RDFG to be in correct state before suspending
+        if len(rdf_group_state) > 1 or (
+                rdf_group_state[0] not in utils.RDF_SYNCED_STATES):
+            self.rest.wait_for_rdf_group_sync(
+                array, sg_name, rdfg_no, rep_extra_specs)
+
+        self.rest.srdf_suspend_replication(
+            array, sg_name, rdfg_no, rep_extra_specs)
+        self.rest.srdf_delete_device_pair(array, rdfg_no, device_id)
+
+        # Remove the volume from the R1 RDFG mgmt SG (R1)
+        if rep_extra_specs['rep_mode'] in [utils.REP_ASYNC, utils.REP_METRO]:
+            self.masking.remove_volume_from_sg(
+                array, device_id, volume_name, mgmt_sg_name, extra_specs)
+
+        # Remove volume from R2 replication SGs
+        for sg_name in r2_sg_names:
+            self.masking.remove_volume_from_sg(
+                remote_array, remote_device_id, volume_name, sg_name,
+                rep_extra_specs)
+
+        if mgmt_sg_name:
+            if not self.rest.get_volumes_in_storage_group(
+                    array, mgmt_sg_name):
+                resume_rdf = False
+        else:
+            if not self.rest.get_volumes_in_storage_group(array, sg_name):
+                resume_rdf = False
+
+        # self.rest.delete_volume(remote_array, remote_device_id)
+        self._delete_from_srp(remote_array, remote_device_id, volume_name,
+                              extra_specs)
+
+        return rep_extra_specs, resume_rdf
+
+    @coordination.synchronized('emc-{rdf_group}-rdf')
     def _cleanup_remote_target(
             self, array, volume, remote_array, device_id, target_device,
             rdf_group, volume_name, rep_extra_specs):
@@ -3745,66 +4055,36 @@ class PowerMaxCommon(object):
         :param volume_name: the volume name
         :param rep_extra_specs: replication extra specifications
         """
-        self.masking.remove_and_reset_members(
-            remote_array, volume, target_device, volume_name,
-            rep_extra_specs, False)
-        are_vols_paired, local_vol_state, pair_state = (
+        are_vols_paired, __, pair_state = (
             self.rest.are_vols_rdf_paired(
                 array, remote_array, device_id, target_device))
         if are_vols_paired:
-            is_metro = self.utils.is_metro_device(
-                self.rep_config, rep_extra_specs)
-            if is_metro:
-                rep_extra_specs['allow_del_metro'] = self.allow_delete_metro
-                self._cleanup_metro_target(
-                    array, device_id, target_device,
-                    rdf_group, rep_extra_specs)
-            else:
-                # Break the sync relationship.
-                self.provision.break_rdf_relationship(
-                    array, device_id, target_device, rdf_group,
-                    rep_extra_specs, pair_state)
-        self._delete_from_srp(
-            remote_array, target_device, volume_name, rep_extra_specs)
+            async_grp = None
+            rep_mode = rep_extra_specs['rep_mode']
+            if rep_mode in [utils.REP_ASYNC, utils.REP_METRO]:
+                async_grp = self.utils.get_rdf_management_group_name(
+                    self.rep_config)
 
-    @coordination.synchronized('emc-rg-{rdf_group}')
-    def _cleanup_metro_target(self, array, device_id, target_device,
-                              rdf_group, rep_extra_specs):
-        """Helper function to cleanup a metro remote target.
+            sg_name = self.rest.get_storage_groups_from_volume(
+                array, device_id)
+            self.provision.break_rdf_relationship(
+                array, device_id, sg_name, rdf_group,
+                rep_extra_specs, pair_state)
+            self.masking.remove_and_reset_members(
+                remote_array, volume, target_device, volume_name,
+                rep_extra_specs, sg_name)
+            if async_grp:
+                self.masking.remove_and_reset_members(
+                    remote_array, volume, target_device, volume_name,
+                    rep_extra_specs, async_grp)
+
+            rdfg_details = self.rest.get_rdf_group(array, rdf_group)
+            if rdfg_details and int(rdfg_details.get('numDevices', 0)):
+                self.rest.srdf_resume_replication(
+                    array, sg_name, rdf_group, rep_extra_specs)
 
-        :param array: the array serial number
-        :param device_id: the device id
-        :param target_device: the target device id
-        :param rdf_group: the rdf group number
-        :param rep_extra_specs: the rep extra specs
-        """
-        if rep_extra_specs['allow_del_metro']:
-            metro_grp = self.utils.get_async_rdf_managed_grp_name(
-                self.rep_config)
-            self.provision.break_metro_rdf_pair(
-                array, device_id, target_device, rdf_group,
-                rep_extra_specs, metro_grp)
-            # Remove the volume from the metro_grp
-            rep_extra_specs['force_vol_remove'] = True
-            self.masking.remove_volume_from_sg(array, device_id, 'metro_vol',
-                                               metro_grp, rep_extra_specs)
-            # Resume I/O on the RDF links for any remaining volumes
-            if self.rest.get_num_vols_in_sg(array, metro_grp) > 0:
-                LOG.info("Resuming I/O for all volumes in the RDF group: "
-                         "%(rdfg)s", {'rdfg': device_id})
-                self.provision.enable_group_replication(
-                    array, metro_grp, rdf_group,
-                    rep_extra_specs, establish=True)
-        else:
-            exception_message = (
-                _("Deleting a Metro-protected replicated volume is "
-                  "not permitted on this backend %(backend)s. "
-                  "Please contact your administrator.")
-                % {'backend': self.configuration.safe_get(
-                    'volume_backend_name')})
-            LOG.error(exception_message)
-            raise exception.VolumeBackendAPIException(
-                message=exception_message)
+        self._delete_from_srp(
+            remote_array, target_device, volume_name, rep_extra_specs)
 
     def _cleanup_replication_source(
             self, array, volume, volume_name, volume_dict, extra_specs):
@@ -3962,7 +4242,7 @@ class PowerMaxCommon(object):
                 non_rep_vol_list.append(volume)
 
         if len(async_vol_list) > 0:
-            vol_grp_name = self.utils.get_async_rdf_managed_grp_name(
+            vol_grp_name = self.utils.get_rdf_management_group_name(
                 self.rep_config)
             __, vol_updates = (
                 self._failover_replication(
@@ -4019,131 +4299,6 @@ class PowerMaxCommon(object):
         self.rest.delete_storage_group(array, temp_grp_name)
         return volume_update_list
 
-    def get_remote_target_device(self, array, volume, device_id):
-        """Get the remote target for a given volume.
-
-        :param array: the array serial number
-        :param volume: the volume object
-        :param device_id: the device id
-        :returns: target_device, target_array, rdf_group, state
-        """
-        target_device, local_vol_state, pair_state = None, '', ''
-        rdf_group, remote_array = self.get_rdf_details(array)
-        try:
-            rep_target_data = volume.replication_driver_data
-            replication_keybindings = ast.literal_eval(rep_target_data)
-            remote_array = replication_keybindings['array']
-            remote_device = replication_keybindings['device_id']
-            target_device_info = self.rest.get_volume(
-                remote_array, remote_device)
-            if target_device_info is not None:
-                target_device = remote_device
-                are_vols_paired, local_vol_state, pair_state = (
-                    self.rest.are_vols_rdf_paired(
-                        array, remote_array, device_id, target_device))
-                if not are_vols_paired:
-                    target_device = None
-        except (KeyError, ValueError):
-            target_device = None
-        return (target_device, remote_array, rdf_group,
-                local_vol_state, pair_state)
-
-    def enable_rdf(self, array, volume, device_id, rdf_group_no, rep_config,
-                   target_name, remote_array, target_device, extra_specs):
-        """Create a replication relationship with a target volume.
-
-        :param array: the array serial number
-        :param volume: the volume object
-        :param device_id: the device id
-        :param rdf_group_no: the rdf group number
-        :param rep_config: the replication config
-        :param target_name: the target volume name
-        :param remote_array: the remote array serial number
-        :param target_device: the target device id
-        :param extra_specs: the extra specifications
-        :returns: rdf_dict
-        """
-        rep_extra_specs = self._get_replication_extra_specs(
-            extra_specs, rep_config)
-        try:
-            # Remove source and target instances from their
-            # default storage groups
-            self.masking.remove_and_reset_members(
-                array, volume, device_id, target_name, extra_specs, False)
-
-            self.masking.remove_and_reset_members(
-                remote_array, volume, target_device, target_name,
-                rep_extra_specs, False)
-
-            # Check if volume is a copy session target
-            self._sync_check(array, device_id, extra_specs, tgt_only=True)
-            # Establish replication relationship
-            rdf_dict = self.rest.create_rdf_device_pair(
-                array, device_id, rdf_group_no, target_device, remote_array,
-                extra_specs)
-
-            # Add source and target instances to their replication groups
-            LOG.debug("Adding source device to default replication group.")
-            self.add_volume_to_replication_group(
-                array, device_id, target_name, extra_specs)
-            LOG.debug("Adding target device to default replication group.")
-            self.add_volume_to_replication_group(
-                remote_array, target_device, target_name, rep_extra_specs)
-
-        except Exception as e:
-            LOG.warning(
-                ("Remote replication failed. Cleaning up the target "
-                 "volume and returning source volume to default storage "
-                 "group. Volume name: %(name)s "),
-                {'name': target_name})
-            self._cleanup_remote_target(
-                array, volume, remote_array, device_id, target_device,
-                rdf_group_no, target_name, rep_extra_specs)
-            # Re-throw the exception.
-            exception_message = (_("Remote replication failed with exception:"
-                                   " %(e)s")
-                                 % {'e': six.text_type(e)})
-            LOG.error(exception_message)
-            raise exception.VolumeBackendAPIException(
-                message=exception_message)
-
-        return rdf_dict
-
-    def add_volume_to_replication_group(
-            self, array, device_id, volume_name, extra_specs):
-        """Add a volume to the default replication group.
-
-        Replication groups are PowerMax/VMAX storage groups that contain only
-        RDF-paired volumes. We can use our normal storage group operations.
-        :param array: array serial number
-        :param device_id: the device id
-        :param volume_name: the volume name
-        :param extra_specs: the extra specifications
-        :returns: storagegroup_name
-        """
-        do_disable_compression = self.utils.is_compression_disabled(
-            extra_specs)
-        rep_mode = extra_specs.get(utils.REP_MODE, None)
-        try:
-            storagegroup_name = (
-                self.masking.get_or_create_default_storage_group(
-                    array, extra_specs[utils.SRP], extra_specs[utils.SLO],
-                    extra_specs[utils.WORKLOAD], extra_specs,
-                    do_disable_compression, is_re=True, rep_mode=rep_mode))
-        except Exception as e:
-            exception_message = (_("Failed to get or create replication "
-                                   "group. Exception received: %(e)s")
-                                 % {'e': six.text_type(e)})
-            LOG.error(exception_message)
-            raise exception.VolumeBackendAPIException(
-                message=exception_message)
-
-        self.masking.add_volume_to_storage_group(
-            array, device_id, storagegroup_name, volume_name, extra_specs,
-            force=True)
-
-        return storagegroup_name
-
     def _get_replication_extra_specs(self, extra_specs, rep_config):
         """Get replication extra specifications.
 
@@ -4161,6 +4316,20 @@ class PowerMaxCommon(object):
         rep_extra_specs[utils.SRP] = rep_config['srp']
         rep_extra_specs[utils.PORTGROUPNAME] = rep_config['portgroup']
 
+        # Get the RDF Group label & number
+        rep_extra_specs['rdf_group_label'] = rep_config['rdf_group_label']
+        rdf_group_no, __ = self.get_rdf_details(extra_specs['array'])
+        rep_extra_specs['rdf_group_no'] = rdf_group_no
+        # Get the SRDF wait/retries settings
+        rep_extra_specs['sync_retries'] = rep_config['sync_retries']
+        rep_extra_specs['sync_interval'] = rep_config['sync_interval']
+
+        if rep_config['mode'] == utils.REP_METRO:
+            exempt = True if self.next_gen else False
+            rep_extra_specs[utils.RDF_CONS_EXEMPT] = exempt
+            bias = True if rep_config[utils.METROBIAS] else False
+            rep_extra_specs[utils.METROBIAS] = bias
+
         # If disable compression is set, check if target array is all flash
         do_disable_compression = self.utils.is_compression_disabled(
             extra_specs)
@@ -4401,9 +4570,17 @@ class PowerMaxCommon(object):
         """
         rdf_group_no, remote_array = self.get_rdf_details(array)
         # Delete replication for group, if applicable
+        group_details = self.rest.get_storage_group_rep(
+            array, vol_grp_name)
+        if group_details and group_details.get('rdf', False):
+            if extra_specs['rep_mode'] in [utils.REP_ASYNC, utils.REP_METRO]:
+                self.rest.srdf_suspend_replication(
+                    array, vol_grp_name, rdf_group_no, extra_specs)
         if volume_device_ids:
-            self.provision.delete_group_replication(
-                array, vol_grp_name, rdf_group_no, extra_specs)
+            LOG.debug("Deleting remote replication for group %(sg)s", {
+                'sg': vol_grp_name})
+            self.rest.delete_storagegroup_rdf(array, vol_grp_name,
+                                              rdf_group_no)
         remote_device_ids = self._get_members_of_volume_group(
             remote_array, vol_grp_name)
         # Remove volumes from remote replication group
@@ -4458,16 +4635,17 @@ class PowerMaxCommon(object):
             src_dev_id = self._get_src_device_id_for_group_snap(snapshot)
             extra_specs = self._initial_setup(snapshot.volume)
             array = extra_specs['array']
+            snapshot_model_dict = {
+                'id': snapshot.id,
+                'provider_location': six.text_type(
+                    {'source_id': src_dev_id, 'snap_name': snap_name}),
+                'status': fields.SnapshotStatus.AVAILABLE}
 
-            snapshots_model_update.append(
-                {'id': snapshot.id,
-                 'provider_location': six.text_type(
-                     {'source_id': src_dev_id, 'snap_name': snap_name}),
-                 'status': fields.SnapshotStatus.AVAILABLE})
-            snapshots_model_update = self.update_metadata(
-                snapshots_model_update, snapshot.metadata,
+            snapshot_model_dict = self.update_metadata(
+                snapshot_model_dict, snapshot.metadata,
                 self.get_snapshot_metadata(
                     array, src_dev_id, snap_name))
+            snapshots_model_update.append(snapshot_model_dict)
         model_update = {'status': fields.GroupStatus.AVAILABLE}
 
         return model_update, snapshots_model_update
@@ -4476,7 +4654,7 @@ class PowerMaxCommon(object):
         """Get the source device id for the provider_location.
 
         :param snapshot: the snapshot object
-        :return: src_device_id
+        :returns: src_device_id
         """
         volume = snapshot.volume
         extra_specs = self._initial_setup(volume)
@@ -4555,16 +4733,10 @@ class PowerMaxCommon(object):
                     {'group_id': source_group.id})
                 raise exception.VolumeBackendAPIException(
                     message=exception_message)
-            # Check if the snapshot exists
-            if 'snapVXSnapshots' in volume_group:
-                if snap_name in volume_group['snapVXSnapshots']:
-                    src_devs = self._get_snap_src_dev_list(array, snapshots)
-                    self.provision.delete_group_replica(
-                        array, snap_name, vol_grp_name, src_devs, extra_specs)
-            else:
-                # Snapshot has been already deleted, return successfully
-                LOG.error("Cannot find group snapshot %(snapId)s.",
-                          {'snapId': group_snapshot.id})
+
+            self.provision.delete_group_replica(
+                array, snap_name, vol_grp_name)
+
             model_update = {'status': fields.GroupSnapshotStatus.DELETED}
             for snapshot in snapshots:
                 snapshots_model_update.append(
@@ -4583,7 +4755,7 @@ class PowerMaxCommon(object):
 
         :param array: the array serial number
         :param snapshots: the list of snapshot objects
-        :return: src_dev_ids
+        :returns: src_dev_ids
         """
         src_dev_ids = []
         for snap in snapshots:
@@ -4886,7 +5058,7 @@ class PowerMaxCommon(object):
         src_dev_id, extra_specs, vol_size, tgt_vol_name = (
             self._get_clone_vol_info(
                 volume, source_vols, snapshots))
-        volume_dict = self._create_volume(
+        volume_dict, __, __ = self._create_volume(
             tgt_vol_name, vol_size, extra_specs)
         device_id = volume_dict['device_id']
         # Add the volume to the volume group SG
@@ -4945,12 +5117,9 @@ class PowerMaxCommon(object):
             # Delete the snapshot if required
             if rollback_dict.get("snap_name"):
                 try:
-                    src_dev_ids = [
-                        a for a, b in rollback_dict['list_volume_pairs']]
                     self.provision.delete_group_replica(
                         array, rollback_dict["snap_name"],
-                        rollback_dict["source_group_name"],
-                        src_dev_ids, rollback_dict['interval_retries_dict'])
+                        rollback_dict["source_group_name"])
                 except Exception as e:
                     LOG.debug("Failed to delete group snapshot. Attempting "
                               "further rollback. Exception received: %(e)s.",
@@ -4985,7 +5154,7 @@ class PowerMaxCommon(object):
         :param volumes_model_update: the volumes model updates
         :param group_name: the group name
         :param extra_specs: the extra specs
-        :return: volumes_model_update
+        :returns: volumes_model_update
         """
         ret_volumes_model_update = []
         rdf_group_no, remote_array = self.get_rdf_details(array)
@@ -5044,7 +5213,7 @@ class PowerMaxCommon(object):
                 raise exception.GroupNotFound(group_id=group.id)
 
             rdf_group_no, _ = self.get_rdf_details(array)
-            self.provision.enable_group_replication(
+            self.rest.srdf_resume_replication(
                 array, vol_grp_name, rdf_group_no, extra_specs)
             model_update.update({
                 'replication_status': fields.ReplicationStatus.ENABLED})
@@ -5085,7 +5254,7 @@ class PowerMaxCommon(object):
                 raise exception.GroupNotFound(group_id=group.id)
 
             rdf_group_no, _ = self.get_rdf_details(array)
-            self.provision.disable_group_replication(
+            self.rest.srdf_suspend_replication(
                 array, vol_grp_name, rdf_group_no, extra_specs)
             model_update.update({
                 'replication_status': fields.ReplicationStatus.DISABLED})
@@ -5125,8 +5294,8 @@ class PowerMaxCommon(object):
         :param host: flag to indicate if whole host is being failed over
         :returns: model_update, vol_model_updates
         """
-        model_update = {}
-        vol_model_updates = []
+        model_update, vol_model_updates = dict(), list()
+        rdf_group_no, extra_specs, failover = None, dict(), False
         if not volumes:
             # Return if empty group
             return model_update, vol_model_updates
@@ -5148,8 +5317,13 @@ class PowerMaxCommon(object):
             failover = False if secondary_backend_id == 'default' else True
             if not is_metro:
                 rdf_group_no, _ = self.get_rdf_details(array)
-                self.provision.failover_group(
-                    array, vol_grp_name, rdf_group_no, extra_specs, failover)
+                if failover:
+                    self.rest.srdf_failover_group(
+                        array, vol_grp_name, rdf_group_no, extra_specs)
+                else:
+                    self.rest.srdf_failback_group(
+                        array, vol_grp_name, rdf_group_no, extra_specs)
+
             if failover:
                 model_update.update({
                     'replication_status':
@@ -5341,28 +5515,46 @@ class PowerMaxCommon(object):
                 message=exception_message)
 
     def update_metadata(
-            self, model_update, existing_metadata, object_metadata):
+            self, model_update, existing_metadata, new_metadata):
         """Update volume metadata in model_update.
 
         :param model_update: existing model
         :param existing_metadata: existing metadata
-        :param object_metadata: object metadata
+        :param new_metadata: new object metadata
         :returns: dict -- updated model
         """
+        if new_metadata:
+            self._is_dict(new_metadata, 'new object metadata')
         if model_update:
+            self._is_dict(model_update, 'existing model')
             if 'metadata' in model_update:
-                model_update['metadata'].update(object_metadata)
+                model_update['metadata'].update(new_metadata)
             else:
-                model_update.update({'metadata': object_metadata})
+                model_update.update({'metadata': new_metadata})
         else:
             model_update = {}
-            model_update.update({'metadata': object_metadata})
+            model_update.update({'metadata': new_metadata})
 
         if existing_metadata:
+            self._is_dict(existing_metadata, 'existing metadata')
             model_update['metadata'].update(existing_metadata)
 
         return model_update
 
+    def _is_dict(self, input, description):
+        """Check that the input is a dict
+
+        :param input: object for checking
+        :raises: VolumeBackendAPIException
+        """
+        if not isinstance(input, dict):
+            exception_message = (_(
+                "Input %(desc)s is not a dict.") % {'desc': description})
+
+            LOG.error(exception_message)
+            raise exception.VolumeBackendAPIException(
+                message=exception_message)
+
     def get_volume_metadata(self, array, device_id):
         """Get volume metadata for model_update.
 
@@ -5428,3 +5620,147 @@ class PowerMaxCommon(object):
                     'SourceDeviceLabel': device_label}
 
         return metadata
+
+    def _check_and_add_tags_to_storage_array(
+            self, serial_number, array_tag_list, extra_specs):
+        """Add tags to a storage group.
+
+        :param serial_number: the array serial number
+        :param array_tag_list: the array tag list
+        :param extra_specs: the extra specifications
+        """
+        if array_tag_list:
+            existing_array_tags = self.rest.get_array_tags(serial_number)
+
+            new_tag_list = self.utils.get_new_tags(
+                self.utils.convert_list_to_string(array_tag_list),
+                self.utils.convert_list_to_string(existing_array_tags))
+            if not new_tag_list:
+                LOG.warning("No new tags to add. Existing tags "
+                            "associated with %(array)s are "
+                            "%(tags)s.",
+                            {'array': serial_number,
+                             'tags': existing_array_tags})
+            else:
+                self._validate_array_tag_list(new_tag_list)
+                LOG.info("Adding the tags %(tag_list)s to %(array)s",
+                         {'tag_list': new_tag_list,
+                          'array': serial_number})
+                try:
+                    self.rest.add_storage_array_tags(
+                        serial_number, new_tag_list, extra_specs)
+                except Exception as ex:
+                    LOG.warning("Unexpected error: %(ex)s. If you still "
+                                "want to add tags to this storage array, "
+                                "please do so on the Unisphere UI.",
+                                {'ex': ex})
+
+    def prepare_replication_details(self, extra_specs):
+        """Prepare details required for initialising replication.
+
+        :param extra_specs: extra sepcifications
+        :returns: first volume in SG, replication extra specs, replication info
+                  dict -- bool, dict, dict
+        """
+        rep_info_dict, rep_first_vol = dict(), True
+
+        # Get volume type replication extra specs
+        rep_extra_specs = self._get_replication_extra_specs(
+            extra_specs, self.rep_config)
+
+        # Get the target SG name for the current volume create op
+        sg_name = self.utils.derive_default_sg_from_extra_specs(
+            extra_specs, rep_mode=extra_specs['rep_mode'])
+        rep_extra_specs['sg_name'] = sg_name
+
+        # Check if there are any volumes in the SG, will return 0 if the SG
+        # does not exist
+        if self.rest.get_num_vols_in_sg(extra_specs['array'], sg_name):
+            # Volumes exist, not first volume in SG
+            rep_first_vol = False
+
+            # Get the list of the current devices in the SG, this will help
+            # with determining the new device added because no device ID is
+            # returned
+            local_device_list = self.rest.get_volume_list(
+                extra_specs['array'],
+                {'storageGroupId': sg_name,
+                 'rdf_group_number': rep_extra_specs['rdf_group_no']})
+
+            # Set replication info that we will need for creating volume in
+            # existing SG, these are not required for new SGs as the only
+            # additional step required is to SRDF protect the SG
+            rep_info_dict.update({
+                'local_array': extra_specs['array'],
+                'remote_array': rep_extra_specs['array'],
+                'rdf_group_no': rep_extra_specs['rdf_group_no'],
+                'rep_mode': extra_specs['rep_mode'],
+                'sg_name': sg_name,
+                'service_level': extra_specs['slo'],
+                'initial_device_list': local_device_list,
+                'sync_interval': rep_extra_specs['sync_interval'],
+                'sync_retries': rep_extra_specs['sync_retries']})
+
+        return rep_first_vol, rep_extra_specs, rep_info_dict
+
+    def srdf_protect_storage_group(self, extra_specs, rep_extra_specs,
+                                   volume_dict):
+        """SRDF protect a storage group.
+
+        :param extra_specs: source extra specs
+        :param rep_extra_specs: replication extra specs
+        :param volume_dict: volume details dict
+        """
+        self.rest.srdf_protect_storage_group(
+            extra_specs['array'], rep_extra_specs['array'],
+            rep_extra_specs['rdf_group_no'], extra_specs['rep_mode'],
+            volume_dict['storage_group'], rep_extra_specs['slo'], extra_specs)
+
+    def get_and_set_remote_device_uuid(
+            self, extra_specs, rep_extra_specs, volume_dict):
+        """Get a remote device id and set device UUID.
+
+        :param extra_specs: source extra specs
+        :param rep_extra_specs: replication extra specs
+        :param volume_dict: volume details dict
+        :returns: remote device ID -- str
+        """
+
+        rdf_pair = self.rest.get_rdf_pair_volume(
+            extra_specs['array'], rep_extra_specs['rdf_group_no'],
+            volume_dict['device_id'])
+
+        self.rest.rename_volume(rep_extra_specs['array'],
+                                rdf_pair['remoteVolumeName'],
+                                volume_dict['device_uuid'])
+
+        return rdf_pair['remoteVolumeName']
+
+    def gather_replication_updates(self, extra_specs, rep_extra_specs,
+                                   volume_dict):
+        """Gather replication updates for returns.
+
+        :param extra_specs: extra specs
+        :param rep_extra_specs: replication extra specs
+        :param volume_dict: volume info dict
+        :returns: replication status, replication info -- str, dict
+        """
+        replication_update = (
+            {'replication_status': REPLICATION_ENABLED,
+             'replication_driver_data': six.text_type(
+                 {'array': rep_extra_specs['array'],
+                  'device_id': volume_dict['remote_device_id']})})
+
+        rep_info_dict = self.volume_metadata.gather_replication_info(
+            volume_dict['device_uuid'], 'replication', False,
+            local_array=extra_specs['array'],
+            remote_array=rep_extra_specs['array'],
+            target_device_id=volume_dict['remote_device_id'],
+            target_name=volume_dict['device_uuid'],
+            rdf_group_no=rep_extra_specs['rdf_group_no'],
+            rep_mode=extra_specs['rep_mode'],
+            replication_status=REPLICATION_ENABLED,
+            rdf_group_label=self.rep_config['rdf_group_label'],
+            target_array_model=rep_extra_specs['target_array_model'])
+
+        return replication_update, rep_info_dict
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/powermax/fc.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/powermax/fc.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/powermax/fc.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/powermax/fc.py	2020-03-24 18:46:31.000000000 +0000
@@ -116,10 +116,13 @@ class PowerMaxFCDriver(san.SanDriver, dr
               - SnapVX noCopy mode enabled for all links
               - Volume/Snapshot backed metadata inclusion
               - Debug metadata compression and service level info fix
-        4.1.1 - QoS calulation fix
+        4.2.0 - Support of Unisphere storage group and array tags
+              - User defined override for short host name and port group name
+                (bp powermax-user-defined-hostname-portgroup)
+              - Switch to Unisphere REST API public replication endpoints
     """
 
-    VERSION = "4.1.1"
+    VERSION = "4.2.0"
 
     # ThirdPartySystems wiki
     CI_WIKI_NAME = "EMC_VMAX_CI"
@@ -332,7 +335,8 @@ class PowerMaxFCDriver(san.SanDriver, dr
         """
         loc = volume.provider_location
         name = ast.literal_eval(loc)
-        host = self.common.utils.get_host_short_name(connector['host'])
+        host_label = self.common.utils.get_host_name_label(
+            connector['host'], self.common.powermax_short_host_name_template)
         zoning_mappings = {}
         try:
             array = name['array']
@@ -345,7 +349,14 @@ class PowerMaxFCDriver(san.SanDriver, dr
 
         masking_views, is_metro = (
             self.common.get_masking_views_from_volume(
-                array, volume, device_id, host))
+                array, volume, device_id, host_label))
+        if not masking_views:
+            # Backward compatibility with pre Ussuri short host name.
+            host_label = self.common.utils.get_host_short_name(
+                connector['host'])
+            masking_views, is_metro = (
+                self.common.get_masking_views_from_volume(
+                    array, volume, device_id, host_label))
         if masking_views:
             portgroup = (
                 self.common.get_port_group_from_masking_view(
@@ -379,7 +390,7 @@ class PowerMaxFCDriver(san.SanDriver, dr
             else:
                 masking_views, __ = (
                     self.common.get_masking_views_from_volume(
-                        metro_array, volume, metro_device_id, host))
+                        metro_array, volume, metro_device_id, host_label))
                 if masking_views:
                     metro_portgroup = (
                         self.common.get_port_group_from_masking_view(
@@ -561,7 +572,7 @@ class PowerMaxFCDriver(san.SanDriver, dr
         :param offset: Number of volumes to skip after marker.
         :param sort_keys: Results sort key. Valid keys: size, reference.
         :param sort_dirs: Results sort direction. Valid dirs: asc, desc.
-        :return: List of dicts containing all manageable volumes.
+        :returns: List of dicts containing all manageable volumes.
         """
         return self.common.get_manageable_volumes(marker, limit, offset,
                                                   sort_keys, sort_dirs)
@@ -578,7 +589,7 @@ class PowerMaxFCDriver(san.SanDriver, dr
         :param offset: Number of snapshots to skip after marker.
         :param sort_keys: Results sort key. Valid keys: size, reference.
         :param sort_dirs: Results sort direction. Valid dirs: asc, desc.
-        :return: List of dicts containing all manageable snapshots.
+        :returns: List of dicts containing all manageable snapshots.
         """
         return self.common.get_manageable_snapshots(marker, limit, offset,
                                                     sort_keys, sort_dirs)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/powermax/iscsi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/powermax/iscsi.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/powermax/iscsi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/powermax/iscsi.py	2020-03-24 18:46:31.000000000 +0000
@@ -121,10 +121,13 @@ class PowerMaxISCSIDriver(san.SanISCSIDr
               - SnapVX noCopy mode enabled for all links
               - Volume/Snapshot backed metadata inclusion
               - Debug metadata compression and service level info fix
-        4.1.1 - QoS calulation fix
+        4.2.0 - Support of Unisphere storage group and array tags
+              - User defined override for short host name and port group name
+                (bp powermax-user-defined-hostname-portgroup)
+              - Switch to Unisphere REST API public replication endpoints
     """
 
-    VERSION = "4.1.1"
+    VERSION = "4.2.0"
 
     # ThirdPartySystems wiki
     CI_WIKI_NAME = "EMC_VMAX_CI"
@@ -481,7 +484,7 @@ class PowerMaxISCSIDriver(san.SanISCSIDr
         :param offset: Number of volumes to skip after marker.
         :param sort_keys: Results sort key. Valid keys: size, reference.
         :param sort_dirs: Results sort direction. Valid dirs: asc, desc.
-        :return: List of dicts containing all manageable volumes.
+        :returns: List of dicts containing all manageable volumes.
         """
         return self.common.get_manageable_volumes(marker, limit, offset,
                                                   sort_keys, sort_dirs)
@@ -498,7 +501,7 @@ class PowerMaxISCSIDriver(san.SanISCSIDr
         :param offset: Number of snapshots to skip after marker.
         :param sort_keys: Results sort key. Valid keys: size, reference.
         :param sort_dirs: Results sort direction. Valid dirs: asc, desc.
-        :return: List of dicts containing all manageable snapshots.
+        :returns: List of dicts containing all manageable snapshots.
         """
         return self.common.get_manageable_snapshots(marker, limit, offset,
                                                     sort_keys, sort_dirs)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/powermax/masking.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/powermax/masking.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/powermax/masking.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/powermax/masking.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,11 +15,11 @@
 
 import ast
 from copy import deepcopy
+import re
 import sys
 import time
 
 from oslo_log import log as logging
-import re
 import six
 
 from cinder import coordination
@@ -240,8 +240,10 @@ class PowerMaxMasking(object):
         storagegroup_name = masking_view_dict[utils.SG_NAME]
         connector = masking_view_dict[utils.CONNECTOR]
         port_group_name = masking_view_dict[utils.PORTGROUPNAME]
-        LOG.info("Port Group in masking view operation: %(port_group_name)s.",
-                 {'port_group_name': port_group_name})
+        LOG.info("Port Group in masking view operation: %(pg_name)s. "
+                 "The port group labels is %(pg_label)s.",
+                 {'pg_name': masking_view_dict[utils.PORTGROUPNAME],
+                  'pg_label': masking_view_dict[utils.PORT_GROUP_LABEL]})
 
         init_group_name, error_message = (self._get_or_create_initiator_group(
             serial_number, init_group_name, connector, extra_specs))
@@ -298,7 +300,7 @@ class PowerMaxMasking(object):
         """
         storage_group_name, msg = self._check_existing_storage_group(
             serial_number, maskingview_name, default_sg_name,
-            masking_view_dict)
+            masking_view_dict, extra_specs)
         if not msg:
             portgroup_name = self.rest.get_element_from_masking_view(
                 serial_number, maskingview_name, portgroup=True)
@@ -397,9 +399,11 @@ class PowerMaxMasking(object):
         storagegroup = self.rest.get_storage_group(
             serial_number, storagegroup_name)
         if storagegroup is None:
-            storagegroup = self.provision.create_storage_group(
+            storagegroup_name = self.provision.create_storage_group(
                 serial_number, storagegroup_name, srp, slo, workload,
                 extra_specs, do_disable_compression)
+            storagegroup = self.rest.get_storage_group(
+                serial_number, storagegroup_name)
 
         if storagegroup is None:
             msg = ("Cannot get or create a storage group: "
@@ -413,11 +417,55 @@ class PowerMaxMasking(object):
             self.rest.update_storagegroup_qos(
                 serial_number, storagegroup_name, extra_specs)
 
+        # If storagetype:storagegrouptags exist update storage group
+        # to add tags
+        if not parent:
+            self._add_tags_to_storage_group(
+                serial_number, storagegroup, extra_specs)
+
         return msg
 
+    def _add_tags_to_storage_group(
+            self, serial_number, storage_group, extra_specs):
+        """Add tags to a storage group.
+
+        :param serial_number: the array serial number
+        :param storage_group: the storage group object
+        :param extra_specs: the extra specifications
+        """
+        if utils.STORAGE_GROUP_TAGS in extra_specs:
+            # Check if the tags exist
+            if 'tags' in storage_group:
+                new_tag_list = self.utils.get_new_tags(
+                    extra_specs[utils.STORAGE_GROUP_TAGS],
+                    storage_group['tags'])
+                if not new_tag_list:
+                    LOG.info("No new tags to add. Existing tags "
+                             "associated with %(sg_name)s are "
+                             "%(tags)s.",
+                             {'sg_name': storage_group['storageGroupId'],
+                              'tags': storage_group['tags']})
+            else:
+                new_tag_list = (
+                    extra_specs[utils.STORAGE_GROUP_TAGS].split(","))
+
+            if self.utils.verify_tag_list(new_tag_list):
+                LOG.info("Adding the tags %(tag_list)s to %(sg_name)s",
+                         {'tag_list': new_tag_list,
+                          'sg_name': storage_group['storageGroupId']})
+                try:
+                    self.rest.add_storage_group_tag(
+                        serial_number, storage_group['storageGroupId'],
+                        new_tag_list, extra_specs)
+                except Exception as ex:
+                    LOG.warning("Unexpected error: %(ex)s. If you still "
+                                "want to add tags to this storage group, "
+                                "please do so on the Unisphere UI.",
+                                {'ex': ex})
+
     def _check_existing_storage_group(
             self, serial_number, maskingview_name,
-            default_sg_name, masking_view_dict):
+            default_sg_name, masking_view_dict, extra_specs):
         """Check if the masking view has the child storage group.
 
         Get the parent storage group associated with a masking view and check
@@ -427,6 +475,7 @@ class PowerMaxMasking(object):
         :param maskingview_name: the masking view name
         :param default_sg_name: the default sg name
         :param masking_view_dict: the masking view dict
+        :param extra_specs: the extra specifications
         :returns: storage group name, msg
         """
         msg = None
@@ -458,6 +507,8 @@ class PowerMaxMasking(object):
                 LOG.info("Retrieved child sg %(sg_name)s from %(mv_name)s",
                          {'sg_name': child_sg_name,
                           'mv_name': maskingview_name})
+                self._add_tags_to_storage_group(
+                    serial_number, child_sg, extra_specs)
             else:
                 msg = self._get_or_create_storage_group(
                     serial_number, masking_view_dict, child_sg_name,
@@ -480,7 +531,7 @@ class PowerMaxMasking(object):
         "emc-sg-{target_storagegroup_name}-{serial_number}")
     def move_volume_between_storage_groups(
             self, serial_number, device_id, source_storagegroup_name,
-            target_storagegroup_name, extra_specs):
+            target_storagegroup_name, extra_specs, force=False):
         """Move a volume between storage groups.
 
         :param serial_number: the array serial number
@@ -488,6 +539,7 @@ class PowerMaxMasking(object):
         :param source_storagegroup_name: the source sg
         :param target_storagegroup_name: the target sg
         :param extra_specs: the extra specifications
+        :param force: optional Force flag required for replicated vols
         """
         num_vol_in_sg = self.rest.get_num_vols_in_sg(
             serial_number, source_storagegroup_name)
@@ -497,7 +549,7 @@ class PowerMaxMasking(object):
                    'sg_name': source_storagegroup_name})
         self.rest.move_volume_between_storage_groups(
             serial_number, device_id, source_storagegroup_name,
-            target_storagegroup_name, extra_specs)
+            target_storagegroup_name, extra_specs, force)
         if num_vol_in_sg == 1:
             # Check if storage group is a child sg
             parent_sg_name = self.get_parent_sg_from_child(
@@ -1033,7 +1085,8 @@ class PowerMaxMasking(object):
     @coordination.synchronized("emc-vol-{device_id}")
     def remove_and_reset_members(
             self, serial_number, volume, device_id, volume_name,
-            extra_specs, reset=True, connector=None, async_grp=None):
+            extra_specs, reset=True, connector=None, async_grp=None,
+            host_template=None):
         """This is called on a delete, unmap device or rollback.
 
         :param serial_number: the array serial number
@@ -1044,14 +1097,16 @@ class PowerMaxMasking(object):
         :param reset: reset, return to original SG (optional)
         :param connector: the connector object (optional)
         :param async_grp: the async rep group (optional)
+        :param host_template: the host template (optional)
         """
         self._cleanup_deletion(
             serial_number, volume, device_id, volume_name,
-            extra_specs, connector, reset, async_grp)
+            extra_specs, connector, reset, async_grp,
+            host_template=host_template)
 
     def _cleanup_deletion(
             self, serial_number, volume, device_id, volume_name,
-            extra_specs, connector, reset, async_grp):
+            extra_specs, connector, reset, async_grp, host_template=None):
         """Prepare a volume for a delete operation.
 
         :param serial_number: the array serial number
@@ -1062,6 +1117,7 @@ class PowerMaxMasking(object):
         :param connector: the connector object
         :param reset: flag to indicate if reset is required -- bool
         :param async_grp: the async rep group
+        :param host_template: the host template (if it exists)
         """
         move = False
         short_host_name = None
@@ -1075,21 +1131,24 @@ class PowerMaxMasking(object):
             if len(storagegroup_names) == 1 and reset is True:
                 move = True
             elif connector is not None:
-                short_host_name = self.utils.get_host_short_name(
-                    connector['host'])
+                short_host_name = self.utils.get_host_name_label(
+                    connector.get('host'),
+                    host_template) if connector.get('host') else None
                 move = reset
             if short_host_name:
                 for sg_name in storagegroup_names:
                     if short_host_name in sg_name:
                         self.remove_volume_from_sg(
                             serial_number, device_id, volume_name, sg_name,
-                            extra_specs, connector, move)
+                            extra_specs, connector, move,
+                            host_template=host_template)
                         break
             else:
                 for sg_name in storagegroup_names:
                     self.remove_volume_from_sg(
                         serial_number, device_id, volume_name, sg_name,
-                        extra_specs, connector, move)
+                        extra_specs, connector, move,
+                        host_template=host_template)
         if reset is True and move is False:
             self.add_volume_to_default_storage_group(
                 serial_number, device_id, volume_name,
@@ -1097,7 +1156,7 @@ class PowerMaxMasking(object):
 
     def remove_volume_from_sg(
             self, serial_number, device_id, vol_name, storagegroup_name,
-            extra_specs, connector=None, move=False):
+            extra_specs, connector=None, move=False, host_template=None):
         """Remove a volume from a storage group.
 
         :param serial_number: the array serial number
@@ -1107,6 +1166,7 @@ class PowerMaxMasking(object):
         :param extra_specs: the extra specifications
         :param connector: the connector object
         :param move: flag to indicate if move should be used instead of remove
+        :param host_template: the host template (if it exists)
         """
         masking_list = self.rest.get_masking_views_from_storage_group(
             serial_number, storagegroup_name)
@@ -1130,7 +1190,7 @@ class PowerMaxMasking(object):
                         # Last volume in the storage group - delete sg.
                         self._last_vol_in_sg(
                             serial_number, device_id, vol_name, sg_name,
-                            extra_specs, move)
+                            extra_specs, move, host_template=host_template)
                     else:
                         # Not the last volume so remove it from storage group
                         self._multiple_vols_in_sg(
@@ -1172,7 +1232,8 @@ class PowerMaxMasking(object):
                         # Last volume in the storage group - delete sg.
                         self._last_vol_in_sg(
                             serial_number, device_id, vol_name, sg_name,
-                            extra_specs, move, connector)
+                            extra_specs, move, connector,
+                            host_template=host_template)
                     else:
                         # Not the last volume so remove it from storage group
                         self._multiple_vols_in_sg(
@@ -1186,8 +1247,9 @@ class PowerMaxMasking(object):
             return do_remove_volume_from_sg(masking_name, storagegroup_name,
                                             parent_sg_name, serial_number)
 
-    def _last_vol_in_sg(self, serial_number, device_id, volume_name,
-                        storagegroup_name, extra_specs, move, connector=None):
+    def _last_vol_in_sg(
+            self, serial_number, device_id, volume_name, storagegroup_name,
+            extra_specs, move, connector=None, host_template=None):
         """Steps if the volume is the last in a storage group.
 
         1. Check if the volume is in a masking view.
@@ -1206,6 +1268,7 @@ class PowerMaxMasking(object):
         :param extra_specs: extra specifications
         :param move: flag to indicate a move instead of remove
         :param connector: the connector object
+        :param host_template: the host template (if it exists)
         :returns: status -- bool
         """
         LOG.debug("Only one volume remains in storage group "
@@ -1220,7 +1283,8 @@ class PowerMaxMasking(object):
         else:
             status = self._last_vol_masking_views(
                 serial_number, storagegroup_name, maskingview_list,
-                device_id, volume_name, extra_specs, connector, move)
+                device_id, volume_name, extra_specs, connector, move,
+                host_template)
         return status
 
     def _last_vol_no_masking_views(self, serial_number, storagegroup_name,
@@ -1265,7 +1329,8 @@ class PowerMaxMasking(object):
 
     def _last_vol_masking_views(
             self, serial_number, storagegroup_name, maskingview_list,
-            device_id, volume_name, extra_specs, connector, move):
+            device_id, volume_name, extra_specs, connector, move,
+            host_template=None):
         """Remove the last vol from an sg associated with masking views.
 
         Helper function for removing the last vol from a storage group
@@ -1277,6 +1342,7 @@ class PowerMaxMasking(object):
         :param volume_name: the volume name
         :param extra_specs: the extra specifications
         :param move: flag to indicate a move instead of remove
+        :param host_template: the host template (if it exists)
         :returns: status -- bool
         """
         status = False
@@ -1287,7 +1353,8 @@ class PowerMaxMasking(object):
             if num_vols_in_mv == 1:
                 self._delete_mv_ig_and_sg(
                     serial_number, device_id, mv, storagegroup_name,
-                    parent_sg_name, connector, move, extra_specs)
+                    parent_sg_name, connector, move, extra_specs,
+                    host_template=host_template)
             else:
                 self._remove_last_vol_and_delete_sg(
                     serial_number, device_id, volume_name,
@@ -1386,7 +1453,7 @@ class PowerMaxMasking(object):
 
     def _delete_mv_ig_and_sg(
             self, serial_number, device_id, masking_view, storagegroup_name,
-            parent_sg_name, connector, move, extra_specs):
+            parent_sg_name, connector, move, extra_specs, host_template=None):
         """Delete the masking view, storage groups and initiator group.
 
         :param serial_number: array serial number
@@ -1397,15 +1464,15 @@ class PowerMaxMasking(object):
         :param connector: the connector object
         :param move: flag to indicate if the volume should be moved
         :param extra_specs: the extra specifications
+        :param host_template: the host template (if it exists)
         """
-        host = (self.utils.get_host_short_name(connector['host'])
-                if connector else None)
-
         initiatorgroup = self.rest.get_element_from_masking_view(
             serial_number, masking_view, host=True)
         self._last_volume_delete_masking_view(serial_number, masking_view)
         self._last_volume_delete_initiator_group(
-            serial_number, initiatorgroup, host)
+            serial_number, initiatorgroup,
+            connector.get('host') if connector else None,
+            host_template)
         self._delete_cascaded_storage_groups(
             serial_number, storagegroup_name, parent_sg_name,
             extra_specs, device_id, move)
@@ -1594,7 +1661,8 @@ class PowerMaxMasking(object):
         self.rest.delete_storage_group(serial_number, storagegroup_name)
 
     def _last_volume_delete_initiator_group(
-            self, serial_number, initiatorgroup_name, host):
+            self, serial_number, initiatorgroup_name, host,
+            host_template=None):
         """Delete the initiator group.
 
         Delete the Initiator group if it has been created by the PowerMax
@@ -1602,40 +1670,58 @@ class PowerMaxMasking(object):
         :param serial_number: the array serial number
         :param initiatorgroup_name: initiator group name
         :param host: the short name of the host
+        :param host_template: the host template (if it exists)
         """
+        def _do_delete_initiator_group(array, init_group_name):
+            is_deleted = False
+            maskingview_names = (
+                self.rest.get_masking_views_by_initiator_group(
+                    array, init_group_name))
+            if not maskingview_names:
+                @coordination.synchronized(
+                    "emc-ig-{ig_name}-{array}")
+                def _delete_ig(ig_name, array):
+                    # Check initiator group hasn't been recently deleted
+                    ig_details = self.rest.get_initiator_group(
+                        serial_number, ig_name)
+                    if ig_details:
+                        LOG.debug(
+                            "Last volume associated with the initiator "
+                            "group - deleting the associated initiator "
+                            "group %(initiatorgroup_name)s.",
+                            {'initiatorgroup_name': ig_name})
+                        self.rest.delete_initiator_group(
+                            array, ig_name)
+                        return True
+                    else:
+                        return False
+                is_deleted = _delete_ig(init_group_name, array)
+            else:
+                LOG.warning("Initiator group %(ig_name)s is associated "
+                            "with masking views and can't be deleted. "
+                            "Number of associated masking view is: "
+                            "%(nmv)d.",
+                            {'ig_name': init_group_name,
+                             'nmv': len(maskingview_names)})
+            return is_deleted
+
         if host is not None:
-            protocol = self.utils.get_short_protocol_type(self.protocol)
-            default_ig_name = ("OS-%(shortHostName)s-%(protocol)s-IG"
-                               % {'shortHostName': host,
-                                  'protocol': protocol})
+            host_label = (self.utils.get_host_name_label(
+                host, host_template) if host else None)
+            default_ig_name = self.utils.get_possible_initiator_name(
+                host_label, self.protocol)
 
             if initiatorgroup_name == default_ig_name:
-                maskingview_names = (
-                    self.rest.get_masking_views_by_initiator_group(
-                        serial_number, initiatorgroup_name))
-                if not maskingview_names:
-                    @coordination.synchronized(
-                        "emc-ig-{ig_name}-{serial_number}")
-                    def _delete_ig(ig_name, serial_number):
-                        # Check initiator group hasn't been recently deleted
-                        ig_details = self.rest.get_initiator_group(
-                            serial_number, ig_name)
-                        if ig_details:
-                            LOG.debug(
-                                "Last volume associated with the initiator "
-                                "group - deleting the associated initiator "
-                                "group %(initiatorgroup_name)s.",
-                                {'initiatorgroup_name': initiatorgroup_name})
-                            self.rest.delete_initiator_group(
-                                serial_number, initiatorgroup_name)
-                    _delete_ig(initiatorgroup_name, serial_number)
-                else:
-                    LOG.warning("Initiator group %(ig_name)s is associated "
-                                "with masking views and can't be deleted. "
-                                "Number of associated masking view is: "
-                                "%(nmv)d.",
-                                {'ig_name': initiatorgroup_name,
-                                 'nmv': len(maskingview_names)})
+                is_deleted = _do_delete_initiator_group(
+                    serial_number, initiatorgroup_name)
+                if not is_deleted:
+                    host_label = (self.utils.get_host_short_name(
+                        host) if host else None)
+                    default_ig_name = self.utils.get_possible_initiator_name(
+                        host_label, self.protocol)
+                    if initiatorgroup_name == default_ig_name:
+                        _do_delete_initiator_group(
+                            serial_number, initiatorgroup_name)
             else:
                 LOG.warning("Initiator group %(ig_name)s was "
                             "not created by the PowerMax driver so will "
@@ -1666,19 +1752,13 @@ class PowerMaxMasking(object):
         for sg in sg_list.get('storageGroupId', []):
             if slo_wl_combo in sg:
                 fast_source_sg_name = sg
-                masking_view_name = (
-                    self.rest.get_masking_views_from_storage_group(
-                        serial_number, fast_source_sg_name))[0]
-                port_group_name = self.rest.get_element_from_masking_view(
-                    serial_number, masking_view_name, portgroup=True)
-                short_pg_name = self.utils.get_pg_short_name(port_group_name)
-                short_host_name = masking_view_name.lstrip('OS-').rstrip(
-                    '-%s-MV' % short_pg_name)[:-2]
-                extra_specs[utils.PORTGROUPNAME] = short_pg_name
+                short_host_name, port_group_label = (
+                    self._get_host_and_port_group_labels(
+                        serial_number, fast_source_sg_name))
                 no_slo_extra_specs = deepcopy(extra_specs)
                 no_slo_extra_specs[utils.SLO] = None
-                no_slo_sg_name, __, __, __ = self.utils.get_child_sg_name(
-                    short_host_name, no_slo_extra_specs)
+                no_slo_sg_name, __, __ = self.utils.get_child_sg_name(
+                    short_host_name, no_slo_extra_specs, port_group_label)
                 source_sg_details = self.rest.get_storage_group(
                     serial_number, fast_source_sg_name)
                 parent_sg_name = source_sg_details[
@@ -1714,6 +1794,34 @@ class PowerMaxMasking(object):
                 message=exception_message)
         return mv_dict
 
+    def _get_host_and_port_group_labels(
+            self, serial_number, storage_group):
+        """Get the host and port group labels
+
+        :param serial_number: the array serial number
+        :param storage_group: the storage group
+        :returns: short_host_name, port_group_label
+        """
+        masking_view_name = (
+            self.rest.get_masking_views_from_storage_group(
+                serial_number, storage_group))[0]
+        object_dict = self.get_components_from_masking_view_name(
+            masking_view_name)
+        return object_dict['host'], object_dict['portgroup']
+
+    def get_components_from_masking_view_name(self, masking_view_name):
+        """Get the host and port group labels
+
+        :param masking_view_name: the masking view name
+        :returns: object dict
+        """
+        regex_str = (r'^(?P<prefix>OS)-(?P<host>.+?)(?P<protocol>I|F)-'
+                     r'(?P<portgroup>(?!CD|RE|CD-RE).+)-(?P<postfix>MV)$')
+
+        object_dict = self.utils.get_object_components_and_correct_host(
+            regex_str, masking_view_name)
+        return object_dict
+
     def return_volume_to_fast_managed_group(
             self, serial_number, device_id, extra_specs):
         """Return a volume to a fast managed group if slo is set.
@@ -1733,18 +1841,11 @@ class PowerMaxMasking(object):
             for sg in sg_list.get('storageGroupId', []):
                 if slo_wl_combo in sg:
                     no_slo_sg_name = sg
-                    masking_view_name = (
-                        self.rest.get_masking_views_from_storage_group(
-                            serial_number, no_slo_sg_name))[0]
-                    port_group_name = self.rest.get_element_from_masking_view(
-                        serial_number, masking_view_name, portgroup=True)
-                    short_pg_name = self.utils.get_pg_short_name(
-                        port_group_name)
-                    short_host_name = masking_view_name.lstrip('OS-').rstrip(
-                        '-%s-MV' % short_pg_name)[:-2]
-                    extra_specs[utils.PORTGROUPNAME] = short_pg_name
-                    fast_sg_name, _, _, _ = self.utils.get_child_sg_name(
-                        short_host_name, extra_specs)
+                    short_host_name, port_group_label = (
+                        self._get_host_and_port_group_labels(
+                            serial_number, no_slo_sg_name))
+                    fast_sg_name, _, _ = self.utils.get_child_sg_name(
+                        short_host_name, extra_specs, port_group_label)
                     source_sg_details = self.rest.get_storage_group(
                         serial_number, no_slo_sg_name)
                     parent_sg_name = source_sg_details[
@@ -1814,20 +1915,24 @@ class PowerMaxMasking(object):
                 self.rest.delete_storage_group(
                     serial_number, child_sg_name)
 
-    def attempt_ig_cleanup(self, connector, protocol, serial_number, force):
+    def attempt_ig_cleanup(
+            self, connector, protocol, serial_number, force,
+            host_template=None):
         """Attempt to cleanup an orphan initiator group
 
         :param connector: connector object
         :param protocol: iscsi or fc
         :param serial_number: extra the array serial number
         :param force: flag to indicate if operation should be forced
+        :param host_template: the host template (if it exists)
         """
         protocol = self.utils.get_short_protocol_type(protocol)
-        host_name = connector['host']
-        short_host_name = self.utils.get_host_short_name(host_name)
-        init_group = (
-            ("OS-%(shortHostName)s-%(protocol)s-IG"
-             % {'shortHostName': short_host_name,
-                'protocol': protocol}))
+        host_name = connector.get('host')
+
+        host_label = self.utils.get_host_name_label(
+            host_name, host_template=host_template)
+        initiator_group_name = self.utils.get_possible_initiator_name(
+            host_label, protocol)
+
         self._check_ig_rollback(
-            serial_number, init_group, connector, force)
+            serial_number, initiator_group_name, connector, force)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/powermax/metadata.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/powermax/metadata.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/powermax/metadata.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/powermax/metadata.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,13 +14,13 @@
 #    under the License.
 import datetime
 import platform
-import prettytable
-import six
 import time
 import traceback
 import types
 
 from oslo_log import log as logging
+import six
+import tabulate
 
 from cinder.objects import volume
 from cinder import version
@@ -237,12 +237,13 @@ class PowerMaxVolumeMetadata(object):
 
         :param datadict: the data dictionary
         """
-        t = prettytable.PrettyTable(['Key', 'Value'])
+        rows = []
         for k, v in datadict.items():
             if v is not None:
-                t.add_row([k, v])
+                rows.append([k, v])
+        t = tabulate.tabulate(rows, headers=['Key', 'Value'], tablefmt='psql')
 
-        LOG.debug('\n%(output)s\n', {'output': t})
+        LOG.debug('\n%s\n', t)
 
     def _consolidate_volume_trace_list(
             self, volume_id, volume_trace_dict, volume_key_value):
@@ -293,6 +294,7 @@ class PowerMaxVolumeMetadata(object):
         mv_list, sg_list = [], []
         child_storage_group, parent_storage_group = None, None
         initiator_group, port_group = None, None
+        child_storage_group_tag_list = None
 
         if is_multiattach:
             successful_operation = 'multi_attach'
@@ -301,6 +303,8 @@ class PowerMaxVolumeMetadata(object):
         else:
             successful_operation = 'attach'
             child_storage_group = masking_view_dict[utils.SG_NAME]
+            child_storage_group_tag_list = (
+                masking_view_dict.get(utils.TAG_LIST, None))
             parent_storage_group = masking_view_dict[utils.PARENT_SG_NAME]
             initiator_group = masking_view_dict[utils.IG_NAME]
             port_group = masking_view_dict[utils.PORTGROUPNAME]
@@ -315,10 +319,13 @@ class PowerMaxVolumeMetadata(object):
             parent_storage_group=parent_storage_group,
             initiator_group=initiator_group,
             port_group=port_group,
-            host=host, is_multipath=is_multipath,
+            host=host, used_host_name=masking_view_dict[utils.USED_HOST_NAME],
+            is_multipath=is_multipath,
             identifier_name=self.utils.get_volume_element_name(volume.id),
             openstack_name=volume.display_name,
-            mv_list=mv_list, sg_list=sg_list)
+            mv_list=mv_list, sg_list=sg_list,
+            child_storage_group_tag_list=child_storage_group_tag_list,
+            array_tag_list=masking_view_dict.get('array_tag_list', None))
 
         volume_metadata = self.update_volume_info_metadata(
             datadict, self.version_dict)
@@ -446,7 +453,8 @@ class PowerMaxVolumeMetadata(object):
     def capture_create_volume(
             self, device_id, volume, group_name, group_id, extra_specs,
             rep_info_dict, successful_operation, source_snapshot_id=None,
-            source_device_id=None, temporary_snapvx=None):
+            source_device_id=None, temporary_snapvx=None,
+            array_tag_list=None):
         """Captures create volume info in volume metadata
 
         :param device_id: device id
@@ -457,6 +465,8 @@ class PowerMaxVolumeMetadata(object):
         :param rep_info_dict: information gathered from replication
         :param successful_operation: the type of create operation
         :param source_snapshot_id: the source snapshot id
+        :param temporary_snapvx: temporary snapVX
+        :param array_tag_list: array tag list
 
         :returns: volume_metadata dict
         """
@@ -501,7 +511,8 @@ class PowerMaxVolumeMetadata(object):
                 extra_specs),
             source_device_id=source_device_id,
             temporary_snapvx=temporary_snapvx,
-            target_array_model=target_array_model)
+            target_array_model=target_array_model,
+            array_tag_list=array_tag_list)
         volume_metadata = self.update_volume_info_metadata(
             datadict, self.version_dict)
         self.print_pretty_table(volume_metadata)
@@ -642,6 +653,15 @@ class PowerMaxVolumeMetadata(object):
             is_rep_enabled=('yes' if is_rep_enabled else 'no'),
             rep_mode=rep_mode, is_compression_disabled=(
                 True if is_compression_disabled else False))
+        if not is_rep_enabled:
+            delete_list = ['rdf_group_no', 'rep_mode', 'target_array_model',
+                           'service_level', 'remote_array', 'target_device_id',
+                           'replication_status', 'rdf_group_label']
+            self.utils.delete_values_from_dict(datadict, delete_list)
+            update_list = [('default_sg_name', 'source_sg_name'),
+                           ('service_level', 'source_service_level')]
+            self.utils.update_values_in_dict(datadict, update_list)
+
         volume_metadata = self.update_volume_info_metadata(
             datadict, self.version_dict)
         self.print_pretty_table(volume_metadata)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/powermax/provision.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/powermax/provision.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/powermax/provision.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/powermax/provision.py	2020-03-24 18:46:31.000000000 +0000
@@ -79,15 +79,16 @@ class PowerMaxProvision(object):
         return do_create_storage_group(storagegroup_name, array)
 
     def create_volume_from_sg(self, array, volume_name, storagegroup_name,
-                              volume_size, extra_specs):
+                              volume_size, extra_specs, rep_info=None):
         """Create a new volume in the given storage group.
 
         :param array: the array serial number
-        :param volume_name: the volume name (String)
+        :param volume_name: the volume name -- string
         :param storagegroup_name: the storage group name
-        :param volume_size: volume size (String)
-        :param extra_specs: the extra specifications
-        :returns: dict -- volume_dict - the volume dict
+        :param volume_size: volume size -- string
+        :param extra_specs: extra specifications
+        :param rep_info: replication session info dict -- optional
+        :returns: volume info -- dict
         """
         @coordination.synchronized("emc-sg-{storage_group}-{array}")
         def do_create_volume_from_sg(storage_group, array):
@@ -95,7 +96,7 @@ class PowerMaxProvision(object):
 
             volume_dict = self.rest.create_volume_from_sg(
                 array, volume_name, storage_group,
-                volume_size, extra_specs)
+                volume_size, extra_specs, rep_info)
 
             LOG.debug("Create volume from storage group "
                       "took: %(delta)s H:MM:SS.",
@@ -145,7 +146,7 @@ class PowerMaxProvision(object):
 
     def create_volume_replica(
             self, array, source_device_id, target_device_id,
-            snap_name, extra_specs, create_snap=False):
+            snap_name, extra_specs, create_snap=False, copy_mode=False):
         """Create a snap vx of a source and copy to a target.
 
         :param array: the array serial number
@@ -154,6 +155,7 @@ class PowerMaxProvision(object):
         :param snap_name: the name for the snap shot
         :param extra_specs: extra specifications
         :param create_snap: Flag for create snapvx
+        :param copy_mode: If copy mode should be used for SnapVX target links
         """
         start_time = time.time()
         if create_snap:
@@ -166,7 +168,7 @@ class PowerMaxProvision(object):
         def do_modify_volume_snap(src_device_id):
             self.rest.modify_volume_snap(
                 array, src_device_id, target_device_id, snap_name,
-                extra_specs, link=True)
+                extra_specs, link=True, copy=copy_mode)
 
         do_modify_volume_snap(source_device_id)
 
@@ -174,7 +176,7 @@ class PowerMaxProvision(object):
                   {'delta': self.utils.get_time_delta(start_time,
                                                       time.time())})
 
-    def break_replication_relationship(
+    def unlink_snapvx_tgt_volume(
             self, array, target_device_id, source_device_id, snap_name,
             extra_specs, generation=0, loop=True):
         """Unlink a snapshot from its target volume.
@@ -213,7 +215,7 @@ class PowerMaxProvision(object):
         :param list_volume_pairs: list of volume pairs, optional
         :param generation: the generation number of the snapshot
         :param loop: if looping call is required for handling retries
-        :return: return code
+        :returns: return code
         """
         def _unlink_vol():
             """Called at an interval until the synchronization is finished.
@@ -392,8 +394,9 @@ class PowerMaxProvision(object):
             self._unlink_volume(array, "", "", snap_name, extra_specs,
                                 list_volume_pairs=list_device_pairs,
                                 generation=generation)
-        self.delete_volume_snap(array, snap_name, source_devices,
-                                restored=False, generation=generation)
+        if source_devices:
+            self.delete_volume_snap(array, snap_name, source_devices,
+                                    restored=False, generation=generation)
 
     def extend_volume(self, array, device_id, new_size, extra_specs,
                       rdf_group=None):
@@ -547,105 +550,32 @@ class PowerMaxProvision(object):
         return '%(slo)s+%(workload)s' % {'slo': slo, 'workload': workload}
 
     @coordination.synchronized('emc-rg-{rdf_group}')
-    def break_rdf_relationship(self, array, device_id, target_device,
+    def break_rdf_relationship(self, array, device_id, sg_name,
                                rdf_group, rep_extra_specs, state):
         """Break the rdf relationship between a pair of devices.
 
+        Resuming replication after suspending is necessary where this function
+        is called from. Doing so in here will disrupt the ability to perform
+        further actions on the RDFG without suspending again.
+
         :param array: the array serial number
         :param device_id: the source device id
-        :param target_device: target device id
+        :param sg_name: storage grto
         :param rdf_group: the rdf group number
         :param rep_extra_specs: replication extra specs
         :param state: the state of the rdf pair
         """
-        LOG.info("Suspending rdf pair: source device: %(src)s "
-                 "target device: %(tgt)s.",
-                 {'src': device_id, 'tgt': target_device})
-        if state.lower() == utils.RDF_SYNCINPROG_STATE:
-            self.rest.wait_for_rdf_consistent_state(
-                array, device_id, target_device,
-                rep_extra_specs, state)
-        if state.lower() == utils.RDF_SUSPENDED_STATE:
-            LOG.info("RDF pair is already suspended")
-        else:
-            self.rest.modify_rdf_device_pair(
-                array, device_id, rdf_group, rep_extra_specs, suspend=True)
-        self.delete_rdf_pair(array, device_id, rdf_group,
-                             target_device, rep_extra_specs)
-
-    def break_metro_rdf_pair(self, array, device_id, target_device,
-                             rdf_group, rep_extra_specs, metro_grp):
-        """Delete replication for a Metro device pair.
-
-        Need to suspend the entire group before we can delete a single pair.
-        :param array: the array serial number
-        :param device_id: the device id
-        :param target_device: the target device id
-        :param rdf_group: the rdf group number
-        :param rep_extra_specs: the replication extra specifications
-        :param metro_grp: the metro storage group name
-        """
-        # Suspend I/O on the RDF links...
-        LOG.info("Suspending I/O for all volumes in the RDF group: %(rdfg)s",
-                 {'rdfg': rdf_group})
-        self.disable_group_replication(
-            array, metro_grp, rdf_group, rep_extra_specs)
-        self.delete_rdf_pair(array, device_id, rdf_group,
-                             target_device, rep_extra_specs)
-
-    def delete_rdf_pair(
-            self, array, device_id, rdf_group, target_device, extra_specs):
-        """Delete an rdf pairing.
-
-        If the replication mode is synchronous, only one attempt is required
-        to delete the pair. Otherwise, we need to wait until all the tracks
-        are cleared before the delete will be successful. As there is
-        currently no way to track this information, we keep attempting the
-        operation until it is successful.
-
-        :param array: the array serial number
-        :param device_id: source volume device id
-        :param rdf_group: the rdf group number
-        :param target_device: the target device
-        :param extra_specs: extra specifications
-        """
-        LOG.info("Deleting rdf pair: source device: %(src)s "
-                 "target device: %(tgt)s.",
-                 {'src': device_id, 'tgt': target_device})
-        if (extra_specs.get(utils.REP_MODE) and
-                extra_specs.get(utils.REP_MODE) == utils.REP_SYNC):
-            return self.rest.delete_rdf_pair(array, device_id, rdf_group)
-
-        def _delete_pair():
-            """Delete a rdf volume pair.
+        LOG.info("Suspending RDF group %(rdf)s to delete source device "
+                 "%(dev)s RDF pair.", {'rdf': rdf_group, 'dev': device_id})
 
-            Called at an interval until all the tracks are cleared
-            and the operation is successful.
-
-            :raises: loopingcall.LoopingCallDone
-            """
-            retries = kwargs['retries']
-            try:
-                kwargs['retries'] = retries + 1
-                if not kwargs['delete_pair_success']:
-                    self.rest.delete_rdf_pair(
-                        array, device_id, rdf_group)
-                    kwargs['delete_pair_success'] = True
-            except exception.VolumeBackendAPIException:
-                pass
-
-            if kwargs['retries'] > UNLINK_RETRIES:
-                LOG.error("Delete volume pair failed after %(retries)d "
-                          "tries.", {'retries': retries})
-                raise loopingcall.LoopingCallDone(retvalue=30)
-            if kwargs['delete_pair_success']:
-                raise loopingcall.LoopingCallDone()
+        if state.lower() == utils.RDF_SYNCINPROG_STATE:
+            self.rest.wait_for_rdf_pair_sync(
+                array, rdf_group, device_id, rep_extra_specs)
+        if state.lower() != utils.RDF_SUSPENDED_STATE:
+            self.rest.srdf_suspend_replication(
+                array, sg_name, rdf_group, rep_extra_specs)
 
-        kwargs = {'retries': 0,
-                  'delete_pair_success': False}
-        timer = loopingcall.FixedIntervalLoopingCall(_delete_pair)
-        rc = timer.start(interval=UNLINK_INTERVAL).wait()
-        return rc
+        self.rest.srdf_delete_device_pair(array, rdf_group, device_id)
 
     def get_or_create_volume_group(self, array, group, extra_specs):
         """Get or create a volume group.
@@ -656,7 +586,7 @@ class PowerMaxProvision(object):
         :param array: the array serial number
         :param group: the group object
         :param extra_specs: the extra specifications
-        :return: group name
+        :returns: group name
         """
         vol_grp_name = self.utils.update_volume_group_name(group)
         return self.get_or_create_group(array, vol_grp_name, extra_specs)
@@ -667,7 +597,7 @@ class PowerMaxProvision(object):
         :param array: the array serial number
         :param group_name: the group name
         :param extra_specs: the extra specifications
-        :return: group name
+        :returns: group name
         """
         storage_group = self.rest.get_storage_group(array, group_name)
         if not storage_group:
@@ -701,22 +631,26 @@ class PowerMaxProvision(object):
         self.rest.create_storagegroup_snap(
             array, source_group, snap_name, extra_specs)
 
-    def delete_group_replica(self, array, snap_name, source_group_name,
-                             src_dev_ids, extra_specs):
+    def delete_group_replica(self, array, snap_name, source_group_name):
         """Delete the snapshot.
 
         :param array: the array serial number
         :param snap_name: the name for the snap shot
         :param source_group_name: the source group name
-        :param src_dev_ids: the list of source device ids
-        :param extra_specs: extra specifications
         """
-        # Delete snapvx snapshot
         LOG.debug("Deleting Snap Vx snapshot: source group: %(srcGroup)s "
                   "snapshot: %(snap_name)s.",
                   {'srcGroup': source_group_name, 'snap_name': snap_name})
-        self.delete_volume_snap_check_for_links(
-            array, snap_name, src_dev_ids, extra_specs)
+        gen_list = self.rest.get_storagegroup_snap_generation_list(
+            array, source_group_name, snap_name)
+        if gen_list:
+            gen_list.sort(reverse=True)
+            for gen in gen_list:
+                self.rest.delete_storagegroup_snap(
+                    array, source_group_name, snap_name, gen)
+        else:
+            LOG.debug("Unable to get generation number(s) for: %(srcGroup)s.",
+                      {'srcGroup': source_group_name})
 
     def link_and_break_replica(self, array, source_group_name,
                                target_group_name, snap_name, extra_specs,
@@ -755,75 +689,6 @@ class PowerMaxProvision(object):
             source_devices = [a for a, b in list_volume_pairs]
             self.delete_volume_snap(array, snap_name, source_devices)
 
-    def enable_group_replication(self, array, storagegroup_name,
-                                 rdf_group_num, extra_specs, establish=False):
-        """Resume rdf replication on a storage group.
-
-        Replication is enabled by default. This allows resuming
-        replication on a suspended group.
-        :param array: the array serial number
-        :param storagegroup_name: the storagegroup name
-        :param rdf_group_num: the rdf group number
-        :param extra_specs: the extra specifications
-        :param establish: flag to indicate 'establish' instead of 'resume'
-        """
-        action = "Establish" if establish is True else "Resume"
-        self.rest.modify_storagegroup_rdf(
-            array, storagegroup_name, rdf_group_num, action, extra_specs)
-
-    def disable_group_replication(self, array, storagegroup_name,
-                                  rdf_group_num, extra_specs):
-        """Suspend rdf replication on a storage group.
-
-        This does not delete the rdf pairs, that can only be done
-        by deleting the group. This method suspends all i/o activity
-        on the rdf links.
-        :param array: the array serial number
-        :param storagegroup_name: the storagegroup name
-        :param rdf_group_num: the rdf group number
-        :param extra_specs: the extra specifications
-        """
-        action = "Suspend"
-        self.rest.modify_storagegroup_rdf(
-            array, storagegroup_name, rdf_group_num, action, extra_specs)
-
-    def failover_group(self, array, storagegroup_name,
-                       rdf_group_num, extra_specs, failover=True):
-        """Failover or failback replication on a storage group.
-
-        :param array: the array serial number
-        :param storagegroup_name: the storagegroup name
-        :param rdf_group_num: the rdf group number
-        :param extra_specs: the extra specifications
-        :param failover: flag to indicate failover/ failback
-        """
-        action = "Failover" if failover else "Failback"
-        self.rest.modify_storagegroup_rdf(
-            array, storagegroup_name, rdf_group_num, action, extra_specs)
-
-    def delete_group_replication(self, array, storagegroup_name,
-                                 rdf_group_num, extra_specs):
-        """Split replication for a group and delete the pairs.
-
-        :param array: the array serial number
-        :param storagegroup_name: the storage group name
-        :param rdf_group_num: the rdf group number
-        :param extra_specs: the extra specifications
-        """
-        group_details = self.rest.get_storage_group_rep(
-            array, storagegroup_name)
-        if (group_details and group_details.get('rdf')
-                and group_details['rdf'] is True):
-            action = "Split"
-            LOG.debug("Splitting remote replication for group %(sg)s",
-                      {'sg': storagegroup_name})
-            self.rest.modify_storagegroup_rdf(
-                array, storagegroup_name, rdf_group_num, action, extra_specs)
-            LOG.debug("Deleting remote replication for group %(sg)s",
-                      {'sg': storagegroup_name})
-            self.rest.delete_storagegroup_rdf(
-                array, storagegroup_name, rdf_group_num)
-
     def revert_volume_snapshot(self, array, source_device_id,
                                snap_name, extra_specs):
         """Revert a volume snapshot
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/powermax/rest.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/powermax/rest.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/powermax/rest.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/powermax/rest.py	2020-03-24 18:46:31.000000000 +0000
@@ -24,10 +24,8 @@ import requests.auth
 import requests.exceptions as r_exc
 # pylint: disable=E0401
 import requests.packages.urllib3.util.retry as requests_retry
-
 import six
 
-from cinder import coordination
 from cinder import exception
 from cinder.i18n import _
 from cinder.utils import retry
@@ -38,7 +36,7 @@ SLOPROVISIONING = 'sloprovisioning'
 REPLICATION = 'replication'
 SYSTEM = 'system'
 U4V_VERSION = '91'
-MIN_U4P_VERSION = '9.1.0.1054'
+MIN_U4P_VERSION = '9.1.0.5'
 UCODE_5978 = '5978'
 retry_exc_tuple = (exception.VolumeBackendAPIException,)
 # HTTP constants
@@ -100,7 +98,6 @@ class PowerMaxRest(object):
         """Set the environment failover Unisphere targets and configuration..
 
         :param failover_info: failover target record
-        :return:
         """
         self.u4p_failover_enabled = True
         self.primary_u4p = failover_info['u4p_primary']
@@ -284,8 +281,8 @@ class PowerMaxRest(object):
         except Exception as e:
             msg = _("The %(method)s request to URL %(url)s failed with "
                     "exception %(e)s")
-            LOG.exception(msg, {'method': method, 'url': url,
-                                'e': six.text_type(e)})
+            LOG.error(msg, {'method': method, 'url': url,
+                            'e': six.text_type(e)})
             raise exception.VolumeBackendAPIException(
                 message=(msg, {'method': method, 'url': url,
                                'e': six.text_type(e)}))
@@ -324,7 +321,7 @@ class PowerMaxRest(object):
                         kwargs['result'], kwargs['task'] = result, task
             except Exception:
                 exception_message = (_("Issue encountered waiting for job."))
-                LOG.exception(exception_message)
+                LOG.error(exception_message)
                 raise exception.VolumeBackendAPIException(
                     message=exception_message)
 
@@ -553,6 +550,16 @@ class PowerMaxRest(object):
                       {'array': array})
         return array_details
 
+    def get_array_tags(self, array):
+        """Get the tags from its serial number.
+
+        :param array: the array serial number
+        :returns: tag list -- list or empty list
+        """
+        target_uri = '/%s/system/tag?array_id=%s' % (U4V_VERSION, array)
+        array_tags = self._get_request(target_uri, 'system')
+        return array_tags.get('tag_name')
+
     def is_next_gen_array(self, array):
         """Check to see if array is a next gen array(ucode 5978 or greater).
 
@@ -570,7 +577,7 @@ class PowerMaxRest(object):
     def get_uni_version(self):
         """Get the unisphere version from the server.
 
-        :return: version and major_version(e.g. ("V8.4.0.16", "84"))
+        :returns: version and major_version(e.g. ("V8.4.0.16", "84"))
         """
         version, major_version = None, None
         response = self.get_unisphere_version()
@@ -652,7 +659,7 @@ class PowerMaxRest(object):
         """Get the PowerMax/VMAX model.
 
         :param array: the array serial number
-        :return: the PowerMax/VMAX model
+        :returns: the PowerMax/VMAX model
         """
         vmax_version = None
         system_info = self.get_array_detail(array)
@@ -664,7 +671,7 @@ class PowerMaxRest(object):
         """Get the PowerMax/VMAX model.
 
         :param array: the array serial number
-        :return: the PowerMax/VMAX model
+        :returns: the PowerMax/VMAX model
         """
         array_model = None
         is_next_gen = False
@@ -681,7 +688,7 @@ class PowerMaxRest(object):
         """Get the PowerMax/VMAX uCode version.
 
         :param array: the array serial number
-        :return: the PowerMax/VMAX uCode version
+        :returns: the PowerMax/VMAX uCode version
         """
         ucode_version = None
         system_info = self.get_array_detail(array)
@@ -858,8 +865,22 @@ class PowerMaxRest(object):
             array, SLOPROVISIONING, 'storagegroup', payload, version,
             resource_name=storagegroup)
 
+    def modify_storage_array(self, array, payload):
+        """Modify a storage array (PUT operation).
+
+        :param array: the array serial number
+        :param payload: the request payload
+        :returns: status_code -- int, message -- string, server response
+        """
+        target_uri = '/%s/sloprovisioning/symmetrix/%s' % (U4V_VERSION, array)
+        status_code, message = self.request(target_uri, PUT,
+                                            request_object=payload)
+        operation = 'modify %(res)s resource' % {'res': 'symmetrix'}
+        self.check_status_code_success(operation, status_code, message)
+        return status_code, message
+
     def create_volume_from_sg(self, array, volume_name, storagegroup_name,
-                              volume_size, extra_specs):
+                              volume_size, extra_specs, rep_info=None):
         """Create a new volume in the given storage group.
 
         :param array: the array serial number
@@ -867,6 +888,7 @@ class PowerMaxRest(object):
         :param storagegroup_name: the storage group name
         :param volume_size: volume size (String)
         :param extra_specs: the extra specifications
+        :param rep_info: replication info dict if volume is replication enabled
         :returns: dict -- volume_dict - the volume dict
         :raises: VolumeBackendAPIException
         """
@@ -887,6 +909,11 @@ class PowerMaxRest(object):
                                  },
                                  "volume_size": volume_size,
                                  "capacityUnit": "GB"}]}}}})
+
+        if rep_info:
+            payload = self.utils.update_payload_for_rdf_vol_create(
+                payload, rep_info[utils.REMOTE_ARRAY], storagegroup_name)
+
         status_code, job = self.modify_storage_group(
             array, storagegroup_name, payload)
 
@@ -897,9 +924,27 @@ class PowerMaxRest(object):
         task = self.wait_for_job('Create volume', status_code,
                                  job, extra_specs)
 
-        # Find the newly created volume.
         device_id = None
-        if task:
+        if rep_info:
+            updated_device_list = self.get_volume_list(
+                array, {'storageGroupId': storagegroup_name,
+                        'rdf_group_number': rep_info['rdf_group_no']})
+            unique_devices = self.utils.get_unique_device_ids_from_lists(
+                rep_info['initial_device_list'], updated_device_list)
+
+            if 0 < len(unique_devices) < 2:
+                device_id = unique_devices[0]
+                self.rename_volume(array, device_id, volume_name)
+            else:
+                raise exception.VolumeBackendAPIException(_(
+                    "There has been more than one volume created in the "
+                    "SRDF protected Storage Group since the current create "
+                    "volume process begun. Not possible to discern what "
+                    "volume has been created by PowerMax Cinder driver."))
+
+        # Find the newly created volume if not located as part of replication
+        # OPT workaround
+        if not device_id and task:
             for t in task:
                 try:
                     desc = t["description"]
@@ -913,15 +958,66 @@ class PowerMaxRest(object):
                 except Exception as e:
                     LOG.info("Could not retrieve device id from job. "
                              "Exception received was %(e)s. Attempting "
-                             "retrieval by volume_identifier.",
-                             {'e': e})
+                             "retrieval by volume_identifier.", {'e': e})
 
         if not device_id:
             device_id = self.find_volume_device_id(array, volume_name)
 
-        volume_dict = {'array': array, 'device_id': device_id}
+        volume_dict = {utils.ARRAY: array, utils.DEVICE_ID: device_id}
         return volume_dict
 
+    def add_storage_group_tag(self, array, storagegroup_name,
+                              tag_list, extra_specs):
+        """Create a new tag(s) on a storage group
+
+        :param array: the array serial number
+        :param storagegroup_name: the storage group name
+        :param tag_list: comma delimited list
+        :param extra_specs: the extra specifications
+        """
+        payload = (
+            {"executionOption": "ASYNCHRONOUS",
+             "editStorageGroupActionParam": {
+                 "tagManagementParam": {
+                     "addTagsParam": {
+                         "tag_name": tag_list
+                     }}}})
+        status_code, job = self.modify_storage_group(
+            array, storagegroup_name, payload)
+
+        LOG.debug("Add tag to storage group: %(sg_name)s. "
+                  "Status code: %(sc)lu.",
+                  {'sg_name': storagegroup_name,
+                   'sc': status_code})
+
+        self.wait_for_job(
+            'Add tag to storage group', status_code, job, extra_specs)
+
+    def add_storage_array_tags(self, array, tag_list, extra_specs):
+        """Create a new tag(s) on a storage group
+
+        :param array: the array serial number
+        :param tag_list: comma delimited list
+        :param extra_specs: the extra specifications
+        """
+        payload = (
+            {"executionOption": "ASYNCHRONOUS",
+             "editSymmetrixActionParam": {
+                 "tagManagementParam": {
+                     "addTagsParam": {
+                         "tag_name": tag_list
+                     }}}})
+        status_code, job = self.modify_storage_array(
+            array, payload)
+
+        LOG.debug("Add tag to storage array: %(array)s. "
+                  "Status code: %(sc)lu.",
+                  {'array': array,
+                   'sc': status_code})
+
+        self.wait_for_job(
+            'Add tag to storage array', status_code, job, extra_specs)
+
     def check_volume_device_id(self, array, device_id, volume_id,
                                name_id=None):
         """Check if the identifiers match for a given volume.
@@ -990,8 +1086,8 @@ class PowerMaxRest(object):
         :param extra_specs: the extra specifications
         """
 
-        force_vol_remove = ("true" if "force_vol_remove" in extra_specs
-                            else "false")
+        force_vol_remove = (
+            "true" if utils.FORCE_VOL_REMOVE in extra_specs else "false")
         if not isinstance(device_id, list):
             device_id = [device_id]
         payload = ({"executionOption": "ASYNCHRONOUS",
@@ -1318,7 +1414,7 @@ class PowerMaxRest(object):
             array, SLOPROVISIONING, 'maskingview',
             resource_name=resource_name, params=params)
         if not connection_info:
-            LOG.error('Cannot retrive masking view connection information '
+            LOG.error('Cannot retrieve masking view connection information '
                       'for %(mv)s.', {'mv': maskingview})
         else:
             try:
@@ -1775,7 +1871,7 @@ class PowerMaxRest(object):
     def modify_volume_snap(self, array, source_id, target_id, snap_name,
                            extra_specs, link=False, unlink=False,
                            rename=False, new_snap_name=None, restore=False,
-                           list_volume_pairs=None, generation=0):
+                           list_volume_pairs=None, generation=0, copy=False):
         """Modify a snapvx snapshot
 
         :param array: the array serial number
@@ -1790,8 +1886,11 @@ class PowerMaxRest(object):
         :param restore: Flag to indicate action = Restore
         :param list_volume_pairs: list of volume pairs to link, optional
         :param generation: the generation number of the snapshot
+        :param copy: If copy mode should be used for SnapVX target links
         """
         action, operation, payload = '', '', {}
+        copy = 'true' if copy else 'false'
+
         if link:
             action = "Link"
         elif unlink:
@@ -1820,7 +1919,7 @@ class PowerMaxRest(object):
                 tgt_list.append({'name': target_id})
             payload = {"deviceNameListSource": src_list,
                        "deviceNameListTarget": tgt_list,
-                       "copy": 'false', "action": action,
+                       "copy": copy, "action": action,
                        "star": 'false', "force": 'false',
                        "exact": 'false', "remote": 'false',
                        "symforce": 'false', "generation": generation}
@@ -1923,7 +2022,6 @@ class PowerMaxRest(object):
         rdf_grp = None
         volume_details = self.get_volume(array, device_id)
         if volume_details:
-            LOG.debug("Vol details: %(vol)s", {'vol': volume_details})
             if volume_details.get('snapvx_target'):
                 snapvx_tgt = volume_details['snapvx_target']
             if volume_details.get('snapvx_source'):
@@ -1961,7 +2059,7 @@ class PowerMaxRest(object):
             except Exception:
                 exception_message = (_("Issue encountered waiting for "
                                        "synchronization."))
-                LOG.exception(exception_message)
+                LOG.error(exception_message)
                 raise exception.VolumeBackendAPIException(
                     message=exception_message)
 
@@ -2065,7 +2163,7 @@ class PowerMaxRest(object):
         :param source_device_id: source device id
         :param snap_name: the snapshot name
         :param state: filter for state of the link
-        :return: list of dict of generations with linked devices
+        :returns: list of dict of generations with linked devices
         """
         snap_dict_list = []
         snap_list = self._find_snap_vx_source_sessions(
@@ -2153,6 +2251,22 @@ class PowerMaxRest(object):
         return self.get_resource(array, REPLICATION, 'rdf_group',
                                  rdf_number)
 
+    def get_storage_group_rdf_group_state(self, array, storage_group,
+                                          rdf_group_no):
+        """Get the RDF group state from a replication enabled Storage Group.
+
+        :param array: the array serial number
+        :param storage_group: the storage group name
+        :param rdf_group_no: the RDF group number
+        :returns: storage group RDF group state
+        """
+        resource = ('storagegroup/%(sg)s/rdf_group/%(rdfg)s' % {
+            'sg': storage_group, 'rdfg': rdf_group_no})
+
+        rdf_group = self.get_resource(array, REPLICATION, resource)
+
+        return rdf_group.get('states', list()) if rdf_group else dict()
+
     def get_rdf_group_list(self, array):
         """Get rdf group list from array.
 
@@ -2175,6 +2289,19 @@ class PowerMaxRest(object):
             LOG.warning("Cannot locate source RDF volume %s", src_device_id)
         return rdf_session
 
+    def get_rdf_pair_volume(self, array, rdf_group_no, device_id):
+        """Get information on an RDF pair from the source volume.
+
+        :param array: the array serial number
+        :param rdf_group_no: the RDF group number
+        :param device_id: the source device ID
+        :returns: RDF pair information -- dict
+        """
+        resource = ('rdf_group/%(rdf_group)s/volume/%(device)s' % {
+            'rdf_group': rdf_group_no, 'device': device_id})
+
+        return self.get_resource(array, REPLICATION, resource)
+
     def are_vols_rdf_paired(self, array, remote_array,
                             device_id, target_device):
         """Check if a pair of volumes are RDF paired.
@@ -2199,55 +2326,142 @@ class PowerMaxRest(object):
             LOG.warning("Cannot locate RDF session for volume %s", device_id)
         return paired, local_vol_state, rdf_pair_state
 
-    def wait_for_rdf_consistent_state(
-            self, array, remote_array, device_id, target_device, extra_specs):
-        """Wait for async pair to be in a consistent state before suspending.
+    def wait_for_rdf_group_sync(self, array, storage_group, rdf_group_no,
+                                rep_extra_specs):
+        """Wait for an RDF group to reach 'Synchronised' state.
 
         :param array: the array serial number
-        :param remote_array: the remote array serial number
-        :param device_id: the device id
-        :param target_device: the target device id
-        :param extra_specs: the extra specifications
+        :param storage_group: the storage group name
+        :param rdf_group_no: the RDF group number
+        :param rep_extra_specs: replication extra specifications
+        :raises: exception.VolumeBackendAPIException
         """
+        def _wait_for_synced_state():
+            try:
+                kwargs['retries'] -= 1
+                if not kwargs['synced']:
+                    rdf_group_state = self.get_storage_group_rdf_group_state(
+                        array, storage_group, rdf_group_no)
+                    if rdf_group_state:
+                        kwargs['state'] = rdf_group_state[0]
+                        if kwargs['state'].lower() in utils.RDF_SYNCED_STATES:
+                            kwargs['synced'] = True
+                            kwargs['rc'] = 0
+            except Exception as e_msg:
+                ex_msg = _("Issue encountered waiting for job: %(e)s" % {
+                    'e': e_msg})
+                LOG.error(ex_msg)
+                raise exception.VolumeBackendAPIException(message=ex_msg)
+            if kwargs['retries'] == 0:
+                ex_msg = _("Wait for RDF Sync State failed after %(r)d "
+                           "tries." % {'r': rep_extra_specs['sync_retries']})
+                LOG.error(ex_msg)
+                raise exception.VolumeBackendAPIException(message=ex_msg)
 
-        def _wait_for_consistent_state():
-            # Called at an interval until the state of the
-            # rdf pair is 'consistent'.
-            retries = kwargs['retries']
+            if kwargs['synced']:
+                raise loopingcall.LoopingCallDone()
+
+        kwargs = {'retries': rep_extra_specs['sync_retries'],
+                  'synced': False, 'rc': 0, 'state': 'syncinprog'}
+
+        timer = loopingcall.FixedIntervalLoopingCall(_wait_for_synced_state)
+        timer.start(interval=rep_extra_specs['sync_interval']).wait()
+        LOG.debug("Return code is: %(rc)lu. State is %(state)s",
+                  {'rc': kwargs['rc'], 'state': kwargs['state']})
+
+    def wait_for_rdf_pair_sync(self, array, rdf_group_no, device_id,
+                               rep_extra_specs):
+        """Wait for an RDF device pair to reach 'Synchronised' state.
+
+        :param array: the array serial number
+        :param rdf_group_no: the RDF group number
+        :param device_id: the source device ID
+        :param rep_extra_specs: replication extra specifications
+        :raises: exception.VolumeBackendAPIException
+        """
+        def _wait_for_synced_state():
             try:
-                kwargs['retries'] = retries + 1
-                if not kwargs['consistent_state']:
-                    __, __, state = (
-                        self.are_vols_rdf_paired(
-                            array, remote_array, device_id, target_device))
-                    kwargs['state'] = state
-                    if state.lower() == utils.RDF_CONSISTENT_STATE:
-                        kwargs['consistent_state'] = True
+                kwargs['retries'] -= 1
+                if not kwargs['synced']:
+                    rdf_pair = self.get_rdf_pair_volume(array, rdf_group_no,
+                                                        device_id)
+                    kwargs['state'] = rdf_pair['rdfpairState']
+
+                    if kwargs['state'].lower() in utils.RDF_SYNCED_STATES:
+                        kwargs['synced'] = True
                         kwargs['rc'] = 0
-            except Exception:
-                exception_message = _("Issue encountered waiting for job.")
-                LOG.exception(exception_message)
-                raise exception.VolumeBackendAPIException(
-                    message=exception_message)
 
-            if retries > int(extra_specs[utils.RETRIES]):
-                LOG.error("_wait_for_consistent_state failed after "
-                          "%(retries)d tries.", {'retries': retries})
-                kwargs['rc'] = -1
+            except Exception as e_msg:
+                ex_msg = _("Issue encountered waiting for job: %(e)s" % {
+                    'e': e_msg})
+                LOG.error(ex_msg)
+                raise exception.VolumeBackendAPIException(message=ex_msg)
+
+            if kwargs['retries'] == 0:
+                ex_msg = _("Wait for RDF Sync State failed after %(r)d "
+                           "tries." % {'r': rep_extra_specs['sync_retries']})
+                LOG.error(ex_msg)
+                raise exception.VolumeBackendAPIException(message=ex_msg)
 
-                raise loopingcall.LoopingCallDone()
-            if kwargs['consistent_state']:
+            if kwargs['synced']:
                 raise loopingcall.LoopingCallDone()
 
-        kwargs = {'retries': 0, 'consistent_state': False,
-                  'rc': 0, 'state': 'syncinprog'}
+        kwargs = {'retries': rep_extra_specs['sync_retries'],
+                  'synced': False, 'rc': 0, 'state': 'syncinprog'}
 
-        timer = loopingcall.FixedIntervalLoopingCall(
-            _wait_for_consistent_state)
-        timer.start(interval=int(extra_specs[utils.INTERVAL])).wait()
+        timer = loopingcall.FixedIntervalLoopingCall(_wait_for_synced_state)
+        timer.start(interval=rep_extra_specs['sync_interval']).wait()
         LOG.debug("Return code is: %(rc)lu. State is %(state)s",
                   {'rc': kwargs['rc'], 'state': kwargs['state']})
 
+    def rdf_resume_with_retries(self, array, rep_extra_specs):
+        """Resume RDF on a RDF group with retry operator included.
+
+        The retry operator is required here because on occassion when we are
+        waiting on a snap copy session to complete we have no way of
+        determining if the copy is complete, operation is retried until
+        either the copy completes or the max interval/retries has been met.
+
+        :param array: the array serial number
+        :param rep_extra_specs: replication extra specifications
+        :raises: exception.VolumeBackendAPIException
+        """
+
+        def wait_for_copy_complete():
+            kwargs['retries'] -= 1
+            if not kwargs['copied']:
+                try:
+                    self.srdf_resume_replication(
+                        array, rep_extra_specs['sg_name'],
+                        rep_extra_specs['rdf_group_no'], rep_extra_specs,
+                        async_call=False)
+                    kwargs['copied'] = True
+                    kwargs['state'] = 'copy_complete'
+                    kwargs['rc'] = 0
+                    raise loopingcall.LoopingCallDone()
+
+                except exception.VolumeBackendAPIException:
+                    LOG.debug('Snapshot copy process still ongoing, Cinder '
+                              'will retry again in %(interval)s seconds. '
+                              'There are %(retries)s remaining.', {
+                                  'interval': rep_extra_specs['sync_interval'],
+                                  'retries': kwargs['retries']})
+
+            if kwargs['retries'] == 0:
+                ex_msg = _("Wait for snapshot copy complete failed after "
+                           "%(r)d tries." % {
+                               'r': rep_extra_specs['sync_retries']})
+                LOG.error(ex_msg)
+                raise exception.VolumeBackendAPIException(message=ex_msg)
+
+        kwargs = {'retries': rep_extra_specs['sync_retries'],
+                  'copied': False, 'rc': 0, 'state': 'copy_in_progress'}
+
+        timer = loopingcall.FixedIntervalLoopingCall(wait_for_copy_complete)
+        timer.start(interval=rep_extra_specs['sync_interval']).wait()
+        LOG.debug("Return code: %(rc)lu. State: %(state)s",
+                  {'rc': kwargs['rc'], 'state': kwargs['state']})
+
     def get_rdf_group_number(self, array, rdf_group_label):
         """Given an rdf_group_label, return the associated group number.
 
@@ -2267,156 +2481,300 @@ class PowerMaxRest(object):
                 number = None
         return number
 
-    @coordination.synchronized('emc-rg-{rdf_group_no}')
-    def create_rdf_device_pair(self, array, device_id, rdf_group_no,
-                               target_device, remote_array, extra_specs):
-        """Create an RDF pairing.
-
-        Create a remote replication relationship between source and target
-        devices.
-        :param array: the array serial number
-        :param device_id: the device id
-        :param rdf_group_no: the rdf group number
-        :param target_device: the target device id
-        :param remote_array: the remote array serial
-        :param extra_specs: the extra specs
-        :returns: rdf_dict
-        """
-        rep_mode = extra_specs[utils.REP_MODE]
-        if rep_mode == utils.REP_METRO:
-            rep_mode = 'Active'
-        payload = ({"deviceNameListSource": [{"name": device_id}],
-                    "deviceNameListTarget": [{"name": target_device}],
-                    "replicationMode": rep_mode,
-                    "establish": 'true',
-                    "rdfType": 'RDF1'})
-        if rep_mode == utils.REP_ASYNC:
-            payload_update = self._get_async_payload_info(array, rdf_group_no)
-            payload.update(payload_update)
-        elif rep_mode == 'Active':
-            # Check if arrays are next gen to support add data vol to existing
-            # metro enabled rdfg, else format drive before adding
-            r1_nxt_gen = self.is_next_gen_array(array)
-            r2_nxt_gen = self.is_next_gen_array(remote_array)
-            if r1_nxt_gen and r2_nxt_gen:
-                extra_specs[utils.RDF_CONS_EXEMPT] = True
-            else:
-                extra_specs[utils.RDF_CONS_EXEMPT] = False
-            payload = self.get_metro_payload_info(
-                array, payload, rdf_group_no, extra_specs)
-        resource_type = ("rdf_group/%(rdf_num)s/volume"
-                         % {'rdf_num': rdf_group_no})
-        status_code, job = self.create_resource(array, REPLICATION,
-                                                resource_type, payload,
-                                                private="/private")
-        self.wait_for_job('Create rdf pair', status_code,
-                          job, extra_specs)
-        rdf_dict = {'array': remote_array, 'device_id': target_device}
-        return rdf_dict
-
     def _get_async_payload_info(self, array, rdf_group_no):
         """Get the payload details for an async create pair.
 
         :param array: the array serial number
         :param rdf_group_no: the rdf group number
-        :return: payload_update
+        :returns: payload_update
         """
         num_vols, payload_update = 0, {}
         rdfg_details = self.get_rdf_group(array, rdf_group_no)
         if rdfg_details is not None and rdfg_details.get('numDevices'):
             num_vols = int(rdfg_details['numDevices'])
         if num_vols > 0:
-            payload_update = {'consExempt': 'true'}
+            payload_update = {'exempt': 'true'}
         return payload_update
 
     def get_metro_payload_info(self, array, payload,
-                               rdf_group_no, extra_specs):
+                               rdf_group_no, extra_specs, next_gen):
         """Get the payload details for a metro active create pair.
 
         :param array: the array serial number
         :param payload: the payload
         :param rdf_group_no: the rdf group number
         :param extra_specs: the replication configuration
-        :return: updated payload
+        :param next_gen: if the array is next gen uCode
+        :returns: updated payload
         """
         num_vols = 0
+        payload["rdfMode"] = "Active"
+        payload['rdfType'] = "RDF1"
+
         rdfg_details = self.get_rdf_group(array, rdf_group_no)
         if rdfg_details is not None and rdfg_details.get('numDevices'):
             num_vols = int(rdfg_details['numDevices'])
+
         if num_vols == 0:
             # First volume - set bias if required
-            if (extra_specs.get(utils.METROBIAS)
-                    and extra_specs[utils.METROBIAS] is True):
-                payload.update({'metroBias': 'true'})
+            if extra_specs.get(utils.METROBIAS):
+                payload.update({"metroBias": "true"})
         else:
-            if (extra_specs.get(utils.RDF_CONS_EXEMPT)
-                    and extra_specs[utils.RDF_CONS_EXEMPT] is True):
-                payload['consExempt'] = 'true'
-                payload['rdfType'] = 'RDF1'
-            else:
-                LOG.warning("Adding HyperMax OS volumes to an existing RDFG "
-                            "requires the volumes to be formatted in advance,"
-                            "please upgrade to PowerMax OS to bypass this "
-                            "restriction.")
-                payload['format'] = 'true'
-                payload['rdfType'] = 'NA'
-
-            payload.pop('establish')
+            if next_gen:
+                payload["exempt"] = "true"
+            if payload.get('establish'):
+                payload.pop('establish')
         return payload
 
-    def modify_rdf_device_pair(
-            self, array, device_id, rdf_group, extra_specs, suspend=False):
-        """Modify an rdf device pair.
+    def srdf_protect_storage_group(
+            self, array_id, remote_array_id, rdf_group_no, replication_mode,
+            sg_name, service_level, extra_specs, target_sg=None):
+        """SRDF protect a storage group.
+
+        :param array_id: local array serial number
+        :param remote_array_id: remote array serial number
+        :param rdf_group_no: RDF group number
+        :param replication_mode: replication mode
+        :param sg_name: storage group name
+        :param service_level: service level
+        :param extra_specs: extra specifications
+        :param target_sg: target storage group -- optional
+        """
+        remote_sg = target_sg if target_sg else sg_name
 
-        :param array: the array serial number
-        :param device_id: the device id
-        :param rdf_group: the rdf group
-        :param extra_specs: the extra specs
-        :param suspend: flag to indicate "suspend" action
-        """
-        common_opts = {"force": 'false',
-                       "symForce": 'false',
-                       "star": 'false',
-                       "hop2": 'false',
-                       "bypass": 'false'}
-        if suspend:
-            if (extra_specs.get(utils.REP_MODE)
-                    and extra_specs[utils.REP_MODE] == utils.REP_ASYNC):
-                common_opts.update({"immediate": 'false',
-                                    "consExempt": 'true'})
-            payload = {"action": "SUSPEND",
-                       "executionOption": "ASYNCHRONOUS",
-                       "suspend": common_opts}
+        payload = {
+            "executionOption": "ASYNCHRONOUS",
+            "replicationMode": replication_mode, "remoteSLO": service_level,
+            "remoteSymmId": remote_array_id, "rdfgNumber": rdf_group_no,
+            "remoteStorageGroupName": remote_sg, "establish": "true"}
+
+        # Metro specific configuration
+        if replication_mode == utils.REP_METRO:
+            bias = "true" if extra_specs[utils.METROBIAS] else "False"
+            payload.update({
+                "replicationMode": "Active", "metroBias": bias})
+
+        LOG.debug('SRDF Protect Payload: %(pay)s', {'pay': payload})
+        resource = 'storagegroup/%(sg_name)s/rdf_group' % {'sg_name': sg_name}
+        status_code, job = self.create_resource(array_id, REPLICATION,
+                                                resource, payload)
+        self.wait_for_job('SRDF Protect Storage Group', status_code,
+                          job, extra_specs)
+
+    def srdf_modify_group(self, array, rdf_group_no, storage_group, payload,
+                          extra_specs, msg, async_call=True):
+        """Modify RDF enabled storage group replication options.
 
+        :param array: array serial number
+        :param rdf_group_no: RDF group number
+        :param storage_group: storage group name
+        :param payload: REST request payload dict
+        :param extra_specs: extra specifications
+        :param msg: message to use for logs when waiting on job to complete
+        :param async_call: if the REST call should be run, this only comes into
+                           effect when trying to resume replication and
+                           interval/retries are a factor.
+        """
+        resource = ('storagegroup/%(sg_name)s/rdf_group/%(rdf_group_no)s' % {
+            'sg_name': storage_group, 'rdf_group_no': rdf_group_no})
+
+        if async_call:
+            payload.update({"executionOption": "ASYNCHRONOUS"})
+            status_code, job = self.modify_resource(array, REPLICATION,
+                                                    resource, payload)
+            self.wait_for_job(msg, status_code, job, extra_specs)
         else:
-            common_opts.update({"establish": 'true',
-                                "restore": 'false',
-                                "remote": 'false',
-                                "immediate": 'false'})
-            payload = {"action": "Failover",
-                       "executionOption": "ASYNCHRONOUS",
-                       "failover": common_opts}
-        resource_name = ("%(rdf_num)s/volume/%(device_id)s"
-                         % {'rdf_num': rdf_group, 'device_id': device_id})
-        sc, job = self.modify_resource(
-            array, REPLICATION, 'rdf_group',
-            payload, resource_name=resource_name, private="/private")
-        self.wait_for_job('Modify device pair', sc,
-                          job, extra_specs)
+            self.modify_resource(array, REPLICATION, resource, payload)
 
-    def delete_rdf_pair(self, array, device_id, rdf_group):
-        """Delete an rdf pair.
+    def srdf_suspend_replication(self, array_id, storage_group, rdf_group_no,
+                                 rep_extra_specs):
+        """Suspend replication on a RDF group.
+
+        :param array_id: array serial number
+        :param storage_group: storage group name
+        :param rdf_group_no: RDF group number
+        :param rep_extra_specs: replication extra specifications
+        """
+        group_state = self.get_storage_group_rdf_group_state(
+            array_id, storage_group, rdf_group_no)
+
+        if group_state:
+            group_state = [x.lower() for x in group_state]
+
+        if utils.RDF_SUSPENDED_STATE not in group_state:
+            self.srdf_modify_group(
+                array_id, rdf_group_no, storage_group,
+                {"suspend": {"force": "true"}, "action": "Suspend"},
+                rep_extra_specs, 'Suspend SRDF Group Replication')
+        else:
+            LOG.info('SRDF Group %(grp_num)s is already in a suspended state',
+                     {'grp_num': rdf_group_no})
 
-        :param array: the array serial number
-        :param device_id: the device id
-        :param rdf_group: the rdf group
+    def srdf_resume_replication(self, array_id, storage_group, rdf_group_no,
+                                rep_extra_specs, async_call=True):
+        """Resume replication on a RDF group.
+
+        :param array_id: array serial number
+        :param storage_group: storage group name
+        :param rdf_group_no: RDF group number
+        :param rep_extra_specs: replication extra specifications
+        :param async_call: if the REST call should be run, this only comes into
+                           effect when trying to resume replication and
+                           interval/retries are a factor.
+        """
+        if self.get_storage_group(array_id, storage_group):
+            group_state = self.get_storage_group_rdf_group_state(
+                array_id, storage_group, rdf_group_no)
+            if group_state:
+                group_state = [x.lower() for x in group_state]
+            if utils.RDF_SUSPENDED_STATE in group_state:
+                payload = {"action": "Resume"}
+                if rep_extra_specs['rep_mode'] == utils.REP_METRO:
+                    payload = {"action": "Establish"}
+                    if rep_extra_specs.get(utils.METROBIAS):
+                        payload.update({"establish": {"metroBias": "true"}})
+
+                self.srdf_modify_group(
+                    array_id, rdf_group_no, storage_group, payload,
+                    rep_extra_specs, 'Resume SRDF Group Replication',
+                    async_call)
+            else:
+                LOG.debug('SRDF Group %(grp_num)s is already in a resumed '
+                          'state.', {'grp_num': rdf_group_no})
+        else:
+            LOG.debug('Storage Group %(sg)s not present on array '
+                      '%(array)s, no resume required.', {
+                          'sg': storage_group, 'array': array_id})
+
+    def srdf_establish_replication(self, array_id, storage_group, rdf_group_no,
+                                   rep_extra_specs):
+        """Establish replication on a RDF group.
+
+        :param array_id: array serial number
+        :param storage_group: storage group name
+        :param rdf_group_no: RDF group number
+        :param rep_extra_specs: replication extra specifications
+        """
+        group_state = self.get_storage_group_rdf_group_state(
+            array_id, storage_group, rdf_group_no)
+
+        if utils.RDF_SUSPENDED_STATE not in group_state:
+            LOG.info('Suspending SRDF Group %(grp_num)s', {
+                'grp_num': rdf_group_no})
+            self.srdf_modify_group(
+                array_id, rdf_group_no, storage_group, {"action": "Suspend"},
+                rep_extra_specs, 'Suspend SRDF Group Replication')
+
+        wait_msg = 'Incremental Establish SRDF Group Replication'
+        LOG.info('Initiating incremental establish on SRDF Group %(grp_num)s',
+                 {'grp_num': rdf_group_no})
+        self.srdf_modify_group(
+            array_id, rdf_group_no, storage_group, {"action": "Establish"},
+            rep_extra_specs, wait_msg)
+
+    def srdf_failover_group(self, array_id, storage_group, rdf_group_no,
+                            rep_extra_specs):
+        """Failover a RDFG/SG volume group to replication target.
+
+        :param array_id: array serial number
+        :param storage_group: storage group name
+        :param rdf_group_no: RDF group number
+        :param rep_extra_specs: replication extra specifications
+        """
+        self.srdf_modify_group(
+            array_id, rdf_group_no, storage_group, {"action": "Failover"},
+            rep_extra_specs, 'Failing over SRDF group replication')
+
+    def srdf_failback_group(self, array_id, storage_group, rdf_group_no,
+                            rep_extra_specs):
+        """Failback a RDFG/SG volume group from replication target.
+
+        :param array_id:
+        :param storage_group:
+        :param rdf_group_no:
+        :param rep_extra_specs:
+        """
+        self.srdf_modify_group(
+            array_id, rdf_group_no, storage_group, {"action": "Failback"},
+            rep_extra_specs, 'Failing back SRDF group replication')
+
+    def srdf_remove_device_pair_from_storage_group(
+            self, array_id, storage_group, remote_array_id, device_id,
+            rep_extra_specs):
+        """Remove a volume from local and remote storage groups simultaneously.
+
+        :param array_id: local array serial number
+        :param storage_group: storage group name
+        :param remote_array_id: remote array serial number
+        :param device_id: source device id
+        :param rep_extra_specs: replication extra specifications
+        """
+        payload = {
+            "editStorageGroupActionParam": {
+                "removeVolumeParam": {
+                    "volumeId": [device_id],
+                    "remoteSymmSGInfoParam": {
+                        "remote_symmetrix_1_id": remote_array_id,
+                        "remote_symmetrix_1_sgs": [storage_group]}}}}
+
+        status_code, job = self.modify_storage_group(array_id, storage_group,
+                                                     payload)
+        self.wait_for_job('SRDF Group remove device pair', status_code,
+                          job, rep_extra_specs)
+
+    def srdf_delete_device_pair(self, array, rdf_group_no, local_device_id):
+        """Delete a RDF device pair.
+
+        :param array: array serial number
+        :param rdf_group_no: RDF group number
+        :param local_device_id: local device id
         """
-        params = {'half': 'false', 'force': 'true', 'symforce': 'false',
-                  'star': 'false', 'bypass': 'false'}
-        resource_name = ("%(rdf_num)s/volume/%(device_id)s"
-                         % {'rdf_num': rdf_group, 'device_id': device_id})
-        self.delete_resource(array, REPLICATION, 'rdf_group', resource_name,
-                             params=params)
+        resource = ('%(rdfg)s/volume/%(dev)s' % {
+            'rdfg': rdf_group_no, 'dev': local_device_id})
+
+        self.delete_resource(array, REPLICATION, 'rdf_group', resource)
+        LOG.debug("Device Pair successfully deleted.")
+
+    def srdf_create_device_pair(self, array, rdf_group_no, mode, device_id,
+                                rep_extra_specs, next_gen):
+        """Create a RDF device pair in an existing RDF group.
+
+        :param array: array serial number
+        :param rdf_group_no: RDF group number
+        :param mode: replication mode
+        :param device_id: local device ID
+        :param rep_extra_specs: replication extra specifications
+        :param next_gen: if the array is next gen uCode
+        :returns: replication session info -- dict
+        """
+        payload = {
+            "executionOption": "ASYNCHRONOUS", "rdfMode": mode,
+            "localDeviceListCriteriaParam": {"localDeviceList": [device_id]},
+            "rdfType": "RDF1"}
+
+        if mode == utils.REP_SYNC:
+            payload.update({"establish": "true"})
+        elif mode == utils.REP_ASYNC:
+            payload.update({"invalidateR2": "true", "exempt": "true"})
+        elif mode.lower() in [utils.REP_METRO.lower(),
+                              utils.RDF_ACTIVE.lower()]:
+            payload = self.get_metro_payload_info(
+                array, payload, rdf_group_no, rep_extra_specs, next_gen)
+
+        LOG.debug('Create Pair Payload: %(pay)s', {'pay': payload})
+        resource = 'rdf_group/%(rdfg)s/volume' % {'rdfg': rdf_group_no}
+        status_code, job = self.create_resource(
+            array, REPLICATION, resource, payload)
+        self.wait_for_job('SRDF Group remove device pair', status_code,
+                          job, rep_extra_specs)
+
+        session_info = self.get_rdf_pair_volume(array, rdf_group_no, device_id)
+        r2_device_id = session_info['remoteVolumeName']
+
+        return {'array': session_info['localSymmetrixId'],
+                'remote_array': session_info['remoteSymmetrixId'],
+                'src_device': device_id, 'tgt_device': r2_device_id,
+                'session_info': session_info}
 
     def get_storage_group_rep(self, array, storage_group_name):
         """Given a name, return storage group details wrt replication.
@@ -2461,6 +2819,43 @@ class PowerMaxRest(object):
         self.wait_for_job('Create storage group snapVx', status_code,
                           job, extra_specs)
 
+    def delete_storagegroup_snap(self, array, source_group,
+                                 snap_name, generation='0'):
+        """Delete a snapVx snapshot of a storage group.
+
+        :param array: the array serial number
+        :param source_group: the source group name
+        :param snap_name: the name of the snapshot
+        :param generation: the generation number of the SnapVX
+        """
+        resource_name = ("%(sg_name)s/snapshot/%(snap_name)s"
+                         "/generation/%(generation)s"
+                         % {'sg_name': source_group, 'snap_name': snap_name,
+                            'generation': generation})
+
+        self.delete_resource(
+            array, REPLICATION, 'storagegroup', resource_name=resource_name)
+
+    def get_storagegroup_snap_generation_list(
+            self, array, source_group, snap_name):
+        """Get a snapshot and its generation count information for an sg.
+
+        The most recent snapshot will have a gen number of 0. The oldest
+        snapshot will have a gen number = genCount - 1 (i.e. if there are 4
+        generations of particular snapshot, the oldest will have a gen num of
+        3).
+
+        :param array: name of the array -- str
+        :param source_group: name of the storage group -- str
+        :param snap_name: the name of the snapshot -- str
+        :returns: generation numbers -- list
+        """
+        resource_name = ("%(sg_name)s/snapshot/%(snap_name)s/generation"
+                         % {'sg_name': source_group, 'snap_name': snap_name})
+        response = self.get_resource(array, REPLICATION, 'storagegroup',
+                                     resource_name=resource_name)
+        return response.get('generations', list()) if response else list()
+
     def get_storagegroup_rdf_details(self, array, storagegroup_name,
                                      rdf_group_num):
         """Get the remote replication details of a storage group.
@@ -2531,40 +2926,6 @@ class PowerMaxRest(object):
                     break
         return mod_rqd
 
-    def modify_storagegroup_rdf(self, array, storagegroup_name,
-                                rdf_group_num, action, extra_specs):
-        """Modify the rdf state of a storage group.
-
-        :param array: the array serial number
-        :param storagegroup_name: the name of the storage group
-        :param rdf_group_num: the number of the rdf group
-        :param action: the required action
-        :param extra_specs: the extra specifications
-        """
-        # Check if group is in valid state for desired action
-        mod_reqd = self._verify_rdf_state(array, storagegroup_name,
-                                          rdf_group_num, action)
-        if mod_reqd:
-            payload = {"executionOption": "ASYNCHRONOUS", "action": action}
-            if action.lower() == 'suspend':
-                payload['suspend'] = {"force": "true"}
-            elif action.lower() == 'establish':
-                metro_bias = (
-                    True if extra_specs.get(utils.METROBIAS) and extra_specs[
-                        utils.METROBIAS] is True else False)
-                payload['establish'] = {"metroBias": metro_bias,
-                                        "full": 'false'}
-            resource_name = ('%(sg_name)s/rdf_group/%(rdf_num)s'
-                             % {'sg_name': storagegroup_name,
-                                'rdf_num': rdf_group_num})
-
-            status_code, job = self.modify_resource(
-                array, REPLICATION, 'storagegroup', payload,
-                resource_name=resource_name)
-
-            self.wait_for_job('Modify storagegroup rdf',
-                              status_code, job, extra_specs)
-
     def delete_storagegroup_rdf(self, array, storagegroup_name,
                                 rdf_group_num):
         """Delete the rdf pairs for a storage group.
@@ -2583,7 +2944,7 @@ class PowerMaxRest(object):
         """Process lists under or over the maxPageSize
 
         :param list_info: the object list information
-        :return: the result list
+        :returns: the result list
         """
         result_list = []
         try:
@@ -2620,7 +2981,7 @@ class PowerMaxRest(object):
         :param start_position: position to begin iterator from
         :param end_position: position to stop iterator
         :param max_page_size: the max page size
-        :return: list -- merged results from multiple pages
+        :returns: list -- merged results from multiple pages
         """
         iterator_result = []
         has_more_entries = True
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/powermax/utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/powermax/utils.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/powermax/utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/powermax/utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -18,7 +18,6 @@ import datetime
 import hashlib
 import re
 
-from cinder.objects.group import Group
 from oslo_log import log as logging
 from oslo_utils import strutils
 from oslo_utils import units
@@ -27,6 +26,7 @@ import six
 from cinder import exception
 from cinder.i18n import _
 from cinder.objects import fields
+from cinder.objects.group import Group
 from cinder.volume import volume_types
 from cinder.volume import volume_utils
 
@@ -44,8 +44,11 @@ TRUNCATE_5 = 5
 TRUNCATE_27 = 27
 UCODE_5978_ELMSR = 221
 UCODE_5978 = 5978
+UPPER_HOST_CHARS = 16
+UPPER_PORT_GROUP_CHARS = 12
 
 ARRAY = 'array'
+REMOTE_ARRAY = 'remote_array'
 SLO = 'slo'
 WORKLOAD = 'workload'
 SRP = 'srp'
@@ -53,6 +56,7 @@ PORTGROUPNAME = 'storagetype:portgroupna
 DEVICE_ID = 'device_id'
 INITIATOR_CHECK = 'initiator_check'
 SG_NAME = 'storagegroup_name'
+SG_ID = 'storageGroupId'
 MV_NAME = 'maskingview_name'
 IG_NAME = 'init_group_name'
 PARENT_SG_NAME = 'parent_sg_name'
@@ -74,10 +78,18 @@ RDF_FAILEDOVER_STATE = 'failed over'
 RDF_ACTIVE = 'active'
 RDF_ACTIVEACTIVE = 'activeactive'
 RDF_ACTIVEBIAS = 'activebias'
-RDF_CONS_EXEMPT = 'consExempt'
+RDF_CONS_EXEMPT = 'exempt'
+RDF_ALLOW_METRO_DELETE = 'allow_delete_metro'
+RDF_GROUP_NO = 'rdf_group_number'
 METROBIAS = 'metro_bias'
 DEFAULT_PORT = 8443
 CLONE_SNAPSHOT_NAME = "snapshot_for_clone"
+STORAGE_GROUP_TAGS = 'storagetype:storagegrouptags'
+TAG_LIST = 'tag_list'
+USED_HOST_NAME = "used_host_name"
+RDF_SYNCED_STATES = [RDF_SYNC_STATE, RDF_CONSISTENT_STATE,
+                     RDF_ACTIVEACTIVE, RDF_ACTIVEBIAS]
+FORCE_VOL_REMOVE = 'force_vol_remove'
 
 # Multiattach constants
 IS_MULTIATTACH = 'multiattach'
@@ -109,6 +121,10 @@ POWERMAX_SRP = 'powermax_srp'
 POWERMAX_SERVICE_LEVEL = 'powermax_service_level'
 POWERMAX_PORT_GROUPS = 'powermax_port_groups'
 POWERMAX_SNAPVX_UNLINK_LIMIT = 'powermax_snapvx_unlink_limit'
+POWERMAX_ARRAY_TAG_LIST = 'powermax_array_tag_list'
+POWERMAX_SHORT_HOST_NAME_TEMPLATE = 'powermax_short_host_name_template'
+POWERMAX_PORT_GROUP_NAME_TEMPLATE = 'powermax_port_group_name_template'
+PORT_GROUP_LABEL = 'port_group_label'
 
 
 class PowerMaxUtils(object):
@@ -130,13 +146,27 @@ class PowerMaxUtils(object):
         :param host_name: the fully qualified host name
         :returns: string -- the short host_name
         """
+        short_host_name = self.get_host_short_name_from_fqn(host_name)
+
+        return self.generate_unique_trunc_host(short_host_name)
+
+    @staticmethod
+    def get_host_short_name_from_fqn(host_name):
+        """Returns the short name for a given qualified host name.
+
+        Checks the host name to see if it is the fully qualified host name
+        and returns part before the dot. If there is no dot in the host name
+        the full host name is returned.
+        :param host_name: the fully qualified host name
+        :returns: string -- the short host_name
+        """
         host_array = host_name.split('.')
         if len(host_array) > 1:
             short_host_name = host_array[0]
         else:
             short_host_name = host_name
 
-        return self.generate_unique_trunc_host(short_host_name)
+        return short_host_name
 
     @staticmethod
     def get_volumetype_extra_specs(volume, volume_type_id=None):
@@ -262,7 +292,7 @@ class PowerMaxUtils(object):
         :param snapshot_name: the old snapshot backend display name
         :param manage: (bool) if the operation is managing a snapshot
         :param unmanage: (bool) if the operation is unmanaging a snapshot
-        :return: snapshot name ready for backend PowerMax/VMAX assignment
+        :returns: snapshot name ready for backend PowerMax/VMAX assignment
         """
         new_snap_name = None
         if manage:
@@ -283,15 +313,12 @@ class PowerMaxUtils(object):
         :param host_name: long host name
         :returns: truncated host name
         """
-        if host_name and len(host_name) > 16:
-            host_name = host_name.lower()
-            m = hashlib.md5()
-            m.update(host_name.encode('utf-8'))
-            uuid = m.hexdigest()
+        if host_name and len(host_name) > UPPER_HOST_CHARS:
+            uuid = self.get_uuid_of_input(host_name)
             new_name = ("%(host)s%(uuid)s"
                         % {'host': host_name[-6:],
                            'uuid': uuid})
-            host_name = self.truncate_string(new_name, 16)
+            host_name = self.truncate_string(new_name, UPPER_HOST_CHARS)
         return host_name
 
     def get_pg_short_name(self, portgroup_name):
@@ -300,18 +327,28 @@ class PowerMaxUtils(object):
         :param portgroup_name: long portgroup_name
         :returns: truncated portgroup_name
         """
-        if portgroup_name and len(portgroup_name) > 12:
-            portgroup_name = portgroup_name.lower()
-            m = hashlib.md5()
-            m.update(portgroup_name.encode('utf-8'))
-            uuid = m.hexdigest()
+        if portgroup_name and len(portgroup_name) > UPPER_PORT_GROUP_CHARS:
+            uuid = self.get_uuid_of_input(portgroup_name)
             new_name = ("%(pg)s%(uuid)s"
                         % {'pg': portgroup_name[-6:],
                            'uuid': uuid})
-            portgroup_name = self.truncate_string(new_name, 12)
+            portgroup_name = self.truncate_string(
+                new_name, UPPER_PORT_GROUP_CHARS)
         return portgroup_name
 
     @staticmethod
+    def get_uuid_of_input(input_str):
+        """Get the uuid of the input string
+
+        :param input_str: input string
+        :returns: uuid
+        """
+        input_str = input_str.lower()
+        m = hashlib.md5()
+        m.update(input_str.encode('utf-8'))
+        return m.hexdigest()
+
+    @staticmethod
     def get_default_oversubscription_ratio(max_over_sub_ratio):
         """Override ratio if necessary.
 
@@ -331,7 +368,7 @@ class PowerMaxUtils(object):
         """Construct a temporary snapshot name for clone operation
 
         :param source_device_id: the source device id
-        :return: snap_name
+        :returns: snap_name
         """
         snap_name = ("temp-%(device)s-%(snap_name)s"
                      % {'device': source_device_id,
@@ -404,7 +441,7 @@ class PowerMaxUtils(object):
 
         :param vol_is_replicated: from source
         :param new_type: from target
-        :return: bool
+        :returns: bool
         """
         is_tgt_rep = self.is_replication_enabled(new_type['extra_specs'])
         return vol_is_replicated != is_tgt_rep
@@ -447,6 +484,17 @@ class PowerMaxUtils(object):
                 raise exception.VolumeBackendAPIException(
                     message=error_message)
 
+            try:
+                rep_config['sync_retries'] = int(target['sync_retries'])
+                rep_config['sync_interval'] = int(target['sync_interval'])
+            except (KeyError, ValueError) as ke:
+                LOG.debug("SRDF Sync wait/retries options not set or set "
+                          "incorrectly, defaulting to 200 retries with a 3 "
+                          "second wait. Configuration load warning: %(ke)s.",
+                          {'ke': six.text_type(ke)})
+                rep_config['sync_retries'] = 200
+                rep_config['sync_interval'] = 3
+
             allow_extend = target.get('allow_extend', 'false')
             if strutils.bool_from_string(allow_extend):
                 rep_config['allow_extend'] = True
@@ -463,11 +511,6 @@ class PowerMaxUtils(object):
                     rep_config[METROBIAS] = True
                 else:
                     rep_config[METROBIAS] = False
-                allow_delete_metro = target.get('allow_delete_metro', 'false')
-                if strutils.bool_from_string(allow_delete_metro):
-                    rep_config['allow_delete_metro'] = True
-                else:
-                    rep_config['allow_delete_metro'] = False
             else:
                 rep_config['mode'] = REP_SYNC
 
@@ -603,7 +646,7 @@ class PowerMaxUtils(object):
         """Add legacy pools to allow extending a volume after upgrade.
 
         :param pools: the pool list
-        :return: pools - the updated pool list
+        :returns: pools - the updated pool list
         """
         extra_pools = []
         for pool in pools:
@@ -677,7 +720,7 @@ class PowerMaxUtils(object):
         synchronous, asynchronous, or metro replication mode.
 
         :param rep_mode: flag to indicate if replication is async
-        :return: prefix
+        :returns: prefix
         """
         if rep_mode == REP_ASYNC:
             prefix = "-RA"
@@ -688,11 +731,11 @@ class PowerMaxUtils(object):
         return prefix
 
     @staticmethod
-    def get_async_rdf_managed_grp_name(rep_config):
+    def get_rdf_management_group_name(rep_config):
         """Get the name of the group used for async replication management.
 
         :param rep_config: the replication configuration
-        :return: group name
+        :returns: group name
         """
         async_grp_name = ("OS-%(rdf)s-%(mode)s-rdf-sg"
                           % {'rdf': rep_config['rdf_group_label'],
@@ -706,7 +749,7 @@ class PowerMaxUtils(object):
 
         :param rep_config: the replication configuration
         :param extra_specs: the extra specifications
-        :return: bool
+        :returns: bool
         """
         is_metro = (True if self.is_replication_enabled(extra_specs)
                     and rep_config is not None
@@ -717,7 +760,7 @@ class PowerMaxUtils(object):
         """Determine if a volume is a Metro or Async.
 
         :param extra_specs: the extra specifications
-        :return: bool
+        :returns: bool
         """
         if (self.is_replication_enabled(extra_specs) and
                 extra_specs.get(REP_MODE, None) in
@@ -729,6 +772,7 @@ class PowerMaxUtils(object):
         """Get the name of the default sg from the extra specs.
 
         :param extra_specs: extra specs
+        :param rep_mode: replication mode
         :returns: default sg - string
         """
         do_disable_compression = self.is_compression_disabled(
@@ -760,7 +804,7 @@ class PowerMaxUtils(object):
         """Get the temporary group name used for failover.
 
         :param rep_config: the replication config
-        :return: temp_grp_name
+        :returns: temp_grp_name
         """
         temp_grp_name = ("OS-%(rdf)s-temp-rdf-sg"
                          % {'rdf': rep_config['rdf_group_label']})
@@ -768,15 +812,15 @@ class PowerMaxUtils(object):
                   {'name': temp_grp_name})
         return temp_grp_name
 
-    def get_child_sg_name(self, host_name, extra_specs):
+    def get_child_sg_name(self, host_name, extra_specs, port_group_label):
         """Get the child storage group name for a masking view.
 
         :param host_name: the short host name
         :param extra_specs: the extra specifications
-        :return: child sg name, compression flag, rep flag, short pg name
+        :param port_group_label: the port group label
+        :returns: child sg name, compression flag, rep flag, short pg name
         """
         do_disable_compression = False
-        pg_name = self.get_pg_short_name(extra_specs[PORTGROUPNAME])
         rep_enabled = self.is_replication_enabled(extra_specs)
         if extra_specs[SLO]:
             slo_wl_combo = self.truncate_string(
@@ -787,7 +831,7 @@ class PowerMaxUtils(object):
                 % {'shortHostName': host_name,
                    'srpName': unique_name,
                    'combo': slo_wl_combo,
-                   'pg': pg_name})
+                   'pg': port_group_label})
             do_disable_compression = self.is_compression_disabled(
                 extra_specs)
             if do_disable_compression:
@@ -796,11 +840,11 @@ class PowerMaxUtils(object):
         else:
             child_sg_name = (
                 "OS-%(shortHostName)s-No_SLO-%(pg)s"
-                % {'shortHostName': host_name, 'pg': pg_name})
+                % {'shortHostName': host_name, 'pg': port_group_label})
         if rep_enabled:
             rep_mode = extra_specs.get(REP_MODE, None)
             child_sg_name += self.get_replication_prefix(rep_mode)
-        return child_sg_name, do_disable_compression, rep_enabled, pg_name
+        return child_sg_name, do_disable_compression, rep_enabled
 
     @staticmethod
     def change_multiattach(extra_specs, new_type_extra_specs):
@@ -808,7 +852,7 @@ class PowerMaxUtils(object):
 
         :param extra_specs: the source type extra specs
         :param new_type_extra_specs: the target type extra specs
-        :return: bool
+        :returns: bool
         """
         is_src_multiattach = volume_utils.is_boolean_str(
             extra_specs.get('multiattach'))
@@ -821,7 +865,7 @@ class PowerMaxUtils(object):
         """Check if a volume with verbose description is valid for management.
 
         :param source_vol: the verbose volume dict
-        :return: bool True/False
+        :returns: bool True/False
         """
         vol_head = source_vol['volumeHeader']
 
@@ -852,7 +896,7 @@ class PowerMaxUtils(object):
         if source_vol['timeFinderInfo']['snapVXTgt'] is True:
             return False
 
-        if vol_head['nameModifier'][0:3] == 'OS-':
+        if vol_head['userDefinedIdentifier'][0:3] == 'OS-':
             return False
 
         return True
@@ -862,7 +906,7 @@ class PowerMaxUtils(object):
         """Check if a volume with snapshot description is valid for management.
 
         :param source_vol: the verbose volume dict
-        :return: bool True/False
+        :returns: bool True/False
         """
         vol_head = source_vol['volumeHeader']
 
@@ -894,18 +938,66 @@ class PowerMaxUtils(object):
 
         return True
 
-    @staticmethod
-    def get_volume_attached_hostname(device_info):
-        """Parse a hostname from a storage group ID.
+    def get_volume_attached_hostname(self, volume):
+        """Get the host name from the attached volume
+
+        :param volume: the volume object
+        :returns: str -- the attached hostname
+        """
+        host_name_set = set()
+        attachment_list = volume.volume_attachment
+        LOG.debug("Volume attachment list: %(atl)s. "
+                  "Attachment type: %(at)s",
+                  {'atl': attachment_list, 'at': type(attachment_list)})
+
+        try:
+            att_list = attachment_list.objects
+        except AttributeError:
+            att_list = attachment_list
+        for att in att_list:
+            host_name_set.add(att.attached_host)
+
+        if host_name_set:
+            if len(host_name_set) > 1:
+                LOG.warning("Volume is attached to multiple instances "
+                            "on more than one compute node.")
+            else:
+                return host_name_set.pop()
+        return None
+
+    def get_rdf_managed_storage_group(self, device_info):
+        """Get the RDF managed storage group
 
         :param device_info: the device info dict
-        :return: str -- the attached hostname
+        :returns: str -- the attached hostname
+                 dict -- storage group details
         """
         try:
-            sg_id = device_info.get("storageGroupId")[0]
-            return sg_id.split('-')[1]
+            sg_list = device_info.get("storageGroupId")
+            for sg_id in sg_list:
+                sg_details = self.get_rdf_group_component_dict(sg_id)
+                if sg_details:
+                    return sg_id, sg_details
         except IndexError:
-            return None
+            return None, None
+        return None, None
+
+    def get_production_storage_group(self, device_info):
+        """Get the production storage group
+
+        :param device_info: the device info dict
+        :returns: str -- the storage group id
+                 dict -- storage group details
+        """
+        try:
+            sg_list = device_info.get("storageGroupId")
+            for sg_id in sg_list:
+                sg_details = self.get_storage_group_component_dict(sg_id)
+                if sg_details:
+                    return sg_id, sg_details
+        except IndexError:
+            return None, None
+        return None, None
 
     @staticmethod
     def validate_qos_input(input_key, sg_value, qos_extra_spec, property_dict):
@@ -959,7 +1051,7 @@ class PowerMaxUtils(object):
         """Compare number of cylinders of source and target.
 
         :param cylinders_source: number of cylinders on source
-        :param cylinders_target: number of cylinders on target
+        :param cylinder_target: number of cylinders on target
         """
         if float(cylinders_source) > float(cylinder_target):
             exception_message = (
@@ -977,7 +1069,7 @@ class PowerMaxUtils(object):
         """Get the service level and workload combination from extra specs.
 
         :param extra_specs: extra specifications
-        :return: string, string
+        :returns: string, string
         """
         service_level, workload = 'None', 'None'
         if extra_specs.get(SLO):
@@ -986,3 +1078,503 @@ class PowerMaxUtils(object):
                     and 'NONE' not in extra_specs.get(WORKLOAD)):
                 workload = extra_specs.get(WORKLOAD)
         return service_level, workload
+
+    def get_new_tags(self, list_str1, list_str2):
+        """Get elements in list_str1 not in list_str2
+
+        :param list_str1: list one in string format
+        :param list_str2: list two in string format
+        :returns: list
+        """
+        list_str1 = re.sub(r"\s+", "", list_str1)
+        if not list_str1:
+            return []
+        common_list = self._get_intersection(
+            list_str1, list_str2)
+
+        my_list1 = sorted(list_str1.split(","))
+        return [x for x in my_list1 if x.lower() not in common_list]
+
+    def verify_tag_list(self, tag_list):
+        """Verify that the tag list has allowable character
+
+        :param tag_list: list of tags
+        :returns: boolean
+        """
+        if not tag_list:
+            return False
+        if not isinstance(tag_list, list):
+            LOG.warning("The list of tags %(tag_list)s is not "
+                        "in list format. Tagging will not proceed.",
+                        {'tag_list': tag_list})
+            return False
+        if len(tag_list) > 8:
+            LOG.warning("The list of tags %(tag_list)s is more "
+                        "than the upper limit of 8. Tagging will not "
+                        "proceed.",
+                        {'tag_list': tag_list})
+            return False
+        for tag in tag_list:
+            tag = tag.strip()
+            if not re.match('^[a-zA-Z0-9_\\-]+$', tag):
+                return False
+        return True
+
+    def convert_list_to_string(self, list_input):
+        """Convert a list to a comma separated list
+
+        :param list_input: list
+        :returns: string or None
+        """
+        return ','.join(map(str, list_input)) if isinstance(
+            list_input, list) else list_input
+
+    def validate_short_host_name_from_template(
+            self, short_host_template, short_host_name):
+        """Validate that the short host name is in a format we can use.
+
+        Can be one of
+        shortHostName - where shortHostName is what the driver specifies
+        it to be, default
+        shortHostName[:x]uuid[:x] - where first x characters of the short
+        host name and x uuid characters created from md5 hash of
+        short host name
+        shortHostName[:x]userdef - where first x characters of the short
+        host name and a user defined name
+        shortHostName[-x:]uuid[:x] - where last x characters of short host
+        name and x uuid characters created from md5 hash of short host
+        name
+        shortHostName[-x:]suserdef - where last x characters of the short
+        host name and a user defined name
+
+        :param short_host_template: short host name template
+        :param short_host_name: short host name
+        :raises: VolumeBackendAPIException
+        :returns: new short host name -- string
+        """
+        new_short_host_name = None
+        is_ok, case = self.regex_check(short_host_template, True)
+        if is_ok:
+            new_short_host_name = (
+                self.generate_entity_string(
+                    case, short_host_template, short_host_name, True))
+        if not new_short_host_name:
+            error_message = (_('Unable to generate string from short '
+                               'host template %(template)s. Please refer to '
+                               'the online documentation for correct '
+                               'template format(s) for short host name.') %
+                             {'template': short_host_template})
+            LOG.error(error_message)
+            raise exception.VolumeBackendAPIException(
+                message=error_message)
+
+        return new_short_host_name
+
+    def validate_port_group_name_from_template(
+            self, port_group_template, port_group_name):
+        """Validate that the port group name is in a format we can use.
+
+        Can be one of
+        portGroupName - where portGroupName is what the driver specifies
+        it to be, default
+        portGroupName[:x]uuid[:x] - where first x characters of the short
+        host name and x uuid characters created from md5 hash of
+        short host name
+        portGroupName[:x]userdef - where first x characters of the short
+        host name and a user defined name
+        portGroupName[-x:]uuid[:x] - where last x characters of short host
+        name and x uuid characters created from md5 hash of short host
+        name
+        portGroupName[-x:]userdef - where last x characters of the short
+        host name and a user defined name
+
+        :param port_group_template: port group name template
+        :param port_group_name: port group name
+        :raises: VolumeBackendAPIException
+        :returns: new port group name -- string
+        """
+        new_port_group_name = None
+        is_ok, case = self.regex_check(port_group_template, False)
+        if is_ok:
+            new_port_group_name = (
+                self.generate_entity_string(
+                    case, port_group_template, port_group_name, False))
+
+        if not new_port_group_name:
+            error_message = (_('Unable to generate string from port group '
+                               'template %(template)s.  Please refer to '
+                               'the online documentation for correct '
+                               'template format(s) for port groups.') %
+                             {'template': port_group_template})
+            LOG.error(error_message)
+            raise exception.VolumeBackendAPIException(
+                message=error_message)
+
+        return new_port_group_name
+
+    def generate_entity_string(
+            self, case, entity_template, entity_name, entity_flag):
+        """Generate the entity string if the template checks out
+
+        :param case: one of five cases
+        :param entity_template: entity template
+        :param entity_name: entity name
+        :param entity_flag: storage group or port group flag
+        :returns: new entity name -- string
+        """
+        new_entity_name = None
+        override_rule_warning = False
+        try:
+            if case == '1':
+                new_entity_name = self.get_name_if_default_template(
+                    entity_name, entity_flag)
+            elif case == '2':
+                pass_two, uuid = self.prepare_string_with_uuid(
+                    entity_template, entity_name, entity_flag)
+                m = re.match(r'^' + entity_name +
+                             r'\[:(\d+)\]' + uuid + r'\[:(\d+)\]$', pass_two)
+                if m:
+                    num_1 = m.group(1)
+                    num_2 = m.group(2)
+                    self.check_upper_limit(
+                        int(num_1), int(num_2), entity_flag)
+                    new_entity_name = (
+                        entity_name[:int(num_1)] + uuid[:int(num_2)])
+                override_rule_warning = True
+            elif case == '3':
+                pass_two, uuid = self.prepare_string_with_uuid(
+                    entity_template, entity_name, entity_flag)
+                m = re.match(r'^' + entity_name +
+                             r'\[-(\d+):\]' + uuid + r'\[:(\d+)\]$', pass_two)
+                if m:
+                    num_1 = m.group(1)
+                    num_2 = m.group(2)
+                    self.check_upper_limit(
+                        int(num_1), int(num_2), entity_flag)
+                    new_entity_name = (
+                        entity_name[-int(num_1):] + uuid[:int(num_2)])
+                override_rule_warning = True
+            elif case == '4':
+                pass_two = self.prepare_string_entity(
+                    entity_template, entity_name, entity_flag)
+                m = re.match(r'^' + entity_name +
+                             r'\[:(\d+)\]' + r'([a-zA-Z0-9_\\-]+)$', pass_two)
+                if m:
+                    num_1 = m.group(1)
+                    user_defined = m.group(2)
+                    self.check_upper_limit(
+                        int(num_1), len(user_defined), entity_flag)
+                    new_entity_name = entity_name[:int(num_1)] + user_defined
+                override_rule_warning = True
+            elif case == '5':
+                pass_two = self.prepare_string_entity(
+                    entity_template, entity_name, entity_flag)
+                m = re.match(r'^' + entity_name +
+                             r'\[-(\d+):\]' + r'([a-zA-Z0-9_\\-]+)$', pass_two)
+                if m:
+                    num_1 = m.group(1)
+                    user_defined = m.group(2)
+                    self.check_upper_limit(
+                        int(num_1), len(user_defined), entity_flag)
+                    new_entity_name = entity_name[-int(num_1):] + user_defined
+                override_rule_warning = True
+            if override_rule_warning:
+                LOG.warning(
+                    "You have opted to override the %(entity)s naming format. "
+                    "Once changed and you have attached volumes or created "
+                    "new instances, you cannot revert to default or change to "
+                    "another format.",
+                    {'entity': 'storage group'
+                        if entity_flag else 'port group'})
+
+        except Exception:
+            new_entity_name = None
+        return new_entity_name
+
+    def get_name_if_default_template(self, entity_name, is_short_host_flag):
+        """Get the entity name if it is the default template
+
+        :param entity_name: the first number
+        :param is_short_host_flag: the second number
+        :returns: entity name -- string
+        """
+        if is_short_host_flag:
+            return self.get_host_short_name(entity_name)
+        else:
+            return self.get_pg_short_name(entity_name)
+
+    @staticmethod
+    def check_upper_limit(num_1, num_2, is_host_flag):
+        """Check that the sum of number is less than upper limit.
+
+        :param num_1: the first number
+        :param num_2: the second number
+        :param is_host_flag: is short host boolean
+        :raises: VolumeBackendAPIException
+        """
+        if is_host_flag:
+            if (num_1 + num_2) > UPPER_HOST_CHARS:
+                error_message = (_("Host name exceeds the character upper "
+                                   "limit of %(upper)d.  Please check your "
+                                   "short host template.") %
+                                 {'upper': UPPER_HOST_CHARS})
+                LOG.error(error_message)
+                raise exception.VolumeBackendAPIException(
+                    message=error_message)
+        else:
+            if (num_1 + num_2) > UPPER_PORT_GROUP_CHARS:
+                error_message = (_("Port group name exceeds the character "
+                                   "upper limit of %(upper)d. Please check "
+                                   "your port group template") %
+                                 {'upper': UPPER_PORT_GROUP_CHARS})
+                LOG.error(error_message)
+                raise exception.VolumeBackendAPIException(
+                    message=error_message)
+
+    def prepare_string_with_uuid(
+            self, template, entity_str, is_short_host_flag):
+        """Prepare string for pass three
+
+        :param template: the template
+        :param entity_str: the entity string
+        :param is_short_host_flag: is short host
+        :returns: pass_two -- string
+                  uuid -- string
+        """
+        pass_one = self.prepare_string_entity(
+            template, entity_str, is_short_host_flag)
+        uuid = self.get_uuid_of_input(entity_str)
+        pass_two = pass_one.replace('uuid', uuid)
+        return pass_two, uuid
+
+    @staticmethod
+    def prepare_string_entity(template, entity_str, is_host_flag):
+        """Prepare string for pass two
+
+        :param template: the template
+        :param entity_str: the entity string
+        :param is_host_flag: is host boolean
+        :returns: pass_one -- string
+        """
+        entity_type = 'shortHostName' if is_host_flag else 'portGroupName'
+        # Replace entity type with variable
+        return template.replace(
+            entity_type, entity_str)
+
+    @staticmethod
+    def regex_check(template, is_short_host_flag):
+        """Check the template is in a validate format.
+
+        :param template: short host name template
+        :param is_short_host_flag: short host boolean
+        :returns: boolean,
+                  case -- string
+        """
+        if is_short_host_flag:
+            entity = 'shortHostName'
+        else:
+            entity = 'portGroupName'
+        if re.match(r'^' + entity + r'$', template):
+            return True, '1'
+        elif re.match(r'^' + entity + r'\[:\d+\]uuid\[:\d+\]$', template):
+            return True, '2'
+        elif re.match(r'^' + entity + r'\[-\d+:\]uuid\[:\d+\]$', template):
+            return True, '3'
+        elif re.match(r'^' + entity + r'\[:\d+\][a-zA-Z0-9_\\-]+$', template):
+            return True, '4'
+        elif re.match(r'^' + entity + r'\[-\d+:\][a-zA-Z0-9_\\-]+$',
+                      template):
+            return True, '5'
+        return False, '0'
+
+    def get_host_name_label(self, host_name_in, host_template):
+        """Get the host name label that will be used in PowerMax Objects
+
+        :param host_name_in: host name as portrayed in connector object
+        :param host_template:
+        :returns: host_name_out
+        """
+        host_name_out = self.get_host_short_name(
+            host_name_in)
+        if host_template:
+            short_host_name = self.get_host_short_name_from_fqn(
+                host_name_in)
+            host_name_out = (
+                self.validate_short_host_name_from_template(
+                    host_template, short_host_name))
+        return host_name_out
+
+    def get_port_name_label(self, port_name_in, port_group_template):
+        """Get the port name label that will be used in PowerMax Objects
+
+        :rtype: object
+        :param host_name_in: host name as portrayed in connector object
+        :param port_group_template: port group template
+        :returns: port_name_out
+        """
+        port_name_out = self.get_pg_short_name(port_name_in)
+        if port_group_template:
+            port_name_out = (
+                self.validate_port_group_name_from_template(
+                    port_group_template, port_name_in))
+        return port_name_out
+
+    def get_storage_group_component_dict(self, storage_group_name):
+        """Parse the storage group string.
+
+        :param storage_group_name: the storage group name -- str
+        :returns: object components -- dict
+        """
+        regex_str = (r'^(?P<prefix>OS)-(?P<host>.+?)'
+                     r'((?P<no_slo>No_SLO)|((?P<srp>SRP.+?)-'
+                     r'(?P<sloworkload>.+?)))-(?P<portgroup>.+?)'
+                     r'(?P<after_pg>$|-CD|-RE|-RA|-RM)')
+        return self.get_object_components_and_correct_host(
+            regex_str, storage_group_name)
+
+    def get_rdf_group_component_dict(self, storage_group_name):
+        """Parse the storage group string.
+
+        :param storage_group_name: the storage group name -- str
+        :returns: object components -- dict
+        """
+        regex_str = (r'^(?P<prefix>OS)-(?P<rdf_label>.+?)-'
+                     r'(?P<sync_mode>Asynchronous|Metro)-'
+                     r'(?P<after_mode>rdf-sg)$')
+        return self.get_object_components(
+            regex_str, storage_group_name)
+
+    def get_object_components_and_correct_host(self, regex_str, input_str):
+        """Get components from input string.
+
+        :param regex_str: the regex -- str
+        :param input_str: the input string -- str
+        :returns: object components -- dict
+        """
+        object_dict = self.get_object_components(regex_str, input_str)
+        if object_dict and 'host' in object_dict:
+            if object_dict['host'].endswith('-'):
+                object_dict['host'] = object_dict['host'][:-1]
+        return object_dict
+
+    @staticmethod
+    def get_object_components(regex_str, input_str):
+        """Get components from input string.
+
+        :param regex_str: the regex -- str
+        :param input_str: the input string -- str
+        :returns: dict
+        """
+        full_str = re.compile(regex_str)
+        match = full_str.match(input_str)
+        return match.groupdict() if match else None
+
+    def get_possible_initiator_name(self, host_label, protocol):
+        """Get possible initiator name based on the host
+
+        :param host_label: the host label -- str
+        :param protocol: the protocol -- str
+        :returns: initiator_group_name -- str
+        """
+        protocol = self.get_short_protocol_type(protocol)
+        return ("OS-%(shortHostName)s-%(protocol)s-IG"
+                % {'shortHostName': host_label,
+                   'protocol': protocol})
+
+    @staticmethod
+    def delete_values_from_dict(datadict, key_list):
+        """Delete values from a dict
+
+        :param datadict: dictionary
+        :param key_list: list of keys
+        :returns: dict
+        """
+        for key in key_list:
+            if datadict.get(key):
+                del datadict[key]
+        return datadict
+
+    @staticmethod
+    def update_values_in_dict(datadict, tuple_list):
+        """Delete values from a dict
+
+        :param datadict: dictionary
+        :param tuple_list: list of tuples
+        :returns: dict
+        """
+        for tuple in tuple_list:
+            if datadict.get(tuple[0]):
+                datadict.update({tuple[1]: datadict.get(tuple[0])})
+                del datadict[tuple[0]]
+        return datadict
+
+    @staticmethod
+    def _get_intersection(list_str1, list_str2):
+        """Get the common values between 2 comma separated list
+
+        :param list_str1: list one
+        :param list_str2: list two
+        :returns: sorted list
+        """
+        list_str1 = re.sub(r"\s+", "", list_str1).lower()
+        list_str2 = re.sub(r"\s+", "", list_str2).lower()
+        my_list1 = sorted(list_str1.split(","))
+        my_list2 = sorted(list_str2.split(","))
+        sorted_common_list = (
+            sorted(list(set(my_list1).intersection(set(my_list2)))))
+        return sorted_common_list
+
+    @staticmethod
+    def get_unique_device_ids_from_lists(list_a, list_b):
+        """Get the unique values from list B that don't appear in list A.
+
+        :param list_a: list A
+        :param list_b: list B
+        :returns: values unique between two lists -- list
+        """
+        set_a = set(list_a)
+        return [dev_id for dev_id in list_b if dev_id not in set_a]
+
+    @staticmethod
+    def update_payload_for_rdf_vol_create(payload, remote_array_id,
+                                          storage_group_name):
+        """Construct the REST payload for creating RDF enabled volumes.
+
+        :param payload: the existing payload -- dict
+        :param remote_array_id: the remote array serial number -- str
+        :param storage_group_name: the storage group name -- str
+        :returns: updated payload -- dict
+        """
+        remote_dict = {"remoteSymmSGInfoParam": {
+            "remote_symmetrix_1_id": remote_array_id,
+            "remote_symmetrix_1_sgs": [storage_group_name],
+            "force": "true"}}
+
+        payload["editStorageGroupActionParam"]["expandStorageGroupParam"][
+            "addVolumeParam"].update(remote_dict)
+
+        return payload
+
+    @staticmethod
+    def is_retype_supported(volume, src_extra_specs, tgt_extra_specs):
+        """Determine if a retype operation involving Metro is supported.
+
+        :param volume: the volume object -- obj
+        :param src_extra_specs: the source extra specs -- dict
+        :param tgt_extra_specs: the target extra specs -- dict
+        :returns: is supported -- bool
+        """
+        if volume.attach_status == 'detached':
+            return True
+
+        src_rep_mode = src_extra_specs.get('rep_mode', None)
+        tgt_rep_mode = tgt_extra_specs.get('rep_mode', None)
+
+        if tgt_rep_mode != REP_METRO:
+            return True
+        else:
+            if src_rep_mode == REP_METRO:
+                return True
+            else:
+                if not src_rep_mode or src_rep_mode in [REP_SYNC, REP_ASYNC]:
+                    return False
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/ps.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/ps.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/ps.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/ps.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,717 +0,0 @@
-#    Copyright (c) 2013-2017 Dell Inc, or its subsidiaries.
-#    Copyright 2013 OpenStack Foundation
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-
-"""Volume driver for Dell EMC PS Series Storage."""
-
-import functools
-import math
-import random
-
-import eventlet
-from eventlet import greenthread
-import greenlet
-from oslo_concurrency import processutils
-from oslo_config import cfg
-from oslo_log import log as logging
-from oslo_log import versionutils
-from oslo_utils import excutils
-from six.moves import range
-
-from cinder import exception
-from cinder.i18n import _
-from cinder import interface
-from cinder import ssh_utils
-from cinder import utils
-from cinder.volume import configuration
-from cinder.volume.drivers import san
-
-LOG = logging.getLogger(__name__)
-
-eqlx_opts = [
-    cfg.StrOpt('eqlx_group_name',
-               default='group-0',
-               help='Group name to use for creating volumes. Defaults to '
-                    '"group-0".'),
-    cfg.IntOpt('eqlx_cli_max_retries',
-               min=0,
-               default=5,
-               help='Maximum retry count for reconnection. Default is 5.'),
-    cfg.StrOpt('eqlx_pool',
-               default='default',
-               help='Pool in which volumes will be created. Defaults '
-                    'to "default".')
-]
-
-
-CONF = cfg.CONF
-CONF.register_opts(eqlx_opts, group=configuration.SHARED_CONF_GROUP)
-
-
-def with_timeout(f):
-    @functools.wraps(f)
-    def __inner(self, *args, **kwargs):
-        timeout = kwargs.pop('timeout', None)
-        gt = eventlet.spawn(f, self, *args, **kwargs)
-        if timeout is None:
-            return gt.wait()
-        else:
-            kill_thread = eventlet.spawn_after(timeout, gt.kill)
-            try:
-                res = gt.wait()
-            except greenlet.GreenletExit:
-                raise exception.VolumeBackendAPIException(
-                    data="Command timed out")
-            else:
-                kill_thread.cancel()
-                return res
-
-    return __inner
-
-
-@interface.volumedriver
-class PSSeriesISCSIDriver(san.SanISCSIDriver):
-    """Implements commands for Dell EMC PS Series ISCSI management.
-
-    To enable the driver add the following line to the cinder configuration:
-        volume_driver=cinder.volume.drivers.dell_emc.ps.PSSeriesISCSIDriver
-
-    Driver's prerequisites are:
-        - a separate volume group set up and running on the SAN
-        - SSH access to the SAN
-        - a special user must be created which must be able to
-            - create/delete volumes and snapshots;
-            - clone snapshots into volumes;
-            - modify volume access records;
-
-    The access credentials to the SAN are provided by means of the following
-    flags:
-
-    .. code-block:: ini
-
-        san_ip=<ip_address>
-        san_login=<user name>
-        san_password=<user password>
-        san_private_key=<file containing SSH private key>
-
-    Thin provision of volumes is enabled by default, to disable it use:
-
-    .. code-block:: ini
-
-        san_thin_provision=false
-
-    In order to use target CHAP authentication (which is disabled by default)
-    SAN administrator must create a local CHAP user and specify the following
-    flags for the driver:
-
-    .. code-block:: ini
-
-        use_chap_auth=True
-        chap_login=<chap_login>
-        chap_password=<chap_password>
-
-    eqlx_group_name parameter actually represents the CLI prompt message
-    without '>' ending. E.g. if prompt looks like 'group-0>', then the
-    parameter must be set to 'group-0'
-
-    Version history:
-
-    .. code-block:: none
-
-        1.0   - Initial driver
-        1.1.0 - Misc fixes
-        1.2.0 - Deprecated eqlx_cli_timeout infavor of ssh_conn_timeout
-        1.3.0 - Added support for manage/unmanage volume
-        1.4.0 - Removed deprecated options eqlx_cli_timeout, eqlx_use_chap,
-                eqlx_chap_login, and eqlx_chap_password.
-        1.4.1 - Rebranded driver to Dell EMC.
-        1.4.2 - Enable report discard support.
-        1.4.3 - Report total_volumes in volume stats
-        1.4.4 - Fixed over-subscription ratio calculation
-        1.4.5 - Optimize volume stats information parsing
-        1.4.6 - Extend volume with no-snap option
-
-    """
-
-    VERSION = "1.4.6"
-
-    # ThirdPartySytems wiki page
-    CI_WIKI_NAME = "Dell_EMC_PS_Series_CI"
-
-    def __init__(self, *args, **kwargs):
-        super(PSSeriesISCSIDriver, self).__init__(*args, **kwargs)
-        self.configuration.append_config_values(eqlx_opts)
-        self._group_ip = None
-        self.sshpool = None
-
-    @staticmethod
-    def get_driver_options():
-        return eqlx_opts
-
-    def _get_output(self, chan):
-        out = ''
-        ending = '%s> ' % self.configuration.eqlx_group_name
-        while out.find(ending) == -1:
-            ret = chan.recv(102400)
-            if len(ret) == 0:
-                # According to paramiko.channel.Channel documentation, which
-                # says "If a string of length zero is returned, the channel
-                # stream has closed". So we can confirm that the PS server
-                # has closed the connection.
-                msg = _("The PS array has closed the connection.")
-                LOG.error(msg)
-                raise exception.VolumeBackendAPIException(data=msg)
-            out += ret
-
-        LOG.debug("CLI output\n%s", out)
-        return out.splitlines()
-
-    def _get_prefixed_value(self, lines, prefix):
-        for line in lines:
-            if line.startswith(prefix):
-                return line[len(prefix):]
-        return
-
-    @with_timeout
-    def _ssh_execute(self, ssh, command, *arg, **kwargs):
-        transport = ssh.get_transport()
-        chan = transport.open_session()
-        completed = False
-
-        try:
-            chan.invoke_shell()
-
-            LOG.debug("Reading CLI MOTD")
-            self._get_output(chan)
-
-            cmd = 'stty columns 255'
-            LOG.debug("Setting CLI terminal width: '%s'", cmd)
-            chan.send(cmd + '\r')
-            out = self._get_output(chan)
-
-            LOG.debug("Sending CLI command: '%s'", command)
-            chan.send(command + '\r')
-            out = self._get_output(chan)
-
-            completed = True
-
-            if any(ln.startswith(('% Error', 'Error:')) for ln in out):
-                desc = _("Error executing PS command")
-                cmdout = '\n'.join(out)
-                LOG.error(cmdout)
-                raise processutils.ProcessExecutionError(
-                    stdout=cmdout, cmd=command, description=desc)
-            return out
-        finally:
-            if not completed:
-                LOG.debug("Timed out executing command: '%s'", command)
-            chan.close()
-
-    def _run_ssh(self, cmd_list, attempts=1):
-        utils.check_ssh_injection(cmd_list)
-        command = ' '. join(cmd_list)
-
-        if not self.sshpool:
-            password = self.configuration.san_password
-            privatekey = self.configuration.san_private_key
-            min_size = self.configuration.ssh_min_pool_conn
-            max_size = self.configuration.ssh_max_pool_conn
-            self.sshpool = ssh_utils.SSHPool(
-                self.configuration.san_ip,
-                self.configuration.san_ssh_port,
-                self.configuration.ssh_conn_timeout,
-                self.configuration.san_login,
-                password=password,
-                privatekey=privatekey,
-                min_size=min_size,
-                max_size=max_size)
-        try:
-            total_attempts = attempts
-            with self.sshpool.item() as ssh:
-                while attempts > 0:
-                    attempts -= 1
-                    try:
-                        LOG.info('PS-driver: executing "%s".', command)
-                        return self._ssh_execute(
-                            ssh, command,
-                            timeout=self.configuration.ssh_conn_timeout)
-                    except Exception:
-                        LOG.exception('Error running command.')
-                        greenthread.sleep(random.randint(20, 500) / 100.0)
-                msg = (_("SSH Command failed after '%(total_attempts)r' "
-                         "attempts : '%(command)s'") %
-                       {'total_attempts': total_attempts - attempts,
-                        'command': command})
-                raise exception.VolumeBackendAPIException(data=msg)
-
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Error running SSH command: "%s".', command)
-
-    def check_for_setup_error(self):
-        super(PSSeriesISCSIDriver, self).check_for_setup_error()
-
-    def _eql_execute(self, *args, **kwargs):
-        return self._run_ssh(
-            args, attempts=self.configuration.eqlx_cli_max_retries + 1)
-
-    def _get_volume_data(self, lines):
-        prefix = 'iSCSI target name is '
-        target_name = self._get_prefixed_value(lines, prefix)[:-1]
-        return self._get_model_update(target_name)
-
-    def _get_model_update(self, target_name):
-        lun_id = "%s:%s,1 %s 0" % (self._group_ip, '3260', target_name)
-        model_update = {}
-        model_update['provider_location'] = lun_id
-        if self.configuration.use_chap_auth:
-            model_update['provider_auth'] = 'CHAP %s %s' % \
-                (self.configuration.chap_username,
-                 self.configuration.chap_password)
-        return model_update
-
-    def _get_space_in_gb(self, val):
-        scale = 1.0
-        part = 'GB'
-        if val.endswith('MB'):
-            scale = 1.0 / 1024
-            part = 'MB'
-        elif val.endswith('TB'):
-            scale = 1.0 * 1024
-            part = 'TB'
-        return math.ceil(scale * float(val.partition(part)[0]))
-
-    def _update_volume_stats(self):
-        """Retrieve stats info from eqlx group."""
-
-        LOG.debug('Updating volume stats.')
-        data = {}
-        backend_name = "eqlx"
-        if self.configuration:
-            backend_name = self.configuration.safe_get('volume_backend_name')
-        data["volume_backend_name"] = backend_name or 'eqlx'
-        data["vendor_name"] = 'Dell EMC'
-        data["driver_version"] = self.VERSION
-        data["storage_protocol"] = 'iSCSI'
-
-        data['reserved_percentage'] = 0
-        data['QoS_support'] = False
-
-        data['total_capacity_gb'] = None
-        data['free_capacity_gb'] = None
-        data['multiattach'] = False
-        data['total_volumes'] = None
-
-        provisioned_capacity = None
-        for line in self._eql_execute('pool', 'select',
-                                      self.configuration.eqlx_pool, 'show'):
-            if line.startswith('TotalCapacity:'):
-                out_tup = line.rstrip().partition(' ')
-                data['total_capacity_gb'] = self._get_space_in_gb(out_tup[-1])
-            if line.startswith('FreeSpace:'):
-                out_tup = line.rstrip().partition(' ')
-                data['free_capacity_gb'] = self._get_space_in_gb(out_tup[-1])
-            if line.startswith('VolumeReportedSpace:'):
-                out_tup = line.rstrip().partition(' ')
-                provisioned_capacity = self._get_space_in_gb(out_tup[-1])
-            if line.startswith('TotalVolumes:'):
-                out_tup = line.rstrip().partition(' ')
-                data['total_volumes'] = int(out_tup[-1])
-            # Terminate parsing once this data is found to improve performance
-            if (data['total_capacity_gb'] and data['free_capacity_gb'] and
-               provisioned_capacity and data['total_volumes']):
-                break
-
-        global_capacity = data['total_capacity_gb']
-        global_free = data['free_capacity_gb']
-
-        thin_enabled = self.configuration.san_thin_provision
-        if not thin_enabled:
-            provisioned_capacity = round(global_capacity - global_free, 2)
-
-        data['provisioned_capacity_gb'] = provisioned_capacity
-        data['max_over_subscription_ratio'] = (
-            self.configuration.max_over_subscription_ratio)
-        data['thin_provisioning_support'] = thin_enabled
-        data['thick_provisioning_support'] = not thin_enabled
-
-        self._stats = data
-
-    def _get_volume_info(self, volume_name):
-        """Get the volume details on the array"""
-        command = ['volume', 'select', volume_name, 'show']
-        try:
-            data = {}
-            for line in self._eql_execute(*command):
-                if line.startswith('Size:'):
-                    out_tup = line.rstrip().partition(' ')
-                    data['size'] = self._get_space_in_gb(out_tup[-1])
-                elif line.startswith('iSCSI Name:'):
-                    out_tup = line.rstrip().partition(': ')
-                    data['iSCSI_Name'] = out_tup[-1]
-            return data
-        except processutils.ProcessExecutionError:
-            msg = (_("Volume does not exists %s.") % volume_name)
-            LOG.error(msg)
-            raise exception.ManageExistingInvalidReference(
-                existing_ref=volume_name, reason=msg)
-
-    def _check_volume(self, volume):
-        """Check if the volume exists on the Array."""
-        command = ['volume', 'select', volume['name'], 'show']
-        try:
-            self._eql_execute(*command)
-        except processutils.ProcessExecutionError as err:
-            with excutils.save_and_reraise_exception():
-                if err.stdout.find('does not exist.\n') > -1:
-                    LOG.debug('Volume %s does not exist, '
-                              'it may have already been deleted',
-                              volume['name'])
-                    raise exception.VolumeNotFound(volume_id=volume['id'])
-
-    def _get_access_record(self, volume, connector):
-        """Returns access record id for the initiator"""
-        try:
-            out = self._eql_execute('volume', 'select', volume['name'],
-                                    'access', 'show')
-            return self._parse_connection(connector, out)
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to get access records '
-                          'to volume "%s".', volume['name'])
-
-    def _parse_connection(self, connector, out):
-        """Returns the correct connection id for the initiator.
-
-        This parses the cli output from the command
-        'volume select <volumename> access show'
-        and returns the correct connection id.
-        """
-        lines = [line for line in out if line != '']
-        # Every record has 2 lines
-        for i in range(0, len(lines), 2):
-            try:
-                int(lines[i][0])
-                # sanity check
-                if len(lines[i + 1].split()) == 1:
-                    check = lines[i].split()[1] + lines[i + 1].strip()
-                    if connector['initiator'] == check:
-                        return lines[i].split()[0]
-            except (IndexError, ValueError):
-                pass  # skip the line that is not a valid access record
-
-        return None
-
-    def do_setup(self, context):
-        """Disable cli confirmation and tune output format."""
-        try:
-            msg = _("The Dell PS driver is moving to maintenance mode "
-                    "in the S release and will be removed in T release.")
-            versionutils.report_deprecated_feature(LOG, msg)
-
-            disabled_cli_features = ('confirmation', 'paging', 'events',
-                                     'formatoutput')
-            for feature in disabled_cli_features:
-                self._eql_execute('cli-settings', feature, 'off')
-
-            for line in self._eql_execute('grpparams', 'show'):
-                if line.startswith('Group-Ipaddress:'):
-                    out_tup = line.rstrip().partition(' ')
-                    self._group_ip = out_tup[-1]
-
-            LOG.info('PS-driver: Setup is complete, group IP is "%s".',
-                     self._group_ip)
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to setup the Dell EMC PS driver.')
-
-    def create_volume(self, volume):
-        """Create a volume."""
-        try:
-            cmd = ['volume', 'create',
-                   volume['name'], "%sG" % (volume['size'])]
-            if self.configuration.eqlx_pool != 'default':
-                cmd.append('pool')
-                cmd.append(self.configuration.eqlx_pool)
-            if self.configuration.san_thin_provision:
-                cmd.append('thin-provision')
-            out = self._eql_execute(*cmd)
-            self.add_multihost_access(volume)
-            return self._get_volume_data(out)
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to create volume "%s".', volume['name'])
-
-    def add_multihost_access(self, volume):
-        """Add multihost-access to a volume. Needed for live migration."""
-        try:
-            cmd = ['volume', 'select',
-                   volume['name'], 'multihost-access', 'enable']
-            self._eql_execute(*cmd)
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to add multihost-access '
-                          'for volume "%s".',
-                          volume['name'])
-
-    def _set_volume_description(self, volume, description):
-        """Set the description of the volume"""
-        try:
-            cmd = ['volume', 'select',
-                   volume['name'], 'description', description]
-            self._eql_execute(*cmd)
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to set description '
-                          'for volume "%s".',
-                          volume['name'])
-
-    def delete_volume(self, volume):
-        """Delete a volume."""
-        try:
-            self._check_volume(volume)
-            self._eql_execute('volume', 'select', volume['name'], 'offline')
-            self._eql_execute('volume', 'delete', volume['name'])
-        except exception.VolumeNotFound:
-            LOG.warning('Volume %s was not found while trying to delete it.',
-                        volume['name'])
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to delete volume "%s".', volume['name'])
-
-    def create_snapshot(self, snapshot):
-        """Create snapshot of existing volume on appliance."""
-        try:
-            out = self._eql_execute('volume', 'select',
-                                    snapshot['volume_name'],
-                                    'snapshot', 'create-now')
-            prefix = 'Snapshot name is '
-            snap_name = self._get_prefixed_value(out, prefix)
-            self._eql_execute('volume', 'select', snapshot['volume_name'],
-                              'snapshot', 'rename', snap_name,
-                              snapshot['name'])
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to create snapshot of volume "%s".',
-                          snapshot['volume_name'])
-
-    def create_volume_from_snapshot(self, volume, snapshot):
-        """Create new volume from other volume's snapshot on appliance."""
-        try:
-            out = self._eql_execute('volume', 'select',
-                                    snapshot['volume_name'], 'snapshot',
-                                    'select', snapshot['name'],
-                                    'clone', volume['name'])
-            # Extend Volume if needed
-            if out and volume['size'] > snapshot['volume_size']:
-                self.extend_volume(volume, volume['size'])
-                LOG.debug('Volume from snapshot %(name)s resized from '
-                          '%(current_size)sGB to %(new_size)sGB.',
-                          {'name': volume['name'],
-                           'current_size': snapshot['volume_size'],
-                           'new_size': volume['size']})
-
-            self.add_multihost_access(volume)
-            return self._get_volume_data(out)
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to create volume from snapshot "%s".',
-                          snapshot['name'])
-
-    def create_cloned_volume(self, volume, src_vref):
-        """Creates a clone of the specified volume."""
-        try:
-            src_volume_name = src_vref['name']
-            out = self._eql_execute('volume', 'select', src_volume_name,
-                                    'clone', volume['name'])
-
-            # Extend Volume if needed
-            if out and volume['size'] > src_vref['size']:
-                self.extend_volume(volume, volume['size'])
-
-            self.add_multihost_access(volume)
-            return self._get_volume_data(out)
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to create clone of volume "%s".',
-                          volume['name'])
-
-    def delete_snapshot(self, snapshot):
-        """Delete volume's snapshot."""
-        try:
-            self._eql_execute('volume', 'select', snapshot['volume_name'],
-                              'snapshot', 'delete', snapshot['name'])
-        except processutils.ProcessExecutionError as err:
-            if err.stdout.find('does not exist') > -1:
-                LOG.debug('Snapshot %s could not be found.', snapshot['name'])
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to delete snapshot %(snap)s of '
-                          'volume %(vol)s.',
-                          {'snap': snapshot['name'],
-                           'vol': snapshot['volume_name']})
-
-    def initialize_connection(self, volume, connector):
-        """Restrict access to a volume."""
-        try:
-            connection_id = self._get_access_record(volume, connector)
-            if connection_id is None:
-                cmd = ['volume', 'select', volume['name'], 'access', 'create',
-                       'initiator', connector['initiator']]
-                if self.configuration.use_chap_auth:
-                    cmd.extend(['authmethod', 'chap', 'username',
-                                self.configuration.chap_username])
-                self._eql_execute(*cmd)
-
-            iscsi_properties = self._get_iscsi_properties(volume)
-            iscsi_properties['discard'] = True
-            return {
-                'driver_volume_type': 'iscsi',
-                'data': iscsi_properties
-            }
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to initialize connection to volume "%s".',
-                          volume['name'])
-
-    def terminate_connection(self, volume, connector, force=False, **kwargs):
-        """Remove access restrictions from a volume."""
-        try:
-            connection_id = self._get_access_record(volume, connector)
-            if connection_id is not None:
-                self._eql_execute('volume', 'select', volume['name'],
-                                  'access', 'delete', connection_id)
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to terminate connection to volume "%s".',
-                          volume['name'])
-
-    def create_export(self, context, volume, connector):
-        """Create an export of a volume.
-
-        Driver has nothing to do here for the volume has been exported
-        already by the SAN, right after it's creation.
-        """
-        pass
-
-    def ensure_export(self, context, volume):
-        """Ensure an export of a volume.
-
-        Driver has nothing to do here for the volume has been exported
-        already by the SAN, right after it's creation. We will just make
-        sure that the volume exists on the array and issue a warning.
-        """
-        try:
-            self._check_volume(volume)
-        except exception.VolumeNotFound:
-            LOG.warning('Volume %s is not found!, it may have been deleted.',
-                        volume['name'])
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to ensure export of volume "%s".',
-                          volume['name'])
-
-    def remove_export(self, context, volume):
-        """Remove an export of a volume.
-
-        Driver has nothing to do here for the volume has been exported
-        already by the SAN, right after it's creation.
-        Nothing to remove since there's nothing exported.
-        """
-        pass
-
-    def extend_volume(self, volume, new_size):
-        """Extend the size of the volume."""
-        try:
-            self._eql_execute('volume', 'select', volume['name'],
-                              'size', "%sG" % new_size, 'no-snap')
-            LOG.info('Volume %(name)s resized from '
-                     '%(current_size)sGB to %(new_size)sGB.',
-                     {'name': volume['name'],
-                      'current_size': volume['size'],
-                      'new_size': new_size})
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to extend_volume %(name)s from '
-                          '%(current_size)sGB to %(new_size)sGB.',
-                          {'name': volume['name'],
-                           'current_size': volume['size'],
-                           'new_size': new_size})
-
-    def _get_existing_volume_ref_name(self, ref):
-        existing_volume_name = None
-        if 'source-name' in ref:
-            existing_volume_name = ref['source-name']
-        elif 'source-id' in ref:
-            existing_volume_name = ref['source-id']
-        else:
-            msg = _('Reference must contain source-id or source-name.')
-            LOG.error(msg)
-            raise exception.InvalidInput(reason=msg)
-
-        return existing_volume_name
-
-    def manage_existing(self, volume, existing_ref):
-        """Manage an existing volume on the backend storage."""
-        existing_volume_name = self._get_existing_volume_ref_name(existing_ref)
-        try:
-            cmd = ['volume', 'rename',
-                   existing_volume_name, volume['name']]
-            self._eql_execute(*cmd)
-            self._set_volume_description(volume, '"OpenStack Managed"')
-            self.add_multihost_access(volume)
-            data = self._get_volume_info(volume['name'])
-            updates = self._get_model_update(data['iSCSI_Name'])
-            LOG.info("Backend volume %(back_vol)s renamed to "
-                     "%(vol)s and is now managed by cinder.",
-                     {'back_vol': existing_volume_name,
-                      'vol': volume['name']})
-            return updates
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to manage volume "%s".', volume['name'])
-
-    def manage_existing_get_size(self, volume, existing_ref):
-        """Return size of volume to be managed by manage_existing.
-
-        When calculating the size, round up to the next GB.
-
-        :param volume:       Cinder volume to manage
-        :param existing_ref: Driver-specific information used to identify a
-                             volume
-        """
-        existing_volume_name = self._get_existing_volume_ref_name(existing_ref)
-        data = self._get_volume_info(existing_volume_name)
-        return data['size']
-
-    def unmanage(self, volume):
-        """Removes the specified volume from Cinder management.
-
-        Does not delete the underlying backend storage object.
-
-        :param volume: Cinder volume to unmanage
-        """
-        try:
-            self._set_volume_description(volume, '"OpenStack UnManaged"')
-            LOG.info("Virtual volume %(disp)s '%(vol)s' is no "
-                     "longer managed.",
-                     {'disp': volume['display_name'],
-                      'vol': volume['name']})
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to unmanage volume "%s".',
-                          volume['name'])
-
-    def local_path(self, volume):
-        raise NotImplementedError()
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/sc/storagecenter_api.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/sc/storagecenter_api.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/sc/storagecenter_api.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/sc/storagecenter_api.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,6 +15,7 @@
 
 import json
 import os.path
+import uuid
 
 import eventlet
 from oslo_log import log as logging
@@ -22,7 +23,6 @@ from oslo_utils import excutils
 import requests
 import six
 from six.moves import http_client
-import uuid
 
 from cinder import exception
 from cinder.i18n import _
@@ -1760,7 +1760,7 @@ class SCApi(object):
         return self._find_domains(self._get_id(mapping.get('controllerPort')))
 
     def _get_iqn(self, mapping):
-        # Get our iqn from the controller port listed in our our mapping.
+        # Get our iqn from the controller port listed in our mapping.
         iqn = None
         cportid = self._get_id(mapping.get('controllerPort'))
         controllerport = self._find_controller_port(cportid)
@@ -3000,7 +3000,7 @@ class SCApi(object):
     def unmanage(self, scvolume):
         """Unmanage our volume.
 
-        We simply rename with with a prefix of `Unmanaged_`  That's it.
+        We simply rename with a prefix of `Unmanaged_`  That's it.
 
         :param scvolume: The Dell SC volume object.
         :return: Nothing.
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/sc/storagecenter_common.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/sc/storagecenter_common.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/sc/storagecenter_common.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/sc/storagecenter_common.py	2020-03-24 18:46:31.000000000 +0000
@@ -659,7 +659,7 @@ class SCCommonDriver(driver.ManageableVD
     def ensure_export(self, context, volume):
         """Ensure an export of a volume.
 
-        Per the eqlx driver we just make sure that the volume actually
+        Per the sc driver we just make sure that the volume actually
         exists where we think it does.
         """
         scvolume = None
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/unity/adapter.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/unity/adapter.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/unity/adapter.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/unity/adapter.py	2020-03-24 18:46:31.000000000 +0000
@@ -995,7 +995,7 @@ class CommonAdapter(object):
     @cinder_utils.trace
     def failover(self, volumes, secondary_id=None, groups=None):
         # TODO(ryan) support group failover after group bp merges
-        # https://review.openstack.org/#/c/574119/
+        # https://review.opendev.org/#/c/574119/
 
         if secondary_id is None:
             LOG.debug('No secondary specified when failover. '
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/unity/driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/unity/driver.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/unity/driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/unity/driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -17,7 +17,6 @@
 
 from oslo_config import cfg
 from oslo_log import log as logging
-
 import six
 
 from cinder import interface
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/vnx/adapter.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/vnx/adapter.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/vnx/adapter.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/vnx/adapter.py	2020-03-24 18:46:31.000000000 +0000
@@ -24,11 +24,9 @@ from oslo_log import log as logging
 from oslo_utils import importutils
 import six
 
-
 from cinder import exception
 from cinder.i18n import _
 from cinder.objects import fields
-
 from cinder.volume.drivers.dell_emc.vnx import client
 from cinder.volume.drivers.dell_emc.vnx import common
 from cinder.volume.drivers.dell_emc.vnx import replication
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/vnx/client.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/vnx/client.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/vnx/client.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/vnx/client.py	2020-03-24 18:46:31.000000000 +0000
@@ -505,7 +505,7 @@ class Client(object):
         """Adds the `lun` to `storage_group`."""
         try:
             return storage_group.attach_alu(lun, max_retries)
-        except storops_ex.VNXAluAlreadyAttachedError as ex:
+        except storops_ex.VNXAluAlreadyAttachedError:
             # Ignore the failure due to retry.
             return storage_group.get_hlu(lun)
         except storops_ex.VNXNoHluAvailableError as ex:
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/vnx/taskflows.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/vnx/taskflows.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/vnx/taskflows.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/vnx/taskflows.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,8 +15,6 @@
 
 from oslo_log import log as logging
 from oslo_utils import importutils
-
-
 import taskflow.engines
 from taskflow.patterns import linear_flow
 from taskflow import task
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/vnx/utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/vnx/utils.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/vnx/utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/vnx/utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,6 @@
 # License for the specific language governing permissions and limitations
 # under the License.
 
-import six
 import time
 
 from oslo_log import log as logging
@@ -21,6 +20,7 @@ from oslo_service import loopingcall
 from oslo_utils import excutils
 from oslo_utils import importutils
 from oslo_utils import uuidutils
+import six
 
 from cinder import exception
 from cinder.i18n import _
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/vxflexos/driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/vxflexos/driver.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/vxflexos/driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/vxflexos/driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -1096,11 +1096,14 @@ class VxFlexOSDriver(driver.VolumeDriver
                  {'vol': volume,
                   'service': six.text_type(image_service),
                   'meta': six.text_type(image_meta)})
+        # retrieve store information from extra-specs
+        store_id = volume.volume_type.extra_specs.get('image_service:store_id')
         try:
             image_utils.upload_volume(context,
                                       image_service,
                                       image_meta,
-                                      self._sio_attach_volume(volume))
+                                      self._sio_attach_volume(volume),
+                                      store_id=store_id)
         finally:
             self._sio_detach_volume(volume)
 
diff -pruN 2:15.0.1-1/cinder/volume/drivers/dell_emc/xtremio.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/xtremio.py
--- 2:15.0.1-1/cinder/volume/drivers/dell_emc/xtremio.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/dell_emc/xtremio.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,9 +12,9 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Driver for Dell EMC XtremIO Storage.
-supported XtremIO version 2.4 and up
+"""Driver for Dell EMC XtremIO Storage.
+
+Supports XtremIO version 2.4 and up.
 
 .. code-block:: none
 
@@ -36,13 +36,13 @@ supported XtremIO version 2.4 and up
 import json
 import math
 import random
-import requests
 import string
 
 from oslo_config import cfg
 from oslo_log import log as logging
 from oslo_utils import strutils
 from oslo_utils import units
+import requests
 import six
 from six.moves import http_client
 
@@ -58,7 +58,6 @@ from cinder.volume.drivers.san import sa
 from cinder.volume import volume_utils
 from cinder.zonemanager import utils as fczm_utils
 
-
 LOG = logging.getLogger(__name__)
 
 CONF = cfg.CONF
@@ -552,8 +551,7 @@ class XtremIOVolumeDriver(san.SanDriver)
                                                             src_vref['id'])
         limit = self.configuration.safe_get('xtremio_volumes_per_glance_cache')
         if cache and limit and limit > 0 and limit <= vol['num-of-dest-snaps']:
-            raise exception.CinderException('Exceeded the configured limit of '
-                                            '%d snapshots per volume' % limit)
+            raise exception.SnapshotLimitReached(set_limit=limit)
         try:
             self.client.create_snapshot(src_vref['id'], volume['id'])
         except XtremIOSnapshotsLimitExceeded as e:
diff -pruN 2:15.0.1-1/cinder/volume/drivers/fujitsu/eternus_dx/constants.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/fujitsu/eternus_dx/constants.py
--- 2:15.0.1-1/cinder/volume/drivers/fujitsu/eternus_dx/constants.py	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/fujitsu/eternus_dx/constants.py	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,120 @@
+# Copyright (c) 2019 FUJITSU LIMITED
+# All Rights Reserved.
+#
+#    Licensed under the Apache License, Version 2.0 (the "License"); you may
+#    not use this file except in compliance with the License. You may obtain
+#    a copy of the License at
+#
+#         http://www.apache.org/licenses/LICENSE-2.0
+#
+#    Unless required by applicable law or agreed to in writing, software
+#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+#    License for the specific language governing permissions and limitations
+#    under the License.
+#
+
+RAIDGROUP = 2
+TPPOOL = 5
+SNAPOPC = 4
+OPC = 5
+RETURN_TO_RESOURCEPOOL = 19
+DETACH = 8
+BROKEN = 5
+
+JOB_RETRIES = 60
+JOB_INTERVAL_SEC = 10
+TIMES_MIN = 3
+EC_REC = 3
+RETRY_INTERVAL = 5
+# Error code keyword.
+VOLUME_IS_BUSY = 32786
+DEVICE_IS_BUSY = 32787
+VOLUMENAME_IN_USE = 32788
+COPYSESSION_NOT_EXIST = 32793
+LUNAME_IN_USE = 4102
+LUNAME_NOT_EXIST = 4097  # Only for InvokeMethod(HidePaths).
+VOL_PREFIX = "FJosv_"
+REPL = "FUJITSU_ReplicationService"
+STOR_CONF = "FUJITSU_StorageConfigurationService"
+CTRL_CONF = "FUJITSU_ControllerConfigurationService"
+UNDEF_MSG = 'Undefined Error!!'
+
+POOL_TYPE_dic = {
+    RAIDGROUP: 'RAID_GROUP',
+    TPPOOL: 'Thinporvisioning_POOL',
+}
+POOL_TYPE_list = [
+    'RAID',
+    'TPP'
+]
+OPERATION_dic = {
+    SNAPOPC: RETURN_TO_RESOURCEPOOL,
+    OPC: DETACH,
+    EC_REC: DETACH,
+}
+
+RETCODE_dic = {
+    '0': 'Success',
+    '1': 'Method Not Supported',
+    '4': 'Failed',
+    '5': 'Invalid Parameter',
+    '4096': 'Method Parameters Checked - Job Started',
+    '4097': 'Size Not Supported',
+    '4101': 'Target/initiator combination already exposed',
+    '4102': 'Requested logical unit number in use',
+    '32769': 'Maximum number of Logical Volume in a RAID group '
+             'has been reached',
+    '32770': 'Maximum number of Logical Volume in the storage device '
+             'has been reached',
+    '32771': 'Maximum number of registered Host WWN '
+             'has been reached',
+    '32772': 'Maximum number of affinity group has been reached',
+    '32773': 'Maximum number of host affinity has been reached',
+    '32781': 'Not available under current system configuration',
+    '32782': 'Controller firmware update in process',
+    '32785': 'The RAID group is in busy state',
+    '32786': 'The Logical Volume is in busy state',
+    '32787': 'The device is in busy state',
+    '32788': 'Element Name is in use',
+    '32791': 'Maximum number of copy session has been reached',
+    '32792': 'No Copy License',
+    '32793': 'Session does not exist',
+    '32794': 'Phase is not correct',
+    '32796': 'Quick Format Error',
+    '32801': 'The CA port is in invalid setting',
+    '32802': 'The Logical Volume is Mainframe volume',
+    '32803': 'The RAID group is not operative',
+    '32804': 'The Logical Volume is not operative',
+    '32805': 'The Logical Element is Thin provisioning Pool Volume',
+    '32806': 'The Logical Volume is pool for copy volume',
+    '32807': 'The Logical Volume is unknown volume',
+    '32808': 'No Thin Provisioning License',
+    '32809': 'The Logical Element is ODX volume',
+    '32810': 'The specified volume is under use as NAS volume',
+    '32811': 'This operation cannot be performed to the NAS resources',
+    '32812': 'This operation cannot be performed to the '
+             'Transparent Failover resources',
+    '32813': 'This operation cannot be performed to the '
+             'VVOL resources',
+    '32816': 'Generic fatal error',
+    '32817': 'Inconsistent State with 1Step Restore '
+             'operation',
+    '32818': 'REC Path failure during copy',
+    '32819': 'RAID failure during EC/REC copy',
+    '32820': 'Previous command in process',
+    '32821': 'Cascade local copy session exist',
+    '32822': 'Cascade EC/REC session is not suspended',
+    '35302': 'Invalid LogicalElement',
+    '35304': 'LogicalElement state error',
+    '35316': 'Multi-hop error',
+    '35318': 'Maximum number of multi-hop has been reached',
+    '35324': 'RAID is broken',
+    '35331': 'Maximum number of session has been reached(per device)',
+    '35333': 'Maximum number of session has been reached(per SourceElement)',
+    '35334': 'Maximum number of session has been reached(per TargetElement)',
+    '35335': 'Maximum number of Snapshot generation has been reached '
+             '(per SourceElement)',
+    '35346': 'Copy table size is not setup',
+    '35347': 'Copy table size is not enough',
+}
diff -pruN 2:15.0.1-1/cinder/volume/drivers/fujitsu/eternus_dx/eternus_dx_cli.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/fujitsu/eternus_dx/eternus_dx_cli.py
--- 2:15.0.1-1/cinder/volume/drivers/fujitsu/eternus_dx/eternus_dx_cli.py	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/fujitsu/eternus_dx/eternus_dx_cli.py	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,264 @@
+# Copyright (c) 2019 FUJITSU LIMITED
+# All Rights Reserved.
+#
+#    Licensed under the Apache License, Version 2.0 (the "License"); you may
+#    not use this file except in compliance with the License. You may obtain
+#    a copy of the License at
+#
+#         http://www.apache.org/licenses/LICENSE-2.0
+#
+#    Unless required by applicable law or agreed to in writing, software
+#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+#    License for the specific language governing permissions and limitations
+#    under the License.
+#
+
+"""Cinder Volume driver for Fujitsu ETERNUS DX S3 series."""
+import six
+
+from cinder.i18n import _
+from cinder import ssh_utils
+
+
+class FJDXCLI(object):
+    """ETERNUS CLI Code."""
+
+    def __init__(self, user, storage_ip, password=None, keyfile=None):
+        """Constructor."""
+        self.user = user
+        self.storage_ip = storage_ip
+        if password and keyfile:
+            raise Exception(_('can not specify both password and keyfile'))
+
+        self.use_ipv6 = False
+        if storage_ip.find(':') != -1:
+            self.use_ipv6 = True
+
+        if password:
+            self.ssh_pool = ssh_utils.SSHPool(storage_ip, 22, None, user,
+                                              password=password, max_size=2)
+
+        if keyfile:
+            self.ssh_pool = ssh_utils.SSHPool(storage_ip, 22, None, user,
+                                              privatekey=keyfile, max_size=2)
+
+        self.ce_support = False
+        self.CMD_dic = {
+            'check_user_role': self._check_user_role,
+            'show_pool_provision': self._show_pool_provision,
+        }
+
+        self.SMIS_dic = {
+            '0000': '0',  # Success.
+            '0060': '32787',  # The device is in busy state.
+            '0100': '4097'
+        }  # Size not supported.
+
+    def done(self, command, **option):
+        func = self.CMD_dic.get(command, self._default_func)
+        return func(**option)
+
+    def _exec_cli(self, cmd, StrictHostKeyChecking=True, **option):
+
+        exec_cmdline = cmd + self._get_option(**option)
+        stdoutdata = self._exec_cli_with_eternus(exec_cmdline)
+        output = []
+        message = []
+        stdoutlist = stdoutdata.split('\r\n')
+        output_header = ""
+
+        for no, outline in enumerate(stdoutlist):
+            if len(outline) <= 0 or outline is None:
+                continue
+
+            if not output_header.endswith(exec_cmdline):
+                output_header += outline
+                continue
+
+            if 0 <= outline.find('Error'):
+                raise Exception(_("Output: %(outline)s: "
+                                  "Command: %(cmdline)s")
+                                % {'outline': outline,
+                                   'cmdline': exec_cmdline})
+
+            if not self._is_status(outline):
+                continue
+
+            status = int(outline, 16)
+            lineno = no + 1
+            break
+        else:
+            raise Exception(_(
+                "Invalid CLI output: %(exec_cmdline)s, %(stdoutlist)s")
+                % {'exec_cmdline': exec_cmdline,
+                   'stdoutlist': stdoutlist})
+
+        if status == 0:
+            rc = '0'
+            for outline in stdoutlist[lineno:]:
+                if 0 <= outline.find('CLI>'):
+                    continue
+                if len(outline) <= 0:
+                    continue
+                if outline is None:
+                    continue
+                message.append(outline)
+        else:
+            code = stdoutlist[lineno]
+            for outline in stdoutlist[lineno + 1:]:
+                if 0 <= outline.find('CLI>'):
+                    continue
+                if len(outline) <= 0:
+                    continue
+                if outline is None:
+                    continue
+                output.append(outline)
+
+            rc, message = self._create_error_message(code, output)
+
+        return {'result': 0, 'rc': rc, 'message': message}
+
+    def _exec_cli_with_eternus(self, exec_cmdline):
+        """Execute CLI command with arguments."""
+        ssh = None
+        try:
+            ssh = self.ssh_pool.get()
+            chan = ssh.invoke_shell()
+            chan.send(exec_cmdline + '\n')
+            stdoutdata = ''
+            while True:
+                temp = chan.recv(65535)
+                if isinstance(temp, six.binary_type):
+                    temp = temp.decode('utf-8')
+                else:
+                    temp = str(temp)
+                stdoutdata += temp
+
+                # CLI command end with 'CLI>'.
+                if stdoutdata == '\r\nCLI> ':
+                    continue
+                if (stdoutdata[len(stdoutdata) - 5: len(stdoutdata) - 1] ==
+                        'CLI>'):
+                    break
+        except Exception as e:
+            raise Exception(_("Execute CLI "
+                              "command error. Error: %s") % six.text_type(e))
+        finally:
+            if ssh:
+                self.ssh_pool.put(ssh)
+                self.ssh_pool.remove(ssh)
+        return stdoutdata
+
+    def _create_error_message(self, code, msg):
+        """Create error code and message using arguements."""
+        message = None
+        if code in self.SMIS_dic:
+            rc = self.SMIS_dic[code]
+        else:
+            rc = 'E' + code
+
+            # TODO(whfnst): we will have a dic to store errors.
+            if rc == "E0001":
+                message = "Bad value: %s" % msg
+            elif rc == "ED184":
+                message = "Because OPC is being executed, "
+                "the processing was discontinued."
+            else:
+                message = msg
+
+        return rc, message
+
+    @staticmethod
+    def _is_status(value):
+        """Check whether input value is status value or not."""
+        try:
+            if len(value) != 2:
+                return False
+
+            int(value, 16)
+            int(value[0], 16)
+            int(value[1], 16)
+
+            return True
+        except ValueError:
+            return False
+
+    @staticmethod
+    def _get_option(**option):
+        """Create option strings from dictionary."""
+        ret = ""
+        for key, value in six.iteritems(option):
+            ret += " -%(key)s %(value)s" % {'key': key, 'value': value}
+        return ret
+
+    def _default_func(self, **option):
+        """Default function."""
+        raise Exception(_("Invalid function is specified"))
+
+    def _check_user_role(self, **option):
+        """Check user role."""
+        try:
+            output = self._exec_cli("show users",
+                                    StrictHostKeyChecking=False,
+                                    **option)
+            # Return error.
+            rc = output['rc']
+            if rc != "0":
+                return output
+
+            userlist = output.get('message')
+            role = None
+            for userinfo in userlist:
+                username = userinfo.split('\t')[0]
+                if username == self.user:
+                    role = userinfo.split('\t')[1]
+                    break
+
+            output['message'] = role
+        except Exception as ex:
+            if 'show users' in six.text_type(ex):
+                msg = ("Specified user(%s) does not have Software role"
+                       % self.user)
+            elif 'Error connecting' in six.text_type(ex):
+                msg = (six.text_type(ex)[34:] +
+                       ', Please check fujitsu_private_key_path or .xml file')
+            else:
+                msg = six.text_type(ex)
+            output = {
+                'result': 0,
+                'rc': '4',
+                'message': msg
+            }
+        return output
+
+    def _show_pool_provision(self, **option):
+        """Get TPP provision capacity information."""
+        try:
+            output = self._exec_cli("show volumes", **option)
+
+            rc = output['rc']
+
+            if rc != "0":
+                return output
+
+            clidatalist = output.get('message')
+
+            data = 0
+            for clidataline in clidatalist[1:]:
+                clidata = clidataline.split('\t')
+                if clidata[0] == 'FFFF':
+                    break
+                data += int(clidata[7], 16)
+            provision = data / 2097152
+
+            output['message'] = provision
+        except Exception as ex:
+            output = {
+                'result': 0,
+                'rc': '4',
+                'message': "show pool provision capacity error: %s"
+                           % six.text_type(ex)
+            }
+
+        return output
diff -pruN 2:15.0.1-1/cinder/volume/drivers/fujitsu/eternus_dx/eternus_dx_common.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/fujitsu/eternus_dx/eternus_dx_common.py
--- 2:15.0.1-1/cinder/volume/drivers/fujitsu/eternus_dx/eternus_dx_common.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/fujitsu/eternus_dx/eternus_dx_common.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,9 +16,8 @@
 #    under the License.
 #
 
-"""
-Cinder Volume driver for Fujitsu ETERNUS DX S3 series.
-"""
+"""Cinder Volume driver for Fujitsu ETERNUS DX S3 series."""
+
 import ast
 import base64
 import hashlib
@@ -36,6 +35,9 @@ from cinder import exception
 from cinder.i18n import _
 from cinder import utils
 from cinder.volume import configuration as conf
+from cinder.volume.drivers.fujitsu.eternus_dx import constants as CONSTANTS
+from cinder.volume.drivers.fujitsu.eternus_dx import eternus_dx_cli
+from cinder.volume import volume_utils
 
 LOG = logging.getLogger(__name__)
 CONF = cfg.CONF
@@ -46,99 +48,12 @@ try:
 except ImportError:
     pywbemAvailable = False
 
-VOL_PREFIX = "FJosv_"
-RAIDGROUP = 2
-TPPOOL = 5
-SNAPOPC = 4
-OPC = 5
-RETURN_TO_RESOURCEPOOL = 19
-DETACH = 8
-INITIALIZED = 2
-UNSYNCHRONIZED = 3
-BROKEN = 5
-PREPARED = 11
-REPL = "FUJITSU_ReplicationService"
-STOR_CONF = "FUJITSU_StorageConfigurationService"
-CTRL_CONF = "FUJITSU_ControllerConfigurationService"
-STOR_HWID = "FUJITSU_StorageHardwareIDManagementService"
-
-UNDEF_MSG = 'Undefined Error!!'
-JOB_RETRIES = 60
-JOB_INTERVAL_SEC = 10
-
-# Error code keyword.
-VOLUME_IS_BUSY = 32786
-DEVICE_IS_BUSY = 32787
-VOLUMENAME_IN_USE = 32788
-COPYSESSION_NOT_EXIST = 32793
-LUNAME_IN_USE = 4102
-LUNAME_NOT_EXIST = 4097  # Only for InvokeMethod(HidePaths).
-EC_REC = 3
 FJ_ETERNUS_DX_OPT_opts = [
     cfg.StrOpt('cinder_eternus_config_file',
                default='/etc/cinder/cinder_fujitsu_eternus_dx.xml',
-               help='config file for cinder eternus_dx volume driver'),
+               help='Config file for cinder eternus_dx volume driver.'),
 ]
 
-POOL_TYPE_dic = {
-    RAIDGROUP: 'RAID_GROUP',
-    TPPOOL: 'Thinporvisioning_POOL',
-}
-
-OPERATION_dic = {
-    SNAPOPC: RETURN_TO_RESOURCEPOOL,
-    OPC: DETACH,
-    EC_REC: DETACH,
-}
-
-RETCODE_dic = {
-    '0': 'Success',
-    '1': 'Method Not Supported',
-    '4': 'Failed',
-    '5': 'Invalid Parameter',
-    '4096': 'Method Parameters Checked - Job Started',
-    '4097': 'Size Not Supported',
-    '4101': 'Target/initiator combination already exposed',
-    '4102': 'Requested logical unit number in use',
-    '32769': 'Maximum number of Logical Volume in a RAID group '
-             'has been reached',
-    '32770': 'Maximum number of Logical Volume in the storage device '
-             'has been reached',
-    '32771': 'Maximum number of registered Host WWN '
-             'has been reached',
-    '32772': 'Maximum number of affinity group has been reached',
-    '32773': 'Maximum number of host affinity has been reached',
-    '32785': 'The RAID group is in busy state',
-    '32786': 'The Logical Volume is in busy state',
-    '32787': 'The device is in busy state',
-    '32788': 'Element Name is in use',
-    '32792': 'No Copy License',
-    '32793': 'Session is not exist',
-    '32796': 'Quick Format Error',
-    '32801': 'The CA port is in invalid setting',
-    '32802': 'The Logical Volume is Mainframe volume',
-    '32803': 'The RAID group is not operative',
-    '32804': 'The Logical Volume is not operative',
-    '32808': 'No Thin Provisioning License',
-    '32809': 'The Logical Element is ODX volume',
-    '32811': 'This operation cannot be performed to the NAS resources',
-    '32812': 'This operation cannot be performed to the Storage Cluster '
-             'resources',
-    '32816': 'Fatal error generic',
-    '35302': 'Invalid LogicalElement',
-    '35304': 'LogicalElement state error',
-    '35316': 'Multi-hop error',
-    '35318': 'Maximum number of multi-hop has been reached',
-    '35324': 'RAID is broken',
-    '35331': 'Maximum number of session has been reached(per device)',
-    '35333': 'Maximum number of session has been reached(per SourceElement)',
-    '35334': 'Maximum number of session has been reached(per TargetElement)',
-    '35335': 'Maximum number of Snapshot generation has been reached '
-             '(per SourceElement)',
-    '35346': 'Copy table size is not setup',
-    '35347': 'Copy table size is not enough',
-}
-
 CONF.register_opts(FJ_ETERNUS_DX_OPT_opts, group=conf.SHARED_CONF_GROUP)
 
 
@@ -148,10 +63,7 @@ class FJDXCommon(object):
     VERSION = "1.3.0"
     stats = {
         'driver_version': VERSION,
-        'free_capacity_gb': 0,
-        'reserved_percentage': 0,
         'storage_protocol': None,
-        'total_capacity_gb': 0,
         'vendor_name': 'FUJITSU',
         'QoS_support': False,
         'volume_backend_name': None,
@@ -169,6 +81,9 @@ class FJDXCommon(object):
             # Get iSCSI ipaddress from driver configuration file.
             self.configuration.iscsi_ip_address = (
                 self._get_drvcfg('EternusISCSIIP'))
+        self.conn = None
+        self.fjdxcli = {}
+        self._check_user()
 
     @staticmethod
     def get_driver_options():
@@ -190,16 +105,16 @@ class FJDXCommon(object):
                    'volumesize': volumesize})
 
         # get poolname from driver configuration file
-        eternus_pool = self._get_drvcfg('EternusPool')
+        eternus_pool = volume_utils.extract_host(volume['host'], 'pool')
         # Existence check the pool
         pool = self._find_pool(eternus_pool)
 
         if 'RSP' in pool['InstanceID']:
-            pooltype = RAIDGROUP
+            pooltype = CONSTANTS.RAIDGROUP
         else:
-            pooltype = TPPOOL
+            pooltype = CONSTANTS.TPPOOL
 
-        configservice = self._find_eternus_service(STOR_CONF)
+        configservice = self._find_eternus_service(CONSTANTS.STOR_CONF)
         if configservice is None:
             msg = (_('create_volume, volume: %(volume)s, '
                      'volumename: %(volumename)s, '
@@ -233,7 +148,7 @@ class FJDXCommon(object):
             ElementType=self._pywbem_uint(pooltype, '16'),
             Size=self._pywbem_uint(volumesize, '64'))
 
-        if rc == VOLUMENAME_IN_USE:  # Element Name is in use
+        if rc == CONSTANTS.VOLUMENAME_IN_USE:  # Element Name is in use
             LOG.warning('create_volume, '
                         'volumename: %(volumename)s, '
                         'Element Name is in use.',
@@ -280,7 +195,7 @@ class FJDXCommon(object):
                    'errordesc': errordesc,
                    'backend': systemnamelist[0]['IdentifyingNumber'],
                    'eternus_pool': eternus_pool,
-                   'pooltype': POOL_TYPE_dic[pooltype]})
+                   'pooltype': CONSTANTS.POOL_TYPE_dic[pooltype]})
 
         # Create return value.
         element_path = {
@@ -299,10 +214,53 @@ class FJDXCommon(object):
                     'FJ_Volume_Name': volumename,
                     'FJ_Volume_No': volume_no,
                     'FJ_Pool_Name': eternus_pool,
-                    'FJ_Pool_Type': POOL_TYPE_dic[pooltype]}
+                    'FJ_Pool_Type': CONSTANTS.POOL_TYPE_dic[pooltype]}
 
         return (element_path, metadata)
 
+    def create_pool_info(self, pool_instance, volume_count, pool_type):
+        """Create pool information from pool instance."""
+        LOG.debug('create_pool_info, pool_instance: %(pool)s, '
+                  'volume_count: %(volcount)s, pool_type: %(ptype)s.',
+                  {'pool': pool_instance,
+                   'volcount': volume_count, 'ptype': pool_type})
+
+        if pool_type not in CONSTANTS.POOL_TYPE_list:
+            msg = (_('Invalid pool type was specified : %s.') % pool_type)
+            LOG.error(msg)
+            raise exception.VolumeBackendAPIException(data=msg)
+
+        total_gb = pool_instance['TotalManagedSpace'] / units.Gi
+        free_gb = pool_instance['RemainingManagedSpace'] / units.Gi
+
+        if hasattr(pool_instance, 'provisioned_capacity_gb'):
+            prov_gb = pool_instance.provisioned_capacity_gb
+        else:
+            prov_gb = total_gb - free_gb
+
+        if pool_type == 'RAID':
+            useable_gb = free_gb
+        else:
+            # If the ratio is less than the value on ETERNUS,
+            # useable_gb may be negative. Avoid over-allocation.
+            max_capacity = total_gb * float(
+                self.configuration.max_over_subscription_ratio)
+            useable_gb = max_capacity - prov_gb
+
+        pool = {
+            'name': pool_instance['ElementName'],
+            'path': pool_instance.path,
+            'total_capacity_gb': total_gb,
+            'free_capacity_gb': free_gb,
+            'type': pool_type,
+            'volume_count': volume_count,
+            'provisioned_capacity_gb': prov_gb,
+            'useable_capacity_gb': useable_gb
+        }
+
+        LOG.debug('create_pool_info, pool: %s.', pool)
+        return pool
+
     def create_volume_from_snapshot(self, volume, snapshot):
         """Creates a volume from a snapshot."""
         LOG.debug('create_volume_from_snapshot, '
@@ -390,8 +348,8 @@ class FJDXCommon(object):
                   {'t_volumename': t_volumename,
                    's_volumename': s_volumename})
 
-        # Get replicationservice for CreateElementReplica.
-        repservice = self._find_eternus_service(REPL)
+        # Get replication service for CreateElementReplica.
+        repservice = self._find_eternus_service(CONSTANTS.REPL)
 
         if repservice is None:
             msg = _('_create_local_cloned_volume, '
@@ -513,7 +471,7 @@ class FJDXCommon(object):
 
         volumename = vol_instance['ElementName']
 
-        configservice = self._find_eternus_service(STOR_CONF)
+        configservice = self._find_eternus_service(CONSTANTS.STOR_CONF)
         if configservice is None:
             msg = (_('_delete_volume, volumename: %(volumename)s, '
                      'Storage Configuration Service not found.')
@@ -565,7 +523,7 @@ class FJDXCommon(object):
         d_volumename = self._create_volume_name(snapshot['id'])
         s_volumename = self._create_volume_name(vol_id)
         vol_instance = self._find_lun(volume)
-        repservice = self._find_eternus_service(REPL)
+        repservice = self._find_eternus_service(CONSTANTS.REPL)
 
         # Check the existence of volume.
         if vol_instance is None:
@@ -803,32 +761,30 @@ class FJDXCommon(object):
                    'vol_instance': vol_instance.path})
 
         # Get poolname from driver configuration file.
-        eternus_pool = self._get_drvcfg('EternusPool')
-        # Check the existence of volume.
-        pool = self._find_pool(eternus_pool)
+        pool_name, pool = self._find_pool_from_volume(vol_instance)
         if pool is None:
             msg = (_('extend_volume, '
                      'eternus_pool: %(eternus_pool)s, '
                      'pool not found.')
-                   % {'eternus_pool': eternus_pool})
+                   % {'eternus_pool': pool_name})
             LOG.error(msg)
             raise exception.VolumeBackendAPIException(data=msg)
 
         # Set pooltype.
         if 'RSP' in pool['InstanceID']:
-            pooltype = RAIDGROUP
+            pooltype = CONSTANTS.RAIDGROUP
         else:
-            pooltype = TPPOOL
+            pooltype = CONSTANTS.TPPOOL
 
-        configservice = self._find_eternus_service(STOR_CONF)
-        if configservice is None:
+        configservice = self._find_eternus_service(CONSTANTS.STOR_CONF)
+        if not configservice:
             msg = (_('extend_volume, volume: %(volume)s, '
                      'volumename: %(volumename)s, '
                      'eternus_pool: %(eternus_pool)s, '
                      'Storage Configuration Service not found.')
                    % {'volume': volume,
                       'volumename': volumename,
-                      'eternus_pool': eternus_pool})
+                      'eternus_pool': pool_name})
             LOG.error(msg)
             raise exception.VolumeBackendAPIException(data=msg)
 
@@ -842,7 +798,7 @@ class FJDXCommon(object):
                   'TheElement: %(vol_instance)s.',
                   {'service': configservice,
                    'volumename': volumename,
-                   'eternus_pool': eternus_pool,
+                   'eternus_pool': pool_name,
                    'pooltype': pooltype,
                    'volumesize': volumesize,
                    'vol_instance': vol_instance.path})
@@ -866,7 +822,7 @@ class FJDXCommon(object):
                    % {'volumename': volumename,
                       'rc': rc,
                       'errordesc': errordesc,
-                      'pooltype': POOL_TYPE_dic[pooltype]})
+                      'pooltype': CONSTANTS.POOL_TYPE_dic[pooltype]})
 
             LOG.error(msg)
             raise exception.VolumeBackendAPIException(data=msg)
@@ -880,48 +836,21 @@ class FJDXCommon(object):
                   {'volumename': volumename,
                    'rc': rc,
                    'errordesc': errordesc,
-                   'eternus_pool': eternus_pool,
-                   'pooltype': POOL_TYPE_dic[pooltype]})
+                   'eternus_pool': pool_name,
+                   'pooltype': CONSTANTS.POOL_TYPE_dic[pooltype]})
 
-        return eternus_pool
+        return pool_name
 
     @lockutils.synchronized('ETERNUS-update', 'cinder-', True)
     def update_volume_stats(self):
-        """get pool capacity."""
+        """Get pool capacity."""
 
         self.conn = self._get_eternus_connection()
-        eternus_pool = self._get_drvcfg('EternusPool')
 
-        LOG.debug('update_volume_stats, pool name: %s.', eternus_pool)
+        poolname_list = self._get_drvcfg('EternusPool', multiple=True)
+        self._find_pools(poolname_list, self.conn)
 
-        pool = self._find_pool(eternus_pool, True)
-        if pool:
-            # pool is found
-            self.stats['total_capacity_gb'] = (
-                pool['TotalManagedSpace'] / units.Gi)
-
-            self.stats['free_capacity_gb'] = (
-                pool['RemainingManagedSpace'] / units.Gi)
-        else:
-            # if pool information is unknown, set 0 GB to capacity information
-            LOG.warning('update_volume_stats, '
-                        'eternus_pool:%(eternus_pool)s, '
-                        'specified pool is not found.',
-                        {'eternus_pool': eternus_pool})
-            self.stats['total_capacity_gb'] = 0
-            self.stats['free_capacity_gb'] = 0
-
-        self.stats['multiattach'] = False
-
-        LOG.debug('update_volume_stats, '
-                  'eternus_pool:%(eternus_pool)s, '
-                  'total capacity[%(total)s], '
-                  'free capacity[%(free)s].',
-                  {'eternus_pool': eternus_pool,
-                   'total': self.stats['total_capacity_gb'],
-                   'free': self.stats['free_capacity_gb']})
-
-        return (self.stats, eternus_pool)
+        return (self.stats, poolname_list)
 
     def _get_mapdata(self, vol_instance, connector, target_portlist):
         """return mapping information."""
@@ -1099,9 +1028,9 @@ class FJDXCommon(object):
         return mapdata
 
     def _get_drvcfg(self, tagname, filename=None, multiple=False):
-        """read from driver configuration file."""
-        if filename is None:
-            # set default configuration file name
+        """Read from driver configuration file."""
+        if not filename:
+            # Set default configuration file name.
             filename = self.configuration.cinder_eternus_config_file
 
         LOG.debug("_get_drvcfg, input[%(filename)s][%(tagname)s].",
@@ -1110,7 +1039,6 @@ class FJDXCommon(object):
         tree = ET.parse(filename)
         elem = tree.getroot()
 
-        ret = None
         if not multiple:
             ret = elem.findtext(".//" + tagname)
         else:
@@ -1179,7 +1107,7 @@ class FJDXCommon(object):
 
         # pylint: disable=E1121
         volumename = base64.urlsafe_b64encode(m.digest()).decode()
-        ret = VOL_PREFIX + six.text_type(volumename)
+        ret = CONSTANTS.VOL_PREFIX + six.text_type(volumename)
 
         LOG.debug('_create_volume_name, ret: %s', ret)
         return ret
@@ -1228,6 +1156,138 @@ class FJDXCommon(object):
         LOG.debug('_find_pool, pool: %s.', ret)
         return ret
 
+    def _find_pools(self, poolname_list, conn):
+        """Find Instance or InstanceName of pool by pool name on ETERNUS."""
+        LOG.debug('_find_pool, pool name: %s.', poolname_list)
+
+        target_poolname = list(poolname_list)
+        pools = []
+
+        # Get pools info from CIM instance(include info about instance path).
+        try:
+            tppoollist = self._enum_eternus_instances(
+                'FUJITSU_ThinProvisioningPool', conn=conn)
+            rgpoollist = self._enum_eternus_instances(
+                'FUJITSU_RAIDStoragePool', conn=conn)
+        except Exception:
+            msg = (_('_find_pool, '
+                     'eternus_pool:%(eternus_pool)s, '
+                     'EnumerateInstances, '
+                     'cannot connect to ETERNUS.')
+                   % {'eternus_pool': target_poolname})
+            LOG.error(msg)
+            raise exception.VolumeBackendAPIException(data=msg)
+
+        # Make total pools list.
+        tppools = [(tppool, 'TPP') for tppool in tppoollist]
+        rgpools = [(rgpool, 'RAID') for rgpool in rgpoollist]
+        poollist = tppools + rgpools
+
+        # One eternus backend has only one special pool name
+        # so just use pool name can get the target pool.
+        for pool, ptype in poollist:
+            poolname = pool['ElementName']
+
+            LOG.debug('_find_pools, '
+                      'pool: %(pool)s, ptype: %(ptype)s.',
+                      {'pool': poolname, 'ptype': ptype})
+            if poolname in target_poolname:
+                try:
+                    volume_list = self._assoc_eternus_names(
+                        pool.path,
+                        conn=conn,
+                        AssocClass='FUJITSU_AllocatedFromStoragePool',
+                        ResultClass='FUJITSU_StorageVolume')
+
+                    volume_count = len(volume_list)
+                except Exception:
+                    msg = (_('_find_pools, '
+                             'poolname: %(poolname)s, '
+                             'pooltype: %(ptype)s, '
+                             'Associator Names, '
+                             'cannot connect to ETERNUS.')
+                           % {'ptype': ptype,
+                              'poolname': poolname})
+                    LOG.error(msg)
+                    raise exception.VolumeBackendAPIException(data=msg)
+
+                if ptype == 'TPP':
+                    param_dict = {
+                        'pool-name': poolname
+                    }
+                    rc, errordesc, data = self._exec_eternus_cli(
+                        'show_pool_provision', **param_dict)
+
+                    if rc != 0:
+                        msg = (_('_find_pools, show_pool_provision, '
+                                 'pool name: %(pool_name)s, '
+                                 'Return code: %(rc)lu, '
+                                 'Error: %(errordesc)s, '
+                                 'Message: %(job)s.')
+                               % {'pool_name': poolname,
+                                  'rc': rc,
+                                  'errordesc': errordesc,
+                                  'job': data})
+                        LOG.error(msg)
+                        raise exception.VolumeBackendAPIException(data=msg)
+
+                    pool.provisioned_capacity_gb = data
+
+                poolinfo = self.create_pool_info(pool, volume_count, ptype)
+
+                target_poolname.remove(poolname)
+                pools.append((poolinfo, poolname))
+
+            if not target_poolname:
+                break
+
+        if not pools:
+            LOG.warning('_find_pools, all the EternusPools in driver '
+                        'configuration file do not exist. '
+                        'Please edit the driver configuration file '
+                        'to include EternusPool names.')
+
+        # Sort pools in the order defined in driver configuration file.
+        sorted_pools = (
+            [pool for name in poolname_list for pool, pname in pools
+             if name == pname])
+
+        LOG.debug('_find_pools, '
+                  'pools: %(pools)s, '
+                  'notfound_pools: %(notfound_pools)s.',
+                  {'pools': pools,
+                   'notfound_pools': target_poolname})
+        pools_stats = {'pools': []}
+        for pool in sorted_pools:
+            single_pool = {}
+            if pool['type'] == 'TPP':
+                thin_enabled = True
+                max_ratio = self.configuration.max_over_subscription_ratio
+            else:
+                thin_enabled = False
+                max_ratio = 1
+
+            single_pool.update(dict(
+                path=pool['path'],
+                pool_name=pool['name'],
+                total_capacity_gb=pool['total_capacity_gb'],
+                total_volumes=pool['volume_count'],
+                free_capacity_gb=pool['free_capacity_gb'],
+                provisioned_capacity_gb=pool['provisioned_capacity_gb'],
+                useable_capacity_gb=pool['useable_capacity_gb'],
+                thin_provisioning_support=thin_enabled,
+                thick_provisioning_support=not thin_enabled,
+                max_over_subscription_ratio=max_ratio,
+            ))
+            single_pool['multiattach'] = False
+            pools_stats['pools'].append(single_pool)
+
+        self.stats['shared_targets'] = True
+        self.stats['backend_state'] = 'up'
+        self.stats['pools'] = pools_stats['pools']
+
+        return self.stats, target_poolname
+
     def _find_eternus_service(self, classname):
         """find CIM instance about service information."""
         LOG.debug('_find_eternus_service, '
@@ -1263,7 +1323,8 @@ class FJDXCommon(object):
                   {'a': classname,
                    'b': instanceNameList,
                    'c': param_dict})
-
+        rc = None
+        retdata = None
         # Use InvokeMethod.
         try:
             rc, retdata = self.conn.InvokeMethod(
@@ -1284,11 +1345,12 @@ class FJDXCommon(object):
         if "Job" in retdata:
             rc = self._wait_for_job_complete(self.conn, retdata)
 
-        if rc == DEVICE_IS_BUSY:
+        if rc == CONSTANTS.DEVICE_IS_BUSY:
             msg = _('Device is in Busy state')
             raise exception.VolumeBackendAPIException(data=msg)
 
-        errordesc = RETCODE_dic.get(six.text_type(rc), UNDEF_MSG)
+        errordesc = CONSTANTS.RETCODE_dic.get(six.text_type(rc),
+                                              CONSTANTS.UNDEF_MSG)
 
         ret = (rc, errordesc, retdata)
 
@@ -1309,11 +1371,14 @@ class FJDXCommon(object):
 
     @lockutils.synchronized('ETERNUS-SMIS-other', 'cinder-', True)
     @utils.retry(exception.VolumeBackendAPIException)
-    def _enum_eternus_instances(self, classname):
+    def _enum_eternus_instances(self, classname, conn=None, **param_dict):
         """Enumerate Instances."""
         LOG.debug('_enum_eternus_instances, classname: %s.', classname)
 
-        ret = self.conn.EnumerateInstances(classname)
+        if not conn:
+            conn = self.conn
+
+        ret = conn.EnumerateInstances(classname, **param_dict)
 
         LOG.debug('_enum_eternus_instances, enum %d instances.', len(ret))
         return ret
@@ -1344,26 +1409,32 @@ class FJDXCommon(object):
 
     @lockutils.synchronized('ETERNUS-SMIS-other', 'cinder-', True)
     @utils.retry(exception.VolumeBackendAPIException)
-    def _assoc_eternus(self, classname, **param_dict):
+    def _assoc_eternus(self, classname, conn=None, **param_dict):
         """Associator."""
         LOG.debug('_assoc_eternus, '
                   'classname: %(cls)s, param: %(param)s.',
                   {'cls': classname, 'param': param_dict})
 
-        ret = self.conn.Associators(classname, **param_dict)
+        if not conn:
+            conn = self.conn
+
+        ret = conn.Associators(classname, **param_dict)
 
         LOG.debug('_assoc_eternus, enum %d instances.', len(ret))
         return ret
 
     @lockutils.synchronized('ETERNUS-SMIS-other', 'cinder-', True)
     @utils.retry(exception.VolumeBackendAPIException)
-    def _assoc_eternus_names(self, classname, **param_dict):
+    def _assoc_eternus_names(self, classname, conn=None, **param_dict):
         """Associator Names."""
         LOG.debug('_assoc_eternus_names, '
                   'classname: %(cls)s, param: %(param)s.',
                   {'cls': classname, 'param': param_dict})
 
-        ret = self.conn.AssociatorNames(classname, **param_dict)
+        if not conn:
+            conn = self.conn
+
+        ret = conn.AssociatorNames(classname, **param_dict)
 
         LOG.debug('_assoc_eternus_names, enum %d names.', len(ret))
         return ret
@@ -1528,7 +1599,7 @@ class FJDXCommon(object):
                       'find target copysession, '
                       'wait for end of copysession.')
 
-            if cpsession_instance['CopyState'] == BROKEN:
+            if cpsession_instance['CopyState'] == CONSTANTS.BROKEN:
                 msg = (_('_wait_for_copy_complete, '
                          'cpsession: %(cpsession)s, '
                          'copysession state is BROKEN.')
@@ -1557,7 +1628,7 @@ class FJDXCommon(object):
         # SnapOPC: 19 (Return To ResourcePool)
         # OPC:8 (Detach)
         # EC/REC:8 (Detach)
-        operation = OPERATION_dic.get(copytype, None)
+        operation = CONSTANTS.OPERATION_dic.get(copytype, None)
         if operation is None:
             msg = (_('_delete_copysession, '
                      'copy session type is undefined! '
@@ -1568,7 +1639,7 @@ class FJDXCommon(object):
             LOG.error(msg)
             raise exception.VolumeBackendAPIException(data=msg)
 
-        repservice = self._find_eternus_service(REPL)
+        repservice = self._find_eternus_service(CONSTANTS.REPL)
         if repservice is None:
             msg = (_('_delete_copysession, '
                      'Cannot find Replication Service'))
@@ -1594,12 +1665,12 @@ class FJDXCommon(object):
                    'rc': rc,
                    'errordesc': errordesc})
 
-        if rc == COPYSESSION_NOT_EXIST:
+        if rc == CONSTANTS.COPYSESSION_NOT_EXIST:
             LOG.debug('_delete_copysession, '
                       'cpsession: %(cpsession)s, '
                       'copysession is not exist.',
                       {'cpsession': cpsession})
-        elif rc == VOLUME_IS_BUSY:
+        elif rc == CONSTANTS.VOLUME_IS_BUSY:
             msg = (_('_delete_copysession, '
                      'copysession: %(cpsession)s, '
                      'operation: %(operation)s, '
@@ -1688,7 +1759,7 @@ class FJDXCommon(object):
         volume_uid = vol_instance['Name']
         initiatorlist = self._find_initiator_names(connector)
         aglist = self._find_affinity_group(connector)
-        configservice = self._find_eternus_service(CTRL_CONF)
+        configservice = self._find_eternus_service(CONSTANTS.CTRL_CONF)
 
         if targetlist is None:
             targetlist = self._get_target_port()
@@ -1748,7 +1819,7 @@ class FJDXCommon(object):
                           {'errordesc': errordesc,
                            'rc': rc})
 
-                if rc != 0 and rc != LUNAME_IN_USE:
+                if rc != 0 and rc != CONSTANTS.LUNAME_IN_USE:
                     LOG.warning('_map_lun, '
                                 'lun_name: %(volume_uid)s, '
                                 'Initiator: %(initiator)s, '
@@ -1781,7 +1852,7 @@ class FJDXCommon(object):
                           {'errordesc': errordesc,
                            'rc': rc})
 
-                if rc != 0 and rc != LUNAME_IN_USE:
+                if rc != 0 and rc != CONSTANTS.LUNAME_IN_USE:
                     LOG.warning('_map_lun, '
                                 'lun_name: %(volume_uid)s, '
                                 'Initiator: %(initiator)s, '
@@ -1946,7 +2017,7 @@ class FJDXCommon(object):
                       {'volume': vol_instance.path,
                        'aglist': aglist})
 
-        configservice = self._find_eternus_service(CTRL_CONF)
+        configservice = self._find_eternus_service(CONSTANTS.CTRL_CONF)
         if configservice is None:
             msg = (_('_unmap_lun, '
                      'vol_instance.path: %(volume)s, '
@@ -1983,7 +2054,7 @@ class FJDXCommon(object):
                       {'errordesc': errordesc,
                        'rc': rc})
 
-            if rc == LUNAME_NOT_EXIST:
+            if rc == CONSTANTS.LUNAME_NOT_EXIST:
                 LOG.debug('_unmap_lun, '
                           'volumename: %(volumename)s, '
                           'Invalid LUNames.',
@@ -2118,7 +2189,7 @@ class FJDXCommon(object):
             """Called at an interval until the job is finished."""
             if self._is_job_finished(conn, job):
                 raise loopingcall.LoopingCallDone()
-            if self.retries > JOB_RETRIES:
+            if self.retries > CONSTANTS.JOB_RETRIES:
                 LOG.error("_wait_for_job_complete, "
                           "failed after %(retries)d tries.",
                           {'retries': self.retries})
@@ -2136,7 +2207,7 @@ class FJDXCommon(object):
 
         self.wait_for_job_called = False
         timer = loopingcall.FixedIntervalLoopingCall(_wait_for_job_complete)
-        timer.start(interval=JOB_INTERVAL_SEC).wait()
+        timer.start(interval=CONSTANTS.JOB_INTERVAL_SEC).wait()
 
         jobInstanceName = job['Job']
         jobinstance = conn.GetInstance(jobInstanceName,
@@ -2189,3 +2260,243 @@ class FJDXCommon(object):
             result = num
 
         return result
+
+    def _find_pool_from_volume(self, vol_instance, manage_type='volume'):
+        """Find Instance or InstanceName of pool by volume instance."""
+        LOG.debug('_find_pool_from_volume, volume: %(volume)s.',
+                  {'volume': vol_instance})
+        poolname = None
+        target_pool = None
+        filename = None
+        conn = self.conn
+
+        # Get poolname of volume on Eternus.
+        try:
+            pools = self._assoc_eternus(
+                vol_instance.path,
+                conn=conn,
+                AssocClass='FUJITSU_AllocatedFromStoragePool',
+                ResultClass='CIM_StoragePool')
+        except Exception:
+            msg = (_('_find_pool_from_volume, '
+                     'vol_instance: %s, '
+                     'Associators: FUJITSU_AllocatedFromStoragePool, '
+                     'cannot connect to ETERNUS.')
+                   % vol_instance.path)
+            LOG.error(msg)
+            raise exception.VolumeBackendAPIException(data=msg)
+
+        if not pools:
+            msg = (_('_find_pool_from_volume, '
+                     'vol_instance: %s, '
+                     'pool not found.')
+                   % vol_instance.path)
+            LOG.error(msg)
+            raise exception.VolumeBackendAPIException(data=msg)
+
+        # Get poolname from driver configuration file.
+        if manage_type == 'volume':
+            cfgpool_list = list(self._get_drvcfg('EternusPool',
+                                                 filename=filename,
+                                                 multiple=True))
+        elif manage_type == 'snapshot':
+            cfgpool_list = list(self._get_drvcfg('EternusSnapPool',
+                                                 filename=filename,
+                                                 multiple=True))
+        LOG.debug('_find_pool_from_volume, cfgpool_list: %(cfgpool_list)s.',
+                  {'cfgpool_list': cfgpool_list})
+        for pool in pools:
+            if pool['ElementName'] in cfgpool_list:
+                poolname = pool['ElementName']
+                target_pool = pool.path
+                break
+
+        if not target_pool:
+            msg = (_('_find_pool_from_volume, '
+                     'vol_instance: %s, '
+                     'the pool of volume not in driver configuration file.')
+                   % vol_instance.path)
+            LOG.error(msg)
+            raise exception.VolumeBackendAPIException(data=msg)
+
+        LOG.debug('_find_pool_from_volume, poolname: %(poolname)s, '
+                  'target_pool: %(target_pool)s.',
+                  {'poolname': poolname, 'target_pool': target_pool})
+        return poolname, target_pool
+
+    def _check_user(self):
+        """Check whether user's role is accessible to ETERNUS and Software."""
+        ret = True
+        rc, errordesc, job = self._exec_eternus_cli('check_user_role')
+        if rc != 0:
+            msg = (_('_check_user, '
+                     'Return code: %(rc)lu, '
+                     'Error: %(errordesc)s, '
+                     'Message: %(job)s.')
+                   % {'rc': rc,
+                      'errordesc': errordesc,
+                      'job': job})
+            LOG.error(msg)
+            raise exception.VolumeBackendAPIException(data=msg)
+
+        if job != 'Software':
+            msg = (_('_check_user, '
+                     'Specified user(%(user)s) does not have '
+                     'Software role: %(role)s.')
+                   % {'user': self._get_drvcfg('EternusUser'),
+                      'role': job})
+            LOG.error(msg)
+            raise exception.VolumeBackendAPIException(data=msg)
+
+        return ret
+
+    def _exec_eternus_cli(self, command, retry=CONSTANTS.TIMES_MIN,
+                          retry_interval=CONSTANTS.RETRY_INTERVAL,
+                          retry_code=[32787], filename=None, timeout=None,
+                          **param_dict):
+        """Execute ETERNUS CLI."""
+        LOG.debug('_exec_eternus_cli, '
+                  'command: %(a)s, '
+                  'filename: %(f)s, '
+                  'timeout: %(t)s, '
+                  'parameters: %(b)s.',
+                  {'a': command,
+                   'f': filename,
+                   't': timeout,
+                   'b': param_dict})
+
+        result = None
+        rc = None
+        retdata = None
+        errordesc = None
+        filename = self.configuration.cinder_eternus_config_file
+        storage_ip = self._get_drvcfg('EternusIP')
+        if not self.fjdxcli.get(filename):
+            user = self._get_drvcfg('EternusUser')
+            password = self._get_drvcfg('EternusPassword')
+            self.fjdxcli[filename] = (
+                eternus_dx_cli.FJDXCLI(user, storage_ip,
+                                       password=password))
+
+        for retry_num in range(retry):
+            # Execute ETERNUS CLI and get return value.
+            try:
+                out_dict = self.fjdxcli[filename].done(command, **param_dict)
+                result = out_dict.get('result')
+                rc_str = out_dict.get('rc')
+                retdata = out_dict.get('message')
+            except Exception as ex:
+                msg = (_('_exec_eternus_cli, '
+                         'unexpected error: %(ex)s.')
+                       % {'ex': ex})
+                LOG.error(msg)
+                raise exception.VolumeBackendAPIException(data=msg)
+
+            # Check ssh result.
+            if result == 255:
+                LOG.info('_exec_eternus_cli, retry, '
+                         'command: %(command)s, '
+                         'option: %(option)s, '
+                         'ip: %(ip)s, '
+                         'SSH Result: %(result)s, '
+                         'retdata: %(retdata)s, '
+                         'TryNum: %(rn)s.',
+                         {'command': command,
+                          'option': param_dict,
+                          'ip': storage_ip,
+                          'result': result,
+                          'retdata': retdata,
+                          'rn': (retry_num + 1)})
+                time.sleep(retry_interval)
+                continue
+            elif result != 0:
+                msg = (_('_exec_eternus_cli, '
+                         'unexpected error, '
+                         'command: %(command)s, '
+                         'option: %(option)s, '
+                         'ip: %(ip)s, '
+                         'resuslt: %(result)s, '
+                         'retdata: %(retdata)s.')
+                       % {'command': command,
+                          'option': param_dict,
+                          'ip': storage_ip,
+                          'result': result,
+                          'retdata': retdata})
+                LOG.error(msg)
+                raise exception.VolumeBackendAPIException(data=msg)
+
+            # Check CLI return code.
+            if rc_str.isdigit():
+                # SMI-S style return code.
+                rc = int(rc_str)
+
+                try:
+                    errordesc = CONSTANTS.RETCODE_dic[str(rc)]
+                except Exception:
+                    errordesc = 'Undefined Error!!'
+
+                if rc in retry_code:
+                    LOG.info('_exec_eternus_cli, retry, '
+                             'ip: %(ip)s, '
+                             'RetryCode: %(rc)s, '
+                             'TryNum: %(rn)s.',
+                             {'ip': storage_ip,
+                              'rc': rc,
+                              'rn': (retry_num + 1)})
+                    time.sleep(retry_interval)
+                    continue
+                if rc == 4:
+                    if ('Authentication failed' in retdata and
+                            retry_num + 1 < retry):
+                        LOG.warning('_exec_eternus_cli, retry, ip: %(ip)s, '
+                                    'Message: %(message)s, '
+                                    'TryNum: %(rn)s.',
+                                    {'ip': storage_ip,
+                                     'message': retdata,
+                                     'rn': (retry_num + 1)})
+                        time.sleep(1)
+                        continue
+
+                break
+            else:
+                # CLI style return code.
+                LOG.warning('_exec_eternus_cli, '
+                            'WARNING!! '
+                            'ip: %(ip)s, '
+                            'ReturnCode: %(rc_str)s, '
+                            'ReturnData: %(retdata)s.',
+                            {'ip': storage_ip,
+                             'rc_str': rc_str,
+                             'retdata': retdata})
+
+                errordesc = rc_str
+                rc = 4  # Failed.
+                break
+        else:
+            if 0 < result:
+                msg = (_('_exec_eternus_cli, '
+                         'cannot connect to ETERNUS. '
+                         'SSH Result: %(result)s, '
+                         'retdata: %(retdata)s.')
+                       % {'result': result,
+                          'retdata': retdata})
+
+                LOG.error(msg)
+                raise exception.VolumeBackendAPIException(data=msg)
+            else:
+                LOG.warning('_exec_eternus_cli, Retry was exceeded.')
+
+        ret = (rc, errordesc, retdata)
+
+        LOG.debug('_exec_eternus_cli, '
+                  'command: %(a)s, '
+                  'parameters: %(b)s, '
+                  'ip: %(ip)s, '
+                  'Return code: %(rc)s, '
+                  'Error: %(errordesc)s.',
+                  {'a': command,
+                   'b': param_dict,
+                   'ip': storage_ip,
+                   'rc': rc,
+                   'errordesc': errordesc})
+        return ret
diff -pruN 2:15.0.1-1/cinder/volume/drivers/fujitsu/eternus_dx/eternus_dx_iscsi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/fujitsu/eternus_dx/eternus_dx_iscsi.py
--- 2:15.0.1-1/cinder/volume/drivers/fujitsu/eternus_dx/eternus_dx_iscsi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/fujitsu/eternus_dx/eternus_dx_iscsi.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,15 +16,13 @@
 #    under the License.
 #
 
-"""
-iSCSI Cinder Volume driver for Fujitsu ETERNUS DX S3 series.
-"""
+"""iSCSI Cinder Volume driver for Fujitsu ETERNUS DX S3 series."""
+from oslo_log import log as logging
 import six
 
 from cinder import interface
 from cinder.volume import driver
 from cinder.volume.drivers.fujitsu.eternus_dx import eternus_dx_common
-from oslo_log import log as logging
 
 LOG = logging.getLogger(__name__)
 
diff -pruN 2:15.0.1-1/cinder/volume/drivers/fusionstorage/constants.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/fusionstorage/constants.py
--- 2:15.0.1-1/cinder/volume/drivers/fusionstorage/constants.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/fusionstorage/constants.py	2020-03-24 18:46:31.000000000 +0000
@@ -18,7 +18,7 @@ LOGIN_SOCKET_TIMEOUT = 32
 
 CONNECT_ERROR = 403
 ERROR_UNAUTHORIZED = 10000003
-VOLUME_NOT_EXIST = 31000000
+VOLUME_NOT_EXIST = (31000000, 50150005)
 
 BASIC_URI = '/dsware/service/'
 CONF_PATH = "/etc/cinder/cinder.conf"
diff -pruN 2:15.0.1-1/cinder/volume/drivers/fusionstorage/dsware.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/fusionstorage/dsware.py
--- 2:15.0.1-1/cinder/volume/drivers/fusionstorage/dsware.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/fusionstorage/dsware.py	2020-03-24 18:46:31.000000000 +0000
@@ -110,9 +110,6 @@ class DSWAREDriver(driver.VolumeDriver):
     VERSION = '2.0'
     CI_WIKI_NAME = 'Huawei_FusionStorage_CI'
 
-    # TODO(jsbryant) Remove driver in the 'U' release due to no py37 support.
-    SUPPORTED = False
-
     def __init__(self, *args, **kwargs):
         super(DSWAREDriver, self).__init__(*args, **kwargs)
 
@@ -161,7 +158,8 @@ class DSWAREDriver(driver.VolumeDriver):
                 "QoS_support": False,
                 "thin_provisioning_support": False,
                 "pools": [],
-                "vendor_name": "Huawei"
+                "vendor_name": "Huawei",
+                "storage_protocol": "SCSI",
                 }
         all_pools = self.client.query_pool_info()
 
@@ -335,7 +333,7 @@ class DSWAREDriver(driver.VolumeDriver):
             self._raise_exception(msg)
         manager_ip = self._get_manager_ip(properties)
         result = self.client.attach_volume(vol_name, manager_ip)
-        attach_path = result[vol_name][0]['devName'].encode('unicode-escape')
+        attach_path = result[vol_name][0]['devName']
         attach_info = dict()
         attach_info['device'] = dict()
         attach_info['device']['path'] = attach_path
diff -pruN 2:15.0.1-1/cinder/volume/drivers/fusionstorage/fs_client.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/fusionstorage/fs_client.py
--- 2:15.0.1-1/cinder/volume/drivers/fusionstorage/fs_client.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/fusionstorage/fs_client.py	2020-03-24 18:46:31.000000000 +0000
@@ -159,7 +159,7 @@ class RestCommon(object):
     def query_volume_by_name(self, vol_name):
         url = '/volume/queryByName?volName=' + vol_name
         result = self.call(url, 'GET')
-        if result.get('errorCode') == constants.VOLUME_NOT_EXIST:
+        if result.get('errorCode') in constants.VOLUME_NOT_EXIST:
             return None
         self._assert_rest_result(
             result, _("Query volume by name session error"))
@@ -168,7 +168,7 @@ class RestCommon(object):
     def query_volume_by_id(self, vol_id):
         url = '/volume/queryById?volId=' + vol_id
         result = self.call(url, 'GET')
-        if result.get('errorCode') == constants.VOLUME_NOT_EXIST:
+        if result.get('errorCode') in constants.VOLUME_NOT_EXIST:
             return None
         self._assert_rest_result(
             result, _("Query volume by ID session error"))
diff -pruN 2:15.0.1-1/cinder/volume/drivers/fusionstorage/fs_conf.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/fusionstorage/fs_conf.py
--- 2:15.0.1-1/cinder/volume/drivers/fusionstorage/fs_conf.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/fusionstorage/fs_conf.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,9 +15,9 @@
 
 import base64
 import os
-import six
 
 from oslo_log import log as logging
+import six
 from six.moves import configparser
 
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/volume/drivers/hedvig/hedvig_cinder.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/hedvig/hedvig_cinder.py
--- 2:15.0.1-1/cinder/volume/drivers/hedvig/hedvig_cinder.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/hedvig/hedvig_cinder.py	2020-03-24 18:46:31.000000000 +0000
@@ -90,7 +90,7 @@ class HedvigISCSIDriver(driver.ISCSIDriv
                                           self.san_clustername)
 
     def get_volume_stats(self, refresh=False):
-        # we need to get get stats for server.
+        # we need to get stats for server.
         if refresh is True:
             total_capacity, free_capacity = self.update_volume_stats()
             stats = dict()
@@ -508,12 +508,12 @@ class HedvigISCSIDriver(driver.ISCSIDriv
             LOG.info('Creating virtual disk. name: %s, description: %s,'
                      'size: %s', name, description, size)
             vDiskInfo = {
-                'name': name.encode('utf-8'),
+                'name': name,
                 'blockSize': HedvigISCSIDriver.DEFAULT_VOL_BLOCK_SIZE,
                 'size': size,
                 'createdBy':
                     HedvigISCSIDriver.DEFAULT_CREATEDBY,
-                'description': description.encode('utf-8'),
+                'description': description,
                 'residence': config.Config.DiskResidence[1],
                 'replicationFactor': 3,
                 'replicationPolicy': 'Agnostic',
@@ -545,12 +545,12 @@ class HedvigISCSIDriver(driver.ISCSIDriv
                             vDiskInfo['compressed'] = True
                     elif "cache_enable" == key:
                         val = self.parse_and_get_boolean_entry(
-                            value.encode('utf-8'))
+                            value)
                         if val:
                             vDiskInfo['cacheEnabled'] = val
                     elif "encryption" == key:
                         val = self.parse_and_get_boolean_entry(
-                            value.encode('utf-8'))
+                            value)
                         if val:
                             vDiskInfo['encryption'] = val
                     elif "replication_factor" == key:
@@ -570,7 +570,7 @@ class HedvigISCSIDriver(driver.ISCSIDriv
                         if len(val) != 0:
                             dcList = []
                             for dataCenter in val:
-                                dcList.append(dataCenter.encode('utf-8'))
+                                dcList.append(dataCenter)
                             vDiskInfo['dataCenters'] = dcList
 
             if vDiskInfo['deduplication'] and (
diff -pruN 2:15.0.1-1/cinder/volume/drivers/hedvig/rest_client.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/hedvig/rest_client.py
--- 2:15.0.1-1/cinder/volume/drivers/hedvig/rest_client.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/hedvig/rest_client.py	2020-03-24 18:46:31.000000000 +0000
@@ -49,7 +49,7 @@ class RestClient(object):
 
     def connect(self):
         self.store_node_map(self.nodes)
-        if len(self.nodeMap) is 0:
+        if len(self.nodeMap) == 0:
             msg = _('Unable to connect to the nodes')
             raise exception.VolumeDriverException(msg)
 
@@ -75,7 +75,7 @@ class RestClient(object):
         if obj['status'] != 'ok':
             msg = _('GetSessionId failure')
             raise exception.VolumeDriverException(msg)
-        return (obj['result']['sessionId']).encode('utf-8')
+        return (obj['result']['sessionId'])
 
     def get_all_cluster_nodes(self, node):
         """Retrieves all the nodes present in the cluster
@@ -143,12 +143,12 @@ class RestClient(object):
         :param node:  hostname of the node
         :return: REST response
         """
-        data = urllib.parse.urlencode(data)
+        data = urllib.parse.urlencode(data).encode("utf-8")
         req = urllib.request.Request("http://%s/rest/" % node, data)
         response = urllib.request.urlopen(req)
         json_str = response.read()
         obj = json.loads(json_str)
-        LOG.debug("Rest call output %s ", json_str)
+        LOG.debug("Rest call output %s ", obj)
         return obj
 
     def make_rest_call(self, data, node):
@@ -178,7 +178,7 @@ class RestClient(object):
                           "exception - %s", data, node, e.args)
                 node = self.get_pages_host()
         else:
-            msg = _('REST call status - %s') % obj['status']
+            msg = _('REST call status - Retry limit reached')
             raise exception.VolumeDriverException(msg)
 
     def create_vdisk(self, vDiskInfo):
@@ -223,7 +223,7 @@ class RestClient(object):
                 'type': 'ResizeDisks',
                 'category': 'VirtualDiskManagement',
                 'params': {
-                    'virtualDisks': [vDiskName.encode('utf-8')],
+                    'virtualDisks': [vDiskName],
                     'size': {
                         'unit': "GB",
                         'value': value
@@ -252,7 +252,7 @@ class RestClient(object):
                 'type': 'DeleteVDisk',
                 'category': 'VirtualDiskManagement',
                 'params': {
-                    'virtualDisks': [vDiskName.encode('utf-8')],
+                    'virtualDisks': [vDiskName],
                 },
                 'sessionId': sessionId,
             }
@@ -280,8 +280,8 @@ class RestClient(object):
                     'type': 'GetLun',
                     'category': 'VirtualDiskManagement',
                     'params': {
-                        'virtualDisk': vDiskName.encode('utf-8'),
-                        'target': target.encode('utf-8'),
+                        'virtualDisk': vDiskName,
+                        'target': target,
                     },
                     'sessionId': sessionId,
                 }
@@ -309,7 +309,7 @@ class RestClient(object):
                 'type': 'GetIqn',
                 'category': 'VirtualDiskManagement',
                 'params': {
-                    'host': host.encode('utf-8'),
+                    'host': host,
                 },
                 'sessionId': sessionId,
             }
@@ -338,8 +338,8 @@ class RestClient(object):
                 'type': 'AddLun',
                 'category': 'VirtualDiskManagement',
                 'params': {
-                    'virtualDisks': [vDiskName.encode('utf-8')],
-                    'targets': [tgtHost.encode('utf-8')],
+                    'virtualDisks': [vDiskName],
+                    'targets': [tgtHost],
                     'readonly': readonly,
                 },
                 'sessionId': sessionId,
@@ -371,8 +371,8 @@ class RestClient(object):
                 'type': 'UnmapLun',
                 'category': 'VirtualDiskManagement',
                 'params': {
-                    'virtualDisk': vDiskName.encode('utf-8'),
-                    'target': target.encode('utf-8'),
+                    'virtualDisk': vDiskName,
+                    'target': target,
                 },
                 'sessionId': sessionId,
             }
@@ -406,10 +406,10 @@ class RestClient(object):
                 'type': 'PersistACLAccess',
                 'category': 'VirtualDiskManagement',
                 'params': {
-                    'virtualDisks': [vDiskName.encode('utf-8')],
-                    'host': host.encode('utf-8'),
-                    'type': type.encode('utf-8'),
-                    'address': address.encode('utf-8')
+                    'virtualDisks': [vDiskName],
+                    'host': host,
+                    'type': type,
+                    'address': address
                 },
                 'sessionId': sessionId,
             }
@@ -435,21 +435,21 @@ class RestClient(object):
                 'type': 'MakeSnapshot',
                 'category': 'SnapshotManagement',
                 'params': {
-                    'virtualDisks': [vDiskName.encode('utf-8')],
+                    'virtualDisks': [vDiskName],
                 },
                 'sessionId': sessionId,
             }
         }
         if snapshotId:
             param = data['request']['params']
-            param['openstackSID'] = snapshotId.encode('utf-8')
+            param['openstackSID'] = snapshotId
         obj = self.make_rest_call(data=data, node=node)
 
         if obj['status'] != 'ok' or obj['result'][0]['status'] != 'ok':
             errmsg = _('REST call status - %s') % obj['status']
             raise exception.VolumeDriverException(errmsg)
 
-        return obj['result'][0]['snapshotName'].encode('utf-8')
+        return obj['result'][0]['snapshotName']
 
     def clone_vdisk(self, srcVolName, dstVolName, size):
         """Rest Call to clone vdisk
@@ -463,8 +463,8 @@ class RestClient(object):
                 'type': 'CloneVdisk',
                 'category': 'SnapshotManagement',
                 'params': {
-                    'srcVolName': srcVolName.encode('utf-8'),
-                    'cloneVolName': dstVolName.encode('utf-8'),
+                    'srcVolName': srcVolName,
+                    'cloneVolName': dstVolName,
                     'size': size
                 },
                 'sessionId': sessionId,
@@ -506,8 +506,8 @@ class RestClient(object):
         total = obj['result']['capacity']['total']['value']
         used = obj['result']['capacity']['used']['value']
         capacity = obj['result']['capacity']
-        total_unit = capacity['total']['units'].encode('utf-8')
-        used_unit = capacity['used']['units'].encode('utf-8')
+        total_unit = capacity['total']['units']
+        used_unit = capacity['used']['units']
         total_capacity = self.get_val_in_gb(total, total_unit)
         used_capacity = self.get_val_in_gb(used, used_unit)
         free_capacity = total_capacity - used_capacity
@@ -527,9 +527,9 @@ class RestClient(object):
                 'type': 'CloneVdisk',
                 'category': 'SnapshotManagement',
                 'params': {
-                    'cloneVolName': dstVolName.encode('utf-8'),
-                    'openstackSID': snapshotID.encode('utf-8'),
-                    'srcVolName': srcVolName.encode('utf-8'),
+                    'cloneVolName': dstVolName,
+                    'openstackSID': snapshotID,
+                    'srcVolName': srcVolName,
                     'size': size
                 },
                 'sessionId': sessionId,
@@ -554,9 +554,9 @@ class RestClient(object):
                 'type': 'DeleteSnapshot',
                 'category': 'SnapshotManagement',
                 'params': {
-                    'snapshotName': snapshotName.encode('utf-8'),
-                    'openstackSID': snapshotId.encode('utf-8'),
-                    'openstackVolName': vDiskName.encode('utf-8')
+                    'snapshotName': snapshotName,
+                    'openstackSID': snapshotId,
+                    'openstackVolName': vDiskName
                 },
                 'sessionId': sessionId,
             }
@@ -610,7 +610,7 @@ class RestClient(object):
         if not self.nodeMap:
             msg = _('NodeMap is empty')
             raise exception.VolumeDriverException(msg)
-        return random.choice(self.nodeMap.keys())
+        return random.choice(list(self.nodeMap.keys()))
 
     def retrieve_session_id(self, node):
         """returns sessionID of the given node
diff -pruN 2:15.0.1-1/cinder/volume/drivers/hpe/hpe_3par_common.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/hpe/hpe_3par_common.py
--- 2:15.0.1-1/cinder/volume/drivers/hpe/hpe_3par_common.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/hpe/hpe_3par_common.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 #
-"""
-Volume driver common utilities for HPE 3PAR Storage array
+"""Volume driver common utilities for HPE 3PAR Storage array.
 
 The 3PAR drivers requires 3.1.3 firmware on the 3PAR array.
 
@@ -39,7 +38,6 @@ import json
 import math
 import pprint
 import re
-import six
 import uuid
 
 from oslo_config import cfg
@@ -49,6 +47,9 @@ from oslo_serialization import base64
 from oslo_service import loopingcall
 from oslo_utils import excutils
 from oslo_utils import units
+import six
+import taskflow.engines
+from taskflow.patterns import linear_flow
 
 from cinder import context
 from cinder import exception
@@ -61,9 +62,6 @@ from cinder.volume import qos_specs
 from cinder.volume import volume_types
 from cinder.volume import volume_utils
 
-import taskflow.engines
-from taskflow.patterns import linear_flow
-
 try:
     import hpe3parclient
     from hpe3parclient import client
diff -pruN 2:15.0.1-1/cinder/volume/drivers/hpe/hpe_lefthand_iscsi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/hpe/hpe_lefthand_iscsi.py
--- 2:15.0.1-1/cinder/volume/drivers/hpe/hpe_lefthand_iscsi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/hpe/hpe_lefthand_iscsi.py	2020-03-24 18:46:31.000000000 +0000
@@ -34,12 +34,16 @@ LeftHand array.
 
 """
 
+import math
+import re
+
 from oslo_config import cfg
 from oslo_log import log as logging
 from oslo_serialization import jsonutils as json
 from oslo_utils import excutils
 from oslo_utils import importutils
 from oslo_utils import units
+import six
 
 from cinder import context
 from cinder import coordination
@@ -54,10 +58,6 @@ from cinder.volume.drivers.san import sa
 from cinder.volume import volume_types
 from cinder.volume import volume_utils
 
-import math
-import re
-import six
-
 LOG = logging.getLogger(__name__)
 
 hpelefthandclient = importutils.try_import("hpelefthandclient")
diff -pruN 2:15.0.1-1/cinder/volume/drivers/huawei/common.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/huawei/common.py
--- 2:15.0.1-1/cinder/volume/drivers/huawei/common.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/huawei/common.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,13 +16,13 @@
 import collections
 import math
 import re
-import six
 import uuid
 
 from oslo_config import cfg
 from oslo_log import log as logging
 from oslo_utils import excutils
 from oslo_utils import units
+import six
 
 from cinder import context
 from cinder import exception
@@ -315,7 +315,7 @@ class HuaweiBaseDriver(driver.VolumeDriv
                 replica_info = self.replica.create_replica(lun_info,
                                                            replica_model)
                 model_update.update(replica_info)
-            except Exception as err:
+            except Exception:
                 LOG.exception('Create replication volume error.')
                 self._delete_lun_with_check(lun_id)
                 raise
@@ -392,7 +392,7 @@ class HuaweiBaseDriver(driver.VolumeDriv
         if replica_data:
             try:
                 self.replica.delete_replica(volume)
-            except exception.VolumeBackendAPIException as err:
+            except exception.VolumeBackendAPIException:
                 with excutils.save_and_reraise_exception():
                     LOG.exception("Delete replication error.")
                     self._delete_volume(volume)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/huawei/huawei_conf.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/huawei/huawei_conf.py
--- 2:15.0.1-1/cinder/volume/drivers/huawei/huawei_conf.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/huawei/huawei_conf.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,20 +13,19 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Set Huawei private configuration into Configuration object.
+"""Sets Huawei private configuration into Configuration object.
 
 For conveniently get private configuration. We parse Huawei config file
 and set every property into Configuration object as an attribute.
 """
 
 import base64
-from defusedxml import ElementTree as ET
 import os
 import re
-import six
 
+from defusedxml import ElementTree as ET
 from oslo_log import log as logging
+import six
 
 from cinder import exception
 from cinder.i18n import _
diff -pruN 2:15.0.1-1/cinder/volume/drivers/huawei/replication.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/huawei/replication.py
--- 2:15.0.1-1/cinder/volume/drivers/huawei/replication.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/huawei/replication.py	2020-03-24 18:46:31.000000000 +0000
@@ -199,7 +199,7 @@ class ReplicaCommonDriver(object):
 
         try:
             self.wait_expect_state(replica_id, running_status)
-        except Exception as err:
+        except Exception:
             msg = _('Split replication failed.')
             LOG.error(msg)
             raise exception.VolumeBackendAPIException(data=msg)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/huawei/rest_client.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/huawei/rest_client.py
--- 2:15.0.1-1/cinder/volume/drivers/huawei/rest_client.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/huawei/rest_client.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,12 +15,12 @@
 
 import json
 import re
-import requests
-import six
 import time
 
 from oslo_log import log as logging
 from oslo_utils import excutils
+import requests
+import six
 
 from cinder import exception
 from cinder.i18n import _
diff -pruN 2:15.0.1-1/cinder/volume/drivers/ibm/gpfs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/gpfs.py
--- 2:15.0.1-1/cinder/volume/drivers/ibm/gpfs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/gpfs.py	2020-03-24 18:46:31.000000000 +0000
@@ -250,7 +250,7 @@ class GPFSDriver(driver.CloneableImageVD
         try:
             fileset = fs_regex.match(out).group('fileset')
             return fileset
-        except AttributeError as exc:
+        except AttributeError:
             msg = (_('Failed to find fileset for path %(path)s, command '
                      'output: %(cmdout)s.') %
                    {'path': path,
@@ -994,10 +994,13 @@ class GPFSDriver(driver.CloneableImageVD
 
     def copy_volume_to_image(self, context, volume, image_service, image_meta):
         """Copy the volume to the specified image."""
+        # retrieve store information from extra-specs
+        store_id = volume.volume_type.extra_specs.get('image_service:store_id')
         image_utils.upload_volume(context,
                                   image_service,
                                   image_meta,
-                                  self.local_path(volume))
+                                  self.local_path(volume),
+                                  store_id=store_id)
 
     def _migrate_volume(self, volume, host):
         """Migrate vol if source and dest are managed by same GPFS cluster."""
diff -pruN 2:15.0.1-1/cinder/volume/drivers/ibm/ibm_storage/ds8k_helper.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/ibm_storage/ds8k_helper.py
--- 2:15.0.1-1/cinder/volume/drivers/ibm/ibm_storage/ds8k_helper.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/ibm_storage/ds8k_helper.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,13 +16,13 @@
 import collections
 import copy
 import distutils.version as dist_version  # pylint: disable=E0611
-import eventlet
 import math
 import os
-import six
 import string
 
+import eventlet
 from oslo_log import log as logging
+import six
 
 from cinder import coordination
 from cinder import exception
@@ -175,7 +175,7 @@ class DS8KCommonHelper(object):
                           'the end.'))
             lss_range = lss_range.replace('-', ' - ').split()
             for index, lss in enumerate(lss_range):
-                if lss is '-':
+                if lss == '-':
                     try:
                         begin = int(lss_range[index - 1], 16)
                         end = int(lss_range[index + 1], 16)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/ibm/ibm_storage/ds8k_proxy.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/ibm_storage/ds8k_proxy.py
--- 2:15.0.1-1/cinder/volume/drivers/ibm/ibm_storage/ds8k_proxy.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/ibm_storage/ds8k_proxy.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 #
-"""
-This is the driver that allows openstack to talk to DS8K.
+"""This is the driver that allows openstack to talk to DS8K.
 
 All volumes are thin provisioned by default, if the machine is licensed for it.
 This can be overridden by creating a volume type and specifying a key like so:
@@ -62,11 +61,11 @@ Sample settings for cinder.conf:
 """
 import ast
 import json
-import six
 
 import eventlet
 from oslo_config import cfg
 from oslo_log import log as logging
+import six
 
 from cinder import context
 from cinder import coordination
diff -pruN 2:15.0.1-1/cinder/volume/drivers/ibm/ibm_storage/ds8k_replication.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/ibm_storage/ds8k_replication.py
--- 2:15.0.1-1/cinder/volume/drivers/ibm/ibm_storage/ds8k_replication.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/ibm_storage/ds8k_replication.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,10 +14,9 @@
 #    under the License.
 #
 import eventlet
-import six
-
 from oslo_log import log as logging
 from oslo_utils import excutils
+import six
 
 from cinder import coordination
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/volume/drivers/ibm/ibm_storage/ds8k_restclient.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/ibm_storage/ds8k_restclient.py
--- 2:15.0.1-1/cinder/volume/drivers/ibm/ibm_storage/ds8k_restclient.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/ibm_storage/ds8k_restclient.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,14 +14,14 @@
 #    under the License.
 #
 import abc
-import eventlet
 import importlib
 import json
-import six
-from six.moves import urllib
 
+import eventlet
 import requests
 from requests import exceptions as req_exception
+import six
+from six.moves import urllib
 
 from cinder import exception
 from cinder.i18n import _
@@ -203,8 +203,8 @@ class RESTScheduler(object):
         self.token = ''
         self.host = host
         self.port = '8452'
-        self.user = user
-        self.passw = passw
+        self.user = user if isinstance(user, str) else user.decode()
+        self.passw = passw if isinstance(passw, str) else passw.decode()
         self.connector = connector_obj or DefaultRESTConnector(verify)
         self.connect()
 
diff -pruN 2:15.0.1-1/cinder/volume/drivers/ibm/ibm_storage/ibm_storage.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/ibm_storage/ibm_storage.py
--- 2:15.0.1-1/cinder/volume/drivers/ibm/ibm_storage/ibm_storage.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/ibm_storage/ibm_storage.py	2020-03-24 18:46:31.000000000 +0000
@@ -85,9 +85,6 @@ class IBMStorageDriver(san.SanDriver,
     # ThirdPartySystems wiki page
     CI_WIKI_NAME = "IBM_STORAGE_CI"
 
-    # TODO(jsbryant) Remove driver in the 'U' release if CI is not fixed.
-    SUPPORTED = False
-
     def __init__(self, *args, **kwargs):
         """Initialize the driver."""
 
diff -pruN 2:15.0.1-1/cinder/volume/drivers/ibm/ibm_storage/proxy.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/ibm_storage/proxy.py
--- 2:15.0.1-1/cinder/volume/drivers/ibm/ibm_storage/proxy.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/ibm_storage/proxy.py	2020-03-24 18:46:31.000000000 +0000
@@ -17,10 +17,10 @@ import functools
 import gettext
 import inspect
 import platform
-import six
 
 from oslo_log import log as logging
 from oslo_utils import timeutils
+import six
 
 from cinder.i18n import _
 from cinder import version
diff -pruN 2:15.0.1-1/cinder/volume/drivers/ibm/ibm_storage/xiv_proxy.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/ibm_storage/xiv_proxy.py
--- 2:15.0.1-1/cinder/volume/drivers/ibm/ibm_storage/xiv_proxy.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/ibm_storage/xiv_proxy.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,13 +15,10 @@
 #
 import datetime
 import re
-import six
 import socket
 
-
 from oslo_log import log as logging
 from oslo_utils import importutils
-
 pyxcli = importutils.try_import("pyxcli")
 if pyxcli:
     from pyxcli import client
@@ -29,6 +26,7 @@ if pyxcli:
     from pyxcli.events import events
     from pyxcli.mirroring import mirrored_entities
     from pyxcli import transports
+import six
 
 from cinder import context
 from cinder.i18n import _
@@ -1801,12 +1799,12 @@ class XIVProxy(proxy.IBMStorageProxy):
                 "cg_create", cg=cgname,
                 pool=self.storage_info[
                     storage.FLAG_KEYS['storage_pool']]).as_list
-        except errors.CgNameExistsError as e:
+        except errors.CgNameExistsError:
             error = (_("consistency group %s already exists on backend") %
                      cgname)
             LOG.error(error)
             raise self._get_exception()(error)
-        except errors.CgLimitReachedError as e:
+        except errors.CgLimitReachedError:
             error = _("Reached Maximum number of consistency groups")
             LOG.error(error)
             raise self._get_exception()(error)
@@ -2176,37 +2174,37 @@ class XIVProxy(proxy.IBMStorageProxy):
             self._call_xiv_xcli(
                 "cg_snapshots_create", cg=cgname,
                 snap_group=groupname).as_list
-        except errors.CgDoesNotExistError as e:
+        except errors.CgDoesNotExistError:
             error = (_("Consistency group %s does not exist on backend") %
                      cgname)
             LOG.error(error)
             raise self._get_exception()(error)
-        except errors.CgBadNameError as e:
+        except errors.CgBadNameError:
             error = (_("Consistency group %s has an illegal name") % cgname)
             LOG.error(error)
             raise self._get_exception()(error)
-        except errors.SnapshotGroupDoesNotExistError as e:
+        except errors.SnapshotGroupDoesNotExistError:
             error = (_("Snapshot group %s has an illegal name") % cgname)
             LOG.error(error)
             raise self._get_exception()(error)
-        except errors.PoolSnapshotLimitReachedError as e:
+        except errors.PoolSnapshotLimitReachedError:
             error = _("Reached maximum snapshots allocation size")
             LOG.error(error)
             raise self._get_exception()(error)
-        except errors.CgEmptyError as e:
+        except errors.CgEmptyError:
             error = (_("Consistency group %s is empty") % cgname)
             LOG.error(error)
             raise self._get_exception()(error)
         except (errors.MaxVolumesReachedError,
-                errors.DomainMaxVolumesReachedError) as e:
+                errors.DomainMaxVolumesReachedError):
             error = _("Reached Maximum number of volumes")
             LOG.error(error)
             raise self._get_exception()(error)
-        except errors.SnapshotGroupIsReservedError as e:
+        except errors.SnapshotGroupIsReservedError:
             error = (_("Consistency group %s name is reserved") % cgname)
             LOG.error(error)
             raise self._get_exception()(error)
-        except errors.SnapshotGroupAlreadyExistsError as e:
+        except errors.SnapshotGroupAlreadyExistsError:
             error = (_("Snapshot group %s already exists") % groupname)
             LOG.error(error)
             raise self._get_exception()(error)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/ibm/ibm_storage/xiv_replication.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/ibm_storage/xiv_replication.py
--- 2:15.0.1-1/cinder/volume/drivers/ibm/ibm_storage/xiv_replication.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/ibm_storage/xiv_replication.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,17 +13,16 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 #
-import six
 
 from oslo_log import log as logging
 from oslo_utils import importutils
-
 pyxcli = importutils.try_import("pyxcli")
 if pyxcli:
     from pyxcli import errors
     from pyxcli.mirroring import cg_recovery_manager
     from pyxcli.mirroring import errors as m_errors
     from pyxcli.mirroring import volume_recovery_manager
+import six
 
 from cinder.i18n import _
 from cinder.volume.drivers.ibm.ibm_storage import strings
diff -pruN 2:15.0.1-1/cinder/volume/drivers/ibm/storwize_svc/storwize_svc_common.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/storwize_svc/storwize_svc_common.py
--- 2:15.0.1-1/cinder/volume/drivers/ibm/storwize_svc/storwize_svc_common.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/storwize_svc/storwize_svc_common.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,7 +15,6 @@
 #
 
 import math
-import paramiko
 import random
 import re
 import time
@@ -31,6 +30,7 @@ from oslo_utils import encodeutils
 from oslo_utils import excutils
 from oslo_utils import strutils
 from oslo_utils import units
+import paramiko
 from retrying import retry
 import six
 
@@ -488,6 +488,7 @@ class StorwizeSSH(object):
         try:
             return self.run_ssh_check_created(ssh_cmd)
         except Exception as ex:
+            # pylint: disable=E1101
             if hasattr(ex, 'msg') and 'CMMVC6372W' in ex.msg:
                 vdisk = self.lsvdisk(name)
                 if vdisk:
@@ -762,6 +763,8 @@ class StorwizeHelpers(object):
             resp = self.ssh.lsguicapabilities()
             if resp.get('license_scheme', '0') == '9846':
                 return True
+            if resp.get('license_scheme', '0') == 'flex':
+                return True
         except exception.VolumeBackendAPIException:
             LOG.exception("Failed to fetch licensing scheme.")
         return False
@@ -1211,6 +1214,7 @@ class StorwizeHelpers(object):
                                         multihostmap)
                 return int(result_lun)
             except Exception as ex:
+                # pylint: disable=E1101
                 if (not multihostmap and hasattr(ex, 'msg') and
                         'CMMVC6071E' in ex.msg):
                     LOG.warning('storwize_svc_multihostmap_enabled is set '
@@ -1445,6 +1449,7 @@ class StorwizeHelpers(object):
                     raise exception.VolumeBackendAPIException(data=ex)
                 else:
                     testValue = False
+                    # pylint: disable=E1101
                     LOG.debug('Helper.'
                               '_wait_for_condition: %(method_name)s '
                               'execution failed for %(exception)s.',
@@ -2123,12 +2128,13 @@ class StorwizeHelpers(object):
         try:
             rc_id = self.ssh.mkrcrelationship(master, aux, system,
                                               asyncmirror, cyclingmode)
-        except exception.VolumeBackendAPIException as e:
+        except exception.VolumeBackendAPIException as ex:
             rc_id = None
             # CMMVC5959E is the code in Stowize storage, meaning that
             # there is a relationship that already has this name on the
             # master cluster.
-            if 'CMMVC5959E' not in e:
+            # pylint: disable=E1101
+            if hasattr(ex, 'msg') and 'CMMVC5959E' not in ex.msg:
                 # If there is no relation between the primary and the
                 # secondary back-end storage, the exception is raised.
                 raise
@@ -2648,9 +2654,6 @@ class StorwizeSVCCommonDriver(san.SanDri
     VDISKCOPYOPS_INTERVAL = 600
     DEFAULT_GR_SLEEP = random.randint(20, 500) / 100.0
 
-    # TODO(jsbryant) Remove driver in the 'U' release if CI is not fixed.
-    SUPPORTED = False
-
     def __init__(self, *args, **kwargs):
         super(StorwizeSVCCommonDriver, self).__init__(*args, **kwargs)
         self.configuration.append_config_values(storwize_svc_opts)
@@ -4225,7 +4228,8 @@ class StorwizeSVCCommonDriver(san.SanDri
                     else:
                         self._helpers.start_rccg(rccg_name, primary='aux')
             else:
-                LOG.warning('group %(grp)s is not in sync.')
+                LOG.warning('group %(grp)s is not in sync.',
+                            {'grp': rccg_name})
         except exception.VolumeBackendAPIException as ex:
             LOG.warning('Fail to copy data from aux group %(rccg)s to master '
                         'group. Please recheck the relationship and '
diff -pruN 2:15.0.1-1/cinder/volume/drivers/ibm/storwize_svc/storwize_svc_iscsi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/storwize_svc/storwize_svc_iscsi.py
--- 2:15.0.1-1/cinder/volume/drivers/ibm/storwize_svc/storwize_svc_iscsi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/ibm/storwize_svc/storwize_svc_iscsi.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,8 +14,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 #
-"""
-ISCSI volume driver for IBM Storwize family and SVC storage systems.
+"""ISCSI volume driver for IBM Storwize family and SVC storage systems.
 
 Notes:
 1. If you specify both a password and a key file, this driver will use the
@@ -45,7 +44,6 @@ from cinder import exception
 from cinder.i18n import _
 from cinder import interface
 from cinder.volume import configuration as conf
-
 from cinder.volume.drivers.ibm.storwize_svc import (
     storwize_svc_common as storwize_common)
 
diff -pruN 2:15.0.1-1/cinder/volume/drivers/infinidat.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/infinidat.py
--- 2:15.0.1-1/cinder/volume/drivers/infinidat.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/infinidat.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,16 +12,14 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-INFINIDAT InfiniBox Volume Driver
-"""
+"""INFINIDAT InfiniBox Volume Driver."""
 
 from contextlib import contextmanager
 import functools
 import platform
 import socket
+from unittest import mock
 
-import mock
 from oslo_config import cfg
 from oslo_log import log as logging
 from oslo_utils import units
diff -pruN 2:15.0.1-1/cinder/volume/drivers/inspur/instorage/instorage_iscsi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/inspur/instorage/instorage_iscsi.py
--- 2:15.0.1-1/cinder/volume/drivers/inspur/instorage/instorage_iscsi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/inspur/instorage/instorage_iscsi.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,8 +13,7 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 #
-"""
-ISCSI volume driver for Inspur InStorage family and MCS storage systems.
+"""ISCSI volume driver for Inspur InStorage family and MCS storage systems.
 
 Notes:
 1. Make sure you config the password or key file. If you specify both
@@ -53,7 +52,6 @@ from cinder.i18n import _
 from cinder import interface
 from cinder import utils as cinder_utils
 from cinder.volume import driver
-
 from cinder.volume.drivers.inspur.instorage import instorage_common
 
 LOG = logging.getLogger(__name__)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/inspur/instorage/replication.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/inspur/instorage/replication.py
--- 2:15.0.1-1/cinder/volume/drivers/inspur/instorage/replication.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/inspur/instorage/replication.py	2020-03-24 18:46:31.000000000 +0000
@@ -176,7 +176,7 @@ class InStorageMCSReplication(object):
             # Reverse the role of the primary and secondary volumes
             self.target_assistant.switch_relationship(rel_info['name'])
             return {'replication_status': fields.ReplicationStatus.FAILED_OVER}
-        except Exception as e:
+        except Exception:
             LOG.exception('Unable to fail-over the volume %(id)s to the '
                           'secondary back-end by switchrcrelationship '
                           'command.', {"id": vref.id})
diff -pruN 2:15.0.1-1/cinder/volume/drivers/linstordrv.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/linstordrv.py
--- 2:15.0.1-1/cinder/volume/drivers/linstordrv.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/linstordrv.py	2020-03-24 18:46:31.000000000 +0000
@@ -1,4 +1,4 @@
-#  Copyright (c) 2014-2018 LINBIT HA Solutions GmbH
+#  Copyright (c) 2014-2019 LINBIT HA Solutions GmbH
 #  All Rights Reserved.
 #
 #  Licensed under the Apache License, Version 2.0 (the "License"); you may
@@ -15,7 +15,7 @@
 
 """This driver connects Cinder to an installed LINSTOR instance.
 
-See https://docs.linbit.com/docs/users-guide-9.0/#ch-openstack
+See https://docs.linbit.com/docs/users-guide-9.0/#ch-openstack-linstor
 for more details.
 """
 
@@ -35,11 +35,6 @@ from cinder.volume import configuration
 from cinder.volume import driver
 
 try:
-    import google.protobuf.json_format as proto
-except ImportError:
-    proto = None
-
-try:
     import linstor
     lin_drv = linstor.Linstor
 except ImportError:
@@ -69,7 +64,14 @@ linstor_opts = [
                default=4096,
                help='Default Block size for Image restoration. '
                     'When using iSCSI transport, this option '
-                    'specifies the block size'),
+                    'specifies the block size.'),
+
+    cfg.IntOpt('linstor_autoplace_count',
+               default=0,
+               help='Autoplace replication count on volume deployment. '
+                    '0 = Full cluster replication without autoplace, '
+                    '1 = Single node deployment without replication, '
+                    '2 or greater = Replicated deployment with autoplace.'),
 
     cfg.BoolOpt('linstor_controller_diskless',
                 default=True,
@@ -84,14 +86,25 @@ CONF.register_opts(linstor_opts, group=c
 CINDER_UNKNOWN = 'unknown'
 DM_VN_PREFIX = 'CV_'
 DM_SN_PREFIX = 'SN_'
-LVM = 'Lvm'
-LVMTHIN = 'LvmThin'
+DISKLESS = 'DISKLESS'
+LVM = 'LVM'
+LVM_THIN = 'LVM_THIN'
+ZFS = 'ZFS'
+ZFS_THIN = 'ZFS_THIN'
 
 
 class LinstorBaseDriver(driver.VolumeDriver):
-    """Cinder driver that uses Linstor for storage."""
+    """Cinder driver that uses LINSTOR for storage.
 
-    VERSION = '1.0.0'
+    Version history:
+
+    .. code-block:: none
+
+        1.0.0 - Initial driver
+        1.0.1 - Added support for LINSTOR 0.9.12
+    """
+
+    VERSION = '1.0.1'
 
     # ThirdPartySystems wiki page
     CI_WIKI_NAME = 'LINBIT_LINSTOR_CI'
@@ -113,6 +126,8 @@ class LinstorBaseDriver(driver.VolumeDri
             'linstor_default_blocksize')
         self.diskless = self.configuration.safe_get(
             'linstor_controller_diskless')
+        self.ap_count = self.configuration.safe_get(
+            'linstor_autoplace_count')
         self.default_backend_name = self.configuration.safe_get(
             'volume_backend_name')
         self.host_name = socket.gethostname()
@@ -176,44 +191,36 @@ class LinstorBaseDriver(driver.VolumeDri
         with lin_drv(self.default_uri) as lin:
             if not lin.connected:
                 lin.connect()
-
-            response = proto.MessageToDict(lin.resource_list()[0].proto_msg)
-        return response
+            api_reply = lin.resource_list()[0].__dict__['_rest_data']
+            return api_reply
 
     def _get_api_resource_dfn_list(self):
         with lin_drv(self.default_uri) as lin:
             if not lin.connected:
                 lin.connect()
+            api_reply = lin.resource_dfn_list()[0].__dict__['_rest_data']
+            return api_reply
 
-            response = proto.MessageToDict(
-                lin.resource_dfn_list()[0].proto_msg)
-            return response
-
-    def _get_api_nodes_list(self):
+    def _get_api_node_list(self):
         with lin_drv(self.default_uri) as lin:
             if not lin.connected:
                 lin.connect()
-
-            response = proto.MessageToDict(lin.node_list()[0].proto_msg)
-            return response
+            api_reply = lin.node_list()[0].__dict__['_rest_data']
+            return api_reply
 
     def _get_api_storage_pool_dfn_list(self):
         with lin_drv(self.default_uri) as lin:
             if not lin.connected:
                 lin.connect()
-
-            response = proto.MessageToDict(
-                lin.storage_pool_dfn_list()[0].proto_msg)
-            return response
+            api_reply = lin.storage_pool_dfn_list()[0].__dict__['_rest_data']
+            return api_reply
 
     def _get_api_storage_pool_list(self):
         with lin_drv(self.default_uri) as lin:
             if not lin.connected:
                 lin.connect()
-
-            response = proto.MessageToDict(
-                lin.storage_pool_list()[0].proto_msg)
-            return response
+            api_reply = lin.storage_pool_list()[0].__dict__['_rest_data']
+            return api_reply
 
     def _get_api_volume_extend(self, rsc_target_name, new_size):
         with lin_drv(self.default_uri) as lin:
@@ -226,25 +233,15 @@ class LinstorBaseDriver(driver.VolumeDri
                 size=self._vol_size_to_linstor(new_size))
             return vol_reply
 
-    def _api_snapshot_create(self, node_names, rsc_name, snapshot_name):
-        with lin_drv(self.default_uri) as lin:
-            if not lin.connected:
-                lin.connect()
-
-            snap_reply = lin.snapshot_create(node_names=node_names,
-                                             rsc_name=rsc_name,
-                                             snapshot_name=snapshot_name,
-                                             async_msg=False)
-            return snap_reply
-
-    def _api_snapshot_delete(self, drbd_rsc_name, snap_name):
-        with lin_drv(self.default_uri) as lin:
-            if not lin.connected:
-                lin.connect()
-
-            snap_reply = lin.snapshot_delete(rsc_name=drbd_rsc_name,
-                                             snapshot_name=snap_name)
-            return snap_reply
+    def _api_snapshot_create(self, drbd_rsc_name, snapshot_name):
+        lin = linstor.Resource(drbd_rsc_name, uri=self.default_uri)
+        snap_reply = lin.snapshot_create(snapshot_name)
+        return snap_reply
+
+    def _api_snapshot_delete(self, drbd_rsc_name, snapshot_name):
+        lin = linstor.Resource(drbd_rsc_name, uri=self.default_uri)
+        snap_reply = lin.snapshot_delete(snapshot_name)
+        return snap_reply
 
     def _api_rsc_dfn_delete(self, drbd_rsc_name):
         with lin_drv(self.default_uri) as lin:
@@ -320,6 +317,18 @@ class LinstorBaseDriver(driver.VolumeDri
             rsc_reply = lin.resource_create([new_rsc], async_msg=False)
             return rsc_reply
 
+    def _api_rsc_autoplace(self, rsc_name):
+        with lin_drv(self.default_uri) as lin:
+            if not lin.connected:
+                lin.connect()
+
+            new_rsc = linstor.Resource(name=rsc_name, uri=self.default_uri)
+            new_rsc.placement.redundancy = self.ap_count
+            new_rsc.placement.storage_pool = self.default_pool
+            rsc_reply = new_rsc.autoplace()
+
+            return rsc_reply
+
     def _api_rsc_delete(self, rsc_name, node_name):
         with lin_drv(self.default_uri) as lin:
             if not lin.connected:
@@ -329,6 +338,36 @@ class LinstorBaseDriver(driver.VolumeDri
                                             rsc_name=rsc_name)
             return rsc_reply
 
+    def _api_rsc_auto_delete(self, rsc_name):
+        with lin_drv(self.default_uri) as lin:
+            if not lin.connected:
+                lin.connect()
+
+            rsc = linstor.Resource(str(rsc_name), self.default_uri)
+            return rsc.delete()
+
+    def _api_rsc_is_diskless(self, rsc_name):
+        with lin_drv(self.default_uri) as lin:
+            if not lin.connected:
+                lin.connect()
+
+            rsc = linstor.Resource(str(rsc_name))
+            return rsc.is_diskless(self.host_name)
+
+    def _api_rsc_size(self, rsc_name):
+        with lin_drv(self.default_uri) as lin:
+            if not lin.connected:
+                lin.connect()
+
+            rsc = linstor.Resource(str(rsc_name))
+            if len(rsc.volumes):
+                if "size" in rsc.volumes:
+                    return rsc.volumes[0].size
+                else:
+                    return 0
+            else:
+                return 0
+
     def _api_volume_dfn_delete(self, rsc_name, volume_nr):
         with lin_drv(self.default_uri) as lin:
             if not lin.connected:
@@ -353,29 +392,39 @@ class LinstorBaseDriver(driver.VolumeDri
             return vol_reply
 
     def _api_snapshot_resource_restore(self,
-                                       nodes,
                                        src_rsc_name,
                                        src_snap_name,
                                        new_vol_name):
+
+        lin = linstor.Resource(src_rsc_name, uri=self.default_uri)
+        new_rsc = lin.restore_from_snapshot(src_snap_name, new_vol_name)
+
+        # Adds an aux/property KV for synchronous return from snapshot restore
         with lin_drv(self.default_uri) as lin:
             if not lin.connected:
                 lin.connect()
 
-            rsc_reply = lin.snapshot_resource_restore(
-                node_names=nodes,
-                from_resource=src_rsc_name,
-                from_snapshot=src_snap_name,
-                to_resource=new_vol_name)
-            return rsc_reply
+            aux_prop = {}
+            aux_prop["Aux/restore"] = "done"
+            lin.volume_dfn_modify(
+                rsc_name=new_vol_name,
+                volume_nr=0,
+                set_properties=aux_prop)
+
+        if new_rsc.name == new_vol_name:
+            return True
+        return False
 
     def _get_rsc_path(self, rsc_name):
         rsc_list_reply = self._get_api_resource_list()
 
-        for rsc in rsc_list_reply['resources']:
-            if rsc['name'] == rsc_name and rsc['nodeName'] == self.host_name:
-                for volume in rsc['vlms']:
-                    if volume['vlmNr'] == 0:
-                        return volume['devicePath']
+        if rsc_list_reply:
+            for rsc in rsc_list_reply:
+                if (rsc["name"] == rsc_name and
+                        rsc["node_name"] == self.host_name):
+                    for volume in rsc["volumes"]:
+                        if volume["volume_number"] == 0:
+                            return volume["device_path"]
 
     def _get_local_path(self, volume):
         try:
@@ -391,13 +440,11 @@ class LinstorBaseDriver(driver.VolumeDri
     def _get_spd(self):
         # Storage Pool Definition List
         spd_list_reply = self._get_api_storage_pool_dfn_list()
-
         spd_list = []
-        for node in spd_list_reply['storPoolDfns']:
-            spd_item = {}
-            spd_item['spd_uuid'] = node['uuid']
-            spd_item['spd_name'] = node['storPoolName']
-            spd_list.append(spd_item)
+
+        if spd_list_reply:
+            for spd in spd_list_reply:
+                spd_list.append(spd["storage_pool_name"])
 
         return spd_list
 
@@ -405,49 +452,39 @@ class LinstorBaseDriver(driver.VolumeDri
         # Fetch Storage Pool List
         sp_list_reply = self._get_api_storage_pool_list()
 
-        # Fetch Resource Definition List
-        sp_list = []
-
         # Separate the diskless nodes
         sp_diskless_list = []
+        sp_list = []
         node_count = 0
 
         if sp_list_reply:
-            for node in sp_list_reply['storPools']:
-                if node['storPoolName'] == self.default_pool:
+            for node in sp_list_reply:
+                if node["storage_pool_name"] == self.default_pool:
                     sp_node = {}
-                    sp_node['node_uuid'] = node['nodeUuid']
-                    sp_node['node_name'] = node['nodeName']
-                    sp_node['sp_uuid'] = node['storPoolUuid']
-                    sp_node['sp_name'] = node['storPoolName']
-                    sp_node['sp_vlms_uuid'] = []
-                    if 'vlms' in node:
-                        for vlm in node['vlms']:
-                            sp_node['sp_vlms_uuid'].append(vlm['vlmDfnUuid'])
+                    sp_node["node_name"] = node["node_name"]
+                    sp_node["sp_uuid"] = node["uuid"]
+                    sp_node["sp_name"] = node["storage_pool_name"]
 
-                    if 'Diskless' in node['driver']:
+                    if node["provider_kind"] == DISKLESS:
                         diskless = True
-                        sp_node['sp_free'] = -1.0
-                        sp_node['sp_cap'] = 0.0
+                        sp_node["sp_free"] = -1.0
+                        sp_node["sp_cap"] = -1.0
+                        sp_node["sp_allocated"] = 0.0
                     else:
                         diskless = False
-                        if 'freeSpace' in node:
-                            sp_node['sp_free'] = round(
-                                int(node['freeSpace']['freeCapacity']) /
-                                units.Mi,
-                                2)
-                            sp_node['sp_cap'] = round(
-                                int(node['freeSpace']['totalCapacity']) /
-                                units.Mi,
-                                2)
-
-                            # Driver
-                    if node['driver'] == "LvmDriver":
-                        sp_node['driver_name'] = LVM
-                    elif node['driver'] == "LvmThinDriver":
-                        sp_node['driver_name'] = LVMTHIN
+                        if "free_capacity" in node:
+                            temp = float(node["free_capacity"]) / units.Mi
+                            sp_node["sp_free"] = round(temp)
+                            temp = float(node["total_capacity"]) / units.Mi
+                            sp_node["sp_cap"] = round(temp)
+
+                    drivers = [LVM, LVM_THIN, ZFS, ZFS_THIN, DISKLESS]
+
+                    # Driver selection
+                    if node["provider_kind"] in drivers:
+                        sp_node['driver_name'] = node["provider_kind"]
                     else:
-                        sp_node['driver_name'] = node['driver']
+                        sp_node['driver_name'] = str(node["provider_kind"])
 
                     if diskless:
                         sp_diskless_list.append(sp_node)
@@ -455,9 +492,9 @@ class LinstorBaseDriver(driver.VolumeDri
                         sp_list.append(sp_node)
                     node_count += 1
 
-        # Add the diskless nodes to the end of the list
-        if sp_diskless_list:
-            sp_list.extend(sp_diskless_list)
+            # Add the diskless nodes to the end of the list
+            if sp_diskless_list:
+                sp_list.extend(sp_diskless_list)
 
         return sp_list
 
@@ -465,7 +502,7 @@ class LinstorBaseDriver(driver.VolumeDri
 
         data = {}
         data["volume_backend_name"] = self.default_backend_name
-        data["vendor_name"] = 'LINBIT'
+        data["vendor_name"] = "LINBIT"
         data["driver_version"] = self.VERSION
         data["pools"] = []
 
@@ -477,40 +514,51 @@ class LinstorBaseDriver(driver.VolumeDri
         for rd in rd_list:
             num_vols += 1
 
-        allocated_sizes_gb = []
-        free_capacity_gb = []
-        total_capacity_gb = []
+        # allocated_sizes_gb = []
+        free_gb = []
+        total_gb = []
         thin_enabled = False
 
-        # Free capacity for Local Node
+        # Total & Free capacity for Local Node
         single_pool = {}
         for sp in sp_data:
-            if 'Diskless' not in sp['driver_name']:
-                if 'LvmThin' in sp['driver_name']:
+            if "Diskless" not in sp["driver_name"]:
+                thin_backends = [LVM_THIN, ZFS_THIN]
+                if sp["driver_name"] in thin_backends:
                     thin_enabled = True
-                if 'sp_cap' in sp:
-                    if sp['sp_cap'] >= 0.0:
-                        total_capacity_gb.append(sp['sp_cap'])
-                if 'sp_free' in sp:
-                    if sp['sp_free'] >= 0.0:
-                        free_capacity_gb.append(sp['sp_free'])
-                sp_allocated_size_gb = 0
-                for vlm_uuid in sp['sp_vlms_uuid']:
-                    for rd in rd_list:
-                        if 'vlm_dfn_uuid' in rd:
-                            if rd['vlm_dfn_uuid'] == vlm_uuid:
-                                sp_allocated_size_gb += rd['rd_size']
-                allocated_sizes_gb.append(sp_allocated_size_gb)
+                if "sp_cap" in sp:
+                    if sp["sp_cap"] >= 0.0:
+                        total_gb.append(sp["sp_cap"])
+                if "sp_free" in sp:
+                    if sp["sp_free"] >= 0.0:
+                        free_gb.append(sp["sp_free"])
+
+        # Allocated capacity
+        sp_allocated_size_gb = 0.0
+        local_resources = []
+
+        reply = self._get_api_resource_list()
+
+        if reply:
+            for rsc in reply:
+                if rsc["node_name"] == self.host_name:
+                    local_resources.append(rsc["name"])
+
+            for rsc_name in local_resources:
+                if not self._api_rsc_is_diskless(rsc_name):
+                    rsc_size = self._api_rsc_size(rsc_name)
+                    sp_allocated_size_gb += round(
+                        int(rsc_size) / units.Gi, 2)
 
         single_pool["pool_name"] = data["volume_backend_name"]
-        single_pool["free_capacity_gb"] = min(free_capacity_gb)
-        single_pool["total_capacity_gb"] = min(total_capacity_gb)
-        single_pool['provisioned_capacity_gb'] = max(allocated_sizes_gb)
+        single_pool["free_capacity_gb"] = min(free_gb) if free_gb else 0
+        single_pool["total_capacity_gb"] = min(total_gb) if total_gb else 0
+        single_pool["provisioned_capacity_gb"] = sp_allocated_size_gb
         single_pool["reserved_percentage"] = (
             self.configuration.reserved_percentage)
-        single_pool['thin_provisioning_support'] = thin_enabled
-        single_pool['thick_provisioning_support'] = not thin_enabled
-        single_pool['max_over_subscription_ratio'] = (
+        single_pool["thin_provisioning_support"] = thin_enabled
+        single_pool["thick_provisioning_support"] = not thin_enabled
+        single_pool["max_over_subscription_ratio"] = (
             self.configuration.max_over_subscription_ratio)
         single_pool["location_info"] = self.default_uri
         single_pool["total_volumes"] = num_vols
@@ -518,7 +566,7 @@ class LinstorBaseDriver(driver.VolumeDri
         single_pool["goodness_function"] = self.get_goodness_function()
         single_pool["QoS_support"] = False
         single_pool["multiattach"] = False
-        single_pool["backend_state"] = 'up'
+        single_pool["backend_state"] = "up"
 
         data["pools"].append(single_pool)
 
@@ -526,29 +574,16 @@ class LinstorBaseDriver(driver.VolumeDri
 
     def _get_resource_definitions(self):
 
-        rd_list = []
-
         rd_list_reply = self._get_api_resource_dfn_list()
+        rd_list = []
 
-        # Only if resource definition present
-        if 'rscDfns' in rd_list_reply:
-            for node in rd_list_reply['rscDfns']:
-
+        if rd_list_reply:
+            for node in rd_list_reply:
                 # Count only Cinder volumes
-                if DM_VN_PREFIX in node['rscName']:
+                if DM_VN_PREFIX in node['name']:
                     rd_node = {}
-                    rd_node['rd_uuid'] = node['rscDfnUuid']
-                    rd_node['rd_name'] = node['rscName']
-                    rd_node['rd_port'] = node['rscDfnPort']
-
-                    if 'vlmDfns' in node:
-                        for vol in node['vlmDfns']:
-                            if vol['vlmNr'] == 0:
-                                rd_node['vlm_dfn_uuid'] = vol['vlmDfnUuid']
-                                rd_node['rd_size'] = round(
-                                    float(vol['vlmSize']) / units.Mi, 2)
-                                break
-
+                    rd_node["rd_uuid"] = node['uuid']
+                    rd_node["rd_name"] = node['name']
                     rd_list.append(rd_node)
 
         return rd_list
@@ -558,46 +593,62 @@ class LinstorBaseDriver(driver.VolumeDri
 
         However, it excludes diskless nodes.
         """
+        rsc_list_reply = self._get_api_resource_list()
+        snap_list = []
 
-        rsc_list_reply = self._get_api_resource_list()  # reply in dict
+        if rsc_list_reply:
+            for rsc in rsc_list_reply:
+                if rsc["name"] != resource:
+                    continue
 
-        snap_list = []
-        for rsc in rsc_list_reply['resources']:
-            if rsc['name'] != resource:
-                continue
-
-            # Diskless nodes are not available for snapshots
-            diskless = False
-            if 'rscFlags' in rsc:
-                if 'DISKLESS' in rsc['rscFlags']:
-                    diskless = True
-            if not diskless:
-                snap_list.append(rsc['nodeName'])
+                # Diskless nodes are not available for snapshots
+                diskless = False
+                if "flags" in rsc:
+                    if 'DISKLESS' in rsc["flags"]:
+                        diskless = True
+                if not diskless:
+                    snap_list.append(rsc["node_name"])
 
         return snap_list
 
-    def _get_linstor_nodes(self):
-        # Returns all available DRBD nodes
-        node_list_reply = self._get_api_nodes_list()
+    def _get_diskless_nodes(self, resource):
+        # Returns diskless nodes given a resource
+        rsc_list_reply = self._get_api_resource_list()
+        diskless_list = []
+
+        if rsc_list_reply:
+            for rsc in rsc_list_reply:
+                if rsc["name"] != resource:
+                    continue
+
+                if "flags" in rsc:
+                    if DISKLESS in rsc["flags"]:
+                        diskless_list.append(rsc["node_name"])
+
+        return diskless_list
 
+    def _get_linstor_nodes(self):
+        # Returns all available LINSTOR nodes
+        node_list_reply = self._get_api_node_list()
         node_list = []
-        for node in node_list_reply['nodes']:
-            node_list.append(node['name'])
+
+        if node_list_reply:
+            for node in node_list_reply:
+                node_list.append(node["name"])
 
         return node_list
 
     def _get_nodes(self):
-        # Get Node List
-        node_list_reply = self._get_api_nodes_list()
-
+        # Returns all LINSTOR nodes in a dict list
+        node_list_reply = self._get_api_node_list()
         node_list = []
+
         if node_list_reply:
-            for node in node_list_reply['nodes']:
+            for node in node_list_reply:
                 node_item = {}
-                node_item['node_name'] = node['name']
-                node_item['node_uuid'] = node['uuid']
-                node_item['node_address'] = (
-                    node['netInterfaces'][0]['address'])
+                node_item["node_name"] = node["name"]
+                node_item["node_address"] = (
+                    node["net_interfaces"][0]["address"])
                 node_list.append(node_item)
 
         return node_list
@@ -610,95 +661,71 @@ class LinstorBaseDriver(driver.VolumeDri
             # Check if all replies are success
             return lin_drv.all_api_responses_success(api_response)
 
-    def _copy_vol_to_image(self, context, image_service, image_meta, rsc_path):
+    def _copy_vol_to_image(self, context, image_service, image_meta, rsc_path,
+                           store_id=None):
 
         return image_utils.upload_volume(context,
                                          image_service,
                                          image_meta,
-                                         rsc_path)
+                                         rsc_path,
+                                         store_id=store_id)
 
     #
     # Snapshot
     #
     def create_snapshot(self, snapshot):
         snap_name = self._snapshot_name_from_cinder_snapshot(snapshot)
-        drbd_rsc_name = self._drbd_resource_name_from_cinder_snapshot(snapshot)
-        node_names = self._get_snapshot_nodes(drbd_rsc_name)
+        rsc_name = self._drbd_resource_name_from_cinder_snapshot(snapshot)
 
-        snap_reply = self._api_snapshot_create(node_names=node_names,
-                                               rsc_name=drbd_rsc_name,
+        snap_reply = self._api_snapshot_create(drbd_rsc_name=rsc_name,
                                                snapshot_name=snap_name)
 
-        if not self._check_api_reply(snap_reply, noerror_only=True):
+        if not snap_reply:
             msg = 'ERROR creating a LINSTOR snapshot {}'.format(snap_name)
             LOG.error(msg)
             raise exception.VolumeBackendAPIException(msg)
 
     def delete_snapshot(self, snapshot):
-        snap_name = self._snapshot_name_from_cinder_snapshot(snapshot)
-        drbd_rsc_name = self._drbd_resource_name_from_cinder_snapshot(snapshot)
+        snapshot_name = self._snapshot_name_from_cinder_snapshot(snapshot)
+        rsc_name = self._drbd_resource_name_from_cinder_snapshot(snapshot)
 
-        snap_reply = self._api_snapshot_delete(drbd_rsc_name, snap_name)
+        snap_reply = self._api_snapshot_delete(rsc_name, snapshot_name)
 
-        if not self._check_api_reply(snap_reply, noerror_only=True):
-            msg = 'ERROR deleting a LINSTOR snapshot {}'.format(snap_name)
+        if not snap_reply:
+            msg = 'ERROR deleting a LINSTOR snapshot {}'.format(snapshot_name)
             LOG.error(msg)
             raise exception.VolumeBackendAPIException(msg)
 
         # Delete RD if no other RSC are found
-        if not self._get_snapshot_nodes(drbd_rsc_name):
-            self._api_rsc_dfn_delete(drbd_rsc_name)
+        if not self._get_snapshot_nodes(rsc_name):
+            self._api_rsc_dfn_delete(rsc_name)
 
     def create_volume_from_snapshot(self, volume, snapshot):
         src_rsc_name = self._drbd_resource_name_from_cinder_snapshot(snapshot)
         src_snap_name = self._snapshot_name_from_cinder_snapshot(snapshot)
         new_vol_name = self._drbd_resource_name_from_cinder_volume(volume)
 
-        # New RD
-        rsc_reply = self._api_rsc_dfn_create(new_vol_name)
-
-        if not self._check_api_reply(rsc_reply):
-            msg = _('Error on creating LINSTOR Resource Definition')
-            LOG.error(msg)
-            raise exception.VolumeBackendAPIException(data=msg)
-
-        # New VD from Snap
-        reply = self._api_snapshot_volume_dfn_restore(src_rsc_name,
-                                                      src_snap_name,
-                                                      new_vol_name)
-        if not self._check_api_reply(reply, noerror_only=True):
-            msg = _('Error on restoring LINSTOR Volume Definition')
-            LOG.error(msg)
-            raise exception.VolumeBackendAPIException(data=msg)
+        # If no autoplace, manually build a cluster list
+        if self.ap_count == 0:
+            diskless_nodes = []
+            nodes = []
+            for node in self._get_storage_pool():
 
-        # Set StorPoolName property on VD
-        reply = self._api_volume_dfn_set_sp(new_vol_name)
-        if not self._check_api_reply(reply):
-            msg = _('Error on restoring LINSTOR Volume StorPoolName property')
-            LOG.error(msg)
-            raise exception.VolumeBackendAPIException(data=msg)
+                if DISKLESS in node['driver_name']:
+                    diskless_nodes.append(node['node_name'])
+                    continue
 
-        # New RSC from Snap
-        # Assumes restoring to all the nodes containing the storage pool
-        # unless diskless
-        nodes = []
-        for node in self._get_storage_pool():
-
-            if 'Diskless' in node['driver_name']:
-                continue
-
-            # Filter out controller node if LINSTOR is diskless
-            if self.diskless and node['node_name'] == self.host_name:
-                continue
-            else:
-                nodes.append(node['node_name'])
+                # Filter out controller node if it is diskless
+                if self.diskless and node['node_name'] == self.host_name:
+                    continue
+                else:
+                    nodes.append(node['node_name'])
 
-        reply = self._api_snapshot_resource_restore(nodes,
-                                                    src_rsc_name,
+        reply = self._api_snapshot_resource_restore(src_rsc_name,
                                                     src_snap_name,
                                                     new_vol_name)
-        if not self._check_api_reply(reply, noerror_only=True):
-            msg = _('Error on restoring LINSTOR resources')
+        if not reply:
+            msg = _('Error on restoring a LINSTOR volume')
             LOG.error(msg)
             raise exception.VolumeBackendAPIException(data=msg)
 
@@ -708,6 +735,13 @@ class LinstorBaseDriver(driver.VolumeDri
                                          node_name=self.host_name,
                                          diskless=self.diskless)
 
+        # Add any other diskless nodes only if not autoplaced
+        if self.ap_count == 0 and diskless_nodes:
+            for node in diskless_nodes:
+                self._api_rsc_create(rsc_name=new_vol_name,
+                                     node_name=node,
+                                     diskless=True)
+
         # Upsize if larger volume than original snapshot
         src_rsc_size = int(snapshot['volume_size'])
         new_vol_size = int(volume['size'])
@@ -722,7 +756,7 @@ class LinstorBaseDriver(driver.VolumeDri
 
             if not self._check_api_reply(reply, noerror_only=True):
                 # Delete failed volume
-                failed_volume = []
+                failed_volume = {}
                 failed_volume['id'] = volume['id']
                 self.delete_volume(failed_volume)
 
@@ -731,9 +765,9 @@ class LinstorBaseDriver(driver.VolumeDri
                 raise exception.VolumeBackendAPIException(data=msg)
 
     def create_volume(self, volume):
+
         # Check for Storage Pool List
         sp_data = self._get_storage_pool()
-        rsc_size = 1
         rsc_size = volume['size']
 
         # No existing Storage Pools found
@@ -747,11 +781,11 @@ class LinstorBaseDriver(driver.VolumeDri
                 LOG.error(msg)
                 raise exception.VolumeBackendAPIException(data=msg)
 
-            # Create Storage Pool (definition is implicit)
+            # Create Storage Pool
             spd_list = self._get_spd()
 
             if spd_list:
-                spd_name = spd_list[0]['spd_name']
+                spd_name = spd_list[0]
 
             for node in node_list:
 
@@ -766,12 +800,12 @@ class LinstorBaseDriver(driver.VolumeDri
                     storage_driver=node_driver,
                     driver_pool_name=self.default_vg_name)
 
-                if not self._check_api_reply(sp_reply):
+                if not self._check_api_reply(sp_reply, noerror_only=True):
                     msg = _('Could not create a LINSTOR storage pool')
                     LOG.error(msg)
                     raise exception.VolumeBackendAPIException(data=msg)
 
-        # # Check for RD
+        # Check for RD
         # If Retyping from another volume, use parent/origin uuid
         # as a name source
         if (volume['migration_status'] is not None and
@@ -785,8 +819,8 @@ class LinstorBaseDriver(driver.VolumeDri
 
         # Create a New RD
         rsc_dfn_reply = self._api_rsc_dfn_create(rsc_name)
-        if not self._check_api_reply(rsc_dfn_reply,
-                                     noerror_only=True):
+
+        if not self._check_api_reply(rsc_dfn_reply, noerror_only=True):
             msg = _("Error creating a LINSTOR resource definition")
             LOG.error(msg)
             raise exception.VolumeBackendAPIException(data=msg)
@@ -795,8 +829,8 @@ class LinstorBaseDriver(driver.VolumeDri
         vd_size = self._vol_size_to_linstor(rsc_size)
         vd_reply = self._api_volume_dfn_create(rsc_name=rsc_name,
                                                size=int(vd_size))
-        if not self._check_api_reply(vd_reply,
-                                     noerror_only=True):
+
+        if not self._check_api_reply(vd_reply, noerror_only=True):
             msg = _("Error creating a LINSTOR volume definition")
             LOG.error(msg)
             raise exception.VolumeBackendAPIException(data=msg)
@@ -804,26 +838,38 @@ class LinstorBaseDriver(driver.VolumeDri
         # Create LINSTOR Resources
         ctrl_in_sp = False
         for node in sp_data:
-
             # Check if controller is in the pool
             if node['node_name'] == self.host_name:
                 ctrl_in_sp = True
 
-            # Create resources and,
-            # Check only errors when creating diskless resources
-            if 'Diskless' in node['driver_name']:
-                diskless = True
-            else:
-                diskless = False
-            rsc_reply = self._api_rsc_create(rsc_name=rsc_name,
-                                             node_name=node['node_name'],
-                                             diskless=diskless)
+        # Use autoplace to deploy if set
+        if self.ap_count:
+            try:
+                self._api_rsc_autoplace(rsc_name=rsc_name)
 
-            if not self._check_api_reply(rsc_reply, noerror_only=True):
-                msg = _("Error creating a LINSTOR resource")
+            except Exception:
+                msg = _("Error creating autoplaces LINSTOR resource(s)")
                 LOG.error(msg)
                 raise exception.VolumeBackendAPIException(data=msg)
 
+        # Otherwise deploy across the entire cluster
+        else:
+            for node in sp_data:
+                # Deploy resource on each node
+                if DISKLESS in node['driver_name']:
+                    diskless = True
+                else:
+                    diskless = False
+
+                rsc_reply = self._api_rsc_create(rsc_name=rsc_name,
+                                                 node_name=node['node_name'],
+                                                 diskless=diskless)
+
+                if not self._check_api_reply(rsc_reply, noerror_only=True):
+                    msg = _("Error creating a LINSTOR resource")
+                    LOG.error(msg)
+                    raise exception.VolumeBackendAPIException(data=msg)
+
         # If the controller is diskless and not in the pool, create a diskless
         # resource on it
         if not ctrl_in_sp and self.diskless:
@@ -832,7 +878,7 @@ class LinstorBaseDriver(driver.VolumeDri
                                              diskless=True)
 
             if not self._check_api_reply(rsc_reply, noerror_only=True):
-                msg = _("Error creating a LINSTOR resource")
+                msg = _("Error creating a LINSTOR controller resource")
                 LOG.error(msg)
                 raise exception.VolumeBackendAPIException(data=msg)
 
@@ -841,32 +887,56 @@ class LinstorBaseDriver(driver.VolumeDri
     def delete_volume(self, volume):
         drbd_rsc_name = self._drbd_resource_name_from_cinder_volume(volume)
         rsc_list_reply = self._get_api_resource_list()
+        diskful_nodes = self._get_snapshot_nodes(drbd_rsc_name)
+        diskless_nodes = self._get_diskless_nodes(drbd_rsc_name)
 
-        if rsc_list_reply:
-            # Delete Resources
-            for rsc in rsc_list_reply['resources']:
-                if rsc['name'] != drbd_rsc_name:
-                    continue
-
-                rsc_reply = self._api_rsc_delete(
-                    node_name=rsc['nodeName'],
-                    rsc_name=drbd_rsc_name)
-                if not self._check_api_reply(rsc_reply, noerror_only=True):
-                    msg = _("Error deleting a LINSTOR resource")
-                    LOG.error(msg)
-                    raise exception.VolumeBackendAPIException(data=msg)
+        # If autoplace was used, use Resource class
+        if self.ap_count:
 
-            # Delete VD
-            vd_reply = self._api_volume_dfn_delete(drbd_rsc_name, 0)
-            if not vd_reply:
-                if not self._check_api_reply(vd_reply):
-                    msg = _("Error deleting a LINSTOR volume definition")
-                    LOG.error(msg)
-                    raise exception.VolumeBackendAPIException(data=msg)
+            rsc_reply = self._api_rsc_auto_delete(drbd_rsc_name)
+            if not rsc_reply:
+                msg = _("Error deleting an autoplaced LINSTOR resource")
+                LOG.error(msg)
+                raise exception.VolumeBackendAPIException(data=msg)
 
-            # Delete RD
-            # Will fail if snapshot exists but expected
-            self._api_rsc_dfn_delete(drbd_rsc_name)
+        # Delete all resources in a cluster manually if not autoplaced
+        else:
+            if rsc_list_reply:
+                # Remove diskless nodes first
+                if diskless_nodes:
+                    for node in diskless_nodes:
+                        rsc_reply = self._api_rsc_delete(
+                            node_name=node,
+                            rsc_name=drbd_rsc_name)
+                        if not self._check_api_reply(rsc_reply,
+                                                     noerror_only=True):
+                            msg = _("Error deleting a diskless LINSTOR rsc")
+                            LOG.error(msg)
+                            raise exception.VolumeBackendAPIException(data=msg)
+
+                # Remove diskful nodes
+                if diskful_nodes:
+                    for node in diskful_nodes:
+                        rsc_reply = self._api_rsc_delete(
+                            node_name=node,
+                            rsc_name=drbd_rsc_name)
+                        if not self._check_api_reply(rsc_reply,
+                                                     noerror_only=True):
+                            msg = _("Error deleting a LINSTOR resource")
+                            LOG.error(msg)
+                            raise exception.VolumeBackendAPIException(data=msg)
+
+                # Delete VD
+                vd_reply = self._api_volume_dfn_delete(drbd_rsc_name, 0)
+                if not vd_reply:
+                    if not self._check_api_reply(vd_reply):
+                        msg = _("Error deleting a LINSTOR volume definition")
+                        LOG.error(msg)
+                        raise exception.VolumeBackendAPIException(data=msg)
+
+                # Delete RD
+                # Will fail if snapshot exists but expected
+                self._api_rsc_dfn_delete(drbd_rsc_name)
 
         return True
 
@@ -877,7 +947,7 @@ class LinstorBaseDriver(driver.VolumeDri
         extend_reply = self._get_api_volume_extend(rsc_target_name, new_size)
 
         if not self._check_api_reply(extend_reply, noerror_only=True):
-            msg = _("ERROR Linstor Volume Extend")
+            msg = _("ERROR extending a LINSTOR volume")
             LOG.error(msg)
             raise exception.VolumeBackendAPIException(data=msg)
 
@@ -895,11 +965,10 @@ class LinstorBaseDriver(driver.VolumeDri
         self.delete_snapshot(snapshot)
 
     def copy_image_to_volume(self, context, volume, image_service, image_id):
-        # self.create_volume(volume) already called by Cinder, and works.
-        # Need to check return values
+        # self.create_volume(volume) already called by Cinder, and works
         full_rsc_name = self._drbd_resource_name_from_cinder_volume(volume)
 
-        # This creates a LINSTOR volume at the original size.
+        # This creates a LINSTOR volume from the source image
         image_utils.fetch_to_raw(context,
                                  image_service,
                                  image_id,
@@ -911,11 +980,13 @@ class LinstorBaseDriver(driver.VolumeDri
     def copy_volume_to_image(self, context, volume, image_service, image_meta):
         full_rsc_name = self._drbd_resource_name_from_cinder_volume(volume)
         rsc_path = str(self._get_rsc_path(full_rsc_name))
-
+        # retrieve store information from extra-specs
+        store_id = volume.volume_type.extra_specs.get('image_service:store_id')
         self._copy_vol_to_image(context,
                                 image_service,
                                 image_meta,
-                                rsc_path)
+                                rsc_path,
+                                store_id=store_id)
         return {}
 
     # Not supported currently
@@ -923,14 +994,10 @@ class LinstorBaseDriver(driver.VolumeDri
         return (False, None)
 
     def check_for_setup_error(self):
-
         msg = None
         if linstor is None:
             msg = _('Linstor python package not found')
 
-        if proto is None:
-            msg = _('Protobuf python package not found')
-
         if msg is not None:
             LOG.error(msg)
             raise exception.VolumeDriverException(message=msg)
@@ -954,7 +1021,7 @@ class LinstorBaseDriver(driver.VolumeDri
 # Class with iSCSI interface methods
 @interface.volumedriver
 class LinstorIscsiDriver(LinstorBaseDriver):
-    """Cinder iSCSI driver that uses Linstor for storage."""
+    """Cinder iSCSI driver that uses LINSTOR for storage."""
 
     def __init__(self, *args, **kwargs):
         super(LinstorIscsiDriver, self).__init__(*args, **kwargs)
@@ -965,7 +1032,7 @@ class LinstorIscsiDriver(LinstorBaseDriv
             self.helper_driver = self.helper_name
             self.target_driver = None
         else:
-            self.helper_name = self.configuration.safe_get('target_helper')
+            self.helper_name = self.configuration.safe_get('iscsi_helper')
             self.helper_driver = self.target_mapping[self.helper_name]
             self.target_driver = importutils.import_object(
                 self.helper_driver,
@@ -973,7 +1040,7 @@ class LinstorIscsiDriver(LinstorBaseDriv
                 db=self.db,
                 executor=self._execute)
 
-        LOG.info('START: LINSTOR DRBD driver {}'.format(self.helper_name))
+        LOG.info('START: LINSTOR DRBD driver %s', self.helper_name)
 
     def get_volume_stats(self, refresh=False):
         data = self._get_volume_stats()
@@ -1024,7 +1091,7 @@ class LinstorIscsiDriver(LinstorBaseDriv
 # Class with DRBD transport mode
 @interface.volumedriver
 class LinstorDrbdDriver(LinstorBaseDriver):
-    """Cinder DRBD driver that uses Linstor for storage."""
+    """Cinder DRBD driver that uses LINSTOR for storage."""
 
     def __init__(self, *args, **kwargs):
         super(LinstorDrbdDriver, self).__init__(*args, **kwargs)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/lvm.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/lvm.py
--- 2:15.0.1-1/cinder/volume/drivers/lvm.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/lvm.py	2020-03-24 18:46:31.000000000 +0000
@@ -508,10 +508,14 @@ class LVMVolumeDriver(driver.VolumeDrive
 
     def copy_volume_to_image(self, context, volume, image_service, image_meta):
         """Copy the volume to the specified image."""
+        # retrieve store information from extra-specs
+        store_id = volume.volume_type.extra_specs.get('image_service:store_id')
+
         image_utils.upload_volume(context,
                                   image_service,
                                   image_meta,
-                                  self.local_path(volume))
+                                  self.local_path(volume),
+                                  store_id=store_id)
 
     def create_cloned_volume(self, volume, src_vref):
         """Creates a clone of the specified volume."""
diff -pruN 2:15.0.1-1/cinder/volume/drivers/macrosan/driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/macrosan/driver.py
--- 2:15.0.1-1/cinder/volume/drivers/macrosan/driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/macrosan/driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -78,6 +78,9 @@ class MacroSANBaseDriver(driver.VolumeDr
 
     CI_WIKI_NAME = 'MacroSAN Volume CI'
 
+    # TODO(jsbryant) Remove driver in 'V' release if CI is not fixed.
+    SUPPORTED = False
+
     def __init__(self, *args, **kwargs):
         """Initialize the driver."""
         super(MacroSANBaseDriver, self).__init__(*args, **kwargs)
@@ -967,7 +970,7 @@ class MacroSANBaseDriver(driver.VolumeDr
         owner = self.client.get_lun_sp(src_name)
         pool = host['capabilities'].get('pool_name', self.pool)
 
-        LOG.info('Migrating volume: %(volume), '
+        LOG.info('Migrating volume: %(volume)s, '
                  'host: %(host)s, '
                  'backend: %(volume_backend_name)s',
                  {'volume': src_name,
diff -pruN 2:15.0.1-1/cinder/volume/drivers/nec/cli.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/nec/cli.py
--- 2:15.0.1-1/cinder/volume/drivers/nec/cli.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/nec/cli.py	2020-03-24 18:46:31.000000000 +0000
@@ -653,18 +653,10 @@ class MStorageISMCLI(object):
         query_status = out[15:39].strip()
         return query_status
 
-    def set_io_limit(self, ldname, specs, force_delete=True):
-        if specs['upperlimit'] is not None:
-            upper = int(specs['upperlimit'], 10)
-        else:
-            upper = None
-
-        if specs['lowerlimit'] is not None:
-            lower = int(specs['lowerlimit'], 10)
-        else:
-            lower = None
-
-        report = specs['upperreport']
+    def set_io_limit(self, ldname, qos_params, force_delete=True):
+        upper = qos_params['upperlimit']
+        lower = qos_params['lowerlimit']
+        report = qos_params['upperreport']
         if upper is None and lower is None and report is None:
             return
         cmd = 'iSMioc setlimit -ldname %s' % ldname
diff -pruN 2:15.0.1-1/cinder/volume/drivers/nec/volume_common.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/nec/volume_common.py
--- 2:15.0.1-1/cinder/volume/drivers/nec/volume_common.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/nec/volume_common.py	2020-03-24 18:46:31.000000000 +0000
@@ -825,9 +825,8 @@ class MStorageVolumeCommon(object):
         specs = {}
 
         ctxt = context.get_admin_context()
-        type_id = volume_type_id
-        if type_id is not None:
-            volume_type = volume_types.get_volume_type(ctxt, type_id)
+        if volume_type_id is not None:
+            volume_type = volume_types.get_volume_type(ctxt, volume_type_id)
 
             qos_specs_id = volume_type.get('qos_specs_id')
             if qos_specs_id is not None:
@@ -842,7 +841,8 @@ class MStorageVolumeCommon(object):
                        'specs': specs})
         return specs
 
-    def correct_qos_parameter(self, specs, reset):
+    def get_qos_parameters(self, specs, reset):
+        qos_params = {}
         if 'upperlimit' in specs and specs['upperlimit'] is not None:
             if self.validates_number(specs['upperlimit']) is True:
                 upper_limit = int(specs['upperlimit'], 10)
@@ -850,13 +850,16 @@ class MStorageVolumeCommon(object):
                         ((upper_limit < 10) or (upper_limit > 1000000))):
                     raise exception.InvalidConfigurationValue(
                         value=upper_limit, option='upperlimit')
+                qos_params['upperlimit'] = upper_limit
             else:
                 raise exception.InvalidConfigurationValue(
                     value=specs['upperlimit'], option='upperlimit')
         else:
             # 0: Set to no limit.(default)
+            #    On the QoS function in NEC Storage, 0 means there is no
+            #    limit.
             # None: Keep current value.
-            specs['upperlimit'] = '0' if reset else None
+            qos_params['upperlimit'] = 0 if reset else None
 
         if 'lowerlimit' in specs and specs['lowerlimit'] is not None:
             if self.validates_number(specs['lowerlimit']) is True:
@@ -865,24 +868,30 @@ class MStorageVolumeCommon(object):
                                           lower_limit > 1000000)):
                     raise exception.InvalidConfigurationValue(
                         value=lower_limit, option='lowerlimit')
+                qos_params['lowerlimit'] = lower_limit
             else:
                 raise exception.InvalidConfigurationValue(
                     value=specs['lowerlimit'], option='lowerlimit')
         else:
             # 0: Set to no limit.(default)
+            #    On the QoS function in NEC Storage, 0 means there is no
+            #    limit.
             # None: Keep current value.
-            specs['lowerlimit'] = '0' if reset else None
+            qos_params['lowerlimit'] = 0 if reset else None
 
         if 'upperreport' in specs:
             if specs['upperreport'] not in ['on', 'off']:
                 LOG.debug('Illegal arguments. '
                           'upperreport is not on or off.'
                           'upperreport=%s', specs['upperreport'])
-                specs['upperreport'] = 'off' if reset else None
+                qos_params['upperreport'] = 'off' if reset else None
+            else:
+                qos_params['upperreport'] = specs['upperreport']
         else:
             # off: Set to no report.(default)
             # None: Keep current value.
-            specs['upperreport'] = 'off' if reset else None
+            qos_params['upperreport'] = 'off' if reset else None
+        return qos_params
 
     def check_accesscontrol(self, ldsets, ld):
         """Check Logical disk is in-use or not."""
diff -pruN 2:15.0.1-1/cinder/volume/drivers/nec/volume_helper.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/nec/volume_helper.py
--- 2:15.0.1-1/cinder/volume/drivers/nec/volume_helper.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/nec/volume_helper.py	2020-03-24 18:46:31.000000000 +0000
@@ -318,13 +318,12 @@ class MStorageDriver(volume_common.MStor
         LOG.debug('_create_volume Start.')
 
         # select ld number and LD bind.
-        (ldname,
-         ldn,
-         selected_pool) = self._bind_ld(volume,
-                                        volume.size,
-                                        None,
-                                        self._convert_id2name,
-                                        self._select_leastused_poolnumber)
+        ldname, ldn, selected_pool = self._bind_ld(
+            volume,
+            volume.size,
+            None,
+            self._convert_id2name,
+            self._select_leastused_poolnumber)
 
         self._set_qos_spec(ldname, volume.volume_type_id)
 
@@ -477,13 +476,12 @@ class MStorageDriver(volume_common.MStor
                 raise exception.VolumeBackendAPIException(data=msg)
 
         # Creating Cloned Volume.
-        (volume_name,
-         ldn,
-         selected_pool) = self._bind_ld(volume,
-                                        src_vref.size,
-                                        None,
-                                        self._convert_id2name,
-                                        self._select_leastused_poolnumber)
+        volume_name, ldn, selected_pool = self._bind_ld(
+            volume,
+            src_vref.size,
+            None,
+            self._convert_id2name,
+            self._select_leastused_poolnumber)
 
         self._set_qos_spec(volume_name, volume.volume_type_id)
 
@@ -523,11 +521,11 @@ class MStorageDriver(volume_common.MStor
     def _set_qos_spec(self, ldname, volume_type_id, reset=False):
         # check io limit.
         specs = self.get_volume_type_qos_specs(volume_type_id)
-        self.correct_qos_parameter(specs, reset)
+        qos_params = self.get_qos_parameters(specs, reset)
 
         # set io limit.
-        self._cli.set_io_limit(ldname, specs)
-        LOG.debug('_set_qos_spec(Specs = %s) End.', specs)
+        self._cli.set_io_limit(ldname, qos_params)
+        LOG.debug('_set_qos_spec(Specs = %s) End.', qos_params)
 
         return
 
@@ -540,12 +538,6 @@ class MStorageDriver(volume_common.MStor
         ldname = self._validate_ld_exist(
             lds, volume.id, self._properties['ld_name_format'])
 
-        # check volume status.
-        if volume.status != 'available':
-            msg = _('Specified Logical Disk %s is not available.') % ldname
-            LOG.error(msg)
-            raise exception.VolumeBackendAPIException(data=msg)
-
         # check rpl attribute.
         ld = lds[ldname]
         if ld['Purpose'] != '---':
@@ -562,7 +554,10 @@ class MStorageDriver(volume_common.MStor
                       'dsthost': host})
         try:
             ret = self._migrate_volume(context, volume, host)
-            LOG.info('Migrated Volume (%s)', msgparm)
+            if ret != (False, None):
+                LOG.info('Migrated Volume (%s)', msgparm)
+            else:
+                LOG.debug('Failed to Migrate Volume (%s)', msgparm)
             return ret
         except exception.CinderException as e:
             with excutils.save_and_reraise_exception():
@@ -586,6 +581,11 @@ class MStorageDriver(volume_common.MStor
 
         false_ret = (False, None)
 
+        # check volume status.
+        if volume.status != 'available':
+            LOG.debug('Specified volume %s is not available.', volume.id)
+            return false_ret
+
         if 'capabilities' not in host:
             LOG.debug('Host not in capabilities. Host = %s ', host)
             return false_ret
@@ -670,7 +670,10 @@ class MStorageDriver(volume_common.MStor
                       'dsthost': host})
         try:
             ret = self._retype(context, volume, new_type, diff, host)
-            LOG.info('Retyped Volume (%s)', msgparm)
+            if ret is not False:
+                LOG.info('Retyped Volume (%s)', msgparm)
+            else:
+                LOG.debug('Failed to Retype Volume (%s)', msgparm)
             return ret
         except exception.CinderException as e:
             with excutils.save_and_reraise_exception():
@@ -696,6 +699,11 @@ class MStorageDriver(volume_common.MStor
                    'diff': diff,
                    'host': host})
 
+        # check volume attach status.
+        if volume.attach_status == 'attached':
+            LOG.debug('Specified volume %s is attached.', volume.id)
+            return False
+
         if self._check_same_backend(diff):
             ldname = self._convert_id2name(volume)
             reset = (diff['qos_specs'].get('consumer')[0] == 'back-end')
@@ -720,14 +728,13 @@ class MStorageDriver(volume_common.MStor
     def _migrate(self, volume, host, volume_type_id, validator, pool_selecter):
 
         # bind LD.
-        (rvname,
-         ldn,
-         selected_pool) = self._bind_ld(volume,
-                                        volume.size,
-                                        validator,
-                                        self._convert_id2migratename,
-                                        pool_selecter,
-                                        host)
+        rvname, __, selected_pool = self._bind_ld(
+            volume,
+            volume.size,
+            validator,
+            self._convert_id2migratename,
+            pool_selecter,
+            host)
 
         if selected_pool >= 0:
             self._set_qos_spec(rvname, volume_type_id)
@@ -775,7 +782,7 @@ class MStorageDriver(volume_common.MStor
 
         name_id = None
         provider_location = None
-        if original_volume_status == 'available':
+        if original_volume_status in ['available', 'in-use']:
             original_name = self._convert_id2name(volume)
             new_name = self._convert_id2name(new_volume)
             try:
@@ -1910,14 +1917,13 @@ class MStorageDSVDriver(MStorageDriver):
         mv_capacity = rv['ld_capacity']
         rv_capacity = volume.size
 
-        (new_rvname,
-         rvnumber,
-         selected_pool) = self._bind_ld(volume,
-                                        mv_capacity,
-                                        None,
-                                        self._convert_id2name,
-                                        self._select_volddr_poolnumber,
-                                        mv_capacity)
+        new_rvname, rvnumber, selected_pool = self._bind_ld(
+            volume,
+            mv_capacity,
+            None,
+            self._convert_id2name,
+            self._select_volddr_poolnumber,
+            mv_capacity)
 
         self._set_qos_spec(new_rvname, volume.volume_type_id)
 
diff -pruN 2:15.0.1-1/cinder/volume/drivers/nec/volume.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/nec/volume.py
--- 2:15.0.1-1/cinder/volume/drivers/nec/volume.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/nec/volume.py	2020-03-24 18:46:31.000000000 +0000
@@ -47,7 +47,7 @@ class MStorageISCSIDriver(volume_helper.
                  Fixed bug #1777385: driver removed access permission from
                  the destination node after live-migraion.
                  Fixed bug #1778669: LUNs of detached volumes are never reused.
-        1.11.1 - Add support pytyon 3.
+        1.11.1 - Add support python 3.
                  Add support for multi-attach.
                  Add support of more than 4 iSCSI portals for a node.
                  Add support to revert a volume to a snapshot.
@@ -115,7 +115,7 @@ class MStorageFCDriver(volume_helper.MSt
                  Fixed bug #1777385: driver removed access permission from
                  the destination node after live-migraion.
                  Fixed bug #1778669: LUNs of detached volumes are never reused.
-        1.11.1 - Add support pytyon 3.
+        1.11.1 - Add support python 3.
                  Add support for multi-attach.
                  Add support of more than 4 iSCSI portals for a node.
                  Add support to revert a volume to a snapshot.
diff -pruN 2:15.0.1-1/cinder/volume/drivers/netapp/dataontap/client/api.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/netapp/dataontap/client/api.py
--- 2:15.0.1-1/cinder/volume/drivers/netapp/dataontap/client/api.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/netapp/dataontap/client/api.py	2020-03-24 18:46:31.000000000 +0000
@@ -15,19 +15,17 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-NetApp API for Data ONTAP and OnCommand DFM.
+"""NetApp API for Data ONTAP and OnCommand DFM.
 
 Contains classes required to issue API calls to Data ONTAP and OnCommand DFM.
 """
+import random
 
 from eventlet import greenthread
 from eventlet import semaphore
-
 from lxml import etree
 from oslo_log import log as logging
 from oslo_utils import netutils
-import random
 import six
 from six.moves import urllib
 
diff -pruN 2:15.0.1-1/cinder/volume/drivers/netapp/dataontap/client/client_base.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/netapp/dataontap/client/client_base.py
--- 2:15.0.1-1/cinder/volume/drivers/netapp/dataontap/client/client_base.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/netapp/dataontap/client/client_base.py	2020-03-24 18:46:31.000000000 +0000
@@ -19,7 +19,6 @@ import sys
 
 from oslo_log import log as logging
 from oslo_utils import excutils
-
 import six
 
 from cinder import exception
@@ -28,7 +27,6 @@ from cinder import utils
 from cinder.volume.drivers.netapp.dataontap.client import api as netapp_api
 from cinder.volume.drivers.netapp import utils as na_utils
 
-
 LOG = logging.getLogger(__name__)
 
 DELETED_PREFIX = 'deleted_cinder_'
diff -pruN 2:15.0.1-1/cinder/volume/drivers/netapp/dataontap/client/client_cmode.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/netapp/dataontap/client/client_cmode.py
--- 2:15.0.1-1/cinder/volume/drivers/netapp/dataontap/client/client_cmode.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/netapp/dataontap/client/client_cmode.py	2020-03-24 18:46:31.000000000 +0000
@@ -21,6 +21,7 @@ import math
 import re
 
 from oslo_log import log as logging
+from oslo_utils import strutils
 from oslo_utils import units
 import six
 
@@ -32,9 +33,6 @@ from cinder.volume.drivers.netapp.dataon
 from cinder.volume.drivers.netapp import utils as na_utils
 from cinder.volume import volume_utils
 
-from oslo_utils import strutils
-
-
 LOG = logging.getLogger(__name__)
 DEFAULT_MAX_PAGE_LENGTH = 50
 
@@ -1590,7 +1588,7 @@ class Client(client_base.Client):
 
     def get_performance_counters(self, object_name, instance_uuids,
                                  counter_names):
-        """Gets or or more cDOT performance counters."""
+        """Gets more cDOT performance counters."""
 
         api_args = {
             'objectname': object_name,
diff -pruN 2:15.0.1-1/cinder/volume/drivers/netapp/dataontap/utils/loopingcalls.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/netapp/dataontap/utils/loopingcalls.py
--- 2:15.0.1-1/cinder/volume/drivers/netapp/dataontap/utils/loopingcalls.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/netapp/dataontap/utils/loopingcalls.py	2020-03-24 18:46:31.000000000 +0000
@@ -11,12 +11,10 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Collects and starts tasks created from oslo_service.loopingcall.
-"""
-
+"""Collects and starts tasks created from oslo_service.loopingcall."""
 
 from collections import namedtuple
+
 from oslo_service import loopingcall
 
 LoopingTask = namedtuple('LoopingTask',
diff -pruN 2:15.0.1-1/cinder/volume/drivers/nexenta/iscsi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/nexenta/iscsi.py
--- 2:15.0.1-1/cinder/volume/drivers/nexenta/iscsi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/nexenta/iscsi.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,10 +12,9 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-import six
-
 from oslo_log import log as logging
 from oslo_utils import excutils
+import six
 
 from cinder import exception
 from cinder.i18n import _
diff -pruN 2:15.0.1-1/cinder/volume/drivers/nexenta/nfs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/nexenta/nfs.py
--- 2:15.0.1-1/cinder/volume/drivers/nexenta/nfs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/nexenta/nfs.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,12 +16,12 @@
 import hashlib
 import os
 import re
-import six
 
 from eventlet import greenthread
 from oslo_log import log as logging
 from oslo_utils import fileutils
 from oslo_utils import units
+import six
 
 from cinder import context
 from cinder import db
diff -pruN 2:15.0.1-1/cinder/volume/drivers/nexenta/utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/nexenta/utils.py
--- 2:15.0.1-1/cinder/volume/drivers/nexenta/utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/nexenta/utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,9 +14,9 @@
 #    under the License.
 
 import re
-import six
 
 from oslo_utils import units
+import six
 import six.moves.urllib.parse as urlparse
 
 from cinder import exception
diff -pruN 2:15.0.1-1/cinder/volume/drivers/nimble.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/nimble.py
--- 2:15.0.1-1/cinder/volume/drivers/nimble.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/nimble.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,1915 +0,0 @@
-# Nimble Storage, Inc. (c) 2013-2014
-# All Rights Reserved.
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-"""
-Volume driver for Nimble Storage.
-
-This driver supports Nimble Storage controller CS-Series and Nimble AF Arrays.
-
-"""
-import abc
-import eventlet
-import functools
-import json
-import random
-import re
-import requests
-import six
-import string
-import sys
-
-from oslo_config import cfg
-from oslo_log import log as logging
-from oslo_utils import units
-
-from cinder import exception
-from cinder.i18n import _
-from cinder import interface
-from cinder.objects import volume
-from cinder import utils
-from cinder.volume import configuration
-from cinder.volume import driver
-from cinder.volume.drivers.san import san
-from cinder.volume import volume_types
-from cinder.zonemanager import utils as fczm_utils
-
-DRIVER_VERSION = "4.0.1"
-AES_256_XTS_CIPHER = 'aes_256_xts'
-DEFAULT_CIPHER = 'none'
-EXTRA_SPEC_ENCRYPTION = 'nimble:encryption'
-EXTRA_SPEC_PERF_POLICY = 'nimble:perfpol-name'
-EXTRA_SPEC_MULTI_INITIATOR = 'nimble:multi-initiator'
-EXTRA_SPEC_DEDUPE = 'nimble:dedupe'
-EXTRA_SPEC_IOPS_LIMIT = 'nimble:iops-limit'
-EXTRA_SPEC_FOLDER = 'nimble:folder'
-DEFAULT_PERF_POLICY_SETTING = 'default'
-DEFAULT_ENCRYPTION_SETTING = 'no'
-DEFAULT_DEDUPE_SETTING = 'false'
-DEFAULT_IOPS_LIMIT_SETTING = None
-DEFAULT_MULTI_INITIATOR_SETTING = 'false'
-DEFAULT_FOLDER_SETTING = None
-DEFAULT_SNAP_QUOTA = sys.maxsize
-BACKUP_VOL_PREFIX = 'backup-vol-'
-AGENT_TYPE_OPENSTACK = 'openstack'
-AGENT_TYPE_OPENSTACK_GST = 'openstackv2'
-AGENT_TYPE_NONE = 'none'
-SM_SUBNET_DATA = 'data'
-SM_SUBNET_MGMT_PLUS_DATA = 'mgmt-data'
-SM_STATE_MSG = "is already in requested state"
-SM_OBJ_EXIST_MSG = "Object exists"
-SM_OBJ_ENOENT_MSG = "No such object"
-SM_OBJ_HAS_CLONE = "has a clone"
-IOPS_ERR_MSG = "Please set valid IOPS limit in the range"
-LUN_ID = '0'
-WARN_LEVEL = 80
-DEFAULT_SLEEP = 5
-MIN_IOPS = 256
-MAX_IOPS = 4294967294
-NimbleDefaultVersion = 1
-
-
-LOG = logging.getLogger(__name__)
-
-nimble_opts = [
-    cfg.StrOpt('nimble_pool_name',
-               default='default',
-               help='Nimble Controller pool name'),
-    cfg.StrOpt('nimble_subnet_label',
-               default='*',
-               help='Nimble Subnet Label'),
-    cfg.BoolOpt('nimble_verify_certificate',
-                default=False,
-                help='Whether to verify Nimble SSL Certificate'),
-    cfg.StrOpt('nimble_verify_cert_path',
-               help='Path to Nimble Array SSL certificate'), ]
-
-CONF = cfg.CONF
-CONF.register_opts(nimble_opts, group=configuration.SHARED_CONF_GROUP)
-
-
-class NimbleDriverException(exception.VolumeDriverException):
-    message = _("Nimble Cinder Driver exception")
-
-
-class NimbleAPIException(exception.VolumeBackendAPIException):
-    message = _("Unexpected response from Nimble API")
-
-
-class NimbleVolumeBusyException(exception.VolumeIsBusy):
-    message = _("Nimble Cinder Driver: Volume Busy")
-
-
-class NimbleBaseVolumeDriver(san.SanDriver):
-    """OpenStack driver to enable Nimble Controller.
-
-    Version history:
-
-    .. code-block:: none
-
-
-        1.0 - Initial driver
-        1.1.1 - Updated VERSION to Nimble driver version
-        1.1.2 - Update snap-quota to unlimited
-        2.0.0 - Added Extra Spec Capability
-                Correct capacity reporting
-                Added Manage/Unmanage volume support
-        2.0.1 - Added multi-initiator support through extra-specs
-        2.0.2 - Fixed supporting extra specs while cloning vols
-        3.0.0 - Newton Support for Force Backup
-        3.1.0 - Fibre Channel Support
-        4.0.0 - Migrate from SOAP to REST API
-                Add support for Group Scoped Target
-        4.0.1 - Add QoS and dedupe support
-    """
-    VERSION = DRIVER_VERSION
-
-    # ThirdPartySystems wiki page
-    CI_WIKI_NAME = "Nimble_Storage_CI"
-
-    # TODO(jsbryant) Remove driver in the 'U' release if CI is not fixed.
-    SUPPORTED = False
-
-    def __init__(self, *args, **kwargs):
-        super(NimbleBaseVolumeDriver, self).__init__(*args, **kwargs)
-        self.APIExecutor = None
-        self.group_stats = {}
-        self.api_protocol = None
-        self._storage_protocol = None
-        self._group_target_enabled = False
-        self.configuration.append_config_values(nimble_opts)
-        self.verify = False
-        if self.configuration.nimble_verify_certificate is True:
-            self.verify = self.configuration.nimble_verify_cert_path or True
-
-    @staticmethod
-    def get_driver_options():
-        return nimble_opts
-
-    def _check_config(self):
-        """Ensure that the flags we care about are set."""
-        required_config = ['san_ip', 'san_login', 'san_password']
-        for attr in required_config:
-            if not getattr(self.configuration, attr, None):
-                raise exception.InvalidInput(reason=_('%s is not set.') %
-                                             attr)
-
-    def create_volume(self, volume):
-        """Create a new volume."""
-        reserve = not self.configuration.san_thin_provision
-        self.APIExecutor.create_vol(
-            volume,
-            self.configuration.nimble_pool_name, reserve,
-            self._storage_protocol,
-            self._group_target_enabled)
-        return self._get_model_info(volume['name'])
-
-    def is_volume_backup_clone(self, volume):
-        """check if the volume is created through cinder-backup workflow.
-
-        :param volume
-        """
-        vol_info = self.APIExecutor.get_vol_info(volume['name'])
-        LOG.debug("is_clone: %(is_clone)s base_snap_id: %(snap)s, "
-                  "parent_vol_id: %(vol)s",
-                  {'is_clone': vol_info['clone'],
-                   'snap': vol_info['base_snap_id'],
-                   'vol': vol_info['parent_vol_id']})
-
-        if vol_info['base_snap_id'] and (
-           vol_info['parent_vol_id'] is not None):
-            LOG.debug("Nimble base-snap exists for volume %(vol)s",
-                      {'vol': volume['name']})
-            volume_name_prefix = volume['name'].replace(volume['id'], "")
-            LOG.debug("volume_name_prefix : %(prefix)s",
-                      {'prefix': volume_name_prefix})
-            snap_id = self.APIExecutor.get_snap_info_by_id(
-                vol_info['base_snap_id'],
-                vol_info['parent_vol_id'])
-            snap_info = self.APIExecutor.get_snap_info_detail(snap_id['id'])
-            LOG.debug("snap_info description %(snap_info)s",
-                      {'snap_info': snap_info['description']})
-            if snap_info['description'] and BACKUP_VOL_PREFIX in (
-                    snap_info['description']):
-                # TODO(rkumar): get parent vol id from parent volume name
-                parent_vol_name = self.APIExecutor.get_volume_name(
-                    vol_info['parent_vol_id'])
-                parent_vol_id = parent_vol_name. replace(
-                    volume_name_prefix, "")
-                if BACKUP_VOL_PREFIX + parent_vol_id in snap_info[
-                   'description']:
-                    LOG.info('Nimble backup-snapshot exists name=%('
-                             'name)s', {'name': snap_info['name']})
-                    snap_vol_name = self.APIExecutor.get_volume_name(
-                        snap_info['vol_id'])
-                    LOG.debug("snap_vol_name %(snap)s",
-                              {'snap': snap_vol_name})
-                    return snap_info['name'], snap_vol_name
-        return "", ""
-
-    def delete_volume(self, volume):
-        """Delete the specified volume."""
-        backup_snap_name, backup_vol_name = self.is_volume_backup_clone(volume)
-        eventlet.sleep(DEFAULT_SLEEP)
-        self.APIExecutor.online_vol(volume['name'], False)
-        LOG.debug("Deleting volume %(vol)s", {'vol': volume['name']})
-
-        @utils.retry(NimbleAPIException, retries=3)
-        def _retry_remove_vol(volume):
-            self.APIExecutor.delete_vol(volume['name'])
-        try:
-            _retry_remove_vol(volume)
-        except NimbleAPIException as ex:
-            LOG.debug("delete volume exception: %s", ex)
-            if SM_OBJ_HAS_CLONE in six.text_type(ex):
-                LOG.warning('Volume %(vol)s : %(state)s',
-                            {'vol': volume['name'],
-                             'state': SM_OBJ_HAS_CLONE})
-                # set the volume back to be online and raise busy exception
-                self.APIExecutor.online_vol(volume['name'], True)
-                raise exception.VolumeIsBusy(volume_name=volume['name'])
-            raise
-        # Nimble backend does not delete the snapshot from the parent volume
-        # if there is a dependent clone. So the deletes need to be in reverse
-        # order i.e.
-        # 1. First delete the clone volume used for backup
-        # 2. Delete the base snapshot used for clone from the parent volume.
-        # This is only done for the force backup clone operation as it is
-        # a temporary operation in which we are certain that the snapshot does
-        # not need to be preserved after the backup is completed.
-
-        if (backup_snap_name != "" and backup_vol_name != "") and (
-           backup_snap_name is not None):
-            LOG.debug("Delete volume backup vol: %(vol)s snap: %(snap)s",
-                      {'vol': backup_vol_name,
-                       'snap': backup_snap_name})
-            self.APIExecutor.online_snap(backup_vol_name,
-                                         False,
-                                         backup_snap_name)
-
-            self.APIExecutor.delete_snap(backup_vol_name,
-                                         backup_snap_name)
-
-    def _generate_random_string(self, length):
-        """Generates random_string."""
-        char_set = string.ascii_lowercase
-        return ''.join(random.sample(char_set, length))
-
-    def _clone_volume_from_snapshot(self, volume, snapshot):
-        """Clone volume from snapshot.
-
-        Extend the volume if the size of the volume is more than the snapshot.
-        """
-        reserve = not self.configuration.san_thin_provision
-        pool_name = self.configuration.nimble_pool_name
-        self.APIExecutor.clone_vol(volume, snapshot, reserve,
-                                   self._group_target_enabled,
-                                   self._storage_protocol,
-                                   pool_name)
-        if(volume['size'] > snapshot['volume_size']):
-            vol_size = volume['size'] * units.Ki
-            reserve_size = 100 if reserve else 0
-            data = {"data": {'size': vol_size,
-                             'reserve': reserve_size,
-                             'warn_level': int(WARN_LEVEL),
-                             'limit': 100,
-                             'snap_limit': DEFAULT_SNAP_QUOTA}}
-            LOG.debug("Edit Vol request %(data)s", {'data': data})
-            self.APIExecutor.edit_vol(volume['name'], data)
-        return self._get_model_info(volume['name'])
-
-    def create_cloned_volume(self, volume, src_vref):
-        """Create a clone of the specified volume."""
-        snapshot_name = ('openstack-clone-' +
-                         volume['name'] + '-' +
-                         self._generate_random_string(12))
-        snapshot = {'volume_name': src_vref['name'],
-                    'name': snapshot_name,
-                    'volume_size': src_vref['size'],
-                    'display_name': volume.display_name,
-                    'display_description': ''}
-        self.APIExecutor.snap_vol(snapshot)
-        self._clone_volume_from_snapshot(volume, snapshot)
-        return self._get_model_info(volume['name'])
-
-    def create_export(self, context, volume, connector):
-        """Driver entry point to get the export info for a new volume."""
-        return self._get_model_info(volume['name'])
-
-    def ensure_export(self, context, volume):
-        """Driver entry point to get the export info for an existing volume."""
-        return self._get_model_info(volume['name'])
-
-    def create_snapshot(self, snapshot):
-        """Create a snapshot."""
-        self.APIExecutor.snap_vol(snapshot)
-
-    def delete_snapshot(self, snapshot):
-        """Delete a snapshot."""
-        self.APIExecutor.online_snap(
-            snapshot['volume_name'],
-            False,
-            snapshot['name'])
-        self.APIExecutor.delete_snap(snapshot['volume_name'],
-                                     snapshot['name'])
-
-    def create_volume_from_snapshot(self, volume, snapshot):
-        """Create a volume from a snapshot."""
-        self._clone_volume_from_snapshot(volume, snapshot)
-        return self._get_model_info(volume['name'])
-
-    def _enable_group_scoped_target(self, group_info):
-        if 'version_current' in group_info:
-            current_version = group_info['version_current']
-            major_minor = current_version.split(".")
-            if len(major_minor) >= 3:
-                major = major_minor[0]
-                minor = major_minor[1]
-                # TODO(rkumar): Fix the major version
-                if int(major) >= 4 and int(minor) >= 0:
-                    # Enforce group scoped target
-                    if 'group_target_enabled' in group_info:
-                        if group_info['group_target_enabled'] is False:
-                            try:
-                                self.APIExecutor.enable_group_scoped_target()
-                            except Exception:
-                                raise NimbleAPIException(_("Unable to enable"
-                                                         " GST"))
-                        self._group_target_enabled = True
-                        LOG.info("Group Scoped Target enabled for "
-                                 "group %(group)s: %(ip)s",
-                                 {'group': group_info['name'],
-                                  'ip': self.configuration.san_ip})
-                    elif 'group_target_enabled' not in group_info:
-                        LOG.info("Group Scoped Target NOT "
-                                 "present for group %(group)s: "
-                                 "%(ip)s",
-                                 {'group': group_info['name'],
-                                  'ip': self.configuration.san_ip})
-            else:
-                raise NimbleAPIException(_("Unable to get current software "
-                                           "version for %s") %
-                                         self.configuration.san_ip)
-
-    def get_volume_stats(self, refresh=False):
-        """Get volume stats. This is more of getting group stats."""
-        if refresh:
-            group_info = self.APIExecutor.get_group_info()
-            if 'usage_valid' not in group_info:
-                raise NimbleDriverException(_('SpaceInfo returned by '
-                                              'array is invalid'))
-            total_capacity = (group_info['usable_capacity_bytes'] /
-                              float(units.Gi))
-            used_space = ((group_info['compressed_vol_usage_bytes'] +
-                          group_info['compressed_snap_usage_bytes'] +
-                          group_info['unused_reserve_bytes']) /
-                          float(units.Gi))
-
-            free_space = total_capacity - used_space
-            LOG.debug('total_capacity=%(capacity)f '
-                      'used_space=%(used)f free_space=%(free)f',
-                      {'capacity': total_capacity,
-                       'used': used_space,
-                       'free': free_space})
-
-            backend_name = self.configuration.safe_get(
-                'volume_backend_name') or self.__class__.__name__
-            self.group_stats = {'volume_backend_name': backend_name,
-                                'vendor_name': 'Nimble',
-                                'driver_version': DRIVER_VERSION,
-                                'storage_protocol': self._storage_protocol}
-            # Just use a single pool for now, FIXME to support multiple
-            # pools
-            single_pool = dict(
-                pool_name=backend_name,
-                total_capacity_gb=total_capacity,
-                free_capacity_gb=free_space,
-                reserved_percentage=0,
-                QoS_support=False)
-            self.group_stats['pools'] = [single_pool]
-        return self.group_stats
-
-    def extend_volume(self, volume, new_size):
-        """Extend an existing volume."""
-        volume_name = volume['name']
-        LOG.info('Entering extend_volume volume=%(vol)s '
-                 'new_size=%(size)s',
-                 {'vol': volume_name, 'size': new_size})
-        vol_size = int(new_size) * units.Ki
-        reserve = not self.configuration.san_thin_provision
-        reserve_size = 100 if reserve else 0
-        LOG.debug("new volume size in MB (size)s", {'size': vol_size})
-        data = {"data": {'size': vol_size,
-                         'reserve': reserve_size,
-                         'warn_level': int(WARN_LEVEL),
-                         'limit': 100,
-                         'snap_limit': DEFAULT_SNAP_QUOTA}}
-        self.APIExecutor.edit_vol(volume_name, data)
-
-    def _get_existing_volume_ref_name(self, existing_ref):
-        """Returns the volume name of an existing ref"""
-        vol_name = None
-        if 'source-name' in existing_ref:
-            vol_name = existing_ref['source-name']
-        else:
-            reason = _("Reference must contain source-name.")
-            raise exception.ManageExistingInvalidReference(
-                existing_ref=existing_ref,
-                reason=reason)
-
-        return vol_name
-
-    def _get_volumetype_extraspecs_with_type(self, type_id):
-        specs = {}
-        if type_id is not None:
-            specs = volume_types.get_volume_type_extra_specs(type_id)
-        return specs
-
-    def retype(self, context, volume, new_type, diff, host):
-        """Retype from one volume type to another.
-
-        At this point HPE Nimble Storage does not differentiate between
-        volume types on the same array. This is a no-op for us if there are
-        no extra specs else honor the extra-specs.
-        """
-        if new_type is None:
-            return True, None
-        LOG.debug("retype called with volume_type %s", new_type)
-
-        volume_type_id = new_type['id']
-        if volume_type_id is None:
-            raise NimbleAPIException(_("No volume_type_id present in"
-                                       " %(type)s") % {'type': new_type})
-
-        LOG.debug("volume_type id is %s", volume_type_id)
-        specs_map = self._get_volumetype_extraspecs_with_type(
-            volume_type_id)
-        if specs_map is None:
-            # no extra specs to retype
-            LOG.debug("volume_type %s has no extra specs", volume_type_id)
-            return True, None
-        vol_info = self.APIExecutor.get_vol_info(volume['name'])
-        LOG.debug("new extra specs %s", specs_map)
-        data = self.APIExecutor.get_valid_nimble_extraspecs(specs_map,
-                                                            vol_info)
-        if data is None:
-            # return if there is no update
-            LOG.debug("no data to update for %s", new_type)
-            return True, None
-        try:
-            # offline the volume before edit
-            self.APIExecutor.online_vol(volume['name'], False)
-            # modify the volume
-            LOG.debug("updated volume %s", data)
-            self.APIExecutor.edit_vol(volume['name'], data)
-            # make the volume online after changing the specs
-            self.APIExecutor.online_vol(volume['name'], True)
-        except NimbleAPIException as ex:
-            raise NimbleAPIException(_("Unable to retype %(vol)s to "
-                                       "%(type)s: %(err)s") %
-                                     {'vol': volume['name'],
-                                      'type': new_type,
-                                      'err': ex.message})
-        return True, None
-
-    def manage_existing(self, volume, external_ref):
-        """Manage an existing nimble volume (import to cinder)"""
-
-        # Get the volume name from the external reference
-        target_vol_name = self._get_existing_volume_ref_name(external_ref)
-        LOG.debug('Entering manage_existing. '
-                  'Target_volume_name =%s', target_vol_name)
-
-        # Get vol info from the volume name obtained from the reference
-        vol_info = self.APIExecutor.get_vol_info(target_vol_name)
-
-        # Check if volume is already managed by OpenStack
-        if vol_info['agent_type'] == AGENT_TYPE_OPENSTACK or (
-           vol_info['agent_type'] == AGENT_TYPE_OPENSTACK_GST):
-            raise exception.ManageExistingAlreadyManaged(
-                volume_ref=volume['id'])
-
-        # If agent-type is not None then raise exception
-        if vol_info['agent_type'] != AGENT_TYPE_NONE:
-            msg = (_('Volume should have agent-type set as None.'))
-            raise exception.InvalidVolume(reason=msg)
-
-        new_vol_name = volume['name']
-        LOG.info("Volume status before managing it : %(status)s",
-                 {'status': vol_info['online']})
-        if vol_info['online'] is True:
-            msg = (_('Volume %s is online. Set volume to offline for '
-                     'managing using OpenStack.') % target_vol_name)
-            raise exception.InvalidVolume(reason=msg)
-
-        # edit the volume
-        data = {'data': {'name': new_vol_name}}
-        if self._group_target_enabled is True:
-            # check if any ACL's are attached to this volume
-            if 'access_control_records' in vol_info and (
-               vol_info['access_control_records'] is not None):
-                msg = (_('Volume %s has ACL associated with it. Remove ACL '
-                         'for managing using OpenStack') % target_vol_name)
-                raise exception.InvalidVolume(reason=msg)
-            data['data']['agent_type'] = AGENT_TYPE_OPENSTACK_GST
-        else:
-            data['data']['agent_type'] = AGENT_TYPE_OPENSTACK
-
-        LOG.debug("Data for edit %(data)s", {'data': data})
-        self.APIExecutor.edit_vol(target_vol_name, data)
-
-        # make the volume online after rename
-        self.APIExecutor.online_vol(new_vol_name, True)
-
-        return self._get_model_info(new_vol_name)
-
-    def manage_existing_get_size(self, volume, external_ref):
-        """Return size of an existing volume"""
-
-        LOG.debug('Volume name : %(name)s  External ref : %(ref)s',
-                  {'name': volume['name'], 'ref': external_ref})
-
-        target_vol_name = self._get_existing_volume_ref_name(external_ref)
-
-        # get vol info
-        vol_info = self.APIExecutor.get_vol_info(target_vol_name)
-
-        LOG.debug('Volume size : %(size)s  Volume-name : %(name)s',
-                  {'size': vol_info['size'], 'name': vol_info['name']})
-
-        return int(vol_info['size'] / units.Ki)
-
-    def unmanage(self, volume):
-        """Removes the specified volume from Cinder management."""
-
-        vol_name = volume['name']
-        LOG.debug("Entering unmanage_volume volume =%s", vol_name)
-
-        # check agent type
-        vol_info = self.APIExecutor.get_vol_info(vol_name)
-        if vol_info['agent_type'] != AGENT_TYPE_OPENSTACK and (
-           vol_info['agent_type'] != AGENT_TYPE_OPENSTACK_GST):
-            msg = (_('Only volumes managed by OpenStack can be unmanaged.'))
-            raise exception.InvalidVolume(reason=msg)
-
-        data = {'data': {'agent_type': AGENT_TYPE_NONE}}
-        # update the agent-type to None
-        self.APIExecutor.edit_vol(vol_name, data)
-
-        # offline the volume
-        self.APIExecutor.online_vol(vol_name, False)
-
-    def do_setup(self, context):
-        """Setup the Nimble Cinder volume driver."""
-        self._check_config()
-        # Setup API Executor
-        try:
-            self.APIExecutor = NimbleRestAPIExecutor(
-                username=self.configuration.san_login,
-                password=self.configuration.san_password,
-                ip=self.configuration.san_ip,
-                verify=self.verify)
-            if self._storage_protocol == "iSCSI":
-                group_info = self.APIExecutor.get_group_info()
-                self._enable_group_scoped_target(group_info)
-        except Exception:
-            LOG.error('Failed to create REST client. '
-                      'Check san_ip, username, password'
-                      ' and make sure the array version is compatible')
-            raise
-        self._update_existing_vols_agent_type(context)
-
-    def _update_existing_vols_agent_type(self, context):
-        backend_name = self.configuration.safe_get('volume_backend_name')
-        all_vols = volume.VolumeList.get_all(
-            context, None, None, None, None, {'status': 'available'})
-        for vol in all_vols:
-            if backend_name in vol.host:
-                try:
-                    vol_info = self.APIExecutor.get_vol_info(vol.name)
-                    # update agent_type only if no ACL's are present
-                    if 'access_control_records' in vol_info and (
-                       vol_info['access_control_records'] is None):
-                        if self._group_target_enabled:
-                            LOG.debug("Updating %(vol)s to have agent_type :"
-                                      "%(agent)s",
-                                      {'vol': vol.name,
-                                       'agent': AGENT_TYPE_OPENSTACK_GST})
-                            # check if this is an upgrade case from
-                            # openstack to openstackv2
-                            if vol_info['agent_type'] == AGENT_TYPE_NONE:
-                                data = {'data': {'agent_type':
-                                                 AGENT_TYPE_OPENSTACK_GST}}
-                                self.APIExecutor.edit_vol(vol.name, data)
-                            elif vol_info['agent_type'] == (
-                                    AGENT_TYPE_OPENSTACK):
-                                # 1. update the agent type to None
-                                data = {'data': {'agent_type':
-                                                 AGENT_TYPE_NONE}}
-                                self.APIExecutor.edit_vol(vol.name, data)
-                                # 2. update the agent type to openstack_gst
-                                data = {'data': {'agent_type':
-                                                 AGENT_TYPE_OPENSTACK_GST}}
-                                self.APIExecutor.edit_vol(vol.name, data)
-                        else:
-                            LOG.debug("Updating %(vol)s to have agent_type :"
-                                      "%(agent)s",
-                                      {'vol': vol.name,
-                                       'agent': AGENT_TYPE_OPENSTACK_GST})
-                            if vol_info['agent_type'] == AGENT_TYPE_NONE:
-                                data = {'data': {'agent_type':
-                                                 AGENT_TYPE_OPENSTACK}}
-                                self.APIExecutor.edit_vol(vol.name, data)
-                            elif vol_info['agent_type'] == (
-                                    AGENT_TYPE_OPENSTACK_GST):
-                                # 1. update the agent type to None
-                                data = {'data': {'agent_type':
-                                                 AGENT_TYPE_NONE}}
-                                self.APIExecutor.edit_vol(vol.name, data)
-                                # 2. update the agent type to openstack
-                                data = {'data': {'agent_type':
-                                                 AGENT_TYPE_OPENSTACK}}
-                                self.APIExecutor.edit_vol(vol.name, data)
-                except NimbleAPIException:
-                    # just log the error but don't fail driver initialization
-                    LOG.warning('Error updating agent-type for '
-                                'volume %s.', vol.name)
-
-    def _get_model_info(self, volume_name):
-        """Get model info for the volume."""
-        return (
-            {'provider_location': self._get_provider_location(volume_name),
-             'provider_auth': None})
-
-    @abc.abstractmethod
-    def _get_provider_location(self, volume_name):
-        """Volume info for iSCSI and FC"""
-
-        pass
-
-    def _create_igroup_for_initiator(self, initiator_name, wwpns):
-        """Creates igroup for an initiator and returns the igroup name."""
-        igrp_name = 'openstack-' + self._generate_random_string(12)
-        LOG.info('Creating initiator group %(grp)s '
-                 'with initiator %(iname)s',
-                 {'grp': igrp_name, 'iname': initiator_name})
-        if self._storage_protocol == "iSCSI":
-            self.APIExecutor.create_initiator_group(igrp_name)
-            self.APIExecutor.add_initiator_to_igroup(igrp_name, initiator_name)
-        elif self._storage_protocol == "FC":
-            self.APIExecutor.create_initiator_group_fc(igrp_name)
-            for wwpn in wwpns:
-                self.APIExecutor.add_initiator_to_igroup_fc(igrp_name, wwpn)
-        return igrp_name
-
-    def _get_igroupname_for_initiator_fc(self, initiator_wwpns):
-        initiator_groups = self.APIExecutor.get_initiator_grp_list()
-        for initiator_group in initiator_groups:
-            if 'fc_initiators' in initiator_group and initiator_group[
-               'fc_initiators'] is not None:
-                wwpns_list = []
-                for initiator in initiator_group['fc_initiators']:
-                    wwpn = str(initiator['wwpn']).replace(":", "")
-                    wwpns_list.append(wwpn)
-                LOG.debug("initiator_wwpns=%(initiator)s "
-                          "wwpns_list_from_array=%(wwpns)s",
-                          {'initiator': initiator_wwpns,
-                           'wwpns': wwpns_list})
-                if set(initiator_wwpns) == set(wwpns_list):
-                    LOG.info('igroup %(grp)s found for '
-                             'initiator %(wwpns_list)s',
-                             {'grp': initiator_group['name'],
-                              'wwpns_list': wwpns_list})
-                    return initiator_group['name']
-        LOG.info('No igroup found for initiators %s', initiator_wwpns)
-        return ''
-
-    def _get_igroupname_for_initiator(self, initiator_name):
-        initiator_groups = self.APIExecutor.get_initiator_grp_list()
-        for initiator_group in initiator_groups:
-            if initiator_group['iscsi_initiators'] is not None:
-                if (len(initiator_group['iscsi_initiators']) == 1 and
-                    initiator_group['iscsi_initiators'][0]['iqn'] ==
-                        initiator_name):
-                    LOG.info('igroup %(grp)s found for '
-                             'initiator %(iname)s',
-                             {'grp': initiator_group['name'],
-                              'iname': initiator_name})
-                    return initiator_group['name']
-        LOG.info('No igroup found for initiator %s', initiator_name)
-        return ''
-
-    def get_lun_number(self, volume, initiator_group_name):
-        vol_info = self.APIExecutor.get_vol_info(volume['name'])
-        for acl in vol_info['access_control_records']:
-            if (initiator_group_name == acl['initiator_group_name']):
-                LOG.info("access_control_record =%(acl)s",
-                         {'acl': acl})
-                lun = acl['lun']
-                LOG.info("LUN : %(lun)s", {"lun": lun})
-                return lun
-        raise NimbleAPIException(_("Lun number not found for volume %(vol)s "
-                                   "with initiator_group: %(igroup)s") %
-                                 {'vol': volume['name'],
-                                  'igroup': initiator_group_name})
-
-
-@interface.volumedriver
-class NimbleISCSIDriver(NimbleBaseVolumeDriver, san.SanISCSIDriver):
-
-    """OpenStack driver to enable Nimble ISCSI Controller."""
-
-    def __init__(self, *args, **kwargs):
-        super(NimbleISCSIDriver, self).__init__(*args, **kwargs)
-        self._storage_protocol = "iSCSI"
-        self._group_target_name = None
-
-    def _set_gst_for_group(self):
-        group_info = self.APIExecutor.get_group_info()
-        if 'group_target_enabled' in group_info and (
-                group_info['group_target_enabled']) is True and (
-                    'group_target_name' in group_info) and (
-                    group_info['group_target_name'] is not None):
-            self._group_target_name = group_info['group_target_name']
-
-    def _get_gst_for_group(self):
-        return self._group_target_name
-
-    def initialize_connection(self, volume, connector):
-        """Driver entry point to attach a volume to an instance."""
-        LOG.info('Entering initialize_connection volume=%(vol)s'
-                 ' connector=%(conn)s location=%(loc)s',
-                 {'vol': volume,
-                  'conn': connector,
-                  'loc': volume['provider_location']})
-        initiator_name = connector['initiator']
-        initiator_group_name = self._get_igroupname_for_initiator(
-            initiator_name)
-        if not initiator_group_name:
-            initiator_group_name = self._create_igroup_for_initiator(
-                initiator_name, None)
-        LOG.info('Initiator group name is %(grp)s for initiator '
-                 '%(iname)s',
-                 {'grp': initiator_group_name, 'iname': initiator_name})
-        self.APIExecutor.add_acl(volume, initiator_group_name)
-        properties = {"driver_volume_type": "iscsi",
-                      "data": {"target_discovered": False},
-                      }
-        properties['data']['volume_id'] = volume['id']  # used by xen currently
-        (iscsi_portal, iqn) = volume['provider_location'].split()
-        if self._get_gst_for_group() is not None:
-            lun_num = self.get_lun_number(volume, initiator_group_name)
-            netconfig = self.APIExecutor.get_netconfig('active')
-            target_portals = self._get_data_ips(netconfig)
-            LOG.info("target portals %(portals)s", {'portals': target_portals})
-            target_luns = [int(lun_num)] * len(target_portals)
-            target_iqns = [iqn] * len(target_portals)
-            LOG.debug("target iqns %(iqns)s target luns %(luns)s",
-                      {'iqns': target_iqns, 'luns': target_luns})
-            if target_luns and target_iqns and target_portals:
-                properties["data"]["target_luns"] = target_luns
-                properties["data"]["target_iqns"] = target_iqns
-                properties["data"]["target_portals"] = target_portals
-        else:
-            # handling volume scoped target
-            lun_num = LUN_ID
-            properties['data']['target_portal'] = iscsi_portal
-            properties['data']['target_iqn'] = iqn
-            properties['data']['target_lun'] = int(lun_num)
-
-        return properties
-
-    def terminate_connection(self, volume, connector, **kwargs):
-        """Driver entry point to unattach a volume from an instance."""
-        LOG.info('Entering terminate_connection volume=%(vol)s'
-                 ' connector=%(conn)s location=%(loc)s.',
-                 {'vol': volume['name'],
-                  'conn': connector,
-                  'loc': volume['provider_location']})
-
-        if connector is None:
-            LOG.warning("Removing ALL host connections for volume %s",
-                        volume)
-            self.APIExecutor.remove_all_acls(volume)
-            return
-
-        initiator_name = connector['initiator']
-        initiator_group_name = self._get_igroupname_for_initiator(
-            initiator_name)
-        if not initiator_group_name:
-            raise NimbleDriverException(_('No initiator group found for '
-                                          'initiator %s') % initiator_name)
-        self.APIExecutor.remove_acl(volume, initiator_group_name)
-        eventlet.sleep(DEFAULT_SLEEP)
-
-    def _get_provider_location(self, volume_name):
-        """Get volume iqn for initiator access."""
-        vol_info = self.APIExecutor.get_vol_info(volume_name)
-        netconfig = self.APIExecutor.get_netconfig('active')
-        self._set_gst_for_group()
-        if self._get_gst_for_group() is not None:
-            iqn = self._get_gst_for_group()
-        else:
-            iqn = vol_info['target_name']
-        target_ipaddr = self._get_discovery_ip(netconfig)
-        iscsi_portal = target_ipaddr + ':3260'
-        provider_location = '%s %s' % (iscsi_portal, iqn)
-        LOG.info('vol_name=%(name)s provider_location=%(loc)s',
-                 {'name': volume_name, 'loc': provider_location})
-        return provider_location
-
-    def _get_data_ips(self, netconfig):
-        """Get data ips."""
-        subnet_label = self.configuration.nimble_subnet_label
-        LOG.debug('subnet_label used %(netlabel)s, netconfig %(netconf)s',
-                  {'netlabel': subnet_label, 'netconf': netconfig})
-        ret_data_ips = []
-        for subnet in netconfig['array_list'][0]['nic_list']:
-            LOG.info('Exploring array subnet label %s', subnet[
-                'subnet_label'])
-            if subnet['data_ip']:
-                if subnet_label == '*':
-                    # if all subnets are mentioned then return all portals
-                    # else just return specific subnet
-                    LOG.info('Data ip %(data_ip)s is used '
-                             'on data subnet %(net_label)s',
-                             {'data_ip': subnet['data_ip'],
-                              'net_label': subnet['subnet_label']})
-                    ret_data_ips.append(str(subnet['data_ip']) + ':3260')
-                elif subnet_label == subnet['subnet_label']:
-                    LOG.info('Data ip %(data_ip)s is used'
-                             ' on subnet %(net_label)s',
-                             {'data_ip': subnet['data_ip'],
-                              'net_label': subnet['subnet_label']})
-                    data_ips_single_subnet = []
-                    data_ips_single_subnet.append(str(subnet['data_ip']) +
-                                                  ':3260')
-                    return data_ips_single_subnet
-        if ret_data_ips:
-            LOG.info('Data ips %s', ret_data_ips)
-            return ret_data_ips
-        else:
-            raise NimbleDriverException(_('No suitable data ip found'))
-
-    def _get_discovery_ip(self, netconfig):
-        """Get discovery ip."""
-        subnet_label = self.configuration.nimble_subnet_label
-        LOG.debug('subnet_label used %(netlabel)s, netconfig %(netconf)s',
-                  {'netlabel': subnet_label, 'netconf': netconfig})
-        ret_discovery_ip = ''
-        for subnet in netconfig['subnet_list']:
-            LOG.info('Exploring array subnet label %s', subnet['label'])
-            if subnet_label == '*':
-                # Use the first data subnet, save mgmt+data for later
-                if subnet['type'] == SM_SUBNET_DATA:
-                    LOG.info('Discovery ip %(disc_ip)s is used '
-                             'on data subnet %(net_label)s',
-                             {'disc_ip': subnet['discovery_ip'],
-                              'net_label': subnet['label']})
-                    return subnet['discovery_ip']
-                elif (subnet['type'] == SM_SUBNET_MGMT_PLUS_DATA):
-                    LOG.info('Discovery ip %(disc_ip)s is found'
-                             ' on mgmt+data subnet %(net_label)s',
-                             {'disc_ip': subnet['discovery_ip'],
-                              'net_label': subnet['label']})
-                    ret_discovery_ip = subnet['discovery_ip']
-            # If subnet is specified and found, use the subnet
-            elif subnet_label == subnet['label']:
-                LOG.info('Discovery ip %(disc_ip)s is used'
-                         ' on subnet %(net_label)s',
-                         {'disc_ip': subnet['discovery_ip'],
-                          'net_label': subnet['label']})
-                return subnet['discovery_ip']
-        if ret_discovery_ip:
-            LOG.info('Discovery ip %s is used on mgmt+data subnet',
-                     ret_discovery_ip)
-            return ret_discovery_ip
-        else:
-            raise NimbleDriverException(_('No suitable discovery ip found'))
-
-
-@interface.volumedriver
-class NimbleFCDriver(NimbleBaseVolumeDriver, driver.FibreChannelDriver):
-    """OpenStack driver to enable Nimble FC Driver Controller."""
-
-    def __init__(self, *args, **kwargs):
-        super(NimbleFCDriver, self).__init__(*args, **kwargs)
-        self._storage_protocol = "FC"
-        self._lookup_service = fczm_utils.create_lookup_service()
-
-    def _get_provider_location(self, volume_name):
-        """Get array info wwn details."""
-        netconfig = self.APIExecutor.get_netconfig('active')
-        array_name = netconfig['group_leader_array']
-        provider_location = '%s' % (array_name)
-        LOG.info('vol_name=%(name)s provider_location=%(loc)s',
-                 {'name': volume_name, 'loc': provider_location})
-        return provider_location
-
-    def _build_initiator_target_map(self, target_wwns, connector):
-        """Build the target_wwns and the initiator target map."""
-        LOG.debug("_build_initiator_target_map for %(wwns)s",
-                  {'wwns': target_wwns})
-        init_targ_map = {}
-
-        if self._lookup_service:
-            # use FC san lookup to determine which wwpns to use
-            # for the new VLUN.
-            dev_map = self._lookup_service.get_device_mapping_from_network(
-                connector['wwpns'],
-                target_wwns)
-            map_fabric = dev_map
-            LOG.info("dev_map =%(fabric)s", {'fabric': map_fabric})
-
-            for fabric_name in dev_map:
-                fabric = dev_map[fabric_name]
-                for initiator in fabric['initiator_port_wwn_list']:
-                    if initiator not in init_targ_map:
-                        init_targ_map[initiator] = []
-                    init_targ_map[initiator] += fabric['target_port_wwn_list']
-                    init_targ_map[initiator] = list(set(
-                        init_targ_map[initiator]))
-        else:
-            init_targ_map = dict.fromkeys(connector["wwpns"], target_wwns)
-
-        return init_targ_map
-
-    def initialize_connection(self, volume, connector):
-        """Driver entry point to attach a volume to an instance."""
-        LOG.info('Entering initialize_connection volume=%(vol)s'
-                 ' connector=%(conn)s location=%(loc)s',
-                 {'vol': volume,
-                  'conn': connector,
-                  'loc': volume['provider_location']})
-        wwpns = []
-        initiator_name = connector['initiator']
-        for wwpn in connector['wwpns']:
-            wwpns.append(wwpn)
-        initiator_group_name = self._get_igroupname_for_initiator_fc(wwpns)
-
-        if not initiator_group_name:
-            initiator_group_name = self._create_igroup_for_initiator(
-                initiator_name, wwpns)
-
-        LOG.info('Initiator group name is %(grp)s for initiator '
-                 '%(iname)s',
-                 {'grp': initiator_group_name, 'iname': initiator_name})
-        self.APIExecutor.add_acl(volume, initiator_group_name)
-        lun = self.get_lun_number(volume, initiator_group_name)
-        init_targ_map = {}
-        (array_name) = volume['provider_location'].split()
-
-        target_wwns = self.get_wwpns_from_array(array_name)
-
-        init_targ_map = self._build_initiator_target_map(target_wwns,
-                                                         connector)
-
-        data = {'driver_volume_type': 'fibre_channel',
-                'data': {'target_lun': lun,
-                         'target_discovered': True,
-                         'target_wwn': target_wwns,
-                         'initiator_target_map': init_targ_map}}
-
-        LOG.info("Return FC data for zone addition: %(data)s.",
-                 {'data': data})
-        fczm_utils.add_fc_zone(data)
-        return data
-
-    def terminate_connection(self, volume, connector, **kwargs):
-        """Driver entry point to unattach a volume from an instance."""
-        LOG.info('Entering terminate_connection volume=%(vol)s'
-                 ' connector=%(conn)s location=%(loc)s.',
-                 {'vol': volume,
-                  'conn': connector,
-                  'loc': volume['provider_location']})
-        wwpns = []
-        if connector is None:
-            LOG.warning("Removing ALL host connections for volume %s",
-                        volume)
-            self.APIExecutor.remove_all_acls(volume)
-            return
-
-        initiator_name = connector['initiator']
-        for wwpn in connector['wwpns']:
-            wwpns.append(wwpn)
-        (array_name) = volume['provider_location'].split()
-        target_wwns = self.get_wwpns_from_array(array_name)
-        init_targ_map = self._build_initiator_target_map(target_wwns,
-                                                         connector)
-        initiator_group_name = self._get_igroupname_for_initiator_fc(wwpns)
-        if not initiator_group_name:
-            raise NimbleDriverException(
-                _('No initiator group found for initiator %s') %
-                initiator_name)
-        LOG.debug("initiator_target_map %s", init_targ_map)
-        self.APIExecutor.remove_acl(volume, initiator_group_name)
-        eventlet.sleep(DEFAULT_SLEEP)
-        # FIXME to check for other volumes attached to the host and then
-        # return the data. Bug https://bugs.launchpad.net/cinder/+bug/1617472
-
-        data = {'driver_volume_type': 'fibre_channel',
-                'data': {'target_wwn': target_wwns}}
-
-        # FIXME: need to optionally add the initiator_target_map here when
-        # there are no more volumes exported to the initiator / target pair
-        # otherwise the zone will never get removed.
-        fczm_utils.remove_fc_zone(data)
-        return data
-
-    def get_wwpns_from_array(self, array_name):
-        """Retrieve the wwpns from the array"""
-        LOG.debug("get_wwpns_from_array %s", array_name)
-        target_wwpns = []
-        interface_info = self.APIExecutor.get_fc_interface_list(array_name)
-        LOG.info("interface_info %(interface_info)s",
-                 {"interface_info": interface_info})
-        for wwpn_list in interface_info:
-            wwpn = wwpn_list['wwpn']
-            wwpn = wwpn.replace(":", "")
-            target_wwpns.append(wwpn)
-
-        return target_wwpns
-
-    def _convert_string_to_colon_separated_wwnn(self, wwnn):
-        return ':'.join(a + b for a, b in zip(wwnn[::2], wwnn[1::2]))
-
-
-def _connection_checker(func):
-    """Decorator to re-establish and re-run the api if session has expired."""
-    @functools.wraps(func)
-    def inner_connection_checker(self, *args, **kwargs):
-        for attempts in range(2):
-            try:
-                return func(self, *args, **kwargs)
-            except Exception as e:
-                if attempts < 1 and (re.search("Failed to execute",
-                                     six.text_type(e))):
-                    LOG.info('Session might have expired.'
-                             ' Trying to relogin')
-                    self.login()
-                    continue
-                else:
-                    LOG.error('Re-throwing Exception %s', e)
-                    raise
-    return inner_connection_checker
-
-
-class NimbleRestAPIExecutor(object):
-
-    """Makes Nimble REST API calls."""
-
-    def __init__(self, api_version=NimbleDefaultVersion, *args, **kwargs):
-        self.token_id = None
-        self.ip = kwargs['ip']
-        self.username = kwargs['username']
-        self.password = kwargs['password']
-        self.verify = kwargs['verify']
-        self.api_version = api_version
-        self.uri = "https://%(ip)s:5392/v%(version)s/" % {
-            'ip': self.ip,
-            'version': self.api_version}
-        self.login()
-
-    def login(self):
-        data = {'data': {"username": self.username,
-                         "password": self.password,
-                         "app_name": "NimbleCinderDriver"}}
-        r = requests.post(self.uri + "tokens",
-                          data=json.dumps(data),
-                          verify=self.verify)
-
-        if r.status_code != 201 and r.status_code != 200:
-            msg = _("Failed to login for user %s"), self.username
-            raise NimbleAPIException(msg)
-        self.token_id = r.json()['data']['session_token']
-        self.headers = {'X-Auth-Token': self.token_id}
-
-    def get_group_id(self):
-        api = 'groups'
-        r = self.get(api)
-        if not r.json()['data']:
-            raise NimbleAPIException(_("Unable to retrieve Group Object for : "
-                                       "%s") % self.ip)
-        return r.json()['data'][0]['id']
-
-    def get_group_info(self):
-        group_id = self.get_group_id()
-        api = 'groups/' + six.text_type(group_id)
-        r = self.get(api)
-        if not r.json()['data']:
-            raise NimbleAPIException(_("Unable to retrieve Group info for: %s")
-                                     % group_id)
-        return r.json()['data']
-
-    def get_folder_id(self, folder_name):
-        api = 'folders'
-        filter = {"name": folder_name}
-        r = self.get_query(api, filter)
-        if not r.json()['data']:
-            raise NimbleAPIException(_("Unable to retrieve information for "
-                                       "Folder: %s") % folder_name)
-        return r.json()['data'][0]['id']
-
-    def get_folder_info(self, folder_name):
-        folder_id = self.get_folder_id(folder_name)
-        api = "folders/" + six.text_type(folder_id)
-        r = self.get(api)
-        if not r.json()['data']:
-            raise NimbleAPIException(_("Unable to retrieve Folder info for: "
-                                     "%s") % folder_id)
-        return r.json()['data']
-
-    def get_performance_policy_id(self, perf_policy_name):
-        api = 'performance_policies/'
-        filter = {'name': perf_policy_name}
-        LOG.debug("Performance policy Name %s", perf_policy_name)
-        r = self.get_query(api, filter)
-        if not r.json()['data']:
-            raise NimbleAPIException(_("No performance policy found for: "
-                                     "%(perf)s") % {'perf': perf_policy_name})
-        LOG.debug("Performance policy ID :%(perf)s",
-                  {'perf': r.json()['data'][0]['id']})
-        return r.json()['data'][0]['id']
-
-    def get_netconfig(self, role):
-        api = "network_configs/detail"
-        filter = {'role': role}
-        r = self.get_query(api, filter)
-        if not r.json()['data']:
-            raise NimbleAPIException(_("No %s network config exists") % role)
-        return r.json()['data'][0]
-
-    def _get_volumetype_extraspecs(self, volume):
-        specs = {}
-
-        type_id = volume['volume_type_id']
-        if type_id is not None:
-            specs = volume_types.get_volume_type_extra_specs(type_id)
-        return specs
-
-    def _get_extra_spec_values(self, extra_specs):
-        """Nimble specific extra specs."""
-        perf_policy_name = extra_specs.get(EXTRA_SPEC_PERF_POLICY,
-                                           DEFAULT_PERF_POLICY_SETTING)
-        encryption = extra_specs.get(EXTRA_SPEC_ENCRYPTION,
-                                     DEFAULT_ENCRYPTION_SETTING)
-        multi_initiator = extra_specs.get(EXTRA_SPEC_MULTI_INITIATOR,
-                                          DEFAULT_MULTI_INITIATOR_SETTING)
-        iops_limit = extra_specs.get(EXTRA_SPEC_IOPS_LIMIT,
-                                     DEFAULT_IOPS_LIMIT_SETTING)
-        folder_name = extra_specs.get(EXTRA_SPEC_FOLDER,
-                                      DEFAULT_FOLDER_SETTING)
-        dedupe = extra_specs.get(EXTRA_SPEC_DEDUPE,
-                                 DEFAULT_DEDUPE_SETTING)
-        extra_specs_map = {}
-        extra_specs_map[EXTRA_SPEC_PERF_POLICY] = perf_policy_name
-        extra_specs_map[EXTRA_SPEC_ENCRYPTION] = encryption
-        extra_specs_map[EXTRA_SPEC_MULTI_INITIATOR] = multi_initiator
-        extra_specs_map[EXTRA_SPEC_IOPS_LIMIT] = iops_limit
-        extra_specs_map[EXTRA_SPEC_DEDUPE] = dedupe
-        extra_specs_map[EXTRA_SPEC_FOLDER] = folder_name
-
-        return extra_specs_map
-
-    def get_valid_nimble_extraspecs(self, extra_specs_map, vol_info):
-
-        extra_specs_map_updated = self._get_extra_spec_values(extra_specs_map)
-        data = {"data": {}}
-        perf_policy_name = extra_specs_map_updated[EXTRA_SPEC_PERF_POLICY]
-        perf_policy_id = self.get_performance_policy_id(perf_policy_name)
-        data['perfpolicy_id'] = perf_policy_id
-
-        encrypt = extra_specs_map_updated[EXTRA_SPEC_ENCRYPTION]
-        cipher = DEFAULT_CIPHER
-        if encrypt.lower() == 'yes':
-            cipher = AES_256_XTS_CIPHER
-        data['cipher'] = cipher
-
-        multi_initiator = extra_specs_map_updated[EXTRA_SPEC_MULTI_INITIATOR]
-        data['multi_initiator'] = multi_initiator
-
-        folder_name = extra_specs_map_updated[EXTRA_SPEC_FOLDER]
-        folder_id = None
-        pool_id = vol_info['pool_id']
-        pool_name = vol_info['pool_name']
-        if folder_name is not None:
-            # validate if folder exists in pool_name
-            pool_info = self.get_pool_info(pool_id)
-            if 'folder_list' in pool_info and (pool_info['folder_list'] is
-                                               not None):
-                for folder_list in pool_info['folder_list']:
-                    LOG.debug("folder_list : %s", folder_list)
-                    if folder_list['fqn'] == "/" + folder_name:
-                        LOG.debug("Folder %(folder)s present in pool "
-                                  "%(pool)s",
-                                  {'folder': folder_name,
-                                   'pool': pool_name})
-                        folder_id = self.get_folder_id(folder_name)
-                        if folder_id is not None:
-                            data['data']["folder_id"] = folder_id
-                if folder_id is None:
-                    raise NimbleAPIException(_("Folder '%(folder)s' not "
-                                               "present in pool  '%("
-                                               "pool)s'") %
-                                             {'folder': folder_name,
-                                              'pool': pool_name})
-            else:
-                raise NimbleAPIException(_(
-                    "Folder '%(folder)s' not present in pool '%(pool)s'")
-                    % {'folder': folder_name,
-                       'pool': pool_name})
-        iops_limit = extra_specs_map_updated[EXTRA_SPEC_IOPS_LIMIT]
-        if iops_limit is not None:
-            if not iops_limit.isdigit() or (
-               int(iops_limit) < MIN_IOPS) or (int(iops_limit) > MAX_IOPS):
-                raise NimbleAPIException(_("%(err)s [%(min)s, %(max)s]")
-                                         % {'err': IOPS_ERR_MSG,
-                                            'min': MIN_IOPS,
-                                            'max': MAX_IOPS})
-
-            data['data']['limit_iops'] = iops_limit
-
-        dedupe = extra_specs_map_updated[EXTRA_SPEC_DEDUPE]
-        if dedupe.lower() == 'true':
-            data['data']['dedupe_enabled'] = True
-
-        return data
-
-    def create_vol(self, volume, pool_name, reserve, protocol, is_gst_enabled):
-        response = self._execute_create_vol(volume, pool_name, reserve,
-                                            protocol, is_gst_enabled)
-        LOG.info('Successfully created volume %(name)s',
-                 {'name': response['name']})
-        return response['name']
-
-    def _is_ascii(self, value):
-        try:
-            return all(ord(c) < 128 for c in value)
-        except TypeError:
-            return False
-
-    def _execute_create_vol(self, volume, pool_name, reserve, protocol,
-                            is_gst_enabled):
-        """Create volume
-
-        :return: r['data']
-        """
-
-        # Set volume size, display name and description
-        volume_size = volume['size'] * units.Ki
-        reserve_size = 100 if reserve else 0
-        # Set volume description
-        display_name = getattr(volume, 'display_name', '')
-        display_description = getattr(volume, 'display_description', '')
-        if self._is_ascii(display_name) and self._is_ascii(
-                display_description):
-            display_list = [getattr(volume, 'display_name', ''),
-                            getattr(volume, 'display_description', '')]
-            description = ':'.join(filter(None, display_list))
-        elif self._is_ascii(display_name):
-            description = display_name
-        elif self._is_ascii(display_description):
-            description = display_description
-        else:
-            description = ""
-
-        # Limit description size to 254 characters
-        description = description[:254]
-        pool_id = self.get_pool_id(pool_name)
-
-        specs = self._get_volumetype_extraspecs(volume)
-        extra_specs_map = self._get_extra_spec_values(specs)
-        perf_policy_name = extra_specs_map[EXTRA_SPEC_PERF_POLICY]
-        perf_policy_id = self.get_performance_policy_id(perf_policy_name)
-        encrypt = extra_specs_map[EXTRA_SPEC_ENCRYPTION]
-        multi_initiator = extra_specs_map[EXTRA_SPEC_MULTI_INITIATOR]
-        folder_name = extra_specs_map[EXTRA_SPEC_FOLDER]
-        iops_limit = extra_specs_map[EXTRA_SPEC_IOPS_LIMIT]
-        dedupe = extra_specs_map[EXTRA_SPEC_DEDUPE]
-
-        cipher = DEFAULT_CIPHER
-        if encrypt.lower() == 'yes':
-            cipher = AES_256_XTS_CIPHER
-        if is_gst_enabled is True:
-            agent_type = AGENT_TYPE_OPENSTACK_GST
-        else:
-            agent_type = AGENT_TYPE_OPENSTACK
-
-        LOG.debug('Creating a new volume=%(vol)s size=%(size)s'
-                  ' reserve=%(reserve)s in pool=%(pool)s'
-                  ' description=%(description)s with Extra Specs'
-                  ' perfpol-name=%(perfpol-name)s'
-                  ' encryption=%(encryption)s cipher=%(cipher)s'
-                  ' agent-type=%(agent-type)s'
-                  ' multi-initiator=%(multi-initiator)s',
-                  {'vol': volume['name'],
-                   'size': volume_size,
-                   'reserve': reserve_size,
-                   'pool': pool_name,
-                   'description': description,
-                   'perfpol-name': perf_policy_name,
-                   'encryption': encrypt,
-                   'cipher': cipher,
-                   'agent-type': agent_type,
-                   'multi-initiator': multi_initiator})
-        data = {"data":
-                {'name': volume['name'],
-                 'description': description,
-                 'size': volume_size,
-                 'reserve': reserve_size,
-                 'warn_level': int(WARN_LEVEL),
-                 'limit': 100,
-                 'snap_limit': DEFAULT_SNAP_QUOTA,
-                 'online': True,
-                 'pool_id': pool_id,
-                 'agent_type': agent_type,
-                 'perfpolicy_id': perf_policy_id,
-                 'encryption_cipher': cipher}}
-
-        if protocol == "iSCSI":
-            data['data']['multi_initiator'] = multi_initiator
-
-        if dedupe.lower() == 'true':
-            data['data']['dedupe_enabled'] = True
-
-        folder_id = None
-        if folder_name is not None:
-            # validate if folder exists in pool_name
-            pool_info = self.get_pool_info(pool_id)
-            if 'folder_list' in pool_info and (pool_info['folder_list'] is
-                                               not None):
-                for folder_list in pool_info['folder_list']:
-                    LOG.debug("folder_list : %s", folder_list)
-                    if folder_list['fqn'] == "/" + folder_name:
-                        LOG.debug("Folder %(folder)s present in pool "
-                                  "%(pool)s",
-                                  {'folder': folder_name,
-                                   'pool': pool_name})
-                        folder_id = self.get_folder_id(folder_name)
-                        if folder_id is not None:
-                            data['data']["folder_id"] = folder_id
-                if folder_id is None:
-                    raise NimbleAPIException(_("Folder '%(folder)s' not "
-                                               "present in pool '%(pool)s'") %
-                                             {'folder': folder_name,
-                                              'pool': pool_name})
-            else:
-                raise NimbleAPIException(_("Folder '%(folder)s' not present in"
-                                           " pool '%(pool)s'") %
-                                         {'folder': folder_name,
-                                          'pool': pool_name})
-
-        if iops_limit is not None:
-            if not iops_limit.isdigit() or (
-               int(iops_limit) < MIN_IOPS) or (int(iops_limit) > MAX_IOPS):
-                raise NimbleAPIException(_("%(err)s [%(min)s, %(max)s]") %
-                                         {'err': IOPS_ERR_MSG,
-                                          'min': MIN_IOPS,
-                                          'max': MAX_IOPS})
-
-            data['data']['limit_iops'] = iops_limit
-
-        LOG.debug("Volume metadata :%s", volume.metadata)
-        for key, value in volume.metadata.items():
-            LOG.debug("Key %(key)s Value %(value)s",
-                      {'key': key, 'value': value})
-            if key == EXTRA_SPEC_IOPS_LIMIT and value.isdigit():
-                if type(value) == int or int(value) < MIN_IOPS or (
-                   int(value) > MAX_IOPS):
-                    raise NimbleAPIException(_("%(err)s [%(min)s, %(max)s]") %
-                                             {'err': IOPS_ERR_MSG,
-                                              'min': MIN_IOPS,
-                                              'max': MAX_IOPS})
-                LOG.debug("IOPS Limit %s", value)
-                data['data']['limit_iops'] = value
-        LOG.debug("Data : %s", data)
-
-        api = 'volumes'
-        r = self.post(api, data)
-        return r['data']
-
-    def create_initiator_group(self, initiator_grp_name):
-        api = "initiator_groups"
-        data = {"data": {"name": initiator_grp_name,
-                         "access_protocol": "iscsi",
-                         }}
-        r = self.post(api, data)
-        return r['data']
-
-    def create_initiator_group_fc(self, initiator_grp_name):
-        api = "initiator_groups"
-
-        data = {}
-        data["data"] = {}
-        data["data"]["name"] = initiator_grp_name
-        data["data"]["access_protocol"] = "fc"
-        r = self.post(api, data)
-        return r['data']
-
-    def get_initiator_grp_id(self, initiator_grp_name):
-        api = "initiator_groups"
-        filter = {'name': initiator_grp_name}
-        r = self.get_query(api, filter)
-        return r.json()['data'][0]['id']
-
-    def add_initiator_to_igroup(self, initiator_grp_name, initiator_name):
-        initiator_group_id = self.get_initiator_grp_id(initiator_grp_name)
-        api = "initiators"
-        data = {"data": {
-            "access_protocol": "iscsi",
-            "initiator_group_id": initiator_group_id,
-            "label": initiator_name,
-            "iqn": initiator_name
-        }}
-        r = self.post(api, data)
-        return r['data']
-
-    def add_initiator_to_igroup_fc(self, initiator_grp_name, wwpn):
-        initiator_group_id = self.get_initiator_grp_id(initiator_grp_name)
-        api = "initiators"
-        data = {"data": {
-            "access_protocol": "fc",
-            "initiator_group_id": initiator_group_id,
-            "wwpn": self._format_to_wwpn(wwpn)
-        }}
-        r = self.post(api, data)
-        return r['data']
-
-    def get_pool_id(self, pool_name):
-        api = "pools/"
-        filter = {'name': pool_name}
-        r = self.get_query(api, filter)
-        if not r.json()['data']:
-            raise NimbleAPIException(_("Unable to retrieve information for "
-                                       "pool : %(pool)s") %
-                                     {'pool': pool_name})
-        return r.json()['data'][0]['id']
-
-    def get_pool_info(self, pool_id):
-        api = 'pools/' + six.text_type(pool_id)
-        r = self.get(api)
-        return r.json()['data']
-
-    def get_initiator_grp_list(self):
-        api = "initiator_groups/detail"
-        r = self.get(api)
-        if 'data' not in r.json():
-            raise NimbleAPIException(_("Unable to retrieve initiator group "
-                                       "list"))
-        LOG.info('Successfully retrieved InitiatorGrpList')
-        return r.json()['data']
-
-    def get_initiator_grp_id_by_name(self, initiator_group_name):
-        api = 'initiator_groups'
-        filter = {"name": initiator_group_name}
-        r = self.get_query(api, filter)
-        if not r.json()['data']:
-            raise NimbleAPIException(_("Unable to retrieve information for "
-                                       "initiator group : %s") %
-                                     initiator_group_name)
-        return r.json()['data'][0]['id']
-
-    def get_volume_id_by_name(self, name):
-        api = "volumes"
-        filter = {"name": name}
-        r = self.get_query(api, filter)
-        if not r.json()['data']:
-            raise NimbleAPIException(_("Unable to retrieve information for "
-                                       "volume: %s") % name)
-        return r.json()['data'][0]['id']
-
-    def get_volume_name(self, volume_id):
-        api = "volumes/" + six.text_type(volume_id)
-        r = self.get(api)
-        if not r.json()['data']:
-            raise NimbleAPIException(_("Unable to retrieve information for "
-                                       "volume: %s") % volume_id)
-        return r.json()['data']['name']
-
-    def add_acl(self, volume, initiator_group_name):
-        initiator_group_id = self.get_initiator_grp_id_by_name(
-            initiator_group_name)
-        volume_id = self.get_volume_id_by_name(volume['name'])
-        data = {'data': {"apply_to": 'both',
-                         "initiator_group_id": initiator_group_id,
-                         "vol_id": volume_id
-                         }}
-        api = 'access_control_records'
-        try:
-            self.post(api, data)
-        except NimbleAPIException as ex:
-            LOG.debug("add_acl_exception: %s", ex)
-            if SM_OBJ_EXIST_MSG in six.text_type(ex):
-                LOG.warning('Volume %(vol)s : %(state)s',
-                            {'vol': volume['name'],
-                             'state': SM_OBJ_EXIST_MSG})
-            else:
-                msg = (_("Add access control failed with error:  %s") %
-                       six.text_type(ex))
-                raise NimbleAPIException(msg)
-
-    def get_acl_record(self, volume_id, initiator_group_id):
-        filter = {"vol_id": volume_id,
-                  "initiator_group_id": initiator_group_id}
-        api = "access_control_records"
-        r = self.get_query(api, filter)
-        if not r.json()['data']:
-            raise NimbleAPIException(_("Unable to retrieve ACL for volume: "
-                                       "%(vol)s %(igroup)s ") %
-                                     {'vol': volume_id,
-                                      'igroup': initiator_group_id})
-        return r.json()['data'][0]
-
-    def get_volume_acl_records(self, volume_id):
-        api = "volumes/" + six.text_type(volume_id)
-        r = self.get(api)
-        if not r.json()['data']:
-            raise NimbleAPIException(_("Unable to retrieve information for "
-                                       "volume: %s") % volume_id)
-        return r.json()['data']['access_control_records']
-
-    def remove_all_acls(self, volume):
-        LOG.info("removing all access control list from volume=%(vol)s",
-                 {"vol": volume['name']})
-        volume_id = self.get_volume_id_by_name(volume['name'])
-        acl_records = self.get_volume_acl_records(volume_id)
-        if acl_records is not None:
-            for acl_record in acl_records:
-                LOG.info("removing acl=%(acl)s with igroup=%(igroup)s",
-                         {"acl": acl_record['id'],
-                          "igroup": acl_record['initiator_group_name']})
-                self.remove_acl(volume, acl_record['initiator_group_name'])
-
-    def remove_acl(self, volume, initiator_group_name):
-        LOG.info("removing ACL from volume=%(vol)s "
-                 "and %(igroup)s",
-                 {"vol": volume['name'],
-                  "igroup": initiator_group_name})
-        initiator_group_id = self.get_initiator_grp_id_by_name(
-            initiator_group_name)
-        volume_id = self.get_volume_id_by_name(volume['name'])
-
-        try:
-            acl_record = self.get_acl_record(volume_id, initiator_group_id)
-            LOG.debug("ACL Record %(acl)s", {"acl": acl_record})
-            acl_id = acl_record['id']
-            api = 'access_control_records/' + six.text_type(acl_id)
-            self.delete(api)
-        except NimbleAPIException as ex:
-            LOG.debug("remove_acl_exception: %s", ex)
-            if SM_OBJ_ENOENT_MSG in six.text_type(ex):
-                LOG.warning('Volume %(vol)s : %(state)s',
-                            {'vol': volume['name'],
-                             'state': SM_OBJ_ENOENT_MSG})
-            else:
-                msg = (_("Remove access control failed with error:  %s") %
-                       six.text_type(ex))
-                raise NimbleAPIException(msg)
-
-    def get_snap_info_by_id(self, snap_id, vol_id):
-        filter = {"id": snap_id, "vol_id": vol_id}
-        api = 'snapshots'
-        r = self.get_query(api, filter)
-        if not r.json()['data']:
-            raise NimbleAPIException(_("Unable to retrieve snapshot info for "
-                                       "snap_id: %(snap)s volume id: %(vol)s")
-                                     % {'snap': snap_id,
-                                        'vol': vol_id})
-        LOG.debug("SnapInfo :%s", r.json()['data'][0])
-        return r.json()['data'][0]
-
-    def get_snap_info(self, snap_name, vol_name):
-        filter = {"name": snap_name, "vol_name": vol_name}
-        api = 'snapshots'
-        r = self.get_query(api, filter)
-        if not r.json()['data']:
-            raise NimbleAPIException(_("Snapshot: %(snap)s of Volume: %(vol)s "
-                                       "doesn't exist") %
-                                     {'snap': snap_name,
-                                      'vol': vol_name})
-        return r.json()['data'][0]
-
-    def get_snap_info_detail(self, snap_id):
-        api = 'snapshots/detail'
-        filter = {'id': snap_id}
-        r = self.get_query(api, filter)
-        if not r.json()['data']:
-            raise NimbleAPIException(_("Snapshot: %s doesn't exist") % snap_id)
-        return r.json()['data'][0]
-
-    @utils.retry(NimbleAPIException, 2, 3)
-    def online_vol(self, volume_name, online_flag):
-        volume_id = self.get_volume_id_by_name(volume_name)
-        LOG.debug("volume_id %s", six.text_type(volume_id))
-        eventlet.sleep(DEFAULT_SLEEP)
-        api = "volumes/" + six.text_type(volume_id)
-        data = {'data': {"online": online_flag, 'force': True}}
-        try:
-            LOG.debug("data :%s", data)
-            self.put(api, data)
-            LOG.debug("Volume %(vol)s is in requested online state :%(flag)s",
-                      {'vol': volume_name,
-                       'flag': online_flag})
-        except Exception as ex:
-            msg = (_("Error  %s") % ex)
-            LOG.debug("online_vol_exception: %s", msg)
-            if msg.__contains__("Object is %s" % SM_STATE_MSG):
-                LOG.warning('Volume %(vol)s : %(state)s',
-                            {'vol': volume_name,
-                             'state': SM_STATE_MSG})
-            # TODO(rkumar): Check if we need to ignore the connected
-            # initiator
-            elif msg.__contains__("Initiators are connected to"):
-                raise NimbleAPIException(msg)
-            else:
-                raise exception.InvalidVolume(reason=msg)
-
-    def online_snap(self, volume_name, online_flag, snap_name):
-        snap_info = self.get_snap_info(snap_name, volume_name)
-        api = "snapshots/" + six.text_type(snap_info['id'])
-        data = {'data': {"online": online_flag}}
-        try:
-            self.put(api, data)
-            LOG.debug("Snapshot %(snap)s is in requested online state "
-                      ":%(flag)s",
-                      {'snap': snap_name, 'flag': online_flag})
-        except Exception as ex:
-            LOG.debug("online_snap_exception: %s", ex)
-            if six.text_type(ex).__contains__("Object %s" % SM_STATE_MSG):
-                LOG.warning('Snapshot %(snap)s :%(state)s',
-                            {'snap': snap_name,
-                             'state': SM_STATE_MSG})
-            else:
-                raise
-
-    @utils.retry(NimbleAPIException, 2, 3)
-    def get_vol_info(self, volume_name):
-        volume_id = self.get_volume_id_by_name(volume_name)
-        api = 'volumes/' + six.text_type(volume_id)
-        r = self.get(api)
-        if not r.json()['data']:
-            raise exception.VolumeNotFound(_("Volume: %s not found") %
-                                           volume_name)
-        return r.json()['data']
-
-    def delete_vol(self, volume_name):
-        volume_id = self.get_volume_id_by_name(volume_name)
-        api = "volumes/" + six.text_type(volume_id)
-        self.delete(api)
-
-    def snap_vol(self, snapshot):
-        api = "snapshots"
-        volume_name = snapshot['volume_name']
-        vol_id = self.get_volume_id_by_name(volume_name)
-        snap_name = snapshot['name']
-        # Set snapshot description
-        display_list = [
-            getattr(snapshot, 'display_name', snapshot['display_name']),
-            getattr(snapshot, 'display_description', '')]
-        snap_description = ':'.join(filter(None, display_list))
-        # Limit to 254 characters
-        snap_description = snap_description[:254]
-        data = {"data": {"name": snap_name,
-                         "description": snap_description,
-                         "vol_id": vol_id
-                         }
-                }
-        r = self.post(api, data)
-        return r['data']
-
-    def clone_vol(self, volume, snapshot, reserve, is_gst_enabled,
-                  protocol, pool_name):
-        api = "volumes"
-        volume_name = snapshot['volume_name']
-        snap_name = snapshot['name']
-        snap_info = self.get_snap_info(snap_name, volume_name)
-        clone_name = volume['name']
-        snap_size = snapshot['volume_size']
-        reserve_size = 100 if reserve else 0
-
-        specs = self._get_volumetype_extraspecs(volume)
-        extra_specs_map = self._get_extra_spec_values(specs)
-        perf_policy_name = extra_specs_map.get(EXTRA_SPEC_PERF_POLICY)
-        perf_policy_id = self.get_performance_policy_id(perf_policy_name)
-        encrypt = extra_specs_map.get(EXTRA_SPEC_ENCRYPTION)
-        multi_initiator = extra_specs_map.get(EXTRA_SPEC_MULTI_INITIATOR)
-        iops_limit = extra_specs_map[EXTRA_SPEC_IOPS_LIMIT]
-        folder_name = extra_specs_map[EXTRA_SPEC_FOLDER]
-        pool_id = self.get_pool_id(pool_name)
-        # default value of cipher for encryption
-        cipher = DEFAULT_CIPHER
-        if encrypt.lower() == 'yes':
-            cipher = AES_256_XTS_CIPHER
-        if is_gst_enabled is True:
-            agent_type = AGENT_TYPE_OPENSTACK_GST
-        else:
-            agent_type = AGENT_TYPE_OPENSTACK
-
-        LOG.info('Cloning volume from snapshot volume=%(vol)s '
-                 'snapshot=%(snap)s clone=%(clone)s snap_size=%(size)s '
-                 'reserve=%(reserve)s' 'agent-type=%(agent-type)s '
-                 'perfpol-name=%(perfpol-name)s '
-                 'encryption=%(encryption)s cipher=%(cipher)s '
-                 'multi-initiator=%(multi-initiator)s',
-                 {'vol': volume_name,
-                  'snap': snap_name,
-                  'clone': clone_name,
-                  'size': snap_size,
-                  'reserve': reserve_size,
-                  'agent-type': agent_type,
-                  'perfpol-name': perf_policy_name,
-                  'encryption': encrypt,
-                  'cipher': cipher,
-                  'multi-initiator': multi_initiator})
-
-        data = {"data": {"name": clone_name,
-                         "clone": 'true',
-                         "base_snap_id": snap_info['id'],
-                         'snap_limit': DEFAULT_SNAP_QUOTA,
-                         'warn_level': int(WARN_LEVEL),
-                         'limit': 100,
-                         "online": 'true',
-                         "reserve": reserve_size,
-                         "agent_type": agent_type,
-                         "perfpolicy_id": perf_policy_id,
-                         "encryption_cipher": cipher
-                         }
-                }
-        if protocol == "iSCSI":
-            data['data']['multi_initiator'] = multi_initiator
-
-        folder_id = None
-        if folder_name is not None:
-            # validate if folder exists in pool_name
-            pool_info = self.get_pool_info(pool_id)
-            if 'folder_list' in pool_info and (pool_info['folder_list'] is
-                                               not None):
-                for folder_list in pool_info['folder_list']:
-                    LOG.debug("folder_list : %s", folder_list)
-                    if folder_list['fqn'] == "/" + folder_name:
-                        LOG.debug("Folder %(folder)s present in pool "
-                                  "%(pool)s",
-                                  {'folder': folder_name,
-                                   'pool': pool_name})
-                        folder_id = self.get_folder_id(folder_name)
-                        if folder_id is not None:
-                            data['data']["folder_id"] = folder_id
-                if folder_id is None:
-                    raise NimbleAPIException(_("Folder '%(folder)s' not "
-                                               "present in pool '%(pool)s'") %
-                                             {'folder': folder_name,
-                                              'pool': pool_name})
-            else:
-                raise NimbleAPIException(_("Folder '%(folder)s' not present in"
-                                           " pool '%(pool)s'") %
-                                         {'folder': folder_name,
-                                          'pool': pool_name})
-
-        if iops_limit is not None:
-            if not iops_limit.isdigit() or (
-               int(iops_limit) < MIN_IOPS) or (int(iops_limit) > MAX_IOPS):
-                raise NimbleAPIException(_("%(err)s [%(min)s, %(max)s]") %
-                                         {'err': IOPS_ERR_MSG,
-                                          'min': MIN_IOPS,
-                                          'max': MAX_IOPS})
-
-            data['data']['limit_iops'] = iops_limit
-        if iops_limit is not None:
-            if not iops_limit.isdigit() or (
-               int(iops_limit) < MIN_IOPS) or (int(iops_limit) > MAX_IOPS):
-                raise NimbleAPIException(_("Please set valid IOPS limit"
-                                         " in the range [%(min)s, %(max)s]") %
-                                         {'min': MIN_IOPS,
-                                          'max': MAX_IOPS})
-            data['data']['limit_iops'] = iops_limit
-
-        LOG.debug("Volume metadata :%s", volume.metadata)
-        for key, value in volume.metadata.items():
-            LOG.debug("Key %(key)s Value %(value)s",
-                      {'key': key, 'value': value})
-            if key == EXTRA_SPEC_IOPS_LIMIT and value.isdigit():
-                if type(value) == int or int(value) < MIN_IOPS or (
-                   int(value) > MAX_IOPS):
-                    raise NimbleAPIException(_("Please enter valid IOPS "
-                                               "limit in the range ["
-                                               "%(min)s, %(max)s]") %
-                                             {'min': MIN_IOPS,
-                                              'max': MAX_IOPS})
-                LOG.debug("IOPS Limit %s", value)
-                data['data']['limit_iops'] = value
-
-        r = self.post(api, data)
-        return r['data']
-
-    def edit_vol(self, volume_name, data):
-        vol_id = self.get_volume_id_by_name(volume_name)
-        api = "volumes/" + six.text_type(vol_id)
-        self.put(api, data)
-
-    def delete_snap(self, volume_name, snap_name):
-        snap_info = self.get_snap_info(snap_name, volume_name)
-        api = "snapshots/" + six.text_type(snap_info['id'])
-        try:
-            self.delete(api)
-        except NimbleAPIException as ex:
-            LOG.debug("delete snapshot exception: %s", ex)
-            if SM_OBJ_HAS_CLONE in six.text_type(ex):
-                # if snap has a clone log the error and continue ahead
-                LOG.warning('Snapshot %(snap)s : %(state)s',
-                            {'snap': snap_name,
-                             'state': SM_OBJ_HAS_CLONE})
-            else:
-                raise
-
-    @_connection_checker
-    def get(self, api):
-        return self.get_query(api, None)
-
-    @_connection_checker
-    def get_query(self, api, query):
-        url = self.uri + api
-        return requests.get(url, headers=self.headers,
-                            params=query, verify=self.verify)
-
-    @_connection_checker
-    def put(self, api, payload):
-        url = self.uri + api
-        r = requests.put(url, data=json.dumps(payload),
-                         headers=self.headers, verify=self.verify)
-        if r.status_code != 201 and r.status_code != 200:
-            base = "Failed to execute api %(api)s : Error Code :%(code)s" % {
-                'api': api,
-                'code': r.status_code}
-            LOG.debug("Base error : %(base)s", {'base': base})
-            try:
-                msg = _("%(base)s Message: %(msg)s") % {
-                    'base': base,
-                    'msg': r.json()['messages'][1]['text']}
-            except IndexError:
-                msg = _("%(base)s Message: %(msg)s") % {
-                    'base': base,
-                    'msg': six.text_type(r.json())}
-            raise NimbleAPIException(msg)
-        return r.json()
-
-    @_connection_checker
-    def post(self, api, payload):
-        url = self.uri + api
-        r = requests.post(url, data=json.dumps(payload),
-                          headers=self.headers, verify=self.verify)
-        if r.status_code != 201 and r.status_code != 200:
-            msg = _("Failed to execute api %(api)s : %(msg)s : %(code)s") % {
-                'api': api,
-                'msg': r.json()['messages'][1]['text'],
-                'code': r.status_code}
-            raise NimbleAPIException(msg)
-        return r.json()
-
-    @_connection_checker
-    def delete(self, api):
-        url = self.uri + api
-        r = requests.delete(url, headers=self.headers, verify=self.verify)
-        if r.status_code != 201 and r.status_code != 200:
-            base = "Failed to execute api %(api)s: Error Code: %(code)s" % {
-                'api': api,
-                'code': r.status_code}
-            LOG.debug("Base error : %(base)s", {'base': base})
-            try:
-                msg = _("%(base)s Message: %(msg)s") % {
-                    'base': base,
-                    'msg': r.json()['messages'][1]['text']}
-            except IndexError:
-                msg = _("%(base)s Message: %(msg)s") % {
-                    'base': base,
-                    'msg': six.text_type(r.json())}
-            raise NimbleAPIException(msg)
-        return r.json()
-
-    def _format_to_wwpn(self, string_wwpn):
-        return ':'.join(a + b for a, b in zip(* [iter(string_wwpn)] * 2))
-
-    def get_fc_interface_list(self, array_name):
-        """getFibreChannelInterfaceList API to get FC interfaces on array."""
-        api = 'fibre_channel_interfaces/detail'
-        filter = {'array_name_or_serial': array_name}
-        r = self.get_query(api, filter)
-        if not r.json()['data']:
-            raise NimbleAPIException(_("No fc interfaces for array %s") %
-                                     array_name)
-        return r.json()['data']
-
-    def enable_group_scoped_target(self):
-        group_id = self.get_group_id()
-        api = "groups/" + six.text_type(group_id)
-        data = {'data': {'group_target_enabled': True}}
-        self.put(api, data)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/prophetstor/dplcommon.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/prophetstor/dplcommon.py
--- 2:15.0.1-1/cinder/volume/drivers/prophetstor/dplcommon.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/prophetstor/dplcommon.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,1522 +0,0 @@
-# Copyright (c) 2014 ProphetStor, Inc.
-# All Rights Reserved.
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-"""
-Implementation of the class of ProphetStor DPL storage adapter of Federator.
-    # v2.0.1 Consistency group support
-    # v2.0.2 Pool aware scheduler
-    # v2.0.3 Consistency group modification support
-    # v2.0.4 Port ProphetStor driver to use new driver model
-    # v2.0.5 Move from httplib to requests
-"""
-
-import base64
-import errno
-import json
-import random
-import requests
-import time
-
-from oslo_log import log as logging
-from oslo_service import loopingcall
-from oslo_utils import units
-import six
-from six.moves import http_client
-
-from cinder import exception
-from cinder.i18n import _
-from cinder import objects
-from cinder.objects import fields
-from cinder.volume import driver
-from cinder.volume.drivers.prophetstor import options
-from cinder.volume.drivers.san import san
-from cinder.volume import volume_utils
-
-LOG = logging.getLogger(__name__)
-
-CONNECTION_RETRY = 10
-MAXSNAPSHOTS = 1024
-DISCOVER_SERVER_TYPE = 'dpl'
-DPL_BLOCKSTOR = '/dpl_blockstor'
-DPL_SYSTEM = '/dpl_system'
-
-DPL_VER_V1 = 'v1'
-DPL_OBJ_POOL = 'dpl_pool'
-DPL_OBJ_DISK = 'dpl_disk'
-DPL_OBJ_VOLUME = 'dpl_volume'
-DPL_OBJ_VOLUMEGROUP = 'dpl_volgroup'
-DPL_OBJ_SNAPSHOT = 'cdmi_snapshots'
-DPL_OBJ_EXPORT = 'dpl_export'
-
-DPL_OBJ_REPLICATION = 'cdmi_replication'
-DPL_OBJ_TARGET = 'dpl_target'
-DPL_OBJ_SYSTEM = 'dpl_system'
-DPL_OBJ_SNS = 'sns_table'
-
-
-class DPLCommand(object):
-    """DPL command interface."""
-
-    def __init__(self, ip, port, username, password, cert_verify=False,
-                 cert_path=None):
-        self.ip = ip
-        self.port = port
-        self.username = username
-        self.password = password
-        self.cert_verify = cert_verify
-        self.cert_path = cert_path
-
-    def send_cmd(self, method, url, params, expected_status):
-        """Send command to DPL."""
-        retcode = 0
-        data = {}
-        header = {'Content-Type': 'application/cdmi-container',
-                  'Accept': 'application/cdmi-container',
-                  'x-cdmi-specification-version': '1.0.2'}
-        # base64 encode the username and password
-        auth = base64.encodestring('%s:%s'
-                                   % (self.username,
-                                      self.password)).replace('\n', '')
-        header['Authorization'] = 'Basic %s' % auth
-
-        if not params:
-            payload = None
-        else:
-            try:
-                payload = json.dumps(params, ensure_ascii=False)
-                payload.encode('utf-8')
-            except Exception as e:
-                LOG.error('JSON encode params %(param)s error:'
-                          ' %(status)s.', {'param': params, 'status': e})
-                retcode = errno.EINVAL
-
-        retry = CONNECTION_RETRY
-        func = getattr(requests, method.lower())
-
-        cert_path = False
-        if self.cert_verify:
-            cert_path = self.cert_path
-        else:
-            cert_path = False
-
-        while (retry):
-            try:
-                r = func(
-                    url="https://%s:%s%s" % (self.ip, self.port, url),
-                    data=payload, headers=header, verify=cert_path)
-
-                if r.status_code == http_client.SERVICE_UNAVAILABLE:
-                    LOG.error("The flexvisor service is unavailable.")
-                    continue
-                else:
-                    break
-            except Exception as e:
-                msg = (_("failed to %(method)s due to %(error)s")
-                       % {"method": method, "error": six.text_type(e)})
-                LOG.error(msg)
-                raise exception.VolumeBackendAPIException(data=msg)
-
-        if (r.status_code in expected_status and
-                r.status_code == http_client.NOT_FOUND):
-            retcode = errno.ENODATA
-        elif r.status_code not in expected_status:
-            LOG.error('%(method)s %(url)s unexpected response status: '
-                      '%(response)s (expects: %(expects)s).',
-                      {'method': method,
-                       'url': url,
-                       'response': http_client.responses[r.status_code],
-                       'expects': expected_status})
-            if r.status_code == http_client.UNAUTHORIZED:
-                raise exception.NotAuthorized
-            else:
-                retcode = errno.EIO
-        elif r.status_code is http_client.NOT_FOUND:
-            retcode = errno.ENODATA
-        elif r.status_code is http_client.ACCEPTED:
-            retcode = errno.EAGAIN
-            try:
-                data = r.json()
-            except (TypeError, ValueError) as e:
-                LOG.error('Call to json.loads() raised an exception: %s.',
-                          e)
-                retcode = errno.ENOEXEC
-            except Exception as e:
-                LOG.error('Read response raised an exception: %s.',
-                          e)
-                retcode = errno.ENOEXEC
-        elif (r.status_code in [http_client.OK, http_client.CREATED] and
-                http_client.NO_CONTENT not in expected_status):
-            try:
-                data = r.json()
-            except (TypeError, ValueError) as e:
-                LOG.error('Call to json.loads() raised an exception: %s.',
-                          e)
-                retcode = errno.ENOEXEC
-            except Exception as e:
-                LOG.error('Read response raised an exception: %s.',
-                          e)
-                retcode = errno.ENOEXEC
-
-        return retcode, data
-
-
-class DPLVolume(object):
-
-    def __init__(self, dplServer, dplPort, dplUser, dplPassword,
-                 cert_verify=False, cert_path=None):
-        self.objCmd = DPLCommand(
-            dplServer, dplPort, dplUser, dplPassword, cert_verify=cert_verify,
-            cert_path=cert_path)
-
-    def _execute(self, method, url, params, expected_status):
-        if self.objCmd:
-            return self.objCmd.send_cmd(method, url, params, expected_status)
-        else:
-            return -1, None
-
-    def _gen_snapshot_url(self, vdevid, snapshotid):
-        snapshot_url = '/%s/%s/%s' % (vdevid, DPL_OBJ_SNAPSHOT, snapshotid)
-        return snapshot_url
-
-    def get_server_info(self):
-        method = 'GET'
-        url = ('/%s/%s/' % (DPL_VER_V1, DPL_OBJ_SYSTEM))
-        return self._execute(method, url, None,
-                             [http_client.OK, http_client.ACCEPTED])
-
-    def create_vdev(self, volumeID, volumeName, volumeDesc, poolID, volumeSize,
-                    fthinprovision=True, maximum_snapshot=MAXSNAPSHOTS,
-                    snapshot_quota=None):
-        method = 'PUT'
-        metadata = {}
-        params = {}
-        url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUME, volumeID)
-
-        if volumeName is None or volumeName == '':
-            metadata['display_name'] = volumeID
-        else:
-            metadata['display_name'] = volumeName
-        metadata['display_description'] = volumeDesc
-        metadata['pool_uuid'] = poolID
-        metadata['total_capacity'] = volumeSize
-        metadata['maximum_snapshot'] = maximum_snapshot
-        if snapshot_quota is not None:
-            metadata['snapshot_quota'] = int(snapshot_quota)
-        metadata['properties'] = dict(thin_provision=fthinprovision)
-        params['metadata'] = metadata
-        return self._execute(method,
-                             url, params,
-                             [http_client.OK, http_client.ACCEPTED,
-                              http_client.CREATED])
-
-    def extend_vdev(self, volumeID, volumeName, volumeDesc, volumeSize,
-                    maximum_snapshot=MAXSNAPSHOTS, snapshot_quota=None):
-        method = 'PUT'
-        metadata = {}
-        params = {}
-        url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUME, volumeID)
-
-        if volumeName is None or volumeName == '':
-            metadata['display_name'] = volumeID
-        else:
-            metadata['display_name'] = volumeName
-        metadata['display_description'] = volumeDesc
-        metadata['total_capacity'] = int(volumeSize)
-        metadata['maximum_snapshot'] = maximum_snapshot
-        if snapshot_quota is not None:
-            metadata['snapshot_quota'] = snapshot_quota
-        params['metadata'] = metadata
-        return self._execute(method,
-                             url, params,
-                             [http_client.OK, http_client.ACCEPTED,
-                              http_client.CREATED])
-
-    def delete_vdev(self, volumeID, force=True):
-        method = 'DELETE'
-        metadata = {}
-        params = {}
-        url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUME, volumeID)
-
-        metadata['force'] = force
-        params['metadata'] = metadata
-        return self._execute(method,
-                             url, params,
-                             [http_client.OK, http_client.ACCEPTED,
-                              http_client.NOT_FOUND, http_client.NO_CONTENT])
-
-    def create_vdev_from_snapshot(self, vdevID, vdevDisplayName, vdevDesc,
-                                  snapshotID, poolID, fthinprovision=True,
-                                  maximum_snapshot=MAXSNAPSHOTS,
-                                  snapshot_quota=None):
-        method = 'PUT'
-        metadata = {}
-        params = {}
-        url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUME, vdevID)
-        metadata['snapshot_operation'] = 'copy'
-        if vdevDisplayName is None or vdevDisplayName == "":
-            metadata['display_name'] = vdevID
-        else:
-            metadata['display_name'] = vdevDisplayName
-        metadata['display_description'] = vdevDesc
-        metadata['pool_uuid'] = poolID
-        metadata['properties'] = {}
-        metadata['maximum_snapshot'] = maximum_snapshot
-        if snapshot_quota:
-            metadata['snapshot_quota'] = snapshot_quota
-        metadata['properties'] = dict(thin_provision=fthinprovision)
-
-        params['metadata'] = metadata
-        params['copy'] = self._gen_snapshot_url(vdevID, snapshotID)
-        return self._execute(method,
-                             url, params,
-                             [http_client.OK, http_client.ACCEPTED,
-                              http_client.CREATED])
-
-    def spawn_vdev_from_snapshot(self, new_vol_id, src_vol_id,
-                                 vol_display_name, description, snap_id):
-        method = 'PUT'
-        params = {}
-        metadata = {}
-        url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUME, new_vol_id)
-
-        metadata['snapshot_operation'] = 'spawn'
-        if vol_display_name is None or vol_display_name == '':
-            metadata['display_name'] = new_vol_id
-        else:
-            metadata['display_name'] = vol_display_name
-        metadata['display_description'] = description
-        params['metadata'] = metadata
-        params['copy'] = self._gen_snapshot_url(src_vol_id, snap_id)
-
-        return self._execute(method, url, params,
-                             [http_client.OK, http_client.ACCEPTED,
-                              http_client.CREATED])
-
-    def get_pools(self):
-        method = 'GET'
-        url = '/%s/%s/' % (DPL_VER_V1, DPL_OBJ_POOL)
-        return self._execute(method, url, None, [http_client.OK])
-
-    def get_pool(self, poolid):
-        method = 'GET'
-        url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_POOL, poolid)
-        return self._execute(method, url, None,
-                             [http_client.OK, http_client.ACCEPTED])
-
-    def clone_vdev(self, SourceVolumeID, NewVolumeID, poolID, volumeName,
-                   volumeDesc, volumeSize, fthinprovision=True,
-                   maximum_snapshot=MAXSNAPSHOTS, snapshot_quota=None):
-        method = 'PUT'
-        params = {}
-        metadata = {}
-        url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUME, NewVolumeID)
-        metadata["snapshot_operation"] = "clone"
-        if volumeName is None or volumeName == '':
-            metadata["display_name"] = NewVolumeID
-        else:
-            metadata["display_name"] = volumeName
-        metadata["display_description"] = volumeDesc
-        metadata["pool_uuid"] = poolID
-        metadata["total_capacity"] = volumeSize
-        metadata["maximum_snapshot"] = maximum_snapshot
-        if snapshot_quota:
-            metadata["snapshot_quota"] = snapshot_quota
-        metadata["properties"] = dict(thin_provision=fthinprovision)
-        params["metadata"] = metadata
-        params["copy"] = SourceVolumeID
-
-        return self._execute(method,
-                             url, params,
-                             [http_client.OK, http_client.CREATED,
-                              http_client.ACCEPTED])
-
-    def create_vdev_snapshot(self, vdevid, snapshotid, snapshotname='',
-                             snapshotdes='', isgroup=False):
-        method = 'PUT'
-        metadata = {}
-        params = {}
-        if isgroup:
-            url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUMEGROUP, vdevid)
-        else:
-            url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUME, vdevid)
-
-        if not snapshotname:
-            metadata['display_name'] = snapshotid
-        else:
-            metadata['display_name'] = snapshotname
-        metadata['display_description'] = snapshotdes
-
-        params['metadata'] = metadata
-        params['snapshot'] = snapshotid
-
-        return self._execute(method,
-                             url, params,
-                             [http_client.OK, http_client.CREATED,
-                              http_client.ACCEPTED])
-
-    def get_vdev(self, vdevid):
-        method = 'GET'
-        url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUME, vdevid)
-
-        return self._execute(method,
-                             url, None,
-                             [http_client.OK, http_client.ACCEPTED,
-                              http_client.NOT_FOUND])
-
-    def get_vdev_status(self, vdevid, eventid):
-        method = 'GET'
-        url = ('/%s/%s/%s/?event_uuid=%s' % (DPL_VER_V1, DPL_OBJ_VOLUME,
-                                             vdevid, eventid))
-
-        return self._execute(method,
-                             url, None,
-                             [http_client.OK, http_client.NOT_FOUND])
-
-    def get_pool_status(self, poolid, eventid):
-        method = 'GET'
-        url = ('/%s/%s/%s/?event_uuid=%s' % (DPL_VER_V1, DPL_OBJ_POOL,
-                                             poolid, eventid))
-
-        return self._execute(method,
-                             url, None,
-                             [http_client.OK, http_client.NOT_FOUND])
-
-    def assign_vdev(self, vdevid, iqn, lunname, portal, lunid=0):
-        method = 'PUT'
-        metadata = {}
-        exports = {}
-        params = {}
-        url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUME, vdevid)
-
-        metadata['export_operation'] = 'assign'
-        exports['Network/iSCSI'] = {}
-        target_info = {}
-        target_info['logical_unit_number'] = 0
-        target_info['logical_unit_name'] = lunname
-        permissions = []
-        portals = []
-        portals.append(portal)
-        permissions.append(iqn)
-        target_info['permissions'] = permissions
-        target_info['portals'] = portals
-        exports['Network/iSCSI'] = target_info
-
-        params['metadata'] = metadata
-        params['exports'] = exports
-
-        return self._execute(method,
-                             url, params,
-                             [http_client.OK, http_client.ACCEPTED,
-                              http_client.CREATED])
-
-    def assign_vdev_fc(self, vdevid, targetwwpn, initiatorwwpn, lunname,
-                       lunid=-1):
-        method = 'PUT'
-        metadata = {}
-        exports = {}
-        params = {}
-        url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUME, vdevid)
-        metadata['export_operation'] = 'assign'
-        exports['Network/FC'] = {}
-        target_info = {}
-        target_info['target_identifier'] = targetwwpn
-        target_info['logical_unit_number'] = lunid
-        target_info['logical_unit_name'] = lunname
-        target_info['permissions'] = initiatorwwpn
-        exports['Network/FC'] = target_info
-
-        params['metadata'] = metadata
-        params['exports'] = exports
-
-        return self._execute(method,
-                             url, params,
-                             [http_client.OK, http_client.ACCEPTED,
-                              http_client.CREATED])
-
-    def unassign_vdev(self, vdevid, initiatorIqn, targetIqn=''):
-        method = 'PUT'
-        metadata = {}
-        exports = {}
-        params = {}
-        url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUME, vdevid)
-
-        metadata['export_operation'] = 'unassign'
-        params['metadata'] = metadata
-
-        exports['Network/iSCSI'] = {}
-        exports['Network/iSCSI']['target_identifier'] = targetIqn
-        permissions = []
-        permissions.append(initiatorIqn)
-        exports['Network/iSCSI']['permissions'] = permissions
-
-        params['exports'] = exports
-
-        return self._execute(method,
-                             url, params,
-                             [http_client.OK, http_client.ACCEPTED,
-                              http_client.NO_CONTENT, http_client.NOT_FOUND])
-
-    def unassign_vdev_fc(self, vdevid, targetwwpn, initiatorwwpns):
-        method = 'PUT'
-        metadata = {}
-        exports = {}
-        params = {}
-        url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUME, vdevid)
-
-        metadata['export_operation'] = 'unassign'
-        params['metadata'] = metadata
-
-        exports['Network/FC'] = {}
-        exports['Network/FC']['target_identifier'] = targetwwpn
-        permissions = initiatorwwpns
-        exports['Network/FC']['permissions'] = permissions
-
-        params['exports'] = exports
-
-        return self._execute(method,
-                             url, params,
-                             [http_client.OK, http_client.ACCEPTED,
-                              http_client.NO_CONTENT, http_client.NOT_FOUND])
-
-    def delete_vdev_snapshot(self, objID, snapshotID, isGroup=False):
-        method = 'DELETE'
-        if isGroup:
-            url = ('/%s/%s/%s/%s/%s/' % (DPL_VER_V1,
-                                         DPL_OBJ_VOLUMEGROUP,
-                                         objID,
-                                         DPL_OBJ_SNAPSHOT, snapshotID))
-        else:
-            url = ('/%s/%s/%s/%s/%s/' % (DPL_VER_V1,
-                                         DPL_OBJ_VOLUME, objID,
-                                         DPL_OBJ_SNAPSHOT, snapshotID))
-
-        return self._execute(method,
-                             url, None,
-                             [http_client.OK, http_client.ACCEPTED,
-                              http_client.NO_CONTENT, http_client.NOT_FOUND])
-
-    def rollback_vdev(self, vdevid, snapshotid):
-        method = 'PUT'
-        params = {}
-        url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUME, vdevid)
-
-        params['copy'] = self._gen_snapshot_url(vdevid, snapshotid)
-
-        return self._execute(method,
-                             url, params,
-                             [http_client.OK, http_client.ACCEPTED])
-
-    def list_vdev_snapshots(self, vdevid, isGroup=False):
-        method = 'GET'
-        if isGroup:
-            url = ('/%s/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUMEGROUP, vdevid,
-                                      DPL_OBJ_SNAPSHOT))
-        else:
-            url = ('/%s/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUME,
-                                      vdevid, DPL_OBJ_SNAPSHOT))
-
-        return self._execute(method,
-                             url, None,
-                             [http_client.OK])
-
-    def query_vdev_snapshot(self, vdevid, snapshotID, isGroup=False):
-        method = 'GET'
-        if isGroup:
-            url = ('/%s/%s/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUMEGROUP,
-                                         vdevid, DPL_OBJ_SNAPSHOT, snapshotID))
-        else:
-            url = ('/%s/%s/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_VOLUME, vdevid,
-                                         DPL_OBJ_SNAPSHOT, snapshotID))
-
-        return self._execute(method,
-                             url, None,
-                             [http_client.OK])
-
-    def create_target(self, targetID, protocol, displayName, targetAddress,
-                      description=''):
-        method = 'PUT'
-        params = {}
-        url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_EXPORT, targetID)
-        params['metadata'] = {}
-        metadata = params['metadata']
-        metadata['type'] = 'target'
-        metadata['protocol'] = protocol
-        if displayName is None or displayName == '':
-            metadata['display_name'] = targetID
-        else:
-            metadata['display_name'] = displayName
-        metadata['display_description'] = description
-        metadata['address'] = targetAddress
-        return self._execute(method, url, params, [http_client.OK])
-
-    def get_target(self, targetID):
-        method = 'GET'
-        url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_EXPORT, targetID)
-        return self._execute(method, url, None, [http_client.OK])
-
-    def delete_target(self, targetID):
-        method = 'DELETE'
-        url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_EXPORT, targetID)
-        return self._execute(method,
-                             url, None,
-                             [http_client.OK, http_client.ACCEPTED,
-                              http_client.NOT_FOUND])
-
-    def get_target_list(self, type='target'):
-        # type = target/initiator
-        method = 'GET'
-        if type is None:
-            url = '/%s/%s/' % (DPL_VER_V1, DPL_OBJ_EXPORT)
-        else:
-            url = '/%s/%s/?type=%s' % (DPL_VER_V1, DPL_OBJ_EXPORT, type)
-        return self._execute(method, url, None, [http_client.OK])
-
-    def get_sns_table(self, wwpn):
-        method = 'PUT'
-        params = {}
-        url = '/%s/%s/%s/' % (DPL_VER_V1, DPL_OBJ_EXPORT, DPL_OBJ_SNS)
-        params['metadata'] = {}
-        params['metadata']['protocol'] = 'fc'
-        params['metadata']['address'] = str(wwpn)
-        return self._execute(method, url, params, [http_client.OK])
-
-    def create_vg(self, groupID, groupName, groupDesc='', listVolume=None,
-                  maxSnapshots=MAXSNAPSHOTS, rotationSnapshot=True):
-        method = 'PUT'
-        metadata = {}
-        params = {}
-        properties = {}
-        url = '/%s/%s/' % (DPL_OBJ_VOLUMEGROUP, groupID)
-        if listVolume:
-            metadata['volume'] = listVolume
-        else:
-            metadata['volume'] = []
-        metadata['display_name'] = groupName
-        metadata['display_description'] = groupDesc
-        metadata['maximum_snapshot'] = maxSnapshots
-        properties['snapshot_rotation'] = rotationSnapshot
-        metadata['properties'] = properties
-        params['metadata'] = metadata
-        return self._execute(method, url, params,
-                             [http_client.OK, http_client.ACCEPTED,
-                              http_client.CREATED])
-
-    def get_vg_list(self, vgtype=None):
-        method = 'GET'
-        if vgtype:
-            url = '/%s/?volume_group_type=%s' % (DPL_OBJ_VOLUMEGROUP, vgtype)
-        else:
-            url = '/%s/' % (DPL_OBJ_VOLUMEGROUP)
-        return self._execute(method, url, None, [http_client.OK])
-
-    def get_vg(self, groupID):
-        method = 'GET'
-        url = '/%s/%s/' % (DPL_OBJ_VOLUMEGROUP, groupID)
-        return self._execute(method, url, None, [http_client.OK])
-
-    def delete_vg(self, groupID, force=True):
-        method = 'DELETE'
-        metadata = {}
-        params = {}
-        url = '/%s/%s/' % (DPL_OBJ_VOLUMEGROUP, groupID)
-        metadata['force'] = force
-        params['metadata'] = metadata
-        return self._execute(method, url, params,
-                             [http_client.NO_CONTENT, http_client.NOT_FOUND])
-
-    def join_vg(self, volumeID, groupID):
-        method = 'PUT'
-        metadata = {}
-        params = {}
-        url = '/%s/%s/' % (DPL_OBJ_VOLUMEGROUP, groupID)
-        metadata['volume_group_operation'] = 'join'
-        metadata['volume'] = []
-        metadata['volume'].append(volumeID)
-        params['metadata'] = metadata
-        return self._execute(method, url, params,
-                             [http_client.OK, http_client.ACCEPTED])
-
-    def leave_vg(self, volumeID, groupID):
-        method = 'PUT'
-        metadata = {}
-        params = {}
-        url = '/%s/%s/' % (DPL_OBJ_VOLUMEGROUP, groupID)
-        metadata['volume_group_operation'] = 'leave'
-        metadata['volume'] = []
-        metadata['volume'].append(volumeID)
-        params['metadata'] = metadata
-        return self._execute(method, url, params,
-                             [http_client.OK, http_client.ACCEPTED])
-
-
-class DPLCOMMONDriver(driver.CloneableImageVD,
-                      driver.BaseVD):
-    """Class of dpl storage adapter."""
-    VERSION = '2.0.5'
-
-    # ThirdPartySystems wiki page
-    CI_WIKI_NAME = "ProphetStor_CI"
-
-    # TODO(jsbryant) Remove driver in the 'U' release if CI is not fixed.
-    SUPPORTED = False
-
-    def __init__(self, *args, **kwargs):
-        cert_path = None
-        cert_verify = False
-        super(DPLCOMMONDriver, self).__init__(*args, **kwargs)
-        if self.configuration:
-            self.configuration.append_config_values(options.DPL_OPTS)
-            self.configuration.append_config_values(san.san_opts)
-            cert_verify = self.configuration.driver_ssl_cert_verify
-            cert_path = self.configuration.driver_ssl_cert_path
-
-        if cert_verify:
-            if not cert_path:
-                LOG.warning(
-                    "Flexvisor: cert_verify is enabled but required cert_path"
-                    " option is missing.")
-                cert_path = None
-        else:
-            cert_path = None
-
-        self.dpl = DPLVolume(self.configuration.san_ip,
-                             self.configuration.dpl_port,
-                             self.configuration.san_login,
-                             self.configuration.san_password,
-                             cert_verify=cert_verify,
-                             cert_path=cert_path)
-        self._stats = {}
-
-    @staticmethod
-    def get_driver_options():
-        return options.DPL_OPTS
-
-    def _convert_size_GB(self, size):
-        s = round(float(size) / units.Gi, 2)
-        if s > 0:
-            return s
-        else:
-            return 0
-
-    def _conver_uuid2hex(self, strID):
-        if strID:
-            return strID.replace('-', '')
-        else:
-            return None
-
-    def _get_event_uuid(self, output):
-        ret = 0
-        event_uuid = ""
-
-        if (type(output) is dict and
-                output.get("metadata") and output["metadata"]):
-            if (output["metadata"].get("event_uuid") and
-                    output["metadata"]["event_uuid"]):
-                event_uuid = output["metadata"]["event_uuid"]
-            else:
-                ret = errno.EINVAL
-        else:
-            ret = errno.EINVAL
-        return ret, event_uuid
-
-    def _wait_event(self, callFun, objuuid, eventid=None):
-        nRetry = 30
-        fExit = False
-        status = {}
-        status['state'] = 'error'
-        status['output'] = {}
-        while nRetry:
-            try:
-                if eventid:
-                    ret, output = callFun(
-                        self._conver_uuid2hex(objuuid),
-                        self._conver_uuid2hex(eventid))
-                else:
-                    ret, output = callFun(self._conver_uuid2hex(objuuid))
-
-                if ret == 0:
-                    if output['completionStatus'] == 'Complete':
-                        fExit = True
-                        status['state'] = 'available'
-                        status['output'] = output
-                    elif output['completionStatus'] == 'Error':
-                        fExit = True
-                        status['state'] = 'error'
-                        raise loopingcall.LoopingCallDone(retvalue=False)
-                    else:
-                        nsleep = random.randint(0, 10)
-                        value = round(float(nsleep) / 10, 2)
-                        time.sleep(value)
-                elif ret == errno.ENODATA:
-                    status['state'] = 'deleted'
-                    fExit = True
-                else:
-                    nRetry -= 1
-                    time.sleep(3)
-                    continue
-
-            except Exception as e:
-                LOG.error('Flexvisor failed to get event %(volume)s '
-                          '(%(status)s).',
-                          {'volume': eventid, 'status': e})
-                raise loopingcall.LoopingCallDone(retvalue=False)
-
-            if fExit is True:
-                break
-        return status
-
-    def _join_volume_group(self, volume, cgId):
-        # Join volume group if consistency group id not empty
-        msg = ''
-        try:
-            ret, output = self.dpl.join_vg(
-                self._conver_uuid2hex(volume['id']),
-                self._conver_uuid2hex(cgId))
-        except Exception as e:
-            ret = errno.EFAULT
-            msg = _('Fexvisor failed to add volume %(id)s '
-                    'due to %(reason)s.') % {"id": volume['id'],
-                                             "reason": six.text_type(e)}
-        if ret:
-            if not msg:
-                msg = _('Flexvisor failed to add volume %(id)s '
-                        'to group %(cgid)s.') % {'id': volume['id'],
-                                                 'cgid': cgId}
-            raise exception.VolumeBackendAPIException(data=msg)
-        else:
-            LOG.info('Flexvisor succeeded to add volume %(id)s to '
-                     'group %(cgid)s.',
-                     {'id': volume['id'], 'cgid': cgId})
-
-    def _leave_volume_group(self, volume, cgId):
-        # Leave volume group if consistency group id not empty
-        msg = ''
-        try:
-            ret, output = self.dpl.leave_vg(
-                self._conver_uuid2hex(volume['id']),
-                self._conver_uuid2hex(cgId))
-        except Exception as e:
-            ret = errno.EFAULT
-            msg = _('Fexvisor failed to remove volume %(id)s '
-                    'due to %(reason)s.') % {"id": volume['id'],
-                                             "reason": six.text_type(e)}
-        if ret:
-            if not msg:
-                msg = _('Flexvisor failed to remove volume %(id)s '
-                        'from group %(cgid)s.') % {'id': volume['id'],
-                                                   'cgid': cgId}
-            raise exception.VolumeBackendAPIException(data=msg)
-        else:
-            LOG.info('Flexvisor succeeded to remove volume %(id)s from '
-                     'group %(cgid)s.',
-                     {'id': volume['id'], 'cgid': cgId})
-
-    def _get_snapshotid_of_vgsnapshot(self, vgID, vgsnapshotID, volumeID):
-        snapshotID = None
-        ret, out = self.dpl.query_vdev_snapshot(vgID, vgsnapshotID, True)
-        if ret == 0:
-            volumes = out.get('metadata', {}).get('member', {})
-            if volumes:
-                snapshotID = volumes.get(volumeID, None)
-        else:
-            msg = _('Flexvisor failed to get snapshot id of volume '
-                    '%(id)s from group %(vgid)s.') % {'id': volumeID,
-                                                      'vgid': vgID}
-            raise exception.VolumeBackendAPIException(data=msg)
-        if not snapshotID:
-            msg = _('Flexvisor could not find volume %(id)s snapshot in'
-                    ' the group %(vgid)s snapshot '
-                    '%(vgsid)s.') % {'id': volumeID, 'vgid': vgID,
-                                     'vgsid': vgsnapshotID}
-            raise exception.VolumeBackendAPIException(data=msg)
-        return snapshotID
-
-    def create_export(self, context, volume, connector):
-        pass
-
-    def ensure_export(self, context, volume):
-        pass
-
-    def remove_export(self, context, volume):
-        pass
-
-    def _create_consistencygroup(self, context, group):
-        """Creates a consistencygroup."""
-        LOG.info('Start to create consistency group: %(group_name)s '
-                 'id: %(id)s',
-                 {'group_name': group.name, 'id': group.id})
-        model_update = {'status': fields.GroupStatus.AVAILABLE}
-        try:
-            ret, output = self.dpl.create_vg(
-                self._conver_uuid2hex(group.id),
-                group.name,
-                group.description)
-            if ret:
-                msg = _('Failed to create consistency group '
-                        '%(id)s:%(ret)s.') % {'id': group.id,
-                                              'ret': ret}
-                raise exception.VolumeBackendAPIException(data=msg)
-            else:
-                return model_update
-        except Exception as e:
-            msg = _('Failed to create consistency group '
-                    '%(id)s due to %(reason)s.') % {'id': group.id,
-                                                    'reason': six.text_type(e)}
-            raise exception.VolumeBackendAPIException(data=msg)
-
-    def _delete_consistencygroup(self, context, group, volumes):
-        """Delete a consistency group."""
-        ret = 0
-        volumes = self.db.volume_get_all_by_group(
-            context, group.id)
-        model_update = {}
-        model_update['status'] = group.status
-        LOG.info('Start to delete consistency group: %(cg_name)s',
-                 {'cg_name': group.id})
-        try:
-            self.dpl.delete_vg(self._conver_uuid2hex(group.id))
-        except Exception as e:
-            msg = _('Failed to delete consistency group %(id)s '
-                    'due to %(reason)s.') % {'id': group.id,
-                                             'reason': six.text_type(e)}
-            raise exception.VolumeBackendAPIException(data=msg)
-
-        for volume_ref in volumes:
-            try:
-                self.dpl.delete_vdev(self._conver_uuid2hex(volume_ref['id']))
-                volume_ref['status'] = 'deleted'
-            except Exception:
-                ret = errno.EFAULT
-                volume_ref['status'] = 'error_deleting'
-                model_update['status'] = (
-                    fields.GroupStatus.ERROR_DELETING)
-        if ret == 0:
-            model_update['status'] = fields.GroupStatus.DELETED
-        return model_update, volumes
-
-    def _create_cgsnapshot(self, context, cgsnapshot, snapshots):
-        """Creates a cgsnapshot."""
-        snapshots = objects.SnapshotList().get_all_for_group_snapshot(
-            context, cgsnapshot.id)
-        model_update = {}
-        LOG.info('Start to create cgsnapshot for consistency group'
-                 ': %(group_name)s',
-                 {'group_name': cgsnapshot.group_id})
-        try:
-            self.dpl.create_vdev_snapshot(
-                self._conver_uuid2hex(cgsnapshot.group_id),
-                self._conver_uuid2hex(cgsnapshot.id),
-                cgsnapshot.name,
-                '',
-                True)
-            for snapshot in snapshots:
-                snapshot.status = fields.SnapshotStatus.AVAILABLE
-        except Exception as e:
-            msg = _('Failed to create cg snapshot %(id)s '
-                    'due to %(reason)s.') % {'id': cgsnapshot.id,
-                                             'reason': six.text_type(e)}
-            raise exception.VolumeBackendAPIException(data=msg)
-
-        model_update['status'] = 'available'
-
-        return model_update, snapshots
-
-    def _delete_cgsnapshot(self, context, cgsnapshot, snapshots):
-        """Deletes a cgsnapshot."""
-        snapshots = objects.SnapshotList().get_all_for_group_snapshot(
-            context, cgsnapshot.id)
-        model_update = {}
-        model_update['status'] = cgsnapshot.status
-        LOG.info('Delete cgsnapshot %(snap_name)s for consistency group: '
-                 '%(group_name)s',
-                 {'snap_name': cgsnapshot.id,
-                  'group_name': cgsnapshot.group_id})
-        try:
-            self.dpl.delete_vdev_snapshot(
-                self._conver_uuid2hex(cgsnapshot.group_id),
-                self._conver_uuid2hex(cgsnapshot.id), True)
-            for snapshot in snapshots:
-                snapshot.status = fields.SnapshotStatus.DELETED
-        except Exception as e:
-            msg = _('Failed to delete cgsnapshot %(id)s due to '
-                    '%(reason)s.') % {'id': cgsnapshot.id,
-                                      'reason': six.text_type(e)}
-            raise exception.VolumeBackendAPIException(data=msg)
-
-        model_update['status'] = 'deleted'
-        return model_update, snapshots
-
-    def update_group(self, context, group, add_volumes=None,
-                     remove_volumes=None):
-        addvollist = []
-        removevollist = []
-        cgid = group.id
-        vid = ''
-        model_update = {'status': fields.GroupStatus.AVAILABLE}
-        if not volume_utils.is_group_a_cg_snapshot_type(group):
-            raise NotImplementedError()
-        # Get current group info in backend storage.
-        ret, output = self.dpl.get_vg(self._conver_uuid2hex(cgid))
-        if ret == 0:
-            group_members = output.get('children', [])
-
-        if add_volumes:
-            addvollist = add_volumes
-        if remove_volumes:
-            removevollist = remove_volumes
-
-        # Process join volumes.
-        try:
-            for volume in addvollist:
-                vid = volume['id']
-                # Verify the volume exists in the group or not.
-                if self._conver_uuid2hex(vid) in group_members:
-                    continue
-                self._join_volume_group(volume, cgid)
-        except Exception as e:
-            msg = _("Fexvisor failed to join the volume %(vol)s in the "
-                    "group %(group)s due to "
-                    "%(ret)s.") % {"vol": vid, "group": cgid,
-                                   "ret": six.text_type(e)}
-            raise exception.VolumeBackendAPIException(data=msg)
-        # Process leave volumes.
-        try:
-            for volume in removevollist:
-                vid = volume['id']
-                if self._conver_uuid2hex(vid) in group_members:
-                    self._leave_volume_group(volume, cgid)
-        except Exception as e:
-            msg = _("Fexvisor failed to remove the volume %(vol)s in the "
-                    "group %(group)s due to "
-                    "%(ret)s.") % {"vol": vid, "group": cgid,
-                                   "ret": six.text_type(e)}
-            raise exception.VolumeBackendAPIException(data=msg)
-        return model_update, None, None
-
-    def create_group(self, context, group):
-        if volume_utils.is_group_a_cg_snapshot_type(group):
-            return self._create_consistencygroup(context, group)
-        raise NotImplementedError()
-
-    def delete_group(self, context, group, volumes):
-        if volume_utils.is_group_a_cg_snapshot_type(group):
-            return self._delete_consistencygroup(context, group, volumes)
-        raise NotImplementedError()
-
-    def create_group_snapshot(self, context, group_snapshot, snapshots):
-        if volume_utils.is_group_a_cg_snapshot_type(group_snapshot):
-            return self._create_cgsnapshot(context, group_snapshot, snapshots)
-        raise NotImplementedError()
-
-    def delete_group_snapshot(self, context, group_snapshot, snapshots):
-        if volume_utils.is_group_a_cg_snapshot_type(group_snapshot):
-            return self._delete_cgsnapshot(context, group_snapshot, snapshots)
-        raise NotImplementedError()
-
-    def create_group_from_src(self, context, group, volumes,
-                              group_snapshot=None, snapshots=None,
-                              source_group=None, source_vols=None):
-        err_msg = _("Prophet Storage doesn't support create_group_from_src.")
-        LOG.error(err_msg)
-        raise exception.VolumeBackendAPIException(data=err_msg)
-
-    def create_volume(self, volume):
-        """Create a volume."""
-        pool = volume_utils.extract_host(volume['host'],
-                                         level='pool')
-        if not pool:
-            if not self.configuration.dpl_pool:
-                msg = _("Pool is not available in the volume host fields.")
-                raise exception.InvalidHost(reason=msg)
-            else:
-                pool = self.configuration.dpl_pool
-
-        ret, output = self.dpl.create_vdev(
-            self._conver_uuid2hex(volume['id']),
-            volume.get('display_name', ''),
-            volume.get('display_description', ''),
-            pool,
-            int(volume['size']) * units.Gi,
-            self.configuration.san_thin_provision)
-        if ret == errno.EAGAIN:
-            ret, event_uuid = self._get_event_uuid(output)
-            if ret == 0:
-                status = self._wait_event(self.dpl.get_vdev_status,
-                                          volume['id'],
-                                          event_uuid)
-                if status['state'] != 'available':
-                    msg = _('Flexvisor failed to create volume %(volume)s: '
-                            '%(status)s.') % {'volume': volume['id'],
-                                              'status': ret}
-                    raise exception.VolumeBackendAPIException(data=msg)
-            else:
-                msg = _('Flexvisor failed to create volume (get event) '
-                        '%s.') % (volume['id'])
-                raise exception.VolumeBackendAPIException(
-                    data=msg)
-        elif ret != 0:
-            msg = _('Flexvisor create volume failed.:%(volumeid)s:'
-                    '%(status)s.') % {'volumeid': volume['id'],
-                                      'status': ret}
-            raise exception.VolumeBackendAPIException(
-                data=msg)
-        else:
-            LOG.info('Flexvisor succeeded to create volume %(id)s.',
-                     {'id': volume['id']})
-
-        if volume.group_id:
-            group = volume_utils.group_get_by_id(volume.group_id)
-            if volume_utils.is_group_a_cg_snapshot_type(group):
-                try:
-                    self._join_volume_group(volume, volume.group_id)
-                except Exception:
-                    # Delete volume if volume failed to join group.
-                    self.dpl.delete_vdev(self._conver_uuid2hex(volume['id']))
-                    msg = _('Flexvisor failed to create volume %(id)s in the '
-                            'group %(vgid)s.') % {
-                        'id': volume['id'],
-                        'vgid': volume.group_id}
-                    raise exception.VolumeBackendAPIException(data=msg)
-
-    def create_volume_from_snapshot(self, volume, snapshot):
-        """Creates a volume from a snapshot."""
-        src_volume = None
-        vgID = None
-        # Detect whether a member of the group.
-        snapshotID = snapshot['id']
-        # Try to get cgid if volume belong in the group.
-        src_volumeID = snapshot['volume_id']
-        cgsnapshotID = snapshot.get('group_snapshot_id', None)
-        if cgsnapshotID:
-            try:
-                src_volume = self.db.volume_get(src_volumeID)
-            except Exception:
-                msg = _("Flexvisor unable to find the source volume "
-                        "%(id)s info.") % {'id': src_volumeID}
-                raise exception.VolumeBackendAPIException(data=msg)
-        if src_volume:
-            vgID = src_volume.group_id
-
-        # Get the volume origin snapshot id if the source snapshot is group
-        # snapshot.
-        if vgID:
-            snapshotID = self._get_snapshotid_of_vgsnapshot(
-                self._conver_uuid2hex(vgID),
-                self._conver_uuid2hex(cgsnapshotID),
-                self._conver_uuid2hex(src_volumeID))
-
-        pool = volume_utils.extract_host(volume['host'],
-                                         level='pool')
-        if not pool:
-            if not self.configuration.dpl_pool:
-                msg = _("Pool is not available in the volume host fields.")
-                raise exception.InvalidHost(reason=msg)
-            else:
-                pool = self.configuration.dpl_pool
-
-        ret, output = self.dpl.create_vdev_from_snapshot(
-            self._conver_uuid2hex(volume['id']),
-            volume.get('display_name', ''),
-            volume.get('display_description', ''),
-            self._conver_uuid2hex(snapshotID),
-            pool,
-            self.configuration.san_thin_provision)
-        if ret == errno.EAGAIN:
-            ret, event_uuid = self._get_event_uuid(output)
-            if ret == 0:
-                status = self._wait_event(self.dpl.get_vdev_status,
-                                          volume['id'],
-                                          event_uuid)
-                if status['state'] != 'available':
-                    msg = _('Flexvisor failed to create volume from '
-                            'snapshot %(id)s:'
-                            '%(status)s.') % {'id': snapshot['id'],
-                                              'status': ret}
-                    raise exception.VolumeBackendAPIException(
-                        data=msg)
-            else:
-                msg = _('Flexvisor failed to create volume from snapshot '
-                        '(failed to get event) '
-                        '%(id)s.') % {'id': snapshot['id']}
-                raise exception.VolumeBackendAPIException(data=msg)
-        elif ret != 0:
-            msg = _('Flexvisor failed to create volume from snapshot '
-                    '%(id)s: %(status)s.') % {'id': snapshot['id'],
-                                              'status': ret}
-            raise exception.VolumeBackendAPIException(
-                data=msg)
-        else:
-            LOG.info('Flexvisor succeeded to create volume %(id)s '
-                     'from snapshot.', {'id': volume['id']})
-
-        if volume['size'] > snapshot['volume_size']:
-            self.extend_volume(volume, volume['size'])
-
-        if volume.group_id:
-            group = volume_utils.group_get_by_id(volume.group_id)
-            if volume_utils.is_group_a_cg_snapshot_type(group):
-                try:
-                    self._join_volume_group(volume, volume.group_id)
-                except Exception:
-                    # Delete volume if volume failed to join group.
-                    self.dpl.delete_vdev(self._conver_uuid2hex(volume['id']))
-                    raise
-
-    def spawn_volume_from_snapshot(self, volume, snapshot):
-        """Spawn a REFERENCED volume from a snapshot."""
-        ret, output = self.dpl.spawn_vdev_from_snapshot(
-            self._conver_uuid2hex(volume['id']),
-            self._conver_uuid2hex(snapshot['volume_id']),
-            volume.get('display_name', ''),
-            volume.get('display_description', ''),
-            self._conver_uuid2hex(snapshot['id']))
-
-        if ret == errno.EAGAIN:
-            # its an async process
-            ret, event_uuid = self._get_event_uuid(output)
-            if ret == 0:
-                status = self._wait_event(self.dpl.get_vdev_status,
-                                          volume['id'], event_uuid)
-                if status['state'] != 'available':
-                    msg = _('Flexvisor failed to spawn volume from snapshot '
-                            '%(id)s:%(status)s.') % {'id': snapshot['id'],
-                                                     'status': ret}
-                    raise exception.VolumeBackendAPIException(data=msg)
-            else:
-                msg = _('Flexvisor failed to spawn volume from snapshot '
-                        '(failed to get event) '
-                        '%(id)s.') % {'id': snapshot['id']}
-                raise exception.VolumeBackendAPIException(data=msg)
-        elif ret != 0:
-            msg = _('Flexvisor failed to create volume from snapshot '
-                    '%(id)s: %(status)s.') % {'id': snapshot['id'],
-                                              'status': ret}
-
-            raise exception.VolumeBackendAPIException(
-                data=msg)
-        else:
-            LOG.info('Flexvisor succeeded to create volume %(id)s '
-                     'from snapshot.', {'id': volume['id']})
-
-    def create_cloned_volume(self, volume, src_vref):
-        """Creates a clone of the specified volume."""
-        pool = volume_utils.extract_host(volume['host'],
-                                         level='pool')
-        if not pool:
-            if not self.configuration.dpl_pool:
-                msg = _("Pool is not available in the volume host fields.")
-                raise exception.InvalidHost(reason=msg)
-            else:
-                pool = self.configuration.dpl_pool
-
-        ret, output = self.dpl.clone_vdev(
-            self._conver_uuid2hex(src_vref['id']),
-            self._conver_uuid2hex(volume['id']),
-            pool,
-            volume.get('display_name', ''),
-            volume.get('display_description', ''),
-            int(volume['size']) * units.Gi,
-            self.configuration.san_thin_provision)
-        if ret == errno.EAGAIN:
-            ret, event_uuid = self._get_event_uuid(output)
-            if ret == 0:
-                status = self._wait_event(self.dpl.get_vdev_status,
-                                          volume['id'],
-                                          event_uuid)
-                if status['state'] != 'available':
-                    msg = _('Flexvisor failed to clone volume %(id)s: '
-                            '%(status)s.') % {'id': src_vref['id'],
-                                              'status': ret}
-                    raise exception.VolumeBackendAPIException(data=msg)
-            else:
-                msg = _('Flexvisor failed to clone volume (failed to'
-                        ' get event) %(id)s.') % {'id': src_vref['id']}
-                raise exception.VolumeBackendAPIException(
-                    data=msg)
-        elif ret != 0:
-            msg = _('Flexvisor failed to clone volume %(id)s: '
-                    '%(status)s.') % {'id': src_vref['id'], 'status': ret}
-            raise exception.VolumeBackendAPIException(
-                data=msg)
-        else:
-            LOG.info('Flexvisor succeeded to clone volume %(id)s.',
-                     {'id': volume['id']})
-
-        if volume.group_id:
-            group = volume_utils.group_get_by_id(volume.group_id)
-            if volume_utils.is_group_a_cg_snapshot_type(group):
-                try:
-                    self._join_volume_group(volume, volume.group_id)
-                except Exception:
-                    # Delete volume if volume failed to join group.
-                    self.dpl.delete_vdev(self._conver_uuid2hex(volume['id']))
-                    msg = _('Flexvisor volume %(id)s failed to join group '
-                            '%(vgid)s.') % {'id': volume['id'],
-                                            'vgid': volume.group_id}
-                    raise exception.VolumeBackendAPIException(data=msg)
-
-    def delete_volume(self, volume):
-        """Deletes a volume."""
-        ret = 0
-        if volume.group_id:
-            group = volume_utils.group_get_by_id(volume.group_id)
-            if group and volume_utils.is_group_a_cg_snapshot_type(group):
-                msg = ''
-                try:
-                    ret, out = self.dpl.leave_vg(
-                        self._conver_uuid2hex(volume['id']),
-                        self._conver_uuid2hex(volume.group_id))
-                    if ret:
-                        LOG.warning('Flexvisor failed to delete volume '
-                                    '%(id)s from the group %(vgid)s.',
-                                    {'id': volume['id'],
-                                     'vgid': volume.group_id})
-                except Exception as e:
-                    LOG.warning('Flexvisor failed to delete volume %(id)s '
-                                'from group %(vgid)s due to %(status)s.',
-                                {'id': volume['id'],
-                                 'vgid': volume.group_id,
-                                 'status': e})
-
-            if ret:
-                ret = 0
-
-        ret, output = self.dpl.delete_vdev(self._conver_uuid2hex(volume['id']))
-        if ret == errno.EAGAIN:
-            status = self._wait_event(self.dpl.get_vdev, volume['id'])
-            if status['state'] == 'error':
-                msg = _('Flexvisor failed deleting volume %(id)s: '
-                        '%(status)s.') % {'id': volume['id'], 'status': ret}
-                raise exception.VolumeBackendAPIException(data=msg)
-        elif ret == errno.ENODATA:
-            ret = 0
-            LOG.info('Flexvisor volume %(id)s does not '
-                     'exist.', {'id': volume['id']})
-        elif ret != 0:
-            msg = _('Flexvisor failed to delete volume %(id)s: '
-                    '%(status)s.') % {'id': volume['id'], 'status': ret}
-            raise exception.VolumeBackendAPIException(
-                data=msg)
-
-    def extend_volume(self, volume, new_size):
-        ret, output = self.dpl.extend_vdev(self._conver_uuid2hex(volume['id']),
-                                           volume.get('display_name', ''),
-                                           volume.get('display_description',
-                                                      ''),
-                                           new_size * units.Gi)
-        if ret == errno.EAGAIN:
-            ret, event_uuid = self._get_event_uuid(output)
-            if ret == 0:
-                status = self._wait_event(self.dpl.get_vdev_status,
-                                          volume['id'],
-                                          event_uuid)
-                if status['state'] != 'available':
-                    msg = _('Flexvisor failed to extend volume '
-                            '%(id)s:%(status)s.') % {'id': volume,
-                                                     'status': ret}
-                    raise exception.VolumeBackendAPIException(
-                        data=msg)
-            else:
-                msg = _('Flexvisor failed to extend volume '
-                        '(failed to get event) '
-                        '%(id)s.') % {'id': volume['id']}
-                raise exception.VolumeBackendAPIException(data=msg)
-        elif ret != 0:
-            msg = _('Flexvisor failed to extend volume '
-                    '%(id)s: %(status)s.') % {'id': volume['id'],
-                                              'status': ret}
-            raise exception.VolumeBackendAPIException(
-                data=msg)
-        else:
-            LOG.info('Flexvisor succeeded to extend volume'
-                     ' %(id)s.', {'id': volume['id']})
-
-    def create_snapshot(self, snapshot):
-        """Creates a snapshot."""
-        ret, output = self.dpl.create_vdev_snapshot(
-            self._conver_uuid2hex(snapshot['volume_id']),
-            self._conver_uuid2hex(snapshot['id']),
-            snapshot.get('display_name', ''),
-            snapshot.get('display_description', ''))
-
-        if ret == errno.EAGAIN:
-            ret, event_uuid = self._get_event_uuid(output)
-            if ret == 0:
-                status = self._wait_event(self.dpl.get_vdev_status,
-                                          snapshot['volume_id'],
-                                          event_uuid)
-                if status['state'] != 'available':
-                    msg = (_('Flexvisor failed to create snapshot for volume '
-                             '%(id)s: %(status)s.') %
-                           {'id': snapshot['volume_id'], 'status': ret})
-                    raise exception.VolumeBackendAPIException(data=msg)
-            else:
-                msg = (_('Flexvisor failed to create snapshot for volume '
-                         '(failed to get event) %(id)s.') %
-                       {'id': snapshot['volume_id']})
-                raise exception.VolumeBackendAPIException(data=msg)
-        elif ret != 0:
-            msg = _('Flexvisor failed to create snapshot for volume %(id)s: '
-                    '%(status)s.') % {'id': snapshot['volume_id'],
-                                      'status': ret}
-            raise exception.VolumeBackendAPIException(data=msg)
-
-    def delete_snapshot(self, snapshot):
-        """Deletes a snapshot."""
-        ret, output = self.dpl.delete_vdev_snapshot(
-            self._conver_uuid2hex(snapshot['volume_id']),
-            self._conver_uuid2hex(snapshot['id']))
-        if ret == errno.EAGAIN:
-            ret, event_uuid = self._get_event_uuid(output)
-            if ret == 0:
-                status = self._wait_event(self.dpl.get_vdev_status,
-                                          snapshot['volume_id'],
-                                          event_uuid)
-                if status['state'] != 'available':
-                    msg = _('Flexvisor failed to delete snapshot %(id)s: '
-                            '%(status)s.') % {'id': snapshot['id'],
-                                              'status': ret}
-                    raise exception.VolumeBackendAPIException(data=msg)
-            else:
-                msg = _('Flexvisor failed to delete snapshot (failed to '
-                        'get event) %(id)s.') % {'id': snapshot['id']}
-                raise exception.VolumeBackendAPIException(data=msg)
-        elif ret == errno.ENODATA:
-            LOG.info('Flexvisor snapshot %(id)s not existed.',
-                     {'id': snapshot['id']})
-        elif ret != 0:
-            msg = _('Flexvisor failed to delete snapshot %(id)s: '
-                    '%(status)s.') % {'id': snapshot['id'], 'status': ret}
-            raise exception.VolumeBackendAPIException(data=msg)
-        else:
-            LOG.info('Flexvisor succeeded to delete snapshot %(id)s.',
-                     {'id': snapshot['id']})
-
-    def get_volume_stats(self, refresh=False):
-        """Get volume stats.
-
-        If 'refresh' is True, run update the stats first.
-        """
-        if refresh:
-            self._update_volume_stats()
-
-        return self._stats
-
-    def _get_pools(self):
-        pools = []
-        qpools = []
-        # Defined access pool by cinder configuration.
-        defined_pool = self.configuration.dpl_pool
-        if defined_pool:
-            qpools.append(defined_pool)
-        else:
-            try:
-                ret, output = self.dpl.get_pools()
-                if ret == 0:
-                    for poolUuid, poolName in output.get('children', []):
-                        qpools.append(poolUuid)
-                else:
-                    LOG.error("Flexvisor failed to get pool list."
-                              " (Error: %d)", ret)
-            except Exception as e:
-                LOG.error("Flexvisor failed to get pool list due to "
-                          "%s.", e)
-
-        # Query pool detail information
-        for poolid in qpools:
-            ret, output = self._get_pool_info(poolid)
-            if ret == 0:
-                pool = {}
-                pool['pool_name'] = output['metadata']['pool_uuid']
-                pool['total_capacity_gb'] = (
-                    self._convert_size_GB(
-                        int(output['metadata']['total_capacity'])))
-                pool['free_capacity_gb'] = (
-                    self._convert_size_GB(
-                        int(output['metadata']['available_capacity'])))
-                pool['QoS_support'] = False
-                pool['reserved_percentage'] = 0
-                pools.append(pool)
-            else:
-                LOG.warning("Failed to query pool %(id)s status "
-                            "%(ret)d.", {'id': poolid, 'ret': ret})
-                continue
-        return pools
-
-    def _update_volume_stats(self, refresh=False):
-        """Return the current state of the volume service.
-
-        If 'refresh' is True, run the update first.
-        """
-        data = {}
-        pools = self._get_pools()
-        data['volume_backend_name'] = (
-            self.configuration.safe_get('volume_backend_name'))
-        location_info = '%(driver)s:%(host)s:%(volume)s' % {
-            'driver': self.__class__.__name__,
-            'host': self.configuration.san_ip,
-            'volume': self.configuration.dpl_pool
-        }
-        try:
-            ret, output = self.dpl.get_server_info()
-            if ret == 0:
-                data['vendor_name'] = output['metadata']['vendor']
-                data['driver_version'] = output['metadata']['version']
-                data['storage_protocol'] = 'iSCSI'
-                data['location_info'] = location_info
-                data['consistencygroup_support'] = True
-                data['consistent_group_snapshot_enabled'] = True
-                data['pools'] = pools
-                self._stats = data
-        except Exception as e:
-            LOG.error('Failed to get server info due to '
-                      '%(state)s.', {'state': e})
-        return self._stats
-
-    def do_setup(self, context):
-        """Any initialization the volume driver does while starting."""
-        self.context = context
-        LOG.info('Activate Flexvisor cinder volume driver.')
-
-    def check_for_setup_error(self):
-        """Check DPL can connect properly."""
-        pass
-
-    def _get_pool_info(self, poolid):
-        """Query pool information."""
-        ret, output = self.dpl.get_pool(poolid)
-        if ret == errno.EAGAIN:
-            ret, event_uuid = self._get_event_uuid(output)
-            if ret == 0:
-                status = self._wait_event(self.dpl.get_pool_status, poolid,
-                                          event_uuid)
-                if status['state'] != 'available':
-                    msg = _('Flexvisor failed to get pool info %(id)s: '
-                            '%(status)s.') % {'id': poolid, 'status': ret}
-                    raise exception.VolumeBackendAPIException(data=msg)
-                else:
-                    ret = 0
-                    output = status.get('output', {})
-            else:
-                LOG.error('Flexvisor failed to get pool %(id)s info.',
-                          {'id': poolid})
-                raise exception.VolumeBackendAPIException(
-                    data="failed to get event")
-        elif ret != 0:
-            msg = _('Flexvisor failed to get pool info %(id)s: '
-                    '%(status)s.') % {'id': poolid, 'status': ret}
-            raise exception.VolumeBackendAPIException(data=msg)
-        else:
-            LOG.debug('Flexvisor succeeded to get pool info.')
-        return ret, output
diff -pruN 2:15.0.1-1/cinder/volume/drivers/prophetstor/dpl_fc.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/prophetstor/dpl_fc.py
--- 2:15.0.1-1/cinder/volume/drivers/prophetstor/dpl_fc.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/prophetstor/dpl_fc.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,413 +0,0 @@
-# Copyright (c) 2014 ProphetStor, Inc.
-# All Rights Reserved.
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-
-import errno
-
-from oslo_log import log as logging
-
-from cinder import exception
-from cinder.i18n import _
-from cinder import interface
-from cinder.volume import driver
-from cinder.volume.drivers.prophetstor import dplcommon
-from cinder.zonemanager import utils as fczm_utils
-
-LOG = logging.getLogger(__name__)
-
-
-@interface.volumedriver
-class DPLFCDriver(dplcommon.DPLCOMMONDriver,
-                  driver.FibreChannelDriver):
-    def __init__(self, *args, **kwargs):
-        super(DPLFCDriver, self).__init__(*args, **kwargs)
-
-    def _get_fc_channel(self):
-        """Get FibreChannel info.
-
-        :returns: fcInfos[uuid]
-                  fcInfo[uuid]['display_name']
-                  fcInfo[uuid]['display_description']
-                  fcInfo[uuid]['hardware_address']
-                  fcInfo[uuid]['type']
-                  fcInfo[uuid]['speed']
-                  fcInfo[uuid]['state']
-        """
-        output = None
-        fcInfos = {}
-        try:
-            retCode, output = self.dpl.get_server_info()
-            if retCode == 0 and output:
-                fcUuids = output.get('metadata',
-                                     {}).get('storage_adapter', {}).keys()
-                for fcUuid in fcUuids:
-                    fcInfo = output.get('metadata',
-                                        {}).get('storage_adapter',
-                                                {}).get(fcUuid)
-                    if fcInfo['type'] == 'fc':
-                        fcInfos[fcUuid] = fcInfo
-        except Exception as e:
-            LOG.error("Failed to get fiber channel info from storage "
-                      "due to %(stat)s", {'stat': e})
-        return fcInfos
-
-    def _get_targets(self):
-        """Get targets.
-
-        :returns: targetInfos[uuid] = targetInfo
-                  targetInfo['targetUuid']
-                  targetInfo['targetName']
-                  targetInfo['targetAddr']
-        """
-        output = None
-        targetInfos = {}
-        try:
-            retCode, output = self.dpl.get_target_list('target')
-            if retCode == 0 and output:
-                for targetInfo in output.get('children', []):
-                    targetI = {}
-                    targetI['targetUuid'] = targetInfo[0]
-                    targetI['targetName'] = targetInfo[1]
-                    targetI['targetAddr'] = targetInfo[2]
-                    targetInfos[str(targetInfo[0])] = targetI
-        except Exception as e:
-            targetInfos = {}
-            LOG.error("Failed to get fiber channel target from "
-                      "storage server due to %(stat)s",
-                      {'stat': e})
-        return targetInfos
-
-    def _get_targetwpns(self, volumeid, initiatorWwpns):
-        lstargetWwpns = []
-        try:
-            ret, output = self.dpl.get_vdev(volumeid)
-            if ret == 0 and output:
-                exports = output.get('exports', {})
-                fc_infos = exports.get('Network/FC', {})
-                for fc_info in fc_infos:
-                    for p in fc_info.get('permissions', []):
-                        if p.get(initiatorWwpns, None):
-                            targetWwpns = fc_info.get('target_identifier', '')
-                            lstargetWwpns.append(targetWwpns)
-        except Exception as e:
-            LOG.error("Failed to get target wwpns from storage due "
-                      "to %(stat)s", {'stat': e})
-            lstargetWwpns = []
-        return lstargetWwpns
-
-    def _is_initiator_wwpn_active(self, targetWwpn, initiatorWwpn):
-        fActive = False
-        output = None
-        try:
-            retCode, output = self.dpl.get_sns_table(targetWwpn)
-            if retCode == 0 and output:
-                for fdwwpn, fcport in output.get('metadata',
-                                                 {}).get('sns_table',
-                                                         []):
-                    if fdwwpn == initiatorWwpn:
-                        fActive = True
-                        break
-        except Exception:
-            LOG.error('Failed to get sns table')
-        return fActive
-
-    def _convertHex2String(self, wwpns):
-        szwwpns = ''
-        if len(str(wwpns)) == 16:
-            szwwpns = '%2s:%2s:%2s:%2s:%2s:%2s:%2s:%2s' % (
-                str(wwpns)[0:2],
-                str(wwpns)[2:4],
-                str(wwpns)[4:6],
-                str(wwpns)[6:8],
-                str(wwpns)[8:10],
-                str(wwpns)[10:12],
-                str(wwpns)[12:14],
-                str(wwpns)[14:16])
-        return szwwpns
-
-    def _export_fc(self, volumeid, targetwwpns, initiatorwwpns, volumename):
-        ret = 0
-        output = ''
-        LOG.debug('Export fc: %(volume)s, %(wwpns)s, %(iqn)s, %(volumename)s',
-                  {'volume': volumeid, 'wwpns': targetwwpns,
-                   'iqn': initiatorwwpns, 'volumename': volumename})
-        try:
-            ret, output = self.dpl.assign_vdev_fc(
-                self._conver_uuid2hex(volumeid), targetwwpns,
-                initiatorwwpns, volumename)
-        except Exception:
-            LOG.error('Volume %(volumeid)s failed to send assign command, '
-                      'ret: %(status)s output: %(output)s',
-                      {'volumeid': volumeid, 'status': ret, 'output': output})
-            ret = errno.EFAULT
-
-        if ret == errno.EAGAIN:
-            ret, event_uuid = self._get_event_uuid(output)
-            if len(event_uuid):
-                ret = 0
-                status = self._wait_event(
-                    self.dpl.get_vdev_status,
-                    self._conver_uuid2hex(volumeid), event_uuid)
-                if status['state'] == 'error':
-                    ret = errno.EFAULT
-                    msg = _('Flexvisor failed to assign volume %(id)s: '
-                            '%(status)s.') % {'id': volumeid,
-                                              'status': status}
-                    raise exception.VolumeBackendAPIException(data=msg)
-            else:
-                ret = errno.EFAULT
-                msg = _('Flexvisor failed to assign volume %(id)s due to '
-                        'unable to query status by event '
-                        'id.') % {'id': volumeid}
-                raise exception.VolumeBackendAPIException(data=msg)
-        elif ret != 0:
-            msg = _('Flexvisor assign volume failed:%(id)s:'
-                    '%(status)s.') % {'id': volumeid, 'status': ret}
-            raise exception.VolumeBackendAPIException(data=msg)
-
-        return ret
-
-    def _delete_export_fc(self, volumeid, targetwwpns, initiatorwwpns):
-        ret = 0
-        output = ''
-        ret, output = self.dpl.unassign_vdev_fc(
-            self._conver_uuid2hex(volumeid),
-            targetwwpns, initiatorwwpns)
-        if ret == errno.EAGAIN:
-            ret, event_uuid = self._get_event_uuid(output)
-            if ret == 0 and len(event_uuid):
-                status = self._wait_event(
-                    self.dpl.get_vdev_status, volumeid, event_uuid)
-                if status['state'] == 'error':
-                    ret = errno.EFAULT
-                    msg = _('Flexvisor failed to unassign volume %(id)s:'
-                            ' %(status)s.') % {'id': volumeid,
-                                               'status': status}
-                    raise exception.VolumeBackendAPIException(data=msg)
-            else:
-                msg = _('Flexvisor failed to unassign volume (get event) '
-                        '%(id)s.') % {'id': volumeid}
-                raise exception.VolumeBackendAPIException(data=msg)
-        elif ret != 0:
-            msg = _('Flexvisor unassign volume failed:%(id)s:'
-                    '%(status)s.') % {'id': volumeid, 'status': ret}
-            raise exception.VolumeBackendAPIException(data=msg)
-        else:
-            LOG.info('Flexvisor succeeded to unassign volume %(id)s.',
-                     {'id': volumeid})
-
-        return ret
-
-    def _build_initiator_target_map(self, connector, tgtwwns):
-        """Build the target_wwns and the initiator target map."""
-        init_targ_map = {}
-        initiator_wwns = connector['wwpns']
-        for initiator in initiator_wwns:
-            init_targ_map[initiator] = tgtwwns
-
-        return init_targ_map
-
-    def initialize_connection(self, volume, connector):
-        """Allow connection to connector and return connection info."""
-        """
-            connector = {'ip': CONF.my_ip,
-                         'host': CONF.host,
-                         'initiator': self._initiator,
-                         'wwnns': self._fc_wwnns,
-                         'wwpns': self._fc_wwpns}
-
-        """
-        dc_fc = {}
-        dc_target = {}
-        lsTargetWwpn = []
-        output = None
-        properties = {}
-        preferTargets = {}
-        ret = 0
-        targetIdentifier = []
-        szwwpns = []
-        LOG.info('initialize_connection volume: %(volume)s, connector:'
-                 ' %(connector)s',
-                 {"volume": volume, "connector": connector})
-        # Get Storage Fiber channel controller
-        dc_fc = self._get_fc_channel()
-
-        # Get existed FC target list to decide target wwpn
-        dc_target = self._get_targets()
-        if len(dc_target) == 0:
-            msg = _('Backend storage did not configure fiber channel '
-                    'target.')
-            raise exception.VolumeBackendAPIException(data=msg)
-
-        for keyFc in dc_fc:
-            for targetuuid in dc_target:
-                if dc_fc[keyFc]['hardware_address'] == \
-                        dc_target[targetuuid]['targetAddr']:
-                    preferTargets[targetuuid] = dc_target[targetuuid]
-                    break
-        # Confirm client wwpn is existed in sns table
-        # Covert wwwpns to 'xx:xx:xx:xx:xx:xx:xx:xx' format
-        for dwwpn in connector['wwpns']:
-            szwwpn = self._convertHex2String(dwwpn)
-            if len(szwwpn) == 0:
-                msg = _('Invalid wwpns format %(wwpns)s') % \
-                    {'wwpns': connector['wwpns']}
-                raise exception.VolumeBackendAPIException(data=msg)
-            szwwpns.append(szwwpn)
-
-        if len(szwwpns):
-            for targetUuid in preferTargets:
-                targetWwpn = ''
-                targetWwpn = preferTargets.get(targetUuid,
-                                               {}).get('targetAddr', '')
-                lsTargetWwpn.append(targetWwpn)
-        # Use wwpns to assign volume.
-        LOG.info('Prefer use target wwpn %(wwpn)s',
-                 {'wwpn': lsTargetWwpn})
-        # Start to create export in all FC target node.
-        assignedTarget = []
-        for pTarget in lsTargetWwpn:
-            try:
-                ret = self._export_fc(volume['id'], str(pTarget), szwwpns,
-                                      volume['name'])
-                if ret:
-                    break
-                else:
-                    assignedTarget.append(pTarget)
-            except Exception as e:
-                LOG.error('Failed to export fiber channel target '
-                          'due to %s', e)
-                ret = errno.EFAULT
-                break
-        if ret == 0:
-            ret, output = self.dpl.get_vdev(self._conver_uuid2hex(
-                volume['id']))
-        nLun = -1
-        if ret == 0:
-            try:
-                for p in output['exports']['Network/FC']:
-                    # check initiator wwpn existed in target initiator list
-                    for initI in p.get('permissions', []):
-                        for szwpn in szwwpns:
-                            if initI.get(szwpn, None):
-                                nLun = initI[szwpn]
-                                break
-                        if nLun != -1:
-                            break
-
-                    if nLun != -1:
-                        targetIdentifier.append(
-                            str(p['target_identifier']).replace(':', ''))
-
-            except Exception:
-                msg = _('Invalid connection initialization response of '
-                        'volume %(name)s: '
-                        '%(output)s') % {'name': volume['name'],
-                                         'output': output}
-                raise exception.VolumeBackendAPIException(data=msg)
-
-        if nLun != -1:
-            init_targ_map = self._build_initiator_target_map(connector,
-                                                             targetIdentifier)
-            properties['target_discovered'] = True
-            properties['target_wwn'] = targetIdentifier
-            properties['target_lun'] = int(nLun)
-            properties['volume_id'] = volume['id']
-            properties['initiator_target_map'] = init_targ_map
-            LOG.info('%(volume)s assign type fibre_channel, properties '
-                     '%(properties)s',
-                     {'volume': volume['id'], 'properties': properties})
-        else:
-            msg = _('Invalid connection initialization response of '
-                    'volume %(name)s') % {'name': volume['name']}
-            raise exception.VolumeBackendAPIException(data=msg)
-        LOG.info('Connect initialization info: '
-                 '{driver_volume_type: fibre_channel, '
-                 'data: %(properties)s', {'properties': properties})
-        conn_info = {'driver_volume_type': 'fibre_channel',
-                     'data': properties}
-        fczm_utils.add_fc_zone(conn_info)
-        return conn_info
-
-    def terminate_connection(self, volume, connector, **kwargs):
-        """Disallow connection from connector."""
-        """
-            connector = {'ip': CONF.my_ip,
-                         'host': CONF.host,
-                         'initiator': self._initiator,
-                         'wwnns': self._fc_wwnns,
-                         'wwpns': self._fc_wwpns}
-        """
-        lstargetWwpns = []
-        lsTargets = []
-        szwwpns = []
-        ret = 0
-        info = {'driver_volume_type': 'fibre_channel', 'data': {}}
-        LOG.info('terminate_connection volume: %(volume)s, '
-                 'connector: %(con)s',
-                 {'volume': volume, 'con': connector})
-        # Query targetwwpns.
-        # Get all target list of volume.
-        for dwwpn in connector['wwpns']:
-            szwwpn = self._convertHex2String(dwwpn)
-            if len(szwwpn) == 0:
-                msg = _('Invalid wwpns format %(wwpns)s') % \
-                    {'wwpns': connector['wwpns']}
-                raise exception.VolumeBackendAPIException(data=msg)
-            szwwpns.append(szwwpn)
-
-        if len(szwwpns) == 0:
-            ret = errno.EFAULT
-            msg = _('Invalid wwpns format %(wwpns)s') % \
-                {'wwpns': connector['wwpns']}
-            raise exception.VolumeBackendAPIException(data=msg)
-        else:
-            for szwwpn in szwwpns:
-                lstargetWwpns = self._get_targetwpns(
-                    self._conver_uuid2hex(volume['id']), szwwpn)
-                lsTargets = list(set(lsTargets + lstargetWwpns))
-
-        # Remove all export target
-        try:
-            for ptarget in lsTargets:
-                ret = self._delete_export_fc(volume['id'], ptarget, szwwpns)
-                if ret:
-                    break
-        except Exception:
-            ret = errno.EFAULT
-        finally:
-            if ret:
-                msg = _('Faield to unassign %(volume)s') % (volume['id'])
-                raise exception.VolumeBackendAPIException(data=msg)
-
-        # Failed to delete export with fibre channel
-        if ret:
-            init_targ_map = self._build_initiator_target_map(connector,
-                                                             lsTargets)
-            info['data'] = {'target_wwn': lsTargets,
-                            'initiator_target_map': init_targ_map}
-            fczm_utils.remove_fc_zone(info)
-
-        return info
-
-    def get_volume_stats(self, refresh=False):
-        if refresh:
-            data = super(DPLFCDriver, self).get_volume_stats(refresh)
-            if data:
-                data['storage_protocol'] = 'FC'
-                backend_name = \
-                    self.configuration.safe_get('volume_backend_name')
-                data['volume_backend_name'] = (backend_name or 'DPLFCDriver')
-                self._stats = data
-        return self._stats
diff -pruN 2:15.0.1-1/cinder/volume/drivers/prophetstor/dpl_iscsi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/prophetstor/dpl_iscsi.py
--- 2:15.0.1-1/cinder/volume/drivers/prophetstor/dpl_iscsi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/prophetstor/dpl_iscsi.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,155 +0,0 @@
-# Copyright (c) 2014 ProphetStor, Inc.
-# All Rights Reserved.
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-
-import errno
-
-from oslo_log import log as logging
-
-from cinder import exception
-from cinder.i18n import _
-from cinder import interface
-import cinder.volume.driver
-from cinder.volume.drivers.prophetstor import dplcommon
-
-LOG = logging.getLogger(__name__)
-
-
-@interface.volumedriver
-class DPLISCSIDriver(dplcommon.DPLCOMMONDriver,
-                     cinder.volume.driver.ISCSIDriver):
-    def __init__(self, *args, **kwargs):
-        super(DPLISCSIDriver, self).__init__(*args, **kwargs)
-
-    def initialize_connection(self, volume, connector):
-        """Allow connection to connector and return connection info."""
-        properties = {}
-        properties['target_lun'] = None
-        properties['target_discovered'] = True
-        properties['target_portal'] = ''
-        properties['target_iqn'] = None
-        properties['volume_id'] = volume['id']
-
-        dpl_server = self.configuration.san_ip
-        dpl_iscsi_port = self.configuration.target_port
-        ret, output = self.dpl.assign_vdev(self._conver_uuid2hex(
-            volume['id']), connector['initiator'].lower(), volume['id'],
-            '%s:%d' % (dpl_server, dpl_iscsi_port), 0)
-
-        if ret == errno.EAGAIN:
-            ret, event_uuid = self._get_event_uuid(output)
-            if len(event_uuid):
-                ret = 0
-                status = self._wait_event(
-                    self.dpl.get_vdev_status, self._conver_uuid2hex(
-                        volume['id']), event_uuid)
-                if status['state'] == 'error':
-                    ret = errno.EFAULT
-                    msg = _('Flexvisor failed to assign volume %(id)s: '
-                            '%(status)s.') % {'id': volume['id'],
-                                              'status': status}
-                    raise exception.VolumeBackendAPIException(data=msg)
-            else:
-                ret = errno.EFAULT
-                msg = _('Flexvisor failed to assign volume %(id)s due to '
-                        'unable to query status by event '
-                        'id.') % {'id': volume['id']}
-                raise exception.VolumeBackendAPIException(data=msg)
-        elif ret != 0:
-            msg = _('Flexvisor assign volume failed.:%(id)s:'
-                    '%(status)s.') % {'id': volume['id'], 'status': ret}
-            raise exception.VolumeBackendAPIException(data=msg)
-
-        if ret == 0:
-            ret, output = self.dpl.get_vdev(
-                self._conver_uuid2hex(volume['id']))
-        if ret == 0:
-            for tgInfo in output['exports']['Network/iSCSI']:
-                if tgInfo['permissions'] and \
-                        isinstance(tgInfo['permissions'][0], dict):
-                    for assign in tgInfo['permissions']:
-                        if connector['initiator'].lower() in assign.keys():
-                            for tgportal in tgInfo.get('portals', {}):
-                                properties['target_portal'] = tgportal
-                                break
-                            properties['target_lun'] = \
-                                int(assign[connector['initiator'].lower()])
-                            break
-
-                    if properties['target_portal'] != '':
-                        properties['target_iqn'] = tgInfo['target_identifier']
-                        break
-                else:
-                    if connector['initiator'].lower() in tgInfo['permissions']:
-                        for tgportal in tgInfo.get('portals', {}):
-                            properties['target_portal'] = tgportal
-                            break
-
-                    if properties['target_portal'] != '':
-                        properties['target_lun'] = int(
-                            tgInfo['logical_unit_number'])
-                        properties['target_iqn'] = tgInfo['target_identifier']
-                        break
-
-        if not (ret == 0 or properties['target_portal']):
-            msg = _('Flexvisor failed to assign volume %(volume)s '
-                    'iqn %(iqn)s.') % {'volume': volume['id'],
-                                       'iqn': connector['initiator']}
-            raise exception.VolumeBackendAPIException(data=msg)
-
-        return {'driver_volume_type': 'iscsi', 'data': properties}
-
-    def terminate_connection(self, volume, connector, **kwargs):
-        """Disallow connection from connector."""
-        ret, output = self.dpl.unassign_vdev(
-            self._conver_uuid2hex(volume['id']),
-            connector['initiator'])
-
-        if ret == errno.EAGAIN:
-            ret, event_uuid = self._get_event_uuid(output)
-            if ret == 0:
-                status = self._wait_event(
-                    self.dpl.get_vdev_status, volume['id'], event_uuid)
-                if status['state'] == 'error':
-                    ret = errno.EFAULT
-                    msg = _('Flexvisor failed to unassign volume %(id)s:'
-                            ' %(status)s.') % {'id': volume['id'],
-                                               'status': status}
-                    raise exception.VolumeBackendAPIException(data=msg)
-            else:
-                msg = _('Flexvisor failed to unassign volume (get event) '
-                        '%(id)s.') % {'id': volume['id']}
-                raise exception.VolumeBackendAPIException(data=msg)
-        elif ret == errno.ENODATA:
-            LOG.info('Flexvisor already unassigned volume %(id)s.',
-                     {'id': volume['id']})
-        elif ret != 0:
-            msg = _('Flexvisor failed to unassign volume:%(id)s:'
-                    '%(status)s.') % {'id': volume['id'], 'status': ret}
-            raise exception.VolumeBackendAPIException(data=msg)
-
-    def get_volume_stats(self, refresh=False):
-        if refresh:
-            try:
-                data = super(DPLISCSIDriver, self).get_volume_stats(refresh)
-                if data:
-                    data['storage_protocol'] = 'iSCSI'
-                    backend_name = \
-                        self.configuration.safe_get('volume_backend_name')
-                    data['volume_backend_name'] = \
-                        (backend_name or 'DPLISCSIDriver')
-                    self._stats = data
-            except Exception as exc:
-                LOG.warning('Cannot get volume status %(exc)s.', {'exc': exc})
-        return self._stats
diff -pruN 2:15.0.1-1/cinder/volume/drivers/prophetstor/options.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/prophetstor/options.py
--- 2:15.0.1-1/cinder/volume/drivers/prophetstor/options.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/prophetstor/options.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,31 +0,0 @@
-# Copyright (c) 2014 ProphetStor, Inc.
-# All Rights Reserved.
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-
-
-from oslo_config import cfg
-
-from cinder.volume import configuration
-
-DPL_OPTS = [
-    cfg.StrOpt('dpl_pool',
-               default='',
-               help='DPL pool uuid in which DPL volumes are stored.'),
-    cfg.PortOpt('dpl_port',
-                default=8357,
-                help='DPL port number.'),
-]
-
-CONF = cfg.CONF
-CONF.register_opts(DPL_OPTS, group=configuration.SHARED_CONF_GROUP)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/pure.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/pure.py
--- 2:15.0.1-1/cinder/volume/drivers/pure.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/pure.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,12 +12,12 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Volume driver for Pure Storage FlashArray storage system.
+"""Volume driver for Pure Storage FlashArray storage system.
 
 This driver requires Purity version 4.0.0 or later.
 """
 
+from distutils import version
 import functools
 import ipaddress
 import math
@@ -25,13 +25,15 @@ import platform
 import re
 import uuid
 
-from distutils import version
 from oslo_config import cfg
 from oslo_log import log as logging
 from oslo_utils import excutils
 from oslo_utils import strutils
 from oslo_utils import units
-import six
+try:
+    from purestorage import purestorage
+except ImportError:
+    purestorage = None
 
 from cinder import exception
 from cinder.i18n import _
@@ -45,11 +47,6 @@ from cinder.volume.drivers.san import sa
 from cinder.volume import volume_utils
 from cinder.zonemanager import utils as fczm_utils
 
-try:
-    from purestorage import purestorage
-except ImportError:
-    purestorage = None
-
 LOG = logging.getLogger(__name__)
 
 PURE_OPTS = [
@@ -1863,7 +1860,7 @@ class PureBaseVolumeDriver(san.SanDriver
             raise PureDriverException(
                 reason=_("Unable to find viable secondary array from "
                          "configured targets: %(targets)s.") %
-                {"targets": six.text_type(self._replication_target_arrays)}
+                {"targets": str(self._replication_target_arrays)}
             )
 
         LOG.debug("Starting failover from %(primary)s to %(secondary)s",
@@ -2343,7 +2340,7 @@ class PureISCSIDriver(PureBaseVolumeDriv
     the underlying storage connectivity with the FlashArray.
     """
 
-    VERSION = "9.0.0"
+    VERSION = "10.0.iscsi"
 
     def __init__(self, *args, **kwargs):
         execute = kwargs.pop("execute", utils.execute)
@@ -2425,13 +2422,13 @@ class PureISCSIDriver(PureBaseVolumeDriv
 
         # Check to ensure all returned portal IP addresses
         # are in iSCSI target CIDR
-        if not isinstance(self.configuration.pure_iscsi_cidr, six.text_type):
+        if not isinstance(self.configuration.pure_iscsi_cidr, str):
             cidr = self.configuration.pure_iscsi_cidr.decode('utf8')
         else:
             cidr = self.configuration.pure_iscsi_cidr
         check_cidr = ipaddress.IPv4Network(cidr)
         for target_portal in target_portals:
-            if not isinstance(target_portal.split(":")[0], six.text_type):
+            if not isinstance(target_portal.split(":")[0], str):
                 portal = (target_portal.split(":")[0]).decode('utf8')
             else:
                 portal = target_portal.split(":")[0]
@@ -2590,7 +2587,7 @@ class PureFCDriver(PureBaseVolumeDriver,
     supports the Cinder Fibre Channel Zone Manager.
     """
 
-    VERSION = "7.0.0"
+    VERSION = "10.0.fc"
 
     def __init__(self, *args, **kwargs):
         execute = kwargs.pop("execute", utils.execute)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/qnap.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/qnap.py
--- 2:15.0.1-1/cinder/volume/drivers/qnap.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/qnap.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,19 +12,19 @@
 #    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 #    License for the specific language governing permissions and limitations
 #    under the License.
-"""
-Volume driver for QNAP Storage.
+"""Volume driver for QNAP Storage.
+
 This driver supports QNAP Storage for iSCSI.
 """
 import base64
 from collections import OrderedDict
-import eventlet
 import functools
 import re
 import threading
 import time
 
 from defusedxml import cElementTree as ET
+import eventlet
 from oslo_concurrency import lockutils
 from oslo_config import cfg
 from oslo_log import log as logging
@@ -349,10 +349,10 @@ class QnapISCSIDriver(san.SanISCSIDriver
                     created_lun.find('LUNNAA').text is not None):
                 lun_naa = created_lun.find('LUNNAA').text
 
-            try_times = try_times + 3
-            eventlet.sleep(self.TIME_INTERVAL)
-            if(try_times > max_wait_sec or lun_naa != ""):
+            try_times += 3
+            if try_times > max_wait_sec or lun_naa:
                 break
+            eventlet.sleep(self.TIME_INTERVAL)
 
         LOG.debug('LUNNAA: %s', lun_naa)
         _metadata = self._get_volume_metadata(volume)
@@ -528,10 +528,10 @@ class QnapISCSIDriver(san.SanISCSIDriver
                 lun_index = created_lun.find('LUNIndex').text
                 LOG.debug('LUNIndex: %s', lun_index)
 
-            try_times = try_times + 3
-            eventlet.sleep(self.TIME_INTERVAL)
-            if(try_times > max_wait_sec or lun_naa != ""):
+            try_times += 3
+            if try_times > max_wait_sec or lun_naa:
                 break
+            eventlet.sleep(self.TIME_INTERVAL)
 
         LOG.debug('LUNNAA: %s', lun_naa)
         if (volume['size'] > src_vref['size']):
@@ -580,10 +580,10 @@ class QnapISCSIDriver(san.SanISCSIDriver
                     created_snapshot.find('snapshot_id').text is not None):
                 snapshot_id = created_snapshot.find('snapshot_id').text
 
-            try_times = try_times + 3
-            eventlet.sleep(self.TIME_INTERVAL)
-            if(try_times > max_wait_sec or snapshot_id != ""):
+            try_times += 3
+            if try_times > max_wait_sec or snapshot_id:
                 break
+            eventlet.sleep(self.TIME_INTERVAL)
 
         LOG.debug('created_snapshot: %s', created_snapshot)
         LOG.debug('snapshot_id: %s', snapshot_id)
@@ -641,10 +641,10 @@ class QnapISCSIDriver(san.SanISCSIDriver
                 LOG.debug('LUNNAA: %s', lun_naa)
                 LOG.debug('LUNIndex: %s', lun_index)
 
-            try_times = try_times + 3
-            eventlet.sleep(self.TIME_INTERVAL)
-            if(try_times > max_wait_sec or lun_naa != ""):
+            try_times += 3
+            if try_times > max_wait_sec or lun_naa:
                 break
+            eventlet.sleep(self.TIME_INTERVAL)
 
         if (volume['size'] > snapshot['volume_size']):
             self._extend_lun(volume, lun_naa)
@@ -875,10 +875,10 @@ class QnapISCSIDriver(san.SanISCSIDriver
                                     .find('LUNTargetList').find('row')
                                     .find('LUNNumber').text)
 
-                try_times = try_times + 3
-                eventlet.sleep(self.TIME_INTERVAL)
-                if(try_times > max_wait_sec or target_lun_id != -999):
+                try_times += 3
+                if try_times > max_wait_sec or target_lun_id != -999:
                     break
+                eventlet.sleep(self.TIME_INTERVAL)
 
             elif 'ES' in internal_model_name.upper():
                 if fw_version >= "1.1.2" and fw_version <= "1.1.3":
@@ -889,10 +889,10 @@ class QnapISCSIDriver(san.SanISCSIDriver
                             'row').find('LUNNumber').text
                     target_lun_id = int(LUNNumber)
 
-                    try_times = try_times + 3
-                    eventlet.sleep(self.TIME_INTERVAL)
-                    if(try_times > max_wait_sec or LUNNumber != ""):
+                    try_times += 3
+                    if try_times > max_wait_sec or LUNNumber:
                         break
+                    eventlet.sleep(self.TIME_INTERVAL)
                 elif "1.1.4" <= fw_version <= "2.1.9999":
                     LOG.debug('in ES FW after 1.1.4: get_one_lun_info')
                     ret = self.api_executor.get_one_lun_info(lun_index)
@@ -901,10 +901,10 @@ class QnapISCSIDriver(san.SanISCSIDriver
                                         .find('row').find('LUNTargetList')
                                         .find('row').find('LUNNumber').text)
 
-                    try_times = try_times + 3
-                    eventlet.sleep(self.TIME_INTERVAL)
-                    if(try_times > max_wait_sec or target_lun_id != -999):
+                    try_times += 3
+                    if try_times > max_wait_sec or target_lun_id != -999:
                         break
+                    eventlet.sleep(self.TIME_INTERVAL)
                 else:
                     break
             else:
@@ -1231,23 +1231,16 @@ class QnapAPIExecutor(object):
 
     def execute_login(self):
         """Login and return sid."""
-        params = OrderedDict()
-        params['pwd'] = base64.b64encode(self.password.encode("utf-8"))
-        params['serviceKey'] = '1'
-        params['user'] = self.username
-
-        sanitized_params = OrderedDict()
-
-        for key in params:
-            value = params[key]
-            if value is not None:
-                sanitized_params[key] = six.text_type(value)
-
-        sanitized_params = urllib.parse.urlencode(sanitized_params)
+        params = OrderedDict(
+            pwd=base64.b64encode(self.password.encode('utf-8')).decode(),
+            serviceKey='1',
+            user=self.username,
+        )
+        encoded_params = urllib.parse.urlencode(params)
         url = ('/cgi-bin/authLogin.cgi?')
 
         res_details = self._execute_and_get_response_details(
-            self.ip, url, sanitized_params)
+            self.ip, url, encoded_params)
         root = ET.fromstring(res_details['data'])
         LOG.debug('execute_login data: %s', res_details['data'])
         session_id = root.find('authSid').text
diff -pruN 2:15.0.1-1/cinder/volume/drivers/quobyte.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/quobyte.py
--- 2:15.0.1-1/cinder/volume/drivers/quobyte.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/quobyte.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,7 +16,6 @@
 
 import errno
 import os
-import psutil
 import shutil
 
 from oslo_concurrency import processutils
@@ -24,6 +23,7 @@ from oslo_config import cfg
 from oslo_log import log as logging
 from oslo_utils import fileutils
 from oslo_utils import fnmatch
+import psutil
 
 from cinder import compute
 from cinder import coordination
diff -pruN 2:15.0.1-1/cinder/volume/drivers/rbd.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/rbd.py
--- 2:15.0.1-1/cinder/volume/drivers/rbd.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/rbd.py	2020-03-24 18:46:31.000000000 +0000
@@ -13,7 +13,6 @@
 #    under the License.
 """RADOS Block Device Driver"""
 
-from __future__ import absolute_import
 import binascii
 import errno
 import json
@@ -31,6 +30,12 @@ from oslo_utils import encodeutils
 from oslo_utils import excutils
 from oslo_utils import fileutils
 from oslo_utils import units
+try:
+    import rados
+    import rbd
+except ImportError:
+    rados = None
+    rbd = None
 import six
 from six.moves import urllib
 
@@ -45,14 +50,6 @@ from cinder.volume import configuration
 from cinder.volume import driver
 from cinder.volume import volume_utils
 
-try:
-    import rados
-    import rbd
-except ImportError:
-    rados = None
-    rbd = None
-
-
 LOG = logging.getLogger(__name__)
 
 RBD_OPTS = [
@@ -69,6 +66,10 @@ RBD_OPTS = [
                default='',  # default determined by librados
                help='Path to the ceph configuration file'),
     cfg.StrOpt('rbd_keyring_conf',
+               deprecated_for_removal=True,
+               deprecated_reason='Use of this option exposes a security '
+                                 'vulnerability.  See OSSN-0085 for details.',
+               deprecated_since='Ussuri',
                default='',
                help='Path to the ceph keyring file'),
     cfg.BoolOpt('rbd_flatten_volume_from_snapshot',
@@ -204,7 +205,7 @@ class RADOSClient(object):
     def features(self):
         features = self.cluster.conf_get('rbd_default_features')
         if ((features is None) or (int(features) == 0)):
-            features = self.driver.rbd.RBD_FEATURE_LAYERING
+            features = self.driver.RBD_FEATURE_LAYERING
         return int(features)
 
 
@@ -223,6 +224,12 @@ class RBDDriver(driver.CloneableImageVD,
 
     SYSCONFDIR = '/etc/ceph/'
 
+    RBD_FEATURE_LAYERING = 1
+    RBD_FEATURE_EXCLUSIVE_LOCK = 4
+    RBD_FEATURE_OBJECT_MAP = 8
+    RBD_FEATURE_FAST_DIFF = 16
+    RBD_FEATURE_JOURNALING = 64
+
     def __init__(self, active_backend_id=None, *args, **kwargs):
         super(RBDDriver, self).__init__(*args, **kwargs)
         self.configuration.append_config_values(RBD_OPTS)
@@ -247,6 +254,20 @@ class RBDDriver(driver.CloneableImageVD,
         self._replication_targets = []
         self._target_names = []
 
+        if self.rbd is not None:
+            self.RBD_FEATURE_LAYERING = self.rbd.RBD_FEATURE_LAYERING
+            self.RBD_FEATURE_EXCLUSIVE_LOCK = \
+                self.rbd.RBD_FEATURE_EXCLUSIVE_LOCK
+            self.RBD_FEATURE_OBJECT_MAP = self.rbd.RBD_FEATURE_OBJECT_MAP
+            self.RBD_FEATURE_FAST_DIFF = self.rbd.RBD_FEATURE_FAST_DIFF
+            self.RBD_FEATURE_JOURNALING = self.rbd.RBD_FEATURE_JOURNALING
+
+        self.MULTIATTACH_EXCLUSIONS = (
+            self.RBD_FEATURE_JOURNALING |
+            self.RBD_FEATURE_FAST_DIFF |
+            self.RBD_FEATURE_OBJECT_MAP |
+            self.RBD_FEATURE_EXCLUSIVE_LOCK)
+
     @staticmethod
     def get_driver_options():
         return RBD_OPTS
@@ -678,6 +699,7 @@ class RBDDriver(driver.CloneableImageVD,
             except Exception as e:
                 src_volume.unprotect_snap(clone_snap)
                 src_volume.remove_snap(clone_snap)
+                src_volume.close()
                 msg = (_("Failed to clone '%(src_vol)s@%(src_snap)s' to "
                          "'%(dest)s', error: %(error)s") %
                        {'src_vol': src_name,
@@ -686,8 +708,6 @@ class RBDDriver(driver.CloneableImageVD,
                         'error': e})
                 LOG.exception(msg)
                 raise exception.VolumeBackendAPIException(data=msg)
-            finally:
-                src_volume.close()
 
             depth = self._get_clone_depth(client, src_name)
             # If dest volume is a clone and rbd_max_clone_depth reached,
@@ -752,13 +772,13 @@ class RBDDriver(driver.CloneableImageVD,
         vol_name = utils.convert_str(volume.name)
         with RBDVolumeProxy(self, vol_name) as image:
             had_exclusive_lock = (image.features() &
-                                  self.rbd.RBD_FEATURE_EXCLUSIVE_LOCK)
-            had_journaling = image.features() & self.rbd.RBD_FEATURE_JOURNALING
+                                  self.RBD_FEATURE_EXCLUSIVE_LOCK)
+            had_journaling = image.features() & self.RBD_FEATURE_JOURNALING
             if not had_exclusive_lock:
-                image.update_features(self.rbd.RBD_FEATURE_EXCLUSIVE_LOCK,
+                image.update_features(self.RBD_FEATURE_EXCLUSIVE_LOCK,
                                       True)
             if not had_journaling:
-                image.update_features(self.rbd.RBD_FEATURE_JOURNALING, True)
+                image.update_features(self.RBD_FEATURE_JOURNALING, True)
             image.mirror_image_enable()
 
         driver_data = self._dumps({
@@ -769,53 +789,49 @@ class RBDDriver(driver.CloneableImageVD,
                 'replication_driver_data': driver_data}
 
     def _enable_multiattach(self, volume):
-        multipath_feature_exclusions = [
-            self.rbd.RBD_FEATURE_JOURNALING,
-            self.rbd.RBD_FEATURE_FAST_DIFF,
-            self.rbd.RBD_FEATURE_OBJECT_MAP,
-            self.rbd.RBD_FEATURE_EXCLUSIVE_LOCK,
-        ]
         vol_name = utils.convert_str(volume.name)
-        image_features = None
         with RBDVolumeProxy(self, vol_name) as image:
             image_features = image.features()
-            for feature in multipath_feature_exclusions:
-                if image_features & feature:
-                    image.update_features(feature, False)
+            change_features = self.MULTIATTACH_EXCLUSIONS & image_features
+            image.update_features(change_features, False)
 
         return {'provider_location':
                 self._dumps({'saved_features': image_features})}
 
     def _disable_multiattach(self, volume):
-        multipath_feature_exclusions = [
-            self.rbd.RBD_FEATURE_EXCLUSIVE_LOCK,
-            self.rbd.RBD_FEATURE_OBJECT_MAP,
-            self.rbd.RBD_FEATURE_FAST_DIFF,
-            self.rbd.RBD_FEATURE_JOURNALING,
-        ]
         vol_name = utils.convert_str(volume.name)
         with RBDVolumeProxy(self, vol_name) as image:
             try:
                 provider_location = json.loads(volume.provider_location)
                 image_features = provider_location['saved_features']
-            except Exception:
-                msg = _('Could not find saved image features.')
+                change_features = self.MULTIATTACH_EXCLUSIONS & image_features
+                image.update_features(change_features, True)
+            except IndexError:
+                msg = "Could not find saved image features."
+                raise RBDDriverException(reason=msg)
+            except self.rbd.InvalidArgument:
+                msg = "Failed to restore image features."
                 raise RBDDriverException(reason=msg)
-            for feature in multipath_feature_exclusions:
-                if image_features & feature:
-                    image.update_features(feature, True)
 
         return {'provider_location': None}
 
     def _is_replicated_type(self, volume_type):
-        # We do a safe attribute get because volume_type could be None
-        specs = getattr(volume_type, 'extra_specs', {})
-        return specs.get(EXTRA_SPECS_REPL_ENABLED) == "<is> True"
+        try:
+            extra_specs = volume_type.extra_specs
+            LOG.debug('extra_specs: %s', extra_specs)
+            return extra_specs.get(EXTRA_SPECS_REPL_ENABLED) == "<is> True"
+        except Exception:
+            LOG.debug('Unable to retrieve extra specs info')
+            return False
 
     def _is_multiattach_type(self, volume_type):
-        # We do a safe attribute get because volume_type could be None
-        specs = getattr(volume_type, 'extra_specs', {})
-        return specs.get(EXTRA_SPECS_MULTIATTACH) == "<is> True"
+        try:
+            extra_specs = volume_type.extra_specs
+            LOG.debug('extra_specs: %s', extra_specs)
+            return extra_specs.get(EXTRA_SPECS_MULTIATTACH) == "<is> True"
+        except Exception:
+            LOG.debug('Unable to retrieve extra specs info')
+            return False
 
     def _setup_volume(self, volume, volume_type=None):
 
@@ -1224,10 +1240,9 @@ class RBDDriver(driver.CloneableImageVD,
             # they will be disabled here. If not, it will keep
             # what it was before.
             if not driver_data['had_journaling']:
-                image.update_features(self.rbd.RBD_FEATURE_JOURNALING, False)
+                image.update_features(self.RBD_FEATURE_JOURNALING, False)
             if not driver_data['had_exclusive_lock']:
-                image.update_features(self.rbd.RBD_FEATURE_EXCLUSIVE_LOCK,
-                                      False)
+                image.update_features(self.RBD_FEATURE_EXCLUSIVE_LOCK, False)
         return {'replication_status': fields.ReplicationStatus.DISABLED,
                 'replication_driver_data': None}
 
@@ -1582,6 +1597,9 @@ class RBDDriver(driver.CloneableImageVD,
                                              volume_id=volume.id)
 
     def copy_volume_to_image(self, context, volume, image_service, image_meta):
+        # retrieve store information from extra-specs
+        store_id = volume.volume_type.extra_specs.get('image_service:store_id')
+
         tmp_dir = volume_utils.image_conversion_dir()
         tmp_file = os.path.join(tmp_dir,
                                 volume.name + '-' + image_meta['id'])
@@ -1592,7 +1610,8 @@ class RBDDriver(driver.CloneableImageVD,
             args.extend(self._ceph_args())
             self._try_execute(*args)
             image_utils.upload_volume(context, image_service,
-                                      image_meta, tmp_file)
+                                      image_meta, tmp_file,
+                                      store_id=store_id)
         os.unlink(tmp_file)
 
     def extend_volume(self, volume, new_size):
diff -pruN 2:15.0.1-1/cinder/volume/drivers/remotefs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/remotefs.py
--- 2:15.0.1-1/cinder/volume/drivers/remotefs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/remotefs.py	2020-03-24 18:46:31.000000000 +0000
@@ -106,7 +106,7 @@ CONF.register_opts(nas_opts, group=confi
 CONF.register_opts(volume_opts, group=configuration.SHARED_CONF_GROUP)
 
 
-def locked_volume_id_operation(f, external=False):
+def locked_volume_id_operation(f):
     """Lock decorator for volume operations.
 
        Takes a named lock prior to executing the operation. The lock is named
@@ -130,7 +130,7 @@ def locked_volume_id_operation(f, extern
             raise exception.VolumeBackendAPIException(data=err_msg)
 
         @utils.synchronized('%s-%s' % (lock_tag, volume_id),
-                            external=external)
+                            external=False)
         def lvo_inner2():
             return f(inst, *args, **kwargs)
         return lvo_inner2()
@@ -141,7 +141,7 @@ class BackingFileTemplate(string.Templat
     """Custom Template for substitutions in backing files regex strings
 
         Changes the default delimiter from '$' to '#' in order to prevent
-        clashing with the the regex end of line marker '$'.
+        clashing with the regex end of line marker '$'.
     """
     delimiter = '#'
     idpattern = r'[a-z][_a-z0-9]*'
@@ -474,11 +474,13 @@ class RemoteFSDriver(driver.BaseVD):
 
     def copy_volume_to_image(self, context, volume, image_service, image_meta):
         """Copy the volume to the specified image."""
+        store_id = volume.volume_type.extra_specs.get('image_service:store_id')
         image_utils.upload_volume(context,
                                   image_service,
                                   image_meta,
                                   self.local_path(volume),
-                                  run_as_root=self._execute_as_root)
+                                  run_as_root=self._execute_as_root,
+                                  store_id=store_id)
 
     def _read_config_file(self, config_file):
         # Returns list of lines in file
@@ -945,7 +947,7 @@ class RemoteFSSnapDriverBase(RemoteFSDri
         return self.base
 
     def _copy_volume_to_image(self, context, volume, image_service,
-                              image_meta):
+                              image_meta, store_id=None):
         """Copy the volume to the specified image."""
 
         # If snapshots exist, flatten to a temporary image, and upload it
@@ -973,11 +975,15 @@ class RemoteFSSnapDriverBase(RemoteFSDri
             else:
                 upload_path = active_file_path
 
+            if not store_id:
+                store_id = volume.volume_type.extra_specs.get(
+                    'image_service:store_id')
             image_utils.upload_volume(context,
                                       image_service,
                                       image_meta,
                                       upload_path,
-                                      run_as_root=self._execute_as_root)
+                                      run_as_root=self._execute_as_root,
+                                      store_id=store_id)
 
     def get_active_image_from_info(self, volume):
         """Returns filename of the active image from the info file."""
diff -pruN 2:15.0.1-1/cinder/volume/drivers/rsd.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/rsd.py
--- 2:15.0.1-1/cinder/volume/drivers/rsd.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/rsd.py	2020-03-24 18:46:31.000000000 +0000
@@ -10,25 +10,14 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 
-"""
-Driver for RackScale Design.
-
-"""
+"""Driver for RackScale Design."""
 
+from distutils import version
 import json
 
 from oslo_config import cfg
 from oslo_log import log as logging
 from oslo_utils import units
-
-from cinder import exception
-from cinder.i18n import _
-from cinder import interface
-from cinder import utils
-from cinder.volume import driver
-
-from distutils import version
-
 try:
     from rsd_lib import RSDLib
     from sushy import exceptions as sushy_exceptions
@@ -37,6 +26,12 @@ except ImportError:
     RSDLib = None
     sushy_exceptions = None
 
+from cinder import exception
+from cinder.i18n import _
+from cinder import interface
+from cinder import utils
+from cinder.volume import driver
+
 LOG = logging.getLogger(__name__)
 
 RSD_OPTS = [
@@ -417,7 +412,7 @@ class RSDClient(object):
                     detail=(_("Volume %s already attached") % volume_url))
 
             node.attach_endpoint(volume.path)
-        except sushy_exceptions.InvalidParameterValueError as e:
+        except sushy_exceptions.InvalidParameterValueError:
             LOG.exception("Attach volume failed (not allowable)")
             raise RSDRetryableException(
                 reason=(_("Not allowed to attach from "
diff -pruN 2:15.0.1-1/cinder/volume/drivers/sheepdog.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/sheepdog.py
--- 2:15.0.1-1/cinder/volume/drivers/sheepdog.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/sheepdog.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,661 +0,0 @@
-#    Copyright 2012 OpenStack Foundation
-#    Copyright (c) 2013 Zelin.io
-#    Copyright (C) 2015 Nippon Telegraph and Telephone Corporation.
-#    All Rights Reserved.
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-
-"""
-SheepDog Volume Driver.
-
-"""
-import errno
-import eventlet
-import io
-import random
-import re
-
-from oslo_concurrency import processutils
-from oslo_config import cfg
-from oslo_log import log as logging
-from oslo_utils import excutils
-from oslo_utils import units
-
-from cinder import exception
-from cinder.i18n import _
-from cinder.image import image_utils
-from cinder import interface
-from cinder import utils
-from cinder.volume import configuration
-from cinder.volume import driver
-
-
-LOG = logging.getLogger(__name__)
-
-sheepdog_opts = [
-    cfg.StrOpt('sheepdog_store_address',
-               default='127.0.0.1',
-               help=('IP address of sheep daemon.')),
-    cfg.PortOpt('sheepdog_store_port',
-                default=7000,
-                help=('Port of sheep daemon.'))
-]
-
-CONF = cfg.CONF
-CONF.import_opt("image_conversion_dir", "cinder.image.image_utils")
-CONF.register_opts(sheepdog_opts, group=configuration.SHARED_CONF_GROUP)
-
-
-class SheepdogError(exception.VolumeBackendAPIException):
-    message = _("An error has occurred in SheepdogDriver. "
-                "(Reason: %(reason)s)")
-
-
-class SheepdogCmdError(SheepdogError):
-    message = _("(Command: %(cmd)s) "
-                "(Return Code: %(exit_code)s) "
-                "(Stdout: %(stdout)s) "
-                "(Stderr: %(stderr)s)")
-
-
-class SheepdogClient(object):
-    """Sheepdog command executor."""
-
-    QEMU_SHEEPDOG_PREFIX = 'sheepdog:'
-    DOG_RESP_CONNECTION_ERROR = 'failed to connect to'
-    DOG_RESP_CLUSTER_RUNNING = 'Cluster status: running'
-    DOG_RESP_CLUSTER_NOT_FORMATTED = ('Cluster status: '
-                                      'Waiting for cluster to be formatted')
-    DOG_RESP_CLUSTER_WAITING = ('Cluster status: '
-                                'Waiting for other nodes to join cluster')
-    DOG_RESP_VDI_ALREADY_EXISTS = ': VDI exists already'
-    DOG_RESP_VDI_NOT_FOUND = ': No VDI found'
-    DOG_RESP_VDI_SHRINK_NOT_SUPPORT = 'Shrinking VDIs is not implemented'
-    DOG_RESP_VDI_SIZE_TOO_LARGE = 'New VDI size is too large'
-    DOG_RESP_SNAPSHOT_VDI_NOT_FOUND = ': No VDI found'
-    DOG_RESP_SNAPSHOT_NOT_FOUND = ': Failed to find requested tag'
-    DOG_RESP_SNAPSHOT_EXISTED = 'tag (%(snapname)s) is existed'
-    QEMU_IMG_RESP_CONNECTION_ERROR = ('Failed to connect socket: '
-                                      'Connection refused')
-    QEMU_IMG_RESP_ALREADY_EXISTS = ': VDI exists already'
-    QEMU_IMG_RESP_SNAPSHOT_NOT_FOUND = 'Failed to find the requested tag'
-    QEMU_IMG_RESP_VDI_NOT_FOUND = 'No vdi found'
-    QEMU_IMG_RESP_SIZE_TOO_LARGE = 'An image is too large.'
-
-    def __init__(self, node_list, port):
-        self.node_list = node_list
-        self.port = port
-
-    def get_addr(self):
-        """Get a random node in sheepdog cluster."""
-        return self.node_list[random.randint(0, len(self.node_list) - 1)]
-
-    def local_path(self, volume):
-        """Return a sheepdog location path."""
-        return "sheepdog:%(addr)s:%(port)s:%(name)s" % {
-            'addr': self.get_addr(),
-            'port': self.port,
-            'name': volume['name']}
-
-    def _run_dog(self, command, subcommand, *params):
-        """Execute dog command wrapper."""
-        addr = self.get_addr()
-        cmd = ('env', 'LC_ALL=C', 'LANG=C', 'dog', command, subcommand,
-               '-a', addr, '-p', self.port) + params
-        try:
-            (_stdout, _stderr) = utils.execute(*cmd)
-            if _stderr.startswith(self.DOG_RESP_CONNECTION_ERROR):
-                # NOTE(tishizaki)
-                # Dog command does not return error_code although
-                # dog command cannot connect to sheep process.
-                # That is a Sheepdog's bug.
-                # To avoid a Sheepdog's bug, now we need to check stderr.
-                # If Sheepdog has been fixed, this check logic is needed
-                # by old Sheepdog users.
-                reason = (_('Failed to connect to sheep daemon. '
-                          'addr: %(addr)s, port: %(port)s'),
-                          {'addr': addr, 'port': self.port})
-                raise SheepdogError(reason=reason)
-            return (_stdout, _stderr)
-        except OSError as e:
-            with excutils.save_and_reraise_exception():
-                if e.errno == errno.ENOENT:
-                    msg = 'Sheepdog is not installed. OSError: command is %s.'
-                else:
-                    msg = 'OSError: command is %s.'
-                LOG.error(msg, cmd)
-        except processutils.ProcessExecutionError as e:
-            _stderr = e.stderr
-            if _stderr.startswith(self.DOG_RESP_CONNECTION_ERROR):
-                reason = (_('Failed to connect to sheep daemon. '
-                          'addr: %(addr)s, port: %(port)s'),
-                          {'addr': addr, 'port': self.port})
-                raise SheepdogError(reason=reason)
-            raise SheepdogCmdError(
-                cmd=e.cmd,
-                exit_code=e.exit_code,
-                stdout=e.stdout.replace('\n', '\\n'),
-                stderr=e.stderr.replace('\n', '\\n'))
-
-    def _run_qemu_img(self, command, *params):
-        """Executes qemu-img command wrapper."""
-        addr = self.get_addr()
-        cmd = ['env', 'LC_ALL=C', 'LANG=C', 'qemu-img', command]
-        for param in params:
-            if param.startswith(self.QEMU_SHEEPDOG_PREFIX):
-                # replace 'sheepdog:vdiname[:snapshotname]' to
-                #         'sheepdog:addr:port:vdiname[:snapshotname]'
-                param = param.replace(self.QEMU_SHEEPDOG_PREFIX,
-                                      '%(prefix)s%(addr)s:%(port)s:' %
-                                      {'prefix': self.QEMU_SHEEPDOG_PREFIX,
-                                       'addr': addr, 'port': self.port},
-                                      1)
-            cmd.append(param)
-        try:
-            return utils.execute(*cmd)
-        except OSError as e:
-            with excutils.save_and_reraise_exception():
-                if e.errno == errno.ENOENT:
-                    msg = ('Qemu-img is not installed. OSError: command is '
-                           '%(cmd)s.')
-                else:
-                    msg = 'OSError: command is %(cmd)s.'
-                LOG.error(msg, {'cmd': tuple(cmd)})
-        except processutils.ProcessExecutionError as e:
-            _stderr = e.stderr
-            if self.QEMU_IMG_RESP_CONNECTION_ERROR in _stderr:
-                reason = (_('Failed to connect to sheep daemon. '
-                            'addr: %(addr)s, port: %(port)s'),
-                          {'addr': addr, 'port': self.port})
-                raise SheepdogError(reason=reason)
-            raise SheepdogCmdError(
-                cmd=e.cmd,
-                exit_code=e.exit_code,
-                stdout=e.stdout.replace('\n', '\\n'),
-                stderr=e.stderr.replace('\n', '\\n'))
-
-    def check_cluster_status(self):
-        try:
-            (_stdout, _stderr) = self._run_dog('cluster', 'info')
-        except SheepdogCmdError as e:
-            cmd = e.kwargs['cmd']
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to check cluster status.'
-                          '(command: %s)', cmd)
-
-        if _stdout.startswith(self.DOG_RESP_CLUSTER_RUNNING):
-            LOG.debug('Sheepdog cluster is running.')
-            return
-
-        reason = _('Invalid sheepdog cluster status.')
-        if _stdout.startswith(self.DOG_RESP_CLUSTER_NOT_FORMATTED):
-            reason = _('Cluster is not formatted. '
-                       'You should probably perform "dog cluster format".')
-        elif _stdout.startswith(self.DOG_RESP_CLUSTER_WAITING):
-            reason = _('Waiting for all nodes to join cluster. '
-                       'Ensure all sheep daemons are running.')
-        raise SheepdogError(reason=reason)
-
-    def create(self, vdiname, size):
-        try:
-            self._run_dog('vdi', 'create', vdiname, '%sG' % size)
-        except SheepdogCmdError as e:
-            _stderr = e.kwargs['stderr']
-            with excutils.save_and_reraise_exception():
-                if _stderr.rstrip('\\n').endswith(
-                        self.DOG_RESP_VDI_ALREADY_EXISTS):
-                    LOG.error('Volume already exists. %s', vdiname)
-                else:
-                    LOG.error('Failed to create volume. %s', vdiname)
-
-    def delete(self, vdiname):
-        try:
-            (_stdout, _stderr) = self._run_dog('vdi', 'delete', vdiname)
-            if _stderr.rstrip().endswith(self.DOG_RESP_VDI_NOT_FOUND):
-                LOG.warning('Volume not found. %s', vdiname)
-        except SheepdogCmdError as e:
-            _stderr = e.kwargs['stderr']
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to delete volume. %s', vdiname)
-
-    def create_snapshot(self, vdiname, snapname):
-        try:
-            self._run_dog('vdi', 'snapshot', '-s', snapname, vdiname)
-        except SheepdogCmdError as e:
-            cmd = e.kwargs['cmd']
-            _stderr = e.kwargs['stderr']
-            with excutils.save_and_reraise_exception():
-                if _stderr.rstrip('\\n').endswith(
-                        self.DOG_RESP_SNAPSHOT_VDI_NOT_FOUND):
-                    LOG.error('Volume "%s" not found. Please check the '
-                              'results of "dog vdi list".',
-                              vdiname)
-                elif _stderr.rstrip('\\n').endswith(
-                        self.DOG_RESP_SNAPSHOT_EXISTED %
-                        {'snapname': snapname}):
-                    LOG.error('Snapshot "%s" already exists.', snapname)
-                else:
-                    LOG.error('Failed to create snapshot. (command: %s)',
-                              cmd)
-
-    def delete_snapshot(self, vdiname, snapname):
-        try:
-            (_stdout, _stderr) = self._run_dog('vdi', 'delete', '-s',
-                                               snapname, vdiname)
-            if _stderr.rstrip().endswith(self.DOG_RESP_SNAPSHOT_NOT_FOUND):
-                LOG.warning('Snapshot "%s" not found.', snapname)
-            elif _stderr.rstrip().endswith(self.DOG_RESP_VDI_NOT_FOUND):
-                LOG.warning('Volume "%s" not found.', vdiname)
-        except SheepdogCmdError as e:
-            cmd = e.kwargs['cmd']
-            _stderr = e.kwargs['stderr']
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to delete snapshot. (command: %s)',
-                          cmd)
-
-    def clone(self, src_vdiname, src_snapname, dst_vdiname, size):
-        try:
-            self._run_qemu_img('create', '-b',
-                               'sheepdog:%(src_vdiname)s:%(src_snapname)s' %
-                               {'src_vdiname': src_vdiname,
-                                'src_snapname': src_snapname},
-                               'sheepdog:%s' % dst_vdiname, '%sG' % size)
-        except SheepdogCmdError as e:
-            cmd = e.kwargs['cmd']
-            _stderr = e.kwargs['stderr']
-            with excutils.save_and_reraise_exception():
-                if self.QEMU_IMG_RESP_ALREADY_EXISTS in _stderr:
-                    LOG.error('Clone volume "%s" already exists. '
-                              'Please check the results of "dog vdi list".',
-                              dst_vdiname)
-                elif self.QEMU_IMG_RESP_VDI_NOT_FOUND in _stderr:
-                    LOG.error('Src Volume "%s" not found. '
-                              'Please check the results of "dog vdi list".',
-                              src_vdiname)
-                elif self.QEMU_IMG_RESP_SNAPSHOT_NOT_FOUND in _stderr:
-                    LOG.error('Snapshot "%s" not found. '
-                              'Please check the results of "dog vdi list".',
-                              src_snapname)
-                elif self.QEMU_IMG_RESP_SIZE_TOO_LARGE in _stderr:
-                    LOG.error('Volume size "%sG" is too large.', size)
-                else:
-                    LOG.error('Failed to clone volume.(command: %s)', cmd)
-
-    def resize(self, vdiname, size):
-        size = int(size) * units.Gi
-        try:
-            (_stdout, _stderr) = self._run_dog('vdi', 'resize', vdiname, size)
-        except SheepdogCmdError as e:
-            _stderr = e.kwargs['stderr']
-            with excutils.save_and_reraise_exception():
-                if _stderr.rstrip('\\n').endswith(
-                        self.DOG_RESP_VDI_NOT_FOUND):
-                    LOG.error('Failed to resize vdi. vdi not found. %s',
-                              vdiname)
-                elif _stderr.startswith(self.DOG_RESP_VDI_SHRINK_NOT_SUPPORT):
-                    LOG.error('Failed to resize vdi. '
-                              'Shrinking vdi not supported. '
-                              'vdi: %(vdiname)s new size: %(size)s',
-                              {'vdiname': vdiname, 'size': size})
-                elif _stderr.startswith(self.DOG_RESP_VDI_SIZE_TOO_LARGE):
-                    LOG.error('Failed to resize vdi. '
-                              'Too large volume size. '
-                              'vdi: %(vdiname)s new size: %(size)s',
-                              {'vdiname': vdiname, 'size': size})
-                else:
-                    LOG.error('Failed to resize vdi. '
-                              'vdi: %(vdiname)s new size: %(size)s',
-                              {'vdiname': vdiname, 'size': size})
-
-    def get_volume_stats(self):
-        try:
-            (_stdout, _stderr) = self._run_dog('node', 'info', '-r')
-        except SheepdogCmdError as e:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to get volume status. %s', e)
-        return _stdout
-
-    def get_vdi_info(self, vdiname):
-        # Get info of the specified vdi.
-        try:
-            (_stdout, _stderr) = self._run_dog('vdi', 'list', vdiname, '-r')
-        except SheepdogCmdError as e:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to get vdi info. %s', e)
-        return _stdout
-
-    def update_node_list(self):
-        try:
-            (_stdout, _stderr) = self._run_dog('node', 'list', '-r')
-        except SheepdogCmdError as e:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to get node list. %s', e)
-        node_list = []
-        stdout = _stdout.strip('\n')
-        for line in stdout.split('\n'):
-            node_list.append(line.split()[1].split(':')[0])
-        self.node_list = node_list
-
-
-class SheepdogIOWrapper(io.RawIOBase):
-    """File-like object with Sheepdog backend."""
-
-    def __init__(self, addr, port, volume, snapshot_name=None):
-        self._addr = addr
-        self._port = port
-        self._vdiname = volume['name']
-        self._snapshot_name = snapshot_name
-        self._offset = 0
-        # SheepdogIOWrapper instance becomes invalid if a write error occurs.
-        self._valid = True
-
-    def _execute(self, cmd, data=None):
-        try:
-            # NOTE(yamada-h): processutils.execute causes busy waiting
-            # under eventlet.
-            # To avoid wasting CPU resources, it should not be used for
-            # the command which takes long time to execute.
-            # For workaround, we replace a subprocess module with
-            # the original one while only executing a read/write command.
-            _processutils_subprocess = processutils.subprocess
-            processutils.subprocess = eventlet.patcher.original('subprocess')
-            return processutils.execute(*cmd, process_input=data)[0]
-        except (processutils.ProcessExecutionError, OSError):
-            self._valid = False
-            msg = _('Sheepdog I/O Error, command was: "%s".') % ' '.join(cmd)
-            raise exception.VolumeDriverException(message=msg)
-        finally:
-            processutils.subprocess = _processutils_subprocess
-
-    def read(self, length=None):
-        if not self._valid:
-            msg = _('An error occurred while reading volume "%s".'
-                    ) % self._vdiname
-            raise exception.VolumeDriverException(message=msg)
-
-        cmd = ['dog', 'vdi', 'read', '-a', self._addr, '-p', self._port]
-        if self._snapshot_name:
-            cmd.extend(('-s', self._snapshot_name))
-        cmd.extend((self._vdiname, self._offset))
-        if length:
-            cmd.append(length)
-        data = self._execute(cmd)
-        self._offset += len(data)
-        return data
-
-    def write(self, data):
-        if not self._valid:
-            msg = _('An error occurred while writing to volume "%s".'
-                    ) % self._vdiname
-            raise exception.VolumeDriverException(message=msg)
-
-        length = len(data)
-        cmd = ('dog', 'vdi', 'write', '-a', self._addr, '-p', self._port,
-               self._vdiname, self._offset, length)
-        self._execute(cmd, data)
-        self._offset += length
-        return length
-
-    def seek(self, offset, whence=0):
-        if not self._valid:
-            msg = _('An error occurred while seeking for volume "%s".'
-                    ) % self._vdiname
-            raise exception.VolumeDriverException(message=msg)
-
-        if whence == 0:
-            # SEEK_SET or 0 - start of the stream (the default);
-            # offset should be zero or positive
-            new_offset = offset
-        elif whence == 1:
-            # SEEK_CUR or 1 - current stream position; offset may be negative
-            new_offset = self._offset + offset
-        else:
-            # SEEK_END or 2 - end of the stream; offset is usually negative
-            # TODO(yamada-h): Support SEEK_END
-            raise IOError(_("Invalid argument - whence=%s not supported.") %
-                          whence)
-
-        if new_offset < 0:
-            raise IOError(_("Invalid argument - negative seek offset."))
-
-        self._offset = new_offset
-
-    def tell(self):
-        return self._offset
-
-    def flush(self):
-        pass
-
-    def fileno(self):
-        """Sheepdog does not have support for fileno so we raise IOError.
-
-        Raising IOError is recommended way to notify caller that interface is
-        not supported - see http://docs.python.org/2/library/io.html#io.IOBase
-        """
-        raise IOError(_("fileno is not supported by SheepdogIOWrapper"))
-
-
-@interface.volumedriver
-class SheepdogDriver(driver.VolumeDriver):
-    """Executes commands relating to Sheepdog Volumes."""
-
-    VERSION = "1.0.0"
-
-    # ThirdPartySystems wiki page
-    CI_WIKI_NAME = "Cinder_Jenkins"
-
-    # TODO(jsbryant) Remove this driver in the 'U' release as it is no
-    # longer maintained.
-    SUPPORTED = False
-
-    def __init__(self, *args, **kwargs):
-        super(SheepdogDriver, self).__init__(*args, **kwargs)
-        self.configuration.append_config_values(sheepdog_opts)
-        addr = self.configuration.sheepdog_store_address
-        self.port = self.configuration.sheepdog_store_port
-        self.stats_pattern = re.compile(r'[\w\s%]*Total\s(\d+)\s(\d+)*')
-        self._stats = {}
-        self.node_list = [addr]
-        self.client = SheepdogClient(self.node_list, self.port)
-
-    @staticmethod
-    def get_driver_options():
-        return sheepdog_opts
-
-    def check_for_setup_error(self):
-        """Check cluster status and update node list."""
-        self.client.check_cluster_status()
-        self.client.update_node_list()
-
-    def _is_cloneable(self, image_location, image_meta):
-        """Check the image can be clone or not."""
-        if image_location is None:
-            return False
-
-        prefix = 'sheepdog://'
-        if not image_location.startswith(prefix):
-            LOG.debug("Image is not stored in sheepdog.")
-            return False
-
-        if image_meta['disk_format'] != 'raw':
-            LOG.debug("Image clone requires image format to be "
-                      "'raw' but image %s(%s) is '%s'.",
-                      image_location,
-                      image_meta['id'],
-                      image_meta['disk_format'])
-            return False
-
-        # check whether volume is stored in sheepdog
-        # The image location would be like
-        # "sheepdog://192.168.10.2:7000:Alice"
-        (ip, port, name) = image_location[len(prefix):].split(":", 2)
-
-        stdout = self.client.get_vdi_info(name)
-        # Dog command return 0 and has a null output if the volume not exists
-        if stdout:
-            return True
-        else:
-            LOG.debug("Can not find vdi %(image)s, is not cloneable",
-                      {'image': name})
-            return False
-
-    def clone_image(self, context, volume,
-                    image_location, image_meta,
-                    image_service):
-        """Create a volume efficiently from an existing image."""
-        image_location = image_location[0] if image_location else None
-        if not self._is_cloneable(image_location, image_meta):
-            return {}, False
-
-        volume_ref = {'name': image_meta['id'], 'size': image_meta['size']}
-        self.create_cloned_volume(volume, volume_ref)
-        self.client.resize(volume.name, volume.size)
-
-        vol_path = self.client.local_path(volume)
-        return {'provider_location': vol_path}, True
-
-    def create_cloned_volume(self, volume, src_vref):
-        """Clone a sheepdog volume from another volume."""
-        snapshot_name = 'tmp-snap-%s-%s' % (src_vref['name'], volume.id)
-        snapshot = {
-            'name': snapshot_name,
-            'volume_name': src_vref['name'],
-            'volume_size': src_vref['size'],
-        }
-
-        self.client.create_snapshot(snapshot['volume_name'], snapshot_name)
-
-        try:
-            self.client.clone(snapshot['volume_name'], snapshot_name,
-                              volume.name, volume.size)
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.error('Failed to create cloned volume %s.',
-                          volume.name)
-        finally:
-            # Delete temp Snapshot
-            self.client.delete_snapshot(snapshot['volume_name'], snapshot_name)
-
-    def create_volume(self, volume):
-        """Create a sheepdog volume."""
-        self.client.create(volume.name, volume.size)
-
-    def create_volume_from_snapshot(self, volume, snapshot):
-        """Create a sheepdog volume from a snapshot."""
-        self.client.clone(snapshot.volume_name, snapshot.name,
-                          volume.name, volume.size)
-
-    def delete_volume(self, volume):
-        """Delete a logical volume."""
-        self.client.delete(volume.name)
-
-    def copy_image_to_volume(self, context, volume, image_service, image_id):
-        with image_utils.temporary_file() as tmp:
-            # (wenhao): we don't need to convert to raw for sheepdog.
-            image_utils.fetch_verify_image(context, image_service,
-                                           image_id, tmp)
-
-            # remove the image created by import before this function.
-            # see volume/drivers/manager.py:_create_volume
-            self.client.delete(volume.name)
-            # convert and store into sheepdog
-            image_utils.convert_image(tmp, self.client.local_path(volume),
-                                      'raw')
-            self.client.resize(volume.name, volume.size)
-
-    def copy_volume_to_image(self, context, volume, image_service, image_meta):
-        """Copy the volume to the specified image."""
-        image_id = image_meta['id']
-        with image_utils.temporary_file() as tmp:
-            # image_utils.convert_image doesn't support "sheepdog:" source,
-            # so we use the qemu-img directly.
-            # Sheepdog volume is always raw-formatted.
-            cmd = ('qemu-img',
-                   'convert',
-                   '-f', 'raw',
-                   '-t', 'none',
-                   '-O', 'raw',
-                   self.client.local_path(volume),
-                   tmp)
-            self._try_execute(*cmd)
-
-            with open(tmp, 'rb') as image_file:
-                image_service.update(context, image_id, {}, image_file)
-
-    def create_snapshot(self, snapshot):
-        """Create a sheepdog snapshot."""
-        self.client.create_snapshot(snapshot.volume_name, snapshot.name)
-
-    def delete_snapshot(self, snapshot):
-        """Delete a sheepdog snapshot."""
-        self.client.delete_snapshot(snapshot.volume_name, snapshot.name)
-
-    def ensure_export(self, context, volume):
-        """Safely and synchronously recreate an export for a logical volume."""
-        pass
-
-    def create_export(self, context, volume, connector):
-        """Export a volume."""
-        pass
-
-    def remove_export(self, context, volume):
-        """Remove an export for a logical volume."""
-        pass
-
-    def initialize_connection(self, volume, connector):
-        return {
-            'driver_volume_type': 'sheepdog',
-            'data': {
-                'name': volume['name'],
-                'hosts': [self.client.get_addr()],
-                'ports': ["%d" % self.port],
-            }
-        }
-
-    def terminate_connection(self, volume, connector, **kwargs):
-        pass
-
-    def _update_volume_stats(self):
-        stats = {}
-
-        backend_name = "sheepdog"
-        if self.configuration:
-            backend_name = self.configuration.safe_get('volume_backend_name')
-        stats["volume_backend_name"] = backend_name or 'sheepdog'
-        stats['vendor_name'] = 'Open Source'
-        stats['driver_version'] = self.VERSION
-        stats['storage_protocol'] = 'sheepdog'
-        stats['total_capacity_gb'] = 'unknown'
-        stats['free_capacity_gb'] = 'unknown'
-        stats['reserved_percentage'] = 0
-        stats['QoS_support'] = False
-
-        stdout = self.client.get_volume_stats()
-        m = self.stats_pattern.match(stdout)
-        total = float(m.group(1))
-        used = float(m.group(2))
-        stats['total_capacity_gb'] = total / units.Gi
-        stats['free_capacity_gb'] = (total - used) / units.Gi
-
-        self._stats = stats
-
-    def get_volume_stats(self, refresh=False):
-        if refresh:
-            self._update_volume_stats()
-        return self._stats
-
-    def extend_volume(self, volume, new_size):
-        """Extend an Existing Volume."""
-        self.client.resize(volume.name, new_size)
-        LOG.debug('Extend volume from %(old_size)s GB to %(new_size)s GB.',
-                  {'old_size': volume.size, 'new_size': new_size})
diff -pruN 2:15.0.1-1/cinder/volume/drivers/solidfire.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/solidfire.py
--- 2:15.0.1-1/cinder/volume/drivers/solidfire.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/solidfire.py	2020-03-24 18:46:31.000000000 +0000
@@ -2376,8 +2376,8 @@ class SolidFireDriver(san.SanISCSIDriver
         else:
             repl_configs = self.configuration.replication_device[0]
             if secondary_id and repl_configs['backend_id'] != secondary_id:
-                msg = _("Replication id (%s) does not match the configured"
-                        "on cinder.conf.") % secondary_id
+                msg = _("Replication id (%s) does not match the configured "
+                        "one in cinder.conf.") % secondary_id
                 raise exception.InvalidReplicationTarget(msg)
 
             remote = self.cluster_pairs[0]
@@ -2407,7 +2407,7 @@ class SolidFireDriver(san.SanISCSIDriver
         for v in volumes:
             if v['status'] == "error":
                 LOG.debug("Skipping operation for Volume %s as it is "
-                          "on error state.")
+                          "on error state.", v['id'])
                 continue
 
             target_vlist = [sfv for sfv in target_vols
diff -pruN 2:15.0.1-1/cinder/volume/drivers/spdk.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/spdk.py
--- 2:15.0.1-1/cinder/volume/drivers/spdk.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/spdk.py	2020-03-24 18:46:31.000000000 +0000
@@ -92,7 +92,7 @@ class SPDKDriver(driver.VolumeDriver):
         pools_status = []
         self.lvs = []
 
-        output = self._rpc_call('get_lvol_stores')
+        output = self._rpc_call('bdev_lvol_get_lvstores')
         if output:
             for lvs in output:
                 pool = {}
@@ -128,14 +128,14 @@ class SPDKDriver(driver.VolumeDriver):
                       lvs['free_size'])
 
     def _get_spdk_volume_name(self, name):
-        output = self._rpc_call('get_bdevs')
+        output = self._rpc_call('bdev_get_bdevs')
         for bdev in output:
             for alias in bdev['aliases']:
                 if name in alias:
                     return bdev['name']
 
     def _get_spdk_lvs_uuid(self, spdk_name):
-        output = self._rpc_call('get_bdevs')
+        output = self._rpc_call('bdev_get_bdevs')
         for bdev in output:
             if spdk_name in bdev['name']:
                 return bdev['driver_specific']['lvol']['lvol_store_uuid']
@@ -153,13 +153,13 @@ class SPDKDriver(driver.VolumeDriver):
         spdk_name = self._get_spdk_volume_name(name)
         if spdk_name is not None:
             params = {'name': spdk_name}
-            self._rpc_call('destroy_lvol_bdev', params)
+            self._rpc_call('bdev_lvol_delete', params)
             LOG.debug('SPDK bdev %s deleted', spdk_name)
         else:
             LOG.debug('Could not find volume %s using SPDK driver', name)
 
     def _create_volume(self, volume, snapshot=None):
-        output = self._rpc_call('get_lvol_stores')
+        output = self._rpc_call('bdev_lvol_get_lvstores')
         for lvs in output:
             free_size = (lvs['free_clusters'] * lvs['cluster_size'])
             if free_size / units.Gi >= volume.size:
@@ -168,22 +168,22 @@ class SPDKDriver(driver.VolumeDriver):
                         'lvol_name': volume.name,
                         'size': volume.size * units.Gi,
                         'uuid': lvs['uuid']}
-                    output2 = self._rpc_call('construct_lvol_bdev', params)
+                    output2 = self._rpc_call('bdev_lvol_create', params)
                 else:
                     snapshot_spdk_name = (
                         self._get_spdk_volume_name(snapshot.name))
                     params = {
                         'clone_name': volume.name,
                         'snapshot_name': snapshot_spdk_name}
-                    output2 = self._rpc_call('clone_lvol_bdev', params)
+                    output2 = self._rpc_call('bdev_lvol_clone', params)
                     spdk_name = self._get_spdk_volume_name(volume.name)
                     params = {'name': spdk_name}
-                    self._rpc_call('inflate_lvol_bdev', params)
+                    self._rpc_call('bdev_lvol_inflate', params)
 
                     if volume.size > snapshot.volume_size:
                         params = {'name': spdk_name,
                                   'size': volume.size * units.Gi}
-                        self._rpc_call('resize_lvol_bdev', params)
+                        self._rpc_call('bdev_lvol_resize', params)
 
                 LOG.debug('SPDK created lvol: %s', output2)
 
@@ -196,7 +196,7 @@ class SPDKDriver(driver.VolumeDriver):
 
     def do_setup(self, context):
         try:
-            payload = {'method': 'get_bdevs', 'jsonrpc': '2.0', 'id': 1}
+            payload = {'method': 'bdev_get_bdevs', 'jsonrpc': '2.0', 'id': 1}
             self.url = ('http://%(ip)s:%(port)s/' %
                         {'ip': self.configuration.spdk_rpc_ip,
                          'port': self.configuration.spdk_rpc_port})
@@ -217,7 +217,7 @@ class SPDKDriver(driver.VolumeDriver):
         """Verify that requirements are in place to use LVM driver."""
 
         # If configuration is incorrect we will get exception here
-        self._rpc_call('get_bdevs')
+        self._rpc_call('bdev_get_bdevs')
 
     def create_volume(self, volume):
         """Creates a logical volume."""
@@ -269,10 +269,10 @@ class SPDKDriver(driver.VolumeDriver):
         params = {
             'lvol_name': spdk_name,
             'snapshot_name': snapshot['name']}
-        self._rpc_call('snapshot_lvol_bdev', params)
+        self._rpc_call('bdev_lvol_snapshot', params)
 
         params = {'name': spdk_name}
-        self._rpc_call('inflate_lvol_bdev', params)
+        self._rpc_call('bdev_lvol_inflate', params)
 
     def delete_snapshot(self, snapshot):
         """Deletes a snapshot."""
@@ -281,12 +281,12 @@ class SPDKDriver(driver.VolumeDriver):
             return
 
         params = {'name': spdk_name}
-        bdev = self._rpc_call('get_bdevs', params)
+        bdev = self._rpc_call('bdev_get_bdevs', params)
         if 'clones' in bdev[0]['driver_specific']['lvol']:
             for clone in bdev[0]['driver_specific']['lvol']['clones']:
                 spdk_name = self._get_spdk_volume_name(clone)
                 params = {'name': spdk_name}
-                self._rpc_call('inflate_lvol_bdev', params)
+                self._rpc_call('bdev_lvol_inflate', params)
 
         self._delete_bdev(snapshot.name)
 
@@ -306,21 +306,21 @@ class SPDKDriver(driver.VolumeDriver):
         params = {
             'lvol_name': spdk_name,
             'snapshot_name': snapshot_name}
-        self._rpc_call('snapshot_lvol_bdev', params)
+        self._rpc_call('bdev_lvol_snapshot', params)
 
         params = {'name': spdk_name}
-        self._rpc_call('inflate_lvol_bdev', params)
+        self._rpc_call('bdev_lvol_inflate', params)
 
         snapshot_spdk_name = self._get_spdk_volume_name(snapshot_name)
         params = {
             'clone_name': volume.name,
             'snapshot_name': snapshot_spdk_name}
 
-        self._rpc_call('clone_lvol_bdev', params)
+        self._rpc_call('bdev_lvol_clone', params)
 
         spdk_name = self._get_spdk_volume_name(volume.name)
         params = {'name': spdk_name}
-        self._rpc_call('inflate_lvol_bdev', params)
+        self._rpc_call('bdev_lvol_inflate', params)
 
         self._delete_bdev(snapshot_name)
 
@@ -358,7 +358,8 @@ class SPDKDriver(driver.VolumeDriver):
 
     def copy_volume_to_image(self, context, volume, image_service, image_meta):
         """Copy the volume to the specified image."""
-
+        # retrieve store information from extra-specs
+        store_id = volume.volume_type.extra_specs.get('image_service:store_id')
         volume['provider_location'] = (
             self.create_export(context, volume, None)['provider_location'])
         connection_data = self.initialize_connection(volume, None)['data']
@@ -378,7 +379,8 @@ class SPDKDriver(driver.VolumeDriver):
             image_utils.upload_volume(context,
                                       image_service,
                                       image_meta,
-                                      device_info['path'])
+                                      device_info['path'],
+                                      store_id=store_id)
 
         finally:
             target_connector.disconnect_volume(connection_data, volume)
@@ -387,7 +389,7 @@ class SPDKDriver(driver.VolumeDriver):
         """Extend an existing volume's size."""
         spdk_name = self._get_spdk_volume_name(volume.name)
         params = {'name': spdk_name, 'size': new_size * units.Gi}
-        self._rpc_call('resize_lvol_bdev', params)
+        self._rpc_call('bdev_lvol_resize', params)
 
     # #######  Interface methods for DataPath (Target Driver) ########
     def ensure_export(self, context, volume):
diff -pruN 2:15.0.1-1/cinder/volume/drivers/storpool.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/storpool.py
--- 2:15.0.1-1/cinder/volume/drivers/storpool.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/storpool.py	2020-03-24 18:46:31.000000000 +0000
@@ -28,6 +28,7 @@ import six
 from cinder import exception
 from cinder.i18n import _
 from cinder import interface
+from cinder.volume import configuration
 from cinder.volume import driver
 from cinder.volume import volume_types
 
@@ -54,7 +55,7 @@ storpool_opts = [
 ]
 
 CONF = cfg.CONF
-CONF.register_opts(storpool_opts)
+CONF.register_opts(storpool_opts, group=configuration.SHARED_CONF_GROUP)
 
 
 class StorPoolConfigurationInvalid(exception.CinderException):
diff -pruN 2:15.0.1-1/cinder/volume/drivers/stx/client.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/stx/client.py
--- 2:15.0.1-1/cinder/volume/drivers/stx/client.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/stx/client.py	2020-03-24 18:46:31.000000000 +0000
@@ -19,7 +19,6 @@ import hashlib
 import math
 import time
 
-from cinder import utils
 from defusedxml import lxml as etree
 from oslo_log import log as logging
 from oslo_utils import strutils
@@ -29,6 +28,7 @@ import six
 
 from cinder import coordination
 from cinder.i18n import _
+from cinder import utils
 import cinder.volume.drivers.stx.exception as stx_exception
 
 LOG = logging.getLogger(__name__)
@@ -120,7 +120,11 @@ class STXClient(object):
 
         url = self._base_url + "/login/" + digest
         try:
-            xml = requests.get(url, verify=self.ssl_verify, timeout=30)
+            if self._protocol == 'https':
+                xml = requests.get(url, verify=self.ssl_verify, timeout=30,
+                                   auth=(self._login, self._password))
+            else:
+                xml = requests.get(url, verify=self.ssl_verify, timeout=30)
         except requests.exceptions.RequestException:
             msg = _("Failed to obtain MC session key")
             LOG.exception(msg)
@@ -392,10 +396,10 @@ class STXClient(object):
                 lun = obj.findtext("PROPERTY[@name='lun']")
                 iid = obj.findtext("PROPERTY[@name='identifier']")
                 if iid in ids:
-                    LOG.debug("volume '{}' is already mapped to {} at lun {}".
-                              format(volume_name, iid, lun))
+                    LOG.debug("volume '%s' is already mapped to %s at lun %s",
+                              volume_name, iid, lun)
                     return int(lun)
-        except Exception as e:
+        except Exception:
             LOG.exception("failed to look up mappings for volume '%s'",
                           volume_name)
             raise
diff -pruN 2:15.0.1-1/cinder/volume/drivers/stx/common.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/stx/common.py
--- 2:15.0.1-1/cinder/volume/drivers/stx/common.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/stx/common.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,16 +14,14 @@
 #    License for the specific language governing permissions and limitations
 #    under the License.
 #
-"""
-Volume driver common utilities for Seagate storage arrays
-"""
+"""Volume driver common utilities for Seagate storage arrays."""
 
 import base64
-import six
 import uuid
 
 from oslo_config import cfg
 from oslo_log import log as logging
+import six
 
 from cinder import exception
 from cinder.i18n import _
diff -pruN 2:15.0.1-1/cinder/volume/drivers/synology/synology_common.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/synology/synology_common.py
--- 2:15.0.1-1/cinder/volume/drivers/synology/synology_common.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/synology/synology_common.py	2020-03-24 18:46:31.000000000 +0000
@@ -890,7 +890,7 @@ class SynoCommon(object):
         if os_name == 'DSM UC':
             return
         elif (os_name == 'DSM' and
-                ((6 > major) or (major is 6 and minor is 0 and hotfix < 2))):
+                ((6 > major) or (major == 6 and minor == 0 and hotfix < 2))):
             m = (_('DS version %s is not supported') %
                  firmware_version)
             raise exception.VolumeDriverException(message=m)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/veritas_access/veritas_iscsi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/veritas_access/veritas_iscsi.py
--- 2:15.0.1-1/cinder/volume/drivers/veritas_access/veritas_iscsi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/veritas_access/veritas_iscsi.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,898 +0,0 @@
-# Copyright 2017 Veritas Technologies LLC.
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-"""
-Veritas Access Driver for ISCSI.
-
-"""
-import ast
-import hashlib
-import json
-from random import randint
-
-from defusedxml import minidom
-from oslo_config import cfg
-from oslo_log import log as logging
-from oslo_service import loopingcall
-from oslo_utils import netutils
-from oslo_utils import strutils
-from oslo_utils import units
-import requests
-import requests.auth
-from six.moves import http_client
-
-from cinder import exception
-from cinder.i18n import _
-from cinder import interface
-from cinder.volume import driver
-from cinder.volume.drivers.san import san
-
-LOG = logging.getLogger(__name__)
-
-
-VA_VOL_OPTS = [
-    cfg.BoolOpt('vrts_lun_sparse',
-                default=True,
-                help='Create sparse Lun.'),
-    cfg.StrOpt('vrts_target_config',
-               default='/etc/cinder/vrts_target.xml',
-               help='VA config file.')
-]
-
-
-CONF = cfg.CONF
-CONF.register_opts(VA_VOL_OPTS)
-
-
-class NoAuth(requests.auth.AuthBase):
-    """This is a 'authentication' handler.
-
-    It exists for use with custom authentication systems, such as the
-    one for the Access API, it simply passes the Authorization header as-is.
-
-    The default authentication handler for requests will clobber the
-    Authorization header.
-    """
-
-    def __call__(self, r):
-        return r
-
-
-@interface.volumedriver
-class ACCESSIscsiDriver(driver.ISCSIDriver):
-    """ACCESS Share Driver.
-
-    Executes commands relating to ACCESS ISCSI.
-    Supports creation of volumes on ACCESS.
-
-    .. code-block:: none
-
-     API version history:
-
-        1.0 - Initial version.
-    """
-
-    VERSION = "1.0"
-    # ThirdPartySytems wiki page
-    CI_WIKI_NAME = "Veritas_Access_CI"
-    DRIVER_VOLUME_TYPE = 'iSCSI'
-    LUN_FOUND_INTERVAL = 30  # seconds
-
-    # TODO(jsbryant) Remove driver in the 'U' release if CI is not fixed.
-    SUPPORTED = False
-
-    def __init__(self, *args, **kwargs):
-        # Parent sets db, host, _execute and base config
-        super(ACCESSIscsiDriver, self).__init__(*args, **kwargs)
-
-        self._va_ip = None
-        self._port = None
-        self._user = None
-        self._pwd = None
-        self.iscsi_port = None
-        self._fs_list_str = '/fs'
-        self._target_list_str = '/iscsi/target/list'
-        self._target_status = '/iscsi/target/status'
-        self._lun_create_str = '/iscsi/lun/create'
-        self._lun_destroy_str = '/iscsi/lun/destroy'
-        self._lun_list_str = '/iscsi/lun/list'
-        self._lun_create_from_snap_str = '/iscsi/lun_from_snap/create'
-        self._snapshot_create_str = '/iscsi/lun/snapshot/create'
-        self._snapshot_destroy_str = '/iscsi/lun/snapshot/destroy'
-        self._snapshot_list_str = '/iscsi/lun/snapshot/list'
-        self._lun_clone_create_str = '/iscsi/lun/clone/create'
-        self._lun_extend_str = '/iscsi/lun/growto'
-        self._lun_shrink_str = '/iscsi/lun/shrinkto'
-        self._lun_getid_str = '/iscsi/lun/getlunid'
-        self._target_map_str = '/iscsi/target/map/add'
-        self._target_list_status = '/iscsi/target/full_list'
-
-        self.configuration.append_config_values(VA_VOL_OPTS)
-        self.configuration.append_config_values(san.san_opts)
-        self.backend_name = (self.configuration.safe_get('volume_'
-                                                         'backend_name') or
-                             'ACCESS_ISCSI')
-        self.verify = (self.configuration.
-                       safe_get('driver_ssl_cert_verify') or False)
-
-        if self.verify:
-            verify_path = (self.configuration.
-                           safe_get('driver_ssl_cert_path') or None)
-            if verify_path:
-                self.verify = verify_path
-
-    @staticmethod
-    def get_driver_options():
-        return VA_VOL_OPTS
-
-    def do_setup(self, context):
-        """Any initialization the volume driver does while starting."""
-        super(ACCESSIscsiDriver, self).do_setup(context)
-
-        required_config = ['san_ip',
-                           'san_login',
-                           'san_password',
-                           'san_api_port']
-
-        for attr in required_config:
-            if not getattr(self.configuration, attr, None):
-                message = (_('config option %s is not set.') % attr)
-                raise exception.InvalidInput(message=message)
-
-        self._va_ip = self.configuration.san_ip
-        self._user = self.configuration.san_login
-        self._pwd = self.configuration.san_password
-        self._port = self.configuration.san_api_port
-        self._sparse_lun_support = self.configuration.vrts_lun_sparse
-        self.target_info_file = self.configuration.vrts_target_config
-        self.iscsi_port = self.configuration.target_port
-        self.session = self._authenticate_access(self._va_ip, self._user,
-                                                 self._pwd)
-
-    def _get_va_lun_name(self, name):
-        length = len(name)
-        index = int(length / 2)
-        name1 = name[:index]
-        name2 = name[index:]
-        crc1 = hashlib.md5(name1.encode('utf-8')).hexdigest()[:5]
-        crc2 = hashlib.md5(name2.encode('utf-8')).hexdigest()[:5]
-        return 'cinder' + '-' + crc1 + '-' + crc2
-
-    def check_for_setup_error(self):
-        """Check if veritas access target is online."""
-        target_list = self._vrts_parse_xml_file(self.target_info_file)
-        if not self._vrts_get_online_targets(target_list):
-            message = ('ACCESSIscsiDriver setup error as '
-                       'no target is online')
-            raise exception.VolumeBackendAPIException(message=message)
-
-    def create_export(self, context, volume, connector):
-        """Driver entry point to get the export info for a new volume."""
-        pass
-
-    def remove_export(self, context, volume):
-        """Driver entry point to remove an export for a volume."""
-        pass
-
-    def ensure_export(self, context, volume):
-        """Driver entry point to get the export info for an existing volume."""
-        pass
-
-    def _vrts_get_iscsi_properties(self, volume, target_name):
-        """Get target and LUN details."""
-        lun_name = self._get_va_lun_name(volume.id)
-
-        data = {}
-        path = self._lun_getid_str
-        provider = '%s:%s' % (self._va_ip, self._port)
-
-        lun_id_list = self._access_api(self.session, provider, path,
-                                       json.dumps(data), 'GET')
-
-        if not lun_id_list:
-            message = _('ACCESSIscsiDriver get LUN ID list '
-                        'operation failed')
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-        for lun in ast.literal_eval(lun_id_list['output']):
-            vrts_lun_name = lun['storage_object'].split('/')[3]
-            if vrts_lun_name == lun_name:
-                lun_id = int(lun['index'])
-
-        target_list = self._vrts_parse_xml_file(self.target_info_file)
-        authentication = False
-        portal_ip = ""
-
-        for target in target_list:
-            if target_name == target['name']:
-                portal_ip = target['portal_ip']
-                if target['auth'] == '1':
-                    auth_user = target['auth_user']
-                    auth_password = target['auth_password']
-                    authentication = True
-                break
-
-        if portal_ip == "":
-            message = (_('ACCESSIscsiDriver initialize_connection '
-                         'failed for %s as no portal ip was found')
-                       % volume.id)
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-        portal_list = portal_ip.split(',')
-
-        target_portal_list = []
-        for ip in portal_list:
-            if netutils.is_valid_ipv6(ip):
-                target_portal_list.append('[%s]:%s' % (ip,
-                                                       str(self.iscsi_port)))
-            else:
-                target_portal_list.append('%s:%s' % (ip, str(self.iscsi_port)))
-
-        iscsi_properties = {}
-        iscsi_properties['target_discovered'] = True
-        iscsi_properties['target_iqn'] = target_name
-        iscsi_properties['target_portal'] = target_portal_list[0]
-        if len(target_portal_list) > 1:
-            iscsi_properties['target_portals'] = target_portal_list
-        iscsi_properties['target_lun'] = lun_id
-        iscsi_properties['volume_id'] = volume.id
-        if authentication:
-            iscsi_properties['auth_username'] = auth_user
-            iscsi_properties['auth_password'] = auth_password
-            iscsi_properties['auth_method'] = 'CHAP'
-
-        return iscsi_properties
-
-    def _get_vrts_lun_list(self):
-        """Get Lun list."""
-        data = {}
-        path = self._lun_list_str
-        provider = '%s:%s' % (self._va_ip, self._port)
-
-        lun_list = self._access_api(self.session, provider, path,
-                                    json.dumps(data), 'GET')
-
-        if not lun_list:
-            message = _('ACCESSIscsiDriver get LUN list '
-                        'operation failed')
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-        return lun_list
-
-    def _vrts_target_initiator_mapping(self, target_name, initiator_name):
-        """Map target to initiator."""
-        path = self._target_map_str
-        provider = '%s:%s' % (self._va_ip, self._port)
-
-        data = {}
-        data["target_name"] = target_name
-        data["initiator_name"] = initiator_name
-
-        result = self._access_api(self.session, provider, path,
-                                  json.dumps(data), 'POST')
-
-        if not result:
-            message = (_('ACCESSIscsiDriver target-initiator mapping '
-                         'failed for target %s')
-                       % target_name)
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-    def initialize_connection(self, volume, connector, initiator_data=None):
-        """Initializes the connection and returns connection info.
-
-        The iscsi driver returns a driver_volume_type of 'iscsi'.
-        the format of the driver data is defined in _vrts_get_iscsi_properties.
-        Example return value::
-
-            {
-                'driver_volume_type': 'iscsi'
-                'data': {
-                    'target_discovered': True,
-                    'target_iqn': 'iqn.2010-10.org.openstack:volume-00000001',
-                    'target_portal': '127.0.0.0.1:3260',
-                    'target_lun': 1,
-                    'volume_id': '12345678-1234-4321-1234-123456789012',
-                }
-            }
-        """
-        lun_name = self._get_va_lun_name(volume.id)
-        target = {'target_name': ''}
-
-        def _inner():
-            lun_list = self._get_vrts_lun_list()
-            for lun in lun_list['output']['output']['luns']:
-                if lun['lun_name'] == lun_name:
-                    target['target_name'] = lun['target_name']
-                    raise loopingcall.LoopingCallDone()
-
-        timer = loopingcall.FixedIntervalWithTimeoutLoopingCall(_inner)
-        try:
-            timer.start(interval=5, timeout=self.LUN_FOUND_INTERVAL).wait()
-        except loopingcall.LoopingCallTimeOut:
-            message = (_('ACCESSIscsiDriver initialize_connection '
-                         'failed for %s as no target was found')
-                       % volume.id)
-
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-        self._vrts_target_initiator_mapping(target['target_name'],
-                                            connector['initiator'])
-
-        iscsi_properties = self._vrts_get_iscsi_properties(
-            volume, target['target_name'])
-
-        return {
-            'driver_volume_type': 'iscsi',
-            'data': iscsi_properties
-        }
-
-    def terminate_connection(self, volume, connector, **kwargs):
-        """Disallow connection from connector."""
-        pass
-
-    def _vrts_parse_xml_file(self, filename):
-        """VRTS target info.
-
-        <VRTS>
-        <VrtsTargets>
-            <Target>
-                <Name>iqn.2017-02.com.veritas:target03</Name>
-                <PortalIP>10.182.174.188</PortalIP>
-            </Target>
-            <Target>
-                <Name>iqn.2017-02.com.veritas:target04</Name>
-                <PortalIP>10.182.174.189</PortalIP>
-            </Target>
-        </VrtsTargets>
-        </VRST>
-
-        :param filename: the configuration file
-        :returns: list
-        """
-        myfile = open(filename, 'r')
-        data = myfile.read()
-        myfile.close()
-        dom = minidom.parseString(data)
-
-        mylist = []
-        target = {}
-
-        try:
-            for trg in dom.getElementsByTagName('Target'):
-                target['name'] = (trg.getElementsByTagName('Name')[0]
-                                  .childNodes[0].nodeValue)
-                target['portal_ip'] = (trg.getElementsByTagName('PortalIP')[0]
-                                       .childNodes[0].nodeValue)
-                target['auth'] = (trg.getElementsByTagName('Authentication')[0]
-                                  .childNodes[0].nodeValue)
-                if target['auth'] == '1':
-                    target['auth_user'] = (trg.getElementsByTagName
-                                           ('Auth_username')[0]
-                                           .childNodes[0].nodeValue)
-                    target['auth_password'] = (trg.getElementsByTagName
-                                               ('Auth_password')[0]
-                                               .childNodes[0].nodeValue)
-
-                mylist.append(target)
-                target = {}
-        except IndexError:
-            pass
-
-        return mylist
-
-    def _vrts_get_fs_list(self):
-        """Get FS list."""
-        path = self._fs_list_str
-        provider = '%s:%s' % (self._va_ip, self._port)
-        data = {}
-        fs_list = self._access_api(self.session, provider, path,
-                                   json.dumps(data), 'GET')
-
-        if not fs_list:
-            message = _('ACCESSIscsiDriver get FS list '
-                        'operation failed')
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-        return fs_list
-
-    def _vrts_get_online_targets(self, available_targets):
-        """Out of available targets get list of targets which are online."""
-
-        online_targets = []
-        path = self._target_list_status
-        provider = '%s:%s' % (self._va_ip, self._port)
-        data = {}
-        target_status_list = self._access_api(self.session, provider, path,
-                                              json.dumps(data), 'GET')
-
-        try:
-            target_status_output = (ast.
-                                    literal_eval(target_status_list['output']))
-        except KeyError:
-            message = _('ACCESSIscsiDriver get online target list '
-                        'operation failed')
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-        for target in available_targets:
-            if target['name'] in target_status_output.keys():
-                if target_status_output[target['name']] == 'ONLINE':
-                    online_targets.append(target)
-
-        return online_targets
-
-    def _vrts_get_targets_store(self):
-        """Get target and its store list."""
-        path = self._target_list_str
-        provider = '%s:%s' % (self._va_ip, self._port)
-        data = {}
-        target_list = self._access_api(self.session, provider, path,
-                                       json.dumps(data), 'GET')
-
-        if not target_list:
-            message = _('ACCESSIscsiDriver get target list '
-                        'operation failed')
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-        return target_list['output']['output']['targets']
-
-    def _vrts_get_assigned_store(self, target, vrts_target_list):
-        """Get the store mapped to given target."""
-        for vrts_target in vrts_target_list:
-            if vrts_target['wwn'] == target:
-                return vrts_target['fs_list'][0]
-
-    def _vrts_is_space_available_in_store(self, vol_size, store_name, fs_list):
-        """Check whether space is available on store."""
-        if self._sparse_lun_support:
-            return True
-
-        for fs in fs_list:
-            if fs['name'] == store_name:
-                fs_avilable_space = (int(fs['file_storage_capacity']) -
-                                     int(fs['file_storage_used']))
-                free_space = fs_avilable_space / units.Gi
-
-                if free_space > vol_size:
-                    return True
-                break
-        return False
-
-    def _vrts_get_suitable_target(self, target_list, vol_size):
-        """Get a suitable target for lun creation.
-
-        Picking random target at first, if space is not available
-        in first selected target then check each target one by one
-        for suitable one.
-        """
-
-        target_count = len(target_list)
-
-        incrmnt_pointer = 0
-        target_index = randint(0, (target_count - 1))
-
-        fs_list = self._vrts_get_fs_list()
-
-        vrts_target_list = self._vrts_get_targets_store()
-
-        store_name = self._vrts_get_assigned_store(
-            target_list[target_index]['name'],
-            vrts_target_list
-        )
-
-        if not self._vrts_is_space_available_in_store(
-                vol_size, store_name, fs_list):
-            while (incrmnt_pointer != target_count - 1):
-                target_index = (target_index + 1) % target_count
-                store_name = self._vrts_get_assigned_store(
-                    target_list[target_index]['name'],
-                    vrts_target_list
-                )
-                if self._vrts_is_space_available_in_store(
-                        vol_size, store_name, fs_list):
-                    return target_list[target_index]['name']
-                incrmnt_pointer = incrmnt_pointer + 1
-        else:
-            return target_list[target_index]['name']
-
-        return False
-
-    def create_volume(self, volume):
-        """Creates a Veritas Access Iscsi LUN."""
-        create_dense = False
-        if 'dense' in volume.metadata.keys():
-            create_dense = strutils.bool_from_string(
-                volume.metadata['dense'])
-
-        lun_name = self._get_va_lun_name(volume.id)
-        lun_size = '%sg' % volume.size
-        path = self._lun_create_str
-        provider = '%s:%s' % (self._va_ip, self._port)
-
-        target_list = self._vrts_parse_xml_file(self.target_info_file)
-
-        target_name = self._vrts_get_suitable_target(target_list, volume.size)
-
-        if not target_name:
-            message = (_('ACCESSIscsiDriver create volume failed %s '
-                         'as no space is available') % volume.id)
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-        data = {}
-        data["lun_name"] = lun_name
-        data["target_name"] = target_name
-        data["size"] = lun_size
-        if not self._sparse_lun_support or create_dense:
-            data["option"] = "option=dense"
-
-        result = self._access_api(self.session, provider, path,
-                                  json.dumps(data), 'POST')
-
-        if not result:
-            message = (_('ACCESSIscsiDriver create volume failed %s')
-                       % volume.id)
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-    def delete_volume(self, volume):
-        """Deletes a Veritas Access Iscsi LUN."""
-        lun_name = self._get_va_lun_name(volume.id)
-        lun_list = self._get_vrts_lun_list()
-        target_name = ""
-
-        for lun in lun_list['output']['output']['luns']:
-            if lun['lun_name'] == lun_name:
-                target_name = lun['target_name']
-
-        path = self._lun_destroy_str
-        provider = '%s:%s' % (self._va_ip, self._port)
-
-        data = {}
-        data["lun_name"] = lun_name
-        data["target_name"] = target_name
-
-        result = self._access_api(self.session, provider, path,
-                                  json.dumps(data), 'POST')
-
-        if not result:
-            message = (_('ACCESSIscsiDriver delete volume failed %s')
-                       % volume.id)
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-    def create_snapshot(self, snapshot):
-        """Creates a snapshot of LUN."""
-        lun_name = self._get_va_lun_name(snapshot.volume_id)
-        snap_name = self._get_va_lun_name(snapshot.id)
-        path = self._snapshot_create_str
-        provider = '%s:%s' % (self._va_ip, self._port)
-
-        data = {}
-        data["lun_name"] = lun_name
-        data["snap_name"] = snap_name
-
-        result = self._access_api(self.session, provider, path,
-                                  json.dumps(data), 'POST')
-
-        if not result:
-            message = (_('ACCESSIscsiDriver create snapshot failed for %s')
-                       % snapshot.volume_id)
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-    def delete_snapshot(self, snapshot):
-        """Deletes a snapshot of LUN."""
-        lun_name = self._get_va_lun_name(snapshot.volume_id)
-        snap_name = self._get_va_lun_name(snapshot.id)
-        path = self._snapshot_destroy_str
-        provider = '%s:%s' % (self._va_ip, self._port)
-
-        data = {}
-        data["lun_name"] = lun_name
-        data["snap_name"] = snap_name
-
-        result = self._access_api(self.session, provider, path,
-                                  json.dumps(data), 'POST')
-
-        if not result:
-            message = (_('ACCESSIscsiDriver delete snapshot failed for %s')
-                       % snapshot.id)
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-    def create_cloned_volume(self, volume, src_vref):
-        """Create a clone of the volume."""
-        lun_name = self._get_va_lun_name(src_vref.id)
-        cloned_lun_name = self._get_va_lun_name(volume.id)
-
-        lun_found = False
-
-        lun_list = self._get_vrts_lun_list()
-        for lun in lun_list['output']['output']['luns']:
-            if lun['lun_name'] == lun_name:
-                store_name = lun['fs_name']
-                lun_found = True
-                break
-
-        if not lun_found:
-            message = (_('ACCESSIscsiDriver create cloned volume '
-                         'failed %s as no source volume found') % volume.id)
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-        fs_list = self._vrts_get_fs_list()
-
-        if not self._vrts_is_space_available_in_store(volume.size, store_name,
-                                                      fs_list):
-            message = (_('ACCESSIscsiDriver create cloned volume '
-                         'failed %s as no space is available') % volume.id)
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-        path = self._lun_clone_create_str
-        provider = '%s:%s' % (self._va_ip, self._port)
-
-        data = {}
-        data["lun_name"] = lun_name
-        data["clone_name"] = cloned_lun_name
-
-        result = self._access_api(self.session, provider, path,
-                                  json.dumps(data), 'POST')
-
-        if not result:
-            message = (_('ACCESSIscsiDriver create cloned '
-                         'volume failed for %s')
-                       % src_vref.id)
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-        if volume.size > src_vref.size:
-            self._vrts_extend_lun(volume, volume.size)
-
-    def create_volume_from_snapshot(self, volume, snapshot):
-        """Creates a volume from snapshot."""
-        LOG.debug('ACCESSIscsiDriver create_volume_from_snapshot called')
-
-        lun_name = self._get_va_lun_name(volume.id)
-        snap_name = self._get_va_lun_name(snapshot.id)
-
-        path = self._snapshot_list_str
-        provider = '%s:%s' % (self._va_ip, self._port)
-        data = {}
-        data["snap_name"] = snap_name
-        snap_info = self._access_api(self.session, provider, path,
-                                     json.dumps(data), 'GET')
-
-        target_name = ""
-        if snap_info:
-            for snap in snap_info['output']['output']['snapshots']:
-                if snap['snapshot_name'] == snap_name:
-                    target_name = snap['target_name']
-                    break
-
-        if target_name == "":
-            message = (_('ACCESSIscsiDriver create volume from snapshot '
-                         'failed for volume %s as failed to gather '
-                         'snapshot details')
-                       % volume.id)
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-        vrts_target_list = self._vrts_get_targets_store()
-        store_name = self._vrts_get_assigned_store(
-            target_name, vrts_target_list)
-
-        fs_list = self._vrts_get_fs_list()
-
-        if not self._vrts_is_space_available_in_store(volume.size, store_name,
-                                                      fs_list):
-            message = (_('ACCESSIscsiDriver create volume from snapshot '
-                         'failed %s as no space is available') % volume.id)
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-        path = self._lun_create_from_snap_str
-        provider = '%s:%s' % (self._va_ip, self._port)
-
-        data = {}
-        data["lun_name"] = lun_name
-        data["snap_name"] = snap_name
-
-        result = self._access_api(self.session, provider, path,
-                                  json.dumps(data), 'POST')
-
-        if not result:
-            message = (_('ACCESSIscsiDriver create volume from snapshot '
-                         'failed for volume %s')
-                       % volume.id)
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-        if volume.size > snapshot.volume_size:
-            self._vrts_extend_lun(volume, volume.size)
-
-    def _vrts_extend_lun(self, volume, size):
-        """Extend vrts LUN to given size."""
-        lun_name = self._get_va_lun_name(volume.id)
-        target = {'target_name': ''}
-
-        def _inner():
-            lun_list = self._get_vrts_lun_list()
-            for lun in lun_list['output']['output']['luns']:
-                if lun['lun_name'] == lun_name:
-                    target['target_name'] = lun['target_name']
-                    raise loopingcall.LoopingCallDone()
-
-        timer = loopingcall.FixedIntervalWithTimeoutLoopingCall(_inner)
-
-        try:
-            timer.start(interval=5, timeout=self.LUN_FOUND_INTERVAL).wait()
-        except loopingcall.LoopingCallTimeOut:
-            return False
-
-        lun_size = '%sg' % size
-        path = self._lun_extend_str
-        provider = '%s:%s' % (self._va_ip, self._port)
-
-        data = {}
-        data["lun_name"] = lun_name
-        data["target_name"] = target['target_name']
-        data["size"] = lun_size
-
-        result = self._access_api(self.session, provider, path,
-                                  json.dumps(data), 'POST')
-        return result
-
-    def extend_volume(self, volume, size):
-        """Extend the volume to new size"""
-        lun_name = self._get_va_lun_name(volume.id)
-        lun_found = False
-
-        lun_list = self._get_vrts_lun_list()
-        for lun in lun_list['output']['output']['luns']:
-            if lun['lun_name'] == lun_name:
-                store_name = lun['fs_name']
-                lun_found = True
-                break
-
-        if not lun_found:
-            message = (_('ACCESSIscsiDriver extend volume '
-                         'failed %s as no volume found at backend')
-                       % volume.id)
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-        fs_list = self._vrts_get_fs_list()
-
-        if not self._vrts_is_space_available_in_store(size, store_name,
-                                                      fs_list):
-            message = (_('ACCESSIscsiDriver extend volume '
-                         'failed %s as no space is available') % volume.id)
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-        result = self._vrts_extend_lun(volume, size)
-
-        if not result:
-            message = (_('ACCESSIscsiDriver extend '
-                         'volume failed for %s')
-                       % volume.id)
-            LOG.error(message)
-            raise exception.VolumeBackendAPIException(message=message)
-
-    def _get_api(self, provider, tail):
-        api_root = 'https://%s/api/access' % (provider)
-        if tail == self._fs_list_str:
-            api_root = 'https://%s/api' % (provider)
-
-        return api_root + tail
-
-    def _access_api(self, session, provider, path, input_data, method):
-        """Returns False if failure occurs."""
-        kwargs = {'data': input_data}
-        if not isinstance(input_data, dict):
-            kwargs['headers'] = {'Content-Type': 'application/json'}
-        full_url = self._get_api(provider, path)
-        response = session.request(method, full_url, **kwargs)
-        if response.status_code == 401:
-            LOG.debug('Generating new session.')
-            self.session = self._authenticate_access(self._va_ip,
-                                                     self._user, self._pwd)
-            response = self.session.request(method, full_url, **kwargs)
-
-        if response.status_code != http_client.OK:
-            LOG.error('Access API operation failed with HTTP error code %s.',
-                      str(response.status_code))
-            return False
-        result = response.json()
-        return result
-
-    def _authenticate_access(self, address, username, password):
-        session = requests.session()
-        session.verify = self.verify
-        session.auth = NoAuth()
-
-        # Here 'address' will be only IPv4.
-        response = session.post('https://%s:%s/api/rest/authenticate'
-                                % (address, self._port),
-                                data={'username': username,
-                                      'password': password})
-        if response.status_code != http_client.OK:
-            LOG.error('Failed to authenticate to remote cluster at %s as %s.',
-                      address, username)
-            raise exception.NotAuthorized(_('Authentication failure.'))
-        result = response.json()
-        session.headers.update({'Authorization': 'Bearer {}'
-                                .format(result['token'])})
-        session.headers.update({'Content-Type': 'application/json'})
-
-        return session
-
-    def _get_va_backend_capacity(self):
-        """Get VA backend total and free capacity."""
-        target_list = self._vrts_parse_xml_file(self.target_info_file)
-        fs_list = self._vrts_get_fs_list()
-        vrts_target_list = self._vrts_get_targets_store()
-
-        total_space = 0
-        free_space = 0
-
-        target_name = []
-        target_store = []
-
-        for target in target_list:
-            target_name.append(target['name'])
-
-        for target in vrts_target_list:
-            if target['wwn'] in target_name:
-                target_store.append(target['fs_list'][0])
-
-        for store in target_store:
-            for fs in fs_list:
-                if fs['name'] == store:
-                    total_space = total_space + fs['file_storage_capacity']
-                    fs_free_space = (fs['file_storage_capacity'] -
-                                     fs['file_storage_used'])
-
-                    if fs_free_space > free_space:
-                        free_space = fs_free_space
-
-        total_capacity = int(total_space) / units.Gi
-        free_capacity = int(free_space) / units.Gi
-
-        return (total_capacity, free_capacity)
-
-    def get_volume_stats(self, refresh=False):
-        """Retrieve status info from share volume group."""
-
-        total_capacity, free_capacity = self._get_va_backend_capacity()
-        backend_name = self.configuration.safe_get('volume_backend_name')
-        res_percentage = self.configuration.safe_get('reserved_percentage')
-        self._stats["volume_backend_name"] = backend_name or 'VeritasISCSI'
-        self._stats["vendor_name"] = 'Veritas'
-        self._stats["reserved_percentage"] = res_percentage or 0
-        self._stats["driver_version"] = self.VERSION
-        self._stats["storage_protocol"] = self.DRIVER_VOLUME_TYPE
-        self._stats['total_capacity_gb'] = total_capacity
-        self._stats['free_capacity_gb'] = free_capacity
-        self._stats['thin_provisioning_support'] = True
-
-        return self._stats
diff -pruN 2:15.0.1-1/cinder/volume/drivers/veritas_cnfs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/veritas_cnfs.py
--- 2:15.0.1-1/cinder/volume/drivers/veritas_cnfs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/veritas_cnfs.py	2020-03-24 18:46:31.000000000 +0000
@@ -54,6 +54,9 @@ class VeritasCNFSDriver(nfs.NfsDriver):
     CI_WIKI_NAME = "Veritas_Access_CI"
     DRIVER_VOLUME_TYPE = 'nfs'
 
+    # TODO(jsbryant) Remove driver in the 'V' release if CI is not fixed.
+    SUPPORTED = False
+
     def __init__(self, *args, **kwargs):
         self._execute = None
         self._context = None
diff -pruN 2:15.0.1-1/cinder/volume/drivers/vmware/fcd.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/vmware/fcd.py
--- 2:15.0.1-1/cinder/volume/drivers/vmware/fcd.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/vmware/fcd.py	2020-03-24 18:46:31.000000000 +0000
@@ -257,6 +257,11 @@ class VMwareVStorageObjectDriver(vmdk.VM
 
             vmdk_file_path = self.volumeops.get_vmdk_path(backing)
             conf = self.configuration
+
+            # retrieve store information from extra-specs
+            store_id = volume.volume_type.extra_specs.get(
+                'image_service:store_id')
+
             image_transfer.upload_image(
                 context,
                 conf.vmware_image_transfer_timeout_secs,
@@ -269,7 +274,8 @@ class VMwareVStorageObjectDriver(vmdk.VM
                 vm=backing,
                 vmdk_file_path=vmdk_file_path,
                 vmdk_size=volume.size * units.Gi,
-                image_name=image_meta['name'])
+                image_name=image_meta['name'],
+                store_id=store_id)
         finally:
             if attached:
                 self.volumeops.detach_fcd(backing, fcd_loc)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/vmware/vmdk.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/vmware/vmdk.py
--- 2:15.0.1-1/cinder/volume/drivers/vmware/vmdk.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/vmware/vmdk.py	2020-03-24 18:46:31.000000000 +0000
@@ -1289,6 +1289,13 @@ class VMwareVcVmdkDriver(driver.VolumeDr
         self.volumeops.extend_virtual_disk(new_size_in_gb, root_vmdk_path,
                                            datacenter, eager_zero)
 
+    def clone_image(self, context, volume, image_location, image_meta,
+                    image_service):
+        """Clone image directly to a volume."""
+        ret = self.copy_image_to_volume(
+            context, volume, image_service, image_meta['id'])
+        return (ret, True)
+
     def copy_image_to_volume(self, context, volume, image_service, image_id):
         """Creates volume from image.
 
@@ -1404,6 +1411,9 @@ class VMwareVcVmdkDriver(driver.VolumeDr
         host_ip = self.configuration.vmware_host_ip
         port = self.configuration.vmware_host_port
 
+        # retrieve store information from extra-specs
+        store_id = volume.volume_type.extra_specs.get('image_service:store_id')
+
         image_transfer.upload_image(context,
                                     timeout,
                                     image_service,
@@ -1416,7 +1426,8 @@ class VMwareVcVmdkDriver(driver.VolumeDr
                                     vmdk_file_path=vmdk_file_path,
                                     vmdk_size=volume['size'] * units.Gi,
                                     image_name=image_meta['name'],
-                                    image_version=1)
+                                    image_version=1,
+                                    store_id=store_id)
         LOG.info("Done copying volume %(vol)s to a new image %(img)s",
                  {'vol': volume['name'], 'img': image_meta['name']})
 
diff -pruN 2:15.0.1-1/cinder/volume/drivers/vzstorage.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/vzstorage.py
--- 2:15.0.1-1/cinder/volume/drivers/vzstorage.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/vzstorage.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,743 +0,0 @@
-# Copyright (c) 2015 Parallels IP Holdings GmbH
-# All Rights Reserved.
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-
-import collections
-import errno
-import json
-import os
-import re
-
-from os_brick.remotefs import remotefs
-from oslo_concurrency import processutils as putils
-from oslo_config import cfg
-from oslo_log import log as logging
-from oslo_utils import imageutils
-from oslo_utils import units
-
-from cinder import exception
-from cinder.i18n import _
-from cinder.image import image_utils
-from cinder import interface
-from cinder import utils
-from cinder.volume import configuration
-from cinder.volume.drivers import remotefs as remotefs_drv
-
-LOG = logging.getLogger(__name__)
-
-vzstorage_opts = [
-    cfg.StrOpt('vzstorage_shares_config',
-               default='/etc/cinder/vzstorage_shares',
-               help='File with the list of available vzstorage shares.'),
-    cfg.BoolOpt('vzstorage_sparsed_volumes',
-                default=True,
-                help=('Create volumes as sparsed files which take no space '
-                      'rather than regular files when using raw format, '
-                      'in which case volume creation takes lot of time.')),
-    cfg.FloatOpt('vzstorage_used_ratio',
-                 default=0.95,
-                 help=('Percent of ACTUAL usage of the underlying volume '
-                       'before no new volumes can be allocated to the volume '
-                       'destination.')),
-    cfg.StrOpt('vzstorage_mount_point_base',
-               default='$state_path/mnt',
-               help=('Base dir containing mount points for '
-                     'vzstorage shares.')),
-    cfg.ListOpt('vzstorage_mount_options',
-                help=('Mount options passed to the vzstorage client. '
-                      'See section of the pstorage-mount man page '
-                      'for details.')),
-    cfg.StrOpt('vzstorage_default_volume_format',
-               default='raw',
-               help=('Default format that will be used when creating volumes '
-                     'if no volume format is specified.')),
-]
-
-CONF = cfg.CONF
-CONF.register_opts(vzstorage_opts, group=configuration.SHARED_CONF_GROUP)
-
-PLOOP_BASE_DELTA_NAME = 'root.hds'
-DISK_FORMAT_RAW = 'raw'
-DISK_FORMAT_QCOW2 = 'qcow2'
-DISK_FORMAT_PLOOP = 'ploop'
-
-
-class VzStorageException(exception.RemoteFSException):
-    message = _("Unknown Virtuozzo Storage exception")
-
-
-class VzStorageNoSharesMounted(exception.RemoteFSNoSharesMounted):
-    message = _("No mounted Virtuozzo Storage shares found")
-
-
-class VzStorageNoSuitableShareFound(exception.RemoteFSNoSuitableShareFound):
-    message = _("There is no share which can host %(volume_size)sG")
-
-
-class PloopDevice(object):
-    """Setup a ploop device for ploop image
-
-    This class is for mounting ploop devices using with statement:
-    with PloopDevice('/vzt/private/my-ct/harddisk.hdd') as dev_path:
-    # do something
-
-    :param path: A path to ploop harddisk dir
-    :param snapshot_id: Snapshot id to mount
-    :param execute: execute helper
-    """
-
-    def __init__(self, path, snapshot_id=None, read_only=True,
-                 execute=putils.execute):
-        self.path = path
-        self.snapshot_id = snapshot_id
-        self.read_only = read_only
-        self.execute = execute
-
-    def __enter__(self):
-        self.dd_path = os.path.join(self.path, 'DiskDescriptor.xml')
-        cmd = ['ploop', 'mount', self.dd_path]
-
-        if self.snapshot_id:
-            cmd.append('-u')
-            cmd.append(self.snapshot_id)
-
-        if self.read_only:
-            cmd.append('-r')
-
-        out, err = self.execute(*cmd, run_as_root=True)
-
-        m = re.search(r'dev=(\S+)', out)
-        if not m:
-            raise Exception('Invalid output from ploop mount: %s' % out)
-
-        self.ploop_dev = m.group(1)
-
-        return self.ploop_dev
-
-    def _umount(self):
-        self.execute('ploop', 'umount', self.dd_path, run_as_root=True)
-
-    def __exit__(self, type, value, traceback):
-        self._umount()
-
-
-@interface.volumedriver
-class VZStorageDriver(remotefs_drv.RemoteFSSnapDriver):
-    """Cinder driver for Virtuozzo Storage.
-
-    Creates volumes as files on the mounted vzstorage cluster.
-
-    .. code-block:: none
-
-      Version history:
-        1.0     - Initial driver.
-        1.1     - Supports vz:volume_format in vendor properties.
-    """
-    VERSION = '1.1'
-    CI_WIKI_NAME = "Virtuozzo_Storage_CI"
-
-    # TODO(jsbryant) Remove driver in the 'U' release if CI is not fixed.
-    SUPPORTED = False
-
-    SHARE_FORMAT_REGEX = r'(?:(\S+):\/)?([a-zA-Z0-9_-]+)(?::(\S+))?'
-
-    def __init__(self, execute=putils.execute, *args, **kwargs):
-        self.driver_volume_type = 'vzstorage'
-        self.driver_prefix = 'vzstorage'
-        self.volume_backend_name = 'Virtuozzo_Storage'
-        self._remotefsclient = None
-        super(VZStorageDriver, self).__init__(*args, **kwargs)
-        self.configuration.append_config_values(vzstorage_opts)
-        self._execute_as_root = False
-        root_helper = utils.get_root_helper()
-        # base bound to instance is used in RemoteFsConnector.
-        self.base = self.configuration.vzstorage_mount_point_base
-        opts = self.configuration.vzstorage_mount_options
-
-        self._remotefsclient = remotefs.VZStorageRemoteFSClient(
-            'vzstorage', root_helper, execute=execute,
-            vzstorage_mount_point_base=self.base,
-            vzstorage_mount_options=opts)
-
-    @staticmethod
-    def get_driver_options():
-        return vzstorage_opts
-
-    def _update_volume_stats(self):
-        super(VZStorageDriver, self)._update_volume_stats()
-        self._stats['vendor_name'] = 'Virtuozzo'
-
-    def _init_vendor_properties(self):
-        namespace = 'vz'
-        properties = {}
-
-        self._set_property(
-            properties,
-            "%s:volume_format" % namespace,
-            "Volume format",
-            _("Specifies volume format."),
-            "string",
-            enum=["qcow2", "ploop", "raw"],
-            default=self.configuration.vzstorage_default_volume_format)
-
-        return properties, namespace
-
-    def _qemu_img_info(self, path, volume_name):
-        qemu_img_cache = path + ".qemu_img_info"
-        is_cache_outdated = True
-        if os.path.isdir(path):
-            # Ploop disks stored along with metadata xml as directories
-            # qemu-img should explore base data file inside
-            path = os.path.join(path, PLOOP_BASE_DELTA_NAME)
-        if os.path.isfile(qemu_img_cache):
-            info_tm = os.stat(qemu_img_cache).st_mtime
-            snap_tm = os.stat(path).st_mtime
-            if info_tm >= snap_tm:
-                is_cache_outdated = False
-        if is_cache_outdated:
-            LOG.debug("Cached qemu-img info %s not present or outdated,"
-                      " refresh", qemu_img_cache)
-            ret = super(VZStorageDriver, self)._qemu_img_info_base(
-                path, volume_name,
-                self.configuration.vzstorage_mount_point_base)
-            # We need only backing_file and file_format
-            d = {'file_format': ret.file_format,
-                 'backing_file': ret.backing_file}
-            with open(qemu_img_cache, "w") as f:
-                json.dump(d, f)
-        else:
-            ret = imageutils.QemuImgInfo()
-            with open(qemu_img_cache, "r") as f:
-                cached_data = json.load(f)
-            ret.file_format = cached_data['file_format']
-            ret.backing_file = cached_data['backing_file']
-        return ret
-
-    @remotefs_drv.locked_volume_id_operation
-    def initialize_connection(self, volume, connector):
-        """Allow connection to connector and return connection info.
-
-        :param volume: volume reference
-        :param connector: connector reference
-        """
-        # Find active image
-        active_file = self.get_active_image_from_info(volume)
-
-        data = {'export': volume.provider_location,
-                'format': self.get_volume_format(volume),
-                'name': active_file,
-                }
-
-        return {
-            'driver_volume_type': self.driver_volume_type,
-            'data': data,
-            'mount_point_base': self._get_mount_point_base(),
-        }
-
-    def do_setup(self, context):
-        """Any initialization the volume driver does while starting."""
-        super(VZStorageDriver, self).do_setup(context)
-
-        config = self.configuration.vzstorage_shares_config
-        if not os.path.exists(config):
-            msg = (_("VzStorage config file at %(config)s doesn't exist.") %
-                   {'config': config})
-            LOG.error(msg)
-            raise VzStorageException(msg)
-
-        if not os.path.isabs(self.base):
-            msg = _("Invalid mount point base: %s.") % self.base
-            LOG.error(msg)
-            raise VzStorageException(msg)
-
-        used_ratio = self.configuration.vzstorage_used_ratio
-        if not ((used_ratio > 0) and (used_ratio <= 1)):
-            msg = _("VzStorage config 'vzstorage_used_ratio' invalid. "
-                    "Must be > 0 and <= 1.0: %s.") % used_ratio
-            LOG.error(msg)
-            raise VzStorageException(msg)
-
-        self.shares = {}
-
-        # Check if mount.fuse.pstorage is installed on this system;
-        # note that we don't need to be root to see if the package
-        # is installed.
-        package = 'mount.fuse.pstorage'
-        try:
-            self._execute(package, check_exit_code=False,
-                          run_as_root=False)
-        except OSError as exc:
-            if exc.errno == errno.ENOENT:
-                msg = _('%s is not installed.') % package
-                raise VzStorageException(msg)
-            else:
-                raise
-
-        self.configuration.nas_secure_file_operations = 'true'
-        self.configuration.nas_secure_file_permissions = 'true'
-
-    def _ensure_share_mounted(self, share):
-        m = re.search(self.SHARE_FORMAT_REGEX, share)
-        if not m:
-            msg = (_("Invalid Virtuozzo Storage share specification: %r. "
-                     "Must be: [MDS1[,MDS2],...:/]<CLUSTER NAME>[:PASSWORD].")
-                   % share)
-            raise VzStorageException(msg)
-        cluster_name = m.group(2)
-
-        if share in self.shares:
-            mnt_flags = json.loads(self.shares[share])
-        else:
-            mnt_flags = []
-
-        if '-l' not in mnt_flags:
-            # If logging path is not specified in shares config
-            # set up logging to non-default path, so that it will
-            # be possible to mount the same cluster to another mount
-            # point by hand with default options.
-            mnt_flags.extend([
-                '-l', '/var/log/vstorage/%s/cinder.log.gz' % cluster_name])
-
-        self._remotefsclient.mount(share, mnt_flags)
-
-    def _find_share(self, volume):
-        """Choose VzStorage share among available ones for given volume size.
-
-        For instances with more than one share that meets the criteria, the
-        first suitable share will be selected.
-
-        :param volume: the volume to be created.
-        """
-
-        if not self._mounted_shares:
-            raise VzStorageNoSharesMounted()
-
-        for share in self._mounted_shares:
-            if self._is_share_eligible(share, volume.size):
-                break
-        else:
-            raise VzStorageNoSuitableShareFound(
-                volume_size=volume.size)
-
-        LOG.debug('Selected %s as target VzStorage share.', share)
-
-        return share
-
-    def _is_share_eligible(self, vz_share, volume_size_in_gib):
-        """Verifies VzStorage share is eligible to host volume with given size.
-
-        :param vz_share: vzstorage share
-        :param volume_size_in_gib: int size in GB
-        """
-
-        used_ratio = self.configuration.vzstorage_used_ratio
-        volume_size = volume_size_in_gib * units.Gi
-
-        total_size, available, allocated = self._get_capacity_info(vz_share)
-
-        if (allocated + volume_size) // total_size > used_ratio:
-            LOG.debug('_is_share_eligible: %s is above '
-                      'vzstorage_used_ratio.', vz_share)
-            return False
-
-        return True
-
-    def choose_volume_format(self, volume):
-        volume_format = None
-        volume_type = volume.volume_type
-
-        # Retrieve volume format from volume metadata
-        if 'volume_format' in volume.metadata:
-            volume_format = volume.metadata['volume_format']
-
-        # If volume format wasn't found in metadata, use
-        # volume type extra specs
-        if not volume_format and volume_type:
-            extra_specs = volume_type.extra_specs or {}
-            if 'vz:volume_format' in extra_specs:
-                volume_format = extra_specs['vz:volume_format']
-
-        # If volume format is still undefined, return default
-        # volume format from backend configuration
-        return (volume_format or
-                self.configuration.vzstorage_default_volume_format)
-
-    def get_volume_format(self, volume):
-        active_file = self.get_active_image_from_info(volume)
-        active_file_path = os.path.join(self._local_volume_dir(volume),
-                                        active_file)
-        img_info = self._qemu_img_info(active_file_path, volume.name)
-        return image_utils.from_qemu_img_disk_format(img_info.file_format)
-
-    def _create_ploop(self, volume_path, volume_size):
-        os.mkdir(volume_path)
-        try:
-            self._execute('ploop', 'init', '-s', '%sG' % volume_size,
-                          os.path.join(volume_path, PLOOP_BASE_DELTA_NAME),
-                          run_as_root=True)
-        except putils.ProcessExecutionError:
-            os.rmdir(volume_path)
-            raise
-
-    def _do_create_volume(self, volume):
-        """Create a volume on given vzstorage share.
-
-        :param volume: volume reference
-        """
-        volume_format = self.choose_volume_format(volume)
-        volume_path = self.local_path(volume)
-        volume_size = volume.size
-
-        LOG.debug("Creating new volume at %s.", volume_path)
-
-        if os.path.exists(volume_path):
-            msg = _('File already exists at %s.') % volume_path
-            LOG.error(msg)
-            raise exception.InvalidVolume(reason=msg)
-
-        if volume_format == DISK_FORMAT_PLOOP:
-            self._create_ploop(volume_path, volume_size)
-        elif volume_format == DISK_FORMAT_QCOW2:
-            self._create_qcow2_file(volume_path, volume_size)
-        elif self.configuration.vzstorage_sparsed_volumes:
-            self._create_sparsed_file(volume_path, volume_size)
-        else:
-            self._create_regular_file(volume_path, volume_size)
-
-        info_path = self._local_path_volume_info(volume)
-        snap_info = {'active': os.path.basename(volume_path)}
-        self._write_info_file(info_path, snap_info)
-
-        # Query qemu-img info to cache the output
-        self._qemu_img_info(volume_path, volume.name)
-
-    def _delete(self, path):
-        self._execute('rm', '-rf', path, run_as_root=True)
-
-    @remotefs_drv.locked_volume_id_operation
-    def extend_volume(self, volume, size_gb):
-        LOG.info('Extending volume %s.', volume.id)
-        volume_format = self.get_volume_format(volume)
-        self._extend_volume(volume, size_gb, volume_format)
-
-    def _extend_volume(self, volume, size_gb, volume_format):
-        self._check_extend_volume_support(volume, size_gb)
-        LOG.info('Resizing file to %sG...', size_gb)
-
-        active_path = os.path.join(
-            self._get_mount_point_for_share(volume.provider_location),
-            self.get_active_image_from_info(volume))
-        self._do_extend_volume(active_path, size_gb, volume_format)
-
-    def _do_extend_volume(self, volume_path, size_gb, volume_format):
-
-        if volume_format == DISK_FORMAT_PLOOP:
-            self._execute('ploop', 'resize', '-s',
-                          '%dG' % size_gb,
-                          os.path.join(volume_path, 'DiskDescriptor.xml'),
-                          run_as_root=True)
-        else:
-            image_utils.resize_image(volume_path, size_gb)
-            if not self._is_file_size_equal(volume_path, size_gb):
-                raise exception.ExtendVolumeError(
-                    reason='Resizing image file failed.')
-
-    def _check_extend_volume_support(self, volume, size_gb):
-        extend_by = int(size_gb) - volume.size
-        if not self._is_share_eligible(volume.provider_location,
-                                       extend_by):
-            raise exception.ExtendVolumeError(reason='Insufficient space to '
-                                              'extend volume %s to %sG.'
-                                              % (volume.id, size_gb))
-
-    def _is_file_size_equal(self, path, size):
-        """Checks if file size at path is equal to size."""
-        data = image_utils.qemu_img_info(path)
-        virt_size = data.virtual_size / units.Gi
-        return virt_size == size
-
-    def _recreate_ploop_desc(self, image_dir, image_file):
-        self._delete(os.path.join(image_dir, 'DiskDescriptor.xml'))
-
-        self._execute('ploop', 'restore-descriptor', image_dir, image_file)
-
-    def copy_image_to_volume(self, context, volume, image_service, image_id):
-        """Fetch the image from image_service and write it to the volume."""
-        volume_format = self.get_volume_format(volume)
-        qemu_volume_format = image_utils.fixup_disk_format(volume_format)
-        image_path = self.local_path(volume)
-        if volume_format == DISK_FORMAT_PLOOP:
-            image_path = os.path.join(image_path, PLOOP_BASE_DELTA_NAME)
-
-        image_utils.fetch_to_volume_format(
-            context, image_service, image_id,
-            image_path, qemu_volume_format,
-            self.configuration.volume_dd_blocksize)
-
-        if volume_format == DISK_FORMAT_PLOOP:
-            self._recreate_ploop_desc(self.local_path(volume), image_path)
-
-        self._do_extend_volume(self.local_path(volume),
-                               volume.size,
-                               volume_format)
-        # Query qemu-img info to cache the output
-        self._qemu_img_info(self.local_path(volume), volume.name)
-
-    def _copy_volume_from_snapshot(self, snapshot, volume, volume_size):
-        """Copy data from snapshot to destination volume.
-
-        This is done with a qemu-img convert to raw/qcow2 from the snapshot
-        qcow2.
-        """
-
-        info_path = self._local_path_volume_info(snapshot.volume)
-        snap_info = self._read_info_file(info_path)
-        vol_dir = self._local_volume_dir(snapshot.volume)
-        out_format = self.choose_volume_format(volume)
-        qemu_out_format = image_utils.fixup_disk_format(out_format)
-        volume_format = self.get_volume_format(snapshot.volume)
-        volume_path = self.local_path(volume)
-
-        if volume_format in (DISK_FORMAT_QCOW2, DISK_FORMAT_RAW):
-            forward_file = snap_info[snapshot.id]
-            forward_path = os.path.join(vol_dir, forward_file)
-
-            # Find the file which backs this file, which represents the point
-            # when this snapshot was created.
-            img_info = self._qemu_img_info(forward_path,
-                                           snapshot.volume.name)
-            path_to_snap_img = os.path.join(vol_dir, img_info.backing_file)
-
-            LOG.debug("_copy_volume_from_snapshot: will copy "
-                      "from snapshot at %s.", path_to_snap_img)
-
-            image_utils.convert_image(path_to_snap_img,
-                                      volume_path,
-                                      qemu_out_format)
-        elif volume_format == DISK_FORMAT_PLOOP:
-            with PloopDevice(self.local_path(snapshot.volume),
-                             snapshot.id,
-                             execute=self._execute) as dev:
-                base_file = os.path.join(volume_path, 'root.hds')
-                image_utils.convert_image(dev,
-                                          base_file,
-                                          qemu_out_format)
-        else:
-            msg = _("Unsupported volume format %s") % volume_format
-            raise exception.InvalidVolume(msg)
-
-        self._extend_volume(volume, volume_size, out_format)
-        # Query qemu-img info to cache the output
-        img_info = self._qemu_img_info(volume_path, volume.name)
-
-    @remotefs_drv.locked_volume_id_operation
-    def delete_volume(self, volume):
-        """Deletes a logical volume."""
-        if not volume.provider_location:
-            msg = (_('Volume %s does not have provider_location '
-                     'specified, skipping.') % volume.name)
-            LOG.error(msg)
-            return
-
-        self._ensure_share_mounted(volume.provider_location)
-        volume_dir = self._local_volume_dir(volume)
-        mounted_path = os.path.join(volume_dir,
-                                    self.get_active_image_from_info(volume))
-        if os.path.exists(mounted_path):
-            self._delete(mounted_path)
-            self._delete(mounted_path + ".qemu_img_info")
-        else:
-            LOG.info("Skipping deletion of volume %s "
-                     "as it does not exist.", mounted_path)
-
-        info_path = self._local_path_volume_info(volume)
-        self._delete(info_path)
-
-    def _get_desc_path(self, volume):
-        return os.path.join(self.local_path(volume), 'DiskDescriptor.xml')
-
-    def _create_snapshot_ploop(self, snapshot):
-        status = snapshot.volume.status
-        if status != 'available':
-            msg = (_('Volume status must be available for '
-                     'snapshot %(id)s. (is %(status)s)') %
-                   {'id': snapshot.id, 'status': status})
-            raise exception.InvalidVolume(msg)
-
-        info_path = self._local_path_volume_info(snapshot.volume)
-        snap_info = self._read_info_file(info_path)
-        self._execute('ploop', 'snapshot', '-u', '{%s}' % snapshot.id,
-                      self._get_desc_path(snapshot.volume),
-                      run_as_root=True)
-        snap_file = os.path.join('volume-%s' % snapshot.volume.id, snapshot.id)
-        snap_info[snapshot.id] = snap_file
-        self._write_info_file(info_path, snap_info)
-
-    def _delete_snapshot_ploop(self, snapshot):
-        status = snapshot.volume.status
-        if status != 'available':
-            msg = (_('Volume status must be available for '
-                     'snapshot %(id)s. (is %(status)s)') %
-                   {'id': snapshot.id, 'status': status})
-            raise exception.InvalidVolume(msg)
-
-        info_path = self._local_path_volume_info(snapshot.volume)
-        snap_info = self._read_info_file(info_path)
-        self._execute('ploop', 'snapshot-delete', '-u', '{%s}' % snapshot.id,
-                      self._get_desc_path(snapshot.volume),
-                      run_as_root=True)
-        snap_info.pop(snapshot.id, None)
-        self._write_info_file(info_path, snap_info)
-
-    def _create_snapshot(self, snapshot):
-        volume_format = self.get_volume_format(snapshot.volume)
-        if volume_format == DISK_FORMAT_PLOOP:
-            self._create_snapshot_ploop(snapshot)
-        else:
-            super(VZStorageDriver, self)._create_snapshot(snapshot)
-
-    def _do_create_snapshot(self, snapshot, backing_filename,
-                            new_snap_path):
-        super(VZStorageDriver, self)._do_create_snapshot(snapshot,
-                                                         backing_filename,
-                                                         new_snap_path)
-        # Cache qemu-img info for created snapshot
-        self._qemu_img_info(new_snap_path, snapshot.volume.name)
-
-    def _delete_snapshot_qcow2(self, snapshot):
-        info_path = self._local_path_volume_info(snapshot.volume)
-        snap_info = self._read_info_file(info_path, empty_if_missing=True)
-        if snapshot.id not in snap_info:
-            LOG.warning("Snapshot %s doesn't exist in snap_info",
-                        snapshot.id)
-            return
-
-        snap_file = os.path.join(self._local_volume_dir(snapshot.volume),
-                                 snap_info[snapshot.id])
-        active_file = os.path.join(self._local_volume_dir(snapshot.volume),
-                                   snap_info['active'])
-        higher_file = self._get_higher_image_path(snapshot)
-        if higher_file:
-            higher_file = os.path.join(self._local_volume_dir(snapshot.volume),
-                                       higher_file)
-        elif active_file != snap_file:
-            msg = (_("Expected higher file exists for snapshot %s") %
-                   snapshot.id)
-            raise VzStorageException(msg)
-
-        img_info = self._qemu_img_info(snap_file, snapshot.volume.name)
-        base_file = os.path.join(self._local_volume_dir(snapshot.volume),
-                                 img_info.backing_file)
-
-        super(VZStorageDriver, self)._delete_snapshot(snapshot)
-
-        def _qemu_info_cache(fn):
-            return fn + ".qemu_img_info"
-
-        def _update_backing_file(info_src, info_dst):
-            with open(info_src, 'r') as fs, open(info_dst, 'r') as fd:
-                src = json.load(fs)
-                dst = json.load(fd)
-            dst['backing_file'] = src['backing_file']
-            with open(info_dst, 'w') as fdw:
-                json.dump(dst, fdw)
-
-        if snap_file != active_file:
-            # mv snap_file.info higher_file.info
-            _update_backing_file(
-                _qemu_info_cache(snap_file),
-                _qemu_info_cache(higher_file))
-            self._delete(_qemu_info_cache(snap_file))
-        elif snapshot.volume.status == 'in-use':
-            # mv base_file.info snap_file.info
-            _update_backing_file(
-                _qemu_info_cache(base_file),
-                _qemu_info_cache(snap_file))
-            self._delete(_qemu_info_cache(base_file))
-        else:
-            # rm snap_file.info
-            self._delete(_qemu_info_cache(snap_file))
-
-    def _delete_snapshot(self, snapshot):
-        volume_format = self.get_volume_format(snapshot.volume)
-        if volume_format == DISK_FORMAT_PLOOP:
-            self._delete_snapshot_ploop(snapshot)
-        else:
-            self._delete_snapshot_qcow2(snapshot)
-
-    def _copy_volume_to_image(self, context, volume, image_service,
-                              image_meta):
-        """Copy the volume to the specified image."""
-
-        volume_format = self.get_volume_format(volume)
-        if volume_format == DISK_FORMAT_PLOOP:
-            with PloopDevice(self.local_path(volume),
-                             execute=self._execute) as dev:
-                image_utils.upload_volume(context,
-                                          image_service,
-                                          image_meta,
-                                          dev,
-                                          volume_format='raw')
-        else:
-            super(VZStorageDriver, self)._copy_volume_to_image(context, volume,
-                                                               image_service,
-                                                               image_meta)
-
-    def _create_cloned_volume_ploop(self, volume, src_vref):
-        LOG.info('Cloning volume %(src)s to volume %(dst)s',
-                 {'src': src_vref.id,
-                  'dst': volume.id})
-
-        if src_vref.status != 'available':
-            msg = _("Volume status must be 'available'.")
-            raise exception.InvalidVolume(msg)
-
-        volume_name = CONF.volume_name_template % volume.id
-
-        # Create fake snapshot object
-        snap_attrs = ['volume_name', 'size', 'volume_size', 'name',
-                      'volume_id', 'id', 'volume']
-        Snapshot = collections.namedtuple('Snapshot', snap_attrs)
-
-        temp_snapshot = Snapshot(id=src_vref.id,
-                                 volume_name=volume_name,
-                                 size=src_vref.size,
-                                 volume_size=src_vref.size,
-                                 name='clone-snap-%s' % src_vref.id,
-                                 volume_id=src_vref.id,
-                                 volume=src_vref)
-
-        self._create_snapshot_ploop(temp_snapshot)
-        try:
-            volume.provider_location = src_vref.provider_location
-            info_path = self._local_path_volume_info(volume)
-            snap_info = {'active': 'volume-%s' % volume.id}
-            self._write_info_file(info_path, snap_info)
-            self._copy_volume_from_snapshot(temp_snapshot,
-                                            volume,
-                                            volume.size)
-
-        finally:
-            self.delete_snapshot(temp_snapshot)
-
-        return {'provider_location': src_vref.provider_location}
-
-    def _create_cloned_volume(self, volume, src_vref, context):
-        """Creates a clone of the specified volume."""
-        volume_format = self.get_volume_format(src_vref)
-        if volume_format == DISK_FORMAT_PLOOP:
-            return self._create_cloned_volume_ploop(volume, src_vref)
-        else:
-            return super(VZStorageDriver, self)._create_cloned_volume(volume,
-                                                                      src_vref)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/windows/iscsi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/windows/iscsi.py
--- 2:15.0.1-1/cinder/volume/drivers/windows/iscsi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/windows/iscsi.py	2020-03-24 18:46:31.000000000 +0000
@@ -285,6 +285,8 @@ class WindowsISCSIDriver(driver.ISCSIDri
 
     def copy_volume_to_image(self, context, volume, image_service, image_meta):
         """Copy the volume to the specified image."""
+        # retrieve store information from extra-specs
+        store_id = volume.volume_type.extra_specs.get('image_service:store_id')
         disk_format = self._tgt_utils.get_supported_disk_format()
         temp_vhd_path = os.path.join(CONF.image_conversion_dir,
                                      str(image_meta['id']) + '.' + disk_format)
@@ -295,7 +297,8 @@ class WindowsISCSIDriver(driver.ISCSIDri
                 # must be exported first.
                 self._tgt_utils.export_snapshot(tmp_snap_name, temp_vhd_path)
                 image_utils.upload_volume(context, image_service, image_meta,
-                                          temp_vhd_path, 'vhd')
+                                          temp_vhd_path, 'vhd',
+                                          store_id=store_id)
         finally:
             fileutils.delete_if_exists(temp_vhd_path)
 
diff -pruN 2:15.0.1-1/cinder/volume/drivers/windows/smbfs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/windows/smbfs.py
--- 2:15.0.1-1/cinder/volume/drivers/windows/smbfs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/windows/smbfs.py	2020-03-24 18:46:31.000000000 +0000
@@ -553,6 +553,8 @@ class WindowsSmbfsDriver(remotefs_drv.Re
     @coordination.synchronized('{self.driver_prefix}-{volume.id}')
     def copy_volume_to_image(self, context, volume, image_service, image_meta):
         """Copy the volume to the specified image."""
+        # retrieve store information from extra-specs
+        store_id = volume.volume_type.extra_specs.get('image_service:store_id')
 
         # If snapshots exist, flatten to a temporary image, and upload it
 
@@ -582,7 +584,8 @@ class WindowsSmbfsDriver(remotefs_drv.Re
                                       image_service,
                                       image_meta,
                                       upload_path,
-                                      root_file_fmt)
+                                      root_file_fmt,
+                                      store_id=store_id)
         finally:
             if temp_path:
                 self._delete(temp_path)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/zfssa/restclient.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/zfssa/restclient.py
--- 2:15.0.1-1/cinder/volume/drivers/zfssa/restclient.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/zfssa/restclient.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,379 +0,0 @@
-# Copyright (c) 2014, 2015, Oracle and/or its affiliates. All rights reserved.
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-"""
-ZFS Storage Appliance REST API Client Programmatic Interface
-"""
-
-import json
-import ssl
-import time
-
-from oslo_log import log
-from oslo_utils import strutils
-import six
-from six.moves import http_client
-from six.moves import urllib
-
-LOG = log.getLogger(__name__)
-
-
-class Status(object):
-    """Result HTTP Status"""
-
-    def __init__(self):
-        pass
-
-    #: Request return OK
-    OK = http_client.OK
-
-    #: New resource created successfully
-    CREATED = http_client.CREATED
-
-    #: Command accepted
-    ACCEPTED = http_client.ACCEPTED
-
-    #: Command returned OK but no data will be returned
-    NO_CONTENT = http_client.NO_CONTENT
-
-    #: Bad Request
-    BAD_REQUEST = http_client.BAD_REQUEST
-
-    #: User is not authorized
-    UNAUTHORIZED = http_client.UNAUTHORIZED
-
-    #: The request is not allowed
-    FORBIDDEN = http_client.FORBIDDEN
-
-    #: The requested resource was not found
-    NOT_FOUND = http_client.NOT_FOUND
-
-    #: The request is not allowed
-    NOT_ALLOWED = http_client.METHOD_NOT_ALLOWED
-
-    #: Request timed out
-    TIMEOUT = http_client.REQUEST_TIMEOUT
-
-    #: Invalid request
-    CONFLICT = http_client.CONFLICT
-
-    #: Service Unavailable
-    BUSY = http_client.SERVICE_UNAVAILABLE
-
-
-class RestResult(object):
-    """Result from a REST API operation"""
-    def __init__(self, response=None, err=None):
-        """Initialize a RestResult containing the results from a REST call.
-
-        :param response: HTTP response
-        """
-        self.response = response
-        self.error = err
-        self.data = ""
-        self.status = 0
-        if self.response:
-            self.status = self.response.getcode()
-            result = self.response.read()
-            while result:
-                self.data += result.decode("utf-8")
-                result = self.response.read()
-
-        if self.error:
-            self.status = self.error.code
-            self.data = http_client.responses[self.status]
-
-        LOG.debug('Response code: %s', self.status)
-        LOG.debug('Response data: %s', self.data)
-
-    def get_header(self, name):
-        """Get an HTTP header with the given name from the results
-
-        :param name: HTTP header name
-        :return: The header value or None if no value is found
-        """
-        if self.response is None:
-            return None
-        info = self.response.info()
-        return info.get(name)
-
-
-class RestClientError(Exception):
-    """Exception for ZFS REST API client errors"""
-    def __init__(self, status, name="ERR_INTERNAL", message=None):
-
-        """Create a REST Response exception
-
-        :param status: HTTP response status
-        :param name: The name of the REST API error type
-        :param message: Descriptive error message returned from REST call
-        """
-        super(RestClientError, self).__init__(message)
-        self.code = status
-        self.name = name
-        self.msg = message
-        if status in http_client.responses:
-            self.msg = http_client.responses[status]
-
-    def __str__(self):
-        return "%d %s %s" % (self.code, self.name, self.msg)
-
-
-class RestClientURL(object):
-    """ZFSSA urllib client"""
-    def __init__(self, url, **kwargs):
-        """Initialize a REST client.
-
-        :param url: The ZFSSA REST API URL
-        :key session: HTTP Cookie value of x-auth-session obtained from a
-                      normal BUI login.
-        :key timeout: Time in seconds to wait for command to complete.
-                      (Default is 60 seconds)
-        """
-        self.url = url
-        self.local = kwargs.get("local", False)
-        self.base_path = kwargs.get("base_path", "/api")
-        self.timeout = kwargs.get("timeout", 60)
-        self.headers = None
-        if kwargs.get('session'):
-            self.headers['x-auth-session'] = kwargs.get('session')
-
-        self.headers = {"content-type": "application/json"}
-        self.do_logout = False
-        self.auth_str = None
-
-    def _path(self, path, base_path=None):
-        """build rest url path"""
-        if path.startswith("http://") or path.startswith("https://"):
-            return path
-        if base_path is None:
-            base_path = self.base_path
-        if not path.startswith(base_path) and not (
-                self.local and ("/api" + path).startswith(base_path)):
-            path = "%s%s" % (base_path, path)
-        if self.local and path.startswith("/api"):
-            path = path[4:]
-        return self.url + path
-
-    def _authorize(self):
-        """Performs authorization setting x-auth-session"""
-        self.headers['authorization'] = 'Basic %s' % self.auth_str
-        if 'x-auth-session' in self.headers:
-            del self.headers['x-auth-session']
-
-        try:
-            result = self.post("/access/v1")
-            del self.headers['authorization']
-            if result.status == http_client.CREATED:
-                self.headers['x-auth-session'] = \
-                    result.get_header('x-auth-session')
-                self.do_logout = True
-                LOG.info('ZFSSA version: %s',
-                         result.get_header('x-zfssa-version'))
-
-            elif result.status == http_client.NOT_FOUND:
-                raise RestClientError(result.status, name="ERR_RESTError",
-                                      message="REST Not Available: \
-                                      Please Upgrade")
-
-        except RestClientError:
-            del self.headers['authorization']
-            raise
-
-    def login(self, auth_str):
-        """Login to an appliance using a user name and password.
-
-        Start a session like what is done logging into the BUI.  This is not a
-        requirement to run REST commands, since the protocol is stateless.
-        What is does is set up a cookie session so that some server side
-        caching can be done.  If login is used remember to call logout when
-        finished.
-
-        :param auth_str: Authorization string (base64)
-        """
-        self.auth_str = auth_str
-        self._authorize()
-
-    def logout(self):
-        """Logout of an appliance"""
-        result = None
-        try:
-            result = self.delete("/access/v1", base_path="/api")
-        except RestClientError:
-            pass
-
-        self.headers.clear()
-        self.do_logout = False
-        return result
-
-    def islogin(self):
-        """return if client is login"""
-        return self.do_logout
-
-    @staticmethod
-    def mkpath(*args, **kwargs):
-        """Make a path?query string for making a REST request
-
-        :cmd_params args: The path part
-        :cmd_params kwargs: The query part
-        """
-        buf = six.StringIO()
-        query = "?"
-        for arg in args:
-            buf.write("/")
-            buf.write(arg)
-        for k in kwargs:
-            buf.write(query)
-            if query == "?":
-                query = "&"
-            buf.write(k)
-            buf.write("=")
-            buf.write(kwargs[k])
-        return buf.getvalue()
-
-    def request(self, path, request, body=None, **kwargs):
-        """Make an HTTP request and return the results
-
-        :param path: Path used with the initialized URL to make a request
-        :param request: HTTP request type (GET, POST, PUT, DELETE)
-        :param body: HTTP body of request
-        :key accept: Set HTTP 'Accept' header with this value
-        :key base_path: Override the base_path for this request
-        :key content: Set HTTP 'Content-Type' header with this value
-        """
-        out_hdrs = dict.copy(self.headers)
-        if kwargs.get("accept"):
-            out_hdrs['accept'] = kwargs.get("accept")
-
-        if body:
-            if isinstance(body, dict):
-                body = json.dumps(body)
-            body = body.encode("utf-8")
-            out_hdrs['content-length'] = len(body)
-        else:
-            body = None
-
-        zfssaurl = self._path(path, kwargs.get("base_path"))
-        req = urllib.request.Request(zfssaurl, body, out_hdrs)
-        req.get_method = lambda: request
-        maxreqretries = kwargs.get("maxreqretries", 10)
-        retry = 0
-        response = None
-
-        LOG.debug('Request: %(request)s %(url)s',
-                  {'request': request, 'url': zfssaurl})
-        LOG.debug('Out headers: %s', out_hdrs)
-        if body and body != '':
-            # body may contain chap secret so must be masked
-            LOG.debug('Body: %s', strutils.mask_password(body))
-
-        context = None
-        if hasattr(ssl, '_create_unverified_context'):
-            context = ssl._create_unverified_context()
-        else:
-            context = None
-
-        while retry < maxreqretries:
-            try:
-                if context:
-                    # only schemes that can be used will be http or https if it
-                    # is given in the path variable, or the path will begin
-                    # with the REST API location meaning invalid or unwanted
-                    # schemes cannot be used
-                    response = urllib.request.urlopen(req,  # nosec
-                                                      timeout=self.timeout,
-                                                      context=context)
-                else:
-                    response = urllib.request.urlopen(req,  # nosec : see above
-                                                      timeout=self.timeout)
-            except urllib.error.HTTPError as err:
-                if err.code == http_client.NOT_FOUND:
-                    LOG.debug('REST Not Found: %s', err.code)
-                else:
-                    LOG.error('REST Not Available: %s', err.code)
-
-                if err.code == http_client.SERVICE_UNAVAILABLE and \
-                   retry < maxreqretries:
-                    retry += 1
-                    time.sleep(1)
-                    LOG.error('Server Busy retry request: %s', retry)
-                    continue
-                if (err.code == http_client.UNAUTHORIZED or
-                    err.code == http_client.INTERNAL_SERVER_ERROR) and \
-                   '/access/v1' not in zfssaurl:
-                    try:
-                        LOG.error('Authorizing request: %(zfssaurl)s '
-                                  'retry: %(retry)d.',
-                                  {'zfssaurl': zfssaurl, 'retry': retry})
-                        self._authorize()
-                        req.add_header('x-auth-session',
-                                       self.headers['x-auth-session'])
-                    except RestClientError:
-                        pass
-                    retry += 1
-                    time.sleep(1)
-                    continue
-
-                return RestResult(err=err)
-
-            except urllib.error.URLError as err:
-                LOG.error('URLError: %s', err.reason)
-                raise RestClientError(-1, name="ERR_URLError",
-                                      message=err.reason)
-
-            break
-
-        if (response and
-            (response.getcode() == http_client.SERVICE_UNAVAILABLE and
-                retry >= maxreqretries)):
-            raise RestClientError(response.getcode(), name="ERR_HTTPError",
-                                  message="REST Not Available: Disabled")
-
-        return RestResult(response=response)
-
-    def get(self, path, **kwargs):
-        """Make an HTTP GET request
-
-        :param path: Path to resource.
-        """
-        return self.request(path, "GET", **kwargs)
-
-    def post(self, path, body="", **kwargs):
-        """Make an HTTP POST request
-
-        :param path: Path to resource.
-        :param body: Post data content
-        """
-        return self.request(path, "POST", body, **kwargs)
-
-    def put(self, path, body="", **kwargs):
-        """Make an HTTP PUT request
-
-        :param path: Path to resource.
-        :param body: Put data content
-        """
-        return self.request(path, "PUT", body, **kwargs)
-
-    def delete(self, path, **kwargs):
-        """Make an HTTP DELETE request
-
-        :param path: Path to resource that will be deleted.
-        """
-        return self.request(path, "DELETE", **kwargs)
-
-    def head(self, path, **kwargs):
-        """Make an HTTP HEAD request
-
-        :param path: Path to resource.
-        """
-        return self.request(path, "HEAD", **kwargs)
diff -pruN 2:15.0.1-1/cinder/volume/drivers/zfssa/webdavclient.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/zfssa/webdavclient.py
--- 2:15.0.1-1/cinder/volume/drivers/zfssa/webdavclient.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/zfssa/webdavclient.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,160 +0,0 @@
-# Copyright (c) 2014, 2015, Oracle and/or its affiliates. All rights reserved.
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-"""
-ZFS Storage Appliance WebDAV Client
-"""
-
-import time
-
-from oslo_log import log
-from six.moves import http_client
-from six.moves import urllib
-
-from cinder import exception
-from cinder.i18n import _
-
-LOG = log.getLogger(__name__)
-
-bad_gateway_err = _('Check the state of the http service. Also ensure that '
-                    'the https port number is the same as the one specified '
-                    'in cinder.conf.')
-
-WebDAVHTTPErrors = {
-    http_client.UNAUTHORIZED: _('User not authorized to perform WebDAV '
-                                'operations.'),
-    http_client.BAD_GATEWAY: bad_gateway_err,
-    http_client.FORBIDDEN: _('Check access permissions for the ZFS share '
-                             'assigned to this driver.'),
-    http_client.NOT_FOUND: _('The source volume for this WebDAV operation not '
-                             'found.'),
-    http_client.INSUFFICIENT_STORAGE: _('Not enough storage space in the ZFS '
-                                        'share to perform this operation.')
-}
-
-WebDAVErrors = {
-    'BadStatusLine': _('http service may have been abruptly disabled or put '
-                       'to maintenance state in the middle of this '
-                       'operation.'),
-    'Bad_Gateway': bad_gateway_err
-}
-
-propertyupdate_data = """<?xml version="1.0"?>
-    <D:propertyupdate xmlns:D="DAV:">
-    <D:set>
-        <D:prop>
-            <D:prop_name>prop_val</D:prop_name>
-        </D:prop>
-    </D:set>
-    </D:propertyupdate>"""
-
-
-class WebDAVClientError(exception.VolumeDriverException):
-    message = _("The WebDAV request failed. Reason: %(msg)s, "
-                "Return code/reason: %(code)s, Source Volume: %(src)s, "
-                "Destination Volume: %(dst)s, Method: %(method)s.")
-
-
-class ZFSSAWebDAVClient(object):
-    def __init__(self, url, auth_str, **kwargs):
-        """Initialize WebDAV Client"""
-        self.https_path = url
-        self.auth_str = auth_str
-
-    def _lookup_error(self, error):
-        msg = ''
-        if error in http_client.responses:
-            msg = http_client.responses[error]
-
-        if error in WebDAVHTTPErrors:
-            msg = WebDAVHTTPErrors[error]
-        elif error in WebDAVErrors:
-            msg = WebDAVErrors[error]
-
-        return msg
-
-    def build_data(self, data, propname, value):
-        res = data.replace('prop_name', propname)
-        res = res.replace('prop_val', value)
-        return res
-
-    def set_file_prop(self, filename, propname, propval):
-        data = self.build_data(propertyupdate_data, propname, propval)
-        return self.request(src_file=filename, data=data, method='PROPPATCH')
-
-    def request(self, src_file="", dst_file="", method="", maxretries=10,
-                data=""):
-        retry = 0
-        src_url = self.https_path + "/" + src_file
-        dst_url = self.https_path + "/" + dst_file
-        request = urllib.request.Request(url=src_url, data=data)
-
-        if dst_file != "":
-            request.add_header('Destination', dst_url)
-        if method == "PROPPATCH":
-            request.add_header('Translate', 'F')
-
-        request.add_header("Authorization", "Basic %s" % self.auth_str)
-
-        request.get_method = lambda: method
-
-        LOG.debug('Sending WebDAV request:%(method)s %(src)s %(des)s',
-                  {'method': method, 'src': src_url, 'des': dst_url})
-
-        while retry < maxretries:
-            try:
-                # URLs are prepended with self.https_path which is safe
-                # meaning that the URL will either be safe or nonexistant
-                response = urllib.request.urlopen(  # nosec
-                    request, timeout=None)
-            except urllib.error.HTTPError as err:
-                LOG.error('WebDAV returned with %(code)s error during '
-                          '%(method)s call.',
-                          {'code': err.code, 'method': method})
-
-                if err.code == http_client.INTERNAL_SERVER_ERROR:
-                    LOG.error('WebDAV operation failed with error code: '
-                              '%(code)s reason: %(reason)s Retry attempt '
-                              '%(retry)s in progress.',
-                              {'code': err.code,
-                               'reason': err.reason,
-                               'retry': retry})
-                    if retry < maxretries:
-                        retry += 1
-                        time.sleep(1)
-                        continue
-
-                msg = self._lookup_error(err.code)
-                raise WebDAVClientError(msg=msg, code=err.code,
-                                        src=src_file, dst=dst_file,
-                                        method=method)
-
-            except http_client.BadStatusLine as err:
-                msg = self._lookup_error('BadStatusLine')
-                code = 'http_client.BadStatusLine'
-                raise WebDAVClientError(msg=msg, code=code,
-                                        src=src_file, dst=dst_file,
-                                        method=method)
-
-            except urllib.error.URLError as err:
-                reason = ''
-                if getattr(err, 'reason'):
-                    reason = err.reason
-
-                msg = self._lookup_error('Bad_Gateway')
-                raise WebDAVClientError(msg=msg, code=reason,
-                                        src=src_file,
-                                        dst=dst_file, method=method)
-
-            break
-        return response
diff -pruN 2:15.0.1-1/cinder/volume/drivers/zfssa/zfssaiscsi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/zfssa/zfssaiscsi.py
--- 2:15.0.1-1/cinder/volume/drivers/zfssa/zfssaiscsi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/zfssa/zfssaiscsi.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,1314 +0,0 @@
-# Copyright (c) 2014, 2017, Oracle and/or its affiliates. All rights reserved.
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-"""
-ZFS Storage Appliance Cinder Volume Driver
-"""
-import ast
-import math
-
-from oslo_config import cfg
-from oslo_log import log
-from oslo_serialization import base64
-from oslo_utils import excutils
-from oslo_utils import units
-import six
-
-from cinder import exception
-from cinder.i18n import _
-from cinder import interface
-from cinder import utils
-from cinder.volume import configuration
-from cinder.volume import driver
-from cinder.volume.drivers.san import san
-from cinder.volume.drivers.zfssa import zfssarest
-from cinder.volume import volume_types
-from cinder.volume import volume_utils
-
-import taskflow.engines
-from taskflow.patterns import linear_flow as lf
-from taskflow import task
-
-CONF = cfg.CONF
-LOG = log.getLogger(__name__)
-
-ZFSSA_OPTS = [
-    cfg.StrOpt('zfssa_pool',
-               help='Storage pool name.'),
-    cfg.StrOpt('zfssa_project',
-               help='Project name.'),
-    cfg.StrOpt('zfssa_lun_volblocksize', default='8k',
-               choices=['512', '1k', '2k', '4k', '8k', '16k', '32k', '64k',
-                        '128k'],
-               help='Block size.'),
-    cfg.BoolOpt('zfssa_lun_sparse', default=False,
-                help='Flag to enable sparse (thin-provisioned): True, False.'),
-    cfg.StrOpt('zfssa_lun_compression', default='off',
-               choices=['off', 'lzjb', 'gzip-2', 'gzip', 'gzip-9'],
-               help='Data compression.'),
-    cfg.StrOpt('zfssa_lun_logbias', default='latency',
-               choices=['latency', 'throughput'],
-               help='Synchronous write bias.'),
-    cfg.StrOpt('zfssa_initiator_group', default='',
-               help='iSCSI initiator group.'),
-    cfg.StrOpt('zfssa_initiator', default='',
-               help='iSCSI initiator IQNs. (comma separated)'),
-    cfg.StrOpt('zfssa_initiator_user', default='',
-               help='iSCSI initiator CHAP user (name).'),
-    cfg.StrOpt('zfssa_initiator_password', default='',
-               help='Secret of the iSCSI initiator CHAP user.', secret=True),
-    cfg.StrOpt('zfssa_initiator_config', default='',
-               help='iSCSI initiators configuration.'),
-    cfg.StrOpt('zfssa_target_group', default='tgt-grp',
-               help='iSCSI target group name.'),
-    cfg.StrOpt('zfssa_target_user', default='',
-               help='iSCSI target CHAP user (name).'),
-    cfg.StrOpt('zfssa_target_password', default='', secret=True,
-               help='Secret of the iSCSI target CHAP user.'),
-    cfg.StrOpt('zfssa_target_portal',
-               help='iSCSI target portal (Data-IP:Port, w.x.y.z:3260).'),
-    cfg.StrOpt('zfssa_target_interfaces',
-               help='Network interfaces of iSCSI targets. (comma separated)'),
-    cfg.IntOpt('zfssa_rest_timeout',
-               help='REST connection timeout. (seconds)'),
-    cfg.StrOpt('zfssa_replication_ip', default='',
-               help='IP address used for replication data. (maybe the same as '
-                    'data ip)'),
-    cfg.BoolOpt('zfssa_enable_local_cache', default=True,
-                help='Flag to enable local caching: True, False.'),
-    cfg.StrOpt('zfssa_cache_project', default='os-cinder-cache',
-               help='Name of ZFSSA project where cache volumes are stored.'),
-    cfg.StrOpt('zfssa_manage_policy', default='loose',
-               choices=['loose', 'strict'],
-               help='Driver policy for volume manage.')
-]
-
-CONF.register_opts(ZFSSA_OPTS, group=configuration.SHARED_CONF_GROUP)
-
-ZFSSA_LUN_SPECS = {
-    'zfssa:volblocksize',
-    'zfssa:sparse',
-    'zfssa:compression',
-    'zfssa:logbias',
-}
-
-
-def factory_zfssa():
-    return zfssarest.ZFSSAApi()
-
-
-@interface.volumedriver
-class ZFSSAISCSIDriver(driver.ISCSIDriver):
-    """ZFSSA Cinder iSCSI volume driver.
-
-    Version history:
-
-    .. code-block:: none
-
-        1.0.1:
-            Backend enabled volume migration.
-            Local cache feature.
-        1.0.2:
-            Volume manage/unmanage support.
-        1.0.3:
-            Fix multi-connect to enable live-migration (LP#1565051).
-        1.0.4:
-            Implement get_manageable_volumes().
-    """
-    VERSION = '1.0.4'
-    protocol = 'iSCSI'
-
-    # TODO(jsbryant) Remove driver in the 'U' release as Oracle
-    #                is dropping support.
-    SUPPORTED = False
-
-    # ThirdPartySystems wiki page
-    CI_WIKI_NAME = "Oracle_ZFSSA_CI"
-
-    def __init__(self, *args, **kwargs):
-        super(ZFSSAISCSIDriver, self).__init__(*args, **kwargs)
-        self.configuration.append_config_values(ZFSSA_OPTS)
-        self.configuration.append_config_values(san.san_opts)
-        self.zfssa = None
-        self.tgt_zfssa = None
-        self._stats = None
-        self.tgtiqn = None
-
-    @staticmethod
-    def get_driver_options():
-        return ZFSSA_OPTS
-
-    def _get_target_alias(self):
-        """return target alias."""
-        return self.configuration.zfssa_target_group
-
-    def do_setup(self, context):
-        """Setup - create multiple elements.
-
-        Project, initiators, initiatorgroup, target and targetgroup.
-        """
-        lcfg = self.configuration
-        LOG.info('Connecting to host: %s.', lcfg.san_ip)
-        self.zfssa = factory_zfssa()
-        self.tgt_zfssa = factory_zfssa()
-        self.zfssa.set_host(lcfg.san_ip, timeout=lcfg.zfssa_rest_timeout)
-        auth_str = '%s:%s' % (lcfg.san_login, lcfg.san_password)
-        auth_str = base64.encode_as_text(auth_str)
-        self.zfssa.login(auth_str)
-
-        self.zfssa.create_project(lcfg.zfssa_pool, lcfg.zfssa_project,
-                                  compression=lcfg.zfssa_lun_compression,
-                                  logbias=lcfg.zfssa_lun_logbias)
-
-        schemas = [
-            {'property': 'cinder_managed',
-             'description': 'Managed by Cinder',
-             'type': 'Boolean'}]
-
-        if lcfg.zfssa_enable_local_cache:
-            self.zfssa.create_project(lcfg.zfssa_pool,
-                                      lcfg.zfssa_cache_project,
-                                      compression=lcfg.zfssa_lun_compression,
-                                      logbias=lcfg.zfssa_lun_logbias)
-            schemas.extend([
-                {'property': 'image_id',
-                 'description': 'OpenStack image ID',
-                 'type': 'String'},
-                {'property': 'updated_at',
-                 'description': 'Most recent updated time of image',
-                 'type': 'String'}])
-
-        self.zfssa.create_schemas(schemas)
-
-        if (lcfg.zfssa_initiator_config != ''):
-            initiator_config = ast.literal_eval(lcfg.zfssa_initiator_config)
-            for initiator_group in initiator_config:
-                zfssa_initiator_group = initiator_group
-                for zfssa_initiator in initiator_config[zfssa_initiator_group]:
-                    self.zfssa.create_initiator(
-                        zfssa_initiator['iqn'],
-                        zfssa_initiator_group + '-' + zfssa_initiator['iqn'],
-                        chapuser=zfssa_initiator['user'],
-                        chapsecret=zfssa_initiator['password'])
-
-                    if (zfssa_initiator_group != 'default'):
-                        self.zfssa.add_to_initiatorgroup(
-                            zfssa_initiator['iqn'],
-                            zfssa_initiator_group)
-        else:
-            LOG.warning('zfssa_initiator_config not found. '
-                        'Using deprecated configuration options.')
-
-            if not lcfg.zfssa_initiator_group:
-                LOG.error('zfssa_initiator_group cannot be empty. '
-                          'Explicitly set the value "default" to use '
-                          'the default initiator group.')
-                raise exception.InvalidConfigurationValue(
-                    value='', option='zfssa_initiator_group')
-
-            if (not lcfg.zfssa_initiator and
-               lcfg.zfssa_initiator_group != 'default'):
-                LOG.error('zfssa_initiator cannot be empty when '
-                          'creating a zfssa_initiator_group.')
-                raise exception.InvalidConfigurationValue(
-                    value='', option='zfssa_initiator')
-
-            if lcfg.zfssa_initiator != '':
-                if lcfg.zfssa_initiator_group == 'default':
-                    LOG.warning('zfssa_initiator: %(ini)s wont be used on '
-                                'zfssa_initiator_group= %(inigrp)s.',
-                                {'ini': lcfg.zfssa_initiator,
-                                 'inigrp': lcfg.zfssa_initiator_group})
-
-                # Setup initiator and initiator group
-                else:
-                    for initiator in lcfg.zfssa_initiator.split(','):
-                        initiator = initiator.strip()
-                        self.zfssa.create_initiator(
-                            initiator,
-                            lcfg.zfssa_initiator_group + '-' + initiator,
-                            chapuser=lcfg.zfssa_initiator_user,
-                            chapsecret=lcfg.zfssa_initiator_password)
-                        self.zfssa.add_to_initiatorgroup(
-                            initiator, lcfg.zfssa_initiator_group)
-
-        # Parse interfaces
-        interfaces = []
-        for intrface in lcfg.zfssa_target_interfaces.split(','):
-            if intrface == '':
-                continue
-            interfaces.append(intrface)
-
-        # Setup target and target group
-        iqn = self.zfssa.create_target(
-            self._get_target_alias(),
-            interfaces,
-            tchapuser=lcfg.zfssa_target_user,
-            tchapsecret=lcfg.zfssa_target_password)
-
-        self.zfssa.add_to_targetgroup(iqn, lcfg.zfssa_target_group)
-
-        if lcfg.zfssa_manage_policy not in ("loose", "strict"):
-            err_msg = (_("zfssa_manage_policy property needs to be set to "
-                         "'strict' or 'loose'. Current value is: %s.") %
-                       lcfg.zfssa_manage_policy)
-            LOG.error(err_msg)
-            raise exception.InvalidInput(reason=err_msg)
-
-        # Lookup the zfssa_target_portal DNS name to an IP address
-        host, port = lcfg.zfssa_target_portal.split(':')
-        host_ip_addr = volume_utils.resolve_hostname(host)
-        self.zfssa_target_portal = host_ip_addr + ':' + port
-
-    def check_for_setup_error(self):
-        """Check that driver can login.
-
-        Check also pool, project, initiators, initiatorgroup, target and
-        targetgroup.
-        """
-        lcfg = self.configuration
-
-        self.zfssa.verify_pool(lcfg.zfssa_pool)
-        self.zfssa.verify_project(lcfg.zfssa_pool, lcfg.zfssa_project)
-
-        if (lcfg.zfssa_initiator_config != ''):
-            initiator_config = ast.literal_eval(lcfg.zfssa_initiator_config)
-            for initiator_group in initiator_config:
-                zfssa_initiator_group = initiator_group
-                for zfssa_initiator in initiator_config[zfssa_initiator_group]:
-                    self.zfssa.verify_initiator(zfssa_initiator['iqn'])
-        else:
-            if (lcfg.zfssa_initiator != '' and
-               lcfg.zfssa_initiator_group != '' and
-               lcfg.zfssa_initiator_group != 'default'):
-                for initiator in lcfg.zfssa_initiator.split(','):
-                    self.zfssa.verify_initiator(initiator)
-
-            self.zfssa.verify_target(self._get_target_alias())
-
-    def _get_provider_info(self):
-        """Return provider information."""
-        lcfg = self.configuration
-
-        if self.tgtiqn is None:
-            self.tgtiqn = self.zfssa.get_target(self._get_target_alias())
-
-        loc = "%s %s" % (self.zfssa_target_portal, self.tgtiqn)
-        LOG.debug('_get_provider_info: provider_location: %s', loc)
-        provider = {'provider_location': loc}
-        if lcfg.zfssa_target_user != '' and lcfg.zfssa_target_password != '':
-            provider['provider_auth'] = ('CHAP %s %s' %
-                                         (lcfg.zfssa_target_user,
-                                          lcfg.zfssa_target_password))
-
-        return provider
-
-    def create_volume(self, volume):
-        """Create a volume on ZFSSA."""
-        LOG.debug('zfssa.create_volume: volume=' + volume['name'])
-        lcfg = self.configuration
-        volsize = str(volume['size']) + 'g'
-        specs = self._get_voltype_specs(volume)
-        specs.update({'custom:cinder_managed': True})
-        self.zfssa.create_lun(lcfg.zfssa_pool,
-                              lcfg.zfssa_project,
-                              volume['name'],
-                              volsize,
-                              lcfg.zfssa_target_group,
-                              specs)
-
-    @utils.trace
-    def delete_volume(self, volume):
-        """Deletes a volume with the given volume['name']."""
-        lcfg = self.configuration
-
-        try:
-            lun2del = self.zfssa.get_lun(lcfg.zfssa_pool,
-                                         lcfg.zfssa_project,
-                                         volume['name'])
-        except exception.VolumeNotFound:
-            # Sometimes a volume exists in cinder for which there is no
-            # corresponding LUN (e.g. LUN create failed). In this case,
-            # allow deletion to complete (without doing anything on the
-            # ZFSSA). Any other exception should be passed up.
-            LOG.warning('No LUN found on ZFSSA corresponding to volume '
-                        'ID %s.', volume['id'])
-            return
-
-        # Delete clone temp snapshot. see create_cloned_volume()
-        if 'origin' in lun2del and 'id' in volume:
-            if lun2del['nodestroy']:
-                self.zfssa.set_lun_props(lcfg.zfssa_pool,
-                                         lcfg.zfssa_project,
-                                         volume['name'],
-                                         nodestroy=False)
-
-            tmpsnap = 'tmp-snapshot-%s' % volume['id']
-            if lun2del['origin']['snapshot'] == tmpsnap:
-                self.zfssa.delete_snapshot(lcfg.zfssa_pool,
-                                           lcfg.zfssa_project,
-                                           lun2del['origin']['share'],
-                                           lun2del['origin']['snapshot'])
-                return
-
-        self.zfssa.delete_lun(pool=lcfg.zfssa_pool,
-                              project=lcfg.zfssa_project,
-                              lun=volume['name'])
-
-        if ('origin' in lun2del and
-                lun2del['origin']['project'] == lcfg.zfssa_cache_project):
-            self._check_origin(lun2del, volume['name'])
-
-    def create_snapshot(self, snapshot):
-        """Creates a snapshot of a volume.
-
-        Snapshot name: snapshot['name']
-        Volume name: snapshot['volume_name']
-        """
-        LOG.debug('zfssa.create_snapshot: snapshot=%s', snapshot['name'])
-        lcfg = self.configuration
-        self.zfssa.create_snapshot(lcfg.zfssa_pool,
-                                   lcfg.zfssa_project,
-                                   snapshot['volume_name'],
-                                   snapshot['name'])
-
-    def delete_snapshot(self, snapshot):
-        """Deletes a snapshot."""
-        LOG.debug('zfssa.delete_snapshot: snapshot=%s', snapshot['name'])
-        lcfg = self.configuration
-        try:
-            snap2del = self.zfssa.get_lun_snapshot(lcfg.zfssa_pool,
-                                                   lcfg.zfssa_project,
-                                                   snapshot['volume_name'],
-                                                   snapshot['name'])
-        except exception.SnapshotNotFound:
-            # If snapshot creation failed, it may exist in the database
-            # but not on the ZFSSA. Exit silently in this case.
-            return
-
-        if snap2del['numclones'] > 0:
-            LOG.error('Snapshot %s: has clones', snapshot['name'])
-            raise exception.SnapshotIsBusy(snapshot_name=snapshot['name'])
-
-        self.zfssa.delete_snapshot(lcfg.zfssa_pool,
-                                   lcfg.zfssa_project,
-                                   snapshot['volume_name'],
-                                   snapshot['name'])
-
-    def create_volume_from_snapshot(self, volume, snapshot):
-        """Creates a volume from a snapshot - clone a snapshot."""
-        LOG.debug('zfssa.create_volume_from_snapshot: volume=%s',
-                  volume['name'])
-        LOG.debug('zfssa.create_volume_from_snapshot: snapshot=%s',
-                  snapshot['name'])
-
-        lcfg = self.configuration
-
-        parent_lun = self.zfssa.get_lun(lcfg.zfssa_pool,
-                                        lcfg.zfssa_project,
-                                        snapshot['volume_name'])
-        parent_size = parent_lun['size']
-
-        child_size = volume['size'] * units.Gi
-
-        if child_size < parent_size:
-            exception_msg = (_('Error clone [%(clone_id)s] '
-                               'size [%(clone_size)d] cannot '
-                               'be smaller than parent volume '
-                               '[%(parent_id)s] size '
-                               '[%(parent_size)d]')
-                             % {'parent_id': snapshot['volume_name'],
-                                'parent_size': parent_size / units.Gi,
-                                'clone_id': volume['name'],
-                                'clone_size': volume['size']})
-            LOG.error(exception_msg)
-            raise exception.InvalidInput(reason=exception_msg)
-
-        specs = self._get_voltype_specs(volume)
-        specs.update({'custom:cinder_managed': True})
-
-        self.zfssa.clone_snapshot(lcfg.zfssa_pool,
-                                  lcfg.zfssa_project,
-                                  snapshot['volume_name'],
-                                  snapshot['name'],
-                                  lcfg.zfssa_project,
-                                  volume['name'],
-                                  specs)
-
-        if child_size > parent_size:
-            LOG.debug('zfssa.create_volume_from_snapshot:  '
-                      'Parent size [%(parent_size)d], '
-                      'Child size [%(child_size)d] - resizing',
-                      {'parent_size': parent_size, 'child_size': child_size})
-            self.zfssa.set_lun_props(lcfg.zfssa_pool,
-                                     lcfg.zfssa_project,
-                                     volume['name'],
-                                     volsize=child_size)
-
-    def _update_volume_status(self):
-        """Retrieve status info from volume group."""
-        LOG.debug("Updating volume status")
-        self._stats = None
-        data = {}
-        backend_name = self.configuration.safe_get('volume_backend_name')
-        data["volume_backend_name"] = backend_name or self.__class__.__name__
-        data["vendor_name"] = 'Oracle'
-        data["driver_version"] = self.VERSION
-        data["storage_protocol"] = self.protocol
-
-        lcfg = self.configuration
-        (avail, total) = self.zfssa.get_project_stats(lcfg.zfssa_pool,
-                                                      lcfg.zfssa_project)
-        if avail is None or total is None:
-            return
-
-        host = lcfg.san_ip
-        pool = lcfg.zfssa_pool
-        project = lcfg.zfssa_project
-        auth_str = '%s:%s' % (lcfg.san_login, lcfg.san_password)
-        auth_str = base64.encode_as_text(auth_str)
-        zfssa_tgt_group = lcfg.zfssa_target_group
-        repl_ip = lcfg.zfssa_replication_ip
-
-        data['location_info'] = "%s:%s:%s:%s:%s:%s" % (host, auth_str, pool,
-                                                       project,
-                                                       zfssa_tgt_group,
-                                                       repl_ip)
-
-        data['total_capacity_gb'] = int(total) / units.Gi
-        data['free_capacity_gb'] = int(avail) / units.Gi
-        data['reserved_percentage'] = 0
-        data['QoS_support'] = False
-
-        pool_details = self.zfssa.get_pool_details(lcfg.zfssa_pool)
-        data['zfssa_poolprofile'] = pool_details['profile']
-        data['zfssa_volblocksize'] = lcfg.zfssa_lun_volblocksize
-        data['zfssa_sparse'] = six.text_type(lcfg.zfssa_lun_sparse)
-        data['zfssa_compression'] = lcfg.zfssa_lun_compression
-        data['zfssa_logbias'] = lcfg.zfssa_lun_logbias
-        data['multiattach'] = True
-
-        self._stats = data
-
-    def get_volume_stats(self, refresh=False):
-        """Get volume status.
-
-        If 'refresh' is True, run update the stats first.
-        """
-        if refresh:
-            self._update_volume_status()
-        return self._stats
-
-    def create_export(self, context, volume, connector):
-        pass
-
-    def remove_export(self, context, volume):
-        pass
-
-    def ensure_export(self, context, volume):
-        pass
-
-    def extend_volume(self, volume, new_size):
-        """Driver entry point to extent volume size."""
-        LOG.debug('extend_volume: volume name: %s', volume['name'])
-        lcfg = self.configuration
-        self.zfssa.set_lun_props(lcfg.zfssa_pool,
-                                 lcfg.zfssa_project,
-                                 volume['name'],
-                                 volsize=new_size * units.Gi)
-
-    def create_cloned_volume(self, volume, src_vref):
-        """Create a clone of the specified volume."""
-        zfssa_snapshot = {'volume_name': src_vref['name'],
-                          'name': 'tmp-snapshot-%s' % volume['id']}
-        self.create_snapshot(zfssa_snapshot)
-        try:
-            self.create_volume_from_snapshot(volume, zfssa_snapshot)
-        except exception.VolumeBackendAPIException:
-            LOG.error('Clone Volume: %(volume)s failed from source volume: '
-                      '%(src_vref)s',
-                      {'volume': volume['name'],
-                       'src_vref': src_vref['name']})
-            # Cleanup snapshot
-            self.delete_snapshot(zfssa_snapshot)
-
-    @utils.synchronized('zfssaiscsi', external=True)
-    def clone_image(self, context, volume,
-                    image_location, image_meta,
-                    image_service):
-        """Create a volume efficiently from an existing image.
-
-        Verify the image ID being used:
-
-        (1) If there is no existing cache volume, create one and transfer
-        image data to it. Take a snapshot.
-
-        (2) If a cache volume already exists, verify if it is either alternated
-        or updated. If so try to remove it, raise exception if removal fails.
-        Create a new cache volume as in (1).
-
-        Clone a volume from the cache volume and returns it to Cinder.
-
-        A file lock is placed on this method to prevent:
-
-        (a) a race condition when a cache volume has been verified, but then
-        gets deleted before it is cloned.
-
-        (b) failure of subsequent clone_image requests if the first request is
-        still pending.
-        """
-        LOG.debug('Cloning image %(image)s to volume %(volume)s',
-                  {'image': image_meta['id'], 'volume': volume['name']})
-        lcfg = self.configuration
-        if not lcfg.zfssa_enable_local_cache:
-            return None, False
-
-        cachevol_size = image_meta['size']
-        if 'virtual_size' in image_meta and image_meta['virtual_size']:
-            cachevol_size = image_meta['virtual_size']
-
-        cachevol_size_gb = int(math.ceil(float(cachevol_size) / units.Gi))
-
-        # Make sure the volume is big enough since cloning adds extra metadata.
-        # Having it as X Gi can cause creation failures.
-        if cachevol_size % units.Gi == 0:
-            cachevol_size_gb += 1
-
-        if cachevol_size_gb > volume['size']:
-            exception_msg = ('Image size %(img_size)dGB is larger '
-                             'than volume size %(vol_size)dGB.',
-                             {'img_size': cachevol_size_gb,
-                              'vol_size': volume['size']})
-            LOG.error(exception_msg)
-            return None, False
-
-        specs = self._get_voltype_specs(volume)
-        specs.update({'custom:cinder_managed': True})
-        cachevol_props = {'size': cachevol_size_gb}
-
-        try:
-            cache_vol, cache_snap = self._verify_cache_volume(context,
-                                                              image_meta,
-                                                              image_service,
-                                                              specs,
-                                                              cachevol_props)
-            # A cache volume and a snapshot should be ready by now
-            # Create a clone from the cache volume
-            self.zfssa.clone_snapshot(lcfg.zfssa_pool,
-                                      lcfg.zfssa_cache_project,
-                                      cache_vol,
-                                      cache_snap,
-                                      lcfg.zfssa_project,
-                                      volume['name'],
-                                      specs)
-            if cachevol_size_gb < volume['size']:
-                self.extend_volume(volume, volume['size'])
-        except exception.VolumeBackendAPIException as exc:
-            exception_msg = ('Cannot clone image %(image)s to '
-                             'volume %(volume)s. Error: %(error)s.',
-                             {'volume': volume['name'],
-                              'image': image_meta['id'],
-                              'error': exc.msg})
-            LOG.error(exception_msg)
-            return None, False
-
-        return None, True
-
-    def _verify_cache_volume(self, context, img_meta,
-                             img_service, specs, cachevol_props):
-        """Verify if we have a cache volume that we want.
-
-        If we don't, create one.
-        If we do, check if it's been updated:
-          * If so, delete it and recreate a new volume
-          * If not, we are good.
-
-        If it's out of date, delete it and create a new one.
-        After the function returns, there should be a cache volume available,
-        ready for cloning.
-        """
-        lcfg = self.configuration
-        cachevol_name = 'os-cache-vol-%s' % img_meta['id']
-        cachesnap_name = 'image-%s' % img_meta['id']
-        cachevol_meta = {
-            'cache_name': cachevol_name,
-            'snap_name': cachesnap_name,
-        }
-        cachevol_props.update(cachevol_meta)
-        cache_vol, cache_snap = None, None
-        updated_at = six.text_type(img_meta['updated_at'].isoformat())
-        LOG.debug('Verifying cache volume: %s', cachevol_name)
-
-        try:
-            cache_vol = self.zfssa.get_lun(lcfg.zfssa_pool,
-                                           lcfg.zfssa_cache_project,
-                                           cachevol_name)
-            if (not cache_vol.get('updated_at', None) or
-                    not cache_vol.get('image_id', None)):
-                exc_msg = (_('Cache volume %s does not have required '
-                             'properties') % cachevol_name)
-                LOG.error(exc_msg)
-                raise exception.VolumeBackendAPIException(data=exc_msg)
-
-            cache_snap = self.zfssa.get_lun_snapshot(lcfg.zfssa_pool,
-                                                     lcfg.zfssa_cache_project,
-                                                     cachevol_name,
-                                                     cachesnap_name)
-        except exception.VolumeNotFound:
-            # There is no existing cache volume, create one:
-            return self._create_cache_volume(context,
-                                             img_meta,
-                                             img_service,
-                                             specs,
-                                             cachevol_props)
-        except exception.SnapshotNotFound:
-            exception_msg = (_('Cache volume %(cache_vol)s '
-                               'does not have snapshot %(cache_snap)s.'),
-                             {'cache_vol': cachevol_name,
-                              'cache_snap': cachesnap_name})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        # A cache volume does exist, check if it's updated:
-        if ((cache_vol['updated_at'] != updated_at) or
-                (cache_vol['image_id'] != img_meta['id'])):
-            # The cache volume is updated, but has clones:
-            if cache_snap['numclones'] > 0:
-                exception_msg = (_('Cannot delete '
-                                   'cache volume: %(cachevol_name)s. '
-                                   'It was updated at %(updated_at)s '
-                                   'and currently has %(numclones)s '
-                                   'volume instances.'),
-                                 {'cachevol_name': cachevol_name,
-                                  'updated_at': updated_at,
-                                  'numclones': cache_snap['numclones']})
-                LOG.error(exception_msg)
-                raise exception.VolumeBackendAPIException(data=exception_msg)
-
-            # The cache volume is updated, but has no clone, so we delete it
-            # and re-create a new one:
-            self.zfssa.delete_lun(lcfg.zfssa_pool,
-                                  lcfg.zfssa_cache_project,
-                                  cachevol_name)
-            return self._create_cache_volume(context,
-                                             img_meta,
-                                             img_service,
-                                             specs,
-                                             cachevol_props)
-
-        return cachevol_name, cachesnap_name
-
-    def _create_cache_volume(self, context, img_meta,
-                             img_service, specs, cachevol_props):
-        """Create a cache volume from an image.
-
-        Returns names of the cache volume and its snapshot.
-        """
-        lcfg = self.configuration
-        cachevol_size = int(cachevol_props['size'])
-        lunsize = "%sg" % six.text_type(cachevol_size)
-        lun_props = {
-            'custom:image_id': img_meta['id'],
-            'custom:updated_at': (
-                six.text_type(img_meta['updated_at'].isoformat())),
-        }
-        lun_props.update(specs)
-
-        cache_vol = {
-            'name': cachevol_props['cache_name'],
-            'id': img_meta['id'],
-            'size': cachevol_size,
-        }
-        LOG.debug('Creating cache volume %s.', cache_vol['name'])
-
-        try:
-            self.zfssa.create_lun(lcfg.zfssa_pool,
-                                  lcfg.zfssa_cache_project,
-                                  cache_vol['name'],
-                                  lunsize,
-                                  lcfg.zfssa_target_group,
-                                  lun_props)
-            super(ZFSSAISCSIDriver, self).copy_image_to_volume(context,
-                                                               cache_vol,
-                                                               img_service,
-                                                               img_meta['id'])
-            self.zfssa.create_snapshot(lcfg.zfssa_pool,
-                                       lcfg.zfssa_cache_project,
-                                       cache_vol['name'],
-                                       cachevol_props['snap_name'])
-        except Exception as exc:
-            exc_msg = (_('Fail to create cache volume %(volume)s. '
-                         'Error: %(err)s'),
-                       {'volume': cache_vol['name'],
-                        'err': six.text_type(exc)})
-            LOG.error(exc_msg)
-            self.zfssa.delete_lun(lcfg.zfssa_pool,
-                                  lcfg.zfssa_cache_project,
-                                  cache_vol['name'])
-            raise exception.VolumeBackendAPIException(data=exc_msg)
-
-        return cachevol_props['cache_name'], cachevol_props['snap_name']
-
-    def local_path(self, volume):
-        """Not implemented."""
-        pass
-
-    @utils.trace
-    def initialize_connection(self, volume, connector):
-        """Driver entry point to setup a connection for a volume."""
-        lcfg = self.configuration
-        init_groups = self.zfssa.get_initiator_initiatorgroup(
-            connector['initiator'])
-        if not init_groups:
-            if lcfg.zfssa_initiator_group == 'default':
-                init_groups.append('default')
-            else:
-                exception_msg = (_('Failed to find iSCSI initiator group '
-                                   'containing %(initiator)s.')
-                                 % {'initiator': connector['initiator']})
-                LOG.error(exception_msg)
-                raise exception.VolumeBackendAPIException(data=exception_msg)
-        if ((lcfg.zfssa_enable_local_cache is True) and
-                (volume['name'].startswith('os-cache-vol-'))):
-            project = lcfg.zfssa_cache_project
-        else:
-            project = lcfg.zfssa_project
-
-        lun = self.zfssa.get_lun(lcfg.zfssa_pool, project, volume['name'])
-
-        # Construct a set (to avoid duplicates) of initiator groups by
-        # combining the list to which the LUN is already presented with
-        # the list for the new connector.
-        new_init_groups = set(lun['initiatorgroup'] + init_groups)
-        self.zfssa.set_lun_initiatorgroup(lcfg.zfssa_pool,
-                                          project,
-                                          volume['name'],
-                                          sorted(list(new_init_groups)))
-
-        iscsi_properties = {}
-        provider = self._get_provider_info()
-
-        (target_portal, target_iqn) = provider['provider_location'].split()
-        iscsi_properties['target_discovered'] = False
-
-        # Get LUN again to discover new initiator group mapping
-        lun = self.zfssa.get_lun(lcfg.zfssa_pool, project, volume['name'])
-
-        # Construct a mapping of LU number to initiator group.
-        lu_map = dict(zip(lun['initiatorgroup'], lun['number']))
-
-        # When an initiator is a member of multiple groups, and a LUN is
-        # presented to all of them, the same LU number is assigned to all of
-        # them, so we can use the first initator group containing the
-        # initiator to lookup the right LU number in our mapping
-        target_lun = int(lu_map[init_groups[0]])
-
-        # Including both singletons and lists below allows basic operation when
-        # the connector is using multipath, although only one path will be
-        # provided. This is necessary to handle the case where the ZFSSA
-        # cluster node has failed, and the other node has taken over the pool.
-        # In that case, the network interface of the remaining node responds to
-        # an iSCSI sendtargets discovery with BOTH targets, which os-brick
-        # interprets as both targets providing paths to the desired LUN, which
-        # can cause one instance to attempt to access another instance's LUN.
-        iscsi_properties['target_portal'] = target_portal
-        iscsi_properties['target_portals'] = [target_portal]
-        iscsi_properties['target_iqn'] = target_iqn
-        iscsi_properties['target_iqns'] = [target_iqn]
-        iscsi_properties['target_lun'] = target_lun
-        iscsi_properties['target_luns'] = [target_lun]
-
-        iscsi_properties['volume_id'] = volume['id']
-
-        if 'provider_auth' in provider:
-            (auth_method, auth_username, auth_password) = provider[
-                'provider_auth'].split()
-            iscsi_properties['auth_method'] = auth_method
-            iscsi_properties['auth_username'] = auth_username
-            iscsi_properties['auth_password'] = auth_password
-
-        return {
-            'driver_volume_type': 'iscsi',
-            'data': iscsi_properties
-        }
-
-    @utils.trace
-    def terminate_connection(self, volume, connector, **kwargs):
-        """Driver entry point to terminate a connection for a volume."""
-        lcfg = self.configuration
-        project = lcfg.zfssa_project
-        pool = lcfg.zfssa_pool
-
-        # If connector is None, assume that we're expected to disconnect
-        # the volume from all initiators
-        if connector is None:
-            new_init_groups = []
-        else:
-            connector_init_groups = self.zfssa.get_initiator_initiatorgroup(
-                connector['initiator'])
-            if ((lcfg.zfssa_enable_local_cache is True) and
-                    (volume['name'].startswith('os-cache-vol-'))):
-                project = lcfg.zfssa_cache_project
-            lun = self.zfssa.get_lun(pool, project, volume['name'])
-            # Construct the new set of initiator groups, starting with the list
-            # that the volume is currently connected to, then removing those
-            # associated with the connector that we're detaching from
-            new_init_groups = set(lun['initiatorgroup'])
-            new_init_groups -= set(connector_init_groups)
-
-        self.zfssa.set_lun_initiatorgroup(pool,
-                                          project,
-                                          volume['name'],
-                                          sorted(list(new_init_groups)))
-
-    def _get_voltype_specs(self, volume):
-        """Get specs suitable for volume creation."""
-        vtype = volume.get('volume_type_id', None)
-        extra_specs = None
-        if vtype:
-            extra_specs = volume_types.get_volume_type_extra_specs(vtype)
-
-        return self._get_specs(extra_specs)
-
-    def _get_specs(self, xspecs):
-        """Return a dict with extra specs and/or config values."""
-        result = {}
-        for spc in ZFSSA_LUN_SPECS:
-            val = None
-            prop = spc.split(':')[1]
-            cfg = 'zfssa_lun_' + prop
-            if xspecs:
-                val = xspecs.pop(spc, None)
-
-            if val is None:
-                val = self.configuration.safe_get(cfg)
-
-            if val is not None and val != '':
-                result.update({prop: val})
-
-        return result
-
-    def migrate_volume(self, ctxt, volume, host):
-        LOG.debug('Attempting ZFSSA enabled volume migration. volume: %(id)s, '
-                  'host: %(host)s, status=%(status)s.',
-                  {'id': volume['id'],
-                   'host': host,
-                   'status': volume['status']})
-
-        lcfg = self.configuration
-        default_ret = (False, None)
-
-        if volume['status'] != "available":
-            LOG.debug('Only available volumes can be migrated using backend '
-                      'assisted migration. Defaulting to generic migration.')
-            return default_ret
-
-        if (host['capabilities']['vendor_name'] != 'Oracle' or
-                host['capabilities']['storage_protocol'] != self.protocol):
-            LOG.debug('Source and destination drivers need to be Oracle iSCSI '
-                      'to use backend assisted migration. Defaulting to '
-                      'generic migration.')
-            return default_ret
-
-        if 'location_info' not in host['capabilities']:
-            LOG.debug('Could not find location_info in capabilities reported '
-                      'by the destination driver. Defaulting to generic '
-                      'migration.')
-            return default_ret
-
-        loc_info = host['capabilities']['location_info']
-
-        try:
-            (tgt_host, auth_str, tgt_pool, tgt_project, tgt_tgtgroup,
-             tgt_repl_ip) = loc_info.split(':')
-        except ValueError:
-            LOG.error("Location info needed for backend enabled volume "
-                      "migration not in correct format: %s. Continuing "
-                      "with generic volume migration.", loc_info)
-            return default_ret
-
-        if tgt_repl_ip == '':
-            LOG.error("zfssa_replication_ip not set in cinder.conf. "
-                      "zfssa_replication_ip is needed for backend enabled "
-                      "volume migration. Continuing with generic volume "
-                      "migration.")
-            return default_ret
-
-        src_pool = lcfg.zfssa_pool
-        src_project = lcfg.zfssa_project
-
-        try:
-            LOG.info('Connecting to target host: %s for backend enabled '
-                     'migration.', tgt_host)
-            self.tgt_zfssa.set_host(tgt_host)
-            self.tgt_zfssa.login(auth_str)
-
-            # Verify that the replication service is online
-            try:
-                self.zfssa.verify_service('replication')
-                self.tgt_zfssa.verify_service('replication')
-            except exception.VolumeBackendAPIException:
-                return default_ret
-
-            # ensure that a target group by the same name exists on the target
-            # system also, if not, use default migration.
-            lun = self.zfssa.get_lun(src_pool, src_project, volume['name'])
-
-            if lun['targetgroup'] != tgt_tgtgroup:
-                return default_ret
-
-            tgt_asn = self.tgt_zfssa.get_asn()
-            src_asn = self.zfssa.get_asn()
-
-            # verify on the source system that the destination has been
-            # registered as a replication target
-            tgts = self.zfssa.get_replication_targets()
-            targets = []
-            for target in tgts['targets']:
-                if target['asn'] == tgt_asn:
-                    targets.append(target)
-
-            if targets == []:
-                LOG.debug('Target host: %(host)s for volume migration '
-                          'not configured as a replication target '
-                          'for volume: %(vol)s.',
-                          {'host': tgt_repl_ip,
-                           'vol': volume['name']})
-                return default_ret
-
-            # Multiple ips from the same appliance may be configured
-            # as different targets
-            for target in targets:
-                if target['address'] == tgt_repl_ip + ':216':
-                    break
-
-            if target['address'] != tgt_repl_ip + ':216':
-                LOG.debug('Target with replication ip: %s not configured on '
-                          'the source appliance for backend enabled volume '
-                          'migration. Proceeding with default migration.',
-                          tgt_repl_ip)
-                return default_ret
-
-            flow = lf.Flow('zfssa_volume_migration').add(
-                MigrateVolumeInit(),
-                MigrateVolumeCreateAction(provides='action_id'),
-                MigrateVolumeSendReplUpdate(),
-                MigrateVolumeSeverRepl(),
-                MigrateVolumeMoveVol(),
-                MigrateVolumeCleanUp()
-            )
-            taskflow.engines.run(flow,
-                                 store={'driver': self,
-                                        'tgt_zfssa': self.tgt_zfssa,
-                                        'tgt_pool': tgt_pool,
-                                        'tgt_project': tgt_project,
-                                        'volume': volume,
-                                        'tgt_asn': tgt_asn,
-                                        'src_zfssa': self.zfssa,
-                                        'src_asn': src_asn,
-                                        'src_pool': src_pool,
-                                        'src_project': src_project,
-                                        'target': target})
-
-            return(True, None)
-
-        except Exception:
-            LOG.error("Error migrating volume: %s", volume['name'])
-            raise
-
-    def update_migrated_volume(self, ctxt, volume, new_volume,
-                               original_volume_status):
-        """Return model update for migrated volume.
-
-        :param volume: The original volume that was migrated to this backend
-        :param new_volume: The migration volume object that was created on
-                           this backend as part of the migration process
-        :param original_volume_status: The status of the original volume
-        :returns: model_update to update DB with any needed changes
-        """
-
-        lcfg = self.configuration
-        original_name = CONF.volume_name_template % volume['id']
-        current_name = CONF.volume_name_template % new_volume['id']
-
-        LOG.debug('Renaming migrated volume: %(cur)s to %(org)s',
-                  {'cur': current_name,
-                   'org': original_name})
-        self.zfssa.set_lun_props(lcfg.zfssa_pool, lcfg.zfssa_project,
-                                 current_name, name=original_name)
-        return {'_name_id': None}
-
-    @utils.synchronized('zfssaiscsi', external=True)
-    def _check_origin(self, lun, volname):
-        """Verify the cache volume of a bootable volume.
-
-        If the cache no longer has clone, it will be deleted.
-        There is a small lag between the time a clone is deleted and the number
-        of clones being updated accordingly. There is also a race condition
-        when multiple volumes (clones of a cache volume) are deleted at once,
-        leading to the number of clones reported incorrectly. The file lock is
-        here to avoid such issues.
-        """
-        lcfg = self.configuration
-        cache = lun['origin']
-        numclones = -1
-        if (cache['snapshot'].startswith('image-') and
-                cache['share'].startswith('os-cache-vol')):
-            try:
-                snap = self.zfssa.get_lun_snapshot(lcfg.zfssa_pool,
-                                                   lcfg.zfssa_cache_project,
-                                                   cache['share'],
-                                                   cache['snapshot'])
-                numclones = snap['numclones']
-            except Exception:
-                LOG.debug('Cache volume is already deleted.')
-                return
-
-            LOG.debug('Checking cache volume %(name)s, numclones = %(clones)d',
-                      {'name': cache['share'], 'clones': numclones})
-
-        # Sometimes numclones still hold old values even when all clones
-        # have been deleted. So we handle this situation separately here:
-        if numclones == 1:
-            try:
-                self.zfssa.get_lun(lcfg.zfssa_pool,
-                                   lcfg.zfssa_project,
-                                   volname)
-                # The volume does exist, so return
-                return
-            except exception.VolumeNotFound:
-                # The volume is already deleted
-                numclones = 0
-
-        if numclones == 0:
-            try:
-                self.zfssa.delete_lun(lcfg.zfssa_pool,
-                                      lcfg.zfssa_cache_project,
-                                      cache['share'])
-            except exception.VolumeBackendAPIException:
-                LOG.warning("Volume %s exists but can't be deleted.",
-                            cache['share'])
-
-    def get_manageable_volumes(self, cinder_volumes, marker, limit, offset,
-                               sort_keys, sort_dirs):
-        lcfg = self.configuration
-        manageable_volumes = []
-        managed_vols = [vol['id'] for vol in cinder_volumes]
-
-        for lun in self.zfssa.get_all_luns(lcfg.zfssa_pool,
-                                           lcfg.zfssa_project):
-            lun_info = {
-                'reference': {'source-name': lun['name']},
-                'size': int(math.ceil(float(lun['size']) / units.Gi)),
-                'cinder_id': None,
-                'extra_info': None,
-                'safe_to_manage': True,
-                'reason_not_safe': None,
-            }
-            if ('cinder_managed' not in lun and
-                    lcfg.zfssa_manage_policy != 'loose'):
-                lun_info['safe_to_manage'] = False
-                lun_info['reason_not_safe'] = 'cinder_managed schema ' \
-                                              'not present'
-            elif lun.get('cinder_managed', False):
-                lun_info['safe_to_manage'] = False
-                vol_id = volume_utils.extract_id_from_volume_name(lun['name'])
-                if vol_id in managed_vols:
-                    lun_info['reason_not_safe'] = 'already managed'
-                    lun_info['cinder_id'] = vol_id
-                else:
-                    lun_info['reason_not_safe'] = \
-                        'managed by another cinder instance?'
-            manageable_volumes.append(lun_info)
-
-        return volume_utils.paginate_entries_list(
-            manageable_volumes, marker, limit, offset, sort_keys, sort_dirs)
-
-    def manage_existing(self, volume, existing_ref):
-        """Manage an existing volume in the ZFSSA backend.
-
-        :param volume: Reference to the new volume.
-        :param existing_ref: Reference to the existing volume to be managed.
-        """
-        lcfg = self.configuration
-
-        existing_vol = self._get_existing_vol(existing_ref)
-        self._verify_volume_to_manage(existing_vol)
-
-        new_vol_name = volume['name']
-
-        try:
-            self.zfssa.set_lun_props(lcfg.zfssa_pool,
-                                     lcfg.zfssa_project,
-                                     existing_vol['name'],
-                                     name=new_vol_name,
-                                     schema={"custom:cinder_managed": True})
-        except exception.VolumeBackendAPIException:
-            with excutils.save_and_reraise_exception():
-                LOG.error("Failed to rename volume %(existing)s to "
-                          "%(new)s. Volume manage failed.",
-                          {'existing': existing_vol['name'],
-                           'new': new_vol_name})
-        return None
-
-    def manage_existing_get_size(self, volume, existing_ref):
-        """Return size of the volume to be managed by manage_existing."""
-        existing_vol = self._get_existing_vol(existing_ref)
-
-        size = existing_vol['size']
-        return int(math.ceil(float(size) / units.Gi))
-
-    def unmanage(self, volume):
-        """Remove an existing volume from cinder management.
-
-        :param volume: Reference to the volume to be unmanaged.
-        """
-        lcfg = self.configuration
-        new_name = 'unmanaged-' + volume['name']
-        try:
-            self.zfssa.set_lun_props(lcfg.zfssa_pool,
-                                     lcfg.zfssa_project,
-                                     volume['name'],
-                                     name=new_name,
-                                     schema={"custom:cinder_managed": False})
-        except exception.VolumeBackendAPIException:
-            with excutils.save_and_reraise_exception():
-                LOG.error("Failed to rename volume %(existing)s to "
-                          "%(new)s. Volume unmanage failed.",
-                          {'existing': volume['name'],
-                           'new': new_name})
-        return None
-
-    def _verify_volume_to_manage(self, volume):
-        lcfg = self.configuration
-        if lcfg.zfssa_manage_policy == 'loose':
-            return
-
-        vol_name = volume['name']
-
-        if 'cinder_managed' not in volume:
-            err_msg = (_("Unknown if the volume: %s to be managed is "
-                         "already being managed by Cinder. Aborting manage "
-                         "volume. Please add 'cinder_managed' custom schema "
-                         "property to the volume and set its value to False. "
-                         "Alternatively, set the value of cinder config "
-                         "policy 'zfssa_manage_policy' to 'loose' to "
-                         "remove this restriction.") % vol_name)
-            LOG.error(err_msg)
-            raise exception.InvalidInput(reason=err_msg)
-
-        if volume['cinder_managed'] is True:
-            msg = (_("Volume: %s is already being managed by Cinder.")
-                   % vol_name)
-            LOG.error(msg)
-            raise exception.ManageExistingAlreadyManaged(volume_ref=vol_name)
-
-    def _get_existing_vol(self, existing_ref):
-        lcfg = self.configuration
-        if 'source-name' not in existing_ref:
-            msg = (_("Reference to volume: %s to be managed must contain "
-                   "source-name.") % existing_ref)
-            raise exception.ManageExistingInvalidReference(
-                existing_ref=existing_ref, reason=msg)
-        try:
-            existing_vol = self.zfssa.get_lun(lcfg.zfssa_pool,
-                                              lcfg.zfssa_project,
-                                              existing_ref['source-name'])
-        except exception.VolumeNotFound:
-            err_msg = (_("No LUN with name %s exists on the ZFSSA "
-                         "backend.") % existing_ref['source-name'])
-            LOG.error(err_msg)
-            raise exception.ManageExistingInvalidReference(
-                existing_ref=existing_ref, reason=err_msg)
-        return existing_vol
-
-
-class MigrateVolumeInit(task.Task):
-    def execute(self, src_zfssa, volume, src_pool, src_project):
-        LOG.debug('Setting inherit flag on source backend to False.')
-        src_zfssa.edit_inherit_replication_flag(src_pool, src_project,
-                                                volume['name'], set=False)
-
-    def revert(self, src_zfssa, volume, src_pool, src_project, **kwargs):
-        LOG.debug('Rollback: Setting inherit flag on source appliance to '
-                  'True.')
-        src_zfssa.edit_inherit_replication_flag(src_pool, src_project,
-                                                volume['name'], set=True)
-
-
-class MigrateVolumeCreateAction(task.Task):
-    def execute(self, src_zfssa, volume, src_pool, src_project, target,
-                tgt_pool):
-        LOG.debug('Creating replication action on source appliance.')
-        action_id = src_zfssa.create_replication_action(src_pool,
-                                                        src_project,
-                                                        target['label'],
-                                                        tgt_pool,
-                                                        volume['name'])
-
-        self._action_id = action_id
-        return action_id
-
-    def revert(self, src_zfssa, **kwargs):
-        if hasattr(self, '_action_id'):
-            LOG.debug('Rollback: deleting replication action on source '
-                      'appliance.')
-            src_zfssa.delete_replication_action(self._action_id)
-
-
-class MigrateVolumeSendReplUpdate(task.Task):
-    def execute(self, src_zfssa, action_id):
-        LOG.debug('Sending replication update from source appliance.')
-        src_zfssa.send_repl_update(action_id)
-        LOG.debug('Deleting replication action on source appliance.')
-        src_zfssa.delete_replication_action(action_id)
-        self._action_deleted = True
-
-
-class MigrateVolumeSeverRepl(task.Task):
-    def execute(self, tgt_zfssa, src_asn, action_id, driver):
-        source = tgt_zfssa.get_replication_source(src_asn)
-        if not source:
-            err = (_('Source with host ip/name: %s not found on the '
-                     'target appliance for backend enabled volume '
-                     'migration, proceeding with default migration.'),
-                   driver.configuration.san_ip)
-            LOG.error(err)
-            raise exception.VolumeBackendAPIException(data=err)
-        LOG.debug('Severing replication package on destination appliance.')
-        tgt_zfssa.sever_replication(action_id, source['name'],
-                                    project=action_id)
-
-
-class MigrateVolumeMoveVol(task.Task):
-    def execute(self, tgt_zfssa, tgt_pool, tgt_project, action_id, volume):
-        LOG.debug('Moving LUN to destination project on destination '
-                  'appliance.')
-        tgt_zfssa.move_volume(tgt_pool, action_id, volume['name'], tgt_project)
-        LOG.debug('Deleting temporary project on destination appliance.')
-        tgt_zfssa.delete_project(tgt_pool, action_id)
-        self._project_deleted = True
-
-    def revert(self, tgt_zfssa, tgt_pool, tgt_project, action_id, volume,
-               **kwargs):
-        if not hasattr(self, '_project_deleted'):
-            LOG.debug('Rollback: deleting temporary project on destination '
-                      'appliance.')
-            tgt_zfssa.delete_project(tgt_pool, action_id)
-
-
-class MigrateVolumeCleanUp(task.Task):
-    def execute(self, driver, volume, tgt_zfssa):
-        LOG.debug('Finally, delete source volume on source appliance.')
-        driver.delete_volume(volume)
-        tgt_zfssa.logout()
diff -pruN 2:15.0.1-1/cinder/volume/drivers/zfssa/zfssanfs.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/zfssa/zfssanfs.py
--- 2:15.0.1-1/cinder/volume/drivers/zfssa/zfssanfs.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/zfssa/zfssanfs.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,792 +0,0 @@
-# Copyright (c) 2014, 2016, Oracle and/or its affiliates. All rights reserved.
-#
-# Licensed under the Apache License, Version 2.0 (the "License"); you may
-# not use this file except in compliance with the License. You may obtain
-# a copy of the License at
-#
-# http://www.apache.org/licenses/LICENSE-2.0
-#
-# Unless required by applicable law or agreed to in writing, software
-# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-# License for the specific language governing permissions and limitations
-# under the License.
-"""
-ZFS Storage Appliance NFS Cinder Volume Driver
-"""
-import datetime as dt
-import errno
-import math
-import os
-
-from oslo_config import cfg
-from oslo_log import log
-from oslo_serialization import base64
-from oslo_utils import excutils
-from oslo_utils import units
-import six
-
-from cinder import exception
-from cinder.i18n import _
-from cinder.image import image_utils
-from cinder import interface
-from cinder.objects.volume import Volume
-from cinder import utils
-from cinder.volume import configuration
-from cinder.volume.drivers import nfs
-from cinder.volume.drivers.san import san
-from cinder.volume.drivers.zfssa import zfssarest
-from cinder.volume import volume_utils
-
-
-ZFSSA_OPTS = [
-    cfg.StrOpt('zfssa_data_ip',
-               help='Data path IP address'),
-    cfg.StrOpt('zfssa_https_port', default='443',
-               help='HTTPS port number'),
-    cfg.StrOpt('zfssa_nfs_mount_options', default='',
-               help='Options to be passed while mounting share over nfs'),
-    cfg.StrOpt('zfssa_nfs_pool', default='',
-               help='Storage pool name.'),
-    cfg.StrOpt('zfssa_nfs_project', default='NFSProject',
-               help='Project name.'),
-    cfg.StrOpt('zfssa_nfs_share', default='nfs_share',
-               help='Share name.'),
-    cfg.StrOpt('zfssa_nfs_share_compression', default='off',
-               choices=['off', 'lzjb', 'gzip-2', 'gzip', 'gzip-9'],
-               help='Data compression.'),
-    cfg.StrOpt('zfssa_nfs_share_logbias', default='latency',
-               choices=['latency', 'throughput'],
-               help='Synchronous write bias-latency, throughput.'),
-    cfg.IntOpt('zfssa_rest_timeout',
-               help='REST connection timeout. (seconds)'),
-    cfg.BoolOpt('zfssa_enable_local_cache', default=True,
-                help='Flag to enable local caching: True, False.'),
-    cfg.StrOpt('zfssa_cache_directory', default='os-cinder-cache',
-               help='Name of directory inside zfssa_nfs_share where cache '
-                    'volumes are stored.'),
-    cfg.StrOpt('zfssa_manage_policy', default='loose',
-               choices=['loose', 'strict'],
-               help='Driver policy for volume manage.')
-]
-
-LOG = log.getLogger(__name__)
-
-CONF = cfg.CONF
-CONF.register_opts(ZFSSA_OPTS, group=configuration.SHARED_CONF_GROUP)
-
-
-def factory_zfssa():
-    return zfssarest.ZFSSANfsApi()
-
-
-@interface.volumedriver
-class ZFSSANFSDriver(nfs.NfsDriver):
-    """ZFSSA Cinder NFS volume driver.
-
-    Version history:
-
-    .. code-block:: none
-
-        1.0.1:
-            Backend enabled volume migration.
-            Local cache feature.
-        1.0.2:
-            Volume manage/unmanage support.
-    """
-    VERSION = '1.0.2'
-    volume_backend_name = 'ZFSSA_NFS'
-    protocol = driver_prefix = driver_volume_type = 'nfs'
-
-    # ThirdPartySystems wiki page
-    CI_WIKI_NAME = "Oracle_ZFSSA_CI"
-
-    # TODO(jsbryant) Remove driver in the 'U' release as Oracle
-    #                is dropping support.
-    SUPPORTED = False
-
-    def __init__(self, *args, **kwargs):
-        super(ZFSSANFSDriver, self).__init__(*args, **kwargs)
-        self.configuration.append_config_values(ZFSSA_OPTS)
-        self.configuration.append_config_values(san.san_opts)
-        self.zfssa = None
-        self._stats = None
-
-    def do_setup(self, context):
-        self.configuration.max_over_subscription_ratio = (
-            volume_utils.get_max_over_subscription_ratio(
-                self.configuration.max_over_subscription_ratio,
-                supports_auto=False))
-
-        if not self.configuration.max_over_subscription_ratio > 0:
-            msg = _("Config 'max_over_subscription_ratio' invalid. Must be > "
-                    "0: %s") % self.configuration.max_over_subscription_ratio
-            LOG.error(msg)
-            raise exception.NfsException(msg)
-
-        packages = ('mount.nfs', '/usr/sbin/mount')
-        for package in packages:
-            try:
-                self._execute(package, check_exit_code=False, run_as_root=True)
-                break
-            except OSError as exc:
-                if exc.errno != errno.ENOENT:
-                    raise
-                LOG.error('%s is not installed.', package)
-        else:
-            msg = utils.build_or_str(packages, '%s needs to be installed.')
-            raise exception.NfsException(msg)
-
-        lcfg = self.configuration
-        LOG.info('Connecting to host: %s.', lcfg.san_ip)
-
-        host = lcfg.san_ip
-        user = lcfg.san_login
-        password = lcfg.san_password
-        https_port = lcfg.zfssa_https_port
-
-        credentials = ['san_ip', 'san_login', 'san_password', 'zfssa_data_ip']
-
-        for cred in credentials:
-            if not getattr(lcfg, cred, None):
-                exception_msg = _('%s not set in cinder.conf') % cred
-                LOG.error(exception_msg)
-                raise exception.CinderException(exception_msg)
-
-        self.zfssa = factory_zfssa()
-        self.zfssa.set_host(host, timeout=lcfg.zfssa_rest_timeout)
-
-        auth_str = base64.encode_as_text('%s:%s' % (user, password))
-        self.zfssa.login(auth_str)
-
-        self.zfssa.create_project(lcfg.zfssa_nfs_pool, lcfg.zfssa_nfs_project,
-                                  compression=lcfg.zfssa_nfs_share_compression,
-                                  logbias=lcfg.zfssa_nfs_share_logbias)
-
-        share_args = {
-            'sharedav': 'rw',
-            'sharenfs': 'rw',
-            'root_permissions': '777',
-            'compression': lcfg.zfssa_nfs_share_compression,
-            'logbias': lcfg.zfssa_nfs_share_logbias
-        }
-
-        self.zfssa.create_share(lcfg.zfssa_nfs_pool, lcfg.zfssa_nfs_project,
-                                lcfg.zfssa_nfs_share, share_args)
-
-        share_details = self.zfssa.get_share(lcfg.zfssa_nfs_pool,
-                                             lcfg.zfssa_nfs_project,
-                                             lcfg.zfssa_nfs_share)
-
-        mountpoint = share_details['mountpoint']
-
-        self.mount_path = lcfg.zfssa_data_ip + ':' + mountpoint
-        https_path = 'https://' + lcfg.zfssa_data_ip + ':' + https_port + \
-            '/shares' + mountpoint
-
-        LOG.debug('NFS mount path: %s', self.mount_path)
-        LOG.debug('WebDAV path to the share: %s', https_path)
-
-        self.shares = {}
-        mnt_opts = self.configuration.zfssa_nfs_mount_options
-        self.shares[self.mount_path] = mnt_opts if len(mnt_opts) > 1 else None
-
-        # Initialize the WebDAV client
-        self.zfssa.set_webdav(https_path, auth_str)
-
-        # Edit http service so that WebDAV requests are always authenticated
-        args = {'https_port': https_port,
-                'require_login': True}
-
-        self.zfssa.modify_service('http', args)
-        self.zfssa.enable_service('http')
-
-        if lcfg.zfssa_enable_local_cache:
-            LOG.debug('Creating local cache directory %s.',
-                      lcfg.zfssa_cache_directory)
-            self.zfssa.create_directory(lcfg.zfssa_cache_directory)
-
-    def _ensure_shares_mounted(self):
-        try:
-            self._ensure_share_mounted(self.mount_path)
-        except Exception as exc:
-            LOG.error('Exception during mounting %s.', exc)
-
-        self._mounted_shares = [self.mount_path]
-        LOG.debug('Available shares %s', self._mounted_shares)
-
-    def check_for_setup_error(self):
-        """Check that driver can login.
-
-        Check also for properly configured pool, project and share
-        Check that the http and nfs services are enabled
-        """
-        lcfg = self.configuration
-
-        self.zfssa.verify_pool(lcfg.zfssa_nfs_pool)
-        self.zfssa.verify_project(lcfg.zfssa_nfs_pool, lcfg.zfssa_nfs_project)
-        self.zfssa.verify_share(lcfg.zfssa_nfs_pool, lcfg.zfssa_nfs_project,
-                                lcfg.zfssa_nfs_share)
-        self.zfssa.verify_service('http')
-        self.zfssa.verify_service('nfs')
-
-    def create_volume(self, volume):
-        ret = super(ZFSSANFSDriver, self).create_volume(volume)
-        self.zfssa.set_file_props(volume.name, {'cinder_managed': 'True'})
-        return ret
-
-    def create_snapshot(self, snapshot):
-        """Creates a snapshot of a volume."""
-        LOG.info('Creating snapshot: %s', snapshot['name'])
-        lcfg = self.configuration
-        snap_name = self._create_snapshot_name()
-        self.zfssa.create_snapshot(lcfg.zfssa_nfs_pool, lcfg.zfssa_nfs_project,
-                                   lcfg.zfssa_nfs_share, snap_name)
-
-        src_file = snap_name + '/' + snapshot['volume_name']
-
-        try:
-            self.zfssa.create_snapshot_of_volume_file(src_file=src_file,
-                                                      dst_file=
-                                                      snapshot['name'])
-        except Exception:
-            with excutils.save_and_reraise_exception():
-                LOG.debug('Error thrown during snapshot: %s creation',
-                          snapshot['name'])
-        finally:
-            self.zfssa.delete_snapshot(lcfg.zfssa_nfs_pool,
-                                       lcfg.zfssa_nfs_project,
-                                       lcfg.zfssa_nfs_share, snap_name)
-
-    def delete_snapshot(self, snapshot):
-        """Deletes a snapshot."""
-        LOG.info('Deleting snapshot: %s', snapshot['name'])
-        self.zfssa.delete_snapshot_of_volume_file(src_file=snapshot['name'])
-
-    def create_volume_from_snapshot(self, volume, snapshot, method='COPY'):
-        LOG.info('Creatng volume from snapshot. volume: %s',
-                 volume['name'])
-        LOG.info('Source Snapshot: %s', snapshot['name'])
-
-        self._ensure_shares_mounted()
-        self.zfssa.create_volume_from_snapshot_file(src_file=snapshot['name'],
-                                                    dst_file=volume['name'],
-                                                    method=method)
-
-        volume['provider_location'] = self.mount_path
-
-        if volume['size'] != snapshot['volume_size']:
-            try:
-                self.extend_volume(volume, volume['size'])
-            except Exception:
-                vol_path = self.local_path(volume)
-                with excutils.save_and_reraise_exception():
-                    LOG.error('Error in extending volume size: Volume: '
-                              '%(volume)s Vol_Size: %(vol_size)d with '
-                              'Snapshot: %(snapshot)s Snap_Size: '
-                              '%(snap_size)d',
-                              {'volume': volume['name'],
-                               'vol_size': volume['size'],
-                               'snapshot': snapshot['name'],
-                               'snap_size': snapshot['volume_size']})
-                    self._execute('rm', '-f', vol_path, run_as_root=True)
-
-        volume_origin = {'origin': snapshot['volume_name'],
-                         'cinder_managed': 'True'}
-        self.zfssa.set_file_props(volume['name'], volume_origin)
-
-        return {'provider_location': volume['provider_location']}
-
-    def create_cloned_volume(self, volume, src_vref):
-        """Creates a snapshot and then clones the snapshot into a volume."""
-        LOG.info('new cloned volume: %s', volume['name'])
-        LOG.info('source volume for cloning: %s', src_vref['name'])
-
-        snapshot = {'volume_name': src_vref['name'],
-                    'volume_id': src_vref['id'],
-                    'volume_size': src_vref['size'],
-                    'name': self._create_snapshot_name()}
-
-        self.create_snapshot(snapshot)
-        return self.create_volume_from_snapshot(volume, snapshot,
-                                                method='MOVE')
-
-    def delete_volume(self, volume):
-        LOG.debug('Deleting volume %s.', volume.name)
-        lcfg = self.configuration
-        try:
-            vol_props = self.zfssa.get_volume(volume.name)
-        except exception.VolumeNotFound:
-            return
-        super(ZFSSANFSDriver, self).delete_volume(volume)
-
-        if vol_props['origin'].startswith(lcfg.zfssa_cache_directory):
-            LOG.info('Checking origin %(origin)s of volume %(volume)s.',
-                     {'origin': vol_props['origin'],
-                      'volume': volume.name})
-            self._check_origin(vol_props['origin'])
-
-    @utils.synchronized('zfssanfs', external=True)
-    def clone_image(self, context, volume,
-                    image_location, image_meta,
-                    image_service):
-        """Create a volume efficiently from an existing image.
-
-        Verify the image ID being used:
-
-        (1) If there is no existing cache volume, create one and transfer
-        image data to it. Take a snapshot.
-
-        (2) If a cache volume already exists, verify if it is either alternated
-        or updated. If so try to remove it, raise exception if removal fails.
-        Create a new cache volume as in (1).
-
-        Clone a volume from the cache volume and returns it to Cinder.
-
-        A file lock is placed on this method to prevent:
-        (a) a race condition when a cache volume has been verified, but then
-        gets deleted before it is cloned.
-
-        (b) failure of subsequent clone_image requests if the first request is
-        still pending.
-        """
-        LOG.debug('Cloning image %(image)s to volume %(volume)s',
-                  {'image': image_meta['id'], 'volume': volume['name']})
-        lcfg = self.configuration
-        cachevol_size = 0
-        if not lcfg.zfssa_enable_local_cache:
-            return None, False
-
-        with image_utils.TemporaryImages.fetch(
-                image_service, context, image_meta['id']) as tmp_image:
-            info = image_utils.qemu_img_info(tmp_image)
-            cachevol_size = int(math.ceil(float(info.virtual_size) / units.Gi))
-
-        if cachevol_size > volume['size']:
-            exception_msg = ('Image size %(img_size)dGB is larger '
-                             'than volume size %(vol_size)dGB.',
-                             {'img_size': cachevol_size,
-                              'vol_size': volume['size']})
-            LOG.error(exception_msg)
-            return None, False
-
-        updated_at = six.text_type(image_meta['updated_at'].isoformat())
-        cachevol_props = {
-            'id': image_meta['id'],
-            'size': cachevol_size,
-            'updated_at': updated_at,
-            'image_id': image_meta['id'],
-        }
-
-        try:
-            cachevol_name = self._verify_cache_volume(context,
-                                                      image_meta,
-                                                      image_service,
-                                                      cachevol_props)
-            # A cache volume should be ready by now
-            # Create a clone from the cache volume
-            cache_vol = {
-                'name': cachevol_name,
-                'size': cachevol_size,
-                'id': image_meta['id'],
-            }
-            clone_vol = self.create_cloned_volume(volume, cache_vol)
-            self._update_origin(volume['name'], cachevol_name)
-        except exception.VolumeBackendAPIException as exc:
-            exception_msg = ('Cannot clone image %(image)s to '
-                             'volume %(volume)s. Error: %(error)s.',
-                             {'volume': volume['name'],
-                              'image': image_meta['id'],
-                              'error': exc.msg})
-            LOG.error(exception_msg)
-            return None, False
-
-        return clone_vol, True
-
-    def _verify_cache_volume(self, context, img_meta,
-                             img_service, cachevol_props):
-        """Verify if we have a cache volume that we want.
-
-        If we don't, create one.
-        If we do, check if it's been updated:
-          * If so, delete it and recreate a new volume
-          * If not, we are good.
-
-        If it's out of date, delete it and create a new one.
-
-        After the function returns, there should be a cache volume available,
-        ready for cloning.
-        """
-        lcfg = self.configuration
-        cache_dir = '%s/' % lcfg.zfssa_cache_directory
-        cache_vol_obj = Volume()
-        cache_vol_obj.provider_location = self.mount_path + '/' + cache_dir
-        cache_vol_obj._name_id = cachevol_props['id']
-        cachevol_name = cache_dir + cache_vol_obj.name
-
-        LOG.debug('Verifying cache volume %s:', cachevol_name)
-
-        try:
-            cache_vol = self.zfssa.get_volume(cachevol_name)
-        except exception.VolumeNotFound:
-            # There is no existing cache volume, create one:
-            LOG.debug('Cache volume not found. Creating one...')
-            return self._create_cache_volume(context,
-                                             img_meta,
-                                             img_service,
-                                             cachevol_props)
-
-        # A cache volume does exist, check if it's updated:
-        if ((cache_vol['updated_at'] != cachevol_props['updated_at']) or
-                (cache_vol['image_id'] != cachevol_props['image_id'])):
-            if cache_vol['numclones'] > 0:
-                # The cache volume is updated, but has clones
-                exception_msg = (_('Cannot delete '
-                                   'cache volume: %(cachevol_name)s. '
-                                   'It was updated at %(updated_at)s '
-                                   'and currently has %(numclones)d '
-                                   'volume instances.'),
-                                 {'cachevol_name': cachevol_name,
-                                  'updated_at': cachevol_props['updated_at'],
-                                  'numclones': cache_vol['numclones']})
-                LOG.error(exception_msg)
-                raise exception.VolumeBackendAPIException(data=exception_msg)
-
-            # The cache volume is updated, but has no clone, so we delete it
-            # and re-create a new one:
-            super(ZFSSANFSDriver, self).delete_volume(cache_vol_obj)
-            return self._create_cache_volume(context,
-                                             img_meta,
-                                             img_service,
-                                             cachevol_props)
-
-        return cachevol_name
-
-    def _create_cache_volume(self, context, img_meta,
-                             img_service, cachevol_props):
-        """Create a cache volume from an image.
-
-        Returns name of the cache volume.
-        """
-        lcfg = self.configuration
-        cache_dir = '%s/' % lcfg.zfssa_cache_directory
-        cache_vol = Volume()
-        cache_vol.provider_location = self.mount_path
-        cache_vol._name_id = cachevol_props['id']
-        cache_vol.size = cachevol_props['size']
-        cache_vol_name = cache_dir + cache_vol.name
-
-        LOG.debug('Creating cache volume %s', cache_vol_name)
-        try:
-            self.create_volume(cache_vol)
-            LOG.debug('Copying image data:')
-            super(ZFSSANFSDriver, self).copy_image_to_volume(context,
-                                                             cache_vol,
-                                                             img_service,
-                                                             img_meta['id'])
-            self.zfssa.webdavclient.request(src_file=cache_vol.name,
-                                            dst_file=cache_vol_name,
-                                            method='MOVE')
-
-        except Exception as exc:
-            exc_msg = (_('Fail to create cache volume %(volume)s. '
-                         'Error: %(err)s'),
-                       {'volume': cache_vol_name,
-                        'err': six.text_type(exc)})
-            LOG.error(exc_msg)
-            self.zfssa.delete_file(cache_vol_name)
-            raise exception.VolumeBackendAPIException(data=exc_msg)
-
-        cachevol_meta = {
-            'updated_at': cachevol_props['updated_at'],
-            'image_id': cachevol_props['image_id'],
-        }
-        cachevol_meta.update({'numclones': '0'})
-        self.zfssa.set_file_props(cache_vol_name, cachevol_meta)
-        return cache_vol_name
-
-    def _create_snapshot_name(self):
-        """Creates a snapshot name from the date and time."""
-
-        return ('cinder-zfssa-nfs-snapshot-%s' %
-                dt.datetime.utcnow().isoformat())
-
-    def _get_share_capacity_info(self):
-        """Get available and used capacity info for the NFS share."""
-        lcfg = self.configuration
-        share_details = self.zfssa.get_share(lcfg.zfssa_nfs_pool,
-                                             lcfg.zfssa_nfs_project,
-                                             lcfg.zfssa_nfs_share)
-
-        free = share_details['space_available']
-        used = share_details['space_total']
-        return free, used
-
-    @utils.synchronized('zfssanfs', external=True)
-    def _check_origin(self, origin):
-        """Verify the cache volume of a bootable volume.
-
-        If the cache no longer has clone, it will be deleted.
-        """
-        try:
-            cachevol_props = self.zfssa.get_volume(origin)
-        except exception.VolumeNotFound:
-            LOG.debug('Origin %s does not exist', origin)
-            return
-
-        numclones = cachevol_props['numclones']
-        LOG.debug('Number of clones: %d', numclones)
-        if numclones <= 1:
-            # This cache vol does not have any other clone
-            self.zfssa.delete_file(origin)
-        else:
-            cachevol_props = {'numclones': six.text_type(numclones - 1)}
-            self.zfssa.set_file_props(origin, cachevol_props)
-
-    def _update_origin(self, vol_name, cachevol_name):
-        """Update WebDAV property of a volume.
-
-        WebDAV properties are used to keep track of:
-        (1) The number of clones of a cache volume.
-        (2) The cache volume name (origin) of a bootable volume.
-
-        To avoid race conditions when multiple volumes are created and needed
-        to be updated, a file lock is used to ensure that the properties are
-        updated properly.
-        """
-        volume_origin = {'origin': cachevol_name}
-        self.zfssa.set_file_props(vol_name, volume_origin)
-
-        cache_props = self.zfssa.get_volume(cachevol_name)
-        cache_props.update({'numclones':
-                            six.text_type(cache_props['numclones'] + 1)})
-        self.zfssa.set_file_props(cachevol_name, cache_props)
-
-    def _update_volume_stats(self):
-        """Get volume stats from zfssa"""
-        self._ensure_shares_mounted()
-        data = {}
-        lcfg = self.configuration
-        backend_name = self.configuration.safe_get('volume_backend_name')
-        data['volume_backend_name'] = backend_name or self.__class__.__name__
-        data['vendor_name'] = 'Oracle'
-        data['driver_version'] = self.VERSION
-        data['storage_protocol'] = self.protocol
-
-        asn = self.zfssa.get_asn()
-        data['location_info'] = '%s:%s' % (asn, lcfg.zfssa_nfs_share)
-
-        free, used = self._get_share_capacity_info()
-        capacity = float(free) + float(used)
-        ratio_used = used / capacity
-
-        data['QoS_support'] = False
-        data['reserved_percentage'] = 0
-
-        used_percentage_limit = 100 - self.configuration.reserved_percentage
-        used_ratio_limit = used_percentage_limit / 100.0
-        if (ratio_used > used_ratio_limit or
-                ratio_used >= self.configuration.max_over_subscription_ratio):
-            data['reserved_percentage'] = 100
-
-        data['total_capacity_gb'] = float(capacity) / units.Gi
-        data['free_capacity_gb'] = float(free) / units.Gi
-
-        share_details = self.zfssa.get_share(lcfg.zfssa_nfs_pool,
-                                             lcfg.zfssa_nfs_project,
-                                             lcfg.zfssa_nfs_share)
-        pool_details = self.zfssa.get_pool_details(lcfg.zfssa_nfs_pool)
-
-        data['zfssa_compression'] = share_details['compression']
-        data['zfssa_encryption'] = share_details['encryption']
-        data['zfssa_logbias'] = share_details['logbias']
-        data['zfssa_poolprofile'] = pool_details['profile']
-        data['zfssa_sparse'] = six.text_type(lcfg.nfs_sparsed_volumes)
-
-        self._stats = data
-
-    def migrate_volume(self, ctxt, volume, host):
-        LOG.debug('Attempting ZFSSA enabled volume migration. volume: %(id)s, '
-                  'host: %(host)s, status=%(status)s',
-                  {'id': volume['id'],
-                   'host': host,
-                   'status': volume['status']})
-
-        lcfg = self.configuration
-        default_ret = (False, None)
-
-        if volume['status'] != "available":
-            LOG.debug('Only available volumes can be migrated using backend '
-                      'assisted migration. Defaulting to generic migration.')
-            return default_ret
-
-        if (host['capabilities']['vendor_name'] != 'Oracle' or
-                host['capabilities']['storage_protocol'] != self.protocol):
-            LOG.debug('Source and destination drivers need to be Oracle iSCSI '
-                      'to use backend assisted migration. Defaulting to '
-                      'generic migration.')
-            return default_ret
-
-        if 'location_info' not in host['capabilities']:
-            LOG.debug('Could not find location_info in capabilities reported '
-                      'by the destination driver. Defaulting to generic '
-                      'migration.')
-            return default_ret
-
-        loc_info = host['capabilities']['location_info']
-
-        try:
-            (tgt_asn, tgt_share) = loc_info.split(':')
-        except ValueError:
-            LOG.error("Location info needed for backend enabled volume "
-                      "migration not in correct format: %s. Continuing "
-                      "with generic volume migration.", loc_info)
-            return default_ret
-
-        src_asn = self.zfssa.get_asn()
-
-        if tgt_asn == src_asn and lcfg.zfssa_nfs_share == tgt_share:
-            LOG.info('Source and destination ZFSSA shares are the same. '
-                     'Do nothing. volume: %s', volume['name'])
-            return (True, None)
-
-        return (False, None)
-
-    def update_migrated_volume(self, ctxt, volume, new_volume,
-                               original_volume_status):
-        """Return model update for migrated volume.
-
-        :param volume: The original volume that was migrated to this backend
-        :param new_volume: The migration volume object that was created on
-                           this backend as part of the migration process
-        :param original_volume_status: The status of the original volume
-        :returns: model_update to update DB with any needed changes
-        """
-
-        original_name = CONF.volume_name_template % volume['id']
-        current_name = CONF.volume_name_template % new_volume['id']
-
-        LOG.debug('Renaming migrated volume: %(cur)s to %(org)s.',
-                  {'cur': current_name,
-                   'org': original_name})
-        self.zfssa.create_volume_from_snapshot_file(src_file=current_name,
-                                                    dst_file=original_name,
-                                                    method='MOVE')
-        provider_location = new_volume['provider_location']
-        return {'_name_id': None, 'provider_location': provider_location}
-
-    def manage_existing(self, volume, existing_ref):
-        """Manage an existing volume in the ZFSSA backend.
-
-        :param volume: Reference to the new volume.
-        :param existing_ref: Reference to the existing volume to be managed.
-        """
-        existing_vol_name = self._get_existing_vol_name(existing_ref)
-        try:
-            vol_props = self.zfssa.get_volume(existing_vol_name)
-        except exception.VolumeNotFound:
-            err_msg = (_("Volume %s doesn't exist on the ZFSSA backend.") %
-                       existing_vol_name)
-            LOG.error(err_msg)
-            raise exception.InvalidInput(reason=err_msg)
-
-        self._verify_volume_to_manage(existing_vol_name, vol_props)
-
-        try:
-            self.zfssa.rename_volume(existing_vol_name, volume['name'])
-        except Exception:
-            LOG.error("Failed to rename volume %(existing)s to %(new)s. "
-                      "Volume manage failed.",
-                      {'existing': existing_vol_name,
-                       'new': volume['name']})
-            raise
-
-        try:
-            self.zfssa.set_file_props(volume['name'],
-                                      {'cinder_managed': 'True'})
-        except Exception:
-            self.zfssa.rename_volume(volume['name'], existing_vol_name)
-            LOG.error("Failed to set properties for volume %(existing)s. "
-                      "Volume manage failed.",
-                      {'existing': volume['name']})
-            raise
-
-        return {'provider_location': self.mount_path}
-
-    def manage_existing_get_size(self, volume, existing_ref):
-        """Return size of the volume to be managed by manage_existing."""
-        existing_vol_name = self._get_existing_vol_name(existing_ref)
-
-        # The ZFSSA NFS driver only has one mounted share.
-        local_share_mount = self._get_mount_point_for_share(
-            self._mounted_shares[0])
-        local_vol_path = os.path.join(local_share_mount, existing_vol_name)
-
-        try:
-            if os.path.isfile(local_vol_path):
-                size = int(math.ceil(float(
-                    utils.get_file_size(local_vol_path)) / units.Gi))
-        except (OSError, ValueError):
-            err_msg = (_("Failed to get size of existing volume: %(vol)s. "
-                         "Volume Manage failed."), {'vol': existing_vol_name})
-            LOG.error(err_msg)
-            raise exception.VolumeBackendAPIException(data=err_msg)
-
-        LOG.debug("Size volume: %(vol)s to be migrated is: %(size)s.",
-                  {'vol': existing_vol_name, 'size': size})
-
-        return size
-
-    def _verify_volume_to_manage(self, name, vol_props):
-        lcfg = self.configuration
-
-        if lcfg.zfssa_manage_policy != 'strict':
-            return
-
-        if vol_props['cinder_managed'] == "":
-            err_msg = (_("Unknown if the volume: %s to be managed is "
-                         "already being managed by Cinder. Aborting manage "
-                         "volume. Please add 'cinder_managed' custom schema "
-                         "property to the volume and set its value to False. "
-                         "Alternatively, Set the value of cinder config "
-                         "policy 'zfssa_manage_policy' to 'loose' to "
-                         "remove this restriction.") % name)
-            LOG.error(err_msg)
-            raise exception.InvalidInput(reason=err_msg)
-
-        if vol_props['cinder_managed'] == 'True':
-            msg = (_("Volume: %s is already being managed by Cinder.") % name)
-            LOG.error(msg)
-            raise exception.ManageExistingAlreadyManaged(volume_ref=name)
-
-    def unmanage(self, volume):
-        """Remove an existing volume from cinder management.
-
-        :param volume: Reference to the volume to be unmanaged.
-        """
-        new_name = 'unmanaged-' + volume['name']
-        try:
-            self.zfssa.rename_volume(volume['name'], new_name)
-        except Exception:
-            LOG.error("Failed to rename volume %(existing)s to %(new)s. "
-                      "Volume unmanage failed.",
-                      {'existing': volume['name'],
-                       'new': new_name})
-            raise
-
-        try:
-            self.zfssa.set_file_props(new_name, {'cinder_managed': 'False'})
-        except Exception:
-            self.zfssa.rename_volume(new_name, volume['name'])
-            LOG.error("Failed to set properties for volume %(existing)s. "
-                      "Volume unmanage failed.",
-                      {'existing': volume['name']})
-            raise
-
-    def _get_existing_vol_name(self, existing_ref):
-        if 'source-name' not in existing_ref:
-            msg = _("Reference to volume to be managed must contain "
-                    "source-name.")
-            raise exception.ManageExistingInvalidReference(
-                existing_ref=existing_ref, reason=msg)
-        return existing_ref['source-name']
diff -pruN 2:15.0.1-1/cinder/volume/drivers/zfssa/zfssarest.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/zfssa/zfssarest.py
--- 2:15.0.1-1/cinder/volume/drivers/zfssa/zfssarest.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/drivers/zfssa/zfssarest.py	1970-01-01 00:00:00.000000000 +0000
@@ -1,1381 +0,0 @@
-# Copyright (c) 2014, 2016, Oracle and/or its affiliates. All rights reserved.
-#
-#    Licensed under the Apache License, Version 2.0 (the "License"); you may
-#    not use this file except in compliance with the License. You may obtain
-#    a copy of the License at
-#
-#         http://www.apache.org/licenses/LICENSE-2.0
-#
-#    Unless required by applicable law or agreed to in writing, software
-#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
-#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
-#    License for the specific language governing permissions and limitations
-#    under the License.
-"""
-ZFS Storage Appliance Proxy
-"""
-import json
-
-from oslo_log import log
-from oslo_service import loopingcall
-
-from cinder import exception
-from cinder.i18n import _
-from cinder.volume.drivers.zfssa import restclient
-from cinder.volume.drivers.zfssa import webdavclient
-
-LOG = log.getLogger(__name__)
-
-
-def factory_restclient(url, **kwargs):
-    return restclient.RestClientURL(url, **kwargs)
-
-
-class ZFSSAApi(object):
-    """ZFSSA API proxy class"""
-
-    def __init__(self):
-        self.host = None
-        self.url = None
-        self.rclient = None
-
-    def __del__(self):
-        if self.rclient and self.rclient.islogin():
-            self.rclient.logout()
-
-    def _is_pool_owned(self, pdata):
-        """Check pool ownership.
-
-           Returns True if the pool's owner is the same as the host, or
-           the peer, if (and only if) it's stripped from the cluster
-        """
-
-        svc = '/api/system/v1/version'
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            exception_msg = (_('Error getting version: '
-                               'svc: %(svc)s.'
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'svc': svc,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        vdata = json.loads(ret.data)['version']
-        if vdata['asn'] == pdata['pool']['asn'] and \
-                vdata['nodename'] == pdata['pool']['owner']:
-            return True
-
-        svc = '/api/hardware/v1/cluster'
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            exception_msg = (_('Error getting cluster: '
-                               'svc: %(svc)s.'
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'svc': svc,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        cdata = json.loads(ret.data)['cluster']
-        if cdata['peer_asn'] == pdata['pool']['asn'] and \
-                cdata['peer_hostname'] == pdata['pool']['owner'] and \
-                cdata['peer_state'] == 'AKCS_STRIPPED':
-            LOG.warning('Cluster node %(nodename)s is stripped',
-                        {'nodename': pdata['pool']['owner']})
-            return True
-
-        return False
-
-    def get_pool_details(self, pool):
-        """Get properties of a pool."""
-        svc = '/api/storage/v1/pools/%s' % pool
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            exception_msg = (_('Error Getting Pool Stats: '
-                               'Pool: %(pool)s '
-                               'Return code: %(status)d '
-                               'Message: %(data)s.')
-                             % {'pool': pool,
-                                'status': ret.status,
-                                'data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        val = json.loads(ret.data)
-
-        if not self._is_pool_owned(val):
-            exception_msg = (_('Error Pool ownership: '
-                               'Pool %(pool)s is not owned '
-                               'by %(host)s.')
-                             % {'pool': pool,
-                                'host': self.host})
-            LOG.error(exception_msg)
-            raise exception.InvalidInput(reason=exception_msg)
-        return val['pool']
-
-    def set_host(self, host, timeout=None):
-        self.host = host
-        self.url = "https://" + self.host + ":215"
-        self.rclient = factory_restclient(self.url, timeout=timeout)
-
-    def login(self, auth_str):
-        """Login to the appliance"""
-        if self.rclient and not self.rclient.islogin():
-            self.rclient.login(auth_str)
-
-    def logout(self):
-        self.rclient.logout()
-
-    def verify_service(self, service, status='online'):
-        """Checks whether a service is online or not"""
-        svc = '/api/service/v1/services/' + service
-        ret = self.rclient.get(svc)
-
-        if ret.status != restclient.Status.OK:
-            exception_msg = (_('Error Verifying '
-                               'Service: %(service)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'service': service,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        data = json.loads(ret.data)['service']
-
-        if data['<status>'] != status:
-            exception_msg = (_('%(service)s Service is not %(status)s '
-                               'on storage appliance: %(host)s')
-                             % {'service': service,
-                                'status': status,
-                                'host': self.host})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def get_asn(self):
-        """Returns appliance asn."""
-        svc = '/api/system/v1/version'
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            exception_msg = (_('Error getting appliance version details. '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s .')
-                             % {'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        val = json.loads(ret.data)
-        return val['version']['asn']
-
-    def get_replication_targets(self):
-        """Returns all replication targets configured on the appliance."""
-        svc = '/api/storage/v1/replication/targets'
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            exception_msg = (_('Error getting replication target details. '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s .')
-                             % {'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        val = json.loads(ret.data)
-        return val
-
-    def edit_inherit_replication_flag(self, pool, project, volume, set=True):
-        """Edit the inherit replication flag for volume."""
-        svc = ('/api/storage/v1/pools/%(pool)s/projects/%(project)s'
-               '/filesystems/%(volume)s/replication'
-               % {'pool': pool,
-                  'project': project,
-                  'volume': volume})
-        arg = {'inherited': set}
-        ret = self.rclient.put(svc, arg)
-
-        if ret.status != restclient.Status.ACCEPTED:
-            exception_msg = (_('Error setting replication inheritance '
-                               'to %(set)s '
-                               'for volume: %(vol)s '
-                               'project %(project)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s .')
-                             % {'set': set,
-                                'project': project,
-                                'vol': volume,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def create_replication_action(self, host_pool, host_project, tgt_name,
-                                  tgt_pool, volume):
-        """Create a replication action."""
-        arg = {'pool': host_pool,
-               'project': host_project,
-               'target_pool': tgt_pool,
-               'target': tgt_name}
-
-        if volume is not None:
-            arg.update({'share': volume})
-
-        svc = '/api/storage/v1/replication/actions'
-        ret = self.rclient.post(svc, arg)
-        if ret.status != restclient.Status.CREATED:
-            exception_msg = (_('Error Creating replication action on: '
-                               'pool: %(pool)s '
-                               'Project: %(proj)s '
-                               'volume: %(vol)s '
-                               'for target: %(tgt)s and pool: %(tgt_pool)s. '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s .')
-                             % {'pool': host_pool,
-                                'proj': host_project,
-                                'vol': volume,
-                                'tgt': tgt_name,
-                                'tgt_pool': tgt_pool,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        val = json.loads(ret.data)
-        return val['action']['id']
-
-    def delete_replication_action(self, action_id):
-        """Delete a replication action."""
-        svc = '/api/storage/v1/replication/actions/%s' % action_id
-        ret = self.rclient.delete(svc)
-        if ret.status != restclient.Status.NO_CONTENT:
-            exception_msg = (_('Error Deleting '
-                               'replication action: %(id)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'id': action_id,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def send_repl_update(self, action_id):
-        """Send replication update
-
-           Send replication update to the target appliance and then wait for
-           it to complete.
-        """
-
-        svc = '/api/storage/v1/replication/actions/%s/sendupdate' % action_id
-        ret = self.rclient.put(svc)
-        if ret.status != restclient.Status.ACCEPTED:
-            exception_msg = (_('Error sending replication update '
-                               'for action id: %(id)s . '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s .')
-                             % {'id': action_id,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        def _loop_func():
-            svc = '/api/storage/v1/replication/actions/%s' % action_id
-            ret = self.rclient.get(svc)
-            if ret.status != restclient.Status.OK:
-                exception_msg = (_('Error getting replication action: %(id)s. '
-                                   'Return code: %(ret.status)d '
-                                   'Message: %(ret.data)s .')
-                                 % {'id': action_id,
-                                    'ret.status': ret.status,
-                                    'ret.data': ret.data})
-                LOG.error(exception_msg)
-                raise exception.VolumeBackendAPIException(data=exception_msg)
-
-            val = json.loads(ret.data)
-            if val['action']['last_result'] == 'success':
-                raise loopingcall.LoopingCallDone()
-            elif (val['action']['last_result'] == '<unknown>' and
-                    val['action']['state'] == 'sending'):
-                pass
-            else:
-                exception_msg = (_('Error sending replication update. '
-                                   'Returned error: %(err)s. '
-                                   'Action: %(id)s.')
-                                 % {'err': val['action']['last_result'],
-                                    'id': action_id})
-                LOG.error(exception_msg)
-                raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        timer = loopingcall.FixedIntervalLoopingCall(_loop_func)
-        timer.start(interval=5).wait()
-
-    def get_replication_source(self, asn):
-        """Return the replication source json which has a matching asn."""
-        svc = "/api/storage/v1/replication/sources"
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            exception_msg = (_('Error getting replication source details. '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s .')
-                             % {'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        val = json.loads(ret.data)
-
-        for source in val['sources']:
-            if source['asn'] == asn:
-                return source
-        return None
-
-    def sever_replication(self, package, src_name, project=None):
-        """Sever Replication at the destination.
-
-           This method will sever the package and move the volume to a project,
-           if project name is not passed in then the package name is selected
-           as the project name
-        """
-
-        svc = ('/api/storage/v1/replication/sources/%(src)s/packages/%(pkg)s'
-               '/sever' % {'src': src_name, 'pkg': package})
-
-        if not project:
-            project = package
-
-        arg = {'projname': project}
-        ret = self.rclient.put(svc, arg)
-
-        if ret.status != restclient.Status.ACCEPTED:
-            exception_msg = (_('Error severing the package: %(package)s '
-                               'from source: %(src)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s .')
-                             % {'package': package,
-                                'src': src_name,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def move_volume(self, pool, project, volume, tgt_project):
-        """Move a LUN from one project to another within the same pool."""
-        svc = ('/api/storage/v1/pools/%(pool)s/projects/%(project)s'
-               '/filesystems/%(volume)s' % {'pool': pool,
-                                            'project': project,
-                                            'volume': volume})
-
-        arg = {'project': tgt_project}
-
-        ret = self.rclient.put(svc, arg)
-        if ret.status != restclient.Status.ACCEPTED:
-            exception_msg = (_('Error moving volume: %(vol)s '
-                               'from source project: %(src)s '
-                               'to target project: %(tgt)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s .')
-                             % {'vol': volume,
-                                'src': project,
-                                'tgt': tgt_project,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def delete_project(self, pool, project):
-        """Delete a project."""
-        svc = ('/api/storage/v1/pools/%(pool)s/projects/%(project)s' %
-               {'pool': pool,
-                'project': project})
-        ret = self.rclient.delete(svc)
-        if ret.status != restclient.Status.NO_CONTENT:
-            exception_msg = (_('Error Deleting '
-                               'project: %(project)s '
-                               'on pool: %(pool)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'project': project,
-                                'pool': pool,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def get_project_stats(self, pool, project):
-        """Get project stats.
-
-           Get available space and total space of a project
-           returns (avail, total).
-        """
-        svc = '/api/storage/v1/pools/%s/projects/%s' % (pool, project)
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            exception_msg = (_('Error Getting Project Stats: '
-                               'Pool: %(pool)s '
-                               'Project: %(project)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'pool': pool,
-                                'project': project,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        val = json.loads(ret.data)
-        avail = val['project']['space_available']
-        total = avail + val['project']['space_total']
-
-        return avail, total
-
-    def create_project(self, pool, project, compression=None, logbias=None):
-        """Create a project on a pool.
-
-        Check first whether the pool exists.
-        """
-        self.verify_pool(pool)
-        svc = '/api/storage/v1/pools/' + pool + '/projects/' + project
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            svc = '/api/storage/v1/pools/' + pool + '/projects'
-            arg = {
-                'name': project
-            }
-            if compression and compression != '':
-                arg.update({'compression': compression})
-            if logbias and logbias != '':
-                arg.update({'logbias': logbias})
-
-            ret = self.rclient.post(svc, arg)
-            if ret.status != restclient.Status.CREATED:
-                exception_msg = (_('Error Creating Project: '
-                                   '%(project)s on '
-                                   'Pool: %(pool)s '
-                                   'Return code: %(ret.status)d '
-                                   'Message: %(ret.data)s .')
-                                 % {'project': project,
-                                    'pool': pool,
-                                    'ret.status': ret.status,
-                                    'ret.data': ret.data})
-                LOG.error(exception_msg)
-                raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def create_initiator(self, initiator, alias, chapuser=None,
-                         chapsecret=None):
-        """Create an iSCSI initiator."""
-
-        svc = '/api/san/v1/iscsi/initiators/alias=' + alias
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            svc = '/api/san/v1/iscsi/initiators'
-            arg = {
-                'initiator': initiator,
-                'alias': alias
-            }
-            if chapuser and chapuser != '' and chapsecret and chapsecret != '':
-                arg.update({'chapuser': chapuser,
-                            'chapsecret': chapsecret})
-
-            ret = self.rclient.post(svc, arg)
-            if ret.status != restclient.Status.CREATED:
-                exception_msg = (_('Error Creating Initiator: '
-                                   '%(initiator)s on '
-                                   'Alias: %(alias)s '
-                                   'Return code: %(ret.status)d '
-                                   'Message: %(ret.data)s .')
-                                 % {'initiator': initiator,
-                                    'alias': alias,
-                                    'ret.status': ret.status,
-                                    'ret.data': ret.data})
-                LOG.error(exception_msg)
-                raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def add_to_initiatorgroup(self, initiator, initiatorgroup):
-        """Add an iSCSI initiator to initiatorgroup"""
-        svc = '/api/san/v1/iscsi/initiator-groups/' + initiatorgroup
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            svc = '/api/san/v1/iscsi/initiator-groups'
-            arg = {
-                'name': initiatorgroup,
-                'initiators': [initiator]
-            }
-            ret = self.rclient.post(svc, arg)
-            if ret.status != restclient.Status.CREATED:
-                exception_msg = (_('Error Adding Initiator: '
-                                   '%(initiator)s on group '
-                                   'InitiatorGroup: %(initiatorgroup)s '
-                                   'Return code: %(ret.status)d '
-                                   'Message: %(ret.data)s .')
-                                 % {'initiator': initiator,
-                                    'initiatorgroup': initiatorgroup,
-                                    'ret.status': ret.status,
-                                    'ret.data': ret.data})
-                LOG.error(exception_msg)
-                raise exception.VolumeBackendAPIException(data=exception_msg)
-        else:
-            val = json.loads(ret.data)
-            inits = val['group']['initiators']
-            if inits is None:
-                exception_msg = (_('Error Getting Initiators: '
-                                   'InitiatorGroup: %(initiatorgroup)s '
-                                   'Return code: %(ret.status)d '
-                                   'Message: %(ret.data)s .')
-                                 % {'initiatorgroup': initiatorgroup,
-                                    'ret.status': ret.status,
-                                    'ret.data': ret.data})
-                LOG.error(exception_msg)
-                raise exception.VolumeBackendAPIException(data=exception_msg)
-
-            if initiator in inits:
-                return
-
-            inits.append(initiator)
-            svc = '/api/san/v1/iscsi/initiator-groups/' + initiatorgroup
-            arg = {
-                'initiators': inits
-            }
-            ret = self.rclient.put(svc, arg)
-            if ret.status != restclient.Status.ACCEPTED:
-                exception_msg = (_('Error Adding Initiator: '
-                                   '%(initiator)s on group '
-                                   'InitiatorGroup: %(initiatorgroup)s '
-                                   'Return code: %(ret.status)d '
-                                   'Message: %(ret.data)s .')
-                                 % {'initiator': initiator,
-                                    'initiatorgroup': initiatorgroup,
-                                    'ret.status': ret.status,
-                                    'ret.data': ret.data})
-                LOG.error(exception_msg)
-                raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def create_target(self, alias, interfaces=None, tchapuser=None,
-                      tchapsecret=None):
-        """Create an iSCSI target.
-
-        :param interfaces: an array with network interfaces
-        :param tchapuser, tchapsecret: target's chapuser and chapsecret
-        :returns: target iqn
-        """
-        svc = '/api/san/v1/iscsi/targets/alias=' + alias
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            svc = '/api/san/v1/iscsi/targets'
-            arg = {
-                'alias': alias
-            }
-
-            if tchapuser and tchapuser != '' and tchapsecret and \
-               tchapsecret != '':
-                arg.update({'targetchapuser': tchapuser,
-                            'targetchapsecret': tchapsecret,
-                            'auth': 'chap'})
-
-            if interfaces is not None and len(interfaces) > 0:
-                arg.update({'interfaces': interfaces})
-
-            ret = self.rclient.post(svc, arg)
-            if ret.status != restclient.Status.CREATED:
-                exception_msg = (_('Error Creating Target: '
-                                   '%(alias)s '
-                                   'Return code: %(ret.status)d '
-                                   'Message: %(ret.data)s .')
-                                 % {'alias': alias,
-                                    'ret.status': ret.status,
-                                    'ret.data': ret.data})
-                LOG.error(exception_msg)
-                raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        val = json.loads(ret.data)
-        return val['target']['iqn']
-
-    def get_target(self, alias):
-        """Get an iSCSI target iqn."""
-        svc = '/api/san/v1/iscsi/targets/alias=' + alias
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            exception_msg = (_('Error Getting Target: '
-                               '%(alias)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s .')
-                             % {'alias': alias,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        val = json.loads(ret.data)
-        return val['target']['iqn']
-
-    def add_to_targetgroup(self, iqn, targetgroup):
-        """Add an iSCSI target to targetgroup."""
-        svc = '/api/san/v1/iscsi/target-groups/' + targetgroup
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            svccrt = '/api/san/v1/iscsi/target-groups'
-            arg = {
-                'name': targetgroup,
-                'targets': [iqn]
-            }
-
-            ret = self.rclient.post(svccrt, arg)
-            if ret.status != restclient.Status.CREATED:
-                exception_msg = (_('Error Creating TargetGroup: '
-                                   '%(targetgroup)s with '
-                                   'IQN: %(iqn)s '
-                                   'Return code: %(ret.status)d '
-                                   'Message: %(ret.data)s .')
-                                 % {'targetgroup': targetgroup,
-                                    'iqn': iqn,
-                                    'ret.status': ret.status,
-                                    'ret.data': ret.data})
-                LOG.error(exception_msg)
-                raise exception.VolumeBackendAPIException(data=exception_msg)
-
-            return
-
-        arg = {
-            'targets': [iqn]
-        }
-
-        ret = self.rclient.put(svc, arg)
-        if ret.status != restclient.Status.ACCEPTED:
-            exception_msg = (_('Error Adding to TargetGroup: '
-                               '%(targetgroup)s with '
-                               'IQN: %(iqn)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'targetgroup': targetgroup,
-                                'iqn': iqn,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def verify_pool(self, pool):
-        """Checks whether pool exists."""
-        svc = '/api/storage/v1/pools/' + pool
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            exception_msg = (_('Error Verifying Pool: '
-                               '%(pool)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'pool': pool,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def verify_project(self, pool, project):
-        """Checks whether project exists."""
-        svc = '/api/storage/v1/pools/' + pool + '/projects/' + project
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            exception_msg = (_('Error Verifying '
-                               'Project: %(project)s on '
-                               'Pool: %(pool)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'project': project,
-                                'pool': pool,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def verify_initiator(self, iqn):
-        """Check whether initiator iqn exists."""
-        svc = '/api/san/v1/iscsi/initiators/' + iqn
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            exception_msg = (_('Error Verifying '
-                               'Initiator: %(iqn)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'initiator': iqn,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def verify_target(self, alias):
-        """Check whether target alias exists."""
-        svc = '/api/san/v1/iscsi/targets/alias=' + alias
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            exception_msg = (_('Error Verifying '
-                               'Target: %(alias)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'alias': alias,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def create_lun(self, pool, project, lun, volsize, targetgroup, specs):
-        """Create a LUN.
-
-        specs - contains volume properties (e.g blocksize, compression).
-        """
-        svc = '/api/storage/v1/pools/' + pool + '/projects/' + \
-              project + '/luns'
-        arg = {
-            'name': lun,
-            'volsize': volsize,
-            'targetgroup': targetgroup,
-            'initiatorgroup': 'com.sun.ms.vss.hg.maskAll'
-        }
-        if specs:
-            arg.update(specs)
-
-        ret = self.rclient.post(svc, arg)
-        if ret.status != restclient.Status.CREATED:
-            exception_msg = (_('Error Creating '
-                               'Volume: %(lun)s '
-                               'Size: %(size)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'lun': lun,
-                                'size': volsize,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        val = json.loads(ret.data)
-        return val
-
-    def _canonify_lun_info(self, lun):
-        def _listify(item):
-            return item if isinstance(item, list) else [item]
-
-        if 'com.sun.ms.vss.hg.maskAll' in lun['initiatorgroup']:
-            # Hide special maskAll value when LUN is not currently presented
-            # to any initiatorgroups:
-            initiatorgroup = []
-            number = []
-        else:
-            # For backward-compatibility with 2013.1.2.x, convert
-            # initiatorgroup and number to lists if they're not already
-            initiatorgroup = _listify(lun['initiatorgroup'])
-            number = _listify(lun['assignednumber'])
-
-        canonical = {
-            'name': lun['name'],
-            'guid': lun['lunguid'],
-            'number': number,
-            'initiatorgroup': initiatorgroup,
-            'size': lun['volsize'],
-            'nodestroy': lun['nodestroy'],
-            'targetgroup': lun['targetgroup']
-        }
-        if 'origin' in lun:
-            canonical['origin'] = lun['origin']
-        for custom in ['image_id', 'updated_at', 'cinder_managed']:
-            custom_value = lun.get('custom:' + custom)
-            if custom_value:
-                canonical[custom] = custom_value
-
-        return canonical
-
-    def get_all_luns(self, pool, project):
-        """return all luns in project."""
-        svc = '/api/storage/v1/pools/' + pool + '/projects/' + \
-            project + "/luns"
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            exception_msg = (_('Error Getting LUNs on '
-                               'Pool: %(pool)s '
-                               'Project: %(project)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'pool': pool,
-                                'project': project,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        canonical = []
-        for lun in json.loads(ret.data)['luns']:
-            canonical.append(self._canonify_lun_info(lun))
-        return canonical
-
-    def get_lun(self, pool, project, lun):
-        """return iscsi lun properties."""
-        svc = '/api/storage/v1/pools/' + pool + '/projects/' + \
-            project + "/luns/" + lun
-        ret = self.rclient.get(svc)
-        if ret.status == restclient.Status.NOT_FOUND:
-            # Sometimes a volume exists in cinder for which there is no
-            # corresponding LUN (e.g. LUN create failed). In this case,
-            # allow deletion to complete (without doing anything on the
-            # ZFSSA). Any other exception should be passed up.
-            LOG.warning('LUN with name %(lun)s not found in project '
-                        '%(project)s, pool %(pool)s.',
-                        {'lun': lun,
-                         'project': project,
-                         'pool': pool})
-            raise exception.VolumeNotFound(volume_id=lun)
-        elif ret.status != restclient.Status.OK:
-            exception_msg = (_('Error Getting '
-                               'Volume: %(lun)s on '
-                               'Pool: %(pool)s '
-                               'Project: %(project)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'lun': lun,
-                                'pool': pool,
-                                'project': project,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        return self._canonify_lun_info(json.loads(ret.data)['lun'])
-
-    def get_lun_snapshot(self, pool, project, lun, snapshot):
-        """Return iscsi lun snapshot properties."""
-        svc = ('/api/storage/v1/pools/' + pool + '/projects/' +
-               project + '/luns/' + lun + '/snapshots/' + snapshot)
-
-        ret = self.rclient.get(svc)
-        if ret.status == restclient.Status.NOT_FOUND:
-            LOG.warning('Snapshot %(snapshot)s of volume %(volume)s not '
-                        'found in project %(project)s, pool %(pool)s.',
-                        {'snapshot': snapshot,
-                         'project': project,
-                         'pool': pool,
-                         'volume': lun})
-            raise exception.SnapshotNotFound(snapshot_id=snapshot)
-        elif ret.status != restclient.Status.OK:
-            exception_msg = ('Error Getting '
-                             'Snapshot: %(snapshot)s of '
-                             'Volume: %(lun)s in '
-                             'Pool: %(pool)s, '
-                             'Project: %(project)s  '
-                             'Return code: %(ret.status)d, '
-                             'Message: %(ret.data)s.',
-                             {'snapshot': snapshot,
-                              'lun': lun,
-                              'pool': pool,
-                              'project': project,
-                              'ret.status': ret.status,
-                              'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        val = json.loads(ret.data)['snapshot']
-        ret = {
-            'name': val['name'],
-            'numclones': val['numclones'],
-        }
-        return ret
-
-    def set_lun_initiatorgroup(self, pool, project, lun, initiatorgroup):
-        """Set the initiatorgroup property of a LUN."""
-
-        # For backward-compatibility with 2013.1.2.x, set initiatorgroup
-        # to a single string if there's only one item in the list.
-        # Live-migration won't work, but existing functionality should still
-        # work. If the list is empty, substitute the special "maskAll" value.
-        if len(initiatorgroup) == 0:
-            initiatorgroup = 'com.sun.ms.vss.hg.maskAll'
-        elif len(initiatorgroup) == 1:
-            initiatorgroup = initiatorgroup[0]
-
-        svc = '/api/storage/v1/pools/' + pool + '/projects/' + \
-            project + '/luns/' + lun
-        arg = {
-            'initiatorgroup': initiatorgroup
-        }
-
-        LOG.debug('Setting LUN initiatorgroup. pool=%(pool)s, '
-                  'project=%(project)s, lun=%(lun)s, '
-                  'initiatorgroup=%(initiatorgroup)s',
-                  {'project': project,
-                   'pool': pool,
-                   'lun': lun,
-                   'initiatorgroup': initiatorgroup})
-
-        ret = self.rclient.put(svc, arg)
-        if ret.status != restclient.Status.ACCEPTED:
-            LOG.error('Error Setting Volume: %(lun)s to InitiatorGroup: '
-                      '%(initiatorgroup)s Pool: %(pool)s Project: '
-                      '%(project)s  Return code: %(ret.status)d Message: '
-                      '%(ret.data)s.',
-                      {'lun': lun,
-                       'initiatorgroup': initiatorgroup,
-                       'pool': pool,
-                       'project': project,
-                       'ret.status': ret.status,
-                       'ret.data': ret.data})
-
-    def delete_lun(self, pool, project, lun):
-        """delete iscsi lun."""
-        svc = '/api/storage/v1/pools/' + pool + '/projects/' + \
-            project + '/luns/' + lun
-
-        ret = self.rclient.delete(svc)
-        if ret.status != restclient.Status.NO_CONTENT:
-            exception_msg = (_('Error Deleting Volume: %(lun)s from '
-                               'Pool: %(pool)s, Project: %(project)s. '
-                               'Return code: %(ret.status)d, '
-                               'Message: %(ret.data)s.'),
-                             {'lun': lun,
-                              'pool': pool,
-                              'project': project,
-                              'ret.status': ret.status,
-                              'ret.data': ret.data})
-            LOG.error(exception_msg)
-            if ret.status == restclient.Status.FORBIDDEN:
-                # This means that the lun exists but it can't be deleted:
-                raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def create_snapshot(self, pool, project, lun, snapshot):
-        """create snapshot."""
-        svc = '/api/storage/v1/pools/' + pool + '/projects/' + \
-            project + '/luns/' + lun + '/snapshots'
-        arg = {
-            'name': snapshot
-        }
-
-        ret = self.rclient.post(svc, arg)
-        if ret.status != restclient.Status.CREATED:
-            exception_msg = (_('Error Creating '
-                               'Snapshot: %(snapshot)s on '
-                               'Volume: %(lun)s to '
-                               'Pool: %(pool)s '
-                               'Project: %(project)s  '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.'),
-                             {'snapshot': snapshot,
-                              'lun': lun,
-                              'pool': pool,
-                              'project': project,
-                              'ret.status': ret.status,
-                              'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def delete_snapshot(self, pool, project, lun, snapshot):
-        """delete snapshot."""
-        svc = '/api/storage/v1/pools/' + pool + '/projects/' + \
-              project + '/luns/' + lun + '/snapshots/' + snapshot
-
-        ret = self.rclient.delete(svc)
-        if ret.status != restclient.Status.NO_CONTENT:
-            exception_msg = (_('Error Deleting '
-                               'Snapshot: %(snapshot)s on '
-                               'Volume: %(lun)s to '
-                               'Pool: %(pool)s '
-                               'Project: %(project)s  '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'snapshot': snapshot,
-                                'lun': lun,
-                                'pool': pool,
-                                'project': project,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def clone_snapshot(self, pool, project, lun, snapshot, clone_proj, clone,
-                       specs):
-        """clone 'snapshot' to a lun named 'clone' in project 'clone_proj'."""
-        svc = '/api/storage/v1/pools/' + pool + '/projects/' + \
-            project + '/luns/' + lun + '/snapshots/' + snapshot + '/clone'
-        arg = {
-            'project': clone_proj,
-            'share': clone,
-            'nodestroy': True
-        }
-        if specs:
-            arg.update(specs)
-        # API fails if volblocksize is specified when cloning
-        arg.pop('volblocksize', '')
-
-        ret = self.rclient.put(svc, arg)
-        if ret.status != restclient.Status.CREATED:
-            exception_msg = (_('Error Cloning '
-                               'Snapshot: %(snapshot)s on '
-                               'Volume: %(lun)s of '
-                               'Pool: %(pool)s '
-                               'Project: %(project)s  '
-                               'Clone project: %(clone_proj)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'snapshot': snapshot,
-                                'lun': lun,
-                                'pool': pool,
-                                'project': project,
-                                'clone_proj': clone_proj,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def set_lun_props(self, pool, project, lun, **kargs):
-        """set lun properties."""
-        svc = '/api/storage/v1/pools/' + pool + '/projects/' + \
-            project + '/luns/' + lun
-        if kargs is None:
-            return
-
-        if 'schema' in kargs:
-            kargs.update(kargs.pop('schema'))
-
-        ret = self.rclient.put(svc, kargs)
-        if ret.status != restclient.Status.ACCEPTED:
-            exception_msg = (_('Error Setting props '
-                               'Props: %(props)s on '
-                               'Volume: %(lun)s of '
-                               'Pool: %(pool)s '
-                               'Project: %(project)s  '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'props': kargs,
-                                'lun': lun,
-                                'pool': pool,
-                                'project': project,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def get_initiator_initiatorgroup(self, initiator):
-        """Returns the initiator group of the initiator."""
-        groups = []
-        svc = "/api/san/v1/iscsi/initiator-groups"
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            msg = _('Error getting initiator groups.')
-            LOG.error(msg)
-            raise exception.VolumeBackendAPIException(data=msg)
-        val = json.loads(ret.data)
-        for initiator_group in val['groups']:
-            if initiator in initiator_group['initiators']:
-                groups.append(initiator_group["name"])
-        return groups
-
-    def create_schema(self, schema):
-        """Create a custom ZFSSA schema."""
-        base = '/api/storage/v1/schema'
-
-        svc = "%(base)s/%(prop)s" % {'base': base, 'prop': schema['property']}
-        ret = self.rclient.get(svc)
-        if ret.status == restclient.Status.OK:
-            LOG.warning('Property %s already exists.', schema['property'])
-            return
-
-        ret = self.rclient.post(base, schema)
-        if ret.status != restclient.Status.CREATED:
-            exception_msg = (_('Error Creating '
-                               'Property: %(property)s '
-                               'Type: %(type)s '
-                               'Description: %(description)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'property': schema['property'],
-                                'type': schema['type'],
-                                'description': schema['description'],
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def create_schemas(self, schemas):
-        """Create multiple custom ZFSSA schemas."""
-        ret = []
-        for schema in schemas:
-            res = self.create_schema(schema)
-            ret.append(res)
-        return ret
-
-
-class ZFSSANfsApi(ZFSSAApi):
-    """ZFSSA API proxy class for NFS driver"""
-    projects_path = '/api/storage/v1/pools/%s/projects'
-    project_path = projects_path + '/%s'
-
-    shares_path = project_path + '/filesystems'
-    share_path = shares_path + '/%s'
-    share_snapshots_path = share_path + '/snapshots'
-    share_snapshot_path = share_snapshots_path + '/%s'
-
-    services_path = '/api/service/v1/services/'
-
-    def __init__(self, *args, **kwargs):
-        super(ZFSSANfsApi, self).__init__(*args, **kwargs)
-        self.webdavclient = None
-
-    def set_webdav(self, https_path, auth_str):
-        self.webdavclient = webdavclient.ZFSSAWebDAVClient(https_path,
-                                                           auth_str)
-
-    def verify_share(self, pool, project, share):
-        """Checks whether the share exists"""
-        svc = self.share_path % (pool, project, share)
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            exception_msg = (_('Error Verifying '
-                               'share: %(share)s on '
-                               'Project: %(project)s and '
-                               'Pool: %(pool)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'share': share,
-                                'project': project,
-                                'pool': pool,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def create_snapshot(self, pool, project, share, snapshot):
-        """create snapshot of a share"""
-        svc = self.share_snapshots_path % (pool, project, share)
-
-        arg = {
-            'name': snapshot
-        }
-
-        ret = self.rclient.post(svc, arg)
-        if ret.status != restclient.Status.CREATED:
-            exception_msg = (_('Error Creating '
-                               'Snapshot: %(snapshot)s on '
-                               'share: %(share)s to '
-                               'Pool: %(pool)s '
-                               'Project: %(project)s  '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'snapshot': snapshot,
-                                'share': share,
-                                'pool': pool,
-                                'project': project,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def delete_snapshot(self, pool, project, share, snapshot):
-        """delete snapshot of a share"""
-        svc = self.share_snapshot_path % (pool, project, share, snapshot)
-
-        ret = self.rclient.delete(svc)
-        if ret.status != restclient.Status.NO_CONTENT:
-            exception_msg = (_('Error Deleting '
-                               'Snapshot: %(snapshot)s on '
-                               'Share: %(share)s to '
-                               'Pool: %(pool)s '
-                               'Project: %(project)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'snapshot': snapshot,
-                                'share': share,
-                                'pool': pool,
-                                'project': project,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def create_snapshot_of_volume_file(self, src_file="", dst_file=""):
-        src_file = '.zfs/snapshot/' + src_file
-        return self.webdavclient.request(src_file=src_file, dst_file=dst_file,
-                                         method='COPY')
-
-    def delete_snapshot_of_volume_file(self, src_file=""):
-        return self.webdavclient.request(src_file=src_file, method='DELETE')
-
-    def create_volume_from_snapshot_file(self, src_file="", dst_file="",
-                                         method='COPY'):
-        return self.webdavclient.request(src_file=src_file, dst_file=dst_file,
-                                         method=method)
-
-    def _change_service_state(self, service, state=''):
-        svc = self.services_path + service + '/' + state
-        ret = self.rclient.put(svc)
-        if ret.status != restclient.Status.ACCEPTED:
-            exception_msg = (_('Error Verifying '
-                               'Service: %(service)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'service': service,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-        data = json.loads(ret.data)['service']
-        LOG.debug('%(service)s service state: %(data)s',
-                  {'service': service, 'data': data})
-
-        status = 'online' if state == 'enable' else 'disabled'
-
-        if data['<status>'] != status:
-            exception_msg = (_('%(service)s Service is not %(status)s '
-                               'on storage appliance: %(host)s')
-                             % {'service': service,
-                                'status': status,
-                                'host': self.host})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def enable_service(self, service):
-        self._change_service_state(service, state='enable')
-        self.verify_service(service)
-
-    def disable_service(self, service):
-        self._change_service_state(service, state='disable')
-        self.verify_service(service, status='offline')
-
-    def modify_service(self, service, edit_args=None):
-        """Edit service properties"""
-        if edit_args is None:
-            edit_args = {}
-
-        svc = self.services_path + service
-
-        ret = self.rclient.put(svc, edit_args)
-
-        if ret.status != restclient.Status.ACCEPTED:
-            exception_msg = (_('Error modifying '
-                               'Service: %(service)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'service': service,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-        data = json.loads(ret.data)['service']
-        LOG.debug('Modify %(service)s service '
-                  'return data: %(data)s',
-                  {'service': service,
-                   'data': data})
-
-    def create_share(self, pool, project, share, args):
-        """Create a share in the specified pool and project"""
-        svc = self.share_path % (pool, project, share)
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            svc = self.shares_path % (pool, project)
-            args.update({'name': share})
-            ret = self.rclient.post(svc, args)
-            if ret.status != restclient.Status.CREATED:
-                exception_msg = (_('Error Creating '
-                                   'Share: %(name)s '
-                                   'Return code: %(ret.status)d '
-                                   'Message: %(ret.data)s.')
-                                 % {'name': share,
-                                    'ret.status': ret.status,
-                                    'ret.data': ret.data})
-                LOG.error(exception_msg)
-                raise exception.VolumeBackendAPIException(data=exception_msg)
-        else:
-            LOG.debug('Editing properties of a pre-existing share')
-            ret = self.rclient.put(svc, args)
-            if ret.status != restclient.Status.ACCEPTED:
-                exception_msg = (_('Error editing share: '
-                                   '%(share)s on '
-                                   'Pool: %(pool)s '
-                                   'Return code: %(ret.status)d '
-                                   'Message: %(ret.data)s .')
-                                 % {'share': share,
-                                    'pool': pool,
-                                    'ret.status': ret.status,
-                                    'ret.data': ret.data})
-                LOG.error(exception_msg)
-                raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def get_share(self, pool, project, share):
-        """return share properties"""
-        svc = self.share_path % (pool, project, share)
-        ret = self.rclient.get(svc)
-        if ret.status != restclient.Status.OK:
-            exception_msg = (_('Error Getting '
-                               'Share: %(share)s on '
-                               'Pool: %(pool)s '
-                               'Project: %(project)s '
-                               'Return code: %(ret.status)d '
-                               'Message: %(ret.data)s.')
-                             % {'share': share,
-                                'pool': pool,
-                                'project': project,
-                                'ret.status': ret.status,
-                                'ret.data': ret.data})
-            LOG.error(exception_msg)
-            raise exception.VolumeBackendAPIException(data=exception_msg)
-
-        val = json.loads(ret.data)
-        return val['filesystem']
-
-    def get_volume(self, volume):
-        LOG.debug('Getting volume %s.', volume)
-        try:
-            resp = self.webdavclient.request(src_file=volume,
-                                             method='PROPFIND')
-        except Exception:
-            raise exception.VolumeNotFound(volume_id=volume)
-
-        resp = resp.read()
-        numclones = self._parse_prop(resp, 'numclones')
-        result = {
-            'numclones': int(numclones) if numclones != '' else 0,
-            'updated_at': self._parse_prop(resp, 'updated_at'),
-            'image_id': self._parse_prop(resp, 'image_id'),
-            'origin': self._parse_prop(resp, 'origin'),
-            'cinder_managed': self._parse_prop(resp, 'cinder_managed'),
-        }
-        return result
-
-    def delete_file(self, filename):
-        try:
-            self.webdavclient.request(src_file=filename, method='DELETE')
-        except Exception:
-            exception_msg = ('Cannot delete file %s.', filename)
-            LOG.error(exception_msg)
-
-    def set_file_props(self, file, specs):
-        """Set custom properties to a file."""
-        for key in specs:
-            self.webdavclient.set_file_prop(file, key, specs[key])
-
-    def _parse_prop(self, response, prop):
-        """Parse a property value from the WebDAV response."""
-        propval = ""
-        for line in response.split("\n"):
-            if prop in line:
-                try:
-                    propval = line[(line.index('>') + 1):line.index('</')]
-                except Exception:
-                    pass
-        return propval
-
-    def create_directory(self, dirname):
-        try:
-            self.webdavclient.request(src_file=dirname, method='GET')
-            LOG.debug('Directory %s already exists.', dirname)
-        except Exception:
-            # The directory does not exist yet
-            try:
-                self.webdavclient.request(src_file=dirname, method='MKCOL')
-            except Exception:
-                exception_msg = (_('Cannot create directory %s.'), dirname)
-                raise exception.VolumeBackendAPIException(data=exception_msg)
-
-    def rename_volume(self, src, dst):
-        return self.webdavclient.request(src_file=src, dst_file=dst,
-                                         method='MOVE')
diff -pruN 2:15.0.1-1/cinder/volume/flows/api/create_volume.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/flows/api/create_volume.py
--- 2:15.0.1-1/cinder/volume/flows/api/create_volume.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/flows/api/create_volume.py	2020-03-24 18:46:31.000000000 +0000
@@ -11,10 +11,10 @@
 #    under the License.
 
 import collections
-import six
 
 from oslo_config import cfg
 from oslo_log import log as logging
+import six
 import taskflow.engines
 from taskflow.patterns import linear_flow
 from taskflow.types import failure as ft
@@ -799,7 +799,7 @@ class VolumeCastTask(flow_utils.CinderTa
         exc_info = False
         if all(flow_failures[-1].exc_info):
             exc_info = flow_failures[-1].exc_info
-        LOG.error('Unexpected build error:', exc_info=exc_info)
+        LOG.error('Unexpected build error:', exc_info=exc_info)  # noqa
 
 
 def get_flow(db_api, image_service_api, availability_zones, create_what,
diff -pruN 2:15.0.1-1/cinder/volume/flows/api/manage_existing.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/flows/api/manage_existing.py
--- 2:15.0.1-1/cinder/volume/flows/api/manage_existing.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/flows/api/manage_existing.py	2020-03-24 18:46:31.000000000 +0000
@@ -126,7 +126,7 @@ class ManageCastTask(flow_utils.CinderTa
         exc_info = False
         if all(flow_failures[-1].exc_info):
             exc_info = flow_failures[-1].exc_info
-        LOG.error('Unexpected build error:', exc_info=exc_info)
+        LOG.error('Unexpected build error:', exc_info=exc_info)  # noqa
 
 
 def get_flow(scheduler_rpcapi, db_api, create_what):
diff -pruN 2:15.0.1-1/cinder/volume/flows/manager/create_volume.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/flows/manager/create_volume.py
--- 2:15.0.1-1/cinder/volume/flows/manager/create_volume.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/flows/manager/create_volume.py	2020-03-24 18:46:31.000000000 +0000
@@ -559,6 +559,7 @@ class CreateVolumeFromSpecTask(flow_util
                     'cryptsetup',
                     'luksChangeKey',
                     attach_info['device']['path'],
+                    '--force-password',
                     run_as_root=True,
                     process_input=key_str,
                     log_errors=processutils.LOG_ALL_ERRORS)
@@ -583,6 +584,7 @@ class CreateVolumeFromSpecTask(flow_util
                     'cryptsetup',
                     '--batch-mode',
                     'luksFormat',
+                    '--force-password',
                     '--type', encryption['provider'],
                     '--cipher', encryption['cipher'],
                     '--key-size', str(encryption['key_size']),
@@ -772,6 +774,14 @@ class CreateVolumeFromSpecTask(flow_util
                     cache_entry['volume_id']
                 )
                 return model_update, True
+        except exception.SnapshotLimitReached:
+            # If this exception occurred when cloning the image-volume,
+            # it is because the image-volume reached its snapshot limit.
+            # Delete current cache entry and create a "fresh" entry
+            # NOTE: This will not delete the existing image-volume and
+            # only delete the cache entry
+            with excutils.save_and_reraise_exception():
+                self.image_volume_cache.evict(context, cache_entry)
         except NotImplementedError:
             LOG.warning('Backend does not support creating image-volume '
                         'clone. Image will be downloaded from Glance.')
@@ -855,17 +865,18 @@ class CreateVolumeFromSpecTask(flow_util
                         image_id,
                         image_meta
                     )
+                except exception.SnapshotLimitReached:
+                    # This exception will be handled by the caller's
+                    # (_create_from_image) retry decorator
+                    with excutils.save_and_reraise_exception():
+                        LOG.debug("Snapshot limit reached. Creating new "
+                                  "image-volume.")
                 except exception.CinderException as e:
                     LOG.warning('Failed to create volume from image-volume '
                                 'cache, image will be downloaded from Glance. '
                                 'Error: %(exception)s',
                                 {'exception': e})
 
-                    # If an exception occurred when cloning the image-volume,
-                    # it may be the image-volume reached its snapshot limit.
-                    # Create another "fresh" cache entry.
-                    update_cache = True
-
                 # Don't cache unless directed.
                 if not cloned and update_cache:
                     should_create_cache_entry = True
@@ -957,6 +968,7 @@ class CreateVolumeFromSpecTask(flow_util
 
         return model_update
 
+    @utils.retry(exception.SnapshotLimitReached, retries=1)
     def _create_from_image(self, context, volume,
                            image_location, image_id, image_meta,
                            image_service, **kwargs):
diff -pruN 2:15.0.1-1/cinder/volume/manager.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/manager.py
--- 2:15.0.1-1/cinder/volume/manager.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/manager.py	2020-03-24 18:46:31.000000000 +0000
@@ -35,8 +35,6 @@ intact.
 
 """
 
-
-import requests
 import time
 
 from castellan import key_manager
@@ -51,6 +49,7 @@ from oslo_utils import timeutils
 from oslo_utils import units
 from oslo_utils import uuidutils
 profiler = importutils.try_import('osprofiler.profiler')
+import requests
 import six
 from taskflow import exceptions as tfe
 
@@ -937,9 +936,6 @@ class VolumeManager(manager.CleanableMan
                 LOG.exception("Failed to update usages deleting volume.",
                               resource=volume)
 
-        # Delete glance metadata if it exists
-        self.db.volume_glance_metadata_delete_by_volume(context, volume.id)
-
         volume.destroy()
 
         # If deleting source/destination volume in a migration or a temp
@@ -1611,9 +1607,17 @@ class VolumeManager(manager.CleanableMan
 
         uri = 'cinder://%s' % image_volume.id
         image_registered = None
+
+        # retrieve store information from extra-specs
+        store_id = volume.volume_type.extra_specs.get('image_service:store_id')
+        location_metadata = {}
+
+        if store_id:
+            location_metadata['store'] = store_id
+
         try:
             image_registered = image_service.add_location(
-                ctx, image_meta['id'], uri, {})
+                ctx, image_meta['id'], uri, location_metadata)
         except (exception.NotAuthorized, exception.Invalid,
                 exception.NotFound):
             LOG.exception('Failed to register image volume location '
@@ -1801,7 +1805,7 @@ class VolumeManager(manager.CleanableMan
         driver_volume_type:
             a string to identify the type of volume.  This can be used by the
             calling code to determine the strategy for connecting to the
-            volume. This could be 'iscsi', 'rbd', 'sheepdog', etc.
+            volume. This could be 'iscsi', 'rbd', etc.
 
         data:
             this is the data that the calling code will use to connect to the
@@ -2416,7 +2420,7 @@ class VolumeManager(manager.CleanableMan
         # swappy thing so it's a bit confusing, but it does unwind properly
         # when you step through it)
 
-        # In the new flow we simlified this and we don't need it, instead of
+        # In the new flow we simplified this and we don't need it, instead of
         # doing a bunch of swapping we just do attachment-create/delete on the
         # nova side, and then here we just do the ID swaps that are necessary
         # to maintain the old beahvior
@@ -2839,7 +2843,7 @@ class VolumeManager(manager.CleanableMan
         new_reservations = reservations
 
         # If volume types have the same contents, no need to do anything.
-        # Use the admin contex to be able to access volume extra_specs
+        # Use the admin context to be able to access volume extra_specs
         retyped = False
         diff, all_equal = volume_types.volume_types_diff(
             context.elevated(), volume.volume_type_id, new_type_id)
@@ -3564,9 +3568,6 @@ class VolumeManager(manager.CleanableMan
                               resource={'type': 'group',
                                         'id': group.id})
 
-            # Delete glance metadata if it exists
-            self.db.volume_glance_metadata_delete_by_volume(context, vol.id)
-
             vol.destroy()
 
             # Commit the reservations
diff -pruN 2:15.0.1-1/cinder/volume/targets/iet.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/targets/iet.py
--- 2:15.0.1-1/cinder/volume/targets/iet.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/targets/iet.py	2020-03-24 18:46:31.000000000 +0000
@@ -16,6 +16,7 @@ import stat
 
 from oslo_concurrency import processutils as putils
 from oslo_log import log as logging
+from oslo_log import versionutils
 
 from cinder import exception
 import cinder.privsep.targets.iet
@@ -34,6 +35,11 @@ class IetAdm(iscsi.ISCSITarget):
         self.iscsi_iotype = self.configuration.safe_get('iscsi_iotype')
         self.auth_type = 'IncomingUser'
         self.iet_sessions = '/proc/net/iet/session'
+        versionutils.report_deprecated_feature(
+            LOG,
+            'The IET iSCSI target is deprecated and will be removed in the '
+            '"V" release. It is recommended to use the LIO or TGT targets '
+            'instead.')
 
     def _get_target(self, iqn):
 
diff -pruN 2:15.0.1-1/cinder/volume/targets/nvmet.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/targets/nvmet.py
--- 2:15.0.1-1/cinder/volume/targets/nvmet.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/targets/nvmet.py	2020-03-24 18:46:31.000000000 +0000
@@ -83,7 +83,7 @@ class NVMET(nvmeof.NVMeOF):
 
     def _restore(self, nvmf_subsystems):
         # Dump updated JSON dict to append new subsystem
-        with tempfile.NamedTemporaryFile() as tmp_fd:
+        with tempfile.NamedTemporaryFile(mode='w') as tmp_fd:
             tmp_fd.write(json.dumps(nvmf_subsystems))
             tmp_fd.flush()
             try:
diff -pruN 2:15.0.1-1/cinder/volume/targets/scst.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/targets/scst.py
--- 2:15.0.1-1/cinder/volume/targets/scst.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/targets/scst.py	2020-03-24 18:46:31.000000000 +0000
@@ -223,7 +223,7 @@ class SCSTAdm(iscsi.ISCSITarget):
             # starts
         try:
             self.scst_execute('-write_config', '/etc/scst.conf')
-        except putils.ProcessExecutionError as e:
+        except putils.ProcessExecutionError:
             LOG.error("Failed to write in /etc/scst.conf.")
             raise exception.ISCSITargetHelperCommandFailed(
                 error_message="Failed to write in /etc/scst.conf.")
diff -pruN 2:15.0.1-1/cinder/volume/targets/spdknvmf.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/targets/spdknvmf.py
--- 2:15.0.1-1/cinder/volume/targets/spdknvmf.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/targets/spdknvmf.py	2020-03-24 18:46:31.000000000 +0000
@@ -91,7 +91,7 @@ class SpdkNvmf(nvmeof.NVMeOF):
         return req.json()['result']
 
     def _get_spdk_volume_name(self, name):
-        output = self._rpc_call('get_bdevs')
+        output = self._rpc_call('bdev_get_bdevs')
 
         for bdev in output:
             for alias in bdev['aliases']:
@@ -99,7 +99,7 @@ class SpdkNvmf(nvmeof.NVMeOF):
                     return bdev['name']
 
     def _get_nqn_with_volume_name(self, name):
-        output = self._rpc_call('get_nvmf_subsystems')
+        output = self._rpc_call('nvmf_get_subsystems')
 
         spdk_name = self._get_spdk_volume_name(name)
 
@@ -112,7 +112,7 @@ class SpdkNvmf(nvmeof.NVMeOF):
     def _get_first_free_node(self):
         cnode_num = []
 
-        output = self._rpc_call('get_nvmf_subsystems')
+        output = self._rpc_call('nvmf_get_subsystems')
 
         # Get node numbers for nqn string like this: nqn.2016-06.io.spdk:cnode1
 
@@ -149,7 +149,7 @@ class SpdkNvmf(nvmeof.NVMeOF):
                 'allow_any_host': True,
                 'serial_number': serial,
             }
-            self._rpc_call('nvmf_subsystem_create', params)
+            self._rpc_call('nvmf_create_subsystem', params)
 
             listen_address = {
                 'trtype': transport_type,
@@ -189,7 +189,7 @@ class SpdkNvmf(nvmeof.NVMeOF):
         if nqn is not None:
             try:
                 params = {'nqn': nqn}
-                self._rpc_call('delete_nvmf_subsystem', params)
+                self._rpc_call('nvmf_delete_subsystem', params)
                 LOG.debug('SPDK subsystem %s deleted', nqn)
             except Exception as e:
                 LOG.debug('SPDK ERROR: subsystem not deleted: %s', e)
diff -pruN 2:15.0.1-1/cinder/volume/volume_utils.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/volume_utils.py
--- 2:15.0.1-1/cinder/volume/volume_utils.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/volume/volume_utils.py	2020-03-24 18:46:31.000000000 +0000
@@ -14,7 +14,6 @@
 
 """Volume-related Utilities and helpers."""
 
-
 import ast
 import functools
 import json
@@ -22,6 +21,7 @@ import math
 import operator
 import os
 from os import urandom
+from random import shuffle
 import re
 import socket
 import tempfile
@@ -43,7 +43,6 @@ from oslo_utils import netutils
 from oslo_utils import strutils
 from oslo_utils import timeutils
 from oslo_utils import units
-from random import shuffle
 import six
 from six.moves import range
 
@@ -53,13 +52,13 @@ from cinder import db
 from cinder import exception
 from cinder.i18n import _
 from cinder import objects
+from cinder.objects import fields
 from cinder import rpc
 from cinder import utils
 from cinder.volume import group_types
 from cinder.volume import throttling
 from cinder.volume import volume_types
 
-
 CONF = cfg.CONF
 
 LOG = logging.getLogger(__name__)
@@ -1247,3 +1246,9 @@ def resolve_hostname(hostname):
     LOG.debug('Asked to resolve hostname %(host)s and got IP %(ip)s.',
               {'host': hostname, 'ip': ip})
     return ip
+
+
+def update_backup_error(backup, err, status=fields.BackupStatus.ERROR):
+    backup.status = status
+    backup.fail_reason = err
+    backup.save()
diff -pruN 2:15.0.1-1/cinder/wsgi/wsgi.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/wsgi/wsgi.py
--- 2:15.0.1-1/cinder/wsgi/wsgi.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/wsgi/wsgi.py	2020-03-24 18:46:31.000000000 +0000
@@ -12,21 +12,17 @@
 
 """Cinder OS API WSGI application."""
 
-
 import sys
 import warnings
-
-from cinder import objects
-
 warnings.simplefilter('once', DeprecationWarning)
 
 from oslo_config import cfg
 from oslo_log import log as logging
 from oslo_service import wsgi
 
-from cinder import i18n
+from cinder import objects  # noqa
+from cinder import i18n  # noqa
 i18n.enable_lazy()
-
 # Need to register global_opts
 from cinder.common import config
 from cinder.common import constants
diff -pruN 2:15.0.1-1/cinder/zonemanager/drivers/brocade/brcd_fc_zone_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/zonemanager/drivers/brocade/brcd_fc_zone_driver.py
--- 2:15.0.1-1/cinder/zonemanager/drivers/brocade/brcd_fc_zone_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/zonemanager/drivers/brocade/brcd_fc_zone_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -83,6 +83,9 @@ class BrcdFCZoneDriver(fc_zone_driver.FC
     # ThirdPartySystems wiki page
     CI_WIKI_NAME = "Brocade_OpenStack_CI"
 
+    # TODO(smcginnis) Evaluate removing plans once we get to the V release
+    SUPPORTED = False
+
     def __init__(self, **kwargs):
         super(BrcdFCZoneDriver, self).__init__(**kwargs)
         self.sb_conn_map = {}
diff -pruN 2:15.0.1-1/cinder/zonemanager/drivers/brocade/brcd_http_fc_zone_client.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/zonemanager/drivers/brocade/brcd_http_fc_zone_client.py
--- 2:15.0.1-1/cinder/zonemanager/drivers/brocade/brcd_http_fc_zone_client.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/zonemanager/drivers/brocade/brcd_http_fc_zone_client.py	2020-03-24 18:46:31.000000000 +0000
@@ -18,13 +18,13 @@ Brocade south bound connector to communi
 HTTP or HTTPS protocol.
 """
 
-import requests
-import six
 import time
 
 from oslo_log import log as logging
 from oslo_serialization import base64
 from oslo_utils import encodeutils
+import requests
+import six
 
 from cinder.i18n import _
 from cinder.zonemanager.drivers.brocade import exception as b_exception
diff -pruN 2:15.0.1-1/cinder/zonemanager/drivers/cisco/cisco_fc_zone_driver.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/zonemanager/drivers/cisco/cisco_fc_zone_driver.py
--- 2:15.0.1-1/cinder/zonemanager/drivers/cisco/cisco_fc_zone_driver.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder/zonemanager/drivers/cisco/cisco_fc_zone_driver.py	2020-03-24 18:46:31.000000000 +0000
@@ -26,15 +26,15 @@ add_connection and delete_connection int
 :zone_activate: Used by: class: 'FCZoneDriver'. Defaults to True
 :zone_name_prefix: Used by: class: 'FCZoneDriver'. Defaults to 'openstack'
 """
+import re
+import string
 
 from oslo_concurrency import lockutils
 from oslo_config import cfg
 from oslo_log import log as logging
 from oslo_utils import excutils
 from oslo_utils import importutils
-import re
 import six
-import string
 
 from cinder import exception
 from cinder.i18n import _
diff -pruN 2:15.0.1-1/cinder.egg-info/dependency_links.txt 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder.egg-info/dependency_links.txt
--- 2:15.0.1-1/cinder.egg-info/dependency_links.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder.egg-info/dependency_links.txt	2020-03-24 18:46:35.000000000 +0000
@@ -0,0 +1 @@
+
diff -pruN 2:15.0.1-1/cinder.egg-info/entry_points.txt 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder.egg-info/entry_points.txt
--- 2:15.0.1-1/cinder.egg-info/entry_points.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder.egg-info/entry_points.txt	2020-03-24 18:46:35.000000000 +0000
@@ -0,0 +1,47 @@
+[cinder.database.migration_backend]
+sqlalchemy = oslo_db.sqlalchemy.migration
+
+[cinder.scheduler.filters]
+AvailabilityZoneFilter = cinder.scheduler.filters.availability_zone_filter:AvailabilityZoneFilter
+CapabilitiesFilter = cinder.scheduler.filters.capabilities_filter:CapabilitiesFilter
+CapacityFilter = cinder.scheduler.filters.capacity_filter:CapacityFilter
+DifferentBackendFilter = cinder.scheduler.filters.affinity_filter:DifferentBackendFilter
+DriverFilter = cinder.scheduler.filters.driver_filter:DriverFilter
+InstanceLocalityFilter = cinder.scheduler.filters.instance_locality_filter:InstanceLocalityFilter
+JsonFilter = cinder.scheduler.filters.json_filter:JsonFilter
+RetryFilter = cinder.scheduler.filters.ignore_attempted_hosts_filter:IgnoreAttemptedHostsFilter
+SameBackendFilter = cinder.scheduler.filters.affinity_filter:SameBackendFilter
+
+[cinder.scheduler.weights]
+AllocatedCapacityWeigher = cinder.scheduler.weights.capacity:AllocatedCapacityWeigher
+CapacityWeigher = cinder.scheduler.weights.capacity:CapacityWeigher
+ChanceWeigher = cinder.scheduler.weights.chance:ChanceWeigher
+GoodnessWeigher = cinder.scheduler.weights.goodness:GoodnessWeigher
+VolumeNumberWeigher = cinder.scheduler.weights.volume_number:VolumeNumberWeigher
+
+[console_scripts]
+cinder-api = cinder.cmd.api:main
+cinder-backup = cinder.cmd.backup:main
+cinder-manage = cinder.cmd.manage:main
+cinder-rootwrap = oslo_rootwrap.cmd:main
+cinder-rtstool = cinder.cmd.rtstool:main
+cinder-scheduler = cinder.cmd.scheduler:main
+cinder-status = cinder.cmd.status:main
+cinder-volume = cinder.cmd.volume:main
+cinder-volume-usage-audit = cinder.cmd.volume_usage_audit:main
+
+[oslo.config.opts]
+cinder = cinder.opts:list_opts
+
+[oslo.config.opts.defaults]
+cinder = cinder.common.config:set_external_library_defaults
+
+[oslo.policy.enforcer]
+cinder = cinder.policy:get_enforcer
+
+[oslo.policy.policies]
+cinder = cinder.policies:list_rules
+
+[wsgi_scripts]
+cinder-wsgi = cinder.wsgi.wsgi:initialize_application
+
diff -pruN 2:15.0.1-1/cinder.egg-info/not-zip-safe 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder.egg-info/not-zip-safe
--- 2:15.0.1-1/cinder.egg-info/not-zip-safe	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder.egg-info/not-zip-safe	2020-03-24 18:46:35.000000000 +0000
@@ -0,0 +1 @@
+
diff -pruN 2:15.0.1-1/cinder.egg-info/pbr.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder.egg-info/pbr.json
--- 2:15.0.1-1/cinder.egg-info/pbr.json	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder.egg-info/pbr.json	2020-03-24 18:46:35.000000000 +0000
@@ -0,0 +1 @@
+{"git_version": "a0c0a9e23", "is_release": false}
\ No newline at end of file
diff -pruN 2:15.0.1-1/cinder.egg-info/PKG-INFO 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder.egg-info/PKG-INFO
--- 2:15.0.1-1/cinder.egg-info/PKG-INFO	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder.egg-info/PKG-INFO	2020-03-24 18:46:35.000000000 +0000
@@ -0,0 +1,69 @@
+Metadata-Version: 2.1
+Name: cinder
+Version: 16.0.0.0b2.dev64
+Summary: OpenStack Block Storage
+Home-page: https://docs.openstack.org/cinder/latest/
+Author: OpenStack
+Author-email: openstack-discuss@lists.openstack.org
+License: UNKNOWN
+Description: ================
+        OpenStack Cinder
+        ================
+        
+        .. image:: https://governance.openstack.org/tc/badges/cinder.svg
+            :target: https://governance.openstack.org/tc/reference/tags/index.html
+        
+        .. Change things from this point on
+        
+        OpenStack Cinder is a storage service for an open cloud computing service.
+        
+        You can learn more about Cinder at:
+        
+        * `Wiki <https://wiki.openstack.org/Cinder/>`__
+        * `Developer Docs <https://docs.openstack.org/cinder/latest/>`__
+        * `Blueprints <https://blueprints.launchpad.net/cinder/>`__
+        * `Release notes <https://docs.openstack.org/releasenotes/cinder/>`__
+        * `Design specifications <https://specs.openstack.org/openstack/cinder-specs/>`__
+        
+        Getting Started
+        ---------------
+        
+        If you'd like to run from the master branch, you can clone the git repo:
+        
+            git clone https://opendev.org/openstack/cinder
+        
+        If you'd like to contribute, please see the information in
+        `CONTRIBUTING.rst <https://opendev.org/openstack/cinder/src/branch/master/CONTRIBUTING.rst>`_
+        
+        You can raise bugs on `Launchpad <https://bugs.launchpad.net/cinder>`__
+        
+        Python client
+        -------------
+        `Python Cinderclient <https://opendev.org/openstack/python-cinderclient>`__
+        
+        
+Platform: UNKNOWN
+Classifier: Environment :: OpenStack
+Classifier: Intended Audience :: Information Technology
+Classifier: Intended Audience :: System Administrators
+Classifier: License :: OSI Approved :: Apache Software License
+Classifier: Operating System :: POSIX :: Linux
+Classifier: Programming Language :: Python
+Classifier: Programming Language :: Python :: 3
+Classifier: Programming Language :: Python :: 3.6
+Classifier: Programming Language :: Python :: 3.7
+Provides-Extra: all
+Provides-Extra: datacore
+Provides-Extra: datera
+Provides-Extra: ds8k
+Provides-Extra: fujitsu
+Provides-Extra: hpe3par
+Provides-Extra: infinidat
+Provides-Extra: kaminario
+Provides-Extra: powermax
+Provides-Extra: pure
+Provides-Extra: rsd
+Provides-Extra: storpool
+Provides-Extra: test
+Provides-Extra: unity
+Provides-Extra: vnx
diff -pruN 2:15.0.1-1/cinder.egg-info/requires.txt 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder.egg-info/requires.txt
--- 2:15.0.1-1/cinder.egg-info/requires.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder.egg-info/requires.txt	2020-03-24 18:46:35.000000000 +0000
@@ -0,0 +1,133 @@
+Paste>=2.0.2
+PasteDeploy>=1.5.0
+Routes>=2.3.1
+SQLAlchemy!=1.1.5,!=1.1.6,!=1.1.7,!=1.1.8,>=1.0.10
+WebOb>=1.7.1
+castellan>=0.16.0
+cryptography>=2.1
+cursive>=0.2.1
+decorator>=3.4.0
+defusedxml>=0.5.0
+eventlet!=0.23.0,!=0.25.0,>=0.22.0
+google-api-python-client>=1.4.2
+greenlet>=0.4.10
+httplib2>=0.9.1
+iso8601>=0.1.11
+jsonschema>=2.6.0
+keystoneauth1>=3.7.0
+keystonemiddleware>=4.21.0
+lxml!=3.7.0,>=3.4.1
+oauth2client!=4.0.0,>=1.5.0
+os-brick>=2.2.0
+os-win>=3.0.0
+oslo.concurrency>=3.26.0
+oslo.config>=5.2.0
+oslo.context>=2.19.2
+oslo.db>=4.35.0
+oslo.i18n>=3.15.3
+oslo.log>=3.36.0
+oslo.messaging>=6.4.0
+oslo.middleware>=3.31.0
+oslo.policy>=1.44.1
+oslo.privsep>=1.32.0
+oslo.reports>=1.18.0
+oslo.rootwrap>=5.8.0
+oslo.serialization!=2.19.1,>=2.18.0
+oslo.service!=1.28.1,>=1.24.0
+oslo.upgradecheck>=0.1.0
+oslo.utils>=3.34.0
+oslo.versionedobjects>=1.31.2
+oslo.vmware>=2.35.0
+osprofiler>=1.4.0
+paramiko>=2.4.0
+pbr!=2.1.0,>=2.0.0
+psutil>=3.2.2
+pyparsing>=2.1.0
+python-barbicanclient>=4.5.2
+python-glanceclient>=2.15.0
+python-keystoneclient>=3.15.0
+python-novaclient>=9.1.0
+python-swiftclient>=3.2.0
+pytz>=2013.6
+requests!=2.20.0,>=2.14.2
+retrying!=1.3.0,>=1.2.3
+rtslib-fb>=2.1.65
+six>=1.10.0
+sqlalchemy-migrate>=0.11.0
+stevedore>=1.20.0
+suds-jurko>=0.6
+tabulate>=0.8.5
+taskflow>=3.2.0
+tooz>=1.58.0
+
+[all]
+infinisdk>=103.0.1
+krest>=1.3.0
+purestorage>=1.6.0
+pyOpenSSL>=17.5.0
+python-3parclient>=4.1.0
+pywbem>=0.7.0
+storops>=0.5.10
+storpool.spopenstack>=2.2.1
+storpool>=4.0.0
+websocket-client>=0.32.0
+
+[datacore]
+websocket-client>=0.32.0
+
+[datera]
+dfs_sdk>=1.2.25
+
+[ds8k]
+pyOpenSSL>=17.5.0
+
+[fujitsu]
+pywbem>=0.7.0
+
+[hpe3par]
+python-3parclient>=4.1.0
+
+[infinidat]
+infinisdk>=103.0.1
+
+[kaminario]
+krest>=1.3.0
+
+[powermax]
+pyOpenSSL>=17.5.0
+
+[pure]
+purestorage>=1.6.0
+
+[rsd]
+rsd-lib>=1.1.0
+
+[storpool]
+storpool.spopenstack>=2.2.1
+storpool>=4.0.0
+
+[test]
+PyMySQL>=0.7.6
+Pygments>=2.2.0
+SQLAlchemy-Utils>=0.36.1
+bandit==1.6.0
+coverage!=4.4,>=4.0
+ddt>=1.2.1
+doc8>=0.6.0
+fixtures>=3.0.0
+flake8-import-order
+flake8-logging-format>=0.6.0
+hacking>=2.0.0
+oslo.versionedobjects[fixtures]>=1.31.2
+oslotest>=3.2.0
+psycopg2>=2.7
+pycodestyle==2.5.0
+reno>=2.5.0
+stestr>=2.2.0
+testtools>=2.2.0
+
+[unity]
+storops>=0.5.10
+
+[vnx]
+storops>=0.5.10
diff -pruN 2:15.0.1-1/cinder.egg-info/SOURCES.txt 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder.egg-info/SOURCES.txt
--- 2:15.0.1-1/cinder.egg-info/SOURCES.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder.egg-info/SOURCES.txt	2020-03-24 18:46:36.000000000 +0000
@@ -0,0 +1,2688 @@
+.coveragerc
+.pylintrc
+.stestr.conf
+.zuul.yaml
+AUTHORS
+CONTRIBUTING.rst
+ChangeLog
+HACKING.rst
+LICENSE
+README.rst
+babel.cfg
+bindep.txt
+driver-requirements.txt
+lower-constraints.txt
+reno.yaml
+requirements.txt
+setup.cfg
+setup.py
+test-requirements.txt
+tox.ini
+api-ref/source/api_microversion_history.rst
+api-ref/source/conf.py
+api-ref/source/index.rst
+api-ref/source/status.yaml
+api-ref/source/v2/api-versions.inc
+api-ref/source/v2/capabilities-v2.inc
+api-ref/source/v2/consistencygroups-v2.inc
+api-ref/source/v2/ext-backups-actions-v2.inc
+api-ref/source/v2/ext-backups.inc
+api-ref/source/v2/hosts.inc
+api-ref/source/v2/index.rst
+api-ref/source/v2/limits.inc
+api-ref/source/v2/os-cgsnapshots-v2.inc
+api-ref/source/v2/os-vol-pool-v2.inc
+api-ref/source/v2/os-vol-transfer-v2.inc
+api-ref/source/v2/parameters.yaml
+api-ref/source/v2/qos-specs-v2-qos-specs.inc
+api-ref/source/v2/quota-classes.inc
+api-ref/source/v2/quota-sets.inc
+api-ref/source/v2/volume-manage.inc
+api-ref/source/v2/volume-type-access.inc
+api-ref/source/v2/volumes-v2-extensions.inc
+api-ref/source/v2/volumes-v2-snapshots-actions.inc
+api-ref/source/v2/volumes-v2-snapshots.inc
+api-ref/source/v2/volumes-v2-types.inc
+api-ref/source/v2/volumes-v2-versions.inc
+api-ref/source/v2/volumes-v2-volumes-actions.inc
+api-ref/source/v2/volumes-v2-volumes.inc
+api-ref/source/v2/samples/backend-capabilities-response.json
+api-ref/source/v2/samples/backup-create-request.json
+api-ref/source/v2/samples/backup-create-response.json
+api-ref/source/v2/samples/backup-force-delete-request.json
+api-ref/source/v2/samples/backup-record-export-response.json
+api-ref/source/v2/samples/backup-record-import-request.json
+api-ref/source/v2/samples/backup-record-import-response.json
+api-ref/source/v2/samples/backup-reset-status-request.json
+api-ref/source/v2/samples/backup-restore-request.json
+api-ref/source/v2/samples/backup-restore-response.json
+api-ref/source/v2/samples/backup-show-response.json
+api-ref/source/v2/samples/backups-list-detailed-response.json
+api-ref/source/v2/samples/backups-list-response.json
+api-ref/source/v2/samples/cgsnapshots-create-request.json
+api-ref/source/v2/samples/cgsnapshots-create-response.json
+api-ref/source/v2/samples/cgsnapshots-list-detailed-response.json
+api-ref/source/v2/samples/cgsnapshots-list-response.json
+api-ref/source/v2/samples/cgsnapshots-show-response.json
+api-ref/source/v2/samples/consistency-group-create-from-src-request.json
+api-ref/source/v2/samples/consistency-group-create-request.json
+api-ref/source/v2/samples/consistency-group-create-response.json
+api-ref/source/v2/samples/consistency-group-delete-request.json
+api-ref/source/v2/samples/consistency-group-show-response.json
+api-ref/source/v2/samples/consistency-group-update-request.json
+api-ref/source/v2/samples/consistency-groups-list-detailed-response.json
+api-ref/source/v2/samples/consistency-groups-list-response.json
+api-ref/source/v2/samples/encryption-type-create-request.json
+api-ref/source/v2/samples/encryption-type-create-response.json
+api-ref/source/v2/samples/encryption-type-show-response.json
+api-ref/source/v2/samples/encryption-type-update-request.json
+api-ref/source/v2/samples/encryption-type-update-response.json
+api-ref/source/v2/samples/extensions-list-response.json
+api-ref/source/v2/samples/host-attach-request.json
+api-ref/source/v2/samples/hosts-get-response.json
+api-ref/source/v2/samples/hosts-list-response.json
+api-ref/source/v2/samples/image-metadata-show-request.json
+api-ref/source/v2/samples/image-metadata-show-response.json
+api-ref/source/v2/samples/limits-show-response.json
+api-ref/source/v2/samples/pools-list-detailed-response.json
+api-ref/source/v2/samples/qos-create-request.json
+api-ref/source/v2/samples/qos-create-response.json
+api-ref/source/v2/samples/qos-list-response.json
+api-ref/source/v2/samples/qos-show-response.json
+api-ref/source/v2/samples/qos-unset-request.json
+api-ref/source/v2/samples/qos-unset-response.json
+api-ref/source/v2/samples/qos-update-request.json
+api-ref/source/v2/samples/qos-update-response.json
+api-ref/source/v2/samples/qos_show_response.json
+api-ref/source/v2/samples/quota-classes-show-response.json
+api-ref/source/v2/samples/quota-classes-update-request.json
+api-ref/source/v2/samples/quota-classes-update-response.json
+api-ref/source/v2/samples/quotas-delete-response.json
+api-ref/source/v2/samples/quotas-show-defaults-response.json
+api-ref/source/v2/samples/quotas-show-response.json
+api-ref/source/v2/samples/quotas-update-request.json
+api-ref/source/v2/samples/quotas-update-response.json
+api-ref/source/v2/samples/quotas-user-show-detailed-response.json
+api-ref/source/v2/samples/quotas-user-show-response.json
+api-ref/source/v2/samples/snapshot-create-request.json
+api-ref/source/v2/samples/snapshot-create-response.json
+api-ref/source/v2/samples/snapshot-metadata-create-request.json
+api-ref/source/v2/samples/snapshot-metadata-create-response.json
+api-ref/source/v2/samples/snapshot-metadata-show-response.json
+api-ref/source/v2/samples/snapshot-metadata-update-request.json
+api-ref/source/v2/samples/snapshot-metadata-update-response.json
+api-ref/source/v2/samples/snapshot-show-response.json
+api-ref/source/v2/samples/snapshot-status-reset-request.json
+api-ref/source/v2/samples/snapshot-update-request.json
+api-ref/source/v2/samples/snapshot-update-response.json
+api-ref/source/v2/samples/snapshots-list-detailed-response.json
+api-ref/source/v2/samples/snapshots-list-response.json
+api-ref/source/v2/samples/user-quotas-show-response.json
+api-ref/source/v2/samples/user-quotas-update-request.json
+api-ref/source/v2/samples/user-quotas-update-response.json
+api-ref/source/v2/samples/version-show-response.json
+api-ref/source/v2/samples/versions-response.json
+api-ref/source/v2/samples/volume-attach-request.json
+api-ref/source/v2/samples/volume-bootable-status-update-request.json
+api-ref/source/v2/samples/volume-create-request.json
+api-ref/source/v2/samples/volume-create-response.json
+api-ref/source/v2/samples/volume-detach-request.json
+api-ref/source/v2/samples/volume-extend-request.json
+api-ref/source/v2/samples/volume-force-delete-request.json
+api-ref/source/v2/samples/volume-force-detach-request.json
+api-ref/source/v2/samples/volume-image-metadata-set-request.json
+api-ref/source/v2/samples/volume-image-metadata-unset-request.json
+api-ref/source/v2/samples/volume-image-metadata-update-response.json
+api-ref/source/v2/samples/volume-manage-request.json
+api-ref/source/v2/samples/volume-manage-response.json
+api-ref/source/v2/samples/volume-metadata-create-request.json
+api-ref/source/v2/samples/volume-metadata-create-response.json
+api-ref/source/v2/samples/volume-metadata-show-key-response.json
+api-ref/source/v2/samples/volume-metadata-show-response.json
+api-ref/source/v2/samples/volume-metadata-update-key-request.json
+api-ref/source/v2/samples/volume-metadata-update-key-response.json
+api-ref/source/v2/samples/volume-metadata-update-request.json
+api-ref/source/v2/samples/volume-metadata-update-response.json
+api-ref/source/v2/samples/volume-os-migrate_volume-request.json
+api-ref/source/v2/samples/volume-os-migrate_volume_completion-request.json
+api-ref/source/v2/samples/volume-os-retype-request.json
+api-ref/source/v2/samples/volume-show-response.json
+api-ref/source/v2/samples/volume-status-reset-request.json
+api-ref/source/v2/samples/volume-transfer-accept-request.json
+api-ref/source/v2/samples/volume-transfer-accept-response.json
+api-ref/source/v2/samples/volume-transfer-create-request.json
+api-ref/source/v2/samples/volume-transfer-create-response.json
+api-ref/source/v2/samples/volume-transfer-show-response.json
+api-ref/source/v2/samples/volume-transfers-list-detailed-response.json
+api-ref/source/v2/samples/volume-transfers-list-response.json
+api-ref/source/v2/samples/volume-type-access-add-request.json
+api-ref/source/v2/samples/volume-type-access-delete-request.json
+api-ref/source/v2/samples/volume-type-access-list-response.json
+api-ref/source/v2/samples/volume-type-create-request.json
+api-ref/source/v2/samples/volume-type-show-request.json
+api-ref/source/v2/samples/volume-type-show-response.json
+api-ref/source/v2/samples/volume-type-update-request.json
+api-ref/source/v2/samples/volume-types-list-response.json
+api-ref/source/v2/samples/volume-unmanage-request.json
+api-ref/source/v2/samples/volume-update-request.json
+api-ref/source/v2/samples/volume-update-response.json
+api-ref/source/v2/samples/volumes-list-detailed-response.json
+api-ref/source/v2/samples/volumes-list-response.json
+api-ref/source/v3/api-versions.inc
+api-ref/source/v3/attachments.inc
+api-ref/source/v3/capabilities-v3.inc
+api-ref/source/v3/consistencygroups-v3.inc
+api-ref/source/v3/ext-backups-actions-v3.inc
+api-ref/source/v3/ext-backups.inc
+api-ref/source/v3/group-replication.inc
+api-ref/source/v3/group-snapshots.inc
+api-ref/source/v3/group-type-specs.inc
+api-ref/source/v3/group-types.inc
+api-ref/source/v3/groups.inc
+api-ref/source/v3/hosts.inc
+api-ref/source/v3/index.rst
+api-ref/source/v3/limits.inc
+api-ref/source/v3/messages.inc
+api-ref/source/v3/os-cgsnapshots-v3.inc
+api-ref/source/v3/os-services.inc
+api-ref/source/v3/os-vol-pool-v3.inc
+api-ref/source/v3/os-vol-transfer-v3.inc
+api-ref/source/v3/parameters.yaml
+api-ref/source/v3/qos-specs-v3-qos-specs.inc
+api-ref/source/v3/quota-classes.inc
+api-ref/source/v3/quota-sets.inc
+api-ref/source/v3/resource-filters.inc
+api-ref/source/v3/snapshot-manage.inc
+api-ref/source/v3/valid-boolean-values.inc
+api-ref/source/v3/vol-transfer-v3.inc
+api-ref/source/v3/volume-manage.inc
+api-ref/source/v3/volume-type-access.inc
+api-ref/source/v3/volumes-v3-extensions.inc
+api-ref/source/v3/volumes-v3-snapshots-actions.inc
+api-ref/source/v3/volumes-v3-snapshots.inc
+api-ref/source/v3/volumes-v3-types.inc
+api-ref/source/v3/volumes-v3-versions.inc
+api-ref/source/v3/volumes-v3-volumes-actions.inc
+api-ref/source/v3/volumes-v3-volumes.inc
+api-ref/source/v3/worker-cleanup.inc
+api-ref/source/v3/samples/attachment-complete.json
+api-ref/source/v3/samples/attachment-create-request.json
+api-ref/source/v3/samples/attachment-create-response.json
+api-ref/source/v3/samples/attachment-list-detailed-response.json
+api-ref/source/v3/samples/attachment-list-response.json
+api-ref/source/v3/samples/attachment-show-response.json
+api-ref/source/v3/samples/attachment-update-request.json
+api-ref/source/v3/samples/attachment-update-response.json
+api-ref/source/v3/samples/backend-capabilities-response.json
+api-ref/source/v3/samples/backup-create-request.json
+api-ref/source/v3/samples/backup-create-response.json
+api-ref/source/v3/samples/backup-force-delete-request.json
+api-ref/source/v3/samples/backup-record-export-response.json
+api-ref/source/v3/samples/backup-record-import-request.json
+api-ref/source/v3/samples/backup-record-import-response.json
+api-ref/source/v3/samples/backup-reset-status-request.json
+api-ref/source/v3/samples/backup-restore-request.json
+api-ref/source/v3/samples/backup-restore-response.json
+api-ref/source/v3/samples/backup-show-response.json
+api-ref/source/v3/samples/backup-update-request.json
+api-ref/source/v3/samples/backup-update-response.json
+api-ref/source/v3/samples/backups-list-detailed-response.json
+api-ref/source/v3/samples/backups-list-response.json
+api-ref/source/v3/samples/cgsnapshots-create-request.json
+api-ref/source/v3/samples/cgsnapshots-create-response.json
+api-ref/source/v3/samples/cgsnapshots-list-detailed-response.json
+api-ref/source/v3/samples/cgsnapshots-list-response.json
+api-ref/source/v3/samples/cgsnapshots-show-response.json
+api-ref/source/v3/samples/consistency-group-create-from-src-request.json
+api-ref/source/v3/samples/consistency-group-create-request.json
+api-ref/source/v3/samples/consistency-group-create-response.json
+api-ref/source/v3/samples/consistency-group-delete-request.json
+api-ref/source/v3/samples/consistency-group-show-response.json
+api-ref/source/v3/samples/consistency-group-update-request.json
+api-ref/source/v3/samples/consistency-groups-list-detailed-response.json
+api-ref/source/v3/samples/consistency-groups-list-response.json
+api-ref/source/v3/samples/group-create-from-src-request.json
+api-ref/source/v3/samples/group-create-from-src-response.json
+api-ref/source/v3/samples/group-create-request.json
+api-ref/source/v3/samples/group-create-response.json
+api-ref/source/v3/samples/group-delete-request.json
+api-ref/source/v3/samples/group-replication-disable.json
+api-ref/source/v3/samples/group-replication-enable.json
+api-ref/source/v3/samples/group-replication-failover.json
+api-ref/source/v3/samples/group-replication-list-targets.json
+api-ref/source/v3/samples/group-replication-target.json
+api-ref/source/v3/samples/group-reset-status-request.json
+api-ref/source/v3/samples/group-show-response.json
+api-ref/source/v3/samples/group-snapshot-reset-status-request.json
+api-ref/source/v3/samples/group-snapshots-create-request.json
+api-ref/source/v3/samples/group-snapshots-create-response.json
+api-ref/source/v3/samples/group-snapshots-list-detailed-response.json
+api-ref/source/v3/samples/group-snapshots-list-response.json
+api-ref/source/v3/samples/group-snapshots-show-response.json
+api-ref/source/v3/samples/group-type-create-request.json
+api-ref/source/v3/samples/group-type-default-response.json
+api-ref/source/v3/samples/group-type-show-response.json
+api-ref/source/v3/samples/group-type-specs-create-request.json
+api-ref/source/v3/samples/group-type-specs-create-response.json
+api-ref/source/v3/samples/group-type-specs-list-response.json
+api-ref/source/v3/samples/group-type-specs-show-response.json
+api-ref/source/v3/samples/group-type-specs-update-request.json
+api-ref/source/v3/samples/group-type-specs-update-response.json
+api-ref/source/v3/samples/group-type-update-request.json
+api-ref/source/v3/samples/group-types-list-response.json
+api-ref/source/v3/samples/group-update-request.json
+api-ref/source/v3/samples/groups-list-detailed-response.json
+api-ref/source/v3/samples/groups-list-response.json
+api-ref/source/v3/samples/host-attach-request.json
+api-ref/source/v3/samples/hosts-get-response.json
+api-ref/source/v3/samples/hosts-list-response.json
+api-ref/source/v3/samples/image-metadata-show-request.json
+api-ref/source/v3/samples/image-metadata-show-response.json
+api-ref/source/v3/samples/messages-list-response.json
+api-ref/source/v3/samples/messages-show-response.json
+api-ref/source/v3/samples/pools-list-detailed-response.json
+api-ref/source/v3/samples/quota-classes-show-response.json
+api-ref/source/v3/samples/quota-classes-update-request.json
+api-ref/source/v3/samples/quota-classes-update-response.json
+api-ref/source/v3/samples/resource-filters-list-response.json
+api-ref/source/v3/samples/services-disable-log-request.json
+api-ref/source/v3/samples/services-disable-log-response.json
+api-ref/source/v3/samples/services-disable-request.json
+api-ref/source/v3/samples/services-disable-response.json
+api-ref/source/v3/samples/services-enable-request.json
+api-ref/source/v3/samples/services-enable-response.json
+api-ref/source/v3/samples/services-failover-host-request.json
+api-ref/source/v3/samples/services-freeze-request.json
+api-ref/source/v3/samples/services-get-log-request.json
+api-ref/source/v3/samples/services-get-log-response.json
+api-ref/source/v3/samples/services-list-response.json
+api-ref/source/v3/samples/services-set-log-request.json
+api-ref/source/v3/samples/services-thaw-request.json
+api-ref/source/v3/samples/snapshot-force-delete-request.json
+api-ref/source/v3/samples/snapshot-manage-list-detail-response.json
+api-ref/source/v3/samples/snapshot-manage-list-response.json
+api-ref/source/v3/samples/snapshot-status-reset-request.json
+api-ref/source/v3/samples/snapshot-status-update-request.json
+api-ref/source/v3/samples/user-quotas-show-response.json
+api-ref/source/v3/samples/user-quotas-update-request.json
+api-ref/source/v3/samples/user-quotas-update-response.json
+api-ref/source/v3/samples/volume-attach-request.json
+api-ref/source/v3/samples/volume-begin-detaching-request.json
+api-ref/source/v3/samples/volume-bootable-status-update-request.json
+api-ref/source/v3/samples/volume-detach-request.json
+api-ref/source/v3/samples/volume-extend-request.json
+api-ref/source/v3/samples/volume-force-delete-request.json
+api-ref/source/v3/samples/volume-force-detach-request.json
+api-ref/source/v3/samples/volume-image-metadata-set-request.json
+api-ref/source/v3/samples/volume-image-metadata-unset-request.json
+api-ref/source/v3/samples/volume-image-metadata-update-response.json
+api-ref/source/v3/samples/volume-initialize-connection-request.json
+api-ref/source/v3/samples/volume-manage-list-detail-response.json
+api-ref/source/v3/samples/volume-manage-list-response.json
+api-ref/source/v3/samples/volume-manage-request-cluster.json
+api-ref/source/v3/samples/volume-os-migrate_volume-request.json
+api-ref/source/v3/samples/volume-os-migrate_volume_completion-request.json
+api-ref/source/v3/samples/volume-os-retype-request.json
+api-ref/source/v3/samples/volume-readonly-update-request.json
+api-ref/source/v3/samples/volume-reserve-request.json
+api-ref/source/v3/samples/volume-revert-to-snapshot-request.json
+api-ref/source/v3/samples/volume-roll-detaching-request.json
+api-ref/source/v3/samples/volume-status-reset-request.json
+api-ref/source/v3/samples/volume-terminate-connection-request.json
+api-ref/source/v3/samples/volume-type-access-delete-request.json
+api-ref/source/v3/samples/volume-unmanage-request.json
+api-ref/source/v3/samples/volume-unreserve-request.json
+api-ref/source/v3/samples/worker-cleanup-request.json
+api-ref/source/v3/samples/worker-cleanup-response.json
+api-ref/source/v3/samples/extensions/extensions-list-response.json
+api-ref/source/v3/samples/limits/limits-show-response.json
+api-ref/source/v3/samples/qos/qos-create-request.json
+api-ref/source/v3/samples/qos/qos-create-response.json
+api-ref/source/v3/samples/qos/qos-list-response.json
+api-ref/source/v3/samples/qos/qos-show-response.json
+api-ref/source/v3/samples/qos/qos-unset-request.json
+api-ref/source/v3/samples/qos/qos-update-request.json
+api-ref/source/v3/samples/qos/qos-update-response.json
+api-ref/source/v3/samples/qos/qos_show_response.json
+api-ref/source/v3/samples/quota_classes/quota-classes-show-response.json
+api-ref/source/v3/samples/quota_classes/quota-classes-update-request.json
+api-ref/source/v3/samples/quota_classes/quota-classes-update-response.json
+api-ref/source/v3/samples/quota_sets/quotas-show-defaults-response.json
+api-ref/source/v3/samples/quota_sets/quotas-show-response.json
+api-ref/source/v3/samples/quota_sets/quotas-show-usage-response.json
+api-ref/source/v3/samples/quota_sets/quotas-update-request.json
+api-ref/source/v3/samples/quota_sets/quotas-update-response.json
+api-ref/source/v3/samples/snapshot_manage_extensions/snapshot-manage-request.json
+api-ref/source/v3/samples/snapshot_manage_extensions/snapshot-manage-response.json
+api-ref/source/v3/samples/snapshots/snapshot-create-request.json
+api-ref/source/v3/samples/snapshots/snapshot-create-response.json
+api-ref/source/v3/samples/snapshots/snapshot-metadata-create-request.json
+api-ref/source/v3/samples/snapshots/snapshot-metadata-create-response.json
+api-ref/source/v3/samples/snapshots/snapshot-metadata-show-key-response.json
+api-ref/source/v3/samples/snapshots/snapshot-metadata-show-response.json
+api-ref/source/v3/samples/snapshots/snapshot-metadata-update-key-request.json
+api-ref/source/v3/samples/snapshots/snapshot-metadata-update-key-response.json
+api-ref/source/v3/samples/snapshots/snapshot-metadata-update-request.json
+api-ref/source/v3/samples/snapshots/snapshot-metadata-update-response.json
+api-ref/source/v3/samples/snapshots/snapshot-show-response.json
+api-ref/source/v3/samples/snapshots/snapshot-update-request.json
+api-ref/source/v3/samples/snapshots/snapshot-update-response.json
+api-ref/source/v3/samples/snapshots/snapshots-list-detailed-response.json
+api-ref/source/v3/samples/snapshots/snapshots-list-response.json
+api-ref/source/v3/samples/versions/version-show-response.json
+api-ref/source/v3/samples/versions/versions-response.json
+api-ref/source/v3/samples/volume_actions/volume-upload-to-image-request.json
+api-ref/source/v3/samples/volume_actions/volume-upload-to-image-response.json
+api-ref/source/v3/samples/volume_manage_extensions/volume-manage-request.json
+api-ref/source/v3/samples/volume_manage_extensions/volume-manage-response.json
+api-ref/source/v3/samples/volume_transfer/volume-transfer-accept-request.json
+api-ref/source/v3/samples/volume_transfer/volume-transfer-accept-response.json
+api-ref/source/v3/samples/volume_transfer/volume-transfer-create-request.json
+api-ref/source/v3/samples/volume_transfer/volume-transfer-create-response.json
+api-ref/source/v3/samples/volume_transfer/volume-transfer-show-response.json
+api-ref/source/v3/samples/volume_transfer/volume-transfers-list-detailed-response.json
+api-ref/source/v3/samples/volume_transfer/volume-transfers-list-response.json
+api-ref/source/v3/samples/volume_type/encryption-type-create-request.json
+api-ref/source/v3/samples/volume_type/encryption-type-create-response.json
+api-ref/source/v3/samples/volume_type/encryption-type-show-response.json
+api-ref/source/v3/samples/volume_type/encryption-type-specific-specs-show-response.json
+api-ref/source/v3/samples/volume_type/encryption-type-update-request.json
+api-ref/source/v3/samples/volume_type/encryption-type-update-response.json
+api-ref/source/v3/samples/volume_type/volume-type-access-add-request.json
+api-ref/source/v3/samples/volume_type/volume-type-access-list-response.json
+api-ref/source/v3/samples/volume_type/volume-type-all-extra-specs-show-response.json
+api-ref/source/v3/samples/volume_type/volume-type-create-request.json
+api-ref/source/v3/samples/volume_type/volume-type-create-response.json
+api-ref/source/v3/samples/volume_type/volume-type-default-response.json
+api-ref/source/v3/samples/volume_type/volume-type-extra-specs-create-update-request.json
+api-ref/source/v3/samples/volume_type/volume-type-extra-specs-create-update-response.json
+api-ref/source/v3/samples/volume_type/volume-type-show-response.json
+api-ref/source/v3/samples/volume_type/volume-type-specific-extra-specs-show-response.json
+api-ref/source/v3/samples/volume_type/volume-type-specific-extra-specs-update-request.json
+api-ref/source/v3/samples/volume_type/volume-type-specific-extra-specs-update-response.json
+api-ref/source/v3/samples/volume_type/volume-type-update-request.json
+api-ref/source/v3/samples/volume_type/volume-type-update-response.json
+api-ref/source/v3/samples/volume_type/volume-types-list-response.json
+api-ref/source/v3/samples/volumes/volume-create-request.json
+api-ref/source/v3/samples/volumes/volume-create-response.json
+api-ref/source/v3/samples/volumes/volume-metadata-create-request.json
+api-ref/source/v3/samples/volumes/volume-metadata-create-response.json
+api-ref/source/v3/samples/volumes/volume-metadata-show-key-response.json
+api-ref/source/v3/samples/volumes/volume-metadata-show-response.json
+api-ref/source/v3/samples/volumes/volume-metadata-update-key-request.json
+api-ref/source/v3/samples/volumes/volume-metadata-update-key-response.json
+api-ref/source/v3/samples/volumes/volume-metadata-update-request.json
+api-ref/source/v3/samples/volumes/volume-metadata-update-response.json
+api-ref/source/v3/samples/volumes/volume-show-response.json
+api-ref/source/v3/samples/volumes/volume-update-request.json
+api-ref/source/v3/samples/volumes/volume-update-response.json
+api-ref/source/v3/samples/volumes/volumes-list-detailed-response.json
+api-ref/source/v3/samples/volumes/volumes-list-response.json
+api-ref/source/v3/samples/volumes/volumes-list-summary-response.json
+cinder/__init__.py
+cinder/context.py
+cinder/coordination.py
+cinder/exception.py
+cinder/flow_utils.py
+cinder/i18n.py
+cinder/manager.py
+cinder/opts.py
+cinder/policy.py
+cinder/quota.py
+cinder/quota_utils.py
+cinder/rpc.py
+cinder/service.py
+cinder/service_auth.py
+cinder/ssh_utils.py
+cinder/test.py
+cinder/utils.py
+cinder/version.py
+cinder.egg-info/PKG-INFO
+cinder.egg-info/SOURCES.txt
+cinder.egg-info/dependency_links.txt
+cinder.egg-info/entry_points.txt
+cinder.egg-info/not-zip-safe
+cinder.egg-info/pbr.json
+cinder.egg-info/requires.txt
+cinder.egg-info/top_level.txt
+cinder/api/__init__.py
+cinder/api/api_utils.py
+cinder/api/common.py
+cinder/api/extensions.py
+cinder/api/microversions.py
+cinder/api/urlmap.py
+cinder/api/versions.py
+cinder/api/contrib/__init__.py
+cinder/api/contrib/admin_actions.py
+cinder/api/contrib/availability_zones.py
+cinder/api/contrib/backups.py
+cinder/api/contrib/capabilities.py
+cinder/api/contrib/cgsnapshots.py
+cinder/api/contrib/consistencygroups.py
+cinder/api/contrib/extended_services.py
+cinder/api/contrib/extended_snapshot_attributes.py
+cinder/api/contrib/hosts.py
+cinder/api/contrib/qos_specs_manage.py
+cinder/api/contrib/quota_classes.py
+cinder/api/contrib/quotas.py
+cinder/api/contrib/resource_common_manage.py
+cinder/api/contrib/scheduler_hints.py
+cinder/api/contrib/scheduler_stats.py
+cinder/api/contrib/services.py
+cinder/api/contrib/snapshot_actions.py
+cinder/api/contrib/snapshot_manage.py
+cinder/api/contrib/snapshot_unmanage.py
+cinder/api/contrib/types_extra_specs.py
+cinder/api/contrib/types_manage.py
+cinder/api/contrib/used_limits.py
+cinder/api/contrib/volume_actions.py
+cinder/api/contrib/volume_encryption_metadata.py
+cinder/api/contrib/volume_host_attribute.py
+cinder/api/contrib/volume_image_metadata.py
+cinder/api/contrib/volume_manage.py
+cinder/api/contrib/volume_mig_status_attribute.py
+cinder/api/contrib/volume_tenant_attribute.py
+cinder/api/contrib/volume_transfer.py
+cinder/api/contrib/volume_type_access.py
+cinder/api/contrib/volume_type_encryption.py
+cinder/api/contrib/volume_unmanage.py
+cinder/api/middleware/__init__.py
+cinder/api/middleware/auth.py
+cinder/api/middleware/fault.py
+cinder/api/openstack/__init__.py
+cinder/api/openstack/api_version_request.py
+cinder/api/openstack/rest_api_version_history.rst
+cinder/api/openstack/versioned_method.py
+cinder/api/openstack/wsgi.py
+cinder/api/schemas/__init__.py
+cinder/api/schemas/admin_actions.py
+cinder/api/schemas/attachments.py
+cinder/api/schemas/backups.py
+cinder/api/schemas/clusters.py
+cinder/api/schemas/group_snapshots.py
+cinder/api/schemas/group_specs.py
+cinder/api/schemas/group_types.py
+cinder/api/schemas/groups.py
+cinder/api/schemas/qos_specs.py
+cinder/api/schemas/quota_classes.py
+cinder/api/schemas/quotas.py
+cinder/api/schemas/scheduler_hints.py
+cinder/api/schemas/services.py
+cinder/api/schemas/snapshot_actions.py
+cinder/api/schemas/snapshot_manage.py
+cinder/api/schemas/snapshots.py
+cinder/api/schemas/types_extra_specs.py
+cinder/api/schemas/volume_actions.py
+cinder/api/schemas/volume_image_metadata.py
+cinder/api/schemas/volume_manage.py
+cinder/api/schemas/volume_metadata.py
+cinder/api/schemas/volume_transfer.py
+cinder/api/schemas/volume_type_access.py
+cinder/api/schemas/volume_type_encryption.py
+cinder/api/schemas/volume_types.py
+cinder/api/schemas/volumes.py
+cinder/api/schemas/workers.py
+cinder/api/v2/__init__.py
+cinder/api/v2/limits.py
+cinder/api/v2/router.py
+cinder/api/v2/snapshot_metadata.py
+cinder/api/v2/snapshots.py
+cinder/api/v2/types.py
+cinder/api/v2/volume_metadata.py
+cinder/api/v2/volumes.py
+cinder/api/v2/views/__init__.py
+cinder/api/v2/views/types.py
+cinder/api/v2/views/volumes.py
+cinder/api/v3/__init__.py
+cinder/api/v3/attachments.py
+cinder/api/v3/backups.py
+cinder/api/v3/clusters.py
+cinder/api/v3/consistencygroups.py
+cinder/api/v3/group_snapshots.py
+cinder/api/v3/group_specs.py
+cinder/api/v3/group_types.py
+cinder/api/v3/groups.py
+cinder/api/v3/limits.py
+cinder/api/v3/messages.py
+cinder/api/v3/resource_common_manage.py
+cinder/api/v3/resource_filters.py
+cinder/api/v3/router.py
+cinder/api/v3/snapshot_manage.py
+cinder/api/v3/snapshots.py
+cinder/api/v3/volume_manage.py
+cinder/api/v3/volume_metadata.py
+cinder/api/v3/volume_transfer.py
+cinder/api/v3/volumes.py
+cinder/api/v3/workers.py
+cinder/api/v3/views/__init__.py
+cinder/api/v3/views/attachments.py
+cinder/api/v3/views/backups.py
+cinder/api/v3/views/clusters.py
+cinder/api/v3/views/group_snapshots.py
+cinder/api/v3/views/group_types.py
+cinder/api/v3/views/groups.py
+cinder/api/v3/views/messages.py
+cinder/api/v3/views/resource_filters.py
+cinder/api/v3/views/snapshots.py
+cinder/api/v3/views/volumes.py
+cinder/api/v3/views/workers.py
+cinder/api/validation/__init__.py
+cinder/api/validation/parameter_types.py
+cinder/api/validation/validators.py
+cinder/api/views/__init__.py
+cinder/api/views/availability_zones.py
+cinder/api/views/backups.py
+cinder/api/views/capabilities.py
+cinder/api/views/cgsnapshots.py
+cinder/api/views/consistencygroups.py
+cinder/api/views/limits.py
+cinder/api/views/manageable_snapshots.py
+cinder/api/views/manageable_volumes.py
+cinder/api/views/qos_specs.py
+cinder/api/views/scheduler_stats.py
+cinder/api/views/snapshots.py
+cinder/api/views/transfers.py
+cinder/api/views/types.py
+cinder/api/views/versions.py
+cinder/backup/__init__.py
+cinder/backup/api.py
+cinder/backup/chunkeddriver.py
+cinder/backup/driver.py
+cinder/backup/manager.py
+cinder/backup/rpcapi.py
+cinder/backup/drivers/__init__.py
+cinder/backup/drivers/ceph.py
+cinder/backup/drivers/gcs.py
+cinder/backup/drivers/glusterfs.py
+cinder/backup/drivers/nfs.py
+cinder/backup/drivers/posix.py
+cinder/backup/drivers/swift.py
+cinder/backup/drivers/tsm.py
+cinder/brick/README.txt
+cinder/brick/__init__.py
+cinder/brick/local_dev/__init__.py
+cinder/brick/local_dev/lvm.py
+cinder/cmd/__init__.py
+cinder/cmd/api.py
+cinder/cmd/backup.py
+cinder/cmd/manage.py
+cinder/cmd/rtstool.py
+cinder/cmd/scheduler.py
+cinder/cmd/status.py
+cinder/cmd/volume.py
+cinder/cmd/volume_usage_audit.py
+cinder/common/__init__.py
+cinder/common/config.py
+cinder/common/constants.py
+cinder/common/sqlalchemyutils.py
+cinder/compute/__init__.py
+cinder/compute/nova.py
+cinder/db/__init__.py
+cinder/db/api.py
+cinder/db/base.py
+cinder/db/migration.py
+cinder/db/sqlalchemy/__init__.py
+cinder/db/sqlalchemy/api.py
+cinder/db/sqlalchemy/models.py
+cinder/db/sqlalchemy/migrate_repo/README
+cinder/db/sqlalchemy/migrate_repo/__init__.py
+cinder/db/sqlalchemy/migrate_repo/manage.py
+cinder/db/sqlalchemy/migrate_repo/migrate.cfg
+cinder/db/sqlalchemy/migrate_repo/versions/123_cinder_init.py
+cinder/db/sqlalchemy/migrate_repo/versions/124_placeholder.py
+cinder/db/sqlalchemy/migrate_repo/versions/125_placeholder.py
+cinder/db/sqlalchemy/migrate_repo/versions/126_placeholder.py
+cinder/db/sqlalchemy/migrate_repo/versions/127_change_project_resource_attribute_for_quota_usages.py
+cinder/db/sqlalchemy/migrate_repo/versions/128_add_project_id_and_accepted_to_transfer.py
+cinder/db/sqlalchemy/migrate_repo/versions/129_placeholder.py
+cinder/db/sqlalchemy/migrate_repo/versions/130_placeholder.py
+cinder/db/sqlalchemy/migrate_repo/versions/131_placeholder.py
+cinder/db/sqlalchemy/migrate_repo/versions/132_create_default_volume_type.py
+cinder/db/sqlalchemy/migrate_repo/versions/133_placeholder.py
+cinder/db/sqlalchemy/migrate_repo/versions/134_placeholder.py
+cinder/db/sqlalchemy/migrate_repo/versions/135_placeholder.py
+cinder/db/sqlalchemy/migrate_repo/versions/136_make_vol_type_col_non_nullable.py
+cinder/db/sqlalchemy/migrate_repo/versions/__init__.py
+cinder/group/__init__.py
+cinder/group/api.py
+cinder/image/__init__.py
+cinder/image/accelerator.py
+cinder/image/cache.py
+cinder/image/glance.py
+cinder/image/image_utils.py
+cinder/image/accelerators/__init__.py
+cinder/image/accelerators/gzip.py
+cinder/image/accelerators/qat.py
+cinder/interface/__init__.py
+cinder/interface/backup_chunked_driver.py
+cinder/interface/backup_driver.py
+cinder/interface/base.py
+cinder/interface/fczm_driver.py
+cinder/interface/util.py
+cinder/interface/volume_consistencygroup_driver.py
+cinder/interface/volume_driver.py
+cinder/interface/volume_group_driver.py
+cinder/interface/volume_manageable_driver.py
+cinder/interface/volume_snapshot_revert.py
+cinder/interface/volume_snapshotmanagement_driver.py
+cinder/keymgr/__init__.py
+cinder/keymgr/conf_key_mgr.py
+cinder/keymgr/migration.py
+cinder/locale/de/LC_MESSAGES/cinder.po
+cinder/locale/es/LC_MESSAGES/cinder.po
+cinder/locale/fr/LC_MESSAGES/cinder.po
+cinder/locale/it/LC_MESSAGES/cinder.po
+cinder/locale/ja/LC_MESSAGES/cinder.po
+cinder/locale/ko_KR/LC_MESSAGES/cinder.po
+cinder/locale/pt_BR/LC_MESSAGES/cinder.po
+cinder/locale/ru/LC_MESSAGES/cinder.po
+cinder/locale/zh_CN/LC_MESSAGES/cinder.po
+cinder/locale/zh_TW/LC_MESSAGES/cinder.po
+cinder/message/__init__.py
+cinder/message/api.py
+cinder/message/defined_messages.py
+cinder/message/message_field.py
+cinder/objects/__init__.py
+cinder/objects/backup.py
+cinder/objects/base.py
+cinder/objects/cgsnapshot.py
+cinder/objects/cleanable.py
+cinder/objects/cleanup_request.py
+cinder/objects/cluster.py
+cinder/objects/consistencygroup.py
+cinder/objects/dynamic_log.py
+cinder/objects/fields.py
+cinder/objects/group.py
+cinder/objects/group_snapshot.py
+cinder/objects/group_type.py
+cinder/objects/manageableresources.py
+cinder/objects/qos_specs.py
+cinder/objects/request_spec.py
+cinder/objects/service.py
+cinder/objects/snapshot.py
+cinder/objects/volume.py
+cinder/objects/volume_attachment.py
+cinder/objects/volume_type.py
+cinder/policies/__init__.py
+cinder/policies/attachments.py
+cinder/policies/backup_actions.py
+cinder/policies/backups.py
+cinder/policies/base.py
+cinder/policies/capabilities.py
+cinder/policies/clusters.py
+cinder/policies/group_actions.py
+cinder/policies/group_snapshot_actions.py
+cinder/policies/group_snapshots.py
+cinder/policies/group_types.py
+cinder/policies/groups.py
+cinder/policies/hosts.py
+cinder/policies/limits.py
+cinder/policies/manageable_snapshots.py
+cinder/policies/manageable_volumes.py
+cinder/policies/messages.py
+cinder/policies/qos_specs.py
+cinder/policies/quota_class.py
+cinder/policies/quotas.py
+cinder/policies/scheduler_stats.py
+cinder/policies/services.py
+cinder/policies/snapshot_actions.py
+cinder/policies/snapshot_metadata.py
+cinder/policies/snapshots.py
+cinder/policies/type_extra_specs.py
+cinder/policies/volume_access.py
+cinder/policies/volume_actions.py
+cinder/policies/volume_metadata.py
+cinder/policies/volume_transfer.py
+cinder/policies/volume_type.py
+cinder/policies/volumes.py
+cinder/policies/workers.py
+cinder/privsep/__init__.py
+cinder/privsep/cgroup.py
+cinder/privsep/fs.py
+cinder/privsep/hscli.py
+cinder/privsep/lvm.py
+cinder/privsep/nvmcli.py
+cinder/privsep/path.py
+cinder/privsep/targets/__init__.py
+cinder/privsep/targets/iet.py
+cinder/privsep/targets/scst.py
+cinder/privsep/targets/tgt.py
+cinder/scheduler/__init__.py
+cinder/scheduler/base_filter.py
+cinder/scheduler/base_handler.py
+cinder/scheduler/base_weight.py
+cinder/scheduler/driver.py
+cinder/scheduler/filter_scheduler.py
+cinder/scheduler/host_manager.py
+cinder/scheduler/manager.py
+cinder/scheduler/rpcapi.py
+cinder/scheduler/scheduler_options.py
+cinder/scheduler/evaluator/__init__.py
+cinder/scheduler/evaluator/evaluator.py
+cinder/scheduler/filters/__init__.py
+cinder/scheduler/filters/affinity_filter.py
+cinder/scheduler/filters/availability_zone_filter.py
+cinder/scheduler/filters/capabilities_filter.py
+cinder/scheduler/filters/capacity_filter.py
+cinder/scheduler/filters/driver_filter.py
+cinder/scheduler/filters/extra_specs_ops.py
+cinder/scheduler/filters/ignore_attempted_hosts_filter.py
+cinder/scheduler/filters/instance_locality_filter.py
+cinder/scheduler/filters/json_filter.py
+cinder/scheduler/flows/__init__.py
+cinder/scheduler/flows/create_volume.py
+cinder/scheduler/weights/__init__.py
+cinder/scheduler/weights/capacity.py
+cinder/scheduler/weights/chance.py
+cinder/scheduler/weights/goodness.py
+cinder/scheduler/weights/stochastic.py
+cinder/scheduler/weights/volume_number.py
+cinder/tests/README.rst
+cinder/tests/__init__.py
+cinder/tests/fake_driver.py
+cinder/tests/fixtures.py
+cinder/tests/compliance/__init__.py
+cinder/tests/compliance/test_backup_drivers.py
+cinder/tests/compliance/test_fczm_drivers.py
+cinder/tests/compliance/test_volume_drivers.py
+cinder/tests/functional/__init__.py
+cinder/tests/functional/api_samples_test_base.py
+cinder/tests/functional/functional_helpers.py
+cinder/tests/functional/test_extensions.py
+cinder/tests/functional/test_group_replication.py
+cinder/tests/functional/test_group_snapshots.py
+cinder/tests/functional/test_groups.py
+cinder/tests/functional/test_login.py
+cinder/tests/functional/test_quotas.py
+cinder/tests/functional/test_volumes.py
+cinder/tests/functional/api/__init__.py
+cinder/tests/functional/api/client.py
+cinder/tests/functional/api/foxinsocks.py
+cinder/tests/functional/api_sample_tests/__init__.py
+cinder/tests/functional/api_sample_tests/fakes.py
+cinder/tests/functional/api_sample_tests/test_extensions.py
+cinder/tests/functional/api_sample_tests/test_limits.py
+cinder/tests/functional/api_sample_tests/test_qos.py
+cinder/tests/functional/api_sample_tests/test_quota_classes.py
+cinder/tests/functional/api_sample_tests/test_quota_sets.py
+cinder/tests/functional/api_sample_tests/test_snapshot_manage_extensions.py
+cinder/tests/functional/api_sample_tests/test_snapshots.py
+cinder/tests/functional/api_sample_tests/test_versions.py
+cinder/tests/functional/api_sample_tests/test_volume_actions.py
+cinder/tests/functional/api_sample_tests/test_volume_manage_extensions.py
+cinder/tests/functional/api_sample_tests/test_volume_transfer.py
+cinder/tests/functional/api_sample_tests/test_volume_types.py
+cinder/tests/functional/api_sample_tests/test_volumes.py
+cinder/tests/functional/api_sample_tests/samples/extensions/extensions-list-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/limits/limits-show-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/qos/qos-create-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/qos/qos-create-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/qos/qos-list-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/qos/qos-show-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/qos/qos-update-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/qos/qos-update-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/qos/qos_show_response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/quota_classes/quota-classes-show-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/quota_classes/quota-classes-update-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/quota_classes/quota-classes-update-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-show-defaults-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-show-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-show-usage-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-update-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/quota_sets/quotas-update-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/snapshot_manage_extensions/snapshot-manage-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/snapshot_manage_extensions/snapshot-manage-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/snapshots/snapshot-create-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/snapshots/snapshot-create-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/snapshots/snapshot-metadata-create-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/snapshots/snapshot-metadata-create-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/snapshots/snapshot-metadata-show-key-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/snapshots/snapshot-metadata-show-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/snapshots/snapshot-metadata-update-key-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/snapshots/snapshot-metadata-update-key-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/snapshots/snapshot-metadata-update-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/snapshots/snapshot-metadata-update-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/snapshots/snapshot-show-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/snapshots/snapshot-update-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/snapshots/snapshot-update-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/snapshots/snapshots-list-detailed-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/snapshots/snapshots-list-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/versions/version-show-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/versions/versions-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_actions/volume-upload-to-image-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_actions/volume-upload-to-image-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_manage_extensions/volume-manage-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_manage_extensions/volume-manage-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_transfer/volume-transfer-accept-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_transfer/volume-transfer-accept-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_transfer/volume-transfer-create-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_transfer/volume-transfer-create-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_transfer/volume-transfer-show-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_transfer/volume-transfers-list-detailed-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_transfer/volume-transfers-list-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/encryption-type-create-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/encryption-type-create-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/encryption-type-show-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/encryption-type-specific-specs-show-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/encryption-type-update-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/encryption-type-update-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/volume-type-access-add-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/volume-type-access-list-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/volume-type-all-extra-specs-show-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/volume-type-create-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/volume-type-create-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/volume-type-default-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/volume-type-extra-specs-create-update-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/volume-type-extra-specs-create-update-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/volume-type-show-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/volume-type-specific-extra-specs-show-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/volume-type-update-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/volume-type-update-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volume_type/volume-types-list-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volumes/volume-create-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volumes/volume-create-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volumes/volume-metadata-create-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volumes/volume-metadata-create-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volumes/volume-metadata-show-key-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volumes/volume-metadata-show-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volumes/volume-metadata-update-key-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volumes/volume-metadata-update-key-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volumes/volume-metadata-update-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volumes/volume-metadata-update-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volumes/volume-show-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volumes/volume-update-request.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volumes/volume-update-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volumes/volumes-list-detailed-response.json.tpl
+cinder/tests/functional/api_sample_tests/samples/volumes/volumes-list-response.json.tpl
+cinder/tests/hacking/__init__.py
+cinder/tests/hacking/checks.py
+cinder/tests/unit/__init__.py
+cinder/tests/unit/cast_as_call.py
+cinder/tests/unit/conf_fixture.py
+cinder/tests/unit/fake_cluster.py
+cinder/tests/unit/fake_constants.py
+cinder/tests/unit/fake_group.py
+cinder/tests/unit/fake_group_snapshot.py
+cinder/tests/unit/fake_notifier.py
+cinder/tests/unit/fake_objects.py
+cinder/tests/unit/fake_service.py
+cinder/tests/unit/fake_snapshot.py
+cinder/tests/unit/fake_utils.py
+cinder/tests/unit/fake_volume.py
+cinder/tests/unit/policy.json
+cinder/tests/unit/test_api.py
+cinder/tests/unit/test_api_urlmap.py
+cinder/tests/unit/test_cleanable_manager.py
+cinder/tests/unit/test_cmd.py
+cinder/tests/unit/test_context.py
+cinder/tests/unit/test_coordination.py
+cinder/tests/unit/test_db_api.py
+cinder/tests/unit/test_db_worker_api.py
+cinder/tests/unit/test_evaluator.py
+cinder/tests/unit/test_exception.py
+cinder/tests/unit/test_fixtures.py
+cinder/tests/unit/test_hacking.py
+cinder/tests/unit/test_image_utils.py
+cinder/tests/unit/test_interface.py
+cinder/tests/unit/test_macrosan_drivers.py
+cinder/tests/unit/test_manager.py
+cinder/tests/unit/test_paginate_query.py
+cinder/tests/unit/test_policy.py
+cinder/tests/unit/test_qos_specs.py
+cinder/tests/unit/test_quota.py
+cinder/tests/unit/test_quota_utils.py
+cinder/tests/unit/test_rpc.py
+cinder/tests/unit/test_service.py
+cinder/tests/unit/test_service_auth.py
+cinder/tests/unit/test_setup_profiler.py
+cinder/tests/unit/test_ssh_utils.py
+cinder/tests/unit/test_test.py
+cinder/tests/unit/test_test_utils.py
+cinder/tests/unit/test_utils.py
+cinder/tests/unit/test_volume_cleanup.py
+cinder/tests/unit/test_volume_configuration.py
+cinder/tests/unit/test_volume_glance_metadata.py
+cinder/tests/unit/test_volume_throttling.py
+cinder/tests/unit/test_volume_transfer.py
+cinder/tests/unit/test_volume_types.py
+cinder/tests/unit/test_volume_types_extra_specs.py
+cinder/tests/unit/test_volume_utils.py
+cinder/tests/unit/utils.py
+cinder/tests/unit/api/__init__.py
+cinder/tests/unit/api/fakes.py
+cinder/tests/unit/api/test_api_validation.py
+cinder/tests/unit/api/test_common.py
+cinder/tests/unit/api/test_versions.py
+cinder/tests/unit/api/contrib/__init__.py
+cinder/tests/unit/api/contrib/test_admin_actions.py
+cinder/tests/unit/api/contrib/test_availability_zones.py
+cinder/tests/unit/api/contrib/test_backup_project_attribute.py
+cinder/tests/unit/api/contrib/test_backups.py
+cinder/tests/unit/api/contrib/test_capabilities.py
+cinder/tests/unit/api/contrib/test_cgsnapshots.py
+cinder/tests/unit/api/contrib/test_consistencygroups.py
+cinder/tests/unit/api/contrib/test_extended_snapshot_attributes.py
+cinder/tests/unit/api/contrib/test_hosts.py
+cinder/tests/unit/api/contrib/test_qos_specs_manage.py
+cinder/tests/unit/api/contrib/test_quotas.py
+cinder/tests/unit/api/contrib/test_quotas_classes.py
+cinder/tests/unit/api/contrib/test_scheduler_hints.py
+cinder/tests/unit/api/contrib/test_scheduler_stats.py
+cinder/tests/unit/api/contrib/test_services.py
+cinder/tests/unit/api/contrib/test_snapshot_actions.py
+cinder/tests/unit/api/contrib/test_snapshot_manage.py
+cinder/tests/unit/api/contrib/test_snapshot_unmanage.py
+cinder/tests/unit/api/contrib/test_types_extra_specs.py
+cinder/tests/unit/api/contrib/test_types_manage.py
+cinder/tests/unit/api/contrib/test_used_limits.py
+cinder/tests/unit/api/contrib/test_volume_actions.py
+cinder/tests/unit/api/contrib/test_volume_encryption_metadata.py
+cinder/tests/unit/api/contrib/test_volume_host_attribute.py
+cinder/tests/unit/api/contrib/test_volume_image_metadata.py
+cinder/tests/unit/api/contrib/test_volume_manage.py
+cinder/tests/unit/api/contrib/test_volume_migration_status_attribute.py
+cinder/tests/unit/api/contrib/test_volume_tenant_attribute.py
+cinder/tests/unit/api/contrib/test_volume_transfer.py
+cinder/tests/unit/api/contrib/test_volume_type_access.py
+cinder/tests/unit/api/contrib/test_volume_type_encryption.py
+cinder/tests/unit/api/contrib/test_volume_unmanage.py
+cinder/tests/unit/api/middleware/__init__.py
+cinder/tests/unit/api/middleware/test_auth.py
+cinder/tests/unit/api/middleware/test_faults.py
+cinder/tests/unit/api/openstack/__init__.py
+cinder/tests/unit/api/openstack/test_api_version_request.py
+cinder/tests/unit/api/openstack/test_versioned_method.py
+cinder/tests/unit/api/openstack/test_wsgi.py
+cinder/tests/unit/api/v2/__init__.py
+cinder/tests/unit/api/v2/fakes.py
+cinder/tests/unit/api/v2/test_limits.py
+cinder/tests/unit/api/v2/test_snapshot_metadata.py
+cinder/tests/unit/api/v2/test_snapshots.py
+cinder/tests/unit/api/v2/test_types.py
+cinder/tests/unit/api/v2/test_volume_metadata.py
+cinder/tests/unit/api/v2/test_volumes.py
+cinder/tests/unit/api/v3/__init__.py
+cinder/tests/unit/api/v3/fakes.py
+cinder/tests/unit/api/v3/stubs.py
+cinder/tests/unit/api/v3/test_attachments.py
+cinder/tests/unit/api/v3/test_backups.py
+cinder/tests/unit/api/v3/test_cluster.py
+cinder/tests/unit/api/v3/test_consistencygroups.py
+cinder/tests/unit/api/v3/test_group_snapshots.py
+cinder/tests/unit/api/v3/test_group_specs.py
+cinder/tests/unit/api/v3/test_group_types.py
+cinder/tests/unit/api/v3/test_groups.py
+cinder/tests/unit/api/v3/test_limits.py
+cinder/tests/unit/api/v3/test_messages.py
+cinder/tests/unit/api/v3/test_resource_filters.py
+cinder/tests/unit/api/v3/test_snapshot_manage.py
+cinder/tests/unit/api/v3/test_snapshots.py
+cinder/tests/unit/api/v3/test_types.py
+cinder/tests/unit/api/v3/test_volume_manage.py
+cinder/tests/unit/api/v3/test_volume_metadata.py
+cinder/tests/unit/api/v3/test_volume_transfer.py
+cinder/tests/unit/api/v3/test_volumes.py
+cinder/tests/unit/api/v3/test_workers.py
+cinder/tests/unit/api/views/__init__.py
+cinder/tests/unit/api/views/test_versions.py
+cinder/tests/unit/attachments/__init__.py
+cinder/tests/unit/attachments/test_attachments_api.py
+cinder/tests/unit/attachments/test_attachments_manager.py
+cinder/tests/unit/backup/__init__.py
+cinder/tests/unit/backup/fake_backup.py
+cinder/tests/unit/backup/fake_google_client.py
+cinder/tests/unit/backup/fake_google_client2.py
+cinder/tests/unit/backup/fake_service.py
+cinder/tests/unit/backup/fake_swift_client.py
+cinder/tests/unit/backup/fake_swift_client2.py
+cinder/tests/unit/backup/test_backup.py
+cinder/tests/unit/backup/test_chunkeddriver.py
+cinder/tests/unit/backup/test_rpcapi.py
+cinder/tests/unit/backup/drivers/__init__.py
+cinder/tests/unit/backup/drivers/test_backup_ceph.py
+cinder/tests/unit/backup/drivers/test_backup_driver_base.py
+cinder/tests/unit/backup/drivers/test_backup_glusterfs.py
+cinder/tests/unit/backup/drivers/test_backup_google.py
+cinder/tests/unit/backup/drivers/test_backup_nfs.py
+cinder/tests/unit/backup/drivers/test_backup_posix.py
+cinder/tests/unit/backup/drivers/test_backup_swift.py
+cinder/tests/unit/backup/drivers/test_backup_tsm.py
+cinder/tests/unit/brick/__init__.py
+cinder/tests/unit/brick/fake_lvm.py
+cinder/tests/unit/brick/test_brick_lvm.py
+cinder/tests/unit/cmd/__init__.py
+cinder/tests/unit/cmd/test_status.py
+cinder/tests/unit/compute/__init__.py
+cinder/tests/unit/compute/test_nova.py
+cinder/tests/unit/consistencygroup/__init__.py
+cinder/tests/unit/consistencygroup/fake_cgsnapshot.py
+cinder/tests/unit/consistencygroup/fake_consistencygroup.py
+cinder/tests/unit/db/__init__.py
+cinder/tests/unit/db/test_cluster.py
+cinder/tests/unit/db/test_migrations.py
+cinder/tests/unit/db/test_name_id.py
+cinder/tests/unit/db/test_orm_relationships.py
+cinder/tests/unit/db/test_purge.py
+cinder/tests/unit/db/test_qos_specs.py
+cinder/tests/unit/db/test_reset_backend.py
+cinder/tests/unit/db/test_transfers.py
+cinder/tests/unit/db/test_volume_type.py
+cinder/tests/unit/glance/__init__.py
+cinder/tests/unit/glance/stubs.py
+cinder/tests/unit/group/__init__.py
+cinder/tests/unit/group/test_groups_api.py
+cinder/tests/unit/group/test_groups_manager.py
+cinder/tests/unit/group/test_groups_manager_replication.py
+cinder/tests/unit/image/__init__.py
+cinder/tests/unit/image/fake.py
+cinder/tests/unit/image/test_accelerator.py
+cinder/tests/unit/image/test_cache.py
+cinder/tests/unit/image/test_glance.py
+cinder/tests/unit/image/accelerators/__init__.py
+cinder/tests/unit/image/accelerators/test_qat_gzip.py
+cinder/tests/unit/keymgr/__init__.py
+cinder/tests/unit/keymgr/fake.py
+cinder/tests/unit/keymgr/test_conf_key_mgr.py
+cinder/tests/unit/keymgr/test_migration.py
+cinder/tests/unit/message/__init__.py
+cinder/tests/unit/message/test_api.py
+cinder/tests/unit/message/test_defined_messages.py
+cinder/tests/unit/message/test_message_field.py
+cinder/tests/unit/monkey_patch_example/__init__.py
+cinder/tests/unit/monkey_patch_example/example_a.py
+cinder/tests/unit/monkey_patch_example/example_b.py
+cinder/tests/unit/objects/__init__.py
+cinder/tests/unit/objects/test_backup.py
+cinder/tests/unit/objects/test_base.py
+cinder/tests/unit/objects/test_cgsnapshot.py
+cinder/tests/unit/objects/test_cleanable.py
+cinder/tests/unit/objects/test_cleanup_request.py
+cinder/tests/unit/objects/test_cluster.py
+cinder/tests/unit/objects/test_consistencygroup.py
+cinder/tests/unit/objects/test_fields.py
+cinder/tests/unit/objects/test_group.py
+cinder/tests/unit/objects/test_group_snapshot.py
+cinder/tests/unit/objects/test_group_type.py
+cinder/tests/unit/objects/test_manageable_volumes_snapshots.py
+cinder/tests/unit/objects/test_objects.py
+cinder/tests/unit/objects/test_qos.py
+cinder/tests/unit/objects/test_service.py
+cinder/tests/unit/objects/test_snapshot.py
+cinder/tests/unit/objects/test_volume.py
+cinder/tests/unit/objects/test_volume_attachment.py
+cinder/tests/unit/objects/test_volume_type.py
+cinder/tests/unit/policies/__init__.py
+cinder/tests/unit/policies/test_base.py
+cinder/tests/unit/policies/test_volume.py
+cinder/tests/unit/policies/test_volume_actions.py
+cinder/tests/unit/policies/test_volume_metadata.py
+cinder/tests/unit/scheduler/__init__.py
+cinder/tests/unit/scheduler/fake_hosts.py
+cinder/tests/unit/scheduler/fakes.py
+cinder/tests/unit/scheduler/test_allocated_capacity_weigher.py
+cinder/tests/unit/scheduler/test_base_filter.py
+cinder/tests/unit/scheduler/test_capacity_weigher.py
+cinder/tests/unit/scheduler/test_chance_weigher.py
+cinder/tests/unit/scheduler/test_filter_scheduler.py
+cinder/tests/unit/scheduler/test_goodness_weigher.py
+cinder/tests/unit/scheduler/test_host_filters.py
+cinder/tests/unit/scheduler/test_host_manager.py
+cinder/tests/unit/scheduler/test_rpcapi.py
+cinder/tests/unit/scheduler/test_scheduler.py
+cinder/tests/unit/scheduler/test_scheduler_options.py
+cinder/tests/unit/scheduler/test_stochastic_weight_handler.py
+cinder/tests/unit/scheduler/test_volume_number_weigher.py
+cinder/tests/unit/scheduler/test_weights.py
+cinder/tests/unit/targets/__init__.py
+cinder/tests/unit/targets/targets_fixture.py
+cinder/tests/unit/targets/test_base_iscsi_driver.py
+cinder/tests/unit/targets/test_cxt_driver.py
+cinder/tests/unit/targets/test_iet_driver.py
+cinder/tests/unit/targets/test_iser_driver.py
+cinder/tests/unit/targets/test_lio_driver.py
+cinder/tests/unit/targets/test_nvmeof_driver.py
+cinder/tests/unit/targets/test_nvmet_driver.py
+cinder/tests/unit/targets/test_scst_driver.py
+cinder/tests/unit/targets/test_spdknvmf.py
+cinder/tests/unit/targets/test_tgt_driver.py
+cinder/tests/unit/volume/__init__.py
+cinder/tests/unit/volume/test_availability_zone.py
+cinder/tests/unit/volume/test_capabilities.py
+cinder/tests/unit/volume/test_connection.py
+cinder/tests/unit/volume/test_driver.py
+cinder/tests/unit/volume/test_image.py
+cinder/tests/unit/volume/test_init_host.py
+cinder/tests/unit/volume/test_manage_volume.py
+cinder/tests/unit/volume/test_replication_manager.py
+cinder/tests/unit/volume/test_rpcapi.py
+cinder/tests/unit/volume/test_snapshot.py
+cinder/tests/unit/volume/test_volume.py
+cinder/tests/unit/volume/test_volume_manager.py
+cinder/tests/unit/volume/test_volume_migration.py
+cinder/tests/unit/volume/test_volume_retype.py
+cinder/tests/unit/volume/test_volume_usage_audit.py
+cinder/tests/unit/volume/drivers/__init__.py
+cinder/tests/unit/volume/drivers/test_datera.py
+cinder/tests/unit/volume/drivers/test_fujitsu_dx.py
+cinder/tests/unit/volume/drivers/test_gpfs.py
+cinder/tests/unit/volume/drivers/test_hedvig.py
+cinder/tests/unit/volume/drivers/test_infinidat.py
+cinder/tests/unit/volume/drivers/test_kaminario.py
+cinder/tests/unit/volume/drivers/test_linstordrv.py
+cinder/tests/unit/volume/drivers/test_lvm_driver.py
+cinder/tests/unit/volume/drivers/test_nfs.py
+cinder/tests/unit/volume/drivers/test_pure.py
+cinder/tests/unit/volume/drivers/test_qnap.py
+cinder/tests/unit/volume/drivers/test_quobyte.py
+cinder/tests/unit/volume/drivers/test_rbd.py
+cinder/tests/unit/volume/drivers/test_remotefs.py
+cinder/tests/unit/volume/drivers/test_rsd.py
+cinder/tests/unit/volume/drivers/test_san.py
+cinder/tests/unit/volume/drivers/test_seagate.py
+cinder/tests/unit/volume/drivers/test_spdk.py
+cinder/tests/unit/volume/drivers/test_storpool.py
+cinder/tests/unit/volume/drivers/test_veritas_cnfs.py
+cinder/tests/unit/volume/drivers/test_zadara.py
+cinder/tests/unit/volume/drivers/dell_emc/__init__.py
+cinder/tests/unit/volume/drivers/dell_emc/test_xtremio.py
+cinder/tests/unit/volume/drivers/dell_emc/powermax/__init__.py
+cinder/tests/unit/volume/drivers/dell_emc/powermax/powermax_data.py
+cinder/tests/unit/volume/drivers/dell_emc/powermax/powermax_fake_objects.py
+cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_common.py
+cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_fc.py
+cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_iscsi.py
+cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_masking.py
+cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_metadata.py
+cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_provision.py
+cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_replication.py
+cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_rest.py
+cinder/tests/unit/volume/drivers/dell_emc/powermax/test_powermax_utils.py
+cinder/tests/unit/volume/drivers/dell_emc/sc/__init__.py
+cinder/tests/unit/volume/drivers/dell_emc/sc/test_fc.py
+cinder/tests/unit/volume/drivers/dell_emc/sc/test_sc.py
+cinder/tests/unit/volume/drivers/dell_emc/sc/test_scapi.py
+cinder/tests/unit/volume/drivers/dell_emc/unity/__init__.py
+cinder/tests/unit/volume/drivers/dell_emc/unity/fake_exception.py
+cinder/tests/unit/volume/drivers/dell_emc/unity/test_adapter.py
+cinder/tests/unit/volume/drivers/dell_emc/unity/test_client.py
+cinder/tests/unit/volume/drivers/dell_emc/unity/test_driver.py
+cinder/tests/unit/volume/drivers/dell_emc/unity/test_replication.py
+cinder/tests/unit/volume/drivers/dell_emc/unity/test_utils.py
+cinder/tests/unit/volume/drivers/dell_emc/vnx/__init__.py
+cinder/tests/unit/volume/drivers/dell_emc/vnx/fake_enum.py
+cinder/tests/unit/volume/drivers/dell_emc/vnx/fake_exception.py
+cinder/tests/unit/volume/drivers/dell_emc/vnx/mocked_cinder.yaml
+cinder/tests/unit/volume/drivers/dell_emc/vnx/mocked_vnx.yaml
+cinder/tests/unit/volume/drivers/dell_emc/vnx/res_mock.py
+cinder/tests/unit/volume/drivers/dell_emc/vnx/test_adapter.py
+cinder/tests/unit/volume/drivers/dell_emc/vnx/test_base.py
+cinder/tests/unit/volume/drivers/dell_emc/vnx/test_client.py
+cinder/tests/unit/volume/drivers/dell_emc/vnx/test_common.py
+cinder/tests/unit/volume/drivers/dell_emc/vnx/test_driver.py
+cinder/tests/unit/volume/drivers/dell_emc/vnx/test_replication.py
+cinder/tests/unit/volume/drivers/dell_emc/vnx/test_res_mock.py
+cinder/tests/unit/volume/drivers/dell_emc/vnx/test_res_mock.yaml
+cinder/tests/unit/volume/drivers/dell_emc/vnx/test_taskflows.py
+cinder/tests/unit/volume/drivers/dell_emc/vnx/test_utils.py
+cinder/tests/unit/volume/drivers/dell_emc/vnx/utils.py
+cinder/tests/unit/volume/drivers/dell_emc/vnx/fake_storops/__init__.py
+cinder/tests/unit/volume/drivers/dell_emc/vnx/fake_storops/lib/__init__.py
+cinder/tests/unit/volume/drivers/dell_emc/vnx/fake_storops/lib/tasks.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/__init__.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/mocks.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_attach_detach_volume.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_create_cloned_volume.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_create_snapshot.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_create_volume.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_create_volume_from_snapshot.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_delete_snapshot.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_delete_volume.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_extend_volume.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_get_manageable.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_groups.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_initialize_connection.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_initialize_connection_snapshot.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_manage_existing.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_manage_existing_snapshot.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_misc.py
+cinder/tests/unit/volume/drivers/dell_emc/vxflexos/test_versions.py
+cinder/tests/unit/volume/drivers/fusionstorage/__init__.py
+cinder/tests/unit/volume/drivers/fusionstorage/test_dsware.py
+cinder/tests/unit/volume/drivers/fusionstorage/test_fs_client.py
+cinder/tests/unit/volume/drivers/fusionstorage/test_fs_conf.py
+cinder/tests/unit/volume/drivers/fusionstorage/test_utils.py
+cinder/tests/unit/volume/drivers/hpe/__init__.py
+cinder/tests/unit/volume/drivers/hpe/fake_hpe_3par_client.py
+cinder/tests/unit/volume/drivers/hpe/fake_hpe_client_exceptions.py
+cinder/tests/unit/volume/drivers/hpe/fake_hpe_lefthand_client.py
+cinder/tests/unit/volume/drivers/hpe/test_hpe3par.py
+cinder/tests/unit/volume/drivers/hpe/test_hpelefthand.py
+cinder/tests/unit/volume/drivers/huawei/__init__.py
+cinder/tests/unit/volume/drivers/huawei/test_huawei_drivers.py
+cinder/tests/unit/volume/drivers/ibm/__init__.py
+cinder/tests/unit/volume/drivers/ibm/fake_pyxcli.py
+cinder/tests/unit/volume/drivers/ibm/fake_pyxcli_exceptions.py
+cinder/tests/unit/volume/drivers/ibm/test_ds8k_proxy.py
+cinder/tests/unit/volume/drivers/ibm/test_ibm_flashsystem.py
+cinder/tests/unit/volume/drivers/ibm/test_ibm_flashsystem_iscsi.py
+cinder/tests/unit/volume/drivers/ibm/test_ibm_storage.py
+cinder/tests/unit/volume/drivers/ibm/test_storwize_svc.py
+cinder/tests/unit/volume/drivers/ibm/test_xiv_proxy.py
+cinder/tests/unit/volume/drivers/infortrend/__init__.py
+cinder/tests/unit/volume/drivers/infortrend/test_infortrend_cli.py
+cinder/tests/unit/volume/drivers/infortrend/test_infortrend_common.py
+cinder/tests/unit/volume/drivers/inspur/__init__.py
+cinder/tests/unit/volume/drivers/inspur/as13000/__init__.py
+cinder/tests/unit/volume/drivers/inspur/as13000/test_as13000_driver.py
+cinder/tests/unit/volume/drivers/inspur/instorage/__init__.py
+cinder/tests/unit/volume/drivers/inspur/instorage/fakes.py
+cinder/tests/unit/volume/drivers/inspur/instorage/test_common.py
+cinder/tests/unit/volume/drivers/inspur/instorage/test_fc_driver.py
+cinder/tests/unit/volume/drivers/inspur/instorage/test_helper_routines.py
+cinder/tests/unit/volume/drivers/inspur/instorage/test_iscsi_driver.py
+cinder/tests/unit/volume/drivers/inspur/instorage/test_replication.py
+cinder/tests/unit/volume/drivers/nec/__init__.py
+cinder/tests/unit/volume/drivers/nec/test_volume.py
+cinder/tests/unit/volume/drivers/netapp/__init__.py
+cinder/tests/unit/volume/drivers/netapp/fakes.py
+cinder/tests/unit/volume/drivers/netapp/test_common.py
+cinder/tests/unit/volume/drivers/netapp/test_utils.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/__init__.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/fakes.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/test_block_base.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/test_block_cmode.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/test_block_driver_interfaces.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/test_nfs_base.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/test_nfs_cmode.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/client/__init__.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/client/fakes.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/client/test_api.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/client/test_client_base.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/client/test_client_cmode.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/performance/__init__.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/performance/fakes.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/performance/test_perf_base.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/performance/test_perf_cmode.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/utils/__init__.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/utils/fakes.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_capabilities.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_data_motion.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_loopingcalls.py
+cinder/tests/unit/volume/drivers/netapp/dataontap/utils/test_utils.py
+cinder/tests/unit/volume/drivers/nexenta/__init__.py
+cinder/tests/unit/volume/drivers/nexenta/test_nexenta.py
+cinder/tests/unit/volume/drivers/nexenta/test_nexenta5_iscsi.py
+cinder/tests/unit/volume/drivers/nexenta/test_nexenta5_jsonrpc.py
+cinder/tests/unit/volume/drivers/nexenta/test_nexenta5_nfs.py
+cinder/tests/unit/volume/drivers/solidfire/__init__.py
+cinder/tests/unit/volume/drivers/solidfire/scaled_iops_invalid_data.json
+cinder/tests/unit/volume/drivers/solidfire/scaled_iops_test_data.json
+cinder/tests/unit/volume/drivers/solidfire/test_solidfire.py
+cinder/tests/unit/volume/drivers/synology/__init__.py
+cinder/tests/unit/volume/drivers/synology/test_synology_common.py
+cinder/tests/unit/volume/drivers/synology/test_synology_iscsi.py
+cinder/tests/unit/volume/drivers/vmware/__init__.py
+cinder/tests/unit/volume/drivers/vmware/test_fcd.py
+cinder/tests/unit/volume/drivers/vmware/test_vmware_datastore.py
+cinder/tests/unit/volume/drivers/vmware/test_vmware_vmdk.py
+cinder/tests/unit/volume/drivers/vmware/test_vmware_volumeops.py
+cinder/tests/unit/volume/flows/__init__.py
+cinder/tests/unit/volume/flows/fake_volume_api.py
+cinder/tests/unit/volume/flows/test_create_volume_flow.py
+cinder/tests/unit/volume/flows/test_manage_snapshot_flow.py
+cinder/tests/unit/volume/flows/test_manage_volume_flow.py
+cinder/tests/unit/windows/__init__.py
+cinder/tests/unit/windows/db_fakes.py
+cinder/tests/unit/windows/test_iscsi.py
+cinder/tests/unit/windows/test_smbfs.py
+cinder/tests/unit/zonemanager/__init__.py
+cinder/tests/unit/zonemanager/test_brcd_fc_san_lookup_service.py
+cinder/tests/unit/zonemanager/test_brcd_fc_zone_client_cli.py
+cinder/tests/unit/zonemanager/test_brcd_fc_zone_driver.py
+cinder/tests/unit/zonemanager/test_brcd_http_fc_zone_client.py
+cinder/tests/unit/zonemanager/test_brcd_lookup_service.py
+cinder/tests/unit/zonemanager/test_cisco_fc_san_lookup_service.py
+cinder/tests/unit/zonemanager/test_cisco_fc_zone_client_cli.py
+cinder/tests/unit/zonemanager/test_cisco_fc_zone_driver.py
+cinder/tests/unit/zonemanager/test_cisco_lookup_service.py
+cinder/tests/unit/zonemanager/test_driverutils.py
+cinder/tests/unit/zonemanager/test_fc_zone_manager.py
+cinder/tests/unit/zonemanager/test_volume_driver.py
+cinder/transfer/__init__.py
+cinder/transfer/api.py
+cinder/volume/__init__.py
+cinder/volume/api.py
+cinder/volume/configuration.py
+cinder/volume/driver.py
+cinder/volume/driver_utils.py
+cinder/volume/group_types.py
+cinder/volume/manager.py
+cinder/volume/qos_specs.py
+cinder/volume/rpcapi.py
+cinder/volume/throttling.py
+cinder/volume/volume_migration.py
+cinder/volume/volume_types.py
+cinder/volume/volume_utils.py
+cinder/volume/drivers/__init__.py
+cinder/volume/drivers/infinidat.py
+cinder/volume/drivers/linstordrv.py
+cinder/volume/drivers/lvm.py
+cinder/volume/drivers/nfs.py
+cinder/volume/drivers/pure.py
+cinder/volume/drivers/qnap.py
+cinder/volume/drivers/quobyte.py
+cinder/volume/drivers/rbd.py
+cinder/volume/drivers/remotefs.py
+cinder/volume/drivers/rsd.py
+cinder/volume/drivers/solidfire.py
+cinder/volume/drivers/spdk.py
+cinder/volume/drivers/storpool.py
+cinder/volume/drivers/veritas_cnfs.py
+cinder/volume/drivers/zadara.py
+cinder/volume/drivers/datera/__init__.py
+cinder/volume/drivers/datera/datera_api21.py
+cinder/volume/drivers/datera/datera_api22.py
+cinder/volume/drivers/datera/datera_common.py
+cinder/volume/drivers/datera/datera_iscsi.py
+cinder/volume/drivers/dell_emc/__init__.py
+cinder/volume/drivers/dell_emc/xtremio.py
+cinder/volume/drivers/dell_emc/powermax/__init__.py
+cinder/volume/drivers/dell_emc/powermax/common.py
+cinder/volume/drivers/dell_emc/powermax/fc.py
+cinder/volume/drivers/dell_emc/powermax/iscsi.py
+cinder/volume/drivers/dell_emc/powermax/masking.py
+cinder/volume/drivers/dell_emc/powermax/metadata.py
+cinder/volume/drivers/dell_emc/powermax/provision.py
+cinder/volume/drivers/dell_emc/powermax/rest.py
+cinder/volume/drivers/dell_emc/powermax/utils.py
+cinder/volume/drivers/dell_emc/sc/__init__.py
+cinder/volume/drivers/dell_emc/sc/storagecenter_api.py
+cinder/volume/drivers/dell_emc/sc/storagecenter_common.py
+cinder/volume/drivers/dell_emc/sc/storagecenter_fc.py
+cinder/volume/drivers/dell_emc/sc/storagecenter_iscsi.py
+cinder/volume/drivers/dell_emc/unity/__init__.py
+cinder/volume/drivers/dell_emc/unity/adapter.py
+cinder/volume/drivers/dell_emc/unity/client.py
+cinder/volume/drivers/dell_emc/unity/driver.py
+cinder/volume/drivers/dell_emc/unity/replication.py
+cinder/volume/drivers/dell_emc/unity/utils.py
+cinder/volume/drivers/dell_emc/vnx/__init__.py
+cinder/volume/drivers/dell_emc/vnx/adapter.py
+cinder/volume/drivers/dell_emc/vnx/client.py
+cinder/volume/drivers/dell_emc/vnx/common.py
+cinder/volume/drivers/dell_emc/vnx/const.py
+cinder/volume/drivers/dell_emc/vnx/driver.py
+cinder/volume/drivers/dell_emc/vnx/replication.py
+cinder/volume/drivers/dell_emc/vnx/taskflows.py
+cinder/volume/drivers/dell_emc/vnx/utils.py
+cinder/volume/drivers/dell_emc/vxflexos/__init__.py
+cinder/volume/drivers/dell_emc/vxflexos/driver.py
+cinder/volume/drivers/dell_emc/vxflexos/options.py
+cinder/volume/drivers/dell_emc/vxflexos/simplecache.py
+cinder/volume/drivers/fujitsu/__init__.py
+cinder/volume/drivers/fujitsu/eternus_dx/__init__.py
+cinder/volume/drivers/fujitsu/eternus_dx/constants.py
+cinder/volume/drivers/fujitsu/eternus_dx/eternus_dx_cli.py
+cinder/volume/drivers/fujitsu/eternus_dx/eternus_dx_common.py
+cinder/volume/drivers/fujitsu/eternus_dx/eternus_dx_fc.py
+cinder/volume/drivers/fujitsu/eternus_dx/eternus_dx_iscsi.py
+cinder/volume/drivers/fusionstorage/__init__.py
+cinder/volume/drivers/fusionstorage/constants.py
+cinder/volume/drivers/fusionstorage/dsware.py
+cinder/volume/drivers/fusionstorage/fs_client.py
+cinder/volume/drivers/fusionstorage/fs_conf.py
+cinder/volume/drivers/hedvig/__init__.py
+cinder/volume/drivers/hedvig/config.py
+cinder/volume/drivers/hedvig/hedvig_cinder.py
+cinder/volume/drivers/hedvig/rest_client.py
+cinder/volume/drivers/hpe/__init__.py
+cinder/volume/drivers/hpe/hpe_3par_base.py
+cinder/volume/drivers/hpe/hpe_3par_common.py
+cinder/volume/drivers/hpe/hpe_3par_fc.py
+cinder/volume/drivers/hpe/hpe_3par_iscsi.py
+cinder/volume/drivers/hpe/hpe_lefthand_iscsi.py
+cinder/volume/drivers/hpe/releasenotes/notes/hpe_3par_multiattach_detach_fix-d2d3785d656fba90.yaml
+cinder/volume/drivers/huawei/__init__.py
+cinder/volume/drivers/huawei/common.py
+cinder/volume/drivers/huawei/constants.py
+cinder/volume/drivers/huawei/fc_zone_helper.py
+cinder/volume/drivers/huawei/huawei_conf.py
+cinder/volume/drivers/huawei/huawei_driver.py
+cinder/volume/drivers/huawei/huawei_utils.py
+cinder/volume/drivers/huawei/hypermetro.py
+cinder/volume/drivers/huawei/replication.py
+cinder/volume/drivers/huawei/rest_client.py
+cinder/volume/drivers/huawei/smartx.py
+cinder/volume/drivers/ibm/__init__.py
+cinder/volume/drivers/ibm/flashsystem_common.py
+cinder/volume/drivers/ibm/flashsystem_fc.py
+cinder/volume/drivers/ibm/flashsystem_iscsi.py
+cinder/volume/drivers/ibm/gpfs.py
+cinder/volume/drivers/ibm/ibm_storage/__init__.py
+cinder/volume/drivers/ibm/ibm_storage/certificate.py
+cinder/volume/drivers/ibm/ibm_storage/cryptish.py
+cinder/volume/drivers/ibm/ibm_storage/ds8k_connection.py
+cinder/volume/drivers/ibm/ibm_storage/ds8k_helper.py
+cinder/volume/drivers/ibm/ibm_storage/ds8k_proxy.py
+cinder/volume/drivers/ibm/ibm_storage/ds8k_replication.py
+cinder/volume/drivers/ibm/ibm_storage/ds8k_restclient.py
+cinder/volume/drivers/ibm/ibm_storage/ibm_storage.py
+cinder/volume/drivers/ibm/ibm_storage/proxy.py
+cinder/volume/drivers/ibm/ibm_storage/strings.py
+cinder/volume/drivers/ibm/ibm_storage/xiv_proxy.py
+cinder/volume/drivers/ibm/ibm_storage/xiv_replication.py
+cinder/volume/drivers/ibm/storwize_svc/__init__.py
+cinder/volume/drivers/ibm/storwize_svc/replication.py
+cinder/volume/drivers/ibm/storwize_svc/storwize_const.py
+cinder/volume/drivers/ibm/storwize_svc/storwize_svc_common.py
+cinder/volume/drivers/ibm/storwize_svc/storwize_svc_fc.py
+cinder/volume/drivers/ibm/storwize_svc/storwize_svc_iscsi.py
+cinder/volume/drivers/infortrend/__init__.py
+cinder/volume/drivers/infortrend/infortrend_fc_cli.py
+cinder/volume/drivers/infortrend/infortrend_iscsi_cli.py
+cinder/volume/drivers/infortrend/raidcmd_cli/__init__.py
+cinder/volume/drivers/infortrend/raidcmd_cli/cli_factory.py
+cinder/volume/drivers/infortrend/raidcmd_cli/common_cli.py
+cinder/volume/drivers/inspur/__init__.py
+cinder/volume/drivers/inspur/as13000/__init__.py
+cinder/volume/drivers/inspur/as13000/as13000_driver.py
+cinder/volume/drivers/inspur/instorage/__init__.py
+cinder/volume/drivers/inspur/instorage/instorage_common.py
+cinder/volume/drivers/inspur/instorage/instorage_const.py
+cinder/volume/drivers/inspur/instorage/instorage_fc.py
+cinder/volume/drivers/inspur/instorage/instorage_iscsi.py
+cinder/volume/drivers/inspur/instorage/replication.py
+cinder/volume/drivers/kaminario/__init__.py
+cinder/volume/drivers/kaminario/kaminario_common.py
+cinder/volume/drivers/kaminario/kaminario_fc.py
+cinder/volume/drivers/kaminario/kaminario_iscsi.py
+cinder/volume/drivers/lenovo/__init__.py
+cinder/volume/drivers/lenovo/lenovo_client.py
+cinder/volume/drivers/lenovo/lenovo_common.py
+cinder/volume/drivers/lenovo/lenovo_fc.py
+cinder/volume/drivers/lenovo/lenovo_iscsi.py
+cinder/volume/drivers/macrosan/__init__.py
+cinder/volume/drivers/macrosan/config.py
+cinder/volume/drivers/macrosan/devop_client.py
+cinder/volume/drivers/macrosan/driver.py
+cinder/volume/drivers/nec/__init__.py
+cinder/volume/drivers/nec/cli.py
+cinder/volume/drivers/nec/product.xml
+cinder/volume/drivers/nec/volume.py
+cinder/volume/drivers/nec/volume_common.py
+cinder/volume/drivers/nec/volume_helper.py
+cinder/volume/drivers/netapp/__init__.py
+cinder/volume/drivers/netapp/common.py
+cinder/volume/drivers/netapp/options.py
+cinder/volume/drivers/netapp/utils.py
+cinder/volume/drivers/netapp/dataontap/__init__.py
+cinder/volume/drivers/netapp/dataontap/block_base.py
+cinder/volume/drivers/netapp/dataontap/block_cmode.py
+cinder/volume/drivers/netapp/dataontap/fc_cmode.py
+cinder/volume/drivers/netapp/dataontap/iscsi_cmode.py
+cinder/volume/drivers/netapp/dataontap/nfs_base.py
+cinder/volume/drivers/netapp/dataontap/nfs_cmode.py
+cinder/volume/drivers/netapp/dataontap/client/__init__.py
+cinder/volume/drivers/netapp/dataontap/client/api.py
+cinder/volume/drivers/netapp/dataontap/client/client_base.py
+cinder/volume/drivers/netapp/dataontap/client/client_cmode.py
+cinder/volume/drivers/netapp/dataontap/performance/__init__.py
+cinder/volume/drivers/netapp/dataontap/performance/perf_base.py
+cinder/volume/drivers/netapp/dataontap/performance/perf_cmode.py
+cinder/volume/drivers/netapp/dataontap/utils/__init__.py
+cinder/volume/drivers/netapp/dataontap/utils/capabilities.py
+cinder/volume/drivers/netapp/dataontap/utils/data_motion.py
+cinder/volume/drivers/netapp/dataontap/utils/loopingcalls.py
+cinder/volume/drivers/netapp/dataontap/utils/utils.py
+cinder/volume/drivers/nexenta/__init__.py
+cinder/volume/drivers/nexenta/iscsi.py
+cinder/volume/drivers/nexenta/jsonrpc.py
+cinder/volume/drivers/nexenta/nfs.py
+cinder/volume/drivers/nexenta/options.py
+cinder/volume/drivers/nexenta/utils.py
+cinder/volume/drivers/nexenta/ns5/__init__.py
+cinder/volume/drivers/nexenta/ns5/iscsi.py
+cinder/volume/drivers/nexenta/ns5/jsonrpc.py
+cinder/volume/drivers/nexenta/ns5/nfs.py
+cinder/volume/drivers/san/__init__.py
+cinder/volume/drivers/san/san.py
+cinder/volume/drivers/san/hp/__init__.py
+cinder/volume/drivers/san/hp/hpmsa_client.py
+cinder/volume/drivers/san/hp/hpmsa_common.py
+cinder/volume/drivers/san/hp/hpmsa_fc.py
+cinder/volume/drivers/san/hp/hpmsa_iscsi.py
+cinder/volume/drivers/stx/__init__.py
+cinder/volume/drivers/stx/client.py
+cinder/volume/drivers/stx/common.py
+cinder/volume/drivers/stx/exception.py
+cinder/volume/drivers/stx/fc.py
+cinder/volume/drivers/stx/iscsi.py
+cinder/volume/drivers/synology/__init__.py
+cinder/volume/drivers/synology/synology_common.py
+cinder/volume/drivers/synology/synology_iscsi.py
+cinder/volume/drivers/vmware/__init__.py
+cinder/volume/drivers/vmware/datastore.py
+cinder/volume/drivers/vmware/exceptions.py
+cinder/volume/drivers/vmware/fcd.py
+cinder/volume/drivers/vmware/vmdk.py
+cinder/volume/drivers/vmware/volumeops.py
+cinder/volume/drivers/windows/__init__.py
+cinder/volume/drivers/windows/constants.py
+cinder/volume/drivers/windows/iscsi.py
+cinder/volume/drivers/windows/smbfs.py
+cinder/volume/flows/__init__.py
+cinder/volume/flows/common.py
+cinder/volume/flows/api/__init__.py
+cinder/volume/flows/api/create_volume.py
+cinder/volume/flows/api/manage_existing.py
+cinder/volume/flows/manager/__init__.py
+cinder/volume/flows/manager/create_volume.py
+cinder/volume/flows/manager/manage_existing.py
+cinder/volume/flows/manager/manage_existing_snapshot.py
+cinder/volume/targets/__init__.py
+cinder/volume/targets/cxt.py
+cinder/volume/targets/driver.py
+cinder/volume/targets/fake.py
+cinder/volume/targets/iet.py
+cinder/volume/targets/iscsi.py
+cinder/volume/targets/lio.py
+cinder/volume/targets/nvmeof.py
+cinder/volume/targets/nvmet.py
+cinder/volume/targets/scst.py
+cinder/volume/targets/spdknvmf.py
+cinder/volume/targets/tgt.py
+cinder/wsgi/__init__.py
+cinder/wsgi/common.py
+cinder/wsgi/eventlet_server.py
+cinder/wsgi/wsgi.py
+cinder/zonemanager/__init__.py
+cinder/zonemanager/fc_common.py
+cinder/zonemanager/fc_san_lookup_service.py
+cinder/zonemanager/fc_zone_manager.py
+cinder/zonemanager/fczm_constants.py
+cinder/zonemanager/utils.py
+cinder/zonemanager/drivers/__init__.py
+cinder/zonemanager/drivers/driver_utils.py
+cinder/zonemanager/drivers/fc_zone_driver.py
+cinder/zonemanager/drivers/brocade/__init__.py
+cinder/zonemanager/drivers/brocade/brcd_fabric_opts.py
+cinder/zonemanager/drivers/brocade/brcd_fc_san_lookup_service.py
+cinder/zonemanager/drivers/brocade/brcd_fc_zone_client_cli.py
+cinder/zonemanager/drivers/brocade/brcd_fc_zone_connector_factory.py
+cinder/zonemanager/drivers/brocade/brcd_fc_zone_driver.py
+cinder/zonemanager/drivers/brocade/brcd_http_fc_zone_client.py
+cinder/zonemanager/drivers/brocade/brcd_rest_fc_zone_client.py
+cinder/zonemanager/drivers/brocade/exception.py
+cinder/zonemanager/drivers/brocade/fc_zone_constants.py
+cinder/zonemanager/drivers/brocade/rest_constants.py
+cinder/zonemanager/drivers/cisco/__init__.py
+cinder/zonemanager/drivers/cisco/cisco_fabric_opts.py
+cinder/zonemanager/drivers/cisco/cisco_fc_san_lookup_service.py
+cinder/zonemanager/drivers/cisco/cisco_fc_zone_client_cli.py
+cinder/zonemanager/drivers/cisco/cisco_fc_zone_driver.py
+cinder/zonemanager/drivers/cisco/exception.py
+cinder/zonemanager/drivers/cisco/fc_zone_constants.py
+contrib/block-box/.gitignore
+contrib/block-box/LICENSE
+contrib/block-box/Makefile
+contrib/block-box/README.CVOL-LVM.md
+contrib/block-box/README.md
+contrib/block-box/cinder.rc
+contrib/block-box/docker-compose-add-vol-service.yml
+contrib/block-box/docker-compose.yml
+contrib/block-box/contrib/cinderflex
+contrib/block-box/docker-entrypoint-initdb.d/script.sql
+contrib/block-box/etc/api-paste.ini
+contrib/block-box/etc/cinder.conf
+contrib/block-box/etc/cinder.conf.keystone
+contrib/block-box/etc/cinder.conf.sf
+contrib/block-box/etc/cinder.conf.solidfire
+contrib/block-box/etc/logging.conf
+contrib/block-box/etc/policy.json
+contrib/block-box/etc/rootwrap.conf
+contrib/block-box/scripts/cinder-api.sh
+contrib/block-box/scripts/lvm-service.sh
+doc/.gitignore
+doc/README.rst
+doc/requirements.txt
+doc/ext/__init__.py
+doc/ext/cinder_driverlist.py
+doc/ext/driver_opts.py
+doc/source/conf.py
+doc/source/drivers-all-about.rst
+doc/source/index.rst
+doc/source/upgrade.rst
+doc/source/_extra/.htaccess
+doc/source/_static/.placeholder
+doc/source/admin/README.rst
+doc/source/admin/blockstorage-accelerate-image-compression.rst
+doc/source/admin/blockstorage-api-throughput.rst
+doc/source/admin/blockstorage-availability-zone-type.rst
+doc/source/admin/blockstorage-backup-disks.rst
+doc/source/admin/blockstorage-basic-volume-qos.rst
+doc/source/admin/blockstorage-boot-from-volume.rst
+doc/source/admin/blockstorage-capacity-based-qos.rst
+doc/source/admin/blockstorage-consistency-groups.rst
+doc/source/admin/blockstorage-driver-filter-weighing.rst
+doc/source/admin/blockstorage-get-capabilities.rst
+doc/source/admin/blockstorage-groups.rst
+doc/source/admin/blockstorage-image-volume-cache.rst
+doc/source/admin/blockstorage-lio-iscsi-support.rst
+doc/source/admin/blockstorage-manage-volumes.rst
+doc/source/admin/blockstorage-multi-backend.rst
+doc/source/admin/blockstorage-nfs-backend.rst
+doc/source/admin/blockstorage-over-subscription.rst
+doc/source/admin/blockstorage-ratelimit-volume-copy-bandwidth.rst
+doc/source/admin/blockstorage-troubleshoot.rst
+doc/source/admin/blockstorage-volume-backed-image.rst
+doc/source/admin/blockstorage-volume-backups-export-import.rst
+doc/source/admin/blockstorage-volume-backups.rst
+doc/source/admin/blockstorage-volume-migration.rst
+doc/source/admin/blockstorage-volume-multiattach.rst
+doc/source/admin/blockstorage-volume-number-weigher.rst
+doc/source/admin/generalized_filters.rst
+doc/source/admin/index.rst
+doc/source/admin/ts-HTTP-bad-req-in-cinder-vol-log.rst
+doc/source/admin/ts-cinder-config.rst
+doc/source/admin/ts-duplicate-3par-host.rst
+doc/source/admin/ts-failed-attach-vol-after-detach.rst
+doc/source/admin/ts-failed-attach-vol-no-sysfsutils.rst
+doc/source/admin/ts-failed-connect-vol-FC-SAN.rst
+doc/source/admin/ts-multipath-warn.rst
+doc/source/admin/ts-no-emulator-x86-64.rst
+doc/source/admin/ts-non-existent-host.rst
+doc/source/admin/ts-non-existent-vlun.rst
+doc/source/cli/README.rst
+doc/source/cli/cinder-manage.rst
+doc/source/cli/cinder-status.rst
+doc/source/cli/cli-cinder-quotas.rst
+doc/source/cli/cli-cinder-scheduling.rst
+doc/source/cli/cli-manage-volumes.rst
+doc/source/cli/cli-set-quotas.rst
+doc/source/cli/index.rst
+doc/source/common/glossary.rst
+doc/source/configuration/README.rst
+doc/source/configuration/index.rst
+doc/source/configuration/block-storage/backup-drivers.rst
+doc/source/configuration/block-storage/block-storage-overview.rst
+doc/source/configuration/block-storage/config-options.rst
+doc/source/configuration/block-storage/fc-zoning.rst
+doc/source/configuration/block-storage/logs.rst
+doc/source/configuration/block-storage/nested-quota.rst
+doc/source/configuration/block-storage/policy-config-HOWTO.rst
+doc/source/configuration/block-storage/policy.rst
+doc/source/configuration/block-storage/scheduler-filters.rst
+doc/source/configuration/block-storage/scheduler-weights.rst
+doc/source/configuration/block-storage/schedulers.rst
+doc/source/configuration/block-storage/service-token.rst
+doc/source/configuration/block-storage/volume-drivers.rst
+doc/source/configuration/block-storage/volume-encryption.rst
+doc/source/configuration/block-storage/backup/ceph-backup-driver.rst
+doc/source/configuration/block-storage/backup/gcs-backup-driver.rst
+doc/source/configuration/block-storage/backup/glusterfs-backup-driver.rst
+doc/source/configuration/block-storage/backup/nfs-backup-driver.rst
+doc/source/configuration/block-storage/backup/posix-backup-driver.rst
+doc/source/configuration/block-storage/backup/swift-backup-driver.rst
+doc/source/configuration/block-storage/backup/tsm-backup-driver.rst
+doc/source/configuration/block-storage/drivers/MacroSAN-storage-driver.rst
+doc/source/configuration/block-storage/drivers/ceph-rbd-volume-driver.rst
+doc/source/configuration/block-storage/drivers/datera-volume-driver.rst
+doc/source/configuration/block-storage/drivers/dell-emc-powermax-driver.rst
+doc/source/configuration/block-storage/drivers/dell-emc-unity-driver.rst
+doc/source/configuration/block-storage/drivers/dell-emc-vnx-driver.rst
+doc/source/configuration/block-storage/drivers/dell-emc-vxflex-driver.rst
+doc/source/configuration/block-storage/drivers/dell-emc-xtremio-driver.rst
+doc/source/configuration/block-storage/drivers/dell-storagecenter-driver.rst
+doc/source/configuration/block-storage/drivers/fujitsu-eternus-dx-driver.rst
+doc/source/configuration/block-storage/drivers/hedvig-volume-driver.rst
+doc/source/configuration/block-storage/drivers/hp-msa-driver.rst
+doc/source/configuration/block-storage/drivers/hpe-3par-driver.rst
+doc/source/configuration/block-storage/drivers/hpe-lefthand-driver.rst
+doc/source/configuration/block-storage/drivers/huawei-storage-driver.rst
+doc/source/configuration/block-storage/drivers/ibm-flashsystem-volume-driver.rst
+doc/source/configuration/block-storage/drivers/ibm-gpfs-volume-driver.rst
+doc/source/configuration/block-storage/drivers/ibm-storage-volume-driver.rst
+doc/source/configuration/block-storage/drivers/ibm-storwize-svc-driver.rst
+doc/source/configuration/block-storage/drivers/infinidat-volume-driver.rst
+doc/source/configuration/block-storage/drivers/infortrend-volume-driver.rst
+doc/source/configuration/block-storage/drivers/inspur-as13000-driver.rst
+doc/source/configuration/block-storage/drivers/inspur-instorage-driver.rst
+doc/source/configuration/block-storage/drivers/intel-rsd-volume-driver.rst
+doc/source/configuration/block-storage/drivers/kaminario-driver.rst
+doc/source/configuration/block-storage/drivers/lenovo-driver.rst
+doc/source/configuration/block-storage/drivers/linstor-driver.rst
+doc/source/configuration/block-storage/drivers/lvm-volume-driver.rst
+doc/source/configuration/block-storage/drivers/nec-storage-m-series-driver.rst
+doc/source/configuration/block-storage/drivers/netapp-volume-driver.rst
+doc/source/configuration/block-storage/drivers/nexentastor4-driver.rst
+doc/source/configuration/block-storage/drivers/nexentastor5-driver.rst
+doc/source/configuration/block-storage/drivers/nfs-volume-driver.rst
+doc/source/configuration/block-storage/drivers/pure-storage-driver.rst
+doc/source/configuration/block-storage/drivers/quobyte-driver.rst
+doc/source/configuration/block-storage/drivers/seagate-driver.rst
+doc/source/configuration/block-storage/drivers/solidfire-volume-driver.rst
+doc/source/configuration/block-storage/drivers/spdk-volume-driver.rst
+doc/source/configuration/block-storage/drivers/storpool-volume-driver.rst
+doc/source/configuration/block-storage/drivers/synology-dsm-driver.rst
+doc/source/configuration/block-storage/drivers/vmware-vmdk-driver.rst
+doc/source/configuration/block-storage/drivers/windows-iscsi-volume-driver.rst
+doc/source/configuration/block-storage/drivers/windows-smb-volume-driver.rst
+doc/source/configuration/block-storage/drivers/zadara-volume-driver.rst
+doc/source/configuration/block-storage/samples/api-paste.ini.inc
+doc/source/configuration/block-storage/samples/api-paste.ini.rst
+doc/source/configuration/block-storage/samples/cinder.conf.rst
+doc/source/configuration/block-storage/samples/index.rst
+doc/source/configuration/block-storage/samples/policy.yaml.rst
+doc/source/configuration/block-storage/samples/rootwrap.conf.inc
+doc/source/configuration/block-storage/samples/rootwrap.conf.rst
+doc/source/configuration/figures/ceph-architecture.png
+doc/source/configuration/figures/emc-enabler.png
+doc/source/configuration/figures/ibm-storage-nova-concept.png
+doc/source/configuration/tables/cinder-ibm_gpfs.inc
+doc/source/configuration/tables/cinder-ibm_gpfs_nfs.inc
+doc/source/configuration/tables/cinder-ibm_gpfs_remote.inc
+doc/source/configuration/tables/cinder-ibm_storage.inc
+doc/source/configuration/tables/cinder-infortrend.inc
+doc/source/configuration/tables/cinder-netapp_cdot_iscsi.inc
+doc/source/configuration/tables/cinder-netapp_cdot_nfs.inc
+doc/source/configuration/tables/cinder-nexenta.inc
+doc/source/configuration/tables/cinder-nexenta5.inc
+doc/source/configuration/tables/cinder-prophetstor_dpl.inc
+doc/source/configuration/tables/cinder-storwize.inc
+doc/source/configuration/tables/cinder-vmware.inc
+doc/source/configuration/tables/manual/cinder-netapp_cdot_extraspecs.inc
+doc/source/contributor/README.rst
+doc/source/contributor/addmethod.openstackapi.rst
+doc/source/contributor/api.apache.rst
+doc/source/contributor/api_conditional_updates.rst
+doc/source/contributor/api_microversion_dev.rst
+doc/source/contributor/api_microversion_history.rst
+doc/source/contributor/architecture.rst
+doc/source/contributor/attach_detach_conventions.rst
+doc/source/contributor/attach_detach_conventions_v2.rst
+doc/source/contributor/contributing.rst
+doc/source/contributor/development.environment.rst
+doc/source/contributor/documentation.rst
+doc/source/contributor/drivers.rst
+doc/source/contributor/drivers_locking_examples.rst
+doc/source/contributor/gerrit.rst
+doc/source/contributor/gmr.rst
+doc/source/contributor/groups.rst
+doc/source/contributor/high_availability.rst
+doc/source/contributor/i18n.rst
+doc/source/contributor/index.rst
+doc/source/contributor/launchpad.rst
+doc/source/contributor/migration.rst
+doc/source/contributor/new_driver_checklist.rst
+doc/source/contributor/releasecycle.rst
+doc/source/contributor/releasenotes.rst
+doc/source/contributor/replication.rst
+doc/source/contributor/rolling.upgrades.rst
+doc/source/contributor/rpc.rst
+doc/source/contributor/testing.rst
+doc/source/contributor/thin_provisioning.rst
+doc/source/contributor/threading.rst
+doc/source/contributor/user_messages.rst
+doc/source/contributor/zuul.rst
+doc/source/images/architecture.png
+doc/source/images/cinder.png
+doc/source/images/rpc/arch.png
+doc/source/images/rpc/arch.svg
+doc/source/images/rpc/flow1.png
+doc/source/images/rpc/flow1.svg
+doc/source/images/rpc/flow2.png
+doc/source/images/rpc/flow2.svg
+doc/source/images/rpc/rabt.png
+doc/source/images/rpc/rabt.svg
+doc/source/images/rpc/state.png
+doc/source/install/README.rst
+doc/source/install/cinder-backup-install-obs.rst
+doc/source/install/cinder-backup-install-rdo.rst
+doc/source/install/cinder-backup-install-ubuntu.rst
+doc/source/install/cinder-controller-install-obs.rst
+doc/source/install/cinder-controller-install-rdo.rst
+doc/source/install/cinder-controller-install-ubuntu.rst
+doc/source/install/cinder-storage-install-obs.rst
+doc/source/install/cinder-storage-install-rdo.rst
+doc/source/install/cinder-storage-install-ubuntu.rst
+doc/source/install/cinder-storage-install-windows.rst
+doc/source/install/cinder-verify.rst
+doc/source/install/get-started-block-storage.rst
+doc/source/install/index-obs.rst
+doc/source/install/index-rdo.rst
+doc/source/install/index-ubuntu.rst
+doc/source/install/index-windows.rst
+doc/source/install/index.rst
+doc/source/install/figures/hwreqs.png
+doc/source/install/figures/network1-services.png
+doc/source/install/figures/network2-services.png
+doc/source/reference/README.rst
+doc/source/reference/support-matrix.ini
+doc/source/reference/support-matrix.rst
+doc/source/user/README.rst
+etc/cinder/README-cinder.conf.sample
+etc/cinder/README-policy.generate.md
+etc/cinder/api-httpd.conf
+etc/cinder/api-paste.ini
+etc/cinder/logging_sample.conf
+etc/cinder/resource_filters.json
+etc/cinder/rootwrap.conf
+etc/cinder/rootwrap.d/volume.filters
+playbooks/cinderlib-run.yaml
+playbooks/tempest-and-cinderlib-run.yaml
+playbooks/legacy/cinder-tempest-dsvm-lvm-lio-barbican/post.yaml
+playbooks/legacy/cinder-tempest-dsvm-lvm-lio-barbican/run.yaml
+playbooks/legacy/grenade-dsvm-cinder-mn-sub-bak/post.yaml
+playbooks/legacy/grenade-dsvm-cinder-mn-sub-bak/run.yaml
+playbooks/legacy/grenade-dsvm-cinder-mn-sub-volbak/post.yaml
+playbooks/legacy/grenade-dsvm-cinder-mn-sub-volbak/run.yaml
+playbooks/legacy/grenade-dsvm-cinder-mn-sub-volschbak/post.yaml
+playbooks/legacy/grenade-dsvm-cinder-mn-sub-volschbak/run.yaml
+rally-jobs/README.rst
+rally-jobs/cinder.yaml
+rally-jobs/extra/README.rst
+rally-jobs/plugins/README.rst
+rally-jobs/plugins/__init__.py
+releasenotes/README.rst
+releasenotes/notes/1220b8a67602b8e7-update_rootwrap_volume_filters.yaml
+releasenotes/notes/3par-create-cg-from-source-cg-5634dcf9feb813f6.yaml
+releasenotes/notes/3par-create-fc-vlun-match-set-type-babcf2cbce1ce317.yaml
+releasenotes/notes/3par-get-capability-de60c9bc7ae51c14.yaml
+releasenotes/notes/3par-license-check-51a16b5247675760.yaml
+releasenotes/notes/3par-manage-unmanage-snapshot-eb4e504e8782ba43.yaml
+releasenotes/notes/84-to-90-endpoints-831c28423d32cac5.yaml
+releasenotes/notes/Dell-SC-Driver-to-dell_emc-folder-e5d6fb1f1cf84149.yaml
+releasenotes/notes/Dell-SC-New-Extra-Specs-1de0d3f1ebc62881.yaml
+releasenotes/notes/Dell-SC-Retype-Limitations-74f4b5f6a94ffe4f.yaml
+releasenotes/notes/Dell-SC-ServerOS-Config-Option-bd0e018319758e03.yaml
+releasenotes/notes/Dell-SC-excluded_domain_ips_ListOpt-51bacddee199ce83.yaml
+releasenotes/notes/Dell-SC-live-volume-41bacddee199ce83.yaml
+releasenotes/notes/Dell-SC-replication-failover_host-failback-a9e9cbbd6a1be6c3.yaml
+releasenotes/notes/Dell-SC-thaw_backend-b9362d381fabd4c9.yaml
+releasenotes/notes/Dell-SC-v2.1-replication-ef6b1d6a4e2795a0.yaml
+releasenotes/notes/Enable-HPE-3PAR-Compression-Feature-90e4de4b64a74a46.yaml
+releasenotes/notes/HPE-3par-Generic-Volume-Group-e048002e1c3469a3.yaml
+releasenotes/notes/Huawei-volume-driver-replication-v2.1-ada5bc3ad62dc633.yaml
+releasenotes/notes/Huawei_Cinder_Driver_Support_Dorado_V6-5289a3b0ef90e8b1.yaml
+releasenotes/notes/Lefthand-generic-volume-group-570d07b4786b93c2.yaml
+releasenotes/notes/MacroSAN-volume-driver-6477e4ec7c38f49d.yaml
+releasenotes/notes/NetApp-ONTAP-full-cg-support-cfdc91bf0acf9fe1.yaml
+releasenotes/notes/SolidFire-generic-volume-group-1b1e55661cd83a43.yaml
+releasenotes/notes/VMEM-6000-drivers-removed-9b6675ff7ae5f960.yaml
+releasenotes/notes/Zadara-change-to-access-key-b16bdaa9d8460b57.yaml
+releasenotes/notes/ZadaraStorage-13a5fff6f4fa1710.yaml
+releasenotes/notes/a7401ead26a7c83b-keystone-url.yaml
+releasenotes/notes/add-availability_zone-filter-for-snapshot-8e1494212276abde.yaml
+releasenotes/notes/add-backup-project-attribute-3f57051ef9159b08.yaml
+releasenotes/notes/add-cg-capability-to-groups-2eb3e71682a88600.yaml
+releasenotes/notes/add-coho-driver-b4472bff3f64aa41.yaml
+releasenotes/notes/add-configurable-img-conversion-param-1e7b545ae816dfe8.yaml
+releasenotes/notes/add-connection-info-to-attachment-84d4dg45uh41db15.yaml
+releasenotes/notes/add-count-info-in-list-api-e43wac44yu750c23.yaml
+releasenotes/notes/add-datacore-volume-driver-3775797b0515f538.yaml
+releasenotes/notes/add-del-volumeTypeAccess-b1c8cb14a9d14db3.yaml
+releasenotes/notes/add-filter-to-group-snapshots-74sd8g138a289dh4.yaml
+releasenotes/notes/add-filters-support-to-get_pools-0852e9c0e42fbf98.yaml
+releasenotes/notes/add-google-backup-driver-d1e7ac33d5780b79.yaml
+releasenotes/notes/add-io-ports-option-c751d1bd395dd614.yaml
+releasenotes/notes/add-like-filter-support-7d4r78d6de3984dv.yaml
+releasenotes/notes/add-operation-to-request-spec-7yt6ub75uy1284as.yaml
+releasenotes/notes/add-option-max_luns_per_storage_group-dfe3e1396b262bc8.yaml
+releasenotes/notes/add-periodic-task-to-clean-expired-messages-84f47gxc88hda035.yaml
+releasenotes/notes/add-project-id-to-group-groupsnapshot-response-512013e95a80784a.yaml
+releasenotes/notes/add-reset-group-snapshot-status-sd21a31cde5fa035.yaml
+releasenotes/notes/add-reset-group-status-sd21a31cde5fa034.yaml
+releasenotes/notes/add-resource-filters-api-8g3dub1700qaye98.yaml
+releasenotes/notes/add-revert-to-snapshot-support-2d21a3dv4f5fa087.yaml
+releasenotes/notes/add-split-logger-conf-option-0424e3bd91de3a5a.yaml
+releasenotes/notes/add-stochastic-scheduling-option-99e10eae023fbcca.yaml
+releasenotes/notes/add-suppress-lvm-fd-warnings-option.402bebc03b0a9f00.yaml
+releasenotes/notes/add-tegile-driver-b7919c5f30911998.yaml
+releasenotes/notes/add-transfer-pagination-support-7y33u7y68de3cb16.yaml
+releasenotes/notes/add-user-id-attribute-to-backup-response-ce27364680c895f7.yaml
+releasenotes/notes/add-vmax-replication-490202c15503ae03.yaml
+releasenotes/notes/add-volume-type-filter-to_get-pools-c791132540921398.yaml
+releasenotes/notes/add-volume-upload-image-options-3a61a31c544fa034.yaml
+releasenotes/notes/add_ceph_custom_keyring_path-43a3b8c21a1ab3c4.yaml
+releasenotes/notes/add_manage_unmanage_itri_disco_driver-1c9ee31cc86b6eda.yaml
+releasenotes/notes/add_multiattach_policies-8e0b22505ed6cbd8.yaml
+releasenotes/notes/add_replication_failback_to_solidfire-82668c071f4fa91d.yaml
+releasenotes/notes/allow-admin-quota-operations-c1c2236711224023.yaml
+releasenotes/notes/allow-encrypted-rbd-volumes-35d3536505e6309b.yaml
+releasenotes/notes/allow-huawei-driver-lun-copy-speed-configurable-361a480e7b7e361d.yaml
+releasenotes/notes/allow-remove-name-and-description-for-consisgroup-408257a0a18bd530.yaml
+releasenotes/notes/apply-limits-to-qemu-img-29f722a1bf4b91f8.yaml
+releasenotes/notes/backend-options-ed19e6c63b2b9090.yaml
+releasenotes/notes/backup-ceph-driver-journaling-exculsive-lock-features-6b6044138a288a83.yaml
+releasenotes/notes/backup-driver-configuration-36357733962dab03.yaml
+releasenotes/notes/backup-path-removal-c411bb6c0d3887f1.yaml
+releasenotes/notes/backup-snapshot-6e7447db930c31f6.yaml
+releasenotes/notes/backup-snapshots-2f547c8788bc11e1.yaml
+releasenotes/notes/backup-update-d0b0db6a7b1c2a5b.yaml
+releasenotes/notes/backup_driver_init_state-d4834fa927e502ab.yaml
+releasenotes/notes/balanced-fc-port-selection-fbf6b841fea99156.yaml
+releasenotes/notes/bdd-pools-stats-afb4398daa9248de.yaml
+releasenotes/notes/bp-datera-cinder-driver-update-2.1-5c6455b45563adc5.yaml
+releasenotes/notes/bp-inspur-instorage-driver-40371862c9559238.yaml
+releasenotes/notes/bp-netapp-solidfire-revert-to-snapshot-741b7c204cc99546.yaml
+releasenotes/notes/bp-nvmeof-lvm-target-b7771955b426abe7.yaml
+releasenotes/notes/bp-open-src-ibm-storage-driver-d17808e52aa4eacb.yaml
+releasenotes/notes/bp-provisioning-improvements-bb7e28896e2a2539.yaml
+releasenotes/notes/bp-remove-netapp-7mode-drivers-c38398e54662f2d4.yaml
+releasenotes/notes/bp-vmware-fcd-fbe19ee577d2e9e4.yaml
+releasenotes/notes/brcd_lookupservice_http_support-f6485b38a1feaa15.yaml
+releasenotes/notes/brocade_http_connector-0021e41dfa56e671.yaml
+releasenotes/notes/brocade_virtual_fabrics_support-d2d0b95b19457c1d.yaml
+releasenotes/notes/bug-1518213-a5bf2ea0d008f329.yaml
+releasenotes/notes/bug-1560649-d4f3ff71fe4ddb89.yaml
+releasenotes/notes/bug-1560867-support-nova-specific-image-7yt6fd1173c4e3wd.yaml
+releasenotes/notes/bug-1570845-efdb0206718f4ca4.yaml
+releasenotes/notes/bug-1587376-fix-manage-resource-quota-issue-78f59f39b9fa4762.yaml
+releasenotes/notes/bug-1612763-report-multiattach-enabled-NetApp-backends-0fbf2cb621e4747d.yaml
+releasenotes/notes/bug-1614095-add-user_id-to-snapshot_show-4884fab825983c3a.yaml
+releasenotes/notes/bug-1615451-NetApp-cDOT-fix-reporting-replication-capability-dca29f39b9fa7651.yaml
+releasenotes/notes/bug-1622057-netapp-cdot-fix-replication-status-cheesecake-volumes-804dc8b0b1380e6b.yaml
+releasenotes/notes/bug-1632333-netapp-ontap-copyoffload-downloads-glance-image-twice-08801d8c7b9eed2c.yaml
+releasenotes/notes/bug-1634203-netapp-cdot-fix-clone-from-nfs-image-cache-2218fb402783bc20.yaml
+releasenotes/notes/bug-1660927-netapp-no-copyoffload-77fc3cf4f2cf2335.yaml
+releasenotes/notes/bug-1667071-dc6407f40a1f7d15.yaml
+releasenotes/notes/bug-1670260-fix-boolean-is_public-d16e1957c0f09d65.yaml
+releasenotes/notes/bug-1671220-4d521be71d0b8aa4.yaml
+releasenotes/notes/bug-1686745-e8f1569455f998ba.yaml
+releasenotes/notes/bug-1690954-40fc21683977e996.yaml
+releasenotes/notes/bug-1691771-fix-netapp-manage-volumes-62bec192a08b3ceb.yaml
+releasenotes/notes/bug-1693084-fix-az-cache-invalid-6td4q74q28uxcd68.yaml
+releasenotes/notes/bug-1699936-fix-host-show-incorrect-fg8698gu7y6r7d15.yaml
+releasenotes/notes/bug-1705375-prohibit-group-deletion-if-groupsnapshot-exists.yaml
+releasenotes/notes/bug-1706888-update-backend-when-extending-3e4a9831a0w29d68.yaml
+releasenotes/notes/bug-1712651-7bc90264eb5001ea.yaml
+releasenotes/notes/bug-1714209-netapp-ontap-drivers-oversubscription-issue-c4655b9c4858d7c6.yaml
+releasenotes/notes/bug-1718739-netapp-eseries-fix-provisioned-capacity-report-8c51fd1173c15dbf.yaml
+releasenotes/notes/bug-1723226-allow-purging-0day-4de8979db7215cf3.yaml
+releasenotes/notes/bug-1730933-1bb0272e3c51eed3.yaml
+releasenotes/notes/bug-1735337-remove-skip-quota-validation-flag-2ecb24143f1f1292.yaml
+releasenotes/notes/bug-1762424-f76af2f37fe408f1.yaml
+releasenotes/notes/bug-1765182-34fdc4bb8482f8a5.yaml
+releasenotes/notes/bug-1765182-bcafd577f4b81eb6.yaml
+releasenotes/notes/bug-1765182-de132ba52167800b.yaml
+releasenotes/notes/bug-1765610-qnap-fix-volume-snapshot-create-fail-2bb785eafdb87fb6.yaml
+releasenotes/notes/bug-1766768-qnap-fix-upload-volume-detach-fail-33cbee59f1381bda.yaml
+releasenotes/notes/bug-1773446-984d76ed29445c9b.yaml
+releasenotes/notes/bug-1773725-xtremio-remove-provisioning-factor-y7r5uy3489yd9pbf.yaml
+releasenotes/notes/bug-1782588-7e058b379da95309.yaml
+releasenotes/notes/bug-1783790-multiattach-none-when-manage-volume-yu7du8yth78i0e6b.yaml
+releasenotes/notes/bug-1784871-7f67402eb13abca7.yaml
+releasenotes/notes/bug-1790141-vmax-powermaxos-upgrade-fix-4c76186cfca66790.yaml
+releasenotes/notes/bug-1799221-fix-truncated-volumes-in-case-of-glance-errors-6cae19218249c3cf.yaml
+releasenotes/notes/bug-1805550-default-policy-file-db15eaa76fefa115.yaml
+releasenotes/notes/bug-1809323-fix-invalid-backup-4a341dc362ded88e.yaml
+releasenotes/notes/bug-1812685-powermax-replication-specs-fix-aa6b13b93b4059d6.yaml
+releasenotes/notes/bug-1813851-60a4f0ffe386d9b6.yaml
+releasenotes/notes/bug-1833115-fix-netapp-ontap-python3-failures-dd869e602f9539e1.yaml
+releasenotes/notes/bug-1860100-8c542363def7d408.yaml
+releasenotes/notes/bug-invalid-content-type-1715094-8yu8i9w425ua08f3.yaml
+releasenotes/notes/bug-reno-69539ecb9b0b5464.yaml
+releasenotes/notes/bugfix-1744692-5aebd0c97ae66407.yaml
+releasenotes/notes/bugfix-netapp-driver-cinder-ipv6-c3c4d0d6a7d0de91.yaml
+releasenotes/notes/capacity-based-qos-9f5d174658a40bd5.yaml
+releasenotes/notes/capacity-based-qos-minimum-values-b24a5f49c986f11d.yaml
+releasenotes/notes/capacity-headroom-4b07701f1df9e5c4.yaml
+releasenotes/notes/castellan-backend-0c49591a54821c45.yaml
+releasenotes/notes/cg-scheduler-change-180a36b77e8cc26b.yaml
+releasenotes/notes/cg_api_volume_type-7db1856776e707c7.yaml
+releasenotes/notes/change-encryption-key-on-clone-3be7cdb0e27386e0.yaml
+releasenotes/notes/check-displayname-displaydescription-123sd5gef91acb12.yaml
+releasenotes/notes/check-snapshots-when-cascade-deleting-transferred-volume-575ef0b76bd7f334.yaml
+releasenotes/notes/cheesecake-promotion-30a3336fb911c3ad.yaml
+releasenotes/notes/cinder-api-microversions-d2082a095c322ce6.yaml
+releasenotes/notes/cinder-api-middleware-remove-deprecated-option-98912ab7e8b472e8.yaml
+releasenotes/notes/cinder-coprhd-driver-11ebd149ea8610fd.yaml
+releasenotes/notes/cinder-manage-db-online-schema-migrations-d1c0d40f26d0f033.yaml
+releasenotes/notes/cinder-manage-online-migrations-exit-status-7c16edb7facc37bb.yaml
+releasenotes/notes/cinder-status-check-backup_driver-fe009985df2bc32f.yaml
+releasenotes/notes/cinder-status-check-policyjson-ef61826eab95372b.yaml
+releasenotes/notes/cinder-status-check-stein_removed_drivers-8184abe8ce82f373.yaml
+releasenotes/notes/cinder-status-check-windows_iscsi_driver-5f4e0b93c7b92f53.yaml
+releasenotes/notes/cloudbyte-retype-support-4b9f79f351465279.yaml
+releasenotes/notes/cluster_job_distribution-f916dd2e4cce6c1b.yaml
+releasenotes/notes/compress-images-fed3e354d94b0845.yaml
+releasenotes/notes/consistency_group_manage-d30a2ad8917a7a86.yaml
+releasenotes/notes/coprhd-generic-volume-group-a1d41d439f94ae19.yaml
+releasenotes/notes/coprhd-mark-unsupported-aa48145873db1ab1.yaml
+releasenotes/notes/coprhd-remove-the-driver-00ef2c41f4c7dccd.yaml
+releasenotes/notes/create-update-rules-b46cf9c07c5a3966.yaml
+releasenotes/notes/create_volume_from_encrypted_image-9666e1ed7b4eab5f.yaml
+releasenotes/notes/datacore-mark-unsupported-2399bc19a789fb4c.yaml
+releasenotes/notes/datera-2.2-driver-update-28b97aa2aaf333b6.yaml
+releasenotes/notes/datera-2.3-driver-update-12d0221fd4bb9fb0.yaml
+releasenotes/notes/datera-2.4.0-driver-update-164bbc77e6b45eb7.yaml
+releasenotes/notes/datera-driver-v2-update-930468e8259c8e86.yaml
+releasenotes/notes/datera-mark-unsupported-7b71d9124b3fded2.yaml
+releasenotes/notes/db-schema-from-kilo-e6e952744531caa2.yaml
+releasenotes/notes/db-schema-from-liberty-f5fa57d67441dece.yaml
+releasenotes/notes/db-schema-from-mitaka-168ac06161e9ca0d.yaml
+releasenotes/notes/db-schema-from-newton-79b18439bd15e4c4.yaml
+releasenotes/notes/db-schema-from-ocata-e1d7dd1dc4d3a0d9.yaml
+releasenotes/notes/db-schema-from-queens-de5025a780ff1d30.yaml
+releasenotes/notes/default-apiv1-disabled-9f6bb0c67b38e670.yaml
+releasenotes/notes/del_volume_with_fc-f024b9f2d6eaca0f.yaml
+releasenotes/notes/delete-volume-metadata-keys-3e19694401e13d00.yaml
+releasenotes/notes/delete-volume-with-snapshots-0b104e212d5d36b1.yaml
+releasenotes/notes/delete_parameters-6f44fece22a7787d.yaml
+releasenotes/notes/dell-emc-sc-api-timeouts-ce8d166e1847ea94.yaml
+releasenotes/notes/dell-emc-sc-bugfix-1756914-ffca3133273040f6.yaml
+releasenotes/notes/dell-emc-sc-mult-attach-d09cfd06ee8db8da.yaml
+releasenotes/notes/dell-emc-sc-support-generic-groups-98c7452d705b36f9.yaml
+releasenotes/notes/dell-emc-unity-driver-72cb901467b23b22.yaml
+releasenotes/notes/deprecate-api-v2-9f4543ab2e14b018.yaml
+releasenotes/notes/deprecate-backends-in-default-b9784a2333fe22f2.yaml
+releasenotes/notes/deprecate-backup-service-to-driver-mapping-a3afabd4f55eca01.yaml
+releasenotes/notes/deprecate-block-device-driver-d30232547a31fe1e.yaml
+releasenotes/notes/deprecate-cinder-linux-smb-driver-4aec58f15a963c54.yaml
+releasenotes/notes/deprecate-consistency-group-apis-0d9120d16f090781.yaml
+releasenotes/notes/deprecate-linbit-drbdmanagedrv-75c41ce8e81cac80.yaml
+releasenotes/notes/deprecate-nested-quota-d1ad7e8f54492a87.yaml
+releasenotes/notes/deprecate-rbd_keyring_conf-432efbcd47e52c8a.yaml
+releasenotes/notes/deprecate-sf-allow-template-caching-b3a1ea32512cbb11.yaml
+releasenotes/notes/deprecate-xml-api-bf3e4079f1dc5eae.yaml
+releasenotes/notes/deprecate_hosts_api_extension-fe0c042af10a20db.yaml
+releasenotes/notes/deprecate_logs_commands-a0d59cb7535a2138.yaml
+releasenotes/notes/deprecate_osapi_volume_base_url-b6984886a902a562.yaml
+releasenotes/notes/deprecate_san_rest_port-0d8610a872e92e09.yaml
+releasenotes/notes/deprecated-ibm-multipath-f06c0e907a6301de.yaml
+releasenotes/notes/deprecated-nas-ip-fd86a734c92f6fae.yaml
+releasenotes/notes/detachedinstanceerror-64be35894c624eae.yaml
+releasenotes/notes/discard-config-option-711a7fbf20685834.yaml
+releasenotes/notes/disco-cinder-driver-9dac5fb04511de1f.yaml
+releasenotes/notes/disco-mark-unsupported-f6eb8208c8c4eb3b.yaml
+releasenotes/notes/disco-options-94fe9eaad5e397a5.yaml
+releasenotes/notes/dothill-drivers-removed-da00a6b83865271a.yaml
+releasenotes/notes/downstream_genconfig-e50791497ce87ce3.yaml
+releasenotes/notes/drbd-linstor-rest-update-52fd52f6c09a4dd3.yaml
+releasenotes/notes/drbd-linstor-volume-driver-20273a9ad3783cf5.yaml
+releasenotes/notes/drbd-resource-options-88599c0a8fc5b8a3.yaml
+releasenotes/notes/driver_reinitialization-b26a8b3e665567ec.yaml
+releasenotes/notes/drop-py2-377a91a5b66165ab.yaml
+releasenotes/notes/ds8k-allow-multi-attach-41fa7bddbbd719ec.yaml
+releasenotes/notes/ds8k-replication-group-3f2e8cd3c2e291a3.yaml
+releasenotes/notes/ds8k-report-backend-state-in-service-list-f0898950a0f4b122.yaml
+releasenotes/notes/ds8k_async_clone_volume-25232c55da921202.yaml
+releasenotes/notes/ds8k_specify_pool_lss-5329489c263951ba.yaml
+releasenotes/notes/enable-force-delete-lun-d0e05b5d669e40f7.yaml
+releasenotes/notes/enable-multiattach-iscsi-fcp-netapp-driver-98ad2d75fbbf333f.yaml
+releasenotes/notes/enable-multiattach-nfs-netapp-driver-406b9b285d85c989.yaml
+releasenotes/notes/enforce_min_vmware-a080055111b04692.yaml
+releasenotes/notes/fail-detach-lun-when-auto-zone-enabled-9c87b18a3acac9d1.yaml
+releasenotes/notes/falconstor-cinder-driver-dcb61441cd7601c5.yaml
+releasenotes/notes/falconstor-extend-driver-to-utilize-multiple-fss-pools-dc6f2bc84432a672.yaml
+releasenotes/notes/feature-abort-restore-fe1252288c59e105.yaml
+releasenotes/notes/feature-cross-az-backups-6b68c4c4456f2fd7.yaml
+releasenotes/notes/feature-multi-process-backup-8cf5ad5a0cf9b2d5.yaml
+releasenotes/notes/feature-rbd-exclusive-pool-a9bdebdeb1f0bf37.yaml
+releasenotes/notes/fix-abort-backup-df196e9dcb992586.yaml
+releasenotes/notes/fix-backup-handling-of-encryption-key-id-f2fa56cadd80d582.yaml
+releasenotes/notes/fix-cross-az-migration-ce97eff61280e1c7.yaml
+releasenotes/notes/fix-extend-volume-939e30f2e9e516bc.yaml
+releasenotes/notes/fix-extend-volume-in-thin-pools-57a3d53be4d47704.yaml
+releasenotes/notes/fix-hnas-clone-with-different-volume-type-b969897cba2610cc.yaml
+releasenotes/notes/fix-hnas-stats-reporting-1335e582e46ff440.yaml
+releasenotes/notes/fix-import-backup-quota-issue-8yh69hd19u7tuu23.yaml
+releasenotes/notes/fix-multiattach-deletion-b3990acf1f5fd378.yaml
+releasenotes/notes/fix-netapp-cg-da4fd6c396e5bedb.yaml
+releasenotes/notes/fix-netapp-force_detach-36bdf75dd2c9a030.yaml
+releasenotes/notes/fix-quota-deleting-temporary-volume-274e371b425e92cc.yaml
+releasenotes/notes/fix-remotefs-clone-volume-locking-385e740d4a5a813b.yaml
+releasenotes/notes/fix-reserve-volume-policy-31790a8d865ee0a1.yaml
+releasenotes/notes/fix-solidfire-provisioning-report-880141e64c1ea52f.yaml
+releasenotes/notes/fix-solidfire-python3-support-ee02ff2c1ec920f2.yaml
+releasenotes/notes/fix-solidfire-replication-dcb3e59b29950933.yaml
+releasenotes/notes/fix-vol-image-metadata-endpoints-returning-none-ba0590e6c6757b0c.yaml
+releasenotes/notes/force-delete-mv-a53924f09c475386.yaml
+releasenotes/notes/friendly-zone-names-d5e131d356040de0.yaml
+releasenotes/notes/fujitsu-eternus-dx-fc-741319960195215c.yaml
+releasenotes/notes/fujitsu-eternus-dx-iscsi-e796beffb740db89.yaml
+releasenotes/notes/fujitsu-eternus-dx-update-4755ec446030d263.yaml
+releasenotes/notes/fujitsu-multiple-pools-a0dd9197b16b3122.yaml
+releasenotes/notes/fusionstorage-cinder-driver-8f3bca98f6e2065a.yaml
+releasenotes/notes/fusionstorage-driver-cf13b8d95ae97319.yaml
+releasenotes/notes/general-upgrades-notes-120f022aa5bfa1ea.yaml
+releasenotes/notes/generalized-resource-filter-hg598uyvuh119008.yaml
+releasenotes/notes/generic-group-quota-manage-support-559629ad07a406f4.yaml
+releasenotes/notes/generic-groups-in-gpfs-00bb093945a02642.yaml
+releasenotes/notes/generic-groups-in-vnx-cbbe1346e889b5c2.yaml
+releasenotes/notes/generic-volume-groups-69f998ce44f42737.yaml
+releasenotes/notes/glance-v1-removed-5121af3bef285324.yaml
+releasenotes/notes/glance_v2_upload-939c5693bcc25483.yaml
+releasenotes/notes/google-auth-for-gcs-backup-1642cd0e741fbdf9.yaml
+releasenotes/notes/group-snapshots-36264409bbb8850c.yaml
+releasenotes/notes/group-type-group-specs-531e33ee0ae9f822.yaml
+releasenotes/notes/group-update-d423eaa18dbcecc1.yaml
+releasenotes/notes/hbsd-driver-deletion-d81f7c4513f45d7b.yaml
+releasenotes/notes/hedvig-cinder-driver-e7b98f4bc214bc49.yaml
+releasenotes/notes/hgst-mark-unsupported-b2886de36421c8b0.yaml
+releasenotes/notes/hitachi-unsupported-drivers-37601e5bfabcdb8f.yaml
+releasenotes/notes/hitachi-vsp-driver-87659bb496bb459b.yaml
+releasenotes/notes/hitachi-vsp-iscsi-driver-cac31d7c54d7718d.yaml
+releasenotes/notes/hitachi-vsp-ports-option-7147289e6529d7fe.yaml
+releasenotes/notes/hnas-change-snapshot-names-8153b043eb7e99fc.yaml
+releasenotes/notes/hnas-deprecate-iscsi-driver-cd521b3a2ba948f3.yaml
+releasenotes/notes/hnas-deprecate-nfs-driver-0d114bbe141b5d90.yaml
+releasenotes/notes/hnas-deprecated-svc-volume-type-77768f27946aadf4.yaml
+releasenotes/notes/hnas-drivers-refactoring-9dbe297ffecced21.yaml
+releasenotes/notes/hnas-list-manageable-9329866618fa9a9c.yaml
+releasenotes/notes/hnas-manage-unmanage-snapshot-support-40c8888cc594a7be.yaml
+releasenotes/notes/hnas-remove-iscsi-driver-419e9c08133f9f0a.yaml
+releasenotes/notes/hnas_deprecate_xml-16840b5a8c25d15e.yaml
+releasenotes/notes/hpe-3par-peer-persistence.yaml-91cc84bf89dbb462.yaml
+releasenotes/notes/hpe-3par-pp-rcg-policy-options-53271f38c315779f.yaml
+releasenotes/notes/hpe-3par-specify-nsp-for-fc-bootable-volume-f372879e1b625b4d.yaml
+releasenotes/notes/hpe3par-replication-group-a18a28d18de09e95.yaml
+releasenotes/notes/hpe_3par_multiattach-bf98a9e5c2208902.yaml
+releasenotes/notes/hpelh-deprecations-eb7716a0b02f145e.yaml
+releasenotes/notes/hpmsa-driver-updates-train-4fcbe71f3e2bb2da.yaml
+releasenotes/notes/huawei-backend-capabilities-report-optimization-d1c18d9f62ef71aa.yaml
+releasenotes/notes/huawei-fusionstorage-driver-readd-70fecc39eeaa0f5f.yaml
+releasenotes/notes/huawei-fusionstorage-unsupported-4be766dd2ba8f980.yaml
+releasenotes/notes/huawei-generic-group-bc3fb7236efc58e7.yaml
+releasenotes/notes/huawei-iscsi-multipath-support-a056201883909287.yaml
+releasenotes/notes/huawei-manage-unmanage-snapshot-e35ff844d72fedfb.yaml
+releasenotes/notes/huawei-pool-disktype-support-7c1f64639b42a48a.yaml
+releasenotes/notes/huawei-support-iscsi-configuration-in-replication-7ec53737b95ffa54.yaml
+releasenotes/notes/huawei-support-manage-volume-2a746cd05621423d.yaml
+releasenotes/notes/hybrid-aggregates-in-netapp-cdot-drivers-f6afa9884cac4e86.yaml
+releasenotes/notes/ibm-flashsystem-manage-unmanage-88e56837102f838c.yaml
+releasenotes/notes/ibm-flashsystem-unsupported-28f9aaf11b56fb2f.yaml
+releasenotes/notes/ibm-gpfs-unsupported-b95274829573835d.yaml
+releasenotes/notes/ibm-storage-supported-a373a54777333929.yaml
+releasenotes/notes/ibm-storage-unsupported-9e8ea6ce9cea503d.yaml
+releasenotes/notes/ibm-storwize-supported-6518628fb78d58a4.yaml
+releasenotes/notes/ibm-storwize-unsupported-e79cfd27523f013c.yaml
+releasenotes/notes/ibm-storwzie-mirror-volume-ffe4c9bde78cdf1d.yaml
+releasenotes/notes/ibmsvciogrpselection-e607739b6f655a27.yaml
+releasenotes/notes/iet-deprecation-f8059417c6adbb78.yaml
+releasenotes/notes/image-volume-type-c91b7cff3cb41c13.yaml
+releasenotes/notes/improve-volume-transfer-records-5599e82ade4d302c.yaml
+releasenotes/notes/improvement-to-get-group-detail-0e8b68114e79a8a2.yaml
+releasenotes/notes/improvement-to-query-consistency-group-detail-84a906d45383e067.yaml
+releasenotes/notes/infinidat-add-infinibox-driver-67cc33fc3fbff1bb.yaml
+releasenotes/notes/infinidat-compression-a828904aaba90da2.yaml
+releasenotes/notes/infinidat-group-support-44cd0715de1ea502.yaml
+releasenotes/notes/infinidat-infinisdk-04f0edc0d0a597e3.yaml
+releasenotes/notes/infinidat-iscsi-support-78e0d34d9e7e08c4.yaml
+releasenotes/notes/infinidat-max-osr-2d9fd2d0f9424657.yaml
+releasenotes/notes/infinidat-multi-attach-support-533b3e559c15801f.yaml
+releasenotes/notes/infinidat-qos-50d743591543db98.yaml
+releasenotes/notes/inspur-as13000-cinder-driver-bfa5cc17683d87a9.yaml
+releasenotes/notes/inspur-instorage-fc-cinder-driver-70c13e4a64d785d5.yaml
+releasenotes/notes/itri-disco-driver-removal-11e14fbf431ea876.yaml
+releasenotes/notes/json-schema-validation-0d22576bd556f4e0.yaml
+releasenotes/notes/k2-disable-discovery-bca0d65b5672ec7b.yaml
+releasenotes/notes/k2-non-unique-fqdns-b62a269a26fd53d5.yaml
+releasenotes/notes/kaminario-cinder-driver-bug-1646692-7aad3b7496689aa7.yaml
+releasenotes/notes/kaminario-cinder-driver-bug-1646766-fe810f5801d24f2f.yaml
+releasenotes/notes/kaminario-cinder-driver-bug-44c728f026394a85.yaml
+releasenotes/notes/kaminario-cinder-driver-remove-deprecate-option-831920f4d25e2979.yaml
+releasenotes/notes/kaminario-fc-cinder-driver-8266641036281a44.yaml
+releasenotes/notes/kaminario-iscsi-cinder-driver-c34fadf63cd253de.yaml
+releasenotes/notes/lefthand-consistency-groups-d73f8e418884fcc6.yaml
+releasenotes/notes/lefthand-manage-unmanage-snapshot-04de39d268d51169.yaml
+releasenotes/notes/lenovo-driver-updates-train-f2ff96ca4a2885db.yaml
+releasenotes/notes/leverage-compression-accelerator-579c7032290cd1e9.yaml
+releasenotes/notes/list-manageable-86c77fc39c5b2cc9.yaml
+releasenotes/notes/live_migration_v3-ae98c0d00e64c954.yaml
+releasenotes/notes/lvm-ipv6-fix-e8d418726c92bbd5.yaml
+releasenotes/notes/lvm-thin-overprovision-1d279f66ee2252ff.yaml
+releasenotes/notes/lvm-type-default-to-auto-a2ad554fc8bb25f2.yaml
+releasenotes/notes/macrosan_driver_unsupported-b25f7a3b8270fa61.yaml
+releasenotes/notes/manage-resources-v3-c06096f75927fd3b.yaml
+releasenotes/notes/mark-blockbridge-unsupported-c9e55df0eb2e3c9f.yaml
+releasenotes/notes/mark-brocade-unsupported-d5760b4bb8173652.yaml
+releasenotes/notes/mark-cisco-zm-unsupported-57e5612f57e2407b.yaml
+releasenotes/notes/mark-cloudbyte-unsupported-8615a127439ed262.yaml
+releasenotes/notes/mark-coho-unsupported-989db9d88ed7fff8.yaml
+releasenotes/notes/mark-dothill-unsupported-7f95115b7b24e53c.yaml
+releasenotes/notes/mark-falconstor-unsupported-3b065556a4cd94de.yaml
+releasenotes/notes/mark-hpe-xp-unsupported-c9ce6cfbab622e46.yaml
+releasenotes/notes/mark-infortrend-deprecated-553de89f8dd58aa8.yaml
+releasenotes/notes/mark-nexenta-edge-unsupported-76c500738f0b3c61.yaml
+releasenotes/notes/mark-nexentaedge-unsupported-56d184fdccc6eaac.yaml
+releasenotes/notes/mark-nimble-deprecated-9f7d1c178b48fa39.yaml
+releasenotes/notes/mark-qnap-unsupported-79bd8ece9a2bfcd2.yaml
+releasenotes/notes/mark-reduxio-deprecated-b435032a8fdb16f2.yaml
+releasenotes/notes/mark-scality-unsupported-530370e034a6f488.yaml
+releasenotes/notes/mark-synology-deprecated-134ba9764e14af67.yaml
+releasenotes/notes/mark-tegile-deprecated-1effb23010ea997c.yaml
+releasenotes/notes/mark-unsupported-lefthand-312f8c34df6ed119.yaml
+releasenotes/notes/mark-unsupported-tintri-driver-a71b09b7c001c75e.yaml
+releasenotes/notes/mark-unsupported-vrtshyperscale-2bd42e2af8b803d7.yaml
+releasenotes/notes/mark-violin-unsupported-fdf6b34cf9847359.yaml
+releasenotes/notes/mark-xio-deprecated-18c914e15695d793.yaml
+releasenotes/notes/mark-zte-unsupported-3c048e419264eca2.yaml
+releasenotes/notes/metadata-for-volume-summary-729ba648db4e4e54.yaml
+releasenotes/notes/migrate-backup-encryption-keys-to-barbican-6f07fd48d4937b2a.yaml
+releasenotes/notes/migrate-cg-to-generic-volume-groups-f82ad3658f3e567c.yaml
+releasenotes/notes/migrate-fixed-key-to-barbican-91dfcb829efd4bb6.yaml
+releasenotes/notes/minimum-u4p-version-4c66d69d1b873796.yaml
+releasenotes/notes/modify-ensure-export-1d56a40f5e762aa8.yaml
+releasenotes/notes/move-scaleio-driver-to-dell-emc-dir-c195374ca6b7e98d.yaml
+releasenotes/notes/move-xtremio-driver-to-dell-emc-dir-f7e07a502cafd78f.yaml
+releasenotes/notes/msa-multiattach-5407eb60093de8f1.yaml
+releasenotes/notes/multiple_clone-82bd7f80ae439080.yaml
+releasenotes/notes/nec-allow-more-than-4iSCSI-portals-8342defe64491f81.yaml
+releasenotes/notes/nec-auto-accesscontrol-55f4b090e8128f5e.yaml
+releasenotes/notes/nec-delete-unused-parameter-367bc9447acbb03e.yaml
+releasenotes/notes/nec-delete-volume-per-limit-d10b9df86f64b80e.yaml
+releasenotes/notes/nec-manage-unmanage-06f9beb3004fc227.yaml
+releasenotes/notes/nec-nondisruptive-backup-471284d07cd806ce.yaml
+releasenotes/notes/nec-storage-assist-revert-to-sanpshot-58cddebfbf06d222.yaml
+releasenotes/notes/nec-support-multi-attach-8aae5100f513656c.yaml
+releasenotes/notes/nec_storage_volume_driver-57663f9ecce1ae19.yaml
+releasenotes/notes/netapp-add-generic-group-support-cdot-9bebd13356694e13.yaml
+releasenotes/notes/netapp-cDOT-whole-backend-replication-support-59d7537fe3d0eb05.yaml
+releasenotes/notes/netapp-chap-iscsi-auth-264cd942b2a76094.yaml
+releasenotes/notes/netapp-data-ontap-deprecate-7mode-drivers-a39bfcb3afefc9a5.yaml
+releasenotes/notes/netapp-deprecate-eseries-drivers-bc4f552d277c07b9.yaml
+releasenotes/notes/netapp-eseries-consistency-groups-4f6b2af2d20c94e9.yaml
+releasenotes/notes/netapp-log-filter-f3256f55c3ac3faa.yaml
+releasenotes/notes/netapp-nfs-consistency-group-support-83eccc2da91ee19b.yaml
+releasenotes/notes/netapp-non-discovery-19af4e10f7b190ea.yaml
+releasenotes/notes/netapp-ontap-fix-force-detach-55be3f4ac962b493.yaml
+releasenotes/notes/netapp-ontap-use_exact_size-d03c90efbb8a30ac.yaml
+releasenotes/notes/netapp-solidfire-add-replication-mode-eb26535d0ec78cb4.yaml
+releasenotes/notes/netapp-solidfire-stats-improving-57207f313d7faf42.yaml
+releasenotes/notes/netapp_cdot_report_shared_blocks_exhaustion-073a73e05daf09d4.yaml
+releasenotes/notes/netapp_fix_svm_scoped_permissions.yaml
+releasenotes/notes/new-config-opts-for-periodic_interval-d0cb17a2d72e0cd0.yaml
+releasenotes/notes/new-nova-config-section-2a7a51a0572e7064.yaml
+releasenotes/notes/new-osprofiler-call-0bb1a305c8e8f9cc.yaml
+releasenotes/notes/nexenta-edge-driver-removal-5626d542d75f3d43.yaml
+releasenotes/notes/nexenta-edge-iscsi-b3f12c7a719e8b8c.yaml
+releasenotes/notes/nexenta-ns5-5d223f3b60f58aad.yaml
+releasenotes/notes/nexentaedge-iscsi-driver-302529c56cdbbf38.yaml
+releasenotes/notes/nexentaedge-iscsi-ee5d6c05d65f97af.yaml
+releasenotes/notes/nexentaedge-nbd-eb48268723141f12.yaml
+releasenotes/notes/nexentastor5-driver-update-937d2a1ba76a504a.yaml
+releasenotes/notes/nexentastor5-https-6d58004838cfab30.yaml
+releasenotes/notes/nexentastor5-smartcompression-disabled-9c6ca7c758b6de69.yaml
+releasenotes/notes/nexentastor5_iscsi-e1d88b07d15c660b.yaml
+releasenotes/notes/nexentastor5_nfs-bcc8848716daea63.yaml
+releasenotes/notes/nfs-snapshots-21b641300341cba1.yaml
+releasenotes/notes/nfs_backup_no_overwrite-be7b545453baf7a3.yaml
+releasenotes/notes/nimble-add-fc-support-0007fdbd647be947.yaml
+releasenotes/notes/nimble-add-force-backup-539e1e5c72f84e61.yaml
+releasenotes/notes/nimble-driver-removal-ff80d077e7707614.yaml
+releasenotes/notes/nimble-manage-unmanage-1d6d5fc23cbe59a1.yaml
+releasenotes/notes/nimble-mark-usnsupported-0c8e5e21c8d1179d.yaml
+releasenotes/notes/nimble-qos-specs-8cd006777c66a64e.yaml
+releasenotes/notes/nimble-rest-api-support-75c2324ee462d026.yaml
+releasenotes/notes/nimble-retype-support-18f717072948ba6d.yaml
+releasenotes/notes/online-migration-checks-64b0d1732901e78e.yaml
+releasenotes/notes/operate-migrated-groups-with-cp-apis-e5835c6673191805.yaml
+releasenotes/notes/oracle-zfssa-unsupported-4ce035213fa0e097.yaml
+releasenotes/notes/orphaned_unmanaged_volume-db63ec0509b70b8f.yaml
+releasenotes/notes/os-brick-lock-dir-35bdd8ec0c0ef46d.yaml
+releasenotes/notes/per-backend-az-28727aca360a1cc8.yaml
+releasenotes/notes/period-task-clean-reservation-0e0617a7905df923.yaml
+releasenotes/notes/permit_volume_type_operations-b2e130fd7088f335.yaml
+releasenotes/notes/policy-for-type-list-and-show-apis-rt56uy78crt5e378.yaml
+releasenotes/notes/policy-in-code-226f71562ab28195.yaml
+releasenotes/notes/powermax-90-to-91-endpoints-a92c4d158cb63fe4.yaml
+releasenotes/notes/powermax-bug-1853589-f6c7164177da0496.yaml
+releasenotes/notes/powermax-disable-inuse-metro-89e9f398ec9e2672.yaml
+releasenotes/notes/powermax-inuse-retype-support-64bd35adab17420d.yaml
+releasenotes/notes/powermax-ode-metro-support-ed50bb20f932548b.yaml
+releasenotes/notes/powermax-snapvx-link-mode-0050ac6b4a16c739.yaml
+releasenotes/notes/powermax-srdf-enhancement-56b0a2817c4d310d.yaml
+releasenotes/notes/powermax-storage-group-tagging-d2281e9b35994bec.yaml
+releasenotes/notes/powermax-tdev-deallocation-90bda0f95ab0b271.yaml
+releasenotes/notes/powermax-train-tag-removal-1dfa77df7440e5f5.yaml
+releasenotes/notes/powermax-user-defined-hostname-portgroup-0b01aaaa730dfaaf.yaml
+releasenotes/notes/powermax-vol-metadata-acd2555818d25b72.yaml
+releasenotes/notes/privsep-rocky-35bdfe70ed62a826.yaml
+releasenotes/notes/prophetstor-driver-removal-f6b9911d1f84b48f.yaml
+releasenotes/notes/prophetstor-generic-groups-c7136c32b2f75c0a.yaml
+releasenotes/notes/ps-removedriver-5ba447c50f2474e7.yaml
+releasenotes/notes/pure-active-cluster-edf8e7e80739b0f8.yaml
+releasenotes/notes/pure-configure-pg-pod-names-525a4ce8e2f46b69.yaml
+releasenotes/notes/pure-custom-user-agent-dcca4cb44b69e763.yaml
+releasenotes/notes/pure-default-replica-interval-07de0a56f61c7c1e.yaml
+releasenotes/notes/pure-enhanced-stats-42a684fe4546d1b1.yaml
+releasenotes/notes/pure-eradicate-on-delete-1e15e1440d5cd4d6.yaml
+releasenotes/notes/pure-fc-wwpn-case-c1d97f3fa7663acf.yaml
+releasenotes/notes/pure-generic-volume-groups-2b0941103f7c01cb.yaml
+releasenotes/notes/pure-host-personality-3512f7ccd961d4ad.yaml
+releasenotes/notes/pure-iscsi-cidr-cbc1afb3850a9217.yaml
+releasenotes/notes/pure-list-mangeable-fed4a1b23212f545.yaml
+releasenotes/notes/pure-storage-multiattach-support-994da363e181d627.yaml
+releasenotes/notes/pure-v2.1-replication-0246223caaa8a9b5.yaml
+releasenotes/notes/pure-verify-https-requests-464320c97ba77a1f.yaml
+releasenotes/notes/qb-backup-5b1f2161d160648a.yaml
+releasenotes/notes/qb-overlay-from-snap-cache-dc102acb4820e368.yaml
+releasenotes/notes/qb-switch-nas-sec-opts-635c6ef1205e4f3f.yaml
+releasenotes/notes/qnap-enhance-support-4ab5cbb110b3303b.yaml
+releasenotes/notes/qnap-support-qes-200-2a3dda49afe14103.yaml
+releasenotes/notes/qnap-support-qes-210-de75892f684cb9c3.yaml
+releasenotes/notes/qnap-support-qts-440-c482f109694cb77f.yaml
+releasenotes/notes/qnap-tds-support-qes-5e5d766cded3a26d.yaml
+releasenotes/notes/queens-driver-removal-72a1a36689b6d890.yaml
+releasenotes/notes/quobyte_vol-snap-cache-baf607f14d916ec7.yaml
+releasenotes/notes/quota-volume-transfer-abd1f418c6c63db0.yaml
+releasenotes/notes/rbd-active-active-replication-b230367912fe4a23.yaml
+releasenotes/notes/rbd-driver-assisted-migration-2d29788243060f77.yaml
+releasenotes/notes/rbd-multiattach-exceptions-43066312f3b527f5.yaml
+releasenotes/notes/rbd-multiattach-support-2900ce0245af0239.yaml
+releasenotes/notes/rbd-stats-report-0c7e803bb0b1aedb.yaml
+releasenotes/notes/rbd-support-list-manageable-snapshots-3474c62ed83fb788.yaml
+releasenotes/notes/rbd-support-list-manageable-volumes-8a088a44e01d227f.yaml
+releasenotes/notes/rbd-support-managing-existing-snapshot-fb871a3ea98dc572.yaml
+releasenotes/notes/rbd-support-report-backend-state-4e124eb9efd36724.yaml
+releasenotes/notes/rbd-thin-provisioning-c98522d6fe7b71ff.yaml
+releasenotes/notes/rbd-v2.1-replication-64a9d0bec5987faf.yaml
+releasenotes/notes/rbd_replication_add_secret_uuid_config-c74d65e6d3d610c6.yaml
+releasenotes/notes/re-add-nexenta-driver-d3af97e33551a485.yaml
+releasenotes/notes/readd-infortrend-driver-d9b399b53a4355f8.yaml
+releasenotes/notes/readd-qnap-driver-e1dc6b0c3fabe30e.yaml
+releasenotes/notes/rebranded-hpe-drivers-caf1dcef1afe37ba.yaml
+releasenotes/notes/rebranded-vnx-driver-2fb7424ddc9c41df.yaml
+releasenotes/notes/redundancy-in-volume-url-4282087232e6e6f1.yaml
+releasenotes/notes/reduxio-iscsci-driver-5827c32a0c498949.yaml
+releasenotes/notes/refactor-disco-volume-driver-3ff0145707ec0f3e.yaml
+releasenotes/notes/reject-volume_clear_size-settings-larger-than-1024MiB-30b38811da048948.yaml
+releasenotes/notes/remove-backup-service-to-driver-mapping-4d2ed6f868a64175.yaml
+releasenotes/notes/remove-block-device-driver-14f76dca2ee9bd38.yaml
+releasenotes/notes/remove-cinder-manage-logs-cmds-40fb8f475b37fb2f.yaml
+releasenotes/notes/remove-datacore-300c667e9f504590.yaml
+releasenotes/notes/remove-deprecated-driver-mappings-b927d8ef9fc3b713.yaml
+releasenotes/notes/remove-deprecated-keymgr-d11a25c620862ed6.yaml
+releasenotes/notes/remove-deprecated-nova-opts-b1ec66fe3a9bb3b9.yaml
+releasenotes/notes/remove-deprecated-option-9ad954726ed4d8c2.yaml
+releasenotes/notes/remove-drbdmanage-driver-4edd1e1e43b6ba39.yaml
+releasenotes/notes/remove-flashsystem-multipath-0a3ee133ebe35d1e.yaml
+releasenotes/notes/remove-hgst-flash-driver-a930927de333329a.yaml
+releasenotes/notes/remove-hitachi-57d0b37cb9cc7e13.yaml
+releasenotes/notes/remove-hp-cliq-41f47fd61e47d13f.yaml
+releasenotes/notes/remove-hp3par-config-options-3cf0d865beff9018.yaml
+releasenotes/notes/remove-ibm-nas-driver-0ed204ed0a2dcf55.yaml
+releasenotes/notes/remove-iscsi-target-config-options-d23e424eb8f82042.yaml
+releasenotes/notes/remove-lvm-over-sub-3c8addbf47827045.yaml
+releasenotes/notes/remove-mirrorpolicy-parameter-from-huawei-driver-d32257a60d32fd90.yaml
+releasenotes/notes/remove-nas-ip-config-option-8d56c14f1f4614fc.yaml
+releasenotes/notes/remove-netapp-teseries-thost-type-config-option-908941dc7d2a1d59.yaml
+releasenotes/notes/remove-pybasedir-config-option-572604d26a57ba5e.yaml
+releasenotes/notes/remove-query-volume-filters-b59958fc68d3abb4.yaml
+releasenotes/notes/remove-scality-fa209aae9748a1f3.yaml
+releasenotes/notes/remove-single-backend-7bf02e525bbbdd3a.yaml
+releasenotes/notes/remove-vol-in-error-from-cg-1ed0fde04ab2b5be.yaml
+releasenotes/notes/remove-volume-clear-shred-bde9f7f9ff430feb.yaml
+releasenotes/notes/remove-windows-mapping-51a004f466470a2b.yaml
+releasenotes/notes/remove-xml-api-392b41f387e60eb1.yaml
+releasenotes/notes/remove_deprecated_xml-4065b893d781f65c.yaml
+releasenotes/notes/remove_eseries-bb1bc134645aee50.yaml
+releasenotes/notes/remove_glusterfs_volume_driver-d8fd2cf5f38e754b.yaml
+releasenotes/notes/remove_lvmdriver-9c35f83132cd2ac8.yaml
+releasenotes/notes/remove_osapi_volume_base_url-33fed24c4ad1b2b6.yaml
+releasenotes/notes/remove_service_filter-380e7990bfdbddc8.yaml
+releasenotes/notes/remove_storwize_npiv-b704ff2d97207666.yaml
+releasenotes/notes/remove_veritas_hyperscale_driver-988ad62d2417124f.yaml
+releasenotes/notes/remove_volume_tmp_dir_option-c83c5341e5a42378.yaml
+releasenotes/notes/removed-apiv1-616b1b76a15521cf.yaml
+releasenotes/notes/removed-isertgtadm-7ccefab5d3e89c59.yaml
+releasenotes/notes/removed-rpc-topic-config-options-21c2b3f0e64f884c.yaml
+releasenotes/notes/removed-scality-7151638fdac3ed9d.yaml
+releasenotes/notes/removing-cinder-all-9f5c3d1eb230f9e6.yaml
+releasenotes/notes/removing-middleware-sizelimit-ba86907acbda83de.yaml
+releasenotes/notes/rename-backup-driver-status-check-interval-option-6b27c1e29cb863e9.yaml
+releasenotes/notes/rename-huawei-driver-092025e46b65cd48.yaml
+releasenotes/notes/rename-iscsi-target-config-options-24913d7452c4a58e.yaml
+releasenotes/notes/rename-windows-iscsi-a7b0ca62a48c1371.yaml
+releasenotes/notes/rename_xiv_ds8k_to_ibm_storage-154eca69c44b3f95.yaml
+releasenotes/notes/replication-group-7c6c8a153460ca58.yaml
+releasenotes/notes/replication-v2.1-3par-b3f780a109f9195c.yaml
+releasenotes/notes/replication-v2.1-lefthand-745b72b64e5944c3.yaml
+releasenotes/notes/replication-v2.1-storwize-2df7bfd8c253090b.yaml
+releasenotes/notes/report-backend-state-in-service-list-1e4ee5a2c623671e.yaml
+releasenotes/notes/report-backend-state-in-service-list-739a5398eec4a6b7.yaml
+releasenotes/notes/report-backend-state-in-service-list-93e9f2b204b735c0.yaml
+releasenotes/notes/retype-encrypted-volume-49b66d3e8e65f9a5.yaml
+releasenotes/notes/revert-volume-to-snapshot-6aa0dffb010265e5.yaml
+releasenotes/notes/rpc-apis-3.0-b745f429c11d8198.yaml
+releasenotes/notes/rpc-update-50bef83f48d4f96f.yaml
+releasenotes/notes/rpc_compatibility-375be8ac3158981d.yaml
+releasenotes/notes/rsd-cinder-driver-d71b88292536bfea.yaml
+releasenotes/notes/sc-handle-multiattach-onterminate-6ab1f96f21bb284d.yaml
+releasenotes/notes/scaleio-backup-via-snapshot-8e75aa3f4570e17c.yaml
+releasenotes/notes/scaleio-consistency-groups-707f9b4ffcb3c14c.yaml
+releasenotes/notes/scaleio-default-volume-provisioning-c648118fcc8f297f.yaml
+releasenotes/notes/scaleio-deprecate-1.32-32033134fec181bb.yaml
+releasenotes/notes/scaleio-deprecate-config-1aa300d0c78ac81c.yaml
+releasenotes/notes/scaleio-enable-multiattach-e7d84ffa282842e9.yaml
+releasenotes/notes/scaleio-generic-volume-group-ee36e4dba8893422.yaml
+releasenotes/notes/scaleio-get-manageable-volumes-dda1e7b8e22be59e.yaml
+releasenotes/notes/scaleio-manage-existing-32217f6d1c295193.yaml
+releasenotes/notes/scaleio-manage-existing-snapshot-5bbd1818654c0776.yaml
+releasenotes/notes/scaleio-qos-support-2ba20be58150f251.yaml
+releasenotes/notes/scaleio-rebranding-d2d113c5d8e5c118.yaml
+releasenotes/notes/scaleio-remove-force-delete-config-48fae029e3622d6d.yaml
+releasenotes/notes/scaleio-scaling-qos-50c58e43d4b54247.yaml
+releasenotes/notes/scaleio-thin-provisioning-support-9c3b9203567771dd.yaml
+releasenotes/notes/scaleio-vxflexos-rebrand-27dfe2b82d35b6a2.yaml
+releasenotes/notes/scaleio-zeropadding-a0273c56c4d14fca.yaml
+releasenotes/notes/scaling-backup-service-7e5058802d2fb3dc.yaml
+releasenotes/notes/seagate-new-driver-d420fad549e9045f.yaml
+releasenotes/notes/service_dynamic_log_change-55147d288be903f1.yaml
+releasenotes/notes/shared-backend-config-d841b806354ad5be.yaml
+releasenotes/notes/sheepdog-driver-removal-b63d12460e886c33.yaml
+releasenotes/notes/sheepdog-mark-unsupported-648b2458d4a198de.yaml
+releasenotes/notes/show-provider-id-for-admin-ff4fd5a2518a4bfa.yaml
+releasenotes/notes/slug-qnap-driver-d4465ea6009c66df.yaml
+releasenotes/notes/smbfs-drop-alloc-data-file-8b94da952a3b1548.yaml
+releasenotes/notes/smbfs-fixed-image-9b642b63fcb79c18.yaml
+releasenotes/notes/smbfs-manage-unmanage-f1502781dd5f82cb.yaml
+releasenotes/notes/smbfs-pools-support-bc43c653cfb1a34f.yaml
+releasenotes/notes/smbfs-removed-options-2c86101340273252.yaml
+releasenotes/notes/smbfs-revert-snapshot-5b265ed5ded951dc.yaml
+releasenotes/notes/smbfs-snapshot-attach-14742fe8f5864ac6.yaml
+releasenotes/notes/snapshot_backing_up_status_support-164fbbb2a564e137.yaml
+releasenotes/notes/solidfire-scaled-qos-9b8632453909e2db.yaml
+releasenotes/notes/solidfire-v2.1-replication-570a1f12f70e67b4.yaml
+releasenotes/notes/spdk-add-config-parameter-39a880ec22956fd2.yaml
+releasenotes/notes/spdk-nvmf-target-31e4d4dd5e2f2114.yaml
+releasenotes/notes/spdk-volume-081f6e72396b30e8.yaml
+releasenotes/notes/split-out-nested-quota-driver-e9493f478d2b8be5.yaml
+releasenotes/notes/ssl-cert-fix-42e8f263c15d5343.yaml
+releasenotes/notes/storpool-multiattach-f9b7edccd4db7e02.yaml
+releasenotes/notes/storpool-volume-driver-4d5f16ad9c2f373a.yaml
+releasenotes/notes/storwize-backup-snapshot-support-728e18dfa0d42943.yaml
+releasenotes/notes/storwize-cg-replication-b038ff0d39fe909f.yaml
+releasenotes/notes/storwize-disable-create-volume-with-non-cgsnap-group-6cba8073e3d6cadd.yaml
+releasenotes/notes/storwize-dr-pool-support-52db3a95e54aef88.yaml
+releasenotes/notes/storwize-generic-volume-group-74495fa23e059bf9.yaml
+releasenotes/notes/storwize-gmcv-support-8aceee3f40eddb9f.yaml
+releasenotes/notes/storwize-hyperswap-host-site-update-621e763768fab9ee.yaml
+releasenotes/notes/storwize-hyperswap-support-b830182e1058cb4f.yaml
+releasenotes/notes/storwize-multiple-management-ip-1cd364d63879d9b8.yaml
+releasenotes/notes/storwize-pool-aware-support-7a40c9934642b202.yaml
+releasenotes/notes/storwize-revert-snapshot-681c76d68676558a.yaml
+releasenotes/notes/storwize-split-up-__init__-153fa8f097a81e37.yaml
+releasenotes/notes/storwize_iscsi_multipath_enhance-9de9dc29661869cd.yaml
+releasenotes/notes/support-az-in-volumetype-8yt6fg67de3976ty.yaml
+releasenotes/notes/support-cg-2b55da0bd9f69c7d.yaml
+releasenotes/notes/support-create-volume-from-backup-d363e2b502a76dc2.yaml
+releasenotes/notes/support-extend-inuse-volume-9e4atf8912qaye99.yaml
+releasenotes/notes/support-glance-multiple-stores-79d11c5344f41446.yaml
+releasenotes/notes/support-huawei-consistency-group-b666f8f6c6cddd8f.yaml
+releasenotes/notes/support-image-signature-verification-yu8qub7286et9dh4.yaml
+releasenotes/notes/support-incremental-backup-completion-in-rbd-1f2165fefcc470d1.yaml
+releasenotes/notes/support-metadata-based-snapshot-list-filtering-6e6df68a7ce981f5.yaml
+releasenotes/notes/support-metadata-for-backup-3d8753f67e2934fa.yaml
+releasenotes/notes/support-project-id-filter-for-limit-bc5d49e239baee2a.yaml
+releasenotes/notes/support-tenants-project-in-attachment-list-3edd8g138a28s4r8.yaml
+releasenotes/notes/support-to-query-cinder-resources-filter-by-update-at-and-created-at-32ae9aaea131d598.yaml
+releasenotes/notes/support-volume-glance-metadata-query-866b9e3beda2cd55.yaml
+releasenotes/notes/support-zeromq-messaging-driver-d26a1141290f5548.yaml
+releasenotes/notes/support-zmq-messaging-41085787156fbda1.yaml
+releasenotes/notes/support_deferred_deletion_in_RBD-0c5d96f8eac5b50a.yaml
+releasenotes/notes/support_sort_backup_by_name-0b080bcb60c0eaa0.yaml
+releasenotes/notes/support_sort_snapshot_with_name-7b66a2d8e587275d.yaml
+releasenotes/notes/supported-drivers-9c95dd2378cd308d.yaml
+releasenotes/notes/sync-bump-versions-a1e6f6359173892e.yaml
+releasenotes/notes/synology-support-uc-model-9cda442828c2eb32.yaml
+releasenotes/notes/synology-volume-driver-c5e0f655b04390ce.yaml
+releasenotes/notes/tintri-driver-removal-91a0931c417481d2.yaml
+releasenotes/notes/tintri_image_direct_clone-f73e561985aad867.yaml
+releasenotes/notes/tooz-coordination-heartbeat-cfac1064fd7878be.yaml
+releasenotes/notes/tooz-locks-0f9f2cc15f8dad5a.yaml
+releasenotes/notes/tpool-size-11121f78df24db39.yaml
+releasenotes/notes/transfer-snapshots-with-volume-a7763570a807c742.yaml
+releasenotes/notes/type-extra-spec-policies-b7742b0ac2732864.yaml
+releasenotes/notes/unity-backup-via-snapshot-81a2d5a118c97042.yaml
+releasenotes/notes/unity-compressed-volume-support-4998dee84534a324.yaml
+releasenotes/notes/unity-enable-ssl-14db2497225c4395.yaml
+releasenotes/notes/unity-fast-clone-02ae88ba8fdef145.yaml
+releasenotes/notes/unity-force-detach-7c89e72105f9de61.yaml
+releasenotes/notes/unity-multiattach-support-993b997e522d9e84.yaml
+releasenotes/notes/unity-remove-empty-host-17d567dbb6738e4e.yaml
+releasenotes/notes/unity-replication-support-2ab121a5ea5a2ade.yaml
+releasenotes/notes/unity-return-logged-out-initiator-6ab1f96f21bb284c.yaml
+releasenotes/notes/unity-storage-assisted-migration-support-145fce87f36f1ecc.yaml
+releasenotes/notes/unity-thick-support-fdbef833f2b4d54f.yaml
+releasenotes/notes/unsupport-prophetstor-bfbc674fd86303db.yaml
+releasenotes/notes/unsupport-veritas-access-ecfb4122770d93f9.yaml
+releasenotes/notes/untyped_to_default_type-0068e6bc8000986c.yaml
+releasenotes/notes/update_config_options_disco_volume_driver-07e52aa43e83c243.yaml
+releasenotes/notes/updated-at-list-0f899098f7258331.yaml
+releasenotes/notes/upgrade-checks-e58c4a81c857847d.yaml
+releasenotes/notes/use-castellan-key-manager-4911c3c4908ca633.yaml
+releasenotes/notes/use-glance-v2-api-and-deprecate-glance_api_version-1a3b698429cb754e.yaml
+releasenotes/notes/use-oslo_middleware_sizelimit-5f171cf1c44444f8.yaml
+releasenotes/notes/validate-expired-user-tokens-40b15322197653ae.yaml
+releasenotes/notes/validate_vol_create_uuids-4f08b4ef201385f6.yaml
+releasenotes/notes/verbose-online-migrations-94fb7e8a85cdbc10.yaml
+releasenotes/notes/verify-dorado-luntype-for-huawei-driver-4fc2f4cca3141bb3.yaml
+releasenotes/notes/veritas-access-driver-removal-dd9f0bc34c798c84.yaml
+releasenotes/notes/veritas_access_driver-c73b2320ba9f46a8.yaml
+releasenotes/notes/veritas_access_iscsi_driver-de642dad9e7d0890.yaml
+releasenotes/notes/veritas_cluster_nfs_unsupported-88ab3ea5cbb6cd88.yaml
+releasenotes/notes/vhd-disk-format-upload-to-image-5851f9d35f4ee447.yaml
+releasenotes/notes/virtuozzo-storage-driver-removal-d53942afce6465d0.yaml
+releasenotes/notes/virtuozzo-unsupported-645b47dceb0ddbd2.yaml
+releasenotes/notes/vmax-attach-snapshot-3137e59ab4ff39a4.yaml
+releasenotes/notes/vmax-clone-cg-09fce492931c957f.yaml
+releasenotes/notes/vmax-compression-support-1dfe463328b56d7f.yaml
+releasenotes/notes/vmax-deprecate-backend-xml-708a41919bcc55a8.yaml
+releasenotes/notes/vmax-driver-multiattach-support-43a7f99cd2d742ee.yaml
+releasenotes/notes/vmax-failover-unisphere-2de78d1f76b5f836.yaml
+releasenotes/notes/vmax-generic-volume-group-28b3b2674c492bbc.yaml
+releasenotes/notes/vmax-iscsi-chap-authentication-e47fcfe310b85f7b.yaml
+releasenotes/notes/vmax-iscsi-multipath-76cc09bacf4fdfbf.yaml
+releasenotes/notes/vmax-list-manageable-vols-snaps-6a7f5aa114fae8f3.yaml
+releasenotes/notes/vmax-manage-unmanage-snapshot-3805c4ac64b8133a.yaml
+releasenotes/notes/vmax-metadata-ac9bdd31e7e561c3.yaml
+releasenotes/notes/vmax-oversubscription-d61d0e3b1df2487a.yaml
+releasenotes/notes/vmax-powermax-rebrand-70569fc8cdf40a8c.yaml
+releasenotes/notes/vmax-qos-eb40ed35bd2f457d.yaml
+releasenotes/notes/vmax-rename-dell-emc-f9ebfb9eb567f427.yaml
+releasenotes/notes/vmax-replication-enhancements-c3bec80a3abb6d2e.yaml
+releasenotes/notes/vmax-replication-enhancements2-0ba03224cfca9959.yaml
+releasenotes/notes/vmax-replication-group-2f65ed92d761f90d.yaml
+releasenotes/notes/vmax-rest-94e48bed6f9c134c.yaml
+releasenotes/notes/vmax-rest-compression-10c2590052a9465e.yaml
+releasenotes/notes/vmax-rest-livemigration-885dd8731d5a8a88.yaml
+releasenotes/notes/vmax-rest-qos-6bb4073b92c932c6.yaml
+releasenotes/notes/vmax-rest-replication-612fcfd136cc076e.yaml
+releasenotes/notes/vmax-rest-retype-ceba5e8d04f637b4.yaml
+releasenotes/notes/vmax-retype-replicated-volumes-325be6e5fd626819.yaml
+releasenotes/notes/vmax-revert-volume-to-snapshot-b4a837d84a8b2a85.yaml
+releasenotes/notes/vmax-volume-migration-992c8c68e2207bbc.yaml
+releasenotes/notes/vmdk_backup_restore-41f807b7bc8e0ae8.yaml
+releasenotes/notes/vmdk_config_conn_pool_size-0658c497e118533f.yaml
+releasenotes/notes/vmdk_default_task_poll_interval-665f032bebfca39e.yaml
+releasenotes/notes/vmdk_image_ova-d3b3a0e72221110c.yaml
+releasenotes/notes/vmdk_vc_51-df29eeb5fc93fbb1.yaml
+releasenotes/notes/vmem-7000-iscsi-3c8683dcc1f0b9b4.yaml
+releasenotes/notes/vmware-vmdk-config-eb70892e4ccf8f3c.yaml
+releasenotes/notes/vmware-vmdk-manage-existing-0edc20d9d4d19172.yaml
+releasenotes/notes/vmware-vmdk-removed-bfb04eed77b95fdf.yaml
+releasenotes/notes/vmware-vmdk-revert-to-snapshot-ee3d638565649f44.yaml
+releasenotes/notes/vmware-vmdk-snapshot-template-d3dcfc0906c02edd.yaml
+releasenotes/notes/vmware_adapter_type-66164bc3857f244f.yaml
+releasenotes/notes/vmware_fcd_retype-979418c39fd5d59d.yaml
+releasenotes/notes/vmware_fcd_snapshot-b702f7e950dfbe7a.yaml
+releasenotes/notes/vmware_fcd_storage_policy-636d6a95f1c44b6e.yaml
+releasenotes/notes/vmware_lazy_create-52f52f71105d2067.yaml
+releasenotes/notes/vmware_retype_adapter_type-dbd8935b8d3bcb1b.yaml
+releasenotes/notes/vmware_revert_datastore_stats-ba85b30612970d91.yaml
+releasenotes/notes/vmware_vmdk_datastore_regex-fe7b68ad69ef7384.yaml
+releasenotes/notes/vmware_vmdk_default_adapter_type-8e247bce5b229c7a.yaml
+releasenotes/notes/vmware_vmdk_enforce_vc_55-7e1b3ede9bf2129b.yaml
+releasenotes/notes/vmware_vmdk_managed_by-3de05504d0f9a65a.yaml
+releasenotes/notes/vmware_vmdk_nfs41-450908bbbc9eea6d.yaml
+releasenotes/notes/vmware_vmdk_paravirtual-3d5eeef96dcbcfb7.yaml
+releasenotes/notes/vmware_vmdk_storage_profile_config-fa3784f1ed50df9e.yaml
+releasenotes/notes/vnx-add-async-migrate-option-0734164feeaecadc.yaml
+releasenotes/notes/vnx-add-force-detach-support-26f215e6f70cc03b.yaml
+releasenotes/notes/vnx-async-migration-support-3c449139bb264004.yaml
+releasenotes/notes/vnx-configurable-migration-rate-5e0a2235777c314f.yaml
+releasenotes/notes/vnx-fail-delete-lun-due-to-tmp-snapshot-edd3cdd85e28be60.yaml
+releasenotes/notes/vnx-new-driver-7e96934c2d3a6edc.yaml
+releasenotes/notes/vnx-perf-optimize-bd55dc3ef7584228.yaml
+releasenotes/notes/vnx-qos-support-7057196782e2c388.yaml
+releasenotes/notes/vnx-replication-group-2ebf04c80e2171f7.yaml
+releasenotes/notes/vnx-replication-v2.1-4d89935547183cc9.yaml
+releasenotes/notes/vnx-repv2.1-config-update-cc2f60c20aec88dd.yaml
+releasenotes/notes/vnx-revert-to-snapshot-e5494b6fb5ad5a1e.yaml
+releasenotes/notes/vnx-update-sg-in-cache-3ecb673727bea79b.yaml
+releasenotes/notes/vnx_clone_cg-db74ee2ea71bedcb.yaml
+releasenotes/notes/volume-filtering-for-quoted-display-name-7f5e8ac888a73001.yaml
+releasenotes/notes/volume-type-encryption-api-policy-granularity-7071e45f4c7894c5.yaml
+releasenotes/notes/volume_init_max_objects_retrieval-966f607c46190946.yaml
+releasenotes/notes/volumes-summary-6b2485f339c88a91.yaml
+releasenotes/notes/vrts_hyperscale_driver-5b63ab706ea8ae89.yaml
+releasenotes/notes/vxflexos-support-compression-9139e556677ac093.yaml
+releasenotes/notes/vxflexos_drop_deprecated_opt-3231a222e458fa92.yaml
+releasenotes/notes/vzstorage-log-path-7539342e562a2e4a.yaml
+releasenotes/notes/vzstorage-volume-format-cde85d3ad02f6bb4.yaml
+releasenotes/notes/win-iscsi-config-portals-51895294228d7883.yaml
+releasenotes/notes/windows-multiple-backends-9aa83631ad3d42f2.yaml
+releasenotes/notes/windows-volume-backup-b328858a20f5a499.yaml
+releasenotes/notes/xiv-ds8k-replication-2.1-996c871391152e31.yaml
+releasenotes/notes/xiv-generic-volume-group-4609cdc86d6aaf81.yaml
+releasenotes/notes/xiv-new-qos-independent-type-58885c77efe24798.yaml
+releasenotes/notes/xiv-replication-group-7ca437c90f2474a7.yaml
+releasenotes/notes/xtremio-cg-from-cg-e05cf286e3a1e943.yaml
+releasenotes/notes/xtremio-generic-groups-912e11525573e970.yaml
+releasenotes/notes/xtremio-ig-cleanup-bbb4bee1f1e3611c.yaml
+releasenotes/notes/xtremio-manage-snapshot-5737d3ad37df81d1.yaml
+releasenotes/notes/xtremio-support-multiattache-20b1882a1216a8b2.yaml
+releasenotes/notes/zfssa-iscsi-get-manageable-volumes-eb23a11570c813d7.yaml
+releasenotes/notes/zfssa-iscsi-multi-connect-3be99ee84660a280.yaml
+releasenotes/notes/zfssa-volume-manage-unmanage-ccd80807103b69c8.yaml
+releasenotes/notes/zte_cinder_driver-76ba6d034e1b6f65.yaml
+releasenotes/source/conf.py
+releasenotes/source/index.rst
+releasenotes/source/liberty.rst
+releasenotes/source/mitaka.rst
+releasenotes/source/newton.rst
+releasenotes/source/ocata.rst
+releasenotes/source/pike.rst
+releasenotes/source/queens.rst
+releasenotes/source/rocky.rst
+releasenotes/source/stein.rst
+releasenotes/source/train.rst
+releasenotes/source/unreleased.rst
+releasenotes/source/_static/.placeholder
+releasenotes/source/_templates/.placeholder
+releasenotes/source/locale/en_GB/LC_MESSAGES/releasenotes.po
+tools/check_exec.py
+tools/coding-checks.sh
+tools/fast8.sh
+tools/generate_driver_list.py
+tools/test-setup.sh
+tools/config/__init__.py
+tools/config/check_uptodate.sh
+tools/config/cinder-config-generator.conf
+tools/config/cinder-policy-generator.conf
+tools/config/generate_cinder_opts.py
+tools/hooks/README
+tools/hooks/run_multi_backend_matrix.sh
+tools/hooks/utils.sh
\ No newline at end of file
diff -pruN 2:15.0.1-1/cinder.egg-info/top_level.txt 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder.egg-info/top_level.txt
--- 2:15.0.1-1/cinder.egg-info/top_level.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/cinder.egg-info/top_level.txt	2020-03-24 18:46:35.000000000 +0000
@@ -0,0 +1 @@
+cinder
diff -pruN 2:15.0.1-1/contrib/block-box/README.md 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/contrib/block-box/README.md
--- 2:15.0.1-1/contrib/block-box/README.md	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/contrib/block-box/README.md	2020-03-24 18:46:31.000000000 +0000
@@ -1,6 +1,12 @@
 # block-box
 Standalone Cinder Containerized using Docker Compose
 
+** This was a proof of concept for running Cinder services in containers
+and is no longer supported.**
+
+There are several projects that support containerized services now. A good
+place to start may be the [LOCI Project](https://opendev.org/openstack/loci).
+
 ## Cinder
 Provides Block Storage as a service as part of the OpenStack Project.
 This project deploys Cinder in containers using docker-compose and
diff -pruN 2:15.0.1-1/CONTRIBUTING.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/CONTRIBUTING.rst
--- 2:15.0.1-1/CONTRIBUTING.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/CONTRIBUTING.rst	2020-03-24 18:46:31.000000000 +0000
@@ -1,16 +1,19 @@
-If you would like to contribute to the development of OpenStack,
-you must follow the steps in this page:
+The source repository for this project can be found at:
 
-   https://docs.openstack.org/infra/manual/developers.html
+  https://opendev.org/openstack/cinder
 
-Once those steps have been completed, changes to OpenStack
-should be submitted for review via the Gerrit tool, following
-the workflow documented at:
+Pull requests submitted through GitHub are not monitored.
 
-   https://docs.openstack.org/infra/manual/developers.html#development-workflow
+To start contributing to OpenStack, follow the steps in the contribution guide
+to set up and use Gerrit:
 
-Pull requests submitted through GitHub will be ignored.
+  https://docs.openstack.org/contributors/code-and-documentation/quick-start.html
 
-Bugs should be filed on Launchpad, not in GitHub's issue tracker:
+Bugs should be filed on Launchpad:
 
-   https://bugs.launchpad.net/cinder
+  https://bugs.launchpad.net/cinder
+
+For more specific information about contributing to this repository, see the
+cinder contributor guide:
+
+  https://docs.openstack.org/cinder/latest/contributor/contributing.html
diff -pruN 2:15.0.1-1/debian/changelog 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/changelog
--- 2:15.0.1-1/debian/changelog	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/changelog	2020-03-24 18:47:42.000000000 +0000
@@ -1,971 +1,1377 @@
-cinder (2:15.0.1-1) unstable; urgency=medium
+cinder (2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1) focal; urgency=medium
 
-  * New upstream point release.
+  * New upstream snapshot for OpenStack Ussuri.
+  * d/cinder-common.postinst: Set default ownership and permissions for
+    /etc/<pkg>, /var/lib/<pkg>, and /var/log/<pkg> (LP: #1859422).
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 26 Mar 2020 15:11:21 +0100
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 24 Mar 2020 14:47:42 -0400
 
-cinder (2:15.0.0-5) UNRELEASED; urgency=medium
+cinder (2:16.0.0~b2~git2020020407.819b4a0fc-0ubuntu1) focal; urgency=medium
 
-  * d/watch: Fix malformed opts=
+  * New upstream snapshot for OpenStack Ussuri.
+  * d/control: Drop. Dropped Python2 support.
+  * d/rules: Switched to pybuild.
+  * d/p/skip-taskflow-tests-py37.patch: Dropped. Fixed upstream.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/control: Added python3-tabulate.
+  * d/control: Removed min version for python-hacking.
+  * d/control: Added python3-sqlalchemy-utils.
+  * d/p/py38skip.patch: Skip failing tests with Python3.8.
 
- -- Michal Arbet <michal.arbet@ultimum.io>  Fri, 13 Mar 2020 15:40:03 +0100
+ -- Sahid Orentino Ferdjaoui <sahid.ferdjaoui@canonical.com>  Thu, 06 Feb 2020 11:33:45 +0000
 
-cinder (2:15.0.0-4) unstable; urgency=medium
+cinder (2:15.0.0-0ubuntu1) eoan; urgency=medium
 
-  * Allow DEFROUTE_IP search to fail.
+  * New upstream release for OpenStack Train.
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 13 Mar 2020 11:21:04 +0100
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 16 Oct 2019 10:59:02 -0400
 
-cinder (2:15.0.0-3) unstable; urgency=medium
+cinder (2:15.0.0~rc1-0ubuntu1) eoan; urgency=medium
 
-  * Fallback to hostname -i if we can't find the my-ip otherwise.
+  * d/watch: Scope to 15.x series.
+  * New upstream release candidate for OpenStack Train.
+  * d/control: Align (Build-)Depends with upstream.
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 13 Mar 2020 10:29:38 +0100
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 27 Sep 2019 08:56:56 -0400
 
-cinder (2:15.0.0-2) unstable; urgency=medium
+cinder (2:15.0.0~b3~git2019092509.cea6e823c-0ubuntu2) eoan; urgency=medium
 
-  [ Ondřej Nový ]
-  * Bump Standards-Version to 4.4.1.
+  * Fix test issues triggered by mysql8
+    - d/p/fix-test-setup-mysql8.patch: use explicit create user in CI setup
+    - debian/tests/cinder-daemons: use explicit create user in autopkgtest
 
-  [ Thomas Goirand ]
-  * Uploading to unstable.
+ -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 26 Sep 2019 09:07:05 +0200
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 21 Oct 2019 23:55:04 +0200
+cinder (2:15.0.0~b3~git2019092509.cea6e823c-0ubuntu1) eoan; urgency=medium
 
-cinder (2:15.0.0-1) experimental; urgency=medium
+  [ Sahid Orentino Ferdjaoui ]
+  * New upstream snapshot for OpenStack Train.
+  * d/control: Align (Build-)Depends with upstream.
 
-  * New upstream release.
+  [ Corey Bryant ]
+  * d/tests/cinder-daemons: As of disco, sqlalchemy defaults to mysqldb so
+    we must override the driver to use pymysql (LP: #1845321).
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 16 Oct 2019 17:53:11 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 25 Sep 2019 08:48:14 -0400
 
-cinder (2:15.0.0~rc1-2) experimental; urgency=medium
+cinder (2:15.0.0~b1~git2019080709.0a0d55d8a-0ubuntu1) eoan; urgency=medium
 
-  * Remove creation of v1 endpoint in postinst,
-    as it is not present in cinder anymore.
+  * New upstream snapshot for OpenStack Train (LP: #1834845).
 
- -- Michal Arbet <michal.arbet@ultimum.io>  Wed, 02 Oct 2019 15:02:49 +0200
+ -- James Page <james.page@ubuntu.com>  Wed, 07 Aug 2019 13:13:56 +0100
 
-cinder (2:15.0.0~rc1-1) experimental; urgency=medium
+cinder (2:15.0.0~b1~git2019061315.6cbc53b71-0ubuntu1) eoan; urgency=medium
 
-  * New upstream release.
-  * Fixed (build-)depends for this release.
-  * Fixed fix-upstream-sheebang.patch.
+  * New upstream release 15.0.0~b1.
+  * d/control: Align (Build-)Depends with upstream.
 
- -- Thomas Goirand <zigo@debian.org>  Sat, 28 Sep 2019 01:03:42 +0200
+ -- Sahid Orentino Ferdjaoui <sahid.ferdjaoui@canonical.com>  Tue, 25 Jun 2019 10:25:06 +0100
 
-cinder (2:14.0.0-5) unstable; urgency=medium
+cinder (2:14.0.0-0ubuntu1) disco; urgency=medium
 
-  [ Ondřej Nový ]
-  * Running wrap-and-sort -bast.
-  * d/copyright: Bump my copyright year.
-  * Use debhelper-compat instead of debian/compat.
-  * Bump Standards-Version to 4.4.0.
+  * New upstream release for OpenStack Stein.
 
-  [ Thomas Goirand ]
-  * Add missing etc/cinder/resource_filters.json.
+ -- James Page <james.page@ubuntu.com>  Fri, 12 Apr 2019 08:44:29 +0100
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 08 Aug 2019 15:48:44 +0200
+cinder (2:14.0.0~rc2-0ubuntu1) disco; urgency=medium
 
-cinder (2:14.0.0-4) unstable; urgency=medium
+  * New upstream release candidate for OpenStack Stein.
 
-  * Uploading to unstable.
+ -- Sahid Orentino Ferdjaoui <sahid.ferdjaoui@canonical.com>  Fri, 05 Apr 2019 11:52:10 +0200
 
- -- Michal Arbet <michal.arbet@ultimum.io>  Wed, 17 Jul 2019 15:21:33 +0200
+cinder (2:14.0.0~rc1-0ubuntu1) disco; urgency=medium
 
-cinder (2:14.0.0-3) experimental; urgency=medium
+  * New upstream release candidate for OpenStack Stein.
+  * d/control: Align (Build-)Depends with upstream.
 
-  * d/cinder-api.postinst.in: Fix 35357 port to 5000
+ -- James Page <james.page@ubuntu.com>  Fri, 22 Mar 2019 09:34:08 +0000
 
- -- Michal Arbet <michal.arbet@ultimum.io>  Tue, 07 May 2019 09:31:43 +0200
+cinder (2:14.0.0~b1~git2019031444.b347f9e31-0ubuntu1) disco; urgency=medium
 
-cinder (2:14.0.0-2) experimental; urgency=medium
+  * New upstream snapshot for OpenStack Stein.
+  * d/control: Align (Build-)Depends with upstream.
 
-  * d/control: Bump openstack-pkg-tools to version 99
+ -- James Page <james.page@ubuntu.com>  Thu, 14 Mar 2019 08:02:32 +0000
 
- -- Michal Arbet <michal.arbet@ultimum.io>  Fri, 03 May 2019 18:52:07 +0200
+cinder (2:14.0.0~b1~git2019013028.45f967ef9-0ubuntu1) disco; urgency=medium
 
-cinder (2:14.0.0-1) experimental; urgency=medium
+  * New upstream snapshot for OpenStack Stein.
+  * d/control: Align (Build-)Depends with upstream.
 
-  * New upstream release.
+ -- James Page <james.page@ubuntu.com>  Wed, 30 Jan 2019 15:42:10 +0000
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 11 Apr 2019 08:59:10 +0200
+cinder (2:14.0.0~b1~git2018120609.2cd694046-0ubuntu1) disco; urgency=medium
 
-cinder (2:14.0.0~rc1-1) experimental; urgency=medium
+  * d/tests/control, d/tests/cinder-daemons, d/tests/cinder-volume: Switch to
+    using mysql-server databases in autopkgtests.
+  * New upstream snapshot for OpenStack Stein.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/control: Ensure python3-migrate version is compatable with sqlite>=3.26
+    (LP: #1807262).
 
-  * New upstream release.
-  * Fixed (build-)depends for this release.
-  * Using oslo-config-generator without the python3- prefix.
-  * Removed New_snapshot_clone_size_option.patch.
-  * Also package usr/bin/cinder-status.
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 06 Dec 2018 09:27:58 -0500
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 29 Mar 2019 12:55:53 +0100
+cinder (2:14.0.0~b1~git2018111617.4529b193d-0ubuntu2) disco; urgency=medium
 
-cinder (2:13.0.3-1) unstable; urgency=medium
+  * d/py3dist-overrides: Added based on recently dropped pydist-overrides.
 
-  * New upstream version
-  * Remove upstream aplied patch
-    - Stop_masking_IOError_different_than_ENOSPC.patch
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 20 Nov 2018 10:09:20 -0500
 
- -- Michal Arbet <michal.arbet@ultimum.io>  Tue, 26 Feb 2019 11:30:22 +0100
+cinder (2:14.0.0~b1~git2018111617.4529b193d-0ubuntu1) disco; urgency=medium
 
-cinder (2:13.0.2-3) unstable; urgency=medium
+  * New upstream snapshot for OpenStack Stein.
+  * d/control, d/rules, d/python(3)-cinder.*, d/tests/*: Drop Python 2
+    support.
 
-  * Update fix-python3-compatibility-ceph.patch
-  * Add ceph-common to recommends
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 16 Nov 2018 17:24:41 -0500
 
- -- Michal Arbet <michal.arbet@ultimum.io>  Tue, 26 Feb 2019 10:42:13 +0100
+cinder (2:14.0.0~b1~git20181113.f0aa3665e-0ubuntu1) disco; urgency=medium
 
-cinder (2:13.0.2-2) unstable; urgency=medium
+  * New upstream snapshot for OpenStack Stein.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/p/rados-read-write-byte-data.patch: Dropped. Fixed in upstream snapshot.
+  * d/rules: Ensure python3 shebangs are set to /usr/bin/python3.
+  * d/rules: Enable Python 3.7 tests.
+  * d/rules: Update PBR_VERSION to handle ~git versioning.
+  * d/p/skip-taskflow-tests-py37.patch: Skip tests that are failing for
+    Python 3.7 due to taskflow StopIteration issue.
+  * d/t/cinder-shebangs-py3: Update shebang for Python 3.7.
+  * d/watch: Scope to 14.x series.
 
-  * Remove fix-qnap-unit-tests.patch
-  * Add fix-python3-compatibility-ceph.patch
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 13 Nov 2018 12:09:27 -0500
 
- -- Michal Arbet <michal.arbet@ultimum.io>  Wed, 06 Feb 2019 17:12:28 +0100
+cinder (2:13.0.0-0ubuntu4) cosmic; urgency=medium
 
-cinder (2:13.0.2-1) unstable; urgency=medium
+  * d/p/rados-read-write-byte-data.patch: Cherry-picked from upstream gerrit
+    review https://review.openstack.org/#/c/612490/ to ensure read/write of
+    volume metadata backups is py3-compatible (LP: #1798917).
 
-  [ Thomas Goirand ]
-  * Fix previous entry's typo that wrongly closed the bug.
-  * New upstream release.
+ -- Corey Bryant <corey.bryant@canonical.com>  Mon, 22 Oct 2018 13:28:59 -0400
 
-  [ Ondřej Nový ]
-  * d/changelog: Remove trailing whitespaces.
+cinder (2:13.0.0-0ubuntu3) cosmic; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 17 Jan 2019 12:45:34 +0100
+  * d/cinder-common.install: Install /etc/cinder/resource_filters.json
 
-cinder (2:13.0.1-5) unstable; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 25 Sep 2018 09:42:11 -0400
 
-  * Check if /bin/ip is executable before using it in config script for
-    autodetecting the value of my_ip (Clsoes: #914779).
+cinder (2:13.0.0-0ubuntu2) cosmic; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 27 Nov 2018 14:05:07 +0100
+  * d/rules: Ensure /usr/etc is purged from python{3}-cinder packages
+    to resolve issues with co-installability.
 
-cinder (2:13.0.1-4) unstable; urgency=medium
+ -- James Page <james.page@ubuntu.com>  Thu, 06 Sep 2018 10:24:56 +0100
 
-  * Add New_snapshot_clone_size_option.patch.
+cinder (2:13.0.0-0ubuntu1) cosmic; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 22 Nov 2018 14:37:58 +0100
+  * New upstream release for OpenStack Rocky.
 
-cinder (2:13.0.1-3) unstable; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 30 Aug 2018 10:21:32 -0400
 
-  * Add Stop_masking_IOError_different_than_ENOSPC.patch.
+cinder (2:13.0.0~rc3-0ubuntu1) cosmic; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 19 Nov 2018 11:53:39 +0100
+  * d/cinder-common.apache2 -> d/cinder-api.apache2: Ensure that
+    Apache2 configuration is installed with cinder-api (which has the
+    right dependencies) rather than as part of the -common base package.
+  * New upstream release candidate.
 
-cinder (2:13.0.1-2) unstable; urgency=medium
+ -- James Page <james.page@ubuntu.com>  Thu, 30 Aug 2018 14:25:13 +0100
 
-  * Rebuild with newer openstack-pkg-tools 89
+cinder (2:13.0.0~rc1-0ubuntu3) cosmic; urgency=medium
 
- -- Michal Arbet <michal.arbet@ultimum.io>  Mon, 12 Nov 2018 23:07:27 +0100
+  * Additional support for Python 3:
+    - d/control, d/cinder-*: Move common files to cinder-common. Only have
+      python(3)-cinder depend on cinder-common. Other packages that used to
+      depend on cinder-common now depend on python-cinder | python3-cinder.
+    - d/control: Drop python(3)-cinder conflicts on each other.
+    - d/python(3)-cinder.postinst: Ensure alternatives priority is 300
+      for Py2 and 200 for Py3.
+    - d/tests/control: Run Py3 tests first due to alternatives priority.
 
-cinder (2:13.0.1-1) unstable; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Mon, 27 Aug 2018 13:07:52 -0400
 
-  [ Michal Arbet ]
-  * New upstream version
-  * d/cinder-common.config.in:
-  * d/cinder-common.postinst.in:
-  * d/cinder-common.templates.in:
-      - Handle glance_api_servers via debconf (Closes: #912992)
-      - Handle my_ip via debconf (Closes: #912991)
-      * Fix volume_group name in config (Closes: #912987)
-  * d/cinder-common.postrm.in:
-      - Fix deletion of policy.json (Closes: #912984)
-  * d/rules: Make auth_strategy default to keystone
-  * d/copyright: Add me to copyright file
-  * d/control: Add me to uploaders field
+cinder (2:13.0.0~rc1-0ubuntu2) cosmic; urgency=medium
 
- -- Michal Arbet <michal.arbet@ultimum.io>  Tue, 06 Nov 2018 13:57:47 +0100
+  * d/control: Correct Suggests for python3-cinder from python3-ceph ->
+    python3-{rbd,rados}, as python3-ceph does not exist.
 
-cinder (2:13.0.0-2) unstable; urgency=medium
+ -- James Page <james.page@ubuntu.com>  Fri, 17 Aug 2018 07:59:43 +0100
 
-  * Uploading to unstable.
+cinder (2:13.0.0~rc1-0ubuntu1) cosmic; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 05 Sep 2018 13:53:41 +0200
+  * New upstream release candidate for OpenStack Rocky.
 
-cinder (2:13.0.0-1) experimental; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 10 Aug 2018 15:20:07 -0400
 
-  [ Thomas Goirand ]
-  * Better init script descriptions.
-  * New upstream release.
-  * Fixed (build-)depends for this release.
+cinder (2:13.0.0~b3-0ubuntu1) cosmic; urgency=medium
 
-  [ Ondřej Nový ]
-  * d/control: Use team+openstack@tracker.debian.org as maintainer
-  * d/changelog: Remove trailing whitespaces
-  * Removed patches applied upstream:
-    - Fix_python_version_check.patch
-    - fix-sqlite3-migration-tests.patch
-    - fix-netapp-unit-tests.patch
-    - disable-unit-tests-bug-1715915.patch
-    - fix-inspur-instorage-unit-tests.patch
-    - fix-dell-emc-unit-tests.patch
-    - fix-hpe3parfcdriver-unit-tests.patch
-    - fix-rbd-driver-for-python3.patch
+  * New upstream milestone for OpenStack Rocky.
+  * d/control: Align (Build-)Depends with upstream.
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 15 Jun 2018 11:56:27 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 07 Aug 2018 16:14:02 -0400
 
-cinder (2:12.0.1-1) unstable; urgency=medium
+cinder (2:13.0.0~b2-0ubuntu2) cosmic; urgency=medium
 
-  [ Michal Arbet ]
-  * New upstream version
-  * Add some deletion of files to dh_clean
-  * Add fix-sqlite3-migration-tests.patch
-  * Allow run all tests
-  * Add fix-netapp-unit-tests.patch
-  * Add fix-qnap-unit-tests.patch
-  * Add fix-dell-emc-unit-tests.patch
-  * Add fix-backup-validation-unit-tests.patch
-  * Add fix-hpe3parfcdriver-unit-tests.patch
-  * Add disable-unit-tests-bug-1715915.patch
+  * Add support for Python 3:
+    - d/control: Add Py3 BDs and python3-cinder package.
+    - d/control: Support Py2 first and Py3 as alternative.
+    - d/control: Move all python deps to python(3)-cinder Depends.
+    - d/control: Make python(3)-cinder conflict against each other.
+    - d/rules: Add Py3 support.
+    - d/rules: Use pkgos-dh_auto_install as this helps name binaries for
+      update-alternatives.
+    - d/python-cinder.install: Drop, not needed.
+    - d/cinder*.install: Drop usr/bin/* as pkgos-dh_auto_install handles
+      install of those files.
+    - d/python(3)-cinder.post*, d/python(3)-cinder.prerm: Add update-alternatives
+      to enable correct shebangs for Python binaries.
+    - d/tests/*: Enable Py3 tests for cinder daemons and add shebang tests.
+    - d/rules: Skip Py3.7 tests until they run successfully upstream.
 
-  [ Thomas Goirand ]
-  * Pipe tests to subunit2pyunit.
-  * Add fix-rbd-driver-for-python3.patch
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 06 Jul 2018 15:01:59 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 02 May 2018 12:02:25 +0200
+cinder (2:13.0.0~b2-0ubuntu1) cosmic; urgency=medium
 
-cinder (2:12.0.0-4) UNRELEASED; urgency=medium
+  * New upstream milestone for OpenStack Rocky.
+  * d/p/fix-migration.patch: Droped. Fixed in new milestone.
 
-  * Switch back to using eventlet instead of uwsgi, as it crashes
-    puppet-openstack when doing "openstack volume type set".
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 13 Jun 2018 12:46:53 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 24 Apr 2018 09:01:26 +0200
+cinder (2:13.0.0~b1-0ubuntu1) cosmic; urgency=medium
 
-cinder (2:12.0.0-3) unstable; urgency=medium
+  * d/watch: Scope to 13.x series.
+  * New upstream milestone for OpenStack Rocky.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/control: Update Standards-Version to 4.1.4.
+  * d/watch, d/control: Use https URLs.
+  * d/control: Drop obsolete XS-Testsuite: autopkgtest header.
+  * d/control, d/tests/*: Enable autopkgtest-pkg-python testsuite.
+  * d/p/fix-sqlite3-migration-tests.patch: Cherry-picked from gerrit to
+    fix DB migration error: https://review.openstack.org/#/c/570361/
 
-  * Using unified postrm from openstack-pkg-tools >= 74~.
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 18 May 2018 10:40:38 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 26 Mar 2018 16:21:45 +0000
+cinder (2:12.0.1-0ubuntu2) cosmic; urgency=medium
 
-cinder (2:12.0.0-2) unstable; urgency=medium
+  * New upstream version.
+  * d/p/log-config-options-with-oslo.config.patch: Dropped. Fixed in
+    new upstream version.
+  * New stable point release for OpenStack Queens (LP: #1767128).
 
-  * Added thin-provisioning-tools as runtime depends for cinder-common.
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 02 May 2018 15:12:35 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 07 Mar 2018 15:56:04 +0000
+cinder (2:12.0.0-0ubuntu1) bionic; urgency=medium
 
-cinder (2:12.0.0-1) unstable; urgency=medium
+  * New upstream release for OpenStack Queens.
 
-  [ Ondřej Nový ]
-  * d/changelog: Remove trailing whitespaces
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 28 Feb 2018 14:14:30 -0500
 
-  [ Thomas Goirand ]
-  * New upstream release.
-  * Switched to openstack-pkg-tools >= 70~ debconf templates.
-  * Switched Cinder to uwsgi.
-  * Add Build-Profiles: <!nodoc> for the -doc package.
-  * Downgrade python3-ceph to Recommends: until Ceph Lumiuous version is
-    uploaded with Python 3 support.
-  * Also downgrade python3-hp3parclient as recommends.
+cinder (2:12.0.0~rc2-0ubuntu2) bionic; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 05 Mar 2018 23:01:40 +0000
+  * d/p/log-config-options-with-oslo.config.patch: Cherry-picked patch
+    from upsream stable/queens branch to fix TypeError failure in
+    cinder/service.py.
 
-cinder (2:12.0.0~rc1-2) unstable; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 27 Feb 2018 15:11:53 -0500
 
-  * Uploading to unstable.
-  * Blacklist tests failing in Stretch backport:
-    - test_instorage_initialize_iscsi_connection_multipath (wrong ordering).
-    - VMAXCommonReplicationTest.test_failover_legacy_volume (wrong IP addr).
-    - TestHPE3PARFCDriver.test_create_modify_host not (not deterministic).
-  * Call stestr directly, do not use pkgos-dh_auto_test.
+cinder (2:12.0.0~rc2-0ubuntu1) bionic; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 26 Feb 2018 21:13:30 +0000
+  * New upstream release candidate for OpenStack Queens.
 
-cinder (2:12.0.0~rc1-1) experimental; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 22 Feb 2018 16:06:49 -0500
 
-  [ Ondřej Nový ]
-  * d/control: Set Vcs-* to salsa.debian.org
-  * Running wrap-and-sort -bast
+cinder (2:12.0.0~rc1-0ubuntu1) bionic; urgency=medium
 
-  [ Thomas Goirand ]
-  * New upstream release.
-  * Fixed (build-)depends for this release.
-  * Using pkgos-dh_auto_test.
-  * Generate policy.yaml using oslo-policy-generator.
-  * Switch package to Python 3.
-  * Blacklist qnap and netapp tests, as they fail in Python 3.
-  * Blacklist 3 other failing tests under Python 3:
-    - test_restore_backup_with_body_KeyError()
-    - test_vmax.VMAXCommonReplicationTest\.test_replicate_group()
-  * Standards-Version is now 4.1.3.
-  * Add patch for fixing some python2 sheebang to python 3.
-  * Fixed debian/copyright holder list and years.
+  * d/control: Add python-defusedxml to (Build-)Depends.
+  * d/cinder-common.install: Drop install of policy.json.
+  * New upstream milestone for OpenStack Queens.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/control: Switch to python3-sphinx.
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 22 Feb 2018 15:37:20 +0000
+ -- James Page <james.page@ubuntu.com>  Tue, 13 Feb 2018 10:09:02 +0000
 
-cinder (2:11.0.0-7) unstable; urgency=medium
+cinder (2:12.0.0~b2-0ubuntu2) bionic; urgency=medium
 
-  [ David Rabel ]
-  * Team upload.
-  * Remove obsolete Build-Depends: dh-systemd.
-  * Remove unused patches at debian/patches/
-  * Fix encoding in d/po/pt.po.
+  * d/cinder-common.postinst: Use reserved uid/gid for cinder user/group,
+    ensuring consistency across deployments (LP: #1657202).
 
- -- Thomas Goirand <zigo@debian.org>  Sat, 10 Feb 2018 12:42:35 +0000
+ -- James Page <james.page@ubuntu.com>  Tue, 12 Dec 2017 15:22:10 +0000
 
-cinder (2:11.0.0-6) unstable; urgency=medium
+cinder (2:12.0.0~b2-0ubuntu1) bionic; urgency=medium
 
-  * Rebuilt with openstack-pkg-tools >= 61~.
+  * d/watch: Scope to 12.x series.
+  * New upstream milestone for OpenStack Queens.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/*: wrap-and-sort -bast.
+  * d/rules: Switch back to ostestr for unit test execution.
+  * d/control,compat: Bump debhelper compat to 10, drop BD on dh-
+    systemd.
+  * d/control: Bumped Standards-Version to 4.1.2.
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 14 Dec 2017 08:41:37 +0000
+ -- James Page <james.page@ubuntu.com>  Mon, 11 Dec 2017 11:43:44 +0000
 
-cinder (2:11.0.0-5) unstable; urgency=medium
+cinder (2:12.0.0~b1-0ubuntu1) bionic; urgency=medium
 
-  * Rebuilt with openstack-pkg-tools >= 60~.
+  * New upstream milestone for OpenStack Queens.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/p/drop-openstackdoctheme.patch: Dropped. No longer needed.
+  * d/control, d/rules: Switch from ostestr to stestr as upstream has to run
+    unit tests. Also drop blacklist as the corresponding bug is now fixed.
+  * d/cinder-common.install, cinder-volume.install: Adjust paths for
+    config file install sources.
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 13 Dec 2017 21:22:08 +0000
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 14 Nov 2017 12:47:46 -0500
 
-cinder (2:11.0.0-4) unstable; urgency=medium
+cinder (2:11.0.0-0ubuntu3) bionic; urgency=medium
 
-  * Rebuilt with openstack-pkg-tools >= 59~, to make sure we're using allocated
-    UID/GID from #884178.
+  * d/control: Move apache dependencies to cinder-api binary package
+    (LP: #1728754).
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 12 Dec 2017 23:23:24 +0000
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 31 Oct 2017 09:33:45 -0400
 
-cinder (2:11.0.0-3) unstable; urgency=medium
+cinder (2:11.0.0-0ubuntu2) artful; urgency=medium
 
-  * Also register volumev3 / cinderv3 API endpoint.
-  * Rebuilt with openstack-pkg-tools >= 56.
+  * d/cinder-wsgi.conf: Ensure apache processes run under cinder group,
+    allowing access to /etc/cinder/* (LP: #1715024).
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 30 Nov 2017 14:44:16 +0100
+ -- James Page <james.page@ubuntu.com>  Mon, 18 Sep 2017 09:24:40 +0100
 
-cinder (2:11.0.0-2) unstable; urgency=medium
+cinder (2:11.0.0-0ubuntu1) artful; urgency=medium
 
-  * Uploading to unstable.
-  * Updated fr.po (Closes: #875751).
-  * Updated pt.po (Closes: #876169).
+  * d/tests/cinder-daemons, d/tests/cinder-volume: Add some resiliency
+    to allow time for services to start after restart.
+  * New upstream release for OpenStack Pike.
 
- -- Thomas Goirand <zigo@debian.org>  Sat, 28 Oct 2017 10:16:42 +0000
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 30 Aug 2017 09:11:08 -0400
 
-cinder (2:11.0.0-1) experimental; urgency=medium
+cinder (2:11.0.0~rc2-0ubuntu3) artful; urgency=medium
 
-  [ Daniel Baumann ]
-  * Updating vcs fields.
-  * Updating copyright format url.
-  * Updating maintainer field.
-  * Running wrap-and-sort -bast.
-  * Updating standards version to 4.0.0.
-  * Removing gbp.conf, not used anymore or should be specified in the
-    developers dotfiles.
-  * Correcting permissions in debian packaging files.
-  * Updating standards version to 4.0.1.
-  * Deprecating priority extra as per policy 4.0.1.
-  * Updating standards version to 4.1.0.
+  * d/cinder.conf, d/tests/cinder-daemons, d/tests/cinder-volume: Update
+    default config with enabled_backends and database connection, and run
+    db sync commands in autopkgtests prior to testing services are running.
 
-  [ Thomas Goirand ]
-  * New upstream release.
-  * Fixed (build-)depends for this release.
-  * Removed now useless patches.
-  * Fixed oslo-config-generator namespaces in debian/rules.
-  * Wrap cinder.conf on 140 chars.
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 29 Aug 2017 17:14:11 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 09 Oct 2017 23:39:49 +0200
+cinder (2:11.0.0~rc2-0ubuntu2) artful; urgency=medium
 
-cinder (2:9.0.0-4) unstable; urgency=medium
+  * d/cinder-common.postinst: Drop db sync (LP: #1713059).
 
-  * Team upload.
-  * Bump build dependency on openstack-pkg-tools (Closes: #858692).
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 29 Aug 2017 10:44:38 -0400
 
- -- David Rabel <david.rabel@noresoft.com>  Sat, 01 Apr 2017 11:22:35 +0200
+cinder (2:11.0.0~rc2-0ubuntu1) artful; urgency=medium
 
-cinder (2:9.0.0-3) unstable; urgency=medium
+  * New upstream release candidate for OpenStack Pike.
 
-  * Team upload.
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 24 Aug 2017 12:05:47 -0400
 
-  [ Ondřej Nový ]
-  * Bumped debhelper compat version to 10
+cinder (2:11.0.0~rc1-0ubuntu1) artful; urgency=medium
 
-  [ Ondřej Kobližek ]
-  * Patch-out upper constraints of SQLAlchemy
-  * Fixed SqlAlchemy worker model (Closes: #846749)
+  * New upstream release candidate for OpenStack Pike.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/p/drop-openstackdoctheme.patch: Temporarily drop openstackdocstheme
+    sphinx extension until sphinx>=1.6.2 is available.
 
- -- Ondřej Kobližek <koblizeko@gmail.com>  Mon, 19 Dec 2016 10:23:09 +0100
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 16 Aug 2017 14:39:57 -0400
 
-cinder (2:9.0.0-2) unstable; urgency=medium
+cinder (2:11.0.0~b3-0ubuntu2) artful; urgency=medium
 
-  * Also allows running open-iscsi using OR depends (Closes: #841452).
+  * d/control: Set min python-requests to 2.14.2.
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 21 Oct 2016 10:40:22 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 03 Aug 2017 16:18:23 -0400
 
-cinder (2:9.0.0-1) unstable; urgency=medium
+cinder (2:11.0.0~b3-0ubuntu1) artful; urgency=medium
 
-  * New upstream release.
+  * New upstream milestone for OpenStack Pike.
+  * d/control: Align (Build-)Depends with upstream.
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 06 Oct 2016 17:32:42 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 28 Jul 2017 10:26:57 -0400
 
-cinder (2:9.0.0~rc1-2) unstable; urgency=medium
+cinder (2:11.0.0~b2-0ubuntu1) artful; urgency=medium
 
-  [ Ondřej Nový ]
-  * d/s/options: extend-diff-ignore of .gitreview
-  * d/control: Use correct branch in Vcs-* fields
+  * New upstream milestone for OpenStack Pike.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/control: Drop duplicate python-sphinx BD.
+  * d/control: Bumped Standards-Version to 3.9.8, no changes.
 
-  [ Thomas Goirand ]
-  * Uploading to unstable.
-  * Build-Depends on openstack-pkg-tools >= 53~.
-  * Fixed oslotest EPOCH.
-  * Debconf translation:
-    - it (Closes: #839197).
+ -- James Page <james.page@ubuntu.com>  Tue, 13 Jun 2017 13:06:10 +0100
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 28 Sep 2016 09:38:45 +0200
+cinder (2:11.0.0~b1-0ubuntu2) artful; urgency=medium
 
-cinder (2:9.0.0~rc1-1) experimental; urgency=medium
+  * No-change rebuild for sqlalchemy 1.1.x.
 
-  * New upstream release.
-  * Fixed (build-)depends for this release.
-  * Fixed namespace list when generating cinder.conf.
-  * Using OpenStack's Gerrit as VCS URLs.
-  * Rebased nozfs patches.
-  * Added PYTHONPATH=. when building sphinx doc.
-  * Black list 3 unit tests that non-deterministically fail:
-    - test_volume.VolumeMigrationTestCase.test_retype_volume_migration_failed
-    - test_volume.VolumeMigrationTestCase.test_retype_volume_migration_bad_policy
-    - backup.test_backup.BackupTestCase.test_create_backup_with_temp_snapshot
+ -- James Page <james.page@ubuntu.com>  Fri, 28 Apr 2017 10:01:01 +0100
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 14 Sep 2016 21:17:08 +0200
+cinder (2:11.0.0~b1-0ubuntu1) artful; urgency=medium
 
-cinder (2:9.0.0~b2-2) experimental; urgency=medium
+  [ Chuck Short ]
+  * d/cinder-common.postinst: Restrict permissions on /etc/cinder
+    (LP: #1675088).
+  * d/README.Debian: no-one should be running nova-volume any more.
+  * d/test-blacklist: Add blacklist-filter so we can exclude tests while
+    running unit tests in the packaging.
 
-  * Team upload.
-  * Added python-pep8 to build depends (Closes: #834275)
+  [ James Page ]
+  * New upstream milestone for OpenStack Pike.
+  * Align (Build-)Depends with new upstream milestone.
 
- -- Ondřej Nový <onovy@debian.org>  Sun, 14 Aug 2016 15:59:27 +0200
+ -- James Page <james.page@ubuntu.com>  Fri, 21 Apr 2017 17:17:13 +0100
 
-cinder (2:9.0.0~b2-1) experimental; urgency=medium
+cinder (2:10.0.0-0ubuntu2) zesty; urgency=medium
 
-  * New upstream release.
-  * Fixed (build-)depends for this release.
-  * Rebased remove-zfssa-from-opts.py.patch.
-  * Updated Danish translation of the debconf templates (Closes: #830641).
-  * Blacklist VolumeMigrationTestCase.test_retype_volume_driver_success.
+  * debian/cinder-api.install: Move cinder-wsgi back to 
+    its regular place. 
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 15 Jul 2016 16:35:01 +0200
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 22 Feb 2017 11:17:48 -0500
 
-cinder (2:9.0.0~b1+dfsg1-1) experimental; urgency=medium
+cinder (2:10.0.0-0ubuntu1) zesty; urgency=medium
 
-  * New upstream release.
-  * Fixed (build-)depends for this release.
-  * Refreshed patches.
-  * Fixed generation of cinder.conf namespace list.
-  * Do not use custom OSLO_PACKAGE_VERSION and build-depends on
-    openstack-pkg-tools 50.
+  * New upstream release for Openstack Ocata. 
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 09 Jun 2016 09:31:38 +0200
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 22 Feb 2017 09:19:18 -0500
 
-cinder (2:8.0.0-4) unstable; urgency=medium
+cinder (2:10.0.0~rc2-0ubuntu1) zesty; urgency=medium
 
-  [ Thomas Goirand ]
-  * Updated Japanese debconf templates (Closes: #820761).
-  * Updated Dutch debconf templates (Closes: #822967).
-  * Added Brazilian Portuguese debconf templates (Closes: #824287).
+  * New upstream release candidate for OpenStack Ocata.
 
-  [ Ondřej Nový ]
-  * d/copyright: Changed source URL to https protocol
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 17 Feb 2017 08:29:17 -0500
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 19 May 2016 10:51:12 +0200
+cinder (2:10.0.0~rc1-0ubuntu1) zesty; urgency=medium
 
-cinder (2:8.0.0-3) unstable; urgency=medium
+  * debian/apache2-wsgi.conf: DefaultProcessGroup should be cinder-wsgi
+    insteam of osapi-volume. (LP: #1655311) 
+  * New upstream release for Ocata. 
 
-  * Also blacklist test_create_delete_cgsnapshot which is non-deterministically
-    failing (Closes: #824595).
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 07 Feb 2017 10:22:15 -0500
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 18 May 2016 10:20:47 +0200
+cinder (2:10.0.0~b3-0ubuntu2) zesty; urgency=medium
 
-cinder (2:8.0.0-2) unstable; urgency=medium
+  * debian/control: Remove bad dependency. 
 
-  [ Ondřej Nový ]
-  * Standards-Version is 3.9.8 now (no change)
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 30 Jan 2017 15:02:05 -0500
 
-  [ Thomas Goirand ]
-  * Fixed endpoint creation that was buggy: it was using keystone admin auth
-    token which we removed for Mitaka (Closes: #820844).
+cinder (2:10.0.0~b3-0ubuntu1) zesty; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 13 Apr 2016 20:21:03 +0000
+  * New upstream milestone for OpenStack Ocata.
+  * debian/patches/google-back-requirements.patch: Dropped
+  * debian/pydist-overrides: Add google-api-python-client and oauth2client.
+  * d/control: Align (Build-)Depends with upstream.
 
-cinder (2:8.0.0-1) unstable; urgency=medium
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 27 Jan 2017 09:20:08 -0500
 
-  * New upstream release.
+cinder (2:10.0.0~b2-0ubuntu1) zesty; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 07 Apr 2016 21:08:51 +0200
+  [ Chuck Short ]
+  * debian/rules, debian/control, debian/cinder-api.init.in,
+    debian/tests/cinder-daemon, debian/apache2.conf: Run cinder API daemon
+    under apache2 with mod_wsgi instead of under eventlet.
 
-cinder (2:8.0.0~rc2-1) unstable; urgency=medium
+  [ Corey Bryant ]
+  * New upstream milestone for OpenStack Ocata.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/p/google-back-requirements.patch: Rebased.
 
-  * New upstream release.
-  * Uploading to unstable.
-  * Updated ja.po debconf translation (Closes: #816343).
-  * Ran debconf-updatepo.
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 16 Dec 2016 12:08:46 -0500
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 05 Apr 2016 10:43:20 +0200
+cinder (2:10.0.0~b1-0ubuntu1) zesty; urgency=medium
 
-cinder (2:8.0.0~rc1-2) experimental; urgency=medium
+  [ Chuck Short ]
+  * New upstream version.
+  * debian/patches/fix-long-casting.patch: Dropped no longer needed.
+  * debian/patches/google-back-requirements.patch: Refreshed
+  * debian/control: Bump dependencies.
 
-  * Do not use Keystone admin auth token to register API endpoint.
+  [ Corey Bryant ]
+  * New upstream version.
+  * d/rules: Add PBR_VERSION to set correct distro version for package build.
+  * d/control: Align python-oslo.versionedobjects with upstream.
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 29 Mar 2016 12:24:55 +0000
+  [ David Della Vecchia ]
+  * New upstream milestone for OpenStack Ocata.
+  * d/control: Align (build-)depends with upstream.
 
-cinder (2:8.0.0~rc1-1) experimental; urgency=medium
+ -- David Della Vecchia <ddv@canonical.com>  Wed, 16 Nov 2016 15:33:19 -0500
 
-  * New upstream release.
-  * Disable non-deterministic failed tests:
-    cinder.tests.unit.test_volume.VolumeTestCase.test_create_delete_volume
-  * Fixed (build-)depends for this release.
-  * Reworked install-missing-files.patch.
-  * Standards-Version: 3.9.7 (no change).
+cinder (2:9.0.0-0ubuntu1) yakkety; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 14 Mar 2016 14:10:58 +0100
+  * New upstream release for OpenStack Newton.
 
-cinder (2:8.0.0~b3-1) experimental; urgency=medium
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 06 Oct 2016 09:54:51 -0400
 
-  [ Thomas Goirand ]
+cinder (2:9.0.0~rc2-0ubuntu1) yakkety; urgency=medium
+
+  * d/control: oslo.log min version level in global-requirements is too low,
+    so set min version to upper-constraints level (LP: #1628883).
+  * New upstream release candidate for OpenStack Newton.
+
+ -- Corey Bryant <corey.bryant@canonical.com>  Mon, 03 Oct 2016 10:36:51 -0400
+
+cinder (2:9.0.0~rc1-0ubuntu1) yakkety; urgency=medium
+
+  [ James Page ]
+  * d/p/bug1619246.patch: Drop, included upstream.
+
+  [ Corey Bryant ]
+  * New upstream version.
+  * d/p/*: Rebased.
+
+  [ James Page ]
+  * d/control: Drop tgt to a Recommends, allowing it to be removed in installs
+    where tgt is not required (LP: #1079466).
+  * d/control: Set correct minimum version of os-brick.
+
+  [ Corey Bryant ]
+  * New upstream release candidate for OpenStack Newton.
+
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 16 Sep 2016 08:55:56 -0400
+
+cinder (2:9.0.0~b3-0ubuntu2) yakkety; urgency=medium
+
+  * d/p/bug1619246.patch: Cherry pick fix for scheduling of
+    volumes with no volume type set (LP: #1619246).
+
+ -- James Page <james.page@ubuntu.com>  Mon, 05 Sep 2016 16:29:47 +0100
+
+cinder (2:9.0.0~b3-0ubuntu1) yakkety; urgency=medium
+
+  [ James Page ]
+  * d/p/skip-failing-tests.patch: Dropped, no longer upstream.
+
+  [ Corey Bryant ]
+  * d/p/*: Rebased.
+
+  [ James Page ]
+  * d/control: Add python-oslo.privsep to BD's.
   * New upstream release.
-  * Fixed (build-)depends for this release.
-  * New (build-)depends on python-oauth2client to ensure its version.
-  * Added missing build-depends on git, needed by sphinx-build.
-  * Fixed config file generation.
-  * Refreshed / rebased patches.
 
-  [ Ondřej Nový ]
-  * Fixed homepage (https).
-  * Fixed VCS URLs (https).
+  [ Corey Bryant ]
+  * d/p/google-back-requirements.patch: Rebased.
+  * d/control: Add python-pep8 to BDs.
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 25 Jan 2016 10:02:39 +0000
+  [ James Page ]
+  * New upstream release.
 
-cinder (2:8.0.0~b2-1) experimental; urgency=medium
+  [ Corey Bryant ]
+  * New upstream version.
+  * d/p/skip-test-retype-volume-migration-failed.patch: Dropped. Fixed upstream.
+  * d/p/*: Rebased.
 
+  [ James Page ]
   * New upstream release.
-  * Fixed (build-)depends for this release.
-  * Removed disable-zfs-tests.patch.
-  * Removed Downstream_Fix_for_Genconfig.patch.
-  * Added patch to remove zfssa tests.
-  * Added a doc-base registration file.
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 07 Dec 2015 14:05:41 +0100
+ -- James Page <james.page@ubuntu.com>  Fri, 02 Sep 2016 09:43:08 +0100
 
-cinder (2:7.0.0-4) unstable; urgency=medium
+cinder (2:9.0.0~b2-0ubuntu1) yakkety; urgency=medium
 
-  * Added q-text-as-data as depends for cinder-api.
+  [ Corey Bryant ]
+  * New upstream milestone for OpenStack Newton.
+  * d/control: Align (Build-)Depends with upstream.
+  * New upstream version.
+  * d/p/google-back-requirements.patch: Rebased.
+  * d/p/*: Rebased.
+  * d/control: Add python-ipaddress to (Build-)Depends.
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 03 Nov 2015 11:32:01 +0000
+  [ David Della Vecchia ]
+  * New upstream version.
+  * d/p/skip-test-retype-volume-migration-failed.patch: Rebased.
+  * d/p/google-back-requirements.patch: Rebased.
 
-cinder (2:7.0.0-3) unstable; urgency=medium
+  [ James Page ]
+  * d/p/fix-i386.patch: Drop, included upstream.
+  * New upstream version.
+  * d/p/*: Refresh.
 
-  * Using Keystone API v3 to register in the catalog.
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 14 Jul 2016 10:12:27 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 02 Nov 2015 18:19:42 +0000
+cinder (2:9.0.0~b1-0ubuntu1) yakkety; urgency=medium
 
-cinder (2:7.0.0-2) unstable; urgency=medium
+  [ James Page ]
+  * New upstream version.
+  * d/control,d/p/*: Restore BD's for google backup tests, limit patch
+    to removal of hard runtime requirement on required dependencies.
+  * d/p/Drop-use-of-invalid-assert_called_once-call.patch: Cherry pick
+    inflight fix for invalid use of assert methods.
+  * d/p/*: Refresh.
+
+  [ Corey Bryant ]
+  * d/p/skip-test-retype-volume-migration-failed.patch: Skip
+    test_retype_volume_migration_failed until bug is resolved.
+    https://bugs.launchpad.net/cinder/+bug/1582306
+  * d/p/skip-timeout-exception.patch: Skip
+    test_snapshot_failure_when_remote_is_unreachable until bug is resolved.
+    https://bugs.launchpad.net/cinder/+bug/1582370
+  * d/p/skip-timeout-exceptions.patch: Dropped. Fixed upstream.
+  * d/p/Drop-use-of-invalid-assert_called_once-call.patch: Dropped. Fixed
+    upstream.
+  * d/p/google-back-requirements.patch: Rebased.
+  * New upstream milestone for OpenStack Newton.
+  * d/control: Align (Build-)Depends with upstream.
+  * d/control: Leave paramiko at >= 1.16.0 for b1.
 
-  * Uploading to unstable.
+ -- Corey Bryant <corey.bryant@canonical.com>  Mon, 06 Jun 2016 09:16:13 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 16 Oct 2015 13:44:00 +0000
+cinder (2:8.0.0-0ubuntu1) xenial; urgency=medium
 
-cinder (2:7.0.0-1) experimental; urgency=medium
+  [ Corey Bryant ]
+  * d/p/fix-i386.patch: Fix failures for i386.
 
-  * New upstream release.
-  * Setup both v1 and v2 endpoints.
+  [ David Della Vecchia ]
+  * Final upstream release for OpenStack Mitaka.
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 15 Oct 2015 15:49:18 +0200
+ -- David Della Vecchia <ddv@canonical.com>  Fri, 08 Apr 2016 14:14:21 +0100
 
-cinder (2:7.0.0~rc2-1) experimental; urgency=medium
+cinder (2:8.0.0~rc1-0ubuntu2) xenial; urgency=medium
 
-  * cinder-api depends on python-openstackclient.
-  * cinder-api also registering the volumev2 type.
-  * Fixed cinder.conf generation:
-    - Fixed the default path for lock_path.
-    - Added upstream patch for fixing config file generation.
-    - Manually set enabled_backends = lvm, and appends a [lvm] section to set
-      the LVM backend as default.
+  * d/p/skip-google-backup-tests.patch: Drop oauth2client from requirements.txt
+    as its only requires to support Google backup, unblocking migration from
+    proposed pocket.
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 29 Sep 2015 13:23:42 +0000
+ -- James Page <james.page@ubuntu.com>  Wed, 30 Mar 2016 12:20:09 +0100
 
-cinder (2:7.0.0~rc1-1) experimental; urgency=medium
+cinder (2:8.0.0~rc1-0ubuntu1) xenial; urgency=medium
 
-  * New upstream release.
-  * Fixed (build-)depends for this release.
-  * Refresh patch.
+  * New upstream release candidate for OpenStack Mitaka.
+  * Align (Build-)Depends with upstream.
+  * d/p/*: Rebased.
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 25 Sep 2015 10:01:08 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 23 Mar 2016 21:34:24 -0400
 
-cinder (2:7.0.0~b3-1) experimental; urgency=medium
+cinder (2:8.0.0~b3-0ubuntu2) xenial; urgency=medium
 
-  * New upstream release.
-  * Align with MOS packaging:
-    - Bumped EPOCH to 2 instead of 1.
-    - Some Ubuntu version lower bounds for dependencies.
-    - Added a cinder-doc package.
-  * Fixed (build-)depends for this release.
-  * Refreshed disable-zfs-tests.patch.
+  * d/p/skip-google-backup-tests.patch: Drop python-googleapi from requirements.txt.
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 01 Sep 2015 13:56:21 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 15 Mar 2016 17:01:42 -0400
 
-cinder (1:7.0.0~b2-1) experimental; urgency=medium
+cinder (2:8.0.0~b3-0ubuntu1) xenial; urgency=medium
 
-  * New upstream release.
-  * Updated (build-)depends for this release.
-  * Fixed OSLO_PACKAGE_VERSION for last PBR version.
-  * Disable zfs tests.
+  * New upstream milestone for OpenStack Mitaka.
+  * Align (Build-)Depends with upstream.
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 10 Jul 2015 09:41:59 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Mon, 07 Mar 2016 09:59:19 -0500
 
-cinder (2015.1.0+2015.06.16.git26.9634b76ba5-3) unstable; urgency=medium
+cinder (2:8.0.0~b2-0ubuntu2) xenial; urgency=medium
 
-  * Rebuilt for sqlalchemy 1.0.6.
+  * d/control: Drop python-googleapi from (Build-)Depends and move to Suggests.
+  * d/rules, d/p/skip-google-backup-tests.patch: Skip python-googleapi tests.
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 01 Jul 2015 02:21:46 +0000
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 18 Feb 2016 12:07:28 -0500
 
-cinder (2015.1.0+2015.06.16.git26.9634b76ba5-2) unstable; urgency=medium
+cinder (2:8.0.0~b2-0ubuntu1) xenial; urgency=medium
 
-  * Fixed changelog regarding CVE number: CVE-2015-1851 and not
-    CVE-2015-1850 (Closes: #789349).
+  * New upstream milestone for OpenStack Mitaka.
+  * d/control: Align dependencies with upstream.
 
- -- Thomas Goirand <zigo@debian.org>  Sun, 21 Jun 2015 14:21:31 +0000
+ -- David Della Vecchia <ddv@canonical.com>  Mon, 25 Jan 2016 10:04:27 -0500
 
-cinder (2015.1.0+2015.06.16.git26.9634b76ba5-1) unstable; urgency=high
+cinder (2:8.0.0~b1-0ubuntu1) xenial; urgency=medium
 
-  * New upstream release (based on commit 26th g9634b76):
-    - Addresses CVE-2015-1851 / OSSA 2015-011 (Closes: #788996).
+  * New upstream milestone for OpenStack Mitaka: 
+    - d/control: Align dependencies with upstream.
+    - d/cinder-common.install: Adding new wsgi binary entrypoint. 
 
- -- Thomas Goirand <zigo@debian.org>  Tue, 16 Jun 2015 22:36:48 +0200
+ -- David Della Vecchia <ddv@canonical.com>  Fri, 18 Dec 2015 08:06:32 -0500
 
-cinder (2015.1.0+2015.06.06.git24.493b6c7f12-1) unstable; urgency=medium
+cinder (2:7.0.0-0ubuntu1) wily; urgency=medium
 
-  * New upstream release (basing on commit 24th 2015.06.06 493b6c7f12).
-  * Fixed debian/watch file to read from correct cinder project and not Nova.
-  * Fixed config file generation taking patches from upstream.
+  * New upstream release for OpenStack Liberty.
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 11 May 2015 23:07:24 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 15 Oct 2015 12:36:21 -0400
 
-cinder (2015.1.0-1) unstable; urgency=medium
+cinder (2:7.0.0~rc3-0ubuntu1) wily; urgency=medium
 
-  * New upstream release.
-  * Fixed gbp.conf.
+  * New upstream release candidate for OpenStack Liberty.
+  * d/control: Align dependencies with upstream.
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 30 Apr 2015 21:33:43 +0000
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 14 Oct 2015 10:18:59 -0400
 
-cinder (2015.1~rc2-1) unstable; urgency=medium
+cinder (2:7.0.0~rc2-0ubuntu1) wily; urgency=medium
 
-  * New upstream release.
-  * Uploading to unstable.
-  * Updated (build-)depends for this release.
-  * Now generates cinder.conf on the fly.
-  * Added Fix_borked_StorPool_driver.patch
+  * New upstream release candidate for OpenStack Liberty.
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 09 Apr 2015 23:48:10 +0200
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 06 Oct 2015 11:16:42 -0400
 
-cinder (2014.2.1-1) experimental; urgency=medium
+cinder (2:7.0.0~rc1-0ubuntu1) wily; urgency=medium
 
-  * New upstream release.
-  * Now depends on openstack-pkg-tools (>= 20~) to avoid systemd issues with
-    previous versions.
+  * d/watch: Update for upstream rc versioning.
+  * New upstream milestone for OpenStack Liberty.
+  * d/control: Align (build-)depends with upstream.
+
+ -- James Page <james.page@ubuntu.com>  Mon, 28 Sep 2015 11:31:25 +0100
+
+cinder (2:7.0.0~b3-0ubuntu1) wily; urgency=medium
+
+  * New upstream milestone for OpenStack Liberty.
+  * d/control: Align (build-)depends with upstream.
+  * d/p/skip-failing-tests.patch: Rebased.
+
+ -- Corey Bryant <corey.bryant@canonical.com>  Tue, 08 Sep 2015 15:49:21 -0400
+
+cinder (2:7.0.0~b2-0ubuntu1) wily; urgency=medium
+
+  * New upstream milestone for OpenStack Liberty.
+  * d/control: Align (build-)depends with upstream.
+  * d/p/fix-requirements.patch: Dropped. dh_python2 no longer guesses
+    dependencies.
+  * d/p/skip-failing-tests.patch: Rebased.
+  * d/rules: Remove .eggs directory in override_dh_auto_clean.
+
+ -- Corey Bryant <corey.bryant@canonical.com>  Fri, 14 Aug 2015 15:24:17 -0400
+
+cinder (2:7.0.0~b1-0ubuntu3) wily; urgency=medium
+
+  * d/pydist-overrides: Ignore dependency on suds-jurko (provided by
+    suds in distro).
+
+ -- James Page <james.page@ubuntu.com>  Wed, 05 Aug 2015 10:48:34 +0200
+
+cinder (2:7.0.0~b1-0ubuntu2) wily; urgency=medium
+
+  * d/p/skip-failing-tests.patch: Skip single failing test in Ubuntu
+    buildd environment due to limit egress network access, resolving
+    FTBFS. 
+
+ -- James Page <james.page@ubuntu.com>  Fri, 24 Jul 2015 09:39:28 +0100
+
+cinder (2:7.0.0~b1-0ubuntu1) wily; urgency=medium
+
+  * New upstream milestone for OpenStack Liberty.
+  * Align (Build-)Depends with upstream.
+
+ -- James Page <james.page@ubuntu.com>  Thu, 09 Jul 2015 09:28:33 +0100
+
+cinder (1:2015.1.0-0ubuntu1) vivid; urgency=medium
+
+  [ Chuck Short ]
+  * New upstream release for OpenStack Kilo. (LP: #1449744)
+
+  [ James Page ]
+  * d/p/*: Refresh.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Sun, 03 May 2015 13:40:57 -0400
+
+cinder (1:2015.1~rc1-0ubuntu1) vivid; urgency=medium
+
+  [ Chuck Short ]
+  * New upstream milestone release:
+    - d/control: Align with upstream dependencies.
+
+  [ James Page ]
+  * d/p/*: Refreshed. 
+
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 15 Apr 2015 13:53:09 -0400
+
+cinder (1:2015.1~b3-0ubuntu1) vivid; urgency=medium
+
+  [ James Page ]
+  * d/pydist-overrides: Add overrides for oslo packages.
 
- -- Thomas Goirand <zigo@debian.org>  Sun, 14 Dec 2014 08:59:02 +0000
+  [ Corey Bryant ]
+  * New upstream milestone release for OpenStack Kilo:
+    - d/control: Align with upstream dependencies.
+    - d/p/skip-huaweistorac-delete-snapshot-success-test.patch: Dropped.
+      Patched test has been removed.
 
-cinder (2014.2-1) experimental; urgency=medium
+  [ James Page ]
+  * d/control: Add missing BD on python-testresources.
+  * d/p/fix-long-casting.patch: Workaround some problematic type casting between
+    int/long (LP: #1435242).
+  * d/p/fix-assert-raises-regex-tests.patch: Patchup incorrect usage of
+    assertUsesRegex{p} in unit tests.
 
+ -- James Page <james.page@ubuntu.com>  Mon, 30 Mar 2015 11:07:20 +0100
+
+cinder (1:2015.1~b2-0ubuntu1) vivid; urgency=medium
+
+  [ Corey Bryant ]
   * New upstream release.
+    - d/control: Align with upstream dependencies.
+    - d/p/fix-assert-raises-regex-tests.patch: Dropped. Fixed upstream.
+    - d/p/remove-private-_lazy-import.patch: Dropped. Fixed upstream.
+    - d/p/pep-0476.patch: Dropped. Fixed upstream.
+    - d/p/skip-rtslib-test.patch: Rebased.
+    - d/p/fix-requirements.patch: Rebased.
+    - d/p/skip-huaweistorac-delete-snapshot-success-test.patch: Rebased.
+
+  [ James Page ]
+  * d/control: Transition to new non-namespaced oslo packages.
+  * d/p/skip-rtslib-test.patch: Rewrite to be a little more elegant. 
+
+ -- Corey Bryant <corey.bryant@canonical.com>  Mon, 16 Feb 2015 10:39:55 +0000
+
+cinder (1:2015.1~b1-0ubuntu5) vivid; urgency=medium
+
+  * d/p/remove-private-_lazy-import.patch: Cherry picked from master and
+    adapted. Fixes tests that were importing internal i18n._lazy module.
+  * d/p/pep-0476.patch: Deal with PEP-0476 certificate chain checking.
+  * d/p/skip-ssl-tests.patch: Dropped in favor of pep-0476.patch.
+
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 15 Jan 2015 08:06:53 +0000
+
+cinder (1:2015.1~b1-0ubuntu4) vivid; urgency=medium
+
+  * Rebuild to pick up pkgos upstart generation fix.
+    - d/control: Bump openstack-pkg-tools to ensure upstart fix inclusion.
+
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 14 Jan 2015 10:40:32 -0500
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 16 Oct 2014 15:23:17 +0000
+cinder (1:2015.1~b1-0ubuntu3) vivid; urgency=medium
 
-cinder (2014.2~rc2-1) experimental; urgency=medium
+  * d/p/fix-iscsi-initiator-exception.patch: Dropped. Abandoned upstream.
+  * d/p/skip-huaweistorac-delete-snapshot-success-test.patch: Handle OSError
+    exception.
+  * d/cinder-common.logrotate: Apply to all cinder log files.
 
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 08 Jan 2015 10:53:04 -0500
+
+cinder (1:2015.1~b1-0ubuntu2) vivid; urgency=medium
+
+  * Systemd enablement:
+    - d/control: Add dh-systemd and openstack-pkg-tools to BD's.
+    - d/rules: Enable use of pkgos, tidyup generated init files.
+    - d/*.init.in: Cherry pick pkgos template configurations from
+      Debian cinder package (thanks Thomas).
+    - d/*.upstart: Drop in preference to generated files.
+  * d/control,compat: Bump debhelper compat level to 9.
+  * d/*.logrotate,cinder-common.logrotate: Move to single logrotate
+    configuration.
+
+ -- James Page <james.page@ubuntu.com>  Thu, 08 Jan 2015 14:18:18 +0000
+
+cinder (1:2015.1~b1-0ubuntu1) vivid; urgency=medium
+
+  [ Chuck Short ]
+  * Open for vivid.
+  * debian/control: Update bzr branch.
+  * debian/patches/fix-requirements.patch: Refreshed.
+
+  [ Corey Bryant ]
   * New upstream release.
-  * Updated (build-)depends for this release.
-  * Switching to templated init scripts using openstack-pkg-tools >= 13.
-  * Mangling upstream rc and beta versions in watch file.
-  * Now using a single cinder-common.logrotate file instead of so many.
-  * Standards-Version is now 3.9.6 (no change).
+    - d/watch: Update uversionmangle for kilo beta naming.
+    - d/control: Align requirements with upstream.
+    - d/p/fix-requirements.patch: Refreshed.
+    - d/p/skip-ssl-tests.patch: Skip tests that fail due to PEP 476.
+    - d/p/fix-iscsi-initiator-exception.patch: Handle OSError exception.
+      Cherry picked from //review.openstack.org/#/c/145342/.
+    - d/p/fix-assert-raises-regex-tests.patch: Use assertRaisesRegexp().
+      Cherry picked from https://review.openstack.org/#/c/145041/.
+    - d/p/skip-rtslib-test.patch: Skip rtslib related tests.
+  * d/control: Bumped Standards-Version to 3.9.6.
 
- -- Thomas Goirand <zigo@debian.org>  Sun, 05 Oct 2014 14:23:48 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 07 Jan 2015 09:10:57 -0500
 
-cinder (2014.2~rc1-1) experimental; urgency=medium
+cinder (1:2014.2-0ubuntu1) utopic; urgency=medium
 
   * New upstream release.
-  * Updated (build-)depends for this release.
-  * Added more lintian-override for false positive about unused debconf
-    templates.
+  * d/watch: Only match versions starting with digits.
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 01 Oct 2014 15:43:51 +0800
+ -- James Page <james.page@ubuntu.com>  Thu, 16 Oct 2014 15:44:32 +0100
 
-cinder (2014.2~b3-2) experimental; urgency=medium
+cinder (1:2014.2~rc2-0ubuntu2) utopic; urgency=medium
 
-  * Fixed the DB connection directive name and section.
+  * d/control: Add missing Depends on qemu-utils to cinder-volume
+    (LP: #1381395).
+  * d/cinder_sudoers: Add missing trailing *, resolving issues running
+    commands using rootwrap (LP: #1380425).
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 24 Sep 2014 18:50:02 +0800
+ -- James Page <james.page@ubuntu.com>  Wed, 15 Oct 2014 10:15:38 +0100
 
-cinder (2014.2~b3-1) experimental; urgency=medium
+cinder (1:2014.2~rc2-0ubuntu1) utopic; urgency=medium
 
-  [ Thomas Goirand ]
-  * New upstream release.
-  * New (build-)depends for this release.
-  * Removes usr/bin/cinder-rpc-zmq-receiver fron cinder-common.install,
-    as its gone upstream (moved into Oslo, it seems).
+  [ Corey Bryant ]
+  * New upstream release candidate.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 09 Oct 2014 15:38:58 -0400
+
+cinder (1:2014.2~rc1-0ubuntu1) utopic; urgency=medium
 
-  [ gustavo panizzo ]
-  * Support to run cinder daemons under systemd.
+  [ Chuck Short ]
+  * debian/patches/debian/patches/fix-requirements.patch: Rediffed.
 
- -- Thomas Goirand <zigo@debian.org>  Sat, 20 Sep 2014 10:15:10 +0000
+  [ James Page ]
+  * New upstream release candidate:
+    - d/p/fix-glance-tests.patch: Dropped, included upstream.
+    - d/control: Align dependency versions with upstream release.
+  * d/watch: Use tarballs.openstack.org for releases.
+  * d/rules: Run testr directly rather than through run_tests.sh.
+  * d/control: Update maintainer.
 
-cinder (2014.1.1-2) unstable; urgency=medium
+ -- James Page <james.page@ubuntu.com>  Wed, 01 Oct 2014 10:00:19 +0100
 
-  * cinder-volume now depends on tgt >= 1:1.0.17-1.1~ (Closes: 751703).
+cinder (1:2014.2~b3-0ubuntu2) utopic; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 16 Jun 2014 15:37:47 +0800
+  [ Chuck Short ]
+  * d/control: Add python-barbicanclient as a dependency.
+  * d/p/no-barbican.patch: Dropped.
 
-cinder (2014.1.1-1) unstable; urgency=medium
+  [ James Page ]
+  * d/rules: Re-enable test suite.
+  * d/control: Align versioned dependencies to Juno b3.
+  * d/p/fix-glance-tests.patch: Cherry pick fix from upstream VCS to
+    resolve unit test failures with glance v2 client.
+
+ -- James Page <james.page@ubuntu.com>  Thu, 18 Sep 2014 16:45:51 +0100
+
+cinder (1:2014.2~b3-0ubuntu1) utopic; urgency=medium
+
+  * New upstream version (LP: #1366146)
+  * debian/cinder-common.install: Removed cinder-rpc-zmq-receiver.
+  * debian/cinder-volume.install: Removed cinder-clear-rabbit-queues.
+  * debian/control: Add python-oslo.i18n.
+  * debian/control: Add python-osprofiler.
+  * debian/patches/no-barbican.patch: Dont use python-barbican because its
+    not in the archive yet.
+  * debian/rules: Temporarily disable tests.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 05 Sep 2014 15:23:13 -0400
+
+cinder (1:2014.2~b2-0ubuntu1) utopic; urgency=medium
 
   * New upstream release.
-  * Removed fallback-to-None-on-missing-Glance-image-attrs.patch applied
-    upstream.
-  * Bumped python-six minimal requirements to 1.6.0.
+  * Clean up dependencies:
+    - debian/control: Dropped python-d2to1, python-hp3parclient,
+      python-hplefthandclient, python-lockfile, python-amqplib
+    - debian/control: Add python-oslosphinx, python-requests,
+      python-hacking, python-oslo.db.
+  * debian/patches/fix-requirements.patch: Refreshed.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 24 Jul 2014 13:44:04 -0400
+
+cinder (1:2014.2~b1-0ubuntu2) utopic; urgency=medium
+
+  * SECURITY UPDATE: specify /etc/nova/rootwrap.conf for use with
+    nova-rootwrap
+    - CVE-2013-1068 (LP: #1185019) 
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 09 Jun 2014 22:08:57 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 18 Jun 2014 11:37:45 -0400
 
-cinder (2014.1-7) unstable; urgency=medium
+cinder (1:2014.2~b1-0ubuntu1) utopic; urgency=medium
 
-  * Now build-depends on openstack-pkg-tools >= 0.12~.
+  * New upstream release.
+  * debian/control: Open up juno release
+  * debian/patches/fix-requirements.patch: Refreshed.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 12 Jun 2014 10:35:06 -0400
+
+cinder (1:2014.1-0ubuntu1) trusty; urgency=medium
+
+  * New upstream release (LP: #1299055).
+
+ -- Corey Bryant <corey.bryant@canonical.com>  Wed, 16 Apr 2014 13:06:37 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 05 Jun 2014 07:04:33 +0000
+cinder (1:2014.1~rc3-0ubuntu1) trusty; urgency=medium
 
-cinder (2014.1-6) unstable; urgency=medium
+  * New release candidate (LP: #1299010).
 
-  * Switched from restarting daemons to copytruncate in logrotate.
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 15 Apr 2014 09:02:40 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 29 May 2014 14:01:00 +0800
+cinder (1:2014.1~rc2-0ubuntu1) trusty; urgency=medium
 
-cinder (2014.1-5) unstable; urgency=medium
+  * New upstream release (LP: #1299010).
 
-  * Disable https for the default keystone conf, as this makes our CI fail.
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 07 Apr 2014 11:18:57 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 05 May 2014 13:14:58 +0800
+cinder (1:2014.1~rc1-0ubuntu1) trusty; urgency=medium
 
-cinder (2014.1-4) unstable; urgency=medium
+  * New upstream release (LP: #1299010).
+  * debian/patches/fixup-rbd-str-handling.patch: Dropped no longer needed. 
+  * debian/patches/fix-requirements.patch: Rediffed. 
+  * debian/control: Add python-oslo.messaging.
 
-  * Updated intalian debconf translations (Closes: #745386).
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 28 Mar 2014 09:48:21 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Sat, 03 May 2014 04:06:37 +0000
+cinder (1:2014.1~b3-0ubuntu3) trusty; urgency=medium
 
-cinder (2014.1-3) unstable; urgency=medium
+  * d/p/fixup-rbd-str-handling.patch: Cherry pick fix from upstream
+    Gerrit to resolve issue deleting Ceph volumes and snapshots
+    (LP: #1292433).
+  * d/control,rules: Use upstream run_tests.sh wrapper to execute unit tests,
+    add subunit to BD's to ensure output is correctly formatted.
 
-  * Now using keystone_authtoken in cinder.conf instead of api-paste.ini:
-    - Fixed config and postinst scripts of cinder-common to use that.
-    - Removed patch for api-paste.ini.
+ -- James Page <james.page@ubuntu.com>  Fri, 14 Mar 2014 11:19:16 +0000
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 01 May 2014 00:01:50 +0800
+cinder (1:2014.1~b3-0ubuntu2) trusty; urgency=medium
 
-cinder (2014.1-2) unstable; urgency=medium
+  * d/cinder-common.postinst: Correct use of getent (LP: #1224275). 
+  * d/cinder-common.postinst: Tidy detection of local sqlite database use
+    for db sync operations (LP: #1290423).
 
-  * Applied patch from Mike Perez <thingee@gmail.com> to be able to create
-    volume from glance image without checksum.
+ -- James Page <james.page@ubuntu.com>  Thu, 13 Mar 2014 10:11:20 +0000
 
- -- Thomas Goirand <zigo@debian.org>  Sat, 26 Apr 2014 23:12:30 +0800
+cinder (1:2014.1~b3-0ubuntu1) trusty; urgency=medium
 
-cinder (2014.1-1) unstable; urgency=medium
+  [ Chuck Short ]
+  * debian/patches/fix-requirements.patch: Refreshed. 
+  * debian/control: Bump python-keystoneclient to 0.4.2.
+  * debian/patches/skip-tests.patch: Temporarily skip
+    testlefthand tests since the needed python library hasnt been 
+    packaged yet.
 
+  [ James Page ]
+  * d/p/fix-requirements.patch: Refreshed.
+  * d/control,d/p/series/skip-tests.patch: Add BD on python-hplefthandclient,
+    bump version requirement on python-hp3parclient to >= 3.0.0 and drop
+    patch that skips hplefthandclient tests.
+
+  [ Corey Bryant ]
   * New upstream release.
-  * Uploading to unstable.
-  * Applied patch from Sylvain Baubeau <sylvain.baubeau@enovance.com> to select
-    log destination (to syslog or to a file).
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 09 Apr 2014 22:09:38 +0800
+ -- Corey Bryant <corey.bryant@canonical.com>  Thu, 06 Mar 2014 13:16:02 -0500
+
+cinder (1:2014.1~b2-0ubuntu1) trusty; urgency=low
 
-cinder (2014.1~rc1-1) experimental; urgency=low
+  [ James Page ]
+  * d/control: Add versioned dependency python-six >= 1.4.1 (LP: #1259203). 
+  * d/p/*: Refreshed.
 
+  [Chuck Short]
   * New upstream release.
-  * Removed now useless fix-sqlalchemy-version patch.
-  * Fixed new (build-)dependencies for this release.
+  * debian/control: Add python-taskflow as a dependency.
+  * debian/control: Add python-oslo.rootwrap as a dependency.
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 28 Mar 2014 18:40:20 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 23 Jan 2014 12:41:54 -0500
 
-cinder (2014.1~b3-1) experimental; urgency=low
+cinder (1:2014.1~b1-0ubuntu1) trusty; urgency=low
 
+  [ Chuck Short ]
   * New upstream release.
+  * debian/control:
+    - Open icehouse release.
+    - Add python-rtslib as a dependency.
+  * debian/patches/fix-sqlalchemy-requirements.patch: Dropped no longer needed.
+  * debian/patches/fix-babel-requirements.patch: Dropped no longer needed.
+  * debian/paches/fix-requirements.patch:  Fixed up requirements.txt for 
+    dependencies we have in Ubuntu.
+  * debian/cinder-common.install: Add "cinder-rtstool".
+
+  [ James Page ]
+  * debian/patches/*: Refresh.
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 17 Feb 2014 15:11:34 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 05 Dec 2013 21:30:40 -0500
 
-cinder (2013.2.2-2) unstable; urgency=medium
+cinder (1:2013.2-0ubuntu1) saucy; urgency=low
 
-  * Rebuilt using openstack-pkg-tools >= 9.
+  * New upstream release (LP: #1236462).
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 14 Feb 2014 17:36:24 +0000
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 17 Oct 2013 10:00:43 -0400
 
-cinder (2013.2.2-1) unstable; urgency=medium
+cinder (1:2013.2~rc3-0ubuntu1) saucy; urgency=low
 
-  * New upstream point release.
+  * New upstream release candidate (LP: #1240254).
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 14 Feb 2014 11:04:50 +0800
+ -- James Page <james.page@ubuntu.com>  Wed, 16 Oct 2013 08:59:28 +0100
 
-cinder (2013.2.1-4) unstable; urgency=medium
+cinder (1:2013.2~rc2-0ubuntu1) saucy; urgency=low
 
-  * Added postrotate script after logrotate to restart daemons.
-  * Fix webob version in requirements.txt.
+  * New upstream release candidate (LP: #1239156). 
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 03 Feb 2014 15:49:21 +0800
+ -- James Page <james.page@ubuntu.com>  Sat, 12 Oct 2013 16:52:11 +0100
 
-cinder (2013.2.1-3) unstable; urgency=medium
+cinder (1:2013.2~rc1-0ubuntu1) saucy; urgency=low
 
-  * Updated fr.po debconf thanks to Julien Patriarca (Closes: #733091).
-  * New sv.po debconf translation thanks to Martin Bagge (Closes: #734585).
+  * New upstream release candidate.
+  * debian/patches/skip-sqlachemy-failures.patch: Dropped
+  * debian/patches/fix-sqlalchemy-requirements.patch: Refreshed.
+  * debian/patches/fix-babel-requirements.patch: Revert dependency requirement
+    for python-babel.
+  * debian/control:
+    - Dropped python-nose and python-setuptool-git.
+    - Added python-netaddr as a build-dependency. (LP: #1227153)
+    - Added python-six as a build-dependency.
+    - Added versioned dependencies to python-pbr, python-amqplib,
+      python-glanceclient, python-novaclient, and python-swiftclient,
+      python-lxml, python-webob, python-oslo.config, python-sqlalchemy,
+      python-fixtures, python-testtools, and python-fixtures
+    - Bumped versioned dependencies for python-eventlet, python-hp3parclient,
+      python-keystoneclient, and python-novaclient
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 13 Jan 2014 17:27:07 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 04 Oct 2013 08:40:26 -0400
 
-cinder (2013.2.1-2) unstable; urgency=medium
+cinder (1:2013.2~b3-0ubuntu1) saucy; urgency=low
 
-  * Kills the "cinder enable" debconf feature. (Closes: #732547)
-  * Adds a Spanish debconf translation thanks to Matias A. Bellone
-    <matiasbellone+debian@gmail.com> (Closes: #732535).
+  [ James Page ]
+  * d/control: Switch ceph-common -> python-ceph inline with upstream
+    refactoring of Ceph RBD driver, move to Suggests of python-cinder.
+    (LP: #1190791). 
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 19 Dec 2013 15:46:34 +0800
+  [ Adam Gandelman ]
+  * debian/patches/avoid_paramiko_vers_depends.patch: Dropped, no longer
+    required.
+  * Add minimum requirement python-greenlet (>= 0.3.2).
+  * Add minimum requirement python-eventlet (>= 0.12.0).
+  * Add minimum requirement python-paramiko (>= 1.8).
 
-cinder (2013.2.1-1) unstable; urgency=medium
+  [ Chuck Short ]
+  * New upstream release.
+  * debian/patches/skip-sqlachemy-failures.patch: Skip testfailures
+    with sqlalchemy 0.8 until they are fixed upstream.
+  * debian/control: Add python-babel to build-depends.
+  * debian/control: Add python-novaclient to build-depends.
 
-  * New upstream release (Icehouse beta 1).
+ -- Chuck Short <zulcss@ubuntu.com>  Sun, 08 Sep 2013 21:09:46 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 09 Dec 2013 21:07:33 +0800
+cinder (1:2013.2~b2-0ubuntu3) saucy; urgency=low
 
-cinder (2013.2-2) unstable; urgency=medium
+  * debian/patches/fix-sqlalchemy-requirements.patch: Fix requirements for sqlalchemy
+    0.8.
 
-  * Updated debconf translations with warm thanks to:
-    - French, Julien Patriarca <leatherface@debian.org> (Closes: #728769).
-    - Russian, Yuri Kozlov <yuray@komyakino.ru> (Closes: #729775).
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 22 Jul 2013 10:03:52 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Sun, 08 Dec 2013 11:21:20 +0800
+cinder (1:2013.2~b2-0ubuntu2) saucy; urgency=low
 
-cinder (2013.2-1) unstable; urgency=low
+  * d/rules: Disable test parallel execution; causing FTBFS when high
+    levels of concurrency occur on buildds. 
 
-  * New upstream release.
-  * Uploading to unstable.
-  * Fixed the path to the log files in the init scripts.
-  * Fixed the value of the state_path directive to /var/lib/cinder instead of
-    somewhere in /usr/lib/python2.x.
+ -- James Page <james.page@ubuntu.com>  Sun, 21 Jul 2013 10:10:10 +0100
+
+cinder (1:2013.2~b2-0ubuntu1) saucy; urgency=low
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 17 Oct 2013 01:02:21 +0800
+  [ Chuck Short ]
+  * debian/patches/avoid_paramiko_vers_depends.patch: Refreshed
+  * debian/control: Add missing testrepostory.
+  * debian/rules: Use testr directly.
 
-cinder (2013.2~rc3-1) experimental; urgency=low
+  [ Adam Gandelman ]
+  * debian/control:
+    - Add minimum requirement python-anyjson (>= 0.3.3).
+    - Add minimum requirement python-keystoneclient (>= 0.2.3).
+    - Add minimum requirement python-kombu (>= 2.5.12).
 
+  [ James Page ]
   * New upstream release.
-  * Kills the CEPH_ARGS hack in /etc/default/cinder and cinder-volume.init
-    since that's not needed anymore (upstream code manages this now in the
-    configuration file directly).
-  * sed -i "s/#auth_strategy=noauth/auth_strategy=keystone/" in the default
-    packaged cinder.conf (otherwise it doesn't work by default).
+  * d/control: Update VCS fields for new branch locations.
+  * d/rules: Run unit tests in parallel.
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 11 Oct 2013 22:54:46 +0800
+ -- James Page <james.page@ubuntu.com>  Fri, 19 Jul 2013 14:14:40 +0100
 
-cinder (2013.2~rc1-2) experimental; urgency=low
+cinder (1:2013.2~b1-0ubuntu2) saucy; urgency=low
 
-  * Updates the templates and translations to really (Closes: #708658).
+  [ Chuck Short ]
+  * debian/patches/avoid_paramiko_vers_depends.patch: Refreshed
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 09 Oct 2013 23:32:13 +0800
+  [ Adam Gandelman ]
+  * debian/control: Bump min. stevedore version >= 0.9.
+ 
+  [Yolanda Robla]
+  * debian/tests: Added autopkgtests.
 
-cinder (2013.2~rc1-1) experimental; urgency=low
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 19 Jun 2013 12:45:18 -0500
 
-  * New upstream release.
-  * Reviewed (build-)dependencies.
+cinder (1:2013.2~b1-0ubuntu1) saucy; urgency=low
+
+  [ Chuck Short ]
+  * New upstream version.
+  * debian/patches/fix_cinder_dependencies.patch: Dropped.
+  * debian/control: Bump standards version to 3.9.4.
+  * debian/control: Add python-pbr and python-d2to1 to build-depends.
+  * debian/control: Add python-testtools and python-fixtures to build-depends
+  * debian/rules: Add work around to remove wonky setup.py setup
+  * debian/cinder-common.install: Add cinder-rpc-zmq-receiver binary.
+
+  [ James Page ]
+  * debian/control: Drop surplus dependency on python-glance (LP: #1175600).
+  * debian/control,rules: Drop dependency on pep8, don't run pep8 tests during
+    package build process (its just way to late).
+  * debian/control: Drop surplus BD on python-cheetah.
+
+  [ Adam Gandelman ]
+  * debian/patches/avoid_paramiko_vers_depends.patch: Avoid version
+    requirement on paramiko.
 
- -- Thomas Goirand <zigo@debian.org>  Sat, 22 Jun 2013 16:27:46 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 31 May 2013 10:01:03 -0500
 
-cinder (2013.1.3-1) unstable; urgency=low
+cinder (1:2013.1-0ubuntu2) raring; urgency=low
 
-  * New upstream point release.
-  * Added several Debconf templates translations:
-    - Portuguese, thanks to Miguel Figueiredo (Closes: #705707).
-    - Italian, thanks to Beatrice Torracca (Closes: #719879).
-    - Czech, thanks to Michal Šimůnek (Closes: #721135).
-  * Removes now applied upstream patches for CVE-2013-4202 & CVE-2013-4183.
+  * debian/control: Bump minimum stevedore version 0.8.
+    (LP: #1169730)
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 30 Aug 2013 11:35:22 +0800
+ -- Adam Gandelman <adamg@ubuntu.com>  Tue, 16 Apr 2013 14:38:46 -0700
 
-cinder (2013.1.2-4) unstable; urgency=high
+cinder (1:2013.1-0ubuntu1) raring; urgency=low
 
-  * Adds missing depends: sqlite3.
-  * CVE-2013-4202: Fix DoS using XML entities in extensions (Closes:
-  * #719118).
-  * CVE-2013-4183: Enable zero the snapshot when delete snapshot in
-    LVMVolumeDriver (Closes: #719010).
+  * New upstream release. 
 
- -- Thomas Goirand <zigo@debian.org>  Sat, 13 Jul 2013 22:51:29 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 05 Apr 2013 07:53:23 -0500
 
-cinder (2013.1.2-3) unstable; urgency=low
+cinder (1:2013.1~rc3-0ubuntu1) raring; urgency=low
 
-  * Adds a patch to make it work with sqlalchemy >= 0.8 (Closes: #715431).
-  * Added build-depends: python-pywbem.
+  * New upstream release. 
 
- -- Thomas Goirand <zigo@debian.org>  Wed, 10 Jul 2013 15:28:16 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 27 Mar 2013 07:51:21 -0500
 
-cinder (2013.1.2-2) unstable; urgency=low
+cinder (1:2013.1~rc2-0ubuntu2) raring; urgency=low
 
-  * Starts Cinder after postgresql, mysql, keystone, rabbitmq-server and
-  * ntp.
-  * Added cinder-volume CEPH_ARGS export using what is configured in
-    /etc/default/cinder-volume.
-  * Rebuilds to use python-sqlalchemy >= 0.8.
+  * debian/rules: Fix FTBFS, we want '-v' and not '-V'. 
 
- -- Thomas Goirand <zigo@debian.org>  Sat, 22 Jun 2013 16:27:46 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 25 Mar 2013 08:30:42 -0500
 
-cinder (2013.1.2-1) unstable; urgency=low
+cinder (1:2013.1~rc2-0ubuntu1) raring; urgency=low
 
   * New upstream release.
+  * debian/control, debian/cinder-volume.install: Dropped rtstool and python-rtslib
+    since it was dropped upstream. 
+  * debian/rules: Run tests more verbosely.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Mon, 25 Mar 2013 07:59:45 -0500
+
+cinder (1:2013.1~rc1-0ubuntu1) raring; urgency=low
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 14 Jun 2013 22:55:23 +0800
+  [ Chuck Short ]
+  * debian/patches/fix-ubuntu-tests.patch: Dropped.
+  * debian/rules: Fix version number when building the testsuite. 
+  * debian/cinder-backup{.install, upstart, logroate}: Add cinder-backup
+    service.
+  * debian/rules: Run the testsuite against PYTHONPATH.
+  * debian/control: Update build-depends and run-time depends.
+    - Dropped python-glance not needed.
+    - Dropped python-cheetah not needed.
+    - Droped python-daemon not needed.
+    - Dropped python-netaddr not needed.
+    - Renamed python-oslo-config to python-oslo.config.
+    - Added python-keystoneclient to depends.
+    - Added python-swiftclient to depends.
+   * debian/pydist-overrides: No longer needed.
 
-cinder (2013.1.1-2) unstable; urgency=low
+  [ James Page ]
+  * New upstream release candidate.
+  * d/watch: Update uversionmangle to deal with upstream versioning
+    changes, remove tarballs.openstack.org.
+  * d/cinder.conf: Set lock_path to /var/lock/cinder (default is not
+    sensible).
 
-  * Added if [ -r /usr/share/dbconfig-common/dpkg/prerm ] in the prerm.
-  * Ran wrap-and-sort to clean stuff.
-  * Added creation and chown of /var/lib/cinder/{cache,volumes} after the
-    removal of the -R flag when doing the chown in openstack-pkg-tools.
+ -- James Page <james.page@ubuntu.com>  Sat, 16 Mar 2013 09:30:20 +0000
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 23 May 2013 00:08:47 +0800
+cinder (2013.1.g3-0ubuntu1) raring; urgency=low
 
-cinder (2013.1.1-1) unstable; urgency=low
+  [ Yolanda Robla Mota ]
+  * d/control: Add BD on python-hp3parclient.
+  * d/patches: Drop patches related to disabling hp3parclient.
 
-  * Uploading to unstable.
+  [ James Page ]
+  * d/control: Add Suggests: python-hp3parclient for python-cinder.
+  * d/control: Add BD on python-oslo-config.
+  * d/*: Wrapped and sorted.
+
+  [ Chuck Short ]
   * New upstream release.
-  * Fixed /etc/sudoers.d/cinder-common
-  * Reviewed package descriptions by the debian-l10n-english team.
+  * debian/rules, debian/cinder-volumes.install: 
+    - Fail if binaries are missing and install missing binaries.
+  * debian/patches/fix-ubuntu-tests.patch: Fix failing tests.
+  * debian/control: Add python-rtslib and python-mock.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 22 Feb 2013 10:45:17 -0600
+
+cinder (2013.1~g2-0ubuntu2) raring; urgency=low
+
+  * debian/patches/series: Enable skip_failed_tests to fix FTBFS. 
+
+ -- Chris J Arges <chris.j.arges@canonical.com>  Tue, 15 Jan 2013 10:10:28 -0600
+
+cinder (2013.1~g2-0ubuntu1) raring; urgency=low
+
+  [ Chuck Short ]
+  * New upstream release. 
+  * debian/patches/avoid_setuptools_git_dependency.patch: Rediff
+    due to upstream changes.
+  * debian/control: Add python-keystoneclient as a dependency
+
+  [ James Page ]
+  * Improve upstart configurations:
+    - d/*.upstart: Switch to using start-stop-daemon instead of su,
+      stop on [!2345] to catch all transitions.
+  * d/control: General tidy of package descriptions.
+  * d/control: Drop BD on python-all-dev as its not required.
+  * d/*.postrm: Dropped; update-rc.d calls for purge are handled by
+    debhelper and are not require for upstart configurations.
+
+  [ Yolanda Robla Mota ]
+  * d/patches: removing hp3parclient dependency from tools/test-requires
+  * d/patches, d/control: adding stevedore dependency, merging deps patches
+  * d/patches: remove failing tests
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 11 Apr 2013 22:30:47 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 11 Jan 2013 07:33:57 -0600
 
-cinder (2013.1-1) experimental; urgency=low
+cinder (2013.1~g1-0ubuntu1) raring; urgency=low
 
   * New upstream release.
+  * debian/patches/avoid_setuptools_git_dependency.patch:
+    Avoid git installation. (LP: #1075948) 
 
- -- Thomas Goirand <zigo@debian.org>  Mon, 28 Jan 2013 15:54:59 +0800
+ -- Chuck Short <zulcss@ubuntu.com>  Fri, 23 Nov 2012 08:39:28 -0600
 
-cinder (2012.2.1-1) experimental; urgency=low
+cinder (2013.1~g1~20121101.361-0ubuntu1) raring; urgency=low
 
-  [ Thomas Goirand ]
-  * New upstream release 2012.2.1
-  * Fixes wrong handling (eg: policy violation) of /etc/cinder/cinder.conf.
-  * Now uses pkgos_func functions for debconf and dbconfig-common handling.
-  * Renames /etc/sudoers.d/cinder_sudoers as /etc/sudoers.d/cinder-common.
-  * Debconf now users cinder/<debconf-screen-name> and not cinder-common/.
-  * Reviewed long and short descriptions in debian/control.
-  * Bumped Build-Depends-Indep: python-all to 2.6.6-3~ since we are using
-  dh_python2.
-  * Added everyone in the team as Uploaders:.
-  * Changed Homepage field to http://cinder.openstack.org/.
-  * Dependencies are now by alpha order.
-  * Removed useless empty cinder-volume.postrm, cinder-api.postrm,
-  cinder-scheduler.postinst, cinder-scheduler.postrm.
-  * Pre-Depends: dpkg (>= 1.15.6~) because we use xz compression.
-  * Asks for admin tenant, user and password with debconf, patches
-  api-paste.ini so it is syntaxicaly correct.
-  * Auto-detects a valide volume group name, and prompt the user with debconf
-  about it.
+  [ Adam Gandelman ]
+  * New upstream release.
+  * debian/patches/0001-Replace-builtin-hash.patch: Dropped.
+
+  [ James Page ]
+  * Cinder should suggest ceph-common, not python-ceph (LP: #1065901):
+    - debian/control: cinder-volume Suggests: python-ceph -> ceph-common
+
+ -- Adam Gandelman <adamg@canonical.com>  Thu, 01 Nov 2012 11:30:15 +0100
+
+cinder (2012.2-0ubuntu2) quantal; urgency=low
+
+  * debian/cinder_tgt.conf: Add missing configuration file. (LP: #1064366) 
+  * debian/README.Debian: Added note about migration from nova-volume
+    to cinder-volume.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 09 Oct 2012 08:26:21 -0500
+
+cinder (2012.2-0ubuntu1) quantal; urgency=low
+
+  * New upstream release. 
+  * debian/cinder-volume.postinst, debian/cinder-common.dirs,
+    debian/cinder.conf: Properly configure tgtd to be used with cinder.
+  * debian/pydist-overrides: Dont try to install babel.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Thu, 27 Sep 2012 11:32:27 -0500
 
- -- Thomas Goirand <zigo@debian.org>  Sun, 02 Dec 2012 07:00:49 +0000
+cinder (2012.2~rc3-0ubuntu1) quantal; urgency=low
 
-cinder (2012.2~rc1+git1~6b31057-1) experimental; urgency=low
+  * New upstream release.
+  * debian/patches/0001-Replace-builtin-hash-with-MD5-to-solve-32-64-bit-iss.patch:
+    Fix FTBFS.
+
+ -- Chuck Short <zulcss@ubuntu.com>  Wed, 26 Sep 2012 14:07:35 -0500
+
+cinder (2012.2~rc2-0ubuntu1) quantal; urgency=low
+
+  [ Adam Gandelman ]
+  * debian/control: Add python-mysqldb to python-cinder Depends.
+
+  [ Chuck Short ]
+  * New upstream release
+  * debian/rules: Fail to build if the testsuite doesnt pass.
 
-  * First debian release
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 25 Sep 2012 10:17:21 -0500
+
+cinder (2012.2~rc1-0ubuntu1) quantal; urgency=low
+
+  [ Adam Gandelman ]
+  * debian/control: Add lvm2 + tgt as a Dependency of cinder-volume.
+  * debian/cinder-volume.{dirs, postinst}:
+        - Create /var/lib/cinder/volumes (LP: #1047059)
+        - chmod 0600, not chown.
+  * debain/cinder-scheduler.postinst: Drop.
+  * debian/cinder.conf: Fix defaults.
+  * debian/*.upstart: Specify --log-file.
+  * debian/*.logrotate: Update.
+  * Only rootwrap filters with the packages that need them (cinder-volume).
+  * Ensure /etc/cinder/rootwrap.d/ is only writable by root, ensure
+    those permissions on /etc/cinder/rootwrap.conf and individual filter
+    configurations.
+
+  [ Chuck Short ]
+  * New upstream version.
+  * debian/control: Add python-ceph as a suggests
 
- -- Mehdi Abaakouk <sileht@sileht.net>  Thu, 13 Sep 2012 15:52:06 +0200
+ -- Chuck Short <zulcss@ubuntu.com>  Tue, 18 Sep 2012 14:24:45 -0500
 
 cinder (2012.2~rc1~20120907.230-0ubuntu4) quantal; urgency=low
 
   [Chuck Short]
   * New upstream version.
-  * debian/cinder.conf: Fix path for cinder-rootwrap. (LP: #1045438)
-  * debian/control: Add python-glanceclient as a dep.
+  * debian/cinder.conf: Fix path for cinder-rootwrap. (LP: #1045438) 
+  * debian/control: Add python-glanceclient as a dep. 
   * debian/cinder-common.postinst: Fix chmod thinko.
   * debian/*.upstart: Specify the configuration files.
 
@@ -985,7 +1391,7 @@ cinder (2012.2~f3-0ubuntu3) quantal; urg
 cinder (2012.2~f3-0ubuntu2) quantal; urgency=low
 
   * debian/cinder.conf: Get rid of deprecated warnings.
-    (LP: #1036240)
+    (LP: #1036240) 
 
  -- Chuck Short <zulcss@ubuntu.com>  Sun, 19 Aug 2012 13:36:22 -0500
 
@@ -999,7 +1405,7 @@ cinder (2012.2~f3-0ubuntu1) quantal; urg
 
 cinder (2012.2~f3~20120809.102-0ubuntu2) quantal; urgency=low
 
-  * debian/cinder.conf, cinder-common.install: Use rootwrap.conf. (LP: #1036240)
+  * debian/cinder.conf, cinder-common.install: Use rootwrap.conf. (LP: #1036240) 
   * debian/control: Drop python-babel.
 
  -- Chuck Short <zulcss@ubuntu.com>  Mon, 13 Aug 2012 14:14:31 -0500
diff -pruN 2:15.0.1-1/debian/cinder-api.apache2 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-api.apache2
--- 2:15.0.1-1/debian/cinder-api.apache2	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-api.apache2	2020-03-24 18:47:42.000000000 +0000
@@ -0,0 +1 @@
+conf debian/cinder-wsgi.conf
diff -pruN 2:15.0.1-1/debian/cinder-api.config.in 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-api.config.in
--- 2:15.0.1-1/debian/cinder-api.config.in	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-api.config.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,11 +0,0 @@
-#!/bin/sh
-
-set -e
-
-. /usr/share/debconf/confmodule
-
-#PKGOS-INCLUDE#
-
-pkgos_register_endpoint_config cinder
-
-exit 0
diff -pruN 2:15.0.1-1/debian/cinder-api.init.in 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-api.init.in
--- 2:15.0.1-1/debian/cinder-api.init.in	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-api.init.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,23 +0,0 @@
-#!/bin/sh
-### BEGIN INIT INFO
-# Provides:          cinder-api
-# Required-Start:    $network $local_fs $remote_fs $syslog
-# Required-Stop:     $remote_fs
-# Should-Start:      postgresql mysql keystone rabbitmq-server ntp
-# Should-Stop:       postgresql mysql keystone rabbitmq-server ntp
-# Default-Start:     2 3 4 5
-# Default-Stop:      0 1 6
-# Short-Description: Cinder Api
-# Description:       Provides EBS like storage for your
-#                    virtual machine instances
-### END INIT INFO
-
-# Author: Thomas Goirand <zigo@debian.org>
-DESC="OpenStack Cinder Api (cinder-api)"
-PROJECT_NAME=cinder
-NAME=${PROJECT_NAME}-api
-#DAEMON=/usr/bin/uwsgi_python3
-#DAEMON_ARGS="--ini /etc/cinder/cinder-uwsgi.ini"
-#NO_OPENSTACK_CONFIG_FILE_DAEMON_ARG=yes
-#NO_OPENSTACK_LOGFILE_DAEMON_ARG=yes
-#USE_SYSLOG=no
diff -pruN 2:15.0.1-1/debian/cinder-api.install 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-api.install
--- 2:15.0.1-1/debian/cinder-api.install	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-api.install	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-debian/cinder-uwsgi.ini	/etc/cinder
-usr/bin/cinder-api
diff -pruN 2:15.0.1-1/debian/cinder-api.lintian-overrides 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-api.lintian-overrides
--- 2:15.0.1-1/debian/cinder-api.lintian-overrides	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-api.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1,7 +0,0 @@
-cinder-api: unused-debconf-template cinder/register-endpoint
-cinder-api: unused-debconf-template cinder/keystone-ip
-cinder-api: unused-debconf-template cinder/keystone-admin-name
-cinder-api: unused-debconf-template cinder/keystone-project-name
-cinder-api: unused-debconf-template cinder/keystone-admin-password
-cinder-api: unused-debconf-template cinder/endpoint-ip
-cinder-api: unused-debconf-template cinder/region-name
diff -pruN 2:15.0.1-1/debian/cinder-api.manpages 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-api.manpages
--- 2:15.0.1-1/debian/cinder-api.manpages	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-api.manpages	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-debian/man/cinder-api.8
diff -pruN 2:15.0.1-1/debian/cinder-api.postinst.in 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-api.postinst.in
--- 2:15.0.1-1/debian/cinder-api.postinst.in	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-api.postinst.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,84 +0,0 @@
-#!/bin/sh
-
-set -e
-
-#PKGOS-INCLUDE#
-
-if [ "$1" = "configure" ] || [ "$1" = "reconfigure" ] ; then
-	. /usr/share/debconf/confmodule
-
-	# We need special handling for Cinder, as it needs 2 endpoints
-	PKG_NAME=cinder
-	db_get ${PKG_NAME}/configure_api-endpoint
-	if [ "${RET}" = "true" ] ; then
-		db_get ${PKG_NAME}/api-keystone-address
-		KEYSTONE_ENDPOINT_IP=${RET}
-		db_get ${PKG_NAME}/api-endpoint-address
-		PKG_ENDPOINT_IP=${RET}
-		db_get ${PKG_NAME}/api-endpoint-region-name
-		REGION_NAME=${RET}
-		db_get ${PKG_NAME}/api-keystone-admin-project-name
-		KEYSTONE_PROJECT_NAME=${RET}
-		db_get ${PKG_NAME}/api-keystone-admin-username
-		KEYSTONE_ADMIN_NAME=${RET}
-		db_get ${PKG_NAME}/api-keystone-admin-password
-		KEYSTONE_ADMIN_PASSWORD=${RET}
-
-		if [ -n "${KEYSTONE_ENDPOINT_IP}" ] && [ -n "${PKG_ENDPOINT_IP}" ] && [ -n "${REGION_NAME}" ] && [ -n "${KEYSTONE_PROJECT_NAME}" ] && [ -n "${KEYSTONE_ADMIN_NAME}" ]  && [ -n "${KEYSTONE_ADMIN_PASSWORD}" ] ; then
-			export OS_PROJECT_DOMAIN_ID=default
-			export OS_USER_DOMAIN_ID=default
-			export OS_TENANT_NAME=${KEYSTONE_PROJECT_NAME}
-			export OS_PROJECT_NAME=${KEYSTONE_PROJECT_NAME}
-			export OS_USERNAME=${KEYSTONE_ADMIN_NAME}
-			export OS_PASSWORD=${KEYSTONE_ADMIN_PASSWORD}
-			export OS_AUTH_URL=http://${KEYSTONE_ENDPOINT_IP}:5000/v3/
-			export OS_IDENTITY_API_VERSION=3
-			export OS_AUTH_VERSION=3
-			export OS_PROJECT_DOMAIN_ID=default
-			export OS_USER_DOMAIN_ID=default
-			export OS_NO_CACHE=1
-
-		        SERVICE_NAME=cinderv2
-		        SERVICE_TYPE=volumev2
-			SERVICE_DESC="OpenStack Block Storage v2"
-			SERVICE_PORT=8776
-			SERVICE_URL=/v2/'%(project_id)s'
-			echo "Registering service and endpoints for ${SERVICE_NAME} with type ${SERVICE_TYPE} at http://${PKG_ENDPOINT_IP}:${SERVICE_PORT}${SERVICE_URL}"
-			NUM_LINES=$(openstack service list --format=csv | q -d , -H 'SELECT ID FROM - WHERE `Type`="'${SERVICE_TYPE}'"' | wc -l)
-			if [ "${NUM_LINES}" = "0" ] ; then
-				openstack service create --name=${SERVICE_NAME} --description="${SERVICE_DESC}" ${SERVICE_TYPE}
-				openstack endpoint create --region "${REGION_NAME}" ${SERVICE_NAME} public   http://${PKG_ENDPOINT_IP}:${SERVICE_PORT}${SERVICE_URL}
-				openstack endpoint create --region "${REGION_NAME}" ${SERVICE_NAME} internal http://${PKG_ENDPOINT_IP}:${SERVICE_PORT}${SERVICE_URL}
-				openstack endpoint create --region "${REGION_NAME}" ${SERVICE_NAME} admin    http://${PKG_ENDPOINT_IP}:${SERVICE_PORT}${SERVICE_URL}
-			fi
-
-		        SERVICE_NAME=cinderv3
-		        SERVICE_TYPE=volumev3
-			SERVICE_DESC="OpenStack Block Storage v3"
-			SERVICE_PORT=8776
-			SERVICE_URL=/v3/'%(project_id)s'
-			echo "Registering service and endpoints for ${SERVICE_NAME} with type ${SERVICE_TYPE} at http://${PKG_ENDPOINT_IP}:${SERVICE_PORT}${SERVICE_URL}"
-			NUM_LINES=$(openstack service list --format=csv | q -d , -H 'SELECT ID FROM - WHERE `Type`="'${SERVICE_TYPE}'"' | wc -l)
-			if [ "${NUM_LINES}" = "0" ] ; then
-				openstack service create --name=${SERVICE_NAME} --description="${SERVICE_DESC}" ${SERVICE_TYPE}
-				openstack endpoint create --region "${REGION_NAME}" ${SERVICE_NAME} public   http://${PKG_ENDPOINT_IP}:${SERVICE_PORT}${SERVICE_URL}
-				openstack endpoint create --region "${REGION_NAME}" ${SERVICE_NAME} internal http://${PKG_ENDPOINT_IP}:${SERVICE_PORT}${SERVICE_URL}
-				openstack endpoint create --region "${REGION_NAME}" ${SERVICE_NAME} admin    http://${PKG_ENDPOINT_IP}:${SERVICE_PORT}${SERVICE_URL}
-			fi
-
-#			pkgos_register_endpoint_postinst cinder cinder volume "Cinder Volume Service" 8776 /v1/'%(tenant_id)s'
-#			pkgos_register_endpoint_postinst cinder cinderv2 volumev2 "Cinder Volume Service" 8776 /v2/'%(tenant_id)s'
-		else
-			echo "Problem in endpoint parameter (IPs or otherwise)."
-		fi
-		db_unregister ${PKG_NAME}/configure_api-endpoint
-	else
-		echo "Will not register "${SERVICE_NAME}" endpoint this time (no user request for it)."
-	fi
-	db_unregister ${PKG_NAME}/api-keystone-admin-password
-	db_stop
-fi
-
-#DEBHELPER#
-
-exit 0
diff -pruN 2:15.0.1-1/debian/cinder-backup.init.in 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-backup.init.in
--- 2:15.0.1-1/debian/cinder-backup.init.in	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-backup.init.in	2020-03-24 18:47:42.000000000 +0000
@@ -12,6 +12,9 @@
 ### END INIT INFO
 
 # Author: Thomas Goirand <zigo@debian.org>
-DESC="OpenStack Cinder Backup (cinder-backup)"
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC="OpenStack Cinder Backup"
 PROJECT_NAME=cinder
 NAME=${PROJECT_NAME}-backup
diff -pruN 2:15.0.1-1/debian/cinder-backup.install 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-backup.install
--- 2:15.0.1-1/debian/cinder-backup.install	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-backup.install	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-usr/bin/cinder-backup
diff -pruN 2:15.0.1-1/debian/cinder-common.config.in 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.config.in
--- 2:15.0.1-1/debian/cinder-common.config.in	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.config.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,65 +0,0 @@
-#!/bin/sh
-
-set -e
-
-. /usr/share/debconf/confmodule
-CINDER_CONF=/etc/cinder/cinder.conf
-
-#PKGOS-INCLUDE#
-
-manage_cinder_my_ip () {
-	pkgos_inifile get ${CINDER_CONF} DEFAULT my_ip
-	if [ -n "${RET}" ] && [ ! "${RET}" = "NOT_FOUND" ] ; then
-		db_set cinder/my-ip "${RET}"
-	else
-		DEFROUTE_IF=`awk '{ if ( $2 == "00000000" ) print $1 }' /proc/net/route | head -n 1`
-		if [ -n "${DEFROUTE_IF}" ] && [ -x /bin/ip ] ; then
-			DEFROUTE_IP=$(LC_ALL=C ip addr show "${DEFROUTE_IF}" | grep inet | head -n 1 | awk '{print $2}' | cut -d/ -f1 | grep -E '^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$' || true)
-		fi
-		if [ -z "${DEFROUTE_IP}" ] ; then
-			HOSTNAME_IP=$(hostname -i)
-			if [ -n "${HOSTNAME_IP}" ] ; then
-				DEFROUTE_IP=${HOSTNAME_IP}
-			fi
-		fi
-		if [ -n "${DEFROUTE_IP}" ] ; then
-			db_set cinder/my-ip ${DEFROUTE_IP}
-		fi
-	fi
-	db_input high cinder/my-ip || true
-	db_go
-}
-
-manage_glance_api_servers () {
-	pkgos_inifile get ${CINDER_CONF} DEFAULT glance_api_servers
-	if [ -n "${RET}" ] && [ ! "${RET}" = "NOT_FOUND" ] ; then
-		db_set cinder/glance-api-servers "${RET}"
-	fi
-	db_input high cinder/glance-api-servers || true
-	db_go
-}
-
-pkgos_var_user_group cinder
-pkgos_dbc_read_conf -pkg cinder-common ${CINDER_CONF} database connection cinder $@
-pkgos_rabbit_read_conf ${CINDER_CONF} oslo_messaging_rabbit cinder
-pkgos_read_admin_creds ${CINDER_CONF} keystone_authtoken cinder
-
-pkgos_inifile get ${CINDER_CONF} lvm volume_group
-if [ -n "${RET}" ] && [ ! "${RET}" = "NOT_FOUND" ] ; then
-	db_set cinder/volume_group "${RET}"
-else
-	db_get cinder/volume_group
-	if [ -z "${RET}" ] && [ -x /sbin/vgdisplay ] ; then
-		# Since we have no prior value, try to guess it from vgdisplay
-		VGDISP=`vgdisplay -c | head -n 1`
-		if [ -n "${VGDISP}" ] ; then
-			VGNAME=`echo ${VGDISP} | cut -d: -f1`
-			db_set cinder/volume_group ${VGNAME}
-		fi
-	fi
-fi
-db_input high cinder/volume_group || true
-db_go
-manage_cinder_my_ip
-
-exit 0
diff -pruN 2:15.0.1-1/debian/cinder-common.dirs 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.dirs
--- 2:15.0.1-1/debian/cinder-common.dirs	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.dirs	2020-03-24 18:47:42.000000000 +0000
@@ -1 +1,5 @@
+etc/cinder
 etc/cinder/rootwrap.d
+var/lib/cinder
+var/lib/cinder/volumes
+var/log/cinder
diff -pruN 2:15.0.1-1/debian/cinder-common.install 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.install
--- 2:15.0.1-1/debian/cinder-common.install	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.install	2020-03-24 18:47:42.000000000 +0000
@@ -1,8 +1,8 @@
-etc/cinder/api-paste.ini		/usr/share/cinder-common
-etc/cinder/resource_filters.json
-etc/cinder/rootwrap.*
-usr/bin/cinder-manage
-usr/bin/cinder-rootwrap
-usr/bin/cinder-rtstool
-usr/bin/cinder-status
-usr/bin/cinder-wsgi
+debian/cinder.conf etc/cinder
+debian/cinder_sudoers etc/sudoers.d
+debian/cinder_tgt.conf etc/tgt/conf.d
+debian/logging.conf etc/cinder
+etc/cinder/api-paste.ini etc/cinder
+etc/cinder/resource_filters.json etc/cinder
+etc/cinder/rootwrap.conf etc/cinder
+etc/cinder/rootwrap.d/volume.filters /etc/cinder/rootwrap.d
diff -pruN 2:15.0.1-1/debian/cinder-common.lintian-overrides 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.lintian-overrides
--- 2:15.0.1-1/debian/cinder-common.lintian-overrides	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.lintian-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1,9 +0,0 @@
-cinder-common: unused-debconf-template cinder/start_services
-cinder-common: unused-debconf-template cinder/start_services
-cinder-common: unused-debconf-template cinder/auth-host
-cinder-common: unused-debconf-template cinder/admin-tenant-name
-cinder-common: unused-debconf-template cinder/admin-user
-cinder-common: unused-debconf-template cinder/admin-password
-cinder-common: unused-debconf-template cinder/rabbit_host
-cinder-common: unused-debconf-template cinder/rabbit_userid
-cinder-common: unused-debconf-template cinder/rabbit_password
diff -pruN 2:15.0.1-1/debian/cinder-common.logrotate 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.logrotate
--- 2:15.0.1-1/debian/cinder-common.logrotate	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.logrotate	2020-03-24 18:47:42.000000000 +0000
@@ -3,6 +3,6 @@
     missingok
     compress
     delaycompress
-    notifempty
     copytruncate
+    notifempty
 }
diff -pruN 2:15.0.1-1/debian/cinder-common.manpages 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.manpages
--- 2:15.0.1-1/debian/cinder-common.manpages	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.manpages	2020-03-24 18:47:42.000000000 +0000
@@ -1,2 +1,5 @@
+debian/man/cinder-api.8
 debian/man/cinder-manage.8
 debian/man/cinder-rootwrap.8
+debian/man/cinder-scheduler.8
+debian/man/cinder-volume.8
diff -pruN 2:15.0.1-1/debian/cinder-common.postinst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.postinst
--- 2:15.0.1-1/debian/cinder-common.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.postinst	2020-03-24 18:47:42.000000000 +0000
@@ -0,0 +1,41 @@
+#!/bin/sh -e
+
+CINDER_UID=64061
+CINDER_GID=64061
+
+if [ "$1" = "configure" ]; then
+    if ! getent group cinder > /dev/null 2>&1; then
+        addgroup --quiet --system \
+            --gid $CINDER_GID cinder 2>/dev/null
+    fi
+
+    if ! getent passwd cinder > /dev/null 2>&1; then
+        adduser --quiet --system \
+            --home /var/lib/cinder \
+            --no-create-home \
+            --uid $CINDER_UID \
+            --gid $CINDER_GID \
+            --shell /bin/false cinder 2>/dev/null
+    fi
+
+    chown cinder:adm /var/log/cinder
+    chmod 0750 /var/log/cinder
+
+    find /etc/cinder -exec chown root:cinder "{}" +
+    find /etc/cinder -type f -exec chmod 0640 "{}" + -o -type d -exec chmod 0750 "{}" +
+
+    find /etc/cinder/rootwrap.d -exec chown root:root "{}" +
+    find /etc/cinder/rootwrap.d -type f -exec chmod 0644 "{}" + -o -type d -exec chmod 0755 "{}" +
+
+    chown cinder:cinder /var/lib/cinder
+    chmod 0750 /var/lib/cinder
+
+    chmod 0440 /etc/sudoers.d/cinder_sudoers
+
+    if [ -e /var/lib/cinder/cinder.sqlite ]; then
+        chown cinder:cinder /var/lib/cinder/cinder.sqlite
+        chmod 0600 /var/lib/cinder/cinder.sqlite
+    fi
+fi
+
+#DEBHELPER#
diff -pruN 2:15.0.1-1/debian/cinder-common.postinst.in 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.postinst.in
--- 2:15.0.1-1/debian/cinder-common.postinst.in	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.postinst.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,57 +0,0 @@
-#!/bin/sh
-
-set -e
-
-CINDER_CONF=/etc/cinder/cinder.conf
-
-#PKGOS-INCLUDE#
-
-if [ "$1" = "configure" ] || [ "$1" = "reconfigure" ] ; then
-	. /usr/share/debconf/confmodule
-	. /usr/share/dbconfig-common/dpkg/postinst
-
-	pkgos_var_user_group cinder
-
-	# we need few folders with cinder:cinder rights.
-	mkdir -p /var/lib/cinder/cache
-	mkdir -p /var/lib/cinder/volumes
-	chown cinder:cinder /var/lib/cinder/cache
-	chown cinder:cinder /var/lib/cinder/volumes
-
-	pkgos_write_new_conf cinder cinder.conf
-	pkgos_write_new_conf cinder api-paste.ini
-	pkgos_write_new_conf cinder logging.conf
-	pkgos_write_new_conf cinder policy.json
-	db_get cinder/configure_db
-	if [ "$RET" = "true" ]; then
-		pkgos_dbc_postinst ${CINDER_CONF} database connection cinder $@
-	fi
-	pkgos_rabbit_write_conf ${CINDER_CONF} oslo_messaging_rabbit cinder
-	pkgos_write_admin_creds ${CINDER_CONF} keystone_authtoken cinder
-	db_get cinder/volume_group
-	if [ -n "${RET}" ] ; then
-		pkgos_inifile set ${CINDER_CONF} lvm volume_group ${RET}
-	fi
-
-	db_get cinder/my-ip
-	if [ -n "${RET}" ] ; then
-		pkgos_inifile set ${CINDER_CONF} DEFAULT my_ip ${RET}
-	fi
-
-	db_get cinder/glance-api-servers
-	if [ -n "${RET}" ] ; then
-		pkgos_inifile set ${CINDER_CONF} DEFAULT glance_api_servers ${RET}
-	fi
-
-	chmod 0440 /etc/sudoers.d/cinder-common
-	db_get cinder/configure_db
-	if [ "$RET" = "true" ]; then
-		echo "Now calling cinder-manage db sync: this may take a while..."
-		su -s /bin/sh -c 'cinder-manage db sync' cinder
-	fi
-	db_stop
-fi
-
-#DEBHELPER#
-
-exit 0
diff -pruN 2:15.0.1-1/debian/cinder-common.postrm.in 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.postrm.in
--- 2:15.0.1-1/debian/cinder-common.postrm.in	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.postrm.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,19 +0,0 @@
-#!/bin/sh
-
-set -e
-
-#PKGOS-INCLUDE#
-
-if [ "$1" = "purge" ] && [ -f /usr/share/debconf/confmodule ] ; then
-	pkgos_dbc_postrm cinder cinder-common $@
-
-	rm -f /etc/cinder/cinder.conf /etc/cinder/api-paste.ini /etc/cinder/logging.conf
-	rmdir --ignore-fail-on-non-empty /etc/cinder || true
-	rm -f /etc/default/cinder-common
-	rm -rf /var/lib/cinder /var/log/cinder
-	rm -f /etc/cinder/policy.json
-fi
-
-#DEBHELPER#
-
-exit 0
diff -pruN 2:15.0.1-1/debian/cinder-common.prerm 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.prerm
--- 2:15.0.1-1/debian/cinder-common.prerm	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.prerm	1970-01-01 00:00:00.000000000 +0000
@@ -1,15 +0,0 @@
-#!/bin/sh
-
-set -e
-
-. /usr/share/debconf/confmodule
-
-db_get cinder/configure_db || true
-if [ "$RET" = "true" ]; then
-	if [ -r /usr/share/dbconfig-common/dpkg/prerm ] ; then
-		. /usr/share/dbconfig-common/dpkg/prerm
-		dbc_go cinder-common $@
-	fi
-fi
-
-#DEBHELPER#
diff -pruN 2:15.0.1-1/debian/cinder-common.sudoers 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.sudoers
--- 2:15.0.1-1/debian/cinder-common.sudoers	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.sudoers	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-Defaults:cinder !requiretty
-
-cinder ALL = (root) NOPASSWD: /usr/bin/cinder-rootwrap /etc/cinder/rootwrap.conf *
diff -pruN 2:15.0.1-1/debian/cinder-common.templates.in 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.templates.in
--- 2:15.0.1-1/debian/cinder-common.templates.in	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.templates.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,26 +0,0 @@
-# These templates have been reviewed by the debian-l10n-english
-# team
-#
-# If modifications/additions/rewording are needed, please ask
-# debian-l10n-english@lists.debian.org for advice.
-#
-# Even minor modifications require translation updates and such
-# changes should be coordinated with translators and reviewers.
-
-Template: cinder/volume_group
-Type: string
-_Description: Cinder volume group:
- Please specify the name of the LVM volume group on which Cinder
- will create partitions.
-
-Template: cinder/my-ip
-Type: string
-_Description: Value for my_ip:
- This value will be stored in the my_ip directive of cinder.conf.
-
-Template: cinder/glance-api-servers
-Type: string
-Default: http://127.0.0.1:9292
-_Description: Value for glance_api_servers:
- A list of the URLs of glance API servers available to cinder ([http[s]://][hostname|ip]:port).
-
diff -pruN 2:15.0.1-1/debian/cinder-common.tmpfile 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.tmpfile
--- 2:15.0.1-1/debian/cinder-common.tmpfile	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-common.tmpfile	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-d /run/cinder 0755 cinder cinder -
diff -pruN 2:15.0.1-1/debian/cinder.conf 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder.conf
--- 2:15.0.1-1/debian/cinder.conf	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder.conf	2020-03-24 18:47:42.000000000 +0000
@@ -1,2849 +1,15 @@
 [DEFAULT]
-
-#
-# Options defined in oslo.messaging
-#
-
-# ZeroMQ bind address. Should be a wildcard (*), an ethernet
-# interface, or IP. The "host" option should point or resolve
-# to this address. (string value)
-#rpc_zmq_bind_address=*
-
-# MatchMaker driver. (string value)
-#rpc_zmq_matchmaker=oslo_messaging._drivers.matchmaker.MatchMakerLocalhost
-
-# ZeroMQ receiver listening port. (integer value)
-#rpc_zmq_port=9501
-
-# Number of ZeroMQ contexts, defaults to 1. (integer value)
-#rpc_zmq_contexts=1
-
-# Maximum number of ingress messages to locally buffer per
-# topic. Default is unlimited. (integer value)
-#rpc_zmq_topic_backlog=<None>
-
-# Directory for holding IPC sockets. (string value)
-#rpc_zmq_ipc_dir=/var/run/openstack
-
-# Name of this node. Must be a valid hostname, FQDN, or IP
-# address. Must match "host" option, if running Nova. (string
-# value)
-#rpc_zmq_host=cinder
-
-# Seconds to wait before a cast expires (TTL). Only supported
-# by impl_zmq. (integer value)
-#rpc_cast_timeout=30
-
-# Heartbeat frequency. (integer value)
-#matchmaker_heartbeat_freq=300
-
-# Heartbeat time-to-live. (integer value)
-#matchmaker_heartbeat_ttl=600
-
-# Size of RPC thread pool. (integer value)
-#rpc_thread_pool_size=64
-
-# Driver or drivers to handle sending notifications. (multi
-# valued)
-#notification_driver=
-
-# AMQP topic used for OpenStack notifications. (list value)
-# Deprecated group/name - [rpc_notifier2]/topics
-#notification_topics=notifications
-
-# Seconds to wait for a response from a call. (integer value)
-#rpc_response_timeout=60
-
-# A URL representing the messaging driver to use and its full
-# configuration. If not set, we fall back to the rpc_backend
-# option and driver specific configuration. (string value)
-#transport_url=<None>
-
-# The messaging driver to use, defaults to rabbit. Other
-# drivers include qpid and zmq. (string value)
-#rpc_backend=rabbit
-
-# The default exchange under which topics are scoped. May be
-# overridden by an exchange name specified in the
-# transport_url option. (string value)
-#control_exchange=openstack
-
-
-#
-# Options defined in cinder.exception
-#
-
-# Make exception message format errors fatal. (boolean value)
-#fatal_exception_format_errors=false
-
-
-#
-# Options defined in cinder.quota
-#
-
-# Number of volumes allowed per project (integer value)
-#quota_volumes=10
-
-# Number of volume snapshots allowed per project (integer
-# value)
-#quota_snapshots=10
-
-# Number of consistencygroups allowed per project (integer
-# value)
-#quota_consistencygroups=10
-
-# Total amount of storage, in gigabytes, allowed for volumes
-# and snapshots per project (integer value)
-#quota_gigabytes=1000
-
-# Number of volume backups allowed per project (integer value)
-#quota_backups=10
-
-# Total amount of storage, in gigabytes, allowed for backups
-# per project (integer value)
-#quota_backup_gigabytes=1000
-
-# Number of seconds until a reservation expires (integer
-# value)
-#reservation_expire=86400
-
-# Count of reservations until usage is refreshed (integer
-# value)
-#until_refresh=0
-
-# Number of seconds between subsequent usage refreshes
-# (integer value)
-#max_age=0
-
-# Default driver to use for quota checks (string value)
-#quota_driver=cinder.quota.DbQuotaDriver
-
-# Enables or disables use of default quota class with default
-# quota. (boolean value)
-#use_default_quota_class=true
-
-
-#
-# Options defined in cinder.service
-#
-
-# Interval, in seconds, between nodes reporting state to
-# datastore (integer value)
-#report_interval=10
-
-# Interval, in seconds, between running periodic tasks
-# (integer value)
-#periodic_interval=60
-
-# Range, in seconds, to randomly delay when starting the
-# periodic task scheduler to reduce stampeding. (Disable by
-# setting to 0) (integer value)
-#periodic_fuzzy_delay=60
-
-# IP address on which OpenStack Volume API listens (string
-# value)
-#osapi_volume_listen=0.0.0.0
-
-# Port on which OpenStack Volume API listens (integer value)
-#osapi_volume_listen_port=8776
-
-# Number of workers for OpenStack Volume API service. The
-# default is equal to the number of CPUs available. (integer
-# value)
-#osapi_volume_workers=<None>
-
-
-#
-# Options defined in cinder.ssh_utils
-#
-
-# Option to enable strict host key checking.  When set to
-# "True" Cinder will only connect to systems with a host key
-# present in the configured "ssh_hosts_key_file".  When set to
-# "False" the host key will be saved upon first connection and
-# used for subsequent connections.  Default=False (boolean
-# value)
-#strict_ssh_host_key_policy=false
-
-# File containing SSH host keys for the systems with which
-# Cinder needs to communicate.  OPTIONAL:
-# Default=$state_path/ssh_known_hosts (string value)
-#ssh_hosts_key_file=$state_path/ssh_known_hosts
-
-
-#
-# Options defined in cinder.test
-#
-
-# File name of clean sqlite db (string value)
-#sqlite_clean_db=clean.sqlite
-
-
-#
-# Options defined in cinder.wsgi
-#
-
-# Maximum line size of message headers to be accepted.
-# max_header_line may need to be increased when using large
-# tokens (typically those generated by the Keystone v3 API
-# with big service catalogs). (integer value)
-#max_header_line=16384
-
-# Timeout for client connections' socket operations. If an
-# incoming connection is idle for this number of seconds it
-# will be closed. A value of '0' means wait forever. (integer
-# value)
-#client_socket_timeout=900
-
-# If False, closes the client socket connection explicitly.
-# Setting it to True to maintain backward compatibility.
-# Recommended setting is set it to False. (boolean value)
-#wsgi_keep_alive=true
-
-# Sets the value of TCP_KEEPALIVE (True/False) for each server
-# socket. (boolean value)
-#tcp_keepalive=true
-
-# Sets the value of TCP_KEEPIDLE in seconds for each server
-# socket. Not supported on OS X. (integer value)
-#tcp_keepidle=600
-
-# Sets the value of TCP_KEEPINTVL in seconds for each server
-# socket. Not supported on OS X. (integer value)
-#tcp_keepalive_interval=<None>
-
-# Sets the value of TCP_KEEPCNT for each server socket. Not
-# supported on OS X. (integer value)
-#tcp_keepalive_count=<None>
-
-# CA certificate file to use to verify connecting clients
-# (string value)
-#ssl_ca_file=<None>
-
-# Certificate file to use when starting the server securely
-# (string value)
-#ssl_cert_file=<None>
-
-# Private key file to use when starting the server securely
-# (string value)
-#ssl_key_file=<None>
-
-
-#
-# Options defined in cinder.api.common
-#
-
-# The maximum number of items that a collection resource
-# returns in a single response (integer value)
-#osapi_max_limit=1000
-
-# Base URL that will be presented to users in links to the
-# OpenStack Volume API (string value)
-# Deprecated group/name - [DEFAULT]/osapi_compute_link_prefix
-#osapi_volume_base_URL=<None>
-
-
-#
-# Options defined in cinder.api.middleware.auth
-#
-
-# Treat X-Forwarded-For as the canonical remote address. Only
-# enable this if you have a sanitizing proxy. (boolean value)
-#use_forwarded_for=false
-
-
-#
-# Options defined in cinder.api.middleware.sizelimit
-#
-
-# Max size for body of a request (integer value)
-#osapi_max_request_body_size=114688
-
-
-#
-# Options defined in cinder.api.views.versions
-#
-
-# Public url to use for versions endpoint. The default is
-# None, which will use the request's host_url attribute to
-# populate the URL base. If Cinder is operating behind a
-# proxy, you will want to change this to represent the proxy's
-# URL. (string value)
-#public_endpoint=<None>
-
-
-#
-# Options defined in cinder.backup.chunkeddriver
-#
-
-# Compression algorithm (None to disable) (string value)
-#backup_compression_algorithm=zlib
-
-
-#
-# Options defined in cinder.backup.driver
-#
-
-# Backup metadata version to be used when backing up volume
-# metadata. If this number is bumped, make sure the service
-# doing the restore supports the new version. (integer value)
-#backup_metadata_version=2
-
-# The number of chunks or objects, for which one Ceilometer
-# notification will be sent (integer value)
-#backup_object_number_per_notification=10
-
-# Interval, in seconds, between two progress notifications
-# reporting the backup status (integer value)
-#backup_timer_interval=120
-
-
-#
-# Options defined in cinder.backup.drivers.ceph
-#
-
-# Ceph configuration file to use. (string value)
-#backup_ceph_conf=/etc/ceph/ceph.conf
-
-# The Ceph user to connect with. Default here is to use the
-# same user as for Cinder volumes. If not using cephx this
-# should be set to None. (string value)
-#backup_ceph_user=cinder
-
-# The chunk size, in bytes, that a backup is broken into
-# before transfer to the Ceph object store. (integer value)
-#backup_ceph_chunk_size=134217728
-
-# The Ceph pool where volume backups are stored. (string
-# value)
-#backup_ceph_pool=backups
-
-# RBD stripe unit to use when creating a backup image.
-# (integer value)
-#backup_ceph_stripe_unit=0
-
-# RBD stripe count to use when creating a backup image.
-# (integer value)
-#backup_ceph_stripe_count=0
-
-# If True, always discard excess bytes when restoring volumes
-# i.e. pad with zeroes. (boolean value)
-#restore_discard_excess_bytes=true
-
-
-#
-# Options defined in cinder.backup.drivers.nfs
-#
-
-# The maximum size in bytes of the files used to hold backups.
-# If the volume being backed up exceeds this size, then it
-# will be backed up into multiple files. (integer value)
-#backup_file_size=1999994880
-
-# The size in bytes that changes are tracked for incremental
-# backups. backup_swift_object_size has to be multiple of
-# backup_swift_block_size. (integer value)
-#backup_sha_block_size_bytes=32768
-
-# Enable or Disable the timer to send the periodic progress
-# notifications to Ceilometer when backing up the volume to
-# the backend storage. The default value is True to enable the
-# timer. (boolean value)
-#backup_enable_progress_timer=true
-
-# Base dir containing mount point for NFS share. (string
-# value)
-#backup_mount_point_base=$state_path/backup_mount
-
-# NFS share in fqdn:path, ipv4addr:path, or "[ipv6addr]:path"
-# format. (string value)
-#backup_share=<None>
-
-# Mount options passed to the NFS client. See NFS man page for
-# details. (string value)
-#backup_mount_options=<None>
-
-# Custom container to use for backups. (string value)
-#backup_container=<None>
-
-
-#
-# Options defined in cinder.backup.drivers.swift
-#
-
-# The URL of the Swift endpoint (string value)
-#backup_swift_url=<None>
-
-# Info to match when looking for swift in the service catalog.
-# Format is: separated values of the form:
-# <service_type>:<service_name>:<endpoint_type> - Only used if
-# backup_swift_url is unset (string value)
-#swift_catalog_info=object-store:swift:publicURL
-
-# Swift authentication mechanism (string value)
-#backup_swift_auth=per_user
-
-# Swift authentication version. Specify "1" for auth 1.0, or
-# "2" for auth 2.0 (string value)
-#backup_swift_auth_version=1
-
-# Swift tenant/account name. Required when connecting to an
-# auth 2.0 system (string value)
-#backup_swift_tenant=<None>
-
-# Swift user name (string value)
-#backup_swift_user=<None>
-
-# Swift key for authentication (string value)
-#backup_swift_key=<None>
-
-# The default Swift container to use (string value)
-#backup_swift_container=volumebackups
-
-# The size in bytes of Swift backup objects (integer value)
-#backup_swift_object_size=52428800
-
-# The size in bytes that changes are tracked for incremental
-# backups. backup_swift_object_size has to be multiple of
-# backup_swift_block_size. (integer value)
-#backup_swift_block_size=32768
-
-# The number of retries to make for Swift operations (integer
-# value)
-#backup_swift_retry_attempts=3
-
-# The backoff time in seconds between Swift retries (integer
-# value)
-#backup_swift_retry_backoff=2
-
-# Enable or Disable the timer to send the periodic progress
-# notifications to Ceilometer when backing up the volume to
-# the Swift backend storage. The default value is True to
-# enable the timer. (boolean value)
-#backup_swift_enable_progress_timer=true
-
-
-#
-# Options defined in cinder.backup.drivers.tsm
-#
-
-# Volume prefix for the backup id when backing up to TSM
-# (string value)
-#backup_tsm_volume_prefix=backup
-
-# TSM password for the running username (string value)
-#backup_tsm_password=password
-
-# Enable or Disable compression for backups (boolean value)
-#backup_tsm_compression=true
-
-
-#
-# Options defined in cinder.backup.manager
-#
-
-# Driver to use for backups. (string value)
-# Deprecated group/name - [DEFAULT]/backup_service
-#backup_driver=cinder.backup.drivers.swift
-
-
-#
-# Options defined in cinder.cmd.volume
-#
-
-# Backend override of host value. (string value)
-# Deprecated group/name - [DEFAULT]/host
-#backend_host=<None>
-
-
-#
-# Options defined in cinder.cmd.volume_usage_audit
-#
-
-# If this option is specified then the start time specified is
-# used instead of the start time of the last completed audit
-# period. (string value)
-#start_time=<None>
-
-# If this option is specified then the end time specified is
-# used instead of the end time of the last completed audit
-# period. (string value)
-#end_time=<None>
-
-# Send the volume and snapshot create and delete notifications
-# generated in the specified period. (boolean value)
-#send_actions=false
-
-
-#
-# Options defined in cinder.common.config
-#
-
-# File name for the paste.deploy config for cinder-api (string
-# value)
-#api_paste_config=api-paste.ini
-
-# Top-level directory for maintaining cinder's state (string
-# value)
-# Deprecated group/name - [DEFAULT]/pybasedir
-#state_path=/var/lib/cinder
-
-# IP address of this host (string value)
-#my_ip=10.0.0.1
-
-# Default glance host name or IP (string value)
-#glance_host=$my_ip
-
-# Default glance port (integer value)
-#glance_port=9292
-
-# A list of the glance API servers available to cinder
-# ([hostname|ip]:port) (list value)
-#glance_api_servers=$glance_host:$glance_port
-
-# Version of the glance API to use (integer value)
-#glance_api_version=1
-
-# Number retries when downloading an image from glance
-# (integer value)
-#glance_num_retries=0
-
-# Allow to perform insecure SSL (https) requests to glance
-# (boolean value)
-#glance_api_insecure=false
-
-# Enables or disables negotiation of SSL layer compression. In
-# some cases disabling compression can improve data
-# throughput, such as when high network bandwidth is available
-# and you use compressed image formats like qcow2. (boolean
-# value)
-#glance_api_ssl_compression=false
-
-# Location of ca certificates file to use for glance client
-# requests. (string value)
-#glance_ca_certificates_file=<None>
-
-# http/https timeout value for glance operations. If no value
-# (None) is supplied here, the glanceclient default value is
-# used. (integer value)
-#glance_request_timeout=<None>
-
-# The topic that scheduler nodes listen on (string value)
-#scheduler_topic=cinder-scheduler
-
-# The topic that volume nodes listen on (string value)
-#volume_topic=cinder-volume
-
-# The topic that volume backup nodes listen on (string value)
-#backup_topic=cinder-backup
-
-# DEPRECATED: Deploy v1 of the Cinder API. (boolean value)
-#enable_v1_api=true
-
-# Deploy v2 of the Cinder API. (boolean value)
-#enable_v2_api=true
-
-# Enables or disables rate limit of the API. (boolean value)
-#api_rate_limit=true
-
-# Specify list of extensions to load when using
-# osapi_volume_extension option with
-# cinder.api.contrib.select_extensions (list value)
-#osapi_volume_ext_list=
-
-# osapi volume extension to load (multi valued)
-#osapi_volume_extension=cinder.api.contrib.standard_extensions
-
-# Full class name for the Manager for volume (string value)
-#volume_manager=cinder.volume.manager.VolumeManager
-
-# Full class name for the Manager for volume backup (string
-# value)
-#backup_manager=cinder.backup.manager.BackupManager
-
-# Full class name for the Manager for scheduler (string value)
-#scheduler_manager=cinder.scheduler.manager.SchedulerManager
-
-# Name of this node.  This can be an opaque identifier. It is
-# not necessarily a host name, FQDN, or IP address. (string
-# value)
-#host=cinder
-
-# Availability zone of this node (string value)
-#storage_availability_zone=nova
-
-# Default availability zone for new volumes. If not set, the
-# storage_availability_zone option value is used as the
-# default for new volumes. (string value)
-#default_availability_zone=<None>
-
-# Default volume type to use (string value)
-#default_volume_type=<None>
-
-# Time period for which to generate volume usages. The options
-# are hour, day, month, or year. (string value)
-#volume_usage_audit_period=month
-
-# Path to the rootwrap configuration file to use for running
-# commands as root (string value)
-#rootwrap_config=/etc/cinder/rootwrap.conf
-
-# Enable monkey patching (boolean value)
-#monkey_patch=false
-
-# List of modules/decorators to monkey patch (list value)
-#monkey_patch_modules=
-
-# Maximum time since last check-in for a service to be
-# considered up (integer value)
-#service_down_time=60
-
-# The full class name of the volume API class to use (string
-# value)
-#volume_api_class=cinder.volume.api.API
-
-# The full class name of the volume backup API class (string
-# value)
-#backup_api_class=cinder.backup.api.API
-
-# The strategy to use for auth. Supports noauth, keystone, and
-# deprecated. (string value)
-auth_strategy=keystone
-
-# A list of backend names to use. These backend names should
-# be backed by a unique [CONFIG] group with its options (list
-# value)
-#enabled_backends=<None>
-
-# Whether snapshots count against gigabyte quota (boolean
-# value)
-#no_snapshot_gb_quota=false
-
-# The full class name of the volume transfer API class (string
-# value)
-#transfer_api_class=cinder.transfer.api.API
-
-# The full class name of the volume replication API class
-# (string value)
-#replication_api_class=cinder.replication.api.API
-
-# The full class name of the consistencygroup API class
-# (string value)
-#consistencygroup_api_class=cinder.consistencygroup.api.API
-
-# OpenStack privileged account username. Used for requests to
-# other services (such as Nova) that require an account with
-# special rights. (string value)
-#os_privileged_user_name=<None>
-
-# Password associated with the OpenStack privileged account.
-# (string value)
-#os_privileged_user_password=<None>
-
-# Tenant name associated with the OpenStack privileged
-# account. (string value)
-#os_privileged_user_tenant=<None>
-
-
-#
-# Options defined in cinder.compute
-#
-
-# The full class name of the compute API class to use (string
-# value)
-#compute_api_class=cinder.compute.nova.API
-
-
-#
-# Options defined in cinder.compute.nova
-#
-
-# Match this value when searching for nova in the service
-# catalog. Format is: separated values of the form:
-# <service_type>:<service_name>:<endpoint_type> (string value)
-#nova_catalog_info=compute:Compute Service:publicURL
-
-# Same as nova_catalog_info, but for admin endpoint. (string
-# value)
-#nova_catalog_admin_info=compute:Compute Service:adminURL
-
-# Override service catalog lookup with template for nova
-# endpoint e.g. http://localhost:8774/v2/%(project_id)s
-# (string value)
-#nova_endpoint_template=<None>
-
-# Same as nova_endpoint_template, but for admin endpoint.
-# (string value)
-#nova_endpoint_admin_template=<None>
-
-# Region name of this node (string value)
-#os_region_name=<None>
-
-# Location of ca certificates file to use for nova client
-# requests. (string value)
-#nova_ca_certificates_file=<None>
-
-# Allow to perform insecure SSL requests to nova (boolean
-# value)
-#nova_api_insecure=false
-
-
-#
-# Options defined in cinder.db.api
-#
-
-# Services to be added to the available pool on create
-# (boolean value)
-#enable_new_services=true
-
-# Template string to be used to generate volume names (string
-# value)
-#volume_name_template=volume-%s
-
-# Template string to be used to generate snapshot names
-# (string value)
-#snapshot_name_template=snapshot-%s
-
-# Template string to be used to generate backup names (string
-# value)
-#backup_name_template=backup-%s
-
-
-#
-# Options defined in cinder.db.base
-#
-
-# Driver to use for database access (string value)
-#db_driver=cinder.db
-
-
-#
-# Options defined in cinder.image.glance
-#
-
-# Default core properties of image (list value)
-#glance_core_properties=checksum,container_format,disk_format,image_name,image_id,min_disk,min_ram,name,size
-
-# A list of url schemes that can be downloaded directly via
-# the direct_url.  Currently supported schemes: [file]. (list
-# value)
-#allowed_direct_url_schemes=
-
-
-#
-# Options defined in cinder.image.image_utils
-#
-
-# Directory used for temporary storage during image conversion
-# (string value)
-#image_conversion_dir=$state_path/conversion
-
-
-#
-# Options defined in cinder.openstack.common.eventlet_backdoor
-#
-
-# Enable eventlet backdoor.  Acceptable values are 0, <port>,
-# and <start>:<end>, where 0 results in listening on a random
-# tcp port number; <port> results in listening on the
-# specified port number (and not enabling backdoor if that
-# port is in use); and <start>:<end> results in listening on
-# the smallest unused port number within the specified range
-# of port numbers.  The chosen port is displayed in the
-# service's log file. (string value)
-#backdoor_port=<None>
-
-
-#
-# Options defined in cinder.openstack.common.periodic_task
-#
-
-# Some periodic tasks can be run in a separate process. Should
-# we run them here? (boolean value)
-#run_external_periodic_tasks=true
-
-
-#
-# Options defined in cinder.openstack.common.policy
-#
-
-# The JSON file that defines policies. (string value)
-#policy_file=policy.json
-
-# Default rule. Enforced when a requested rule is not found.
-# (string value)
-#policy_default_rule=default
-
-# Directories where policy configuration files are stored.
-# They can be relative to any directory in the search path
-# defined by the config_dir option, or absolute paths. The
-# file defined by policy_file must exist for these directories
-# to be searched.  Missing or empty directories are ignored.
-# (multi valued)
-#policy_dirs=policy.d
-
-
-#
-# Options defined in cinder.openstack.common.versionutils
-#
-
-# Enables or disables fatal status of deprecations. (boolean
-# value)
-#fatal_deprecations=false
-
-
-#
-# Options defined in cinder.scheduler.driver
-#
-
-# The scheduler host manager class to use (string value)
-#scheduler_host_manager=cinder.scheduler.host_manager.HostManager
-
-# Maximum number of attempts to schedule an volume (integer
-# value)
-#scheduler_max_attempts=3
-
-
-#
-# Options defined in cinder.scheduler.host_manager
-#
-
-# Which filter class names to use for filtering hosts when not
-# specified in the request. (list value)
-#scheduler_default_filters=AvailabilityZoneFilter,CapacityFilter,CapabilitiesFilter
-
-# Which weigher class names to use for weighing hosts. (list
-# value)
-#scheduler_default_weighers=CapacityWeigher
-
-
-#
-# Options defined in cinder.scheduler.manager
-#
-
-# Default scheduler driver to use (string value)
-#scheduler_driver=cinder.scheduler.filter_scheduler.FilterScheduler
-
-
-#
-# Options defined in cinder.scheduler.scheduler_options
-#
-
-# Absolute path to scheduler configuration JSON file. (string
-# value)
-#scheduler_json_config_location=
-
-
-#
-# Options defined in cinder.scheduler.simple
-#
-
-# This configure option has been deprecated along with the
-# SimpleScheduler.  New scheduler is able to gather capacity
-# information for each host, thus setting the maximum number
-# of volume gigabytes for host is no longer needed.  It's safe
-# to remove this configure from cinder.conf. (integer value)
-#max_gigabytes=10000
-
-
-#
-# Options defined in cinder.scheduler.weights.capacity
-#
-
-# Multiplier used for weighing volume capacity. Negative
-# numbers mean to stack vs spread. (floating point value)
-#capacity_weight_multiplier=1.0
-
-# Multiplier used for weighing volume capacity. Negative
-# numbers mean to stack vs spread. (floating point value)
-#allocated_capacity_weight_multiplier=-1.0
-
-
-#
-# Options defined in cinder.scheduler.weights.volume_number
-#
-
-# Multiplier used for weighing volume number. Negative numbers
-# mean to spread vs stack. (floating point value)
-#volume_number_multiplier=-1.0
-
-
-#
-# Options defined in cinder.transfer.api
-#
-
-# The number of characters in the salt. (integer value)
-#volume_transfer_salt_length=8
-
-# The number of characters in the autogenerated auth key.
-# (integer value)
-#volume_transfer_key_length=16
-
-
-#
-# Options defined in cinder.volume.api
-#
-
-# Cache volume availability zones in memory for the provided
-# duration in seconds (integer value)
-#az_cache_duration=3600
-
-# Create volume from snapshot at the host where snapshot
-# resides (boolean value)
-#snapshot_same_host=true
-
-# Ensure that the new volumes are the same AZ as snapshot or
-# source volume (boolean value)
-#cloned_volume_same_az=true
-
-
-#
-# Options defined in cinder.volume.driver
-#
-
-# The maximum number of times to rescan iSER targetto find
-# volume (integer value)
-#num_iser_scan_tries=3
-
-# This option is deprecated and unused. It will be removed in
-# the Liberty release. (integer value)
-#iser_num_targets=<None>
-
-# Prefix for iSER volumes (string value)
-#iser_target_prefix=iqn.2010-10.org.openstack:
-
-# The IP address that the iSER daemon is listening on (string
-# value)
-#iser_ip_address=$my_ip
-
-# The port that the iSER daemon is listening on (integer
-# value)
-#iser_port=3260
-
-# The name of the iSER target user-land tool to use (string
-# value)
-#iser_helper=tgtadm
-
-# Number of times to attempt to run flakey shell commands
-# (integer value)
-#num_shell_tries=3
-
-# The percentage of backend capacity is reserved (integer
-# value)
-#reserved_percentage=0
-
-# This option is deprecated and unused. It will be removed in
-# the Liberty release. (integer value)
-#iscsi_num_targets=<None>
-
-# Prefix for iSCSI volumes (string value)
-#iscsi_target_prefix=iqn.2010-10.org.openstack:
-
-# The IP address that the iSCSI daemon is listening on (string
-# value)
-#iscsi_ip_address=$my_ip
-
-# The list of secondary IP addresses of the iSCSI daemon (list
-# value)
-#iscsi_secondary_ip_addresses=
-
-# The port that the iSCSI daemon is listening on (integer
-# value)
-#iscsi_port=3260
-
-# The maximum number of times to rescan targets to find volume
-# (integer value)
-# Deprecated group/name - [DEFAULT]/num_iscsi_scan_tries
-#num_volume_device_scan_tries=3
-
-# The backend name for a given driver implementation (string
-# value)
-#volume_backend_name=<None>
-
-# Do we attach/detach volumes in cinder using multipath for
-# volume to image and image to volume transfers? (boolean
-# value)
-#use_multipath_for_image_xfer=false
-
-# If this is set to True, attachment of volumes for image
-# transfer will be aborted when multipathd is not running.
-# Otherwise, it will fallback to single path. (boolean value)
-#enforce_multipath_for_image_xfer=false
-
-# Method used to wipe old volumes (string value)
-#volume_clear=zero
-
-# Size in MiB to wipe at start of old volumes. 0 => all
-# (integer value)
-#volume_clear_size=0
-
-# The flag to pass to ionice to alter the i/o priority of the
-# process used to zero a volume after deletion, for example
-# "-c3" for idle only priority. (string value)
-#volume_clear_ionice=<None>
-
-# iSCSI target user-land tool to use. tgtadm is default, use
-# lioadm for LIO iSCSI support, scstadmin for SCST target
-# support, iseradm for the ISER protocol, ietadm for iSCSI
-# Enterprise Target, iscsictl for Chelsio iSCSI Target or fake
-# for testing. (string value)
-#iscsi_helper=tgtadm
-
-# Volume configuration file storage directory (string value)
-#volumes_dir=$state_path/volumes
-
-# IET configuration file (string value)
-#iet_conf=/etc/iet/ietd.conf
-
-# Chiscsi (CXT) global defaults configuration file (string
-# value)
-#chiscsi_conf=/etc/chelsio-iscsi/chiscsi.conf
-
-# This option is deprecated and unused. It will be removed in
-# the next release. (string value)
-#lio_initiator_iqns=
-
-# Sets the behavior of the iSCSI target to either perform
-# blockio or fileio optionally, auto can be set and Cinder
-# will autodetect type of backing device (string value)
-#iscsi_iotype=fileio
-
-# The default block size used when copying/clearing volumes
-# (string value)
-#volume_dd_blocksize=1M
-
-# The blkio cgroup name to be used to limit bandwidth of
-# volume copy (string value)
-#volume_copy_blkio_cgroup_name=cinder-volume-copy
-
-# The upper limit of bandwidth of volume copy. 0 => unlimited
-# (integer value)
-#volume_copy_bps_limit=0
-
-# Sets the behavior of the iSCSI target to either perform
-# write-back(on) or write-through(off). This parameter is
-# valid if iscsi_helper is set to tgtadm or iseradm. (string
-# value)
-#iscsi_write_cache=on
-
-# Determines the iSCSI protocol for new iSCSI volumes, created
-# with tgtadm or lioadm target helpers. In order to enable
-# RDMA, this parameter should be set with the value "iser".
-# The supported iSCSI protocol values are "iscsi" and "iser".
-# (string value)
-#iscsi_protocol=iscsi
-
-# The path to the client certificate key for verification, if
-# the driver supports it. (string value)
-#driver_client_cert_key=<None>
-
-# The path to the client certificate for verification, if the
-# driver supports it. (string value)
-#driver_client_cert=<None>
-
-# Tell driver to use SSL for connection to backend storage if
-# the driver supports it. (boolean value)
-#driver_use_ssl=false
-
-# Float representation of the over subscription ratio when
-# thin provisioning is involved. Default ratio is 20.0,
-# meaning provisioned capacity can be 20 times of the total
-# physical capacity. If the ratio is 10.5, it means
-# provisioned capacity can be 10.5 times of the total physical
-# capacity. A ratio of 1.0 means provisioned capacity cannot
-# exceed the total physical capacity. A ratio lower than 1.0
-# will be ignored and the default value will be used instead.
-# (floating point value)
-#max_over_subscription_ratio=20.0
-
-# Certain ISCSI targets have predefined target names, SCST
-# target driver uses this name. (string value)
-#scst_target_iqn_name=<None>
-
-# SCST target implementation can choose from multiple SCST
-# target drivers. (string value)
-#scst_target_driver=iscsi
-
-# Option to enable/disable CHAP authentication for targets.
-# (boolean value)
-# Deprecated group/name - [DEFAULT]/eqlx_use_chap
-#use_chap_auth=false
-
-# CHAP user name. (string value)
-# Deprecated group/name - [DEFAULT]/eqlx_chap_login
-#chap_username=
-
-# Password for specified CHAP account name. (string value)
-# Deprecated group/name - [DEFAULT]/eqlx_chap_password
-#chap_password=
-
-# Namespace for driver private data values to be saved in.
-# (string value)
-#driver_data_namespace=<None>
-
-# String representation for an equation that will be used to
-# filter hosts. Only used when the driver filter is set to be
-# used by the Cinder scheduler. (string value)
-#filter_function=<None>
-
-# String representation for an equation that will be used to
-# determine the goodness of a host. Only used when using the
-# goodness weigher is set to be used by the Cinder scheduler.
-# (string value)
-#goodness_function=<None>
-
-
-#
-# Options defined in cinder.volume.drivers.block_device
-#
-
-# List of all available devices (list value)
-#available_devices=
-
-
-#
-# Options defined in cinder.volume.drivers.cloudbyte.options
-#
-
-# These values will be used for CloudByte storage's addQos API
-# call. (dict value)
-#cb_add_qosgroup=latency:15,iops:10,graceallowed:false,iopscontrol:true,memlimit:0,throughput:0,tpcontrol:false,networkspeed:0
-
-# Driver will use this API key to authenticate against the
-# CloudByte storage's management interface. (string value)
-#cb_apikey=None
-
-# CloudByte storage specific account name. This maps to a
-# project name in OpenStack. (string value)
-#cb_account_name=None
-
-# This corresponds to the name of Tenant Storage Machine (TSM)
-# in CloudByte storage. A volume will be created in this TSM.
-# (string value)
-#cb_tsm_name=None
-
-# A retry value in seconds. Will be used by the driver to
-# check if volume creation was successful in CloudByte
-# storage. (integer value)
-#cb_confirm_volume_create_retry_interval=5
-
-# Will confirm a successful volume creation in CloudByte
-# storage by making this many number of attempts. (integer
-# value)
-#cb_confirm_volume_create_retries=3
-
-# These values will be used for CloudByte storage's
-# createVolume API call. (dict value)
-#cb_create_volume=compression:off,deduplication:off,blocklength:512B,sync:always,protocoltype:ISCSI,recordsize:16k
-
-
-#
-# Options defined in cinder.volume.drivers.datera
-#
-
-# DEPRECATED: This will be removed in the Liberty release. Use
-# san_login and san_password instead. This directly sets the
-# Datera API token. (string value)
-#datera_api_token=<None>
-
-# Datera API port. (string value)
-#datera_api_port=7717
-
-# Datera API version. (string value)
-#datera_api_version=1
-
-# Number of replicas to create of an inode. (string value)
-#datera_num_replicas=3
-
-
-#
-# Options defined in cinder.volume.drivers.dell.dell_storagecenter_common
-#
-
-# Storage Center System Serial Number (integer value)
-#dell_sc_ssn=64702
-
-# Dell API port (integer value)
-#dell_sc_api_port=3033
-
-# Name of the server folder to use on the Storage Center
-# (string value)
-#dell_sc_server_folder=openstack
-
-# Name of the volume folder to use on the Storage Center
-# (string value)
-#dell_sc_volume_folder=openstack
-
-
-#
-# Options defined in cinder.volume.drivers.emc.emc_vmax_common
-#
-
-# use this file for cinder emc plugin config data (string
-# value)
-#cinder_emc_config_file=/etc/cinder/cinder_emc_config.xml
-
-
-#
-# Options defined in cinder.volume.drivers.emc.emc_vnx_cli
-#
-
-# VNX authentication scope type. (string value)
-#storage_vnx_authentication_type=global
-
-# Directory path that contains the VNX security file. Make
-# sure the security file is generated first. (string value)
-#storage_vnx_security_file_dir=<None>
-
-# Naviseccli Path. (string value)
-#naviseccli_path=
-
-# Storage pool name. (string value)
-#storage_vnx_pool_name=<None>
-
-# VNX secondary SP IP Address. (string value)
-#san_secondary_ip=<None>
-
-# Default timeout for CLI operations in minutes. For example,
-# LUN migration is a typical long running operation, which
-# depends on the LUN size and the load of the array. An upper
-# bound in the specific deployment can be set to avoid
-# unnecessary long wait. By default, it is 365 days long.
-# (integer value)
-#default_timeout=525600
-
-# Default max number of LUNs in a storage group. By default,
-# the value is 255. (integer value)
-#max_luns_per_storage_group=255
-
-# To destroy storage group when the last LUN is removed from
-# it. By default, the value is False. (boolean value)
-#destroy_empty_storage_group=false
-
-# Mapping between hostname and its iSCSI initiator IP
-# addresses. (string value)
-#iscsi_initiators=
-
-# Automatically register initiators. By default, the value is
-# False. (boolean value)
-#initiator_auto_registration=false
-
-# Automatically deregister initiators after the related
-# storage group is destroyed. By default, the value is False.
-# (boolean value)
-#initiator_auto_deregistration=false
-
-# Report free_capacity_gb as 0 when the limit to maximum
-# number of pool LUNs is reached. By default, the value is
-# False. (boolean value)
-#check_max_pool_luns_threshold=false
-
-# Delete a LUN even if it is in Storage Groups. (boolean
-# value)
-#force_delete_lun_in_storagegroup=false
-
-
-#
-# Options defined in cinder.volume.drivers.emc.xtremio
-#
-
-# XMS cluster id in multi-cluster environment (string value)
-#xtremio_cluster_name=
-
-
-#
-# Options defined in cinder.volume.drivers.eqlx
-#
-
-# Group name to use for creating volumes. Defaults to
-# "group-0". (string value)
-#eqlx_group_name=group-0
-
-# Timeout for the Group Manager cli command execution. Default
-# is 30. (integer value)
-#eqlx_cli_timeout=30
-
-# Maximum retry count for reconnection. Default is 5. (integer
-# value)
-#eqlx_cli_max_retries=5
-
-# Use CHAP authentication for targets. Note that this option
-# is deprecated in favour of "use_chap_auth" as specified in
-# cinder/volume/driver.py and will be removed in next release.
-# (boolean value)
-#eqlx_use_chap=false
-
-# Existing CHAP account name. Note that this option is
-# deprecated in favour of "chap_username" as specified in
-# cinder/volume/driver.py and will be removed in next release.
-# (string value)
-#eqlx_chap_login=admin
-
-# Password for specified CHAP account name. Note that this
-# option is deprecated in favour of "chap_password" as
-# specified in cinder/volume/driver.py and will be removed in
-# the next release (string value)
-#eqlx_chap_password=password
-
-# Pool in which volumes will be created. Defaults to
-# "default". (string value)
-#eqlx_pool=default
-
-
-#
-# Options defined in cinder.volume.drivers.glusterfs
-#
-
-# File with the list of available gluster shares (string
-# value)
-#glusterfs_shares_config=/etc/cinder/glusterfs_shares
-
-# Create volumes as sparsed files which take no space.If set
-# to False volume is created as regular file.In such case
-# volume creation takes a lot of time. (boolean value)
-#glusterfs_sparsed_volumes=true
-
-# Create volumes as QCOW2 files rather than raw files.
-# (boolean value)
-#glusterfs_qcow2_volumes=false
-
-# Base dir containing mount points for gluster shares. (string
-# value)
-#glusterfs_mount_point_base=$state_path/mnt
-
-
-#
-# Options defined in cinder.volume.drivers.hds.hds
-#
-
-# The configuration file for the Cinder HDS driver for HUS
-# (string value)
-#hds_cinder_config_file=/opt/hds/hus/cinder_hus_conf.xml
-
-
-#
-# Options defined in cinder.volume.drivers.hds.iscsi
-#
-
-# Configuration file for HDS iSCSI cinder plugin (string
-# value)
-#hds_hnas_iscsi_config_file=/opt/hds/hnas/cinder_iscsi_conf.xml
-
-
-#
-# Options defined in cinder.volume.drivers.hds.nfs
-#
-
-# Configuration file for HDS NFS cinder plugin (string value)
-#hds_hnas_nfs_config_file=/opt/hds/hnas/cinder_nfs_conf.xml
-
-
-#
-# Options defined in cinder.volume.drivers.hitachi.hbsd_common
-#
-
-# Serial number of storage system (string value)
-#hitachi_serial_number=<None>
-
-# Name of an array unit (string value)
-#hitachi_unit_name=<None>
-
-# Pool ID of storage system (integer value)
-#hitachi_pool_id=<None>
-
-# Thin pool ID of storage system (integer value)
-#hitachi_thin_pool_id=<None>
-
-# Range of logical device of storage system (string value)
-#hitachi_ldev_range=<None>
-
-# Default copy method of storage system (string value)
-#hitachi_default_copy_method=FULL
-
-# Copy speed of storage system (integer value)
-#hitachi_copy_speed=3
-
-# Interval to check copy (integer value)
-#hitachi_copy_check_interval=3
-
-# Interval to check copy asynchronously (integer value)
-#hitachi_async_copy_check_interval=10
-
-# Control port names for HostGroup or iSCSI Target (string
-# value)
-#hitachi_target_ports=<None>
-
-# Range of group number (string value)
-#hitachi_group_range=<None>
-
-# Request for creating HostGroup or iSCSI Target (boolean
-# value)
-#hitachi_group_request=false
-
-
-#
-# Options defined in cinder.volume.drivers.hitachi.hbsd_fc
-#
-
-# Request for FC Zone creating HostGroup (boolean value)
-#hitachi_zoning_request=false
-
-
-#
-# Options defined in cinder.volume.drivers.hitachi.hbsd_horcm
-#
-
-# Instance numbers for HORCM (string value)
-#hitachi_horcm_numbers=200,201
-
-# Username of storage system for HORCM (string value)
-#hitachi_horcm_user=<None>
-
-# Password of storage system for HORCM (string value)
-#hitachi_horcm_password=<None>
-
-# Add to HORCM configuration (boolean value)
-#hitachi_horcm_add_conf=true
-
-
-#
-# Options defined in cinder.volume.drivers.hitachi.hbsd_iscsi
-#
-
-# Add CHAP user (boolean value)
-#hitachi_add_chap_user=false
-
-# iSCSI authentication method (string value)
-#hitachi_auth_method=<None>
-
-# iSCSI authentication username (string value)
-#hitachi_auth_user=HBSD-CHAP-user
-
-# iSCSI authentication password (string value)
-#hitachi_auth_password=HBSD-CHAP-password
-
-
-#
-# Options defined in cinder.volume.drivers.huawei
-#
-
-# The configuration file for the Cinder Huawei driver (string
-# value)
-#cinder_huawei_conf_file=/etc/cinder/cinder_huawei_conf.xml
-
-
-#
-# Options defined in cinder.volume.drivers.ibm.flashsystem
-#
-
-# Connection protocol should be FC. (string value)
-#flashsystem_connection_protocol=FC
-
-# Connect with multipath (FC only). (boolean value)
-#flashsystem_multipath_enabled=false
-
-# Allows vdisk to multi host mapping. (boolean value)
-#flashsystem_multihostmap_enabled=true
-
-
-#
-# Options defined in cinder.volume.drivers.ibm.gpfs
-#
-
-# Specifies the path of the GPFS directory where Block Storage
-# volume and snapshot files are stored. (string value)
-#gpfs_mount_point_base=<None>
-
-# Specifies the path of the Image service repository in GPFS.
-# Leave undefined if not storing images in GPFS. (string
-# value)
-#gpfs_images_dir=<None>
-
-# Specifies the type of image copy to be used.  Set this when
-# the Image service repository also uses GPFS so that image
-# files can be transferred efficiently from the Image service
-# to the Block Storage service. There are two valid values:
-# "copy" specifies that a full copy of the image is made;
-# "copy_on_write" specifies that copy-on-write optimization
-# strategy is used and unmodified blocks of the image file are
-# shared efficiently. (string value)
-#gpfs_images_share_mode=<None>
-
-# Specifies an upper limit on the number of indirections
-# required to reach a specific block due to snapshots or
-# clones.  A lengthy chain of copy-on-write snapshots or
-# clones can have a negative impact on performance, but
-# improves space utilization.  0 indicates unlimited clone
-# depth. (integer value)
-#gpfs_max_clone_depth=0
-
-# Specifies that volumes are created as sparse files which
-# initially consume no space. If set to False, the volume is
-# created as a fully allocated file, in which case, creation
-# may take a significantly longer time. (boolean value)
-#gpfs_sparse_volumes=true
-
-# Specifies the storage pool that volumes are assigned to. By
-# default, the system storage pool is used. (string value)
-#gpfs_storage_pool=system
-
-
-#
-# Options defined in cinder.volume.drivers.ibm.ibmnas
-#
-
-# IBMNAS platform type to be used as backend storage; valid
-# values are - v7ku : for using IBM Storwize V7000 Unified,
-# sonas : for using IBM Scale Out NAS, gpfs-nas : for using
-# NFS based IBM GPFS deployments. (string value)
-#ibmnas_platform_type=v7ku
-
-
-#
-# Options defined in cinder.volume.drivers.ibm.storwize_svc
-#
-
-# Storage system storage pool for volumes (string value)
-#storwize_svc_volpool_name=volpool
-
-# Storage system space-efficiency parameter for volumes
-# (percentage) (integer value)
-#storwize_svc_vol_rsize=2
-
-# Storage system threshold for volume capacity warnings
-# (percentage) (integer value)
-#storwize_svc_vol_warning=0
-
-# Storage system autoexpand parameter for volumes (True/False)
-# (boolean value)
-#storwize_svc_vol_autoexpand=true
-
-# Storage system grain size parameter for volumes
-# (32/64/128/256) (integer value)
-#storwize_svc_vol_grainsize=256
-
-# Storage system compression option for volumes (boolean
-# value)
-#storwize_svc_vol_compression=false
-
-# Enable Easy Tier for volumes (boolean value)
-#storwize_svc_vol_easytier=true
-
-# The I/O group in which to allocate volumes (integer value)
-#storwize_svc_vol_iogrp=0
-
-# Maximum number of seconds to wait for FlashCopy to be
-# prepared. Maximum value is 600 seconds (10 minutes) (integer
-# value)
-#storwize_svc_flashcopy_timeout=120
-
-# Connection protocol (iSCSI/FC) (string value)
-#storwize_svc_connection_protocol=iSCSI
-
-# Configure CHAP authentication for iSCSI connections
-# (Default: Enabled) (boolean value)
-#storwize_svc_iscsi_chap_enabled=true
-
-# Connect with multipath (FC only; iSCSI multipath is
-# controlled by Nova) (boolean value)
-#storwize_svc_multipath_enabled=false
-
-# Allows vdisk to multi host mapping (boolean value)
-#storwize_svc_multihostmap_enabled=true
-
-# Indicate whether svc driver is compatible for NPIV setup. If
-# it is compatible, it will allow no wwpns being returned on
-# get_conn_fc_wwpns during initialize_connection (boolean
-# value)
-#storwize_svc_npiv_compatibility_mode=false
-
-# Allow tenants to specify QOS on create (boolean value)
-#storwize_svc_allow_tenant_qos=false
-
-# If operating in stretched cluster mode, specify the name of
-# the pool in which mirrored copies are stored.Example:
-# "pool2" (string value)
-#storwize_svc_stretched_cluster_partner=<None>
-
-
-#
-# Options defined in cinder.volume.drivers.ibm.xiv_ds8k
-#
-
-# Proxy driver that connects to the IBM Storage Array (string
-# value)
-#xiv_ds8k_proxy=xiv_ds8k_openstack.nova_proxy.XIVDS8KNovaProxy
-
-# Connection type to the IBM Storage Array (string value)
-#xiv_ds8k_connection_type=iscsi
-
-# CHAP authentication mode, effective only for iscsi
-# (disabled|enabled) (string value)
-#xiv_chap=disabled
-
-
-#
-# Options defined in cinder.volume.drivers.lvm
-#
-
-# Name for the VG that will contain exported volumes (string
-# value)
-#volume_group=cinder-volumes
-
-# If >0, create LVs with multiple mirrors. Note that this
-# requires lvm_mirrors + 2 PVs with available space (integer
-# value)
-#lvm_mirrors=0
-
-# Type of LVM volumes to deploy (string value)
-#lvm_type=default
-
-# LVM conf file to use for the LVM driver in Cinder; this
-# setting is ignored if the specified file does not exist (You
-# can also specify 'None' to not use a conf file even if one
-# exists). (string value)
-#lvm_conf_file=/etc/cinder/lvm.conf
-
-
-#
-# Options defined in cinder.volume.drivers.netapp.options
-#
-
-# The vFiler unit on which provisioning of block storage
-# volumes will be done. This option is only used by the driver
-# when connecting to an instance with a storage family of Data
-# ONTAP operating in 7-Mode. Only use this option when
-# utilizing the MultiStore feature on the NetApp storage
-# system. (string value)
-#netapp_vfiler=<None>
-
-# The name of the config.conf stanza for a Data ONTAP (7-mode)
-# HA partner.  This option is only used by the driver when
-# connecting to an instance with a storage family of Data
-# ONTAP operating in 7-Mode, and it is required if the storage
-# protocol selected is FC. (string value)
-#netapp_partner_backend_name=<None>
-
-# Administrative user account name used to access the storage
-# system or proxy server. (string value)
-#netapp_login=<None>
-
-# Password for the administrative user account specified in
-# the netapp_login option. (string value)
-#netapp_password=<None>
-
-# This option specifies the virtual storage server (Vserver)
-# name on the storage cluster on which provisioning of block
-# storage volumes should occur. (string value)
-#netapp_vserver=<None>
-
-# The hostname (or IP address) for the storage system or proxy
-# server. (string value)
-#netapp_server_hostname=<None>
-
-# The TCP port to use for communication with the storage
-# system or proxy server. If not specified, Data ONTAP drivers
-# will use 80 for HTTP and 443 for HTTPS; E-Series will use
-# 8080 for HTTP and 8443 for HTTPS. (integer value)
-#netapp_server_port=<None>
-
-# This option is used to specify the path to the E-Series
-# proxy application on a proxy server. The value is combined
-# with the value of the netapp_transport_type,
-# netapp_server_hostname, and netapp_server_port options to
-# create the URL used by the driver to connect to the proxy
-# application. (string value)
-#netapp_webservice_path=/devmgr/v2
-
-# This option is only utilized when the storage family is
-# configured to eseries. This option is used to restrict
-# provisioning to the specified controllers. Specify the value
-# of this option to be a comma separated list of controller
-# hostnames or IP addresses to be used for provisioning.
-# (string value)
-#netapp_controller_ips=<None>
-
-# Password for the NetApp E-Series storage array. (string
-# value)
-#netapp_sa_password=<None>
-
-# This option is used to restrict provisioning to the
-# specified storage pools. Only dynamic disk pools are
-# currently supported. Specify the value of this option to be
-# a comma separated list of disk pool names to be used for
-# provisioning. (string value)
-#netapp_storage_pools=<None>
-
-# This option is used to define how the controllers in the
-# E-Series storage array will work with the particular
-# operating system on the hosts that are connected to it.
-# (string value)
-#netapp_eseries_host_type=linux_dm_mp
-
-# If the percentage of available space for an NFS share has
-# dropped below the value specified by this option, the NFS
-# image cache will be cleaned. (integer value)
-#thres_avl_size_perc_start=20
-
-# When the percentage of available space on an NFS share has
-# reached the percentage specified by this option, the driver
-# will stop clearing files from the NFS image cache that have
-# not been accessed in the last M minutes, where M is the
-# value of the expiry_thres_minutes configuration option.
-# (integer value)
-#thres_avl_size_perc_stop=60
-
-# This option specifies the threshold for last access time for
-# images in the NFS image cache. When a cache cleaning cycle
-# begins, images in the cache that have not been accessed in
-# the last M minutes, where M is the value of this parameter,
-# will be deleted from the cache to create free space on the
-# NFS share. (integer value)
-#expiry_thres_minutes=720
-
-# This option specifies the path of the NetApp copy offload
-# tool binary. Ensure that the binary has execute permissions
-# set which allow the effective user of the cinder-volume
-# process to execute the file. (string value)
-#netapp_copyoffload_tool_path=<None>
-
-# The quantity to be multiplied by the requested volume size
-# to ensure enough space is available on the virtual storage
-# server (Vserver) to fulfill the volume creation request.
-# (floating point value)
-#netapp_size_multiplier=1.2
-
-# This option is only utilized when the storage protocol is
-# configured to use iSCSI or FC. This option is used to
-# restrict provisioning to the specified controller volumes.
-# Specify the value of this option to be a comma separated
-# list of NetApp controller volume names to be used for
-# provisioning. (string value)
-#netapp_volume_list=<None>
-
-# The storage family type used on the storage system; valid
-# values are ontap_7mode for using Data ONTAP operating in
-# 7-Mode, ontap_cluster for using clustered Data ONTAP, or
-# eseries for using E-Series. (string value)
-#netapp_storage_family=ontap_cluster
-
-# The storage protocol to be used on the data path with the
-# storage system. (string value)
-#netapp_storage_protocol=<None>
-
-# The transport protocol used when communicating with the
-# storage system or proxy server. (string value)
-#netapp_transport_type=http
-
-
-#
-# Options defined in cinder.volume.drivers.nfs
-#
-
-# File with the list of available nfs shares (string value)
-#nfs_shares_config=/etc/cinder/nfs_shares
-
-# Create volumes as sparsed files which take no space.If set
-# to False volume is created as regular file.In such case
-# volume creation takes a lot of time. (boolean value)
-#nfs_sparsed_volumes=true
-
-# Percent of ACTUAL usage of the underlying volume before no
-# new volumes can be allocated to the volume destination.
-# (floating point value)
-#nfs_used_ratio=0.95
-
-# This will compare the allocated to available space on the
-# volume destination.  If the ratio exceeds this number, the
-# destination will no longer be valid. (floating point value)
-#nfs_oversub_ratio=1.0
-
-# Base dir containing mount points for nfs shares. (string
-# value)
-#nfs_mount_point_base=$state_path/mnt
-
-# Mount options passed to the nfs client. See section of the
-# nfs man page for details. (string value)
-#nfs_mount_options=<None>
-
-# The number of attempts to mount nfs shares before raising an
-# error.  At least one attempt will be made to mount an nfs
-# share, regardless of the value specified. (integer value)
-#nfs_mount_attempts=3
-
-
-#
-# Options defined in cinder.volume.drivers.nimble
-#
-
-# Nimble Controller pool name (string value)
-#nimble_pool_name=default
-
-# Nimble Subnet Label (string value)
-#nimble_subnet_label=*
-
-
-#
-# Options defined in cinder.volume.drivers.openvstorage
-#
-
-# Vpool to use for volumes - backend is defined by vpool not
-# by us. (string value)
-#vpool_name=
-
-
-#
-# Options defined in cinder.volume.drivers.prophetstor.options
-#
-
-# DPL pool uuid in which DPL volumes are stored. (string
-# value)
-#dpl_pool=
-
-# DPL port number. (integer value)
-#dpl_port=8357
-
-
-#
-# Options defined in cinder.volume.drivers.pure
-#
-
-# REST API authorization token. (string value)
-#pure_api_token=<None>
-
-
-#
-# Options defined in cinder.volume.drivers.quobyte
-#
-
-# URL to the Quobyte volume e.g., quobyte://<DIR host>/<volume
-# name> (string value)
-#quobyte_volume_url=<None>
-
-# Path to a Quobyte Client configuration file. (string value)
-#quobyte_client_cfg=<None>
-
-# Create volumes as sparse files which take no space. If set
-# to False, volume is created as regular file.In such case
-# volume creation takes a lot of time. (boolean value)
-#quobyte_sparsed_volumes=true
-
-# Create volumes as QCOW2 files rather than raw files.
-# (boolean value)
-#quobyte_qcow2_volumes=true
-
-# Base dir containing the mount point for the Quobyte volume.
-# (string value)
-#quobyte_mount_point_base=$state_path/mnt
-
-
-#
-# Options defined in cinder.volume.drivers.rbd
-#
-
-# The RADOS pool where rbd volumes are stored (string value)
-#rbd_pool=rbd
-
-# The RADOS client name for accessing rbd volumes - only set
-# when using cephx authentication (string value)
-#rbd_user=<None>
-
-# Path to the ceph configuration file (string value)
-#rbd_ceph_conf=
-
-# Flatten volumes created from snapshots to remove dependency
-# from volume to snapshot (boolean value)
-#rbd_flatten_volume_from_snapshot=false
-
-# The libvirt uuid of the secret for the rbd_user volumes
-# (string value)
-#rbd_secret_uuid=<None>
-
-# Directory where temporary image files are stored when the
-# volume driver does not write them directly to the volume.
-# Warning: this option is now deprecated, please use
-# image_conversion_dir instead. (string value)
-#volume_tmp_dir=<None>
-
-# Maximum number of nested volume clones that are taken before
-# a flatten occurs. Set to 0 to disable cloning. (integer
-# value)
-#rbd_max_clone_depth=5
-
-# Volumes will be chunked into objects of this size (in
-# megabytes). (integer value)
-#rbd_store_chunk_size=4
-
-# Timeout value (in seconds) used when connecting to ceph
-# cluster. If value < 0, no timeout is set and default
-# librados value is used. (integer value)
-#rados_connect_timeout=-1
-
-
-#
-# Options defined in cinder.volume.drivers.remotefs
-#
-
-# IP address or Hostname of NAS system. (string value)
-#nas_ip=
-
-# User name to connect to NAS system. (string value)
-#nas_login=admin
-
-# Password to connect to NAS system. (string value)
-#nas_password=
-
-# SSH port to use to connect to NAS system. (integer value)
-#nas_ssh_port=22
-
-# Filename of private key to use for SSH authentication.
-# (string value)
-#nas_private_key=
-
-# Allow network-attached storage systems to operate in a
-# secure environment where root level access is not permitted.
-# If set to False, access is as the root user and insecure. If
-# set to True, access is not as root. If set to auto, a check
-# is done to determine if this is a new installation: True is
-# used if so, otherwise False. Default is auto. (string value)
-#nas_secure_file_operations=auto
-
-# Set more secure file permissions on network-attached storage
-# volume files to restrict broad other/world access. If set to
-# False, volumes are created with open permissions. If set to
-# True, volumes are created with permissions for the cinder
-# user and group (660). If set to auto, a check is done to
-# determine if this is a new installation: True is used if so,
-# otherwise False. Default is auto. (string value)
-#nas_secure_file_permissions=auto
-
-# Path to the share to use for storing Cinder volumes. For
-# example:  "/srv/export1" for an NFS server export available
-# at 10.0.5.10:/srv/export1 . (string value)
-#nas_share_path=
-
-# Options used to mount the storage backend file system where
-# Cinder volumes are stored. (string value)
-#nas_mount_options=<None>
-
-
-#
-# Options defined in cinder.volume.drivers.san.hp.hp_3par_common
-#
-
-# 3PAR WSAPI Server Url like https://<3par ip>:8080/api/v1
-# (string value)
-#hp3par_api_url=
-
-# 3PAR Super user username (string value)
-#hp3par_username=
-
-# 3PAR Super user password (string value)
-#hp3par_password=
-
-# List of the CPG(s) to use for volume creation (list value)
-#hp3par_cpg=OpenStack
-
-# The CPG to use for Snapshots for volumes. If empty the
-# userCPG will be used. (string value)
-#hp3par_cpg_snap=
-
-# The time in hours to retain a snapshot.  You can't delete it
-# before this expires. (string value)
-#hp3par_snapshot_retention=
-
-# The time in hours when a snapshot expires  and is deleted.
-# This must be larger than expiration (string value)
-#hp3par_snapshot_expiration=
-
-# Enable HTTP debugging to 3PAR (boolean value)
-#hp3par_debug=false
-
-# List of target iSCSI addresses to use. (list value)
-#hp3par_iscsi_ips=
-
-# Enable CHAP authentication for iSCSI connections. (boolean
-# value)
-#hp3par_iscsi_chap_enabled=false
-
-
-#
-# Options defined in cinder.volume.drivers.san.hp.hp_lefthand_rest_proxy
-#
-
-# HP LeftHand WSAPI Server Url like https://<LeftHand
-# ip>:8081/lhos (string value)
-#hplefthand_api_url=<None>
-
-# HP LeftHand Super user username (string value)
-#hplefthand_username=<None>
-
-# HP LeftHand Super user password (string value)
-#hplefthand_password=<None>
-
-# HP LeftHand cluster name (string value)
-#hplefthand_clustername=<None>
-
-# Configure CHAP authentication for iSCSI connections
-# (Default: Disabled) (boolean value)
-#hplefthand_iscsi_chap_enabled=false
-
-# Enable HTTP debugging to LeftHand (boolean value)
-#hplefthand_debug=false
-
-
-#
-# Options defined in cinder.volume.drivers.san.san
-#
-
-# Use thin provisioning for SAN volumes? (boolean value)
-#san_thin_provision=true
-
-# IP address of SAN controller (string value)
-#san_ip=
-
-# Username for SAN controller (string value)
-#san_login=admin
-
-# Password for SAN controller (string value)
-#san_password=
-
-# Filename of private key to use for SSH authentication
-# (string value)
-#san_private_key=
-
-# Cluster name to use for creating volumes (string value)
-#san_clustername=
-
-# SSH port to use with SAN (integer value)
-#san_ssh_port=22
-
-# Execute commands locally instead of over SSH; use if the
-# volume service is running on the SAN device (boolean value)
-#san_is_local=false
-
-# SSH connection timeout in seconds (integer value)
-#ssh_conn_timeout=30
-
-# Minimum ssh connections in the pool (integer value)
-#ssh_min_pool_conn=1
-
-# Maximum ssh connections in the pool (integer value)
-#ssh_max_pool_conn=5
-
-
-#
-# Options defined in cinder.volume.drivers.scality
-#
-
-# Path or URL to Scality SOFS configuration file (string
-# value)
-#scality_sofs_config=<None>
-
-# Base dir where Scality SOFS shall be mounted (string value)
-#scality_sofs_mount_point=$state_path/scality
-
-# Path from Scality SOFS root to volume dir (string value)
-#scality_sofs_volume_dir=cinder/volumes
-
-
-#
-# Options defined in cinder.volume.drivers.smbfs
-#
-
-# File with the list of available smbfs shares. (string value)
-#smbfs_shares_config=/etc/cinder/smbfs_shares
-
-# Default format that will be used when creating volumes if no
-# volume format is specified. (string value)
-#smbfs_default_volume_format=qcow2
-
-# Create volumes as sparsed files which take no space rather
-# than regular files when using raw format, in which case
-# volume creation takes lot of time. (boolean value)
-#smbfs_sparsed_volumes=true
-
-# Percent of ACTUAL usage of the underlying volume before no
-# new volumes can be allocated to the volume destination.
-# (floating point value)
-#smbfs_used_ratio=0.95
-
-# This will compare the allocated to available space on the
-# volume destination.  If the ratio exceeds this number, the
-# destination will no longer be valid. (floating point value)
-#smbfs_oversub_ratio=1.0
-
-# Base dir containing mount points for smbfs shares. (string
-# value)
-#smbfs_mount_point_base=$state_path/mnt
-
-# Mount options passed to the smbfs client. See mount.cifs man
-# page for details. (string value)
-#smbfs_mount_options=noperm,file_mode=0775,dir_mode=0775
-
-
-#
-# Options defined in cinder.volume.drivers.solidfire
-#
-
-# Set 512 byte emulation on volume creation;  (boolean value)
-#sf_emulate_512=true
-
-# Allow tenants to specify QOS on create (boolean value)
-#sf_allow_tenant_qos=false
-
-# Create SolidFire accounts with this prefix. Any string can
-# be used here, but the string "hostname" is special and will
-# create a prefix using the cinder node hostsname (previous
-# default behavior).  The default is NO prefix. (string value)
-#sf_account_prefix=<None>
-
-# Account name on the SolidFire Cluster to use as owner of
-# template/cache volumes (created if does not exist). (string
-# value)
-#sf_template_account_name=openstack-vtemplate
-
-# Create an internal cache of copy of images when a bootable
-# volume is created to eliminate fetch from glance and qemu-
-# conversion on subsequent calls. (boolean value)
-#sf_allow_template_caching=true
-
-# SolidFire API port. Useful if the device api is behind a
-# proxy on a different port. (integer value)
-#sf_api_port=443
-
-
-#
-# Options defined in cinder.volume.drivers.srb
-#
-
-# Comma-separated list of REST servers IP to connect to. (eg
-# http://IP1/,http://IP2:81/path (string value)
-#srb_base_urls=<None>
-
-
-#
-# Options defined in cinder.volume.drivers.violin.v6000_common
-#
-
-# IP address or hostname of mg-a (string value)
-#gateway_mga=<None>
-
-# IP address or hostname of mg-b (string value)
-#gateway_mgb=<None>
-
-# Use igroups to manage targets and initiators (boolean value)
-#use_igroups=false
-
-# Global backend request timeout, in seconds (integer value)
-#request_timeout=300
-
-
-#
-# Options defined in cinder.volume.drivers.vmware.vmdk
-#
-
-# IP address for connecting to VMware ESX/VC server. (string
-# value)
-#vmware_host_ip=<None>
-
-# Username for authenticating with VMware ESX/VC server.
-# (string value)
-#vmware_host_username=<None>
-
-# Password for authenticating with VMware ESX/VC server.
-# (string value)
-#vmware_host_password=<None>
-
-# Optional VIM service WSDL Location e.g
-# http://<server>/vimService.wsdl. Optional over-ride to
-# default location for bug work-arounds. (string value)
-#vmware_wsdl_location=<None>
-
-# Number of times VMware ESX/VC server API must be retried
-# upon connection related issues. (integer value)
-#vmware_api_retry_count=10
-
-# The interval (in seconds) for polling remote tasks invoked
-# on VMware ESX/VC server. (floating point value)
-#vmware_task_poll_interval=0.5
-
-# Name for the folder in the VC datacenter that will contain
-# cinder volumes. (string value)
-#vmware_volume_folder=cinder-volumes
-
-# Timeout in seconds for VMDK volume transfer between Cinder
-# and Glance. (integer value)
-#vmware_image_transfer_timeout_secs=7200
-
-# Max number of objects to be retrieved per batch. Query
-# results will be obtained in batches from the server and not
-# in one shot. Server may still limit the count to something
-# less than the configured value. (integer value)
-#vmware_max_objects_retrieval=100
-
-# Optional string specifying the VMware VC server version. The
-# driver attempts to retrieve the version from VMware VC
-# server. Set this configuration only if you want to override
-# the VC server version. (string value)
-#vmware_host_version=<None>
-
-# Directory where virtual disks are stored during volume
-# backup and restore. (string value)
-#vmware_tmp_dir=/tmp
-
-
-#
-# Options defined in cinder.volume.drivers.windows.windows
-#
-
-# Path to store VHD backed volumes (string value)
-#windows_iscsi_lun_path=C:\iSCSIVirtualDisks
-
-
-#
-# Options defined in cinder.volume.drivers.xio
-#
-
-# Default storage pool for volumes. (integer value)
-#ise_storage_pool=1
-
-# Raid level for ISE volumes. (integer value)
-#ise_raid=1
-
-# Number of retries (per port) when establishing connection to
-# ISE management port. (integer value)
-#ise_connection_retries=5
-
-# Interval (secs) between retries. (integer value)
-#ise_retry_interval=1
-
-# Number on retries to get completion status after issuing a
-# command to ISE. (integer value)
-#ise_completion_retries=30
-
-
-#
-# Options defined in cinder.volume.drivers.zfssa.zfssanfs
-#
-
-# Data path IP address (string value)
-#zfssa_data_ip=<None>
-
-# HTTPS port number (string value)
-#zfssa_https_port=443
-
-# Options to be passed while mounting share over nfs (string
-# value)
-#zfssa_nfs_mount_options=
-
-# Storage pool name. (string value)
-#zfssa_nfs_pool=
-
-# Project name. (string value)
-#zfssa_nfs_project=NFSProject
-
-# Share name. (string value)
-#zfssa_nfs_share=nfs_share
-
-# Data compression. (string value)
-#zfssa_nfs_share_compression=off
-
-# Synchronous write bias-latency, throughput. (string value)
-#zfssa_nfs_share_logbias=latency
-
-# REST connection timeout. (seconds) (integer value)
-#zfssa_rest_timeout=<None>
-
-
-#
-# Options defined in cinder.volume.manager
-#
-
-# Driver to use for volume creation (string value)
-#volume_driver=cinder.volume.drivers.lvm.LVMISCSIDriver
-
-# Timeout for creating the volume to migrate to when
-# performing volume migration (seconds) (integer value)
-#migration_create_volume_timeout_secs=300
-
-# Offload pending volume delete during volume service startup
-# (boolean value)
-#volume_service_inithost_offload=false
-
-# FC Zoning mode configured (string value)
-#zoning_mode=none
-
-# User defined capabilities, a JSON formatted string
-# specifying key/value pairs. The key/value pairs can be used
-# by the CapabilitiesFilter to select between backends when
-# requests specify volume types. For example, specifying a
-# service level or the geographical location of a backend,
-# then creating a volume type to allow the user to select by
-# these different properties. (string value)
-#extra_capabilities={}
-
-
-[BRCD_FABRIC_EXAMPLE]
-
-#
-# Options defined in cinder.zonemanager.drivers.brocade.brcd_fabric_opts
-#
-
-# Management IP of fabric (string value)
-#fc_fabric_address=
-
-# Fabric user ID (string value)
-#fc_fabric_user=
-
-# Password for user (string value)
-#fc_fabric_password=
-
-# Connecting port (integer value)
-#fc_fabric_port=22
-
-# overridden zoning policy (string value)
-#zoning_policy=initiator-target
-
-# overridden zoning activation state (boolean value)
-#zone_activate=true
-
-# overridden zone name prefix (string value)
-#zone_name_prefix=<None>
-
-# Principal switch WWN of the fabric (string value)
-#principal_switch_wwn=<None>
-
-
-[CISCO_FABRIC_EXAMPLE]
-
-#
-# Options defined in cinder.zonemanager.drivers.cisco.cisco_fabric_opts
-#
-
-# Management IP of fabric (string value)
-#cisco_fc_fabric_address=
-
-# Fabric user ID (string value)
-#cisco_fc_fabric_user=
-
-# Password for user (string value)
-#cisco_fc_fabric_password=
-
-# Connecting port (integer value)
-#cisco_fc_fabric_port=22
-
-# overridden zoning policy (string value)
-#cisco_zoning_policy=initiator-target
-
-# overridden zoning activation state (boolean value)
-#cisco_zone_activate=true
-
-# overridden zone name prefix (string value)
-#cisco_zone_name_prefix=<None>
-
-# VSAN of the Fabric (string value)
-#cisco_zoning_vsan=<None>
-
+rootwrap_config = /etc/cinder/rootwrap.conf
+api_paste_confg = /etc/cinder/api-paste.ini
+iscsi_helper = tgtadm
+volume_name_template = volume-%s
+volume_group = cinder-volumes
+verbose = True
+auth_strategy = keystone
+state_path = /var/lib/cinder
+lock_path = /var/lock/cinder
+volumes_dir = /var/lib/cinder/volumes
+enabled_backends = lvm
 
 [database]
-
-#
-# Options defined in oslo.db.concurrency
-#
-
-# Enable the experimental use of thread pooling for all DB API
-# calls (boolean value)
-# Deprecated group/name - [DEFAULT]/dbapi_use_tpool
-#use_tpool=false
-
-
-[fc-zone-manager]
-
-#
-# Options defined in cinder.zonemanager.drivers.brocade.brcd_fc_zone_driver
-#
-
-# Southbound connector for zoning operation (string value)
-#brcd_sb_connector=cinder.zonemanager.drivers.brocade.brcd_fc_zone_client_cli.BrcdFCZoneClientCLI
-
-
-#
-# Options defined in cinder.zonemanager.drivers.cisco.cisco_fc_zone_driver
-#
-
-# Southbound connector for zoning operation (string value)
-#cisco_sb_connector=cinder.zonemanager.drivers.cisco.cisco_fc_zone_client_cli.CiscoFCZoneClientCLI
-
-
-#
-# Options defined in cinder.zonemanager.fc_zone_manager
-#
-
-# FC Zone Driver responsible for zone management (string
-# value)
-#zone_driver=cinder.zonemanager.drivers.brocade.brcd_fc_zone_driver.BrcdFCZoneDriver
-
-# Zoning policy configured by user; valid values include
-# "initiator-target" or "initiator" (string value)
-#zoning_policy=initiator-target
-
-# Comma separated list of Fibre Channel fabric names. This
-# list of names is used to retrieve other SAN credentials for
-# connecting to each SAN fabric (string value)
-#fc_fabric_names=<None>
-
-# FC SAN Lookup Service (string value)
-#fc_san_lookup_service=cinder.zonemanager.drivers.brocade.brcd_fc_san_lookup_service.BrcdFCSanLookupService
-
-
-[keymgr]
-
-#
-# Options defined in cinder.keymgr
-#
-
-# The full class name of the key manager API class (string
-# value)
-#api_class=cinder.keymgr.conf_key_mgr.ConfKeyManager
-
-
-#
-# Options defined in cinder.keymgr.conf_key_mgr
-#
-
-# Fixed key returned by key manager, specified in hex (string
-# value)
-#fixed_key=<None>
-
-
-#
-# Options defined in cinder.keymgr.key_mgr
-#
-
-# Authentication url for encryption service. (string value)
-#encryption_auth_url=http://localhost:5000/v3
-
-# Url for encryption service. (string value)
-#encryption_api_url=http://localhost:9311/v1
-
-
-[keystone_authtoken]
-
-#
-# Options defined in keystonemiddleware.auth_token
-#
-
-# Complete public Identity API endpoint. (string value)
-#auth_uri=<None>
-
-# API version of the admin Identity API endpoint. (string
-# value)
-#auth_version=<None>
-
-# Do not handle authorization requests within the middleware,
-# but delegate the authorization decision to downstream WSGI
-# components. (boolean value)
-#delay_auth_decision=false
-
-# Request timeout value for communicating with Identity API
-# server. (integer value)
-#http_connect_timeout=<None>
-
-# How many times are we trying to reconnect when communicating
-# with Identity API Server. (integer value)
-#http_request_max_retries=3
-
-# Env key for the swift cache. (string value)
-#cache=<None>
-
-# Required if identity server requires client certificate
-# (string value)
-#certfile=<None>
-
-# Required if identity server requires client certificate
-# (string value)
-#keyfile=<None>
-
-# A PEM encoded Certificate Authority to use when verifying
-# HTTPs connections. Defaults to system CAs. (string value)
-#cafile=<None>
-
-# Verify HTTPS connections. (boolean value)
-#insecure=false
-
-# Directory used to cache files related to PKI tokens. (string
-# value)
-#signing_dir=<None>
-
-# Optionally specify a list of memcached server(s) to use for
-# caching. If left undefined, tokens will instead be cached
-# in-process. (list value)
-# Deprecated group/name - [DEFAULT]/memcache_servers
-#memcached_servers=<None>
-
-# In order to prevent excessive effort spent validating
-# tokens, the middleware caches previously-seen tokens for a
-# configurable duration (in seconds). Set to -1 to disable
-# caching completely. (integer value)
-#token_cache_time=300
-
-# Determines the frequency at which the list of revoked tokens
-# is retrieved from the Identity service (in seconds). A high
-# number of revocation events combined with a low cache
-# duration may significantly reduce performance. (integer
-# value)
-#revocation_cache_time=10
-
-# (Optional) If defined, indicate whether token data should be
-# authenticated or authenticated and encrypted. Acceptable
-# values are MAC or ENCRYPT.  If MAC, token data is
-# authenticated (with HMAC) in the cache. If ENCRYPT, token
-# data is encrypted and authenticated in the cache. If the
-# value is not one of these options or empty, auth_token will
-# raise an exception on initialization. (string value)
-#memcache_security_strategy=<None>
-
-# (Optional, mandatory if memcache_security_strategy is
-# defined) This string is used for key derivation. (string
-# value)
-#memcache_secret_key=<None>
-
-# (Optional) Number of seconds memcached server is considered
-# dead before it is tried again. (integer value)
-#memcache_pool_dead_retry=300
-
-# (Optional) Maximum total number of open connections to every
-# memcached server. (integer value)
-#memcache_pool_maxsize=10
-
-# (Optional) Socket timeout in seconds for communicating with
-# a memcache server. (integer value)
-#memcache_pool_socket_timeout=3
-
-# (Optional) Number of seconds a connection to memcached is
-# held unused in the pool before it is closed. (integer value)
-#memcache_pool_unused_timeout=60
-
-# (Optional) Number of seconds that an operation will wait to
-# get a memcache client connection from the pool. (integer
-# value)
-#memcache_pool_conn_get_timeout=10
-
-# (Optional) Use the advanced (eventlet safe) memcache client
-# pool. The advanced pool will only work under python 2.x.
-# (boolean value)
-#memcache_use_advanced_pool=false
-
-# (Optional) Indicate whether to set the X-Service-Catalog
-# header. If False, middleware will not ask for service
-# catalog on token validation and will not set the X-Service-
-# Catalog header. (boolean value)
-#include_service_catalog=true
-
-# Used to control the use and type of token binding. Can be
-# set to: "disabled" to not check token binding. "permissive"
-# (default) to validate binding information if the bind type
-# is of a form known to the server and ignore it if not.
-# "strict" like "permissive" but if the bind type is unknown
-# the token will be rejected. "required" any form of token
-# binding is needed to be allowed. Finally the name of a
-# binding method that must be present in tokens. (string
-# value)
-#enforce_token_bind=permissive
-
-# If true, the revocation list will be checked for cached
-# tokens. This requires that PKI tokens are configured on the
-# identity server. (boolean value)
-#check_revocations_for_cached=false
-
-# Hash algorithms to use for hashing PKI tokens. This may be a
-# single algorithm or multiple. The algorithms are those
-# supported by Python standard hashlib.new(). The hashes will
-# be tried in the order given, so put the preferred one first
-# for performance. The result of the first hash will be stored
-# in the cache. This will typically be set to multiple values
-# only while migrating from a less secure algorithm to a more
-# secure one. Once all the old tokens are expired this option
-# should be set to a single value for better performance.
-# (list value)
-#hash_algorithms=md5
-
-# Prefix to prepend at the beginning of the path. Deprecated, use
-# identity_uri. (string value)
-#auth_admin_prefix =
-
-# Host providing the admin Identity API endpoint. Deprecated, use
-# identity_uri. (string value)
-#auth_host = 127.0.0.1
-
-# Port of the admin Identity API endpoint. Deprecated, use
-# identity_uri. (integer value)
-#auth_port = 35357
-
-# Protocol of the admin Identity API endpoint (http or https).
-# Deprecated, use identity_uri. (string value)
-auth_protocol=http
-
-# Complete admin Identity API endpoint. This should specify the
-# unversioned root endpoint e.g. https://localhost:35357/ (string
-# value)
-#identity_uri = <None>
-
-# This option is deprecated and may be removed in a future release.
-# Single shared secret with the Keystone configuration used for
-# bootstrapping a Keystone installation, or otherwise bypassing the
-# normal authentication process. This option should not be used, use
-# `admin_user` and `admin_password` instead. (string value)
-#admin_token = <None>
-
-# Service username. (string value)
-#admin_user = <None>
-
-# Service user password. (string value)
-#admin_password = <None>
-
-# Service tenant name. (string value)
-#admin_tenant_name = admin
-
-
-[matchmaker_redis]
-
-#
-# Options defined in oslo.messaging
-#
-
-# Host to locate redis. (string value)
-#host=127.0.0.1
-
-# Use this port to connect to redis host. (integer value)
-#port=6379
-
-# Password for Redis server (optional). (string value)
-#password=<None>
-
-
-[matchmaker_ring]
-
-#
-# Options defined in oslo.messaging
-#
-
-# Matchmaker ring file (JSON). (string value)
-# Deprecated group/name - [DEFAULT]/matchmaker_ringfile
-#ringfile=/etc/oslo/matchmaker_ring.json
-
-
-[oslo_messaging_amqp]
-
-#
-# Options defined in oslo.messaging
-#
-
-# address prefix used when sending to a specific server
-# (string value)
-#server_request_prefix=exclusive
-
-# address prefix used when broadcasting to all servers (string
-# value)
-#broadcast_prefix=broadcast
-
-# address prefix when sending to any server in group (string
-# value)
-#group_request_prefix=unicast
-
-# Name for the AMQP container (string value)
-#container_name=<None>
-
-# Timeout for inactive connections (in seconds) (integer
-# value)
-#idle_timeout=0
-
-# Debug: dump AMQP frames to stdout (boolean value)
-#trace=false
-
-# CA certificate PEM file for verifing server certificate
-# (string value)
-#ssl_ca_file=
-
-# Identifying certificate PEM file to present to clients
-# (string value)
-#ssl_cert_file=
-
-# Private key PEM file used to sign cert_file certificate
-# (string value)
-#ssl_key_file=
-
-# Password for decrypting ssl_key_file (if encrypted) (string
-# value)
-#ssl_key_password=<None>
-
-# Accept clients using either SSL or plain TCP (boolean value)
-#allow_insecure_clients=false
-
-
-[oslo_messaging_qpid]
-
-#
-# Options defined in oslo.messaging
-#
-
-# Use durable queues in AMQP. (boolean value)
-# Deprecated group/name - [DEFAULT]/rabbit_durable_queues
-#amqp_durable_queues=false
-
-# Auto-delete queues in AMQP. (boolean value)
-#amqp_auto_delete=false
-
-# Size of RPC connection pool. (integer value)
-#rpc_conn_pool_size=30
-
-# Qpid broker hostname. (string value)
-#qpid_hostname=localhost
-
-# Qpid broker port. (integer value)
-#qpid_port=5672
-
-# Qpid HA cluster host:port pairs. (list value)
-#qpid_hosts=$qpid_hostname:$qpid_port
-
-# Username for Qpid connection. (string value)
-#qpid_username=
-
-# Password for Qpid connection. (string value)
-#qpid_password=
-
-# Space separated list of SASL mechanisms to use for auth.
-# (string value)
-#qpid_sasl_mechanisms=
-
-# Seconds between connection keepalive heartbeats. (integer
-# value)
-#qpid_heartbeat=60
-
-# Transport to use, either 'tcp' or 'ssl'. (string value)
-#qpid_protocol=tcp
-
-# Whether to disable the Nagle algorithm. (boolean value)
-#qpid_tcp_nodelay=true
-
-# The number of prefetched messages held by receiver. (integer
-# value)
-#qpid_receiver_capacity=1
-
-# The qpid topology version to use.  Version 1 is what was
-# originally used by impl_qpid.  Version 2 includes some
-# backwards-incompatible changes that allow broker federation
-# to work.  Users should update to version 2 when they are
-# able to take everything down, as it requires a clean break.
-# (integer value)
-#qpid_topology_version=1
-
-
-[oslo_messaging_rabbit]
-
-#
-# Options defined in oslo.messaging
-#
-
-# Use durable queues in AMQP. (boolean value)
-# Deprecated group/name - [DEFAULT]/rabbit_durable_queues
-#amqp_durable_queues=false
-
-# Auto-delete queues in AMQP. (boolean value)
-#amqp_auto_delete=false
-
-# Size of RPC connection pool. (integer value)
-#rpc_conn_pool_size=30
-
-# SSL version to use (valid only if SSL enabled). Valid values
-# are TLSv1 and SSLv23. SSLv2, SSLv3, TLSv1_1, and TLSv1_2 may
-# be available on some distributions. (string value)
-#kombu_ssl_version=
-
-# SSL key file (valid only if SSL enabled). (string value)
-#kombu_ssl_keyfile=
-
-# SSL cert file (valid only if SSL enabled). (string value)
-#kombu_ssl_certfile=
-
-# SSL certification authority file (valid only if SSL
-# enabled). (string value)
-#kombu_ssl_ca_certs=
-
-# How long to wait before reconnecting in response to an AMQP
-# consumer cancel notification. (floating point value)
-#kombu_reconnect_delay=1.0
-
-# The RabbitMQ broker address where a single node is used.
-# (string value)
-#rabbit_host=localhost
-
-# The RabbitMQ broker port where a single node is used.
-# (integer value)
-#rabbit_port=5672
-
-# RabbitMQ HA cluster host:port pairs. (list value)
-#rabbit_hosts=$rabbit_host:$rabbit_port
-
-# Connect over SSL for RabbitMQ. (boolean value)
-#rabbit_use_ssl=false
-
-# The RabbitMQ userid. (string value)
-#rabbit_userid=guest
-
-# The RabbitMQ password. (string value)
-#rabbit_password=guest
-
-# The RabbitMQ login method. (string value)
-#rabbit_login_method=AMQPLAIN
-
-# The RabbitMQ virtual host. (string value)
-#rabbit_virtual_host=/
-
-# How frequently to retry connecting with RabbitMQ. (integer
-# value)
-#rabbit_retry_interval=1
-
-# How long to backoff for between retries when connecting to
-# RabbitMQ. (integer value)
-#rabbit_retry_backoff=2
-
-# Maximum number of RabbitMQ connection retries. Default is 0
-# (infinite retry count). (integer value)
-#rabbit_max_retries=0
-
-# Use HA queues in RabbitMQ (x-ha-policy: all). If you change
-# this option, you must wipe the RabbitMQ database. (boolean
-# value)
-#rabbit_ha_queues=false
-
-# Number of seconds after which the Rabbit broker is
-# considered down if heartbeat's keep-alive fails (0 disable
-# the heartbeat). (integer value)
-#heartbeat_timeout_threshold=60
-
-# How often times during the heartbeat_timeout_threshold we
-# check the heartbeat. (integer value)
-#heartbeat_rate=2
-
-# Deprecated, use rpc_backend=kombu+memory or rpc_backend=fake
-# (boolean value)
-#fake_rabbit=false
-
-
-[profiler]
-
-#
-# Options defined in cinder.service
-#
-
-# If False fully disable profiling feature. (boolean value)
-#profiler_enabled=false
-
-# If False doesn't trace SQL requests. (boolean value)
-#trace_sqlalchemy=false
-
-
-# Connection to db:
-sql_connection = sqlite:////var/lib/cinder/cinderdb
+connection = sqlite:////var/lib/cinder/cinder.sqlite
diff -pruN 2:15.0.1-1/debian/cinder-doc.doc-base 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-doc.doc-base
--- 2:15.0.1-1/debian/cinder-doc.doc-base	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-doc.doc-base	1970-01-01 00:00:00.000000000 +0000
@@ -1,9 +0,0 @@
-Document: cinder
-Title: cinder Documentation
-Author: N/A
-Abstract: Sphinx documentation for Cinder
-Section: Programming/Python
-
-Format: HTML
-Index: /usr/share/doc/cinder-doc/html/index.html
-Files: /usr/share/doc/cinder-doc/html/*
diff -pruN 2:15.0.1-1/debian/cinder-scheduler.init.in 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-scheduler.init.in
--- 2:15.0.1-1/debian/cinder-scheduler.init.in	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-scheduler.init.in	2020-03-24 18:47:42.000000000 +0000
@@ -12,7 +12,10 @@
 #                    virtual machine instances
 ### END INIT INFO
 
-# Author: Thomas Goirand <zigo@debian.org>
-DESC="OpenStack Cinder Scheduler (cinder-scheduler)"
+# Author: Julien Danjou <acid@debian.org>, Thomas Goirand <zigo@debian.org>
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC="OpenStack Cinder Scheduler"
 PROJECT_NAME=cinder
 NAME=${PROJECT_NAME}-scheduler
diff -pruN 2:15.0.1-1/debian/cinder-scheduler.install 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-scheduler.install
--- 2:15.0.1-1/debian/cinder-scheduler.install	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-scheduler.install	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-usr/bin/cinder-scheduler
diff -pruN 2:15.0.1-1/debian/cinder-scheduler.manpages 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-scheduler.manpages
--- 2:15.0.1-1/debian/cinder-scheduler.manpages	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-scheduler.manpages	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-debian/man/cinder-scheduler.8
diff -pruN 2:15.0.1-1/debian/cinder_sudoers 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder_sudoers
--- 2:15.0.1-1/debian/cinder_sudoers	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder_sudoers	2020-03-24 18:47:42.000000000 +0000
@@ -0,0 +1,3 @@
+Defaults:cinder !requiretty
+
+cinder ALL = (root) NOPASSWD: /usr/bin/cinder-rootwrap  /etc/cinder/rootwrap.conf *
diff -pruN 2:15.0.1-1/debian/cinder-uwsgi.ini 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-uwsgi.ini
--- 2:15.0.1-1/debian/cinder-uwsgi.ini	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-uwsgi.ini	1970-01-01 00:00:00.000000000 +0000
@@ -1,35 +0,0 @@
-[uwsgi]
-# This is the standard port for Cinder, listening on all available IPs
-http-socket = :8776
-
-wsgi-file = /usr/bin/cinder-wsgi
-
-# Override the default size for headers from the 4k default.
-buffer-size = 65535
-
-# This is running standalone
-master = true
-
-# Threads and processes
-enable-threads = true
-
-processes = 4
-
-# uwsgi recommends this to prevent thundering herd on accept.
-thunder-lock = true
-
-plugins = python3
-
-# This ensures that file descriptors aren't shared between keystone processes.
-lazy-apps = true
-
-paste-logger = true
-
-logto = /var/log/cinder/cinder-api.log
-
-no-orphans = true
-name = cinder
-uid = cinder
-gid = cinder
-chdir = /var/lib/cinder
-die-on-term = true
diff -pruN 2:15.0.1-1/debian/cinder-volume.init.in 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-volume.init.in
--- 2:15.0.1-1/debian/cinder-volume.init.in	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-volume.init.in	2020-03-24 18:47:42.000000000 +0000
@@ -12,7 +12,10 @@
 #                    virtual machine instances
 ### END INIT INFO
 
-# Author: Thomas Goirand <zigo@debian.org>
-DESC="OpenStack Cinder Volume (cinder-volume)"
+# Author: Julien Danjou <acid@debian.org>
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC="OpenStack Cinder Volume"
 PROJECT_NAME=cinder
 NAME=${PROJECT_NAME}-volume
diff -pruN 2:15.0.1-1/debian/cinder-volume.install 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-volume.install
--- 2:15.0.1-1/debian/cinder-volume.install	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-volume.install	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-debian/cinder_tgt.conf etc/tgt/conf.d
-usr/bin/cinder-volume
-usr/bin/cinder-volume-usage-audit
diff -pruN 2:15.0.1-1/debian/cinder-volume.manpages 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-volume.manpages
--- 2:15.0.1-1/debian/cinder-volume.manpages	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-volume.manpages	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-debian/man/cinder-volume.8
diff -pruN 2:15.0.1-1/debian/cinder-volume.postinst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-volume.postinst
--- 2:15.0.1-1/debian/cinder-volume.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-volume.postinst	2020-03-24 18:47:42.000000000 +0000
@@ -0,0 +1,22 @@
+#!/bin/sh -e
+
+if [ "$1" = "configure" ]; then
+    chown cinder:cinder /var/lib/cinder/volumes
+    chmod 0750 /var/lib/cinder/volumes
+    chown root:root /etc/cinder/rootwrap.d/volume.filters
+
+	if which invoke-rc.d >/dev/null 2>&1; then
+		invoke-rc.d tgtd restart > /dev/null 2>&1 || true
+	else
+		/etc/init.d/tgtd restart > /dev/null 2>&1 || true
+	fi
+
+	if which invoke-rc.d >/dev/null 2>&1; then
+		invoke-rc.d cinder-volume restart > /dev/null 2>&1 || true
+	else
+		/etc/init.d/cinder-volume restart > /dev/null 2>&1 || true
+	fi
+
+fi
+
+#DEBHELPER#
diff -pruN 2:15.0.1-1/debian/cinder-volume.postinst.in 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-volume.postinst.in
--- 2:15.0.1-1/debian/cinder-volume.postinst.in	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-volume.postinst.in	1970-01-01 00:00:00.000000000 +0000
@@ -1,21 +0,0 @@
-#!/bin/sh
-
-set -e
-
-#PKGOS-INCLUDE#
-
-if [ "$1" = "configure" ] || [ "$1" = "reconfigure" ] ; then
-	pkgos_var_user_group cinder
-	chmod 0750 /var/lib/cinder/volumes
-	chown root:root /etc/cinder/rootwrap.d/volume.filters
-
-	if which invoke-rc.d >/dev/null 2>&1; then
-		invoke-rc.d tgtd restart > /dev/null 2>&1 || true
-	else
-		/etc/init.d/tgtd restart > /dev/null 2>&1 || true
-	fi
-fi
-
-#DEBHELPER#
-
-exit 0
diff -pruN 2:15.0.1-1/debian/cinder-wsgi.conf 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-wsgi.conf
--- 2:15.0.1-1/debian/cinder-wsgi.conf	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/cinder-wsgi.conf	2020-03-24 18:47:42.000000000 +0000
@@ -0,0 +1,26 @@
+Listen 8776
+LogFormat "%h %l %u %t \"%r\" %>s %b \"%{Referer}i\" \"%{User-agent}i\" %D(us)" cinder_combined
+
+<VirtualHost *:8776>
+    WSGIDaemonProcess cinder-wsgi processes=5 threads=1 user=cinder group=cinder display-name=%{GROUP}
+    WSGIProcessGroup cinder-wsgi
+    WSGIScriptAlias / /usr/bin/cinder-wsgi
+    WSGIApplicationGroup %{GLOBAL}
+    WSGIPassAuthorization On
+    <IfVersion >= 2.4>
+      ErrorLogFormat "%{cu}t %M"
+    </IfVersion>
+
+    ErrorLog /var/log/apache2/cinder_error.log
+    CustomLog /var/log/apache2/cinder.log cinder_combined
+
+    <Directory /usr/bin>
+	<IfVersion >= 2.4>
+            Require all granted
+        </IfVersion>
+        <IfVersion < 2.4>
+            Order allow,deny
+            Allow from all
+        </IfVersion>
+    </Directory>
+</VirtualHost>
diff -pruN 2:15.0.1-1/debian/clean 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/clean
--- 2:15.0.1-1/debian/clean	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/clean	2020-03-24 18:47:42.000000000 +0000
@@ -0,0 +1 @@
+setup.cfg
diff -pruN 2:15.0.1-1/debian/compat 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/compat
--- 2:15.0.1-1/debian/compat	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/compat	2020-03-24 18:47:42.000000000 +0000
@@ -0,0 +1 @@
+10
diff -pruN 2:15.0.1-1/debian/control 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/control
--- 2:15.0.1-1/debian/control	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/control	2020-03-24 18:47:42.000000000 +0000
@@ -1,151 +1,138 @@
 Source: cinder
 Section: net
-Priority: optional
-Maintainer: Debian OpenStack <team+openstack@tracker.debian.org>
-Uploaders:
- Thomas Goirand <zigo@debian.org>,
- Michal Arbet <michal.arbet@ultimum.io>,
+Priority: extra
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Chuck Short <zulcss@ubuntu.com>
 Build-Depends:
- debhelper-compat (= 10),
+ apache2-dev,
+ debhelper (>= 10~),
+ dh-apache2,
  dh-python,
- openstack-pkg-tools (>= 99~),
- po-debconf,
+ openstack-pkg-tools (>= 85ubuntu3~),
  python3-all,
- python3-pbr,
+ python3-pbr (>= 2.0.0),
  python3-setuptools,
- python3-sphinx,
+ python3-sphinx (>= 1.6.3),
+ python3-tabulate,
 Build-Depends-Indep:
- bandit,
- python3-barbicanclient,
- python3-castellan,
- python3-coverage,
- python3-cryptography,
- python3-cursive,
+ python3-barbicanclient (>= 4.5.2),
+ python3-castellan (>= 0.16.0),
+ python3-coverage (>= 4.0),
+ python3-cryptography (>= 2.1),
+ python3-cursive (>= 0.2.1),
  python3-ddt (>= 1.2.1),
- python3-decorator,
- python3-defusedxml,
- python3-doc8,
+ python3-decorator (>= 3.4.0),
+ python3-defusedxml (>= 0.5.0),
+ python3-doc8 (>= 0.6.0),
  python3-eventlet (>= 0.22.0),
- python3-fixtures,
- python3-glanceclient (>= 2.15.0),
- python3-googleapi,
- python3-greenlet,
+ python3-fixtures (>= 3.0.0),
+ python3-glanceclient (>= 1:2.15.0),
+ python3-googleapi (>= 1.4.2),
+ python3-greenlet (>= 0.4.10),
  python3-hacking,
- python3-httplib2,
- python3-iso8601,
- python3-jsonschema,
- python3-keystoneauth1,
- python3-keystoneclient,
- python3-keystonemiddleware,
- python3-lxml,
- python3-migrate,
- python3-mock,
- python3-mysqldb,
- python3-novaclient,
- python3-oauth2client,
- python3-openstackdocstheme,
- python3-os-api-ref,
- python3-os-brick,
- python3-os-win,
- python3-oslo.concurrency,
- python3-oslo.config,
- python3-oslo.context,
- python3-oslo.db,
- python3-oslo.i18n,
- python3-oslo.log,
- python3-oslo.messaging,
- python3-oslo.middleware,
+ python3-httplib2 (>= 0.9.1),
+ python3-iso8601 (>= 0.1.11),
+ python3-jsonschema (>= 2.6.0),
+ python3-keystoneauth1 (>= 3.7.0),
+ python3-keystoneclient (>= 1:3.15.0),
+ python3-keystonemiddleware (>= 4.21.0),
+ python3-lxml (>= 3.4.1),
+ python3-migrate (>= 0.11.0),
+ python3-mock (>= 2.0.0),
+ python3-novaclient (>= 2:9.1.0),
+ python3-oauth2client (>= 1.5.0),
+ python3-openstackdocstheme (>= 1.20.0),
+ python3-os-api-ref (>= 1.4.0),
+ python3-os-brick (>= 2.2.0),
+ python3-os-win (>= 3.0.0),
+ python3-oslo.concurrency (>= 3.26.0),
+ python3-oslo.config (>= 1:5.2.0),
+ python3-oslo.context (>= 1:2.19.2),
+ python3-oslo.db (>= 4.35.0),
+ python3-oslo.i18n (>= 3.15.3),
+ python3-oslo.log (>= 3.36.0),
+ python3-oslo.messaging (>= 6.4.0),
+ python3-oslo.middleware (>= 3.31.0),
  python3-oslo.policy (>= 1.44.1),
  python3-oslo.privsep (>= 1.32.0),
- python3-oslo.reports,
- python3-oslo.rootwrap,
- python3-oslo.serialization,
- python3-oslo.service,
- python3-oslo.upgradecheck,
- python3-oslo.utils,
- python3-oslo.versionedobjects,
- python3-oslo.vmware,
- python3-oslotest,
- python3-osprofiler,
- python3-paramiko,
- python3-paste,
- python3-pastedeploy,
+ python3-oslo.reports (>= 1.18.0),
+ python3-oslo.rootwrap (>= 5.8.0),
+ python3-oslo.serialization (>= 2.18.0),
+ python3-oslo.service (>= 1.24.0),
+ python3-oslo.upgradecheck (>= 0.1.0),
+ python3-oslo.utils (>= 3.34.0),
+ python3-oslo.versionedobjects (>= 1.31.2),
+ python3-oslo.vmware (>= 2.35.0),
+ python3-oslotest (>= 1:3.2.0),
+ python3-osprofiler (>= 1.4.0),
+ python3-paramiko (>= 2.4.0),
+ python3-paste (>= 2.0.2),
+ python3-pastedeploy (>= 1.5.0),
  python3-pep8,
- python3-prettytable,
- python3-psutil,
- python3-psycopg2,
- python3-pymysql,
- python3-pyparsing,
- python3-reno,
- python3-requests,
- python3-retrying,
- python3-routes,
- python3-rtslib-fb,
- python3-six,
- python3-sphinx-feature-classification,
- python3-sphinxcontrib.apidoc,
- python3-sqlalchemy,
- python3-stestr,
- python3-stevedore,
- python3-swiftclient,
- python3-taskflow,
- python3-tempest,
- python3-testresources,
- python3-testscenarios,
- python3-testtools,
- python3-tooz,
- python3-tz,
- python3-webob,
- subunit,
-Standards-Version: 4.4.1
-Vcs-Browser: https://salsa.debian.org/openstack-team/services/cinder
-Vcs-Git: https://salsa.debian.org/openstack-team/services/cinder.git
-Homepage: https://github.com/openstack/cinder
+ python3-prettytable (>= 0.7.1),
+ python3-psutil (>= 3.2.2),
+ python3-psycopg2 (>= 2.7),
+ python3-pycodestyle (>= 2.5.0),
+ python3-pymysql (>= 0.7.6),
+ python3-pyparsing (>= 2.1.0),
+ python3-reno (>= 2.5.0),
+ python3-requests (>= 2.14.2),
+ python3-retrying (>= 1.2.3),
+ python3-routes (>= 2.3.1),
+ python3-rtslib-fb (>= 2.1.65),
+ python3-six (>= 1.10.0),
+ python3-sphinx-feature-classification (>= 0.1.0),
+ python3-sphinxcontrib.apidoc (>= 0.2.0),
+ python3-sqlalchemy (>= 1.0.10),
+ python3-sqlalchemy-utils (>= 0.36.1),
+ python3-stestr (>= 2.2.0),
+ python3-stevedore (>= 1:1.20.0),
+ python3-suds (>= 0.6),
+ python3-swiftclient (>= 1:3.2.0),
+ python3-taskflow (>= 3.2.0),
+ python3-tempest (>= 1:17.1.0),
+ python3-testrepository (>= 0.0.18),
+ python3-testresources (>= 2.0.0),
+ python3-testscenarios (>= 0.4),
+ python3-testtools (>= 2.2.0),
+ python3-tooz (>= 1.58.0),
+ python3-tz (>= 2013.6),
+ python3-webob (>= 1:1.7.1),
+Standards-Version: 4.1.4
+Homepage: https://launchpad.net/cinder
+Vcs-Browser: https://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/cinder
+Vcs-Git: https://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/cinder
+Testsuite: autopkgtest-pkg-python
 
 Package: cinder-api
 Architecture: all
 Depends:
- adduser,
- cinder-common (= ${binary:Version}),
- debconf,
- python3-keystoneclient,
- python3-openstackclient,
- python3-pastescript,
- q-text-as-data,
- thin-provisioning-tools,
- uwsgi-plugin-python3,
+ apache2 | httpd,
+ libapache2-mod-wsgi-py3,
+ python3-cinder (= ${binary:Version}),
  ${misc:Depends},
- ${ostack-lsb-base},
- ${python3:Depends},
-Description: OpenStack block storage system - API server
- Cinder is a block Storage-as-a-Service system for the OpenStack cloud
- computing suite. It re-implements the features of Nova-volume, which it
- directly replaces.
- .
- Cinder uses LVM partitions of your volume servers in order to provide iSCSI
- permanent block storage devices for your virtual machines running on Nova.
- It also has back-end drivers for many hardware and software storage solutions
- like Ceph, NFS, Net-APP, etc.
+Description: Cinder storage service - API server
+ OpenStack is a reliable cloud infrastructure. Its mission is to produce
+ the ubiquitous cloud computing platform that will meet the needs of public
+ and private cloud providers regardless of size, by being simple to implement
+ and massively scalable.
+ .
+ Cinder is the OpenStack Block storage service.
  .
  This package contains the Cinder API server.
 
 Package: cinder-backup
 Architecture: all
 Depends:
- adduser,
- cinder-common (= ${binary:Version}),
+ python3-cinder (= ${binary:Version}),
  ${misc:Depends},
- ${ostack-lsb-base},
- ${python3:Depends},
-Description: OpenStack block storage system - Backup server
- Cinder is a block Storage-as-a-Service system for the OpenStack cloud
- computing suite. It re-implements the features of Nova-volume, which it
- directly replaces.
- .
- Cinder uses LVM partitions of your volume servers in order to provide iSCSI
- permanent block storage devices for your virtual machines running on Nova.
- It also has back-end drivers for many hardware and software storage solutions
- like Ceph, NFS, Net-APP, etc.
+Description: Cinder storage service - Scheduler server
+ OpenStack is a reliable cloud infrastructure. Its mission is to produce
+ the ubiquitous cloud computing platform that will meet the needs of public
+ and private cloud providers regardless of size, by being simple to implement
+ and massively scalable.
+ .
+ Cinder is the OpenStack Block storage service.
  .
  This package contains the Cinder backup service.
 
@@ -153,86 +140,59 @@ Package: cinder-common
 Architecture: all
 Depends:
  adduser,
- dbconfig-common,
- debconf,
- python3-cinder (= ${binary:Version}),
- sqlite3,
  ${misc:Depends},
- ${python3:Depends},
-Description: OpenStack block storage system - common files
- Cinder is a block Storage-as-a-Service system for the OpenStack cloud
- computing suite. It re-implements the features of Nova-volume, which it
- directly replaces.
- .
- Cinder uses LVM partitions of your volume servers in order to provide iSCSI
- permanent block storage devices for your virtual machines running on Nova.
- It also has back-end drivers for many hardware and software storage solutions
- like Ceph, NFS, Net-APP, etc.
+Recommends:
+ ${misc:Recommends},
+Breaks:
+ cinder-api (<< 2:13.0.0~rc1-0ubuntu3~),
+ cinder-backup (<< 2:13.0.0~rc1-0ubuntu3~),
+ cinder-scheduler (<< 2:13.0.0~rc1-0ubuntu3~),
+ cinder-volume (<< 2:13.0.0~rc1-0ubuntu3~),
+Replaces:
+ cinder-api (<< 2:13.0.0~rc1-0ubuntu3~),
+ cinder-backup (<< 2:13.0.0~rc1-0ubuntu3~),
+ cinder-scheduler (<< 2:13.0.0~rc1-0ubuntu3~),
+ cinder-volume (<< 2:13.0.0~rc1-0ubuntu3~),
+Description: Cinder storage service - common files
+ OpenStack is a reliable cloud infrastructure. Its mission is to produce
+ the ubiquitous cloud computing platform that will meet the needs of public
+ and private cloud providers regardless of size, by being simple to implement
+ and massively scalable.
  .
- This package contains common files and configuration that are
- needed by all the daemon packages of Cinder.
-
-Package: cinder-doc
-Architecture: all
-Build-Profiles: <!nodoc>
-Section: doc
-Depends:
- ${misc:Depends},
- ${sphinxdoc:Depends},
-Description: OpenStack block storage system - doc
- Cinder is a block Storage-as-a-Service system for the OpenStack cloud
- computing suite. It re-implements the features of Nova-volume, which it
- directly replaces.
- .
- Cinder uses LVM partitions of your volume servers in order to provide iSCSI
- permanent block storage devices for your virtual machines running on Nova.
- It also has back-end drivers for many hardware and software storage
- solutions
- like Ceph, NFS, Net-APP, etc.
+ Cinder is the OpenStack Block storage service.
  .
- This package contains the documentation.
+ This package contains commons components for Cinder.
 
 Package: cinder-scheduler
 Architecture: all
 Depends:
- cinder-common (= ${binary:Version}),
+ python3-cinder (= ${binary:Version}),
  ${misc:Depends},
- ${ostack-lsb-base},
- ${python3:Depends},
-Description: OpenStack block storage system - Scheduler server
- Cinder is a block Storage-as-a-Service system for the OpenStack cloud
- computing suite. It re-implements the features of Nova-volume, which it
- directly replaces.
- .
- Cinder uses LVM partitions of your volume servers in order to provide iSCSI
- permanent block storage devices for your virtual machines running on Nova.
- It also has back-end drivers for many hardware and software storage solutions
- like Ceph, NFS, Net-APP, etc.
+Description: Cinder storage service - Scheduler server
+ OpenStack is a reliable cloud infrastructure. Its mission is to produce
+ the ubiquitous cloud computing platform that will meet the needs of public
+ and private cloud providers regardless of size, by being simple to implement
+ and massively scalable.
+ .
+ Cinder is the OpenStack Block storage service.
  .
  This package contains the Cinder Scheduler server.
 
 Package: cinder-volume
 Architecture: all
 Depends:
- adduser,
- cinder-common (= ${binary:Version}),
  lvm2,
+ python3-cinder (= ${binary:Version}),
  qemu-utils,
- tgt | open-iscsi,
+ tgt,
  ${misc:Depends},
- ${ostack-lsb-base},
- ${python3:Depends},
-Suggests:
- ceph-common,
-Description: OpenStack block storage system - Volume server
- Cinder is a block Storage-as-a-Service system for the OpenStack cloud
- computing suite. It re-implements the features of Nova-volume, which it
- directly replaces.
- .
- Cinder uses LVM partitions of your volume servers in order to provide iSCSI
- permanent block storage devices for your virtual machines running on Nova.
- It also has back-end drivers for many hardware and software storage solutions
- like Ceph, NFS, Net-APP, etc.
+Description: Cinder storage service - Volume server
+ OpenStack is a reliable cloud infrastructure. Its mission is to produce
+ the ubiquitous cloud computing platform that will meet the needs of public
+ and private cloud providers regardless of size, by being simple to implement
+ and massively scalable.
+ .
+ Cinder is the OpenStack Block storage service.
  .
  This package contains the Cinder Volume server.
 
@@ -240,83 +200,80 @@ Package: python3-cinder
 Section: python
 Architecture: all
 Depends:
- python3-barbicanclient,
- python3-castellan,
- python3-cryptography,
- python3-cursive,
- python3-decorator,
- python3-defusedxml,
+ cinder-common (= ${binary:Version}),
+ python3-barbicanclient (>= 4.5.2),
+ python3-castellan (>= 0.16.0),
+ python3-cryptography (>= 2.1),
+ python3-cursive (>= 0.2.1),
+ python3-decorator (>= 3.4.0),
+ python3-defusedxml (>= 0.5.0),
  python3-eventlet (>= 0.22.0),
- python3-glanceclient (>= 2.15.0),
- python3-googleapi,
- python3-greenlet,
- python3-httplib2,
- python3-iso8601,
- python3-jsonschema,
- python3-keystoneauth1,
- python3-keystoneclient,
- python3-keystonemiddleware,
- python3-lxml,
- python3-migrate,
- python3-mysqldb,
- python3-novaclient,
- python3-oauth2client,
- python3-os-brick,
- python3-os-win,
- python3-oslo.concurrency,
- python3-oslo.config,
- python3-oslo.context,
- python3-oslo.db,
- python3-oslo.i18n,
- python3-oslo.log,
- python3-oslo.messaging,
- python3-oslo.middleware,
+ python3-glanceclient (>= 1:2.15.0),
+ python3-greenlet (>= 0.4.10),
+ python3-httplib2 (>= 0.9.1),
+ python3-iso8601 (>= 0.1.11),
+ python3-jsonschema (>= 2.6.0),
+ python3-keystoneauth1 (>= 3.7.0),
+ python3-keystoneclient (>= 1:3.15.0),
+ python3-keystonemiddleware (>= 4.21.0),
+ python3-lxml (>= 3.4.1),
+ python3-migrate (>= 0.11.0),
+ python3-novaclient (>= 2:9.1.0),
+ python3-os-brick (>= 2.2.0),
+ python3-os-win (>= 3.0.0),
+ python3-oslo.concurrency (>= 3.26.0),
+ python3-oslo.config (>= 1:5.2.0),
+ python3-oslo.context (>= 1:2.19.2),
+ python3-oslo.db (>= 4.35.0),
+ python3-oslo.i18n (>= 3.15.3),
+ python3-oslo.log (>= 3.36.0),
+ python3-oslo.messaging (>= 6.4.0),
+ python3-oslo.middleware (>= 3.31.0),
  python3-oslo.policy (>= 1.44.1),
- python3-oslo.privsep (>= 1.32.1),
- python3-oslo.reports,
- python3-oslo.rootwrap,
- python3-oslo.serialization,
- python3-oslo.service,
- python3-oslo.upgradecheck,
- python3-oslo.utils,
- python3-oslo.versionedobjects,
- python3-oslo.vmware,
- python3-osprofiler,
- python3-paramiko,
- python3-paste,
- python3-pastedeploy,
- python3-pbr,
- python3-prettytable,
- python3-psutil,
- python3-psycopg2,
- python3-pymysql,
- python3-pyparsing,
- python3-requests,
- python3-retrying,
- python3-routes,
- python3-rtslib-fb,
- python3-six,
- python3-sqlalchemy,
- python3-stevedore,
- python3-swiftclient,
- python3-taskflow,
- python3-tooz,
- python3-tz,
- python3-webob,
+ python3-oslo.privsep (>= 1.32.0),
+ python3-oslo.reports (>= 1.18.0),
+ python3-oslo.rootwrap (>= 5.8.0),
+ python3-oslo.serialization (>= 2.18.0),
+ python3-oslo.service (>= 1.24.0),
+ python3-oslo.upgradecheck (>= 0.1.0),
+ python3-oslo.utils (>= 3.34.0),
+ python3-oslo.versionedobjects (>= 1.31.2),
+ python3-oslo.vmware (>= 2.35.0),
+ python3-osprofiler (>= 1.4.0),
+ python3-paramiko (>= 2.4.0),
+ python3-paste (>= 2.0.2),
+ python3-pastedeploy (>= 1.5.0),
+ python3-pbr (>= 2.0.0),
+ python3-prettytable (>= 0.7.1),
+ python3-psutil (>= 3.2.2),
+ python3-pyparsing (>= 2.1.0),
+ python3-requests (>= 2.14.2),
+ python3-retrying (>= 1.2.3),
+ python3-routes (>= 2.3.1),
+ python3-six (>= 1.10.0),
+ python3-sqlalchemy (>= 1.0.10),
+ python3-stevedore (>= 1:1.20.0),
+ python3-suds (>= 0.6),
+ python3-swiftclient (>= 1:3.2.0),
+ python3-taskflow (>= 3.2.0),
+ python3-tooz (>= 1.58.0),
+ python3-tz (>= 2013.6),
+ python3-webob (>= 1:1.7.1),
  ${misc:Depends},
  ${python3:Depends},
-Recommends:
- ceph-common,
- python3-ceph,
+Suggests:
+ python3-googleapi (>= 1.4.2),
  python3-hp3parclient,
-Description: OpenStack block storage system - Python libraries
- Cinder is a block Storage-as-a-Service system for the OpenStack cloud
- computing suite. It re-implements the features of Nova-volume, which it
- directly replaces.
- .
- Cinder uses LVM partitions of your volume servers in order to provide iSCSI
- permanent block storage devices for your virtual machines running on Nova.
- It also has back-end drivers for many hardware and software storage solutions
- like Ceph, NFS, Net-APP, etc.
+ python3-oauth2client (>= 1.5.0),
+ python3-rados,
+ python3-rbd,
+ python3-rtslib-fb (>= 2.1.65),
+Description: Cinder Python 3 libraries
+ OpenStack is a reliable cloud infrastructure. Its mission is to produce
+ the ubiquitous cloud computing platform that will meet the needs of public
+ and private cloud providers regardless of size, by being simple to implement
+ and massively scalable.
+ .
+ Cinder is the OpenStack Block storage service.
  .
- This package contains the Python libraries that are part of Cinder.
+ This package contains the Python 3 library for Cinder.
diff -pruN 2:15.0.1-1/debian/copyright 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/copyright
--- 2:15.0.1-1/debian/copyright	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/copyright	2020-03-24 18:47:42.000000000 +0000
@@ -1,112 +1,13 @@
-Format: https://www.debian.org/doc/packaging-manuals/copyright-format/1.0/
-Upstream-Name: cinder
-Source: https://github.com/openstack/cinder
+Format: http://dep.debian.net/deps/dep5-
+Upstream-Name: nova
+Source: https://code.launchpad.net/nova
 
 Files: *
-Copyright: (c) 2010-2011, US Gov. as represented by the Administrator of NASA
-           (c) 2010-2016, OpenStack Foundation
-           (c) 2012-2013, AT&T Labs, Yun Mao <yunmao@gmail.com>
-           (c) 2015-2016, Hitachi, Erlon Cruz <erlon.cruz@fit-tecnologia.org.br>
-           (c) 2012-2016, Hewlett-Packard Development Company, L.P.
-           (c) 2010-2011, Citrix Systems, Inc.
-           (c) 2012-2016, EMC Corporation.
-           (c) 2011-2016, Intel Corporation
-           (c) 2011-2012, Justin Santa Barbara
-           (c) 2012-2017, IBM Corporation
-           (c) 2013-2017, Dell Inc.
-           (c) 2012-2017, Red Hat, Inc.
-           (c) 2016-2017, Mirantis Inc.
-           (c) 2011-2016, Zadara Storage Inc.
-           (c) 2011-2014, eBay Inc.
-           (c) 2013, Nebula, Inc.
-           (c) 2001-2010, Twisted Matrix Laboratories.
-           (c) 2015, The Kubernetes Authors.
-           (c) 2015, SimpliVity Corp.
-           (c) 2013-2015, Yahoo! Inc.
-           (c) 2016, Synology Inc.
-           (c) 2014-2016, Clinton Knight
-           (c) 2015-2016, Michael Price
-           (c) 2015, Yogesh Kshirsagar
-           (c) 2014-2016, Alex Meade
-           (c) 2014-2015, Navneet Singh
-           (c) 2015, Rushil Chugh
-           (c) 2014, Adrien Vergé <adrien.verge@numergy.com>
-           (c) 2015, Tom Barron
-           (c) 2015, Chelsio Communications Inc.
-           (c) 2014, Andrew Kerr
-           (c) 2016, Mike Rooney
-           (c) 2014, Bob Callaway
-           (c) 2015, Dustin Schoenbrun
-           (c) 2014, Ben Swartzlander
-           (c) 2016, Chuck Fouts
-           (c) 2014-2015, Pure Storage, Inc.
-           (c) 2015, Goutham Pacha Ravi
-           (c) 2016, NEC Corporation
-           (c) 2017, DataCore Software Corp
-           (c) 2013, Zelin.io
-           (c) 2016, QNAP Systems, Inc.
-           (c) 2011, University of Southern California
-           (c) 2015, FUJITSU LIMITED
-           (c) 2013-2017, VMware, Inc.
-           (c) 2017, Inspur Corp.
-           (c) 2015-2016, Industrial Technology Research Institute
-           (c) 2015, Nippon Telegraph and Telephone Corporation
-           (c) 2016, Infinidat Ltd.
-           (c) 2013-2017, Huawei Technologies Co., Ltd.
-           (c) 2017, Veritas Technologies LLC
-           (c) 2017, Datera
-           (c) 2014-2015, Cloudbase Solutions SRL
-           (c) 2015, HGST Inc
-           (c) 2013, Canonical Ltd.
-           (c) 2014, 2016, Oracle
-           (c) 2015, Tintri
-           (c) 2014-2017, StorPool
-           (c) 2016, Seagate Technology or one of its affiliates
-           (c) 2015, Odin
-           (c) 2012-2013, Josh Durgin
-           (c) 2012, NetApp, Inc.
-           (c) 2014, ProphetStor, Inc.
-           (c) 2013-2016, Nexenta Systems, Inc.
-           (c) 2014, Objectif Libre
-           (c) 2014, Cisco Systems Inc.
-           (c) 2016 by Kaminario Technologies, Ltd.
-           (c) 2015, DotHill Systems
-           (c) 2012, Pedro Navarro Perez
-           (c) 2014-2016, Brocade Communications Systems Inc.
-           (c) 2016, Google Inc.
-           (c) 2012, Rackspace Hosting
-           (c) 2014, LINBIT HA Solutions GmbH
-           (c) 2016, Vedams Inc.
-           (c) 2013-2017, NTT corp.
-           (c) 2013-2014, Deutsche Telekom AG
-           (c) 2013, eNovance, Inc.
-           (c) 2016, Stratoscale, Ltd.
-           (c) 2011, Denali Systems, Inc.
-           (c) 2013, The Johns Hopkins University
-           (c) 2014, TrilioData, Inc
-           (c) 2014, Quobyte Inc.
-           (c) 2015-2017, Jose Porrua
-           (c) 2014, Glenn Gobeli
-           (c) 2014, Jeff Applewhite
-           (c) 2015, Dot Hill Systems Corp.
-           (c) 2015, Kevin Fox <kevin@efox.cc>
-           (c) 2015, Parallels IP Holdings GmbH
-           (c) 2011, Ken Pepple
-           (c) 2013, SolidFire Inc
-           (c) 2011, Piston Cloud Computing, Inc.
-           (c) 2005, the Lawrence Journal-World
-           (c) 2017, FiberHome Telecommunication Technologies CO.,LTD
-License: Apache-2
-
-Files: debian/*
-Copyright: (c) 2016-2019, Ondřej Nový <onovy@debian.org>
-           (c) 2012-2018, Thomas Goirand <zigo@debian.org>
-           (c) 2017-2019, Michal Arbet <michal.arbet@ultimum.io>
-           (c) 2017, David Rabel <david.rabel@noresoft.com>
-           (c) 2012, Chuck Short <zulcss@ubuntu.com>
-           (c) 2016, Ondřej Kobližek <koblizeko@gmail.com>
-License: Apache-2
-
+Copyright: 2010 United States Government as represented
+                by the Administrator of the National Aeronautics
+                and Space Administration.
+Copyright: 2010 OpenStack LLC
+Copyright: Others (See individual files for more details)
 License: Apache-2
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
diff -pruN 2:15.0.1-1/debian/debian_control_vars 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/debian_control_vars
--- 2:15.0.1-1/debian/debian_control_vars	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/debian_control_vars	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-ostack-lsb-base= lsb-base  (>= 3.0-6)
diff -pruN 2:15.0.1-1/debian/docs 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/docs
--- 2:15.0.1-1/debian/docs	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/docs	2020-03-24 18:47:42.000000000 +0000
@@ -0,0 +1 @@
+README.rst
diff -pruN 2:15.0.1-1/debian/gbp.conf 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/gbp.conf
--- 2:15.0.1-1/debian/gbp.conf	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/gbp.conf	2020-03-24 18:47:42.000000000 +0000
@@ -0,0 +1,7 @@
+[DEFAULT]
+debian-branch = master
+upstream-tag = %(version)s
+pristine-tar = True
+
+[buildpackage]
+export-dir = ../build-area
diff -pruN 2:15.0.1-1/debian/logging.conf 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/logging.conf
--- 2:15.0.1-1/debian/logging.conf	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/logging.conf	2020-03-24 18:47:42.000000000 +0000
@@ -0,0 +1,76 @@
+[loggers]
+keys = root, cinder
+
+[handlers]
+keys = stderr, stdout, watchedfile, syslog, null
+
+[formatters]
+keys = legacycinder, default
+
+[logger_root]
+level = WARNING
+handlers = null
+
+[logger_cinder]
+level = INFO
+handlers = stderr
+qualname = cinder
+
+[logger_amqplib]
+level = WARNING
+handlers = stderr
+qualname = amqplib
+
+[logger_sqlalchemy]
+level = WARNING
+handlers = stderr
+qualname = sqlalchemy
+# "level = INFO" logs SQL queries.
+# "level = DEBUG" logs SQL queries and results.
+# "level = WARNING" logs neither.  (Recommended for production systems.)
+
+[logger_boto]
+level = WARNING
+handlers = stderr
+qualname = boto
+
+[logger_suds]
+level = INFO
+handlers = stderr
+qualname = suds
+
+[logger_eventletwsgi]
+level = WARNING
+handlers = stderr
+qualname = eventlet.wsgi.server
+
+[handler_stderr]
+class = StreamHandler
+args = (sys.stderr,)
+formatter = legacycinder
+
+[handler_stdout]
+class = StreamHandler
+args = (sys.stdout,)
+formatter = legacycinder
+
+[handler_watchedfile]
+class = handlers.WatchedFileHandler
+args = ('cinder.log',)
+formatter = legacycinder
+
+[handler_syslog]
+class = handlers.SysLogHandler
+args = ('/dev/log', handlers.SysLogHandler.LOG_USER)
+formatter = legacycinder
+
+[handler_null]
+class = cinder.log.NullHandler
+formatter = default
+args = ()
+
+[formatter_legacycinder]
+class = cinder.log.LegacyCinderFormatter
+
+[formatter_default]
+format = %(message)s
diff -pruN 2:15.0.1-1/debian/patches/fix-test-setup-mysql8.patch 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/patches/fix-test-setup-mysql8.patch
--- 2:15.0.1-1/debian/patches/fix-test-setup-mysql8.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/patches/fix-test-setup-mysql8.patch	2020-03-24 18:47:42.000000000 +0000
@@ -0,0 +1,22 @@
+Description: fix tests with mysql8
+ mysql 8 no more supports implicit user creation in GRANT statements.
+ Add explicit CREATE USER statements to work.
+Forwarded: no
+X-Not-Forwarded-Reason: up to the openstack Team
+Author: Christian Ehrhardt <christian.ehrhardt@canonical.com>
+Origin: https://dev.mysql.com/doc/refman/8.0/en/grant.html
+Bug-Ubuntu: https://bugs.launchpad.net/bugs/1845321
+Last-Update: 2019-09-26
+--- a/tools/test-setup.sh
++++ b/tools/test-setup.sh
+@@ -23,8 +23,9 @@ sudo -H mysqladmin -u root password $DB_
+ sudo -H mysql -u root -p$DB_ROOT_PW -h localhost -e "
+     DELETE FROM mysql.user WHERE User='';
+     FLUSH PRIVILEGES;
++    CREATE USER '$DB_USER'@'%' identified by '$DB_PW';
+     GRANT ALL PRIVILEGES ON *.*
+-        TO '$DB_USER'@'%' identified by '$DB_PW' WITH GRANT OPTION;"
++        TO '$DB_USER'@'%' WITH GRANT OPTION;"
+ 
+ # Now create our database.
+ mysql -u $DB_USER -p$DB_PW -h 127.0.0.1 -e "
diff -pruN 2:15.0.1-1/debian/patches/fix-upstream-sheebang.patch 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/patches/fix-upstream-sheebang.patch
--- 2:15.0.1-1/debian/patches/fix-upstream-sheebang.patch	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/patches/fix-upstream-sheebang.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,38 +0,0 @@
-Description: Fix upstream sheebang
- We need Py3, not Py2.
-Author: Thomas Goirand <zigo@debian.org>
-Forwarded: no
-Last-Update: 2018-02-24
-
---- cinder-12.0.0~rc1.orig/cinder/db/sqlalchemy/migrate_repo/manage.py
-+++ cinder-12.0.0~rc1/cinder/db/sqlalchemy/migrate_repo/manage.py
-@@ -1,4 +1,4 @@
--#!/usr/bin/env python
-+#!/usr/bin/env python3
- # Copyright 2013 OpenStack Foundation
- #
- #    Licensed under the Apache License, Version 2.0 (the "License"); you may
---- cinder-12.0.0~rc1.orig/tools/check_exec.py
-+++ cinder-12.0.0~rc1/tools/check_exec.py
-@@ -1,4 +1,4 @@
--#!/usr/bin/python
-+#!/usr/bin/python3
- #
- #    Licensed under the Apache License, Version 2.0 (the "License"); you may
- #    not use this file except in compliance with the License. You may obtain
---- cinder-12.0.0~rc1.orig/tools/config/generate_cinder_opts.py
-+++ cinder-12.0.0~rc1/tools/config/generate_cinder_opts.py
-@@ -1,4 +1,4 @@
--#!/usr/bin/env python
-+#!/usr/bin/env python3
- # Licensed under the Apache License, Version 2.0 (the "License");
- # you may not use this file except in compliance with the License.
- # You may obtain a copy of the License at
---- cinder-12.0.0~rc1.orig/tools/generate_driver_list.py
-+++ cinder-12.0.0~rc1/tools/generate_driver_list.py
-@@ -1,4 +1,4 @@
--#! /usr/bin/env python
-+#! /usr/bin/env python3
- #
- #    Licensed under the Apache License, Version 2.0 (the "License"); you may
- #    not use this file except in compliance with the License. You may obtain
diff -pruN 2:15.0.1-1/debian/patches/install-missing-files.patch 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/patches/install-missing-files.patch
--- 2:15.0.1-1/debian/patches/install-missing-files.patch	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/patches/install-missing-files.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,9 +0,0 @@
-Description: Install missing files
-Author: Thomas Goirand <zigo@debian.org>
-Forwarded: not-needed
-Last-Update: 2016-03-22
-
---- /dev/null	2015-11-25 10:13:06.495404578 +0000
-+++ b/MANIFEST.in	2016-03-22 10:59:45.903008926 +0000
-@@ -0,0 +1 @@
-+recursive-include cinder *
diff -pruN 2:15.0.1-1/debian/patches/py38skip.patch 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/patches/py38skip.patch
--- 2:15.0.1-1/debian/patches/py38skip.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/patches/py38skip.patch	2020-03-24 18:47:42.000000000 +0000
@@ -0,0 +1,49 @@
+Skip failing tests with Python3.8
+LP: https://bugs.launchpad.net/cinder/+bug/1861506
+
+--- a/cinder/tests/unit/test_hacking.py
++++ b/cinder/tests/unit/test_hacking.py
+@@ -14,6 +14,8 @@
+ 
+ import textwrap
+ from unittest import mock
++import sys
++import testtools
+ 
+ import ddt
+ import pycodestyle
+@@ -154,6 +156,7 @@
+     def _assert_has_no_errors(self, code, checker, filename=None):
+         self._assert_has_errors(code, checker, filename=filename)
+ 
++    @testtools.skipIf(sys.version_info >= (3, 8), "Skipping test for Python 3.8")
+     def test_logging_format_args(self):
+         checker = checks.CheckLoggingFormatArgs
+         code = """
+@@ -185,6 +188,7 @@
+         self._assert_has_errors(code, checker,
+                                 expected_errors=[(4, 37, 'C310')])
+ 
++    @testtools.skipIf(sys.version_info >= (3, 8), "Skipping test for Python 3.8")
+     def test_opt_type_registration_args(self):
+         checker = checks.CheckOptRegistrationArgs
+         code = """
+--- a/cinder/tests/unit/volume/drivers/dell_emc/unity/test_client.py
++++ b/cinder/tests/unit/volume/drivers/dell_emc/unity/test_client.py
+@@ -14,6 +14,8 @@
+ # under the License.
+ import unittest
+ from unittest import mock
++import sys
++import testtools
+ 
+ import ddt
+ from oslo_utils import units
+@@ -645,6 +647,7 @@
+         back_snap = self.client.restore_snapshot('snap1')
+         self.assertEqual("internal_snap", back_snap.name)
+ 
++    @testtools.skipIf(sys.version_info >= (3, 8), "Skipping test for Python 3.8")
+     def test_delete_host_wo_lock(self):
+         host = MockResource(name='empty-host')
+         self.client.host_cache['empty-host'] = host
diff -pruN 2:15.0.1-1/debian/patches/series 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/patches/series
--- 2:15.0.1-1/debian/patches/series	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/patches/series	2020-03-24 18:47:42.000000000 +0000
@@ -1,2 +1,2 @@
-install-missing-files.patch
-fix-upstream-sheebang.patch
+fix-test-setup-mysql8.patch
+py38skip.patch
diff -pruN 2:15.0.1-1/debian/po/cs.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/cs.po
--- 2:15.0.1-1/debian/po/cs.po	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/cs.po	1970-01-01 00:00:00.000000000 +0000
@@ -1,33 +0,0 @@
-# Czech PO debconf template translation of nova.
-# Copyright (C) 2013 Michal Simunek <michal.simunek@gmail.com>
-# This file is distributed under the same license as the nova package.
-# Michal Simunek <michal.simunek@gmail.com>, 2013.
-#
-msgid ""
-msgstr ""
-"Project-Id-Version: cinder 2013.1.2-4\n"
-"Report-Msgid-Bugs-To: cinder@packages.debian.org\n"
-"POT-Creation-Date: 2018-03-05 23:08+0000\n"
-"PO-Revision-Date: 2013-08-28 12:31+0200\n"
-"Last-Translator: Michal Simunek <michal.simunek@gmail.com>\n"
-"Language-Team: Czech <debian-l10n-czech@lists.debian.org>\n"
-"Language: cs\n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=utf-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid "Cinder volume group:"
-msgstr "Skupina svazků pro Cinder:"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid ""
-"Please specify the name of the LVM volume group on which Cinder will create "
-"partitions."
-msgstr ""
-"Zadejte prosím název skupiny LVM svazků (vg), na které bude Cinder vytvářet "
-"oddíly."
diff -pruN 2:15.0.1-1/debian/po/da.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/da.po
--- 2:15.0.1-1/debian/po/da.po	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/da.po	1970-01-01 00:00:00.000000000 +0000
@@ -1,33 +0,0 @@
-# Danish translation cinder.
-# Copyright (C) 2016 cinder og nedenstående oversættere.
-# This file is distributed under the same license as the cinder package.
-# Joe Hansen (joedalton2@yahoo.dk), 2013, 2014, 2016.
-#
-msgid ""
-msgstr ""
-"Project-Id-Version: cinder\n"
-"Report-Msgid-Bugs-To: cinder@packages.debian.org\n"
-"POT-Creation-Date: 2018-03-05 23:08+0000\n"
-"PO-Revision-Date: 2016-07-09 12:42+0000\n"
-"Last-Translator: Joe Hansen <joedalton2@yahoo.dk>\n"
-"Language-Team: Danish <debian-l10n-danish@lists.debian.org>\n"
-"Language: da\n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid "Cinder volume group:"
-msgstr "Cinder-diskenhedsgruppe:"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid ""
-"Please specify the name of the LVM volume group on which Cinder will create "
-"partitions."
-msgstr ""
-"Angiv venligst navnet for LVM-diskenhedsgruppen hvor Cinder vil oprette "
-"partitioner."
diff -pruN 2:15.0.1-1/debian/po/de.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/de.po
--- 2:15.0.1-1/debian/po/de.po	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/de.po	1970-01-01 00:00:00.000000000 +0000
@@ -1,34 +0,0 @@
-# German debconf translation of cinder.
-# This file is distributed under the same license as the cinder package.
-# Copyright (C) 2010 United States Government,2010-2011 OpenStack LLC.
-# Copyright (C) of this file 2014 Chris Leick <c.leick@vollbio.de>.
-#
-msgid ""
-msgstr ""
-"Project-Id-Version: cinder 2013.2.1-2\n"
-"Report-Msgid-Bugs-To: cinder@packages.debian.org\n"
-"POT-Creation-Date: 2018-03-05 23:08+0000\n"
-"PO-Revision-Date: 2014-01-23 19:01+0100\n"
-"Last-Translator: Chris Leick <c.leick@vollbio.de>\n"
-"Language-Team: German <debian-l10n-german@lists.debian.org>\n"
-"Language: de\n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid "Cinder volume group:"
-msgstr "Cinder-Datenträgergruppe:"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid ""
-"Please specify the name of the LVM volume group on which Cinder will create "
-"partitions."
-msgstr ""
-"Bitte geben Sie den Namen der LVM-Datenträgergruppe an, auf der Cinder "
-"Partitionen erstellen wird."
-
diff -pruN 2:15.0.1-1/debian/po/es.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/es.po
--- 2:15.0.1-1/debian/po/es.po	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/es.po	1970-01-01 00:00:00.000000000 +0000
@@ -1,55 +0,0 @@
-# cinder po-debconf translation to Spanish
-# Copyright (C) 2013 Software in the Public Interest
-# This file is distributed under the same license as the cinder package.
-#
-# Changes:
-#   - Initial translation
-#       Matías A. Bellone <matiasbellone+debian@gmail.com>, 2013
-#
-# Traductores, si no conocen el formato PO, merece la pena leer la
-# documentación de gettext, especialmente las secciones dedicadas a este
-# formato, por ejemplo ejecutando:
-#       info -n '(gettext)PO Files'
-#       info -n '(gettext)Header Entry'
-#
-# Equipo de traducción al español, por favor lean antes de traducir
-# los siguientes documentos:
-#
-#   - El proyecto de traducción de Debian al español
-#     http://www.debian.org/intl/spanish/coordinacion
-#     especialmente las notas de traducción en
-#     http://www.debian.org/intl/spanish/notas
-#
-#   - La guía de traducción de po's de debconf:
-#     /usr/share/doc/po-debconf/README-trans
-#     o http://www.debian.org/intl/l10n/po-debconf/README-trans
-#
-msgid ""
-msgstr ""
-"Project-Id-Version: cinder\n"
-"Report-Msgid-Bugs-To: cinder@packages.debian.org\n"
-"POT-Creation-Date: 2018-03-05 23:08+0000\n"
-"PO-Revision-Date: 2013-12-08 21:31-0300\n"
-"Last-Translator: Matías Bellone <matiasbellone+debian@gmail.com>\n"
-"Language-Team: Debian l10n Spanish <debian-l10n-spanish@lists.debian.org>\n"
-"Language: es\n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid "Cinder volume group:"
-msgstr "Grupo de volúmenes para Cinder:"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid ""
-"Please specify the name of the LVM volume group on which Cinder will create "
-"partitions."
-msgstr ""
-"Indique el nombre del grupo de volúmenes LVM en el que Cinder creará las "
-"particiones."
-
diff -pruN 2:15.0.1-1/debian/po/fr.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/fr.po
--- 2:15.0.1-1/debian/po/fr.po	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/fr.po	1970-01-01 00:00:00.000000000 +0000
@@ -1,38 +0,0 @@
-# Translation of cinder debconf templates to French.
-# Copyright (C) 2013, 2017, French l10n team <debian-l10n-french@lists.debian.org>
-# This file is distributed under the same license as the CINDER package.
-#
-# Translators:
-# Julien Patriarca <leatherface@debian.org>, 2013.
-# Alban Vidal <alban.vidal@zordhak.fr>, 2017.
-msgid ""
-msgstr ""
-"Project-Id-Version: cinder 2.9.0.0-4\n"
-"Report-Msgid-Bugs-To: cinder@packages.debian.org\n"
-"POT-Creation-Date: 2018-03-05 23:08+0000\n"
-"PO-Revision-Date: 2017-09-04 06:39+0100\n"
-"Last-Translator: Alban Vidal <alban.vidal@zordhak.fr>\n"
-"Language-Team: French <debian-l10n-french@lists.debian.org>\n"
-"Language: fr\n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-"X-Generator: Lokalize 2.0\n"
-"Plural-Forms: nplurals=2; plural=(n > 1);\n"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid "Cinder volume group:"
-msgstr "Groupe de volumes pour Cinder :"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid ""
-"Please specify the name of the LVM volume group on which Cinder will create "
-"partitions."
-msgstr ""
-"Veuillez indiquer le nom du groupe de volumes LVM dans lequel Cinder créera "
-"les partitions."
-
diff -pruN 2:15.0.1-1/debian/po/it.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/it.po
--- 2:15.0.1-1/debian/po/it.po	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/it.po	1970-01-01 00:00:00.000000000 +0000
@@ -1,35 +0,0 @@
-# Italian translation of cinder debconf messages
-# Copyright (C) 2016, cinder package's copyright holder
-# This file is distributed under the same license as the cinder package.
-# Beatrice Torracca <beatricet@libero.it>, 2013, 2014, 2016.
-msgid ""
-msgstr ""
-"Project-Id-Version: cinder\n"
-"Report-Msgid-Bugs-To: cinder@packages.debian.org\n"
-"POT-Creation-Date: 2018-03-05 23:08+0000\n"
-"PO-Revision-Date: 2016-09-30 07:25+0200\n"
-"Last-Translator: Beatrice Torracca <beatricet@libero.it>\n"
-"Language-Team: Italian <debian-l10n-italian@lists.debian.org>\n"
-"Language: it\n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-"Plural-Forms: nplurals=2; plural=(n != 1);\n"
-"X-Generator: Virtaal 0.7.1\n"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid "Cinder volume group:"
-msgstr "Gruppo di volumi Cinder:"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid ""
-"Please specify the name of the LVM volume group on which Cinder will create "
-"partitions."
-msgstr ""
-"Specificare il nome del gruppo di volumi (vg) LVM su cui Cinder creerà le "
-"partizioni."
-
diff -pruN 2:15.0.1-1/debian/po/ja.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/ja.po
--- 2:15.0.1-1/debian/po/ja.po	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/ja.po	1970-01-01 00:00:00.000000000 +0000
@@ -1,37 +0,0 @@
-# SOME DESCRIPTIVE TITLE.
-# Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
-# This file is distributed under the same license as the cinder package.
-# victory <victory.deb@gmail.com>, 2013.
-# Takuma Yamada <tyamada@takumayamada.com>, 2016.
-#
-msgid ""
-msgstr ""
-"Project-Id-Version: cinder\n"
-"Report-Msgid-Bugs-To: cinder@packages.debian.org\n"
-"POT-Creation-Date: 2018-03-05 23:08+0000\n"
-"PO-Revision-Date: 2016-04-07 13:00+0900\n"
-"Last-Translator: Takuma Yamada <tyamada@takumayamada.com>\n"
-"Language-Team: Japanese <debian-japanese@lists.debian.org>\n"
-"Language: ja\n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-"Plural-Forms: nplurals=1; plural=0;\n"
-"X-Generator: Gtranslator 2.91.6\n"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid "Cinder volume group:"
-msgstr "Cinder ボリュームグループ:"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid ""
-"Please specify the name of the LVM volume group on which Cinder will create "
-"partitions."
-msgstr ""
-"Cinder がパーティションを作成する LVM ボリュームグループの名前を指定してくだ"
-"さい。"
-
diff -pruN 2:15.0.1-1/debian/po/nl.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/nl.po
--- 2:15.0.1-1/debian/po/nl.po	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/nl.po	1970-01-01 00:00:00.000000000 +0000
@@ -1,35 +0,0 @@
-# Dutch translation of cinder debconf templates.
-# Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
-# This file is distributed under the same license as the cinder package.
-# Frans Spiesschaert <Frans.Spiesschaert@yucom.be>, 2014, 2016.
-#
-msgid ""
-msgstr ""
-"Project-Id-Version: cinder_2_8.0.0-2\n"
-"Report-Msgid-Bugs-To: cinder@packages.debian.org\n"
-"POT-Creation-Date: 2018-03-05 23:08+0000\n"
-"PO-Revision-Date: 2016-04-19 16:49+0200\n"
-"Last-Translator: Frans Spiesschaert <Frans.Spiesschaert@yucom.be>\n"
-"Language-Team: Debian Dutch l10n Team <debian-l10n-dutch@lists.debian.org>\n"
-"Language: nl\n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-"Plural-Forms: nplurals=2; plural=(n != 1);\n"
-"X-Generator: Gtranslator 2.91.6\n"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid "Cinder volume group:"
-msgstr "Volumegroep voor Cinder:"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid ""
-"Please specify the name of the LVM volume group on which Cinder will create "
-"partitions."
-msgstr ""
-"Geef de naam op van de LVM-volumegroep waarop Cinder partities zal aanmaken."
-
diff -pruN 2:15.0.1-1/debian/po/POTFILES.in 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/POTFILES.in
--- 2:15.0.1-1/debian/po/POTFILES.in	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/POTFILES.in	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-[type: gettext/rfc822deb] cinder-common.templates.in
diff -pruN 2:15.0.1-1/debian/po/pt_BR.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/pt_BR.po
--- 2:15.0.1-1/debian/po/pt_BR.po	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/pt_BR.po	1970-01-01 00:00:00.000000000 +0000
@@ -1,35 +0,0 @@
-# Debconf translations for cinder.
-# Copyright (C) 2016 THE cinder'S COPYRIGHT HOLDER
-# This file is distributed under the same license as the cinder package.
-# Adriano Rafael Gomes <adrianorg@arg.eti.br>, 2016.
-#
-msgid ""
-msgstr ""
-"Project-Id-Version: cinder\n"
-"Report-Msgid-Bugs-To: cinder@packages.debian.org\n"
-"POT-Creation-Date: 2018-03-05 23:08+0000\n"
-"PO-Revision-Date: 2016-04-30 16:27-0300\n"
-"Last-Translator: Adriano Rafael Gomes <adrianorg@arg.eti.br>\n"
-"Language-Team: Brazilian Portuguese <debian-l10n-portuguese@lists.debian."
-"org>\n"
-"Language: pt_BR\n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid "Cinder volume group:"
-msgstr "Grupo de volume do Cinder:"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid ""
-"Please specify the name of the LVM volume group on which Cinder will create "
-"partitions."
-msgstr ""
-"Por favor, especifique o nome do grupo de volume LVM no qual o Cinder criará "
-"partições."
-
diff -pruN 2:15.0.1-1/debian/po/pt.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/pt.po
--- 2:15.0.1-1/debian/po/pt.po	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/pt.po	1970-01-01 00:00:00.000000000 +0000
@@ -1,34 +0,0 @@
-# cinder debconf portuguese messages
-# Copyright (C) 2013 THE CINDER COPYRIGHT HOLDER
-# This file is distributed under the same license as the cinder package.
-# Pedro Ribeiro <p.m42.ribeiro@gmail.com>, 2013-2014, 2017
-#
-msgid ""
-msgstr ""
-"Project-Id-Version: cinder_2:9.0.0-4\n"
-"Report-Msgid-Bugs-To: cinder@packages.debian.org\n"
-"POT-Creation-Date: 2018-03-05 23:08+0000\n"
-"PO-Revision-Date: 2017-09-11 10:07+0100\n"
-"Last-Translator: Pedro Ribeiro <p.m42.ribeiro@gmail.com>\n"
-"Language-Team: Portuguese <traduz@debianpt.org>\n"
-"Language: pt\n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid "Cinder volume group:"
-msgstr "Grupo de volume do Cinder:"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid ""
-"Please specify the name of the LVM volume group on which Cinder will create "
-"partitions."
-msgstr ""
-"Indique por favor o nome do grupo de volume LVM no qual o Cinder irá criar "
-"partições."
-
diff -pruN 2:15.0.1-1/debian/po/ru.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/ru.po
--- 2:15.0.1-1/debian/po/ru.po	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/ru.po	1970-01-01 00:00:00.000000000 +0000
@@ -1,35 +0,0 @@
-# Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
-# This file is distributed under the same license as the cinder package.
-#
-# Yuri Kozlov <yuray@komyakino.ru>, 2013.
-msgid ""
-msgstr ""
-"Project-Id-Version: cinder 2013.2-1\n"
-"Report-Msgid-Bugs-To: cinder@packages.debian.org\n"
-"POT-Creation-Date: 2018-03-05 23:08+0000\n"
-"PO-Revision-Date: 2013-11-17 08:49+0400\n"
-"Last-Translator: Yuri Kozlov <yuray@komyakino.ru>\n"
-"Language-Team: Russian <debian-l10n-russian@lists.debian.org>\n"
-"Language: ru\n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-"Plural-Forms: nplurals=3; plural=(n%10==1 && n%100!=11 ? 0 : n%10>=2 && n"
-"%10<=4 && (n%100<10 || n%100>=20) ? 1 : 2);\n"
-"X-Generator: Lokalize 1.4\n"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid "Cinder volume group:"
-msgstr "Группа томов Cinder:"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid ""
-"Please specify the name of the LVM volume group on which Cinder will create "
-"partitions."
-msgstr ""
-"Укажите имя группы томов LVM, в которой Cinder будет создавать разделы."
-
diff -pruN 2:15.0.1-1/debian/po/sv.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/sv.po
--- 2:15.0.1-1/debian/po/sv.po	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/sv.po	1970-01-01 00:00:00.000000000 +0000
@@ -1,38 +0,0 @@
-# Translation of cinder debconf template to Swedish
-# Copyright (C) 2014 Martin Bagge <brother@bsnet.se>
-# This file is distributed under the same license as the cinder package.
-#
-# Martin Bagge <brother@bsnet.se>, 2014
-msgid ""
-msgstr ""
-"Project-Id-Version: cinder\n"
-"Report-Msgid-Bugs-To: cinder@packages.debian.org\n"
-"POT-Creation-Date: 2018-03-05 23:08+0000\n"
-"PO-Revision-Date: 2014-01-08 16:52+0100\n"
-"Last-Translator: Martin Bagge / brother <brother@bsnet.se>\n"
-"Language-Team: Swedish <debian-l10n-swedish@lists.debian.org>\n"
-"Language: Swedish\n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-"X-Generator: Poedit 1.5.4\n"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid "Cinder volume group:"
-msgstr "Volymgrupp för Cinder:"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-#, fuzzy
-#| msgid ""
-#| "Please specify the name of the LVM volume group (vg) on which Cinder will "
-#| "create partitions."
-msgid ""
-"Please specify the name of the LVM volume group on which Cinder will create "
-"partitions."
-msgstr ""
-"Ange namnet för LVM-volym-grupp (vg) där Cinder ska skapa sina partitioner."
-
diff -pruN 2:15.0.1-1/debian/po/templates.pot 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/templates.pot
--- 2:15.0.1-1/debian/po/templates.pot	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/po/templates.pot	1970-01-01 00:00:00.000000000 +0000
@@ -1,32 +0,0 @@
-# SOME DESCRIPTIVE TITLE.
-# Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
-# This file is distributed under the same license as the cinder package.
-# FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.
-#
-#, fuzzy
-msgid ""
-msgstr ""
-"Project-Id-Version: cinder\n"
-"Report-Msgid-Bugs-To: cinder@packages.debian.org\n"
-"POT-Creation-Date: 2018-03-05 23:08+0000\n"
-"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
-"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
-"Language-Team: LANGUAGE <LL@li.org>\n"
-"Language: \n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=CHARSET\n"
-"Content-Transfer-Encoding: 8bit\n"
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid "Cinder volume group:"
-msgstr ""
-
-#. Type: string
-#. Description
-#: ../cinder-common.templates.in:2001
-msgid ""
-"Please specify the name of the LVM volume group on which Cinder will create "
-"partitions."
-msgstr ""
diff -pruN 2:15.0.1-1/debian/py3dist-overrides 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/py3dist-overrides
--- 2:15.0.1-1/debian/py3dist-overrides	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/py3dist-overrides	2020-03-24 18:47:42.000000000 +0000
@@ -0,0 +1,4 @@
+rtslib-fb
+suds-jurko
+oauth2client
+google-api-python-client
diff -pruN 2:15.0.1-1/debian/pydist-overrides 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/pydist-overrides
--- 2:15.0.1-1/debian/pydist-overrides	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/pydist-overrides	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-babel
diff -pruN 2:15.0.1-1/debian/python3-cinder.install 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/python3-cinder.install
--- 2:15.0.1-1/debian/python3-cinder.install	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/python3-cinder.install	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-usr/lib/python*/dist-packages/*
diff -pruN 2:15.0.1-1/debian/README.Debian 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/README.Debian
--- 2:15.0.1-1/debian/README.Debian	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/README.Debian	1970-01-01 00:00:00.000000000 +0000
@@ -1,10 +0,0 @@
-Migration from nova-volumes to cinder-volumes:
-
-1. upgrade your nova install to folsom
-2. upgrade your nova database using nova-manage db sync
-3. install the folsom version of cinder
-4. create a cinder database using cinder-manage db sync
-5. copy data from nova database using cinder-manage migrate import_db --src=$NOVA_SQL_CONN --dest=$CINDER_SQL_CONN
-6. disable the nova-volume-api in enabled apis in /etc/nova/nova.conf sed -i "s/osapi_volume,// /etc/nova/nova.conf"
-7. restart nova-api
-8. start cinder-api
diff -pruN 2:15.0.1-1/debian/README.source 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/README.source
--- 2:15.0.1-1/debian/README.source	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/README.source	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-The package is +dfsg1 because of the removal of non-free minified
-bootstrap 3.x .js and .css in the api-ref folder.
diff -pruN 2:15.0.1-1/debian/rules 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/rules
--- 2:15.0.1-1/debian/rules	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/rules	2020-03-24 18:47:42.000000000 +0000
@@ -1,113 +1,40 @@
 #!/usr/bin/make -f
 
-include /usr/share/openstack-pkg-tools/pkgos.make
-
-%:
-	dh $@ --buildsystem=python_distutils --with python3,systemd,sphinxdoc
+# Uncomment this to turn on verbose mode.
+#export DH_VERBOSE=1
 
-override_dh_clean:
-	dh_clean
-	rm -f debian/cinder-common.config debian/cinder-common.postinst debian/cinder-api.config debian/cinder-api.postinst debian/cinder-volume.postinst debian/cinder-common.postrm
-	rm -rf debian/*.upstart debian/*.service debian/*.templates
-	if [ -e debian/po-backup ] ; then \
-		rm -rf debian/po ; \
-		mv debian/po-backup debian/po ; \
-	fi
-	rm -rf build
-	find . -name '*.pyc' -delete
-	rm -rf .stestr
-	rm -rf cinder.egg-info
-	rm -f AUTHORS ChangeLog
-
-override_dh_auto_clean:
-	echo "Do nothing..."
+DEBVERS ?= $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p')
+VERSION ?= $(shell echo '$(DEBVERS)' | sed -e 's/^[[:digit:]]*://' -e 's/[-].*//' -e 's/[+].*//' -e 's/~git.*//g' -e 's/~/./g')
+export PBR_VERSION=$(VERSION)
 
-override_dh_auto_install:
-	echo "Do nothing..."
-
-override_dh_auto_test:
-	echo "Do nothing..."
-
-override_dh_auto_build:
-	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func cinder-common.config
-	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func cinder-common.postinst
-	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func cinder-api.config
-	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func cinder-api.postinst
-	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func cinder-volume.postinst
-	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_postrm cinder-common.postrm
-	cp -auxf debian/po debian/po-backup
-	pkgos-merge-templates cinder-api cinder endpoint
-	pkgos-merge-templates cinder-common cinder db rabbit ksat
+include /usr/share/openstack-pkg-tools/pkgos.make
 
-override_dh_install:
-	python3 setup.py install --install-layout=deb --root $(CURDIR)/debian/tmp
-	rm -rf $(CURDIR)/debian/tmp/usr/etc
+%:
+	dh $@  --with python3,systemd,apache2 --buildsystem=pybuild
 
 ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
-	for i in $(PYTHON3S) ; do \
-		PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3/dist-packages PYTHON=python$$i stestr run  | subunit2pyunit ; \
-	done
+override_dh_auto_test:
+	pkgos-dh_auto_test --no-py2
 endif
 
-	mkdir -p $(CURDIR)/debian/cinder-common/usr/share/cinder-common
-	PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3/dist-packages oslo-config-generator \
-		--output-file $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf \
-		--wrap-width 140 \
-		--namespace castellan.config \
-		--namespace cinder \
-		--namespace keystonemiddleware.auth_token \
-		--namespace osprofiler \
-		--namespace oslo.config \
-		--namespace oslo.concurrency \
-		--namespace oslo.db \
-		--namespace oslo.log \
-		--namespace oslo.messaging \
-		--namespace oslo.middleware \
-		--namespace oslo.policy \
-		--namespace oslo.reports \
-		--namespace oslo.service.periodic_task \
-		--namespace oslo.service.service \
-		--namespace oslo.service.sslutils \
-		--namespace oslo.service.wsgi \
-		--namespace oslo.versionedobjects
-	pkgos-readd-keystone-authtoken-missing-options $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf keystone_authtoken cinder
-
-	PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3/dist-packages oslopolicy-sample-generator \
-		--output-file $(CURDIR)/debian/cinder-common/usr/share/cinder-common/policy.json \
-		--format json \
-		--namespace cinder
-
-	dh_install
-	dh_missing --fail-missing -Xbin/cinder-all
-	install -D -m 0440 debian/cinder-common.sudoers $(CURDIR)/debian/cinder-common/etc/sudoers.d/cinder-common
-
-	pkgos-fix-config-default $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf DEFAULT auth_strategy keystone
-
-	# Set LVM as default backend
-	pkgos-fix-config-default $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf DEFAULT enabled_backends lvm
-	echo "[lvm]" 				>> $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf
-	echo "volume_driver = cinder.volume.drivers.lvm.LVMVolumeDriver" >> $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf
-	echo "volume_group = pkgosvg0" 		>> $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf
-	echo "iscsi_protocol = iscsi" 		>> $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf
-	echo "iscsi_helper = tgtadm" 		>> $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf
-
-	# Set a default value for lock_path & state_path
-	pkgos-fix-config-default $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf oslo_concurrency lock_path /var/lock/cinder
-
-	# Fix the missing sql_connection directive
-	pkgos-fix-config-default $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf database sqlite:////var/lib/cinder/cinderdb
+override_dh_auto_install:
+	pkgos-dh_auto_install --no-py2
+	rm -rf $(CURDIR)/debian/python*-cinder/usr/etc
 
-	install -D -m 0644 $(CURDIR)/etc/cinder/logging_sample.conf $(CURDIR)/debian/cinder-common/usr/share/cinder-common/logging.conf
+override_dh_install:
+	dh_install --fail-missing -Xbin/cinder-all -Xusr/bin/cinder-api
 
 override_dh_fixperms:
 	dh_fixperms -Xcinder_tgt.conf
-	chmod 0440 $(CURDIR)/debian/cinder-common/etc/sudoers.d/cinder-common
 
-override_dh_sphinxdoc:
-ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
-	PYTHONPATH=$(CURDIR)/debian/python3-cinder/usr/lib/python3/dist-packages PYTHON=python3 python3 -m sphinx -b html doc/source $(CURDIR)/debian/cinder-doc/usr/share/doc/cinder-doc/html
-	dh_sphinxdoc
-endif
+override_dh_clean:
+	# temporary workaround for d2to1 wonkyness
+	dh_clean -Xsetup.cfg
+	rm -f debian/*.init debian/*.service debian/*.upstart
+
+override_dh_auto_clean:
+	dh_auto_clean
+	rm -rf .eggs .testrepository
 
 override_dh_python3:
 	dh_python3 --shebang=/usr/bin/python3
diff -pruN 2:15.0.1-1/debian/source/options 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/source/options
--- 2:15.0.1-1/debian/source/options	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/source/options	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-extend-diff-ignore = "^[.]gitreview$"
diff -pruN 2:15.0.1-1/debian/tests/cinder-daemons 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/tests/cinder-daemons
--- 2:15.0.1-1/debian/tests/cinder-daemons	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/tests/cinder-daemons	2020-03-24 18:47:42.000000000 +0000
@@ -0,0 +1,46 @@
+#!/bin/bash
+#-----------------------
+# Testing cinder-daemons
+#-----------------------
+set -e
+DAEMONS=('apache2' 'cinder-scheduler')
+failure=false
+
+mysql -u root << EOF
+CREATE DATABASE cinder;
+CREATE USER 'cinder'@'localhost' IDENTIFIED BY 'changeme';
+GRANT ALL PRIVILEGES ON cinder.* TO 'cinder'@'localhost';
+CREATE USER 'cinder'@'%' IDENTIFIED BY 'changeme';
+GRANT ALL PRIVILEGES ON cinder.* TO 'cinder'@'%';
+EOF
+
+sed -i -e 's!connection = sqlite.*cinder.sqlite!connection = mysql+pymysql://cinder:changeme@localhost/cinder!g' /etc/cinder/cinder.conf
+
+su -s /bin/sh -c 'cinder-manage db sync' cinder
+
+for daemon in "${DAEMONS[@]}"; do
+    systemctl restart $daemon
+done
+
+for daemon in "${DAEMONS[@]}"; do
+    TIMEOUT=50
+    while [ "$TIMEOUT" -gt 0 ]; do
+        if pidof -x $daemon > /dev/null; then
+            echo "OK"
+            break
+        fi
+        TIMEOUT=$((TIMEOUT - 1))
+        sleep 0.1
+    done
+
+    if [ "$TIMEOUT" -le 0 ]; then
+        echo "ERROR: ${daemon} IS NOT RUNNING"
+        failure=true
+    else
+        echo "${daemon} IS RUNNING"
+    fi
+done
+
+if [ "$failure" = true ]; then
+    exit 1
+fi
diff -pruN 2:15.0.1-1/debian/tests/cinder-volume 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/tests/cinder-volume
--- 2:15.0.1-1/debian/tests/cinder-volume	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/tests/cinder-volume	2020-03-24 18:47:42.000000000 +0000
@@ -0,0 +1,37 @@
+#!/bin/bash
+#----------------------
+# Testing cinder-volume
+#----------------------
+set -e
+apt-get install -y cinder-volume cinder-backup 2>&1 > /dev/null
+DAEMONS=('cinder-volume' 'cinder-backup')
+failure=false
+
+for daemon in "${DAEMONS[@]}"; do
+    systemctl restart $daemon
+done
+
+for daemon in "${DAEMONS[@]}"; do
+    TIMEOUT=50
+    while [ "$TIMEOUT" -gt 0 ]; do
+        if pidof -x $daemon > /dev/null; then
+            echo "OK"
+            break
+        fi
+        TIMEOUT=$((TIMEOUT - 1))
+        sleep 0.1
+    done
+
+    if [ "$TIMEOUT" -le 0 ]; then
+        echo "ERROR: ${daemon} IS NOT RUNNING"
+        failure=true
+    else
+        echo "${daemon} IS RUNNING"
+    fi
+done
+
+apt-get remove -y cinder-volume cinder-backup 2>&1 > /dev/null
+
+if [ "$failure" = true ]; then
+    exit 1
+fi
diff -pruN 2:15.0.1-1/debian/tests/control 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/tests/control
--- 2:15.0.1-1/debian/tests/control	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/tests/control	2020-03-24 18:47:42.000000000 +0000
@@ -0,0 +1,7 @@
+Tests: cinder-daemons cinder-volume
+Depends:
+ cinder-api,
+ cinder-scheduler,
+ lvm2,
+ mysql-server,
+Restrictions: needs-root
diff -pruN 2:15.0.1-1/debian/watch 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/watch
--- 2:15.0.1-1/debian/watch	2020-03-26 14:11:21.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/debian/watch	2020-03-24 18:47:42.000000000 +0000
@@ -1,3 +1,3 @@
 version=3
-opts="uversionmangle=s/\.(b|rc)/~$1/,dversionmangle=s/\+dfsg\d+$//" \
-https://github.com/openstack/cinder/tags .*/(\d[\d\.]+)\.tar\.gz
+opts="uversionmangle=s/\.([a-zA-Z])/~$1/;s/%7E/~/;s/\.0b/~b/;s/\.0rc/~rc/" \
+ https://tarballs.openstack.org/cinder/ cinder-(15\.\d.*)\.tar\.gz
diff -pruN 2:15.0.1-1/doc/requirements.txt 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/requirements.txt
--- 2:15.0.1-1/doc/requirements.txt	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/requirements.txt	2020-03-24 18:46:31.000000000 +0000
@@ -3,8 +3,7 @@
 # process, which may cause wedges in the gate later.
 openstackdocstheme>=1.20.0 # Apache-2.0
 reno>=2.5.0 # Apache-2.0
-sphinx!=1.6.6,!=1.6.7,>=1.6.3,<2.0.0;python_version=='2.7'  # BSD
-sphinx!=1.6.6,!=1.6.7,!=2.1.0,>=1.6.3;python_version>='3.4'  # BSD
+sphinx!=1.6.6,!=1.6.7,!=2.1.0,>=1.6.3  # BSD
 os-api-ref>=1.4.0 # Apache-2.0
 sphinxcontrib-apidoc>=0.2.0  # BSD
 sphinx-feature-classification>=0.1.0 # Apache 2.0
diff -pruN 2:15.0.1-1/doc/source/admin/blockstorage-multi-backend.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/admin/blockstorage-multi-backend.rst
--- 2:15.0.1-1/doc/source/admin/blockstorage-multi-backend.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/admin/blockstorage-multi-backend.rst	2020-03-24 18:46:31.000000000 +0000
@@ -100,7 +100,7 @@ Configure shared volume driver backends
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 When configuring multiple volume backends, common configuration
-parameters can be shared using the `[backend_default]` section. As
+parameters can be shared using the `[backend_defaults]` section. As
 an example:
 
 .. code-block:: ini
@@ -108,7 +108,7 @@ an example:
    [DEFAULT]
    enabled_backends=backend1,backend2,backend3
 
-   [backend_default]
+   [backend_defaults]
    image_volume_cache_enabled = True
    volume_clear = none
    target_helper = tgtadm
@@ -125,15 +125,15 @@ an example:
    volume_group = cinder-volume-3
 
 In this configuration, ``backend2`` and ``backend3`` have the same
-``image_volume_cache_enabled`` as it is defined in the ``backend_default``
+``image_volume_cache_enabled`` as it is defined in the ``backend_defaults``
 section. In other words, ``backend2`` and ``backend3`` have enabled
 the image cache features. ``image_volume_cache_enabled`` in ``backend1``
 is False, that means any overwritten configuration in a volume backend
-will ignore the original value in ``backend_default``.
+will ignore the original value in ``backend_defaults``.
 
 .. note::
 
-   The ``backend_default`` section should be configured according to
+   The ``backend_defaults`` section should be configured according to
    your cloud environment or your backend driver information.
 
 Configure Block Storage scheduler multi back end
diff -pruN 2:15.0.1-1/doc/source/admin/blockstorage-troubleshoot.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/admin/blockstorage-troubleshoot.rst
--- 2:15.0.1-1/doc/source/admin/blockstorage-troubleshoot.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/admin/blockstorage-troubleshoot.rst	2020-03-24 18:46:31.000000000 +0000
@@ -10,7 +10,6 @@ Storage installation.
 
    ts-cinder-config.rst
    ts-multipath-warn.rst
-   ts-eql-volume-size.rst
    ts-HTTP-bad-req-in-cinder-vol-log.rst
    ts-duplicate-3par-host.rst
    ts-failed-attach-vol-after-detach.rst
diff -pruN 2:15.0.1-1/doc/source/admin/ts-eql-volume-size.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/admin/ts-eql-volume-size.rst
--- 2:15.0.1-1/doc/source/admin/ts-eql-volume-size.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/admin/ts-eql-volume-size.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,223 +0,0 @@
-========================================================================
-Addressing discrepancies in reported volume sizes for EqualLogic storage
-========================================================================
-
-Problem
-~~~~~~~
-
-There is a discrepancy between both the actual volume size in EqualLogic
-(EQL) storage and the image size in the Image service, with what is
-reported to OpenStack database. This could lead to confusion
-if a user is creating volumes from an image that was uploaded from an EQL
-volume (through the Image service). The image size is slightly larger
-than the target volume size; this is because EQL size reporting accounts
-for additional storage used by EQL for internal volume metadata.
-
-To reproduce the issue follow the steps in the following procedure.
-
-This procedure assumes that the EQL array is provisioned, and that
-appropriate configuration settings have been included in
-``/etc/cinder/cinder.conf`` to connect to the EQL array.
-
-Create a new volume. Note the ID and size of the volume. In the
-following example, the ID and size are
-``74cf9c04-4543-47ae-a937-a9b7c6c921e7`` and ``1``, respectively:
-
-.. code-block:: console
-
-   $ openstack volume create volume1 --size 1
-
-   +---------------------+--------------------------------------+
-   | Field               | Value                                |
-   +---------------------+--------------------------------------+
-   | attachments         | []                                   |
-   | availability_zone   | nova                                 |
-   | bootable            | false                                |
-   | consistencygroup_id | None                                 |
-   | created_at          | 2016-12-06T11:33:30.957318           |
-   | description         | None                                 |
-   | encrypted           | False                                |
-   | id                  | 74cf9c04-4543-47ae-a937-a9b7c6c921e7 |
-   | migration_status    | None                                 |
-   | multiattach         | False                                |
-   | name                | volume1                              |
-   | properties          |                                      |
-   | replication_status  | disabled                             |
-   | size                | 1                                    |
-   | snapshot_id         | None                                 |
-   | source_volid        | None                                 |
-   | status              | creating                             |
-   | type                | iscsi                                |
-   | updated_at          | None                                 |
-   | user_id             | c36cec73b0e44876a4478b1e6cd749bb     |
-   +---------------------+--------------------------------------+
-
-Verify the volume size on the EQL array by using its command-line
-interface.
-
-The actual size (``VolReserve``) is 1.01GB. The EQL Group Manager
-should also report a volume size of 1.01GB:
-
-.. code-block:: console
-
-   eql> volume select volume-74cf9c04-4543-47ae-a937-a9b7c6c921e7
-   eql (volume_volume-74cf9c04-4543-47ae-a937-a9b7c6c921e7)> show
-   _______________________________ Volume Information ________________________________
-   Name: volume-74cf9c04-4543-47ae-a937-a9b7c6c921e7
-   Size: 1GB
-   VolReserve: 1.01GB
-   VolReservelnUse: 0MB
-   ReplReservelnUse: 0MB
-   iSCSI Alias: volume-74cf9c04-4543-47ae-a937-a9b7c6c921e7
-   iSCSI Name: iqn.2001-05.com.equallogic:0-8a0906-19f91850c-067000000b4532cl-volume-74cf9c04-4543-47ae-a937-a9b7c6c921e7
-   ActualMembers: 1
-   Snap-Warn: 10%
-   Snap-Depletion: delete-oldest
-   Description:
-   Snap-Reserve: 100%
-   Snap-Reserve-Avail: 100% (1.01GB)
-   Permission: read-write
-   DesiredStatus: online
-   Status: online
-   Connections: O
-   Snapshots: O
-   Bind:
-   Type: not-replicated
-   ReplicationReserveSpace: 0MB
-
-Create a new image from this volume:
-
-.. code-block:: console
-
-   $ openstack image create --volume volume1 \
-     --disk-format raw --container-format bare image_from_volume1
-
-   +---------------------+--------------------------------------+
-   | Field               | Value                                |
-   +---------------------+--------------------------------------+
-   | container_format    | bare                                 |
-   | disk_format         | raw                                  |
-   | display_description | None                                 |
-   | id                  | 850fd393-a968-4259-9c65-6b495cba5209 |
-   | image_id            | 3020a21d-ba37-4495-8899-07fc201161b9 |
-   | image_name          | image_from_volume1                   |
-   | is_public           | False                                |
-   | protected           | False                                |
-   | size                | 1                                    |
-   | status              | uploading                            |
-   | updated_at          | 2016-12-05T12:43:56.000000           |
-   | volume_type         | iscsi                                |
-   +---------------------+--------------------------------------+
-
-When you uploaded the volume in the previous step, the Image service
-reported the volume's size as ``1`` (GB). However, when using
-:command:`openstack image show` to show the image, the displayed size is
-1085276160 bytes, or roughly 1.01 GB:
-
-+------------------+--------------------------------------+
-| Property         | Value                                |
-+------------------+--------------------------------------+
-| checksum         | cd573cfaace07e7949bc0c46028904ff     |
-| container_format | bare                                 |
-| created_at       | 2016-12-06T11:39:06Z                 |
-| disk_format      | raw                                  |
-| id               | 3020a21d-ba37-4495-8899-07fc201161b9 |
-| min_disk         | 0                                    |
-| min_ram          | 0                                    |
-| name             | image_from_volume1                   |
-| owner            | 5669caad86a04256994cdf755df4d3c1     |
-| protected        | False                                |
-| size             | 1085276160                           |
-| status           | active                               |
-| tags             | []                                   |
-| updated_at       | 2016-12-06T11:39:24Z                 |
-| virtual_size     | None                                 |
-| visibility       | private                              |
-+------------------+--------------------------------------+
-
-
-
-Create a new volume using the previous image (``image_id 3020a21d-ba37-4495
--8899-07fc201161b9`` in this example) as
-the source. Set the target volume size to 1GB; this is the size
-reported by the ``cinder`` tool when you uploaded the volume to the
-Image service:
-
-.. code-block:: console
-
-   $ openstack volume create volume2 --size 1 --image 3020a21d-ba37-4495-8899-07fc201161b9
-   ERROR: Invalid input received: Size of specified image 2 is larger
-   than volume size 1. (HTTP 400) (Request-ID: req-4b9369c0-dec5-4e16-a114-c0cdl6bSd210)
-
-The attempt to create a new volume based on the size reported by the
-``cinder`` tool will then fail.
-
-Solution
-~~~~~~~~
-
-To work around this problem, increase the target size of the new image
-to the next whole number. In the problem example, you created a 1GB
-volume to be used as volume-backed image, so a new volume using this
-volume-backed image should use a size of 2GB:
-
-.. code-block:: console
-
-   $ openstack volume create volume2 --size 1 --image 3020a21d-ba37-4495-8899-07fc201161b9
-   +---------------------+--------------------------------------+
-   | Field               | Value                                |
-   +---------------------+--------------------------------------+
-   | attachments         | []                                   |
-   | availability_zone   | nova                                 |
-   | bootable            | false                                |
-   | consistencygroup_id | None                                 |
-   | created_at          | 2016-12-06T11:49:06.031768           |
-   | description         | None                                 |
-   | encrypted           | False                                |
-   | id                  | a70d6305-f861-4382-84d8-c43128be0013 |
-   | migration_status    | None                                 |
-   | multiattach         | False                                |
-   | name                | volume2                              |
-   | properties          |                                      |
-   | replication_status  | disabled                             |
-   | size                | 1                                    |
-   | snapshot_id         | None                                 |
-   | source_volid        | None                                 |
-   | status              | creating                             |
-   | type                | iscsi                                |
-   | updated_at          | None                                 |
-   | user_id             | c36cec73b0e44876a4478b1e6cd749bb     |
-   +---------------------+--------------------------------------+
-
-.. note::
-
-   The dashboard suggests a suitable size when you create a new volume
-   based on a volume-backed image.
-
-You can then check this new volume into the EQL array:
-
-.. code-block:: console
-
-   eql> volume select volume-64e8eb18-d23f-437b-bcac-b352afa6843a
-   eql (volume_volume-61e8eb18-d23f-437b-bcac-b352afa6843a)> show
-   ______________________________ Volume Information _______________________________
-   Name: volume-64e8eb18-d23f-437b-bcac-b352afa6843a
-   Size: 2GB
-   VolReserve: 2.01GB
-   VolReserveInUse: 1.01GB
-   ReplReserveInUse: 0MB
-   iSCSI Alias: volume-64e8eb18-d23f-437b-bcac-b352afa6843a
-   iSCSI Name: iqn.2001-05.com.equallogic:0-8a0906-e3091850e-eae000000b7S32cl-volume-64e8eb18-d23f-437b-bcac-b3S2afa6Bl3a
-   ActualMembers: 1
-   Snap-Warn: 10%
-   Snap-Depletion: delete-oldest
-   Description:
-   Snap-Reserve: 100%
-   Snap-Reserve-Avail: 100% (2GB)
-   Permission: read-write
-   DesiredStatus: online
-   Status: online
-   Connections: 1
-   Snapshots: O
-   Bind:
-   Type: not-replicated
-   ReplicationReserveSpace: 0MB
diff -pruN 2:15.0.1-1/doc/source/cli/cinder-status.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/cli/cinder-status.rst
--- 2:15.0.1-1/doc/source/cli/cinder-status.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/cli/cinder-status.rst	2020-03-24 18:46:31.000000000 +0000
@@ -101,7 +101,7 @@ Upgrade
 
   * Check added to make operators aware of new finer-grained configuration
     options affecting the periodicity of various Cinder tasks.  Triggered
-    when the the ``periodic_interval`` option is not set to its default value.
+    when the ``periodic_interval`` option is not set to its default value.
   * Added check for use of deprecated ``cinder.quota.NestedDbQuotaDriver``.
 
 See Also
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/drivers/dell-emc-powermax-driver.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/dell-emc-powermax-driver.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/drivers/dell-emc-powermax-driver.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/dell-emc-powermax-driver.rst	2020-03-24 18:46:31.000000000 +0000
@@ -1,5 +1,5 @@
 ======================================
-Dell EMC POWERMAX iSCSI and FC drivers
+Dell EMC PowerMax iSCSI and FC drivers
 ======================================
 
 The Dell EMC PowerMax drivers, ``PowerMaxISCSIDriver`` and
@@ -37,9 +37,50 @@ Download Solutions Enabler and Unisphere
 and Configuration Guide`` and ``Dell EMC Unisphere for PowerMax Installation
 Guide`` at ``support.emc.com``.
 
+.. note::
+
+   While it is not explicitly documented  which OS versions should be
+   installed on a particular array, it is recommended to install the latest
+   PowerMax OS as supported by Unisphere for PowerMax, that the PowerMax
+   driver supports for a given OpenStack release.
+
+   +-----------+------------------------+-------------+
+   | OpenStack | Unisphere for PowerMax | PowerMax OS |
+   +===========+========================+=============+
+   | Train     | 9.1.x                  | 5978.444    |
+   +-----------+------------------------+-------------+
+   | Stein     | 9.0.x                  | 5978.221    |
+   +-----------+------------------------+-------------+
+
+   However, a Hybrid array can only run HyperMax OS 5977, and is still
+   supported until further notice. Some functionality will not be available
+   in older versions of the OS.  If in any doubt, please contact your customer
+   representative.
+
+
+
 Required PowerMax software suites for OpenStack
 -----------------------------------------------
 
+The storage system requires a Unisphere for PowerMax (SMC) eLicense.
+
+PowerMax
+~~~~~~~~
+There are two licenses for the PowerMax 2000 and 8000:
+
+- Essentials software package
+- Pro software package
+
+The Dell EMC PowerMax cinder driver requires the Pro software package.
+
+All Flash
+~~~~~~~~~
+For full functionality including SRDF for the VMAX All Flash, the FX package,
+or the F package plus the SRDF a la carte add on is required.
+
+Hybrid
+~~~~~~
+
 There are five Dell EMC Software Suites sold with the VMAX Hybrid arrays:
 
 - Base Suite
@@ -55,13 +96,11 @@ Suite and the Local Replication Suite) f
 Using PowerMax Remote Replication functionality will also require the Remote
 Replication Suite.
 
-For full functionality including SRDF for the VMAX All Flash, the FX package,
-or the F package plus the SRDF ``a la carte`` add on is required.
 
-The storage system also requires a Unisphere for PowerMax (SMC) eLicence.
+.. note::
 
-Each are licensed separately. For further details on how to get the
-relevant license(s), reference eLicensing Support below.
+   Each are licensed separately. For further details on how to get the
+   relevant license(s), reference eLicensing Support below.
 
 
 eLicensing support
@@ -129,16 +168,9 @@ PowerMax drivers also support the follow
 -  Extending attached volume
 -  Replicated volume retype support
 -  Retyping attached(in-use) volume
--  Unisphere high availability(HA) support
+-  Unisphere High Availability(HA) support
 -  Online device expansion of a metro device
--  Rapid tdev deallocation of deletes
-
-.. note::
-
-   VMAX All Flash array with Solutions Enabler 8.3.0.11 or later have
-   compression enabled by default when associated with Diamond Service Level.
-   This means volumes added to any newly created storage groups will be
-   compressed.
+-  Rapid TDEV deallocation of deletes
 
 
 PowerMax naming conventions
@@ -156,8 +188,8 @@ PowerMax naming conventions
           1. Perform md5 hash on the shortHostName
           2. Convert output of 1. to hex
           3. Take last 6 characters of shortHostName and append output of 2.
-          4. If the length of output of 3. exceeds 16 characters
-          5. Add the first 8 characters and last 8 characters together
+          4. If the length of output of 3. exceeds 16 characters, join the
+             first 8 characters and last 8 characters.
 
 .. note::
 
@@ -171,8 +203,8 @@ PowerMax naming conventions
           1. Perform md5 hash on the portgroup_name
           2. Convert output of 1. to hex
           3. Take last 6 characters of portgroup_name and append output of 2.
-          4. If the length of output of 3. exceeds 12 characters
-          5. Add the first 6 characters and last 6 characters together
+          4. If the length of output of 3. exceeds 12 characters, join the
+             first 6 characters and last 6 characters.
 
 
 Masking view names
@@ -180,7 +212,7 @@ Masking view names
 
 Masking views are dynamically created by the PowerMax FC and iSCSI drivers
 using the following naming conventions. ``[protocol]`` is either ``I`` for
-volumes attached over iSCSI or ``F`` for volumes attached over Fiber Channel.
+volumes attached over iSCSI or ``F`` for volumes attached over Fibre Channel.
 
 .. code-block:: text
 
@@ -196,7 +228,7 @@ each new attach volume operation, the Po
 (either WWNNs or IQNs) from OpenStack and adds or updates the contents of the
 Initiator Group as required. Names are of the following format. ``[protocol]``
 is either ``I`` for volumes attached over iSCSI or ``F`` for volumes attached
-over Fiber Channel.
+over Fibre Channel.
 
 .. code-block:: console
 
@@ -245,15 +277,16 @@ Child storage groups:
 .. note::
 
    CD and RE are only set if compression is explicitly disabled or replication
-   explicitly enabled. See the compression and replication sections below.
+   explicitly enabled. See the compression `11. All Flash compression support`_
+   and replication `Volume replication support`_ sections below.
 
 .. note::
 
    For PowerMax and any All Flash with PowerMax OS (5978) or greater, workload
-   is NONE
+   if set will be ignored and set to NONE
 
 
-PowerMax Driver Integration
+PowerMax driver integration
 ===========================
 
 1. Prerequisites
@@ -286,7 +319,7 @@ PowerMax Driver Integration
    Configuration Guide`` at ``support.emc.com``.
 
 
-2. FC Zoning with PowerMax
+2. FC zoning with PowerMax
 --------------------------
 
 Zone Manager is required when there is a fabric between the host and array.
@@ -296,8 +329,8 @@ complex and open-zoning would raise secu
 3. iSCSI with PowerMax
 ----------------------
 
--  Make sure the ``iscsi-initiator-utils`` package is installed on all Compute
-   nodes.
+-  Make sure the ``open-iscsi`` package (or distro equivalent) is installed
+   on all Compute nodes.
 
 .. note::
 
@@ -305,15 +338,16 @@ complex and open-zoning would raise secu
    masking view. An attach operation creates this masking view.
 
 
-4. Configure Block Storage in cinder.conf
+
+4. Configure block storage in cinder.conf
 -----------------------------------------
 
 .. note::
 
    VMAX driver was rebranded to PowerMax in Stein, so some of the driver
-   specific tags have also changed. Legacy tags like vmax_srp, vmax_array,
-   vmax_service_level and vmax_port_group, as well as the old driver
-   location, will continue to work until the 'V' release.
+   specific tags have also changed. Legacy tags like ``vmax_srp``,
+   ``vmax_array``, ``vmax_service_level`` and ``vmax_port_group``, as well
+   as the old driver location, will continue to work until the 'V' release.
 
 
 .. config-table::
@@ -324,13 +358,6 @@ complex and open-zoning would raise secu
 
 .. note::
 
-   For security and backend uniformity, the use of the XML file for PowerMax
-   backend configuration was deprecated in Queens and removed entirely
-   in Rocky.
-
-
-.. note::
-
    ``san_api_port`` is ``8443`` by default but can be changed if
    necessary. For the purposes of this documentation the default is
    assumed so the tag will not appear in any of the ``cinder.conf``
@@ -363,7 +390,7 @@ complex and open-zoning would raise secu
    +--------------------+----------------------------+---------+----------+
 
 
-Configure Block Storage in cinder.conf
+Configure block storage in cinder.conf
 
 Add the following entries to ``/etc/cinder/cinder.conf``:
 
@@ -459,7 +486,7 @@ section describing unique parameters for
    ``cinder.conf`` backend stanza.
 
 
-6. Create Volume Types
+6. Create volume types
 ----------------------
 
 Once the ``cinder.conf`` has been updated,  :command:`openstack` commands
@@ -515,15 +542,16 @@ associated with any service level).
 
 .. note::
 
-   PowerMax and Hybrid support Optimized, Diamond, Platinum, Gold, Silver,
-   Bronze, and NONE service levels. VMAX All Flash supports Diamond and
-   None. Hybrid and All Flash support DSS_REP, DSS, OLTP_REP, OLTP, and None
-   workloads, the latter up until ucode 5977. Please refer to Stein PowerMax
-   online documentation if you wish to use ``workload``. There is no support
+   PowerMax and Hybrid support ``Optimized``, ``Diamond``, ``Platinum``,
+   ``Gold``, ``Silver``, ``Bronze``, and ``NONE`` service levels. VMAX
+   All Flash supports ``Diamond`` and `None. Hybrid and All Flash support
+   ``DSS_REP``, ``DSS``, ``OLTP_REP``, ``OLTP``, and None workloads, the
+   latter up until ucode 5977. Please refer to Stein PowerMax online
+   documentation if you wish to use ``workload``. There is no support
    for workloads in PowerMax OS (5978) or greater.
 
 
-7. Interval and Retries
+7. Interval and retries
 -----------------------
 
 By default, ``interval`` and ``retries`` are ``3`` seconds and ``200`` retries
@@ -554,32 +582,32 @@ Add the following lines to the PowerMax
    interval = 1
    retries = 700
 
-8. CHAP Authentication Support
+8. CHAP authentication support
 ------------------------------
 
-This supports one way initiator CHAP authentication functionality into the
+This supports one-way initiator CHAP authentication functionality into the
 PowerMax backend. With CHAP one-way authentication, the storage array
 challenges the host during the initial link negotiation process and expects
 to receive a valid credential and CHAP secret in response. When challenged,
 the host transmits a CHAP credential and CHAP secret to the storage array.
-The storagearray looks for this credential and CHAP secret which stored in
+The storage array looks for this credential and CHAP secret which stored in
 the host initiator's initiator group (IG) information in the ACLX database.
 Once a positive authentication occurs, the storage array sends an acceptance
 message to the host. However, if the storage array fails to find any record
 of the credential/secret pair, it sends a rejection message, and the link is
 closed.
 
-Assumptions, Restrictions and Pre-Requisites
+Assumptions, restrictions and prerequisites
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 #. The host initiator IQN is required along with the credentials the host
    initiator will use to log into the storage array with. The same credentials
    should be used in a multi node system if connecting to the same array.
 
-#. Enable one way CHAP authentication for the iscsi initiator on the storage
+#. Enable one-way CHAP authentication for the iSCSI initiator on the storage
    array using SYMCLI. Template and example shown below. For the purpose of
    this setup, the credential/secret used would be my_username/my_password
-   with iscsi initiator of iqn.1991-05.com.company.lcseb130
+   with iSCSI initiator of iqn.1991-05.com.company.lcseb130
 
    .. code-block:: console
 
@@ -593,7 +621,7 @@ Assumptions, Restrictions and Pre-Requis
 
 
 
-Settings and Configuration
+Settings and configuration
 ~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 #. Set the configuration in the PowerMax backend group in cinder.conf using the
@@ -765,8 +793,8 @@ Prerequisites - PowerMax
 Volume is created against volume type and QoS is enforced with the parameters
 above.
 
-USE CASE 2 - Preset limits
-~~~~~~~~~~~~~~~~~~~~~~~~~~
+USE CASE 2 - Pre-set limits
+~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 Prerequisites - PowerMax
 
@@ -889,8 +917,8 @@ The output of the command contains the x
    </iotune>
 
 
-USE CASE 3 - Preset limits
-~~~~~~~~~~~~~~~~~~~~~~~~~~
+USE CASE 3 - Pre-set limits
+~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 Prerequisites - PowerMax
 
@@ -1091,9 +1119,9 @@ On Compute (Nova) node, add the followin
 
    volume_use_multipath = True
 
-On Cinder controller node, iSCSI MPIO can be set globally in the
-[DEFAULT] section or set individually in the PowerMax backend stanza in
-:file:`/etc/cinder/cinder.conf`:
+On Cinder controller node, multipath for image transfer can be enabled in
+``/etc/cinder/cinder.conf`` for each  backend section or
+in ``[backend_defaults]`` section as a common configuration for all backends.
 
 .. code-block:: ini
 
@@ -1145,7 +1173,10 @@ uncompressed.
 .. note::
 
    This feature is only applicable for All Flash arrays, 250F, 450F, 850F
-   and 950F and PowerMax 2000 and 8000.
+   and 950F and PowerMax 2000 and 8000. It was first introduced Solutions
+   Enabler 8.3.0.11 or later and is enabled by default when associated with
+   a Service Level. This means volumes added to any newly created storage
+   groups will be  compressed.
 
 Use case 1 - Compression disabled create, attach, detach, and delete volume
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -1195,7 +1226,7 @@ Please refer to the following:
 :doc:`/admin/blockstorage-over-subscription`.
 
 
-13. Live Migration support
+13. Live migration support
 --------------------------
 
 Non-live migration (sometimes referred to simply as 'migration'). The instance
@@ -1222,7 +1253,7 @@ Architecture
 
 In PowerMax, A volume cannot belong to two or more FAST storage groups at the
 same time. To get around this limitation we leverage both cascaded storage
-groups and a temporary non FAST storage group.
+groups and a temporary non-FAST storage group.
 
 A volume can remain 'live' if moved between masking views that have the same
 initiator group and port groups which preserves the host path.
@@ -1236,7 +1267,7 @@ on the volume:
 #. The volume is added to the FAST storage group within the destination
    parent storage group of the destination masking view. At this point the
    volume belongs to two storage groups.
-#. One of two things happens:
+#. One of two things happen:
 
    - If the connection to the destination instance is successful, the volume
      is removed from the non-FAST storage group in the originating masking
@@ -1251,11 +1282,12 @@ Live migration configuration
 
 Please refer to the following for more information:
 
-https://docs.openstack.org/nova/latest/admin/live-migration-usage.html
+https://docs.openstack.org/nova/latest/admin/configuring-migrations.html
 
 and
 
-https://docs.openstack.org/nova/latest/admin/configuring-migrations.html
+https://docs.openstack.org/nova/latest/admin/live-migration-usage.html
+
 
 .. note::
 
@@ -1326,7 +1358,7 @@ For our use case shown below, we have th
 and HostC. HostA is the compute node while HostB and HostC are the compute
 nodes. The following were also used in live migration.
 
-- 2 gb bootable volume using the cirros image.
+- 2 gb bootable volume using the CirrOS image.
 - Instance created using the 2gb volume above with a flavor m1.small using
   2048 RAM, 20GB of Disk and 1 VCPU.
 
@@ -1390,7 +1422,7 @@ hosts/servers simultaneously. Please see
 :doc:`/admin/blockstorage-volume-multiattach`
 for configuration information.
 
-Multi-attach Architecture
+Multi-attach architecture
 ~~~~~~~~~~~~~~~~~~~~~~~~~
 
 In PowerMax, a volume cannot belong to two or more FAST storage groups at the
@@ -1405,7 +1437,7 @@ no service level, workload, or SRP speci
    backend is required – the volume is attached to and detached from each
    host as normal.
 
-Example Use Case
+Example use case
 ~~~~~~~~~~~~~~~~
 
 Volume ``Multi-attach-Vol-1`` (with a multi-attach capable volume type, and
@@ -1435,21 +1467,22 @@ We then decide to detach the volume from
    storage group. The non-FAST managed storage group is cleaned up,
    if required.
 
-.. note::
-
-   Known issue - the multi-attach flag is still false after a retype. This
-   is being addressed in https://bugs.launchpad.net/cinder/+bug/1790840
-
 
-15. Volume Encryption support
+15. Volume encryption support
 -----------------------------
 
 Please refer to the following:
 :doc:`/configuration/block-storage/volume-encryption`.
 
 
-16. Volume metadata in logs
----------------------------
+16. Volume metadata
+-------------------
+
+Volume metadata is returned to the user in both the Cinder Volume logs and
+with volumes and snapshots created in Cinder via the UI or CLI.
+
+16.1 Volume metadata in logs
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 If debug is enabled in the default section of the cinder.conf, PowerMax Cinder
 driver will log additional volume information in the Cinder volume log,
@@ -1485,7 +1518,36 @@ PowerMax view point.
    | serial_number                      | 000123456789                                            |
    +------------------------------------+---------------------------------------------------------+
 
-17. Unisphere high availability(HA) support
+16.2 Metadata in the UI and CLI
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+By default metadata will be set on all volume and snapshot objects created in
+Cinder. This information represents the state of the object on the backend
+PowerMax and will change when volume attributes are changed by performing
+actions on them such as re-type or attaching to an instance.
+
+.. code-block:: console
+
+   demo@openstack-controller:~$ cinder show powermax-volume
+
+   +--------------------------------+------------------------------------------------------------+
+   | Property                       | Value                                                      |
+   +--------------------------------+------------------------------------------------------------+
+   | metadata                       | ArrayID : 000123456789                                     |
+   |                                | ArrayModel : PowerMax_8000                                 |
+   |                                | CompressionDisabled : False                                |
+   |                                | Configuration : TDEV                                       |
+   |                                | DeviceID : 0012F                                           |
+   |                                | DeviceLabel : OS-d87edb98-60fd-49dd-bb0f-cc388cf6f3f4      |
+   |                                | Emulation : FBA                                            |
+   |                                | ReplicationEnabled : False                                 |
+   |                                | ServiceLevel : Diamond                                     |
+   |                                | Workload : None                                            |
+   | name                           | powermax-volume                                            |
+   +--------------------------------+------------------------------------------------------------+
+
+
+17. Unisphere High Availability(HA) support
 -------------------------------------------
 
 This feature facilitates high availability of Unisphere for PowerMax servers,
@@ -1564,7 +1626,7 @@ restarted for changes to take effect.
    used by the PowerMax driver.
 
 
-18. Rapid TDEV Deallocation
+18. Rapid TDEV deallocation
 ---------------------------
 
 The PowerMax driver can now leverage the enhanced volume delete feature-set
@@ -1579,7 +1641,7 @@ compliant volume deletion sequence based
 metadata.
 
 
-19. PowerMax Online (in-use) Device Expansion
+19. PowerMax online (in-use) device expansion
 ---------------------------------------------
 
 .. table::
@@ -1589,27 +1651,27 @@ metadata.
    +----------------+----------------+--------------+--------------+-------------+
    | R1 uCode Level | R2 uCode Level | Sync         | Async        | Metro       |
    +================+================+==============+==============+=============+
-   | 5979           | 5979           | Y            | Y            | Y           |
+   | 5978.444       | 5978.444       | Y            | Y            | Y           |
    +----------------+----------------+--------------+--------------+-------------+
-   | 5979           | 5978           | Y            | Y            | N           |
+   | 5978.444       | 5978.221       | Y            | Y            | N           |
    +----------------+----------------+--------------+--------------+-------------+
-   | 5978           | 5978           | Y            | Y            | N           |
+   | 5978.221       | 5978.221       | Y            | Y            | N           |
    +----------------+----------------+--------------+--------------+-------------+
 
 
-Assumptions, Restrictions and Pre-Requisites
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+Assumptions, restrictions and prerequisites
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 - ODE in the context of this document refers to extending a volume where it
   is in-use, that is, attached to an instance.
 - The ``allow_extend`` is only applicable on Hybrid arrays or All Flash arrays
   with HyperMax OS. If included elsewhere, it is ignored.
 - Extending a Metro volume is blocked for all replication sessions where both
-  R1 and R2 arrays are not PowerMax OS 5979 or newer.
+  R1 and R2 arrays are not PowerMax OS 5978.444 or newer.
 - Where one array is a lower uCode than the other, the environment is limited
-  to functionality of that of the lowest uCode level, i.e. if R1 is 5979 and
-  R2 is 5978, expanding a metro volume is not supported, both R1 and R2 need
-  to be on 5979 uCode.
+  to functionality of that of the lowest uCode level, i.e. if R1 is 5978.444
+  and R2 is 5978.221, expanding a metro volume is not supported, both R1 and
+  R2 need to be on 5978.444 uCode.
 
 Cinder supported operations
 ===========================
@@ -1690,7 +1752,7 @@ Configure the source and target arrays
 
    * ``remote_port_group`` is the name of a PowerMax port group that has been
      pre-configured to expose volumes managed by this backend in the event
-     of a failover. Make sure that this portgroup contains either all FC or
+     of a failover. Make sure that this port group contains either all FC or
      all iSCSI port groups (for a given back end), as appropriate for the
      configured driver (iSCSI or FC).
 
@@ -1749,7 +1811,7 @@ Configure the source and target arrays
    ``replication_device`` parameter has been entered in the PowerMax
    backend entry in the ``cinder.conf``, a corresponding volume type
    needs to be created ``replication_enabled`` property set. See
-   above ``Setup PowerMax drivers`` for details.
+   above `6. Create volume types`_ for details.
 
    .. code-block:: console
 
@@ -1791,6 +1853,11 @@ Most features are supported, except for
 Failover host
 ~~~~~~~~~~~~~
 
+.. note::
+
+   Failover and Failback operations are not applicable in Metro
+   configurations.
+
 In the event of a disaster, or where there is required downtime, upgrade
 of the primary array for example, the administrator can issue the failover
 host command to failover to the configured target:
@@ -1799,22 +1866,38 @@ host command to failover to the configur
 
    # cinder failover-host cinder_host@POWERMAX_FC_REPLICATION
 
-If the primary array becomes available again, you can initiate a failback
-using the same command and specifying ``--backend_id default``:
+After issuing Cinder failover-host command Cinder will set the R2 array as the
+target array for Cinder, however to get existing instances to use this new
+array and paths to volumes it is necessary to first shelve Nova instances and
+then unshelve them, this will effectively restart the Nova instance and
+re-establish data paths between Nova instances and the volumes on the R2 array.
 
 .. code-block:: console
 
-   # cinder failover-host cinder_host@POWERMAX_FC_REPLICATION --backend_id default
+   # nova shelve <server>
+   # nova unshelve [--availability-zone <availability_zone>] <server>
+
+When a host is in failover mode performing normal volume or snapshot
+provisioning will not be possible, failover-host mode simply provides access
+to replicated volumes to minimise environment down-time. The primary objective
+whilst in failover mode should be to get the R1 array back online.  When the
+primary array becomes available again, you can initiate a failback using the
+same failover command and specifying --backend_id default:
 
-.. note::
+.. code-block:: console
 
-   Failover and Failback operations are not applicable in Metro configurations.
+   # cinder failover-host cinder_host@POWERMAX_FC_REPLICATION --backend_id default
 
+After issuing the failover command to revert to the default backend host it is
+necessary to re-issue the Nova shelve and unshelve commands to restore the
+data paths between Nova instances and their corresponding back end volumes.
+Once reverted to the default backend volume and snapshot provisioning
+operations can continue as normal.
 
-Asynchronous and Metro replication management groups
+Asynchronous and metro replication management groups
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-Asynchronous and Metro volumes in an RDF session, i.e. belonging to an SRDF
+Asynchronous and metro volumes in an RDF session, i.e. belonging to an SRDF
 group, must be managed together for RDF operations (although there is a
 ``consistency exempt`` option for creating and deleting pairs in an Async
 group). To facilitate this management, we create an internal RDF management
@@ -1827,7 +1910,7 @@ group. For this reason, it is imperative
 Metro support
 ~~~~~~~~~~~~~
 
-SRDF/Metro is a High Availabilty solution. It works by masking both sides of
+SRDF/Metro is a high availability solution. It works by masking both sides of
 the RDF relationship to the host, and presenting all paths to the host,
 appearing that they all point to the one device. In order to do this,
 there needs to be multipath software running to manage writing to the
@@ -1854,7 +1937,7 @@ Known issues
    replication volume type.
 
 
-Volume retype -  storage assisted volume migration
+Volume retype - storage assisted volume migration
 --------------------------------------------------
 
 Volume retype with storage assisted migration is supported now for
@@ -1866,7 +1949,7 @@ retype, follow these steps:
    another, use volume retype with the migration-policy to on-demand. The
    target volume type should have the same volume_backend_name configured and
    should have the desired pool_name to which you are trying to retype to
-   (please refer to ``Setup PowerMax Drivers`` for details).
+   (please refer to `6. Create volume types`_ for details).
 
    .. code-block:: console
 
@@ -1884,7 +1967,7 @@ retype, follow these steps:
 
 .. note::
 
-   With the Stein release, In Use (attached) volume retype is supported
+   With the Stein release, in-use (attached) volume retype is supported
 
 
 Generic volume group support
@@ -1944,7 +2027,7 @@ without failing over the entire host. Se
    A generic volume group can be both consistent group snapshot enabled and
    consistent group replication enabled.
 
-Storage Group Names
+Storage group names
 ~~~~~~~~~~~~~~~~~~~
 
 Storage groups are created on the PowerMax as a result of creation of generic
@@ -1956,113 +2039,22 @@ name.
 
    TruncatedGroupName_GroupUUID or GroupUUID
 
-Group type operations
-~~~~~~~~~~~~~~~~~~~~~
-
-- Create a group type
-
-.. code-block:: console
-
-   cinder --os-volume-api-version 3.11 group-type-create GROUP_TYPE
-
-- Show a group type
-
-.. code-block:: console
-
-   cinder --os-volume-api-version 3.11 group-type-show GROUP_TYPE
-
-- List group types
-
-.. code-block:: console
+Group type, group and group snapshot operations
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-   cinder --os-volume-api-version 3.11 group-type-list
-
-- Delete group type
-
-.. code-block:: console
-
-   cinder --os-volume-api-version 3.11 group-type-delete GROUP_TYPE
-
-- Set/unset a group spec
-
-.. code-block:: console
-
-   cinder --os-volume-api-version 3.11 group-type-key GROUP_TYPE set consistent_group_snapshot_enabled="<is> True"
-
-- List group types and group specs:
-
-.. code-block:: console
-
-   cinder --os-volume-api-version 3.11 group-specs-list
-
-Group operations
-~~~~~~~~~~~~~~~~
-
-- Create a group:
-
-.. code-block:: console
-
-   cinder --os-volume-api-version 3.13 group-create --name GROUP GROUP_TYPE VOLUME_TYPE1,VOLUME_TYPE2
-
-- Show a group:
-
-.. code-block:: console
-
-   cinder --os-volume-api-version 3.13 group-show GROUP
-
-- List all groups:
-
-.. code-block:: console
-
-   cinder --os-volume-api-version 3.13 group-list
-
-- Create a volume and add it to a group at the time of creation:
-
-.. code-block:: console
-
-   cinder --os-volume-api-version 3.13 create --volume-type VOLUME_TYPE1 --group-id GROUP_ID 1
-
-- Modify a group to add or remove volumes:
-
-.. code-block:: console
-
-   cinder --os-volume-api-version 3.13 group-update --add-volumes UUID1,UUID2 --remove-volumes UUID3,UUID4 GROUP
-
-- Delete a group
-
-.. code-block:: console
-
-   cinder --os-volume-api-version 3.13 group-delete --delete-volumes GROUP
-
-Group snapshot operations
-~~~~~~~~~~~~~~~~~~~~~~~~~
-
-- Create a group snapshot:
-
-.. code-block:: console
-
-   cinder --os-volume-api-version 3.14 group-snapshot-create --name GROUP_SNAPSHOT GROUP
-
-- Delete group snapshot(s):
-
-.. code-block:: console
-
-   cinder --os-volume-api-version 3.14 group-snapshot-delete GROUP_SNAPSHOT
-
-- Create a group from a group snapshot:
-
-.. code-block:: console
-
-   $ cinder --os-volume-api-version 3.14 group-create-from-src --group-snapshot GROUP_SNAPSHOT --name GROUP
-
-- Create a group from a source snapshot:
-
-.. code-block:: console
-
-   $ cinder --os-volume-api-version 3.14 group-create-from-src --source-group SOURCE_GROUP --name GROUP
+Please refer to the following section for the most up to date group type
+group and group replication operations https://docs.openstack.org/cinder/latest/admin/blockstorage-groups.html
 
 Group replication operations
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+Generic volume group operations no longer require the user to specify the
+Cinder CLI version, however, performing generic volume group replication
+operations still require this setting. When running generic volume group
+commands set the value --os-volume-api-version to 3.38.
+These commands are not listed in the latest Cinder CLI documentation so
+will remain here until added to the latest Cinder CLI version or
+deprecated from Cinder.
+
 
 - Enable group replication
 
@@ -2090,7 +2082,7 @@ Group replication operations
        --secondary-backend-id default
 
 
-Manage and Unmanage Volumes
+Manage and unmanage Volumes
 ---------------------------
 
 Managing volumes in OpenStack is the process whereby a volume which exists
@@ -2110,7 +2102,7 @@ OpenStack, the following prerequisites m
 
 - The volume must a whole GB e.g. 5.5GB is not a valid size
 
-- The volume cannot be a snapvx target
+- The volume cannot be a SnapVX target
 
 
 For a volume to exist in a Cinder managed pool, it must reside in the same
@@ -2137,7 +2129,7 @@ the same format:
      - The PowerMax serial number (12 digit numerical)
 
 
-Manage Volumes
+Manage volumes
 ~~~~~~~~~~~~~~
 
 With your pool name defined you can now manage the volume into OpenStack, this
@@ -2171,7 +2163,7 @@ the same way as any other OpenStack Powe
    PowerMax driver on a manage operation.
 
 
-Managing Volumes with Replication Enabled
+Managing volumes with replication enabled
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 Whilst it is not possible to manage volumes into OpenStack that are part of a
@@ -2183,7 +2175,7 @@ volume type as the chosen volume type. O
 enabled for that volume.
 
 
-Unmanage Volume
+Unmanage volume
 ~~~~~~~~~~~~~~~
 
 Unmanaging a volume is not the same as deleting a volume. When a volume is
@@ -2212,7 +2204,7 @@ the 'OS-' prefix has been removed, this
 the volume is no longer managed by OpenStack.
 
 
-Manage/Unmanage Snapshots
+Manage/unmanage snapshots
 -------------------------
 
 Users can manage PowerMax SnapVX snapshots into OpenStack if the source volume
@@ -2231,7 +2223,7 @@ Set-up, restrictions and requirements:
 
 #. It is only possible to manage or unmanage one snapshot at a time in Cinder.
 
-Manage SnapVX Snapshot
+Manage SnapVX snapshot
 ~~~~~~~~~~~~~~~~~~~~~~
 
 It is possible to manage PowerMax SnapVX snapshots into OpenStack, where the
@@ -2247,7 +2239,7 @@ the restriction around managing SnapVX s
    or volumes which exist in a replication session.
 
 
-Requirements/Restrictions:
+Requirements/restrictions:
 
 #. The SnapVX source volume must be present in and managed by Cinder.
 
@@ -2259,7 +2251,7 @@ Requirements/Restrictions:
    linked target volumes.
 
 
-Command Structure:
+Command structure:
 
 #. Identify your SnapVX snapshot for management on the PowerMax, note the name.
 
@@ -2321,7 +2313,7 @@ snapshot in this example named ``OS-Powe
 managed by Cinder will be present for use under the name ``SnapshotManaged``.
 
 
-Unmanage Cinder Snapshot
+Unmanage cinder snapshot
 ~~~~~~~~~~~~~~~~~~~~~~~~
 
 Unmanaging a snapshot in Cinder is the process whereby the snapshot is removed
@@ -2386,7 +2378,7 @@ List manageable volume is filtered by:
 - Volume should not be ``encapsulated``
 - Volume should not be ``reserved``
 - Volume should not be a part of an RDF session
-- Volume should not be a snapVX Target
+- Volume should not be a SnapVX Target
 - Volume identifier should not begin with ``OS-``.
 
 Manageable snaphots
@@ -2411,7 +2403,7 @@ List manageable snapshots is filtered by
 
    There is some delay in the syncing of the Unisphere for PowerMax database
    when the state/properties of a volume is modified using ``symcli``.  To
-   prevent this it is preferrable to modify state/properties of volumes within
+   prevent this it is preferable to modify state/properties of volumes within
    Unisphere.
 
 
@@ -2430,10 +2422,17 @@ Upgrading from SMI-S based driver to RES
 Seamless upgrades from an SMI-S based driver to RESTAPI based driver,
 following the setup instructions above, are supported with a few exceptions:
 
-#. Live migration functionality will not work on already attached/in-use
-   legacy volumes. These volumes will first need to be detached and reattached
-   using the RESTAPI based driver. This is because we have changed the masking
-   view architecture from Pike to better support this functionality.
+#. OpenStack's ``live migration`` functionality will not work on already
+   attached/in-use legacy volumes without first migrating the volumes to
+   the new REST masking view structure.  This can be done by running the
+   migrate.py script in PyU4V.  Please refer to the Tools Guide in PyU4V_.
+
+   .. code-block:: text
+
+      $ pip install PyU4V
+
 
 #. Consistency groups are deprecated in Pike. Generic Volume Groups are
    supported from Pike onwards.
+
+.. _PyU4V: https://pyu4v.readthedocs.io/en/latest/
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/drivers/dell-emc-unity-driver.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/dell-emc-unity-driver.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/drivers/dell-emc-unity-driver.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/dell-emc-unity-driver.rst	2020-03-24 18:46:31.000000000 +0000
@@ -145,7 +145,9 @@ Driver configuration
       # service multipath-tools restart
 
 
-#. Enable multipath for image transfer in ``/etc/cinder/cinder.conf``.
+#. Enable multipath for image transfer in ``/etc/cinder/cinder.conf`` for each
+   backend or in ``[backend_defaults]`` section as a common configuration
+   for all backends.
 
    .. code-block:: ini
 
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/drivers/dell-emc-xtremio-driver.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/dell-emc-xtremio-driver.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/drivers/dell-emc-xtremio-driver.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/dell-emc-xtremio-driver.rst	2020-03-24 18:46:31.000000000 +0000
@@ -160,7 +160,8 @@ modified as follows:
 -  Multipathing
 
    The ``use_multipath_for_image_xfer`` parameter in the ``cinder.conf`` file
-   should be set to ``True`` as follows:
+   should be set to ``True`` for each backend  or in ``[backend_defaults]``
+   section as a common configuration for all backends.
 
    .. code-block:: ini
 
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/drivers/dell-equallogic-driver.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/dell-equallogic-driver.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/drivers/dell-equallogic-driver.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/dell-equallogic-driver.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,166 +0,0 @@
-=============================================
-Dell EMC PS Series volume driver (Deprecated)
-=============================================
-
-The Dell PS Series (EqualLogic) volume driver interacts with configured PS
-Series arrays and supports various operations.
-
-.. note::
-   The Dell PS Series volume driver is moving into maintanence mode in S
-   release and will be removed in the T release.
-
-Supported operations
-~~~~~~~~~~~~~~~~~~~~
-
--  Create, delete, attach, and detach volumes.
--  Create, list, and delete volume snapshots.
--  Clone a volume.
-
-Configuration
-~~~~~~~~~~~~~
-
-The OpenStack Block Storage service supports:
-
--  Multiple instances of Dell EqualLogic Groups or Dell EqualLogic Group
-   Storage Pools and multiple pools on a single array.
-
--  Multiple instances of Dell EqualLogic Groups or Dell EqualLogic Group
-   Storage Pools or multiple pools on a single array.
-
-The Dell EqualLogic volume driver's ability to access the EqualLogic Group is
-dependent upon the generic block storage driver's SSH settings in the
-``/etc/cinder/cinder.conf`` file (see
-:ref:`block-storage-sample-configuration-file` for reference).
-
-.. config-table::
-   :config-target: PS Series
-
-   cinder.volume.drivers.dell_emc.ps
-
-Default (single-instance) configuration
----------------------------------------
-
-The following sample ``/etc/cinder/cinder.conf`` configuration lists the
-relevant settings for a typical Block Storage service using a single
-Dell EqualLogic Group:
-
-.. code-block:: ini
-
-   [DEFAULT]
-   # Required settings
-
-   volume_driver = cinder.volume.drivers.dell_emc.ps.PSSeriesISCSIDriver
-   san_ip = IP_EQLX
-   san_login = SAN_UNAME
-   san_password = SAN_PW
-   eqlx_group_name = EQLX_GROUP
-   eqlx_pool = EQLX_POOL
-
-   # Optional settings
-
-   san_thin_provision = true|false
-   use_chap_auth = true|false
-   chap_username = EQLX_UNAME
-   chap_password = EQLX_PW
-   eqlx_cli_max_retries = 5
-   san_ssh_port = 22
-   ssh_conn_timeout = 30
-   san_private_key = SAN_KEY_PATH
-   ssh_min_pool_conn = 1
-   ssh_max_pool_conn = 5
-
-In this example, replace the following variables accordingly:
-
-IP_EQLX
-    The IP address used to reach the Dell EqualLogic Group through SSH.
-    This field has no default value.
-
-SAN_UNAME
-    The user name to login to the Group manager via SSH at the
-    ``san_ip``. Default user name is ``grpadmin``.
-
-SAN_PW
-    The corresponding password of SAN_UNAME. Not used when
-    ``san_private_key`` is set. Default password is ``password``.
-
-EQLX_GROUP
-    The group to be used for a pool where the Block Storage service will
-    create volumes and snapshots. Default group is ``group-0``.
-
-EQLX_POOL
-    The pool where the Block Storage service will create volumes and
-    snapshots. Default pool is ``default``. This option cannot be used
-    for multiple pools utilized by the Block Storage service on a single
-    Dell EqualLogic Group.
-
-EQLX_UNAME
-    The CHAP login account for each volume in a pool, if
-    ``use_chap_auth`` is set to ``true``. Default account name is
-    ``chapadmin``.
-
-EQLX_PW
-    The corresponding password of EQLX_UNAME. The default password is
-    randomly generated in hexadecimal, so you must set this password
-    manually.
-
-SAN_KEY_PATH (optional)
-    The filename of the private key used for SSH authentication. This
-    provides password-less login to the EqualLogic Group. Not used when
-    ``san_password`` is set. There is no default value.
-
-In addition, enable thin provisioning for SAN volumes using the default
-``san_thin_provision = true`` setting.
-
-Multiple back-end configuration
--------------------------------
-
-The following example shows the typical configuration for a Block
-Storage service that uses two Dell EqualLogic back ends:
-
-.. code-block:: ini
-
-   enabled_backends = backend1,backend2
-   san_ssh_port = 22
-   ssh_conn_timeout = 30
-   san_thin_provision = true
-
-   [backend1]
-   volume_driver = cinder.volume.drivers.dell_emc.ps.PSSeriesISCSIDriver
-   volume_backend_name = backend1
-   san_ip = IP_EQLX1
-   san_login = SAN_UNAME
-   san_password = SAN_PW
-   eqlx_group_name = EQLX_GROUP
-   eqlx_pool = EQLX_POOL
-
-   [backend2]
-   volume_driver = cinder.volume.drivers.dell_emc.ps.PSSeriesISCSIDriver
-   volume_backend_name = backend2
-   san_ip = IP_EQLX2
-   san_login = SAN_UNAME
-   san_password = SAN_PW
-   eqlx_group_name = EQLX_GROUP
-   eqlx_pool = EQLX_POOL
-
-In this example:
-
--  Thin provisioning for SAN volumes is enabled
-   (``san_thin_provision = true``). This is recommended when setting up
-   Dell EqualLogic back ends.
-
--  Each Dell EqualLogic back-end configuration (``[backend1]`` and
-   ``[backend2]``) has the same required settings as a single back-end
-   configuration, with the addition of ``volume_backend_name``.
-
--  The ``san_ssh_port`` option is set to its default value, 22. This
-   option sets the port used for SSH.
-
--  The ``ssh_conn_timeout`` option is also set to its default value, 30.
-   This option sets the timeout in seconds for CLI commands over SSH.
-
--  The ``IP_EQLX1`` and ``IP_EQLX2`` refer to the IP addresses used to
-   reach the Dell EqualLogic Group of ``backend1`` and ``backend2``
-   through SSH, respectively.
-
-For information on configuring multiple back ends, see :doc:`Configure a
-multiple-storage back end </admin/blockstorage-multi-backend>`.
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/drivers/fujitsu-eternus-dx-driver.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/fujitsu-eternus-dx-driver.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/drivers/fujitsu-eternus-dx-driver.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/fujitsu-eternus-dx-driver.rst	2020-03-24 18:46:31.000000000 +0000
@@ -132,6 +132,8 @@ Configuration
        <EternusUser>smisuser</EternusUser>
        <EternusPassword>smispassword</EternusPassword>
        <EternusPool>raid5_0001</EternusPool>
+       <EternusPool>tpp_0001</EternusPool>
+       <EternusPool>raid_0002</EternusPool>
        <EternusSnapPool>raid5_0001</EternusSnapPool>
        </FUJITSU>
 
@@ -146,6 +148,8 @@ Configuration
        <EternusUser>smisuser</EternusUser>
        <EternusPassword>smispassword</EternusPassword>
        <EternusPool>raid5_0001</EternusPool>
+       <EternusPool>tpp_0001</EternusPool>
+       <EternusPool>raid_0002</EternusPool>
        <EternusSnapPool>raid5_0001</EternusSnapPool>
        <EternusISCSIIP>1.1.1.1</EternusISCSIIP>
        <EternusISCSIIP>1.1.1.2</EternusISCSIIP>
@@ -169,7 +173,7 @@ Configuration
    ``EternusPassword``
        Password for the SMI-S connection of the ETERNUS DX.
 
-   ``EternusPool``
+   ``EternusPool`` (Multiple setting allowed)
        Storage pool name for volumes.
 
        Enter RAID Group name or TPP name in the ETERNUS DX.
@@ -188,6 +192,8 @@ Configuration
         and cannot specify TPP name.
       * You can specify the same RAID Group name for ``EternusPool`` and ``EternusSnapPool``
         if you create volumes and snapshots on a same storage pool.
+      * For ``EternusPool``, when multiple pools are specified,
+        cinder-scheduler will select one from multiple pools to create the volume.
 
 Configuration example
 ~~~~~~~~~~~~~~~~~~~~~
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/drivers/huawei-storage-driver.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/huawei-storage-driver.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/drivers/huawei-storage-driver.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/huawei-storage-driver.rst	2020-03-24 18:46:31.000000000 +0000
@@ -123,8 +123,9 @@ iSCSI storage or Fibre Channel storage.
 **Pre-requisites**
 
 When creating a volume from image, install the ``multipath`` tool and add the
-following configuration keys in the ``[DEFAULT]`` configuration group of
-the ``/etc/cinder/cinder.conf`` file:
+following configuration keys for each backend section or in
+``[backend_defaults]`` section as a common configuration for all backends in
+``/etc/cinder/cinder.conf`` file:
 
 .. code-block:: ini
 
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/drivers/ibm-storwize-svc-driver.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/ibm-storwize-svc-driver.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/drivers/ibm-storwize-svc-driver.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/ibm-storwize-svc-driver.rst	2020-03-24 18:46:31.000000000 +0000
@@ -320,7 +320,8 @@ driver:
 - mirror_pool
 - volume_topology
 - peer_pool
-- host_site
+- flashcopy_rate
+- cycle_period_seconds
 
 These keys have the same semantics as their counterparts in the
 configuration file. They are set similarly; for example, ``rsize=2`` or
@@ -462,7 +463,9 @@ modify volume types, you can also change
 
 -  peer_pool
 
--  host_site
+-  flashcopy_rate
+
+-  cycle_period_seconds
 
 .. note::
 
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/drivers/infortrend-volume-driver.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/infortrend-volume-driver.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/drivers/infortrend-volume-driver.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/infortrend-volume-driver.rst	2020-03-24 18:46:31.000000000 +0000
@@ -103,7 +103,9 @@ Fibre Channel configuration example
 Multipath configuration
 -----------------------
 
-* Enable multipath for image transfer in ``/etc/cinder/cinder.conf``.
+* Enable multipath for image transfer in ``/etc/cinder/cinder.conf`` for each
+  back end or in ``[backend_defaults]`` section as a common configuration
+  for all backends.
 
    .. code-block:: ini
 
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/drivers/MacroSAN-storage-driver.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/MacroSAN-storage-driver.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/drivers/MacroSAN-storage-driver.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/MacroSAN-storage-driver.rst	2020-03-24 18:46:31.000000000 +0000
@@ -23,11 +23,13 @@ To use the MacroSAN drivers, the followi
 - HTTPS or HTTP must be enabled on the array
 
 When creating a volume from image, install the ``multipath`` tool and add the
-following configuration keys in the ``[DEFAULT]`` configuration group of
-the ``/etc/cinder/cinder.conf`` file:
+following configuration keys for each backend section or in
+``[backend_defaults]`` section as a common configuration for all backends in
+``/etc/cinder/cinder.conf`` file:
 
 .. code-block:: ini
 
+   [cinder-iscsi-a]
    use_multipath_for_image_xfer = True
 
 When creating a instance from image, install the ``multipath`` tool and add the
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/drivers/nimble-volume-driver.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/nimble-volume-driver.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/drivers/nimble-volume-driver.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/nimble-volume-driver.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,252 +0,0 @@
-============================
-Nimble Storage volume driver
-============================
-
-Nimble Storage fully integrates with the OpenStack platform through
-the Nimble Cinder driver, allowing a host to configure and manage Nimble
-Storage array features through Block Storage interfaces.
-
-Support for iSCSI storage protocol is available with NimbleISCSIDriver
-Volume Driver class and Fibre Channel with NimbleFCDriver.
-
-Support for the Liberty release and above is available from Nimble OS
-2.3.8 or later.
-
-Support for the Ocata release and above is available from Nimble OS 3.6 or
-later.
-
-Nimble Storage Cinder driver does not support port binding with multiple
-interfaces on the same subnet due to existing limitation in os-brick. This
-is partially referenced in the bug
-https://bugs.launchpad.net/os-brick/+bug/1722432 but does not resolve
-for multiple software iscsi ifaces.
-
-Supported operations
-~~~~~~~~~~~~~~~~~~~~
-
-* Create, delete, clone, attach, and detach volumes
-* Create and delete volume snapshots
-* Create a volume from a snapshot
-* Copy an image to a volume
-* Copy a volume to an image
-* Extend a volume
-* Get volume statistics
-* Manage and unmanage a volume
-* Enable encryption and default performance policy for a volume-type
-  extra-specs
-* Force backup of an in-use volume.
-
-Nimble Storage driver configuration
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-Update the file ``/etc/cinder/cinder.conf`` with the given configuration.
-
-In case of a basic (single back-end) configuration, add the parameters
-within the ``[default]`` section as follows.
-
-.. code-block:: ini
-
-   [default]
-   san_ip = NIMBLE_MGMT_IP
-   san_login = NIMBLE_USER
-   san_password = NIMBLE_PASSWORD
-   use_multipath_for_image_xfer = True
-   volume_driver = NIMBLE_VOLUME_DRIVER
-
-In case of multiple back-end configuration, for example, configuration
-which supports multiple Nimble Storage arrays or a single Nimble Storage
-array with arrays from other vendors, use the following parameters.
-
-.. code-block:: ini
-
-   [default]
-   enabled_backends = Nimble-Cinder
-
-   [Nimble-Cinder]
-   san_ip = NIMBLE_MGMT_IP
-   san_login = NIMBLE_USER
-   san_password = NIMBLE_PASSWORD
-   use_multipath_for_image_xfer = True
-   volume_driver = NIMBLE_VOLUME_DRIVER
-   volume_backend_name = NIMBLE_BACKEND_NAME
-
-In case of multiple back-end configuration, Nimble Storage volume type
-is created and associated with a back-end name as follows.
-
-.. note::
-
-   Single back-end configuration users do not need to create the volume type.
-
-.. code-block:: console
-
-   $ openstack volume type create NIMBLE_VOLUME_TYPE
-   $ openstack volume type set --property volume_backend_name=NIMBLE_BACKEND_NAME NIMBLE_VOLUME_TYPE
-
-This section explains the variables used above:
-
-NIMBLE_MGMT_IP
-  Management IP address of Nimble Storage array/group.
-
-NIMBLE_USER
-  Nimble Storage account login with minimum ``power user`` (admin) privilege
-  if RBAC is used.
-
-NIMBLE_PASSWORD
-  Password of the admin account for nimble array.
-
-NIMBLE_VOLUME_DRIVER
-  Use either cinder.volume.drivers.nimble.NimbleISCSIDriver for iSCSI or
-  cinder.volume.drivers.nimble.NimbleFCDriver for Fibre Channel.
-
-NIMBLE_BACKEND_NAME
-  A volume back-end name which is specified in the ``cinder.conf`` file.
-  This is also used while assigning a back-end name to the Nimble volume type.
-
-NIMBLE_VOLUME_TYPE
-  The Nimble volume-type which is created from the CLI and associated with
-  ``NIMBLE_BACKEND_NAME``.
-
-  .. note::
-
-     Restart the ``cinder-api``, ``cinder-scheduler``, and ``cinder-volume``
-     services after updating the ``cinder.conf`` file.
-
-Nimble driver extra spec options
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-The Nimble volume driver also supports the following extra spec options:
-
-'nimble:encryption'='yes'
-  Used to enable encryption for a volume-type.
-
-'nimble:perfpol-name'=PERF_POL_NAME
-  PERF_POL_NAME is the name of a performance policy which exists on the
-  Nimble array and should be enabled for every volume in a volume type.
-
-'nimble:multi-initiator'='true'
-  Used to enable multi-initiator access for a volume-type.
-
-nimble:dedupe'='true'
-  Used to enable dedupe support for a volume-type.
-
-'nimble:iops-limit'=IOPS_LIMIT
-  Used to set the IOPS_LIMIT between 256 and 4294967294 for all
-  volumes created for this volume-type.
-
-'nimble:folder'=FOLDER_NAME
-  FOLDER_NAME is the name of the folder which exists on the Nimble array
-  and should be enabled for every volume in a volume type
-
-These extra-specs can be enabled by using the following command:
-
-.. code-block:: console
-
-   $ openstack volume type set --property KEY=VALUE VOLUME_TYPE
-
-``VOLUME_TYPE`` is the Nimble volume type and ``KEY`` and ``VALUE`` are
-the options mentioned above.
-
-Configuration options
-~~~~~~~~~~~~~~~~~~~~~
-
-The Nimble storage driver supports these configuration options:
-
-.. config-table::
-   :config-target: Nimble
-
-   cinder.volume.drivers.nimble
-
-Multipathing
-~~~~~~~~~~~~
-In OpenStack environments where Cinder block device multipathing is desired
-there are a few things to consider.
-
-Configuring mulitpathing varies by system depending on the environment. In a
-scenario where solely Nimble devices are being created by Cinder, the
-following ``/etc/multipath.conf`` file may be used:
-
-.. code-block:: text
-
-   defaults {
-       user_friendly_names yes
-       find_multipaths     no
-   }
-
-   blacklist {
-       devnode "^(ram|raw|loop|fd|md|dm-|sr|scd|st)[0-9]*"
-       devnode "^hd[a-z]"
-       device {
-           vendor  ".*"
-           product ".*"
-       }
-   }
-
-   blacklist_exceptions {
-       device {
-           vendor  "Nimble"
-           product "Server"
-       }
-   }
-
-   devices {
-       device {
-           vendor               "Nimble"
-           product              "Server"
-           path_grouping_policy group_by_prio
-           prio                 "alua"
-           hardware_handler     "1 alua"
-           path_selector        "service-time 0"
-           path_checker         tur
-           features             "1 queue_if_no_path"
-           no_path_retry        30
-           failback             immediate
-           fast_io_fail_tmo     5
-           dev_loss_tmo         infinity
-           rr_min_io_rq         1
-           rr_weight            uniform
-       }
-   }
-
-After making changes to ``/etc/multipath.conf``, the multipath subsystem needs
-to be reconfigured:
-
-.. code-block:: console
-
-   # multipathd reconfigure
-
-.. tip::
-
-   The latest best practices for Nimble devices can be found in the HPE Nimble
-   Storage Linux Integration Guide found on https://infosight.hpe.com
-
-.. important::
-
-   OpenStack Cinder is currently not compatible with the HPE Nimble Storage
-   Linux Toolkit (NLT)
-
-Nova needs to be configured to pickup the actual multipath device created on
-the host.
-
-In ``/etc/nova/nova.conf``, add the following to the ``[libvirt]`` section:
-
-.. code-block:: ini
-
-   [libvirt]
-   volume_use_multipath = True
-
-.. note::
-   In versions prior to Newton, the option was called ``iscsi_use_multipath``
-
-After editing the Nova configuration file, the ``nova-conductor`` service
-needs to be restarted.
-
-.. tip::
-   Depending on which particular OpenStack distribution is being used, Nova
-   may use a different configuration file than the default.
-
-To validate that instances get properly connected to the multipath device,
-inspect the instance devices:
-
-.. code-block:: console
-
-   # virsh dumpxml <Instance ID | Instance Name | Instance UUID>
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/drivers/oracle-zfssa-iscsi-driver.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/oracle-zfssa-iscsi-driver.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/drivers/oracle-zfssa-iscsi-driver.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/oracle-zfssa-iscsi-driver.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,269 +0,0 @@
-=========================================
-Oracle ZFS Storage Appliance iSCSI driver
-=========================================
-
-Oracle ZFS Storage Appliances (ZFSSAs) provide advanced software to
-protect data, speed tuning and troubleshooting, and deliver high
-performance and high availability. Through the Oracle ZFSSA iSCSI
-Driver, OpenStack Block Storage can use an Oracle ZFSSA as a block
-storage resource. The driver enables you to create iSCSI volumes that an
-OpenStack Block Storage server can allocate to any virtual machine
-running on a compute host.
-
-Requirements
-~~~~~~~~~~~~
-
-The Oracle ZFSSA iSCSI Driver, version ``1.0.0`` and later, supports
-ZFSSA software release ``2013.1.2.0`` and later.
-
-Supported operations
-~~~~~~~~~~~~~~~~~~~~
-
-- Create, delete, attach, detach, manage, and unmanage volumes.
-- Create and delete snapshots.
-- Create volume from snapshot.
-- Extend a volume.
-- Attach and detach volumes.
-- Get volume stats.
-- Clone volumes.
-- Migrate a volume.
-- Local cache of a bootable volume.
-
-Configuration
-~~~~~~~~~~~~~
-
-#. Enable RESTful service on the ZFSSA Storage Appliance.
-
-#. Create a new user on the appliance with the following authorizations:
-
-   .. code-block:: bash
-
-      scope=stmf - allow_configure=true
-      scope=nas - allow_clone=true, allow_createProject=true, allow_createShare=true, allow_changeSpaceProps=true, allow_changeGeneralProps=true, allow_destroy=true, allow_rename=true, allow_rollback=true, allow_takeSnap=true
-      scope=schema - allow_modify=true
-
-   You can create a role with authorizations as follows:
-
-   .. code-block:: console
-
-      zfssa:> configuration roles
-      zfssa:configuration roles> role OpenStackRole
-      zfssa:configuration roles OpenStackRole (uncommitted)> set description="OpenStack Cinder Driver"
-      zfssa:configuration roles OpenStackRole (uncommitted)> commit
-      zfssa:configuration roles> select OpenStackRole
-      zfssa:configuration roles OpenStackRole> authorizations create
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set scope=stmf
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_configure=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> commit
-      zfssa:configuration roles OpenStackRole> authorizations create
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set scope=nas
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_clone=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_createProject=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_createShare=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_changeSpaceProps=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_changeGeneralProps=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_destroy=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_rename=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_rollback=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_takeSnap=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> commit
-
-   You can create a user with a specific role as follows:
-
-   .. code-block:: console
-
-      zfssa:> configuration users
-      zfssa:configuration users> user cinder
-      zfssa:configuration users cinder (uncommitted)> set fullname="OpenStack Cinder Driver"
-      zfssa:configuration users cinder (uncommitted)> set initial_password=12345
-      zfssa:configuration users cinder (uncommitted)> commit
-      zfssa:configuration users> select cinder set roles=OpenStackRole
-
-   .. note::
-
-      You can also run this `workflow
-      <https://openstackci.oracle.com/openstack_docs/zfssa_cinder_workflow.akwf>`__
-      to automate the above tasks.
-      Refer to `Oracle documentation
-      <https://docs.oracle.com/cd/E37831_01/html/E52872/godgw.html>`__
-      on how to download, view, and execute a workflow.
-
-#. Ensure that the ZFSSA iSCSI service is online. If the ZFSSA iSCSI service is
-   not online, enable the service by using the BUI, CLI or REST API in the
-   appliance.
-
-   .. code-block:: console
-
-      zfssa:> configuration services iscsi
-      zfssa:configuration services iscsi> enable
-      zfssa:configuration services iscsi> show
-      Properties:
-      <status>= online
-      ...
-
-   Define the following required properties in the ``cinder.conf`` file:
-
-   .. code-block:: ini
-
-      volume_driver = cinder.volume.drivers.zfssa.zfssaiscsi.ZFSSAISCSIDriver
-      san_ip = myhost
-      san_login = username
-      san_password = password
-      zfssa_pool = mypool
-      zfssa_project = myproject
-      zfssa_initiator_group = default
-      zfssa_target_portal = w.x.y.z:3260
-      zfssa_target_interfaces = e1000g0
-
-   Optionally, you can define additional properties.
-
-   Target interfaces can be seen as follows in the CLI:
-
-   .. code-block:: console
-
-      zfssa:> configuration net interfaces
-      zfssa:configuration net interfaces> show
-      Interfaces:
-      INTERFACE STATE CLASS LINKS    ADDRS          LABEL
-      e1000g0   up    ip    e1000g0  1.10.20.30/24  Untitled Interface
-      ...
-
-   .. note::
-
-      Do not use management interfaces for ``zfssa_target_interfaces``.
-
-#. Configure the cluster:
-
-   If a cluster is used as the cinder storage resource, the following
-   verifications are required on your Oracle ZFS Storage Appliance:
-
-   - Verify that both the pool and the network interface are of type
-     singleton and are not locked to the current controller. This
-     approach ensures that the pool and the interface used for data
-     always belong to the active controller, regardless of the current
-     state of the cluster.
-
-   - Verify that the management IP, data IP and storage pool belong to
-     the same head.
-
-   .. note::
-
-      Most configuration settings, including service properties, users, roles,
-      and iSCSI initiator definitions are replicated on both heads
-      automatically. If the driver modifies any of these settings, they will be
-      modified automatically on both heads.
-
-   .. note::
-
-      A short service interruption occurs during failback or takeover,
-      but once the process is complete, the ``cinder-volume`` service should be able
-      to access the pool through the data IP.
-
-ZFSSA assisted volume migration
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-The ZFSSA iSCSI driver supports storage assisted volume migration
-starting in the Liberty release. This feature uses remote replication
-feature on the ZFSSA. Volumes can be migrated between two backends
-configured not only to the same ZFSSA but also between two separate
-ZFSSAs altogether.
-
-The following conditions must be met in order to use ZFSSA assisted
-volume migration:
-
-- Both the source and target backends are configured to ZFSSAs.
-
-- Remote replication service on the source and target appliance is enabled.
-
-- The ZFSSA to which the target backend is configured should be configured as a
-  target in the remote replication service of the ZFSSA configured to the
-  source backend. The remote replication target needs to be configured even
-  when the source and the destination for volume migration are the same ZFSSA.
-  Define ``zfssa_replication_ip`` in the ``cinder.conf`` file of the source
-  backend as the IP address used to register the target ZFSSA in the remote
-  replication service of the source ZFSSA.
-
-- The name of the iSCSI target group(``zfssa_target_group``) on the source and
-  the destination ZFSSA is the same.
-
-- The volume is not attached and is in available state.
-
-If any of the above conditions are not met, the driver will proceed with
-generic volume migration.
-
-The ZFSSA user on the source and target appliances will need to have
-additional role authorizations for assisted volume migration to work. In
-scope nas, set ``allow_rrtarget`` and ``allow_rrsource`` to ``true``.
-
-.. code-block:: console
-
-   zfssa:configuration roles OpenStackRole auth (uncommitted)> set scope=nas
-   zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_rrtarget=true
-   zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_rrsource=true
-
-ZFSSA local cache
-~~~~~~~~~~~~~~~~~
-
-The local cache feature enables ZFSSA drivers to serve the usage of bootable
-volumes significantly better. With the feature, the first bootable volume
-created from an image is cached, so that subsequent volumes can be created
-directly from the cache, instead of having image data transferred over the
-network multiple times.
-
-The following conditions must be met in order to use ZFSSA local cache feature:
-
-- A storage pool needs to be configured.
-
-- REST and iSCSI services need to be turned on.
-
-- On an OpenStack controller, ``cinder.conf`` needs to contain necessary
-  properties used to configure and set up the ZFSSA iSCSI driver, including the
-  following new properties:
-
-  - ``zfssa_enable_local_cache``: (True/False) To enable/disable the feature.
-
-  - ``zfssa_cache_project``: The ZFSSA project name where cache volumes are
-    stored.
-
-Every cache volume has two additional properties stored as ZFSSA custom
-schema. It is important that the schema are not altered outside of Block
-Storage when the driver is in use:
-
-- ``image_id``: stores the image id as in Image service.
-
-- ``updated_at``: stores the most current timestamp when the image is updated
-  in Image service.
-
-Supported extra specs
-~~~~~~~~~~~~~~~~~~~~~
-
-Extra specs provide the OpenStack storage admin the flexibility to create
-volumes with different characteristics from the ones specified in the
-``cinder.conf`` file. The admin will specify the volume properties as keys
-at volume type creation. When a user requests a volume of this volume type,
-the volume will be created with the properties specified as extra specs.
-
-The following extra specs scoped keys are supported by the driver:
-
--  ``zfssa:volblocksize``
-
--  ``zfssa:sparse``
-
--  ``zfssa:compression``
-
--  ``zfssa:logbias``
-
-Volume types can be created using the :command:`openstack volume type create`
-command.
-Extra spec keys can be added using :command:`openstack volume type set`
-command.
-
-Driver options
-~~~~~~~~~~~~~~
-
-The Oracle ZFSSA iSCSI Driver supports these options:
-
-.. config-table::
-   :config-target: ZFS Storage Appliance iSCSI
-
-   cinder.volume.drivers.zfssa.zfssaiscsi
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/drivers/oracle-zfssa-nfs-driver.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/oracle-zfssa-nfs-driver.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/drivers/oracle-zfssa-nfs-driver.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/oracle-zfssa-nfs-driver.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,300 +0,0 @@
-=======================================
-Oracle ZFS Storage Appliance NFS driver
-=======================================
-
-The Oracle ZFS Storage Appliance (ZFSSA) NFS driver enables the ZFSSA to
-be used seamlessly as a block storage resource. The driver enables you
-to create volumes on a ZFS share that is NFS mounted.
-
-Requirements
-~~~~~~~~~~~~
-
-Oracle ZFS Storage Appliance Software version ``2013.1.2.0`` or later.
-
-Supported operations
-~~~~~~~~~~~~~~~~~~~~
-
-- Create, delete, attach, detach, manage, and unmanage volumes.
-
-- Create and delete snapshots.
-
-- Create a volume from a snapshot.
-
-- Extend a volume.
-
-- Copy an image to a volume.
-
-- Copy a volume to an image.
-
-- Clone a volume.
-
-- Volume migration.
-
-- Local cache of a bootable volume
-
-Appliance configuration
-~~~~~~~~~~~~~~~~~~~~~~~
-
-Appliance configuration using the command-line interface (CLI) is
-described below. To access the CLI, ensure SSH remote access is enabled,
-which is the default. You can also perform configuration using the
-browser user interface (BUI) or the RESTful API. Please refer to the
-`Oracle ZFS Storage Appliance
-documentation <http://www.oracle.com/technetwork/documentation/oracle-unified-ss-193371.html>`__
-for details on how to configure the Oracle ZFS Storage Appliance using
-the BUI, CLI, and RESTful API.
-
-#. Log in to the Oracle ZFS Storage Appliance CLI and enable the REST
-   service. REST service needs to stay online for this driver to function.
-
-   .. code-block:: console
-
-      zfssa:>configuration services rest enable
-
-#. Create a new storage pool on the appliance if you do not want to use an
-   existing one. This storage pool is named ``'mypool'`` for the sake of this
-   documentation.
-
-#. Create a new project and share in the storage pool (``mypool``) if you do
-   not want to use existing ones. This driver will create a project and share
-   by the names specified in the ``cinder.conf`` file, if a project and share
-   by that name does not already exist in the storage pool (``mypool``).
-   The project and share are named ``NFSProject`` and ``nfs_share``' in the
-   sample ``cinder.conf`` file as entries below.
-
-#. To perform driver operations, create a role with the following
-   authorizations:
-
-   .. code-block:: bash
-
-      scope=svc - allow_administer=true, allow_restart=true, allow_configure=true
-      scope=nas - pool=pool_name, project=project_name, share=share_name, allow_clone=true, allow_createProject=true, allow_createShare=true, allow_changeSpaceProps=true, allow_changeGeneralProps=true, allow_destroy=true, allow_rollback=true, allow_takeSnap=true, allow_changeAccessProps=true, allow_changeProtocolProps=true
-
-   The following examples show how to create a role with authorizations.
-
-   .. code-block:: console
-
-      zfssa:> configuration roles
-      zfssa:configuration roles> role OpenStackRole
-      zfssa:configuration roles OpenStackRole (uncommitted)> set description="OpenStack NFS Cinder Driver"
-      zfssa:configuration roles OpenStackRole (uncommitted)> commit
-      zfssa:configuration roles> select OpenStackRole
-      zfssa:configuration roles OpenStackRole> authorizations create
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set scope=svc
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_administer=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_restart=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_configure=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> commit
-
-
-   .. code-block:: console
-
-      zfssa:> configuration roles OpenStackRole authorizations> set scope=nas
-
-   The following properties need to be set when the scope of this role needs to
-   be limited to a pool (``mypool``), a project (``NFSProject``) and a share
-   (``nfs_share``) created in the steps above. This will prevent the user
-   assigned to this role from being used to modify other pools, projects and
-   shares.
-
-   .. code-block:: console
-
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set pool=mypool
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set project=NFSProject
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set share=nfs_share
-
-#. The following properties only need to be set when a share and project has
-   not been created following the steps above and wish to allow the driver to
-   create them for you.
-
-   .. code-block:: console
-
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_createProject=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_createShare=true
-
-   .. code-block:: console
-
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_clone=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_changeSpaceProps=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_destroy=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_rollback=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_takeSnap=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_changeAccessProps=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> set allow_changeProtocolProps=true
-      zfssa:configuration roles OpenStackRole auth (uncommitted)> commit
-
-#. Create a new user or modify an existing one and assign the new role to
-   the user.
-
-   The following example shows how to create a new user and assign the new
-   role to the user.
-
-   .. code-block:: console
-
-      zfssa:> configuration users
-      zfssa:configuration users> user cinder
-      zfssa:configuration users cinder (uncommitted)> set fullname="OpenStack Cinder Driver"
-      zfssa:configuration users cinder (uncommitted)> set initial_password=12345
-      zfssa:configuration users cinder (uncommitted)> commit
-      zfssa:configuration users> select cinder set roles=OpenStackRole
-
-#. Ensure that NFS and HTTP services on the appliance are online. Note the
-   HTTPS port number for later entry in the cinder service configuration file
-   (``cinder.conf``). This driver uses WebDAV over HTTPS to create snapshots
-   and clones of volumes, and therefore needs to have the HTTP service online.
-
-   The following example illustrates enabling the services and showing their
-   properties.
-
-   .. code-block:: console
-
-      zfssa:> configuration services nfs
-      zfssa:configuration services nfs> enable
-      zfssa:configuration services nfs> show
-      Properties:
-      <status>= online
-      ...
-
-   .. code-block:: console
-
-      zfssa:configuration services http> enable
-      zfssa:configuration services http> show
-      Properties:
-      <status>= online
-      require_login = true
-      protocols = http/https
-      listen_port = 80
-      https_port = 443
-
-   .. note::
-
-      You can also run this `workflow
-      <https://openstackci.oracle.com/openstack_docs/zfssa_cinder_workflow.akwf>`__
-      to automate the above tasks.
-      Refer to `Oracle documentation
-      <https://docs.oracle.com/cd/E37831_01/html/E52872/godgw.html>`__
-      on how to download, view, and execute a workflow.
-
-#. Create a network interface to be used exclusively for data. An existing
-   network interface may also be used. The following example illustrates how to
-   make a network interface for data traffic flow only.
-
-   .. note::
-
-      For better performance and reliability, it is recommended to configure a
-      separate subnet exclusively for data traffic in your cloud environment.
-
-   .. code-block:: console
-
-      zfssa:> configuration net interfaces
-      zfssa:configuration net interfaces> select igbx
-      zfssa:configuration net interfaces igbx> set admin=false
-      zfssa:configuration net interfaces igbx> commit
-
-#. For clustered controller systems, the following verification is required in
-   addition to the above steps. Skip this step if a standalone system is used.
-
-   .. code-block:: console
-
-      zfssa:> configuration cluster resources list
-
-   Verify that both the newly created pool and the network interface are of
-   type ``singleton`` and are not locked to the current controller.  This
-   approach ensures that the pool and the interface used for data always belong
-   to the active controller, regardless of the current state of the cluster.
-   Verify that both the network interface used for management and data, and the
-   storage pool belong to the same head.
-
-   .. note::
-
-      There will be a short service interruption during failback/takeover, but
-      once the process is complete, the driver should be able to access the
-      ZFSSA for data as well as for management.
-
-Cinder service configuration
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-#. Define the following required properties in the ``cinder.conf``
-   configuration file:
-
-   .. code-block:: ini
-
-      volume_driver = cinder.volume.drivers.zfssa.zfssanfs.ZFSSANFSDriver
-      san_ip = myhost
-      san_login = username
-      san_password = password
-      zfssa_data_ip = mydata
-      zfssa_nfs_pool = mypool
-
-   .. note::
-
-      Management interface ``san_ip`` can be used instead of ``zfssa_data_ip``,
-      but it is not recommended.
-
-#. You can also define the following additional properties in the
-   ``cinder.conf`` configuration file:
-
-   .. code:: ini
-
-       zfssa_nfs_project = NFSProject
-       zfssa_nfs_share = nfs_share
-       zfssa_nfs_mount_options =
-       zfssa_nfs_share_compression = off
-       zfssa_nfs_share_logbias = latency
-       zfssa_https_port = 443
-
-   .. note::
-
-      The driver does not use the file specified in the ``nfs_shares_config``
-      option.
-
-ZFSSA local cache
-~~~~~~~~~~~~~~~~~
-
-The local cache feature enables ZFSSA drivers to serve the usage of
-bootable volumes significantly better. With the feature, the first
-bootable volume created from an image is cached, so that subsequent
-volumes can be created directly from the cache, instead of having image
-data transferred over the network multiple times.
-
-The following conditions must be met in order to use ZFSSA local cache
-feature:
-
--  A storage pool needs to be configured.
-
--  REST and NFS services need to be turned on.
-
--  On an OpenStack controller, ``cinder.conf`` needs to contain
-   necessary properties used to configure and set up the ZFSSA NFS
-   driver, including the following new properties:
-
-   zfssa_enable_local_cache
-        (True/False) To enable/disable the feature.
-
-   zfssa_cache_directory
-        The directory name inside zfssa_nfs_share where cache volumes
-        are stored.
-
-Every cache volume has two additional properties stored as WebDAV
-properties. It is important that they are not altered outside of Block
-Storage when the driver is in use:
-
-image_id
-  stores the image id as in Image service.
-
-updated_at
-  stores the most current timestamp when the image is
-  updated in Image service.
-
-Driver options
-~~~~~~~~~~~~~~
-
-The Oracle ZFS Storage Appliance NFS driver supports these options:
-
-.. config-table::
-   :config-target: ZFS Storage Appliance NFS
-
-   cinder.volume.drivers.zfssa.zfssanfs
-
-This driver shares additional NFS configuration options with the generic
-NFS driver. For a description of these, see :ref:`cinder-storage_nfs`.
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/drivers/prophetstor-dpl-driver.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/prophetstor-dpl-driver.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/drivers/prophetstor-dpl-driver.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/prophetstor-dpl-driver.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,104 +0,0 @@
-===========================================
-ProphetStor Fibre Channel and iSCSI drivers
-===========================================
-
-ProhetStor Fibre Channel and iSCSI drivers add support for
-ProphetStor Flexvisor through the Block Storage service.
-ProphetStor Flexvisor enables commodity x86 hardware as software-defined
-storage leveraging well-proven ZFS for disk management to provide
-enterprise grade storage services such as snapshots, data protection
-with different RAID levels, replication, and deduplication.
-
-The ``DPLFCDriver`` and ``DPLISCSIDriver`` drivers run volume operations
-by communicating with the ProphetStor storage system over HTTPS.
-
-Supported operations
-~~~~~~~~~~~~~~~~~~~~
-
-* Create, delete, attach, and detach volumes.
-
-* Create, list, and delete volume snapshots.
-
-* Create a volume from a snapshot.
-
-* Copy an image to a volume.
-
-* Copy a volume to an image.
-
-* Clone a volume.
-
-* Extend a volume.
-
-Enable the Fibre Channel or iSCSI drivers
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-The ``DPLFCDriver`` and ``DPLISCSIDriver`` are installed with the OpenStack
-software.
-
-#. Query storage pool id to configure ``dpl_pool`` of the ``cinder.conf``
-   file.
-
-   a. Log on to the storage system with administrator access.
-
-      .. code-block:: console
-
-         $ ssh root@STORAGE_IP_ADDRESS
-
-   b. View the current usable pool id.
-
-      .. code-block:: console
-
-         $ flvcli show pool list
-         - d5bd40b58ea84e9da09dcf25a01fdc07 : default_pool_dc07
-
-   c. Use ``d5bd40b58ea84e9da09dcf25a01fdc07`` to configure the ``dpl_pool`` of
-      ``/etc/cinder/cinder.conf`` file.
-
-      .. note::
-
-         Other management commands can be referenced with the help command
-         :command:`flvcli -h`.
-
-#. Make the following changes on the volume node ``/etc/cinder/cinder.conf``
-   file.
-
-   .. code-block:: ini
-
-      # IP address of SAN controller (string value)
-      san_ip=STORAGE IP ADDRESS
-
-      # Username for SAN controller (string value)
-      san_login=USERNAME
-
-      # Password for SAN controller (string value)
-      san_password=PASSWORD
-
-      # Use thin provisioning for SAN volumes? (boolean value)
-      san_thin_provision=true
-
-      # The port that the iSCSI daemon is listening on. (integer value)
-      iscsi_port=3260
-
-      # DPL pool uuid in which DPL volumes are stored. (string value)
-      dpl_pool=d5bd40b58ea84e9da09dcf25a01fdc07
-
-      # DPL port number. (integer value)
-      dpl_port=8357
-
-      # Uncomment one of the next two option to enable Fibre channel or iSCSI
-      # FIBRE CHANNEL(uncomment the next line to enable the FC driver)
-      #volume_driver=cinder.volume.drivers.prophetstor.dpl_fc.DPLFCDriver
-      # iSCSI (uncomment the next line to enable the iSCSI driver)
-      #volume_driver=cinder.volume.drivers.prophetstor.dpl_iscsi.DPLISCSIDriver
-
-#. Save the changes to the ``/etc/cinder/cinder.conf`` file and
-   restart the ``cinder-volume`` service.
-
-The ProphetStor Fibre Channel or iSCSI drivers are now enabled on your
-OpenStack system. If you experience problems, review the Block Storage
-service log files for errors.
-
-The following table contains the options supported by the ProphetStor
-storage driver.
-
-.. include:: ../../tables/cinder-prophetstor_dpl.inc
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/drivers/sheepdog-driver.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/sheepdog-driver.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/drivers/sheepdog-driver.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/sheepdog-driver.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,51 +0,0 @@
-===============
-Sheepdog driver
-===============
-
-Sheepdog is an open-source distributed storage system that provides a
-virtual storage pool utilizing internal disk of commodity servers.
-
-Sheepdog scales to several hundred nodes, and has powerful virtual disk
-management features like snapshotting, cloning, rollback, and thin
-provisioning.
-
-More information can be found on `Sheepdog
-Project <http://sheepdog.github.io/sheepdog/>`__.
-
-This driver enables the use of Sheepdog through Qemu/KVM.
-
-Supported operations
-~~~~~~~~~~~~~~~~~~~~
-
-Sheepdog driver supports these operations:
-
-- Create, delete, attach, and detach volumes.
-
-- Create, list, and delete volume snapshots.
-
-- Create a volume from a snapshot.
-
-- Copy an image to a volume.
-
-- Copy a volume to an image.
-
-- Clone a volume.
-
-- Extend a volume.
-
-Configuration
-~~~~~~~~~~~~~
-
-Set the following option in the ``cinder.conf`` file:
-
-.. code-block:: ini
-
-   volume_driver = cinder.volume.drivers.sheepdog.SheepdogDriver
-
-The following table contains the configuration options supported by the
-Sheepdog driver:
-
-.. config-table::
-   :config-target: Sheepdog
-
-   cinder.volume.drivers.sheepdog
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/drivers/spdk-volume-driver.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/spdk-volume-driver.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/drivers/spdk-volume-driver.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/spdk-volume-driver.rst	2020-03-24 18:46:31.000000000 +0000
@@ -15,7 +15,8 @@ SPDK NVMe-oF target installation
 --------------------------------
 
 Follow instructions available on https://spdk.io/doc/nvmf.html to install
-and configure environment with SPDK NVMe-oF target application.
+and configure environment with SPDK NVMe-oF target application. Starting
+from Ussuri release SPDK release v19.10 or higher is required.
 
 Storage pools configuration
 ---------------------------
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/drivers/veritas-access-iscsi-driver.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/veritas-access-iscsi-driver.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/drivers/veritas-access-iscsi-driver.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/veritas-access-iscsi-driver.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,91 +0,0 @@
-===========================
-Veritas ACCESS iSCSI driver
-===========================
-
-Veritas Access is a software-defined scale-out network-attached
-storage (NAS) solution for unstructured data that works on commodity
-hardware and takes advantage of placing data on premise or in the
-cloud based on intelligent policies. Through Veritas Access iSCSI
-Driver, OpenStack Block Storage can use Veritas Access backend as a
-block storage resource. The driver enables you to create iSCSI volumes
-that an OpenStack Block Storage server can allocate to any virtual machine
-running on a compute host.
-
-Requirements
-~~~~~~~~~~~~
-
-The Veritas ACCESS iSCSI Driver, version ``1.0.0`` and later, supports
-Veritas ACCESS release ``7.4`` and later.
-
-Supported operations
-~~~~~~~~~~~~~~~~~~~~
-
-- Create and delete volumes.
-- Create and delete snapshots.
-- Create volume from snapshot.
-- Extend a volume.
-- Attach and detach volumes.
-- Clone volumes.
-
-Configuration
-~~~~~~~~~~~~~
-
-#. Enable RESTful service on the Veritas Access Backend.
-
-#. Create Veritas Access iSCSI target, add store and portal IP to it.
-
-   You can create target and add portal IP, store to it as follows:
-
-   .. code-block:: console
-
-      Target> iscsi target create iqn.2018-02.com.veritas:target02
-      Target> iscsi target store add target_fs iqn.2018-02.com.veritas:target02
-      Target> iscsi target portal add iqn.2018-02.com.veritas:target02 10.10.10.1
-      ...
-
-   You can add authentication to target as follows:
-
-   .. code-block:: console
-
-      Target> iscsi target auth incominguser add iqn.2018-02.com.veritas:target02 user1
-      ...
-
-#. Ensure that the Veritas Access iSCSI target service is online. If the
-   Veritas Access
-   iSCSI target service is not online, enable the service by using the CLI or
-   REST API.
-
-   .. code-block:: console
-
-      Target> iscsi service start
-      Target> iscsi service status
-      ...
-
-   Define the following required properties in the ``cinder.conf`` file:
-
-   .. code-block:: ini
-
-      volume_driver = cinder.volume.drivers.veritas_access.veritas_iscsi.ACCESSIscsiDriver
-      san_ip = va_console_ip
-      san_api_port = 14161
-      san_login = master
-      san_password = password
-      target_port = 3260
-      vrts_lun_sparse = True
-      vrts_target_config = /etc/cinder/vrts_target.xml
-
-#. Define Veritas Access Target details in ``/etc/cinder/vrts_target.xml``:
-
-   .. code-block:: console
-
-      <?xml version="1.0" ?>
-      <VRTS>
-           <VrtsTargets>
-                <Target>
-                        <Name>iqn.2018-02.com.veritas:target02</Name>
-                        <PortalIP>10.10.10.1</PortalIP>
-                        <Authentication>0</Authentication>
-                </Target>
-           </VrtsTargets>
-      </VRTS>
-      ...
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/drivers/vzstorage-driver.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/vzstorage-driver.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/drivers/vzstorage-driver.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/drivers/vzstorage-driver.rst	1970-01-01 00:00:00.000000000 +0000
@@ -1,17 +0,0 @@
-========================
-Virtuozzo Storage driver
-========================
-
-The Virtuozzo Storage driver is a fault-tolerant distributed storage
-system that is optimized for virtualization workloads.
-Set the following in your ``cinder.conf`` file, and use the following
-options to configure it.
-
-.. code-block:: ini
-
-   volume_driver = cinder.volume.drivers.vzstorage.VZStorageDriver
-
-.. config-table::
-   :config-target: Virtuozzo Storage
-
-   cinder.volume.drivers.vzstorage
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/fc-zoning.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/fc-zoning.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/fc-zoning.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/fc-zoning.rst	2020-03-24 18:46:31.000000000 +0000
@@ -50,6 +50,12 @@ Brocade Fibre Channel Zone Driver
 Brocade Fibre Channel Zone Driver performs zoning operations
 through HTTP, HTTPS, or SSH.
 
+.. warning::
+
+   The Brocade Fibre Channel Zone Driver is no longer supported. It is subject
+   to removal during the "V" development cycle, following the standard
+   OpenStack deprecation policy.
+
 Set the following options in the ``cinder.conf`` configuration file under the
 ``[fc-zone-manager]`` section.
 
diff -pruN 2:15.0.1-1/doc/source/configuration/block-storage/policy-config-HOWTO.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/policy-config-HOWTO.rst
--- 2:15.0.1-1/doc/source/configuration/block-storage/policy-config-HOWTO.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/block-storage/policy-config-HOWTO.rst	2020-03-24 18:46:31.000000000 +0000
@@ -383,7 +383,7 @@ Immediately following it, introduce a ne
      <admin-stuff> or <project-stuff>
 
    To construct the strict version, we need to make sure that the
-   ``not cinder:reader-admin`` part applies only the the left-hand side (the
+   ``not cinder:reader-admin`` part applies only the left-hand side (the
    <admin-stuff>).  The easiest way to do that is to structure the new rule as
    follows::
 
Binary files 2:15.0.1-1/doc/source/configuration/figures/bb-cinder-fig1.png and 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/figures/bb-cinder-fig1.png differ
diff -pruN 2:15.0.1-1/doc/source/configuration/README.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/README.rst
--- 2:15.0.1-1/doc/source/configuration/README.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/README.rst	2020-03-24 18:46:31.000000000 +0000
@@ -8,10 +8,12 @@ Introduction:
 This directory is intended to hold any documentation that relates to
 how to configure Cinder.  It is intended that some of this content
 be automatically generated in the future.  At the moment, however, it
-is not.  Changes to configuration options for Cinder or its drivers
-needs to be put under this directory.
+is not.  If you would like to work on this, please use Launchpad Bug
+`#1847600 <https://bugs.launchpad.net/cinder/+bug/1847600>`_ for
+tracking purposes.  Changes to configuration options for Cinder or its
+drivers needs to be put under this directory.
 
 The full spec for organization of documentation may be seen in the
 `OS Manuals Migration Spec
-<https://specs.openstack.org/openstack/docs-specs/specs/pike/os-manuals-migration.html>`.
+<https://specs.openstack.org/openstack/docs-specs/specs/pike/os-manuals-migration.html>`_.
 
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-fusionio.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-fusionio.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-fusionio.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-fusionio.inc	1970-01-01 00:00:00.000000000 +0000
@@ -1,48 +0,0 @@
-
-Volume driver configuration
-~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-This section describes how to configure the FusionStorage Volume Driver.
-
-To configure the volume driver, follow the steps below:
-
-#. Configure the ``cinder.conf`` file.
-
-   In the ``[default]`` block of ``/etc/cinder/cinder.conf``,
-   enable the ``VOLUME_BACKEND``:
-
-   .. code-block:: ini
-
-      enabled_backends = VOLUME_BACKEND
-
-   Add a new block ``[VOLUME_BACKEND]``, and add the following contents:
-
-   .. code-block:: ini
-
-    [VOLUME_BACKEND]
-    volume_driver = cinder.volume.drivers.fusionstorage.dsware.DSWAREDriver
-    volume_backend_name = backend_name
-    manager_ips =
-        host1:ip1,
-        host2:ip2
-    storage =
-        UserName: username,
-        Password: password,
-        RestURL: url,
-        StoragePool: pool0;pool1;pool2
-
-   * ``volume_driver`` indicates the loaded driver.
-
-   * ``volume_backend_name`` indicates the name of the backend.
-
-   * ``manager_ips`` indicates the management host name and its corresponding IP address;
-   The parameters takes the standard dict config form, such as
-   manager_ips = host1:ip1, host2:ip2.
-
-   * ``storage``  indicates the FusionStorage and user info, include "UserName",
-   "Password", "RestURL", "StoragePool". The parameters takes the standard
-   dict config form.
-
-#. Run the :command:`service cinder-volume restart` command to restart the
-   Block Storage service.
-
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-ibm_gpfs.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-ibm_gpfs.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-ibm_gpfs.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-ibm_gpfs.inc	2020-03-24 18:46:31.000000000 +0000
@@ -1,13 +1,3 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
 .. _cinder-ibm_gpfs:
 
 .. list-table:: Description of Spectrum Scale volume driver configuration options
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-ibm_gpfs_nfs.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-ibm_gpfs_nfs.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-ibm_gpfs_nfs.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-ibm_gpfs_nfs.inc	2020-03-24 18:46:31.000000000 +0000
@@ -1,13 +1,3 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
 .. _cinder-ibm_gpfs_nfs:
 
 .. list-table:: Description of Spectrum Scale NFS volume driver configuration options
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-ibm_gpfs_remote.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-ibm_gpfs_remote.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-ibm_gpfs_remote.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-ibm_gpfs_remote.inc	2020-03-24 18:46:31.000000000 +0000
@@ -1,13 +1,3 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
 .. _cinder-ibm_gpfs_remote:
 
 .. list-table:: Description of Spectrum Scale Remote volume driver configuration options
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-ibm_storage.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-ibm_storage.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-ibm_storage.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-ibm_storage.inc	2020-03-24 18:46:31.000000000 +0000
@@ -1,13 +1,3 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
 .. _cinder-ibm_storage:
 
 .. list-table:: Description of IBM Storage driver configuration options
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-infortrend.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-infortrend.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-infortrend.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-infortrend.inc	2020-03-24 18:46:31.000000000 +0000
@@ -1,13 +1,3 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
 .. _cinder-infortrend:
 
 .. list-table:: Description of Infortrend volume driver configuration options
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-netapp_cdot_iscsi.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-netapp_cdot_iscsi.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-netapp_cdot_iscsi.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-netapp_cdot_iscsi.inc	2020-03-24 18:46:31.000000000 +0000
@@ -1,13 +1,3 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
 .. _cinder-netapp_cdot_iscsi:
 
 .. list-table:: Description of NetApp cDOT iSCSI driver configuration options
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-netapp_cdot_nfs.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-netapp_cdot_nfs.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-netapp_cdot_nfs.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-netapp_cdot_nfs.inc	2020-03-24 18:46:31.000000000 +0000
@@ -1,13 +1,3 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
 .. _cinder-netapp_cdot_nfs:
 
 .. list-table:: Description of NetApp cDOT NFS driver configuration options
@@ -24,8 +14,6 @@
      - (String) This option specifies the path of the NetApp copy offload tool binary. Ensure that the binary has execute permissions set which allow the effective user of the cinder-volume process to execute the file.
    * - ``netapp_host_type`` = ``None``
      - (String) This option defines the type of operating system for all initiators that can access a LUN. This information is used when mapping LUNs to individual hosts or groups of hosts.
-   * - ``netapp_host_type`` = ``None``
-     - (String) This option defines the type of operating system for all initiators that can access a LUN. This information is used when mapping LUNs to individual hosts or groups of hosts.
    * - ``netapp_login`` = ``None``
      - (String) Administrative user account name used to access the storage system or proxy server.
    * - ``netapp_lun_ostype`` = ``None``
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-nexenta5.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-nexenta5.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-nexenta5.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-nexenta5.inc	2020-03-24 18:46:31.000000000 +0000
@@ -1,13 +1,3 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
 .. _cinder-nexenta5:
 
 .. list-table:: Description of NexentaStor 5 driver configuration options
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-nexenta.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-nexenta.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-nexenta.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-nexenta.inc	2020-03-24 18:46:31.000000000 +0000
@@ -1,13 +1,3 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
 .. _cinder-nexenta:
 
 .. list-table:: Description of Nexenta driver configuration options
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-osbrick.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-osbrick.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-osbrick.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-osbrick.inc	1970-01-01 00:00:00.000000000 +0000
@@ -1,28 +0,0 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
-.. _cinder-osbrick:
-
-.. list-table:: Description of os-brick configuration options
-   :header-rows: 1
-   :class: config-ref-table
-
-   * - Configuration option = Default value
-     - Description
-   * - **[privsep_osbrick]**
-     -
-   * - ``capabilities`` = ``[]``
-     - (Unknown) List of Linux capabilities retained by the privsep daemon.
-   * - ``group`` = ``None``
-     - (String) Group that the privsep daemon should run as.
-   * - ``helper_command`` = ``None``
-     - (String) Command to invoke to start the privsep daemon if not using the "fork" method. If not specified, a default is generated using "sudo privsep-helper" and arguments designed to recreate the current configuration. This command must accept suitable --privsep_context and --privsep_sock_path arguments.
-   * - ``user`` = ``None``
-     - (String) User that the privsep daemon should run as.
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-prophetstor_dpl.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-prophetstor_dpl.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-prophetstor_dpl.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-prophetstor_dpl.inc	2020-03-24 18:46:31.000000000 +0000
@@ -1,13 +1,3 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
 .. _cinder-prophetstor_dpl:
 
 .. list-table:: Description of ProphetStor Fibre Channel and iSCSi drivers configuration options
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-scheduler.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-scheduler.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-scheduler.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-scheduler.inc	1970-01-01 00:00:00.000000000 +0000
@@ -1,40 +0,0 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
-.. _cinder-scheduler:
-
-.. list-table:: Description of scheduler configuration options
-   :header-rows: 1
-   :class: config-ref-table
-
-   * - Configuration option = Default value
-     - Description
-   * - **[DEFAULT]**
-     -
-   * - ``filter_function`` = ``None``
-     - (String) String representation for an equation that will be used to filter hosts. Only used when the driver filter is set to be used by the Cinder scheduler.
-   * - ``goodness_function`` = ``None``
-     - (String) String representation for an equation that will be used to determine the goodness of a host. Only used when using the goodness weigher is set to be used by the Cinder scheduler.
-   * - ``scheduler_default_filters`` = ``AvailabilityZoneFilter, CapacityFilter, CapabilitiesFilter``
-     - (List) Which filter class names to use for filtering hosts when not specified in the request.
-   * - ``scheduler_default_weighers`` = ``CapacityWeigher``
-     - (List) Which weigher class names to use for weighing hosts.
-   * - ``scheduler_driver`` = ``cinder.scheduler.filter_scheduler.FilterScheduler``
-     - (String) Default scheduler driver to use
-   * - ``scheduler_host_manager`` = ``cinder.scheduler.host_manager.HostManager``
-     - (String) The scheduler host manager class to use
-   * - ``scheduler_json_config_location`` =
-     - (String) Absolute path to scheduler configuration JSON file.
-   * - ``scheduler_manager`` = ``cinder.scheduler.manager.SchedulerManager``
-     - (String) Full class name for the Manager for scheduler
-   * - ``scheduler_max_attempts`` = ``3``
-     - (Integer) Maximum number of attempts to schedule a volume
-   * - ``scheduler_weight_handler`` = ``cinder.scheduler.weights.OrderedHostWeightHandler``
-     - (String) Which handler to use for selecting the host/pool after weighing
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-storage_gpfs.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-storage_gpfs.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-storage_gpfs.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-storage_gpfs.inc	1970-01-01 00:00:00.000000000 +0000
@@ -1,42 +0,0 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
-.. _cinder-storage_gpfs:
-
-.. list-table:: Description of GPFS storage configuration options
-   :header-rows: 1
-   :class: config-ref-table
-
-   * - Configuration option = Default value
-     - Description
-   * - **[DEFAULT]**
-     -
-   * - ``gpfs_images_dir`` = ``None``
-     - (String) Specifies the path of the Image service repository in GPFS. Leave undefined if not storing images in GPFS.
-   * - ``gpfs_images_share_mode`` = ``None``
-     - (String) Specifies the type of image copy to be used. Set this when the Image service repository also uses GPFS so that image files can be transferred efficiently from the Image service to the Block Storage service. There are two valid values: "copy" specifies that a full copy of the image is made; "copy_on_write" specifies that copy-on-write optimization strategy is used and unmodified blocks of the image file are shared efficiently.
-   * - ``gpfs_max_clone_depth`` = ``0``
-     - (Integer) Specifies an upper limit on the number of indirections required to reach a specific block due to snapshots or clones. A lengthy chain of copy-on-write snapshots or clones can have a negative impact on performance, but improves space utilization. 0 indicates unlimited clone depth.
-   * - ``gpfs_mount_point_base`` = ``None``
-     - (String) Specifies the path of the GPFS directory where Block Storage volume and snapshot files are stored.
-   * - ``gpfs_sparse_volumes`` = ``True``
-     - (Boolean) Specifies that volumes are created as sparse files which initially consume no space. If set to False, the volume is created as a fully allocated file, in which case, creation may take a significantly longer time.
-   * - ``gpfs_storage_pool`` = ``system``
-     - (String) Specifies the storage pool that volumes are assigned to. By default, the system storage pool is used.
-   * - ``nas_host`` =
-     - (String) IP address or Hostname of NAS system.
-   * - ``nas_login`` = ``admin``
-     - (String) User name to connect to NAS system.
-   * - ``nas_password`` =
-     - (String) Password to connect to NAS system.
-   * - ``nas_private_key`` =
-     - (String) Filename of private key to use for SSH authentication.
-   * - ``nas_ssh_port`` = ``22``
-     - (Port number) SSH port to use to connect to NAS system.
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-storage.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-storage.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-storage.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-storage.inc	1970-01-01 00:00:00.000000000 +0000
@@ -1,80 +0,0 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
-.. _cinder-storage:
-
-.. list-table:: Description of storage configuration options
-   :header-rows: 1
-   :class: config-ref-table
-
-   * - Configuration option = Default value
-     - Description
-   * - **[DEFAULT]**
-     -
-   * - ``allocated_capacity_weight_multiplier`` = ``-1.0``
-     - (Floating point) Multiplier used for weighing allocated capacity. Positive numbers mean to stack vs spread.
-   * - ``capacity_weight_multiplier`` = ``1.0``
-     - (Floating point) Multiplier used for weighing free capacity. Negative numbers mean to stack vs spread.
-   * - ``enabled_backends`` = ``None``
-     - (List) A list of backend names to use. These backend names should be backed by a unique [CONFIG] group with its options
-   * - ``target_helper`` = ``tgtadm``
-     - (String) iSCSI target user-land tool to use. tgtadm is default, use lioadm for LIO iSCSI support, scstadmin for SCST target support, ietadm for iSCSI Enterprise Target, iscsictl for Chelsio iSCSI Target or fake for testing.
-   * - ``iscsi_iotype`` = ``fileio``
-     - (String) Sets the behavior of the iSCSI target to either perform blockio or fileio optionally, auto can be set and Cinder will autodetect type of backing device
-   * - ``target_ip_address`` = ``$my_ip``
-     - (String) The IP address that the iSCSI daemon is listening on
-   * - ``target_port`` = ``3260``
-     - (Port number) The port that the iSCSI daemon is listening on
-   * - ``target_protocol`` = ``iscsi``
-     - (String) Determines the iSCSI protocol for new iSCSI volumes, created with tgtadm or lioadm target helpers. In order to enable RDMA, this parameter should be set with the value "iser". The supported iSCSI protocol values are "iscsi" and "iser".
-   * - ``iscsi_target_flags`` =
-     - (String) Sets the target-specific flags for the iSCSI target. Only used for tgtadm to specify backing device flags using bsoflags option. The specified string is passed as is to the underlying tool.
-   * - ``target_prefix`` = ``iqn.2010-10.org.openstack:``
-     - (String) Prefix for iSCSI volumes
-   * - ``iscsi_write_cache`` = ``on``
-     - (String) Sets the behavior of the iSCSI target to either perform write-back(on) or write-through(off). This parameter is valid if target_helper is set to tgtadm.
-   * - ``iser_helper`` = ``tgtadm``
-     - (String) The name of the iSER target user-land tool to use
-   * - ``iser_ip_address`` = ``$my_ip``
-     - (String) The IP address that the iSER daemon is listening on
-   * - ``iser_port`` = ``3260``
-     - (Port number) The port that the iSER daemon is listening on
-   * - ``iser_target_prefix`` = ``iqn.2010-10.org.openstack:``
-     - (String) Prefix for iSER volumes
-   * - ``migration_create_volume_timeout_secs`` = ``300``
-     - (Integer) Timeout for creating the volume to migrate to when performing volume migration (seconds)
-   * - ``num_iser_scan_tries`` = ``3``
-     - (Integer) The maximum number of times to rescan iSER targetto find volume
-   * - ``num_volume_device_scan_tries`` = ``3``
-     - (Integer) The maximum number of times to rescan targets to find volume
-   * - ``volume_backend_name`` = ``None``
-     - (String) The backend name for a given driver implementation
-   * - ``volume_clear`` = ``zero``
-     - (String) Method used to wipe old volumes. This option can either be set in section [backend_defaults] (to apply to all enabled_backends) or directly in the backend specific section to apply for just this one backend.
-   * - ``volume_clear_ionice`` = ``None``
-     - (String) The flag to pass to ionice to alter the i/o priority of the process used to zero a volume after deletion, for example "-c3" for idle only priority. This option can either be set in section [backend_defaults] (to apply to all enabled_backends) or directly in the backend specific section to apply for just this one backend.
-   * - ``volume_clear_size`` = ``0``
-     - (Integer) Size in MiB to wipe at start of old volumes. 1024 MiBat max. 0 => all. This option can either be set in section [backend_defaults] (to apply to all enabled_backends) or directly in the backend specific section to apply for just this one backend.
-   * - ``volume_copy_blkio_cgroup_name`` = ``cinder-volume-copy``
-     - (String) The blkio cgroup name to be used to limit bandwidth of volume copy
-   * - ``volume_copy_bps_limit`` = ``0``
-     - (Integer) The upper limit of bandwidth of volume copy. 0 => unlimited
-   * - ``volume_dd_blocksize`` = ``1M``
-     - (String) The default block size used when copying/clearing volumes
-   * - ``volume_driver`` = ``cinder.volume.drivers.lvm.LVMVolumeDriver``
-     - (String) Driver to use for volume creation
-   * - ``volume_manager`` = ``cinder.volume.manager.VolumeManager``
-     - (String) Full class name for the Manager for volume
-   * - ``volume_service_inithost_offload`` = ``False``
-     - (Boolean) Offload pending volume delete during volume service startup
-   * - ``volume_usage_audit_period`` = ``month``
-     - (String) Time period for which to generate volume usages. The options are hour, day, month, or year.
-   * - ``volumes_dir`` = ``$state_path/volumes``
-     - (String) Volume configuration file storage directory
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-storwize.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-storwize.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-storwize.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-storwize.inc	2020-03-24 18:46:31.000000000 +0000
@@ -1,13 +1,3 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
 .. _cinder-storwize:
 
 .. list-table:: Description of IBM Storwise driver configuration options
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-swift.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-swift.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-swift.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-swift.inc	1970-01-01 00:00:00.000000000 +0000
@@ -1,24 +0,0 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
-.. _cinder-swift:
-
-.. list-table:: Description of swift configuration options
-   :header-rows: 1
-   :class: config-ref-table
-
-   * - Configuration option = Default value
-     - Description
-   * - **[DEFAULT]**
-     -
-   * - ``backup_swift_auth_insecure`` = ``False``
-     - (Boolean) Bypass verification of server certificate when making SSL connection to Swift.
-   * - ``backup_swift_auth_url`` = ``None``
-     - (URI) The URL of the Keystone endpoint
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-vmware.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-vmware.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-vmware.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-vmware.inc	2020-03-24 18:46:31.000000000 +0000
@@ -1,13 +1,3 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
 .. _cinder-vmware:
 
 .. list-table:: Description of VMware configuration options
diff -pruN 2:15.0.1-1/doc/source/configuration/tables/cinder-windows.inc 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-windows.inc
--- 2:15.0.1-1/doc/source/configuration/tables/cinder-windows.inc	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/configuration/tables/cinder-windows.inc	1970-01-01 00:00:00.000000000 +0000
@@ -1,22 +0,0 @@
-..
-    Warning: Do not edit this file. It is automatically generated from the
-    software project's code and your changes will be overwritten.
-
-    The tool to generate this file lives in openstack-doc-tools repository.
-
-    Please make any changes needed in the code, then run the
-    autogenerate-config-doc tool from the openstack-doc-tools repository, or
-    ask for help on the documentation mailing list, IRC channel or meeting.
-
-.. _cinder-windows:
-
-.. list-table:: Description of Windows configuration options
-   :header-rows: 1
-   :class: config-ref-table
-
-   * - Configuration option = Default value
-     - Description
-   * - **[DEFAULT]**
-     -
-   * - ``windows_iscsi_lun_path`` = ``C:\iSCSIVirtualDisks``
-     - (String) Path to store VHD backed volumes
diff -pruN 2:15.0.1-1/doc/source/contributor/architecture.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/contributor/architecture.rst
--- 2:15.0.1-1/doc/source/contributor/architecture.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/contributor/architecture.rst	2020-03-24 18:46:31.000000000 +0000
@@ -31,23 +31,12 @@ Components
 
 Below you will find a brief explanation of the different components.
 
-::
-
-                                                  /- ( LDAP )
-                              [ Auth Manager ] ---
-                                     |            \- ( DB )
-                                     |
-                                     |
-                    cinderclient     |
-                   /             \   |                   /- [ scheduler ] -- [ volume ] -- ( iSCSI )
- [ Web Dashboard ]-               -[ api ] -- < AMQP > --
-                   \             /   |                   \- [ backup ]
-                    novaclient       |
-                                     |
-                                     |
-                                     |
-                                  < REST >
+.. figure:: ../images/architecture.png
+   :alt: Cinder architecture
+   :align: center
+   :width: 110%
 
+..
 
 * DB: sql database for data storage. Used by all components (LINKS NOT SHOWN).
 * Web Dashboard: potential external component that talks to the api.
diff -pruN 2:15.0.1-1/doc/source/contributor/contributing.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/contributor/contributing.rst
--- 2:15.0.1-1/doc/source/contributor/contributing.rst	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/contributor/contributing.rst	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,252 @@
+============================
+So You Want to Contribute...
+============================
+
+For general information on contributing to OpenStack, please check out the
+`contributor guide <https://docs.openstack.org/contributors/>`_ to get started.
+It covers all the basics that are common to all OpenStack projects: the
+accounts you need, the basics of interacting with our Gerrit review system, how
+we communicate as a community, etc.
+
+Below will cover the more project specific information you need to get started
+with the Cinder project, which is responsible for the following OpenStack
+deliverables:
+
+cinder
+    | The OpenStack Block Storage service.
+    | code: https://opendev.org/openstack/cinder
+    | docs: https://cinder.openstack.org
+    | api-ref: https://docs.openstack.org/api-ref/block-storage
+    | Launchpad: https://launchpad.net/cinder
+
+os-brick
+    | Shared library for managing local volume attaches.
+    | code: https://opendev.org/openstack/os-brick
+    | docs: https://docs.openstack.org/os-brick
+    | Launchpad: https://launchpad.net/os-brick
+
+python-cinderclient
+    | Python client library for the OpenStack Block Storage API; includes
+      a CLI shell.
+    | code: https://opendev.org/openstack/python-cinderclient
+    | docs: https://docs.openstack.org/python-cinderclient
+    | Launchpad: https://launchpad.net/python-cinderclient
+
+python-brick-cinderclient-ext
+    | Extends the python-cinderclient library so that it can handle local
+      volume attaches.
+    | code: https://opendev.org/openstack/python-brick-cinderclient-ext
+    | docs: https://docs.openstack.org/python-brick-cinderclient-ext
+    | Launchpad: (doesn't have its own space, uses python-cinderclient's)
+
+cinderlib
+    | Library that allows direct usage of Cinder backend drivers without
+      cinder services.
+    | code: https://opendev.org/openstack/cinderlib
+    | docs: https://docs.openstack.org/cinderlib
+    | Launchpad: https://launchpad.net/cinderlib
+
+cinder-tempest-plugin
+    | Contains additional Cinder tempest-based tests beyond those in the
+      main OpenStack Integration Test Suite (tempest).
+    | code: https://opendev.org/openstack/cinder-tempest-plugin
+    | Launchpad: https://launchpad.net/cinder-tempest-plugin
+
+See the ``CONTRIBUTING.rst`` file in each code repository for more
+information about contributing to that specific deliverable.  Additionally,
+you should look over the docs links above; most components have helpful
+developer information specific to that deliverable.  (The main cinder
+documentation is especially thorough in this regard and you should read
+through it, particularly :ref:`background-concepts` and
+:ref:`programming-howtos`.)
+
+Communication
+~~~~~~~~~~~~~
+
+IRC
+    People working on the Cinder project may be found in the
+    ``#openstack-cinder`` channel on Freenode during working hours
+    in their timezone.  The channel is logged, so if you ask a question
+    when no one is around, you can check the log to see if it's been
+    answered: http://eavesdrop.openstack.org/irclogs/%23openstack-cinder/
+
+weekly meeting
+    Wednesdays at 14:00 UTC in ``#openstack-meeting-alt`` on Freenode.
+    Meetings are logged: http://eavesdrop.openstack.org/meetings/cinder/
+
+    More information (including a link to the Agenda, some pointers on
+    meeting etiquette, and an ICS file to put the meeting on your calendar)
+    can be found at: http://eavesdrop.openstack.org/#Cinder_Team_Meeting
+
+mailing list
+    We use the openstack-discuss@lists.openstack.org mailing list for
+    asynchronous discussions or to communicate with other OpenStack teams.
+    Use the prefix ``[cinder]`` in your subject line (it's a high-volume
+    list, so most people use email filters).
+
+    More information about the mailing list, including how to subscribe
+    and read the archives, can be found at:
+    http://lists.openstack.org/cgi-bin/mailman/listinfo/openstack-discuss
+
+virtual meet-ups
+    From time to time, the Cinder project will have video meetings to
+    address topics not easily covered by the above methods.  These are
+    announced well in advance at the weekly meeting and on the mailing
+    list.
+
+physical meet-ups
+    The Cinder project usually has a presence at the OpenDev/OpenStack
+    Project Team Gathering that takes place at the beginning of each
+    development cycle.  Planning happens on an etherpad whose URL is
+    announced at the weekly meetings and on the mailing list.
+
+Contacting the Core Team
+~~~~~~~~~~~~~~~~~~~~~~~~
+
+The cinder-core team is an active group of contributors who are responsible
+for directing and maintaining the Cinder project.  As a new contributor, your
+interaction with this group will be mostly through code reviews, because
+only members of cinder-core can approve a code change to be merged into the
+code repository.
+
+.. note::
+   Although your contribution will require reviews by members of
+   cinder-core, these aren't the only people whose reviews matter.
+   Anyone with a gerrit account can post reviews, so you can ask
+   other developers you know to review your code ... and you can
+   review theirs.  (A good way to learn your way around the codebase
+   is to review other people's patches.)
+
+   If you're thinking, "I'm new at this, how can I possibly provide
+   a helpful review?", take a look at `How to Review Changes the
+   OpenStack Way
+   <https://docs.openstack.org/project-team-guide/review-the-openstack-way.html>`_.
+
+   There are also some Cinder project specific reviewing guidelines
+   in the :ref:`reviewing-cinder` section of the Cinder Contributor Guide.
+
+You can learn more about the role of core reviewers in the OpenStack
+governance documentation:
+https://docs.openstack.org/contributors/common/governance.html#core-reviewer
+
+The membership list of cinder-core is maintained in gerrit:
+https://review.opendev.org/#/admin/groups/83,members
+
+You can also find the members of the cinder-core team at the Cinder weekly
+meetings.
+
+
+New Feature Planning
+~~~~~~~~~~~~~~~~~~~~
+
+The Cinder project uses both "specs" and "blueprints" to track new features.
+Here's a quick rundown of what they are and how the Cinder project uses them.
+
+specs
+    | Exist in the cinder-specs repository.
+      Each spec must have a Launchpad blueprint (see below) associated with
+      it for tracking purposes.
+
+    | A spec is required for any new Cinder core feature, anything that
+      changes the Block Storage API, or anything that entails a mass change
+      to existing drivers.
+
+    | The specs repository is: https://opendev.org/openstack/cinder-specs
+    | It contains a ``README.rst`` file explaining how to file a spec.
+
+    | You can read rendered specs docs at:
+    | https://specs.openstack.org/openstack/cinder-specs/
+
+blueprints
+    | Exist in Launchpad, where they can be targeted to release milestones.
+    | You file one at https://blueprints.launchpad.net/cinder
+
+    | Examples of changes that can be covered by a blueprint only are:
+
+    * adding a new volume, backup, or target driver; or
+    * adding support for a defined capability that already exists in the
+      base volume, backup, or target drivers
+
+Feel free to ask in ``#openstack-cinder`` or at the weekly meeting if you
+have an idea you want to develop and you're not sure whether it requires
+a blueprint *and* a spec or simply a blueprint.
+
+The Cinder project observes the following deadlines.  For the current
+development cycle, the dates of each (and a more detailed description)
+may be found on the release schedule, which you can find from:
+https://releases.openstack.org/
+
+* spec freeze (all specs must be approved by this date)
+* new driver merge deadline
+* new target driver merge deadline
+* new feature status checkpoint
+* third-party CI compliance checkpoint
+
+Additionally, the Cinder project observes the OpenStack-wide deadlines,
+for example, final release of non-client libraries (os-brick), final
+release for client libraries (python-cinderclient), feature freeze,
+etc.  These are also noted and explained on the release schedule for the
+current development cycle.
+
+Task Tracking
+~~~~~~~~~~~~~
+
+We track our tasks in Launchpad.  See the top of the page for the URL of each
+Cinder project deliverable.
+
+If you're looking for some smaller, easier work item to pick up and get started
+on, search for the 'low-hanging-fruit' tag in the Bugs section.
+
+When you start working on a bug, make sure you assign it to yourself.
+Otherwise someone else may also start working on it, and we don't want to
+duplicate efforts.  Also, if you find a bug in the code and want to post a
+fix, make sure you file a bug (and assign it to yourself!) just in case someone
+else comes across the problem in the meantime.
+
+Reporting a Bug
+~~~~~~~~~~~~~~~
+
+You found an issue and want to make sure we are aware of it? You can do so in
+the Launchpad space for the affected deliverable:
+
+* cinder: https://bugs.launchpad.net/cinder
+* os-brick: https://bugs.launchpad.net/os-brick
+* python-cinderclient: https://bugs.launchpad.net/python-cinderclient
+* python-brick-cinderclient-ext: same as for python-cinderclient, but tag
+  the bug with 'brick-cinderclient-ext'
+* cinderlib: https://bugs.launchpad.net/cinderlib
+* cinder-tempest-plugin: https://bugs.launchpad.net/cinder-tempest-plugin
+
+Getting Your Patch Merged
+~~~~~~~~~~~~~~~~~~~~~~~~~
+
+The Cinder project policy is that a patch must have two +2s before it can
+be merged.  (Exceptions are documentation changes, which require only a
+single +2, and specs, for which the PTL may require more than two +2s,
+depending on the complexity of the proposal.)
+
+Patches lacking unit tests are unlikely to be approved.  Check out the
+:ref:`testing-cinder` section of the Cinder Contributors Guide for a
+discussion of the kinds of testing we do with cinder.
+
+In addition, some changes may require a release note.  Any patch that
+changes functionality, adds functionality, or addresses a significant
+bug should have a release note.  You can find more information about
+how to write a release note in the :ref:`release-notes` section of the
+Cinder Contributors Guide.
+
+Keep in mind that the best way to make sure your patches are reviewed in
+a timely manner is to review other people's patches.  We're engaged in a
+cooperative enterprise here.
+
+You can see who's been doing what with Cinder recently in Stackalytics:
+https://www.stackalytics.com/report/activity?module=cinder-group
+
+Project Team Lead Duties
+~~~~~~~~~~~~~~~~~~~~~~~~
+
+All common PTL duties are enumerated in the `PTL guide
+<https://docs.openstack.org/project-team-guide/ptl.html>`_.
+
+Additional responsibilities for the Cinder PTL can be found by reading through
+the :ref:`managing-development` section of the Cinder documentation.
diff -pruN 2:15.0.1-1/doc/source/contributor/development.environment.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/contributor/development.environment.rst
--- 2:15.0.1-1/doc/source/contributor/development.environment.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/contributor/development.environment.rst	2020-03-24 18:46:31.000000000 +0000
@@ -120,8 +120,7 @@ so the only package you install is ``tox
 
 Run the unit tests by doing::
 
-    tox -e py35
-    tox -e py27
+    tox -e py3
 
 See :doc:`testing` for more details.
 
@@ -132,22 +131,14 @@ Manually installing and using the virtua
 
 You can also manually install the virtual environment::
 
-  tox -e py27 --notest
-
-or::
-
-  tox -e py35 --notest
+  tox -e py3 --notest
 
 This will install all of the Python packages listed in the
 ``requirements.txt`` file into your virtualenv.
 
 To activate the Cinder virtualenv you can run::
 
-     $ source .tox/py27/bin/activate
-
-or::
-
-     $ source .tox/py35/bin/activate
+     $ source .tox/py3/bin/activate
 
 To exit your virtualenv, just type::
 
diff -pruN 2:15.0.1-1/doc/source/contributor/gerrit.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/contributor/gerrit.rst
--- 2:15.0.1-1/doc/source/contributor/gerrit.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/contributor/gerrit.rst	2020-03-24 18:46:31.000000000 +0000
@@ -1,3 +1,5 @@
+.. _reviewing-cinder:
+
 Code Reviews
 ============
 
@@ -9,7 +11,7 @@ Gerrit
 ------
 
 Cinder uses the `Gerrit`_ tool to review proposed code changes. The review
-site is https://review.openstack.org
+site is https://review.opendev.org
 
 Gerrit is a complete replacement for Github pull requests. `All Github pull
 requests to the Cinder repository will be ignored`.
@@ -19,6 +21,44 @@ See `Getting Started`_ for information o
 See `Development Workflow`_ for more detailed information on how to work with
 Gerrit.
 
+The Great Change
+----------------
+
+With the demise of Python 2.7 in January 2020, beginning with the Ussuri
+development cycle, Cinder only needs to support Python 3 runtimes (in
+particular, 3.6 and 3.7).  Thus we can begin to incorporate Python 3
+language features and remove Python 2 compatibility code.  At the same
+time, however, we are still supporting stable branches that must support
+Python 2.  Our biggest interaction with the stable branches is backporting
+bugfixes, where in the ideal case, we're just doing a simple cherry-pick of
+a commit from master to the stable branches.  You can see that there's some
+tension here.
+
+With that in mind, here are some guidelines for reviewers and developers
+that the Cinder community has agreed on during this phase where we want to
+write pure Python 3 but still must support Python 2 code.
+
+.. _transition-guidelines:
+
+Python 2 to Python 3 transition guidelines
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+* We need to be checking the code coverage of test cases very carefully so
+  that new code has excellent coverage.  The idea is that we want these
+  tests to fail when a backport is proposed to a stable branch and the
+  tests are run under Python 2 (if the code is using any Python-3-only
+  language features).
+* New features can use Python-3-only language constructs, but bugfixes
+  likely to be backported should be more conservative and write for
+  Python 2 compatibilty.
+* The code for drivers may continue to use the six compatibility library at
+  their discretion.
+* We will not remove six from mainline Cinder code that impacts the drivers
+  (for example, classes they inherit from).
+* We can remove six from code that doesn't impact drivers, keeping in mind
+  that backports may be more problematic, and hence making sure that we have
+  really good test coverage.
+
 Targeting Milestones
 --------------------
 
@@ -88,7 +128,7 @@ to the submitter with a request for the
    does not include a unit test execution.
 
 .. _Review guidelines: https://docs.openstack.org/doc-contrib-guide/docs-review-guidelines.html
-.. _Gerrit: https://review.openstack.org/#/q/project:openstack/cinder+status:open
+.. _Gerrit: https://review.opendev.org/#/q/project:openstack/cinder+status:open
 .. _Quick Reference: https://docs.openstack.org/infra/manual/developers.html#quick-reference
 .. _Getting Started: https://docs.openstack.org/infra/manual/developers.html#getting-started
 .. _Development Workflow: https://docs.openstack.org/infra/manual/developers.html#development-workflow
diff -pruN 2:15.0.1-1/doc/source/contributor/index.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/contributor/index.rst
--- 2:15.0.1-1/doc/source/contributor/index.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/contributor/index.rst	2020-03-24 18:46:31.000000000 +0000
@@ -23,6 +23,15 @@ Content includes architectural overviews
 development environment, and information on Cinder's lower level programming
 APIs.
 
+Getting Started
+---------------
+.. toctree::
+    :maxdepth: 2
+
+    contributing
+
+.. _programming-howtos:
+
 Programming HowTos and Tutorials
 --------------------------------
 .. toctree::
@@ -43,6 +52,8 @@ Programming HowTos and Tutorials
     rolling.upgrades
     groups
 
+.. _managing-development:
+
 Managing the Development Cycle
 ------------------------------
 .. toctree::
@@ -57,6 +68,8 @@ Documentation Contribution
 
    documentation
 
+.. _background-concepts:
+
 Background Concepts for Cinder
 ------------------------------
 .. toctree::
diff -pruN 2:15.0.1-1/doc/source/contributor/releasenotes.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/contributor/releasenotes.rst
--- 2:15.0.1-1/doc/source/contributor/releasenotes.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/contributor/releasenotes.rst	2020-03-24 18:46:31.000000000 +0000
@@ -14,6 +14,8 @@
       License for the specific language governing permissions and limitations
       under the License.
 
+.. _release-notes:
+
 Release notes
 =============
 
diff -pruN 2:15.0.1-1/doc/source/contributor/rolling.upgrades.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/contributor/rolling.upgrades.rst
--- 2:15.0.1-1/doc/source/contributor/rolling.upgrades.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/contributor/rolling.upgrades.rst	2020-03-24 18:46:31.000000000 +0000
@@ -436,11 +436,10 @@ to return either a `uc.Result` where the
 * FAILURE, <Failure explanation>
 * WARNING, <Warning explanation>
 
-Your new function should should then be added to the `_upgrade_checks`
-tuple. For your check give the name of the Upgrade Check to be displayed
-to end users upon success or failure as well as the name of the
-function used to implement your check. Upgrade Checks should be submitted
-with Unit Tests.
+Your new function should then be added to the `_upgrade_checks` tuple.
+For your check give the name of the Upgrade Check to be displayed to end
+users upon success or failure as well as the name of the function used to
+implement your check. Upgrade Checks should be submitted with Unit Tests.
 
 The `doc/source/cli/cinder-status.rst` documentation should be updated to
 indicate the release for which your Upgrade Check was released and to
diff -pruN 2:15.0.1-1/doc/source/contributor/testing.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/contributor/testing.rst
--- 2:15.0.1-1/doc/source/contributor/testing.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/contributor/testing.rst	2020-03-24 18:46:31.000000000 +0000
@@ -1,3 +1,5 @@
+.. _testing-cinder:
+
 Testing
 =======
 
@@ -57,9 +59,9 @@ This will create a virtual environment,
 test-requirements.txt and run all unit tests as well as run flake8 and hacking
 checks against the code.
 
-You may run individual test targets, for example only py27 tests, by running::
+You may run individual test targets, for example only py37 tests, by running::
 
-    tox -e py27
+    tox -e py37
 
 Note that you can inspect the tox.ini file to get more details on the available
 options and what the test run does by default.
@@ -93,17 +95,17 @@ it's setup in the CI environment.
 Running a subset of tests using tox
 -----------------------------------
 One common activity is to just run a single test, you can do this with tox
-simply by specifying to just run py27 or py35 tests against a single test::
+simply by specifying to just run py37 tests against a single test::
 
-    tox -epy27 -- cinder.tests.unit.volume.test_availability_zone.AvailabilityZoneTestCase.test_list_availability_zones_cached
+    tox -epy37 -- cinder.tests.unit.volume.test_availability_zone.AvailabilityZoneTestCase.test_list_availability_zones_cached
 
 Or all tests in the test_volume.py file::
 
-    tox -epy27 -- cinder.tests.unit.volume.test_volume
+    tox -epy37 -- cinder.tests.unit.volume.test_volume
 
 You may also use regular expressions to run any matching tests::
 
-    tox -epy27 -- test_volume
+    tox -epy37 -- test_volume
 
 For more information on these options and details about stestr, please see the
 `stestr documentation <http://stestr.readthedocs.io/en/latest/MANUAL.html>`_.
@@ -123,44 +125,6 @@ can get around this by manually setting
 Note that you may use any location (not just ``/tmp``!) as long as it is not
 a shared folder.
 
-**Running py35 tests**
-
-You will need to install python3-dev in order to get py35 tests to run. If you
-do not have this, you will get the following::
-
-    netifaces.c:1:20: fatal error: Python.h: No such file or directory
-        #include <Python.h>
-                ^
-        compilation terminated.
-        error: command 'x86_64-linux-gnu-gcc' failed with exit status 1
-
-        ----------------------------------------
-        <snip>
-    ERROR: could not install deps [-r/opt/stack/cinder/test-requirements.txt,
-        oslo.versionedobjects[fixtures]]; v = InvocationError('/opt/stack/cinder/
-        .tox/py35/bin/pip install -r/opt/stack/cinder/test-requirements.txt
-        oslo.versionedobjects[fixtures] (see /opt/stack/cinder/.tox/py35/log/py35-1.log)', 1)
-    _______________________________________________________________ summary _______________________________________________________________
-    ERROR:   py35: could not install deps [-r/opt/stack/cinder/test-requirements.txt,
-        oslo.versionedobjects[fixtures]]; v = InvocationError('/opt/stack/cinder/
-        .tox/py35/bin/pip install -r/opt/stack/cinder/test-requirements.txt
-        oslo.versionedobjects[fixtures] (see /opt/stack/cinder/.tox/py35/log/py35-1.log)', 1)
-
-To Fix:
-
-- On Ubuntu/Debian::
-
-    sudo apt-get install python3-dev
-
-- On Fedora 21/RHEL7/CentOS7::
-
-    sudo yum install python3-devel
-
-- On Fedora 22 and higher::
-
-    sudo dnf install python3-devel
-
-
 **Assertion types in unit tests**
 
 In general, it is best to use the most specific assertion possible in a unit
@@ -239,4 +203,4 @@ Then run the unit test with pdb enabled:
    # Or to get a list of tests to run
 
    stestr list test_volume_utils > tests_to_run.txt
-   stestr run -n --load-list tests_to_run.txt
+   stestr run --load-list tests_to_run.txt
diff -pruN 2:15.0.1-1/doc/source/drivers-all-about.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/drivers-all-about.rst
--- 2:15.0.1-1/doc/source/drivers-all-about.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/drivers-all-about.rst	2020-03-24 18:46:31.000000000 +0000
@@ -103,8 +103,45 @@ option ``enable_unsupported_driver=True`
 section of ``cinder.conf`` or the Cinder service will fail to load.
 
 If the issue is not corrected before the next release, the driver will be
-removed from the Cinder code repository per the standard OpenStack
-deprecation policy.
+eligible for removal from the Cinder code repository per the standard
+OpenStack deprecation policy.
+
+Driver Removal
+--------------
+**(Added January 2020**)
+
+As stated above, an unsupported driver is eligible for removal during the
+development cycle following the release in which it was marked 'unsupported'.
+(For example, a driver marked 'unsupported' in the Ussuri release is eligible
+for removal during the development cycle leading up to the Victoria release.)
+
+During the Ussuri development cycle, the Cinder team decided that drivers
+eligible for removal, at the discretion of the team, may remain in the code
+repository *as long as they continue to pass OpenStack CI testing*. When such a
+driver blocks the CI check or gate, it will be removed immediately.  (This does
+not violate the OpenStack deprecation policy because such a driver's
+deprecation period began when it was marked as 'unsupported'.)
+
+.. note::
+   Why the "at the discretion of the team" qualification?  Some vendors may
+   announce that they have no intention of continuing to support a driver.
+   In that case, the Cinder team reserves the right to remove the driver as
+   soon as the deprecation period has passed.
+
+Thus, unsupported drivers *may* remain in the code repository for multiple
+releases following their declaration as 'unsupported'.  Operators should
+therefore take into account the length of time a driver has been marked
+'unsupported' when deciding to deploy an unsupported driver.  This is because
+as an unmaintained driver ages, updates and bugfixes to libraries and other
+software it depends on may cause the driver to fail unit and functional tests,
+making it subject to immediate removal.
+
+The intent of this policy revision is twofold.  First, it gives vendors a
+longer grace period in which to make the necessary changes to have their
+drivers reinstated as 'supported'.  Second, keeping these drivers in-tree
+longer should make life easier for operators who have deployed storage backends
+with drivers that have been marked as 'unsupported'.  Operators should keep the
+above points in mind, however, when deploying such a driver.
 
 Current Cinder Drivers
 ~~~~~~~~~~~~~~~~~~~~~~
Binary files 2:15.0.1-1/doc/source/images/architecture.png and 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/images/architecture.png differ
diff -pruN 2:15.0.1-1/doc/source/index.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/index.rst
--- 2:15.0.1-1/doc/source/index.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/index.rst	2020-03-24 18:46:31.000000000 +0000
@@ -135,11 +135,6 @@ information needed to get started. This
 Please feel free to also ask any questions in the **#openstack-cinder** IRC
 channel.
 
-Getting started
-~~~~~~~~~~~~~~~
-
-* `OpenStack Contributor Guide <https://docs.openstack.org/contributors/>`_
-
 Contributing to Cinder
 ~~~~~~~~~~~~~~~~~~~~~~
 
@@ -151,8 +146,13 @@ Contents:
    contributor/index
    API Microversions </contributor/api_microversion_dev/>
 
+For reviewers
+-------------
+
+* :ref:`transition-guidelines`
+
 Additional reference
-~~~~~~~~~~~~~~~~~~~~
+--------------------
 
 Contents:
 
@@ -165,7 +165,7 @@ Contents:
 .. only:: html
 
    Indices and tables
-   ~~~~~~~~~~~~~~~~~~
+   ------------------
 
    Contents:
 
diff -pruN 2:15.0.1-1/doc/source/reference/support-matrix.ini 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/reference/support-matrix.ini
--- 2:15.0.1-1/doc/source/reference/support-matrix.ini	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/reference/support-matrix.ini	2020-03-24 18:46:31.000000000 +0000
@@ -24,9 +24,6 @@ title=Dell EMC XtremeIO Storage Driver (
 [driver.dell_emc_powermax]
 title=Dell EMC PowerMax (2000, 8000) Storage Driver (iSCSI, FC)
 
-[driver.dell_emc_ps]
-title=Dell EMC PS Series Storage Driver (iSCSI)
-
 [driver.dell_emc_sc]
 title=Dell EMC SC Series Storage Driver (iSCSI, FC)
 
@@ -79,7 +76,7 @@ title=Huawei F V5 Series Driver (iSCSI,
 title=Huawei 18000 Series Driver (iSCSI, FC)
 
 [driver.huawei_dorado]
-title=Huawei Dorado V3 Series Driver (iSCSI, FC)
+title=Huawei Dorado V3, V6 Series Driver (iSCSI, FC)
 
 [driver.huawei_fusionstorage]
 title=Huawei FusionStorage Driver (dsware)
@@ -106,7 +103,7 @@ title=Infinidat Storage Driver (iSCSI, F
 title=infortrend Storage Driver (iSCSI, FC)
 
 [driver.inspur]
-title=Inspur G2 Storage Driver (iSCSI, FC)
+title=Inspur AS/HF Series Driver (iSCSI, FC)
 
 [driver.inspur_as13000]
 title=Inspur AS13000 Storage Driver (iSCSI)
@@ -141,15 +138,6 @@ title=Nexenta Driver (iSCSI, NFS)
 [driver.nfs]
 title=Generic NFS Reference Driver (NFS)
 
-[driver.nimble]
-title=Nimble Storage Driver (iSCSI)
-
-[driver.prophetstor]
-title=ProphetStor Flexvisor Driver (iSCSI, NFS)
-
-[driver.oracle_zfssa]
-title=Oracle ZFSSA Driver (iSCSI, NFS)
-
 [driver.pure]
 title=Pure Storage Driver (iSCSI, FC)
 
@@ -165,24 +153,15 @@ title=RBD (Ceph) Storage Driver (RBD)
 [driver.seagate]
 title=Seagate Driver (iSCSI, FC)
 
-[driver.sheepdog]
-title=Sheepdog Storage Driver (sheepdog)
-
 [driver.storpool]
 title=StorPool Storage Driver (storpool)
 
 [driver.synology]
 title=Synology Storage Driver (iSCSI)
 
-[driver.vrtsaccess]
-title=Veritas Access iSCSI Driver (iSCSI)
-
 [driver.vrtscnfs]
 title=Veritas Cluster NFS Driver (NFS)
 
-[driver.vzstorage]
-title=Virtuozzo Storage Driver (remotefs)
-
 [driver.vmware]
 title=VMware Storage Driver (vmdk)
 
@@ -207,7 +186,6 @@ notes=A vendor driver is considered supp
   isn't resolved before the end of the subsequent release.
 driver.datera=missing
 driver.dell_emc_powermax=complete
-driver.dell_emc_ps=complete
 driver.dell_emc_sc=complete
 driver.dell_emc_unity=complete
 driver.dell_emc_vmax_af=complete
@@ -227,12 +205,12 @@ driver.huawei_v5=complete
 driver.huawei_f_v5=complete
 driver.huawei_18000=complete
 driver.huawei_dorado=complete
-driver.huawei_fusionstorage=missing
+driver.huawei_fusionstorage=complete
 driver.infinidat=complete
 driver.ibm_ds8k=complete
 driver.ibm_flashsystem=missing
 driver.ibm_gpfs=complete
-driver.ibm_storwize=missing
+driver.ibm_storwize=complete
 driver.ibm_xiv=complete
 driver.infortrend=complete
 driver.inspur=complete
@@ -241,26 +219,20 @@ driver.kaminario=complete
 driver.lenovo=complete
 driver.linbit_linstor=complete
 driver.lvm=complete
-driver.macrosan=complete
+driver.macrosan=missing
 driver.nec=complete
 driver.netapp_ontap=complete
 driver.netapp_solidfire=complete
 driver.nexenta=complete
 driver.nfs=complete
-driver.nimble=missing
-driver.oracle_zfssa=missing
-driver.prophetstor=missing
 driver.pure=complete
 driver.qnap=complete
 driver.quobyte=complete
 driver.rbd=complete
 driver.seagate=complete
-driver.sheepdog=missing
 driver.storpool=complete
 driver.synology=complete
-driver.vrtsaccess=missing
-driver.vrtscnfs=complete
-driver.vzstorage=missing
+driver.vrtscnfs=missing
 driver.vmware=complete
 driver.win_iscsi=complete
 driver.win_smb=complete
@@ -273,7 +245,6 @@ notes=Cinder supports the ability to ext
   an instance, but not all drivers are able to do this.
 driver.datera=complete
 driver.dell_emc_powermax=complete
-driver.dell_emc_ps=complete
 driver.dell_emc_sc=complete
 driver.dell_emc_unity=complete
 driver.dell_emc_vmax_af=complete
@@ -295,7 +266,7 @@ driver.huawei_18000=complete
 driver.huawei_dorado=complete
 driver.huawei_fusionstorage=complete
 driver.infinidat=complete
-driver.ibm_ds8k=missing
+driver.ibm_ds8k=complete
 driver.ibm_flashsystem=complete
 driver.ibm_gpfs=missing
 driver.ibm_storwize=complete
@@ -313,20 +284,14 @@ driver.netapp_ontap=missing
 driver.netapp_solidfire=complete
 driver.nexenta=complete
 driver.nfs=complete
-driver.nimble=complete
-driver.oracle_zfssa=complete
-driver.prophetstor=complete
 driver.pure=complete
 driver.qnap=complete
 driver.quobyte=complete
 driver.rbd=complete
 driver.seagate=complete
-driver.sheepdog=complete
 driver.storpool=complete
 driver.synology=complete
-driver.vrtsaccess=complete
 driver.vrtscnfs=complete
-driver.vzstorage=complete
 driver.vmware=complete
 driver.win_iscsi=complete
 driver.win_smb=complete
@@ -339,7 +304,6 @@ notes=This is the ability to directly at
   instance like a volume.
 driver.datera=missing
 driver.dell_emc_powermax=missing
-driver.dell_emc_ps=missing
 driver.dell_emc_sc=missing
 driver.dell_emc_unity=complete
 driver.dell_emc_vmax_af=missing
@@ -379,20 +343,14 @@ driver.netapp_ontap=missing
 driver.netapp_solidfire=missing
 driver.nexenta=missing
 driver.nfs=missing
-driver.nimble=missing
-driver.oracle_zfssa=missing
-driver.prophetstor=missing
 driver.pure=missing
 driver.qnap=missing
 driver.quobyte=missing
 driver.rbd=missing
 driver.seagate=missing
-driver.sheepdog=missing
 driver.storpool=missing
 driver.synology=missing
-driver.vrtsaccess=missing
 driver.vrtscnfs=missing
-driver.vzstorage=missing
 driver.vmware=missing
 driver.win_iscsi=missing
 driver.win_smb=complete
@@ -408,7 +366,6 @@ notes=Vendor drivers that support Qualit
   utilize frontend QoS via libvirt.
 driver.datera=complete
 driver.dell_emc_powermax=complete
-driver.dell_emc_ps=missing
 driver.dell_emc_sc=complete
 driver.dell_emc_unity=complete
 driver.dell_emc_vmax_af=complete
@@ -448,20 +405,14 @@ driver.netapp_ontap=complete
 driver.netapp_solidfire=complete
 driver.nexenta=missing
 driver.nfs=missing
-driver.nimble=missing
-driver.oracle_zfssa=missing
-driver.prophetstor=missing
 driver.pure=missing
 driver.qnap=missing
 driver.quobyte=missing
 driver.rbd=missing
 driver.seagate=missing
-driver.sheepdog=missing
 driver.storpool=missing
 driver.synology=missing
-driver.vrtsaccess=missing
 driver.vrtscnfs=missing
-driver.vzstorage=missing
 driver.vmware=missing
 driver.win_iscsi=missing
 driver.win_smb=missing
@@ -476,7 +427,6 @@ notes=Vendor drivers that support volume
   to take advantage of Cinder's failover and failback commands.
 driver.datera=missing
 driver.dell_emc_powermax=complete
-driver.dell_emc_ps=missing
 driver.dell_emc_sc=complete
 driver.dell_emc_unity=complete
 driver.dell_emc_vmax_af=complete
@@ -516,20 +466,14 @@ driver.netapp_ontap=complete
 driver.netapp_solidfire=complete
 driver.nexenta=missing
 driver.nfs=missing
-driver.nimble=missing
-driver.oracle_zfssa=missing
-driver.prophetstor=missing
 driver.pure=complete
 driver.qnap=missing
 driver.quobyte=missing
 driver.rbd=complete
 driver.seagate=missing
-driver.sheepdog=missing
 driver.storpool=complete
 driver.synology=missing
-driver.vrtsaccess=missing
 driver.vrtscnfs=missing
-driver.vzstorage=missing
 driver.vmware=missing
 driver.win_iscsi=missing
 driver.win_smb=missing
@@ -545,7 +489,6 @@ notes=Vendor drivers that support consis
   creation of consistent snapshots across a group.
 driver.datera=missing
 driver.dell_emc_powermax=complete
-driver.dell_emc_ps=missing
 driver.dell_emc_sc=complete
 driver.dell_emc_unity=complete
 driver.dell_emc_vmax_af=complete
@@ -585,20 +528,14 @@ driver.netapp_ontap=complete
 driver.netapp_solidfire=complete
 driver.nexenta=missing
 driver.nfs=missing
-driver.nimble=missing
-driver.oracle_zfssa=missing
-driver.prophetstor=complete
 driver.pure=complete
 driver.qnap=missing
 driver.quobyte=missing
 driver.rbd=missing
 driver.seagate=missing
-driver.sheepdog=missing
 driver.storpool=missing
 driver.synology=missing
-driver.vrtsaccess=missing
 driver.vrtscnfs=missing
-driver.vzstorage=missing
 driver.vmware=missing
 driver.win_iscsi=missing
 driver.win_smb=missing
@@ -613,7 +550,6 @@ notes=If a volume driver supports thin p
   'oversubscription'.
 driver.datera=missing
 driver.dell_emc_powermax=complete
-driver.dell_emc_ps=complete
 driver.dell_emc_sc=complete
 driver.dell_emc_unity=complete
 driver.dell_emc_vmax_af=complete
@@ -621,7 +557,7 @@ driver.dell_emc_vmax_3=complete
 driver.dell_emc_vnx=complete
 driver.dell_emc_vxflexos=complete
 driver.dell_emc_xtremio=complete
-driver.fujitsu_eternus=missing
+driver.fujitsu_eternus=complete
 driver.hpe_3par=complete
 driver.hpe_lefthand=complete
 driver.hpe_msa=missing
@@ -653,20 +589,14 @@ driver.netapp_ontap=complete
 driver.netapp_solidfire=complete
 driver.nexenta=missing
 driver.nfs=complete
-driver.nimble=missing
-driver.oracle_zfssa=complete
-driver.prophetstor=missing
 driver.pure=complete
 driver.qnap=missing
 driver.quobyte=missing
 driver.rbd=complete
 driver.seagate=missing
-driver.sheepdog=missing
 driver.storpool=complete
 driver.synology=missing
-driver.vrtsaccess=missing
 driver.vrtscnfs=missing
-driver.vzstorage=missing
 driver.vmware=missing
 driver.win_iscsi=missing
 driver.win_smb=complete
@@ -682,7 +612,6 @@ notes=Storage assisted volume migration
   functionality.
 driver.datera=missing
 driver.dell_emc_powermax=complete
-driver.dell_emc_ps=missing
 driver.dell_emc_sc=missing
 driver.dell_emc_unity=complete
 driver.dell_emc_vmax_af=complete
@@ -722,20 +651,14 @@ driver.netapp_ontap=missing
 driver.netapp_solidfire=missing
 driver.nexenta=missing
 driver.nfs=missing
-driver.nimble=missing
-driver.oracle_zfssa=complete
-driver.prophetstor=missing
 driver.pure=missing
 driver.qnap=missing
 driver.quobyte=missing
 driver.rbd=missing
 driver.seagate=missing
-driver.sheepdog=missing
 driver.storpool=complete
 driver.synology=missing
-driver.vrtsaccess=missing
 driver.vrtscnfs=missing
-driver.vzstorage=missing
 driver.vmware=missing
 driver.win_iscsi=missing
 driver.win_smb=missing
@@ -751,7 +674,6 @@ notes=Vendor drivers that report multi-a
   attach functionality otherwise data corruption may occur.
 driver.datera=missing
 driver.dell_emc_powermax=complete
-driver.dell_emc_ps=missing
 driver.dell_emc_sc=complete
 driver.dell_emc_unity=complete
 driver.dell_emc_vmax_af=complete
@@ -791,20 +713,14 @@ driver.netapp_ontap=complete
 driver.netapp_solidfire=complete
 driver.nexenta=missing
 driver.nfs=missing
-driver.nimble=missing
-driver.oracle_zfssa=complete
-driver.prophetstor=missing
 driver.pure=complete
 driver.qnap=missing
 driver.quobyte=missing
 driver.rbd=complete
 driver.seagate=complete
-driver.sheepdog=missing
 driver.storpool=complete
 driver.synology=missing
-driver.vrtsaccess=missing
 driver.vrtscnfs=missing
-driver.vzstorage=missing
 driver.vmware=missing
 driver.win_iscsi=missing
 driver.win_smb=missing
@@ -817,7 +733,6 @@ notes=Vendor drivers that implement the
   volume to the last snapshot taken.
 driver.datera=missing
 driver.dell_emc_powermax=complete
-driver.dell_emc_ps=missing
 driver.dell_emc_sc=missing
 driver.dell_emc_unity=complete
 driver.dell_emc_vmax_af=complete
@@ -857,20 +772,14 @@ driver.netapp_ontap=missing
 driver.netapp_solidfire=complete
 driver.nexenta=missing
 driver.nfs=missing
-driver.nimble=missing
-driver.oracle_zfssa=missing
-driver.prophetstor=missing
 driver.pure=missing
 driver.qnap=missing
 driver.quobyte=missing
 driver.rbd=missing
 driver.seagate=missing
-driver.sheepdog=missing
 driver.storpool=missing
 driver.synology=missing
-driver.vrtsaccess=missing
 driver.vrtscnfs=missing
-driver.vzstorage=missing
 driver.vmware=complete
 driver.win_iscsi=missing
 driver.win_smb=missing
@@ -887,7 +796,6 @@ notes=Vendor drivers that support runnin
       a configuration.
 driver.datera=missing
 driver.dell_emc_powermax=missing
-driver.dell_emc_ps=missing
 driver.dell_emc_sc=missing
 driver.dell_emc_unity=missing
 driver.dell_emc_vmax_af=missing
@@ -896,7 +804,7 @@ driver.dell_emc_vnx=missing
 driver.dell_emc_vxflexos=missing
 driver.dell_emc_xtremio=missing
 driver.fujitsu_eternus=missing
-driver.hpe_3par=complete
+driver.hpe_3par=missing
 driver.hpe_lefthand=missing
 driver.hpe_msa=missing
 driver.huawei_t_v1=missing
@@ -927,20 +835,14 @@ driver.netapp_ontap=missing
 driver.netapp_solidfire=missing
 driver.nexenta=missing
 driver.nfs=missing
-driver.nimble=missing
-driver.oracle_zfssa=missing
-driver.prophetstor=missing
 driver.pure=missing
 driver.qnap=missing
 driver.quobyte=missing
 driver.rbd=complete
 driver.seagate=missing
-driver.sheepdog=missing
 driver.storpool=missing
 driver.synology=missing
-driver.vrtsaccess=missing
 driver.vrtscnfs=missing
-driver.vzstorage=missing
 driver.vmware=missing
 driver.win_iscsi=missing
 driver.win_smb=missing
diff -pruN 2:15.0.1-1/doc/source/reference/support-matrix.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/reference/support-matrix.rst
--- 2:15.0.1-1/doc/source/reference/support-matrix.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/doc/source/reference/support-matrix.rst	2020-03-24 18:46:31.000000000 +0000
@@ -85,3 +85,11 @@ release.
    * Tintri Storage Driver
    * Veritas HyperScale Storage Driver
    * Nexenta Edge Storage Driver
+
+* Ussuri
+   * Nimble Storage Driver
+   * ProphetStor Flexvisor Driver
+   * Sheepdog Driver
+   * Veritas Access Storage Driver
+   * Virtuozzo Storage Driver
+
diff -pruN 2:15.0.1-1/driver-requirements.txt 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/driver-requirements.txt
--- 2:15.0.1-1/driver-requirements.txt	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/driver-requirements.txt	2020-03-24 18:46:31.000000000 +0000
@@ -23,9 +23,6 @@ pywbem>=0.7.0 # LGPLv2.1+
 # IBM XIV
 pyxcli>=1.1.5 # Apache-2.0
 
-# LINSTOR
-protobuf>=3.6.1 # BSD
-
 # RBD
 rados # LGPLv2.1
 rbd # LGPLv2.1
@@ -42,3 +39,6 @@ infi.dtypes.iqn # PSF
 # Storpool
 storpool>=4.0.0 # Apache-2.0
 storpool.spopenstack>=2.2.1 # Apache-2.0
+
+# Datera
+dfs_sdk>=1.2.25 # Apache-2.0
diff -pruN 2:15.0.1-1/etc/cinder/resource_filters.json 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/etc/cinder/resource_filters.json
--- 2:15.0.1-1/etc/cinder/resource_filters.json	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/etc/cinder/resource_filters.json	2020-03-24 18:46:31.000000000 +0000
@@ -1,7 +1,7 @@
 {
     "volume": ["name", "status", "metadata",
                "bootable", "migration_status", "availability_zone",
-               "group_id", "size"],
+               "group_id", "size", "created_at", "updated_at"],
     "backup": ["name", "status", "volume_id"],
     "snapshot": ["name", "status", "volume_id", "metadata",
                  "availability_zone"],
diff -pruN 2:15.0.1-1/.gitignore 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/.gitignore
--- 2:15.0.1-1/.gitignore	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/.gitignore	1970-01-01 00:00:00.000000000 +0000
@@ -1,44 +0,0 @@
-*.DS_Store
-*.log
-*.mo
-*.pyc
-*.sqlite
-/.*
-!.coveragerc
-!.gitignore
-!.mailmap
-!.testr.conf
-!.stestr.conf
-!.zuul.yaml
-.*.sw?
-AUTHORS
-Authors
-build/*
-build-stamp
-CA/
-ChangeLog
-cinder.egg-info
-cover/*
-covhtml
-dist/*
-etc/cinder/cinder.conf.sample
-etc/cinder/policy.yaml.sample
-instances
-keeper
-keys
-local_settings.py
-tools/lintstack.head.py
-tools/pylint_exceptions
-tags
-# Files created by Sphinx build
-doc/build
-doc/source/_static/cinder.conf.sample
-doc/source/_static/cinder.policy.yaml.sample
-doc/source/drivers.rst
-
-#Files created for API reference
-api-ref/build
-
-# Files created by releasenotes build
-releasenotes/build
-contrib/block-box/.db_data
diff -pruN 2:15.0.1-1/.gitreview 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/.gitreview
--- 2:15.0.1-1/.gitreview	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/.gitreview	1970-01-01 00:00:00.000000000 +0000
@@ -1,5 +0,0 @@
-[gerrit]
-host=review.opendev.org
-port=29418
-project=openstack/cinder.git
-defaultbranch=stable/train
diff -pruN 2:15.0.1-1/HACKING.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/HACKING.rst
--- 2:15.0.1-1/HACKING.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/HACKING.rst	2020-03-24 18:46:31.000000000 +0000
@@ -10,8 +10,6 @@ Cinder Specific Commandments
 - [N314] Check for vi editor configuration in source files.
 - [N322] Ensure default arguments are not mutable.
 - [N323] Add check for explicit import of _() to ensure proper translation.
-- [N325] str() and unicode() cannot be used on an exception. Remove or use
-  six.text_type().
 - [N336] Must use a dict comprehension instead of a dict constructor with a
   sequence of key-value pairs.
 - [C301] timeutils.utcnow() from oslo_utils should be used instead of
diff -pruN 2:15.0.1-1/lower-constraints.txt 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/lower-constraints.txt
--- 2:15.0.1-1/lower-constraints.txt	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/lower-constraints.txt	2020-03-24 18:46:31.000000000 +0000
@@ -26,23 +26,23 @@ docutils==0.14
 dogpile.cache==0.6.5
 dulwich==0.19.0
 enum-compat==0.0.2
-enum34==1.0.4;python_version=='2.7' or python_version=='2.6' or python_version=='3.3' # BSD
 eventlet==0.22.0
 extras==1.0.0
 fasteners==0.14.1
 fixtures==3.0.0
 flake8==2.5.5
+flake8-import-order==0.18.1
+flake8-logging-format==0.6.0
 future==0.16.0
 futurist==1.6.0
 gitdb2==2.0.3
 GitPython==2.1.8
 google-api-python-client==1.4.2
 greenlet==0.4.10
-hacking==1.1.0
+hacking==2.0.0
 httplib2==0.9.1
 idna==2.6
 imagesize==1.0.0
-ipaddress==1.0.17;python_version<'3.3' # PSF
 iso8601==0.1.11
 Jinja2==2.10
 jsonpatch==1.21
@@ -72,7 +72,7 @@ oslo.cache==1.29.0
 oslo.concurrency==3.26.0
 oslo.config==5.2.0
 oslo.context==2.19.2
-oslo.db==4.27.0
+oslo.db==4.35.0
 oslo.i18n==3.15.3
 oslo.log==3.36.0
 oslo.messaging==6.4.0
@@ -85,17 +85,16 @@ oslo.serialization==2.18.0
 oslo.service==1.24.0
 oslo.utils==3.34.0
 oslo.versionedobjects==1.31.2
-oslo.vmware==2.17.0
+oslo.vmware==2.35.0
 oslotest==3.2.0
 osprofiler==1.4.0
-paramiko==2.0.0
+paramiko==2.4.0
 Paste==2.0.2
 PasteDeploy==1.5.0
 pbr==2.0.0
 pep8==1.5.7
 pika-pool==0.1.3
 pika==0.10.0
-prettytable==0.7.1
 psutil==3.2.2
 psycopg2==2.7
 pyasn1-modules==0.2.1
@@ -140,18 +139,17 @@ sphinx-feature-classification==0.1.0
 sphinxcontrib-websupport==1.0.1
 sqlalchemy-migrate==0.11.0
 SQLAlchemy==1.0.10
+SQLAlchemy-Utils==0.36.1
 sqlparse==0.2.4
 statsd==3.2.2
 stestr==2.2.0
 stevedore==1.20.0
 suds-jurko==0.6
+tabulate==0.8.5
 taskflow==3.2.0
-tempest==17.1.0
 Tempita==0.5.2
 tenacity==4.9.0
 testrepository==0.0.20
-testresources==2.0.0
-testscenarios==0.4
 testtools==2.2.0
 tooz==1.58.0
 traceback2==1.4.0
@@ -177,3 +175,4 @@ purestorage==1.6.0
 rsd-lib==1.1.0
 storpool==4.0.0
 storpool.spopenstack==2.2.1
+dfs_sdk==1.2.25
diff -pruN 2:15.0.1-1/PKG-INFO 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/PKG-INFO
--- 2:15.0.1-1/PKG-INFO	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/PKG-INFO	2020-03-24 18:46:36.798701800 +0000
@@ -0,0 +1,69 @@
+Metadata-Version: 2.1
+Name: cinder
+Version: 16.0.0.0b2.dev64
+Summary: OpenStack Block Storage
+Home-page: https://docs.openstack.org/cinder/latest/
+Author: OpenStack
+Author-email: openstack-discuss@lists.openstack.org
+License: UNKNOWN
+Description: ================
+        OpenStack Cinder
+        ================
+        
+        .. image:: https://governance.openstack.org/tc/badges/cinder.svg
+            :target: https://governance.openstack.org/tc/reference/tags/index.html
+        
+        .. Change things from this point on
+        
+        OpenStack Cinder is a storage service for an open cloud computing service.
+        
+        You can learn more about Cinder at:
+        
+        * `Wiki <https://wiki.openstack.org/Cinder/>`__
+        * `Developer Docs <https://docs.openstack.org/cinder/latest/>`__
+        * `Blueprints <https://blueprints.launchpad.net/cinder/>`__
+        * `Release notes <https://docs.openstack.org/releasenotes/cinder/>`__
+        * `Design specifications <https://specs.openstack.org/openstack/cinder-specs/>`__
+        
+        Getting Started
+        ---------------
+        
+        If you'd like to run from the master branch, you can clone the git repo:
+        
+            git clone https://opendev.org/openstack/cinder
+        
+        If you'd like to contribute, please see the information in
+        `CONTRIBUTING.rst <https://opendev.org/openstack/cinder/src/branch/master/CONTRIBUTING.rst>`_
+        
+        You can raise bugs on `Launchpad <https://bugs.launchpad.net/cinder>`__
+        
+        Python client
+        -------------
+        `Python Cinderclient <https://opendev.org/openstack/python-cinderclient>`__
+        
+        
+Platform: UNKNOWN
+Classifier: Environment :: OpenStack
+Classifier: Intended Audience :: Information Technology
+Classifier: Intended Audience :: System Administrators
+Classifier: License :: OSI Approved :: Apache Software License
+Classifier: Operating System :: POSIX :: Linux
+Classifier: Programming Language :: Python
+Classifier: Programming Language :: Python :: 3
+Classifier: Programming Language :: Python :: 3.6
+Classifier: Programming Language :: Python :: 3.7
+Provides-Extra: all
+Provides-Extra: datacore
+Provides-Extra: datera
+Provides-Extra: ds8k
+Provides-Extra: fujitsu
+Provides-Extra: hpe3par
+Provides-Extra: infinidat
+Provides-Extra: kaminario
+Provides-Extra: powermax
+Provides-Extra: pure
+Provides-Extra: rsd
+Provides-Extra: storpool
+Provides-Extra: test
+Provides-Extra: unity
+Provides-Extra: vnx
diff -pruN 2:15.0.1-1/playbooks/legacy/cinder-tempest-dsvm-lvm-lio-barbican/run.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/playbooks/legacy/cinder-tempest-dsvm-lvm-lio-barbican/run.yaml
--- 2:15.0.1-1/playbooks/legacy/cinder-tempest-dsvm-lvm-lio-barbican/run.yaml	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/playbooks/legacy/cinder-tempest-dsvm-lvm-lio-barbican/run.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -54,6 +54,7 @@
               # pip for stable branches.
               export DEVSTACK_PROJECT_FROM_GIT=os-brick
           fi
+          export DEVSTACK_GATE_USE_PYTHON3=True
           export DEVSTACK_GATE_TEMPEST=1
           export DEVSTACK_GATE_TEMPEST_ALL_PLUGINS=1
           # As we are setting DEVSTACK_GATE_TEMPEST_ALL_PLUGINS, we need to add
diff -pruN 2:15.0.1-1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-bak/post.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-bak/post.yaml
--- 2:15.0.1-1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-bak/post.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-bak/post.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,15 @@
+- hosts: primary
+  tasks:
+
+    - name: Copy files from {{ ansible_user_dir }}/workspace/ on node
+      synchronize:
+        src: '{{ ansible_user_dir }}/workspace/'
+        dest: '{{ zuul.executor.log_root }}'
+        mode: pull
+        copy_links: true
+        verify_host: true
+        rsync_opts:
+          - --include=/logs/**
+          - --include=*/
+          - --exclude=*
+          - --prune-empty-dirs
diff -pruN 2:15.0.1-1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-bak/run.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-bak/run.yaml
--- 2:15.0.1-1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-bak/run.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-bak/run.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,53 @@
+- hosts: primary
+  name: Autoconverted job legacy-grenade-dsvm-cinder-mn-sub-bak from old job gate-grenade-dsvm-cinder-mn-sub-bak-ubuntu-xenial-nv
+  tasks:
+
+    - name: Ensure legacy workspace directory
+      file:
+        path: '{{ ansible_user_dir }}/workspace'
+        state: directory
+
+    - shell:
+        cmd: |
+          set -e
+          set -x
+          cat > clonemap.yaml << EOF
+          clonemap:
+            - name: openstack/devstack-gate
+              dest: devstack-gate
+          EOF
+          /usr/zuul-env/bin/zuul-cloner -m clonemap.yaml --cache-dir /opt/git \
+              https://opendev.org \
+              openstack/devstack-gate
+        executable: /bin/bash
+        chdir: '{{ ansible_user_dir }}/workspace'
+      environment: '{{ zuul | zuul_legacy_vars }}'
+
+    - shell:
+        cmd: |
+          set -e
+          set -x
+          export PYTHONUNBUFFERED=true
+          export DEVSTACK_GATE_CONFIGDRIVE=0
+          export DEVSTACK_GATE_GRENADE=pullup
+          export DEVSTACK_GATE_USE_PYTHON3=True
+          export PROJECTS="openstack/grenade $PROJECTS"
+          export BRANCH_OVERRIDE=default
+          if [ "$BRANCH_OVERRIDE" != "default" ] ; then
+              export OVERRIDE_ZUUL_BRANCH=$BRANCH_OVERRIDE
+          fi
+          export DEVSTACK_GATE_TOPOLOGY="multinode"
+          export SERVICES=bak
+          if [ "$SERVICES" == "bak" ] ; then
+            export DEVSTACK_GATE_CINDER_MN_GRENADE_SUB_BAK=1
+          elif [ "$SERVICES" == "volschbak" ] ; then
+            export DEVSTACK_GATE_CINDER_MN_GRENADE_SUB_VOLSCHBAK=1
+          else
+            export DEVSTACK_GATE_CINDER_MN_GRENADE=1
+          fi
+
+          cp devstack-gate/devstack-vm-gate-wrap.sh ./safe-devstack-vm-gate-wrap.sh
+          ./safe-devstack-vm-gate-wrap.sh
+        executable: /bin/bash
+        chdir: '{{ ansible_user_dir }}/workspace'
+      environment: '{{ zuul | zuul_legacy_vars }}'
diff -pruN 2:15.0.1-1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-volbak/post.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-volbak/post.yaml
--- 2:15.0.1-1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-volbak/post.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-volbak/post.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,15 @@
+- hosts: primary
+  tasks:
+
+    - name: Copy files from {{ ansible_user_dir }}/workspace/ on node
+      synchronize:
+        src: '{{ ansible_user_dir }}/workspace/'
+        dest: '{{ zuul.executor.log_root }}'
+        mode: pull
+        copy_links: true
+        verify_host: true
+        rsync_opts:
+          - --include=/logs/**
+          - --include=*/
+          - --exclude=*
+          - --prune-empty-dirs
diff -pruN 2:15.0.1-1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-volbak/run.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-volbak/run.yaml
--- 2:15.0.1-1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-volbak/run.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-volbak/run.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,53 @@
+- hosts: primary
+  name: Autoconverted job legacy-grenade-dsvm-cinder-mn-sub-volbak from old job gate-grenade-dsvm-cinder-mn-sub-volbak-ubuntu-xenial
+  tasks:
+
+    - name: Ensure legacy workspace directory
+      file:
+        path: '{{ ansible_user_dir }}/workspace'
+        state: directory
+
+    - shell:
+        cmd: |
+          set -e
+          set -x
+          cat > clonemap.yaml << EOF
+          clonemap:
+            - name: openstack/devstack-gate
+              dest: devstack-gate
+          EOF
+          /usr/zuul-env/bin/zuul-cloner -m clonemap.yaml --cache-dir /opt/git \
+              https://opendev.org \
+              openstack/devstack-gate
+        executable: /bin/bash
+        chdir: '{{ ansible_user_dir }}/workspace'
+      environment: '{{ zuul | zuul_legacy_vars }}'
+
+    - shell:
+        cmd: |
+          set -e
+          set -x
+          export PYTHONUNBUFFERED=true
+          export DEVSTACK_GATE_CONFIGDRIVE=0
+          export DEVSTACK_GATE_GRENADE=pullup
+          export DEVSTACK_GATE_USE_PYTHON3=True
+          export PROJECTS="openstack/grenade $PROJECTS"
+          export BRANCH_OVERRIDE=default
+          if [ "$BRANCH_OVERRIDE" != "default" ] ; then
+              export OVERRIDE_ZUUL_BRANCH=$BRANCH_OVERRIDE
+          fi
+          export DEVSTACK_GATE_TOPOLOGY="multinode"
+          export SERVICES=volbak
+          if [ "$SERVICES" == "bak" ] ; then
+            export DEVSTACK_GATE_CINDER_MN_GRENADE_SUB_BAK=1
+          elif [ "$SERVICES" == "volschbak" ] ; then
+            export DEVSTACK_GATE_CINDER_MN_GRENADE_SUB_VOLSCHBAK=1
+          else
+            export DEVSTACK_GATE_CINDER_MN_GRENADE=1
+          fi
+
+          cp devstack-gate/devstack-vm-gate-wrap.sh ./safe-devstack-vm-gate-wrap.sh
+          ./safe-devstack-vm-gate-wrap.sh
+        executable: /bin/bash
+        chdir: '{{ ansible_user_dir }}/workspace'
+      environment: '{{ zuul | zuul_legacy_vars }}'
diff -pruN 2:15.0.1-1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-volschbak/post.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-volschbak/post.yaml
--- 2:15.0.1-1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-volschbak/post.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-volschbak/post.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,15 @@
+- hosts: primary
+  tasks:
+
+    - name: Copy files from {{ ansible_user_dir }}/workspace/ on node
+      synchronize:
+        src: '{{ ansible_user_dir }}/workspace/'
+        dest: '{{ zuul.executor.log_root }}'
+        mode: pull
+        copy_links: true
+        verify_host: true
+        rsync_opts:
+          - --include=/logs/**
+          - --include=*/
+          - --exclude=*
+          - --prune-empty-dirs
diff -pruN 2:15.0.1-1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-volschbak/run.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-volschbak/run.yaml
--- 2:15.0.1-1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-volschbak/run.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/playbooks/legacy/grenade-dsvm-cinder-mn-sub-volschbak/run.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,54 @@
+- hosts: primary
+  name: Autoconverted job legacy-grenade-dsvm-cinder-mn-sub-volschbak from old job
+    gate-grenade-dsvm-cinder-mn-sub-volschbak-ubuntu-xenial-nv
+  tasks:
+
+    - name: Ensure legacy workspace directory
+      file:
+        path: '{{ ansible_user_dir }}/workspace'
+        state: directory
+
+    - shell:
+        cmd: |
+          set -e
+          set -x
+          cat > clonemap.yaml << EOF
+          clonemap:
+            - name: openstack/devstack-gate
+              dest: devstack-gate
+          EOF
+          /usr/zuul-env/bin/zuul-cloner -m clonemap.yaml --cache-dir /opt/git \
+              https://opendev.org \
+              openstack/devstack-gate
+        executable: /bin/bash
+        chdir: '{{ ansible_user_dir }}/workspace'
+      environment: '{{ zuul | zuul_legacy_vars }}'
+
+    - shell:
+        cmd: |
+          set -e
+          set -x
+          export PYTHONUNBUFFERED=true
+          export DEVSTACK_GATE_CONFIGDRIVE=0
+          export DEVSTACK_GATE_GRENADE=pullup
+          export DEVSTACK_GATE_USE_PYTHON3=True
+          export PROJECTS="openstack/grenade $PROJECTS"
+          export BRANCH_OVERRIDE=default
+          if [ "$BRANCH_OVERRIDE" != "default" ] ; then
+              export OVERRIDE_ZUUL_BRANCH=$BRANCH_OVERRIDE
+          fi
+          export DEVSTACK_GATE_TOPOLOGY="multinode"
+          export SERVICES=volschbak
+          if [ "$SERVICES" == "bak" ] ; then
+            export DEVSTACK_GATE_CINDER_MN_GRENADE_SUB_BAK=1
+          elif [ "$SERVICES" == "volschbak" ] ; then
+            export DEVSTACK_GATE_CINDER_MN_GRENADE_SUB_VOLSCHBAK=1
+          else
+            export DEVSTACK_GATE_CINDER_MN_GRENADE=1
+          fi
+
+          cp devstack-gate/devstack-vm-gate-wrap.sh ./safe-devstack-vm-gate-wrap.sh
+          ./safe-devstack-vm-gate-wrap.sh
+        executable: /bin/bash
+        chdir: '{{ ansible_user_dir }}/workspace'
+      environment: '{{ zuul | zuul_legacy_vars }}'
diff -pruN 2:15.0.1-1/README.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/README.rst
--- 2:15.0.1-1/README.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/README.rst	2020-03-24 18:46:31.000000000 +0000
@@ -1,24 +1,21 @@
-========================
-Team and repository tags
-========================
+================
+OpenStack Cinder
+================
 
 .. image:: https://governance.openstack.org/tc/badges/cinder.svg
     :target: https://governance.openstack.org/tc/reference/tags/index.html
 
 .. Change things from this point on
 
-======
-CINDER
-======
-
-You have come across a storage service for an open cloud computing service.
-It has identified itself as `Cinder`. It was abstracted from the Nova project.
-
-* Wiki: https://wiki.openstack.org/Cinder
-* Developer docs: https://docs.openstack.org/cinder/latest/
-* Blueprints: https://blueprints.launchpad.net/cinder
-* Release notes: https://docs.openstack.org/releasenotes/cinder/
-* Design specifications: https://specs.openstack.org/openstack/cinder-specs/
+OpenStack Cinder is a storage service for an open cloud computing service.
+
+You can learn more about Cinder at:
+
+* `Wiki <https://wiki.openstack.org/Cinder/>`__
+* `Developer Docs <https://docs.openstack.org/cinder/latest/>`__
+* `Blueprints <https://blueprints.launchpad.net/cinder/>`__
+* `Release notes <https://docs.openstack.org/releasenotes/cinder/>`__
+* `Design specifications <https://specs.openstack.org/openstack/cinder-specs/>`__
 
 Getting Started
 ---------------
@@ -27,11 +24,11 @@ If you'd like to run from the master bra
 
     git clone https://opendev.org/openstack/cinder
 
-For developer information please see
-`HACKING.rst <https://opendev.org/openstack/cinder/src/branch/master/HACKING.rst>`_
+If you'd like to contribute, please see the information in
+`CONTRIBUTING.rst <https://opendev.org/openstack/cinder/src/branch/master/CONTRIBUTING.rst>`_
 
-You can raise bugs here https://bugs.launchpad.net/cinder
+You can raise bugs on `Launchpad <https://bugs.launchpad.net/cinder>`__
 
 Python client
 -------------
-https://opendev.org/openstack/python-cinderclient
+`Python Cinderclient <https://opendev.org/openstack/python-cinderclient>`__
diff -pruN 2:15.0.1-1/releasenotes/notes/add-configurable-img-conversion-param-1e7b545ae816dfe8.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/add-configurable-img-conversion-param-1e7b545ae816dfe8.yaml
--- 2:15.0.1-1/releasenotes/notes/add-configurable-img-conversion-param-1e7b545ae816dfe8.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/add-configurable-img-conversion-param-1e7b545ae816dfe8.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,7 @@
+---
+features:
+  - |
+    Added the ``image_conversion_cpu_limit`` and
+    ``image_conversion_address_space_limit`` as configurable parameters. This
+    adds configurability to the image conversion process to prevent the process
+    from timing out when converting larger images.
diff -pruN 2:15.0.1-1/releasenotes/notes/bug-1860100-8c542363def7d408.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/bug-1860100-8c542363def7d408.yaml
--- 2:15.0.1-1/releasenotes/notes/bug-1860100-8c542363def7d408.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/bug-1860100-8c542363def7d408.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,6 @@
+---
+fixes:
+  - |
+    The volume-transfers list calls (``GET /v3/{project_id}/volume-transfers``,
+    ``GET /v3/{project_id}/volume-transfers/detail``) were not recognizing ``name``
+    as a filterable attribute.  That has been fixed in the current release.
diff -pruN 2:15.0.1-1/releasenotes/notes/dell-emc-ps-deprecation-ae8d166e1847ea94.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/dell-emc-ps-deprecation-ae8d166e1847ea94.yaml
--- 2:15.0.1-1/releasenotes/notes/dell-emc-ps-deprecation-ae8d166e1847ea94.yaml	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/dell-emc-ps-deprecation-ae8d166e1847ea94.yaml	1970-01-01 00:00:00.000000000 +0000
@@ -1,6 +0,0 @@
----
-deprecations:
-  - The Dell EMC PS Series volume driver which supports
-    Dell PS Series (EqualLogic) Storage is moving to
-    maintenance mode in S Release and will be removed
-    in T Release.
diff -pruN 2:15.0.1-1/releasenotes/notes/deprecate-rbd_keyring_conf-432efbcd47e52c8a.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/deprecate-rbd_keyring_conf-432efbcd47e52c8a.yaml
--- 2:15.0.1-1/releasenotes/notes/deprecate-rbd_keyring_conf-432efbcd47e52c8a.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/deprecate-rbd_keyring_conf-432efbcd47e52c8a.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,18 @@
+---
+security:
+  - |
+    Due to `OSSN-0085
+    <https://wiki.openstack.org/wiki/OSSN/OSSN-0085>`_:
+    Cinder configuration option can leak secret key from Ceph backend,
+    deployers using the ``rbd_keyring_conf`` option are advised to stop
+    using it immediately.  The option has been deprecated for removal
+    early in the 'V' development cycle.
+deprecations:
+  - |
+    The configuration option ``rbd_keyring_conf`` for the Ceph cinder
+    driver presents a security risk and the option is hereby deprecated
+    and scheduled to be removed early in the 'V' development cycle,
+    following the standard OpenStack deprecation policy.  For more
+    information, see `OSSN-0085
+    <https://wiki.openstack.org/wiki/OSSN/OSSN-0085>`_:
+    Cinder configuration option can leak secret key from Ceph backend.
diff -pruN 2:15.0.1-1/releasenotes/notes/deprecate-sf-allow-template-caching-b3a1ea32512cbb11.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/deprecate-sf-allow-template-caching-b3a1ea32512cbb11.yaml
--- 2:15.0.1-1/releasenotes/notes/deprecate-sf-allow-template-caching-b3a1ea32512cbb11.yaml	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/deprecate-sf-allow-template-caching-b3a1ea32512cbb11.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -1,7 +1,9 @@
 ---
+prelude: >
+    SolidFire cinder driver deprecate sf_allow_template_caching
 deprecations:
   - |
-    The configuration option ``sf_allow_template_caching`` for the
-    SolidFire driver has been removed. Use ``image_volume_cache`` enabled
-    equals ``True`` for a better template image cache that is managed from
-    Cinder.
+    The configuration option sf_allow_template_caching for the
+    SolidFire cinder driver has been removed. Use image_volume_cache_enabled
+    equals True for a better template image cache that is managed from
+    cinder.
diff -pruN 2:15.0.1-1/releasenotes/notes/drbd-linstor-rest-update-52fd52f6c09a4dd3.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/drbd-linstor-rest-update-52fd52f6c09a4dd3.yaml
--- 2:15.0.1-1/releasenotes/notes/drbd-linstor-rest-update-52fd52f6c09a4dd3.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/drbd-linstor-rest-update-52fd52f6c09a4dd3.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,11 @@
+---
+upgrade:
+  - |
+    The LINSTOR driver for Cinder supports LINSTOR 0.9.12.  The driver
+    supports LINSTOR backend using REST API.
+
+    The new driver adds 'linstor_autoplace_count' configuration option that
+    specifies the number of volume replicas.
+features:
+  - |
+    The LINSTOR Driver for Cinder now supports LINSTOR 0.9.12.
diff -pruN 2:15.0.1-1/releasenotes/notes/drop-py2-377a91a5b66165ab.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/drop-py2-377a91a5b66165ab.yaml
--- 2:15.0.1-1/releasenotes/notes/drop-py2-377a91a5b66165ab.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/drop-py2-377a91a5b66165ab.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,6 @@
+---
+upgrade:
+  - |
+    Python 2.7 support has been dropped. The last release of Cinder to support
+    py2.7 is OpenStack Train. The minimum version of Python now supported by
+    Cinder is Python 3.6.
diff -pruN 2:15.0.1-1/releasenotes/notes/eqlx-volume-manage-unmanage-a24ec7f0d9989df3.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/eqlx-volume-manage-unmanage-a24ec7f0d9989df3.yaml
--- 2:15.0.1-1/releasenotes/notes/eqlx-volume-manage-unmanage-a24ec7f0d9989df3.yaml	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/eqlx-volume-manage-unmanage-a24ec7f0d9989df3.yaml	1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
----
-features:
-  - Added manage/unmanage volume support for Dell Equallogic driver.
diff -pruN 2:15.0.1-1/releasenotes/notes/fujitsu-multiple-pools-a0dd9197b16b3122.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/fujitsu-multiple-pools-a0dd9197b16b3122.yaml
--- 2:15.0.1-1/releasenotes/notes/fujitsu-multiple-pools-a0dd9197b16b3122.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/fujitsu-multiple-pools-a0dd9197b16b3122.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,4 @@
+---
+features:
+  - |
+    Fujitsu Driver: Added multiple pools support.
diff -pruN 2:15.0.1-1/releasenotes/notes/Huawei_Cinder_Driver_Support_Dorado_V6-5289a3b0ef90e8b1.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/Huawei_Cinder_Driver_Support_Dorado_V6-5289a3b0ef90e8b1.yaml
--- 2:15.0.1-1/releasenotes/notes/Huawei_Cinder_Driver_Support_Dorado_V6-5289a3b0ef90e8b1.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/Huawei_Cinder_Driver_Support_Dorado_V6-5289a3b0ef90e8b1.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,4 @@
+---
+features:
+  - |
+    Huawei Cinder Driver Support Dorado V6 Storage.(iSCSI, FC)
diff -pruN 2:15.0.1-1/releasenotes/notes/huawei-fusionstorage-driver-readd-70fecc39eeaa0f5f.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/huawei-fusionstorage-driver-readd-70fecc39eeaa0f5f.yaml
--- 2:15.0.1-1/releasenotes/notes/huawei-fusionstorage-driver-readd-70fecc39eeaa0f5f.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/huawei-fusionstorage-driver-readd-70fecc39eeaa0f5f.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,5 @@
+upgrade:
+  - |
+    The Huawei FusionStorage driver had previously been marked unsupported. The 3rd Party CI has
+    been restored, and the driver is now fully supported in the Ussuri release.
+
diff -pruN 2:15.0.1-1/releasenotes/notes/ibm-storage-supported-a373a54777333929.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/ibm-storage-supported-a373a54777333929.yaml
--- 2:15.0.1-1/releasenotes/notes/ibm-storage-supported-a373a54777333929.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/ibm-storage-supported-a373a54777333929.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,6 @@
+---
+upgrade:
+  - |
+    IBM DS8k drivers had been previously marked unsupported. Testing
+    requirements have been addressed and they are now fully supported again.
+    IBM DS8k drivers allow cinder to manage volumes in FC environment.
diff -pruN 2:15.0.1-1/releasenotes/notes/ibm-storwize-supported-6518628fb78d58a4.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/ibm-storwize-supported-6518628fb78d58a4.yaml
--- 2:15.0.1-1/releasenotes/notes/ibm-storwize-supported-6518628fb78d58a4.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/ibm-storwize-supported-6518628fb78d58a4.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,7 @@
+---
+upgrade:
+  - |
+    IBM Storwize drivers had been previously marked unsupported. Testing
+    requirements have been addressed and they are now fully supported again.
+    IBM Storwize drivers allow cinder to manage volumes both in iSCSI and
+    FC environment.
diff -pruN 2:15.0.1-1/releasenotes/notes/iet-deprecation-f8059417c6adbb78.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/iet-deprecation-f8059417c6adbb78.yaml
--- 2:15.0.1-1/releasenotes/notes/iet-deprecation-f8059417c6adbb78.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/iet-deprecation-f8059417c6adbb78.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,13 @@
+---
+upgrade:
+  - |
+    The IET iSCSI target driver has been marked deprecated and will be
+    removed in the "V" release. The IET iSCSI target project is no longer
+    active and is not supported by all distributions. It is recommended to
+    migrate to a supported distribution and iSCSI target prior to upgrading.
+deprecations:
+  - |
+    The IET iSCSI target driver has been marked deprecated and will be
+    removed in the "V" release. The IET iSCSI target project is no longer
+    active and is not supported by all distributions. It is recommended to
+    migrate to a supported distribution and iSCSI target prior to upgrading.
diff -pruN 2:15.0.1-1/releasenotes/notes/macrosan_driver_unsupported-b25f7a3b8270fa61.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/macrosan_driver_unsupported-b25f7a3b8270fa61.yaml
--- 2:15.0.1-1/releasenotes/notes/macrosan_driver_unsupported-b25f7a3b8270fa61.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/macrosan_driver_unsupported-b25f7a3b8270fa61.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,14 @@
+---
+upgrade:
+  - |
+    The MacroSAN Storage driver has been marked as unsupported
+    and is now deprecated.  ``enabled_unsupported_driver`` will need
+    to be set to ``True`` in the driver's section in cinder.conf to
+    continue to use the driver.
+deprecations:
+  - |
+    The MacroSAN Storage driver has been marked as unsupported and
+    is now deprecated.  ``enable_unsupported_driver`` will need to be
+    set to ``True`` in the driver's section in cinder.conf to
+    continue to use the driver.  It its support status does not change
+    the driver will be removed in the 'V' development cycle.
diff -pruN 2:15.0.1-1/releasenotes/notes/mark-brocade-unsupported-d5760b4bb8173652.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/mark-brocade-unsupported-d5760b4bb8173652.yaml
--- 2:15.0.1-1/releasenotes/notes/mark-brocade-unsupported-d5760b4bb8173652.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/mark-brocade-unsupported-d5760b4bb8173652.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,17 @@
+---
+upgrade:
+  - |
+    The Brocade Fibre Channel Zone Manager driver has been marked as
+    unsupported and is now deprecated. It is subject to removal during the "V"
+    development cycle, following the standard OpenStack deprecation policy.
+    The config option ``enable_unsupported_driver`` will need to be set to
+    ``True`` in the driver's section in cinder.conf to continue to use it
+    in this release.
+deprecations:
+  - |
+    The Brocade Fibre Channel Zone Manager driver has been marked as
+    unsupported and is now deprecated. It is subject to removal during the "V"
+    development cycle, following the standard OpenStack deprecation policy.
+    The config option ``enable_unsupported_driver`` will need to be set to
+    ``True`` in the driver's section in cinder.conf to continue to use it
+    in this release.
diff -pruN 2:15.0.1-1/releasenotes/notes/minimum-u4p-version-4c66d69d1b873796.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/minimum-u4p-version-4c66d69d1b873796.yaml
--- 2:15.0.1-1/releasenotes/notes/minimum-u4p-version-4c66d69d1b873796.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/minimum-u4p-version-4c66d69d1b873796.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,6 @@
+---
+other:
+  - |
+    PowerMax driver - the minimum version of Unisphere for PowerMax for the
+    current release is 9.1.0.5.  It is however recommended to install the
+    Security Releases(SR) of Unisphere for PowerMax if they become available.
diff -pruN 2:15.0.1-1/releasenotes/notes/move-eqlx-driver-to-dell-emc-fe5d2b484c47b7a6.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/move-eqlx-driver-to-dell-emc-fe5d2b484c47b7a6.yaml
--- 2:15.0.1-1/releasenotes/notes/move-eqlx-driver-to-dell-emc-fe5d2b484c47b7a6.yaml	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/move-eqlx-driver-to-dell-emc-fe5d2b484c47b7a6.yaml	1970-01-01 00:00:00.000000000 +0000
@@ -1,6 +0,0 @@
----
-upgrade:
-  - The EqualLogic driver is moved to the dell_emc directory and has been
-    rebranded to its current Dell EMC PS Series name. The volume_driver
-    entry in cinder.conf needs to be changed to
-    ``cinder.volume.drivers.dell_emc.ps.PSSeriesISCSIDriver``.
diff -pruN 2:15.0.1-1/releasenotes/notes/nimble-driver-removal-ff80d077e7707614.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/nimble-driver-removal-ff80d077e7707614.yaml
--- 2:15.0.1-1/releasenotes/notes/nimble-driver-removal-ff80d077e7707614.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/nimble-driver-removal-ff80d077e7707614.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,7 @@
+---
+upgrade:
+  - |
+    The Nimble Storage driver was marked unsupported in the
+    Train release and has now been removed.  All data on
+    Nimble Storage backends should be migrated to a supported
+    storage backend before upgrading your Cinder installation.
diff -pruN 2:15.0.1-1/releasenotes/notes/powermax-bug-1853589-f6c7164177da0496.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/powermax-bug-1853589-f6c7164177da0496.yaml
--- 2:15.0.1-1/releasenotes/notes/powermax-bug-1853589-f6c7164177da0496.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/powermax-bug-1853589-f6c7164177da0496.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,6 @@
+---
+fixes:
+  - |
+    PowerMax driver - fix to eliminate 'cannot use the device for the function
+    because it is in a Copy Session' when attempting to delete a volume group
+    that previously had a group snapshot created on and deleted from it.
diff -pruN 2:15.0.1-1/releasenotes/notes/powermax-disable-inuse-metro-89e9f398ec9e2672.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/powermax-disable-inuse-metro-89e9f398ec9e2672.yaml
--- 2:15.0.1-1/releasenotes/notes/powermax-disable-inuse-metro-89e9f398ec9e2672.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/powermax-disable-inuse-metro-89e9f398ec9e2672.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,6 @@
+---
+issues:
+  - |
+    PowerMax driver - Disabling inuse storage assisted migration to a metro
+    or asynchronous replicated volume type as this operation will
+    not facilitate FC scanning or iSCSI login of the target array.
diff -pruN 2:15.0.1-1/releasenotes/notes/powermax-srdf-enhancement-56b0a2817c4d310d.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/powermax-srdf-enhancement-56b0a2817c4d310d.yaml
--- 2:15.0.1-1/releasenotes/notes/powermax-srdf-enhancement-56b0a2817c4d310d.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/powermax-srdf-enhancement-56b0a2817c4d310d.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,8 @@
+---
+other:
+  - |
+    PowerMax Driver - Two new replication specific configuration options
+    sync_interval and sync_retries have been added to PowerMax cinder
+    configuration.  These configuration options determine how many times to
+    retry checks to see if a SnapVX copy mode has completed with a replication
+    enabled volume, and how long to wait between retries.
diff -pruN 2:15.0.1-1/releasenotes/notes/powermax-storage-group-tagging-d2281e9b35994bec.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/powermax-storage-group-tagging-d2281e9b35994bec.yaml
--- 2:15.0.1-1/releasenotes/notes/powermax-storage-group-tagging-d2281e9b35994bec.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/powermax-storage-group-tagging-d2281e9b35994bec.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,6 @@
+---
+features:
+  - |
+    Dell EMC PowerMax driver now supports Unisphere storage group
+    and array tagging to allow the user to specify a user defined
+    tag to facilitate easy access and classification.
diff -pruN 2:15.0.1-1/releasenotes/notes/powermax-user-defined-hostname-portgroup-0b01aaaa730dfaaf.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/powermax-user-defined-hostname-portgroup-0b01aaaa730dfaaf.yaml
--- 2:15.0.1-1/releasenotes/notes/powermax-user-defined-hostname-portgroup-0b01aaaa730dfaaf.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/powermax-user-defined-hostname-portgroup-0b01aaaa730dfaaf.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,9 @@
+---
+features:
+  - |
+    Dell EMC PowerMax driver now faciliates the user to override the
+    short host name and port group name seen in PowerMax masking view
+    and storage view terminology. This means the user can give more
+    meaningful names, especially when the short host name exceeds 16
+    characters and the port group name exceeds 12 characters, which
+    is the condition where the driver truncates these values.
diff -pruN 2:15.0.1-1/releasenotes/notes/prophetstor-driver-removal-f6b9911d1f84b48f.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/prophetstor-driver-removal-f6b9911d1f84b48f.yaml
--- 2:15.0.1-1/releasenotes/notes/prophetstor-driver-removal-f6b9911d1f84b48f.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/prophetstor-driver-removal-f6b9911d1f84b48f.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,7 @@
+---
+upgrade:
+  - |
+    The ProphetStor Flexvisor driver was marked unsupported in the
+    Train release and has now been removed.  All data on
+    ProphetStor Flexvisor backends should be migrated to a supported
+    storage backend before upgrading your Cinder installation.
diff -pruN 2:15.0.1-1/releasenotes/notes/ps-duplicate-ACL-5aa447c50f2474e7.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/ps-duplicate-ACL-5aa447c50f2474e7.yaml
--- 2:15.0.1-1/releasenotes/notes/ps-duplicate-ACL-5aa447c50f2474e7.yaml	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/ps-duplicate-ACL-5aa447c50f2474e7.yaml	1970-01-01 00:00:00.000000000 +0000
@@ -1,5 +0,0 @@
----
-fixes:
-  - Dell EMC PS Series Driver code was creating duplicate ACL records during
-    live migration. Fixes the initialize_connection code to not create access
-    record for a host if one exists previously. This change fixes bug 1726591.
diff -pruN 2:15.0.1-1/releasenotes/notes/ps-extend_volume-no-snap-8aa447c50f2475a7.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/ps-extend_volume-no-snap-8aa447c50f2475a7.yaml
--- 2:15.0.1-1/releasenotes/notes/ps-extend_volume-no-snap-8aa447c50f2475a7.yaml	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/ps-extend_volume-no-snap-8aa447c50f2475a7.yaml	1970-01-01 00:00:00.000000000 +0000
@@ -1,5 +0,0 @@
----
-fixes:
-  - Dell EMC PS Series Driver was creating unmanaged snapshots
-    when extending volumes. Fixed it by adding the missing
-    no-snap parameter. This changes fixes bug 1720454.
diff -pruN 2:15.0.1-1/releasenotes/notes/ps-optimize-parsing-8aa447c50f2474c7.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/ps-optimize-parsing-8aa447c50f2474c7.yaml
--- 2:15.0.1-1/releasenotes/notes/ps-optimize-parsing-8aa447c50f2474c7.yaml	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/ps-optimize-parsing-8aa447c50f2474c7.yaml	1970-01-01 00:00:00.000000000 +0000
@@ -1,5 +0,0 @@
----
-fixes:
-  - Dell EMC PS Series Driver code reporting volume stats is now optimized
-    to return the information earlier and accelerate the process. This change
-    fixes bug 1661154.
diff -pruN 2:15.0.1-1/releasenotes/notes/ps-over-subscription-ratio-cal-8aa447c50f2474a8.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/ps-over-subscription-ratio-cal-8aa447c50f2474a8.yaml
--- 2:15.0.1-1/releasenotes/notes/ps-over-subscription-ratio-cal-8aa447c50f2474a8.yaml	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/ps-over-subscription-ratio-cal-8aa447c50f2474a8.yaml	1970-01-01 00:00:00.000000000 +0000
@@ -1,5 +0,0 @@
----
-fixes:
-  - |
-    Dell EMC PS Driver stats report has been fixed, now reports the
-    `provisioned_capacity_gb` properly. Fixes bug 1719659.
diff -pruN 2:15.0.1-1/releasenotes/notes/ps-removedriver-5ba447c50f2474e7.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/ps-removedriver-5ba447c50f2474e7.yaml
--- 2:15.0.1-1/releasenotes/notes/ps-removedriver-5ba447c50f2474e7.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/ps-removedriver-5ba447c50f2474e7.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,6 @@
+---
+upgrade:
+  - |
+    Dell EMC PS Series storage driver is not supported and
+    removed starting from the Ussuri release. It was marked as
+    deprecated in the Train release.
diff -pruN 2:15.0.1-1/releasenotes/notes/ps-report-total-volumes-8aa447c50f2474a7.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/ps-report-total-volumes-8aa447c50f2474a7.yaml
--- 2:15.0.1-1/releasenotes/notes/ps-report-total-volumes-8aa447c50f2474a7.yaml	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/ps-report-total-volumes-8aa447c50f2474a7.yaml	1970-01-01 00:00:00.000000000 +0000
@@ -1,4 +0,0 @@
----
-features:
-  - Dell EMC PS volume driver reports the total number
-    of volumes on the backend in volume stats.
diff -pruN 2:15.0.1-1/releasenotes/notes/rbd-multiattach-exceptions-43066312f3b527f5.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/rbd-multiattach-exceptions-43066312f3b527f5.yaml
--- 2:15.0.1-1/releasenotes/notes/rbd-multiattach-exceptions-43066312f3b527f5.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/rbd-multiattach-exceptions-43066312f3b527f5.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,6 @@
+---
+fixes:
+  - |
+    Catch argument exceptions when configuring multiattach for rbd volumes.
+    This allows multiattach images with flags already set to continue instead
+    of raising an exception and failing.
diff -pruN 2:15.0.1-1/releasenotes/notes/remove-eqlx-deprecated-options-89ba02c41d4da62a.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/remove-eqlx-deprecated-options-89ba02c41d4da62a.yaml
--- 2:15.0.1-1/releasenotes/notes/remove-eqlx-deprecated-options-89ba02c41d4da62a.yaml	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/remove-eqlx-deprecated-options-89ba02c41d4da62a.yaml	1970-01-01 00:00:00.000000000 +0000
@@ -1,15 +0,0 @@
----
-upgrade:
-  - |
-
-    Removing the Dell EqualLogic driver's deprecated configuration options.
-    Please replace old options in your cinder.conf with the new one.
-
-    * Removed - ``eqlx_cli_timeout``
-    * Replaced with - ``ssh_conn_timeout``
-    * Removed - ``eqlx_use_chap``
-    * Replaced with - ``use_chap_auth``
-    * Removed - ``eqlx_chap_login``
-    * Replaced with - ``chap_username``
-    * Removed - ``eqlx_chap_password``
-    * Replaced with - ``chap_password``
diff -pruN 2:15.0.1-1/releasenotes/notes/rename-backup-driver-status-check-interval-option-6b27c1e29cb863e9.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/rename-backup-driver-status-check-interval-option-6b27c1e29cb863e9.yaml
--- 2:15.0.1-1/releasenotes/notes/rename-backup-driver-status-check-interval-option-6b27c1e29cb863e9.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/rename-backup-driver-status-check-interval-option-6b27c1e29cb863e9.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,11 @@
+---
+upgrade:
+  - |
+    If you have ``backup_driver_status_check_interval`` option in your
+    cinder.conf we recommend you to use ``backup_driver_stats_polling_interval``
+    to avoid deprecation warnings in logs.
+deprecations:
+  - |
+    ``backup_driver_status_check_interval`` config option is renamed to
+    ``backup_driver_stats_polling_interval`` to be similar with volume drivers
+    configuration. Old option name support will be dropped in U release.
diff -pruN 2:15.0.1-1/releasenotes/notes/rpc-update-50bef83f48d4f96f.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/rpc-update-50bef83f48d4f96f.yaml
--- 2:15.0.1-1/releasenotes/notes/rpc-update-50bef83f48d4f96f.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/rpc-update-50bef83f48d4f96f.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,6 @@
+---
+upgrade:
+  - |
+    SPDK target and volume drivers have been updated with new SPDK specific
+    RPC calls due to deprecation of some old RPC calls. Starting from Ussuri
+    release SPDK release v19.10 or higher is required.
diff -pruN 2:15.0.1-1/releasenotes/notes/sheepdog-driver-removal-b63d12460e886c33.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/sheepdog-driver-removal-b63d12460e886c33.yaml
--- 2:15.0.1-1/releasenotes/notes/sheepdog-driver-removal-b63d12460e886c33.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/sheepdog-driver-removal-b63d12460e886c33.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,6 @@
+---
+upgrade:
+  - |
+    The Sheepdog driver was marked unsupported in the Train release and has
+    now been removed. All data on Sheepdog backends should be migrated to a
+    supported backend before upgrading your Cinder installation.
diff -pruN 2:15.0.1-1/releasenotes/notes/support-glance-multiple-stores-79d11c5344f41446.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/support-glance-multiple-stores-79d11c5344f41446.yaml
--- 2:15.0.1-1/releasenotes/notes/support-glance-multiple-stores-79d11c5344f41446.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/support-glance-multiple-stores-79d11c5344f41446.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,23 @@
+---
+features:
+  - |
+    This release includes support for Glance multiple stores.  An
+    operator may now specify which Glance store will be used when
+    a volume is uploaded to Glance as an image.  Some details
+    about this feature:
+
+    * This feature is not directly user-facing.  To enable it, an
+      operator must add the field ``image_service:store_id`` in the
+      volume-type extra-specs.  The value of the field is a valid
+      store identifier (``id``) configured in Glance, which may be
+      discovered by making a ``GET /v2/info/stores`` call to the
+      Image Service API.
+    * If ``image_service:store_id`` is not set in the extra-specs for a
+      volume-type, then any volume of that type uploaded as an image will
+      be uploaded to the default store in Glance.
+    * The ``image_service:store_id`` can only be set in the extra-specs
+      for a volume-type when multiple glance stores are configured.
+    * Cinder validates proposed Glance store identifiers by contacting
+      Glance at the time the ``image_service:store_id`` is added to a
+      volume-type's extra-specs.  Thus the Image Service API must be
+      available when a volume-type is updated.
diff -pruN 2:15.0.1-1/releasenotes/notes/support-to-query-cinder-resources-filter-by-update-at-and-created-at-32ae9aaea131d598.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/support-to-query-cinder-resources-filter-by-update-at-and-created-at-32ae9aaea131d598.yaml
--- 2:15.0.1-1/releasenotes/notes/support-to-query-cinder-resources-filter-by-update-at-and-created-at-32ae9aaea131d598.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/support-to-query-cinder-resources-filter-by-update-at-and-created-at-32ae9aaea131d598.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,8 @@
+---
+features:
+  - Beginning with microversion 3.60, users may apply time comparison filters
+    to the volume summary list and volume detail list requests by using the
+    "created_at" or "updated_at" fields. Time must be expressed in ISO
+    8601 format. See the 'Block Storage API v3 Reference
+    <https://docs.openstack.org/api-ref/block-storage/v3/index.html>'_ for
+    details.
diff -pruN 2:15.0.1-1/releasenotes/notes/veritas-access-driver-removal-dd9f0bc34c798c84.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/veritas-access-driver-removal-dd9f0bc34c798c84.yaml
--- 2:15.0.1-1/releasenotes/notes/veritas-access-driver-removal-dd9f0bc34c798c84.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/veritas-access-driver-removal-dd9f0bc34c798c84.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,7 @@
+---
+upgrade:
+  - |
+    The Veritas Access driver was marked unsupported in the
+    Train release and has now been removed.  All data on
+    Veritas Access backends should be migrated to a supported
+    storage backend before upgrading your Cinder installation.
diff -pruN 2:15.0.1-1/releasenotes/notes/veritas_cluster_nfs_unsupported-88ab3ea5cbb6cd88.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/veritas_cluster_nfs_unsupported-88ab3ea5cbb6cd88.yaml
--- 2:15.0.1-1/releasenotes/notes/veritas_cluster_nfs_unsupported-88ab3ea5cbb6cd88.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/veritas_cluster_nfs_unsupported-88ab3ea5cbb6cd88.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,14 @@
+---
+upgrade:
+  - |
+    The Veritas Clustered NFS driver has been marked as unsupported
+    and is now deprecated.  ``enabled_unsupported_driver`` will need
+    to be set to ``True`` in the driver's section in cinder.conf to
+    continue to use the driver.
+deprecations:
+  - |
+    The Veritas Clustered NFS driver has been marked as unsupported and
+    is now deprecated.  ``enable_unsupported_driver`` will need to be
+    set to ``True`` in the driver's section in cinder.conf to
+    continue to use the driver.  It its support status does not change
+    the driver will be removed in the 'V' development cycle.
diff -pruN 2:15.0.1-1/releasenotes/notes/virtuozzo-storage-driver-removal-d53942afce6465d0.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/virtuozzo-storage-driver-removal-d53942afce6465d0.yaml
--- 2:15.0.1-1/releasenotes/notes/virtuozzo-storage-driver-removal-d53942afce6465d0.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/notes/virtuozzo-storage-driver-removal-d53942afce6465d0.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,7 @@
+---
+upgrade:
+  - |
+    The Virtuozzo Storage driver was marked unsupported in the
+    Train release and has now been removed.  All data on
+    Virtuozzo Storage backends should be migrated to a supported
+    storage backend before upgrading your Cinder installation.
diff -pruN 2:15.0.1-1/releasenotes/source/index.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/source/index.rst
--- 2:15.0.1-1/releasenotes/source/index.rst	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/source/index.rst	2020-03-24 18:46:31.000000000 +0000
@@ -6,6 +6,7 @@
    :maxdepth: 1
 
    unreleased
+   train
    stein
    rocky
    queens
diff -pruN 2:15.0.1-1/releasenotes/source/locale/en_GB/LC_MESSAGES/releasenotes.po 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/source/locale/en_GB/LC_MESSAGES/releasenotes.po
--- 2:15.0.1-1/releasenotes/source/locale/en_GB/LC_MESSAGES/releasenotes.po	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/source/locale/en_GB/LC_MESSAGES/releasenotes.po	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,6671 @@
+# Andi Chandler <andi@gowling.com>, 2017. #zanata
+# Andi Chandler <andi@gowling.com>, 2018. #zanata
+# Andi Chandler <andi@gowling.com>, 2019. #zanata
+# Andi Chandler <andi@gowling.com>, 2020. #zanata
+msgid ""
+msgstr ""
+"Project-Id-Version: cinder\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2020-03-18 14:36+0000\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"PO-Revision-Date: 2020-03-18 12:11+0000\n"
+"Last-Translator: Andi Chandler <andi@gowling.com>\n"
+"Language-Team: English (United Kingdom)\n"
+"Language: en_GB\n"
+"X-Generator: Zanata 4.3.3\n"
+"Plural-Forms: nplurals=2; plural=(n != 1)\n"
+
+msgid ""
+"\"volume_extension:types_extra_specs:create\": \"rule:admin or rule:"
+"type_admin\", \"volume_extension:types_extra_specs:delete\": \"rule:admin or "
+"rule:type_admin\", \"volume_extension:types_extra_specs:index\": \"\", "
+"\"volume_extension:types_extra_specs:show\": \"rule:admin or rule:type_admin "
+"or rule:type_viewer\", \"volume_extension:types_extra_specs:update\": \"rule:"
+"admin or rule:type_admin\""
+msgstr ""
+"\"volume_extension:types_extra_specs:create\": \"rule:admin or rule:"
+"type_admin\", \"volume_extension:types_extra_specs:delete\": \"rule:admin or "
+"rule:type_admin\", \"volume_extension:types_extra_specs:index\": \"\", "
+"\"volume_extension:types_extra_specs:show\": \"rule:admin or rule:type_admin "
+"or rule:type_viewer\", \"volume_extension:types_extra_specs:update\": \"rule:"
+"admin or rule:type_admin\""
+
+msgid "10.0.0"
+msgstr "10.0.0"
+
+msgid "10.0.1"
+msgstr "10.0.1"
+
+msgid "10.0.3"
+msgstr "10.0.3"
+
+msgid "10.0.4"
+msgstr "10.0.4"
+
+msgid "10.0.5"
+msgstr "10.0.5"
+
+msgid "10.0.7"
+msgstr "10.0.7"
+
+msgid "10.0.8"
+msgstr "10.0.8"
+
+msgid "10.0.8-20"
+msgstr "10.0.8-20"
+
+msgid "11.0.0"
+msgstr "11.0.0"
+
+msgid "11.0.1"
+msgstr "11.0.1"
+
+msgid "11.0.2"
+msgstr "11.0.2"
+
+msgid "11.1.1"
+msgstr "11.1.1"
+
+msgid "11.2.0"
+msgstr "11.2.0"
+
+msgid "11.2.1"
+msgstr "11.2.1"
+
+msgid "11.2.2"
+msgstr "11.2.2"
+
+msgid "11.2.2-15"
+msgstr "11.2.2-15"
+
+msgid "12.0.0"
+msgstr "12.0.0"
+
+msgid "12.0.1"
+msgstr "12.0.1"
+
+msgid "12.0.10"
+msgstr "12.0.10"
+
+msgid "12.0.10-6"
+msgstr "12.0.10-6"
+
+msgid "12.0.2"
+msgstr "12.0.2"
+
+msgid "12.0.3"
+msgstr "12.0.3"
+
+msgid "12.0.4"
+msgstr "12.0.4"
+
+msgid "12.0.5"
+msgstr "12.0.5"
+
+msgid "12.0.6"
+msgstr "12.0.6"
+
+msgid "12.0.7"
+msgstr "12.0.7"
+
+msgid "12.0.8"
+msgstr "12.0.8"
+
+msgid "13.0.0"
+msgstr "13.0.0"
+
+msgid "13.0.1"
+msgstr "13.0.1"
+
+msgid "13.0.2"
+msgstr "13.0.2"
+
+msgid "13.0.3"
+msgstr "13.0.3"
+
+msgid "13.0.4"
+msgstr "13.0.4"
+
+msgid "13.0.6"
+msgstr "13.0.6"
+
+msgid "13.0.7"
+msgstr "13.0.7"
+
+msgid "13.0.8"
+msgstr "13.0.8"
+
+msgid "13.0.9"
+msgstr "13.0.9"
+
+msgid "14.0.0"
+msgstr "14.0.0"
+
+msgid "14.0.1"
+msgstr "14.0.1"
+
+msgid "14.0.2"
+msgstr "14.0.2"
+
+msgid "14.0.3"
+msgstr "14.0.3"
+
+msgid "15.0.0"
+msgstr "15.0.0"
+
+msgid "15.0.1"
+msgstr "15.0.1"
+
+msgid "15.0.1-18"
+msgstr "15.0.1-18"
+
+msgid "16.0.0.0b1"
+msgstr "16.0.0.0b1"
+
+msgid ""
+"3PAR driver creates FC VLUN of match-set type instead of host sees. With "
+"match-set, the host will see the virtual volume on specified NSP (Node-Slot-"
+"Port). This change in vlun type fixes bug 1577993."
+msgstr ""
+"3PAR driver creates FC VLUN of match-set type instead of host sees. With "
+"match-set, the host will see the virtual volume on specified NSP (Node-Slot-"
+"Port). This change in vlun type fixes bug 1577993."
+
+msgid "7.0.1"
+msgstr "7.0.1"
+
+msgid "7.0.2"
+msgstr "7.0.2"
+
+msgid "7.0.3"
+msgstr "7.0.3"
+
+msgid "8.0.0"
+msgstr "8.0.0"
+
+msgid "8.1.0"
+msgstr "8.1.0"
+
+msgid "8.1.1"
+msgstr "8.1.1"
+
+msgid "8.1.1-11"
+msgstr "8.1.1-11"
+
+msgid "9.0.0"
+msgstr "9.0.0"
+
+msgid "9.1.0"
+msgstr "9.1.0"
+
+msgid "9.1.1"
+msgstr "9.1.1"
+
+msgid "9.1.2"
+msgstr "9.1.2"
+
+msgid ""
+"A bug in the Quobyte driver was fixed that prevented backing up volumes and "
+"snapshots"
+msgstr ""
+"A bug in the Quobyte driver was fixed that prevented backing up volumes and "
+"snapshots"
+
+msgid ""
+"A general framework to accommodate hardware compression accelerators for "
+"compression of volumes uploaded to the Image service (Glance) as images and "
+"decompression of compressed images used to create volumes is introduced."
+msgstr ""
+"A general framework to accommodate hardware compression accelerators for "
+"compression of volumes uploaded to the Image service (Glance) as images and "
+"decompression of compressed images used to create volumes is introduced."
+
+msgid ""
+"A lock in the volume manager flow generally prevents this on normal clone "
+"volume operations, but this clone method in the driver is called for "
+"operations such as cloning from the cinder image-volume cache or cloning "
+"from a cinder backend used as a glance store."
+msgstr ""
+"A lock in the volume manager flow generally prevents this on normal clone "
+"volume operations, but this clone method in the driver is called for "
+"operations such as cloning from the Cinder image-volume cache or cloning "
+"from a Cinder backend used as a Glance store."
+
+msgid ""
+"A new API to display the volumes summary. This summary API displays the "
+"total number of volumes and total volume's size in GB."
+msgstr ""
+"A new API to display the volumes summary. This summary API displays the "
+"total number of volumes and total volume's size in GB."
+
+msgid ""
+"A new check is added to the ``cinder-status upgrade check`` CLI to check for "
+"the configuration of CoprHD, HGST or ITRI DISCO drivers.  These drivers were "
+"removed in the Stein release and should not be configured at the time of "
+"upgrade."
+msgstr ""
+"A new check is added to the ``cinder-status upgrade check`` CLI to check for "
+"the configuration of CoprHD, HGST or ITRI DISCO drivers.  These drivers were "
+"removed in the Stein release and should not be configured at the time of "
+"upgrade."
+
+msgid ""
+"A new check is added to the ``cinder-status upgrade check`` CLI to check for "
+"the use of ``cinder.volume.drivers.windows.windows.WindowsDriver`` and a "
+"message is reported that the user needs to update the setting to ``cinder."
+"volume.drivers.windows.iscsi.WindowsISCSIDriver`` if it is encountered."
+msgstr ""
+"A new check is added to the ``cinder-status upgrade check`` CLI to check for "
+"the use of ``cinder.volume.drivers.windows.windows.WindowsDriver`` and a "
+"message is reported that the user needs to update the setting to ``cinder."
+"volume.drivers.windows.iscsi.WindowsISCSIDriver`` if it is encountered."
+
+msgid ""
+"A new check is added to the ``cinder-status upgrade check`` CLI to check for "
+"the use of backup driver module path instead of full driver class path in "
+"the ``backup_driver`` configuration setting."
+msgstr ""
+"A new check is added to the ``cinder-status upgrade check`` CLI to check for "
+"the use of backup driver module path instead of full driver class path in "
+"the ``backup_driver`` configuration setting."
+
+msgid ""
+"A new check is added to the ``cinder-status upgrade check`` CLI to check for "
+"the use of the deprecated ``cinder.quota.NestedDbQuotaDriver``. This driver "
+"will be replaced by a new, OpenStack-wide, nested quota management."
+msgstr ""
+"A new check is added to the ``cinder-status upgrade check`` CLI to check for "
+"the use of the deprecated ``cinder.quota.NestedDbQuotaDriver``. This driver "
+"will be replaced by a new, OpenStack-wide, nested quota management."
+
+msgid ""
+"A new cinder-manage command, reset_active_backend, was added to promote a "
+"failed-over backend participating in replication.  This allows you to reset "
+"a backend without manually editing the database.  A backend undergoing "
+"promotion using this command is expected to be in a disabled and frozen "
+"state.  Support for both standalone and clustered backend configurations are "
+"supported."
+msgstr ""
+"A new cinder-manage command, reset_active_backend, was added to promote a "
+"failed-over backend participating in replication.  This allows you to reset "
+"a backend without manually editing the database.  A backend undergoing "
+"promotion using this command is expected to be in a disabled and frozen "
+"state.  Support for both standalone and clustered backend configurations are "
+"supported."
+
+msgid ""
+"A new target, NVMET, is added for the LVM driver over RDMA, it allows cinder "
+"to use nvmetcli in order to create/delete subsystems on attaching/detaching "
+"an LVM volume to/from an instance."
+msgstr ""
+"A new target, NVMET, is added for the LVM driver over RDMA, it allows Cinder "
+"to use nvmetcli in order to create/delete subsystems on attaching/detaching "
+"an LVM volume to/from an instance."
+
+msgid ""
+"A new target, spdk-nvmeof, is added for the SPDK driver over RDMA. It allows "
+"cinder to use SPDK target in order to create/delete subsystems on attaching/"
+"detaching an SPDK volume to/from an instance."
+msgstr ""
+"A new target, spdk-nvmeof, is added for the SPDK driver over RDMA. It allows "
+"Cinder to use SPDK target in order to create/delete subsystems on attaching/"
+"detaching an SPDK volume to/from an instance."
+
+msgid ""
+"A new volume driver, SPDK, is added for Storage Performance Development Kit "
+"NVMe-oF target handling, that allows Cinder to manage volumes in SPDK NVMe-"
+"oF driver."
+msgstr ""
+"A new volume driver, SPDK, is added for Storage Performance Development Kit "
+"NVMe-oF target handling, that allows Cinder to manage volumes in SPDK NVMe-"
+"oF driver."
+
+msgid "A new volume is created without a type"
+msgstr "A new volume is created without a type"
+
+msgid ""
+"Add 'LUNType' configuration verification for Huawei driver when connecting "
+"to Dorado array. Because Dorado array only supports 'Thin' lun type, so "
+"'LUNType' only can be configured as 'Thin', any other type is invalid and if "
+"'LUNType' not explicitly configured, by default use 'Thin' for Dorado array."
+msgstr ""
+"Add 'LUNType' configuration verification for Huawei driver when connecting "
+"to Dorado array. Because Dorado array only supports 'Thin' LUN type, so "
+"'LUNType' only can be configured as 'Thin', any other type is invalid and if "
+"'LUNType' not explicitly configured, by default use 'Thin' for Dorado array."
+
+msgid ""
+"Add 'display_name' and 'display_description' validation for creating/"
+"updating snapshot and volume operations."
+msgstr ""
+"Add 'display_name' and 'display_description' validation for creating/"
+"updating snapshot and volume operations."
+
+msgid "Add CG capability to generic volume groups in Huawei driver."
+msgstr "Add CG capability to generic volume groups in Huawei driver."
+
+msgid "Add CG capability to generic volume groups in INFINIDAT driver."
+msgstr "Add CG capability to generic volume groups in INFINIDAT driver."
+
+msgid ""
+"Add Support for QoS in the Nimble Storage driver. QoS is available from "
+"Nimble OS release 4.x and above."
+msgstr ""
+"Add Support for QoS in the Nimble Storage driver. QoS is available from "
+"Nimble OS release 4.x and above."
+
+msgid "Add Support for deduplication of volumes in the Nimble Storage driver."
+msgstr ""
+"Add Support for de-duplication of volumes in the Nimble Storage driver."
+
+msgid "Add ``admin_or_storage_type_admin`` rule to ``policy.json``, e.g."
+msgstr "Add ``admin_or_storage_type_admin`` rule to ``policy.json``, e.g."
+
+msgid ""
+"Add ``all_tenants``, ``project_id`` support in attachment list&detail APIs."
+msgstr ""
+"Add ``all_tenants``, ``project_id`` support in attachment list&detail APIs."
+
+msgid ""
+"Add ``all_tenants``, ``project_id`` support in the attachment list and "
+"detail APIs."
+msgstr ""
+"Add ``all_tenants``, ``project_id`` support in the attachment list and "
+"detail APIs."
+
+msgid "Add ``storage_type_admin`` role."
+msgstr "Add ``storage_type_admin`` role."
+
+msgid ""
+"Add ``user_id`` attribute to response body of list backup with detail and "
+"show backup detail APIs."
+msgstr ""
+"Add ``user_id`` attribute to response body of list backup with detail and "
+"show backup detail APIs."
+
+msgid "Add ``user_id`` field to snapshot list/detail and snapshot show."
+msgstr "Add ``user_id`` field to snapshot list/detail and snapshot show."
+
+msgid "Add ``volume-type`` filter to API Get-Pools"
+msgstr "Add ``volume-type`` filter to API Get-Pools"
+
+msgid ""
+"Add ability to call failover-host on a replication enabled SF cluster a "
+"second time with host id = default to initiate a failback to the default "
+"configured SolidFire Cluster."
+msgstr ""
+"Add ability to call failover-host on a replication enabled SF cluster a "
+"second time with host id = default to initiate a failback to the default "
+"configured SolidFire Cluster."
+
+msgid ""
+"Add ability to enable multi-initiator support to allow live migration in the "
+"Nimble backend driver."
+msgstr ""
+"Add ability to enable multi-initiator support to allow live migration in the "
+"Nimble backend driver."
+
+msgid ""
+"Add ability to extend ``in-use`` volume. User should be aware of the whole "
+"environment before using this feature because it's dependent on several "
+"external factors below:"
+msgstr ""
+"Add ability to extend ``in-use`` volume. User should be aware of the whole "
+"environment before using this feature because it's dependent on several "
+"external factors below:"
+
+msgid "Add ability to specify backup driver via class name."
+msgstr "Add ability to specify backup driver via class name."
+
+msgid "Add backup snapshots support for Storwize/SVC driver."
+msgstr "Add backup snapshots support for Storwize/SVC driver."
+
+msgid "Add chap authentication support for the vmax backend."
+msgstr "Add CHAP authentication support for the vmax backend."
+
+msgid ""
+"Add consistency group capability to Generic Volume Groups in the Dell EMC SC "
+"driver."
+msgstr ""
+"Add consistency group capability to Generic Volume Groups in the Dell EMC SC "
+"driver."
+
+msgid ""
+"Add consistency group capability to generic volume groups in Storwize "
+"drivers."
+msgstr ""
+"Add consistency group capability to generic volume groups in Storwize "
+"drivers."
+
+msgid "Add consistency group replication support in XIV\\A9000 Cinder driver."
+msgstr "Add consistency group replication support in XIV\\A9000 Cinder driver."
+
+msgid ""
+"Add consistent group capability to generic volume groups in CoprHD driver."
+msgstr ""
+"Add consistent group capability to generic volume groups in CoprHD driver."
+
+msgid ""
+"Add consistent group capability to generic volume groups in Lefthand driver."
+msgstr ""
+"Add consistent group capability to generic volume groups in Lefthand driver."
+
+msgid ""
+"Add consistent group capability to generic volume groups in Pure drivers."
+msgstr ""
+"Add consistent group capability to generic volume groups in Pure drivers."
+
+msgid "Add consistent group capability to generic volume groups in VNX driver."
+msgstr ""
+"Add consistent group capability to generic volume groups in VNX driver."
+
+msgid ""
+"Add consistent group capability to generic volume groups in XIV, Spectrum "
+"Accelerate and A9000/R storage systems."
+msgstr ""
+"Add consistent group capability to generic volume groups in XIV, Spectrum "
+"Accelerate and A9000/R storage systems."
+
+msgid ""
+"Add consistent group capability to generic volume groups in the SolidFire "
+"driver."
+msgstr ""
+"Add consistent group capability to generic volume groups in the SolidFire "
+"driver."
+
+msgid ""
+"Add consistent group capability to generic volume groups in the XtremIO "
+"driver."
+msgstr ""
+"Add consistent group capability to generic volume groups in the XtremIO "
+"driver."
+
+msgid ""
+"Add consistent group snapshot support to generic volume groups in VMAX "
+"driver version 3.0."
+msgstr ""
+"Add consistent group snapshot support to generic volume groups in VMAX "
+"driver version 3.0."
+
+msgid ""
+"Add consistent replication group support in Dell EMC VMAX cinder driver."
+msgstr ""
+"Add consistent replication group support in Dell EMC VMAX cinder driver."
+
+msgid "Add consistent replication group support in Storwize Cinder driver."
+msgstr "Add consistent replication group support in Storwize Cinder driver."
+
+msgid "Add consistent replication group support in VNX cinder driver."
+msgstr "Add consistent replication group support in VNX cinder driver."
+
+msgid ""
+"Add enhanced support to the QNAP Cinder driver, including 'CHAP', 'Thin "
+"Provision', 'SSD Cache', 'Dedup' and 'Compression'."
+msgstr ""
+"Add enhanced support to the QNAP Cinder driver, including 'CHAP', 'Thin "
+"Provision', 'SSD Cache', 'Dedup' and 'Compression'."
+
+msgid "Add filter, sorter and pagination support in group snapshot listings."
+msgstr "Add filter, sorter and pagination support in group snapshot listings."
+
+msgid "Add filters support to get_pools API v3.28."
+msgstr "Add filters support to get_pools API v3.28."
+
+msgid ""
+"Add get_manageable_volumes and get_manageable_snapshots implementations for "
+"Pure Storage Volume Drivers."
+msgstr ""
+"Add get_manageable_volumes and get_manageable_snapshots implementations for "
+"Pure Storage Volume Drivers."
+
+msgid ""
+"Add global mirror with change volumes(gmcv) support and user can manage gmcv "
+"replication volume by SVC driver. An example to set a gmcv replication "
+"volume type, set property replication_type as \"<in> gmcv\", property "
+"replication_enabled as \"<is> True\" and set property drivers:"
+"cycle_period_seconds as 500."
+msgstr ""
+"Add global mirror with change volumes(gmcv) support and user can manage gmcv "
+"replication volume by SVC driver. An example to set a gmcv replication "
+"volume type, set property replication_type as \"<in> gmcv\", property "
+"replication_enabled as \"<is> True\" and set property drivers:"
+"cycle_period_seconds as 500."
+
+msgid ""
+"Add granularity to the ``volume_extension:volume_type_encryption`` policy "
+"with the addition of distinct actions for create, get, update, and delete:"
+msgstr ""
+"Add granularity to the ``volume_extension:volume_type_encryption`` policy "
+"with the addition of distinct actions for create, get, update, and delete:"
+
+msgid "Add mirrored volume support in IBM SVC/Storwize driver."
+msgstr "Add mirrored volume support in IBM SVC/Storwize driver."
+
+msgid "Add multipath enhancement to Storwize iSCSI driver."
+msgstr "Add multipath enhancement to Storwize iSCSI driver."
+
+msgid ""
+"Add option `max_luns_per_storage_group` back. The max LUNs per storage group "
+"was set to 255 before. With the new option, admin can set it to a larger "
+"number."
+msgstr ""
+"Add option `max_luns_per_storage_group` back. The max LUNs per storage group "
+"was set to 255 before. With the new option, admin can set it to a larger "
+"number."
+
+msgid "Add provider_id in the detailed view of a volume for admin."
+msgstr "Add provider_id in the detailed view of a volume for admin."
+
+msgid "Add replication consistency group support in DS8K cinder driver."
+msgstr "Add replication consistency group support in DS8K cinder driver."
+
+msgid "Add retype functionality to VMAX driver version 3.0."
+msgstr "Add retype functionality to VMAX driver version 3.0."
+
+msgid "Add revert to snapshot API and support in LVM driver."
+msgstr "Add revert to snapshot API and support in LVM driver."
+
+msgid "Add reverting to snapshot support in Storwize Cinder driver."
+msgstr "Add reverting to snapshot support in Storwize Cinder driver."
+
+msgid "Add support for deferred deletion in the RBD volume driver."
+msgstr "Add support for deferred deletion in the RBD volume driver."
+
+msgid "Add support for hybrid aggregates to the NetApp cDOT drivers."
+msgstr "Add support for hybrid aggregates to the NetApp cDOT drivers."
+
+msgid "Add support for reporting pool disk type in Huawei driver."
+msgstr "Add support for reporting pool disk type in Huawei driver."
+
+msgid "Add support for sorting backups by \"name\"."
+msgstr "Add support for sorting backups by \"name\"."
+
+msgid ""
+"Add support to backup volume using snapshot in the Unity driver, which "
+"enables backing up of volumes that are in-use."
+msgstr ""
+"Add support to backup volume using snapshot in the Unity driver, which "
+"enables backing up of volumes that are in-use."
+
+msgid "Add support to backup volume using snapshot in the Unity driver."
+msgstr "Add support to backup volume using snapshot in the Unity driver."
+
+msgid "Add support to configure IO ports option in Dell EMC Unity driver."
+msgstr "Add support to configure IO ports option in Dell EMC Unity driver."
+
+msgid "Add support to force detach a volume from all hosts on 3PAR."
+msgstr "Add support to force detach a volume from all hosts on 3PAR."
+
+msgid "Add support to force detach a volume from all hosts on Unity."
+msgstr "Add support to force detach a volume from all hosts on Unity."
+
+msgid "Add support to force detach a volume from all hosts on VNX."
+msgstr "Add support to force detach a volume from all hosts on VNX."
+
+msgid ""
+"Add thin clone support in the Unity driver. Unity storage supports the thin "
+"clone of a LUN from OE version 4.2.0. It is more efficient than the dd "
+"solution. However, there is a limit of thin clone inside each LUN family. "
+"Every time the limit reaches, a new LUN family will be created by a dd-copy, "
+"and then the volume clone afterward will use the thin clone of the new LUN "
+"family."
+msgstr ""
+"Add thin clone support in the Unity driver. Unity storage supports the thin "
+"clone of a LUN from OE version 4.2.0. It is more efficient than the dd "
+"solution. However, there is a limit of thin clone inside each LUN family. "
+"Every time the limit reaches, a new LUN family will be created by a dd-copy, "
+"and then the volume clone afterwards will use the thin clone of the new LUN "
+"family."
+
+msgid "Add v2.1 volume replication support in VMAX driver."
+msgstr "Add v2.1 volume replication support in VMAX driver."
+
+msgid ""
+"Added \"backend_state: up/down\" in response body of service list if context "
+"is admin. This feature will help operators or cloud management system to get "
+"the backend device state in every service. If device state is *down*, "
+"specify that storage device has got some problems. Give more information to "
+"locate bugs quickly."
+msgstr ""
+"Added \"backend_state: up/down\" in response body of service list if context "
+"is admin. This feature will help operators or cloud management system to get "
+"the backend device state in every service. If device state is *down*, "
+"specify that storage device has got some problems. Give more information to "
+"locate bugs quickly."
+
+msgid ""
+"Added Cheesecake (v2.1) replication support to the Pure Storage Volume "
+"drivers."
+msgstr ""
+"Added Cheesecake (v2.1) replication support to the Pure Storage Volume "
+"drivers."
+
+msgid "Added Cinder consistency group for the NetApp NFS driver."
+msgstr "Added Cinder consistency group for the NetApp NFS driver."
+
+msgid "Added Cinder fast-retype support to Datera EDF driver."
+msgstr "Added Cinder fast-retype support to Datera EDF driver."
+
+msgid "Added Consistency Group support in ScaleIO driver."
+msgstr "Added Consistency Group support in ScaleIO driver."
+
+msgid "Added Datera EDF API 2.1 support."
+msgstr "Added Datera EDF API 2.1 support."
+
+msgid "Added Datera Multi-Tenancy Support."
+msgstr "Added Datera Multi-Tenancy Support."
+
+msgid "Added Datera Template Support."
+msgstr "Added Datera Template Support."
+
+msgid "Added HA support for NexentaEdge iSCSI driver"
+msgstr "Added HA support for NexentaEdge iSCSI driver"
+
+msgid "Added ISCSI based driver for Veritas Access."
+msgstr "Added iSCSI based driver for Veritas Access."
+
+msgid "Added Keystone v3 support for Swift backup driver in single user mode."
+msgstr "Added Keystone v3 support for Swift backup driver in single user mode."
+
+msgid "Added Migrate and Extend for Nexenta NFS driver."
+msgstr "Added Migrate and Extend for Nexenta NFS driver."
+
+msgid "Added NBD driver for NexentaEdge."
+msgstr "Added NBD driver for NexentaEdge."
+
+msgid "Added NFS based driver for Veritas Access."
+msgstr "Added NFS based driver for Veritas Access."
+
+msgid "Added Nimble Storage Fibre Channel backend driver."
+msgstr "Added Nimble Storage Fibre Channel backend driver."
+
+msgid "Added QoS support in ScaleIO driver."
+msgstr "Added QoS support in ScaleIO driver."
+
+msgid ""
+"Added RBD keyring configuration parameter ``rbd_keyring_conf`` to define "
+"custom path of Ceph keyring file."
+msgstr ""
+"Added RBD keyring configuration parameter ``rbd_keyring_conf`` to define "
+"custom path of Ceph keyring file."
+
+msgid "Added REST API to update backup name and description."
+msgstr "Added REST API to update backup name and description."
+
+msgid ""
+"Added RPC backward compatibility layer similar to the one implemented in "
+"Nova. This means that Cinder services can be upgraded one-by-one without "
+"breakage. After all the services are upgraded SIGHUP signals should be "
+"issued to all the services to signal them to reload cached minimum RPC "
+"versions. Alternative is of course restart of them. Please note that cinder-"
+"api service doesn't support SIGHUP yet. Please also take into account that "
+"all the rolling upgrades capabilities are considered tech preview, as we "
+"don't have a CI testing it yet."
+msgstr ""
+"Added RPC backward compatibility layer similar to the one implemented in "
+"Nova. This means that Cinder services can be upgraded one-by-one without "
+"breakage. After all the services are upgraded SIGHUP signals should be "
+"issued to all the services to signal them to reload cached minimum RPC "
+"versions. Alternative is of course restart of them. Please note that cinder-"
+"api service doesn't support SIGHUP yet. Please also take into account that "
+"all the rolling upgrades capabilities are considered tech preview, as we "
+"don't have a CI testing it yet."
+
+msgid "Added Retype functionality to Nexenta iSCSI and NFS drivers."
+msgstr "Added Retype functionality to Nexenta iSCSI and NFS drivers."
+
+msgid "Added Volume Placement extra-specs support to Datera EDF driver."
+msgstr "Added Volume Placement extra-specs support to Datera EDF driver."
+
+msgid "Added ``datera_disable_profiler`` boolean config option."
+msgstr "Added ``datera_disable_profiler`` boolean config option."
+
+msgid "Added ``resource_filters`` API to retrieve configured resource filters."
+msgstr ""
+"Added ``resource_filters`` API to retrieve configured resource filters."
+
+msgid ""
+"Added a new config ``reinit_driver_count`` in volume driver, which indicates "
+"the maximum retry limit for driver re-initialization when it fails to "
+"initialize a volume driver. Its default value is 3. The interval of retry is "
+"exponentially backoff, and will be 1s, 2s, 4s etc."
+msgstr ""
+"Added a new config ``reinit_driver_count`` in volume driver, which indicates "
+"the maximum retry limit for driver re-initialisation when it fails to "
+"initialise a volume driver. Its default value is 3. The interval of retry is "
+"exponentially back-off, and will be 1s, 2s, 4s etc."
+
+msgid ""
+"Added a new config option `scheduler_weight_handler`. This is a global "
+"option which specifies how the scheduler should choose from a listed of "
+"weighted pools. By default the existing weigher is used which always chooses "
+"the highest weight."
+msgstr ""
+"Added a new config option `scheduler_weight_handler`. This is a global "
+"option which specifies how the scheduler should choose from a listed of "
+"weighted pools. By default the existing weigher is used which always chooses "
+"the highest weight."
+
+msgid ""
+"Added a new option ``quobyte_overlay_volumes`` for the Quobyte volume "
+"driver. This option activates internal snapshots who allow to create volumes "
+"from snapshots as overlay files based on the volume from snapshot cache. "
+"This significantly speeds up the creation of volumes from large snapshots."
+msgstr ""
+"Added a new option ``quobyte_overlay_volumes`` for the Quobyte volume "
+"driver. This option activates internal snapshots who allow to create volumes "
+"from snapshots as overlay files based on the volume from snapshot cache. "
+"This significantly speeds up the creation of volumes from large snapshots."
+
+msgid ""
+"Added a new optional cache of volumes generated from snapshots for the "
+"Quobyte backend. Enabling this cache speeds up creation of multiple volumes "
+"from a single snapshot at the cost of a slight increase in creation time for "
+"the first volume generated for this given snapshot. The "
+"``quobyte_volume_from_snapshot_cache`` option is off by default."
+msgstr ""
+"Added a new optional cache of volumes generated from snapshots for the "
+"Quobyte backend. Enabling this cache speeds up creation of multiple volumes "
+"from a single snapshot at the cost of a slight increase in creation time for "
+"the first volume generated for this given snapshot. The "
+"``quobyte_volume_from_snapshot_cache`` option is off by default."
+
+msgid ""
+"Added a new weight handler `StochasticHostWeightHandler`. This weight "
+"handler chooses pools randomly, where the random probabilities are "
+"proportional to the weights, so higher weighted pools are chosen more "
+"frequently, but not all the time. This weight handler spreads new shares "
+"across available pools more fairly."
+msgstr ""
+"Added a new weight handler `StochasticHostWeightHandler`. This weight "
+"handler chooses pools randomly, where the random probabilities are "
+"proportional to the weights, so higher weighted pools are chosen more "
+"frequently, but not all the time. This weight handler spreads new shares "
+"across available pools more fairly."
+
+msgid "Added ability to backup snapshots."
+msgstr "Added ability to backup snapshots."
+
+msgid "Added ability to list all manageable volumes within ScaleIO Driver."
+msgstr "Added ability to list all manageable volumes within ScaleIO Driver."
+
+msgid ""
+"Added ability to purge records less than 1 day old, using the cinder-manage "
+"db_purge utility. This helps especially for those testing scenarios in which "
+"a a large number of volumes are created and deleted. (bug"
+msgstr ""
+"Added ability to purge records less than 1 day old, using the cinder-manage "
+"db_purge utility. This helps especially for those testing scenarios in which "
+"a a large number of volumes are created and deleted. (bug"
+
+msgid "Added ability to query backups by project ID."
+msgstr "Added ability to query backups by project ID."
+
+msgid ""
+"Added ability to specify multiple storage pools in the FalconStor driver."
+msgstr ""
+"Added ability to specify multiple storage pools in the FalconStor driver."
+
+msgid ""
+"Added additional metrics reported to the scheduler for Pure Volume Drivers "
+"for better filtering and weighing functions."
+msgstr ""
+"Added additional metrics reported to the scheduler for Pure Volume Drivers "
+"for better filtering and weighing functions."
+
+msgid ""
+"Added an ``excluded_domain_ips`` option to the Dell EMC SC driver. This is "
+"identical to the excluded_domain_ip option only comma separated rather than "
+"multiple entry. This is concatenated with the ``excluded_domain_ip`` option."
+msgstr ""
+"Added an ``excluded_domain_ips`` option to the Dell EMC SC driver. This is "
+"identical to the excluded_domain_ip option only comma separated rather than "
+"multiple entry. This is concatenated with the ``excluded_domain_ip`` option."
+
+msgid ""
+"Added asynchronous remote replication support in Dell EMC VMAX cinder driver."
+msgstr ""
+"Added asynchronous remote replication support in Dell EMC VMAX Cinder driver."
+
+msgid "Added attribute ``connection_info`` to attachment object."
+msgstr "Added attribute ``connection_info`` to attachment object."
+
+msgid ""
+"Added automatic configuration of SAN access control for the NEC volume "
+"driver."
+msgstr ""
+"Added automatic configuration of SAN access control for the NEC volume "
+"driver."
+
+msgid "Added availability_zone filter for snapshots list."
+msgstr "Added availability_zone filter for snapshots list."
+
+msgid "Added backend FC and iSCSI drivers for NEC Storage."
+msgstr "Added backend FC and iSCSI drivers for NEC Storage."
+
+msgid "Added backend ISCSI driver for Reduxio."
+msgstr "Added backend ISCSI driver for Reduxio."
+
+msgid "Added backend driver for Coho Data storage."
+msgstr "Added backend driver for Coho Data storage."
+
+msgid "Added backend driver for DISCO storage."
+msgstr "Added backend driver for DISCO storage."
+
+msgid "Added backend driver for Dell EMC Unity storage."
+msgstr "Added backend driver for Dell EMC Unity storage."
+
+msgid "Added backend driver for FalconStor FreeStor."
+msgstr "Added backend driver for FalconStor FreeStor."
+
+msgid "Added backend driver for Fujitsu ETERNUS DX (FC)."
+msgstr "Added backend driver for Fujitsu ETERNUS DX (FC)."
+
+msgid "Added backend driver for Fujitsu ETERNUS DX (iSCSI)."
+msgstr "Added backend driver for Fujitsu ETERNUS DX (iSCSI)."
+
+msgid "Added backend driver for Hedvig iSCSI storage."
+msgstr "Added backend driver for Hedvig iSCSI storage."
+
+msgid "Added backend driver for Huawei FusionStorage."
+msgstr "Added backend driver for Huawei FusionStorage."
+
+msgid "Added backend driver for Nexenta Edge iSCSI storage."
+msgstr "Added backend driver for Nexenta Edge iSCSI storage."
+
+msgid "Added backend driver for NexentaStor5 NFS storage."
+msgstr "Added backend driver for NexentaStor5 NFS storage."
+
+msgid "Added backend driver for NexentaStor5 iSCSI storage."
+msgstr "Added backend driver for NexentaStor5 iSCSI storage."
+
+msgid "Added backend driver for Synology iSCSI-supported storage."
+msgstr "Added backend driver for Synology iSCSI-supported storage."
+
+msgid "Added backend driver for VMware VStorageObject (First Class Disk)."
+msgstr "Added backend driver for VMware VStorageObject (First Class Disk)."
+
+msgid "Added backend driver for Violin Memory 7000 iscsi storage."
+msgstr "Added backend driver for Violin Memory 7000 iSCSI storage."
+
+msgid "Added backend driver for ZTE iSCSI storage."
+msgstr "Added backend driver for ZTE iSCSI storage."
+
+msgid ""
+"Added boolean conf option 'split_loggers' in [default] section of cinder."
+"conf to `enable split logging`_ functionality. The default value of "
+"split_loggers option is set to False. Operator can set it's value to True to "
+"split HTTP content into subloggers to allow for fine-grained control of what "
+"is logged and how. This new config option 'split_loggers' should be enabled "
+"only when keystoneauth log level is set to DEBUG in 'default_log_levels' "
+"config option."
+msgstr ""
+"Added boolean conf option 'split_loggers' in [default] section of cinder."
+"conf to `enable split logging`_ functionality. The default value of "
+"split_loggers option is set to False. Operator can set it's value to True to "
+"split HTTP content into subloggers to allow for fine-grained control of what "
+"is logged and how. This new config option 'split_loggers' should be enabled "
+"only when keystoneauth log level is set to DEBUG in 'default_log_levels' "
+"config option."
+
+msgid "Added cinder backup driver for Google Cloud Storage."
+msgstr "Added Cinder backup driver for Google Cloud Storage."
+
+msgid ""
+"Added config option ``vmware_adapter_type`` for the VMware VMDK driver to "
+"specify the default adapter type for volumes in vCenter server."
+msgstr ""
+"Added config option ``vmware_adapter_type`` for the VMware VMDK driver to "
+"specify the default adapter type for volumes in vCenter server."
+
+msgid ""
+"Added config option ``vmware_connection_pool_size`` in the VMware VMDK "
+"driver to specify the maximum number of connections (to vCenter) in the http "
+"connection pool."
+msgstr ""
+"Added config option ``vmware_connection_pool_size`` in the VMware VMDK "
+"driver to specify the maximum number of connections (to vCenter) in the HTTP "
+"connection pool."
+
+msgid ""
+"Added config option to enable/disable automatically calculation an over-"
+"subscription ratio max for Pure Volume Drivers. When disabled the drivers "
+"will now respect the max_oversubscription_ratio config option."
+msgstr ""
+"Added config option to enable/disable automatically calculation an over-"
+"subscription ratio max for Pure Volume Drivers. When disabled the drivers "
+"will now respect the max_oversubscription_ratio config option."
+
+msgid ""
+"Added consistency group capability to generic volume groups in the HPE 3PAR "
+"driver."
+msgstr ""
+"Added consistency group capability to generic volume groups in the HPE 3PAR "
+"driver."
+
+msgid ""
+"Added consistency group support to generic volume groups in ScaleIO Driver."
+msgstr ""
+"Added consistency group support to generic volume groups in ScaleIO Driver."
+
+msgid "Added consistency group support to the Huawei driver."
+msgstr "Added consistency group support to the Huawei driver."
+
+msgid ""
+"Added consistent group capability to generic volume groups in GPFS driver."
+msgstr ""
+"Added consistent group capability to generic volume groups in GPFS driver."
+
+msgid ""
+"Added consistent group capability to generic volume groups in ProphetStor "
+"driver."
+msgstr ""
+"Added consistent group capability to generic volume groups in ProphetStor "
+"driver."
+
+msgid "Added count info in volume, snapshot and backup's list APIs since 3.45."
+msgstr ""
+"Added count info in volume, snapshot and backup's list APIs since 3.45."
+
+msgid ""
+"Added create/delete APIs for group snapshots and an API to create group from "
+"source."
+msgstr ""
+"Added create/delete APIs for group snapshots and an API to create group from "
+"source."
+
+msgid ""
+"Added data reduction pool support for thin-provisoned and compressed volume "
+"in Storwize cinder driver."
+msgstr ""
+"Added data reduction pool support for thin-provisoned and compressed volume "
+"in Storwize cinder driver."
+
+msgid ""
+"Added dell_api_async_rest_timeout option to the Dell EMC SC driver. This is "
+"the timeout used for asynchronous REST calls to the Dell EMC SC REST API. "
+"Default is 15 seconds."
+msgstr ""
+"Added dell_api_async_rest_timeout option to the Dell EMC SC driver. This is "
+"the timeout used for asynchronous REST calls to the Dell EMC SC REST API. "
+"Default is 15 seconds."
+
+msgid ""
+"Added dell_api_sync_rest_timeout option to the Dell EMC SC driver. This is "
+"the timeout used for synchronous REST calls to the Dell EMC SC REST API. "
+"Default is 30 seconds."
+msgstr ""
+"Added dell_api_sync_rest_timeout option to the Dell EMC SC driver. This is "
+"the timeout used for synchronous REST calls to the Dell EMC SC REST API. "
+"Default is 30 seconds."
+
+msgid "Added driver for Tegile IntelliFlash arrays."
+msgstr "Added driver for Tegile IntelliFlash arrays."
+
+msgid "Added driver for the InfiniBox storage array."
+msgstr "Added driver for the InfiniBox storage array."
+
+msgid ""
+"Added driver-assisted volume migration to RBD driver. This allows a volume "
+"to be efficiently copied by Ceph from one pool to another within the same "
+"cluster."
+msgstr ""
+"Added driver-assisted volume migration to RBD driver. This allows a volume "
+"to be efficiently copied by Ceph from one pool to another within the same "
+"cluster."
+
+msgid "Added extend method to NFS driver for NexentaStor 5."
+msgstr "Added extend method to NFS driver for NexentaStor 5."
+
+msgid ""
+"Added flag 'backend_state' which will give backend state info in service "
+"list."
+msgstr ""
+"Added flag 'backend_state' which will give backend state info in service "
+"list."
+
+msgid ""
+"Added flag 'backend_state: up/down' which will give backend state info in "
+"service list."
+msgstr ""
+"Added flag 'backend_state: up/down' which will give backend state info in "
+"service list."
+
+msgid ""
+"Added generalized resource filter support in ``list volume``, ``list "
+"backup``, ``list snapshot``, ``list group``, ``list group-snapshot``, ``list "
+"attachment``, ``list message`` and ``list pools`` APIs."
+msgstr ""
+"Added generalised resource filter support in ``list volume``, ``list "
+"backup``, ``list snapshot``, ``list group``, ``list group-snapshot``, ``list "
+"attachment``, ``list message`` and ``list pools`` APIs."
+
+msgid ""
+"Added generic volume group capability to NetApp cDot drivers with support "
+"for write consistent group snapshots."
+msgstr ""
+"Added generic volume group capability to NetApp cDot drivers with support "
+"for write consistent group snapshots."
+
+msgid "Added get capability feature for HPE-3PAR."
+msgstr "Added get capability feature for HPE-3PAR."
+
+msgid "Added group type and group specs APIs."
+msgstr "Added group type and group specs APIs."
+
+msgid ""
+"Added host-level (whole back end replication - v2.1) replication support to "
+"the NetApp cDOT drivers (iSCSI, FC, NFS)."
+msgstr ""
+"Added host-level (whole back end replication - v2.1) replication support to "
+"the NetApp cDOT drivers (iSCSI, FC, NFS)."
+
+msgid ""
+"Added hyperswap volume and group support in Storwize cinder driver. Storwize/"
+"svc versions prior to 7.6 do not support this feature."
+msgstr ""
+"Added hyperswap volume and group support in Storwize Cinder driver. Storwize/"
+"svc versions prior to 7.6 do not support this feature."
+
+msgid "Added iSCSI CHAP uni-directional authentication for NetApp drivers."
+msgstr "Added iSCSI CHAP uni-directional authentication for NetApp drivers."
+
+msgid ""
+"Added iSCSI and Fibre Channel volume drivers for DataCore's SANsymphony and "
+"Hyper-converged Virtual SAN storage."
+msgstr ""
+"Added iSCSI and Fibre Channel volume drivers for DataCore's SANsymphony and "
+"Hyper-converged Virtual SAN storage."
+
+msgid ""
+"Added image signature verification support when creating volume from image. "
+"This depends on signature metadata from glance. This feature is turned on by "
+"default, administrators can change behaviour by updating option "
+"``verify_glance_signatures``. Also, an additional image metadata "
+"``signature_verified`` has been added to indicate whether signature "
+"verification was performed during creating process."
+msgstr ""
+"Added image signature verification support when creating volume from image. "
+"This depends on signature metadata from glance. This feature is turned on by "
+"default, administrators can change behaviour by updating option "
+"``verify_glance_signatures``. Also, an additional image metadata "
+"``signature_verified`` has been added to indicate whether signature "
+"verification was performed during creating process."
+
+msgid ""
+"Added independent and shared types for qos classes in XIV & A9000. Shared "
+"type enables to share bandwidth and IO rates between volumes of the same "
+"class. Independent type gives each volume the same bandwidth and IO rates "
+"without being affected by other volumes in the same qos class."
+msgstr ""
+"Added independent and shared types for QoS classes in XIV & A9000. Shared "
+"type enables to share bandwidth and I/O rates between volumes of the same "
+"class. Independent type gives each volume the same bandwidth and I/O rates "
+"without being affected by other volumes in the same QoS class."
+
+msgid "Added like operator support to filters for the following resources::"
+msgstr "Added like operator support to filters for the following resources::"
+
+msgid "Added manage/unmanage snapshot support for Huawei drivers."
+msgstr "Added manage/unmanage snapshot support for Huawei drivers."
+
+msgid "Added manage/unmanage snapshot support to the HNAS NFS driver."
+msgstr "Added manage/unmanage snapshot support to the HNAS NFS driver."
+
+msgid "Added manage/unmanage volume support for Dell Equallogic driver."
+msgstr "Added manage/unmanage volume support for Dell Equallogic driver."
+
+msgid "Added manage/unmanage volume support for Huawei drivers."
+msgstr "Added manage/unmanage volume support for Huawei drivers."
+
+msgid ""
+"Added metadata support for backup source. Now users can create/update "
+"metadata for a specified backup."
+msgstr ""
+"Added metadata support for backup source. Now users can create/update "
+"metadata for a specified backup."
+
+msgid "Added multiple management IP support to Storwize SVC driver."
+msgstr "Added multiple management IP support to Storwize SVC driver."
+
+msgid "Added multiple pools support to Storwize SVC driver."
+msgstr "Added multiple pools support to Storwize SVC driver."
+
+msgid ""
+"Added new APIs on microversion 3.32 to support dynamically changing log "
+"levels in Cinder services without restart as well as retrieving current log "
+"levels, which is an easy way to ping via the message broker a service."
+msgstr ""
+"Added new APIs on microversion 3.32 to support dynamically changing log "
+"levels in Cinder services without restart as well as retrieving current log "
+"levels, which is an easy way to ping via the message broker a service."
+
+msgid ""
+"Added new BoolOpt ``backup_ceph_image_journals`` for enabling the Ceph image "
+"features required to support RBD mirroring of Cinder backup pool."
+msgstr ""
+"Added new BoolOpt ``backup_ceph_image_journals`` for enabling the Ceph image "
+"features required to support RBD mirroring of Cinder backup pool."
+
+msgid ""
+"Added new Hitachi VSP FC Driver. The VSP driver supports all Hitachi VSP "
+"Family and HUSVM."
+msgstr ""
+"Added new Hitachi VSP FC Driver. The VSP driver supports all Hitachi VSP "
+"Family and HUSVM."
+
+msgid ""
+"Added new option to delete XtremIO initiator groups after the last volume "
+"was detached from them. Cleanup can be enabled by setting "
+"``xtremio_clean_unused_ig`` to ``True`` under the backend settings in cinder."
+"conf."
+msgstr ""
+"Added new option to delete XtremIO initiator groups after the last volume "
+"was detached from them. Cleanup can be enabled by setting "
+"``xtremio_clean_unused_ig`` to ``True`` under the backend settings in cinder."
+"conf."
+
+msgid "Added oversubscription support in the VMAX driver"
+msgstr "Added over-subscription support in the VMAX driver"
+
+msgid ""
+"Added periodic task to clean expired messages in cinder scheduler, also "
+"added a configuration option ``message_reap_interval`` to handle the "
+"interval."
+msgstr ""
+"Added periodic task to clean expired messages in Cinder scheduler, also "
+"added a configuration option ``message_reap_interval`` to handle the "
+"interval."
+
+msgid ""
+"Added periodic task to clean expired reservation in cinder scheduler. Added "
+"a configuration option ``reservation_clean_interval`` to handle the interval."
+msgstr ""
+"Added periodic task to clean expired reservation in Cinder scheduler. Added "
+"a configuration option ``reservation_clean_interval`` to handle the interval."
+
+msgid ""
+"Added policies to disallow multiattach operations.  This includes two "
+"policies, the first being a general policy to allow the creation or retyping "
+"of multiattach volumes is a volume create policy with the name ``volume:"
+"multiattach``. The second policy is specifically for disallowing the ability "
+"to create multiple attachments on a volume that is marked as bootable, and "
+"is an attachment policy with the name ``volume:"
+"multiattach_bootable_volume``. The default for these new policies is ``rule:"
+"admin_or_owner``; be aware that if you wish to disable either of these "
+"policies for your users you will need to modify the default policy settings."
+msgstr ""
+"Added policies to disallow multiattach operations.  This includes two "
+"policies, the first being a general policy to allow the creation or retyping "
+"of multiattach volumes is a volume create policy with the name ``volume:"
+"multiattach``. The second policy is specifically for disallowing the ability "
+"to create multiple attachments on a volume that is marked as bootable, and "
+"is an attachment policy with the name ``volume:"
+"multiattach_bootable_volume``. The default for these new policies is ``rule:"
+"admin_or_owner``; be aware that if you wish to disable either of these "
+"policies for your users you will need to modify the default policy settings."
+
+msgid "Added replication failback support for the Dell SC driver."
+msgstr "Added replication failback support for the Dell SC driver."
+
+msgid "Added replication group support in HPE 3PAR cinder driver."
+msgstr "Added replication group support in HPE 3PAR Cinder driver."
+
+msgid "Added replication v2.1 support to the Dell Storage Center drivers."
+msgstr "Added replication v2.1 support to the Dell Storage Centre drivers."
+
+msgid "Added replication v2.1 support to the IBM Storwize driver."
+msgstr "Added replication v2.1 support to the IBM Storwize driver."
+
+msgid "Added replication v2.1 support to the IBM XIV/DS8K driver."
+msgstr "Added replication v2.1 support to the IBM XIV/DS8K driver."
+
+msgid "Added reset status API to generic volume group."
+msgstr "Added reset status API to generic volume group."
+
+msgid "Added reset status API to group snapshot."
+msgstr "Added reset status API to group snapshot."
+
+msgid "Added revert volume to snapshot in 3par driver."
+msgstr "Added revert volume to snapshot in 3PAR driver."
+
+msgid ""
+"Added schema validation support using jsonschema `[json-schema-validation]`_ "
+"for all supported v3 APIs."
+msgstr ""
+"Added schema validation support using jsonschema `[json-schema-validation]`_ "
+"for all supported v3 APIs."
+
+msgid ""
+"Added secure HTTP support for REST API calls in the NexentaStor5 driver. Use "
+"of HTTPS is set True by default with option ``nexenta_use_https``."
+msgstr ""
+"Added secure HTTP support for REST API calls in the NexentaStor5 driver. Use "
+"of HTTPS is set True by default with option ``nexenta_use_https``."
+
+msgid "Added snapshot manage/unmanage support to the EMC XtremIO driver."
+msgstr "Added snapshot manage/unmanage support to the EMC XtremIO driver."
+
+msgid "Added snapshot manage/unmanage support to the HPE 3PAR driver."
+msgstr "Added snapshot manage/unmanage support to the HPE 3PAR driver."
+
+msgid "Added snapshot manage/unmanage support to the HPE LeftHand driver."
+msgstr "Added snapshot manage/unmanage support to the HPE LeftHand driver."
+
+msgid "Added support for API microversions, as well as /v3 API endpoint."
+msgstr "Added support for API microversions, as well as /v3 API endpoint."
+
+msgid ""
+"Added support for Keystone middleware feature to pass service token along "
+"with the user token for Cinder to Nova and Glance services. This will help "
+"get rid of user token expiration issues during long running tasks e.g. "
+"creating volume snapshot (Cinder->Nova) and creating volume from image "
+"(Cinder->Glance) etc. To use this functionality a service user needs to be "
+"created first. Add the service user configurations in ``cinder.conf`` under "
+"``service_user`` group and set ``send_service_user_token`` flag to ``True``."
+msgstr ""
+"Added support for Keystone middleware feature to pass service token along "
+"with the user token for Cinder to Nova and Glance services. This will help "
+"get rid of user token expiration issues during long running tasks e.g. "
+"creating volume snapshot (Cinder->Nova) and creating volume from image "
+"(Cinder->Glance) etc. To use this functionality a service user needs to be "
+"created first. Add the service user configurations in ``cinder.conf`` under "
+"``service_user`` group and set ``send_service_user_token`` flag to ``True``."
+
+msgid ""
+"Added support for QoS in the INFINIDAT InfiniBox driver. QoS is available on "
+"InfiniBox 4.0 onward."
+msgstr ""
+"Added support for QoS in the INFINIDAT InfiniBox driver. QoS is available on "
+"InfiniBox 4.0 onward."
+
+msgid "Added support for ZMQ messaging layer in multibackend configuration."
+msgstr "Added support for ZMQ messaging layer in multibackend configuration."
+
+msgid ""
+"Added support for ZeroMQ messaging driver in cinder single backend config."
+msgstr ""
+"Added support for ZeroMQ messaging driver in Cinder single backend config."
+
+msgid ""
+"Added support for active-active replication to the RBD driver.  This allows "
+"users to configure multiple volume backends that are all a member of the "
+"same cluster participating in replication."
+msgstr ""
+"Added support for active-active replication to the RBD driver.  This allows "
+"users to configure multiple volume backends that are all a member of the "
+"same cluster participating in replication."
+
+msgid ""
+"Added support for cloning volume asynchronously, it can be enabled by option "
+"async_clone set to true in parameter metadata when creating volume from "
+"volume or snapshot."
+msgstr ""
+"Added support for cloning volume asynchronously, it can be enabled by option "
+"async_clone set to true in parameter metadata when creating volume from "
+"volume or snapshot."
+
+msgid ""
+"Added support for creating a consistency group from a source consistency "
+"group in the HPE 3PAR driver."
+msgstr ""
+"Added support for creating a consistency group from a source consistency "
+"group in the HPE 3PAR driver."
+
+msgid ""
+"Added support for creating, deleting, and updating consistency groups for "
+"NetApp 7mode and CDOT backends."
+msgstr ""
+"Added support for creating, deleting, and updating consistency groups for "
+"NetApp 7mode and CDOT backends."
+
+msgid ""
+"Added support for get all distinct volumes' metadata from volume-summary API."
+msgstr ""
+"Added support for get all distinct volumes' metadata from volume-summary API."
+
+msgid ""
+"Added support for images with vmware_adaptertype set to paraVirtual in the "
+"VMDK driver."
+msgstr ""
+"Added support for images with vmware_adaptertype set to paraVirtual in the "
+"VMDK driver."
+
+msgid "Added support for manage volume in the VMware VMDK driver."
+msgstr "Added support for manage volume in the VMware VMDK driver."
+
+msgid "Added support for manage/unmanage snapshot in the ScaleIO driver."
+msgstr "Added support for manage/unmanage snapshot in the ScaleIO driver."
+
+msgid "Added support for manage/unmanage volume in the ScaleIO driver."
+msgstr "Added support for manage/unmanage volume in the ScaleIO driver."
+
+msgid ""
+"Added support for oversubscription in thin provisioning in the INFINIDAT "
+"InfiniBox driver. To use oversubscription, define "
+"``max_over_subscription_ratio`` in the cinder configuration file."
+msgstr ""
+"Added support for over-subscription in thin provisioning in the INFINIDAT "
+"InfiniBox driver. To use over-subscription, define "
+"``max_over_subscription_ratio`` in the Cinder configuration file."
+
+msgid ""
+"Added support for oversubscription in thin provisioning in the ScaleIO "
+"driver. Volumes should have extra_specs with the key provisioning:type with "
+"value equals to either 'thick' or 'thin'. max_oversubscription_ratio can be "
+"defined by the global config or for ScaleIO specific with the config option "
+"sio_max_over_subscription_ratio. The maximum oversubscription ratio "
+"supported at the moment is 10.0."
+msgstr ""
+"Added support for over-subscription in thin provisioning in the ScaleIO "
+"driver. Volumes should have extra_specs with the key provisioning:type with "
+"value equals to either 'thick' or 'thin'. max_oversubscription_ratio can be "
+"defined by the global config or for ScaleIO specific with the config option "
+"sio_max_over_subscription_ratio. The maximum over-subscription ratio "
+"supported at the moment is 10.0."
+
+msgid ""
+"Added support for querying group details with volume ids which are in this "
+"group. For example, \"groups/{group_id}?list_volume=True\"."
+msgstr ""
+"Added support for querying group details with volume ids which are in this "
+"group. For example, \"groups/{group_id}?list_volume=True\"."
+
+msgid ""
+"Added support for querying volumes filtered by glance metadata key/value "
+"using 'glance_metadata' optional URL parameter. For example, \"volumes/"
+"detail?glance_metadata={\"image_name\":\"xxx\"}\"."
+msgstr ""
+"Added support for querying volumes filtered by Glance metadata key/value "
+"using 'glance_metadata' optional URL parameter. For example, \"volumes/"
+"detail?glance_metadata={\"image_name\":\"xxx\"}\"."
+
+msgid ""
+"Added support for querying volumes filtered by group_id using 'group_id' "
+"optional URL parameter. For example, \"volumes/detail?"
+"group_id={consistency_group_id}\"."
+msgstr ""
+"Added support for querying volumes filtered by group_id using 'group_id' "
+"optional URL parameter. For example, \"volumes/detail?"
+"group_id={consistency_group_id}\"."
+
+msgid "Added support for revert-to-snapshot in the VMware VMDK driver."
+msgstr "Added support for revert-to-snapshot in the VMware VMDK driver."
+
+msgid ""
+"Added support for scaling QoS in the ScaleIO driver. The new QoS keys are "
+"maxIOPSperGB and maxBWSperGB."
+msgstr ""
+"Added support for scaling QoS in the ScaleIO driver. The new QoS keys are "
+"maxIOPSperGB and maxBWSperGB."
+
+msgid ""
+"Added support for snapshots in the NFS driver. This functionality is only "
+"enabled if ``nfs_snapshot_support`` is set to ``True`` in cinder.conf. "
+"Cloning volumes is only supported if the source volume is not attached."
+msgstr ""
+"Added support for snapshots in the NFS driver. This functionality is only "
+"enabled if ``nfs_snapshot_support`` is set to ``True`` in cinder.conf. "
+"Cloning volumes is only supported if the source volume is not attached."
+
+msgid ""
+"Added support for taking, deleting, and restoring a cgsnapshot for NetApp "
+"7mode and CDOT backends."
+msgstr ""
+"Added support for taking, deleting, and restoring a cgsnapshot for NetApp "
+"7mode and CDOT backends."
+
+msgid ""
+"Added support for the use of live volume in place of standard replication in "
+"the Dell SC driver."
+msgstr ""
+"Added support for the use of live volume in place of standard replication in "
+"the Dell SC driver."
+
+msgid "Added support for vhd and vhdx disk-formats for volume upload-to-image."
+msgstr ""
+"Added support for vhd and vhdx disk-formats for volume upload-to-image."
+
+msgid "Added support for vhd disk-format for volume upload-to-image."
+msgstr "Added support for vhd disk-format for volume upload-to-image."
+
+msgid ""
+"Added support for volume compression in INFINIDAT driver. Compression is "
+"available on InfiniBox 3.0 onward. To enable volume compression, set "
+"``infinidat_use_compression`` to True in the backend section in the Cinder "
+"configuration file."
+msgstr ""
+"Added support for volume compression in INFINIDAT driver. Compression is "
+"available on InfiniBox 3.0 onward. To enable volume compression, set "
+"``infinidat_use_compression`` to True in the backend section in the Cinder "
+"configuration file."
+
+msgid ""
+"Added support to Pure Storage Volume Drivers for Active Cluster using the "
+"standard replication API's for the Block Storage Service."
+msgstr ""
+"Added support to Pure Storage Volume Drivers for Active Cluster using the "
+"standard replication APIs for the Block Storage Service."
+
+msgid ""
+"Added support to querying snapshots filtered by metadata key/value using "
+"'metadata' optional URL parameter. For example, \"/v3/snapshots?"
+"metadata=={'key1':'value1'}\"."
+msgstr ""
+"Added support to querying snapshots filtered by metadata key/value using "
+"'metadata' optional URL parameter. For example, \"/v3/snapshots?"
+"metadata=={'key1':'value1'}\"."
+
+msgid ""
+"Added support to revert a volume to a snapshot with the Dell EMC VNX driver."
+msgstr ""
+"Added support to revert a volume to a snapshot with the Dell EMC VNX driver."
+
+msgid "Added supported driver checks on all drivers."
+msgstr "Added supported driver checks on all drivers."
+
+msgid "Added the ability to create a CG from a source CG with the VMAX driver."
+msgstr ""
+"Added the ability to create a CG from a source CG with the VMAX driver."
+
+msgid ""
+"Added the ability to list manageable volumes and snapshots to HNAS NFS "
+"driver."
+msgstr ""
+"Added the ability to list manageable volumes and snapshots to HNAS NFS "
+"driver."
+
+msgid ""
+"Added the ability to list manageable volumes and snapshots via GET operation "
+"on the /v2/<project_id>/os-volume-manage and /v2/<project_id>/os-snapshot-"
+"manage URLs, respectively."
+msgstr ""
+"Added the ability to list manageable volumes and snapshots via GET operation "
+"on the /v2/<project_id>/os-volume-manage and /v2/<project_id>/os-snapshot-"
+"manage URLs, respectively."
+
+msgid ""
+"Added the options ``visibility`` and ``protected`` to the os-"
+"volume_upload_image REST API call."
+msgstr ""
+"Added the options ``visibility`` and ``protected`` to the os-"
+"volume_upload_image REST API call."
+
+msgid "Added update-host command for consistency groups in cinder-manage."
+msgstr "Added update-host command for consistency groups in cinder-manage."
+
+msgid ""
+"Added using etags in API calls to avoid the lost update problem during "
+"deleting volume metadata."
+msgstr ""
+"Added using etags in API calls to avoid the lost update problem during "
+"deleting volume metadata."
+
+msgid "Added v2.1 replication support in Huawei Cinder driver."
+msgstr "Added v2.1 replication support in Huawei Cinder driver."
+
+msgid "Added v2.1 replication support to RBD driver."
+msgstr "Added v2.1 replication support to RBD driver."
+
+msgid "Added v2.1 replication support to SolidFire driver."
+msgstr "Added v2.1 replication support to SolidFire driver."
+
+msgid "Added v2.1 replication support to the HPE 3PAR driver."
+msgstr "Added v2.1 replication support to the HPE 3PAR driver."
+
+msgid "Added v2.1 replication support to the HPE LeftHand driver."
+msgstr "Added v2.1 replication support to the HPE LeftHand driver."
+
+msgid "Added volume backend driver for Veritas HyperScale storage."
+msgstr "Added volume backend driver for Veritas HyperScale storage."
+
+msgid "Added volume backend drivers for CoprHD FC, iSCSI and Scaleio."
+msgstr "Added volume backend drivers for CoprHD FC, iSCSI and Scaleio."
+
+msgid "Added volume driver for QNAP ES Storage Driver."
+msgstr "Added volume driver for QNAP ES Storage Driver."
+
+msgid "Added volume driver for Zadara Storage VPSA."
+msgstr "Added volume driver for Zadara Storage VPSA."
+
+msgid "Adding Live Migration functionality to VMAX driver version 3.0."
+msgstr "Adding Live Migration functionality to VMAX driver version 3.0."
+
+msgid "Adding Qos functionality to VMAX driver version 3.0."
+msgstr "Adding QoS functionality to VMAX driver version 3.0."
+
+msgid "Adding Replication V2.1 functionality to VMAX driver version 3.0."
+msgstr "Adding Replication V2.1 functionality to VMAX driver version 3.0."
+
+msgid "Adding compression functionality to VMAX driver version 3.0."
+msgstr "Adding compression functionality to VMAX driver version 3.0."
+
+msgid ""
+"Adding or removing volume_type_access from any project during DB migration "
+"62 must not be performed."
+msgstr ""
+"Adding or removing volume_type_access from any project during DB migration "
+"62 must not be performed."
+
+msgid "Adds QoS support for VNX Cinder driver."
+msgstr "Adds QoS support for VNX Cinder driver."
+
+msgid "Adds new Hitachi VSP iSCSI Driver."
+msgstr "Adds new Hitachi VSP iSCSI Driver."
+
+msgid ""
+"Adds support to configure the size of the native thread pool used by the "
+"cinder volume and backup services.  For the backup we use "
+"`backup_native_threads_pool_size` in the `[DEFAULT]` section, and for the "
+"backends we use `backend_native_threads_pool_size` in the driver section."
+msgstr ""
+"Adds support to configure the size of the native thread pool used by the "
+"Cinder volume and backup services.  For the backup we use "
+"`backup_native_threads_pool_size` in the `[DEFAULT]` section, and for the "
+"backends we use `backend_native_threads_pool_size` in the driver section."
+
+msgid "Adds v2.1 replication support in VNX Cinder driver."
+msgstr "Adds v2.1 replication support in VNX Cinder driver."
+
+msgid ""
+"Administrator can disable this ability by updating the ``volume:"
+"extend_attached_volume`` policy rule."
+msgstr ""
+"Administrator can disable this ability by updating the ``volume:"
+"extend_attached_volume`` policy rule."
+
+msgid ""
+"After CG tables are removed, we will allow default_cgsnapshot_type to be "
+"used by group APIs."
+msgstr ""
+"After CG tables are removed, we will allow default_cgsnapshot_type to be "
+"used by group APIs."
+
+msgid ""
+"After an offline upgrade we had to restart all Cinder services twice, now "
+"with the `cinder-manage db sync --bump-versions` command we can avoid the "
+"second restart."
+msgstr ""
+"After an offline upgrade we had to restart all Cinder services twice, now "
+"with the `cinder-manage db sync --bump-versions` command we can avoid the "
+"second restart."
+
+msgid ""
+"After being marked unsupported in the Rocky release the CoprHD driver is now "
+"being removed in Stein.  The vendor has indicated that this is desired as "
+"the CoprHD driver has been deprecated."
+msgstr ""
+"After being marked unsupported in the Rocky release the CoprHD driver is now "
+"being removed in Stein.  The vendor has indicated that this is desired as "
+"the CoprHD driver has been deprecated."
+
+msgid ""
+"After running the migration script to migrate CGs to generic volume groups, "
+"CG and group APIs work as follows."
+msgstr ""
+"After running the migration script to migrate CGs to generic volume groups, "
+"CG and group APIs work as follows."
+
+msgid ""
+"After transferring a volume without snapshots from one user project to "
+"another user project, if the receiving user uses cascade deleting, it will "
+"cause some exceptions in driver and volume will be error_deleting. Adding "
+"additional check to ensure there are no snapshots left in other project when "
+"cascade deleting a tranferred volume."
+msgstr ""
+"After transferring a volume without snapshots from one user project to "
+"another user project, if the receiving user uses cascade deleting, it will "
+"cause some exceptions in driver and volume will be error_deleting. Adding "
+"additional check to ensure there are no snapshots left in other project when "
+"cascade deleting a transferred volume."
+
+msgid ""
+"All Datera DataFabric backed volume-types will now use API version 2 with "
+"Datera DataFabric"
+msgstr ""
+"All Datera DataFabric backed volume-types will now use API version 2 with "
+"Datera DataFabric"
+
+msgid ""
+"All barbican and keymgr config options in Cinder are now deprecated. All of "
+"these options are moved to the key_manager section for the Castellan library."
+msgstr ""
+"All Barbican and keymgr config options in Cinder are now deprecated. All of "
+"these options are moved to the key_manager section for the Castellan library."
+
+msgid ""
+"Allow API user to remove the consistency group name or description "
+"information."
+msgstr ""
+"Allow API user to remove the consistency group name or description "
+"information."
+
+msgid ""
+"Allow for eradicating Pure Storage volumes, snapshots, and pgroups when "
+"deleting their Cinder counterpart."
+msgstr ""
+"Allow for eradicating Pure Storage volumes, snapshots, and pgroups when "
+"deleting their Cinder counterpart."
+
+msgid "Allow rbd driver to list manageable snapshots."
+msgstr "Allow RBD driver to list manageable snapshots."
+
+msgid "Allow rbd driver to list manageable volumes."
+msgstr "Allow RBD driver to list manageable volumes."
+
+msgid "Allow rbd driver to manage existing snapshot."
+msgstr "Allow RBD driver to manage existing snapshot."
+
+msgid "Allow rbd driver to report backend state."
+msgstr "Allow RBD driver to report backend state."
+
+msgid "Allow spaces when managing existing volumes with the HNAS iSCSI driver."
+msgstr ""
+"Allow spaces when managing existing volumes with the HNAS iSCSI driver."
+
+msgid "Allow the RBD driver to work with max_over_subscription_ratio."
+msgstr "Allow the RBD driver to work with max_over_subscription_ratio."
+
+msgid ""
+"Allow users to specify the copy speed while using Huawei driver to create "
+"volume from snapshot or clone volume, by the new added metadata 'copyspeed'. "
+"For example, user can add --metadata copyspeed=1 when creating volume from "
+"source volume/snapshot. The valid optional range of copyspeed is [1, 2, 3, "
+"4], respectively representing LOW, MEDIUM, HIGH and HIGHEST."
+msgstr ""
+"Allow users to specify the copy speed while using Huawei driver to create "
+"volume from snapshot or clone volume, by the new added metadata 'copyspeed'. "
+"For example, user can add --metadata copyspeed=1 when creating volume from "
+"source volume/snapshot. The valid optional range of copyspeed is [1, 2, 3, "
+"4], respectively representing LOW, MEDIUM, HIGH and HIGHEST."
+
+msgid ""
+"Also some options are renamed (note that 3 of them were both moved and "
+"renamed):"
+msgstr ""
+"Also some options are renamed (note that 3 of them were both moved and "
+"renamed):"
+
+msgid ""
+"An error has been corrected in the EMC ScaleIO driver that had caused all "
+"volumes to be provisioned at 'thick' even if user had specificed 'thin'."
+msgstr ""
+"An error has been corrected in the EMC ScaleIO driver that had caused all "
+"volumes to be provisioned at 'thick' even if user had specified 'thin'."
+
+msgid ""
+"Any Volume Drivers configured in the DEFAULT config stanza should be moved "
+"to their own stanza and enabled via the enabled_backends config option. The "
+"older style of config with DEFAULT is deprecated and will be removed in "
+"future releases."
+msgstr ""
+"Any Volume Drivers configured in the DEFAULT config stanza should be moved "
+"to their own stanza and enabled via the enabled_backends config option. The "
+"older style of config with DEFAULT is deprecated and will be removed in "
+"future releases."
+
+msgid ""
+"As an example one provider may have roles called viewer, admin, type_viewer, "
+"and say type_admin. Admin and type_admin can create, delete, update types. "
+"Everyone can list the storage types. Admin, type_viewer, and type_admin can "
+"view the extra_specs."
+msgstr ""
+"As an example one provider may have roles called viewer, admin, type_viewer, "
+"and say type_admin. Admin and type_admin can create, delete, update types. "
+"Everyone can list the storage types. Admin, type_viewer, and type_admin can "
+"view the extra_specs."
+
+msgid ""
+"As cinder-backup was strongly reworked in this release, the recommended "
+"upgrade order when executing live (rolling) upgrade is c-api->c-sch->c-vol-"
+">c-bak."
+msgstr ""
+"As cinder-backup was strongly reworked in this release, the recommended "
+"upgrade order when executing live (rolling) upgrade is c-api->c-sch->c-vol-"
+">c-bak."
+
+msgid ""
+"Availability zones may now be configured per backend in a multi-backend "
+"configuration. Individual backend sections can now set the configuration "
+"option ``backend_availability_zone``. If set, this value will override the "
+"[DEFAULT] ``storage_availability_zone`` setting."
+msgstr ""
+"Availability zones may now be configured per backend in a multi-backend "
+"configuration. Individual backend sections can now set the configuration "
+"option ``backend_availability_zone``. If set, this value will override the "
+"[DEFAULT] ``storage_availability_zone`` setting."
+
+msgid "Backend driver for Scality SRB has been removed."
+msgstr "Backend driver for Scality SRB has been removed."
+
+msgid "Backup driver initialization using module name is deprecated."
+msgstr "Backup driver initialisation using module name is deprecated."
+
+msgid ""
+"Backup service to driver mapping is deprecated. If you use old values like "
+"'cinder.backup.services.swift' or 'cinder.backup.services.ceph' it should be "
+"changed to 'cinder.backup.drivers.swift' or 'cinder.backup.drivers.ceph' "
+"accordingly to get your backup service working in the 'R' release."
+msgstr ""
+"Backup service to driver mapping is deprecated. If you use old values like "
+"'cinder.backup.services.swift' or 'cinder.backup.services.ceph' it should be "
+"changed to 'cinder.backup.drivers.swift' or 'cinder.backup.drivers.ceph' "
+"accordingly to get your backup service working in the 'R' release."
+
+msgid ""
+"Backup service to driver mapping is removed. If you use old values like "
+"'cinder.backup.services.swift' or 'cinder.backup.services.ceph' it should be "
+"changed to 'cinder.backup.drivers.swift' or 'cinder.backup.drivers.ceph' "
+"accordingly to get your backup service working."
+msgstr ""
+"Backup service to driver mapping is removed. If you use old values like "
+"'cinder.backup.services.swift' or 'cinder.backup.services.ceph' it should be "
+"changed to 'cinder.backup.drivers.swift' or 'cinder.backup.drivers.ceph' "
+"accordingly to get your backup service working."
+
+msgid ""
+"Beginning with Cinder 12.0.0, you only need to specify policies in your "
+"policy file that you want to **differ** from the default values. Unspecified "
+"policies will use the default values *defined in the code*. Given that a "
+"default value *must* be specified *in the code* when a new policy is "
+"introduced, the ``default`` policy, which was formerly used as a catch-all "
+"for policy targets that were not defined elsewhere in the policy file, has "
+"no effect.  We mention this because an old upgrade strategy was to use the "
+"policy file from the previous release with ``\"default\": \"role:admin\"`` "
+"(or ``\"default\": \"!\"``) so that newly introduced actions would be "
+"blocked from end users until the operator had time to assess the "
+"implications of exposing these actions.  This strategy no longer works.  "
+"Hopefully this isn't a problem because we're defining sensible defaults in "
+"the code.  It would be a good idea, however, to generate the sample policy "
+"file with each release (see instructions above) to verify this for yourself."
+msgstr ""
+"Beginning with Cinder 12.0.0, you only need to specify policies in your "
+"policy file that you want to **differ** from the default values. Unspecified "
+"policies will use the default values *defined in the code*. Given that a "
+"default value *must* be specified *in the code* when a new policy is "
+"introduced, the ``default`` policy, which was formerly used as a catch-all "
+"for policy targets that were not defined elsewhere in the policy file, has "
+"no effect.  We mention this because an old upgrade strategy was to use the "
+"policy file from the previous release with ``\"default\": \"role:admin\"`` "
+"(or ``\"default\": \"!\"``) so that newly introduced actions would be "
+"blocked from end users until the operator had time to assess the "
+"implications of exposing these actions.  This strategy no longer works.  "
+"Hopefully this isn't a problem because we're defining sensible defaults in "
+"the code.  It would be a good idea, however, to generate the sample policy "
+"file with each release (see instructions above) to verify this for yourself."
+
+msgid ""
+"Beginning with Cinder version 12.0.0, as part of the Queens release "
+"\"policies  in code\" community effort, Cinder has had the ability to run "
+"without a policy file because sensible default values are specified in the "
+"code.  Customizing the policies in effect at your site, however, still "
+"requires a policy file.  The default location of this file has been ``/etc/"
+"cinder/policy.json`` (although the documentation has indicated otherwise).  "
+"With this release, the default location of this file is changed to ``/etc/"
+"cinder/policy.yaml``."
+msgstr ""
+"Beginning with Cinder version 12.0.0, as part of the Queens release "
+"\"policies  in code\" community effort, Cinder has had the ability to run "
+"without a policy file because sensible default values are specified in the "
+"code.  Customizing the policies in effect at your site, however, still "
+"requires a policy file.  The default location of this file has been ``/etc/"
+"cinder/policy.json`` (although the documentation has indicated otherwise).  "
+"With this release, the default location of this file is changed to ``/etc/"
+"cinder/policy.yaml``."
+
+msgid "Better cleanup handling in the NetApp E-Series driver."
+msgstr "Better clean-up handling in the NetApp E-Series driver."
+
+msgid "Block device driver"
+msgstr "Block device driver"
+
+msgid ""
+"BlockDeviceDriver was deprecated in Ocata release and marked as "
+"'unsupported'. There is no CI for it too. If you used this driver before you "
+"have to migrate your volumes to LVM with LIO target yourself before "
+"upgrading to Queens release to get your volumes working."
+msgstr ""
+"BlockDeviceDriver was deprecated in Ocata release and marked as "
+"'unsupported'. There is no CI for it too. If you used this driver before you "
+"have to migrate your volumes to LVM with LIO target yourself before "
+"upgrading to Queens release to get your volumes working."
+
+msgid "Blockbridge"
+msgstr "Blockbridge"
+
+msgid ""
+"BoolOpt ``datera_acl_allow_all`` is changed to a volume type extra spec "
+"option-- ``DF:acl_allow_all``"
+msgstr ""
+"BoolOpt ``datera_acl_allow_all`` is changed to a volume type extra spec "
+"option-- ``DF:acl_allow_all``"
+
+msgid "Broke Datera driver up into modules."
+msgstr "Broke Datera driver up into modules."
+
+msgid "Bug Fixes"
+msgstr "Bug Fixes"
+
+msgid "Capabilites List for Datera Volume Drivers"
+msgstr "Capabilities List for Datera Volume Drivers"
+
+msgid "Capacity reporting fixed with Huawei backend drivers."
+msgstr "Capacity reporting fixed with Huawei backend drivers."
+
+msgid "Changes config option default for datera_num_replicas from 1 to 3"
+msgstr "Changes config option default for datera_num_replicas from 1 to 3"
+
+msgid ""
+"Cinder FC Zone Manager Friendly Zone Names This feature adds support for "
+"Fibre Channel user friendly zone names if implemented by the volume driver. "
+"If the volume driver passes the host name and storage system to the Fibre "
+"Channel Zone Manager in the conn_info structure, the zone manager will use "
+"these names in structuring the zone name to provide a user friendly zone "
+"name."
+msgstr ""
+"Cinder FC Zone Manager Friendly Zone Names This feature adds support for "
+"Fibre Channel user friendly zone names if implemented by the volume driver. "
+"If the volume driver passes the host name and storage system to the Fibre "
+"Channel Zone Manager in the conn_info structure, the zone manager will use "
+"these names in structuring the zone name to provide a user friendly zone "
+"name."
+
+msgid "Cinder Release Notes"
+msgstr "Cinder Release Notes"
+
+msgid ""
+"Cinder backup creation can now (since microversion 3.51) receive the "
+"availability zone where the backup should be stored."
+msgstr ""
+"Cinder backup creation can now (since microversion 3.51) receive the "
+"availability zone where the backup should be stored."
+
+msgid ""
+"Cinder backup now supports running multiple processes to make the most of "
+"the available CPU cores.  Performance gains will be significant when running "
+"multiple concurrent backups/restores with compression.  The number of "
+"processes is set with `backup_workers` configuration option."
+msgstr ""
+"Cinder backup now supports running multiple processes to make the most of "
+"the available CPU cores.  Performance gains will be significant when running "
+"multiple concurrent backups/restores with compression.  The number of "
+"processes is set with `backup_workers` configuration option."
+
+msgid ""
+"Cinder is now collecting capacity data, including virtual free capacity etc "
+"from the backends. A notification which includes that data is periodically "
+"emitted."
+msgstr ""
+"Cinder is now collecting capacity data, including virtual free capacity etc "
+"from the backends. A notification which includes that data is periodically "
+"emitted."
+
+msgid ""
+"Cinder now allows for a minimum value when using the capacity based QoS in "
+"order to make sure small volumes can get a minimum allocation for them to be "
+"usable. The newly added QoS specs are `read_iops_sec_per_gb_min`, "
+"`write_iops_sec_per_gb_min`, `total_iops_sec_per_gb_min`, "
+"`read_bytes_sec_per_gb_min`, `write_bytes_sec_per_gb_min` and "
+"`total_bytes_sec_per_gb_min`"
+msgstr ""
+"Cinder now allows for a minimum value when using the capacity based QoS in "
+"order to make sure small volumes can get a minimum allocation for them to be "
+"usable. The newly added QoS specs are `read_iops_sec_per_gb_min`, "
+"`write_iops_sec_per_gb_min`, `total_iops_sec_per_gb_min`, "
+"`read_bytes_sec_per_gb_min`, `write_bytes_sec_per_gb_min` and "
+"`total_bytes_sec_per_gb_min`"
+
+msgid ""
+"Cinder now allows for capacity based QoS which can be useful in environments "
+"where storage performance scales with consumption (such as RBD backed "
+"storage).  The newly added QoS specs are `read_iops_sec_per_gb`, "
+"`write_iops_sec_per_gb`, `total_iops_sec_per_gb`, `read_bytes_sec_per_gb`, "
+"`write_bytes_sec_per_gb` and `total_bytes_sec_per_gb`.  These values will be "
+"multiplied by the size of the volume and passed to the consumer. For "
+"example, setting `total_iops_sec_per_gb` to 30 and setting "
+"`total_bytes_sec_per_gb` to `1048576` (1MB) then creating a 100 GB volume "
+"with that QoS will result in a volume with 3,000 total IOPs and 100MB/s "
+"throughput limit."
+msgstr ""
+"Cinder now allows for capacity based QoS which can be useful in environments "
+"where storage performance scales with consumption (such as RBD backed "
+"storage).  The newly added QoS specs are `read_iops_sec_per_gb`, "
+"`write_iops_sec_per_gb`, `total_iops_sec_per_gb`, `read_bytes_sec_per_gb`, "
+"`write_bytes_sec_per_gb` and `total_bytes_sec_per_gb`.  These values will be "
+"multiplied by the size of the volume and passed to the consumer. For "
+"example, setting `total_iops_sec_per_gb` to 30 and setting "
+"`total_bytes_sec_per_gb` to `1048576` (1MB) then creating a 100 GB volume "
+"with that QoS will result in a volume with 3,000 total IOPs and 100MB/s "
+"throughput limit."
+
+msgid ""
+"Cinder now defaults to using the Glance v2 API. The ``glance_api_version`` "
+"configuration option has been deprecated and will be removed in the 12.0.0 "
+"Queens release."
+msgstr ""
+"Cinder now defaults to using the Glance v2 API. The ``glance_api_version`` "
+"configuration option has been deprecated and will be removed in the 12.0.0 "
+"Queens release."
+
+msgid ""
+"Cinder now support policy in code, which means if users don't need to modify "
+"any of the default policy rules, they do not need a policy file. Users can "
+"modify/generate a `policy.yaml` file which will override specific policy "
+"rules from their defaults."
+msgstr ""
+"Cinder now support policy in code, which means if users don't need to modify "
+"any of the default policy rules, they do not need a policy file. Users can "
+"modify/generate a `policy.yaml` file which will override specific policy "
+"rules from their defaults."
+
+msgid ""
+"Cinder now supports the use of 'max_over_subscription_ratio = auto' which "
+"automatically calculates the value for max_over_subscription_ratio in the "
+"scheduler."
+msgstr ""
+"Cinder now supports the use of 'max_over_subscription_ratio = auto' which "
+"automatically calculates the value for max_over_subscription_ratio in the "
+"scheduler."
+
+msgid ""
+"Cinder now will return 415 (HTTPUnsupportedMediaType) when any unsupported "
+"content type is specified in request header."
+msgstr ""
+"Cinder now will return 415 (HTTPUnsupportedMediaType) when any unsupported "
+"content type is specified in request header."
+
+msgid ""
+"Cinder services are now automatically downgrading RPC messages to be "
+"understood by the oldest version of a service among all the deployment. "
+"Disabled and dead services are also taken into account. It is important to "
+"keep service list up to date, without old, unused records. This can be done "
+"using ``cinder-manage service remove`` command. Once situation is cleaned up "
+"services should be either restarted or ``SIGHUP`` signal should be issued to "
+"their processes to force them to reload version pins.  Please note that "
+"cinder-api does not support ``SIGHUP`` signal."
+msgstr ""
+"Cinder services are now automatically downgrading RPC messages to be "
+"understood by the oldest version of a service among all the deployment. "
+"Disabled and dead services are also taken into account. It is important to "
+"keep service list up to date without old unused records. This can be done "
+"using ``cinder-manage service remove`` command. Once the situation is "
+"cleaned up services should be either restarted or the ``SIGHUP`` signal "
+"should be issued to their processes to force them to reload.  Please note "
+"that cinder-api does not support ``SIGHUP`` signal."
+
+msgid ""
+"Cinder stopped supporting single-backend configurations in Ocata. However, "
+"sample ``cinder.conf`` was still generated with driver-related options in "
+"``[DEFAULT]`` section, where those options had no effect at all. Now all of "
+"driver options are listed in ``[backend_defaults]`` section, that indicates "
+"that those options are effective only in this section and "
+"``[<backend_name>]`` sections listed in ``enabled_backends``."
+msgstr ""
+"Cinder stopped supporting single-backend configurations in Ocata. However, "
+"sample ``cinder.conf`` was still generated with driver-related options in "
+"``[DEFAULT]`` section, where those options had no effect at all. Now all of "
+"driver options are listed in ``[backend_defaults]`` section, that indicates "
+"that those options are effective only in this section and "
+"``[<backend_name>]`` sections listed in ``enabled_backends``."
+
+msgid "Cinder will now consume quota when importing new backup resource."
+msgstr "Cinder will now consume quota when importing new backup resource."
+
+msgid ""
+"Cinder will now correctly read Keystone's endpoint for quota calls from "
+"keystone_authtoken.auth_uri instead of keymgr.encryption_auth_url config "
+"option."
+msgstr ""
+"Cinder will now correctly read Keystone's endpoint for quota calls from "
+"keystone_authtoken.auth_uri instead of keymgr.encryption_auth_url config "
+"option."
+
+msgid ""
+"Cinder's Google backup driver is now called gcs, so ``backup_driver`` "
+"configuration for Google Cloud Storage should be updated from ``cinder."
+"backup.drivers.google`` to ``cinder.backup.driver.gcs``."
+msgstr ""
+"Cinder's Google backup driver is now called gcs, so ``backup_driver`` "
+"configuration for Google Cloud Storage should be updated from ``cinder."
+"backup.drivers.google`` to ``cinder.backup.driver.gcs``."
+
+msgid ""
+"Cinder-manage DB sync command can now bump the RPC and Objects versions of "
+"the services to avoid a second restart when doing offline upgrades."
+msgstr ""
+"Cinder-manage DB sync command can now bump the RPC and Objects versions of "
+"the services to avoid a second restart when doing offline upgrades."
+
+msgid "Cloning of consistency group added to EMC VNX backend driver."
+msgstr "Cloning of consistency group added to EMC VNX backend driver."
+
+msgid "Coho"
+msgstr "Coho"
+
+msgid "Configrable migration rate in VNX driver via metadata"
+msgstr "Configurable migration rate in VNX driver via metadata"
+
+msgid ""
+"Configuration options for the DRBD driver that will be applied to DRBD "
+"resources; the default values should be okay for most installations."
+msgstr ""
+"Configuration options for the DRBD driver that will be applied to DRBD "
+"resources; the default values should be okay for most installations."
+
+msgid ""
+"Configurations that are setting backend config in ``[DEFAULT]`` section are "
+"now not supported. You should use ``enabled_backends`` option to set up "
+"backends."
+msgstr ""
+"Configurations that are setting backend config in ``[DEFAULT]`` section are "
+"now not supported. You should use ``enabled_backends`` option to set up "
+"backends."
+
+msgid ""
+"Configuring Volume Drivers in the DEFAULT config stanza is not going to be "
+"maintained and will be removed in the next release. All backends should use "
+"the enabled_backends config option with separate stanza's for each."
+msgstr ""
+"Configuring Volume Drivers in the DEFAULT config stanza is not going to be "
+"maintained and will be removed in the next release. All backends should use "
+"the enabled_backends config option with separate stanzas for each."
+
+msgid ""
+"Consistency group creation previously scheduled at the pool level. Now it is "
+"fixed to schedule at the backend level as designed."
+msgstr ""
+"Consistency group creation previously scheduled at the pool level. Now it is "
+"fixed to schedule at the backend level as designed."
+
+msgid ""
+"Consistency group support has been added to the LeftHand backend driver."
+msgstr ""
+"Consistency group support has been added to the LeftHand backend driver."
+
+msgid "Corrected quota usage when transferring a volume between tenants."
+msgstr "Corrected quota usage when transferring a volume between tenants."
+
+msgid "Corrected support to force detach a volume from all hosts on Unity."
+msgstr "Corrected support to force detach a volume from all hosts on Unity."
+
+msgid ""
+"Create CG Snapshot creates either in the CG or the groups table depending on "
+"where the CG is."
+msgstr ""
+"Create CG Snapshot creates either in the CG or the groups table depending on "
+"where the CG is."
+
+msgid ""
+"Create CG from Source creates in either the CG or the groups table depending "
+"on the source."
+msgstr ""
+"Create CG from Source creates in either the CG or the groups table depending "
+"on the source."
+
+msgid "Create CG only creates in the groups table."
+msgstr "Create CG only creates in the groups table."
+
+msgid "Create Volume adds the volume either to the CG or the group."
+msgstr "Create Volume adds the volume either to the CG or the group."
+
+msgid ""
+"Creating a new volume from an image that was created from an encrypted "
+"Cinder volume now succeeds."
+msgstr ""
+"Creating a new volume from an image that was created from an encrypted "
+"Cinder volume now succeeds."
+
+msgid "Current Series Release Notes"
+msgstr "Current Series Release Notes"
+
+msgid ""
+"DS8K driver adds two new properties into extra-specs so that user can "
+"specify pool or lss or both of them to allocate volume in their expected "
+"area."
+msgstr ""
+"DS8K driver adds two new properties into extra-specs so that user can "
+"specify pool or lss or both of them to allocate volume in their expected "
+"area."
+
+msgid ""
+"Datera driver location has changed from cinder.volume.drivers .datera."
+"DateraDriver to cinder.volume.drivers.datera.datera_iscsi .DateraDriver."
+msgstr ""
+"Datera driver location has changed from cinder.volume.drivers .datera."
+"DateraDriver to cinder.volume.drivers.datera.datera_iscsi .DateraDriver."
+
+msgid ""
+"Default `policy.json` file is now removed as Cinder now uses default "
+"policies. A policy file is only needed if overriding one of the defaults."
+msgstr ""
+"Default `policy.json` file is now removed as Cinder now uses default "
+"policies. A policy file is only needed if overriding one of the defaults."
+
+msgid ""
+"Delete CG deletes from the CG or the groups table depending on where the CG "
+"is."
+msgstr ""
+"Delete CG deletes from the CG or the groups table depending on where the CG "
+"is."
+
+msgid ""
+"Dell EMC PS Driver stats report has been fixed, now reports the "
+"`provisioned_capacity_gb` properly. Fixes bug 1719659."
+msgstr ""
+"Dell EMC PS Driver stats report has been fixed, now reports the "
+"`provisioned_capacity_gb` properly. Fixes bug 1719659."
+
+msgid ""
+"Dell EMC PS Series Driver code reporting volume stats is now optimized to "
+"return the information earlier and accelerate the process. This change fixes "
+"bug 1661154."
+msgstr ""
+"Dell EMC PS Series Driver code reporting volume stats is now optimized to "
+"return the information earlier and accelerate the process. This change fixes "
+"bug 1661154."
+
+msgid ""
+"Dell EMC PS Series Driver code was creating duplicate ACL records during "
+"live migration. Fixes the initialize_connection code to not create access "
+"record for a host if one exists previously. This change fixes bug 1726591."
+msgstr ""
+"Dell EMC PS Series Driver code was creating duplicate ACL records during "
+"live migration. Fixes the initialize_connection code to not create access "
+"record for a host if one exists previously. This change fixes bug 1726591."
+
+msgid ""
+"Dell EMC PS Series Driver was creating unmanaged snapshots when extending "
+"volumes. Fixed it by adding the missing no-snap parameter. This change fixes "
+"bug 1720454."
+msgstr ""
+"Dell EMC PS Series Driver was creating unmanaged snapshots when extending "
+"volumes. Fixed it by adding the missing no-snap parameter. This change fixes "
+"bug 1720454."
+
+msgid ""
+"Dell EMC PS Series Driver was creating unmanaged snapshots when extending "
+"volumes. Fixed it by adding the missing no-snap parameter. This changes "
+"fixes bug 1720454."
+msgstr ""
+"Dell EMC PS Series Driver was creating unmanaged snapshots when extending "
+"volumes. Fixed it by adding the missing no-snap parameter. This changes "
+"fixes bug 1720454."
+
+msgid ""
+"Dell EMC PS volume driver reports the total number of volumes on the backend "
+"in volume stats."
+msgstr ""
+"Dell EMC PS volume driver reports the total number of volumes on the backend "
+"in volume stats."
+
+msgid ""
+"Dell EMC SC driver correctly returns initialize_connection data when more "
+"than one IQN is attached to a volume. This fixes some random Nova Live "
+"Migration failures where the connection information being returned was for "
+"an IQN other than the one for which it was being requested."
+msgstr ""
+"Dell EMC SC driver correctly returns initialise_connection data when more "
+"than one IQN is attached to a volume. This fixes some random Nova Live "
+"Migration failures where the connection information being returned was for "
+"an IQN other than the one for which it was being requested."
+
+msgid ""
+"Dell EMC Scale IO Driver: Fixes `bug 1560649 <https://bugs.launchpad.net/"
+"cinder/+bug/1560649>` for creating volumes with sizes greater than that of "
+"the original snapshot."
+msgstr ""
+"Dell EMC Scale IO Driver: Fixes `bug 1560649 <https://bugs.launchpad.net/"
+"cinder/+bug/1560649>` for creating volumes with sizes greater than that of "
+"the original snapshot."
+
+msgid ""
+"Dell EMC ScaleIO has been renamed to Dell EMC VxFlex OS. Documentation for "
+"the driver can be found under the new name. The driver maintains full "
+"backwards compatability with prior ScaleIO releases and no configuration "
+"changes are needed upon upgrade to the new version of the driver."
+msgstr ""
+"Dell EMC ScaleIO has been renamed to Dell EMC VxFlex OS. Documentation for "
+"the driver can be found under the new name. The driver maintains full "
+"backwards compatibility with prior ScaleIO releases and no configuration "
+"changes are needed upon upgrade to the new version of the driver."
+
+msgid ""
+"Dell EMC Unity Cinder driver allows enabling/disabling the SSL verification. "
+"Admin can set `True` or `False` for `driver_ssl_cert_verify` to enable or "
+"disable this function, alternatively set the `driver_ssl_cert_path=<PATH>` "
+"for customized CA path. Both above 2 options should go under the driver "
+"section."
+msgstr ""
+"Dell EMC Unity Cinder driver allows enabling/disabling the SSL verification. "
+"Admin can set `True` or `False` for `driver_ssl_cert_verify` to enable or "
+"disable this function, alternatively set the `driver_ssl_cert_path=<PATH>` "
+"for customized CA path. Both above 2 options should go under the driver "
+"section."
+
+msgid ""
+"Dell EMC Unity Driver: Add thick volume support. Refer to `Unity Cinder "
+"Configuration document <https://docs.openstack.org/cinder/latest/"
+"configuration/block-storage/drivers/dell-emc-unity-driver.html>`__ to create "
+"a thick volume."
+msgstr ""
+"Dell EMC Unity Driver: Add thick volume support. Refer to `Unity Cinder "
+"Configuration document <https://docs.openstack.org/cinder/latest/"
+"configuration/block-storage/drivers/dell-emc-unity-driver.html>`__ to create "
+"a thick volume."
+
+msgid ""
+"Dell EMC Unity Driver: Adds support for removing empty host. The new option "
+"named `remove_empty_host` could be configured as `True` to notify Unity "
+"driver to remove the host after the last LUN is detached from it."
+msgstr ""
+"Dell EMC Unity Driver: Adds support for removing empty host. The new option "
+"named `remove_empty_host` could be configured as `True` to notify Unity "
+"driver to remove the host after the last LUN is detached from it."
+
+msgid ""
+"Dell EMC Unity Driver: Fixes `bug 1759175 <https://bugs.launchpad.net/cinder/"
+"+bug/1759175>`__ to detach the lun correctly when auto zone was enabled and "
+"the lun was the last one attached to the host."
+msgstr ""
+"Dell EMC Unity Driver: Fixes `bug 1759175 <https://bugs.launchpad.net/cinder/"
+"+bug/1759175>`__ to detach the LUN correctly when auto zone was enabled and "
+"the LUN was the last one attached to the host."
+
+msgid ""
+"Dell EMC Unity Driver: Fixes `bug 1773305 <https://bugs.launchpad.net/cinder/"
+"+bug/1773305>`__ to return the targets which connect to the logged-out "
+"initiators. Then the zone manager could clean up the FC zone based on the "
+"correct target wwns."
+msgstr ""
+"Dell EMC Unity Driver: Fixes `bug 1773305 <https://bugs.launchpad.net/cinder/"
+"+bug/1773305>`__ to return the targets which connect to the logged-out "
+"initiators. Then the zone manager could clean up the FC zone based on the "
+"correct target WWNs."
+
+msgid "Dell EMC Unity driver: Add compressed volume support."
+msgstr "Dell EMC Unity driver: Add compressed volume support."
+
+msgid ""
+"Dell EMC Unity: Fixes bug 1775518 to make sure driver succeed to initialize "
+"even though the value of unity_io_ports and unity_storage_pool_names are "
+"empty"
+msgstr ""
+"Dell EMC Unity: Fixes bug 1775518 to make sure driver succeed to initialize "
+"even though the value of unity_io_ports and unity_storage_pool_names are "
+"empty"
+
+msgid ""
+"Dell EMC Unity: Implements `bp unity-multiattach-support <https://blueprints."
+"launchpad.net/cinder/+spec/unity-multiattach-support>`__ to support "
+"attaching a volume to multiple servers simultaneously."
+msgstr ""
+"Dell EMC Unity: Implements `bp unity-multiattach-support <https://blueprints."
+"launchpad.net/cinder/+spec/unity-multiattach-support>`__ to support "
+"attaching a volume to multiple servers simultaneously."
+
+msgid ""
+"Dell EMC VMAX driver has added list manageable volumes and snapshots support."
+msgstr ""
+"Dell EMC VMAX driver has added list manageable volumes and snapshots support."
+
+msgid "Dell EMC VMAX driver has added multiattach support."
+msgstr "Dell EMC VMAX driver has added multiattach support."
+
+msgid ""
+"Dell EMC VMAX driver has added support for failover to second instance of "
+"Unisphere."
+msgstr ""
+"Dell EMC VMAX driver has added support for failover to second instance of "
+"Unisphere."
+
+msgid "Dell EMC VNX driver: Enhances the performance of create/delete volume."
+msgstr "Dell EMC VNX driver: Enhances the performance of create/delete volume."
+
+msgid "Dell EMC XtremIO driver has added multiattach support."
+msgstr "Dell EMC XtremIO driver has added multiattach support."
+
+msgid ""
+"Dell SC - Compression and Dedupe support added for Storage Centers that "
+"support the options."
+msgstr ""
+"Dell SC - Compression and Dedupe support added for Storage Centres that "
+"support the options."
+
+msgid ""
+"Dell SC - Volume and Group QOS support added for Storage Centers that "
+"support and have enabled the option."
+msgstr ""
+"Dell SC - Volume and Group QOS support added for Storage Centres that "
+"support and have enabled the option."
+
+msgid ""
+"Dell SC Cinder driver has limited support in a failed over state so "
+"thaw_backend has been implemented to reject the thaw call when in such a "
+"state."
+msgstr ""
+"Dell SC Cinder driver has limited support in a failed over state so "
+"thaw_backend has been implemented to reject the thaw call when in such a "
+"state."
+
+msgid ""
+"Deployments doing continuous live upgrades from master branch should not "
+"upgrade into Ocata before doing an upgrade which includes all the Newton's "
+"RPC API version bump commits (scheduler, volume). If you're upgrading "
+"deployment in a release-to-release manner, then you can safely ignore this "
+"note."
+msgstr ""
+"Deployments doing continuous live upgrades from master branch should not "
+"upgrade into Ocata before doing an upgrade which includes all the Newton's "
+"RPC API version bump commits (scheduler, volume). If you're upgrading "
+"deployment in a release-to-release manner, then you can safely ignore this "
+"note."
+
+msgid ""
+"Deprecate option `check_max_pool_luns_threshold`. The VNX driver will always "
+"check the threshold."
+msgstr ""
+"Deprecate option `check_max_pool_luns_threshold`. The VNX driver will always "
+"check the threshold."
+
+msgid ""
+"Deprecate the \"cinder-manage logs\" commands.  These will be removed in a "
+"later release."
+msgstr ""
+"Deprecate the \"cinder-manage logs\" commands.  These will be removed in a "
+"later release."
+
+msgid "Deprecated IBM driver _multipath_enabled config flags."
+msgstr "Deprecated IBM driver _multipath_enabled config flags."
+
+msgid ""
+"Deprecated config option `query_volume_filters` is removed now. Please, use "
+"config file described in resource_query_filters_file to configure allowed "
+"volume filters."
+msgstr ""
+"Deprecated config option `query_volume_filters` is removed now. Please, use "
+"config file described in resource_query_filters_file to configure allowed "
+"volume filters."
+
+msgid "Deprecated datera_api_version option."
+msgstr "Deprecated datera_api_version option."
+
+msgid ""
+"Deprecated the configuration option ``hnas_svcX_volume_type``. Use option "
+"``hnas_svcX_pool_name`` to indicate the name of the services (pools)."
+msgstr ""
+"Deprecated the configuration option ``hnas_svcX_volume_type``. Use option "
+"``hnas_svcX_pool_name`` to indicate the name of the services (pools)."
+
+msgid ""
+"Deprecated the configuration option ``nas_ip``. Use option ``nas_host`` to "
+"indicate the IP address or hostname of the NAS system."
+msgstr ""
+"Deprecated the configuration option ``nas_ip``. Use option ``nas_host`` to "
+"indicate the IP address or hostname of the NAS system."
+
+msgid "Deprecation Notes"
+msgstr "Deprecation Notes"
+
+msgid ""
+"Disable creating volume with non cg_snapshot group_id in Storwize/SVC driver."
+msgstr ""
+"Disable creating volume with non cg_snapshot group_id in Storwize/SVC driver."
+
+msgid "Disable standard capabilities based on 3PAR licenses."
+msgstr "Disable standard capabilities based on 3PAR licenses."
+
+msgid ""
+"Drivers supporting consistent group snapshot in generic volume groups "
+"reports \"consistent_group_snapshot_enabled = True\" instead of "
+"\"consistencygroup_support = True\". As a result, a spec such as "
+"\"consistencygroup_support: '<is> True'\" in either group type or volume "
+"type will cause the scheduler not to choose the backend that does not report "
+"\"consistencygroup_support = True\". In order to create a generic volume "
+"group that supports consistent group snapshot, "
+"\"consistent_group_snapshot_enable: '<is> True'\" should be set in the group "
+"type specs and volume type extra specs, and \"consistencygroup_support: "
+"'<is> True'\" should not be set in group type spec and volume type extra "
+"specs."
+msgstr ""
+"Drivers supporting consistent group snapshot in generic volume groups "
+"reports \"consistent_group_snapshot_enabled = True\" instead of "
+"\"consistencygroup_support = True\". As a result, a spec such as "
+"\"consistencygroup_support: '<is> True'\" in either group type or volume "
+"type will cause the scheduler not to choose the backend that does not report "
+"\"consistencygroup_support = True\". In order to create a generic volume "
+"group that supports consistent group snapshot, "
+"\"consistent_group_snapshot_enable: '<is> True'\" should be set in the group "
+"type specs and volume type extra specs, and \"consistencygroup_support: "
+"'<is> True'\" should not be set in group type spec and volume type extra "
+"specs."
+
+msgid ""
+"Due to the ibmnas (SONAS) driver being rendered redundant by the addition of "
+"NFS capabilities to the IBM GPFS driver, the ibmnas driver is being removed "
+"in the Mitaka release."
+msgstr ""
+"Due to the ibmnas (SONAS) driver being rendered redundant by the addition of "
+"NFS capabilities to the IBM GPFS driver, the ibmnas driver is being removed "
+"in the Mitaka release."
+
+msgid ""
+"EMC ScaleIO driver now uses the config option san_thin_provision to "
+"determine the default provisioning type."
+msgstr ""
+"EMC ScaleIO driver now uses the config option san_thin_provision to "
+"determine the default provisioning type."
+
+msgid ""
+"EMC VNX driver have been rebranded to Dell EMC VNX driver. Existing "
+"configurations will continue to work with the legacy name, but will need to "
+"be updated by the next release. User needs update ``volume_driver`` to "
+"``cinder.volume.drivers.dell_emc.vnx.driver.VNXDriver``."
+msgstr ""
+"EMC VNX driver have been rebranded to Dell EMC VNX driver. Existing "
+"configurations will continue to work with the legacy name, but will need to "
+"be updated by the next release. User needs update ``volume_driver`` to "
+"``cinder.volume.drivers.dell_emc.vnx.driver.VNXDriver``."
+
+msgid ""
+"Enable backup snapshot optimal path by implementing attach and detach "
+"snapshot in the NEC driver."
+msgstr ""
+"Enable backup snapshot optimal path by implementing attach and detach "
+"snapshot in the NEC driver."
+
+msgid ""
+"Enable backup snapshot optimal path by implementing attach and detach "
+"snapshot in the VMAX driver."
+msgstr ""
+"Enable backup snapshot optimal path by implementing attach and detach "
+"snapshot in the VMAX driver."
+
+msgid ""
+"Enabled Cinder Multi-Attach capability in the Dell EMC Storage Center Cinder "
+"driver."
+msgstr ""
+"Enabled Cinder Multi-Attach capability in the Dell EMC Storage Centre Cinder "
+"driver."
+
+msgid ""
+"Enabled a cloud operator to correctly manage policy for volume type "
+"operations. To permit volume type operations for specific user, you can for "
+"example do as follows."
+msgstr ""
+"Enabled a cloud operator to correctly manage policy for volume type "
+"operations. To permit volume type operations for specific user, you can for "
+"example do as follows."
+
+msgid ""
+"Everything in Cinder's release notes related to the High Availability Active-"
+"Active effort -preluded with \"HA A-A:\"- is work in progress and should not "
+"be used in production until it has been completed and the appropriate "
+"release note has been issued stating its readiness for production."
+msgstr ""
+"Everything in Cinder's release notes related to the High Availability Active-"
+"Active effort -preluded with \"HA A-A:\"- is work in progress and should not "
+"be used in production until it has been completed and the appropriate "
+"release note has been issued stating its readiness for production."
+
+msgid "Extended Volume-Type Support for Datera Volume Drivers"
+msgstr "Extended Volume-Type Support for Datera Volume Drivers"
+
+msgid ""
+"Extra spec ``RESKEY:availability_zones`` will only be used for filtering "
+"backends when creating and retyping volumes."
+msgstr ""
+"Extra spec ``RESKEY:availability_zones`` will only be used for filtering "
+"backends when creating and retyping volumes."
+
+msgid "FalconStor FSS"
+msgstr "FalconStor FSS"
+
+msgid ""
+"Filtering volumes by their display name now correctly handles display names "
+"with single and double quotes."
+msgstr ""
+"Filtering volumes by their display name now correctly handles display names "
+"with single and double quotes."
+
+msgid ""
+"Fix NFS backup driver, we now support multiple backups on the same "
+"container, they are no longer overwritten."
+msgstr ""
+"Fix NFS backup driver, we now support multiple backups on the same "
+"container, they are no longer overwritten."
+
+msgid ""
+"Fix a quota usage error triggered by a non-admin user backing up an in-use "
+"volume. The forced backup uses a temporary volume, and quota usage was "
+"incorrectly updated when the temporary volume was deleted after the backup "
+"operation completed. Fixes `bug 1778774 <https://bugs.launchpad.net/tripleo/"
+"+bug/1778774>`__."
+msgstr ""
+"Fix a quota usage error triggered by a non-admin user backing up an in-use "
+"volume. The forced backup uses a temporary volume, and quota usage was "
+"incorrectly updated when the temporary volume was deleted after the backup "
+"operation completed. Fixes `bug 1778774 <https://bugs.launchpad.net/tripleo/"
+"+bug/1778774>`__."
+
+msgid ""
+"Fix for Tintri image direct clone feature. Fix for the bug 1400966 prevents "
+"user from specifying image \"nfs share location\" as location value for an "
+"image. Now, in order to use Tintri image direct clone, user can specify "
+"\"provider_location\" in image metadata to specify image nfs share location. "
+"NFS share which hosts images should be specified in a file using "
+"tintri_image_shares_config config option."
+msgstr ""
+"Fix for Tintri image direct clone feature. Fix for the bug 1400966 prevents "
+"user from specifying image \"nfs share location\" as location value for an "
+"image. Now, in order to use Tintri image direct clone, user can specify "
+"\"provider_location\" in image metadata to specify image NFS share location. "
+"NFS share which hosts images should be specified in a file using "
+"tintri_image_shares_config config option."
+
+msgid ""
+"Fix issue with PureFCDriver where partially case sensitive comparison of "
+"connector wwpn could cause initialize_connection to fail when attempting to "
+"create duplicate Purity host."
+msgstr ""
+"Fix issue with PureFCDriver where partially case sensitive comparison of "
+"connector wwpn could cause initialise_connection to fail when attempting to "
+"create duplicate Purity host."
+
+msgid ""
+"Fix the bug that Cinder can't support creating volume from Nova specific "
+"image which only includes ``snapshot-id`` metadata (Bug"
+msgstr ""
+"Fix the bug that Cinder can't support creating volume from Nova specific "
+"image which only includes ``snapshot-id`` metadata (Bug"
+
+msgid ""
+"Fix the bug that Cinder would commit quota twice in a clean environment when "
+"managing volume and snapshot resource (Bug"
+msgstr ""
+"Fix the bug that Cinder would commit quota twice in a clean environment when "
+"managing volume and snapshot resource (Bug"
+
+msgid ""
+"Fix the following volume image metadata endpoints returning None following "
+"policy enforcement failure:"
+msgstr ""
+"Fix the following volume image metadata endpoints returning None following "
+"policy enforcement failure:"
+
+msgid ""
+"Fix the way encryption key IDs are managed for encrypted volume backups. "
+"When creating a backup, the volume's encryption key is cloned and assigned a "
+"new key ID. The backup's cloned key ID is now stored in the backup database "
+"so that it can be deleted whenever the backup is deleted."
+msgstr ""
+"Fix the way encryption key IDs are managed for encrypted volume backups. "
+"When creating a backup, the volume's encryption key is cloned and assigned a "
+"new key ID. The backup's cloned key ID is now stored in the backup database "
+"so that it can be deleted whenever the backup is deleted."
+
+msgid ""
+"Fixed 'No Space left' error by dd command when users set the config option "
+"``volume_clear_size`` to a value larger than the size of a volume."
+msgstr ""
+"Fixed 'No Space left' error by dd command when users set the config option "
+"``volume_clear_size`` to a value larger than the size of a volume."
+
+msgid "Fixed ACL multi-attach bug in Datera EDF driver."
+msgstr "Fixed ACL multi-attach bug in Datera EDF driver."
+
+msgid ""
+"Fixed HNAS bug that placed a cloned volume in the same pool as its source, "
+"even if the clone had a different pool specification. Driver will not allow "
+"to make clones using a different volume type anymore."
+msgstr ""
+"Fixed HNAS bug that placed a cloned volume in the same pool as its source, "
+"even if the clone had a different pool specification. Driver will not allow "
+"to make clones using a different volume type any more."
+
+msgid "Fixed Non-WAN port filter issue in Kaminario iSCSI driver"
+msgstr "Fixed Non-WAN port filter issue in Kaminario iSCSI driver"
+
+msgid "Fixed Non-WAN port filter issue in Kaminario iSCSI driver."
+msgstr "Fixed Non-WAN port filter issue in Kaminario iSCSI driver."
+
+msgid "Fixed QNAP driver failures to create volume and snapshot in some cases."
+msgstr ""
+"Fixed QNAP driver failures to create volume and snapshot in some cases."
+
+msgid ""
+"Fixed QNAP driver failures to detach iscsi device while uploading volume to "
+"image."
+msgstr ""
+"Fixed QNAP driver failures to detach iSCSI device while uploading volume to "
+"image."
+
+msgid ""
+"Fixed StorWize/SVC error causing volume deletion to get stuck in the "
+"'deleting' state when using FlashCopy."
+msgstr ""
+"Fixed StorWize/SVC error causing volume deletion to get stuck in the "
+"'deleting' state when using FlashCopy."
+
+msgid ""
+"Fixed a bug which could create volumes with invalid content in case of "
+"unhandled errors from glance client (Bug `#1799221 <https://bugs.launchpad."
+"net/cinder/+bug/1799221>`_)."
+msgstr ""
+"Fixed a bug which could create volumes with invalid content in case of "
+"unhandled errors from glance client (Bug `#1799221 <https://bugs.launchpad."
+"net/cinder/+bug/1799221>`_)."
+
+msgid "Fixed a few scalability bugs in the Datera EDF driver."
+msgstr "Fixed a few scalability bugs in the Datera EDF driver."
+
+msgid ""
+"Fixed an error in quota handling that required the keystone "
+"encryption_auth_url to be configured even if no encryption was being used."
+msgstr ""
+"Fixed an error in quota handling that required the keystone "
+"encryption_auth_url to be configured even if no encryption was being used."
+
+msgid ""
+"Fixed an issue when deleting a consistency group snapshot with the Dell SC "
+"backend driver."
+msgstr ""
+"Fixed an issue when deleting a consistency group snapshot with the Dell SC "
+"backend driver."
+
+msgid ""
+"Fixed an issue where the NetApp cDOT NFS driver failed to clone new volumes "
+"from the image cache."
+msgstr ""
+"Fixed an issue where the NetApp cDOT NFS driver failed to clone new volumes "
+"from the image cache."
+
+msgid "Fixed an issue with live migration when using the EMC VMAX driver."
+msgstr "Fixed an issue with live migration when using the EMC VMAX driver."
+
+msgid "Fixed backup and restore of volumes in VMware VMDK driver."
+msgstr "Fixed backup and restore of volumes in VMware VMDK driver."
+
+msgid ""
+"Fixed bug #1731474 on NetApp Data ONTAP driver that was causing LUNs to be "
+"created with larger size than requested. This fix requires version 9.1 of "
+"ONTAP or later."
+msgstr ""
+"Fixed bug #1731474 on NetApp Data ONTAP driver that was causing LUNs to be "
+"created with larger size than requested. This fix requires version 9.1 of "
+"ONTAP or later."
+
+msgid ""
+"Fixed bug #1783582, where calls to os-force_detach were failing on NetApp "
+"ONTAP iSCSI/FC drivers."
+msgstr ""
+"Fixed bug #1783582, where calls to os-force_detach were failing on NetApp "
+"ONTAP iSCSI/FC drivers."
+
+msgid ""
+"Fixed bug 1632333 with the NetApp ONTAP Driver. Now the copy offload method "
+"is invoked early to avoid downloading Glance images twice."
+msgstr ""
+"Fixed bug 1632333 with the NetApp ONTAP Driver. Now the copy offload method "
+"is invoked early to avoid downloading Glance images twice."
+
+msgid ""
+"Fixed bug causing snapshot creation to fail on systems with LC_NUMERIC set "
+"to locale using ',' as decimal separator."
+msgstr ""
+"Fixed bug causing snapshot creation to fail on systems with LC_NUMERIC set "
+"to locale using ',' as decimal separator."
+
+msgid ""
+"Fixed consistency groups API which was always returning groups scoped to "
+"project ID from user context instead of given input project ID."
+msgstr ""
+"Fixed consistency groups API which was always returning groups scoped to "
+"project ID from user context instead of given input project ID."
+
+msgid ""
+"Fixed group availability zone-backend host mismatch [`Bug 1773446 <https://"
+"bugs.launchpad.net/cinder/+bug/1773446>`_]."
+msgstr ""
+"Fixed group availability zone-backend host mismatch [`Bug 1773446 <https://"
+"bugs.launchpad.net/cinder/+bug/1773446>`_]."
+
+msgid ""
+"Fixed issue of managing a VG with more than one volume in Kaminario FC and "
+"iSCSI Cinder drivers."
+msgstr ""
+"Fixed issue of managing a VG with more than one volume in Kaminario FC and "
+"iSCSI Cinder drivers."
+
+msgid ""
+"Fixed issue where Pure Volume Drivers would ignore reserved_percentage "
+"config option."
+msgstr ""
+"Fixed issue where Pure Volume Drivers would ignore reserved_percentage "
+"config option."
+
+msgid ""
+"Fixed issue where ``create`` and ``update`` api's of ``volume-type`` and "
+"``group_type`` were returning 500 error if boolean 'is_public' value passed "
+"in the form of string. Now user can pass following valid boolean values to "
+"these api's: '0', 'f', 'false', 'off', 'n', 'no', '1', 't', 'true', 'on', "
+"'y', 'yes'"
+msgstr ""
+"Fixed issue where ``create`` and ``update`` api's of ``volume-type`` and "
+"``group_type`` were returning 500 error if boolean 'is_public' value passed "
+"in the form of string. Now user can pass following valid boolean values to "
+"these api's: '0', 'f', 'false', 'off', 'n', 'no', '1', 't', 'true', 'on', "
+"'y', 'yes'"
+
+msgid ""
+"Fixed issue where the HNAS driver was not correctly reporting THIN "
+"provisioning and related stats."
+msgstr ""
+"Fixed issue where the HNAS driver was not correctly reporting THIN "
+"provisioning and related stats."
+
+msgid ""
+"Fixed issue with error being raised when performing a delete quota operation "
+"in a subproject."
+msgstr ""
+"Fixed issue with error being raised when performing a delete quota operation "
+"in a subproject."
+
+msgid "Fixed issue with extra-specs not being applied when cloning a volume."
+msgstr "Fixed issue with extra-specs not being applied when cloning a volume."
+
+msgid ""
+"Fixed issue with the EMC ScaleIO driver not able to identify a volume after "
+"a migration is performed."
+msgstr ""
+"Fixed issue with the EMC ScaleIO driver not able to identify a volume after "
+"a migration is performed."
+
+msgid "Fixed live migration on EMC VMAX3 backends."
+msgstr "Fixed live migration on EMC VMAX3 backends."
+
+msgid ""
+"Fixed misleading error message when NetApp copyoffload tool is not in place "
+"during image cloning."
+msgstr ""
+"Fixed misleading error message when NetApp copyoffload tool is not in place "
+"during image cloning."
+
+msgid ""
+"Fixed service state reporting when backup manager is unable to initialize "
+"one of the backup drivers."
+msgstr ""
+"Fixed service state reporting when backup manager is unable to initialise "
+"one of the backup drivers."
+
+msgid ""
+"Fixed support for IPv6 on management and data paths for NFS, iSCSI and FCP "
+"NetApp ONTAP drivers."
+msgstr ""
+"Fixed support for IPv6 on management and data paths for NFS, iSCSI and FCP "
+"NetApp ONTAP drivers."
+
+msgid ""
+"Fixed the VMware VMDK driver to create volume from image in ova container."
+msgstr ""
+"Fixed the VMware VMDK driver to create volume from image in ova container."
+
+msgid ""
+"Fixed using of the user's token in the nova client (`bug #1686616 <https://"
+"bugs.launchpad.net/cinder/+bug/1686616>`_)"
+msgstr ""
+"Fixed using of the user's token in the nova client (`bug #1686616 <https://"
+"bugs.launchpad.net/cinder/+bug/1686616>`_)"
+
+msgid ""
+"Fixed volume extend issue that allowed a tenant with enough quota to extend "
+"the volume to limits greater than what the volume backend supported."
+msgstr ""
+"Fixed volume extend issue that allowed a tenant with enough quota to extend "
+"the volume to limits greater than what the volume backend supported."
+
+msgid ""
+"Fixes a bug in NetApp SolidFire where the deletion of group snapshots was "
+"failing."
+msgstr ""
+"Fixes a bug in NetApp SolidFire where the deletion of group snapshots was "
+"failing."
+
+msgid ""
+"Fixes a bug that prevented the configuration of multiple redundant Quobyte "
+"registries in the quobyte_volume_url config option."
+msgstr ""
+"Fixes a bug that prevented the configuration of multiple redundant Quobyte "
+"registries in the quobyte_volume_url config option."
+
+msgid ""
+"Fixes an issue where starting the Pure volume drivers with replication "
+"enabled and default values for pure_replica_interval_default would cause an "
+"error to be raised from the backend."
+msgstr ""
+"Fixes an issue where starting the Pure volume drivers with replication "
+"enabled and default values for pure_replica_interval_default would cause an "
+"error to be raised from the backend."
+
+msgid ""
+"Fixes concurrency issue on backups, where only 20 native threads could be "
+"concurrently be executed.  Now default will be 60, and can be changed with "
+"`backup_native_threads_pool_size`."
+msgstr ""
+"Fixes concurrency issue on backups, where only 20 native threads could be "
+"concurrently be executed.  Now the default will be 60, and can be changed "
+"with `backup_native_threads_pool_size`."
+
+msgid "Fixes force_detach behavior for volumes in NetApp SolidFire driver."
+msgstr "Fixes force_detach behaviour for volumes in NetApp SolidFire driver."
+
+msgid ""
+"Following APIs were accepting boolean parameters with leading and trailing "
+"white spaces (for e.g. \" true \"). But now with schema validation support, "
+"all these boolean parameters henceforth will not accept leading and trailing "
+"whitespaces to maintain consistency."
+msgstr ""
+"Following APIs were accepting boolean parameters with leading and trailing "
+"white spaces (for e.g. \" true \"). But now with schema validation support, "
+"all these boolean parameters henceforth will not accept leading and trailing "
+"whitespaces to maintain consistency."
+
+msgid ""
+"For EMC VNX backends, please upgrade to use ``cinder.volume.drivers.emc.vnx."
+"driver.EMCVNXDriver``. Add config option ``storage_protocol = fc`` or "
+"``storage_protocol = iscsi`` to the driver section to enable the FC or iSCSI "
+"driver respectively."
+msgstr ""
+"For EMC VNX backends, please upgrade to use ``cinder.volume.drivers.emc.vnx."
+"driver.EMCVNXDriver``. Add config option ``storage_protocol = fc`` or "
+"``storage_protocol = iscsi`` to the driver section to enable the FC or iSCSI "
+"driver respectively."
+
+msgid ""
+"For SolidFire, QoS specs are now checked to make sure they fall within the "
+"min and max constraints. If not the QoS specs are capped at the min or max "
+"(i.e. if spec says 50 and minimum supported is 100, the driver will set it "
+"to 100)."
+msgstr ""
+"For SolidFire, QoS specs are now checked to make sure they fall within the "
+"min and max constraints. If not the QoS specs are capped at the min or max "
+"(i.e. if spec says 50 and minimum supported is 100, the driver will set it "
+"to 100)."
+
+msgid "Generic group is added into quota management."
+msgstr "Generic group is added into quota management."
+
+msgid "Generic volume groups:"
+msgstr "Generic volume groups:"
+
+msgid ""
+"Google backup driver now supports ``google-auth`` library, and is the "
+"preferred library if both ``google-auth`` (together with ``google-auth-"
+"httplib2``) and ``oauth2client`` libraries are present in the system."
+msgstr ""
+"Google backup driver now supports ``google-auth`` library, and is the "
+"preferred library if both ``google-auth`` (together with ``google-auth-"
+"httplib2``) and ``oauth2client`` libraries are present in the system."
+
+msgid ""
+"Google backup driver now works when using ``google-api-python-client`` "
+"version 1.6.0 or higher."
+msgstr ""
+"Google backup driver now works when using ``google-api-python-client`` "
+"version 1.6.0 or higher."
+
+msgid "Group APIs will not work on groups with default_cgsnapshot_type."
+msgstr "Group APIs will not work on groups with default_cgsnapshot_type."
+
+msgid "Group APIs will only write/read in/from the groups table."
+msgstr "Group APIs will only write/read in/from the groups table."
+
+msgid "Groups with default_cgsnapshot_type can only be operated by CG APIs."
+msgstr "Groups with default_cgsnapshot_type can only be operated by CG APIs."
+
+msgid ""
+"HA A-A: Add cluster configuration option to allow grouping hosts that share "
+"the same backend configurations and should work in Active-Active fashion."
+msgstr ""
+"HA A-A: Add cluster configuration option to allow grouping hosts that share "
+"the same backend configurations and should work in Active-Active fashion."
+
+msgid ""
+"HA A-A: Added cluster subcommand in manage command to list, remove, and "
+"rename clusters."
+msgstr ""
+"HA A-A: Added cluster subcommand in manage command to list, remove, and "
+"rename clusters."
+
+msgid ""
+"HA A-A: Added clusters API endpoints for cluster related operations (index, "
+"detail, show, enable/disable).  Index and detail accept filtering by `name`, "
+"`binary`, `disabled`, `num_hosts`, `num_down_hosts`, and up/down status "
+"(`is_up`) as URL parameters.  Also added their respective policies."
+msgstr ""
+"HA A-A: Added clusters API endpoints for cluster related operations (index, "
+"detail, show, enable/disable).  Index and detail accept filtering by `name`, "
+"`binary`, `disabled`, `num_hosts`, `num_down_hosts`, and up/down status "
+"(`is_up`) as URL parameters.  Also added their respective policies."
+
+msgid ""
+"HA A-A: Updated manage command to display cluster information on service "
+"listings."
+msgstr ""
+"HA A-A: Updated manage command to display cluster information on service "
+"listings."
+
+msgid ""
+"HNAS drivers have new configuration paths. Users should now use ``cinder."
+"volume.drivers.hitachi.hnas_nfs.HNASNFSDriver`` for HNAS NFS driver and "
+"``cinder.volume.drivers.hitachi.hnas_iscsi.HNASISCSIDriver`` for HNAS iSCSI "
+"driver."
+msgstr ""
+"HNAS drivers have new configuration paths. Users should now use ``cinder."
+"volume.drivers.hitachi.hnas_nfs.HNASNFSDriver`` for HNAS NFS driver and "
+"``cinder.volume.drivers.hitachi.hnas_iscsi.HNASISCSIDriver`` for HNAS iSCSI "
+"driver."
+
+msgid "HNAS drivers will now read configuration from cinder.conf."
+msgstr "HNAS drivers will now read configuration from cinder.conf."
+
+msgid ""
+"HP drivers have been rebranded to HPE. Existing configurations will continue "
+"to work with the legacy name, but will need to be updated by the next "
+"release."
+msgstr ""
+"HP drivers have been rebranded to HPE. Existing configurations will continue "
+"to work with the legacy name, but will need to be updated by the next "
+"release."
+
+msgid ""
+"HPE 3PAR driver adds following functionalities Creating thin/dedup "
+"compresssed volume. Retype for tpvv/tdvv volumes to be compressed. Migration "
+"of compressed volumes. Create compressed volume from compressed volume/"
+"snapshot source. Compression support to create cg from source."
+msgstr ""
+"HPE 3PAR driver adds following functionalities Creating thin/dedup "
+"compressed volume. Retype for tpvv/tdvv volumes to be compressed. Migration "
+"of compressed volumes. Create compressed volume from compressed volume/"
+"snapshot source. Compression support to create cg from source."
+
+msgid ""
+"HPE LeftHand config options ``hplefthand_api_url``, ``hplefthand_username``, "
+"``hplefthand_password``, ``hplefthand_clustername``, "
+"``hplefthand_iscsi_chap_enabled``, and ``hplefthand_debug`` were deprecated "
+"in the Mitaka release and have now been removed. The corresponding "
+"``hpelefthand_api_url``, ``hpelefthand_username``, ``hpelefthand_password``, "
+"``hpelefthand_clustername``, ``hpelefthand_iscsi_chap_enabled``, and "
+"``hpelefthand_debug`` should be used instead."
+msgstr ""
+"HPE LeftHand config options ``hplefthand_api_url``, ``hplefthand_username``, "
+"``hplefthand_password``, ``hplefthand_clustername``, "
+"``hplefthand_iscsi_chap_enabled``, and ``hplefthand_debug`` were deprecated "
+"in the Mitaka release and have now been removed. The corresponding "
+"``hpelefthand_api_url``, ``hpelefthand_username``, ``hpelefthand_password``, "
+"``hpelefthand_clustername``, ``hpelefthand_iscsi_chap_enabled``, and "
+"``hpelefthand_debug`` should be used instead."
+
+msgid ""
+"HTTP connector for the Cinder Brocade FC Zone plugin. This connector allows "
+"for communication between the Brocade FC zone plugin and the switch to be "
+"over HTTP or HTTPs.  To make use of this connector, the user would add a "
+"configuration setting in the fabric block for a Brocade switch with the name "
+"as 'fc_southbound_protocol' with a value as 'HTTP' or 'HTTPS'."
+msgstr ""
+"HTTP connector for the Cinder Brocade FC Zone plugin. This connector allows "
+"for communication between the Brocade FC zone plugin and the switch to be "
+"over HTTP or HTTPS.  To make use of this connector, the user would add a "
+"configuration setting in the fabric block for a Brocade switch with the name "
+"as 'fc_southbound_protocol' with a value as 'HTTP' or 'HTTPS'."
+
+msgid ""
+"Hitachi VSP drivers have a new config option ``vsp_compute_target_ports`` to "
+"specify IDs of the storage ports used to attach volumes to compute nodes. "
+"The default is the value specified for the existing ``vsp_target_ports`` "
+"option. Either or both of ``vsp_compute_target_ports`` and "
+"``vsp_target_ports`` must be specified."
+msgstr ""
+"Hitachi VSP drivers have a new config option ``vsp_compute_target_ports`` to "
+"specify IDs of the storage ports used to attach volumes to compute nodes. "
+"The default is the value specified for the existing ``vsp_target_ports`` "
+"option. Either or both of ``vsp_compute_target_ports`` and "
+"``vsp_target_ports`` must be specified."
+
+msgid ""
+"Hitachi VSP drivers have a new config option ``vsp_horcm_pair_target_ports`` "
+"to specify IDs of the storage ports used to copy volumes by Shadow Image or "
+"Thin Image. The default is the value specified for the existing "
+"``vsp_target_ports`` option. Either or both of "
+"``vsp_horcm_pair_target_ports`` and ``vsp_target_ports`` must be specified."
+msgstr ""
+"Hitachi VSP drivers have a new config option ``vsp_horcm_pair_target_ports`` "
+"to specify IDs of the storage ports used to copy volumes by Shadow Image or "
+"Thin Image. The default is the value specified for the existing "
+"``vsp_target_ports`` option. Either or both of "
+"``vsp_horcm_pair_target_ports`` and ``vsp_target_ports`` must be specified."
+
+msgid "IBM DS8K driver has added multiattach support."
+msgstr "IBM DS8K driver has added multiattach support."
+
+msgid ""
+"INFINIDAT volume driver now requires the 'infinisdk' python module to be "
+"installed."
+msgstr ""
+"INFINIDAT volume driver now requires the 'infinisdk' Python module to be "
+"installed."
+
+msgid "IQN identification is now case-insensitive when using LIO."
+msgstr "IQN identification is now case-insensitive when using LIO."
+
+msgid ""
+"If RBD stats collection is taking too long in your environment maybe even "
+"leading to the service appearing as down you'll want to use the "
+"`rbd_exclusive_cinder_pool = true` configuration option if you are using the "
+"pool exclusively for Cinder and maybe even if you are not and can live with "
+"the innacuracy."
+msgstr ""
+"If RBD stats collection is taking too long in your environment maybe even "
+"leading to the service appearing as down you'll want to use the "
+"`rbd_exclusive_cinder_pool = true` configuration option if you are using the "
+"pool exclusively for Cinder and maybe even if you are not and can live with "
+"the inaccuracy."
+
+msgid ""
+"If device attachment failed it could leave the volume partially attached. "
+"Cinder now tries to clean up on failure."
+msgstr ""
+"If device attachment failed it could leave the volume partially attached. "
+"Cinder now tries to clean up on failure."
+
+msgid ""
+"If during a *live* upgrade from Liberty a backup service will be killed "
+"while processing a restore request it may happen that such backup status "
+"won't be automatically cleaned up on the service restart. Such orphaned "
+"backups need to be cleaned up manually."
+msgstr ""
+"If during a *live* upgrade from Liberty a backup service will be killed "
+"while processing a restore request it may happen that such backup status "
+"won't be automatically cleaned up on the service restart. Such orphaned "
+"backups need to be cleaned up manually."
+
+msgid ""
+"If policy for update volume metadata is modified in a desired way it's "
+"needed to add a desired rule for create volume metadata."
+msgstr ""
+"If policy for update volume metadata is modified in a desired way it's "
+"needed to add a desired rule for create volume metadata."
+
+msgid ""
+"If using the NetApp ONTAP drivers (7mode/cmode), the configuration value for "
+"\"max_over_subscription_ratio\" may need to be increased to avoid scheduling "
+"problems where storage pools that previously were valid to schedule new "
+"volumes suddenly appear to be out of space to the Cinder scheduler. See "
+"documentation `here <https://docs.openstack .org/cinder/latest/admin/"
+"blockstorage-over-subscription.html>`_."
+msgstr ""
+"If using the NetApp ONTAP drivers (7mode/cmode), the configuration value for "
+"\"max_over_subscription_ratio\" may need to be increased to avoid scheduling "
+"problems where storage pools that previously were valid to schedule new "
+"volumes suddenly appear to be out of space to the Cinder scheduler. See "
+"documentation `here <https://docs.openstack .org/cinder/latest/admin/"
+"blockstorage-over-subscription.html>`_."
+
+msgid ""
+"If using the key manager, the configuration details should be updated to "
+"reflect the Castellan-specific configuration options."
+msgstr ""
+"If using the key manager, the configuration details should be updated to "
+"reflect the Castellan-specific configuration options."
+
+msgid ""
+"In IBM Storwize_SVC driver, user could specify only one IO group per backend "
+"definition. The user now may specify a comma separated list of IO groups, "
+"and at the time of creating the volume, the driver will select an IO group "
+"which has the least number of volumes associated with it. The change is "
+"backward compatible, meaning single value is still supported."
+msgstr ""
+"In IBM Storwize_SVC driver, user could specify only one IO group per backend "
+"definition. The user now may specify a comma separated list of IO groups, "
+"and at the time of creating the volume, the driver will select an IO group "
+"which has the least number of volumes associated with it. The change is "
+"backward compatible, meaning single value is still supported."
+
+msgid ""
+"In NEC driver, the deprecated configuration parameter "
+"`ldset_controller_node_name` was deleted."
+msgstr ""
+"In NEC driver, the deprecated configuration parameter "
+"`ldset_controller_node_name` was deleted."
+
+msgid ""
+"In NEC driver, the number of volumes in a storage pool is no longer limited "
+"to 1024. More volumes can be created with storage firmware revision 1015 or "
+"later."
+msgstr ""
+"In the NEC driver, the number of volumes in a storage pool is no longer "
+"limited to 1024. More volumes can be created with storage firmware revision "
+"1015 or later."
+
+msgid ""
+"In VNX Cinder driver, ``replication_device`` keys, ``backend_id`` and "
+"``san_ip`` are mandatory now. If you prefer security file authentication, "
+"please append ``storage_vnx_security_file_dir`` in ``replication_device``, "
+"otherwise, append ``san_login``, ``san_password``, "
+"``storage_vnx_authentication_type`` in ``replication_device``."
+msgstr ""
+"In VNX Cinder driver, ``replication_device`` keys, ``backend_id`` and "
+"``san_ip`` are mandatory now. If you prefer security file authentication, "
+"please append ``storage_vnx_security_file_dir`` in ``replication_device``, "
+"otherwise, append ``san_login``, ``san_password``, "
+"``storage_vnx_authentication_type`` in ``replication_device``."
+
+msgid ""
+"In certain environments (Kubernetes for example) indirect calls to the LVM "
+"commands result in file descriptor leak warning messages which in turn cause "
+"the process_execution method to raise and exception."
+msgstr ""
+"In certain environments (Kubernetes for example) indirect calls to the LVM "
+"commands result in file descriptor leak warning messages which in turn cause "
+"the process_execution method to raise and exception."
+
+msgid ""
+"In order to simplify initial setup for new installations the default "
+"behaviour of the Quobyte driver for the options "
+"``nas_secure_file_operations`` and ``nas_secure_file_permissions`` has "
+"changed. The 'auto' values are no longer mapped to true but to false. "
+"Therefore the old default behaviour to run with secure settings is changed "
+"to run without secure settings as the new default behaviour. Installations "
+"using the default values for these options should ensure to explicitly set "
+"them to true with this new Cinder Quobyte driver version."
+msgstr ""
+"In order to simplify initial setup for new installations the default "
+"behaviour of the Quobyte driver for the options "
+"``nas_secure_file_operations`` and ``nas_secure_file_permissions`` has "
+"changed. The 'auto' values are no longer mapped to true but to false. "
+"Therefore the old default behaviour to run with secure settings is changed "
+"to run without secure settings as the new default behaviour. Installations "
+"using the default values for these options should ensure to explicitly set "
+"them to true with this new Cinder Quobyte driver version."
+
+msgid "Infortrend"
+msgstr "Infortrend"
+
+msgid ""
+"Instead of ``api_class`` option ``cinder.keymgr.barbican."
+"BarbicanKeyManager``, use ``backend`` option `barbican``"
+msgstr ""
+"Instead of ``api_class`` option ``cinder.keymgr.barbican."
+"BarbicanKeyManager``, use ``backend`` option `barbican``"
+
+msgid ""
+"Instead of using osapi_volume_base_url use public_endpoint. Both do the same "
+"thing."
+msgstr ""
+"Instead of using osapi_volume_base_url use public_endpoint. Both do the same "
+"thing."
+
+msgid ""
+"IntOpt ``datera_num_replicas`` is changed to a volume type extra spec "
+"option-- ``DF:replica_count``"
+msgstr ""
+"IntOpt ``datera_num_replicas`` is changed to a volume type extra spec "
+"option-- ``DF:replica_count``"
+
+msgid ""
+"Introduced generic volume groups and added create/ delete/update/list/show "
+"APIs for groups."
+msgstr ""
+"Introduced generic volume groups and added create/ delete/update/list/show "
+"APIs for groups."
+
+msgid ""
+"Introduced replication group support and added group action APIs "
+"enable_replication, disable_replication, failover_replication and "
+"list_replication_targets."
+msgstr ""
+"Introduced replication group support and added group action APIs "
+"enable_replication, disable_replication, failover_replication and "
+"list_replication_targets."
+
+msgid ""
+"It is now possible to delete a volume and its snapshots by passing an "
+"additional argument to volume delete, \"cascade=True\"."
+msgstr ""
+"It is now possible to delete a volume and its snapshots by passing an "
+"additional argument to volume delete, \"cascade=True\"."
+
+msgid ""
+"It is required to copy new rootwrap.d/volume.filters file into /etc/cinder/"
+"rootwrap.d directory."
+msgstr ""
+"It is required to copy new rootwrap.d/volume.filters file into /etc/cinder/"
+"rootwrap.d directory."
+
+msgid ""
+"Kaminario K2 iSCSI driver now supports non discovery multipathing (Nova and "
+"Cinder won't use iSCSI sendtargets) which can be enabled by setting "
+"`disable_discovery` to `true` in the configuration."
+msgstr ""
+"Kaminario K2 iSCSI driver now supports non discovery multipathing (Nova and "
+"Cinder won't use iSCSI sendtargets) which can be enabled by setting "
+"`disable_discovery` to `true` in the configuration."
+
+msgid ""
+"Kaminario K2 now supports networks with duplicated FQDNs via configuration "
+"option `unique_fqdn_network` so attaching in these networks will work (bug "
+"#1720147)."
+msgstr ""
+"Kaminario K2 now supports networks with duplicated FQDNs via configuration "
+"option `unique_fqdn_network` so attaching in these networks will work (bug "
+"#1720147)."
+
+msgid ""
+"Key migration is initiated on service startup, and entries in the cinder-"
+"volume log will indicate the migration status. Log entries will indicate "
+"when a volume's encryption key ID has been migrated to Barbican, and a "
+"summary log message will indicate when key migration has finished."
+msgstr ""
+"Key migration is initiated on service start-up, and entries in the cinder-"
+"volume log will indicate the migration status. Log entries will indicate "
+"when a volume's encryption key ID has been migrated to Barbican, and a "
+"summary log message will indicate when key migration has finished."
+
+msgid "Known Issues"
+msgstr "Known Issues"
+
+msgid ""
+"LUKS Encrypted RBD volumes can now be created by cinder-volume. This "
+"capability was previously blocked by the rbd volume driver due to the lack "
+"of any encryptors capable of attaching to an encrypted RBD volume. These "
+"volumes can also be seeded with RAW image data from Glance through the use "
+"of QEMU 2.10 and the qemu-img convert command."
+msgstr ""
+"LUKS Encrypted RBD volumes can now be created by cinder-volume. This "
+"capability was previously blocked by the rbd volume driver due to the lack "
+"of any encryptors capable of attaching to an encrypted RBD volume. These "
+"volumes can also be seeded with RAW image data from Glance through the use "
+"of QEMU 2.10 and the qemu-img convert command."
+
+msgid "Liberty Series Release Notes"
+msgstr "Liberty Series Release Notes"
+
+msgid "List CG Snapshots checks both the CG and the groups tables."
+msgstr "List CG Snapshots checks both the CG and the groups tables."
+
+msgid "List CG checks both CG and groups tables."
+msgstr "List CG checks both CG and groups tables."
+
+msgid ""
+"Locks may use Tooz as abstraction layer now, to support distributed lock "
+"managers and prepare Cinder to better support HA configurations."
+msgstr ""
+"Locks may use Tooz as abstraction layer now, to support distributed lock "
+"managers and prepare Cinder to better support HA configurations."
+
+msgid "Log VMAX specific metadata of a volume if debug is enabled."
+msgstr "Log VMAX specific metadata of a volume if debug is enabled."
+
+msgid ""
+"Logging path can now be configured for vzstorage driver in shares config "
+"file (specified by vzstorage_shares_config option). To set custom logging "
+"path add `'-l', '<path_to_log_file>'` to mount options array. Otherwise "
+"default logging path `/var/log/vstorage/<cluster_name>/cinder.log.gz` will "
+"be used."
+msgstr ""
+"Logging path can now be configured for vzstorage driver in shares config "
+"file (specified by vzstorage_shares_config option). To set custom logging "
+"path add `'-l', '<path_to_log_file>'` to mount options array. Otherwise "
+"default logging path `/var/log/vstorage/<cluster_name>/cinder.log.gz` will "
+"be used."
+
+msgid ""
+"Make Cinder scheduler check if backend reports `online_extend_support` "
+"before performing an online extend operation."
+msgstr ""
+"Make Cinder scheduler check if backend reports `online_extend_support` "
+"before performing an online extend operation."
+
+msgid ""
+"Manage and unmanage support has been added to the Nimble backend driver."
+msgstr ""
+"Manage and unmanage support has been added to the Nimble backend driver."
+
+msgid ""
+"Marked the ITRI DISCO driver option ``disco_wsdl_path`` as deprecated. The "
+"new preferred protocol for array communication is REST and SOAP support will "
+"be removed."
+msgstr ""
+"Marked the ITRI DISCO driver option ``disco_wsdl_path`` as deprecated. The "
+"new preferred protocol for array communication is REST and SOAP support will "
+"be removed."
+
+msgid "Mitaka Series Release Notes"
+msgstr "Mitaka Series Release Notes"
+
+msgid ""
+"Modify CG modifies in the CG table if the CG is in the CG table, otherwise "
+"it modifies in the groups table."
+msgstr ""
+"Modify CG modifies in the CG table if the CG is in the CG table, otherwise "
+"it modifies in the groups table."
+
+msgid ""
+"Modify default lvm_type setting from thick to auto.  This will result in "
+"Cinder preferring thin on init, if there are no LV's in the VG it will "
+"create a thin-pool and use thin.  If there are LV's and no thin-pool it will "
+"continue using thick."
+msgstr ""
+"Modify default lvm_type setting from thick to auto.  This will result in "
+"Cinder preferring thin on init, if there are no LV's in the VG it will "
+"create a thin-pool and use thin.  If there are LV's and no thin-pool it will "
+"continue using thick."
+
+msgid "Modify rule for types_manage and volume_type_access, e.g."
+msgstr "Modify rule for types_manage and volume_type_access, e.g."
+
+msgid ""
+"Modifying the extra-specs of an in use Volume Type was something that we've "
+"unintentionally allowed.  The result is unexpected or unknown volume "
+"behaviors in cases where a type was modified while a volume was assigned "
+"that type.  This has been particularly annoying for folks that have assigned "
+"the volume-type to a different/new backend device. In case there are "
+"customers using this \"bug\" we add a config option to retain the bad "
+"behavior \"allow_inuse_volume_type_modification\", with a default setting of "
+"False (Don't allow).  Note this config option is being introduced as "
+"deprecated and will be removed in a future release.  It's being provided as "
+"a bridge to not break upgrades without notice."
+msgstr ""
+"Modifying the extra-specs of an in use Volume Type was something that we've "
+"unintentionally allowed.  The result is unexpected or unknown volume "
+"behaviours in cases where a type was modified while a volume was assigned "
+"that type.  This has been particularly annoying for folks that have assigned "
+"the volume-type to a different/new backend device. In case there are "
+"customers using this \"bug\" we add a config option to retain the bad "
+"behaviour \"allow_inuse_volume_type_modification\", with a default setting "
+"of False (Don't allow).  Note this config option is being introduced as "
+"deprecated and will be removed in a future release.  It's being provided as "
+"a bridge to not break upgrades without notice."
+
+msgid ""
+"Multiattach support is disabled for the LVM driver when using the LIO iSCSI "
+"target.  This functionality will be fixed in a later release."
+msgstr ""
+"Multiattach support is disabled for the LVM driver when using the LIO iSCSI "
+"target.  This functionality will be fixed in a later release."
+
+msgid ""
+"Multiple backends may now be enabled within the same Cinder Volume service "
+"on Windows by using the ``enabled_backends`` config option."
+msgstr ""
+"Multiple backends may now be enabled within the same Cinder Volume service "
+"on Windows by using the ``enabled_backends`` config option."
+
+msgid "Naming convention change for Datera Volume Drivers"
+msgstr "Naming convention change for Datera Volume Drivers"
+
+msgid ""
+"Nested quotas will no longer be used by default, but can be configured by "
+"setting ``quota_driver = cinder.quota.NestedDbQuotaDriver``"
+msgstr ""
+"Nested quotas will no longer be used by default, but can be configured by "
+"setting ``quota_driver = cinder.quota.NestedDbQuotaDriver``"
+
+msgid ""
+"NetApp E-series (bug 1718739):The NetApp E-series driver has been fixed to "
+"correctly report the \"provisioned_capacity_gb\". Now it sums the capacity "
+"of all the volumes in the configured backend to get the correct value. This "
+"bug fix affects all the protocols supported by the driver (FC and iSCSI)."
+msgstr ""
+"NetApp E-series (bug 1718739):The NetApp E-series driver has been fixed to "
+"correctly report the \"provisioned_capacity_gb\". Now it sums the capacity "
+"of all the volumes in the configured backend to get the correct value. This "
+"bug fix affects all the protocols supported by the driver (FC and iSCSI)."
+
+msgid ""
+"NetApp ONTAP (bug 1762424): Fix ONTAP NetApp driver not being able to extend "
+"a volume to a size greater than the corresponding LUN max geometry."
+msgstr ""
+"NetApp ONTAP (bug 1762424): Fix ONTAP NetApp driver not being able to extend "
+"a volume to a size greater than the corresponding LUN max geometry."
+
+msgid ""
+"NetApp ONTAP (bug 1765182): Make ONTAP NetApp NFS driver report to the "
+"Cinder scheduler that it doesn't support online volume extending."
+msgstr ""
+"NetApp ONTAP (bug 1765182): Make ONTAP NetApp NFS driver report to the "
+"Cinder scheduler that it doesn't support online volume extending."
+
+msgid ""
+"NetApp ONTAP (bug 1765182): Make ONTAP NetApp iSCSI driver and FC driver "
+"report to the Cinder scheduler that they don't support online volume "
+"extending."
+msgstr ""
+"NetApp ONTAP (bug 1765182): Make ONTAP NetApp iSCSI driver and FC driver "
+"report to the Cinder scheduler that they don't support online volume "
+"extending."
+
+msgid ""
+"NetApp ONTAP NFS (bug 1690954): Fix wrong usage of export path as volume "
+"name when deleting volumes and snapshots."
+msgstr ""
+"NetApp ONTAP NFS (bug 1690954): Fix wrong usage of export path as volume "
+"name when deleting volumes and snapshots."
+
+msgid "NetApp ONTAP NFS multiattach capability enabled."
+msgstr "NetApp ONTAP NFS multiattach capability enabled."
+
+msgid ""
+"NetApp ONTAP iSCSI (bug 1712651): Fix ONTAP NetApp iSCSI driver not raising "
+"a proper exception when trying to extend an attached volume beyond its max "
+"geometry."
+msgstr ""
+"NetApp ONTAP iSCSI (bug 1712651): Fix ONTAP NetApp iSCSI driver not raising "
+"a proper exception when trying to extend an attached volume beyond its max "
+"geometry."
+
+msgid "NetApp ONTAP iSCSI and FCP drivers multiattach capability enabled."
+msgstr "NetApp ONTAP iSCSI and FCP drivers multiattach capability enabled."
+
+msgid ""
+"NetApp SolidFire driver now supports optimized revert to snapshot operations."
+msgstr ""
+"NetApp SolidFire driver now supports optimized revert to snapshot operations."
+
+msgid ""
+"NetApp cDOT block and file drivers have improved support for SVM scoped user "
+"accounts. Features not supported for SVM scoped users include QoS, aggregate "
+"usage reporting, and dedupe usage reporting."
+msgstr ""
+"NetApp cDOT block and file drivers have improved support for SVM scoped user "
+"accounts. Features not supported for SVM scoped users include QoS, aggregate "
+"usage reporting, and dedupe usage reporting."
+
+msgid ""
+"NetApp cDOT block and file drivers now report replication capability at the "
+"pool level; and are hence compatible with using the ``replication_enabled`` "
+"extra-spec in volume types."
+msgstr ""
+"NetApp cDOT block and file drivers now report replication capability at the "
+"pool level; and are hence compatible with using the ``replication_enabled`` "
+"extra-spec in volume types."
+
+msgid ""
+"New BoolOpt ``datera_debug_override_num_replicas`` for Datera Volume Drivers"
+msgstr ""
+"New BoolOpt ``datera_debug_override_num_replicas`` for Datera Volume Drivers"
+
+msgid ""
+"New Cinder driver based on storops library (available in pypi) for EMC VNX."
+msgstr ""
+"New Cinder driver based on storops library (available in pypi) for EMC VNX."
+
+msgid "New Cinder volume driver for Inspur AS13000 series."
+msgstr "New Cinder volume driver for Inspur AS13000 series."
+
+msgid ""
+"New Cinder volume driver for Inspur InStorage. The new driver supports iSCSI."
+msgstr ""
+"New Cinder volume driver for Inspur InStorage. The new driver supports iSCSI."
+
+msgid "New Cinder volume driver for LINBIT LINSTOR resources."
+msgstr "New Cinder volume driver for LINBIT LINSTOR resources."
+
+msgid "New FC Cinder volume driver for Inspur Instorage."
+msgstr "New FC Cinder volume driver for Inspur Instorage."
+
+msgid "New FC Cinder volume driver for Kaminario K2 all-flash arrays."
+msgstr "New FC Cinder volume driver for Kaminario K2 all-flash arrays."
+
+msgid "New Features"
+msgstr "New Features"
+
+msgid ""
+"New config format to allow for using shared Volume Driver configuration "
+"defaults via the [backend_defaults] stanza. Config options defined there "
+"will be used as defaults for each backend enabled via enabled_backends."
+msgstr ""
+"New config format to allow for using shared Volume Driver configuration "
+"defaults via the [backend_defaults] stanza. Config options defined there "
+"will be used as defaults for each backend enabled via enabled_backends."
+
+msgid ""
+"New config option added. ``\"connection_string\"`` in [profiler] section is "
+"used to specify OSProfiler driver connection string, for example, ``"
+"\"connection_string = messaging://\"``, ``\"connection_string = mongodb://"
+"localhost:27017\"``"
+msgstr ""
+"New config option added. ``\"connection_string\"`` in [profiler] section is "
+"used to specify OSProfiler driver connection string, for example, ``"
+"\"connection_string = messaging://\"``, ``\"connection_string = mongodb://"
+"localhost:27017\"``"
+
+msgid ""
+"New config option for Pure Storage volume drivers pure_eradicate_on_delete. "
+"When enabled will permanantly eradicate data instead of placing into pending "
+"eradication state."
+msgstr ""
+"New config option for Pure Storage volume drivers pure_eradicate_on_delete. "
+"When enabled will permanently eradicate data instead of placing into pending "
+"eradication state."
+
+msgid ""
+"New config option to enable discard (trim/unmap) support for any backend."
+msgstr ""
+"New config option to enable discard (trim/unmap) support for any backend."
+
+msgid "New iSCSI Cinder volume driver for Kaminario K2 all-flash arrays."
+msgstr "New iSCSI Cinder volume driver for Kaminario K2 all-flash arrays."
+
+msgid "New path - cinder.volume.drivers.hpe.hpe_3par_fc.HPE3PARFCDriver"
+msgstr "New path - cinder.volume.drivers.hpe.hpe_3par_fc.HPE3PARFCDriver"
+
+msgid "New path - cinder.volume.drivers.hpe.hpe_3par_iscsi.HPE3PARISCSIDriver"
+msgstr "New path - cinder.volume.drivers.hpe.hpe_3par_iscsi.HPE3PARISCSIDriver"
+
+msgid ""
+"New path - cinder.volume.drivers.hpe.hpe_lefthand_iscsi."
+"HPELeftHandISCSIDriver"
+msgstr ""
+"New path - cinder.volume.drivers.hpe.hpe_lefthand_iscsi."
+"HPELeftHandISCSIDriver"
+
+msgid "New path - cinder.volume.drivers.hpe.hpe_xp_fc.HPEXPFCDriver"
+msgstr "New path - cinder.volume.drivers.hpe.hpe_xp_fc.HPEXPFCDriver"
+
+msgid "New path - cinder.volume.drivers.huawei.huawei_driver.HuaweiFCDriver"
+msgstr "New path - cinder.volume.drivers.huawei.huawei_driver.HuaweiFCDriver"
+
+msgid "New path - cinder.volume.drivers.huawei.huawei_driver.HuaweiISCSIDriver"
+msgstr ""
+"New path - cinder.volume.drivers.huawei.huawei_driver.HuaweiISCSIDriver"
+
+msgid "Newton Series Release Notes"
+msgstr "Newton Series Release Notes"
+
+msgid "Now availability zone is supported in volume type as below."
+msgstr "Now availability zone is supported in volume type as below."
+
+msgid ""
+"Now cinder will keep track of 'multiattach' attribute when managing backend "
+"volumes."
+msgstr ""
+"Now Cinder will keep track of 'multiattach' attribute when managing backend "
+"volumes."
+
+msgid ""
+"Now cinder will refresh the az cache immediately if previous create volume "
+"task failed due to az not found."
+msgstr ""
+"Now Cinder will refresh the az cache immediately if previous create volume "
+"task failed due to az not found."
+
+msgid ""
+"Now extend won't work on disabled services because it's going through the "
+"scheduler, unlike how it worked before."
+msgstr ""
+"Now extend won't work on disabled services because it's going through the "
+"scheduler, unlike how it worked before."
+
+msgid ""
+"Now scheduler plugins are aware of operation type via ``operation`` "
+"attribute in RequestSpec dictionary, plugins can support backend filtering "
+"according to backend status as well as operation type. Current possible "
+"values for ``operation`` are:"
+msgstr ""
+"Now scheduler plugins are aware of operation type via ``operation`` "
+"attribute in RequestSpec dictionary, plugins can support backend filtering "
+"according to backend status as well as operation type. Current possible "
+"values for ``operation`` are:"
+
+msgid "Now the ``os-host show`` API will count project's resource correctly."
+msgstr "Now the ``os-host show`` API will count project's resource correctly."
+
+msgid "Ocata Series Release Notes"
+msgstr "Ocata Series Release Notes"
+
+msgid ""
+"Old VNX FC (``cinder.volume.drivers.emc.emc_cli_fc.EMCCLIFCDriver``)/ iSCSI "
+"(``cinder.volume.drivers.emc.emc_cli_iscsi.EMCCLIISCSIDriver``) drivers are "
+"deprecated. Please refer to upgrade section for information about the new "
+"driver."
+msgstr ""
+"Old VNX FC (``cinder.volume.drivers.emc.emc_cli_fc.EMCCLIFCDriver``)/ iSCSI "
+"(``cinder.volume.drivers.emc.emc_cli_iscsi.EMCCLIISCSIDriver``) drivers are "
+"deprecated. Please refer to upgrade section for information about the new "
+"driver."
+
+msgid ""
+"Old driver paths have been removed since they have been through our alloted "
+"deprecation period. Make sure if you have any of these paths being set in "
+"your cinder.conf for the volume_driver option, to update to the new driver "
+"path listed here."
+msgstr ""
+"Old driver paths have been removed since they have been through our allotted "
+"deprecation period. Make sure if you have any of these paths being set in "
+"your cinder.conf for the volume_driver option, to update to the new driver "
+"path listed here."
+
+msgid ""
+"Old names and locations are still supported but support will be removed in "
+"the future."
+msgstr ""
+"Old names and locations are still supported but support will be removed in "
+"the future."
+
+msgid ""
+"Old path - cinder.volume.drivers.huawei.huawei_18000.Huawei18000FCDriver"
+msgstr ""
+"Old path - cinder.volume.drivers.huawei.huawei_18000.Huawei18000FCDriver"
+
+msgid ""
+"Old path - cinder.volume.drivers.huawei.huawei_18000.Huawei18000ISCSIDriver"
+msgstr ""
+"Old path - cinder.volume.drivers.huawei.huawei_18000.Huawei18000ISCSIDriver"
+
+msgid ""
+"Old path - cinder.volume.drivers.huawei.huawei_driver.Huawei18000FCDriver"
+msgstr ""
+"Old path - cinder.volume.drivers.huawei.huawei_driver.Huawei18000FCDriver"
+
+msgid ""
+"Old path - cinder.volume.drivers.huawei.huawei_driver.Huawei18000ISCSIDriver"
+msgstr ""
+"Old path - cinder.volume.drivers.huawei.huawei_driver.Huawei18000ISCSIDriver"
+
+msgid "Old path - cinder.volume.drivers.san.hp.hp_3par_fc.HP3PARFCDriver"
+msgstr "Old path - cinder.volume.drivers.san.hp.hp_3par_fc.HP3PARFCDriver"
+
+msgid "Old path - cinder.volume.drivers.san.hp.hp_3par_iscsi.HP3PARISCSIDriver"
+msgstr ""
+"Old path - cinder.volume.drivers.san.hp.hp_3par_iscsi.HP3PARISCSIDriver"
+
+msgid ""
+"Old path - cinder.volume.drivers.san.hp.hp_lefthand_iscsi."
+"HPLeftHandISCSIDriver"
+msgstr ""
+"Old path - cinder.volume.drivers.san.hp.hp_lefthand_iscsi."
+"HPLeftHandISCSIDriver"
+
+msgid "Old path - cinder.volume.drivers.san.hp.hp_xp_fc.HPXPFCDriver"
+msgstr "Old path - cinder.volume.drivers.san.hp.hp_xp_fc.HPXPFCDriver"
+
+msgid ""
+"On offline upgrades, due to the rolling upgrade mechanism we need to restart "
+"the cinder services twice to complete the installation just like in the "
+"rolling upgrades case.  First you stop the cinder services, then you upgrade "
+"them, you sync your DB, then you start all the cinder services, and then you "
+"restart them all.  To avoid this last restart we can now instruct the DB "
+"sync to bump the services after the migration is completed, the command to "
+"do this is `cinder-manage db sync --bump-versions`"
+msgstr ""
+"On offline upgrades, due to the rolling upgrade mechanism we need to restart "
+"the cinder services twice to complete the installation just like in the "
+"rolling upgrades case.  First you stop the cinder services, then you upgrade "
+"them, you sync your DB, then you start all the cinder services, and then you "
+"restart them all.  To avoid this last restart we can now instruct the DB "
+"sync to bump the services after the migration is completed, the command to "
+"do this is `cinder-manage db sync --bump-versions`"
+
+msgid ""
+"Operator needs to perform ``cinder-manage db online_data_migrations`` to "
+"migrate existing consistency groups to generic volume groups."
+msgstr ""
+"Operator needs to perform ``cinder-manage db online_data_migrations`` to "
+"migrate existing consistency groups to generic volume groups."
+
+msgid ""
+"Operators should change backup driver configuration value to use class name "
+"to get backup service working in a 'S' release."
+msgstr ""
+"Operators should change backup driver configuration value to use class name "
+"to get backup service working in a 'S' release."
+
+msgid "Optimize backend reporting capabilities for Huawei drivers."
+msgstr "Optimise backend reporting capabilities for Huawei drivers."
+
+msgid ""
+"Oracle ZFSSA iSCSI - allows a volume to be connected to more than one "
+"connector at the same time, which is required for live-migration to work. "
+"ZFSSA software release 2013.1.3.x (or newer) is required for this to work."
+msgstr ""
+"Oracle ZFSSA iSCSI - allows a volume to be connected to more than one "
+"connector at the same time, which is required for live-migration to work. "
+"ZFSSA software release 2013.1.3.x (or newer) is required for this to work."
+
+msgid ""
+"Oracle ZFSSA iSCSI volume driver implements ``get_manageable_volumes()``"
+msgstr ""
+"Oracle ZFSSA iSCSI volume driver implements ``get_manageable_volumes()``"
+
+msgid "Other Notes"
+msgstr "Other Notes"
+
+msgid "Pike Series Release Notes"
+msgstr "Pike Series Release Notes"
+
+msgid ""
+"PowerMax driver - Workload support was dropped in ucode 5978. If a VMAX All "
+"Flash array is upgraded to 5978 or greater and existing volume types "
+"leveraged workload e.g. DSS, DSS_REP, OLTP and OLTP_REP, certain operations "
+"will no longer work and the volume type will be unusable. This fix addresses "
+"these issues and fixes problems with using old volume types with workloads "
+"included in the volume type pool_name."
+msgstr ""
+"PowerMax driver - Workload support was dropped in ucode 5978. If a VMAX All "
+"Flash array is upgraded to 5978 or greater and existing volume types "
+"leveraged workload e.g. DSS, DSS_REP, OLTP and OLTP_REP, certain operations "
+"will no longer work and the volume type will be unusable. This fix addresses "
+"these issues and fixes problems with using old volume types with workloads "
+"included in the volume type pool_name."
+
+msgid "Prelude"
+msgstr "Prelude"
+
+msgid ""
+"Previous installations of IBM Storage must be un-installed first and the new "
+"driver should be installed on top. In addition the cinder.conf values should "
+"be updated to reflect the new paths. For example the proxy setting of "
+"``storage.proxy.IBMStorageProxy`` should be updated to ``cinder.volume."
+"drivers.ibm.ibm_storage.proxy.IBMStorageProxy``."
+msgstr ""
+"Previous installations of IBM Storage must be uninstalled first and the new "
+"driver should be installed on top. In addition the cinder.conf values should "
+"be updated to reflect the new paths. For example the proxy setting of "
+"``storage.proxy.IBMStorageProxy`` should be updated to ``cinder.volume."
+"drivers.ibm.ibm_storage.proxy.IBMStorageProxy``."
+
+msgid ""
+"Previously the only way to remove volumes in error states from a consistency-"
+"group was to delete the consistency group and create it again. Now it is "
+"possible to remove volumes in error and error_deleting states."
+msgstr ""
+"Previously the only way to remove volumes in error states from a consistency-"
+"group was to delete the consistency group and create it again. Now it is "
+"possible to remove volumes in error and error_deleting states."
+
+msgid ""
+"Privsep daemons are now started by Cinder when required. These daemons can "
+"be started via rootwrap if required. rootwrap configs therefore need to be "
+"updated to include new privsep daemon invocations."
+msgstr ""
+"Privsep daemons are now started by Cinder when required. These daemons can "
+"be started via rootwrap if required. rootwrap configs therefore need to be "
+"updated to include new privsep daemon invocations."
+
+msgid ""
+"Privsep transitions. Cinder is transitioning from using the older style "
+"rootwrap privilege escalation path to the new style Oslo privsep path. This "
+"should improve performance and security of Cinder in the long term."
+msgstr ""
+"Privsep transitions. Cinder is transitioning from using the older style "
+"rootwrap privilege escalation path to the new style Oslo privsep path. This "
+"should improve performance and security of Cinder in the long term."
+
+msgid "Prohibit the deletion of group if group snapshot exists."
+msgstr "Prohibit the deletion of group if group snapshot exists."
+
+msgid ""
+"Projects with the admin role are now allowed to operate on the quotas of all "
+"other projects."
+msgstr ""
+"Projects with the admin role are now allowed to operate on the quotas of all "
+"other projects."
+
+msgid ""
+"Pure Storage FlashArray driver has added configuration options "
+"``pure_replication_pg_name`` and ``pure_replication_pod_name`` for setting "
+"the names for replication PGs and Pods."
+msgstr ""
+"Pure Storage FlashArray driver has added configuration options "
+"``pure_replication_pg_name`` and ``pure_replication_pod_name`` for setting "
+"the names for replication PGs and Pods."
+
+msgid "Pure Storage FlashArray driver has added multiatach support."
+msgstr "Pure Storage FlashArray driver has added multiattach support."
+
+msgid ""
+"Pure Storage Volume Drivers can now utilize driver_ssl_cert_verify and "
+"driver_ssl_cert_path config options to allow for secure https requests to "
+"the FlashArray."
+msgstr ""
+"Pure Storage Volume Drivers can now utilise driver_ssl_cert_verify and "
+"driver_ssl_cert_path config options to allow for secure https requests to "
+"the FlashArray."
+
+msgid ""
+"Pure volume drivers will need 'purestorage' python module v1.6.0 or newer. "
+"Support for 1.4.x has been removed."
+msgstr ""
+"Pure volume drivers will need 'purestorage' Python module v1.6.0 or newer. "
+"Support for 1.4.x has been removed."
+
+msgid "QNAP"
+msgstr "QNAP"
+
+msgid "QNAP Cinder driver added support for QES fw 2.0.0."
+msgstr "QNAP Cinder driver added support for QES fw 2.0.0."
+
+msgid "QNAP Cinder driver added support for QES fw 2.1.0."
+msgstr "QNAP Cinder driver added support for QES fw 2.1.0."
+
+msgid "QoS support in EMC VMAX iSCSI and FC drivers."
+msgstr "QoS support in EMC VMAX iSCSI and FC drivers."
+
+msgid "Queens Series Release Notes"
+msgstr "Queens Series Release Notes"
+
+msgid ""
+"Quota validations are now forced for all APIs. skip_validation flag is now "
+"removed from the request body for the quota-set update API."
+msgstr ""
+"Quota validations are now forced for all APIs. skip_validation flag is now "
+"removed from the request body for the quota-set update API."
+
+msgid ""
+"RBD driver can have bottlenecks if too many slow operations are happening at "
+"the same time (for example many huge volume deletions), we can now use the "
+"`backend_native_threads_pool_size` option in the RBD driver section to "
+"resolve the issue."
+msgstr ""
+"RBD driver can have bottlenecks if too many slow operations are happening at "
+"the same time (for example many huge volume deletions), we can now use the "
+"`backend_native_threads_pool_size` option in the RBD driver section to "
+"resolve the issue."
+
+msgid ""
+"RBD driver supports returning a static total capacity value instead of a "
+"dynamic value like it's been doing.  Configurable with "
+"`report_dynamic_total_capacity` configuration option."
+msgstr ""
+"RBD driver supports returning a static total capacity value instead of a "
+"dynamic value like it's been doing.  Configurable with "
+"`report_dynamic_total_capacity` configuration option."
+
+msgid ""
+"RBD stats report has been fixed, now properly reports "
+"`allocated_capacity_gb` and `provisioned_capacity_gb` with the sum of the "
+"sizes of the volumes (not physical sizes) for volumes created by Cinder and "
+"all available in the pool respectively.  Free capacity will now properly "
+"handle quota size restrictions of the pool."
+msgstr ""
+"RBD stats report has been fixed, now properly reports "
+"`allocated_capacity_gb` and `provisioned_capacity_gb` with the sum of the "
+"sizes of the volumes (not physical sizes) for volumes created by Cinder and "
+"all available in the pool respectively.  Free capacity will now properly "
+"handle quota size restrictions of the pool."
+
+msgid ""
+"RBD/Ceph backends should adjust `max_over_subscription_ratio` to take into "
+"account that the driver is no longer reporting volume's physical usage but "
+"it's provisioned size."
+msgstr ""
+"RBD/Ceph backends should adjust `max_over_subscription_ratio` to take into "
+"account that the driver is no longer reporting volume's physical usage but "
+"it's provisioned size."
+
+msgid "Re-added QNAP Cinder volume driver."
+msgstr "Re-added QNAP Cinder volume driver."
+
+msgid "Reduxio"
+msgstr "Reduxio"
+
+msgid "Remove mirror policy parameter from huawei driver."
+msgstr "Remove mirror policy parameter from Huawei driver."
+
+msgid "Removed - ``eqlx_chap_login``"
+msgstr "Removed - ``eqlx_chap_login``"
+
+msgid "Removed - ``eqlx_chap_password``"
+msgstr "Removed - ``eqlx_chap_password``"
+
+msgid "Removed - ``eqlx_cli_timeout``"
+msgstr "Removed - ``eqlx_cli_timeout``"
+
+msgid "Removed - ``eqlx_use_chap``"
+msgstr "Removed - ``eqlx_use_chap``"
+
+msgid "Removed datera_acl_allow_all option."
+msgstr "Removed datera_acl_allow_all option."
+
+msgid "Removed datera_num_replicas option."
+msgstr "Removed datera_num_replicas option."
+
+msgid ""
+"Removed deprecated LVMISCSIDriver and LVMISERDriver. These should be "
+"switched to use the LVMVolumeDriver with the desired iscsi_helper "
+"configuration set to the desired iSCSI helper."
+msgstr ""
+"Removed deprecated LVMISCSIDriver and LVMISERDriver. These should be "
+"switched to use the LVMVolumeDriver with the desired iscsi_helper "
+"configuration set to the desired iSCSI helper."
+
+msgid ""
+"Removed deprecated option ``kaminario_nodedup_substring`` in Kaminario FC "
+"and iSCSI Cinder drivers."
+msgstr ""
+"Removed deprecated option ``kaminario_nodedup_substring`` in Kaminario FC "
+"and iSCSI Cinder drivers."
+
+msgid "Removed deprecated option ``osapi_max_request_body_size``."
+msgstr "Removed deprecated option ``osapi_max_request_body_size``."
+
+msgid "Removed force_delete option from ScaleIO configuration."
+msgstr "Removed force_delete option from ScaleIO configuration."
+
+msgid ""
+"Removed restriction of hard coded iSCSI IP address to allow the use of "
+"multiple iSCSI portgroups."
+msgstr ""
+"Removed restriction of hard coded iSCSI IP address to allow the use of "
+"multiple iSCSI portgroups."
+
+msgid ""
+"Removed storwize_svc_connection_protocol config setting. Users will now need "
+"to set different values for volume_driver in cinder.conf. FC:volume_driver = "
+"cinder.volume.drivers.ibm.storwize_svc.storwize_svc_fc.StorwizeSVCFCDriver "
+"iSCSI:volume_driver = cinder.volume.drivers.ibm.storwize_svc."
+"storwize_svc_iscsi.StorwizeSVCISCSIDriver"
+msgstr ""
+"Removed storwize_svc_connection_protocol config setting. Users will now need "
+"to set different values for volume_driver in cinder.conf. FC:volume_driver = "
+"cinder.volume.drivers.ibm.storwize_svc.storwize_svc_fc.StorwizeSVCFCDriver "
+"iSCSI:volume_driver = cinder.volume.drivers.ibm.storwize_svc."
+"storwize_svc_iscsi.StorwizeSVCISCSIDriver"
+
+msgid ""
+"Removed the ability to create volumes in a ScaleIO Storage Pool that has "
+"zero-padding disabled. A new configuration option "
+"``sio_allow_non_padded_volumes`` has been added to override this new "
+"behavior and allow unpadded volumes, but should not be enabled if multiple "
+"tenants will utilize volumes from a shared Storage Pool."
+msgstr ""
+"Removed the ability to create volumes in a ScaleIO Storage Pool that has "
+"zero-padding disabled. A new configuration option "
+"``sio_allow_non_padded_volumes`` has been added to override this new "
+"behaviour and allow unpadded volumes, but should not be enabled if multiple "
+"tenants will utilise volumes from a shared Storage Pool."
+
+msgid ""
+"Removed the ability to create volumes in a ScaleIO Storage Pool that has "
+"zero-padding disabled. A new configuration option had been added to override "
+"this new behavior and allow volume creation, but should not be enabled if "
+"multiple tenants will utilize volumes from a shared Storage Pool."
+msgstr ""
+"Removed the ability to create volumes in a ScaleIO Storage Pool that has "
+"zero-padding disabled. A new configuration option had been added to override "
+"this new behaviour and allow volume creation, but should not be enabled if "
+"multiple tenants will utilise volumes from a shared Storage Pool."
+
+msgid "Removed the deprecated NPIV options for the Storwize backend driver."
+msgstr "Removed the deprecated NPIV options for the Storwize backend driver."
+
+msgid ""
+"Removed the deprecated options for the Nova connection:> "
+"os_privileged_user{name, password, tenant, auth_url}, nova_catalog_info, "
+"nova_catalog_admin_info, nova_endpoint_template, "
+"nova_endpoint_admin_template, nova_ca_certificates_file, nova_api_insecure. "
+"From Pike, using the [nova] section is preferred to configure compute "
+"connection for Guest Assisted Snapshost or the InstanceLocalityFilter."
+msgstr ""
+"Removed the deprecated options for the Nova connection:> "
+"os_privileged_user{name, password, tenant, auth_url}, nova_catalog_info, "
+"nova_catalog_admin_info, nova_endpoint_template, "
+"nova_endpoint_admin_template, nova_ca_certificates_file, nova_api_insecure. "
+"From Pike, using the [nova] section is preferred to configure compute "
+"connection for Guest Assisted Snapshot or the InstanceLocalityFilter."
+
+msgid ""
+"Removed the need for deployers to run tox for config reference generation."
+msgstr ""
+"Removed the need for deployers to run tox for config reference generation."
+
+msgid ""
+"Removed the option ``allow_inuse_volume_type_modification`` which had been "
+"deprecated in Ocata release."
+msgstr ""
+"Removed the option ``allow_inuse_volume_type_modification`` which had been "
+"deprecated in Ocata release."
+
+msgid ""
+"Removing cinder-all binary. Instead use the individual binaries like cinder-"
+"api, cinder-backup, cinder-volume, cinder-scheduler."
+msgstr ""
+"Removing cinder-all binary. Instead use the individual binaries like cinder-"
+"api, cinder-backup, cinder-volume, cinder-scheduler."
+
+msgid ""
+"Removing deprecated file cinder.middleware.sizelimit. In your api-paste.ini, "
+"replace cinder.middleware.sizelimit:RequestBodySizeLimiter.factory with "
+"oslo_middleware.sizelimit:RequestBodySizeLimiter.factory"
+msgstr ""
+"Removing deprecated file cinder.middleware.sizelimit. In your api-paste.ini, "
+"replace cinder.middleware.sizelimit:RequestBodySizeLimiter.factory with "
+"oslo_middleware.sizelimit:RequestBodySizeLimiter.factory"
+
+msgid ""
+"Removing the Dell EqualLogic driver's deprecated configuration options. "
+"Please replace old options in your cinder.conf with the new one."
+msgstr ""
+"Removing the Dell EqualLogic driver's deprecated configuration options. "
+"Please replace old options in your cinder.conf with the new one."
+
+msgid ""
+"Rename Huawei18000ISCSIDriver and Huawei18000FCDriver to HuaweiISCSIDriver "
+"and HuaweiFCDriver."
+msgstr ""
+"Rename Huawei18000ISCSIDriver and Huawei18000FCDriver to HuaweiISCSIDriver "
+"and HuaweiFCDriver."
+
+msgid "Replaced with - ``chap_password``"
+msgstr "Replaced with - ``chap_password``"
+
+msgid "Replaced with - ``chap_username``"
+msgstr "Replaced with - ``chap_username``"
+
+msgid "Replaced with - ``ssh_conn_timeout``"
+msgstr "Replaced with - ``ssh_conn_timeout``"
+
+msgid "Replaced with - ``use_chap_auth``"
+msgstr "Replaced with - ``use_chap_auth``"
+
+msgid "Report pools in volume stats for Block Device Driver."
+msgstr "Report pools in volume stats for Block Device Driver."
+
+msgid ""
+"Resolve issue with cross AZ migrations and retypes where the destination "
+"volume kept the source volume's AZ, so we ended up with a volume where the "
+"AZ does not match the backend. (bug 1747949)"
+msgstr ""
+"Resolve issue with cross AZ migrations and retypes where the destination "
+"volume kept the source volume's AZ, so we ended up with a volume where the "
+"AZ does not match the backend. (bug 1747949)"
+
+msgid "Retype support added to CloudByte iSCSI driver."
+msgstr "Retype support added to CloudByte iSCSI driver."
+
+msgid "Rocky Series Release Notes"
+msgstr "Rocky Series Release Notes"
+
+msgid ""
+"ScaleIO volumes need to be sized in increments of 8G. Handling added to "
+"volume extend operations to ensure the new size is rounded up to the nearest "
+"size when needed."
+msgstr ""
+"ScaleIO volumes need to be sized in increments of 8G. Handling added to "
+"volume extend operations to ensure the new size is rounded up to the nearest "
+"size when needed."
+
+msgid "Security Issues"
+msgstr "Security Issues"
+
+msgid "Separate create and update rules for volume metadata."
+msgstr "Separate create and update rules for volume metadata."
+
+msgid "Show CG Snapshot checks both tables."
+msgstr "Show CG Snapshot checks both tables."
+
+msgid "Show CG checks both tables."
+msgstr "Show CG checks both tables."
+
+msgid ""
+"Some of DISCO driver options were incorrectly read from ``[DEFAULT]`` "
+"section in the cinder.conf. Now those are correctly read from "
+"``[<backend_id>]`` section. This includes following options:"
+msgstr ""
+"Some of DISCO driver options were incorrectly read from ``[DEFAULT]`` "
+"section in the cinder.conf. Now those are correctly read from "
+"``[<backend_id>]`` section. This includes following options:"
+
+msgid "Some points to keep in mind:"
+msgstr "Some points to keep in mind:"
+
+msgid ""
+"Split nested quota support into a separate driver. In order to use nested "
+"quotas, change the following config ``quota_driver = cinder.quota."
+"NestedDbQuotaDriver`` after running the following admin API \"os-quota-sets/"
+"validate_setup_for_nested_quota_use\" command to ensure the existing quota "
+"values make sense to nest."
+msgstr ""
+"Split nested quota support into a separate driver. In order to use nested "
+"quotas, change the following config ``quota_driver = cinder.quota."
+"NestedDbQuotaDriver`` after running the following admin API \"os-quota-sets/"
+"validate_setup_for_nested_quota_use\" command to ensure the existing quota "
+"values make sense to nest."
+
+msgid "Start using reno to manage release notes."
+msgstr "Start using Reno to manage release notes."
+
+msgid ""
+"Starting from Mitaka release Cinder is having a tech preview of rolling "
+"upgrades support."
+msgstr ""
+"Starting from Mitaka release Cinder is having a tech preview of rolling "
+"upgrades support."
+
+msgid ""
+"Starting with API microversion 3.47, Cinder now supports the ability to "
+"create a volume directly from a backup. For instance, you can use the "
+"command: ``cinder create <size> --backup-id <backup_id>`` in cinderclient."
+msgstr ""
+"Starting with API microversion 3.47, Cinder now supports the ability to "
+"create a volume directly from a backup. For instance, you can use the "
+"command: ``cinder create <size> --backup-id <backup_id>`` in cinderclient."
+
+msgid "Stein Series Release Notes"
+msgstr "Stein Series Release Notes"
+
+msgid ""
+"Storage assisted volume migration from one Pool/SLO/Workload combination to "
+"another, on the same array, via retype, for the VMAX driver. Both All Flash "
+"and Hybrid VMAX3 arrays are supported. VMAX2 is not supported."
+msgstr ""
+"Storage assisted volume migration from one Pool/SLO/Workload combination to "
+"another, on the same array, via retype, for the VMAX driver. Both All Flash "
+"and Hybrid VMAX3 arrays are supported. VMAX2 is not supported."
+
+msgid ""
+"Storwize SVC Driver: Fixes `bug 1749687 <https://bugs.launchpad.net/cinder/"
+"+bug/1749687>`__ previously lsvdisk() was called separately for every 'in-"
+"use' volume in order to check if the volume exists on the storage. In order "
+"to avoid problem of too long driver initialization now lsvdisk() is called "
+"once per pool."
+msgstr ""
+"Storwize SVC Driver: Fixes `bug 1749687 <https://bugs.launchpad.net/cinder/"
+"+bug/1749687>`__ previously lsvdisk() was called separately for every 'in-"
+"use' volume in order to check if the volume exists on the storage. In order "
+"to avoid problem of too long driver initialisation now lsvdisk() is called "
+"once per pool."
+
+msgid "Support Force backup of in-use cinder volumes for Nimble Storage."
+msgstr "Support Force backup of in-use cinder volumes for Nimble Storage."
+
+msgid ""
+"Support backup restore cancelation by changing the backup status to anything "
+"other than `restoring` using `cinder backup-reset-state`."
+msgstr ""
+"Support backup restore cancellation by changing the backup status to "
+"anything other than `restoring` using `cinder backup-reset-state`."
+
+msgid "Support balanced FC port selection for Huawei drivers."
+msgstr "Support balanced FC port selection for Huawei drivers."
+
+msgid ""
+"Support cinder_img_volume_type property in glance image metadata to specify "
+"volume type."
+msgstr ""
+"Support cinder_img_volume_type property in glance image metadata to specify "
+"volume type."
+
+msgid "Support for Consistency Groups in the NetApp E-Series Volume Driver."
+msgstr "Support for Consistency Groups in the NetApp E-Series Volume Driver."
+
+msgid "Support for Dot Hill AssuredSAN arrays has been removed."
+msgstr "Support for Dot Hill AssuredSAN arrays has been removed."
+
+msgid ""
+"Support for NetApp E-Series has been removed. The NetApp Unified driver can "
+"now only be used with NetApp Clustered Data ONTAP."
+msgstr ""
+"Support for NetApp E-Series has been removed. The NetApp Unified driver can "
+"now only be used with NetApp Clustered Data ONTAP."
+
+msgid ""
+"Support for NetApp ONTAP 7 (previously known as \"Data ONTAP operating in "
+"7mode\") has been removed. The NetApp Unified driver can now only be used "
+"with NetApp Clustered Data ONTAP and NetApp E-Series storage systems. This "
+"removal affects all three storage protocols that were supported on for ONTAP "
+"7 - iSCSI, NFS and FC. Deployers are advised to consult the `migration "
+"support <https://mysupport.netapp.com/info/web/ECMP1658253 .html>`_ provided "
+"to transition from ONTAP 7 to Clustered Data ONTAP operating system."
+msgstr ""
+"Support for NetApp ONTAP 7 (previously known as \"Data ONTAP operating in "
+"7mode\") has been removed. The NetApp Unified driver can now only be used "
+"with NetApp Clustered Data ONTAP and NetApp E-Series storage systems. This "
+"removal affects all three storage protocols that were supported on for ONTAP "
+"7 - iSCSI, NFS and FC. Deployers are advised to consult the `migration "
+"support <https://mysupport.netapp.com/info/web/ECMP1658253 .html>`_ provided "
+"to transition from ONTAP 7 to Clustered Data ONTAP operating system."
+
+msgid ""
+"Support for ScaleIO 1.32 is now deprecated and will be removed in a future "
+"release."
+msgstr ""
+"Support for ScaleIO 1.32 is now deprecated and will be removed in a future "
+"release."
+
+msgid "Support for VMAX SRDF/Metro on VMAX cinder driver."
+msgstr "Support for VMAX SRDF/Metro on VMAX cinder driver."
+
+msgid "Support for compression on VMAX All Flash in the VMAX driver."
+msgstr "Support for compression on VMAX All Flash in the VMAX driver."
+
+msgid ""
+"Support for configuring Fibre Channel zoning on Brocade switches through "
+"Cinder Fibre Channel Zone Manager and Brocade Fibre Channel zone plugin. To "
+"zone in a Virtual Fabric, set the configuration option "
+"'fc_virtual_fabric_id' for the fabric."
+msgstr ""
+"Support for configuring Fibre Channel zoning on Brocade switches through "
+"Cinder Fibre Channel Zone Manager and Brocade Fibre Channel zone plugin. To "
+"zone in a Virtual Fabric, set the configuration option "
+"'fc_virtual_fabric_id' for the fabric."
+
+msgid ""
+"Support for creating a consistency group from consistency group in XtremIO."
+msgstr ""
+"Support for creating a consistency group from consistency group in XtremIO."
+
+msgid "Support for force backup of in-use Cinder volumes in Nimble driver."
+msgstr "Support for force backup of in-use Cinder volumes in Nimble driver."
+
+msgid "Support for iSCSI in INFINIDAT InfiniBox driver."
+msgstr "Support for iSCSI in INFINIDAT InfiniBox driver."
+
+msgid "Support for iSCSI multipath in Huawei driver."
+msgstr "Support for iSCSI multipath in Huawei driver."
+
+msgid "Support for iSCSI multipathing in EMC VMAX driver."
+msgstr "Support for iSCSI multipathing in EMC VMAX driver."
+
+msgid "Support for manage/ unmanage snapshots on VMAX cinder driver."
+msgstr "Support for manage/unmanage snapshots on VMAX cinder driver."
+
+msgid ""
+"Support for retype (storage-assisted migration) of replicated volumes on "
+"VMAX cinder driver."
+msgstr ""
+"Support for retype (storage-assisted migration) of replicated volumes on "
+"VMAX Cinder driver."
+
+msgid "Support for retype and volume migration for HPE Nimble Storage driver."
+msgstr "Support for retype and volume migration for HPE Nimble Storage driver."
+
+msgid ""
+"Support for retype volumes with different encryptions including changes from "
+"unencrypted types to encrypted types and vice-versa."
+msgstr ""
+"Support for retype volumes with different encryptions including changes from "
+"unencrypted types to encrypted types and vice-versa."
+
+msgid ""
+"Support for reverting a volume to a previous snapshot in VMAX cinder driver."
+msgstr ""
+"Support for reverting a volume to a previous snapshot in VMAX cinder driver."
+
+msgid "Support for snapshot backup using the optimal path in Huawei driver."
+msgstr "Support for snapshot backup using the optimal path in Huawei driver."
+
+msgid ""
+"Support for snapshots named in the backend as ``snapshot-<snapshot-id>`` is "
+"deprecated. Snapshots are now named in the backend as ``<volume-name>."
+"<snapshot-id>``."
+msgstr ""
+"Support for snapshots named in the backend as ``snapshot-<snapshot-id>`` is "
+"deprecated. Snapshots are now named in the backend as ``<volume-name>."
+"<snapshot-id>``."
+
+msgid ""
+"Support for use of 'fc_southbound_protocol' configuration setting in the "
+"Brocade FC SAN lookup service."
+msgstr ""
+"Support for use of 'fc_southbound_protocol' configuration setting in the "
+"Brocade FC SAN lookup service."
+
+msgid "Support for volume multi-attach in the INFINIDAT InfiniBox driver."
+msgstr "Support for volume multi-attach in the INFINIDAT InfiniBox driver."
+
+msgid "Support iSCSI configuration in replication in Huawei driver."
+msgstr "Support iSCSI configuration in replication in Huawei driver."
+
+msgid ""
+"Support manage/unmanage volume and manage/unmanage snapshot functions for "
+"the NEC volume driver."
+msgstr ""
+"Support managed/unmanaged volume and managed/unmanaged snapshot functions "
+"for the NEC volume driver."
+
+msgid "Support to sort snapshots with \"name\"."
+msgstr "Support to sort snapshots with \"name\"."
+
+msgid ""
+"Support transfer volume with snapshots by default in new V3 API 'v3/"
+"volume_transfers'. After microverison 3.55, if users don't want to transfer "
+"snapshots, they could use the new optional argument `no_snapshots=True` in "
+"request body of new transfer creation API."
+msgstr ""
+"Support transfer volume with snapshots by default in new V3 API 'v3/"
+"volume_transfers'. After microverison 3.55, if users don't want to transfer "
+"snapshots, they could use the new optional argument `no_snapshots=True` in "
+"request body of new transfer creation API."
+
+msgid "Supported ``project_id`` admin filters to limits API."
+msgstr "Supported ``project_id`` admin filters to limits API."
+
+msgid "Tegile"
+msgstr "Tegile"
+
+msgid "The \"backing-up\" status is added to snapshot's status matrix."
+msgstr "The \"backing-up\" status is added to snapshot's status matrix."
+
+msgid ""
+"The \"cinder-manage logs\" commands have been removed.  Information "
+"previously gathered by these commands may be found in cinder service and "
+"syslog logs."
+msgstr ""
+"The \"cinder-manage logs\" commands have been removed.  Information "
+"previously gathered by these commands may be found in cinder service and "
+"syslog logs."
+
+msgid ""
+"The 'backup_service_inithost_offload' configuration option now defaults to "
+"'True' instead of 'False'."
+msgstr ""
+"The 'backup_service_inithost_offload' configuration option now defaults to "
+"'True' instead of 'False'."
+
+msgid ""
+"The 'smbfs_allocation_info_file_path' SMBFS driver config option is now "
+"deprecated as we're no longer using a JSON file to store volume allocation "
+"data. This file had a considerable chance of getting corrupted."
+msgstr ""
+"The 'smbfs_allocation_info_file_path' SMBFS driver config option is now "
+"deprecated as we're no longer using a JSON file to store volume allocation "
+"data. This file had a considerable chance of getting corrupted."
+
+msgid ""
+"The 7-Mode Data ONTAP configuration of the NetApp Unified driver is "
+"deprecated as of the Ocata release and will be removed in the Queens "
+"release. Other configurations of the NetApp Unified driver, including "
+"Clustered Data ONTAP and E-series, are unaffected."
+msgstr ""
+"The 7-Mode Data ONTAP configuration of the NetApp Unified driver is "
+"deprecated as of the Ocata release and will be removed in the Queens "
+"release. Other configurations of the NetApp Unified driver, including "
+"Clustered Data ONTAP and E-series, are unaffected."
+
+msgid ""
+"The Blockbridge driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it."
+msgstr ""
+"The Blockbridge driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it."
+
+msgid ""
+"The Blockbridge driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it. If its support status does not change it will be "
+"removed in the next release."
+msgstr ""
+"The Blockbridge driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it. If its support status does not change it will be "
+"removed in the next release."
+
+msgid ""
+"The Castellan library used for encryption has deprecated the ``api_class`` "
+"config option. Configuration files using this should now be updated to use "
+"the ``backend`` option instead."
+msgstr ""
+"The Castellan library used for encryption has deprecated the ``api_class`` "
+"config option. Configuration files using this should now be updated to use "
+"the ``backend`` option instead."
+
+msgid ""
+"The Cinder API v1 was deprecated in the Juno release and defaulted to be "
+"disabled in the Ocata release. It is now removed completely. If upgrading "
+"from a previous version, it is recommended you edit your `/etc/cinder/api-"
+"paste.ini` file to remove all references to v1."
+msgstr ""
+"The Cinder API v1 was deprecated in the Juno release and defaulted to be "
+"disabled in the Ocata release. It is now removed completely. If upgrading "
+"from a previous version, it is recommended you edit your `/etc/cinder/api-"
+"paste.ini` file to remove all references to v1."
+
+msgid ""
+"The Cinder Linux SMBFS driver is now deprecated and will be removed during "
+"the following release. Deployers are encouraged to use the Windows SMBFS "
+"driver instead."
+msgstr ""
+"The Cinder Linux SMBFS driver is now deprecated and will be removed during "
+"the following release. Deployers are encouraged to use the Windows SMBFS "
+"driver instead."
+
+msgid ""
+"The Cinder Volume Backup service can now be run on Windows. It supports "
+"backing up volumes exposed by SMBFS/iSCSI Windows Cinder Volume backends, as "
+"well as any other Cinder backend that's accessible on Windows (e.g. SANs "
+"exposing volumes via iSCSI/FC)."
+msgstr ""
+"The Cinder Volume Backup service can now be run on Windows. It supports "
+"backing up volumes exposed by SMBFS/iSCSI Windows Cinder Volume backends, as "
+"well as any other Cinder backend that's accessible on Windows (e.g. SANs "
+"exposing volumes via iSCSI/FC)."
+
+msgid ""
+"The Cinder database can now only be ugpraded from changes since the Newton "
+"release. In order to upgrade from a version prior to that, you must now "
+"upgrade to at least Newton first, then to Queens or later."
+msgstr ""
+"The Cinder database can now only be upgraded from changes since the Newton "
+"release. In order to upgrade from a version prior to that, you must now "
+"upgrade to at least Newton first, then to Queens or later."
+
+msgid ""
+"The Cinder database can now only be upgraded from changes since the Kilo "
+"release. In order to upgrade from a version prior to that, you must now "
+"upgrade to at least Kilo first, then to Newton or later."
+msgstr ""
+"The Cinder database can now only be upgraded from changes since the Kilo "
+"release. In order to upgrade from a version prior to that, you must now "
+"upgrade to at least Kilo first, then to Newton or later."
+
+msgid ""
+"The Cinder database can now only be upgraded from changes since the Liberty "
+"release. In order to upgrade from a version prior to that, you must now "
+"upgrade to at least Liberty first, then to Ocata or later."
+msgstr ""
+"The Cinder database can now only be upgraded from changes since the Liberty "
+"release. In order to upgrade from a version prior to that, you must now "
+"upgrade to at least Liberty first, then to Ocata or later."
+
+msgid ""
+"The Cinder database can now only be upgraded from changes since the Mitaka "
+"release. In order to upgrade from a version prior to that, you must now "
+"upgrade to at least Mitaka first, then to Pike or later."
+msgstr ""
+"The Cinder database can now only be upgraded from changes since the Mitaka "
+"release. In order to upgrade from a version prior to that, you must now "
+"upgrade to at least Mitaka first, then to Pike or later."
+
+msgid ""
+"The Cinder v2 API has now been marked as deprecated. All new client code "
+"should use the v3 API. API v3 adds support for microversioned API calls. If "
+"no microversion is requested, the base 3.0 version for the v3 API is "
+"identical to v2."
+msgstr ""
+"The Cinder v2 API has now been marked as deprecated. All new client code "
+"should use the v3 API. API v3 adds support for microversioned API calls. If "
+"no microversion is requested, the base 3.0 version for the v3 API is "
+"identical to v2."
+
+msgid ""
+"The Cisco Fibre Channel Zone Manager driver has been marked as unsupported "
+"and is now deprecated. ``enable_unsupported_driver`` will need to be set to "
+"``True`` in the driver's section in cinder.conf to continue to use it."
+msgstr ""
+"The Cisco Fibre Channel Zone Manager driver has been marked as unsupported "
+"and is now deprecated. ``enable_unsupported_driver`` will need to be set to "
+"``True`` in the driver's section in cinder.conf to continue to use it."
+
+msgid ""
+"The Cisco Firbre Channel Zone Manager driver has been marked as unsupported "
+"and is now deprecated. ``enable_unsupported_driver`` will need to be set to "
+"``True`` in the driver's section in cinder.conf to continue to use it. If "
+"its support status does not change, they will be removed in the Queens "
+"development cycle."
+msgstr ""
+"The Cisco Fibre Channel Zone Manager driver has been marked as unsupported "
+"and is now deprecated. ``enable_unsupported_driver`` will need to be set to "
+"``True`` in the driver's section in cinder.conf to continue to use it. If "
+"its support status does not change, they will be removed in the Queens "
+"development cycle."
+
+msgid ""
+"The CloudByte driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it."
+msgstr ""
+"The CloudByte driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it."
+
+msgid ""
+"The CloudByte driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it. If its support status does not change it will be "
+"removed in the next release."
+msgstr ""
+"The CloudByte driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it. If its support status does not change it will be "
+"removed in the next release."
+
+msgid ""
+"The Coho driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it."
+msgstr ""
+"The Coho driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it."
+
+msgid ""
+"The Coho driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it. If its support status "
+"does not change, they will be removed in the Queens development cycle."
+msgstr ""
+"The Coho driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it. If its support status "
+"does not change, they will be removed in the Queens development cycle."
+
+msgid ""
+"The Consistency Group APIs have now been marked as deprecated and will be "
+"removed in a future release. Generic Volume Group APIs should be used "
+"instead."
+msgstr ""
+"The Consistency Group APIs have now been marked as deprecated and will be "
+"removed in a future release. Generic Volume Group APIs should be used "
+"instead."
+
+msgid ""
+"The DataCore drivers have been marked as unsupported and are now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it."
+msgstr ""
+"The DataCore drivers have been marked as unsupported and are now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it."
+
+msgid ""
+"The DataCore drivers have been marked as unsupported and are now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it. If its support status "
+"does not change, they will be removed in the Stein development cycle."
+msgstr ""
+"The DataCore drivers have been marked as unsupported and are now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it. If its support status "
+"does not change, they will be removed in the Stein development cycle."
+
+msgid ""
+"The Dell EMC CoprHD drivers have been marked as unsupported and are now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use it."
+msgstr ""
+"The Dell EMC CoprHD drivers have been marked as unsupported and are now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use it."
+
+msgid ""
+"The Dell EMC CoprHD drivers have been marked as unsupported and are now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use it. If its support "
+"status does not change, they will be removed in the Stein development cycle."
+msgstr ""
+"The Dell EMC CoprHD drivers have been marked as unsupported and are now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use it. If its support "
+"status does not change, they will be removed in the Stein development cycle."
+
+msgid ""
+"The Dell EMC PS Series volume driver which supports Dell PS Series "
+"(EqualLogic) Storage is moving to maintenance mode in S Release and will be "
+"removed in T Release."
+msgstr ""
+"The Dell EMC PS Series volume driver which supports Dell PS Series "
+"(EqualLogic) Storage is moving to maintenance mode in S Release and will be "
+"removed in T Release."
+
+msgid ""
+"The Dell EMC SC configuration option ``excluded_domain_ip`` has been "
+"deprecated and will be removed in a future release. Deployments should now "
+"migrate to the option ``excluded_domain_ips`` for equivalent functionality."
+msgstr ""
+"The Dell EMC SC configuration option ``excluded_domain_ip`` has been "
+"deprecated and will be removed in a future release. Deployments should now "
+"migrate to the option ``excluded_domain_ips`` for equivalent functionality."
+
+msgid ""
+"The Disco driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it."
+msgstr ""
+"The Disco driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it."
+
+msgid ""
+"The Disco driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it. If its support status "
+"does not change, it will be removed in the Stein development cycle."
+msgstr ""
+"The Disco driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it. If its support status "
+"does not change, it will be removed in the Stein development cycle."
+
+msgid ""
+"The DotHill drivers has been marked as unsupported and are now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it. If its support status does not change it will be "
+"removed in the next release."
+msgstr ""
+"The DotHill drivers has been marked as unsupported and are now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it. If its support status does not change it will be "
+"removed in the next release."
+
+msgid ""
+"The DotHill drivers have been marked as unsupported and are now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it."
+msgstr ""
+"The DotHill drivers have been marked as unsupported and are now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it."
+
+msgid ""
+"The EqualLogic driver is moved to the dell_emc directory and has been "
+"rebranded to its current Dell EMC PS Series name. The volume_driver entry in "
+"cinder.conf needs to be changed to ``cinder.volume.drivers.dell_emc.ps."
+"PSSeriesISCSIDriver``."
+msgstr ""
+"The EqualLogic driver is moved to the dell_emc directory and has been "
+"rebranded to its current Dell EMC PS Series name. The volume_driver entry in "
+"cinder.conf needs to be changed to ``cinder.volume.drivers.dell_emc.ps."
+"PSSeriesISCSIDriver``."
+
+msgid ""
+"The Falconstor drivers have been marked as unsupported and are now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use it."
+msgstr ""
+"The Falconstor drivers have been marked as unsupported and are now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use it."
+
+msgid ""
+"The Falconstor drivers have been marked as unsupported and are now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use it. If its support "
+"status does not change, they will be removed in the Queens development cycle."
+msgstr ""
+"The Falconstor drivers have been marked as unsupported and are now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use it. If its support "
+"status does not change, they will be removed in the Queens development cycle."
+
+msgid ""
+"The Glance v1 API has been deprecated and will soon be removed. Cinder "
+"support for using the v1 API was deprecated in the Pike release and is now "
+"no longer available. The ``glance_api_version`` configuration option to "
+"support version selection has now been removed."
+msgstr ""
+"The Glance v1 API has been deprecated and will soon be removed. Cinder "
+"support for using the v1 API was deprecated in the Pike release and is now "
+"no longer available. The ``glance_api_version`` configuration option to "
+"support version selection has now been removed."
+
+msgid ""
+"The GlusterFS volume driver, which was deprecated in the Newton release, has "
+"been removed."
+msgstr ""
+"The GlusterFS volume driver, which was deprecated in the Newton release, has "
+"been removed."
+
+msgid ""
+"The HBSD (Hitachi Block Storage Driver) volume drivers which supports "
+"Hitachi Storages HUS100 and VSP family are deprecated. Support for HUS110 "
+"family will be no longer provided. Support on VSP will be provided as "
+"hitachi.vsp_* drivers."
+msgstr ""
+"The HBSD (Hitachi Block Storage Driver) volume drivers which supports "
+"Hitachi Storages HUS100 and VSP family are deprecated. Support for HUS110 "
+"family will be no longer provided. Support on VSP will be provided as "
+"hitachi.vsp_* drivers."
+
+msgid ""
+"The HGST Flash Storage Suite Driver was marked unsupported in the Rocky "
+"release because their 3rd Party CI system was not meeting Cinder's "
+"requirements.  The system has not started reporting so the driver is now "
+"removed as of the Stein release."
+msgstr ""
+"The HGST Flash Storage Suite Driver was marked unsupported in the Rocky "
+"release because their 3rd Party CI system was not meeting Cinder's "
+"requirements.  The system has not started reporting so the driver is now "
+"removed as of the Stein release."
+
+msgid ""
+"The HGST Flash Suite storage driver has been removed after completion of its "
+"deprecation period without a reliable 3rd Party CI system being supported.  "
+"Customers using the HGST Flash Suite driver should not upgrade Cinder "
+"without first migrating all volumes from their HGST backend to a supported "
+"storage backend.  Failure to migrate volumes will result in no longer being "
+"able to access volumes backed by the HGST storage backend."
+msgstr ""
+"The HGST Flash Suite storage driver has been removed after completion of its "
+"deprecation period without a reliable 3rd Party CI system being supported.  "
+"Customers using the HGST Flash Suite driver should not upgrade Cinder "
+"without first migrating all volumes from their HGST backend to a supported "
+"storage backend.  Failure to migrate volumes will result in no longer being "
+"able to access volumes backed by the HGST storage backend."
+
+msgid ""
+"The HGST driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it."
+msgstr ""
+"The HGST driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it."
+
+msgid ""
+"The HGST driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it. If its support status "
+"does not change, it will be removed in the Stein development cycle."
+msgstr ""
+"The HGST driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it. If its support status "
+"does not change, it will be removed in the Stein development cycle."
+
+msgid ""
+"The HPE XP driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it."
+msgstr ""
+"The HPE XP driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it."
+
+msgid ""
+"The HPE XP driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it. If its support status does not change it will be "
+"removed in the next release."
+msgstr ""
+"The HPE XP driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it. If its support status does not change it will be "
+"removed in the next release."
+
+msgid ""
+"The Hitachi Block Storage Driver (HBSD) and VSP driver have been marked as "
+"unsupported and are now deprecated. enable_unsupported_driver will need to "
+"be set to True in cinder.conf to continue to use them."
+msgstr ""
+"The Hitachi Block Storage Driver (HBSD) and VSP driver have been marked as "
+"unsupported and are now deprecated. enable_unsupported_driver will need to "
+"be set to True in cinder.conf to continue to use them."
+
+msgid ""
+"The Hitachi HNAS, HBSD, and VSP volume drivers were marked as deprecated in "
+"the Pike release and have now been removed. Hitachi storage drivers are now "
+"only available directly from Hitachi."
+msgstr ""
+"The Hitachi HNAS, HBSD, and VSP volume drivers were marked as deprecated in "
+"the Pike release and have now been removed. Hitachi storage drivers are now "
+"only available directly from Hitachi."
+
+msgid ""
+"The Hitachi NAS NFS driver has been marked as unsupported and is now "
+"deprecated. enable_unsupported_driver will need to be set to True in cinder."
+"conf to continue to use it."
+msgstr ""
+"The Hitachi NAS NFS driver has been marked as unsupported and is now "
+"deprecated. enable_unsupported_driver will need to be set to True in cinder."
+"conf to continue to use it."
+
+msgid ""
+"The Hitachi NAS Platform iSCSI driver was marked as not supported in the "
+"Ocata realease and has now been removed."
+msgstr ""
+"The Hitachi NAS Platform iSCSI driver was marked as not supported in the "
+"Ocata release and has now been removed."
+
+msgid ""
+"The Hitachi NAS iSCSI driver has been marked as unsupported and is now "
+"deprecated. ``enable_unsupported_drivers`` will need to be set to ``True`` "
+"in cinder.conf to continue to use it."
+msgstr ""
+"The Hitachi NAS iSCSI driver has been marked as unsupported and is now "
+"deprecated. ``enable_unsupported_drivers`` will need to be set to ``True`` "
+"in cinder.conf to continue to use it."
+
+msgid ""
+"The Hitachi NAS iSCSI driver has been marked as unsupported and is now "
+"deprecated. ``enable_unsupported_drivers`` will need to be set to ``True`` "
+"in cinder.conf to continue to use it. The driver will be removed in the next "
+"release."
+msgstr ""
+"The Hitachi NAS iSCSI driver has been marked as unsupported and is now "
+"deprecated. ``enable_unsupported_drivers`` will need to be set to ``True`` "
+"in cinder.conf to continue to use it. The driver will be removed in the next "
+"release."
+
+msgid ""
+"The IBM FlashSystem configuration options ``flashsystem_multipath_enabled`` "
+"was deprecated in the Mitaka release. It had no effect, so it can be safely "
+"removed and does not have a new equivalent config option."
+msgstr ""
+"The IBM FlashSystem configuration options ``flashsystem_multipath_enabled`` "
+"was deprecated in the Mitaka release. It had no effect, so it can be safely "
+"removed and does not have a new equivalent config option."
+
+msgid ""
+"The IBM_Storage driver has been open sourced. This means that there is no "
+"more need to download the package from the IBM site. The only requirement "
+"remaining is to install pyxcli, which is available through pypi::"
+msgstr ""
+"The IBM_Storage driver has been open sourced. This means that there is no "
+"more need to download the package from the IBM site. The only requirement "
+"remaining is to install pyxcli, which is available through pypi::"
+
+msgid ""
+"The ISERTgtAdm target was deprecated in the Kilo release. It has now been "
+"removed. You should now just use LVMVolumeDriver and specify iscsi_helper "
+"for the target driver you wish to use. In order to enable iser, please set "
+"iscsi_protocol=iser with lioadm or tgtadm target helpers."
+msgstr ""
+"The ISERTgtAdm target was deprecated in the Kilo release. It has now been "
+"removed. You should now just use LVMVolumeDriver and specify iscsi_helper "
+"for the target driver you wish to use. In order to enable iser, please set "
+"iscsi_protocol=iser with lioadm or tgtadm target helpers."
+
+msgid ""
+"The ITRI DISCO storage driver has been removed after completion of its "
+"deprecation period without a reliable 3rd Party CI system being supported.  "
+"Customers using the ITRI DISCO driver should not upgrade Cinder without "
+"first migrating all volumes from their DISCO backend to a supported storage "
+"backend.  Failure to migrate volumes will result in no longer being able to "
+"access volumes back by the ITRI DISCO storage backend."
+msgstr ""
+"The ITRI DISCO storage driver has been removed after completion of its "
+"deprecation period without a reliable 3rd Party CI system being supported.  "
+"Customers using the ITRI DISCO driver should not upgrade Cinder without "
+"first migrating all volumes from their DISCO backend to a supported storage "
+"backend.  Failure to migrate volumes will result in no longer being able to "
+"access volumes back by the ITRI DISCO storage backend."
+
+msgid ""
+"The ITRI DISCO storage driver was marked unsupported  in Rocky due to 3rd "
+"Party CI not meeting Cinder's requirements.  As a result the driver is "
+"removed starting from the Stein release."
+msgstr ""
+"The ITRI DISCO storage driver was marked unsupported  in Rocky due to 3rd "
+"Party CI not meeting Cinder's requirements.  As a result the driver is "
+"removed starting from the Stein release."
+
+msgid ""
+"The Infortrend drivers have been marked as unsupported and are now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use them."
+msgstr ""
+"The Infortrend drivers have been marked as unsupported and are now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use them."
+
+msgid ""
+"The Infortrend drivers have been marked as unsupported and are now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use them. If their "
+"support status does not change, they will be removed in the Queens "
+"development cycle."
+msgstr ""
+"The Infortrend drivers have been marked as unsupported and are now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use them. If their "
+"support status does not change, they will be removed in the Queens "
+"development cycle."
+
+msgid ""
+"The LINBIT DRBDManage volume driver is moving to maintenance mode in Stein "
+"Release and will be removed in T Release."
+msgstr ""
+"The LINBIT DRBDManage volume driver is moving to maintenance mode in Stein "
+"Release and will be removed in T Release."
+
+msgid ""
+"The LVM driver specific `lvm_max_over_subscription_ratio` setting had been "
+"deprecated and is now removed. Over subscription should now be managed using "
+"the generic `max_over_subscription_ratio` setting."
+msgstr ""
+"The LVM driver specific `lvm_max_over_subscription_ratio` setting had been "
+"deprecated and is now removed. Over subscription should now be managed using "
+"the generic `max_over_subscription_ratio` setting."
+
+msgid ""
+"The NetApp E-Series drivers are deprecated as of the Rocky release and will "
+"be removed in the Stein release. Other configurations of the NetApp driver, "
+"i.e Clustered Data ONTAP and Solidfire, are unaffected."
+msgstr ""
+"The NetApp E-Series drivers are deprecated as of the Rocky release and will "
+"be removed in the Stein release. Other configurations of the NetApp driver, "
+"i.e Clustered Data ONTAP and Solidfire, are unaffected."
+
+msgid ""
+"The NetApp E-series driver has been fixed to correctly report the "
+"\"provisioned_capacity_gb\". Now it sums the capacity of all the volumes in "
+"the configured backend to get the correct value. This bug fix affects all "
+"the protocols supported by the driver (FC and iSCSI)."
+msgstr ""
+"The NetApp E-series driver has been fixed to correctly report the "
+"\"provisioned_capacity_gb\". Now it sums the capacity of all the volumes in "
+"the configured backend to get the correct value. This bug fix affects all "
+"the protocols supported by the driver (FC and iSCSI)."
+
+msgid ""
+"The NetApp ONTAP driver supports a new configuration option "
+"``netapp_api_trace_pattern`` to enable filtering backend API interactions to "
+"log. This option must be specified in the backend section when desired and "
+"it accepts a valid python regular expression."
+msgstr ""
+"The NetApp ONTAP driver supports a new configuration option "
+"``netapp_api_trace_pattern`` to enable filtering backend API interactions to "
+"log. This option must be specified in the backend section when desired and "
+"it accepts a valid python regular expression."
+
+msgid ""
+"The NetApp cDOT driver now sets the ``replication_status`` attribute "
+"appropriately on volumes created within replicated backends when using host "
+"level replication."
+msgstr ""
+"The NetApp cDOT driver now sets the ``replication_status`` attribute "
+"appropriately on volumes created within replicated backends when using host "
+"level replication."
+
+msgid ""
+"The NetApp cDOT driver operating with NFS protocol has been fixed to manage "
+"volumes correctly when ``nas_secure_file_operations`` option has been set to "
+"False."
+msgstr ""
+"The NetApp cDOT driver operating with NFS protocol has been fixed to manage "
+"volumes correctly when ``nas_secure_file_operations`` option has been set to "
+"False."
+
+msgid ""
+"The NetApp cDOT drivers report to the scheduler, for each FlexVol pool, the "
+"fraction of the shared block limit that has been consumed by dedupe and "
+"cloning operations. This value, netapp_dedupe_used_percent, may be used in "
+"the filter & goodness functions for better placement of new Cinder volumes."
+msgstr ""
+"The NetApp cDOT drivers report to the scheduler, for each FlexVol pool, the "
+"fraction of the shared block limit that has been consumed by dedupe and "
+"cloning operations. This value, netapp_dedupe_used_percent, may be used in "
+"the filter & goodness functions for better placement of new Cinder volumes."
+
+msgid ""
+"The Nexenta Edge driver has been marked as unsupported and is now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use it."
+msgstr ""
+"The Nexenta Edge driver has been marked as unsupported and is now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use it."
+
+msgid ""
+"The Nexenta Edge driver has been marked as unsupported and is now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use it. If its support "
+"status does not change, it will be removed in the 'T' development cycle."
+msgstr ""
+"The Nexenta Edge driver has been marked as unsupported and is now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use it. If its support "
+"status does not change, it will be removed in the 'T' development cycle."
+
+msgid ""
+"The Nexenta Edge drivers has been marked as unsupported and are now "
+"deprecated. ``enable_unsupported_drivers`` will need to be set to ``True`` "
+"in cinder.conf to continue to use it. If its support status does not change "
+"it will be removed in the next release."
+msgstr ""
+"The Nexenta Edge drivers has been marked as unsupported and are now "
+"deprecated. ``enable_unsupported_drivers`` will need to be set to ``True`` "
+"in cinder.conf to continue to use it. If its support status does not change "
+"it will be removed in the next release."
+
+msgid ""
+"The Nexenta Edge drivers have been marked as unsupported and are now "
+"deprecated. ``enable_unsupported_drivers`` will need to be set to ``True`` "
+"in cinder.conf to continue to use it."
+msgstr ""
+"The Nexenta Edge drivers have been marked as unsupported and are now "
+"deprecated. ``enable_unsupported_drivers`` will need to be set to ``True`` "
+"in cinder.conf to continue to use it."
+
+msgid ""
+"The Nimble backend driver has been updated to use REST for array "
+"communication."
+msgstr ""
+"The Nimble backend driver has been updated to use REST for array "
+"communication."
+
+msgid ""
+"The ONTAP drivers (\"7mode\" and \"cmode\") have been fixed to not report "
+"consumed space as \"provisioned_capacity_gb\". They instead rely on the "
+"cinder scheduler's calculation of \"provisioned_capacity_gb\". This fixes "
+"the oversubscription miscalculations with the ONTAP drivers. This bugfix "
+"affects all three protocols supported by these drivers (iSCSI/FC/NFS)."
+msgstr ""
+"The ONTAP drivers (\"7mode\" and \"cmode\") have been fixed to not report "
+"consumed space as \"provisioned_capacity_gb\". They instead rely on the "
+"cinder scheduler's calculation of \"provisioned_capacity_gb\". This fixes "
+"the over-subscription miscalculations with the ONTAP drivers. This bugfix "
+"affects all three protocols supported by these drivers (iSCSI/FC/NFS)."
+
+msgid ""
+"The QNAP driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it."
+msgstr ""
+"The QNAP driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it."
+
+msgid ""
+"The QNAP driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it. If its support status does not change it will be "
+"removed in the next release."
+msgstr ""
+"The QNAP driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use it. If its support status does not change it will be "
+"removed in the next release."
+
+msgid ""
+"The Quobyte Cinder driver now supports identifying Quobyte mounts via the "
+"mounts fstype field."
+msgstr ""
+"The Quobyte Cinder driver now supports identifying Quobyte mounts via the "
+"mounts fstype field."
+
+msgid ""
+"The RBD driver no longer uses the \"volume_tmp_dir\" option to set where "
+"temporary files for image conversion are stored.  Set \"image_conversion_dir"
+"\" to configure this in Ocata."
+msgstr ""
+"The RBD driver no longer uses the \"volume_tmp_dir\" option to set where "
+"temporary files for image conversion are stored.  Set \"image_conversion_dir"
+"\" to configure this in Ocata."
+
+msgid ""
+"The Reduxio driver has been marked unsupported and is now deprecated. "
+"``use_unsupported_driver`` will need to be set to ``True`` in the driver's "
+"section in cinder.conf to use it."
+msgstr ""
+"The Reduxio driver has been marked unsupported and is now deprecated. "
+"``use_unsupported_driver`` will need to be set to ``True`` in the driver's "
+"section in cinder.conf to use it."
+
+msgid ""
+"The Reduxio driver has been marked unsupported and is now deprecated. "
+"``use_unsupported_driver`` will need to be set to ``True`` in the driver's "
+"section in cinder.conf to use it. If its support status does not change, the "
+"driver will be removed in the Queens development cycle."
+msgstr ""
+"The Reduxio driver has been marked unsupported and is now deprecated. "
+"``use_unsupported_driver`` will need to be set to ``True`` in the driver's "
+"section in cinder.conf to use it. If its support status does not change, the "
+"driver will be removed in the Queens development cycle."
+
+msgid ""
+"The SMBFS driver now exposes share information to the scheduler via pools. "
+"The pool names are configurable, defaulting to the share names."
+msgstr ""
+"The SMBFS driver now exposes share information to the scheduler via pools. "
+"The pool names are configurable, defaulting to the share names."
+
+msgid ""
+"The SMBFS driver now supports the 'snapshot attach' feature. Special care "
+"must be taken when attaching snapshots though, as writing to a snapshot will "
+"corrupt the differencing image chain."
+msgstr ""
+"The SMBFS driver now supports the 'snapshot attach' feature. Special care "
+"must be taken when attaching snapshots though, as writing to a snapshot will "
+"corrupt the differencing image chain."
+
+msgid ""
+"The SMBFS driver now supports the volume manage/unmanage feature. Images "
+"residing on preconfigured shares may be listed and managed by Cinder."
+msgstr ""
+"The SMBFS driver now supports the volume manage/unmanage feature. Images "
+"residing on preconfigured shares may be listed and managed by Cinder."
+
+msgid ""
+"The SMBFS volume driver can now be configured to use fixed vhd/x images "
+"through the 'nas_volume_prov_type' config option."
+msgstr ""
+"The SMBFS volume driver can now be configured to use fixed VHD/X images "
+"through the 'nas_volume_prov_type' config option."
+
+msgid ""
+"The SMBFS volume driver now supports reverting volumes to the latest "
+"snapshot."
+msgstr ""
+"The SMBFS volume driver now supports reverting volumes to the latest "
+"snapshot."
+
+msgid ""
+"The ScaleIO Driver has deprecated several options specified in ``cinder."
+"conf``: * ``sio_protection_domain_id`` * ``sio_protection_domain_name``, * "
+"``sio_storage_pool_id`` * ``sio_storage_pool_name``. Users of the ScaleIO "
+"Driver should now utilize the ``sio_storage_pools`` options to provide a "
+"list of protection_domain:storage_pool pairs."
+msgstr ""
+"The ScaleIO Driver has deprecated several options specified in ``cinder."
+"conf``: * ``sio_protection_domain_id`` * ``sio_protection_domain_name``, * "
+"``sio_storage_pool_id`` * ``sio_storage_pool_name``. Users of the ScaleIO "
+"Driver should now utilise the ``sio_storage_pools`` options to provide a "
+"list of protection_domain:storage_pool pairs."
+
+msgid ""
+"The ScaleIO Driver has deprecated the ability to specify the protection "
+"domain, as ``sio:pd_name``, and storage pool, as ``sio:sp_name``, extra "
+"specs in volume types. The supported way to specify a specific protection "
+"domain and storage pool in a volume type is to define a ``pool_name`` extra "
+"spec and set the value to the appropriate ``protection_domain_name:"
+"storage_pool_name``."
+msgstr ""
+"The ScaleIO Driver has deprecated the ability to specify the protection "
+"domain, as ``sio:pd_name``, and storage pool, as ``sio:sp_name``, extra "
+"specs in volume types. The supported way to specify a specific protection "
+"domain and storage pool in a volume type is to define a ``pool_name`` extra "
+"spec and set the value to the appropriate ``protection_domain_name:"
+"storage_pool_name``."
+
+msgid ""
+"The ScaleIO driver is moved to the dell_emc directory. volume_driver entry "
+"in cinder.conf needs to be changed to ``cinder.volume.drivers.dell_emc."
+"scaleio.driver.ScaleIODriver``."
+msgstr ""
+"The ScaleIO driver is moved to the dell_emc directory. volume_driver entry "
+"in cinder.conf needs to be changed to ``cinder.volume.drivers.dell_emc."
+"scaleio.driver.ScaleIODriver``."
+
+msgid ""
+"The Scality backend volume driver was marked as not supported in the "
+"previous release and has now been removed."
+msgstr ""
+"The Scality backend volume driver was marked as not supported in the "
+"previous release and has now been removed."
+
+msgid ""
+"The Scality driver has been marked as unsupported and is now deprecated. "
+"enable_unsupported_drivers will need to be set to True in cinder.conf to "
+"continue to use it."
+msgstr ""
+"The Scality driver has been marked as unsupported and is now deprecated. "
+"enable_unsupported_drivers will need to be set to True in cinder.conf to "
+"continue to use it."
+
+msgid ""
+"The Scality driver has been marked as unsupported and is now deprecated. "
+"enable_unsupported_drivers will need to be set to True in cinder.conf to "
+"continue to use it. If its support status does not change it will be removed "
+"in the next release."
+msgstr ""
+"The Scality driver has been marked as unsupported and is now deprecated. "
+"enable_unsupported_drivers will need to be set to True in cinder.conf to "
+"continue to use it. If its support status does not change it will be removed "
+"in the next release."
+
+msgid ""
+"The SolidFire driver will recognize 4 new QoS spec keys to allow an "
+"administrator to specify QoS settings which are scaled by the size of the "
+"volume. 'ScaledIOPS' is a flag which will tell the driver to look for "
+"'scaleMin', 'scaleMax' and 'scaleBurst' which provide the scaling factor "
+"from the minimum values specified by the previous QoS keys ('minIOPS', "
+"'maxIOPS', 'burstIOPS'). The administrator must take care to assure that no "
+"matter what the final calculated QoS values follow minIOPS <= maxIOPS <= "
+"burstIOPS. A exception will be thrown if not. The QoS settings are also "
+"checked against the cluster min and max allowed and truncated at the min or "
+"max if they exceed."
+msgstr ""
+"The SolidFire driver will recognize 4 new QoS spec keys to allow an "
+"administrator to specify QoS settings which are scaled by the size of the "
+"volume. 'ScaledIOPS' is a flag which will tell the driver to look for "
+"'scaleMin', 'scaleMax' and 'scaleBurst' which provide the scaling factor "
+"from the minimum values specified by the previous QoS keys ('minIOPS', "
+"'maxIOPS', 'burstIOPS'). The administrator must take care to assure that no "
+"matter what the final calculated QoS values follow minIOPS <= maxIOPS <= "
+"burstIOPS. A exception will be thrown if not. The QoS settings are also "
+"checked against the cluster min and max allowed and truncated at the min or "
+"max if they exceed."
+
+msgid ""
+"The Solidfire cinder driver has been fixed to ensure delete happens on the "
+"correct volume."
+msgstr ""
+"The Solidfire Cinder driver has been fixed to ensure delete happens on the "
+"correct volume."
+
+msgid "The StorPool backend driver was added."
+msgstr "The StorPool backend driver was added."
+
+msgid "The Swift and Posix backup drivers are known to be working on Windows."
+msgstr "The Swift and Posix backup drivers are known to be working on Windows."
+
+msgid ""
+"The Synology driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in ``cinder.conf`` to continue to use it."
+msgstr ""
+"The Synology driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in ``cinder.conf`` to continue to use it."
+
+msgid ""
+"The Synology driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in ``cinder.conf`` to continue to use it. If its support "
+"status does not change, the driver will be removed in the Queens development "
+"cycle."
+msgstr ""
+"The Synology driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in ``cinder.conf`` to continue to use it. If its support "
+"status does not change, the driver will be removed in the Queens development "
+"cycle."
+
+msgid ""
+"The Tegile driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it."
+msgstr ""
+"The Tegile driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it."
+
+msgid ""
+"The Tegile driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it. If its support status "
+"does not change, they will be removed in the Queens development cycle."
+msgstr ""
+"The Tegile driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it. If its support status "
+"does not change, they will be removed in the Queens development cycle."
+
+msgid ""
+"The Tintri driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it."
+msgstr ""
+"The Tintri driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it."
+
+msgid ""
+"The Tintri driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it. If its support status "
+"does not change, it will be removed in the 'T' development cycle."
+msgstr ""
+"The Tintri driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it. If its support status "
+"does not change, it will be removed in the 'T' development cycle."
+
+msgid ""
+"The VMAX driver is moved to the dell_emc directory. volume_driver entry in "
+"cinder.conf needs to be changed to ``cinder.volume.drivers.dell_emc.vmax."
+"iscsi.VMAXISCSIDriver`` or ``cinder.volume.drivers.dell_emc.vmax.fc."
+"VMAXFCDriver``."
+msgstr ""
+"The VMAX driver is moved to the dell_emc directory. volume_driver entry in "
+"cinder.conf needs to be changed to ``cinder.volume.drivers.dell_emc.vmax."
+"iscsi.VMAXISCSIDriver`` or ``cinder.volume.drivers.dell_emc.vmax.fc."
+"VMAXFCDriver``."
+
+msgid "The VMware VMDK driver for ESX server has been removed."
+msgstr "The VMware VMDK driver for ESX server has been removed."
+
+msgid "The VMware VMDK driver now enforces minimum vCenter version of 5.1."
+msgstr "The VMware VMDK driver now enforces minimum vCenter version of 5.1."
+
+msgid "The VMware VMDK driver now enforces minimum vCenter version of 5.5."
+msgstr "The VMware VMDK driver now enforces minimum vCenter version of 5.5."
+
+msgid ""
+"The VMware VMDK driver supports a new config option 'vmware_host_port' to "
+"specify the port number to connect to vCenter server."
+msgstr ""
+"The VMware VMDK driver supports a new config option 'vmware_host_port' to "
+"specify the port number to connect to vCenter server."
+
+msgid ""
+"The Veritas HyperScale driver has been marked as unsupported and is now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use it."
+msgstr ""
+"The Veritas HyperScale driver has been marked as unsupported and is now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use it."
+
+msgid ""
+"The Veritas HyperScale driver has been marked as unsupported and is now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use it. If its support "
+"status does not change, it will be removed in the 'T' development cycle."
+msgstr ""
+"The Veritas HyperScale driver has been marked as unsupported and is now "
+"deprecated. ``enable_unsupported_driver`` will need to be set to ``True`` in "
+"the driver's section in cinder.conf to continue to use it. If its support "
+"status does not change, it will be removed in the 'T' development cycle."
+
+msgid ""
+"The Violin drivers have been marked as unsupported and are now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use them."
+msgstr ""
+"The Violin drivers have been marked as unsupported and are now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use them."
+
+msgid ""
+"The Violin drivers have been marked as unsupported and are now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use them. If its support status does not change it will "
+"be removed in the next release."
+msgstr ""
+"The Violin drivers have been marked as unsupported and are now deprecated. "
+"``enable_unsupported_drivers`` will need to be set to ``True`` in cinder."
+"conf to continue to use them. If its support status does not change it will "
+"be removed in the next release."
+
+msgid ""
+"The Windows iSCSI driver has been renamed. The updated driver location is "
+"``cinder.volume.drivers.windows.iscsi.WindowsISCSIDriver``."
+msgstr ""
+"The Windows iSCSI driver has been renamed. The updated driver location is "
+"``cinder.volume.drivers.windows.iscsi.WindowsISCSIDriver``."
+
+msgid ""
+"The Windows iSCSI driver now honors the configured iSCSI addresses, ensuring "
+"that only those addresses will be used for iSCSI traffic."
+msgstr ""
+"The Windows iSCSI driver now honours the configured iSCSI addresses, "
+"ensuring that only those addresses will be used for iSCSI traffic."
+
+msgid ""
+"The Windows iSCSI driver now returns multiple portals when available and "
+"multipath is requested."
+msgstr ""
+"The Windows iSCSI driver now returns multiple portals when available and "
+"multipath is requested."
+
+msgid ""
+"The X-IO driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it."
+msgstr ""
+"The X-IO driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it."
+
+msgid ""
+"The X-IO driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it. If its support status "
+"does not change, they will be removed in the Queens development cycle."
+msgstr ""
+"The X-IO driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it. If its support status "
+"does not change, they will be removed in the Queens development cycle."
+
+msgid ""
+"The XML API has been marked deprecated and will be removed in a future "
+"release."
+msgstr ""
+"The XML API has been marked deprecated and will be removed in a future "
+"release."
+
+msgid ""
+"The XML API has been removed in Newton release. Cinder supports only JSON "
+"API request/response format now."
+msgstr ""
+"The XML API has been removed in Newton release. Cinder supports only JSON "
+"API request/response format now."
+
+msgid ""
+"The XML configuration file used by the HNAS drivers is now deprecated and "
+"will no longer be used in the future. Please use cinder.conf for all driver "
+"configuration."
+msgstr ""
+"The XML configuration file used by the HNAS drivers is now deprecated and "
+"will no longer be used in the future. Please use cinder.conf for all driver "
+"configuration."
+
+msgid ""
+"The XtremIO driver has been fixed to correctly report the \"free_capacity_gb"
+"\" size."
+msgstr ""
+"The XtremIO driver has been fixed to correctly report the \"free_capacity_gb"
+"\" size."
+
+msgid ""
+"The XtremIO driver is moved to the dell_emc directory. volume_driver entry "
+"in cinder.conf needs to be changed to ``cinder.volume.drivers.dell_emc."
+"xtremio.XtremIOISCSIDriver`` or ``cinder.volume.drivers.dell_emc.xtremio."
+"XtremIOFCDriver``."
+msgstr ""
+"The XtremIO driver is moved to the dell_emc directory. volume_driver entry "
+"in cinder.conf needs to be changed to ``cinder.volume.drivers.dell_emc."
+"xtremio.XtremIOISCSIDriver`` or ``cinder.volume.drivers.dell_emc.xtremio."
+"XtremIOFCDriver``."
+
+msgid ""
+"The ZTE driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it."
+msgstr ""
+"The ZTE driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it."
+
+msgid ""
+"The ZTE driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it. If its support status "
+"does not change, they will be removed in the Queens development cycle."
+msgstr ""
+"The ZTE driver has been marked as unsupported and is now deprecated. "
+"``enable_unsupported_driver`` will need to be set to ``True`` in the "
+"driver's section in cinder.conf to continue to use it. If its support status "
+"does not change, they will be removed in the Queens development cycle."
+
+msgid ""
+"The ``WindowsDriver`` was renamed in the Queens release to "
+"``WindowsISCSIDriver`` to avoid confusion with the SMB driver. The backwards "
+"compatibility for this has now been removed, so any cinder.conf settings "
+"still using ``cinder.volume.drivers.windows.windows.WindowsDriver`` must now "
+"be updated to use ``cinder.volume.drivers.windows.iscsi.WindowsISCSIDriver``."
+msgstr ""
+"The ``WindowsDriver`` was renamed in the Queens release to "
+"``WindowsISCSIDriver`` to avoid confusion with the SMB driver. The backwards "
+"compatibility for this has now been removed, so any cinder.conf settings "
+"still using ``cinder.volume.drivers.windows.windows.WindowsDriver`` must now "
+"be updated to use ``cinder.volume.drivers.windows.iscsi.WindowsISCSIDriver``."
+
+msgid ""
+"The ``cinder-manage db online_data_migrations`` command now returns exit "
+"status 2 in the case where some migrations failed (raised exceptions) and no "
+"others were completed successfully from the last batch attempted. This "
+"should be considered a fatal condition that requires intervention. Exit "
+"status 1 will be returned in the case where the ``--max-count`` option was "
+"used and some migrations failed but others succeeded (updated at least one "
+"row), because more work may remain for the non-failing migrations, and their "
+"completion may be a dependency for the failing ones. The command should be "
+"reiterated while it returns exit status 1, and considered completed "
+"successfully only when it returns exit status 0."
+msgstr ""
+"The ``cinder-manage db online_data_migrations`` command now returns exit "
+"status 2 in the case where some migrations failed (raised exceptions) and no "
+"others were completed successfully from the last batch attempted. This "
+"should be considered a fatal condition that requires intervention. Exit "
+"status 1 will be returned in the case where the ``--max-count`` option was "
+"used and some migrations failed but others succeeded (updated at least one "
+"row), because more work may remain for the non-failing migrations, and their "
+"completion may be a dependency for the failing ones. The command should be "
+"reiterated while it returns exit status 1, and considered completed "
+"successfully only when it returns exit status 0."
+
+msgid ""
+"The ``force`` boolean parameter has been added to the volume delete API.  It "
+"may be used in combination with ``cascade``. This also means that volume "
+"force delete is available in the base volume API rather than only in the "
+"``volume_admin_actions`` extension."
+msgstr ""
+"The ``force`` boolean parameter has been added to the volume delete API.  It "
+"may be used in combination with ``cascade``. This also means that volume "
+"force delete is available in the base volume API rather than only in the "
+"``volume_admin_actions`` extension."
+
+msgid ""
+"The ``service`` filter for service list API was deprecated 3 years ago in "
+"2013 July (Havana). Removed this filter and please use \"binary\" instead."
+msgstr ""
+"The ``service`` filter for service list API was deprecated 3 years ago in "
+"2013 July (Havana). Removed this filter and please use \"binary\" instead."
+
+msgid ""
+"The `lvm_max_overprovision_ratio` config option has been deprecated. It will "
+"be removed in a future release. Configurations should move to using the "
+"common `max_overprovision_ratio` config option."
+msgstr ""
+"The `lvm_max_overprovision_ratio` config option has been deprecated. It will "
+"be removed in a future release. Configurations should move to using the "
+"common `max_overprovision_ratio` config option."
+
+msgid ""
+"The `osapi_volume_base_URL` config option was deprecated in Pike and has now "
+"been removed. The `public_endpoint` config option should be used instead."
+msgstr ""
+"The `osapi_volume_base_URL` config option was deprecated in Pike and has now "
+"been removed. The `public_endpoint` config option should be used instead."
+
+msgid ""
+"The ability to specify a backup driver by module name was deprecated in the "
+"Queens release and the ability has now been removed. Any configuration in "
+"cinder.conf still using the module path should be updated to include the "
+"full class name. For example, ``cinder.backup.drivers.swift`` should be "
+"updated to ``cinder.backup.drivers.swift.SwiftBackupDriver``."
+msgstr ""
+"The ability to specify a backup driver by module name was deprecated in the "
+"Queens release and the ability has now been removed. Any configuration in "
+"cinder.conf still using the module path should be updated to include the "
+"full class name. For example, ``cinder.backup.drivers.swift`` should be "
+"updated to ``cinder.backup.drivers.swift.SwiftBackupDriver``."
+
+msgid ""
+"The block_driver is deprecated as of the Ocata release and will be removed "
+"in the Queens release of Cinder.  Instead the LVM driver with the LIO iSCSI "
+"target should be used.  For those that desire higher performance, they "
+"should use LVM striping."
+msgstr ""
+"The block_driver is deprecated as of the Ocata release and will be removed "
+"in the Queens release of Cinder.  Instead the LVM driver with the LIO iSCSI "
+"target should be used.  For those that desire higher performance they should "
+"use LVM striping."
+
+msgid ""
+"The cinder-manage online_data_migrations command now prints a tabular "
+"summary of completed and remaining records. The goal here is to get all your "
+"numbers to zero. The previous execution return code behavior is retained for "
+"scripting."
+msgstr ""
+"The cinder-manage online_data_migrations command now prints a tabular "
+"summary of completed and remaining records. The goal here is to get all your "
+"numbers to zero. The previous execution return code behaviour is retained "
+"for scripting."
+
+msgid ""
+"The config options ``iscsi_ip_address``, ``iscsi_port``, ``target_helper``, "
+"``iscsi_target_prefix`` and ``iscsi_protocol`` were deprecated in the Queens "
+"release and have now been removed. Deployments should now used the more "
+"general ``target_ip_address``, ``target_port``, ``target_helper``, "
+"``target_prefix`` and ``target_protocol`` options."
+msgstr ""
+"The config options ``iscsi_ip_address``, ``iscsi_port``, ``target_helper``, "
+"``iscsi_target_prefix`` and ``iscsi_protocol`` were deprecated in the Queens "
+"release and have now been removed. Deployments should now used the more "
+"general ``target_ip_address``, ``target_port``, ``target_helper``, "
+"``target_prefix`` and ``target_protocol`` options."
+
+msgid ""
+"The config options ``scheduler_topic``, ``volume_topic`` and "
+"``backup_topic`` have been removed without a deprecation period as these had "
+"never worked correctly."
+msgstr ""
+"The config options ``scheduler_topic``, ``volume_topic`` and "
+"``backup_topic`` have been removed without a deprecation period as these had "
+"never worked correctly."
+
+msgid "The consistency group API now returns volume type IDs."
+msgstr "The consistency group API now returns volume type IDs."
+
+msgid ""
+"The coordination system used by Cinder has been simplified to leverage tooz "
+"builtin heartbeat feature. Therefore, the configuration options "
+"`coordination.heartbeat`, `coordination.initial_reconnect_backoff` and "
+"`coordination.max_reconnect_backoff` have been removed."
+msgstr ""
+"The coordination system used by Cinder has been simplified to leverage Tooz "
+"built-in heartbeat feature. Therefore, the configuration options "
+"`coordination.heartbeat`, `coordination.initial_reconnect_backoff` and "
+"`coordination.max_reconnect_backoff` have been removed."
+
+msgid ""
+"The create volume api will now return 400 error instead of 404/500 if user "
+"passes non-uuid values to consistencygroup_id, source_volid and "
+"source_replica parameters in the request body."
+msgstr ""
+"The create volume API will now return 400 error instead of 404/500 if user "
+"passes non-UUID values to consistencygroup_id, source_volid and "
+"source_replica parameters in the request body."
+
+msgid ""
+"The default interval for polling vCenter tasks in the VMware VMDK driver is "
+"changed to 2s."
+msgstr ""
+"The default interval for polling vCenter tasks in the VMware VMDK driver is "
+"changed to 2s."
+
+msgid ""
+"The default key manager interface in Cinder was deprecated and the Castellan "
+"key manager interface library is now used instead. For more information "
+"about Castellan, please see http://docs.openstack.org/developer/castellan/ ."
+msgstr ""
+"The default key manager interface in Cinder was deprecated and the Castellan "
+"key manager interface library is now used instead. For more information "
+"about Castellan, please see http://docs.openstack.org/developer/castellan/ ."
+
+msgid ""
+"The default value for pure_replica_interval_default used by Pure Storage "
+"volume drivers has changed from 900 to 3600 seconds."
+msgstr ""
+"The default value for pure_replica_interval_default used by Pure Storage "
+"volume drivers has changed from 900 to 3600 seconds."
+
+msgid ""
+"The default value has been removed for the LVM specific "
+"`lvm_max_over_subscription_ratio` setting. This changes the behavior so that "
+"LVM backends now adhere to the common `max_over_subscription_ratio` setting. "
+"The LVM specific config option may still be used, but it is now deprecated "
+"and will be removed in a future release."
+msgstr ""
+"The default value has been removed for the LVM specific "
+"`lvm_max_over_subscription_ratio` setting. This changes the behaviour so "
+"that LVM backends now adhere to the common `max_over_subscription_ratio` "
+"setting. The LVM specific config option may still be used, but it is now "
+"deprecated and will be removed in a future release."
+
+msgid "The deprecated HP CLIQ proxy driver has now been removed."
+msgstr "The deprecated HP CLIQ proxy driver has now been removed."
+
+msgid "The endpoints will now correctly raise a 403 Forbidden instead."
+msgstr "The endpoints will now correctly raise a 403 Forbidden instead."
+
+msgid ""
+"The following commands are no longer required to be listed in your rootwrap "
+"configuration: cgcreate; and cgset."
+msgstr ""
+"The following commands are no longer required to be listed in your rootwrap "
+"configuration: cgcreate; and cgset."
+
+msgid ""
+"The following volume drivers were deprecated in the Pike release and have "
+"now been removed:"
+msgstr ""
+"The following volume drivers were deprecated in the Pike release and have "
+"now been removed:"
+
+msgid "The fss_pool option is deprecated. Use fss_pools instead."
+msgstr "The fss_pool option is deprecated. Use fss_pools instead."
+
+msgid ""
+"The hosts api extension is now deprecated and will be removed in a future "
+"version."
+msgstr ""
+"The hosts API extension is now deprecated and will be removed in a future "
+"version."
+
+msgid ""
+"The multiattach capability has been enabled and verified as working with the "
+"ScaleIO driver. It is the user's responsibility to add some type of "
+"exclusion (at the file system or network file system layer) to prevent "
+"multiple writers from corrupting data on the volume."
+msgstr ""
+"The multiattach capability has been enabled and verified as working with the "
+"ScaleIO driver. It is the user's responsibility to add some type of "
+"exclusion (at the file system or network file system layer) to prevent "
+"multiple writers from corrupting data on the volume."
+
+msgid ""
+"The old HNAS drivers configuration paths have been marked for deprecation."
+msgstr ""
+"The old HNAS drivers configuration paths have been marked for deprecation."
+
+msgid ""
+"The old deprecated ``hp3par*`` options have been removed. Use the "
+"``hpe3par*`` instead of them."
+msgstr ""
+"The old deprecated ``hp3par*`` options have been removed. Use the "
+"``hpe3par*`` instead of them."
+
+msgid ""
+"The old deprecated ``keymgr`` options have been removed. Configuration "
+"options using the ``[keymgr]`` group will not be applied anymore. Use the "
+"``[key_manager]`` group from Castellan instead. The Castellan ``backend`` "
+"options should also be used instead of ``api_class``, as most of the options "
+"that lived in Cinder have migrated to Castellan."
+msgstr ""
+"The old deprecated ``keymgr`` options have been removed. Configuration "
+"options using the ``[keymgr]`` group will not be applied any more. Use the "
+"``[key_manager]`` group from Castellan instead. The Castellan ``backend`` "
+"options should also be used instead of ``api_class``, as most of the options "
+"that lived in Cinder have migrated to Castellan."
+
+msgid ""
+"The old deprecated ``nas_ip`` option has been removed. Use the ``nas_host`` "
+"instead of it."
+msgstr ""
+"The old deprecated ``nas_ip`` option has been removed. Use the ``nas_host`` "
+"instead of it."
+
+msgid ""
+"The old deprecated ``netapp_eseries_host_type`` option has been removed. Use "
+"the ``netapp_host_type`` instead."
+msgstr ""
+"The old deprecated ``netapp_eseries_host_type`` option has been removed. Use "
+"the ``netapp_host_type`` instead."
+
+msgid ""
+"The old deprecated ``pybasedir`` option has been removed. Use the "
+"``state_path`` instead."
+msgstr ""
+"The old deprecated ``pybasedir`` option has been removed. Use the "
+"``state_path`` instead."
+
+msgid ""
+"The os_privileged_xxx and nova_xxx in the [default] section are deprecated "
+"in favor of the settings in the [nova] section."
+msgstr ""
+"The os_privileged_xxx and nova_xxx in the [default] section are deprecated "
+"in favour of the settings in the [nova] section."
+
+msgid ""
+"The policy file to be used may be specified in the ``/etc/cinder/cinder."
+"conf`` file in the ``[oslo_policy]`` section as the value of the "
+"``policy_file`` configuration option. That way there's no question what file "
+"is being used."
+msgstr ""
+"The policy file to be used may be specified in the ``/etc/cinder/cinder."
+"conf`` file in the ``[oslo_policy]`` section as the value of the "
+"``policy_file`` configuration option. That way there's no question what file "
+"is being used."
+
+msgid ""
+"The qemu-img tool now has resource limits applied which prevent it from "
+"using more than 1GB of address space or more than 2 seconds of CPU time. "
+"This provides protection against denial of service attacks from maliciously "
+"crafted or corrupted disk images."
+msgstr ""
+"The qemu-img tool now has resource limits applied which prevent it from "
+"using more than 1GB of address space or more than 2 seconds of CPU time. "
+"This provides protection against denial of service attacks from maliciously "
+"crafted or corrupted disk images."
+
+msgid ""
+"The reserve volume API was incorrectly enforcing \"volume:retype\" policy "
+"action. It has been corrected to \"volume_extension:volume_actions:reserve\"."
+msgstr ""
+"The reserve volume API was incorrectly enforcing \"volume:retype\" policy "
+"action. It has been corrected to \"volume_extension:volume_actions:reserve\"."
+
+msgid ""
+"The sample file is YAML (because unlike JSON, YAML allows comments). If you "
+"prefer, you may use a JSON policy file."
+msgstr ""
+"The sample file is YAML (because unlike JSON, YAML allows comments). If you "
+"prefer, you may use a JSON policy file."
+
+msgid ""
+"The support for ``cinder.keymgr.barbican.BarbicanKeyManager`` and the "
+"``[keymgr]`` config section has now been removed. All configs should now be "
+"switched to use ``castellan.key_manager.barbican_key_manager."
+"BarbicanKeyManager`` and the ``[key_manager]`` config section."
+msgstr ""
+"The support for ``cinder.keymgr.barbican.BarbicanKeyManager`` and the "
+"``[keymgr]`` config section has now been removed. All configs should now be "
+"switched to use ``castellan.key_manager.barbican_key_manager."
+"BarbicanKeyManager`` and the ``[key_manager]`` config section."
+
+msgid "The updated_at timestamp is now returned in listing detail."
+msgstr "The updated_at timestamp is now returned in listing detail."
+
+msgid ""
+"The use of xml files for vmax backend configuration is now deprecated and "
+"will be removed during the following release. Deployers are encouraged to "
+"use the cinder.conf for configuring connections to the vmax."
+msgstr ""
+"The use of XML files for VMAX backend configuration is now deprecated and "
+"will be removed during the following release. Deployers are encouraged to "
+"use the cinder.conf for configuring connections to the VMAX."
+
+msgid ""
+"The v1 API was deprecated in the Juno release and is now defaulted to "
+"disabled. In order to still use the v1 API, you must now set "
+"``enable_v1_api`` to ``True`` in your cinder.conf file."
+msgstr ""
+"The v1 API was deprecated in the Juno release and is now defaulted to "
+"disabled. In order to still use the v1 API, you must now set "
+"``enable_v1_api`` to ``True`` in your cinder.conf file."
+
+msgid ""
+"The v2 API extensions os-volume-manage and os-snapshot-manage have been "
+"mapped to the v3 resources manageable_volumes and manageable_snapshots"
+msgstr ""
+"The v2 API extensions os-volume-manage and os-snapshot-manage have been "
+"mapped to the v3 resources manageable_volumes and manageable_snapshots"
+
+msgid ""
+"The volume_clear option to use `shred` was deprecated in the Newton release "
+"and has now been removed. Since deprecation, this option has performed the "
+"same action as the `zero` option. Config settings for `shred` should be "
+"updated to be set to `zero` for continued operation."
+msgstr ""
+"The volume_clear option to use `shred` was deprecated in the Newton release "
+"and has now been removed. Since deprecation, this option has performed the "
+"same action as the `zero` option. Configuration settings for `shred` should "
+"be updated to be set to `zero` for continued operation."
+
+msgid ""
+"The volumes created by VMware VMDK driver will be displayed as \"managed by "
+"OpenStack Cinder\" in vCenter server."
+msgstr ""
+"The volumes created by VMware VMDK driver will be displayed as \"managed by "
+"OpenStack Cinder\" in vCenter server."
+
+msgid ""
+"The xiv_ds8k driver now supports IBM XIV, Spectrum Accelerate, FlashSystem "
+"A9000, FlashSystem A9000R and DS8000 storage systems, and was renamed to IBM "
+"Storage Driver for OpenStack. The changes include text changes, file names, "
+"names of cinder.conf flags, and names of the proxy classes."
+msgstr ""
+"The xiv_ds8k driver now supports IBM XIV, Spectrum Accelerate, FlashSystem "
+"A9000, FlashSystem A9000R and DS8000 storage systems, and was renamed to IBM "
+"Storage Driver for OpenStack. The changes include text changes, file names, "
+"names of cinder.conf flags, and names of the proxy classes."
+
+msgid ""
+"There is a new policy option ``volume:force_delete`` which controls access "
+"to the ability to specify force delete via the volume delete API.  This is "
+"separate from the pre-existing ``volume-admin-actions:force_delete`` policy "
+"check."
+msgstr ""
+"There is a new policy option ``volume:force_delete`` which controls access "
+"to the ability to specify force delete via the volume delete API.  This is "
+"separate from the pre-existing ``volume-admin-actions:force_delete`` policy "
+"check."
+
+msgid ""
+"This PowerMax driver now puts the unmanaged \"orphan\" volume in a storage "
+"group called OS-Unmanaged. It is not possible to query a volume's associated "
+"snapvx snapshots using the PowerMax management software, unless it belongs "
+"to a storage group."
+msgstr ""
+"This PowerMax driver now puts the unmanaged \"orphan\" volume in a storage "
+"group called OS-Unmanaged. It is not possible to query a volume's associated "
+"snapvx snapshots using the PowerMax management software, unless it belongs "
+"to a storage group."
+
+msgid ""
+"This is made an optional configuration because it only applies to very "
+"specific environments.  If we were to make this global that would require a "
+"rootwrap/privsep update that could break compatibility when trying to do "
+"rolling upgrades of the volume service."
+msgstr ""
+"This is made an optional configuration because it only applies to very "
+"specific environments.  If we were to make this global that would require a "
+"rootwrap/privsep update that could break compatibility when trying to do "
+"rolling upgrades of the volume service."
+
+msgid ""
+"This will generate a file named ``policy.yaml`` in the ``etc/cinder`` "
+"directory of your checked-out Cinder repository."
+msgstr ""
+"This will generate a file named ``policy.yaml`` in the ``etc/cinder`` "
+"directory of your checked-out Cinder repository."
+
+msgid ""
+"To accommodate these environments, and to maintain backward compatibility in "
+"Newton we add a ``lvm_suppress_fd_warnings`` bool config to the LVM driver. "
+"Setting this to True will append the LVM env vars to include the variable "
+"``LVM_SUPPRESS_FD_WARNINGS=1``."
+msgstr ""
+"To accommodate these environments, and to maintain backward compatibility in "
+"Newton we add a ``lvm_suppress_fd_warnings`` bool config to the LVM driver. "
+"Setting this to True will append the LVM environment variables to include "
+"the variable ``LVM_SUPPRESS_FD_WARNINGS=1``."
+
+msgid ""
+"To address backwards compatibility, the new rules added to the volume_type."
+"py policy file, default to the existing rule, ``volume_extension:"
+"volume_type_encryption``, if it is set to a non-default value."
+msgstr ""
+"To address backwards compatibility, the new rules added to the volume_type."
+"py policy file, default to the existing rule, ``volume_extension:"
+"volume_type_encryption``, if it is set to a non-default value."
+
+msgid ""
+"To find out what policies are available and what their default values are, "
+"you can generate a sample policy file.  To do this, you must have a local "
+"copy of the Cinder source code repository. From the top level directory, run "
+"the command::"
+msgstr ""
+"To find out what policies are available and what their default values are, "
+"you can generate a sample policy file.  To do this, you must have a local "
+"copy of the Cinder source code repository. From the top level directory, run "
+"the command::"
+
+msgid ""
+"To get rid of long running DB data migrations that must be run offline, "
+"Cinder will now be able to execute them online, on a live cloud. Before "
+"upgrading from Ocata to Pike, operator needs to perform all the Newton data "
+"migrations. To achieve that he needs to perform ``cinder-manage db "
+"online_data_migrations`` until there are no records to be updated. To limit "
+"DB performance impact migrations can be performed in chunks limited by ``--"
+"max_number`` option. If your intent is to upgrade Cinder in a non-live "
+"manner, you can use ``--ignore_state`` option safely. Please note that "
+"finishing all the Newton data migrations will be enforced by the first "
+"schema migration in Pike, so you won't be able to upgrade to Pike without "
+"that."
+msgstr ""
+"To get rid of long running DB data migrations that must be run offline, "
+"Cinder will now be able to execute them online, on a live cloud. Before "
+"upgrading from Ocata to Pike, operator needs to perform all the Newton data "
+"migrations. To achieve that he needs to perform ``cinder-manage db "
+"online_data_migrations`` until there are no records to be updated. To limit "
+"DB performance impact migrations can be performed in chunks limited by ``--"
+"max_number`` option. If your intent is to upgrade Cinder in a non-live "
+"manner, you can use ``--ignore_state`` option safely. Please note that "
+"finishing all the Newton data migrations will be enforced by the first "
+"schema migration in Pike, so you won't be able to upgrade to Pike without "
+"that."
+
+msgid "Train Series Release Notes"
+msgstr "Train Series Release Notes"
+
+msgid ""
+"Two new policies \"volume_extension:type_get\" and \"volume_extension:"
+"type_get_all\" have been added to control type show and type list APIs."
+msgstr ""
+"Two new policies \"volume_extension:type_get\" and \"volume_extension:"
+"type_get_all\" have been added to control type show and type list APIs."
+
+msgid "Update backend state in scheduler when extending volume."
+msgstr "Update backend state in scheduler when extending volume."
+
+msgid ""
+"Updated the parameter storwize_preferred_host_site from StrOpt to DictOpt in "
+"cinder back-end configuration, and removed it from volume type configuration."
+msgstr ""
+"Updated the parameter storwize_preferred_host_site from StrOpt to DictOpt in "
+"cinder back-end configuration, and removed it from volume type configuration."
+
+msgid ""
+"Updated the parameter storwzie_preferred_host_site from StrOpt to DictOpt in "
+"cinder back-end configuration, and removed it from volume type configuration."
+msgstr ""
+"Updated the parameter storwzie_preferred_host_site from StrOpt to DictOpt in "
+"Cinder back-end configuration, and removed it from volume type configuration."
+
+msgid ""
+"Updating the Datera Elastic DataFabric Storage Driver to version 2.1.  This "
+"adds ACL support, Multipath support and basic IP pool support."
+msgstr ""
+"Updating the Datera Elastic DataFabric Storage Driver to version 2.1.  This "
+"adds ACL support, Multipath support and basic IP pool support."
+
+msgid "Upgrade Notes"
+msgstr "Upgrade Notes"
+
+msgid ""
+"Users of the Datera Cinder driver are now required to use Datera DataFabric "
+"version 1.0+. Versions before 1.0 will not be able to utilize this new "
+"driver since they still function on v1 of the Datera DataFabric API"
+msgstr ""
+"Users of the Datera Cinder driver are now required to use Datera DataFabric "
+"version 1.0+. Versions before 1.0 will not be able to utilise this new "
+"driver since they still function on v1 of the Datera DataFabric API"
+
+msgid ""
+"Users of the IBM Storage Driver, previously known as the IBM XIV/DS8K "
+"driver, upgrading from Mitaka or previous releases, need to reconfigure the "
+"relevant cinder.conf entries. In most cases the change is just removal of "
+"the xiv-ds8k field prefix, but for details use the driver documentation."
+msgstr ""
+"Users of the IBM Storage Driver, previously known as the IBM XIV/DS8K "
+"driver, upgrading from Mitaka or previous releases, need to reconfigure the "
+"relevant cinder.conf entries. In most cases the change is just removal of "
+"the xiv-ds8k field prefix, but for details use the driver documentation."
+
+msgid ""
+"Users of the ibmnas driver should switch to using the IBM GPFS driver to "
+"enable Cinder access to IBM NAS resources.  For details configuring the IBM "
+"GPFS driver, see the GPFS config reference. - http://docs.openstack.org/"
+"liberty/config-reference/content/GPFS-driver.html"
+msgstr ""
+"Users of the ibmnas driver should switch to using the IBM GPFS driver to "
+"enable Cinder access to IBM NAS resources.  For details configuring the IBM "
+"GPFS driver, see the GPFS config reference. - http://docs.openstack.org/"
+"liberty/config-reference/content/GPFS-driver.html"
+
+msgid "VMAX driver - Removed deprecated option ``cinder_dell_emc_config_file``"
+msgstr ""
+"VMAX driver - Removed deprecated option ``cinder_dell_emc_config_file``"
+
+msgid ""
+"VMAX driver - configuration tag san_rest_port will be replaced by "
+"san_api_port in the next release."
+msgstr ""
+"VMAX driver - configuration tag san_rest_port will be replaced by "
+"san_api_port in the next release."
+
+msgid "VMAX driver - fixes SSL certificate verification error."
+msgstr "VMAX driver - fixes SSL certificate verification error."
+
+msgid ""
+"VMAX driver support for new configuration option - vmax_snapvx_unlink_limit "
+"for specifying the maximum number of unlinks which will be performed before "
+"a clone operation. Default value is 3"
+msgstr ""
+"VMAX driver support for new configuration option - vmax_snapvx_unlink_limit "
+"for specifying the maximum number of unlinks which will be performed before "
+"a clone operation. Default value is 3"
+
+msgid ""
+"VMAX driver version 3.0, replacing SMI-S with Unisphere REST. This driver "
+"supports VMAX3 hybrid and All Flash arrays."
+msgstr ""
+"VMAX driver version 3.0, replacing SMI-S with Unisphere REST. This driver "
+"supports VMAX3 hybrid and All Flash arrays."
+
+msgid ""
+"VMware VMDK driver and FCD driver now support NFS 4.1 datastores in vCenter "
+"server."
+msgstr ""
+"VMware VMDK driver and FCD driver now support NFS 4.1 datastores in vCenter "
+"server."
+
+msgid ""
+"VMware VMDK driver and FCD driver now support a config option "
+"``vmware_datastore_regex`` to specify the regular expression pattern to "
+"match the name of datastores where backend volumes are created."
+msgstr ""
+"VMware VMDK driver and FCD driver now support a config option "
+"``vmware_datastore_regex`` to specify the regular expression pattern to "
+"match the name of datastores where backend volumes are created."
+
+msgid "VMware VMDK driver deprecated the support for vCenter version 5.1"
+msgstr "VMware VMDK driver deprecated the support for vCenter version 5.1"
+
+msgid ""
+"VMware VMDK driver now supports a config option ``vmware_lazy_create`` to "
+"disable the default behavior of lazy creation of raw volumes in the backend."
+msgstr ""
+"VMware VMDK driver now supports a config option ``vmware_lazy_create`` to "
+"disable the default behaviour of lazy creation of raw volumes in the backend."
+
+msgid ""
+"VMware VMDK driver now supports changing adpater type using retype. To "
+"change the adapter type, set ``vmware:adapter_type`` in the new volume type."
+msgstr ""
+"VMware VMDK driver now supports changing adapter type using retype. To "
+"change the adapter type, set ``vmware:adapter_type`` in the new volume type."
+
+msgid ""
+"VMware VMDK driver now supports vSphere template as a volume snapshot format "
+"in vCenter server. The snapshot format in vCenter server can be specified "
+"using driver config option ``vmware_snapshot_format``."
+msgstr ""
+"VMware VMDK driver now supports vSphere template as a volume snapshot format "
+"in vCenter server. The snapshot format in vCenter server can be specified "
+"using driver config option ``vmware_snapshot_format``."
+
+msgid ""
+"VMware VMDK driver now supports volume type extra-spec option ``vmware:"
+"adapter_type`` to specify the adapter type of volumes in vCenter server."
+msgstr ""
+"VMware VMDK driver now supports volume type extra-spec option ``vmware:"
+"adapter_type`` to specify the adapter type of volumes in vCenter server."
+
+msgid ""
+"VMware VMDK driver will use vSphere template as the default snapshot format "
+"in vCenter server."
+msgstr ""
+"VMware VMDK driver will use vSphere template as the default snapshot format "
+"in vCenter server."
+
+msgid ""
+"VNX cinder driver now supports async migration during volume cloning. By "
+"default, the cloned volume will be available after the migration starts in "
+"the VNX instead of waiting for the completion of migration. This greatly "
+"accelerates the cloning process. If user wants to disable this, he could add "
+"``--metadata async_migrate=False`` when creating volume from source volume/"
+"snapshot."
+msgstr ""
+"VNX cinder driver now supports async migration during volume cloning. By "
+"default, the cloned volume will be available after the migration starts in "
+"the VNX instead of waiting for the completion of migration. This greatly "
+"accelerates the cloning process. If user wants to disable this, he could add "
+"``--metadata async_migrate=False`` when creating volume from source volume/"
+"snapshot."
+
+msgid "Violin"
+msgstr "Violin"
+
+msgid "Violin Memory 6000 array series drivers are removed."
+msgstr "Violin Memory 6000 array series drivers are removed."
+
+msgid ""
+"Volume \"force delete\" was introduced with the 3.23 API microversion, "
+"however the check for in the service was incorrectly looking for "
+"microversion 3.2. That check has now been fixed. It is possible that an API "
+"call using a microversion below 3.23 would previously work for this call, "
+"which will now fail. This closes `bug #1783028 <https://bugs.launchpad.net/"
+"cinder/+bug/1783028>`_."
+msgstr ""
+"Volume \"force delete\" was introduced with the 3.23 API microversion, "
+"however the check for in the service was incorrectly looking for "
+"microversion 3.2. That check has now been fixed. It is possible that an API "
+"call using a microversion below 3.23 would previously work for this call, "
+"which will now fail. This closes `bug #1783028 <https://bugs.launchpad.net/"
+"cinder/+bug/1783028>`_."
+
+msgid "Volume Manage/Unmanage support for Datera Volume Drivers"
+msgstr "Volume Manage/Unmanage support for Datera Volume Drivers"
+
+msgid "Volume Snapshots:"
+msgstr "Volume Snapshots:"
+
+msgid ""
+"Volume group updates of any kind had previously required the group to be in "
+"``Available`` status. Updates to the group name or description will now work "
+"regardless of the volume group status."
+msgstr ""
+"Volume group updates of any kind had previously required the group to be in "
+"``Available`` status. Updates to the group name or description will now work "
+"regardless of the volume group status."
+
+msgid ""
+"Volume manage/unmanage support for IBM FlashSystem FC and iSCSI drivers."
+msgstr ""
+"Volume manage/unmanage support for IBM FlashSystem FC and iSCSI drivers."
+
+msgid "Volume manage/unmanage support for Oracle ZFSSA iSCSI and NFS drivers."
+msgstr "Volume manage/unmanage support for Oracle ZFSSA iSCSI and NFS drivers."
+
+msgid ""
+"Volume type can be filtered within extra spec: /types?extra_specs={\"key\":"
+"\"value\"} since microversion \"3.52\"."
+msgstr ""
+"Volume type can be filtered within extra spec: /types?extra_specs={\"key\":"
+"\"value\"} since microversion \"3.52\"."
+
+msgid "Volume_actions:"
+msgstr "Volume_actions:"
+
+msgid ""
+"Volumes created on NetApp cDOT and 7mode storage systems now report "
+"'multiattach' capability. They have always supported such a capability, but "
+"not reported it to Cinder."
+msgstr ""
+"Volumes created on NetApp cDOT and 7mode storage systems now report "
+"'multiattach' capability. They have always supported such a capability, but "
+"not reported it to Cinder."
+
+msgid ""
+"VzStorage volume driver now supports choosing desired volume format by "
+"setting vendor property 'vz:volume_format' in volume type metadata. Allowed "
+"values are 'ploop', 'qcow2' and 'raw'."
+msgstr ""
+"VzStorage volume driver now supports choosing desired volume format by "
+"setting vendor property 'vz:volume_format' in volume type metadata. Allowed "
+"values are 'ploop', 'qcow2' and 'raw'."
+
+msgid ""
+"We no longer leave orphaned chunks on the backup backend or leave a "
+"temporary volume/snapshot when aborting a backup."
+msgstr ""
+"We no longer leave orphaned chunks on the backup backend or leave a "
+"temporary volume/snapshot when aborting a backup."
+
+msgid ""
+"We replaced the config option in the disco volume driver "
+"\"disco_choice_client\" with \"disco_client_protocol\". We add \"san_api_port"
+"\" as new config option in san driver for accessing the SAN API using this "
+"port."
+msgstr ""
+"We replaced the config option in the disco volume driver "
+"\"disco_choice_client\" with \"disco_client_protocol\". We add \"san_api_port"
+"\" as new config option in SAN driver for accessing the SAN API using this "
+"port."
+
+msgid ""
+"When Barbican is the encryption key_manager backend, any encryption keys "
+"associated with the legacy ConfKeyManager will be automatically migrated to "
+"Barbican. All database references to the ConfKeyManager's all-zeros key ID "
+"will be updated with a Barbican key ID. The encryption keys do not change. "
+"Only the encryption key ID changes."
+msgstr ""
+"When Barbican is the encryption key_manager backend, any encryption keys "
+"associated with the legacy ConfKeyManager will be automatically migrated to "
+"Barbican. All database references to the ConfKeyManager's all-zeros key ID "
+"will be updated with a Barbican key ID. The encryption keys do not change. "
+"Only the encryption key ID changes."
+
+msgid ""
+"When backing up a volume from a snapshot, the volume status would be set to "
+"\"backing-up\", preventing operations on the volume until the backup is "
+"complete. This status is now set on the snapshot instead, making the volume "
+"available for other operations."
+msgstr ""
+"When backing up a volume from a snapshot, the volume status would be set to "
+"\"backing-up\", preventing operations on the volume until the backup is "
+"complete. This status is now set on the snapshot instead, making the volume "
+"available for other operations."
+
+msgid ""
+"When encryption keys based on the ConfKeyManager's fixed_key are migrated to "
+"Barbican, ConfKeyManager keys stored in the Backup table are included in the "
+"migration process. Fixes `bug 1757235 <https://bugs.launchpad.net/tripleo/"
+"+bug/1757235>`__."
+msgstr ""
+"When encryption keys based on the ConfKeyManager's fixed_key are migrated to "
+"Barbican, ConfKeyManager keys stored in the Backup table are included in the "
+"migration process. Fixes `bug 1757235 <https://bugs.launchpad.net/tripleo/"
+"+bug/1757235>`__."
+
+msgid ""
+"When managing volume types an OpenStack provider is now given more control "
+"to grant access to for different storage type operations. The provider can "
+"now customize access to type create, delete, update, list, and show using "
+"new entries in the cinder policy file."
+msgstr ""
+"When managing volume types an OpenStack provider is now given more control "
+"to grant access to for different storage type operations. The provider can "
+"now customise access to type create, delete, update, list, and show using "
+"new entries in the Cinder policy file."
+
+msgid ""
+"When performing a *live* upgrade from Liberty it may happen that retype "
+"calls will reserve additional quota. As by default quota reservations are "
+"invalidated after 24 hours (config option ``reservation_expire=86400``), we "
+"recommend either decreasing that time or watching for unused quota "
+"reservations manually during the upgrade process."
+msgstr ""
+"When performing a *live* upgrade from Liberty it may happen that retype "
+"calls will reserve additional quota. As by default quota reservations are "
+"invalidated after 24 hours (config option ``reservation_expire=86400``), we "
+"recommend either decreasing that time or watching for unused quota "
+"reservations manually during the upgrade process."
+
+msgid ""
+"When restoring the backup of an encrypted volume, the destination volume is "
+"assigned a clone of the backup's encryption key ID. This ensures every "
+"restored backup has a unique encryption key ID, even when multiple volumes "
+"have been restored from the same backup."
+msgstr ""
+"When restoring the backup of an encrypted volume, the destination volume is "
+"assigned a clone of the backup's encryption key ID. This ensures every "
+"restored backup has a unique encryption key ID, even when multiple volumes "
+"have been restored from the same backup."
+
+msgid ""
+"When running Nova Compute and Cinder Volume or Backup services on the same "
+"host they must use a shared lock directory to avoid rare race conditions "
+"that can cause volume operation failures (primarily attach/detach of "
+"volumes). This is done by setting the \"lock_path\" to the same directory in "
+"the \"oslo_concurrency\" section of nova.conf and cinder.conf. This issue "
+"affects all previous releases utilizing os-brick and shared operations on "
+"hosts between Nova Compute and Cinder data services."
+msgstr ""
+"When running Nova Compute and Cinder Volume or Backup services on the same "
+"host they must use a shared lock directory to avoid rare race conditions "
+"that can cause volume operation failures (primarily attach/detach of "
+"volumes). This is done by setting the \"lock_path\" to the same directory in "
+"the \"oslo_concurrency\" section of nova.conf and cinder.conf. This issue "
+"affects all previous releases utilising os-brick and shared operations on "
+"hosts between Nova Compute and Cinder data services."
+
+msgid ""
+"When running PostgreSQL it is required to upgrade and restart all the cinder-"
+"api services along with DB migration 62."
+msgstr ""
+"When running PostgreSQL it is required to upgrade and restart all the cinder-"
+"api services along with DB migration 62."
+
+msgid ""
+"When using the RBD pool exclusively for Cinder we can now set "
+"`rbd_exclusive_cinder_pool` to `true` and Cinder will use DB information to "
+"calculate provisioned size instead of querying all volumes in the backend, "
+"which will reduce the load on the Ceph cluster and the volume service."
+msgstr ""
+"When using the RBD pool exclusively for Cinder we can now set "
+"`rbd_exclusive_cinder_pool` to `true` and Cinder will use DB information to "
+"calculate provisioned size instead of querying all volumes in the backend, "
+"which will reduce the load on the Ceph cluster and the volume service."
+
+msgid ""
+"While configuring NetApp cDOT back ends, new configuration options "
+"('replication_device' and 'netapp_replication_aggregate_map') must be added "
+"in order to use the host-level failover feature."
+msgstr ""
+"While configuring NetApp cDOT back ends, new configuration options "
+"('replication_device' and 'netapp_replication_aggregate_map') must be added "
+"in order to use the host-level failover feature."
+
+msgid ""
+"With removal of the CoprHD Volume Driver any volumes being used by Cinder "
+"within a CoprHD backend should be migrated to a supported storage backend "
+"before upgrade."
+msgstr ""
+"With removal of the CoprHD Volume Driver any volumes being used by Cinder "
+"within a CoprHD backend should be migrated to a supported storage backend "
+"before upgrade."
+
+msgid ""
+"With the Dell SC Cinder Driver if a volume is retyped to a new storage "
+"profile all volumes created via snapshots from this volume will also change "
+"to the new storage profile."
+msgstr ""
+"With the Dell SC Cinder Driver if a volume is retyped to a new storage "
+"profile all volumes created via snapshots from this volume will also change "
+"to the new storage profile."
+
+msgid ""
+"With the Dell SC Cinder Driver retype failed to return a tuple if it had to "
+"return an update to the volume state."
+msgstr ""
+"With the Dell SC Cinder Driver retype failed to return a tuple if it had to "
+"return an update to the volume state."
+
+msgid ""
+"With the Dell SC Cinder Driver retyping from one replication type to another "
+"type (ex. regular replication to live volume replication) is not supported."
+msgstr ""
+"With the Dell SC Cinder Driver retyping from one replication type to another "
+"type (ex. regular replication to live volume replication) is not supported."
+
+msgid ""
+"With the Dell SC Cinder Driver retyping to or from a replicated type should "
+"now work."
+msgstr ""
+"With the Dell SC Cinder Driver retyping to or from a replicated type should "
+"now work."
+
+msgid "X-IO"
+msgstr "X-IO"
+
+msgid "ZTE"
+msgstr "ZTE"
+
+msgid ""
+"Zadara VPSA Driver: Added new driver authentication method to use VPSA API "
+"access key, and deprecate exisiting authentication method that used username "
+"and password combination. The deprecated config inputs will be removed in "
+"the next official release after Train."
+msgstr ""
+"Zadara VPSA Driver: Added new driver authentication method to use VPSA API "
+"access key, and deprecate existing authentication method that used username "
+"and password combination. The deprecated config inputs will be removed in "
+"the next official release after Train."
+
+msgid ""
+"[`Community Goal <https://governance.openstack.org/tc/goals/stein/upgrade-"
+"checkers.html>`_] Support has been added for developers to write pre-upgrade "
+"checks. Operators can run these checks using ``cinder-status upgrade "
+"check``. This allows operators to be more confident when upgrading their "
+"deployments by having a tool that automates programmable checks against the "
+"deployment configuration or dataset."
+msgstr ""
+"[`Community Goal <https://governance.openstack.org/tc/goals/stein/upgrade-"
+"checkers.html>`_] Support has been added for developers to write pre-upgrade "
+"checks. Operators can run these checks using ``cinder-status upgrade "
+"check``. This allows operators to be more confident when upgrading their "
+"deployments by having a tool that automates programmable checks against the "
+"deployment configuration or dataset."
+
+msgid ""
+"[`bug 1772421 <https://bugs.launchpad.net/keystone/+bug/1772421>`_] "
+"INFINIDAT fixed a bug in volume extension feature where volumes were not "
+"extended to target size but added the given target size."
+msgstr ""
+"[`bug 1772421 <https://bugs.launchpad.net/keystone/+bug/1772421>`_] "
+"INFINIDAT fixed a bug in volume extension feature where volumes were not "
+"extended to target size but added the given target size."
+
+msgid ""
+"`Bug 1809249 <https://bugs.launchpad.net/cinder/+bug/1809249>`_ - 3PAR "
+"driver adds the config option `hpe3par_target_nsp` that can be set to the "
+"3PAR backend to use when multipath is not enabled and the Fibre Channel Zone "
+"Manager is not used."
+msgstr ""
+"`Bug 1809249 <https://bugs.launchpad.net/cinder/+bug/1809249>`_ - 3PAR "
+"driver adds the config option `hpe3par_target_nsp` that can be set to the "
+"3PAR backend to use when multipath is not enabled and the Fibre Channel Zone "
+"Manager is not used."
+
+msgid ""
+"``\"admin_or_storage_type_admin\": \"is_admin:True or role:storage_type_admin"
+"\",``"
+msgstr ""
+"``\"admin_or_storage_type_admin\": \"is_admin:True or role:storage_type_admin"
+"\",``"
+
+msgid ""
+"``\"volume_extension:types_manage\": \"rule:admin_or_storage_type_admin\", "
+"\"volume_extension:volume_type_access:addProjectAccess\": \"rule:"
+"admin_or_storage_type_admin\", \"volume_extension:volume_type_access:"
+"removeProjectAccess\": \"rule:admin_or_storage_type_admin\",``"
+msgstr ""
+"``\"volume_extension:types_manage\": \"rule:admin_or_storage_type_admin\", "
+"\"volume_extension:volume_type_access:addProjectAccess\": \"rule:"
+"admin_or_storage_type_admin\", \"volume_extension:volume_type_access:"
+"removeProjectAccess\": \"rule:admin_or_storage_type_admin\",``"
+
+msgid ""
+"``RESKEY:availability_zones`` now is a reserved spec key for AZ volume type, "
+"and administrator can create AZ volume type that includes AZ restrictions by "
+"adding a list of Az's to the extra specs similar to: ``RESKEY:"
+"availability_zones: az1,az2``."
+msgstr ""
+"``RESKEY:availability_zones`` now is a reserved spec key for AZ volume type, "
+"and administrator can create AZ volume type that includes AZ restrictions by "
+"adding a list of AZs to the extra specs similar to: ``RESKEY:"
+"availability_zones: az1,az2``."
+
+msgid "``backend_stats_polling_interval``"
+msgstr "``backend_stats_polling_interval``"
+
+msgid "``backup_driver_init_check_interval``"
+msgstr "``backup_driver_init_check_interval``"
+
+msgid "``backup_driver_status_check_interval``"
+msgstr "``backup_driver_status_check_interval``"
+
+msgid ""
+"``backup_driver_status_check_interval`` config option is renamed to "
+"``backup_driver_stats_polling_interval`` to be similar with volume drivers "
+"configuration. Old option name support will be dropped in U release."
+msgstr ""
+"``backup_driver_status_check_interval`` config option is renamed to "
+"``backup_driver_stats_polling_interval`` to be similar with volume drivers "
+"configuration. Old option name support will be dropped in U release."
+
+msgid "``choice_client``"
+msgstr "``choice_client``"
+
+msgid "``choice_client`` to ``disco_choice_client``"
+msgstr "``choice_client`` to ``disco_choice_client``"
+
+msgid ""
+"``cinder.keymgr.conf_key_mgr.ConfKeyManager`` still remains, but the "
+"``fixed_key`` configuration options should be moved to the ``[key_manager]`` "
+"section"
+msgstr ""
+"``cinder.keymgr.conf_key_mgr.ConfKeyManager`` still remains, but the "
+"``fixed_key`` configuration options should be moved to the ``[key_manager]`` "
+"section"
+
+msgid "``clone_check_timeout`` to ``disco_clone_check_timeout``"
+msgstr "``clone_check_timeout`` to ``disco_clone_check_timeout``"
+
+msgid "``disco_client_port``"
+msgstr "``disco_client_port``"
+
+msgid "``disco_client``"
+msgstr "``disco_client``"
+
+msgid "``disco_src_api_port``"
+msgstr "``disco_src_api_port``"
+
+msgid ""
+"``iscsi_ip_address``, ``iscsi_port``, ``target_helper``, "
+"``iscsi_target_prefix`` and ``iscsi_protocol`` config options are deprecated "
+"in flavor of ``target_ip_address``, ``target_port``, ``target_helper``, "
+"``target_prefix`` and ``target_protocol`` accordingly. Old config options "
+"will be removed in S release."
+msgstr ""
+"``iscsi_ip_address``, ``iscsi_port``, ``target_helper``, "
+"``iscsi_target_prefix`` and ``iscsi_protocol`` config options are deprecated "
+"in flavour of ``target_ip_address``, ``target_port``, ``target_helper``, "
+"``target_prefix`` and ``target_protocol`` accordingly. Old config options "
+"will be removed in S release."
+
+msgid "``os-set_image_metadata``"
+msgstr "``os-set_image_metadata``"
+
+msgid "``os-unset_image_metadata``"
+msgstr "``os-unset_image_metadata``"
+
+msgid "``rest_ip``"
+msgstr "``rest_ip``"
+
+msgid "``rest_ip`` to ``disco_rest_ip``"
+msgstr "``rest_ip`` to ``disco_rest_ip``"
+
+msgid "``restore_check_timeout`` to ``disco_restore_check_timeout``"
+msgstr "``restore_check_timeout`` to ``disco_restore_check_timeout``"
+
+msgid "``retry_interval``"
+msgstr "``retry_interval``"
+
+msgid "``retry_interval`` to ``disco_retry_interval``"
+msgstr "``retry_interval`` to ``disco_retry_interval``"
+
+msgid "``scheduler_driver_init_wait_time``"
+msgstr "``scheduler_driver_init_wait_time``"
+
+msgid "``snapshot_check_timeout`` to ``disco_snapshot_check_timeout``"
+msgstr "``snapshot_check_timeout`` to ``disco_snapshot_check_timeout``"
+
+msgid "``volume_extension:volume_type_encryption:create``"
+msgstr "``volume_extension:volume_type_encryption:create``"
+
+msgid "``volume_extension:volume_type_encryption:delete``"
+msgstr "``volume_extension:volume_type_encryption:delete``"
+
+msgid "``volume_extension:volume_type_encryption:get``"
+msgstr "``volume_extension:volume_type_encryption:get``"
+
+msgid "``volume_extension:volume_type_encryption:update``"
+msgstr "``volume_extension:volume_type_encryption:update``"
+
+msgid "``volume_name_prefix`` to ``disco_volume_name_prefix``"
+msgstr "``volume_name_prefix`` to ``disco_volume_name_prefix``"
+
+msgid ""
+"a [nova] section is added to configure the connection to the compute "
+"service, which is needed to the InstanceLocalityFilter, for example."
+msgstr ""
+"a [nova] section is added to configure the connection to the compute "
+"service, which is needed to the InstanceLocalityFilter, for example."
+
+msgid ""
+"cinder-backup service is now decoupled from cinder-volume, which allows more "
+"flexible scaling."
+msgstr ""
+"cinder-backup service is now decoupled from cinder-volume, which allows more "
+"flexible scaling."
+
+msgid ""
+"cinder.api.middleware.sizelimit was deprecated in kilo and compatability "
+"shim added to call into oslo_middleware.  Using oslo_middleware.sizelimit "
+"directly will allow us to remove the compatability shim in a future release."
+msgstr ""
+"cinder.api.middleware.sizelimit was deprecated in Kilo and a compatibility "
+"shim added to call into oslo_middleware.  Using oslo_middleware.sizelimit "
+"directly will allow us to remove the compatibility shim in a future release."
+
+msgid "create a snapshot: \"POST /v3/{project_id}/snapshots\""
+msgstr "create a snapshot: \"POST /v3/{project_id}/snapshots\""
+
+msgid "create_group"
+msgstr "create_group"
+
+msgid "create_snapshot"
+msgstr "create_snapshot"
+
+msgid "create_volume"
+msgstr "create_volume"
+
+msgid ""
+"datera_api_token -- this has been replaced by san_login and san_password"
+msgstr ""
+"datera_api_token -- this has been replaced by san_login and san_password"
+
+msgid "default_cgsnapshot_type is reserved for migrating CGs."
+msgstr "default_cgsnapshot_type is reserved for migrating CGs."
+
+msgid "delete group: \"POST /v3/{project_id}/groups/{group_id}/action\""
+msgstr "delete group: \"POST /v3/{project_id}/groups/{group_id}/action\""
+
+msgid ""
+"dell_server_os option added to the Dell SC driver. This option allows the "
+"selection of the server type used when creating a server on the Dell DSM "
+"during initialize connection. This is only used if the server does not "
+"exist. Valid values are from the Dell DSM create server list."
+msgstr ""
+"dell_server_os option added to the Dell SC driver. This option allows the "
+"selection of the server type used when creating a server on the Dell DSM "
+"during initialise connection. This is only used if the server does not "
+"exist. Valid values are from the Dell DSM create server list."
+
+msgid "extend_volume"
+msgstr "extend_volume"
+
+msgid ""
+"failover replication: \"POST /v3/{project_id}/groups/{group_id}/action\""
+msgstr ""
+"failover replication: \"POST /v3/{project_id}/groups/{group_id}/action\""
+
+msgid "manage_existing"
+msgstr "manage_existing"
+
+msgid "manage_existing_snapshot"
+msgstr "manage_existing_snapshot"
+
+msgid "migrate_volume"
+msgstr "migrate_volume"
+
+msgid "nova-compute version - needs to be the latest for Pike."
+msgstr "nova-compute version - needs to be the latest for Pike."
+
+msgid ""
+"only iscsi and fibre channel volume types are supported on the nova side "
+"currently."
+msgstr ""
+"only iSCSI and fibre channel volume types are supported on the Nova side "
+"currently."
+
+msgid "only the libvirt compute driver supports this currently."
+msgstr "only the libvirt compute driver supports this currently."
+
+msgid "retype_volume"
+msgstr "retype_volume"
+
+msgid "set bootable: \"POST /v3/{project_id}/volumes/{volume_id}/action\""
+msgstr "set bootable: \"POST /v3/{project_id}/volumes/{volume_id}/action\""
+
+msgid ""
+"upload-to-image using Image API v2 now correctly handles custom image "
+"properties."
+msgstr ""
+"upload-to-image using Image API v2 now correctly handles custom image "
+"properties."
+
+msgid ""
+"use oslo_middleware.sizelimit rather than cinder.api.middleware.sizelimit "
+"compatibility shim"
+msgstr ""
+"use oslo_middleware.sizelimit rather than cinder.api.middleware.sizelimit "
+"compatibility shim"
+
+msgid ""
+"vSphere 6.7 added support for vStorageObject snapshots. The "
+"VMwareVStorageObjectDriver is updated to use VStorageObject snapshots for "
+"volume snapshots."
+msgstr ""
+"vSphere 6.7 added support for vStorageObject snapshots. The "
+"VMwareVStorageObjectDriver is updated to use VStorageObject snapshots for "
+"volume snapshots."
+
+msgid ""
+"volume readonly update: \"POST /v3/{project_id}/volumes/{volume_id}/action\""
+msgstr ""
+"volume readonly update: \"POST /v3/{project_id}/volumes/{volume_id}/action\""
diff -pruN 2:15.0.1-1/releasenotes/source/train.rst 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/source/train.rst
--- 2:15.0.1-1/releasenotes/source/train.rst	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/releasenotes/source/train.rst	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,6 @@
+==========================
+Train Series Release Notes
+==========================
+
+.. release-notes::
+   :branch: stable/train
diff -pruN 2:15.0.1-1/reno.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/reno.yaml
--- 2:15.0.1-1/reno.yaml	1970-01-01 00:00:00.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/reno.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -0,0 +1,4 @@
+---
+# Ignore the kilo-eol tag because that branch does not work with reno
+# and contains no release notes.
+closed_branch_tag_re: "(.+)(?<!kilo)-eol"
diff -pruN 2:15.0.1-1/requirements.txt 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/requirements.txt
--- 2:15.0.1-1/requirements.txt	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/requirements.txt	2020-03-24 18:46:31.000000000 +0000
@@ -5,13 +5,11 @@
 pbr!=2.1.0,>=2.0.0 # Apache-2.0
 decorator>=3.4.0 # BSD
 defusedxml>=0.5.0 # PSF
-enum34>=1.0.4;python_version=='2.7' or python_version=='2.6' or python_version=='3.3' # BSD
 eventlet!=0.23.0,!=0.25.0,>=0.22.0 # MIT
 greenlet>=0.4.10 # MIT
 httplib2>=0.9.1 # MIT
 iso8601>=0.1.11 # MIT
 jsonschema>=2.6.0 # MIT
-ipaddress>=1.0.17;python_version<'3.3' # PSF
 keystoneauth1>=3.7.0 # Apache-2.0
 keystonemiddleware>=4.21.0 # Apache-2.0
 lxml!=3.7.0,>=3.4.1 # BSD
@@ -19,7 +17,7 @@ oauth2client!=4.0.0,>=1.5.0 # Apache-2.0
 oslo.config>=5.2.0 # Apache-2.0
 oslo.concurrency>=3.26.0 # Apache-2.0
 oslo.context>=2.19.2 # Apache-2.0
-oslo.db>=4.27.0 # Apache-2.0
+oslo.db>=4.35.0 # Apache-2.0
 oslo.log>=3.36.0 # Apache-2.0
 oslo.messaging>=6.4.0 # Apache-2.0
 oslo.middleware>=3.31.0 # Apache-2.0
@@ -33,10 +31,9 @@ oslo.upgradecheck>=0.1.0 # Apache-2.0
 oslo.utils>=3.34.0 # Apache-2.0
 oslo.versionedobjects>=1.31.2 # Apache-2.0
 osprofiler>=1.4.0 # Apache-2.0
-paramiko>=2.0.0 # LGPLv2.1+
+paramiko>=2.4.0 # LGPLv2.1+
 Paste>=2.0.2 # MIT
 PasteDeploy>=1.5.0 # MIT
-PrettyTable<0.8,>=0.7.1 # BSD
 psutil>=3.2.2 # BSD
 pyparsing>=2.1.0 # MIT
 python-barbicanclient>=4.5.2 # Apache-2.0
@@ -55,9 +52,10 @@ SQLAlchemy!=1.1.5,!=1.1.6,!=1.1.7,!=1.1.
 sqlalchemy-migrate>=0.11.0 # Apache-2.0
 stevedore>=1.20.0 # Apache-2.0
 suds-jurko>=0.6 # LGPLv3+
+tabulate>=0.8.5 # MIT
 WebOb>=1.7.1 # MIT
 oslo.i18n>=3.15.3 # Apache-2.0
-oslo.vmware>=2.17.0 # Apache-2.0
+oslo.vmware>=2.35.0 # Apache-2.0
 os-brick>=2.2.0 # Apache-2.0
 os-win>=3.0.0 # Apache-2.0
 tooz>=1.58.0 # Apache-2.0
diff -pruN 2:15.0.1-1/setup.cfg 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/setup.cfg
--- 2:15.0.1-1/setup.cfg	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/setup.cfg	2020-03-24 18:46:36.802702000 +0000
@@ -1,85 +1,78 @@
 [metadata]
 name = cinder
 summary = OpenStack Block Storage
-description-file =
-    README.rst
+description-file = 
+	README.rst
 author = OpenStack
 author-email = openstack-discuss@lists.openstack.org
 home-page = https://docs.openstack.org/cinder/latest/
-classifier =
-    Environment :: OpenStack
-    Intended Audience :: Information Technology
-    Intended Audience :: System Administrators
-    License :: OSI Approved :: Apache Software License
-    Operating System :: POSIX :: Linux
-    Programming Language :: Python
-    Programming Language :: Python :: 2
-    Programming Language :: Python :: 2.7
-    Programming Language :: Python :: 3
-    Programming Language :: Python :: 3.6
-    Programming Language :: Python :: 3.7
+classifier = 
+	Environment :: OpenStack
+	Intended Audience :: Information Technology
+	Intended Audience :: System Administrators
+	License :: OSI Approved :: Apache Software License
+	Operating System :: POSIX :: Linux
+	Programming Language :: Python
+	Programming Language :: Python :: 3
+	Programming Language :: Python :: 3.6
+	Programming Language :: Python :: 3.7
 
 [global]
-setup-hooks =
-    pbr.hooks.setup_hook
+setup-hooks = 
+	pbr.hooks.setup_hook
 
 [files]
-data_files =
-    etc/cinder =
-        etc/cinder/api-paste.ini
-        etc/cinder/rootwrap.conf
-        etc/cinder/resource_filters.json
-    etc/cinder/rootwrap.d = etc/cinder/rootwrap.d/*
-packages =
-    cinder
+data_files = 
+	etc/cinder =
+	etc/cinder/api-paste.ini
+	etc/cinder/rootwrap.conf
+	etc/cinder/resource_filters.json
+	etc/cinder/rootwrap.d = etc/cinder/rootwrap.d/*
+packages = 
+	cinder
 
 [entry_points]
-cinder.scheduler.filters =
-    AvailabilityZoneFilter = cinder.scheduler.filters.availability_zone_filter:AvailabilityZoneFilter
-    CapabilitiesFilter = cinder.scheduler.filters.capabilities_filter:CapabilitiesFilter
-    CapacityFilter = cinder.scheduler.filters.capacity_filter:CapacityFilter
-    DifferentBackendFilter = cinder.scheduler.filters.affinity_filter:DifferentBackendFilter
-    DriverFilter = cinder.scheduler.filters.driver_filter:DriverFilter
-    JsonFilter = cinder.scheduler.filters.json_filter:JsonFilter
-    RetryFilter = cinder.scheduler.filters.ignore_attempted_hosts_filter:IgnoreAttemptedHostsFilter
-    SameBackendFilter = cinder.scheduler.filters.affinity_filter:SameBackendFilter
-    InstanceLocalityFilter = cinder.scheduler.filters.instance_locality_filter:InstanceLocalityFilter
-cinder.scheduler.weights =
-    AllocatedCapacityWeigher = cinder.scheduler.weights.capacity:AllocatedCapacityWeigher
-    CapacityWeigher = cinder.scheduler.weights.capacity:CapacityWeigher
-    ChanceWeigher = cinder.scheduler.weights.chance:ChanceWeigher
-    GoodnessWeigher = cinder.scheduler.weights.goodness:GoodnessWeigher
-    VolumeNumberWeigher = cinder.scheduler.weights.volume_number:VolumeNumberWeigher
-oslo.config.opts =
-    cinder = cinder.opts:list_opts
-oslo.config.opts.defaults =
-    cinder = cinder.common.config:set_external_library_defaults
-oslo.policy.enforcer =
-    cinder = cinder.policy:get_enforcer
-oslo.policy.policies =
-    # The sample policies will be ordered by entry point and then by list
-    # returned from that entry point. If more control is desired split out each
-    # list_rules method into a separate entry point rather than using the
-    # aggregate method.
-    cinder = cinder.policies:list_rules
-console_scripts =
-    cinder-api = cinder.cmd.api:main
-    cinder-backup = cinder.cmd.backup:main
-    cinder-manage = cinder.cmd.manage:main
-    cinder-rootwrap = oslo_rootwrap.cmd:main
-    cinder-rtstool = cinder.cmd.rtstool:main
-    cinder-scheduler = cinder.cmd.scheduler:main
-    cinder-status = cinder.cmd.status:main
-    cinder-volume = cinder.cmd.volume:main
-    cinder-volume-usage-audit = cinder.cmd.volume_usage_audit:main
-wsgi_scripts =
-    cinder-wsgi = cinder.wsgi.wsgi:initialize_application
-cinder.database.migration_backend =
-    sqlalchemy = oslo_db.sqlalchemy.migration
-
+cinder.scheduler.filters = 
+	AvailabilityZoneFilter = cinder.scheduler.filters.availability_zone_filter:AvailabilityZoneFilter
+	CapabilitiesFilter = cinder.scheduler.filters.capabilities_filter:CapabilitiesFilter
+	CapacityFilter = cinder.scheduler.filters.capacity_filter:CapacityFilter
+	DifferentBackendFilter = cinder.scheduler.filters.affinity_filter:DifferentBackendFilter
+	DriverFilter = cinder.scheduler.filters.driver_filter:DriverFilter
+	JsonFilter = cinder.scheduler.filters.json_filter:JsonFilter
+	RetryFilter = cinder.scheduler.filters.ignore_attempted_hosts_filter:IgnoreAttemptedHostsFilter
+	SameBackendFilter = cinder.scheduler.filters.affinity_filter:SameBackendFilter
+	InstanceLocalityFilter = cinder.scheduler.filters.instance_locality_filter:InstanceLocalityFilter
+cinder.scheduler.weights = 
+	AllocatedCapacityWeigher = cinder.scheduler.weights.capacity:AllocatedCapacityWeigher
+	CapacityWeigher = cinder.scheduler.weights.capacity:CapacityWeigher
+	ChanceWeigher = cinder.scheduler.weights.chance:ChanceWeigher
+	GoodnessWeigher = cinder.scheduler.weights.goodness:GoodnessWeigher
+	VolumeNumberWeigher = cinder.scheduler.weights.volume_number:VolumeNumberWeigher
+oslo.config.opts = 
+	cinder = cinder.opts:list_opts
+oslo.config.opts.defaults = 
+	cinder = cinder.common.config:set_external_library_defaults
+oslo.policy.enforcer = 
+	cinder = cinder.policy:get_enforcer
+oslo.policy.policies = 
+	cinder = cinder.policies:list_rules
+console_scripts = 
+	cinder-api = cinder.cmd.api:main
+	cinder-backup = cinder.cmd.backup:main
+	cinder-manage = cinder.cmd.manage:main
+	cinder-rootwrap = oslo_rootwrap.cmd:main
+	cinder-rtstool = cinder.cmd.rtstool:main
+	cinder-scheduler = cinder.cmd.scheduler:main
+	cinder-status = cinder.cmd.status:main
+	cinder-volume = cinder.cmd.volume:main
+	cinder-volume-usage-audit = cinder.cmd.volume_usage_audit:main
+wsgi_scripts = 
+	cinder-wsgi = cinder.wsgi.wsgi:initialize_application
+cinder.database.migration_backend = 
+	sqlalchemy = oslo_db.sqlalchemy.migration
 
 [egg_info]
-tag_build =
+tag_build = 
 tag_date = 0
 tag_svn_revision = 0
 
@@ -98,40 +91,42 @@ mapping_file = babel.cfg
 output_file = cinder/locale/cinder.pot
 
 [extras]
-all =
-    websocket-client>=0.32.0 # LGPLv2+
-    pyOpenSSL>=17.5.0 # Apache-2.0
-    storops>=0.5.10 # Apache-2.0
-    pywbem>=0.7.0  #LGPLv2.1+
-    python-3parclient>=4.1.0  # Apache-2.0
-    krest>=1.3.0 # Apache-2.0
-    infinisdk>=103.0.1 # BSD-3
-    purestorage>=1.6.0 # BSD
-    storpool>=4.0.0 # Apache-2.0
-    storpool.spopenstack>=2.2.1 # Apache-2.0
-datacore =
-    websocket-client>=0.32.0 # LGPLv2+
-powermax =
-    pyOpenSSL>=17.5.0 # Apache-2.0
-vnx =
-    storops>=0.5.10 # Apache-2.0
-unity =
-    storops>=0.5.10 # Apache-2.0
-fujitsu =
-    pywbem>=0.7.0  #LGPLv2.1+
-hpe3par =
-    python-3parclient>=4.1.0  # Apache-2.0
-kaminario =
-    krest>=1.3.0 # Apache-2.0
-ds8k =
-    pyOpenSSL>=17.5.0 # Apache-2.0
-infinidat =
-    infinisdk>=103.0.1 # BSD-3
-pure =
-    purestorage>=1.6.0 # BSD
-rsd =
-    rsd-lib>=1.1.0 # Apache-2.0
-storpool =
-    storpool>=4.0.0 # Apache-2.0
-    storpool.spopenstack>=2.2.1 # Apache-2.0
+all = 
+	websocket-client>=0.32.0 # LGPLv2+
+	pyOpenSSL>=17.5.0 # Apache-2.0
+	storops>=0.5.10 # Apache-2.0
+	pywbem>=0.7.0  #LGPLv2.1+
+	python-3parclient>=4.1.0  # Apache-2.0
+	krest>=1.3.0 # Apache-2.0
+	infinisdk>=103.0.1 # BSD-3
+	purestorage>=1.6.0 # BSD
+	storpool>=4.0.0 # Apache-2.0
+	storpool.spopenstack>=2.2.1 # Apache-2.0
+datacore = 
+	websocket-client>=0.32.0 # LGPLv2+
+powermax = 
+	pyOpenSSL>=17.5.0 # Apache-2.0
+vnx = 
+	storops>=0.5.10 # Apache-2.0
+unity = 
+	storops>=0.5.10 # Apache-2.0
+fujitsu = 
+	pywbem>=0.7.0  #LGPLv2.1+
+hpe3par = 
+	python-3parclient>=4.1.0  # Apache-2.0
+kaminario = 
+	krest>=1.3.0 # Apache-2.0
+ds8k = 
+	pyOpenSSL>=17.5.0 # Apache-2.0
+infinidat = 
+	infinisdk>=103.0.1 # BSD-3
+pure = 
+	purestorage>=1.6.0 # BSD
+rsd = 
+	rsd-lib>=1.1.0 # Apache-2.0
+storpool = 
+	storpool>=4.0.0 # Apache-2.0
+	storpool.spopenstack>=2.2.1 # Apache-2.0
+datera = 
+	dfs_sdk>=1.2.25 # Apache-2.0
 
diff -pruN 2:15.0.1-1/test-requirements.txt 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/test-requirements.txt
--- 2:15.0.1-1/test-requirements.txt	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/test-requirements.txt	2020-03-24 18:46:31.000000000 +0000
@@ -3,23 +3,25 @@
 # process, which may cause wedges in the gate later.
 
 # Install bounded pep8/pyflakes first, then let flake8 install
-hacking>=1.1.0,<1.2.0 # Apache-2.0
+hacking>=2.0.0 # Apache-2.0
+flake8-import-order # LGPLv3
+flake8-logging-format>=0.6.0 # Apache-2.0
 
+stestr>=2.2.0 # Apache-2.0
 coverage!=4.4,>=4.0 # Apache-2.0
 ddt>=1.2.1 # MIT
 fixtures>=3.0.0 # Apache-2.0/BSD
-mock>=2.0.0 # BSD
-os-api-ref>=1.4.0 # Apache-2.0
 oslotest>=3.2.0 # Apache-2.0
 pycodestyle==2.5.0 # MIT License
 PyMySQL>=0.7.6 # MIT License
 psycopg2>=2.7 # LGPL/ZPL
+SQLAlchemy-Utils>=0.36.1 # BSD License
 testtools>=2.2.0 # MIT
-testresources>=2.0.0 # Apache-2.0/BSD
-testscenarios>=0.4 # Apache-2.0/BSD
 oslo.versionedobjects[fixtures]>=1.31.2 # Apache-2.0
-tempest>=17.1.0 # Apache-2.0
+
 # bandit is not included in upper-constraints,
 # so we need to pin it here to a known working version
 bandit==1.6.0 # Apache-2.0
 doc8>=0.6.0 # Apache-2.0
+reno>=2.5.0 # Apache-2.0
+Pygments>=2.2.0 # BSD license
diff -pruN 2:15.0.1-1/tools/check_exec.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/tools/check_exec.py
--- 2:15.0.1-1/tools/check_exec.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/tools/check_exec.py	2020-03-24 18:46:31.000000000 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/python
+#!/usr/bin/python3
 #
 #    Licensed under the Apache License, Version 2.0 (the "License"); you may
 #    not use this file except in compliance with the License. You may obtain
diff -pruN 2:15.0.1-1/tools/coding-checks.sh 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/tools/coding-checks.sh
--- 2:15.0.1-1/tools/coding-checks.sh	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/tools/coding-checks.sh	2020-03-24 18:46:31.000000000 +0000
@@ -31,7 +31,7 @@ run_pylint() {
     if [[ "$target" = *"all"* ]]; then
         files="cinder"
     else
-        files=$(git diff --name-only --diff-filter=ACMRU $target "*.py")
+        files=$(git diff --name-only --diff-filter=ACMRU $target -- "*.py")
     fi
 
     if [ -n "${files}" ]; then
diff -pruN 2:15.0.1-1/tools/config/generate_cinder_opts.py 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/tools/config/generate_cinder_opts.py
--- 2:15.0.1-1/tools/config/generate_cinder_opts.py	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/tools/config/generate_cinder_opts.py	2020-03-24 18:46:31.000000000 +0000
@@ -69,7 +69,8 @@ if __name__ == "__main__":
     # cinder files, otherwise any decorator that uses cinder.objects.YYY will
     # fail with exception AttributeError: 'module' object has no attribute
     # 'YYY' when running tox -egenconfig
-    opt_file.write("from cinder import objects\nobjects.register_all()\n\n")
+    opt_file.write(
+        "from cinder import objects  # noqa\nobjects.register_all()\n")
 
     targetdir = 'cinder'
 
diff -pruN 2:15.0.1-1/tox.ini 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/tox.ini
--- 2:15.0.1-1/tox.ini	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/tox.ini	2020-03-24 18:46:31.000000000 +0000
@@ -1,10 +1,15 @@
 [tox]
-minversion = 2.5
+minversion = 3.1.0
 skipsdist = True
 skip_missing_interpreters = true
-envlist = py37,py27,compliance,pep8
+# python runtimes: https://governance.openstack.org/tc/reference/runtimes/ussuri.html
+envlist = py37,py36,compliance,pep8
+# this allows tox to infer the base python from the environment name
+# and override any basepython configured in this file
+ignore_basepython_conflict=true
 
 [testenv]
+basepython = python3
 setenv = VIRTUAL_ENV={envdir}
          PYTHONWARNINGS=default::DeprecationWarning
          OS_STDOUT_CAPTURE=1
@@ -14,7 +19,7 @@ setenv = VIRTUAL_ENV={envdir}
 usedevelop = True
 install_command = pip install {opts} {packages}
 
-deps = -c{env:UPPER_CONSTRAINTS_FILE:https://releases.openstack.org/constraints/upper/train}
+deps = -c{env:UPPER_CONSTRAINTS_FILE:https://releases.openstack.org/constraints/upper/master}
         -r{toxinidir}/test-requirements.txt
         -r{toxinidir}/requirements.txt
 
@@ -33,7 +38,6 @@ whitelist_externals =
 passenv = *_proxy *_PROXY
 
 [testenv:api-ref]
-basepython = python3
 whitelist_externals = rm
 deps = {[testenv:docs]deps}
 commands =
@@ -41,7 +45,6 @@ commands =
   sphinx-build -W -b html -d api-ref/build/doctrees api-ref/source api-ref/build/html/
 
 [testenv:releasenotes]
-basepython = python3
 deps = {[testenv:docs]deps}
 commands = sphinx-build -a -E -W -d releasenotes/build/doctrees -b html releasenotes/source releasenotes/build/html
 
@@ -68,12 +71,10 @@ commands =
   stestr slowest
 
 [testenv:compliance]
-basepython = python3
 setenv =
   OS_TEST_PATH = ./cinder/tests/compliance
 
 [testenv:pep8]
-basepython = python3
 commands =
   flake8 {posargs} .
   doc8
@@ -81,7 +82,6 @@ commands =
   {toxinidir}/tools/check_exec.py {toxinidir}/cinder {toxinidir}/doc/source/ {toxinidir}/releasenotes/notes
 
 [testenv:fast8]
-basepython = python3
 # Use same environment directory as pep8 env to save space and install time
 envdir = {toxworkdir}/pep8
 commands =
@@ -89,17 +89,15 @@ commands =
 passenv = FAST8_NUM_COMMITS
 
 [testenv:pylint]
-basepython = python3
 deps = -r{toxinidir}/requirements.txt
        -r{toxinidir}/test-requirements.txt
-       pylint==2.1.1
+       pylint==2.3.0
 commands =
   bash ./tools/coding-checks.sh --pylint {posargs}
 
 [testenv:cover]
 # Also do not run test_coverage_ext tests while gathering coverage as those
 # tests conflict with coverage.
-basepython = python3
 setenv =
     {[testenv]setenv}
     PYTHON=coverage run --source cinder --parallel-mode
@@ -110,30 +108,26 @@ commands =
     coverage xml -o cover/coverage.xml
 
 [testenv:genconfig]
-basepython = python3
 sitepackages = False
 envdir = {toxworkdir}/pep8
 commands = oslo-config-generator --config-file=tools/config/cinder-config-generator.conf
 
 
 [testenv:genpolicy]
-basepython = python3
 commands = oslopolicy-sample-generator --config-file=tools/config/cinder-policy-generator.conf
 
 [testenv:genopts]
-basepython = python3
 sitepackages = False
 envdir = {toxworkdir}/pep8
 commands = python tools/config/generate_cinder_opts.py
 
 [testenv:venv]
-basepython = python3
 commands = {posargs}
 
 [testenv:docs]
-basepython = python3
 deps =
-  -c{env:UPPER_CONSTRAINTS_FILE:https://releases.openstack.org/constraints/upper/train}
+  -c{env:UPPER_CONSTRAINTS_FILE:https://releases.openstack.org/constraints/upper/master}
+  -r{toxinidir}/requirements.txt
   -r{toxinidir}/doc/requirements.txt
 commands =
   rm -fr doc/source/contributor/api/
@@ -142,7 +136,6 @@ commands =
 whitelist_externals = rm
 
 [testenv:pdf-docs]
-basepython = python3
 deps = {[testenv:docs]deps}
 commands =
   rm -fr doc/source/contributor/api/
@@ -154,18 +147,15 @@ whitelist_externals =
   rm
 
 [testenv:gendriverlist]
-basepython = python3
 sitepackages = False
 envdir = {toxworkdir}/venv
 commands = python {toxinidir}/tools/generate_driver_list.py
 
 [testenv:bandit]
-basepython = python3
 deps = -r{toxinidir}/test-requirements.txt
 commands = bandit -r cinder -n5 -x cinder/tests/* -ll
 
 [testenv:bandit-baseline]
-basepython = python3
 envdir = {toxworkdir}/bandit
 commands = bandit-baseline -r cinder -n5 -x cinder/tests/* -ii -ll
 
@@ -176,9 +166,8 @@ commands = bandit-baseline -r cinder -n5
 # separately, outside of the requirements files, and develop mode disabled
 # explicitly to avoid unnecessarily installing the checked-out repo too (this
 # further relies on "tox.skipsdist = True" above).
-basepython = python3
 deps = bindep
-commands = bindep test
+commands = bindep {posargs}
 usedevelop = False
 
 [flake8]
@@ -200,23 +189,25 @@ usedevelop = False
 #  tools from getting in our way with regards to this.
 # H101 include name with TODO
 #  reason: no real benefit
-ignore = E251,E402,W503,W504,H101
+# G200 Logging statements should not include the exception
+#  reason: Many existing cases of this that may be legitimate
+ignore = E251,E402,W503,W504,H101,G200
 # H904 Delay string interpolations at logging calls.
 enable-extensions = H106,H203,H904
 exclude = .git,.venv,.tox,dist,tools,doc/ext,*egg,build
-max-complexity=30
+max-complexity = 30
+application-import-names = cinder
+import-order-style = pep8
 
 [hacking]
 local-check-factory = cinder.tests.hacking.checks.factory
 import_exceptions = cinder.i18n
 
 [doc8]
-
 ignore-path=.tox,*.egg-info,doc/src/api,doc/source/drivers.rst,doc/build,.eggs/*/EGG-INFO/*.txt,doc/source/configuration/tables,./*.txt
 extension=.txt,.rst,.inc
 
 [testenv:lower-constraints]
-basepython = python3
 deps =
   -c{toxinidir}/lower-constraints.txt
   -r{toxinidir}/test-requirements.txt
diff -pruN 2:15.0.1-1/.zuul.yaml 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/.zuul.yaml
--- 2:15.0.1-1/.zuul.yaml	2019-12-11 02:50:50.000000000 +0000
+++ 2:16.0.0~b3~git2020032414.a0c0a9e23-0ubuntu1/.zuul.yaml	2020-03-24 18:46:31.000000000 +0000
@@ -1,12 +1,10 @@
 - project:
     templates:
       - openstack-lower-constraints-jobs
-      - openstack-python-jobs
-      - openstack-python3-train-jobs
+      - openstack-python3-ussuri-jobs
       - publish-openstack-docs-pti
       - periodic-stable-jobs
       - check-requirements
-      - integrated-gate
       - integrated-gate-storage
       - release-notes-jobs-python3
     check:
@@ -24,6 +22,8 @@
               - ^contrib/block-box.*$
               - ^doc/.*$
               - ^releasenotes/.*$
+        - openstack-tox-functional-py37:
+            irrelevant-files: *functional-irrelevant-files
         - cinder-rally-task:
             voting: false
         - openstack-tox-pylint:
@@ -31,7 +31,6 @@
             timeout: 5400
             irrelevant-files: *functional-irrelevant-files
         - cinder-plugin-ceph-tempest:
-            voting: false
             irrelevant-files: &gate-irrelevant-files
               - ^(test-|)requirements.txt$
               - ^lower-constraints.txt$
@@ -48,10 +47,7 @@
               - ^setup.cfg$
               - ^tools/.*$
               - ^tox.ini$
-        - openstack-tox-functional:
-            voting: false
-            irrelevant-files: *functional-irrelevant-files
-        - legacy-grenade-dsvm-cinder-mn-sub-volbak:
+        - cinder-grenade-dsvm-mn-sub-volbak:
             irrelevant-files: *gate-irrelevant-files
         - legacy-tempest-dsvm-lvm-multibackend:
             voting: false
@@ -59,12 +55,8 @@
         - legacy-tempest-dsvm-full-devstack-plugin-nfs:
             voting: false
             irrelevant-files: *gate-irrelevant-files
-        - neutron-grenade:
-            irrelevant-files: *gate-irrelevant-files
         - tempest-slow-py3:
             irrelevant-files: *gate-irrelevant-files
-        - tempest-full:
-            irrelevant-files: *gate-irrelevant-files
         - tempest-integrated-storage:
             irrelevant-files: *gate-irrelevant-files
         - grenade-py3:
@@ -73,11 +65,9 @@
             irrelevant-files: *gate-irrelevant-files
     gate:
       jobs:
-        - legacy-grenade-dsvm-cinder-mn-sub-volbak:
+        - cinder-grenade-dsvm-mn-sub-volbak:
             irrelevant-files: *gate-irrelevant-files
-        - neutron-grenade:
-            irrelevant-files: *gate-irrelevant-files
-        - tempest-full:
+        - cinder-plugin-ceph-tempest:
             irrelevant-files: *gate-irrelevant-files
         - tempest-integrated-storage:
             irrelevant-files: *gate-irrelevant-files
@@ -93,9 +83,9 @@
             irrelevant-files: *gate-irrelevant-files
         - legacy-tempest-dsvm-multibackend-matrix:
             irrelevant-files: *gate-irrelevant-files
-        - legacy-grenade-dsvm-cinder-mn-sub-volschbak:
+        - cinder-grenade-dsvm-mn-sub-volschbak:
             irrelevant-files: *gate-irrelevant-files
-        - legacy-grenade-dsvm-cinder-mn-sub-bak:
+        - cinder-grenade-dsvm-mn-sub-bak:
             irrelevant-files: *gate-irrelevant-files
         - devstack-plugin-ceph-tempest-py3:
             irrelevant-files: *gate-irrelevant-files
@@ -148,8 +138,59 @@
 
 - job:
     name: cinder-plugin-ceph-tempest
-    parent: devstack-plugin-ceph-tempest
+    parent: devstack-plugin-ceph-tempest-py3
     run: playbooks/tempest-and-cinderlib-run.yaml
     required-projects:
       - openstack/cinderlib
       - openstack/tempest
+
+- job:
+    name: cinder-grenade-dsvm-mn-sub-bak
+    parent: legacy-dsvm-base-multinode
+    # Old name: legacy-grenade-dsvm-cinder-mn-sub-bak
+    # This is py3 version for ussuri onwards rest all branch needs to be py2
+    # version which is present in openstack-zuul-jobs.
+    # We need to take care of this branch variant and python version while
+    # migrating these jobs to zuulv3.
+    branches: ^(?!(driverfixes|stable/(ocata|pike|queens|rocky|stein|train))).*$
+    run: playbooks/legacy/grenade-dsvm-cinder-mn-sub-bak/run.yaml
+    post-run: playbooks/legacy/grenade-dsvm-cinder-mn-sub-bak/post.yaml
+    timeout: 10800
+    required-projects:
+      - openstack/grenade
+      - openstack/devstack-gate
+      - openstack/cinder
+
+- job:
+    name: cinder-grenade-dsvm-mn-sub-volbak
+    parent: legacy-dsvm-base-multinode
+    # Old name: legacy-grenade-dsvm-cinder-mn-sub-volbak
+    # This is py3 version for ussuri onwards rest all branch needs to be py2
+    # version which is present in openstack-zuul-jobs.
+    # We need to take care of this branch variant and python version while
+    # migrating these jobs to zuulv3.
+    branches: ^(?!(driverfixes|stable/(ocata|pike|queens|rocky|stein|train))).*$
+    run: playbooks/legacy/grenade-dsvm-cinder-mn-sub-volbak/run.yaml
+    post-run: playbooks/legacy/grenade-dsvm-cinder-mn-sub-volbak/post.yaml
+    timeout: 10800
+    required-projects:
+      - openstack/grenade
+      - openstack/devstack-gate
+      - openstack/cinder
+
+- job:
+    name: cinder-grenade-dsvm-mn-sub-volschbak
+    parent: legacy-dsvm-base-multinode
+    # Old name: legacy-grenade-dsvm-cinder-mn-sub-volschbak
+    # This is py3 version for ussuri onwards rest all branch needs to be py2
+    # version which is present in openstack-zuul-jobs.
+    # We need to take care of this branch variant and python version while
+    # migrating these jobs to zuulv3.
+    branches: ^(?!(driverfixes|stable/(ocata|pike|queens|rocky|stein|train))).*$
+    run: playbooks/legacy/grenade-dsvm-cinder-mn-sub-volschbak/run.yaml
+    post-run: playbooks/legacy/grenade-dsvm-cinder-mn-sub-volschbak/post.yaml
+    timeout: 10800
+    required-projects:
+      - openstack/grenade
+      - openstack/devstack-gate
+      - openstack/cinder
